%------------------------------------------------------------------------------
% File     : VBT00010^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem Hoare_Triple 00469_013750
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0025_Hoare_Triple_00469_013750 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 7533 (2119 unt; 965 typ;   0 def)
%            Number of atoms       : 19998 (6963 equ;   7 cnn)
%            Maximal formula atoms :   48 (   3 avg)
%            Number of connectives : 152435 (1972   ~; 184   |;1186   &;139586   @)
%                                         (   0 <=>;9507  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   38 (   8 avg)
%            Number of types       :   13 (  12 usr)
%            Number of type conns  : 7058 (7058   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  957 ( 953 usr;  22 con; 0-10 aty)
%            Number of variables   : 25529 (2306   ^21803   !; 344   ?;25529   :)
%                                         (1076  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 15:43:46.477
%------------------------------------------------------------------------------
% Could-be-implicit typings (27)
thf(ty_t_Heap__Time__Monad_OHeap,type,
    heap_Time_Heap: $tType > $tType ).

thf(ty_t_Code__Numeral_Onatural,type,
    code_natural: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Code__Evaluation_Oterm,type,
    code_term: $tType ).

thf(ty_t_Heap_Oheap_Oheap__ext,type,
    heap_ext: $tType > $tType ).

thf(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Old__Datatype_Onode,type,
    old_node: $tType > $tType > $tType ).

thf(ty_t_Multiset_Omultiset,type,
    multiset: $tType > $tType ).

thf(ty_t_Typerep_Otyperep,type,
    typerep: $tType ).

thf(ty_t_Assertions_Oassn,type,
    assn: $tType ).

thf(ty_t_Predicate_Opred,type,
    pred: $tType > $tType ).

thf(ty_t_Sum__Type_Osum,type,
    sum_sum: $tType > $tType > $tType ).

thf(ty_t_Predicate_Oseq,type,
    seq: $tType > $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Heap_Oarray,type,
    array: $tType > $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Heap_Oref,type,
    ref: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

thf(ty_tf_a,type,
    a: $tType ).

% Explicit typings (938)
thf(sy_cl_Typerep_Otyperep,type,
    typerep2: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Oenum,type,
    enum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Code__Evaluation_Oterm__of,type,
    code_term_of: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Oequal,type,
    cl_HOL_Oequal: 
      !>[A: $tType] : $o ).

thf(sy_cl_Heap_Oheap,type,
    heap: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Otimes,type,
    times: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Oinf,type,
    inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osup,type,
    sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Obot,type,
    bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Otop,type,
    top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__lattice,type,
    finite_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_OInf,type,
    complete_Inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_OSup,type,
    complete_Sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Quickcheck__Random_Orandom,type,
    quickcheck_random: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Partial__Order_Occpo,type,
    comple9053668089753744459l_ccpo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Onormalization__semidom,type,
    normal8620421768224518004emidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,
    bounded_lattice_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice__top,type,
    bounded_lattice_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Quickcheck__Exhaustive_Oexhaustive,type,
    quickc658316121487927005ustive: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide__unit__factor,type,
    semido2269285787275462019factor: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Quickcheck__Exhaustive_Ofull__exhaustive,type,
    quickc3360725361186068524ustive: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Onormalization__semidom__multiplicative,type,
    normal6328177297339901930cative: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Array__Time_Oalloc,type,
    array_alloc: 
      !>[A: $tType] : ( ( list @ A ) > ( heap_ext @ product_unit ) > ( product_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) ) ) ).

thf(sy_c_Array__Time_Ofreeze,type,
    array_freeze: 
      !>[A: $tType] : ( ( array @ A ) > ( heap_Time_Heap @ ( list @ A ) ) ) ).

thf(sy_c_Array__Time_Oget,type,
    array_get: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( array @ A ) > ( list @ A ) ) ).

thf(sy_c_Array__Time_Olen,type,
    array_len: 
      !>[A: $tType] : ( ( array @ A ) > ( heap_Time_Heap @ nat ) ) ).

thf(sy_c_Array__Time_Olength,type,
    array_length: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( array @ A ) > nat ) ).

thf(sy_c_Array__Time_Omake,type,
    array_make: 
      !>[A: $tType] : ( nat > ( nat > A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Omake_H,type,
    array_make2: 
      !>[B: $tType,A: $tType] : ( code_integer > ( B > A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Omap__entry,type,
    array_map_entry: 
      !>[A: $tType] : ( nat > ( A > A ) > ( array @ A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Onew,type,
    array_new: 
      !>[A: $tType] : ( nat > A > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Onew_H,type,
    array_new2: 
      !>[A: $tType] : ( code_integer > A > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Onth,type,
    array_nth: 
      !>[A: $tType] : ( ( array @ A ) > nat > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Array__Time_Onth_H,type,
    array_nth2: 
      !>[A: $tType] : ( ( array @ A ) > code_integer > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Array__Time_Oof__list,type,
    array_of_list: 
      !>[A: $tType] : ( ( list @ A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Oset,type,
    array_set: 
      !>[A: $tType] : ( ( array @ A ) > ( list @ A ) > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) ) ).

thf(sy_c_Array__Time_Oswap,type,
    array_swap: 
      !>[A: $tType] : ( nat > A > ( array @ A ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Array__Time_Oupd,type,
    array_upd: 
      !>[A: $tType] : ( nat > A > ( array @ A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Oupdate,type,
    array_update: 
      !>[A: $tType] : ( ( array @ A ) > nat > A > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) ) ).

thf(sy_c_Assertions_Oassn_OAbs__assn,type,
    abs_assn: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > assn ).

thf(sy_c_Assertions_Oassn_ORep__assn,type,
    rep_assn: assn > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oentails,type,
    entails: assn > assn > $o ).

thf(sy_c_Assertions_Oentailst,type,
    entailst: assn > assn > $o ).

thf(sy_c_Assertions_Oex__assn,type,
    ex_assn: 
      !>[A: $tType] : ( ( A > assn ) > assn ) ).

thf(sy_c_Assertions_Oin__range,type,
    in_range: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oin__range__rel,type,
    in_range_rel: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Ois__pure__assn,type,
    is_pure_assn: assn > $o ).

thf(sy_c_Assertions_Oone__assn__raw,type,
    one_assn_raw: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oone__assn__raw__rel,type,
    one_assn_raw_rel: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oprecise,type,
    precise: 
      !>[A: $tType,B: $tType] : ( ( A > B > assn ) > $o ) ).

thf(sy_c_Assertions_Oproper,type,
    proper: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > $o ).

thf(sy_c_Assertions_Opure__assn,type,
    pure_assn: $o > assn ).

thf(sy_c_Assertions_Opure__assn__raw,type,
    pure_assn_raw: 
      !>[A: $tType,B: $tType] : ( $o > ( product_prod @ A @ ( set @ B ) ) > $o ) ).

thf(sy_c_Assertions_Opure__assn__raw__rel,type,
    pure_assn_raw_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) > ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) > $o ) ).

thf(sy_c_Assertions_OrelH,type,
    relH: ( set @ nat ) > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) > $o ).

thf(sy_c_Assertions_Osnga__assn,type,
    snga_assn: 
      !>[A: $tType] : ( ( array @ A ) > ( list @ A ) > assn ) ).

thf(sy_c_Assertions_Osnga__assn__raw,type,
    snga_assn_raw: 
      !>[A: $tType] : ( ( array @ A ) > ( list @ A ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) ).

thf(sy_c_Assertions_Osnga__assn__raw__rel,type,
    snga_assn_raw_rel: 
      !>[A: $tType] : ( ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ) ).

thf(sy_c_Assertions_Osngr__assn,type,
    sngr_assn: 
      !>[A: $tType] : ( ( ref @ A ) > A > assn ) ).

thf(sy_c_Assertions_Osngr__assn__raw,type,
    sngr_assn_raw: 
      !>[A: $tType] : ( ( ref @ A ) > A > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) ).

thf(sy_c_Assertions_Osngr__assn__raw__rel,type,
    sngr_assn_raw_rel: 
      !>[A: $tType] : ( ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ) ).

thf(sy_c_Assertions_Otimes__assn__raw,type,
    times_assn_raw: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Otimes__assn__raw__rel,type,
    times_assn_raw_rel: ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ).

thf(sy_c_Assertions_Owand__assn,type,
    wand_assn: assn > assn > assn ).

thf(sy_c_Assertions_Owand__raw,type,
    wand_raw: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Owand__raw__rel,type,
    wand_raw_rel: ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ).

thf(sy_c_BNF__Cardinal__Arithmetic_OCsum,type,
    bNF_Cardinal_Csum: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocexp,type,
    bNF_Cardinal_cexp: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocfinite,type,
    bNF_Cardinal_cfinite: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocinfinite,type,
    bNF_Ca4139267488887388095finite: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocone,type,
    bNF_Cardinal_cone: set @ ( product_prod @ product_unit @ product_unit ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocprod,type,
    bNF_Cardinal_cprod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Ocsum,type,
    bNF_Cardinal_csum: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Octwo,type,
    bNF_Cardinal_ctwo: set @ ( product_prod @ $o @ $o ) ).

thf(sy_c_BNF__Cardinal__Arithmetic_Oczero,type,
    bNF_Cardinal_czero: 
      !>[A: $tType] : ( set @ ( product_prod @ A @ A ) ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OcardSuc,type,
    bNF_Ca8387033319878233205ardSuc: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_Ocard__of,type,
    bNF_Ca6860139660246222851ard_of: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_Ocard__order__on,type,
    bNF_Ca8970107618336181345der_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_Ocofinal,type,
    bNF_Ca7293521722713021262ofinal: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OisCardSuc,type,
    bNF_Ca6246979054910435723ardSuc: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OnatLeq,type,
    bNF_Ca8665028551170535155natLeq: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OregularCard,type,
    bNF_Ca7133664381575040944arCard: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OrelChain,type,
    bNF_Ca3754400796208372196lChain: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( A > B ) > $o ) ).

thf(sy_c_BNF__Composition_Oid__bnf,type,
    bNF_id_bnf: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Def_OGrp,type,
    bNF_Grp: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > A > B > $o ) ).

thf(sy_c_BNF__Def_Ocollect,type,
    bNF_collect: 
      !>[B: $tType,A: $tType] : ( ( set @ ( B > ( set @ A ) ) ) > B > ( set @ A ) ) ).

thf(sy_c_BNF__Def_Oconvol,type,
    bNF_convol: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B ) > ( A > C ) > A > ( product_prod @ B @ C ) ) ).

thf(sy_c_BNF__Def_Oeq__onp,type,
    bNF_eq_onp: 
      !>[A: $tType] : ( ( A > $o ) > A > A > $o ) ).

thf(sy_c_BNF__Def_OfstOp,type,
    bNF_fstOp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > $o ) > ( B > C > $o ) > ( product_prod @ A @ C ) > ( product_prod @ A @ B ) ) ).

thf(sy_c_BNF__Def_Opick__middlep,type,
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] : ( ( B > A > $o ) > ( A > C > $o ) > B > C > A ) ).

thf(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) ).

thf(sy_c_BNF__Def_Orel__set,type,
    bNF_rel_set: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_BNF__Def_OsndOp,type,
    bNF_sndOp: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( C > A > $o ) > ( A > B > $o ) > ( product_prod @ C @ B ) > ( product_prod @ A @ B ) ) ).

thf(sy_c_BNF__Def_Ovimage2p,type,
    bNF_vimage2p: 
      !>[A: $tType,D: $tType,B: $tType,E: $tType,C: $tType] : ( ( A > D ) > ( B > E ) > ( D > E > C ) > A > B > C ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OfromCard,type,
    bNF_Gr5436034075474128252omCard: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ B @ B ) ) > B > A ) ).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OrelImage,type,
    bNF_Gr4221423524335903396lImage: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ B ) ) > ( B > A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OrelInvImage,type,
    bNF_Gr7122648621184425601vImage: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OtoCard,type,
    bNF_Greatest_toCard: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ B @ B ) ) > A > B ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OtoCard__pred,type,
    bNF_Gr1419584066657907630d_pred: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > $o ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set @ B ) > ( C > A ) > ( B > D ) > ( D > C ) > B > A ) ).

thf(sy_c_BNF__Wellorder__Constructions_Obsqr,type,
    bNF_Wellorder_bsqr: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_Ocurr,type,
    bNF_Wellorder_curr: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ A ) > ( ( product_prod @ A @ B ) > C ) > A > B > C ) ).

thf(sy_c_BNF__Wellorder__Constructions_Odir__image,type,
    bNF_We2720479622203943262_image: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( A > A2 ) > ( set @ ( product_prod @ A2 @ A2 ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OofilterIncl,type,
    bNF_We413866401316099525erIncl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OordIso,type,
    bNF_Wellorder_ordIso: 
      !>[A: $tType,A2: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OordLeq,type,
    bNF_Wellorder_ordLeq: 
      !>[A: $tType,A2: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OordLess,type,
    bNF_We4044943003108391690rdLess: 
      !>[A: $tType,A2: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_Oord__to__filter,type,
    bNF_We8469521843155493636filter: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) ) ).

thf(sy_c_BNF__Wellorder__Embedding_Ocompat,type,
    bNF_Wellorder_compat: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_BNF__Wellorder__Embedding_Oembed,type,
    bNF_Wellorder_embed: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_BNF__Wellorder__Embedding_OembedS,type,
    bNF_Wellorder_embedS: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_BNF__Wellorder__Embedding_Oiso,type,
    bNF_Wellorder_iso: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel,type,
    bNF_Wellorder_wo_rel: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel_OisMinim,type,
    bNF_We4791949203932849705sMinim: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > A > $o ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel_Omax2,type,
    bNF_We1388413361240627857o_max2: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > A > A ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel_Ominim,type,
    bNF_We6954850376910717587_minim: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > A ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel_Osuc,type,
    bNF_Wellorder_wo_suc: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > A ) ).

thf(sy_c_Basic__BNF__LFPs_Octor__rec,type,
    basic_BNF_ctor_rec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Basic__BNF__LFPs_Osum_Osize__sum,type,
    basic_BNF_size_sum: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( sum_sum @ A @ B ) > nat ) ).

thf(sy_c_Basic__BNF__LFPs_Oxtor,type,
    basic_BNF_xtor: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Basic__BNFs_Ofsts,type,
    basic_fsts: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > ( set @ A ) ) ).

thf(sy_c_Basic__BNFs_Opred__fun,type,
    basic_pred_fun: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( B > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Basic__BNFs_Opred__prod,type,
    basic_pred_prod: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( B > $o ) > ( product_prod @ A @ B ) > $o ) ).

thf(sy_c_Basic__BNFs_Opred__sum,type,
    basic_pred_sum: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( B > $o ) > ( sum_sum @ A @ B ) > $o ) ).

thf(sy_c_Basic__BNFs_Orel__prod,type,
    basic_rel_prod: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( A > B > $o ) > ( C > D > $o ) > ( product_prod @ A @ C ) > ( product_prod @ B @ D ) > $o ) ).

thf(sy_c_Basic__BNFs_Osetl,type,
    basic_setl: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ B ) > ( set @ A ) ) ).

thf(sy_c_Basic__BNFs_Osetr,type,
    basic_setr: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ B ) > ( set @ B ) ) ).

thf(sy_c_Basic__BNFs_Osnds,type,
    basic_snds: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > ( set @ B ) ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself @ A ) > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oor__num,type,
    bit_un6697907153464112080or_num: num > num > num ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oor__num__rel,type,
    bit_un4773296044027857193um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num__rel,type,
    bit_un2901131394128224187um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__axioms,type,
    boolea6902313364301356556axioms: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff__axioms,type,
    boolea5476839437570043046axioms: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_OSuc,type,
    code_Suc: code_natural > code_natural ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onatural_Onat__of__natural,type,
    code_nat_of_natural: code_natural > nat ).

thf(sy_c_Code__Numeral_Onatural_Onatural__of__nat,type,
    code_natural_of_nat: nat > code_natural ).

thf(sy_c_Code__Numeral_Onegative,type,
    code_negative: num > code_integer ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Numeral_Opcr__integer,type,
    code_pcr_integer: int > code_integer > $o ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Occpo_Oadmissible,type,
    comple1908693960933563346ssible: 
      !>[A: $tType] : ( ( ( set @ A ) > A ) > ( A > A > $o ) > ( A > $o ) > $o ) ).

thf(sy_c_Complete__Partial__Order_Occpo_Ofixp,type,
    comple187402453842119260l_fixp: 
      !>[A: $tType] : ( ( ( set @ A ) > A ) > ( A > A > $o ) > ( A > A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Occpo__class_Ofixp,type,
    comple115746919287870866o_fixp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Occpo__class_Oiterates,type,
    comple6359979572994053840erates: 
      !>[A: $tType] : ( ( A > A ) > ( set @ A ) ) ).

thf(sy_c_Complete__Partial__Order_Ochain,type,
    comple1602240252501008431_chain: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Complete__Partial__Order_Omonotone,type,
    comple7038119648293358887notone: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__above,type,
    condit8047198070973881523_above: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__below,type,
    condit8119078960628432327_below: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Countable_Ofrom__nat,type,
    from_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Countable_Onat__to__rat__surj,type,
    nat_to_rat_surj: nat > rat ).

thf(sy_c_Countable_Onth__item__rel,type,
    nth_item_rel: nat > nat > $o ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Equiv__Relations_Ocongruent,type,
    equiv_congruent: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( A > B ) > $o ) ).

thf(sy_c_Equiv__Relations_Ocongruent2,type,
    equiv_congruent2: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( A > B > C ) > $o ) ).

thf(sy_c_Equiv__Relations_Oequiv,type,
    equiv_equiv: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Equiv__Relations_Oequivp,type,
    equiv_equivp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Equiv__Relations_Oproj,type,
    equiv_proj: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ A ) ) > B > ( set @ A ) ) ).

thf(sy_c_Equiv__Relations_Oquotient,type,
    equiv_quotient: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Ocofinite,type,
    cofinite: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofilter_OAbs__filter,type,
    abs_filter: 
      !>[A: $tType] : ( ( ( A > $o ) > $o ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ ( set @ A ) ) ) ).

thf(sy_c_Filter_Ofrequently,type,
    frequently: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( filter @ B ) > ( filter @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__idem__axioms,type,
    finite1981172056906289455axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__idem__on,type,
    finite673082921795544331dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__idem__on__axioms,type,
    finite4980608107308702382axioms: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B > $o ) ).

thf(sy_c_Finite__Set_Ofolding,type,
    finite_folding: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__idem,type,
    finite_folding_idem: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__idem__axioms,type,
    finite7837460588564673216axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__idem__on,type,
    finite1890593828518410140dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__idem__on__axioms,type,
    finite6916993218817215295axioms: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > B > A > B ) ).

thf(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ooverride__on,type,
    override_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( set @ A ) > A > B ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_Fun__Def_Ois__measure,type,
    fun_is_measure: 
      !>[A: $tType] : ( ( A > nat ) > $o ) ).

thf(sy_c_Fun__Def_Omax__strict,type,
    fun_max_strict: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Omax__weak,type,
    fun_max_weak: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Omin__strict,type,
    fun_min_strict: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Omin__weak,type,
    fun_min_weak: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Opair__leq,type,
    fun_pair_leq: set @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) ).

thf(sy_c_Fun__Def_Opair__less,type,
    fun_pair_less: set @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) ).

thf(sy_c_Fun__Def_Oreduction__pair,type,
    fun_reduction_pair: 
      !>[A: $tType] : ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > $o ) ).

thf(sy_c_Fun__Def_Orp__inv__image,type,
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_OGcd__class_OLcm,type,
    gcd_Lcm: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Obounded__quasi__semilattice,type,
    bounde8507323023520639062attice: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( A > A ) > $o ) ).

thf(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( A > A ) > $o ) ).

thf(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( set @ A ) > A ) ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__class_Olcm,type,
    gcd_lcm: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OLcm__fin,type,
    semiring_gcd_Lcm_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Groups_Oabel__semigroup,type,
    abel_semigroup: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Groups_Oabel__semigroup__axioms,type,
    abel_s757365448890700780axioms: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ocomm__monoid,type,
    comm_monoid: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Ocomm__monoid__axioms,type,
    comm_monoid_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Ogroup,type,
    group: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A ) > $o ) ).

thf(sy_c_Groups_Ogroup__axioms,type,
    group_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A ) > $o ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Omonoid,type,
    monoid: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Omonoid__axioms,type,
    monoid_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osemigroup,type,
    semigroup: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add_Osum,type,
    groups3894954378712506084id_sum: 
      !>[A: $tType,B: $tType] : ( ( A > A > A ) > A > ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__set,type,
    groups778175481326437816id_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__set_OF,type,
    groups_comm_monoid_F: 
      !>[A: $tType,B: $tType] : ( ( A > A > A ) > A > ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__set_OG,type,
    groups_comm_monoid_G: 
      !>[A: $tType,B: $tType] : ( ( A > A > A ) > A > ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__List_Ocomm__monoid__list,type,
    groups1828464146339083142d_list: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Ocomm__monoid__list__set,type,
    groups4802862169904069756st_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__list,type,
    groups_monoid_list: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Omonoid__list_OF,type,
    groups_monoid_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_OEx1,type,
    ex1: 
      !>[A: $tType] : ( ( A > $o ) > $o ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_HOL_OUniq,type,
    uniq: 
      !>[A: $tType] : ( ( A > $o ) > $o ) ).

thf(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

thf(sy_c_Heap_Oaddr__of__array,type,
    addr_of_array: 
      !>[A: $tType] : ( ( array @ A ) > nat ) ).

thf(sy_c_Heap_Oaddr__of__ref,type,
    addr_of_ref: 
      !>[A: $tType] : ( ( ref @ A ) > nat ) ).

thf(sy_c_Heap_Oarray_OArray,type,
    array2: 
      !>[A: $tType] : ( nat > ( array @ A ) ) ).

thf(sy_c_Heap_Oheap_Oarrays,type,
    arrays: 
      !>[Z: $tType] : ( ( heap_ext @ Z ) > typerep > nat > ( list @ nat ) ) ).

thf(sy_c_Heap_Oheap_Olim,type,
    lim: 
      !>[Z: $tType] : ( ( heap_ext @ Z ) > nat ) ).

thf(sy_c_Heap_Oheap_Olim__update,type,
    lim_update: 
      !>[Z: $tType] : ( ( nat > nat ) > ( heap_ext @ Z ) > ( heap_ext @ Z ) ) ).

thf(sy_c_Heap_Oheap_Orefs,type,
    refs: 
      !>[Z: $tType] : ( ( heap_ext @ Z ) > typerep > nat > nat ) ).

thf(sy_c_Heap_Oref_ORef,type,
    ref2: 
      !>[A: $tType] : ( nat > ( ref @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap_OHeap,type,
    heap_Time_Heap2: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Ocase__Heap,type,
    heap_Time_case_Heap: 
      !>[A: $tType,B: $tType] : ( ( ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > B ) > ( heap_Time_Heap @ A ) > B ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Omap__Heap,type,
    heap_Time_map_Heap: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( heap_Time_Heap @ A ) > ( heap_Time_Heap @ Aa ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Opred__Heap,type,
    heap_Time_pred_Heap: 
      !>[A: $tType] : ( ( A > $o ) > ( heap_Time_Heap @ A ) > $o ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Orec__Heap,type,
    heap_Time_rec_Heap: 
      !>[A: $tType,C: $tType] : ( ( ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > C ) > ( heap_Time_Heap @ A ) > C ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Orel__Heap,type,
    heap_Time_rel_Heap: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( heap_Time_Heap @ A ) > ( heap_Time_Heap @ B ) > $o ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Oset__Heap,type,
    heap_Time_set_Heap: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( set @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap_Osize__Heap,type,
    heap_Time_size_Heap: 
      !>[A: $tType] : ( ( A > nat ) > ( heap_Time_Heap @ A ) > nat ) ).

thf(sy_c_Heap__Time__Monad_OHeap__lub,type,
    heap_Time_Heap_lub: 
      !>[A: $tType] : ( ( set @ ( heap_Time_Heap @ A ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap__ord,type,
    heap_Time_Heap_ord: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_Time_Heap @ A ) > $o ) ).

thf(sy_c_Heap__Time__Monad_Oassert,type,
    heap_Time_assert: 
      !>[A: $tType] : ( ( A > $o ) > A > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Obind,type,
    heap_Time_bind: 
      !>[A: $tType,B: $tType] : ( ( heap_Time_Heap @ A ) > ( A > ( heap_Time_Heap @ B ) ) > ( heap_Time_Heap @ B ) ) ).

thf(sy_c_Heap__Time__Monad_Oeffect,type,
    heap_Time_effect: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) > A > nat > $o ) ).

thf(sy_c_Heap__Time__Monad_Oexecute,type,
    heap_Time_execute: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ).

thf(sy_c_Heap__Time__Monad_Oguard,type,
    heap_Time_guard: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > $o ) > ( ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Oheap,type,
    heap_Time_heap: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Olift,type,
    heap_Time_lift: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > ( heap_Time_Heap @ B ) ) ).

thf(sy_c_Heap__Time__Monad_Oraise,type,
    heap_Time_raise: 
      !>[A: $tType] : ( ( list @ char ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Oreturn,type,
    heap_Time_return: 
      !>[A: $tType] : ( A > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Osuccess,type,
    heap_Time_success: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_ext @ product_unit ) > $o ) ).

thf(sy_c_Heap__Time__Monad_Otap,type,
    heap_Time_tap: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > A ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OtimeFrame,type,
    heap_Time_timeFrame: 
      !>[A: $tType] : ( nat > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ).

thf(sy_c_Heap__Time__Monad_OtimeFrame__rel,type,
    heap_T5500966940807335491me_rel: 
      !>[A: $tType] : ( ( product_prod @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > ( product_prod @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > $o ) ).

thf(sy_c_Heap__Time__Monad_Oureturn,type,
    heap_Time_ureturn: 
      !>[A: $tType] : ( A > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Owait,type,
    heap_Time_wait: nat > ( heap_Time_Heap @ product_unit ) ).

thf(sy_c_Hilbert__Choice_Obijection,type,
    hilbert_bijection: 
      !>[A: $tType] : ( ( A > A ) > $o ) ).

thf(sy_c_Hilbert__Choice_Oinv__into,type,
    hilbert_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_Hoare__Triple_Ohoare__triple,type,
    hoare_hoare_triple: 
      !>[A: $tType] : ( assn > ( heap_Time_Heap @ A ) > ( A > assn ) > $o ) ).

thf(sy_c_Hoare__Triple_Onew__addrs,type,
    hoare_new_addrs: ( heap_ext @ product_unit ) > ( set @ nat ) > ( heap_ext @ product_unit ) > ( set @ nat ) ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Inductive_Ocomplete__lattice__class_Ogfp,type,
    complete_lattice_gfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Inductive_Ocomplete__lattice__class_Olfp,type,
    complete_lattice_lfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Ointrel,type,
    intrel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opcr__int,type,
    pcr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice,type,
    semilattice: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__axioms,type,
    semilattice_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__neutr,type,
    semilattice_neutr: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__order,type,
    semilattice_order: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__order__axioms,type,
    semila6385135966242565138axioms: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Ois__arg__min,type,
    lattic501386751177426532rg_min: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf_OInf__fin,type,
    lattic8678736583308907530nf_fin: 
      !>[A: $tType] : ( ( A > A > A ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__neutr__set,type,
    lattic5652469242046573047tr_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__neutr__set_OF,type,
    lattic5214292709420241887eutr_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__set,type,
    lattic149705377957585745ce_set: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__set_OF,type,
    lattic1715443433743089157tice_F: 
      !>[A: $tType] : ( ( A > A > A ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup_OSup__fin,type,
    lattic4630905495605216202up_fin: 
      !>[A: $tType] : ( ( A > A > A ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lifting_OQuotient,type,
    quotient: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > B ) > ( B > A ) > ( A > B > $o ) > $o ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > A ) ).

thf(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B ) @ ( list @ A ) ) > ( product_prod @ ( A > B ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldl,type,
    foldl: 
      !>[B: $tType,A: $tType] : ( ( B > A > B ) > B > ( list @ A ) > B ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) ).

thf(sy_c_List_Olist_Olist__all,type,
    list_all: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Orec__list,type,
    rec_list: 
      !>[C: $tType,A: $tType] : ( C > ( A > ( list @ A ) > C > C ) > ( list @ A ) > C ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( ( list @ ( set @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omap__tailrec__rev,type,
    map_tailrec_rev: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Omap__tailrec__rev__rel,type,
    map_tailrec_rev_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > $o ) ).

thf(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( ( list @ ( A > nat ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Oord__class_Olexordp,type,
    ord_lexordp: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osorted__wrt__rel,type,
    sorted_wrt_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Osplice__rel,type,
    splice_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osuccessively,type,
    successively: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osuccessively__rel,type,
    successively_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) ) ).

thf(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Omap__add,type,
    map_add: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( A > ( option @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) > A > ( option @ B ) ) ).

thf(sy_c_Misc_OEps__Opt,type,
    eps_Opt: 
      !>[A: $tType] : ( ( A > $o ) > ( option @ A ) ) ).

thf(sy_c_Misc_Obijective,type,
    bijective: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > $o ) ).

thf(sy_c_Misc_Obrk__rel,type,
    brk_rel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) ) ) ) ).

thf(sy_c_Misc_Odflt__None__set,type,
    dflt_None_set: 
      !>[A: $tType] : ( ( set @ A ) > ( option @ ( set @ A ) ) ) ).

thf(sy_c_Misc_Ofilter__rev,type,
    filter_rev: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Ofun__of__rel,type,
    fun_of_rel: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ A ) ) > B > A ) ).

thf(sy_c_Misc_Olist__all__zip,type,
    list_all_zip: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_Misc_Olist__all__zip__rel,type,
    list_all_zip_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > $o ) ).

thf(sy_c_Misc_Olist__collect__set,type,
    list_collect_set: 
      !>[B: $tType,A: $tType] : ( ( B > ( set @ A ) ) > ( list @ B ) > ( set @ A ) ) ).

thf(sy_c_Misc_Omap__mmupd,type,
    map_mmupd: 
      !>[B: $tType,A: $tType] : ( ( B > ( option @ A ) ) > ( set @ B ) > A > B > ( option @ A ) ) ).

thf(sy_c_Misc_Omap__to__set,type,
    map_to_set: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Misc_Omerge,type,
    merge: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omerge__rel,type,
    merge_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Misc_Omergesort__by__rel,type,
    mergesort_by_rel: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omergesort__by__rel__merge,type,
    merges9089515139780605204_merge: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omergesort__by__rel__merge__rel,type,
    merges2244889521215249637ge_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) > ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) > $o ) ).

thf(sy_c_Misc_Omergesort__by__rel__rel,type,
    mergesort_by_rel_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Misc_Omergesort__by__rel__split,type,
    merges295452479951948502_split: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_Misc_Omergesort__by__rel__split__rel,type,
    merges7066485432131860899it_rel: 
      !>[A: $tType] : ( ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) > ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Misc_Opairself,type,
    pairself: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( product_prod @ A @ A ) > ( product_prod @ B @ B ) ) ).

thf(sy_c_Misc_Opairself__rel,type,
    pairself_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B ) @ ( product_prod @ A @ A ) ) > ( product_prod @ ( A > B ) @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Misc_Opartition__rev,type,
    partition_rev: 
      !>[A: $tType] : ( ( A > $o ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_Misc_Opartition__rev__rel,type,
    partition_rev_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) ) > ( product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) ) > $o ) ).

thf(sy_c_Misc_Oquicksort__by__rel,type,
    quicksort_by_rel: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Oquicksort__by__rel__rel,type,
    quicksort_by_rel_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) > ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) > $o ) ).

thf(sy_c_Misc_Orel__of,type,
    rel_of: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( ( product_prod @ A @ B ) > $o ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Misc_Orel__restrict,type,
    rel_restrict: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Misc_Oremove__rev,type,
    remove_rev: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Orevg,type,
    revg: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Orevg__rel,type,
    revg_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Misc_Oset__to__map,type,
    set_to_map: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ A ) ) > B > ( option @ A ) ) ).

thf(sy_c_Misc_Osu__rel__fun,type,
    su_rel_fun: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( A > B ) > $o ) ).

thf(sy_c_Misc_Othe__default,type,
    the_default: 
      !>[A: $tType] : ( A > ( option @ A ) > A ) ).

thf(sy_c_Misc_Ouncurry,type,
    uncurry: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Misc_Ozipf,type,
    zipf: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( list @ A ) > ( list @ B ) > ( list @ C ) ) ).

thf(sy_c_Misc_Ozipf__rel,type,
    zipf_rel: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > $o ) ).

thf(sy_c_Multiset_Oadd__mset,type,
    add_mset: 
      !>[A: $tType] : ( A > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Ocomm__monoid__add__class_Osum__mset,type,
    comm_m7189776963980413722m_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > A ) ).

thf(sy_c_Multiset_Ocomm__monoid__mset,type,
    comm_monoid_mset: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Multiset_Ocomm__monoid__mset_OF,type,
    comm_monoid_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( multiset @ A ) > A ) ).

thf(sy_c_Multiset_Ocomm__monoid__mult__class_Oprod__mset,type,
    comm_m9189036328036947845d_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > A ) ).

thf(sy_c_Multiset_Ofold__mset,type,
    fold_mset: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( multiset @ A ) > B ) ).

thf(sy_c_Multiset_Oimage__mset,type,
    image_mset: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( multiset @ A ) > ( multiset @ B ) ) ).

thf(sy_c_Multiset_Ointer__mset,type,
    inter_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Olinorder__class_Opart,type,
    linorder_part: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) ) ) ).

thf(sy_c_Multiset_Oms__strict,type,
    ms_strict: set @ ( product_prod @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Multiset_Oms__weak,type,
    ms_weak: set @ ( product_prod @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Multiset_Omset,type,
    mset: 
      !>[A: $tType] : ( ( list @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Omset__set,type,
    mset_set: 
      !>[B: $tType] : ( ( set @ B ) > ( multiset @ B ) ) ).

thf(sy_c_Multiset_Omult,type,
    mult: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) ) ) ).

thf(sy_c_Multiset_Omult1,type,
    mult1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) ) ) ).

thf(sy_c_Multiset_Omulteqp__code,type,
    multeqp_code: 
      !>[A: $tType] : ( ( A > A > $o ) > ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Omultiset_OAbs__multiset,type,
    abs_multiset: 
      !>[A: $tType] : ( ( A > nat ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Omultiset_Ocount,type,
    count: 
      !>[A: $tType] : ( ( multiset @ A ) > A > nat ) ).

thf(sy_c_Multiset_Omultp,type,
    multp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Omultp__code,type,
    multp_code: 
      !>[A: $tType] : ( ( A > A > $o ) > ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Opcr__multiset,type,
    pcr_multiset: 
      !>[C: $tType,B: $tType] : ( ( C > B > $o ) > ( C > nat ) > ( multiset @ B ) > $o ) ).

thf(sy_c_Multiset_Opred__mset,type,
    pred_mset: 
      !>[A: $tType] : ( ( A > $o ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Opw__leq,type,
    pw_leq: ( multiset @ ( product_prod @ nat @ nat ) ) > ( multiset @ ( product_prod @ nat @ nat ) ) > $o ).

thf(sy_c_Multiset_Oreplicate__mset,type,
    replicate_mset: 
      !>[A: $tType] : ( nat > A > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Oset__mset,type,
    set_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( set @ A ) ) ).

thf(sy_c_Multiset_Osize__multiset,type,
    size_multiset: 
      !>[A: $tType] : ( ( A > nat ) > ( multiset @ A ) > nat ) ).

thf(sy_c_Multiset_Osubset__eq__mset__impl,type,
    subset_eq_mset_impl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( option @ $o ) ) ).

thf(sy_c_Multiset_Osubset__eq__mset__impl__rel,type,
    subset751672762298770561pl_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Multiset_Osubset__mset,type,
    subset_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Osubseteq__mset,type,
    subseteq_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Ounion__mset,type,
    union_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Owcount,type,
    wcount: 
      !>[A: $tType] : ( ( A > nat ) > ( multiset @ A ) > A > nat ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Olist__decode__rel,type,
    nat_list_decode_rel: nat > nat > $o ).

thf(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: ( list @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: ( list @ nat ) > ( list @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__decode,type,
    nat_prod_decode: nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: ( product_prod @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Osum__decode,type,
    nat_sum_decode: nat > ( sum_sum @ nat @ nat ) ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Ois__num,type,
    neg_numeral_is_num: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Old__Datatype_OAtom,type,
    old_Atom: 
      !>[A: $tType,B: $tType] : ( ( sum_sum @ A @ nat ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_OIn0,type,
    old_In0: 
      !>[A: $tType,B: $tType] : ( ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_OIn1,type,
    old_In1: 
      !>[A: $tType,B: $tType] : ( ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_OLeaf,type,
    old_Leaf: 
      !>[A: $tType,B: $tType] : ( A > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_ONode,type,
    old_Node: 
      !>[B: $tType,A: $tType] : ( set @ ( product_prod @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) ) ) ).

thf(sy_c_Old__Datatype_ONumb,type,
    old_Numb: 
      !>[A: $tType,B: $tType] : ( nat > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_OScons,type,
    old_Scons: 
      !>[A: $tType,B: $tType] : ( ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_Odprod,type,
    old_dprod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) > ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) > ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) ) ).

thf(sy_c_Old__Datatype_Odsum,type,
    old_dsum: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) > ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) > ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) ) ).

thf(sy_c_Old__Datatype_Ondepth,type,
    old_ndepth: 
      !>[A: $tType,B: $tType] : ( ( old_node @ A @ B ) > nat ) ).

thf(sy_c_Old__Datatype_Onode_OAbs__Node,type,
    old_Abs_Node: 
      !>[B: $tType,A: $tType] : ( ( product_prod @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) ) > ( old_node @ A @ B ) ) ).

thf(sy_c_Old__Datatype_Ontrunc,type,
    old_ntrunc: 
      !>[A: $tType,B: $tType] : ( nat > ( set @ ( old_node @ A @ B ) ) > ( set @ ( old_node @ A @ B ) ) ) ).

thf(sy_c_Old__Datatype_Ouprod,type,
    old_uprod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( set @ ( old_node @ A @ B ) ) ) > ( set @ ( set @ ( old_node @ A @ B ) ) ) > ( set @ ( set @ ( old_node @ A @ B ) ) ) ) ).

thf(sy_c_Option_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( option @ A ) > ( A > ( option @ B ) ) > ( option @ B ) ) ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Opred__option,type,
    pred_option: 
      !>[A: $tType] : ( ( A > $o ) > ( option @ A ) > $o ) ).

thf(sy_c_Option_Ooption_Orec__option,type,
    rec_option: 
      !>[C: $tType,A: $tType] : ( C > ( A > C ) > ( option @ A ) > C ) ).

thf(sy_c_Option_Ooption_Orel__option,type,
    rel_option: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( option @ A ) > ( option @ B ) > $o ) ).

thf(sy_c_Option_Ooption_Oset__option,type,
    set_option: 
      !>[A: $tType] : ( ( option @ A ) > ( set @ A ) ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( ( set @ ( option @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OAbove,type,
    order_Above: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OAboveS,type,
    order_AboveS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OUnder,type,
    order_Under: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OUnderS,type,
    order_UnderS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_Oabove,type,
    order_above: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OaboveS,type,
    order_aboveS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_Olinear__order__on,type,
    order_679001287576687338der_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Order__Relation_Oofilter,type,
    order_ofilter: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > $o ) ).

thf(sy_c_Order__Relation_Opartial__order__on,type,
    order_7125193373082350890der_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Order__Relation_Opreorder__on,type,
    order_preorder_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Order__Relation_Orelation__of,type,
    order_relation_of: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Order__Relation_Ounder,type,
    order_under: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OunderS,type,
    order_underS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_Owell__order__on,type,
    order_well_order_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder_Omono,type,
    mono: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oordering,type,
    ordering: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Oordering__axioms,type,
    ordering_axioms: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > A > $o ) ).

thf(sy_c_Orderings_Oordering__top__axioms,type,
    ordering_top_axioms: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Orderings_Opartial__preordering,type,
    partial_preordering: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Opreordering,type,
    preordering: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Opreordering__axioms,type,
    preordering_axioms: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( A > ( set @ A ) > A ) ).

thf(sy_c_Partial__Function_Oflat__ord,type,
    partial_flat_ord: 
      !>[A: $tType] : ( A > A > A > $o ) ).

thf(sy_c_Partial__Function_Ofun__lub,type,
    partial_fun_lub: 
      !>[C: $tType,B: $tType,A: $tType] : ( ( ( set @ C ) > B ) > ( set @ ( A > C ) ) > A > B ) ).

thf(sy_c_Partial__Function_Ofun__ord,type,
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > $o ) > ( C > A ) > ( C > B ) > $o ) ).

thf(sy_c_Partial__Function_Oimg__lub,type,
    partial_img_lub: 
      !>[A: $tType,C: $tType,D: $tType,B: $tType] : ( ( A > C ) > ( D > B ) > ( ( set @ C ) > D ) > ( set @ A ) > B ) ).

thf(sy_c_Partial__Function_Oimg__ord,type,
    partial_img_ord: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( C > C > B ) > A > A > B ) ).

thf(sy_c_Partial__Function_Opartial__function__definitions,type,
    partia7178651479351089652itions: 
      !>[A: $tType] : ( ( A > A > $o ) > ( ( set @ A ) > A ) > $o ) ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Predicate_OSeq,type,
    seq2: 
      !>[A: $tType] : ( ( product_unit > ( seq @ A ) ) > ( pred @ A ) ) ).

thf(sy_c_Predicate_Obind,type,
    bind2: 
      !>[A: $tType,B: $tType] : ( ( pred @ A ) > ( A > ( pred @ B ) ) > ( pred @ B ) ) ).

thf(sy_c_Predicate_Oif__pred,type,
    if_pred: $o > ( pred @ product_unit ) ).

thf(sy_c_Predicate_Ois__empty,type,
    is_empty: 
      !>[A: $tType] : ( ( pred @ A ) > $o ) ).

thf(sy_c_Predicate_Oiterate__upto,type,
    iterate_upto: 
      !>[A: $tType] : ( ( code_natural > A ) > code_natural > code_natural > ( pred @ A ) ) ).

thf(sy_c_Predicate_Oiterate__upto__rel,type,
    iterate_upto_rel: 
      !>[A: $tType] : ( ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) > ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) > $o ) ).

thf(sy_c_Predicate_Omap,type,
    map2: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( pred @ A ) > ( pred @ B ) ) ).

thf(sy_c_Predicate_Onot__pred,type,
    not_pred: ( pred @ product_unit ) > ( pred @ product_unit ) ).

thf(sy_c_Predicate_Opred_OPred,type,
    pred2: 
      !>[A: $tType] : ( ( A > $o ) > ( pred @ A ) ) ).

thf(sy_c_Predicate_Opred_Oeval,type,
    eval: 
      !>[A: $tType] : ( ( pred @ A ) > A > $o ) ).

thf(sy_c_Predicate_Opred__of__seq,type,
    pred_of_seq: 
      !>[A: $tType] : ( ( seq @ A ) > ( pred @ A ) ) ).

thf(sy_c_Predicate_Opred__of__set,type,
    pred_of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( pred @ A ) ) ).

thf(sy_c_Predicate_Oseq_OEmpty,type,
    empty: 
      !>[A: $tType] : ( seq @ A ) ).

thf(sy_c_Predicate_Oseq_OInsert,type,
    insert: 
      !>[A: $tType] : ( A > ( pred @ A ) > ( seq @ A ) ) ).

thf(sy_c_Predicate_Oseq_Ocase__seq,type,
    case_seq: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( pred @ A ) > B ) > ( ( pred @ A ) > ( seq @ A ) > B ) > ( seq @ A ) > B ) ).

thf(sy_c_Predicate_Oset__of__pred,type,
    set_of_pred: 
      !>[A: $tType] : ( ( pred @ A ) > ( set @ A ) ) ).

thf(sy_c_Predicate_Oset__of__seq,type,
    set_of_seq: 
      !>[A: $tType] : ( ( seq @ A ) > ( set @ A ) ) ).

thf(sy_c_Predicate_Osingle,type,
    single: 
      !>[A: $tType] : ( A > ( pred @ A ) ) ).

thf(sy_c_Predicate_Osingleton,type,
    singleton: 
      !>[A: $tType] : ( ( product_unit > A ) > ( pred @ A ) > A ) ).

thf(sy_c_Predicate__Compile_Ocontains__pred,type,
    predic7144156976422707464s_pred: 
      !>[A: $tType] : ( ( set @ A ) > A > ( pred @ product_unit ) ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_OUnity,type,
    product_Unity: product_unit ).

thf(sy_c_Product__Type_Oapfst,type,
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( product_prod @ A @ B ) > ( product_prod @ C @ B ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Ocurry,type,
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( ( product_prod @ A @ B ) > C ) > A > B > C ) ).

thf(sy_c_Product__Type_Ointernal__case__prod,type,
    produc5280177257484947105e_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) ).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oprod_Oswap,type,
    product_swap: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) ).

thf(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oscomp,type,
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( A > ( product_prod @ B @ C ) ) > ( B > C > D ) > A > D ) ).

thf(sy_c_Product__Type_Ounit_OAbs__unit,type,
    product_Abs_unit: $o > product_unit ).

thf(sy_c_Product__Type_Ounit_ORep__unit,type,
    product_Rep_unit: product_unit > $o ).

thf(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : ( itself @ A ) ).

thf(sy_c_Quotient_OQuotient3,type,
    quotient3: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > B ) > ( B > A ) > $o ) ).

thf(sy_c_Random_Oinc__shift,type,
    inc_shift: code_natural > code_natural > code_natural ).

thf(sy_c_Random_Oiterate,type,
    iterate: 
      !>[B: $tType,A: $tType] : ( code_natural > ( B > A > ( product_prod @ B @ A ) ) > B > A > ( product_prod @ B @ A ) ) ).

thf(sy_c_Random_Oiterate__rel,type,
    iterate_rel: 
      !>[B: $tType,A: $tType] : ( ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) > ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) > $o ) ).

thf(sy_c_Random_Olog,type,
    log: code_natural > code_natural > code_natural ).

thf(sy_c_Random_Olog__rel,type,
    log_rel: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ code_natural @ code_natural ) > $o ).

thf(sy_c_Random_Ominus__shift,type,
    minus_shift: code_natural > code_natural > code_natural > code_natural ).

thf(sy_c_Random_Onext,type,
    next: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Random_Opick,type,
    pick: 
      !>[A: $tType] : ( ( list @ ( product_prod @ code_natural @ A ) ) > code_natural > A ) ).

thf(sy_c_Random_Orange,type,
    range: code_natural > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Random_Oselect,type,
    select: 
      !>[A: $tType] : ( ( list @ A ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random_Oselect__weight,type,
    select_weight: 
      !>[A: $tType] : ( ( list @ ( product_prod @ code_natural @ A ) ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random_Osplit__seed,type,
    split_seed: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Random__Pred_ORandom,type,
    random_Random: 
      !>[A: $tType] : ( ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( product_prod @ A @ ( product_unit > code_term ) ) @ ( product_prod @ code_natural @ code_natural ) ) ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random__Pred_Obind,type,
    random_bind: 
      !>[A: $tType,B: $tType] : ( ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) ) > ( A > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ B ) @ ( product_prod @ code_natural @ code_natural ) ) ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ B ) @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random__Pred_Oempty,type,
    random_empty: 
      !>[A: $tType] : ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random__Pred_Oiterate__upto,type,
    random_iterate_upto: 
      !>[A: $tType] : ( ( code_natural > A ) > code_natural > code_natural > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random__Pred_Omap,type,
    random_map: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ B ) @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random__Pred_Onot__randompred,type,
    random6974930770145893639ompred: ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ product_unit ) @ ( product_prod @ code_natural @ code_natural ) ) ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ product_unit ) @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Random__Pred_Osingle,type,
    random_single: 
      !>[A: $tType] : ( A > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random__Pred_Ounion,type,
    random_union: 
      !>[A: $tType] : ( ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) ) > ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_ORep__Rat,type,
    rep_Rat: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : ( rat > A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oof__int,type,
    of_int: int > rat ).

thf(sy_c_Rat_Opcr__rat,type,
    pcr_rat: ( product_prod @ int @ int ) > rat > $o ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oratrel,type,
    ratrel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Ref__Time_Oalloc,type,
    ref_alloc: 
      !>[A: $tType] : ( A > ( heap_ext @ product_unit ) > ( product_prod @ ( ref @ A ) @ ( heap_ext @ product_unit ) ) ) ).

thf(sy_c_Ref__Time_Ochange,type,
    ref_change: 
      !>[A: $tType] : ( ( A > A ) > ( ref @ A ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Ref__Time_Oget,type,
    ref_get: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( ref @ A ) > A ) ).

thf(sy_c_Ref__Time_Olookup,type,
    ref_lookup: 
      !>[A: $tType] : ( ( ref @ A ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Ref__Time_Opresent,type,
    ref_present: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( ref @ A ) > $o ) ).

thf(sy_c_Ref__Time_Oref,type,
    ref_ref: 
      !>[A: $tType] : ( A > ( heap_Time_Heap @ ( ref @ A ) ) ) ).

thf(sy_c_Ref__Time_Oset,type,
    ref_set: 
      !>[A: $tType] : ( ( ref @ A ) > A > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) ) ).

thf(sy_c_Ref__Time_Oupdate,type,
    ref_update: 
      !>[A: $tType] : ( ( ref @ A ) > A > ( heap_Time_Heap @ product_unit ) ) ).

thf(sy_c_Relation_ODomain,type,
    domain: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ A ) ) ).

thf(sy_c_Relation_ODomainp,type,
    domainp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > A > $o ) ).

thf(sy_c_Relation_OField,type,
    field2: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Relation_OId,type,
    id2: 
      !>[A: $tType] : ( set @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_OImage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Relation_ORange,type,
    range2: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Relation_ORangep,type,
    rangep: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > B > $o ) ).

thf(sy_c_Relation_Oantisym,type,
    antisym: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Oantisymp,type,
    antisymp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Relation_Oasym,type,
    asym: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Oasymp,type,
    asymp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Relation_Oconverse,type,
    converse: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ A ) ) ) ).

thf(sy_c_Relation_Oconversep,type,
    conversep: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > B > A > $o ) ).

thf(sy_c_Relation_Oinv__image,type,
    inv_image: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Oirreflp,type,
    irreflp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Relation_Orefl__on,type,
    refl_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Oreflp,type,
    reflp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Relation_Orelcompp,type,
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > $o ) > ( B > C > $o ) > A > C > $o ) ).

thf(sy_c_Relation_Osingle__valued,type,
    single_valued: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > $o ) ).

thf(sy_c_Relation_Osingle__valuedp,type,
    single_valuedp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Relation_Osym,type,
    sym: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Osymp,type,
    symp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Relation_Ototal__on,type,
    total_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Otrans,type,
    trans: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Onormalization__semidom__class_Onormalize,type,
    normal6383669964737779283malize: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Rings_Ounit__factor__class_Ounit__factor,type,
    unit_f5069060285200089521factor: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Obind,type,
    bind3: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Set_Odisjnt,type,
    disjnt: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ A ) > $o ) ).

thf(sy_c_Set_Ofilter,type,
    filter3: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Oimage,type,
    image2: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert2: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Ois__empty,type,
    is_empty2: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Set_Ois__singleton,type,
    is_singleton: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Set_Opairwise,type,
    pairwise: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ B ) > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : ( ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > $o ) ).

thf(sy_c_Set__Interval_Oord_OatLeast,type,
    set_atLeast: 
      !>[A: $tType] : ( ( A > A > $o ) > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OatLeastAtMost,type,
    set_atLeastAtMost: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OatLeastLessThan,type,
    set_atLeastLessThan: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OatMost,type,
    set_atMost: 
      !>[A: $tType] : ( ( A > A > $o ) > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OgreaterThan,type,
    set_greaterThan: 
      !>[A: $tType] : ( ( A > A > $o ) > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OgreaterThanAtMost,type,
    set_gr3752724095348155675AtMost: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,
    set_gr287244882034783167ssThan: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord_OlessThan,type,
    set_lessThan: 
      !>[A: $tType] : ( ( A > A > $o ) > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_Sum__Type_OInl,type,
    sum_Inl: 
      !>[A: $tType,B: $tType] : ( A > ( sum_sum @ A @ B ) ) ).

thf(sy_c_Sum__Type_OInr,type,
    sum_Inr: 
      !>[B: $tType,A: $tType] : ( B > ( sum_sum @ A @ B ) ) ).

thf(sy_c_Sum__Type_OPlus,type,
    sum_Plus: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( sum_sum @ A @ B ) ) ) ).

thf(sy_c_Sum__Type_Omap__sum,type,
    sum_map_sum: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C ) > ( B > D ) > ( sum_sum @ A @ B ) > ( sum_sum @ C @ D ) ) ).

thf(sy_c_Sum__Type_Osum_Ocase__sum,type,
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( B > C ) > ( sum_sum @ A @ B ) > C ) ).

thf(sy_c_Syntax__Match_Oac__operator,type,
    syntax_ac_operator: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Syntax__Match_Osyntax__fo__nomatch,type,
    syntax7388354845996824322omatch: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_Transfer_Obi__unique,type,
    bi_unique: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transfer_Oleft__unique,type,
    left_unique: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transfer_Oright__total,type,
    right_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transitive__Closure_Oacyclic,type,
    transitive_acyclic: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortranclp,type,
    transitive_rtranclp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > $o ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otranclp,type,
    transitive_tranclp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > $o ) ).

thf(sy_c_Typedef_Otype__definition,type,
    type_definition: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Typerep_Otyperep__class_Otyperep,type,
    typerep_typerep: 
      !>[A: $tType] : ( ( itself @ A ) > typerep ) ).

thf(sy_c_Wellfounded_Oacc,type,
    acc: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ).

thf(sy_c_Wellfounded_Oless__than,type,
    less_than: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omax__extp,type,
    max_extp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > ( set @ A ) > $o ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_Wellfounded_Owf,type,
    wf: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Wellfounded_OwfP,type,
    wfP: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Wfrec_Oadm__wf,type,
    adm_wf: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( ( A > B ) > A > B ) > $o ) ).

thf(sy_c_Wfrec_Ocut,type,
    cut: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ ( product_prod @ A @ A ) ) > A > A > B ) ).

thf(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_Zorn_OChains,type,
    chains: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Zorn_Ochains,type,
    chains2: 
      !>[A: $tType] : ( ( set @ ( set @ A ) ) > ( set @ ( set @ ( set @ A ) ) ) ) ).

thf(sy_c_Zorn_Oinit__seg__of,type,
    init_seg_of: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

thf(sy_c_Zorn_Opred__on_Ochain,type,
    pred_chain: 
      !>[A: $tType] : ( ( set @ A ) > ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_P,type,
    p: assn ).

thf(sy_v_Q,type,
    q: a > assn ).

thf(sy_v_Q1,type,
    q1: a > assn ).

thf(sy_v_Q2,type,
    q2: a > assn ).

thf(sy_v_b,type,
    b: $o ).

thf(sy_v_f,type,
    f: heap_Time_Heap @ a ).

thf(sy_v_g,type,
    g: heap_Time_Heap @ a ).

% Relevant facts (5723)
thf(fact_0_B,axiom,
    ( b
   => ( hoare_hoare_triple @ a @ p @ f @ q1 ) ) ).

% B
thf(fact_1_NB,axiom,
    ( ~ b
   => ( hoare_hoare_triple @ a @ p @ g @ q2 ) ) ).

% NB
thf(fact_2_if__rule,axiom,
    ! [A: $tType,B2: $o,P: assn,F: heap_Time_Heap @ A,Q: A > assn,G: heap_Time_Heap @ A] :
      ( ( B2
       => ( hoare_hoare_triple @ A @ P @ F @ Q ) )
     => ( ( ~ B2
         => ( hoare_hoare_triple @ A @ P @ G @ Q ) )
       => ( hoare_hoare_triple @ A @ P @ ( if @ ( heap_Time_Heap @ A ) @ B2 @ F @ G ) @ Q ) ) ) ).

% if_rule
thf(fact_3_return__wp__rule,axiom,
    ! [A: $tType,Q: A > assn,X: A] : ( hoare_hoare_triple @ A @ ( Q @ X ) @ ( heap_Time_return @ A @ X ) @ Q ) ).

% return_wp_rule
thf(fact_4_M,axiom,
    ! [X: a] : ( entails @ ( sup_sup @ assn @ ( times_times @ assn @ ( q1 @ X ) @ ( pure_assn @ b ) ) @ ( times_times @ assn @ ( q2 @ X ) @ ( pure_assn @ ~ b ) ) ) @ ( q @ X ) ) ).

% M
thf(fact_5_bind__rule,axiom,
    ! [A: $tType,B: $tType,P: assn,F: heap_Time_Heap @ A,R: A > assn,G: A > ( heap_Time_Heap @ B ),Q: B > assn] :
      ( ( hoare_hoare_triple @ A @ P @ F @ R )
     => ( ! [X2: A] : ( hoare_hoare_triple @ B @ ( R @ X2 ) @ ( G @ X2 ) @ Q )
       => ( hoare_hoare_triple @ B @ P @ ( heap_Time_bind @ A @ B @ F @ G ) @ Q ) ) ) ).

% bind_rule
thf(fact_6_false__rule,axiom,
    ! [A: $tType,C2: heap_Time_Heap @ A,Q: A > assn] : ( hoare_hoare_triple @ A @ ( bot_bot @ assn ) @ C2 @ Q ) ).

% false_rule
thf(fact_7_cons__rule,axiom,
    ! [A: $tType,P: assn,P2: assn,Q: A > assn,Q2: A > assn,C2: heap_Time_Heap @ A] :
      ( ( entails @ P @ P2 )
     => ( ! [X2: A] : ( entails @ ( Q @ X2 ) @ ( Q2 @ X2 ) )
       => ( ( hoare_hoare_triple @ A @ P2 @ C2 @ Q )
         => ( hoare_hoare_triple @ A @ P @ C2 @ Q2 ) ) ) ) ).

% cons_rule
thf(fact_8_cons__post__rule,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,Q2: A > assn] :
      ( ( hoare_hoare_triple @ A @ P @ C2 @ Q )
     => ( ! [X2: A] : ( entails @ ( Q @ X2 ) @ ( Q2 @ X2 ) )
       => ( hoare_hoare_triple @ A @ P @ C2 @ Q2 ) ) ) ).

% cons_post_rule
thf(fact_9_hoare__triple__preI,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn] :
      ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P @ H )
         => ( hoare_hoare_triple @ A @ P @ C2 @ Q ) )
     => ( hoare_hoare_triple @ A @ P @ C2 @ Q ) ) ).

% hoare_triple_preI
thf(fact_10_new__addr__refl,axiom,
    ! [H2: heap_ext @ product_unit,As: set @ nat] :
      ( ( hoare_new_addrs @ H2 @ As @ H2 )
      = As ) ).

% new_addr_refl
thf(fact_11_raise__iff,axiom,
    ! [A: $tType,P: assn,S: list @ char,Q: A > assn] :
      ( ( hoare_hoare_triple @ A @ P @ ( heap_Time_raise @ A @ S ) @ Q )
      = ( P
        = ( bot_bot @ assn ) ) ) ).

% raise_iff
thf(fact_12_raise__rule,axiom,
    ! [A: $tType,S: list @ char,Q: A > assn] : ( hoare_hoare_triple @ A @ ( bot_bot @ assn ) @ ( heap_Time_raise @ A @ S ) @ Q ) ).

% raise_rule
thf(fact_13_norm__pre__pure__iff__sng,axiom,
    ! [A: $tType,B2: $o,F: heap_Time_Heap @ A,Q: A > assn] :
      ( ( hoare_hoare_triple @ A @ ( pure_assn @ B2 ) @ F @ Q )
      = ( B2
       => ( hoare_hoare_triple @ A @ ( one_one @ assn ) @ F @ Q ) ) ) ).

% norm_pre_pure_iff_sng
thf(fact_14_norm__pre__pure__iff,axiom,
    ! [A: $tType,P: assn,B2: $o,F: heap_Time_Heap @ A,Q: A > assn] :
      ( ( hoare_hoare_triple @ A @ ( times_times @ assn @ P @ ( pure_assn @ B2 ) ) @ F @ Q )
      = ( B2
       => ( hoare_hoare_triple @ A @ P @ F @ Q ) ) ) ).

% norm_pre_pure_iff
thf(fact_15_norm__pre__pure__rule1,axiom,
    ! [A: $tType,B2: $o,P: assn,F: heap_Time_Heap @ A,Q: A > assn] :
      ( ( B2
       => ( hoare_hoare_triple @ A @ P @ F @ Q ) )
     => ( hoare_hoare_triple @ A @ ( times_times @ assn @ P @ ( pure_assn @ B2 ) ) @ F @ Q ) ) ).

% norm_pre_pure_rule1
thf(fact_16_norm__pre__pure__rule2,axiom,
    ! [A: $tType,B2: $o,F: heap_Time_Heap @ A,Q: A > assn] :
      ( ( B2
       => ( hoare_hoare_triple @ A @ ( one_one @ assn ) @ F @ Q ) )
     => ( hoare_hoare_triple @ A @ ( pure_assn @ B2 ) @ F @ Q ) ) ).

% norm_pre_pure_rule2
thf(fact_17_ent__pure__post__iff__sng,axiom,
    ! [P: assn,B2: $o] :
      ( ( entails @ P @ ( pure_assn @ B2 ) )
      = ( ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( rep_assn @ P @ H3 )
           => B2 )
        & ( entails @ P @ ( one_one @ assn ) ) ) ) ).

% ent_pure_post_iff_sng
thf(fact_18_ent__pure__post__iff,axiom,
    ! [P: assn,Q: assn,B2: $o] :
      ( ( entails @ P @ ( times_times @ assn @ Q @ ( pure_assn @ B2 ) ) )
      = ( ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( rep_assn @ P @ H3 )
           => B2 )
        & ( entails @ P @ Q ) ) ) ).

% ent_pure_post_iff
thf(fact_19_ent__pure__pre__iff__sng,axiom,
    ! [B2: $o,Q: assn] :
      ( ( entails @ ( pure_assn @ B2 ) @ Q )
      = ( B2
       => ( entails @ ( one_one @ assn ) @ Q ) ) ) ).

% ent_pure_pre_iff_sng
thf(fact_20_ent__false__iff,axiom,
    ! [P: assn] :
      ( ( entails @ P @ ( bot_bot @ assn ) )
      = ( ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ~ ( rep_assn @ P @ H3 ) ) ) ).

% ent_false_iff
thf(fact_21_ent__pure__pre__iff,axiom,
    ! [P: assn,B2: $o,Q: assn] :
      ( ( entails @ ( times_times @ assn @ P @ ( pure_assn @ B2 ) ) @ Q )
      = ( B2
       => ( entails @ P @ Q ) ) ) ).

% ent_pure_pre_iff
thf(fact_22_mod__pure__star__dist,axiom,
    ! [P: assn,B2: $o,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ P @ ( pure_assn @ B2 ) ) @ H2 )
      = ( ( rep_assn @ P @ H2 )
        & B2 ) ) ).

% mod_pure_star_dist
thf(fact_23_raise__bind,axiom,
    ! [B: $tType,A: $tType,E2: list @ char,F: B > ( heap_Time_Heap @ A )] :
      ( ( heap_Time_bind @ B @ A @ ( heap_Time_raise @ B @ E2 ) @ F )
      = ( heap_Time_raise @ A @ E2 ) ) ).

% raise_bind
thf(fact_24_assn__basic__inequalities_I3_J,axiom,
    ( bot_bot @ assn )
 != ( one_one @ assn ) ).

% assn_basic_inequalities(3)
thf(fact_25_pure__false,axiom,
    ( ( pure_assn @ $false )
    = ( bot_bot @ assn ) ) ).

% pure_false
thf(fact_26_pure__assn__eq__false__iff,axiom,
    ! [P: $o] :
      ( ( ( pure_assn @ P )
        = ( bot_bot @ assn ) )
      = ( ~ P ) ) ).

% pure_assn_eq_false_iff
thf(fact_27_pure__true,axiom,
    ( ( pure_assn @ $true )
    = ( one_one @ assn ) ) ).

% pure_true
thf(fact_28_pure__assn__eq__emp__iff,axiom,
    ! [P: $o] :
      ( ( ( pure_assn @ P )
        = ( one_one @ assn ) )
      = P ) ).

% pure_assn_eq_emp_iff
thf(fact_29_Rep__assn__inject,axiom,
    ! [X: assn,Y: assn] :
      ( ( ( rep_assn @ X )
        = ( rep_assn @ Y ) )
      = ( X = Y ) ) ).

% Rep_assn_inject
thf(fact_30_pure__assn__eq__conv,axiom,
    ! [P: $o,Q: $o] :
      ( ( ( pure_assn @ P )
        = ( pure_assn @ Q ) )
      = ( P = Q ) ) ).

% pure_assn_eq_conv
thf(fact_31_merge__pure__star,axiom,
    ! [A3: $o,B2: $o] :
      ( ( times_times @ assn @ ( pure_assn @ A3 ) @ ( pure_assn @ B2 ) )
      = ( pure_assn
        @ ( A3
          & B2 ) ) ) ).

% merge_pure_star
thf(fact_32_mod__or__dist,axiom,
    ! [P: assn,Q: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( sup_sup @ assn @ P @ Q ) @ H2 )
      = ( ( rep_assn @ P @ H2 )
        | ( rep_assn @ Q @ H2 ) ) ) ).

% mod_or_dist
thf(fact_33_star__false__right,axiom,
    ! [P: assn] :
      ( ( times_times @ assn @ P @ ( bot_bot @ assn ) )
      = ( bot_bot @ assn ) ) ).

% star_false_right
thf(fact_34_star__false__left,axiom,
    ! [P: assn] :
      ( ( times_times @ assn @ ( bot_bot @ assn ) @ P )
      = ( bot_bot @ assn ) ) ).

% star_false_left
thf(fact_35_merge__pure__or,axiom,
    ! [A3: $o,B2: $o] :
      ( ( sup_sup @ assn @ ( pure_assn @ A3 ) @ ( pure_assn @ B2 ) )
      = ( pure_assn
        @ ( A3
          | B2 ) ) ) ).

% merge_pure_or
thf(fact_36_assn__times__assoc,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( ( times_times @ assn @ ( times_times @ assn @ P @ Q ) @ R )
      = ( times_times @ assn @ P @ ( times_times @ assn @ Q @ R ) ) ) ).

% assn_times_assoc
thf(fact_37_assn__times__comm,axiom,
    ( ( times_times @ assn )
    = ( ^ [P3: assn,Q3: assn] : ( times_times @ assn @ Q3 @ P3 ) ) ) ).

% assn_times_comm
thf(fact_38_ent__trans,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( ( entails @ P @ Q )
     => ( ( entails @ Q @ R )
       => ( entails @ P @ R ) ) ) ).

% ent_trans
thf(fact_39_ent__refl,axiom,
    ! [P: assn] : ( entails @ P @ P ) ).

% ent_refl
thf(fact_40_ent__iffI,axiom,
    ! [A4: assn,B3: assn] :
      ( ( entails @ A4 @ B3 )
     => ( ( entails @ B3 @ A4 )
       => ( A4 = B3 ) ) ) ).

% ent_iffI
thf(fact_41_fold__if__return,axiom,
    ! [A: $tType,B2: $o,C2: A,D2: A] :
      ( ( B2
       => ( ( heap_Time_return @ A @ C2 )
          = ( heap_Time_return @ A @ ( if @ A @ B2 @ C2 @ D2 ) ) ) )
      & ( ~ B2
       => ( ( heap_Time_return @ A @ D2 )
          = ( heap_Time_return @ A @ ( if @ A @ B2 @ C2 @ D2 ) ) ) ) ) ).

% fold_if_return
thf(fact_42_mod__starE,axiom,
    ! [A3: assn,B2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ A3 @ B2 ) @ H2 )
     => ~ ( ? [X_1: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] : ( rep_assn @ A3 @ X_1 )
         => ! [H_2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ~ ( rep_assn @ B2 @ H_2 ) ) ) ).

% mod_starE
thf(fact_43_mod__starD,axiom,
    ! [A4: assn,B3: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ A4 @ B3 ) @ H2 )
     => ? [H1: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),H22: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ A4 @ H1 )
          & ( rep_assn @ B3 @ H22 ) ) ) ).

% mod_starD
thf(fact_44_entails__def,axiom,
    ( entails
    = ( ^ [P3: assn,Q3: assn] :
        ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P3 @ H3 )
         => ( rep_assn @ Q3 @ H3 ) ) ) ) ).

% entails_def
thf(fact_45_mem__Collect__eq,axiom,
    ! [A: $tType,A3: A,P: A > $o] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) ).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( collect @ A
        @ ^ [X3: A] : ( member @ A @ X3 @ A4 ) )
      = A4 ) ).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_48_ext,axiom,
    ! [B: $tType,A: $tType,F: A > B,G: A > B] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G @ X2 ) )
     => ( F = G ) ) ).

% ext
thf(fact_49_entailsI,axiom,
    ! [P: assn,Q: assn] :
      ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P @ H )
         => ( rep_assn @ Q @ H ) )
     => ( entails @ P @ Q ) ) ).

% entailsI
thf(fact_50_entailsD,axiom,
    ! [P: assn,Q: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( entails @ P @ Q )
     => ( ( rep_assn @ P @ H2 )
       => ( rep_assn @ Q @ H2 ) ) ) ).

% entailsD
thf(fact_51_ent__fwd,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Q: assn] :
      ( ( rep_assn @ P @ H2 )
     => ( ( entails @ P @ Q )
       => ( rep_assn @ Q @ H2 ) ) ) ).

% ent_fwd
thf(fact_52_ent__star__mono,axiom,
    ! [P: assn,P2: assn,Q: assn,Q2: assn] :
      ( ( entails @ P @ P2 )
     => ( ( entails @ Q @ Q2 )
       => ( entails @ ( times_times @ assn @ P @ Q ) @ ( times_times @ assn @ P2 @ Q2 ) ) ) ) ).

% ent_star_mono
thf(fact_53_star__or__dist2,axiom,
    ! [C3: assn,A4: assn,B3: assn] :
      ( ( times_times @ assn @ C3 @ ( sup_sup @ assn @ A4 @ B3 ) )
      = ( sup_sup @ assn @ ( times_times @ assn @ C3 @ A4 ) @ ( times_times @ assn @ C3 @ B3 ) ) ) ).

% star_or_dist2
thf(fact_54_star__or__dist1,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( ( times_times @ assn @ ( sup_sup @ assn @ A4 @ B3 ) @ C3 )
      = ( sup_sup @ assn @ ( times_times @ assn @ A4 @ C3 ) @ ( times_times @ assn @ B3 @ C3 ) ) ) ).

% star_or_dist1
thf(fact_55_ent__disjI2__direct,axiom,
    ! [B3: assn,A4: assn] : ( entails @ B3 @ ( sup_sup @ assn @ A4 @ B3 ) ) ).

% ent_disjI2_direct
thf(fact_56_ent__disjI1__direct,axiom,
    ! [A4: assn,B3: assn] : ( entails @ A4 @ ( sup_sup @ assn @ A4 @ B3 ) ) ).

% ent_disjI1_direct
thf(fact_57_ent__disjI2_H,axiom,
    ! [A4: assn,C3: assn,B3: assn] :
      ( ( entails @ A4 @ C3 )
     => ( entails @ A4 @ ( sup_sup @ assn @ B3 @ C3 ) ) ) ).

% ent_disjI2'
thf(fact_58_ent__disjI1_H,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( ( entails @ A4 @ B3 )
     => ( entails @ A4 @ ( sup_sup @ assn @ B3 @ C3 ) ) ) ).

% ent_disjI1'
thf(fact_59_ent__disjI2,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( ( entails @ ( sup_sup @ assn @ P @ Q ) @ R )
     => ( entails @ Q @ R ) ) ).

% ent_disjI2
thf(fact_60_ent__disjI1,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( ( entails @ ( sup_sup @ assn @ P @ Q ) @ R )
     => ( entails @ P @ R ) ) ).

% ent_disjI1
thf(fact_61_ent__disjE,axiom,
    ! [A4: assn,C3: assn,B3: assn] :
      ( ( entails @ A4 @ C3 )
     => ( ( entails @ B3 @ C3 )
       => ( entails @ ( sup_sup @ assn @ A4 @ B3 ) @ C3 ) ) ) ).

% ent_disjE
thf(fact_62_mod__false,axiom,
    ! [H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ~ ( rep_assn @ ( bot_bot @ assn ) @ H2 ) ).

% mod_false
thf(fact_63_assn__one__left,axiom,
    ! [P: assn] :
      ( ( times_times @ assn @ ( one_one @ assn ) @ P )
      = P ) ).

% assn_one_left
thf(fact_64_ent__false,axiom,
    ! [P: assn] : ( entails @ ( bot_bot @ assn ) @ P ) ).

% ent_false
thf(fact_65_sup__bot_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A3: A] :
          ( ( sup_sup @ A @ A3 @ ( bot_bot @ A ) )
          = A3 ) ) ).

% sup_bot.right_neutral
thf(fact_66_sup__bot_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ A3 @ B2 ) )
          = ( ( A3
              = ( bot_bot @ A ) )
            & ( B2
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_bot.neutr_eq_iff
thf(fact_67_sup__bot_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A3: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A3 )
          = A3 ) ) ).

% sup_bot.left_neutral
thf(fact_68_sup__bot_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A3: A,B2: A] :
          ( ( ( sup_sup @ A @ A3 @ B2 )
            = ( bot_bot @ A ) )
          = ( ( A3
              = ( bot_bot @ A ) )
            & ( B2
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_bot.eq_neutr_iff
thf(fact_69_sup__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_eq_bot_iff
thf(fact_70_bot__eq__sup__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) ).

% bot_eq_sup_iff
thf(fact_71_sup__bot__right,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) ).

% sup_bot_right
thf(fact_72_sup__bot__left,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X )
          = X ) ) ).

% sup_bot_left
thf(fact_73_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A3 )
          = A3 ) ) ).

% mult_1
thf(fact_74_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% mult.right_neutral
thf(fact_75_lift__collapse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( heap_Time_lift @ B @ A )
      = ( ^ [F2: B > A,X3: B] : ( heap_Time_return @ A @ ( F2 @ X3 ) ) ) ) ).

% lift_collapse
thf(fact_76_sup__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: A > B,G2: A > B,X3: A] : ( sup_sup @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ).

% sup_apply
thf(fact_77_sup_Oidem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A] :
          ( ( sup_sup @ A @ A3 @ A3 )
          = A3 ) ) ).

% sup.idem
thf(fact_78_sup__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) ).

% sup_idem
thf(fact_79_sup_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( sup_sup @ A @ A3 @ ( sup_sup @ A @ A3 @ B2 ) )
          = ( sup_sup @ A @ A3 @ B2 ) ) ) ).

% sup.left_idem
thf(fact_80_sup__left__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_left_idem
thf(fact_81_sup_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A3 @ B2 ) @ B2 )
          = ( sup_sup @ A @ A3 @ B2 ) ) ) ).

% sup.right_idem
thf(fact_82_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_83_ab__semigroup__mult__class_Omult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ B4 @ A5 ) ) ) ) ).

% ab_semigroup_mult_class.mult.commute
thf(fact_84_ab__semigroup__mult__class_Omult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) )
          = ( times_times @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult.left_commute
thf(fact_85_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_86_inf__sup__aci_I8_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_aci(8)
thf(fact_87_inf__sup__aci_I7_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% inf_sup_aci(7)
thf(fact_88_inf__sup__aci_I6_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z2 )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% inf_sup_aci(6)
thf(fact_89_inf__sup__aci_I5_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ( ( sup_sup @ A )
        = ( ^ [X3: A,Y2: A] : ( sup_sup @ A @ Y2 @ X3 ) ) ) ) ).

% inf_sup_aci(5)
thf(fact_90_sup_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A3 @ B2 ) @ C2 )
          = ( sup_sup @ A @ A3 @ ( sup_sup @ A @ B2 @ C2 ) ) ) ) ).

% sup.assoc
thf(fact_91_sup__assoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z2 )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% sup_assoc
thf(fact_92_sup_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( sup_sup @ A )
        = ( ^ [A5: A,B4: A] : ( sup_sup @ A @ B4 @ A5 ) ) ) ) ).

% sup.commute
thf(fact_93_sup__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( sup_sup @ A )
        = ( ^ [X3: A,Y2: A] : ( sup_sup @ A @ Y2 @ X3 ) ) ) ) ).

% sup_commute
thf(fact_94_sup_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( sup_sup @ A @ B2 @ ( sup_sup @ A @ A3 @ C2 ) )
          = ( sup_sup @ A @ A3 @ ( sup_sup @ A @ B2 @ C2 ) ) ) ) ).

% sup.left_commute
thf(fact_95_sup__left__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% sup_left_commute
thf(fact_96_sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: A > B,G2: A > B,X3: A] : ( sup_sup @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ).

% sup_fun_def
thf(fact_97_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A3 )
          = A3 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_98_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% mult.comm_neutral
thf(fact_99_bot__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( bot @ C )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X3: D] : ( bot_bot @ C ) ) ) ) ).

% bot_apply
thf(fact_100_boolean__algebra_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) ).

% boolean_algebra.disj_zero_right
thf(fact_101_sngr__same__false,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P4: ref @ A,X: A,Y: A] :
          ( ( times_times @ assn @ ( sngr_assn @ A @ P4 @ X ) @ ( sngr_assn @ A @ P4 @ Y ) )
          = ( bot_bot @ assn ) ) ) ).

% sngr_same_false
thf(fact_102_ent__mp,axiom,
    ! [P: assn,Q: assn] : ( entails @ ( times_times @ assn @ P @ ( wand_assn @ P @ Q ) ) @ Q ) ).

% ent_mp
thf(fact_103_ent__wandI,axiom,
    ! [Q: assn,P: assn,R: assn] :
      ( ( entails @ ( times_times @ assn @ Q @ P ) @ R )
     => ( entails @ P @ ( wand_assn @ Q @ R ) ) ) ).

% ent_wandI
thf(fact_104_snga__same__false,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P4: array @ A,X: list @ A,Y: list @ A] :
          ( ( times_times @ assn @ ( snga_assn @ A @ P4 @ X ) @ ( snga_assn @ A @ P4 @ Y ) )
          = ( bot_bot @ assn ) ) ) ).

% snga_same_false
thf(fact_105_preciseD_H,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn,A3: A,P4: B,F3: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),A6: A,F4: assn] :
      ( ( precise @ A @ B @ R )
     => ( ( rep_assn @ ( times_times @ assn @ ( R @ A3 @ P4 ) @ F3 ) @ H2 )
       => ( ( rep_assn @ ( times_times @ assn @ ( R @ A6 @ P4 ) @ F4 ) @ H2 )
         => ( A3 = A6 ) ) ) ) ).

% preciseD'
thf(fact_106_is__pure__assn__pure,axiom,
    ! [P: $o] : ( is_pure_assn @ ( pure_assn @ P ) ) ).

% is_pure_assn_pure
thf(fact_107_is__pure__assn__starI,axiom,
    ! [A3: assn,B2: assn] :
      ( ( is_pure_assn @ A3 )
     => ( ( is_pure_assn @ B2 )
       => ( is_pure_assn @ ( times_times @ assn @ A3 @ B2 ) ) ) ) ).

% is_pure_assn_starI
thf(fact_108_boolean__algebra__cancel_Osup1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: A,K: A,A3: A,B2: A] :
          ( ( A4
            = ( sup_sup @ A @ K @ A3 ) )
         => ( ( sup_sup @ A @ A4 @ B2 )
            = ( sup_sup @ A @ K @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ) ).

% boolean_algebra_cancel.sup1
thf(fact_109_boolean__algebra__cancel_Osup2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3
            = ( sup_sup @ A @ K @ B2 ) )
         => ( ( sup_sup @ A @ A3 @ B3 )
            = ( sup_sup @ A @ K @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ) ).

% boolean_algebra_cancel.sup2
thf(fact_110_bot__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot @ B )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X3: A] : ( bot_bot @ B ) ) ) ) ).

% bot_fun_def
thf(fact_111_is__pure__assn__def,axiom,
    ( is_pure_assn
    = ( ^ [A5: assn] :
        ? [P3: $o] :
          ( A5
          = ( pure_assn @ P3 ) ) ) ) ).

% is_pure_assn_def
thf(fact_112_is__pure__assnE,axiom,
    ! [A3: assn] :
      ( ( is_pure_assn @ A3 )
     => ~ ! [P5: $o] :
            ( A3
           != ( pure_assn @ P5 ) ) ) ).

% is_pure_assnE
thf(fact_113_is__pure__assn__basic__simps_I2_J,axiom,
    is_pure_assn @ ( one_one @ assn ) ).

% is_pure_assn_basic_simps(2)
thf(fact_114_is__pure__assn__basic__simps_I1_J,axiom,
    is_pure_assn @ ( bot_bot @ assn ) ).

% is_pure_assn_basic_simps(1)
thf(fact_115_precise__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( precise @ A @ B )
      = ( ^ [R2: A > B > assn] :
          ! [A5: A,A7: A,H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),P6: B,F5: assn,F6: assn] :
            ( ( rep_assn @ ( inf_inf @ assn @ ( times_times @ assn @ ( R2 @ A5 @ P6 ) @ F5 ) @ ( times_times @ assn @ ( R2 @ A7 @ P6 ) @ F6 ) ) @ H3 )
           => ( A5 = A7 ) ) ) ) ).

% precise_def
thf(fact_116_preciseI,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn] :
      ( ! [A8: A,A9: A,H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),P7: B,F7: assn,F8: assn] :
          ( ( rep_assn @ ( inf_inf @ assn @ ( times_times @ assn @ ( R @ A8 @ P7 ) @ F7 ) @ ( times_times @ assn @ ( R @ A9 @ P7 ) @ F8 ) ) @ H )
         => ( A8 = A9 ) )
     => ( precise @ A @ B @ R ) ) ).

% preciseI
thf(fact_117_preciseD,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn,A3: A,P4: B,F3: assn,A6: A,F4: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( precise @ A @ B @ R )
     => ( ( rep_assn @ ( inf_inf @ assn @ ( times_times @ assn @ ( R @ A3 @ P4 ) @ F3 ) @ ( times_times @ assn @ ( R @ A6 @ P4 ) @ F4 ) ) @ H2 )
       => ( A3 = A6 ) ) ) ).

% preciseD
thf(fact_118_mult_Oright__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% mult.right_commute
thf(fact_119_mult_Oright__assoc,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.right_assoc
thf(fact_120_mod__h__bot__iff_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P4: ref @ A,X: A,H2: heap_ext @ product_unit] :
          ~ ( rep_assn @ ( sngr_assn @ A @ P4 @ X ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mod_h_bot_iff(3)
thf(fact_121_sup__bot_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semilattice_neutr @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.semilattice_neutr_axioms
thf(fact_122_mod__h__bot__iff_I4_J,axiom,
    ! [B: $tType] :
      ( ( heap @ B )
     => ! [Q4: array @ B,Y: list @ B,H2: heap_ext @ product_unit] :
          ~ ( rep_assn @ ( snga_assn @ B @ Q4 @ Y ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mod_h_bot_iff(4)
thf(fact_123_sup__bot_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.monoid_axioms
thf(fact_124_mod__h__bot__iff_I7_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( sup_sup @ assn @ P @ Q ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        | ( rep_assn @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(7)
thf(fact_125_lift__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( heap_Time_lift @ A @ B )
      = ( comp @ B @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_return @ B ) ) ) ).

% lift_def
thf(fact_126_mult_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( monoid @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% mult.monoid_axioms
thf(fact_127_inf__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F2: A > B,G2: A > B,X3: A] : ( inf_inf @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ).

% inf_apply
thf(fact_128_inf__right__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Y )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_right_idem
thf(fact_129_inf_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A3 @ B2 ) @ B2 )
          = ( inf_inf @ A @ A3 @ B2 ) ) ) ).

% inf.right_idem
thf(fact_130_inf__left__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_left_idem
thf(fact_131_inf_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( inf_inf @ A @ A3 @ ( inf_inf @ A @ A3 @ B2 ) )
          = ( inf_inf @ A @ A3 @ B2 ) ) ) ).

% inf.left_idem
thf(fact_132_inf__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ X )
          = X ) ) ).

% inf_idem
thf(fact_133_inf_Oidem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A] :
          ( ( inf_inf @ A @ A3 @ A3 )
          = A3 ) ) ).

% inf.idem
thf(fact_134_inf__bot__left,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% inf_bot_left
thf(fact_135_inf__bot__right,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% inf_bot_right
thf(fact_136_boolean__algebra_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_zero_left
thf(fact_137_boolean__algebra_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_zero_right
thf(fact_138_inf__sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = X ) ) ).

% inf_sup_absorb
thf(fact_139_sup__inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = X ) ) ).

% sup_inf_absorb
thf(fact_140_merge__pure__and,axiom,
    ! [A3: $o,B2: $o] :
      ( ( inf_inf @ assn @ ( pure_assn @ A3 ) @ ( pure_assn @ B2 ) )
      = ( pure_assn
        @ ( A3
          & B2 ) ) ) ).

% merge_pure_and
thf(fact_141_mod__h__bot__iff_I5_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( times_times @ assn @ P @ Q ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        & ( rep_assn @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(5)
thf(fact_142_mod__h__bot__iff_I1_J,axiom,
    ! [B2: $o,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( pure_assn @ B2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = B2 ) ).

% mod_h_bot_iff(1)
thf(fact_143_mod__h__bot__iff_I6_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( inf_inf @ assn @ P @ Q ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        & ( rep_assn @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(6)
thf(fact_144_boolean__algebra__cancel_Oinf2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3
            = ( inf_inf @ A @ K @ B2 ) )
         => ( ( inf_inf @ A @ A3 @ B3 )
            = ( inf_inf @ A @ K @ ( inf_inf @ A @ A3 @ B2 ) ) ) ) ) ).

% boolean_algebra_cancel.inf2
thf(fact_145_boolean__algebra__cancel_Oinf1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: A,K: A,A3: A,B2: A] :
          ( ( A4
            = ( inf_inf @ A @ K @ A3 ) )
         => ( ( inf_inf @ A @ A4 @ B2 )
            = ( inf_inf @ A @ K @ ( inf_inf @ A @ A3 @ B2 ) ) ) ) ) ).

% boolean_algebra_cancel.inf1
thf(fact_146_one__assn__raw_Ocases,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
          ( X
         != ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ).

% one_assn_raw.cases
thf(fact_147_inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F2: A > B,G2: A > B,X3: A] : ( inf_inf @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ).

% inf_fun_def
thf(fact_148_inf__left__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z2 ) ) ) ) ).

% inf_left_commute
thf(fact_149_inf_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( inf_inf @ A @ B2 @ ( inf_inf @ A @ A3 @ C2 ) )
          = ( inf_inf @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ).

% inf.left_commute
thf(fact_150_inf__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( inf_inf @ A )
        = ( ^ [X3: A,Y2: A] : ( inf_inf @ A @ Y2 @ X3 ) ) ) ) ).

% inf_commute
thf(fact_151_inf_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( inf_inf @ A )
        = ( ^ [A5: A,B4: A] : ( inf_inf @ A @ B4 @ A5 ) ) ) ) ).

% inf.commute
thf(fact_152_inf__assoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z2 )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ).

% inf_assoc
thf(fact_153_inf_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 )
          = ( inf_inf @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ).

% inf.assoc
thf(fact_154_monoid_Oright__neutral,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,A3: A] :
      ( ( monoid @ A @ F @ Z2 )
     => ( ( F @ A3 @ Z2 )
        = A3 ) ) ).

% monoid.right_neutral
thf(fact_155_monoid_Oleft__neutral,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,A3: A] :
      ( ( monoid @ A @ F @ Z2 )
     => ( ( F @ Z2 @ A3 )
        = A3 ) ) ).

% monoid.left_neutral
thf(fact_156_inf__sup__aci_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ( ( inf_inf @ A )
        = ( ^ [X3: A,Y2: A] : ( inf_inf @ A @ Y2 @ X3 ) ) ) ) ).

% inf_sup_aci(1)
thf(fact_157_inf__sup__aci_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z2 )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ).

% inf_sup_aci(2)
thf(fact_158_inf__sup__aci_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z2 ) ) ) ) ).

% inf_sup_aci(3)
thf(fact_159_inf__sup__aci_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_sup_aci(4)
thf(fact_160_distrib__imp1,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ! [X2: A,Y3: A,Z3: A] :
              ( ( inf_inf @ A @ X2 @ ( sup_sup @ A @ Y3 @ Z3 ) )
              = ( sup_sup @ A @ ( inf_inf @ A @ X2 @ Y3 ) @ ( inf_inf @ A @ X2 @ Z3 ) ) )
         => ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
            = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ) ).

% distrib_imp1
thf(fact_161_distrib__imp2,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ! [X2: A,Y3: A,Z3: A] :
              ( ( sup_sup @ A @ X2 @ ( inf_inf @ A @ Y3 @ Z3 ) )
              = ( inf_inf @ A @ ( sup_sup @ A @ X2 @ Y3 ) @ ( sup_sup @ A @ X2 @ Z3 ) ) )
         => ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) )
            = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z2 ) ) ) ) ) ).

% distrib_imp2
thf(fact_162_inf__sup__distrib1,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z2 ) ) ) ) ).

% inf_sup_distrib1
thf(fact_163_inf__sup__distrib2,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X ) @ ( inf_inf @ A @ Z2 @ X ) ) ) ) ).

% inf_sup_distrib2
thf(fact_164_sup__inf__distrib1,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% sup_inf_distrib1
thf(fact_165_sup__inf__distrib2,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z2 ) @ X )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X ) @ ( sup_sup @ A @ Z2 @ X ) ) ) ) ).

% sup_inf_distrib2
thf(fact_166_boolean__algebra_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z2 ) ) ) ) ).

% boolean_algebra.conj_disj_distrib
thf(fact_167_boolean__algebra_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% boolean_algebra.disj_conj_distrib
thf(fact_168_boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X ) @ ( inf_inf @ A @ Z2 @ X ) ) ) ) ).

% boolean_algebra.conj_disj_distrib2
thf(fact_169_boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z2 ) @ X )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X ) @ ( sup_sup @ A @ Z2 @ X ) ) ) ) ).

% boolean_algebra.disj_conj_distrib2
thf(fact_170_mod__and__dist,axiom,
    ! [P: assn,Q: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( inf_inf @ assn @ P @ Q ) @ H2 )
      = ( ( rep_assn @ P @ H2 )
        & ( rep_assn @ Q @ H2 ) ) ) ).

% mod_and_dist
thf(fact_171_ent__conjI,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( ( entails @ A4 @ B3 )
     => ( ( entails @ A4 @ C3 )
       => ( entails @ A4 @ ( inf_inf @ assn @ B3 @ C3 ) ) ) ) ).

% ent_conjI
thf(fact_172_ent__conjE1,axiom,
    ! [A4: assn,C3: assn,B3: assn] :
      ( ( entails @ A4 @ C3 )
     => ( entails @ ( inf_inf @ assn @ A4 @ B3 ) @ C3 ) ) ).

% ent_conjE1
thf(fact_173_ent__conjE2,axiom,
    ! [B3: assn,C3: assn,A4: assn] :
      ( ( entails @ B3 @ C3 )
     => ( entails @ ( inf_inf @ assn @ A4 @ B3 ) @ C3 ) ) ).

% ent_conjE2
thf(fact_174_mod__h__bot__indep,axiom,
    ! [P: assn,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit] :
      ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mod_h_bot_indep
thf(fact_175_mod__emp__simp,axiom,
    ! [H2: heap_ext @ product_unit] : ( rep_assn @ ( one_one @ assn ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% mod_emp_simp
thf(fact_176_comp__apply,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F2: B > A,G2: C > B,X3: C] : ( F2 @ ( G2 @ X3 ) ) ) ) ).

% comp_apply
thf(fact_177_empty__Collect__eq,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X3: A] :
            ~ ( P @ X3 ) ) ) ).

% empty_Collect_eq
thf(fact_178_Collect__empty__eq,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X3: A] :
            ~ ( P @ X3 ) ) ) ).

% Collect_empty_eq
thf(fact_179_all__not__in__conv,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ! [X3: A] :
            ~ ( member @ A @ X3 @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% all_not_in_conv
thf(fact_180_empty__iff,axiom,
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) ).

% empty_iff
thf(fact_181_Un__empty,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        & ( B3
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Un_empty
thf(fact_182_prod_Oinject,axiom,
    ! [A: $tType,B: $tType,X1: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y22 ) ) ) ).

% prod.inject
thf(fact_183_old_Oprod_Oinject,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,A6: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B2 )
        = ( product_Pair @ A @ B @ A6 @ B5 ) )
      = ( ( A3 = A6 )
        & ( B2 = B5 ) ) ) ).

% old.prod.inject
thf(fact_184_hoare__triple__effect,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,H2: heap_ext @ product_unit,As: set @ nat] :
      ( ( hoare_hoare_triple @ A @ P @ C2 @ Q )
     => ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
       => ? [H5: heap_ext @ product_unit,R3: A,T2: nat] :
            ( ( heap_Time_effect @ A @ C2 @ H2 @ H5 @ R3 @ T2 )
            & ( rep_assn @ ( Q @ R3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ ( hoare_new_addrs @ H2 @ As @ H5 ) ) ) ) ) ) ).

% hoare_triple_effect
thf(fact_185_pure__assn__raw_Oelims_I3_J,axiom,
    ! [B: $tType,A: $tType,X: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ~ ( pure_assn_raw @ A @ B @ X @ Xa )
     => ~ ! [H: A,As2: set @ B] :
            ( ( Xa
              = ( product_Pair @ A @ ( set @ B ) @ H @ As2 ) )
           => ( ( As2
                = ( bot_bot @ ( set @ B ) ) )
              & X ) ) ) ).

% pure_assn_raw.elims(3)
thf(fact_186_pure__assn__raw_Oelims_I2_J,axiom,
    ! [B: $tType,A: $tType,X: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ( pure_assn_raw @ A @ B @ X @ Xa )
     => ~ ! [H: A,As2: set @ B] :
            ( ( Xa
              = ( product_Pair @ A @ ( set @ B ) @ H @ As2 ) )
           => ~ ( ( As2
                  = ( bot_bot @ ( set @ B ) ) )
                & X ) ) ) ).

% pure_assn_raw.elims(2)
thf(fact_187_pure__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X: $o,Xa: product_prod @ A @ ( set @ B ),Y: $o] :
      ( ( ( pure_assn_raw @ A @ B @ X @ Xa )
        = Y )
     => ~ ! [H: A,As2: set @ B] :
            ( ( Xa
              = ( product_Pair @ A @ ( set @ B ) @ H @ As2 ) )
           => ( Y
              = ( ~ ( ( As2
                      = ( bot_bot @ ( set @ B ) ) )
                    & X ) ) ) ) ) ).

% pure_assn_raw.elims(1)
thf(fact_188_Int__Un__eq_I4_J,axiom,
    ! [A: $tType,T3: set @ A,S2: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ T3 @ ( inf_inf @ ( set @ A ) @ S2 @ T3 ) )
      = T3 ) ).

% Int_Un_eq(4)
thf(fact_189_Int__Un__eq_I3_J,axiom,
    ! [A: $tType,S2: set @ A,T3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ S2 @ ( inf_inf @ ( set @ A ) @ S2 @ T3 ) )
      = S2 ) ).

% Int_Un_eq(3)
thf(fact_190_Int__Un__eq_I2_J,axiom,
    ! [A: $tType,S2: set @ A,T3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ S2 @ T3 ) @ T3 )
      = T3 ) ).

% Int_Un_eq(2)
thf(fact_191_Int__Un__eq_I1_J,axiom,
    ! [A: $tType,S2: set @ A,T3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ S2 @ T3 ) @ S2 )
      = S2 ) ).

% Int_Un_eq(1)
thf(fact_192_Un__Int__eq_I4_J,axiom,
    ! [A: $tType,T3: set @ A,S2: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ T3 @ ( sup_sup @ ( set @ A ) @ S2 @ T3 ) )
      = T3 ) ).

% Un_Int_eq(4)
thf(fact_193_Un__Int__eq_I3_J,axiom,
    ! [A: $tType,S2: set @ A,T3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ S2 @ ( sup_sup @ ( set @ A ) @ S2 @ T3 ) )
      = S2 ) ).

% Un_Int_eq(3)
thf(fact_194_Un__Int__eq_I2_J,axiom,
    ! [A: $tType,S2: set @ A,T3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ S2 @ T3 ) @ T3 )
      = T3 ) ).

% Un_Int_eq(2)
thf(fact_195_Un__Int__eq_I1_J,axiom,
    ! [A: $tType,S2: set @ A,T3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ S2 @ T3 ) @ S2 )
      = S2 ) ).

% Un_Int_eq(1)
thf(fact_196_Un__Int__crazy,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,C3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ ( inf_inf @ ( set @ A ) @ B3 @ C3 ) ) @ ( inf_inf @ ( set @ A ) @ C3 @ A4 ) )
      = ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) @ ( sup_sup @ ( set @ A ) @ B3 @ C3 ) ) @ ( sup_sup @ ( set @ A ) @ C3 @ A4 ) ) ) ).

% Un_Int_crazy
thf(fact_197_Int__Un__distrib,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,C3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ B3 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ ( inf_inf @ ( set @ A ) @ A4 @ C3 ) ) ) ).

% Int_Un_distrib
thf(fact_198_Un__Int__distrib,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,C3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B3 @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) @ ( sup_sup @ ( set @ A ) @ A4 @ C3 ) ) ) ).

% Un_Int_distrib
thf(fact_199_Int__Un__distrib2,axiom,
    ! [A: $tType,B3: set @ A,C3: set @ A,A4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B3 @ C3 ) @ A4 )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B3 @ A4 ) @ ( inf_inf @ ( set @ A ) @ C3 @ A4 ) ) ) ).

% Int_Un_distrib2
thf(fact_200_Un__Int__distrib2,axiom,
    ! [A: $tType,B3: set @ A,C3: set @ A,A4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B3 @ C3 ) @ A4 )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B3 @ A4 ) @ ( sup_sup @ ( set @ A ) @ C3 @ A4 ) ) ) ).

% Un_Int_distrib2
thf(fact_201_effect__deterministic_I3_J,axiom,
    ! [A: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,A3: A,N: nat,H6: heap_ext @ product_unit,B2: A,N2: nat] :
      ( ( heap_Time_effect @ A @ F @ H2 @ H4 @ A3 @ N )
     => ( ( heap_Time_effect @ A @ F @ H2 @ H6 @ B2 @ N2 )
       => ( N = N2 ) ) ) ).

% effect_deterministic(3)
thf(fact_202_effect__deterministic_I2_J,axiom,
    ! [A: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,A3: A,N: nat,H6: heap_ext @ product_unit,B2: A,N2: nat] :
      ( ( heap_Time_effect @ A @ F @ H2 @ H4 @ A3 @ N )
     => ( ( heap_Time_effect @ A @ F @ H2 @ H6 @ B2 @ N2 )
       => ( H4 = H6 ) ) ) ).

% effect_deterministic(2)
thf(fact_203_effect__deterministic_I1_J,axiom,
    ! [A: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,A3: A,N: nat,H6: heap_ext @ product_unit,B2: A,N2: nat] :
      ( ( heap_Time_effect @ A @ F @ H2 @ H4 @ A3 @ N )
     => ( ( heap_Time_effect @ A @ F @ H2 @ H6 @ B2 @ N2 )
       => ( A3 = B2 ) ) ) ).

% effect_deterministic(1)
thf(fact_204_effect__ifE,axiom,
    ! [A: $tType,C2: $o,T4: heap_Time_Heap @ A,E2: heap_Time_Heap @ A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( if @ ( heap_Time_Heap @ A ) @ C2 @ T4 @ E2 ) @ H2 @ H4 @ R4 @ N )
     => ( ( C2
         => ~ ( heap_Time_effect @ A @ T4 @ H2 @ H4 @ R4 @ N ) )
       => ~ ( ~ C2
           => ~ ( heap_Time_effect @ A @ E2 @ H2 @ H4 @ R4 @ N ) ) ) ) ).

% effect_ifE
thf(fact_205_effect__ifI,axiom,
    ! [A: $tType,C2: $o,T4: heap_Time_Heap @ A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat,E2: heap_Time_Heap @ A] :
      ( ( C2
       => ( heap_Time_effect @ A @ T4 @ H2 @ H4 @ R4 @ N ) )
     => ( ( ~ C2
         => ( heap_Time_effect @ A @ E2 @ H2 @ H4 @ R4 @ N ) )
       => ( heap_Time_effect @ A @ ( if @ ( heap_Time_Heap @ A ) @ C2 @ T4 @ E2 ) @ H2 @ H4 @ R4 @ N ) ) ) ).

% effect_ifI
thf(fact_206_times__assn__raw_Ocases,axiom,
    ! [X: product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) )] :
      ~ ! [P5: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q5: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H: heap_ext @ product_unit,As2: set @ nat] :
          ( X
         != ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ P5 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Q5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) ) ).

% times_assn_raw.cases
thf(fact_207_sngr__assn__raw_Ocases,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) )] :
          ~ ! [R3: ref @ A,X2: A,H: heap_ext @ product_unit,As2: set @ nat] :
              ( X
             != ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ R3 @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ X2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) ) ) ).

% sngr_assn_raw.cases
thf(fact_208_snga__assn__raw_Ocases,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) )] :
          ~ ! [R3: array @ A,X2: list @ A,H: heap_ext @ product_unit,As2: set @ nat] :
              ( X
             != ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ R3 @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ X2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) ) ) ).

% snga_assn_raw.cases
thf(fact_209_Int__emptyI,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A4 )
         => ~ ( member @ A @ X2 @ B3 ) )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% Int_emptyI
thf(fact_210_disjoint__iff,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ~ ( member @ A @ X3 @ B3 ) ) ) ) ).

% disjoint_iff
thf(fact_211_Int__empty__left,axiom,
    ! [A: $tType,B3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B3 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_empty_left
thf(fact_212_Int__empty__right,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_empty_right
thf(fact_213_disjoint__iff__not__equal,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ! [Y2: A] :
                ( ( member @ A @ Y2 @ B3 )
               => ( X3 != Y2 ) ) ) ) ) ).

% disjoint_iff_not_equal
thf(fact_214_pure__assn__raw_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ $o @ ( product_prod @ A @ ( set @ B ) )] :
      ~ ! [B6: $o,H: A,As2: set @ B] :
          ( X
         != ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ B6 @ ( product_Pair @ A @ ( set @ B ) @ H @ As2 ) ) ) ).

% pure_assn_raw.cases
thf(fact_215_effect__returnI,axiom,
    ! [A: $tType,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,X: A] :
      ( ( H2 = H4 )
     => ( heap_Time_effect @ A @ ( heap_Time_return @ A @ X ) @ H2 @ H4 @ X @ ( one_one @ nat ) ) ) ).

% effect_returnI
thf(fact_216_effect__returnE,axiom,
    ! [A: $tType,X: A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( heap_Time_return @ A @ X ) @ H2 @ H4 @ R4 @ N )
     => ~ ( ( R4 = X )
         => ( ( H4 = H2 )
           => ( N
             != ( one_one @ nat ) ) ) ) ) ).

% effect_returnE
thf(fact_217_effect__raiseE,axiom,
    ! [A: $tType,X: list @ char,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ~ ( heap_Time_effect @ A @ ( heap_Time_raise @ A @ X ) @ H2 @ H4 @ R4 @ N ) ).

% effect_raiseE
thf(fact_218_prod__induct7,axiom,
    ! [G3: $tType,F9: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) ) ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) ) ) )] :
      ( ! [A8: A,B6: B,C4: C,D3: D,E3: E,F10: F9,G4: G3] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) @ D3 @ ( product_Pair @ E @ ( product_prod @ F9 @ G3 ) @ E3 @ ( product_Pair @ F9 @ G3 @ F10 @ G4 ) ) ) ) ) ) )
     => ( P @ X ) ) ).

% prod_induct7
thf(fact_219_prod__induct6,axiom,
    ! [F9: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F9 ) ) ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F9 ) ) ) )] :
      ( ! [A8: A,B6: B,C4: C,D3: D,E3: E,F10: F9] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F9 ) ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F9 ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F9 ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ F9 ) @ D3 @ ( product_Pair @ E @ F9 @ E3 @ F10 ) ) ) ) ) )
     => ( P @ X ) ) ).

% prod_induct6
thf(fact_220_prod__induct5,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) )] :
      ( ! [A8: A,B6: B,C4: C,D3: D,E3: E] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C4 @ ( product_Pair @ D @ E @ D3 @ E3 ) ) ) ) )
     => ( P @ X ) ) ).

% prod_induct5
thf(fact_221_prod__induct4,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) )] :
      ( ! [A8: A,B6: B,C4: C,D3: D] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C4 @ D3 ) ) ) )
     => ( P @ X ) ) ).

% prod_induct4
thf(fact_222_prod__induct3,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ C )] :
      ( ! [A8: A,B6: B,C4: C] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A8 @ ( product_Pair @ B @ C @ B6 @ C4 ) ) )
     => ( P @ X ) ) ).

% prod_induct3
thf(fact_223_prod__cases7,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F9: $tType,G3: $tType,Y: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) ) ) )] :
      ~ ! [A8: A,B6: B,C4: C,D3: D,E3: E,F10: F9,G4: G3] :
          ( Y
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F9 @ G3 ) ) @ D3 @ ( product_Pair @ E @ ( product_prod @ F9 @ G3 ) @ E3 @ ( product_Pair @ F9 @ G3 @ F10 @ G4 ) ) ) ) ) ) ) ).

% prod_cases7
thf(fact_224_prod__cases6,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F9: $tType,Y: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F9 ) ) ) )] :
      ~ ! [A8: A,B6: B,C4: C,D3: D,E3: E,F10: F9] :
          ( Y
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F9 ) ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F9 ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F9 ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ F9 ) @ D3 @ ( product_Pair @ E @ F9 @ E3 @ F10 ) ) ) ) ) ) ).

% prod_cases6
thf(fact_225_prod__cases5,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) )] :
      ~ ! [A8: A,B6: B,C4: C,D3: D,E3: E] :
          ( Y
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C4 @ ( product_Pair @ D @ E @ D3 @ E3 ) ) ) ) ) ).

% prod_cases5
thf(fact_226_prod__cases4,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) )] :
      ~ ! [A8: A,B6: B,C4: C,D3: D] :
          ( Y
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C4 @ D3 ) ) ) ) ).

% prod_cases4
thf(fact_227_prod__cases3,axiom,
    ! [A: $tType,B: $tType,C: $tType,Y: product_prod @ A @ ( product_prod @ B @ C )] :
      ~ ! [A8: A,B6: B,C4: C] :
          ( Y
         != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A8 @ ( product_Pair @ B @ C @ B6 @ C4 ) ) ) ).

% prod_cases3
thf(fact_228_Pair__inject,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,A6: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B2 )
        = ( product_Pair @ A @ B @ A6 @ B5 ) )
     => ~ ( ( A3 = A6 )
         => ( B2 != B5 ) ) ) ).

% Pair_inject
thf(fact_229_prod__cases,axiom,
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ) > $o,P4: product_prod @ A @ B] :
      ( ! [A8: A,B6: B] : ( P @ ( product_Pair @ A @ B @ A8 @ B6 ) )
     => ( P @ P4 ) ) ).

% prod_cases
thf(fact_230_surj__pair,axiom,
    ! [A: $tType,B: $tType,P4: product_prod @ A @ B] :
    ? [X2: A,Y3: B] :
      ( P4
      = ( product_Pair @ A @ B @ X2 @ Y3 ) ) ).

% surj_pair
thf(fact_231_old_Oprod_Oexhaust,axiom,
    ! [A: $tType,B: $tType,Y: product_prod @ A @ B] :
      ~ ! [A8: A,B6: B] :
          ( Y
         != ( product_Pair @ A @ B @ A8 @ B6 ) ) ).

% old.prod.exhaust
thf(fact_232_emptyE,axiom,
    ! [A: $tType,A3: A] :
      ~ ( member @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ).

% emptyE
thf(fact_233_equals0D,axiom,
    ! [A: $tType,A4: set @ A,A3: A] :
      ( ( A4
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A3 @ A4 ) ) ).

% equals0D
thf(fact_234_equals0I,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ! [Y3: A] :
          ~ ( member @ A @ Y3 @ A4 )
     => ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% equals0I
thf(fact_235_ex__in__conv,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ? [X3: A] : ( member @ A @ X3 @ A4 ) )
      = ( ( A4
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% ex_in_conv
thf(fact_236_bot__set__def,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) ).

% bot_set_def
thf(fact_237_Un__empty__left,axiom,
    ! [A: $tType,B3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B3 )
      = B3 ) ).

% Un_empty_left
thf(fact_238_Un__empty__right,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = A4 ) ).

% Un_empty_right
thf(fact_239_comp__eq__dest__lhs,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: C > B,B2: A > C,C2: A > B,V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B2 )
        = C2 )
     => ( ( A3 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) ).

% comp_eq_dest_lhs
thf(fact_240_comp__eq__elim,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A3: C > B,B2: A > C,C2: D > B,D2: A > D] :
      ( ( ( comp @ C @ B @ A @ A3 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ! [V2: A] :
          ( ( A3 @ ( B2 @ V2 ) )
          = ( C2 @ ( D2 @ V2 ) ) ) ) ).

% comp_eq_elim
thf(fact_241_comp__eq__dest,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A3: C > B,B2: A > C,C2: D > B,D2: A > D,V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ( ( A3 @ ( B2 @ V ) )
        = ( C2 @ ( D2 @ V ) ) ) ) ).

% comp_eq_dest
thf(fact_242_comp__assoc,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: D > B,G: C > D,H2: A > C] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G ) @ H2 )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G @ H2 ) ) ) ).

% comp_assoc
thf(fact_243_comp__def,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F2: B > C,G2: A > B,X3: A] : ( F2 @ ( G2 @ X3 ) ) ) ) ).

% comp_def
thf(fact_244_star__assnI,axiom,
    ! [P: assn,H2: heap_ext @ product_unit,As: set @ nat,Q: assn,As3: set @ nat] :
      ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
     => ( ( rep_assn @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As3 ) )
       => ( ( ( inf_inf @ ( set @ nat ) @ As @ As3 )
            = ( bot_bot @ ( set @ nat ) ) )
         => ( rep_assn @ ( times_times @ assn @ P @ Q ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( sup_sup @ ( set @ nat ) @ As @ As3 ) ) ) ) ) ) ).

% star_assnI
thf(fact_245_mod__star__conv,axiom,
    ! [A4: assn,B3: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ A4 @ B3 ) @ H2 )
      = ( ? [Hr: heap_ext @ product_unit,As1: set @ nat,As22: set @ nat] :
            ( ( H2
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ Hr @ ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) ) )
            & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
              = ( bot_bot @ ( set @ nat ) ) )
            & ( rep_assn @ A4 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ Hr @ As1 ) )
            & ( rep_assn @ B3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ Hr @ As22 ) ) ) ) ) ).

% mod_star_conv
thf(fact_246_pure__assn__raw_Osimps,axiom,
    ! [A: $tType,B: $tType,B2: $o,H2: A,As: set @ B] :
      ( ( pure_assn_raw @ A @ B @ B2 @ ( product_Pair @ A @ ( set @ B ) @ H2 @ As ) )
      = ( ( As
          = ( bot_bot @ ( set @ B ) ) )
        & B2 ) ) ).

% pure_assn_raw.simps
thf(fact_247_old_Oprod_Orec,axiom,
    ! [A: $tType,T: $tType,B: $tType,F1: A > B > T,A3: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A3 @ B2 ) )
      = ( F1 @ A3 @ B2 ) ) ).

% old.prod.rec
thf(fact_248_Set_Ois__empty__def,axiom,
    ! [A: $tType] :
      ( ( is_empty2 @ A )
      = ( ^ [A10: set @ A] :
            ( A10
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Set.is_empty_def
thf(fact_249_internal__case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: B > C > A,A3: B,B2: C] :
      ( ( produc5280177257484947105e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A3 @ B2 ) )
      = ( C2 @ A3 @ B2 ) ) ).

% internal_case_prod_conv
thf(fact_250_one__assn__raw_Osimps,axiom,
    ! [H2: heap_ext @ product_unit,As: set @ nat] :
      ( ( one_assn_raw @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
      = ( As
        = ( bot_bot @ ( set @ nat ) ) ) ) ).

% one_assn_raw.simps
thf(fact_251_one__assn__raw_Oelims_I1_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( one_assn_raw @ X )
        = Y )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ( Y
              = ( ( As2
                 != ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% one_assn_raw.elims(1)
thf(fact_252_one__assn__raw_Oelims_I2_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( one_assn_raw @ X )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ( As2
             != ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% one_assn_raw.elims(2)
thf(fact_253_one__assn__raw_Oelims_I3_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( one_assn_raw @ X )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ( As2
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% one_assn_raw.elims(3)
thf(fact_254_hoare__triple__success,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,H2: heap_ext @ product_unit,As: set @ nat] :
      ( ( hoare_hoare_triple @ A @ P @ C2 @ Q )
     => ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
       => ( heap_Time_success @ A @ C2 @ H2 ) ) ) ).

% hoare_triple_success
thf(fact_255_times__assn__raw_Osimps,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As: set @ nat] :
      ( ( times_assn_raw @ P @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
      = ( ? [As1: set @ nat,As22: set @ nat] :
            ( ( As
              = ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) )
            & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
              = ( bot_bot @ ( set @ nat ) ) )
            & ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As1 ) )
            & ( Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As22 ) ) ) ) ) ).

% times_assn_raw.simps
thf(fact_256_times__assn__raw_Oelims_I1_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( times_assn_raw @ X @ Xa @ Xb )
        = Y )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ( Y
              = ( ~ ? [As1: set @ nat,As22: set @ nat] :
                      ( ( As2
                        = ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) )
                      & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
                        = ( bot_bot @ ( set @ nat ) ) )
                      & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As1 ) )
                      & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As22 ) ) ) ) ) ) ) ).

% times_assn_raw.elims(1)
thf(fact_257_times__assn__raw_Oelims_I2_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( times_assn_raw @ X @ Xa @ Xb )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ~ ? [As12: set @ nat,As23: set @ nat] :
                  ( ( As2
                    = ( sup_sup @ ( set @ nat ) @ As12 @ As23 ) )
                  & ( ( inf_inf @ ( set @ nat ) @ As12 @ As23 )
                    = ( bot_bot @ ( set @ nat ) ) )
                  & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As12 ) )
                  & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As23 ) ) ) ) ) ).

% times_assn_raw.elims(2)
thf(fact_258_IntI,axiom,
    ! [A: $tType,C2: A,A4: set @ A,B3: set @ A] :
      ( ( member @ A @ C2 @ A4 )
     => ( ( member @ A @ C2 @ B3 )
       => ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% IntI
thf(fact_259_Int__iff,axiom,
    ! [A: $tType,C2: A,A4: set @ A,B3: set @ A] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
      = ( ( member @ A @ C2 @ A4 )
        & ( member @ A @ C2 @ B3 ) ) ) ).

% Int_iff
thf(fact_260_IntE,axiom,
    ! [A: $tType,C2: A,A4: set @ A,B3: set @ A] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
     => ~ ( ( member @ A @ C2 @ A4 )
         => ~ ( member @ A @ C2 @ B3 ) ) ) ).

% IntE
thf(fact_261_IntD1,axiom,
    ! [A: $tType,C2: A,A4: set @ A,B3: set @ A] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
     => ( member @ A @ C2 @ A4 ) ) ).

% IntD1
thf(fact_262_IntD2,axiom,
    ! [A: $tType,C2: A,A4: set @ A,B3: set @ A] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
     => ( member @ A @ C2 @ B3 ) ) ).

% IntD2
thf(fact_263_Int__assoc,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,C3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ C3 )
      = ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B3 @ C3 ) ) ) ).

% Int_assoc
thf(fact_264_Int__absorb,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ A4 )
      = A4 ) ).

% Int_absorb
thf(fact_265_Int__commute,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A10: set @ A,B7: set @ A] : ( inf_inf @ ( set @ A ) @ B7 @ A10 ) ) ) ).

% Int_commute
thf(fact_266_Int__left__absorb,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ).

% Int_left_absorb
thf(fact_267_Int__left__commute,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,C3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B3 @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ B3 @ ( inf_inf @ ( set @ A ) @ A4 @ C3 ) ) ) ).

% Int_left_commute
thf(fact_268_success__ifI,axiom,
    ! [A: $tType,C2: $o,T4: heap_Time_Heap @ A,H2: heap_ext @ product_unit,E2: heap_Time_Heap @ A] :
      ( ( C2
       => ( heap_Time_success @ A @ T4 @ H2 ) )
     => ( ( ~ C2
         => ( heap_Time_success @ A @ E2 @ H2 ) )
       => ( heap_Time_success @ A @ ( if @ ( heap_Time_Heap @ A ) @ C2 @ T4 @ E2 ) @ H2 ) ) ) ).

% success_ifI
thf(fact_269_success__effectE,axiom,
    ! [A: $tType,C2: heap_Time_Heap @ A,H2: heap_ext @ product_unit] :
      ( ( heap_Time_success @ A @ C2 @ H2 )
     => ~ ! [R3: A,H5: heap_ext @ product_unit,N3: nat] :
            ~ ( heap_Time_effect @ A @ C2 @ H2 @ H5 @ R3 @ N3 ) ) ).

% success_effectE
thf(fact_270_effect__success,axiom,
    ! [A: $tType,C2: heap_Time_Heap @ A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ C2 @ H2 @ H4 @ R4 @ N )
     => ( heap_Time_success @ A @ C2 @ H2 ) ) ).

% effect_success
thf(fact_271_success__returnI,axiom,
    ! [A: $tType,X: A,H2: heap_ext @ product_unit] : ( heap_Time_success @ A @ ( heap_Time_return @ A @ X ) @ H2 ) ).

% success_returnI
thf(fact_272_success__bind__effectI,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,X: A,N: nat,G: A > ( heap_Time_Heap @ B )] :
      ( ( heap_Time_effect @ A @ F @ H2 @ H4 @ X @ N )
     => ( ( heap_Time_success @ B @ ( G @ X ) @ H4 )
       => ( heap_Time_success @ B @ ( heap_Time_bind @ A @ B @ F @ G ) @ H2 ) ) ) ).

% success_bind_effectI
thf(fact_273_times__assn__raw_Oelims_I3_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( times_assn_raw @ X @ Xa @ Xb )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ? [As13: set @ nat,As24: set @ nat] :
                ( ( As2
                  = ( sup_sup @ ( set @ nat ) @ As13 @ As24 ) )
                & ( ( inf_inf @ ( set @ nat ) @ As13 @ As24 )
                  = ( bot_bot @ ( set @ nat ) ) )
                & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As13 ) )
                & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As24 ) ) ) ) ) ).

% times_assn_raw.elims(3)
thf(fact_274_Collect__empty__eq__bot,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) ).

% Collect_empty_eq_bot
thf(fact_275_bot__empty__eq,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X3: A] : ( member @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% bot_empty_eq
thf(fact_276_pairself_Ocases,axiom,
    ! [B: $tType,A: $tType,X: product_prod @ ( A > B ) @ ( product_prod @ A @ A )] :
      ~ ! [F10: A > B,A8: A,B6: A] :
          ( X
         != ( product_Pair @ ( A > B ) @ ( product_prod @ A @ A ) @ F10 @ ( product_Pair @ A @ A @ A8 @ B6 ) ) ) ).

% pairself.cases
thf(fact_277_disjointI,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A3 )
         => ~ ( member @ A @ X2 @ B2 ) )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% disjointI
thf(fact_278_times__assn__raw_Opelims_I1_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( times_assn_raw @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( Y
                  = ( ? [As1: set @ nat,As22: set @ nat] :
                        ( ( As2
                          = ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) )
                        & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
                          = ( bot_bot @ ( set @ nat ) ) )
                        & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As1 ) )
                        & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As22 ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) ) ) ) ) ) ).

% times_assn_raw.pelims(1)
thf(fact_279_times__assn__raw_Opelims_I2_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( times_assn_raw @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) )
               => ~ ? [As12: set @ nat,As23: set @ nat] :
                      ( ( As2
                        = ( sup_sup @ ( set @ nat ) @ As12 @ As23 ) )
                      & ( ( inf_inf @ ( set @ nat ) @ As12 @ As23 )
                        = ( bot_bot @ ( set @ nat ) ) )
                      & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As12 ) )
                      & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As23 ) ) ) ) ) ) ) ).

% times_assn_raw.pelims(2)
thf(fact_280_times__assn__raw_Opelims_I3_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( times_assn_raw @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) )
               => ? [As13: set @ nat,As24: set @ nat] :
                    ( ( As2
                      = ( sup_sup @ ( set @ nat ) @ As13 @ As24 ) )
                    & ( ( inf_inf @ ( set @ nat ) @ As13 @ As24 )
                      = ( bot_bot @ ( set @ nat ) ) )
                    & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As13 ) )
                    & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As24 ) ) ) ) ) ) ) ).

% times_assn_raw.pelims(3)
thf(fact_281_effect__tapI,axiom,
    ! [A: $tType,H4: heap_ext @ product_unit,H2: heap_ext @ product_unit,R4: A,F: ( heap_ext @ product_unit ) > A] :
      ( ( H4 = H2 )
     => ( ( R4
          = ( F @ H2 ) )
       => ( heap_Time_effect @ A @ ( heap_Time_tap @ A @ F ) @ H2 @ H4 @ R4 @ ( one_one @ nat ) ) ) ) ).

% effect_tapI
thf(fact_282_effect__tapE,axiom,
    ! [A: $tType,F: ( heap_ext @ product_unit ) > A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( heap_Time_tap @ A @ F ) @ H2 @ H4 @ R4 @ N )
     => ~ ( ( H4 = H2 )
         => ( ( R4
              = ( F @ H2 ) )
           => ( N
             != ( one_one @ nat ) ) ) ) ) ).

% effect_tapE
thf(fact_283_times__assn__def,axiom,
    ( ( times_times @ assn )
    = ( ^ [P3: assn,Q3: assn] : ( abs_assn @ ( times_assn_raw @ ( rep_assn @ P3 ) @ ( rep_assn @ Q3 ) ) ) ) ) ).

% times_assn_def
thf(fact_284_effect__assertI,axiom,
    ! [A: $tType,P: A > $o,X: A,H4: heap_ext @ product_unit,H2: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( P @ X )
     => ( ( H4 = H2 )
       => ( ( R4 = X )
         => ( ( N
              = ( one_one @ nat ) )
           => ( heap_Time_effect @ A @ ( heap_Time_assert @ A @ P @ X ) @ H2 @ H4 @ R4 @ N ) ) ) ) ) ).

% effect_assertI
thf(fact_285_Rep__assn__inverse,axiom,
    ! [X: assn] :
      ( ( abs_assn @ ( rep_assn @ X ) )
      = X ) ).

% Rep_assn_inverse
thf(fact_286_Abs__assn__eqI_I1_J,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Pr: assn] :
      ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( P @ H )
          = ( rep_assn @ Pr @ H ) )
     => ( ( abs_assn @ P )
        = Pr ) ) ).

% Abs_assn_eqI(1)
thf(fact_287_Abs__assn__eqI_I2_J,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Pr: assn] :
      ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( P @ H )
          = ( rep_assn @ Pr @ H ) )
     => ( Pr
        = ( abs_assn @ P ) ) ) ).

% Abs_assn_eqI(2)
thf(fact_288_pure__assn__def,axiom,
    ( pure_assn
    = ( ^ [B4: $o] : ( abs_assn @ ( pure_assn_raw @ ( heap_ext @ product_unit ) @ nat @ B4 ) ) ) ) ).

% pure_assn_def
thf(fact_289_assert__cong,axiom,
    ! [B: $tType,A: $tType,P: A > $o,P2: A > $o,F: A > ( heap_Time_Heap @ B ),F11: A > ( heap_Time_Heap @ B ),X: A] :
      ( ( P = P2 )
     => ( ! [X2: A] :
            ( ( P2 @ X2 )
           => ( ( F @ X2 )
              = ( F11 @ X2 ) ) )
       => ( ( heap_Time_bind @ A @ B @ ( heap_Time_assert @ A @ P @ X ) @ F )
          = ( heap_Time_bind @ A @ B @ ( heap_Time_assert @ A @ P2 @ X ) @ F11 ) ) ) ) ).

% assert_cong
thf(fact_290_success__assertI,axiom,
    ! [A: $tType,P: A > $o,X: A,H2: heap_ext @ product_unit] :
      ( ( P @ X )
     => ( heap_Time_success @ A @ ( heap_Time_assert @ A @ P @ X ) @ H2 ) ) ).

% success_assertI
thf(fact_291_success__tapI,axiom,
    ! [A: $tType,F: ( heap_ext @ product_unit ) > A,H2: heap_ext @ product_unit] : ( heap_Time_success @ A @ ( heap_Time_tap @ A @ F ) @ H2 ) ).

% success_tapI
thf(fact_292_bex2I,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,S2: set @ ( product_prod @ A @ B ),P: A > B > $o] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ S2 )
     => ( ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ S2 )
         => ( P @ A3 @ B2 ) )
       => ? [A8: A,B6: B] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A8 @ B6 ) @ S2 )
            & ( P @ A8 @ B6 ) ) ) ) ).

% bex2I
thf(fact_293_set__notEmptyE,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ A ) ) )
     => ~ ! [X2: A] :
            ~ ( member @ A @ X2 @ S2 ) ) ).

% set_notEmptyE
thf(fact_294_memb__imp__not__empty,axiom,
    ! [A: $tType,X: A,S2: set @ A] :
      ( ( member @ A @ X @ S2 )
     => ( S2
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% memb_imp_not_empty
thf(fact_295_fun__comp__eq__conv,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: C > B,G: A > C,Fg: A > B] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = Fg )
      = ( ! [X3: A] :
            ( ( F @ ( G @ X3 ) )
            = ( Fg @ X3 ) ) ) ) ).

% fun_comp_eq_conv
thf(fact_296_comp__cong__right,axiom,
    ! [C: $tType,B: $tType,A: $tType,X: A > B,Y: A > B,F: B > C] :
      ( ( X = Y )
     => ( ( comp @ B @ C @ A @ F @ X )
        = ( comp @ B @ C @ A @ F @ Y ) ) ) ).

% comp_cong_right
thf(fact_297_comp__cong__left,axiom,
    ! [B: $tType,A: $tType,C: $tType,X: A > B,Y: A > B,F: C > A] :
      ( ( X = Y )
     => ( ( comp @ A @ B @ C @ X @ F )
        = ( comp @ A @ B @ C @ Y @ F ) ) ) ).

% comp_cong_left
thf(fact_298_one__assn__def,axiom,
    ( ( one_one @ assn )
    = ( abs_assn @ one_assn_raw ) ) ).

% one_assn_def
thf(fact_299_effect__assertE,axiom,
    ! [A: $tType,P: A > $o,X: A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( heap_Time_assert @ A @ P @ X ) @ H2 @ H4 @ R4 @ N )
     => ~ ( ( P @ X )
         => ( ( R4 = X )
           => ( ( H4 = H2 )
             => ( N
               != ( one_one @ nat ) ) ) ) ) ) ).

% effect_assertE
thf(fact_300_wand__assn__def,axiom,
    ( wand_assn
    = ( ^ [P3: assn,Q3: assn] : ( abs_assn @ ( wand_raw @ ( rep_assn @ P3 ) @ ( rep_assn @ Q3 ) ) ) ) ) ).

% wand_assn_def
thf(fact_301_uncurry__apply,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: B > C > A,A3: B,B2: C] :
      ( ( uncurry @ B @ C @ A @ F @ ( product_Pair @ B @ C @ A3 @ B2 ) )
      = ( F @ A3 @ B2 ) ) ).

% uncurry_apply
thf(fact_302_sngr__assn__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( sngr_assn @ A )
        = ( ^ [R5: ref @ A,X3: A] : ( abs_assn @ ( sngr_assn_raw @ A @ R5 @ X3 ) ) ) ) ) ).

% sngr_assn_def
thf(fact_303_snga__assn__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( snga_assn @ A )
        = ( ^ [R5: array @ A,A5: list @ A] : ( abs_assn @ ( snga_assn_raw @ A @ R5 @ A5 ) ) ) ) ) ).

% snga_assn_def
thf(fact_304_pairself_Opelims,axiom,
    ! [B: $tType,A: $tType,X: A > B,Xa: product_prod @ A @ A,Y: product_prod @ B @ B] :
      ( ( ( pairself @ A @ B @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ A @ A ) ) @ ( pairself_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ A @ A ) @ X @ Xa ) )
       => ~ ! [A8: A,B6: A] :
              ( ( Xa
                = ( product_Pair @ A @ A @ A8 @ B6 ) )
             => ( ( Y
                  = ( product_Pair @ B @ B @ ( X @ A8 ) @ ( X @ B6 ) ) )
               => ~ ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ A @ A ) ) @ ( pairself_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ A @ A ) @ X @ ( product_Pair @ A @ A @ A8 @ B6 ) ) ) ) ) ) ) ).

% pairself.pelims
thf(fact_305_wand__assnI,axiom,
    ! [H2: heap_ext @ product_unit,As: set @ nat,Q: assn,R: assn] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
     => ( ! [H5: heap_ext @ product_unit,As4: set @ nat] :
            ( ( ( inf_inf @ ( set @ nat ) @ As @ As4 )
              = ( bot_bot @ ( set @ nat ) ) )
           => ( ( relH @ As @ H2 @ H5 )
             => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As ) )
               => ( ( rep_assn @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As4 ) )
                 => ( rep_assn @ R @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ ( sup_sup @ ( set @ nat ) @ As @ As4 ) ) ) ) ) ) )
       => ( rep_assn @ ( wand_assn @ Q @ R ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) ) ) ) ).

% wand_assnI
thf(fact_306_mod__pure,axiom,
    ! [B2: $o,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( pure_assn @ B2 ) @ H2 )
      = ( ( ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 )
          = ( bot_bot @ ( set @ nat ) ) )
        & B2 ) ) ).

% mod_pure
thf(fact_307_pure__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X: $o,Xa: product_prod @ A @ ( set @ B ),Y: $o] :
      ( ( ( pure_assn_raw @ A @ B @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ Xa ) )
       => ~ ! [H: A,As2: set @ B] :
              ( ( Xa
                = ( product_Pair @ A @ ( set @ B ) @ H @ As2 ) )
             => ( ( Y
                  = ( ( As2
                      = ( bot_bot @ ( set @ B ) ) )
                    & X ) )
               => ~ ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ ( product_Pair @ A @ ( set @ B ) @ H @ As2 ) ) ) ) ) ) ) ).

% pure_assn_raw.pelims(1)
thf(fact_308_pure__assn__raw_Opelims_I2_J,axiom,
    ! [B: $tType,A: $tType,X: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ( pure_assn_raw @ A @ B @ X @ Xa )
     => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ Xa ) )
       => ~ ! [H: A,As2: set @ B] :
              ( ( Xa
                = ( product_Pair @ A @ ( set @ B ) @ H @ As2 ) )
             => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ ( product_Pair @ A @ ( set @ B ) @ H @ As2 ) ) )
               => ~ ( ( As2
                      = ( bot_bot @ ( set @ B ) ) )
                    & X ) ) ) ) ) ).

% pure_assn_raw.pelims(2)
thf(fact_309_pure__assn__raw_Opelims_I3_J,axiom,
    ! [B: $tType,A: $tType,X: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ~ ( pure_assn_raw @ A @ B @ X @ Xa )
     => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ Xa ) )
       => ~ ! [H: A,As2: set @ B] :
              ( ( Xa
                = ( product_Pair @ A @ ( set @ B ) @ H @ As2 ) )
             => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ ( product_Pair @ A @ ( set @ B ) @ H @ As2 ) ) )
               => ( ( As2
                    = ( bot_bot @ ( set @ B ) ) )
                  & X ) ) ) ) ) ).

% pure_assn_raw.pelims(3)
thf(fact_310_monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( monoid @ A @ F @ Z2 )
     => ( monoid_axioms @ A @ F @ Z2 ) ) ).

% monoid.axioms(2)
thf(fact_311_relH__dist__union,axiom,
    ! [As: set @ nat,As3: set @ nat,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit] :
      ( ( relH @ ( sup_sup @ ( set @ nat ) @ As @ As3 ) @ H2 @ H4 )
      = ( ( relH @ As @ H2 @ H4 )
        & ( relH @ As3 @ H2 @ H4 ) ) ) ).

% relH_dist_union
thf(fact_312_in__range__empty,axiom,
    ! [H2: heap_ext @ product_unit] : ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% in_range_empty
thf(fact_313_in__range__dist__union,axiom,
    ! [H2: heap_ext @ product_unit,As: set @ nat,As3: set @ nat] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( sup_sup @ ( set @ nat ) @ As @ As3 ) ) )
      = ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
        & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As3 ) ) ) ) ).

% in_range_dist_union
thf(fact_314_relH__trans,axiom,
    ! [As: set @ nat,H12: heap_ext @ product_unit,H23: heap_ext @ product_unit,H32: heap_ext @ product_unit] :
      ( ( relH @ As @ H12 @ H23 )
     => ( ( relH @ As @ H23 @ H32 )
       => ( relH @ As @ H12 @ H32 ) ) ) ).

% relH_trans
thf(fact_315_relH__sym,axiom,
    ! [As: set @ nat,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit] :
      ( ( relH @ As @ H2 @ H4 )
     => ( relH @ As @ H4 @ H2 ) ) ).

% relH_sym
thf(fact_316_relH__refl,axiom,
    ! [H2: heap_ext @ product_unit,As: set @ nat] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
     => ( relH @ As @ H2 @ H2 ) ) ).

% relH_refl
thf(fact_317_relH__in__rangeI_I1_J,axiom,
    ! [As: set @ nat,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit] :
      ( ( relH @ As @ H2 @ H4 )
     => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) ) ) ).

% relH_in_rangeI(1)
thf(fact_318_relH__in__rangeI_I2_J,axiom,
    ! [As: set @ nat,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit] :
      ( ( relH @ As @ H2 @ H4 )
     => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ).

% relH_in_rangeI(2)
thf(fact_319_monoid__axioms_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ! [A8: A] :
          ( ( F @ Z2 @ A8 )
          = A8 )
     => ( ! [A8: A] :
            ( ( F @ A8 @ Z2 )
            = A8 )
       => ( monoid_axioms @ A @ F @ Z2 ) ) ) ).

% monoid_axioms.intro
thf(fact_320_monoid__axioms__def,axiom,
    ! [A: $tType] :
      ( ( monoid_axioms @ A )
      = ( ^ [F2: A > A > A,Z4: A] :
            ( ! [A5: A] :
                ( ( F2 @ Z4 @ A5 )
                = A5 )
            & ! [A5: A] :
                ( ( F2 @ A5 @ Z4 )
                = A5 ) ) ) ) ).

% monoid_axioms_def
thf(fact_321_snd__eqD,axiom,
    ! [B: $tType,A: $tType,X: B,Y: A,A3: A] :
      ( ( ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) )
        = A3 )
     => ( Y = A3 ) ) ).

% snd_eqD
thf(fact_322_snd__conv,axiom,
    ! [Aa: $tType,A: $tType,X1: Aa,X22: A] :
      ( ( product_snd @ Aa @ A @ ( product_Pair @ Aa @ A @ X1 @ X22 ) )
      = X22 ) ).

% snd_conv
thf(fact_323_sndE,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ A @ B,A3: A,B2: B,P: B > $o] :
      ( ( X
        = ( product_Pair @ A @ B @ A3 @ B2 ) )
     => ( ( P @ ( product_snd @ A @ B @ X ) )
       => ( P @ B2 ) ) ) ).

% sndE
thf(fact_324_models__in__range,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ P @ H2 )
     => ( in_range @ H2 ) ) ).

% models_in_range
thf(fact_325_wand__raw_Oelims_I3_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( wand_raw @ X @ Xa @ Xb )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
              & ! [H5: heap_ext @ product_unit,As4: set @ nat] :
                  ( ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As4 )
                      = ( bot_bot @ ( set @ nat ) ) )
                    & ( relH @ As2 @ H @ H5 )
                    & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) )
                    & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As4 ) ) )
                 => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ ( sup_sup @ ( set @ nat ) @ As2 @ As4 ) ) ) ) ) ) ) ).

% wand_raw.elims(3)
thf(fact_326_wand__raw_Oelims_I2_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( wand_raw @ X @ Xa @ Xb )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ~ ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                & ! [H7: heap_ext @ product_unit,As5: set @ nat] :
                    ( ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As5 )
                        = ( bot_bot @ ( set @ nat ) ) )
                      & ( relH @ As2 @ H @ H7 )
                      & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As2 ) )
                      & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As5 ) ) )
                   => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( sup_sup @ ( set @ nat ) @ As2 @ As5 ) ) ) ) ) ) ) ).

% wand_raw.elims(2)
thf(fact_327_wand__raw_Oelims_I1_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( wand_raw @ X @ Xa @ Xb )
        = Y )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ( Y
              = ( ~ ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                    & ! [H8: heap_ext @ product_unit,As6: set @ nat] :
                        ( ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As6 )
                            = ( bot_bot @ ( set @ nat ) ) )
                          & ( relH @ As2 @ H @ H8 )
                          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ As2 ) )
                          & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ As6 ) ) )
                       => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ ( sup_sup @ ( set @ nat ) @ As2 @ As6 ) ) ) ) ) ) ) ) ) ).

% wand_raw.elims(1)
thf(fact_328_wand__raw_Osimps,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As: set @ nat] :
      ( ( wand_raw @ P @ Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
      = ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
        & ! [H8: heap_ext @ product_unit,As6: set @ nat] :
            ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As6 )
                = ( bot_bot @ ( set @ nat ) ) )
              & ( relH @ As @ H2 @ H8 )
              & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ As ) )
              & ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ As6 ) ) )
           => ( Q @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ ( sup_sup @ ( set @ nat ) @ As @ As6 ) ) ) ) ) ) ).

% wand_raw.simps
thf(fact_329_pairself_Oelims,axiom,
    ! [B: $tType,A: $tType,X: A > B,Xa: product_prod @ A @ A,Y: product_prod @ B @ B] :
      ( ( ( pairself @ A @ B @ X @ Xa )
        = Y )
     => ~ ! [A8: A,B6: A] :
            ( ( Xa
              = ( product_Pair @ A @ A @ A8 @ B6 ) )
           => ( Y
             != ( product_Pair @ B @ B @ ( X @ A8 ) @ ( X @ B6 ) ) ) ) ) ).

% pairself.elims
thf(fact_330_pairself_Osimps,axiom,
    ! [B: $tType,A: $tType,F: A > B,A3: A,B2: A] :
      ( ( pairself @ A @ B @ F @ ( product_Pair @ A @ A @ A3 @ B2 ) )
      = ( product_Pair @ B @ B @ ( F @ A3 ) @ ( F @ B2 ) ) ) ).

% pairself.simps
thf(fact_331_mod__relH,axiom,
    ! [As: set @ nat,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,P: assn] :
      ( ( relH @ As @ H2 @ H4 )
     => ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
        = ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ).

% mod_relH
thf(fact_332_mod__emp,axiom,
    ! [H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( one_one @ assn ) @ H2 )
      = ( ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 )
        = ( bot_bot @ ( set @ nat ) ) ) ) ).

% mod_emp
thf(fact_333_wand__raw_Opelims_I1_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( wand_raw @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( Y
                  = ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                    & ! [H8: heap_ext @ product_unit,As6: set @ nat] :
                        ( ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As6 )
                            = ( bot_bot @ ( set @ nat ) ) )
                          & ( relH @ As2 @ H @ H8 )
                          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ As2 ) )
                          & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ As6 ) ) )
                       => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ ( sup_sup @ ( set @ nat ) @ As2 @ As6 ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) ) ) ) ) ) ).

% wand_raw.pelims(1)
thf(fact_334_wand__raw_Opelims_I2_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( wand_raw @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) )
               => ~ ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                    & ! [H7: heap_ext @ product_unit,As5: set @ nat] :
                        ( ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As5 )
                            = ( bot_bot @ ( set @ nat ) ) )
                          & ( relH @ As2 @ H @ H7 )
                          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As2 ) )
                          & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As5 ) ) )
                       => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( sup_sup @ ( set @ nat ) @ As2 @ As5 ) ) ) ) ) ) ) ) ) ).

% wand_raw.pelims(2)
thf(fact_335_wand__raw_Opelims_I3_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( wand_raw @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) )
               => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                  & ! [H5: heap_ext @ product_unit,As4: set @ nat] :
                      ( ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As4 )
                          = ( bot_bot @ ( set @ nat ) ) )
                        & ( relH @ As2 @ H @ H5 )
                        & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) )
                        & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As4 ) ) )
                     => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ ( sup_sup @ ( set @ nat ) @ As2 @ As4 ) ) ) ) ) ) ) ) ) ).

% wand_raw.pelims(3)
thf(fact_336_sndI,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ A @ B,Y: A,Z2: B] :
      ( ( X
        = ( product_Pair @ A @ B @ Y @ Z2 ) )
     => ( ( product_snd @ A @ B @ X )
        = Z2 ) ) ).

% sndI
thf(fact_337_eq__snd__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,P4: product_prod @ B @ A] :
      ( ( B2
        = ( product_snd @ B @ A @ P4 ) )
      = ( ? [A5: B] :
            ( P4
            = ( product_Pair @ B @ A @ A5 @ B2 ) ) ) ) ).

% eq_snd_iff
thf(fact_338_proper__iff,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,As: set @ nat,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit] :
      ( ( proper @ P )
     => ( ( relH @ As @ H2 @ H4 )
       => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
         => ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
            = ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ) ) ).

% proper_iff
thf(fact_339_proper__def,axiom,
    ( proper
    = ( ^ [P3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
        ! [H3: heap_ext @ product_unit,H8: heap_ext @ product_unit,As7: set @ nat] :
          ( ( ( P3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As7 ) )
           => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As7 ) ) )
          & ( ( ( P3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As7 ) )
              & ( relH @ As7 @ H3 @ H8 )
              & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ As7 ) ) )
           => ( P3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ As7 ) ) ) ) ) ) ).

% proper_def
thf(fact_340_properD2,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As: set @ nat,H4: heap_ext @ product_unit] :
      ( ( proper @ P )
     => ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
       => ( ( relH @ As @ H2 @ H4 )
         => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
           => ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) ) ) ).

% properD2
thf(fact_341_properI,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ! [As2: set @ nat,H: heap_ext @ product_unit] :
          ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
         => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) )
     => ( ! [As2: set @ nat,H: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
            ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ( ( relH @ As2 @ H @ H5 )
             => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) )
               => ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) ) ) ) )
       => ( proper @ P ) ) ) ).

% properI
thf(fact_342_monoid__def,axiom,
    ! [A: $tType] :
      ( ( monoid @ A )
      = ( ^ [F2: A > A > A,Z4: A] :
            ( ( semigroup @ A @ F2 )
            & ( monoid_axioms @ A @ F2 @ Z4 ) ) ) ) ).

% monoid_def
thf(fact_343_monoid_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( semigroup @ A @ F )
     => ( ( monoid_axioms @ A @ F @ Z2 )
       => ( monoid @ A @ F @ Z2 ) ) ) ).

% monoid.intro
thf(fact_344_bool__assn__proper_I1_J,axiom,
    proper @ in_range ).

% bool_assn_proper(1)
thf(fact_345_one__assn__proper,axiom,
    proper @ one_assn_raw ).

% one_assn_proper
thf(fact_346_times__assn__proper,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P )
     => ( ( proper @ Q )
       => ( proper @ ( times_assn_raw @ P @ Q ) ) ) ) ).

% times_assn_proper
thf(fact_347_wand__proper,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] : ( proper @ ( wand_raw @ P @ Q ) ) ).

% wand_proper
thf(fact_348_snga__assn__proper,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: array @ A,X: list @ A] : ( proper @ ( snga_assn_raw @ A @ R4 @ X ) ) ) ).

% snga_assn_proper
thf(fact_349_sngr__assn__proper,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,X: A] : ( proper @ ( sngr_assn_raw @ A @ R4 @ X ) ) ) ).

% sngr_assn_proper
thf(fact_350_pure__assn__proper,axiom,
    ! [B2: $o] : ( proper @ ( pure_assn_raw @ ( heap_ext @ product_unit ) @ nat @ B2 ) ) ).

% pure_assn_proper
thf(fact_351_semigroup_Oassoc,axiom,
    ! [A: $tType,F: A > A > A,A3: A,B2: A,C2: A] :
      ( ( semigroup @ A @ F )
     => ( ( F @ ( F @ A3 @ B2 ) @ C2 )
        = ( F @ A3 @ ( F @ B2 @ C2 ) ) ) ) ).

% semigroup.assoc
thf(fact_352_semigroup_Ointro,axiom,
    ! [A: $tType,F: A > A > A] :
      ( ! [A8: A,B6: A,C4: A] :
          ( ( F @ ( F @ A8 @ B6 ) @ C4 )
          = ( F @ A8 @ ( F @ B6 @ C4 ) ) )
     => ( semigroup @ A @ F ) ) ).

% semigroup.intro
thf(fact_353_semigroup__def,axiom,
    ! [A: $tType] :
      ( ( semigroup @ A )
      = ( ^ [F2: A > A > A] :
          ! [A5: A,B4: A,C5: A] :
            ( ( F2 @ ( F2 @ A5 @ B4 ) @ C5 )
            = ( F2 @ A5 @ ( F2 @ B4 @ C5 ) ) ) ) ) ).

% semigroup_def
thf(fact_354_Rep__assn__induct,axiom,
    ! [Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,P: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > $o] :
      ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ( ! [X2: assn] : ( P @ ( rep_assn @ X2 ) )
       => ( P @ Y ) ) ) ).

% Rep_assn_induct
thf(fact_355_Rep__assn__cases,axiom,
    ! [Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ~ ! [X2: assn] :
            ( Y
           != ( rep_assn @ X2 ) ) ) ).

% Rep_assn_cases
thf(fact_356_Rep__assn,axiom,
    ! [X: assn] : ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( rep_assn @ X ) @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) ) ).

% Rep_assn
thf(fact_357_mult_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ( semigroup @ A @ ( times_times @ A ) ) ) ).

% mult.semigroup_axioms
thf(fact_358_inf_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semigroup @ A @ ( inf_inf @ A ) ) ) ).

% inf.semigroup_axioms
thf(fact_359_sup_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semigroup @ A @ ( sup_sup @ A ) ) ) ).

% sup.semigroup_axioms
thf(fact_360_Abs__assn__cases,axiom,
    ! [X: assn] :
      ~ ! [Y3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
          ( ( X
            = ( abs_assn @ Y3 ) )
         => ~ ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y3 @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) ) ) ).

% Abs_assn_cases
thf(fact_361_Abs__assn__induct,axiom,
    ! [P: assn > $o,X: assn] :
      ( ! [Y3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
          ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y3 @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
         => ( P @ ( abs_assn @ Y3 ) ) )
     => ( P @ X ) ) ).

% Abs_assn_induct
thf(fact_362_Abs__assn__inject,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ X @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
       => ( ( ( abs_assn @ X )
            = ( abs_assn @ Y ) )
          = ( X = Y ) ) ) ) ).

% Abs_assn_inject
thf(fact_363_monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( monoid @ A @ F @ Z2 )
     => ( semigroup @ A @ F ) ) ).

% monoid.axioms(1)
thf(fact_364_properD1,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As: set @ nat] :
      ( ( proper @ P )
     => ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
       => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) ) ) ) ).

% properD1
thf(fact_365_Abs__assn__inverse,axiom,
    ! [Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( member @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ( ( rep_assn @ ( abs_assn @ Y ) )
        = Y ) ) ).

% Abs_assn_inverse
thf(fact_366_comp__apply__eq,axiom,
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: B > A,G: C > B,X: C,H2: D > A,K: C > D] :
      ( ( ( F @ ( G @ X ) )
        = ( H2 @ ( K @ X ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ C @ H2 @ K @ X ) ) ) ).

% comp_apply_eq
thf(fact_367_type__definition__assn,axiom,
    type_definition @ assn @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ rep_assn @ abs_assn @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) ).

% type_definition_assn
thf(fact_368_rewriteR__comp__comp2,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G: C > B,H2: A > C,R1: D > B,R22: A > D,F: B > E,L: D > E] :
      ( ( ( comp @ C @ B @ A @ G @ H2 )
        = ( comp @ D @ B @ A @ R1 @ R22 ) )
     => ( ( ( comp @ B @ E @ D @ F @ R1 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F @ G ) @ H2 )
          = ( comp @ D @ E @ A @ L @ R22 ) ) ) ) ).

% rewriteR_comp_comp2
thf(fact_369_rewriteL__comp__comp2,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: C > B,G: A > C,L1: D > B,L2: A > D,H2: E > A,R4: E > D] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H2 )
          = R4 )
       => ( ( comp @ C @ B @ E @ F @ ( comp @ A @ C @ E @ G @ H2 ) )
          = ( comp @ D @ B @ E @ L1 @ R4 ) ) ) ) ).

% rewriteL_comp_comp2
thf(fact_370_rewriteR__comp__comp,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: C > B,H2: A > C,R4: A > B,F: B > D] :
      ( ( ( comp @ C @ B @ A @ G @ H2 )
        = R4 )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H2 )
        = ( comp @ B @ D @ A @ F @ R4 ) ) ) ).

% rewriteR_comp_comp
thf(fact_371_rewriteL__comp__comp,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: C > B,G: A > C,L: A > B,H2: D > A] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H2 ) )
        = ( comp @ A @ B @ D @ L @ H2 ) ) ) ).

% rewriteL_comp_comp
thf(fact_372_type__copy__map__cong0,axiom,
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: B > A,G: C > B,X: C,N4: D > A,H2: C > D,F: A > E] :
      ( ( ( M @ ( G @ X ) )
        = ( N4 @ ( H2 @ X ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F @ M ) @ G @ X )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F @ N4 ) @ H2 @ X ) ) ) ).

% type_copy_map_cong0
thf(fact_373_comp__cong,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F: B > A,G: C > B,X: C,F11: D > A,G5: E > D,X4: E] :
      ( ( ( F @ ( G @ X ) )
        = ( F11 @ ( G5 @ X4 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ E @ F11 @ G5 @ X4 ) ) ) ).

% comp_cong
thf(fact_374_fun_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G: B > C,F: A > B,V: D > A] :
      ( ( comp @ B @ C @ D @ G @ ( comp @ A @ B @ D @ F @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) ).

% fun.map_comp
thf(fact_375_mod__h__bot__iff_I2_J,axiom,
    ! [H2: heap_ext @ product_unit] : ( rep_assn @ ( top_top @ assn ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% mod_h_bot_iff(2)
thf(fact_376_override__on__emptyset,axiom,
    ! [B: $tType,A: $tType,F: A > B,G: A > B] :
      ( ( override_on @ A @ B @ F @ G @ ( bot_bot @ ( set @ A ) ) )
      = F ) ).

% override_on_emptyset
thf(fact_377_mult_Osafe__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [X: A,Y: A,A3: A,B2: A] :
          ( ( syntax7388354845996824322omatch @ A @ A @ ( times_times @ A @ X @ Y ) @ A3 )
         => ( ( times_times @ A @ A3 @ B2 )
            = ( times_times @ A @ B2 @ A3 ) ) ) ) ).

% mult.safe_commute
thf(fact_378_top__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( top @ C )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X3: D] : ( top_top @ C ) ) ) ) ).

% top_apply
thf(fact_379_inf__top_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A3: A] :
          ( ( inf_inf @ A @ A3 @ ( top_top @ A ) )
          = A3 ) ) ).

% inf_top.right_neutral
thf(fact_380_inf__top_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A3: A,B2: A] :
          ( ( ( top_top @ A )
            = ( inf_inf @ A @ A3 @ B2 ) )
          = ( ( A3
              = ( top_top @ A ) )
            & ( B2
              = ( top_top @ A ) ) ) ) ) ).

% inf_top.neutr_eq_iff
thf(fact_381_inf__top_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A3: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ A3 )
          = A3 ) ) ).

% inf_top.left_neutral
thf(fact_382_inf__top_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A3: A,B2: A] :
          ( ( ( inf_inf @ A @ A3 @ B2 )
            = ( top_top @ A ) )
          = ( ( A3
              = ( top_top @ A ) )
            & ( B2
              = ( top_top @ A ) ) ) ) ) ).

% inf_top.eq_neutr_iff
thf(fact_383_top__eq__inf__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A,Y: A] :
          ( ( ( top_top @ A )
            = ( inf_inf @ A @ X @ Y ) )
          = ( ( X
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% top_eq_inf_iff
thf(fact_384_inf__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ( X
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% inf_eq_top_iff
thf(fact_385_inf__top__right,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% inf_top_right
thf(fact_386_inf__top__left,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ X )
          = X ) ) ).

% inf_top_left
thf(fact_387_sup__top__left,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) ).

% sup_top_left
thf(fact_388_sup__top__right,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% sup_top_right
thf(fact_389_boolean__algebra_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) ).

% boolean_algebra.disj_one_left
thf(fact_390_boolean__algebra_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% boolean_algebra.disj_one_right
thf(fact_391_merge__true__star,axiom,
    ( ( times_times @ assn @ ( top_top @ assn ) @ ( top_top @ assn ) )
    = ( top_top @ assn ) ) ).

% merge_true_star
thf(fact_392_assn__basic__inequalities_I1_J,axiom,
    ( top_top @ assn )
 != ( one_one @ assn ) ).

% assn_basic_inequalities(1)
thf(fact_393_assn__basic__inequalities_I5_J,axiom,
    ( top_top @ assn )
 != ( bot_bot @ assn ) ).

% assn_basic_inequalities(5)
thf(fact_394_mod__true,axiom,
    ! [H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( top_top @ assn ) @ H2 )
      = ( in_range @ H2 ) ) ).

% mod_true
thf(fact_395_syntax__fo__nomatch__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( syntax7388354845996824322omatch @ A @ B )
      = ( ^ [Pat: A,Obj: B] : $true ) ) ).

% syntax_fo_nomatch_def
thf(fact_396_boolean__algebra_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% boolean_algebra.conj_one_right
thf(fact_397_ent__true,axiom,
    ! [P: assn] : ( entails @ P @ ( top_top @ assn ) ) ).

% ent_true
thf(fact_398_mod__star__trueE,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ P @ ( top_top @ assn ) ) @ H2 )
     => ~ ! [H5: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ~ ( rep_assn @ P @ H5 ) ) ).

% mod_star_trueE
thf(fact_399_mod__star__trueI,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ P @ H2 )
     => ( rep_assn @ ( times_times @ assn @ P @ ( top_top @ assn ) ) @ H2 ) ) ).

% mod_star_trueI
thf(fact_400_inf__top_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( monoid @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.monoid_axioms
thf(fact_401_inf__top_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semilattice_neutr @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.semilattice_neutr_axioms
thf(fact_402_top__assn__def,axiom,
    ( ( top_top @ assn )
    = ( abs_assn @ in_range ) ) ).

% top_assn_def
thf(fact_403_boolean__algebra_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [A3: A,X: A,Y: A] :
          ( ( ( inf_inf @ A @ A3 @ X )
            = ( bot_bot @ A ) )
         => ( ( ( sup_sup @ A @ A3 @ X )
              = ( top_top @ A ) )
           => ( ( ( inf_inf @ A @ A3 @ Y )
                = ( bot_bot @ A ) )
             => ( ( ( sup_sup @ A @ A3 @ Y )
                  = ( top_top @ A ) )
               => ( X = Y ) ) ) ) ) ) ).

% boolean_algebra.complement_unique
thf(fact_404_enttD,axiom,
    ! [A4: assn,B3: assn] :
      ( ( entailst @ A4 @ B3 )
     => ( entails @ A4 @ ( times_times @ assn @ B3 @ ( top_top @ assn ) ) ) ) ).

% enttD
thf(fact_405_enttI,axiom,
    ! [A4: assn,B3: assn] :
      ( ( entails @ A4 @ ( times_times @ assn @ B3 @ ( top_top @ assn ) ) )
     => ( entailst @ A4 @ B3 ) ) ).

% enttI
thf(fact_406_enttI__true,axiom,
    ! [P: assn,Q: assn] :
      ( ( entails @ ( times_times @ assn @ P @ ( top_top @ assn ) ) @ ( times_times @ assn @ Q @ ( top_top @ assn ) ) )
     => ( entailst @ P @ Q ) ) ).

% enttI_true
thf(fact_407_entailst__def,axiom,
    ( entailst
    = ( ^ [A10: assn,B7: assn] : ( entails @ A10 @ ( times_times @ assn @ B7 @ ( top_top @ assn ) ) ) ) ) ).

% entailst_def
thf(fact_408_entt__def__true,axiom,
    ( entailst
    = ( ^ [P3: assn,Q3: assn] : ( entails @ ( times_times @ assn @ P3 @ ( top_top @ assn ) ) @ ( times_times @ assn @ Q3 @ ( top_top @ assn ) ) ) ) ) ).

% entt_def_true
thf(fact_409_boolean__algebra__class_Oboolean__algebra_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( bot_bot @ A ) )
         => ( ( ( sup_sup @ A @ X @ Y )
              = ( top_top @ A ) )
           => ( ( uminus_uminus @ A @ X )
              = Y ) ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_unique
thf(fact_410_entt__star__true__simp_I1_J,axiom,
    ! [A4: assn,B3: assn] :
      ( ( entailst @ A4 @ ( times_times @ assn @ B3 @ ( top_top @ assn ) ) )
      = ( entailst @ A4 @ B3 ) ) ).

% entt_star_true_simp(1)
thf(fact_411_entt__star__true__simp_I2_J,axiom,
    ! [A4: assn,B3: assn] :
      ( ( entailst @ ( times_times @ assn @ A4 @ ( top_top @ assn ) ) @ B3 )
      = ( entailst @ A4 @ B3 ) ) ).

% entt_star_true_simp(2)
thf(fact_412_snd__sndOp,axiom,
    ! [B: $tType,A: $tType,C: $tType,P: B > C > $o,Q: C > A > $o] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ C @ A ) @ A @ ( product_prod @ B @ A ) @ ( product_snd @ C @ A ) @ ( bNF_sndOp @ B @ C @ A @ P @ Q ) ) ) ).

% snd_sndOp
thf(fact_413_bijective__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bijective @ A @ B )
      = ( ^ [R2: set @ ( product_prod @ A @ B )] :
            ( ! [X3: A,Y2: B,Z4: B] :
                ( ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R2 )
                  & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Z4 ) @ R2 ) )
               => ( Y2 = Z4 ) )
            & ! [X3: A,Y2: A,Z4: B] :
                ( ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Z4 ) @ R2 )
                  & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y2 @ Z4 ) @ R2 ) )
               => ( X3 = Y2 ) ) ) ) ) ).

% bijective_def
thf(fact_414_ssubst__Pair__rhs,axiom,
    ! [B: $tType,A: $tType,R4: A,S: B,R: set @ ( product_prod @ A @ B ),S3: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R4 @ S ) @ R )
     => ( ( S3 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R4 @ S3 ) @ R ) ) ) ).

% ssubst_Pair_rhs
thf(fact_415_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A3 ) )
          = A3 ) ) ).

% add.inverse_inverse
thf(fact_416_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A3 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_417_uminus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A10: A > B,X3: A] : ( uminus_uminus @ B @ ( A10 @ X3 ) ) ) ) ) ).

% uminus_apply
thf(fact_418_boolean__algebra__class_Oboolean__algebra_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ X ) )
          = X ) ) ).

% boolean_algebra_class.boolean_algebra.double_compl
thf(fact_419_boolean__algebra__class_Oboolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( uminus_uminus @ A @ X )
            = ( uminus_uminus @ A @ Y ) )
          = ( X = Y ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_eq_compl_iff
thf(fact_420_Int__UNIV,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( top_top @ ( set @ A ) ) )
      = ( ( A4
          = ( top_top @ ( set @ A ) ) )
        & ( B3
          = ( top_top @ ( set @ A ) ) ) ) ) ).

% Int_UNIV
thf(fact_421_entt__refl,axiom,
    ! [A4: assn] : ( entailst @ A4 @ A4 ) ).

% entt_refl
thf(fact_422_bijective__Empty,axiom,
    ! [B: $tType,A: $tType] : ( bijective @ A @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% bijective_Empty
thf(fact_423_Compl__disjoint2,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) @ A4 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Compl_disjoint2
thf(fact_424_Compl__disjoint,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Compl_disjoint
thf(fact_425_mod__not__dist,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( uminus_uminus @ assn @ P ) @ H2 )
      = ( ( in_range @ H2 )
        & ~ ( rep_assn @ P @ H2 ) ) ) ).

% mod_not_dist
thf(fact_426_entt__true,axiom,
    ! [A4: assn] : ( entailst @ A4 @ ( top_top @ assn ) ) ).

% entt_true
thf(fact_427_entt__emp,axiom,
    ! [A4: assn] : ( entailst @ A4 @ ( one_one @ assn ) ) ).

% entt_emp
thf(fact_428_boolean__algebra_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( uminus_uminus @ A @ ( bot_bot @ A ) )
        = ( top_top @ A ) ) ) ).

% boolean_algebra.compl_zero
thf(fact_429_boolean__algebra_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( uminus_uminus @ A @ ( top_top @ A ) )
        = ( bot_bot @ A ) ) ) ).

% boolean_algebra.compl_one
thf(fact_430_boolean__algebra_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( uminus_uminus @ A @ X ) )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_cancel_right
thf(fact_431_boolean__algebra_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ X )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_cancel_left
thf(fact_432_inf__compl__bot__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ ( uminus_uminus @ A @ X ) ) )
          = ( bot_bot @ A ) ) ) ).

% inf_compl_bot_right
thf(fact_433_inf__compl__bot__left2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ Y ) )
          = ( bot_bot @ A ) ) ) ).

% inf_compl_bot_left2
thf(fact_434_inf__compl__bot__left1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ ( inf_inf @ A @ X @ Y ) )
          = ( bot_bot @ A ) ) ) ).

% inf_compl_bot_left1
thf(fact_435_boolean__algebra_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( uminus_uminus @ A @ X ) )
          = ( top_top @ A ) ) ) ).

% boolean_algebra.disj_cancel_right
thf(fact_436_boolean__algebra_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( uminus_uminus @ A @ X ) @ X )
          = ( top_top @ A ) ) ) ).

% boolean_algebra.disj_cancel_left
thf(fact_437_sup__compl__top__left2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ ( uminus_uminus @ A @ X ) @ Y ) )
          = ( top_top @ A ) ) ) ).

% sup_compl_top_left2
thf(fact_438_sup__compl__top__left1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ ( uminus_uminus @ A @ X ) @ ( sup_sup @ A @ X @ Y ) )
          = ( top_top @ A ) ) ) ).

% sup_compl_top_left1
thf(fact_439_boolean__algebra_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( sup_sup @ A @ X @ Y ) )
          = ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% boolean_algebra.de_Morgan_disj
thf(fact_440_boolean__algebra_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( inf_inf @ A @ X @ Y ) )
          = ( sup_sup @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% boolean_algebra.de_Morgan_conj
thf(fact_441_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% equation_minus_iff
thf(fact_442_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A3 ) ) ) ).

% minus_equation_iff
thf(fact_443_fun__Compl__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A10: A > B,X3: A] : ( uminus_uminus @ B @ ( A10 @ X3 ) ) ) ) ) ).

% fun_Compl_def
thf(fact_444_entt__trans,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( ( entailst @ A4 @ B3 )
     => ( ( entailst @ B3 @ C3 )
       => ( entailst @ A4 @ C3 ) ) ) ).

% entt_trans
thf(fact_445_Compl__empty__eq,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% Compl_empty_eq
thf(fact_446_Compl__UNIV__eq,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Compl_UNIV_eq
thf(fact_447_empty__not__UNIV,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
     != ( top_top @ ( set @ A ) ) ) ).

% empty_not_UNIV
thf(fact_448_Int__UNIV__right,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( top_top @ ( set @ A ) ) )
      = A4 ) ).

% Int_UNIV_right
thf(fact_449_Int__UNIV__left,axiom,
    ! [A: $tType,B3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B3 )
      = B3 ) ).

% Int_UNIV_left
thf(fact_450_type__copy__wit,axiom,
    ! [A: $tType,C: $tType,B: $tType,Rep: A > B,Abs: B > A,X: C,S2: B > ( set @ C ),Y: B] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( member @ C @ X @ ( comp @ B @ ( set @ C ) @ A @ S2 @ Rep @ ( Abs @ Y ) ) )
       => ( member @ C @ X @ ( S2 @ Y ) ) ) ) ).

% type_copy_wit
thf(fact_451_entt__star__mono,axiom,
    ! [A4: assn,B3: assn,C3: assn,D4: assn] :
      ( ( entailst @ A4 @ B3 )
     => ( ( entailst @ C3 @ D4 )
       => ( entailst @ ( times_times @ assn @ A4 @ C3 ) @ ( times_times @ assn @ B3 @ D4 ) ) ) ) ).

% entt_star_mono
thf(fact_452_entt__frame__fwd,axiom,
    ! [P: assn,Q: assn,A4: assn,F3: assn,B3: assn] :
      ( ( entailst @ P @ Q )
     => ( ( entailst @ A4 @ ( times_times @ assn @ P @ F3 ) )
       => ( ( entailst @ ( times_times @ assn @ Q @ F3 ) @ B3 )
         => ( entailst @ A4 @ B3 ) ) ) ) ).

% entt_frame_fwd
thf(fact_453_ent__imp__entt,axiom,
    ! [P: assn,Q: assn] :
      ( ( entails @ P @ Q )
     => ( entailst @ P @ Q ) ) ).

% ent_imp_entt
thf(fact_454_entt__disjI2__direct,axiom,
    ! [B3: assn,A4: assn] : ( entailst @ B3 @ ( sup_sup @ assn @ A4 @ B3 ) ) ).

% entt_disjI2_direct
thf(fact_455_entt__disjI1__direct,axiom,
    ! [A4: assn,B3: assn] : ( entailst @ A4 @ ( sup_sup @ assn @ A4 @ B3 ) ) ).

% entt_disjI1_direct
thf(fact_456_entt__disjI2_H,axiom,
    ! [A4: assn,C3: assn,B3: assn] :
      ( ( entailst @ A4 @ C3 )
     => ( entailst @ A4 @ ( sup_sup @ assn @ B3 @ C3 ) ) ) ).

% entt_disjI2'
thf(fact_457_entt__disjI1_H,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( ( entailst @ A4 @ B3 )
     => ( entailst @ A4 @ ( sup_sup @ assn @ B3 @ C3 ) ) ) ).

% entt_disjI1'
thf(fact_458_entt__disjD2,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( ( entailst @ ( sup_sup @ assn @ A4 @ B3 ) @ C3 )
     => ( entailst @ B3 @ C3 ) ) ).

% entt_disjD2
thf(fact_459_entt__disjD1,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( ( entailst @ ( sup_sup @ assn @ A4 @ B3 ) @ C3 )
     => ( entailst @ A4 @ C3 ) ) ).

% entt_disjD1
thf(fact_460_entt__disjE,axiom,
    ! [A4: assn,M: assn,B3: assn] :
      ( ( entailst @ A4 @ M )
     => ( ( entailst @ B3 @ M )
       => ( entailst @ ( sup_sup @ assn @ A4 @ B3 ) @ M ) ) ) ).

% entt_disjE
thf(fact_461_inf__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ A3 ) @ ( inf_inf @ A @ X @ B2 ) )
          = ( bot_bot @ A ) ) ) ).

% inf_cancel_left2
thf(fact_462_inf__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ A3 ) @ ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ B2 ) )
          = ( bot_bot @ A ) ) ) ).

% inf_cancel_left1
thf(fact_463_sup__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ ( uminus_uminus @ A @ X ) @ A3 ) @ ( sup_sup @ A @ X @ B2 ) )
          = ( top_top @ A ) ) ) ).

% sup_cancel_left2
thf(fact_464_sup__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ A3 ) @ ( sup_sup @ A @ ( uminus_uminus @ A @ X ) @ B2 ) )
          = ( top_top @ A ) ) ) ).

% sup_cancel_left1
thf(fact_465_Compl__Un,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) ) ) ).

% Compl_Un
thf(fact_466_Compl__Int,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) ) ) ).

% Compl_Int
thf(fact_467_type__copy__map__comp0__undo,axiom,
    ! [E: $tType,A: $tType,C: $tType,B: $tType,D: $tType,F9: $tType,Rep: A > B,Abs: B > A,Rep2: C > D,Abs2: D > C,Rep3: E > F9,Abs3: F9 > E,M: F9 > D,M1: B > D,M2: F9 > B] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( type_definition @ C @ D @ Rep2 @ Abs2 @ ( top_top @ ( set @ D ) ) )
       => ( ( type_definition @ E @ F9 @ Rep3 @ Abs3 @ ( top_top @ ( set @ F9 ) ) )
         => ( ( ( comp @ F9 @ C @ E @ ( comp @ D @ C @ F9 @ Abs2 @ M ) @ Rep3 )
              = ( comp @ A @ C @ E @ ( comp @ B @ C @ A @ ( comp @ D @ C @ B @ Abs2 @ M1 ) @ Rep ) @ ( comp @ F9 @ A @ E @ ( comp @ B @ A @ F9 @ Abs @ M2 ) @ Rep3 ) ) )
           => ( ( comp @ B @ D @ F9 @ M1 @ M2 )
              = M ) ) ) ) ) ).

% type_copy_map_comp0_undo
thf(fact_468_type__copy__map__comp0,axiom,
    ! [F9: $tType,D: $tType,B: $tType,A: $tType,C: $tType,E: $tType,Rep: A > B,Abs: B > A,M: C > D,M1: B > D,M2: C > B,F: D > F9,G: E > C] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( M
          = ( comp @ B @ D @ C @ M1 @ M2 ) )
       => ( ( comp @ C @ F9 @ E @ ( comp @ D @ F9 @ C @ F @ M ) @ G )
          = ( comp @ A @ F9 @ E @ ( comp @ B @ F9 @ A @ ( comp @ D @ F9 @ B @ F @ M1 ) @ Rep ) @ ( comp @ C @ A @ E @ ( comp @ B @ A @ C @ Abs @ M2 ) @ G ) ) ) ) ) ).

% type_copy_map_comp0
thf(fact_469_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1_right
thf(fact_470_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z2 )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1
thf(fact_471_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_472_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A3 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_473_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_474_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X: A] :
          ( ( ( times_times @ A @ X @ X )
            = ( one_one @ A ) )
          = ( ( X
              = ( one_one @ A ) )
            | ( X
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_475_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_476_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( times_times @ A @ A3 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_477_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ A3 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A3 = B2 )
            | ( A3
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_478_snd__comp__apsnd,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: B > C] :
      ( ( comp @ ( product_prod @ A @ C ) @ C @ ( product_prod @ A @ B ) @ ( product_snd @ A @ C ) @ ( product_apsnd @ B @ C @ A @ F ) )
      = ( comp @ B @ C @ ( product_prod @ A @ B ) @ F @ ( product_snd @ A @ B ) ) ) ).

% snd_comp_apsnd
thf(fact_479_boolean__algebra_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( inf_inf @ A ) @ ( sup_sup @ A ) @ ( uminus_uminus @ A ) @ ( bot_bot @ A ) @ ( top_top @ A ) ) ) ).

% boolean_algebra.abstract_boolean_algebra_axioms
thf(fact_480_apsnd__conv,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: C > B,X: A,Y: C] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_Pair @ A @ C @ X @ Y ) )
      = ( product_Pair @ A @ B @ X @ ( F @ Y ) ) ) ).

% apsnd_conv
thf(fact_481_abstract__boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Y: A,Z2: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ ( Conj @ Y @ Z2 ) @ X )
        = ( Conj @ ( Disj @ Y @ X ) @ ( Disj @ Z2 @ X ) ) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib2
thf(fact_482_abstract__boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Y: A,Z2: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ ( Disj @ Y @ Z2 ) @ X )
        = ( Disj @ ( Conj @ Y @ X ) @ ( Conj @ Z2 @ X ) ) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib2
thf(fact_483_abstract__boolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A,Y: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( ( Compl @ X )
          = ( Compl @ Y ) )
        = ( X = Y ) ) ) ).

% abstract_boolean_algebra.compl_eq_compl_iff
thf(fact_484_abstract__boolean__algebra_Odisj__conj__distrib,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A,Y: A,Z2: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ X @ ( Conj @ Y @ Z2 ) )
        = ( Conj @ ( Disj @ X @ Y ) @ ( Disj @ X @ Z2 ) ) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib
thf(fact_485_abstract__boolean__algebra_Odisj__cancel__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ X @ ( Compl @ X ) )
        = One ) ) ).

% abstract_boolean_algebra.disj_cancel_right
thf(fact_486_abstract__boolean__algebra_Oconj__disj__distrib,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A,Y: A,Z2: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ X @ ( Disj @ Y @ Z2 ) )
        = ( Disj @ ( Conj @ X @ Y ) @ ( Conj @ X @ Z2 ) ) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib
thf(fact_487_abstract__boolean__algebra_Oconj__cancel__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ X @ ( Compl @ X ) )
        = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_right
thf(fact_488_abstract__boolean__algebra_Ocomplement__unique,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,A3: A,X: A,Y: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( ( Conj @ A3 @ X )
          = Zero )
       => ( ( ( Disj @ A3 @ X )
            = One )
         => ( ( ( Conj @ A3 @ Y )
              = Zero )
           => ( ( ( Disj @ A3 @ Y )
                = One )
             => ( X = Y ) ) ) ) ) ) ).

% abstract_boolean_algebra.complement_unique
thf(fact_489_abstract__boolean__algebra_Odisj__cancel__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ ( Compl @ X ) @ X )
        = One ) ) ).

% abstract_boolean_algebra.disj_cancel_left
thf(fact_490_abstract__boolean__algebra_Oconj__cancel__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ ( Compl @ X ) @ X )
        = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_left
thf(fact_491_abstract__boolean__algebra_Odisj__zero__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ X @ Zero )
        = X ) ) ).

% abstract_boolean_algebra.disj_zero_right
thf(fact_492_abstract__boolean__algebra_Oconj__zero__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ X @ Zero )
        = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_right
thf(fact_493_abstract__boolean__algebra_Odisj__one__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ X @ One )
        = One ) ) ).

% abstract_boolean_algebra.disj_one_right
thf(fact_494_abstract__boolean__algebra_Ode__Morgan__disj,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A,Y: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Compl @ ( Disj @ X @ Y ) )
        = ( Conj @ ( Compl @ X ) @ ( Compl @ Y ) ) ) ) ).

% abstract_boolean_algebra.de_Morgan_disj
thf(fact_495_abstract__boolean__algebra_Ode__Morgan__conj,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A,Y: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Compl @ ( Conj @ X @ Y ) )
        = ( Disj @ ( Compl @ X ) @ ( Compl @ Y ) ) ) ) ).

% abstract_boolean_algebra.de_Morgan_conj
thf(fact_496_abstract__boolean__algebra_Oconj__zero__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ Zero @ X )
        = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_left
thf(fact_497_abstract__boolean__algebra_Oconj__one__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Conj @ X @ One )
        = X ) ) ).

% abstract_boolean_algebra.conj_one_right
thf(fact_498_abstract__boolean__algebra_Odisj__one__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Disj @ One @ X )
        = One ) ) ).

% abstract_boolean_algebra.disj_one_left
thf(fact_499_abstract__boolean__algebra_Odouble__compl,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Compl @ ( Compl @ X ) )
        = X ) ) ).

% abstract_boolean_algebra.double_compl
thf(fact_500_abstract__boolean__algebra_Ocompl__unique,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,X: A,Y: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( ( Conj @ X @ Y )
          = Zero )
       => ( ( ( Disj @ X @ Y )
            = One )
         => ( ( Compl @ X )
            = Y ) ) ) ) ).

% abstract_boolean_algebra.compl_unique
thf(fact_501_abstract__boolean__algebra_Ocompl__zero,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Compl @ Zero )
        = One ) ) ).

% abstract_boolean_algebra.compl_zero
thf(fact_502_abstract__boolean__algebra_Ocompl__one,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( Compl @ One )
        = Zero ) ) ).

% abstract_boolean_algebra.compl_one
thf(fact_503_apsnd__compose,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F: C > B,G: D > C,X: product_prod @ A @ D] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_apsnd @ D @ C @ A @ G @ X ) )
      = ( product_apsnd @ D @ B @ A @ ( comp @ C @ B @ D @ F @ G ) @ X ) ) ).

% apsnd_compose
thf(fact_504_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_505_snd__comp__map__prod,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: A > D,G: B > C] :
      ( ( comp @ ( product_prod @ D @ C ) @ C @ ( product_prod @ A @ B ) @ ( product_snd @ D @ C ) @ ( product_map_prod @ A @ D @ B @ C @ F @ G ) )
      = ( comp @ B @ C @ ( product_prod @ A @ B ) @ G @ ( product_snd @ A @ B ) ) ) ).

% snd_comp_map_prod
thf(fact_506_type__copy__set__map0,axiom,
    ! [A: $tType,B: $tType,D: $tType,E: $tType,C: $tType,F9: $tType,Rep: A > B,Abs: B > A,S2: B > ( set @ D ),M: C > B,F: E > D,S4: C > ( set @ E ),G: F9 > C] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( ( comp @ B @ ( set @ D ) @ C @ S2 @ M )
          = ( comp @ ( set @ E ) @ ( set @ D ) @ C @ ( image2 @ E @ D @ F ) @ S4 ) )
       => ( ( comp @ A @ ( set @ D ) @ F9 @ ( comp @ B @ ( set @ D ) @ A @ S2 @ Rep ) @ ( comp @ C @ A @ F9 @ ( comp @ B @ A @ C @ Abs @ M ) @ G ) )
          = ( comp @ ( set @ E ) @ ( set @ D ) @ F9 @ ( image2 @ E @ D @ F ) @ ( comp @ C @ ( set @ E ) @ F9 @ S4 @ G ) ) ) ) ) ).

% type_copy_set_map0
thf(fact_507_snd__comp__apfst,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > C] :
      ( ( comp @ ( product_prod @ C @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ C @ B ) @ ( product_apfst @ A @ C @ B @ F ) )
      = ( product_snd @ A @ B ) ) ).

% snd_comp_apfst
thf(fact_508_Id__on__empty,axiom,
    ! [A: $tType] :
      ( ( id_on @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% Id_on_empty
thf(fact_509_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_510_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ B3 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_511_snd__convol,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > C,G: A > B] :
      ( ( comp @ ( product_prod @ C @ B ) @ B @ A @ ( product_snd @ C @ B ) @ ( bNF_convol @ A @ C @ B @ F @ G ) )
      = G ) ).

% snd_convol
thf(fact_512_abstract__boolean__algebra_Oaxioms_I3_J,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( boolea6902313364301356556axioms @ A @ Conj @ Disj @ Compl @ Zero @ One ) ) ).

% abstract_boolean_algebra.axioms(3)
thf(fact_513_minus__assn__def,axiom,
    ( ( minus_minus @ assn )
    = ( ^ [A5: assn,B4: assn] : ( inf_inf @ assn @ A5 @ ( uminus_uminus @ assn @ B4 ) ) ) ) ).

% minus_assn_def
thf(fact_514_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ X ) ) ).

% order_refl
thf(fact_515_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ A3 @ A3 ) ) ).

% dual_order.refl
thf(fact_516_minus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A10: A > B,B7: A > B,X3: A] : ( minus_minus @ B @ ( A10 @ X3 ) @ ( B7 @ X3 ) ) ) ) ) ).

% minus_apply
thf(fact_517_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_518_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% compl_le_compl_iff
thf(fact_519_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( ord_less_eq @ A @ X @ Z2 ) ) ) ) ).

% le_inf_iff
thf(fact_520_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A3 @ B2 )
            & ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_521_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            & ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% sup.bounded_iff
thf(fact_522_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            & ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% le_sup_iff
thf(fact_523_image__empty,axiom,
    ! [B: $tType,A: $tType,F: B > A] :
      ( ( image2 @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% image_empty
thf(fact_524_empty__is__image,axiom,
    ! [A: $tType,B: $tType,F: B > A,A4: set @ B] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( image2 @ B @ A @ F @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ B ) ) ) ) ).

% empty_is_image
thf(fact_525_image__is__empty,axiom,
    ! [A: $tType,B: $tType,F: B > A,A4: set @ B] :
      ( ( ( image2 @ B @ A @ F @ A4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( A4
        = ( bot_bot @ ( set @ B ) ) ) ) ).

% image_is_empty
thf(fact_526_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A3 ) ) ) ).

% minus_diff_eq
thf(fact_527_subset__empty,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_empty
thf(fact_528_empty__subsetI,axiom,
    ! [A: $tType,A4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A4 ) ).

% empty_subsetI
thf(fact_529_img__snd,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,S2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ S2 )
     => ( member @ B @ B2 @ ( image2 @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ S2 ) ) ) ).

% img_snd
thf(fact_530_Int__subset__iff,axiom,
    ! [A: $tType,C3: set @ A,A4: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C3 @ A4 )
        & ( ord_less_eq @ ( set @ A ) @ C3 @ B3 ) ) ) ).

% Int_subset_iff
thf(fact_531_map__prod__imageI,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,A3: A,B2: B,R: set @ ( product_prod @ A @ B ),F: A > C,G: B > D] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ R )
     => ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ ( F @ A3 ) @ ( G @ B2 ) ) @ ( image2 @ ( product_prod @ A @ B ) @ ( product_prod @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F @ G ) @ R ) ) ) ).

% map_prod_imageI
thf(fact_532_map__prod__simp,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: C > A,G: D > B,A3: C,B2: D] :
      ( ( product_map_prod @ C @ A @ D @ B @ F @ G @ ( product_Pair @ C @ D @ A3 @ B2 ) )
      = ( product_Pair @ A @ B @ ( F @ A3 ) @ ( G @ B2 ) ) ) ).

% map_prod_simp
thf(fact_533_apfst__conv,axiom,
    ! [C: $tType,A: $tType,B: $tType,F: C > A,X: C,Y: B] :
      ( ( product_apfst @ C @ A @ B @ F @ ( product_Pair @ C @ B @ X @ Y ) )
      = ( product_Pair @ A @ B @ ( F @ X ) @ Y ) ) ).

% apfst_conv
thf(fact_534_Id__onI,axiom,
    ! [A: $tType,A3: A,A4: set @ A] :
      ( ( member @ A @ A3 @ A4 )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A3 ) @ ( id_on @ A @ A4 ) ) ) ).

% Id_onI
thf(fact_535_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A3 = B2 )
            = ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_536_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_537_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A3 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_538_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_539_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_540_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A3 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% cancel_ab_semigroup_add_class.diff_right_commute
thf(fact_541_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A10: A > B,B7: A > B,X3: A] : ( minus_minus @ B @ ( A10 @ X3 ) @ ( B7 @ X3 ) ) ) ) ) ).

% fun_diff_def
thf(fact_542_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A3 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            & ( B2 != A3 ) ) ) ) ).

% nle_le
thf(fact_543_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y @ X )
             => ~ ( ord_less_eq @ A @ X @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_544_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
        = ( ^ [X3: A,Y2: A] :
              ( ( ord_less_eq @ A @ X3 @ Y2 )
              & ( ord_less_eq @ A @ Y2 @ X3 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_545_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_546_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_547_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) ).

% order_antisym
thf(fact_548_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% order.trans
thf(fact_549_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less_eq @ A @ X @ Z2 ) ) ) ) ).

% order_trans
thf(fact_550_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A3: A,B2: A] :
          ( ! [A8: A,B6: A] :
              ( ( ord_less_eq @ A @ A8 @ B6 )
             => ( P @ A8 @ B6 ) )
         => ( ! [A8: A,B6: A] :
                ( ( P @ B6 @ A8 )
               => ( P @ A8 @ B6 ) )
           => ( P @ A3 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_551_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ( ord_less_eq @ A @ A5 @ B4 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_552_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( A3 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_553_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% dual_order.trans
thf(fact_554_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A3 )
           => ( A3 = B2 ) ) ) ) ).

% antisym
thf(fact_555_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) ).

% le_funD
thf(fact_556_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) ).

% le_funE
thf(fact_557_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F: A > B,G: A > B] :
          ( ! [X2: A] : ( ord_less_eq @ B @ ( F @ X2 ) @ ( G @ X2 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) ).

% le_funI
thf(fact_558_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F2: A > B,G2: A > B] :
            ! [X3: A] : ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ).

% le_fun_def
thf(fact_559_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ( ord_less_eq @ A @ B4 @ A5 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_560_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A3: A,F: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_561_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A3: A,B2: A,F: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ C @ ( F @ B2 ) @ C2 )
           => ( ! [X2: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y3 )
                 => ( ord_less_eq @ C @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ C @ ( F @ A3 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_562_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_eq_refl
thf(fact_563_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_linear
thf(fact_564_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A3: A,F: B > A,B2: B,C2: B] :
          ( ( A3
            = ( F @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_565_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A3: A,B2: A,F: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ( F @ B2 )
              = C2 )
           => ( ! [X2: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y3 )
                 => ( ord_less_eq @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ B @ ( F @ A3 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_566_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_le_cases
thf(fact_567_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% order_antisym_conv
thf(fact_568_prod__fun__imageE,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,C2: product_prod @ A @ B,F: C > A,G: D > B,R: set @ ( product_prod @ C @ D )] :
      ( ( member @ ( product_prod @ A @ B ) @ C2 @ ( image2 @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ A @ D @ B @ F @ G ) @ R ) )
     => ~ ! [X2: C,Y3: D] :
            ( ( C2
              = ( product_Pair @ A @ B @ ( F @ X2 ) @ ( G @ Y3 ) ) )
           => ~ ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ X2 @ Y3 ) @ R ) ) ) ).

% prod_fun_imageE
thf(fact_569_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( minus_minus @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% diff_shunt_var
thf(fact_570_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F: B > A,A4: set @ B,B3: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image2 @ B @ A @ F @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( image2 @ B @ A @ F @ A4 ) @ ( image2 @ B @ A @ F @ B3 ) ) ) ).

% image_Int_subset
thf(fact_571_map__prod__o__convol,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,A: $tType,H12: D > B,H23: E > C,F: A > D,G: A > E] :
      ( ( comp @ ( product_prod @ D @ E ) @ ( product_prod @ B @ C ) @ A @ ( product_map_prod @ D @ B @ E @ C @ H12 @ H23 ) @ ( bNF_convol @ A @ D @ E @ F @ G ) )
      = ( bNF_convol @ A @ B @ C @ ( comp @ D @ B @ A @ H12 @ F ) @ ( comp @ E @ C @ A @ H23 @ G ) ) ) ).

% map_prod_o_convol
thf(fact_572_abstract__boolean__algebra__axioms__def,axiom,
    ! [A: $tType] :
      ( ( boolea6902313364301356556axioms @ A )
      = ( ^ [Conj2: A > A > A,Disj2: A > A > A,Compl2: A > A,Zero2: A,One2: A] :
            ( ! [X3: A,Y2: A,Z4: A] :
                ( ( Conj2 @ X3 @ ( Disj2 @ Y2 @ Z4 ) )
                = ( Disj2 @ ( Conj2 @ X3 @ Y2 ) @ ( Conj2 @ X3 @ Z4 ) ) )
            & ! [X3: A,Y2: A,Z4: A] :
                ( ( Disj2 @ X3 @ ( Conj2 @ Y2 @ Z4 ) )
                = ( Conj2 @ ( Disj2 @ X3 @ Y2 ) @ ( Disj2 @ X3 @ Z4 ) ) )
            & ! [X3: A] :
                ( ( Conj2 @ X3 @ One2 )
                = X3 )
            & ! [X3: A] :
                ( ( Disj2 @ X3 @ Zero2 )
                = X3 )
            & ! [X3: A] :
                ( ( Conj2 @ X3 @ ( Compl2 @ X3 ) )
                = Zero2 )
            & ! [X3: A] :
                ( ( Disj2 @ X3 @ ( Compl2 @ X3 ) )
                = One2 ) ) ) ) ).

% abstract_boolean_algebra_axioms_def
thf(fact_573_abstract__boolean__algebra__axioms_Ointro,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,One: A,Zero: A,Compl: A > A] :
      ( ! [X2: A,Y3: A,Z3: A] :
          ( ( Conj @ X2 @ ( Disj @ Y3 @ Z3 ) )
          = ( Disj @ ( Conj @ X2 @ Y3 ) @ ( Conj @ X2 @ Z3 ) ) )
     => ( ! [X2: A,Y3: A,Z3: A] :
            ( ( Disj @ X2 @ ( Conj @ Y3 @ Z3 ) )
            = ( Conj @ ( Disj @ X2 @ Y3 ) @ ( Disj @ X2 @ Z3 ) ) )
       => ( ! [X2: A] :
              ( ( Conj @ X2 @ One )
              = X2 )
         => ( ! [X2: A] :
                ( ( Disj @ X2 @ Zero )
                = X2 )
           => ( ! [X2: A] :
                  ( ( Conj @ X2 @ ( Compl @ X2 ) )
                  = Zero )
             => ( ! [X2: A] :
                    ( ( Disj @ X2 @ ( Compl @ X2 ) )
                    = One )
               => ( boolea6902313364301356556axioms @ A @ Conj @ Disj @ Compl @ Zero @ One ) ) ) ) ) ) ) ).

% abstract_boolean_algebra_axioms.intro
thf(fact_574_snd__image__mp,axiom,
    ! [B: $tType,A: $tType,A4: set @ ( product_prod @ B @ A ),B3: set @ A,X: B,Y: A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image2 @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ A4 ) @ B3 )
     => ( ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y ) @ A4 )
       => ( member @ A @ Y @ B3 ) ) ) ).

% snd_image_mp
thf(fact_575_image__eq__imp__comp,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: B > A,A4: set @ B,G: C > A,B3: set @ C,H2: A > D] :
      ( ( ( image2 @ B @ A @ F @ A4 )
        = ( image2 @ C @ A @ G @ B3 ) )
     => ( ( image2 @ B @ D @ ( comp @ A @ D @ B @ H2 @ F ) @ A4 )
        = ( image2 @ C @ D @ ( comp @ A @ D @ C @ H2 @ G ) @ B3 ) ) ) ).

% image_eq_imp_comp
thf(fact_576_image__comp,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: B > A,G: C > B,R4: set @ C] :
      ( ( image2 @ B @ A @ F @ ( image2 @ C @ B @ G @ R4 ) )
      = ( image2 @ C @ A @ ( comp @ B @ A @ C @ F @ G ) @ R4 ) ) ).

% image_comp
thf(fact_577_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_578_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A3 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A3 ) @ ( times_times @ A @ C2 @ A3 ) ) ) ) ).

% left_diff_distrib'
thf(fact_579_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_580_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_581_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A3: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A3 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_582_map__prod__compose,axiom,
    ! [D: $tType,C: $tType,A: $tType,E: $tType,F9: $tType,B: $tType,F1: E > C,F22: A > E,G1: F9 > D,G22: B > F9] :
      ( ( product_map_prod @ A @ C @ B @ D @ ( comp @ E @ C @ A @ F1 @ F22 ) @ ( comp @ F9 @ D @ B @ G1 @ G22 ) )
      = ( comp @ ( product_prod @ E @ F9 ) @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ E @ C @ F9 @ D @ F1 @ G1 ) @ ( product_map_prod @ A @ E @ B @ F9 @ F22 @ G22 ) ) ) ).

% map_prod_compose
thf(fact_583_map__prod_Ocompositionality,axiom,
    ! [D: $tType,F9: $tType,E: $tType,C: $tType,B: $tType,A: $tType,F: C > E,G: D > F9,H2: A > C,I: B > D,Prod: product_prod @ A @ B] :
      ( ( product_map_prod @ C @ E @ D @ F9 @ F @ G @ ( product_map_prod @ A @ C @ B @ D @ H2 @ I @ Prod ) )
      = ( product_map_prod @ A @ E @ B @ F9 @ ( comp @ C @ E @ A @ F @ H2 ) @ ( comp @ D @ F9 @ B @ G @ I ) @ Prod ) ) ).

% map_prod.compositionality
thf(fact_584_map__prod_Ocomp,axiom,
    ! [A: $tType,C: $tType,E: $tType,F9: $tType,D: $tType,B: $tType,F: C > E,G: D > F9,H2: A > C,I: B > D] :
      ( ( comp @ ( product_prod @ C @ D ) @ ( product_prod @ E @ F9 ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ E @ D @ F9 @ F @ G ) @ ( product_map_prod @ A @ C @ B @ D @ H2 @ I ) )
      = ( product_map_prod @ A @ E @ B @ F9 @ ( comp @ C @ E @ A @ F @ H2 ) @ ( comp @ D @ F9 @ B @ G @ I ) ) ) ).

% map_prod.comp
thf(fact_585_prod_Omap__comp,axiom,
    ! [D: $tType,F9: $tType,E: $tType,C: $tType,B: $tType,A: $tType,G1: C > E,G22: D > F9,F1: A > C,F22: B > D,V: product_prod @ A @ B] :
      ( ( product_map_prod @ C @ E @ D @ F9 @ G1 @ G22 @ ( product_map_prod @ A @ C @ B @ D @ F1 @ F22 @ V ) )
      = ( product_map_prod @ A @ E @ B @ F9 @ ( comp @ C @ E @ A @ G1 @ F1 ) @ ( comp @ D @ F9 @ B @ G22 @ F22 ) @ V ) ) ).

% prod.map_comp
thf(fact_586_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_587_subrelI,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ! [X2: A,Y3: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ R4 )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R4 @ S ) ) ).

% subrelI
thf(fact_588_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
         => ( A3
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_589_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
          = ( A3
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_590_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A3 ) ) ).

% bot.extremum
thf(fact_591_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% le_minus_iff
thf(fact_592_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A3 ) ) ) ).

% minus_le_iff
thf(fact_593_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% le_imp_neg_le
thf(fact_594_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ ( uminus_uminus @ A @ X ) ) ) ) ).

% compl_mono
thf(fact_595_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_le_swap1
thf(fact_596_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_le_swap2
thf(fact_597_subset__emptyI,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ! [X2: A] :
          ~ ( member @ A @ X2 @ A4 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_emptyI
thf(fact_598_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ A3 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_599_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
          = ( A3
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_600_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
         => ( A3
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_601_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_sup_ord(2)
thf(fact_602_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_sup_ord(1)
thf(fact_603_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_le1
thf(fact_604_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_le2
thf(fact_605_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A3 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X @ A3 )
             => ~ ( ord_less_eq @ A @ X @ B2 ) ) ) ) ).

% le_infE
thf(fact_606_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A3 )
         => ( ( ord_less_eq @ A @ X @ B2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A3 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_607_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ ( inf_inf @ A @ C2 @ D2 ) ) ) ) ) ).

% inf_mono
thf(fact_608_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X ) ) ) ).

% le_infI1
thf(fact_609_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X ) ) ) ).

% le_infI2
thf(fact_610_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( A3
            = ( inf_inf @ A @ A3 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_611_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( inf_inf @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% inf.orderI
thf(fact_612_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F: A > A > A,X: A,Y: A] :
          ( ! [X2: A,Y3: A] : ( ord_less_eq @ A @ ( F @ X2 @ Y3 ) @ X2 )
         => ( ! [X2: A,Y3: A] : ( ord_less_eq @ A @ ( F @ X2 @ Y3 ) @ Y3 )
           => ( ! [X2: A,Y3: A,Z3: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y3 )
                 => ( ( ord_less_eq @ A @ X2 @ Z3 )
                   => ( ord_less_eq @ A @ X2 @ ( F @ Y3 @ Z3 ) ) ) )
             => ( ( inf_inf @ A @ X @ Y )
                = ( F @ X @ Y ) ) ) ) ) ) ).

% inf_unique
thf(fact_613_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X3: A,Y2: A] :
              ( ( inf_inf @ A @ X3 @ Y2 )
              = X3 ) ) ) ) ).

% le_iff_inf
thf(fact_614_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% inf.absorb1
thf(fact_615_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_616_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( inf_inf @ A @ X @ Y )
            = X ) ) ) ).

% inf_absorb1
thf(fact_617_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( inf_inf @ A @ X @ Y )
            = Y ) ) ) ).

% inf_absorb2
thf(fact_618_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A3 @ B2 )
             => ~ ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_619_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ A3 @ C2 )
           => ( ord_less_eq @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_620_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Z2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ) ).

% inf_greatest
thf(fact_621_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( A5
              = ( inf_inf @ A @ A5 @ B4 ) ) ) ) ) ).

% inf.order_iff
thf(fact_622_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ A3 ) ) ).

% inf.cobounded1
thf(fact_623_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_624_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( inf_inf @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_625_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( inf_inf @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_626_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_627_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_628_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_629_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_630_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( sup_sup @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_631_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( sup_sup @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_632_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_633_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ A3 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_634_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( A5
              = ( sup_sup @ A @ A5 @ B4 ) ) ) ) ) ).

% sup.order_iff
thf(fact_635_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ A3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% sup.boundedI
thf(fact_636_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A3 )
             => ~ ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% sup.boundedE
thf(fact_637_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( sup_sup @ A @ X @ Y )
            = Y ) ) ) ).

% sup_absorb2
thf(fact_638_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( sup_sup @ A @ X @ Y )
            = X ) ) ) ).

% sup_absorb1
thf(fact_639_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_640_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% sup.absorb1
thf(fact_641_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F: A > A > A,X: A,Y: A] :
          ( ! [X2: A,Y3: A] : ( ord_less_eq @ A @ X2 @ ( F @ X2 @ Y3 ) )
         => ( ! [X2: A,Y3: A] : ( ord_less_eq @ A @ Y3 @ ( F @ X2 @ Y3 ) )
           => ( ! [X2: A,Y3: A,Z3: A] :
                  ( ( ord_less_eq @ A @ Y3 @ X2 )
                 => ( ( ord_less_eq @ A @ Z3 @ X2 )
                   => ( ord_less_eq @ A @ ( F @ Y3 @ Z3 ) @ X2 ) ) )
             => ( ( sup_sup @ A @ X @ Y )
                = ( F @ X @ Y ) ) ) ) ) ) ).

% sup_unique
thf(fact_642_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( sup_sup @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% sup.orderI
thf(fact_643_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( A3
            = ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_644_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X3: A,Y2: A] :
              ( ( sup_sup @ A @ X3 @ Y2 )
              = Y2 ) ) ) ) ).

% le_iff_sup
thf(fact_645_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ Z2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X ) ) ) ) ).

% sup_least
thf(fact_646_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B2 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) ).

% sup_mono
thf(fact_647_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A3: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_648_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ X @ B2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_649_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A3 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_650_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge2
thf(fact_651_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge1
thf(fact_652_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ X )
         => ( ( ord_less_eq @ A @ B2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B2 ) @ X ) ) ) ) ).

% le_supI
thf(fact_653_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B2 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A3 @ X )
             => ~ ( ord_less_eq @ A @ B2 @ X ) ) ) ) ).

% le_supE
thf(fact_654_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(3)
thf(fact_655_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(4)
thf(fact_656_inter__eq__subsetI,axiom,
    ! [A: $tType,S2: set @ A,S4: set @ A,A4: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ S4 )
     => ( ( ( inf_inf @ ( set @ A ) @ A4 @ S4 )
          = ( inf_inf @ ( set @ A ) @ B3 @ S4 ) )
       => ( ( inf_inf @ ( set @ A ) @ A4 @ S2 )
          = ( inf_inf @ ( set @ A ) @ B3 @ S2 ) ) ) ) ).

% inter_eq_subsetI
thf(fact_657_Int__Collect__mono,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ A4 )
           => ( ( P @ X2 )
             => ( Q @ X2 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B3 @ ( collect @ A @ Q ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_658_Int__greatest,axiom,
    ! [A: $tType,C3: set @ A,A4: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C3 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ C3 @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ C3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% Int_greatest
thf(fact_659_Int__absorb2,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = A4 ) ) ).

% Int_absorb2
thf(fact_660_Int__absorb1,axiom,
    ! [A: $tType,B3: set @ A,A4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A4 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = B3 ) ) ).

% Int_absorb1
thf(fact_661_Int__lower2,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ B3 ) ).

% Int_lower2
thf(fact_662_Int__lower1,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ A4 ) ).

% Int_lower1
thf(fact_663_Int__mono,axiom,
    ! [A: $tType,A4: set @ A,C3: set @ A,B3: set @ A,D4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ D4 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ ( inf_inf @ ( set @ A ) @ C3 @ D4 ) ) ) ) ).

% Int_mono
thf(fact_664_less__by__empty,axiom,
    ! [A: $tType,A4: set @ ( product_prod @ A @ A ),B3: set @ ( product_prod @ A @ A )] :
      ( ( A4
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A4 @ B3 ) ) ).

% less_by_empty
thf(fact_665_relH__subset,axiom,
    ! [Bs: set @ nat,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,As: set @ nat] :
      ( ( relH @ Bs @ H2 @ H4 )
     => ( ( ord_less_eq @ ( set @ nat ) @ As @ Bs )
       => ( relH @ As @ H2 @ H4 ) ) ) ).

% relH_subset
thf(fact_666_apfst__compose,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: C > A,G: D > C,X: product_prod @ D @ B] :
      ( ( product_apfst @ C @ A @ B @ F @ ( product_apfst @ D @ C @ B @ G @ X ) )
      = ( product_apfst @ D @ A @ B @ ( comp @ C @ A @ D @ F @ G ) @ X ) ) ).

% apfst_compose
thf(fact_667_Id__on__iff,axiom,
    ! [A: $tType,X: A,Y: A,A4: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( id_on @ A @ A4 ) )
      = ( ( X = Y )
        & ( member @ A @ X @ A4 ) ) ) ).

% Id_on_iff
thf(fact_668_Id__on__eqI,axiom,
    ! [A: $tType,A3: A,B2: A,A4: set @ A] :
      ( ( A3 = B2 )
     => ( ( member @ A @ A3 @ A4 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( id_on @ A @ A4 ) ) ) ) ).

% Id_on_eqI
thf(fact_669_Id__onE,axiom,
    ! [A: $tType,C2: product_prod @ A @ A,A4: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ C2 @ ( id_on @ A @ A4 ) )
     => ~ ! [X2: A] :
            ( ( member @ A @ X2 @ A4 )
           => ( C2
             != ( product_Pair @ A @ A @ X2 @ X2 ) ) ) ) ).

% Id_onE
thf(fact_670_convol__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( bNF_convol @ A @ B @ C )
      = ( ^ [F2: A > B,G2: A > C,A5: A] : ( product_Pair @ B @ C @ ( F2 @ A5 ) @ ( G2 @ A5 ) ) ) ) ).

% convol_def
thf(fact_671_convol__o,axiom,
    ! [B: $tType,C: $tType,D: $tType,A: $tType,F: D > B,G: D > C,H2: A > D] :
      ( ( comp @ D @ ( product_prod @ B @ C ) @ A @ ( bNF_convol @ D @ B @ C @ F @ G ) @ H2 )
      = ( bNF_convol @ A @ B @ C @ ( comp @ D @ B @ A @ F @ H2 ) @ ( comp @ D @ C @ A @ G @ H2 ) ) ) ).

% convol_o
thf(fact_672_in__snd__imageE,axiom,
    ! [A: $tType,B: $tType,Y: A,S2: set @ ( product_prod @ B @ A )] :
      ( ( member @ A @ Y @ ( image2 @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ S2 ) )
     => ~ ! [X2: B] :
            ~ ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y ) @ S2 ) ) ).

% in_snd_imageE
thf(fact_673_surj__fun__eq,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: B > A,X5: set @ B,G1: A > C,G22: A > C] :
      ( ( ( image2 @ B @ A @ F @ X5 )
        = ( top_top @ ( set @ A ) ) )
     => ( ! [X2: B] :
            ( ( member @ B @ X2 @ X5 )
           => ( ( comp @ A @ C @ B @ G1 @ F @ X2 )
              = ( comp @ A @ C @ B @ G22 @ F @ X2 ) ) )
       => ( G1 = G22 ) ) ) ).

% surj_fun_eq
thf(fact_674_comp__surj,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: B > A,G: A > C] :
      ( ( ( image2 @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ( image2 @ A @ C @ G @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ C ) ) )
       => ( ( image2 @ B @ C @ ( comp @ A @ C @ B @ G @ F ) @ ( top_top @ ( set @ B ) ) )
          = ( top_top @ ( set @ C ) ) ) ) ) ).

% comp_surj
thf(fact_675_fun_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,D: $tType,X: D > A,Xa: D > A,F: A > B,Fa: A > B] :
      ( ! [Z3: A,Za: A] :
          ( ( member @ A @ Z3 @ ( image2 @ D @ A @ X @ ( top_top @ ( set @ D ) ) ) )
         => ( ( member @ A @ Za @ ( image2 @ D @ A @ Xa @ ( top_top @ ( set @ D ) ) ) )
           => ( ( ( F @ Z3 )
                = ( Fa @ Za ) )
             => ( Z3 = Za ) ) ) )
     => ( ( ( comp @ A @ B @ D @ F @ X )
          = ( comp @ A @ B @ D @ Fa @ Xa ) )
       => ( X = Xa ) ) ) ).

% fun.inj_map_strong
thf(fact_676_fun_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,D: $tType,X: D > A,F: A > B,G: A > B] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( image2 @ D @ A @ X @ ( top_top @ ( set @ D ) ) ) )
         => ( ( F @ Z3 )
            = ( G @ Z3 ) ) )
     => ( ( comp @ A @ B @ D @ F @ X )
        = ( comp @ A @ B @ D @ G @ X ) ) ) ).

% fun.map_cong0
thf(fact_677_fun_Omap__cong,axiom,
    ! [B: $tType,A: $tType,D: $tType,X: D > A,Ya: D > A,F: A > B,G: A > B] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( image2 @ D @ A @ Ya @ ( top_top @ ( set @ D ) ) ) )
           => ( ( F @ Z3 )
              = ( G @ Z3 ) ) )
       => ( ( comp @ A @ B @ D @ F @ X )
          = ( comp @ A @ B @ D @ G @ Ya ) ) ) ) ).

% fun.map_cong
thf(fact_678_fun_Oset__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,F: A > B,V: D > A] :
      ( ( image2 @ D @ B @ ( comp @ A @ B @ D @ F @ V ) @ ( top_top @ ( set @ D ) ) )
      = ( image2 @ A @ B @ F @ ( image2 @ D @ A @ V @ ( top_top @ ( set @ D ) ) ) ) ) ).

% fun.set_map
thf(fact_679_diff__eq,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( minus_minus @ A )
        = ( ^ [X3: A,Y2: A] : ( inf_inf @ A @ X3 @ ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% diff_eq
thf(fact_680_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_681_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_682_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z2 ) ) @ ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% distrib_inf_le
thf(fact_683_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% distrib_sup_le
thf(fact_684_disjoint__mono,axiom,
    ! [A: $tType,A3: set @ A,A6: set @ A,B2: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ A6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ B5 )
       => ( ( ( inf_inf @ ( set @ A ) @ A6 @ B5 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% disjoint_mono
thf(fact_685_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,C3: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ C3 )
        = ( inf_inf @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ B3 @ C3 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C3 @ A4 ) ) ).

% Un_Int_assoc_eq
thf(fact_686_subset__Compl__self__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_Compl_self_eq
thf(fact_687_in__range__subset,axiom,
    ! [As: set @ nat,As3: set @ nat,H2: heap_ext @ product_unit] :
      ( ( ord_less_eq @ ( set @ nat ) @ As @ As3 )
     => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As3 ) )
       => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) ) ) ) ).

% in_range_subset
thf(fact_688_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% inf_shunt
thf(fact_689_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% sup_shunt
thf(fact_690_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y ) @ Z2 ) ) ) ) ).

% shunt1
thf(fact_691_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ ( uminus_uminus @ A @ Y ) ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% shunt2
thf(fact_692_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P4: A,Q4: A,R4: A] :
          ( ( ord_less_eq @ A @ P4 @ ( sup_sup @ A @ Q4 @ R4 ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P4 @ ( uminus_uminus @ A @ Q4 ) ) @ R4 ) ) ) ).

% sup_neg_inf
thf(fact_693_apfst__convE,axiom,
    ! [C: $tType,A: $tType,B: $tType,Q4: product_prod @ A @ B,F: C > A,P4: product_prod @ C @ B] :
      ( ( Q4
        = ( product_apfst @ C @ A @ B @ F @ P4 ) )
     => ~ ! [X2: C,Y3: B] :
            ( ( P4
              = ( product_Pair @ C @ B @ X2 @ Y3 ) )
           => ( Q4
             != ( product_Pair @ A @ B @ ( F @ X2 ) @ Y3 ) ) ) ) ).

% apfst_convE
thf(fact_694_Sup_OSUP__image,axiom,
    ! [B: $tType,A: $tType,C: $tType,Sup: ( set @ A ) > A,G: B > A,F: C > B,A4: set @ C] :
      ( ( Sup @ ( image2 @ B @ A @ G @ ( image2 @ C @ B @ F @ A4 ) ) )
      = ( Sup @ ( image2 @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A4 ) ) ) ).

% Sup.SUP_image
thf(fact_695_Inf_OINF__image,axiom,
    ! [B: $tType,A: $tType,C: $tType,Inf: ( set @ A ) > A,G: B > A,F: C > B,A4: set @ C] :
      ( ( Inf @ ( image2 @ B @ A @ G @ ( image2 @ C @ B @ F @ A4 ) ) )
      = ( Inf @ ( image2 @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A4 ) ) ) ).

% Inf.INF_image
thf(fact_696_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D4: A,Q: A > $o] :
          ( ! [X2: A,K2: A] :
              ( ( P @ X2 )
              = ( P @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D4 ) ) ) )
         => ( ! [X2: A,K2: A] :
                ( ( Q @ X2 )
                = ( Q @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D4 ) ) ) )
           => ! [X6: A,K3: A] :
                ( ( ( P @ X6 )
                  & ( Q @ X6 ) )
                = ( ( P @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K3 @ D4 ) ) )
                  & ( Q @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K3 @ D4 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_697_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D4: A,Q: A > $o] :
          ( ! [X2: A,K2: A] :
              ( ( P @ X2 )
              = ( P @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D4 ) ) ) )
         => ( ! [X2: A,K2: A] :
                ( ( Q @ X2 )
                = ( Q @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K2 @ D4 ) ) ) )
           => ! [X6: A,K3: A] :
                ( ( ( P @ X6 )
                  | ( Q @ X6 ) )
                = ( ( P @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K3 @ D4 ) ) )
                  | ( Q @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K3 @ D4 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_698_apsnd__apfst,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F: C > B,G: D > A,X: product_prod @ D @ C] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_apfst @ D @ A @ C @ G @ X ) )
      = ( product_Pair @ A @ B @ ( G @ ( product_fst @ D @ C @ X ) ) @ ( F @ ( product_snd @ D @ C @ X ) ) ) ) ).

% apsnd_apfst
thf(fact_699_apfst__apsnd,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,F: C > A,G: D > B,X: product_prod @ C @ D] :
      ( ( product_apfst @ C @ A @ B @ F @ ( product_apsnd @ D @ B @ C @ G @ X ) )
      = ( product_Pair @ A @ B @ ( F @ ( product_fst @ C @ D @ X ) ) @ ( G @ ( product_snd @ C @ D @ X ) ) ) ) ).

% apfst_apsnd
thf(fact_700_the__elem__image__unique,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,F: A > B,X: A] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [Y3: A] :
            ( ( member @ A @ Y3 @ A4 )
           => ( ( F @ Y3 )
              = ( F @ X ) ) )
       => ( ( the_elem @ B @ ( image2 @ A @ B @ F @ A4 ) )
          = ( F @ X ) ) ) ) ).

% the_elem_image_unique
thf(fact_701_mod__star__trueE_H,axiom,
    ! [P: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ P @ ( top_top @ assn ) ) @ H2 )
     => ~ ! [H5: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( ( product_fst @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 )
              = ( product_fst @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 ) )
           => ( ( ord_less_eq @ ( set @ nat ) @ ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 ) @ ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 ) )
             => ~ ( rep_assn @ P @ H5 ) ) ) ) ).

% mod_star_trueE'
thf(fact_702_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_703_Diff__cancel,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ A4 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_cancel
thf(fact_704_empty__Diff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A4 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% empty_Diff
thf(fact_705_Diff__empty,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = A4 ) ).

% Diff_empty
thf(fact_706_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_707_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_708_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_709_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A3
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_710_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A3 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_711_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_712_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ A3 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_713_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% diff_zero
thf(fact_714_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_715_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% diff_0_right
thf(fact_716_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ A3 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_717_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = A3 )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_718_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( A3
            = ( uminus_uminus @ A @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_719_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_720_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A3 ) )
          = ( ( zero_zero @ A )
            = A3 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_721_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_722_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ B3 ) ) ).

% Diff_eq_empty_iff
thf(fact_723_Diff__UNIV,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_UNIV
thf(fact_724_Diff__disjoint,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ B3 @ A4 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_disjoint
thf(fact_725_Diff__Compl,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ).

% Diff_Compl
thf(fact_726_inter__compl__diff__conv,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ B3 ) )
      = ( minus_minus @ ( set @ A ) @ A4 @ B3 ) ) ).

% inter_compl_diff_conv
thf(fact_727_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_728_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_729_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_730_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_le_0_iff_le
thf(fact_731_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_732_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_733_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A3: A] :
          ( ( ( times_times @ A @ C2 @ A3 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_734_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_735_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A3: A,C2: A] :
          ( ( ( times_times @ A @ A3 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_736_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_737_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A3 )
          = ( uminus_uminus @ A @ A3 ) ) ) ).

% diff_0
thf(fact_738_prod_Ocollapse,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod @ A @ B] :
      ( ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) )
      = Prod ) ).

% prod.collapse
thf(fact_739_img__fst,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,S2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ S2 )
     => ( member @ A @ A3 @ ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ S2 ) ) ) ).

% img_fst
thf(fact_740_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_741_fst__comp__apsnd,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: B > C] :
      ( ( comp @ ( product_prod @ A @ C ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ C ) @ ( product_apsnd @ B @ C @ A @ F ) )
      = ( product_fst @ A @ B ) ) ).

% fst_comp_apsnd
thf(fact_742_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_743_fst__comp__map__prod,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: A > C,G: B > D] :
      ( ( comp @ ( product_prod @ C @ D ) @ C @ ( product_prod @ A @ B ) @ ( product_fst @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F @ G ) )
      = ( comp @ A @ C @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) ) ) ).

% fst_comp_map_prod
thf(fact_744_fst__comp__apfst,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > C] :
      ( ( comp @ ( product_prod @ C @ B ) @ C @ ( product_prod @ A @ B ) @ ( product_fst @ C @ B ) @ ( product_apfst @ A @ C @ B @ F ) )
      = ( comp @ A @ C @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) ) ) ).

% fst_comp_apfst
thf(fact_745_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_746_fst__eqD,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,A3: A] :
      ( ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X @ Y ) )
        = A3 )
     => ( X = A3 ) ) ).

% fst_eqD
thf(fact_747_fst__conv,axiom,
    ! [B: $tType,A: $tType,X1: A,X22: B] :
      ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = X1 ) ).

% fst_conv
thf(fact_748_fstE,axiom,
    ! [B: $tType,A: $tType,X: product_prod @ A @ B,A3: A,B2: B,P: A > $o] :
      ( ( X
        = ( product_Pair @ A @ B @ A3 @ B2 ) )
     => ( ( P @ ( product_fst @ A @ B @ X ) )
       => ( P @ A3 ) ) ) ).

% fstE
thf(fact_749_fstI,axiom,
    ! [B: $tType,A: $tType,X: product_prod @ A @ B,Y: A,Z2: B] :
      ( ( X
        = ( product_Pair @ A @ B @ Y @ Z2 ) )
     => ( ( product_fst @ A @ B @ X )
        = Y ) ) ).

% fstI
thf(fact_750_eq__fst__iff,axiom,
    ! [A: $tType,B: $tType,A3: A,P4: product_prod @ A @ B] :
      ( ( A3
        = ( product_fst @ A @ B @ P4 ) )
      = ( ? [B4: B] :
            ( P4
            = ( product_Pair @ A @ B @ A3 @ B4 ) ) ) ) ).

% eq_fst_iff
thf(fact_751_in__fst__imageE,axiom,
    ! [B: $tType,A: $tType,X: A,S2: set @ ( product_prod @ A @ B )] :
      ( ( member @ A @ X @ ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ S2 ) )
     => ~ ! [Y3: B] :
            ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y3 ) @ S2 ) ) ).

% in_fst_imageE
thf(fact_752_Int__Diff,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,C3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ C3 )
      = ( inf_inf @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ B3 @ C3 ) ) ) ).

% Int_Diff
thf(fact_753_Diff__Int2,axiom,
    ! [A: $tType,A4: set @ A,C3: set @ A,B3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ C3 ) @ ( inf_inf @ ( set @ A ) @ B3 @ C3 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ C3 ) @ B3 ) ) ).

% Diff_Int2
thf(fact_754_Diff__Diff__Int,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ).

% Diff_Diff_Int
thf(fact_755_Diff__Int__distrib,axiom,
    ! [A: $tType,C3: set @ A,A4: set @ A,B3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ C3 @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ C3 @ A4 ) @ ( inf_inf @ ( set @ A ) @ C3 @ B3 ) ) ) ).

% Diff_Int_distrib
thf(fact_756_Diff__Int__distrib2,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,C3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) @ C3 )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ C3 ) @ ( inf_inf @ ( set @ A ) @ B3 @ C3 ) ) ) ).

% Diff_Int_distrib2
thf(fact_757_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ).

% zero_le
thf(fact_758_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A3
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_759_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A3
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_760_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A3 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_761_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A3 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A3 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_762_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A3 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A3 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_763_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_764_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
        = ( ^ [A5: A,B4: A] :
              ( ( minus_minus @ A @ A5 @ B4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_765_less__eq__assn__def,axiom,
    ( ( ord_less_eq @ assn )
    = ( ^ [A5: assn,B4: assn] :
          ( A5
          = ( inf_inf @ assn @ A5 @ B4 ) ) ) ) ).

% less_eq_assn_def
thf(fact_766_fst__image__mp,axiom,
    ! [B: $tType,A: $tType,A4: set @ ( product_prod @ A @ B ),B3: set @ A,X: A,Y: B] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A4 ) @ B3 )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ A4 )
       => ( member @ A @ X @ B3 ) ) ) ).

% fst_image_mp
thf(fact_767_surjective__pairing,axiom,
    ! [B: $tType,A: $tType,T4: product_prod @ A @ B] :
      ( T4
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ T4 ) @ ( product_snd @ A @ B @ T4 ) ) ) ).

% surjective_pairing
thf(fact_768_prod_Oexhaust__sel,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod @ A @ B] :
      ( Prod
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ).

% prod.exhaust_sel
thf(fact_769_subset__minus__empty,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
     => ( ( minus_minus @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_minus_empty
thf(fact_770_Diff__triv,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( minus_minus @ ( set @ A ) @ A4 @ B3 )
        = A4 ) ) ).

% Diff_triv
thf(fact_771_Int__Diff__disjoint,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_Diff_disjoint
thf(fact_772_disjoint__alt__simp1,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A4 @ B3 )
        = A4 )
      = ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% disjoint_alt_simp1
thf(fact_773_disjoint__alt__simp2,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ B3 )
         != A4 ) )
      = ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjoint_alt_simp2
thf(fact_774_Un__Diff__Int,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
      = A4 ) ).

% Un_Diff_Int
thf(fact_775_Int__Diff__Un,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) )
      = A4 ) ).

% Int_Diff_Un
thf(fact_776_Diff__Int,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,C3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B3 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) @ ( minus_minus @ ( set @ A ) @ A4 @ C3 ) ) ) ).

% Diff_Int
thf(fact_777_Diff__Un,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,C3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ B3 @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) @ ( minus_minus @ ( set @ A ) @ A4 @ C3 ) ) ) ).

% Diff_Un
thf(fact_778_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_779_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_780_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ A3 ) ) ) ).

% zero_le_square
thf(fact_781_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_782_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_783_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_784_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_785_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_786_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_787_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_788_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_789_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_790_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_791_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_792_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_793_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_794_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_795_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_796_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_797_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_798_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A5 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_799_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_800_fst__convol,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > B,G: A > C] :
      ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ ( bNF_convol @ A @ B @ C @ F @ G ) )
      = F ) ).

% fst_convol
thf(fact_801_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y @ X ) @ X ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_802_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X @ Y ) @ X ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_803_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_804_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A3: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ A3 ) ) ) ) ).

% mult_left_le
thf(fact_805_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_806_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_807_convol__expand__snd,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > ( product_prod @ B @ C ),G: A > B] :
      ( ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F )
        = G )
     => ( ( bNF_convol @ A @ B @ C @ G @ ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F ) )
        = F ) ) ).

% convol_expand_snd
thf(fact_808_convol__expand__snd_H,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > ( product_prod @ B @ C ),G: A > B,H2: A > C] :
      ( ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F )
        = G )
     => ( ( H2
          = ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F ) )
        = ( ( bNF_convol @ A @ B @ C @ G @ H2 )
          = F ) ) ) ).

% convol_expand_snd'
thf(fact_809_sndOp__def,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( bNF_sndOp @ C @ A @ B )
      = ( ^ [P3: C > A > $o,Q3: A > B > $o,Ac: product_prod @ C @ B] : ( product_Pair @ A @ B @ ( bNF_pick_middlep @ C @ A @ B @ P3 @ Q3 @ ( product_fst @ C @ B @ Ac ) @ ( product_snd @ C @ B @ Ac ) ) @ ( product_snd @ C @ B @ Ac ) ) ) ) ).

% sndOp_def
thf(fact_810_exI__realizer,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Y: A,X: B] :
      ( ( P @ Y @ X )
     => ( P @ ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) ) @ ( product_fst @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) ) ) ) ).

% exI_realizer
thf(fact_811_conjI__realizer,axiom,
    ! [A: $tType,B: $tType,P: A > $o,P4: A,Q: B > $o,Q4: B] :
      ( ( P @ P4 )
     => ( ( Q @ Q4 )
       => ( ( P @ ( product_fst @ A @ B @ ( product_Pair @ A @ B @ P4 @ Q4 ) ) )
          & ( Q @ ( product_snd @ A @ B @ ( product_Pair @ A @ B @ P4 @ Q4 ) ) ) ) ) ) ).

% conjI_realizer
thf(fact_812_BNF__Greatest__Fixpoint_Osubst__Pair,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,X: A,Y: B,A3: product_prod @ A @ B] :
      ( ( P @ X @ Y )
     => ( ( A3
          = ( product_Pair @ A @ B @ X @ Y ) )
       => ( P @ ( product_fst @ A @ B @ A3 ) @ ( product_snd @ A @ B @ A3 ) ) ) ) ).

% BNF_Greatest_Fixpoint.subst_Pair
thf(fact_813_fst__fstOp,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: A > C > $o,Q: C > B > $o] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ A @ C ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ C ) @ ( bNF_fstOp @ A @ C @ B @ P @ Q ) ) ) ).

% fst_fstOp
thf(fact_814_pair__in__swap__image,axiom,
    ! [A: $tType,B: $tType,Y: A,X: B,A4: set @ ( product_prod @ B @ A )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ X ) @ ( image2 @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ A4 ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y ) @ A4 ) ) ).

% pair_in_swap_image
thf(fact_815_prod_Oswap__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_swap @ A @ B )
      = ( ^ [P6: product_prod @ A @ B] : ( product_Pair @ B @ A @ ( product_snd @ A @ B @ P6 ) @ ( product_fst @ A @ B @ P6 ) ) ) ) ).

% prod.swap_def
thf(fact_816_map__prod__o__convol__id,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: C > A,G: C > B,X: C] :
      ( ( comp @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B ) @ C @ ( product_map_prod @ C @ A @ B @ B @ F @ ( id @ B ) ) @ ( bNF_convol @ C @ C @ B @ ( id @ C ) @ G ) @ X )
      = ( bNF_convol @ C @ A @ B @ ( comp @ A @ A @ C @ ( id @ A ) @ F ) @ G @ X ) ) ).

% map_prod_o_convol_id
thf(fact_817_prod_Osize__gen__o__map,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: C > nat,Fa: D > nat,G: A > C,Ga: B > D] :
      ( ( comp @ ( product_prod @ C @ D ) @ nat @ ( product_prod @ A @ B ) @ ( basic_BNF_size_prod @ C @ D @ F @ Fa ) @ ( product_map_prod @ A @ C @ B @ D @ G @ Ga ) )
      = ( basic_BNF_size_prod @ A @ B @ ( comp @ C @ nat @ A @ F @ G ) @ ( comp @ D @ nat @ B @ Fa @ Ga ) ) ) ).

% prod.size_gen_o_map
thf(fact_818_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q4: A,R4: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q4 @ R4 ) )
          = ( R4
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_819_id__comp,axiom,
    ! [B: $tType,A: $tType,G: A > B] :
      ( ( comp @ B @ B @ A @ ( id @ B ) @ G )
      = G ) ).

% id_comp
thf(fact_820_comp__id,axiom,
    ! [B: $tType,A: $tType,F: A > B] :
      ( ( comp @ A @ B @ A @ F @ ( id @ A ) )
      = F ) ).

% comp_id
thf(fact_821_fun_Omap__id,axiom,
    ! [A: $tType,D: $tType,T4: D > A] :
      ( ( comp @ A @ A @ D @ ( id @ A ) @ T4 )
      = T4 ) ).

% fun.map_id
thf(fact_822_swap__simp,axiom,
    ! [A: $tType,B: $tType,X: B,Y: A] :
      ( ( product_swap @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) )
      = ( product_Pair @ A @ B @ Y @ X ) ) ).

% swap_simp
thf(fact_823_group__add__class_Ominus__comp__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( comp @ A @ A @ A @ ( uminus_uminus @ A ) @ ( uminus_uminus @ A ) )
        = ( id @ A ) ) ) ).

% group_add_class.minus_comp_minus
thf(fact_824_boolean__algebra__class_Ominus__comp__minus,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( comp @ A @ A @ A @ ( uminus_uminus @ A ) @ ( uminus_uminus @ A ) )
        = ( id @ A ) ) ) ).

% boolean_algebra_class.minus_comp_minus
thf(fact_825_swap__comp__swap,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ ( product_swap @ A @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) ).

% swap_comp_swap
thf(fact_826_fun_Omap__id0,axiom,
    ! [A: $tType,D: $tType] :
      ( ( comp @ A @ A @ D @ ( id @ A ) )
      = ( id @ ( D > A ) ) ) ).

% fun.map_id0
thf(fact_827_comp__eq__id__dest,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: C > B,B2: A > C,C2: A > B,V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B2 )
        = ( comp @ B @ B @ A @ ( id @ B ) @ C2 ) )
     => ( ( A3 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) ).

% comp_eq_id_dest
thf(fact_828_pointfree__idE,axiom,
    ! [B: $tType,A: $tType,F: B > A,G: A > B,X: A] :
      ( ( ( comp @ B @ A @ A @ F @ G )
        = ( id @ A ) )
     => ( ( F @ ( G @ X ) )
        = X ) ) ).

% pointfree_idE
thf(fact_829_type__copy__Rep__o__Abs,axiom,
    ! [A: $tType,B: $tType,Rep: A > B,Abs: B > A] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( comp @ A @ B @ B @ Rep @ Abs )
        = ( id @ B ) ) ) ).

% type_copy_Rep_o_Abs
thf(fact_830_type__copy__Abs__o__Rep,axiom,
    ! [B: $tType,A: $tType,Rep: A > B,Abs: B > A] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( comp @ B @ A @ A @ Abs @ Rep )
        = ( id @ A ) ) ) ).

% type_copy_Abs_o_Rep
thf(fact_831_type__copy__map__id0,axiom,
    ! [B: $tType,A: $tType,Rep: A > B,Abs: B > A,M: B > B] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( M
          = ( id @ B ) )
       => ( ( comp @ B @ A @ A @ ( comp @ B @ A @ B @ Abs @ M ) @ Rep )
          = ( id @ A ) ) ) ) ).

% type_copy_map_id0
thf(fact_832_fstOp__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( bNF_fstOp @ A @ B @ C )
      = ( ^ [P3: A > B > $o,Q3: B > C > $o,Ac: product_prod @ A @ C] : ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Ac ) @ ( bNF_pick_middlep @ A @ B @ C @ P3 @ Q3 @ ( product_fst @ A @ C @ Ac ) @ ( product_snd @ A @ C @ Ac ) ) ) ) ) ).

% fstOp_def
thf(fact_833_inj__on__Un,axiom,
    ! [A: $tType,B: $tType,F: A > B,A4: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
      = ( ( inj_on @ A @ B @ F @ A4 )
        & ( inj_on @ A @ B @ F @ B3 )
        & ( ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) ) @ ( image2 @ A @ B @ F @ ( minus_minus @ ( set @ A ) @ B3 @ A4 ) ) )
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% inj_on_Un
thf(fact_834_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_835_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_836_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_837_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_838_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_839_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A3: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_840_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_841_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_842_relChain__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( bNF_Ca3754400796208372196lChain @ A @ B )
        = ( ^ [R5: set @ ( product_prod @ A @ A ),As8: A > B] :
            ! [I2: A,J: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ I2 @ J ) @ R5 )
             => ( ord_less_eq @ B @ ( As8 @ I2 ) @ ( As8 @ J ) ) ) ) ) ) ).

% relChain_def
thf(fact_843_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_844_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% compl_less_compl_iff
thf(fact_845_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_846_inj__on__empty,axiom,
    ! [B: $tType,A: $tType,F: A > B] : ( inj_on @ A @ B @ F @ ( bot_bot @ ( set @ A ) ) ) ).

% inj_on_empty
thf(fact_847_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( ord_less @ A @ B2 @ A3 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_848_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_less_0_iff_less
thf(fact_849_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_850_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_less_pos
thf(fact_851_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_852_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_imp_not_less
thf(fact_853_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( Y != X ) ) ) ).

% order_less_imp_not_eq2
thf(fact_854_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) ).

% order_less_imp_not_eq
thf(fact_855_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
          | ( X = Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_less_linear
thf(fact_856_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,P: $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ X )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_857_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_not_sym
thf(fact_858_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A3: A,B2: A,F: A > C,C2: C] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ C @ ( F @ B2 ) @ C2 )
           => ( ! [X2: A,Y3: A] :
                  ( ( ord_less @ A @ X2 @ Y3 )
                 => ( ord_less @ C @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ C @ ( F @ A3 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_859_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A3: A,F: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A3 @ ( F @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X2: B,Y3: B] :
                  ( ( ord_less @ B @ X2 @ Y3 )
                 => ( ord_less @ A @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_860_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) ).

% order_less_irrefl
thf(fact_861_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A3: A,B2: A,F: A > B,C2: B] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ( F @ B2 )
              = C2 )
           => ( ! [X2: A,Y3: A] :
                  ( ( ord_less @ A @ X2 @ Y3 )
                 => ( ord_less @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ B @ ( F @ A3 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_862_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A3: A,F: B > A,B2: B,C2: B] :
          ( ( A3
            = ( F @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X2: B,Y3: B] :
                  ( ( ord_less @ B @ X2 @ Y3 )
                 => ( ord_less @ A @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_863_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_less_trans
thf(fact_864_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A3 ) ) ) ).

% order_less_asym'
thf(fact_865_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ( X != Y ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neq_iff
thf(fact_866_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_asym
thf(fact_867_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neqE
thf(fact_868_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( A3 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_869_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( A3 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_870_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_871_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Y @ X )
            | ( X = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_872_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_873_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A3: A,B2: A] :
          ( ! [A8: A,B6: A] :
              ( ( ord_less @ A @ A8 @ B6 )
             => ( P @ A8 @ B6 ) )
         => ( ! [A8: A] : ( P @ A8 @ A8 )
           => ( ! [A8: A,B6: A] :
                  ( ( P @ B6 @ A8 )
                 => ( P @ A8 @ B6 ) )
             => ( P @ A3 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_874_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P8: A > $o] :
            ? [X7: A] : ( P8 @ X7 ) )
        = ( ^ [P3: A > $o] :
            ? [N5: A] :
              ( ( P3 @ N5 )
              & ! [M3: A] :
                  ( ( ord_less @ A @ M3 @ N5 )
                 => ~ ( P3 @ M3 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_875_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ A3 @ A3 ) ) ).

% dual_order.irrefl
thf(fact_876_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ~ ( ord_less @ A @ A3 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_877_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( X != Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_cases
thf(fact_878_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less @ A @ Y @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv3
thf(fact_879_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A3: A] :
          ( ! [X2: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ A @ Y5 @ X2 )
                 => ( P @ Y5 ) )
             => ( P @ X2 ) )
         => ( P @ A3 ) ) ) ).

% less_induct
thf(fact_880_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_881_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_882_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A3 ) ) ) ).

% order.asym
thf(fact_883_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) ).

% less_imp_neq
thf(fact_884_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [Z3: A] :
              ( ( ord_less @ A @ X @ Z3 )
              & ( ord_less @ A @ Z3 @ Y ) ) ) ) ).

% dense
thf(fact_885_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X: A] :
        ? [X_1: A] : ( ord_less @ A @ X @ X_1 ) ) ).

% gt_ex
thf(fact_886_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X: A] :
        ? [Y3: A] : ( ord_less @ A @ Y3 @ X ) ) ).

% lt_ex
thf(fact_887_fun_Oinj__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,F: A > B] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( D > A ) @ ( D > B ) @ ( comp @ A @ B @ D @ F ) @ ( top_top @ ( set @ ( D > A ) ) ) ) ) ).

% fun.inj_map
thf(fact_888_inj__on__imageI2,axiom,
    ! [B: $tType,C: $tType,A: $tType,F11: C > B,F: A > C,A4: set @ A] :
      ( ( inj_on @ A @ B @ ( comp @ C @ B @ A @ F11 @ F ) @ A4 )
     => ( inj_on @ A @ C @ F @ A4 ) ) ).

% inj_on_imageI2
thf(fact_889_inj__on__Int,axiom,
    ! [B: $tType,A: $tType,F: A > B,A4: set @ A,B3: set @ A] :
      ( ( ( inj_on @ A @ B @ F @ A4 )
        | ( inj_on @ A @ B @ F @ B3 ) )
     => ( inj_on @ A @ B @ F @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ).

% inj_on_Int
thf(fact_890_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ X @ Y )
            | ( X = Y ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_891_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_le_less_linear
thf(fact_892_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A3: A,B2: A,F: A > C,C2: C] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ C @ ( F @ B2 ) @ C2 )
           => ( ! [X2: A,Y3: A] :
                  ( ( ord_less @ A @ X2 @ Y3 )
                 => ( ord_less @ C @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ C @ ( F @ A3 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_893_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A3: A,F: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A3 @ ( F @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_894_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A3: A,B2: A,F: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ C @ ( F @ B2 ) @ C2 )
           => ( ! [X2: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y3 )
                 => ( ord_less_eq @ C @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ C @ ( F @ A3 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_895_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A3: A,F: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X2: B,Y3: B] :
                  ( ( ord_less @ B @ X2 @ Y3 )
                 => ( ord_less @ A @ ( F @ X2 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_896_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_less_le_trans
thf(fact_897_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_le_less_trans
thf(fact_898_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( A3 != B2 )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_899_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( A3 != B2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_900_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_less_imp_le
thf(fact_901_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_not_less
thf(fact_902_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_not_le
thf(fact_903_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X3: A,Y2: A] :
              ( ( ord_less_eq @ A @ X3 @ Y2 )
              & ( X3 != Y2 ) ) ) ) ) ).

% order_less_le
thf(fact_904_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X3: A,Y2: A] :
              ( ( ord_less @ A @ X3 @ Y2 )
              | ( X3 = Y2 ) ) ) ) ) ).

% order_le_less
thf(fact_905_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_906_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_907_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ~ ( ord_less_eq @ A @ A5 @ B4 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_908_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_909_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_910_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ( A5 != B4 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_911_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less @ A @ B4 @ A5 )
              | ( A5 = B4 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_912_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ! [W: A] :
                ( ( ord_less @ A @ X @ W )
               => ( ( ord_less @ A @ W @ Y )
                 => ( ord_less_eq @ A @ W @ Z2 ) ) )
           => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% dense_le_bounded
thf(fact_913_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ( ! [W: A] :
                ( ( ord_less @ A @ Z2 @ W )
               => ( ( ord_less @ A @ W @ X )
                 => ( ord_less_eq @ A @ Y @ W ) ) )
           => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% dense_ge_bounded
thf(fact_914_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ~ ( ord_less_eq @ A @ B4 @ A5 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_915_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_916_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_917_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ( A5 != B4 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_918_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less @ A @ A5 @ B4 )
              | ( A5 = B4 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_919_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y @ X )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% not_le_imp_less
thf(fact_920_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X3: A,Y2: A] :
              ( ( ord_less_eq @ A @ X3 @ Y2 )
              & ~ ( ord_less_eq @ A @ Y2 @ X3 ) ) ) ) ) ).

% less_le_not_le
thf(fact_921_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y: A,Z2: A] :
          ( ! [X2: A] :
              ( ( ord_less @ A @ X2 @ Y )
             => ( ord_less_eq @ A @ X2 @ Z2 ) )
         => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ).

% dense_le
thf(fact_922_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,Y: A] :
          ( ! [X2: A] :
              ( ( ord_less @ A @ Z2 @ X2 )
             => ( ord_less_eq @ A @ Y @ X2 ) )
         => ( ord_less_eq @ A @ Y @ Z2 ) ) ) ).

% dense_ge
thf(fact_923_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv2
thf(fact_924_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% antisym_conv1
thf(fact_925_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A3 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A3 @ B2 )
            | ( A3 = B2 ) ) ) ) ).

% nless_le
thf(fact_926_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% leI
thf(fact_927_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ~ ( ord_less @ A @ X @ Y ) ) ) ).

% leD
thf(fact_928_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( ( N
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_929_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M4: A,N: A] :
          ( ( ord_less @ A @ M4 @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_930_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_931_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) ).

% gr_zeroI
thf(fact_932_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_933_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_934_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A3 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_935_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A3 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_936_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_937_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ A3 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_938_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A3: A] :
          ( ( ( A3
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A3 ) ) ) ).

% bot.not_eq_extremum
thf(fact_939_not__psubset__empty,axiom,
    ! [A: $tType,A4: set @ A] :
      ~ ( ord_less @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) ) ).

% not_psubset_empty
thf(fact_940_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_less_swap2
thf(fact_941_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_less_swap1
thf(fact_942_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A3 ) ) ) ).

% minus_less_iff
thf(fact_943_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% less_minus_iff
thf(fact_944_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A3: A] :
          ( ( ( A3
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A3 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_945_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A3 ) ) ).

% top.extremum_strict
thf(fact_946_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_947_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A3 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_948_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( inf_inf @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_949_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A3 @ B2 )
             => ~ ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_950_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_951_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% inf.absorb3
thf(fact_952_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A3: A] :
          ( ( ord_less @ A @ B2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X ) ) ) ).

% less_infI2
thf(fact_953_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,X: A,B2: A] :
          ( ( ord_less @ A @ A3 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X ) ) ) ).

% less_infI1
thf(fact_954_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( ord_less @ A @ X @ A3 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_955_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A3: A] :
          ( ( ord_less @ A @ X @ B2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_956_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% sup.absorb3
thf(fact_957_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_958_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less @ A @ B2 @ A3 )
             => ~ ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_959_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( A5
                = ( sup_sup @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_960_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A3 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_961_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_962_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F2: A > B,G2: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F2 @ G2 )
              & ~ ( ord_less_eq @ ( A > B ) @ G2 @ F2 ) ) ) ) ) ).

% less_fun_def
thf(fact_963_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A3 ) @ A4 ) ) ) ).

% inj_on_mult
thf(fact_964_comp__inj__on,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: A > B,A4: set @ A,G: B > C] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( inj_on @ B @ C @ G @ ( image2 @ A @ B @ F @ A4 ) )
       => ( inj_on @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ A4 ) ) ) ).

% comp_inj_on
thf(fact_965_inj__on__imageI,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: C > B,F: A > C,A4: set @ A] :
      ( ( inj_on @ A @ B @ ( comp @ C @ B @ A @ G @ F ) @ A4 )
     => ( inj_on @ C @ B @ G @ ( image2 @ A @ C @ F @ A4 ) ) ) ).

% inj_on_imageI
thf(fact_966_comp__inj__on__iff,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: A > B,A4: set @ A,F11: B > C] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( inj_on @ B @ C @ F11 @ ( image2 @ A @ B @ F @ A4 ) )
        = ( inj_on @ A @ C @ ( comp @ B @ C @ A @ F11 @ F ) @ A4 ) ) ) ).

% comp_inj_on_iff
thf(fact_967_inj__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: A > B,G: C > A] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( ( inj_on @ C @ A @ G @ ( top_top @ ( set @ C ) ) )
       => ( inj_on @ C @ B @ ( comp @ A @ B @ C @ F @ G ) @ ( top_top @ ( set @ C ) ) ) ) ) ).

% inj_compose
thf(fact_968_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_969_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A3 @ A3 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_970_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_971_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_972_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_973_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_974_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_975_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_976_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_977_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A3 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_978_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_979_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_980_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_981_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_982_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_983_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_984_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_985_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_986_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_987_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_988_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_989_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_990_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] : ( ord_less @ A @ ( minus_minus @ A @ A5 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_991_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M4: A,N: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M4 @ N ) ) ) ) ) ).

% less_1_mult
thf(fact_992_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_993_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_994_less__assn__def,axiom,
    ( ( ord_less @ assn )
    = ( ^ [A5: assn,B4: assn] :
          ( ( ord_less_eq @ assn @ A5 @ B4 )
          & ( A5 != B4 ) ) ) ) ).

% less_assn_def
thf(fact_995_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F: A > B,C3: set @ A,A4: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ C3 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C3 )
         => ( ( image2 @ A @ B @ F @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
            = ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F @ A4 ) @ ( image2 @ A @ B @ F @ B3 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_996_image__Int,axiom,
    ! [B: $tType,A: $tType,F: A > B,A4: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( ( image2 @ A @ B @ F @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
        = ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F @ A4 ) @ ( image2 @ A @ B @ F @ B3 ) ) ) ) ).

% image_Int
thf(fact_997_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_998_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_999_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_1000_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_1001_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_1002_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_1003_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_1004_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_1005_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_1006_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_1007_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_1008_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_1009_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_1010_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_1011_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_1012_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_1013_disjoint__alt__simp3,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) @ A4 )
      = ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjoint_alt_simp3
thf(fact_1014_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A3: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A3 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_1015_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z3 )
             => ( ( ord_less @ A @ Z3 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z3 @ X ) @ Y ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_mult_one_interval
thf(fact_1016_inj__on__iff__surj,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,A11: set @ B] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [F2: A > B] :
              ( ( inj_on @ A @ B @ F2 @ A4 )
              & ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ A4 ) @ A11 ) ) )
        = ( ? [G2: B > A] :
              ( ( image2 @ B @ A @ G2 @ A11 )
              = A4 ) ) ) ) ).

% inj_on_iff_surj
thf(fact_1017_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ Z2 ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_1018_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ X ) @ ( times_times @ A @ Z2 @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_1019_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ Z2 ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% mult_less_iff1
thf(fact_1020_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_1021_the__inv__f__o__f__id,axiom,
    ! [B: $tType,A: $tType,F: A > B,Z2: A] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( ( comp @ B @ A @ A @ ( the_inv_into @ A @ B @ ( top_top @ ( set @ A ) ) @ F ) @ F @ Z2 )
        = ( id @ A @ Z2 ) ) ) ).

% the_inv_f_o_f_id
thf(fact_1022_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A3 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_1023_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_1024_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( sgn_sgn @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_1025_semilattice__neutr__order_Oeq__neutr__iff,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semila1105856199041335345_order @ A @ F @ Z2 @ Less_eq @ Less )
     => ( ( ( F @ A3 @ B2 )
          = Z2 )
        = ( ( A3 = Z2 )
          & ( B2 = Z2 ) ) ) ) ).

% semilattice_neutr_order.eq_neutr_iff
thf(fact_1026_semilattice__neutr__order_Oneutr__eq__iff,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semila1105856199041335345_order @ A @ F @ Z2 @ Less_eq @ Less )
     => ( ( Z2
          = ( F @ A3 @ B2 ) )
        = ( ( A3 = Z2 )
          & ( B2 = Z2 ) ) ) ) ).

% semilattice_neutr_order.neutr_eq_iff
thf(fact_1027_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A3 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_1028_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_1029_semilattice__neutr__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semila1105856199041335345_order @ A @ F @ Z2 @ Less_eq @ Less )
     => ( semilattice_neutr @ A @ F @ Z2 ) ) ).

% semilattice_neutr_order.axioms(1)
thf(fact_1030_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ( sgn_sgn @ A @ A3 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% sgn_1_pos
thf(fact_1031_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ( sgn_sgn @ A @ A3 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_1032_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X3: A] :
              ( if @ A
              @ ( X3
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X3 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_1033_the__inv__into__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: A > B,G: C > A,A4: set @ C,X: B] :
      ( ( inj_on @ A @ B @ F @ ( image2 @ C @ A @ G @ A4 ) )
     => ( ( inj_on @ C @ A @ G @ A4 )
       => ( ( member @ B @ X @ ( image2 @ A @ B @ F @ ( image2 @ C @ A @ G @ A4 ) ) )
         => ( ( the_inv_into @ C @ B @ A4 @ ( comp @ A @ B @ C @ F @ G ) @ X )
            = ( comp @ A @ C @ B @ ( the_inv_into @ C @ A @ A4 @ G ) @ ( the_inv_into @ A @ B @ ( image2 @ C @ A @ G @ A4 ) @ F ) @ X ) ) ) ) ) ).

% the_inv_into_comp
thf(fact_1034_top_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ( ordering_top @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ A ) ) ) ).

% top.ordering_top_axioms
thf(fact_1035_inj__on__insert,axiom,
    ! [B: $tType,A: $tType,F: A > B,A3: A,A4: set @ A] :
      ( ( inj_on @ A @ B @ F @ ( insert2 @ A @ A3 @ A4 ) )
      = ( ( inj_on @ A @ B @ F @ A4 )
        & ~ ( member @ B @ ( F @ A3 ) @ ( image2 @ A @ B @ F @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% inj_on_insert
thf(fact_1036_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X: A,A3: A,Y: A,U: A,V: A] :
          ( ( ord_less @ A @ X @ A3 )
         => ( ( ord_less @ A @ Y @ A3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V @ Y ) ) @ A3 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_1037_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_1038_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_1039_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_1040_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_1041_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_1042_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_1043_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = ( plus_plus @ A @ C2 @ A3 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_1044_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ A3 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_1045_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_1046_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_1047_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% add_0
thf(fact_1048_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X @ Y ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_1049_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ X @ Y )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_1050_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ A3 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_1051_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ B2 @ A3 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_1052_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = A3 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_1053_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A3: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = A3 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_1054_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A3 @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_1055_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% add.right_neutral
thf(fact_1056_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_1057_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_1058_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = A3 ) ) ).

% add_diff_cancel_right'
thf(fact_1059_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A3 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_1060_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ A3 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_1061_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A3 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_1062_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ B2 )
          = A3 ) ) ).

% diff_add_cancel
thf(fact_1063_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = A3 ) ) ).

% add_diff_cancel
thf(fact_1064_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_1065_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ ( plus_plus @ A @ A3 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_1066_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ A3 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_1067_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_1068_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_1069_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_1070_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_1071_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% div_by_1
thf(fact_1072_singletonI,axiom,
    ! [A: $tType,A3: A] : ( member @ A @ A3 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% singletonI
thf(fact_1073_Int__insert__left__if0,axiom,
    ! [A: $tType,A3: A,C3: set @ A,B3: set @ A] :
      ( ~ ( member @ A @ A3 @ C3 )
     => ( ( inf_inf @ ( set @ A ) @ ( insert2 @ A @ A3 @ B3 ) @ C3 )
        = ( inf_inf @ ( set @ A ) @ B3 @ C3 ) ) ) ).

% Int_insert_left_if0
thf(fact_1074_Int__insert__left__if1,axiom,
    ! [A: $tType,A3: A,C3: set @ A,B3: set @ A] :
      ( ( member @ A @ A3 @ C3 )
     => ( ( inf_inf @ ( set @ A ) @ ( insert2 @ A @ A3 @ B3 ) @ C3 )
        = ( insert2 @ A @ A3 @ ( inf_inf @ ( set @ A ) @ B3 @ C3 ) ) ) ) ).

% Int_insert_left_if1
thf(fact_1075_insert__inter__insert,axiom,
    ! [A: $tType,A3: A,A4: set @ A,B3: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( insert2 @ A @ A3 @ A4 ) @ ( insert2 @ A @ A3 @ B3 ) )
      = ( insert2 @ A @ A3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ).

% insert_inter_insert
thf(fact_1076_Int__insert__right__if0,axiom,
    ! [A: $tType,A3: A,A4: set @ A,B3: set @ A] :
      ( ~ ( member @ A @ A3 @ A4 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ B3 ) )
        = ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ).

% Int_insert_right_if0
thf(fact_1077_Int__insert__right__if1,axiom,
    ! [A: $tType,A3: A,A4: set @ A,B3: set @ A] :
      ( ( member @ A @ A3 @ A4 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ B3 ) )
        = ( insert2 @ A @ A3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% Int_insert_right_if1
thf(fact_1078_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ A3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_1079_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_1080_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( plus_plus @ A @ B2 @ A3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_1081_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_1082_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_1083_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_1084_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_1085_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_1086_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_1087_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( plus_plus @ A @ B2 @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_1088_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_1089_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_1090_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_1091_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_1092_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( uminus_uminus @ A @ A3 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_1093_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ A3 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_1094_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ B2 )
            = A3 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_1095_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_1096_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_1097_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_1098_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_1099_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_1100_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A3 @ A3 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_1101_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_1102_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_1103_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A3 ) )
          = ( ( A3
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_1104_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ A3 )
            = ( one_one @ A ) )
          = ( ( A3
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_1105_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( ( A3
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A3 @ A3 )
              = ( zero_zero @ A ) ) )
          & ( ( A3
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A3 @ A3 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_1106_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A3 @ A3 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_1107_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A3 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_1108_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( ( divide_divide @ A @ A3 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_1109_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A3 ) ) ) ).

% uminus_add_conv_diff
thf(fact_1110_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A3 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_1111_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( divide_divide @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X ) ) ) ).

% divide_minus1
thf(fact_1112_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A3: A,A4: set @ A] :
      ( ( ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert2 @ A @ A3 @ A4 ) )
      = ( ( A3 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq
thf(fact_1113_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A3: A,A4: set @ A,B2: A] :
      ( ( ( insert2 @ A @ A3 @ A4 )
        = ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A3 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq'
thf(fact_1114_disjoint__insert_I2_J,axiom,
    ! [A: $tType,A4: set @ A,B2: A,B3: set @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( inf_inf @ ( set @ A ) @ A4 @ ( insert2 @ A @ B2 @ B3 ) ) )
      = ( ~ ( member @ A @ B2 @ A4 )
        & ( ( bot_bot @ ( set @ A ) )
          = ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% disjoint_insert(2)
thf(fact_1115_disjoint__insert_I1_J,axiom,
    ! [A: $tType,B3: set @ A,A3: A,A4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ B3 @ ( insert2 @ A @ A3 @ A4 ) )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ~ ( member @ A @ A3 @ B3 )
        & ( ( inf_inf @ ( set @ A ) @ B3 @ A4 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjoint_insert(1)
thf(fact_1116_insert__disjoint_I2_J,axiom,
    ! [A: $tType,A3: A,A4: set @ A,B3: set @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( inf_inf @ ( set @ A ) @ ( insert2 @ A @ A3 @ A4 ) @ B3 ) )
      = ( ~ ( member @ A @ A3 @ B3 )
        & ( ( bot_bot @ ( set @ A ) )
          = ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% insert_disjoint(2)
thf(fact_1117_insert__disjoint_I1_J,axiom,
    ! [A: $tType,A3: A,A4: set @ A,B3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( insert2 @ A @ A3 @ A4 ) @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ~ ( member @ A @ A3 @ B3 )
        & ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% insert_disjoint(1)
thf(fact_1118_insert__Diff__single,axiom,
    ! [A: $tType,A3: A,A4: set @ A] :
      ( ( insert2 @ A @ A3 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert2 @ A @ A3 @ A4 ) ) ).

% insert_Diff_single
thf(fact_1119_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( divide_divide @ A @ A3 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A3 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_1120_the__elem__eq,axiom,
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = X ) ).

% the_elem_eq
thf(fact_1121_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_1122_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_1123_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_1124_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_1125_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_1126_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_1127_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_1128_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_1129_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_1130_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_1131_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ A3 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_1132_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A3 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A3 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_1133_subset__Compl__singleton,axiom,
    ! [A: $tType,A4: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B2 @ A4 ) ) ) ).

% subset_Compl_singleton
thf(fact_1134_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_1135_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_1136_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_1137_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_1138_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = ( plus_plus @ A @ C2 @ A3 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_1139_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ A3 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_1140_ab__semigroup__add__class_Oadd_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add.left_commute
thf(fact_1141_ab__semigroup__add__class_Oadd_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ B4 @ A5 ) ) ) ) ).

% ab_semigroup_add_class.add.commute
thf(fact_1142_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = ( plus_plus @ A @ C2 @ A3 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_1143_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ A3 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_1144_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_1145_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A3 @ B3 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_1146_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: A,K: A,A3: A,B2: A] :
          ( ( A4
            = ( plus_plus @ A @ K @ A3 ) )
         => ( ( plus_plus @ A @ A4 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_1147_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( I = J2 )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_1148_add_Oright__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% add.right_commute
thf(fact_1149_add_Oright__assoc,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.right_assoc
thf(fact_1150_ordering__top_Oextremum__uniqueI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A3: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ( Less_eq @ Top @ A3 )
       => ( A3 = Top ) ) ) ).

% ordering_top.extremum_uniqueI
thf(fact_1151_ordering__top_Onot__eq__extremum,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A3: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ( ( A3 != Top ) )
        = ( Less @ A3 @ Top ) ) ) ).

% ordering_top.not_eq_extremum
thf(fact_1152_ordering__top_Oextremum__unique,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A3: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ( Less_eq @ Top @ A3 )
        = ( A3 = Top ) ) ) ).

% ordering_top.extremum_unique
thf(fact_1153_ordering__top_Oextremum__strict,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A3: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ~ ( Less @ Top @ A3 ) ) ).

% ordering_top.extremum_strict
thf(fact_1154_ordering__top_Oextremum,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A3: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( Less_eq @ A3 @ Top ) ) ).

% ordering_top.extremum
thf(fact_1155_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_1156_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A3 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_1157_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_1158_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z2 @ Y ) ) @ Y ) ) ) ) ).

% add_frac_num
thf(fact_1159_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z2 @ Y ) ) @ Y ) ) ) ) ).

% add_num_frac
thf(fact_1160_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X @ ( divide_divide @ A @ Y @ Z2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z2 ) @ Y ) @ Z2 ) ) ) ) ).

% add_divide_eq_iff
thf(fact_1161_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Z2 ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_add_eq_iff
thf(fact_1162_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ A3 @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_1163_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_1164_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_1165_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_1166_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
            ? [C5: A] :
              ( B4
              = ( plus_plus @ A @ A5 @ C5 ) ) ) ) ) ).

% le_iff_add
thf(fact_1167_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_1168_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ~ ! [C4: A] :
                ( B2
               != ( plus_plus @ A @ A3 @ C4 ) ) ) ) ).

% less_eqE
thf(fact_1169_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_1170_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_1171_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_1172_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( I = J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_1173_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J2 )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_1174_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% add.group_left_neutral
thf(fact_1175_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% add.comm_neutral
thf(fact_1176_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_1177_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z2: A,W2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z2 @ W2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ W2 ) ) ) ) ).

% times_divide_times_eq
thf(fact_1178_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z2: A,W2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z2 @ W2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ W2 ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ).

% divide_divide_times_eq
thf(fact_1179_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_1180_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_1181_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_1182_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_1183_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_1184_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_1185_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J2 )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_1186_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( I = J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_1187_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_1188_singleton__inject,axiom,
    ! [A: $tType,A3: A,B2: A] :
      ( ( ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A3 = B2 ) ) ).

% singleton_inject
thf(fact_1189_insert__not__empty,axiom,
    ! [A: $tType,A3: A,A4: set @ A] :
      ( ( insert2 @ A @ A3 @ A4 )
     != ( bot_bot @ ( set @ A ) ) ) ).

% insert_not_empty
thf(fact_1190_doubleton__eq__iff,axiom,
    ! [A: $tType,A3: A,B2: A,C2: A,D2: A] :
      ( ( ( insert2 @ A @ A3 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert2 @ A @ C2 @ ( insert2 @ A @ D2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A3 = C2 )
          & ( B2 = D2 ) )
        | ( ( A3 = D2 )
          & ( B2 = C2 ) ) ) ) ).

% doubleton_eq_iff
thf(fact_1191_singleton__iff,axiom,
    ! [A: $tType,B2: A,A3: A] :
      ( ( member @ A @ B2 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B2 = A3 ) ) ).

% singleton_iff
thf(fact_1192_singletonD,axiom,
    ! [A: $tType,B2: A,A3: A] :
      ( ( member @ A @ B2 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B2 = A3 ) ) ).

% singletonD
thf(fact_1193_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_1194_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_1195_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_1196_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_1197_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_1198_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A3: A,E2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ E2 ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_1199_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_1200_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A3 )
         => ( C2
            = ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_1201_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_1202_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_1203_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_1204_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_1205_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( A3
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A3 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_1206_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = C2 )
          = ( A3
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_1207_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,K: A,A3: A,B2: A] :
          ( ( A4
            = ( plus_plus @ A @ K @ A3 ) )
         => ( ( minus_minus @ A @ A4 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_1208_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_1209_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,K: A,A3: A] :
          ( ( A4
            = ( plus_plus @ A @ K @ A3 ) )
         => ( ( uminus_uminus @ A @ A4 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_1210_Int__insert__left,axiom,
    ! [A: $tType,A3: A,C3: set @ A,B3: set @ A] :
      ( ( ( member @ A @ A3 @ C3 )
       => ( ( inf_inf @ ( set @ A ) @ ( insert2 @ A @ A3 @ B3 ) @ C3 )
          = ( insert2 @ A @ A3 @ ( inf_inf @ ( set @ A ) @ B3 @ C3 ) ) ) )
      & ( ~ ( member @ A @ A3 @ C3 )
       => ( ( inf_inf @ ( set @ A ) @ ( insert2 @ A @ A3 @ B3 ) @ C3 )
          = ( inf_inf @ ( set @ A ) @ B3 @ C3 ) ) ) ) ).

% Int_insert_left
thf(fact_1211_Int__insert__right,axiom,
    ! [A: $tType,A3: A,A4: set @ A,B3: set @ A] :
      ( ( ( member @ A @ A3 @ A4 )
       => ( ( inf_inf @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ B3 ) )
          = ( insert2 @ A @ A3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) )
      & ( ~ ( member @ A @ A3 @ A4 )
       => ( ( inf_inf @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ B3 ) )
          = ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% Int_insert_right
thf(fact_1212_add_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ( semigroup @ A @ ( plus_plus @ A ) ) ) ).

% add.semigroup_axioms
thf(fact_1213_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_1214_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z2 ) ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_1215_add_Osafe__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [X: A,Y: A,A3: A,B2: A] :
          ( ( syntax7388354845996824322omatch @ A @ A @ ( plus_plus @ A @ X @ Y ) @ A3 )
         => ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ B2 @ A3 ) ) ) ) ).

% add.safe_commute
thf(fact_1216_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V: A,R4: A,S: A] :
          ( ( ord_less_eq @ A @ U @ V )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R4 )
           => ( ( ord_less_eq @ A @ R4 @ S )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R4 @ ( minus_minus @ A @ V @ U ) ) @ S ) ) @ V ) ) ) ) ) ).

% scaling_mono
thf(fact_1217_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X @ Y )
                = ( divide_divide @ A @ W2 @ Z2 ) )
              = ( ( times_times @ A @ X @ Z2 )
                = ( times_times @ A @ W2 @ Y ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_1218_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A3 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A3 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_1219_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_1220_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A3 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A3 ) ) ) ) ).

% divide_eq_imp
thf(fact_1221_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A3 @ C2 )
              = B2 )
           => ( A3
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_1222_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A3 )
            = ( B2
              = ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_1223_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A3
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A3 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_1224_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A3 @ B2 )
              = ( one_one @ A ) )
            = ( A3 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_1225_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_1226_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_1227_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_1228_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_1229_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A3 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_1230_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_1231_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_1232_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_1233_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J2 )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_1234_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J2 )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J2 @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_1235_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_1236_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_1237_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_1238_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_1239_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ! [C4: A] :
                ( ( B2
                  = ( plus_plus @ A @ A3 @ C4 ) )
               => ( C4
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_1240_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_1241_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A3 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A3 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_1242_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ A3 @ ( minus_minus @ A @ B2 @ A3 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_1243_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A3 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_1244_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A3 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A3 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_1245_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A3 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_1246_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A3 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_1247_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A3 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_1248_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_1249_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% le_add_diff
thf(fact_1250_ordered__cancel__comm__monoid__diff__class_Odiff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A3 ) @ A3 )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add
thf(fact_1251_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_1252_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A3 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_1253_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A] : ( ord_less @ A @ A3 @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_1254_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_1255_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_1256_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( ord_less @ A @ A3 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_1257_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = B2 )
          = ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_1258_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_1259_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A3 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_1260_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_1261_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% add_eq_0_iff
thf(fact_1262_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ E2 ) @ C2 )
            = D2 ) ) ) ).

% eq_add_iff1
thf(fact_1263_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A3 ) @ E2 ) @ D2 ) ) ) ) ).

% eq_add_iff2
thf(fact_1264_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X: A,Y: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ A @ X @ Y ) ) ) ) ).

% square_diff_square_factored
thf(fact_1265_subset__singletonD,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        | ( A4
          = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singletonD
thf(fact_1266_subset__singleton__iff,axiom,
    ! [A: $tType,X5: set @ A,A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X5 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X5
          = ( bot_bot @ ( set @ A ) ) )
        | ( X5
          = ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singleton_iff
thf(fact_1267_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ A5 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_1268_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A5: A,B4: A] : ( plus_plus @ A @ A5 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_1269_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A3 @ B3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_1270_singleton__Un__iff,axiom,
    ! [A: $tType,X: A,A4: set @ A,B3: set @ A] :
      ( ( ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) )
        = ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
      = ( ( ( A4
            = ( bot_bot @ ( set @ A ) ) )
          & ( B3
            = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        | ( ( A4
            = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B3
            = ( bot_bot @ ( set @ A ) ) ) )
        | ( ( A4
            = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B3
            = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% singleton_Un_iff
thf(fact_1271_Un__singleton__iff,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,X: A] :
      ( ( ( sup_sup @ ( set @ A ) @ A4 @ B3 )
        = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( ( A4
            = ( bot_bot @ ( set @ A ) ) )
          & ( B3
            = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        | ( ( A4
            = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B3
            = ( bot_bot @ ( set @ A ) ) ) )
        | ( ( A4
            = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B3
            = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% Un_singleton_iff
thf(fact_1272_insert__is__Un,axiom,
    ! [A: $tType] :
      ( ( insert2 @ A )
      = ( ^ [A5: A] : ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% insert_is_Un
thf(fact_1273_Diff__insert,axiom,
    ! [A: $tType,A4: set @ A,A3: A,B3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ B3 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Diff_insert
thf(fact_1274_insert__Diff,axiom,
    ! [A: $tType,A3: A,A4: set @ A] :
      ( ( member @ A @ A3 @ A4 )
     => ( ( insert2 @ A @ A3 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A4 ) ) ).

% insert_Diff
thf(fact_1275_Diff__insert2,axiom,
    ! [A: $tType,A4: set @ A,A3: A,B3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ B3 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) ) ).

% Diff_insert2
thf(fact_1276_Diff__insert__absorb,axiom,
    ! [A: $tType,X: A,A4: set @ A] :
      ( ~ ( member @ A @ X @ A4 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert2 @ A @ X @ A4 ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = A4 ) ) ).

% Diff_insert_absorb
thf(fact_1277_insert__minus__eq,axiom,
    ! [A: $tType,X: A,Y: A,A4: set @ A] :
      ( ( X != Y )
     => ( ( minus_minus @ ( set @ A ) @ ( insert2 @ A @ X @ A4 ) @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert2 @ A @ X @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% insert_minus_eq
thf(fact_1278_set__minus__singleton__eq,axiom,
    ! [A: $tType,X: A,X5: set @ A] :
      ( ~ ( member @ A @ X @ X5 )
     => ( ( minus_minus @ ( set @ A ) @ X5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = X5 ) ) ).

% set_minus_singleton_eq
thf(fact_1279_in__image__insert__iff,axiom,
    ! [A: $tType,B3: set @ ( set @ A ),X: A,A4: set @ A] :
      ( ! [C6: set @ A] :
          ( ( member @ ( set @ A ) @ C6 @ B3 )
         => ~ ( member @ A @ X @ C6 ) )
     => ( ( member @ ( set @ A ) @ A4 @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( insert2 @ A @ X ) @ B3 ) )
        = ( ( member @ A @ X @ A4 )
          & ( member @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) ) ) ) ).

% in_image_insert_iff
thf(fact_1280_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,S: set @ A,T4: set @ A] :
          ( ( image2 @ A @ A @ ( plus_plus @ A @ A3 ) @ ( inf_inf @ ( set @ A ) @ S @ T4 ) )
          = ( inf_inf @ ( set @ A ) @ ( image2 @ A @ A @ ( plus_plus @ A @ A3 ) @ S ) @ ( image2 @ A @ A @ ( plus_plus @ A @ A3 ) @ T4 ) ) ) ) ).

% translation_Int
thf(fact_1281_add_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( monoid @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% add.monoid_axioms
thf(fact_1282_effect__bindI,axiom,
    ! [B: $tType,A: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat,G: A > ( heap_Time_Heap @ B ),H6: heap_ext @ product_unit,R6: B,N2: nat] :
      ( ( heap_Time_effect @ A @ F @ H2 @ H4 @ R4 @ N )
     => ( ( heap_Time_effect @ B @ ( G @ R4 ) @ H4 @ H6 @ R6 @ N2 )
       => ( heap_Time_effect @ B @ ( heap_Time_bind @ A @ B @ F @ G ) @ H2 @ H6 @ R6 @ ( plus_plus @ nat @ N @ N2 ) ) ) ) ).

% effect_bindI
thf(fact_1283_effect__bindE,axiom,
    ! [B: $tType,A: $tType,F: heap_Time_Heap @ B,G: B > ( heap_Time_Heap @ A ),H2: heap_ext @ product_unit,H6: heap_ext @ product_unit,R6: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( heap_Time_bind @ B @ A @ F @ G ) @ H2 @ H6 @ R6 @ N )
     => ~ ! [H5: heap_ext @ product_unit,R3: B,N1: nat] :
            ( ( heap_Time_effect @ B @ F @ H2 @ H5 @ R3 @ N1 )
           => ! [N22: nat] :
                ( ( heap_Time_effect @ A @ ( G @ R3 ) @ H5 @ H6 @ R6 @ N22 )
               => ( N
                 != ( plus_plus @ nat @ N1 @ N22 ) ) ) ) ) ).

% effect_bindE
thf(fact_1284_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X3: A] : ( plus_plus @ A @ ( plus_plus @ A @ X3 @ X3 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_1285_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_1286_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_1287_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_1288_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_1289_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_1290_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_1291_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_1292_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ X @ ( times_times @ A @ Z2 @ Y ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_1293_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ ( times_times @ A @ Z2 @ Y ) @ X )
           => ( ord_less @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_1294_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_1295_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_1296_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_1297_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ B2 @ A3 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_1298_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A3 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A3 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1299_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1300_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X @ ( divide_divide @ A @ Y @ Z2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ Y ) @ Z2 ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1301_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Z2 ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1302_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_1303_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_1304_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_1305_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_1306_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_1307_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_1308_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_1309_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_1310_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A3 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A3 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_1311_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A3 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_1312_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A3 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_1313_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( ( divide_divide @ A @ A3 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A3
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_1314_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_1315_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_1316_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_1317_le__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A3 ) @ E2 ) @ D2 ) ) ) ) ).

% le_add_iff2
thf(fact_1318_le__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% le_add_iff1
thf(fact_1319_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A3 ) @ E2 ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_1320_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_1321_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_1322_range__eq__singletonD,axiom,
    ! [B: $tType,A: $tType,F: B > A,A3: A,X: B] :
      ( ( ( image2 @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( F @ X )
        = A3 ) ) ).

% range_eq_singletonD
thf(fact_1323_Diff__single__insert,axiom,
    ! [A: $tType,A4: set @ A,X: A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ B3 ) ) ) ).

% Diff_single_insert
thf(fact_1324_subset__insert__iff,axiom,
    ! [A: $tType,A4: set @ A,X: A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ B3 ) )
      = ( ( ( member @ A @ X @ A4 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) )
        & ( ~ ( member @ A @ X @ A4 )
         => ( ord_less_eq @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% subset_insert_iff
thf(fact_1325_remove__subset,axiom,
    ! [A: $tType,X: A,S2: set @ A] :
      ( ( member @ A @ X @ S2 )
     => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ S2 ) ) ).

% remove_subset
thf(fact_1326_Compl__insert,axiom,
    ! [A: $tType,X: A,A4: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ X @ A4 ) )
      = ( minus_minus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Compl_insert
thf(fact_1327_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X3: A] : ( minus_minus @ A @ ( plus_plus @ A @ X3 @ X3 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_1328_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_1329_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ Y ) @ X )
           => ( ord_less_eq @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_1330_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ ( times_times @ A @ Z2 @ Y ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_1331_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_1332_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_1333_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_1334_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_1335_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_1336_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_1337_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_1338_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ A3 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A3 @ B2 ) )
            | ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_1339_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_1340_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1341_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z2 ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1342_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_1343_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_1344_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_1345_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_1346_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_1347_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_1348_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A3 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_1349_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A3 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_1350_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z2 ) ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_1351_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X: A,A3: A,Y: A,U: A,V: A] :
          ( ( ord_less_eq @ A @ X @ A3 )
         => ( ( ord_less_eq @ A @ Y @ A3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V @ Y ) ) @ A3 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_1352_psubset__insert__iff,axiom,
    ! [A: $tType,A4: set @ A,X: A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ B3 ) )
      = ( ( ( member @ A @ X @ B3 )
         => ( ord_less @ ( set @ A ) @ A4 @ B3 ) )
        & ( ~ ( member @ A @ X @ B3 )
         => ( ( ( member @ A @ X @ A4 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) )
            & ( ~ ( member @ A @ X @ A4 )
             => ( ord_less_eq @ ( set @ A ) @ A4 @ B3 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_1353_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_1354_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_1355_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A3 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_1356_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A3 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_1357_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A3 ) ) ) ).

% div_minus1_right
thf(fact_1358_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_1359_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_1360_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_1361_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% bits_div_by_1
thf(fact_1362_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1363_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1364_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_1365_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_1366_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R4: A,A3: A,B2: A,C2: A,D2: A] :
          ( ( R4
           != ( zero_zero @ A ) )
         => ( ( ( A3 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A3 @ ( times_times @ A @ R4 @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R4 @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_1367_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_1368_is__singleton__the__elem,axiom,
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A10: set @ A] :
            ( A10
            = ( insert2 @ A @ ( the_elem @ A @ A10 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% is_singleton_the_elem
thf(fact_1369_is__singletonI,axiom,
    ! [A: $tType,X: A] : ( is_singleton @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% is_singletonI
thf(fact_1370_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W2: A,Y: A,X: A,Z2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W2 @ Y ) @ ( times_times @ A @ X @ Z2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ W2 @ Z2 ) @ ( times_times @ A @ X @ Y ) ) )
          = ( ( W2 = X )
            | ( Y = Z2 ) ) ) ) ).

% crossproduct_eq
thf(fact_1371_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( A3 != B2 )
            & ( C2 != D2 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A3 @ D2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_1372_is__singletonI_H,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X2: A,Y3: A] :
            ( ( member @ A @ X2 @ A4 )
           => ( ( member @ A @ Y3 @ A4 )
             => ( X2 = Y3 ) ) )
       => ( is_singleton @ A @ A4 ) ) ) ).

% is_singletonI'
thf(fact_1373_is__singletonE,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( is_singleton @ A @ A4 )
     => ~ ! [X2: A] :
            ( A4
           != ( insert2 @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% is_singletonE
thf(fact_1374_is__singleton__def,axiom,
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A10: set @ A] :
          ? [X3: A] :
            ( A10
            = ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% is_singleton_def
thf(fact_1375_remove__def,axiom,
    ! [A: $tType] :
      ( ( remove @ A )
      = ( ^ [X3: A,A10: set @ A] : ( minus_minus @ ( set @ A ) @ A10 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% remove_def
thf(fact_1376_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_1377_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_1378_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y: B,A3: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ A3 )
         => ( ( times_times @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_1379_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y: B,C2: A,A3: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_1380_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y: B,C2: A,A3: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_1381_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y: B,A3: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ A3 )
         => ( ( times_times @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_1382_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A3: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_1383_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V: num,W2: num,Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Z2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W2 ) ) @ Z2 ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_1384_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M4: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M4 ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M4 @ N ) ) ) ) ).

% numeral_times_numeral
thf(fact_1385_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_1386_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A3: A,B2: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_1387_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_1388_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A3: A,B2: A,V: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_1389_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M4: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M4 @ N ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_1390_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M4: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M4 @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_1391_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M4: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M4 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M4 @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_1392_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) @ A3 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_1393_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W2: num] :
          ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W2 ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_1394_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W2: num,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) )
            = A3 )
          = ( ( ( ( numeral_numeral @ A @ W2 )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W2 ) ) ) )
            & ( ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_1395_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,W2: num] :
          ( ( A3
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ( numeral_numeral @ A @ W2 )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W2 ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_1396_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) @ A3 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_1397_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W2: num] :
          ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W2 ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_1398_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ A3 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_1399_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W2: num] :
          ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_1400_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W2: num,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
            = A3 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_1401_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,W2: num] :
          ( ( A3
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_1402_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ A3 )
          = ( ord_less @ A @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_1403_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W2: num] :
          ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_1404_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A3: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_1405_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% one_le_numeral
thf(fact_1406_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_1407_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_1408_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_1409_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_1410_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_1411_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M4 ) ) ) ).

% neg_one_le_numeral
thf(fact_1412_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_1413_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M4 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_1414_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_1415_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_1416_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_1417_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_1418_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M4 ) ) ) ).

% neg_one_less_numeral
thf(fact_1419_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M4 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_1420_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_1421_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_1422_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_1423_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W2 ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_1424_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_1425_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_1426_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W2 ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_1427_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_1428_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_1429_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_1430_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W2: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W2 ) ) ) @ Y ) ) ) ).

% semiring_norm(170)
thf(fact_1431_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W2: num,Y: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W2 ) ) ) @ Y ) ) ) ).

% semiring_norm(171)
thf(fact_1432_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W2: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ Y ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W2 ) ) @ Y ) ) ) ).

% semiring_norm(172)
thf(fact_1433_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W2: num,X: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ ( uminus_uminus @ A @ X ) )
          = ( times_times @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_1434_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M4: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M4 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M4 ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_1435_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_1436_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M4: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M4 ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_1437_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_1438_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( numeral_numeral @ A @ ( inc @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_1439_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_1440_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M4: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M4 @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_1441_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M4 != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_1442_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M4: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) ) )
          = ( ( M4 != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_1443_prod__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B] :
      ( ( basic_fsts @ A @ B @ ( product_Pair @ A @ B @ X @ Y ) )
      = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% prod_set_simps(1)
thf(fact_1444_prod__set__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( basic_snds @ A @ B @ ( product_Pair @ A @ B @ X @ Y ) )
      = ( insert2 @ B @ Y @ ( bot_bot @ ( set @ B ) ) ) ) ).

% prod_set_simps(2)
thf(fact_1445_total__on__singleton,axiom,
    ! [A: $tType,X: A] : ( total_on @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% total_on_singleton
thf(fact_1446_Field__insert,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( field2 @ A @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) )
      = ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ A3 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( field2 @ A @ R4 ) ) ) ).

% Field_insert
thf(fact_1447_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) ).

% one_eq_numeral_iff
thf(fact_1448_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_1449_Field__empty,axiom,
    ! [A: $tType] :
      ( ( field2 @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Field_empty
thf(fact_1450_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_1451_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ one2 @ N ) ) ) ).

% one_less_numeral_iff
thf(fact_1452_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_1453_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_1454_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% one_plus_numeral
thf(fact_1455_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_1456_FieldI2,axiom,
    ! [A: $tType,I: A,J2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ I @ J2 ) @ R )
     => ( member @ A @ J2 @ ( field2 @ A @ R ) ) ) ).

% FieldI2
thf(fact_1457_FieldI1,axiom,
    ! [A: $tType,I: A,J2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ I @ J2 ) @ R )
     => ( member @ A @ I @ ( field2 @ A @ R ) ) ) ).

% FieldI1
thf(fact_1458_total__on__def,axiom,
    ! [A: $tType] :
      ( ( total_on @ A )
      = ( ^ [A10: set @ A,R5: set @ ( product_prod @ A @ A )] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A10 )
           => ! [Y2: A] :
                ( ( member @ A @ Y2 @ A10 )
               => ( ( X3 != Y2 )
                 => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 )
                    | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R5 ) ) ) ) ) ) ) ).

% total_on_def
thf(fact_1459_total__onI,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ! [X2: A,Y3: A] :
          ( ( member @ A @ X2 @ A4 )
         => ( ( member @ A @ Y3 @ A4 )
           => ( ( X2 != Y3 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R4 )
                | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X2 ) @ R4 ) ) ) ) )
     => ( total_on @ A @ A4 @ R4 ) ) ).

% total_onI
thf(fact_1460_total__on__empty,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] : ( total_on @ A @ ( bot_bot @ ( set @ A ) ) @ R4 ) ).

% total_on_empty
thf(fact_1461_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A3 )
          = A3 ) ) ).

% mult_numeral_1
thf(fact_1462_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( numeral_numeral @ A @ one2 ) )
          = A3 ) ) ).

% mult_numeral_1_right
thf(fact_1463_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_1464_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_1465_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_1466_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_1467_prod__set__defs_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_fsts @ A @ B )
      = ( ^ [P6: product_prod @ A @ B] : ( insert2 @ A @ ( product_fst @ A @ B @ P6 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% prod_set_defs(1)
thf(fact_1468_prod__set__defs_I2_J,axiom,
    ! [D: $tType,C: $tType] :
      ( ( basic_snds @ C @ D )
      = ( ^ [P6: product_prod @ C @ D] : ( insert2 @ D @ ( product_snd @ C @ D @ P6 ) @ ( bot_bot @ ( set @ D ) ) ) ) ) ).

% prod_set_defs(2)
thf(fact_1469_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_div_numeral
thf(fact_1470_cofinal__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Ca7293521722713021262ofinal @ A )
      = ( ^ [A10: set @ A,R5: set @ ( product_prod @ A @ A )] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ ( field2 @ A @ R5 ) )
           => ? [Y2: A] :
                ( ( member @ A @ Y2 @ A10 )
                & ( X3 != Y2 )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 ) ) ) ) ) ).

% cofinal_def
thf(fact_1471_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M4: num] :
          ( ( unique8689654367752047608divmod @ A @ M4 @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M4 ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_1472_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M4: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M4 ) ) ) ).

% diff_numeral_special(8)
thf(fact_1473_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_1474_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M4: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M4 @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_1475_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_1476_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M4: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M4 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M4 @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_1477_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M4: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M4 ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M4 @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_1478_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ one2 @ N ) ) ) ).

% diff_numeral_special(1)
thf(fact_1479_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M4: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M4 ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_1480_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M4: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M4 ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M4 ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_1481_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_1482_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_1483_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_1484_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_1485_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R4: A,Q4: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R4 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q4 @ R4 ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R4 @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R4 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q4 @ R4 ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R4 ) ) ) ) ) ).

% divmod_step_eq
thf(fact_1486_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_1487_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_1488_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_1489_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_1490_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_1491_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_1492_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_1493_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_1494_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M4: num,N: num] :
          ( ( ( ord_less_eq @ num @ M4 @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M4 ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M4 ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M4 @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M4 ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M4 ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_1495_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M4: num,N: num] :
          ( ( ( ord_less @ num @ M4 @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M4 ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M4 ) ) ) ) )
          & ( ~ ( ord_less @ num @ M4 @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M4 ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M4 ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_1496_xor__num_Ocases,axiom,
    ! [X: product_prod @ num @ num] :
      ( ( X
       != ( product_Pair @ num @ num @ one2 @ one2 ) )
     => ( ! [N3: num] :
            ( X
           != ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) )
       => ( ! [N3: num] :
              ( X
             != ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) )
         => ( ! [M5: num] :
                ( X
               != ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ one2 ) )
           => ( ! [M5: num,N3: num] :
                  ( X
                 != ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit0 @ N3 ) ) )
             => ( ! [M5: num,N3: num] :
                    ( X
                   != ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit1 @ N3 ) ) )
               => ( ! [M5: num] :
                      ( X
                     != ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ one2 ) )
                 => ( ! [M5: num,N3: num] :
                        ( X
                       != ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit0 @ N3 ) ) )
                   => ~ ! [M5: num,N3: num] :
                          ( X
                         != ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
thf(fact_1497_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_1498_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_1499_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_1500_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N5: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M3 @ N5 ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M3 ) ) @ ( unique1321980374590559556d_step @ A @ N5 @ ( unique8689654367752047608divmod @ A @ M3 @ ( bit0 @ N5 ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_1501_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_1502_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2_right
thf(fact_1503_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2
thf(fact_1504_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_1505_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_1506_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_1507_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_1508_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_1509_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_1510_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_1511_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_1512_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_1513_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_1514_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A3 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_1515_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_1516_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_1517_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_1518_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_1519_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_1520_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A3 ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_1521_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A3 ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_1522_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1523_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_1524_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_1525_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_1526_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% xor_numerals(1)
thf(fact_1527_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y ) ) ) ) ).

% xor_numerals(2)
thf(fact_1528_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% xor_numerals(5)
thf(fact_1529_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X ) ) ) ) ).

% xor_numerals(8)
thf(fact_1530_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_1531_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_1532_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_1533_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_1534_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_1535_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_mod_numeral
thf(fact_1536_divmod__int__def,axiom,
    ( ( unique8689654367752047608divmod @ int )
    = ( ^ [M3: num,N5: num] : ( product_Pair @ int @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N5 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N5 ) ) ) ) ) ).

% divmod_int_def
thf(fact_1537_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_1538_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_1539_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_1540_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_1541_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,A6: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A3 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A6 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_1542_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_1543_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A3 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D3: A] :
                ( B2
               != ( plus_plus @ A @ A3 @ ( times_times @ A @ C2 @ D3 ) ) ) ) ) ).

% mod_eqE
thf(fact_1544_xor_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( monoid @ A @ ( bit_se5824344971392196577ns_xor @ A ) @ ( zero_zero @ A ) ) ) ).

% xor.monoid_axioms
thf(fact_1545_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A3: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = A3 ) ) ).

% mult_div_mod_eq
thf(fact_1546_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) )
          = A3 ) ) ).

% mod_mult_div_eq
thf(fact_1547_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) )
          = A3 ) ) ).

% mod_div_mult_eq
thf(fact_1548_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = A3 ) ) ).

% div_mult_mod_eq
thf(fact_1549_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( A3
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_1550_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A3 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_1551_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A3 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_1552_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A3 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_1553_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_1554_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_1555_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_1556_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_1557_divmod__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N5: num] : ( product_Pair @ A @ A @ ( divide_divide @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N5 ) ) @ ( modulo_modulo @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N5 ) ) ) ) ) ) ).

% divmod_def
thf(fact_1558_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_1559_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_1560_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_1561_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M4: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) )
                = ( modulo_modulo @ A @ X @ M4 ) )
              | ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X @ M4 ) @ M4 ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_1562_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_1563_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N5: nat,A5: A] :
              ( if @ A
              @ ( N5
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N5 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_1564_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N5: nat,A5: A] :
              ( if @ A
              @ ( N5
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N5 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_1565_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_1566_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_1567_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A3 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_1568_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_1569_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_1570_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_1571_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_1572_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_1573_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A3 ) @ ( times_times @ A @ C2 @ A3 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_1574_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_1575_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_1576_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_1577_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A3 ) @ B2 ) )
          = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_1578_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A3 ) ) )
          = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_1579_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_1580_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A3 ) @ A3 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_1581_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ A3 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_1582_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
            = A3 ) ) ) ).

% unit_div_1_div_1
thf(fact_1583_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_1584_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_1585_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_1586_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_1587_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_1588_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_1589_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_1590_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A3 ) @ A3 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_1591_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
            = ( divide_divide @ A @ B2 @ A3 ) ) ) ) ).

% unit_mult_div_div
thf(fact_1592_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_1593_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(2)
thf(fact_1594_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(8)
thf(fact_1595_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_1596_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% or_numerals(3)
thf(fact_1597_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(5)
thf(fact_1598_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(1)
thf(fact_1599_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ).

% even_plus_one_iff
thf(fact_1600_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_1601_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_1602_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_1603_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A] : ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ A3 ) ) ) ).

% dvd_triv_right
thf(fact_1604_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_1605_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D2 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_1606_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A] : ( dvd_dvd @ A @ A3 @ ( times_times @ A @ A3 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_1607_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A3 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_1608_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_1609_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ C2 )
         => ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_1610_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B4: A,A5: A] :
            ? [K4: A] :
              ( A5
              = ( times_times @ A @ B4 @ K4 ) ) ) ) ) ).

% dvd_def
thf(fact_1611_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A3: A,B2: A,K: A] :
          ( ( A3
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A3 ) ) ) ).

% dvdI
thf(fact_1612_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ A3 )
         => ~ ! [K2: A] :
                ( A3
               != ( times_times @ A @ B2 @ K2 ) ) ) ) ).

% dvdE
thf(fact_1613_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_1614_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A3 ) ) ) ).

% unit_imp_dvd
thf(fact_1615_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A3 ) ) ).

% one_dvd
thf(fact_1616_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_1617_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_1618_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A3 )
              = ( times_times @ A @ C2 @ A3 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_1619_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A3 @ B2 )
              = ( times_times @ A @ A3 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_1620_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_1621_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_1622_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_1623_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_1624_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_1625_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_1626_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_1627_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A3 )
           => ( ( divide_divide @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_1628_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A3 )
         => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_1629_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_1630_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,D2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A3 )
         => ( ( dvd_dvd @ A @ D2 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( divide_divide @ A @ C2 @ D2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_1631_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_1632_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_1633_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A3 )
              = ( divide_divide @ A @ C2 @ A3 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_1634_or_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( monoid @ A @ ( bit_se1065995026697491101ons_or @ A ) @ ( zero_zero @ A ) ) ) ).

% or.monoid_axioms
thf(fact_1635_or_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( semilattice_neutr @ A @ ( bit_se1065995026697491101ons_or @ A ) @ ( zero_zero @ A ) ) ) ).

% or.semilattice_neutr_axioms
thf(fact_1636_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L: A] :
          ( ( ? [X3: A] : ( P @ ( times_times @ A @ L @ X3 ) ) )
          = ( ? [X3: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X3 @ ( zero_zero @ A ) ) )
                & ( P @ X3 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1637_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ~ ( ( A3
               != ( zero_zero @ A ) )
             => ! [C4: A] :
                  ( B2
                 != ( times_times @ A @ A3 @ C4 ) ) ) ) ) ).

% unit_dvdE
thf(fact_1638_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D4: A,T4: A] :
          ( ( dvd_dvd @ A @ D2 @ D4 )
         => ! [X6: A,K3: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X6 @ T4 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K3 @ D4 ) ) @ T4 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1639_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D4: A,T4: A] :
          ( ( dvd_dvd @ A @ D2 @ D4 )
         => ! [X6: A,K3: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X6 @ T4 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X6 @ ( times_times @ A @ K3 @ D4 ) ) @ T4 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1640_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A3 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A3 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1641_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A3 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1642_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1643_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A3 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A3 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A3 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1644_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A3 @ B2 )
              = ( zero_zero @ A ) )
            = ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_1645_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_1646_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_1647_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_1648_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A3 )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_1649_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A3
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A3 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_1650_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A3 @ B2 )
              = C2 )
            = ( A3
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_1651_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A3 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_1652_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_1653_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_1654_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_1655_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ A3 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1656_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ A3 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1657_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ~ ( ( A3
               != ( zero_zero @ A ) )
             => ! [B6: A] :
                  ( ( B6
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B6 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A3 )
                        = B6 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B6 )
                          = A3 )
                       => ( ( ( times_times @ A @ A3 @ B6 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A3 )
                           != ( times_times @ A @ C2 @ B6 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1658_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ~ ! [B6: A] :
                ( A3
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) ) ) ) ).

% evenE
thf(fact_1659_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_1660_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A3 ) ) ) ).

% even_two_times_div_two
thf(fact_1661_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
          = ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_1662_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ~ ! [B6: A] :
                ( A3
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1663_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
           => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
           => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_1664_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
           => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
             => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_1665_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_1666_divmod__BitM__2__eq,axiom,
    ! [M4: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M4 ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M4 ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_1667_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_1668_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_1669_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,N: nat] :
          ( ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A3 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A3 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A3 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_1670_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% mask_Suc_double
thf(fact_1671_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A3: int,Q4: int,R4: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A3 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q4 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R4 ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_1672_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A3: int,Q4: int,R4: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q4 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R4 ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_1673_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_1674_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,M4: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ( power_power @ A @ A3 @ M4 )
              = ( power_power @ A @ A3 @ N ) )
            = ( M4 = N ) ) ) ) ).

% power_inject_exp
thf(fact_1675_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less_eq @ nat @ X @ Y ) ) ) ) ).

% power_increasing_iff
thf(fact_1676_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less @ nat @ X @ Y ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_1677_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_1678_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat,A3: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ A3 ) )
          = A3 ) ) ).

% left_minus_one_mult_self
thf(fact_1679_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_1680_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M4: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ M4 ) ) @ ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M4 @ N ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_1681_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M4: num,N: num] :
          ( ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ M4 ) ) @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ N ) ) )
          = ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M4 @ N ) ) ) ) ) ).

% power_add_numeral
thf(fact_1682_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_1683_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M4: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M4 ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less_eq @ nat @ N @ M4 ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_1684_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M4: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M4 ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less @ nat @ N @ M4 ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_1685_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_1686_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_1687_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_1688_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_1689_divmod_H__nat__def,axiom,
    ( ( unique8689654367752047608divmod @ nat )
    = ( ^ [M3: num,N5: num] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N5 ) ) @ ( modulo_modulo @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N5 ) ) ) ) ) ).

% divmod'_nat_def
thf(fact_1690_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ Y )
            = ( times_times @ A @ Y @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_1691_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A3 @ B2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_mult_distrib
thf(fact_1692_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A3 @ N ) @ A3 )
          = ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_commutes
thf(fact_1693_unique__quotient,axiom,
    ! [A3: int,B2: int,Q4: int,R4: int,Q6: int,R6: int] :
      ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
     => ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q6 @ R6 ) )
       => ( Q4 = Q6 ) ) ) ).

% unique_quotient
thf(fact_1694_unique__remainder,axiom,
    ! [A3: int,B2: int,Q4: int,R4: int,Q6: int,R6: int] :
      ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
     => ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q6 @ R6 ) )
       => ( R4 = R6 ) ) ) ).

% unique_remainder
thf(fact_1695_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A3: A] :
          ( ( ord_less_eq @ nat @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ A3 @ N4 ) ) ) ) ) ).

% power_increasing
thf(fact_1696_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% one_le_power
thf(fact_1697_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A3: A] :
          ( ( ord_less @ nat @ N @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ A3 @ N4 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_1698_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,M4: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ A @ ( power_power @ A @ A3 @ M4 ) @ ( power_power @ A @ A3 @ N ) )
           => ( ord_less @ nat @ M4 @ N ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_1699_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_1700_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_Suc
thf(fact_1701_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A3 @ N ) @ A3 ) ) ) ).

% power_Suc2
thf(fact_1702_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_1703_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_one_over
thf(fact_1704_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M4: nat,N: nat] :
          ( ( power_power @ A @ A3 @ ( plus_plus @ nat @ M4 @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A3 @ M4 ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_add
thf(fact_1705_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N5: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N5 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_1706_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A3: A] :
          ( ( ord_less_eq @ nat @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N4 ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ) ).

% power_decreasing
thf(fact_1707_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_1708_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,M4: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A3 @ M4 ) @ ( power_power @ A @ A3 @ N ) )
           => ( ord_less_eq @ nat @ M4 @ N ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_1709_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A3: A] :
          ( ( ord_less @ nat @ N @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A3 @ N4 ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_1710_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_1711_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less @ A @ ( power_power @ A @ A3 @ N ) @ ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_1712_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less_eq @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% self_le_power
thf(fact_1713_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_1714_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,M4: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X @ M4 ) @ ( power_power @ A @ X @ N ) )
            = ( ( dvd_dvd @ A @ X @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M4 @ N ) ) ) ) ) ).

% dvd_power_iff
thf(fact_1715_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% one_less_power
thf(fact_1716_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ ( suc @ N ) ) ) ) ) ).

% power_gt1
thf(fact_1717_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_minus
thf(fact_1718_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A3 @ A3 ) ) ) ).

% power2_eq_square
thf(fact_1719_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A] :
          ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X @ X ) @ X ) @ X ) ) ) ).

% power4_eq_xxxx
thf(fact_1720_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_1721_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A3 @ N ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_1722_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat,X: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            | ( X
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X @ ( power_power @ A @ X @ N ) ) ) ) ).

% dvd_power
thf(fact_1723_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A3 @ A3 ) @ A3 ) ) ) ).

% power3_eq_cube
thf(fact_1724_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_1725_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q4: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q4 @ L ) )
       => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_1726_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q4: int,R4: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L @ Q4 ) @ R4 ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R4 )
            & ( ord_less @ int @ R4 @ L ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L @ R4 )
                & ( ord_less_eq @ int @ R4 @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( Q4
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_1727_div__int__unique,axiom,
    ! [K: int,L: int,Q4: int,R4: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
     => ( ( divide_divide @ int @ K @ L )
        = Q4 ) ) ).

% div_int_unique
thf(fact_1728_mod__int__unique,axiom,
    ! [K: int,L: int,Q4: int,R4: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
     => ( ( modulo_modulo @ int @ K @ L )
        = R4 ) ) ).

% mod_int_unique
thf(fact_1729_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% power_Suc_less
thf(fact_1730_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ ( suc @ N ) ) @ A3 ) ) ) ) ).

% power_Suc_le_self
thf(fact_1731_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A3 @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_1732_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N ) )
          = ( power_power @ A @ A3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% minus_power_mult_self
thf(fact_1733_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ A3 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( times_times @ A @ A3 @ ( power_power @ A @ ( power_power @ A @ A3 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_1734_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A3: A] :
          ( ( ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A3
              = ( one_one @ A ) )
            | ( A3
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_1735_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_1736_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,N: nat,M4: nat] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N @ M4 )
             => ( ( divide_divide @ A @ ( power_power @ A @ A3 @ M4 ) @ ( power_power @ A @ A3 @ N ) )
                = ( power_power @ A @ A3 @ ( minus_minus @ nat @ M4 @ N ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N @ M4 )
             => ( ( divide_divide @ A @ ( power_power @ A @ A3 @ M4 ) @ ( power_power @ A @ A3 @ N ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1737_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_1738_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat,A3: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( power_power @ A @ A3 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ A3 )
            = ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_minus_mult
thf(fact_1739_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,N: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_minus'
thf(fact_1740_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_1741_eucl__rel__int,axiom,
    ! [K: int,L: int] : ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ ( divide_divide @ int @ K @ L ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% eucl_rel_int
thf(fact_1742_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_sum
thf(fact_1743_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_1744_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_1745_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P6: A,M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P6 @ ( power_power @ A @ P6 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1746_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_diff
thf(fact_1747_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M4: nat,N: nat,A3: A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M4 ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_1748_zminus1__lemma,axiom,
    ! [A3: int,B2: int,Q4: int,R4: int] :
      ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A3 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R4
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q4 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q4 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R4
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R4 ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_1749_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M4: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ord_less_eq @ nat @ M4 @ N ) ) ) ).

% even_mask_div_iff'
thf(fact_1750_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_1751_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M4: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M4 @ N ) ) ) ) ).

% even_mask_div_iff
thf(fact_1752_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,M4: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ord_less @ nat @ N @ M4 )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M4 @ N )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1753_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_1754_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_1755_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_1756_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_1757_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_1758_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N ) ) ) ) ) ) ).

% mask_numeral
thf(fact_1759_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M4: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N @ M4 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_of_exp
thf(fact_1760_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_1761_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_1762_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( one_one @ A ) )
          = P ) ) ).

% of_bool_eq_1_iff
thf(fact_1763_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_1764_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_1765_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ) ).

% of_bool_not_iff
thf(fact_1766_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A3 ) @ ( sgn_sgn @ A @ A3 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_1767_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% take_bit_of_1
thf(fact_1768_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ A3 )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_1769_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_of_1
thf(fact_1770_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_1771_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_1772_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_1773_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P6: $o] : ( if @ A @ P6 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_1774_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P4: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P4 ) )
          = ( ( P4
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P4
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_1775_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P4: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P4 ) )
          = ( ~ ( ( P4
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P4
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_1776_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( bit_se1065995026697491101ons_or @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N5 @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_1777_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( bit_se5824344971392196577ns_xor @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N5 @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_1778_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_1779_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( times_times @ A @ A5 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N5 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_1780_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A3: A] :
          ( ! [A8: A] :
              ( ( ( divide_divide @ A @ A8 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A8 )
             => ( P @ A8 ) )
         => ( ! [A8: A,B6: $o] :
                ( ( P @ A8 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A8 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A8 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A8 ) ) ) ) )
           => ( P @ A3 ) ) ) ) ).

% bits_induct
thf(fact_1781_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_1782_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M4: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M4 @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) ) ) ) ).

% exp_mod_exp
thf(fact_1783_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A3 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% or_one_eq
thf(fact_1784_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A3 )
          = ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% one_or_eq
thf(fact_1785_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M4: nat,N: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N @ M4 ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M4 @ N ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_1786_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A3 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% one_xor_eq
thf(fact_1787_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A3 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% xor_one_eq
thf(fact_1788_Divides_Oadjust__div__eq,axiom,
    ! [Q4: int,R4: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
      = ( plus_plus @ int @ Q4
        @ ( zero_neq_one_of_bool @ int
          @ ( R4
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_1789_and__int_Oelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y )
     => ( ( ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_1790_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K4: int,L3: int] :
          ( if @ int
          @ ( ( member @ int @ K4 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L3 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K4 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K4 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_1791_normalize__negative,axiom,
    ! [Q4: int,P4: int] :
      ( ( ord_less @ int @ Q4 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q4 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P4 ) @ ( uminus_uminus @ int @ Q4 ) ) ) ) ) ).

% normalize_negative
thf(fact_1792_divmod__nat__def,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N5: nat] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ M3 @ N5 ) @ ( modulo_modulo @ nat @ M3 @ N5 ) ) ) ) ).

% divmod_nat_def
thf(fact_1793_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [K2: int,L4: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K2 @ L4 ) )
           => ( ( ~ ( ( member @ int @ K2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L4 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K2 @ L4 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% and_int.pinduct
thf(fact_1794_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_1795_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X ) ) ).

% bit.conj_one_right
thf(fact_1796_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A3 ) ) ).

% and.right_neutral
thf(fact_1797_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A3 )
          = A3 ) ) ).

% and.left_neutral
thf(fact_1798_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_1799_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_1800_normalize__denom__zero,axiom,
    ! [P4: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P4 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_1801_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_1802_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_1803_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(3)
thf(fact_1804_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(4)
thf(fact_1805_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(6)
thf(fact_1806_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A3
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_1807_and_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( monoid @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.monoid_axioms
thf(fact_1808_and_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( semilattice_neutr @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.semilattice_neutr_axioms
thf(fact_1809_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A3 @ X )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A3 @ X )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A3 @ Y )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A3 @ Y )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X = Y ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_1810_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A3 )
          = ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_1811_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_1812_normalize__denom__pos,axiom,
    ! [R4: product_prod @ int @ int,P4: int,Q4: int] :
      ( ( ( normalize @ R4 )
        = ( product_Pair @ int @ int @ P4 @ Q4 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q4 ) ) ).

% normalize_denom_pos
thf(fact_1813_normalize__crossproduct,axiom,
    ! [Q4: int,S: int,P4: int,R4: int] :
      ( ( Q4
       != ( zero_zero @ int ) )
     => ( ( S
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q4 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R4 @ S ) ) )
         => ( ( times_times @ int @ P4 @ S )
            = ( times_times @ int @ R4 @ Q4 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_1814_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member @ int @ K @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_1815_and__int_Opelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% and_int.pelims
thf(fact_1816_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [I3: int,J3: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I3 @ J3 ) )
           => ( ( ( ord_less_eq @ int @ I3 @ J3 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J3 ) )
             => ( P @ I3 @ J3 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% upto.pinduct
thf(fact_1817_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ! [J3: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A3 @ ( suc @ J3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N )
            = ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_1818_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P4: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ P4 @ ( times_times @ A @ A3 @ B2 ) )
         => ~ ! [X2: A,Y3: A] :
                ( ( P4
                  = ( times_times @ A @ X2 @ Y3 ) )
               => ( ( dvd_dvd @ A @ X2 @ A3 )
                 => ~ ( dvd_dvd @ A @ Y3 @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_1819_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B8: A,C7: A] :
              ( ( A3
                = ( times_times @ A @ B8 @ C7 ) )
              & ( dvd_dvd @ A @ B8 @ B2 )
              & ( dvd_dvd @ A @ C7 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_1820_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_1821_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_1822_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat,M4: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M4 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_1823_min_Oidem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A] :
          ( ( ord_min @ A @ A3 @ A3 )
          = A3 ) ) ).

% min.idem
thf(fact_1824_min_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_min @ A @ A3 @ ( ord_min @ A @ A3 @ B2 ) )
          = ( ord_min @ A @ A3 @ B2 ) ) ) ).

% min.left_idem
thf(fact_1825_min_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_min @ A @ ( ord_min @ A @ A3 @ B2 ) @ B2 )
          = ( ord_min @ A @ A3 @ B2 ) ) ) ).

% min.right_idem
thf(fact_1826_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% min.absorb1
thf(fact_1827_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_1828_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A3 @ B2 )
            & ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_1829_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_1830_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% min.absorb3
thf(fact_1831_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_1832_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_min @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z2 @ X )
            & ( ord_less @ A @ Z2 @ Y ) ) ) ) ).

% min_less_iff_conj
thf(fact_1833_min__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% min_bot2
thf(fact_1834_min__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% min_bot
thf(fact_1835_min__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ ( top_top @ A ) @ X )
          = X ) ) ).

% min_top
thf(fact_1836_min__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% min_top2
thf(fact_1837_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_1838_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_1839_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_1840_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_1841_ceiling__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% ceiling_one
thf(fact_1842_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_1843_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_less_ceiling
thf(fact_1844_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_1845_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_1846_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_1847_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X ) ) ) ).

% zero_le_ceiling
thf(fact_1848_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_1849_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_le_ceiling
thf(fact_1850_min_Oassoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_min @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 )
          = ( ord_min @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ).

% min.assoc
thf(fact_1851_min_Ocommute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_min @ A )
        = ( ^ [A5: A,B4: A] : ( ord_min @ A @ B4 @ A5 ) ) ) ) ).

% min.commute
thf(fact_1852_min_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_min @ A @ B2 @ ( ord_min @ A @ A3 @ C2 ) )
          = ( ord_min @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ).

% min.left_commute
thf(fact_1853_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ ( ord_min @ A @ C2 @ D2 ) ) ) ) ) ).

% min.mono
thf(fact_1854_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( A3
            = ( ord_min @ A @ A3 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_1855_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( ord_min @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% min.orderI
thf(fact_1856_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A3 @ B2 )
             => ~ ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_1857_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ A3 @ C2 )
           => ( ord_less_eq @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_1858_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( A5
              = ( ord_min @ A @ A5 @ B4 ) ) ) ) ) ).

% min.order_iff
thf(fact_1859_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ A3 ) ) ).

% min.cobounded1
thf(fact_1860_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_1861_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_min @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% min.absorb_iff1
thf(fact_1862_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_min @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% min.absorb_iff2
thf(fact_1863_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_1864_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_1865_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            | ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% min_le_iff_disj
thf(fact_1866_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ A5 @ B4 ) ) ) ) ).

% min_def
thf(fact_1867_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_min @ A @ X @ Y )
            = X ) ) ) ).

% min_absorb1
thf(fact_1868_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_min @ A @ X @ Y )
            = Y ) ) ) ).

% min_absorb2
thf(fact_1869_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less @ A @ X @ Z2 )
            | ( ord_less @ A @ Y @ Z2 ) ) ) ) ).

% min_less_iff_disj
thf(fact_1870_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A3 @ B2 )
             => ~ ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_1871_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( A5
                = ( ord_min @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_1872_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A3 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_1873_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_1874_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( plus_plus @ A @ Y @ Z2 ) ) ) ) ).

% min_add_distrib_left
thf(fact_1875_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ X @ ( ord_min @ A @ Y @ Z2 ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z2 ) ) ) ) ).

% min_add_distrib_right
thf(fact_1876_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ord_min @ A @ ( minus_minus @ A @ X @ Z2 ) @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ).

% min_diff_distrib_left
thf(fact_1877_inf__min,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( linorder @ A ) )
     => ( ( inf_inf @ A )
        = ( ord_min @ A ) ) ) ).

% inf_min
thf(fact_1878_complete__linorder__inf__min,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ( ( inf_inf @ A )
        = ( ord_min @ A ) ) ) ).

% complete_linorder_inf_min
thf(fact_1879_min_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semigroup @ A @ ( ord_min @ A ) ) ) ).

% min.semigroup_axioms
thf(fact_1880_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_1881_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N ) ) ) ).

% not_bit_1_Suc
thf(fact_1882_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% bit_numeral_simps(1)
thf(fact_1883_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A3 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A3 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_1884_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N5: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_se4730199178511100633sh_bit @ A @ N5 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_1885_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_1886_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_1887_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_1888_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_less_floor
thf(fact_1889_bezw__0,axiom,
    ! [X: nat] :
      ( ( bezw @ X @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_1890_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N5 @ A5 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A5 @ N5 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N5 ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_1891_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_1892_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_less_floor
thf(fact_1893_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P4 @ Q4 ) ) ) @ ( one_one @ A ) ) @ Q4 ) @ P4 ) ) ) ).

% ceiling_divide_lower
thf(fact_1894_floor__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% floor_one
thf(fact_1895_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_1896_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_1897_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_1898_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_1899_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_1900_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_1901_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_right
thf(fact_1902_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_left
thf(fact_1903_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% zero_less_floor
thf(fact_1904_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_1905_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_le_floor
thf(fact_1906_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_1907_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_1908_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_1909_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_1910_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T4: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T4 ) )
          = ( ! [I2: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I2 ) @ T4 )
                  & ( ord_less @ A @ T4 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I2 ) @ ( one_one @ A ) ) ) )
               => ( P @ I2 ) ) ) ) ) ).

% floor_split
thf(fact_1911_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A3: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X )
            = A3 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A3 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A3 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_1912_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X )
         => ( ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X )
              = Z2 ) ) ) ) ).

% floor_unique
thf(fact_1913_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% less_floor_iff
thf(fact_1914_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_1915_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P4 @ Q4 ) ) ) @ Q4 ) @ P4 ) ) ) ).

% floor_divide_lower
thf(fact_1916_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less @ A @ P4 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P4 @ Q4 ) ) ) @ ( one_one @ A ) ) @ Q4 ) ) ) ) ).

% floor_divide_upper
thf(fact_1917_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A5: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A5 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_1918_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A5: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_1919_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A5: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A5 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_1920_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_1921_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( bit_se5824344872417868541ns_and @ A @ A5 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N5 @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_1922_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A3 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_1923_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) @ ( one_one @ A ) ) @ X )
          & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ) ).

% ceiling_correct
thf(fact_1924_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z2 ) )
           => ( ( archimedean_ceiling @ A @ X )
              = Z2 ) ) ) ) ).

% ceiling_unique
thf(fact_1925_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A3: int] :
          ( ( ( archimedean_ceiling @ A @ X )
            = A3 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A3 ) @ ( one_one @ A ) ) @ X )
            & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A3 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_1926_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T4: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T4 ) )
          = ( ! [I2: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I2 ) @ ( one_one @ A ) ) @ T4 )
                  & ( ord_less_eq @ A @ T4 @ ( ring_1_of_int @ A @ I2 ) ) )
               => ( P @ I2 ) ) ) ) ) ).

% ceiling_split
thf(fact_1927_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_1928_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% le_ceiling_iff
thf(fact_1929_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X @ Y )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X @ Y )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X )
              = Y ) ) ) ) ).

% bit.compl_unique
thf(fact_1930_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less_eq @ A @ P4 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P4 @ Q4 ) ) ) @ Q4 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_1931_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_1932_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_1933_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_less_iff
thf(fact_1934_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_1935_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_le_iff
thf(fact_1936_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W2: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W2 @ Z2 ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_mult
thf(fact_1937_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( one_one @ A ) )
          = ( Z2
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_1938_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_1939_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: int,Y: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% mult_of_int_commute
thf(fact_1940_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X )
              = Y ) ) ) ) ).

% round_unique
thf(fact_1941_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_gt
thf(fact_1942_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_ge
thf(fact_1943_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_1944_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_1945_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X3: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_1946_bezw_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_1947_round__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% round_1
thf(fact_1948_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib2,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,Y: A,Z2: A,X: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Conj @ ( Xor @ Y @ Z2 ) @ X )
        = ( Xor @ ( Conj @ Y @ X ) @ ( Conj @ Z2 @ X ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib2
thf(fact_1949_abstract__boolean__algebra__sym__diff_Oxor__cancel__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X @ ( Compl @ X ) )
        = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_right
thf(fact_1950_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A,Y: A,Z2: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Conj @ X @ ( Xor @ Y @ Z2 ) )
        = ( Xor @ ( Conj @ X @ Y ) @ ( Conj @ X @ Z2 ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib
thf(fact_1951_abstract__boolean__algebra__sym__diff_Oxor__compl__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A,Y: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X @ ( Compl @ Y ) )
        = ( Compl @ ( Xor @ X @ Y ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_right
thf(fact_1952_abstract__boolean__algebra__sym__diff_Oxor__cancel__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ ( Compl @ X ) @ X )
        = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_left
thf(fact_1953_abstract__boolean__algebra__sym__diff_Oxor__compl__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A,Y: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ ( Compl @ X ) @ Y )
        = ( Compl @ ( Xor @ X @ Y ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_left
thf(fact_1954_abstract__boolean__algebra__sym__diff_Oxor__one__right,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X @ One )
        = ( Compl @ X ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_right
thf(fact_1955_abstract__boolean__algebra__sym__diff_Oxor__left__self,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A,Y: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X @ ( Xor @ X @ Y ) )
        = Y ) ) ).

% abstract_boolean_algebra_sym_diff.xor_left_self
thf(fact_1956_abstract__boolean__algebra__sym__diff_Oxor__one__left,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ One @ X )
        = ( Compl @ X ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_left
thf(fact_1957_abstract__boolean__algebra__sym__diff_Oxor__self,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X @ X )
        = Zero ) ) ).

% abstract_boolean_algebra_sym_diff.xor_self
thf(fact_1958_abstract__boolean__algebra__sym__diff_Oxor__def2,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A,Y: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X @ Y )
        = ( Conj @ ( Disj @ X @ Y ) @ ( Disj @ ( Compl @ X ) @ ( Compl @ Y ) ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def2
thf(fact_1959_abstract__boolean__algebra__sym__diff_Oxor__def,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A,X: A,Y: A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( ( Xor @ X @ Y )
        = ( Disj @ ( Conj @ X @ ( Compl @ Y ) ) @ ( Conj @ ( Compl @ X ) @ Y ) ) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def
thf(fact_1960_abstract__boolean__algebra__sym__diff_Oaxioms_I1_J,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One ) ) ).

% abstract_boolean_algebra_sym_diff.axioms(1)
thf(fact_1961_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A,M4: nat,N: nat] :
          ( ( divide_divide @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M4 ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ M4 ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% div_mult2_eq'
thf(fact_1962_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ Y @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ X ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_1963_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A,M4: nat,N: nat] :
          ( ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M4 ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M4 ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ M4 ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) @ ( modulo_modulo @ A @ A3 @ ( semiring_1_of_nat @ A @ M4 ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_1964_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
         => ~ ! [N3: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ E2 ) ) ) ).

% nat_approx_posE
thf(fact_1965_bezw__non__0,axiom,
    ! [Y: nat,X: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y )
     => ( ( bezw @ X @ Y )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Y ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_1966_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X3: nat,Y2: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y2
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X3 @ Y2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X3 @ Y2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X3 @ Y2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X3 @ Y2 ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_1967_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M4: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M4 ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M4 ) ) ) ) ).

% of_nat_Suc
thf(fact_1968_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_1969_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_1970_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( one_one @ A ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_1971_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M4: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M4 @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M4 ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mult
thf(fact_1972_bezw_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% bezw.pelims
thf(fact_1973_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X3: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X3 ) ) @ ( archimedean_ceiling @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ X3 ) ) ) ) ) ).

% round_altdef
thf(fact_1974_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_1975_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_1_eq
thf(fact_1976_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_1977_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_1978_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = X )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_1979_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_1980_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: nat,Y: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( semiring_1_of_nat @ A @ X ) ) ) ) ).

% mult_of_nat_commute
thf(fact_1981_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_1982_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N ) ) ) ) ).

% pochhammer_double
thf(fact_1983_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ N ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X )
            = N ) ) ) ).

% round_unique'
thf(fact_1984_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ X ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_1985_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_1986_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_1987_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A3: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A3 )
         => ( ( member @ B @ A3 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A3 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A3 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_1988_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A3: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A3 )
         => ( ( member @ B @ A3 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A3 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A3 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_1989_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A3 ) )
          = ( abs_abs @ A @ A3 ) ) ) ).

% abs_idempotent
thf(fact_1990_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_1991_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ( abs_abs @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_1992_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_1993_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_1994_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ A3 ) )
          = ( times_times @ A @ A3 @ A3 ) ) ) ).

% abs_mult_self_eq
thf(fact_1995_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_1996_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A3 ) )
          = ( abs_abs @ A @ A3 ) ) ) ).

% abs_minus_cancel
thf(fact_1997_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_1998_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ A3 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% abs_le_self_iff
thf(fact_1999_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( abs_abs @ A @ A3 )
            = A3 ) ) ) ).

% abs_of_nonneg
thf(fact_2000_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A3 ) )
          = ( ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_2001_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_2002_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_2003_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A3 )
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% abs_of_nonpos
thf(fact_2004_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A3 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_2005_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ A3 @ ( abs_abs @ A @ A3 ) ) ) ).

% abs_ge_self
thf(fact_2006_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_2007_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_2008_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_2009_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A3 ) ) ) ) ).

% abs_minus_commute
thf(fact_2010_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A,B2: A] :
          ( ( member @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A3 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_2011_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_2012_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_2013_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) )
           => ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_2014_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y @ ( ring_1_Ints @ A ) )
           => ( ( X = Y )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_2015_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A3 ) ) ) ).

% abs_ge_zero
thf(fact_2016_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( abs_abs @ A @ A3 )
            = A3 ) ) ) ).

% abs_of_pos
thf(fact_2017_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A3 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_2018_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A3 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_2019_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A3 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_2020_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_2021_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_2022_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A3 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_2023_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ ( abs_abs @ A @ A3 ) ) ) ).

% abs_ge_minus_self
thf(fact_2024_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 )
          = ( ( ord_less_eq @ A @ A3 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_2025_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_2026_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_2027_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( abs_abs @ A @ X ) )
          = X ) ) ).

% mult_sgn_abs
thf(fact_2028_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A3 ) @ ( abs_abs @ A @ A3 ) )
          = A3 ) ) ).

% sgn_mult_abs
thf(fact_2029_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( sgn_sgn @ A @ A3 ) )
          = A3 ) ) ).

% abs_mult_sgn
thf(fact_2030_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K4: A] : ( times_times @ A @ K4 @ ( sgn_sgn @ A @ K4 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_2031_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A] :
          ( ! [E3: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E3 )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ E3 ) )
         => ( X
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_2032_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              | ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_2033_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y ) @ X )
            = ( abs_abs @ A @ ( times_times @ A @ Y @ X ) ) ) ) ) ).

% abs_mult_pos
thf(fact_2034_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A3 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_2035_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_2036_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_2037_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A3 )
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% abs_of_neg
thf(fact_2038_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ( A3
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A3 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A3
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A3 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_2039_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_2040_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A3: A] :
          ( ( member @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ A3 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_2041_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_2042_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_leD
thf(fact_2043_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_lessD
thf(fact_2044_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ A3 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% pochhammer_rec
thf(fact_2045_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) ) ) ).

% pochhammer_rec'
thf(fact_2046_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A3 @ N ) @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_2047_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat,M4: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( plus_plus @ nat @ N @ M4 ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ M4 ) ) ) ) ).

% pochhammer_product'
thf(fact_2048_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( member @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ A3 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_2049_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_2050_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M4: nat,N: nat,Z2: A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ Z2 @ N )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ M4 ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ M4 ) ) @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_2051_eucl__rel__int__remainderI,axiom,
    ! [R4: int,L: int,K: int,Q4: int] :
      ( ( ( sgn_sgn @ int @ R4 )
        = ( sgn_sgn @ int @ L ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R4 ) @ ( abs_abs @ int @ L ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L ) @ R4 ) )
         => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q4 @ R4 ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_2052_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_2053_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_2054_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X ) ) ) ) ) ) ).

% frac_neg
thf(fact_2055_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R4: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R4 @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R4 ) @ K ) )
          = ( times_times @ A @ R4 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R4 ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_2056_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A32: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A1 @ A22 @ A32 )
     => ( ( ( A22
            = ( zero_zero @ int ) )
         => ( A32
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A1 ) ) )
       => ( ! [Q7: int] :
              ( ( A32
                = ( product_Pair @ int @ int @ Q7 @ ( zero_zero @ int ) ) )
             => ( ( A22
                 != ( zero_zero @ int ) )
               => ( A1
                 != ( times_times @ int @ Q7 @ A22 ) ) ) )
         => ~ ! [R3: int,Q7: int] :
                ( ( A32
                  = ( product_Pair @ int @ int @ Q7 @ R3 ) )
               => ( ( ( sgn_sgn @ int @ R3 )
                    = ( sgn_sgn @ int @ A22 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R3 ) @ ( abs_abs @ int @ A22 ) )
                   => ( A1
                     != ( plus_plus @ int @ ( times_times @ int @ Q7 @ A22 ) @ R3 ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_2057_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A12: int,A23: int,A33: product_prod @ int @ int] :
          ( ? [K4: int] :
              ( ( A12 = K4 )
              & ( A23
                = ( zero_zero @ int ) )
              & ( A33
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K4 ) ) )
          | ? [L3: int,K4: int,Q8: int] :
              ( ( A12 = K4 )
              & ( A23 = L3 )
              & ( A33
                = ( product_Pair @ int @ int @ Q8 @ ( zero_zero @ int ) ) )
              & ( L3
               != ( zero_zero @ int ) )
              & ( K4
                = ( times_times @ int @ Q8 @ L3 ) ) )
          | ? [R5: int,L3: int,K4: int,Q8: int] :
              ( ( A12 = K4 )
              & ( A23 = L3 )
              & ( A33
                = ( product_Pair @ int @ int @ Q8 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L3 ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L3 ) )
              & ( K4
                = ( plus_plus @ int @ ( times_times @ int @ Q8 @ L3 ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_2058_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A3: A] :
          ( ( ( archimedean_frac @ A @ X )
            = A3 )
          = ( ( member @ A @ ( minus_minus @ A @ X @ A3 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
            & ( ord_less @ A @ A3 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_2059_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_double
thf(fact_2060_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A3 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_2061_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( gcd_Gcd @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert2 @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_2062_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% pochhammer_same
thf(fact_2063_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_2064_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M3 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_2065_abstract__boolean__algebra__sym__diff__def,axiom,
    ! [A: $tType] :
      ( ( boolea3799213064322606851m_diff @ A )
      = ( ^ [Conj2: A > A > A,Disj2: A > A > A,Compl2: A > A,Zero2: A,One2: A,Xor2: A > A > A] :
            ( ( boolea2506097494486148201lgebra @ A @ Conj2 @ Disj2 @ Compl2 @ Zero2 @ One2 )
            & ( boolea5476839437570043046axioms @ A @ Conj2 @ Disj2 @ Compl2 @ Xor2 ) ) ) ) ).

% abstract_boolean_algebra_sym_diff_def
thf(fact_2066_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_2067_Gcd__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_empty
thf(fact_2068_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A3: A] :
          ( ( gbinomial @ A @ A3 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_2069_fact__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_1
thf(fact_2070_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( top_top @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Gcd_UNIV
thf(fact_2071_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_2072_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_Suc
thf(fact_2073_abstract__boolean__algebra__sym__diff__axioms_Ointro,axiom,
    ! [A: $tType,Xor: A > A > A,Disj: A > A > A,Conj: A > A > A,Compl: A > A] :
      ( ! [X2: A,Y3: A] :
          ( ( Xor @ X2 @ Y3 )
          = ( Disj @ ( Conj @ X2 @ ( Compl @ Y3 ) ) @ ( Conj @ ( Compl @ X2 ) @ Y3 ) ) )
     => ( boolea5476839437570043046axioms @ A @ Conj @ Disj @ Compl @ Xor ) ) ).

% abstract_boolean_algebra_sym_diff_axioms.intro
thf(fact_2074_abstract__boolean__algebra__sym__diff__axioms__def,axiom,
    ! [A: $tType] :
      ( ( boolea5476839437570043046axioms @ A )
      = ( ^ [Conj2: A > A > A,Disj2: A > A > A,Compl2: A > A,Xor2: A > A > A] :
          ! [X3: A,Y2: A] :
            ( ( Xor2 @ X3 @ Y2 )
            = ( Disj2 @ ( Conj2 @ X3 @ ( Compl2 @ Y2 ) ) @ ( Conj2 @ ( Compl2 @ X3 ) @ Y2 ) ) ) ) ) ).

% abstract_boolean_algebra_sym_diff_axioms_def
thf(fact_2075_Gcd__1,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( member @ A @ ( one_one @ A ) @ A4 )
         => ( ( gcd_Gcd @ A @ A4 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_1
thf(fact_2076_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A3 @ K ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_2077_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_1
thf(fact_2078_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_2079_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_semiring_1 @ A ) )
     => ( ( semiring_char_0_fact @ A )
        = ( comm_s3205402744901411588hammer @ A @ ( one_one @ A ) ) ) ) ).

% pochhammer_fact
thf(fact_2080_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K4: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ K4 ) ) @ ( one_one @ A ) ) @ K4 ) @ ( semiring_char_0_fact @ A @ K4 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_2081_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K4 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A5 ) @ K4 ) ) @ ( semiring_char_0_fact @ A @ K4 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_2082_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( member @ A @ A3 @ A4 )
           => ( ( gcd_Gcd @ A @ A4 )
              = ( one_one @ A ) ) ) ) ) ).

% Gcd_eq_1_I
thf(fact_2083_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ A3 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_2084_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A3 @ K ) )
          = ( times_times @ A @ A3 @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_2085_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ A3 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A3 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_2086_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ A3 @ ( gbinomial @ A @ A3 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A3 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_2087_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% choose_dvd
thf(fact_2088_abstract__boolean__algebra__sym__diff_Oaxioms_I2_J,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A] :
      ( ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor )
     => ( boolea5476839437570043046axioms @ A @ Conj @ Disj @ Compl @ Xor ) ) ).

% abstract_boolean_algebra_sym_diff.axioms(2)
thf(fact_2089_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A3 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_2090_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) )
          = ( times_times @ A @ A3 @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_2091_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M4: nat,A3: A] :
          ( ( ord_less_eq @ nat @ K @ M4 )
         => ( ( times_times @ A @ ( gbinomial @ A @ A3 @ M4 ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M4 ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M4 @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_2092_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_2093_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A3 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_2094_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N ) ) ) ) ).

% gbinomial_index_swap
thf(fact_2095_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K4: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K4 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K4 ) @ A5 ) @ ( one_one @ A ) ) @ K4 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_2096_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_2097_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A3 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_2098_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A3 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_2099_abstract__boolean__algebra__sym__diff_Ointro,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A,Xor: A > A > A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( ( boolea5476839437570043046axioms @ A @ Conj @ Disj @ Compl @ Xor )
       => ( boolea3799213064322606851m_diff @ A @ Conj @ Disj @ Compl @ Zero @ One @ Xor ) ) ) ).

% abstract_boolean_algebra_sym_diff.intro
thf(fact_2100_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_2101_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_2102_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_2103_card__doubleton__eq__2__iff,axiom,
    ! [A: $tType,A3: A,B2: A] :
      ( ( ( finite_card @ A @ ( insert2 @ A @ A3 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( A3 != B2 ) ) ) ).

% card_doubleton_eq_2_iff
thf(fact_2104_refl__on__singleton,axiom,
    ! [A: $tType,X: A] : ( refl_on @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% refl_on_singleton
thf(fact_2105_pair__lessI2,axiom,
    ! [A3: nat,B2: nat,S: nat,T4: nat] :
      ( ( ord_less_eq @ nat @ A3 @ B2 )
     => ( ( ord_less @ nat @ S @ T4 )
       => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A3 @ S ) @ ( product_Pair @ nat @ nat @ B2 @ T4 ) ) @ fun_pair_less ) ) ) ).

% pair_lessI2
thf(fact_2106_euclidean__size__times__nonunit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ~ ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ B2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ) ) ).

% euclidean_size_times_nonunit
thf(fact_2107_euclidean__size__1,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) )
        = ( one_one @ nat ) ) ) ).

% euclidean_size_1
thf(fact_2108_rat__one__code,axiom,
    ( ( quotient_of @ ( one_one @ rat ) )
    = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% rat_one_code
thf(fact_2109_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_2110_pair__less__iff1,axiom,
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ Y ) @ ( product_Pair @ nat @ nat @ X @ Z2 ) ) @ fun_pair_less )
      = ( ord_less @ nat @ Y @ Z2 ) ) ).

% pair_less_iff1
thf(fact_2111_quotient__of__number_I4_J,axiom,
    ( ( quotient_of @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
    = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(4)
thf(fact_2112_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_2113_refl__onD,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( refl_on @ A @ A4 @ R4 )
     => ( ( member @ A @ A3 @ A4 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A3 ) @ R4 ) ) ) ).

% refl_onD
thf(fact_2114_refl__onD1,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ( refl_on @ A @ A4 @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
       => ( member @ A @ X @ A4 ) ) ) ).

% refl_onD1
thf(fact_2115_refl__onD2,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ( refl_on @ A @ A4 @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
       => ( member @ A @ Y @ A4 ) ) ) ).

% refl_onD2
thf(fact_2116_refl__on__Int,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),B3: set @ A,S: set @ ( product_prod @ A @ A )] :
      ( ( refl_on @ A @ A4 @ R4 )
     => ( ( refl_on @ A @ B3 @ S )
       => ( refl_on @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S ) ) ) ) ).

% refl_on_Int
thf(fact_2117_quotient__of__div,axiom,
    ! [R4: rat,N: int,D2: int] :
      ( ( ( quotient_of @ R4 )
        = ( product_Pair @ int @ int @ N @ D2 ) )
     => ( R4
        = ( divide_divide @ rat @ ( ring_1_of_int @ rat @ N ) @ ( ring_1_of_int @ rat @ D2 ) ) ) ) ).

% quotient_of_div
thf(fact_2118_euclidean__size__unit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( euclid6346220572633701492n_size @ A @ A3 )
            = ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) ) ) ) ) ).

% euclidean_size_unit
thf(fact_2119_euclidean__size__mult,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A3: A,B2: A] :
          ( ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ nat @ ( euclid6346220572633701492n_size @ A @ A3 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ).

% euclidean_size_mult
thf(fact_2120_refl__on__empty,axiom,
    ! [A: $tType] : ( refl_on @ A @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% refl_on_empty
thf(fact_2121_unit__iff__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
          = ( ( ( euclid6346220572633701492n_size @ A @ A3 )
              = ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) ) )
            & ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% unit_iff_euclidean_size
thf(fact_2122_size__mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A3 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ B2 @ A3 ) ) ) ) ) ).

% size_mult_mono'
thf(fact_2123_size__mult__mono,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A3 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% size_mult_mono
thf(fact_2124_euclidean__size__times__unit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ).

% euclidean_size_times_unit
thf(fact_2125_quotient__of__denom__pos,axiom,
    ! [R4: rat,P4: int,Q4: int] :
      ( ( ( quotient_of @ R4 )
        = ( product_Pair @ int @ int @ P4 @ Q4 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q4 ) ) ).

% quotient_of_denom_pos
thf(fact_2126_pair__lessI1,axiom,
    ! [A3: nat,B2: nat,S: nat,T4: nat] :
      ( ( ord_less @ nat @ A3 @ B2 )
     => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A3 @ S ) @ ( product_Pair @ nat @ nat @ B2 @ T4 ) ) @ fun_pair_less ) ) ).

% pair_lessI1
thf(fact_2127_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A4 ) )
     => ( A4
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_2128_rat__sgn__code,axiom,
    ! [P4: rat] :
      ( ( quotient_of @ ( sgn_sgn @ rat @ P4 ) )
      = ( product_Pair @ int @ int @ ( sgn_sgn @ int @ ( product_fst @ int @ int @ ( quotient_of @ P4 ) ) ) @ ( one_one @ int ) ) ) ).

% rat_sgn_code
thf(fact_2129_card_Oempty,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ nat ) ) ).

% card.empty
thf(fact_2130_card__Diff__singleton,axiom,
    ! [A: $tType,X: A,A4: set @ A] :
      ( ( member @ A @ X @ A4 )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A4 ) @ ( one_one @ nat ) ) ) ) ).

% card_Diff_singleton
thf(fact_2131_card__Diff__singleton__if,axiom,
    ! [A: $tType,X: A,A4: set @ A] :
      ( ( ( member @ A @ X @ A4 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A4 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ A4 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( finite_card @ A @ A4 ) ) ) ) ).

% card_Diff_singleton_if
thf(fact_2132_card__3__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X3: A,Y2: A,Z4: A] :
            ( ( S2
              = ( insert2 @ A @ X3 @ ( insert2 @ A @ Y2 @ ( insert2 @ A @ Z4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X3 != Y2 )
            & ( Y2 != Z4 )
            & ( X3 != Z4 ) ) ) ) ).

% card_3_iff
thf(fact_2133_card__2__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X3: A,Y2: A] :
            ( ( S2
              = ( insert2 @ A @ X3 @ ( insert2 @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X3 != Y2 ) ) ) ) ).

% card_2_iff
thf(fact_2134_card__Diff1__le,axiom,
    ! [A: $tType,A4: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) ) ).

% card_Diff1_le
thf(fact_2135_card__Suc__eq,axiom,
    ! [A: $tType,A4: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A4 )
        = ( suc @ K ) )
      = ( ? [B4: A,B7: set @ A] :
            ( ( A4
              = ( insert2 @ A @ B4 @ B7 ) )
            & ~ ( member @ A @ B4 @ B7 )
            & ( ( finite_card @ A @ B7 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B7
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_2136_card_Ocomp__fun__commute__on,axiom,
    ( ( comp @ nat @ nat @ nat @ suc @ suc )
    = ( comp @ nat @ nat @ nat @ suc @ suc ) ) ).

% card.comp_fun_commute_on
thf(fact_2137_fold__atLeastAtMost__nat_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) )] :
      ~ ! [F10: nat > A > A,A8: nat,B6: nat,Acc: A] :
          ( X
         != ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F10 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A8 @ ( product_Pair @ nat @ A @ B6 @ Acc ) ) ) ) ).

% fold_atLeastAtMost_nat.cases
thf(fact_2138_card__1__singletonE,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ( finite_card @ A @ A4 )
        = ( one_one @ nat ) )
     => ~ ! [X2: A] :
            ( A4
           != ( insert2 @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_1_singletonE
thf(fact_2139_card__1__singleton__iff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ( finite_card @ A @ A4 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X3: A] :
            ( A4
            = ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_2140_card__eq__SucD,axiom,
    ! [A: $tType,A4: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A4 )
        = ( suc @ K ) )
     => ? [B6: A,B9: set @ A] :
          ( ( A4
            = ( insert2 @ A @ B6 @ B9 ) )
          & ~ ( member @ A @ B6 @ B9 )
          & ( ( finite_card @ A @ B9 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B9
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_2141_quotient__of__int,axiom,
    ! [A3: int] :
      ( ( quotient_of @ ( of_int @ A3 ) )
      = ( product_Pair @ int @ int @ A3 @ ( one_one @ int ) ) ) ).

% quotient_of_int
thf(fact_2142_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_2143_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: nat > A > A,A1: nat,A22: nat,A32: A,P: ( nat > A > A ) > nat > nat > A > $o] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ A0 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A1 @ ( product_Pair @ nat @ A @ A22 @ A32 ) ) ) )
     => ( ! [F10: nat > A > A,A8: nat,B6: nat,Acc: A] :
            ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F10 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A8 @ ( product_Pair @ nat @ A @ B6 @ Acc ) ) ) )
           => ( ( ~ ( ord_less @ nat @ B6 @ A8 )
               => ( P @ F10 @ ( plus_plus @ nat @ A8 @ ( one_one @ nat ) ) @ B6 @ ( F10 @ A8 @ Acc ) ) )
             => ( P @ F10 @ A8 @ B6 @ Acc ) ) )
       => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ).

% fold_atLeastAtMost_nat.pinduct
thf(fact_2144_divmod__cases,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,A3: A] :
          ( ( ( B2
             != ( zero_zero @ A ) )
           => ( ( ( modulo_modulo @ A @ A3 @ B2 )
                = ( zero_zero @ A ) )
             => ( A3
               != ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) ) ) )
         => ( ( ( B2
               != ( zero_zero @ A ) )
             => ! [Q7: A,R3: A] :
                  ( ( ( euclid7384307370059645450egment @ A @ R3 )
                    = ( euclid7384307370059645450egment @ A @ B2 ) )
                 => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R3 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
                   => ( ( R3
                       != ( zero_zero @ A ) )
                     => ( ( ( divide_divide @ A @ A3 @ B2 )
                          = Q7 )
                       => ( ( ( modulo_modulo @ A @ A3 @ B2 )
                            = R3 )
                         => ( A3
                           != ( plus_plus @ A @ ( times_times @ A @ Q7 @ B2 ) @ R3 ) ) ) ) ) ) ) )
           => ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divmod_cases
thf(fact_2145_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( numeral_numeral @ int @ L ) ) )
      = ( divide_divide @ rat @ ( numeral_numeral @ rat @ K ) @ ( numeral_numeral @ rat @ L ) ) ) ).

% Frct_code_post(6)
thf(fact_2146_mod__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R4: A,Q4: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R4 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R4 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q4 @ B2 ) @ R4 )
                  = A3 )
               => ( ( modulo_modulo @ A @ A3 @ B2 )
                  = R4 ) ) ) ) ) ) ).

% mod_eqI
thf(fact_2147_div__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R4: A,Q4: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R4 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R4 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q4 @ B2 ) @ R4 )
                  = A3 )
               => ( ( divide_divide @ A @ A3 @ B2 )
                  = Q4 ) ) ) ) ) ) ).

% div_eqI
thf(fact_2148_division__segment__1,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( euclid7384307370059645450egment @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% division_segment_1
thf(fact_2149_division__segment__numeral,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [K: num] :
          ( ( euclid7384307370059645450egment @ A @ ( numeral_numeral @ A @ K ) )
          = ( one_one @ A ) ) ) ).

% division_segment_numeral
thf(fact_2150_division__segment__of__nat,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( euclid7384307370059645450egment @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( one_one @ A ) ) ) ).

% division_segment_of_nat
thf(fact_2151_division__segment__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A3 ) @ ( semiring_1_of_nat @ A @ ( euclid6346220572633701492n_size @ A @ A3 ) ) )
          = A3 ) ) ).

% division_segment_euclidean_size
thf(fact_2152_division__segment__mult,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( euclid7384307370059645450egment @ A @ ( times_times @ A @ A3 @ B2 ) )
              = ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A3 ) @ ( euclid7384307370059645450egment @ A @ B2 ) ) ) ) ) ) ).

% division_segment_mult
thf(fact_2153_is__unit__division__segment,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A3: A] : ( dvd_dvd @ A @ ( euclid7384307370059645450egment @ A @ A3 ) @ ( one_one @ A ) ) ) ).

% is_unit_division_segment
thf(fact_2154_Frct__code__post_I2_J,axiom,
    ! [A3: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A3 @ ( zero_zero @ int ) ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(2)
thf(fact_2155_Frct__code__post_I1_J,axiom,
    ! [A3: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A3 ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(1)
thf(fact_2156_Frct__code__post_I3_J,axiom,
    ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) )
    = ( one_one @ rat ) ) ).

% Frct_code_post(3)
thf(fact_2157_Frct__code__post_I7_J,axiom,
    ! [A3: int,B2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ A3 ) @ B2 ) )
      = ( uminus_uminus @ rat @ ( frct @ ( product_Pair @ int @ int @ A3 @ B2 ) ) ) ) ).

% Frct_code_post(7)
thf(fact_2158_Frct__code__post_I8_J,axiom,
    ! [A3: int,B2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A3 @ ( uminus_uminus @ int @ B2 ) ) )
      = ( uminus_uminus @ rat @ ( frct @ ( product_Pair @ int @ int @ A3 @ B2 ) ) ) ) ).

% Frct_code_post(8)
thf(fact_2159_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_2160_div__bounded,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R4: A,Q4: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R4 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R4 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ Q4 @ B2 ) @ R4 ) @ B2 )
                = Q4 ) ) ) ) ) ).

% div_bounded
thf(fact_2161_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb @ Xc )
        = Y )
     => ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb @ Xc ) ) ) )
       => ~ ( ( ( ( ord_less @ nat @ Xb @ Xa )
               => ( Y = Xc ) )
              & ( ~ ( ord_less @ nat @ Xb @ Xa )
               => ( Y
                  = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X @ Xa @ Xc ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb @ Xc ) ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
thf(fact_2162_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F: nat > A > A,A3: nat,B2: nat,Acc2: A] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A3 @ ( product_Pair @ nat @ A @ B2 @ Acc2 ) ) ) )
     => ( ( ( ord_less @ nat @ B2 @ A3 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F @ A3 @ B2 @ Acc2 )
            = Acc2 ) )
        & ( ~ ( ord_less @ nat @ B2 @ A3 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F @ A3 @ B2 @ Acc2 )
            = ( set_fo6178422350223883121st_nat @ A @ F @ ( plus_plus @ nat @ A3 @ ( one_one @ nat ) ) @ B2 @ ( F @ A3 @ Acc2 ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
thf(fact_2163_refl__on__domain,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( refl_on @ A @ A4 @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
       => ( ( member @ A @ A3 @ A4 )
          & ( member @ A @ B2 @ A4 ) ) ) ) ).

% refl_on_domain
thf(fact_2164_smin__insertI,axiom,
    ! [X: product_prod @ nat @ nat,XS: set @ ( product_prod @ nat @ nat ),Y: product_prod @ nat @ nat,YS: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ X @ XS )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_less )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS @ YS ) @ fun_min_strict )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS @ ( insert2 @ ( product_prod @ nat @ nat ) @ Y @ YS ) ) @ fun_min_strict ) ) ) ) ).

% smin_insertI
thf(fact_2165_pair__leqI2,axiom,
    ! [A3: nat,B2: nat,S: nat,T4: nat] :
      ( ( ord_less_eq @ nat @ A3 @ B2 )
     => ( ( ord_less_eq @ nat @ S @ T4 )
       => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A3 @ S ) @ ( product_Pair @ nat @ nat @ B2 @ T4 ) ) @ fun_pair_leq ) ) ) ).

% pair_leqI2
thf(fact_2166_pair__leqI1,axiom,
    ! [A3: nat,B2: nat,S: nat,T4: nat] :
      ( ( ord_less @ nat @ A3 @ B2 )
     => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A3 @ S ) @ ( product_Pair @ nat @ nat @ B2 @ T4 ) ) @ fun_pair_leq ) ) ).

% pair_leqI1
thf(fact_2167_zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ) ).

% zero_rat_def
thf(fact_2168_smin__emptyI,axiom,
    ! [X5: set @ ( product_prod @ nat @ nat )] :
      ( ( X5
       != ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ X5 @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_min_strict ) ) ).

% smin_emptyI
thf(fact_2169_one__rat__def,axiom,
    ( ( one_one @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ) ) ).

% one_rat_def
thf(fact_2170_wmin__insertI,axiom,
    ! [X: product_prod @ nat @ nat,XS: set @ ( product_prod @ nat @ nat ),Y: product_prod @ nat @ nat,YS: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ X @ XS )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_leq )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS @ YS ) @ fun_min_weak )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS @ ( insert2 @ ( product_prod @ nat @ nat ) @ Y @ YS ) ) @ fun_min_weak ) ) ) ) ).

% wmin_insertI
thf(fact_2171_wmax__insertI,axiom,
    ! [Y: product_prod @ nat @ nat,YS: set @ ( product_prod @ nat @ nat ),X: product_prod @ nat @ nat,XS: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ Y @ YS )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_leq )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS @ YS ) @ fun_max_weak )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( insert2 @ ( product_prod @ nat @ nat ) @ X @ XS ) @ YS ) @ fun_max_weak ) ) ) ) ).

% wmax_insertI
thf(fact_2172_smax__insertI,axiom,
    ! [Y: product_prod @ nat @ nat,Y6: set @ ( product_prod @ nat @ nat ),X: product_prod @ nat @ nat,X5: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ Y @ Y6 )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_less )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ X5 @ Y6 ) @ fun_max_strict )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( insert2 @ ( product_prod @ nat @ nat ) @ X @ X5 ) @ Y6 ) @ fun_max_strict ) ) ) ) ).

% smax_insertI
thf(fact_2173_linear__order__on__singleton,axiom,
    ! [A: $tType,X: A] : ( order_679001287576687338der_on @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% linear_order_on_singleton
thf(fact_2174_uminus__rat_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( uminus_uminus @ rat @ ( abs_Rat @ X ) )
        = ( abs_Rat @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( product_fst @ int @ int @ X ) ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ).

% uminus_rat.abs_eq
thf(fact_2175_Total__subset__Id,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( total_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( id2 @ A ) )
       => ( ( R4
            = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
          | ? [A8: A] :
              ( R4
              = ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A8 @ A8 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ) ) ).

% Total_subset_Id
thf(fact_2176_plus__rat_Oabs__eq,axiom,
    ! [Xa: product_prod @ int @ int,X: product_prod @ int @ int] :
      ( ( ratrel @ Xa @ Xa )
     => ( ( ratrel @ X @ X )
       => ( ( plus_plus @ rat @ ( abs_Rat @ Xa ) @ ( abs_Rat @ X ) )
          = ( abs_Rat @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ) ).

% plus_rat.abs_eq
thf(fact_2177_IdI,axiom,
    ! [A: $tType,A3: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A3 ) @ ( id2 @ A ) ) ).

% IdI
thf(fact_2178_pair__in__Id__conv,axiom,
    ! [A: $tType,A3: A,B2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( id2 @ A ) )
      = ( A3 = B2 ) ) ).

% pair_in_Id_conv
thf(fact_2179_Linear__order__in__diff__Id,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( order_679001287576687338der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ B2 @ ( field2 @ A @ R4 ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
            = ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A3 ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( id2 @ A ) ) ) ) ) ) ) ) ).

% Linear_order_in_diff_Id
thf(fact_2180_IdE,axiom,
    ! [A: $tType,P4: product_prod @ A @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ ( id2 @ A ) )
     => ~ ! [X2: A] :
            ( P4
           != ( product_Pair @ A @ A @ X2 @ X2 ) ) ) ).

% IdE
thf(fact_2181_BNF__Greatest__Fixpoint_OIdD,axiom,
    ! [A: $tType,A3: A,B2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( id2 @ A ) )
     => ( A3 = B2 ) ) ).

% BNF_Greatest_Fixpoint.IdD
thf(fact_2182_one__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ).

% one_rat.rsp
thf(fact_2183_lnear__order__on__empty,axiom,
    ! [A: $tType] : ( order_679001287576687338der_on @ A @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% lnear_order_on_empty
thf(fact_2184_zero__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ).

% zero_rat.rsp
thf(fact_2185_wmin__emptyI,axiom,
    ! [X5: set @ ( product_prod @ nat @ nat )] : ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ X5 @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_min_weak ) ).

% wmin_emptyI
thf(fact_2186_times__rat_Oabs__eq,axiom,
    ! [Xa: product_prod @ int @ int,X: product_prod @ int @ int] :
      ( ( ratrel @ Xa @ Xa )
     => ( ( ratrel @ X @ X )
       => ( ( times_times @ rat @ ( abs_Rat @ Xa ) @ ( abs_Rat @ X ) )
          = ( abs_Rat @ ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ Xa ) @ ( product_fst @ int @ int @ X ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ) ).

% times_rat.abs_eq
thf(fact_2187_min__weak__def,axiom,
    ( fun_min_weak
    = ( sup_sup @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( min_ext @ ( product_prod @ nat @ nat ) @ fun_pair_leq ) @ ( insert2 @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) ) ) ) ) ).

% min_weak_def
thf(fact_2188_max__weak__def,axiom,
    ( fun_max_weak
    = ( sup_sup @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( max_ext @ ( product_prod @ nat @ nat ) @ fun_pair_leq ) @ ( insert2 @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) ) ) ) ) ).

% max_weak_def
thf(fact_2189_inverse__rat_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( inverse_inverse @ rat @ ( abs_Rat @ X ) )
        = ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_fst @ int @ int @ X )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) ) ) ) ) ).

% inverse_rat.abs_eq
thf(fact_2190_min__rpair__set,axiom,
    fun_reduction_pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_min_strict @ fun_min_weak ) ).

% min_rpair_set
thf(fact_2191_max__rpair__set,axiom,
    fun_reduction_pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_max_strict @ fun_max_weak ) ).

% max_rpair_set
thf(fact_2192_Linear__order__wf__diff__Id,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( order_679001287576687338der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( wf @ A @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( id2 @ A ) ) )
        = ( ! [A10: set @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ A10 @ ( field2 @ A @ R4 ) )
             => ( ( A10
                 != ( bot_bot @ ( set @ A ) ) )
               => ? [X3: A] :
                    ( ( member @ A @ X3 @ A10 )
                    & ! [Y2: A] :
                        ( ( member @ A @ Y2 @ A10 )
                       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) ) ) ) ) ) ) ) ).

% Linear_order_wf_diff_Id
thf(fact_2193_zero__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( zero_zero @ rat ) ).

% zero_rat.transfer
thf(fact_2194_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_2195_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_2196_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( ( inverse_inverse @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_2197_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A3 @ ( inverse_inverse @ A @ A3 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_2198_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ A3 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_2199_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_2200_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_2201_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y: A,X: A] :
          ( ( ( times_times @ A @ Y @ X )
            = ( times_times @ A @ X @ Y ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y ) @ X )
            = ( times_times @ A @ X @ ( inverse_inverse @ A @ Y ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_2202_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A3 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_2203_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A3 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_2204_wf__iff__no__infinite__down__chain,axiom,
    ! [A: $tType] :
      ( ( wf @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ~ ? [F2: nat > A] :
              ! [I2: nat] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) ) @ R5 ) ) ) ).

% wf_iff_no_infinite_down_chain
thf(fact_2205_wf__no__infinite__down__chainE,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),F: nat > A] :
      ( ( wf @ A @ R4 )
     => ~ ! [K2: nat] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F @ ( suc @ K2 ) ) @ ( F @ K2 ) ) @ R4 ) ) ).

% wf_no_infinite_down_chainE
thf(fact_2206_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ A5 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_2207_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ A5 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% divide_inverse
thf(fact_2208_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A5: A,B4: A] : ( times_times @ A @ ( inverse_inverse @ A @ B4 ) @ A5 ) ) ) ) ).

% divide_inverse_commute
thf(fact_2209_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_2210_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M4: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M4 ) @ ( inverse_inverse @ A @ X ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X ) @ ( power_power @ A @ X @ M4 ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_2211_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M4: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M4 ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) @ ( power_power @ A @ X @ M4 ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_2212_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: nat,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_2213_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: int,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_2214_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_le_1_iff
thf(fact_2215_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% one_less_inverse
thf(fact_2216_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_2217_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ ( plus_plus @ A @ A3 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_2218_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( inverse_inverse @ A @ A3 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_2219_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ A3 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_2220_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ ( minus_minus @ A @ B2 @ A3 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_2221_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A3 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A3 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_2222_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_2223_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less @ A @ B2 @ A3 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A3 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_2224_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_2225_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_less_1_iff
thf(fact_2226_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% one_le_inverse
thf(fact_2227_wf__eq__minimal2,axiom,
    ! [A: $tType] :
      ( ( wf @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [A10: set @ A] :
            ( ( ( ord_less_eq @ ( set @ A ) @ A10 @ ( field2 @ A @ R5 ) )
              & ( A10
               != ( bot_bot @ ( set @ A ) ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A10 )
                & ! [Y2: A] :
                    ( ( member @ A @ Y2 @ A10 )
                   => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R5 ) ) ) ) ) ) ).

% wf_eq_minimal2
thf(fact_2228_one__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) @ ( one_one @ rat ) ).

% one_rat.transfer
thf(fact_2229_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M4: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M4 @ N )
           => ( ( power_power @ A @ X @ ( minus_minus @ nat @ N @ M4 ) )
              = ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ M4 ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_2230_wf__empty,axiom,
    ! [A: $tType] : ( wf @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% wf_empty
thf(fact_2231_wf__bounded__measure,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Ub: A > nat,F: A > nat] :
      ( ! [A8: A,B6: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A8 ) @ R4 )
         => ( ( ord_less_eq @ nat @ ( Ub @ B6 ) @ ( Ub @ A8 ) )
            & ( ord_less_eq @ nat @ ( F @ B6 ) @ ( Ub @ A8 ) )
            & ( ord_less @ nat @ ( F @ A8 ) @ ( F @ B6 ) ) ) )
     => ( wf @ A @ R4 ) ) ).

% wf_bounded_measure
thf(fact_2232_max__ext__additive,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,R: set @ ( product_prod @ A @ A ),C3: set @ A,D4: set @ A] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A4 @ B3 ) @ ( max_ext @ A @ R ) )
     => ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ C3 @ D4 ) @ ( max_ext @ A @ R ) )
       => ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ C3 ) @ ( sup_sup @ ( set @ A ) @ B3 @ D4 ) ) @ ( max_ext @ A @ R ) ) ) ) ).

% max_ext_additive
thf(fact_2233_wfE__min_H,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Q: set @ A] :
      ( ( wf @ A @ R )
     => ( ( Q
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ! [Z3: A] :
              ( ( member @ A @ Z3 @ Q )
             => ~ ! [Y5: A] :
                    ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z3 ) @ R )
                   => ~ ( member @ A @ Y5 @ Q ) ) ) ) ) ).

% wfE_min'
thf(fact_2234_wf__Int1,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R4 )
     => ( wf @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R6 ) ) ) ).

% wf_Int1
thf(fact_2235_wf__Int2,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R4 )
     => ( wf @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) ) ) ).

% wf_Int2
thf(fact_2236_wf__def,axiom,
    ! [A: $tType] :
      ( ( wf @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [P3: A > $o] :
            ( ! [X3: A] :
                ( ! [Y2: A] :
                    ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R5 )
                   => ( P3 @ Y2 ) )
               => ( P3 @ X3 ) )
           => ! [X8: A] : ( P3 @ X8 ) ) ) ) ).

% wf_def
thf(fact_2237_wf__induct__rule,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),P: A > $o,A3: A] :
      ( ( wf @ A @ R4 )
     => ( ! [X2: A] :
            ( ! [Y5: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ X2 ) @ R4 )
               => ( P @ Y5 ) )
           => ( P @ X2 ) )
       => ( P @ A3 ) ) ) ).

% wf_induct_rule
thf(fact_2238_wf__eq__minimal,axiom,
    ! [A: $tType] :
      ( ( wf @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [Q3: set @ A] :
            ( ? [X3: A] : ( member @ A @ X3 @ Q3 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ Q3 )
                & ! [Y2: A] :
                    ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R5 )
                   => ~ ( member @ A @ Y2 @ Q3 ) ) ) ) ) ) ).

% wf_eq_minimal
thf(fact_2239_wf__not__refl,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( wf @ A @ R4 )
     => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A3 ) @ R4 ) ) ).

% wf_not_refl
thf(fact_2240_wf__not__sym,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,X: A] :
      ( ( wf @ A @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ X ) @ R4 )
       => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ A3 ) @ R4 ) ) ) ).

% wf_not_sym
thf(fact_2241_wf__irrefl,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( wf @ A @ R4 )
     => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A3 ) @ R4 ) ) ).

% wf_irrefl
thf(fact_2242_wf__induct,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),P: A > $o,A3: A] :
      ( ( wf @ A @ R4 )
     => ( ! [X2: A] :
            ( ! [Y5: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ X2 ) @ R4 )
               => ( P @ Y5 ) )
           => ( P @ X2 ) )
       => ( P @ A3 ) ) ) ).

% wf_induct
thf(fact_2243_wf__asym,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,X: A] :
      ( ( wf @ A @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ X ) @ R4 )
       => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ A3 ) @ R4 ) ) ) ).

% wf_asym
thf(fact_2244_wfUNIVI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ! [P5: A > $o,X2: A] :
          ( ! [Xa2: A] :
              ( ! [Y3: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Xa2 ) @ R4 )
                 => ( P5 @ Y3 ) )
             => ( P5 @ Xa2 ) )
         => ( P5 @ X2 ) )
     => ( wf @ A @ R4 ) ) ).

% wfUNIVI
thf(fact_2245_wfI__min,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ! [X2: A,Q5: set @ A] :
          ( ( member @ A @ X2 @ Q5 )
         => ? [Xa2: A] :
              ( ( member @ A @ Xa2 @ Q5 )
              & ! [Y3: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Xa2 ) @ R )
                 => ~ ( member @ A @ Y3 @ Q5 ) ) ) )
     => ( wf @ A @ R ) ) ).

% wfI_min
thf(fact_2246_wfE__min,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: A,Q: set @ A] :
      ( ( wf @ A @ R )
     => ( ( member @ A @ X @ Q )
       => ~ ! [Z3: A] :
              ( ( member @ A @ Z3 @ Q )
             => ~ ! [Y5: A] :
                    ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z3 ) @ R )
                   => ~ ( member @ A @ Y5 @ Q ) ) ) ) ) ).

% wfE_min
thf(fact_2247_in__measure,axiom,
    ! [A: $tType,X: A,Y: A,F: A > nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measure @ A @ F ) )
      = ( ord_less @ nat @ ( F @ X ) @ ( F @ Y ) ) ) ).

% in_measure
thf(fact_2248_in__lex__prod,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,A6: A,B5: B,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ ( product_Pair @ A @ B @ A6 @ B5 ) ) @ ( lex_prod @ A @ B @ R4 @ S ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A6 ) @ R4 )
        | ( ( A3 = A6 )
          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B2 @ B5 ) @ S ) ) ) ) ).

% in_lex_prod
thf(fact_2249_dependent__wf__choice,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ A ),P: ( A > B ) > A > B > $o] :
      ( ( wf @ A @ R )
     => ( ! [F10: A > B,G4: A > B,X2: A,R3: B] :
            ( ! [Z6: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z6 @ X2 ) @ R )
               => ( ( F10 @ Z6 )
                  = ( G4 @ Z6 ) ) )
           => ( ( P @ F10 @ X2 @ R3 )
              = ( P @ G4 @ X2 @ R3 ) ) )
       => ( ! [X2: A,F10: A > B] :
              ( ! [Y5: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ X2 ) @ R )
                 => ( P @ F10 @ Y5 @ ( F10 @ Y5 ) ) )
             => ? [X_12: B] : ( P @ F10 @ X2 @ X_12 ) )
         => ? [F10: A > B] :
            ! [X6: A] : ( P @ F10 @ X6 @ ( F10 @ X6 ) ) ) ) ) ).

% dependent_wf_choice
thf(fact_2250_wo__rel_Ocases__Total3,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A,Phi: A > A > $o] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ A3 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( field2 @ A @ R4 ) )
       => ( ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( id2 @ A ) ) )
              | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A3 ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( id2 @ A ) ) ) )
           => ( Phi @ A3 @ B2 ) )
         => ( ( ( A3 = B2 )
             => ( Phi @ A3 @ B2 ) )
           => ( Phi @ A3 @ B2 ) ) ) ) ) ).

% wo_rel.cases_Total3
thf(fact_2251_of__rat__neg__one,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% of_rat_neg_one
thf(fact_2252_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_2253_of__rat__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( one_one @ rat ) )
        = ( one_one @ A ) ) ) ).

% of_rat_1
thf(fact_2254_of__rat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: rat] :
          ( ( ( field_char_0_of_rat @ A @ A3 )
            = ( one_one @ A ) )
          = ( A3
            = ( one_one @ rat ) ) ) ) ).

% of_rat_eq_1_iff
thf(fact_2255_one__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: rat] :
          ( ( ( one_one @ A )
            = ( field_char_0_of_rat @ A @ A3 ) )
          = ( ( one_one @ rat )
            = A3 ) ) ) ).

% one_eq_of_rat_iff
thf(fact_2256_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R4: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R4 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ rat @ R4 @ ( one_one @ rat ) ) ) ) ).

% of_rat_le_1_iff
thf(fact_2257_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R4: rat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R4 ) )
          = ( ord_less_eq @ rat @ ( one_one @ rat ) @ R4 ) ) ) ).

% one_le_of_rat_iff
thf(fact_2258_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R4: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R4 ) @ ( one_one @ A ) )
          = ( ord_less @ rat @ R4 @ ( one_one @ rat ) ) ) ) ).

% of_rat_less_1_iff
thf(fact_2259_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R4: rat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R4 ) )
          = ( ord_less @ rat @ ( one_one @ rat ) @ R4 ) ) ) ).

% one_less_of_rat_iff
thf(fact_2260_wo__rel_Owell__order__induct,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),P: A > $o,A3: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ! [X2: A] :
            ( ! [Y5: A] :
                ( ( ( Y5 != X2 )
                  & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ X2 ) @ R4 ) )
               => ( P @ Y5 ) )
           => ( P @ X2 ) )
       => ( P @ A3 ) ) ) ).

% wo_rel.well_order_induct
thf(fact_2261_wo__rel_OTOTALS,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ! [X6: A] :
          ( ( member @ A @ X6 @ ( field2 @ A @ R4 ) )
         => ! [Xa2: A] :
              ( ( member @ A @ Xa2 @ ( field2 @ A @ R4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ Xa2 ) @ R4 )
                | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Xa2 @ X6 ) @ R4 ) ) ) ) ) ).

% wo_rel.TOTALS
thf(fact_2262_well__order__induct__imp,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),P: A > $o,A3: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ! [X2: A] :
            ( ! [Y5: A] :
                ( ( ( Y5 != X2 )
                  & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ X2 ) @ R4 ) )
               => ( ( member @ A @ Y5 @ ( field2 @ A @ R4 ) )
                 => ( P @ Y5 ) ) )
           => ( ( member @ A @ X2 @ ( field2 @ A @ R4 ) )
             => ( P @ X2 ) ) )
       => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
         => ( P @ A3 ) ) ) ) ).

% well_order_induct_imp
thf(fact_2263_of__rat__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( times_times @ rat @ A3 @ B2 ) )
          = ( times_times @ A @ ( field_char_0_of_rat @ A @ A3 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_mult
thf(fact_2264_wo__rel_Ocases__Total,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A,Phi: A > A > $o] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ A3 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( field2 @ A @ R4 ) )
       => ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
           => ( Phi @ A3 @ B2 ) )
         => ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A3 ) @ R4 )
             => ( Phi @ A3 @ B2 ) )
           => ( Phi @ A3 @ B2 ) ) ) ) ) ).

% wo_rel.cases_Total
thf(fact_2265_wo__rel_OWell__order__isMinim__exists,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
       => ( ( B3
           != ( bot_bot @ ( set @ A ) ) )
         => ? [X_1: A] : ( bNF_We4791949203932849705sMinim @ A @ R4 @ B3 @ X_1 ) ) ) ) ).

% wo_rel.Well_order_isMinim_exists
thf(fact_2266_wo__rel_Ominim__in,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
       => ( ( B3
           != ( bot_bot @ ( set @ A ) ) )
         => ( member @ A @ ( bNF_We6954850376910717587_minim @ A @ R4 @ B3 ) @ B3 ) ) ) ) ).

% wo_rel.minim_in
thf(fact_2267_wo__rel_Ominim__inField,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
       => ( ( B3
           != ( bot_bot @ ( set @ A ) ) )
         => ( member @ A @ ( bNF_We6954850376910717587_minim @ A @ R4 @ B3 ) @ ( field2 @ A @ R4 ) ) ) ) ) ).

% wo_rel.minim_inField
thf(fact_2268_wo__rel_Oequals__minim,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ A,A3: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ A3 @ B3 )
         => ( ! [B6: A] :
                ( ( member @ A @ B6 @ B3 )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B6 ) @ R4 ) )
           => ( A3
              = ( bNF_We6954850376910717587_minim @ A @ R4 @ B3 ) ) ) ) ) ) ).

% wo_rel.equals_minim
thf(fact_2269_wo__rel_Ominim__least,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ A,B2: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ B2 @ B3 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( bNF_We6954850376910717587_minim @ A @ R4 @ B3 ) @ B2 ) @ R4 ) ) ) ) ).

% wo_rel.minim_least
thf(fact_2270_wo__rel_Omax2__greater__among,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ B2 @ ( field2 @ A @ R4 ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A3 @ B2 ) ) @ R4 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A3 @ B2 ) ) @ R4 )
            & ( member @ A @ ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A3 @ B2 ) @ ( insert2 @ A @ A3 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% wo_rel.max2_greater_among
thf(fact_2271_wo__rel_Omax2__def,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
         => ( ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A3 @ B2 )
            = B2 ) )
        & ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
         => ( ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A3 @ B2 )
            = A3 ) ) ) ) ).

% wo_rel.max2_def
thf(fact_2272_wo__rel_Ominim__isMinim,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
       => ( ( B3
           != ( bot_bot @ ( set @ A ) ) )
         => ( bNF_We4791949203932849705sMinim @ A @ R4 @ B3 @ ( bNF_We6954850376910717587_minim @ A @ R4 @ B3 ) ) ) ) ) ).

% wo_rel.minim_isMinim
thf(fact_2273_wo__rel_OisMinim__def,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B2: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( bNF_We4791949203932849705sMinim @ A @ R4 @ A4 @ B2 )
        = ( ( member @ A @ B2 @ A4 )
          & ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ X3 ) @ R4 ) ) ) ) ) ).

% wo_rel.isMinim_def
thf(fact_2274_wo__rel_Omax2__equals1,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ B2 @ ( field2 @ A @ R4 ) )
         => ( ( ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A3 @ B2 )
              = A3 )
            = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A3 ) @ R4 ) ) ) ) ) ).

% wo_rel.max2_equals1
thf(fact_2275_wo__rel_Omax2__equals2,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ B2 @ ( field2 @ A @ R4 ) )
         => ( ( ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A3 @ B2 )
              = B2 )
            = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) ) ) ) ) ).

% wo_rel.max2_equals2
thf(fact_2276_wo__rel_Omax2__greater,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ B2 @ ( field2 @ A @ R4 ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A3 @ B2 ) ) @ R4 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A3 @ B2 ) ) @ R4 ) ) ) ) ) ).

% wo_rel.max2_greater
thf(fact_2277_wo__rel_Omax2__among,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ B2 @ ( field2 @ A @ R4 ) )
         => ( member @ A @ ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A3 @ B2 ) @ ( insert2 @ A @ A3 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% wo_rel.max2_among
thf(fact_2278_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I2: int,J: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J @ I2 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert2 @ int @ I2 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J ) ) ) ) ) ).

% simp_from_to
thf(fact_2279_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X: A,Y: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X ) @ ( times_times @ A @ C2 @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X @ Y )
               => ( ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y ) @ ( times_times @ A @ C2 @ X ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X @ Y )
               => ( ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_2280_one__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( one_one @ int ) ).

% one_int.transfer
thf(fact_2281_less__than__iff,axiom,
    ! [X: nat,Y: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ Y ) @ less_than )
      = ( ord_less @ nat @ X @ Y ) ) ).

% less_than_iff
thf(fact_2282_card__Un__disjoint,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B3 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_2283_reduction__pairI,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R @ S2 ) @ R )
       => ( fun_reduction_pair @ A @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R @ S2 ) ) ) ) ).

% reduction_pairI
thf(fact_2284_finite__Int,axiom,
    ! [A: $tType,F3: set @ A,G6: set @ A] :
      ( ( ( finite_finite @ A @ F3 )
        | ( finite_finite @ A @ G6 ) )
     => ( finite_finite @ A @ ( inf_inf @ ( set @ A ) @ F3 @ G6 ) ) ) ).

% finite_Int
thf(fact_2285_relcomp__empty1,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ C ) ) ) @ R )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% relcomp_empty1
thf(fact_2286_relcomp__empty2,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set @ ( product_prod @ A @ C )] :
      ( ( relcomp @ A @ C @ B @ R @ ( bot_bot @ ( set @ ( product_prod @ C @ B ) ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% relcomp_empty2
thf(fact_2287_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_2288_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_2289_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_2290_atLeastAtMost__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A] :
          ( ( set_or1337092689740270186AtMost @ A @ A3 @ A3 )
          = ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastAtMost_singleton
thf(fact_2291_atLeastAtMost__singleton__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
            = ( insert2 @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )
          = ( ( A3 = B2 )
            & ( B2 = C2 ) ) ) ) ).

% atLeastAtMost_singleton_iff
thf(fact_2292_card__0__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ( finite_card @ A @ A4 )
          = ( zero_zero @ nat ) )
        = ( A4
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_0_eq
thf(fact_2293_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image2 @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A3 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_2294_relcompEpair,axiom,
    ! [A: $tType,B: $tType,C: $tType,A3: A,C2: B,R4: set @ ( product_prod @ A @ C ),S: set @ ( product_prod @ C @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ C2 ) @ ( relcomp @ A @ C @ B @ R4 @ S ) )
     => ~ ! [B6: C] :
            ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A3 @ B6 ) @ R4 )
           => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ B6 @ C2 ) @ S ) ) ) ).

% relcompEpair
thf(fact_2295_relcompE,axiom,
    ! [A: $tType,B: $tType,C: $tType,Xz: product_prod @ A @ B,R4: set @ ( product_prod @ A @ C ),S: set @ ( product_prod @ C @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ Xz @ ( relcomp @ A @ C @ B @ R4 @ S ) )
     => ~ ! [X2: A,Y3: C,Z3: B] :
            ( ( Xz
              = ( product_Pair @ A @ B @ X2 @ Z3 ) )
           => ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X2 @ Y3 ) @ R4 )
             => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y3 @ Z3 ) @ S ) ) ) ) ).

% relcompE
thf(fact_2296_relcomp_OrelcompI,axiom,
    ! [A: $tType,C: $tType,B: $tType,A3: A,B2: B,R4: set @ ( product_prod @ A @ B ),C2: C,S: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ R4 )
     => ( ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B2 @ C2 ) @ S )
       => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A3 @ C2 ) @ ( relcomp @ A @ B @ C @ R4 @ S ) ) ) ) ).

% relcomp.relcompI
thf(fact_2297_relcomp_Osimps,axiom,
    ! [B: $tType,C: $tType,A: $tType,A1: A,A22: C,R4: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A1 @ A22 ) @ ( relcomp @ A @ B @ C @ R4 @ S ) )
      = ( ? [A5: A,B4: B,C5: C] :
            ( ( A1 = A5 )
            & ( A22 = C5 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B4 ) @ R4 )
            & ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B4 @ C5 ) @ S ) ) ) ) ).

% relcomp.simps
thf(fact_2298_relcomp_Ocases,axiom,
    ! [A: $tType,C: $tType,B: $tType,A1: A,A22: C,R4: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A1 @ A22 ) @ ( relcomp @ A @ B @ C @ R4 @ S ) )
     => ~ ! [B6: B] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A1 @ B6 ) @ R4 )
           => ~ ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B6 @ A22 ) @ S ) ) ) ).

% relcomp.cases
thf(fact_2299_finite_OemptyI,axiom,
    ! [A: $tType] : ( finite_finite @ A @ ( bot_bot @ ( set @ A ) ) ) ).

% finite.emptyI
thf(fact_2300_infinite__imp__nonempty,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ~ ( finite_finite @ A @ S2 )
     => ( S2
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% infinite_imp_nonempty
thf(fact_2301_atLeastAtMost__singleton_H,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
         => ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
            = ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% atLeastAtMost_singleton'
thf(fact_2302_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ A4 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A4 )
                   => ( ( ord_less_eq @ A @ X2 @ Xa2 )
                     => ( X2 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_2303_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ A4 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A4 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X2 )
                     => ( X2 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_2304_wf__no__loop,axiom,
    ! [B: $tType,R: set @ ( product_prod @ B @ B )] :
      ( ( ( relcomp @ B @ B @ B @ R @ R )
        = ( bot_bot @ ( set @ ( product_prod @ B @ B ) ) ) )
     => ( wf @ B @ R ) ) ).

% wf_no_loop
thf(fact_2305_finite_Ocases,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ! [A13: set @ A] :
              ( ? [A8: A] :
                  ( A3
                  = ( insert2 @ A @ A8 @ A13 ) )
             => ~ ( finite_finite @ A @ A13 ) ) ) ) ).

% finite.cases
thf(fact_2306_finite_Osimps,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A5: set @ A] :
            ( ( A5
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A10: set @ A,B4: A] :
                ( ( A5
                  = ( insert2 @ A @ B4 @ A10 ) )
                & ( finite_finite @ A @ A10 ) ) ) ) ) ).

% finite.simps
thf(fact_2307_finite__induct,axiom,
    ! [A: $tType,F3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F3 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X2: A,F7: set @ A] :
              ( ( finite_finite @ A @ F7 )
             => ( ~ ( member @ A @ X2 @ F7 )
               => ( ( P @ F7 )
                 => ( P @ ( insert2 @ A @ X2 @ F7 ) ) ) ) )
         => ( P @ F3 ) ) ) ) ).

% finite_induct
thf(fact_2308_finite__ne__induct,axiom,
    ! [A: $tType,F3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F3 )
     => ( ( F3
         != ( bot_bot @ ( set @ A ) ) )
       => ( ! [X2: A] : ( P @ ( insert2 @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ! [X2: A,F7: set @ A] :
                ( ( finite_finite @ A @ F7 )
               => ( ( F7
                   != ( bot_bot @ ( set @ A ) ) )
                 => ( ~ ( member @ A @ X2 @ F7 )
                   => ( ( P @ F7 )
                     => ( P @ ( insert2 @ A @ X2 @ F7 ) ) ) ) ) )
           => ( P @ F3 ) ) ) ) ) ).

% finite_ne_induct
thf(fact_2309_infinite__finite__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,A4: set @ A] :
      ( ! [A13: set @ A] :
          ( ~ ( finite_finite @ A @ A13 )
         => ( P @ A13 ) )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X2: A,F7: set @ A] :
              ( ( finite_finite @ A @ F7 )
             => ( ~ ( member @ A @ X2 @ F7 )
               => ( ( P @ F7 )
                 => ( P @ ( insert2 @ A @ X2 @ F7 ) ) ) ) )
         => ( P @ A4 ) ) ) ) ).

% infinite_finite_induct
thf(fact_2310_union__comp__emptyL,axiom,
    ! [A: $tType,A4: set @ ( product_prod @ A @ A ),C3: set @ ( product_prod @ A @ A ),B3: set @ ( product_prod @ A @ A )] :
      ( ( ( relcomp @ A @ A @ A @ A4 @ C3 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ( ( relcomp @ A @ A @ A @ B3 @ C3 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ( ( relcomp @ A @ A @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ A4 @ B3 ) @ C3 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ).

% union_comp_emptyL
thf(fact_2311_union__comp__emptyR,axiom,
    ! [A: $tType,A4: set @ ( product_prod @ A @ A ),B3: set @ ( product_prod @ A @ A ),C3: set @ ( product_prod @ A @ A )] :
      ( ( ( relcomp @ A @ A @ A @ A4 @ B3 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ( ( relcomp @ A @ A @ A @ A4 @ C3 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ( ( relcomp @ A @ A @ A @ A4 @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ B3 @ C3 ) )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ).

% union_comp_emptyR
thf(fact_2312_Gcd__remove0__nat,axiom,
    ! [M: set @ nat] :
      ( ( finite_finite @ nat @ M )
     => ( ( gcd_Gcd @ nat @ M )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M @ ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_2313_atLeastAtMost__eq__UNIV__iff,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice @ A )
     => ! [X: A,Y: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ X @ Y )
            = ( top_top @ ( set @ A ) ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% atLeastAtMost_eq_UNIV_iff
thf(fact_2314_finite__subset__induct,axiom,
    ! [A: $tType,F3: set @ A,A4: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ F3 @ A4 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A8: A,F7: set @ A] :
                ( ( finite_finite @ A @ F7 )
               => ( ( member @ A @ A8 @ A4 )
                 => ( ~ ( member @ A @ A8 @ F7 )
                   => ( ( P @ F7 )
                     => ( P @ ( insert2 @ A @ A8 @ F7 ) ) ) ) ) )
           => ( P @ F3 ) ) ) ) ) ).

% finite_subset_induct
thf(fact_2315_finite__subset__induct_H,axiom,
    ! [A: $tType,F3: set @ A,A4: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ F3 @ A4 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A8: A,F7: set @ A] :
                ( ( finite_finite @ A @ F7 )
               => ( ( member @ A @ A8 @ A4 )
                 => ( ( ord_less_eq @ ( set @ A ) @ F7 @ A4 )
                   => ( ~ ( member @ A @ A8 @ F7 )
                     => ( ( P @ F7 )
                       => ( P @ ( insert2 @ A @ A8 @ F7 ) ) ) ) ) ) )
           => ( P @ F3 ) ) ) ) ) ).

% finite_subset_induct'
thf(fact_2316_infinite__remove,axiom,
    ! [A: $tType,S2: set @ A,A3: A] :
      ( ~ ( finite_finite @ A @ S2 )
     => ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_remove
thf(fact_2317_infinite__coinduct,axiom,
    ! [A: $tType,X5: ( set @ A ) > $o,A4: set @ A] :
      ( ( X5 @ A4 )
     => ( ! [A13: set @ A] :
            ( ( X5 @ A13 )
           => ? [X6: A] :
                ( ( member @ A @ X6 @ A13 )
                & ( ( X5 @ ( minus_minus @ ( set @ A ) @ A13 @ ( insert2 @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  | ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A13 @ ( insert2 @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
       => ~ ( finite_finite @ A @ A4 ) ) ) ).

% infinite_coinduct
thf(fact_2318_finite__empty__induct,axiom,
    ! [A: $tType,A4: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ A4 )
     => ( ( P @ A4 )
       => ( ! [A8: A,A13: set @ A] :
              ( ( finite_finite @ A @ A13 )
             => ( ( member @ A @ A8 @ A13 )
               => ( ( P @ A13 )
                 => ( P @ ( minus_minus @ ( set @ A ) @ A13 @ ( insert2 @ A @ A8 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
         => ( P @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% finite_empty_induct
thf(fact_2319_card__eq__0__iff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ( finite_card @ A @ A4 )
        = ( zero_zero @ nat ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite @ A @ A4 ) ) ) ).

% card_eq_0_iff
thf(fact_2320_finite__range__prod,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: B > ( product_prod @ A @ C )] :
      ( ( finite_finite @ A @ ( image2 @ B @ A @ ( comp @ ( product_prod @ A @ C ) @ A @ B @ ( product_fst @ A @ C ) @ F ) @ ( top_top @ ( set @ B ) ) ) )
     => ( ( finite_finite @ C @ ( image2 @ B @ C @ ( comp @ ( product_prod @ A @ C ) @ C @ B @ ( product_snd @ A @ C ) @ F ) @ ( top_top @ ( set @ B ) ) ) )
       => ( finite_finite @ ( product_prod @ A @ C ) @ ( image2 @ B @ ( product_prod @ A @ C ) @ F @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% finite_range_prod
thf(fact_2321_zero__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( zero_zero @ int ) ).

% zero_int.transfer
thf(fact_2322_max__ext__compat,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R @ S2 ) @ R )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( max_ext @ A @ R ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( max_ext @ A @ S2 ) @ ( insert2 @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( max_ext @ A @ R ) ) ) ).

% max_ext_compat
thf(fact_2323_finite__remove__induct,axiom,
    ! [A: $tType,B3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ B3 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A13: set @ A] :
              ( ( finite_finite @ A @ A13 )
             => ( ( A13
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A13 @ B3 )
                 => ( ! [X6: A] :
                        ( ( member @ A @ X6 @ A13 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A13 @ ( insert2 @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A13 ) ) ) ) )
         => ( P @ B3 ) ) ) ) ).

% finite_remove_induct
thf(fact_2324_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B3: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite @ A @ B3 )
         => ( P @ B3 ) )
       => ( ! [A13: set @ A] :
              ( ( finite_finite @ A @ A13 )
             => ( ( A13
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A13 @ B3 )
                 => ( ! [X6: A] :
                        ( ( member @ A @ X6 @ A13 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A13 @ ( insert2 @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A13 ) ) ) ) )
         => ( P @ B3 ) ) ) ) ).

% remove_induct
thf(fact_2325_card__gt__0__iff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A4 ) )
      = ( ( A4
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A4 ) ) ) ).

% card_gt_0_iff
thf(fact_2326_min__ext__compat,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R @ S2 ) @ R )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( min_ext @ A @ R ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( min_ext @ A @ S2 ) @ ( insert2 @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( min_ext @ A @ R ) ) ) ).

% min_ext_compat
thf(fact_2327_card__1__singletonI,axiom,
    ! [A: $tType,S2: set @ A,X: A] :
      ( ( finite_finite @ A @ S2 )
     => ( ( ( finite_card @ A @ S2 )
          = ( one_one @ nat ) )
       => ( ( member @ A @ X @ S2 )
         => ( S2
            = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_1_singletonI
thf(fact_2328_finite__induct__select,axiom,
    ! [A: $tType,S2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ S2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T5: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T5 @ S2 )
             => ( ( P @ T5 )
               => ? [X6: A] :
                    ( ( member @ A @ X6 @ ( minus_minus @ ( set @ A ) @ S2 @ T5 ) )
                    & ( P @ ( insert2 @ A @ X6 @ T5 ) ) ) ) )
         => ( P @ S2 ) ) ) ) ).

% finite_induct_select
thf(fact_2329_card__Un__Int,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B3 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_2330_wf__bounded__set,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),Ub: A > ( set @ B ),F: A > ( set @ B )] :
      ( ! [A8: A,B6: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A8 ) @ R4 )
         => ( ( finite_finite @ B @ ( Ub @ A8 ) )
            & ( ord_less_eq @ ( set @ B ) @ ( Ub @ B6 ) @ ( Ub @ A8 ) )
            & ( ord_less_eq @ ( set @ B ) @ ( F @ B6 ) @ ( Ub @ A8 ) )
            & ( ord_less @ ( set @ B ) @ ( F @ A8 ) @ ( F @ B6 ) ) ) )
     => ( wf @ A @ R4 ) ) ).

% wf_bounded_set
thf(fact_2331_smax__emptyI,axiom,
    ! [Y6: set @ ( product_prod @ nat @ nat )] :
      ( ( finite_finite @ ( product_prod @ nat @ nat ) @ Y6 )
     => ( ( Y6
         != ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ Y6 ) @ fun_max_strict ) ) ) ).

% smax_emptyI
thf(fact_2332_card__Diff__subset__Int,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ) ).

% card_Diff_subset_Int
thf(fact_2333_max__ext_Ocases,axiom,
    ! [A: $tType,A1: set @ A,A22: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A1 @ A22 ) @ ( max_ext @ A @ R ) )
     => ~ ( ( finite_finite @ A @ A1 )
         => ( ( finite_finite @ A @ A22 )
           => ( ( A22
               != ( bot_bot @ ( set @ A ) ) )
             => ~ ! [X6: A] :
                    ( ( member @ A @ X6 @ A1 )
                   => ? [Xa3: A] :
                        ( ( member @ A @ Xa3 @ A22 )
                        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ Xa3 ) @ R ) ) ) ) ) ) ) ).

% max_ext.cases
thf(fact_2334_max__ext_Osimps,axiom,
    ! [A: $tType,A1: set @ A,A22: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A1 @ A22 ) @ ( max_ext @ A @ R ) )
      = ( ( finite_finite @ A @ A1 )
        & ( finite_finite @ A @ A22 )
        & ( A22
         != ( bot_bot @ ( set @ A ) ) )
        & ! [X3: A] :
            ( ( member @ A @ X3 @ A1 )
           => ? [Y2: A] :
                ( ( member @ A @ Y2 @ A22 )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R ) ) ) ) ) ).

% max_ext.simps
thf(fact_2335_max__ext_Omax__extI,axiom,
    ! [A: $tType,X5: set @ A,Y6: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ A @ X5 )
     => ( ( finite_finite @ A @ Y6 )
       => ( ( Y6
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X5 )
               => ? [Xa2: A] :
                    ( ( member @ A @ Xa2 @ Y6 )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Xa2 ) @ R ) ) )
           => ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X5 @ Y6 ) @ ( max_ext @ A @ R ) ) ) ) ) ) ).

% max_ext.max_extI
thf(fact_2336_wmax__emptyI,axiom,
    ! [X5: set @ ( product_prod @ nat @ nat )] :
      ( ( finite_finite @ ( product_prod @ nat @ nat ) @ X5 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ X5 ) @ fun_max_weak ) ) ).

% wmax_emptyI
thf(fact_2337_card__Suc__Diff1,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
          = ( finite_card @ A @ A4 ) ) ) ) ).

% card_Suc_Diff1
thf(fact_2338_card_Oinsert__remove,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_card @ A @ ( insert2 @ A @ X @ A4 ) )
        = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% card.insert_remove
thf(fact_2339_card_Oremove,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ( finite_card @ A @ A4 )
          = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% card.remove
thf(fact_2340_card__Diff1__less__iff,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) )
      = ( ( finite_finite @ A @ A4 )
        & ( member @ A @ X @ A4 ) ) ) ).

% card_Diff1_less_iff
thf(fact_2341_card__Diff2__less,axiom,
    ! [A: $tType,A4: set @ A,X: A,Y: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ( member @ A @ Y @ A4 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_2342_card__Diff1__less,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) ) ) ) ).

% card_Diff1_less
thf(fact_2343_in__finite__psubset,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A4 @ B3 ) @ ( finite_psubset @ A ) )
      = ( ( ord_less @ ( set @ A ) @ A4 @ B3 )
        & ( finite_finite @ A @ B3 ) ) ) ).

% in_finite_psubset
thf(fact_2344_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A4 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A13: set @ A] :
                  ( ( finite_finite @ A @ A13 )
                 => ( ! [X6: A] :
                        ( ( member @ A @ X6 @ A13 )
                       => ( ord_less @ A @ X6 @ B6 ) )
                   => ( ( P @ A13 )
                     => ( P @ ( insert2 @ A @ B6 @ A13 ) ) ) ) )
             => ( P @ A4 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_2345_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A4 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A13: set @ A] :
                  ( ( finite_finite @ A @ A13 )
                 => ( ! [X6: A] :
                        ( ( member @ A @ X6 @ A13 )
                       => ( ord_less @ A @ B6 @ X6 ) )
                   => ( ( P @ A13 )
                     => ( P @ ( insert2 @ A @ B6 @ A13 ) ) ) ) )
             => ( P @ A4 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_2346_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S2: set @ B,P: ( set @ B ) > $o,F: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X2: B,S5: set @ B] :
                  ( ( finite_finite @ B @ S5 )
                 => ( ! [Y5: B] :
                        ( ( member @ B @ Y5 @ S5 )
                       => ( ord_less_eq @ A @ ( F @ Y5 ) @ ( F @ X2 ) ) )
                   => ( ( P @ S5 )
                     => ( P @ ( insert2 @ B @ X2 @ S5 ) ) ) ) )
             => ( P @ S2 ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_2347_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X5: set @ A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X5 )
               => ? [Xa2: A] :
                    ( ( member @ A @ Xa2 @ X5 )
                    & ( ord_less @ A @ X2 @ Xa2 ) ) )
           => ~ ( finite_finite @ A @ X5 ) ) ) ) ).

% infinite_growing
thf(fact_2348_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ S2 )
                & ~ ? [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S2 )
                      & ( ord_less @ A @ Xa2 @ X2 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_2349_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X6: A] :
                  ( ( member @ A @ X6 @ S2 )
                  & ( ord_less @ B @ ( F @ X6 ) @ ( F @ ( lattic7623131987881927897min_on @ A @ B @ F @ S2 ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_2350_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,Y: A,F: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y @ S2 )
             => ( ord_less_eq @ B @ ( F @ ( lattic7623131987881927897min_on @ A @ B @ F @ S2 ) ) @ ( F @ Y ) ) ) ) ) ) ).

% arg_min_least
thf(fact_2351_finite__transitivity__chain,axiom,
    ! [A: $tType,A4: set @ A,R: A > A > $o] :
      ( ( finite_finite @ A @ A4 )
     => ( ! [X2: A] :
            ~ ( R @ X2 @ X2 )
       => ( ! [X2: A,Y3: A,Z3: A] :
              ( ( R @ X2 @ Y3 )
             => ( ( R @ Y3 @ Z3 )
               => ( R @ X2 @ Z3 ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ A4 )
               => ? [Y5: A] :
                    ( ( member @ A @ Y5 @ A4 )
                    & ( R @ X2 @ Y5 ) ) )
           => ( A4
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% finite_transitivity_chain
thf(fact_2352_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( semiring_gcd_Gcd_fin @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert2 @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) )
            & ( finite_finite @ A @ A4 ) ) ) ) ).

% Gcd_fin_0_iff
thf(fact_2353_greaterThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_greaterThan @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_greaterThan @ nat @ K ) @ ( insert2 @ nat @ ( suc @ K ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% greaterThan_Suc
thf(fact_2354_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A4 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.insert_remove
thf(fact_2355_Gcd__fin_Oempty,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_fin.empty
thf(fact_2356_Sup__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Sup_fin.singleton
thf(fact_2357_Gcd__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ~ ( finite_finite @ A @ A4 )
         => ( ( semiring_gcd_Gcd_fin @ A @ A4 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_fin.infinite
thf(fact_2358_inf__Sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A,A3: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A3 @ A4 )
           => ( ( inf_inf @ A @ A3 @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
              = A3 ) ) ) ) ).

% inf_Sup_absorb
thf(fact_2359_is__unit__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ( dvd_dvd @ A @ ( semiring_gcd_Gcd_fin @ A @ A4 ) @ ( one_one @ A ) )
          = ( ( semiring_gcd_Gcd_fin @ A @ A4 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_Gcd_fin_iff
thf(fact_2360_Sup__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A4 ) )
              = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ) ).

% Sup_fin.insert
thf(fact_2361_greaterThan__non__empty,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X: A] :
          ( ( set_ord_greaterThan @ A @ X )
         != ( bot_bot @ ( set @ A ) ) ) ) ).

% greaterThan_non_empty
thf(fact_2362_Sup__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
              = ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ).

% Sup_fin.in_idem
thf(fact_2363_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ X )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                   => ( ord_less_eq @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Sup_fin.bounded_iff
thf(fact_2364_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A8: A] :
                  ( ( member @ A @ A8 @ A4 )
                 => ( ord_less_eq @ A @ A8 @ X ) )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ X ) ) ) ) ) ).

% Sup_fin.boundedI
thf(fact_2365_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ X )
             => ! [A14: A] :
                  ( ( member @ A @ A14 @ A4 )
                 => ( ord_less_eq @ A @ A14 @ X ) ) ) ) ) ) ).

% Sup_fin.boundedE
thf(fact_2366_ivl__disj__int__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(7)
thf(fact_2367_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ B3 ) ) ) ) ) ) ).

% Sup_fin.subset_imp
thf(fact_2368_Sup__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X2: A,Y3: A] :
              ( ( H2 @ ( sup_sup @ A @ X2 @ Y3 ) )
              = ( sup_sup @ A @ ( H2 @ X2 ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic5882676163264333800up_fin @ A @ N4 ) )
                = ( lattic5882676163264333800up_fin @ A @ ( image2 @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% Sup_fin.hom_commute
thf(fact_2369_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A4 )
             => ( ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ B3 ) @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
                = ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ) ).

% Sup_fin.subset
thf(fact_2370_Sup__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X2: A,Y3: A] : ( member @ A @ ( sup_sup @ A @ X2 @ Y3 ) @ ( insert2 @ A @ X2 @ ( insert2 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Sup_fin.closed
thf(fact_2371_Sup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A4 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
thf(fact_2372_Sup__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ( B3
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
                  = ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ B3 ) ) ) ) ) ) ) ) ).

% Sup_fin.union
thf(fact_2373_arg__min__if__finite_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic7623131987881927897min_on @ A @ B @ F @ S2 ) @ S2 ) ) ) ) ).

% arg_min_if_finite(1)
thf(fact_2374_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A4 )
                  = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.remove
thf(fact_2375_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
          = ( infini527867602293511546merate @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert2 @ A @ ( infini527867602293511546merate @ A @ S2 @ ( zero_zero @ nat ) ) @ ( bot_bot @ ( set @ A ) ) ) ) @ N ) ) ) ).

% enumerate_Suc'
thf(fact_2376_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A4 )
                  = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.remove
thf(fact_2377_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A4 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.insert_remove
thf(fact_2378_Inf__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A4 ) )
              = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ).

% Inf_fin.insert
thf(fact_2379_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N ) @ ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_2380_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_2381_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_2382_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_2383_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_2384_Int__atMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ A3 ) @ ( set_ord_atMost @ A @ B2 ) )
          = ( set_ord_atMost @ A @ ( ord_min @ A @ A3 @ B2 ) ) ) ) ).

% Int_atMost
thf(fact_2385_Inf__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Inf_fin.singleton
thf(fact_2386_sup__Inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A,A3: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A3 @ A4 )
           => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ A3 )
              = A3 ) ) ) ) ).

% sup_Inf_absorb
thf(fact_2387_Int__atLeastAtMostL1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ ( set_ord_atMost @ A @ D2 ) )
          = ( set_or1337092689740270186AtMost @ A @ A3 @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_atLeastAtMostL1
thf(fact_2388_Int__atLeastAtMostR1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( set_or1337092689740270186AtMost @ A @ C2 @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_atLeastAtMostR1
thf(fact_2389_atMost__0,axiom,
    ( ( set_ord_atMost @ nat @ ( zero_zero @ nat ) )
    = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atMost_0
thf(fact_2390_ivl__disj__int__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(3)
thf(fact_2391_greaterThanAtMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or3652927894154168847AtMost @ A )
        = ( ^ [L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ L3 ) @ ( set_ord_atMost @ A @ U2 ) ) ) ) ) ).

% greaterThanAtMost_def
thf(fact_2392_not__empty__eq__Iic__eq__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [H2: A] :
          ( ( bot_bot @ ( set @ A ) )
         != ( set_ord_atMost @ A @ H2 ) ) ) ).

% not_empty_eq_Iic_eq_empty
thf(fact_2393_ivl__disj__int__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M4: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M4 ) @ ( set_or3652927894154168847AtMost @ A @ M4 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(6)
thf(fact_2394_Inf__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
              = ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ).

% Inf_fin.in_idem
thf(fact_2395_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            | ( ord_less_eq @ A @ D2 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D2 @ A3 ) ) ) ) ).

% Ioc_disjoint
thf(fact_2396_ivl__disj__int__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M4: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M4 ) @ ( set_or3652927894154168847AtMost @ A @ M4 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(8)
thf(fact_2397_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
             => ! [A14: A] :
                  ( ( member @ A @ A14 @ A4 )
                 => ( ord_less_eq @ A @ X @ A14 ) ) ) ) ) ) ).

% Inf_fin.boundedE
thf(fact_2398_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A8: A] :
                  ( ( member @ A @ A8 @ A4 )
                 => ( ord_less_eq @ A @ X @ A8 ) )
             => ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ).

% Inf_fin.boundedI
thf(fact_2399_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                   => ( ord_less_eq @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Inf_fin.bounded_iff
thf(fact_2400_ivl__disj__int__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(5)
thf(fact_2401_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( set_or3652927894154168847AtMost @ A )
        = ( ^ [A5: A,B4: A] : ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A5 @ B4 ) @ ( insert2 @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
thf(fact_2402_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ B3 ) @ ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ).

% Inf_fin.subset_imp
thf(fact_2403_Inf__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X2: A,Y3: A] :
              ( ( H2 @ ( inf_inf @ A @ X2 @ Y3 ) )
              = ( inf_inf @ A @ ( H2 @ X2 ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic7752659483105999362nf_fin @ A @ N4 ) )
                = ( lattic7752659483105999362nf_fin @ A @ ( image2 @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% Inf_fin.hom_commute
thf(fact_2404_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A4 )
             => ( ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ B3 ) @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
                = ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ).

% Inf_fin.subset
thf(fact_2405_Inf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A4 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
thf(fact_2406_Inf__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X2: A,Y3: A] : ( member @ A @ ( inf_inf @ A @ X2 @ Y3 ) @ ( insert2 @ A @ X2 @ ( insert2 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Inf_fin.closed
thf(fact_2407_Inf__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ( B3
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
                  = ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ ( lattic7752659483105999362nf_fin @ A @ B3 ) ) ) ) ) ) ) ) ).

% Inf_fin.union
thf(fact_2408_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ).

% Inf_fin_le_Sup_fin
thf(fact_2409_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M4: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M4 ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_2410_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat,S: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ N @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ S2 @ ( set_ord_lessThan @ A @ S ) ) ) )
           => ( ( infini527867602293511546merate @ A @ ( inf_inf @ ( set @ A ) @ S2 @ ( set_ord_lessThan @ A @ S ) ) @ N )
              = ( infini527867602293511546merate @ A @ S2 @ N ) ) ) ) ) ).

% finite_enumerate_initial_segment
thf(fact_2411_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M4: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M4 ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_2412_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_2413_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M4: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_2414_atLeastLessThan__nat__numeral,axiom,
    ! [M4: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M4 @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M4 @ ( numeral_numeral @ nat @ K ) )
          = ( insert2 @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M4 @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M4 @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_2415_lessThan__0,axiom,
    ( ( set_ord_lessThan @ nat @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% lessThan_0
thf(fact_2416_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( set_or7035219750837199246ssThan @ A @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_2417_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_2418_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A3 @ B2 ) )
          = ( ~ ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_2419_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_2420_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_2421_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_2422_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_2423_single__Diff__lessThan,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A] :
          ( ( minus_minus @ ( set @ A ) @ ( insert2 @ A @ K @ ( bot_bot @ ( set @ A ) ) ) @ ( set_ord_lessThan @ A @ K ) )
          = ( insert2 @ A @ K @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% single_Diff_lessThan
thf(fact_2424_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_2425_atLeastLessThan__singleton,axiom,
    ! [M4: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M4 @ ( suc @ M4 ) )
      = ( insert2 @ nat @ M4 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atLeastLessThan_singleton
thf(fact_2426_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M4: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_2427_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M4: nat,N: nat,P4: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( ord_less_eq @ nat @ N @ P4 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P4 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ P4 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_2428_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
thf(fact_2429_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
thf(fact_2430_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M4: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M4 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% prod.atLeastLessThan_shift_bounds
thf(fact_2431_ivl__disj__int__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(2)
thf(fact_2432_ivl__disj__int__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M4: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M4 ) @ ( set_or7035219750837199246ssThan @ A @ M4 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(1)
thf(fact_2433_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M4: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M4 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% sum.atLeastLessThan_shift_bounds
thf(fact_2434_greaterThanLessThan__eq,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or5935395276787703475ssThan @ A )
        = ( ^ [A5: A,B4: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A5 ) @ ( set_ord_lessThan @ A @ B4 ) ) ) ) ) ).

% greaterThanLessThan_eq
thf(fact_2435_greaterThanLessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or5935395276787703475ssThan @ A )
        = ( ^ [L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ L3 ) @ ( set_ord_lessThan @ A @ U2 ) ) ) ) ) ).

% greaterThanLessThan_def
thf(fact_2436_lessThan__non__empty,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X: A] :
          ( ( set_ord_lessThan @ A @ X )
         != ( bot_bot @ ( set @ A ) ) ) ) ).

% lessThan_non_empty
thf(fact_2437_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_2438_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M4: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M4 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) )
            = ( times_times @ A @ ( G @ M4 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M4 ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_2439_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A3 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A3 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A3 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_2440_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M4: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
            = ( times_times @ A @ ( G @ N ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_2441_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M4: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.head_if
thf(fact_2442_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_2443_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_2444_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M4 ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_2445_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M4 ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_2446_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_2447_ivl__disj__int__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M4: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M4 ) @ ( set_or7035219750837199246ssThan @ A @ M4 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(3)
thf(fact_2448_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( ( set_ord_lessThan @ nat @ N )
        = ( bot_bot @ ( set @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% lessThan_empty_iff
thf(fact_2449_atLeastLessThan0,axiom,
    ! [M4: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M4 @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% atLeastLessThan0
thf(fact_2450_Iio__eq__empty__iff,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( order_bot @ A ) )
     => ! [N: A] :
          ( ( ( set_ord_lessThan @ A @ N )
            = ( bot_bot @ ( set @ A ) ) )
          = ( N
            = ( bot_bot @ A ) ) ) ) ).

% Iio_eq_empty_iff
thf(fact_2451_greaterThan__Int__greaterThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A3 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( set_ord_lessThan @ A @ ( ord_min @ A @ A3 @ B2 ) ) ) ) ).

% greaterThan_Int_greaterThan
thf(fact_2452_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N ) @ ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_2453_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N @ K ) @ N ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_2454_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M4: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
            = ( times_times @ A @ ( G @ M4 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M4 @ N ) ) ) ) ) ) ).

% prod.head
thf(fact_2455_ivl__disj__int__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M4: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M4 ) @ ( set_or1337092689740270186AtMost @ A @ M4 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(7)
thf(fact_2456_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
thf(fact_2457_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M4: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M4 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% prod.atLeastAtMost_shift_bounds
thf(fact_2458_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
thf(fact_2459_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M4: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M4 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% sum.atLeastAtMost_shift_bounds
thf(fact_2460_ivl__disj__int__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(4)
thf(fact_2461_ivl__disj__int__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M4: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M4 ) @ ( set_or1337092689740270186AtMost @ A @ M4 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(5)
thf(fact_2462_ivl__disj__int__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M4: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M4 ) @ ( set_or5935395276787703475ssThan @ A @ M4 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(4)
thf(fact_2463_ivl__disj__int__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(1)
thf(fact_2464_ivl__disj__int__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M4: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M4 ) @ ( set_or5935395276787703475ssThan @ A @ M4 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(2)
thf(fact_2465_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_2466_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M4: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M4 @ ( suc @ N ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_2467_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M4: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
            = ( times_times @ A @ ( G @ M4 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M4 ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_2468_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( set_or7035219750837199246ssThan @ A )
        = ( ^ [A5: A,B4: A] : ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A5 @ B4 ) @ ( insert2 @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
thf(fact_2469_atLeastLessThanSuc,axiom,
    ! [M4: nat,N: nat] :
      ( ( ( ord_less_eq @ nat @ M4 @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M4 @ ( suc @ N ) )
          = ( insert2 @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M4 @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M4 @ ( suc @ N ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_2470_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,K: A] :
          ( ( ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_2471_atLeastAtMost__diff__ends,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ ( insert2 @ A @ A3 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) ) ) ).

% atLeastAtMost_diff_ends
thf(fact_2472_ivl__disj__un__singleton_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [U: A] :
          ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ U ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
          = ( set_ord_atMost @ A @ U ) ) ) ).

% ivl_disj_un_singleton(2)
thf(fact_2473_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M4: nat,N: nat,G: nat > A,P4: nat] :
          ( ( ord_less_eq @ nat @ M4 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ ( plus_plus @ nat @ N @ P4 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P4 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_2474_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_2475_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_2476_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_2477_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ~ ( member @ B @ X @ A4 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert2 @ B @ X @ A4 ) )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ) ) ).

% prod.insert
thf(fact_2478_prod_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A4 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
            = ( one_one @ A ) ) ) ) ).

% prod.infinite
thf(fact_2479_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty
thf(fact_2480_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty
thf(fact_2481_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A4: set @ B,F: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less @ A @ ( F @ I3 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A4 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_2482_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A4: set @ B,B3: set @ B,F: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) )
                 => ( ( F @ X2 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ F @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_2483_sum_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: int > A,M4: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ int @ A @ G @ ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% sum.atLeast_int_lessThan_int_shift
thf(fact_2484_prod_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: int > A,M4: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ int @ A @ G @ ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% prod.atLeast_int_lessThan_int_shift
thf(fact_2485_sum__diff1__nat,axiom,
    ! [A: $tType,A3: A,A4: set @ A,F: A > nat] :
      ( ( ( member @ A @ A3 @ A4 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F @ A4 ) @ ( F @ A3 ) ) ) )
      & ( ~ ( member @ A @ A3 @ A4 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( groups7311177749621191930dd_sum @ A @ nat @ F @ A4 ) ) ) ) ).

% sum_diff1_nat
thf(fact_2486_sum__Un__nat,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,F: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F @ A4 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F @ B3 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_2487_prod_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: int > A,M4: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ int @ A @ G @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% prod.atLeast_int_atMost_int_shift
thf(fact_2488_sum_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: int > A,M4: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ int @ A @ G @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% sum.atLeast_int_atMost_int_shift
thf(fact_2489_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,A4: set @ B] :
          ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
           != ( one_one @ A ) )
         => ~ ! [A8: B] :
                ( ( member @ B @ A8 @ A4 )
               => ( ( G @ A8 )
                  = ( one_one @ A ) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
thf(fact_2490_prod_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,G: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A4 )
             => ( ( G @ X2 )
                = ( one_one @ A ) ) )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
            = ( one_one @ A ) ) ) ) ).

% prod.neutral
thf(fact_2491_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A4: set @ B,F: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A4 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F @ X2 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F @ A4 ) ) ) ) ).

% prod_ge_1
thf(fact_2492_prod__inversef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F: B > A,A4: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A @ ( comp @ A @ A @ B @ ( inverse_inverse @ A ) @ F ) @ A4 )
          = ( inverse_inverse @ A @ ( groups7121269368397514597t_prod @ B @ A @ F @ A4 ) ) ) ) ).

% prod_inversef
thf(fact_2493_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A4: set @ B,F: B > A] :
          ( ! [X2: B] :
              ( ( member @ B @ X2 @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F @ X2 ) )
                & ( ord_less_eq @ A @ ( F @ X2 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F @ A4 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_2494_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A4: set @ B,F: B > A,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ A4 )
                 => ( ord_less @ A @ ( F @ X2 ) @ ( G @ X2 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_2495_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H2: B > A,G: C > B,A4: set @ C] :
          ( ( ( H2 @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X2: B,Y3: B] :
                ( ( H2 @ ( plus_plus @ B @ X2 @ Y3 ) )
                = ( plus_plus @ A @ ( H2 @ X2 ) @ ( H2 @ Y3 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H2 @ G ) @ A4 )
              = ( H2 @ ( groups7311177749621191930dd_sum @ C @ B @ G @ A4 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_2496_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R: A > A > $o,S2: set @ B,H2: B > A,G: B > A] :
          ( ( R @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X12: A,Y12: A,X23: A,Y23: A] :
                ( ( ( R @ X12 @ X23 )
                  & ( R @ Y12 @ Y23 ) )
               => ( R @ ( times_times @ A @ X12 @ Y12 ) @ ( times_times @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ S2 )
                   => ( R @ ( H2 @ X2 ) @ ( G @ X2 ) ) )
               => ( R @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ) ).

% prod.related
thf(fact_2497_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( ( member @ B @ X @ A4 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert2 @ B @ X @ A4 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) )
            & ( ~ ( member @ B @ X @ A4 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert2 @ B @ X @ A4 ) )
                = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_2498_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S4: set @ B,T6: set @ C,S2: set @ B,I: C > B,J2: B > C,T3: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T6 )
           => ( ! [A8: B] :
                  ( ( member @ B @ A8 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) )
                 => ( ( I @ ( J2 @ A8 ) )
                    = A8 ) )
             => ( ! [A8: B] :
                    ( ( member @ B @ A8 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) )
                   => ( member @ C @ ( J2 @ A8 ) @ ( minus_minus @ ( set @ C ) @ T3 @ T6 ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T3 @ T6 ) )
                     => ( ( J2 @ ( I @ B6 ) )
                        = B6 ) )
                 => ( ! [B6: C] :
                        ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T3 @ T6 ) )
                       => ( member @ B @ ( I @ B6 ) @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) ) )
                   => ( ! [A8: B] :
                          ( ( member @ B @ A8 @ S4 )
                         => ( ( G @ A8 )
                            = ( one_one @ A ) ) )
                     => ( ! [B6: C] :
                            ( ( member @ C @ B6 @ T6 )
                           => ( ( H2 @ B6 )
                              = ( one_one @ A ) ) )
                       => ( ! [A8: B] :
                              ( ( member @ B @ A8 @ S2 )
                             => ( ( H2 @ ( J2 @ A8 ) )
                                = ( G @ A8 ) ) )
                         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                            = ( groups7121269368397514597t_prod @ C @ A @ H2 @ T3 ) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
thf(fact_2499_sum_Oreindex,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [H2: B > C,A4: set @ B,G: C > A] :
          ( ( inj_on @ B @ C @ H2 @ A4 )
         => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( image2 @ B @ C @ H2 @ A4 ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A4 ) ) ) ) ).

% sum.reindex
thf(fact_2500_prod_Oreindex,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [H2: B > C,A4: set @ B,G: C > A] :
          ( ( inj_on @ B @ C @ H2 @ A4 )
         => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( image2 @ B @ C @ H2 @ A4 ) )
            = ( groups7121269368397514597t_prod @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A4 ) ) ) ) ).

% prod.reindex
thf(fact_2501_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I4: set @ B,F: B > A] :
          ( ( finite_finite @ B @ I4 )
         => ( ( I4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ I4 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F @ I3 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F @ I4 ) ) ) ) ) ) ).

% sum_pos
thf(fact_2502_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I4: set @ A,I: A,F: A > B] :
          ( ( finite_finite @ A @ I4 )
         => ( ( member @ A @ I @ I4 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F @ I ) )
             => ( ! [I3: A] :
                    ( ( member @ A @ I3 @ I4 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F @ I3 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F @ I4 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_2503_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I4: set @ A,F: A > B] :
          ( ( finite_finite @ A @ I4 )
         => ( ( I4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I3: A] :
                  ( ( member @ A @ I3 @ I4 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F @ I3 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F @ I4 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_2504_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ! [X2: B,Y3: B] :
                ( ( member @ B @ X2 @ A4 )
               => ( ( member @ B @ Y3 @ A4 )
                 => ( ( X2 != Y3 )
                   => ( ( ( H2 @ X2 )
                        = ( H2 @ Y3 ) )
                     => ( ( G @ ( H2 @ X2 ) )
                        = ( zero_zero @ A ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( image2 @ B @ C @ H2 @ A4 ) )
              = ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A4 ) ) ) ) ) ).

% sum.reindex_nontrivial
thf(fact_2505_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ! [X2: B,Y3: B] :
                ( ( member @ B @ X2 @ A4 )
               => ( ( member @ B @ Y3 @ A4 )
                 => ( ( X2 != Y3 )
                   => ( ( ( H2 @ X2 )
                        = ( H2 @ Y3 ) )
                     => ( ( G @ ( H2 @ X2 ) )
                        = ( one_one @ A ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( image2 @ B @ C @ H2 @ A4 ) )
              = ( groups7121269368397514597t_prod @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A4 ) ) ) ) ) ).

% prod.reindex_nontrivial
thf(fact_2506_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A4: set @ B,K5: A,F: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less_eq @ A @ K5 @ ( F @ I3 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) ) ) ) ).

% sum_bounded_below
thf(fact_2507_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A4: set @ B,F: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less_eq @ A @ ( F @ I3 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_2508_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T3: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T3 )
         => ( ( finite_finite @ B @ S2 )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
                 => ( ( H2 @ I3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I3: B] :
                    ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S2 @ T3 ) )
                   => ( ( G @ I3 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X2: B] :
                      ( ( member @ B @ X2 @ ( inf_inf @ ( set @ B ) @ S2 @ T3 ) )
                     => ( ( G @ X2 )
                        = ( H2 @ X2 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T3 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_2509_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B3: set @ B,A4: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B3 @ A4 )
         => ( ( finite_finite @ B @ A4 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_2510_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C3: set @ B,A4: set @ B,B3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ C3 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C3 )
             => ( ! [A8: B] :
                    ( ( member @ B @ A8 @ ( minus_minus @ ( set @ B ) @ C3 @ A4 ) )
                   => ( ( G @ A8 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C3 @ B3 ) )
                     => ( ( H2 @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B3 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G @ C3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C3 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_2511_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C3: set @ B,A4: set @ B,B3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ C3 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C3 )
             => ( ! [A8: B] :
                    ( ( member @ B @ A8 @ ( minus_minus @ ( set @ B ) @ C3 @ A4 ) )
                   => ( ( G @ A8 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C3 @ B3 ) )
                     => ( ( H2 @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ C3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C3 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B3 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_2512_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T3: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T3 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T3 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
                 => ( ( G @ X2 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ T3 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_2513_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T3: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T3 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T3 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
                 => ( ( G @ X2 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T3 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_2514_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T3: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T3 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T3 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
                 => ( ( H2 @ X2 )
                    = ( one_one @ A ) ) )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ S2 )
                   => ( ( G @ X2 )
                      = ( H2 @ X2 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T3 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_2515_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T3: set @ B,S2: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T3 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T3 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
                 => ( ( G @ X2 )
                    = ( one_one @ A ) ) )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ S2 )
                   => ( ( G @ X2 )
                      = ( H2 @ X2 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T3 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_2516_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_2517_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B3 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_2518_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_2519_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B3 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_2520_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T3: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T3 )
         => ( ( finite_finite @ B @ S2 )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
                 => ( ( H2 @ I3 )
                    = ( one_one @ A ) ) )
             => ( ! [I3: B] :
                    ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S2 @ T3 ) )
                   => ( ( G @ I3 )
                      = ( one_one @ A ) ) )
               => ( ! [X2: B] :
                      ( ( member @ B @ X2 @ ( inf_inf @ ( set @ B ) @ S2 @ T3 ) )
                     => ( ( G @ X2 )
                        = ( H2 @ X2 ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                    = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T3 ) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
thf(fact_2521_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F: B > A,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ A4 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F @ I3 ) )
                  & ( ord_less @ A @ ( F @ I3 ) @ ( G @ I3 ) ) ) )
           => ( ( A4
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_2522_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I4: set @ C,G: A > B,F: C > A] :
          ( ( finite_finite @ C @ I4 )
         => ( ! [I3: C] :
                ( ( member @ C @ I3 @ I4 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G @ ( F @ I3 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G @ ( image2 @ C @ A @ F @ I4 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G @ F ) @ I4 ) ) ) ) ) ).

% sum_image_le
thf(fact_2523_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) )
                 => ( ( G @ X2 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_2524_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( member @ B @ X @ A4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
              = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_2525_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert2 @ B @ X @ A4 ) )
            = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_2526_sum__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: set @ B,A3: B,F: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( ( member @ B @ A3 @ A4 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ F @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) )
                = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) @ ( F @ A3 ) ) ) )
            & ( ~ ( member @ B @ A3 @ A4 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ F @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) ) ) ) ) ) ).

% sum_diff1
thf(fact_2527_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: set @ B,B3: set @ B,F: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_2528_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( ( inf_inf @ ( set @ B ) @ A4 @ B3 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_2529_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert2 @ B @ X @ A4 ) )
            = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_2530_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( member @ B @ X @ A4 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A4 )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_2531_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) )
                 => ( ( G @ X2 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_2532_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( ( inf_inf @ ( set @ B ) @ A4 @ B3 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_2533_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A4: set @ A,B3: set @ A,F: A > B] :
          ( ( finite_finite @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F @ ( minus_minus @ ( set @ A ) @ A4 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F @ ( minus_minus @ ( set @ A ) @ B3 @ A4 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_2534_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B3 @ A4 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_2535_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B3 @ A4 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_2536_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I: C,A4: set @ C,F: C > B] :
          ( ( member @ C @ I @ A4 )
         => ( ! [X2: C] :
                ( ( member @ C @ X2 @ ( minus_minus @ ( set @ C ) @ A4 @ ( insert2 @ C @ I @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F @ X2 ) ) )
           => ( ( finite_finite @ C @ A4 )
             => ( ord_less_eq @ B @ ( F @ I ) @ ( groups7311177749621191930dd_sum @ C @ B @ F @ A4 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_2537_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B3: set @ A,A4: set @ A,F: A > B] :
          ( ( finite_finite @ A @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B3 @ A4 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F @ B6 ) ) )
             => ( ! [A8: A] :
                    ( ( member @ A @ A8 @ A4 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F @ A8 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F @ A4 ) @ ( groups7121269368397514597t_prod @ A @ B @ F @ B3 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_2538_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F: B > A,N: A,K: nat] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F @ I3 ) )
                & ( ord_less_eq @ A @ ( F @ I3 ) @ N ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A4 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F @ A4 ) @ ( power_power @ A @ N @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_2539_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A4: set @ B,F: B > A,A3: B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( ( F @ A3 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A3 @ A4 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F @ A4 ) @ ( F @ A3 ) ) ) )
              & ( ~ ( member @ B @ A3 @ A4 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F @ A4 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_2540_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: set @ B,F: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A4 )
             => ( ord_less_eq @ A @ ( F @ I3 ) @ ( divide_divide @ A @ K5 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) ) ) )
         => ( ( finite_finite @ B @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_2541_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A] :
          ( ! [A8: A,B6: A,X2: A] :
              ( ( member @ A @ A8 @ S2 )
             => ( ( member @ A @ B6 @ S2 )
               => ( ( ord_less_eq @ A @ A8 @ X2 )
                 => ( ( ord_less_eq @ A @ X2 @ B6 )
                   => ( member @ A @ X2 @ S2 ) ) ) ) )
         => ? [A8: A,B6: A] :
              ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
              | ( S2
                = ( top_top @ ( set @ A ) ) )
              | ( S2
                = ( set_ord_lessThan @ A @ B6 ) )
              | ( S2
                = ( set_ord_atMost @ A @ B6 ) )
              | ( S2
                = ( set_ord_greaterThan @ A @ A8 ) )
              | ( S2
                = ( set_ord_atLeast @ A @ A8 ) )
              | ( S2
                = ( set_or5935395276787703475ssThan @ A @ A8 @ B6 ) )
              | ( S2
                = ( set_or3652927894154168847AtMost @ A @ A8 @ B6 ) )
              | ( S2
                = ( set_or7035219750837199246ssThan @ A @ A8 @ B6 ) )
              | ( S2
                = ( set_or1337092689740270186AtMost @ A @ A8 @ B6 ) ) ) ) ) ).

% interval_cases
thf(fact_2542_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K4: nat] : ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K4 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_2543_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_odd_sum
thf(fact_2544_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_even_sum
thf(fact_2545_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,M4: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( gbinomial @ A @ A3 @ K4 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M4 ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M4 ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A3 @ ( plus_plus @ nat @ M4 @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_2546_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M4: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M4 ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M4 ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_2547_atLeast__empty__triv,axiom,
    ! [A: $tType] :
      ( ( set_ord_atLeast @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) )
      = ( top_top @ ( set @ ( set @ A ) ) ) ) ).

% atLeast_empty_triv
thf(fact_2548_Heap__Time__Monad_Obind__bind,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: heap_Time_Heap @ A,G: A > ( heap_Time_Heap @ C ),K: C > ( heap_Time_Heap @ B )] :
      ( ( heap_Time_bind @ C @ B @ ( heap_Time_bind @ A @ C @ F @ G ) @ K )
      = ( heap_Time_bind @ A @ B @ F
        @ ^ [X3: A] : ( heap_Time_bind @ C @ B @ ( G @ X3 ) @ K ) ) ) ).

% Heap_Time_Monad.bind_bind
thf(fact_2549_bool__assn__proper_I2_J,axiom,
    ( proper
    @ ^ [Uu: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] : $false ) ).

% bool_assn_proper(2)
thf(fact_2550_bool__assn__proper_I3_J,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P )
     => ( ( proper @ Q )
       => ( proper
          @ ^ [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( P @ H3 )
              | ( Q @ H3 ) ) ) ) ) ).

% bool_assn_proper(3)
thf(fact_2551_bool__assn__proper_I4_J,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P )
     => ( ( proper @ Q )
       => ( proper
          @ ^ [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( P @ H3 )
              & ( Q @ H3 ) ) ) ) ) ).

% bool_assn_proper(4)
thf(fact_2552_singleton__conv2,axiom,
    ! [A: $tType,A3: A] :
      ( ( collect @ A
        @ ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
          @ A3 ) )
      = ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% singleton_conv2
thf(fact_2553_singleton__conv,axiom,
    ! [A: $tType,A3: A] :
      ( ( collect @ A
        @ ^ [X3: A] : ( X3 = A3 ) )
      = ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% singleton_conv
thf(fact_2554_Collect__const,axiom,
    ! [A: $tType,P: $o] :
      ( ( P
       => ( ( collect @ A
            @ ^ [S6: A] : P )
          = ( top_top @ ( set @ A ) ) ) )
      & ( ~ P
       => ( ( collect @ A
            @ ^ [S6: A] : P )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Collect_const
thf(fact_2555_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [Uu: B] : ( one_one @ A )
            @ A4 )
          = ( one_one @ A ) ) ) ).

% prod.neutral_const
thf(fact_2556_bool__assn__proper_I5_J,axiom,
    ! [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P )
     => ( proper
        @ ^ [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( in_range @ H3 )
            & ~ ( P @ H3 ) ) ) ) ).

% bool_assn_proper(5)
thf(fact_2557_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A3: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( B2 @ A3 ) ) )
            & ( ~ ( member @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta
thf(fact_2558_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A3: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( A3 = K4 ) @ ( B2 @ K4 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( B2 @ A3 ) ) )
            & ( ~ ( member @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( A3 = K4 ) @ ( B2 @ K4 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta'
thf(fact_2559_if__image__distrib,axiom,
    ! [A: $tType,B: $tType,P: B > $o,F: B > A,G: B > A,S2: set @ B] :
      ( ( image2 @ B @ A
        @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( F @ X3 ) @ ( G @ X3 ) )
        @ S2 )
      = ( sup_sup @ ( set @ A ) @ ( image2 @ B @ A @ F @ ( inf_inf @ ( set @ B ) @ S2 @ ( collect @ B @ P ) ) )
        @ ( image2 @ B @ A @ G
          @ ( inf_inf @ ( set @ B ) @ S2
            @ ( collect @ B
              @ ^ [X3: B] :
                  ~ ( P @ X3 ) ) ) ) ) ) ).

% if_image_distrib
thf(fact_2560_precise__extr__pure_I1_J,axiom,
    ! [B: $tType,A: $tType,P: $o,R: A > B > assn] :
      ( ( precise @ A @ B
        @ ^ [X3: A,Y2: B] : ( times_times @ assn @ ( pure_assn @ P ) @ ( R @ X3 @ Y2 ) ) )
      = ( P
       => ( precise @ A @ B @ R ) ) ) ).

% precise_extr_pure(1)
thf(fact_2561_precise__extr__pure_I2_J,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn,P: $o] :
      ( ( precise @ A @ B
        @ ^ [X3: A,Y2: B] : ( times_times @ assn @ ( R @ X3 @ Y2 ) @ ( pure_assn @ P ) ) )
      = ( P
       => ( precise @ A @ B @ R ) ) ) ).

% precise_extr_pure(2)
thf(fact_2562_range__constant,axiom,
    ! [B: $tType,A: $tType,X: A] :
      ( ( image2 @ B @ A
        @ ^ [Uu: B] : X
        @ ( top_top @ ( set @ B ) ) )
      = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% range_constant
thf(fact_2563_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: A,A4: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X3: B] : Y
            @ A4 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ Y ) ) ) ).

% sum_constant
thf(fact_2564_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A4: set @ B,P: B > $o,F: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P @ X3 ) ) @ ( F @ X3 ) )
              @ A4 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_2565_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A4: set @ B,F: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( F @ X3 ) @ ( zero_neq_one_of_bool @ A @ ( P @ X3 ) ) )
              @ A4 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_2566_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A4 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) )
                @ A4 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A4 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) )
                @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_2567_sum__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A4: set @ B,P: B > $o] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ A4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [X3: B] : ( zero_neq_one_of_bool @ A @ ( P @ X3 ) )
                @ A4 )
              = ( semiring_1_of_nat @ A @ ( finite_card @ B @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum_of_bool_eq
thf(fact_2568_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A4 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) ) @ ( D2 @ I2 ) )
                @ A4 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A4 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I2: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I2 ) ) @ ( D2 @ I2 ) )
                @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_2569_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F: A > B,A4: set @ A,G: C > B,B3: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F @ A4 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B3 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I2: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J: C] : ( times_times @ B @ ( F @ I2 ) @ ( G @ J ) )
                @ B3 )
            @ A4 ) ) ) ).

% sum_product
thf(fact_2570_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A4: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X3: B] : ( times_times @ A @ ( G @ X3 ) @ ( H2 @ X3 ) )
            @ A4 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ A4 ) ) ) ) ).

% prod.distrib
thf(fact_2571_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F: B > A,A4: set @ B,R4: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) @ R4 )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N5: B] : ( times_times @ A @ ( F @ N5 ) @ R4 )
            @ A4 ) ) ) ).

% sum_distrib_right
thf(fact_2572_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R4: A,F: B > A,A4: set @ B] :
          ( ( times_times @ A @ R4 @ ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N5: B] : ( times_times @ A @ R4 @ ( F @ N5 ) )
            @ A4 ) ) ) ).

% sum_distrib_left
thf(fact_2573_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R )
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ S2 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ).

% pred_subset_eq2
thf(fact_2574_bot__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% bot_empty_eq2
thf(fact_2575_inj__singleton,axiom,
    ! [A: $tType,A4: set @ A] :
      ( inj_on @ A @ ( set @ A )
      @ ^ [X3: A] : ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) )
      @ A4 ) ).

% inj_singleton
thf(fact_2576_Collect__conv__if2,axiom,
    ! [A: $tType,P: A > $o,A3: A] :
      ( ( ( P @ A3 )
       => ( ( collect @ A
            @ ^ [X3: A] :
                ( ( A3 = X3 )
                & ( P @ X3 ) ) )
          = ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P @ A3 )
       => ( ( collect @ A
            @ ^ [X3: A] :
                ( ( A3 = X3 )
                & ( P @ X3 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Collect_conv_if2
thf(fact_2577_Collect__conv__if,axiom,
    ! [A: $tType,P: A > $o,A3: A] :
      ( ( ( P @ A3 )
       => ( ( collect @ A
            @ ^ [X3: A] :
                ( ( X3 = A3 )
                & ( P @ X3 ) ) )
          = ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P @ A3 )
       => ( ( collect @ A
            @ ^ [X3: A] :
                ( ( X3 = A3 )
                & ( P @ X3 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Collect_conv_if
thf(fact_2578_Set_Oempty__def,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X3: A] : $false ) ) ).

% Set.empty_def
thf(fact_2579_inf__Int__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( inf_inf @ ( A > B > $o )
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R )
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ S2 ) )
      = ( ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ) ) ).

% inf_Int_eq2
thf(fact_2580_sup__Un__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( sup_sup @ ( A > B > $o )
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R )
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ S2 ) )
      = ( ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ) ) ).

% sup_Un_eq2
thf(fact_2581_sngr__prec,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( precise @ A @ ( ref @ A )
        @ ^ [X3: A,P6: ref @ A] : ( sngr_assn @ A @ P6 @ X3 ) ) ) ).

% sngr_prec
thf(fact_2582_effect__LetI,axiom,
    ! [B: $tType,A: $tType,X: A,T4: A,F: A > ( heap_Time_Heap @ B ),H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: B,N: nat] :
      ( ( X = T4 )
     => ( ( heap_Time_effect @ B @ ( F @ X ) @ H2 @ H4 @ R4 @ N )
       => ( heap_Time_effect @ B @ ( F @ T4 ) @ H2 @ H4 @ R4 @ N ) ) ) ).

% effect_LetI
thf(fact_2583_distrib__if__bind,axiom,
    ! [A: $tType,B: $tType,B2: $o,C2: heap_Time_Heap @ B,D2: heap_Time_Heap @ B,F: B > ( heap_Time_Heap @ A )] :
      ( ( B2
       => ( ( heap_Time_bind @ B @ A @ ( if @ ( heap_Time_Heap @ B ) @ B2 @ C2 @ D2 ) @ F )
          = ( heap_Time_bind @ B @ A @ C2 @ F ) ) )
      & ( ~ B2
       => ( ( heap_Time_bind @ B @ A @ ( if @ ( heap_Time_Heap @ B ) @ B2 @ C2 @ D2 ) @ F )
          = ( heap_Time_bind @ B @ A @ D2 @ F ) ) ) ) ).

% distrib_if_bind
thf(fact_2584_success__LetI,axiom,
    ! [A: $tType,B: $tType,X: A,T4: A,F: A > ( heap_Time_Heap @ B ),H2: heap_ext @ product_unit] :
      ( ( X = T4 )
     => ( ( heap_Time_success @ B @ ( F @ X ) @ H2 )
       => ( heap_Time_success @ B @ ( F @ T4 ) @ H2 ) ) ) ).

% success_LetI
thf(fact_2585_snga__prec,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( precise @ ( list @ A ) @ ( array @ A )
        @ ^ [X3: list @ A,P6: array @ A] : ( snga_assn @ A @ P6 @ X3 ) ) ) ).

% snga_prec
thf(fact_2586_Int__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A10: set @ A,B7: set @ A] :
            ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A10 )
                & ( member @ A @ X3 @ B7 ) ) ) ) ) ).

% Int_def
thf(fact_2587_Int__Collect,axiom,
    ! [A: $tType,X: A,A4: set @ A,P: A > $o] :
      ( ( member @ A @ X @ ( inf_inf @ ( set @ A ) @ A4 @ ( collect @ A @ P ) ) )
      = ( ( member @ A @ X @ A4 )
        & ( P @ X ) ) ) ).

% Int_Collect
thf(fact_2588_inf__set__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A10: set @ A,B7: set @ A] :
            ( collect @ A
            @ ( inf_inf @ ( A > $o )
              @ ^ [X3: A] : ( member @ A @ X3 @ A10 )
              @ ^ [X3: A] : ( member @ A @ X3 @ B7 ) ) ) ) ) ).

% inf_set_def
thf(fact_2589_Collect__conj__eq,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( ( P @ X3 )
            & ( Q @ X3 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_conj_eq
thf(fact_2590_inf__Int__eq,axiom,
    ! [A: $tType,R: set @ A,S2: set @ A] :
      ( ( inf_inf @ ( A > $o )
        @ ^ [X3: A] : ( member @ A @ X3 @ R )
        @ ^ [X3: A] : ( member @ A @ X3 @ S2 ) )
      = ( ^ [X3: A] : ( member @ A @ X3 @ ( inf_inf @ ( set @ A ) @ R @ S2 ) ) ) ) ).

% inf_Int_eq
thf(fact_2591_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X3: A] : X3 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_2592_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H3: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_2593_pred__equals__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R ) )
        = ( ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ S2 ) ) )
      = ( R = S2 ) ) ).

% pred_equals_eq2
thf(fact_2594_top__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( top_top @ ( A > B > $o ) )
      = ( ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% top_empty_eq2
thf(fact_2595_inj__on__convol__ident,axiom,
    ! [B: $tType,A: $tType,F: A > B,X5: set @ A] :
      ( inj_on @ A @ ( product_prod @ A @ B )
      @ ^ [X3: A] : ( product_Pair @ A @ B @ X3 @ ( F @ X3 ) )
      @ X5 ) ).

% inj_on_convol_ident
thf(fact_2596_inj__Pair_I1_J,axiom,
    ! [B: $tType,A: $tType,C2: A > B,S2: set @ A] :
      ( inj_on @ A @ ( product_prod @ A @ B )
      @ ^ [X3: A] : ( product_Pair @ A @ B @ X3 @ ( C2 @ X3 ) )
      @ S2 ) ).

% inj_Pair(1)
thf(fact_2597_inj__Pair_I2_J,axiom,
    ! [B: $tType,A: $tType,C2: A > B,S2: set @ A] :
      ( inj_on @ A @ ( product_prod @ B @ A )
      @ ^ [X3: A] : ( product_Pair @ B @ A @ ( C2 @ X3 ) @ X3 )
      @ S2 ) ).

% inj_Pair(2)
thf(fact_2598_fun_Omap__ident,axiom,
    ! [A: $tType,D: $tType,T4: D > A] :
      ( ( comp @ A @ A @ D
        @ ^ [X3: A] : X3
        @ T4 )
      = T4 ) ).

% fun.map_ident
thf(fact_2599_frame__rule,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,R: assn] :
      ( ( hoare_hoare_triple @ A @ P @ C2 @ Q )
     => ( hoare_hoare_triple @ A @ ( times_times @ assn @ P @ R ) @ C2
        @ ^ [X3: A] : ( times_times @ assn @ ( Q @ X3 ) @ R ) ) ) ).

% frame_rule
thf(fact_2600_cons__pre__rule,axiom,
    ! [A: $tType,P: assn,P2: assn,C2: heap_Time_Heap @ A,Q: A > assn] :
      ( ( entails @ P @ P2 )
     => ( ( hoare_hoare_triple @ A @ P2 @ C2 @ Q )
       => ( hoare_hoare_triple @ A @ P @ C2 @ Q ) ) ) ).

% cons_pre_rule
thf(fact_2601_bot__assn__def,axiom,
    ( ( bot_bot @ assn )
    = ( abs_assn
      @ ^ [Uu: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] : $false ) ) ).

% bot_assn_def
thf(fact_2602_not__empty__eq__Ici__eq__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A] :
          ( ( bot_bot @ ( set @ A ) )
         != ( set_ord_atLeast @ A @ L ) ) ) ).

% not_empty_eq_Ici_eq_empty
thf(fact_2603_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I4: set @ B,X: B > A,Y: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I2: B] :
                  ( ( member @ B @ I2 @ I4 )
                  & ( ( X @ I2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I2: B] :
                    ( ( member @ B @ I2 @ I4 )
                    & ( ( Y @ I2 )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I2: B] :
                    ( ( member @ B @ I2 @ I4 )
                    & ( ( times_times @ A @ ( X @ I2 ) @ ( Y @ I2 ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_2604_image__constant__conv,axiom,
    ! [B: $tType,A: $tType,A4: set @ B,C2: A] :
      ( ( ( A4
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ B @ A
            @ ^ [X3: B] : C2
            @ A4 )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A4
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ B @ A
            @ ^ [X3: B] : C2
            @ A4 )
          = ( insert2 @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_constant_conv
thf(fact_2605_image__constant,axiom,
    ! [A: $tType,B: $tType,X: A,A4: set @ A,C2: B] :
      ( ( member @ A @ X @ A4 )
     => ( ( image2 @ A @ B
          @ ^ [X3: A] : C2
          @ A4 )
        = ( insert2 @ B @ C2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ).

% image_constant
thf(fact_2606_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,S: set @ A,T4: set @ A] :
          ( ( image2 @ A @ A
            @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A3 )
            @ ( inf_inf @ ( set @ A ) @ S @ T4 ) )
          = ( inf_inf @ ( set @ A )
            @ ( image2 @ A @ A
              @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A3 )
              @ S )
            @ ( image2 @ A @ A
              @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A3 )
              @ T4 ) ) ) ) ).

% translation_subtract_Int
thf(fact_2607_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( collect @ B
                @ ^ [X3: B] :
                    ( ( member @ B @ X3 @ A4 )
                    & ( P @ X3 ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( G @ X3 ) @ ( one_one @ A ) )
              @ A4 ) ) ) ) ).

% prod.inter_filter
thf(fact_2608_bind__rule_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: assn,F: heap_Time_Heap @ B,R: B > assn,G: B > ( heap_Time_Heap @ C ),Q: C > assn] :
      ( ! [R3: A] :
          ( hoare_hoare_triple @ B @ P @ F
          @ ^ [S6: B] : ( times_times @ assn @ P @ ( R @ S6 ) ) )
     => ( ! [X2: B] : ( hoare_hoare_triple @ C @ ( times_times @ assn @ ( R @ X2 ) @ P ) @ ( G @ X2 ) @ Q )
       => ( hoare_hoare_triple @ C @ P @ ( heap_Time_bind @ B @ C @ F @ G ) @ Q ) ) ) ).

% bind_rule'
thf(fact_2609_sup__assn__def,axiom,
    ( ( sup_sup @ assn )
    = ( ^ [P3: assn,Q3: assn] :
          ( abs_assn
          @ ^ [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( rep_assn @ P3 @ H3 )
              | ( rep_assn @ Q3 @ H3 ) ) ) ) ) ).

% sup_assn_def
thf(fact_2610_inf__assn__def,axiom,
    ( ( inf_inf @ assn )
    = ( ^ [P3: assn,Q3: assn] :
          ( abs_assn
          @ ^ [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( rep_assn @ P3 @ H3 )
              & ( rep_assn @ Q3 @ H3 ) ) ) ) ) ).

% inf_assn_def
thf(fact_2611_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_2612_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( member @ B @ X3 @ B3 ) @ ( G @ X3 ) @ ( zero_zero @ A ) )
              @ A4 ) ) ) ) ).

% sum.inter_restrict
thf(fact_2613_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W2: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit0 @ W2 ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) ) ) ) ).

% power_numeral_even
thf(fact_2614_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W2: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit1 @ W2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z2 @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W2 ) ) ) ) ) ).

% power_numeral_odd
thf(fact_2615_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( member @ B @ X3 @ B3 ) @ ( G @ X3 ) @ ( one_one @ A ) )
              @ A4 ) ) ) ) ).

% prod.inter_restrict
thf(fact_2616_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A4
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( G @ X3 )
                      = ( one_one @ A ) ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ).

% prod.setdiff_irrelevant
thf(fact_2617_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M4: nat,I4: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( power_power @ A @ X @ ( plus_plus @ nat @ M4 @ I2 ) )
            @ I4 )
          = ( times_times @ A @ ( power_power @ A @ X @ M4 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ I4 ) ) ) ) ).

% sum_power_add
thf(fact_2618_fst__diag__id,axiom,
    ! [A: $tType,Z2: A] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ A @ ( product_fst @ A @ A )
        @ ^ [X3: A] : ( product_Pair @ A @ A @ X3 @ X3 )
        @ Z2 )
      = ( id @ A @ Z2 ) ) ).

% fst_diag_id
thf(fact_2619_snd__diag__id,axiom,
    ! [A: $tType,Z2: A] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ A @ ( product_snd @ A @ A )
        @ ^ [X3: A] : ( product_Pair @ A @ A @ X3 @ X3 )
        @ Z2 )
      = ( id @ A @ Z2 ) ) ).

% snd_diag_id
thf(fact_2620_bot_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ( ordering_top @ A
        @ ^ [X3: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X3 )
        @ ^ [X3: A,Y2: A] : ( ord_less @ A @ Y2 @ X3 )
        @ ( bot_bot @ A ) ) ) ).

% bot.ordering_top_axioms
thf(fact_2621_bind__lift,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap @ B,G: B > A] :
      ( ( heap_Time_bind @ B @ A @ F @ ( heap_Time_lift @ B @ A @ G ) )
      = ( heap_Time_bind @ B @ A @ F
        @ ^ [X3: B] : ( heap_Time_return @ A @ ( G @ X3 ) ) ) ) ).

% bind_lift
thf(fact_2622_empty__natural,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F: A > C,G: D > B] :
      ( ( comp @ C @ ( set @ B ) @ A
        @ ^ [Uu: C] : ( bot_bot @ ( set @ B ) )
        @ F )
      = ( comp @ ( set @ D ) @ ( set @ B ) @ A @ ( image2 @ D @ B @ G )
        @ ^ [Uu: A] : ( bot_bot @ ( set @ D ) ) ) ) ).

% empty_natural
thf(fact_2623_cons__rulet,axiom,
    ! [A: $tType,P: assn,P2: assn,Q: A > assn,Q2: A > assn,C2: heap_Time_Heap @ A] :
      ( ( entailst @ P @ P2 )
     => ( ! [X2: A] : ( entailst @ ( Q @ X2 ) @ ( Q2 @ X2 ) )
       => ( ( hoare_hoare_triple @ A @ P2 @ C2
            @ ^ [R5: A] : ( times_times @ assn @ ( Q @ R5 ) @ ( top_top @ assn ) ) )
         => ( hoare_hoare_triple @ A @ P @ C2
            @ ^ [R5: A] : ( times_times @ assn @ ( Q2 @ R5 ) @ ( top_top @ assn ) ) ) ) ) ) ).

% cons_rulet
thf(fact_2624_cons__pre__rulet,axiom,
    ! [A: $tType,P: assn,P2: assn,C2: heap_Time_Heap @ A,Q: A > assn] :
      ( ( entailst @ P @ P2 )
     => ( ( hoare_hoare_triple @ A @ P2 @ C2
          @ ^ [R5: A] : ( times_times @ assn @ ( Q @ R5 ) @ ( top_top @ assn ) ) )
       => ( hoare_hoare_triple @ A @ P @ C2
          @ ^ [R5: A] : ( times_times @ assn @ ( Q @ R5 ) @ ( top_top @ assn ) ) ) ) ) ).

% cons_pre_rulet
thf(fact_2625_cons__post__rulet,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,Q2: A > assn] :
      ( ( hoare_hoare_triple @ A @ P @ C2
        @ ^ [R5: A] : ( times_times @ assn @ ( Q @ R5 ) @ ( top_top @ assn ) ) )
     => ( ! [X2: A] : ( entailst @ ( Q @ X2 ) @ ( Q2 @ X2 ) )
       => ( hoare_hoare_triple @ A @ P @ C2
          @ ^ [R5: A] : ( times_times @ assn @ ( Q2 @ R5 ) @ ( top_top @ assn ) ) ) ) ) ).

% cons_post_rulet
thf(fact_2626_return__sp__rule,axiom,
    ! [A: $tType,P: assn,X: A] :
      ( hoare_hoare_triple @ A @ P @ ( heap_Time_return @ A @ X )
      @ ^ [R5: A] : ( times_times @ assn @ P @ ( pure_assn @ ( R5 = X ) ) ) ) ).

% return_sp_rule
thf(fact_2627_fst__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X3: A] : ( product_Pair @ A @ A @ X3 @ X3 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% fst_diag_fst
thf(fact_2628_snd__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X3: B] : ( product_Pair @ B @ B @ X3 @ X3 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% snd_diag_snd
thf(fact_2629_inj__on__disjoint__Un,axiom,
    ! [B: $tType,A: $tType,F: A > B,A4: set @ A,G: A > B,B3: set @ A] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( inj_on @ A @ B @ G @ B3 )
       => ( ( ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F @ A4 ) @ ( image2 @ A @ B @ G @ B3 ) )
            = ( bot_bot @ ( set @ B ) ) )
         => ( inj_on @ A @ B
            @ ^ [X3: A] : ( if @ B @ ( member @ A @ X3 @ A4 ) @ ( F @ X3 ) @ ( G @ X3 ) )
            @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) ) ) ) ) ).

% inj_on_disjoint_Un
thf(fact_2630_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( H2 @ X3 ) @ ( G @ X3 ) )
              @ A4 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_2631_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M4: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ M4 )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_2632_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( H2 @ X3 ) @ ( G @ X3 ) )
              @ A4 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_2633_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_2634_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_2635_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X3: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X3 )
        @ ^ [X3: A,Y2: A] : ( ord_less @ A @ Y2 @ X3 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_2636_atLeast__eq__UNIV__iff,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ( set_ord_atLeast @ A @ X )
            = ( top_top @ ( set @ A ) ) )
          = ( X
            = ( bot_bot @ A ) ) ) ) ).

% atLeast_eq_UNIV_iff
thf(fact_2637_If__the__inv__into__f__f,axiom,
    ! [B: $tType,A: $tType,I: A,C3: set @ A,G: A > B,X: A] :
      ( ( member @ A @ I @ C3 )
     => ( ( inj_on @ A @ B @ G @ C3 )
       => ( ( comp @ B @ A @ A
            @ ^ [I2: B] : ( if @ A @ ( member @ B @ I2 @ ( image2 @ A @ B @ G @ C3 ) ) @ ( the_inv_into @ A @ B @ C3 @ G @ I2 ) @ X )
            @ G
            @ I )
          = ( id @ A @ I ) ) ) ) ).

% If_the_inv_into_f_f
thf(fact_2638_uminus__assn__def,axiom,
    ( ( uminus_uminus @ assn )
    = ( ^ [P3: assn] :
          ( abs_assn
          @ ^ [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( in_range @ H3 )
              & ~ ( rep_assn @ P3 @ H3 ) ) ) ) ) ).

% uminus_assn_def
thf(fact_2639_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F: nat > A,A3: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F @ ( set_or1337092689740270186AtMost @ nat @ A3 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A5: nat] : ( times_times @ A @ ( F @ A5 ) )
            @ A3
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_2640_snd__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X3: A] : ( product_Pair @ A @ A @ X3 @ X3 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% snd_diag_fst
thf(fact_2641_fst__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_fst @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X3: B] : ( product_Pair @ B @ B @ X3 @ X3 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% fst_diag_snd
thf(fact_2642_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A3: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A3 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( C2 @ K4 ) )
                  @ S2 )
                = ( plus_plus @ A @ ( B2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A3 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( C2 @ K4 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_2643_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A4: set @ B,F: B > A,B2: A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F @ A4 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A5: B] : ( divide_divide @ A @ ( F @ A5 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A4
                  @ ( collect @ B
                    @ ^ [A5: B] : ( dvd_dvd @ A @ B2 @ ( F @ A5 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F
                  @ ( inf_inf @ ( set @ B ) @ A4
                    @ ( collect @ B
                      @ ^ [A5: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F @ A5 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_2644_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A3: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( C2 @ K4 ) )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( C2 @ K4 ) )
                  @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_2645_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_2646_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_2647_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: nat] :
          ( ( X
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_2648_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ K4 ) ) @ K4 )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ N ) ) ) ).

% gbinomial_parallel_sum
thf(fact_2649_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I2: nat] : ( G @ ( suc @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_2650_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_2651_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_2652_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_2653_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_2654_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y: nat,X: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y )
       => ( ( image2 @ nat @ nat
            @ ^ [I2: nat] : ( minus_minus @ nat @ I2 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X @ C2 ) @ ( minus_minus @ nat @ Y @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y )
       => ( ( ( ord_less @ nat @ X @ Y )
           => ( ( image2 @ nat @ nat
                @ ^ [I2: nat] : ( minus_minus @ nat @ I2 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X @ Y )
           => ( ( image2 @ nat @ nat
                @ ^ [I2: nat] : ( minus_minus @ nat @ I2 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_2655_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image2 @ A @ A
                    @ ^ [X3: A] : ( times_times @ A @ X3 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X @ C2 ) @ ( times_times @ A @ Y @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image2 @ A @ A
                    @ ^ [X3: A] : ( times_times @ A @ X3 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y @ C2 ) @ ( times_times @ A @ X @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X @ Y )
           => ( ( image2 @ A @ A
                @ ^ [X3: A] : ( times_times @ A @ X3 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_2656_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,M4: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image2 @ A @ A
                @ ^ [X3: A] : ( plus_plus @ A @ ( times_times @ A @ M4 @ X3 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M4 )
               => ( ( image2 @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( times_times @ A @ M4 @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M4 @ A3 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M4 @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M4 )
               => ( ( image2 @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( times_times @ A @ M4 @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M4 @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M4 @ A3 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_2657_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,M4: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image2 @ A @ A
                @ ^ [X3: A] : ( minus_minus @ A @ ( times_times @ A @ M4 @ X3 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M4 )
               => ( ( image2 @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( times_times @ A @ M4 @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M4 @ A3 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M4 @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M4 )
               => ( ( image2 @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( times_times @ A @ M4 @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M4 @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M4 @ A3 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_2658_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,M4: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image2 @ A @ A
                @ ^ [X3: A] : ( plus_plus @ A @ ( divide_divide @ A @ X3 @ M4 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M4 )
               => ( ( image2 @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( divide_divide @ A @ X3 @ M4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A3 @ M4 ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M4 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M4 )
               => ( ( image2 @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( divide_divide @ A @ X3 @ M4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M4 ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A3 @ M4 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_2659_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,M4: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image2 @ A @ A
                @ ^ [X3: A] : ( minus_minus @ A @ ( divide_divide @ A @ X3 @ M4 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M4 )
               => ( ( image2 @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( divide_divide @ A @ X3 @ M4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A3 @ M4 ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M4 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M4 )
               => ( ( image2 @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( divide_divide @ A @ X3 @ M4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M4 ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A3 @ M4 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_2660_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I4: set @ A,X: A > B,A3: A > B,B2: B,Delta: B] :
          ( ! [I3: A] :
              ( ( member @ A @ I3 @ I4 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X @ I3 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X @ I4 )
              = ( one_one @ B ) )
           => ( ! [I3: A] :
                  ( ( member @ A @ I3 @ I4 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A3 @ I3 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I2: A] : ( times_times @ B @ ( A3 @ I2 ) @ ( X @ I2 ) )
                      @ I4 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_2661_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S2: set @ A,R: set @ B,G: A > B,F: B > C] :
          ( ( finite_finite @ A @ S2 )
         => ( ( finite_finite @ B @ R )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ G @ S2 ) @ R )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X3: A] : ( F @ ( G @ X3 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y2: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X3: A] :
                                ( ( member @ A @ X3 @ S2 )
                                & ( ( G @ X3 )
                                  = Y2 ) ) ) ) )
                      @ ( F @ Y2 ) )
                  @ R ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_2662_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ).

% sum_gp_basic
thf(fact_2663_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A3: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ C2 )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A3 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S2 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A3 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ C2 )
                  @ S2 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S2 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_2664_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_2665_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) ) @ ( power_power @ A @ X @ I2 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_2666_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ ( suc @ N ) ) @ ( power_power @ A @ Y @ ( suc @ N ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ X @ P6 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ P6 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_2667_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M4: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
            = ( times_times @ A @ ( power_power @ A @ X @ M4 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_2668_ivl__disj__int__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(8)
thf(fact_2669_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q8: nat] : ( ord_less @ nat @ Q8 @ N ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_2670_atLeastAtMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or1337092689740270186AtMost @ A )
        = ( ^ [L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ L3 ) @ ( set_ord_atMost @ A @ U2 ) ) ) ) ) ).

% atLeastAtMost_def
thf(fact_2671_atLeastLessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or7035219750837199246ssThan @ A )
        = ( ^ [L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ L3 ) @ ( set_ord_lessThan @ A @ U2 ) ) ) ) ) ).

% atLeastLessThan_def
thf(fact_2672_ivl__disj__int__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(6)
thf(fact_2673_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M4: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X @ M4 ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_2674_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M4: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% prod.in_pairs
thf(fact_2675_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_2676_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I2 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.in_pairs_0
thf(fact_2677_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,M4: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( gbinomial @ A @ A3 @ K4 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K4 ) )
            @ ( set_ord_atMost @ nat @ M4 ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M4 ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ M4 ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_2678_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A3 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K4 ) ) @ ( power_power @ A @ A3 @ K4 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% binomial_ring
thf(fact_2679_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N5: nat,A5: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N5 ) @ A5 ) @ N5 ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N5 ) @ A5 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N5 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N5 ) @ A5 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_2680_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_2681_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A3 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I2: nat] : ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_2682_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A3 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K4 ) ) @ ( comm_s3205402744901411588hammer @ A @ A3 @ K4 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_2683_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P4: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P4 )
         => ( ( ord_less_eq @ nat @ K @ P4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J: nat] : ( if @ A @ ( ord_less @ nat @ J @ K ) @ ( G @ J ) @ ( if @ A @ ( J = K ) @ ( one_one @ A ) @ ( H2 @ ( minus_minus @ nat @ J @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P4 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J: nat] : ( if @ A @ ( ord_less @ nat @ J @ K ) @ ( G @ J ) @ ( H2 @ J ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_2684_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_2685_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M4: nat,A3: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M4 ) @ A3 ) @ K4 ) @ ( power_power @ A @ X @ K4 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M4 @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M4 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A3 ) @ K4 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ K4 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M4 @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M4 ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_2686_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A5: A,N5: nat] :
              ( if @ A
              @ ( N5
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A5 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N5 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_2687_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_2688_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,D2: A,N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( plus_plus @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I2 ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_2689_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp0
thf(fact_2690_atMost__Int__atLeast,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [N: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ N ) @ ( set_ord_atLeast @ A @ N ) )
          = ( insert2 @ A @ N @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atMost_Int_atLeast
thf(fact_2691_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M4: nat,A3: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M4 ) @ A3 ) @ K4 ) @ ( power_power @ A @ X @ K4 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M4 @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M4 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K4 ) @ A3 ) @ ( one_one @ A ) ) @ K4 ) @ ( power_power @ A @ X @ K4 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M4 @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M4 ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_2692_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( N
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I2 ) @ ( semiring_1_of_nat @ A @ I2 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_2693_ivl__disj__un__singleton_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A] :
          ( ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_ord_greaterThan @ A @ L ) )
          = ( set_ord_atLeast @ A @ L ) ) ) ).

% ivl_disj_un_singleton(1)
thf(fact_2694_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_2695_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_2696_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A,D2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I2: nat] : ( plus_plus @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I2 ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_2697_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M4: nat,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ ( plus_plus @ nat @ M4 @ N ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ ( plus_plus @ nat @ M4 @ N ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X @ M4 ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_2698_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I2: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I2 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I2 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_2699_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A5: A,K4: nat] :
              ( if @ A
              @ ( K4
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L3: nat] : ( times_times @ A @ ( minus_minus @ A @ A5 @ ( semiring_1_of_nat @ A @ L3 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K4 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K4 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_2700_atLeast__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atLeast @ nat @ K ) @ ( insert2 @ nat @ K @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast_Suc
thf(fact_2701_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_2702_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R4: A,M4: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( gbinomial @ A @ R4 @ K4 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K4 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M4 ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M4 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R4 @ ( suc @ M4 ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_2703_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N: nat,M4: nat,X: A] :
          ( ( ( ord_less @ nat @ N @ M4 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M4 )
           => ( ( ( X
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M4 ) ) ) )
              & ( ( X
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ M4 ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_2704_reflcl__set__eq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( sup_sup @ ( A > A > $o )
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 )
        @ ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
      = ( ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( id2 @ A ) ) ) ) ) ).

% reflcl_set_eq
thf(fact_2705_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: A > B,C3: set @ A,B3: set @ A,X: A] :
      ( ( inj_on @ A @ B @ G @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ C3 @ ( sup_sup @ ( set @ A ) @ B3 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member @ ( B > A )
          @ ^ [I2: B] : ( if @ A @ ( member @ B @ I2 @ ( image2 @ A @ B @ G @ C3 ) ) @ ( the_inv_into @ A @ B @ C3 @ G @ I2 ) @ X )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B3 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_2706_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N5: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I2: A] : ( plus_plus @ A @ I2 @ ( one_one @ A ) )
              @ N5
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_2707_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M4: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M4 ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q8: A,R5: A] : ( product_Pair @ A @ A @ Q8 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M4 @ N ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_2708_lookup__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P4: ref @ A,X: A] :
          ( hoare_hoare_triple @ A @ ( sngr_assn @ A @ P4 @ X ) @ ( ref_lookup @ A @ P4 )
          @ ^ [R5: A] : ( times_times @ assn @ ( sngr_assn @ A @ P4 @ X ) @ ( pure_assn @ ( R5 = X ) ) ) ) ) ).

% lookup_rule
thf(fact_2709_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L3: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q8: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L3 ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q8 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L3 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q8 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_2710_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Q: A > B > $o] :
      ( ! [X2: A,Y3: B] :
          ( ( P @ X2 @ Y3 )
         => ( Q @ X2 @ Y3 ) )
     => ( ord_less_eq @ ( A > B > $o ) @ P @ Q ) ) ).

% predicate2I
thf(fact_2711_inf1I,axiom,
    ! [A: $tType,A4: A > $o,X: A,B3: A > $o] :
      ( ( A4 @ X )
     => ( ( B3 @ X )
       => ( inf_inf @ ( A > $o ) @ A4 @ B3 @ X ) ) ) ).

% inf1I
thf(fact_2712_inf2I,axiom,
    ! [A: $tType,B: $tType,A4: A > B > $o,X: A,Y: B,B3: A > B > $o] :
      ( ( A4 @ X @ Y )
     => ( ( B3 @ X @ Y )
       => ( inf_inf @ ( A > B > $o ) @ A4 @ B3 @ X @ Y ) ) ) ).

% inf2I
thf(fact_2713_top2I,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] : ( top_top @ ( A > B > $o ) @ X @ Y ) ).

% top2I
thf(fact_2714_case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: B > C > A,A3: B,B2: C] :
      ( ( product_case_prod @ B @ C @ A @ F @ ( product_Pair @ B @ C @ A3 @ B2 ) )
      = ( F @ A3 @ B2 ) ) ).

% case_prod_conv
thf(fact_2715_case__prod__Pair,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) ).

% case_prod_Pair
thf(fact_2716_pair__imageI,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: A,B2: B,A4: set @ ( product_prod @ A @ B ),F: A > B > C] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ A4 )
     => ( member @ C @ ( F @ A3 @ B2 ) @ ( image2 @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ F ) @ A4 ) ) ) ).

% pair_imageI
thf(fact_2717_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M4: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M4 ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q8: A,R5: A] : ( product_Pair @ A @ A @ Q8 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M4 @ N ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_2718_inf1E,axiom,
    ! [A: $tType,A4: A > $o,B3: A > $o,X: A] :
      ( ( inf_inf @ ( A > $o ) @ A4 @ B3 @ X )
     => ~ ( ( A4 @ X )
         => ~ ( B3 @ X ) ) ) ).

% inf1E
thf(fact_2719_inf2E,axiom,
    ! [A: $tType,B: $tType,A4: A > B > $o,B3: A > B > $o,X: A,Y: B] :
      ( ( inf_inf @ ( A > B > $o ) @ A4 @ B3 @ X @ Y )
     => ~ ( ( A4 @ X @ Y )
         => ~ ( B3 @ X @ Y ) ) ) ).

% inf2E
thf(fact_2720_inf1D1,axiom,
    ! [A: $tType,A4: A > $o,B3: A > $o,X: A] :
      ( ( inf_inf @ ( A > $o ) @ A4 @ B3 @ X )
     => ( A4 @ X ) ) ).

% inf1D1
thf(fact_2721_inf1D2,axiom,
    ! [A: $tType,A4: A > $o,B3: A > $o,X: A] :
      ( ( inf_inf @ ( A > $o ) @ A4 @ B3 @ X )
     => ( B3 @ X ) ) ).

% inf1D2
thf(fact_2722_inf2D1,axiom,
    ! [A: $tType,B: $tType,A4: A > B > $o,B3: A > B > $o,X: A,Y: B] :
      ( ( inf_inf @ ( A > B > $o ) @ A4 @ B3 @ X @ Y )
     => ( A4 @ X @ Y ) ) ).

% inf2D1
thf(fact_2723_inf2D2,axiom,
    ! [A: $tType,B: $tType,A4: A > B > $o,B3: A > B > $o,X: A,Y: B] :
      ( ( inf_inf @ ( A > B > $o ) @ A4 @ B3 @ X @ Y )
     => ( B3 @ X @ Y ) ) ).

% inf2D2
thf(fact_2724_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X: A,Y: B,Q: A > B > $o] :
      ( ( P @ X @ Y )
     => ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
       => ( Q @ X @ Y ) ) ) ).

% rev_predicate2D
thf(fact_2725_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,X: A,Y: B] :
      ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
     => ( ( P @ X @ Y )
       => ( Q @ X @ Y ) ) ) ).

% predicate2D
thf(fact_2726_bot2E,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ~ ( bot_bot @ ( A > B > $o ) @ X @ Y ) ).

% bot2E
thf(fact_2727_split__cong,axiom,
    ! [C: $tType,B: $tType,A: $tType,Q4: product_prod @ A @ B,F: A > B > C,G: A > B > C,P4: product_prod @ A @ B] :
      ( ! [X2: A,Y3: B] :
          ( ( ( product_Pair @ A @ B @ X2 @ Y3 )
            = Q4 )
         => ( ( F @ X2 @ Y3 )
            = ( G @ X2 @ Y3 ) ) )
     => ( ( P4 = Q4 )
       => ( ( product_case_prod @ A @ B @ C @ F @ P4 )
          = ( product_case_prod @ A @ B @ C @ G @ Q4 ) ) ) ) ).

% split_cong
thf(fact_2728_old_Oprod_Ocase,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: A > B > C,X1: A,X22: B] :
      ( ( product_case_prod @ A @ B @ C @ F @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = ( F @ X1 @ X22 ) ) ).

% old.prod.case
thf(fact_2729_swap__inj__on,axiom,
    ! [B: $tType,A: $tType,A4: set @ ( product_prod @ A @ B )] :
      ( inj_on @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A )
      @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
        @ ^ [I2: A,J: B] : ( product_Pair @ B @ A @ J @ I2 ) )
      @ A4 ) ).

% swap_inj_on
thf(fact_2730_case__prod__Pair__iden,axiom,
    ! [B: $tType,A: $tType,P4: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P4 )
      = P4 ) ).

% case_prod_Pair_iden
thf(fact_2731_case__prodE2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Q: A > $o,P: B > C > A,Z2: product_prod @ B @ C] :
      ( ( Q @ ( product_case_prod @ B @ C @ A @ P @ Z2 ) )
     => ~ ! [X2: B,Y3: C] :
            ( ( Z2
              = ( product_Pair @ B @ C @ X2 @ Y3 ) )
           => ~ ( Q @ ( P @ X2 @ Y3 ) ) ) ) ).

% case_prodE2
thf(fact_2732_case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: ( product_prod @ A @ B ) > C] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X3: A,Y2: B] : ( F @ ( product_Pair @ A @ B @ X3 @ Y2 ) ) )
      = F ) ).

% case_prod_eta
thf(fact_2733_cond__case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > B > C,G: ( product_prod @ A @ B ) > C] :
      ( ! [X2: A,Y3: B] :
          ( ( F @ X2 @ Y3 )
          = ( G @ ( product_Pair @ A @ B @ X2 @ Y3 ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F )
        = G ) ) ).

% cond_case_prod_eta
thf(fact_2734_map__prod__def,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType] :
      ( ( product_map_prod @ A @ C @ B @ D )
      = ( ^ [F2: A > C,G2: B > D] :
            ( product_case_prod @ A @ B @ ( product_prod @ C @ D )
            @ ^ [X3: A,Y2: B] : ( product_Pair @ C @ D @ ( F2 @ X3 ) @ ( G2 @ Y2 ) ) ) ) ) ).

% map_prod_def
thf(fact_2735_case__prod__comp,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F: D > C > A,G: B > D,X: product_prod @ B @ C] :
      ( ( product_case_prod @ B @ C @ A @ ( comp @ D @ ( C > A ) @ B @ F @ G ) @ X )
      = ( F @ ( G @ ( product_fst @ B @ C @ X ) ) @ ( product_snd @ B @ C @ X ) ) ) ).

% case_prod_comp
thf(fact_2736_case__prod__o__map__prod,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType,A: $tType,F: D > E > C,G1: A > D,G22: B > E] :
      ( ( comp @ ( product_prod @ D @ E ) @ C @ ( product_prod @ A @ B ) @ ( product_case_prod @ D @ E @ C @ F ) @ ( product_map_prod @ A @ D @ B @ E @ G1 @ G22 ) )
      = ( product_case_prod @ A @ B @ C
        @ ^ [L3: A,R5: B] : ( F @ ( G1 @ L3 ) @ ( G22 @ R5 ) ) ) ) ).

% case_prod_o_map_prod
thf(fact_2737_prod_Osplit__sel,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: C > $o,F: A > B > C,Prod: product_prod @ A @ B] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( ( Prod
          = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
       => ( P @ ( F @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ).

% prod.split_sel
thf(fact_2738_prod_Osplit__sel__asm,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: C > $o,F: A > B > C,Prod: product_prod @ A @ B] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( ~ ( ( Prod
              = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
            & ~ ( P @ ( F @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ) ).

% prod.split_sel_asm
thf(fact_2739_rat__abs__code,axiom,
    ! [P4: rat] :
      ( ( quotient_of @ ( abs_abs @ rat @ P4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int] : ( product_Pair @ int @ int @ ( abs_abs @ int @ A5 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_abs_code
thf(fact_2740_fst__snd__flip,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ B @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ B @ A )
        @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
          @ ^ [X3: A,Y2: B] : ( product_Pair @ B @ A @ Y2 @ X3 ) ) ) ) ).

% fst_snd_flip
thf(fact_2741_snd__fst__flip,axiom,
    ! [A: $tType,B: $tType] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ A @ B ) @ A @ ( product_prod @ B @ A ) @ ( product_fst @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [X3: B,Y2: A] : ( product_Pair @ A @ B @ Y2 @ X3 ) ) ) ) ).

% snd_fst_flip
thf(fact_2742_rat__uminus__code,axiom,
    ! [P4: rat] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ P4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ A5 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_uminus_code
thf(fact_2743_rat__minus__code,axiom,
    ! [P4: rat,Q4: rat] :
      ( ( quotient_of @ ( minus_minus @ rat @ P4 @ Q4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C5: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( minus_minus @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ B4 @ C5 ) ) @ ( times_times @ int @ C5 @ D5 ) ) )
            @ ( quotient_of @ Q4 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_minus_code
thf(fact_2744_rat__divide__code,axiom,
    ! [P4: rat,Q4: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P4 @ Q4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C5: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ C5 @ B4 ) ) )
            @ ( quotient_of @ Q4 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_divide_code
thf(fact_2745_rat__times__code,axiom,
    ! [P4: rat,Q4: rat] :
      ( ( quotient_of @ ( times_times @ rat @ P4 @ Q4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C5: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A5 @ B4 ) @ ( times_times @ int @ C5 @ D5 ) ) )
            @ ( quotient_of @ Q4 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_times_code
thf(fact_2746_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N5: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N5
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M3 @ N5 ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M3 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q8: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q8 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M3 @ N5 ) @ N5 ) ) ) ) ) ).

% divmod_nat_if
thf(fact_2747_rat__plus__code,axiom,
    ! [P4: rat,Q4: rat] :
      ( ( quotient_of @ ( plus_plus @ rat @ P4 @ Q4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,C5: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D5: int] : ( normalize @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ A5 @ D5 ) @ ( times_times @ int @ B4 @ C5 ) ) @ ( times_times @ int @ C5 @ D5 ) ) )
            @ ( quotient_of @ Q4 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_plus_code
thf(fact_2748_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L3: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q8: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L3 ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q8 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L3 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q8 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_2749_rat__inverse__code,axiom,
    ! [P4: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A5: int,B4: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A5
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A5 ) @ B4 ) @ ( abs_abs @ int @ A5 ) ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_inverse_code
thf(fact_2750_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L3: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q8: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L3 ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q8 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L3 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q8 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_2751_normalize__def,axiom,
    ( normalize
    = ( ^ [P6: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P6 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P6 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_2752_freeze__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,Xs: list @ A] :
          ( hoare_hoare_triple @ ( list @ A ) @ ( snga_assn @ A @ A3 @ Xs ) @ ( array_freeze @ A @ A3 )
          @ ^ [R5: list @ A] : ( times_times @ assn @ ( snga_assn @ A @ A3 @ Xs ) @ ( pure_assn @ ( R5 = Xs ) ) ) ) ) ).

% freeze_rule
thf(fact_2753_bind__return,axiom,
    ! [A: $tType,F: heap_Time_Heap @ A] :
      ( ( heap_Time_bind @ A @ A @ F @ ( heap_Time_return @ A ) )
      = ( heap_Time_bind @ product_unit @ A @ ( heap_Time_wait @ ( one_one @ nat ) )
        @ ^ [Uu: product_unit] : F ) ) ).

% bind_return
thf(fact_2754_return__bind,axiom,
    ! [B: $tType,A: $tType,X: B,F: B > ( heap_Time_Heap @ A )] :
      ( ( heap_Time_bind @ B @ A @ ( heap_Time_return @ B @ X ) @ F )
      = ( heap_Time_bind @ product_unit @ A @ ( heap_Time_wait @ ( one_one @ nat ) )
        @ ^ [Uu: product_unit] : ( F @ X ) ) ) ).

% return_bind
thf(fact_2755_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F3: set @ A,I4: set @ A,F: A > B,I: A] :
          ( ( finite_finite @ A @ F3 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I2: A] :
                    ( ( member @ A @ I2 @ I4 )
                    & ( ( F @ I2 )
                     != ( zero_zero @ B ) ) ) )
              @ F3 )
           => ( ( ( member @ A @ I @ I4 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F @ ( minus_minus @ ( set @ A ) @ I4 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F @ I4 ) @ ( F @ I ) ) ) )
              & ( ~ ( member @ A @ I @ I4 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F @ ( minus_minus @ ( set @ A ) @ I4 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F @ I4 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_2756_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L3: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q8: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L3 ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q8 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L3 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q8 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_2757_case__prodI2,axiom,
    ! [B: $tType,A: $tType,P4: product_prod @ A @ B,C2: A > B > $o] :
      ( ! [A8: A,B6: B] :
          ( ( P4
            = ( product_Pair @ A @ B @ A8 @ B6 ) )
         => ( C2 @ A8 @ B6 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P4 ) ) ).

% case_prodI2
thf(fact_2758_case__prodI,axiom,
    ! [A: $tType,B: $tType,F: A > B > $o,A3: A,B2: B] :
      ( ( F @ A3 @ B2 )
     => ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A3 @ B2 ) ) ) ).

% case_prodI
thf(fact_2759_mem__case__prodI2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P4: product_prod @ A @ B,Z2: C,C2: A > B > ( set @ C )] :
      ( ! [A8: A,B6: B] :
          ( ( P4
            = ( product_Pair @ A @ B @ A8 @ B6 ) )
         => ( member @ C @ Z2 @ ( C2 @ A8 @ B6 ) ) )
     => ( member @ C @ Z2 @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P4 ) ) ) ).

% mem_case_prodI2
thf(fact_2760_mem__case__prodI,axiom,
    ! [A: $tType,B: $tType,C: $tType,Z2: A,C2: B > C > ( set @ A ),A3: B,B2: C] :
      ( ( member @ A @ Z2 @ ( C2 @ A3 @ B2 ) )
     => ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A3 @ B2 ) ) ) ) ).

% mem_case_prodI
thf(fact_2761_case__prodI2_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P4: product_prod @ A @ B,C2: A > B > C > $o,X: C] :
      ( ! [A8: A,B6: B] :
          ( ( ( product_Pair @ A @ B @ A8 @ B6 )
            = P4 )
         => ( C2 @ A8 @ B6 @ X ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P4 @ X ) ) ).

% case_prodI2'
thf(fact_2762_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] :
          ( ( gcd_gcd @ A @ A3 @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_right_bottom
thf(fact_2763_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] :
          ( ( gcd_gcd @ A @ ( one_one @ A ) @ A3 )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_left_bottom
thf(fact_2764_Collect__const__case__prod,axiom,
    ! [B: $tType,A: $tType,P: $o] :
      ( ( P
       => ( ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A5: A,B4: B] : P ) )
          = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) )
      & ( ~ P
       => ( ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A5: A,B4: B] : P ) )
          = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% Collect_const_case_prod
thf(fact_2765_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ ( one_one @ A ) )
          = ( ( gcd_gcd @ A @ A3 @ B2 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_gcd_iff
thf(fact_2766_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P4: B > A] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty'
thf(fact_2767_Gcd__2,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( gcd_Gcd @ A @ ( insert2 @ A @ A3 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( gcd_gcd @ A @ A3 @ B2 ) ) ) ).

% Gcd_2
thf(fact_2768_lex__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( lex_prod @ A @ B )
      = ( ^ [Ra: set @ ( product_prod @ A @ A ),Rb: set @ ( product_prod @ B @ B )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [A5: A,B4: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [A7: A,B10: B] :
                        ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ A7 ) @ Ra )
                        | ( ( A5 = A7 )
                          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B4 @ B10 ) @ Rb ) ) ) ) ) ) ) ) ) ).

% lex_prod_def
thf(fact_2769_divmod__integer_H__def,axiom,
    ( ( unique8689654367752047608divmod @ code_integer )
    = ( ^ [M3: num,N5: num] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( numeral_numeral @ code_integer @ M3 ) @ ( numeral_numeral @ code_integer @ N5 ) ) @ ( modulo_modulo @ code_integer @ ( numeral_numeral @ code_integer @ M3 ) @ ( numeral_numeral @ code_integer @ N5 ) ) ) ) ) ).

% divmod_integer'_def
thf(fact_2770_mem__case__prodE,axiom,
    ! [B: $tType,A: $tType,C: $tType,Z2: A,C2: B > C > ( set @ A ),P4: product_prod @ B @ C] :
      ( ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P4 ) )
     => ~ ! [X2: B,Y3: C] :
            ( ( P4
              = ( product_Pair @ B @ C @ X2 @ Y3 ) )
           => ~ ( member @ A @ Z2 @ ( C2 @ X2 @ Y3 ) ) ) ) ).

% mem_case_prodE
thf(fact_2771_case__prodE,axiom,
    ! [A: $tType,B: $tType,C2: A > B > $o,P4: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P4 )
     => ~ ! [X2: A,Y3: B] :
            ( ( P4
              = ( product_Pair @ A @ B @ X2 @ Y3 ) )
           => ~ ( C2 @ X2 @ Y3 ) ) ) ).

% case_prodE
thf(fact_2772_case__prodD,axiom,
    ! [A: $tType,B: $tType,F: A > B > $o,A3: A,B2: B] :
      ( ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A3 @ B2 ) )
     => ( F @ A3 @ B2 ) ) ).

% case_prodD
thf(fact_2773_case__prodE_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: A > B > C > $o,P4: product_prod @ A @ B,Z2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P4 @ Z2 )
     => ~ ! [X2: A,Y3: B] :
            ( ( P4
              = ( product_Pair @ A @ B @ X2 @ Y3 ) )
           => ~ ( C2 @ X2 @ Y3 @ Z2 ) ) ) ).

% case_prodE'
thf(fact_2774_case__prodD_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,R: A > B > C > $o,A3: A,B2: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R @ ( product_Pair @ A @ B @ A3 @ B2 ) @ C2 )
     => ( R @ A3 @ B2 @ C2 ) ) ).

% case_prodD'
thf(fact_2775_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M4: A,K: A,N: A] :
          ( ( gcd_gcd @ A @ M4 @ ( plus_plus @ A @ ( times_times @ A @ K @ M4 ) @ N ) )
          = ( gcd_gcd @ A @ M4 @ N ) ) ) ).

% gcd_add_mult
thf(fact_2776_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_2777_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_2778_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A3 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_2779_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A3 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_2780_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A3 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_2781_wait__bind__decon,axiom,
    ! [A: $tType,P: assn,M4: heap_Time_Heap @ A,Q: A > assn,N: nat] :
      ( ( hoare_hoare_triple @ A @ P @ M4 @ Q )
     => ( hoare_hoare_triple @ A @ P
        @ ( heap_Time_bind @ product_unit @ A @ ( heap_Time_wait @ N )
          @ ^ [Uu: product_unit] : M4 )
        @ Q ) ) ).

% wait_bind_decon
thf(fact_2782_Gcd__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( semiring_gcd_Gcd_fin @ A @ ( insert2 @ A @ A3 @ A4 ) )
          = ( gcd_gcd @ A @ A3 @ ( semiring_gcd_Gcd_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% Gcd_fin.insert_remove
thf(fact_2783_Gcd__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( member @ A @ A3 @ A4 )
         => ( ( semiring_gcd_Gcd_fin @ A @ A4 )
            = ( gcd_gcd @ A @ A3 @ ( semiring_gcd_Gcd_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% Gcd_fin.remove
thf(fact_2784_wait__rule,axiom,
    ! [N: nat] :
      ( hoare_hoare_triple @ product_unit @ ( one_one @ assn ) @ ( heap_Time_wait @ N )
      @ ^ [Uu: product_unit] : ( one_one @ assn ) ) ).

% wait_rule
thf(fact_2785_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I4: set @ A,F: A > B,I: A] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [I2: A] :
                  ( ( member @ A @ I2 @ I4 )
                  & ( ( F @ I2 )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member @ A @ I @ I4 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F @ ( minus_minus @ ( set @ A ) @ I4 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F @ I4 ) @ ( F @ I ) ) ) )
            & ( ~ ( member @ A @ I @ I4 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F @ ( minus_minus @ ( set @ A ) @ I4 @ ( insert2 @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F @ I4 ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_2786_lookup__chain,axiom,
    ! [B: $tType,A: $tType] :
      ( ( heap @ B )
     => ! [R4: ref @ B,F: heap_Time_Heap @ A] :
          ( ( heap_Time_bind @ B @ A @ ( ref_lookup @ B @ R4 )
            @ ^ [Uu: B] : F )
          = ( heap_Time_bind @ product_unit @ A @ ( heap_Time_wait @ ( one_one @ nat ) )
            @ ^ [Uu: product_unit] : F ) ) ) ).

% lookup_chain
thf(fact_2787_bsqr__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Wellorder_bsqr @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) )
            @ ( product_case_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) @ $o
              @ ( product_case_prod @ A @ A @ ( ( product_prod @ A @ A ) > $o )
                @ ^ [A12: A,A23: A] :
                    ( product_case_prod @ A @ A @ $o
                    @ ^ [B1: A,B22: A] :
                        ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ A12 @ ( insert2 @ A @ A23 @ ( insert2 @ A @ B1 @ ( insert2 @ A @ B22 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) @ ( field2 @ A @ R5 ) )
                        & ( ( ( A12 = B1 )
                            & ( A23 = B22 ) )
                          | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( bNF_We1388413361240627857o_max2 @ A @ R5 @ A12 @ A23 ) @ ( bNF_We1388413361240627857o_max2 @ A @ R5 @ B1 @ B22 ) ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ ( id2 @ A ) ) )
                          | ( ( ( bNF_We1388413361240627857o_max2 @ A @ R5 @ A12 @ A23 )
                              = ( bNF_We1388413361240627857o_max2 @ A @ R5 @ B1 @ B22 ) )
                            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A12 @ B1 ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ ( id2 @ A ) ) ) )
                          | ( ( ( bNF_We1388413361240627857o_max2 @ A @ R5 @ A12 @ A23 )
                              = ( bNF_We1388413361240627857o_max2 @ A @ R5 @ B1 @ B22 ) )
                            & ( A12 = B1 )
                            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A23 @ B22 ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ ( id2 @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% bsqr_def
thf(fact_2788_Code__Numeral_Onegative__def,axiom,
    ( code_negative
    = ( comp @ code_integer @ code_integer @ num @ ( uminus_uminus @ code_integer ) @ ( numeral_numeral @ code_integer ) ) ) ).

% Code_Numeral.negative_def
thf(fact_2789_insert__relcomp__union__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B ),X: product_prod @ C @ A,X5: set @ ( product_prod @ C @ B )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S2 )
     => ( ( sup_sup @ ( set @ ( product_prod @ C @ B ) ) @ ( relcomp @ C @ A @ B @ ( insert2 @ ( product_prod @ C @ A ) @ X @ ( bot_bot @ ( set @ ( product_prod @ C @ A ) ) ) ) @ S2 ) @ X5 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z4: B,A15: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X )
                  = W3 )
                @ ( insert2 @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X ) @ Z4 ) @ A15 )
                @ A15 ) )
          @ X5
          @ S2 ) ) ) ).

% insert_relcomp_union_fold
thf(fact_2790_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: B > A,A16: set @ B,B12: set @ A,F22: C > D,B23: set @ C,A24: set @ D] :
      ( ( ( image2 @ B @ A @ F1 @ A16 )
        = B12 )
     => ( ( inj_on @ C @ D @ F22 @ B23 )
       => ( ( ord_less_eq @ ( set @ D ) @ ( image2 @ C @ D @ F22 @ B23 ) @ A24 )
         => ( ( ( B23
                = ( bot_bot @ ( set @ C ) ) )
             => ( A24
                = ( bot_bot @ ( set @ D ) ) ) )
           => ( ( bNF_Wellorder_Func @ C @ A @ B23 @ B12 )
              = ( image2 @ ( D > B ) @ ( C > A ) @ ( bNF_We4925052301507509544nc_map @ C @ B @ A @ D @ B23 @ F1 @ F22 ) @ ( bNF_Wellorder_Func @ D @ B @ A24 @ A16 ) ) ) ) ) ) ) ).

% Func_map_surj
thf(fact_2791_Func__non__emp,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,A4: set @ B] :
      ( ( B3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( bNF_Wellorder_Func @ B @ A @ A4 @ B3 )
       != ( bot_bot @ ( set @ ( B > A ) ) ) ) ) ).

% Func_non_emp
thf(fact_2792_fold__empty,axiom,
    ! [B: $tType,A: $tType,F: B > A > A,Z2: A] :
      ( ( finite_fold @ B @ A @ F @ Z2 @ ( bot_bot @ ( set @ B ) ) )
      = Z2 ) ).

% fold_empty
thf(fact_2793_gcd__nat_Osemilattice__neutr__axioms,axiom,
    semilattice_neutr @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) ).

% gcd_nat.semilattice_neutr_axioms
thf(fact_2794_gcd__nat_Omonoid__axioms,axiom,
    monoid @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) ).

% gcd_nat.monoid_axioms
thf(fact_2795_Gcd__in,axiom,
    ! [A4: set @ nat] :
      ( ! [A8: nat,B6: nat] :
          ( ( member @ nat @ A8 @ A4 )
         => ( ( member @ nat @ B6 @ A4 )
           => ( member @ nat @ ( gcd_gcd @ nat @ A8 @ B6 ) @ A4 ) ) )
     => ( ( A4
         != ( bot_bot @ ( set @ nat ) ) )
       => ( member @ nat @ ( gcd_Gcd @ nat @ A4 ) @ A4 ) ) ) ).

% Gcd_in
thf(fact_2796_fold__image,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: A > B,A4: set @ A,F: B > C > C,Z2: C] :
      ( ( inj_on @ A @ B @ G @ A4 )
     => ( ( finite_fold @ B @ C @ F @ Z2 @ ( image2 @ A @ B @ G @ A4 ) )
        = ( finite_fold @ A @ C @ ( comp @ B @ ( C > C ) @ A @ F @ G ) @ Z2 @ A4 ) ) ) ).

% fold_image
thf(fact_2797_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups7311177749621191930dd_sum @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( plus_plus @ A ) @ G2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% sum.eq_fold
thf(fact_2798_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( times_times @ A ) @ G2 ) @ ( one_one @ A ) ) ) ) ) ).

% prod.eq_fold
thf(fact_2799_Inf__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A4 ) )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ X @ A4 ) ) ) ) ).

% Inf_fin.eq_fold
thf(fact_2800_Sup__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A4 ) )
            = ( finite_fold @ A @ A @ ( sup_sup @ A ) @ X @ A4 ) ) ) ) ).

% Sup_fin.eq_fold
thf(fact_2801_image__fold__insert,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,F: A > B] :
      ( ( finite_finite @ A @ A4 )
     => ( ( image2 @ A @ B @ F @ A4 )
        = ( finite_fold @ A @ ( set @ B )
          @ ^ [K4: A] : ( insert2 @ B @ ( F @ K4 ) )
          @ ( bot_bot @ ( set @ B ) )
          @ A4 ) ) ) ).

% image_fold_insert
thf(fact_2802_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( ^ [A10: set @ A] : ( if @ A @ ( finite_finite @ A @ A10 ) @ ( finite_fold @ A @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ A10 ) @ ( one_one @ A ) ) ) ) ) ).

% Gcd_fin.eq_fold
thf(fact_2803_relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ B @ C )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ R )
     => ( ( finite_finite @ ( product_prod @ B @ C ) @ S2 )
       => ( ( relcomp @ A @ B @ C @ R @ S2 )
          = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ A @ C ) )
            @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
              @ ^ [X3: A,Y2: B,A10: set @ ( product_prod @ A @ C )] :
                  ( finite_fold @ ( product_prod @ B @ C ) @ ( set @ ( product_prod @ A @ C ) )
                  @ ( product_case_prod @ B @ C @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
                    @ ^ [W3: B,Z4: C,A15: set @ ( product_prod @ A @ C )] : ( if @ ( set @ ( product_prod @ A @ C ) ) @ ( Y2 = W3 ) @ ( insert2 @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X3 @ Z4 ) @ A15 ) @ A15 ) )
                  @ A10
                  @ S2 ) )
            @ ( bot_bot @ ( set @ ( product_prod @ A @ C ) ) )
            @ R ) ) ) ) ).

% relcomp_fold
thf(fact_2804_Id__on__fold,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( id_on @ A @ A4 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ A @ A ) )
          @ ^ [X3: A] : ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) )
          @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) )
          @ A4 ) ) ) ).

% Id_on_fold
thf(fact_2805_insert__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B ),X: product_prod @ C @ A,R: set @ ( product_prod @ C @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S2 )
     => ( ( relcomp @ C @ A @ B @ ( insert2 @ ( product_prod @ C @ A ) @ X @ R ) @ S2 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z4: B,A15: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X )
                  = W3 )
                @ ( insert2 @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X ) @ Z4 ) @ A15 )
                @ A15 ) )
          @ ( relcomp @ C @ A @ B @ R @ S2 )
          @ S2 ) ) ) ).

% insert_relcomp_fold
thf(fact_2806_Func__is__emp,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( ( bNF_Wellorder_Func @ A @ B @ A4 @ B3 )
        = ( bot_bot @ ( set @ ( A > B ) ) ) )
      = ( ( A4
         != ( bot_bot @ ( set @ A ) ) )
        & ( B3
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% Func_is_emp
thf(fact_2807_gcd__nat_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y = X ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_2808_Set__filter__fold,axiom,
    ! [A: $tType,A4: set @ A,P: A > $o] :
      ( ( finite_finite @ A @ A4 )
     => ( ( filter3 @ A @ P @ A4 )
        = ( finite_fold @ A @ ( set @ A )
          @ ^ [X3: A,A15: set @ A] : ( if @ ( set @ A ) @ ( P @ X3 ) @ ( insert2 @ A @ X3 @ A15 ) @ A15 )
          @ ( bot_bot @ ( set @ A ) )
          @ A4 ) ) ) ).

% Set_filter_fold
thf(fact_2809_comp__fun__commute__relcomp__fold,axiom,
    ! [A: $tType,B: $tType,C: $tType,S2: set @ ( product_prod @ A @ B )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S2 )
     => ( finite6289374366891150609ommute @ ( product_prod @ C @ A ) @ ( set @ ( product_prod @ C @ B ) )
        @ ( product_case_prod @ C @ A @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
          @ ^ [X3: C,Y2: A,A10: set @ ( product_prod @ C @ B )] :
              ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
              @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
                @ ^ [W3: A,Z4: B,A15: set @ ( product_prod @ C @ B )] : ( if @ ( set @ ( product_prod @ C @ B ) ) @ ( Y2 = W3 ) @ ( insert2 @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ X3 @ Z4 ) @ A15 ) @ A15 ) )
              @ A10
              @ S2 ) ) ) ) ).

% comp_fun_commute_relcomp_fold
thf(fact_2810_bit__cut__integer__def,axiom,
    ( code_bit_cut_integer
    = ( ^ [K4: code_integer] :
          ( product_Pair @ code_integer @ $o @ ( divide_divide @ code_integer @ K4 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) )
          @ ~ ( dvd_dvd @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ K4 ) ) ) ) ).

% bit_cut_integer_def
thf(fact_2811_divmod__integer__def,axiom,
    ( code_divmod_integer
    = ( ^ [K4: code_integer,L3: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ K4 @ L3 ) @ ( modulo_modulo @ code_integer @ K4 @ L3 ) ) ) ) ).

% divmod_integer_def
thf(fact_2812_convol__image__vimage2p,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,F: C > A,G: D > B,R: A > B > $o] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( bNF_convol @ ( product_prod @ C @ D ) @ A @ B @ ( comp @ C @ A @ ( product_prod @ C @ D ) @ F @ ( product_fst @ C @ D ) ) @ ( comp @ D @ B @ ( product_prod @ C @ D ) @ G @ ( product_snd @ C @ D ) ) ) @ ( collect @ ( product_prod @ C @ D ) @ ( product_case_prod @ C @ D @ $o @ ( bNF_vimage2p @ C @ A @ D @ B @ $o @ F @ G @ R ) ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) ) ).

% convol_image_vimage2p
thf(fact_2813_comp__fun__commute_Ointro,axiom,
    ! [B: $tType,A: $tType,F: A > B > B] :
      ( ! [Y3: A,X2: A] :
          ( ( comp @ B @ B @ B @ ( F @ Y3 ) @ ( F @ X2 ) )
          = ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) )
     => ( finite6289374366891150609ommute @ A @ B @ F ) ) ).

% comp_fun_commute.intro
thf(fact_2814_comp__fun__commute_Ocomp__fun__commute,axiom,
    ! [B: $tType,A: $tType,F: A > B > B,Y: A,X: A] :
      ( ( finite6289374366891150609ommute @ A @ B @ F )
     => ( ( comp @ B @ B @ B @ ( F @ Y ) @ ( F @ X ) )
        = ( comp @ B @ B @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ).

% comp_fun_commute.comp_fun_commute
thf(fact_2815_comp__fun__commute__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite6289374366891150609ommute @ A @ B )
      = ( ^ [F2: A > B > B] :
          ! [Y2: A,X3: A] :
            ( ( comp @ B @ B @ B @ ( F2 @ Y2 ) @ ( F2 @ X3 ) )
            = ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) ) ).

% comp_fun_commute_def
thf(fact_2816_comp__fun__commute_Ocomp__comp__fun__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: A > B > B,G: C > A] :
      ( ( finite6289374366891150609ommute @ A @ B @ F )
     => ( finite6289374366891150609ommute @ C @ B @ ( comp @ A @ ( B > B ) @ C @ F @ G ) ) ) ).

% comp_fun_commute.comp_comp_fun_commute
thf(fact_2817_vimage2p__comp,axiom,
    ! [E: $tType,D: $tType,F9: $tType,A: $tType,C: $tType,B: $tType,G3: $tType,F1: F9 > A,F22: D > F9,G1: G3 > B,G22: E > G3] :
      ( ( bNF_vimage2p @ D @ A @ E @ B @ C @ ( comp @ F9 @ A @ D @ F1 @ F22 ) @ ( comp @ G3 @ B @ E @ G1 @ G22 ) )
      = ( comp @ ( F9 > G3 > C ) @ ( D > E > C ) @ ( A > B > C ) @ ( bNF_vimage2p @ D @ F9 @ E @ G3 @ C @ F22 @ G22 ) @ ( bNF_vimage2p @ F9 @ A @ G3 @ B @ C @ F1 @ G1 ) ) ) ).

% vimage2p_comp
thf(fact_2818_inter__Set__filter,axiom,
    ! [A: $tType,B3: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( filter3 @ A
          @ ^ [X3: A] : ( member @ A @ X3 @ A4 )
          @ B3 ) ) ) ).

% inter_Set_filter
thf(fact_2819_comp__fun__commute__product__fold,axiom,
    ! [A: $tType,B: $tType,B3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( finite6289374366891150609ommute @ B @ ( set @ ( product_prod @ B @ A ) )
        @ ^ [X3: B,Z4: set @ ( product_prod @ B @ A )] :
            ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
            @ ^ [Y2: A] : ( insert2 @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X3 @ Y2 ) )
            @ Z4
            @ B3 ) ) ) ).

% comp_fun_commute_product_fold
thf(fact_2820_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K4: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S6: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K4 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S6 ) )
                @ ( S6
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K4 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_2821_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K4: code_integer,L3: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L3
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K4 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L3
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K4 )
                  = ( sgn_sgn @ code_integer @ L3 ) )
                @ ( code_divmod_abs @ K4 @ L3 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S6: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S6
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L3 ) @ S6 ) ) )
                  @ ( code_divmod_abs @ K4 @ L3 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_2822_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K4: code_integer,L3: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L3 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K4 ) @ ( code_divmod_abs @ K4 @ L3 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S6: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S6
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L3 @ S6 ) ) )
                @ ( code_divmod_abs @ K4 @ L3 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L3
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K4 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K4 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K4 @ L3 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S6: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S6
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L3 ) @ S6 ) ) )
                    @ ( code_divmod_abs @ K4 @ L3 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_2823_inverse__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X3: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X3 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) )
    @ ( inverse_inverse @ rat ) ) ).

% inverse_rat.transfer
thf(fact_2824_max__extp__max__ext__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( max_extp @ A
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R ) )
      = ( ^ [X3: set @ A,Y2: set @ A] : ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X3 @ Y2 ) @ ( max_ext @ A @ R ) ) ) ) ).

% max_extp_max_ext_eq
thf(fact_2825_same__fst__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( same_fst @ A @ B )
      = ( ^ [P3: A > $o,R2: A > ( set @ ( product_prod @ B @ B ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [X9: A,Y7: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [X3: A,Y2: B] :
                        ( ( X9 = X3 )
                        & ( P3 @ X3 )
                        & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y7 @ Y2 ) @ ( R2 @ X3 ) ) ) ) ) ) ) ) ) ).

% same_fst_def
thf(fact_2826_same__fstI,axiom,
    ! [B: $tType,A: $tType,P: A > $o,X: A,Y8: B,Y: B,R: A > ( set @ ( product_prod @ B @ B ) )] :
      ( ( P @ X )
     => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y8 @ Y ) @ ( R @ X ) )
       => ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y8 ) @ ( product_Pair @ A @ B @ X @ Y ) ) @ ( same_fst @ A @ B @ P @ R ) ) ) ) ).

% same_fstI
thf(fact_2827_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( power @ B )
        & ( power @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ A @ B @ ( nat > A ) @ ( nat > B ) @ R
              @ ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
                @ R )
              @ ( power_power @ A )
              @ ( power_power @ B ) ) ) ) ) ).

% power_transfer
thf(fact_2828_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( semiring_numeral @ B )
        & ( monoid_add @ A )
        & ( semiring_numeral @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ num @ num @ A @ B
                @ ^ [Y4: num,Z5: num] : ( Y4 = Z5 )
                @ R
                @ ( numeral_numeral @ A )
                @ ( numeral_numeral @ B ) ) ) ) ) ) ).

% transfer_rule_numeral
thf(fact_2829_fun_Omap__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,G3: $tType,F9: $tType,Rb2: A > F9 > $o,Sd: B > G3 > $o] :
      ( bNF_rel_fun @ ( A > B ) @ ( F9 > G3 ) @ ( ( D > A ) > D > B ) @ ( ( D > F9 ) > D > G3 ) @ ( bNF_rel_fun @ A @ F9 @ B @ G3 @ Rb2 @ Sd )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > F9 ) @ ( D > B ) @ ( D > G3 )
        @ ( bNF_rel_fun @ D @ D @ A @ F9
          @ ^ [Y4: D,Z5: D] : ( Y4 = Z5 )
          @ Rb2 )
        @ ( bNF_rel_fun @ D @ D @ B @ G3
          @ ^ [Y4: D,Z5: D] : ( Y4 = Z5 )
          @ Sd ) )
      @ ( comp @ A @ B @ D )
      @ ( comp @ F9 @ G3 @ D ) ) ).

% fun.map_transfer
thf(fact_2830_comp__transfer,axiom,
    ! [A: $tType,B: $tType,E: $tType,F9: $tType,D: $tType,C: $tType,B3: A > C > $o,C3: B > D > $o,A4: E > F9 > $o] : ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > A ) > E > B ) @ ( ( F9 > C ) > F9 > D ) @ ( bNF_rel_fun @ A @ C @ B @ D @ B3 @ C3 ) @ ( bNF_rel_fun @ ( E > A ) @ ( F9 > C ) @ ( E > B ) @ ( F9 > D ) @ ( bNF_rel_fun @ E @ F9 @ A @ C @ A4 @ B3 ) @ ( bNF_rel_fun @ E @ F9 @ B @ D @ A4 @ C3 ) ) @ ( comp @ A @ B @ E ) @ ( comp @ C @ D @ F9 ) ) ).

% comp_transfer
thf(fact_2831_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ring_1 @ B )
        & ( ring_1 @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( ( bNF_rel_fun @ A @ B @ A @ B @ R @ R @ ( uminus_uminus @ A ) @ ( uminus_uminus @ B ) )
               => ( bNF_rel_fun @ int @ int @ A @ B
                  @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
                  @ R
                  @ ( ring_1_of_int @ A )
                  @ ( ring_1_of_int @ B ) ) ) ) ) ) ) ).

% transfer_rule_of_int
thf(fact_2832_fun_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Sa: A > C > $o,X: D > A,G: B > C,Y: D > B] :
      ( ( bNF_rel_fun @ D @ D @ A @ C
        @ ^ [Y4: D,Z5: D] : ( Y4 = Z5 )
        @ Sa
        @ X
        @ ( comp @ B @ C @ D @ G @ Y ) )
      = ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y4: D,Z5: D] : ( Y4 = Z5 )
        @ ^ [X3: A,Y2: B] : ( Sa @ X3 @ ( G @ Y2 ) )
        @ X
        @ Y ) ) ).

% fun.rel_map(2)
thf(fact_2833_fun_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Sb: C > B > $o,I: A > C,X: D > A,Y: D > B] :
      ( ( bNF_rel_fun @ D @ D @ C @ B
        @ ^ [Y4: D,Z5: D] : ( Y4 = Z5 )
        @ Sb
        @ ( comp @ A @ C @ D @ I @ X )
        @ Y )
      = ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y4: D,Z5: D] : ( Y4 = Z5 )
        @ ^ [X3: A] : ( Sb @ ( I @ X3 ) )
        @ X
        @ Y ) ) ).

% fun.rel_map(1)
thf(fact_2834_divmod__abs__code_I5_J,axiom,
    ! [J2: code_integer] :
      ( ( code_divmod_abs @ J2 @ ( zero_zero @ code_integer ) )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( abs_abs @ code_integer @ J2 ) ) ) ).

% divmod_abs_code(5)
thf(fact_2835_divmod__abs__code_I6_J,axiom,
    ! [J2: code_integer] :
      ( ( code_divmod_abs @ ( zero_zero @ code_integer ) @ J2 )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ) ).

% divmod_abs_code(6)
thf(fact_2836_rel__fun__Collect__case__prodD,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,A4: A > B > $o,B3: C > D > $o,F: A > C,G: B > D,X5: set @ ( product_prod @ A @ B ),X: product_prod @ A @ B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A4 @ B3 @ F @ G )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ X5 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A4 ) ) )
       => ( ( member @ ( product_prod @ A @ B ) @ X @ X5 )
         => ( B3 @ ( comp @ A @ C @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) @ X ) @ ( comp @ B @ D @ ( product_prod @ A @ B ) @ G @ ( product_snd @ A @ B ) @ X ) ) ) ) ) ).

% rel_fun_Collect_case_prodD
thf(fact_2837_max__ext__def,axiom,
    ! [A: $tType] :
      ( ( max_ext @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
            @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
              @ ( max_extp @ A
                @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R2 ) ) ) ) ) ) ).

% max_ext_def
thf(fact_2838_divmod__abs__def,axiom,
    ( code_divmod_abs
    = ( ^ [K4: code_integer,L3: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K4 ) @ ( abs_abs @ code_integer @ L3 ) ) @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K4 ) @ ( abs_abs @ code_integer @ L3 ) ) ) ) ) ).

% divmod_abs_def
thf(fact_2839_uminus__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X3: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( product_fst @ int @ int @ X3 ) ) @ ( product_snd @ int @ int @ X3 ) )
    @ ( uminus_uminus @ rat ) ) ).

% uminus_rat.transfer
thf(fact_2840_fun_Oin__rel,axiom,
    ! [B: $tType,A: $tType,D: $tType,R: A > B > $o,A3: D > A,B2: D > B] :
      ( ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y4: D,Z5: D] : ( Y4 = Z5 )
        @ R
        @ A3
        @ B2 )
      = ( ? [Z4: D > ( product_prod @ A @ B )] :
            ( ( member @ ( D > ( product_prod @ A @ B ) ) @ Z4
              @ ( collect @ ( D > ( product_prod @ A @ B ) )
                @ ^ [X3: D > ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ D @ ( product_prod @ A @ B ) @ X3 @ ( top_top @ ( set @ D ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) ) ) )
            & ( ( comp @ ( product_prod @ A @ B ) @ A @ D @ ( product_fst @ A @ B ) @ Z4 )
              = A3 )
            & ( ( comp @ ( product_prod @ A @ B ) @ B @ D @ ( product_snd @ A @ B ) @ Z4 )
              = B2 ) ) ) ) ).

% fun.in_rel
thf(fact_2841_max__extp__eq,axiom,
    ! [A: $tType] :
      ( ( max_extp @ A )
      = ( ^ [R5: A > A > $o,X3: set @ A,Y2: set @ A] : ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X3 @ Y2 ) @ ( max_ext @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% max_extp_eq
thf(fact_2842_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( semiring_1 @ B )
        & ( semiring_1 @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
                @ R
                @ ( semiring_1_of_nat @ A )
                @ ( semiring_1_of_nat @ B ) ) ) ) ) ) ).

% transfer_rule_of_nat
thf(fact_2843_plus__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X3: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y2 ) @ ( product_snd @ int @ int @ X3 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) )
    @ ( plus_plus @ rat ) ) ).

% plus_rat.transfer
thf(fact_2844_times__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X3: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_fst @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) )
    @ ( times_times @ rat ) ) ).

% times_rat.transfer
thf(fact_2845_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B,A4: set @ A,B3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ S2 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ S2 )
         => ( ( finite_finite @ A @ A4 )
           => ( ( finite_finite @ A @ B3 )
             => ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( finite_fold @ A @ B @ F @ Z2 @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
                  = ( finite_fold @ A @ B @ F @ ( finite_fold @ A @ B @ F @ Z2 @ A4 ) @ B3 ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
thf(fact_2846_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B,A4: set @ A,X: A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ S2 )
       => ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( finite_fold @ A @ B @ F @ Z2 @ A4 )
              = ( F @ X @ ( finite_fold @ A @ B @ F @ Z2 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
thf(fact_2847_comp__fun__commute__on_Ointro,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B] :
      ( ! [X2: A,Y3: A] :
          ( ( member @ A @ X2 @ S2 )
         => ( ( member @ A @ Y3 @ S2 )
           => ( ( comp @ B @ B @ B @ ( F @ Y3 ) @ ( F @ X2 ) )
              = ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) ) ) )
     => ( finite4664212375090638736ute_on @ A @ B @ S2 @ F ) ) ).

% comp_fun_commute_on.intro
thf(fact_2848_comp__fun__commute__on_Ocommute__left__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,S2: set @ A,F: A > B > B,X: A,Y: A,G: C > B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F )
     => ( ( member @ A @ X @ S2 )
       => ( ( member @ A @ Y @ S2 )
         => ( ( comp @ B @ B @ C @ ( F @ Y ) @ ( comp @ B @ B @ C @ ( F @ X ) @ G ) )
            = ( comp @ B @ B @ C @ ( F @ X ) @ ( comp @ B @ B @ C @ ( F @ Y ) @ G ) ) ) ) ) ) ).

% comp_fun_commute_on.commute_left_comp
thf(fact_2849_comp__fun__commute__on_Ocomp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B,X: A,Y: A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F )
     => ( ( member @ A @ X @ S2 )
       => ( ( member @ A @ Y @ S2 )
         => ( ( comp @ B @ B @ B @ ( F @ Y ) @ ( F @ X ) )
            = ( comp @ B @ B @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) ) ).

% comp_fun_commute_on.comp_fun_commute_on
thf(fact_2850_comp__fun__commute__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite4664212375090638736ute_on @ A @ B )
      = ( ^ [S7: set @ A,F2: A > B > B] :
          ! [X3: A,Y2: A] :
            ( ( member @ A @ X3 @ S7 )
           => ( ( member @ A @ Y2 @ S7 )
             => ( ( comp @ B @ B @ B @ ( F2 @ Y2 ) @ ( F2 @ X3 ) )
                = ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) ) ) ) ).

% comp_fun_commute_on_def
thf(fact_2851_Fract_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > ( product_prod @ int @ int ) )
    @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int )
      @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
      @ ratrel )
    @ ^ [A5: int,B4: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B4
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A5 @ B4 ) )
    @ ^ [A5: int,B4: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B4
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A5 @ B4 ) ) ) ).

% Fract.rsp
thf(fact_2852_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( zero_neq_one @ B )
        & ( zero_neq_one @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( bNF_rel_fun @ $o @ $o @ A @ B
              @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
              @ R
              @ ( zero_neq_one_of_bool @ A )
              @ ( zero_neq_one_of_bool @ B ) ) ) ) ) ).

% transfer_rule_of_bool
thf(fact_2853_times__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X3: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_fst @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) )
    @ ^ [X3: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_fst @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) ) ) ).

% times_rat.rsp
thf(fact_2854_plus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y2 @ V3 ) ) ) )
    @ ( plus_plus @ int ) ) ).

% plus_int.transfer
thf(fact_2855_minus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V3 ) @ ( plus_plus @ nat @ Y2 @ U2 ) ) ) )
    @ ( minus_minus @ int ) ) ).

% minus_int.transfer
thf(fact_2856_plus__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X3: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y2 ) @ ( product_snd @ int @ int @ X3 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) )
    @ ^ [X3: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y2 ) @ ( product_snd @ int @ int @ X3 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) ) ) ).

% plus_rat.rsp
thf(fact_2857_times__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y2 @ V3 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V3 ) @ ( times_times @ nat @ Y2 @ U2 ) ) ) ) )
    @ ( times_times @ int ) ) ).

% times_int.transfer
thf(fact_2858_int__transfer,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( product_prod @ nat @ nat ) @ int
    @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
    @ pcr_int
    @ ^ [N5: nat] : ( product_Pair @ nat @ nat @ N5 @ ( zero_zero @ nat ) )
    @ ( semiring_1_of_nat @ int ) ) ).

% int_transfer
thf(fact_2859_uminus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X3: nat,Y2: nat] : ( product_Pair @ nat @ nat @ Y2 @ X3 ) )
    @ ( uminus_uminus @ int ) ) ).

% uminus_int.transfer
thf(fact_2860_comp__fun__commute__on_Ocomp__comp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set @ A,F: A > B > B,G: C > A,R: set @ C] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image2 @ C @ A @ G @ ( top_top @ ( set @ C ) ) ) @ S2 )
       => ( finite4664212375090638736ute_on @ C @ B @ R @ ( comp @ A @ ( B > B ) @ C @ F @ G ) ) ) ) ).

% comp_fun_commute_on.comp_comp_fun_commute_on
thf(fact_2861_uminus__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X3: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( product_fst @ int @ int @ X3 ) ) @ ( product_snd @ int @ int @ X3 ) )
    @ ^ [X3: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( product_fst @ int @ int @ X3 ) ) @ ( product_snd @ int @ int @ X3 ) ) ) ).

% uminus_rat.rsp
thf(fact_2862_inverse__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X3: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X3 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) )
    @ ^ [X3: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X3 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) ) ) ).

% inverse_rat.rsp
thf(fact_2863_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B,X: A,A4: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A4 ) @ S2 )
       => ( ( finite_finite @ A @ A4 )
         => ( ( finite_fold @ A @ B @ F @ Z2 @ ( insert2 @ A @ X @ A4 ) )
            = ( F @ X @ ( finite_fold @ A @ B @ F @ Z2 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
thf(fact_2864_o__rsp_I2_J,axiom,
    ! [E: $tType,F9: $tType,H9: $tType,G3: $tType,R12: E > F9 > $o] :
      ( bNF_rel_fun @ ( G3 > H9 ) @ ( G3 > H9 ) @ ( ( E > G3 ) > E > H9 ) @ ( ( F9 > G3 ) > F9 > H9 )
      @ ^ [Y4: G3 > H9,Z5: G3 > H9] : ( Y4 = Z5 )
      @ ( bNF_rel_fun @ ( E > G3 ) @ ( F9 > G3 ) @ ( E > H9 ) @ ( F9 > H9 )
        @ ( bNF_rel_fun @ E @ F9 @ G3 @ G3 @ R12
          @ ^ [Y4: G3,Z5: G3] : ( Y4 = Z5 ) )
        @ ( bNF_rel_fun @ E @ F9 @ H9 @ H9 @ R12
          @ ^ [Y4: H9,Z5: H9] : ( Y4 = Z5 ) ) )
      @ ( comp @ G3 @ H9 @ E )
      @ ( comp @ G3 @ H9 @ F9 ) ) ).

% o_rsp(2)
thf(fact_2865_o__rsp_I1_J,axiom,
    ! [A: $tType,B: $tType,E: $tType,F9: $tType,D: $tType,C: $tType,R23: A > C > $o,R32: B > D > $o,R12: E > F9 > $o] : ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > A ) > E > B ) @ ( ( F9 > C ) > F9 > D ) @ ( bNF_rel_fun @ A @ C @ B @ D @ R23 @ R32 ) @ ( bNF_rel_fun @ ( E > A ) @ ( F9 > C ) @ ( E > B ) @ ( F9 > D ) @ ( bNF_rel_fun @ E @ F9 @ A @ C @ R12 @ R23 ) @ ( bNF_rel_fun @ E @ F9 @ B @ D @ R12 @ R32 ) ) @ ( comp @ A @ B @ E ) @ ( comp @ C @ D @ F9 ) ) ).

% o_rsp(1)
thf(fact_2866_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F2: A > nat,R2: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X3: A,Y2: A] :
                  ( ( ord_less @ nat @ ( F2 @ X3 ) @ ( F2 @ Y2 ) )
                  | ( ( ord_less_eq @ nat @ ( F2 @ X3 ) @ ( F2 @ Y2 ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R2 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_2867_update__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P4: ref @ A,Y: A,X: A] :
          ( hoare_hoare_triple @ product_unit @ ( sngr_assn @ A @ P4 @ Y ) @ ( ref_update @ A @ P4 @ X )
          @ ^ [R5: product_unit] : ( sngr_assn @ A @ P4 @ X ) ) ) ).

% update_rule
thf(fact_2868_enumerate__Suc,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
          = ( infini527867602293511546merate @ A
            @ ( minus_minus @ ( set @ A ) @ S2
              @ ( insert2 @ A
                @ ( ord_Least @ A
                  @ ^ [N5: A] : ( member @ A @ N5 @ S2 ) )
                @ ( bot_bot @ ( set @ A ) ) ) )
            @ N ) ) ) ).

% enumerate_Suc
thf(fact_2869_LeastI,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI
thf(fact_2870_LeastI2__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [X2: A] :
                ( ( P @ X2 )
               => ( Q @ X2 ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_ex
thf(fact_2871_LeastI__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI_ex
thf(fact_2872_LeastI2,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A3: A,Q: A > $o] :
          ( ( P @ A3 )
         => ( ! [X2: A] :
                ( ( P @ X2 )
               => ( Q @ X2 ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2
thf(fact_2873_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [A8: A] :
                ( ( P @ A8 )
               => ( ! [B11: A] :
                      ( ( P @ B11 )
                     => ( ord_less_eq @ A @ A8 @ B11 ) )
                 => ( Q @ A8 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder_ex
thf(fact_2874_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A3: A,Q: A > $o] :
          ( ( P @ A3 )
         => ( ! [A8: A] :
                ( ( P @ A8 )
               => ( ! [B11: A] :
                      ( ( P @ B11 )
                     => ( ord_less_eq @ A @ A8 @ B11 ) )
                 => ( Q @ A8 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder
thf(fact_2875_Least__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ X @ Y3 ) )
           => ( ( ord_Least @ A @ P )
              = X ) ) ) ) ).

% Least_equality
thf(fact_2876_LeastI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ X @ Y3 ) )
           => ( ! [X2: A] :
                  ( ( P @ X2 )
                 => ( ! [Y5: A] :
                        ( ( P @ Y5 )
                       => ( ord_less_eq @ A @ X2 @ Y5 ) )
                   => ( Q @ X2 ) ) )
             => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ) ).

% LeastI2_order
thf(fact_2877_Least1__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,Z2: A] :
          ( ? [X6: A] :
              ( ( P @ X6 )
              & ! [Y3: A] :
                  ( ( P @ Y3 )
                 => ( ord_less_eq @ A @ X6 @ Y3 ) )
              & ! [Y3: A] :
                  ( ( ( P @ Y3 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y3 @ Ya2 ) ) )
                 => ( Y3 = X6 ) ) )
         => ( ( P @ Z2 )
           => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ Z2 ) ) ) ) ).

% Least1_le
thf(fact_2878_Least1I,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o] :
          ( ? [X6: A] :
              ( ( P @ X6 )
              & ! [Y3: A] :
                  ( ( P @ Y3 )
                 => ( ord_less_eq @ A @ X6 @ Y3 ) )
              & ! [Y3: A] :
                  ( ( ( P @ Y3 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y3 @ Ya2 ) ) )
                 => ( Y3 = X6 ) ) )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% Least1I
thf(fact_2879_Least__le,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ K ) ) ) ).

% Least_le
thf(fact_2880_not__less__Least,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [K: A,P: A > $o] :
          ( ( ord_less @ A @ K @ ( ord_Least @ A @ P ) )
         => ~ ( P @ K ) ) ) ).

% not_less_Least
thf(fact_2881_mlex__iff,axiom,
    ! [A: $tType,X: A,Y: A,F: A > nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F @ R ) )
      = ( ( ord_less @ nat @ ( F @ X ) @ ( F @ Y ) )
        | ( ( ( F @ X )
            = ( F @ Y ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R ) ) ) ) ).

% mlex_iff
thf(fact_2882_mlex__less,axiom,
    ! [A: $tType,F: A > nat,X: A,Y: A,R: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F @ X ) @ ( F @ Y ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F @ R ) ) ) ).

% mlex_less
thf(fact_2883_mlex__leq,axiom,
    ! [A: $tType,F: A > nat,X: A,Y: A,R: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F @ X ) @ ( F @ Y ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F @ R ) ) ) ) ).

% mlex_leq
thf(fact_2884_change__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_change @ A )
        = ( ^ [F2: A > A,R5: ref @ A] :
              ( heap_Time_bind @ A @ A @ ( ref_lookup @ A @ R5 )
              @ ^ [X3: A] :
                  ( heap_Time_bind @ product_unit @ A @ ( ref_update @ A @ R5 @ ( F2 @ X3 ) )
                  @ ^ [Uu: product_unit] : ( heap_Time_return @ A @ ( F2 @ X3 ) ) ) ) ) ) ) ).

% change_def
thf(fact_2885_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X3: nat,Y2: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y2 @ V3 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V3 ) @ ( times_times @ nat @ Y2 @ U2 ) ) ) )
          @ Xa
          @ X ) ) ) ).

% times_int.abs_eq
thf(fact_2886_update__wp__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,Y: A,X: A,Q: product_unit > assn] : ( hoare_hoare_triple @ product_unit @ ( times_times @ assn @ ( sngr_assn @ A @ R4 @ Y ) @ ( wand_assn @ ( sngr_assn @ A @ R4 @ X ) @ ( Q @ product_Unity ) ) ) @ ( ref_update @ A @ R4 @ X ) @ Q ) ) ).

% update_wp_rule
thf(fact_2887_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X3: nat,Y2: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V3 ) @ ( plus_plus @ nat @ Y2 @ U2 ) ) )
          @ Xa
          @ X ) ) ) ).

% minus_int.abs_eq
thf(fact_2888_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X3: nat,Y2: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y2 @ V3 ) ) )
          @ Xa
          @ X ) ) ) ).

% plus_int.abs_eq
thf(fact_2889_UNIV__unit,axiom,
    ( ( top_top @ ( set @ product_unit ) )
    = ( insert2 @ product_unit @ product_Unity @ ( bot_bot @ ( set @ product_unit ) ) ) ) ).

% UNIV_unit
thf(fact_2890_bot__unit__def,axiom,
    ( ( bot_bot @ product_unit )
    = product_Unity ) ).

% bot_unit_def
thf(fact_2891_inf__unit__def,axiom,
    ( ( inf_inf @ product_unit )
    = ( ^ [Uu2: product_unit,Uv: product_unit] : product_Unity ) ) ).

% inf_unit_def
thf(fact_2892_eq__Abs__Integ,axiom,
    ! [Z2: int] :
      ~ ! [X2: nat,Y3: nat] :
          ( Z2
         != ( abs_Integ @ ( product_Pair @ nat @ nat @ X2 @ Y3 ) ) ) ).

% eq_Abs_Integ
thf(fact_2893_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_2894_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N5: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N5 @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_2895_uminus__int_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X3: nat,Y2: nat] : ( product_Pair @ nat @ nat @ Y2 @ X3 )
          @ X ) ) ) ).

% uminus_int.abs_eq
thf(fact_2896_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_2897_range__prod,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: C > ( product_prod @ A @ B )] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ C @ ( product_prod @ A @ B ) @ F @ ( top_top @ ( set @ C ) ) )
      @ ( product_Sigma @ A @ B @ ( image2 @ C @ A @ ( comp @ ( product_prod @ A @ B ) @ A @ C @ ( product_fst @ A @ B ) @ F ) @ ( top_top @ ( set @ C ) ) )
        @ ^ [Uu: A] : ( image2 @ C @ B @ ( comp @ ( product_prod @ A @ B ) @ B @ C @ ( product_snd @ A @ B ) @ F ) @ ( top_top @ ( set @ C ) ) ) ) ) ).

% range_prod
thf(fact_2898_fold__union__pair,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,X: B,A4: set @ ( product_prod @ B @ A )] :
      ( ( finite_finite @ A @ B3 )
     => ( ( sup_sup @ ( set @ ( product_prod @ B @ A ) )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ A ) )
            @ ( image2 @ A @ ( set @ ( product_prod @ B @ A ) )
              @ ^ [Y2: A] : ( insert2 @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y2 ) @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
              @ B3 ) )
          @ A4 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
          @ ^ [Y2: A] : ( insert2 @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y2 ) )
          @ A4
          @ B3 ) ) ) ).

% fold_union_pair
thf(fact_2899_mlex__prod__def,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F2: A > nat,R2: set @ ( product_prod @ A @ A )] :
            ( inv_image @ ( product_prod @ nat @ A ) @ A @ ( lex_prod @ nat @ A @ less_than @ R2 )
            @ ^ [X3: A] : ( product_Pair @ nat @ A @ ( F2 @ X3 ) @ X3 ) ) ) ) ).

% mlex_prod_def
thf(fact_2900_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I4: set @ B,P4: B > A,I: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I4 )
                  & ( ( P4 @ X3 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member @ B @ I @ I4 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( insert2 @ B @ I @ I4 ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P4 @ I4 ) ) )
            & ( ~ ( member @ B @ I @ I4 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( insert2 @ B @ I @ I4 ) )
                = ( times_times @ A @ ( P4 @ I ) @ ( groups1962203154675924110t_prod @ B @ A @ P4 @ I4 ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_2901_times__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y2 @ V3 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V3 ) @ ( times_times @ nat @ Y2 @ U2 ) ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y2 @ V3 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V3 ) @ ( times_times @ nat @ Y2 @ U2 ) ) ) ) ) ) ).

% times_int.rsp
thf(fact_2902_Sup__bot__conv_I2_J,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( ( bot_bot @ A )
            = ( complete_Sup_Sup @ A @ A4 ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( X3
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% Sup_bot_conv(2)
thf(fact_2903_Sup__bot__conv_I1_J,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A4 )
            = ( bot_bot @ A ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( X3
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% Sup_bot_conv(1)
thf(fact_2904_SigmaI,axiom,
    ! [B: $tType,A: $tType,A3: A,A4: set @ A,B2: B,B3: A > ( set @ B )] :
      ( ( member @ A @ A3 @ A4 )
     => ( ( member @ B @ B2 @ ( B3 @ A3 ) )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ ( product_Sigma @ A @ B @ A4 @ B3 ) ) ) ) ).

% SigmaI
thf(fact_2905_mem__Sigma__iff,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,A4: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ ( product_Sigma @ A @ B @ A4 @ B3 ) )
      = ( ( member @ A @ A3 @ A4 )
        & ( member @ B @ B2 @ ( B3 @ A3 ) ) ) ) ).

% mem_Sigma_iff
thf(fact_2906_in__inv__image,axiom,
    ! [A: $tType,B: $tType,X: A,Y: A,R4: set @ ( product_prod @ B @ B ),F: A > B] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( inv_image @ B @ A @ R4 @ F ) )
      = ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F @ X ) @ ( F @ Y ) ) @ R4 ) ) ).

% in_inv_image
thf(fact_2907_Sup__empty,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( bot_bot @ A ) ) ) ).

% Sup_empty
thf(fact_2908_cSup__singleton,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A] :
          ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% cSup_singleton
thf(fact_2909_Sup__insert,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ A3 @ A4 ) )
          = ( sup_sup @ A @ A3 @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ).

% Sup_insert
thf(fact_2910_Sigma__empty1,axiom,
    ! [B: $tType,A: $tType,B3: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( bot_bot @ ( set @ A ) ) @ B3 )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% Sigma_empty1
thf(fact_2911_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P4: B > A] :
          ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty'
thf(fact_2912_intrel__iff,axiom,
    ! [X: nat,Y: nat,U: nat,V: nat] :
      ( ( intrel @ ( product_Pair @ nat @ nat @ X @ Y ) @ ( product_Pair @ nat @ nat @ U @ V ) )
      = ( ( plus_plus @ nat @ X @ V )
        = ( plus_plus @ nat @ U @ Y ) ) ) ).

% intrel_iff
thf(fact_2913_SUP__bot__conv_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: B > A,A4: set @ B] :
          ( ( ( bot_bot @ A )
            = ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ B3 @ A4 ) ) )
          = ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ( B3 @ X3 )
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% SUP_bot_conv(2)
thf(fact_2914_SUP__bot__conv_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: B > A,A4: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ B3 @ A4 ) )
            = ( bot_bot @ A ) )
          = ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ( B3 @ X3 )
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% SUP_bot_conv(1)
thf(fact_2915_SUP__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B] :
          ( ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [X3: B] : ( bot_bot @ A )
              @ A4 ) )
          = ( bot_bot @ A ) ) ) ).

% SUP_bot
thf(fact_2916_cSUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image2 @ B @ A
                @ ^ [X3: B] : C2
                @ A4 ) )
            = C2 ) ) ) ).

% cSUP_const
thf(fact_2917_SUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image2 @ B @ A
                @ ^ [I2: B] : F
                @ A4 ) )
            = F ) ) ) ).

% SUP_const
thf(fact_2918_UN__constant,axiom,
    ! [B: $tType,A: $tType,A4: set @ B,C2: set @ A] :
      ( ( ( A4
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : C2
              @ A4 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A4
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : C2
              @ A4 ) )
          = C2 ) ) ) ).

% UN_constant
thf(fact_2919_Sigma__empty2,axiom,
    ! [B: $tType,A: $tType,A4: set @ A] :
      ( ( product_Sigma @ A @ B @ A4
        @ ^ [Uu: A] : ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% Sigma_empty2
thf(fact_2920_Times__empty,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : B3 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        | ( B3
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% Times_empty
thf(fact_2921_UN__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set @ B,A3: A,B3: B > ( set @ A )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [X3: B] : ( insert2 @ A @ A3 @ ( B3 @ X3 ) )
              @ C3 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [X3: B] : ( insert2 @ A @ A3 @ ( B3 @ X3 ) )
              @ C3 ) )
          = ( insert2 @ A @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ C3 ) ) ) ) ) ) ).

% UN_simps(1)
thf(fact_2922_UN__singleton,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ A @ ( set @ A )
          @ ^ [X3: A] : ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) )
          @ A4 ) )
      = A4 ) ).

% UN_singleton
thf(fact_2923_UN__simps_I3_J,axiom,
    ! [E: $tType,F9: $tType,C3: set @ F9,A4: set @ E,B3: F9 > ( set @ E )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ F9 ) ) )
       => ( ( complete_Sup_Sup @ ( set @ E )
            @ ( image2 @ F9 @ ( set @ E )
              @ ^ [X3: F9] : ( sup_sup @ ( set @ E ) @ A4 @ ( B3 @ X3 ) )
              @ C3 ) )
          = ( bot_bot @ ( set @ E ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ F9 ) ) )
       => ( ( complete_Sup_Sup @ ( set @ E )
            @ ( image2 @ F9 @ ( set @ E )
              @ ^ [X3: F9] : ( sup_sup @ ( set @ E ) @ A4 @ ( B3 @ X3 ) )
              @ C3 ) )
          = ( sup_sup @ ( set @ E ) @ A4 @ ( complete_Sup_Sup @ ( set @ E ) @ ( image2 @ F9 @ ( set @ E ) @ B3 @ C3 ) ) ) ) ) ) ).

% UN_simps(3)
thf(fact_2924_UN__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set @ C,A4: C > ( set @ D ),B3: set @ D] :
      ( ( ( C3
          = ( bot_bot @ ( set @ C ) ) )
       => ( ( complete_Sup_Sup @ ( set @ D )
            @ ( image2 @ C @ ( set @ D )
              @ ^ [X3: C] : ( sup_sup @ ( set @ D ) @ ( A4 @ X3 ) @ B3 )
              @ C3 ) )
          = ( bot_bot @ ( set @ D ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ C ) ) )
       => ( ( complete_Sup_Sup @ ( set @ D )
            @ ( image2 @ C @ ( set @ D )
              @ ^ [X3: C] : ( sup_sup @ ( set @ D ) @ ( A4 @ X3 ) @ B3 )
              @ C3 ) )
          = ( sup_sup @ ( set @ D ) @ ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ C @ ( set @ D ) @ A4 @ C3 ) ) @ B3 ) ) ) ) ).

% UN_simps(2)
thf(fact_2925_fst__image__times,axiom,
    ! [B: $tType,A: $tType,B3: set @ B,A4: set @ A] :
      ( ( ( B3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B )
            @ ( product_Sigma @ A @ B @ A4
              @ ^ [Uu: A] : B3 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( B3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B )
            @ ( product_Sigma @ A @ B @ A4
              @ ^ [Uu: A] : B3 ) )
          = A4 ) ) ) ).

% fst_image_times
thf(fact_2926_snd__image__times,axiom,
    ! [B: $tType,A: $tType,A4: set @ B,B3: set @ A] :
      ( ( ( A4
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A )
            @ ( product_Sigma @ B @ A @ A4
              @ ^ [Uu: B] : B3 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A4
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( image2 @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A )
            @ ( product_Sigma @ B @ A @ A4
              @ ^ [Uu: B] : B3 ) )
          = B3 ) ) ) ).

% snd_image_times
thf(fact_2927_Sigma__UNIV__cancel,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,X5: set @ B] :
      ( ( minus_minus @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : X5 )
        @ ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : ( top_top @ ( set @ B ) ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% Sigma_UNIV_cancel
thf(fact_2928_insert__Times__insert,axiom,
    ! [B: $tType,A: $tType,A3: A,A4: set @ A,B2: B,B3: set @ B] :
      ( ( product_Sigma @ A @ B @ ( insert2 @ A @ A3 @ A4 )
        @ ^ [Uu: A] : ( insert2 @ B @ B2 @ B3 ) )
      = ( insert2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 )
        @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) )
          @ ( product_Sigma @ A @ B @ A4
            @ ^ [Uu: A] : ( insert2 @ B @ B2 @ B3 ) )
          @ ( product_Sigma @ A @ B @ ( insert2 @ A @ A3 @ A4 )
            @ ^ [Uu: A] : B3 ) ) ) ) ).

% insert_Times_insert
thf(fact_2929_SigmaE2,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,A4: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ ( product_Sigma @ A @ B @ A4 @ B3 ) )
     => ~ ( ( member @ A @ A3 @ A4 )
         => ~ ( member @ B @ B2 @ ( B3 @ A3 ) ) ) ) ).

% SigmaE2
thf(fact_2930_SigmaD2,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,A4: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ ( product_Sigma @ A @ B @ A4 @ B3 ) )
     => ( member @ B @ B2 @ ( B3 @ A3 ) ) ) ).

% SigmaD2
thf(fact_2931_SigmaD1,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,A4: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ ( product_Sigma @ A @ B @ A4 @ B3 ) )
     => ( member @ A @ A3 @ A4 ) ) ).

% SigmaD1
thf(fact_2932_SigmaE,axiom,
    ! [A: $tType,B: $tType,C2: product_prod @ A @ B,A4: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ C2 @ ( product_Sigma @ A @ B @ A4 @ B3 ) )
     => ~ ! [X2: A] :
            ( ( member @ A @ X2 @ A4 )
           => ! [Y3: B] :
                ( ( member @ B @ Y3 @ ( B3 @ X2 ) )
               => ( C2
                 != ( product_Pair @ A @ B @ X2 @ Y3 ) ) ) ) ) ).

% SigmaE
thf(fact_2933_empty__Union__conv,axiom,
    ! [A: $tType,A4: set @ ( set @ A )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ A4 ) )
      = ( ! [X3: set @ A] :
            ( ( member @ ( set @ A ) @ X3 @ A4 )
           => ( X3
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% empty_Union_conv
thf(fact_2934_Union__empty__conv,axiom,
    ! [A: $tType,A4: set @ ( set @ A )] :
      ( ( ( complete_Sup_Sup @ ( set @ A ) @ A4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X3: set @ A] :
            ( ( member @ ( set @ A ) @ X3 @ A4 )
           => ( X3
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Union_empty_conv
thf(fact_2935_Union__empty,axiom,
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Union_empty
thf(fact_2936_times__eq__iff,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B,C3: set @ A,D4: set @ B] :
      ( ( ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : B3 )
        = ( product_Sigma @ A @ B @ C3
          @ ^ [Uu: A] : D4 ) )
      = ( ( ( A4 = C3 )
          & ( B3 = D4 ) )
        | ( ( ( A4
              = ( bot_bot @ ( set @ A ) ) )
            | ( B3
              = ( bot_bot @ ( set @ B ) ) ) )
          & ( ( C3
              = ( bot_bot @ ( set @ A ) ) )
            | ( D4
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% times_eq_iff
thf(fact_2937_SUP__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: $o > A] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ $o @ A @ A4 @ ( top_top @ ( set @ $o ) ) ) )
          = ( sup_sup @ A @ ( A4 @ $true ) @ ( A4 @ $false ) ) ) ) ).

% SUP_UNIV_bool_expand
thf(fact_2938_Sigma__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_Sigma @ A @ B )
      = ( ^ [A10: set @ A,B7: A > ( set @ B )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
            @ ( image2 @ A @ ( set @ ( product_prod @ A @ B ) )
              @ ^ [X3: A] :
                  ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) )
                  @ ( image2 @ B @ ( set @ ( product_prod @ A @ B ) )
                    @ ^ [Y2: B] : ( insert2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
                    @ ( B7 @ X3 ) ) )
              @ A10 ) ) ) ) ).

% Sigma_def
thf(fact_2939_in__Union__o__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,X: A,Gset: B > ( set @ ( set @ A ) ),Gmap: C > B,A4: C] :
      ( ( member @ A @ X @ ( comp @ B @ ( set @ A ) @ C @ ( comp @ ( set @ ( set @ A ) ) @ ( set @ A ) @ B @ ( complete_Sup_Sup @ ( set @ A ) ) @ Gset ) @ Gmap @ A4 ) )
     => ( member @ A @ X @ ( comp @ ( set @ ( set @ A ) ) @ ( set @ A ) @ C @ ( complete_Sup_Sup @ ( set @ A ) ) @ ( comp @ B @ ( set @ ( set @ A ) ) @ C @ Gset @ Gmap ) @ A4 ) ) ) ).

% in_Union_o_assoc
thf(fact_2940_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,I4: set @ B] :
          ( ( groups1962203154675924110t_prod @ B @ A @ G
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I4 )
                  & ( ( G @ X3 )
                   != ( one_one @ A ) ) ) ) )
          = ( groups1962203154675924110t_prod @ B @ A @ G @ I4 ) ) ) ).

% prod.non_neutral'
thf(fact_2941_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A4 )
             => ( ord_less_eq @ A @ U @ V4 ) )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_2942_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A3: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X5 )
               => ( ord_less_eq @ A @ X2 @ A3 ) )
           => ( ! [Y3: A] :
                  ( ! [X6: A] :
                      ( ( member @ A @ X6 @ X5 )
                     => ( ord_less_eq @ A @ X6 @ Y3 ) )
                 => ( ord_less_eq @ A @ A3 @ Y3 ) )
             => ( ( complete_Sup_Sup @ A @ X5 )
                = A3 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_2943_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,Z2: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X5 )
               => ( ord_less_eq @ A @ X2 @ Z2 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X5 ) @ Z2 ) ) ) ) ).

% cSup_least
thf(fact_2944_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y: A,X5: set @ A] :
          ( ( ord_less @ A @ Y @ ( complete_Sup_Sup @ A @ X5 ) )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X2: A] :
                  ( ( member @ A @ X2 @ X5 )
                 => ~ ( ord_less @ A @ Y @ X2 ) ) ) ) ) ).

% less_cSupE
thf(fact_2945_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,Z2: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z2 @ ( complete_Sup_Sup @ A @ X5 ) )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ X5 )
                & ( ord_less @ A @ Z2 @ X2 ) ) ) ) ) ).

% less_cSupD
thf(fact_2946_SUP__eq__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I4: set @ B,F: B > A,X: A] :
          ( ( I4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I4 )
               => ( ( F @ I3 )
                  = X ) )
           => ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ I4 ) )
              = X ) ) ) ) ).

% SUP_eq_const
thf(fact_2947_Sup__inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B3: set @ A,A3: A] :
          ( ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ B3 ) @ A3 )
            = ( bot_bot @ A ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ B3 )
               => ( ( inf_inf @ A @ X3 @ A3 )
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% Sup_inf_eq_bot_iff
thf(fact_2948_inf__Sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: A,B3: set @ A] :
          ( ( inf_inf @ A @ A3 @ ( complete_Sup_Sup @ A @ B3 ) )
          = ( complete_Sup_Sup @ A @ ( image2 @ A @ A @ ( inf_inf @ A @ A3 ) @ B3 ) ) ) ) ).

% inf_Sup
thf(fact_2949_SUP__image,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( complete_Sup @ A )
     => ! [G: B > A,F: C > B,A4: set @ C] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ ( image2 @ C @ B @ F @ A4 ) ) )
          = ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A4 ) ) ) ) ).

% SUP_image
thf(fact_2950_Sup__finite__insert,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ A3 @ A4 ) )
          = ( sup_sup @ A @ A3 @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ).

% Sup_finite_insert
thf(fact_2951_Sup__union__distrib,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( complete_Sup_Sup @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
          = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_union_distrib
thf(fact_2952_Sigma__Int__distrib1,axiom,
    ! [B: $tType,A: $tType,I4: set @ A,J4: set @ A,C3: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( inf_inf @ ( set @ A ) @ I4 @ J4 ) @ C3 )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I4 @ C3 ) @ ( product_Sigma @ A @ B @ J4 @ C3 ) ) ) ).

% Sigma_Int_distrib1
thf(fact_2953_Union__disjoint,axiom,
    ! [A: $tType,C3: set @ ( set @ A ),A4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ C3 ) @ A4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X3: set @ A] :
            ( ( member @ ( set @ A ) @ X3 @ C3 )
           => ( ( inf_inf @ ( set @ A ) @ X3 @ A4 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Union_disjoint
thf(fact_2954_insert__partition,axiom,
    ! [A: $tType,X: set @ A,F3: set @ ( set @ A )] :
      ( ~ ( member @ ( set @ A ) @ X @ F3 )
     => ( ! [X2: set @ A] :
            ( ( member @ ( set @ A ) @ X2 @ ( insert2 @ ( set @ A ) @ X @ F3 ) )
           => ! [Xa3: set @ A] :
                ( ( member @ ( set @ A ) @ Xa3 @ ( insert2 @ ( set @ A ) @ X @ F3 ) )
               => ( ( X2 != Xa3 )
                 => ( ( inf_inf @ ( set @ A ) @ X2 @ Xa3 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ X @ ( complete_Sup_Sup @ ( set @ A ) @ F3 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% insert_partition
thf(fact_2955_Union__Int__subset,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),B3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A4 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A4 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) ).

% Union_Int_subset
thf(fact_2956_Sigma__empty__iff,axiom,
    ! [B: $tType,A: $tType,I4: set @ A,X5: A > ( set @ B )] :
      ( ( ( product_Sigma @ A @ B @ I4 @ X5 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ I4 )
           => ( ( X5 @ X3 )
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ).

% Sigma_empty_iff
thf(fact_2957_SUP__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F: B > A,B3: set @ B,A3: A] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ B3 ) ) @ A3 )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [B4: B] : ( inf_inf @ A @ ( F @ B4 ) @ A3 )
              @ B3 ) ) ) ) ).

% SUP_inf
thf(fact_2958_Sup__inf,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B3: set @ A,A3: A] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ B3 ) @ A3 )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ A @ A
              @ ^ [B4: A] : ( inf_inf @ A @ B4 @ A3 )
              @ B3 ) ) ) ) ).

% Sup_inf
thf(fact_2959_inf__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: A,F: B > A,B3: set @ B] :
          ( ( inf_inf @ A @ A3 @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ B3 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [B4: B] : ( inf_inf @ A @ A3 @ ( F @ B4 ) )
              @ B3 ) ) ) ) ).

% inf_SUP
thf(fact_2960_SUP__inf__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F: B > A,A4: set @ B,G: C > A,B3: set @ C] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ G @ B3 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [A5: B] :
                  ( complete_Sup_Sup @ A
                  @ ( image2 @ C @ A
                    @ ^ [B4: C] : ( inf_inf @ A @ ( F @ A5 ) @ ( G @ B4 ) )
                    @ B3 ) )
              @ A4 ) ) ) ) ).

% SUP_inf_distrib2
thf(fact_2961_complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: B > A,A4: set @ B,G: B > A] :
          ( ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ A4 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [A5: B] : ( sup_sup @ A @ ( F @ A5 ) @ ( G @ A5 ) )
              @ A4 ) ) ) ) ).

% complete_lattice_class.SUP_sup_distrib
thf(fact_2962_SUP__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [K: B,I4: set @ B,A4: B > A] :
          ( ( member @ B @ K @ I4 )
         => ( ( sup_sup @ A @ ( A4 @ K ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ A4 @ I4 ) ) )
            = ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ A4 @ I4 ) ) ) ) ) ).

% SUP_absorb
thf(fact_2963_Restr__subset,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
     => ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) )
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ B3
              @ ^ [Uu: A] : B3 ) )
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) )
        = ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) ) ) ).

% Restr_subset
thf(fact_2964_Restr__Field,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
        @ ( product_Sigma @ A @ A @ ( field2 @ A @ R4 )
          @ ^ [Uu: A] : ( field2 @ A @ R4 ) ) )
      = R4 ) ).

% Restr_Field
thf(fact_2965_Times__Int__distrib1,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ A,C3: set @ B] :
      ( ( product_Sigma @ A @ B @ ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        @ ^ [Uu: A] : C3 )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : C3 )
        @ ( product_Sigma @ A @ B @ B3
          @ ^ [Uu: A] : C3 ) ) ) ).

% Times_Int_distrib1
thf(fact_2966_Sigma__Int__distrib2,axiom,
    ! [B: $tType,A: $tType,I4: set @ A,A4: A > ( set @ B ),B3: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ I4
        @ ^ [I2: A] : ( inf_inf @ ( set @ B ) @ ( A4 @ I2 ) @ ( B3 @ I2 ) ) )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I4 @ A4 ) @ ( product_Sigma @ A @ B @ I4 @ B3 ) ) ) ).

% Sigma_Int_distrib2
thf(fact_2967_Times__Int__Times,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B,C3: set @ A,D4: set @ B] :
      ( ( inf_inf @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : B3 )
        @ ( product_Sigma @ A @ B @ C3
          @ ^ [Uu: A] : D4 ) )
      = ( product_Sigma @ A @ B @ ( inf_inf @ ( set @ A ) @ A4 @ C3 )
        @ ^ [Uu: A] : ( inf_inf @ ( set @ B ) @ B3 @ D4 ) ) ) ).

% Times_Int_Times
thf(fact_2968_zero__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ).

% zero_int.rsp
thf(fact_2969_UNION__empty__conv_I2_J,axiom,
    ! [A: $tType,B: $tType,B3: B > ( set @ A ),A4: set @ B] :
      ( ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ A4 ) )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ A4 )
           => ( ( B3 @ X3 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% UNION_empty_conv(2)
thf(fact_2970_UNION__empty__conv_I1_J,axiom,
    ! [A: $tType,B: $tType,B3: B > ( set @ A ),A4: set @ B] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ A4 ) ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ A4 )
           => ( ( B3 @ X3 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% UNION_empty_conv(1)
thf(fact_2971_UN__empty,axiom,
    ! [B: $tType,A: $tType,B3: B > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ ( bot_bot @ ( set @ B ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% UN_empty
thf(fact_2972_UN__empty2,axiom,
    ! [B: $tType,A: $tType,A4: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X3: B] : ( bot_bot @ ( set @ A ) )
          @ A4 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% UN_empty2
thf(fact_2973_Int__UN__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType,A4: B > ( set @ A ),I4: set @ B,B3: C > ( set @ A ),J4: set @ C] :
      ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A4 @ I4 ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ C @ ( set @ A ) @ B3 @ J4 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I2: B] :
              ( complete_Sup_Sup @ ( set @ A )
              @ ( image2 @ C @ ( set @ A )
                @ ^ [J: C] : ( inf_inf @ ( set @ A ) @ ( A4 @ I2 ) @ ( B3 @ J ) )
                @ J4 ) )
          @ I4 ) ) ) ).

% Int_UN_distrib2
thf(fact_2974_Int__UN__distrib,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,A4: B > ( set @ A ),I4: set @ B] :
      ( ( inf_inf @ ( set @ A ) @ B3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A4 @ I4 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I2: B] : ( inf_inf @ ( set @ A ) @ B3 @ ( A4 @ I2 ) )
          @ I4 ) ) ) ).

% Int_UN_distrib
thf(fact_2975_UN__extend__simps_I4_J,axiom,
    ! [H9: $tType,G3: $tType,A4: G3 > ( set @ H9 ),C3: set @ G3,B3: set @ H9] :
      ( ( inf_inf @ ( set @ H9 ) @ ( complete_Sup_Sup @ ( set @ H9 ) @ ( image2 @ G3 @ ( set @ H9 ) @ A4 @ C3 ) ) @ B3 )
      = ( complete_Sup_Sup @ ( set @ H9 )
        @ ( image2 @ G3 @ ( set @ H9 )
          @ ^ [X3: G3] : ( inf_inf @ ( set @ H9 ) @ ( A4 @ X3 ) @ B3 )
          @ C3 ) ) ) ).

% UN_extend_simps(4)
thf(fact_2976_UN__extend__simps_I5_J,axiom,
    ! [I5: $tType,J5: $tType,A4: set @ I5,B3: J5 > ( set @ I5 ),C3: set @ J5] :
      ( ( inf_inf @ ( set @ I5 ) @ A4 @ ( complete_Sup_Sup @ ( set @ I5 ) @ ( image2 @ J5 @ ( set @ I5 ) @ B3 @ C3 ) ) )
      = ( complete_Sup_Sup @ ( set @ I5 )
        @ ( image2 @ J5 @ ( set @ I5 )
          @ ^ [X3: J5] : ( inf_inf @ ( set @ I5 ) @ A4 @ ( B3 @ X3 ) )
          @ C3 ) ) ) ).

% UN_extend_simps(5)
thf(fact_2977_Union__natural,axiom,
    ! [B: $tType,A: $tType,F: A > B] :
      ( ( comp @ ( set @ ( set @ B ) ) @ ( set @ B ) @ ( set @ ( set @ A ) ) @ ( complete_Sup_Sup @ ( set @ B ) ) @ ( image2 @ ( set @ A ) @ ( set @ B ) @ ( image2 @ A @ B @ F ) ) )
      = ( comp @ ( set @ A ) @ ( set @ B ) @ ( set @ ( set @ A ) ) @ ( image2 @ A @ B @ F ) @ ( complete_Sup_Sup @ ( set @ A ) ) ) ) ).

% Union_natural
thf(fact_2978_Int__Union2,axiom,
    ! [A: $tType,B3: set @ ( set @ A ),A4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) @ A4 )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ ( set @ A ) @ ( set @ A )
          @ ^ [C8: set @ A] : ( inf_inf @ ( set @ A ) @ C8 @ A4 )
          @ B3 ) ) ) ).

% Int_Union2
thf(fact_2979_Int__Union,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 ) @ B3 ) ) ) ).

% Int_Union
thf(fact_2980_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I4: set @ B,C2: A,F: B > A] :
          ( ( I4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I4 )
               => ( ord_less_eq @ A @ C2 @ ( F @ I3 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ I4 ) )
                = C2 )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ I4 )
                   => ( ( F @ X3 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_2981_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F: B > A,M: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ A4 )
               => ( ord_less_eq @ A @ ( F @ X2 ) @ M ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ M ) ) ) ) ).

% cSUP_least
thf(fact_2982_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,A3: A] :
          ( ( finite_finite @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X5 ) @ A3 )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ X5 )
                   => ( ord_less @ A @ X3 @ A3 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_2983_finite__Sup__in,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X2: A,Y3: A] :
                  ( ( member @ A @ X2 @ A4 )
                 => ( ( member @ A @ Y3 @ A4 )
                   => ( member @ A @ ( sup_sup @ A @ X2 @ Y3 ) @ A4 ) ) )
             => ( member @ A @ ( complete_Sup_Sup @ A @ A4 ) @ A4 ) ) ) ) ) ).

% finite_Sup_in
thf(fact_2984_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A3: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ A3 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S2 ) ) @ A3 ) ) ) ) ).

% cSup_abs_le
thf(fact_2985_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B3: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_2986_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B3: set @ ( set @ B ),G: B > A] :
          ( ! [X2: set @ B] :
              ( ( member @ ( set @ B ) @ X2 @ B3 )
             => ( finite_finite @ B @ X2 ) )
         => ( ! [A17: set @ B] :
                ( ( member @ ( set @ B ) @ A17 @ B3 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B3 )
                   => ( ( A17 != A25 )
                     => ! [X2: B] :
                          ( ( member @ B @ X2 @ A17 )
                         => ( ( member @ B @ X2 @ A25 )
                           => ( ( G @ X2 )
                              = ( zero_zero @ A ) ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B3 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ B3 ) ) ) ) ) ).

% sum.Union_comp
thf(fact_2987_sup__Sup__fold__sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B3: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A4 ) @ B3 )
            = ( finite_fold @ A @ A @ ( sup_sup @ A ) @ B3 @ A4 ) ) ) ) ).

% sup_Sup_fold_sup
thf(fact_2988_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I4 )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I2: B] : ( times_times @ A @ ( G @ I2 ) @ ( H2 @ I2 ) )
              @ I4 )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I4 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I4 ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_2989_prod_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B3: set @ ( set @ B ),G: B > A] :
          ( ! [X2: set @ B] :
              ( ( member @ ( set @ B ) @ X2 @ B3 )
             => ( finite_finite @ B @ X2 ) )
         => ( ! [A17: set @ B] :
                ( ( member @ ( set @ B ) @ A17 @ B3 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B3 )
                   => ( ( A17 != A25 )
                     => ! [X2: B] :
                          ( ( member @ B @ X2 @ A17 )
                         => ( ( member @ B @ X2 @ A25 )
                           => ( ( G @ X2 )
                              = ( one_one @ A ) ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B3 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G @ B3 ) ) ) ) ) ).

% prod.Union_comp
thf(fact_2990_Sup__fin__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ A4 )
              = ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% Sup_fin_Sup
thf(fact_2991_cSup__eq__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A] :
          ( ( finite_finite @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Sup_Sup @ A @ X5 )
              = ( lattic5882676163264333800up_fin @ A @ X5 ) ) ) ) ) ).

% cSup_eq_Sup_fin
thf(fact_2992_Union__image__empty,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,F: B > ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ F @ ( bot_bot @ ( set @ B ) ) ) ) )
      = A4 ) ).

% Union_image_empty
thf(fact_2993_uminus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X3: nat,Y2: nat] : ( product_Pair @ nat @ nat @ Y2 @ X3 ) )
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X3: nat,Y2: nat] : ( product_Pair @ nat @ nat @ Y2 @ X3 ) ) ) ).

% uminus_int.rsp
thf(fact_2994_card__cartesian__product__singleton,axiom,
    ! [A: $tType,B: $tType,X: A,A4: set @ B] :
      ( ( finite_card @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) )
          @ ^ [Uu: A] : A4 ) )
      = ( finite_card @ B @ A4 ) ) ).

% card_cartesian_product_singleton
thf(fact_2995_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,C3: set @ B,B3: set @ A,D4: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : C3 )
        @ ( product_Sigma @ A @ B @ B3
          @ ^ [Uu: A] : D4 ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        | ( C3
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
          & ( ord_less_eq @ ( set @ B ) @ C3 @ D4 ) ) ) ) ).

% times_subset_iff
thf(fact_2996_wfI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4
        @ ( product_Sigma @ A @ A @ A4
          @ ^ [Uu: A] : B3 ) )
     => ( ! [X2: A,P5: A > $o] :
            ( ! [Xa2: A] :
                ( ! [Y3: A] :
                    ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Xa2 ) @ R4 )
                   => ( P5 @ Y3 ) )
               => ( P5 @ Xa2 ) )
           => ( ( member @ A @ X2 @ A4 )
             => ( ( member @ A @ X2 @ B3 )
               => ( P5 @ X2 ) ) ) )
       => ( wf @ A @ R4 ) ) ) ).

% wfI
thf(fact_2997_SUP__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: B > A] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) ) )
          = ( bot_bot @ A ) ) ) ).

% SUP_empty
thf(fact_2998_SUP__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( ( A4
              = ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Sup_Sup @ A
                @ ( image2 @ B @ A
                  @ ^ [Y2: B] : C2
                  @ A4 ) )
              = ( bot_bot @ A ) ) )
          & ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Sup_Sup @ A
                @ ( image2 @ B @ A
                  @ ^ [Y2: B] : C2
                  @ A4 ) )
              = C2 ) ) ) ) ).

% SUP_constant
thf(fact_2999_Field__Restr__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ord_less_eq @ ( set @ A )
      @ ( field2 @ A
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) )
      @ A4 ) ).

% Field_Restr_subset
thf(fact_3000_finite__cartesian__product__iff,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( finite_finite @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : B3 ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        | ( B3
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( finite_finite @ A @ A4 )
          & ( finite_finite @ B @ B3 ) ) ) ) ).

% finite_cartesian_product_iff
thf(fact_3001_finite__cartesian__productD2,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( finite_finite @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : B3 ) )
     => ( ( A4
         != ( bot_bot @ ( set @ A ) ) )
       => ( finite_finite @ B @ B3 ) ) ) ).

% finite_cartesian_productD2
thf(fact_3002_finite__cartesian__productD1,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( ( finite_finite @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : B3 ) )
     => ( ( B3
         != ( bot_bot @ ( set @ B ) ) )
       => ( finite_finite @ A @ A4 ) ) ) ).

% finite_cartesian_productD1
thf(fact_3003_finite__SigmaI2,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: A > ( set @ B )] :
      ( ( finite_finite @ A
        @ ( collect @ A
          @ ^ [X3: A] :
              ( ( member @ A @ X3 @ A4 )
              & ( ( B3 @ X3 )
               != ( bot_bot @ ( set @ B ) ) ) ) ) )
     => ( ! [A8: A] :
            ( ( member @ A @ A8 @ A4 )
           => ( finite_finite @ B @ ( B3 @ A8 ) ) )
       => ( finite_finite @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ A4 @ B3 ) ) ) ) ).

% finite_SigmaI2
thf(fact_3004_fst__image__Sigma,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: A > ( set @ B )] :
      ( ( image2 @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( product_Sigma @ A @ B @ A4 @ B3 ) )
      = ( collect @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ A4 )
            & ( ( B3 @ X3 )
             != ( bot_bot @ ( set @ B ) ) ) ) ) ) ).

% fst_image_Sigma
thf(fact_3005_SUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: B > A,A3: B,A4: set @ B] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ ( insert2 @ B @ A3 @ A4 ) ) )
          = ( sup_sup @ A @ ( F @ A3 ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) ) ) ) ).

% SUP_insert
thf(fact_3006_SUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [M: B > A,A4: set @ B,B3: set @ B] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ M @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) )
          = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ M @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ M @ B3 ) ) ) ) ) ).

% SUP_union
thf(fact_3007_refl__on__def,axiom,
    ! [A: $tType] :
      ( ( refl_on @ A )
      = ( ^ [A10: set @ A,R5: set @ ( product_prod @ A @ A )] :
            ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5
              @ ( product_Sigma @ A @ A @ A10
                @ ^ [Uu: A] : A10 ) )
            & ! [X3: A] :
                ( ( member @ A @ X3 @ A10 )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R5 ) ) ) ) ) ).

% refl_on_def
thf(fact_3008_refl__onI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4
        @ ( product_Sigma @ A @ A @ A4
          @ ^ [Uu: A] : A4 ) )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ A4 )
           => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R4 ) )
       => ( refl_on @ A @ A4 @ R4 ) ) ) ).

% refl_onI
thf(fact_3009_Refl__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( refl_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( refl_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A4
              @ ^ [Uu: A] : A4 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) ) ) ).

% Refl_Restr
thf(fact_3010_Total__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( total_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( total_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A4
              @ ^ [Uu: A] : A4 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) ) ) ).

% Total_Restr
thf(fact_3011_total__on__imp__Total__Restr,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( total_on @ A @ A4 @ R4 )
     => ( total_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A4
              @ ^ [Uu: A] : A4 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) ) ) ).

% total_on_imp_Total_Restr
thf(fact_3012_UN__extend__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set @ B,A3: A,B3: B > ( set @ A )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( insert2 @ A @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ C3 ) ) )
          = ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( insert2 @ A @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ C3 ) ) )
          = ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [X3: B] : ( insert2 @ A @ A3 @ ( B3 @ X3 ) )
              @ C3 ) ) ) ) ) ).

% UN_extend_simps(1)
thf(fact_3013_UN__extend__simps_I2_J,axiom,
    ! [D: $tType,C: $tType,C3: set @ C,A4: C > ( set @ D ),B3: set @ D] :
      ( ( ( C3
          = ( bot_bot @ ( set @ C ) ) )
       => ( ( sup_sup @ ( set @ D ) @ ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ C @ ( set @ D ) @ A4 @ C3 ) ) @ B3 )
          = B3 ) )
      & ( ( C3
         != ( bot_bot @ ( set @ C ) ) )
       => ( ( sup_sup @ ( set @ D ) @ ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ C @ ( set @ D ) @ A4 @ C3 ) ) @ B3 )
          = ( complete_Sup_Sup @ ( set @ D )
            @ ( image2 @ C @ ( set @ D )
              @ ^ [X3: C] : ( sup_sup @ ( set @ D ) @ ( A4 @ X3 ) @ B3 )
              @ C3 ) ) ) ) ) ).

% UN_extend_simps(2)
thf(fact_3014_UN__extend__simps_I3_J,axiom,
    ! [E: $tType,F9: $tType,C3: set @ F9,A4: set @ E,B3: F9 > ( set @ E )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ F9 ) ) )
       => ( ( sup_sup @ ( set @ E ) @ A4 @ ( complete_Sup_Sup @ ( set @ E ) @ ( image2 @ F9 @ ( set @ E ) @ B3 @ C3 ) ) )
          = A4 ) )
      & ( ( C3
         != ( bot_bot @ ( set @ F9 ) ) )
       => ( ( sup_sup @ ( set @ E ) @ A4 @ ( complete_Sup_Sup @ ( set @ E ) @ ( image2 @ F9 @ ( set @ E ) @ B3 @ C3 ) ) )
          = ( complete_Sup_Sup @ ( set @ E )
            @ ( image2 @ F9 @ ( set @ E )
              @ ^ [X3: F9] : ( sup_sup @ ( set @ E ) @ A4 @ ( B3 @ X3 ) )
              @ C3 ) ) ) ) ) ).

% UN_extend_simps(3)
thf(fact_3015_Linear__order__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( order_679001287576687338der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( order_679001287576687338der_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A4
              @ ^ [Uu: A] : A4 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) ) ) ).

% Linear_order_Restr
thf(fact_3016_swap__product,axiom,
    ! [B: $tType,A: $tType,A4: set @ B,B3: set @ A] :
      ( ( image2 @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [I2: B,J: A] : ( product_Pair @ A @ B @ J @ I2 ) )
        @ ( product_Sigma @ B @ A @ A4
          @ ^ [Uu: B] : B3 ) )
      = ( product_Sigma @ A @ B @ B3
        @ ^ [Uu: A] : A4 ) ) ).

% swap_product
thf(fact_3017_one__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ).

% one_int.rsp
thf(fact_3018_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T3: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T3 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
               => ( ( G @ X2 )
                  = ( one_one @ A ) ) )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ S2 )
                 => ( ( G @ X2 )
                    = ( H2 @ X2 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T3 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_3019_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T3: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T3 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
               => ( ( H2 @ I3 )
                  = ( one_one @ A ) ) )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ S2 )
                 => ( ( G @ X2 )
                    = ( H2 @ X2 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ T3 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_3020_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T3 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
               => ( ( G @ X2 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T3 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ S2 ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_3021_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T3 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
               => ( ( G @ X2 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ T3 ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_3022_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S2 ) @ L ) ) @ E2 ) ) ) ) ).

% cSup_asclose
thf(fact_3023_Sup__fold__sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( complete_Sup_Sup @ A @ A4 )
            = ( finite_fold @ A @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) @ A4 ) ) ) ) ).

% Sup_fold_sup
thf(fact_3024_sum_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C3: set @ ( set @ B ),G: B > A] :
          ( ! [X2: set @ B] :
              ( ( member @ ( set @ B ) @ X2 @ C3 )
             => ( finite_finite @ B @ X2 ) )
         => ( ! [X2: set @ B] :
                ( ( member @ ( set @ B ) @ X2 @ C3 )
               => ! [Xa3: set @ B] :
                    ( ( member @ ( set @ B ) @ Xa3 @ C3 )
                   => ( ( X2 != Xa3 )
                     => ( ( inf_inf @ ( set @ B ) @ X2 @ Xa3 )
                        = ( bot_bot @ ( set @ B ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ C3 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ C3 ) ) ) ) ) ).

% sum.Union_disjoint
thf(fact_3025_prod_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C3: set @ ( set @ B ),G: B > A] :
          ( ! [X2: set @ B] :
              ( ( member @ ( set @ B ) @ X2 @ C3 )
             => ( finite_finite @ B @ X2 ) )
         => ( ! [X2: set @ B] :
                ( ( member @ ( set @ B ) @ X2 @ C3 )
               => ! [Xa3: set @ B] :
                    ( ( member @ ( set @ B ) @ Xa3 @ C3 )
                   => ( ( X2 != Xa3 )
                     => ( ( inf_inf @ ( set @ B ) @ X2 @ Xa3 )
                        = ( bot_bot @ ( set @ B ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ C3 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G @ C3 ) ) ) ) ) ).

% prod.Union_disjoint
thf(fact_3026_inv__image__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( inv_image @ B @ A )
      = ( ^ [R5: set @ ( product_prod @ B @ B ),F2: A > B] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) @ R5 ) ) ) ) ) ).

% inv_image_def
thf(fact_3027_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I4 )
                  & ( ( G @ X3 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X3: B] :
                    ( ( member @ B @ X3 @ I4 )
                    & ( ( H2 @ X3 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I2: B] : ( times_times @ A @ ( G @ I2 ) @ ( H2 @ I2 ) )
                @ I4 )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I4 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I4 ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_3028_prod_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ B @ A )
        = ( ^ [P6: B > A,I6: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( member @ B @ X3 @ I6 )
                      & ( ( P6 @ X3 )
                       != ( one_one @ A ) ) ) ) )
              @ ( groups7121269368397514597t_prod @ B @ A @ P6
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( member @ B @ X3 @ I6 )
                      & ( ( P6 @ X3 )
                       != ( one_one @ A ) ) ) ) )
              @ ( one_one @ A ) ) ) ) ) ).

% prod.G_def
thf(fact_3029_Refl__Field__Restr2,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( refl_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( field2 @ A @ R4 ) )
       => ( ( field2 @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ A4
                @ ^ [Uu: A] : A4 ) ) )
          = A4 ) ) ) ).

% Refl_Field_Restr2
thf(fact_3030_Refl__Field__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( refl_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A4
              @ ^ [Uu: A] : A4 ) ) )
        = ( inf_inf @ ( set @ A ) @ ( field2 @ A @ R4 ) @ A4 ) ) ) ).

% Refl_Field_Restr
thf(fact_3031_image__paired__Times,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,F: C > A,G: D > B,A4: set @ C,B3: set @ D] :
      ( ( image2 @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X3: C,Y2: D] : ( product_Pair @ A @ B @ ( F @ X3 ) @ ( G @ Y2 ) ) )
        @ ( product_Sigma @ C @ D @ A4
          @ ^ [Uu: C] : B3 ) )
      = ( product_Sigma @ A @ B @ ( image2 @ C @ A @ F @ A4 )
        @ ^ [Uu: A] : ( image2 @ D @ B @ G @ B3 ) ) ) ).

% image_paired_Times
thf(fact_3032_UNION__singleton__eq__range,axiom,
    ! [A: $tType,B: $tType,F: B > A,A4: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X3: B] : ( insert2 @ A @ ( F @ X3 ) @ ( bot_bot @ ( set @ A ) ) )
          @ A4 ) )
      = ( image2 @ B @ A @ F @ A4 ) ) ).

% UNION_singleton_eq_range
thf(fact_3033_Id__on__def,axiom,
    ! [A: $tType] :
      ( ( id_on @ A )
      = ( ^ [A10: set @ A] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image2 @ A @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [X3: A] : ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
              @ A10 ) ) ) ) ).

% Id_on_def
thf(fact_3034_sup__SUP__fold__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,B3: A,F: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( sup_sup @ A @ B3 @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) )
            = ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( sup_sup @ A ) @ F ) @ B3 @ A4 ) ) ) ) ).

% sup_SUP_fold_sup
thf(fact_3035_card__partition,axiom,
    ! [A: $tType,C3: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ ( set @ A ) @ C3 )
     => ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C3 ) )
       => ( ! [C4: set @ A] :
              ( ( member @ ( set @ A ) @ C4 @ C3 )
             => ( ( finite_card @ A @ C4 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member @ ( set @ A ) @ C1 @ C3 )
               => ( ( member @ ( set @ A ) @ C22 @ C3 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C3 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C3 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_3036_dvd__partition,axiom,
    ! [A: $tType,C3: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C3 ) )
     => ( ! [X2: set @ A] :
            ( ( member @ ( set @ A ) @ X2 @ C3 )
           => ( dvd_dvd @ nat @ K @ ( finite_card @ A @ X2 ) ) )
       => ( ! [X2: set @ A] :
              ( ( member @ ( set @ A ) @ X2 @ C3 )
             => ! [Xa3: set @ A] :
                  ( ( member @ ( set @ A ) @ Xa3 @ C3 )
                 => ( ( X2 != Xa3 )
                   => ( ( inf_inf @ ( set @ A ) @ X2 @ Xa3 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( dvd_dvd @ nat @ K @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C3 ) ) ) ) ) ) ).

% dvd_partition
thf(fact_3037_sum_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I4: set @ B,A4: B > ( set @ C ),G: C > A] :
          ( ( finite_finite @ B @ I4 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ I4 )
               => ( finite_finite @ C @ ( A4 @ X2 ) ) )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ I4 )
                 => ! [Xa3: B] :
                      ( ( member @ B @ Xa3 @ I4 )
                     => ( ( X2 != Xa3 )
                       => ( ( inf_inf @ ( set @ C ) @ ( A4 @ X2 ) @ ( A4 @ Xa3 ) )
                          = ( bot_bot @ ( set @ C ) ) ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A4 @ I4 ) ) )
                = ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [X3: B] : ( groups7311177749621191930dd_sum @ C @ A @ G @ ( A4 @ X3 ) )
                  @ I4 ) ) ) ) ) ) ).

% sum.UNION_disjoint
thf(fact_3038_prod_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I4: set @ B,A4: B > ( set @ C ),G: C > A] :
          ( ( finite_finite @ B @ I4 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ I4 )
               => ( finite_finite @ C @ ( A4 @ X2 ) ) )
           => ( ! [X2: B] :
                  ( ( member @ B @ X2 @ I4 )
                 => ! [Xa3: B] :
                      ( ( member @ B @ Xa3 @ I4 )
                     => ( ( X2 != Xa3 )
                       => ( ( inf_inf @ ( set @ C ) @ ( A4 @ X2 ) @ ( A4 @ Xa3 ) )
                          = ( bot_bot @ ( set @ C ) ) ) ) ) )
             => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A4 @ I4 ) ) )
                = ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [X3: B] : ( groups7121269368397514597t_prod @ C @ A @ G @ ( A4 @ X3 ) )
                  @ I4 ) ) ) ) ) ) ).

% prod.UNION_disjoint
thf(fact_3039_product__fold,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ B @ B3 )
       => ( ( product_Sigma @ A @ B @ A4
            @ ^ [Uu: A] : B3 )
          = ( finite_fold @ A @ ( set @ ( product_prod @ A @ B ) )
            @ ^ [X3: A,Z4: set @ ( product_prod @ A @ B )] :
                ( finite_fold @ B @ ( set @ ( product_prod @ A @ B ) )
                @ ^ [Y2: B] : ( insert2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) )
                @ Z4
                @ B3 )
            @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) )
            @ A4 ) ) ) ) ).

% product_fold
thf(fact_3040_plus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y2 @ V3 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y2 @ V3 ) ) ) ) ) ).

% plus_int.rsp
thf(fact_3041_minus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V3 ) @ ( plus_plus @ nat @ Y2 @ U2 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y2: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V3 ) @ ( plus_plus @ nat @ Y2 @ U2 ) ) ) ) ) ).

% minus_int.rsp
thf(fact_3042_SUP__fold__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) )
            = ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( sup_sup @ A ) @ F ) @ ( bot_bot @ A ) @ A4 ) ) ) ) ).

% SUP_fold_sup
thf(fact_3043_card__UN__disjoint,axiom,
    ! [B: $tType,A: $tType,I4: set @ A,A4: A > ( set @ B )] :
      ( ( finite_finite @ A @ I4 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ I4 )
           => ( finite_finite @ B @ ( A4 @ X2 ) ) )
       => ( ! [X2: A] :
              ( ( member @ A @ X2 @ I4 )
             => ! [Xa3: A] :
                  ( ( member @ A @ Xa3 @ I4 )
                 => ( ( X2 != Xa3 )
                   => ( ( inf_inf @ ( set @ B ) @ ( A4 @ X2 ) @ ( A4 @ Xa3 ) )
                      = ( bot_bot @ ( set @ B ) ) ) ) ) )
         => ( ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A4 @ I4 ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I2: A] : ( finite_card @ B @ ( A4 @ I2 ) )
              @ I4 ) ) ) ) ) ).

% card_UN_disjoint
thf(fact_3044_ccpo__Sup__singleton,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [X: A] :
          ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% ccpo_Sup_singleton
thf(fact_3045_linear__order__on__Restr,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X: A] :
      ( ( order_679001287576687338der_on @ A @ A4 @ R4 )
     => ( order_679001287576687338der_on @ A @ ( inf_inf @ ( set @ A ) @ A4 @ ( order_above @ A @ R4 @ X ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ ( order_above @ A @ R4 @ X )
            @ ^ [Uu: A] : ( order_above @ A @ R4 @ X ) ) ) ) ) ).

% linear_order_on_Restr
thf(fact_3046_rp__inv__image__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( fun_rp_inv_image @ A @ B )
      = ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) )
        @ ^ [R2: set @ ( product_prod @ A @ A ),S7: set @ ( product_prod @ A @ A ),F2: B > A] : ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( inv_image @ A @ B @ R2 @ F2 ) @ ( inv_image @ A @ B @ S7 @ F2 ) ) ) ) ).

% rp_inv_image_def
thf(fact_3047_UNION__fun__upd,axiom,
    ! [B: $tType,A: $tType,A4: B > ( set @ A ),I: B,B3: set @ A,J4: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ ( fun_upd @ B @ ( set @ A ) @ A4 @ I @ B3 ) @ J4 ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ B ) @ J4 @ ( insert2 @ B @ I @ ( bot_bot @ ( set @ B ) ) ) ) ) ) @ ( if @ ( set @ A ) @ ( member @ B @ I @ J4 ) @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% UNION_fun_upd
thf(fact_3048_rtrancl__last__visit__node,axiom,
    ! [A: $tType,S: A,S3: A,R: set @ ( product_prod @ A @ A ),Sh: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ S @ S3 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( ( S != Sh )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ S @ S3 )
            @ ( transitive_rtrancl @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
                @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                  @ ^ [Uu: A] : ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ Sh @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) )
        | ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ S @ Sh ) @ ( transitive_rtrancl @ A @ R ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Sh @ S3 )
            @ ( transitive_rtrancl @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
                @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                  @ ^ [Uu: A] : ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ Sh @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% rtrancl_last_visit_node
thf(fact_3049_Sup__nat__empty,axiom,
    ( ( complete_Sup_Sup @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% Sup_nat_empty
thf(fact_3050_rtrancl__empty,axiom,
    ! [A: $tType] :
      ( ( transitive_rtrancl @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
      = ( id2 @ A ) ) ).

% rtrancl_empty
thf(fact_3051_wf__insert,axiom,
    ! [A: $tType,Y: A,X: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X ) @ R4 ) )
      = ( ( wf @ A @ R4 )
        & ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ).

% wf_insert
thf(fact_3052_UNIV__bool,axiom,
    ( ( top_top @ ( set @ $o ) )
    = ( insert2 @ $o @ $false @ ( insert2 @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) ) ) ).

% UNIV_bool
thf(fact_3053_converse__rtrancl__into__rtrancl,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R4 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ C2 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ).

% converse_rtrancl_into_rtrancl
thf(fact_3054_converse__rtrancl__induct,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( P @ B2 )
       => ( ! [Y3: A,Z3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ R4 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ B2 ) @ ( transitive_rtrancl @ A @ R4 ) )
               => ( ( P @ Z3 )
                 => ( P @ Y3 ) ) ) )
         => ( P @ A3 ) ) ) ) ).

% converse_rtrancl_induct
thf(fact_3055_converse__rtranclE,axiom,
    ! [A: $tType,X: A,Z2: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( X != Z2 )
       => ~ ! [Y3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R4 )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ) ).

% converse_rtranclE
thf(fact_3056_rtrancl__induct,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( P @ A3 )
       => ( ! [Y3: A,Z3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ Y3 ) @ ( transitive_rtrancl @ A @ R4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ R4 )
               => ( ( P @ Y3 )
                 => ( P @ Z3 ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% rtrancl_induct
thf(fact_3057_rtrancl__trans,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ ( transitive_rtrancl @ A @ R4 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ).

% rtrancl_trans
thf(fact_3058_rtranclE,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( A3 != B2 )
       => ~ ! [Y3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ Y3 ) @ ( transitive_rtrancl @ A @ R4 ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ B2 ) @ R4 ) ) ) ) ).

% rtranclE
thf(fact_3059_rtrancl_Ortrancl__into__rtrancl,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R4 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ C2 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ).

% rtrancl.rtrancl_into_rtrancl
thf(fact_3060_rtrancl_Ortrancl__refl,axiom,
    ! [A: $tType,A3: A,R4: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A3 ) @ ( transitive_rtrancl @ A @ R4 ) ) ).

% rtrancl.rtrancl_refl
thf(fact_3061_rtrancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_rtrancl @ A @ R4 ) )
      = ( ? [A5: A] :
            ( ( A1 = A5 )
            & ( A22 = A5 ) )
        | ? [A5: A,B4: A,C5: A] :
            ( ( A1 = A5 )
            & ( A22 = C5 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ ( transitive_rtrancl @ A @ R4 ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C5 ) @ R4 ) ) ) ) ).

% rtrancl.simps
thf(fact_3062_rtrancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( A22 != A1 )
       => ~ ! [B6: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ B6 ) @ ( transitive_rtrancl @ A @ R4 ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A22 ) @ R4 ) ) ) ) ).

% rtrancl.cases
thf(fact_3063_converse__rtranclE_H,axiom,
    ! [A: $tType,U: A,V: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( U != V )
       => ~ ! [Vh: A] :
              ( ( U != Vh )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ Vh ) @ R )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Vh @ V ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ) ).

% converse_rtranclE'
thf(fact_3064_fun__upd__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: C > B,G: A > C,X: A,Y: C] :
      ( ( comp @ C @ B @ A @ F @ ( fun_upd @ A @ C @ G @ X @ Y ) )
      = ( fun_upd @ A @ B @ ( comp @ C @ B @ A @ F @ G ) @ X @ ( F @ Y ) ) ) ).

% fun_upd_comp
thf(fact_3065_rtrancl__Un__separatorE,axiom,
    ! [A: $tType,A3: A,B2: A,P: set @ ( product_prod @ A @ A ),Q: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ P @ Q ) ) )
     => ( ! [X2: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ X2 ) @ ( transitive_rtrancl @ A @ P ) )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ Q )
             => ( X2 = Y3 ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ P ) ) ) ) ).

% rtrancl_Un_separatorE
thf(fact_3066_rtrancl__Un__separator__converseE,axiom,
    ! [A: $tType,A3: A,B2: A,P: set @ ( product_prod @ A @ A ),Q: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ P @ Q ) ) )
     => ( ! [X2: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ B2 ) @ ( transitive_rtrancl @ A @ P ) )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X2 ) @ Q )
             => ( Y3 = X2 ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ P ) ) ) ) ).

% rtrancl_Un_separator_converseE
thf(fact_3067_converse__rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R4: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R4 ) )
     => ( ( P @ Bx @ By )
       => ( ! [A8: A,B6: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A8 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R4 )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R4 ) )
               => ( ( P @ Aa2 @ Ba )
                 => ( P @ A8 @ B6 ) ) ) )
         => ( P @ Ax @ Ay ) ) ) ) ).

% converse_rtrancl_induct2
thf(fact_3068_converse__rtranclE2,axiom,
    ! [B: $tType,A: $tType,Xa: A,Xb: B,Za2: A,Zb: B,R4: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Xa @ Xb ) @ ( product_Pair @ A @ B @ Za2 @ Zb ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R4 ) )
     => ( ( ( product_Pair @ A @ B @ Xa @ Xb )
         != ( product_Pair @ A @ B @ Za2 @ Zb ) )
       => ~ ! [A8: A,B6: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Xa @ Xb ) @ ( product_Pair @ A @ B @ A8 @ B6 ) ) @ R4 )
             => ~ ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A8 @ B6 ) @ ( product_Pair @ A @ B @ Za2 @ Zb ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R4 ) ) ) ) ) ).

% converse_rtranclE2
thf(fact_3069_rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R4: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R4 ) )
     => ( ( P @ Ax @ Ay )
       => ( ! [A8: A,B6: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A8 @ B6 ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R4 ) )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A8 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R4 )
               => ( ( P @ A8 @ B6 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% rtrancl_induct2
thf(fact_3070_SUP__Sup__eq2,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image2 @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I2: set @ ( product_prod @ A @ B ),X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ I2 )
          @ S2 ) )
      = ( ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ S2 ) ) ) ) ).

% SUP_Sup_eq2
thf(fact_3071_Sup__SUP__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Sup_Sup @ ( A > B > $o ) )
      = ( ^ [S7: set @ ( A > B > $o ),X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image2 @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S7 ) ) ) ) ) ) ).

% Sup_SUP_eq2
thf(fact_3072_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) )
       => ( ( A3 = B2 )
          | ( member @ A @ A3 @ A4 ) ) ) ) ).

% trancl_subset_Sigma_aux
thf(fact_3073_Restr__rtrancl__mono,axiom,
    ! [A: $tType,V: A,W2: A,E4: set @ ( product_prod @ A @ A ),U3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 )
        @ ( transitive_rtrancl @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ E4
            @ ( product_Sigma @ A @ A @ U3
              @ ^ [Uu: A] : U3 ) ) ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 ) @ ( transitive_rtrancl @ A @ E4 ) ) ) ).

% Restr_rtrancl_mono
thf(fact_3074_SUP__UN__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: C > ( set @ ( product_prod @ A @ B ) ),S2: set @ C] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image2 @ C @ ( A > B > $o )
          @ ^ [I2: C,X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( R4 @ I2 ) )
          @ S2 ) )
      = ( ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ C @ ( set @ ( product_prod @ A @ B ) ) @ R4 @ S2 ) ) ) ) ) ).

% SUP_UN_eq2
thf(fact_3075_rtrancl__mapI,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: A,E4: set @ ( product_prod @ A @ A ),F: A > B] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ E4 ) )
     => ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F @ A3 ) @ ( F @ B2 ) ) @ ( transitive_rtrancl @ B @ ( image2 @ ( product_prod @ A @ A ) @ ( product_prod @ B @ B ) @ ( pairself @ A @ B @ F ) @ E4 ) ) ) ) ).

% rtrancl_mapI
thf(fact_3076_above__def,axiom,
    ! [A: $tType] :
      ( ( order_above @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),A5: A] :
            ( collect @ A
            @ ^ [B4: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R5 ) ) ) ) ).

% above_def
thf(fact_3077_rtrancl__Int__subset,axiom,
    ! [A: $tType,S: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( id2 @ A ) @ S )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R4 ) @ S ) @ R4 ) @ S )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R4 ) @ S ) ) ) ).

% rtrancl_Int_subset
thf(fact_3078_rtrancl__last__touch,axiom,
    ! [A: $tType,Q4: A,Q6: A,R: set @ ( product_prod @ A @ A ),S2: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Q6 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ A @ Q4 @ S2 )
       => ~ ! [Qt: A] :
              ( ( member @ A @ Qt @ S2 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Qt ) @ ( transitive_rtrancl @ A @ R ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Qt @ Q6 )
                    @ ( transitive_rtrancl @ A
                      @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R
                        @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                          @ ^ [Uu: A] : S2 ) ) ) ) ) ) ) ) ).

% rtrancl_last_touch
thf(fact_3079_rtrancl__last__visit_H,axiom,
    ! [A: $tType,Q4: A,Q6: A,R: set @ ( product_prod @ A @ A ),S2: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Q6 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Q6 )
            @ ( transitive_rtrancl @ A
              @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R
                @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                  @ ^ [Uu: A] : S2 ) ) ) )
       => ~ ! [Qt: A] :
              ( ( member @ A @ Qt @ S2 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Qt ) @ ( transitive_rtrancl @ A @ R ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Qt @ Q6 )
                    @ ( transitive_rtrancl @ A
                      @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R
                        @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                          @ ^ [Uu: A] : S2 ) ) ) ) ) ) ) ) ).

% rtrancl_last_visit'
thf(fact_3080_rtrancl__insert,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtrancl @ A @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R4 )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X3: A,Y2: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ A3 ) @ ( transitive_rtrancl @ A @ R4 ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y2 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ) ) ) ).

% rtrancl_insert
thf(fact_3081_fun__upd__image,axiom,
    ! [A: $tType,B: $tType,X: B,A4: set @ B,F: B > A,Y: A] :
      ( ( ( member @ B @ X @ A4 )
       => ( ( image2 @ B @ A @ ( fun_upd @ B @ A @ F @ X @ Y ) @ A4 )
          = ( insert2 @ A @ Y @ ( image2 @ B @ A @ F @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
      & ( ~ ( member @ B @ X @ A4 )
       => ( ( image2 @ B @ A @ ( fun_upd @ B @ A @ F @ X @ Y ) @ A4 )
          = ( image2 @ B @ A @ F @ A4 ) ) ) ) ).

% fun_upd_image
thf(fact_3082_subset__mset_OcSUP__const,axiom,
    ! [B: $tType,A: $tType,A4: set @ B,C2: multiset @ A] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( complete_Sup_Sup @ ( multiset @ A )
          @ ( image2 @ B @ ( multiset @ A )
            @ ^ [X3: B] : C2
            @ A4 ) )
        = C2 ) ) ).

% subset_mset.cSUP_const
thf(fact_3083_Pow__fold,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( pow @ A @ A4 )
        = ( finite_fold @ A @ ( set @ ( set @ A ) )
          @ ^ [X3: A,A10: set @ ( set @ A )] : ( sup_sup @ ( set @ ( set @ A ) ) @ A10 @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( insert2 @ A @ X3 ) @ A10 ) )
          @ ( insert2 @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
          @ A4 ) ) ) ).

% Pow_fold
thf(fact_3084_chains__extend,axiom,
    ! [A: $tType,C2: set @ ( set @ A ),S2: set @ ( set @ A ),Z2: set @ A] :
      ( ( member @ ( set @ ( set @ A ) ) @ C2 @ ( chains2 @ A @ S2 ) )
     => ( ( member @ ( set @ A ) @ Z2 @ S2 )
       => ( ! [X2: set @ A] :
              ( ( member @ ( set @ A ) @ X2 @ C2 )
             => ( ord_less_eq @ ( set @ A ) @ X2 @ Z2 ) )
         => ( member @ ( set @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( insert2 @ ( set @ A ) @ Z2 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) @ C2 ) @ ( chains2 @ A @ S2 ) ) ) ) ) ).

% chains_extend
thf(fact_3085_rtrancl__restrictI,axiom,
    ! [A: $tType,U: A,V: A,E4: set @ ( product_prod @ A @ A ),R: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V )
        @ ( transitive_rtrancl @ A
          @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ E4
            @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
              @ ^ [Uu: A] : R ) ) ) )
     => ( ~ ( member @ A @ U @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V ) @ ( transitive_rtrancl @ A @ ( rel_restrict @ A @ E4 @ R ) ) ) ) ) ).

% rtrancl_restrictI
thf(fact_3086_image__split__eq__Sigma,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: C > A,G: C > B,A4: set @ C] :
      ( ( image2 @ C @ ( product_prod @ A @ B )
        @ ^ [X3: C] : ( product_Pair @ A @ B @ ( F @ X3 ) @ ( G @ X3 ) )
        @ A4 )
      = ( product_Sigma @ A @ B @ ( image2 @ C @ A @ F @ A4 )
        @ ^ [X3: A] : ( image2 @ C @ B @ G @ ( inf_inf @ ( set @ C ) @ ( vimage @ C @ A @ F @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ A4 ) ) ) ) ).

% image_split_eq_Sigma
thf(fact_3087_subset__mset_OcSup__singleton,axiom,
    ! [A: $tType,X: multiset @ A] :
      ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
      = X ) ).

% subset_mset.cSup_singleton
thf(fact_3088_vimage__empty,axiom,
    ! [B: $tType,A: $tType,F: A > B] :
      ( ( vimage @ A @ B @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% vimage_empty
thf(fact_3089_vimage__Int,axiom,
    ! [A: $tType,B: $tType,F: A > B,A4: set @ B,B3: set @ B] :
      ( ( vimage @ A @ B @ F @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F @ A4 ) @ ( vimage @ A @ B @ F @ B3 ) ) ) ).

% vimage_Int
thf(fact_3090_rel__restrict__empty,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( rel_restrict @ A @ R @ ( bot_bot @ ( set @ A ) ) )
      = R ) ).

% rel_restrict_empty
thf(fact_3091_vimage__const,axiom,
    ! [B: $tType,A: $tType,C2: B,A4: set @ B] :
      ( ( ( member @ B @ C2 @ A4 )
       => ( ( vimage @ A @ B
            @ ^ [X3: A] : C2
            @ A4 )
          = ( top_top @ ( set @ A ) ) ) )
      & ( ~ ( member @ B @ C2 @ A4 )
       => ( ( vimage @ A @ B
            @ ^ [X3: A] : C2
            @ A4 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% vimage_const
thf(fact_3092_Pow__Int__eq,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( pow @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
      = ( inf_inf @ ( set @ ( set @ A ) ) @ ( pow @ A @ A4 ) @ ( pow @ A @ B3 ) ) ) ).

% Pow_Int_eq
thf(fact_3093_image__vimage__eq,axiom,
    ! [A: $tType,B: $tType,F: B > A,A4: set @ A] :
      ( ( image2 @ B @ A @ F @ ( vimage @ B @ A @ F @ A4 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ ( image2 @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) ) ).

% image_vimage_eq
thf(fact_3094_vimage__if,axiom,
    ! [B: $tType,A: $tType,C2: B,A4: set @ B,D2: B,B3: set @ A] :
      ( ( ( member @ B @ C2 @ A4 )
       => ( ( ( member @ B @ D2 @ A4 )
           => ( ( vimage @ A @ B
                @ ^ [X3: A] : ( if @ B @ ( member @ A @ X3 @ B3 ) @ C2 @ D2 )
                @ A4 )
              = ( top_top @ ( set @ A ) ) ) )
          & ( ~ ( member @ B @ D2 @ A4 )
           => ( ( vimage @ A @ B
                @ ^ [X3: A] : ( if @ B @ ( member @ A @ X3 @ B3 ) @ C2 @ D2 )
                @ A4 )
              = B3 ) ) ) )
      & ( ~ ( member @ B @ C2 @ A4 )
       => ( ( ( member @ B @ D2 @ A4 )
           => ( ( vimage @ A @ B
                @ ^ [X3: A] : ( if @ B @ ( member @ A @ X3 @ B3 ) @ C2 @ D2 )
                @ A4 )
              = ( uminus_uminus @ ( set @ A ) @ B3 ) ) )
          & ( ~ ( member @ B @ D2 @ A4 )
           => ( ( vimage @ A @ B
                @ ^ [X3: A] : ( if @ B @ ( member @ A @ X3 @ B3 ) @ C2 @ D2 )
                @ A4 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% vimage_if
thf(fact_3095_Pow__singleton__iff,axiom,
    ! [A: $tType,X5: set @ A,Y6: set @ A] :
      ( ( ( pow @ A @ X5 )
        = ( insert2 @ ( set @ A ) @ Y6 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) )
      = ( ( X5
          = ( bot_bot @ ( set @ A ) ) )
        & ( Y6
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Pow_singleton_iff
thf(fact_3096_Pow__empty,axiom,
    ! [A: $tType] :
      ( ( pow @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( insert2 @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_empty
thf(fact_3097_vimage__inter__cong,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B,G: A > B,Y: set @ B] :
      ( ! [W: A] :
          ( ( member @ A @ W @ S2 )
         => ( ( F @ W )
            = ( G @ W ) ) )
     => ( ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F @ Y ) @ S2 )
        = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ G @ Y ) @ S2 ) ) ) ).

% vimage_inter_cong
thf(fact_3098_Sup__multiset__empty,axiom,
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
      = ( zero_zero @ ( multiset @ A ) ) ) ).

% Sup_multiset_empty
thf(fact_3099_vimage__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: A > B,G: B > C,X: set @ C] :
      ( ( vimage @ A @ B @ F @ ( vimage @ B @ C @ G @ X ) )
      = ( vimage @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ X ) ) ).

% vimage_comp
thf(fact_3100_set_Ocompositionality,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: C > B,G: B > A,Set: set @ A] :
      ( ( vimage @ C @ B @ F @ ( vimage @ B @ A @ G @ Set ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ Set ) ) ).

% set.compositionality
thf(fact_3101_Pow__bottom,axiom,
    ! [A: $tType,B3: set @ A] : ( member @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( pow @ A @ B3 ) ) ).

% Pow_bottom
thf(fact_3102_rel__restrict__notR_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,A4: set @ ( product_prod @ A @ A ),R: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( rel_restrict @ A @ A4 @ R ) )
     => ~ ( member @ A @ Y @ R ) ) ).

% rel_restrict_notR(2)
thf(fact_3103_rel__restrict__notR_I1_J,axiom,
    ! [A: $tType,X: A,Y: A,A4: set @ ( product_prod @ A @ A ),R: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( rel_restrict @ A @ A4 @ R ) )
     => ~ ( member @ A @ X @ R ) ) ).

% rel_restrict_notR(1)
thf(fact_3104_rel__restrictI,axiom,
    ! [A: $tType,X: A,R: set @ A,Y: A,E4: set @ ( product_prod @ A @ A )] :
      ( ~ ( member @ A @ X @ R )
     => ( ~ ( member @ A @ Y @ R )
       => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ E4 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( rel_restrict @ A @ E4 @ R ) ) ) ) ) ).

% rel_restrictI
thf(fact_3105_rel__restrict__lift,axiom,
    ! [A: $tType,X: A,Y: A,E4: set @ ( product_prod @ A @ A ),R: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( rel_restrict @ A @ E4 @ R ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ E4 ) ) ).

% rel_restrict_lift
thf(fact_3106_Pow__not__empty,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( pow @ A @ A4 )
     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ).

% Pow_not_empty
thf(fact_3107_vimage__singleton__eq,axiom,
    ! [A: $tType,B: $tType,A3: A,F: A > B,B2: B] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F @ ( insert2 @ B @ B2 @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( ( F @ A3 )
        = B2 ) ) ).

% vimage_singleton_eq
thf(fact_3108_vimage__Times,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: A > ( product_prod @ B @ C ),A4: set @ B,B3: set @ C] :
      ( ( vimage @ A @ ( product_prod @ B @ C ) @ F
        @ ( product_Sigma @ B @ C @ A4
          @ ^ [Uu: B] : B3 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F ) @ A4 ) @ ( vimage @ A @ C @ ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F ) @ B3 ) ) ) ).

% vimage_Times
thf(fact_3109_set_Ocomp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: C > B,G: B > A] :
      ( ( comp @ ( set @ B ) @ ( set @ C ) @ ( set @ A ) @ ( vimage @ C @ B @ F ) @ ( vimage @ B @ A @ G ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G @ F ) ) ) ).

% set.comp
thf(fact_3110_Pair__vimage__Sigma,axiom,
    ! [B: $tType,A: $tType,X: B,A4: set @ B,F: B > ( set @ A )] :
      ( ( ( member @ B @ X @ A4 )
       => ( ( vimage @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X ) @ ( product_Sigma @ B @ A @ A4 @ F ) )
          = ( F @ X ) ) )
      & ( ~ ( member @ B @ X @ A4 )
       => ( ( vimage @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X ) @ ( product_Sigma @ B @ A @ A4 @ F ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Pair_vimage_Sigma
thf(fact_3111_surj__vimage__empty,axiom,
    ! [B: $tType,A: $tType,F: B > A,A4: set @ A] :
      ( ( ( image2 @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ( vimage @ B @ A @ F @ A4 )
          = ( bot_bot @ ( set @ B ) ) )
        = ( A4
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% surj_vimage_empty
thf(fact_3112_vimage__insert,axiom,
    ! [A: $tType,B: $tType,F: A > B,A3: B,B3: set @ B] :
      ( ( vimage @ A @ B @ F @ ( insert2 @ B @ A3 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ ( vimage @ A @ B @ F @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) @ ( vimage @ A @ B @ F @ B3 ) ) ) ).

% vimage_insert
thf(fact_3113_finite__vimage__IntI,axiom,
    ! [A: $tType,B: $tType,F3: set @ A,H2: B > A,A4: set @ B] :
      ( ( finite_finite @ A @ F3 )
     => ( ( inj_on @ B @ A @ H2 @ A4 )
       => ( finite_finite @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ H2 @ F3 ) @ A4 ) ) ) ) ).

% finite_vimage_IntI
thf(fact_3114_rel__restrict__def,axiom,
    ! [A: $tType] :
      ( ( rel_restrict @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A ),A10: set @ A] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [V3: A,W3: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V3 @ W3 ) @ R2 )
                  & ~ ( member @ A @ V3 @ A10 )
                  & ~ ( member @ A @ W3 @ A10 ) ) ) ) ) ) ).

% rel_restrict_def
thf(fact_3115_inf__img__fin__domE,axiom,
    ! [B: $tType,A: $tType,F: B > A,A4: set @ B] :
      ( ( finite_finite @ A @ ( image2 @ B @ A @ F @ A4 ) )
     => ( ~ ( finite_finite @ B @ A4 )
       => ~ ! [Y3: A] :
              ( ( member @ A @ Y3 @ ( image2 @ B @ A @ F @ A4 ) )
             => ( finite_finite @ B @ ( vimage @ B @ A @ F @ ( insert2 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% inf_img_fin_domE
thf(fact_3116_inf__img__fin__dom,axiom,
    ! [B: $tType,A: $tType,F: B > A,A4: set @ B] :
      ( ( finite_finite @ A @ ( image2 @ B @ A @ F @ A4 ) )
     => ( ~ ( finite_finite @ B @ A4 )
       => ? [X2: A] :
            ( ( member @ A @ X2 @ ( image2 @ B @ A @ F @ A4 ) )
            & ~ ( finite_finite @ B @ ( vimage @ B @ A @ F @ ( insert2 @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% inf_img_fin_dom
thf(fact_3117_finite__finite__vimage__IntI,axiom,
    ! [A: $tType,B: $tType,F3: set @ A,H2: B > A,A4: set @ B] :
      ( ( finite_finite @ A @ F3 )
     => ( ! [Y3: A] :
            ( ( member @ A @ Y3 @ F3 )
           => ( finite_finite @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ H2 @ ( insert2 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) @ A4 ) ) )
       => ( finite_finite @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ H2 @ F3 ) @ A4 ) ) ) ) ).

% finite_finite_vimage_IntI
thf(fact_3118_rel__restrict__Int__empty,axiom,
    ! [A: $tType,A4: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ ( field2 @ A @ R ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( rel_restrict @ A @ R @ A4 )
        = R ) ) ).

% rel_restrict_Int_empty
thf(fact_3119_vimage__eq__UN,axiom,
    ! [B: $tType,A: $tType] :
      ( ( vimage @ A @ B )
      = ( ^ [F2: A > B,B7: set @ B] :
            ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : ( vimage @ A @ B @ F2 @ ( insert2 @ B @ Y2 @ ( bot_bot @ ( set @ B ) ) ) )
              @ B7 ) ) ) ) ).

% vimage_eq_UN
thf(fact_3120_rel__restrict__compl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( rel_restrict @ A @ R @ A4 ) @ ( rel_restrict @ A @ R @ ( uminus_uminus @ ( set @ A ) @ A4 ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% rel_restrict_compl
thf(fact_3121_inf__img__fin__domE_H,axiom,
    ! [A: $tType,B: $tType,F: B > A,A4: set @ B] :
      ( ( finite_finite @ A @ ( image2 @ B @ A @ F @ A4 ) )
     => ( ~ ( finite_finite @ B @ A4 )
       => ~ ! [Y3: A] :
              ( ( member @ A @ Y3 @ ( image2 @ B @ A @ F @ A4 ) )
             => ( finite_finite @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ F @ ( insert2 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) @ A4 ) ) ) ) ) ).

% inf_img_fin_domE'
thf(fact_3122_inf__img__fin__dom_H,axiom,
    ! [A: $tType,B: $tType,F: B > A,A4: set @ B] :
      ( ( finite_finite @ A @ ( image2 @ B @ A @ F @ A4 ) )
     => ( ~ ( finite_finite @ B @ A4 )
       => ? [X2: A] :
            ( ( member @ A @ X2 @ ( image2 @ B @ A @ F @ A4 ) )
            & ~ ( finite_finite @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ F @ ( insert2 @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ A4 ) ) ) ) ) ).

% inf_img_fin_dom'
thf(fact_3123_rel__restrict__alt__def,axiom,
    ! [A: $tType] :
      ( ( rel_restrict @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A ),A10: set @ A] :
            ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R2
            @ ( product_Sigma @ A @ A @ ( uminus_uminus @ ( set @ A ) @ A10 )
              @ ^ [Uu: A] : ( uminus_uminus @ ( set @ A ) @ A10 ) ) ) ) ) ).

% rel_restrict_alt_def
thf(fact_3124_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F: A > B,D4: set @ A,A4: set @ B] :
      ( ( inj_on @ A @ B @ F @ D4 )
     => ( ( finite_finite @ B @ A4 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F @ A4 ) @ D4 ) ) @ ( finite_card @ B @ A4 ) ) ) ) ).

% card_vimage_inj_on_le
thf(fact_3125_Fpow__Pow__finite,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A10: set @ A] : ( inf_inf @ ( set @ ( set @ A ) ) @ ( pow @ A @ A10 ) @ ( collect @ ( set @ A ) @ ( finite_finite @ A ) ) ) ) ) ).

% Fpow_Pow_finite
thf(fact_3126_inj__on__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F: A > B,A4: set @ A,A3: B] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) @ A4 )
        @ ( insert2 @ A
          @ ( the @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ( ( F @ X3 )
                  = A3 ) ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_on_vimage_singleton
thf(fact_3127_inj__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F: A > B,A3: B] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) )
        @ ( insert2 @ A
          @ ( the @ A
            @ ^ [X3: A] :
                ( ( F @ X3 )
                = A3 ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_vimage_singleton
thf(fact_3128_comp__fun__idem__on_Ocomp__comp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set @ A,F: A > B > B,G: C > A,R: set @ C] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image2 @ C @ A @ G @ ( top_top @ ( set @ C ) ) ) @ S2 )
       => ( finite673082921795544331dem_on @ C @ B @ R @ ( comp @ A @ ( B > B ) @ C @ F @ G ) ) ) ) ).

% comp_fun_idem_on.comp_comp_fun_idem_on
thf(fact_3129_ref__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: A] :
          ( hoare_hoare_triple @ ( ref @ A ) @ ( one_one @ assn ) @ ( ref_ref @ A @ X )
          @ ^ [R5: ref @ A] : ( sngr_assn @ A @ R5 @ X ) ) ) ).

% ref_rule
thf(fact_3130_The__split__eq,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( the @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X9: A,Y7: B] :
              ( ( X = X9 )
              & ( Y = Y7 ) ) ) )
      = ( product_Pair @ A @ B @ X @ Y ) ) ).

% The_split_eq
thf(fact_3131_comp__fun__idem__on_Ocomp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B,X: A] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F )
     => ( ( member @ A @ X @ S2 )
       => ( ( comp @ B @ B @ B @ ( F @ X ) @ ( F @ X ) )
          = ( F @ X ) ) ) ) ).

% comp_fun_idem_on.comp_fun_idem_on
thf(fact_3132_empty__in__Fpow,axiom,
    ! [A: $tType,A4: set @ A] : ( member @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( finite_Fpow @ A @ A4 ) ) ).

% empty_in_Fpow
thf(fact_3133_Fpow__not__empty,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_Fpow @ A @ A4 )
     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ).

% Fpow_not_empty
thf(fact_3134_the__elem__def,axiom,
    ! [A: $tType] :
      ( ( the_elem @ A )
      = ( ^ [X8: set @ A] :
            ( the @ A
            @ ^ [X3: A] :
                ( X8
                = ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% the_elem_def
thf(fact_3135_image__o__collect,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: C > B,F3: set @ ( A > ( set @ C ) )] :
      ( ( bNF_collect @ A @ B @ ( image2 @ ( A > ( set @ C ) ) @ ( A > ( set @ B ) ) @ ( comp @ ( set @ C ) @ ( set @ B ) @ A @ ( image2 @ C @ B @ G ) ) @ F3 ) )
      = ( comp @ ( set @ C ) @ ( set @ B ) @ A @ ( image2 @ C @ B @ G ) @ ( bNF_collect @ A @ C @ F3 ) ) ) ).

% image_o_collect
thf(fact_3136_of__list__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [Xs: list @ A] :
          ( hoare_hoare_triple @ ( array @ A ) @ ( one_one @ assn ) @ ( array_of_list @ A @ Xs )
          @ ^ [R5: array @ A] : ( snga_assn @ A @ R5 @ Xs ) ) ) ).

% of_list_rule
thf(fact_3137_INT__simps_I4_J,axiom,
    ! [G3: $tType,H9: $tType,C3: set @ H9,A4: set @ G3,B3: H9 > ( set @ G3 )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ H9 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G3 )
            @ ( image2 @ H9 @ ( set @ G3 )
              @ ^ [X3: H9] : ( minus_minus @ ( set @ G3 ) @ A4 @ ( B3 @ X3 ) )
              @ C3 ) )
          = ( top_top @ ( set @ G3 ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ H9 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G3 )
            @ ( image2 @ H9 @ ( set @ G3 )
              @ ^ [X3: H9] : ( minus_minus @ ( set @ G3 ) @ A4 @ ( B3 @ X3 ) )
              @ C3 ) )
          = ( minus_minus @ ( set @ G3 ) @ A4 @ ( complete_Sup_Sup @ ( set @ G3 ) @ ( image2 @ H9 @ ( set @ G3 ) @ B3 @ C3 ) ) ) ) ) ) ).

% INT_simps(4)
thf(fact_3138_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_0 @ B )
     => ! [F: A > B,G: C > B,A4: set @ A,B3: set @ C] :
          ( ( inj_on @ ( product_prod @ A @ C ) @ B
            @ ( product_case_prod @ A @ C @ B
              @ ^ [A5: A,B4: C] : ( times_times @ B @ ( F @ A5 ) @ ( G @ B4 ) ) )
            @ ( product_Sigma @ A @ C @ A4
              @ ^ [Uu: A] : B3 ) )
         => ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F @ A4 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B3 ) )
            = ( groups7311177749621191930dd_sum @ B @ B @ ( id @ B )
              @ ( collect @ B
                @ ^ [Uu: B] :
                  ? [A5: A,B4: C] :
                    ( ( Uu
                      = ( times_times @ B @ ( F @ A5 ) @ ( G @ B4 ) ) )
                    & ( member @ A @ A5 @ A4 )
                    & ( member @ C @ B4 @ B3 ) ) ) ) ) ) ) ).

% sum_mult_sum_if_inj
thf(fact_3139_card__UNION,axiom,
    ! [A: $tType,A4: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A4 )
     => ( ! [X2: set @ A] :
            ( ( member @ ( set @ A ) @ X2 @ A4 )
           => ( finite_finite @ A @ X2 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A4 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I6: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I6 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I6 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I6: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I6 @ A4 )
                    & ( I6
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_3140_ex__assn__proper,axiom,
    ! [A: $tType,P: A > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ! [X2: A] : ( proper @ ( P @ X2 ) )
     => ( proper
        @ ^ [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ? [X3: A] : ( P @ X3 @ H3 ) ) ) ).

% ex_assn_proper
thf(fact_3141_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A4 )
            = ( bot_bot @ A ) )
          = ( ! [X3: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X3 )
               => ? [Y2: A] :
                    ( ( member @ A @ Y2 @ A4 )
                    & ( ord_less @ A @ Y2 @ X3 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_3142_Inf__empty,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( top_top @ A ) ) ) ).

% Inf_empty
thf(fact_3143_Inf__UNIV,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A @ ( top_top @ ( set @ A ) ) )
        = ( bot_bot @ A ) ) ) ).

% Inf_UNIV
thf(fact_3144_cInf__singleton,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A] :
          ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% cInf_singleton
thf(fact_3145_Inf__insert,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ A3 @ A4 ) )
          = ( inf_inf @ A @ A3 @ ( complete_Inf_Inf @ A @ A4 ) ) ) ) ).

% Inf_insert
thf(fact_3146_Inf__atMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( complete_Inf_Inf @ A @ ( set_ord_atMost @ A @ X ) )
          = ( bot_bot @ A ) ) ) ).

% Inf_atMost
thf(fact_3147_cINF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image2 @ B @ A
                @ ^ [X3: B] : C2
                @ A4 ) )
            = C2 ) ) ) ).

% cINF_const
thf(fact_3148_INF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image2 @ B @ A
                @ ^ [I2: B] : F
                @ A4 ) )
            = F ) ) ) ).

% INF_const
thf(fact_3149_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F: B > A,A4: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) )
            = ( bot_bot @ A ) )
          = ( ! [X3: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X3 )
               => ? [Y2: B] :
                    ( ( member @ B @ Y2 @ A4 )
                    & ( ord_less @ A @ ( F @ Y2 ) @ X3 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_3150_INT__constant,axiom,
    ! [B: $tType,A: $tType,A4: set @ B,C2: set @ A] :
      ( ( ( A4
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Inf_Inf @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : C2
              @ A4 ) )
          = ( top_top @ ( set @ A ) ) ) )
      & ( ( A4
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Inf_Inf @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : C2
              @ A4 ) )
          = C2 ) ) ) ).

% INT_constant
thf(fact_3151_INT__insert,axiom,
    ! [A: $tType,B: $tType,B3: B > ( set @ A ),A3: B,A4: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ ( insert2 @ B @ A3 @ A4 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( B3 @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ A4 ) ) ) ) ).

% INT_insert
thf(fact_3152_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_3153_INT__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set @ D,A4: set @ C,B3: D > ( set @ C )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ D ) ) )
       => ( ( complete_Inf_Inf @ ( set @ C )
            @ ( image2 @ D @ ( set @ C )
              @ ^ [X3: D] : ( inf_inf @ ( set @ C ) @ A4 @ ( B3 @ X3 ) )
              @ C3 ) )
          = ( top_top @ ( set @ C ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ D ) ) )
       => ( ( complete_Inf_Inf @ ( set @ C )
            @ ( image2 @ D @ ( set @ C )
              @ ^ [X3: D] : ( inf_inf @ ( set @ C ) @ A4 @ ( B3 @ X3 ) )
              @ C3 ) )
          = ( inf_inf @ ( set @ C ) @ A4 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image2 @ D @ ( set @ C ) @ B3 @ C3 ) ) ) ) ) ) ).

% INT_simps(2)
thf(fact_3154_INT__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set @ A,A4: A > ( set @ B ),B3: set @ B] :
      ( ( ( C3
          = ( bot_bot @ ( set @ A ) ) )
       => ( ( complete_Inf_Inf @ ( set @ B )
            @ ( image2 @ A @ ( set @ B )
              @ ^ [X3: A] : ( inf_inf @ ( set @ B ) @ ( A4 @ X3 ) @ B3 )
              @ C3 ) )
          = ( top_top @ ( set @ B ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ A ) ) )
       => ( ( complete_Inf_Inf @ ( set @ B )
            @ ( image2 @ A @ ( set @ B )
              @ ^ [X3: A] : ( inf_inf @ ( set @ B ) @ ( A4 @ X3 ) @ B3 )
              @ C3 ) )
          = ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A4 @ C3 ) ) @ B3 ) ) ) ) ).

% INT_simps(1)
thf(fact_3155_INT__simps_I3_J,axiom,
    ! [E: $tType,F9: $tType,C3: set @ E,A4: E > ( set @ F9 ),B3: set @ F9] :
      ( ( ( C3
          = ( bot_bot @ ( set @ E ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F9 )
            @ ( image2 @ E @ ( set @ F9 )
              @ ^ [X3: E] : ( minus_minus @ ( set @ F9 ) @ ( A4 @ X3 ) @ B3 )
              @ C3 ) )
          = ( top_top @ ( set @ F9 ) ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ E ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F9 )
            @ ( image2 @ E @ ( set @ F9 )
              @ ^ [X3: E] : ( minus_minus @ ( set @ F9 ) @ ( A4 @ X3 ) @ B3 )
              @ C3 ) )
          = ( minus_minus @ ( set @ F9 ) @ ( complete_Inf_Inf @ ( set @ F9 ) @ ( image2 @ E @ ( set @ F9 ) @ A4 @ C3 ) ) @ B3 ) ) ) ) ).

% INT_simps(3)
thf(fact_3156_pairself__image__eq,axiom,
    ! [B: $tType,A: $tType,F: B > A,P: B > B > $o] :
      ( ( image2 @ ( product_prod @ B @ B ) @ ( product_prod @ A @ A ) @ ( pairself @ B @ A @ F ) @ ( collect @ ( product_prod @ B @ B ) @ ( product_case_prod @ B @ B @ $o @ P ) ) )
      = ( collect @ ( product_prod @ A @ A )
        @ ^ [Uu: product_prod @ A @ A] :
          ? [A5: B,B4: B] :
            ( ( Uu
              = ( product_Pair @ A @ A @ ( F @ A5 ) @ ( F @ B4 ) ) )
            & ( P @ A5 @ B4 ) ) ) ) ).

% pairself_image_eq
thf(fact_3157_euclidean__size__int__def,axiom,
    ( ( euclid6346220572633701492n_size @ int )
    = ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) ) ).

% euclidean_size_int_def
thf(fact_3158_num__of__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ num @ num
    @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
    @ ^ [Y4: num,Z5: num] : ( Y4 = Z5 )
    @ ( comp @ nat @ num @ int @ num_of_nat @ nat2 )
    @ ( comp @ nat @ num @ int @ num_of_nat @ nat2 ) ) ).

% num_of_integer.rsp
thf(fact_3159_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A4 )
             => ( ord_less_eq @ A @ V4 @ U ) )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ U ) ) ) ) ).

% Inf_less_eq
thf(fact_3160_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A3: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X5 )
               => ( ord_less_eq @ A @ A3 @ X2 ) )
           => ( ! [Y3: A] :
                  ( ! [X6: A] :
                      ( ( member @ A @ X6 @ X5 )
                     => ( ord_less_eq @ A @ Y3 @ X6 ) )
                 => ( ord_less_eq @ A @ Y3 @ A3 ) )
             => ( ( complete_Inf_Inf @ A @ X5 )
                = A3 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_3161_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,Z2: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X5 )
               => ( ord_less_eq @ A @ Z2 @ X2 ) )
           => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ X5 ) ) ) ) ) ).

% cInf_greatest
thf(fact_3162_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,Z2: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X5 ) @ Z2 )
           => ? [X2: A] :
                ( ( member @ A @ X2 @ X5 )
                & ( ord_less @ A @ X2 @ Z2 ) ) ) ) ) ).

% cInf_lessD
thf(fact_3163_INF__eq__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I4: set @ B,F: B > A,X: A] :
          ( ( I4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I4 )
               => ( ( F @ I3 )
                  = X ) )
           => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ I4 ) )
              = X ) ) ) ) ).

% INF_eq_const
thf(fact_3164_bot__finite__def,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ( ( bot_bot @ A )
        = ( complete_Inf_Inf @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% bot_finite_def
thf(fact_3165_sup__Inf,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: A,B3: set @ A] :
          ( ( sup_sup @ A @ A3 @ ( complete_Inf_Inf @ A @ B3 ) )
          = ( complete_Inf_Inf @ A @ ( image2 @ A @ A @ ( sup_sup @ A @ A3 ) @ B3 ) ) ) ) ).

% sup_Inf
thf(fact_3166_INF__image,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( complete_Inf @ A )
     => ! [G: B > A,F: C > B,A4: set @ C] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ ( image2 @ C @ B @ F @ A4 ) ) )
          = ( complete_Inf_Inf @ A @ ( image2 @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A4 ) ) ) ) ).

% INF_image
thf(fact_3167_Inf__sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B3: set @ A,A3: A] :
          ( ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ B3 ) @ A3 )
            = ( top_top @ A ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ B3 )
               => ( ( sup_sup @ A @ X3 @ A3 )
                  = ( top_top @ A ) ) ) ) ) ) ).

% Inf_sup_eq_top_iff
thf(fact_3168_Inf__finite__insert,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ A3 @ A4 ) )
          = ( inf_inf @ A @ A3 @ ( complete_Inf_Inf @ A @ A4 ) ) ) ) ).

% Inf_finite_insert
thf(fact_3169_Inf__union__distrib,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( complete_Inf_Inf @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
          = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B3 ) ) ) ) ).

% Inf_union_distrib
thf(fact_3170_infinite__int__iff__infinite__nat__abs,axiom,
    ! [S2: set @ int] :
      ( ( ~ ( finite_finite @ int @ S2 ) )
      = ( ~ ( finite_finite @ nat @ ( image2 @ int @ nat @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) @ S2 ) ) ) ) ).

% infinite_int_iff_infinite_nat_abs
thf(fact_3171_Inter__subset,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),B3: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A4 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ B3 ) )
     => ( ( A4
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A4 ) @ B3 ) ) ) ).

% Inter_subset
thf(fact_3172_Inter__empty,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% Inter_empty
thf(fact_3173_inj__on__Inter,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( set @ A ),F: A > B] :
      ( ( S2
       != ( bot_bot @ ( set @ ( set @ A ) ) ) )
     => ( ! [A13: set @ A] :
            ( ( member @ ( set @ A ) @ A13 @ S2 )
           => ( inj_on @ A @ B @ F @ A13 ) )
       => ( inj_on @ A @ B @ F @ ( complete_Inf_Inf @ ( set @ A ) @ S2 ) ) ) ) ).

% inj_on_Inter
thf(fact_3174_finite__inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( inf_inf @ A @ A3 @ ( complete_Sup_Sup @ A @ A4 ) )
          = ( complete_Sup_Sup @ A
            @ ( collect @ A
              @ ^ [Uu: A] :
                ? [B4: A] :
                  ( ( Uu
                    = ( inf_inf @ A @ A3 @ B4 ) )
                  & ( member @ A @ B4 @ A4 ) ) ) ) ) ) ).

% finite_inf_Sup
thf(fact_3175_INF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: B > A,A4: set @ B,G: B > A] :
          ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ A4 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [A5: B] : ( inf_inf @ A @ ( F @ A5 ) @ ( G @ A5 ) )
              @ A4 ) ) ) ) ).

% INF_inf_distrib
thf(fact_3176_INF__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [K: B,I4: set @ B,A4: B > A] :
          ( ( member @ B @ K @ I4 )
         => ( ( inf_inf @ A @ ( A4 @ K ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ A4 @ I4 ) ) )
            = ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ A4 @ I4 ) ) ) ) ) ).

% INF_absorb
thf(fact_3177_INF__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F: B > A,B3: set @ B,A3: A] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ B3 ) ) @ A3 )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [B4: B] : ( sup_sup @ A @ ( F @ B4 ) @ A3 )
              @ B3 ) ) ) ) ).

% INF_sup
thf(fact_3178_Inf__sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B3: set @ A,A3: A] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ B3 ) @ A3 )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ A @ A
              @ ^ [B4: A] : ( sup_sup @ A @ B4 @ A3 )
              @ B3 ) ) ) ) ).

% Inf_sup
thf(fact_3179_sup__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: A,F: B > A,B3: set @ B] :
          ( ( sup_sup @ A @ A3 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ B3 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [B4: B] : ( sup_sup @ A @ A3 @ ( F @ B4 ) )
              @ B3 ) ) ) ) ).

% sup_INF
thf(fact_3180_INF__sup__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F: B > A,A4: set @ B,G: C > A,B3: set @ C] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ C @ A @ G @ B3 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [A5: B] :
                  ( complete_Inf_Inf @ A
                  @ ( image2 @ C @ A
                    @ ^ [B4: C] : ( sup_sup @ A @ ( F @ A5 ) @ ( G @ B4 ) )
                    @ B3 ) )
              @ A4 ) ) ) ) ).

% INF_sup_distrib2
thf(fact_3181_Inter__insert,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( insert2 @ ( set @ A ) @ A3 @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( complete_Inf_Inf @ ( set @ A ) @ B3 ) ) ) ).

% Inter_insert
thf(fact_3182_Id__def,axiom,
    ! [A: $tType] :
      ( ( id2 @ A )
      = ( collect @ ( product_prod @ A @ A )
        @ ^ [P6: product_prod @ A @ A] :
          ? [X3: A] :
            ( P6
            = ( product_Pair @ A @ A @ X3 @ X3 ) ) ) ) ).

% Id_def
thf(fact_3183_Inter__UNIV,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( top_top @ ( set @ ( set @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Inter_UNIV
thf(fact_3184_Inter__Un__distrib,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),B3: set @ ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ A4 @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A4 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B3 ) ) ) ).

% Inter_Un_distrib
thf(fact_3185_Int__Inter__image,axiom,
    ! [A: $tType,B: $tType,A4: B > ( set @ A ),B3: B > ( set @ A ),C3: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X3: B] : ( inf_inf @ ( set @ A ) @ ( A4 @ X3 ) @ ( B3 @ X3 ) )
          @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A4 @ C3 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ C3 ) ) ) ) ).

% Int_Inter_image
thf(fact_3186_INT__Int__distrib,axiom,
    ! [A: $tType,B: $tType,A4: B > ( set @ A ),B3: B > ( set @ A ),I4: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I2: B] : ( inf_inf @ ( set @ A ) @ ( A4 @ I2 ) @ ( B3 @ I2 ) )
          @ I4 ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A4 @ I4 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ I4 ) ) ) ) ).

% INT_Int_distrib
thf(fact_3187_INT__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I4: set @ A,A4: A > ( set @ B )] :
      ( ( member @ A @ K @ I4 )
     => ( ( inf_inf @ ( set @ B ) @ ( A4 @ K ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A4 @ I4 ) ) )
        = ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A4 @ I4 ) ) ) ) ).

% INT_absorb
thf(fact_3188_INT__bool__eq,axiom,
    ! [A: $tType,A4: $o > ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ $o @ ( set @ A ) @ A4 @ ( top_top @ ( set @ $o ) ) ) )
      = ( inf_inf @ ( set @ A ) @ ( A4 @ $true ) @ ( A4 @ $false ) ) ) ).

% INT_bool_eq
thf(fact_3189_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I4: set @ B,F: B > A,C2: A] :
          ( ( I4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I4 )
               => ( ord_less_eq @ A @ ( F @ I3 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ I4 ) )
                = C2 )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ I4 )
                   => ( ( F @ X3 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_3190_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,M4: A,F: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ A4 )
               => ( ord_less_eq @ A @ M4 @ ( F @ X2 ) ) )
           => ( ord_less_eq @ A @ M4 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_3191_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,A3: A] :
          ( ( finite_finite @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A3 @ ( complete_Inf_Inf @ A @ X5 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ X5 )
                   => ( ord_less @ A @ A3 @ X3 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_3192_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ).

% Inf_le_Sup
thf(fact_3193_finite__Inf__in,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X2: A,Y3: A] :
                  ( ( member @ A @ X2 @ A4 )
                 => ( ( member @ A @ Y3 @ A4 )
                   => ( member @ A @ ( inf_inf @ A @ X2 @ Y3 ) @ A4 ) ) )
             => ( member @ A @ ( complete_Inf_Inf @ A @ A4 ) @ A4 ) ) ) ) ) ).

% finite_Inf_in
thf(fact_3194_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A3: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ A3 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S2 ) ) @ A3 ) ) ) ) ).

% cInf_abs_ge
thf(fact_3195_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B3: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B3 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_3196_Inf__finite__empty,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ( ( complete_Inf_Inf @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( complete_Sup_Sup @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% Inf_finite_empty
thf(fact_3197_Sup__finite__empty,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ( ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( complete_Inf_Inf @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% Sup_finite_empty
thf(fact_3198_inf__Inf__fold__inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B3: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A4 ) @ B3 )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ B3 @ A4 ) ) ) ) ).

% inf_Inf_fold_inf
thf(fact_3199_Inf__fin__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ A4 )
              = ( complete_Inf_Inf @ A @ A4 ) ) ) ) ) ).

% Inf_fin_Inf
thf(fact_3200_cInf__eq__Inf__fin,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A] :
          ( ( finite_finite @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Inf_Inf @ A @ X5 )
              = ( lattic7752659483105999362nf_fin @ A @ X5 ) ) ) ) ) ).

% cInf_eq_Inf_fin
thf(fact_3201_INT__greaterThan__UNIV,axiom,
    ( ( complete_Inf_Inf @ ( set @ nat ) @ ( image2 @ nat @ ( set @ nat ) @ ( set_ord_greaterThan @ nat ) @ ( top_top @ ( set @ nat ) ) ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% INT_greaterThan_UNIV
thf(fact_3202_INF__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: B > A] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) ) )
          = ( top_top @ A ) ) ) ).

% INF_empty
thf(fact_3203_INF__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( ( A4
              = ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Inf_Inf @ A
                @ ( image2 @ B @ A
                  @ ^ [Y2: B] : C2
                  @ A4 ) )
              = ( top_top @ A ) ) )
          & ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Inf_Inf @ A
                @ ( image2 @ B @ A
                  @ ^ [Y2: B] : C2
                  @ A4 ) )
              = C2 ) ) ) ) ).

% INF_constant
thf(fact_3204_INF__inf__const2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I4: set @ B,F: B > A,X: A] :
          ( ( I4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image2 @ B @ A
                @ ^ [I2: B] : ( inf_inf @ A @ ( F @ I2 ) @ X )
                @ I4 ) )
            = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ I4 ) ) @ X ) ) ) ) ).

% INF_inf_const2
thf(fact_3205_INF__inf__const1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I4: set @ B,X: A,F: B > A] :
          ( ( I4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image2 @ B @ A
                @ ^ [I2: B] : ( inf_inf @ A @ X @ ( F @ I2 ) )
                @ I4 ) )
            = ( inf_inf @ A @ X @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ I4 ) ) ) ) ) ) ).

% INF_inf_const1
thf(fact_3206_INF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: B > A,A3: B,A4: set @ B] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ ( insert2 @ B @ A3 @ A4 ) ) )
          = ( inf_inf @ A @ ( F @ A3 ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) ) ) ) ).

% INF_insert
thf(fact_3207_INF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [M: B > A,A4: set @ B,B3: set @ B] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ M @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) )
          = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ M @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ M @ B3 ) ) ) ) ) ).

% INF_union
thf(fact_3208_relcomp__unfold,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcomp @ A @ C @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ C ),S6: set @ ( product_prod @ C @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [X3: A,Z4: B] :
                ? [Y2: C] :
                  ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X3 @ Y2 ) @ R5 )
                  & ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y2 @ Z4 ) @ S6 ) ) ) ) ) ) ).

% relcomp_unfold
thf(fact_3209_INT__empty,axiom,
    ! [B: $tType,A: $tType,B3: B > ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ ( bot_bot @ ( set @ B ) ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% INT_empty
thf(fact_3210_INT__extend__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set @ D,A4: set @ C,B3: D > ( set @ C )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ D ) ) )
       => ( ( inf_inf @ ( set @ C ) @ A4 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image2 @ D @ ( set @ C ) @ B3 @ C3 ) ) )
          = A4 ) )
      & ( ( C3
         != ( bot_bot @ ( set @ D ) ) )
       => ( ( inf_inf @ ( set @ C ) @ A4 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image2 @ D @ ( set @ C ) @ B3 @ C3 ) ) )
          = ( complete_Inf_Inf @ ( set @ C )
            @ ( image2 @ D @ ( set @ C )
              @ ^ [X3: D] : ( inf_inf @ ( set @ C ) @ A4 @ ( B3 @ X3 ) )
              @ C3 ) ) ) ) ) ).

% INT_extend_simps(2)
thf(fact_3211_INT__extend__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,C3: set @ A,A4: A > ( set @ B ),B3: set @ B] :
      ( ( ( C3
          = ( bot_bot @ ( set @ A ) ) )
       => ( ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A4 @ C3 ) ) @ B3 )
          = B3 ) )
      & ( ( C3
         != ( bot_bot @ ( set @ A ) ) )
       => ( ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A4 @ C3 ) ) @ B3 )
          = ( complete_Inf_Inf @ ( set @ B )
            @ ( image2 @ A @ ( set @ B )
              @ ^ [X3: A] : ( inf_inf @ ( set @ B ) @ ( A4 @ X3 ) @ B3 )
              @ C3 ) ) ) ) ) ).

% INT_extend_simps(1)
thf(fact_3212_inj__on__INTER,axiom,
    ! [C: $tType,B: $tType,A: $tType,I4: set @ A,F: B > C,A4: A > ( set @ B )] :
      ( ( I4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I4 )
           => ( inj_on @ B @ C @ F @ ( A4 @ I3 ) ) )
       => ( inj_on @ B @ C @ F @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A4 @ I4 ) ) ) ) ) ).

% inj_on_INTER
thf(fact_3213_INT__Un,axiom,
    ! [A: $tType,B: $tType,M: B > ( set @ A ),A4: set @ B,B3: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ A4 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ B3 ) ) ) ) ).

% INT_Un
thf(fact_3214_Inter__Un__subset,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),B3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A4 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B3 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A4 @ B3 ) ) ) ).

% Inter_Un_subset
thf(fact_3215_Gcd__int__def,axiom,
    ( ( gcd_Gcd @ int )
    = ( ^ [K6: set @ int] : ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ ( image2 @ int @ nat @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) @ K6 ) ) ) ) ) ).

% Gcd_int_def
thf(fact_3216_Int__Inter__eq_I1_J,axiom,
    ! [A: $tType,B13: set @ ( set @ A ),A4: set @ A] :
      ( ( ( B13
          = ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ A4 @ ( complete_Inf_Inf @ ( set @ A ) @ B13 ) )
          = A4 ) )
      & ( ( B13
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ A4 @ ( complete_Inf_Inf @ ( set @ A ) @ B13 ) )
          = ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 ) @ B13 ) ) ) ) ) ).

% Int_Inter_eq(1)
thf(fact_3217_Int__Inter__eq_I2_J,axiom,
    ! [A: $tType,B13: set @ ( set @ A ),A4: set @ A] :
      ( ( ( B13
          = ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ B13 ) @ A4 )
          = A4 ) )
      & ( ( B13
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ B13 ) @ A4 )
          = ( complete_Inf_Inf @ ( set @ A )
            @ ( image2 @ ( set @ A ) @ ( set @ A )
              @ ^ [B7: set @ A] : ( inf_inf @ ( set @ A ) @ B7 @ A4 )
              @ B13 ) ) ) ) ) ).

% Int_Inter_eq(2)
thf(fact_3218_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_3219_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S2 ) @ L ) ) @ E2 ) ) ) ) ).

% cInf_asclose
thf(fact_3220_Inf__insert__finite,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A,X: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ X @ S2 ) )
                = X ) )
            & ( ( S2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ X @ S2 ) )
                = ( ord_min @ A @ X @ ( complete_Inf_Inf @ A @ S2 ) ) ) ) ) ) ) ).

% Inf_insert_finite
thf(fact_3221_Inf__fold__inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( complete_Inf_Inf @ A @ A4 )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ A4 ) ) ) ) ).

% Inf_fold_inf
thf(fact_3222_collect__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: set @ ( C > ( set @ B ) ),G: A > C] :
      ( ( comp @ C @ ( set @ B ) @ A @ ( bNF_collect @ C @ B @ F3 ) @ G )
      = ( bNF_collect @ A @ B
        @ ( image2 @ ( C > ( set @ B ) ) @ ( A > ( set @ B ) )
          @ ^ [F2: C > ( set @ B )] : ( comp @ C @ ( set @ B ) @ A @ F2 @ G )
          @ F3 ) ) ) ).

% collect_comp
thf(fact_3223_INF__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: $o > A] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ $o @ A @ A4 @ ( top_top @ ( set @ $o ) ) ) )
          = ( inf_inf @ A @ ( A4 @ $true ) @ ( A4 @ $false ) ) ) ) ).

% INF_UNIV_bool_expand
thf(fact_3224_inf__Sup2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ( B3
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( inf_inf @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ B3 ) )
                  = ( lattic5882676163264333800up_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu: A] :
                        ? [A5: A,B4: A] :
                          ( ( Uu
                            = ( inf_inf @ A @ A5 @ B4 ) )
                          & ( member @ A @ A5 @ A4 )
                          & ( member @ A @ B4 @ B3 ) ) ) ) ) ) ) ) ) ) ).

% inf_Sup2_distrib
thf(fact_3225_inf__Sup1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( inf_inf @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
              = ( lattic5882676163264333800up_fin @ A
                @ ( collect @ A
                  @ ^ [Uu: A] :
                    ? [A5: A] :
                      ( ( Uu
                        = ( inf_inf @ A @ X @ A5 ) )
                      & ( member @ A @ A5 @ A4 ) ) ) ) ) ) ) ) ).

% inf_Sup1_distrib
thf(fact_3226_sup__Inf1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( sup_sup @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
              = ( lattic7752659483105999362nf_fin @ A
                @ ( collect @ A
                  @ ^ [Uu: A] :
                    ? [A5: A] :
                      ( ( Uu
                        = ( sup_sup @ A @ X @ A5 ) )
                      & ( member @ A @ A5 @ A4 ) ) ) ) ) ) ) ) ).

% sup_Inf1_distrib
thf(fact_3227_sup__Inf2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ( B3
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ ( lattic7752659483105999362nf_fin @ A @ B3 ) )
                  = ( lattic7752659483105999362nf_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu: A] :
                        ? [A5: A,B4: A] :
                          ( ( Uu
                            = ( sup_sup @ A @ A5 @ B4 ) )
                          & ( member @ A @ A5 @ A4 )
                          & ( member @ A @ B4 @ B3 ) ) ) ) ) ) ) ) ) ) ).

% sup_Inf2_distrib
thf(fact_3228_INT__extend__simps_I3_J,axiom,
    ! [F9: $tType,E: $tType,C3: set @ E,A4: E > ( set @ F9 ),B3: set @ F9] :
      ( ( ( C3
          = ( bot_bot @ ( set @ E ) ) )
       => ( ( minus_minus @ ( set @ F9 ) @ ( complete_Inf_Inf @ ( set @ F9 ) @ ( image2 @ E @ ( set @ F9 ) @ A4 @ C3 ) ) @ B3 )
          = ( minus_minus @ ( set @ F9 ) @ ( top_top @ ( set @ F9 ) ) @ B3 ) ) )
      & ( ( C3
         != ( bot_bot @ ( set @ E ) ) )
       => ( ( minus_minus @ ( set @ F9 ) @ ( complete_Inf_Inf @ ( set @ F9 ) @ ( image2 @ E @ ( set @ F9 ) @ A4 @ C3 ) ) @ B3 )
          = ( complete_Inf_Inf @ ( set @ F9 )
            @ ( image2 @ E @ ( set @ F9 )
              @ ^ [X3: E] : ( minus_minus @ ( set @ F9 ) @ ( A4 @ X3 ) @ B3 )
              @ C3 ) ) ) ) ) ).

% INT_extend_simps(3)
thf(fact_3229_INT__extend__simps_I4_J,axiom,
    ! [G3: $tType,H9: $tType,C3: set @ H9,A4: set @ G3,B3: H9 > ( set @ G3 )] :
      ( ( ( C3
          = ( bot_bot @ ( set @ H9 ) ) )
       => ( ( minus_minus @ ( set @ G3 ) @ A4 @ ( complete_Sup_Sup @ ( set @ G3 ) @ ( image2 @ H9 @ ( set @ G3 ) @ B3 @ C3 ) ) )
          = A4 ) )
      & ( ( C3
         != ( bot_bot @ ( set @ H9 ) ) )
       => ( ( minus_minus @ ( set @ G3 ) @ A4 @ ( complete_Sup_Sup @ ( set @ G3 ) @ ( image2 @ H9 @ ( set @ G3 ) @ B3 @ C3 ) ) )
          = ( complete_Inf_Inf @ ( set @ G3 )
            @ ( image2 @ H9 @ ( set @ G3 )
              @ ^ [X3: H9] : ( minus_minus @ ( set @ G3 ) @ A4 @ ( B3 @ X3 ) )
              @ C3 ) ) ) ) ) ).

% INT_extend_simps(4)
thf(fact_3230_inf__INF__fold__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,B3: A,F: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( inf_inf @ A @ B3 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) )
            = ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F ) @ B3 @ A4 ) ) ) ) ).

% inf_INF_fold_inf
thf(fact_3231_INF__fold__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) )
            = ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F ) @ ( top_top @ A ) @ A4 ) ) ) ) ).

% INF_fold_inf
thf(fact_3232_brk__rel__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( brk_rel @ A @ B )
      = ( ^ [R2: set @ ( product_prod @ A @ B )] :
            ( sup_sup @ ( set @ ( product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) ) )
            @ ( collect @ ( product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) )
              @ ^ [Uu: product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B )] :
                ? [X3: A,Y2: B] :
                  ( ( Uu
                    = ( product_Pair @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) @ ( product_Pair @ $o @ A @ $false @ X3 ) @ ( product_Pair @ $o @ B @ $false @ Y2 ) ) )
                  & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R2 ) ) )
            @ ( collect @ ( product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) )
              @ ^ [Uu: product_prod @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B )] :
                ? [X3: A,Y2: B] :
                  ( Uu
                  = ( product_Pair @ ( product_prod @ $o @ A ) @ ( product_prod @ $o @ B ) @ ( product_Pair @ $o @ A @ $true @ X3 ) @ ( product_Pair @ $o @ B @ $false @ Y2 ) ) ) ) ) ) ) ).

% brk_rel_def
thf(fact_3233_image2__def,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( bNF_Greatest_image2 @ C @ A @ B )
      = ( ^ [A10: set @ C,F2: C > A,G2: C > B] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu: product_prod @ A @ B] :
              ? [A5: C] :
                ( ( Uu
                  = ( product_Pair @ A @ B @ ( F2 @ A5 ) @ ( G2 @ A5 ) ) )
                & ( member @ C @ A5 @ A10 ) ) ) ) ) ).

% image2_def
thf(fact_3234_card__quotient__disjoint,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ A @ A4 )
     => ( ( inj_on @ A @ ( set @ ( set @ A ) )
          @ ^ [X3: A] : ( equiv_quotient @ A @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) @ R4 )
          @ A4 )
       => ( ( finite_card @ ( set @ A ) @ ( equiv_quotient @ A @ A4 @ R4 ) )
          = ( finite_card @ A @ A4 ) ) ) ) ).

% card_quotient_disjoint
thf(fact_3235_Preorder__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( order_preorder_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( order_preorder_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A4
              @ ^ [Uu: A] : A4 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) ) ) ).

% Preorder_Restr
thf(fact_3236_mod__h__bot__iff_I8_J,axiom,
    ! [C: $tType,R: C > assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( ex_assn @ C @ R ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ? [X3: C] : ( rep_assn @ ( R @ X3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(8)
thf(fact_3237_ex__assn__const,axiom,
    ! [A: $tType,C2: assn] :
      ( ( ex_assn @ A
        @ ^ [X3: A] : C2 )
      = C2 ) ).

% ex_assn_const
thf(fact_3238_subset__mset_OcInf__singleton,axiom,
    ! [A: $tType,X: multiset @ A] :
      ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
      = X ) ).

% subset_mset.cInf_singleton
thf(fact_3239_subset__mset_OcINF__const,axiom,
    ! [B: $tType,A: $tType,A4: set @ B,C2: multiset @ A] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( complete_Inf_Inf @ ( multiset @ A )
          @ ( image2 @ B @ ( multiset @ A )
            @ ^ [X3: B] : C2
            @ A4 ) )
        = C2 ) ) ).

% subset_mset.cINF_const
thf(fact_3240_mod__ex__dist,axiom,
    ! [A: $tType,P: A > assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( ex_assn @ A @ P ) @ H2 )
      = ( ? [X3: A] : ( rep_assn @ ( P @ X3 ) @ H2 ) ) ) ).

% mod_ex_dist
thf(fact_3241_triv__exI,axiom,
    ! [A: $tType,Q: A > assn,X: A] : ( entails @ ( Q @ X ) @ ( ex_assn @ A @ Q ) ) ).

% triv_exI
thf(fact_3242_Inf__nat__def1,axiom,
    ! [K5: set @ nat] :
      ( ( K5
       != ( bot_bot @ ( set @ nat ) ) )
     => ( member @ nat @ ( complete_Inf_Inf @ nat @ K5 ) @ K5 ) ) ).

% Inf_nat_def1
thf(fact_3243_ex__one__point__gen,axiom,
    ! [A: $tType,P: A > assn,V: A] :
      ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),X2: A] :
          ( ( rep_assn @ ( P @ X2 ) @ H )
         => ( X2 = V ) )
     => ( ( ex_assn @ A @ P )
        = ( P @ V ) ) ) ).

% ex_one_point_gen
thf(fact_3244_mod__exI,axiom,
    ! [A: $tType,P: A > assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ? [X6: A] : ( rep_assn @ ( P @ X6 ) @ H2 )
     => ( rep_assn @ ( ex_assn @ A @ P ) @ H2 ) ) ).

% mod_exI
thf(fact_3245_mod__exE,axiom,
    ! [A: $tType,P: A > assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( ex_assn @ A @ P ) @ H2 )
     => ~ ! [X2: A] :
            ~ ( rep_assn @ ( P @ X2 ) @ H2 ) ) ).

% mod_exE
thf(fact_3246_Inf__multiset__empty,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
      = ( zero_zero @ ( multiset @ A ) ) ) ).

% Inf_multiset_empty
thf(fact_3247_ex__distrib__star,axiom,
    ! [A: $tType,P: A > assn,Q: assn] :
      ( ( ex_assn @ A
        @ ^ [X3: A] : ( times_times @ assn @ ( P @ X3 ) @ Q ) )
      = ( times_times @ assn @ ( ex_assn @ A @ P ) @ Q ) ) ).

% ex_distrib_star
thf(fact_3248_post__exI__rule,axiom,
    ! [B: $tType,A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > B > assn,X: B] :
      ( ( hoare_hoare_triple @ A @ P @ C2
        @ ^ [R5: A] : ( Q @ R5 @ X ) )
     => ( hoare_hoare_triple @ A @ P @ C2
        @ ^ [R5: A] : ( ex_assn @ B @ ( Q @ R5 ) ) ) ) ).

% post_exI_rule
thf(fact_3249_norm__pre__ex__rule,axiom,
    ! [A: $tType,B: $tType,P: A > assn,F: heap_Time_Heap @ B,Q: B > assn] :
      ( ! [X2: A] : ( hoare_hoare_triple @ B @ ( P @ X2 ) @ F @ Q )
     => ( hoare_hoare_triple @ B @ ( ex_assn @ A @ P ) @ F @ Q ) ) ).

% norm_pre_ex_rule
thf(fact_3250_ent__ex__postI,axiom,
    ! [A: $tType,P: assn,Q: A > assn,X: A] :
      ( ( entails @ P @ ( Q @ X ) )
     => ( entails @ P @ ( ex_assn @ A @ Q ) ) ) ).

% ent_ex_postI
thf(fact_3251_ent__ex__preI,axiom,
    ! [A: $tType,P: A > assn,Q: assn] :
      ( ! [X2: A] : ( entails @ ( P @ X2 ) @ Q )
     => ( entails @ ( ex_assn @ A @ P ) @ Q ) ) ).

% ent_ex_preI
thf(fact_3252_ex__join__or,axiom,
    ! [A: $tType,P: A > assn,Q: A > assn] :
      ( ( ex_assn @ A
        @ ^ [X3: A] : ( sup_sup @ assn @ ( P @ X3 ) @ ( ex_assn @ A @ Q ) ) )
      = ( ex_assn @ A
        @ ^ [X3: A] : ( sup_sup @ assn @ ( P @ X3 ) @ ( Q @ X3 ) ) ) ) ).

% ex_join_or
thf(fact_3253_ex__distrib__or,axiom,
    ! [A: $tType,P: A > assn,Q: assn] :
      ( ( ex_assn @ A
        @ ^ [X3: A] : ( sup_sup @ assn @ ( P @ X3 ) @ Q ) )
      = ( sup_sup @ assn @ ( ex_assn @ A @ P ) @ Q ) ) ).

% ex_distrib_or
thf(fact_3254_INF__filter__not__bot,axiom,
    ! [I5: $tType,A: $tType,B3: set @ I5,F3: I5 > ( filter @ A )] :
      ( ! [X10: set @ I5] :
          ( ( ord_less_eq @ ( set @ I5 ) @ X10 @ B3 )
         => ( ( finite_finite @ I5 @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image2 @ I5 @ ( filter @ A ) @ F3 @ X10 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image2 @ I5 @ ( filter @ A ) @ F3 @ B3 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_3255_ex__distrib__and,axiom,
    ! [A: $tType,P: A > assn,Q: assn] :
      ( ( ex_assn @ A
        @ ^ [X3: A] : ( inf_inf @ assn @ ( P @ X3 ) @ Q ) )
      = ( inf_inf @ assn @ ( ex_assn @ A @ P ) @ Q ) ) ).

% ex_distrib_and
thf(fact_3256_INF__Int__eq2,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image2 @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I2: set @ ( product_prod @ A @ B ),X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ I2 )
          @ S2 ) )
      = ( ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ S2 ) ) ) ) ).

% INF_Int_eq2
thf(fact_3257_INF__INT__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: C > ( set @ ( product_prod @ A @ B ) ),S2: set @ C] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image2 @ C @ ( A > B > $o )
          @ ^ [I2: C,X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( R4 @ I2 ) )
          @ S2 ) )
      = ( ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ C @ ( set @ ( product_prod @ A @ B ) ) @ R4 @ S2 ) ) ) ) ) ).

% INF_INT_eq2
thf(fact_3258_image2__eqI,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: A,F: B > A,X: B,C2: C,G: B > C,A4: set @ B] :
      ( ( B2
        = ( F @ X ) )
     => ( ( C2
          = ( G @ X ) )
       => ( ( member @ B @ X @ A4 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B2 @ C2 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A4 @ F @ G ) ) ) ) ) ).

% image2_eqI
thf(fact_3259_preorder__on__empty,axiom,
    ! [A: $tType] : ( order_preorder_on @ A @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% preorder_on_empty
thf(fact_3260_ex__assn__def,axiom,
    ! [A: $tType] :
      ( ( ex_assn @ A )
      = ( ^ [P3: A > assn] :
            ( abs_assn
            @ ^ [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ? [X3: A] : ( rep_assn @ ( P3 @ X3 ) @ H3 ) ) ) ) ).

% ex_assn_def
thf(fact_3261_Inf__INT__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Inf_Inf @ ( A > B > $o ) )
      = ( ^ [S7: set @ ( A > B > $o ),X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image2 @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S7 ) ) ) ) ) ) ).

% Inf_INT_eq2
thf(fact_3262_quotient__is__empty2,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( ( bot_bot @ ( set @ ( set @ A ) ) )
        = ( equiv_quotient @ A @ A4 @ R4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% quotient_is_empty2
thf(fact_3263_quotient__is__empty,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( ( equiv_quotient @ A @ A4 @ R4 )
        = ( bot_bot @ ( set @ ( set @ A ) ) ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% quotient_is_empty
thf(fact_3264_quotient__empty,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( equiv_quotient @ A @ ( bot_bot @ ( set @ A ) ) @ R4 )
      = ( bot_bot @ ( set @ ( set @ A ) ) ) ) ).

% quotient_empty
thf(fact_3265_quotient__diff1,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,A3: A] :
      ( ( inj_on @ A @ ( set @ ( set @ A ) )
        @ ^ [A5: A] : ( equiv_quotient @ A @ ( insert2 @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) @ R4 )
        @ A4 )
     => ( ( member @ A @ A3 @ A4 )
       => ( ( equiv_quotient @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) @ R4 )
          = ( minus_minus @ ( set @ ( set @ A ) ) @ ( equiv_quotient @ A @ A4 @ R4 ) @ ( equiv_quotient @ A @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) @ R4 ) ) ) ) ) ).

% quotient_diff1
thf(fact_3266_Gcd__eq__Max,axiom,
    ! [M: set @ nat] :
      ( ( finite_finite @ nat @ M )
     => ( ( M
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( gcd_Gcd @ nat @ M )
            = ( lattic643756798349783984er_Max @ nat
              @ ( complete_Inf_Inf @ ( set @ nat )
                @ ( image2 @ nat @ ( set @ nat )
                  @ ^ [M3: nat] :
                      ( collect @ nat
                      @ ^ [D5: nat] : ( dvd_dvd @ nat @ D5 @ M3 ) )
                  @ M ) ) ) ) ) ) ) ).

% Gcd_eq_Max
thf(fact_3267_Max__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Max_singleton
thf(fact_3268_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                   => ( ord_less_eq @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Max.bounded_iff
thf(fact_3269_Max__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                   => ( ord_less @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Max_less_iff
thf(fact_3270_Max__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image2 @ B @ A
                  @ ^ [Uu: B] : C2
                  @ A4 ) )
              = C2 ) ) ) ) ).

% Max_const
thf(fact_3271_INF__filter__bot__base,axiom,
    ! [B: $tType,A: $tType,I4: set @ A,F3: A > ( filter @ B )] :
      ( ! [I3: A] :
          ( ( member @ A @ I3 @ I4 )
         => ! [J3: A] :
              ( ( member @ A @ J3 @ I4 )
             => ? [X6: A] :
                  ( ( member @ A @ X6 @ I4 )
                  & ( ord_less_eq @ ( filter @ B ) @ ( F3 @ X6 ) @ ( inf_inf @ ( filter @ B ) @ ( F3 @ I3 ) @ ( F3 @ J3 ) ) ) ) ) )
     => ( ( ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ A @ ( filter @ B ) @ F3 @ I4 ) )
          = ( bot_bot @ ( filter @ B ) ) )
        = ( ? [X3: A] :
              ( ( member @ A @ X3 @ I4 )
              & ( ( F3 @ X3 )
                = ( bot_bot @ ( filter @ B ) ) ) ) ) ) ) ).

% INF_filter_bot_base
thf(fact_3272_Inf__filter__not__bot,axiom,
    ! [A: $tType,B3: set @ ( filter @ A )] :
      ( ! [X10: set @ ( filter @ A )] :
          ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X10 @ B3 )
         => ( ( finite_finite @ ( filter @ A ) @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ X10 )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ B3 )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% Inf_filter_not_bot
thf(fact_3273_Max__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ A4 ) ) ) ) ).

% Max_in
thf(fact_3274_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A8: A] :
                  ( ( member @ A @ A8 @ A4 )
                 => ( ord_less_eq @ A @ A8 @ X ) )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X ) ) ) ) ) ).

% Max.boundedI
thf(fact_3275_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X )
             => ! [A14: A] :
                  ( ( member @ A @ A14 @ A4 )
                 => ( ord_less_eq @ A @ A14 @ X ) ) ) ) ) ) ).

% Max.boundedE
thf(fact_3276_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M4: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M4
                = ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( ( member @ A @ M4 @ A4 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                   => ( ord_less_eq @ A @ X3 @ M4 ) ) ) ) ) ) ) ).

% eq_Max_iff
thf(fact_3277_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                    & ( ord_less_eq @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Max_ge_iff
thf(fact_3278_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M4: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798349783984er_Max @ A @ A4 )
                = M4 )
              = ( ( member @ A @ M4 @ A4 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                   => ( ord_less_eq @ A @ X3 @ M4 ) ) ) ) ) ) ) ).

% Max_eq_iff
thf(fact_3279_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                    & ( ord_less @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Max_gr_iff
thf(fact_3280_cSup__eq__Max,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A] :
          ( ( finite_finite @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Sup_Sup @ A @ X5 )
              = ( lattic643756798349783984er_Max @ A @ X5 ) ) ) ) ) ).

% cSup_eq_Max
thf(fact_3281_Max__Sup,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ A4 )
              = ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% Max_Sup
thf(fact_3282_Sup__nat__def,axiom,
    ( ( complete_Sup_Sup @ nat )
    = ( ^ [X8: set @ nat] :
          ( if @ nat
          @ ( X8
            = ( bot_bot @ ( set @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat @ X8 ) ) ) ) ).

% Sup_nat_def
thf(fact_3283_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ ( lattic643756798349783984er_Max @ A @ B3 ) ) ) ) ) ) ).

% Max.subset_imp
thf(fact_3284_Max__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: set @ A,N4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M @ N4 )
         => ( ( M
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N4 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ M ) @ ( lattic643756798349783984er_Max @ A @ N4 ) ) ) ) ) ) ).

% Max_mono
thf(fact_3285_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F: B > A,K: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image2 @ B @ A
                  @ ^ [X3: B] : ( plus_plus @ A @ ( F @ X3 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798349783984er_Max @ A @ ( image2 @ B @ A @ F @ S2 ) ) @ K ) ) ) ) ) ).

% Max_add_commute
thf(fact_3286_measure__function__int,axiom,
    fun_is_measure @ int @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) ).

% measure_function_int
thf(fact_3287_minus__Max__eq__Min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798349783984er_Max @ A @ S2 ) )
              = ( lattic643756798350308766er_Min @ A @ ( image2 @ A @ A @ ( uminus_uminus @ A ) @ S2 ) ) ) ) ) ) ).

% minus_Max_eq_Min
thf(fact_3288_minus__Min__eq__Max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798350308766er_Min @ A @ S2 ) )
              = ( lattic643756798349783984er_Max @ A @ ( image2 @ A @ A @ ( uminus_uminus @ A ) @ S2 ) ) ) ) ) ) ).

% minus_Min_eq_Max
thf(fact_3289_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F: A > B > B,A4: set @ A,Z2: B,Y: B,A3: A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ S2 )
       => ( ( finite_fold_graph @ A @ B @ F @ Z2 @ A4 @ Y )
         => ( ( member @ A @ A3 @ A4 )
           => ? [Y9: B] :
                ( ( Y
                  = ( F @ A3 @ Y9 ) )
                & ( finite_fold_graph @ A @ B @ F @ Z2 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) @ Y9 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
thf(fact_3290_Image__fold,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ A] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ R )
     => ( ( image @ A @ B @ R @ S2 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ B )
          @ ( product_case_prod @ A @ B @ ( ( set @ B ) > ( set @ B ) )
            @ ^ [X3: A,Y2: B,A10: set @ B] : ( if @ ( set @ B ) @ ( member @ A @ X3 @ S2 ) @ ( insert2 @ B @ Y2 @ A10 ) @ A10 ) )
          @ ( bot_bot @ ( set @ B ) )
          @ R ) ) ) ).

% Image_fold
thf(fact_3291_ImageI,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,R4: set @ ( product_prod @ A @ B ),A4: set @ A] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ R4 )
     => ( ( member @ A @ A3 @ A4 )
       => ( member @ B @ B2 @ ( image @ A @ B @ R4 @ A4 ) ) ) ) ).

% ImageI
thf(fact_3292_Image__empty2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ B @ A )] :
      ( ( image @ B @ A @ R @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Image_empty2
thf(fact_3293_Min__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Min_singleton
thf(fact_3294_Image__empty1,axiom,
    ! [B: $tType,A: $tType,X5: set @ B] :
      ( ( image @ B @ A @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) @ X5 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Image_empty1
thf(fact_3295_Image__Id__on,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( image @ A @ A @ ( id_on @ A @ A4 ) @ B3 )
      = ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ).

% Image_Id_on
thf(fact_3296_Image__singleton__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,R4: set @ ( product_prod @ B @ A ),A3: B] :
      ( ( member @ A @ B2 @ ( image @ B @ A @ R4 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ A3 @ B2 ) @ R4 ) ) ).

% Image_singleton_iff
thf(fact_3297_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                   => ( ord_less_eq @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Min.bounded_iff
thf(fact_3298_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                   => ( ord_less @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Min_gr_iff
thf(fact_3299_Min__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image2 @ B @ A
                  @ ^ [Uu: B] : C2
                  @ A4 ) )
              = C2 ) ) ) ) ).

% Min_const
thf(fact_3300_Min__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A4 ) )
              = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min_insert
thf(fact_3301_pair__vimage__is__Image,axiom,
    ! [A: $tType,B: $tType,U: B,E4: set @ ( product_prod @ B @ A )] :
      ( ( vimage @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ U ) @ E4 )
      = ( image @ B @ A @ E4 @ ( insert2 @ B @ U @ ( bot_bot @ ( set @ B ) ) ) ) ) ).

% pair_vimage_is_Image
thf(fact_3302_ImageE,axiom,
    ! [A: $tType,B: $tType,B2: A,R4: set @ ( product_prod @ B @ A ),A4: set @ B] :
      ( ( member @ A @ B2 @ ( image @ B @ A @ R4 @ A4 ) )
     => ~ ! [X2: B] :
            ( ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ B2 ) @ R4 )
           => ~ ( member @ B @ X2 @ A4 ) ) ) ).

% ImageE
thf(fact_3303_Image__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,R4: set @ ( product_prod @ B @ A ),A4: set @ B] :
      ( ( member @ A @ B2 @ ( image @ B @ A @ R4 @ A4 ) )
      = ( ? [X3: B] :
            ( ( member @ B @ X3 @ A4 )
            & ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X3 @ B2 ) @ R4 ) ) ) ) ).

% Image_iff
thf(fact_3304_rev__ImageI,axiom,
    ! [B: $tType,A: $tType,A3: A,A4: set @ A,B2: B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ A @ A3 @ A4 )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ R4 )
       => ( member @ B @ B2 @ ( image @ A @ B @ R4 @ A4 ) ) ) ) ).

% rev_ImageI
thf(fact_3305_fold__graph_OemptyI,axiom,
    ! [A: $tType,B: $tType,F: A > B > B,Z2: B] : ( finite_fold_graph @ A @ B @ F @ Z2 @ ( bot_bot @ ( set @ A ) ) @ Z2 ) ).

% fold_graph.emptyI
thf(fact_3306_empty__fold__graphE,axiom,
    ! [A: $tType,B: $tType,F: A > B > B,Z2: B,X: B] :
      ( ( finite_fold_graph @ A @ B @ F @ Z2 @ ( bot_bot @ ( set @ A ) ) @ X )
     => ( X = Z2 ) ) ).

% empty_fold_graphE
thf(fact_3307_Image__Int__subset,axiom,
    ! [A: $tType,B: $tType,R: set @ ( product_prod @ B @ A ),A4: set @ B,B3: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ R @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ R @ A4 ) @ ( image @ B @ A @ R @ B3 ) ) ) ).

% Image_Int_subset
thf(fact_3308_rtrancl__image__advance__rtrancl,axiom,
    ! [A: $tType,Q4: A,R: set @ ( product_prod @ A @ A ),Q0: set @ A,X: A] :
      ( ( member @ A @ Q4 @ ( image @ A @ A @ ( transitive_rtrancl @ A @ R ) @ Q0 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ X ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ A @ X @ ( image @ A @ A @ ( transitive_rtrancl @ A @ R ) @ Q0 ) ) ) ) ).

% rtrancl_image_advance_rtrancl
thf(fact_3309_rtrancl__image__advance,axiom,
    ! [A: $tType,Q4: A,R: set @ ( product_prod @ A @ A ),Q0: set @ A,X: A] :
      ( ( member @ A @ Q4 @ ( image @ A @ A @ ( transitive_rtrancl @ A @ R ) @ Q0 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ X ) @ R )
       => ( member @ A @ X @ ( image @ A @ A @ ( transitive_rtrancl @ A @ R ) @ Q0 ) ) ) ) ).

% rtrancl_image_advance
thf(fact_3310_Min__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ A4 ) ) ) ) ).

% Min_in
thf(fact_3311_fold__graph_Ocases,axiom,
    ! [A: $tType,B: $tType,F: A > B > B,Z2: B,A1: set @ A,A22: B] :
      ( ( finite_fold_graph @ A @ B @ F @ Z2 @ A1 @ A22 )
     => ( ( ( A1
            = ( bot_bot @ ( set @ A ) ) )
         => ( A22 != Z2 ) )
       => ~ ! [X2: A,A13: set @ A] :
              ( ( A1
                = ( insert2 @ A @ X2 @ A13 ) )
             => ! [Y3: B] :
                  ( ( A22
                    = ( F @ X2 @ Y3 ) )
                 => ( ~ ( member @ A @ X2 @ A13 )
                   => ~ ( finite_fold_graph @ A @ B @ F @ Z2 @ A13 @ Y3 ) ) ) ) ) ) ).

% fold_graph.cases
thf(fact_3312_fold__graph_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_fold_graph @ A @ B )
      = ( ^ [F2: A > B > B,Z4: B,A12: set @ A,A23: B] :
            ( ( ( A12
                = ( bot_bot @ ( set @ A ) ) )
              & ( A23 = Z4 ) )
            | ? [X3: A,A10: set @ A,Y2: B] :
                ( ( A12
                  = ( insert2 @ A @ X3 @ A10 ) )
                & ( A23
                  = ( F2 @ X3 @ Y2 ) )
                & ~ ( member @ A @ X3 @ A10 )
                & ( finite_fold_graph @ A @ B @ F2 @ Z4 @ A10 @ Y2 ) ) ) ) ) ).

% fold_graph.simps
thf(fact_3313_Image__empty__rtrancl__Image__id,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),V: A] :
      ( ( ( image @ A @ A @ R @ ( insert2 @ A @ V @ ( bot_bot @ ( set @ A ) ) ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( transitive_rtrancl @ A @ R ) @ ( insert2 @ A @ V @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert2 @ A @ V @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Image_empty_rtrancl_Image_id
thf(fact_3314_wfE__pf,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( wf @ A @ R )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( image @ A @ A @ R @ A4 ) )
       => ( A4
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% wfE_pf
thf(fact_3315_wfI__pf,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ! [A13: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A13 @ ( image @ A @ A @ R @ A13 ) )
         => ( A13
            = ( bot_bot @ ( set @ A ) ) ) )
     => ( wf @ A @ R ) ) ).

% wfI_pf
thf(fact_3316_quotientI,axiom,
    ! [A: $tType,X: A,A4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ A @ X @ A4 )
     => ( member @ ( set @ A ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( equiv_quotient @ A @ A4 @ R4 ) ) ) ).

% quotientI
thf(fact_3317_quotientE,axiom,
    ! [A: $tType,X5: set @ A,A4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A4 @ R4 ) )
     => ~ ! [X2: A] :
            ( ( X5
              = ( image @ A @ A @ R4 @ ( insert2 @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
           => ~ ( member @ A @ X2 @ A4 ) ) ) ).

% quotientE
thf(fact_3318_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M4: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798350308766er_Min @ A @ A4 )
                = M4 )
              = ( ( member @ A @ M4 @ A4 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                   => ( ord_less_eq @ A @ M4 @ X3 ) ) ) ) ) ) ) ).

% Min_eq_iff
thf(fact_3319_Min__le__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ X )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                    & ( ord_less_eq @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Min_le_iff
thf(fact_3320_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M4: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M4
                = ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( ( member @ A @ M4 @ A4 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                   => ( ord_less_eq @ A @ M4 @ X3 ) ) ) ) ) ) ) ).

% eq_Min_iff
thf(fact_3321_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
             => ! [A14: A] :
                  ( ( member @ A @ A14 @ A4 )
                 => ( ord_less_eq @ A @ X @ A14 ) ) ) ) ) ) ).

% Min.boundedE
thf(fact_3322_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A8: A] :
                  ( ( member @ A @ A8 @ A4 )
                 => ( ord_less_eq @ A @ X @ A8 ) )
             => ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min.boundedI
thf(fact_3323_Min__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ X )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ A4 )
                    & ( ord_less @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Min_less_iff
thf(fact_3324_Min__Inf,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ A4 )
              = ( complete_Inf_Inf @ A @ A4 ) ) ) ) ) ).

% Min_Inf
thf(fact_3325_cInf__eq__Min,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A] :
          ( ( finite_finite @ A @ X5 )
         => ( ( X5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Inf_Inf @ A @ X5 )
              = ( lattic643756798350308766er_Min @ A @ X5 ) ) ) ) ) ).

% cInf_eq_Min
thf(fact_3326_Image__singleton,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ B @ A ),A3: B] :
      ( ( image @ B @ A @ R4 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) )
      = ( collect @ A
        @ ^ [B4: A] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ A3 @ B4 ) @ R4 ) ) ) ).

% Image_singleton
thf(fact_3327_rtrancl__apply__insert,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: A,S2: set @ A] :
      ( ( image @ A @ A @ ( transitive_rtrancl @ A @ R ) @ ( insert2 @ A @ X @ S2 ) )
      = ( insert2 @ A @ X @ ( image @ A @ A @ ( transitive_rtrancl @ A @ R ) @ ( sup_sup @ ( set @ A ) @ S2 @ ( image @ A @ A @ R @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% rtrancl_apply_insert
thf(fact_3328_fold__graph__image,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: A > B,A4: set @ A,F: B > C > C,Z2: C] :
      ( ( inj_on @ A @ B @ G @ A4 )
     => ( ( finite_fold_graph @ B @ C @ F @ Z2 @ ( image2 @ A @ B @ G @ A4 ) )
        = ( finite_fold_graph @ A @ C @ ( comp @ B @ ( C > C ) @ A @ F @ G ) @ Z2 @ A4 ) ) ) ).

% fold_graph_image
thf(fact_3329_E__closed__restr__reach__cases,axiom,
    ! [A: $tType,U: A,V: A,E4: set @ ( product_prod @ A @ A ),R: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V ) @ ( transitive_rtrancl @ A @ E4 ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ E4 @ R ) @ R )
       => ( ~ ( member @ A @ V @ R )
         => ~ ( ~ ( member @ A @ U @ R )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V ) @ ( transitive_rtrancl @ A @ ( rel_restrict @ A @ E4 @ R ) ) ) ) ) ) ) ).

% E_closed_restr_reach_cases
thf(fact_3330_Min__antimono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: set @ A,N4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M @ N4 )
         => ( ( M
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N4 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ N4 ) @ ( lattic643756798350308766er_Min @ A @ M ) ) ) ) ) ) ).

% Min_antimono
thf(fact_3331_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ B3 ) @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min.subset_imp
thf(fact_3332_subset__Image__Image__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B3: set @ A] :
      ( ( order_preorder_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( field2 @ A @ R4 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ R4 @ A4 ) @ ( image @ A @ A @ R4 @ B3 ) )
            = ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A4 )
                 => ? [Y2: A] :
                      ( ( member @ A @ Y2 @ B3 )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R4 ) ) ) ) ) ) ) ) ).

% subset_Image_Image_iff
thf(fact_3333_Image__eq__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( image @ B @ A )
      = ( ^ [R5: set @ ( product_prod @ B @ A ),B7: set @ B] :
            ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ B @ ( set @ A )
              @ ^ [Y2: B] : ( image @ B @ A @ R5 @ ( insert2 @ B @ Y2 @ ( bot_bot @ ( set @ B ) ) ) )
              @ B7 ) ) ) ) ).

% Image_eq_UN
thf(fact_3334_hom__Min__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X2: A,Y3: A] :
              ( ( H2 @ ( ord_min @ A @ X2 @ Y3 ) )
              = ( ord_min @ A @ ( H2 @ X2 ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798350308766er_Min @ A @ N4 ) )
                = ( lattic643756798350308766er_Min @ A @ ( image2 @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% hom_Min_commute
thf(fact_3335_Min_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A4 )
             => ( ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ B3 ) @ ( lattic643756798350308766er_Min @ A @ A4 ) )
                = ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min.subset
thf(fact_3336_Min_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A4 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ) ).

% Min.insert_not_elem
thf(fact_3337_Min_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X2: A,Y3: A] : ( member @ A @ ( ord_min @ A @ X2 @ Y3 ) @ ( insert2 @ A @ X2 @ ( insert2 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Min.closed
thf(fact_3338_Min_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ( B3
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
                  = ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ ( lattic643756798350308766er_Min @ A @ B3 ) ) ) ) ) ) ) ) ).

% Min.union
thf(fact_3339_Sigma__Image,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,B3: B > ( set @ A ),X5: set @ B] :
      ( ( image @ B @ A @ ( product_Sigma @ B @ A @ A4 @ B3 ) @ X5 )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B3 @ ( inf_inf @ ( set @ B ) @ X5 @ A4 ) ) ) ) ).

% Sigma_Image
thf(fact_3340_Min__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F: B > A,K: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image2 @ B @ A
                  @ ^ [X3: B] : ( plus_plus @ A @ ( F @ X3 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798350308766er_Min @ A @ ( image2 @ B @ A @ F @ S2 ) ) @ K ) ) ) ) ) ).

% Min_add_commute
thf(fact_3341_finite__reachable__advance,axiom,
    ! [A: $tType,E4: set @ ( product_prod @ A @ A ),V0: A,V: A] :
      ( ( finite_finite @ A @ ( image @ A @ A @ ( transitive_rtrancl @ A @ E4 ) @ ( insert2 @ A @ V0 @ ( bot_bot @ ( set @ A ) ) ) ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V0 @ V ) @ ( transitive_rtrancl @ A @ E4 ) )
       => ( finite_finite @ A @ ( image @ A @ A @ ( transitive_rtrancl @ A @ E4 ) @ ( insert2 @ A @ V @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% finite_reachable_advance
thf(fact_3342_rtrancl__Image__advance__ss,axiom,
    ! [A: $tType,U: A,V: A,E4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V ) @ E4 )
     => ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ ( transitive_rtrancl @ A @ E4 ) @ ( insert2 @ A @ V @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ ( transitive_rtrancl @ A @ E4 ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% rtrancl_Image_advance_ss
thf(fact_3343_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A4 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Min.insert_remove
thf(fact_3344_Min_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A4 )
                  = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Min.remove
thf(fact_3345_singleton__quotient,axiom,
    ! [A: $tType,X: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( equiv_quotient @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) @ R4 )
      = ( insert2 @ ( set @ A ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% singleton_quotient
thf(fact_3346_quotient__def,axiom,
    ! [A: $tType] :
      ( ( equiv_quotient @ A )
      = ( ^ [A10: set @ A,R5: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( set @ A ) )
            @ ( image2 @ A @ ( set @ ( set @ A ) )
              @ ^ [X3: A] : ( insert2 @ ( set @ A ) @ ( image @ A @ A @ R5 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
              @ A10 ) ) ) ) ).

% quotient_def
thf(fact_3347_subset__Image1__Image1__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( order_preorder_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ B2 @ ( field2 @ A @ R4 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A3 ) @ R4 ) ) ) ) ) ).

% subset_Image1_Image1_iff
thf(fact_3348_Refl__antisym__eq__Image1__Image1__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( refl_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( antisym @ A @ R4 )
       => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
         => ( ( member @ A @ B2 @ ( field2 @ A @ R4 ) )
           => ( ( ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
                = ( image @ A @ A @ R4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
              = ( A3 = B2 ) ) ) ) ) ) ).

% Refl_antisym_eq_Image1_Image1_iff
thf(fact_3349_trancl__multi__insert2,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),M4: A,X5: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 )
        @ ( transitive_trancl @ A
          @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ ( insert2 @ A @ M4 @ ( bot_bot @ ( set @ A ) ) )
              @ ^ [Uu: A] : X5 ) ) ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ R4 ) )
       => ~ ! [X2: A] :
              ( ( member @ A @ X2 @ X5 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ M4 ) @ ( transitive_rtrancl @ A @ R4 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ B2 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ) ) ).

% trancl_multi_insert2
thf(fact_3350_trancl__multi__insert,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),X5: set @ A,M4: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 )
        @ ( transitive_trancl @ A
          @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ X5
              @ ^ [Uu: A] : ( insert2 @ A @ M4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ R4 ) )
       => ~ ! [X2: A] :
              ( ( member @ A @ X2 @ X5 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ X2 ) @ ( transitive_rtrancl @ A @ R4 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M4 @ B2 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ) ) ).

% trancl_multi_insert
thf(fact_3351_relation__of__def,axiom,
    ! [A: $tType] :
      ( ( order_relation_of @ A )
      = ( ^ [P3: A > A > $o,A10: set @ A] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [A5: A,B4: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 )
                    @ ( product_Sigma @ A @ A @ A10
                      @ ^ [Uu: A] : A10 ) )
                  & ( P3 @ A5 @ B4 ) ) ) ) ) ) ).

% relation_of_def
thf(fact_3352_pred__nat__trancl__eq__le,axiom,
    ! [M4: nat,N: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M4 @ N ) @ ( transitive_rtrancl @ nat @ pred_nat ) )
      = ( ord_less_eq @ nat @ M4 @ N ) ) ).

% pred_nat_trancl_eq_le
thf(fact_3353_trancl__empty,axiom,
    ! [A: $tType] :
      ( ( transitive_trancl @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% trancl_empty
thf(fact_3354_trancl__single,axiom,
    ! [A: $tType,A3: A,B2: A] :
      ( ( transitive_trancl @ A @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) )
      = ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% trancl_single
thf(fact_3355_trancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_trancl @ A @ R4 ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ R4 )
       => ~ ! [B6: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ B6 ) @ ( transitive_trancl @ A @ R4 ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A22 ) @ R4 ) ) ) ) ).

% trancl.cases
thf(fact_3356_trancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_trancl @ A @ R4 ) )
      = ( ? [A5: A,B4: A] :
            ( ( A1 = A5 )
            & ( A22 = B4 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R4 ) )
        | ? [A5: A,B4: A,C5: A] :
            ( ( A1 = A5 )
            & ( A22 = C5 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ ( transitive_trancl @ A @ R4 ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C5 ) @ R4 ) ) ) ) ).

% trancl.simps
thf(fact_3357_trancl_Or__into__trancl,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ R4 ) ) ) ).

% trancl.r_into_trancl
thf(fact_3358_tranclE,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ R4 ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
       => ~ ! [C4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ C4 ) @ ( transitive_trancl @ A @ R4 ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ C4 @ B2 ) @ R4 ) ) ) ) ).

% tranclE
thf(fact_3359_trancl__trans,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R4 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ ( transitive_trancl @ A @ R4 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_trancl @ A @ R4 ) ) ) ) ).

% trancl_trans
thf(fact_3360_trancl__induct,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ R4 ) )
     => ( ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ Y3 ) @ R4 )
           => ( P @ Y3 ) )
       => ( ! [Y3: A,Z3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ Y3 ) @ ( transitive_trancl @ A @ R4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ R4 )
               => ( ( P @ Y3 )
                 => ( P @ Z3 ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% trancl_induct
thf(fact_3361_r__r__into__trancl,axiom,
    ! [A: $tType,A3: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% r_r_into_trancl
thf(fact_3362_converse__tranclE,axiom,
    ! [A: $tType,X: A,Z2: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_trancl @ A @ R4 ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ R4 )
       => ~ ! [Y3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R4 )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ ( transitive_trancl @ A @ R4 ) ) ) ) ) ).

% converse_tranclE
thf(fact_3363_irrefl__trancl__rD,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ! [X2: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ ( transitive_trancl @ A @ R4 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
       => ( X != Y ) ) ) ).

% irrefl_trancl_rD
thf(fact_3364_Transitive__Closure_Otrancl__into__trancl,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ R4 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R4 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ C2 ) @ ( transitive_trancl @ A @ R4 ) ) ) ) ).

% Transitive_Closure.trancl_into_trancl
thf(fact_3365_trancl__into__trancl2,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_trancl @ A @ R4 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ C2 ) @ ( transitive_trancl @ A @ R4 ) ) ) ) ).

% trancl_into_trancl2
thf(fact_3366_trancl__trans__induct,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),P: A > A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R4 ) )
     => ( ! [X2: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R4 )
           => ( P @ X2 @ Y3 ) )
       => ( ! [X2: A,Y3: A,Z3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ ( transitive_trancl @ A @ R4 ) )
             => ( ( P @ X2 @ Y3 )
               => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ ( transitive_trancl @ A @ R4 ) )
                 => ( ( P @ Y3 @ Z3 )
                   => ( P @ X2 @ Z3 ) ) ) ) )
         => ( P @ X @ Y ) ) ) ) ).

% trancl_trans_induct
thf(fact_3367_converse__trancl__induct,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ R4 ) )
     => ( ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ B2 ) @ R4 )
           => ( P @ Y3 ) )
       => ( ! [Y3: A,Z3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ R4 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ B2 ) @ ( transitive_trancl @ A @ R4 ) )
               => ( ( P @ Z3 )
                 => ( P @ Y3 ) ) ) )
         => ( P @ A3 ) ) ) ) ).

% converse_trancl_induct
thf(fact_3368_less__eq,axiom,
    ! [M4: nat,N: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M4 @ N ) @ ( transitive_trancl @ nat @ pred_nat ) )
      = ( ord_less @ nat @ M4 @ N ) ) ).

% less_eq
thf(fact_3369_antisymD,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( antisym @ A @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
       => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A3 ) @ R4 )
         => ( A3 = B2 ) ) ) ) ).

% antisymD
thf(fact_3370_antisymI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ! [X2: A,Y3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R4 )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X2 ) @ R4 )
           => ( X2 = Y3 ) ) )
     => ( antisym @ A @ R4 ) ) ).

% antisymI
thf(fact_3371_antisym__def,axiom,
    ! [A: $tType] :
      ( ( antisym @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [X3: A,Y2: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R5 )
             => ( X3 = Y2 ) ) ) ) ) ).

% antisym_def
thf(fact_3372_antisym__empty,axiom,
    ! [A: $tType] : ( antisym @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% antisym_empty
thf(fact_3373_trancl__rtrancl__trancl,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ R4 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R4 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ C2 ) @ ( transitive_trancl @ A @ R4 ) ) ) ) ).

% trancl_rtrancl_trancl
thf(fact_3374_rtrancl__trancl__trancl,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ ( transitive_trancl @ A @ R4 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_trancl @ A @ R4 ) ) ) ) ).

% rtrancl_trancl_trancl
thf(fact_3375_rtrancl__into__trancl2,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R4 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ C2 ) @ ( transitive_trancl @ A @ R4 ) ) ) ) ).

% rtrancl_into_trancl2
thf(fact_3376_rtrancl__into__trancl1,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R4 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ C2 ) @ ( transitive_trancl @ A @ R4 ) ) ) ) ).

% rtrancl_into_trancl1
thf(fact_3377_rtrancl__eq__or__trancl,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R ) )
      = ( ( X = Y )
        | ( ( X != Y )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R ) ) ) ) ) ).

% rtrancl_eq_or_trancl
thf(fact_3378_trancl__into__rtrancl,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ R4 ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ).

% trancl_into_rtrancl
thf(fact_3379_tranclD2,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R ) )
     => ? [Z3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z3 ) @ ( transitive_rtrancl @ A @ R ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ Y ) @ R ) ) ) ).

% tranclD2
thf(fact_3380_rtranclD,axiom,
    ! [A: $tType,A3: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( A3 = B2 )
        | ( ( A3 != B2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ) ).

% rtranclD
thf(fact_3381_tranclD,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R ) )
     => ? [Z3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z3 ) @ R )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ Y ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% tranclD
thf(fact_3382_rel__restrict__trancl__notR_I2_J,axiom,
    ! [A: $tType,V: A,W2: A,E4: set @ ( product_prod @ A @ A ),R: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 ) @ ( transitive_trancl @ A @ ( rel_restrict @ A @ E4 @ R ) ) )
     => ~ ( member @ A @ W2 @ R ) ) ).

% rel_restrict_trancl_notR(2)
thf(fact_3383_rel__restrict__trancl__notR_I1_J,axiom,
    ! [A: $tType,V: A,W2: A,E4: set @ ( product_prod @ A @ A ),R: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 ) @ ( transitive_trancl @ A @ ( rel_restrict @ A @ E4 @ R ) ) )
     => ~ ( member @ A @ V @ R ) ) ).

% rel_restrict_trancl_notR(1)
thf(fact_3384_rel__restrict__trancl__mem,axiom,
    ! [A: $tType,A3: A,B2: A,A4: set @ ( product_prod @ A @ A ),R: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( transitive_trancl @ A @ ( rel_restrict @ A @ A4 @ R ) ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( rel_restrict @ A @ ( transitive_trancl @ A @ A4 ) @ R ) ) ) ).

% rel_restrict_trancl_mem
thf(fact_3385_trancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R4: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_trancl @ ( product_prod @ A @ B ) @ R4 ) )
     => ( ! [A8: A,B6: B] :
            ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A8 @ B6 ) ) @ R4 )
           => ( P @ A8 @ B6 ) )
       => ( ! [A8: A,B6: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A8 @ B6 ) ) @ ( transitive_trancl @ ( product_prod @ A @ B ) @ R4 ) )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A8 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R4 )
               => ( ( P @ A8 @ B6 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% trancl_induct2
thf(fact_3386_Image__empty__trancl__Image__empty,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),V: A] :
      ( ( ( image @ A @ A @ R @ ( insert2 @ A @ V @ ( bot_bot @ ( set @ A ) ) ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( transitive_trancl @ A @ R ) @ ( insert2 @ A @ V @ ( bot_bot @ ( set @ A ) ) ) )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% Image_empty_trancl_Image_empty
thf(fact_3387_wf__linord__ex__has__least,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),P: B > $o,K: B,M4: B > A] :
      ( ( wf @ A @ R4 )
     => ( ! [X2: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ ( transitive_trancl @ A @ R4 ) )
            = ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X2 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) )
       => ( ( P @ K )
         => ? [X2: B] :
              ( ( P @ X2 )
              & ! [Y5: B] :
                  ( ( P @ Y5 )
                 => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( M4 @ X2 ) @ ( M4 @ Y5 ) ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ) ) ) ).

% wf_linord_ex_has_least
thf(fact_3388_trancl__union__outside,axiom,
    ! [A: $tType,V: A,W2: A,E4: set @ ( product_prod @ A @ A ),U3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 ) @ ( transitive_trancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ E4 @ U3 ) ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 ) @ ( transitive_trancl @ A @ E4 ) )
       => ? [X2: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ X2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ E4 @ U3 ) ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ U3 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ W2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ E4 @ U3 ) ) ) ) ) ) ).

% trancl_union_outside
thf(fact_3389_trancl__over__edgeE,axiom,
    ! [A: $tType,U: A,W2: A,V1: A,V22: A,E4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ W2 ) @ ( transitive_trancl @ A @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V1 @ V22 ) @ E4 ) ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ W2 ) @ ( transitive_trancl @ A @ E4 ) )
       => ~ ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V1 ) @ ( transitive_rtrancl @ A @ E4 ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V22 @ W2 ) @ ( transitive_rtrancl @ A @ E4 ) ) ) ) ) ).

% trancl_over_edgeE
thf(fact_3390_antisym__singleton,axiom,
    ! [A: $tType,X: product_prod @ A @ A] : ( antisym @ A @ ( insert2 @ ( product_prod @ A @ A ) @ X @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% antisym_singleton
thf(fact_3391_trancl__Int__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R4 ) @ S ) @ R4 ) @ S )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R4 ) @ S ) ) ) ).

% trancl_Int_subset
thf(fact_3392_Restr__trancl__mono,axiom,
    ! [A: $tType,V: A,W2: A,E4: set @ ( product_prod @ A @ A ),U3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 )
        @ ( transitive_trancl @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ E4
            @ ( product_Sigma @ A @ A @ U3
              @ ^ [Uu: A] : U3 ) ) ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V @ W2 ) @ ( transitive_trancl @ A @ E4 ) ) ) ).

% Restr_trancl_mono
thf(fact_3393_antisym__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( antisym @ A @ R4 )
     => ( antisym @ A
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) ) ) ).

% antisym_Restr
thf(fact_3394_rel__restrict__tranclI,axiom,
    ! [A: $tType,X: A,Y: A,E4: set @ ( product_prod @ A @ A ),R: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ E4 ) )
     => ( ~ ( member @ A @ X @ R )
       => ( ~ ( member @ A @ Y @ R )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ E4 @ R ) @ R )
           => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ ( rel_restrict @ A @ E4 @ R ) ) ) ) ) ) ) ).

% rel_restrict_tranclI
thf(fact_3395_trancl__insert2,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R4 )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X3: A,Y2: A] :
                ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ A3 ) @ ( transitive_trancl @ A @ R4 ) )
                  | ( X3 = A3 ) )
                & ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y2 ) @ ( transitive_trancl @ A @ R4 ) )
                  | ( Y2 = B2 ) ) ) ) ) ) ) ).

% trancl_insert2
thf(fact_3396_trancl__Image__advance__ss,axiom,
    ! [A: $tType,U: A,V: A,E4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V ) @ E4 )
     => ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ ( transitive_trancl @ A @ E4 ) @ ( insert2 @ A @ V @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ ( transitive_trancl @ A @ E4 ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% trancl_Image_advance_ss
thf(fact_3397_trancl__restrict__reachable,axiom,
    ! [A: $tType,U: A,V: A,E4: set @ ( product_prod @ A @ A ),S2: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V ) @ ( transitive_trancl @ A @ E4 ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ E4 @ S2 ) @ S2 )
       => ( ( member @ A @ U @ S2 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V )
            @ ( transitive_trancl @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ E4
                @ ( product_Sigma @ A @ A @ S2
                  @ ^ [Uu: A] : S2 ) ) ) ) ) ) ) ).

% trancl_restrict_reachable
thf(fact_3398_rtrancl__last__visit,axiom,
    ! [A: $tType,Q4: A,Q6: A,R: set @ ( product_prod @ A @ A ),S2: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Q6 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Q6 )
            @ ( transitive_rtrancl @ A
              @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R
                @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                  @ ^ [Uu: A] : S2 ) ) ) )
       => ~ ! [Qt: A] :
              ( ( member @ A @ Qt @ S2 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Q4 @ Qt ) @ ( transitive_trancl @ A @ R ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Qt @ Q6 )
                    @ ( transitive_rtrancl @ A
                      @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ R
                        @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                          @ ^ [Uu: A] : S2 ) ) ) ) ) ) ) ) ).

% rtrancl_last_visit
thf(fact_3399_trancl__insert,axiom,
    ! [A: $tType,Y: A,X: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X ) @ R4 ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R4 )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [A5: A,B4: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ Y ) @ ( transitive_rtrancl @ A @ R4 ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ B4 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ) ) ) ).

% trancl_insert
thf(fact_3400_new__addrs__def,axiom,
    ( hoare_new_addrs
    = ( ^ [H3: heap_ext @ product_unit,As7: set @ nat,H8: heap_ext @ product_unit] :
          ( sup_sup @ ( set @ nat ) @ As7
          @ ( collect @ nat
            @ ^ [A5: nat] :
                ( ( ord_less_eq @ nat @ ( lim @ product_unit @ H3 ) @ A5 )
                & ( ord_less @ nat @ A5 @ ( lim @ product_unit @ H8 ) ) ) ) ) ) ) ).

% new_addrs_def
thf(fact_3401_flat__lub__def,axiom,
    ! [A: $tType] :
      ( ( partial_flat_lub @ A )
      = ( ^ [B4: A,A10: set @ A] :
            ( if @ A @ ( ord_less_eq @ ( set @ A ) @ A10 @ ( insert2 @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4
            @ ( the @ A
              @ ^ [X3: A] : ( member @ A @ X3 @ ( minus_minus @ ( set @ A ) @ A10 @ ( insert2 @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% flat_lub_def
thf(fact_3402_Rep__unit,axiom,
    ! [X: product_unit] : ( member @ $o @ ( product_Rep_unit @ X ) @ ( insert2 @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) ) ).

% Rep_unit
thf(fact_3403_Abs__unit__cases,axiom,
    ! [X: product_unit] :
      ~ ! [Y3: $o] :
          ( ( X
            = ( product_Abs_unit @ Y3 ) )
         => ~ ( member @ $o @ Y3 @ ( insert2 @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) ) ) ).

% Abs_unit_cases
thf(fact_3404_Rep__unit__cases,axiom,
    ! [Y: $o] :
      ( ( member @ $o @ Y @ ( insert2 @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
     => ~ ! [X2: product_unit] :
            ( Y
            = ( ~ ( product_Rep_unit @ X2 ) ) ) ) ).

% Rep_unit_cases
thf(fact_3405_type__definition__unit,axiom,
    type_definition @ product_unit @ $o @ product_Rep_unit @ product_Abs_unit @ ( insert2 @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) ).

% type_definition_unit
thf(fact_3406_Abs__unit__inverse,axiom,
    ! [Y: $o] :
      ( ( member @ $o @ Y @ ( insert2 @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
     => ( ( product_Rep_unit @ ( product_Abs_unit @ Y ) )
        = Y ) ) ).

% Abs_unit_inverse
thf(fact_3407_in__range_Oelims_I3_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( in_range @ X )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ! [X2: nat] :
                ( ( member @ nat @ X2 @ As2 )
               => ( ord_less @ nat @ X2 @ ( lim @ product_unit @ H ) ) ) ) ) ).

% in_range.elims(3)
thf(fact_3408_in__range_Oelims_I2_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( in_range @ X )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ~ ! [X6: nat] :
                  ( ( member @ nat @ X6 @ As2 )
                 => ( ord_less @ nat @ X6 @ ( lim @ product_unit @ H ) ) ) ) ) ).

% in_range.elims(2)
thf(fact_3409_in__range_Oelims_I1_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( in_range @ X )
        = Y )
     => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
           => ( Y
              = ( ~ ! [X3: nat] :
                      ( ( member @ nat @ X3 @ As2 )
                     => ( ord_less @ nat @ X3 @ ( lim @ product_unit @ H ) ) ) ) ) ) ) ).

% in_range.elims(1)
thf(fact_3410_in__range_Osimps,axiom,
    ! [H2: heap_ext @ product_unit,As: set @ nat] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
      = ( ! [X3: nat] :
            ( ( member @ nat @ X3 @ As )
           => ( ord_less @ nat @ X3 @ ( lim @ product_unit @ H2 ) ) ) ) ) ).

% in_range.simps
thf(fact_3411_Rep__unit__induct,axiom,
    ! [Y: $o,P: $o > $o] :
      ( ( member @ $o @ Y @ ( insert2 @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
     => ( ! [X2: product_unit] : ( P @ ( product_Rep_unit @ X2 ) )
       => ( P @ Y ) ) ) ).

% Rep_unit_induct
thf(fact_3412_Abs__unit__inject,axiom,
    ! [X: $o,Y: $o] :
      ( ( member @ $o @ X @ ( insert2 @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
     => ( ( member @ $o @ Y @ ( insert2 @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
       => ( ( ( product_Abs_unit @ X )
            = ( product_Abs_unit @ Y ) )
          = ( X = Y ) ) ) ) ).

% Abs_unit_inject
thf(fact_3413_Abs__unit__induct,axiom,
    ! [P: product_unit > $o,X: product_unit] :
      ( ! [Y3: $o] :
          ( ( member @ $o @ Y3 @ ( insert2 @ $o @ $true @ ( bot_bot @ ( set @ $o ) ) ) )
         => ( P @ ( product_Abs_unit @ Y3 ) ) )
     => ( P @ X ) ) ).

% Abs_unit_induct
thf(fact_3414_Partial__order__eq__Image1__Image1__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( order_7125193373082350890der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ B2 @ ( field2 @ A @ R4 ) )
         => ( ( ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( image @ A @ A @ R4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( A3 = B2 ) ) ) ) ) ).

% Partial_order_eq_Image1_Image1_iff
thf(fact_3415_return__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_return @ A )
      = ( ^ [X3: A] :
            ( heap_Time_heap @ A
            @ ^ [H3: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H3 @ ( one_one @ nat ) ) ) ) ) ) ).

% return_def
thf(fact_3416_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,F3: A > ( filter @ B ),P: B > $o] :
      ( ( B3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [A8: A] :
            ( ( member @ A @ A8 @ B3 )
           => ! [B6: A] :
                ( ( member @ A @ B6 @ B3 )
               => ? [X6: A] :
                    ( ( member @ A @ X6 @ B3 )
                    & ( ord_less_eq @ ( filter @ B ) @ ( F3 @ X6 ) @ ( inf_inf @ ( filter @ B ) @ ( F3 @ A8 ) @ ( F3 @ B6 ) ) ) ) ) )
       => ( ( eventually @ B @ P @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ A @ ( filter @ B ) @ F3 @ B3 ) ) )
          = ( ? [X3: A] :
                ( ( member @ A @ X3 @ B3 )
                & ( eventually @ B @ P @ ( F3 @ X3 ) ) ) ) ) ) ) ).

% eventually_INF_base
thf(fact_3417_proj__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( equiv_proj @ B @ A )
      = ( ^ [R5: set @ ( product_prod @ B @ A ),X3: B] : ( image @ B @ A @ R5 @ ( insert2 @ B @ X3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ).

% proj_def
thf(fact_3418_cSUP__UNION,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [A4: set @ C,B3: C > ( set @ D ),F: D > B] :
          ( ( A4
           != ( bot_bot @ ( set @ C ) ) )
         => ( ! [X2: C] :
                ( ( member @ C @ X2 @ A4 )
               => ( ( B3 @ X2 )
                 != ( bot_bot @ ( set @ D ) ) ) )
           => ( ( condit941137186595557371_above @ B
                @ ( complete_Sup_Sup @ ( set @ B )
                  @ ( image2 @ C @ ( set @ B )
                    @ ^ [X3: C] : ( image2 @ D @ B @ F @ ( B3 @ X3 ) )
                    @ A4 ) ) )
             => ( ( complete_Sup_Sup @ B @ ( image2 @ D @ B @ F @ ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ C @ ( set @ D ) @ B3 @ A4 ) ) ) )
                = ( complete_Sup_Sup @ B
                  @ ( image2 @ C @ B
                    @ ^ [X3: C] : ( complete_Sup_Sup @ B @ ( image2 @ D @ B @ F @ ( B3 @ X3 ) ) )
                    @ A4 ) ) ) ) ) ) ) ).

% cSUP_UNION
thf(fact_3419_bdd__above__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit941137186595557371_above @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% bdd_above_empty
thf(fact_3420_eventually__const,axiom,
    ! [A: $tType,F3: filter @ A,P: $o] :
      ( ( F3
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ A
          @ ^ [X3: A] : P
          @ F3 )
        = P ) ) ).

% eventually_const
thf(fact_3421_bdd__above__image__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F: B > A,G: B > A,A4: set @ B] :
          ( ( condit941137186595557371_above @ A
            @ ( image2 @ B @ A
              @ ^ [X3: B] : ( sup_sup @ A @ ( F @ X3 ) @ ( G @ X3 ) )
              @ A4 ) )
          = ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F @ A4 ) )
            & ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ G @ A4 ) ) ) ) ) ).

% bdd_above_image_sup
thf(fact_3422_bdd__above__Int2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B3: set @ A,A4: set @ A] :
          ( ( condit941137186595557371_above @ A @ B3 )
         => ( condit941137186595557371_above @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% bdd_above_Int2
thf(fact_3423_bdd__above__Int1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( condit941137186595557371_above @ A @ A4 )
         => ( condit941137186595557371_above @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% bdd_above_Int1
thf(fact_3424_eventually__happens_H,axiom,
    ! [A: $tType,F3: filter @ A,P: A > $o] :
      ( ( F3
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ A @ P @ F3 )
       => ? [X_1: A] : ( P @ X_1 ) ) ) ).

% eventually_happens'
thf(fact_3425_eventually__happens,axiom,
    ! [A: $tType,P: A > $o,Net: filter @ A] :
      ( ( eventually @ A @ P @ Net )
     => ( ( Net
          = ( bot_bot @ ( filter @ A ) ) )
        | ? [X_1: A] : ( P @ X_1 ) ) ) ).

% eventually_happens
thf(fact_3426_eventually__bot,axiom,
    ! [A: $tType,P: A > $o] : ( eventually @ A @ P @ ( bot_bot @ ( filter @ A ) ) ) ).

% eventually_bot
thf(fact_3427_eventually__inf,axiom,
    ! [A: $tType,P: A > $o,F3: filter @ A,F4: filter @ A] :
      ( ( eventually @ A @ P @ ( inf_inf @ ( filter @ A ) @ F3 @ F4 ) )
      = ( ? [Q3: A > $o,R2: A > $o] :
            ( ( eventually @ A @ Q3 @ F3 )
            & ( eventually @ A @ R2 @ F4 )
            & ! [X3: A] :
                ( ( ( Q3 @ X3 )
                  & ( R2 @ X3 ) )
               => ( P @ X3 ) ) ) ) ) ).

% eventually_inf
thf(fact_3428_trivial__limit__def,axiom,
    ! [A: $tType,F3: filter @ A] :
      ( ( F3
        = ( bot_bot @ ( filter @ A ) ) )
      = ( eventually @ A
        @ ^ [X3: A] : $false
        @ F3 ) ) ).

% trivial_limit_def
thf(fact_3429_eventually__const__iff,axiom,
    ! [A: $tType,P: $o,F3: filter @ A] :
      ( ( eventually @ A
        @ ^ [X3: A] : P
        @ F3 )
      = ( P
        | ( F3
          = ( bot_bot @ ( filter @ A ) ) ) ) ) ).

% eventually_const_iff
thf(fact_3430_False__imp__not__eventually,axiom,
    ! [A: $tType,P: A > $o,Net: filter @ A] :
      ( ! [X2: A] :
          ~ ( P @ X2 )
     => ( ( Net
         != ( bot_bot @ ( filter @ A ) ) )
       => ~ ( eventually @ A @ P @ Net ) ) ) ).

% False_imp_not_eventually
thf(fact_3431_effect__heapE,axiom,
    ! [A: $tType,F: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ),H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( heap_Time_heap @ A @ F ) @ H2 @ H4 @ R4 @ N )
     => ~ ( ( H4
            = ( product_fst @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) ) )
         => ( ( N
              = ( product_snd @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) ) )
           => ( R4
             != ( product_fst @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) ) ) ) ) ).

% effect_heapE
thf(fact_3432_effect__heapI,axiom,
    ! [A: $tType,N: nat,F: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ),H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A] :
      ( ( N
        = ( product_snd @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) ) )
     => ( ( H4
          = ( product_fst @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) ) )
       => ( ( R4
            = ( product_fst @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) )
         => ( heap_Time_effect @ A @ ( heap_Time_heap @ A @ F ) @ H2 @ H4 @ R4 @ N ) ) ) ) ).

% effect_heapI
thf(fact_3433_success__heapI,axiom,
    ! [A: $tType,F: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ),H2: heap_ext @ product_unit] : ( heap_Time_success @ A @ ( heap_Time_heap @ A @ F ) @ H2 ) ).

% success_heapI
thf(fact_3434_cSup__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B3: set @ A,A4: set @ A] :
          ( ( B3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A4 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ B3 )
                 => ? [X6: A] :
                      ( ( member @ A @ X6 @ A4 )
                      & ( ord_less_eq @ A @ B6 @ X6 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ B3 ) @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ) ).

% cSup_mono
thf(fact_3435_cSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A,A3: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S2 )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ S2 ) @ A3 )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ord_less_eq @ A @ X3 @ A3 ) ) ) ) ) ) ) ).

% cSup_le_iff
thf(fact_3436_less__cSup__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,Y: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ X5 )
           => ( ( ord_less @ A @ Y @ ( complete_Sup_Sup @ A @ X5 ) )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ X5 )
                    & ( ord_less @ A @ Y @ X3 ) ) ) ) ) ) ) ).

% less_cSup_iff
thf(fact_3437_partial__order__on__empty,axiom,
    ! [A: $tType] : ( order_7125193373082350890der_on @ A @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% partial_order_on_empty
thf(fact_3438_eventually__Inf__base,axiom,
    ! [A: $tType,B3: set @ ( filter @ A ),P: A > $o] :
      ( ( B3
       != ( bot_bot @ ( set @ ( filter @ A ) ) ) )
     => ( ! [F7: filter @ A] :
            ( ( member @ ( filter @ A ) @ F7 @ B3 )
           => ! [G7: filter @ A] :
                ( ( member @ ( filter @ A ) @ G7 @ B3 )
               => ? [X6: filter @ A] :
                    ( ( member @ ( filter @ A ) @ X6 @ B3 )
                    & ( ord_less_eq @ ( filter @ A ) @ X6 @ ( inf_inf @ ( filter @ A ) @ F7 @ G7 ) ) ) ) )
       => ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B3 ) )
          = ( ? [X3: filter @ A] :
                ( ( member @ ( filter @ A ) @ X3 @ B3 )
                & ( eventually @ A @ P @ X3 ) ) ) ) ) ) ).

% eventually_Inf_base
thf(fact_3439_cSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F: B > A,U: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F @ A4 ) )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ U )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ A4 )
                   => ( ord_less_eq @ A @ ( F @ X3 ) @ U ) ) ) ) ) ) ) ).

% cSUP_le_iff
thf(fact_3440_cSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,G: C > A,B3: set @ C,F: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ C @ A @ G @ B3 ) )
           => ( ! [N3: B] :
                  ( ( member @ B @ N3 @ A4 )
                 => ? [X6: C] :
                      ( ( member @ C @ X6 @ B3 )
                      & ( ord_less_eq @ A @ ( F @ N3 ) @ ( G @ X6 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ G @ B3 ) ) ) ) ) ) ) ).

% cSUP_mono
thf(fact_3441_cSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ B3 )
           => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ) ) ).

% cSup_subset_mono
thf(fact_3442_cSup__insert__If,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A3: A] :
          ( ( condit941137186595557371_above @ A @ X5 )
         => ( ( ( X5
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ A3 @ X5 ) )
                = A3 ) )
            & ( ( X5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ A3 @ X5 ) )
                = ( sup_sup @ A @ A3 @ ( complete_Sup_Sup @ A @ X5 ) ) ) ) ) ) ) ).

% cSup_insert_If
thf(fact_3443_cSup__insert,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A3: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ X5 )
           => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ A3 @ X5 ) )
              = ( sup_sup @ A @ A3 @ ( complete_Sup_Sup @ A @ X5 ) ) ) ) ) ) ).

% cSup_insert
thf(fact_3444_cSup__union__distrib,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A4 )
           => ( ( B3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit941137186595557371_above @ A @ B3 )
               => ( ( complete_Sup_Sup @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
                  = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ) ) ) ) ).

% cSup_union_distrib
thf(fact_3445_less__cSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A4: set @ B,F: B > A,A3: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F @ A4 ) )
           => ( ( ord_less @ A @ A3 @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) )
              = ( ? [X3: B] :
                    ( ( member @ B @ X3 @ A4 )
                    & ( ord_less @ A @ A3 @ ( F @ X3 ) ) ) ) ) ) ) ) ).

% less_cSUP_iff
thf(fact_3446_conditionally__complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F: B > A,G: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F @ A4 ) )
           => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ G @ A4 ) )
             => ( ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ A4 ) ) )
                = ( complete_Sup_Sup @ A
                  @ ( image2 @ B @ A
                    @ ^ [A5: B] : ( sup_sup @ A @ ( F @ A5 ) @ ( G @ A5 ) )
                    @ A4 ) ) ) ) ) ) ) ).

% conditionally_complete_lattice_class.SUP_sup_distrib
thf(fact_3447_cSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,G: B > A,B3: set @ B,F: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ G @ B3 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B3 )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ A4 )
                   => ( ord_less_eq @ A @ ( F @ X2 ) @ ( G @ X2 ) ) )
               => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ G @ B3 ) ) ) ) ) ) ) ) ).

% cSUP_subset_mono
thf(fact_3448_cSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( condit941137186595557371_above @ A @ A4 )
         => ( ( condit941137186595557371_above @ A @ B3 )
           => ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) @ ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ) ) ) ).

% cSup_inter_less_eq
thf(fact_3449_cSUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F: B > A,A3: B] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F @ A4 ) )
           => ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ ( insert2 @ B @ A3 @ A4 ) ) )
              = ( sup_sup @ A @ ( F @ A3 ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) ) ) ) ) ) ).

% cSUP_insert
thf(fact_3450_Partial__order__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( order_7125193373082350890der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( order_7125193373082350890der_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A4
              @ ^ [Uu: A] : A4 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) ) ) ).

% Partial_order_Restr
thf(fact_3451_cSUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F: B > A,B3: set @ B] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F @ A4 ) )
           => ( ( B3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ( condit941137186595557371_above @ A @ ( image2 @ B @ A @ F @ B3 ) )
               => ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) )
                  = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ B3 ) ) ) ) ) ) ) ) ) ).

% cSUP_union
thf(fact_3452_ureturn__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_ureturn @ A )
      = ( ^ [X3: A] :
            ( heap_Time_heap @ A
            @ ^ [H3: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% ureturn_def
thf(fact_3453_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: B > A,Y6: set @ B,X5: set @ A,F3: filter @ B,F: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image2 @ B @ A @ G @ Y6 ) @ X5 )
     => ( ( eventually @ B
          @ ^ [X3: B] : ( member @ B @ X3 @ Y6 )
          @ F3 )
       => ( ( map_filter_on @ A @ C @ X5 @ F @ ( map_filter_on @ B @ A @ Y6 @ G @ F3 ) )
          = ( map_filter_on @ B @ C @ Y6 @ ( comp @ A @ C @ B @ F @ G ) @ F3 ) ) ) ) ).

% map_filter_on_comp
thf(fact_3454_Ref__Time_Oupdate__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_update @ A )
        = ( ^ [R5: ref @ A,V3: A] :
              ( heap_Time_heap @ product_unit
              @ ^ [H3: heap_ext @ product_unit] : ( product_Pair @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ product_Unity @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( ref_set @ A @ R5 @ V3 @ H3 ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% Ref_Time.update_def
thf(fact_3455_Zorns__po__lemma,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( order_7125193373082350890der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ! [C6: set @ A] :
            ( ( member @ ( set @ A ) @ C6 @ ( chains @ A @ R4 ) )
           => ? [X6: A] :
                ( ( member @ A @ X6 @ ( field2 @ A @ R4 ) )
                & ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ C6 )
                   => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Xa3 @ X6 ) @ R4 ) ) ) )
       => ? [X2: A] :
            ( ( member @ A @ X2 @ ( field2 @ A @ R4 ) )
            & ! [Xa2: A] :
                ( ( member @ A @ Xa2 @ ( field2 @ A @ R4 ) )
               => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Xa2 ) @ R4 )
                 => ( Xa2 = X2 ) ) ) ) ) ) ).

% Zorns_po_lemma
thf(fact_3456_hoare__tripleE,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn,H2: heap_ext @ product_unit,As: set @ nat] :
      ( ( hoare_hoare_triple @ A @ P @ C2 @ Q )
     => ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
       => ~ ! [R3: A,H5: heap_ext @ product_unit] :
              ( ? [T2: nat] :
                  ( ( heap_Time_execute @ A @ C2 @ H2 )
                  = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H5 @ T2 ) ) ) )
             => ( ( rep_assn @ ( Q @ R3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ ( hoare_new_addrs @ H2 @ As @ H5 ) ) )
               => ( ( relH
                    @ ( collect @ nat
                      @ ^ [A5: nat] :
                          ( ( ord_less @ nat @ A5 @ ( lim @ product_unit @ H2 ) )
                          & ~ ( member @ nat @ A5 @ As ) ) )
                    @ H2
                    @ H5 )
                 => ~ ( ord_less_eq @ nat @ ( lim @ product_unit @ H2 ) @ ( lim @ product_unit @ H5 ) ) ) ) ) ) ) ).

% hoare_tripleE
thf(fact_3457_successE,axiom,
    ! [A: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit] :
      ( ( heap_Time_success @ A @ F @ H2 )
     => ~ ! [R3: A,H5: product_prod @ ( heap_ext @ product_unit ) @ nat] :
            ( ( heap_Time_execute @ A @ F @ H2 )
           != ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ H5 ) ) ) ) ).

% successE
thf(fact_3458_execute__heap,axiom,
    ! [A: $tType,F: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
      ( ( heap_Time_execute @ A @ ( heap_Time_heap @ A @ F ) )
      = ( comp @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ F ) ) ).

% execute_heap
thf(fact_3459_Heap__eqI,axiom,
    ! [A: $tType,F: heap_Time_Heap @ A,G: heap_Time_Heap @ A] :
      ( ! [H: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ A @ F @ H )
          = ( heap_Time_execute @ A @ G @ H ) )
     => ( F = G ) ) ).

% Heap_eqI
thf(fact_3460_execute__ureturn,axiom,
    ! [A: $tType,X: A] :
      ( ( heap_Time_execute @ A @ ( heap_Time_ureturn @ A @ X ) )
      = ( comp @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ^ [H3: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H3 @ ( zero_zero @ nat ) ) ) ) ) ).

% execute_ureturn
thf(fact_3461_execute__update,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,V: A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ product_unit @ ( ref_update @ A @ R4 @ V ) @ H2 )
          = ( some @ ( product_prod @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ product_Unity @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( ref_set @ A @ R4 @ V @ H2 ) @ ( one_one @ nat ) ) ) ) ) ) ).

% execute_update
thf(fact_3462_effect__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_effect @ A )
      = ( ^ [C5: heap_Time_Heap @ A,H3: heap_ext @ product_unit,H8: heap_ext @ product_unit,R5: A,N5: nat] :
            ( ( heap_Time_execute @ A @ C5 @ H3 )
            = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H8 @ N5 ) ) ) ) ) ) ).

% effect_def
thf(fact_3463_effectI,axiom,
    ! [A: $tType,C2: heap_Time_Heap @ A,H2: heap_ext @ product_unit,R4: A,H4: heap_ext @ product_unit,N: nat] :
      ( ( ( heap_Time_execute @ A @ C2 @ H2 )
        = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R4 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H4 @ N ) ) ) )
     => ( heap_Time_effect @ A @ C2 @ H2 @ H4 @ R4 @ N ) ) ).

% effectI
thf(fact_3464_execute__bind__eq__SomeI,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit,X: A,H4: heap_ext @ product_unit,N: nat,G: A > ( heap_Time_Heap @ B ),Y: B,H6: heap_ext @ product_unit,N2: nat] :
      ( ( ( heap_Time_execute @ A @ F @ H2 )
        = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H4 @ N ) ) ) )
     => ( ( ( heap_Time_execute @ B @ ( G @ X ) @ H4 )
          = ( some @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ Y @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H6 @ N2 ) ) ) )
       => ( ( heap_Time_execute @ B @ ( heap_Time_bind @ A @ B @ F @ G ) @ H2 )
          = ( some @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ Y @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H6 @ ( plus_plus @ nat @ N @ N2 ) ) ) ) ) ) ) ).

% execute_bind_eq_SomeI
thf(fact_3465_success__bind__executeI,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit,X: A,H4: heap_ext @ product_unit,N: nat,G: A > ( heap_Time_Heap @ B )] :
      ( ( ( heap_Time_execute @ A @ F @ H2 )
        = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H4 @ N ) ) ) )
     => ( ( heap_Time_success @ B @ ( G @ X ) @ H4 )
       => ( heap_Time_success @ B @ ( heap_Time_bind @ A @ B @ F @ G ) @ H2 ) ) ) ).

% success_bind_executeI
thf(fact_3466_execute__assert_I1_J,axiom,
    ! [A: $tType,P: A > $o,X: A,H2: heap_ext @ product_unit] :
      ( ( P @ X )
     => ( ( heap_Time_execute @ A @ ( heap_Time_assert @ A @ P @ X ) @ H2 )
        = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( one_one @ nat ) ) ) ) ) ) ).

% execute_assert(1)
thf(fact_3467_execute__tap,axiom,
    ! [A: $tType,F: ( heap_ext @ product_unit ) > A,H2: heap_ext @ product_unit] :
      ( ( heap_Time_execute @ A @ ( heap_Time_tap @ A @ F ) @ H2 )
      = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( one_one @ nat ) ) ) ) ) ).

% execute_tap
thf(fact_3468_execute__return,axiom,
    ! [A: $tType,X: A] :
      ( ( heap_Time_execute @ A @ ( heap_Time_return @ A @ X ) )
      = ( comp @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ^ [H3: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H3 @ ( one_one @ nat ) ) ) ) ) ).

% execute_return
thf(fact_3469_ureturn__bind,axiom,
    ! [A: $tType,B: $tType,X: B,F: B > ( heap_Time_Heap @ A )] :
      ( ( heap_Time_bind @ B @ A @ ( heap_Time_ureturn @ B @ X ) @ F )
      = ( F @ X ) ) ).

% ureturn_bind
thf(fact_3470_bind__ureturn,axiom,
    ! [A: $tType,F: heap_Time_Heap @ A] :
      ( ( heap_Time_bind @ A @ A @ F @ ( heap_Time_ureturn @ A ) )
      = F ) ).

% bind_ureturn
thf(fact_3471_success__ureturnI,axiom,
    ! [A: $tType,X: A,H2: heap_ext @ product_unit] : ( heap_Time_success @ A @ ( heap_Time_ureturn @ A @ X ) @ H2 ) ).

% success_ureturnI
thf(fact_3472_effect__ureturnE,axiom,
    ! [A: $tType,X: A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( heap_Time_ureturn @ A @ X ) @ H2 @ H4 @ R4 @ N )
     => ~ ( ( R4 = X )
         => ( ( H4 = H2 )
           => ( N
             != ( zero_zero @ nat ) ) ) ) ) ).

% effect_ureturnE
thf(fact_3473_effect__ureturnI,axiom,
    ! [A: $tType,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,X: A] :
      ( ( H2 = H4 )
     => ( heap_Time_effect @ A @ ( heap_Time_ureturn @ A @ X ) @ H2 @ H4 @ X @ ( zero_zero @ nat ) ) ) ).

% effect_ureturnI
thf(fact_3474_hoare__triple__def,axiom,
    ! [A: $tType] :
      ( ( hoare_hoare_triple @ A )
      = ( ^ [P3: assn,C5: heap_Time_Heap @ A,Q3: A > assn] :
          ! [H3: heap_ext @ product_unit,As7: set @ nat] :
            ( ( rep_assn @ P3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As7 ) )
           => ? [R5: A,H8: heap_ext @ product_unit] :
                ( ? [T7: nat] :
                    ( ( heap_Time_execute @ A @ C5 @ H3 )
                    = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H8 @ T7 ) ) ) )
                & ( rep_assn @ ( Q3 @ R5 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ ( hoare_new_addrs @ H3 @ As7 @ H8 ) ) )
                & ( relH
                  @ ( collect @ nat
                    @ ^ [A5: nat] :
                        ( ( ord_less @ nat @ A5 @ ( lim @ product_unit @ H3 ) )
                        & ~ ( member @ nat @ A5 @ As7 ) ) )
                  @ H3
                  @ H8 )
                & ( ord_less_eq @ nat @ ( lim @ product_unit @ H3 ) @ ( lim @ product_unit @ H8 ) ) ) ) ) ) ).

% hoare_triple_def
thf(fact_3475_hoare__tripleI,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap @ A,Q: A > assn] :
      ( ! [H: heap_ext @ product_unit,As2: set @ nat] :
          ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
         => ? [R7: A,H7: heap_ext @ product_unit,T8: nat] :
              ( ( ( heap_Time_execute @ A @ C2 @ H )
                = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R7 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ T8 ) ) ) )
              & ( rep_assn @ ( Q @ R7 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( hoare_new_addrs @ H @ As2 @ H7 ) ) )
              & ( relH
                @ ( collect @ nat
                  @ ^ [A5: nat] :
                      ( ( ord_less @ nat @ A5 @ ( lim @ product_unit @ H ) )
                      & ~ ( member @ nat @ A5 @ As2 ) ) )
                @ H
                @ H7 )
              & ( ord_less_eq @ nat @ ( lim @ product_unit @ H ) @ ( lim @ product_unit @ H7 ) ) ) )
     => ( hoare_hoare_triple @ A @ P @ C2 @ Q ) ) ).

% hoare_tripleI
thf(fact_3476_sup__Some,axiom,
    ! [A: $tType] :
      ( ( sup @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ ( option @ A ) @ ( some @ A @ X ) @ ( some @ A @ Y ) )
          = ( some @ A @ ( sup_sup @ A @ X @ Y ) ) ) ) ).

% sup_Some
thf(fact_3477_inf__Some,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ ( option @ A ) @ ( some @ A @ X ) @ ( some @ A @ Y ) )
          = ( some @ A @ ( inf_inf @ A @ X @ Y ) ) ) ) ).

% inf_Some
thf(fact_3478_Some__SUP,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ B )
     => ! [A4: set @ A,F: A > B] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( some @ B @ ( complete_Sup_Sup @ B @ ( image2 @ A @ B @ F @ A4 ) ) )
            = ( complete_Sup_Sup @ ( option @ B )
              @ ( image2 @ A @ ( option @ B )
                @ ^ [X3: A] : ( some @ B @ ( F @ X3 ) )
                @ A4 ) ) ) ) ) ).

% Some_SUP
thf(fact_3479_rel__of__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_of @ A @ B )
      = ( ^ [M3: A > ( option @ B ),P3: ( product_prod @ A @ B ) > $o] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [K4: A,V3: B] :
                  ( ( ( M3 @ K4 )
                    = ( some @ B @ V3 ) )
                  & ( P3 @ ( product_Pair @ A @ B @ K4 @ V3 ) ) ) ) ) ) ) ).

% rel_of_def
thf(fact_3480_effect__guardI,axiom,
    ! [A: $tType,P: ( heap_ext @ product_unit ) > $o,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,F: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ),N: nat,R4: A] :
      ( ( P @ H2 )
     => ( ( H4
          = ( product_fst @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) ) )
       => ( ( N
            = ( product_snd @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) ) )
         => ( ( R4
              = ( product_fst @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) )
           => ( heap_Time_effect @ A @ ( heap_Time_guard @ A @ P @ F ) @ H2 @ H4 @ R4 @ N ) ) ) ) ) ).

% effect_guardI
thf(fact_3481_success__guardI,axiom,
    ! [A: $tType,P: ( heap_ext @ product_unit ) > $o,H2: heap_ext @ product_unit,F: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
      ( ( P @ H2 )
     => ( heap_Time_success @ A @ ( heap_Time_guard @ A @ P @ F ) @ H2 ) ) ).

% success_guardI
thf(fact_3482_execute__guard_I2_J,axiom,
    ! [A: $tType,P: ( heap_ext @ product_unit ) > $o,H2: heap_ext @ product_unit,F: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
      ( ( P @ H2 )
     => ( ( heap_Time_execute @ A @ ( heap_Time_guard @ A @ P @ F ) @ H2 )
        = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( F @ H2 ) ) ) ) ).

% execute_guard(2)
thf(fact_3483_Some__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( some @ A @ ( complete_Sup_Sup @ A @ A4 ) )
            = ( complete_Sup_Sup @ ( option @ A ) @ ( image2 @ A @ ( option @ A ) @ ( some @ A ) @ A4 ) ) ) ) ) ).

% Some_Sup
thf(fact_3484_effect__guardE,axiom,
    ! [A: $tType,P: ( heap_ext @ product_unit ) > $o,F: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ),H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( heap_Time_guard @ A @ P @ F ) @ H2 @ H4 @ R4 @ N )
     => ~ ( ( H4
            = ( product_fst @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) ) )
         => ( ( N
              = ( product_snd @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) ) )
           => ( ( R4
                = ( product_fst @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ H2 ) ) )
             => ~ ( P @ H2 ) ) ) ) ) ).

% effect_guardE
thf(fact_3485_execute__change,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [F: A > A,R4: ref @ A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ A @ ( ref_change @ A @ F @ R4 ) @ H2 )
          = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F @ ( ref_get @ A @ H2 @ R4 ) ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( ref_set @ A @ R4 @ ( F @ ( ref_get @ A @ H2 @ R4 ) ) @ H2 ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ) ) ) ).

% execute_change
thf(fact_3486_map__to__set__upd,axiom,
    ! [B: $tType,A: $tType,M4: A > ( option @ B ),K: A,V: B] :
      ( ( map_to_set @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M4 @ K @ ( some @ B @ V ) ) )
      = ( insert2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V )
        @ ( minus_minus @ ( set @ ( product_prod @ A @ B ) ) @ ( map_to_set @ A @ B @ M4 )
          @ ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu: product_prod @ A @ B] :
              ? [V5: B] :
                ( Uu
                = ( product_Pair @ A @ B @ K @ V5 ) ) ) ) ) ) ).

% map_to_set_upd
thf(fact_3487_effectE,axiom,
    ! [A: $tType,C2: heap_Time_Heap @ A,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ C2 @ H2 @ H4 @ R4 @ N )
     => ~ ( ( R4
            = ( product_fst @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( the2 @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( heap_Time_execute @ A @ C2 @ H2 ) ) ) )
         => ( ( H4
              = ( product_fst @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( the2 @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( heap_Time_execute @ A @ C2 @ H2 ) ) ) ) )
           => ( ( N
                = ( product_snd @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( the2 @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( heap_Time_execute @ A @ C2 @ H2 ) ) ) ) )
             => ~ ( heap_Time_success @ A @ C2 @ H2 ) ) ) ) ) ).

% effectE
thf(fact_3488_execute__bind_I1_J,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit,X: A,H4: heap_ext @ product_unit,N: nat,G: A > ( heap_Time_Heap @ B )] :
      ( ( ( heap_Time_execute @ A @ F @ H2 )
        = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H4 @ N ) ) ) )
     => ( ( heap_Time_execute @ B @ ( heap_Time_bind @ A @ B @ F @ G ) @ H2 )
        = ( heap_Time_timeFrame @ B @ N @ ( heap_Time_execute @ B @ ( G @ X ) @ H4 ) ) ) ) ).

% execute_bind(1)
thf(fact_3489_wait__def,axiom,
    ( heap_Time_wait
    = ( ^ [N5: nat] :
          ( heap_Time_Heap2 @ product_unit
          @ ^ [H3: heap_ext @ product_unit] : ( some @ ( product_prod @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ product_Unity @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H3 @ N5 ) ) ) ) ) ) ).

% wait_def
thf(fact_3490_Heap_Oinject,axiom,
    ! [A: $tType,X: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ),Ya: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( ( heap_Time_Heap2 @ A @ X )
        = ( heap_Time_Heap2 @ A @ Ya ) )
      = ( X = Ya ) ) ).

% Heap.inject
thf(fact_3491_Heap__execute,axiom,
    ! [A: $tType,F: heap_Time_Heap @ A] :
      ( ( heap_Time_Heap2 @ A @ ( heap_Time_execute @ A @ F ) )
      = F ) ).

% Heap_execute
thf(fact_3492_timeFrame__zero,axiom,
    ! [A: $tType,H2: option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
      ( ( heap_Time_timeFrame @ A @ ( zero_zero @ nat ) @ H2 )
      = H2 ) ).

% timeFrame_zero
thf(fact_3493_timeFrame__assoc,axiom,
    ! [A: $tType,N: nat,N2: nat,F: option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
      ( ( heap_Time_timeFrame @ A @ N @ ( heap_Time_timeFrame @ A @ N2 @ F ) )
      = ( heap_Time_timeFrame @ A @ ( plus_plus @ nat @ N @ N2 ) @ F ) ) ).

% timeFrame_assoc
thf(fact_3494_Heap_Oexhaust,axiom,
    ! [A: $tType,Y: heap_Time_Heap @ A] :
      ~ ! [X2: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
          ( Y
         != ( heap_Time_Heap2 @ A @ X2 ) ) ).

% Heap.exhaust
thf(fact_3495_execute_Osimps,axiom,
    ! [A: $tType,F: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( heap_Time_execute @ A @ ( heap_Time_Heap2 @ A @ F ) )
      = F ) ).

% execute.simps
thf(fact_3496_heap__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_heap @ A )
      = ( ^ [F2: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] : ( heap_Time_Heap2 @ A @ ( comp @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ F2 ) ) ) ) ).

% heap_def
thf(fact_3497_execute__bind__success,axiom,
    ! [B: $tType,A: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit,G: A > ( heap_Time_Heap @ B )] :
      ( ( heap_Time_success @ A @ F @ H2 )
     => ( ( heap_Time_execute @ B @ ( heap_Time_bind @ A @ B @ F @ G ) @ H2 )
        = ( heap_Time_timeFrame @ B @ ( product_snd @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( the2 @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( heap_Time_execute @ A @ F @ H2 ) ) ) ) @ ( heap_Time_execute @ B @ ( G @ ( product_fst @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( the2 @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( heap_Time_execute @ A @ F @ H2 ) ) ) ) @ ( product_fst @ ( heap_ext @ product_unit ) @ nat @ ( product_snd @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( the2 @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( heap_Time_execute @ A @ F @ H2 ) ) ) ) ) ) ) ) ).

% execute_bind_success
thf(fact_3498_tap__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_tap @ A )
      = ( ^ [F2: ( heap_ext @ product_unit ) > A] :
            ( heap_Time_Heap2 @ A
            @ ^ [H3: heap_ext @ product_unit] : ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F2 @ H3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% tap_def
thf(fact_3499_timeFrame_Osimps_I1_J,axiom,
    ! [A: $tType,N: nat,R4: A,H2: heap_ext @ product_unit,N2: nat] :
      ( ( heap_Time_timeFrame @ A @ N @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R4 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ N2 ) ) ) )
      = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R4 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( plus_plus @ nat @ N @ N2 ) ) ) ) ) ).

% timeFrame.simps(1)
thf(fact_3500_execute__lookup,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ A @ ( ref_lookup @ A @ R4 ) @ H2 )
          = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( ref_get @ A @ H2 @ R4 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( one_one @ nat ) ) ) ) ) ) ).

% execute_lookup
thf(fact_3501_comp__the__Some,axiom,
    ! [A: $tType] :
      ( ( comp @ ( option @ A ) @ A @ A @ ( the2 @ A ) @ ( some @ A ) )
      = ( id @ A ) ) ).

% comp_the_Some
thf(fact_3502_sngr__assn__raw_Osimps,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,X: A,H2: heap_ext @ product_unit,As: set @ nat] :
          ( ( sngr_assn_raw @ A @ R4 @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
          = ( ( ( ref_get @ A @ H2 @ R4 )
              = X )
            & ( As
              = ( insert2 @ nat @ ( addr_of_ref @ A @ R4 ) @ ( bot_bot @ ( set @ nat ) ) ) )
            & ( ord_less @ nat @ ( addr_of_ref @ A @ R4 ) @ ( lim @ product_unit @ H2 ) ) ) ) ) ).

% sngr_assn_raw.simps
thf(fact_3503_sngr__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( sngr_assn_raw @ A @ X @ Xa @ Xb )
            = Y )
         => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
               => ( Y
                  = ( ~ ( ( ( ref_get @ A @ H @ X )
                          = Xa )
                        & ( As2
                          = ( insert2 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.elims(1)
thf(fact_3504_sngr__assn__raw_Oelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( sngr_assn_raw @ A @ X @ Xa @ Xb )
         => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
               => ~ ( ( ( ref_get @ A @ H @ X )
                      = Xa )
                    & ( As2
                      = ( insert2 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                    & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H ) ) ) ) ) ) ).

% sngr_assn_raw.elims(2)
thf(fact_3505_sngr__assn__raw_Oelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( sngr_assn_raw @ A @ X @ Xa @ Xb )
         => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
               => ( ( ( ref_get @ A @ H @ X )
                    = Xa )
                  & ( As2
                    = ( insert2 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                  & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H ) ) ) ) ) ) ).

% sngr_assn_raw.elims(3)
thf(fact_3506_relH__ref,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [As: set @ nat,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: ref @ A] :
          ( ( relH @ As @ H2 @ H4 )
         => ( ( member @ nat @ ( addr_of_ref @ A @ R4 ) @ As )
           => ( ( ref_get @ A @ H2 @ R4 )
              = ( ref_get @ A @ H4 @ R4 ) ) ) ) ) ).

% relH_ref
thf(fact_3507_relH__set__ref,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,As: set @ nat,H2: heap_ext @ product_unit,X: A] :
          ( ~ ( member @ nat @ ( addr_of_ref @ A @ R4 ) @ As )
         => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
           => ( relH @ As @ H2 @ ( ref_set @ A @ R4 @ X @ H2 ) ) ) ) ) ).

% relH_set_ref
thf(fact_3508_Heap_Osize__gen,axiom,
    ! [A: $tType,Xa: A > nat,X: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( heap_Time_size_Heap @ A @ Xa @ ( heap_Time_Heap2 @ A @ X ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% Heap.size_gen
thf(fact_3509_sngr__assn__raw_Opelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( sngr_assn_raw @ A @ X @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                 => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) )
                   => ( ( ( ref_get @ A @ H @ X )
                        = Xa )
                      & ( As2
                        = ( insert2 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                      & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(3)
thf(fact_3510_sngr__assn__raw_Opelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( sngr_assn_raw @ A @ X @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                 => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) )
                   => ~ ( ( ( ref_get @ A @ H @ X )
                          = Xa )
                        & ( As2
                          = ( insert2 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(2)
thf(fact_3511_sngr__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( sngr_assn_raw @ A @ X @ Xa @ Xb )
            = Y )
         => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                 => ( ( Y
                      = ( ( ( ref_get @ A @ H @ X )
                          = Xa )
                        & ( As2
                          = ( insert2 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H ) ) ) )
                   => ~ ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(1)
thf(fact_3512_Heap_Osize_I2_J,axiom,
    ! [A: $tType,X: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( size_size @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap2 @ A @ X ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% Heap.size(2)
thf(fact_3513_Heap_Osize__neq,axiom,
    ! [A: $tType,X: heap_Time_Heap @ A] :
      ( ( size_size @ ( heap_Time_Heap @ A ) @ X )
     != ( zero_zero @ nat ) ) ).

% Heap.size_neq
thf(fact_3514_set__to__map__simp,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B ),K: A,V: B] :
      ( ( inj_on @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ S2 )
     => ( ( ( set_to_map @ A @ B @ S2 @ K )
          = ( some @ B @ V ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ S2 ) ) ) ).

% set_to_map_simp
thf(fact_3515_Chains__subset_H,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( refl_on @ A @ ( top_top @ ( set @ A ) ) @ R4 )
     => ( ord_less_eq @ ( set @ ( set @ A ) )
        @ ( collect @ ( set @ A )
          @ ( pred_chain @ A @ ( top_top @ ( set @ A ) )
            @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) ) )
        @ ( chains @ A @ R4 ) ) ) ).

% Chains_subset'
thf(fact_3516_timeFrame_Oelims,axiom,
    ! [A: $tType,X: nat,Xa: option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ),Y: option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
      ( ( ( heap_Time_timeFrame @ A @ X @ Xa )
        = Y )
     => ( ! [R3: A,H: heap_ext @ product_unit,N6: nat] :
            ( ( Xa
              = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ N6 ) ) ) )
           => ( Y
             != ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( plus_plus @ nat @ X @ N6 ) ) ) ) ) )
       => ~ ( ( Xa
              = ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) )
           => ( Y
             != ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ) ) ).

% timeFrame.elims
thf(fact_3517_the__dflt__None__nonempty,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( dflt_None_set @ A @ S2 )
        = ( some @ ( set @ A ) @ S2 ) ) ) ).

% the_dflt_None_nonempty
thf(fact_3518_Chains__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( chains @ A @ R4 )
      @ ( collect @ ( set @ A )
        @ ( pred_chain @ A @ ( top_top @ ( set @ A ) )
          @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) ) ) ) ).

% Chains_subset
thf(fact_3519_singleton__None__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ ( option @ A ) @ ( insert2 @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) )
        = ( none @ A ) ) ) ).

% singleton_None_Sup
thf(fact_3520_empty__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ ( option @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) )
        = ( none @ A ) ) ) ).

% empty_Sup
thf(fact_3521_inf__None__2,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ! [X: option @ A] :
          ( ( inf_inf @ ( option @ A ) @ X @ ( none @ A ) )
          = ( none @ A ) ) ) ).

% inf_None_2
thf(fact_3522_inf__None__1,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ! [Y: option @ A] :
          ( ( inf_inf @ ( option @ A ) @ ( none @ A ) @ Y )
          = ( none @ A ) ) ) ).

% inf_None_1
thf(fact_3523_not__Some__eq2,axiom,
    ! [B: $tType,A: $tType,V: option @ ( product_prod @ A @ B )] :
      ( ( ! [X3: A,Y2: B] :
            ( V
           != ( some @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) ) ) )
      = ( V
        = ( none @ ( product_prod @ A @ B ) ) ) ) ).

% not_Some_eq2
thf(fact_3524_set__to__map__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( set_to_map @ A @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ^ [X3: A] : ( none @ B ) ) ) ).

% set_to_map_empty
thf(fact_3525_map__to__set__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_to_set @ A @ B
        @ ^ [X3: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% map_to_set_empty
thf(fact_3526_rel__of__empty,axiom,
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ) > $o] :
      ( ( rel_of @ A @ B
        @ ^ [X3: A] : ( none @ B )
        @ P )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% rel_of_empty
thf(fact_3527_set__to__map__empty__iff_I2_J,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X3: A] : ( none @ B ) )
        = ( set_to_map @ A @ B @ S2 ) )
      = ( S2
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ).

% set_to_map_empty_iff(2)
thf(fact_3528_set__to__map__empty__iff_I1_J,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B )] :
      ( ( ( set_to_map @ A @ B @ S2 )
        = ( ^ [X3: A] : ( none @ B ) ) )
      = ( S2
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ).

% set_to_map_empty_iff(1)
thf(fact_3529_bot__option__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( bot_bot @ ( option @ A ) )
        = ( none @ A ) ) ) ).

% bot_option_def
thf(fact_3530_pred__on_Ochain__empty,axiom,
    ! [A: $tType,A4: set @ A,P: A > A > $o] : ( pred_chain @ A @ A4 @ P @ ( bot_bot @ ( set @ A ) ) ) ).

% pred_on.chain_empty
thf(fact_3531_timeFrame_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat] :
      ( ( heap_Time_timeFrame @ A @ N @ ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) )
      = ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ).

% timeFrame.simps(2)
thf(fact_3532_subset_Ochain__empty,axiom,
    ! [A: $tType,A4: set @ ( set @ A )] : ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ).

% subset.chain_empty
thf(fact_3533_execute__bind_I2_J,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit,G: A > ( heap_Time_Heap @ B )] :
      ( ( ( heap_Time_execute @ A @ F @ H2 )
        = ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) )
     => ( ( heap_Time_execute @ B @ ( heap_Time_bind @ A @ B @ F @ G ) @ H2 )
        = ( none @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ).

% execute_bind(2)
thf(fact_3534_successI,axiom,
    ! [A: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit] :
      ( ( ( heap_Time_execute @ A @ F @ H2 )
       != ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) )
     => ( heap_Time_success @ A @ F @ H2 ) ) ).

% successI
thf(fact_3535_success__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_success @ A )
      = ( ^ [F2: heap_Time_Heap @ A,H3: heap_ext @ product_unit] :
            ( ( heap_Time_execute @ A @ F2 @ H3 )
           != ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ) ).

% success_def
thf(fact_3536_map__to__set__empty__iff_I2_J,axiom,
    ! [B: $tType,A: $tType,M4: A > ( option @ B )] :
      ( ( ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) )
        = ( map_to_set @ A @ B @ M4 ) )
      = ( M4
        = ( ^ [X3: A] : ( none @ B ) ) ) ) ).

% map_to_set_empty_iff(2)
thf(fact_3537_map__to__set__empty__iff_I1_J,axiom,
    ! [B: $tType,A: $tType,M4: A > ( option @ B )] :
      ( ( ( map_to_set @ A @ B @ M4 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( M4
        = ( ^ [X3: A] : ( none @ B ) ) ) ) ).

% map_to_set_empty_iff(1)
thf(fact_3538_execute__guard_I1_J,axiom,
    ! [A: $tType,P: ( heap_ext @ product_unit ) > $o,H2: heap_ext @ product_unit,F: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
      ( ~ ( P @ H2 )
     => ( ( heap_Time_execute @ A @ ( heap_Time_guard @ A @ P @ F ) @ H2 )
        = ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ).

% execute_guard(1)
thf(fact_3539_execute__assert_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,H2: heap_ext @ product_unit] :
      ( ~ ( P @ X )
     => ( ( heap_Time_execute @ A @ ( heap_Time_assert @ A @ P @ X ) @ H2 )
        = ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ).

% execute_assert(2)
thf(fact_3540_execute__raise,axiom,
    ! [A: $tType,S: list @ char] :
      ( ( heap_Time_execute @ A @ ( heap_Time_raise @ A @ S ) )
      = ( ^ [Uu: heap_ext @ product_unit] : ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ).

% execute_raise
thf(fact_3541_raise__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_raise @ A )
      = ( ^ [S6: list @ char] :
            ( heap_Time_Heap2 @ A
            @ ^ [Uu: heap_ext @ product_unit] : ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ) ).

% raise_def
thf(fact_3542_Heap__cases,axiom,
    ! [A: $tType,F: heap_Time_Heap @ A,H2: heap_ext @ product_unit] :
      ( ! [X2: A,H5: product_prod @ ( heap_ext @ product_unit ) @ nat] :
          ( ( heap_Time_execute @ A @ F @ H2 )
         != ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X2 @ H5 ) ) )
     => ( ( heap_Time_execute @ A @ F @ H2 )
        = ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ).

% Heap_cases
thf(fact_3543_timeFrame_Ocases,axiom,
    ! [A: $tType,X: product_prod @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ! [N3: nat,R3: A,H: heap_ext @ product_unit,N6: nat] :
          ( X
         != ( product_Pair @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ N3 @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ N6 ) ) ) ) )
     => ~ ! [N3: nat] :
            ( X
           != ( product_Pair @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ N3 @ ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ) ).

% timeFrame.cases
thf(fact_3544_subset__Zorn__nonempty,axiom,
    ! [A: $tType,A18: set @ ( set @ A )] :
      ( ( A18
       != ( bot_bot @ ( set @ ( set @ A ) ) ) )
     => ( ! [C9: set @ ( set @ A )] :
            ( ( C9
             != ( bot_bot @ ( set @ ( set @ A ) ) ) )
           => ( ( pred_chain @ ( set @ A ) @ A18 @ ( ord_less @ ( set @ A ) ) @ C9 )
             => ( member @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ C9 ) @ A18 ) ) )
       => ? [X2: set @ A] :
            ( ( member @ ( set @ A ) @ X2 @ A18 )
            & ! [Xa2: set @ A] :
                ( ( member @ ( set @ A ) @ Xa2 @ A18 )
               => ( ( ord_less_eq @ ( set @ A ) @ X2 @ Xa2 )
                 => ( Xa2 = X2 ) ) ) ) ) ) ).

% subset_Zorn_nonempty
thf(fact_3545_guard__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_guard @ A )
      = ( ^ [P3: ( heap_ext @ product_unit ) > $o,F2: ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
            ( heap_Time_Heap2 @ A
            @ ^ [H3: heap_ext @ product_unit] : ( if @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( P3 @ H3 ) @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( F2 @ H3 ) ) @ ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ) ) ).

% guard_def
thf(fact_3546_Union__in__chain,axiom,
    ! [A: $tType,B13: set @ ( set @ A ),A18: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ B13 )
     => ( ( B13
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( pred_chain @ ( set @ A ) @ A18 @ ( ord_less @ ( set @ A ) ) @ B13 )
         => ( member @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ B13 ) @ B13 ) ) ) ) ).

% Union_in_chain
thf(fact_3547_Inter__in__chain,axiom,
    ! [A: $tType,B13: set @ ( set @ A ),A18: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ B13 )
     => ( ( B13
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( pred_chain @ ( set @ A ) @ A18 @ ( ord_less @ ( set @ A ) ) @ B13 )
         => ( member @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ B13 ) @ B13 ) ) ) ) ).

% Inter_in_chain
thf(fact_3548_subset_Ochain__extend,axiom,
    ! [A: $tType,A4: set @ ( set @ A ),C3: set @ ( set @ A ),Z2: set @ A] :
      ( ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ C3 )
     => ( ( member @ ( set @ A ) @ Z2 @ A4 )
       => ( ! [X2: set @ A] :
              ( ( member @ ( set @ A ) @ X2 @ C3 )
             => ( sup_sup @ ( ( set @ A ) > ( set @ A ) > $o ) @ ( ord_less @ ( set @ A ) )
                @ ^ [Y4: set @ A,Z5: set @ A] : ( Y4 = Z5 )
                @ X2
                @ Z2 ) )
         => ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( insert2 @ ( set @ A ) @ Z2 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) @ C3 ) ) ) ) ) ).

% subset.chain_extend
thf(fact_3549_pred__on_Ochain__extend,axiom,
    ! [A: $tType,A4: set @ A,P: A > A > $o,C3: set @ A,Z2: A] :
      ( ( pred_chain @ A @ A4 @ P @ C3 )
     => ( ( member @ A @ Z2 @ A4 )
       => ( ! [X2: A] :
              ( ( member @ A @ X2 @ C3 )
             => ( sup_sup @ ( A > A > $o ) @ P
                @ ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
                @ X2
                @ Z2 ) )
         => ( pred_chain @ A @ A4 @ P @ ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ Z2 @ ( bot_bot @ ( set @ A ) ) ) @ C3 ) ) ) ) ) ).

% pred_on.chain_extend
thf(fact_3550_finite__subset__Union__chain,axiom,
    ! [A: $tType,A4: set @ A,B13: set @ ( set @ A ),A18: set @ ( set @ A )] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ B13 ) )
       => ( ( B13
           != ( bot_bot @ ( set @ ( set @ A ) ) ) )
         => ( ( pred_chain @ ( set @ A ) @ A18 @ ( ord_less @ ( set @ A ) ) @ B13 )
           => ~ ! [B9: set @ A] :
                  ( ( member @ ( set @ A ) @ B9 @ B13 )
                 => ~ ( ord_less_eq @ ( set @ A ) @ A4 @ B9 ) ) ) ) ) ) ).

% finite_subset_Union_chain
thf(fact_3551_Chains__alt__def,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( refl_on @ A @ ( top_top @ ( set @ A ) ) @ R4 )
     => ( ( chains @ A @ R4 )
        = ( collect @ ( set @ A )
          @ ( pred_chain @ A @ ( top_top @ ( set @ A ) )
            @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) ) ) ) ) ).

% Chains_alt_def
thf(fact_3552_the__dflt__None__set,axiom,
    ! [A: $tType,X: set @ A] :
      ( ( the_default @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( dflt_None_set @ A @ X ) )
      = X ) ).

% the_dflt_None_set
thf(fact_3553_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( ^ [A10: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X3: A,Y2: option @ A] : ( some @ A @ ( case_option @ A @ A @ X3 @ ( sup_sup @ A @ X3 ) @ Y2 ) )
                @ ( none @ A )
                @ A10 ) ) ) ) ) ).

% Sup_fin.eq_fold'
thf(fact_3554_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( ^ [A10: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X3: A,Y2: option @ A] : ( some @ A @ ( case_option @ A @ A @ X3 @ ( inf_inf @ A @ X3 ) @ Y2 ) )
                @ ( none @ A )
                @ A10 ) ) ) ) ) ).

% Inf_fin.eq_fold'
thf(fact_3555_Heap__Time__Monad_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( heap_Time_bind @ A @ B )
      = ( ^ [F2: heap_Time_Heap @ A,G2: A > ( heap_Time_Heap @ B )] :
            ( heap_Time_Heap2 @ B
            @ ^ [H3: heap_ext @ product_unit] :
                ( case_option @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( none @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
                @ ( product_case_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
                  @ ^ [R5: A] :
                      ( product_case_prod @ ( heap_ext @ product_unit ) @ nat @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
                      @ ^ [H8: heap_ext @ product_unit,N5: nat] : ( heap_Time_timeFrame @ B @ N5 @ ( heap_Time_execute @ B @ ( G2 @ R5 ) @ H8 ) ) ) )
                @ ( heap_Time_execute @ A @ F2 @ H3 ) ) ) ) ) ).

% Heap_Time_Monad.bind_def
thf(fact_3556_Sup__option__def,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ ( option @ A ) )
        = ( ^ [A10: set @ ( option @ A )] :
              ( if @ ( option @ A )
              @ ( ( A10
                  = ( bot_bot @ ( set @ ( option @ A ) ) ) )
                | ( A10
                  = ( insert2 @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) )
              @ ( none @ A )
              @ ( some @ A @ ( complete_Sup_Sup @ A @ ( these @ A @ A10 ) ) ) ) ) ) ) ).

% Sup_option_def
thf(fact_3557_the__dflt__None__empty,axiom,
    ! [A: $tType] :
      ( ( dflt_None_set @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( none @ ( set @ A ) ) ) ).

% the_dflt_None_empty
thf(fact_3558_these__empty,axiom,
    ! [A: $tType] :
      ( ( these @ A @ ( bot_bot @ ( set @ ( option @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% these_empty
thf(fact_3559_these__empty__eq,axiom,
    ! [A: $tType,B3: set @ ( option @ A )] :
      ( ( ( these @ A @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( B3
          = ( bot_bot @ ( set @ ( option @ A ) ) ) )
        | ( B3
          = ( insert2 @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) ) ) ).

% these_empty_eq
thf(fact_3560_these__not__empty__eq,axiom,
    ! [A: $tType,B3: set @ ( option @ A )] :
      ( ( ( ( these @ A @ B3 )
         != ( bot_bot @ ( set @ A ) ) ) )
      = ( ( B3
         != ( bot_bot @ ( set @ ( option @ A ) ) ) )
        & ( B3
         != ( insert2 @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) ) ) ).

% these_not_empty_eq
thf(fact_3561_dflt__None__set__def,axiom,
    ! [A: $tType] :
      ( ( dflt_None_set @ A )
      = ( ^ [S7: set @ A] :
            ( if @ ( option @ ( set @ A ) )
            @ ( S7
              = ( bot_bot @ ( set @ A ) ) )
            @ ( none @ ( set @ A ) )
            @ ( some @ ( set @ A ) @ S7 ) ) ) ) ).

% dflt_None_set_def
thf(fact_3562_sup__option__def,axiom,
    ! [A: $tType] :
      ( ( sup @ A )
     => ( ( sup_sup @ ( option @ A ) )
        = ( ^ [X3: option @ A,Y2: option @ A] :
              ( case_option @ ( option @ A ) @ A @ Y2
              @ ^ [X9: A] :
                  ( case_option @ ( option @ A ) @ A @ X3
                  @ ^ [Z4: A] : ( some @ A @ ( sup_sup @ A @ X9 @ Z4 ) )
                  @ Y2 )
              @ X3 ) ) ) ) ).

% sup_option_def
thf(fact_3563_execute__bind__case,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap @ B,G: B > ( heap_Time_Heap @ A ),H2: heap_ext @ product_unit] :
      ( ( heap_Time_execute @ A @ ( heap_Time_bind @ B @ A @ F @ G ) @ H2 )
      = ( case_option @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ( product_case_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
          @ ^ [X3: B] :
              ( product_case_prod @ ( heap_ext @ product_unit ) @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
              @ ^ [H8: heap_ext @ product_unit,N5: nat] : ( heap_Time_timeFrame @ A @ N5 @ ( heap_Time_execute @ A @ ( G @ X3 ) @ H8 ) ) ) )
        @ ( heap_Time_execute @ B @ F @ H2 ) ) ) ).

% execute_bind_case
thf(fact_3564_inf__option__def,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ( ( inf_inf @ ( option @ A ) )
        = ( ^ [X3: option @ A,Y2: option @ A] :
              ( case_option @ ( option @ A ) @ A @ ( none @ A )
              @ ^ [Z4: A] :
                  ( case_option @ ( option @ A ) @ A @ ( none @ A )
                  @ ^ [Aa3: A] : ( some @ A @ ( inf_inf @ A @ Z4 @ Aa3 ) )
                  @ Y2 )
              @ X3 ) ) ) ) ).

% inf_option_def
thf(fact_3565_timeFrame_Opelims,axiom,
    ! [A: $tType,X: nat,Xa: option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ),Y: option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
      ( ( ( heap_Time_timeFrame @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ ( heap_T5500966940807335491me_rel @ A ) @ ( product_Pair @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ X @ Xa ) )
       => ( ! [R3: A,H: heap_ext @ product_unit,N6: nat] :
              ( ( Xa
                = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ N6 ) ) ) )
             => ( ( Y
                  = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( plus_plus @ nat @ X @ N6 ) ) ) ) )
               => ~ ( accp @ ( product_prod @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ ( heap_T5500966940807335491me_rel @ A ) @ ( product_Pair @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ X @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ N6 ) ) ) ) ) ) )
         => ~ ( ( Xa
                = ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) )
             => ( ( Y
                  = ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) )
               => ~ ( accp @ ( product_prod @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ ( heap_T5500966940807335491me_rel @ A ) @ ( product_Pair @ nat @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ X @ ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ) ) ) ) ) ).

% timeFrame.pelims
thf(fact_3566_execute__ref,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [V: A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( ref @ A ) @ ( ref_ref @ A @ V ) @ H2 )
          = ( some @ ( product_prod @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R5: ref @ A,H8: heap_ext @ product_unit] : ( product_Pair @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H8 @ ( one_one @ nat ) ) )
              @ ( ref_alloc @ A @ V @ H2 ) ) ) ) ) ).

% execute_ref
thf(fact_3567_ref__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_ref @ A )
        = ( ^ [V3: A] :
              ( heap_Time_heap @ ( ref @ A )
              @ ^ [H3: heap_ext @ product_unit] :
                  ( product_case_prod @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R5: ref @ A,H8: heap_ext @ product_unit] : ( product_Pair @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H8 @ ( one_one @ nat ) ) )
                  @ ( ref_alloc @ A @ V3 @ H3 ) ) ) ) ) ) ).

% ref_def
thf(fact_3568_map__upd__eq__restrict,axiom,
    ! [B: $tType,A: $tType,M4: A > ( option @ B ),X: A] :
      ( ( fun_upd @ A @ ( option @ B ) @ M4 @ X @ ( none @ B ) )
      = ( restrict_map @ A @ B @ M4 @ ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% map_upd_eq_restrict
thf(fact_3569_proj__iff,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) @ A4 )
       => ( ( ( equiv_proj @ A @ A @ R4 @ X )
            = ( equiv_proj @ A @ A @ R4 @ Y ) )
          = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 ) ) ) ) ).

% proj_iff
thf(fact_3570_quotient__eqI,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X5: set @ A,Y6: set @ A,X: A,Y: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A4 @ R4 ) )
       => ( ( member @ ( set @ A ) @ Y6 @ ( equiv_quotient @ A @ A4 @ R4 ) )
         => ( ( member @ A @ X @ X5 )
           => ( ( member @ A @ Y @ Y6 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
               => ( X5 = Y6 ) ) ) ) ) ) ) ).

% quotient_eqI
thf(fact_3571_quotient__eq__iff,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X5: set @ A,Y6: set @ A,X: A,Y: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A4 @ R4 ) )
       => ( ( member @ ( set @ A ) @ Y6 @ ( equiv_quotient @ A @ A4 @ R4 ) )
         => ( ( member @ A @ X @ X5 )
           => ( ( member @ A @ Y @ Y6 )
             => ( ( X5 = Y6 )
                = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 ) ) ) ) ) ) ) ).

% quotient_eq_iff
thf(fact_3572_in__quotient__imp__closed,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X5: set @ A,X: A,Y: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A4 @ R4 ) )
       => ( ( member @ A @ X @ X5 )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
           => ( member @ A @ Y @ X5 ) ) ) ) ) ).

% in_quotient_imp_closed
thf(fact_3573_in__quotient__imp__non__empty,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X5: set @ A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A4 @ R4 ) )
       => ( X5
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% in_quotient_imp_non_empty
thf(fact_3574_equiv__class__self,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ A @ A3 @ A4 )
       => ( member @ A @ A3 @ ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% equiv_class_self
thf(fact_3575_quotient__disj,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X5: set @ A,Y6: set @ A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A4 @ R4 ) )
       => ( ( member @ ( set @ A ) @ Y6 @ ( equiv_quotient @ A @ A4 @ R4 ) )
         => ( ( X5 = Y6 )
            | ( ( inf_inf @ ( set @ A ) @ X5 @ Y6 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% quotient_disj
thf(fact_3576_effect__refI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,H4: heap_ext @ product_unit,V: A,H2: heap_ext @ product_unit,N: nat] :
          ( ( ( product_Pair @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ R4 @ H4 )
            = ( ref_alloc @ A @ V @ H2 ) )
         => ( ( N
              = ( one_one @ nat ) )
           => ( heap_Time_effect @ ( ref @ A ) @ ( ref_ref @ A @ V ) @ H2 @ H4 @ R4 @ N ) ) ) ) ).

% effect_refI
thf(fact_3577_equiv__proj,axiom,
    ! [A: $tType,A4: set @ A,R: set @ ( product_prod @ A @ A ),Z2: product_prod @ A @ A] :
      ( ( equiv_equiv @ A @ A4 @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ Z2 @ R )
       => ( ( comp @ A @ ( set @ A ) @ ( product_prod @ A @ A ) @ ( equiv_proj @ A @ A @ R ) @ ( product_fst @ A @ A ) @ Z2 )
          = ( comp @ A @ ( set @ A ) @ ( product_prod @ A @ A ) @ ( equiv_proj @ A @ A @ R ) @ ( product_snd @ A @ A ) @ Z2 ) ) ) ) ).

% equiv_proj
thf(fact_3578_equiv__class__eq__iff,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
        = ( ( ( image @ A @ A @ R4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
            = ( image @ A @ A @ R4 @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( member @ A @ X @ A4 )
          & ( member @ A @ Y @ A4 ) ) ) ) ).

% equiv_class_eq_iff
thf(fact_3579_eq__equiv__class__iff,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ A @ X @ A4 )
       => ( ( member @ A @ Y @ A4 )
         => ( ( ( image @ A @ A @ R4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( image @ A @ A @ R4 @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 ) ) ) ) ) ).

% eq_equiv_class_iff
thf(fact_3580_equiv__class__eq,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
       => ( ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
          = ( image @ A @ A @ R4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% equiv_class_eq
thf(fact_3581_eq__equiv__class,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A,A4: set @ A] :
      ( ( ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( image @ A @ A @ R4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
     => ( ( equiv_equiv @ A @ A4 @ R4 )
       => ( ( member @ A @ B2 @ A4 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) ) ) ) ).

% eq_equiv_class
thf(fact_3582_eq__equiv__class__iff2,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ A @ X @ A4 )
       => ( ( member @ A @ Y @ A4 )
         => ( ( ( equiv_quotient @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) @ R4 )
              = ( equiv_quotient @ A @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) @ R4 ) )
            = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 ) ) ) ) ) ).

% eq_equiv_class_iff2
thf(fact_3583_refines__equiv__class__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A ),A4: set @ A,A3: A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S2 )
     => ( ( equiv_equiv @ A @ A4 @ R )
       => ( ( equiv_equiv @ A @ A4 @ S2 )
         => ( ( image @ A @ A @ R @ ( image @ A @ A @ S2 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( image @ A @ A @ S2 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% refines_equiv_class_eq
thf(fact_3584_refines__equiv__class__eq2,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A ),A4: set @ A,A3: A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S2 )
     => ( ( equiv_equiv @ A @ A4 @ R )
       => ( ( equiv_equiv @ A @ A4 @ S2 )
         => ( ( image @ A @ A @ S2 @ ( image @ A @ A @ R @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( image @ A @ A @ S2 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% refines_equiv_class_eq2
thf(fact_3585_equiv__class__subset,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
       => ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% equiv_class_subset
thf(fact_3586_subset__equiv__class,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),B2: A,A3: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( ( member @ A @ B2 @ A4 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) ) ) ) ).

% subset_equiv_class
thf(fact_3587_equiv__class__nondisjoint,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X: A,A3: A,B2: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ A @ X @ ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) ) ) ).

% equiv_class_nondisjoint
thf(fact_3588_in__quotient__imp__in__rel,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),X5: set @ A,X: A,Y: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A4 @ R4 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) @ X5 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 ) ) ) ) ).

% in_quotient_imp_in_rel
thf(fact_3589_restrict__upd__same,axiom,
    ! [B: $tType,A: $tType,M4: A > ( option @ B ),X: A,Y: B] :
      ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M4 @ X @ ( some @ B @ Y ) ) @ ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( restrict_map @ A @ B @ M4 @ ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% restrict_upd_same
thf(fact_3590_fun__upd__None__restrict,axiom,
    ! [B: $tType,A: $tType,X: A,D4: set @ A,M4: A > ( option @ B )] :
      ( ( ( member @ A @ X @ D4 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M4 @ D4 ) @ X @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M4 @ ( minus_minus @ ( set @ A ) @ D4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )
      & ( ~ ( member @ A @ X @ D4 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M4 @ D4 ) @ X @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M4 @ D4 ) ) ) ) ).

% fun_upd_None_restrict
thf(fact_3591_restrict__fun__upd,axiom,
    ! [B: $tType,A: $tType,X: A,D4: set @ A,M4: A > ( option @ B ),Y: option @ B] :
      ( ( ( member @ A @ X @ D4 )
       => ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M4 @ X @ Y ) @ D4 )
          = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M4 @ ( minus_minus @ ( set @ A ) @ D4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X @ Y ) ) )
      & ( ~ ( member @ A @ X @ D4 )
       => ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M4 @ X @ Y ) @ D4 )
          = ( restrict_map @ A @ B @ M4 @ D4 ) ) ) ) ).

% restrict_fun_upd
thf(fact_3592_fun__upd__restrict__conv,axiom,
    ! [A: $tType,B: $tType,X: A,D4: set @ A,M4: A > ( option @ B ),Y: option @ B] :
      ( ( member @ A @ X @ D4 )
     => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M4 @ D4 ) @ X @ Y )
        = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M4 @ ( minus_minus @ ( set @ A ) @ D4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X @ Y ) ) ) ).

% fun_upd_restrict_conv
thf(fact_3593_restrict__map__to__empty,axiom,
    ! [B: $tType,A: $tType,M4: A > ( option @ B )] :
      ( ( restrict_map @ A @ B @ M4 @ ( bot_bot @ ( set @ A ) ) )
      = ( ^ [X3: A] : ( none @ B ) ) ) ).

% restrict_map_to_empty
thf(fact_3594_restrict__restrict,axiom,
    ! [B: $tType,A: $tType,M4: A > ( option @ B ),A4: set @ A,B3: set @ A] :
      ( ( restrict_map @ A @ B @ ( restrict_map @ A @ B @ M4 @ A4 ) @ B3 )
      = ( restrict_map @ A @ B @ M4 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ).

% restrict_restrict
thf(fact_3595_fun__upd__restrict,axiom,
    ! [A: $tType,B: $tType,M4: A > ( option @ B ),D4: set @ A,X: A,Y: option @ B] :
      ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M4 @ D4 ) @ X @ Y )
      = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M4 @ ( minus_minus @ ( set @ A ) @ D4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X @ Y ) ) ).

% fun_upd_restrict
thf(fact_3596_restrict__complement__singleton__eq,axiom,
    ! [A: $tType,B: $tType,F: A > ( option @ B ),X: A] :
      ( ( restrict_map @ A @ B @ F @ ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( fun_upd @ A @ ( option @ B ) @ F @ X @ ( none @ B ) ) ) ).

% restrict_complement_singleton_eq
thf(fact_3597_UN__equiv__class2,axiom,
    ! [A: $tType,C: $tType,B: $tType,A16: set @ A,R1: set @ ( product_prod @ A @ A ),A24: set @ B,R22: set @ ( product_prod @ B @ B ),F: A > B > ( set @ C ),A1: A,A22: B] :
      ( ( equiv_equiv @ A @ A16 @ R1 )
     => ( ( equiv_equiv @ B @ A24 @ R22 )
       => ( ( equiv_congruent2 @ A @ B @ ( set @ C ) @ R1 @ R22 @ F )
         => ( ( member @ A @ A1 @ A16 )
           => ( ( member @ B @ A22 @ A24 )
             => ( ( complete_Sup_Sup @ ( set @ C )
                  @ ( image2 @ A @ ( set @ C )
                    @ ^ [X13: A] : ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ ( F @ X13 ) @ ( image @ B @ B @ R22 @ ( insert2 @ B @ A22 @ ( bot_bot @ ( set @ B ) ) ) ) ) )
                    @ ( image @ A @ A @ R1 @ ( insert2 @ A @ A1 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                = ( F @ A1 @ A22 ) ) ) ) ) ) ) ).

% UN_equiv_class2
thf(fact_3598_UN__equiv__class,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),F: A > ( set @ B ),A3: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( equiv_congruent @ A @ ( set @ B ) @ R4 @ F )
       => ( ( member @ A @ A3 @ A4 )
         => ( ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F @ ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            = ( F @ A3 ) ) ) ) ) ).

% UN_equiv_class
thf(fact_3599_UN__equiv__class__inject,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),F: A > ( set @ B ),X5: set @ A,Y6: set @ A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( equiv_congruent @ A @ ( set @ B ) @ R4 @ F )
       => ( ( ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F @ X5 ) )
            = ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ F @ Y6 ) ) )
         => ( ( member @ ( set @ A ) @ X5 @ ( equiv_quotient @ A @ A4 @ R4 ) )
           => ( ( member @ ( set @ A ) @ Y6 @ ( equiv_quotient @ A @ A4 @ R4 ) )
             => ( ! [X2: A,Y3: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ( member @ A @ Y3 @ A4 )
                     => ( ( ( F @ X2 )
                          = ( F @ Y3 ) )
                       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R4 ) ) ) )
               => ( X5 = Y6 ) ) ) ) ) ) ) ).

% UN_equiv_class_inject
thf(fact_3600_graph__map__upd,axiom,
    ! [A: $tType,B: $tType,M4: A > ( option @ B ),K: A,V: B] :
      ( ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M4 @ K @ ( some @ B @ V ) ) )
      = ( insert2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M4 @ K @ ( none @ B ) ) ) ) ) ).

% graph_map_upd
thf(fact_3601_Ref__Time_Oalloc__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_alloc @ A )
        = ( ^ [X3: A,H3: heap_ext @ product_unit] :
              ( product_Pair @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ ( ref2 @ A @ ( lim @ product_unit @ H3 ) )
              @ ( ref_set @ A @ ( ref2 @ A @ ( lim @ product_unit @ H3 ) ) @ X3
                @ ( lim_update @ product_unit
                  @ ^ [Uu: nat] : ( plus_plus @ nat @ ( lim @ product_unit @ H3 ) @ ( one_one @ nat ) )
                  @ H3 ) ) ) ) ) ) ).

% Ref_Time.alloc_def
thf(fact_3602_graph__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B
        @ ^ [X3: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% graph_empty
thf(fact_3603_congruent2I_H,axiom,
    ! [C: $tType,B: $tType,A: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),F: A > B > C] :
      ( ! [Y12: A,Z1: A,Y23: B,Z22: B] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y12 @ Z1 ) @ R1 )
         => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y23 @ Z22 ) @ R22 )
           => ( ( F @ Y12 @ Y23 )
              = ( F @ Z1 @ Z22 ) ) ) )
     => ( equiv_congruent2 @ A @ B @ C @ R1 @ R22 @ F ) ) ).

% congruent2I'
thf(fact_3604_congruent2D,axiom,
    ! [A: $tType,C: $tType,B: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),F: A > B > C,Y1: A,Z12: A,Y22: B,Z23: B] :
      ( ( equiv_congruent2 @ A @ B @ C @ R1 @ R22 @ F )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y1 @ Z12 ) @ R1 )
       => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y22 @ Z23 ) @ R22 )
         => ( ( F @ Y1 @ Y22 )
            = ( F @ Z12 @ Z23 ) ) ) ) ) ).

% congruent2D
thf(fact_3605_congruentI,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),F: A > B] :
      ( ! [Y3: A,Z3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ R4 )
         => ( ( F @ Y3 )
            = ( F @ Z3 ) ) )
     => ( equiv_congruent @ A @ B @ R4 @ F ) ) ).

% congruentI
thf(fact_3606_congruentD,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),F: A > B,Y: A,Z2: A] :
      ( ( equiv_congruent @ A @ B @ R4 @ F )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ R4 )
       => ( ( F @ Y )
          = ( F @ Z2 ) ) ) ) ).

% congruentD
thf(fact_3607_in__graphD,axiom,
    ! [A: $tType,B: $tType,K: A,V: B,M4: A > ( option @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ M4 ) )
     => ( ( M4 @ K )
        = ( some @ B @ V ) ) ) ).

% in_graphD
thf(fact_3608_in__graphI,axiom,
    ! [A: $tType,B: $tType,M4: B > ( option @ A ),K: B,V: A] :
      ( ( ( M4 @ K )
        = ( some @ A @ V ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ V ) @ ( graph @ B @ A @ M4 ) ) ) ).

% in_graphI
thf(fact_3609_graph__restrictD_I1_J,axiom,
    ! [B: $tType,A: $tType,K: A,V: B,M4: A > ( option @ B ),A4: set @ A] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ ( restrict_map @ A @ B @ M4 @ A4 ) ) )
     => ( member @ A @ K @ A4 ) ) ).

% graph_restrictD(1)
thf(fact_3610_graph__restrictD_I2_J,axiom,
    ! [A: $tType,B: $tType,K: A,V: B,M4: A > ( option @ B ),A4: set @ A] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ ( restrict_map @ A @ B @ M4 @ A4 ) ) )
     => ( ( M4 @ K )
        = ( some @ B @ V ) ) ) ).

% graph_restrictD(2)
thf(fact_3611_graph__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M3: A > ( option @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu: product_prod @ A @ B] :
              ? [A5: A,B4: B] :
                ( ( Uu
                  = ( product_Pair @ A @ B @ A5 @ B4 ) )
                & ( ( M3 @ A5 )
                  = ( some @ B @ B4 ) ) ) ) ) ) ).

% graph_def
thf(fact_3612_congruent2__commuteI,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),F: A > A > B] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ! [Y3: A,Z3: A] :
            ( ( member @ A @ Y3 @ A4 )
           => ( ( member @ A @ Z3 @ A4 )
             => ( ( F @ Y3 @ Z3 )
                = ( F @ Z3 @ Y3 ) ) ) )
       => ( ! [Y3: A,Z3: A,W: A] :
              ( ( member @ A @ W @ A4 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ R4 )
               => ( ( F @ W @ Y3 )
                  = ( F @ W @ Z3 ) ) ) )
         => ( equiv_congruent2 @ A @ A @ B @ R4 @ R4 @ F ) ) ) ) ).

% congruent2_commuteI
thf(fact_3613_congruent2I,axiom,
    ! [C: $tType,B: $tType,A: $tType,A16: set @ A,R1: set @ ( product_prod @ A @ A ),A24: set @ B,R22: set @ ( product_prod @ B @ B ),F: A > B > C] :
      ( ( equiv_equiv @ A @ A16 @ R1 )
     => ( ( equiv_equiv @ B @ A24 @ R22 )
       => ( ! [Y3: A,Z3: A,W: B] :
              ( ( member @ B @ W @ A24 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ R1 )
               => ( ( F @ Y3 @ W )
                  = ( F @ Z3 @ W ) ) ) )
         => ( ! [Y3: B,Z3: B,W: A] :
                ( ( member @ A @ W @ A16 )
               => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y3 @ Z3 ) @ R22 )
                 => ( ( F @ W @ Y3 )
                    = ( F @ W @ Z3 ) ) ) )
           => ( equiv_congruent2 @ A @ B @ C @ R1 @ R22 @ F ) ) ) ) ) ).

% congruent2I
thf(fact_3614_congruent2__implies__congruent__UN,axiom,
    ! [B: $tType,C: $tType,A: $tType,A16: set @ A,R1: set @ ( product_prod @ A @ A ),A24: set @ B,R22: set @ ( product_prod @ B @ B ),F: A > B > ( set @ C ),A3: B] :
      ( ( equiv_equiv @ A @ A16 @ R1 )
     => ( ( equiv_equiv @ B @ A24 @ R22 )
       => ( ( equiv_congruent2 @ A @ B @ ( set @ C ) @ R1 @ R22 @ F )
         => ( ( member @ B @ A3 @ A24 )
           => ( equiv_congruent @ A @ ( set @ C ) @ R1
              @ ^ [X13: A] : ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ ( F @ X13 ) @ ( image @ B @ B @ R22 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ) ).

% congruent2_implies_congruent_UN
thf(fact_3615_disjnt__equiv__class,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( equiv_equiv @ A @ A4 @ R4 )
     => ( ( disjnt @ A @ ( image @ A @ A @ R4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) ) ) ) ).

% disjnt_equiv_class
thf(fact_3616_cINF__UNION,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [A4: set @ C,B3: C > ( set @ D ),F: D > B] :
          ( ( A4
           != ( bot_bot @ ( set @ C ) ) )
         => ( ! [X2: C] :
                ( ( member @ C @ X2 @ A4 )
               => ( ( B3 @ X2 )
                 != ( bot_bot @ ( set @ D ) ) ) )
           => ( ( condit1013018076250108175_below @ B
                @ ( complete_Sup_Sup @ ( set @ B )
                  @ ( image2 @ C @ ( set @ B )
                    @ ^ [X3: C] : ( image2 @ D @ B @ F @ ( B3 @ X3 ) )
                    @ A4 ) ) )
             => ( ( complete_Inf_Inf @ B @ ( image2 @ D @ B @ F @ ( complete_Sup_Sup @ ( set @ D ) @ ( image2 @ C @ ( set @ D ) @ B3 @ A4 ) ) ) )
                = ( complete_Inf_Inf @ B
                  @ ( image2 @ C @ B
                    @ ^ [X3: C] : ( complete_Inf_Inf @ B @ ( image2 @ D @ B @ F @ ( B3 @ X3 ) ) )
                    @ A4 ) ) ) ) ) ) ) ).

% cINF_UNION
thf(fact_3617_finite__def,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( complete_lattice_lfp @ ( ( set @ A ) > $o )
        @ ^ [P6: ( set @ A ) > $o,X3: set @ A] :
            ( ( X3
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A10: set @ A,A5: A] :
                ( ( X3
                  = ( insert2 @ A @ A5 @ A10 ) )
                & ( P6 @ A10 ) ) ) ) ) ).

% finite_def
thf(fact_3618_bsqr__max2,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A1: A,A22: A,B14: A,B24: A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( member @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) @ ( product_Pair @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( product_Pair @ A @ A @ B14 @ B24 ) ) @ ( bNF_Wellorder_bsqr @ A @ R4 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( bNF_We1388413361240627857o_max2 @ A @ R4 @ A1 @ A22 ) @ ( bNF_We1388413361240627857o_max2 @ A @ R4 @ B14 @ B24 ) ) @ R4 ) ) ) ).

% bsqr_max2
thf(fact_3619_bdd__below__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit1013018076250108175_below @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% bdd_below_empty
thf(fact_3620_disjnt__self__iff__empty,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( disjnt @ A @ S2 @ S2 )
      = ( S2
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% disjnt_self_iff_empty
thf(fact_3621_bdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F: B > A,G: B > A,A4: set @ B] :
          ( ( condit1013018076250108175_below @ A
            @ ( image2 @ B @ A
              @ ^ [X3: B] : ( inf_inf @ A @ ( F @ X3 ) @ ( G @ X3 ) )
              @ A4 ) )
          = ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F @ A4 ) )
            & ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ G @ A4 ) ) ) ) ) ).

% bdd_below_image_inf
thf(fact_3622_disjnt__Times1__iff,axiom,
    ! [A: $tType,B: $tType,C3: set @ A,A4: set @ B,B3: set @ B] :
      ( ( disjnt @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ C3
          @ ^ [Uu: A] : A4 )
        @ ( product_Sigma @ A @ B @ C3
          @ ^ [Uu: A] : B3 ) )
      = ( ( C3
          = ( bot_bot @ ( set @ A ) ) )
        | ( disjnt @ B @ A4 @ B3 ) ) ) ).

% disjnt_Times1_iff
thf(fact_3623_disjnt__Times2__iff,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,C3: set @ B,B3: set @ A] :
      ( ( disjnt @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A4
          @ ^ [Uu: A] : C3 )
        @ ( product_Sigma @ A @ B @ B3
          @ ^ [Uu: A] : C3 ) )
      = ( ( C3
          = ( bot_bot @ ( set @ B ) ) )
        | ( disjnt @ A @ A4 @ B3 ) ) ) ).

% disjnt_Times2_iff
thf(fact_3624_disjnt__empty2,axiom,
    ! [A: $tType,A4: set @ A] : ( disjnt @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ).

% disjnt_empty2
thf(fact_3625_disjnt__empty1,axiom,
    ! [A: $tType,A4: set @ A] : ( disjnt @ A @ ( bot_bot @ ( set @ A ) ) @ A4 ) ).

% disjnt_empty1
thf(fact_3626_bdd__below__Int2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B3: set @ A,A4: set @ A] :
          ( ( condit1013018076250108175_below @ A @ B3 )
         => ( condit1013018076250108175_below @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% bdd_below_Int2
thf(fact_3627_bdd__below__Int1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A4 )
         => ( condit1013018076250108175_below @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% bdd_below_Int1
thf(fact_3628_well__order__on__domain,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( order_well_order_on @ A @ A4 @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
       => ( ( member @ A @ A3 @ A4 )
          & ( member @ A @ B2 @ A4 ) ) ) ) ).

% well_order_on_domain
thf(fact_3629_disjnt__Sigma__iff,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,C3: A > ( set @ B ),B3: set @ A] :
      ( ( disjnt @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ A4 @ C3 ) @ ( product_Sigma @ A @ B @ B3 @ C3 ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
           => ( ( C3 @ X3 )
              = ( bot_bot @ ( set @ B ) ) ) )
        | ( disjnt @ A @ A4 @ B3 ) ) ) ).

% disjnt_Sigma_iff
thf(fact_3630_well__order__on__empty,axiom,
    ! [A: $tType] : ( order_well_order_on @ A @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% well_order_on_empty
thf(fact_3631_disjnt__def,axiom,
    ! [A: $tType] :
      ( ( disjnt @ A )
      = ( ^ [A10: set @ A,B7: set @ A] :
            ( ( inf_inf @ ( set @ A ) @ A10 @ B7 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjnt_def
thf(fact_3632_le__cInf__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A,A3: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S2 )
           => ( ( ord_less_eq @ A @ A3 @ ( complete_Inf_Inf @ A @ S2 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ord_less_eq @ A @ A3 @ X3 ) ) ) ) ) ) ) ).

% le_cInf_iff
thf(fact_3633_cInf__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B3: set @ A,A4: set @ A] :
          ( ( B3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A4 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ B3 )
                 => ? [X6: A] :
                      ( ( member @ A @ X6 @ A4 )
                      & ( ord_less_eq @ A @ X6 @ B6 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B3 ) ) ) ) ) ) ).

% cInf_mono
thf(fact_3634_cInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X5: set @ A,Y: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X5 )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X5 ) @ Y )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ X5 )
                    & ( ord_less @ A @ X3 @ Y ) ) ) ) ) ) ) ).

% cInf_less_iff
thf(fact_3635_Well__order__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( order_well_order_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A4
              @ ^ [Uu: A] : A4 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) ) ) ).

% Well_order_Restr
thf(fact_3636_cINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B3: set @ B,F: C > A,A4: set @ C,G: B > A] :
          ( ( B3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ C @ A @ F @ A4 ) )
           => ( ! [M5: B] :
                  ( ( member @ B @ M5 @ B3 )
                 => ? [X6: C] :
                      ( ( member @ C @ X6 @ A4 )
                      & ( ord_less_eq @ A @ ( F @ X6 ) @ ( G @ M5 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ C @ A @ F @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% cINF_mono
thf(fact_3637_le__cINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F: B > A,U: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F @ A4 ) )
           => ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ A4 )
                   => ( ord_less_eq @ A @ U @ ( F @ X3 ) ) ) ) ) ) ) ) ).

% le_cINF_iff
thf(fact_3638_cInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ B3 )
           => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ B3 ) @ ( complete_Inf_Inf @ A @ A4 ) ) ) ) ) ) ).

% cInf_superset_mono
thf(fact_3639_cInf__insert,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A3: A] :
          ( ( X5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X5 )
           => ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ A3 @ X5 ) )
              = ( inf_inf @ A @ A3 @ ( complete_Inf_Inf @ A @ X5 ) ) ) ) ) ) ).

% cInf_insert
thf(fact_3640_cInf__insert__If,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X5: set @ A,A3: A] :
          ( ( condit1013018076250108175_below @ A @ X5 )
         => ( ( ( X5
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ A3 @ X5 ) )
                = A3 ) )
            & ( ( X5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert2 @ A @ A3 @ X5 ) )
                = ( inf_inf @ A @ A3 @ ( complete_Inf_Inf @ A @ X5 ) ) ) ) ) ) ) ).

% cInf_insert_If
thf(fact_3641_cInf__union__distrib,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A4 )
           => ( ( B3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit1013018076250108175_below @ A @ B3 )
               => ( ( complete_Inf_Inf @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
                  = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B3 ) ) ) ) ) ) ) ) ).

% cInf_union_distrib
thf(fact_3642_well__order__on__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( field2 @ A @ R4 ) )
       => ( order_well_order_on @ A @ A4
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A4
              @ ^ [Uu: A] : A4 ) ) ) ) ) ).

% well_order_on_Restr
thf(fact_3643_cINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A4: set @ B,F: B > A,A3: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F @ A4 ) )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ A3 )
              = ( ? [X3: B] :
                    ( ( member @ B @ X3 @ A4 )
                    & ( ord_less @ A @ ( F @ X3 ) @ A3 ) ) ) ) ) ) ) ).

% cINF_less_iff
thf(fact_3644_cINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F: B > A,G: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F @ A4 ) )
           => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ G @ A4 ) )
             => ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ A4 ) ) )
                = ( complete_Inf_Inf @ A
                  @ ( image2 @ B @ A
                    @ ^ [A5: B] : ( inf_inf @ A @ ( F @ A5 ) @ ( G @ A5 ) )
                    @ A4 ) ) ) ) ) ) ) ).

% cINF_inf_distrib
thf(fact_3645_Linear__order__Well__order__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( order_679001287576687338der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
        = ( ! [A10: set @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ A10 @ ( field2 @ A @ R4 ) )
             => ( ( A10
                 != ( bot_bot @ ( set @ A ) ) )
               => ? [X3: A] :
                    ( ( member @ A @ X3 @ A10 )
                    & ! [Y2: A] :
                        ( ( member @ A @ Y2 @ A10 )
                       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) ) ) ) ) ) ) ) ).

% Linear_order_Well_order_iff
thf(fact_3646_cINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,G: B > A,B3: set @ B,F: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ G @ B3 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B3 )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ B3 )
                   => ( ord_less_eq @ A @ ( G @ X2 ) @ ( F @ X2 ) ) )
               => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ B3 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) ) ) ) ) ) ) ).

% cINF_superset_mono
thf(fact_3647_less__eq__cInf__inter,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A4 )
         => ( ( condit1013018076250108175_below @ A @ B3 )
           => ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B3 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ) ) ) ).

% less_eq_cInf_inter
thf(fact_3648_cINF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F: B > A,A3: B] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F @ A4 ) )
           => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ ( insert2 @ B @ A3 @ A4 ) ) )
              = ( inf_inf @ A @ ( F @ A3 ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) ) ) ) ) ) ).

% cINF_insert
thf(fact_3649_cINF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F: B > A,B3: set @ B] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F @ A4 ) )
           => ( ( B3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F @ B3 ) )
               => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) )
                  = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ B3 ) ) ) ) ) ) ) ) ) ).

% cINF_union
thf(fact_3650_cInf__le__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A4 )
           => ( ( condit1013018076250108175_below @ A @ A4 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ) ).

% cInf_le_cSup
thf(fact_3651_ofilter__Restr__Int,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( order_ofilter @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ B3
              @ ^ [Uu: A] : B3 ) )
          @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ).

% ofilter_Restr_Int
thf(fact_3652_ofilter__Restr__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
         => ( order_ofilter @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ B3
                @ ^ [Uu: A] : B3 ) )
            @ A4 ) ) ) ) ).

% ofilter_Restr_subset
thf(fact_3653_inverse__rat__def,axiom,
    ( ( inverse_inverse @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X3: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int )
          @ ( ( product_fst @ int @ int @ X3 )
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) ) ) ) ).

% inverse_rat_def
thf(fact_3654_set__to__map__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( set_to_map @ B @ A )
      = ( ^ [S7: set @ ( product_prod @ B @ A ),K4: B] :
            ( eps_Opt @ A
            @ ^ [V3: A] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K4 @ V3 ) @ S7 ) ) ) ) ).

% set_to_map_def
thf(fact_3655_map__fun_Ocompositionality,axiom,
    ! [D: $tType,F9: $tType,C: $tType,E: $tType,B: $tType,A: $tType,F: E > C,G: D > F9,H2: C > A,I: B > D,Fun: A > B] :
      ( ( map_fun @ E @ C @ D @ F9 @ F @ G @ ( map_fun @ C @ A @ B @ D @ H2 @ I @ Fun ) )
      = ( map_fun @ E @ A @ B @ F9 @ ( comp @ C @ A @ E @ H2 @ F ) @ ( comp @ D @ F9 @ B @ G @ I ) @ Fun ) ) ).

% map_fun.compositionality
thf(fact_3656_map__fun__def,axiom,
    ! [B: $tType,D: $tType,A: $tType,C: $tType] :
      ( ( map_fun @ C @ A @ B @ D )
      = ( ^ [F2: C > A,G2: B > D,H3: A > B] : ( comp @ A @ D @ C @ ( comp @ B @ D @ A @ G2 @ H3 ) @ F2 ) ) ) ).

% map_fun_def
thf(fact_3657_map__fun_Ocomp,axiom,
    ! [E: $tType,C: $tType,A: $tType,F9: $tType,D: $tType,B: $tType,F: E > C,G: D > F9,H2: C > A,I: B > D] :
      ( ( comp @ ( C > D ) @ ( E > F9 ) @ ( A > B ) @ ( map_fun @ E @ C @ D @ F9 @ F @ G ) @ ( map_fun @ C @ A @ B @ D @ H2 @ I ) )
      = ( map_fun @ E @ A @ B @ F9 @ ( comp @ C @ A @ E @ H2 @ F ) @ ( comp @ D @ F9 @ B @ G @ I ) ) ) ).

% map_fun.comp
thf(fact_3658_uminus__rat__def,axiom,
    ( ( uminus_uminus @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X3: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( product_fst @ int @ int @ X3 ) ) @ ( product_snd @ int @ int @ X3 ) ) ) ) ).

% uminus_rat_def
thf(fact_3659_Field__Restr__ofilter,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( ( field2 @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ A4
                @ ^ [Uu: A] : A4 ) ) )
          = A4 ) ) ) ).

% Field_Restr_ofilter
thf(fact_3660_plus__rat__def,axiom,
    ( ( plus_plus @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X3: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y2 ) @ ( product_snd @ int @ int @ X3 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) ) ) ) ).

% plus_rat_def
thf(fact_3661_ofilter__subset__embedS,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( ( order_ofilter @ A @ R4 @ B3 )
         => ( ( ord_less @ ( set @ A ) @ A4 @ B3 )
            = ( bNF_Wellorder_embedS @ A @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ A4
                  @ ^ [Uu: A] : A4 ) )
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ B3
                  @ ^ [Uu: A] : B3 ) )
              @ ( id @ A ) ) ) ) ) ) ).

% ofilter_subset_embedS
thf(fact_3662_times__rat__def,axiom,
    ( ( times_times @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X3: product_prod @ int @ int,Y2: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_fst @ int @ int @ Y2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y2 ) ) ) ) ) ).

% times_rat_def
thf(fact_3663_ofilter__subset__ordLess,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( ( order_ofilter @ A @ R4 @ B3 )
         => ( ( ord_less @ ( set @ A ) @ A4 @ B3 )
            = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ A4
                    @ ^ [Uu: A] : A4 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ B3
                    @ ^ [Uu: A] : B3 ) ) )
              @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ) ) ).

% ofilter_subset_ordLess
thf(fact_3664_ordLess__transitive,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),R8: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R6 @ R8 ) @ ( bNF_We4044943003108391690rdLess @ B @ C ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R4 @ R8 ) @ ( bNF_We4044943003108391690rdLess @ A @ C ) ) ) ) ).

% ordLess_transitive
thf(fact_3665_ordLess__irreflexive,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R4 ) @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ).

% ordLess_irreflexive
thf(fact_3666_finite__ordLess__infinite,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( finite_finite @ A @ ( field2 @ A @ R4 ) )
         => ( ~ ( finite_finite @ B @ ( field2 @ B @ R6 ) )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) ) ) ) ) ) ).

% finite_ordLess_infinite
thf(fact_3667_ofilter__ordLess,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( ( ord_less @ ( set @ A ) @ A4 @ ( field2 @ A @ R4 ) )
          = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ A4
                  @ ^ [Uu: A] : A4 ) )
              @ R4 )
            @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ) ).

% ofilter_ordLess
thf(fact_3668_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X3: nat,Y2: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y2 @ V3 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V3 ) @ ( times_times @ nat @ Y2 @ U2 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_3669_ofilter__subset__embedS__iso,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( ( order_ofilter @ A @ R4 @ B3 )
         => ( ( ( ord_less @ ( set @ A ) @ A4 @ B3 )
              = ( bNF_Wellorder_embedS @ A @ A
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ A4
                    @ ^ [Uu: A] : A4 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ B3
                    @ ^ [Uu: A] : B3 ) )
                @ ( id @ A ) ) )
            & ( ( A4 = B3 )
              = ( bNF_Wellorder_iso @ A @ A
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ A4
                    @ ^ [Uu: A] : A4 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ B3
                    @ ^ [Uu: A] : B3 ) )
                @ ( id @ A ) ) ) ) ) ) ) ).

% ofilter_subset_embedS_iso
thf(fact_3670_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X3: nat,Y2: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V3 ) @ ( plus_plus @ nat @ Y2 @ U2 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_3671_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X3: nat,Y2: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V3: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y2 @ V3 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_3672_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X3: nat,Y2: nat] : ( product_Pair @ nat @ nat @ Y2 @ X3 ) ) ) ) ).

% uminus_int_def
thf(fact_3673_iso__comp__embedS,axiom,
    ! [C: $tType,B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),F: A > B,R8: set @ ( product_prod @ C @ C ),F11: B > C] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( bNF_Wellorder_iso @ A @ B @ R4 @ R6 @ F )
         => ( ( bNF_Wellorder_embedS @ B @ C @ R6 @ R8 @ F11 )
           => ( bNF_Wellorder_embedS @ A @ C @ R4 @ R8 @ ( comp @ B @ C @ A @ F11 @ F ) ) ) ) ) ) ).

% iso_comp_embedS
thf(fact_3674_embedS__comp__iso,axiom,
    ! [C: $tType,B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),F: A > B,R8: set @ ( product_prod @ C @ C ),F11: B > C] :
      ( ( bNF_Wellorder_embedS @ A @ B @ R4 @ R6 @ F )
     => ( ( bNF_Wellorder_iso @ B @ C @ R6 @ R8 @ F11 )
       => ( bNF_Wellorder_embedS @ A @ C @ R4 @ R8 @ ( comp @ B @ C @ A @ F11 @ F ) ) ) ) ).

% embedS_comp_iso
thf(fact_3675_underS__Restr__ordLess,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ( field2 @ A @ R4 )
         != ( bot_bot @ ( set @ A ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R4 @ A3 )
                @ ^ [Uu: A] : ( order_underS @ A @ R4 @ A3 ) ) )
            @ R4 )
          @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ).

% underS_Restr_ordLess
thf(fact_3676_comp__iso,axiom,
    ! [C: $tType,B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),F: A > B,R8: set @ ( product_prod @ C @ C ),F11: B > C] :
      ( ( bNF_Wellorder_iso @ A @ B @ R4 @ R6 @ F )
     => ( ( bNF_Wellorder_iso @ B @ C @ R6 @ R8 @ F11 )
       => ( bNF_Wellorder_iso @ A @ C @ R4 @ R8 @ ( comp @ B @ C @ A @ F11 @ F ) ) ) ) ).

% comp_iso
thf(fact_3677_underS__I,axiom,
    ! [A: $tType,I: A,J2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( I != J2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ I @ J2 ) @ R )
       => ( member @ A @ I @ ( order_underS @ A @ R @ J2 ) ) ) ) ).

% underS_I
thf(fact_3678_underS__E,axiom,
    ! [A: $tType,I: A,R: set @ ( product_prod @ A @ A ),J2: A] :
      ( ( member @ A @ I @ ( order_underS @ A @ R @ J2 ) )
     => ( ( I != J2 )
        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ I @ J2 ) @ R ) ) ) ).

% underS_E
thf(fact_3679_underS__def,axiom,
    ! [A: $tType] :
      ( ( order_underS @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),A5: A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( B4 != A5 )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ A5 ) @ R5 ) ) ) ) ) ).

% underS_def
thf(fact_3680_underS__empty,axiom,
    ! [A: $tType,A3: A,R4: set @ ( product_prod @ A @ A )] :
      ( ~ ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
     => ( ( order_underS @ A @ R4 @ A3 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% underS_empty
thf(fact_3681_underS__Field3,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( ( field2 @ A @ R4 )
       != ( bot_bot @ ( set @ A ) ) )
     => ( ord_less @ ( set @ A ) @ ( order_underS @ A @ R4 @ A3 ) @ ( field2 @ A @ R4 ) ) ) ).

% underS_Field3
thf(fact_3682_underS__incl__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( order_679001287576687338der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ B2 @ ( field2 @ A @ R4 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( order_underS @ A @ R4 @ A3 ) @ ( order_underS @ A @ R4 @ B2 ) )
            = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) ) ) ) ) ).

% underS_incl_iff
thf(fact_3683_iso__forward,axiom,
    ! [A: $tType,B: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),F: A > B] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
     => ( ( bNF_Wellorder_iso @ A @ B @ R4 @ R6 @ F )
       => ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F @ X ) @ ( F @ Y ) ) @ R6 ) ) ) ).

% iso_forward
thf(fact_3684_ordLess__iff__ordIso__Restr,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) )
          = ( ? [X3: A] :
                ( ( member @ A @ X3 @ ( field2 @ A @ R4 ) )
                & ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) )
                  @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6
                    @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                      @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R4 @ X3 )
                        @ ^ [Uu: A] : ( order_underS @ A @ R4 @ X3 ) ) ) )
                  @ ( bNF_Wellorder_ordIso @ B @ A ) ) ) ) ) ) ) ).

% ordLess_iff_ordIso_Restr
thf(fact_3685_ordLeq__iff__ordLess__Restr,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( field2 @ A @ R4 ) )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) )
                  @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) )
                    @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                      @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R4 @ X3 )
                        @ ^ [Uu: A] : ( order_underS @ A @ R4 @ X3 ) ) )
                    @ R6 )
                  @ ( bNF_We4044943003108391690rdLess @ A @ B ) ) ) ) ) ) ) ).

% ordLeq_iff_ordLess_Restr
thf(fact_3686_ofilter__subset__embed,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( ( order_ofilter @ A @ R4 @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
            = ( bNF_Wellorder_embed @ A @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ A4
                  @ ^ [Uu: A] : A4 ) )
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ B3
                  @ ^ [Uu: A] : B3 ) )
              @ ( id @ A ) ) ) ) ) ) ).

% ofilter_subset_embed
thf(fact_3687_ofilter__embed,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
        = ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( field2 @ A @ R4 ) )
          & ( bNF_Wellorder_embed @ A @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ A4
                @ ^ [Uu: A] : A4 ) )
            @ R4
            @ ( id @ A ) ) ) ) ) ).

% ofilter_embed
thf(fact_3688_comp__embed,axiom,
    ! [C: $tType,B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),F: A > B,R8: set @ ( product_prod @ C @ C ),F11: B > C] :
      ( ( bNF_Wellorder_embed @ A @ B @ R4 @ R6 @ F )
     => ( ( bNF_Wellorder_embed @ B @ C @ R6 @ R8 @ F11 )
       => ( bNF_Wellorder_embed @ A @ C @ R4 @ R8 @ ( comp @ B @ C @ A @ F11 @ F ) ) ) ) ).

% comp_embed
thf(fact_3689_ordLeq__iff__ordLess__or__ordIso,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
      = ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
        | ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ) ).

% ordLeq_iff_ordLess_or_ordIso
thf(fact_3690_ordLeq__transitive,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),R8: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R6 @ R8 ) @ ( bNF_Wellorder_ordLeq @ B @ C ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R4 @ R8 ) @ ( bNF_Wellorder_ordLeq @ A @ C ) ) ) ) ).

% ordLeq_transitive
thf(fact_3691_ordLeq__ordIso__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),R8: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R6 @ R8 ) @ ( bNF_Wellorder_ordIso @ B @ C ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R4 @ R8 ) @ ( bNF_Wellorder_ordLeq @ A @ C ) ) ) ) ).

% ordLeq_ordIso_trans
thf(fact_3692_ordIso__ordLeq__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),R8: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R6 @ R8 ) @ ( bNF_Wellorder_ordLeq @ B @ C ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R4 @ R8 ) @ ( bNF_Wellorder_ordLeq @ A @ C ) ) ) ) ).

% ordIso_ordLeq_trans
thf(fact_3693_ordIso__imp__ordLeq,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ).

% ordIso_imp_ordLeq
thf(fact_3694_ordIso__iff__ordLeq,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
      = ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
        & ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ) ).

% ordIso_iff_ordLeq
thf(fact_3695_ordIso__symmetric,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) @ ( bNF_Wellorder_ordIso @ B @ A ) ) ) ).

% ordIso_symmetric
thf(fact_3696_ordIso__transitive,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),R8: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R6 @ R8 ) @ ( bNF_Wellorder_ordIso @ B @ C ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R4 @ R8 ) @ ( bNF_Wellorder_ordIso @ A @ C ) ) ) ) ).

% ordIso_transitive
thf(fact_3697_internalize__ordLeq,axiom,
    ! [A: $tType,B: $tType,R6: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R6 @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
      = ( ? [P6: set @ ( product_prod @ B @ B )] :
            ( ( ord_less_eq @ ( set @ B ) @ ( field2 @ B @ P6 ) @ ( field2 @ B @ R4 ) )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R6 @ P6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P6 @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ B ) ) ) ) ) ).

% internalize_ordLeq
thf(fact_3698_ordLess__ordLeq__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),R8: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R6 @ R8 ) @ ( bNF_Wellorder_ordLeq @ B @ C ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R4 @ R8 ) @ ( bNF_We4044943003108391690rdLess @ A @ C ) ) ) ) ).

% ordLess_ordLeq_trans
thf(fact_3699_ordLeq__ordLess__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),R8: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R6 @ R8 ) @ ( bNF_We4044943003108391690rdLess @ B @ C ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R4 @ R8 ) @ ( bNF_We4044943003108391690rdLess @ A @ C ) ) ) ) ).

% ordLeq_ordLess_trans
thf(fact_3700_ordLess__imp__ordLeq,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ).

% ordLess_imp_ordLeq
thf(fact_3701_not__ordLess__ordLeq,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
     => ~ ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ).

% not_ordLess_ordLeq
thf(fact_3702_ordLess__ordIso__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),R8: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R6 @ R8 ) @ ( bNF_Wellorder_ordIso @ B @ C ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R4 @ R8 ) @ ( bNF_We4044943003108391690rdLess @ A @ C ) ) ) ) ).

% ordLess_ordIso_trans
thf(fact_3703_ordIso__ordLess__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),R8: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R6 @ R8 ) @ ( bNF_We4044943003108391690rdLess @ B @ C ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R4 @ R8 ) @ ( bNF_We4044943003108391690rdLess @ A @ C ) ) ) ) ).

% ordIso_ordLess_trans
thf(fact_3704_not__ordLess__ordIso,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
     => ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ).

% not_ordLess_ordIso
thf(fact_3705_ordLess__not__embed,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
     => ~ ? [X_12: B > A] : ( bNF_Wellorder_embed @ B @ A @ R6 @ R4 @ X_12 ) ) ).

% ordLess_not_embed
thf(fact_3706_iso__comp__embed,axiom,
    ! [C: $tType,B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),F: A > B,R8: set @ ( product_prod @ C @ C ),F11: B > C] :
      ( ( bNF_Wellorder_iso @ A @ B @ R4 @ R6 @ F )
     => ( ( bNF_Wellorder_embed @ B @ C @ R6 @ R8 @ F11 )
       => ( bNF_Wellorder_embed @ A @ C @ R4 @ R8 @ ( comp @ B @ C @ A @ F11 @ F ) ) ) ) ).

% iso_comp_embed
thf(fact_3707_embed__comp__iso,axiom,
    ! [C: $tType,B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),F: A > B,R8: set @ ( product_prod @ C @ C ),F11: B > C] :
      ( ( bNF_Wellorder_embed @ A @ B @ R4 @ R6 @ F )
     => ( ( bNF_Wellorder_iso @ B @ C @ R6 @ R8 @ F11 )
       => ( bNF_Wellorder_embed @ A @ C @ R4 @ R8 @ ( comp @ B @ C @ A @ F11 @ F ) ) ) ) ).

% embed_comp_iso
thf(fact_3708_finite__well__order__on__ordIso,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ A @ A4 )
     => ( ( order_well_order_on @ A @ A4 @ R4 )
       => ( ( order_well_order_on @ A @ A4 @ R6 )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ A ) ) ) ) ) ).

% finite_well_order_on_ordIso
thf(fact_3709_exists__minim__Well__order,axiom,
    ! [A: $tType,R: set @ ( set @ ( product_prod @ A @ A ) )] :
      ( ( R
       != ( bot_bot @ ( set @ ( set @ ( product_prod @ A @ A ) ) ) ) )
     => ( ! [X2: set @ ( product_prod @ A @ A )] :
            ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X2 @ R )
           => ( order_well_order_on @ A @ ( field2 @ A @ X2 ) @ X2 ) )
       => ? [X2: set @ ( product_prod @ A @ A )] :
            ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X2 @ R )
            & ! [Xa2: set @ ( product_prod @ A @ A )] :
                ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ Xa2 @ R )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ X2 @ Xa2 ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ) ) ) ).

% exists_minim_Well_order
thf(fact_3710_ordLeq__total,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
          | ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ) ) ).

% ordLeq_total
thf(fact_3711_ordLeq__reflexive,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ).

% ordLeq_reflexive
thf(fact_3712_ordLeq__Well__order__simp,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
        & ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 ) ) ) ).

% ordLeq_Well_order_simp
thf(fact_3713_ordIso__reflexive,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R4 ) @ ( bNF_Wellorder_ordIso @ A @ A ) ) ) ).

% ordIso_reflexive
thf(fact_3714_BNF__Wellorder__Constructions_OordLess__Field,axiom,
    ! [A: $tType,B: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),F: A > B] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R1 @ R22 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
     => ( ( bNF_Wellorder_embed @ A @ B @ R1 @ R22 @ F )
       => ( ( image2 @ A @ B @ F @ ( field2 @ A @ R1 ) )
         != ( field2 @ B @ R22 ) ) ) ) ).

% BNF_Wellorder_Constructions.ordLess_Field
thf(fact_3715_internalize__ordLess,axiom,
    ! [A: $tType,B: $tType,R6: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R6 @ R4 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
      = ( ? [P6: set @ ( product_prod @ B @ B )] :
            ( ( ord_less @ ( set @ B ) @ ( field2 @ B @ P6 ) @ ( field2 @ B @ R4 ) )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R6 @ P6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P6 @ R4 ) @ ( bNF_We4044943003108391690rdLess @ B @ B ) ) ) ) ) ).

% internalize_ordLess
thf(fact_3716_ordLess__or__ordLeq,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
          | ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ) ) ).

% ordLess_or_ordLeq
thf(fact_3717_not__ordLeq__iff__ordLess,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) )
          = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) ) ) ) ) ).

% not_ordLeq_iff_ordLess
thf(fact_3718_not__ordLess__iff__ordLeq,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) ) )
          = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ) ) ).

% not_ordLess_iff_ordLeq
thf(fact_3719_ordLess__iff,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
      = ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
        & ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
        & ~ ? [X8: B > A] : ( bNF_Wellorder_embed @ B @ A @ R6 @ R4 @ X8 ) ) ) ).

% ordLess_iff
thf(fact_3720_embed__comp__embedS,axiom,
    ! [C: $tType,B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),F: A > B,R8: set @ ( product_prod @ C @ C ),F11: B > C] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( bNF_Wellorder_embed @ A @ B @ R4 @ R6 @ F )
         => ( ( bNF_Wellorder_embedS @ B @ C @ R6 @ R8 @ F11 )
           => ( bNF_Wellorder_embedS @ A @ C @ R4 @ R8 @ ( comp @ B @ C @ A @ F11 @ F ) ) ) ) ) ) ).

% embed_comp_embedS
thf(fact_3721_embedS__comp__embed,axiom,
    ! [C: $tType,B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),F: A > B,R8: set @ ( product_prod @ C @ C ),F11: B > C] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( bNF_Wellorder_embedS @ A @ B @ R4 @ R6 @ F )
         => ( ( bNF_Wellorder_embed @ B @ C @ R6 @ R8 @ F11 )
           => ( bNF_Wellorder_embedS @ A @ C @ R4 @ R8 @ ( comp @ B @ C @ A @ F11 @ F ) ) ) ) ) ) ).

% embedS_comp_embed
thf(fact_3722_embed__implies__iso__Restr,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),F: B > A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( bNF_Wellorder_embed @ B @ A @ R6 @ R4 @ F )
         => ( bNF_Wellorder_iso @ B @ A @ R6
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ ( image2 @ B @ A @ F @ ( field2 @ B @ R6 ) )
                @ ^ [Uu: A] : ( image2 @ B @ A @ F @ ( field2 @ B @ R6 ) ) ) )
            @ F ) ) ) ) ).

% embed_implies_iso_Restr
thf(fact_3723_ofilter__subset__ordLeq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B3: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( ( order_ofilter @ A @ R4 @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
            = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ A4
                    @ ^ [Uu: A] : A4 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ B3
                    @ ^ [Uu: A] : B3 ) ) )
              @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ) ) ) ).

% ofilter_subset_ordLeq
thf(fact_3724_embed__ordLess__ofilterIncl,axiom,
    ! [B: $tType,A: $tType,C: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),R33: set @ ( product_prod @ C @ C ),F13: A > C,F23: B > C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R1 @ R22 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R22 @ R33 ) @ ( bNF_We4044943003108391690rdLess @ B @ C ) )
       => ( ( bNF_Wellorder_embed @ A @ C @ R1 @ R33 @ F13 )
         => ( ( bNF_Wellorder_embed @ B @ C @ R22 @ R33 @ F23 )
           => ( member @ ( product_prod @ ( set @ C ) @ ( set @ C ) ) @ ( product_Pair @ ( set @ C ) @ ( set @ C ) @ ( image2 @ A @ C @ F13 @ ( field2 @ A @ R1 ) ) @ ( image2 @ B @ C @ F23 @ ( field2 @ B @ R22 ) ) ) @ ( bNF_We413866401316099525erIncl @ C @ R33 ) ) ) ) ) ) ).

% embed_ordLess_ofilterIncl
thf(fact_3725_Refl__under__underS,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( refl_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( ( order_under @ A @ R4 @ A3 )
          = ( sup_sup @ ( set @ A ) @ ( order_underS @ A @ R4 @ A3 ) @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% Refl_under_underS
thf(fact_3726_ofilter__Restr__under,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,A3: A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( ( member @ A @ A3 @ A4 )
         => ( ( order_under @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ A4
                  @ ^ [Uu: A] : A4 ) )
              @ A3 )
            = ( order_under @ A @ R4 @ A3 ) ) ) ) ) ).

% ofilter_Restr_under
thf(fact_3727_comp__set__bd__Union__o__collect,axiom,
    ! [C: $tType,B: $tType,A: $tType,X: C,X5: set @ ( C > ( set @ ( set @ A ) ) ),Hbd: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) )
          @ ( bNF_Ca6860139660246222851ard_of @ A
            @ ( complete_Sup_Sup @ ( set @ A )
              @ ( complete_Sup_Sup @ ( set @ ( set @ A ) )
                @ ( image2 @ ( C > ( set @ ( set @ A ) ) ) @ ( set @ ( set @ A ) )
                  @ ^ [F2: C > ( set @ ( set @ A ) )] : ( F2 @ X )
                  @ X5 ) ) ) )
          @ Hbd )
        @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( comp @ ( set @ ( set @ A ) ) @ ( set @ A ) @ C @ ( complete_Sup_Sup @ ( set @ A ) ) @ ( bNF_collect @ C @ ( set @ A ) @ X5 ) @ X ) ) @ Hbd ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ).

% comp_set_bd_Union_o_collect
thf(fact_3728_card__of__Times1,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
            @ ( product_Sigma @ B @ A @ B3
              @ ^ [Uu: B] : A4 ) ) )
        @ ( bNF_Wellorder_ordLeq @ B @ ( product_prod @ B @ A ) ) ) ) ).

% card_of_Times1
thf(fact_3729_card__of__Times2,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
            @ ( product_Sigma @ A @ B @ A4
              @ ^ [Uu: A] : B3 ) ) )
        @ ( bNF_Wellorder_ordLeq @ B @ ( product_prod @ A @ B ) ) ) ) ).

% card_of_Times2
thf(fact_3730_card__of__Times3,axiom,
    ! [A: $tType,A4: set @ A] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ A )
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) )
      @ ( bNF_Wellorder_ordLeq @ A @ ( product_prod @ A @ A ) ) ) ).

% card_of_Times3
thf(fact_3731_card__of__Func__Times,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: set @ A,B3: set @ B,C3: set @ C] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( ( product_prod @ A @ B ) > C ) @ ( ( product_prod @ A @ B ) > C ) ) ) @ ( set @ ( product_prod @ ( A > B > C ) @ ( A > B > C ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( ( product_prod @ A @ B ) > C ) @ ( ( product_prod @ A @ B ) > C ) ) ) @ ( set @ ( product_prod @ ( A > B > C ) @ ( A > B > C ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( ( product_prod @ A @ B ) > C )
          @ ( bNF_Wellorder_Func @ ( product_prod @ A @ B ) @ C
            @ ( product_Sigma @ A @ B @ A4
              @ ^ [Uu: A] : B3 )
            @ C3 ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( A > B > C ) @ ( bNF_Wellorder_Func @ A @ ( B > C ) @ A4 @ ( bNF_Wellorder_Func @ B @ C @ B3 @ C3 ) ) ) )
      @ ( bNF_Wellorder_ordIso @ ( ( product_prod @ A @ B ) > C ) @ ( A > B > C ) ) ) ).

% card_of_Func_Times
thf(fact_3732_Func__Times__Range,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: set @ A,B3: set @ B,C3: set @ C] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > ( product_prod @ B @ C ) ) @ ( A > ( product_prod @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( product_prod @ ( A > B ) @ ( A > C ) ) @ ( product_prod @ ( A > B ) @ ( A > C ) ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( A > ( product_prod @ B @ C ) ) @ ( A > ( product_prod @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( product_prod @ ( A > B ) @ ( A > C ) ) @ ( product_prod @ ( A > B ) @ ( A > C ) ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( A > ( product_prod @ B @ C ) )
          @ ( bNF_Wellorder_Func @ A @ ( product_prod @ B @ C ) @ A4
            @ ( product_Sigma @ B @ C @ B3
              @ ^ [Uu: B] : C3 ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ ( A > B ) @ ( A > C ) )
          @ ( product_Sigma @ ( A > B ) @ ( A > C ) @ ( bNF_Wellorder_Func @ A @ B @ A4 @ B3 )
            @ ^ [Uu: A > B] : ( bNF_Wellorder_Func @ A @ C @ A4 @ C3 ) ) ) )
      @ ( bNF_Wellorder_ordIso @ ( A > ( product_prod @ B @ C ) ) @ ( product_prod @ ( A > B ) @ ( A > C ) ) ) ) ).

% Func_Times_Range
thf(fact_3733_card__of__Pow__Func,axiom,
    ! [A: $tType,A4: set @ A] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ ( A > $o ) @ ( A > $o ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ ( A > $o ) @ ( A > $o ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( set @ A ) @ ( pow @ A @ A4 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( A > $o ) @ ( bNF_Wellorder_Func @ A @ $o @ A4 @ ( top_top @ ( set @ $o ) ) ) ) ) @ ( bNF_Wellorder_ordIso @ ( set @ A ) @ ( A > $o ) ) ) ).

% card_of_Pow_Func
thf(fact_3734_card__of__Times__same__infinite,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ A )
            @ ( product_Sigma @ A @ A @ A4
              @ ^ [Uu: A] : A4 ) )
          @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) )
        @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ A ) @ A ) ) ) ).

% card_of_Times_same_infinite
thf(fact_3735_card__of__Pow,axiom,
    ! [A: $tType,A4: set @ A] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ ( set @ A ) @ ( pow @ A @ A4 ) ) ) @ ( bNF_We4044943003108391690rdLess @ A @ ( set @ A ) ) ) ).

% card_of_Pow
thf(fact_3736_card__of__Times__commute,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
          @ ( product_Sigma @ A @ B @ A4
            @ ^ [Uu: A] : B3 ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
          @ ( product_Sigma @ B @ A @ B3
            @ ^ [Uu: B] : A4 ) ) )
      @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A ) ) ) ).

% card_of_Times_commute
thf(fact_3737_infinite__iff__card__of__nat,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ~ ( finite_finite @ A @ A4 ) )
      = ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ nat @ ( top_top @ ( set @ nat ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ nat @ A ) ) ) ).

% infinite_iff_card_of_nat
thf(fact_3738_card__of__bool,axiom,
    ! [A: $tType,A1: A,A22: A] :
      ( ( A1 != A22 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ $o @ ( top_top @ ( set @ $o ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( insert2 @ A @ A1 @ ( insert2 @ A @ A22 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) @ ( bNF_Wellorder_ordIso @ $o @ A ) ) ) ).

% card_of_bool
thf(fact_3739_card__of__UNION__Sigma,axiom,
    ! [B: $tType,A: $tType,A4: B > ( set @ A ),I4: set @ B] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A4 @ I4 ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A ) @ ( product_Sigma @ B @ A @ I4 @ A4 ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( product_prod @ B @ A ) ) ) ).

% card_of_UNION_Sigma
thf(fact_3740_card__of__Times__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,A4: set @ A,B3: set @ B,C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ C @ A )
            @ ( product_Sigma @ C @ A @ C3
              @ ^ [Uu: C] : A4 ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ C @ B )
            @ ( product_Sigma @ C @ B @ C3
              @ ^ [Uu: C] : B3 ) ) )
        @ ( bNF_Wellorder_ordLeq @ ( product_prod @ C @ A ) @ ( product_prod @ C @ B ) ) ) ) ).

% card_of_Times_mono2
thf(fact_3741_card__of__Times__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,A4: set @ A,B3: set @ B,C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ C )
            @ ( product_Sigma @ A @ C @ A4
              @ ^ [Uu: A] : C3 ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ C )
            @ ( product_Sigma @ B @ C @ B3
              @ ^ [Uu: B] : C3 ) ) )
        @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C ) ) ) ) ).

% card_of_Times_mono1
thf(fact_3742_card__of__Sigma__mono1,axiom,
    ! [C: $tType,B: $tType,A: $tType,I4: set @ A,A4: A > ( set @ B ),B3: A > ( set @ C )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ I4 )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( A4 @ X2 ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( B3 @ X2 ) ) ) @ ( bNF_Wellorder_ordLeq @ B @ C ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ I4 @ A4 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ C ) @ ( product_Sigma @ A @ C @ I4 @ B3 ) ) ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) ) ).

% card_of_Sigma_mono1
thf(fact_3743_under__def,axiom,
    ! [A: $tType] :
      ( ( order_under @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),A5: A] :
            ( collect @ A
            @ ^ [B4: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ A5 ) @ R5 ) ) ) ) ).

% under_def
thf(fact_3744_card__of__Sigma__ordLeq__infinite,axiom,
    ! [A: $tType,C: $tType,B: $tType,B3: set @ A,I4: set @ B,A4: B > ( set @ C )] :
      ( ~ ( finite_finite @ A @ B3 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ I4 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ! [X2: B] :
              ( ( member @ B @ X2 @ I4 )
             => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A4 @ X2 ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ C ) @ ( product_Sigma @ B @ C @ I4 @ A4 ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ B @ C ) @ A ) ) ) ) ) ).

% card_of_Sigma_ordLeq_infinite
thf(fact_3745_card__of__refl,axiom,
    ! [A: $tType,A4: set @ A] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) ) ).

% card_of_refl
thf(fact_3746_card__of__Times__infinite__simps_I4_J,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( B3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 )
              @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
                @ ( product_Sigma @ B @ A @ B3
                  @ ^ [Uu: B] : A4 ) ) )
            @ ( bNF_Wellorder_ordIso @ A @ ( product_prod @ B @ A ) ) ) ) ) ) ).

% card_of_Times_infinite_simps(4)
thf(fact_3747_card__of__Times__infinite__simps_I3_J,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( B3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) )
              @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
                @ ( product_Sigma @ B @ A @ B3
                  @ ^ [Uu: B] : A4 ) )
              @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) )
            @ ( bNF_Wellorder_ordIso @ ( product_prod @ B @ A ) @ A ) ) ) ) ) ).

% card_of_Times_infinite_simps(3)
thf(fact_3748_card__of__Times__infinite__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( B3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 )
              @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
                @ ( product_Sigma @ A @ B @ A4
                  @ ^ [Uu: A] : B3 ) ) )
            @ ( bNF_Wellorder_ordIso @ A @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% card_of_Times_infinite_simps(2)
thf(fact_3749_card__of__Times__infinite__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( B3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) )
              @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
                @ ( product_Sigma @ A @ B @ A4
                  @ ^ [Uu: A] : B3 ) )
              @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) )
            @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ B ) @ A ) ) ) ) ) ).

% card_of_Times_infinite_simps(1)
thf(fact_3750_card__of__Times__infinite,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( B3
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
                  @ ( product_Sigma @ A @ B @ A4
                    @ ^ [Uu: A] : B3 ) )
                @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) )
              @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ B ) @ A ) )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
                  @ ( product_Sigma @ B @ A @ B3
                    @ ^ [Uu: B] : A4 ) )
                @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) )
              @ ( bNF_Wellorder_ordIso @ ( product_prod @ B @ A ) @ A ) ) ) ) ) ) ).

% card_of_Times_infinite
thf(fact_3751_card__of__image,axiom,
    ! [B: $tType,A: $tType,F: B > A,A4: set @ B] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( image2 @ B @ A @ F @ A4 ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ).

% card_of_image
thf(fact_3752_card__of__empty3,axiom,
    ! [B: $tType,A: $tType,A4: set @ A] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( bot_bot @ ( set @ B ) ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% card_of_empty3
thf(fact_3753_card__of__empty,axiom,
    ! [B: $tType,A: $tType,A4: set @ B] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( bot_bot @ ( set @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ).

% card_of_empty
thf(fact_3754_card__of__ordLeq__finite,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( finite_finite @ B @ B3 )
       => ( finite_finite @ A @ A4 ) ) ) ).

% card_of_ordLeq_finite
thf(fact_3755_card__of__ordLeq__infinite,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ~ ( finite_finite @ A @ A4 )
       => ~ ( finite_finite @ B @ B3 ) ) ) ).

% card_of_ordLeq_infinite
thf(fact_3756_card__of__mono1,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ).

% card_of_mono1
thf(fact_3757_card__of__empty__ordIso,axiom,
    ! [B: $tType,A: $tType] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( bot_bot @ ( set @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( bot_bot @ ( set @ B ) ) ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ).

% card_of_empty_ordIso
thf(fact_3758_card__of__empty2,axiom,
    ! [B: $tType,A: $tType,A4: set @ A] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( bot_bot @ ( set @ B ) ) ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% card_of_empty2
thf(fact_3759_card__of__ordIso__finite,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( finite_finite @ A @ A4 )
        = ( finite_finite @ B @ B3 ) ) ) ).

% card_of_ordIso_finite
thf(fact_3760_card__of__mono2,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( field2 @ A @ R4 ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( field2 @ B @ R6 ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ).

% card_of_mono2
thf(fact_3761_card__of__cong,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( field2 @ A @ R4 ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( field2 @ B @ R6 ) ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ).

% card_of_cong
thf(fact_3762_card__of__ordLeqI,axiom,
    ! [B: $tType,A: $tType,F: A > B,A4: set @ A,B3: set @ B] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ! [A8: A] :
            ( ( member @ A @ A8 @ A4 )
           => ( member @ B @ ( F @ A8 ) @ B3 ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ) ).

% card_of_ordLeqI
thf(fact_3763_card__of__least,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( order_well_order_on @ A @ A4 @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ).

% card_of_least
thf(fact_3764_BNF__Cardinal__Order__Relation_OordLess__Field,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( field2 @ A @ R4 ) ) @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) ) ) ).

% BNF_Cardinal_Order_Relation.ordLess_Field
thf(fact_3765_type__copy__set__bd,axiom,
    ! [A: $tType,D: $tType,C: $tType,B: $tType,S2: A > ( set @ B ),Bd: set @ ( product_prod @ C @ C ),Rep: D > A,X: D] :
      ( ! [Y3: A] : ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( S2 @ Y3 ) ) @ Bd ) @ ( bNF_Wellorder_ordLeq @ B @ C ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( comp @ A @ ( set @ B ) @ D @ S2 @ Rep @ X ) ) @ Bd ) @ ( bNF_Wellorder_ordLeq @ B @ C ) ) ) ).

% type_copy_set_bd
thf(fact_3766_card__of__ordLeq2,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [G2: B > A] :
              ( ( image2 @ B @ A @ G2 @ B3 )
              = A4 ) )
        = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ) ).

% card_of_ordLeq2
thf(fact_3767_surj__imp__ordLeq,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,F: B > A,A4: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( image2 @ B @ A @ F @ A4 ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ).

% surj_imp_ordLeq
thf(fact_3768_card__of__singl__ordLeq,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B2: B] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( insert2 @ B @ B2 @ ( bot_bot @ ( set @ B ) ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ).

% card_of_singl_ordLeq
thf(fact_3769_card__of__ordLess2,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,A4: set @ B] :
      ( ( B3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ? [F2: B > A] :
                ( ( image2 @ B @ A @ F2 @ A4 )
                = B3 ) )
        = ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) ) ) ) ).

% card_of_ordLess2
thf(fact_3770_internalize__card__of__ordLeq2,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,C3: set @ B] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ C3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
      = ( ? [B7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ B7 @ C3 )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B7 ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B7 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ C3 ) ) @ ( bNF_Wellorder_ordLeq @ B @ B ) ) ) ) ) ).

% internalize_card_of_ordLeq2
thf(fact_3771_card__of__Field__ordLess,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( field2 @ A @ R4 ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ).

% card_of_Field_ordLess
thf(fact_3772_card__of__Func__UNIV,axiom,
    ! [B: $tType,A: $tType,B3: set @ B] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) @ ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) @ ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( A > B ) @ ( bNF_Wellorder_Func @ A @ B @ ( top_top @ ( set @ A ) ) @ B3 ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( A > B )
          @ ( collect @ ( A > B )
            @ ^ [F2: A > B] : ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) @ B3 ) ) ) )
      @ ( bNF_Wellorder_ordIso @ ( A > B ) @ ( A > B ) ) ) ).

% card_of_Func_UNIV
thf(fact_3773_ordLeq__Times__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ C )
            @ ( product_Sigma @ A @ C @ ( field2 @ A @ R4 )
              @ ^ [Uu: A] : C3 ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ C )
            @ ( product_Sigma @ B @ C @ ( field2 @ B @ R6 )
              @ ^ [Uu: B] : C3 ) ) )
        @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C ) ) ) ) ).

% ordLeq_Times_mono1
thf(fact_3774_ordLeq__Times__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),A4: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ C @ A )
            @ ( product_Sigma @ C @ A @ A4
              @ ^ [Uu: C] : ( field2 @ A @ R4 ) ) )
          @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ C @ B )
            @ ( product_Sigma @ C @ B @ A4
              @ ^ [Uu: C] : ( field2 @ B @ R6 ) ) ) )
        @ ( bNF_Wellorder_ordLeq @ ( product_prod @ C @ A ) @ ( product_prod @ C @ B ) ) ) ) ).

% ordLeq_Times_mono2
thf(fact_3775_card__of__ordLeq,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( ( ? [F2: A > B] :
            ( ( inj_on @ A @ B @ F2 @ A4 )
            & ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ A4 ) @ B3 ) ) )
      = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ).

% card_of_ordLeq
thf(fact_3776_internalize__card__of__ordLeq,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,R4: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
      = ( ? [B7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ B7 @ ( field2 @ B @ R4 ) )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B7 ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B7 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ B ) ) ) ) ) ).

% internalize_card_of_ordLeq
thf(fact_3777_card__of__ordLess,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( ~ ? [F2: A > B] :
              ( ( inj_on @ A @ B @ F2 @ A4 )
              & ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ A4 ) @ B3 ) ) )
      = ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) ) ) ).

% card_of_ordLess
thf(fact_3778_card__of__UNION__ordLeq__infinite,axiom,
    ! [B: $tType,A: $tType,C: $tType,B3: set @ A,I4: set @ B,A4: B > ( set @ C )] :
      ( ~ ( finite_finite @ A @ B3 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ I4 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ! [X2: B] :
              ( ( member @ B @ X2 @ I4 )
             => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A4 @ X2 ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A4 @ I4 ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) ) ) ) ).

% card_of_UNION_ordLeq_infinite
thf(fact_3779_regularCard__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Ca7133664381575040944arCard @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [K6: set @ A] :
            ( ( ( ord_less_eq @ ( set @ A ) @ K6 @ ( field2 @ A @ R5 ) )
              & ( bNF_Ca7293521722713021262ofinal @ A @ K6 @ R5 ) )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ K6 ) @ R5 ) @ ( bNF_Wellorder_ordIso @ A @ A ) ) ) ) ) ).

% regularCard_def
thf(fact_3780_card__of__ordIso__subst,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( A4 = B3 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) ) ) ).

% card_of_ordIso_subst
thf(fact_3781_Card__order__iff__Restr__underS,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
        = ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( field2 @ A @ R4 ) )
             => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
                @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
                  @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                    @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R4 @ X3 )
                      @ ^ [Uu: A] : ( order_underS @ A @ R4 @ X3 ) ) )
                  @ ( bNF_Ca6860139660246222851ard_of @ A @ ( field2 @ A @ R4 ) ) )
                @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ) ) ).

% Card_order_iff_Restr_underS
thf(fact_3782_card__of__Plus__Times__aux,axiom,
    ! [B: $tType,A: $tType,A1: A,A22: A,A4: set @ A,B3: set @ B] :
      ( ( ( A1 != A22 )
        & ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ A1 @ ( insert2 @ A @ A22 @ ( bot_bot @ ( set @ A ) ) ) ) @ A4 ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A4 @ B3 ) )
            @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
              @ ( product_Sigma @ A @ B @ A4
                @ ^ [Uu: A] : B3 ) ) )
          @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ) ).

% card_of_Plus_Times_aux
thf(fact_3783_Card__order__Plus1,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ R4 @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ ( field2 @ A @ R4 ) @ B3 ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( sum_sum @ A @ B ) ) ) ) ).

% Card_order_Plus1
thf(fact_3784_Card__order__Plus2,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ R4 @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ A ) @ ( sum_Plus @ B @ A @ A4 @ ( field2 @ A @ R4 ) ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( sum_sum @ B @ A ) ) ) ) ).

% Card_order_Plus2
thf(fact_3785_card__of__Plus__commute,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A4 @ B3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ A ) @ ( sum_Plus @ B @ A @ B3 @ A4 ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ B ) @ ( sum_sum @ B @ A ) ) ) ).

% card_of_Plus_commute
thf(fact_3786_card__of__Plus__assoc,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: set @ A,B3: set @ B,C3: set @ C] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) @ ( sum_Plus @ ( sum_sum @ A @ B ) @ C @ ( sum_Plus @ A @ B @ A4 @ B3 ) @ C3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) @ ( sum_Plus @ A @ ( sum_sum @ B @ C ) @ A4 @ ( sum_Plus @ B @ C @ B3 @ C3 ) ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) ) ) ).

% card_of_Plus_assoc
thf(fact_3787_card__of__Plus2,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,A4: set @ B] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ A ) @ ( sum_Plus @ B @ A @ A4 @ B3 ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( sum_sum @ B @ A ) ) ) ).

% card_of_Plus2
thf(fact_3788_card__of__Plus1,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A4 @ B3 ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( sum_sum @ A @ B ) ) ) ).

% card_of_Plus1
thf(fact_3789_card__of__Times__Plus__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: set @ A,B3: set @ B,C3: set @ C] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ ( sum_sum @ B @ C ) )
          @ ( product_Sigma @ A @ ( sum_sum @ B @ C ) @ A4
            @ ^ [Uu: A] : ( sum_Plus @ B @ C @ B3 @ C3 ) ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) )
          @ ( sum_Plus @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C )
            @ ( product_Sigma @ A @ B @ A4
              @ ^ [Uu: A] : B3 )
            @ ( product_Sigma @ A @ C @ A4
              @ ^ [Uu: A] : C3 ) ) ) )
      @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) ) ).

% card_of_Times_Plus_distrib
thf(fact_3790_Card__order__Plus__infinite,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),P4: set @ ( product_prod @ B @ B )] :
      ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P4 @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ ( field2 @ A @ R4 ) @ ( field2 @ B @ P4 ) ) ) @ R4 ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ B ) @ A ) )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ A ) @ ( sum_Plus @ B @ A @ ( field2 @ B @ P4 ) @ ( field2 @ A @ R4 ) ) ) @ R4 ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ B @ A ) @ A ) ) ) ) ) ) ).

% Card_order_Plus_infinite
thf(fact_3791_card__of__Plus__Times__bool,axiom,
    ! [A: $tType,A4: set @ A] :
      ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ A ) @ ( sum_sum @ A @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ $o ) @ ( product_prod @ A @ $o ) ) ) )
      @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ A ) @ ( sum_sum @ A @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ $o ) @ ( product_prod @ A @ $o ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ A ) @ ( sum_Plus @ A @ A @ A4 @ A4 ) )
        @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ $o )
          @ ( product_Sigma @ A @ $o @ A4
            @ ^ [Uu: A] : ( top_top @ ( set @ $o ) ) ) ) )
      @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ A ) @ ( product_prod @ A @ $o ) ) ) ).

% card_of_Plus_Times_bool
thf(fact_3792_Card__order__trans,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: A,Y: A,Z2: A] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( X != Y )
       => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
         => ( ( Y != Z2 )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ R4 )
             => ( ( X != Z2 )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ R4 ) ) ) ) ) ) ) ).

% Card_order_trans
thf(fact_3793_ordLeq__refl,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ).

% ordLeq_refl
thf(fact_3794_ordIso__refl,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R4 ) @ ( bNF_Wellorder_ordIso @ A @ A ) ) ) ).

% ordIso_refl
thf(fact_3795_card__order__on__ordIso,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ A4 @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ A4 @ R6 )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ A ) ) ) ) ).

% card_order_on_ordIso
thf(fact_3796_card__of__Plus__empty2,axiom,
    ! [B: $tType,A: $tType,A4: set @ A] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ A ) @ ( sum_Plus @ B @ A @ ( bot_bot @ ( set @ B ) ) @ A4 ) ) ) @ ( bNF_Wellorder_ordIso @ A @ ( sum_sum @ B @ A ) ) ) ).

% card_of_Plus_empty2
thf(fact_3797_card__of__Plus__empty1,axiom,
    ! [B: $tType,A: $tType,A4: set @ A] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A4 @ ( bot_bot @ ( set @ B ) ) ) ) ) @ ( bNF_Wellorder_ordIso @ A @ ( sum_sum @ A @ B ) ) ) ).

% card_of_Plus_empty1
thf(fact_3798_card__of__Un__Plus__ordLeq,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ A ) @ ( sum_sum @ A @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ A ) @ ( sum_sum @ A @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ A ) @ ( sum_Plus @ A @ A @ A4 @ B3 ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( sum_sum @ A @ A ) ) ) ).

% card_of_Un_Plus_ordLeq
thf(fact_3799_card__of__Plus__ordLeq__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ B,B3: set @ C] :
      ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ B3 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) )
         => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ C ) @ ( sum_Plus @ B @ C @ A4 @ B3 ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ B @ C ) @ A ) ) ) ) ) ) ).

% card_of_Plus_ordLeq_infinite_Field
thf(fact_3800_card__of__Plus__ordLess__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ B,B3: set @ C] :
      ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) @ R4 ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) )
         => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ B3 ) @ R4 ) @ ( bNF_We4044943003108391690rdLess @ C @ A ) )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ C ) @ ( sum_Plus @ B @ C @ A4 @ B3 ) ) @ R4 ) @ ( bNF_We4044943003108391690rdLess @ ( sum_sum @ B @ C ) @ A ) ) ) ) ) ) ).

% card_of_Plus_ordLess_infinite_Field
thf(fact_3801_infinite__Card__order__limit,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
         => ? [X2: A] :
              ( ( member @ A @ X2 @ ( field2 @ A @ R4 ) )
              & ( A3 != X2 )
              & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ X2 ) @ R4 ) ) ) ) ) ).

% infinite_Card_order_limit
thf(fact_3802_Card__order__ordIso,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) @ ( bNF_Wellorder_ordIso @ B @ A ) )
       => ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R6 ) @ R6 ) ) ) ).

% Card_order_ordIso
thf(fact_3803_Card__order__ordIso2,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
       => ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R6 ) @ R6 ) ) ) ).

% Card_order_ordIso2
thf(fact_3804_card__of__unique,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ A4 @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) ) ) ).

% card_of_unique
thf(fact_3805_card__order__on__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Ca8970107618336181345der_on @ A )
      = ( ^ [A10: set @ A,R5: set @ ( product_prod @ A @ A )] :
            ( ( order_well_order_on @ A @ A10 @ R5 )
            & ! [R9: set @ ( product_prod @ A @ A )] :
                ( ( order_well_order_on @ A @ A10 @ R9 )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ R9 ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ) ) ) ).

% card_order_on_def
thf(fact_3806_ordLeq__Plus__mono,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),P4: set @ ( product_prod @ C @ C ),P9: set @ ( product_prod @ D @ D )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P4 @ P9 ) @ ( bNF_Wellorder_ordLeq @ C @ D ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ C ) @ ( sum_Plus @ A @ C @ ( field2 @ A @ R4 ) @ ( field2 @ C @ P4 ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ D ) @ ( sum_Plus @ B @ D @ ( field2 @ B @ R6 ) @ ( field2 @ D @ P9 ) ) ) ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) ) ) ) ).

% ordLeq_Plus_mono
thf(fact_3807_ordLeq__Plus__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ C ) @ ( sum_Plus @ A @ C @ ( field2 @ A @ R4 ) @ C3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ C ) @ ( sum_Plus @ B @ C @ ( field2 @ B @ R6 ) @ C3 ) ) ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ C ) ) ) ) ).

% ordLeq_Plus_mono1
thf(fact_3808_ordLeq__Plus__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),A4: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ C @ A ) @ ( sum_Plus @ C @ A @ A4 @ ( field2 @ A @ R4 ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ C @ B ) @ ( sum_Plus @ C @ B @ A4 @ ( field2 @ B @ R6 ) ) ) ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ B ) ) ) ) ).

% ordLeq_Plus_mono2
thf(fact_3809_ordIso__Plus__cong,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),P4: set @ ( product_prod @ C @ C ),P9: set @ ( product_prod @ D @ D )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P4 @ P9 ) @ ( bNF_Wellorder_ordIso @ C @ D ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ C ) @ ( sum_Plus @ A @ C @ ( field2 @ A @ R4 ) @ ( field2 @ C @ P4 ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ D ) @ ( sum_Plus @ B @ D @ ( field2 @ B @ R6 ) @ ( field2 @ D @ P9 ) ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) ) ) ) ).

% ordIso_Plus_cong
thf(fact_3810_ordIso__Plus__cong1,axiom,
    ! [B: $tType,C: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ C ) @ ( sum_Plus @ A @ C @ ( field2 @ A @ R4 ) @ C3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ C ) @ ( sum_Plus @ B @ C @ ( field2 @ B @ R6 ) @ C3 ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ C ) ) ) ) ).

% ordIso_Plus_cong1
thf(fact_3811_ordIso__Plus__cong2,axiom,
    ! [B: $tType,A: $tType,C: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B ),A4: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ C @ A ) @ ( sum_Plus @ C @ A @ A4 @ ( field2 @ A @ R4 ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ C @ B ) @ ( sum_Plus @ C @ B @ A4 @ ( field2 @ B @ R6 ) ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ B ) ) ) ) ).

% ordIso_Plus_cong2
thf(fact_3812_card__of__Plus__mono,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,A4: set @ A,B3: set @ B,C3: set @ C,D4: set @ D] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ C3 ) @ ( bNF_Ca6860139660246222851ard_of @ D @ D4 ) ) @ ( bNF_Wellorder_ordLeq @ C @ D ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ C ) @ ( sum_Plus @ A @ C @ A4 @ C3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ D ) @ ( sum_Plus @ B @ D @ B3 @ D4 ) ) ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) ) ) ) ).

% card_of_Plus_mono
thf(fact_3813_card__of__Plus__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,A4: set @ A,B3: set @ B,C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ C ) @ ( sum_Plus @ A @ C @ A4 @ C3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ C ) @ ( sum_Plus @ B @ C @ B3 @ C3 ) ) ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ C ) ) ) ) ).

% card_of_Plus_mono1
thf(fact_3814_card__of__Plus__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,A4: set @ A,B3: set @ B,C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ C @ A ) @ ( sum_Plus @ C @ A @ C3 @ A4 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ C @ B ) @ ( sum_Plus @ C @ B @ C3 @ B3 ) ) ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ B ) ) ) ) ).

% card_of_Plus_mono2
thf(fact_3815_card__of__Plus__cong,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,A4: set @ A,B3: set @ B,C3: set @ C,D4: set @ D] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ C3 ) @ ( bNF_Ca6860139660246222851ard_of @ D @ D4 ) ) @ ( bNF_Wellorder_ordIso @ C @ D ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ C ) @ ( sum_Plus @ A @ C @ A4 @ C3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ D ) @ ( sum_Plus @ B @ D @ B3 @ D4 ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) ) ) ) ).

% card_of_Plus_cong
thf(fact_3816_card__of__Plus__cong1,axiom,
    ! [B: $tType,C: $tType,A: $tType,A4: set @ A,B3: set @ B,C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ C ) @ ( sum_Plus @ A @ C @ A4 @ C3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ C ) @ ( sum_Plus @ B @ C @ B3 @ C3 ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ C ) ) ) ) ).

% card_of_Plus_cong1
thf(fact_3817_card__of__Plus__cong2,axiom,
    ! [B: $tType,A: $tType,C: $tType,A4: set @ A,B3: set @ B,C3: set @ C] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ C @ A ) @ ( sum_Plus @ C @ A @ C3 @ A4 ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ C @ B ) @ ( sum_Plus @ C @ B @ C3 @ B3 ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ B ) ) ) ) ).

% card_of_Plus_cong2
thf(fact_3818_Card__order__Times2,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( A4
         != ( bot_bot @ ( set @ B ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ R4
            @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
              @ ( product_Sigma @ B @ A @ A4
                @ ^ [Uu: B] : ( field2 @ A @ R4 ) ) ) )
          @ ( bNF_Wellorder_ordLeq @ A @ ( product_prod @ B @ A ) ) ) ) ) ).

% Card_order_Times2
thf(fact_3819_Card__order__Times1,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( B3
         != ( bot_bot @ ( set @ B ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ R4
            @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
              @ ( product_Sigma @ A @ B @ ( field2 @ A @ R4 )
                @ ^ [Uu: A] : B3 ) ) )
          @ ( bNF_Wellorder_ordLeq @ A @ ( product_prod @ A @ B ) ) ) ) ) ).

% Card_order_Times1
thf(fact_3820_Card__order__Times__same__infinite,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) )
            @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ A )
              @ ( product_Sigma @ A @ A @ ( field2 @ A @ R4 )
                @ ^ [Uu: A] : ( field2 @ A @ R4 ) ) )
            @ R4 )
          @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ A ) @ A ) ) ) ) ).

% Card_order_Times_same_infinite
thf(fact_3821_Card__order__Pow,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ R4 @ ( bNF_Ca6860139660246222851ard_of @ ( set @ A ) @ ( pow @ A @ ( field2 @ A @ R4 ) ) ) ) @ ( bNF_We4044943003108391690rdLess @ A @ ( set @ A ) ) ) ) ).

% Card_order_Pow
thf(fact_3822_Card__order__iff__ordLeq__card__of,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
      = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( bNF_Ca6860139660246222851ard_of @ A @ ( field2 @ A @ R4 ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ).

% Card_order_iff_ordLeq_card_of
thf(fact_3823_card__of__Field__ordIso,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( field2 @ A @ R4 ) ) @ R4 ) @ ( bNF_Wellorder_ordIso @ A @ A ) ) ) ).

% card_of_Field_ordIso
thf(fact_3824_Card__order__iff__ordIso__card__of,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
      = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( bNF_Ca6860139660246222851ard_of @ A @ ( field2 @ A @ R4 ) ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) ) ) ).

% Card_order_iff_ordIso_card_of
thf(fact_3825_ordIso__card__of__imp__Card__order,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ B] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) ) ).

% ordIso_card_of_imp_Card_order
thf(fact_3826_card__of__Plus__infinite2,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ A ) @ ( sum_Plus @ B @ A @ B3 @ A4 ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ B @ A ) @ A ) ) ) ) ).

% card_of_Plus_infinite2
thf(fact_3827_card__of__Plus__infinite1,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A4 @ B3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ B ) @ A ) ) ) ) ).

% card_of_Plus_infinite1
thf(fact_3828_card__of__Plus__infinite,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A4 @ B3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ B ) @ A ) )
          & ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ A ) @ ( sum_Plus @ B @ A @ B3 @ A4 ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ B @ A ) @ A ) ) ) ) ) ).

% card_of_Plus_infinite
thf(fact_3829_card__of__Plus__ordLess__infinite,axiom,
    ! [A: $tType,C: $tType,B: $tType,C3: set @ A,A4: set @ B,B3: set @ C] :
      ( ~ ( finite_finite @ A @ C3 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ C3 ) ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ B3 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ C3 ) ) @ ( bNF_We4044943003108391690rdLess @ C @ A ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ B @ C ) @ ( sum_Plus @ B @ C @ A4 @ B3 ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ C3 ) ) @ ( bNF_We4044943003108391690rdLess @ ( sum_sum @ B @ C ) @ A ) ) ) ) ) ).

% card_of_Plus_ordLess_infinite
thf(fact_3830_card__of__Plus__Times,axiom,
    ! [B: $tType,A: $tType,A1: A,A22: A,A4: set @ A,B14: B,B24: B,B3: set @ B] :
      ( ( ( A1 != A22 )
        & ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ A1 @ ( insert2 @ A @ A22 @ ( bot_bot @ ( set @ A ) ) ) ) @ A4 ) )
     => ( ( ( B14 != B24 )
          & ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ B14 @ ( insert2 @ B @ B24 @ ( bot_bot @ ( set @ B ) ) ) ) @ B3 ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A4 @ B3 ) )
            @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
              @ ( product_Sigma @ A @ B @ A4
                @ ^ [Uu: A] : B3 ) ) )
          @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ) ).

% card_of_Plus_Times
thf(fact_3831_exists__minim__Card__order,axiom,
    ! [A: $tType,R: set @ ( set @ ( product_prod @ A @ A ) )] :
      ( ( R
       != ( bot_bot @ ( set @ ( set @ ( product_prod @ A @ A ) ) ) ) )
     => ( ! [X2: set @ ( product_prod @ A @ A )] :
            ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X2 @ R )
           => ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ X2 ) @ X2 ) )
       => ? [X2: set @ ( product_prod @ A @ A )] :
            ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X2 @ R )
            & ! [Xa2: set @ ( product_prod @ A @ A )] :
                ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ Xa2 @ R )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ X2 @ Xa2 ) @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ) ) ) ).

% exists_minim_Card_order
thf(fact_3832_Card__order__empty,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( bot_bot @ ( set @ B ) ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ).

% Card_order_empty
thf(fact_3833_card__of__ordIso__finite__Field,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
       => ( ( finite_finite @ A @ ( field2 @ A @ R4 ) )
          = ( finite_finite @ B @ A4 ) ) ) ) ).

% card_of_ordIso_finite_Field
thf(fact_3834_card__of__underS,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( member @ A @ A3 @ ( field2 @ A @ R4 ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( order_underS @ A @ R4 @ A3 ) ) @ R4 ) @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ).

% card_of_underS
thf(fact_3835_regularCard__UNION,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),As9: A > ( set @ B ),B3: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( bNF_Ca7133664381575040944arCard @ A @ R4 )
       => ( ( bNF_Ca3754400796208372196lChain @ A @ ( set @ B ) @ R4 @ As9 )
         => ( ( ord_less_eq @ ( set @ B ) @ B3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ As9 @ ( field2 @ A @ R4 ) ) ) )
           => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ R4 ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) )
             => ? [X2: A] :
                  ( ( member @ A @ X2 @ ( field2 @ A @ R4 ) )
                  & ( ord_less_eq @ ( set @ B ) @ B3 @ ( As9 @ X2 ) ) ) ) ) ) ) ) ).

% regularCard_UNION
thf(fact_3836_Card__order__singl__ordLeq,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),B2: B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ( field2 @ A @ R4 )
         != ( bot_bot @ ( set @ A ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( insert2 @ B @ B2 @ ( bot_bot @ ( set @ B ) ) ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ) ).

% Card_order_singl_ordLeq
thf(fact_3837_card__of__Un__ordLeq__infinite__Field,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ B,B3: set @ B] :
      ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ) ) ) ).

% card_of_Un_ordLeq_infinite_Field
thf(fact_3838_card__of__empty1,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
        | ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( bot_bot @ ( set @ B ) ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ).

% card_of_empty1
thf(fact_3839_Card__order__Times__infinite,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),P4: set @ ( product_prod @ B @ B )] :
      ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
       => ( ( ( field2 @ B @ P4 )
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P4 @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
           => ( ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
                @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) )
                  @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ A @ B )
                    @ ( product_Sigma @ A @ B @ ( field2 @ A @ R4 )
                      @ ^ [Uu: A] : ( field2 @ B @ P4 ) ) )
                  @ R4 )
                @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ B ) @ A ) )
              & ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
                @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) )
                  @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ A )
                    @ ( product_Sigma @ B @ A @ ( field2 @ B @ P4 )
                      @ ^ [Uu: B] : ( field2 @ A @ R4 ) ) )
                  @ R4 )
                @ ( bNF_Wellorder_ordIso @ ( product_prod @ B @ A ) @ A ) ) ) ) ) ) ) ).

% Card_order_Times_infinite
thf(fact_3840_card__of__Sigma__ordLeq__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),I4: set @ B,A4: B > ( set @ C )] :
      ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ I4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ I4 )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A4 @ X2 ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ C ) @ ( product_Sigma @ B @ C @ I4 @ A4 ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ B @ C ) @ A ) ) ) ) ) ) ).

% card_of_Sigma_ordLeq_infinite_Field
thf(fact_3841_card__of__Times__ordLeq__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ B,B3: set @ C] :
      ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ B3 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) )
         => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( bNF_Ca6860139660246222851ard_of @ ( product_prod @ B @ C )
                  @ ( product_Sigma @ B @ C @ A4
                    @ ^ [Uu: B] : B3 ) )
                @ R4 )
              @ ( bNF_Wellorder_ordLeq @ ( product_prod @ B @ C ) @ A ) ) ) ) ) ) ).

% card_of_Times_ordLeq_infinite_Field
thf(fact_3842_card__of__UNION__ordLeq__infinite__Field,axiom,
    ! [B: $tType,A: $tType,C: $tType,R4: set @ ( product_prod @ A @ A ),I4: set @ B,A4: B > ( set @ C )] :
      ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ I4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ I4 )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A4 @ X2 ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A4 @ I4 ) ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) ) ) ) ) ).

% card_of_UNION_ordLeq_infinite_Field
thf(fact_3843_Plus__eq__empty__conv,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( ( sum_Plus @ A @ B @ A4 @ B3 )
        = ( bot_bot @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        & ( B3
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% Plus_eq_empty_conv
thf(fact_3844_ex__toCard__pred,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,R4: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 )
       => ? [X_1: A > B] : ( bNF_Gr1419584066657907630d_pred @ A @ B @ A4 @ R4 @ X_1 ) ) ) ).

% ex_toCard_pred
thf(fact_3845_cardSuc__UNION,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),As9: ( set @ A ) > ( set @ B ),B3: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ~ ( finite_finite @ A @ ( field2 @ A @ R4 ) )
       => ( ( bNF_Ca3754400796208372196lChain @ ( set @ A ) @ ( set @ B ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) @ As9 )
         => ( ( ord_less_eq @ ( set @ B ) @ B3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ ( set @ A ) @ ( set @ B ) @ As9 @ ( field2 @ ( set @ A ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) ) ) ) )
           => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
             => ? [X2: set @ A] :
                  ( ( member @ ( set @ A ) @ X2 @ ( field2 @ ( set @ A ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) ) )
                  & ( ord_less_eq @ ( set @ B ) @ B3 @ ( As9 @ X2 ) ) ) ) ) ) ) ) ).

% cardSuc_UNION
thf(fact_3846_isCardSuc__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Ca6246979054910435723ardSuc @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),R9: set @ ( product_prod @ ( set @ A ) @ ( set @ A ) )] :
            ( ( bNF_Ca8970107618336181345der_on @ ( set @ A ) @ ( field2 @ ( set @ A ) @ R9 ) @ R9 )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ R5 @ R9 ) @ ( bNF_We4044943003108391690rdLess @ A @ ( set @ A ) ) )
            & ! [R10: set @ ( product_prod @ ( set @ A ) @ ( set @ A ) )] :
                ( ( ( bNF_Ca8970107618336181345der_on @ ( set @ A ) @ ( field2 @ ( set @ A ) @ R10 ) @ R10 )
                  & ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ R5 @ R10 ) @ ( bNF_We4044943003108391690rdLess @ A @ ( set @ A ) ) ) )
               => ( member @ ( product_prod @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ R9 @ R10 ) @ ( bNF_Wellorder_ordLeq @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) ).

% isCardSuc_def
thf(fact_3847_cardSuc__ordLeq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ R4 @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( set @ A ) ) ) ) ).

% cardSuc_ordLeq
thf(fact_3848_cardSuc__greater,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ R4 @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) ) @ ( bNF_We4044943003108391690rdLess @ A @ ( set @ A ) ) ) ) ).

% cardSuc_greater
thf(fact_3849_cardSuc__ordLess__ordLeq,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
          = ( member @ ( product_prod @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) @ R6 ) @ ( bNF_Wellorder_ordLeq @ ( set @ A ) @ B ) ) ) ) ) ).

% cardSuc_ordLess_ordLeq
thf(fact_3850_cardSuc__least,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) @ R6 ) @ ( bNF_Wellorder_ordLeq @ ( set @ A ) @ B ) ) ) ) ) ).

% cardSuc_least
thf(fact_3851_cardSuc__mono__ordLeq,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ ( set @ B ) @ ( set @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ ( set @ B ) @ ( set @ B ) ) ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) @ ( bNF_Ca8387033319878233205ardSuc @ B @ R6 ) ) @ ( bNF_Wellorder_ordLeq @ ( set @ A ) @ ( set @ B ) ) )
          = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ) ) ).

% cardSuc_mono_ordLeq
thf(fact_3852_cardSuc__invar__ordIso,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ ( set @ B ) @ ( set @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ ( set @ B ) @ ( set @ B ) ) ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) @ ( bNF_Ca8387033319878233205ardSuc @ B @ R6 ) ) @ ( bNF_Wellorder_ordIso @ ( set @ A ) @ ( set @ B ) ) )
          = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R6 ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ) ) ).

% cardSuc_invar_ordIso
thf(fact_3853_cardSuc__least__aux,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ ( set @ A ) @ ( set @ A ) )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ ( set @ A ) @ ( field2 @ ( set @ A ) @ R6 ) @ R6 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ R4 @ R6 ) @ ( bNF_We4044943003108391690rdLess @ A @ ( set @ A ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) @ R6 ) @ ( bNF_Wellorder_ordLeq @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ).

% cardSuc_least_aux
thf(fact_3854_cardSuc__ordLeq__ordLess,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R6: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R6 ) @ R6 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ R6 @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) ) @ ( bNF_We4044943003108391690rdLess @ B @ ( set @ A ) ) )
          = ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R6 @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) ) ) ) ) ).

% cardSuc_ordLeq_ordLess
thf(fact_3855_toCard__pred__toCard,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,R4: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 )
       => ( bNF_Gr1419584066657907630d_pred @ A @ B @ A4 @ R4 @ ( bNF_Greatest_toCard @ A @ B @ A4 @ R4 ) ) ) ) ).

% toCard_pred_toCard
thf(fact_3856_cardSuc__UNION__Cinfinite,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),As9: ( set @ A ) > ( set @ B ),B3: set @ B] :
      ( ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( ( bNF_Ca3754400796208372196lChain @ ( set @ A ) @ ( set @ B ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) @ As9 )
       => ( ( ord_less_eq @ ( set @ B ) @ B3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ ( set @ A ) @ ( set @ B ) @ As9 @ ( field2 @ ( set @ A ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) ) ) ) )
         => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
           => ? [X2: set @ A] :
                ( ( member @ ( set @ A ) @ X2 @ ( field2 @ ( set @ A ) @ ( bNF_Ca8387033319878233205ardSuc @ A @ R4 ) ) )
                & ( ord_less_eq @ ( set @ B ) @ B3 @ ( As9 @ X2 ) ) ) ) ) ) ) ).

% cardSuc_UNION_Cinfinite
thf(fact_3857_toCard__inj,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,R4: set @ ( product_prod @ B @ B ),X: A,Y: A] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 )
       => ( ( member @ A @ X @ A4 )
         => ( ( member @ A @ Y @ A4 )
           => ( ( ( bNF_Greatest_toCard @ A @ B @ A4 @ R4 @ X )
                = ( bNF_Greatest_toCard @ A @ B @ A4 @ R4 @ Y ) )
              = ( X = Y ) ) ) ) ) ) ).

% toCard_inj
thf(fact_3858_comp__single__set__bd,axiom,
    ! [B: $tType,D: $tType,A: $tType,E: $tType,C: $tType,Fbd: set @ ( product_prod @ A @ A ),Fset: B > ( set @ C ),Gset: D > ( set @ B ),Gbd: set @ ( product_prod @ E @ E ),X: D] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ Fbd ) @ Fbd )
     => ( ! [X2: B] : ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( Fset @ X2 ) ) @ Fbd ) @ ( bNF_Wellorder_ordLeq @ C @ A ) )
       => ( ! [X2: D] : ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ E @ E ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ E @ E ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( Gset @ X2 ) ) @ Gbd ) @ ( bNF_Wellorder_ordLeq @ B @ E ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ ( product_prod @ E @ A ) @ ( product_prod @ E @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ ( product_prod @ E @ A ) @ ( product_prod @ E @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ Fset @ ( Gset @ X ) ) ) ) @ ( bNF_Cardinal_cprod @ E @ A @ Gbd @ Fbd ) ) @ ( bNF_Wellorder_ordLeq @ C @ ( product_prod @ E @ A ) ) ) ) ) ) ).

% comp_single_set_bd
thf(fact_3859_cinfinite__mono,axiom,
    ! [A: $tType,B: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R1 @ R22 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( bNF_Ca4139267488887388095finite @ A @ R1 )
       => ( bNF_Ca4139267488887388095finite @ B @ R22 ) ) ) ).

% cinfinite_mono
thf(fact_3860_cprod__infinite,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Cardinal_cprod @ A @ A @ R4 @ R4 ) @ R4 ) @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ A ) @ A ) ) ) ).

% cprod_infinite
thf(fact_3861_cprod__com,axiom,
    ! [B: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),P22: set @ ( product_prod @ B @ B )] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) @ ( bNF_Cardinal_cprod @ A @ B @ P1 @ P22 ) @ ( bNF_Cardinal_cprod @ B @ A @ P22 @ P1 ) ) @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A ) ) ) ).

% cprod_com
thf(fact_3862_Cinfinite__limit,axiom,
    ! [A: $tType,X: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ A @ X @ ( field2 @ A @ R4 ) )
     => ( ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
          & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
       => ? [X2: A] :
            ( ( member @ A @ X2 @ ( field2 @ A @ R4 ) )
            & ( X != X2 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X2 ) @ R4 ) ) ) ) ).

% Cinfinite_limit
thf(fact_3863_Cinfinite__limit2,axiom,
    ! [A: $tType,X1: A,R4: set @ ( product_prod @ A @ A ),X22: A] :
      ( ( member @ A @ X1 @ ( field2 @ A @ R4 ) )
     => ( ( member @ A @ X22 @ ( field2 @ A @ R4 ) )
       => ( ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
            & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
         => ? [X2: A] :
              ( ( member @ A @ X2 @ ( field2 @ A @ R4 ) )
              & ( X1 != X2 )
              & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X1 @ X2 ) @ R4 )
              & ( X22 != X2 )
              & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X22 @ X2 ) @ R4 ) ) ) ) ) ).

% Cinfinite_limit2
thf(fact_3864_cprod__cinfinite__bound,axiom,
    ! [B: $tType,C: $tType,A: $tType,P4: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P4 @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) @ Q4 @ R4 ) @ ( bNF_Wellorder_ordLeq @ C @ B ) )
       => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ P4 ) @ P4 )
         => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ Q4 ) @ Q4 )
           => ( ( ( bNF_Ca4139267488887388095finite @ B @ R4 )
                & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 ) )
             => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Cardinal_cprod @ A @ C @ P4 @ Q4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ C ) @ B ) ) ) ) ) ) ) ).

% cprod_cinfinite_bound
thf(fact_3865_cprod__dup,axiom,
    ! [A: $tType,C: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),P4: set @ ( product_prod @ B @ B ),P9: set @ ( product_prod @ C @ C )] :
      ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ A ) @ ( product_prod @ A @ A ) ) ) @ ( bNF_Cardinal_cprod @ B @ C @ P4 @ P9 ) @ ( bNF_Cardinal_cprod @ A @ A @ R4 @ R4 ) ) @ ( bNF_Wellorder_ordIso @ ( product_prod @ B @ C ) @ ( product_prod @ A @ A ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Cardinal_cprod @ B @ C @ P4 @ P9 ) @ R4 ) @ ( bNF_Wellorder_ordIso @ ( product_prod @ B @ C ) @ A ) ) ) ) ) ).

% cprod_dup
thf(fact_3866_Cinfinite__cong,axiom,
    ! [A: $tType,B: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R1 @ R22 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( ( bNF_Ca4139267488887388095finite @ A @ R1 )
          & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R1 ) @ R1 ) )
       => ( ( bNF_Ca4139267488887388095finite @ B @ R22 )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R22 ) @ R22 ) ) ) ) ).

% Cinfinite_cong
thf(fact_3867_Cinfinite__limit__finite,axiom,
    ! [A: $tType,X5: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ A @ X5 )
     => ( ( ord_less_eq @ ( set @ A ) @ X5 @ ( field2 @ A @ R4 ) )
       => ( ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
            & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
         => ? [X2: A] :
              ( ( member @ A @ X2 @ ( field2 @ A @ R4 ) )
              & ! [Xa2: A] :
                  ( ( member @ A @ Xa2 @ X5 )
                 => ( ( Xa2 != X2 )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Xa2 @ X2 ) @ R4 ) ) ) ) ) ) ) ).

% Cinfinite_limit_finite
thf(fact_3868_cprod__mono,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),P22: set @ ( product_prod @ C @ C ),R22: set @ ( product_prod @ D @ D )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordLeq @ C @ D ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ D ) @ ( product_prod @ B @ D ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ D ) @ ( product_prod @ B @ D ) ) ) @ ( bNF_Cardinal_cprod @ A @ C @ P1 @ P22 ) @ ( bNF_Cardinal_cprod @ B @ D @ R1 @ R22 ) ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) ) ) ) ) ).

% cprod_mono
thf(fact_3869_cprod__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( bNF_Cardinal_cprod @ A @ C @ P1 @ Q4 ) @ ( bNF_Cardinal_cprod @ B @ C @ R1 @ Q4 ) ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C ) ) ) ) ).

% cprod_mono1
thf(fact_3870_cprod__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,P22: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) ) @ ( bNF_Cardinal_cprod @ C @ A @ Q4 @ P22 ) @ ( bNF_Cardinal_cprod @ C @ B @ Q4 @ R22 ) ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ C @ A ) @ ( product_prod @ C @ B ) ) ) ) ).

% cprod_mono2
thf(fact_3871_cprod__cong,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),P22: set @ ( product_prod @ C @ C ),R22: set @ ( product_prod @ D @ D )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordIso @ C @ D ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ D ) @ ( product_prod @ B @ D ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ D ) @ ( product_prod @ B @ D ) ) ) @ ( bNF_Cardinal_cprod @ A @ C @ P1 @ P22 ) @ ( bNF_Cardinal_cprod @ B @ D @ R1 @ R22 ) ) @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) ) ) ) ) ).

% cprod_cong
thf(fact_3872_cprod__cong1,axiom,
    ! [B: $tType,C: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),P22: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( bNF_Cardinal_cprod @ A @ C @ P1 @ P22 ) @ ( bNF_Cardinal_cprod @ B @ C @ R1 @ P22 ) ) @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C ) ) ) ) ).

% cprod_cong1
thf(fact_3873_cprod__cong2,axiom,
    ! [B: $tType,A: $tType,C: $tType,P22: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ C @ A ) @ ( product_prod @ C @ A ) ) ) @ ( set @ ( product_prod @ ( product_prod @ C @ B ) @ ( product_prod @ C @ B ) ) ) @ ( bNF_Cardinal_cprod @ C @ A @ Q4 @ P22 ) @ ( bNF_Cardinal_cprod @ C @ B @ Q4 @ R22 ) ) @ ( bNF_Wellorder_ordIso @ ( product_prod @ C @ A ) @ ( product_prod @ C @ B ) ) ) ) ).

% cprod_cong2
thf(fact_3874_Un__Cinfinite__bound,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,R4: set @ ( product_prod @ B @ B ),B3: set @ A] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
       => ( ( ( bNF_Ca4139267488887388095finite @ B @ R4 )
            & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) ) ) ) ) ).

% Un_Cinfinite_bound
thf(fact_3875_UNION__Cinfinite__bound,axiom,
    ! [A: $tType,B: $tType,C: $tType,I4: set @ A,R4: set @ ( product_prod @ B @ B ),A4: A > ( set @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ I4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ I4 )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A4 @ X2 ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ C @ B ) ) )
       => ( ( ( bNF_Ca4139267488887388095finite @ B @ R4 )
            & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ A @ ( set @ C ) @ A4 @ I4 ) ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ C @ B ) ) ) ) ) ).

% UNION_Cinfinite_bound
thf(fact_3876_fromCard__toCard,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,R4: set @ ( product_prod @ B @ B ),B2: A] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 )
       => ( ( member @ A @ B2 @ A4 )
         => ( ( bNF_Gr5436034075474128252omCard @ A @ B @ A4 @ R4 @ ( bNF_Greatest_toCard @ A @ B @ A4 @ R4 @ B2 ) )
            = B2 ) ) ) ) ).

% fromCard_toCard
thf(fact_3877_card__of__Csum__Times_H,axiom,
    ! [A: $tType,C: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),I4: set @ B,A4: B > ( set @ C )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ! [X2: B] :
            ( ( member @ B @ X2 @ I4 )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ ( A4 @ X2 ) ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ C @ A ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ B @ C ) @ ( product_prod @ B @ C ) ) ) @ ( set @ ( product_prod @ ( product_prod @ B @ A ) @ ( product_prod @ B @ A ) ) )
            @ ( bNF_Cardinal_Csum @ B @ C @ ( bNF_Ca6860139660246222851ard_of @ B @ I4 )
              @ ^ [I2: B] : ( bNF_Ca6860139660246222851ard_of @ C @ ( A4 @ I2 ) ) )
            @ ( bNF_Cardinal_cprod @ B @ A @ ( bNF_Ca6860139660246222851ard_of @ B @ I4 ) @ R4 ) )
          @ ( bNF_Wellorder_ordLeq @ ( product_prod @ B @ C ) @ ( product_prod @ B @ A ) ) ) ) ) ).

% card_of_Csum_Times'
thf(fact_3878_card__of__Csum__Times,axiom,
    ! [C: $tType,B: $tType,A: $tType,I4: set @ A,A4: A > ( set @ B ),B3: set @ C] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ I4 )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ C @ C ) ) @ ( bNF_Ca6860139660246222851ard_of @ B @ ( A4 @ X2 ) ) @ ( bNF_Ca6860139660246222851ard_of @ C @ B3 ) ) @ ( bNF_Wellorder_ordLeq @ B @ C ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) ) )
        @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ C ) @ ( product_prod @ A @ C ) ) )
          @ ( bNF_Cardinal_Csum @ A @ B @ ( bNF_Ca6860139660246222851ard_of @ A @ I4 )
            @ ^ [I2: A] : ( bNF_Ca6860139660246222851ard_of @ B @ ( A4 @ I2 ) ) )
          @ ( bNF_Cardinal_cprod @ A @ C @ ( bNF_Ca6860139660246222851ard_of @ A @ I4 ) @ ( bNF_Ca6860139660246222851ard_of @ C @ B3 ) ) )
        @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) ) ).

% card_of_Csum_Times
thf(fact_3879_Cfinite__cprod__Cinfinite,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ B @ B )] :
      ( ( ( bNF_Cardinal_cfinite @ A @ R4 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( ( ( bNF_Ca4139267488887388095finite @ B @ S )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ S ) @ S ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Cardinal_cprod @ A @ B @ R4 @ S ) @ S ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ B ) @ B ) ) ) ) ).

% Cfinite_cprod_Cinfinite
thf(fact_3880_Cfinite__ordLess__Cinfinite,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ B @ B )] :
      ( ( ( bNF_Cardinal_cfinite @ A @ R4 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( ( ( bNF_Ca4139267488887388095finite @ B @ S )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ S ) @ S ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ S ) @ ( bNF_We4044943003108391690rdLess @ A @ B ) ) ) ) ).

% Cfinite_ordLess_Cinfinite
thf(fact_3881_cprod__infinite1_H,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),P4: set @ ( product_prod @ B @ B )] :
      ( ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P4 @ ( bNF_Cardinal_czero @ B ) ) @ ( bNF_Wellorder_ordIso @ B @ B ) )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ P4 ) @ P4 ) )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P4 @ R4 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Cardinal_cprod @ A @ B @ R4 @ P4 ) @ R4 ) @ ( bNF_Wellorder_ordIso @ ( product_prod @ A @ B ) @ A ) ) ) ) ) ).

% cprod_infinite1'
thf(fact_3882_ordLeq__cprod2,axiom,
    ! [A: $tType,B: $tType,P1: set @ ( product_prod @ A @ A ),P22: set @ ( product_prod @ B @ B )] :
      ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P1 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ P1 ) @ P1 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ P22 ) @ P22 )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ P22 @ ( bNF_Cardinal_cprod @ A @ B @ P1 @ P22 ) ) @ ( bNF_Wellorder_ordLeq @ B @ ( product_prod @ A @ B ) ) ) ) ) ).

% ordLeq_cprod2
thf(fact_3883_cone__def,axiom,
    ( bNF_Cardinal_cone
    = ( bNF_Ca6860139660246222851ard_of @ product_unit @ ( insert2 @ product_unit @ product_Unity @ ( bot_bot @ ( set @ product_unit ) ) ) ) ) ).

% cone_def
thf(fact_3884_cinfinite__cprod2,axiom,
    ! [A: $tType,B: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B )] :
      ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R1 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R1 ) @ R1 ) )
     => ( ( ( bNF_Ca4139267488887388095finite @ B @ R22 )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R22 ) @ R22 ) )
       => ( bNF_Ca4139267488887388095finite @ ( product_prod @ A @ B ) @ ( bNF_Cardinal_cprod @ A @ B @ R1 @ R22 ) ) ) ) ).

% cinfinite_cprod2
thf(fact_3885_cone__not__czero,axiom,
    ! [A: $tType] :
      ~ ( member @ ( product_prod @ ( set @ ( product_prod @ product_unit @ product_unit ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ product_unit @ product_unit ) ) @ ( set @ ( product_prod @ A @ A ) ) @ bNF_Cardinal_cone @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ product_unit @ A ) ) ).

% cone_not_czero
thf(fact_3886_czero__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Cardinal_czero @ A )
      = ( bNF_Ca6860139660246222851ard_of @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% czero_def
thf(fact_3887_czero__ordIso,axiom,
    ! [B: $tType,A: $tType] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Cardinal_czero @ A ) @ ( bNF_Cardinal_czero @ B ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ).

% czero_ordIso
thf(fact_3888_cone__ordLeq__Cnotzero,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ product_unit @ product_unit ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ product_unit @ product_unit ) ) @ ( set @ ( product_prod @ A @ A ) ) @ bNF_Cardinal_cone @ R4 ) @ ( bNF_Wellorder_ordLeq @ product_unit @ A ) ) ) ).

% cone_ordLeq_Cnotzero
thf(fact_3889_cinfinite__not__czero,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca4139267488887388095finite @ B @ R4 )
     => ~ ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ B @ A ) ) ) ).

% cinfinite_not_czero
thf(fact_3890_czeroE,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ ( bNF_Cardinal_czero @ B ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( field2 @ A @ R4 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% czeroE
thf(fact_3891_card__of__ordIso__czero__iff__empty,axiom,
    ! [B: $tType,A: $tType,A4: set @ A] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Cardinal_czero @ B ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% card_of_ordIso_czero_iff_empty
thf(fact_3892_czeroI,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ( field2 @ A @ R4 )
          = ( bot_bot @ ( set @ A ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ ( bNF_Cardinal_czero @ B ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ) ).

% czeroI
thf(fact_3893_Cnotzero__imp__not__empty,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( ( field2 @ A @ R4 )
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% Cnotzero_imp_not_empty
thf(fact_3894_Cnotzero__mono,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),Q4: set @ ( product_prod @ B @ B )] :
      ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ Q4 ) @ Q4 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ Q4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
         => ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ Q4 @ ( bNF_Cardinal_czero @ B ) ) @ ( bNF_Wellorder_ordIso @ B @ B ) )
            & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ Q4 ) @ Q4 ) ) ) ) ) ).

% Cnotzero_mono
thf(fact_3895_Cinfinite__Cnotzero,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) ) ) ).

% Cinfinite_Cnotzero
thf(fact_3896_Cnotzero__UNIV,axiom,
    ! [A: $tType] :
      ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( top_top @ ( set @ A ) ) ) @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
      & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ ( bNF_Ca6860139660246222851ard_of @ A @ ( top_top @ ( set @ A ) ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% Cnotzero_UNIV
thf(fact_3897_Cinfinite__cprod2,axiom,
    ! [A: $tType,B: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B )] :
      ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R1 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R1 ) @ R1 ) )
     => ( ( ( bNF_Ca4139267488887388095finite @ B @ R22 )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R22 ) @ R22 ) )
       => ( ( bNF_Ca4139267488887388095finite @ ( product_prod @ A @ B ) @ ( bNF_Cardinal_cprod @ A @ B @ R1 @ R22 ) )
          & ( bNF_Ca8970107618336181345der_on @ ( product_prod @ A @ B ) @ ( field2 @ ( product_prod @ A @ B ) @ ( bNF_Cardinal_cprod @ A @ B @ R1 @ R22 ) ) @ ( bNF_Cardinal_cprod @ A @ B @ R1 @ R22 ) ) ) ) ) ).

% Cinfinite_cprod2
thf(fact_3898_cexp__mono,axiom,
    ! [E: $tType,F9: $tType,B: $tType,D: $tType,A: $tType,C: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),P22: set @ ( product_prod @ C @ C ),R22: set @ ( product_prod @ D @ D )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordLeq @ C @ D ) )
       => ( ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ E @ E ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ E @ E ) ) @ P22 @ ( bNF_Cardinal_czero @ E ) ) @ ( bNF_Wellorder_ordIso @ C @ E ) )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ D @ D ) ) @ ( set @ ( product_prod @ F9 @ F9 ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ D @ D ) ) @ ( set @ ( product_prod @ F9 @ F9 ) ) @ R22 @ ( bNF_Cardinal_czero @ F9 ) ) @ ( bNF_Wellorder_ordIso @ D @ F9 ) ) )
         => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ P22 ) @ P22 )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( D > B ) @ ( D > B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( D > B ) @ ( D > B ) ) ) @ ( bNF_Cardinal_cexp @ A @ C @ P1 @ P22 ) @ ( bNF_Cardinal_cexp @ B @ D @ R1 @ R22 ) ) @ ( bNF_Wellorder_ordLeq @ ( C > A ) @ ( D > B ) ) ) ) ) ) ) ).

% cexp_mono
thf(fact_3899_cexp__mono2,axiom,
    ! [D: $tType,E: $tType,B: $tType,C: $tType,A: $tType,P22: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ Q4 ) @ Q4 )
       => ( ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P22 @ ( bNF_Cardinal_czero @ D ) ) @ ( bNF_Wellorder_ordIso @ A @ D ) )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ E @ E ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ E @ E ) ) @ R22 @ ( bNF_Cardinal_czero @ E ) ) @ ( bNF_Wellorder_ordIso @ B @ E ) ) )
         => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ P22 ) @ P22 )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > C ) @ ( A > C ) ) ) @ ( set @ ( product_prod @ ( B > C ) @ ( B > C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( A > C ) @ ( A > C ) ) ) @ ( set @ ( product_prod @ ( B > C ) @ ( B > C ) ) ) @ ( bNF_Cardinal_cexp @ C @ A @ Q4 @ P22 ) @ ( bNF_Cardinal_cexp @ C @ B @ Q4 @ R22 ) ) @ ( bNF_Wellorder_ordLeq @ ( A > C ) @ ( B > C ) ) ) ) ) ) ) ).

% cexp_mono2
thf(fact_3900_cexp__mono2__Cnotzero,axiom,
    ! [B: $tType,C: $tType,A: $tType,P22: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ Q4 ) @ Q4 )
       => ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P22 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
            & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ P22 ) @ P22 ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > C ) @ ( A > C ) ) ) @ ( set @ ( product_prod @ ( B > C ) @ ( B > C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( A > C ) @ ( A > C ) ) ) @ ( set @ ( product_prod @ ( B > C ) @ ( B > C ) ) ) @ ( bNF_Cardinal_cexp @ C @ A @ Q4 @ P22 ) @ ( bNF_Cardinal_cexp @ C @ B @ Q4 @ R22 ) ) @ ( bNF_Wellorder_ordLeq @ ( A > C ) @ ( B > C ) ) ) ) ) ) ).

% cexp_mono2_Cnotzero
thf(fact_3901_csum__dup,axiom,
    ! [A: $tType,C: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),P4: set @ ( product_prod @ B @ B ),P9: set @ ( product_prod @ C @ C )] :
      ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ A ) @ ( sum_sum @ A @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ A ) @ ( sum_sum @ A @ A ) ) ) @ ( bNF_Cardinal_csum @ B @ C @ P4 @ P9 ) @ ( bNF_Cardinal_csum @ A @ A @ R4 @ R4 ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ B @ C ) @ ( sum_sum @ A @ A ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Cardinal_csum @ B @ C @ P4 @ P9 ) @ R4 ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ B @ C ) @ A ) ) ) ) ) ).

% csum_dup
thf(fact_3902_cprod__csum__distrib1,axiom,
    ! [C: $tType,B: $tType,A: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),R33: set @ ( product_prod @ C @ C )] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) ) ) @ ( set @ ( product_prod @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) ) ) @ ( bNF_Cardinal_csum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) @ ( bNF_Cardinal_cprod @ A @ B @ R1 @ R22 ) @ ( bNF_Cardinal_cprod @ A @ C @ R1 @ R33 ) ) @ ( bNF_Cardinal_cprod @ A @ ( sum_sum @ B @ C ) @ R1 @ ( bNF_Cardinal_csum @ B @ C @ R22 @ R33 ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) ) @ ( product_prod @ A @ ( sum_sum @ B @ C ) ) ) ) ).

% cprod_csum_distrib1
thf(fact_3903_csum__assoc,axiom,
    ! [C: $tType,B: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),P22: set @ ( product_prod @ B @ B ),P32: set @ ( product_prod @ C @ C )] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) ) ) @ ( bNF_Cardinal_csum @ ( sum_sum @ A @ B ) @ C @ ( bNF_Cardinal_csum @ A @ B @ P1 @ P22 ) @ P32 ) @ ( bNF_Cardinal_csum @ A @ ( sum_sum @ B @ C ) @ P1 @ ( bNF_Cardinal_csum @ B @ C @ P22 @ P32 ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ ( sum_sum @ A @ B ) @ C ) @ ( sum_sum @ A @ ( sum_sum @ B @ C ) ) ) ) ).

% csum_assoc
thf(fact_3904_csum__csum,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),R33: set @ ( product_prod @ C @ C ),R42: set @ ( product_prod @ D @ D )] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ ( sum_sum @ A @ B ) @ ( sum_sum @ C @ D ) ) @ ( sum_sum @ ( sum_sum @ A @ B ) @ ( sum_sum @ C @ D ) ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) @ ( sum_sum @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ ( sum_sum @ A @ B ) @ ( sum_sum @ C @ D ) ) @ ( sum_sum @ ( sum_sum @ A @ B ) @ ( sum_sum @ C @ D ) ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) @ ( sum_sum @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) ) ) @ ( bNF_Cardinal_csum @ ( sum_sum @ A @ B ) @ ( sum_sum @ C @ D ) @ ( bNF_Cardinal_csum @ A @ B @ R1 @ R22 ) @ ( bNF_Cardinal_csum @ C @ D @ R33 @ R42 ) ) @ ( bNF_Cardinal_csum @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) @ ( bNF_Cardinal_csum @ A @ C @ R1 @ R33 ) @ ( bNF_Cardinal_csum @ B @ D @ R22 @ R42 ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ ( sum_sum @ A @ B ) @ ( sum_sum @ C @ D ) ) @ ( sum_sum @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) ) ) ).

% csum_csum
thf(fact_3905_cexp__cprod,axiom,
    ! [A: $tType,C: $tType,B: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ C @ C ),R33: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R1 ) @ R1 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( B > C > A ) @ ( B > C > A ) ) ) @ ( set @ ( product_prod @ ( ( product_prod @ C @ B ) > A ) @ ( ( product_prod @ C @ B ) > A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( B > C > A ) @ ( B > C > A ) ) ) @ ( set @ ( product_prod @ ( ( product_prod @ C @ B ) > A ) @ ( ( product_prod @ C @ B ) > A ) ) ) @ ( bNF_Cardinal_cexp @ ( C > A ) @ B @ ( bNF_Cardinal_cexp @ A @ C @ R1 @ R22 ) @ R33 ) @ ( bNF_Cardinal_cexp @ A @ ( product_prod @ C @ B ) @ R1 @ ( bNF_Cardinal_cprod @ C @ B @ R22 @ R33 ) ) ) @ ( bNF_Wellorder_ordIso @ ( B > C > A ) @ ( ( product_prod @ C @ B ) > A ) ) ) ) ).

% cexp_cprod
thf(fact_3906_cprod__cexp__csum__cexp__Cinfinite,axiom,
    ! [C: $tType,B: $tType,A: $tType,T4: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ B @ B ),S: set @ ( product_prod @ C @ C )] :
      ( ( ( bNF_Ca4139267488887388095finite @ A @ T4 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ T4 ) @ T4 ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > ( product_prod @ B @ C ) ) @ ( A > ( product_prod @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( A > ( sum_sum @ B @ C ) ) @ ( A > ( sum_sum @ B @ C ) ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( A > ( product_prod @ B @ C ) ) @ ( A > ( product_prod @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( A > ( sum_sum @ B @ C ) ) @ ( A > ( sum_sum @ B @ C ) ) ) ) @ ( bNF_Cardinal_cexp @ ( product_prod @ B @ C ) @ A @ ( bNF_Cardinal_cprod @ B @ C @ R4 @ S ) @ T4 ) @ ( bNF_Cardinal_cexp @ ( sum_sum @ B @ C ) @ A @ ( bNF_Cardinal_csum @ B @ C @ R4 @ S ) @ T4 ) ) @ ( bNF_Wellorder_ordLeq @ ( A > ( product_prod @ B @ C ) ) @ ( A > ( sum_sum @ B @ C ) ) ) ) ) ).

% cprod_cexp_csum_cexp_Cinfinite
thf(fact_3907_csum__com,axiom,
    ! [B: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),P22: set @ ( product_prod @ B @ B )] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( bNF_Cardinal_csum @ A @ B @ P1 @ P22 ) @ ( bNF_Cardinal_csum @ B @ A @ P22 @ P1 ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ B ) @ ( sum_sum @ B @ A ) ) ) ).

% csum_com
thf(fact_3908_cprod__cexp,axiom,
    ! [C: $tType,B: $tType,A: $tType,R4: set @ ( product_prod @ B @ B ),S: set @ ( product_prod @ C @ C ),T4: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > ( product_prod @ B @ C ) ) @ ( A > ( product_prod @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( product_prod @ ( A > B ) @ ( A > C ) ) @ ( product_prod @ ( A > B ) @ ( A > C ) ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( A > ( product_prod @ B @ C ) ) @ ( A > ( product_prod @ B @ C ) ) ) ) @ ( set @ ( product_prod @ ( product_prod @ ( A > B ) @ ( A > C ) ) @ ( product_prod @ ( A > B ) @ ( A > C ) ) ) ) @ ( bNF_Cardinal_cexp @ ( product_prod @ B @ C ) @ A @ ( bNF_Cardinal_cprod @ B @ C @ R4 @ S ) @ T4 ) @ ( bNF_Cardinal_cprod @ ( A > B ) @ ( A > C ) @ ( bNF_Cardinal_cexp @ B @ A @ R4 @ T4 ) @ ( bNF_Cardinal_cexp @ C @ A @ S @ T4 ) ) ) @ ( bNF_Wellorder_ordIso @ ( A > ( product_prod @ B @ C ) ) @ ( product_prod @ ( A > B ) @ ( A > C ) ) ) ) ).

% cprod_cexp
thf(fact_3909_cexp__cone,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_unit > A ) @ ( product_unit > A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_unit > A ) @ ( product_unit > A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Cardinal_cexp @ A @ product_unit @ R4 @ bNF_Cardinal_cone ) @ R4 ) @ ( bNF_Wellorder_ordIso @ ( product_unit > A ) @ A ) ) ) ).

% cexp_cone
thf(fact_3910_cexp__cprod__ordLeq,axiom,
    ! [A: $tType,B: $tType,C: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),R33: set @ ( product_prod @ C @ C )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R1 ) @ R1 )
     => ( ( ( bNF_Ca4139267488887388095finite @ B @ R22 )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R22 ) @ R22 ) )
       => ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ C @ C ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ C @ C ) ) @ R33 @ ( bNF_Cardinal_czero @ C ) ) @ ( bNF_Wellorder_ordIso @ C @ C ) )
            & ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ R33 ) @ R33 ) )
         => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R33 @ R22 ) @ ( bNF_Wellorder_ordLeq @ C @ B ) )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ ( C > B > A ) @ ( C > B > A ) ) ) @ ( set @ ( product_prod @ ( B > A ) @ ( B > A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( C > B > A ) @ ( C > B > A ) ) ) @ ( set @ ( product_prod @ ( B > A ) @ ( B > A ) ) ) @ ( bNF_Cardinal_cexp @ ( B > A ) @ C @ ( bNF_Cardinal_cexp @ A @ B @ R1 @ R22 ) @ R33 ) @ ( bNF_Cardinal_cexp @ A @ B @ R1 @ R22 ) ) @ ( bNF_Wellorder_ordIso @ ( C > B > A ) @ ( B > A ) ) ) ) ) ) ) ).

% cexp_cprod_ordLeq
thf(fact_3911_Un__csum,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ A ) @ ( sum_sum @ A @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ A ) @ ( sum_sum @ A @ A ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) ) @ ( bNF_Cardinal_csum @ A @ A @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ A @ B3 ) ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( sum_sum @ A @ A ) ) ) ).

% Un_csum
thf(fact_3912_ordLeq__csum2,axiom,
    ! [B: $tType,A: $tType,P22: set @ ( product_prod @ A @ A ),P1: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ P22 ) @ P22 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ P22 @ ( bNF_Cardinal_csum @ B @ A @ P1 @ P22 ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( sum_sum @ B @ A ) ) ) ) ).

% ordLeq_csum2
thf(fact_3913_ordLeq__csum1,axiom,
    ! [B: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),P22: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ P1 ) @ P1 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ P1 @ ( bNF_Cardinal_csum @ A @ B @ P1 @ P22 ) ) @ ( bNF_Wellorder_ordLeq @ A @ ( sum_sum @ A @ B ) ) ) ) ).

% ordLeq_csum1
thf(fact_3914_csum__cong2,axiom,
    ! [B: $tType,A: $tType,C: $tType,P22: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) @ ( bNF_Cardinal_csum @ C @ A @ Q4 @ P22 ) @ ( bNF_Cardinal_csum @ C @ B @ Q4 @ R22 ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ B ) ) ) ) ).

% csum_cong2
thf(fact_3915_csum__cong1,axiom,
    ! [B: $tType,C: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( bNF_Cardinal_csum @ A @ C @ P1 @ Q4 ) @ ( bNF_Cardinal_csum @ B @ C @ R1 @ Q4 ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ C ) ) ) ) ).

% csum_cong1
thf(fact_3916_csum__cong,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),P22: set @ ( product_prod @ C @ C ),R22: set @ ( product_prod @ D @ D )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordIso @ C @ D ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) @ ( bNF_Cardinal_csum @ A @ C @ P1 @ P22 ) @ ( bNF_Cardinal_csum @ B @ D @ R1 @ R22 ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) ) ) ) ).

% csum_cong
thf(fact_3917_csum__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,P22: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ A ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ C @ B ) @ ( sum_sum @ C @ B ) ) ) @ ( bNF_Cardinal_csum @ C @ A @ Q4 @ P22 ) @ ( bNF_Cardinal_csum @ C @ B @ Q4 @ R22 ) ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ C @ A ) @ ( sum_sum @ C @ B ) ) ) ) ).

% csum_mono2
thf(fact_3918_csum__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ C ) ) ) @ ( bNF_Cardinal_csum @ A @ C @ P1 @ Q4 ) @ ( bNF_Cardinal_csum @ B @ C @ R1 @ Q4 ) ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ C ) ) ) ) ).

% csum_mono1
thf(fact_3919_csum__mono,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),P22: set @ ( product_prod @ C @ C ),R22: set @ ( product_prod @ D @ D )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordLeq @ C @ D ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ B @ D ) @ ( sum_sum @ B @ D ) ) ) @ ( bNF_Cardinal_csum @ A @ C @ P1 @ P22 ) @ ( bNF_Cardinal_csum @ B @ D @ R1 @ R22 ) ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ C ) @ ( sum_sum @ B @ D ) ) ) ) ) ).

% csum_mono
thf(fact_3920_Plus__csum,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( bNF_Ca6860139660246222851ard_of @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A4 @ B3 ) ) @ ( bNF_Cardinal_csum @ A @ B @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) ).

% Plus_csum
thf(fact_3921_cexp__mono_H,axiom,
    ! [B: $tType,D: $tType,A: $tType,C: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),P22: set @ ( product_prod @ C @ C ),R22: set @ ( product_prod @ D @ D )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordLeq @ C @ D ) )
       => ( ( ( ( field2 @ C @ P22 )
              = ( bot_bot @ ( set @ C ) ) )
           => ( ( field2 @ D @ R22 )
              = ( bot_bot @ ( set @ D ) ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( D > B ) @ ( D > B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( D > B ) @ ( D > B ) ) ) @ ( bNF_Cardinal_cexp @ A @ C @ P1 @ P22 ) @ ( bNF_Cardinal_cexp @ B @ D @ R1 @ R22 ) ) @ ( bNF_Wellorder_ordLeq @ ( C > A ) @ ( D > B ) ) ) ) ) ) ).

% cexp_mono'
thf(fact_3922_cexp__mono1,axiom,
    ! [B: $tType,A: $tType,C: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ Q4 ) @ Q4 )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( C > B ) @ ( C > B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( C > B ) @ ( C > B ) ) ) @ ( bNF_Cardinal_cexp @ A @ C @ P1 @ Q4 ) @ ( bNF_Cardinal_cexp @ B @ C @ R1 @ Q4 ) ) @ ( bNF_Wellorder_ordLeq @ ( C > A ) @ ( C > B ) ) ) ) ) ).

% cexp_mono1
thf(fact_3923_cexp__mono2_H,axiom,
    ! [B: $tType,C: $tType,A: $tType,P22: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ Q4 ) @ Q4 )
       => ( ( ( ( field2 @ A @ P22 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( field2 @ B @ R22 )
              = ( bot_bot @ ( set @ B ) ) ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > C ) @ ( A > C ) ) ) @ ( set @ ( product_prod @ ( B > C ) @ ( B > C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( A > C ) @ ( A > C ) ) ) @ ( set @ ( product_prod @ ( B > C ) @ ( B > C ) ) ) @ ( bNF_Cardinal_cexp @ C @ A @ Q4 @ P22 ) @ ( bNF_Cardinal_cexp @ C @ B @ Q4 @ R22 ) ) @ ( bNF_Wellorder_ordLeq @ ( A > C ) @ ( B > C ) ) ) ) ) ) ).

% cexp_mono2'
thf(fact_3924_csum__absorb2_H,axiom,
    ! [A: $tType,B: $tType,R22: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R22 ) @ R22 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R1 @ R22 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ( ( bNF_Ca4139267488887388095finite @ B @ R1 )
            | ( bNF_Ca4139267488887388095finite @ A @ R22 ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ B @ A ) @ ( sum_sum @ B @ A ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Cardinal_csum @ B @ A @ R1 @ R22 ) @ R22 ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ B @ A ) @ A ) ) ) ) ) ).

% csum_absorb2'
thf(fact_3925_csum__absorb1_H,axiom,
    ! [B: $tType,A: $tType,R22: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R22 ) @ R22 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R1 @ R22 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( ( ( bNF_Ca4139267488887388095finite @ B @ R1 )
            | ( bNF_Ca4139267488887388095finite @ A @ R22 ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Cardinal_csum @ A @ B @ R22 @ R1 ) @ R22 ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ B ) @ A ) ) ) ) ) ).

% csum_absorb1'
thf(fact_3926_csum__absorb1,axiom,
    ! [B: $tType,A: $tType,R22: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B )] :
      ( ( ( bNF_Ca4139267488887388095finite @ A @ R22 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R22 ) @ R22 ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R1 @ R22 ) @ ( bNF_Wellorder_ordLeq @ B @ A ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_Cardinal_csum @ A @ B @ R22 @ R1 ) @ R22 ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ B ) @ A ) ) ) ) ).

% csum_absorb1
thf(fact_3927_ordLeq__cexp1,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),Q4: set @ ( product_prod @ B @ B )] :
      ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ Q4 ) @ Q4 )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( A > B ) @ ( A > B ) ) ) @ Q4 @ ( bNF_Cardinal_cexp @ B @ A @ Q4 @ R4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ ( A > B ) ) ) ) ) ).

% ordLeq_cexp1
thf(fact_3928_csum__cinfinite__bound,axiom,
    ! [B: $tType,C: $tType,A: $tType,P4: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P4 @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ B @ B ) ) @ Q4 @ R4 ) @ ( bNF_Wellorder_ordLeq @ C @ B ) )
       => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ P4 ) @ P4 )
         => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ Q4 ) @ Q4 )
           => ( ( ( bNF_Ca4139267488887388095finite @ B @ R4 )
                & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 ) )
             => ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ C ) ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Cardinal_csum @ A @ C @ P4 @ Q4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ ( sum_sum @ A @ C ) @ B ) ) ) ) ) ) ) ).

% csum_cinfinite_bound
thf(fact_3929_csum__Cnotzero1,axiom,
    ! [A: $tType,B: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B )] :
      ( ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R1 @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ A @ A ) )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R1 ) @ R1 ) )
     => ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( set @ ( product_prod @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) ) @ ( bNF_Cardinal_csum @ A @ B @ R1 @ R22 ) @ ( bNF_Cardinal_czero @ ( sum_sum @ A @ B ) ) ) @ ( bNF_Wellorder_ordIso @ ( sum_sum @ A @ B ) @ ( sum_sum @ A @ B ) ) )
        & ( bNF_Ca8970107618336181345der_on @ ( sum_sum @ A @ B ) @ ( field2 @ ( sum_sum @ A @ B ) @ ( bNF_Cardinal_csum @ A @ B @ R1 @ R22 ) ) @ ( bNF_Cardinal_csum @ A @ B @ R1 @ R22 ) ) ) ) ).

% csum_Cnotzero1
thf(fact_3930_cexp__cong2,axiom,
    ! [B: $tType,C: $tType,A: $tType,P22: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ Q4 ) @ Q4 )
       => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ P22 ) @ P22 )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( A > C ) @ ( A > C ) ) ) @ ( set @ ( product_prod @ ( B > C ) @ ( B > C ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( A > C ) @ ( A > C ) ) ) @ ( set @ ( product_prod @ ( B > C ) @ ( B > C ) ) ) @ ( bNF_Cardinal_cexp @ C @ A @ Q4 @ P22 ) @ ( bNF_Cardinal_cexp @ C @ B @ Q4 @ R22 ) ) @ ( bNF_Wellorder_ordIso @ ( A > C ) @ ( B > C ) ) ) ) ) ) ).

% cexp_cong2
thf(fact_3931_cexp__cong1,axiom,
    ! [B: $tType,A: $tType,C: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),Q4: set @ ( product_prod @ C @ C )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ Q4 ) @ Q4 )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( C > B ) @ ( C > B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( C > B ) @ ( C > B ) ) ) @ ( bNF_Cardinal_cexp @ A @ C @ P1 @ Q4 ) @ ( bNF_Cardinal_cexp @ B @ C @ R1 @ Q4 ) ) @ ( bNF_Wellorder_ordIso @ ( C > A ) @ ( C > B ) ) ) ) ) ).

% cexp_cong1
thf(fact_3932_cexp__cong,axiom,
    ! [B: $tType,D: $tType,A: $tType,C: $tType,P1: set @ ( product_prod @ A @ A ),R1: set @ ( product_prod @ B @ B ),P22: set @ ( product_prod @ C @ C ),R22: set @ ( product_prod @ D @ D )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ P1 @ R1 ) @ ( bNF_Wellorder_ordIso @ A @ B ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ C @ C ) ) @ ( set @ ( product_prod @ D @ D ) ) @ P22 @ R22 ) @ ( bNF_Wellorder_ordIso @ C @ D ) )
       => ( ( bNF_Ca8970107618336181345der_on @ D @ ( field2 @ D @ R22 ) @ R22 )
         => ( ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ P22 ) @ P22 )
           => ( member @ ( product_prod @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( D > B ) @ ( D > B ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( C > A ) @ ( C > A ) ) ) @ ( set @ ( product_prod @ ( D > B ) @ ( D > B ) ) ) @ ( bNF_Cardinal_cexp @ A @ C @ P1 @ P22 ) @ ( bNF_Cardinal_cexp @ B @ D @ R1 @ R22 ) ) @ ( bNF_Wellorder_ordIso @ ( C > A ) @ ( D > B ) ) ) ) ) ) ) ).

% cexp_cong
thf(fact_3933_ordLeq__cexp2,axiom,
    ! [A: $tType,B: $tType,Q4: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) @ bNF_Cardinal_ctwo @ Q4 ) @ ( bNF_Wellorder_ordLeq @ $o @ A ) )
     => ( ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( B > A ) @ ( B > A ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ ( B > A ) @ ( B > A ) ) ) @ R4 @ ( bNF_Cardinal_cexp @ A @ B @ Q4 @ R4 ) ) @ ( bNF_Wellorder_ordLeq @ B @ ( B > A ) ) ) ) ) ).

% ordLeq_cexp2
thf(fact_3934_Cfinite__cexp__Cinfinite,axiom,
    ! [A: $tType,B: $tType,S: set @ ( product_prod @ A @ A ),T4: set @ ( product_prod @ B @ B )] :
      ( ( ( bNF_Cardinal_cfinite @ A @ S )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ S ) @ S ) )
     => ( ( ( bNF_Ca4139267488887388095finite @ B @ T4 )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ T4 ) @ T4 ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ ( B > A ) @ ( B > A ) ) ) @ ( set @ ( product_prod @ ( B > $o ) @ ( B > $o ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( B > A ) @ ( B > A ) ) ) @ ( set @ ( product_prod @ ( B > $o ) @ ( B > $o ) ) ) @ ( bNF_Cardinal_cexp @ A @ B @ S @ T4 ) @ ( bNF_Cardinal_cexp @ $o @ B @ bNF_Cardinal_ctwo @ T4 ) ) @ ( bNF_Wellorder_ordLeq @ ( B > A ) @ ( B > $o ) ) ) ) ) ).

% Cfinite_cexp_Cinfinite
thf(fact_3935_cinfinite__cexp,axiom,
    ! [A: $tType,B: $tType,Q4: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) @ bNF_Cardinal_ctwo @ Q4 ) @ ( bNF_Wellorder_ordLeq @ $o @ A ) )
     => ( ( ( bNF_Ca4139267488887388095finite @ B @ R4 )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 ) )
       => ( bNF_Ca4139267488887388095finite @ ( B > A ) @ ( bNF_Cardinal_cexp @ A @ B @ Q4 @ R4 ) ) ) ) ).

% cinfinite_cexp
thf(fact_3936_Cinfinite__cexp,axiom,
    ! [A: $tType,B: $tType,Q4: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) @ bNF_Cardinal_ctwo @ Q4 ) @ ( bNF_Wellorder_ordLeq @ $o @ A ) )
     => ( ( ( bNF_Ca4139267488887388095finite @ B @ R4 )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ R4 ) @ R4 ) )
       => ( ( bNF_Ca4139267488887388095finite @ ( B > A ) @ ( bNF_Cardinal_cexp @ A @ B @ Q4 @ R4 ) )
          & ( bNF_Ca8970107618336181345der_on @ ( B > A ) @ ( field2 @ ( B > A ) @ ( bNF_Cardinal_cexp @ A @ B @ Q4 @ R4 ) ) @ ( bNF_Cardinal_cexp @ A @ B @ Q4 @ R4 ) ) ) ) ) ).

% Cinfinite_cexp
thf(fact_3937_ctwo__Cnotzero,axiom,
    ( ~ ( member @ ( product_prod @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ $o @ $o ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ $o @ $o ) ) @ bNF_Cardinal_ctwo @ ( bNF_Cardinal_czero @ $o ) ) @ ( bNF_Wellorder_ordIso @ $o @ $o ) )
    & ( bNF_Ca8970107618336181345der_on @ $o @ ( field2 @ $o @ bNF_Cardinal_ctwo ) @ bNF_Cardinal_ctwo ) ) ).

% ctwo_Cnotzero
thf(fact_3938_cprod__csum__cexp,axiom,
    ! [B: $tType,A: $tType,R1: set @ ( product_prod @ A @ A ),R22: set @ ( product_prod @ B @ B )] : ( member @ ( product_prod @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( $o > ( sum_sum @ A @ B ) ) @ ( $o > ( sum_sum @ A @ B ) ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) @ ( set @ ( product_prod @ ( $o > ( sum_sum @ A @ B ) ) @ ( $o > ( sum_sum @ A @ B ) ) ) ) @ ( bNF_Cardinal_cprod @ A @ B @ R1 @ R22 ) @ ( bNF_Cardinal_cexp @ ( sum_sum @ A @ B ) @ $o @ ( bNF_Cardinal_csum @ A @ B @ R1 @ R22 ) @ bNF_Cardinal_ctwo ) ) @ ( bNF_Wellorder_ordLeq @ ( product_prod @ A @ B ) @ ( $o > ( sum_sum @ A @ B ) ) ) ) ).

% cprod_csum_cexp
thf(fact_3939_ordLess__ctwo__cexp,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( A > $o ) @ ( A > $o ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ ( A > $o ) @ ( A > $o ) ) ) @ R4 @ ( bNF_Cardinal_cexp @ $o @ A @ bNF_Cardinal_ctwo @ R4 ) ) @ ( bNF_We4044943003108391690rdLess @ A @ ( A > $o ) ) ) ) ).

% ordLess_ctwo_cexp
thf(fact_3940_ctwo__not__czero,axiom,
    ! [A: $tType] :
      ~ ( member @ ( product_prod @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) @ bNF_Cardinal_ctwo @ ( bNF_Cardinal_czero @ A ) ) @ ( bNF_Wellorder_ordIso @ $o @ A ) ) ).

% ctwo_not_czero
thf(fact_3941_ctwo__ordLess__Cinfinite,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) @ bNF_Cardinal_ctwo @ R4 ) @ ( bNF_We4044943003108391690rdLess @ $o @ A ) ) ) ).

% ctwo_ordLess_Cinfinite
thf(fact_3942_ctwo__ordLeq__Cinfinite,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ A @ A ) ) @ bNF_Cardinal_ctwo @ R4 ) @ ( bNF_Wellorder_ordLeq @ $o @ A ) ) ) ).

% ctwo_ordLeq_Cinfinite
thf(fact_3943_csum__Cfinite__cexp__Cinfinite,axiom,
    ! [B: $tType,A: $tType,C: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ B @ B ),T4: set @ ( product_prod @ C @ C )] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ( bNF_Cardinal_cfinite @ B @ S )
          & ( bNF_Ca8970107618336181345der_on @ B @ ( field2 @ B @ S ) @ S ) )
       => ( ( ( bNF_Ca4139267488887388095finite @ C @ T4 )
            & ( bNF_Ca8970107618336181345der_on @ C @ ( field2 @ C @ T4 ) @ T4 ) )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ ( C > ( sum_sum @ A @ B ) ) @ ( C > ( sum_sum @ A @ B ) ) ) ) @ ( set @ ( product_prod @ ( C > ( sum_sum @ A @ $o ) ) @ ( C > ( sum_sum @ A @ $o ) ) ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( C > ( sum_sum @ A @ B ) ) @ ( C > ( sum_sum @ A @ B ) ) ) ) @ ( set @ ( product_prod @ ( C > ( sum_sum @ A @ $o ) ) @ ( C > ( sum_sum @ A @ $o ) ) ) ) @ ( bNF_Cardinal_cexp @ ( sum_sum @ A @ B ) @ C @ ( bNF_Cardinal_csum @ A @ B @ R4 @ S ) @ T4 ) @ ( bNF_Cardinal_cexp @ ( sum_sum @ A @ $o ) @ C @ ( bNF_Cardinal_csum @ A @ $o @ R4 @ bNF_Cardinal_ctwo ) @ T4 ) ) @ ( bNF_Wellorder_ordLeq @ ( C > ( sum_sum @ A @ B ) ) @ ( C > ( sum_sum @ A @ $o ) ) ) ) ) ) ) ).

% csum_Cfinite_cexp_Cinfinite
thf(fact_3944_natLeq__ordLeq__cinfinite,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( ( bNF_Ca4139267488887388095finite @ A @ R4 )
        & ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ A @ A ) ) @ bNF_Ca8665028551170535155natLeq @ R4 ) @ ( bNF_Wellorder_ordLeq @ nat @ A ) ) ) ).

% natLeq_ordLeq_cinfinite
thf(fact_3945_infinite__iff__natLeq__ordLeq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     != ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ A @ A ) ) @ bNF_Ca8665028551170535155natLeq @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) ) @ ( bNF_Wellorder_ordLeq @ nat @ A ) ) ) ).

% infinite_iff_natLeq_ordLeq
thf(fact_3946_dir__image__ordIso,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),F: A > B] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( inj_on @ A @ B @ F @ ( field2 @ A @ R4 ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ ( bNF_We2720479622203943262_image @ A @ B @ R4 @ F ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ) ).

% dir_image_ordIso
thf(fact_3947_card__of__nat,axiom,
    member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bNF_Ca6860139660246222851ard_of @ nat @ ( top_top @ ( set @ nat ) ) ) @ bNF_Ca8665028551170535155natLeq ) @ ( bNF_Wellorder_ordIso @ nat @ nat ) ).

% card_of_nat
thf(fact_3948_ctwo__ordLess__natLeq,axiom,
    member @ ( product_prod @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ $o @ $o ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ bNF_Cardinal_ctwo @ bNF_Ca8665028551170535155natLeq ) @ ( bNF_We4044943003108391690rdLess @ $o @ nat ) ).

% ctwo_ordLess_natLeq
thf(fact_3949_dir__image__def,axiom,
    ! [A2: $tType,A: $tType] :
      ( ( bNF_We2720479622203943262_image @ A @ A2 )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),F2: A > A2] :
            ( collect @ ( product_prod @ A2 @ A2 )
            @ ^ [Uu: product_prod @ A2 @ A2] :
              ? [A5: A,B4: A] :
                ( ( Uu
                  = ( product_Pair @ A2 @ A2 @ ( F2 @ A5 ) @ ( F2 @ B4 ) ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R5 ) ) ) ) ) ).

% dir_image_def
thf(fact_3950_Restr__natLeq2,axiom,
    ! [N: nat] :
      ( ( inf_inf @ ( set @ ( product_prod @ nat @ nat ) ) @ bNF_Ca8665028551170535155natLeq
        @ ( product_Sigma @ nat @ nat @ ( order_underS @ nat @ bNF_Ca8665028551170535155natLeq @ N )
          @ ^ [Uu: nat] : ( order_underS @ nat @ bNF_Ca8665028551170535155natLeq @ N ) ) )
      = ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X3: nat,Y2: nat] :
              ( ( ord_less @ nat @ X3 @ N )
              & ( ord_less @ nat @ Y2 @ N )
              & ( ord_less_eq @ nat @ X3 @ Y2 ) ) ) ) ) ).

% Restr_natLeq2
thf(fact_3951_Restr__natLeq,axiom,
    ! [N: nat] :
      ( ( inf_inf @ ( set @ ( product_prod @ nat @ nat ) ) @ bNF_Ca8665028551170535155natLeq
        @ ( product_Sigma @ nat @ nat
          @ ( collect @ nat
            @ ^ [X3: nat] : ( ord_less @ nat @ X3 @ N ) )
          @ ^ [Uu: nat] :
              ( collect @ nat
              @ ^ [X3: nat] : ( ord_less @ nat @ X3 @ N ) ) ) )
      = ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X3: nat,Y2: nat] :
              ( ( ord_less @ nat @ X3 @ N )
              & ( ord_less @ nat @ Y2 @ N )
              & ( ord_less_eq @ nat @ X3 @ Y2 ) ) ) ) ) ).

% Restr_natLeq
thf(fact_3952_card__of__Field__natLeq,axiom,
    member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bNF_Ca6860139660246222851ard_of @ nat @ ( field2 @ nat @ bNF_Ca8665028551170535155natLeq ) ) @ bNF_Ca8665028551170535155natLeq ) @ ( bNF_Wellorder_ordIso @ nat @ nat ) ).

% card_of_Field_natLeq
thf(fact_3953_finite__iff__ordLess__natLeq,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A10: set @ A] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A10 ) @ bNF_Ca8665028551170535155natLeq ) @ ( bNF_We4044943003108391690rdLess @ A @ nat ) ) ) ) ).

% finite_iff_ordLess_natLeq
thf(fact_3954_dir__image,axiom,
    ! [B: $tType,A: $tType,F: A > B,R4: set @ ( product_prod @ A @ A )] :
      ( ! [X2: A,Y3: A] :
          ( ( ( F @ X2 )
            = ( F @ Y3 ) )
          = ( X2 = Y3 ) )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ ( bNF_We2720479622203943262_image @ A @ B @ R4 @ F ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ) ).

% dir_image
thf(fact_3955_subset__singleton__iff__Uniq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ? [A5: A] : ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert2 @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( uniq @ A
        @ ^ [X3: A] : ( member @ A @ X3 @ A4 ) ) ) ).

% subset_singleton_iff_Uniq
thf(fact_3956_Gcd__fin__def,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( bounde2362111253966948842tice_F @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ) ).

% Gcd_fin_def
thf(fact_3957_dom__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y: option @ B,F: A > ( option @ B ),X: A] :
      ( ( ( Y
          = ( none @ B ) )
       => ( ( dom @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F @ X @ Y ) )
          = ( minus_minus @ ( set @ A ) @ ( dom @ A @ B @ F ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
      & ( ( Y
         != ( none @ B ) )
       => ( ( dom @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F @ X @ Y ) )
          = ( insert2 @ A @ X @ ( dom @ A @ B @ F ) ) ) ) ) ).

% dom_fun_upd
thf(fact_3958_ex__is__arg__min__if__finite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X_1: A] :
                ( lattic501386751177426532rg_min @ A @ B @ F
                @ ^ [X3: A] : ( member @ A @ X3 @ S2 )
                @ X_1 ) ) ) ) ).

% ex_is_arg_min_if_finite
thf(fact_3959_dom__eq__empty__conv,axiom,
    ! [B: $tType,A: $tType,F: A > ( option @ B )] :
      ( ( ( dom @ A @ B @ F )
        = ( bot_bot @ ( set @ A ) ) )
      = ( F
        = ( ^ [X3: A] : ( none @ B ) ) ) ) ).

% dom_eq_empty_conv
thf(fact_3960_dom__restrict,axiom,
    ! [B: $tType,A: $tType,M4: A > ( option @ B ),A4: set @ A] :
      ( ( dom @ A @ B @ ( restrict_map @ A @ B @ M4 @ A4 ) )
      = ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M4 ) @ A4 ) ) ).

% dom_restrict
thf(fact_3961_dom__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dom @ A @ B
        @ ^ [X3: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% dom_empty
thf(fact_3962_dom__override__on,axiom,
    ! [B: $tType,A: $tType,F: A > ( option @ B ),G: A > ( option @ B ),A4: set @ A] :
      ( ( dom @ A @ B @ ( override_on @ A @ ( option @ B ) @ F @ G @ A4 ) )
      = ( sup_sup @ ( set @ A )
        @ ( minus_minus @ ( set @ A ) @ ( dom @ A @ B @ F )
          @ ( collect @ A
            @ ^ [A5: A] : ( member @ A @ A5 @ ( minus_minus @ ( set @ A ) @ A4 @ ( dom @ A @ B @ G ) ) ) ) )
        @ ( collect @ A
          @ ^ [A5: A] : ( member @ A @ A5 @ ( inf_inf @ ( set @ A ) @ A4 @ ( dom @ A @ B @ G ) ) ) ) ) ) ).

% dom_override_on
thf(fact_3963_dom__if,axiom,
    ! [B: $tType,A: $tType,P: A > $o,F: A > ( option @ B ),G: A > ( option @ B )] :
      ( ( dom @ A @ B
        @ ^ [X3: A] : ( if @ ( option @ B ) @ ( P @ X3 ) @ ( F @ X3 ) @ ( G @ X3 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ F ) @ ( collect @ A @ P ) )
        @ ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ G )
          @ ( collect @ A
            @ ^ [X3: A] :
                ~ ( P @ X3 ) ) ) ) ) ).

% dom_if
thf(fact_3964_restrict__map__eq_I1_J,axiom,
    ! [A: $tType,B: $tType,M4: B > ( option @ A ),A4: set @ B,K: B] :
      ( ( ( restrict_map @ B @ A @ M4 @ A4 @ K )
        = ( none @ A ) )
      = ( ~ ( member @ B @ K @ ( inf_inf @ ( set @ B ) @ ( dom @ B @ A @ M4 ) @ A4 ) ) ) ) ).

% restrict_map_eq(1)
thf(fact_3965_inj__on__map__the,axiom,
    ! [B: $tType,A: $tType,D4: set @ A,M4: A > ( option @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ D4 @ ( dom @ A @ B @ M4 ) )
     => ( ( inj_on @ A @ ( option @ B ) @ M4 @ D4 )
       => ( inj_on @ A @ B @ ( comp @ ( option @ B ) @ B @ A @ ( the2 @ B ) @ M4 ) @ D4 ) ) ) ).

% inj_on_map_the
thf(fact_3966_graph__eq__to__snd__dom,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M3: A > ( option @ B )] :
            ( image2 @ A @ ( product_prod @ A @ B )
            @ ^ [X3: A] : ( product_Pair @ A @ B @ X3 @ ( the2 @ B @ ( M3 @ X3 ) ) )
            @ ( dom @ A @ B @ M3 ) ) ) ) ).

% graph_eq_to_snd_dom
thf(fact_3967_dom__eq__singleton__conv,axiom,
    ! [A: $tType,B: $tType,F: A > ( option @ B ),X: A] :
      ( ( ( dom @ A @ B @ F )
        = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ? [V3: B] :
            ( F
            = ( fun_upd @ A @ ( option @ B )
              @ ^ [X3: A] : ( none @ B )
              @ X
              @ ( some @ B @ V3 ) ) ) ) ) ).

% dom_eq_singleton_conv
thf(fact_3968_ran__map__upd__Some,axiom,
    ! [B: $tType,A: $tType,M4: B > ( option @ A ),X: B,Y: A,Z2: A] :
      ( ( ( M4 @ X )
        = ( some @ A @ Y ) )
     => ( ( inj_on @ B @ ( option @ A ) @ M4 @ ( dom @ B @ A @ M4 ) )
       => ( ~ ( member @ A @ Z2 @ ( ran @ B @ A @ M4 ) )
         => ( ( ran @ B @ A @ ( fun_upd @ B @ ( option @ A ) @ M4 @ X @ ( some @ A @ Z2 ) ) )
            = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( ran @ B @ A @ M4 ) @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert2 @ A @ Z2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% ran_map_upd_Some
thf(fact_3969_bounded__quasi__semilattice__set_Oremove,axiom,
    ! [A: $tType,F: A > A > A,Top: A,Bot: A,Normalize: A > A,A3: A,A4: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F @ Top @ Bot @ Normalize )
     => ( ( member @ A @ A3 @ A4 )
       => ( ( bounde2362111253966948842tice_F @ A @ F @ Top @ Bot @ A4 )
          = ( F @ A3 @ ( bounde2362111253966948842tice_F @ A @ F @ Top @ Bot @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% bounded_quasi_semilattice_set.remove
thf(fact_3970_bounded__quasi__semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F: A > A > A,Top: A,Bot: A,Normalize: A > A,A3: A,A4: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F @ Top @ Bot @ Normalize )
     => ( ( bounde2362111253966948842tice_F @ A @ F @ Top @ Bot @ ( insert2 @ A @ A3 @ A4 ) )
        = ( F @ A3 @ ( bounde2362111253966948842tice_F @ A @ F @ Top @ Bot @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% bounded_quasi_semilattice_set.insert_remove
thf(fact_3971_graph__map__add,axiom,
    ! [B: $tType,A: $tType,M12: A > ( option @ B ),M22: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M12 ) @ ( dom @ A @ B @ M22 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( graph @ A @ B @ ( map_add @ A @ B @ M12 @ M22 ) )
        = ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ ( graph @ A @ B @ M12 ) @ ( graph @ A @ B @ M22 ) ) ) ) ).

% graph_map_add
thf(fact_3972_ran__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ran @ B @ A
        @ ^ [X3: B] : ( none @ A ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% ran_empty
thf(fact_3973_ran__add,axiom,
    ! [B: $tType,A: $tType,F: A > ( option @ B ),G: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ F ) @ ( dom @ A @ B @ G ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( ran @ A @ B @ ( map_add @ A @ B @ F @ G ) )
        = ( sup_sup @ ( set @ B ) @ ( ran @ A @ B @ F ) @ ( ran @ A @ B @ G ) ) ) ) ).

% ran_add
thf(fact_3974_ran__map__add,axiom,
    ! [B: $tType,A: $tType,M12: A > ( option @ B ),M22: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M12 ) @ ( dom @ A @ B @ M22 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( ran @ A @ B @ ( map_add @ A @ B @ M12 @ M22 ) )
        = ( sup_sup @ ( set @ B ) @ ( ran @ A @ B @ M12 ) @ ( ran @ A @ B @ M22 ) ) ) ) ).

% ran_map_add
thf(fact_3975_map__add__left__comm,axiom,
    ! [B: $tType,A: $tType,A4: A > ( option @ B ),B3: A > ( option @ B ),C3: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ A4 ) @ ( dom @ A @ B @ B3 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( map_add @ A @ B @ A4 @ ( map_add @ A @ B @ B3 @ C3 ) )
        = ( map_add @ A @ B @ B3 @ ( map_add @ A @ B @ A4 @ C3 ) ) ) ) ).

% map_add_left_comm
thf(fact_3976_map__add__distinct__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( preorder @ B )
     => ! [M4: A > ( option @ B ),M6: A > ( option @ B ),N: A > ( option @ B ),N2: A > ( option @ B )] :
          ( ( ord_less_eq @ ( A > ( option @ B ) ) @ M4 @ M6 )
         => ( ( ord_less_eq @ ( A > ( option @ B ) ) @ N @ N2 )
           => ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M6 ) @ ( dom @ A @ B @ N2 ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ ( A > ( option @ B ) ) @ ( map_add @ A @ B @ M4 @ N ) @ ( map_add @ A @ B @ M6 @ N2 ) ) ) ) ) ) ).

% map_add_distinct_le
thf(fact_3977_map__add__comm,axiom,
    ! [B: $tType,A: $tType,M12: A > ( option @ B ),M22: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M12 ) @ ( dom @ A @ B @ M22 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( map_add @ A @ B @ M12 @ M22 )
        = ( map_add @ A @ B @ M22 @ M12 ) ) ) ).

% map_add_comm
thf(fact_3978_bounded__quasi__semilattice__set_Oempty,axiom,
    ! [A: $tType,F: A > A > A,Top: A,Bot: A,Normalize: A > A] :
      ( ( bounde6485984586167503788ce_set @ A @ F @ Top @ Bot @ Normalize )
     => ( ( bounde2362111253966948842tice_F @ A @ F @ Top @ Bot @ ( bot_bot @ ( set @ A ) ) )
        = Top ) ) ).

% bounded_quasi_semilattice_set.empty
thf(fact_3979_ran__is__image,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ran @ B @ A )
      = ( ^ [M7: B > ( option @ A )] : ( image2 @ B @ A @ ( comp @ ( option @ A ) @ A @ B @ ( the2 @ A ) @ M7 ) @ ( dom @ B @ A @ M7 ) ) ) ) ).

% ran_is_image
thf(fact_3980_relImage__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( bNF_Gr4221423524335903396lImage @ B @ A )
      = ( ^ [R2: set @ ( product_prod @ B @ B ),F2: B > A] :
            ( collect @ ( product_prod @ A @ A )
            @ ^ [Uu: product_prod @ A @ A] :
              ? [A12: B,A23: B] :
                ( ( Uu
                  = ( product_Pair @ A @ A @ ( F2 @ A12 ) @ ( F2 @ A23 ) ) )
                & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ A12 @ A23 ) @ R2 ) ) ) ) ) ).

% relImage_def
thf(fact_3981_Sup__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( lattic4895041142388067077er_set @ A @ ( sup_sup @ A )
        @ ^ [X3: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X3 )
        @ ^ [X3: A,Y2: A] : ( ord_less @ A @ Y2 @ X3 ) ) ) ).

% Sup_fin.semilattice_order_set_axioms
thf(fact_3982_type__copy__vimage2p__Grp__Abs,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Rep: A > B,Abs: B > A,G: D > C,P: C > $o,H2: C > A] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( bNF_vimage2p @ D @ C @ B @ A @ $o @ G @ Abs @ ( bNF_Grp @ C @ A @ ( collect @ C @ P ) @ H2 ) )
        = ( bNF_Grp @ D @ B
          @ ( collect @ D
            @ ^ [X3: D] : ( P @ ( G @ X3 ) ) )
          @ ( comp @ C @ B @ D @ ( comp @ A @ B @ C @ Rep @ H2 ) @ G ) ) ) ) ).

% type_copy_vimage2p_Grp_Abs
thf(fact_3983_type__copy__vimage2p__Grp__Rep,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,Rep: A > B,Abs: B > A,F: C > D,P: D > $o,H2: D > B] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( bNF_vimage2p @ C @ D @ A @ B @ $o @ F @ Rep @ ( bNF_Grp @ D @ B @ ( collect @ D @ P ) @ H2 ) )
        = ( bNF_Grp @ C @ A
          @ ( collect @ C
            @ ^ [X3: C] : ( P @ ( F @ X3 ) ) )
          @ ( comp @ D @ A @ C @ ( comp @ B @ A @ D @ Abs @ H2 ) @ F ) ) ) ) ).

% type_copy_vimage2p_Grp_Rep
thf(fact_3984_fun_Orel__Grp,axiom,
    ! [D: $tType,B: $tType,A: $tType,A4: set @ A,F: A > B] :
      ( ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y4: D,Z5: D] : ( Y4 = Z5 )
        @ ( bNF_Grp @ A @ B @ A4 @ F ) )
      = ( bNF_Grp @ ( D > A ) @ ( D > B )
        @ ( collect @ ( D > A )
          @ ^ [X3: D > A] : ( ord_less_eq @ ( set @ A ) @ ( image2 @ D @ A @ X3 @ ( top_top @ ( set @ D ) ) ) @ A4 ) )
        @ ( comp @ A @ B @ D @ F ) ) ) ).

% fun.rel_Grp
thf(fact_3985_Collect__case__prod__Grp__eqD,axiom,
    ! [B: $tType,A: $tType,Z2: product_prod @ A @ B,A4: set @ A,F: A > B] :
      ( ( member @ ( product_prod @ A @ B ) @ Z2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( bNF_Grp @ A @ B @ A4 @ F ) ) ) )
     => ( ( comp @ A @ B @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) @ Z2 )
        = ( product_snd @ A @ B @ Z2 ) ) ) ).

% Collect_case_prod_Grp_eqD
thf(fact_3986_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( lattic4895041142388067077er_set @ A @ ( inf_inf @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% Inf_fin.semilattice_order_set_axioms
thf(fact_3987_mono__cINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F: A > B,A4: C > A,I4: set @ C] :
          ( ( order_mono @ A @ B @ F )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ C @ A @ A4 @ I4 ) )
           => ( ( I4
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B @ ( F @ ( complete_Inf_Inf @ A @ ( image2 @ C @ A @ A4 @ I4 ) ) )
                @ ( complete_Inf_Inf @ B
                  @ ( image2 @ C @ B
                    @ ^ [X3: C] : ( F @ ( A4 @ X3 ) )
                    @ I4 ) ) ) ) ) ) ) ).

% mono_cINF
thf(fact_3988_mono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F )
         => ( ( condit1013018076250108175_below @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( F @ ( complete_Inf_Inf @ A @ A4 ) ) @ ( complete_Inf_Inf @ B @ ( image2 @ A @ B @ F @ A4 ) ) ) ) ) ) ) ).

% mono_cInf
thf(fact_3989_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F: A > B,A4: C > A,I4: set @ C] :
          ( ( order_mono @ A @ B @ F )
         => ( ( condit941137186595557371_above @ A @ ( image2 @ C @ A @ A4 @ I4 ) )
           => ( ( I4
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B
                @ ( complete_Sup_Sup @ B
                  @ ( image2 @ C @ B
                    @ ^ [X3: C] : ( F @ ( A4 @ X3 ) )
                    @ I4 ) )
                @ ( F @ ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ A4 @ I4 ) ) ) ) ) ) ) ) ).

% mono_cSUP
thf(fact_3990_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F )
         => ( ( condit941137186595557371_above @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image2 @ A @ B @ F @ A4 ) ) @ ( F @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ) ) ).

% mono_cSup
thf(fact_3991_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) ).

% monoD
thf(fact_3992_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) ).

% monoE
thf(fact_3993_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F: A > B] :
          ( ! [X2: A,Y3: A] :
              ( ( ord_less_eq @ A @ X2 @ Y3 )
             => ( ord_less_eq @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) )
         => ( order_mono @ A @ B @ F ) ) ) ).

% monoI
thf(fact_3994_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F2: A > B] :
            ! [X3: A,Y2: A] :
              ( ( ord_less_eq @ A @ X3 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) ) ) ).

% mono_def
thf(fact_3995_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F )
         => ( ( ord_less @ B @ ( F @ X ) @ ( F @ Y ) )
           => ( ord_less @ A @ X @ Y ) ) ) ) ).

% mono_strict_invE
thf(fact_3996_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A3 ) ) ) ).

% mono_add
thf(fact_3997_min__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F: A > B,M4: A,N: A] :
          ( ( order_mono @ A @ B @ F )
         => ( ( ord_min @ B @ ( F @ M4 ) @ ( F @ N ) )
            = ( F @ ( ord_min @ A @ M4 @ N ) ) ) ) ) ).

% min_of_mono
thf(fact_3998_mono__Int,axiom,
    ! [B: $tType,A: $tType,F: ( set @ A ) > ( set @ B ),A4: set @ A,B3: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F )
     => ( ord_less_eq @ ( set @ B ) @ ( F @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) @ ( inf_inf @ ( set @ B ) @ ( F @ A4 ) @ ( F @ B3 ) ) ) ) ).

% mono_Int
thf(fact_3999_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F )
         => ( ( ord_less @ B @ ( F @ X ) @ ( F @ Y ) )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mono_invE
thf(fact_4000_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F: A > B,A4: A,B3: A] :
          ( ( order_mono @ A @ B @ F )
         => ( ord_less_eq @ B @ ( F @ ( inf_inf @ A @ A4 @ B3 ) ) @ ( inf_inf @ B @ ( F @ A4 ) @ ( F @ B3 ) ) ) ) ) ).

% mono_inf
thf(fact_4001_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F: A > B,A4: A,B3: A] :
          ( ( order_mono @ A @ B @ F )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F @ A4 ) @ ( F @ B3 ) ) @ ( F @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) ) ).

% mono_sup
thf(fact_4002_Rings_Omono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A3 ) ) ) ) ).

% Rings.mono_mult
thf(fact_4003_mono__Max__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F )
         => ( ( finite_finite @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F @ ( lattic643756798349783984er_Max @ A @ A4 ) )
                = ( lattic643756798349783984er_Max @ B @ ( image2 @ A @ B @ F @ A4 ) ) ) ) ) ) ) ).

% mono_Max_commute
thf(fact_4004_mono__Min__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F )
         => ( ( finite_finite @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F @ ( lattic643756798350308766er_Min @ A @ A4 ) )
                = ( lattic643756798350308766er_Min @ B @ ( image2 @ A @ B @ F @ A4 ) ) ) ) ) ) ) ).

% mono_Min_commute
thf(fact_4005_finite_Omono,axiom,
    ! [A: $tType] :
      ( order_mono @ ( ( set @ A ) > $o ) @ ( ( set @ A ) > $o )
      @ ^ [P6: ( set @ A ) > $o,X3: set @ A] :
          ( ( X3
            = ( bot_bot @ ( set @ A ) ) )
          | ? [A10: set @ A,A5: A] :
              ( ( X3
                = ( insert2 @ A @ A5 @ A10 ) )
              & ( P6 @ A10 ) ) ) ) ).

% finite.mono
thf(fact_4006_lfp__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: A > A,P: A] :
          ( ( order_mono @ A @ A @ F )
         => ( ( ord_less_eq @ A @ ( F @ ( inf_inf @ A @ ( complete_lattice_lfp @ A @ F ) @ P ) ) @ P )
           => ( ord_less_eq @ A @ ( complete_lattice_lfp @ A @ F ) @ P ) ) ) ) ).

% lfp_induct
thf(fact_4007_def__lfp__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: A,F: A > A,P: A] :
          ( ( A4
            = ( complete_lattice_lfp @ A @ F ) )
         => ( ( order_mono @ A @ A @ F )
           => ( ( ord_less_eq @ A @ ( F @ ( inf_inf @ A @ A4 @ P ) ) @ P )
             => ( ord_less_eq @ A @ A4 @ P ) ) ) ) ) ).

% def_lfp_induct
thf(fact_4008_cInf__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S2 )
           => ( ( complete_Inf_Inf @ A @ S2 )
              = ( complete_Sup_Sup @ A
                @ ( collect @ A
                  @ ^ [X3: A] :
                    ! [Y2: A] :
                      ( ( member @ A @ Y2 @ S2 )
                     => ( ord_less_eq @ A @ X3 @ Y2 ) ) ) ) ) ) ) ) ).

% cInf_cSup
thf(fact_4009_cSup__cInf,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S2 )
           => ( ( complete_Sup_Sup @ A @ S2 )
              = ( complete_Inf_Inf @ A
                @ ( collect @ A
                  @ ^ [X3: A] :
                    ! [Y2: A] :
                      ( ( member @ A @ Y2 @ S2 )
                     => ( ord_less_eq @ A @ Y2 @ X3 ) ) ) ) ) ) ) ) ).

% cSup_cInf
thf(fact_4010_ball__empty,axiom,
    ! [A: $tType,P: A > $o,X6: A] :
      ( ( member @ A @ X6 @ ( bot_bot @ ( set @ A ) ) )
     => ( P @ X6 ) ) ).

% ball_empty
thf(fact_4011_def__lfp__induct__set,axiom,
    ! [A: $tType,A4: set @ A,F: ( set @ A ) > ( set @ A ),A3: A,P: A > $o] :
      ( ( A4
        = ( complete_lattice_lfp @ ( set @ A ) @ F ) )
     => ( ( order_mono @ ( set @ A ) @ ( set @ A ) @ F )
       => ( ( member @ A @ A3 @ A4 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( F @ ( inf_inf @ ( set @ A ) @ A4 @ ( collect @ A @ P ) ) ) )
               => ( P @ X2 ) )
           => ( P @ A3 ) ) ) ) ) ).

% def_lfp_induct_set
thf(fact_4012_lfp__induct__set,axiom,
    ! [A: $tType,A3: A,F: ( set @ A ) > ( set @ A ),P: A > $o] :
      ( ( member @ A @ A3 @ ( complete_lattice_lfp @ ( set @ A ) @ F ) )
     => ( ( order_mono @ ( set @ A ) @ ( set @ A ) @ F )
       => ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( F @ ( inf_inf @ ( set @ A ) @ ( complete_lattice_lfp @ ( set @ A ) @ F ) @ ( collect @ A @ P ) ) ) )
             => ( P @ X2 ) )
         => ( P @ A3 ) ) ) ) ).

% lfp_induct_set
thf(fact_4013_mono__compose,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ C ) )
     => ! [Q: A > B > C,F: D > B] :
          ( ( order_mono @ A @ ( B > C ) @ Q )
         => ( order_mono @ A @ ( D > C )
            @ ^ [I2: A,X3: D] : ( Q @ I2 @ ( F @ X3 ) ) ) ) ) ).

% mono_compose
thf(fact_4014_Ball__image__comp,axiom,
    ! [A: $tType,B: $tType,F: B > A,A4: set @ B,G: A > $o] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( image2 @ B @ A @ F @ A4 ) )
           => ( G @ X3 ) ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ A4 )
           => ( comp @ A @ $o @ B @ G @ F @ X3 ) ) ) ) ).

% Ball_image_comp
thf(fact_4015_Ball__comp__iff,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: B > ( set @ C ),F: C > $o,G: A > B] :
      ( ( comp @ B @ $o @ A
        @ ^ [X3: B] :
          ! [Y2: C] :
            ( ( member @ C @ Y2 @ ( A4 @ X3 ) )
           => ( F @ Y2 ) )
        @ G )
      = ( ^ [X3: A] :
          ! [Y2: C] :
            ( ( member @ C @ Y2 @ ( comp @ B @ ( set @ C ) @ A @ A4 @ G @ X3 ) )
           => ( F @ Y2 ) ) ) ) ).

% Ball_comp_iff
thf(fact_4016_Chains__def,axiom,
    ! [A: $tType] :
      ( ( chains @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( set @ A )
            @ ^ [C8: set @ A] :
              ! [X3: A] :
                ( ( member @ A @ X3 @ C8 )
               => ! [Y2: A] :
                    ( ( member @ A @ Y2 @ C8 )
                   => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 )
                      | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R5 ) ) ) ) ) ) ) ).

% Chains_def
thf(fact_4017_refl__on__def_H,axiom,
    ! [A: $tType] :
      ( ( refl_on @ A )
      = ( ^ [A10: set @ A,R5: set @ ( product_prod @ A @ A )] :
            ( ! [X3: product_prod @ A @ A] :
                ( ( member @ ( product_prod @ A @ A ) @ X3 @ R5 )
               => ( product_case_prod @ A @ A @ $o
                  @ ^ [Y2: A,Z4: A] :
                      ( ( member @ A @ Y2 @ A10 )
                      & ( member @ A @ Z4 @ A10 ) )
                  @ X3 ) )
            & ! [X3: A] :
                ( ( member @ A @ X3 @ A10 )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R5 ) ) ) ) ) ).

% refl_on_def'
thf(fact_4018_lfp__induct2,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,F: ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ ( complete_lattice_lfp @ ( set @ ( product_prod @ A @ B ) ) @ F ) )
     => ( ( order_mono @ ( set @ ( product_prod @ A @ B ) ) @ ( set @ ( product_prod @ A @ B ) ) @ F )
       => ( ! [A8: A,B6: B] :
              ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A8 @ B6 ) @ ( F @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( complete_lattice_lfp @ ( set @ ( product_prod @ A @ B ) ) @ F ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) ) ) )
             => ( P @ A8 @ B6 ) )
         => ( P @ A3 @ B2 ) ) ) ) ).

% lfp_induct2
thf(fact_4019_UnderS__def,axiom,
    ! [A: $tType] :
      ( ( order_UnderS @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),A10: set @ A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( member @ A @ B4 @ ( field2 @ A @ R5 ) )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A10 )
                   => ( ( B4 != X3 )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ X3 ) @ R5 ) ) ) ) ) ) ) ).

% UnderS_def
thf(fact_4020_Under__def,axiom,
    ! [A: $tType] :
      ( ( order_Under @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),A10: set @ A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( member @ A @ B4 @ ( field2 @ A @ R5 ) )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A10 )
                   => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ X3 ) @ R5 ) ) ) ) ) ) ).

% Under_def
thf(fact_4021_Above__def,axiom,
    ! [A: $tType] :
      ( ( order_Above @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),A10: set @ A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( member @ A @ B4 @ ( field2 @ A @ R5 ) )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A10 )
                   => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ B4 ) @ R5 ) ) ) ) ) ) ).

% Above_def
thf(fact_4022_min__ext__def,axiom,
    ! [A: $tType] :
      ( ( min_ext @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
            @ ^ [Uu: product_prod @ ( set @ A ) @ ( set @ A )] :
              ? [X8: set @ A,Y10: set @ A] :
                ( ( Uu
                  = ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X8 @ Y10 ) )
                & ( X8
                 != ( bot_bot @ ( set @ A ) ) )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ Y10 )
                   => ? [Y2: A] :
                        ( ( member @ A @ Y2 @ X8 )
                        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R5 ) ) ) ) ) ) ) ).

% min_ext_def
thf(fact_4023_bex__empty,axiom,
    ! [A: $tType,P: A > $o] :
      ~ ? [X6: A] :
          ( ( member @ A @ X6 @ ( bot_bot @ ( set @ A ) ) )
          & ( P @ X6 ) ) ).

% bex_empty
thf(fact_4024_conj__comp__iff,axiom,
    ! [B: $tType,A: $tType,P: B > $o,Q: B > $o,G: A > B] :
      ( ( comp @ B @ $o @ A
        @ ^ [X3: B] :
            ( ( P @ X3 )
            & ( Q @ X3 ) )
        @ G )
      = ( ^ [X3: A] :
            ( ( comp @ B @ $o @ A @ P @ G @ X3 )
            & ( comp @ B @ $o @ A @ Q @ G @ X3 ) ) ) ) ).

% conj_comp_iff
thf(fact_4025_Image__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( image @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B ),S6: set @ A] :
            ( collect @ B
            @ ^ [Y2: B] :
              ? [X3: A] :
                ( ( member @ A @ X3 @ S6 )
                & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R5 ) ) ) ) ) ).

% Image_def
thf(fact_4026_max__extp_Ocases,axiom,
    ! [A: $tType,R: A > A > $o,A1: set @ A,A22: set @ A] :
      ( ( max_extp @ A @ R @ A1 @ A22 )
     => ~ ( ( finite_finite @ A @ A1 )
         => ( ( finite_finite @ A @ A22 )
           => ( ( A22
               != ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) )
             => ~ ! [X6: A] :
                    ( ( member @ A @ X6 @ A1 )
                   => ? [Xa3: A] :
                        ( ( member @ A @ Xa3 @ A22 )
                        & ( R @ X6 @ Xa3 ) ) ) ) ) ) ) ).

% max_extp.cases
thf(fact_4027_max__extp_Osimps,axiom,
    ! [A: $tType] :
      ( ( max_extp @ A )
      = ( ^ [R2: A > A > $o,A12: set @ A,A23: set @ A] :
            ( ( finite_finite @ A @ A12 )
            & ( finite_finite @ A @ A23 )
            & ( A23
             != ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) )
            & ! [X3: A] :
                ( ( member @ A @ X3 @ A12 )
               => ? [Y2: A] :
                    ( ( member @ A @ Y2 @ A23 )
                    & ( R2 @ X3 @ Y2 ) ) ) ) ) ) ).

% max_extp.simps
thf(fact_4028_max__extp_Omax__extI,axiom,
    ! [A: $tType,X5: set @ A,Y6: set @ A,R: A > A > $o] :
      ( ( finite_finite @ A @ X5 )
     => ( ( finite_finite @ A @ Y6 )
       => ( ( Y6
           != ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ X5 )
               => ? [Xa2: A] :
                    ( ( member @ A @ Xa2 @ Y6 )
                    & ( R @ X2 @ Xa2 ) ) )
           => ( max_extp @ A @ R @ X5 @ Y6 ) ) ) ) ) ).

% max_extp.max_extI
thf(fact_4029_max__ext__eq,axiom,
    ! [A: $tType] :
      ( ( max_ext @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
            @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
              @ ^ [X8: set @ A,Y10: set @ A] :
                  ( ( finite_finite @ A @ X8 )
                  & ( finite_finite @ A @ Y10 )
                  & ( Y10
                   != ( bot_bot @ ( set @ A ) ) )
                  & ! [X3: A] :
                      ( ( member @ A @ X3 @ X8 )
                     => ? [Y2: A] :
                          ( ( member @ A @ Y2 @ Y10 )
                          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R2 ) ) ) ) ) ) ) ) ).

% max_ext_eq
thf(fact_4030_AboveS__def,axiom,
    ! [A: $tType] :
      ( ( order_AboveS @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),A10: set @ A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( member @ A @ B4 @ ( field2 @ A @ R5 ) )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A10 )
                   => ( ( B4 != X3 )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ B4 ) @ R5 ) ) ) ) ) ) ) ).

% AboveS_def
thf(fact_4031_flip__pred,axiom,
    ! [A: $tType,B: $tType,A4: set @ ( product_prod @ A @ B ),R: B > A > $o] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A4 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( conversep @ B @ A @ R ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) )
        @ ( image2 @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A )
          @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
            @ ^ [X3: A,Y2: B] : ( product_Pair @ B @ A @ Y2 @ X3 ) )
          @ A4 )
        @ ( collect @ ( product_prod @ B @ A ) @ ( product_case_prod @ B @ A @ $o @ R ) ) ) ) ).

% flip_pred
thf(fact_4032_acyclic__insert,axiom,
    ! [A: $tType,Y: A,X: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( transitive_acyclic @ A @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X ) @ R4 ) )
      = ( ( transitive_acyclic @ A @ R4 )
        & ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ).

% acyclic_insert
thf(fact_4033_acyclic__empty,axiom,
    ! [A: $tType] : ( transitive_acyclic @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% acyclic_empty
thf(fact_4034_converse__meet,axiom,
    ! [A: $tType,B: $tType,R4: B > A > $o,S: B > A > $o] :
      ( ( conversep @ B @ A @ ( inf_inf @ ( B > A > $o ) @ R4 @ S ) )
      = ( inf_inf @ ( A > B > $o ) @ ( conversep @ B @ A @ R4 ) @ ( conversep @ B @ A @ S ) ) ) ).

% converse_meet
thf(fact_4035_acyclicI__order,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [R4: set @ ( product_prod @ B @ B ),F: B > A] :
          ( ! [A8: B,B6: B] :
              ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ A8 @ B6 ) @ R4 )
             => ( ord_less @ A @ ( F @ B6 ) @ ( F @ A8 ) ) )
         => ( transitive_acyclic @ B @ R4 ) ) ) ).

% acyclicI_order
thf(fact_4036_acyclicI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ! [X2: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ ( transitive_trancl @ A @ R4 ) )
     => ( transitive_acyclic @ A @ R4 ) ) ).

% acyclicI
thf(fact_4037_acyclic__def,axiom,
    ! [A: $tType] :
      ( ( transitive_acyclic @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [X3: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ ( transitive_trancl @ A @ R5 ) ) ) ) ).

% acyclic_def
thf(fact_4038_cyclicE,axiom,
    ! [A: $tType,G: set @ ( product_prod @ A @ A )] :
      ( ~ ( transitive_acyclic @ A @ G )
     => ~ ! [X2: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ ( transitive_trancl @ A @ G ) ) ) ).

% cyclicE
thf(fact_4039_AboveS__disjoint,axiom,
    ! [A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( order_AboveS @ A @ R4 @ A4 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% AboveS_disjoint
thf(fact_4040_Least__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_Least @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X3: A] :
                  ( ( P3 @ X3 )
                  & ! [Y2: A] :
                      ( ( P3 @ Y2 )
                     => ( ord_less_eq @ A @ X3 @ Y2 ) ) ) ) ) ) ) ).

% Least_def
thf(fact_4041_acyclic__insert__cyclic,axiom,
    ! [A: $tType,G: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ( transitive_acyclic @ A @ G )
     => ( ~ ( transitive_acyclic @ A @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ G ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X ) @ ( transitive_rtrancl @ A @ G ) ) ) ) ).

% acyclic_insert_cyclic
thf(fact_4042_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X3: A] :
                  ( ( P3 @ X3 )
                  & ! [Y2: A] :
                      ( ( P3 @ Y2 )
                     => ( ord_less_eq @ A @ Y2 @ X3 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_4043_wo__rel_Osuc__greater,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ A,B2: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
       => ( ( ( order_AboveS @ A @ R4 @ B3 )
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ A @ B2 @ B3 )
           => ( ( ( bNF_Wellorder_wo_suc @ A @ R4 @ B3 )
               != B2 )
              & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ ( bNF_Wellorder_wo_suc @ A @ R4 @ B3 ) ) @ R4 ) ) ) ) ) ) ).

% wo_rel.suc_greater
thf(fact_4044_wo__rel_Osuc__ofilter__in,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A,B2: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A4 )
       => ( ( ( order_AboveS @ A @ R4 @ A4 )
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ ( bNF_Wellorder_wo_suc @ A @ R4 @ A4 ) ) @ R4 )
           => ( ( B2
               != ( bNF_Wellorder_wo_suc @ A @ R4 @ A4 ) )
             => ( member @ A @ B2 @ A4 ) ) ) ) ) ) ).

% wo_rel.suc_ofilter_in
thf(fact_4045_wo__rel_Osuc__AboveS,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
       => ( ( ( order_AboveS @ A @ R4 @ B3 )
           != ( bot_bot @ ( set @ A ) ) )
         => ( member @ A @ ( bNF_Wellorder_wo_suc @ A @ R4 @ B3 ) @ ( order_AboveS @ A @ R4 @ B3 ) ) ) ) ) ).

% wo_rel.suc_AboveS
thf(fact_4046_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ! [X2: A] :
                  ( ( P @ X2 )
                 => ( ! [Y5: A] :
                        ( ( P @ Y5 )
                       => ( ord_less_eq @ A @ Y5 @ X2 ) )
                   => ( Q @ X2 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_4047_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ( order_Greatest @ A @ P )
              = X ) ) ) ) ).

% Greatest_equality
thf(fact_4048_wo__rel_Osuc__least__AboveS,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B3: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( member @ A @ A3 @ ( order_AboveS @ A @ R4 @ B3 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( bNF_Wellorder_wo_suc @ A @ R4 @ B3 ) @ A3 ) @ R4 ) ) ) ).

% wo_rel.suc_least_AboveS
thf(fact_4049_wo__rel_Oequals__suc__AboveS,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ A,A3: A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
       => ( ( member @ A @ A3 @ ( order_AboveS @ A @ R4 @ B3 ) )
         => ( ! [A9: A] :
                ( ( member @ A @ A9 @ ( order_AboveS @ A @ R4 @ B3 ) )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A9 ) @ R4 ) )
           => ( A3
              = ( bNF_Wellorder_wo_suc @ A @ R4 @ B3 ) ) ) ) ) ) ).

% wo_rel.equals_suc_AboveS
thf(fact_4050_wo__rel_Osuc__inField,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B3: set @ A] :
      ( ( bNF_Wellorder_wo_rel @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( field2 @ A @ R4 ) )
       => ( ( ( order_AboveS @ A @ R4 @ B3 )
           != ( bot_bot @ ( set @ A ) ) )
         => ( member @ A @ ( bNF_Wellorder_wo_suc @ A @ R4 @ B3 ) @ ( field2 @ A @ R4 ) ) ) ) ) ).

% wo_rel.suc_inField
thf(fact_4051_ord_OLeast__def,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( ^ [Less_eq2: A > A > $o,P3: A > $o] :
            ( the @ A
            @ ^ [X3: A] :
                ( ( P3 @ X3 )
                & ! [Y2: A] :
                    ( ( P3 @ Y2 )
                   => ( Less_eq2 @ X3 @ Y2 ) ) ) ) ) ) ).

% ord.Least_def
thf(fact_4052_fun_Orel__compp__Grp,axiom,
    ! [D: $tType,B: $tType,A: $tType,R: A > B > $o] :
      ( ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y4: D,Z5: D] : ( Y4 = Z5 )
        @ R )
      = ( relcompp @ ( D > A ) @ ( D > ( product_prod @ A @ B ) ) @ ( D > B )
        @ ( conversep @ ( D > ( product_prod @ A @ B ) ) @ ( D > A )
          @ ( bNF_Grp @ ( D > ( product_prod @ A @ B ) ) @ ( D > A )
            @ ( collect @ ( D > ( product_prod @ A @ B ) )
              @ ^ [X3: D > ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ D @ ( product_prod @ A @ B ) @ X3 @ ( top_top @ ( set @ D ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) ) )
            @ ( comp @ ( product_prod @ A @ B ) @ A @ D @ ( product_fst @ A @ B ) ) ) )
        @ ( bNF_Grp @ ( D > ( product_prod @ A @ B ) ) @ ( D > B )
          @ ( collect @ ( D > ( product_prod @ A @ B ) )
            @ ^ [X3: D > ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image2 @ D @ ( product_prod @ A @ B ) @ X3 @ ( top_top @ ( set @ D ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R ) ) ) )
          @ ( comp @ ( product_prod @ A @ B ) @ B @ D @ ( product_snd @ A @ B ) ) ) ) ) ).

% fun.rel_compp_Grp
thf(fact_4053_init__seg__of__def,axiom,
    ! [A: $tType] :
      ( ( init_seg_of @ A )
      = ( collect @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
        @ ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ $o
          @ ^ [R5: set @ ( product_prod @ A @ A ),S6: set @ ( product_prod @ A @ A )] :
              ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R5 @ S6 )
              & ! [A5: A,B4: A,C5: A] :
                  ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ S6 )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C5 ) @ R5 ) )
                 => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R5 ) ) ) ) ) ) ).

% init_seg_of_def
thf(fact_4054_inf__filter__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( filter @ A ) )
      = ( ^ [F5: filter @ A,F6: filter @ A] :
            ( abs_filter @ A
            @ ^ [P3: A > $o] :
              ? [Q3: A > $o,R2: A > $o] :
                ( ( eventually @ A @ Q3 @ F5 )
                & ( eventually @ A @ R2 @ F6 )
                & ! [X3: A] :
                    ( ( ( Q3 @ X3 )
                      & ( R2 @ X3 ) )
                   => ( P3 @ X3 ) ) ) ) ) ) ).

% inf_filter_def
thf(fact_4055_relcompp__bot1,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: C > B > $o] :
      ( ( relcompp @ A @ C @ B @ ( bot_bot @ ( A > C > $o ) ) @ R )
      = ( bot_bot @ ( A > B > $o ) ) ) ).

% relcompp_bot1
thf(fact_4056_relcompp__bot2,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: A > C > $o] :
      ( ( relcompp @ A @ C @ B @ R @ ( bot_bot @ ( C > B > $o ) ) )
      = ( bot_bot @ ( A > B > $o ) ) ) ).

% relcompp_bot2
thf(fact_4057_ord_OLeast_Ocong,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( least @ A ) ) ).

% ord.Least.cong
thf(fact_4058_refl__on__init__seg__of,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R4 ) @ ( init_seg_of @ A ) ) ).

% refl_on_init_seg_of
thf(fact_4059_antisym__init__seg__of,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S ) @ ( init_seg_of @ A ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ S @ R4 ) @ ( init_seg_of @ A ) )
       => ( R4 = S ) ) ) ).

% antisym_init_seg_of
thf(fact_4060_trans__init__seg__of,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A ),T4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S ) @ ( init_seg_of @ A ) )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ S @ T4 ) @ ( init_seg_of @ A ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ T4 ) @ ( init_seg_of @ A ) ) ) ) ).

% trans_init_seg_of
thf(fact_4061_bot__filter__def,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( filter @ A ) )
      = ( abs_filter @ A
        @ ^ [P3: A > $o] : $true ) ) ).

% bot_filter_def
thf(fact_4062_relcompp__relcomp__eq,axiom,
    ! [C: $tType,B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ B @ C )] :
      ( ( relcompp @ A @ B @ C
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R4 )
        @ ^ [X3: B,Y2: C] : ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ X3 @ Y2 ) @ S ) )
      = ( ^ [X3: A,Y2: C] : ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X3 @ Y2 ) @ ( relcomp @ A @ B @ C @ R4 @ S ) ) ) ) ).

% relcompp_relcomp_eq
thf(fact_4063_relcomp__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( relcomp @ A @ B @ C )
      = ( ^ [R5: set @ ( product_prod @ A @ B ),S6: set @ ( product_prod @ B @ C )] :
            ( collect @ ( product_prod @ A @ C )
            @ ( product_case_prod @ A @ C @ $o
              @ ( relcompp @ A @ B @ C
                @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R5 )
                @ ^ [X3: B,Y2: C] : ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ X3 @ Y2 ) @ S6 ) ) ) ) ) ) ).

% relcomp_def
thf(fact_4064_Chains__init__seg__of__Union,axiom,
    ! [A: $tType,R: set @ ( set @ ( product_prod @ A @ A ) ),R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( set @ ( set @ ( product_prod @ A @ A ) ) ) @ R @ ( chains @ ( set @ ( product_prod @ A @ A ) ) @ ( init_seg_of @ A ) ) )
     => ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) ) @ R ) ) @ ( init_seg_of @ A ) ) ) ) ).

% Chains_init_seg_of_Union
thf(fact_4065_initial__segment__of__Diff,axiom,
    ! [A: $tType,P4: set @ ( product_prod @ A @ A ),Q4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P4 @ Q4 ) @ ( init_seg_of @ A ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ P4 @ S ) @ ( minus_minus @ ( set @ ( product_prod @ A @ A ) ) @ Q4 @ S ) ) @ ( init_seg_of @ A ) ) ) ).

% initial_segment_of_Diff
thf(fact_4066_irrefl__tranclI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: A] :
      ( ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( converse @ A @ A @ R4 ) @ ( transitive_rtrancl @ A @ R4 ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( transitive_trancl @ A @ R4 ) ) ) ).

% irrefl_tranclI
thf(fact_4067_su__rel__fun_Of__def,axiom,
    ! [A: $tType,B: $tType,F3: set @ ( product_prod @ A @ B ),F: A > B,A4: A] :
      ( ( su_rel_fun @ A @ B @ F3 @ F )
     => ( ( F @ A4 )
        = ( the @ B
          @ ^ [B7: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B7 ) @ F3 ) ) ) ) ).

% su_rel_fun.f_def
thf(fact_4068_su__rel__fun_Ointro,axiom,
    ! [B: $tType,A: $tType,F3: set @ ( product_prod @ A @ B ),F: A > B] :
      ( ! [A13: A,B9: B,B15: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A13 @ B9 ) @ F3 )
         => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A13 @ B15 ) @ F3 )
           => ( B9 = B15 ) ) )
     => ( ! [A13: A,P5: $o] :
            ( ! [B16: B] :
                ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A13 @ B16 ) @ F3 )
               => P5 )
           => P5 )
       => ( ! [A13: A] :
              ( ( F @ A13 )
              = ( the @ B
                @ ^ [B7: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A13 @ B7 ) @ F3 ) ) )
         => ( su_rel_fun @ A @ B @ F3 @ F ) ) ) ) ).

% su_rel_fun.intro
thf(fact_4069_su__rel__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( su_rel_fun @ A @ B )
      = ( ^ [F5: set @ ( product_prod @ A @ B ),F2: A > B] :
            ( ! [A10: A,B7: B,B17: B] :
                ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A10 @ B7 ) @ F5 )
               => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A10 @ B17 ) @ F5 )
                 => ( B7 = B17 ) ) )
            & ! [A10: A,P3: $o] :
                ( ! [B7: B] :
                    ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A10 @ B7 ) @ F5 )
                   => P3 )
               => P3 )
            & ! [A10: A] :
                ( ( F2 @ A10 )
                = ( the @ B
                  @ ^ [B7: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A10 @ B7 ) @ F5 ) ) ) ) ) ) ).

% su_rel_fun_def
thf(fact_4070_converse__iff,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,R4: set @ ( product_prod @ B @ A )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ ( converse @ B @ A @ R4 ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ B2 @ A3 ) @ R4 ) ) ).

% converse_iff
thf(fact_4071_converse__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( converse @ B @ A @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% converse_empty
thf(fact_4072_converse_Ocases,axiom,
    ! [B: $tType,A: $tType,A1: B,A22: A,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ A1 @ A22 ) @ ( converse @ A @ B @ R4 ) )
     => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A22 @ A1 ) @ R4 ) ) ).

% converse.cases
thf(fact_4073_converse_Osimps,axiom,
    ! [B: $tType,A: $tType,A1: B,A22: A,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ A1 @ A22 ) @ ( converse @ A @ B @ R4 ) )
      = ( ? [A5: A,B4: B] :
            ( ( A1 = B4 )
            & ( A22 = A5 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B4 ) @ R4 ) ) ) ) ).

% converse.simps
thf(fact_4074_converseD,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,R4: set @ ( product_prod @ B @ A )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ ( converse @ B @ A @ R4 ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ B2 @ A3 ) @ R4 ) ) ).

% converseD
thf(fact_4075_converseE,axiom,
    ! [A: $tType,B: $tType,Yx: product_prod @ A @ B,R4: set @ ( product_prod @ B @ A )] :
      ( ( member @ ( product_prod @ A @ B ) @ Yx @ ( converse @ B @ A @ R4 ) )
     => ~ ! [X2: B,Y3: A] :
            ( ( Yx
              = ( product_Pair @ A @ B @ Y3 @ X2 ) )
           => ~ ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y3 ) @ R4 ) ) ) ).

% converseE
thf(fact_4076_converseI,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ R4 )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ B2 @ A3 ) @ ( converse @ A @ B @ R4 ) ) ) ).

% converseI
thf(fact_4077_converse__Int,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ B @ A ),S: set @ ( product_prod @ B @ A )] :
      ( ( converse @ B @ A @ ( inf_inf @ ( set @ ( product_prod @ B @ A ) ) @ R4 @ S ) )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( converse @ B @ A @ R4 ) @ ( converse @ B @ A @ S ) ) ) ).

% converse_Int
thf(fact_4078_rtrancl__converseD,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ ( converse @ A @ A @ R4 ) ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ).

% rtrancl_converseD
thf(fact_4079_rtrancl__converseI,axiom,
    ! [A: $tType,Y: A,X: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ ( converse @ A @ A @ R4 ) ) ) ) ).

% rtrancl_converseI
thf(fact_4080_trancl__converseI,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( converse @ A @ A @ ( transitive_trancl @ A @ R4 ) ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ ( converse @ A @ A @ R4 ) ) ) ) ).

% trancl_converseI
thf(fact_4081_trancl__converseD,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ ( converse @ A @ A @ R4 ) ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( converse @ A @ A @ ( transitive_trancl @ A @ R4 ) ) ) ) ).

% trancl_converseD
thf(fact_4082_su__rel__fun_Osurjective,axiom,
    ! [B: $tType,A: $tType,F3: set @ ( product_prod @ A @ B ),F: A > B,A4: A] :
      ( ( su_rel_fun @ A @ B @ F3 @ F )
     => ~ ! [B9: B] :
            ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B9 ) @ F3 ) ) ).

% su_rel_fun.surjective
thf(fact_4083_su__rel__fun_Ounique,axiom,
    ! [A: $tType,B: $tType,F3: set @ ( product_prod @ A @ B ),F: A > B,A4: A,B3: B,B18: B] :
      ( ( su_rel_fun @ A @ B @ F3 @ F )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ F3 )
       => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B18 ) @ F3 )
         => ( B3 = B18 ) ) ) ) ).

% su_rel_fun.unique
thf(fact_4084_su__rel__fun_Orepr2,axiom,
    ! [B: $tType,A: $tType,F3: set @ ( product_prod @ A @ B ),F: A > B,A4: A,B3: B] :
      ( ( su_rel_fun @ A @ B @ F3 @ F )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ F3 )
       => ( B3
          = ( F @ A4 ) ) ) ) ).

% su_rel_fun.repr2
thf(fact_4085_su__rel__fun_Orepr1,axiom,
    ! [B: $tType,A: $tType,F3: set @ ( product_prod @ A @ B ),F: A > B,A4: A] :
      ( ( su_rel_fun @ A @ B @ F3 @ F )
     => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ ( F @ A4 ) ) @ F3 ) ) ).

% su_rel_fun.repr1
thf(fact_4086_su__rel__fun_Orepr,axiom,
    ! [B: $tType,A: $tType,F3: set @ ( product_prod @ A @ B ),F: A > B,A4: A,B3: B] :
      ( ( su_rel_fun @ A @ B @ F3 @ F )
     => ( ( ( F @ A4 )
          = B3 )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ F3 ) ) ) ).

% su_rel_fun.repr
thf(fact_4087_converse__unfold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( converse @ B @ A )
      = ( ^ [R5: set @ ( product_prod @ B @ A )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [Y2: A,X3: B] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X3 @ Y2 ) @ R5 ) ) ) ) ) ).

% converse_unfold
thf(fact_4088_conversep__converse__eq,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ B )] :
      ( ( conversep @ A @ B
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R4 ) )
      = ( ^ [X3: B,Y2: A] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X3 @ Y2 ) @ ( converse @ A @ B @ R4 ) ) ) ) ).

% conversep_converse_eq
thf(fact_4089_converse__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( converse @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B )] :
            ( collect @ ( product_prod @ B @ A )
            @ ( product_case_prod @ B @ A @ $o
              @ ( conversep @ A @ B
                @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R5 ) ) ) ) ) ) ).

% converse_def
thf(fact_4090_trans__wf__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( trans @ A @ R4 )
     => ( ( wf @ A @ R4 )
        = ( ! [A5: A] :
              ( wf @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ ( image @ A @ A @ ( converse @ A @ A @ R4 ) @ ( insert2 @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) )
                  @ ^ [Uu: A] : ( image @ A @ A @ ( converse @ A @ A @ R4 ) @ ( insert2 @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% trans_wf_iff
thf(fact_4091_Image__INT__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,R4: set @ ( product_prod @ B @ A ),A4: set @ C,B3: C > ( set @ B )] :
      ( ( single_valued @ A @ B @ ( converse @ B @ A @ R4 ) )
     => ( ( A4
         != ( bot_bot @ ( set @ C ) ) )
       => ( ( image @ B @ A @ R4 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ C @ ( set @ B ) @ B3 @ A4 ) ) )
          = ( complete_Inf_Inf @ ( set @ A )
            @ ( image2 @ C @ ( set @ A )
              @ ^ [X3: C] : ( image @ B @ A @ R4 @ ( B3 @ X3 ) )
              @ A4 ) ) ) ) ) ).

% Image_INT_eq
thf(fact_4092_ord__to__filter__compat,axiom,
    ! [A: $tType,R0: set @ ( product_prod @ A @ A )] :
      ( bNF_Wellorder_compat @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ A )
      @ ( inf_inf @ ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) ) @ ( bNF_We4044943003108391690rdLess @ A @ A )
        @ ( product_Sigma @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( image @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( converse @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) @ ( insert2 @ ( set @ ( product_prod @ A @ A ) ) @ R0 @ ( bot_bot @ ( set @ ( set @ ( product_prod @ A @ A ) ) ) ) ) )
          @ ^ [Uu: set @ ( product_prod @ A @ A )] : ( image @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( converse @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) @ ( insert2 @ ( set @ ( product_prod @ A @ A ) ) @ R0 @ ( bot_bot @ ( set @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ) )
      @ ( bNF_We413866401316099525erIncl @ A @ R0 )
      @ ( bNF_We8469521843155493636filter @ A @ R0 ) ) ).

% ord_to_filter_compat
thf(fact_4093_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa @ X )
               => ( Y
                  = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa @ X )
               => ( Y
                  = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa @ ( suc @ X ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_4094_trans__empty,axiom,
    ! [A: $tType] : ( trans @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% trans_empty
thf(fact_4095_trans__Int,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( trans @ A @ R4 )
     => ( ( trans @ A @ S )
       => ( trans @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S ) ) ) ) ).

% trans_Int
thf(fact_4096_transD,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: A,Y: A,Z2: A] :
      ( ( trans @ A @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
       => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ R4 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ R4 ) ) ) ) ).

% transD
thf(fact_4097_transE,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: A,Y: A,Z2: A] :
      ( ( trans @ A @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
       => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ R4 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ R4 ) ) ) ) ).

% transE
thf(fact_4098_transI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ! [X2: A,Y3: A,Z3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R4 )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ R4 )
           => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z3 ) @ R4 ) ) )
     => ( trans @ A @ R4 ) ) ).

% transI
thf(fact_4099_trans__def,axiom,
    ! [A: $tType] :
      ( ( trans @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [X3: A,Y2: A,Z4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z4 ) @ R5 )
             => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Z4 ) @ R5 ) ) ) ) ) ).

% trans_def
thf(fact_4100_single__valuedD,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ B ),X: A,Y: B,Z2: B] :
      ( ( single_valued @ A @ B @ R4 )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ R4 )
       => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Z2 ) @ R4 )
         => ( Y = Z2 ) ) ) ) ).

% single_valuedD
thf(fact_4101_single__valuedI,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B )] :
      ( ! [X2: A,Y3: B,Z3: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ R4 )
         => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Z3 ) @ R4 )
           => ( Y3 = Z3 ) ) )
     => ( single_valued @ A @ B @ R4 ) ) ).

% single_valuedI
thf(fact_4102_single__valued__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( single_valued @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B )] :
          ! [X3: A,Y2: B] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R5 )
           => ! [Z4: B] :
                ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Z4 ) @ R5 )
               => ( Y2 = Z4 ) ) ) ) ) ).

% single_valued_def
thf(fact_4103_single__valued__empty,axiom,
    ! [B: $tType,A: $tType] : ( single_valued @ A @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% single_valued_empty
thf(fact_4104_single__valued__inter2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( single_valued @ A @ B @ R )
     => ( single_valued @ A @ B @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ S2 @ R ) ) ) ).

% single_valued_inter2
thf(fact_4105_single__valued__inter1,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( single_valued @ A @ B @ R )
     => ( single_valued @ A @ B @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ) ).

% single_valued_inter1
thf(fact_4106_compat__def,axiom,
    ! [A2: $tType,A: $tType] :
      ( ( bNF_Wellorder_compat @ A @ A2 )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),R9: set @ ( product_prod @ A2 @ A2 ),F2: A > A2] :
          ! [A5: A,B4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R5 )
           => ( member @ ( product_prod @ A2 @ A2 ) @ ( product_Pair @ A2 @ A2 @ ( F2 @ A5 ) @ ( F2 @ B4 ) ) @ R9 ) ) ) ) ).

% compat_def
thf(fact_4107_trans__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A4: set @ A] :
      ( ( trans @ A @ R4 )
     => ( trans @ A
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A4
            @ ^ [Uu: A] : A4 ) ) ) ) ).

% trans_Restr
thf(fact_4108_single__valued__confluent,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: A,Y: A,Z2: A] :
      ( ( single_valued @ A @ A @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R4 ) )
       => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_rtrancl @ A @ R4 ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ ( transitive_rtrancl @ A @ R4 ) )
            | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z2 @ Y ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ) ) ).

% single_valued_confluent
thf(fact_4109_under__incr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( trans @ A @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
       => ( ord_less_eq @ ( set @ A ) @ ( order_under @ A @ R4 @ A3 ) @ ( order_under @ A @ R4 @ B2 ) ) ) ) ).

% under_incr
thf(fact_4110_trans__singleton,axiom,
    ! [A: $tType,A3: A] : ( trans @ A @ ( insert2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A3 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% trans_singleton
thf(fact_4111_trans__join,axiom,
    ! [A: $tType] :
      ( ( trans @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [X3: product_prod @ A @ A] :
            ( ( member @ ( product_prod @ A @ A ) @ X3 @ R5 )
           => ( product_case_prod @ A @ A @ $o
              @ ^ [Y2: A,Y13: A] :
                ! [Z4: product_prod @ A @ A] :
                  ( ( member @ ( product_prod @ A @ A ) @ Z4 @ R5 )
                 => ( product_case_prod @ A @ A @ $o
                    @ ^ [Y24: A,Aa3: A] :
                        ( ( Y13 = Y24 )
                       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Aa3 ) @ R5 ) )
                    @ Z4 ) )
              @ X3 ) ) ) ) ).

% trans_join
thf(fact_4112_prod__decode__aux_Ocases,axiom,
    ! [X: product_prod @ nat @ nat] :
      ~ ! [K2: nat,M5: nat] :
          ( X
         != ( product_Pair @ nat @ nat @ K2 @ M5 ) ) ).

% prod_decode_aux.cases
thf(fact_4113_underS__incr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A,B2: A] :
      ( ( trans @ A @ R4 )
     => ( ( antisym @ A @ R4 )
       => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
         => ( ord_less_eq @ ( set @ A ) @ ( order_underS @ A @ R4 @ A3 ) @ ( order_underS @ A @ R4 @ B2 ) ) ) ) ) ).

% underS_incr
thf(fact_4114_Image__Int__eq,axiom,
    ! [A: $tType,B: $tType,R: set @ ( product_prod @ B @ A ),A4: set @ B,B3: set @ B] :
      ( ( single_valued @ A @ B @ ( converse @ B @ A @ R ) )
     => ( ( image @ B @ A @ R @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) )
        = ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ R @ A4 ) @ ( image @ B @ A @ R @ B3 ) ) ) ) ).

% Image_Int_eq
thf(fact_4115_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K4: nat,M3: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M3 @ K4 ) @ ( product_Pair @ nat @ nat @ M3 @ ( minus_minus @ nat @ K4 @ M3 ) ) @ ( nat_prod_decode_aux @ ( suc @ K4 ) @ ( minus_minus @ nat @ M3 @ ( suc @ K4 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_4116_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa )
        = Y )
     => ( ( ( ord_less_eq @ nat @ Xa @ X )
         => ( Y
            = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa @ X )
         => ( Y
            = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa @ ( suc @ X ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_4117_wf__finite__segments,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R4 )
     => ( ( trans @ A @ R4 )
       => ( ! [X2: A] :
              ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X2 ) @ R4 ) ) )
         => ( wf @ A @ R4 ) ) ) ) ).

% wf_finite_segments
thf(fact_4118_single__valuedp__single__valued__eq,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B )] :
      ( ( single_valuedp @ A @ B
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R4 ) )
      = ( single_valued @ A @ B @ R4 ) ) ).

% single_valuedp_single_valued_eq
thf(fact_4119_set__encode__empty,axiom,
    ( ( nat_set_encode @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% set_encode_empty
thf(fact_4120_aboveS__def,axiom,
    ! [A: $tType] :
      ( ( order_aboveS @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),A5: A] :
            ( collect @ A
            @ ^ [B4: A] :
                ( ( B4 != A5 )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R5 ) ) ) ) ) ).

% aboveS_def
thf(fact_4121_irrefl__def,axiom,
    ! [A: $tType] :
      ( ( irrefl @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [A5: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ A5 ) @ R5 ) ) ) ).

% irrefl_def
thf(fact_4122_irreflI,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ! [A8: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A8 @ A8 ) @ R )
     => ( irrefl @ A @ R ) ) ).

% irreflI
thf(fact_4123_single__valuedp__bot,axiom,
    ! [B: $tType,A: $tType] : ( single_valuedp @ A @ B @ ( bot_bot @ ( A > B > $o ) ) ) ).

% single_valuedp_bot
thf(fact_4124_relInvImage__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Gr7122648621184425601vImage @ A @ B )
      = ( ^ [A10: set @ A,R2: set @ ( product_prod @ B @ B ),F2: A > B] :
            ( collect @ ( product_prod @ A @ A )
            @ ^ [Uu: product_prod @ A @ A] :
              ? [A12: A,A23: A] :
                ( ( Uu
                  = ( product_Pair @ A @ A @ A12 @ A23 ) )
                & ( member @ A @ A12 @ A10 )
                & ( member @ A @ A23 @ A10 )
                & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F2 @ A12 ) @ ( F2 @ A23 ) ) @ R2 ) ) ) ) ) ).

% relInvImage_def
thf(fact_4125_Heap__lub__empty,axiom,
    ! [A: $tType] :
      ( ( heap_Time_Heap_lub @ A @ ( bot_bot @ ( set @ ( heap_Time_Heap @ A ) ) ) )
      = ( heap_Time_Heap2 @ A
        @ ^ [X3: heap_ext @ product_unit] : ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ).

% Heap_lub_empty
thf(fact_4126_normalize__stable,axiom,
    ! [Q4: int,P4: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Q4 )
     => ( ( algebr8660921524188924756oprime @ int @ P4 @ Q4 )
       => ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q4 ) )
          = ( product_Pair @ int @ int @ P4 @ Q4 ) ) ) ) ).

% normalize_stable
thf(fact_4127_semilattice__order__set_Osubset__imp,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,B3: set @ A] :
      ( ( lattic4895041142388067077er_set @ A @ F @ Less_eq @ Less )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_finite @ A @ B3 )
           => ( Less_eq @ ( lattic1715443433743089157tice_F @ A @ F @ B3 ) @ ( lattic1715443433743089157tice_F @ A @ F @ A4 ) ) ) ) ) ) ).

% semilattice_order_set.subset_imp
thf(fact_4128_coprime__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( algebr8660921524188924756oprime @ A @ C2 @ A3 )
            & ( algebr8660921524188924756oprime @ A @ C2 @ B2 ) ) ) ) ).

% coprime_mult_right_iff
thf(fact_4129_coprime__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( ( algebr8660921524188924756oprime @ A @ A3 @ C2 )
            & ( algebr8660921524188924756oprime @ A @ B2 @ C2 ) ) ) ) ).

% coprime_mult_left_iff
thf(fact_4130_coprime__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ A3 )
          = ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% coprime_self
thf(fact_4131_coprime__imp__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
         => ( ( gcd_gcd @ A @ A3 @ B2 )
            = ( one_one @ A ) ) ) ) ).

% coprime_imp_gcd_eq_1
thf(fact_4132_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( zero_zero @ A ) @ A3 )
          = ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% coprime_0_left_iff
thf(fact_4133_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% coprime_0_right_iff
thf(fact_4134_coprime__mult__self__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ) ).

% coprime_mult_self_left_iff
thf(fact_4135_coprime__mult__self__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ) ).

% coprime_mult_self_right_iff
thf(fact_4136_is__unit__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ ( one_one @ A ) )
          = ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ).

% is_unit_gcd
thf(fact_4137_coprime__1__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ A3 @ ( one_one @ A ) ) ) ).

% coprime_1_right
thf(fact_4138_coprime__1__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ ( one_one @ A ) @ A3 ) ) ).

% coprime_1_left
thf(fact_4139_coprime__add__one__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ A3 @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% coprime_add_one_right
thf(fact_4140_coprime__add__one__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ A3 ) ) ).

% coprime_add_one_left
thf(fact_4141_coprime__doff__one__right,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ A3 @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% coprime_doff_one_right
thf(fact_4142_coprime__diff__one__left,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ A3 ) ) ).

% coprime_diff_one_left
thf(fact_4143_coprime__dvd__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ C2 )
         => ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% coprime_dvd_mult_right_iff
thf(fact_4144_coprime__dvd__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ C2 )
         => ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% coprime_dvd_mult_left_iff
thf(fact_4145_divides__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ C2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
             => ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% divides_mult
thf(fact_4146_is__unit__right__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ).

% is_unit_right_imp_coprime
thf(fact_4147_is__unit__left__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ).

% is_unit_left_imp_coprime
thf(fact_4148_coprime__common__divisor,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ A3 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( dvd_dvd @ A @ C2 @ ( one_one @ A ) ) ) ) ) ) ).

% coprime_common_divisor
thf(fact_4149_coprime__absorb__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [Y: A,X: A] :
          ( ( dvd_dvd @ A @ Y @ X )
         => ( ( algebr8660921524188924756oprime @ A @ X @ Y )
            = ( dvd_dvd @ A @ Y @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_right
thf(fact_4150_coprime__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,D2: A,A3: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ D2 )
         => ( ! [E3: A] :
                ( ~ ( dvd_dvd @ A @ E3 @ ( one_one @ A ) )
               => ( ( dvd_dvd @ A @ E3 @ A3 )
                 => ( ( dvd_dvd @ A @ E3 @ B2 )
                   => ( dvd_dvd @ A @ E3 @ C2 ) ) ) )
           => ( ! [E3: A] :
                  ( ~ ( dvd_dvd @ A @ E3 @ ( one_one @ A ) )
                 => ( ( dvd_dvd @ A @ E3 @ A3 )
                   => ( ( dvd_dvd @ A @ E3 @ B2 )
                     => ( dvd_dvd @ A @ E3 @ D2 ) ) ) )
             => ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ) ) ).

% coprime_imp_coprime
thf(fact_4151_coprime__absorb__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( ( algebr8660921524188924756oprime @ A @ X @ Y )
            = ( dvd_dvd @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_left
thf(fact_4152_not__coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A3 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ~ ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
             => ~ ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ) ) ).

% not_coprimeI
thf(fact_4153_not__coprimeE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ~ ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
         => ~ ! [C4: A] :
                ( ( dvd_dvd @ A @ C4 @ A3 )
               => ( ( dvd_dvd @ A @ C4 @ B2 )
                 => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) ) ) ) ).

% not_coprimeE
thf(fact_4154_coprime__def,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [A5: A,B4: A] :
            ! [C5: A] :
              ( ( dvd_dvd @ A @ C5 @ A5 )
             => ( ( dvd_dvd @ A @ C5 @ B4 )
               => ( dvd_dvd @ A @ C5 @ ( one_one @ A ) ) ) ) ) ) ) ).

% coprime_def
thf(fact_4155_coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ! [C4: A] :
              ( ( dvd_dvd @ A @ C4 @ A3 )
             => ( ( dvd_dvd @ A @ C4 @ B2 )
               => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) )
         => ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ).

% coprimeI
thf(fact_4156_mult__mod__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [A3: A,N: A,M4: A,B2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ N ) @ M4 )
            = ( modulo_modulo @ A @ ( times_times @ A @ B2 @ N ) @ M4 ) )
         => ( ( algebr8660921524188924756oprime @ A @ M4 @ N )
           => ( ( modulo_modulo @ A @ A3 @ M4 )
              = ( modulo_modulo @ A @ B2 @ M4 ) ) ) ) ) ).

% mult_mod_cancel_right
thf(fact_4157_mult__mod__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [N: A,A3: A,M4: A,B2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ N @ A3 ) @ M4 )
            = ( modulo_modulo @ A @ ( times_times @ A @ N @ B2 ) @ M4 ) )
         => ( ( algebr8660921524188924756oprime @ A @ M4 @ N )
           => ( ( modulo_modulo @ A @ A3 @ M4 )
              = ( modulo_modulo @ A @ B2 @ M4 ) ) ) ) ) ).

% mult_mod_cancel_left
thf(fact_4158_gcd__mult__right__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ C2 )
         => ( ( gcd_gcd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( gcd_gcd @ A @ A3 @ B2 ) ) ) ) ).

% gcd_mult_right_right_cancel
thf(fact_4159_gcd__mult__right__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ C2 )
         => ( ( gcd_gcd @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) )
            = ( gcd_gcd @ A @ A3 @ B2 ) ) ) ) ).

% gcd_mult_right_left_cancel
thf(fact_4160_gcd__mult__left__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 )
            = ( gcd_gcd @ A @ A3 @ B2 ) ) ) ) ).

% gcd_mult_left_right_cancel
thf(fact_4161_gcd__mult__left__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A3 ) @ B2 )
            = ( gcd_gcd @ A @ A3 @ B2 ) ) ) ) ).

% gcd_mult_left_left_cancel
thf(fact_4162_coprime__iff__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( gcd_gcd @ A @ A5 @ B4 )
              = ( one_one @ A ) ) ) ) ) ).

% coprime_iff_gcd_eq_1
thf(fact_4163_gcd__eq__1__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A3 @ B2 )
            = ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ).

% gcd_eq_1_imp_coprime
thf(fact_4164_quotient__of__coprime,axiom,
    ! [R4: rat,P4: int,Q4: int] :
      ( ( ( quotient_of @ R4 )
        = ( product_Pair @ int @ int @ P4 @ Q4 ) )
     => ( algebr8660921524188924756oprime @ int @ P4 @ Q4 ) ) ).

% quotient_of_coprime
thf(fact_4165_normalize__coprime,axiom,
    ! [R4: product_prod @ int @ int,P4: int,Q4: int] :
      ( ( ( normalize @ R4 )
        = ( product_Pair @ int @ int @ P4 @ Q4 ) )
     => ( algebr8660921524188924756oprime @ int @ P4 @ Q4 ) ) ).

% normalize_coprime
thf(fact_4166_Inf__fin__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( lattic1715443433743089157tice_F @ A @ ( inf_inf @ A ) ) ) ) ).

% Inf_fin_def
thf(fact_4167_Sup__fin__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( lattic1715443433743089157tice_F @ A @ ( sup_sup @ A ) ) ) ) ).

% Sup_fin_def
thf(fact_4168_invertible__coprime,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
            = ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A3 @ C2 ) ) ) ).

% invertible_coprime
thf(fact_4169_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A3 @ B2 )
           != ( zero_zero @ A ) )
         => ? [A9: A,B8: A] :
              ( ( A3
                = ( times_times @ A @ A9 @ ( gcd_gcd @ A @ A3 @ B2 ) ) )
              & ( B2
                = ( times_times @ A @ B8 @ ( gcd_gcd @ A @ A3 @ B2 ) ) )
              & ( algebr8660921524188924756oprime @ A @ A9 @ B8 ) ) ) ) ).

% gcd_coprime_exists
thf(fact_4170_gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,A6: A,B5: A] :
          ( ( ( gcd_gcd @ A @ A3 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A3
              = ( times_times @ A @ A6 @ ( gcd_gcd @ A @ A3 @ B2 ) ) )
           => ( ( B2
                = ( times_times @ A @ B5 @ ( gcd_gcd @ A @ A3 @ B2 ) ) )
             => ( algebr8660921524188924756oprime @ A @ A6 @ B5 ) ) ) ) ) ).

% gcd_coprime
thf(fact_4171_semilattice__order__set_Obounded__iff,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,X: A] :
      ( ( lattic4895041142388067077er_set @ A @ F @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( Less_eq @ X @ ( lattic1715443433743089157tice_F @ A @ F @ A4 ) )
            = ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A4 )
                 => ( Less_eq @ X @ X3 ) ) ) ) ) ) ) ).

% semilattice_order_set.bounded_iff
thf(fact_4172_semilattice__order__set_OboundedI,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,X: A] :
      ( ( lattic4895041142388067077er_set @ A @ F @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [A8: A] :
                ( ( member @ A @ A8 @ A4 )
               => ( Less_eq @ X @ A8 ) )
           => ( Less_eq @ X @ ( lattic1715443433743089157tice_F @ A @ F @ A4 ) ) ) ) ) ) ).

% semilattice_order_set.boundedI
thf(fact_4173_semilattice__order__set_OboundedE,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,X: A] :
      ( ( lattic4895041142388067077er_set @ A @ F @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( Less_eq @ X @ ( lattic1715443433743089157tice_F @ A @ F @ A4 ) )
           => ! [A14: A] :
                ( ( member @ A @ A14 @ A4 )
               => ( Less_eq @ X @ A14 ) ) ) ) ) ) ).

% semilattice_order_set.boundedE
thf(fact_4174_semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F: A > A > A,A4: set @ A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F )
     => ( ( finite_finite @ A @ A4 )
       => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic1715443433743089157tice_F @ A @ F @ ( insert2 @ A @ X @ A4 ) )
              = X ) )
          & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic1715443433743089157tice_F @ A @ F @ ( insert2 @ A @ X @ A4 ) )
              = ( F @ X @ ( lattic1715443433743089157tice_F @ A @ F @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% semilattice_set.insert_remove
thf(fact_4175_semilattice__set_Oremove,axiom,
    ! [A: $tType,F: A > A > A,A4: set @ A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F )
     => ( ( finite_finite @ A @ A4 )
       => ( ( member @ A @ X @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic1715443433743089157tice_F @ A @ F @ A4 )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic1715443433743089157tice_F @ A @ F @ A4 )
                = ( F @ X @ ( lattic1715443433743089157tice_F @ A @ F @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% semilattice_set.remove
thf(fact_4176_semilattice__set_Ounion,axiom,
    ! [A: $tType,F: A > A > A,A4: set @ A,B3: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_finite @ A @ B3 )
           => ( ( B3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic1715443433743089157tice_F @ A @ F @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
                = ( F @ ( lattic1715443433743089157tice_F @ A @ F @ A4 ) @ ( lattic1715443433743089157tice_F @ A @ F @ B3 ) ) ) ) ) ) ) ) ).

% semilattice_set.union
thf(fact_4177_semilattice__set_Oinsert__not__elem,axiom,
    ! [A: $tType,F: A > A > A,A4: set @ A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F )
     => ( ( finite_finite @ A @ A4 )
       => ( ~ ( member @ A @ X @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic1715443433743089157tice_F @ A @ F @ ( insert2 @ A @ X @ A4 ) )
              = ( F @ X @ ( lattic1715443433743089157tice_F @ A @ F @ A4 ) ) ) ) ) ) ) ).

% semilattice_set.insert_not_elem
thf(fact_4178_Sup__fin_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( lattic149705377957585745ce_set @ A @ ( sup_sup @ A ) ) ) ).

% Sup_fin.semilattice_set_axioms
thf(fact_4179_Inf__fin_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( lattic149705377957585745ce_set @ A @ ( inf_inf @ A ) ) ) ).

% Inf_fin.semilattice_set_axioms
thf(fact_4180_semilattice__set_Osingleton,axiom,
    ! [A: $tType,F: A > A > A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F )
     => ( ( lattic1715443433743089157tice_F @ A @ F @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = X ) ) ).

% semilattice_set.singleton
thf(fact_4181_semilattice__set_Ohom__commute,axiom,
    ! [A: $tType,F: A > A > A,H2: A > A,N4: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F )
     => ( ! [X2: A,Y3: A] :
            ( ( H2 @ ( F @ X2 @ Y3 ) )
            = ( F @ ( H2 @ X2 ) @ ( H2 @ Y3 ) ) )
       => ( ( finite_finite @ A @ N4 )
         => ( ( N4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( H2 @ ( lattic1715443433743089157tice_F @ A @ F @ N4 ) )
              = ( lattic1715443433743089157tice_F @ A @ F @ ( image2 @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% semilattice_set.hom_commute
thf(fact_4182_semilattice__set_Osubset,axiom,
    ! [A: $tType,F: A > A > A,A4: set @ A,B3: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F )
     => ( ( finite_finite @ A @ A4 )
       => ( ( B3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A4 )
           => ( ( F @ ( lattic1715443433743089157tice_F @ A @ F @ B3 ) @ ( lattic1715443433743089157tice_F @ A @ F @ A4 ) )
              = ( lattic1715443433743089157tice_F @ A @ F @ A4 ) ) ) ) ) ) ).

% semilattice_set.subset
thf(fact_4183_semilattice__set_Oclosed,axiom,
    ! [A: $tType,F: A > A > A,A4: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A,Y3: A] : ( member @ A @ ( F @ X2 @ Y3 ) @ ( insert2 @ A @ X2 @ ( insert2 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
           => ( member @ A @ ( lattic1715443433743089157tice_F @ A @ F @ A4 ) @ A4 ) ) ) ) ) ).

% semilattice_set.closed
thf(fact_4184_semilattice__set_Oinsert,axiom,
    ! [A: $tType,F: A > A > A,A4: set @ A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( lattic1715443433743089157tice_F @ A @ F @ ( insert2 @ A @ X @ A4 ) )
            = ( F @ X @ ( lattic1715443433743089157tice_F @ A @ F @ A4 ) ) ) ) ) ) ).

% semilattice_set.insert
thf(fact_4185_prod_OatLeastLessThan__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( ord @ B ) )
     => ! [H2: nat > B,M4: nat,N: nat,G: B > A] :
          ( ( bij_betw @ nat @ B @ H2 @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) @ ( set_or7035219750837199246ssThan @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ B @ A @ nat @ G @ H2 ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ) ).

% prod.atLeastLessThan_reindex
thf(fact_4186_antisymp__antisym__eq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( antisymp @ A
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) )
      = ( antisym @ A @ R4 ) ) ).

% antisymp_antisym_eq
thf(fact_4187_prod_OatLeastAtMost__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( ord @ B ) )
     => ! [H2: nat > B,M4: nat,N: nat,G: B > A] :
          ( ( bij_betw @ nat @ B @ H2 @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) @ ( set_or1337092689740270186AtMost @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or1337092689740270186AtMost @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ B @ A @ nat @ G @ H2 ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ) ).

% prod.atLeastAtMost_reindex
thf(fact_4188_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A4 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Max.insert_remove
thf(fact_4189_max_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_max @ A @ ( ord_max @ A @ A3 @ B2 ) @ B2 )
          = ( ord_max @ A @ A3 @ B2 ) ) ) ).

% max.right_idem
thf(fact_4190_max_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_max @ A @ A3 @ ( ord_max @ A @ A3 @ B2 ) )
          = ( ord_max @ A @ A3 @ B2 ) ) ) ).

% max.left_idem
thf(fact_4191_max_Oidem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A] :
          ( ( ord_max @ A @ A3 @ A3 )
          = A3 ) ) ).

% max.idem
thf(fact_4192_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            & ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% max.bounded_iff
thf(fact_4193_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_4194_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% max.absorb1
thf(fact_4195_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% max.absorb3
thf(fact_4196_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_4197_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less @ A @ X @ Z2 )
            & ( ord_less @ A @ Y @ Z2 ) ) ) ) ).

% max_less_iff_conj
thf(fact_4198_max__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ X @ ( bot_bot @ A ) )
          = X ) ) ).

% max_bot2
thf(fact_4199_max__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ ( bot_bot @ A ) @ X )
          = X ) ) ).

% max_bot
thf(fact_4200_max__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) ).

% max_top
thf(fact_4201_max__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% max_top2
thf(fact_4202_max__min__same_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ( ord_max @ A @ Y @ ( ord_min @ A @ X @ Y ) )
          = Y ) ) ).

% max_min_same(4)
thf(fact_4203_max__min__same_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X @ Y ) @ Y )
          = Y ) ) ).

% max_min_same(3)
thf(fact_4204_max__min__same_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X @ Y ) @ X )
          = X ) ) ).

% max_min_same(2)
thf(fact_4205_max__min__same_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ X @ ( ord_min @ A @ X @ Y ) )
          = X ) ) ).

% max_min_same(1)
thf(fact_4206_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_4207_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_4208_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(6)
thf(fact_4209_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(5)
thf(fact_4210_Int__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A3 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_atLeastAtMost
thf(fact_4211_Int__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A3 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( ord_max @ A @ A3 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_atLeastLessThan
thf(fact_4212_Int__atLeastAtMostR2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ A3 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A3 @ C2 ) @ D2 ) ) ) ).

% Int_atLeastAtMostR2
thf(fact_4213_Int__atLeastAtMostL2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ ( set_ord_atLeast @ A @ C2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% Int_atLeastAtMostL2
thf(fact_4214_Int__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( ord_max @ A @ A3 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_greaterThanAtMost
thf(fact_4215_Int__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( set_or5935395276787703475ssThan @ A @ ( ord_max @ A @ A3 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_greaterThanLessThan
thf(fact_4216_Max__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A4 ) )
              = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ) ).

% Max_insert
thf(fact_4217_max__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F: A > B,M4: A,N: A] :
          ( ( order_mono @ A @ B @ F )
         => ( ( ord_max @ B @ ( F @ M4 ) @ ( F @ N ) )
            = ( F @ ( ord_max @ A @ M4 @ N ) ) ) ) ) ).

% max_of_mono
thf(fact_4218_bij__betw__trans,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: A > B,A4: set @ A,B3: set @ B,G: B > C,C3: set @ C] :
      ( ( bij_betw @ A @ B @ F @ A4 @ B3 )
     => ( ( bij_betw @ B @ C @ G @ B3 @ C3 )
       => ( bij_betw @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ A4 @ C3 ) ) ) ).

% bij_betw_trans
thf(fact_4219_bij__betw__comp__iff,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: A > B,A4: set @ A,A11: set @ B,F11: B > C,A19: set @ C] :
      ( ( bij_betw @ A @ B @ F @ A4 @ A11 )
     => ( ( bij_betw @ B @ C @ F11 @ A11 @ A19 )
        = ( bij_betw @ A @ C @ ( comp @ B @ C @ A @ F11 @ F ) @ A4 @ A19 ) ) ) ).

% bij_betw_comp_iff
thf(fact_4220_sup__max,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( linorder @ A ) )
     => ( ( sup_sup @ A )
        = ( ord_max @ A ) ) ) ).

% sup_max
thf(fact_4221_complete__linorder__sup__max,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ( ( sup_sup @ A )
        = ( ord_max @ A ) ) ) ).

% complete_linorder_sup_max
thf(fact_4222_max__min__distrib1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ B2 @ C2 ) @ A3 )
          = ( ord_min @ A @ ( ord_max @ A @ B2 @ A3 ) @ ( ord_max @ A @ C2 @ A3 ) ) ) ) ).

% max_min_distrib1
thf(fact_4223_max__min__distrib2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_max @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ord_min @ A @ ( ord_max @ A @ A3 @ B2 ) @ ( ord_max @ A @ A3 @ C2 ) ) ) ) ).

% max_min_distrib2
thf(fact_4224_min__max__distrib1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_min @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
          = ( ord_max @ A @ ( ord_min @ A @ B2 @ A3 ) @ ( ord_min @ A @ C2 @ A3 ) ) ) ) ).

% min_max_distrib1
thf(fact_4225_min__max__distrib2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_min @ A @ A3 @ ( ord_max @ A @ B2 @ C2 ) )
          = ( ord_max @ A @ ( ord_min @ A @ A3 @ B2 ) @ ( ord_min @ A @ A3 @ C2 ) ) ) ) ).

% min_max_distrib2
thf(fact_4226_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( plus_plus @ A @ Y @ Z2 ) ) ) ) ).

% max_add_distrib_left
thf(fact_4227_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ X @ ( ord_max @ A @ Y @ Z2 ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z2 ) ) ) ) ).

% max_add_distrib_right
thf(fact_4228_max_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_max @ A @ B2 @ ( ord_max @ A @ A3 @ C2 ) )
          = ( ord_max @ A @ A3 @ ( ord_max @ A @ B2 @ C2 ) ) ) ) ).

% max.left_commute
thf(fact_4229_max_Ocommute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_max @ A )
        = ( ^ [A5: A,B4: A] : ( ord_max @ A @ B4 @ A5 ) ) ) ) ).

% max.commute
thf(fact_4230_max_Oassoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_max @ A @ ( ord_max @ A @ A3 @ B2 ) @ C2 )
          = ( ord_max @ A @ A3 @ ( ord_max @ A @ B2 @ C2 ) ) ) ) ).

% max.assoc
thf(fact_4231_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_4232_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A3 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_4233_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( A5
                = ( ord_max @ A @ A5 @ B4 ) )
              & ( A5 != B4 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_4234_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less @ A @ B2 @ A3 )
             => ~ ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% max.strict_boundedE
thf(fact_4235_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z2 @ X )
            | ( ord_less @ A @ Z2 @ Y ) ) ) ) ).

% less_max_iff_disj
thf(fact_4236_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ord_max @ A @ ( minus_minus @ A @ X @ Z2 ) @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ).

% max_diff_distrib_left
thf(fact_4237_max_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semigroup @ A @ ( ord_max @ A ) ) ) ).

% max.semigroup_axioms
thf(fact_4238_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A3: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D2 ) @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_4239_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( A3
            = ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_4240_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( ord_max @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% max.orderI
thf(fact_4241_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A3 )
             => ~ ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% max.boundedE
thf(fact_4242_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ A3 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% max.boundedI
thf(fact_4243_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( A5
              = ( ord_max @ A @ A5 @ B4 ) ) ) ) ) ).

% max.order_iff
thf(fact_4244_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ A3 @ ( ord_max @ A @ A3 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_4245_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_4246_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less_eq @ A @ Z2 @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less_eq @ A @ Z2 @ X )
            | ( ord_less_eq @ A @ Z2 @ Y ) ) ) ) ).

% le_max_iff_disj
thf(fact_4247_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_max @ A @ A5 @ B4 )
              = A5 ) ) ) ) ).

% max.absorb_iff1
thf(fact_4248_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_max @ A @ A5 @ B4 )
              = B4 ) ) ) ) ).

% max.absorb_iff2
thf(fact_4249_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_4250_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_4251_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A5: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A5 @ B4 ) @ B4 @ A5 ) ) ) ) ).

% max_def
thf(fact_4252_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_max @ A @ X @ Y )
            = X ) ) ) ).

% max_absorb1
thf(fact_4253_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_max @ A @ X @ Y )
            = Y ) ) ) ).

% max_absorb2
thf(fact_4254_bij__betw__empty2,axiom,
    ! [B: $tType,A: $tType,F: A > B,A4: set @ A] :
      ( ( bij_betw @ A @ B @ F @ A4 @ ( bot_bot @ ( set @ B ) ) )
     => ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% bij_betw_empty2
thf(fact_4255_bij__betw__empty1,axiom,
    ! [A: $tType,B: $tType,F: A > B,A4: set @ B] :
      ( ( bij_betw @ A @ B @ F @ ( bot_bot @ ( set @ A ) ) @ A4 )
     => ( A4
        = ( bot_bot @ ( set @ B ) ) ) ) ).

% bij_betw_empty1
thf(fact_4256_bij__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: A > B,G: B > C] :
      ( ( bij_betw @ A @ B @ F @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
     => ( ( bij_betw @ B @ C @ G @ ( top_top @ ( set @ B ) ) @ ( top_top @ ( set @ C ) ) )
       => ( bij_betw @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ C ) ) ) ) ) ).

% bij_comp
thf(fact_4257_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X @ Y ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_max_eq_min
thf(fact_4258_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X @ Y ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_min_eq_max
thf(fact_4259_lessThan__Int__lessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A3 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( set_ord_greaterThan @ A @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% lessThan_Int_lessThan
thf(fact_4260_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F11: A > B,A11: set @ A,A19: set @ B,F: C > A,A4: set @ C] :
      ( ( bij_betw @ A @ B @ F11 @ A11 @ A19 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image2 @ C @ A @ F @ A4 ) @ A11 )
       => ( ( bij_betw @ C @ A @ F @ A4 @ A11 )
          = ( bij_betw @ C @ B @ ( comp @ A @ B @ C @ F11 @ F ) @ A4 @ A19 ) ) ) ) ).

% bij_betw_comp_iff2
thf(fact_4261_notIn__Un__bij__betw,axiom,
    ! [A: $tType,B: $tType,B2: A,A4: set @ A,F: A > B,A11: set @ B] :
      ( ~ ( member @ A @ B2 @ A4 )
     => ( ~ ( member @ B @ ( F @ B2 ) @ A11 )
       => ( ( bij_betw @ A @ B @ F @ A4 @ A11 )
         => ( bij_betw @ A @ B @ F @ ( sup_sup @ ( set @ A ) @ A4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( sup_sup @ ( set @ B ) @ A11 @ ( insert2 @ B @ ( F @ B2 ) @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ).

% notIn_Un_bij_betw
thf(fact_4262_notIn__Un__bij__betw3,axiom,
    ! [A: $tType,B: $tType,B2: A,A4: set @ A,F: A > B,A11: set @ B] :
      ( ~ ( member @ A @ B2 @ A4 )
     => ( ~ ( member @ B @ ( F @ B2 ) @ A11 )
       => ( ( bij_betw @ A @ B @ F @ A4 @ A11 )
          = ( bij_betw @ A @ B @ F @ ( sup_sup @ ( set @ A ) @ A4 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( sup_sup @ ( set @ B ) @ A11 @ ( insert2 @ B @ ( F @ B2 ) @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ).

% notIn_Un_bij_betw3
thf(fact_4263_bij__betw__combine,axiom,
    ! [A: $tType,B: $tType,F: A > B,A4: set @ A,B3: set @ B,C3: set @ A,D4: set @ B] :
      ( ( bij_betw @ A @ B @ F @ A4 @ B3 )
     => ( ( bij_betw @ A @ B @ F @ C3 @ D4 )
       => ( ( ( inf_inf @ ( set @ B ) @ B3 @ D4 )
            = ( bot_bot @ ( set @ B ) ) )
         => ( bij_betw @ A @ B @ F @ ( sup_sup @ ( set @ A ) @ A4 @ C3 ) @ ( sup_sup @ ( set @ B ) @ B3 @ D4 ) ) ) ) ) ).

% bij_betw_combine
thf(fact_4264_bij__betw__partition,axiom,
    ! [A: $tType,B: $tType,F: A > B,A4: set @ A,C3: set @ A,B3: set @ B,D4: set @ B] :
      ( ( bij_betw @ A @ B @ F @ ( sup_sup @ ( set @ A ) @ A4 @ C3 ) @ ( sup_sup @ ( set @ B ) @ B3 @ D4 ) )
     => ( ( bij_betw @ A @ B @ F @ C3 @ D4 )
       => ( ( ( inf_inf @ ( set @ A ) @ A4 @ C3 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( ( inf_inf @ ( set @ B ) @ B3 @ D4 )
              = ( bot_bot @ ( set @ B ) ) )
           => ( bij_betw @ A @ B @ F @ A4 @ B3 ) ) ) ) ) ).

% bij_betw_partition
thf(fact_4265_o__bij,axiom,
    ! [A: $tType,B: $tType,G: B > A,F: A > B] :
      ( ( ( comp @ B @ A @ A @ G @ F )
        = ( id @ A ) )
     => ( ( ( comp @ A @ B @ B @ F @ G )
          = ( id @ B ) )
       => ( bij_betw @ A @ B @ F @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) ) ) ) ).

% o_bij
thf(fact_4266_ex__bij__betw,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,R4: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ R4 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
     => ? [F10: B > A,B9: set @ B] : ( bij_betw @ B @ A @ F10 @ B9 @ A4 ) ) ).

% ex_bij_betw
thf(fact_4267_card__of__ordIso,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B3: set @ B] :
      ( ( ? [F2: A > B] : ( bij_betw @ A @ B @ F2 @ A4 @ B3 ) )
      = ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ).

% card_of_ordIso
thf(fact_4268_card__of__ordIsoI,axiom,
    ! [B: $tType,A: $tType,F: A > B,A4: set @ A,B3: set @ B] :
      ( ( bij_betw @ A @ B @ F @ A4 @ B3 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Ca6860139660246222851ard_of @ A @ A4 ) @ ( bNF_Ca6860139660246222851ard_of @ B @ B3 ) ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ).

% card_of_ordIsoI
thf(fact_4269_antisym__bot,axiom,
    ! [A: $tType] : ( antisymp @ A @ ( bot_bot @ ( A > A > $o ) ) ) ).

% antisym_bot
thf(fact_4270_Well__order__iso__copy,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,R4: set @ ( product_prod @ A @ A ),F: A > B,A11: set @ B] :
      ( ( order_well_order_on @ A @ A4 @ R4 )
     => ( ( bij_betw @ A @ B @ F @ A4 @ A11 )
       => ? [R11: set @ ( product_prod @ B @ B )] :
            ( ( order_well_order_on @ B @ A11 @ R11 )
            & ( member @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R11 ) @ ( bNF_Wellorder_ordIso @ A @ B ) ) ) ) ) ).

% Well_order_iso_copy
thf(fact_4271_iso__iff2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Wellorder_iso @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),R9: set @ ( product_prod @ B @ B ),F2: A > B] :
            ( ( bij_betw @ A @ B @ F2 @ ( field2 @ A @ R5 ) @ ( field2 @ B @ R9 ) )
            & ! [X3: A] :
                ( ( member @ A @ X3 @ ( field2 @ A @ R5 ) )
               => ! [Y2: A] :
                    ( ( member @ A @ Y2 @ ( field2 @ A @ R5 ) )
                   => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 )
                      = ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) @ R9 ) ) ) ) ) ) ) ).

% iso_iff2
thf(fact_4272_max__nat_Osemilattice__neutr__axioms,axiom,
    semilattice_neutr @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat ) ).

% max_nat.semilattice_neutr_axioms
thf(fact_4273_max__nat_Omonoid__axioms,axiom,
    monoid @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat ) ).

% max_nat.monoid_axioms
thf(fact_4274_bij__betw__disjoint__Un,axiom,
    ! [A: $tType,B: $tType,F: A > B,A4: set @ A,C3: set @ B,G: A > B,B3: set @ A,D4: set @ B] :
      ( ( bij_betw @ A @ B @ F @ A4 @ C3 )
     => ( ( bij_betw @ A @ B @ G @ B3 @ D4 )
       => ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( ( inf_inf @ ( set @ B ) @ C3 @ D4 )
              = ( bot_bot @ ( set @ B ) ) )
           => ( bij_betw @ A @ B
              @ ^ [X3: A] : ( if @ B @ ( member @ A @ X3 @ A4 ) @ ( F @ X3 ) @ ( G @ X3 ) )
              @ ( sup_sup @ ( set @ A ) @ A4 @ B3 )
              @ ( sup_sup @ ( set @ B ) @ C3 @ D4 ) ) ) ) ) ) ).

% bij_betw_disjoint_Un
thf(fact_4275_infinite__imp__bij__betw2,axiom,
    ! [A: $tType,A4: set @ A,A3: A] :
      ( ~ ( finite_finite @ A @ A4 )
     => ? [H: A > A] : ( bij_betw @ A @ A @ H @ A4 @ ( sup_sup @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_imp_bij_betw2
thf(fact_4276_infinite__imp__bij__betw,axiom,
    ! [A: $tType,A4: set @ A,A3: A] :
      ( ~ ( finite_finite @ A @ A4 )
     => ? [H: A > A] : ( bij_betw @ A @ A @ H @ A4 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_imp_bij_betw
thf(fact_4277_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P4 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P4 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_4278_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P4 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P4 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_4279_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_4280_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_4281_Sup__insert__finite,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A,X: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ X @ S2 ) )
                = X ) )
            & ( ( S2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ X @ S2 ) )
                = ( ord_max @ A @ X @ ( complete_Sup_Sup @ A @ S2 ) ) ) ) ) ) ) ).

% Sup_insert_finite
thf(fact_4282_hom__Max__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X2: A,Y3: A] :
              ( ( H2 @ ( ord_max @ A @ X2 @ Y3 ) )
              = ( ord_max @ A @ ( H2 @ X2 ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798349783984er_Max @ A @ N4 ) )
                = ( lattic643756798349783984er_Max @ A @ ( image2 @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% hom_Max_commute
thf(fact_4283_Max_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A4 )
             => ( ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ B3 ) @ ( lattic643756798349783984er_Max @ A @ A4 ) )
                = ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ) ).

% Max.subset
thf(fact_4284_Max_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A4 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ) ) ).

% Max.insert_not_elem
thf(fact_4285_Max_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X2: A,Y3: A] : ( member @ A @ ( ord_max @ A @ X2 @ Y3 ) @ ( insert2 @ A @ X2 @ ( insert2 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Max.closed
thf(fact_4286_Max_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B3: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B3 )
             => ( ( B3
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
                  = ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ ( lattic643756798349783984er_Max @ A @ B3 ) ) ) ) ) ) ) ) ).

% Max.union
thf(fact_4287_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S4: set @ B,T6: set @ C,H2: B > C,S2: set @ B,T3: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) @ ( minus_minus @ ( set @ C ) @ T3 @ T6 ) )
             => ( ! [A8: B] :
                    ( ( member @ B @ A8 @ S4 )
                   => ( ( G @ ( H2 @ A8 ) )
                      = ( one_one @ A ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ T6 )
                     => ( ( G @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A
                      @ ^ [X3: B] : ( G @ ( H2 @ X3 ) )
                      @ S2 )
                    = ( groups7121269368397514597t_prod @ C @ A @ G @ T3 ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
thf(fact_4288_sum_OatLeastAtMost__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( ord @ B ) )
     => ! [H2: nat > B,M4: nat,N: nat,G: B > A] :
          ( ( bij_betw @ nat @ B @ H2 @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) @ ( set_or1337092689740270186AtMost @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or1337092689740270186AtMost @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ B @ A @ nat @ G @ H2 ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ) ).

% sum.atLeastAtMost_reindex
thf(fact_4289_sum_OatLeastLessThan__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( ord @ B ) )
     => ! [H2: nat > B,M4: nat,N: nat,G: B > A] :
          ( ( bij_betw @ nat @ B @ H2 @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) @ ( set_or7035219750837199246ssThan @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ B @ A @ nat @ G @ H2 ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ) ).

% sum.atLeastLessThan_reindex
thf(fact_4290_Max_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A4 )
                  = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Max.remove
thf(fact_4291_next__present,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,H4: heap_ext @ product_unit,X: A,H2: heap_ext @ product_unit] :
          ( ( ( product_Pair @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ R4 @ H4 )
            = ( ref_alloc @ A @ X @ H2 ) )
         => ( ref_present @ A @ H4 @ R4 ) ) ) ).

% next_present
thf(fact_4292_next__fresh,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,H4: heap_ext @ product_unit,X: A,H2: heap_ext @ product_unit] :
          ( ( ( product_Pair @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ R4 @ H4 )
            = ( ref_alloc @ A @ X @ H2 ) )
         => ~ ( ref_present @ A @ H2 @ R4 ) ) ) ).

% next_fresh
thf(fact_4293_K__record__comp,axiom,
    ! [C: $tType,B: $tType,A: $tType,C2: B,F: A > C] :
      ( ( comp @ C @ B @ A
        @ ^ [X3: C] : C2
        @ F )
      = ( ^ [X3: A] : C2 ) ) ).

% K_record_comp
thf(fact_4294_bind__singleton__conv__image,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,F: B > A] :
      ( ( bind3 @ B @ A @ A4
        @ ^ [X3: B] : ( insert2 @ A @ ( F @ X3 ) @ ( bot_bot @ ( set @ A ) ) ) )
      = ( image2 @ B @ A @ F @ A4 ) ) ).

% bind_singleton_conv_image
thf(fact_4295_empty__bind,axiom,
    ! [B: $tType,A: $tType,F: B > ( set @ A )] :
      ( ( bind3 @ B @ A @ ( bot_bot @ ( set @ B ) ) @ F )
      = ( bot_bot @ ( set @ A ) ) ) ).

% empty_bind
thf(fact_4296_bind__const,axiom,
    ! [B: $tType,A: $tType,A4: set @ B,B3: set @ A] :
      ( ( ( A4
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( bind3 @ B @ A @ A4
            @ ^ [Uu: B] : B3 )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A4
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( bind3 @ B @ A @ A4
            @ ^ [Uu: B] : B3 )
          = B3 ) ) ) ).

% bind_const
thf(fact_4297_nonempty__bind__const,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B3: set @ B] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( bind3 @ A @ B @ A4
          @ ^ [Uu: A] : B3 )
        = B3 ) ) ).

% nonempty_bind_const
thf(fact_4298_bind__image,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: C > B,A4: set @ C,G: B > ( set @ A )] :
      ( ( bind3 @ B @ A @ ( image2 @ C @ B @ F @ A4 ) @ G )
      = ( bind3 @ C @ A @ A4 @ ( comp @ B @ ( set @ A ) @ C @ G @ F ) ) ) ).

% bind_image
thf(fact_4299_image__bind,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: B > A,A4: set @ C,G: C > ( set @ B )] :
      ( ( image2 @ B @ A @ F @ ( bind3 @ C @ B @ A4 @ G ) )
      = ( bind3 @ C @ A @ A4 @ ( comp @ ( set @ B ) @ ( set @ A ) @ C @ ( image2 @ B @ A @ F ) @ G ) ) ) ).

% image_bind
thf(fact_4300_set__decode__zero,axiom,
    ( ( nat_set_decode @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% set_decode_zero
thf(fact_4301_Func__empty,axiom,
    ! [B: $tType,A: $tType,B3: set @ B] :
      ( ( bNF_Wellorder_Func @ A @ B @ ( bot_bot @ ( set @ A ) ) @ B3 )
      = ( insert2 @ ( A > B )
        @ ^ [X3: A] : ( undefined @ B )
        @ ( bot_bot @ ( set @ ( A > B ) ) ) ) ) ).

% Func_empty
thf(fact_4302_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M4: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M4
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M4 @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M4 ) @ X ) ) ) ) ).

% power_int_add_1
thf(fact_4303_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M4: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M4
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M4 @ ( one_one @ int ) ) )
            = ( times_times @ A @ X @ ( power_int @ A @ X @ M4 ) ) ) ) ) ).

% power_int_add_1'
thf(fact_4304_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_4305_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W2: num,Y: A,M4: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Y ) @ M4 )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W2 ) @ M4 ) @ ( power_int @ A @ Y @ M4 ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_4306_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,W2: num,M4: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ ( numeral_numeral @ A @ W2 ) ) @ M4 )
          = ( times_times @ A @ ( power_int @ A @ X @ M4 ) @ ( power_int @ A @ ( numeral_numeral @ A @ W2 ) @ M4 ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_4307_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X: B] :
          ( ( power_int @ B @ X @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_4308_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M4: int] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M4 ) @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M4 ) )
          = ( one_one @ A ) ) ) ).

% power_int_minus_one_mult_self
thf(fact_4309_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M4: int,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M4 ) @ ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M4 ) @ B2 ) )
          = B2 ) ) ).

% power_int_minus_one_mult_self'
thf(fact_4310_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M4: num,N: num] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M4 ) ) @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M4 @ N ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_4311_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M4: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M4 ) ) @ ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M4 @ N ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_4312_mod__h__bot__normalize,axiom,
    ! [A: $tType,H2: heap_ext @ product_unit,P: assn] :
      ( ( syntax7388354845996824322omatch @ A @ ( heap_ext @ product_unit ) @ ( undefined @ A ) @ H2 )
     => ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        = ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ ( undefined @ ( heap_ext @ product_unit ) ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_normalize
thf(fact_4313_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( times_times @ A @ ( power_int @ A @ X @ N ) @ X )
          = ( times_times @ A @ X @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_commutes
thf(fact_4314_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M4: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ Y ) @ M4 )
          = ( times_times @ A @ ( power_int @ A @ X @ M4 ) @ ( power_int @ A @ Y @ M4 ) ) ) ) ).

% power_int_mult_distrib
thf(fact_4315_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_one_over
thf(fact_4316_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M4: int] :
          ( ( ( M4
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M4 )
              = ( one_one @ A ) ) )
          & ( ( M4
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_4317_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A3: A] :
          ( ( ord_less_eq @ int @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A3 @ N ) @ ( power_int @ A @ A3 @ N4 ) ) ) ) ) ).

% power_int_increasing
thf(fact_4318_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A3: A] :
          ( ( ord_less @ int @ N @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less @ A @ ( power_int @ A @ A3 @ N ) @ ( power_int @ A @ A3 @ N4 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_4319_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ int @ N ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) ) ) ).

% power_int_minus_one_minus
thf(fact_4320_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: int,B2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ A3 @ B2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ B2 @ A3 ) ) ) ) ).

% power_int_minus_one_diff_commute
thf(fact_4321_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A3: A] :
          ( ( ord_less @ int @ N @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A3 @ N4 ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_4322_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% one_le_power_int
thf(fact_4323_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ).

% one_less_power_int
thf(fact_4324_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M4: int,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M4 @ N )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M4 @ N ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M4 ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% power_int_add
thf(fact_4325_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( division_ring @ A )
        & ( one @ B )
        & ( uminus @ B ) )
     => ! [X: C,A3: A,N: int] :
          ( ( nO_MATCH @ B @ C @ ( uminus_uminus @ B @ ( one_one @ B ) ) @ X )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A3 ) @ N )
            = ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ).

% power_int_minus_left_distrib
thf(fact_4326_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_4327_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A3: A] :
          ( ( ord_less_eq @ int @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
             => ( ( ( A3
                   != ( zero_zero @ A ) )
                  | ( N4
                   != ( zero_zero @ int ) )
                  | ( N
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A3 @ N4 ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_4328_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M4: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X @ M4 ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less_eq @ int @ M4 @ N ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_4329_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M4: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less @ A @ ( power_int @ A @ X @ M4 ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ int @ M4 @ N ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_4330_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) @ X )
            = ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_minus_mult
thf(fact_4331_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K4: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K4 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_4332_Fract__def,axiom,
    ( fract
    = ( map_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat ) @ ( id @ int ) @ ( map_fun @ int @ int @ ( product_prod @ int @ int ) @ rat @ ( id @ int ) @ abs_Rat )
      @ ^ [A5: int,B4: int] :
          ( if @ ( product_prod @ int @ int )
          @ ( B4
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ A5 @ B4 ) ) ) ) ).

% Fract_def
thf(fact_4333_Fract_Otransfer,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat )
    @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ rat
      @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
      @ pcr_rat )
    @ ^ [A5: int,B4: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B4
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A5 @ B4 ) )
    @ fract ) ).

% Fract.transfer
thf(fact_4334_mset__set__Union,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( mset_set @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
            = ( plus_plus @ ( multiset @ A ) @ ( mset_set @ A @ A4 ) @ ( mset_set @ A @ B3 ) ) ) ) ) ) ).

% mset_set_Union
thf(fact_4335_mset__set_Oempty,axiom,
    ! [A: $tType] :
      ( ( mset_set @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ ( multiset @ A ) ) ) ).

% mset_set.empty
thf(fact_4336_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N: nat,F: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N @ ( comp @ A @ A @ B @ F ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N @ F ) ) ) ).

% comp_funpow
thf(fact_4337_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F: A > nat,X: A] :
          ( ( compow @ ( A > A ) @ ( F @ X ) @ ( times_times @ A @ X ) )
          = ( times_times @ A @ ( power_power @ A @ X @ ( F @ X ) ) ) ) ) ).

% funpow_times_power
thf(fact_4338_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F )
      = ( comp @ A @ A @ A @ F @ ( compow @ ( A > A ) @ N @ F ) ) ) ).

% funpow.simps(2)
thf(fact_4339_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N @ F ) @ F ) ) ).

% funpow_Suc_right
thf(fact_4340_funpow__add,axiom,
    ! [A: $tType,M4: nat,N: nat,F: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M4 @ N ) @ F )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M4 @ F ) @ ( compow @ ( A > A ) @ N @ F ) ) ) ).

% funpow_add
thf(fact_4341_quotient__of__eq,axiom,
    ! [A3: int,B2: int,P4: int,Q4: int] :
      ( ( ( quotient_of @ ( fract @ A3 @ B2 ) )
        = ( product_Pair @ int @ int @ P4 @ Q4 ) )
     => ( ( fract @ P4 @ Q4 )
        = ( fract @ A3 @ B2 ) ) ) ).

% quotient_of_eq
thf(fact_4342_normalize__eq,axiom,
    ! [A3: int,B2: int,P4: int,Q4: int] :
      ( ( ( normalize @ ( product_Pair @ int @ int @ A3 @ B2 ) )
        = ( product_Pair @ int @ int @ P4 @ Q4 ) )
     => ( ( fract @ P4 @ Q4 )
        = ( fract @ A3 @ B2 ) ) ) ).

% normalize_eq
thf(fact_4343_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I2: nat] : ( compow @ ( A > A ) @ I2 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_4344_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F: A > A,P4: A,K: nat] :
          ( ( order_mono @ A @ A @ F )
         => ( ( ord_less_eq @ A @ ( F @ P4 ) @ P4 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F @ ( bot_bot @ A ) ) @ P4 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_4345_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( A > A > $o ) @ N @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_4346_mset__set__empty__iff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ( mset_set @ A @ A4 )
        = ( zero_zero @ ( multiset @ A ) ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite @ A @ A4 ) ) ) ).

% mset_set_empty_iff
thf(fact_4347_quotient__of__Fract,axiom,
    ! [A3: int,B2: int] :
      ( ( quotient_of @ ( fract @ A3 @ B2 ) )
      = ( normalize @ ( product_Pair @ int @ int @ A3 @ B2 ) ) ) ).

% quotient_of_Fract
thf(fact_4348_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N5: nat] : ( compow @ ( A > A ) @ N5 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_4349_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A3: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A3 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A3 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_4350_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M4: nat,N: nat,F: A > A] :
          ( ( ord_less_eq @ nat @ M4 @ N )
         => ( ( order_mono @ A @ A @ F )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M4 @ F @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N @ F @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_4351_lfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: A > A,K: nat] :
          ( ( order_mono @ A @ A @ F )
         => ( ( ( compow @ ( A > A ) @ ( suc @ K ) @ F @ ( bot_bot @ A ) )
              = ( compow @ ( A > A ) @ K @ F @ ( bot_bot @ A ) ) )
           => ( ( complete_lattice_lfp @ A @ F )
              = ( compow @ ( A > A ) @ K @ F @ ( bot_bot @ A ) ) ) ) ) ) ).

% lfp_Kleene_iter
thf(fact_4352_Fract_Oabs__eq,axiom,
    ( fract
    = ( ^ [Xa4: int,X3: int] :
          ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( X3
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ Xa4 @ X3 ) ) ) ) ) ).

% Fract.abs_eq
thf(fact_4353_mset__set_Oinsert__remove,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( mset_set @ A @ ( insert2 @ A @ X @ A4 ) )
        = ( add_mset @ A @ X @ ( mset_set @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% mset_set.insert_remove
thf(fact_4354_mset__set_Oremove,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ( mset_set @ A @ A4 )
          = ( add_mset @ A @ X @ ( mset_set @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% mset_set.remove
thf(fact_4355_mult__cancel,axiom,
    ! [A: $tType,S: set @ ( product_prod @ A @ A ),X5: multiset @ A,Z7: multiset @ A,Y6: multiset @ A] :
      ( ( trans @ A @ S )
     => ( ( irrefl @ A @ S )
       => ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ ( plus_plus @ ( multiset @ A ) @ X5 @ Z7 ) @ ( plus_plus @ ( multiset @ A ) @ Y6 @ Z7 ) ) @ ( mult @ A @ S ) )
          = ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ X5 @ Y6 ) @ ( mult @ A @ S ) ) ) ) ) ).

% mult_cancel
thf(fact_4356_o__prs_I2_J,axiom,
    ! [F9: $tType,E: $tType,C: $tType,D: $tType,A: $tType,B: $tType,H9: $tType,G3: $tType,R12: A > A > $o,Abs1: A > B,Rep1: B > A,R23: C > C > $o,Abs22: C > D,Rep22: D > C,R32: E > E > $o,Abs32: E > F9,Rep32: F9 > E] :
      ( ( quotient3 @ A @ B @ R12 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R23 @ Abs22 @ Rep22 )
       => ( ( quotient3 @ E @ F9 @ R32 @ Abs32 @ Rep32 )
         => ( ( map_fun @ ( G3 > H9 ) @ ( G3 > H9 ) @ ( ( A > G3 ) > A > H9 ) @ ( ( B > G3 ) > B > H9 ) @ ( id @ ( G3 > H9 ) ) @ ( map_fun @ ( B > G3 ) @ ( A > G3 ) @ ( A > H9 ) @ ( B > H9 ) @ ( map_fun @ A @ B @ G3 @ G3 @ Abs1 @ ( id @ G3 ) ) @ ( map_fun @ B @ A @ H9 @ H9 @ Rep1 @ ( id @ H9 ) ) ) @ ( comp @ G3 @ H9 @ A ) )
            = ( comp @ G3 @ H9 @ B ) ) ) ) ) ).

% o_prs(2)
thf(fact_4357_mult__cancel__add__mset,axiom,
    ! [A: $tType,S: set @ ( product_prod @ A @ A ),Uu3: A,X5: multiset @ A,Y6: multiset @ A] :
      ( ( trans @ A @ S )
     => ( ( irrefl @ A @ S )
       => ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ ( add_mset @ A @ Uu3 @ X5 ) @ ( add_mset @ A @ Uu3 @ Y6 ) ) @ ( mult @ A @ S ) )
          = ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ X5 @ Y6 ) @ ( mult @ A @ S ) ) ) ) ) ).

% mult_cancel_add_mset
thf(fact_4358_mset__set_Ocomp__fun__commute__on,axiom,
    ! [A: $tType,Y: A,X: A] :
      ( ( comp @ ( multiset @ A ) @ ( multiset @ A ) @ ( multiset @ A ) @ ( add_mset @ A @ Y ) @ ( add_mset @ A @ X ) )
      = ( comp @ ( multiset @ A ) @ ( multiset @ A ) @ ( multiset @ A ) @ ( add_mset @ A @ X ) @ ( add_mset @ A @ Y ) ) ) ).

% mset_set.comp_fun_commute_on
thf(fact_4359_comp__fun__commute__mset__image,axiom,
    ! [B: $tType,A: $tType,F: A > B] : ( finite6289374366891150609ommute @ A @ ( multiset @ B ) @ ( comp @ B @ ( ( multiset @ B ) > ( multiset @ B ) ) @ A @ ( add_mset @ B ) @ F ) ) ).

% comp_fun_commute_mset_image
thf(fact_4360_abs__o__rep,axiom,
    ! [A: $tType,B: $tType,R: A > A > $o,Abs: A > B,Rep: B > A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( comp @ A @ B @ B @ Abs @ Rep )
        = ( id @ B ) ) ) ).

% abs_o_rep
thf(fact_4361_o__prs_I1_J,axiom,
    ! [C: $tType,E: $tType,A: $tType,B: $tType,F9: $tType,D: $tType,R12: A > A > $o,Abs1: A > B,Rep1: B > A,R23: C > C > $o,Abs22: C > D,Rep22: D > C,R32: E > E > $o,Abs32: E > F9,Rep32: F9 > E] :
      ( ( quotient3 @ A @ B @ R12 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R23 @ Abs22 @ Rep22 )
       => ( ( quotient3 @ E @ F9 @ R32 @ Abs32 @ Rep32 )
         => ( ( map_fun @ ( D > F9 ) @ ( C > E ) @ ( ( A > C ) > A > E ) @ ( ( B > D ) > B > F9 ) @ ( map_fun @ C @ D @ F9 @ E @ Abs22 @ Rep32 ) @ ( map_fun @ ( B > D ) @ ( A > C ) @ ( A > E ) @ ( B > F9 ) @ ( map_fun @ A @ B @ D @ C @ Abs1 @ Rep22 ) @ ( map_fun @ B @ A @ E @ F9 @ Rep1 @ Abs32 ) ) @ ( comp @ C @ E @ A ) )
            = ( comp @ D @ F9 @ B ) ) ) ) ) ).

% o_prs(1)
thf(fact_4362_OOO__eq__quotient3,axiom,
    ! [A: $tType,B: $tType,C: $tType,R12: A > A > $o,Abs1: A > B,Rep1: B > A,Abs22: B > C,Rep22: C > B] :
      ( ( quotient3 @ A @ B @ R12 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ B @ C
          @ ^ [Y4: B,Z5: B] : ( Y4 = Z5 )
          @ Abs22
          @ Rep22 )
       => ( quotient3 @ A @ C
          @ ( relcompp @ A @ A @ A @ R12
            @ ( relcompp @ A @ A @ A
              @ ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
              @ R12 ) )
          @ ( comp @ B @ C @ A @ Abs22 @ Abs1 )
          @ ( comp @ B @ A @ C @ Rep1 @ Rep22 ) ) ) ) ).

% OOO_eq_quotient3
thf(fact_4363_OOO__quotient3,axiom,
    ! [A: $tType,B: $tType,C: $tType,R12: A > A > $o,Abs1: A > B,Rep1: B > A,R23: B > B > $o,Abs22: B > C,Rep22: C > B,R24: A > A > $o] :
      ( ( quotient3 @ A @ B @ R12 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ B @ C @ R23 @ Abs22 @ Rep22 )
       => ( ! [X2: A,Y3: A] :
              ( ( R24 @ X2 @ Y3 )
             => ( ( R12 @ X2 @ X2 )
               => ( ( R12 @ Y3 @ Y3 )
                 => ( R23 @ ( Abs1 @ X2 ) @ ( Abs1 @ Y3 ) ) ) ) )
         => ( ! [X2: B,Y3: B] :
                ( ( R23 @ X2 @ Y3 )
               => ( R24 @ ( Rep1 @ X2 ) @ ( Rep1 @ Y3 ) ) )
           => ( quotient3 @ A @ C @ ( relcompp @ A @ A @ A @ R12 @ ( relcompp @ A @ A @ A @ R24 @ R12 ) ) @ ( comp @ B @ C @ A @ Abs22 @ Abs1 ) @ ( comp @ B @ A @ C @ Rep1 @ Rep22 ) ) ) ) ) ) ).

% OOO_quotient3
thf(fact_4364_mult__cancel__max,axiom,
    ! [A: $tType,S: set @ ( product_prod @ A @ A ),X5: multiset @ A,Y6: multiset @ A] :
      ( ( trans @ A @ S )
     => ( ( irrefl @ A @ S )
       => ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ X5 @ Y6 ) @ ( mult @ A @ S ) )
          = ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ ( minus_minus @ ( multiset @ A ) @ X5 @ Y6 ) @ ( minus_minus @ ( multiset @ A ) @ Y6 @ X5 ) ) @ ( mult @ A @ S ) ) ) ) ) ).

% mult_cancel_max
thf(fact_4365_multeqp__code__iff__reflcl__mult,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),P: A > A > $o,N4: multiset @ A,M: multiset @ A] :
      ( ( irrefl @ A @ R )
     => ( ( trans @ A @ R )
       => ( ! [X2: A,Y3: A] :
              ( ( P @ X2 @ Y3 )
              = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R ) )
         => ( ( multeqp_code @ A @ P @ N4 @ M )
            = ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ N4 @ M ) @ ( sup_sup @ ( set @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) ) @ ( mult @ A @ R ) @ ( id2 @ ( multiset @ A ) ) ) ) ) ) ) ) ).

% multeqp_code_iff_reflcl_mult
thf(fact_4366_multp__code__iff__mult,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),P: A > A > $o,N4: multiset @ A,M: multiset @ A] :
      ( ( irrefl @ A @ R )
     => ( ( trans @ A @ R )
       => ( ! [X2: A,Y3: A] :
              ( ( P @ X2 @ Y3 )
              = ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R ) )
         => ( ( multp_code @ A @ P @ N4 @ M )
            = ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ N4 @ M ) @ ( mult @ A @ R ) ) ) ) ) ) ).

% multp_code_iff_mult
thf(fact_4367_mult__implies__one__step,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),M: multiset @ A,N4: multiset @ A] :
      ( ( trans @ A @ R4 )
     => ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ M @ N4 ) @ ( mult @ A @ R4 ) )
       => ? [I7: multiset @ A,J6: multiset @ A] :
            ( ( N4
              = ( plus_plus @ ( multiset @ A ) @ I7 @ J6 ) )
            & ? [K7: multiset @ A] :
                ( ( M
                  = ( plus_plus @ ( multiset @ A ) @ I7 @ K7 ) )
                & ( J6
                 != ( zero_zero @ ( multiset @ A ) ) )
                & ! [X6: A] :
                    ( ( member @ A @ X6 @ ( set_mset @ A @ K7 ) )
                   => ? [Xa3: A] :
                        ( ( member @ A @ Xa3 @ ( set_mset @ A @ J6 ) )
                        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ Xa3 ) @ R4 ) ) ) ) ) ) ) ).

% mult_implies_one_step
thf(fact_4368_multp__def,axiom,
    ! [A: $tType] :
      ( ( multp @ A )
      = ( ^ [R5: A > A > $o,M7: multiset @ A,N7: multiset @ A] : ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ M7 @ N7 ) @ ( mult @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% multp_def
thf(fact_4369_set__mset__eq__empty__iff,axiom,
    ! [A: $tType,M: multiset @ A] :
      ( ( ( set_mset @ A @ M )
        = ( bot_bot @ ( set @ A ) ) )
      = ( M
        = ( zero_zero @ ( multiset @ A ) ) ) ) ).

% set_mset_eq_empty_iff
thf(fact_4370_set__mset__empty,axiom,
    ! [A: $tType] :
      ( ( set_mset @ A @ ( zero_zero @ ( multiset @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% set_mset_empty
thf(fact_4371_in__Inf__multiset__iff,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: A] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( member @ A @ X @ ( set_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A4 ) ) )
        = ( ! [X3: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ X3 @ A4 )
             => ( member @ A @ X @ ( set_mset @ A @ X3 ) ) ) ) ) ) ).

% in_Inf_multiset_iff
thf(fact_4372_infinite__set__mset__mset__set,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( set_mset @ A @ ( mset_set @ A @ A4 ) )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% infinite_set_mset_mset_set
thf(fact_4373_set__mset__Inf,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( set_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A4 ) )
        = ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ ( multiset @ A ) @ ( set @ A ) @ ( set_mset @ A ) @ A4 ) ) ) ) ).

% set_mset_Inf
thf(fact_4374_set__mset__single,axiom,
    ! [A: $tType,B2: A] :
      ( ( set_mset @ A @ ( add_mset @ A @ B2 @ ( zero_zero @ ( multiset @ A ) ) ) )
      = ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_mset_single
thf(fact_4375_at__most__one__mset__mset__diff,axiom,
    ! [A: $tType,A3: A,M: multiset @ A] :
      ( ~ ( member @ A @ A3 @ ( set_mset @ A @ ( minus_minus @ ( multiset @ A ) @ M @ ( add_mset @ A @ A3 @ ( zero_zero @ ( multiset @ A ) ) ) ) ) )
     => ( ( set_mset @ A @ ( minus_minus @ ( multiset @ A ) @ M @ ( add_mset @ A @ A3 @ ( zero_zero @ ( multiset @ A ) ) ) ) )
        = ( minus_minus @ ( set @ A ) @ ( set_mset @ A @ M ) @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% at_most_one_mset_mset_diff
thf(fact_4376_one__step__implies__mult,axiom,
    ! [A: $tType,J4: multiset @ A,K5: multiset @ A,R4: set @ ( product_prod @ A @ A ),I4: multiset @ A] :
      ( ( J4
       != ( zero_zero @ ( multiset @ A ) ) )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set_mset @ A @ K5 ) )
           => ? [Xa2: A] :
                ( ( member @ A @ Xa2 @ ( set_mset @ A @ J4 ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Xa2 ) @ R4 ) ) )
       => ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ ( plus_plus @ ( multiset @ A ) @ I4 @ K5 ) @ ( plus_plus @ ( multiset @ A ) @ I4 @ J4 ) ) @ ( mult @ A @ R4 ) ) ) ) ).

% one_step_implies_mult
thf(fact_4377_mult1__def,axiom,
    ! [A: $tType] :
      ( ( mult1 @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) )
            @ ( product_case_prod @ ( multiset @ A ) @ ( multiset @ A ) @ $o
              @ ^ [N7: multiset @ A,M7: multiset @ A] :
                ? [A5: A,M0: multiset @ A,K6: multiset @ A] :
                  ( ( M7
                    = ( add_mset @ A @ A5 @ M0 ) )
                  & ( N7
                    = ( plus_plus @ ( multiset @ A ) @ M0 @ K6 ) )
                  & ! [B4: A] :
                      ( ( member @ A @ B4 @ ( set_mset @ A @ K6 ) )
                     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ A5 ) @ R5 ) ) ) ) ) ) ) ).

% mult1_def
thf(fact_4378_less__add,axiom,
    ! [A: $tType,N4: multiset @ A,A3: A,M02: multiset @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ N4 @ ( add_mset @ A @ A3 @ M02 ) ) @ ( mult1 @ A @ R4 ) )
     => ( ? [M8: multiset @ A] :
            ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ M8 @ M02 ) @ ( mult1 @ A @ R4 ) )
            & ( N4
              = ( add_mset @ A @ A3 @ M8 ) ) )
        | ? [K7: multiset @ A] :
            ( ! [B11: A] :
                ( ( member @ A @ B11 @ ( set_mset @ A @ K7 ) )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B11 @ A3 ) @ R4 ) )
            & ( N4
              = ( plus_plus @ ( multiset @ A ) @ M02 @ K7 ) ) ) ) ) ).

% less_add
thf(fact_4379_mult1I,axiom,
    ! [A: $tType,M: multiset @ A,A3: A,M02: multiset @ A,N4: multiset @ A,K5: multiset @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( M
        = ( add_mset @ A @ A3 @ M02 ) )
     => ( ( N4
          = ( plus_plus @ ( multiset @ A ) @ M02 @ K5 ) )
       => ( ! [B6: A] :
              ( ( member @ A @ B6 @ ( set_mset @ A @ K5 ) )
             => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A3 ) @ R4 ) )
         => ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ N4 @ M ) @ ( mult1 @ A @ R4 ) ) ) ) ) ).

% mult1I
thf(fact_4380_mult1E,axiom,
    ! [A: $tType,N4: multiset @ A,M: multiset @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ N4 @ M ) @ ( mult1 @ A @ R4 ) )
     => ~ ! [A8: A,M03: multiset @ A] :
            ( ( M
              = ( add_mset @ A @ A8 @ M03 ) )
           => ! [K7: multiset @ A] :
                ( ( N4
                  = ( plus_plus @ ( multiset @ A ) @ M03 @ K7 ) )
               => ~ ! [B11: A] :
                      ( ( member @ A @ B11 @ ( set_mset @ A @ K7 ) )
                     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B11 @ A8 ) @ R4 ) ) ) ) ) ).

% mult1E
thf(fact_4381_not__less__empty,axiom,
    ! [A: $tType,M: multiset @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ M @ ( zero_zero @ ( multiset @ A ) ) ) @ ( mult1 @ A @ R4 ) ) ).

% not_less_empty
thf(fact_4382_mult1__union,axiom,
    ! [A: $tType,B3: multiset @ A,D4: multiset @ A,R4: set @ ( product_prod @ A @ A ),C3: multiset @ A] :
      ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ B3 @ D4 ) @ ( mult1 @ A @ R4 ) )
     => ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ ( plus_plus @ ( multiset @ A ) @ C3 @ B3 ) @ ( plus_plus @ ( multiset @ A ) @ C3 @ D4 ) ) @ ( mult1 @ A @ R4 ) ) ) ).

% mult1_union
thf(fact_4383_mult1__lessE,axiom,
    ! [A: $tType,N4: multiset @ A,M: multiset @ A,R4: A > A > $o] :
      ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ N4 @ M ) @ ( mult1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R4 ) ) ) )
     => ( ( asymp @ A @ R4 )
       => ~ ! [A8: A,M03: multiset @ A] :
              ( ( M
                = ( add_mset @ A @ A8 @ M03 ) )
             => ! [K7: multiset @ A] :
                  ( ( N4
                    = ( plus_plus @ ( multiset @ A ) @ M03 @ K7 ) )
                 => ( ~ ( member @ A @ A8 @ ( set_mset @ A @ K7 ) )
                   => ~ ! [B11: A] :
                          ( ( member @ A @ B11 @ ( set_mset @ A @ K7 ) )
                         => ( R4 @ B11 @ A8 ) ) ) ) ) ) ) ).

% mult1_lessE
thf(fact_4384_sum__wcount__Int,axiom,
    ! [A: $tType,A4: set @ A,F: A > nat,N4: multiset @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( wcount @ A @ F @ N4 ) @ ( inf_inf @ ( set @ A ) @ A4 @ ( set_mset @ A @ N4 ) ) )
        = ( groups7311177749621191930dd_sum @ A @ nat @ ( wcount @ A @ F @ N4 ) @ A4 ) ) ) ).

% sum_wcount_Int
thf(fact_4385_wmsI,axiom,
    ! [A4: multiset @ ( product_prod @ nat @ nat ),B3: multiset @ ( product_prod @ nat @ nat ),Z7: multiset @ ( product_prod @ nat @ nat )] :
      ( ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set_mset @ ( product_prod @ nat @ nat ) @ A4 ) @ ( set_mset @ ( product_prod @ nat @ nat ) @ B3 ) ) @ fun_max_strict )
        | ( ( A4
            = ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) )
          & ( B3
            = ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) ) )
     => ( member @ ( product_prod @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ Z7 @ A4 ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ Z7 @ B3 ) ) @ ms_weak ) ) ).

% wmsI
thf(fact_4386_smsI,axiom,
    ! [A4: multiset @ ( product_prod @ nat @ nat ),B3: multiset @ ( product_prod @ nat @ nat ),Z7: multiset @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set_mset @ ( product_prod @ nat @ nat ) @ A4 ) @ ( set_mset @ ( product_prod @ nat @ nat ) @ B3 ) ) @ fun_max_strict )
     => ( member @ ( product_prod @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ Z7 @ A4 ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ Z7 @ B3 ) ) @ ms_strict ) ) ).

% smsI
thf(fact_4387_ms__reduction__pair,axiom,
    fun_reduction_pair @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) @ ( set @ ( product_prod @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) @ ms_strict @ ms_weak ) ).

% ms_reduction_pair
thf(fact_4388_ms__strictI,axiom,
    ! [Z7: multiset @ ( product_prod @ nat @ nat ),Z8: multiset @ ( product_prod @ nat @ nat ),A4: multiset @ ( product_prod @ nat @ nat ),B3: multiset @ ( product_prod @ nat @ nat )] :
      ( ( pw_leq @ Z7 @ Z8 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set_mset @ ( product_prod @ nat @ nat ) @ A4 ) @ ( set_mset @ ( product_prod @ nat @ nat ) @ B3 ) ) @ fun_max_strict )
       => ( member @ ( product_prod @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ Z7 @ A4 ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ Z8 @ B3 ) ) @ ms_strict ) ) ) ).

% ms_strictI
thf(fact_4389_ms__weakI1,axiom,
    ! [Z7: multiset @ ( product_prod @ nat @ nat ),Z8: multiset @ ( product_prod @ nat @ nat ),A4: multiset @ ( product_prod @ nat @ nat ),B3: multiset @ ( product_prod @ nat @ nat )] :
      ( ( pw_leq @ Z7 @ Z8 )
     => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set_mset @ ( product_prod @ nat @ nat ) @ A4 ) @ ( set_mset @ ( product_prod @ nat @ nat ) @ B3 ) ) @ fun_max_strict )
       => ( member @ ( product_prod @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ Z7 @ A4 ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ Z8 @ B3 ) ) @ ms_weak ) ) ) ).

% ms_weakI1
thf(fact_4390_pw__leq__split,axiom,
    ! [X5: multiset @ ( product_prod @ nat @ nat ),Y6: multiset @ ( product_prod @ nat @ nat )] :
      ( ( pw_leq @ X5 @ Y6 )
     => ? [A13: multiset @ ( product_prod @ nat @ nat ),B9: multiset @ ( product_prod @ nat @ nat ),Z9: multiset @ ( product_prod @ nat @ nat )] :
          ( ( X5
            = ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ A13 @ Z9 ) )
          & ( Y6
            = ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ B9 @ Z9 ) )
          & ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set_mset @ ( product_prod @ nat @ nat ) @ A13 ) @ ( set_mset @ ( product_prod @ nat @ nat ) @ B9 ) ) @ fun_max_strict )
            | ( ( B9
                = ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) )
              & ( A13
                = ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) ) ) ) ) ).

% pw_leq_split
thf(fact_4391_ms__weakI2,axiom,
    ! [Z7: multiset @ ( product_prod @ nat @ nat ),Z8: multiset @ ( product_prod @ nat @ nat )] :
      ( ( pw_leq @ Z7 @ Z8 )
     => ( member @ ( product_prod @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ Z7 @ ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ Z8 @ ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) ) @ ms_weak ) ) ).

% ms_weakI2
thf(fact_4392_pw__leq__lstep,axiom,
    ! [X: product_prod @ nat @ nat,Y: product_prod @ nat @ nat] :
      ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_leq )
     => ( pw_leq @ ( add_mset @ ( product_prod @ nat @ nat ) @ X @ ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) @ ( add_mset @ ( product_prod @ nat @ nat ) @ Y @ ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) ) ) ).

% pw_leq_lstep
thf(fact_4393_pw__leq__step,axiom,
    ! [X: product_prod @ nat @ nat,Y: product_prod @ nat @ nat,X5: multiset @ ( product_prod @ nat @ nat ),Y6: multiset @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_leq )
     => ( ( pw_leq @ X5 @ Y6 )
       => ( pw_leq @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( add_mset @ ( product_prod @ nat @ nat ) @ X @ ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) @ X5 ) @ ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( add_mset @ ( product_prod @ nat @ nat ) @ Y @ ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) @ Y6 ) ) ) ) ).

% pw_leq_step
thf(fact_4394_pw__leq_Osimps,axiom,
    ( pw_leq
    = ( ^ [A12: multiset @ ( product_prod @ nat @ nat ),A23: multiset @ ( product_prod @ nat @ nat )] :
          ( ( ( A12
              = ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) )
            & ( A23
              = ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) )
          | ? [X3: product_prod @ nat @ nat,Y2: product_prod @ nat @ nat,X8: multiset @ ( product_prod @ nat @ nat ),Y10: multiset @ ( product_prod @ nat @ nat )] :
              ( ( A12
                = ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( add_mset @ ( product_prod @ nat @ nat ) @ X3 @ ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) @ X8 ) )
              & ( A23
                = ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( add_mset @ ( product_prod @ nat @ nat ) @ Y2 @ ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) @ Y10 ) )
              & ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X3 @ Y2 ) @ fun_pair_leq )
              & ( pw_leq @ X8 @ Y10 ) ) ) ) ) ).

% pw_leq.simps
thf(fact_4395_pw__leq_Ocases,axiom,
    ! [A1: multiset @ ( product_prod @ nat @ nat ),A22: multiset @ ( product_prod @ nat @ nat )] :
      ( ( pw_leq @ A1 @ A22 )
     => ( ( ( A1
            = ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) )
         => ( A22
           != ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) )
       => ~ ! [X2: product_prod @ nat @ nat,Y3: product_prod @ nat @ nat,X10: multiset @ ( product_prod @ nat @ nat )] :
              ( ( A1
                = ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( add_mset @ ( product_prod @ nat @ nat ) @ X2 @ ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) @ X10 ) )
             => ! [Y11: multiset @ ( product_prod @ nat @ nat )] :
                  ( ( A22
                    = ( plus_plus @ ( multiset @ ( product_prod @ nat @ nat ) ) @ ( add_mset @ ( product_prod @ nat @ nat ) @ Y3 @ ( zero_zero @ ( multiset @ ( product_prod @ nat @ nat ) ) ) ) @ Y11 ) )
                 => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X2 @ Y3 ) @ fun_pair_leq )
                   => ~ ( pw_leq @ X10 @ Y11 ) ) ) ) ) ) ).

% pw_leq.cases
thf(fact_4396_set__mset__replicate__mset__subset,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set_mset @ A @ ( replicate_mset @ A @ N @ X ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set_mset @ A @ ( replicate_mset @ A @ N @ X ) )
          = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_mset_replicate_mset_subset
thf(fact_4397_mult__cancel__max0,axiom,
    ! [A: $tType,S: set @ ( product_prod @ A @ A ),X5: multiset @ A,Y6: multiset @ A] :
      ( ( trans @ A @ S )
     => ( ( irrefl @ A @ S )
       => ( ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ X5 @ Y6 ) @ ( mult @ A @ S ) )
          = ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ ( minus_minus @ ( multiset @ A ) @ X5 @ ( inter_mset @ A @ X5 @ Y6 ) ) @ ( minus_minus @ ( multiset @ A ) @ Y6 @ ( inter_mset @ A @ X5 @ Y6 ) ) ) @ ( mult @ A @ S ) ) ) ) ) ).

% mult_cancel_max0
thf(fact_4398_prod__mset_Oremove,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [X: A,A4: multiset @ A] :
          ( ( member @ A @ X @ ( set_mset @ A @ A4 ) )
         => ( ( comm_m9189036328036947845d_mset @ A @ A4 )
            = ( times_times @ A @ X @ ( comm_m9189036328036947845d_mset @ A @ ( minus_minus @ ( multiset @ A ) @ A4 @ ( add_mset @ A @ X @ ( zero_zero @ ( multiset @ A ) ) ) ) ) ) ) ) ) ).

% prod_mset.remove
thf(fact_4399_add_Ogroup__axioms,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( group @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A ) ) ) ).

% add.group_axioms
thf(fact_4400_set__mset__inter,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A] :
      ( ( set_mset @ A @ ( inter_mset @ A @ A4 @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ ( set_mset @ A @ A4 ) @ ( set_mset @ A @ B3 ) ) ) ).

% set_mset_inter
thf(fact_4401_prod__mset__empty,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( comm_m9189036328036947845d_mset @ A @ ( zero_zero @ ( multiset @ A ) ) )
        = ( one_one @ A ) ) ) ).

% prod_mset_empty
thf(fact_4402_prod__mset_Oadd__mset,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [X: A,N4: multiset @ A] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( add_mset @ A @ X @ N4 ) )
          = ( times_times @ A @ X @ ( comm_m9189036328036947845d_mset @ A @ N4 ) ) ) ) ).

% prod_mset.add_mset
thf(fact_4403_prod__mset__Un,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: multiset @ A,B3: multiset @ A] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( plus_plus @ ( multiset @ A ) @ A4 @ B3 ) )
          = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ A4 ) @ ( comm_m9189036328036947845d_mset @ A @ B3 ) ) ) ) ).

% prod_mset_Un
thf(fact_4404_prod__mset_Ounion,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: multiset @ A,N4: multiset @ A] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( plus_plus @ ( multiset @ A ) @ M @ N4 ) )
          = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ M ) @ ( comm_m9189036328036947845d_mset @ A @ N4 ) ) ) ) ).

% prod_mset.union
thf(fact_4405_group_Oleft__cancel,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A,A3: A,B2: A,C2: A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( ( ( F @ A3 @ B2 )
          = ( F @ A3 @ C2 ) )
        = ( B2 = C2 ) ) ) ).

% group.left_cancel
thf(fact_4406_group_Oleft__inverse,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A,A3: A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( ( F @ ( Inverse @ A3 ) @ A3 )
        = Z2 ) ) ).

% group.left_inverse
thf(fact_4407_group_Oright__cancel,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A,B2: A,A3: A,C2: A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( ( ( F @ B2 @ A3 )
          = ( F @ C2 @ A3 ) )
        = ( B2 = C2 ) ) ) ).

% group.right_cancel
thf(fact_4408_group_Oright__inverse,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A,A3: A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( ( F @ A3 @ ( Inverse @ A3 ) )
        = Z2 ) ) ).

% group.right_inverse
thf(fact_4409_group_Oinverse__unique,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A,A3: A,B2: A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( ( ( F @ A3 @ B2 )
          = Z2 )
       => ( ( Inverse @ A3 )
          = B2 ) ) ) ).

% group.inverse_unique
thf(fact_4410_group_Oinverse__inverse,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A,A3: A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( ( Inverse @ ( Inverse @ A3 ) )
        = A3 ) ) ).

% group.inverse_inverse
thf(fact_4411_group_Oinverse__neutral,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( ( Inverse @ Z2 )
        = Z2 ) ) ).

% group.inverse_neutral
thf(fact_4412_group_Ogroup__left__neutral,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A,A3: A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( ( F @ Z2 @ A3 )
        = A3 ) ) ).

% group.group_left_neutral
thf(fact_4413_group_Oinverse__distrib__swap,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A,A3: A,B2: A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( ( Inverse @ ( F @ A3 @ B2 ) )
        = ( F @ ( Inverse @ B2 ) @ ( Inverse @ A3 ) ) ) ) ).

% group.inverse_distrib_swap
thf(fact_4414_group_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( semigroup @ A @ F ) ) ).

% group.axioms(1)
thf(fact_4415_prod__mset_Oneutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: multiset @ A] :
          ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( set_mset @ A @ A4 ) )
             => ( X2
                = ( one_one @ A ) ) )
         => ( ( comm_m9189036328036947845d_mset @ A @ A4 )
            = ( one_one @ A ) ) ) ) ).

% prod_mset.neutral
thf(fact_4416_is__unit__prod__mset__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A4: multiset @ A] :
          ( ( dvd_dvd @ A @ ( comm_m9189036328036947845d_mset @ A @ A4 ) @ ( one_one @ A ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set_mset @ A @ A4 ) )
               => ( dvd_dvd @ A @ X3 @ ( one_one @ A ) ) ) ) ) ) ).

% is_unit_prod_mset_iff
thf(fact_4417_group__def,axiom,
    ! [A: $tType] :
      ( ( group @ A )
      = ( ^ [F2: A > A > A,Z4: A,Inverse2: A > A] :
            ( ( semigroup @ A @ F2 )
            & ( group_axioms @ A @ F2 @ Z4 @ Inverse2 ) ) ) ) ).

% group_def
thf(fact_4418_group_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A] :
      ( ( semigroup @ A @ F )
     => ( ( group_axioms @ A @ F @ Z2 @ Inverse )
       => ( group @ A @ F @ Z2 @ Inverse ) ) ) ).

% group.intro
thf(fact_4419_prod__mset_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( comm_m9189036328036947845d_mset @ A )
        = ( fold_mset @ A @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod_mset.eq_fold
thf(fact_4420_subset__mset_OInf__fin_Oinsert,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ A4 ) )
          = ( inter_mset @ A @ X @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) ) ) ) ) ).

% subset_mset.Inf_fin.insert
thf(fact_4421_subset__mset_OInf__fin_Osingleton,axiom,
    ! [A: $tType,X: multiset @ A] :
      ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
      = X ) ).

% subset_mset.Inf_fin.singleton
thf(fact_4422_group__axioms__def,axiom,
    ! [A: $tType] :
      ( ( group_axioms @ A )
      = ( ^ [F2: A > A > A,Z4: A,Inverse2: A > A] :
            ( ! [A5: A] :
                ( ( F2 @ Z4 @ A5 )
                = A5 )
            & ! [A5: A] :
                ( ( F2 @ ( Inverse2 @ A5 ) @ A5 )
                = Z4 ) ) ) ) ).

% group_axioms_def
thf(fact_4423_group__axioms_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A] :
      ( ! [A8: A] :
          ( ( F @ Z2 @ A8 )
          = A8 )
     => ( ! [A8: A] :
            ( ( F @ ( Inverse @ A8 ) @ A8 )
            = Z2 )
       => ( group_axioms @ A @ F @ Z2 @ Inverse ) ) ) ).

% group_axioms.intro
thf(fact_4424_subset__mset_OInf__fin_Ounion,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite @ ( multiset @ A ) @ B3 )
         => ( ( B3
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( sup_sup @ ( set @ ( multiset @ A ) ) @ A4 @ B3 ) )
              = ( inter_mset @ A @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ B3 ) ) ) ) ) ) ) ).

% subset_mset.Inf_fin.union
thf(fact_4425_subset__mset_OInf__fin_Osubset,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( B3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ B3 @ A4 )
         => ( ( inter_mset @ A @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ B3 ) @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) )
            = ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) ) ) ) ) ).

% subset_mset.Inf_fin.subset
thf(fact_4426_subset__mset_OInf__fin_Ohom__commute,axiom,
    ! [A: $tType,H2: ( multiset @ A ) > ( multiset @ A ),N4: set @ ( multiset @ A )] :
      ( ! [X2: multiset @ A,Y3: multiset @ A] :
          ( ( H2 @ ( inter_mset @ A @ X2 @ Y3 ) )
          = ( inter_mset @ A @ ( H2 @ X2 ) @ ( H2 @ Y3 ) ) )
     => ( ( finite_finite @ ( multiset @ A ) @ N4 )
       => ( ( N4
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( H2 @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ N4 ) )
            = ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( image2 @ ( multiset @ A ) @ ( multiset @ A ) @ H2 @ N4 ) ) ) ) ) ) ).

% subset_mset.Inf_fin.hom_commute
thf(fact_4427_group_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Inverse: A > A] :
      ( ( group @ A @ F @ Z2 @ Inverse )
     => ( group_axioms @ A @ F @ Z2 @ Inverse ) ) ).

% group.axioms(2)
thf(fact_4428_subset__mset_OcInf__eq__Inf__fin,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ X5 )
     => ( ( X5
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( complete_Inf_Inf @ ( multiset @ A ) @ X5 )
          = ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ X5 ) ) ) ) ).

% subset_mset.cInf_eq_Inf_fin
thf(fact_4429_subset__mset_OInf__fin_Oremove,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( member @ ( multiset @ A ) @ X @ A4 )
       => ( ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
              = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 )
              = X ) )
          & ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 )
              = ( inter_mset @ A @ X @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% subset_mset.Inf_fin.remove
thf(fact_4430_subset__mset_OInf__fin_Oinsert__remove,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
            = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ A4 ) )
            = X ) )
        & ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ A4 ) )
            = ( inter_mset @ A @ X @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ) ) ) ) ) ).

% subset_mset.Inf_fin.insert_remove
thf(fact_4431_subset__mset_OInf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ~ ( member @ ( multiset @ A ) @ X @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ A4 ) )
            = ( inter_mset @ A @ X @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) ) ) ) ) ) ).

% subset_mset.Inf_fin.insert_not_elem
thf(fact_4432_subset__mset_OInf__fin_Oclosed,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ! [X2: multiset @ A,Y3: multiset @ A] : ( member @ ( multiset @ A ) @ ( inter_mset @ A @ X2 @ Y3 ) @ ( insert2 @ ( multiset @ A ) @ X2 @ ( insert2 @ ( multiset @ A ) @ Y3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) )
         => ( member @ ( multiset @ A ) @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) @ A4 ) ) ) ) ).

% subset_mset.Inf_fin.closed
thf(fact_4433_subset__mset_Osup__Inf1__distrib,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( union_mset @ A @ X @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) )
          = ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A )
            @ ( collect @ ( multiset @ A )
              @ ^ [Uu: multiset @ A] :
                ? [A5: multiset @ A] :
                  ( ( Uu
                    = ( union_mset @ A @ X @ A5 ) )
                  & ( member @ ( multiset @ A ) @ A5 @ A4 ) ) ) ) ) ) ) ).

% subset_mset.sup_Inf1_distrib
thf(fact_4434_subset__mset_Osup__Inf2__distrib,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite @ ( multiset @ A ) @ B3 )
         => ( ( B3
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( union_mset @ A @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ B3 ) )
              = ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A )
                @ ( collect @ ( multiset @ A )
                  @ ^ [Uu: multiset @ A] :
                    ? [A5: multiset @ A,B4: multiset @ A] :
                      ( ( Uu
                        = ( union_mset @ A @ A5 @ B4 ) )
                      & ( member @ ( multiset @ A ) @ A5 @ A4 )
                      & ( member @ ( multiset @ A ) @ B4 @ B3 ) ) ) ) ) ) ) ) ) ).

% subset_mset.sup_Inf2_distrib
thf(fact_4435_subset__mset_OInf__fin_Obounded__iff,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( subseteq_mset @ A @ X @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) )
          = ( ! [X3: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ X3 @ A4 )
               => ( subseteq_mset @ A @ X @ X3 ) ) ) ) ) ) ).

% subset_mset.Inf_fin.bounded_iff
thf(fact_4436_subset__mset_OInf__fin_OboundedI,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ! [A8: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ A8 @ A4 )
             => ( subseteq_mset @ A @ X @ A8 ) )
         => ( subseteq_mset @ A @ X @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) ) ) ) ) ).

% subset_mset.Inf_fin.boundedI
thf(fact_4437_subset__mset_Omonoid__axioms,axiom,
    ! [A: $tType] : ( monoid @ ( multiset @ A ) @ ( union_mset @ A ) @ ( zero_zero @ ( multiset @ A ) ) ) ).

% subset_mset.monoid_axioms
thf(fact_4438_subset__mset_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] : ( semilattice_neutr @ ( multiset @ A ) @ ( union_mset @ A ) @ ( zero_zero @ ( multiset @ A ) ) ) ).

% subset_mset.semilattice_neutr_axioms
thf(fact_4439_subset__mset_OcInf__eq__non__empty,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A3: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ! [X2: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X2 @ X5 )
           => ( subseteq_mset @ A @ A3 @ X2 ) )
       => ( ! [Y3: multiset @ A] :
              ( ! [X6: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ X6 @ X5 )
                 => ( subseteq_mset @ A @ Y3 @ X6 ) )
             => ( subseteq_mset @ A @ Y3 @ A3 ) )
         => ( ( complete_Inf_Inf @ ( multiset @ A ) @ X5 )
            = A3 ) ) ) ) ).

% subset_mset.cInf_eq_non_empty
thf(fact_4440_subset__mset_OcInf__greatest,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),Z2: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ! [X2: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X2 @ X5 )
           => ( subseteq_mset @ A @ Z2 @ X2 ) )
       => ( subseteq_mset @ A @ Z2 @ ( complete_Inf_Inf @ ( multiset @ A ) @ X5 ) ) ) ) ).

% subset_mset.cInf_greatest
thf(fact_4441_subset__mset_OcSup__least,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),Z2: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ! [X2: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X2 @ X5 )
           => ( subseteq_mset @ A @ X2 @ Z2 ) )
       => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ X5 ) @ Z2 ) ) ) ).

% subset_mset.cSup_least
thf(fact_4442_subset__mset_OcSup__eq__non__empty,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A3: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ! [X2: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X2 @ X5 )
           => ( subseteq_mset @ A @ X2 @ A3 ) )
       => ( ! [Y3: multiset @ A] :
              ( ! [X6: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ X6 @ X5 )
                 => ( subseteq_mset @ A @ X6 @ Y3 ) )
             => ( subseteq_mset @ A @ A3 @ Y3 ) )
         => ( ( complete_Sup_Sup @ ( multiset @ A ) @ X5 )
            = A3 ) ) ) ) ).

% subset_mset.cSup_eq_non_empty
thf(fact_4443_subset__mset_Ofinite__has__minimal,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ? [X2: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X2 @ A4 )
            & ! [Xa2: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ Xa2 @ A4 )
               => ( ( subseteq_mset @ A @ Xa2 @ X2 )
                 => ( X2 = Xa2 ) ) ) ) ) ) ).

% subset_mset.finite_has_minimal
thf(fact_4444_subset__mset_Ofinite__has__maximal,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ? [X2: multiset @ A] :
            ( ( member @ ( multiset @ A ) @ X2 @ A4 )
            & ! [Xa2: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ Xa2 @ A4 )
               => ( ( subseteq_mset @ A @ X2 @ Xa2 )
                 => ( X2 = Xa2 ) ) ) ) ) ) ).

% subset_mset.finite_has_maximal
thf(fact_4445_subset__mset_OcINF__greatest,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,M4: multiset @ A,F: B > ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ! [X2: B] :
            ( ( member @ B @ X2 @ A4 )
           => ( subseteq_mset @ A @ M4 @ ( F @ X2 ) ) )
       => ( subseteq_mset @ A @ M4 @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) ) ) ) ).

% subset_mset.cINF_greatest
thf(fact_4446_subset__mset_OcSUP__least,axiom,
    ! [B: $tType,A: $tType,A4: set @ B,F: B > ( multiset @ A ),M: multiset @ A] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ! [X2: B] :
            ( ( member @ B @ X2 @ A4 )
           => ( subseteq_mset @ A @ ( F @ X2 ) @ M ) )
       => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) @ M ) ) ) ).

% subset_mset.cSUP_least
thf(fact_4447_subset__mset_OInf__fin_Osubset__imp,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ A4 @ B3 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite @ ( multiset @ A ) @ B3 )
         => ( subseteq_mset @ A @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ B3 ) @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) ) ) ) ) ).

% subset_mset.Inf_fin.subset_imp
thf(fact_4448_subset__mset_OInf__fin_OboundedE,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( subseteq_mset @ A @ X @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) )
         => ! [A14: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ A14 @ A4 )
             => ( subseteq_mset @ A @ X @ A14 ) ) ) ) ) ).

% subset_mset.Inf_fin.boundedE
thf(fact_4449_subset__mset_OInf__fin__le__Sup__fin,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( subseteq_mset @ A @ ( lattic8678736583308907530nf_fin @ ( multiset @ A ) @ ( inter_mset @ A ) @ A4 ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) ) ) ) ).

% subset_mset.Inf_fin_le_Sup_fin
thf(fact_4450_subset__mset_OSup__fin_Oinsert__remove,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
            = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ A4 ) )
            = X ) )
        & ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ A4 ) )
            = ( union_mset @ A @ X @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ) ) ) ) ) ).

% subset_mset.Sup_fin.insert_remove
thf(fact_4451_subset__mset_OSup__fin_Oremove,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( member @ ( multiset @ A ) @ X @ A4 )
       => ( ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
              = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 )
              = X ) )
          & ( ( ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 )
              = ( union_mset @ A @ X @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( minus_minus @ ( set @ ( multiset @ A ) ) @ A4 @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% subset_mset.Sup_fin.remove
thf(fact_4452_subset__mset_Oinf__Sup2__distrib,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite @ ( multiset @ A ) @ B3 )
         => ( ( B3
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( inter_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ B3 ) )
              = ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A )
                @ ( collect @ ( multiset @ A )
                  @ ^ [Uu: multiset @ A] :
                    ? [A5: multiset @ A,B4: multiset @ A] :
                      ( ( Uu
                        = ( inter_mset @ A @ A5 @ B4 ) )
                      & ( member @ ( multiset @ A ) @ A5 @ A4 )
                      & ( member @ ( multiset @ A ) @ B4 @ B3 ) ) ) ) ) ) ) ) ) ).

% subset_mset.inf_Sup2_distrib
thf(fact_4453_subset__mset_OSup__fin_Osingleton,axiom,
    ! [A: $tType,X: multiset @ A] :
      ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
      = X ) ).

% subset_mset.Sup_fin.singleton
thf(fact_4454_subset__mset_OSup__fin_Oinsert,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ A4 ) )
          = ( union_mset @ A @ X @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) ) ) ) ) ).

% subset_mset.Sup_fin.insert
thf(fact_4455_subset__mset_OSup__fin_Obounded__iff,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( subseteq_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) @ X )
          = ( ! [X3: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ X3 @ A4 )
               => ( subseteq_mset @ A @ X3 @ X ) ) ) ) ) ) ).

% subset_mset.Sup_fin.bounded_iff
thf(fact_4456_subset__mset_OSup__fin_OboundedI,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ! [A8: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ A8 @ A4 )
             => ( subseteq_mset @ A @ A8 @ X ) )
         => ( subseteq_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) @ X ) ) ) ) ).

% subset_mset.Sup_fin.boundedI
thf(fact_4457_subset__mset_OSup__fin_OboundedE,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( subseteq_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) @ X )
         => ! [A14: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ A14 @ A4 )
             => ( subseteq_mset @ A @ A14 @ X ) ) ) ) ) ).

% subset_mset.Sup_fin.boundedE
thf(fact_4458_subset__mset_OcSup__eq__Sup__fin,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ X5 )
     => ( ( X5
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( complete_Sup_Sup @ ( multiset @ A ) @ X5 )
          = ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ X5 ) ) ) ) ).

% subset_mset.cSup_eq_Sup_fin
thf(fact_4459_subset__mset_OSup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ~ ( member @ ( multiset @ A ) @ X @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( insert2 @ ( multiset @ A ) @ X @ A4 ) )
            = ( union_mset @ A @ X @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) ) ) ) ) ) ).

% subset_mset.Sup_fin.insert_not_elem
thf(fact_4460_subset__mset_OSup__fin_Oclosed,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ! [X2: multiset @ A,Y3: multiset @ A] : ( member @ ( multiset @ A ) @ ( union_mset @ A @ X2 @ Y3 ) @ ( insert2 @ ( multiset @ A ) @ X2 @ ( insert2 @ ( multiset @ A ) @ Y3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) )
         => ( member @ ( multiset @ A ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) @ A4 ) ) ) ) ).

% subset_mset.Sup_fin.closed
thf(fact_4461_subset__mset_OSup__fin_Osubset,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( B3
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ B3 @ A4 )
         => ( ( union_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ B3 ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) )
            = ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) ) ) ) ) ).

% subset_mset.Sup_fin.subset
thf(fact_4462_subset__mset_OSup__fin_Ounion,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite @ ( multiset @ A ) @ B3 )
         => ( ( B3
             != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
           => ( ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( sup_sup @ ( set @ ( multiset @ A ) ) @ A4 @ B3 ) )
              = ( union_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ B3 ) ) ) ) ) ) ) ).

% subset_mset.Sup_fin.union
thf(fact_4463_subset__mset_OSup__fin_Ohom__commute,axiom,
    ! [A: $tType,H2: ( multiset @ A ) > ( multiset @ A ),N4: set @ ( multiset @ A )] :
      ( ! [X2: multiset @ A,Y3: multiset @ A] :
          ( ( H2 @ ( union_mset @ A @ X2 @ Y3 ) )
          = ( union_mset @ A @ ( H2 @ X2 ) @ ( H2 @ Y3 ) ) )
     => ( ( finite_finite @ ( multiset @ A ) @ N4 )
       => ( ( N4
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( H2 @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ N4 ) )
            = ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ ( image2 @ ( multiset @ A ) @ ( multiset @ A ) @ H2 @ N4 ) ) ) ) ) ) ).

% subset_mset.Sup_fin.hom_commute
thf(fact_4464_subset__mset_OSup__fin_Osubset__imp,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ A4 @ B3 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( finite_finite @ ( multiset @ A ) @ B3 )
         => ( subseteq_mset @ A @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ B3 ) ) ) ) ) ).

% subset_mset.Sup_fin.subset_imp
thf(fact_4465_subset__mset_Oinf__Sup1__distrib,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: multiset @ A] :
      ( ( finite_finite @ ( multiset @ A ) @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
       => ( ( inter_mset @ A @ X @ ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A ) @ A4 ) )
          = ( lattic4630905495605216202up_fin @ ( multiset @ A ) @ ( union_mset @ A )
            @ ( collect @ ( multiset @ A )
              @ ^ [Uu: multiset @ A] :
                ? [A5: multiset @ A] :
                  ( ( Uu
                    = ( inter_mset @ A @ X @ A5 ) )
                  & ( member @ ( multiset @ A ) @ A5 @ A4 ) ) ) ) ) ) ) ).

% subset_mset.inf_Sup1_distrib
thf(fact_4466_subset__mset_Omono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ! [F: ( multiset @ A ) > B,A4: multiset @ A,B3: multiset @ A] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F @ A4 ) @ ( F @ B3 ) ) @ ( F @ ( union_mset @ A @ A4 @ B3 ) ) ) ) ) ).

% subset_mset.mono_sup
thf(fact_4467_subset__mset_Omono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ! [F: ( multiset @ A ) > B,A4: multiset @ A,B3: multiset @ A] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F )
         => ( ord_less_eq @ B @ ( F @ ( inter_mset @ A @ A4 @ B3 ) ) @ ( inf_inf @ B @ ( F @ A4 ) @ ( F @ B3 ) ) ) ) ) ).

% subset_mset.mono_inf
thf(fact_4468_subset__mset_OcINF__union,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,F: B > ( multiset @ A ),B3: set @ B] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) )
       => ( ( B3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ B3 ) )
           => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) )
              = ( inter_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ B3 ) ) ) ) ) ) ) ) ).

% subset_mset.cINF_union
thf(fact_4469_subset__mset_OcINF__insert,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,F: B > ( multiset @ A ),A3: B] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) )
       => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ ( insert2 @ B @ A3 @ A4 ) ) )
          = ( inter_mset @ A @ ( F @ A3 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) ) ) ) ) ).

% subset_mset.cINF_insert
thf(fact_4470_subset__mset_Obdd__below__empty,axiom,
    ! [A: $tType] : ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ).

% subset_mset.bdd_below_empty
thf(fact_4471_order_Omono_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ( ( mono @ A @ B )
        = ( mono @ A @ B ) ) ) ).

% order.mono.cong
thf(fact_4472_subset__mset_Obdd__below__Int2,axiom,
    ! [A: $tType,B3: set @ ( multiset @ A ),A4: set @ ( multiset @ A )] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B3 )
     => ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A4 @ B3 ) ) ) ).

% subset_mset.bdd_below_Int2
thf(fact_4473_subset__mset_Obdd__below__Int1,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
     => ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A4 @ B3 ) ) ) ).

% subset_mset.bdd_below_Int1
thf(fact_4474_subset__mset_OcInf__mono,axiom,
    ! [A: $tType,B3: set @ ( multiset @ A ),A4: set @ ( multiset @ A )] :
      ( ( B3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
       => ( ! [B6: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ B6 @ B3 )
             => ? [X6: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ X6 @ A4 )
                  & ( subseteq_mset @ A @ X6 @ B6 ) ) )
         => ( subseteq_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A4 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ B3 ) ) ) ) ) ).

% subset_mset.cInf_mono
thf(fact_4475_subset__mset_Ole__cInf__iff,axiom,
    ! [A: $tType,S2: set @ ( multiset @ A ),A3: multiset @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ S2 )
       => ( ( subseteq_mset @ A @ A3 @ ( complete_Inf_Inf @ ( multiset @ A ) @ S2 ) )
          = ( ! [X3: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ X3 @ S2 )
               => ( subseteq_mset @ A @ A3 @ X3 ) ) ) ) ) ) ).

% subset_mset.le_cInf_iff
thf(fact_4476_subset__mset_Omono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F: ( multiset @ A ) > B,A4: set @ ( multiset @ A )] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F )
         => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
             => ( ord_less_eq @ B @ ( F @ ( complete_Inf_Inf @ ( multiset @ A ) @ A4 ) ) @ ( complete_Inf_Inf @ B @ ( image2 @ ( multiset @ A ) @ B @ F @ A4 ) ) ) ) ) ) ) ).

% subset_mset.mono_cInf
thf(fact_4477_subset__mset_Ole__cINF__iff,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,F: B > ( multiset @ A ),U: multiset @ A] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) )
       => ( ( subseteq_mset @ A @ U @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) )
          = ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( subseteq_mset @ A @ U @ ( F @ X3 ) ) ) ) ) ) ) ).

% subset_mset.le_cINF_iff
thf(fact_4478_subset__mset_OcINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType,B3: set @ B,F: C > ( multiset @ A ),A4: set @ C,G: B > ( multiset @ A )] :
      ( ( B3
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ F @ A4 ) )
       => ( ! [M5: B] :
              ( ( member @ B @ M5 @ B3 )
             => ? [X6: C] :
                  ( ( member @ C @ X6 @ A4 )
                  & ( subseteq_mset @ A @ ( F @ X6 ) @ ( G @ M5 ) ) ) )
         => ( subseteq_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ F @ A4 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ B3 ) ) ) ) ) ) ).

% subset_mset.cINF_mono
thf(fact_4479_subset__mset_Oless__eq__cInf__inter,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B3 )
       => ( ( ( inf_inf @ ( set @ ( multiset @ A ) ) @ A4 @ B3 )
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( subseteq_mset @ A @ ( inter_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A4 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ B3 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A4 @ B3 ) ) ) ) ) ) ).

% subset_mset.less_eq_cInf_inter
thf(fact_4480_subset__mset_Omono__cINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F: ( multiset @ A ) > B,A4: C > ( multiset @ A ),I4: set @ C] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F )
         => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ A4 @ I4 ) )
           => ( ( I4
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B @ ( F @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ A4 @ I4 ) ) )
                @ ( complete_Inf_Inf @ B
                  @ ( image2 @ C @ B
                    @ ^ [X3: C] : ( F @ ( A4 @ X3 ) )
                    @ I4 ) ) ) ) ) ) ) ).

% subset_mset.mono_cINF
thf(fact_4481_subset__mset_OcInf__superset__mono,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B3 )
       => ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ A4 @ B3 )
         => ( subseteq_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ B3 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ A4 ) ) ) ) ) ).

% subset_mset.cInf_superset_mono
thf(fact_4482_subset__mset_OcInf__cSup,axiom,
    ! [A: $tType,S2: set @ ( multiset @ A )] :
      ( ( S2
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ S2 )
       => ( ( complete_Inf_Inf @ ( multiset @ A ) @ S2 )
          = ( complete_Sup_Sup @ ( multiset @ A )
            @ ( collect @ ( multiset @ A )
              @ ^ [X3: multiset @ A] :
                ! [Y2: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ Y2 @ S2 )
                 => ( subseteq_mset @ A @ X3 @ Y2 ) ) ) ) ) ) ) ).

% subset_mset.cInf_cSup
thf(fact_4483_subset__mset_OcINF__superset__mono,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,G: B > ( multiset @ A ),B3: set @ B,F: B > ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ B3 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B3 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ B3 )
               => ( subseteq_mset @ A @ ( G @ X2 ) @ ( F @ X2 ) ) )
           => ( subseteq_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ B3 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) ) ) ) ) ) ).

% subset_mset.cINF_superset_mono
thf(fact_4484_subset__mset_OcInf__insert__If,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A3: multiset @ A] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ X5 )
     => ( ( ( X5
            = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( insert2 @ ( multiset @ A ) @ A3 @ X5 ) )
            = A3 ) )
        & ( ( X5
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( insert2 @ ( multiset @ A ) @ A3 @ X5 ) )
            = ( inter_mset @ A @ A3 @ ( complete_Inf_Inf @ ( multiset @ A ) @ X5 ) ) ) ) ) ) ).

% subset_mset.cInf_insert_If
thf(fact_4485_subset__mset_OcInf__insert,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A3: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ X5 )
       => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( insert2 @ ( multiset @ A ) @ A3 @ X5 ) )
          = ( inter_mset @ A @ A3 @ ( complete_Inf_Inf @ ( multiset @ A ) @ X5 ) ) ) ) ) ).

% subset_mset.cInf_insert
thf(fact_4486_subset__mset_OcINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,F: B > ( multiset @ A ),G: B > ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) )
       => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ A4 ) )
         => ( ( inter_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ A4 ) ) )
            = ( complete_Inf_Inf @ ( multiset @ A )
              @ ( image2 @ B @ ( multiset @ A )
                @ ^ [A5: B] : ( inter_mset @ A @ ( F @ A5 ) @ ( G @ A5 ) )
                @ A4 ) ) ) ) ) ) ).

% subset_mset.cINF_inf_distrib
thf(fact_4487_subset__mset_OcInf__union__distrib,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
       => ( ( B3
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B3 )
           => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( sup_sup @ ( set @ ( multiset @ A ) ) @ A4 @ B3 ) )
              = ( inter_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A4 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ B3 ) ) ) ) ) ) ) ).

% subset_mset.cInf_union_distrib
thf(fact_4488_subset__mset_Omono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F: ( multiset @ A ) > B,A4: C > ( multiset @ A ),I4: set @ C] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F )
         => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ A4 @ I4 ) )
           => ( ( I4
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B
                @ ( complete_Sup_Sup @ B
                  @ ( image2 @ C @ B
                    @ ^ [X3: C] : ( F @ ( A4 @ X3 ) )
                    @ I4 ) )
                @ ( F @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ A4 @ I4 ) ) ) ) ) ) ) ) ).

% subset_mset.mono_cSUP
thf(fact_4489_subset__mset_Omono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F: ( multiset @ A ) > B,A4: set @ ( multiset @ A )] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F )
         => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
             => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image2 @ ( multiset @ A ) @ B @ F @ A4 ) ) @ ( F @ ( complete_Sup_Sup @ ( multiset @ A ) @ A4 ) ) ) ) ) ) ) ).

% subset_mset.mono_cSup
thf(fact_4490_subset__mset_OcSUP__union,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,F: B > ( multiset @ A ),B3: set @ B] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) )
       => ( ( B3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ B3 ) )
           => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) )
              = ( union_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ B3 ) ) ) ) ) ) ) ) ).

% subset_mset.cSUP_union
thf(fact_4491_subset__mset_OcSUP__insert,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,F: B > ( multiset @ A ),A3: B] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) )
       => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ ( insert2 @ B @ A3 @ A4 ) ) )
          = ( union_mset @ A @ ( F @ A3 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) ) ) ) ) ).

% subset_mset.cSUP_insert
thf(fact_4492_subset__mset_Obdd__above__empty,axiom,
    ! [A: $tType] : ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ).

% subset_mset.bdd_above_empty
thf(fact_4493_subset__mset_Obdd__above__Int1,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
     => ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A4 @ B3 ) ) ) ).

% subset_mset.bdd_above_Int1
thf(fact_4494_subset__mset_Obdd__above__Int2,axiom,
    ! [A: $tType,B3: set @ ( multiset @ A ),A4: set @ ( multiset @ A )] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B3 )
     => ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A4 @ B3 ) ) ) ).

% subset_mset.bdd_above_Int2
thf(fact_4495_subset__mset_OcSup__le__iff,axiom,
    ! [A: $tType,S2: set @ ( multiset @ A ),A3: multiset @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ S2 )
       => ( ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ S2 ) @ A3 )
          = ( ! [X3: multiset @ A] :
                ( ( member @ ( multiset @ A ) @ X3 @ S2 )
               => ( subseteq_mset @ A @ X3 @ A3 ) ) ) ) ) ) ).

% subset_mset.cSup_le_iff
thf(fact_4496_subset__mset_OcSup__mono,axiom,
    ! [A: $tType,B3: set @ ( multiset @ A ),A4: set @ ( multiset @ A )] :
      ( ( B3
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
       => ( ! [B6: multiset @ A] :
              ( ( member @ ( multiset @ A ) @ B6 @ B3 )
             => ? [X6: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ X6 @ A4 )
                  & ( subseteq_mset @ A @ B6 @ X6 ) ) )
         => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ B3 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ A4 ) ) ) ) ) ).

% subset_mset.cSup_mono
thf(fact_4497_subset__mset_OcSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType,A4: set @ B,G: C > ( multiset @ A ),B3: set @ C,F: B > ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ G @ B3 ) )
       => ( ! [N3: B] :
              ( ( member @ B @ N3 @ A4 )
             => ? [X6: C] :
                  ( ( member @ C @ X6 @ B3 )
                  & ( subseteq_mset @ A @ ( F @ N3 ) @ ( G @ X6 ) ) ) )
         => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ C @ ( multiset @ A ) @ G @ B3 ) ) ) ) ) ) ).

% subset_mset.cSUP_mono
thf(fact_4498_subset__mset_OcSUP__le__iff,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,F: B > ( multiset @ A ),U: multiset @ A] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) )
       => ( ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) @ U )
          = ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( subseteq_mset @ A @ ( F @ X3 ) @ U ) ) ) ) ) ) ).

% subset_mset.cSUP_le_iff
thf(fact_4499_subset__mset_OcSup__inter__less__eq,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B3 )
       => ( ( ( inf_inf @ ( set @ ( multiset @ A ) ) @ A4 @ B3 )
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A4 @ B3 ) ) @ ( union_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ A4 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ B3 ) ) ) ) ) ) ).

% subset_mset.cSup_inter_less_eq
thf(fact_4500_subset__mset_OcSup__subset__mono,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B3 )
       => ( ( ord_less_eq @ ( set @ ( multiset @ A ) ) @ A4 @ B3 )
         => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ A4 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ B3 ) ) ) ) ) ).

% subset_mset.cSup_subset_mono
thf(fact_4501_subset__mset_OcSup__cInf,axiom,
    ! [A: $tType,S2: set @ ( multiset @ A )] :
      ( ( S2
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ S2 )
       => ( ( complete_Sup_Sup @ ( multiset @ A ) @ S2 )
          = ( complete_Inf_Inf @ ( multiset @ A )
            @ ( collect @ ( multiset @ A )
              @ ^ [X3: multiset @ A] :
                ! [Y2: multiset @ A] :
                  ( ( member @ ( multiset @ A ) @ Y2 @ S2 )
                 => ( subseteq_mset @ A @ Y2 @ X3 ) ) ) ) ) ) ) ).

% subset_mset.cSup_cInf
thf(fact_4502_subset__mset_OcSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,G: B > ( multiset @ A ),B3: set @ B,F: B > ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ B3 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B3 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ A4 )
               => ( subseteq_mset @ A @ ( F @ X2 ) @ ( G @ X2 ) ) )
           => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ B3 ) ) ) ) ) ) ) ).

% subset_mset.cSUP_subset_mono
thf(fact_4503_subset__mset_OcSup__insert,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A3: multiset @ A] :
      ( ( X5
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ X5 )
       => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( insert2 @ ( multiset @ A ) @ A3 @ X5 ) )
          = ( union_mset @ A @ A3 @ ( complete_Sup_Sup @ ( multiset @ A ) @ X5 ) ) ) ) ) ).

% subset_mset.cSup_insert
thf(fact_4504_subset__mset_OcSup__insert__If,axiom,
    ! [A: $tType,X5: set @ ( multiset @ A ),A3: multiset @ A] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ X5 )
     => ( ( ( X5
            = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( insert2 @ ( multiset @ A ) @ A3 @ X5 ) )
            = A3 ) )
        & ( ( X5
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( insert2 @ ( multiset @ A ) @ A3 @ X5 ) )
            = ( union_mset @ A @ A3 @ ( complete_Sup_Sup @ ( multiset @ A ) @ X5 ) ) ) ) ) ) ).

% subset_mset.cSup_insert_If
thf(fact_4505_subset__mset_OcInf__le__cSup,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
       => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
         => ( subseteq_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A4 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ A4 ) ) ) ) ) ).

% subset_mset.cInf_le_cSup
thf(fact_4506_subset__mset_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,F: B > ( multiset @ A ),G: B > ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ B ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) )
       => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ A4 ) )
         => ( ( union_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ F @ A4 ) ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( image2 @ B @ ( multiset @ A ) @ G @ A4 ) ) )
            = ( complete_Sup_Sup @ ( multiset @ A )
              @ ( image2 @ B @ ( multiset @ A )
                @ ^ [A5: B] : ( union_mset @ A @ ( F @ A5 ) @ ( G @ A5 ) )
                @ A4 ) ) ) ) ) ) ).

% subset_mset.SUP_sup_distrib
thf(fact_4507_subset__mset_OcSup__union__distrib,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),B3: set @ ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
       => ( ( B3
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B3 )
           => ( ( complete_Sup_Sup @ ( multiset @ A ) @ ( sup_sup @ ( set @ ( multiset @ A ) ) @ A4 @ B3 ) )
              = ( union_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ A4 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ B3 ) ) ) ) ) ) ) ).

% subset_mset.cSup_union_distrib
thf(fact_4508_bdd__above__multiset__imp__finite__support,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
       => ( finite_finite @ A
          @ ( complete_Sup_Sup @ ( set @ A )
            @ ( image2 @ ( multiset @ A ) @ ( set @ A )
              @ ^ [X8: multiset @ A] :
                  ( collect @ A
                  @ ^ [X3: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( count @ A @ X8 @ X3 ) ) )
              @ A4 ) ) ) ) ) ).

% bdd_above_multiset_imp_finite_support
thf(fact_4509_Sup__multiset__in__multiset,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
       => ( finite_finite @ A
          @ ( collect @ A
            @ ^ [I2: A] :
                ( ord_less @ nat @ ( zero_zero @ nat )
                @ ( complete_Sup_Sup @ nat
                  @ ( image2 @ ( multiset @ A ) @ nat
                    @ ^ [M7: multiset @ A] : ( count @ A @ M7 @ I2 )
                    @ A4 ) ) ) ) ) ) ) ).

% Sup_multiset_in_multiset
thf(fact_4510_count__Sup__multiset__nonempty,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: A] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A4 )
       => ( ( count @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ A4 ) @ X )
          = ( complete_Sup_Sup @ nat
            @ ( image2 @ ( multiset @ A ) @ nat
              @ ^ [X8: multiset @ A] : ( count @ A @ X8 @ X )
              @ A4 ) ) ) ) ) ).

% count_Sup_multiset_nonempty
thf(fact_4511_subset__mset_OatLeastAtMost__singleton__iff,axiom,
    ! [A: $tType,A3: multiset @ A,B2: multiset @ A,C2: multiset @ A] :
      ( ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 @ B2 )
        = ( insert2 @ ( multiset @ A ) @ C2 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
      = ( ( A3 = B2 )
        & ( B2 = C2 ) ) ) ).

% subset_mset.atLeastAtMost_singleton_iff
thf(fact_4512_subset__mset_OatLeastatMost__empty__iff,axiom,
    ! [A: $tType,A3: multiset @ A,B2: multiset @ A] :
      ( ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
      = ( ~ ( subseteq_mset @ A @ A3 @ B2 ) ) ) ).

% subset_mset.atLeastatMost_empty_iff
thf(fact_4513_subset__mset_OatLeastatMost__empty__iff2,axiom,
    ! [A: $tType,A3: multiset @ A,B2: multiset @ A] :
      ( ( ( bot_bot @ ( set @ ( multiset @ A ) ) )
        = ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 @ B2 ) )
      = ( ~ ( subseteq_mset @ A @ A3 @ B2 ) ) ) ).

% subset_mset.atLeastatMost_empty_iff2
thf(fact_4514_subset__mset_OatLeastAtMost__singleton,axiom,
    ! [A: $tType,A3: multiset @ A] :
      ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 @ A3 )
      = ( insert2 @ ( multiset @ A ) @ A3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ).

% subset_mset.atLeastAtMost_singleton
thf(fact_4515_Inf__multiset_Orep__eq,axiom,
    ! [A: $tType,X: set @ ( multiset @ A )] :
      ( ( count @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ X ) )
      = ( ^ [I2: A] :
            ( if @ nat
            @ ( ( image2 @ ( multiset @ A ) @ ( A > nat ) @ ( count @ A ) @ X )
              = ( bot_bot @ ( set @ ( A > nat ) ) ) )
            @ ( zero_zero @ nat )
            @ ( complete_Inf_Inf @ nat
              @ ( image2 @ ( A > nat ) @ nat
                @ ^ [F2: A > nat] : ( F2 @ I2 )
                @ ( image2 @ ( multiset @ A ) @ ( A > nat ) @ ( count @ A ) @ X ) ) ) ) ) ) ).

% Inf_multiset.rep_eq
thf(fact_4516_count__Inf__multiset__nonempty,axiom,
    ! [A: $tType,A4: set @ ( multiset @ A ),X: A] :
      ( ( A4
       != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
     => ( ( count @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A4 ) @ X )
        = ( complete_Inf_Inf @ nat
          @ ( image2 @ ( multiset @ A ) @ nat
            @ ^ [X8: multiset @ A] : ( count @ A @ X8 @ X )
            @ A4 ) ) ) ) ).

% count_Inf_multiset_nonempty
thf(fact_4517_subset__mset_OatLeastAtMost__singleton_H,axiom,
    ! [A: $tType,A3: multiset @ A,B2: multiset @ A] :
      ( ( A3 = B2 )
     => ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 @ B2 )
        = ( insert2 @ ( multiset @ A ) @ A3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ).

% subset_mset.atLeastAtMost_singleton'
thf(fact_4518_Sup__multiset__def,axiom,
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( multiset @ A ) )
      = ( ^ [A10: set @ ( multiset @ A )] :
            ( if @ ( multiset @ A )
            @ ( ( A10
               != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
              & ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A10 ) )
            @ ( abs_multiset @ A
              @ ^ [I2: A] :
                  ( complete_Sup_Sup @ nat
                  @ ( image2 @ ( multiset @ A ) @ nat
                    @ ^ [X8: multiset @ A] : ( count @ A @ X8 @ I2 )
                    @ A10 ) ) )
            @ ( zero_zero @ ( multiset @ A ) ) ) ) ) ).

% Sup_multiset_def
thf(fact_4519_count__image__mset,axiom,
    ! [A: $tType,B: $tType,F: B > A,A4: multiset @ B,X: A] :
      ( ( count @ A @ ( image_mset @ B @ A @ F @ A4 ) @ X )
      = ( groups7311177749621191930dd_sum @ B @ nat @ ( count @ B @ A4 ) @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ F @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( set_mset @ B @ A4 ) ) ) ) ).

% count_image_mset
thf(fact_4520_Inf__multiset__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( multiset @ A ) )
      = ( map_fun @ ( set @ ( multiset @ A ) ) @ ( set @ ( A > nat ) ) @ ( A > nat ) @ ( multiset @ A ) @ ( image2 @ ( multiset @ A ) @ ( A > nat ) @ ( count @ A ) ) @ ( abs_multiset @ A )
        @ ^ [A10: set @ ( A > nat ),I2: A] :
            ( if @ nat
            @ ( A10
              = ( bot_bot @ ( set @ ( A > nat ) ) ) )
            @ ( zero_zero @ nat )
            @ ( complete_Inf_Inf @ nat
              @ ( image2 @ ( A > nat ) @ nat
                @ ^ [F2: A > nat] : ( F2 @ I2 )
                @ A10 ) ) ) ) ) ).

% Inf_multiset_def
thf(fact_4521_prod__mset_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: multiset @ B,B3: multiset @ B,G: B > A] :
          ( ( ( inter_mset @ B @ A4 @ B3 )
            = ( zero_zero @ ( multiset @ B ) ) )
         => ( ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ ( union_mset @ B @ A4 @ B3 ) ) )
            = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ A4 ) ) @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod_mset.union_disjoint
thf(fact_4522_prod__mset_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [Uu: B] : ( one_one @ A )
              @ A4 ) )
          = ( one_one @ A ) ) ) ).

% prod_mset.neutral_const
thf(fact_4523_prod__mset_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,X: B,A4: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ ( add_mset @ B @ X @ A4 ) ) )
          = ( times_times @ A @ ( G @ X ) @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ A4 ) ) ) ) ) ).

% prod_mset.insert
thf(fact_4524_multiset_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F: A > B,V: multiset @ A] :
      ( ( image_mset @ B @ C @ G @ ( image_mset @ A @ B @ F @ V ) )
      = ( image_mset @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) ).

% multiset.map_comp
thf(fact_4525_image__mset_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: B > C,G: A > B,Multiset: multiset @ A] :
      ( ( image_mset @ B @ C @ F @ ( image_mset @ A @ B @ G @ Multiset ) )
      = ( image_mset @ A @ C @ ( comp @ B @ C @ A @ F @ G ) @ Multiset ) ) ).

% image_mset.compositionality
thf(fact_4526_prod__mset_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A4: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( G @ X3 ) @ ( H2 @ X3 ) )
              @ A4 ) )
          = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ A4 ) ) @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ H2 @ A4 ) ) ) ) ) ).

% prod_mset.distrib
thf(fact_4527_image__mset_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: B > C,G: A > B] :
      ( ( comp @ ( multiset @ B ) @ ( multiset @ C ) @ ( multiset @ A ) @ ( image_mset @ B @ C @ F ) @ ( image_mset @ A @ B @ G ) )
      = ( image_mset @ A @ C @ ( comp @ B @ C @ A @ F @ G ) ) ) ).

% image_mset.comp
thf(fact_4528_image__mset__cong__pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,M: multiset @ ( product_prod @ A @ B ),F: A > B > C,G: A > B > C] :
      ( ! [X2: A,Y3: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ ( set_mset @ ( product_prod @ A @ B ) @ M ) )
         => ( ( F @ X2 @ Y3 )
            = ( G @ X2 @ Y3 ) ) )
     => ( ( image_mset @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ F ) @ M )
        = ( image_mset @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ G ) @ M ) ) ) ).

% image_mset_cong_pair
thf(fact_4529_image__mset__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( image_mset @ A @ B )
      = ( ^ [F2: A > B] : ( fold_mset @ A @ ( multiset @ B ) @ ( comp @ B @ ( ( multiset @ B ) > ( multiset @ B ) ) @ A @ ( add_mset @ B ) @ F2 ) @ ( zero_zero @ ( multiset @ B ) ) ) ) ) ).

% image_mset_def
thf(fact_4530_prod__mset__delta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: B,C2: A,A4: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( Y = X3 ) @ C2 @ ( one_one @ A ) )
              @ A4 ) )
          = ( power_power @ A @ C2 @ ( count @ B @ A4 @ Y ) ) ) ) ).

% prod_mset_delta'
thf(fact_4531_prod__mset__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: B,C2: A,A4: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( X3 = Y ) @ C2 @ ( one_one @ A ) )
              @ A4 ) )
          = ( power_power @ A @ C2 @ ( count @ B @ A4 @ Y ) ) ) ) ).

% prod_mset_delta
thf(fact_4532_sum__mset__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: B,C2: A,A4: multiset @ B] :
          ( ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( X3 = Y ) @ C2 @ ( zero_zero @ A ) )
              @ A4 ) )
          = ( times_times @ A @ C2 @ ( semiring_1_of_nat @ A @ ( count @ B @ A4 @ Y ) ) ) ) ) ).

% sum_mset_delta
thf(fact_4533_sum__mset__delta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: B,C2: A,A4: multiset @ B] :
          ( ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( Y = X3 ) @ C2 @ ( zero_zero @ A ) )
              @ A4 ) )
          = ( times_times @ A @ C2 @ ( semiring_1_of_nat @ A @ ( count @ B @ A4 @ Y ) ) ) ) ) ).

% sum_mset_delta'
thf(fact_4534_inv__o__cancel,axiom,
    ! [B: $tType,A: $tType,F: A > B] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( ( comp @ B @ A @ A @ ( hilbert_inv_into @ A @ B @ ( top_top @ ( set @ A ) ) @ F ) @ F )
        = ( id @ A ) ) ) ).

% inv_o_cancel
thf(fact_4535_prod__filter__INF,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,I4: set @ A,J4: set @ B,A4: A > ( filter @ C ),B3: B > ( filter @ D )] :
      ( ( I4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( J4
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( prod_filter @ C @ D @ ( complete_Inf_Inf @ ( filter @ C ) @ ( image2 @ A @ ( filter @ C ) @ A4 @ I4 ) ) @ ( complete_Inf_Inf @ ( filter @ D ) @ ( image2 @ B @ ( filter @ D ) @ B3 @ J4 ) ) )
          = ( complete_Inf_Inf @ ( filter @ ( product_prod @ C @ D ) )
            @ ( image2 @ A @ ( filter @ ( product_prod @ C @ D ) )
              @ ^ [I2: A] :
                  ( complete_Inf_Inf @ ( filter @ ( product_prod @ C @ D ) )
                  @ ( image2 @ B @ ( filter @ ( product_prod @ C @ D ) )
                    @ ^ [J: B] : ( prod_filter @ C @ D @ ( A4 @ I2 ) @ ( B3 @ J ) )
                    @ J4 ) )
              @ I4 ) ) ) ) ) ).

% prod_filter_INF
thf(fact_4536_o__inv__o__cancel,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: A > B,G: A > C] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( ( comp @ B @ C @ A @ ( comp @ A @ C @ B @ G @ ( hilbert_inv_into @ A @ B @ ( top_top @ ( set @ A ) ) @ F ) ) @ F )
        = G ) ) ).

% o_inv_o_cancel
thf(fact_4537_sum__mset__replicate__mset,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,A3: A] :
          ( ( comm_m7189776963980413722m_mset @ A @ ( replicate_mset @ A @ N @ A3 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ A3 ) ) ) ).

% sum_mset_replicate_mset
thf(fact_4538_prod__filter__eq__bot,axiom,
    ! [A: $tType,B: $tType,A4: filter @ A,B3: filter @ B] :
      ( ( ( prod_filter @ A @ B @ A4 @ B3 )
        = ( bot_bot @ ( filter @ ( product_prod @ A @ B ) ) ) )
      = ( ( A4
          = ( bot_bot @ ( filter @ A ) ) )
        | ( B3
          = ( bot_bot @ ( filter @ B ) ) ) ) ) ).

% prod_filter_eq_bot
thf(fact_4539_eventually__prod__same,axiom,
    ! [A: $tType,P: ( product_prod @ A @ A ) > $o,F3: filter @ A] :
      ( ( eventually @ ( product_prod @ A @ A ) @ P @ ( prod_filter @ A @ A @ F3 @ F3 ) )
      = ( ? [Q3: A > $o] :
            ( ( eventually @ A @ Q3 @ F3 )
            & ! [X3: A,Y2: A] :
                ( ( Q3 @ X3 )
               => ( ( Q3 @ Y2 )
                 => ( P @ ( product_Pair @ A @ A @ X3 @ Y2 ) ) ) ) ) ) ) ).

% eventually_prod_same
thf(fact_4540_eventually__prod__filter,axiom,
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ) > $o,F3: filter @ A,G6: filter @ B] :
      ( ( eventually @ ( product_prod @ A @ B ) @ P @ ( prod_filter @ A @ B @ F3 @ G6 ) )
      = ( ? [Pf: A > $o,Pg: B > $o] :
            ( ( eventually @ A @ Pf @ F3 )
            & ( eventually @ B @ Pg @ G6 )
            & ! [X3: A,Y2: B] :
                ( ( Pf @ X3 )
               => ( ( Pg @ Y2 )
                 => ( P @ ( product_Pair @ A @ B @ X3 @ Y2 ) ) ) ) ) ) ) ).

% eventually_prod_filter
thf(fact_4541_sum__mset__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( times @ A )
        & ( semiring_0 @ B ) )
     => ! [F: A > B,A4: multiset @ A,G: C > B,B3: multiset @ C] :
          ( ( times_times @ B @ ( comm_m7189776963980413722m_mset @ B @ ( image_mset @ A @ B @ F @ A4 ) ) @ ( comm_m7189776963980413722m_mset @ B @ ( image_mset @ C @ B @ G @ B3 ) ) )
          = ( comm_m7189776963980413722m_mset @ B
            @ ( image_mset @ A @ B
              @ ^ [I2: A] :
                  ( comm_m7189776963980413722m_mset @ B
                  @ ( image_mset @ C @ B
                    @ ^ [J: C] : ( times_times @ B @ ( F @ I2 ) @ ( G @ J ) )
                    @ B3 ) )
              @ A4 ) ) ) ) ).

% sum_mset_product
thf(fact_4542_sum__mset__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F: B > A,M: multiset @ B,C2: A] :
          ( ( times_times @ A @ ( comm_m7189776963980413722m_mset @ A @ ( image_mset @ B @ A @ F @ M ) ) @ C2 )
          = ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( F @ X3 ) @ C2 )
              @ M ) ) ) ) ).

% sum_mset_distrib_right
thf(fact_4543_sum__mset__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F: B > A,M: multiset @ B] :
          ( ( times_times @ A @ C2 @ ( comm_m7189776963980413722m_mset @ A @ ( image_mset @ B @ A @ F @ M ) ) )
          = ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ C2 @ ( F @ X3 ) )
              @ M ) ) ) ) ).

% sum_mset_distrib_left
thf(fact_4544_inv__into__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: A > B,G: C > A,A4: set @ C,X: B] :
      ( ( inj_on @ A @ B @ F @ ( image2 @ C @ A @ G @ A4 ) )
     => ( ( inj_on @ C @ A @ G @ A4 )
       => ( ( member @ B @ X @ ( image2 @ A @ B @ F @ ( image2 @ C @ A @ G @ A4 ) ) )
         => ( ( hilbert_inv_into @ C @ B @ A4 @ ( comp @ A @ B @ C @ F @ G ) @ X )
            = ( comp @ A @ C @ B @ ( hilbert_inv_into @ C @ A @ A4 @ G ) @ ( hilbert_inv_into @ A @ B @ ( image2 @ C @ A @ G @ A4 ) @ F ) @ X ) ) ) ) ) ).

% inv_into_comp
thf(fact_4545_inv__unique__comp,axiom,
    ! [B: $tType,A: $tType,F: B > A,G: A > B] :
      ( ( ( comp @ B @ A @ A @ F @ G )
        = ( id @ A ) )
     => ( ( ( comp @ A @ B @ B @ G @ F )
          = ( id @ B ) )
       => ( ( hilbert_inv_into @ B @ A @ ( top_top @ ( set @ B ) ) @ F )
          = G ) ) ) ).

% inv_unique_comp
thf(fact_4546_o__inv__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > B,G: C > A] :
      ( ( bij_betw @ A @ B @ F @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
     => ( ( bij_betw @ C @ A @ G @ ( top_top @ ( set @ C ) ) @ ( top_top @ ( set @ A ) ) )
       => ( ( hilbert_inv_into @ C @ B @ ( top_top @ ( set @ C ) ) @ ( comp @ A @ B @ C @ F @ G ) )
          = ( comp @ A @ C @ B @ ( hilbert_inv_into @ C @ A @ ( top_top @ ( set @ C ) ) @ G ) @ ( hilbert_inv_into @ A @ B @ ( top_top @ ( set @ A ) ) @ F ) ) ) ) ) ).

% o_inv_distrib
thf(fact_4547_prod__filter__mono__iff,axiom,
    ! [A: $tType,B: $tType,A4: filter @ A,B3: filter @ B,C3: filter @ A,D4: filter @ B] :
      ( ( A4
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( B3
         != ( bot_bot @ ( filter @ B ) ) )
       => ( ( ord_less_eq @ ( filter @ ( product_prod @ A @ B ) ) @ ( prod_filter @ A @ B @ A4 @ B3 ) @ ( prod_filter @ A @ B @ C3 @ D4 ) )
          = ( ( ord_less_eq @ ( filter @ A ) @ A4 @ C3 )
            & ( ord_less_eq @ ( filter @ B ) @ B3 @ D4 ) ) ) ) ) ).

% prod_filter_mono_iff
thf(fact_4548_iso__backward,axiom,
    ! [A: $tType,B: $tType,X: A,Y: A,R6: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ B @ B ),F: B > A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R6 )
     => ( ( bNF_Wellorder_iso @ B @ A @ R4 @ R6 @ F )
       => ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( hilbert_inv_into @ B @ A @ ( field2 @ B @ R4 ) @ F @ X ) @ ( hilbert_inv_into @ B @ A @ ( field2 @ B @ R4 ) @ F @ Y ) ) @ R4 ) ) ) ).

% iso_backward
thf(fact_4549_surj__iff,axiom,
    ! [B: $tType,A: $tType,F: B > A] :
      ( ( ( image2 @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ( comp @ B @ A @ A @ F @ ( hilbert_inv_into @ B @ A @ ( top_top @ ( set @ B ) ) @ F ) )
        = ( id @ A ) ) ) ).

% surj_iff
thf(fact_4550_inj__iff,axiom,
    ! [B: $tType,A: $tType,F: A > B] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
      = ( ( comp @ B @ A @ A @ ( hilbert_inv_into @ A @ B @ ( top_top @ ( set @ A ) ) @ F ) @ F )
        = ( id @ A ) ) ) ).

% inj_iff
thf(fact_4551_fn__o__inv__fn__is__id,axiom,
    ! [A: $tType,F: A > A,N: nat] :
      ( ( bij_betw @ A @ A @ F @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N @ F ) @ ( compow @ ( A > A ) @ N @ ( hilbert_inv_into @ A @ A @ ( top_top @ ( set @ A ) ) @ F ) ) )
        = ( ^ [X3: A] : X3 ) ) ) ).

% fn_o_inv_fn_is_id
thf(fact_4552_inv__fn__o__fn__is__id,axiom,
    ! [A: $tType,F: A > A,N: nat] :
      ( ( bij_betw @ A @ A @ F @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N @ ( hilbert_inv_into @ A @ A @ ( top_top @ ( set @ A ) ) @ F ) ) @ ( compow @ ( A > A ) @ N @ F ) )
        = ( ^ [X3: A] : X3 ) ) ) ).

% inv_fn_o_fn_is_id
thf(fact_4553_eventually__prod1,axiom,
    ! [A: $tType,B: $tType,B3: filter @ A,P: B > $o,A4: filter @ B] :
      ( ( B3
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ ( product_prod @ B @ A )
          @ ( product_case_prod @ B @ A @ $o
            @ ^ [X3: B,Y2: A] : ( P @ X3 ) )
          @ ( prod_filter @ B @ A @ A4 @ B3 ) )
        = ( eventually @ B @ P @ A4 ) ) ) ).

% eventually_prod1
thf(fact_4554_eventually__prod2,axiom,
    ! [A: $tType,B: $tType,A4: filter @ A,P: B > $o,B3: filter @ B] :
      ( ( A4
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ B @ $o
            @ ^ [X3: A] : P )
          @ ( prod_filter @ A @ B @ A4 @ B3 ) )
        = ( eventually @ B @ P @ B3 ) ) ) ).

% eventually_prod2
thf(fact_4555_prod__filter__INF2,axiom,
    ! [B: $tType,C: $tType,A: $tType,J4: set @ A,A4: filter @ B,B3: A > ( filter @ C )] :
      ( ( J4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( prod_filter @ B @ C @ A4 @ ( complete_Inf_Inf @ ( filter @ C ) @ ( image2 @ A @ ( filter @ C ) @ B3 @ J4 ) ) )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ B @ C ) )
          @ ( image2 @ A @ ( filter @ ( product_prod @ B @ C ) )
            @ ^ [I2: A] : ( prod_filter @ B @ C @ A4 @ ( B3 @ I2 ) )
            @ J4 ) ) ) ) ).

% prod_filter_INF2
thf(fact_4556_prod__filter__INF1,axiom,
    ! [B: $tType,C: $tType,A: $tType,I4: set @ A,A4: A > ( filter @ B ),B3: filter @ C] :
      ( ( I4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( prod_filter @ B @ C @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image2 @ A @ ( filter @ B ) @ A4 @ I4 ) ) @ B3 )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ B @ C ) )
          @ ( image2 @ A @ ( filter @ ( product_prod @ B @ C ) )
            @ ^ [I2: A] : ( prod_filter @ B @ C @ ( A4 @ I2 ) @ B3 )
            @ I4 ) ) ) ) ).

% prod_filter_INF1
thf(fact_4557_bijection_Oinv__comp__left,axiom,
    ! [A: $tType,F: A > A] :
      ( ( hilbert_bijection @ A @ F )
     => ( ( comp @ A @ A @ A @ ( hilbert_inv_into @ A @ A @ ( top_top @ ( set @ A ) ) @ F ) @ F )
        = ( id @ A ) ) ) ).

% bijection.inv_comp_left
thf(fact_4558_bijection_Oinv__comp__right,axiom,
    ! [A: $tType,F: A > A] :
      ( ( hilbert_bijection @ A @ F )
     => ( ( comp @ A @ A @ A @ F @ ( hilbert_inv_into @ A @ A @ ( top_top @ ( set @ A ) ) @ F ) )
        = ( id @ A ) ) ) ).

% bijection.inv_comp_right
thf(fact_4559_sum__mset__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [Y: B,A4: multiset @ A] :
          ( ( comm_m7189776963980413722m_mset @ B
            @ ( image_mset @ A @ B
              @ ^ [X3: A] : Y
              @ A4 ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( multiset @ A ) @ A4 ) ) @ Y ) ) ) ).

% sum_mset_constant
thf(fact_4560_relpow__fun__conv,axiom,
    ! [A: $tType,A3: A,B2: A,N: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) )
      = ( ? [F2: nat > A] :
            ( ( ( F2 @ ( zero_zero @ nat ) )
              = A3 )
            & ( ( F2 @ N )
              = B2 )
            & ! [I2: nat] :
                ( ( ord_less @ nat @ I2 @ N )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F2 @ I2 ) @ ( F2 @ ( suc @ I2 ) ) ) @ R ) ) ) ) ) ).

% relpow_fun_conv
thf(fact_4561_relpow__Suc__D2_H,axiom,
    ! [A: $tType,N: nat,R: set @ ( product_prod @ A @ A ),X6: A,Y5: A,Z6: A] :
      ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ Y5 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) )
        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z6 ) @ R ) )
     => ? [W: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X6 @ W ) @ R )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ W @ Z6 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) ) ) ) ).

% relpow_Suc_D2'
thf(fact_4562_relpow__0__I,axiom,
    ! [A: $tType,X: A,R: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R ) ) ).

% relpow_0_I
thf(fact_4563_relpow__0__E,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R ) )
     => ( X = Y ) ) ).

% relpow_0_E
thf(fact_4564_relpow__Suc__I2,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Z2: A,N: nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R ) ) ) ) ).

% relpow_Suc_I2
thf(fact_4565_relpow__Suc__E2,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R ) )
     => ~ ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) ) ) ) ).

% relpow_Suc_E2
thf(fact_4566_relpow__Suc__D2,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R ) )
     => ? [Y3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) ) ) ) ).

% relpow_Suc_D2
thf(fact_4567_relpow__Suc__I,axiom,
    ! [A: $tType,X: A,Y: A,N: nat,R: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R ) ) ) ) ).

% relpow_Suc_I
thf(fact_4568_relpow__Suc__E,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R ) )
     => ~ ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ R ) ) ) ).

% relpow_Suc_E
thf(fact_4569_relpowp__relpow__eq,axiom,
    ! [A: $tType,N: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( A > A > $o ) @ N
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R ) )
      = ( ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) ) ) ) ).

% relpowp_relpow_eq
thf(fact_4570_relpow__E,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y3: A,M5: nat] :
              ( ( N
                = ( suc @ M5 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M5 @ R ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ R ) ) ) ) ) ).

% relpow_E
thf(fact_4571_relpow__E2,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y3: A,M5: nat] :
              ( ( N
                = ( suc @ M5 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M5 @ R ) ) ) ) ) ) ).

% relpow_E2
thf(fact_4572_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_4573_exhaustive__integer_H_Ocases,axiom,
    ! [X: product_prod @ ( code_integer > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_integer @ code_integer )] :
      ~ ! [F10: code_integer > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),D3: code_integer,I3: code_integer] :
          ( X
         != ( product_Pair @ ( code_integer > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_integer @ code_integer ) @ F10 @ ( product_Pair @ code_integer @ code_integer @ D3 @ I3 ) ) ) ).

% exhaustive_integer'.cases
thf(fact_4574_full__exhaustive__integer_H_Ocases,axiom,
    ! [X: product_prod @ ( ( product_prod @ code_integer @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_integer @ code_integer )] :
      ~ ! [F10: ( product_prod @ code_integer @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),D3: code_integer,I3: code_integer] :
          ( X
         != ( product_Pair @ ( ( product_prod @ code_integer @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_integer @ code_integer ) @ F10 @ ( product_Pair @ code_integer @ code_integer @ D3 @ I3 ) ) ) ).

% full_exhaustive_integer'.cases
thf(fact_4575_Inf__multiset_Oabs__eq,axiom,
    ! [A: $tType,X: set @ ( A > nat )] :
      ( ( bNF_rel_set @ ( A > nat ) @ ( A > nat )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F2: A > nat] :
              ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X3: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X3 ) ) ) ) )
        @ X
        @ X )
     => ( ( complete_Inf_Inf @ ( multiset @ A ) @ ( image2 @ ( A > nat ) @ ( multiset @ A ) @ ( abs_multiset @ A ) @ X ) )
        = ( abs_multiset @ A
          @ ^ [I2: A] :
              ( if @ nat
              @ ( X
                = ( bot_bot @ ( set @ ( A > nat ) ) ) )
              @ ( zero_zero @ nat )
              @ ( complete_Inf_Inf @ nat
                @ ( image2 @ ( A > nat ) @ nat
                  @ ^ [F2: A > nat] : ( F2 @ I2 )
                  @ X ) ) ) ) ) ) ).

% Inf_multiset.abs_eq
thf(fact_4576_irreflp__irrefl__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( irreflp @ A
        @ ^ [A5: A,B4: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R ) )
      = ( irrefl @ A @ R ) ) ).

% irreflp_irrefl_eq
thf(fact_4577_Inf__multiset_Orsp,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ ( set @ ( A > nat ) ) @ ( set @ ( A > nat ) ) @ ( A > nat ) @ ( A > nat )
      @ ( bNF_rel_set @ ( A > nat ) @ ( A > nat )
        @ ( bNF_eq_onp @ ( A > nat )
          @ ^ [F2: A > nat] :
              ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X3: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X3 ) ) ) ) ) )
      @ ( bNF_eq_onp @ ( A > nat )
        @ ^ [F2: A > nat] :
            ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X3: A] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X3 ) ) ) ) )
      @ ^ [A10: set @ ( A > nat ),I2: A] :
          ( if @ nat
          @ ( A10
            = ( bot_bot @ ( set @ ( A > nat ) ) ) )
          @ ( zero_zero @ nat )
          @ ( complete_Inf_Inf @ nat
            @ ( image2 @ ( A > nat ) @ nat
              @ ^ [F2: A > nat] : ( F2 @ I2 )
              @ A10 ) ) )
      @ ^ [A10: set @ ( A > nat ),I2: A] :
          ( if @ nat
          @ ( A10
            = ( bot_bot @ ( set @ ( A > nat ) ) ) )
          @ ( zero_zero @ nat )
          @ ( complete_Inf_Inf @ nat
            @ ( image2 @ ( A > nat ) @ nat
              @ ^ [F2: A > nat] : ( F2 @ I2 )
              @ A10 ) ) ) ) ).

% Inf_multiset.rsp
thf(fact_4578_exhaustive__int_H_Ocases,axiom,
    ! [X: product_prod @ ( int > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ int @ int )] :
      ~ ! [F10: int > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),D3: int,I3: int] :
          ( X
         != ( product_Pair @ ( int > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ int @ int ) @ F10 @ ( product_Pair @ int @ int @ D3 @ I3 ) ) ) ).

% exhaustive_int'.cases
thf(fact_4579_full__exhaustive__int_H_Ocases,axiom,
    ! [X: product_prod @ ( ( product_prod @ int @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ int @ int )] :
      ~ ! [F10: ( product_prod @ int @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),D3: int,I3: int] :
          ( X
         != ( product_Pair @ ( ( product_prod @ int @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ int @ int ) @ F10 @ ( product_Pair @ int @ int @ D3 @ I3 ) ) ) ).

% full_exhaustive_int'.cases
thf(fact_4580_empty__transfer,axiom,
    ! [A: $tType,B: $tType,A4: A > B > $o] : ( bNF_rel_set @ A @ B @ A4 @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ B ) ) ) ).

% empty_transfer
thf(fact_4581_equivp__equiv,axiom,
    ! [A: $tType,A4: set @ ( product_prod @ A @ A )] :
      ( ( equiv_equiv @ A @ ( top_top @ ( set @ A ) ) @ A4 )
      = ( equiv_equivp @ A
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ A4 ) ) ) ).

% equivp_equiv
thf(fact_4582_asymp__asym__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( asymp @ A
        @ ^ [A5: A,B4: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ R ) )
      = ( asym @ A @ R ) ) ).

% asymp_asym_eq
thf(fact_4583_asym_Ocases,axiom,
    ! [A: $tType,A3: set @ ( product_prod @ A @ A )] :
      ( ( asym @ A @ A3 )
     => ! [A14: A,B11: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A14 @ B11 ) @ A3 )
         => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B11 @ A14 ) @ A3 ) ) ) ).

% asym.cases
thf(fact_4584_asym_Osimps,axiom,
    ! [A: $tType] :
      ( ( asym @ A )
      = ( ^ [A5: set @ ( product_prod @ A @ A )] :
          ? [R2: set @ ( product_prod @ A @ A )] :
            ( ( A5 = R2 )
            & ! [X3: A,Y2: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R2 )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R2 ) ) ) ) ) ).

% asym.simps
thf(fact_4585_asym_Ointros,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ! [A8: A,B6: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A8 @ B6 ) @ R )
         => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A8 ) @ R ) )
     => ( asym @ A @ R ) ) ).

% asym.intros
thf(fact_4586_asymD,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ( asym @ A @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
       => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X ) @ R ) ) ) ).

% asymD
thf(fact_4587_asym__iff,axiom,
    ! [A: $tType] :
      ( ( asym @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A )] :
          ! [X3: A,Y2: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R2 )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R2 ) ) ) ) ).

% asym_iff
thf(fact_4588_Inf__multiset_Otransfer,axiom,
    ! [A: $tType] :
      ( bNF_rel_fun @ ( set @ ( A > nat ) ) @ ( set @ ( multiset @ A ) ) @ ( A > nat ) @ ( multiset @ A )
      @ ( bNF_rel_set @ ( A > nat ) @ ( multiset @ A )
        @ ( pcr_multiset @ A @ A
          @ ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) ) )
      @ ( pcr_multiset @ A @ A
        @ ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
      @ ^ [A10: set @ ( A > nat ),I2: A] :
          ( if @ nat
          @ ( A10
            = ( bot_bot @ ( set @ ( A > nat ) ) ) )
          @ ( zero_zero @ nat )
          @ ( complete_Inf_Inf @ nat
            @ ( image2 @ ( A > nat ) @ nat
              @ ^ [F2: A > nat] : ( F2 @ I2 )
              @ A10 ) ) )
      @ ( complete_Inf_Inf @ ( multiset @ A ) ) ) ).

% Inf_multiset.transfer
thf(fact_4589_min__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F )
         => ( ( ord_min @ B @ ( F @ X ) @ ( F @ Y ) )
            = ( F @ ( ord_max @ A @ X @ Y ) ) ) ) ) ).

% min_of_antimono
thf(fact_4590_max__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F )
         => ( ( ord_max @ B @ ( F @ X ) @ ( F @ Y ) )
            = ( F @ ( ord_min @ A @ X @ Y ) ) ) ) ) ).

% max_of_antimono
thf(fact_4591_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ Y ) @ ( F @ X ) ) ) ) ) ).

% antimonoD
thf(fact_4592_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ Y ) @ ( F @ X ) ) ) ) ) ).

% antimonoE
thf(fact_4593_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F: A > B] :
          ( ! [X2: A,Y3: A] :
              ( ( ord_less_eq @ A @ X2 @ Y3 )
             => ( ord_less_eq @ B @ ( F @ Y3 ) @ ( F @ X2 ) ) )
         => ( order_antimono @ A @ B @ F ) ) ) ).

% antimonoI
thf(fact_4594_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F2: A > B] :
            ! [X3: A,Y2: A] :
              ( ( ord_less_eq @ A @ X3 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ Y2 ) @ ( F2 @ X3 ) ) ) ) ) ) ).

% antimono_def
thf(fact_4595_Range__insert,axiom,
    ! [A: $tType,B: $tType,A3: B,B2: A,R4: set @ ( product_prod @ B @ A )] :
      ( ( range2 @ B @ A @ ( insert2 @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ A3 @ B2 ) @ R4 ) )
      = ( insert2 @ A @ B2 @ ( range2 @ B @ A @ R4 ) ) ) ).

% Range_insert
thf(fact_4596_in__chain__finite,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [A4: set @ A] :
          ( ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ A4 )
         => ( ( finite_finite @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( member @ A @ ( complete_Sup_Sup @ A @ A4 ) @ A4 ) ) ) ) ) ).

% in_chain_finite
thf(fact_4597_Range__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( range2 @ B @ A @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Range_empty
thf(fact_4598_chain__empty,axiom,
    ! [A: $tType,Ord: A > A > $o] : ( comple1602240252501008431_chain @ A @ Ord @ ( bot_bot @ ( set @ A ) ) ) ).

% chain_empty
thf(fact_4599_Range_Ocases,axiom,
    ! [B: $tType,A: $tType,A3: B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ B @ A3 @ ( range2 @ A @ B @ R4 ) )
     => ~ ! [A8: A] :
            ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A8 @ A3 ) @ R4 ) ) ).

% Range.cases
thf(fact_4600_Range_Osimps,axiom,
    ! [B: $tType,A: $tType,A3: B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ B @ A3 @ ( range2 @ A @ B @ R4 ) )
      = ( ? [A5: A,B4: B] :
            ( ( A3 = B4 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B4 ) @ R4 ) ) ) ) ).

% Range.simps
thf(fact_4601_Range_Ointros,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ R4 )
     => ( member @ B @ B2 @ ( range2 @ A @ B @ R4 ) ) ) ).

% Range.intros
thf(fact_4602_RangeE,axiom,
    ! [A: $tType,B: $tType,B2: A,R4: set @ ( product_prod @ B @ A )] :
      ( ( member @ A @ B2 @ ( range2 @ B @ A @ R4 ) )
     => ~ ! [A8: B] :
            ~ ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ A8 @ B2 ) @ R4 ) ) ).

% RangeE
thf(fact_4603_Range__iff,axiom,
    ! [A: $tType,B: $tType,A3: A,R4: set @ ( product_prod @ B @ A )] :
      ( ( member @ A @ A3 @ ( range2 @ B @ A @ R4 ) )
      = ( ? [Y2: B] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ Y2 @ A3 ) @ R4 ) ) ) ).

% Range_iff
thf(fact_4604_Range__empty__iff,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ B @ A )] :
      ( ( ( range2 @ B @ A @ R4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( R4
        = ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) ) ) ).

% Range_empty_iff
thf(fact_4605_chain__singleton,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [X: A] : ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% chain_singleton
thf(fact_4606_Range__Int__subset,axiom,
    ! [A: $tType,B: $tType,A4: set @ ( product_prod @ B @ A ),B3: set @ ( product_prod @ B @ A )] : ( ord_less_eq @ ( set @ A ) @ ( range2 @ B @ A @ ( inf_inf @ ( set @ ( product_prod @ B @ A ) ) @ A4 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( range2 @ B @ A @ A4 ) @ ( range2 @ B @ A @ B3 ) ) ) ).

% Range_Int_subset
thf(fact_4607_wf__UN,axiom,
    ! [B: $tType,A: $tType,I4: set @ A,R4: A > ( set @ ( product_prod @ B @ B ) )] :
      ( ! [I3: A] :
          ( ( member @ A @ I3 @ I4 )
         => ( wf @ B @ ( R4 @ I3 ) ) )
     => ( ! [I3: A,J3: A] :
            ( ( member @ A @ I3 @ I4 )
           => ( ( member @ A @ J3 @ I4 )
             => ( ( ( R4 @ I3 )
                 != ( R4 @ J3 ) )
               => ( ( inf_inf @ ( set @ B ) @ ( domain @ B @ B @ ( R4 @ I3 ) ) @ ( range2 @ B @ B @ ( R4 @ J3 ) ) )
                  = ( bot_bot @ ( set @ B ) ) ) ) ) )
       => ( wf @ B @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ B ) ) @ ( image2 @ A @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ I4 ) ) ) ) ) ).

% wf_UN
thf(fact_4608_dom__ran__disj__comp,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ R ) @ ( range2 @ A @ A @ R ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( relcomp @ A @ A @ A @ R @ R )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% dom_ran_disj_comp
thf(fact_4609_wf__max,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ ( converse @ A @ A @ R ) )
     => ( ( R
         != ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ~ ! [M5: A] :
              ~ ( member @ A @ M5 @ ( minus_minus @ ( set @ A ) @ ( range2 @ A @ A @ R ) @ ( domain @ A @ A @ R ) ) ) ) ) ).

% wf_max
thf(fact_4610_Domain__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( domain @ A @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Domain_empty
thf(fact_4611_Domain__insert,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,R4: set @ ( product_prod @ A @ B )] :
      ( ( domain @ A @ B @ ( insert2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ R4 ) )
      = ( insert2 @ A @ A3 @ ( domain @ A @ B @ R4 ) ) ) ).

% Domain_insert
thf(fact_4612_Domain__iff,axiom,
    ! [A: $tType,B: $tType,A3: A,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ A @ A3 @ ( domain @ A @ B @ R4 ) )
      = ( ? [Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ Y2 ) @ R4 ) ) ) ).

% Domain_iff
thf(fact_4613_DomainE,axiom,
    ! [B: $tType,A: $tType,A3: A,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ A @ A3 @ ( domain @ A @ B @ R4 ) )
     => ~ ! [B6: B] :
            ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B6 ) @ R4 ) ) ).

% DomainE
thf(fact_4614_Domain_ODomainI,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ R4 )
     => ( member @ A @ A3 @ ( domain @ A @ B @ R4 ) ) ) ).

% Domain.DomainI
thf(fact_4615_Domain_Osimps,axiom,
    ! [B: $tType,A: $tType,A3: A,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ A @ A3 @ ( domain @ A @ B @ R4 ) )
      = ( ? [A5: A,B4: B] :
            ( ( A3 = A5 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B4 ) @ R4 ) ) ) ) ).

% Domain.simps
thf(fact_4616_Domain_Ocases,axiom,
    ! [B: $tType,A: $tType,A3: A,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ A @ A3 @ ( domain @ A @ B @ R4 ) )
     => ~ ! [B6: B] :
            ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B6 ) @ R4 ) ) ).

% Domain.cases
thf(fact_4617_Not__Domain__rtrancl,axiom,
    ! [A: $tType,X: A,R: set @ ( product_prod @ A @ A ),Y: A] :
      ( ~ ( member @ A @ X @ ( domain @ A @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R ) )
        = ( X = Y ) ) ) ).

% Not_Domain_rtrancl
thf(fact_4618_Domain__empty__iff,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B )] :
      ( ( ( domain @ A @ B @ R4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( R4
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ).

% Domain_empty_iff
thf(fact_4619_Domain__unfold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( domain @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B )] :
            ( collect @ A
            @ ^ [X3: A] :
              ? [Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R5 ) ) ) ) ).

% Domain_unfold
thf(fact_4620_Domain__Int__subset,axiom,
    ! [B: $tType,A: $tType,A4: set @ ( product_prod @ A @ B ),B3: set @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ A ) @ ( domain @ A @ B @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ A4 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( domain @ A @ B @ A4 ) @ ( domain @ A @ B @ B3 ) ) ) ).

% Domain_Int_subset
thf(fact_4621_wf__no__path,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ R ) @ ( range2 @ A @ A @ R ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( wf @ A @ R ) ) ).

% wf_no_path
thf(fact_4622_wf__min,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R )
     => ( ( R
         != ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ~ ! [M5: A] :
              ~ ( member @ A @ M5 @ ( minus_minus @ ( set @ A ) @ ( domain @ A @ A @ R ) @ ( range2 @ A @ A @ R ) ) ) ) ) ).

% wf_min
thf(fact_4623_wf__Un,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R4 )
     => ( ( wf @ A @ S )
       => ( ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ R4 ) @ ( range2 @ A @ A @ S ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( wf @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S ) ) ) ) ) ).

% wf_Un
thf(fact_4624_wf__Union,axiom,
    ! [A: $tType,R: set @ ( set @ ( product_prod @ A @ A ) )] :
      ( ! [X2: set @ ( product_prod @ A @ A )] :
          ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X2 @ R )
         => ( wf @ A @ X2 ) )
     => ( ! [X2: set @ ( product_prod @ A @ A )] :
            ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ X2 @ R )
           => ! [Xa3: set @ ( product_prod @ A @ A )] :
                ( ( member @ ( set @ ( product_prod @ A @ A ) ) @ Xa3 @ R )
               => ( ( X2 != Xa3 )
                 => ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ X2 ) @ ( range2 @ A @ A @ Xa3 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
       => ( wf @ A @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) ) @ R ) ) ) ) ).

% wf_Union
thf(fact_4625_for__in__RI,axiom,
    ! [B: $tType,A: $tType,X: A,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ A @ X @ ( domain @ A @ B @ R ) )
     => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ ( fun_of_rel @ A @ B @ R @ X ) ) @ R ) ) ).

% for_in_RI
thf(fact_4626_Rangep__Range__eq,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ B )] :
      ( ( rangep @ A @ B
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R4 ) )
      = ( ^ [X3: B] : ( member @ B @ X3 @ ( range2 @ A @ B @ R4 ) ) ) ) ).

% Rangep_Range_eq
thf(fact_4627_Range__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( range2 @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B )] :
            ( collect @ B
            @ ( rangep @ A @ B
              @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R5 ) ) ) ) ) ).

% Range_def
thf(fact_4628_cofinite__bot,axiom,
    ! [A: $tType] :
      ( ( ( cofinite @ A )
        = ( bot_bot @ ( filter @ A ) ) )
      = ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ).

% cofinite_bot
thf(fact_4629_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_4630_wfP__SUP,axiom,
    ! [B: $tType,A: $tType,R4: A > B > B > $o] :
      ( ! [I3: A] : ( wfP @ B @ ( R4 @ I3 ) )
     => ( ! [I3: A,J3: A] :
            ( ( ( R4 @ I3 )
             != ( R4 @ J3 ) )
           => ( ( inf_inf @ ( B > $o ) @ ( domainp @ B @ B @ ( R4 @ I3 ) ) @ ( rangep @ B @ B @ ( R4 @ J3 ) ) )
              = ( bot_bot @ ( B > $o ) ) ) )
       => ( wfP @ B @ ( complete_Sup_Sup @ ( B > B > $o ) @ ( image2 @ A @ ( B > B > $o ) @ R4 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% wfP_SUP
thf(fact_4631_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A3 ) @ ( plus_plus @ nat @ N ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_4632_Domainp__Domain__eq,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B )] :
      ( ( domainp @ A @ B
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R4 ) )
      = ( ^ [X3: A] : ( member @ A @ X3 @ ( domain @ A @ B @ R4 ) ) ) ) ).

% Domainp_Domain_eq
thf(fact_4633_Domain__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( domain @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B )] :
            ( collect @ A
            @ ( domainp @ A @ B
              @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R5 ) ) ) ) ) ).

% Domain_def
thf(fact_4634_wfP__wf__eq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( wfP @ A
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) )
      = ( wf @ A @ R4 ) ) ).

% wfP_wf_eq
thf(fact_4635_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,N: nat] :
          ( ( divide_divide @ A @ A3 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_4636_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A5: A,N5: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N5 @ A5 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_4637_pcr__Domainp__par,axiom,
    ! [A: $tType,B: $tType,C: $tType,B3: A > B > $o,P23: A > $o,A4: C > A > $o,P12: C > $o,P24: C > $o] :
      ( ( ( domainp @ A @ B @ B3 )
        = P23 )
     => ( ( ( domainp @ C @ A @ A4 )
          = P12 )
       => ( ( bNF_rel_fun @ C @ A @ $o @ $o @ A4
            @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
            @ P24
            @ P23 )
         => ( ( domainp @ C @ B @ ( relcompp @ C @ A @ B @ A4 @ B3 ) )
            = ( inf_inf @ ( C > $o ) @ P12 @ P24 ) ) ) ) ) ).

% pcr_Domainp_par
thf(fact_4638_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M4: nat,N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ M4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ord_less_eq @ nat @ M4 @ N )
                & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ).

% drop_bit_exp_eq
thf(fact_4639_composed__equiv__rel__eq__onp,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o,P: A > $o,P2: B > $o,P10: A > $o] :
      ( ( left_unique @ A @ B @ R )
     => ( ( bNF_rel_fun @ A @ B @ $o @ $o @ R
          @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
          @ P
          @ P2 )
       => ( ( ( domainp @ A @ B @ R )
            = P10 )
         => ( ( relcompp @ A @ B @ A @ R @ ( relcompp @ B @ B @ A @ ( bNF_eq_onp @ B @ P2 ) @ ( conversep @ A @ B @ R ) ) )
            = ( bNF_eq_onp @ A @ ( inf_inf @ ( A > $o ) @ P10 @ P ) ) ) ) ) ) ).

% composed_equiv_rel_eq_onp
thf(fact_4640_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
          = ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ).

% bit_minus_1_iff
thf(fact_4641_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ A3 ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% bit_minus_iff
thf(fact_4642_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M4: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M4 ) @ ( one_one @ A ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ N @ M4 ) ) ) ) ).

% bit_mask_sub_iff
thf(fact_4643_bit__double__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            & ( N
             != ( zero_zero @ nat ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% bit_double_iff
thf(fact_4644_multiset_Odomain__par,axiom,
    ! [B: $tType,C: $tType,T3: C > B > $o,DT: C > $o,DS: nat > $o,P24: ( C > nat ) > $o] :
      ( ( ( domainp @ C @ B @ T3 )
        = DT )
     => ( ( ( domainp @ nat @ nat
            @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 ) )
          = DS )
       => ( ( left_unique @ C @ B @ T3 )
         => ( ( bNF_rel_fun @ ( C > nat ) @ ( B > nat ) @ $o @ $o
              @ ( bNF_rel_fun @ C @ B @ nat @ nat @ T3
                @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 ) )
              @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
              @ P24
              @ ^ [F2: B > nat] :
                  ( finite_finite @ B
                  @ ( collect @ B
                    @ ^ [X3: B] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X3 ) ) ) ) )
           => ( ( domainp @ ( C > nat ) @ ( multiset @ B ) @ ( pcr_multiset @ C @ B @ T3 ) )
              = ( inf_inf @ ( ( C > nat ) > $o ) @ ( basic_pred_fun @ C @ nat @ DT @ DS ) @ P24 ) ) ) ) ) ) ).

% multiset.domain_par
thf(fact_4645_cut__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( cut @ A @ B )
      = ( ^ [F2: A > B,R2: set @ ( product_prod @ A @ A ),X3: A,Y2: A] : ( if @ B @ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R2 ) @ ( F2 @ Y2 ) @ ( undefined @ B ) ) ) ) ).

% cut_def
thf(fact_4646_pairwise__alt,axiom,
    ! [A: $tType] :
      ( ( pairwise @ A )
      = ( ^ [R2: A > A > $o,S7: set @ A] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ S7 )
           => ! [Y2: A] :
                ( ( member @ A @ Y2 @ ( minus_minus @ ( set @ A ) @ S7 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
               => ( R2 @ X3 @ Y2 ) ) ) ) ) ).

% pairwise_alt
thf(fact_4647_pairwise__empty,axiom,
    ! [A: $tType,P: A > A > $o] : ( pairwise @ A @ P @ ( bot_bot @ ( set @ A ) ) ) ).

% pairwise_empty
thf(fact_4648_pred__fun__True__id,axiom,
    ! [A: $tType,B: $tType,C: $tType,P4: B > $o,F: C > B] :
      ( ( nO_MATCH @ ( A > A ) @ ( B > $o ) @ ( id @ A ) @ P4 )
     => ( ( basic_pred_fun @ C @ B
          @ ^ [X3: C] : $true
          @ P4
          @ F )
        = ( basic_pred_fun @ C @ $o
          @ ^ [X3: C] : $true
          @ ( id @ $o )
          @ ( comp @ B @ $o @ C @ P4 @ F ) ) ) ) ).

% pred_fun_True_id
thf(fact_4649_fun_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,D: $tType,X: D > A,Ya: D > A,F: A > B,G: A > B] :
      ( ( X = Ya )
     => ( ( basic_pred_fun @ D @ A
          @ ^ [Uu: D] : $true
          @ ^ [Z4: A] :
              ( ( F @ Z4 )
              = ( G @ Z4 ) )
          @ Ya )
       => ( ( comp @ A @ B @ D @ F @ X )
          = ( comp @ A @ B @ D @ G @ Ya ) ) ) ) ).

% fun.map_cong_pred
thf(fact_4650_cuts__eq,axiom,
    ! [B: $tType,A: $tType,F: A > B,R: set @ ( product_prod @ A @ A ),X: A,G: A > B] :
      ( ( ( cut @ A @ B @ F @ R @ X )
        = ( cut @ A @ B @ G @ R @ X ) )
      = ( ! [Y2: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X ) @ R )
           => ( ( F @ Y2 )
              = ( G @ Y2 ) ) ) ) ) ).

% cuts_eq
thf(fact_4651_cut__apply,axiom,
    ! [B: $tType,A: $tType,X: A,A3: A,R: set @ ( product_prod @ A @ A ),F: A > B] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ A3 ) @ R )
     => ( ( cut @ A @ B @ F @ R @ A3 @ X )
        = ( F @ X ) ) ) ).

% cut_apply
thf(fact_4652_pairwise__singleton,axiom,
    ! [A: $tType,P: A > A > $o,A4: A] : ( pairwise @ A @ P @ ( insert2 @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% pairwise_singleton
thf(fact_4653_fun_Opred__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,Q: B > $o,F: A > B,X: D > A] :
      ( ( basic_pred_fun @ D @ B
        @ ^ [Uu: D] : $true
        @ Q
        @ ( comp @ A @ B @ D @ F @ X ) )
      = ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true
        @ ( comp @ B @ $o @ A @ Q @ F )
        @ X ) ) ).

% fun.pred_map
thf(fact_4654_ID_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_id_bnf @ ( A > B > $o ) )
      = ( ^ [R2: A > B > $o,A5: A,B4: B] :
          ? [Z4: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ Z4
              @ ( collect @ ( product_prod @ A @ B )
                @ ^ [X3: product_prod @ A @ B] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( insert2 @ ( product_prod @ A @ B ) @ X3 @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( bNF_id_bnf @ ( ( product_prod @ A @ B ) > A ) @ ( product_fst @ A @ B ) @ Z4 )
              = A5 )
            & ( ( bNF_id_bnf @ ( ( product_prod @ A @ B ) > B ) @ ( product_snd @ A @ B ) @ Z4 )
              = B4 ) ) ) ) ).

% ID.in_rel
thf(fact_4655_is__num_Ocases,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A3: A] :
          ( ( neg_numeral_is_num @ A @ A3 )
         => ( ( A3
             != ( one_one @ A ) )
           => ( ! [X2: A] :
                  ( ( A3
                    = ( uminus_uminus @ A @ X2 ) )
                 => ~ ( neg_numeral_is_num @ A @ X2 ) )
             => ~ ! [X2: A,Y3: A] :
                    ( ( A3
                      = ( plus_plus @ A @ X2 @ Y3 ) )
                   => ( ( neg_numeral_is_num @ A @ X2 )
                     => ~ ( neg_numeral_is_num @ A @ Y3 ) ) ) ) ) ) ) ).

% is_num.cases
thf(fact_4656_is__num_Osimps,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_is_num @ A )
        = ( ^ [A5: A] :
              ( ( A5
                = ( one_one @ A ) )
              | ? [X3: A] :
                  ( ( A5
                    = ( uminus_uminus @ A @ X3 ) )
                  & ( neg_numeral_is_num @ A @ X3 ) )
              | ? [X3: A,Y2: A] :
                  ( ( A5
                    = ( plus_plus @ A @ X3 @ Y2 ) )
                  & ( neg_numeral_is_num @ A @ X3 )
                  & ( neg_numeral_is_num @ A @ Y2 ) ) ) ) ) ) ).

% is_num.simps
thf(fact_4657_is__num__normalize_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( neg_numeral_is_num @ A @ ( one_one @ A ) ) ) ).

% is_num_normalize(4)
thf(fact_4658_ID_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q: B > $o,F: A > B,X: A] :
      ( ( bNF_id_bnf @ ( B > $o ) @ Q @ ( bNF_id_bnf @ ( A > B ) @ F @ X ) )
      = ( bNF_id_bnf @ ( A > $o ) @ ( comp @ B @ $o @ A @ Q @ F ) @ X ) ) ).

% ID.pred_map
thf(fact_4659_ID_Orel__refl__strong,axiom,
    ! [A: $tType,X: A,Ra2: A > A > $o] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
         => ( Ra2 @ Z3 @ Z3 ) )
     => ( bNF_id_bnf @ ( A > A > $o ) @ Ra2 @ X @ X ) ) ).

% ID.rel_refl_strong
thf(fact_4660_ID_Orel__mono__strong,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X: A,Y: B,Ra2: A > B > $o] :
      ( ( bNF_id_bnf @ ( A > B > $o ) @ R @ X @ Y )
     => ( ! [Z3: A,Yb: B] :
            ( ( member @ A @ Z3 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
           => ( ( member @ B @ Yb @ ( insert2 @ B @ Y @ ( bot_bot @ ( set @ B ) ) ) )
             => ( ( R @ Z3 @ Yb )
               => ( Ra2 @ Z3 @ Yb ) ) ) )
       => ( bNF_id_bnf @ ( A > B > $o ) @ Ra2 @ X @ Y ) ) ) ).

% ID.rel_mono_strong
thf(fact_4661_ID_Orel__cong,axiom,
    ! [A: $tType,B: $tType,X: A,Ya: A,Y: B,Xa: B,R: A > B > $o,Ra2: A > B > $o] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z3: A,Yb: B] :
              ( ( member @ A @ Z3 @ ( insert2 @ A @ Ya @ ( bot_bot @ ( set @ A ) ) ) )
             => ( ( member @ B @ Yb @ ( insert2 @ B @ Xa @ ( bot_bot @ ( set @ B ) ) ) )
               => ( ( R @ Z3 @ Yb )
                  = ( Ra2 @ Z3 @ Yb ) ) ) )
         => ( ( bNF_id_bnf @ ( A > B > $o ) @ R @ X @ Y )
            = ( bNF_id_bnf @ ( A > B > $o ) @ Ra2 @ Ya @ Xa ) ) ) ) ) ).

% ID.rel_cong
thf(fact_4662_Basic__BNF__LFPs_Octor__rec__o__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: C > B,G: A > C] :
      ( ( comp @ C @ B @ A @ ( basic_BNF_ctor_rec @ ( C > B ) @ F ) @ G )
      = ( basic_BNF_ctor_rec @ ( A > B ) @ ( comp @ C @ B @ A @ F @ ( comp @ A @ C @ A @ ( comp @ C @ C @ A @ ( bNF_id_bnf @ C ) @ G ) @ ( bNF_id_bnf @ A ) ) ) ) ) ).

% Basic_BNF_LFPs.ctor_rec_o_map
thf(fact_4663_Basic__BNF__LFPs_Octor__rec__def__alt,axiom,
    ! [B: $tType,A: $tType,F: A > B] :
      ( F
      = ( basic_BNF_ctor_rec @ ( A > B ) @ ( comp @ A @ B @ A @ F @ ( bNF_id_bnf @ A ) ) ) ) ).

% Basic_BNF_LFPs.ctor_rec_def_alt
thf(fact_4664_snga__assn__raw_Oelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( snga_assn_raw @ A @ X @ Xa @ Xb )
         => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
               => ( ( ( array_get @ A @ H @ X )
                    = Xa )
                  & ( As2
                    = ( insert2 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                  & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H ) ) ) ) ) ) ).

% snga_assn_raw.elims(3)
thf(fact_4665_relH__array,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [As: set @ nat,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: array @ A] :
          ( ( relH @ As @ H2 @ H4 )
         => ( ( member @ nat @ ( addr_of_array @ A @ R4 ) @ As )
           => ( ( array_get @ A @ H2 @ R4 )
              = ( array_get @ A @ H4 @ R4 ) ) ) ) ) ).

% relH_array
thf(fact_4666_ID_Opred__cong,axiom,
    ! [A: $tType,X: A,Ya: A,P: A > $o,Pa: A > $o] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( insert2 @ A @ Ya @ ( bot_bot @ ( set @ A ) ) ) )
           => ( ( P @ Z3 )
              = ( Pa @ Z3 ) ) )
       => ( ( bNF_id_bnf @ ( A > $o ) @ P @ X )
          = ( bNF_id_bnf @ ( A > $o ) @ Pa @ Ya ) ) ) ) ).

% ID.pred_cong
thf(fact_4667_ID_Opred__mono__strong,axiom,
    ! [A: $tType,P: A > $o,X: A,Pa: A > $o] :
      ( ( bNF_id_bnf @ ( A > $o ) @ P @ X )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
           => ( ( P @ Z3 )
             => ( Pa @ Z3 ) ) )
       => ( bNF_id_bnf @ ( A > $o ) @ Pa @ X ) ) ) ).

% ID.pred_mono_strong
thf(fact_4668_ID_Opred__set,axiom,
    ! [A: $tType] :
      ( ( bNF_id_bnf @ ( A > $o ) )
      = ( ^ [P3: A > $o,X3: A] :
          ! [Y2: A] :
            ( ( member @ A @ Y2 @ ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
           => ( P3 @ Y2 ) ) ) ) ).

% ID.pred_set
thf(fact_4669_snga__assn__raw_Osimps,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: array @ A,X: list @ A,H2: heap_ext @ product_unit,As: set @ nat] :
          ( ( snga_assn_raw @ A @ R4 @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
          = ( ( ( array_get @ A @ H2 @ R4 )
              = X )
            & ( As
              = ( insert2 @ nat @ ( addr_of_array @ A @ R4 ) @ ( bot_bot @ ( set @ nat ) ) ) )
            & ( ord_less @ nat @ ( addr_of_array @ A @ R4 ) @ ( lim @ product_unit @ H2 ) ) ) ) ) ).

% snga_assn_raw.simps
thf(fact_4670_snga__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( snga_assn_raw @ A @ X @ Xa @ Xb )
            = Y )
         => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
               => ( Y
                  = ( ~ ( ( ( array_get @ A @ H @ X )
                          = Xa )
                        & ( As2
                          = ( insert2 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H ) ) ) ) ) ) ) ) ).

% snga_assn_raw.elims(1)
thf(fact_4671_snga__assn__raw_Oelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( snga_assn_raw @ A @ X @ Xa @ Xb )
         => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
               => ~ ( ( ( array_get @ A @ H @ X )
                      = Xa )
                    & ( As2
                      = ( insert2 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                    & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H ) ) ) ) ) ) ).

% snga_assn_raw.elims(2)
thf(fact_4672_snga__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( snga_assn_raw @ A @ X @ Xa @ Xb )
            = Y )
         => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                 => ( ( Y
                      = ( ( ( array_get @ A @ H @ X )
                          = Xa )
                        & ( As2
                          = ( insert2 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H ) ) ) )
                   => ~ ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(1)
thf(fact_4673_snga__assn__raw_Opelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( snga_assn_raw @ A @ X @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                 => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) )
                   => ~ ( ( ( array_get @ A @ H @ X )
                          = Xa )
                        & ( As2
                          = ( insert2 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H ) ) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(2)
thf(fact_4674_snga__assn__raw_Opelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( snga_assn_raw @ A @ X @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
                 => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) )
                   => ( ( ( array_get @ A @ H @ X )
                        = Xa )
                      & ( As2
                        = ( insert2 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                      & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H ) ) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(3)
thf(fact_4675_relH__set__array,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: array @ A,As: set @ nat,H2: heap_ext @ product_unit,X: list @ A] :
          ( ~ ( member @ nat @ ( addr_of_array @ A @ R4 ) @ As )
         => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As ) )
           => ( relH @ As @ H2 @ ( array_set @ A @ R4 @ X @ H2 ) ) ) ) ) ).

% relH_set_array
thf(fact_4676_ctor__rec__unique,axiom,
    ! [B: $tType,A: $tType,G: A > A,F: A > B,S: A > B] :
      ( ( G
        = ( id @ A ) )
     => ( ( ( comp @ A @ B @ A @ F @ ( basic_BNF_xtor @ A ) )
          = ( comp @ A @ B @ A @ S @ ( comp @ A @ A @ A @ ( comp @ A @ A @ A @ ( bNF_id_bnf @ A ) @ G ) @ ( bNF_id_bnf @ A ) ) ) )
       => ( F
          = ( basic_BNF_ctor_rec @ ( A > B ) @ S ) ) ) ) ).

% ctor_rec_unique
thf(fact_4677_Basic__BNF__LFPs_Octor__rec,axiom,
    ! [B: $tType,A: $tType,G: A > A,F: A > B,X: A] :
      ( ( G
        = ( id @ A ) )
     => ( ( basic_BNF_ctor_rec @ ( A > B ) @ F @ ( basic_BNF_xtor @ A @ X ) )
        = ( F @ ( comp @ A @ A @ A @ ( comp @ A @ A @ A @ ( bNF_id_bnf @ A ) @ G ) @ ( bNF_id_bnf @ A ) @ X ) ) ) ) ).

% Basic_BNF_LFPs.ctor_rec
thf(fact_4678_xtor__map__unique,axiom,
    ! [B: $tType,A: $tType,U: A > B,F: A > B] :
      ( ( ( comp @ A @ B @ A @ U @ ( basic_BNF_xtor @ A ) )
        = ( comp @ B @ B @ A @ ( basic_BNF_xtor @ B ) @ F ) )
     => ( U = F ) ) ).

% xtor_map_unique
thf(fact_4679_Basic__BNF__LFPs_OPair__def__alt,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_Pair @ A @ B )
      = ( ^ [A5: A,B4: B] : ( basic_BNF_xtor @ ( product_prod @ A @ B ) @ ( bNF_id_bnf @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B4 ) ) ) ) ) ).

% Basic_BNF_LFPs.Pair_def_alt
thf(fact_4680_freeze__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_freeze @ A )
        = ( ^ [A5: array @ A] :
              ( heap_Time_heap @ ( list @ A )
              @ ^ [H3: heap_ext @ product_unit] : ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( array_get @ A @ H3 @ A5 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H3 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( array_length @ A @ H3 @ A5 ) ) ) ) ) ) ) ) ).

% freeze_def
thf(fact_4681_execute__freeze,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( list @ A ) @ ( array_freeze @ A @ A3 ) @ H2 )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( array_get @ A @ H2 @ A3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( array_length @ A @ H2 @ A3 ) ) ) ) ) ) ) ).

% execute_freeze
thf(fact_4682_subset__mset_OatLeastatMost__empty,axiom,
    ! [A: $tType,B2: multiset @ A,A3: multiset @ A] :
      ( ( subset_mset @ A @ B2 @ A3 )
     => ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ).

% subset_mset.atLeastatMost_empty
thf(fact_4683_subset__mset_OacyclicI__order,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ B @ B ),F: B > ( multiset @ A )] :
      ( ! [A8: B,B6: B] :
          ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ A8 @ B6 ) @ R4 )
         => ( subset_mset @ A @ ( F @ B6 ) @ ( F @ A8 ) ) )
     => ( transitive_acyclic @ B @ R4 ) ) ).

% subset_mset.acyclicI_order
thf(fact_4684_subset__implies__mult,axiom,
    ! [A: $tType,A4: multiset @ A,B3: multiset @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( subset_mset @ A @ A4 @ B3 )
     => ( member @ ( product_prod @ ( multiset @ A ) @ ( multiset @ A ) ) @ ( product_Pair @ ( multiset @ A ) @ ( multiset @ A ) @ A4 @ B3 ) @ ( mult @ A @ R4 ) ) ) ).

% subset_implies_mult
thf(fact_4685_subset__mset_OgreaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType,A3: multiset @ A,B2: multiset @ A] :
      ( ( set_gr3752724095348155675AtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ A3 @ B2 )
      = ( minus_minus @ ( set @ ( multiset @ A ) ) @ ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 @ B2 ) @ ( insert2 @ ( multiset @ A ) @ A3 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ).

% subset_mset.greaterThanAtMost_eq_atLeastAtMost_diff
thf(fact_4686_subset__mset_OatLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType,A3: multiset @ A,B2: multiset @ A] :
      ( ( set_atLeastLessThan @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ A3 @ B2 )
      = ( minus_minus @ ( set @ ( multiset @ A ) ) @ ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A3 @ B2 ) @ ( insert2 @ ( multiset @ A ) @ B2 @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ).

% subset_mset.atLeastLessThan_eq_atLeastAtMost_diff
thf(fact_4687_subset__mset_OgreaterThanLessThan__empty,axiom,
    ! [A: $tType,L: multiset @ A,K: multiset @ A] :
      ( ( subseteq_mset @ A @ L @ K )
     => ( ( set_gr287244882034783167ssThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ K @ L )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ).

% subset_mset.greaterThanLessThan_empty
thf(fact_4688_subset__mset_OatLeastLessThan__empty__iff2,axiom,
    ! [A: $tType,A3: multiset @ A,B2: multiset @ A] :
      ( ( ( bot_bot @ ( set @ ( multiset @ A ) ) )
        = ( set_atLeastLessThan @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ A3 @ B2 ) )
      = ( ~ ( subset_mset @ A @ A3 @ B2 ) ) ) ).

% subset_mset.atLeastLessThan_empty_iff2
thf(fact_4689_subset__mset_OatLeastLessThan__empty__iff,axiom,
    ! [A: $tType,A3: multiset @ A,B2: multiset @ A] :
      ( ( ( set_atLeastLessThan @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
      = ( ~ ( subset_mset @ A @ A3 @ B2 ) ) ) ).

% subset_mset.atLeastLessThan_empty_iff
thf(fact_4690_subset__mset_OatLeastLessThan__empty,axiom,
    ! [A: $tType,B2: multiset @ A,A3: multiset @ A] :
      ( ( subseteq_mset @ A @ B2 @ A3 )
     => ( ( set_atLeastLessThan @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ).

% subset_mset.atLeastLessThan_empty
thf(fact_4691_subset__mset_OgreaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType,K: multiset @ A,L: multiset @ A] :
      ( ( ( bot_bot @ ( set @ ( multiset @ A ) ) )
        = ( set_gr3752724095348155675AtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ K @ L ) )
      = ( ~ ( subset_mset @ A @ K @ L ) ) ) ).

% subset_mset.greaterThanAtMost_empty_iff2
thf(fact_4692_subset__mset_OgreaterThanAtMost__empty__iff,axiom,
    ! [A: $tType,K: multiset @ A,L: multiset @ A] :
      ( ( ( set_gr3752724095348155675AtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ K @ L )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
      = ( ~ ( subset_mset @ A @ K @ L ) ) ) ).

% subset_mset.greaterThanAtMost_empty_iff
thf(fact_4693_subset__mset_OgreaterThanAtMost__empty,axiom,
    ! [A: $tType,L: multiset @ A,K: multiset @ A] :
      ( ( subseteq_mset @ A @ L @ K )
     => ( ( set_gr3752724095348155675AtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ K @ L )
        = ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ).

% subset_mset.greaterThanAtMost_empty
thf(fact_4694_execute__len,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ nat @ ( array_len @ A @ A3 ) @ H2 )
          = ( some @ ( product_prod @ nat @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ nat @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( array_length @ A @ H2 @ A3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( one_one @ nat ) ) ) ) ) ) ).

% execute_len
thf(fact_4695_subset__mset_OIio__Int__singleton,axiom,
    ! [A: $tType,X: multiset @ A,K: multiset @ A] :
      ( ( ( subset_mset @ A @ X @ K )
       => ( ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ K ) @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
          = ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) )
      & ( ~ ( subset_mset @ A @ X @ K )
       => ( ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ K ) @ ( insert2 @ ( multiset @ A ) @ X @ ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) )
          = ( bot_bot @ ( set @ ( multiset @ A ) ) ) ) ) ) ).

% subset_mset.Iio_Int_singleton
thf(fact_4696_subset__mset_Osum__pos,axiom,
    ! [A: $tType,B: $tType,I4: set @ B,F: B > ( multiset @ A )] :
      ( ( finite_finite @ B @ I4 )
     => ( ( I4
         != ( bot_bot @ ( set @ B ) ) )
       => ( ! [I3: B] :
              ( ( member @ B @ I3 @ I4 )
             => ( subset_mset @ A @ ( zero_zero @ ( multiset @ A ) ) @ ( F @ I3 ) ) )
         => ( subset_mset @ A @ ( zero_zero @ ( multiset @ A ) ) @ ( groups3894954378712506084id_sum @ ( multiset @ A ) @ B @ ( plus_plus @ ( multiset @ A ) ) @ ( zero_zero @ ( multiset @ A ) ) @ F @ I4 ) ) ) ) ) ).

% subset_mset.sum_pos
thf(fact_4697_subset__mset_Osum__strict__mono,axiom,
    ! [A: $tType,B: $tType,A4: set @ B,F: B > ( multiset @ A ),G: B > ( multiset @ A )] :
      ( ( finite_finite @ B @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ B ) ) )
       => ( ! [X2: B] :
              ( ( member @ B @ X2 @ A4 )
             => ( subset_mset @ A @ ( F @ X2 ) @ ( G @ X2 ) ) )
         => ( subset_mset @ A @ ( groups3894954378712506084id_sum @ ( multiset @ A ) @ B @ ( plus_plus @ ( multiset @ A ) ) @ ( zero_zero @ ( multiset @ A ) ) @ F @ A4 ) @ ( groups3894954378712506084id_sum @ ( multiset @ A ) @ B @ ( plus_plus @ ( multiset @ A ) ) @ ( zero_zero @ ( multiset @ A ) ) @ G @ A4 ) ) ) ) ) ).

% subset_mset.sum_strict_mono
thf(fact_4698_subset__mset_OatLeastLessThan__def,axiom,
    ! [A: $tType,L: multiset @ A,U: multiset @ A] :
      ( ( set_atLeastLessThan @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ L @ U )
      = ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_atLeast @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ L ) @ ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ U ) ) ) ).

% subset_mset.atLeastLessThan_def
thf(fact_4699_subset__mset_OgreaterThanLessThan__eq,axiom,
    ! [A: $tType,A3: multiset @ A,B2: multiset @ A] :
      ( ( set_gr287244882034783167ssThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ A3 @ B2 )
      = ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_greaterThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ A3 ) @ ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ B2 ) ) ) ).

% subset_mset.greaterThanLessThan_eq
thf(fact_4700_subset__mset_OgreaterThanLessThan__def,axiom,
    ! [A: $tType,L: multiset @ A,U: multiset @ A] :
      ( ( set_gr287244882034783167ssThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ L @ U )
      = ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_greaterThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ L ) @ ( set_lessThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ U ) ) ) ).

% subset_mset.greaterThanLessThan_def
thf(fact_4701_subset__mset_Onot__empty__eq__Ici__eq__empty,axiom,
    ! [A: $tType,L: multiset @ A] :
      ( ( bot_bot @ ( set @ ( multiset @ A ) ) )
     != ( set_atLeast @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ L ) ) ).

% subset_mset.not_empty_eq_Ici_eq_empty
thf(fact_4702_ord_OgreaterThanLessThan__def,axiom,
    ! [A: $tType] :
      ( ( set_gr287244882034783167ssThan @ A )
      = ( ^ [Less2: A > A > $o,L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ L3 ) @ ( set_lessThan @ A @ Less2 @ U2 ) ) ) ) ).

% ord.greaterThanLessThan_def
thf(fact_4703_ord_OgreaterThanLessThan__eq,axiom,
    ! [A: $tType] :
      ( ( set_gr287244882034783167ssThan @ A )
      = ( ^ [Less2: A > A > $o,A5: A,B4: A] : ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ A5 ) @ ( set_lessThan @ A @ Less2 @ B4 ) ) ) ) ).

% ord.greaterThanLessThan_eq
thf(fact_4704_ord_OatLeastLessThan__def,axiom,
    ! [A: $tType] :
      ( ( set_atLeastLessThan @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o,L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_atLeast @ A @ Less_eq2 @ L3 ) @ ( set_lessThan @ A @ Less2 @ U2 ) ) ) ) ).

% ord.atLeastLessThan_def
thf(fact_4705_subset__mset_OgreaterThanAtMost__def,axiom,
    ! [A: $tType,L: multiset @ A,U: multiset @ A] :
      ( ( set_gr3752724095348155675AtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( subset_mset @ A ) @ L @ U )
      = ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_greaterThan @ ( multiset @ A ) @ ( subset_mset @ A ) @ L ) @ ( set_atMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ U ) ) ) ).

% subset_mset.greaterThanAtMost_def
thf(fact_4706_ord_OgreaterThanAtMost__def,axiom,
    ! [A: $tType] :
      ( ( set_gr3752724095348155675AtMost @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o,L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ L3 ) @ ( set_atMost @ A @ Less_eq2 @ U2 ) ) ) ) ).

% ord.greaterThanAtMost_def
thf(fact_4707_ord_OatLeastAtMost__def,axiom,
    ! [A: $tType] :
      ( ( set_atLeastAtMost @ A )
      = ( ^ [Less_eq2: A > A > $o,L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_atLeast @ A @ Less_eq2 @ L3 ) @ ( set_atMost @ A @ Less_eq2 @ U2 ) ) ) ) ).

% ord.atLeastAtMost_def
thf(fact_4708_subset__mset_Onot__empty__eq__Iic__eq__empty,axiom,
    ! [A: $tType,H2: multiset @ A] :
      ( ( bot_bot @ ( set @ ( multiset @ A ) ) )
     != ( set_atMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ H2 ) ) ).

% subset_mset.not_empty_eq_Iic_eq_empty
thf(fact_4709_subset__mset_OatLeastAtMost__def,axiom,
    ! [A: $tType,L: multiset @ A,U: multiset @ A] :
      ( ( set_atLeastAtMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ L @ U )
      = ( inf_inf @ ( set @ ( multiset @ A ) ) @ ( set_atLeast @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ L ) @ ( set_atMost @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ U ) ) ) ).

% subset_mset.atLeastAtMost_def
thf(fact_4710_execute__nth_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I: nat,H2: heap_ext @ product_unit,A3: array @ A] :
          ( ( ord_less @ nat @ I @ ( array_length @ A @ H2 @ A3 ) )
         => ( ( heap_Time_execute @ A @ ( array_nth @ A @ A3 @ I ) @ H2 )
            = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( nth @ A @ ( array_get @ A @ H2 @ A3 ) @ I ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% execute_nth(1)
thf(fact_4711_length__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,Xs: list @ A] :
          ( hoare_hoare_triple @ nat @ ( snga_assn @ A @ A3 @ Xs ) @ ( array_len @ A @ A3 )
          @ ^ [R5: nat] :
              ( times_times @ assn @ ( snga_assn @ A @ A3 @ Xs )
              @ ( pure_assn
                @ ( R5
                  = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% length_rule
thf(fact_4712_Array__Time_Onth__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_nth @ A )
        = ( ^ [A5: array @ A,I2: nat] :
              ( heap_Time_guard @ A
              @ ^ [H3: heap_ext @ product_unit] : ( ord_less @ nat @ I2 @ ( array_length @ A @ H3 @ A5 ) )
              @ ^ [H3: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( nth @ A @ ( array_get @ A @ H3 @ A5 ) @ I2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% Array_Time.nth_def
thf(fact_4713_nth__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I: nat,Xs: list @ A,A3: array @ A] :
          ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( hoare_hoare_triple @ A @ ( snga_assn @ A @ A3 @ Xs ) @ ( array_nth @ A @ A3 @ I )
            @ ^ [R5: A] :
                ( times_times @ assn @ ( snga_assn @ A @ A3 @ Xs )
                @ ( pure_assn
                  @ ( R5
                    = ( nth @ A @ Xs @ I ) ) ) ) ) ) ) ).

% nth_rule
thf(fact_4714_nth__step__trancl,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A ),N: nat,M4: nat] :
      ( ! [N3: nat] :
          ( ( ord_less @ nat @ N3 @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ ( suc @ N3 ) ) @ ( nth @ A @ Xs @ N3 ) ) @ R ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ord_less @ nat @ M4 @ N )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N ) @ ( nth @ A @ Xs @ M4 ) ) @ ( transitive_trancl @ A @ R ) ) ) ) ) ).

% nth_step_trancl
thf(fact_4715_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ N @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) @ N )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ ( divide_divide @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) @ ( nth @ B @ Ys @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% product_nth
thf(fact_4716_mergesort__by__rel__split__length,axiom,
    ! [A: $tType,Xs1: list @ A,Xs2: list @ A,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs2 ) @ Xs ) ) )
        = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs1 ) @ ( divide_divide @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( modulo_modulo @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
      & ( ( size_size @ ( list @ A ) @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs2 ) @ Xs ) ) )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( divide_divide @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% mergesort_by_rel_split_length
thf(fact_4717_execute__swap_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I: nat,H2: heap_ext @ product_unit,A3: array @ A,X: A] :
          ( ( ord_less @ nat @ I @ ( array_length @ A @ H2 @ A3 ) )
         => ( ( heap_Time_execute @ A @ ( array_swap @ A @ I @ X @ A3 ) @ H2 )
            = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( nth @ A @ ( array_get @ A @ H2 @ A3 ) @ I ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A3 @ I @ X @ H2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% execute_swap(1)
thf(fact_4718_swap__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_swap @ A )
        = ( ^ [I2: nat,X3: A,A5: array @ A] :
              ( heap_Time_guard @ A
              @ ^ [H3: heap_ext @ product_unit] : ( ord_less @ nat @ I2 @ ( array_length @ A @ H3 @ A5 ) )
              @ ^ [H3: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( nth @ A @ ( array_get @ A @ H3 @ A5 ) @ I2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A5 @ I2 @ X3 @ H3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% swap_def
thf(fact_4719_map__entry__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_map_entry @ A )
        = ( ^ [I2: nat,F2: A > A,A5: array @ A] :
              ( heap_Time_guard @ ( array @ A )
              @ ^ [H3: heap_ext @ product_unit] : ( ord_less @ nat @ I2 @ ( array_length @ A @ H3 @ A5 ) )
              @ ^ [H3: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ A5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A5 @ I2 @ ( F2 @ ( nth @ A @ ( array_get @ A @ H3 @ A5 ) @ I2 ) ) @ H3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% map_entry_def
thf(fact_4720_execute__map__entry_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I: nat,H2: heap_ext @ product_unit,A3: array @ A,F: A > A] :
          ( ( ord_less @ nat @ I @ ( array_length @ A @ H2 @ A3 ) )
         => ( ( heap_Time_execute @ ( array @ A ) @ ( array_map_entry @ A @ I @ F @ A3 ) @ H2 )
            = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ A3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A3 @ I @ ( F @ ( nth @ A @ ( array_get @ A @ H2 @ A3 ) @ I ) ) @ H2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% execute_map_entry(1)
thf(fact_4721_mergesort__by__rel__split_Osimps_I1_J,axiom,
    ! [A: $tType,Xs1: list @ A,Xs2: list @ A] :
      ( ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs2 ) @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs2 ) ) ).

% mergesort_by_rel_split.simps(1)
thf(fact_4722_execute__upd_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I: nat,H2: heap_ext @ product_unit,A3: array @ A,X: A] :
          ( ( ord_less @ nat @ I @ ( array_length @ A @ H2 @ A3 ) )
         => ( ( heap_Time_execute @ ( array @ A ) @ ( array_upd @ A @ I @ X @ A3 ) @ H2 )
            = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ A3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A3 @ I @ X @ H2 ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% execute_upd(1)
thf(fact_4723_upd__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_upd @ A )
        = ( ^ [I2: nat,X3: A,A5: array @ A] :
              ( heap_Time_guard @ ( array @ A )
              @ ^ [H3: heap_ext @ product_unit] : ( ord_less @ nat @ I2 @ ( array_length @ A @ H3 @ A5 ) )
              @ ^ [H3: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ A5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A5 @ I2 @ X3 @ H3 ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% upd_def
thf(fact_4724_execute__of__list,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [Xs: list @ A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( array @ A ) @ ( array_of_list @ A @ Xs ) @ H2 )
          = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R5: array @ A,H8: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H8 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) )
              @ ( array_alloc @ A @ Xs @ H2 ) ) ) ) ) ).

% execute_of_list
thf(fact_4725_effect__of__listI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H4: heap_ext @ product_unit,Xs: list @ A,H2: heap_ext @ product_unit] :
          ( ( ( product_Pair @ ( array @ A ) @ ( heap_ext @ product_unit ) @ A3 @ H4 )
            = ( array_alloc @ A @ Xs @ H2 ) )
         => ( heap_Time_effect @ ( array @ A ) @ ( array_of_list @ A @ Xs ) @ H2 @ H4 @ A3 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% effect_of_listI
thf(fact_4726_of__list__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_of_list @ A )
        = ( ^ [Xs3: list @ A] :
              ( heap_Time_heap @ ( array @ A )
              @ ^ [H3: heap_ext @ product_unit] :
                  ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R5: array @ A,H8: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H8 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) )
                  @ ( array_alloc @ A @ Xs3 @ H3 ) ) ) ) ) ) ).

% of_list_def
thf(fact_4727_Array__Time_Oalloc__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_alloc @ A )
        = ( ^ [Xs3: list @ A,H3: heap_ext @ product_unit] :
              ( product_Pair @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( array2 @ A @ ( lim @ product_unit @ H3 ) )
              @ ( array_set @ A @ ( array2 @ A @ ( lim @ product_unit @ H3 ) ) @ Xs3
                @ ( lim_update @ product_unit
                  @ ^ [Uu: nat] : ( plus_plus @ nat @ ( lim @ product_unit @ H3 ) @ ( one_one @ nat ) )
                  @ H3 ) ) ) ) ) ) ).

% Array_Time.alloc_def
thf(fact_4728_upd__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I: nat,Xs: list @ A,A3: array @ A,X: A] :
          ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( hoare_hoare_triple @ ( array @ A ) @ ( snga_assn @ A @ A3 @ Xs ) @ ( array_upd @ A @ I @ X @ A3 )
            @ ^ [R5: array @ A] : ( times_times @ assn @ ( snga_assn @ A @ A3 @ ( list_update @ A @ Xs @ I @ X ) ) @ ( pure_assn @ ( R5 = A3 ) ) ) ) ) ) ).

% upd_rule
thf(fact_4729_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F2: B > A,A5: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N5: nat] : ( compow @ ( A > A ) @ N5 @ ( times_times @ A @ A5 ) @ ( F2 @ ( nth @ B @ Xs3 @ N5 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_4730_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F2: B > A,A5: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N5: nat] : ( times_times @ A @ ( F2 @ ( nth @ B @ Xs3 @ N5 ) ) @ ( power_power @ A @ A5 @ N5 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_4731_nth__enumerate__eq,axiom,
    ! [A: $tType,M4: nat,Xs: list @ A,N: nat] :
      ( ( ord_less @ nat @ M4 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) @ M4 )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N @ M4 ) @ ( nth @ A @ Xs @ M4 ) ) ) ) ).

% nth_enumerate_eq
thf(fact_4732_mergesort__by__rel_Opinduct,axiom,
    ! [A: $tType,A0: A > A > $o,A1: list @ A,P: ( A > A > $o ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( mergesort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [R13: A > A > $o,Xs4: list @ A] :
            ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( mergesort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ R13 @ Xs4 ) )
           => ( ( ~ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
               => ( P @ R13 @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs4 ) ) ) )
             => ( ( ~ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                 => ( P @ R13 @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs4 ) ) ) )
               => ( P @ R13 @ Xs4 ) ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% mergesort_by_rel.pinduct
thf(fact_4733_mergesort__by__rel_Oelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: list @ A] :
      ( ( ( mergesort_by_rel @ A @ X @ Xa )
        = Y )
     => ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xa ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         => ( Y = Xa ) )
        & ( ~ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xa ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         => ( Y
            = ( merges9089515139780605204_merge @ A @ X @ ( mergesort_by_rel @ A @ X @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xa ) ) ) @ ( mergesort_by_rel @ A @ X @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xa ) ) ) ) ) ) ) ) ).

% mergesort_by_rel.elims
thf(fact_4734_mergesort__by__rel_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ~ ! [R13: A > A > $o,Xs4: list @ A] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ R13 @ Xs4 ) ) ).

% mergesort_by_rel.cases
thf(fact_4735_mergesort__by__rel_Opsimps,axiom,
    ! [A: $tType,R: A > A > $o,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( mergesort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ R @ Xs ) )
     => ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         => ( ( mergesort_by_rel @ A @ R @ Xs )
            = Xs ) )
        & ( ~ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         => ( ( mergesort_by_rel @ A @ R @ Xs )
            = ( merges9089515139780605204_merge @ A @ R @ ( mergesort_by_rel @ A @ R @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs ) ) ) @ ( mergesort_by_rel @ A @ R @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs ) ) ) ) ) ) ) ) ).

% mergesort_by_rel.psimps
thf(fact_4736_mergesort__by__rel_Opelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: list @ A] :
      ( ( ( mergesort_by_rel @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( mergesort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ~ ( ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xa ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
               => ( Y = Xa ) )
              & ( ~ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xa ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
               => ( Y
                  = ( merges9089515139780605204_merge @ A @ X @ ( mergesort_by_rel @ A @ X @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xa ) ) ) @ ( mergesort_by_rel @ A @ X @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xa ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( mergesort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) ) ) ) ) ).

% mergesort_by_rel.pelims
thf(fact_4737_mergesort__by__rel_Osimps,axiom,
    ! [A: $tType] :
      ( ( mergesort_by_rel @ A )
      = ( ^ [R2: A > A > $o,Xs3: list @ A] : ( if @ ( list @ A ) @ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Xs3 @ ( merges9089515139780605204_merge @ A @ R2 @ ( mergesort_by_rel @ A @ R2 @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs3 ) ) ) @ ( mergesort_by_rel @ A @ R2 @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs3 ) ) ) ) ) ) ) ).

% mergesort_by_rel.simps
thf(fact_4738_mergesort__by__rel__simps_I3_J,axiom,
    ! [A: $tType,R: A > A > $o,X1: A,X22: A,Xs: list @ A] :
      ( ( mergesort_by_rel @ A @ R @ ( cons @ A @ X1 @ ( cons @ A @ X22 @ Xs ) ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
        @ ^ [Xs12: list @ A,Xs22: list @ A] : ( merges9089515139780605204_merge @ A @ R @ ( mergesort_by_rel @ A @ R @ Xs12 ) @ ( mergesort_by_rel @ A @ R @ Xs22 ) )
        @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X1 @ ( nil @ A ) ) @ ( cons @ A @ X22 @ ( nil @ A ) ) ) @ Xs ) ) ) ).

% mergesort_by_rel_simps(3)
thf(fact_4739_execute__new,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,X: A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( array @ A ) @ ( array_new @ A @ N @ X ) @ H2 )
          = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R5: array @ A,H8: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H8 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
              @ ( array_alloc @ A @ ( replicate @ A @ N @ X ) @ H2 ) ) ) ) ) ).

% execute_new
thf(fact_4740_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
      = ( ? [Y2: A,N5: nat] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N5 ) @ Y2 ) @ R4 )
            & ( ord_less @ nat @ N5 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( Ys
              = ( list_update @ A @ Xs @ N5 @ Y2 ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_4741_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( listrel1 @ A @ R4 ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
          & ( Xs = Ys ) )
        | ( ( X = Y )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) ) ) ) ) ).

% Cons_listrel1_Cons
thf(fact_4742_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F: B > A,A3: A,X: B,Xs: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F @ A3 @ ( cons @ B @ X @ Xs ) )
          = ( plus_plus @ A @ ( F @ X ) @ ( times_times @ A @ A3 @ ( groups4207007520872428315er_sum @ B @ A @ F @ A3 @ Xs ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_4743_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs: list @ B] :
      ( ( enumerate @ B @ N @ ( cons @ B @ X @ Xs ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N @ X ) @ ( enumerate @ B @ ( suc @ N ) @ Xs ) ) ) ).

% enumerate_simps(2)
thf(fact_4744_listrel1I1,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Xs ) ) @ ( listrel1 @ A @ R4 ) ) ) ).

% listrel1I1
thf(fact_4745_listrel1I2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys ) ) @ ( listrel1 @ A @ R4 ) ) ) ).

% listrel1I2
thf(fact_4746_Cons__listrel1E1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ys ) @ ( listrel1 @ A @ R4 ) )
     => ( ! [Y3: A] :
            ( ( Ys
              = ( cons @ A @ Y3 @ Xs ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R4 ) )
       => ~ ! [Zs: list @ A] :
              ( ( Ys
                = ( cons @ A @ X @ Zs ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( listrel1 @ A @ R4 ) ) ) ) ) ).

% Cons_listrel1E1
thf(fact_4747_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( cons @ A @ Y @ Ys ) ) @ ( listrel1 @ A @ R4 ) )
     => ( ! [X2: A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Ys ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ R4 ) )
       => ~ ! [Zs: list @ A] :
              ( ( Xs
                = ( cons @ A @ Y @ Zs ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Zs @ Ys ) @ ( listrel1 @ A @ R4 ) ) ) ) ) ).

% Cons_listrel1E2
thf(fact_4748_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ) ) ).

% rtrancl_listrel1_ConsI2
thf(fact_4749_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ) ).

% rtrancl_listrel1_ConsI1
thf(fact_4750_zipf_Ocases,axiom,
    ! [C: $tType,A: $tType,B: $tType,X: product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F10: A > B > C] :
          ( X
         != ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F10 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) ) )
     => ( ! [F10: A > B > C,A8: A,As2: list @ A,B6: B,Bs2: list @ B] :
            ( X
           != ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F10 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A8 @ As2 ) @ ( cons @ B @ B6 @ Bs2 ) ) ) )
       => ( ! [A8: A > B > C,V4: A,Va: list @ A] :
              ( X
             != ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ A8 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ V4 @ Va ) @ ( nil @ B ) ) ) )
         => ~ ! [A8: A > B > C,V4: B,Va: list @ B] :
                ( X
               != ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ A8 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( cons @ B @ V4 @ Va ) ) ) ) ) ) ) ).

% zipf.cases
thf(fact_4751_merge_Ocases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: product_prod @ ( list @ A ) @ ( list @ A )] :
          ( ! [L22: list @ A] :
              ( X
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ L22 ) )
         => ( ! [V4: A,Va: list @ A] :
                ( X
               != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ V4 @ Va ) @ ( nil @ A ) ) )
           => ~ ! [X12: A,L12: list @ A,X23: A,L22: list @ A] :
                  ( X
                 != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X12 @ L12 ) @ ( cons @ A @ X23 @ L22 ) ) ) ) ) ) ).

% merge.cases
thf(fact_4752_list__all__zip_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [P5: A > B > $o] :
          ( X
         != ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ P5 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) ) )
     => ( ! [P5: A > B > $o,A8: A,As2: list @ A,B6: B,Bs2: list @ B] :
            ( X
           != ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ P5 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A8 @ As2 ) @ ( cons @ B @ B6 @ Bs2 ) ) ) )
       => ( ! [P5: A > B > $o,V4: A,Va: list @ A] :
              ( X
             != ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ P5 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ V4 @ Va ) @ ( nil @ B ) ) ) )
         => ~ ! [P5: A > B > $o,V4: B,Va: list @ B] :
                ( X
               != ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ P5 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( cons @ B @ V4 @ Va ) ) ) ) ) ) ) ).

% list_all_zip.cases
thf(fact_4753_partition__rev_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) )] :
      ( ! [P5: A > $o,Yes: list @ A,No: list @ A] :
          ( X
         != ( product_Pair @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ P5 @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) @ ( nil @ A ) ) ) )
     => ~ ! [P5: A > $o,Yes: list @ A,No: list @ A,X2: A,Xs4: list @ A] :
            ( X
           != ( product_Pair @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ P5 @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) @ ( cons @ A @ X2 @ Xs4 ) ) ) ) ) ).

% partition_rev.cases
thf(fact_4754_quicksort__by__rel_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )] :
      ( ! [R13: A > A > $o,Sl: list @ A] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R13 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl @ ( nil @ A ) ) ) )
     => ~ ! [R13: A > A > $o,Sl: list @ A,X2: A,Xs4: list @ A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R13 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl @ ( cons @ A @ X2 @ Xs4 ) ) ) ) ) ).

% quicksort_by_rel.cases
thf(fact_4755_mergesort__by__rel__merge_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )] :
      ( ! [R13: A > A > $o,X2: A,Xs4: list @ A,Y3: A,Ys2: list @ A] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R13 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys2 ) ) ) )
     => ( ! [R13: A > A > $o,Xs4: list @ A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R13 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs4 @ ( nil @ A ) ) ) )
       => ~ ! [R13: A > A > $o,V4: A,Va: list @ A] :
              ( X
             != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R13 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( cons @ A @ V4 @ Va ) ) ) ) ) ) ).

% mergesort_by_rel_merge.cases
thf(fact_4756_mergesort__by__rel__split_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A )] :
      ( ! [Xs13: list @ A,Xs23: list @ A] :
          ( X
         != ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) @ ( nil @ A ) ) )
     => ( ! [Xs13: list @ A,Xs23: list @ A,X2: A] :
            ( X
           != ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
       => ~ ! [Xs13: list @ A,Xs23: list @ A,X12: A,X23: A,Xs4: list @ A] :
              ( X
             != ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) @ ( cons @ A @ X12 @ ( cons @ A @ X23 @ Xs4 ) ) ) ) ) ) ).

% mergesort_by_rel_split.cases
thf(fact_4757_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F10: A > B,Bs2: list @ B] :
          ( X
         != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F10 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Bs2 ) ) )
     => ~ ! [F10: A > B,A8: A,As2: list @ A,Bs2: list @ B] :
            ( X
           != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F10 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A8 @ As2 ) @ Bs2 ) ) ) ) ).

% map_tailrec_rev.cases
thf(fact_4758_shuffles_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys2: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) )
     => ( ! [Xs4: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs4 @ ( nil @ A ) ) )
       => ~ ! [X2: A,Xs4: list @ A,Y3: A,Ys2: list @ A] :
              ( X
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys2 ) ) ) ) ) ).

% shuffles.cases
thf(fact_4759_subset__eq__mset__impl_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys2: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) )
     => ~ ! [X2: A,Xs4: list @ A,Ys2: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs4 ) @ Ys2 ) ) ) ).

% subset_eq_mset_impl.cases
thf(fact_4760_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: product_prod @ ( A > B ) @ ( list @ A )] :
          ( ! [F10: A > B,X2: A] :
              ( X
             != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F10 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
         => ( ! [F10: A > B,X2: A,Y3: A,Zs: list @ A] :
                ( X
               != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F10 @ ( cons @ A @ X2 @ ( cons @ A @ Y3 @ Zs ) ) ) )
           => ~ ! [A8: A > B] :
                  ( X
                 != ( product_Pair @ ( A > B ) @ ( list @ A ) @ A8 @ ( nil @ A ) ) ) ) ) ) ).

% arg_min_list.cases
thf(fact_4761_successively_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P5: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P5 @ ( nil @ A ) ) )
     => ( ! [P5: A > A > $o,X2: A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P5 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
       => ~ ! [P5: A > A > $o,X2: A,Y3: A,Xs4: list @ A] :
              ( X
             != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P5 @ ( cons @ A @ X2 @ ( cons @ A @ Y3 @ Xs4 ) ) ) ) ) ) ).

% successively.cases
thf(fact_4762_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P5: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P5 @ ( nil @ A ) ) )
     => ~ ! [P5: A > A > $o,X2: A,Ys2: list @ A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P5 @ ( cons @ A @ X2 @ Ys2 ) ) ) ) ).

% sorted_wrt.cases
thf(fact_4763_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( listrel1 @ A @ R4 ) ) ).

% not_listrel1_Nil
thf(fact_4764_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xs ) @ ( listrel1 @ A @ R4 ) ) ).

% not_Nil_listrel1
thf(fact_4765_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) )
     => ( ( size_size @ ( list @ A ) @ X )
        = ( size_size @ ( list @ A ) @ Y ) ) ) ).

% rtrancl_listrel1_eq_len
thf(fact_4766_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% listrel1_eq_len
thf(fact_4767_mergesort__by__rel__split_Osimps_I3_J,axiom,
    ! [A: $tType,Xs1: list @ A,Xs2: list @ A,X1: A,X22: A,Xs: list @ A] :
      ( ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs2 ) @ ( cons @ A @ X1 @ ( cons @ A @ X22 @ Xs ) ) )
      = ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X1 @ Xs1 ) @ ( cons @ A @ X22 @ Xs2 ) ) @ Xs ) ) ).

% mergesort_by_rel_split.simps(3)
thf(fact_4768_in__listrel1__converse,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( listrel1 @ A @ ( converse @ A @ A @ R4 ) ) )
      = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( converse @ ( list @ A ) @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ) ).

% in_listrel1_converse
thf(fact_4769_new__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,X: A] :
          ( hoare_hoare_triple @ ( array @ A ) @ ( one_one @ assn ) @ ( array_new @ A @ N @ X )
          @ ^ [R5: array @ A] : ( snga_assn @ A @ R5 @ ( replicate @ A @ N @ X ) ) ) ) ).

% new_rule
thf(fact_4770_mergesort__by__rel__split_Osimps_I2_J,axiom,
    ! [A: $tType,Xs1: list @ A,Xs2: list @ A,X: A] :
      ( ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs2 ) @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs1 ) @ Xs2 ) ) ).

% mergesort_by_rel_split.simps(2)
thf(fact_4771_mergesort__by__rel__split_Oelims,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A ),Xa: list @ A,Y: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ( ( merges295452479951948502_split @ A @ X @ Xa )
        = Y )
     => ( ! [Xs13: list @ A,Xs23: list @ A] :
            ( ( X
              = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) )
           => ( ( Xa
                = ( nil @ A ) )
             => ( Y
               != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) ) ) )
       => ( ! [Xs13: list @ A,Xs23: list @ A] :
              ( ( X
                = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) )
             => ! [X2: A] :
                  ( ( Xa
                    = ( cons @ A @ X2 @ ( nil @ A ) ) )
                 => ( Y
                   != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs13 ) @ Xs23 ) ) ) )
         => ~ ! [Xs13: list @ A,Xs23: list @ A] :
                ( ( X
                  = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) )
               => ! [X12: A,X23: A,Xs4: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ X12 @ ( cons @ A @ X23 @ Xs4 ) ) )
                   => ( Y
                     != ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X12 @ Xs13 ) @ ( cons @ A @ X23 @ Xs23 ) ) @ Xs4 ) ) ) ) ) ) ) ).

% mergesort_by_rel_split.elims
thf(fact_4772_effect__newI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H4: heap_ext @ product_unit,N: nat,X: A,H2: heap_ext @ product_unit] :
          ( ( ( product_Pair @ ( array @ A ) @ ( heap_ext @ product_unit ) @ A3 @ H4 )
            = ( array_alloc @ A @ ( replicate @ A @ N @ X ) @ H2 ) )
         => ( heap_Time_effect @ ( array @ A ) @ ( array_new @ A @ N @ X ) @ H2 @ H4 @ A3 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% effect_newI
thf(fact_4773_new__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_new @ A )
        = ( ^ [N5: nat,X3: A] :
              ( heap_Time_heap @ ( array @ A )
              @ ^ [H3: heap_ext @ product_unit] :
                  ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R5: array @ A,H8: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H8 @ ( plus_plus @ nat @ N5 @ ( one_one @ nat ) ) ) )
                  @ ( array_alloc @ A @ ( replicate @ A @ N5 @ X3 ) @ H3 ) ) ) ) ) ) ).

% new_def
thf(fact_4774_listrel1p__def,axiom,
    ! [A: $tType] :
      ( ( listrel1p @ A )
      = ( ^ [R5: A > A > $o,Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( listrel1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% listrel1p_def
thf(fact_4775_mergesort__by__rel__merge_Opelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Xb: list @ A,Y: list @ A] :
      ( ( ( merges9089515139780605204_merge @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( merges2244889521215249637ge_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ Xb ) ) )
       => ( ! [X2: A,Xs4: list @ A] :
              ( ( Xa
                = ( cons @ A @ X2 @ Xs4 ) )
             => ! [Y3: A,Ys2: list @ A] :
                  ( ( Xb
                    = ( cons @ A @ Y3 @ Ys2 ) )
                 => ( ( ( ( X @ X2 @ Y3 )
                       => ( Y
                          = ( cons @ A @ X2 @ ( merges9089515139780605204_merge @ A @ X @ Xs4 @ ( cons @ A @ Y3 @ Ys2 ) ) ) ) )
                      & ( ~ ( X @ X2 @ Y3 )
                       => ( Y
                          = ( cons @ A @ Y3 @ ( merges9089515139780605204_merge @ A @ X @ ( cons @ A @ X2 @ Xs4 ) @ Ys2 ) ) ) ) )
                   => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( merges2244889521215249637ge_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys2 ) ) ) ) ) ) )
         => ( ( ( Xb
                = ( nil @ A ) )
             => ( ( Y = Xa )
               => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( merges2244889521215249637ge_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ ( nil @ A ) ) ) ) ) )
           => ~ ( ( Xa
                  = ( nil @ A ) )
               => ! [V4: A,Va: list @ A] :
                    ( ( Xb
                      = ( cons @ A @ V4 @ Va ) )
                   => ( ( Y
                        = ( cons @ A @ V4 @ Va ) )
                     => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( merges2244889521215249637ge_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( cons @ A @ V4 @ Va ) ) ) ) ) ) ) ) ) ) ) ).

% mergesort_by_rel_merge.pelims
thf(fact_4776_lexn_Osimps_I2_J,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( lexn @ A @ R4 @ ( suc @ N ) )
      = ( inf_inf @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image2 @ ( product_prod @ ( product_prod @ A @ ( list @ A ) ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_map_prod @ ( product_prod @ A @ ( list @ A ) ) @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( list @ A ) @ ( product_case_prod @ A @ ( list @ A ) @ ( list @ A ) @ ( cons @ A ) ) @ ( product_case_prod @ A @ ( list @ A ) @ ( list @ A ) @ ( cons @ A ) ) ) @ ( lex_prod @ A @ ( list @ A ) @ R4 @ ( lexn @ A @ R4 @ N ) ) )
        @ ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
          @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Xs3: list @ A,Ys3: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs3 )
                  = ( suc @ N ) )
                & ( ( size_size @ ( list @ A ) @ Ys3 )
                  = ( suc @ N ) ) ) ) ) ) ) ).

% lexn.simps(2)
thf(fact_4777_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R4 @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_4778_lexn__length,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexn @ A @ R4 @ N ) )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = N )
        & ( ( size_size @ ( list @ A ) @ Ys )
          = N ) ) ) ).

% lexn_length
thf(fact_4779_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( set_Cons @ A @ A4 @ ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
      = ( image2 @ A @ ( list @ A )
        @ ^ [X3: A] : ( cons @ A @ X3 @ ( nil @ A ) )
        @ A4 ) ) ).

% set_Cons_sing_Nil
thf(fact_4780_part__code_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F: B > A,Pivot: A,X: B,Xs: list @ B] :
          ( ( linorder_part @ B @ A @ F @ Pivot @ ( cons @ B @ X @ Xs ) )
          = ( product_case_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) )
            @ ^ [Lts: list @ B] :
                ( product_case_prod @ ( list @ B ) @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) )
                @ ^ [Eqs: list @ B,Gts: list @ B] : ( if @ ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) ) @ ( ord_less @ A @ ( F @ X ) @ Pivot ) @ ( product_Pair @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ ( cons @ B @ X @ Lts ) @ ( product_Pair @ ( list @ B ) @ ( list @ B ) @ Eqs @ Gts ) ) @ ( if @ ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) ) @ ( ord_less @ A @ Pivot @ ( F @ X ) ) @ ( product_Pair @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ Lts @ ( product_Pair @ ( list @ B ) @ ( list @ B ) @ Eqs @ ( cons @ B @ X @ Gts ) ) ) @ ( product_Pair @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ Lts @ ( product_Pair @ ( list @ B ) @ ( list @ B ) @ ( cons @ B @ X @ Eqs ) @ Gts ) ) ) ) )
            @ ( linorder_part @ B @ A @ F @ Pivot @ Xs ) ) ) ) ).

% part_code(2)
thf(fact_4781_part__code_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F: B > A,Pivot: A] :
          ( ( linorder_part @ B @ A @ F @ Pivot @ ( nil @ B ) )
          = ( product_Pair @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ ( nil @ B ) @ ( product_Pair @ ( list @ B ) @ ( list @ B ) @ ( nil @ B ) @ ( nil @ B ) ) ) ) ) ).

% part_code(1)
thf(fact_4782_listrel__Cons,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ B @ A ),X: B,Xs: list @ B] :
      ( ( image @ ( list @ B ) @ ( list @ A ) @ ( listrel @ B @ A @ R4 ) @ ( insert2 @ ( list @ B ) @ ( cons @ B @ X @ Xs ) @ ( bot_bot @ ( set @ ( list @ B ) ) ) ) )
      = ( set_Cons @ A @ ( image @ B @ A @ R4 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) @ ( image @ ( list @ B ) @ ( list @ A ) @ ( listrel @ B @ A @ R4 ) @ ( insert2 @ ( list @ B ) @ Xs @ ( bot_bot @ ( set @ ( list @ B ) ) ) ) ) ) ) ).

% listrel_Cons
thf(fact_4783_listset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( listset @ A @ ( nil @ ( set @ A ) ) )
      = ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listset.simps(1)
thf(fact_4784_extract__Cons__code,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( extract @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( nil @ A ) @ ( product_Pair @ A @ ( list @ A ) @ X @ Xs ) ) ) ) )
      & ( ~ ( P @ X )
       => ( ( extract @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( case_option @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
              @ ^ [Ys3: list @ A] :
                  ( product_case_prod @ A @ ( list @ A ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
                  @ ^ [Y2: A,Zs2: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( cons @ A @ X @ Ys3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Zs2 ) ) ) ) )
            @ ( extract @ A @ P @ Xs ) ) ) ) ) ).

% extract_Cons_code
thf(fact_4785_listrel__rtrancl__refl,axiom,
    ! [A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) ) ) ).

% listrel_rtrancl_refl
thf(fact_4786_listrel__Nil,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ B @ A )] :
      ( ( image @ ( list @ B ) @ ( list @ A ) @ ( listrel @ B @ A @ R4 ) @ ( insert2 @ ( list @ B ) @ ( nil @ B ) @ ( bot_bot @ ( set @ ( list @ B ) ) ) ) )
      = ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listrel_Nil
thf(fact_4787_listrel_ONil,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B )] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) @ ( listrel @ A @ B @ R4 ) ) ).

% listrel.Nil
thf(fact_4788_listrel__Nil1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xs ) @ ( listrel @ A @ B @ R4 ) )
     => ( Xs
        = ( nil @ B ) ) ) ).

% listrel_Nil1
thf(fact_4789_listrel__Nil2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( nil @ B ) ) @ ( listrel @ A @ B @ R4 ) )
     => ( Xs
        = ( nil @ A ) ) ) ).

% listrel_Nil2
thf(fact_4790_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R4 ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% listrel_eq_len
thf(fact_4791_listrel__rtrancl__trans,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),Zs3: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs3 ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs3 ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ) ).

% listrel_rtrancl_trans
thf(fact_4792_listrel__Cons2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( cons @ B @ Y @ Ys ) ) @ ( listrel @ A @ B @ R4 ) )
     => ~ ! [X2: A,Xs4: list @ A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Xs4 ) )
           => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ R4 )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs4 @ Ys ) @ ( listrel @ A @ B @ R4 ) ) ) ) ) ).

% listrel_Cons2
thf(fact_4793_listrel__Cons1,axiom,
    ! [B: $tType,A: $tType,Y: A,Ys: list @ A,Xs: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ Y @ Ys ) @ Xs ) @ ( listrel @ A @ B @ R4 ) )
     => ~ ! [Y3: B,Ys2: list @ B] :
            ( ( Xs
              = ( cons @ B @ Y3 @ Ys2 ) )
           => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ Y3 ) @ R4 )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Ys @ Ys2 ) @ ( listrel @ A @ B @ R4 ) ) ) ) ) ).

% listrel_Cons1
thf(fact_4794_listrel_OCons,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,R4: set @ ( product_prod @ A @ B ),Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ R4 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R4 ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) ) @ ( listrel @ A @ B @ R4 ) ) ) ) ).

% listrel.Cons
thf(fact_4795_listrel__reflcl__if__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ).

% listrel_reflcl_if_listrel1
thf(fact_4796_rtrancl__listrel1__if__listrel,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ R4 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ) ).

% rtrancl_listrel1_if_listrel
thf(fact_4797_listrel_Osimps,axiom,
    ! [B: $tType,A: $tType,A1: list @ A,A22: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A22 ) @ ( listrel @ A @ B @ R4 ) )
      = ( ( ( A1
            = ( nil @ A ) )
          & ( A22
            = ( nil @ B ) ) )
        | ? [X3: A,Y2: B,Xs3: list @ A,Ys3: list @ B] :
            ( ( A1
              = ( cons @ A @ X3 @ Xs3 ) )
            & ( A22
              = ( cons @ B @ Y2 @ Ys3 ) )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R4 )
            & ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs3 @ Ys3 ) @ ( listrel @ A @ B @ R4 ) ) ) ) ) ).

% listrel.simps
thf(fact_4798_listrel_Ocases,axiom,
    ! [B: $tType,A: $tType,A1: list @ A,A22: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A22 ) @ ( listrel @ A @ B @ R4 ) )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A22
           != ( nil @ B ) ) )
       => ~ ! [X2: A,Y3: B,Xs4: list @ A] :
              ( ( A1
                = ( cons @ A @ X2 @ Xs4 ) )
             => ! [Ys2: list @ B] :
                  ( ( A22
                    = ( cons @ B @ Y3 @ Ys2 ) )
                 => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ R4 )
                   => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs4 @ Ys2 ) @ ( listrel @ A @ B @ R4 ) ) ) ) ) ) ) ).

% listrel.cases
thf(fact_4799_listrel__iff__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R4 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [N5: nat] :
            ( ( ord_less @ nat @ N5 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( nth @ A @ Xs @ N5 ) @ ( nth @ B @ Ys @ N5 ) ) @ R4 ) ) ) ) ).

% listrel_iff_nth
thf(fact_4800_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( linord4507533701916653071of_set @ A @ A4 )
              = ( cons @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set_nonempty
thf(fact_4801_upto_Opelims,axiom,
    ! [X: int,Xa: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X @ Xa )
               => ( Y
                  = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X @ Xa )
               => ( Y
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% upto.pelims
thf(fact_4802_upto_Opsimps,axiom,
    ! [I: int,J2: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I @ J2 ) )
     => ( ( ( ord_less_eq @ int @ I @ J2 )
         => ( ( upto @ I @ J2 )
            = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I @ J2 )
         => ( ( upto @ I @ J2 )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_4803_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
thf(fact_4804_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( linord4507533701916653071of_set @ A @ A4 )
              = ( nil @ A ) )
            = ( A4
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
thf(fact_4805_Cons__lenlex__iff,axiom,
    ! [A: $tType,M4: A,Ms: list @ A,N: A,Ns: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M4 @ Ms ) @ ( cons @ A @ N @ Ns ) ) @ ( lenlex @ A @ R4 ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M4 @ N ) @ R4 ) )
        | ( ( M4 = N )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R4 ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_4806_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),N5: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = N5 )
                  & ( ( size_size @ ( list @ A ) @ Ys3 )
                    = N5 )
                  & ? [Xys: list @ A,X3: A,Y2: A,Xs5: list @ A,Ys4: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X3 @ Xs5 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y2 @ Ys4 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_4807_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ns ) @ ( lenlex @ A @ R4 ) )
      = ( ( Ns
         != ( nil @ A ) ) ) ) ).

% Nil_lenlex_iff1
thf(fact_4808_lenlex__append2,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Us: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( irrefl @ A @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Xs ) @ ( append @ A @ Us @ Ys ) ) @ ( lenlex @ A @ R ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lenlex @ A @ R ) ) ) ) ).

% lenlex_append2
thf(fact_4809_append_Omonoid__axioms,axiom,
    ! [A: $tType] : ( monoid @ ( list @ A ) @ ( append @ A ) @ ( nil @ A ) ) ).

% append.monoid_axioms
thf(fact_4810_lenlex__append1,axiom,
    ! [A: $tType,Us: list @ A,Xs: list @ A,R: set @ ( product_prod @ A @ A ),Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Xs ) @ ( lenlex @ A @ R ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Vs ) @ ( append @ A @ Xs @ Ys ) ) @ ( lenlex @ A @ R ) ) ) ) ).

% lenlex_append1
thf(fact_4811_append__listrel1I,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),Us: list @ A,Vs: list @ A] :
      ( ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
          & ( Us = Vs ) )
        | ( ( Xs = Ys )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Vs ) @ ( listrel1 @ A @ R4 ) ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( listrel1 @ A @ R4 ) ) ) ).

% append_listrel1I
thf(fact_4812_lenlex__irreflexive,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X2: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R4 )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lenlex @ A @ R4 ) ) ) ).

% lenlex_irreflexive
thf(fact_4813_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ns @ ( nil @ A ) ) @ ( lenlex @ A @ R4 ) ) ).

% Nil_lenlex_iff2
thf(fact_4814_lenlex__trans,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A ),Z2: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lenlex @ A @ R4 ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y @ Z2 ) @ ( lenlex @ A @ R4 ) )
       => ( ( trans @ A @ R4 )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Z2 ) @ ( lenlex @ A @ R4 ) ) ) ) ) ).

% lenlex_trans
thf(fact_4815_listrel1I,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),Xs: list @ A,Us: list @ A,Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
     => ( ( Xs
          = ( append @ A @ Us @ ( cons @ A @ X @ Vs ) ) )
       => ( ( Ys
            = ( append @ A @ Us @ ( cons @ A @ Y @ Vs ) ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) ) ) ) ) ).

% listrel1I
thf(fact_4816_listrel1E,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
     => ~ ! [X2: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R4 )
           => ! [Us2: list @ A,Vs2: list @ A] :
                ( ( Xs
                  = ( append @ A @ Us2 @ ( cons @ A @ X2 @ Vs2 ) ) )
               => ( Ys
                 != ( append @ A @ Us2 @ ( cons @ A @ Y3 @ Vs2 ) ) ) ) ) ) ).

% listrel1E
thf(fact_4817_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R4 ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_4818_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) @ ( listrel1 @ A @ R4 ) )
      = ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
          & ( X = Y ) )
        | ( ( Xs = Ys )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 ) ) ) ) ).

% snoc_listrel1_snoc_iff
thf(fact_4819_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F: B > A,A3: A,Xs: list @ B,Ys: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F @ A3 @ ( append @ B @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F @ A3 @ Xs ) @ ( times_times @ A @ ( power_power @ A @ A3 @ ( size_size @ ( list @ B ) @ Xs ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F @ A3 @ Ys ) ) ) ) ) ).

% horner_sum_append
thf(fact_4820_listrel1__def,axiom,
    ! [A: $tType] :
      ( ( listrel1 @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                ? [Us3: list @ A,Z4: A,Z10: A,Vs3: list @ A] :
                  ( ( Xs3
                    = ( append @ A @ Us3 @ ( cons @ A @ Z4 @ Vs3 ) ) )
                  & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z4 @ Z10 ) @ R5 )
                  & ( Ys3
                    = ( append @ A @ Us3 @ ( cons @ A @ Z10 @ Vs3 ) ) ) ) ) ) ) ) ).

% listrel1_def
thf(fact_4821_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = ( size_size @ ( list @ A ) @ Ys3 ) )
                  & ? [Xys: list @ A,X3: A,Y2: A,Xs5: list @ A,Ys4: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X3 @ Xs5 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y2 @ Ys4 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_4822_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( size_size @ ( list @ A ) @ Ys3 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs3 )
                      = ( size_size @ ( list @ A ) @ Ys3 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_4823_lexord__def,axiom,
    ! [A: $tType] :
      ( ( lexord @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [X3: list @ A,Y2: list @ A] :
                ? [A5: A,V3: list @ A] :
                  ( ( Y2
                    = ( append @ A @ X3 @ ( cons @ A @ A5 @ V3 ) ) )
                  | ? [U2: list @ A,B4: A,C5: A,W3: list @ A,Z4: list @ A] :
                      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C5 ) @ R5 )
                      & ( X3
                        = ( append @ A @ U2 @ ( cons @ A @ B4 @ W3 ) ) )
                      & ( Y2
                        = ( append @ A @ U2 @ ( cons @ A @ C5 @ Z4 ) ) ) ) ) ) ) ) ) ).

% lexord_def
thf(fact_4824_lexord__cons__cons,axiom,
    ! [A: $tType,A3: A,X: list @ A,B2: A,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A3 @ X ) @ ( cons @ A @ B2 @ Y ) ) @ ( lexord @ A @ R4 ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
        | ( ( A3 = B2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R4 ) ) ) ) ) ).

% lexord_cons_cons
thf(fact_4825_lexord__Nil__left,axiom,
    ! [A: $tType,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Y ) @ ( lexord @ A @ R4 ) )
      = ( ? [A5: A,X3: list @ A] :
            ( Y
            = ( cons @ A @ A5 @ X3 ) ) ) ) ).

% lexord_Nil_left
thf(fact_4826_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs3: list @ A] :
      ( ( irrefl @ A @ R4 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs3 ) ) @ ( lexord @ A @ R4 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs3 ) @ ( lexord @ A @ R4 ) ) ) ) ).

% lexord_same_pref_if_irrefl
thf(fact_4827_Cons__in__lex,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( lex @ A @ R4 ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
          & ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) ) )
        | ( ( X = Y )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R4 ) ) ) ) ) ).

% Cons_in_lex
thf(fact_4828_lexord__lex,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lex @ A @ R4 ) )
      = ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R4 ) )
        & ( ( size_size @ ( list @ A ) @ X )
          = ( size_size @ ( list @ A ) @ Y ) ) ) ) ).

% lexord_lex
thf(fact_4829_lexord__linear,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: list @ A,Y: list @ A] :
      ( ! [A8: A,B6: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A8 @ B6 ) @ R4 )
          | ( A8 = B6 )
          | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A8 ) @ R4 ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R4 ) )
        | ( X = Y )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y @ X ) @ ( lexord @ A @ R4 ) ) ) ) ).

% lexord_linear
thf(fact_4830_lexord__irreflexive,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X2: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R4 )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_irreflexive
thf(fact_4831_lexord__Nil__right,axiom,
    ! [A: $tType,X: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) @ ( lexord @ A @ R4 ) ) ).

% lexord_Nil_right
thf(fact_4832_lexord__append__leftI,axiom,
    ! [A: $tType,U: list @ A,V: list @ A,R4: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V ) @ ( lexord @ A @ R4 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V ) ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_append_leftI
thf(fact_4833_lexord__trans,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A ),Z2: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R4 ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y @ Z2 ) @ ( lexord @ A @ R4 ) )
       => ( ( trans @ A @ R4 )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Z2 ) @ ( lexord @ A @ R4 ) ) ) ) ) ).

% lexord_trans
thf(fact_4834_lexord__asymmetric,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),A3: list @ A,B2: list @ A] :
      ( ( asym @ A @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A3 @ B2 ) @ ( lexord @ A @ R ) )
       => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ B2 @ A3 ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_asymmetric
thf(fact_4835_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( lex @ A @ R4 ) ) ).

% Nil2_notin_lex
thf(fact_4836_Nil__notin__lex,axiom,
    ! [A: $tType,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) @ ( lex @ A @ R4 ) ) ).

% Nil_notin_lex
thf(fact_4837_lex__append__leftI,axiom,
    ! [A: $tType,Ys: list @ A,Zs3: list @ A,R4: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs3 ) @ ( lex @ A @ R4 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs3 ) ) @ ( lex @ A @ R4 ) ) ) ).

% lex_append_leftI
thf(fact_4838_lexl__not__refl,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( irrefl @ A @ R4 )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ X ) @ ( lex @ A @ R4 ) ) ) ).

% lexl_not_refl
thf(fact_4839_lexord__append__leftD,axiom,
    ! [A: $tType,X: list @ A,U: list @ A,V: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V ) ) @ ( lexord @ A @ R4 ) )
     => ( ! [A8: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A8 @ A8 ) @ R4 )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V ) @ ( lexord @ A @ R4 ) ) ) ) ).

% lexord_append_leftD
thf(fact_4840_lexord__append__rightI,axiom,
    ! [A: $tType,Y: list @ A,X: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ? [B11: A,Z6: list @ A] :
          ( Y
          = ( cons @ A @ B11 @ Z6 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( append @ A @ X @ Y ) ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_append_rightI
thf(fact_4841_lexord__sufE,axiom,
    ! [A: $tType,Xs: list @ A,Zs3: list @ A,Ys: list @ A,Qs: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Zs3 ) @ ( append @ A @ Ys @ Qs ) ) @ ( lexord @ A @ R4 ) )
     => ( ( Xs != Ys )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) )
         => ( ( ( size_size @ ( list @ A ) @ Zs3 )
              = ( size_size @ ( list @ A ) @ Qs ) )
           => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R4 ) ) ) ) ) ) ).

% lexord_sufE
thf(fact_4842_lex__append__left__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs3: list @ A] :
      ( ! [X2: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R4 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs3 ) ) @ ( lex @ A @ R4 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs3 ) @ ( lex @ A @ R4 ) ) ) ) ).

% lex_append_left_iff
thf(fact_4843_lex__append__leftD,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs3: list @ A] :
      ( ! [X2: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R4 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs3 ) ) @ ( lex @ A @ R4 ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs3 ) @ ( lex @ A @ R4 ) ) ) ) ).

% lex_append_leftD
thf(fact_4844_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),Vs: list @ A,Us: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R4 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Us ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( lex @ A @ R4 ) ) ) ) ).

% lex_append_rightI
thf(fact_4845_lexord__append__left__rightI,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),U: list @ A,X: list @ A,Y: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ ( cons @ A @ A3 @ X ) ) @ ( append @ A @ U @ ( cons @ A @ B2 @ Y ) ) ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_append_left_rightI
thf(fact_4846_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W2: list @ A,R4: set @ ( product_prod @ A @ A ),V: list @ A,Z2: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W2 ) @ ( lexord @ A @ R4 ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W2 ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V ) @ ( append @ A @ W2 @ Z2 ) ) @ ( lexord @ A @ R4 ) ) ) ) ).

% lexord_sufI
thf(fact_4847_lenlex__def,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( inv_image @ ( product_prod @ nat @ ( list @ A ) ) @ ( list @ A ) @ ( lex_prod @ nat @ ( list @ A ) @ less_than @ ( lex @ A @ R5 ) )
            @ ^ [Xs3: list @ A] : ( product_Pair @ nat @ ( list @ A ) @ ( size_size @ ( list @ A ) @ Xs3 ) @ Xs3 ) ) ) ) ).

% lenlex_def
thf(fact_4848_List_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [R5: A > A > $o,Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% List.lexordp_def
thf(fact_4849_extract__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A,Y: A,Zs3: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs3 ) ) ) )
      = ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y @ Zs3 ) ) )
        & ( P @ Y )
        & ~ ? [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
              & ( P @ X3 ) ) ) ) ).

% extract_Some_iff
thf(fact_4850_extract__SomeE,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A,Y: A,Zs3: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs3 ) ) ) )
     => ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y @ Zs3 ) ) )
        & ( P @ Y )
        & ~ ? [X6: A] :
              ( ( member @ A @ X6 @ ( set2 @ A @ Ys ) )
              & ( P @ X6 ) ) ) ) ).

% extract_SomeE
thf(fact_4851_set__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty
thf(fact_4852_set__empty2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty2
thf(fact_4853_set__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
        = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_4854_empty__set,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) ).

% empty_set
thf(fact_4855_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ A ),Ys: list @ A,Zs3: list @ A] :
      ( ! [X2: A,Y3: A,Z3: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R4 )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ R4 )
             => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z3 ) @ R4 ) ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R4 ) )
       => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs3 ) @ ( lexord @ A @ R4 ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs3 ) @ ( lexord @ A @ R4 ) ) ) ) ) ).

% lexord_partial_trans
thf(fact_4856_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_4857_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N ) @ X ) )
      = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_4858_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs3: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs3 ) ) @ ( lexord @ A @ R4 ) )
      = ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R4 ) )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs3 ) @ ( lexord @ A @ R4 ) ) ) ) ).

% lexord_same_pref_iff
thf(fact_4859_Pow__set_I1_J,axiom,
    ! [A: $tType] :
      ( ( pow @ A @ ( set2 @ A @ ( nil @ A ) ) )
      = ( insert2 @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_set(1)
thf(fact_4860_set__update__distinct,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs @ N @ X ) )
          = ( insert2 @ A @ X @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ ( nth @ A @ Xs @ N ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_4861_arg__min__list_Opelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: A > B,Xa: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X @ Xa )
            = Y )
         => ( ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ Xa ) )
           => ( ! [X2: A] :
                  ( ( Xa
                    = ( cons @ A @ X2 @ ( nil @ A ) ) )
                 => ( ( Y = X2 )
                   => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) )
             => ( ! [X2: A,Y3: A,Zs: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ X2 @ ( cons @ A @ Y3 @ Zs ) ) )
                   => ( ( Y
                        = ( if @ A @ ( ord_less_eq @ B @ ( X @ X2 ) @ ( X @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y3 @ Zs ) ) ) ) @ X2 @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y3 @ Zs ) ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ ( cons @ A @ Y3 @ Zs ) ) ) ) ) )
               => ~ ( ( Xa
                      = ( nil @ A ) )
                   => ( ( Y
                        = ( undefined @ A ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
thf(fact_4862_set__removeAll,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X @ Xs ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_4863_distinct__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( append @ A @ Xs @ Ys ) )
      = ( ( distinct @ A @ Xs )
        & ( distinct @ A @ Ys )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% distinct_append
thf(fact_4864_distinct__list__update,axiom,
    ! [A: $tType,Xs: list @ A,A3: A,I: nat] :
      ( ( distinct @ A @ Xs )
     => ( ~ ( member @ A @ A3 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ ( nth @ A @ Xs @ I ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs @ I @ A3 ) ) ) ) ).

% distinct_list_update
thf(fact_4865_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( set2 @ A @ ( remove1 @ A @ X @ Xs ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_4866_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert2 @ A @ X @ A4 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_4867_distinct__foldl__invar,axiom,
    ! [B: $tType,A: $tType,S2: list @ A,I4: ( set @ A ) > B > $o,Sigma_0: B,F: B > A > B] :
      ( ( distinct @ A @ S2 )
     => ( ( I4 @ ( set2 @ A @ S2 ) @ Sigma_0 )
       => ( ! [X2: A,It: set @ A,Sigma: B] :
              ( ( member @ A @ X2 @ It )
             => ( ( ord_less_eq @ ( set @ A ) @ It @ ( set2 @ A @ S2 ) )
               => ( ( I4 @ It @ Sigma )
                 => ( I4 @ ( minus_minus @ ( set @ A ) @ It @ ( insert2 @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( F @ Sigma @ X2 ) ) ) ) )
         => ( I4 @ ( bot_bot @ ( set @ A ) ) @ ( foldl @ B @ A @ F @ Sigma_0 @ S2 ) ) ) ) ) ).

% distinct_foldl_invar
thf(fact_4868_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ Y )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X ) )
          = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ Y ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
thf(fact_4869_fst__foldl,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: A > C > A,G: A > B > C > B,A3: A,B2: B,Xs: list @ C] :
      ( ( product_fst @ A @ B
        @ ( foldl @ ( product_prod @ A @ B ) @ C
          @ ( product_case_prod @ A @ B @ ( C > ( product_prod @ A @ B ) )
            @ ^ [A5: A,B4: B,X3: C] : ( product_Pair @ A @ B @ ( F @ A5 @ X3 ) @ ( G @ A5 @ B4 @ X3 ) ) )
          @ ( product_Pair @ A @ B @ A3 @ B2 )
          @ Xs ) )
      = ( foldl @ A @ C @ F @ A3 @ Xs ) ) ).

% fst_foldl
thf(fact_4870_foldl__absorb1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Zs3: list @ A] :
          ( ( times_times @ A @ X @ ( foldl @ A @ A @ ( times_times @ A ) @ ( one_one @ A ) @ Zs3 ) )
          = ( foldl @ A @ A @ ( times_times @ A ) @ X @ Zs3 ) ) ) ).

% foldl_absorb1
thf(fact_4871_foldl__un__empty__eq,axiom,
    ! [A: $tType,I: set @ A,Ww: list @ ( set @ A )] :
      ( ( foldl @ ( set @ A ) @ ( set @ A ) @ ( sup_sup @ ( set @ A ) ) @ I @ Ww )
      = ( sup_sup @ ( set @ A ) @ I @ ( foldl @ ( set @ A ) @ ( set @ A ) @ ( sup_sup @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) @ Ww ) ) ) ).

% foldl_un_empty_eq
thf(fact_4872_foldl__set,axiom,
    ! [A: $tType,L: list @ ( set @ A )] :
      ( ( foldl @ ( set @ A ) @ ( set @ A ) @ ( sup_sup @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) @ L )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [X3: set @ A] : ( member @ ( set @ A ) @ X3 @ ( set2 @ ( set @ A ) @ L ) ) ) ) ) ).

% foldl_set
thf(fact_4873_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( linord4507533701916653071of_set @ A @ A4 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X3: A] : X3
                @ X
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_4874_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X @ ( linord4507533701916653071of_set @ A @ A4 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_4875_lexord__take__index__conv,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R4 ) )
      = ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) )
          & ( ( take @ A @ ( size_size @ ( list @ A ) @ X ) @ Y )
            = X ) )
        | ? [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) ) )
            & ( ( take @ A @ I2 @ X )
              = ( take @ A @ I2 @ Y ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ X @ I2 ) @ ( nth @ A @ Y @ I2 ) ) @ R4 ) ) ) ) ).

% lexord_take_index_conv
thf(fact_4876_mset__mergesort__by__rel__split,axiom,
    ! [A: $tType,Xs1: list @ A,Xs2: list @ A,Xs: list @ A] :
      ( ( plus_plus @ ( multiset @ A ) @ ( mset @ A @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs2 ) @ Xs ) ) ) @ ( mset @ A @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs2 ) @ Xs ) ) ) )
      = ( plus_plus @ ( multiset @ A ) @ ( plus_plus @ ( multiset @ A ) @ ( mset @ A @ Xs ) @ ( mset @ A @ Xs1 ) ) @ ( mset @ A @ Xs2 ) ) ) ).

% mset_mergesort_by_rel_split
thf(fact_4877_listrel__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrel @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ B ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ B ) @ $o
              @ ( listrelp @ A @ B
                @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R5 ) ) ) ) ) ) ).

% listrel_def
thf(fact_4878_set__mset__comp__mset,axiom,
    ! [A: $tType] :
      ( ( comp @ ( multiset @ A ) @ ( set @ A ) @ ( list @ A ) @ ( set_mset @ A ) @ ( mset @ A ) )
      = ( set2 @ A ) ) ).

% set_mset_comp_mset
thf(fact_4879_lex__take__index,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R4 ) )
     => ~ ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys ) )
             => ( ( ( take @ A @ I3 @ Xs )
                  = ( take @ A @ I3 @ Ys ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Ys @ I3 ) ) @ R4 ) ) ) ) ) ).

% lex_take_index
thf(fact_4880_listrelp__listrel__eq,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B )] :
      ( ( listrelp @ A @ B
        @ ^ [X3: A,Y2: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R4 ) )
      = ( ^ [X3: list @ A,Y2: list @ B] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ X3 @ Y2 ) @ ( listrel @ A @ B @ R4 ) ) ) ) ).

% listrelp_listrel_eq
thf(fact_4881_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_4882_nth__zip,axiom,
    ! [A: $tType,B: $tType,I: nat,Xs: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ B ) @ Ys ) )
       => ( ( nth @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I )
          = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I ) @ ( nth @ B @ Ys @ I ) ) ) ) ) ).

% nth_zip
thf(fact_4883_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R4 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [X3: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ X3 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
           => ( product_case_prod @ A @ B @ $o
              @ ^ [Y2: A,Z4: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y2 @ Z4 ) @ R4 )
              @ X3 ) ) ) ) ).

% listrel_iff_zip
thf(fact_4884_zip__Cons__Cons,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) )
      = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_Cons_Cons
thf(fact_4885_zip__replicate,axiom,
    ! [A: $tType,B: $tType,I: nat,X: A,J2: nat,Y: B] :
      ( ( zip @ A @ B @ ( replicate @ A @ I @ X ) @ ( replicate @ B @ J2 @ Y ) )
      = ( replicate @ ( product_prod @ A @ B ) @ ( ord_min @ nat @ I @ J2 ) @ ( product_Pair @ A @ B @ X @ Y ) ) ) ).

% zip_replicate
thf(fact_4886_zip__same,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs @ Xs ) ) )
      = ( ( member @ A @ A3 @ ( set2 @ A @ Xs ) )
        & ( A3 = B2 ) ) ) ).

% zip_same
thf(fact_4887_in__set__zipE,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ~ ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ~ ( member @ B @ Y @ ( set2 @ B @ Ys ) ) ) ) ).

% in_set_zipE
thf(fact_4888_set__zip__leftD,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_zip_leftD
thf(fact_4889_set__zip__rightD,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ( member @ B @ Y @ ( set2 @ B @ Ys ) ) ) ).

% set_zip_rightD
thf(fact_4890_zip__update,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,I: nat,X: A,Ys: list @ B,Y: B] :
      ( ( zip @ A @ B @ ( list_update @ A @ Xs @ I @ X ) @ ( list_update @ B @ Ys @ I @ Y ) )
      = ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I @ ( product_Pair @ A @ B @ X @ Y ) ) ) ).

% zip_update
thf(fact_4891_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Y: B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ B @ Y @ ( set2 @ B @ Ys ) )
       => ~ ! [X2: A] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip2
thf(fact_4892_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ~ ! [Y3: B] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y3 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip1
thf(fact_4893_zip__eq__ConsE,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Xy: product_prod @ A @ B,Xys2: list @ ( product_prod @ A @ B )] :
      ( ( ( zip @ A @ B @ Xs @ Ys )
        = ( cons @ ( product_prod @ A @ B ) @ Xy @ Xys2 ) )
     => ~ ! [X2: A,Xs6: list @ A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Xs6 ) )
           => ! [Y3: B,Ys5: list @ B] :
                ( ( Ys
                  = ( cons @ B @ Y3 @ Ys5 ) )
               => ( ( Xy
                    = ( product_Pair @ A @ B @ X2 @ Y3 ) )
                 => ( Xys2
                   != ( zip @ A @ B @ Xs6 @ Ys5 ) ) ) ) ) ) ).

% zip_eq_ConsE
thf(fact_4894_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( shuffles @ A @ Xs @ ( nil @ A ) )
      = ( insert2 @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(2)
thf(fact_4895_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( shuffles @ A @ ( nil @ A ) @ Ys )
      = ( insert2 @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(1)
thf(fact_4896_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs3: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ A @ Ys )
       => ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ ( list @ A ) @ Zs3 @ ( shuffles @ A @ Xs @ Ys ) )
           => ( distinct @ A @ Zs3 ) ) ) ) ) ).

% distinct_disjoint_shuffles
thf(fact_4897_shuffles_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( insert2 @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y
             != ( insert2 @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
         => ~ ! [X2: A,Xs4: list @ A] :
                ( ( X
                  = ( cons @ A @ X2 @ Xs4 ) )
               => ! [Y3: A,Ys2: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ Y3 @ Ys2 ) )
                   => ( Y
                     != ( sup_sup @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs4 @ ( cons @ A @ Y3 @ Ys2 ) ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y3 ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs4 ) @ Ys2 ) ) ) ) ) ) ) ) ) ).

% shuffles.elims
thf(fact_4898_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu: product_prod @ A @ B] :
          ? [I2: nat] :
            ( ( Uu
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I2 ) @ ( nth @ B @ Ys @ I2 ) ) )
            & ( ord_less @ nat @ I2 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% set_zip
thf(fact_4899_inv__image__partition,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ! [Y3: A] :
            ( ( member @ A @ Y3 @ ( set2 @ A @ Ys ) )
           => ~ ( P @ Y3 ) )
       => ( ( vimage @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( partition @ A @ P ) @ ( insert2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) )
          = ( shuffles @ A @ Xs @ Ys ) ) ) ) ).

% inv_image_partition
thf(fact_4900_mset__zip__take__Cons__drop__twice,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,J2: nat,X: A,Y: B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ord_less_eq @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( mset @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ ( append @ A @ ( take @ A @ J2 @ Xs ) @ ( cons @ A @ X @ ( drop @ A @ J2 @ Xs ) ) ) @ ( append @ B @ ( take @ B @ J2 @ Ys ) @ ( cons @ B @ Y @ ( drop @ B @ J2 @ Ys ) ) ) ) )
          = ( add_mset @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( mset @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ) ).

% mset_zip_take_Cons_drop_twice
thf(fact_4901_lists__empty,axiom,
    ! [A: $tType] :
      ( ( lists @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% lists_empty
thf(fact_4902_lists__Int__eq,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( lists @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
      = ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ A4 ) @ ( lists @ A @ B3 ) ) ) ).

% lists_Int_eq
thf(fact_4903_lists__IntI,axiom,
    ! [A: $tType,L: list @ A,A4: set @ A,B3: set @ A] :
      ( ( member @ ( list @ A ) @ L @ ( lists @ A @ A4 ) )
     => ( ( member @ ( list @ A ) @ L @ ( lists @ A @ B3 ) )
       => ( member @ ( list @ A ) @ L @ ( lists @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) ) ).

% lists_IntI
thf(fact_4904_lists__of__len__fin1,axiom,
    ! [A: $tType,P: set @ A,N: nat] :
      ( ( finite_finite @ A @ P )
     => ( finite_finite @ ( list @ A )
        @ ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ P )
          @ ( collect @ ( list @ A )
            @ ^ [L3: list @ A] :
                ( ( size_size @ ( list @ A ) @ L3 )
                = N ) ) ) ) ) ).

% lists_of_len_fin1
thf(fact_4905_lists__of__len__fin2,axiom,
    ! [A: $tType,P: set @ A,N: nat] :
      ( ( finite_finite @ A @ P )
     => ( finite_finite @ ( list @ A )
        @ ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ P )
          @ ( collect @ ( list @ A )
            @ ^ [L3: list @ A] :
                ( N
                = ( size_size @ ( list @ A ) @ L3 ) ) ) ) ) ) ).

% lists_of_len_fin2
thf(fact_4906_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( partition @ A @ P @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) ) ).

% partition.simps(1)
thf(fact_4907_partition__P,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes2: list @ A,No2: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ No2 ) )
     => ( ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ Yes2 ) )
           => ( P @ X6 ) )
        & ! [X6: A] :
            ( ( member @ A @ X6 @ ( set2 @ A @ No2 ) )
           => ~ ( P @ X6 ) ) ) ) ).

% partition_P
thf(fact_4908_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( partition @ A @ P @ ( cons @ A @ X @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
        @ ^ [Yes3: list @ A,No3: list @ A] : ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P @ X ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Yes3 ) @ No3 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes3 @ ( cons @ A @ X @ No3 ) ) )
        @ ( partition @ A @ P @ Xs ) ) ) ).

% partition.simps(2)
thf(fact_4909_partition__set,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes2: list @ A,No2: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ No2 ) )
     => ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Yes2 ) @ ( set2 @ A @ No2 ) )
        = ( set2 @ A @ Xs ) ) ) ).

% partition_set
thf(fact_4910_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I: nat,J2: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I @ J2 )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J2 @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_4911_INF__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: B > A,Xs: list @ B] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F @ ( set2 @ B @ Xs ) ) )
          = ( fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F ) @ Xs @ ( top_top @ A ) ) ) ) ).

% INF_set_fold
thf(fact_4912_SUP__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: B > A,Xs: list @ B] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F @ ( set2 @ B @ Xs ) ) )
          = ( fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( sup_sup @ A ) @ F ) @ Xs @ ( bot_bot @ A ) ) ) ) ).

% SUP_set_fold
thf(fact_4913_shuffles_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y
                = ( insert2 @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ( ( ( Xa
                = ( nil @ A ) )
             => ( ( Y
                  = ( insert2 @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
           => ~ ! [X2: A,Xs4: list @ A] :
                  ( ( X
                    = ( cons @ A @ X2 @ Xs4 ) )
                 => ! [Y3: A,Ys2: list @ A] :
                      ( ( Xa
                        = ( cons @ A @ Y3 @ Ys2 ) )
                     => ( ( Y
                          = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs4 @ ( cons @ A @ Y3 @ Ys2 ) ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y3 ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs4 ) @ Ys2 ) ) ) )
                       => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys2 ) ) ) ) ) ) ) ) ) ) ).

% shuffles.pelims
thf(fact_4914_fold__append,axiom,
    ! [A: $tType,B: $tType,F: B > A > A,Xs: list @ B,Ys: list @ B] :
      ( ( fold @ B @ A @ F @ ( append @ B @ Xs @ Ys ) )
      = ( comp @ A @ A @ A @ ( fold @ B @ A @ F @ Ys ) @ ( fold @ B @ A @ F @ Xs ) ) ) ).

% fold_append
thf(fact_4915_shuffles_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys2: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) )
           => ( P @ ( nil @ A ) @ Ys2 ) )
       => ( ! [Xs4: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs4 @ ( nil @ A ) ) )
             => ( P @ Xs4 @ ( nil @ A ) ) )
         => ( ! [X2: A,Xs4: list @ A,Y3: A,Ys2: list @ A] :
                ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys2 ) ) )
               => ( ( P @ Xs4 @ ( cons @ A @ Y3 @ Ys2 ) )
                 => ( ( P @ ( cons @ A @ X2 @ Xs4 ) @ Ys2 )
                   => ( P @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys2 ) ) ) ) )
           => ( P @ A0 @ A1 ) ) ) ) ) ).

% shuffles.pinduct
thf(fact_4916_fold__Cons,axiom,
    ! [B: $tType,A: $tType,F: A > B > B,X: A,Xs: list @ A] :
      ( ( fold @ A @ B @ F @ ( cons @ A @ X @ Xs ) )
      = ( comp @ B @ B @ B @ ( fold @ A @ B @ F @ Xs ) @ ( F @ X ) ) ) ).

% fold_Cons
thf(fact_4917_fold__commute,axiom,
    ! [A: $tType,C: $tType,B: $tType,Xs: list @ A,H2: B > C,G: A > B > B,F: A > C > C] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( comp @ B @ C @ B @ H2 @ ( G @ X2 ) )
            = ( comp @ C @ C @ B @ ( F @ X2 ) @ H2 ) ) )
     => ( ( comp @ B @ C @ B @ H2 @ ( fold @ A @ B @ G @ Xs ) )
        = ( comp @ C @ C @ B @ ( fold @ A @ C @ F @ Xs ) @ H2 ) ) ) ).

% fold_commute
thf(fact_4918_fold__commute__apply,axiom,
    ! [A: $tType,C: $tType,B: $tType,Xs: list @ A,H2: B > C,G: A > B > B,F: A > C > C,S: B] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( comp @ B @ C @ B @ H2 @ ( G @ X2 ) )
            = ( comp @ C @ C @ B @ ( F @ X2 ) @ H2 ) ) )
     => ( ( H2 @ ( fold @ A @ B @ G @ Xs @ S ) )
        = ( fold @ A @ C @ F @ Xs @ ( H2 @ S ) ) ) ) ).

% fold_commute_apply
thf(fact_4919_fold__multiset__equiv,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F: A > B > B,Ys: list @ A] :
      ( ! [X2: A,Y3: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ Y3 ) )
              = ( comp @ B @ B @ B @ ( F @ Y3 ) @ ( F @ X2 ) ) ) ) )
     => ( ( ( mset @ A @ Xs )
          = ( mset @ A @ Ys ) )
       => ( ( fold @ A @ B @ F @ Xs )
          = ( fold @ A @ B @ F @ Ys ) ) ) ) ).

% fold_multiset_equiv
thf(fact_4920_fold__remove1__split,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F: A > B > B,X: A] :
      ( ! [X2: A,Y3: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ Y3 ) )
              = ( comp @ B @ B @ B @ ( F @ Y3 ) @ ( F @ X2 ) ) ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( fold @ A @ B @ F @ Xs )
          = ( comp @ B @ B @ B @ ( fold @ A @ B @ F @ ( remove1 @ A @ X @ Xs ) ) @ ( F @ X ) ) ) ) ) ).

% fold_remove1_split
thf(fact_4921_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( shuffles @ A @ ( nil @ A ) @ Ys )
        = ( insert2 @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(1)
thf(fact_4922_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) )
     => ( ( shuffles @ A @ Xs @ ( nil @ A ) )
        = ( insert2 @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(2)
thf(fact_4923_shuffles_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) )
     => ( ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
        = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys ) ) ) ) ) ).

% shuffles.psimps(3)
thf(fact_4924_Sup__set__fold,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Xs: list @ A] :
          ( ( complete_Sup_Sup @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( sup_sup @ A ) @ Xs @ ( bot_bot @ A ) ) ) ) ).

% Sup_set_fold
thf(fact_4925_Inf__set__fold,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Xs: list @ A] :
          ( ( complete_Inf_Inf @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( inf_inf @ A ) @ Xs @ ( top_top @ A ) ) ) ) ).

% Inf_set_fold
thf(fact_4926_Inf__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( inf_inf @ A ) @ Xs @ X ) ) ) ).

% Inf_fin.set_eq_fold
thf(fact_4927_Sup__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( sup_sup @ A ) @ Xs @ X ) ) ) ).

% Sup_fin.set_eq_fold
thf(fact_4928_splice_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys2: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) )
           => ( P @ ( nil @ A ) @ Ys2 ) )
       => ( ! [X2: A,Xs4: list @ A,Ys2: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs4 ) @ Ys2 ) )
             => ( ( P @ Ys2 @ Xs4 )
               => ( P @ ( cons @ A @ X2 @ Xs4 ) @ Ys2 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) ).

% splice.pinduct
thf(fact_4929_subset__eq__mset__impl_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: option @ $o] :
      ( ( ( subset_eq_mset_impl @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( subset751672762298770561pl_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y
                = ( some @ $o
                  @ ( Xa
                   != ( nil @ A ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( subset751672762298770561pl_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ~ ! [X2: A,Xs4: list @ A] :
                ( ( X
                  = ( cons @ A @ X2 @ Xs4 ) )
               => ( ( Y
                    = ( case_option @ ( option @ $o ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ $o )
                      @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ $o )
                        @ ^ [Ys1: list @ A] :
                            ( product_case_prod @ A @ ( list @ A ) @ ( option @ $o )
                            @ ^ [Y2: A,Ys22: list @ A] : ( subset_eq_mset_impl @ A @ Xs4 @ ( append @ A @ Ys1 @ Ys22 ) ) ) )
                      @ ( extract @ A
                        @ ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
                          @ X2 )
                        @ Xa ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( subset751672762298770561pl_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs4 ) @ Xa ) ) ) ) ) ) ) ).

% subset_eq_mset_impl.pelims
thf(fact_4930_zipf__zip,axiom,
    ! [A: $tType,B: $tType,L1: list @ A,L2: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ L1 )
        = ( size_size @ ( list @ B ) @ L2 ) )
     => ( ( zipf @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ L1 @ L2 )
        = ( zip @ A @ B @ L1 @ L2 ) ) ) ).

% zipf_zip
thf(fact_4931_zipf_Opelims,axiom,
    ! [C: $tType,A: $tType,B: $tType,X: A > B > C,Xa: list @ A,Xb: list @ B,Y: list @ C] :
      ( ( ( zipf @ A @ B @ C @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( zipf_rel @ A @ B @ C ) @ ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( ( Xb
                = ( nil @ B ) )
             => ( ( Y
                  = ( nil @ C ) )
               => ~ ( accp @ ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( zipf_rel @ A @ B @ C ) @ ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) ) ) ) ) )
         => ( ! [A8: A,As2: list @ A] :
                ( ( Xa
                  = ( cons @ A @ A8 @ As2 ) )
               => ! [B6: B,Bs2: list @ B] :
                    ( ( Xb
                      = ( cons @ B @ B6 @ Bs2 ) )
                   => ( ( Y
                        = ( cons @ C @ ( X @ A8 @ B6 ) @ ( zipf @ A @ B @ C @ X @ As2 @ Bs2 ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( zipf_rel @ A @ B @ C ) @ ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A8 @ As2 ) @ ( cons @ B @ B6 @ Bs2 ) ) ) ) ) ) )
           => ( ! [V4: A,Va: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ V4 @ Va ) )
                 => ( ( Xb
                      = ( nil @ B ) )
                   => ( ( Y
                        = ( undefined @ ( list @ C ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( zipf_rel @ A @ B @ C ) @ ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ V4 @ Va ) @ ( nil @ B ) ) ) ) ) ) )
             => ~ ( ( Xa
                    = ( nil @ A ) )
                 => ! [V4: B,Va: list @ B] :
                      ( ( Xb
                        = ( cons @ B @ V4 @ Va ) )
                     => ( ( Y
                          = ( undefined @ ( list @ C ) ) )
                       => ~ ( accp @ ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( zipf_rel @ A @ B @ C ) @ ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( cons @ B @ V4 @ Va ) ) ) ) ) ) ) ) ) ) ) ) ).

% zipf.pelims
thf(fact_4932_splice_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: list @ A] :
      ( ( ( splice @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y = Xa )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ~ ! [X2: A,Xs4: list @ A] :
                ( ( X
                  = ( cons @ A @ X2 @ Xs4 ) )
               => ( ( Y
                    = ( cons @ A @ X2 @ ( splice @ A @ Xa @ Xs4 ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs4 ) @ Xa ) ) ) ) ) ) ) ).

% splice.pelims
thf(fact_4933_splice_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( splice @ A @ ( nil @ A ) @ Ys )
        = Ys ) ) ).

% splice.psimps(1)
thf(fact_4934_splice_Opsimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ys ) )
     => ( ( splice @ A @ ( cons @ A @ X @ Xs ) @ Ys )
        = ( cons @ A @ X @ ( splice @ A @ Ys @ Xs ) ) ) ) ).

% splice.psimps(2)
thf(fact_4935_set__rec,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( rec_list @ ( set @ A ) @ A @ ( bot_bot @ ( set @ A ) )
        @ ^ [X3: A,Uu: list @ A] : ( insert2 @ A @ X3 ) ) ) ).

% set_rec
thf(fact_4936_map__tailrec__rev_Opelims,axiom,
    ! [A: $tType,B: $tType,X: A > B,Xa: list @ A,Xb: list @ B,Y: list @ B] :
      ( ( ( map_tailrec_rev @ A @ B @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( ( Y = Xb )
             => ~ ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xb ) ) ) ) )
         => ~ ! [A8: A,As2: list @ A] :
                ( ( Xa
                  = ( cons @ A @ A8 @ As2 ) )
               => ( ( Y
                    = ( map_tailrec_rev @ A @ B @ X @ As2 @ ( cons @ B @ ( X @ A8 ) @ Xb ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A8 @ As2 ) @ Xb ) ) ) ) ) ) ) ) ).

% map_tailrec_rev.pelims
thf(fact_4937_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs3: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys @ Zs3 ) )
      = ( map @ ( product_prod @ B @ ( product_prod @ A @ C ) ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ B @ ( product_prod @ A @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ^ [Y2: B] :
              ( product_case_prod @ A @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
              @ ^ [X3: A,Z4: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X3 @ ( product_Pair @ B @ C @ Y2 @ Z4 ) ) ) )
        @ ( zip @ B @ ( product_prod @ A @ C ) @ Ys @ ( zip @ A @ C @ Xs @ Zs3 ) ) ) ) ).

% zip_left_commute
thf(fact_4938_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: B > A,G: C > B,Xs: list @ C] :
      ( ( map @ B @ A @ F @ ( map @ C @ B @ G @ Xs ) )
      = ( map @ C @ A @ ( comp @ B @ A @ C @ F @ G ) @ Xs ) ) ).

% map_map
thf(fact_4939_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: B > C,G: A > B,List: list @ A] :
      ( ( map @ B @ C @ F @ ( map @ A @ B @ G @ List ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F @ G ) @ List ) ) ).

% List.map.compositionality
thf(fact_4940_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F: A > B,V: list @ A] :
      ( ( map @ B @ C @ G @ ( map @ A @ B @ F @ V ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) ).

% list.map_comp
thf(fact_4941_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: C > B,G: A > C] :
      ( ( comp @ ( list @ C ) @ ( list @ B ) @ ( list @ A ) @ ( map @ C @ B @ F ) @ ( map @ A @ C @ G ) )
      = ( map @ A @ B @ ( comp @ C @ B @ A @ F @ G ) ) ) ).

% map_comp_map
thf(fact_4942_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: B > C,G: A > B] :
      ( ( comp @ ( list @ B ) @ ( list @ C ) @ ( list @ A ) @ ( map @ B @ C @ F ) @ ( map @ A @ B @ G ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F @ G ) ) ) ).

% List.map.comp
thf(fact_4943_map__fst__mk__snd,axiom,
    ! [B: $tType,A: $tType,K: B,L: list @ A] :
      ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B )
        @ ( map @ A @ ( product_prod @ A @ B )
          @ ^ [X3: A] : ( product_Pair @ A @ B @ X3 @ K )
          @ L ) )
      = L ) ).

% map_fst_mk_snd
thf(fact_4944_map__snd__mk__fst,axiom,
    ! [B: $tType,A: $tType,K: B,L: list @ A] :
      ( ( map @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( map @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K ) @ L ) )
      = L ) ).

% map_snd_mk_fst
thf(fact_4945_map__fst__mk__fst,axiom,
    ! [B: $tType,A: $tType,K: A,L: list @ B] :
      ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K ) @ L ) )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ L ) @ K ) ) ).

% map_fst_mk_fst
thf(fact_4946_map__snd__mk__snd,axiom,
    ! [B: $tType,A: $tType,K: A,L: list @ B] :
      ( ( map @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A )
        @ ( map @ B @ ( product_prod @ B @ A )
          @ ^ [X3: B] : ( product_Pair @ B @ A @ X3 @ K )
          @ L ) )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ L ) @ K ) ) ).

% map_snd_mk_snd
thf(fact_4947_list_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: C,Ga: B > ( list @ B ) > C > C,F: A > B] :
      ( ( comp @ ( list @ B ) @ C @ ( list @ A ) @ ( rec_list @ C @ B @ G @ Ga ) @ ( map @ A @ B @ F ) )
      = ( rec_list @ C @ A @ G
        @ ^ [X3: A,Xa4: list @ A] : ( Ga @ ( F @ X3 ) @ ( map @ A @ B @ F @ Xa4 ) ) ) ) ).

% list.rec_o_map
thf(fact_4948_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: C > A,Xs: list @ C,Ys: list @ B] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F @ Xs ) @ Ys )
      = ( map @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ B @ ( product_prod @ A @ B )
          @ ^ [X3: C] : ( product_Pair @ A @ B @ ( F @ X3 ) ) )
        @ ( zip @ C @ B @ Xs @ Ys ) ) ) ).

% zip_map1
thf(fact_4949_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,F: C > B,Ys: list @ C] :
      ( ( zip @ A @ B @ Xs @ ( map @ C @ B @ F @ Ys ) )
      = ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
          @ ^ [X3: A,Y2: C] : ( product_Pair @ A @ B @ X3 @ ( F @ Y2 ) ) )
        @ ( zip @ A @ C @ Xs @ Ys ) ) ) ).

% zip_map2
thf(fact_4950_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( product_prod @ B @ C ) > A,G: D > B,Xs: list @ D,Ys: list @ C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F @ ( zip @ B @ C @ ( map @ D @ B @ G @ Xs ) @ Ys ) )
      = ( map @ ( product_prod @ D @ C ) @ A
        @ ( product_case_prod @ D @ C @ A
          @ ^ [X3: D,Y2: C] : ( F @ ( product_Pair @ B @ C @ ( G @ X3 ) @ Y2 ) ) )
        @ ( zip @ D @ C @ Xs @ Ys ) ) ) ).

% map_zip_map
thf(fact_4951_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: ( product_prod @ B @ C ) > A,Xs: list @ B,G: D > C,Ys: list @ D] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F @ ( zip @ B @ C @ Xs @ ( map @ D @ C @ G @ Ys ) ) )
      = ( map @ ( product_prod @ B @ D ) @ A
        @ ( product_case_prod @ B @ D @ A
          @ ^ [X3: B,Y2: D] : ( F @ ( product_Pair @ B @ C @ X3 @ ( G @ Y2 ) ) ) )
        @ ( zip @ B @ D @ Xs @ Ys ) ) ) ).

% map_zip_map2
thf(fact_4952_map__prod__fun__zip,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: C > A,G: D > B,Xs: list @ C,Ys: list @ D] :
      ( ( map @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X3: C,Y2: D] : ( product_Pair @ A @ B @ ( F @ X3 ) @ ( G @ Y2 ) ) )
        @ ( zip @ C @ D @ Xs @ Ys ) )
      = ( zip @ A @ B @ ( map @ C @ A @ F @ Xs ) @ ( map @ D @ B @ G @ Ys ) ) ) ).

% map_prod_fun_zip
thf(fact_4953_set__oo__map__alt,axiom,
    ! [B: $tType,A: $tType,F: A > B] :
      ( ( comp @ ( list @ B ) @ ( set @ B ) @ ( list @ A ) @ ( set2 @ B ) @ ( map @ A @ B @ F ) )
      = ( ^ [L3: list @ A] : ( image2 @ A @ B @ F @ ( set2 @ A @ L3 ) ) ) ) ).

% set_oo_map_alt
thf(fact_4954_fold__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: B > A > A,F: C > B,Xs: list @ C] :
      ( ( fold @ B @ A @ G @ ( map @ C @ B @ F @ Xs ) )
      = ( fold @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G @ F ) @ Xs ) ) ).

% fold_map
thf(fact_4955_zip__same__conv__map,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( zip @ A @ A @ Xs @ Xs )
      = ( map @ A @ ( product_prod @ A @ A )
        @ ^ [X3: A] : ( product_Pair @ A @ A @ X3 @ X3 )
        @ Xs ) ) ).

% zip_same_conv_map
thf(fact_4956_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Ys: list @ B] :
      ( ( product @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( append @ ( product_prod @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ Ys ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ).

% product.simps(2)
thf(fact_4957_zip__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zip @ A @ B )
      = ( ^ [Xs3: list @ A,Ys3: list @ B] :
            ( map @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
            @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
              @ ^ [X3: B,Y2: A] : ( product_Pair @ A @ B @ Y2 @ X3 ) )
            @ ( zip @ B @ A @ Ys3 @ Xs3 ) ) ) ) ).

% zip_commute
thf(fact_4958_distinct__map__fstD,axiom,
    ! [A: $tType,B: $tType,Xs: list @ ( product_prod @ A @ B ),X: A,Y: B,Z2: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
       => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Z2 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
         => ( Y = Z2 ) ) ) ) ).

% distinct_map_fstD
thf(fact_4959_eq__key__imp__eq__value,axiom,
    ! [A: $tType,B: $tType,Xs: list @ ( product_prod @ A @ B ),K: A,V1: B,V22: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V1 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
       => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V22 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
         => ( V1 = V22 ) ) ) ) ).

% eq_key_imp_eq_value
thf(fact_4960_zip__replicate1,axiom,
    ! [A: $tType,B: $tType,N: nat,X: A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( replicate @ A @ N @ X ) @ Ys )
      = ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ ( take @ B @ N @ Ys ) ) ) ).

% zip_replicate1
thf(fact_4961_map__zip2,axiom,
    ! [A: $tType,B: $tType,K: A,L: list @ B] :
      ( ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K ) @ L )
      = ( zip @ A @ B @ ( replicate @ A @ ( size_size @ ( list @ B ) @ L ) @ K ) @ L ) ) ).

% map_zip2
thf(fact_4962_map__zip1,axiom,
    ! [A: $tType,B: $tType,K: B,L: list @ A] :
      ( ( map @ A @ ( product_prod @ A @ B )
        @ ^ [X3: A] : ( product_Pair @ A @ B @ X3 @ K )
        @ L )
      = ( zip @ A @ B @ L @ ( replicate @ B @ ( size_size @ ( list @ A ) @ L ) @ K ) ) ) ).

% map_zip1
thf(fact_4963_zip__replicate2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,N: nat,Y: B] :
      ( ( zip @ A @ B @ Xs @ ( replicate @ B @ N @ Y ) )
      = ( map @ A @ ( product_prod @ A @ B )
        @ ^ [X3: A] : ( product_Pair @ A @ B @ X3 @ Y )
        @ ( take @ A @ N @ Xs ) ) ) ).

% zip_replicate2
thf(fact_4964_Id__on__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( id_on @ A @ ( set2 @ A @ Xs ) )
      = ( set2 @ ( product_prod @ A @ A )
        @ ( map @ A @ ( product_prod @ A @ A )
          @ ^ [X3: A] : ( product_Pair @ A @ A @ X3 @ X3 )
          @ Xs ) ) ) ).

% Id_on_set
thf(fact_4965_map__of__eq__Some__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B ),X: A,Y: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( ( map_of @ A @ B @ Xys2 @ X )
          = ( some @ B @ Y ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) ) ) ) ).

% map_of_eq_Some_iff
thf(fact_4966_Some__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B ),Y: B,X: A] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( ( some @ B @ Y )
          = ( map_of @ A @ B @ Xys2 @ X ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) ) ) ) ).

% Some_eq_map_of_iff
thf(fact_4967_map__of__is__SomeI,axiom,
    ! [A: $tType,B: $tType,Xys2: list @ ( product_prod @ A @ B ),X: A,Y: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) )
       => ( ( map_of @ A @ B @ Xys2 @ X )
          = ( some @ B @ Y ) ) ) ) ).

% map_of_is_SomeI
thf(fact_4968_weak__map__of__SomeI,axiom,
    ! [A: $tType,B: $tType,K: A,X: B,L: list @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ X ) @ ( set2 @ ( product_prod @ A @ B ) @ L ) )
     => ? [X2: B] :
          ( ( map_of @ A @ B @ L @ K )
          = ( some @ B @ X2 ) ) ) ).

% weak_map_of_SomeI
thf(fact_4969_map__of__SomeD,axiom,
    ! [A: $tType,B: $tType,Xs: list @ ( product_prod @ B @ A ),K: B,Y: A] :
      ( ( ( map_of @ B @ A @ Xs @ K )
        = ( some @ A @ Y ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ Y ) @ ( set2 @ ( product_prod @ B @ A ) @ Xs ) ) ) ).

% map_of_SomeD
thf(fact_4970_map__of__Cons__code_I2_J,axiom,
    ! [C: $tType,B: $tType,L: B,K: B,V: C,Ps: list @ ( product_prod @ B @ C )] :
      ( ( ( L = K )
       => ( ( map_of @ B @ C @ ( cons @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ L @ V ) @ Ps ) @ K )
          = ( some @ C @ V ) ) )
      & ( ( L != K )
       => ( ( map_of @ B @ C @ ( cons @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ L @ V ) @ Ps ) @ K )
          = ( map_of @ B @ C @ Ps @ K ) ) ) ) ).

% map_of_Cons_code(2)
thf(fact_4971_map__of__Some__split,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ B @ A ),K: B,V: A] :
      ( ( ( map_of @ B @ A @ Xs @ K )
        = ( some @ A @ V ) )
     => ? [Ys2: list @ ( product_prod @ B @ A ),Zs: list @ ( product_prod @ B @ A )] :
          ( ( Xs
            = ( append @ ( product_prod @ B @ A ) @ Ys2 @ ( cons @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ V ) @ Zs ) ) )
          & ( ( map_of @ B @ A @ Ys2 @ K )
            = ( none @ A ) ) ) ) ).

% map_of_Some_split
thf(fact_4972_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs3: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys @ Zs3 ) )
      = ( map @ ( product_prod @ ( product_prod @ A @ B ) @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ ( product_prod @ A @ B ) @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ( product_case_prod @ A @ B @ ( C > ( product_prod @ A @ ( product_prod @ B @ C ) ) )
            @ ^ [X3: A,Y2: B,Z4: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X3 @ ( product_Pair @ B @ C @ Y2 @ Z4 ) ) ) )
        @ ( zip @ ( product_prod @ A @ B ) @ C @ ( zip @ A @ B @ Xs @ Ys ) @ Zs3 ) ) ) ).

% zip_assoc
thf(fact_4973_map__of__map__keys,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,M4: A > ( option @ B )] :
      ( ( ( set2 @ A @ Xs )
        = ( dom @ A @ B @ M4 ) )
     => ( ( map_of @ A @ B
          @ ( map @ A @ ( product_prod @ A @ B )
            @ ^ [K4: A] : ( product_Pair @ A @ B @ K4 @ ( the2 @ B @ ( M4 @ K4 ) ) )
            @ Xs ) )
        = M4 ) ) ).

% map_of_map_keys
thf(fact_4974_map__of__distinct__lookup,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B ),Y: B] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) ) )
     => ( ~ ( member @ A @ X @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) ) )
       => ( ( map_of @ A @ B @ ( append @ ( product_prod @ A @ B ) @ Xs @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ Ys ) ) @ X )
          = ( some @ B @ Y ) ) ) ) ).

% map_of_distinct_lookup
thf(fact_4975_map__of__mapk__SomeI,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: A > B,T4: list @ ( product_prod @ A @ C ),K: A,X: C] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map_of @ A @ C @ T4 @ K )
          = ( some @ C @ X ) )
       => ( ( map_of @ B @ C
            @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C )
              @ ( product_case_prod @ A @ C @ ( product_prod @ B @ C )
                @ ^ [K4: A] : ( product_Pair @ B @ C @ ( F @ K4 ) ) )
              @ T4 )
            @ ( F @ K ) )
          = ( some @ C @ X ) ) ) ) ).

% map_of_mapk_SomeI
thf(fact_4976_map__of__map__restrict,axiom,
    ! [B: $tType,A: $tType,F: A > B,Ks: list @ A] :
      ( ( map_of @ A @ B
        @ ( map @ A @ ( product_prod @ A @ B )
          @ ^ [K4: A] : ( product_Pair @ A @ B @ K4 @ ( F @ K4 ) )
          @ Ks ) )
      = ( restrict_map @ A @ B @ ( comp @ B @ ( option @ B ) @ A @ ( some @ B ) @ F ) @ ( set2 @ A @ Ks ) ) ) ).

% map_of_map_restrict
thf(fact_4977_map__of__distinct__upd3,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B ),Y: B,Y8: B] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) ) )
     => ( ~ ( member @ A @ X @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) ) )
       => ( ( map_of @ A @ B @ ( append @ ( product_prod @ A @ B ) @ Xs @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ Ys ) ) )
          = ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ ( append @ ( product_prod @ A @ B ) @ Xs @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y8 ) @ Ys ) ) ) @ X @ ( some @ B @ Y ) ) ) ) ) ).

% map_of_distinct_upd3
thf(fact_4978_map__of__distinct__upd2,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B ),Y: B] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) ) )
     => ( ~ ( member @ A @ X @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) ) )
       => ( ( map_of @ A @ B @ ( append @ ( product_prod @ A @ B ) @ Xs @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ Ys ) ) )
          = ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ ( append @ ( product_prod @ A @ B ) @ Xs @ Ys ) ) @ X @ ( some @ B @ Y ) ) ) ) ) ).

% map_of_distinct_upd2
thf(fact_4979_map__of__distinct__upd4,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B ),Y: B] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) ) )
     => ( ~ ( member @ A @ X @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) ) )
       => ( ( map_of @ A @ B @ ( append @ ( product_prod @ A @ B ) @ Xs @ Ys ) )
          = ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ ( append @ ( product_prod @ A @ B ) @ Xs @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ Ys ) ) ) @ X @ ( none @ B ) ) ) ) ) ).

% map_of_distinct_upd4
thf(fact_4980_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ C ),Yzs: list @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( set2 @ ( product_prod @ A @ C ) @ Xys2 ) @ ( set2 @ ( product_prod @ C @ B ) @ Yzs ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ ( product_prod @ A @ C ) @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [Xy2: product_prod @ A @ C] :
                ( concat @ ( product_prod @ A @ B )
                @ ( map @ ( product_prod @ C @ B ) @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [Yz: product_prod @ C @ B] :
                      ( if @ ( list @ ( product_prod @ A @ B ) )
                      @ ( ( product_snd @ A @ C @ Xy2 )
                        = ( product_fst @ C @ B @ Yz ) )
                      @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Xy2 ) @ ( product_snd @ C @ B @ Yz ) ) @ ( nil @ ( product_prod @ A @ B ) ) )
                      @ ( nil @ ( product_prod @ A @ B ) ) )
                  @ Yzs ) )
            @ Xys2 ) ) ) ) ).

% set_relcomp
thf(fact_4981_execute__make,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,F: nat > A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( array @ A ) @ ( array_make @ A @ N @ F ) @ H2 )
          = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R5: array @ A,H8: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H8 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
              @ ( array_alloc @ A @ ( map @ nat @ A @ F @ ( upt @ ( zero_zero @ nat ) @ N ) ) @ H2 ) ) ) ) ) ).

% execute_make
thf(fact_4982_map__of__Some__filter__not__in,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ B @ A ),K: B,V: A,P: ( product_prod @ B @ A ) > $o] :
      ( ( ( map_of @ B @ A @ Xs @ K )
        = ( some @ A @ V ) )
     => ( ~ ( P @ ( product_Pair @ B @ A @ K @ V ) )
       => ( ( distinct @ B @ ( map @ ( product_prod @ B @ A ) @ B @ ( product_fst @ B @ A ) @ Xs ) )
         => ( ( map_of @ B @ A @ ( filter2 @ ( product_prod @ B @ A ) @ P @ Xs ) @ K )
            = ( none @ A ) ) ) ) ) ).

% map_of_Some_filter_not_in
thf(fact_4983_partition__filter__conv,axiom,
    ! [A: $tType] :
      ( ( partition @ A )
      = ( ^ [F2: A > $o,Xs3: list @ A] : ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ F2 @ Xs3 ) @ ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ F2 ) @ Xs3 ) ) ) ) ).

% partition_filter_conv
thf(fact_4984_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ ( map @ B @ A @ F @ Xs ) ) )
      = ( size_size @ ( list @ B ) @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F ) @ Xs ) ) ) ).

% length_filter_map
thf(fact_4985_filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F: B > A,Xs: list @ B] :
      ( ( filter2 @ A @ P @ ( map @ B @ A @ F @ Xs ) )
      = ( map @ B @ A @ F @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F ) @ Xs ) ) ) ).

% filter_map
thf(fact_4986_inter__set__filter,axiom,
    ! [A: $tType,A4: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X3: A] : ( member @ A @ X3 @ A4 )
          @ Xs ) ) ) ).

% inter_set_filter
thf(fact_4987_partition__filter2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs ) ) ).

% partition_filter2
thf(fact_4988_enumerate__map__upt,axiom,
    ! [A: $tType,N: nat,F: nat > A,M4: nat] :
      ( ( enumerate @ A @ N @ ( map @ nat @ A @ F @ ( upt @ N @ M4 ) ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [K4: nat] : ( product_Pair @ nat @ A @ K4 @ ( F @ K4 ) )
        @ ( upt @ N @ M4 ) ) ) ).

% enumerate_map_upt
thf(fact_4989_make__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,F: nat > A] :
          ( hoare_hoare_triple @ ( array @ A ) @ ( one_one @ assn ) @ ( array_make @ A @ N @ F )
          @ ^ [R5: array @ A] : ( snga_assn @ A @ R5 @ ( map @ nat @ A @ F @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% make_rule
thf(fact_4990_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list @ A,Y: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X3: A] : ( X3 != Y )
          @ Xs ) ) ) ).

% set_minus_filter_out
thf(fact_4991_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs3: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs3 @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X3: A] :
                ~ ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
            @ Zs3 )
          = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
thf(fact_4992_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs3: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs3 @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X3: A] : ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
            @ Zs3 )
          = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
thf(fact_4993_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs3: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs3 @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X3: A] :
                ~ ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
            @ Zs3 )
          = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
thf(fact_4994_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs3: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs3 @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X3: A] : ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
            @ Zs3 )
          = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
thf(fact_4995_product__concat__map,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product @ A @ B )
      = ( ^ [Xs3: list @ A,Ys3: list @ B] :
            ( concat @ ( product_prod @ A @ B )
            @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
              @ ^ [X3: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 ) @ Ys3 )
              @ Xs3 ) ) ) ) ).

% product_concat_map
thf(fact_4996_distinct__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A ) @ Xs )
     => ( ! [Ys2: list @ A] :
            ( ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys2 ) )
       => ( ! [Ys2: list @ A,Zs: list @ A] :
              ( ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member @ ( list @ A ) @ Zs @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys2 != Zs )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys2 ) @ ( set2 @ A @ Zs ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat
thf(fact_4997_effect__makeI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H4: heap_ext @ product_unit,F: nat > A,N: nat,H2: heap_ext @ product_unit] :
          ( ( ( product_Pair @ ( array @ A ) @ ( heap_ext @ product_unit ) @ A3 @ H4 )
            = ( array_alloc @ A @ ( map @ nat @ A @ F @ ( upt @ ( zero_zero @ nat ) @ N ) ) @ H2 ) )
         => ( heap_Time_effect @ ( array @ A ) @ ( array_make @ A @ N @ F ) @ H2 @ H4 @ A3 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% effect_makeI
thf(fact_4998_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M4: nat,A3: A] :
      ( ( enumerate @ A @ N @ ( replicate @ A @ M4 @ A3 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q8: nat] : ( product_Pair @ nat @ A @ Q8 @ A3 )
        @ ( upt @ N @ ( plus_plus @ nat @ N @ M4 ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_4999_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_length_filter
thf(fact_5000_part__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_part @ B @ A )
        = ( ^ [F2: B > A,Pivot2: A,Xs3: list @ B] :
              ( product_Pair @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) )
              @ ( filter2 @ B
                @ ^ [X3: B] : ( ord_less @ A @ ( F2 @ X3 ) @ Pivot2 )
                @ Xs3 )
              @ ( product_Pair @ ( list @ B ) @ ( list @ B )
                @ ( filter2 @ B
                  @ ^ [X3: B] :
                      ( ( F2 @ X3 )
                      = Pivot2 )
                  @ Xs3 )
                @ ( filter2 @ B
                  @ ^ [X3: B] : ( ord_less @ A @ Pivot2 @ ( F2 @ X3 ) )
                  @ Xs3 ) ) ) ) ) ) ).

% part_def
thf(fact_5001_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ A @ ( concat @ A @ Xs ) )
      = ( ( distinct @ ( list @ A ) @ ( removeAll @ ( list @ A ) @ ( nil @ A ) @ Xs ) )
        & ! [Ys3: list @ A] :
            ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys3 ) )
        & ! [Ys3: list @ A,Zs2: list @ A] :
            ( ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( member @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( Ys3 != Zs2 ) )
           => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs2 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% distinct_concat_iff
thf(fact_5002_Array__Time_Omake__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_make @ A )
        = ( ^ [N5: nat,F2: nat > A] :
              ( heap_Time_heap @ ( array @ A )
              @ ^ [H3: heap_ext @ product_unit] :
                  ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R5: array @ A,H8: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H8 @ ( plus_plus @ nat @ N5 @ ( one_one @ nat ) ) ) )
                  @ ( array_alloc @ A @ ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ N5 ) ) @ H3 ) ) ) ) ) ) ).

% Array_Time.make_def
thf(fact_5003_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( product_product @ A @ B @ ( set2 @ A @ Xs ) @ ( set2 @ B @ Ys ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [X3: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 ) @ Ys )
            @ Xs ) ) ) ) ).

% product_code
thf(fact_5004_map__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_filter @ A @ B )
      = ( ^ [F2: A > ( option @ B ),Xs3: list @ A] :
            ( map @ A @ B @ ( comp @ ( option @ B ) @ B @ A @ ( the2 @ B ) @ F2 )
            @ ( filter2 @ A
              @ ^ [X3: A] :
                  ( ( F2 @ X3 )
                 != ( none @ B ) )
              @ Xs3 ) ) ) ) ).

% map_filter_def
thf(fact_5005_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ B @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Y2: B,Ys3: list @ B] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( zip @ A @ B @ Xs @ Ys3 ) )
        @ Ys ) ) ).

% zip_Cons1
thf(fact_5006_distinct__concat_H,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xs ) )
     => ( ! [Ys2: list @ A] :
            ( ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys2 ) )
       => ( ! [Ys2: list @ A,Zs: list @ A] :
              ( ( member @ ( list @ A ) @ Ys2 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member @ ( list @ A ) @ Zs @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys2 != Zs )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys2 ) @ ( set2 @ A @ Zs ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat'
thf(fact_5007_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( cons @ B @ Y @ Ys ) )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ A @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Z4: A,Zs2: list @ A] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Z4 @ Y ) @ ( zip @ A @ B @ Zs2 @ Ys ) )
        @ Xs ) ) ).

% zip_Cons
thf(fact_5008_in__measures_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,F: A > nat,Fs: list @ ( A > nat )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F @ Fs ) ) )
      = ( ( ord_less @ nat @ ( F @ X ) @ ( F @ Y ) )
        | ( ( ( F @ X )
            = ( F @ Y ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ Fs ) ) ) ) ) ).

% in_measures(2)
thf(fact_5009_partition__rev_Opelims,axiom,
    ! [A: $tType,X: A > $o,Xa: product_prod @ ( list @ A ) @ ( list @ A ),Xb: list @ A,Y: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ( ( partition_rev @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) ) @ ( partition_rev_rel @ A ) @ ( product_Pair @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ Xa @ Xb ) ) )
       => ( ! [Yes: list @ A,No: list @ A] :
              ( ( Xa
                = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
             => ( ( Xb
                  = ( nil @ A ) )
               => ( ( Y
                    = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
                 => ~ ( accp @ ( product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) ) @ ( partition_rev_rel @ A ) @ ( product_Pair @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) @ ( nil @ A ) ) ) ) ) ) )
         => ~ ! [Yes: list @ A,No: list @ A] :
                ( ( Xa
                  = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
               => ! [X2: A,Xs4: list @ A] :
                    ( ( Xb
                      = ( cons @ A @ X2 @ Xs4 ) )
                   => ( ( Y
                        = ( partition_rev @ A @ X @ ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( X @ X2 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Yes ) @ No ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ ( cons @ A @ X2 @ No ) ) ) @ Xs4 ) )
                     => ~ ( accp @ ( product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) ) @ ( partition_rev_rel @ A ) @ ( product_Pair @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) @ ( cons @ A @ X2 @ Xs4 ) ) ) ) ) ) ) ) ) ) ).

% partition_rev.pelims
thf(fact_5010_list__collect__set__map__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: B > ( set @ A ),X: C > B] :
      ( ( list_collect_set @ B @ A @ F @ ( map @ C @ B @ X @ ( nil @ C ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% list_collect_set_map_simps(1)
thf(fact_5011_in__measures_I1_J,axiom,
    ! [A: $tType,X: A,Y: A] :
      ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( nil @ ( A > nat ) ) ) ) ).

% in_measures(1)
thf(fact_5012_list__collect__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F: B > ( set @ A )] :
      ( ( list_collect_set @ B @ A @ F @ ( nil @ B ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% list_collect_set_simps(1)
thf(fact_5013_partition__rev_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,Yes2: list @ A,No2: list @ A,X: A,Xs: list @ A] :
      ( ( partition_rev @ A @ P @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ No2 ) @ ( cons @ A @ X @ Xs ) )
      = ( partition_rev @ A @ P @ ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P @ X ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Yes2 ) @ No2 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ ( cons @ A @ X @ No2 ) ) ) @ Xs ) ) ).

% partition_rev.simps(2)
thf(fact_5014_partition__rev_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o,Yes2: list @ A,No2: list @ A] :
      ( ( partition_rev @ A @ P @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ No2 ) @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ No2 ) ) ).

% partition_rev.simps(1)
thf(fact_5015_measures__less,axiom,
    ! [A: $tType,F: A > nat,X: A,Y: A,Fs: list @ ( A > nat )] :
      ( ( ord_less @ nat @ ( F @ X ) @ ( F @ Y ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F @ Fs ) ) ) ) ).

% measures_less
thf(fact_5016_measures__lesseq,axiom,
    ! [A: $tType,F: A > nat,X: A,Y: A,Fs: list @ ( A > nat )] :
      ( ( ord_less_eq @ nat @ ( F @ X ) @ ( F @ Y ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ Fs ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F @ Fs ) ) ) ) ) ).

% measures_lesseq
thf(fact_5017_partition__rev_Oelims,axiom,
    ! [A: $tType,X: A > $o,Xa: product_prod @ ( list @ A ) @ ( list @ A ),Xb: list @ A,Y: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ( ( partition_rev @ A @ X @ Xa @ Xb )
        = Y )
     => ( ! [Yes: list @ A,No: list @ A] :
            ( ( Xa
              = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
           => ( ( Xb
                = ( nil @ A ) )
             => ( Y
               != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) ) ) )
       => ~ ! [Yes: list @ A,No: list @ A] :
              ( ( Xa
                = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
             => ! [X2: A,Xs4: list @ A] :
                  ( ( Xb
                    = ( cons @ A @ X2 @ Xs4 ) )
                 => ( Y
                   != ( partition_rev @ A @ X @ ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( X @ X2 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Yes ) @ No ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ ( cons @ A @ X2 @ No ) ) ) @ Xs4 ) ) ) ) ) ) ).

% partition_rev.elims
thf(fact_5018_quicksort__by__rel_Osimps_I2_J,axiom,
    ! [A: $tType,R: A > A > $o,Sl2: list @ A,X: A,Xs: list @ A] :
      ( ( quicksort_by_rel @ A @ R @ Sl2 @ ( cons @ A @ X @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
        @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ R @ ( cons @ A @ X @ ( quicksort_by_rel @ A @ R @ Sl2 @ Xs_b ) ) @ Xs_s )
        @ ( partition_rev @ A
          @ ^ [Y2: A] : ( R @ Y2 @ X )
          @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
          @ Xs ) ) ) ).

% quicksort_by_rel.simps(2)
thf(fact_5019_quicksort__by__rel_Oelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Xb: list @ A,Y: list @ A] :
      ( ( ( quicksort_by_rel @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( ( Xb
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ~ ! [X2: A,Xs4: list @ A] :
              ( ( Xb
                = ( cons @ A @ X2 @ Xs4 ) )
             => ( Y
               != ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
                  @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ X @ ( cons @ A @ X2 @ ( quicksort_by_rel @ A @ X @ Xa @ Xs_b ) ) @ Xs_s )
                  @ ( partition_rev @ A
                    @ ^ [Y2: A] : ( X @ Y2 @ X2 )
                    @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                    @ Xs4 ) ) ) ) ) ) ).

% quicksort_by_rel.elims
thf(fact_5020_quicksort__by__rel_Opelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Xb: list @ A,Y: list @ A] :
      ( ( ( quicksort_by_rel @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ Xb ) ) )
       => ( ( ( Xb
              = ( nil @ A ) )
           => ( ( Y = Xa )
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ ( nil @ A ) ) ) ) ) )
         => ~ ! [X2: A,Xs4: list @ A] :
                ( ( Xb
                  = ( cons @ A @ X2 @ Xs4 ) )
               => ( ( Y
                    = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
                      @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ X @ ( cons @ A @ X2 @ ( quicksort_by_rel @ A @ X @ Xa @ Xs_b ) ) @ Xs_s )
                      @ ( partition_rev @ A
                        @ ^ [Y2: A] : ( X @ Y2 @ X2 )
                        @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                        @ Xs4 ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ ( cons @ A @ X2 @ Xs4 ) ) ) ) ) ) ) ) ) ).

% quicksort_by_rel.pelims
thf(fact_5021_quicksort__by__rel_Opsimps_I1_J,axiom,
    ! [A: $tType,R: A > A > $o,Sl2: list @ A] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl2 @ ( nil @ A ) ) ) )
     => ( ( quicksort_by_rel @ A @ R @ Sl2 @ ( nil @ A ) )
        = Sl2 ) ) ).

% quicksort_by_rel.psimps(1)
thf(fact_5022_quicksort__by__rel_Opinduct,axiom,
    ! [A: $tType,A0: A > A > $o,A1: list @ A,A22: list @ A,P: ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ A0 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A1 @ A22 ) ) )
     => ( ! [R13: A > A > $o,Sl: list @ A] :
            ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R13 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl @ ( nil @ A ) ) ) )
           => ( P @ R13 @ Sl @ ( nil @ A ) ) )
       => ( ! [R13: A > A > $o,Sl: list @ A,X2: A,Xs4: list @ A] :
              ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R13 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl @ ( cons @ A @ X2 @ Xs4 ) ) ) )
             => ( ! [Xa2: product_prod @ ( list @ A ) @ ( list @ A ),Xb2: list @ A,Y5: list @ A] :
                    ( ( Xa2
                      = ( partition_rev @ A
                        @ ^ [Z4: A] : ( R13 @ Z4 @ X2 )
                        @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                        @ Xs4 ) )
                   => ( ( ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xb2 @ Y5 )
                        = Xa2 )
                     => ( P @ R13 @ Sl @ Y5 ) ) )
               => ( ! [Xa2: product_prod @ ( list @ A ) @ ( list @ A ),Xb2: list @ A,Y5: list @ A] :
                      ( ( Xa2
                        = ( partition_rev @ A
                          @ ^ [Z4: A] : ( R13 @ Z4 @ X2 )
                          @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                          @ Xs4 ) )
                     => ( ( ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xb2 @ Y5 )
                          = Xa2 )
                       => ( P @ R13 @ ( cons @ A @ X2 @ ( quicksort_by_rel @ A @ R13 @ Sl @ Y5 ) ) @ Xb2 ) ) )
                 => ( P @ R13 @ Sl @ ( cons @ A @ X2 @ Xs4 ) ) ) ) )
         => ( P @ A0 @ A1 @ A22 ) ) ) ) ).

% quicksort_by_rel.pinduct
thf(fact_5023_quicksort__by__rel_Opsimps_I2_J,axiom,
    ! [A: $tType,R: A > A > $o,Sl2: list @ A,X: A,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl2 @ ( cons @ A @ X @ Xs ) ) ) )
     => ( ( quicksort_by_rel @ A @ R @ Sl2 @ ( cons @ A @ X @ Xs ) )
        = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
          @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ R @ ( cons @ A @ X @ ( quicksort_by_rel @ A @ R @ Sl2 @ Xs_b ) ) @ Xs_s )
          @ ( partition_rev @ A
            @ ^ [Y2: A] : ( R @ Y2 @ X )
            @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
            @ Xs ) ) ) ) ).

% quicksort_by_rel.psimps(2)
thf(fact_5024_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F2: B > A,A5: A,Xs3: list @ B] :
              ( foldr @ B @ A
              @ ^ [X3: B,B4: A] : ( plus_plus @ A @ ( F2 @ X3 ) @ ( times_times @ A @ A5 @ B4 ) )
              @ Xs3
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_5025_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( ( comm_semiring_0 @ B )
        & ( comm_semiring_0 @ A ) )
     => ! [A4: A > B > $o,B3: C > D > $o] :
          ( ( A4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A4 @ ( bNF_rel_fun @ A @ B @ A @ B @ A4 @ A4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A4 @ ( bNF_rel_fun @ A @ B @ A @ B @ A4 @ A4 ) @ ( times_times @ A ) @ ( times_times @ B ) )
             => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( A > ( list @ C ) > A ) @ ( B > ( list @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ A @ B @ B3 @ A4 ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ C ) > A ) @ ( ( list @ D ) > B ) @ A4 @ ( bNF_rel_fun @ ( list @ C ) @ ( list @ D ) @ A @ B @ ( list_all2 @ C @ D @ B3 ) @ A4 ) ) @ ( groups4207007520872428315er_sum @ C @ A ) @ ( groups4207007520872428315er_sum @ D @ B ) ) ) ) ) ) ).

% horner_sum_transfer
thf(fact_5026_partition__rev__filter__conv,axiom,
    ! [A: $tType,P: A > $o,Yes2: list @ A,No2: list @ A,Xs: list @ A] :
      ( ( partition_rev @ A @ P @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ No2 ) @ Xs )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ ( rev @ A @ ( filter2 @ A @ P @ Xs ) ) @ Yes2 ) @ ( append @ A @ ( rev @ A @ ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs ) ) @ No2 ) ) ) ).

% partition_rev_filter_conv
thf(fact_5027_foldr_Ofoldr__Cons,axiom,
    ! [B: $tType,A: $tType,F: A > B > B,X: A,Xs: list @ A] :
      ( ( foldr @ A @ B @ F @ ( cons @ A @ X @ Xs ) )
      = ( comp @ B @ B @ B @ ( F @ X ) @ ( foldr @ A @ B @ F @ Xs ) ) ) ).

% foldr.foldr_Cons
thf(fact_5028_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: B > A > A,F: C > B,Xs: list @ C,A3: A] :
      ( ( foldr @ B @ A @ G @ ( map @ C @ B @ F @ Xs ) @ A3 )
      = ( foldr @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G @ F ) @ Xs @ A3 ) ) ).

% foldr_map
thf(fact_5029_fold__rev,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F: A > B > B] :
      ( ! [X2: A,Y3: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F @ Y3 ) @ ( F @ X2 ) )
              = ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) ) ) )
     => ( ( fold @ A @ B @ F @ ( rev @ A @ Xs ) )
        = ( fold @ A @ B @ F @ Xs ) ) ) ).

% fold_rev
thf(fact_5030_foldr__fold,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F: A > B > B] :
      ( ! [X2: A,Y3: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F @ Y3 ) @ ( F @ X2 ) )
              = ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) ) ) )
     => ( ( foldr @ A @ B @ F @ Xs )
        = ( fold @ A @ B @ F @ Xs ) ) ) ).

% foldr_fold
thf(fact_5031_prod__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_mult @ B )
        & ( monoid_mult @ A ) )
     => ! [A4: A > B > $o] :
          ( ( A4 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A4 @ ( bNF_rel_fun @ A @ B @ A @ B @ A4 @ A4 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A4 ) @ A4 @ ( groups5270119922927024881d_list @ A ) @ ( groups5270119922927024881d_list @ B ) ) ) ) ) ).

% prod_list_transfer
thf(fact_5032_lexordp__conv__lexord,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ ( ord_less @ A ) ) ) ) ) ) ) ) ).

% lexordp_conv_lexord
thf(fact_5033_revg_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: list @ A] :
      ( ( ( revg @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( revg_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y = Xa )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( revg_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ~ ! [A8: A,As2: list @ A] :
                ( ( X
                  = ( cons @ A @ A8 @ As2 ) )
               => ( ( Y
                    = ( revg @ A @ As2 @ ( cons @ A @ A8 @ Xa ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( revg_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A8 @ As2 ) @ Xa ) ) ) ) ) ) ) ).

% revg.pelims
thf(fact_5034_prod__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( cons @ A @ X @ Xs ) )
          = ( times_times @ A @ X @ ( groups5270119922927024881d_list @ A @ Xs ) ) ) ) ).

% prod_list.Cons
thf(fact_5035_prod__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A @ ( nil @ A ) )
        = ( one_one @ A ) ) ) ).

% prod_list.Nil
thf(fact_5036_prod__list_Oappend,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( append @ A @ Xs @ Ys ) )
          = ( times_times @ A @ ( groups5270119922927024881d_list @ A @ Xs ) @ ( groups5270119922927024881d_list @ A @ Ys ) ) ) ) ).

% prod_list.append
thf(fact_5037_prod__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A )
        = ( ^ [Xs3: list @ A] : ( foldr @ A @ A @ ( times_times @ A ) @ Xs3 @ ( one_one @ A ) ) ) ) ) ).

% prod_list.eq_foldr
thf(fact_5038_map__of__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: C > B,Xs: list @ ( product_prod @ A @ C )] :
      ( ( map_of @ A @ B
        @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
            @ ^ [K4: A,V3: C] : ( product_Pair @ A @ B @ K4 @ ( F @ V3 ) ) )
          @ Xs ) )
      = ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F ) @ ( map_of @ A @ C @ Xs ) ) ) ).

% map_of_map
thf(fact_5039_assert__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_assert @ A )
      = ( ^ [P3: A > $o,X3: A] : ( if @ ( heap_Time_Heap @ A ) @ ( P3 @ X3 ) @ ( heap_Time_return @ A @ X3 ) @ ( heap_Time_raise @ A @ ( cons @ char @ ( char2 @ $true @ $false @ $false @ $false @ $false @ $true @ $true @ $false ) @ ( cons @ char @ ( char2 @ $true @ $true @ $false @ $false @ $true @ $true @ $true @ $false ) @ ( cons @ char @ ( char2 @ $true @ $true @ $false @ $false @ $true @ $true @ $true @ $false ) @ ( cons @ char @ ( char2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ $false ) @ ( cons @ char @ ( char2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ $false ) @ ( cons @ char @ ( char2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ $false ) @ ( nil @ char ) ) ) ) ) ) ) ) ) ) ) ).

% assert_def
thf(fact_5040_prod__list__def,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A )
        = ( groups_monoid_F @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod_list_def
thf(fact_5041_case__map__option,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: A,H2: B > A,F: C > B,X: option @ C] :
      ( ( case_option @ A @ B @ G @ H2 @ ( map_option @ C @ B @ F @ X ) )
      = ( case_option @ A @ C @ G @ ( comp @ B @ A @ C @ H2 @ F ) @ X ) ) ).

% case_map_option
thf(fact_5042_dom__map__option__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: C > B,M4: A > ( option @ C )] :
      ( ( dom @ A @ B @ ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ G ) @ M4 ) )
      = ( dom @ A @ C @ M4 ) ) ).

% dom_map_option_comp
thf(fact_5043_map__option__o__empty,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: C > B] :
      ( ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F )
        @ ^ [X3: A] : ( none @ C ) )
      = ( ^ [X3: A] : ( none @ B ) ) ) ).

% map_option_o_empty
thf(fact_5044_map__option__o__map__upd,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: C > B,M4: A > ( option @ C ),A3: A,B2: C] :
      ( ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F ) @ ( fun_upd @ A @ ( option @ C ) @ M4 @ A3 @ ( some @ C @ B2 ) ) )
      = ( fun_upd @ A @ ( option @ B ) @ ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F ) @ M4 ) @ A3 @ ( some @ B @ ( F @ B2 ) ) ) ) ).

% map_option_o_map_upd
thf(fact_5045_map__option_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: B > C,G: A > B,Option: option @ A] :
      ( ( map_option @ B @ C @ F @ ( map_option @ A @ B @ G @ Option ) )
      = ( map_option @ A @ C @ ( comp @ B @ C @ A @ F @ G ) @ Option ) ) ).

% map_option.compositionality
thf(fact_5046_option_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F: A > B,V: option @ A] :
      ( ( map_option @ B @ C @ G @ ( map_option @ A @ B @ F @ V ) )
      = ( map_option @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) ).

% option.map_comp
thf(fact_5047_map__option_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: B > C,G: A > B] :
      ( ( comp @ ( option @ B ) @ ( option @ C ) @ ( option @ A ) @ ( map_option @ B @ C @ F ) @ ( map_option @ A @ B @ G ) )
      = ( map_option @ A @ C @ ( comp @ B @ C @ A @ F @ G ) ) ) ).

% map_option.comp
thf(fact_5048_option_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F: B > nat,G: A > B] :
      ( ( comp @ ( option @ B ) @ nat @ ( option @ A ) @ ( size_option @ B @ F ) @ ( map_option @ A @ B @ G ) )
      = ( size_option @ A @ ( comp @ B @ nat @ A @ F @ G ) ) ) ).

% option.size_gen_o_map
thf(fact_5049_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R4: B,Xs: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X3: C] : R4
              @ Xs ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs ) ) @ R4 ) ) ) ).

% sum_list_triv
thf(fact_5050_merge_Opelims,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: list @ A,Xa: list @ A,Y: list @ A] :
          ( ( ( merge @ A @ X @ Xa )
            = Y )
         => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( merge_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
           => ( ( ( X
                  = ( nil @ A ) )
               => ( ( Y = Xa )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( merge_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
             => ( ! [V4: A,Va: list @ A] :
                    ( ( X
                      = ( cons @ A @ V4 @ Va ) )
                   => ( ( Xa
                        = ( nil @ A ) )
                     => ( ( Y
                          = ( cons @ A @ V4 @ Va ) )
                       => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( merge_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ V4 @ Va ) @ ( nil @ A ) ) ) ) ) )
               => ~ ! [X12: A,L12: list @ A] :
                      ( ( X
                        = ( cons @ A @ X12 @ L12 ) )
                     => ! [X23: A,L22: list @ A] :
                          ( ( Xa
                            = ( cons @ A @ X23 @ L22 ) )
                         => ( ( ( ( ord_less @ A @ X12 @ X23 )
                               => ( Y
                                  = ( cons @ A @ X12 @ ( merge @ A @ L12 @ ( cons @ A @ X23 @ L22 ) ) ) ) )
                              & ( ~ ( ord_less @ A @ X12 @ X23 )
                               => ( ( ( X12 = X23 )
                                   => ( Y
                                      = ( cons @ A @ X12 @ ( merge @ A @ L12 @ L22 ) ) ) )
                                  & ( ( X12 != X23 )
                                   => ( Y
                                      = ( cons @ A @ X23 @ ( merge @ A @ ( cons @ A @ X12 @ L12 ) @ L22 ) ) ) ) ) ) )
                           => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( merge_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X12 @ L12 ) @ ( cons @ A @ X23 @ L22 ) ) ) ) ) ) ) ) ) ) ) ).

% merge.pelims
thf(fact_5051_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ C2 @ ( F @ X3 ) )
              @ Xs ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F @ Xs ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_5052_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F: B > A,C2: A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( F @ X3 ) @ C2 )
              @ Xs ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F @ Xs ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_5053_uminus__sum__list__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F: B > A,Xs: list @ B] :
          ( ( uminus_uminus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F @ Xs ) ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ ( comp @ A @ A @ B @ ( uminus_uminus @ A ) @ F ) @ Xs ) ) ) ) ).

% uminus_sum_list_map
thf(fact_5054_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_5055_option_Orec__o__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: C,Ga: B > C,F: A > B] :
      ( ( comp @ ( option @ B ) @ C @ ( option @ A ) @ ( rec_option @ C @ B @ G @ Ga ) @ ( map_option @ A @ B @ F ) )
      = ( rec_option @ C @ A @ G
        @ ^ [X3: A] : ( Ga @ ( F @ X3 ) ) ) ) ).

% option.rec_o_map
thf(fact_5056_mergesort__by__rel__split_Opelims,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A ),Xa: list @ A,Y: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ( ( merges295452479951948502_split @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ ( merges7066485432131860899it_rel @ A ) @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ X @ Xa ) )
       => ( ! [Xs13: list @ A,Xs23: list @ A] :
              ( ( X
                = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) )
             => ( ( Xa
                  = ( nil @ A ) )
               => ( ( Y
                    = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) )
                 => ~ ( accp @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ ( merges7066485432131860899it_rel @ A ) @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) @ ( nil @ A ) ) ) ) ) )
         => ( ! [Xs13: list @ A,Xs23: list @ A] :
                ( ( X
                  = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) )
               => ! [X2: A] :
                    ( ( Xa
                      = ( cons @ A @ X2 @ ( nil @ A ) ) )
                   => ( ( Y
                        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs13 ) @ Xs23 ) )
                     => ~ ( accp @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ ( merges7066485432131860899it_rel @ A ) @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ) )
           => ~ ! [Xs13: list @ A,Xs23: list @ A] :
                  ( ( X
                    = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) )
                 => ! [X12: A,X23: A,Xs4: list @ A] :
                      ( ( Xa
                        = ( cons @ A @ X12 @ ( cons @ A @ X23 @ Xs4 ) ) )
                     => ( ( Y
                          = ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X12 @ Xs13 ) @ ( cons @ A @ X23 @ Xs23 ) ) @ Xs4 ) )
                       => ~ ( accp @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ ( merges7066485432131860899it_rel @ A ) @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs13 @ Xs23 ) @ ( cons @ A @ X12 @ ( cons @ A @ X23 @ Xs4 ) ) ) ) ) ) ) ) ) ) ) ).

% mergesort_by_rel_split.pelims
thf(fact_5057_size__list__map,axiom,
    ! [A: $tType,B: $tType,F: A > nat,G: B > A,Xs: list @ B] :
      ( ( size_list @ A @ F @ ( map @ B @ A @ G @ Xs ) )
      = ( size_list @ B @ ( comp @ A @ nat @ B @ F @ G ) @ Xs ) ) ).

% size_list_map
thf(fact_5058_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F: B > nat,G: A > B] :
      ( ( comp @ ( list @ B ) @ nat @ ( list @ A ) @ ( size_list @ B @ F ) @ ( map @ A @ B @ G ) )
      = ( size_list @ A @ ( comp @ B @ nat @ A @ F @ G ) ) ) ).

% list.size_gen_o_map
thf(fact_5059_make_H__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( heap @ A )
        & ( semiring_1 @ B ) )
     => ( ( array_make2 @ B @ A )
        = ( ^ [I2: code_integer,F2: B > A] : ( array_make @ A @ ( code_nat_of_integer @ I2 ) @ ( comp @ B @ A @ nat @ F2 @ ( semiring_1_of_nat @ B ) ) ) ) ) ) ).

% make'_def
thf(fact_5060_next_Osimps,axiom,
    ! [V: code_natural,W2: code_natural] :
      ( ( next @ ( product_Pair @ code_natural @ code_natural @ V @ W2 ) )
      = ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( plus_plus @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( plus_plus @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ W2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ W2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( one_one @ code_natural ) ) ) @ ( one_one @ code_natural ) ) @ ( product_Pair @ code_natural @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ W2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ W2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% next.simps
thf(fact_5061_inter__coset__fold,axiom,
    ! [A: $tType,A4: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( coset @ A @ Xs ) )
      = ( fold @ A @ ( set @ A ) @ ( remove @ A ) @ Xs @ A4 ) ) ).

% inter_coset_fold
thf(fact_5062_log_Ocases,axiom,
    ! [X: product_prod @ code_natural @ code_natural] :
      ~ ! [B6: code_natural,I3: code_natural] :
          ( X
         != ( product_Pair @ code_natural @ code_natural @ B6 @ I3 ) ) ).

% log.cases
thf(fact_5063_iter_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( product_prod @ A @ ( product_unit > code_term ) ) @ ( product_prod @ code_natural @ code_natural ) ) ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) )] :
      ~ ! [Random: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( product_prod @ A @ ( product_unit > code_term ) ) @ ( product_prod @ code_natural @ code_natural ) ),Nrandom: code_natural,Seed: product_prod @ code_natural @ code_natural] :
          ( X
         != ( product_Pair @ ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( product_prod @ A @ ( product_unit > code_term ) ) @ ( product_prod @ code_natural @ code_natural ) ) ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) @ Random @ ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ Nrandom @ Seed ) ) ) ).

% iter.cases
thf(fact_5064_exhaustive__fun_H_Ocases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( quickc658316121487927005ustive @ B )
        & ( cl_HOL_Oequal @ A )
        & ( quickc658316121487927005ustive @ A ) )
     => ! [X: product_prod @ ( ( A > B ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural )] :
          ~ ! [F10: ( A > B ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),I3: code_natural,D3: code_natural] :
              ( X
             != ( product_Pair @ ( ( A > B ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) @ F10 @ ( product_Pair @ code_natural @ code_natural @ I3 @ D3 ) ) ) ) ).

% exhaustive_fun'.cases
thf(fact_5065_exhaustive__natural_H_Ocases,axiom,
    ! [X: product_prod @ ( code_natural > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural )] :
      ~ ! [F10: code_natural > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),D3: code_natural,I3: code_natural] :
          ( X
         != ( product_Pair @ ( code_natural > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) @ F10 @ ( product_Pair @ code_natural @ code_natural @ D3 @ I3 ) ) ) ).

% exhaustive_natural'.cases
thf(fact_5066_full__exhaustive__fun_H_Ocases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( quickc3360725361186068524ustive @ B )
        & ( cl_HOL_Oequal @ A )
        & ( quickc3360725361186068524ustive @ A ) )
     => ! [X: product_prod @ ( ( product_prod @ ( A > B ) @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural )] :
          ~ ! [F10: ( product_prod @ ( A > B ) @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),I3: code_natural,D3: code_natural] :
              ( X
             != ( product_Pair @ ( ( product_prod @ ( A > B ) @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) @ F10 @ ( product_Pair @ code_natural @ code_natural @ I3 @ D3 ) ) ) ) ).

% full_exhaustive_fun'.cases
thf(fact_5067_full__exhaustive__natural_H_Ocases,axiom,
    ! [X: product_prod @ ( ( product_prod @ code_natural @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural )] :
      ~ ! [F10: ( product_prod @ code_natural @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),D3: code_natural,I3: code_natural] :
          ( X
         != ( product_Pair @ ( ( product_prod @ code_natural @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) @ F10 @ ( product_Pair @ code_natural @ code_natural @ D3 @ I3 ) ) ) ).

% full_exhaustive_natural'.cases
thf(fact_5068_nth_H__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_nth2 @ A )
        = ( ^ [A5: array @ A] : ( comp @ nat @ ( heap_Time_Heap @ A ) @ code_integer @ ( array_nth @ A @ A5 ) @ code_nat_of_integer ) ) ) ) ).

% nth'_def
thf(fact_5069_new_H__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_new2 @ A )
        = ( comp @ nat @ ( A > ( heap_Time_Heap @ ( array @ A ) ) ) @ code_integer @ ( array_new @ A ) @ code_nat_of_integer ) ) ) ).

% new'_def
thf(fact_5070_split__seed__def,axiom,
    ( split_seed
    = ( ^ [S6: product_prod @ code_natural @ code_natural] :
          ( product_case_prod @ code_natural @ code_natural @ ( product_prod @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) )
          @ ^ [V3: code_natural,W3: code_natural] :
              ( product_case_prod @ code_natural @ code_natural @ ( product_prod @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) )
              @ ^ [V5: code_natural,W4: code_natural] : ( product_Pair @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) @ ( product_Pair @ code_natural @ code_natural @ ( inc_shift @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ V3 ) @ W4 ) @ ( product_Pair @ code_natural @ code_natural @ V5 @ ( inc_shift @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ W3 ) ) )
              @ ( product_snd @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( next @ S6 ) ) )
          @ S6 ) ) ) ).

% split_seed_def
thf(fact_5071_Lazy__Sequence_Oiterate__upto_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural )] :
      ~ ! [F10: code_natural > A,N3: code_natural,M5: code_natural] :
          ( X
         != ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ F10 @ ( product_Pair @ code_natural @ code_natural @ N3 @ M5 ) ) ) ).

% Lazy_Sequence.iterate_upto.cases
thf(fact_5072_Predicate_Oiterate__upto_Opinduct,axiom,
    ! [A: $tType,A0: code_natural > A,A1: code_natural,A22: code_natural,P: ( code_natural > A ) > code_natural > code_natural > $o] :
      ( ( accp @ ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( iterate_upto_rel @ A ) @ ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ A0 @ ( product_Pair @ code_natural @ code_natural @ A1 @ A22 ) ) )
     => ( ! [F10: code_natural > A,N3: code_natural,M5: code_natural] :
            ( ( accp @ ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( iterate_upto_rel @ A ) @ ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ F10 @ ( product_Pair @ code_natural @ code_natural @ N3 @ M5 ) ) )
           => ( ! [X6: product_unit] :
                  ( ~ ( ord_less @ code_natural @ M5 @ N3 )
                 => ( P @ F10 @ ( plus_plus @ code_natural @ N3 @ ( one_one @ code_natural ) ) @ M5 ) )
             => ( P @ F10 @ N3 @ M5 ) ) )
       => ( P @ A0 @ A1 @ A22 ) ) ) ).

% Predicate.iterate_upto.pinduct
thf(fact_5073_Random_Orange__def,axiom,
    ( range
    = ( ^ [K4: code_natural] :
          ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) )
          @ ( iterate @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( log @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ K4 )
            @ ^ [L3: code_natural] :
                ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) @ next
                @ ^ [V3: code_natural] : ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( plus_plus @ code_natural @ V3 @ ( times_times @ code_natural @ L3 @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
            @ ( one_one @ code_natural ) )
          @ ^ [V3: code_natural] : ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( modulo_modulo @ code_natural @ V3 @ K4 ) ) ) ) ) ).

% Random.range_def
thf(fact_5074_scomp__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,X: A > ( product_prod @ B @ C )] :
      ( ( product_scomp @ A @ B @ C @ ( product_prod @ B @ C ) @ X @ ( product_Pair @ B @ C ) )
      = X ) ).

% scomp_Pair
thf(fact_5075_Pair__scomp,axiom,
    ! [A: $tType,B: $tType,C: $tType,X: C,F: C > A > B] :
      ( ( product_scomp @ A @ C @ A @ B @ ( product_Pair @ C @ A @ X ) @ F )
      = ( F @ X ) ) ).

% Pair_scomp
thf(fact_5076_small__lazy_H_Ocases,axiom,
    ! [X: product_prod @ int @ int] :
      ~ ! [D3: int,I3: int] :
          ( X
         != ( product_Pair @ int @ int @ D3 @ I3 ) ) ).

% small_lazy'.cases
thf(fact_5077_iterate_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( iterate @ B @ A )
      = ( ^ [K4: code_natural,F2: B > A > ( product_prod @ B @ A ),X3: B] :
            ( if @ ( A > ( product_prod @ B @ A ) )
            @ ( K4
              = ( zero_zero @ code_natural ) )
            @ ( product_Pair @ B @ A @ X3 )
            @ ( product_scomp @ A @ B @ A @ ( product_prod @ B @ A ) @ ( F2 @ X3 ) @ ( iterate @ B @ A @ ( minus_minus @ code_natural @ K4 @ ( one_one @ code_natural ) ) @ F2 ) ) ) ) ) ).

% iterate.simps
thf(fact_5078_iterate_Oelims,axiom,
    ! [A: $tType,B: $tType,X: code_natural,Xa: B > A > ( product_prod @ B @ A ),Xb: B,Y: A > ( product_prod @ B @ A )] :
      ( ( ( iterate @ B @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( ( X
            = ( zero_zero @ code_natural ) )
         => ( Y
            = ( product_Pair @ B @ A @ Xb ) ) )
        & ( ( X
           != ( zero_zero @ code_natural ) )
         => ( Y
            = ( product_scomp @ A @ B @ A @ ( product_prod @ B @ A ) @ ( Xa @ Xb ) @ ( iterate @ B @ A @ ( minus_minus @ code_natural @ X @ ( one_one @ code_natural ) ) @ Xa ) ) ) ) ) ) ).

% iterate.elims
thf(fact_5079_log_Opelims,axiom,
    ! [X: code_natural,Xa: code_natural,Y: code_natural] :
      ( ( ( log @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ code_natural @ code_natural ) @ log_rel @ ( product_Pair @ code_natural @ code_natural @ X @ Xa ) )
       => ~ ( ( ( ( ( ord_less_eq @ code_natural @ X @ ( one_one @ code_natural ) )
                  | ( ord_less @ code_natural @ Xa @ X ) )
               => ( Y
                  = ( one_one @ code_natural ) ) )
              & ( ~ ( ( ord_less_eq @ code_natural @ X @ ( one_one @ code_natural ) )
                    | ( ord_less @ code_natural @ Xa @ X ) )
               => ( Y
                  = ( plus_plus @ code_natural @ ( one_one @ code_natural ) @ ( log @ X @ ( divide_divide @ code_natural @ Xa @ X ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ code_natural @ code_natural ) @ log_rel @ ( product_Pair @ code_natural @ code_natural @ X @ Xa ) ) ) ) ) ).

% log.pelims
thf(fact_5080_iterate_Opelims,axiom,
    ! [A: $tType,B: $tType,X: code_natural,Xa: B > A > ( product_prod @ B @ A ),Xb: B,Y: A > ( product_prod @ B @ A )] :
      ( ( ( iterate @ B @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) @ ( iterate_rel @ B @ A ) @ ( product_Pair @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) @ X @ ( product_Pair @ ( B > A > ( product_prod @ B @ A ) ) @ B @ Xa @ Xb ) ) )
       => ~ ( ( ( ( X
                  = ( zero_zero @ code_natural ) )
               => ( Y
                  = ( product_Pair @ B @ A @ Xb ) ) )
              & ( ( X
                 != ( zero_zero @ code_natural ) )
               => ( Y
                  = ( product_scomp @ A @ B @ A @ ( product_prod @ B @ A ) @ ( Xa @ Xb ) @ ( iterate @ B @ A @ ( minus_minus @ code_natural @ X @ ( one_one @ code_natural ) ) @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) @ ( iterate_rel @ B @ A ) @ ( product_Pair @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) @ X @ ( product_Pair @ ( B > A > ( product_prod @ B @ A ) ) @ B @ Xa @ Xb ) ) ) ) ) ) ).

% iterate.pelims
thf(fact_5081_iter_H_Ocases,axiom,
    ! [A: $tType] :
      ( ( quickcheck_random @ A )
     => ! [X: product_prod @ ( itself @ A ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) )] :
          ~ ! [T5: itself @ A,Nrandom: code_natural,Sz: code_natural,Seed: product_prod @ code_natural @ code_natural] :
              ( X
             != ( product_Pair @ ( itself @ A ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) ) @ T5 @ ( product_Pair @ code_natural @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) @ Nrandom @ ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ Sz @ Seed ) ) ) ) ) ).

% iter'.cases
thf(fact_5082_iterate_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B )] :
      ~ ! [K2: code_natural,F10: B > A > ( product_prod @ B @ A ),X2: B] :
          ( X
         != ( product_Pair @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) @ K2 @ ( product_Pair @ ( B > A > ( product_prod @ B @ A ) ) @ B @ F10 @ X2 ) ) ) ).

% iterate.cases
thf(fact_5083_prod__filter__assoc,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: filter @ A,G6: filter @ B,H10: filter @ C] :
      ( ( prod_filter @ ( product_prod @ A @ B ) @ C @ ( prod_filter @ A @ B @ F3 @ G6 ) @ H10 )
      = ( filtermap @ ( product_prod @ A @ ( product_prod @ B @ C ) ) @ ( product_prod @ ( product_prod @ A @ B ) @ C )
        @ ( product_case_prod @ A @ ( product_prod @ B @ C ) @ ( product_prod @ ( product_prod @ A @ B ) @ C )
          @ ^ [X3: A] :
              ( product_case_prod @ B @ C @ ( product_prod @ ( product_prod @ A @ B ) @ C )
              @ ^ [Y2: B] : ( product_Pair @ ( product_prod @ A @ B ) @ C @ ( product_Pair @ A @ B @ X3 @ Y2 ) ) ) )
        @ ( prod_filter @ A @ ( product_prod @ B @ C ) @ F3 @ ( prod_filter @ B @ C @ G6 @ H10 ) ) ) ) ).

% prod_filter_assoc
thf(fact_5084_select__weight__cons__zero,axiom,
    ! [A: $tType,X: A,Xs: list @ ( product_prod @ code_natural @ A )] :
      ( ( select_weight @ A @ ( cons @ ( product_prod @ code_natural @ A ) @ ( product_Pair @ code_natural @ A @ ( zero_zero @ code_natural ) @ X ) @ Xs ) )
      = ( select_weight @ A @ Xs ) ) ).

% select_weight_cons_zero
thf(fact_5085_select__weight__def,axiom,
    ! [A: $tType] :
      ( ( select_weight @ A )
      = ( ^ [Xs3: list @ ( product_prod @ code_natural @ A )] :
            ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) @ ( range @ ( groups8242544230860333062m_list @ code_natural @ ( map @ ( product_prod @ code_natural @ A ) @ code_natural @ ( product_fst @ code_natural @ A ) @ Xs3 ) ) )
            @ ^ [K4: code_natural] : ( product_Pair @ A @ ( product_prod @ code_natural @ code_natural ) @ ( pick @ A @ Xs3 @ K4 ) ) ) ) ) ).

% select_weight_def
thf(fact_5086_filtermap__bot,axiom,
    ! [B: $tType,A: $tType,F: B > A] :
      ( ( filtermap @ B @ A @ F @ ( bot_bot @ ( filter @ B ) ) )
      = ( bot_bot @ ( filter @ A ) ) ) ).

% filtermap_bot
thf(fact_5087_filtermap__bot__iff,axiom,
    ! [A: $tType,B: $tType,F: B > A,F3: filter @ B] :
      ( ( ( filtermap @ B @ A @ F @ F3 )
        = ( bot_bot @ ( filter @ A ) ) )
      = ( F3
        = ( bot_bot @ ( filter @ B ) ) ) ) ).

% filtermap_bot_iff
thf(fact_5088_filtermap__Pair,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: C > A,G: C > B,F3: filter @ C] :
      ( ord_less_eq @ ( filter @ ( product_prod @ A @ B ) )
      @ ( filtermap @ C @ ( product_prod @ A @ B )
        @ ^ [X3: C] : ( product_Pair @ A @ B @ ( F @ X3 ) @ ( G @ X3 ) )
        @ F3 )
      @ ( prod_filter @ A @ B @ ( filtermap @ C @ A @ F @ F3 ) @ ( filtermap @ C @ B @ G @ F3 ) ) ) ).

% filtermap_Pair
thf(fact_5089_filtermap__inf,axiom,
    ! [A: $tType,B: $tType,F: B > A,F12: filter @ B,F24: filter @ B] : ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ B @ A @ F @ ( inf_inf @ ( filter @ B ) @ F12 @ F24 ) ) @ ( inf_inf @ ( filter @ A ) @ ( filtermap @ B @ A @ F @ F12 ) @ ( filtermap @ B @ A @ F @ F24 ) ) ) ).

% filtermap_inf
thf(fact_5090_select__weight__select,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( select_weight @ A @ ( map @ A @ ( product_prod @ code_natural @ A ) @ ( product_Pair @ code_natural @ A @ ( one_one @ code_natural ) ) @ Xs ) )
        = ( select @ A @ Xs ) ) ) ).

% select_weight_select
thf(fact_5091_prod__filter__principal__singleton2,axiom,
    ! [B: $tType,A: $tType,F3: filter @ A,X: B] :
      ( ( prod_filter @ A @ B @ F3 @ ( principal @ B @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( filtermap @ A @ ( product_prod @ A @ B )
        @ ^ [A5: A] : ( product_Pair @ A @ B @ A5 @ X )
        @ F3 ) ) ).

% prod_filter_principal_singleton2
thf(fact_5092_pick__same,axiom,
    ! [A: $tType,L: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ L @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( pick @ A @ ( map @ A @ ( product_prod @ code_natural @ A ) @ ( product_Pair @ code_natural @ A @ ( one_one @ code_natural ) ) @ Xs ) @ ( code_natural_of_nat @ L ) )
        = ( nth @ A @ Xs @ L ) ) ) ).

% pick_same
thf(fact_5093_inf__principal,axiom,
    ! [A: $tType,A4: set @ A,B3: set @ A] :
      ( ( inf_inf @ ( filter @ A ) @ ( principal @ A @ A4 ) @ ( principal @ A @ B3 ) )
      = ( principal @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ).

% inf_principal
thf(fact_5094_principal__eq__bot__iff,axiom,
    ! [A: $tType,X5: set @ A] :
      ( ( ( principal @ A @ X5 )
        = ( bot_bot @ ( filter @ A ) ) )
      = ( X5
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% principal_eq_bot_iff
thf(fact_5095_bot__eq__principal__empty,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( filter @ A ) )
      = ( principal @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% bot_eq_principal_empty
thf(fact_5096_eventually__inf__principal,axiom,
    ! [A: $tType,P: A > $o,F3: filter @ A,S: set @ A] :
      ( ( eventually @ A @ P @ ( inf_inf @ ( filter @ A ) @ F3 @ ( principal @ A @ S ) ) )
      = ( eventually @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ S )
           => ( P @ X3 ) )
        @ F3 ) ) ).

% eventually_inf_principal
thf(fact_5097_prod__filter__principal__singleton,axiom,
    ! [A: $tType,B: $tType,X: A,F3: filter @ B] :
      ( ( prod_filter @ A @ B @ ( principal @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ F3 )
      = ( filtermap @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ F3 ) ) ).

% prod_filter_principal_singleton
thf(fact_5098_select__def,axiom,
    ! [A: $tType] :
      ( ( select @ A )
      = ( ^ [Xs3: list @ A] :
            ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) @ ( range @ ( code_natural_of_nat @ ( size_size @ ( list @ A ) @ Xs3 ) ) )
            @ ^ [K4: code_natural] : ( product_Pair @ A @ ( product_prod @ code_natural @ code_natural ) @ ( nth @ A @ Xs3 @ ( code_nat_of_natural @ K4 ) ) ) ) ) ) ).

% select_def
thf(fact_5099_finite__subsets__at__top__finite,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite5375528669736107172at_top @ A @ A4 )
        = ( principal @ ( set @ A ) @ ( insert2 @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ).

% finite_subsets_at_top_finite
thf(fact_5100_filterlim__base__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,I4: set @ A,F3: A > ( set @ B ),F: B > C,G6: D > ( set @ C ),J4: set @ D] :
      ( ( I4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I4 )
           => ! [J3: A] :
                ( ( member @ A @ J3 @ I4 )
               => ( ( ord_less_eq @ ( set @ B ) @ ( F3 @ I3 ) @ ( F3 @ J3 ) )
                  | ( ord_less_eq @ ( set @ B ) @ ( F3 @ J3 ) @ ( F3 @ I3 ) ) ) ) )
       => ( ( filterlim @ B @ C @ F
            @ ( complete_Inf_Inf @ ( filter @ C )
              @ ( image2 @ D @ ( filter @ C )
                @ ^ [J: D] : ( principal @ C @ ( G6 @ J ) )
                @ J4 ) )
            @ ( complete_Inf_Inf @ ( filter @ B )
              @ ( image2 @ A @ ( filter @ B )
                @ ^ [I2: A] : ( principal @ B @ ( F3 @ I2 ) )
                @ I4 ) ) )
          = ( ! [X3: D] :
                ( ( member @ D @ X3 @ J4 )
               => ? [Y2: A] :
                    ( ( member @ A @ Y2 @ I4 )
                    & ! [Z4: B] :
                        ( ( member @ B @ Z4 @ ( F3 @ Y2 ) )
                       => ( member @ C @ ( F @ Z4 ) @ ( G6 @ X3 ) ) ) ) ) ) ) ) ) ).

% filterlim_base_iff
thf(fact_5101_filterlim__inf,axiom,
    ! [B: $tType,A: $tType,F: A > B,F24: filter @ B,F32: filter @ B,F12: filter @ A] :
      ( ( filterlim @ A @ B @ F @ ( inf_inf @ ( filter @ B ) @ F24 @ F32 ) @ F12 )
      = ( ( filterlim @ A @ B @ F @ F24 @ F12 )
        & ( filterlim @ A @ B @ F @ F32 @ F12 ) ) ) ).

% filterlim_inf
thf(fact_5102_finite__subsets__at__top__neq__bot,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite5375528669736107172at_top @ A @ A4 )
     != ( bot_bot @ ( filter @ ( set @ A ) ) ) ) ).

% finite_subsets_at_top_neq_bot
thf(fact_5103_filterlim__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > B,G6: filter @ B,F3: filter @ A,G: A > C,H10: filter @ C] :
      ( ( filterlim @ A @ B @ F @ G6 @ F3 )
     => ( ( filterlim @ A @ C @ G @ H10 @ F3 )
       => ( filterlim @ A @ ( product_prod @ B @ C )
          @ ^ [X3: A] : ( product_Pair @ B @ C @ ( F @ X3 ) @ ( G @ X3 ) )
          @ ( prod_filter @ B @ C @ G6 @ H10 )
          @ F3 ) ) ) ).

% filterlim_Pair
thf(fact_5104_filterlim__If,axiom,
    ! [B: $tType,A: $tType,F: A > B,G6: filter @ B,F3: filter @ A,P: A > $o,G: A > B] :
      ( ( filterlim @ A @ B @ F @ G6 @ ( inf_inf @ ( filter @ A ) @ F3 @ ( principal @ A @ ( collect @ A @ P ) ) ) )
     => ( ( filterlim @ A @ B @ G @ G6
          @ ( inf_inf @ ( filter @ A ) @ F3
            @ ( principal @ A
              @ ( collect @ A
                @ ^ [X3: A] :
                    ~ ( P @ X3 ) ) ) ) )
       => ( filterlim @ A @ B
          @ ^ [X3: A] : ( if @ B @ ( P @ X3 ) @ ( F @ X3 ) @ ( G @ X3 ) )
          @ G6
          @ F3 ) ) ) ).

% filterlim_If
thf(fact_5105_map__conv__bind__option,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map_option @ B @ A )
      = ( ^ [F2: B > A,X3: option @ B] : ( bind @ B @ A @ X3 @ ( comp @ A @ ( option @ A ) @ B @ ( some @ A ) @ F2 ) ) ) ) ).

% map_conv_bind_option
thf(fact_5106_Random__Pred_Ounion__def,axiom,
    ! [A: $tType] :
      ( ( random_union @ A )
      = ( ^ [R14: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ),R25: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ),S6: product_prod @ code_natural @ code_natural] :
            ( product_case_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) )
            @ ^ [P13: pred @ A,S8: product_prod @ code_natural @ code_natural] :
                ( product_case_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) )
                @ ^ [P25: pred @ A] : ( product_Pair @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) @ ( sup_sup @ ( pred @ A ) @ P13 @ P25 ) )
                @ ( R25 @ S8 ) )
            @ ( R14 @ S6 ) ) ) ) ).

% Random_Pred.union_def
thf(fact_5107_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F: B > A,X: B,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X @ A4 ) @ S2 )
       => ( ( finite_finite @ B @ A4 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F @ A4 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_5108_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F )
     => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F @ ( bot_bot @ ( set @ B ) ) )
        = ( nil @ B ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
thf(fact_5109_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F: B > A,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ B ) @ A4 @ S2 )
       => ( ( finite_finite @ B @ A4 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F @ A4 )
              = ( nil @ B ) )
            = ( A4
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_5110_bind__map__option,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: C > B,X: option @ C,G: B > ( option @ A )] :
      ( ( bind @ B @ A @ ( map_option @ C @ B @ F @ X ) @ G )
      = ( bind @ C @ A @ X @ ( comp @ B @ ( option @ A ) @ C @ G @ F ) ) ) ).

% bind_map_option
thf(fact_5111_map__option__bind,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: B > A,X: option @ C,G: C > ( option @ B )] :
      ( ( map_option @ B @ A @ F @ ( bind @ C @ B @ X @ G ) )
      = ( bind @ C @ A @ X @ ( comp @ ( option @ B ) @ ( option @ A ) @ C @ ( map_option @ B @ A @ F ) @ G ) ) ) ).

% map_option_bind
thf(fact_5112_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F: B > A,X: B,A4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X @ A4 ) @ S2 )
       => ( ( finite_finite @ B @ A4 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F @ ( insert2 @ B @ X @ A4 ) )
            = ( insort_key @ A @ B @ Less_eq @ F @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_5113_Random__Pred_Oempty__def,axiom,
    ! [A: $tType] :
      ( ( random_empty @ A )
      = ( product_Pair @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) @ ( bot_bot @ ( pred @ A ) ) ) ) ).

% Random_Pred.empty_def
thf(fact_5114_Random__Pred_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( random_bind @ A @ B )
      = ( ^ [R2: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ),F2: A > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ B ) @ ( product_prod @ code_natural @ code_natural ) ),S6: product_prod @ code_natural @ code_natural] :
            ( product_case_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ ( pred @ B ) @ ( product_prod @ code_natural @ code_natural ) )
            @ ^ [P3: pred @ A,S8: product_prod @ code_natural @ code_natural] :
                ( product_case_prod @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ ( pred @ B ) @ ( product_prod @ code_natural @ code_natural ) )
                @ ^ [S1: product_prod @ code_natural @ code_natural] :
                    ( product_Pair @ ( pred @ B ) @ ( product_prod @ code_natural @ code_natural )
                    @ ( bind2 @ A @ B @ P3
                      @ ^ [A5: A] : ( product_fst @ ( pred @ B ) @ ( product_prod @ code_natural @ code_natural ) @ ( F2 @ A5 @ S1 ) ) ) )
                @ ( split_seed @ S8 ) )
            @ ( R2 @ S6 ) ) ) ) ).

% Random_Pred.bind_def
thf(fact_5115_bottom__bind,axiom,
    ! [B: $tType,A: $tType,P: B > ( pred @ A )] :
      ( ( bind2 @ B @ A @ ( bot_bot @ ( pred @ B ) ) @ P )
      = ( bot_bot @ ( pred @ A ) ) ) ).

% bottom_bind
thf(fact_5116_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F: B > A,X: B,Y: B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F )
     => ( ( member @ B @ X @ S2 )
       => ( ( member @ B @ Y @ S2 )
         => ( ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F @ Y ) @ ( insort_key @ A @ B @ Less_eq @ F @ X ) )
            = ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F @ X ) @ ( insort_key @ A @ B @ Less_eq @ F @ Y ) ) ) ) ) ) ).

% folding_insort_key.insort_key_commute
thf(fact_5117_Random__Pred_Omap__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( random_map @ A @ B )
      = ( ^ [F2: A > B,P3: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) )] : ( random_bind @ A @ B @ P3 @ ( comp @ B @ ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ B ) @ ( product_prod @ code_natural @ code_natural ) ) ) @ A @ ( random_single @ B ) @ F2 ) ) ) ) ).

% Random_Pred.map_def
thf(fact_5118_set__bind__option,axiom,
    ! [A: $tType,B: $tType,X: option @ B,F: B > ( option @ A )] :
      ( ( set_option @ A @ ( bind @ B @ A @ X @ F ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ ( comp @ ( option @ A ) @ ( set @ A ) @ B @ ( set_option @ A ) @ F ) @ ( set_option @ B @ X ) ) ) ) ).

% set_bind_option
thf(fact_5119_singleton__sup,axiom,
    ! [A: $tType,A4: pred @ A,Default: product_unit > A,B3: pred @ A] :
      ( ( ( A4
          = ( bot_bot @ ( pred @ A ) ) )
       => ( ( singleton @ A @ Default @ ( sup_sup @ ( pred @ A ) @ A4 @ B3 ) )
          = ( singleton @ A @ Default @ B3 ) ) )
      & ( ( A4
         != ( bot_bot @ ( pred @ A ) ) )
       => ( ( ( B3
              = ( bot_bot @ ( pred @ A ) ) )
           => ( ( singleton @ A @ Default @ ( sup_sup @ ( pred @ A ) @ A4 @ B3 ) )
              = ( singleton @ A @ Default @ A4 ) ) )
          & ( ( B3
             != ( bot_bot @ ( pred @ A ) ) )
           => ( ( ( ( singleton @ A @ Default @ A4 )
                  = ( singleton @ A @ Default @ B3 ) )
               => ( ( singleton @ A @ Default @ ( sup_sup @ ( pred @ A ) @ A4 @ B3 ) )
                  = ( singleton @ A @ Default @ A4 ) ) )
              & ( ( ( singleton @ A @ Default @ A4 )
                 != ( singleton @ A @ Default @ B3 ) )
               => ( ( singleton @ A @ Default @ ( sup_sup @ ( pred @ A ) @ A4 @ B3 ) )
                  = ( Default @ product_Unity ) ) ) ) ) ) ) ) ).

% singleton_sup
thf(fact_5120_set__empty__eq,axiom,
    ! [A: $tType,Xo: option @ A] :
      ( ( ( set_option @ A @ Xo )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xo
        = ( none @ A ) ) ) ).

% set_empty_eq
thf(fact_5121_option_Osimps_I14_J,axiom,
    ! [A: $tType] :
      ( ( set_option @ A @ ( none @ A ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% option.simps(14)
thf(fact_5122_singleton__bot,axiom,
    ! [A: $tType,Default: product_unit > A] :
      ( ( singleton @ A @ Default @ ( bot_bot @ ( pred @ A ) ) )
      = ( Default @ product_Unity ) ) ).

% singleton_bot
thf(fact_5123_option_Osimps_I15_J,axiom,
    ! [A: $tType,X22: A] :
      ( ( set_option @ A @ ( some @ A @ X22 ) )
      = ( insert2 @ A @ X22 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% option.simps(15)
thf(fact_5124_singleton__sup__aux,axiom,
    ! [A: $tType,A4: pred @ A,Default: product_unit > A,B3: pred @ A] :
      ( ( ( A4
          = ( bot_bot @ ( pred @ A ) ) )
       => ( ( singleton @ A @ Default @ ( sup_sup @ ( pred @ A ) @ A4 @ B3 ) )
          = ( singleton @ A @ Default @ B3 ) ) )
      & ( ( A4
         != ( bot_bot @ ( pred @ A ) ) )
       => ( ( ( B3
              = ( bot_bot @ ( pred @ A ) ) )
           => ( ( singleton @ A @ Default @ ( sup_sup @ ( pred @ A ) @ A4 @ B3 ) )
              = ( singleton @ A @ Default @ A4 ) ) )
          & ( ( B3
             != ( bot_bot @ ( pred @ A ) ) )
           => ( ( singleton @ A @ Default @ ( sup_sup @ ( pred @ A ) @ A4 @ B3 ) )
              = ( singleton @ A @ Default @ ( sup_sup @ ( pred @ A ) @ ( single @ A @ ( singleton @ A @ Default @ A4 ) ) @ ( single @ A @ ( singleton @ A @ Default @ B3 ) ) ) ) ) ) ) ) ) ).

% singleton_sup_aux
thf(fact_5125_Random__Pred_Osingle__def,axiom,
    ! [A: $tType] :
      ( ( random_single @ A )
      = ( ^ [X3: A] : ( product_Pair @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) @ ( single @ A @ X3 ) ) ) ) ).

% Random_Pred.single_def
thf(fact_5126_mult__one__div__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ A3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( unit_f5069060285200089521factor @ A @ B2 ) ) )
          = ( divide_divide @ A @ A3 @ ( unit_f5069060285200089521factor @ A @ B2 ) ) ) ) ).

% mult_one_div_unit_factor
thf(fact_5127_unit__factor__1,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ( ( unit_f5069060285200089521factor @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% unit_factor_1
thf(fact_5128_inv__unit__factor__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ ( unit_f5069060285200089521factor @ A @ A3 ) )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% inv_unit_factor_eq_0_iff
thf(fact_5129_unit__factor__mult__unit__left,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( times_times @ A @ A3 @ ( unit_f5069060285200089521factor @ A @ B2 ) ) ) ) ) ).

% unit_factor_mult_unit_left
thf(fact_5130_unit__factor__mult__unit__right,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ ( times_times @ A @ B2 @ A3 ) )
            = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ B2 ) @ A3 ) ) ) ) ).

% unit_factor_mult_unit_right
thf(fact_5131_unit__factor__mult,axiom,
    ! [A: $tType] :
      ( ( normal6328177297339901930cative @ A )
     => ! [A3: A,B2: A] :
          ( ( unit_f5069060285200089521factor @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ A3 ) @ ( unit_f5069060285200089521factor @ A @ B2 ) ) ) ) ).

% unit_factor_mult
thf(fact_5132_unit__pred__cases,axiom,
    ! [P: ( pred @ product_unit ) > $o,Q: pred @ product_unit] :
      ( ( P @ ( bot_bot @ ( pred @ product_unit ) ) )
     => ( ( P @ ( single @ product_unit @ product_Unity ) )
       => ( P @ Q ) ) ) ).

% unit_pred_cases
thf(fact_5133_single__not__bot,axiom,
    ! [A: $tType,X: A] :
      ( ( single @ A @ X )
     != ( bot_bot @ ( pred @ A ) ) ) ).

% single_not_bot
thf(fact_5134_is__unit__unit__factor,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ A3 )
            = A3 ) ) ) ).

% is_unit_unit_factor
thf(fact_5135_gcd__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [K: A,A3: A,B2: A] :
          ( ( times_times @ A @ K @ ( gcd_gcd @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( gcd_gcd @ A @ ( times_times @ A @ K @ A3 ) @ ( times_times @ A @ K @ B2 ) ) @ ( unit_f5069060285200089521factor @ A @ K ) ) ) ) ).

% gcd_mult_distrib
thf(fact_5136_mult__gcd__right,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ ( gcd_gcd @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) @ ( unit_f5069060285200089521factor @ A @ C2 ) ) ) ) ).

% mult_gcd_right
thf(fact_5137_mult__gcd__left,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( gcd_gcd @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ C2 ) @ ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_gcd_left
thf(fact_5138_unit__factor__is__unit,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ ( unit_f5069060285200089521factor @ A @ A3 ) @ ( one_one @ A ) ) ) ) ).

% unit_factor_is_unit
thf(fact_5139_unit__factor__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( A3
                = ( zero_zero @ A ) )
              & ( B2
                = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_gcd @ A @ A3 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ( A3
                  = ( zero_zero @ A ) )
                & ( B2
                  = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_gcd @ A @ A3 @ B2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_gcd
thf(fact_5140_coprime__crossproduct_H,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [B2: A,D2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( unit_f5069060285200089521factor @ A @ B2 )
              = ( unit_f5069060285200089521factor @ A @ D2 ) )
           => ( ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
             => ( ( algebr8660921524188924756oprime @ A @ C2 @ D2 )
               => ( ( ( times_times @ A @ A3 @ D2 )
                    = ( times_times @ A @ B2 @ C2 ) )
                  = ( ( A3 = C2 )
                    & ( B2 = D2 ) ) ) ) ) ) ) ) ).

% coprime_crossproduct'
thf(fact_5141_unit__factor__Gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( ( gcd_Gcd @ A @ A4 )
              = ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Gcd @ A @ A4 ) )
              = ( zero_zero @ A ) ) )
          & ( ( ( gcd_Gcd @ A @ A4 )
             != ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Gcd @ A @ A4 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_Gcd
thf(fact_5142_Random__Pred_ORandom__def,axiom,
    ! [A: $tType] :
      ( ( random_Random @ A )
      = ( ^ [G2: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( product_prod @ A @ ( product_unit > code_term ) ) @ ( product_prod @ code_natural @ code_natural ) )] : ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ A @ ( product_unit > code_term ) ) @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) @ G2 @ ( comp @ ( pred @ A ) @ ( ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) ) @ ( product_prod @ A @ ( product_unit > code_term ) ) @ ( product_Pair @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( comp @ A @ ( pred @ A ) @ ( product_prod @ A @ ( product_unit > code_term ) ) @ ( single @ A ) @ ( product_fst @ A @ ( product_unit > code_term ) ) ) ) ) ) ) ).

% Random_Pred.Random_def
thf(fact_5143_pred__of__set__set__foldr__sup,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( pred_of_set @ A @ ( set2 @ A @ Xs ) )
      = ( foldr @ ( pred @ A ) @ ( pred @ A ) @ ( sup_sup @ ( pred @ A ) ) @ ( map @ A @ ( pred @ A ) @ ( single @ A ) @ Xs ) @ ( bot_bot @ ( pred @ A ) ) ) ) ).

% pred_of_set_set_foldr_sup
thf(fact_5144_pred__of__set__set__fold__sup,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( pred_of_set @ A @ ( set2 @ A @ Xs ) )
      = ( fold @ ( pred @ A ) @ ( pred @ A ) @ ( sup_sup @ ( pred @ A ) ) @ ( map @ A @ ( pred @ A ) @ ( single @ A ) @ Xs ) @ ( bot_bot @ ( pred @ A ) ) ) ) ).

% pred_of_set_set_fold_sup
thf(fact_5145_pred__of__set__fold__sup,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( pred_of_set @ A @ A4 )
        = ( finite_fold @ ( pred @ A ) @ ( pred @ A ) @ ( sup_sup @ ( pred @ A ) ) @ ( bot_bot @ ( pred @ A ) ) @ ( image2 @ A @ ( pred @ A ) @ ( single @ A ) @ A4 ) ) ) ) ).

% pred_of_set_fold_sup
thf(fact_5146_if__pred__eq,axiom,
    ( if_pred
    = ( ^ [B4: $o] : ( if @ ( pred @ product_unit ) @ B4 @ ( single @ product_unit @ product_Unity ) @ ( bot_bot @ ( pred @ product_unit ) ) ) ) ) ).

% if_pred_eq
thf(fact_5147_Predicate_Omap__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map2 @ A @ B )
      = ( ^ [F2: A > B,P3: pred @ A] : ( bind2 @ A @ B @ P3 @ ( comp @ B @ ( pred @ B ) @ A @ ( single @ B ) @ F2 ) ) ) ) ).

% Predicate.map_def
thf(fact_5148_contains__pred__def,axiom,
    ! [A: $tType] :
      ( ( predic7144156976422707464s_pred @ A )
      = ( ^ [A10: set @ A,X3: A] : ( if @ ( pred @ product_unit ) @ ( member @ A @ X3 @ A10 ) @ ( single @ product_unit @ product_Unity ) @ ( bot_bot @ ( pred @ product_unit ) ) ) ) ) ).

% contains_pred_def
thf(fact_5149_Predicate_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: B > C,G: A > B] :
      ( ( comp @ ( pred @ B ) @ ( pred @ C ) @ ( pred @ A ) @ ( map2 @ B @ C @ F ) @ ( map2 @ A @ B @ G ) )
      = ( map2 @ A @ C @ ( comp @ B @ C @ A @ F @ G ) ) ) ).

% Predicate.map.comp
thf(fact_5150_Predicate_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: B > C,G: A > B,Pred: pred @ A] :
      ( ( map2 @ B @ C @ F @ ( map2 @ A @ B @ G @ Pred ) )
      = ( map2 @ A @ C @ ( comp @ B @ C @ A @ F @ G ) @ Pred ) ) ).

% Predicate.map.compositionality
thf(fact_5151_Gcd__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde6485984586167503788ce_set @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% Gcd_fin.bounded_quasi_semilattice_set_axioms
thf(fact_5152_Lcm__no__units,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Lcm @ A )
        = ( ^ [A10: set @ A] :
              ( gcd_Lcm @ A
              @ ( minus_minus @ ( set @ A ) @ A10
                @ ( collect @ A
                  @ ^ [A5: A] : ( dvd_dvd @ A @ A5 @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% Lcm_no_units
thf(fact_5153_Heap__lub__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_Heap_lub @ A )
      = ( partial_img_lub @ ( heap_Time_Heap @ A ) @ ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ ( heap_Time_Heap @ A ) @ ( heap_Time_execute @ A ) @ ( heap_Time_Heap2 @ A ) @ ( partial_fun_lub @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( partial_flat_lub @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ) ) ).

% Heap_lub_def
thf(fact_5154_normalize__mult__normalize__right,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A,B2: A] :
          ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ ( normal6383669964737779283malize @ A @ B2 ) ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% normalize_mult_normalize_right
thf(fact_5155_normalize__mult__normalize__left,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A,B2: A] :
          ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ B2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% normalize_mult_normalize_left
thf(fact_5156_gcd_Onormalize__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( normal6383669964737779283malize @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% gcd.normalize_bottom
thf(fact_5157_normalize__1,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ( ( normal6383669964737779283malize @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% normalize_1
thf(fact_5158_Lcm__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Lcm @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Lcm_empty
thf(fact_5159_Lcm__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( gcd_Lcm @ A @ A4 )
            = ( one_one @ A ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( dvd_dvd @ A @ X3 @ ( one_one @ A ) ) ) ) ) ) ).

% Lcm_1_iff
thf(fact_5160_normalize__mult__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ ( unit_f5069060285200089521factor @ A @ A3 ) )
          = A3 ) ) ).

% normalize_mult_unit_factor
thf(fact_5161_unit__factor__mult__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ A3 ) @ ( normal6383669964737779283malize @ A @ A3 ) )
          = A3 ) ) ).

% unit_factor_mult_normalize
thf(fact_5162_normalize__mult__unit__right,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( normal6383669964737779283malize @ A @ A3 ) ) ) ) ).

% normalize_mult_unit_right
thf(fact_5163_normalize__mult__unit__left,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( normal6383669964737779283malize @ A @ B2 ) ) ) ) ).

% normalize_mult_unit_left
thf(fact_5164_normalize__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( normal6383669964737779283malize @ A @ ( unit_f5069060285200089521factor @ A @ A3 ) )
            = ( one_one @ A ) ) ) ) ).

% normalize_unit_factor
thf(fact_5165_unit__factor__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ ( normal6383669964737779283malize @ A @ A3 ) )
            = ( one_one @ A ) ) ) ) ).

% unit_factor_normalize
thf(fact_5166_Lcm__singleton,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: A] :
          ( ( gcd_Lcm @ A @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
          = ( normal6383669964737779283malize @ A @ A3 ) ) ) ).

% Lcm_singleton
thf(fact_5167_normalize__div,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ A3 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( unit_f5069060285200089521factor @ A @ A3 ) ) ) ) ).

% normalize_div
thf(fact_5168_Gcd__singleton,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: A] :
          ( ( gcd_Gcd @ A @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
          = ( normal6383669964737779283malize @ A @ A3 ) ) ) ).

% Gcd_singleton
thf(fact_5169_Lcm__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A,C2: A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( gcd_Lcm @ A @ ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ A4 ) )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_Lcm @ A @ A4 ) ) ) ) ) ) ).

% Lcm_mult
thf(fact_5170_normalize__mult,axiom,
    ! [A: $tType] :
      ( ( normal6328177297339901930cative @ A )
     => ! [A3: A,B2: A] :
          ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ ( normal6383669964737779283malize @ A @ B2 ) ) ) ) ).

% normalize_mult
thf(fact_5171_associated__unit,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A,B2: A] :
          ( ( ( normal6383669964737779283malize @ A @ A3 )
            = ( normal6383669964737779283malize @ A @ B2 ) )
         => ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% associated_unit
thf(fact_5172_normalize__1__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( ( normal6383669964737779283malize @ A @ A3 )
            = ( one_one @ A ) )
          = ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% normalize_1_iff
thf(fact_5173_is__unit__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( normal6383669964737779283malize @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_normalize
thf(fact_5174_normalize__idem__imp__is__unit__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( ( normal6383669964737779283malize @ A @ A3 )
            = A3 )
         => ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
            = ( A3
              = ( one_one @ A ) ) ) ) ) ).

% normalize_idem_imp_is_unit_iff
thf(fact_5175_gcd__mult__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_gcd @ A @ A3 @ B2 ) ) ) ) ) ).

% gcd_mult_left
thf(fact_5176_gcd__mult__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( gcd_gcd @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ ( gcd_gcd @ A @ B2 @ A3 ) @ C2 ) ) ) ) ).

% gcd_mult_right
thf(fact_5177_gcd__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ C2 ) @ ( gcd_gcd @ A @ A3 @ B2 ) )
          = ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% gcd_mult_distrib'
thf(fact_5178_coprime__crossproduct,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,D2: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ D2 )
         => ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
           => ( ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ ( normal6383669964737779283malize @ A @ C2 ) )
                = ( times_times @ A @ ( normal6383669964737779283malize @ A @ B2 ) @ ( normal6383669964737779283malize @ A @ D2 ) ) )
              = ( ( ( normal6383669964737779283malize @ A @ A3 )
                  = ( normal6383669964737779283malize @ A @ B2 ) )
                & ( ( normal6383669964737779283malize @ A @ C2 )
                  = ( normal6383669964737779283malize @ A @ D2 ) ) ) ) ) ) ) ).

% coprime_crossproduct
thf(fact_5179_Lcm__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A8: A,B6: A] :
                  ( ( member @ A @ A8 @ A4 )
                 => ( ( member @ A @ B6 @ A4 )
                   => ( ( A8 != B6 )
                     => ( algebr8660921524188924756oprime @ A @ A8 @ B6 ) ) ) )
             => ( ( gcd_Lcm @ A @ A4 )
                = ( normal6383669964737779283malize @ A
                  @ ( groups7121269368397514597t_prod @ A @ A
                    @ ^ [X3: A] : X3
                    @ A4 ) ) ) ) ) ) ) ).

% Lcm_coprime
thf(fact_5180_Lcm__nat__empty,axiom,
    ( ( gcd_Lcm @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( one_one @ nat ) ) ).

% Lcm_nat_empty
thf(fact_5181_Gcd__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [C2: A,A4: set @ A] :
          ( ( gcd_Gcd @ A @ ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ A4 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_Gcd @ A @ A4 ) ) ) ) ) ).

% Gcd_mult
thf(fact_5182_Lcm__int__def,axiom,
    ( ( gcd_Lcm @ int )
    = ( ^ [K6: set @ int] : ( semiring_1_of_nat @ int @ ( gcd_Lcm @ nat @ ( image2 @ int @ nat @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) @ K6 ) ) ) ) ) ).

% Lcm_int_def
thf(fact_5183_unit__factor__Lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( ( gcd_Lcm @ A @ A4 )
              = ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Lcm @ A @ A4 ) )
              = ( zero_zero @ A ) ) )
          & ( ( ( gcd_Lcm @ A @ A4 )
             != ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Lcm @ A @ A4 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_Lcm
thf(fact_5184_Gcd__fin__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A,B2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( semiring_gcd_Gcd_fin @ A @ ( image2 @ A @ A @ ( times_times @ A @ B2 ) @ A4 ) )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ B2 @ ( semiring_gcd_Gcd_fin @ A @ A4 ) ) ) ) ) ) ).

% Gcd_fin_mult
thf(fact_5185_gcd_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde8507323023520639062attice @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% gcd.bounded_quasi_semilattice_axioms
thf(fact_5186_Lcm__fin__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A,B2: A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( semiring_gcd_Lcm_fin @ A @ ( image2 @ A @ A @ ( times_times @ A @ B2 ) @ A4 ) )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ B2 @ ( semiring_gcd_Lcm_fin @ A @ A4 ) ) ) ) ) ) ).

% Lcm_fin_mult
thf(fact_5187_gcd__lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( gcd_gcd @ A @ A3 @ B2 )
              = ( normal6383669964737779283malize @ A @ ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ ( gcd_lcm @ A @ A3 @ B2 ) ) ) ) ) ) ) ).

% gcd_lcm
thf(fact_5188_lcm__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( gcd_lcm @ A @ A3 @ B2 )
            = ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% lcm_eq_1_iff
thf(fact_5189_lcm_Otop__left__normalize,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] :
          ( ( gcd_lcm @ A @ ( one_one @ A ) @ A3 )
          = ( normal6383669964737779283malize @ A @ A3 ) ) ) ).

% lcm.top_left_normalize
thf(fact_5190_lcm_Otop__right__normalize,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] :
          ( ( gcd_lcm @ A @ A3 @ ( one_one @ A ) )
          = ( normal6383669964737779283malize @ A @ A3 ) ) ) ).

% lcm.top_right_normalize
thf(fact_5191_Lcm__fin_Oempty,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Lcm_fin.empty
thf(fact_5192_is__unit__Lcm__fin__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ( dvd_dvd @ A @ ( semiring_gcd_Lcm_fin @ A @ A4 ) @ ( one_one @ A ) )
          = ( ( semiring_gcd_Lcm_fin @ A @ A4 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_Lcm_fin_iff
thf(fact_5193_unit__factor__lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( A3
                = ( zero_zero @ A ) )
              | ( B2
                = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_lcm @ A @ A3 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ( A3
                  = ( zero_zero @ A ) )
                | ( B2
                  = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_lcm @ A @ A3 @ B2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_lcm
thf(fact_5194_lcm__mult__gcd,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( gcd_lcm @ A @ A3 @ B2 ) @ ( gcd_gcd @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ ( normal6383669964737779283malize @ A @ B2 ) ) ) ) ).

% lcm_mult_gcd
thf(fact_5195_gcd__mult__lcm,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ ( gcd_lcm @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ ( normal6383669964737779283malize @ A @ B2 ) ) ) ) ).

% gcd_mult_lcm
thf(fact_5196_Lcm__2,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( gcd_Lcm @ A @ ( insert2 @ A @ A3 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( gcd_lcm @ A @ A3 @ B2 ) ) ) ).

% Lcm_2
thf(fact_5197_lcm_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde8507323023520639062attice @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% lcm.bounded_quasi_semilattice_axioms
thf(fact_5198_Lcm__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( member @ A @ A3 @ A4 )
         => ( ( semiring_gcd_Lcm_fin @ A @ A4 )
            = ( gcd_lcm @ A @ A3 @ ( semiring_gcd_Lcm_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% Lcm_fin.remove
thf(fact_5199_Lcm__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,A4: set @ A] :
          ( ( semiring_gcd_Lcm_fin @ A @ ( insert2 @ A @ A3 @ A4 ) )
          = ( gcd_lcm @ A @ A3 @ ( semiring_gcd_Lcm_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% Lcm_fin.insert_remove
thf(fact_5200_Lcm__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs: list @ A] :
          ( ( semiring_gcd_Lcm_fin @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_lcm @ A ) @ Xs @ ( one_one @ A ) ) ) ) ).

% Lcm_fin.set_eq_fold
thf(fact_5201_Lcm__fin__def,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A )
        = ( bounde2362111253966948842tice_F @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ).

% Lcm_fin_def
thf(fact_5202_lcm__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ C2 ) @ ( gcd_lcm @ A @ A3 @ B2 ) )
          = ( gcd_lcm @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% lcm_mult_distrib'
thf(fact_5203_lcm__mult__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( gcd_lcm @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ ( gcd_lcm @ A @ B2 @ A3 ) @ C2 ) ) ) ) ).

% lcm_mult_right
thf(fact_5204_lcm__mult__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( gcd_lcm @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_lcm @ A @ A3 @ B2 ) ) ) ) ) ).

% lcm_mult_left
thf(fact_5205_Lcm__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A )
        = ( ^ [A10: set @ A] : ( if @ A @ ( finite_finite @ A @ A10 ) @ ( finite_fold @ A @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ A10 ) @ ( zero_zero @ A ) ) ) ) ) ).

% Lcm_fin.eq_fold
thf(fact_5206_lcm__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [K: A,A3: A,B2: A] :
          ( ( times_times @ A @ K @ ( gcd_lcm @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( gcd_lcm @ A @ ( times_times @ A @ K @ A3 ) @ ( times_times @ A @ K @ B2 ) ) @ ( unit_f5069060285200089521factor @ A @ K ) ) ) ) ).

% lcm_mult_distrib
thf(fact_5207_mult__lcm__right,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( gcd_lcm @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ ( gcd_lcm @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) @ ( unit_f5069060285200089521factor @ A @ C2 ) ) ) ) ).

% mult_lcm_right
thf(fact_5208_mult__lcm__left,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( gcd_lcm @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ C2 ) @ ( gcd_lcm @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_lcm_left
thf(fact_5209_Lcm__in__lcm__closed__set__nat,axiom,
    ! [M: set @ nat] :
      ( ( finite_finite @ nat @ M )
     => ( ( M
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ! [M5: nat,N3: nat] :
              ( ( member @ nat @ M5 @ M )
             => ( ( member @ nat @ N3 @ M )
               => ( member @ nat @ ( gcd_lcm @ nat @ M5 @ N3 ) @ M ) ) )
         => ( member @ nat @ ( gcd_Lcm @ nat @ M ) @ M ) ) ) ) ).

% Lcm_in_lcm_closed_set_nat
thf(fact_5210_lcm__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ B2 @ ( times_times @ A @ C2 @ A3 ) )
            = ( gcd_lcm @ A @ B2 @ C2 ) ) ) ) ).

% lcm_mult_unit2
thf(fact_5211_lcm__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 )
            = ( gcd_lcm @ A @ B2 @ C2 ) ) ) ) ).

% lcm_mult_unit1
thf(fact_5212_lcm__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ B2 @ ( divide_divide @ A @ C2 @ A3 ) )
            = ( gcd_lcm @ A @ B2 @ C2 ) ) ) ) ).

% lcm_div_unit2
thf(fact_5213_lcm__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ ( divide_divide @ A @ B2 @ A3 ) @ C2 )
            = ( gcd_lcm @ A @ B2 @ C2 ) ) ) ) ).

% lcm_div_unit1
thf(fact_5214_lcm__gcd__prod,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( gcd_lcm @ A @ A3 @ B2 ) @ ( gcd_gcd @ A @ A3 @ B2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% lcm_gcd_prod
thf(fact_5215_lcm__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
         => ( ( gcd_lcm @ A @ A3 @ B2 )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% lcm_coprime
thf(fact_5216_Lcm__fin__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( semiring_gcd_Lcm_fin @ A @ A4 )
            = ( one_one @ A ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( dvd_dvd @ A @ X3 @ ( one_one @ A ) ) )
            & ( finite_finite @ A @ A4 ) ) ) ) ).

% Lcm_fin_1_iff
thf(fact_5217_lcm__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( gcd_lcm @ A )
        = ( ^ [A5: A,B4: A] : ( normal6383669964737779283malize @ A @ ( divide_divide @ A @ ( times_times @ A @ A5 @ B4 ) @ ( gcd_gcd @ A @ A5 @ B4 ) ) ) ) ) ) ).

% lcm_gcd
thf(fact_5218_Lcm__set__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [Xs: list @ A] :
          ( ( gcd_Lcm @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_lcm @ A ) @ Xs @ ( one_one @ A ) ) ) ) ).

% Lcm_set_eq_fold
thf(fact_5219_Lcm__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde6485984586167503788ce_set @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% Lcm_fin.bounded_quasi_semilattice_set_axioms
thf(fact_5220_Lcm__eq__Max__nat,axiom,
    ! [M: set @ nat] :
      ( ( finite_finite @ nat @ M )
     => ( ( M
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M )
         => ( ! [M5: nat,N3: nat] :
                ( ( member @ nat @ M5 @ M )
               => ( ( member @ nat @ N3 @ M )
                 => ( member @ nat @ ( gcd_lcm @ nat @ M5 @ N3 ) @ M ) ) )
           => ( ( gcd_Lcm @ nat @ M )
              = ( lattic643756798349783984er_Max @ nat @ M ) ) ) ) ) ) ).

% Lcm_eq_Max_nat
thf(fact_5221_prod_Ocomm__monoid__list__set__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( groups4802862169904069756st_set @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod.comm_monoid_list_set_axioms
thf(fact_5222_prod_H__def,axiom,
    ! [C: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ C @ A )
        = ( groups_comm_monoid_G @ A @ C @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod'_def
thf(fact_5223_Gr__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bNF_Gr @ A @ B )
      = ( ^ [A10: set @ A,F2: A > B] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu: product_prod @ A @ B] :
              ? [A5: A] :
                ( ( Uu
                  = ( product_Pair @ A @ B @ A5 @ ( F2 @ A5 ) ) )
                & ( member @ A @ A5 @ A10 ) ) ) ) ) ).

% Gr_def
thf(fact_5224_GrD1,axiom,
    ! [B: $tType,A: $tType,X: A,Fx: B,A4: set @ A,F: A > B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Fx ) @ ( bNF_Gr @ A @ B @ A4 @ F ) )
     => ( member @ A @ X @ A4 ) ) ).

% GrD1
thf(fact_5225_GrD2,axiom,
    ! [A: $tType,B: $tType,X: A,Fx: B,A4: set @ A,F: A > B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Fx ) @ ( bNF_Gr @ A @ B @ A4 @ F ) )
     => ( ( F @ X )
        = Fx ) ) ).

% GrD2
thf(fact_5226_and_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( comm_monoid @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.comm_monoid_axioms
thf(fact_5227_Heap_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F: B > nat,G: A > B] :
      ( ( comp @ ( heap_Time_Heap @ B ) @ nat @ ( heap_Time_Heap @ A ) @ ( heap_Time_size_Heap @ B @ F ) @ ( heap_Time_map_Heap @ A @ B @ G ) )
      = ( heap_Time_size_Heap @ A @ ( comp @ B @ nat @ A @ F @ G ) ) ) ).

% Heap.size_gen_o_map
thf(fact_5228_max_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice_order @ A @ ( ord_max @ A )
        @ ^ [X3: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X3 )
        @ ^ [X3: A,Y2: A] : ( ord_less @ A @ Y2 @ X3 ) ) ) ).

% max.semilattice_order_axioms
thf(fact_5229_Heap_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F: A > B,V: heap_Time_Heap @ A] :
      ( ( heap_Time_map_Heap @ B @ C @ G @ ( heap_Time_map_Heap @ A @ B @ F @ V ) )
      = ( heap_Time_map_Heap @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) ).

% Heap.map_comp
thf(fact_5230_Heap_Omap,axiom,
    ! [B: $tType,A: $tType,F: A > B,X: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( heap_Time_map_Heap @ A @ B @ F @ ( heap_Time_Heap2 @ A @ X ) )
      = ( heap_Time_Heap2 @ B @ ( comp @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( map_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_map_prod @ A @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ F @ ( id @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ X ) ) ) ).

% Heap.map
thf(fact_5231_Heap_Omap__ident,axiom,
    ! [A: $tType,T4: heap_Time_Heap @ A] :
      ( ( heap_Time_map_Heap @ A @ A
        @ ^ [X3: A] : X3
        @ T4 )
      = T4 ) ).

% Heap.map_ident
thf(fact_5232_semilattice__order_Ostrict__coboundedI2,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,C2: A,A3: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less @ B2 @ C2 )
       => ( Less @ ( F @ A3 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.strict_coboundedI2
thf(fact_5233_semilattice__order_Ostrict__coboundedI1,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,C2: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less @ A3 @ C2 )
       => ( Less @ ( F @ A3 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.strict_coboundedI1
thf(fact_5234_semilattice__order_Ostrict__order__iff,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
        = ( ( A3
            = ( F @ A3 @ B2 ) )
          & ( A3 != B2 ) ) ) ) ).

% semilattice_order.strict_order_iff
thf(fact_5235_semilattice__order_Ostrict__boundedE,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less @ A3 @ ( F @ B2 @ C2 ) )
       => ~ ( ( Less @ A3 @ B2 )
           => ~ ( Less @ A3 @ C2 ) ) ) ) ).

% semilattice_order.strict_boundedE
thf(fact_5236_semilattice__order_OcoboundedI2,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,C2: A,A3: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ B2 @ C2 )
       => ( Less_eq @ ( F @ A3 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.coboundedI2
thf(fact_5237_semilattice__order_OcoboundedI1,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,C2: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ C2 )
       => ( Less_eq @ ( F @ A3 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.coboundedI1
thf(fact_5238_semilattice__order_Obounded__iff,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ ( F @ B2 @ C2 ) )
        = ( ( Less_eq @ A3 @ B2 )
          & ( Less_eq @ A3 @ C2 ) ) ) ) ).

% semilattice_order.bounded_iff
thf(fact_5239_semilattice__order_Oabsorb__iff2,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,A3: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ B2 @ A3 )
        = ( ( F @ A3 @ B2 )
          = B2 ) ) ) ).

% semilattice_order.absorb_iff2
thf(fact_5240_semilattice__order_Oabsorb__iff1,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
        = ( ( F @ A3 @ B2 )
          = A3 ) ) ) ).

% semilattice_order.absorb_iff1
thf(fact_5241_semilattice__order_Ocobounded2,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( Less_eq @ ( F @ A3 @ B2 ) @ B2 ) ) ).

% semilattice_order.cobounded2
thf(fact_5242_semilattice__order_Ocobounded1,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( Less_eq @ ( F @ A3 @ B2 ) @ A3 ) ) ).

% semilattice_order.cobounded1
thf(fact_5243_semilattice__order_Oorder__iff,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
        = ( A3
          = ( F @ A3 @ B2 ) ) ) ) ).

% semilattice_order.order_iff
thf(fact_5244_semilattice__order_OboundedI,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
       => ( ( Less_eq @ A3 @ C2 )
         => ( Less_eq @ A3 @ ( F @ B2 @ C2 ) ) ) ) ) ).

% semilattice_order.boundedI
thf(fact_5245_semilattice__order_OboundedE,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ ( F @ B2 @ C2 ) )
       => ~ ( ( Less_eq @ A3 @ B2 )
           => ~ ( Less_eq @ A3 @ C2 ) ) ) ) ).

% semilattice_order.boundedE
thf(fact_5246_semilattice__order_Oabsorb4,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,A3: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less @ B2 @ A3 )
       => ( ( F @ A3 @ B2 )
          = B2 ) ) ) ).

% semilattice_order.absorb4
thf(fact_5247_semilattice__order_Oabsorb3,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
       => ( ( F @ A3 @ B2 )
          = A3 ) ) ) ).

% semilattice_order.absorb3
thf(fact_5248_semilattice__order_Oabsorb2,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,A3: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ B2 @ A3 )
       => ( ( F @ A3 @ B2 )
          = B2 ) ) ) ).

% semilattice_order.absorb2
thf(fact_5249_semilattice__order_Oabsorb1,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
       => ( ( F @ A3 @ B2 )
          = A3 ) ) ) ).

% semilattice_order.absorb1
thf(fact_5250_semilattice__order_OorderI,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( A3
          = ( F @ A3 @ B2 ) )
       => ( Less_eq @ A3 @ B2 ) ) ) ).

% semilattice_order.orderI
thf(fact_5251_semilattice__order_OorderE,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
       => ( A3
          = ( F @ A3 @ B2 ) ) ) ) ).

% semilattice_order.orderE
thf(fact_5252_semilattice__order_Omono,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,C2: A,B2: A,D2: A] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ C2 )
       => ( ( Less_eq @ B2 @ D2 )
         => ( Less_eq @ ( F @ A3 @ B2 ) @ ( F @ C2 @ D2 ) ) ) ) ) ).

% semilattice_order.mono
thf(fact_5253_comm__monoid_Ocomm__neutral,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,A3: A] :
      ( ( comm_monoid @ A @ F @ Z2 )
     => ( ( F @ A3 @ Z2 )
        = A3 ) ) ).

% comm_monoid.comm_neutral
thf(fact_5254_semilattice__neutr__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semila1105856199041335345_order @ A @ F @ Z2 @ Less_eq @ Less )
     => ( semilattice_order @ A @ F @ Less_eq @ Less ) ) ).

% semilattice_neutr_order.axioms(2)
thf(fact_5255_Heap_Omap__id,axiom,
    ! [A: $tType,T4: heap_Time_Heap @ A] :
      ( ( heap_Time_map_Heap @ A @ A @ ( id @ A ) @ T4 )
      = T4 ) ).

% Heap.map_id
thf(fact_5256_Heap_Omap__id0,axiom,
    ! [A: $tType] :
      ( ( heap_Time_map_Heap @ A @ A @ ( id @ A ) )
      = ( id @ ( heap_Time_Heap @ A ) ) ) ).

% Heap.map_id0
thf(fact_5257_semilattice__neutr_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( semilattice_neutr @ A @ F @ Z2 )
     => ( comm_monoid @ A @ F @ Z2 ) ) ).

% semilattice_neutr.axioms(2)
thf(fact_5258_add_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ( comm_monoid @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% add.comm_monoid_axioms
thf(fact_5259_mult_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( comm_monoid @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% mult.comm_monoid_axioms
thf(fact_5260_Heap_Oinj__map,axiom,
    ! [B: $tType,A: $tType,F: A > B] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ ( heap_Time_map_Heap @ A @ B @ F ) @ ( top_top @ ( set @ ( heap_Time_Heap @ A ) ) ) ) ) ).

% Heap.inj_map
thf(fact_5261_sup__bot_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( comm_monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.comm_monoid_axioms
thf(fact_5262_inf__top_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( comm_monoid @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.comm_monoid_axioms
thf(fact_5263_semilattice__neutr__order__def,axiom,
    ! [A: $tType] :
      ( ( semila1105856199041335345_order @ A )
      = ( ^ [F2: A > A > A,Z4: A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( semilattice_neutr @ A @ F2 @ Z4 )
            & ( semilattice_order @ A @ F2 @ Less_eq2 @ Less2 ) ) ) ) ).

% semilattice_neutr_order_def
thf(fact_5264_semilattice__neutr__order_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_neutr @ A @ F @ Z2 )
     => ( ( semilattice_order @ A @ F @ Less_eq @ Less )
       => ( semila1105856199041335345_order @ A @ F @ Z2 @ Less_eq @ Less ) ) ) ).

% semilattice_neutr_order.intro
thf(fact_5265_inf_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semilattice_order @ A @ ( inf_inf @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf.semilattice_order_axioms
thf(fact_5266_min_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice_order @ A @ ( ord_min @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% min.semilattice_order_axioms
thf(fact_5267_sup_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semilattice_order @ A @ ( sup_sup @ A )
        @ ^ [X3: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X3 )
        @ ^ [X3: A,Y2: A] : ( ord_less @ A @ Y2 @ X3 ) ) ) ).

% sup.semilattice_order_axioms
thf(fact_5268_Heap_Orec__o__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > C,F: A > B] :
      ( ( comp @ ( heap_Time_Heap @ B ) @ C @ ( heap_Time_Heap @ A ) @ ( heap_Time_rec_Heap @ B @ C @ G ) @ ( heap_Time_map_Heap @ A @ B @ F ) )
      = ( heap_Time_rec_Heap @ A @ C
        @ ^ [X3: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] : ( G @ ( comp @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( map_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_map_prod @ A @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ F @ ( id @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ X3 ) ) ) ) ).

% Heap.rec_o_map
thf(fact_5269_prod__mset__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( comm_m9189036328036947845d_mset @ A )
        = ( comm_monoid_F @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod_mset_def
thf(fact_5270_Heap_Oset,axiom,
    ! [A: $tType,X: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( heap_Time_set_Heap @ A @ ( heap_Time_Heap2 @ A @ X ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( set @ A )
          @ ^ [Uu2: option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] : ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( set @ A ) @ ( basic_fsts @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( set_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ Uu2 ) ) )
          @ ( image2 @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ X @ ( top_top @ ( set @ ( heap_ext @ product_unit ) ) ) ) ) ) ) ).

% Heap.set
thf(fact_5271_Heap_Oset__intros,axiom,
    ! [A: $tType,Y: option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ),X: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ),Ya: product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ),Yb2: A] :
      ( ( member @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ Y @ ( image2 @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ X @ ( top_top @ ( set @ ( heap_ext @ product_unit ) ) ) ) )
     => ( ( member @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ Ya @ ( set_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ Y ) )
       => ( ( member @ A @ Yb2 @ ( basic_fsts @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ Ya ) )
         => ( member @ A @ Yb2 @ ( heap_Time_set_Heap @ A @ ( heap_Time_Heap2 @ A @ X ) ) ) ) ) ) ).

% Heap.set_intros
thf(fact_5272_Heap_Oset__cases,axiom,
    ! [A: $tType,E2: A,A3: heap_Time_Heap @ A] :
      ( ( member @ A @ E2 @ ( heap_Time_set_Heap @ A @ A3 ) )
     => ~ ! [Z3: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
            ( ( A3
              = ( heap_Time_Heap2 @ A @ Z3 ) )
           => ! [Xa3: option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )] :
                ( ( member @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ Xa3 @ ( image2 @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ Z3 @ ( top_top @ ( set @ ( heap_ext @ product_unit ) ) ) ) )
               => ! [Xb3: product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat )] :
                    ( ( member @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ Xb3 @ ( set_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ Xa3 ) )
                   => ~ ( member @ A @ E2 @ ( basic_fsts @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ Xb3 ) ) ) ) ) ) ).

% Heap.set_cases
thf(fact_5273_Heap_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X: heap_Time_Heap @ A,Ya: heap_Time_Heap @ A,F: A > B,G: A > B] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( heap_Time_set_Heap @ A @ Ya ) )
           => ( ( F @ Z3 )
              = ( G @ Z3 ) ) )
       => ( ( heap_Time_map_Heap @ A @ B @ F @ X )
          = ( heap_Time_map_Heap @ A @ B @ G @ Ya ) ) ) ) ).

% Heap.map_cong
thf(fact_5274_Heap_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X: heap_Time_Heap @ A,F: A > B,G: A > B] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( heap_Time_set_Heap @ A @ X ) )
         => ( ( F @ Z3 )
            = ( G @ Z3 ) ) )
     => ( ( heap_Time_map_Heap @ A @ B @ F @ X )
        = ( heap_Time_map_Heap @ A @ B @ G @ X ) ) ) ).

% Heap.map_cong0
thf(fact_5275_Heap_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X: heap_Time_Heap @ A,Xa: heap_Time_Heap @ A,F: A > B,Fa: A > B] :
      ( ! [Z3: A,Za: A] :
          ( ( member @ A @ Z3 @ ( heap_Time_set_Heap @ A @ X ) )
         => ( ( member @ A @ Za @ ( heap_Time_set_Heap @ A @ Xa ) )
           => ( ( ( F @ Z3 )
                = ( Fa @ Za ) )
             => ( Z3 = Za ) ) ) )
     => ( ( ( heap_Time_map_Heap @ A @ B @ F @ X )
          = ( heap_Time_map_Heap @ A @ B @ Fa @ Xa ) )
       => ( X = Xa ) ) ) ).

% Heap.inj_map_strong
thf(fact_5276_Heap_Orec,axiom,
    ! [C: $tType,A: $tType,F: ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > C,X: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( heap_Time_rec_Heap @ A @ C @ F @ ( heap_Time_Heap2 @ A @ X ) )
      = ( F @ X ) ) ).

% Heap.rec
thf(fact_5277_Heap_Oset__map,axiom,
    ! [B: $tType,A: $tType,F: A > B,V: heap_Time_Heap @ A] :
      ( ( heap_Time_set_Heap @ B @ ( heap_Time_map_Heap @ A @ B @ F @ V ) )
      = ( image2 @ A @ B @ F @ ( heap_Time_set_Heap @ A @ V ) ) ) ).

% Heap.set_map
thf(fact_5278_Heap_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,F: A > B] :
      ( ( heap_Time_rel_Heap @ A @ B @ ( bNF_Grp @ A @ B @ A4 @ F ) )
      = ( bNF_Grp @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B )
        @ ( collect @ ( heap_Time_Heap @ A )
          @ ^ [X3: heap_Time_Heap @ A] : ( ord_less_eq @ ( set @ A ) @ ( heap_Time_set_Heap @ A @ X3 ) @ A4 ) )
        @ ( heap_Time_map_Heap @ A @ B @ F ) ) ) ).

% Heap.rel_Grp
thf(fact_5279_Heap_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( heap_Time_rel_Heap @ A @ B )
      = ( ^ [R2: A > B > $o] :
            ( relcompp @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ ( product_prod @ A @ B ) ) @ ( heap_Time_Heap @ B )
            @ ( conversep @ ( heap_Time_Heap @ ( product_prod @ A @ B ) ) @ ( heap_Time_Heap @ A )
              @ ( bNF_Grp @ ( heap_Time_Heap @ ( product_prod @ A @ B ) ) @ ( heap_Time_Heap @ A )
                @ ( collect @ ( heap_Time_Heap @ ( product_prod @ A @ B ) )
                  @ ^ [X3: heap_Time_Heap @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( heap_Time_set_Heap @ ( product_prod @ A @ B ) @ X3 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
                @ ( heap_Time_map_Heap @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) ) ) )
            @ ( bNF_Grp @ ( heap_Time_Heap @ ( product_prod @ A @ B ) ) @ ( heap_Time_Heap @ B )
              @ ( collect @ ( heap_Time_Heap @ ( product_prod @ A @ B ) )
                @ ^ [X3: heap_Time_Heap @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( heap_Time_set_Heap @ ( product_prod @ A @ B ) @ X3 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
              @ ( heap_Time_map_Heap @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) ) ) ) ) ) ).

% Heap.rel_compp_Grp
thf(fact_5280_Heap_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( heap_Time_rel_Heap @ A @ B )
      = ( ^ [R2: A > B > $o,A5: heap_Time_Heap @ A,B4: heap_Time_Heap @ B] :
          ? [Z4: heap_Time_Heap @ ( product_prod @ A @ B )] :
            ( ( member @ ( heap_Time_Heap @ ( product_prod @ A @ B ) ) @ Z4
              @ ( collect @ ( heap_Time_Heap @ ( product_prod @ A @ B ) )
                @ ^ [X3: heap_Time_Heap @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( heap_Time_set_Heap @ ( product_prod @ A @ B ) @ X3 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( heap_Time_map_Heap @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z4 )
              = A5 )
            & ( ( heap_Time_map_Heap @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z4 )
              = B4 ) ) ) ) ).

% Heap.in_rel
thf(fact_5281_Heap_Orel__cong,axiom,
    ! [A: $tType,B: $tType,X: heap_Time_Heap @ A,Ya: heap_Time_Heap @ A,Y: heap_Time_Heap @ B,Xa: heap_Time_Heap @ B,R: A > B > $o,Ra2: A > B > $o] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z3: A,Yb: B] :
              ( ( member @ A @ Z3 @ ( heap_Time_set_Heap @ A @ Ya ) )
             => ( ( member @ B @ Yb @ ( heap_Time_set_Heap @ B @ Xa ) )
               => ( ( R @ Z3 @ Yb )
                  = ( Ra2 @ Z3 @ Yb ) ) ) )
         => ( ( heap_Time_rel_Heap @ A @ B @ R @ X @ Y )
            = ( heap_Time_rel_Heap @ A @ B @ Ra2 @ Ya @ Xa ) ) ) ) ) ).

% Heap.rel_cong
thf(fact_5282_Heap_Orel__mono__strong,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X: heap_Time_Heap @ A,Y: heap_Time_Heap @ B,Ra2: A > B > $o] :
      ( ( heap_Time_rel_Heap @ A @ B @ R @ X @ Y )
     => ( ! [Z3: A,Yb: B] :
            ( ( member @ A @ Z3 @ ( heap_Time_set_Heap @ A @ X ) )
           => ( ( member @ B @ Yb @ ( heap_Time_set_Heap @ B @ Y ) )
             => ( ( R @ Z3 @ Yb )
               => ( Ra2 @ Z3 @ Yb ) ) ) )
       => ( heap_Time_rel_Heap @ A @ B @ Ra2 @ X @ Y ) ) ) ).

% Heap.rel_mono_strong
thf(fact_5283_Heap_Orel__refl__strong,axiom,
    ! [A: $tType,X: heap_Time_Heap @ A,Ra2: A > A > $o] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( heap_Time_set_Heap @ A @ X ) )
         => ( Ra2 @ Z3 @ Z3 ) )
     => ( heap_Time_rel_Heap @ A @ A @ Ra2 @ X @ X ) ) ).

% Heap.rel_refl_strong
thf(fact_5284_Heap_Orel__mono,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o,Ra2: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R @ Ra2 )
     => ( ord_less_eq @ ( ( heap_Time_Heap @ A ) > ( heap_Time_Heap @ B ) > $o ) @ ( heap_Time_rel_Heap @ A @ B @ R ) @ ( heap_Time_rel_Heap @ A @ B @ Ra2 ) ) ) ).

% Heap.rel_mono
thf(fact_5285_Heap_Orel__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Sa: A > C > $o,Sc: B > D > $o] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > D > $o ) @ ( ( heap_Time_Heap @ A ) > ( heap_Time_Heap @ B ) > $o ) @ ( ( heap_Time_Heap @ C ) > ( heap_Time_Heap @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( D > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ Sc
          @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) ) )
      @ ( bNF_rel_fun @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ C ) @ ( ( heap_Time_Heap @ B ) > $o ) @ ( ( heap_Time_Heap @ D ) > $o ) @ ( heap_Time_rel_Heap @ A @ C @ Sa )
        @ ( bNF_rel_fun @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ D ) @ $o @ $o @ ( heap_Time_rel_Heap @ B @ D @ Sc )
          @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) ) )
      @ ( heap_Time_rel_Heap @ A @ B )
      @ ( heap_Time_rel_Heap @ C @ D ) ) ).

% Heap.rel_transfer
thf(fact_5286_Heap_Orel__compp,axiom,
    ! [A: $tType,C: $tType,B: $tType,R: A > B > $o,S2: B > C > $o] :
      ( ( heap_Time_rel_Heap @ A @ C @ ( relcompp @ A @ B @ C @ R @ S2 ) )
      = ( relcompp @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ C ) @ ( heap_Time_rel_Heap @ A @ B @ R ) @ ( heap_Time_rel_Heap @ B @ C @ S2 ) ) ) ).

% Heap.rel_compp
thf(fact_5287_Heap_Orel__refl,axiom,
    ! [B: $tType,Ra2: B > B > $o,X: heap_Time_Heap @ B] :
      ( ! [X2: B] : ( Ra2 @ X2 @ X2 )
     => ( heap_Time_rel_Heap @ B @ B @ Ra2 @ X @ X ) ) ).

% Heap.rel_refl
thf(fact_5288_Heap_Orel__eq,axiom,
    ! [A: $tType] :
      ( ( heap_Time_rel_Heap @ A @ A
        @ ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
      = ( ^ [Y4: heap_Time_Heap @ A,Z5: heap_Time_Heap @ A] : ( Y4 = Z5 ) ) ) ).

% Heap.rel_eq
thf(fact_5289_Heap_Orel__conversep,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( heap_Time_rel_Heap @ B @ A @ ( conversep @ A @ B @ R ) )
      = ( conversep @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ ( heap_Time_rel_Heap @ A @ B @ R ) ) ) ).

% Heap.rel_conversep
thf(fact_5290_Heap_Orel__flip,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,A3: heap_Time_Heap @ B,B2: heap_Time_Heap @ A] :
      ( ( heap_Time_rel_Heap @ B @ A @ ( conversep @ A @ B @ R ) @ A3 @ B2 )
      = ( heap_Time_rel_Heap @ A @ B @ R @ B2 @ A3 ) ) ).

% Heap.rel_flip
thf(fact_5291_Heap_Oleft__unique__rel,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( left_unique @ A @ B @ R )
     => ( left_unique @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ ( heap_Time_rel_Heap @ A @ B @ R ) ) ) ).

% Heap.left_unique_rel
thf(fact_5292_Heap_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: A > C > $o,X: heap_Time_Heap @ A,G: B > C,Y: heap_Time_Heap @ B] :
      ( ( heap_Time_rel_Heap @ A @ C @ Sa @ X @ ( heap_Time_map_Heap @ B @ C @ G @ Y ) )
      = ( heap_Time_rel_Heap @ A @ B
        @ ^ [X3: A,Y2: B] : ( Sa @ X3 @ ( G @ Y2 ) )
        @ X
        @ Y ) ) ).

% Heap.rel_map(2)
thf(fact_5293_Heap_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: C > B > $o,I: A > C,X: heap_Time_Heap @ A,Y: heap_Time_Heap @ B] :
      ( ( heap_Time_rel_Heap @ C @ B @ Sb @ ( heap_Time_map_Heap @ A @ C @ I @ X ) @ Y )
      = ( heap_Time_rel_Heap @ A @ B
        @ ^ [X3: A] : ( Sb @ ( I @ X3 ) )
        @ X
        @ Y ) ) ).

% Heap.rel_map(1)
thf(fact_5294_Heap_Omap__transfer,axiom,
    ! [A: $tType,B: $tType,F9: $tType,E: $tType,Rb2: A > E > $o,Sd: B > F9 > $o] : ( bNF_rel_fun @ ( A > B ) @ ( E > F9 ) @ ( ( heap_Time_Heap @ A ) > ( heap_Time_Heap @ B ) ) @ ( ( heap_Time_Heap @ E ) > ( heap_Time_Heap @ F9 ) ) @ ( bNF_rel_fun @ A @ E @ B @ F9 @ Rb2 @ Sd ) @ ( bNF_rel_fun @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ E ) @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ F9 ) @ ( heap_Time_rel_Heap @ A @ E @ Rb2 ) @ ( heap_Time_rel_Heap @ B @ F9 @ Sd ) ) @ ( heap_Time_map_Heap @ A @ B ) @ ( heap_Time_map_Heap @ E @ F9 ) ) ).

% Heap.map_transfer
thf(fact_5295_Heap_Oset__transfer,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] : ( bNF_rel_fun @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ ( set @ A ) @ ( set @ B ) @ ( heap_Time_rel_Heap @ A @ B @ R ) @ ( bNF_rel_set @ A @ B @ R ) @ ( heap_Time_set_Heap @ A ) @ ( heap_Time_set_Heap @ B ) ) ).

% Heap.set_transfer
thf(fact_5296_sorted__wrt_Opelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: $o] :
      ( ( ( sorted_wrt @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
         => ~ ! [X2: A,Ys2: list @ A] :
                ( ( Xa
                  = ( cons @ A @ X2 @ Ys2 ) )
               => ( ( Y
                    = ( ! [Y2: A] :
                          ( ( member @ A @ Y2 @ ( set2 @ A @ Ys2 ) )
                         => ( X @ X2 @ Y2 ) )
                      & ( sorted_wrt @ A @ X @ Ys2 ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ Ys2 ) ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(1)
thf(fact_5297_sorted__wrt_Opelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ( sorted_wrt @ A @ X @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) )
         => ~ ! [X2: A,Ys2: list @ A] :
                ( ( Xa
                  = ( cons @ A @ X2 @ Ys2 ) )
               => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ Ys2 ) ) )
                 => ~ ( ! [Xa2: A] :
                          ( ( member @ A @ Xa2 @ ( set2 @ A @ Ys2 ) )
                         => ( X @ X2 @ Xa2 ) )
                      & ( sorted_wrt @ A @ X @ Ys2 ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(2)
thf(fact_5298_size__multiset__o__map,axiom,
    ! [B: $tType,A: $tType,G: B > nat,F: A > B] :
      ( ( comp @ ( multiset @ B ) @ nat @ ( multiset @ A ) @ ( size_multiset @ B @ G ) @ ( image_mset @ A @ B @ F ) )
      = ( size_multiset @ A @ ( comp @ B @ nat @ A @ G @ F ) ) ) ).

% size_multiset_o_map
thf(fact_5299_sorted__wrt_Opelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ~ ( sorted_wrt @ A @ X @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ~ ! [X2: A,Ys2: list @ A] :
              ( ( Xa
                = ( cons @ A @ X2 @ Ys2 ) )
             => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ Ys2 ) ) )
               => ( ! [Xa3: A] :
                      ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys2 ) )
                     => ( X @ X2 @ Xa3 ) )
                  & ( sorted_wrt @ A @ X @ Ys2 ) ) ) ) ) ) ).

% sorted_wrt.pelims(3)
thf(fact_5300_Heap_Opred__transfer,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( heap_Time_Heap @ A ) > $o ) @ ( ( heap_Time_Heap @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( bNF_rel_fun @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ $o @ $o @ ( heap_Time_rel_Heap @ A @ B @ R )
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( heap_Time_pred_Heap @ A )
      @ ( heap_Time_pred_Heap @ B ) ) ).

% Heap.pred_transfer
thf(fact_5301_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_5302_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B,A4: set @ A,X: A,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ S2 )
       => ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( finite_folding_F @ A @ B @ F @ Z2 @ A4 )
              = ( F @ X @ ( finite_folding_F @ A @ B @ F @ Z2 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% folding_on.remove
thf(fact_5303_Heap_Opred__mono,axiom,
    ! [A: $tType,P: A > $o,Pa: A > $o] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Pa )
     => ( ord_less_eq @ ( ( heap_Time_Heap @ A ) > $o ) @ ( heap_Time_pred_Heap @ A @ P ) @ ( heap_Time_pred_Heap @ A @ Pa ) ) ) ).

% Heap.pred_mono
thf(fact_5304_folding__on_Ointro,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B] :
      ( ! [X2: A,Y3: A] :
          ( ( member @ A @ X2 @ S2 )
         => ( ( member @ A @ Y3 @ S2 )
           => ( ( comp @ B @ B @ B @ ( F @ Y3 ) @ ( F @ X2 ) )
              = ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) ) ) )
     => ( finite_folding_on @ A @ B @ S2 @ F ) ) ).

% folding_on.intro
thf(fact_5305_folding__on_Ocomp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B,X: A,Y: A] :
      ( ( finite_folding_on @ A @ B @ S2 @ F )
     => ( ( member @ A @ X @ S2 )
       => ( ( member @ A @ Y @ S2 )
         => ( ( comp @ B @ B @ B @ ( F @ Y ) @ ( F @ X ) )
            = ( comp @ B @ B @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) ) ).

% folding_on.comp_fun_commute_on
thf(fact_5306_folding__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_folding_on @ A @ B )
      = ( ^ [S7: set @ A,F2: A > B > B] :
          ! [X3: A,Y2: A] :
            ( ( member @ A @ X3 @ S7 )
           => ( ( member @ A @ Y2 @ S7 )
             => ( ( comp @ B @ B @ B @ ( F2 @ Y2 ) @ ( F2 @ X3 ) )
                = ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) ) ) ) ).

% folding_on_def
thf(fact_5307_folding__on_Oempty,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F: A > B > B,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F )
     => ( ( finite_folding_F @ A @ B @ F @ Z2 @ ( bot_bot @ ( set @ A ) ) )
        = Z2 ) ) ).

% folding_on.empty
thf(fact_5308_Heap_Opred__True,axiom,
    ! [A: $tType] :
      ( ( heap_Time_pred_Heap @ A
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: heap_Time_Heap @ A] : $true ) ) ).

% Heap.pred_True
thf(fact_5309_Heap_Opred__mono__strong,axiom,
    ! [A: $tType,P: A > $o,X: heap_Time_Heap @ A,Pa: A > $o] :
      ( ( heap_Time_pred_Heap @ A @ P @ X )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( heap_Time_set_Heap @ A @ X ) )
           => ( ( P @ Z3 )
             => ( Pa @ Z3 ) ) )
       => ( heap_Time_pred_Heap @ A @ Pa @ X ) ) ) ).

% Heap.pred_mono_strong
thf(fact_5310_Heap_Opred__cong,axiom,
    ! [A: $tType,X: heap_Time_Heap @ A,Ya: heap_Time_Heap @ A,P: A > $o,Pa: A > $o] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( heap_Time_set_Heap @ A @ Ya ) )
           => ( ( P @ Z3 )
              = ( Pa @ Z3 ) ) )
       => ( ( heap_Time_pred_Heap @ A @ P @ X )
          = ( heap_Time_pred_Heap @ A @ Pa @ Ya ) ) ) ) ).

% Heap.pred_cong
thf(fact_5311_Heap_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X: heap_Time_Heap @ A,Ya: heap_Time_Heap @ A,F: A > B,G: A > B] :
      ( ( X = Ya )
     => ( ( heap_Time_pred_Heap @ A
          @ ^ [Z4: A] :
              ( ( F @ Z4 )
              = ( G @ Z4 ) )
          @ Ya )
       => ( ( heap_Time_map_Heap @ A @ B @ F @ X )
          = ( heap_Time_map_Heap @ A @ B @ G @ Ya ) ) ) ) ).

% Heap.map_cong_pred
thf(fact_5312_Heap_Orel__eq__onp,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( heap_Time_rel_Heap @ A @ A @ ( bNF_eq_onp @ A @ P ) )
      = ( bNF_eq_onp @ ( heap_Time_Heap @ A ) @ ( heap_Time_pred_Heap @ A @ P ) ) ) ).

% Heap.rel_eq_onp
thf(fact_5313_Heap_Opred__rel,axiom,
    ! [A: $tType] :
      ( ( heap_Time_pred_Heap @ A )
      = ( ^ [P3: A > $o,X3: heap_Time_Heap @ A] : ( heap_Time_rel_Heap @ A @ A @ ( bNF_eq_onp @ A @ P3 ) @ X3 @ X3 ) ) ) ).

% Heap.pred_rel
thf(fact_5314_Heap_Opred__set,axiom,
    ! [A: $tType] :
      ( ( heap_Time_pred_Heap @ A )
      = ( ^ [P3: A > $o,X3: heap_Time_Heap @ A] :
          ! [Y2: A] :
            ( ( member @ A @ Y2 @ ( heap_Time_set_Heap @ A @ X3 ) )
           => ( P3 @ Y2 ) ) ) ) ).

% Heap.pred_set
thf(fact_5315_Heap_ODomainp__rel,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( domainp @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ ( heap_Time_rel_Heap @ A @ B @ R ) )
      = ( heap_Time_pred_Heap @ A @ ( domainp @ A @ B @ R ) ) ) ).

% Heap.Domainp_rel
thf(fact_5316_Heap_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q: B > $o,F: A > B,X: heap_Time_Heap @ A] :
      ( ( heap_Time_pred_Heap @ B @ Q @ ( heap_Time_map_Heap @ A @ B @ F @ X ) )
      = ( heap_Time_pred_Heap @ A @ ( comp @ B @ $o @ A @ Q @ F ) @ X ) ) ).

% Heap.pred_map
thf(fact_5317_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B,X: A,A4: set @ A,Z2: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A4 ) @ S2 )
       => ( ( finite_finite @ A @ A4 )
         => ( ( finite_folding_F @ A @ B @ F @ Z2 @ ( insert2 @ A @ X @ A4 ) )
            = ( F @ X @ ( finite_folding_F @ A @ B @ F @ Z2 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% folding_on.insert_remove
thf(fact_5318_coinduct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F: A > A,X5: A] :
          ( ( order_mono @ A @ A @ F )
         => ( ( ord_less_eq @ A @ X5 @ ( F @ ( sup_sup @ A @ X5 @ ( complete_lattice_gfp @ A @ F ) ) ) )
           => ( ord_less_eq @ A @ X5 @ ( complete_lattice_gfp @ A @ F ) ) ) ) ) ).

% coinduct
thf(fact_5319_def__coinduct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: A,F: A > A,X5: A] :
          ( ( A4
            = ( complete_lattice_gfp @ A @ F ) )
         => ( ( order_mono @ A @ A @ F )
           => ( ( ord_less_eq @ A @ X5 @ ( F @ ( sup_sup @ A @ X5 @ A4 ) ) )
             => ( ord_less_eq @ A @ X5 @ A4 ) ) ) ) ) ).

% def_coinduct
thf(fact_5320_coinduct__lemma,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X5: A,F: A > A] :
          ( ( ord_less_eq @ A @ X5 @ ( F @ ( sup_sup @ A @ X5 @ ( complete_lattice_gfp @ A @ F ) ) ) )
         => ( ( order_mono @ A @ A @ F )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ X5 @ ( complete_lattice_gfp @ A @ F ) ) @ ( F @ ( sup_sup @ A @ X5 @ ( complete_lattice_gfp @ A @ F ) ) ) ) ) ) ) ).

% coinduct_lemma
thf(fact_5321_predicate1I,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( A > $o ) @ P @ Q ) ) ).

% predicate1I
thf(fact_5322_rev__predicate1D,axiom,
    ! [A: $tType,P: A > $o,X: A,Q: A > $o] :
      ( ( P @ X )
     => ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
       => ( Q @ X ) ) ) ).

% rev_predicate1D
thf(fact_5323_predicate1D,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,X: A] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
     => ( ( P @ X )
       => ( Q @ X ) ) ) ).

% predicate1D
thf(fact_5324_Random__Pred_Onot__randompred__def,axiom,
    ( random6974930770145893639ompred
    = ( ^ [P3: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( pred @ product_unit ) @ ( product_prod @ code_natural @ code_natural ) ),S6: product_prod @ code_natural @ code_natural] :
          ( product_case_prod @ ( pred @ product_unit ) @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ ( pred @ product_unit ) @ ( product_prod @ code_natural @ code_natural ) )
          @ ^ [P11: pred @ product_unit,S8: product_prod @ code_natural @ code_natural] : ( if @ ( product_prod @ ( pred @ product_unit ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( eval @ product_unit @ P11 @ product_Unity ) @ ( product_Pair @ ( pred @ product_unit ) @ ( product_prod @ code_natural @ code_natural ) @ ( bot_bot @ ( pred @ product_unit ) ) @ S8 ) @ ( product_Pair @ ( pred @ product_unit ) @ ( product_prod @ code_natural @ code_natural ) @ ( single @ product_unit @ product_Unity ) @ S8 ) )
          @ ( P3 @ S6 ) ) ) ) ).

% Random_Pred.not_randompred_def
thf(fact_5325_filtercomap__neq__bot__surj,axiom,
    ! [A: $tType,B: $tType,F3: filter @ A,F: B > A] :
      ( ( F3
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( ( image2 @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
          = ( top_top @ ( set @ A ) ) )
       => ( ( filtercomap @ B @ A @ F @ F3 )
         != ( bot_bot @ ( filter @ B ) ) ) ) ) ).

% filtercomap_neq_bot_surj
thf(fact_5326_trancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_trancl @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ( transitive_tranclp @ A
                @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 ) ) ) ) ) ) ).

% trancl_def
thf(fact_5327_filtercomap__bot,axiom,
    ! [B: $tType,A: $tType,F: A > B] :
      ( ( filtercomap @ A @ B @ F @ ( bot_bot @ ( filter @ B ) ) )
      = ( bot_bot @ ( filter @ A ) ) ) ).

% filtercomap_bot
thf(fact_5328_eval__inf,axiom,
    ! [A: $tType,P: pred @ A,Q: pred @ A] :
      ( ( eval @ A @ ( inf_inf @ ( pred @ A ) @ P @ Q ) )
      = ( inf_inf @ ( A > $o ) @ ( eval @ A @ P ) @ ( eval @ A @ Q ) ) ) ).

% eval_inf
thf(fact_5329_eval__bot,axiom,
    ! [A: $tType] :
      ( ( eval @ A @ ( bot_bot @ ( pred @ A ) ) )
      = ( bot_bot @ ( A > $o ) ) ) ).

% eval_bot
thf(fact_5330_eval__INF,axiom,
    ! [A: $tType,B: $tType,F: B > ( pred @ A ),A4: set @ B] :
      ( ( eval @ A @ ( complete_Inf_Inf @ ( pred @ A ) @ ( image2 @ B @ ( pred @ A ) @ F @ A4 ) ) )
      = ( complete_Inf_Inf @ ( A > $o ) @ ( image2 @ B @ ( A > $o ) @ ( comp @ ( pred @ A ) @ ( A > $o ) @ B @ ( eval @ A ) @ F ) @ A4 ) ) ) ).

% eval_INF
thf(fact_5331_eval__SUP,axiom,
    ! [A: $tType,B: $tType,F: B > ( pred @ A ),A4: set @ B] :
      ( ( eval @ A @ ( complete_Sup_Sup @ ( pred @ A ) @ ( image2 @ B @ ( pred @ A ) @ F @ A4 ) ) )
      = ( complete_Sup_Sup @ ( A > $o ) @ ( image2 @ B @ ( A > $o ) @ ( comp @ ( pred @ A ) @ ( A > $o ) @ B @ ( eval @ A ) @ F ) @ A4 ) ) ) ).

% eval_SUP
thf(fact_5332_botE,axiom,
    ! [A: $tType,X: A] :
      ~ ( eval @ A @ ( bot_bot @ ( pred @ A ) ) @ X ) ).

% botE
thf(fact_5333_not__bot,axiom,
    ! [A: $tType,A4: pred @ A] :
      ( ( A4
       != ( bot_bot @ ( pred @ A ) ) )
     => ~ ! [X2: A] :
            ~ ( eval @ A @ A4 @ X2 ) ) ).

% not_bot
thf(fact_5334_tranclp__induct2,axiom,
    ! [A: $tType,B: $tType,R4: ( product_prod @ A @ B ) > ( product_prod @ A @ B ) > $o,Ax: A,Ay: B,Bx: A,By: B,P: A > B > $o] :
      ( ( transitive_tranclp @ ( product_prod @ A @ B ) @ R4 @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) )
     => ( ! [A8: A,B6: B] :
            ( ( R4 @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A8 @ B6 ) )
           => ( P @ A8 @ B6 ) )
       => ( ! [A8: A,B6: B,Aa2: A,Ba: B] :
              ( ( transitive_tranclp @ ( product_prod @ A @ B ) @ R4 @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A8 @ B6 ) )
             => ( ( R4 @ ( product_Pair @ A @ B @ A8 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) )
               => ( ( P @ A8 @ B6 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% tranclp_induct2
thf(fact_5335_filtercomap__inf,axiom,
    ! [A: $tType,B: $tType,F: A > B,F12: filter @ B,F24: filter @ B] :
      ( ( filtercomap @ A @ B @ F @ ( inf_inf @ ( filter @ B ) @ F12 @ F24 ) )
      = ( inf_inf @ ( filter @ A ) @ ( filtercomap @ A @ B @ F @ F12 ) @ ( filtercomap @ A @ B @ F @ F24 ) ) ) ).

% filtercomap_inf
thf(fact_5336_filterlim__filtercomap__iff,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > B,G: B > C,G6: filter @ C,F3: filter @ A] :
      ( ( filterlim @ A @ B @ F @ ( filtercomap @ B @ C @ G @ G6 ) @ F3 )
      = ( filterlim @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ G6 @ F3 ) ) ).

% filterlim_filtercomap_iff
thf(fact_5337_tranclp__trancl__eq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( transitive_tranclp @ A
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) )
      = ( ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ ( transitive_trancl @ A @ R4 ) ) ) ) ).

% tranclp_trancl_eq
thf(fact_5338_filtercomap__neq__bot,axiom,
    ! [A: $tType,B: $tType,F3: filter @ A,F: B > A] :
      ( ! [P5: A > $o] :
          ( ( eventually @ A @ P5 @ F3 )
         => ? [X6: B] : ( P5 @ ( F @ X6 ) ) )
     => ( ( filtercomap @ B @ A @ F @ F3 )
       != ( bot_bot @ ( filter @ B ) ) ) ) ).

% filtercomap_neq_bot
thf(fact_5339_Nitpick_Otranclp__unfold,axiom,
    ! [A: $tType] :
      ( ( transitive_tranclp @ A )
      = ( ^ [R5: A > A > $o,A5: A,B4: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B4 ) @ ( transitive_trancl @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% Nitpick.tranclp_unfold
thf(fact_5340_not__pred__eq,axiom,
    ( not_pred
    = ( ^ [P3: pred @ product_unit] : ( if @ ( pred @ product_unit ) @ ( eval @ product_unit @ P3 @ product_Unity ) @ ( bot_bot @ ( pred @ product_unit ) ) @ ( single @ product_unit @ product_Unity ) ) ) ) ).

% not_pred_eq
thf(fact_5341_reflp__refl__eq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( reflp @ A
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) )
      = ( refl_on @ A @ ( top_top @ ( set @ A ) ) @ R4 ) ) ).

% reflp_refl_eq
thf(fact_5342_Heap_Orel__reflp,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( ( reflp @ A @ R )
     => ( reflp @ ( heap_Time_Heap @ A ) @ ( heap_Time_rel_Heap @ A @ A @ R ) ) ) ).

% Heap.rel_reflp
thf(fact_5343_reflp__inf,axiom,
    ! [A: $tType,R4: A > A > $o,S: A > A > $o] :
      ( ( reflp @ A @ R4 )
     => ( ( reflp @ A @ S )
       => ( reflp @ A @ ( inf_inf @ ( A > A > $o ) @ R4 @ S ) ) ) ) ).

% reflp_inf
thf(fact_5344_inf__pred__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( pred @ A ) )
      = ( ^ [P3: pred @ A,Q3: pred @ A] : ( pred2 @ A @ ( inf_inf @ ( A > $o ) @ ( eval @ A @ P3 ) @ ( eval @ A @ Q3 ) ) ) ) ) ).

% inf_pred_def
thf(fact_5345_fun__of__rel__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( fun_of_rel @ B @ A )
      = ( ^ [R2: set @ ( product_prod @ B @ A ),X3: B] :
            ( fChoice @ A
            @ ^ [Y2: A] : ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X3 @ Y2 ) @ R2 ) ) ) ) ).

% fun_of_rel_def
thf(fact_5346_le__prod__encode__1,axiom,
    ! [A3: nat,B2: nat] : ( ord_less_eq @ nat @ A3 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A3 @ B2 ) ) ) ).

% le_prod_encode_1
thf(fact_5347_Eps__case__prod__eq,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( fChoice @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X9: A,Y7: B] :
              ( ( X = X9 )
              & ( Y = Y7 ) ) ) )
      = ( product_Pair @ A @ B @ X @ Y ) ) ).

% Eps_case_prod_eq
thf(fact_5348_some__insert__self,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( insert2 @ A
          @ ( fChoice @ A
            @ ^ [X3: A] : ( member @ A @ X3 @ S2 ) )
          @ S2 )
        = S2 ) ) ).

% some_insert_self
thf(fact_5349_some__elem,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( S2
       != ( bot_bot @ ( set @ A ) ) )
     => ( member @ A
        @ ( fChoice @ A
          @ ^ [X3: A] : ( member @ A @ X3 @ S2 ) )
        @ S2 ) ) ).

% some_elem
thf(fact_5350_some__in__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( member @ A
        @ ( fChoice @ A
          @ ^ [X3: A] : ( member @ A @ X3 @ A4 ) )
        @ A4 )
      = ( ( A4
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% some_in_eq
thf(fact_5351_split__paired__Eps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( fChoice @ ( product_prod @ A @ B ) )
      = ( ^ [P3: ( product_prod @ A @ B ) > $o] :
            ( fChoice @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A5: A,B4: B] : ( P3 @ ( product_Pair @ A @ B @ A5 @ B4 ) ) ) ) ) ) ).

% split_paired_Eps
thf(fact_5352_pred__of__set__def,axiom,
    ! [A: $tType] :
      ( ( pred_of_set @ A )
      = ( comp @ ( A > $o ) @ ( pred @ A ) @ ( set @ A ) @ ( pred2 @ A )
        @ ^ [A10: set @ A,X3: A] : ( member @ A @ X3 @ A10 ) ) ) ).

% pred_of_set_def
thf(fact_5353_bot__pred__def,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( pred @ A ) )
      = ( pred2 @ A @ ( bot_bot @ ( A > $o ) ) ) ) ).

% bot_pred_def
thf(fact_5354_le__prod__encode__2,axiom,
    ! [B2: nat,A3: nat] : ( ord_less_eq @ nat @ B2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A3 @ B2 ) ) ) ).

% le_prod_encode_2
thf(fact_5355_list__encode_Oelims,axiom,
    ! [X: list @ nat,Y: nat] :
      ( ( ( nat_list_encode @ X )
        = Y )
     => ( ( ( X
            = ( nil @ nat ) )
         => ( Y
           != ( zero_zero @ nat ) ) )
       => ~ ! [X2: nat,Xs4: list @ nat] :
              ( ( X
                = ( cons @ nat @ X2 @ Xs4 ) )
             => ( Y
               != ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X2 @ ( nat_list_encode @ Xs4 ) ) ) ) ) ) ) ) ).

% list_encode.elims
thf(fact_5356_list__encode_Osimps_I2_J,axiom,
    ! [X: nat,Xs: list @ nat] :
      ( ( nat_list_encode @ ( cons @ nat @ X @ Xs ) )
      = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X @ ( nat_list_encode @ Xs ) ) ) ) ) ).

% list_encode.simps(2)
thf(fact_5357_prod__list_Ocomm__monoid__list__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( groups1828464146339083142d_list @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod_list.comm_monoid_list_axioms
thf(fact_5358_list__encode_Opelims,axiom,
    ! [X: list @ nat,Y: nat] :
      ( ( ( nat_list_encode @ X )
        = Y )
     => ( ( accp @ ( list @ nat ) @ nat_list_encode_rel @ X )
       => ( ( ( X
              = ( nil @ nat ) )
           => ( ( Y
                = ( zero_zero @ nat ) )
             => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( nil @ nat ) ) ) )
         => ~ ! [X2: nat,Xs4: list @ nat] :
                ( ( X
                  = ( cons @ nat @ X2 @ Xs4 ) )
               => ( ( Y
                    = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X2 @ ( nat_list_encode @ Xs4 ) ) ) ) )
                 => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( cons @ nat @ X2 @ Xs4 ) ) ) ) ) ) ) ).

% list_encode.pelims
thf(fact_5359_map__option__o__case__sum,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: D > C,G: A > ( option @ D ),H2: B > ( option @ D )] :
      ( ( comp @ ( option @ D ) @ ( option @ C ) @ ( sum_sum @ A @ B ) @ ( map_option @ D @ C @ F ) @ ( sum_case_sum @ A @ ( option @ D ) @ B @ G @ H2 ) )
      = ( sum_case_sum @ A @ ( option @ C ) @ B @ ( comp @ ( option @ D ) @ ( option @ C ) @ A @ ( map_option @ D @ C @ F ) @ G ) @ ( comp @ ( option @ D ) @ ( option @ C ) @ B @ ( map_option @ D @ C @ F ) @ H2 ) ) ) ).

% map_option_o_case_sum
thf(fact_5360_Pair__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A4: A > B > $o,B3: C > D > $o] : ( bNF_rel_fun @ A @ B @ ( C > ( product_prod @ A @ C ) ) @ ( D > ( product_prod @ B @ D ) ) @ A4 @ ( bNF_rel_fun @ C @ D @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ B3 @ ( basic_rel_prod @ A @ B @ C @ D @ A4 @ B3 ) ) @ ( product_Pair @ A @ C ) @ ( product_Pair @ B @ D ) ) ).

% Pair_transfer
thf(fact_5361_rel__prod__inject,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,R12: A > B > $o,R23: C > D > $o,A3: A,B2: C,C2: B,D2: D] :
      ( ( basic_rel_prod @ A @ B @ C @ D @ R12 @ R23 @ ( product_Pair @ A @ C @ A3 @ B2 ) @ ( product_Pair @ B @ D @ C2 @ D2 ) )
      = ( ( R12 @ A3 @ C2 )
        & ( R23 @ B2 @ D2 ) ) ) ).

% rel_prod_inject
thf(fact_5362_o__case__sum,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,H2: D > C,F: A > D,G: B > D] :
      ( ( comp @ D @ C @ ( sum_sum @ A @ B ) @ H2 @ ( sum_case_sum @ A @ D @ B @ F @ G ) )
      = ( sum_case_sum @ A @ C @ B @ ( comp @ D @ C @ A @ H2 @ F ) @ ( comp @ D @ C @ B @ H2 @ G ) ) ) ).

% o_case_sum
thf(fact_5363_rel__prod_Ocases,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,R12: A > B > $o,R23: C > D > $o,A1: product_prod @ A @ C,A22: product_prod @ B @ D] :
      ( ( basic_rel_prod @ A @ B @ C @ D @ R12 @ R23 @ A1 @ A22 )
     => ~ ! [A8: A,B6: B,C4: C] :
            ( ( A1
              = ( product_Pair @ A @ C @ A8 @ C4 ) )
           => ! [D3: D] :
                ( ( A22
                  = ( product_Pair @ B @ D @ B6 @ D3 ) )
               => ( ( R12 @ A8 @ B6 )
                 => ~ ( R23 @ C4 @ D3 ) ) ) ) ) ).

% rel_prod.cases
thf(fact_5364_rel__prod_Osimps,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType] :
      ( ( basic_rel_prod @ A @ B @ C @ D )
      = ( ^ [R14: A > B > $o,R25: C > D > $o,A12: product_prod @ A @ C,A23: product_prod @ B @ D] :
          ? [A5: A,B4: B,C5: C,D5: D] :
            ( ( A12
              = ( product_Pair @ A @ C @ A5 @ C5 ) )
            & ( A23
              = ( product_Pair @ B @ D @ B4 @ D5 ) )
            & ( R14 @ A5 @ B4 )
            & ( R25 @ C5 @ D5 ) ) ) ) ).

% rel_prod.simps
thf(fact_5365_rel__prod_Ointros,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,R12: A > B > $o,A3: A,B2: B,R23: C > D > $o,C2: C,D2: D] :
      ( ( R12 @ A3 @ B2 )
     => ( ( R23 @ C2 @ D2 )
       => ( basic_rel_prod @ A @ B @ C @ D @ R12 @ R23 @ ( product_Pair @ A @ C @ A3 @ C2 ) @ ( product_Pair @ B @ D @ B2 @ D2 ) ) ) ) ).

% rel_prod.intros
thf(fact_5366_Heap_Orec__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R: A > B > $o,S2: C > D > $o] :
      ( bNF_rel_fun @ ( ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > C ) @ ( ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > D ) @ ( ( heap_Time_Heap @ A ) > C ) @ ( ( heap_Time_Heap @ B ) > D )
      @ ( bNF_rel_fun @ ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ C @ D
        @ ( bNF_rel_fun @ ( heap_ext @ product_unit ) @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
          @ ^ [Y4: heap_ext @ product_unit,Z5: heap_ext @ product_unit] : ( Y4 = Z5 )
          @ ( rel_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( basic_rel_prod @ A @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R
              @ ^ [Y4: product_prod @ ( heap_ext @ product_unit ) @ nat,Z5: product_prod @ ( heap_ext @ product_unit ) @ nat] : ( Y4 = Z5 ) ) ) )
        @ S2 )
      @ ( bNF_rel_fun @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ C @ D @ ( heap_Time_rel_Heap @ A @ B @ R ) @ S2 )
      @ ( heap_Time_rec_Heap @ A @ C )
      @ ( heap_Time_rec_Heap @ B @ D ) ) ).

% Heap.rec_transfer
thf(fact_5367_ordering__top_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ordering_top_axioms @ A @ Less_eq @ Top ) ) ).

% ordering_top.axioms(2)
thf(fact_5368_heap__step__admissible,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: E > A > C > B > D > $o,X: E] :
      ( comple1908693960933563346ssible @ ( A > ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) ) @ ( partial_fun_lub @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ A @ ( partial_flat_lub @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ ( none @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) ) ) @ ( partial_fun_ord @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ A @ ( partial_flat_ord @ ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) @ ( none @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) ) )
      @ ^ [F2: A > ( option @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
        ! [H3: A,H8: C,R5: B,N5: D] :
          ( ( ( F2 @ H3 )
            = ( some @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ R5 @ ( product_Pair @ C @ D @ H8 @ N5 ) ) ) )
         => ( P @ X @ H3 @ H8 @ R5 @ N5 ) ) ) ).

% heap_step_admissible
thf(fact_5369_rel__option__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( rel_option @ A @ B )
      = ( ^ [R2: A > B > $o,X3: option @ A,Y2: option @ B] :
            ( product_case_prod @ ( option @ A ) @ ( option @ B ) @ $o
            @ ^ [A5: option @ A,B4: option @ B] :
                ( case_option @ $o @ A
                @ ( case_option @ $o @ B @ $true
                  @ ^ [C5: B] : $false
                  @ B4 )
                @ ^ [Z4: A] : ( case_option @ $o @ B @ $false @ ( R2 @ Z4 ) @ B4 )
                @ A5 )
            @ ( product_Pair @ ( option @ A ) @ ( option @ B ) @ X3 @ Y2 ) ) ) ) ).

% rel_option_iff
thf(fact_5370_ordering__top__axioms_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Top: A] :
      ( ! [A8: A] : ( Less_eq @ A8 @ Top )
     => ( ordering_top_axioms @ A @ Less_eq @ Top ) ) ).

% ordering_top_axioms.intro
thf(fact_5371_ordering__top__axioms__def,axiom,
    ! [A: $tType] :
      ( ( ordering_top_axioms @ A )
      = ( ^ [Less_eq2: A > A > $o,Top2: A] :
          ! [A5: A] : ( Less_eq2 @ A5 @ Top2 ) ) ) ).

% ordering_top_axioms_def
thf(fact_5372_rel__option__inf,axiom,
    ! [B: $tType,A: $tType,A4: A > B > $o,B3: A > B > $o] :
      ( ( inf_inf @ ( ( option @ A ) > ( option @ B ) > $o ) @ ( rel_option @ A @ B @ A4 ) @ ( rel_option @ A @ B @ B3 ) )
      = ( rel_option @ A @ B @ ( inf_inf @ ( A > B > $o ) @ A4 @ B3 ) ) ) ).

% rel_option_inf
thf(fact_5373_Heap_Orel__cases,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,A3: heap_Time_Heap @ A,B2: heap_Time_Heap @ B] :
      ( ( heap_Time_rel_Heap @ A @ B @ R @ A3 @ B2 )
     => ~ ! [Xa3: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
            ( ( A3
              = ( heap_Time_Heap2 @ A @ Xa3 ) )
           => ! [Ya3: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
                ( ( B2
                  = ( heap_Time_Heap2 @ B @ Ya3 ) )
               => ~ ( bNF_rel_fun @ ( heap_ext @ product_unit ) @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
                    @ ^ [Y4: heap_ext @ product_unit,Z5: heap_ext @ product_unit] : ( Y4 = Z5 )
                    @ ( rel_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                      @ ( basic_rel_prod @ A @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R
                        @ ^ [Y4: product_prod @ ( heap_ext @ product_unit ) @ nat,Z5: product_prod @ ( heap_ext @ product_unit ) @ nat] : ( Y4 = Z5 ) ) )
                    @ Xa3
                    @ Ya3 ) ) ) ) ).

% Heap.rel_cases
thf(fact_5374_Heap_Orel__induct,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X: heap_Time_Heap @ A,Y: heap_Time_Heap @ B,Q: ( heap_Time_Heap @ A ) > ( heap_Time_Heap @ B ) > $o] :
      ( ( heap_Time_rel_Heap @ A @ B @ R @ X @ Y )
     => ( ! [A8: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ),B6: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
            ( ( bNF_rel_fun @ ( heap_ext @ product_unit ) @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
              @ ^ [Y4: heap_ext @ product_unit,Z5: heap_ext @ product_unit] : ( Y4 = Z5 )
              @ ( rel_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                @ ( basic_rel_prod @ A @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R
                  @ ^ [Y4: product_prod @ ( heap_ext @ product_unit ) @ nat,Z5: product_prod @ ( heap_ext @ product_unit ) @ nat] : ( Y4 = Z5 ) ) )
              @ A8
              @ B6 )
           => ( Q @ ( heap_Time_Heap2 @ A @ A8 ) @ ( heap_Time_Heap2 @ B @ B6 ) ) )
       => ( Q @ X @ Y ) ) ) ).

% Heap.rel_induct
thf(fact_5375_Heap_Orel__inject,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ),Y: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( heap_Time_rel_Heap @ A @ B @ R @ ( heap_Time_Heap2 @ A @ X ) @ ( heap_Time_Heap2 @ B @ Y ) )
      = ( bNF_rel_fun @ ( heap_ext @ product_unit ) @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ^ [Y4: heap_ext @ product_unit,Z5: heap_ext @ product_unit] : ( Y4 = Z5 )
        @ ( rel_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
          @ ( basic_rel_prod @ A @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R
            @ ^ [Y4: product_prod @ ( heap_ext @ product_unit ) @ nat,Z5: product_prod @ ( heap_ext @ product_unit ) @ nat] : ( Y4 = Z5 ) ) )
        @ X
        @ Y ) ) ).

% Heap.rel_inject
thf(fact_5376_Heap_Orel__intros,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ),Y: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( bNF_rel_fun @ ( heap_ext @ product_unit ) @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ^ [Y4: heap_ext @ product_unit,Z5: heap_ext @ product_unit] : ( Y4 = Z5 )
        @ ( rel_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
          @ ( basic_rel_prod @ A @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R
            @ ^ [Y4: product_prod @ ( heap_ext @ product_unit ) @ nat,Z5: product_prod @ ( heap_ext @ product_unit ) @ nat] : ( Y4 = Z5 ) ) )
        @ X
        @ Y )
     => ( heap_Time_rel_Heap @ A @ B @ R @ ( heap_Time_Heap2 @ A @ X ) @ ( heap_Time_Heap2 @ B @ Y ) ) ) ).

% Heap.rel_intros
thf(fact_5377_Heap_Octr__transfer,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B )
      @ ( bNF_rel_fun @ ( heap_ext @ product_unit ) @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ^ [Y4: heap_ext @ product_unit,Z5: heap_ext @ product_unit] : ( Y4 = Z5 )
        @ ( rel_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
          @ ( basic_rel_prod @ A @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R
            @ ^ [Y4: product_prod @ ( heap_ext @ product_unit ) @ nat,Z5: product_prod @ ( heap_ext @ product_unit ) @ nat] : ( Y4 = Z5 ) ) ) )
      @ ( heap_Time_rel_Heap @ A @ B @ R )
      @ ( heap_Time_Heap2 @ A )
      @ ( heap_Time_Heap2 @ B ) ) ).

% Heap.ctr_transfer
thf(fact_5378_ccpo_OadmissibleD,axiom,
    ! [A: $tType,Lub: ( set @ A ) > A,Ord: A > A > $o,P: A > $o,A4: set @ A] :
      ( ( comple1908693960933563346ssible @ A @ Lub @ Ord @ P )
     => ( ( comple1602240252501008431_chain @ A @ Ord @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ A4 )
               => ( P @ X2 ) )
           => ( P @ ( Lub @ A4 ) ) ) ) ) ) ).

% ccpo.admissibleD
thf(fact_5379_ccpo_OadmissibleI,axiom,
    ! [A: $tType,Ord: A > A > $o,P: A > $o,Lub: ( set @ A ) > A] :
      ( ! [A13: set @ A] :
          ( ( comple1602240252501008431_chain @ A @ Ord @ A13 )
         => ( ( A13
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X6: A] :
                  ( ( member @ A @ X6 @ A13 )
                 => ( P @ X6 ) )
             => ( P @ ( Lub @ A13 ) ) ) ) )
     => ( comple1908693960933563346ssible @ A @ Lub @ Ord @ P ) ) ).

% ccpo.admissibleI
thf(fact_5380_ccpo_Oadmissible__def,axiom,
    ! [A: $tType] :
      ( ( comple1908693960933563346ssible @ A )
      = ( ^ [Lub2: ( set @ A ) > A,Ord2: A > A > $o,P3: A > $o] :
          ! [A10: set @ A] :
            ( ( comple1602240252501008431_chain @ A @ Ord2 @ A10 )
           => ( ( A10
               != ( bot_bot @ ( set @ A ) ) )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A10 )
                   => ( P3 @ X3 ) )
               => ( P3 @ ( Lub2 @ A10 ) ) ) ) ) ) ) ).

% ccpo.admissible_def
thf(fact_5381_Heap_Ocase__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R: A > B > $o,S2: C > D > $o] :
      ( bNF_rel_fun @ ( ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > C ) @ ( ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > D ) @ ( ( heap_Time_Heap @ A ) > C ) @ ( ( heap_Time_Heap @ B ) > D )
      @ ( bNF_rel_fun @ ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ C @ D
        @ ( bNF_rel_fun @ ( heap_ext @ product_unit ) @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
          @ ^ [Y4: heap_ext @ product_unit,Z5: heap_ext @ product_unit] : ( Y4 = Z5 )
          @ ( rel_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_prod @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( basic_rel_prod @ A @ B @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R
              @ ^ [Y4: product_prod @ ( heap_ext @ product_unit ) @ nat,Z5: product_prod @ ( heap_ext @ product_unit ) @ nat] : ( Y4 = Z5 ) ) ) )
        @ S2 )
      @ ( bNF_rel_fun @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ C @ D @ ( heap_Time_rel_Heap @ A @ B @ R ) @ S2 )
      @ ( heap_Time_case_Heap @ A @ C )
      @ ( heap_Time_case_Heap @ B @ D ) ) ).

% Heap.case_transfer
thf(fact_5382_ordering__top__def,axiom,
    ! [A: $tType] :
      ( ( ordering_top @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o,Top2: A] :
            ( ( ordering @ A @ Less_eq2 @ Less2 )
            & ( ordering_top_axioms @ A @ Less_eq2 @ Top2 ) ) ) ) ).

% ordering_top_def
thf(fact_5383_ordering__top_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( ordering_top_axioms @ A @ Less_eq @ Top )
       => ( ordering_top @ A @ Less_eq @ Less @ Top ) ) ) ).

% ordering_top.intro
thf(fact_5384_Heap_Ocase__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,H2: B > C,F: ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > B,Heap: heap_Time_Heap @ A] :
      ( ( H2 @ ( heap_Time_case_Heap @ A @ B @ F @ Heap ) )
      = ( heap_Time_case_Heap @ A @ C
        @ ^ [X3: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] : ( H2 @ ( F @ X3 ) )
        @ Heap ) ) ).

% Heap.case_distrib
thf(fact_5385_ordering__dualI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( ordering @ A
        @ ^ [A5: A,B4: A] : ( Less_eq @ B4 @ A5 )
        @ ^ [A5: A,B4: A] : ( Less @ B4 @ A5 ) )
     => ( ordering @ A @ Less_eq @ Less ) ) ).

% ordering_dualI
thf(fact_5386_ordering__strictI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ! [A8: A,B6: A] :
          ( ( Less_eq @ A8 @ B6 )
          = ( ( Less @ A8 @ B6 )
            | ( A8 = B6 ) ) )
     => ( ! [A8: A,B6: A] :
            ( ( Less @ A8 @ B6 )
           => ~ ( Less @ B6 @ A8 ) )
       => ( ! [A8: A] :
              ~ ( Less @ A8 @ A8 )
         => ( ! [A8: A,B6: A,C4: A] :
                ( ( Less @ A8 @ B6 )
               => ( ( Less @ B6 @ C4 )
                 => ( Less @ A8 @ C4 ) ) )
           => ( ordering @ A @ Less_eq @ Less ) ) ) ) ) ).

% ordering_strictI
thf(fact_5387_ordering_Onot__eq__order__implies__strict,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( A3 != B2 )
       => ( ( Less_eq @ A3 @ B2 )
         => ( Less @ A3 @ B2 ) ) ) ) ).

% ordering.not_eq_order_implies_strict
thf(fact_5388_ordering_Ostrict__implies__not__eq,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
       => ( A3 != B2 ) ) ) ).

% ordering.strict_implies_not_eq
thf(fact_5389_ordering_Ostrict__iff__order,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
        = ( ( Less_eq @ A3 @ B2 )
          & ( A3 != B2 ) ) ) ) ).

% ordering.strict_iff_order
thf(fact_5390_ordering_Oorder__iff__strict,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
        = ( ( Less @ A3 @ B2 )
          | ( A3 = B2 ) ) ) ) ).

% ordering.order_iff_strict
thf(fact_5391_ordering_Oantisym,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
       => ( ( Less_eq @ B2 @ A3 )
         => ( A3 = B2 ) ) ) ) ).

% ordering.antisym
thf(fact_5392_ordering_Oeq__iff,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( A3 = B2 )
        = ( ( Less_eq @ A3 @ B2 )
          & ( Less_eq @ B2 @ A3 ) ) ) ) ).

% ordering.eq_iff
thf(fact_5393_ordering__top_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ordering @ A @ Less_eq @ Less ) ) ).

% ordering_top.axioms(1)
thf(fact_5394_order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ordering @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% order.ordering_axioms
thf(fact_5395_Heap_Ocase,axiom,
    ! [B: $tType,A: $tType,F: ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > B,X: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( heap_Time_case_Heap @ A @ B @ F @ ( heap_Time_Heap2 @ A @ X ) )
      = ( F @ X ) ) ).

% Heap.case
thf(fact_5396_dual__order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ordering @ A
        @ ^ [X3: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X3 )
        @ ^ [X3: A,Y2: A] : ( ord_less @ A @ Y2 @ X3 ) ) ) ).

% dual_order.ordering_axioms
thf(fact_5397_admissible__image,axiom,
    ! [A: $tType,B: $tType,Le: A > A > $o,Lub: ( set @ A ) > A,P: B > $o,G: A > B,F: B > A] :
      ( ( partia7178651479351089652itions @ A @ Le @ Lub )
     => ( ( comple1908693960933563346ssible @ A @ Lub @ Le @ ( comp @ B @ $o @ A @ P @ G ) )
       => ( ! [X2: B,Y3: B] :
              ( ( ( F @ X2 )
                = ( F @ Y3 ) )
             => ( X2 = Y3 ) )
         => ( ! [X2: A] :
                ( ( F @ ( G @ X2 ) )
                = X2 )
           => ( comple1908693960933563346ssible @ B @ ( partial_img_lub @ B @ A @ A @ B @ F @ G @ Lub ) @ ( partial_img_ord @ B @ A @ $o @ F @ Le ) @ P ) ) ) ) ) ).

% admissible_image
thf(fact_5398_list__all__zip_Opelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X: A > B > $o,Xa: list @ A,Xb: list @ B,Y: $o] :
      ( ( ( list_all_zip @ A @ B @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( ( Xb
                = ( nil @ B ) )
             => ( Y
               => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) ) ) ) ) )
         => ( ! [A8: A,As2: list @ A] :
                ( ( Xa
                  = ( cons @ A @ A8 @ As2 ) )
               => ! [B6: B,Bs2: list @ B] :
                    ( ( Xb
                      = ( cons @ B @ B6 @ Bs2 ) )
                   => ( ( Y
                        = ( ( X @ A8 @ B6 )
                          & ( list_all_zip @ A @ B @ X @ As2 @ Bs2 ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A8 @ As2 ) @ ( cons @ B @ B6 @ Bs2 ) ) ) ) ) ) )
           => ( ! [V4: A,Va: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ V4 @ Va ) )
                 => ( ( Xb
                      = ( nil @ B ) )
                   => ( ~ Y
                     => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ V4 @ Va ) @ ( nil @ B ) ) ) ) ) ) )
             => ~ ( ( Xa
                    = ( nil @ A ) )
                 => ! [V4: B,Va: list @ B] :
                      ( ( Xb
                        = ( cons @ B @ V4 @ Va ) )
                     => ( ~ Y
                       => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( cons @ B @ V4 @ Va ) ) ) ) ) ) ) ) ) ) ) ) ).

% list_all_zip.pelims(1)
thf(fact_5399_list__all__zip_Opelims_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A > B > $o,Xa: list @ A,Xb: list @ B] :
      ( ( list_all_zip @ A @ B @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( ( Xb
                = ( nil @ B ) )
             => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) ) ) ) )
         => ~ ! [A8: A,As2: list @ A] :
                ( ( Xa
                  = ( cons @ A @ A8 @ As2 ) )
               => ! [B6: B,Bs2: list @ B] :
                    ( ( Xb
                      = ( cons @ B @ B6 @ Bs2 ) )
                   => ( ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A8 @ As2 ) @ ( cons @ B @ B6 @ Bs2 ) ) ) )
                     => ~ ( ( X @ A8 @ B6 )
                          & ( list_all_zip @ A @ B @ X @ As2 @ Bs2 ) ) ) ) ) ) ) ) ).

% list_all_zip.pelims(2)
thf(fact_5400_list__all__zip_Opelims_I3_J,axiom,
    ! [A: $tType,B: $tType,X: A > B > $o,Xa: list @ A,Xb: list @ B] :
      ( ~ ( list_all_zip @ A @ B @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ! [A8: A,As2: list @ A] :
              ( ( Xa
                = ( cons @ A @ A8 @ As2 ) )
             => ! [B6: B,Bs2: list @ B] :
                  ( ( Xb
                    = ( cons @ B @ B6 @ Bs2 ) )
                 => ( ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A8 @ As2 ) @ ( cons @ B @ B6 @ Bs2 ) ) ) )
                   => ( ( X @ A8 @ B6 )
                      & ( list_all_zip @ A @ B @ X @ As2 @ Bs2 ) ) ) ) )
         => ( ! [V4: A,Va: list @ A] :
                ( ( Xa
                  = ( cons @ A @ V4 @ Va ) )
               => ( ( Xb
                    = ( nil @ B ) )
                 => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ V4 @ Va ) @ ( nil @ B ) ) ) ) ) )
           => ~ ( ( Xa
                  = ( nil @ A ) )
               => ! [V4: B,Va: list @ B] :
                    ( ( Xb
                      = ( cons @ B @ V4 @ Va ) )
                   => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( cons @ B @ V4 @ Va ) ) ) ) ) ) ) ) ) ) ).

% list_all_zip.pelims(3)
thf(fact_5401_partial__function__definitions_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Leq: A > A > $o,Lub: ( set @ A ) > A,U3: C > B > A,F3: C > C,C3: ( B > A ) > C,F: C,P: ( B > A ) > $o] :
      ( ( partia7178651479351089652itions @ A @ Leq @ Lub )
     => ( ! [X2: B] :
            ( comple7038119648293358887notone @ ( B > A ) @ A @ ( partial_fun_ord @ A @ A @ B @ Leq ) @ Leq
            @ ^ [F2: B > A] : ( U3 @ ( F3 @ ( C3 @ F2 ) ) @ X2 ) )
       => ( ( F
            = ( C3
              @ ( comple187402453842119260l_fixp @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ Lub ) @ ( partial_fun_ord @ A @ A @ B @ Leq )
                @ ^ [F2: B > A] : ( U3 @ ( F3 @ ( C3 @ F2 ) ) ) ) ) )
         => ( ! [F10: B > A] :
                ( ( U3 @ ( C3 @ F10 ) )
                = F10 )
           => ( ( comple1908693960933563346ssible @ ( B > A ) @ ( partial_fun_lub @ A @ A @ B @ Lub ) @ ( partial_fun_ord @ A @ A @ B @ Leq ) @ P )
             => ( ( P
                  @ ^ [Uu: B] : ( Lub @ ( bot_bot @ ( set @ A ) ) ) )
               => ( ! [F10: C] :
                      ( ( P @ ( U3 @ F10 ) )
                     => ( P @ ( U3 @ ( F3 @ F10 ) ) ) )
                 => ( P @ ( U3 @ F ) ) ) ) ) ) ) ) ) ).

% partial_function_definitions.fixp_induct_uc
thf(fact_5402_rat_Odomain__par,axiom,
    ! [DR1: int > $o,DR2: int > $o,P24: ( product_prod @ int @ int ) > $o] :
      ( ( ( domainp @ int @ int
          @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 ) )
        = DR1 )
     => ( ( ( domainp @ int @ int
            @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 ) )
          = DR2 )
       => ( ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o
            @ ( basic_rel_prod @ int @ int @ int @ int
              @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
              @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 ) )
            @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
            @ P24
            @ ^ [X3: product_prod @ int @ int] : ( ratrel @ X3 @ X3 ) )
         => ( ( domainp @ ( product_prod @ int @ int ) @ rat @ pcr_rat )
            = ( inf_inf @ ( ( product_prod @ int @ int ) > $o ) @ ( basic_pred_prod @ int @ int @ DR1 @ DR2 ) @ P24 ) ) ) ) ) ).

% rat.domain_par
thf(fact_5403_Predicate_Oiterate__upto_Opelims,axiom,
    ! [A: $tType,X: code_natural > A,Xa: code_natural,Xb: code_natural,Y: pred @ A] :
      ( ( ( iterate_upto @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( iterate_upto_rel @ A ) @ ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ X @ ( product_Pair @ code_natural @ code_natural @ Xa @ Xb ) ) )
       => ~ ( ( Y
              = ( seq2 @ A
                @ ^ [U2: product_unit] : ( if @ ( seq @ A ) @ ( ord_less @ code_natural @ Xb @ Xa ) @ ( empty @ A ) @ ( insert @ A @ ( X @ Xa ) @ ( iterate_upto @ A @ X @ ( plus_plus @ code_natural @ Xa @ ( one_one @ code_natural ) ) @ Xb ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( iterate_upto_rel @ A ) @ ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ X @ ( product_Pair @ code_natural @ code_natural @ Xa @ Xb ) ) ) ) ) ) ).

% Predicate.iterate_upto.pelims
thf(fact_5404_pred__prod__inject,axiom,
    ! [A: $tType,B: $tType,P12: A > $o,P23: B > $o,A3: A,B2: B] :
      ( ( basic_pred_prod @ A @ B @ P12 @ P23 @ ( product_Pair @ A @ B @ A3 @ B2 ) )
      = ( ( P12 @ A3 )
        & ( P23 @ B2 ) ) ) ).

% pred_prod_inject
thf(fact_5405_Predicate_Osingle__code,axiom,
    ! [A: $tType] :
      ( ( single @ A )
      = ( ^ [X3: A] :
            ( seq2 @ A
            @ ^ [U2: product_unit] : ( insert @ A @ X3 @ ( bot_bot @ ( pred @ A ) ) ) ) ) ) ).

% Predicate.single_code
thf(fact_5406_bot__set__code,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( pred @ A ) )
      = ( seq2 @ A
        @ ^ [U2: product_unit] : ( empty @ A ) ) ) ).

% bot_set_code
thf(fact_5407_pred__prod_Ocases,axiom,
    ! [A: $tType,B: $tType,P12: A > $o,P23: B > $o,A3: product_prod @ A @ B] :
      ( ( basic_pred_prod @ A @ B @ P12 @ P23 @ A3 )
     => ~ ! [A8: A,B6: B] :
            ( ( A3
              = ( product_Pair @ A @ B @ A8 @ B6 ) )
           => ( ( P12 @ A8 )
             => ~ ( P23 @ B6 ) ) ) ) ).

% pred_prod.cases
thf(fact_5408_pred__prod_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_pred_prod @ A @ B )
      = ( ^ [P13: A > $o,P25: B > $o,A5: product_prod @ A @ B] :
          ? [B4: A,C5: B] :
            ( ( A5
              = ( product_Pair @ A @ B @ B4 @ C5 ) )
            & ( P13 @ B4 )
            & ( P25 @ C5 ) ) ) ) ).

% pred_prod.simps
thf(fact_5409_pred__prod_Ointros,axiom,
    ! [A: $tType,B: $tType,P12: A > $o,A3: A,P23: B > $o,B2: B] :
      ( ( P12 @ A3 )
     => ( ( P23 @ B2 )
       => ( basic_pred_prod @ A @ B @ P12 @ P23 @ ( product_Pair @ A @ B @ A3 @ B2 ) ) ) ) ).

% pred_prod.intros
thf(fact_5410_pred__prod__split,axiom,
    ! [B: $tType,A: $tType,P: $o > $o,Q: A > $o,R: B > $o,Xy: product_prod @ A @ B] :
      ( ( P @ ( basic_pred_prod @ A @ B @ Q @ R @ Xy ) )
      = ( ! [X3: A,Y2: B] :
            ( ( Xy
              = ( product_Pair @ A @ B @ X3 @ Y2 ) )
           => ( P
              @ ( ( Q @ X3 )
                & ( R @ Y2 ) ) ) ) ) ) ).

% pred_prod_split
thf(fact_5411_prod_Opred__map,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,Q1: C > $o,Q22: D > $o,F1: A > C,F22: B > D,X: product_prod @ A @ B] :
      ( ( basic_pred_prod @ C @ D @ Q1 @ Q22 @ ( product_map_prod @ A @ C @ B @ D @ F1 @ F22 @ X ) )
      = ( basic_pred_prod @ A @ B @ ( comp @ C @ $o @ A @ Q1 @ F1 ) @ ( comp @ D @ $o @ B @ Q22 @ F22 ) @ X ) ) ).

% prod.pred_map
thf(fact_5412_Predicate_Oiterate__upto_Opsimps,axiom,
    ! [A: $tType,F: code_natural > A,N: code_natural,M4: code_natural] :
      ( ( accp @ ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( iterate_upto_rel @ A ) @ ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ F @ ( product_Pair @ code_natural @ code_natural @ N @ M4 ) ) )
     => ( ( iterate_upto @ A @ F @ N @ M4 )
        = ( seq2 @ A
          @ ^ [U2: product_unit] : ( if @ ( seq @ A ) @ ( ord_less @ code_natural @ M4 @ N ) @ ( empty @ A ) @ ( insert @ A @ ( F @ N ) @ ( iterate_upto @ A @ F @ ( plus_plus @ code_natural @ N @ ( one_one @ code_natural ) ) @ M4 ) ) ) ) ) ) ).

% Predicate.iterate_upto.psimps
thf(fact_5413_Random__Pred_Oiterate__upto__def,axiom,
    ! [A: $tType] :
      ( ( random_iterate_upto @ A )
      = ( ^ [F2: code_natural > A,N5: code_natural,M3: code_natural] : ( product_Pair @ ( pred @ A ) @ ( product_prod @ code_natural @ code_natural ) @ ( iterate_upto @ A @ F2 @ N5 @ M3 ) ) ) ) ).

% Random_Pred.iterate_upto_def
thf(fact_5414_fixp__induct,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [P: A > $o,F: A > A] :
          ( ( comple1908693960933563346ssible @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A ) @ P )
         => ( ( comple7038119648293358887notone @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less_eq @ A ) @ F )
           => ( ( P @ ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) ) )
             => ( ! [X2: A] :
                    ( ( P @ X2 )
                   => ( P @ ( F @ X2 ) ) )
               => ( P @ ( comple115746919287870866o_fixp @ A @ F ) ) ) ) ) ) ) ).

% fixp_induct
thf(fact_5415_heap_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U3: C > B > ( heap_Time_Heap @ A ),F3: C > C,C3: ( B > ( heap_Time_Heap @ A ) ) > C,F: C,P: ( B > ( heap_Time_Heap @ A ) ) > $o] :
      ( ! [X2: B] :
          ( comple7038119648293358887notone @ ( B > ( heap_Time_Heap @ A ) ) @ ( heap_Time_Heap @ A ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ ( heap_Time_Heap_ord @ A )
          @ ^ [F2: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F3 @ ( C3 @ F2 ) ) @ X2 ) )
     => ( ( F
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) )
              @ ^ [F2: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F3 @ ( C3 @ F2 ) ) ) ) ) )
       => ( ! [F10: B > ( heap_Time_Heap @ A )] :
              ( ( U3 @ ( C3 @ F10 ) )
              = F10 )
         => ( ( comple1908693960933563346ssible @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ P )
           => ( ( P
                @ ^ [Uu: B] :
                    ( heap_Time_Heap2 @ A
                    @ ^ [X3: heap_ext @ product_unit] : ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) )
             => ( ! [F10: C] :
                    ( ( P @ ( U3 @ F10 ) )
                   => ( P @ ( U3 @ ( F3 @ F10 ) ) ) )
               => ( P @ ( U3 @ F ) ) ) ) ) ) ) ) ).

% heap.fixp_induct_uc
thf(fact_5416_heap_Oconst__mono,axiom,
    ! [A: $tType,B: $tType,Ord: B > B > $o,C2: heap_Time_Heap @ A] :
      ( comple7038119648293358887notone @ B @ ( heap_Time_Heap @ A ) @ Ord @ ( heap_Time_Heap_ord @ A )
      @ ^ [F2: B] : C2 ) ).

% heap.const_mono
thf(fact_5417_heap_Oleq__refl,axiom,
    ! [A: $tType,X: heap_Time_Heap @ A] : ( heap_Time_Heap_ord @ A @ X @ X ) ).

% heap.leq_refl
thf(fact_5418_heap_Oleq__trans,axiom,
    ! [A: $tType,X: heap_Time_Heap @ A,Y: heap_Time_Heap @ A,Z2: heap_Time_Heap @ A] :
      ( ( heap_Time_Heap_ord @ A @ X @ Y )
     => ( ( heap_Time_Heap_ord @ A @ Y @ Z2 )
       => ( heap_Time_Heap_ord @ A @ X @ Z2 ) ) ) ).

% heap.leq_trans
thf(fact_5419_heap_Oleq__antisym,axiom,
    ! [A: $tType,X: heap_Time_Heap @ A,Y: heap_Time_Heap @ A] :
      ( ( heap_Time_Heap_ord @ A @ X @ Y )
     => ( ( heap_Time_Heap_ord @ A @ Y @ X )
       => ( X = Y ) ) ) ).

% heap.leq_antisym
thf(fact_5420_heap_Olub__least,axiom,
    ! [A: $tType,A4: set @ ( heap_Time_Heap @ A ),Z2: heap_Time_Heap @ A] :
      ( ( comple1602240252501008431_chain @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap_ord @ A ) @ A4 )
     => ( ! [X2: heap_Time_Heap @ A] :
            ( ( member @ ( heap_Time_Heap @ A ) @ X2 @ A4 )
           => ( heap_Time_Heap_ord @ A @ X2 @ Z2 ) )
       => ( heap_Time_Heap_ord @ A @ ( heap_Time_Heap_lub @ A @ A4 ) @ Z2 ) ) ) ).

% heap.lub_least
thf(fact_5421_heap_Olub__upper,axiom,
    ! [A: $tType,A4: set @ ( heap_Time_Heap @ A ),X: heap_Time_Heap @ A] :
      ( ( comple1602240252501008431_chain @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap_ord @ A ) @ A4 )
     => ( ( member @ ( heap_Time_Heap @ A ) @ X @ A4 )
       => ( heap_Time_Heap_ord @ A @ X @ ( heap_Time_Heap_lub @ A @ A4 ) ) ) ) ).

% heap.lub_upper
thf(fact_5422_heap__interpretation,axiom,
    ! [A: $tType] : ( partia7178651479351089652itions @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap_ord @ A ) @ ( heap_Time_Heap_lub @ A ) ) ).

% heap_interpretation
thf(fact_5423_heap_Omono__body__fixp,axiom,
    ! [A: $tType,B: $tType,F3: ( B > ( heap_Time_Heap @ A ) ) > B > ( heap_Time_Heap @ A )] :
      ( ! [X2: B] :
          ( comple7038119648293358887notone @ ( B > ( heap_Time_Heap @ A ) ) @ ( heap_Time_Heap @ A ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ ( heap_Time_Heap_ord @ A )
          @ ^ [F2: B > ( heap_Time_Heap @ A )] : ( F3 @ F2 @ X2 ) )
     => ( ( comple187402453842119260l_fixp @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ F3 )
        = ( F3 @ ( comple187402453842119260l_fixp @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ F3 ) ) ) ) ).

% heap.mono_body_fixp
thf(fact_5424_heap_Ofixp__rule__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U3: C > B > ( heap_Time_Heap @ A ),F3: C > C,C3: ( B > ( heap_Time_Heap @ A ) ) > C,F: C] :
      ( ! [X2: B] :
          ( comple7038119648293358887notone @ ( B > ( heap_Time_Heap @ A ) ) @ ( heap_Time_Heap @ A ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ ( heap_Time_Heap_ord @ A )
          @ ^ [F2: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F3 @ ( C3 @ F2 ) ) @ X2 ) )
     => ( ( F
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) )
              @ ^ [F2: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F3 @ ( C3 @ F2 ) ) ) ) ) )
       => ( ! [F10: C] :
              ( ( C3 @ ( U3 @ F10 ) )
              = F10 )
         => ( F
            = ( F3 @ F ) ) ) ) ) ).

% heap.fixp_rule_uc
thf(fact_5425_Heap__Time__Monad_Obind__mono,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,B3: ( A > ( heap_Time_Heap @ B ) ) > ( heap_Time_Heap @ C ),C3: C > ( A > ( heap_Time_Heap @ B ) ) > ( heap_Time_Heap @ D )] :
      ( ( comple7038119648293358887notone @ ( A > ( heap_Time_Heap @ B ) ) @ ( heap_Time_Heap @ C ) @ ( partial_fun_ord @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_Heap_ord @ B ) ) @ ( heap_Time_Heap_ord @ C ) @ B3 )
     => ( ! [Y3: C] : ( comple7038119648293358887notone @ ( A > ( heap_Time_Heap @ B ) ) @ ( heap_Time_Heap @ D ) @ ( partial_fun_ord @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_Heap_ord @ B ) ) @ ( heap_Time_Heap_ord @ D ) @ ( C3 @ Y3 ) )
       => ( comple7038119648293358887notone @ ( A > ( heap_Time_Heap @ B ) ) @ ( heap_Time_Heap @ D ) @ ( partial_fun_ord @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_Heap_ord @ B ) ) @ ( heap_Time_Heap_ord @ D )
          @ ^ [F2: A > ( heap_Time_Heap @ B )] :
              ( heap_Time_bind @ C @ D @ ( B3 @ F2 )
              @ ^ [Y2: C] : ( C3 @ Y2 @ F2 ) ) ) ) ) ).

% Heap_Time_Monad.bind_mono
thf(fact_5426_Heap__ord__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_Heap_ord @ A )
      = ( partial_img_ord @ ( heap_Time_Heap @ A ) @ ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) @ $o @ ( heap_Time_execute @ A ) @ ( partial_fun_ord @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( partial_flat_ord @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ) ) ) ).

% Heap_ord_def
thf(fact_5427_Heap__ordE,axiom,
    ! [A: $tType,X: heap_Time_Heap @ A,Y: heap_Time_Heap @ A,H2: heap_ext @ product_unit] :
      ( ( heap_Time_Heap_ord @ A @ X @ Y )
     => ( ( ( heap_Time_execute @ A @ X @ H2 )
         != ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) )
       => ( ( heap_Time_execute @ A @ X @ H2 )
          = ( heap_Time_execute @ A @ Y @ H2 ) ) ) ) ).

% Heap_ordE
thf(fact_5428_Heap__ordI,axiom,
    ! [A: $tType,X: heap_Time_Heap @ A,Y: heap_Time_Heap @ A] :
      ( ! [H: heap_ext @ product_unit] :
          ( ( ( heap_Time_execute @ A @ X @ H )
            = ( none @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) )
          | ( ( heap_Time_execute @ A @ X @ H )
            = ( heap_Time_execute @ A @ Y @ H ) ) )
     => ( heap_Time_Heap_ord @ A @ X @ Y ) ) ).

% Heap_ordI
thf(fact_5429_fixp__induct__heap,axiom,
    ! [C: $tType,A: $tType,B: $tType,U3: C > B > ( heap_Time_Heap @ A ),F3: C > C,C3: ( B > ( heap_Time_Heap @ A ) ) > C,F: C,P: B > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) > A > nat > $o,X: B,H2: heap_ext @ product_unit,H4: heap_ext @ product_unit,R4: A,N: nat] :
      ( ! [X2: B] :
          ( comple7038119648293358887notone @ ( B > ( heap_Time_Heap @ A ) ) @ ( heap_Time_Heap @ A ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) ) @ ( heap_Time_Heap_ord @ A )
          @ ^ [F2: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F3 @ ( C3 @ F2 ) ) @ X2 ) )
     => ( ( F
          = ( C3
            @ ( comple187402453842119260l_fixp @ ( B > ( heap_Time_Heap @ A ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_lub @ A ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ A ) @ B @ ( heap_Time_Heap_ord @ A ) )
              @ ^ [F2: B > ( heap_Time_Heap @ A )] : ( U3 @ ( F3 @ ( C3 @ F2 ) ) ) ) ) )
       => ( ! [F10: B > ( heap_Time_Heap @ A )] :
              ( ( U3 @ ( C3 @ F10 ) )
              = F10 )
         => ( ! [F10: C,X2: B,H: heap_ext @ product_unit,H5: heap_ext @ product_unit,R3: A,N3: nat] :
                ( ! [Xa2: B,Ha: heap_ext @ product_unit,H_a: heap_ext @ product_unit,Ra3: A,Na: nat] :
                    ( ( heap_Time_effect @ A @ ( U3 @ F10 @ Xa2 ) @ Ha @ H_a @ Ra3 @ Na )
                   => ( P @ Xa2 @ Ha @ H_a @ Ra3 @ Na ) )
               => ( ( heap_Time_effect @ A @ ( U3 @ ( F3 @ F10 ) @ X2 ) @ H @ H5 @ R3 @ N3 )
                 => ( P @ X2 @ H @ H5 @ R3 @ N3 ) ) )
           => ( ( heap_Time_effect @ A @ ( U3 @ F @ X ) @ H2 @ H4 @ R4 @ N )
             => ( P @ X @ H2 @ H4 @ R4 @ N ) ) ) ) ) ) ).

% fixp_induct_heap
thf(fact_5430_admissible__heap,axiom,
    ! [B: $tType,A: $tType,P: A > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) > B > nat > $o] :
      ( comple1908693960933563346ssible @ ( A > ( heap_Time_Heap @ B ) ) @ ( partial_fun_lub @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_Heap_lub @ B ) ) @ ( partial_fun_ord @ ( heap_Time_Heap @ B ) @ ( heap_Time_Heap @ B ) @ A @ ( heap_Time_Heap_ord @ B ) )
      @ ^ [F2: A > ( heap_Time_Heap @ B )] :
        ! [X3: A,H3: heap_ext @ product_unit,H8: heap_ext @ product_unit,R5: B,N5: nat] :
          ( ( heap_Time_effect @ B @ ( F2 @ X3 ) @ H3 @ H8 @ R5 @ N5 )
         => ( P @ X3 @ H3 @ H8 @ R5 @ N5 ) ) ) ).

% admissible_heap
thf(fact_5431_Heap_Opred__inject,axiom,
    ! [A: $tType,P: A > $o,A3: ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )] :
      ( ( heap_Time_pred_Heap @ A @ P @ ( heap_Time_Heap2 @ A @ A3 ) )
      = ( basic_pred_fun @ ( heap_ext @ product_unit ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ^ [Uu: heap_ext @ product_unit] : $true
        @ ( pred_option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( basic_pred_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ P @ ( top_top @ ( ( product_prod @ ( heap_ext @ product_unit ) @ nat ) > $o ) ) ) )
        @ A3 ) ) ).

% Heap.pred_inject
thf(fact_5432_of__seq__code_I1_J,axiom,
    ! [A: $tType] :
      ( ( set_of_seq @ A @ ( empty @ A ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% of_seq_code(1)
thf(fact_5433_pred__of__seq_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( pred_of_seq @ A @ ( empty @ A ) )
      = ( bot_bot @ ( pred @ A ) ) ) ).

% pred_of_seq.simps(1)
thf(fact_5434_top1I,axiom,
    ! [A: $tType,X: A] : ( top_top @ ( A > $o ) @ X ) ).

% top1I
thf(fact_5435_option_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q: B > $o,F: A > B,X: option @ A] :
      ( ( pred_option @ B @ Q @ ( map_option @ A @ B @ F @ X ) )
      = ( pred_option @ A @ ( comp @ B @ $o @ A @ Q @ F ) @ X ) ) ).

% option.pred_map
thf(fact_5436_of__pred__code,axiom,
    ! [A: $tType,F: product_unit > ( seq @ A )] :
      ( ( set_of_pred @ A @ ( seq2 @ A @ F ) )
      = ( case_seq @ ( set @ A ) @ A @ ( bot_bot @ ( set @ A ) )
        @ ^ [X3: A,P3: pred @ A] : ( insert2 @ A @ X3 @ ( set_of_pred @ A @ P3 ) )
        @ ^ [P3: pred @ A,Xq: seq @ A] : ( sup_sup @ ( set @ A ) @ ( set_of_pred @ A @ P3 ) @ ( set_of_seq @ A @ Xq ) )
        @ ( F @ product_Unity ) ) ) ).

% of_pred_code
thf(fact_5437_set__of__seq__def,axiom,
    ! [A: $tType] :
      ( ( set_of_seq @ A )
      = ( comp @ ( pred @ A ) @ ( set @ A ) @ ( seq @ A ) @ ( set_of_pred @ A ) @ ( pred_of_seq @ A ) ) ) ).

% set_of_seq_def
thf(fact_5438_nths__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( nths @ A @ Xs @ ( bot_bot @ ( set @ nat ) ) )
      = ( nil @ A ) ) ).

% nths_empty
thf(fact_5439_set__of__pred__def,axiom,
    ! [A: $tType] :
      ( ( set_of_pred @ A )
      = ( comp @ ( A > $o ) @ ( set @ A ) @ ( pred @ A ) @ ( collect @ A ) @ ( eval @ A ) ) ) ).

% set_of_pred_def
thf(fact_5440_ordering_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ordering_axioms @ A @ Less_eq @ Less ) ) ).

% ordering.axioms(2)
thf(fact_5441_abstract__boolean__algebra_Ointro,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( abel_semigroup @ A @ Conj )
     => ( ( abel_semigroup @ A @ Disj )
       => ( ( boolea6902313364301356556axioms @ A @ Conj @ Disj @ Compl @ Zero @ One )
         => ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One ) ) ) ) ).

% abstract_boolean_algebra.intro
thf(fact_5442_abstract__boolean__algebra__def,axiom,
    ! [A: $tType] :
      ( ( boolea2506097494486148201lgebra @ A )
      = ( ^ [Conj2: A > A > A,Disj2: A > A > A,Compl2: A > A,Zero2: A,One2: A] :
            ( ( abel_semigroup @ A @ Conj2 )
            & ( abel_semigroup @ A @ Disj2 )
            & ( boolea6902313364301356556axioms @ A @ Conj2 @ Disj2 @ Compl2 @ Zero2 @ One2 ) ) ) ) ).

% abstract_boolean_algebra_def
thf(fact_5443_sup_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( abel_semigroup @ A @ ( sup_sup @ A ) ) ) ).

% sup.abel_semigroup_axioms
thf(fact_5444_max_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( abel_semigroup @ A @ ( ord_max @ A ) ) ) ).

% max.abel_semigroup_axioms
thf(fact_5445_ordering__axioms__def,axiom,
    ! [A: $tType] :
      ( ( ordering_axioms @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ! [A5: A,B4: A] :
                ( ( Less2 @ A5 @ B4 )
                = ( ( Less_eq2 @ A5 @ B4 )
                  & ( A5 != B4 ) ) )
            & ! [A5: A,B4: A] :
                ( ( Less_eq2 @ A5 @ B4 )
               => ( ( Less_eq2 @ B4 @ A5 )
                 => ( A5 = B4 ) ) ) ) ) ) ).

% ordering_axioms_def
thf(fact_5446_ordering__axioms_Ointro,axiom,
    ! [A: $tType,Less: A > A > $o,Less_eq: A > A > $o] :
      ( ! [A8: A,B6: A] :
          ( ( Less @ A8 @ B6 )
          = ( ( Less_eq @ A8 @ B6 )
            & ( A8 != B6 ) ) )
     => ( ! [A8: A,B6: A] :
            ( ( Less_eq @ A8 @ B6 )
           => ( ( Less_eq @ B6 @ A8 )
             => ( A8 = B6 ) ) )
       => ( ordering_axioms @ A @ Less_eq @ Less ) ) ) ).

% ordering_axioms.intro
thf(fact_5447_abel__semigroup_Oleft__commute,axiom,
    ! [A: $tType,F: A > A > A,B2: A,A3: A,C2: A] :
      ( ( abel_semigroup @ A @ F )
     => ( ( F @ B2 @ ( F @ A3 @ C2 ) )
        = ( F @ A3 @ ( F @ B2 @ C2 ) ) ) ) ).

% abel_semigroup.left_commute
thf(fact_5448_abel__semigroup_Ocommute,axiom,
    ! [A: $tType,F: A > A > A,A3: A,B2: A] :
      ( ( abel_semigroup @ A @ F )
     => ( ( F @ A3 @ B2 )
        = ( F @ B2 @ A3 ) ) ) ).

% abel_semigroup.commute
thf(fact_5449_min_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( abel_semigroup @ A @ ( ord_min @ A ) ) ) ).

% min.abel_semigroup_axioms
thf(fact_5450_abstract__boolean__algebra_Oaxioms_I2_J,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( abel_semigroup @ A @ Disj ) ) ).

% abstract_boolean_algebra.axioms(2)
thf(fact_5451_abstract__boolean__algebra_Oaxioms_I1_J,axiom,
    ! [A: $tType,Conj: A > A > A,Disj: A > A > A,Compl: A > A,Zero: A,One: A] :
      ( ( boolea2506097494486148201lgebra @ A @ Conj @ Disj @ Compl @ Zero @ One )
     => ( abel_semigroup @ A @ Conj ) ) ).

% abstract_boolean_algebra.axioms(1)
thf(fact_5452_abel__semigroup_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: A > A > A] :
      ( ( abel_semigroup @ A @ F )
     => ( semigroup @ A @ F ) ) ).

% abel_semigroup.axioms(1)
thf(fact_5453_mult_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( abel_semigroup @ A @ ( times_times @ A ) ) ) ).

% mult.abel_semigroup_axioms
thf(fact_5454_add_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( abel_semigroup @ A @ ( plus_plus @ A ) ) ) ).

% add.abel_semigroup_axioms
thf(fact_5455_comm__monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( comm_monoid @ A @ F @ Z2 )
     => ( abel_semigroup @ A @ F ) ) ).

% comm_monoid.axioms(1)
thf(fact_5456_inf_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( abel_semigroup @ A @ ( inf_inf @ A ) ) ) ).

% inf.abel_semigroup_axioms
thf(fact_5457_abel__semigroup_Ointro,axiom,
    ! [A: $tType,F: A > A > A] :
      ( ( semigroup @ A @ F )
     => ( ( abel_s757365448890700780axioms @ A @ F )
       => ( abel_semigroup @ A @ F ) ) ) ).

% abel_semigroup.intro
thf(fact_5458_abel__semigroup__def,axiom,
    ! [A: $tType] :
      ( ( abel_semigroup @ A )
      = ( ^ [F2: A > A > A] :
            ( ( semigroup @ A @ F2 )
            & ( abel_s757365448890700780axioms @ A @ F2 ) ) ) ) ).

% abel_semigroup_def
thf(fact_5459_comm__monoid_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( abel_semigroup @ A @ F )
     => ( ( comm_monoid_axioms @ A @ F @ Z2 )
       => ( comm_monoid @ A @ F @ Z2 ) ) ) ).

% comm_monoid.intro
thf(fact_5460_comm__monoid__axioms_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ! [A8: A] :
          ( ( F @ A8 @ Z2 )
          = A8 )
     => ( comm_monoid_axioms @ A @ F @ Z2 ) ) ).

% comm_monoid_axioms.intro
thf(fact_5461_abel__semigroup__axioms_Ointro,axiom,
    ! [A: $tType,F: A > A > A] :
      ( ! [A8: A,B6: A] :
          ( ( F @ A8 @ B6 )
          = ( F @ B6 @ A8 ) )
     => ( abel_s757365448890700780axioms @ A @ F ) ) ).

% abel_semigroup_axioms.intro
thf(fact_5462_comm__monoid__axioms__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_axioms @ A )
      = ( ^ [F2: A > A > A,Z4: A] :
          ! [A5: A] :
            ( ( F2 @ A5 @ Z4 )
            = A5 ) ) ) ).

% comm_monoid_axioms_def
thf(fact_5463_abel__semigroup__axioms__def,axiom,
    ! [A: $tType] :
      ( ( abel_s757365448890700780axioms @ A )
      = ( ^ [F2: A > A > A] :
          ! [A5: A,B4: A] :
            ( ( F2 @ A5 @ B4 )
            = ( F2 @ B4 @ A5 ) ) ) ) ).

% abel_semigroup_axioms_def
thf(fact_5464_abel__semigroup_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: A > A > A] :
      ( ( abel_semigroup @ A @ F )
     => ( abel_s757365448890700780axioms @ A @ F ) ) ).

% abel_semigroup.axioms(2)
thf(fact_5465_comm__monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( comm_monoid @ A @ F @ Z2 )
     => ( comm_monoid_axioms @ A @ F @ Z2 ) ) ).

% comm_monoid.axioms(2)
thf(fact_5466_comm__monoid__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid @ A )
      = ( ^ [F2: A > A > A,Z4: A] :
            ( ( abel_semigroup @ A @ F2 )
            & ( comm_monoid_axioms @ A @ F2 @ Z4 ) ) ) ) ).

% comm_monoid_def
thf(fact_5467_ordering__def,axiom,
    ! [A: $tType] :
      ( ( ordering @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( partial_preordering @ A @ Less_eq2 )
            & ( ordering_axioms @ A @ Less_eq2 @ Less2 ) ) ) ) ).

% ordering_def
thf(fact_5468_ordering_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( partial_preordering @ A @ Less_eq )
     => ( ( ordering_axioms @ A @ Less_eq @ Less )
       => ( ordering @ A @ Less_eq @ Less ) ) ) ).

% ordering.intro
thf(fact_5469_prod__list_Omonoid__list__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( groups_monoid_list @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod_list.monoid_list_axioms
thf(fact_5470_order_Opartial__preordering__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( partial_preordering @ A @ ( ord_less_eq @ A ) ) ) ).

% order.partial_preordering_axioms
thf(fact_5471_partial__preordering__def,axiom,
    ! [A: $tType] :
      ( ( partial_preordering @ A )
      = ( ^ [Less_eq2: A > A > $o] :
            ( ! [A5: A] : ( Less_eq2 @ A5 @ A5 )
            & ! [A5: A,B4: A,C5: A] :
                ( ( Less_eq2 @ A5 @ B4 )
               => ( ( Less_eq2 @ B4 @ C5 )
                 => ( Less_eq2 @ A5 @ C5 ) ) ) ) ) ) ).

% partial_preordering_def
thf(fact_5472_partial__preordering_Otrans,axiom,
    ! [A: $tType,Less_eq: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( partial_preordering @ A @ Less_eq )
     => ( ( Less_eq @ A3 @ B2 )
       => ( ( Less_eq @ B2 @ C2 )
         => ( Less_eq @ A3 @ C2 ) ) ) ) ).

% partial_preordering.trans
thf(fact_5473_partial__preordering_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o] :
      ( ! [A8: A] : ( Less_eq @ A8 @ A8 )
     => ( ! [A8: A,B6: A,C4: A] :
            ( ( Less_eq @ A8 @ B6 )
           => ( ( Less_eq @ B6 @ C4 )
             => ( Less_eq @ A8 @ C4 ) ) )
       => ( partial_preordering @ A @ Less_eq ) ) ) ).

% partial_preordering.intro
thf(fact_5474_partial__preordering_Orefl,axiom,
    ! [A: $tType,Less_eq: A > A > $o,A3: A] :
      ( ( partial_preordering @ A @ Less_eq )
     => ( Less_eq @ A3 @ A3 ) ) ).

% partial_preordering.refl
thf(fact_5475_monoid__list_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( monoid @ A @ F @ Z2 )
     => ( groups_monoid_list @ A @ F @ Z2 ) ) ).

% monoid_list.intro
thf(fact_5476_monoid__list_Oaxioms,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( groups_monoid_list @ A @ F @ Z2 )
     => ( monoid @ A @ F @ Z2 ) ) ).

% monoid_list.axioms
thf(fact_5477_monoid__list__def,axiom,
    ! [A: $tType] :
      ( ( groups_monoid_list @ A )
      = ( monoid @ A ) ) ).

% monoid_list_def
thf(fact_5478_ordering_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( partial_preordering @ A @ Less_eq ) ) ).

% ordering.axioms(1)
thf(fact_5479_dual__order_Opartial__preordering__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( partial_preordering @ A
        @ ^ [X3: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X3 ) ) ) ).

% dual_order.partial_preordering_axioms
thf(fact_5480_semilattice__neutr_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( semilattice @ A @ F )
     => ( ( comm_monoid @ A @ F @ Z2 )
       => ( semilattice_neutr @ A @ F @ Z2 ) ) ) ).

% semilattice_neutr.intro
thf(fact_5481_semilattice__neutr__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_neutr @ A )
      = ( ^ [F2: A > A > A,Z4: A] :
            ( ( semilattice @ A @ F2 )
            & ( comm_monoid @ A @ F2 @ Z4 ) ) ) ) ).

% semilattice_neutr_def
thf(fact_5482_case__sum__o__map__sum__id,axiom,
    ! [A: $tType,B: $tType,C: $tType,G: B > A,F: C > A,X: sum_sum @ C @ B] :
      ( ( comp @ ( sum_sum @ A @ B ) @ A @ ( sum_sum @ C @ B ) @ ( sum_case_sum @ A @ A @ B @ ( id @ A ) @ G ) @ ( sum_map_sum @ C @ A @ B @ B @ F @ ( id @ B ) ) @ X )
      = ( sum_case_sum @ C @ A @ B @ ( comp @ C @ A @ C @ F @ ( id @ C ) ) @ G @ X ) ) ).

% case_sum_o_map_sum_id
thf(fact_5483_map__sum_Ocomp,axiom,
    ! [A: $tType,C: $tType,E: $tType,F9: $tType,D: $tType,B: $tType,F: C > E,G: D > F9,H2: A > C,I: B > D] :
      ( ( comp @ ( sum_sum @ C @ D ) @ ( sum_sum @ E @ F9 ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ C @ E @ D @ F9 @ F @ G ) @ ( sum_map_sum @ A @ C @ B @ D @ H2 @ I ) )
      = ( sum_map_sum @ A @ E @ B @ F9 @ ( comp @ C @ E @ A @ F @ H2 ) @ ( comp @ D @ F9 @ B @ G @ I ) ) ) ).

% map_sum.comp
thf(fact_5484_map__sum_Ocompositionality,axiom,
    ! [D: $tType,F9: $tType,E: $tType,C: $tType,B: $tType,A: $tType,F: C > E,G: D > F9,H2: A > C,I: B > D,Sum: sum_sum @ A @ B] :
      ( ( sum_map_sum @ C @ E @ D @ F9 @ F @ G @ ( sum_map_sum @ A @ C @ B @ D @ H2 @ I @ Sum ) )
      = ( sum_map_sum @ A @ E @ B @ F9 @ ( comp @ C @ E @ A @ F @ H2 ) @ ( comp @ D @ F9 @ B @ G @ I ) @ Sum ) ) ).

% map_sum.compositionality
thf(fact_5485_sum_Omap__comp,axiom,
    ! [D: $tType,F9: $tType,E: $tType,C: $tType,B: $tType,A: $tType,G1: C > E,G22: D > F9,F1: A > C,F22: B > D,V: sum_sum @ A @ B] :
      ( ( sum_map_sum @ C @ E @ D @ F9 @ G1 @ G22 @ ( sum_map_sum @ A @ C @ B @ D @ F1 @ F22 @ V ) )
      = ( sum_map_sum @ A @ E @ B @ F9 @ ( comp @ C @ E @ A @ G1 @ F1 ) @ ( comp @ D @ F9 @ B @ G22 @ F22 ) @ V ) ) ).

% sum.map_comp
thf(fact_5486_semilattice_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: A > A > A] :
      ( ( semilattice @ A @ F )
     => ( abel_semigroup @ A @ F ) ) ).

% semilattice.axioms(1)
thf(fact_5487_inf_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semilattice @ A @ ( inf_inf @ A ) ) ) ).

% inf.semilattice_axioms
thf(fact_5488_semilattice__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( semilattice @ A @ F ) ) ).

% semilattice_order.axioms(1)
thf(fact_5489_max_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice @ A @ ( ord_max @ A ) ) ) ).

% max.semilattice_axioms
thf(fact_5490_semilattice_Oidem,axiom,
    ! [A: $tType,F: A > A > A,A3: A] :
      ( ( semilattice @ A @ F )
     => ( ( F @ A3 @ A3 )
        = A3 ) ) ).

% semilattice.idem
thf(fact_5491_semilattice_Oleft__idem,axiom,
    ! [A: $tType,F: A > A > A,A3: A,B2: A] :
      ( ( semilattice @ A @ F )
     => ( ( F @ A3 @ ( F @ A3 @ B2 ) )
        = ( F @ A3 @ B2 ) ) ) ).

% semilattice.left_idem
thf(fact_5492_semilattice_Oright__idem,axiom,
    ! [A: $tType,F: A > A > A,A3: A,B2: A] :
      ( ( semilattice @ A @ F )
     => ( ( F @ ( F @ A3 @ B2 ) @ B2 )
        = ( F @ A3 @ B2 ) ) ) ).

% semilattice.right_idem
thf(fact_5493_min_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice @ A @ ( ord_min @ A ) ) ) ).

% min.semilattice_axioms
thf(fact_5494_semilattice__neutr_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( semilattice_neutr @ A @ F @ Z2 )
     => ( semilattice @ A @ F ) ) ).

% semilattice_neutr.axioms(1)
thf(fact_5495_sup_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semilattice @ A @ ( sup_sup @ A ) ) ) ).

% sup.semilattice_axioms
thf(fact_5496_case__sum__o__map__sum,axiom,
    ! [A: $tType,D: $tType,C: $tType,E: $tType,B: $tType,F: D > C,G: E > C,H12: A > D,H23: B > E] :
      ( ( comp @ ( sum_sum @ D @ E ) @ C @ ( sum_sum @ A @ B ) @ ( sum_case_sum @ D @ C @ E @ F @ G ) @ ( sum_map_sum @ A @ D @ B @ E @ H12 @ H23 ) )
      = ( sum_case_sum @ A @ C @ B @ ( comp @ D @ C @ A @ F @ H12 ) @ ( comp @ E @ C @ B @ G @ H23 ) ) ) ).

% case_sum_o_map_sum
thf(fact_5497_case__sum__map__sum,axiom,
    ! [C: $tType,A: $tType,B: $tType,E: $tType,D: $tType,L: B > A,R4: C > A,F: D > B,G: E > C,X: sum_sum @ D @ E] :
      ( ( sum_case_sum @ B @ A @ C @ L @ R4 @ ( sum_map_sum @ D @ B @ E @ C @ F @ G @ X ) )
      = ( sum_case_sum @ D @ A @ E @ ( comp @ B @ A @ D @ L @ F ) @ ( comp @ C @ A @ E @ R4 @ G ) @ X ) ) ).

% case_sum_map_sum
thf(fact_5498_sum_Osize__gen__o__map,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: C > nat,Fa: D > nat,G: A > C,Ga: B > D] :
      ( ( comp @ ( sum_sum @ C @ D ) @ nat @ ( sum_sum @ A @ B ) @ ( basic_BNF_size_sum @ C @ D @ F @ Fa ) @ ( sum_map_sum @ A @ C @ B @ D @ G @ Ga ) )
      = ( basic_BNF_size_sum @ A @ B @ ( comp @ C @ nat @ A @ F @ G ) @ ( comp @ D @ nat @ B @ Fa @ Ga ) ) ) ).

% sum.size_gen_o_map
thf(fact_5499_semilattice__def,axiom,
    ! [A: $tType] :
      ( ( semilattice @ A )
      = ( ^ [F2: A > A > A] :
            ( ( abel_semigroup @ A @ F2 )
            & ( semilattice_axioms @ A @ F2 ) ) ) ) ).

% semilattice_def
thf(fact_5500_semilattice_Ointro,axiom,
    ! [A: $tType,F: A > A > A] :
      ( ( abel_semigroup @ A @ F )
     => ( ( semilattice_axioms @ A @ F )
       => ( semilattice @ A @ F ) ) ) ).

% semilattice.intro
thf(fact_5501_semilattice__axioms__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_axioms @ A )
      = ( ^ [F2: A > A > A] :
          ! [A5: A] :
            ( ( F2 @ A5 @ A5 )
            = A5 ) ) ) ).

% semilattice_axioms_def
thf(fact_5502_semilattice__axioms_Ointro,axiom,
    ! [A: $tType,F: A > A > A] :
      ( ! [A8: A] :
          ( ( F @ A8 @ A8 )
          = A8 )
     => ( semilattice_axioms @ A @ F ) ) ).

% semilattice_axioms.intro
thf(fact_5503_semilattice_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: A > A > A] :
      ( ( semilattice @ A @ F )
     => ( semilattice_axioms @ A @ F ) ) ).

% semilattice.axioms(2)
thf(fact_5504_semilattice__order_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice @ A @ F )
     => ( ( semila6385135966242565138axioms @ A @ F @ Less_eq @ Less )
       => ( semilattice_order @ A @ F @ Less_eq @ Less ) ) ) ).

% semilattice_order.intro
thf(fact_5505_semilattice__order__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_order @ A )
      = ( ^ [F2: A > A > A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( semilattice @ A @ F2 )
            & ( semila6385135966242565138axioms @ A @ F2 @ Less_eq2 @ Less2 ) ) ) ) ).

% semilattice_order_def
thf(fact_5506_map__sum__o__inj_I1_J,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: A > B,G: D > C] :
      ( ( comp @ ( sum_sum @ A @ D ) @ ( sum_sum @ B @ C ) @ A @ ( sum_map_sum @ A @ B @ D @ C @ F @ G ) @ ( sum_Inl @ A @ D ) )
      = ( comp @ B @ ( sum_sum @ B @ C ) @ A @ ( sum_Inl @ B @ C ) @ F ) ) ).

% map_sum_o_inj(1)
thf(fact_5507_semilattice__order__axioms_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,F: A > A > A,Less: A > A > $o] :
      ( ! [A8: A,B6: A] :
          ( ( Less_eq @ A8 @ B6 )
          = ( A8
            = ( F @ A8 @ B6 ) ) )
     => ( ! [A8: A,B6: A] :
            ( ( Less @ A8 @ B6 )
            = ( ( A8
                = ( F @ A8 @ B6 ) )
              & ( A8 != B6 ) ) )
       => ( semila6385135966242565138axioms @ A @ F @ Less_eq @ Less ) ) ) ).

% semilattice_order_axioms.intro
thf(fact_5508_semilattice__order__axioms__def,axiom,
    ! [A: $tType] :
      ( ( semila6385135966242565138axioms @ A )
      = ( ^ [F2: A > A > A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ! [A5: A,B4: A] :
                ( ( Less_eq2 @ A5 @ B4 )
                = ( A5
                  = ( F2 @ A5 @ B4 ) ) )
            & ! [A5: A,B4: A] :
                ( ( Less2 @ A5 @ B4 )
                = ( ( A5
                    = ( F2 @ A5 @ B4 ) )
                  & ( A5 != B4 ) ) ) ) ) ) ).

% semilattice_order_axioms_def
thf(fact_5509_case__sum__o__inj_I1_J,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: A > B,G: C > B] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ ( sum_case_sum @ A @ B @ C @ F @ G ) @ ( sum_Inl @ A @ C ) )
      = F ) ).

% case_sum_o_inj(1)
thf(fact_5510_semilattice__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_order @ A @ F @ Less_eq @ Less )
     => ( semila6385135966242565138axioms @ A @ F @ Less_eq @ Less ) ) ).

% semilattice_order.axioms(2)
thf(fact_5511_prod_OPlus,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A4: set @ B,B3: set @ C,G: ( sum_sum @ B @ C ) > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ C @ B3 )
           => ( ( groups7121269368397514597t_prod @ ( sum_sum @ B @ C ) @ A @ G @ ( sum_Plus @ B @ C @ A4 @ B3 ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ ( comp @ ( sum_sum @ B @ C ) @ A @ B @ G @ ( sum_Inl @ B @ C ) ) @ A4 ) @ ( groups7121269368397514597t_prod @ C @ A @ ( comp @ ( sum_sum @ B @ C ) @ A @ C @ G @ ( sum_Inr @ C @ B ) ) @ B3 ) ) ) ) ) ) ).

% prod.Plus
thf(fact_5512_sum_OPlus,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,B3: set @ C,G: ( sum_sum @ B @ C ) > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ C @ B3 )
           => ( ( groups7311177749621191930dd_sum @ ( sum_sum @ B @ C ) @ A @ G @ ( sum_Plus @ B @ C @ A4 @ B3 ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ ( sum_sum @ B @ C ) @ A @ B @ G @ ( sum_Inl @ B @ C ) ) @ A4 ) @ ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ ( sum_sum @ B @ C ) @ A @ C @ G @ ( sum_Inr @ C @ B ) ) @ B3 ) ) ) ) ) ) ).

% sum.Plus
thf(fact_5513_card__order__csum__cone__cexp__def,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),A16: set @ B] :
      ( ( bNF_Ca8970107618336181345der_on @ A @ ( top_top @ ( set @ A ) ) @ R4 )
     => ( ( bNF_Cardinal_cexp @ ( sum_sum @ B @ product_unit ) @ A @ ( bNF_Cardinal_csum @ B @ product_unit @ ( bNF_Ca6860139660246222851ard_of @ B @ A16 ) @ bNF_Cardinal_cone ) @ R4 )
        = ( bNF_Ca6860139660246222851ard_of @ ( A > ( sum_sum @ B @ product_unit ) ) @ ( bNF_Wellorder_Func @ A @ ( sum_sum @ B @ product_unit ) @ ( top_top @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( sum_sum @ B @ product_unit ) ) @ ( image2 @ B @ ( sum_sum @ B @ product_unit ) @ ( sum_Inl @ B @ product_unit ) @ A16 ) @ ( insert2 @ ( sum_sum @ B @ product_unit ) @ ( sum_Inr @ product_unit @ B @ product_Unity ) @ ( bot_bot @ ( set @ ( sum_sum @ B @ product_unit ) ) ) ) ) ) ) ) ) ).

% card_order_csum_cone_cexp_def
thf(fact_5514_case__sum__o__inj_I2_J,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: A > B,G: C > B] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ C @ ( sum_case_sum @ A @ B @ C @ F @ G ) @ ( sum_Inr @ C @ A ) )
      = G ) ).

% case_sum_o_inj(2)
thf(fact_5515_case__sum__expand__Inr__pointfree,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: ( sum_sum @ A @ C ) > B,G: A > B] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( sum_case_sum @ A @ B @ C @ G @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) )
        = F ) ) ).

% case_sum_expand_Inr_pointfree
thf(fact_5516_case__sum__expand__Inr_H,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: ( sum_sum @ A @ C ) > B,G: A > B,H2: C > B] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( H2
          = ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) )
        = ( ( sum_case_sum @ A @ B @ C @ G @ H2 )
          = F ) ) ) ).

% case_sum_expand_Inr'
thf(fact_5517_case__sum__expand__Inr,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: ( sum_sum @ A @ C ) > B,G: A > B,X: sum_sum @ A @ C] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( F @ X )
        = ( sum_case_sum @ A @ B @ C @ G @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) @ X ) ) ) ).

% case_sum_expand_Inr
thf(fact_5518_map__sum__o__inj_I2_J,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F: A > B,G: D > C] :
      ( ( comp @ ( sum_sum @ A @ D ) @ ( sum_sum @ B @ C ) @ D @ ( sum_map_sum @ A @ B @ D @ C @ F @ G ) @ ( sum_Inr @ D @ A ) )
      = ( comp @ C @ ( sum_sum @ B @ C ) @ D @ ( sum_Inr @ C @ B ) @ G ) ) ).

% map_sum_o_inj(2)
thf(fact_5519_sum__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,X: A] :
      ( ( basic_setl @ A @ B @ ( sum_Inl @ A @ B @ X ) )
      = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% sum_set_simps(1)
thf(fact_5520_sum__set__simps_I4_J,axiom,
    ! [E: $tType,A: $tType,X: A] :
      ( ( basic_setr @ E @ A @ ( sum_Inr @ A @ E @ X ) )
      = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% sum_set_simps(4)
thf(fact_5521_Node__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( old_Node @ B @ A )
      = ( collect @ ( product_prod @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) )
        @ ^ [P6: product_prod @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat )] :
          ? [F2: nat > ( sum_sum @ B @ nat ),X3: sum_sum @ A @ nat,K4: nat] :
            ( ( P6
              = ( product_Pair @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat ) @ F2 @ X3 ) )
            & ( ( F2 @ K4 )
              = ( sum_Inr @ nat @ B @ ( zero_zero @ nat ) ) ) ) ) ) ).

% Node_def
thf(fact_5522_sum__set__simps_I2_J,axiom,
    ! [A: $tType,C: $tType,X: A] :
      ( ( basic_setl @ C @ A @ ( sum_Inr @ A @ C @ X ) )
      = ( bot_bot @ ( set @ C ) ) ) ).

% sum_set_simps(2)
thf(fact_5523_sum__set__simps_I3_J,axiom,
    ! [A: $tType,D: $tType,X: A] :
      ( ( basic_setr @ A @ D @ ( sum_Inl @ A @ D @ X ) )
      = ( bot_bot @ ( set @ D ) ) ) ).

% sum_set_simps(3)
thf(fact_5524_Node__K0__I,axiom,
    ! [B: $tType,A: $tType,A3: sum_sum @ B @ nat] :
      ( member @ ( product_prod @ ( nat > ( sum_sum @ A @ nat ) ) @ ( sum_sum @ B @ nat ) )
      @ ( product_Pair @ ( nat > ( sum_sum @ A @ nat ) ) @ ( sum_sum @ B @ nat )
        @ ^ [K4: nat] : ( sum_Inr @ nat @ A @ ( zero_zero @ nat ) )
        @ A3 )
      @ ( old_Node @ A @ B ) ) ).

% Node_K0_I
thf(fact_5525_sum__set__defs_I2_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( basic_setr @ C @ D )
      = ( sum_case_sum @ C @ ( set @ D ) @ D
        @ ^ [A5: C] : ( bot_bot @ ( set @ D ) )
        @ ^ [Z4: D] : ( insert2 @ D @ Z4 @ ( bot_bot @ ( set @ D ) ) ) ) ) ).

% sum_set_defs(2)
thf(fact_5526_sum__set__defs_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( basic_setl @ A @ B )
      = ( sum_case_sum @ A @ ( set @ A ) @ B
        @ ^ [Z4: A] : ( insert2 @ A @ Z4 @ ( bot_bot @ ( set @ A ) ) )
        @ ^ [B4: B] : ( bot_bot @ ( set @ A ) ) ) ) ).

% sum_set_defs(1)
thf(fact_5527_ndepth__K0,axiom,
    ! [A: $tType,B: $tType,X: sum_sum @ A @ nat] :
      ( ( old_ndepth @ A @ B
        @ ( old_Abs_Node @ B @ A
          @ ( product_Pair @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat )
            @ ^ [K4: nat] : ( sum_Inr @ nat @ B @ ( zero_zero @ nat ) )
            @ X ) ) )
      = ( zero_zero @ nat ) ) ).

% ndepth_K0
thf(fact_5528_Atom__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_Atom @ A @ B )
      = ( ^ [X3: sum_sum @ A @ nat] :
            ( insert2 @ ( old_node @ A @ B )
            @ ( old_Abs_Node @ B @ A
              @ ( product_Pair @ ( nat > ( sum_sum @ B @ nat ) ) @ ( sum_sum @ A @ nat )
                @ ^ [K4: nat] : ( sum_Inr @ nat @ B @ ( zero_zero @ nat ) )
                @ X3 ) )
            @ ( bot_bot @ ( set @ ( old_node @ A @ B ) ) ) ) ) ) ).

% Atom_def
thf(fact_5529_Leaf__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_Leaf @ A @ B )
      = ( comp @ ( sum_sum @ A @ nat ) @ ( set @ ( old_node @ A @ B ) ) @ A @ ( old_Atom @ A @ B ) @ ( sum_Inl @ A @ nat ) ) ) ).

% Leaf_def
thf(fact_5530_nth__item_Opinduct,axiom,
    ! [A0: nat,P: nat > $o] :
      ( ( accp @ nat @ nth_item_rel @ A0 )
     => ( ( ( accp @ nat @ nth_item_rel @ ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
       => ( ! [N3: nat] :
              ( ( accp @ nat @ nth_item_rel @ ( suc @ N3 ) )
             => ( ! [A14: nat,Aa4: nat] :
                    ( ( ( nat_sum_decode @ N3 )
                      = ( sum_Inl @ nat @ nat @ A14 ) )
                   => ( ( ( nat_sum_decode @ A14 )
                        = ( sum_Inl @ nat @ nat @ Aa4 ) )
                     => ( P @ Aa4 ) ) )
               => ( ! [A14: nat,B11: nat] :
                      ( ( ( nat_sum_decode @ N3 )
                        = ( sum_Inl @ nat @ nat @ A14 ) )
                     => ( ( ( nat_sum_decode @ A14 )
                          = ( sum_Inr @ nat @ nat @ B11 ) )
                       => ( P @ B11 ) ) )
                 => ( ! [B11: nat,Ba2: nat,X6: nat,Y5: nat] :
                        ( ( ( nat_sum_decode @ N3 )
                          = ( sum_Inr @ nat @ nat @ B11 ) )
                       => ( ( ( nat_sum_decode @ B11 )
                            = ( sum_Inr @ nat @ nat @ Ba2 ) )
                         => ( ( ( product_Pair @ nat @ nat @ X6 @ Y5 )
                              = ( nat_prod_decode @ Ba2 ) )
                           => ( P @ X6 ) ) ) )
                   => ( ! [B11: nat,Ba2: nat,X6: nat,Y5: nat] :
                          ( ( ( nat_sum_decode @ N3 )
                            = ( sum_Inr @ nat @ nat @ B11 ) )
                         => ( ( ( nat_sum_decode @ B11 )
                              = ( sum_Inr @ nat @ nat @ Ba2 ) )
                           => ( ( ( product_Pair @ nat @ nat @ X6 @ Y5 )
                                = ( nat_prod_decode @ Ba2 ) )
                             => ( P @ Y5 ) ) ) )
                     => ( P @ ( suc @ N3 ) ) ) ) ) ) )
         => ( P @ A0 ) ) ) ) ).

% nth_item.pinduct
thf(fact_5531_ntrunc__0,axiom,
    ! [B: $tType,A: $tType,M: set @ ( old_node @ A @ B )] :
      ( ( old_ntrunc @ A @ B @ ( zero_zero @ nat ) @ M )
      = ( bot_bot @ ( set @ ( old_node @ A @ B ) ) ) ) ).

% ntrunc_0
thf(fact_5532_ntrunc__o__equality,axiom,
    ! [C: $tType,B: $tType,A: $tType,H12: A > ( set @ ( old_node @ B @ C ) ),H23: A > ( set @ ( old_node @ B @ C ) )] :
      ( ! [K2: nat] :
          ( ( comp @ ( set @ ( old_node @ B @ C ) ) @ ( set @ ( old_node @ B @ C ) ) @ A @ ( old_ntrunc @ B @ C @ K2 ) @ H12 )
          = ( comp @ ( set @ ( old_node @ B @ C ) ) @ ( set @ ( old_node @ B @ C ) ) @ A @ ( old_ntrunc @ B @ C @ K2 ) @ H23 ) )
     => ( H12 = H23 ) ) ).

% ntrunc_o_equality
thf(fact_5533_list__decode_Opinduct,axiom,
    ! [A0: nat,P: nat > $o] :
      ( ( accp @ nat @ nat_list_decode_rel @ A0 )
     => ( ( ( accp @ nat @ nat_list_decode_rel @ ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
       => ( ! [N3: nat] :
              ( ( accp @ nat @ nat_list_decode_rel @ ( suc @ N3 ) )
             => ( ! [X6: nat,Y5: nat] :
                    ( ( ( product_Pair @ nat @ nat @ X6 @ Y5 )
                      = ( nat_prod_decode @ N3 ) )
                   => ( P @ Y5 ) )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ A0 ) ) ) ) ).

% list_decode.pinduct
thf(fact_5534_ntrunc__one__In0,axiom,
    ! [B: $tType,A: $tType,M: set @ ( old_node @ A @ B )] :
      ( ( old_ntrunc @ A @ B @ ( suc @ ( zero_zero @ nat ) ) @ ( old_In0 @ A @ B @ M ) )
      = ( bot_bot @ ( set @ ( old_node @ A @ B ) ) ) ) ).

% ntrunc_one_In0
thf(fact_5535_ntrunc__one__In1,axiom,
    ! [B: $tType,A: $tType,M: set @ ( old_node @ A @ B )] :
      ( ( old_ntrunc @ A @ B @ ( suc @ ( zero_zero @ nat ) ) @ ( old_In1 @ A @ B @ M ) )
      = ( bot_bot @ ( set @ ( old_node @ A @ B ) ) ) ) ).

% ntrunc_one_In1
thf(fact_5536_dsum__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_dsum @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),S6: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) )] :
            ( sup_sup @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
            @ ( complete_Sup_Sup @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
              @ ( image2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                @ ( product_case_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                  @ ^ [X3: set @ ( old_node @ A @ B ),X9: set @ ( old_node @ A @ B )] : ( insert2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_In0 @ A @ B @ X3 ) @ ( old_In0 @ A @ B @ X9 ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) ) ) )
                @ R5 ) )
            @ ( complete_Sup_Sup @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
              @ ( image2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                @ ( product_case_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                  @ ^ [Y2: set @ ( old_node @ A @ B ),Y7: set @ ( old_node @ A @ B )] : ( insert2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_In1 @ A @ B @ Y2 ) @ ( old_In1 @ A @ B @ Y7 ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) ) ) )
                @ S6 ) ) ) ) ) ).

% dsum_def
thf(fact_5537_Numb__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_Numb @ A @ B )
      = ( comp @ ( sum_sum @ A @ nat ) @ ( set @ ( old_node @ A @ B ) ) @ nat @ ( old_Atom @ A @ B ) @ ( sum_Inr @ nat @ A ) ) ) ).

% Numb_def
thf(fact_5538_dsumE,axiom,
    ! [B: $tType,A: $tType,W2: product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ),R4: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),S: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) )] :
      ( ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ W2 @ ( old_dsum @ A @ B @ R4 @ S ) )
     => ( ! [X2: set @ ( old_node @ A @ B ),X11: set @ ( old_node @ A @ B )] :
            ( ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ X2 @ X11 ) @ R4 )
           => ( W2
             != ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_In0 @ A @ B @ X2 ) @ ( old_In0 @ A @ B @ X11 ) ) ) )
       => ~ ! [Y3: set @ ( old_node @ A @ B ),Y9: set @ ( old_node @ A @ B )] :
              ( ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ Y3 @ Y9 ) @ S )
             => ( W2
               != ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_In1 @ A @ B @ Y3 ) @ ( old_In1 @ A @ B @ Y9 ) ) ) ) ) ) ).

% dsumE
thf(fact_5539_dsum__In1I,axiom,
    ! [B: $tType,A: $tType,N4: set @ ( old_node @ A @ B ),N8: set @ ( old_node @ A @ B ),S: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),R4: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) )] :
      ( ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ N4 @ N8 ) @ S )
     => ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_In1 @ A @ B @ N4 ) @ ( old_In1 @ A @ B @ N8 ) ) @ ( old_dsum @ A @ B @ R4 @ S ) ) ) ).

% dsum_In1I
thf(fact_5540_dsum__In0I,axiom,
    ! [B: $tType,A: $tType,M: set @ ( old_node @ A @ B ),M9: set @ ( old_node @ A @ B ),R4: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),S: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) )] :
      ( ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ M @ M9 ) @ R4 )
     => ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_In0 @ A @ B @ M ) @ ( old_In0 @ A @ B @ M9 ) ) @ ( old_dsum @ A @ B @ R4 @ S ) ) ) ).

% dsum_In0I
thf(fact_5541_dprod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_dprod @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),S6: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
            @ ( image2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
              @ ( product_case_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                @ ^ [X3: set @ ( old_node @ A @ B ),X9: set @ ( old_node @ A @ B )] :
                    ( complete_Sup_Sup @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                    @ ( image2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                      @ ( product_case_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) )
                        @ ^ [Y2: set @ ( old_node @ A @ B ),Y7: set @ ( old_node @ A @ B )] : ( insert2 @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_Scons @ A @ B @ X3 @ Y2 ) @ ( old_Scons @ A @ B @ X9 @ Y7 ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) ) ) ) )
                      @ S6 ) ) )
              @ R5 ) ) ) ) ).

% dprod_def
thf(fact_5542_dual__order_Opreordering__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( preordering @ A
        @ ^ [X3: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X3 )
        @ ^ [X3: A,Y2: A] : ( ord_less @ A @ Y2 @ X3 ) ) ) ).

% dual_order.preordering_axioms
thf(fact_5543_curr__def,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( bNF_Wellorder_curr @ A @ B @ C )
      = ( ^ [A10: set @ A,F2: ( product_prod @ A @ B ) > C,A5: A] :
            ( if @ ( B > C ) @ ( member @ A @ A5 @ A10 )
            @ ^ [B4: B] : ( F2 @ ( product_Pair @ A @ B @ A5 @ B4 ) )
            @ ( undefined @ ( B > C ) ) ) ) ) ).

% curr_def
thf(fact_5544_dprodI,axiom,
    ! [B: $tType,A: $tType,M: set @ ( old_node @ A @ B ),M9: set @ ( old_node @ A @ B ),R4: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),N4: set @ ( old_node @ A @ B ),N8: set @ ( old_node @ A @ B ),S: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) )] :
      ( ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ M @ M9 ) @ R4 )
     => ( ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ N4 @ N8 ) @ S )
       => ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_Scons @ A @ B @ M @ N4 ) @ ( old_Scons @ A @ B @ M9 @ N8 ) ) @ ( old_dprod @ A @ B @ R4 @ S ) ) ) ) ).

% dprodI
thf(fact_5545_dprodE,axiom,
    ! [B: $tType,A: $tType,C2: product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ),R4: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ),S: set @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) )] :
      ( ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ C2 @ ( old_dprod @ A @ B @ R4 @ S ) )
     => ~ ! [X2: set @ ( old_node @ A @ B ),Y3: set @ ( old_node @ A @ B ),X11: set @ ( old_node @ A @ B )] :
            ( ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ X2 @ X11 ) @ R4 )
           => ! [Y9: set @ ( old_node @ A @ B )] :
                ( ( member @ ( product_prod @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) ) @ ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ Y3 @ Y9 ) @ S )
               => ( C2
                 != ( product_Pair @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( old_node @ A @ B ) ) @ ( old_Scons @ A @ B @ X2 @ Y3 ) @ ( old_Scons @ A @ B @ X11 @ Y9 ) ) ) ) ) ) ).

% dprodE
thf(fact_5546_preordering__dualI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( preordering @ A
        @ ^ [A5: A,B4: A] : ( Less_eq @ B4 @ A5 )
        @ ^ [A5: A,B4: A] : ( Less @ B4 @ A5 ) )
     => ( preordering @ A @ Less_eq @ Less ) ) ).

% preordering_dualI
thf(fact_5547_preordering__strictI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ! [A8: A,B6: A] :
          ( ( Less_eq @ A8 @ B6 )
          = ( ( Less @ A8 @ B6 )
            | ( A8 = B6 ) ) )
     => ( ! [A8: A,B6: A] :
            ( ( Less @ A8 @ B6 )
           => ~ ( Less @ B6 @ A8 ) )
       => ( ! [A8: A] :
              ~ ( Less @ A8 @ A8 )
         => ( ! [A8: A,B6: A,C4: A] :
                ( ( Less @ A8 @ B6 )
               => ( ( Less @ B6 @ C4 )
                 => ( Less @ A8 @ C4 ) ) )
           => ( preordering @ A @ Less_eq @ Less ) ) ) ) ) ).

% preordering_strictI
thf(fact_5548_preordering_Ostrict__implies__order,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
       => ( Less_eq @ A3 @ B2 ) ) ) ).

% preordering.strict_implies_order
thf(fact_5549_preordering_Ostrict__iff__not,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
        = ( ( Less_eq @ A3 @ B2 )
          & ~ ( Less_eq @ B2 @ A3 ) ) ) ) ).

% preordering.strict_iff_not
thf(fact_5550_preordering_Ostrict__trans2,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
       => ( ( Less_eq @ B2 @ C2 )
         => ( Less @ A3 @ C2 ) ) ) ) ).

% preordering.strict_trans2
thf(fact_5551_preordering_Ostrict__trans1,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
       => ( ( Less @ B2 @ C2 )
         => ( Less @ A3 @ C2 ) ) ) ) ).

% preordering.strict_trans1
thf(fact_5552_preordering_Ostrict__trans,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
       => ( ( Less @ B2 @ C2 )
         => ( Less @ A3 @ C2 ) ) ) ) ).

% preordering.strict_trans
thf(fact_5553_preordering_Oirrefl,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ~ ( Less @ A3 @ A3 ) ) ).

% preordering.irrefl
thf(fact_5554_preordering_Oasym,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
       => ~ ( Less @ B2 @ A3 ) ) ) ).

% preordering.asym
thf(fact_5555_preordering_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( partial_preordering @ A @ Less_eq ) ) ).

% preordering.axioms(1)
thf(fact_5556_order_Opreordering__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( preordering @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% order.preordering_axioms
thf(fact_5557_preordering_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( partial_preordering @ A @ Less_eq )
     => ( ( preordering_axioms @ A @ Less_eq @ Less )
       => ( preordering @ A @ Less_eq @ Less ) ) ) ).

% preordering.intro
thf(fact_5558_preordering__def,axiom,
    ! [A: $tType] :
      ( ( preordering @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( partial_preordering @ A @ Less_eq2 )
            & ( preordering_axioms @ A @ Less_eq2 @ Less2 ) ) ) ) ).

% preordering_def
thf(fact_5559_preordering_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( preordering @ A @ Less_eq @ Less )
     => ( preordering_axioms @ A @ Less_eq @ Less ) ) ).

% preordering.axioms(2)
thf(fact_5560_preordering__axioms_Ointro,axiom,
    ! [A: $tType,Less: A > A > $o,Less_eq: A > A > $o] :
      ( ! [A8: A,B6: A] :
          ( ( Less @ A8 @ B6 )
          = ( ( Less_eq @ A8 @ B6 )
            & ~ ( Less_eq @ B6 @ A8 ) ) )
     => ( preordering_axioms @ A @ Less_eq @ Less ) ) ).

% preordering_axioms.intro
thf(fact_5561_preordering__axioms__def,axiom,
    ! [A: $tType] :
      ( ( preordering_axioms @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o] :
          ! [A5: A,B4: A] :
            ( ( Less2 @ A5 @ B4 )
            = ( ( Less_eq2 @ A5 @ B4 )
              & ~ ( Less_eq2 @ B4 @ A5 ) ) ) ) ) ).

% preordering_axioms_def
thf(fact_5562_rotate__add,axiom,
    ! [A: $tType,M4: nat,N: nat] :
      ( ( rotate @ A @ ( plus_plus @ nat @ M4 @ N ) )
      = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A ) @ ( rotate @ A @ M4 ) @ ( rotate @ A @ N ) ) ) ).

% rotate_add
thf(fact_5563_extract__def,axiom,
    ! [A: $tType] :
      ( ( extract @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( case_list @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ A @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ^ [Y2: A,Ys3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( takeWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Ys3 ) ) )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) ) ) ) ).

% extract_def
thf(fact_5564_relH__def,axiom,
    ( relH
    = ( ^ [As7: set @ nat,H3: heap_ext @ product_unit,H8: heap_ext @ product_unit] :
          ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As7 ) )
          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H8 @ As7 ) )
          & ! [T7: typerep,X3: nat] :
              ( ( member @ nat @ X3 @ As7 )
             => ( ( ( refs @ product_unit @ H3 @ T7 @ X3 )
                  = ( refs @ product_unit @ H8 @ T7 @ X3 ) )
                & ( ( arrays @ product_unit @ H3 @ T7 @ X3 )
                  = ( arrays @ product_unit @ H8 @ T7 @ X3 ) ) ) ) ) ) ) ).

% relH_def
thf(fact_5565_zip__takeWhile__snd,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,P: B > $o,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( takeWhile @ B @ P @ Ys ) )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ B @ $o @ ( product_prod @ A @ B ) @ P @ ( product_snd @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_takeWhile_snd
thf(fact_5566_zip__takeWhile__fst,axiom,
    ! [A: $tType,B: $tType,P: A > $o,Xs: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( takeWhile @ A @ P @ Xs ) @ Ys )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ A @ $o @ ( product_prod @ A @ B ) @ P @ ( product_fst @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_takeWhile_fst
thf(fact_5567_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F: B > A,Xs: list @ B] :
      ( ( takeWhile @ A @ P @ ( map @ B @ A @ F @ Xs ) )
      = ( map @ B @ A @ F @ ( takeWhile @ B @ ( comp @ A @ $o @ B @ P @ F ) @ Xs ) ) ) ).

% takeWhile_map
thf(fact_5568_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F: B > A,Xs: list @ B] :
      ( ( dropWhile @ A @ P @ ( map @ B @ A @ F @ Xs ) )
      = ( map @ B @ A @ F @ ( dropWhile @ B @ ( comp @ A @ $o @ B @ P @ F ) @ Xs ) ) ) ).

% dropWhile_map
thf(fact_5569_find__dropWhile,axiom,
    ! [A: $tType] :
      ( ( find @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( case_list @ ( option @ A ) @ A @ ( none @ A )
            @ ^ [X3: A,Xa4: list @ A] : ( some @ A @ X3 )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) ) ) ) ).

% find_dropWhile
thf(fact_5570_Ref__Time_Oget__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_get @ A )
        = ( ^ [H3: heap_ext @ product_unit] : ( comp @ nat @ A @ ( ref @ A ) @ ( comp @ nat @ A @ nat @ ( from_nat @ A ) @ ( refs @ product_unit @ H3 @ ( typerep_typerep @ A @ ( type2 @ A ) ) ) ) @ ( addr_of_ref @ A ) ) ) ) ) ).

% Ref_Time.get_def
thf(fact_5571_sum_Opred__map,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,Q1: C > $o,Q22: D > $o,F1: A > C,F22: B > D,X: sum_sum @ A @ B] :
      ( ( basic_pred_sum @ C @ D @ Q1 @ Q22 @ ( sum_map_sum @ A @ C @ B @ D @ F1 @ F22 @ X ) )
      = ( basic_pred_sum @ A @ B @ ( comp @ C @ $o @ A @ Q1 @ F1 ) @ ( comp @ D @ $o @ B @ Q22 @ F22 ) @ X ) ) ).

% sum.pred_map
thf(fact_5572_in__range_Opelims_I3_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( in_range @ X )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ X )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
               => ! [X2: nat] :
                    ( ( member @ nat @ X2 @ As2 )
                   => ( ord_less @ nat @ X2 @ ( lim @ product_unit @ H ) ) ) ) ) ) ) ).

% in_range.pelims(3)
thf(fact_5573_in__range_Opelims_I2_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( in_range @ X )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ X )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
               => ~ ! [X6: nat] :
                      ( ( member @ nat @ X6 @ As2 )
                     => ( ord_less @ nat @ X6 @ ( lim @ product_unit @ H ) ) ) ) ) ) ) ).

% in_range.pelims(2)
thf(fact_5574_in__range_Opelims_I1_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( in_range @ X )
        = Y )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ X )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( Y
                  = ( ! [X3: nat] :
                        ( ( member @ nat @ X3 @ As2 )
                       => ( ord_less @ nat @ X3 @ ( lim @ product_unit @ H ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) ) ) ) ).

% in_range.pelims(1)
thf(fact_5575_one__assn__raw_Opelims_I3_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( one_assn_raw @ X )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ X )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
               => ( As2
                  = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% one_assn_raw.pelims(3)
thf(fact_5576_one__assn__raw_Opelims_I2_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( one_assn_raw @ X )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ X )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
               => ( As2
                 != ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% one_assn_raw.pelims(2)
thf(fact_5577_one__assn__raw_Opelims_I1_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( one_assn_raw @ X )
        = Y )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ X )
       => ~ ! [H: heap_ext @ product_unit,As2: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) )
             => ( ( Y
                  = ( As2
                    = ( bot_bot @ ( set @ nat ) ) ) )
               => ~ ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As2 ) ) ) ) ) ) ).

% one_assn_raw.pelims(1)
thf(fact_5578_Enum_Ortranclp__rtrancl__eq,axiom,
    ! [A: $tType] :
      ( ( transitive_rtranclp @ A )
      = ( ^ [R5: A > A > $o,X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ ( transitive_rtrancl @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% Enum.rtranclp_rtrancl_eq
thf(fact_5579_rtrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_rtrancl @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ( transitive_rtranclp @ A
                @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 ) ) ) ) ) ) ).

% rtrancl_def
thf(fact_5580_Quotient__compose,axiom,
    ! [A: $tType,C: $tType,B: $tType,R12: A > A > $o,Abs1: A > B,Rep1: B > A,T1: A > B > $o,R23: B > B > $o,Abs22: B > C,Rep22: C > B,T22: B > C > $o] :
      ( ( quotient @ A @ B @ R12 @ Abs1 @ Rep1 @ T1 )
     => ( ( quotient @ B @ C @ R23 @ Abs22 @ Rep22 @ T22 )
       => ( quotient @ A @ C @ ( relcompp @ A @ B @ A @ T1 @ ( relcompp @ B @ B @ A @ R23 @ ( conversep @ A @ B @ T1 ) ) ) @ ( comp @ B @ C @ A @ Abs22 @ Abs1 ) @ ( comp @ B @ A @ C @ Rep1 @ Rep22 ) @ ( relcompp @ A @ B @ C @ T1 @ T22 ) ) ) ) ).

% Quotient_compose
thf(fact_5581_rtranclp__induct2,axiom,
    ! [A: $tType,B: $tType,R4: ( product_prod @ A @ B ) > ( product_prod @ A @ B ) > $o,Ax: A,Ay: B,Bx: A,By: B,P: A > B > $o] :
      ( ( transitive_rtranclp @ ( product_prod @ A @ B ) @ R4 @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) )
     => ( ( P @ Ax @ Ay )
       => ( ! [A8: A,B6: B,Aa2: A,Ba: B] :
              ( ( transitive_rtranclp @ ( product_prod @ A @ B ) @ R4 @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A8 @ B6 ) )
             => ( ( R4 @ ( product_Pair @ A @ B @ A8 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) )
               => ( ( P @ A8 @ B6 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% rtranclp_induct2
thf(fact_5582_converse__rtranclpE2,axiom,
    ! [A: $tType,B: $tType,R4: ( product_prod @ A @ B ) > ( product_prod @ A @ B ) > $o,Xa: A,Xb: B,Za2: A,Zb: B] :
      ( ( transitive_rtranclp @ ( product_prod @ A @ B ) @ R4 @ ( product_Pair @ A @ B @ Xa @ Xb ) @ ( product_Pair @ A @ B @ Za2 @ Zb ) )
     => ( ( ( product_Pair @ A @ B @ Xa @ Xb )
         != ( product_Pair @ A @ B @ Za2 @ Zb ) )
       => ~ ! [A8: A,B6: B] :
              ( ( R4 @ ( product_Pair @ A @ B @ Xa @ Xb ) @ ( product_Pair @ A @ B @ A8 @ B6 ) )
             => ~ ( transitive_rtranclp @ ( product_prod @ A @ B ) @ R4 @ ( product_Pair @ A @ B @ A8 @ B6 ) @ ( product_Pair @ A @ B @ Za2 @ Zb ) ) ) ) ) ).

% converse_rtranclpE2
thf(fact_5583_converse__rtranclp__induct2,axiom,
    ! [A: $tType,B: $tType,R4: ( product_prod @ A @ B ) > ( product_prod @ A @ B ) > $o,Ax: A,Ay: B,Bx: A,By: B,P: A > B > $o] :
      ( ( transitive_rtranclp @ ( product_prod @ A @ B ) @ R4 @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) )
     => ( ( P @ Bx @ By )
       => ( ! [A8: A,B6: B,Aa2: A,Ba: B] :
              ( ( R4 @ ( product_Pair @ A @ B @ A8 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) )
             => ( ( transitive_rtranclp @ ( product_prod @ A @ B ) @ R4 @ ( product_Pair @ A @ B @ Aa2 @ Ba ) @ ( product_Pair @ A @ B @ Bx @ By ) )
               => ( ( P @ Aa2 @ Ba )
                 => ( P @ A8 @ B6 ) ) ) )
         => ( P @ Ax @ Ay ) ) ) ) ).

% converse_rtranclp_induct2
thf(fact_5584_Heap_OQuotient,axiom,
    ! [B: $tType,A: $tType,R: A > A > $o,Abs: A > B,Rep: B > A,T3: A > B > $o] :
      ( ( quotient @ A @ B @ R @ Abs @ Rep @ T3 )
     => ( quotient @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ ( heap_Time_rel_Heap @ A @ A @ R ) @ ( heap_Time_map_Heap @ A @ B @ Abs ) @ ( heap_Time_map_Heap @ B @ A @ Rep ) @ ( heap_Time_rel_Heap @ A @ B @ T3 ) ) ) ).

% Heap.Quotient
thf(fact_5585_rtranclp__r__diff__Id,axiom,
    ! [A: $tType,R4: A > A > $o] :
      ( ( transitive_rtranclp @ A
        @ ( inf_inf @ ( A > A > $o ) @ R4
          @ ^ [X3: A,Y2: A] : ( X3 != Y2 ) ) )
      = ( transitive_rtranclp @ A @ R4 ) ) ).

% rtranclp_r_diff_Id
thf(fact_5586_Transitive__Closure_Ortranclp__rtrancl__eq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtranclp @ A
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) )
      = ( ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ).

% Transitive_Closure.rtranclp_rtrancl_eq
thf(fact_5587_accp__acc__eq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( accp @ A
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) )
      = ( ^ [X3: A] : ( member @ A @ X3 @ ( acc @ A @ R4 ) ) ) ) ).

% accp_acc_eq
thf(fact_5588_acc__def,axiom,
    ! [A: $tType] :
      ( ( acc @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ A
            @ ( accp @ A
              @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 ) ) ) ) ) ).

% acc_def
thf(fact_5589_map__mmupd__empty,axiom,
    ! [B: $tType,A: $tType,M4: A > ( option @ B ),V: B] :
      ( ( map_mmupd @ A @ B @ M4 @ ( bot_bot @ ( set @ A ) ) @ V )
      = M4 ) ).

% map_mmupd_empty
thf(fact_5590_acc_Ocases,axiom,
    ! [A: $tType,A3: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ A @ A3 @ ( acc @ A @ R4 ) )
     => ! [Y5: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ A3 ) @ R4 )
         => ( member @ A @ Y5 @ ( acc @ A @ R4 ) ) ) ) ).

% acc.cases
thf(fact_5591_acc_Osimps,axiom,
    ! [A: $tType,A3: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ A @ A3 @ ( acc @ A @ R4 ) )
      = ( ? [X3: A] :
            ( ( A3 = X3 )
            & ! [Y2: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R4 )
               => ( member @ A @ Y2 @ ( acc @ A @ R4 ) ) ) ) ) ) ).

% acc.simps
thf(fact_5592_acc_Ointros,axiom,
    ! [A: $tType,X: A,R4: set @ ( product_prod @ A @ A )] :
      ( ! [Y3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X ) @ R4 )
         => ( member @ A @ Y3 @ ( acc @ A @ R4 ) ) )
     => ( member @ A @ X @ ( acc @ A @ R4 ) ) ) ).

% acc.intros
thf(fact_5593_acc__induct,axiom,
    ! [A: $tType,A3: A,R4: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ A @ A3 @ ( acc @ A @ R4 ) )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( acc @ A @ R4 ) )
           => ( ! [Y5: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ X2 ) @ R4 )
                 => ( P @ Y5 ) )
             => ( P @ X2 ) ) )
       => ( P @ A3 ) ) ) ).

% acc_induct
thf(fact_5594_acc__downward,axiom,
    ! [A: $tType,B2: A,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( member @ A @ B2 @ ( acc @ A @ R4 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
       => ( member @ A @ A3 @ ( acc @ A @ R4 ) ) ) ) ).

% acc_downward
thf(fact_5595_not__acc__down,axiom,
    ! [A: $tType,X: A,R: set @ ( product_prod @ A @ A )] :
      ( ~ ( member @ A @ X @ ( acc @ A @ R ) )
     => ~ ! [Z3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ X ) @ R )
           => ( member @ A @ Z3 @ ( acc @ A @ R ) ) ) ) ).

% not_acc_down
thf(fact_5596_acc__induct__rule,axiom,
    ! [A: $tType,A3: A,R4: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ A @ A3 @ ( acc @ A @ R4 ) )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( acc @ A @ R4 ) )
           => ( ! [Y5: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ X2 ) @ R4 )
                 => ( P @ Y5 ) )
             => ( P @ X2 ) ) )
       => ( P @ A3 ) ) ) ).

% acc_induct_rule
thf(fact_5597_acc__subset__induct,axiom,
    ! [A: $tType,D4: set @ A,R: set @ ( product_prod @ A @ A ),X: A,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ D4 @ ( acc @ A @ R ) )
     => ( ! [X2: A,Z3: A] :
            ( ( member @ A @ X2 @ D4 )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ X2 ) @ R )
             => ( member @ A @ Z3 @ D4 ) ) )
       => ( ( member @ A @ X @ D4 )
         => ( ! [X2: A] :
                ( ( member @ A @ X2 @ D4 )
               => ( ! [Z6: A] :
                      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z6 @ X2 ) @ R )
                     => ( P @ Z6 ) )
                 => ( P @ X2 ) ) )
           => ( P @ X ) ) ) ) ) ).

% acc_subset_induct
thf(fact_5598_acc__downwards__aux,axiom,
    ! [A: $tType,B2: A,A3: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A3 ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( member @ A @ A3 @ ( acc @ A @ R4 ) )
       => ( member @ A @ B2 @ ( acc @ A @ R4 ) ) ) ) ).

% acc_downwards_aux
thf(fact_5599_acc__downwards,axiom,
    ! [A: $tType,A3: A,R4: set @ ( product_prod @ A @ A ),B2: A] :
      ( ( member @ A @ A3 @ ( acc @ A @ R4 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A3 ) @ ( transitive_rtrancl @ A @ R4 ) )
       => ( member @ A @ B2 @ ( acc @ A @ R4 ) ) ) ) ).

% acc_downwards
thf(fact_5600_or__not__num__neg_Opelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( ( bit_or_not_num_neg @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = one2 )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [M5: num] :
                  ( ( Xa
                    = ( bit0 @ M5 ) )
                 => ( ( Y
                      = ( bit1 @ M5 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ M5 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [M5: num] :
                    ( ( Xa
                      = ( bit1 @ M5 ) )
                   => ( ( Y
                        = ( bit1 @ M5 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ M5 ) ) ) ) ) )
             => ( ! [N3: num] :
                    ( ( X
                      = ( bit0 @ N3 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( bit0 @ one2 ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ one2 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X
                        = ( bit0 @ N3 ) )
                     => ! [M5: num] :
                          ( ( Xa
                            = ( bit0 @ M5 ) )
                         => ( ( Y
                              = ( bitM @ ( bit_or_not_num_neg @ N3 @ M5 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit0 @ M5 ) ) ) ) ) )
                 => ( ! [N3: num] :
                        ( ( X
                          = ( bit0 @ N3 ) )
                       => ! [M5: num] :
                            ( ( Xa
                              = ( bit1 @ M5 ) )
                           => ( ( Y
                                = ( bit0 @ ( bit_or_not_num_neg @ N3 @ M5 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit1 @ M5 ) ) ) ) ) )
                   => ( ! [N3: num] :
                          ( ( X
                            = ( bit1 @ N3 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y = one2 )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ one2 ) ) ) ) )
                     => ( ! [N3: num] :
                            ( ( X
                              = ( bit1 @ N3 ) )
                           => ! [M5: num] :
                                ( ( Xa
                                  = ( bit0 @ M5 ) )
                               => ( ( Y
                                    = ( bitM @ ( bit_or_not_num_neg @ N3 @ M5 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit0 @ M5 ) ) ) ) ) )
                       => ~ ! [N3: num] :
                              ( ( X
                                = ( bit1 @ N3 ) )
                             => ! [M5: num] :
                                  ( ( Xa
                                    = ( bit1 @ M5 ) )
                                 => ( ( Y
                                      = ( bitM @ ( bit_or_not_num_neg @ N3 @ M5 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit1 @ M5 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
thf(fact_5601_and__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y
                  = ( some @ num @ one2 ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit0 @ N3 ) )
                 => ( ( Y
                      = ( none @ num ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa
                      = ( bit1 @ N3 ) )
                   => ( ( Y
                        = ( some @ num @ one2 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M5: num] :
                    ( ( X
                      = ( bit0 @ M5 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( none @ num ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ one2 ) ) ) ) )
               => ( ! [M5: num] :
                      ( ( X
                        = ( bit0 @ M5 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit0 @ N3 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M5 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M5: num] :
                        ( ( X
                          = ( bit0 @ M5 ) )
                       => ! [N3: num] :
                            ( ( Xa
                              = ( bit1 @ N3 ) )
                           => ( ( Y
                                = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M5 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M5: num] :
                          ( ( X
                            = ( bit1 @ M5 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y
                                = ( some @ num @ one2 ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ one2 ) ) ) ) )
                     => ( ! [M5: num] :
                            ( ( X
                              = ( bit1 @ M5 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit0 @ N3 ) )
                               => ( ( Y
                                    = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M5 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X
                                = ( bit1 @ M5 ) )
                             => ! [N3: num] :
                                  ( ( Xa
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y
                                      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                        @ ^ [N9: num] : ( some @ num @ ( bit1 @ N9 ) )
                                        @ ( bit_un7362597486090784418nd_num @ M5 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
thf(fact_5602_and__not__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option @ num] :
      ( ( ( bit_and_not_num @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit0 @ N3 ) )
                 => ( ( Y
                      = ( some @ num @ one2 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa
                      = ( bit1 @ N3 ) )
                   => ( ( Y
                        = ( none @ num ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M5: num] :
                    ( ( X
                      = ( bit0 @ M5 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( some @ num @ ( bit0 @ M5 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ one2 ) ) ) ) )
               => ( ! [M5: num] :
                      ( ( X
                        = ( bit0 @ M5 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit0 @ N3 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M5 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M5: num] :
                        ( ( X
                          = ( bit0 @ M5 ) )
                       => ! [N3: num] :
                            ( ( Xa
                              = ( bit1 @ N3 ) )
                           => ( ( Y
                                = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M5 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M5: num] :
                          ( ( X
                            = ( bit1 @ M5 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y
                                = ( some @ num @ ( bit0 @ M5 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ one2 ) ) ) ) )
                     => ( ! [M5: num] :
                            ( ( X
                              = ( bit1 @ M5 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit0 @ N3 ) )
                               => ( ( Y
                                    = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                      @ ^ [N9: num] : ( some @ num @ ( bit1 @ N9 ) )
                                      @ ( bit_and_not_num @ M5 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X
                                = ( bit1 @ M5 ) )
                             => ! [N3: num] :
                                  ( ( Xa
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y
                                      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M5 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
thf(fact_5603_xor__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit0 @ N3 ) )
                 => ( ( Y
                      = ( some @ num @ ( bit1 @ N3 ) ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa
                      = ( bit1 @ N3 ) )
                   => ( ( Y
                        = ( some @ num @ ( bit0 @ N3 ) ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M5: num] :
                    ( ( X
                      = ( bit0 @ M5 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( some @ num @ ( bit1 @ M5 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ one2 ) ) ) ) )
               => ( ! [M5: num] :
                      ( ( X
                        = ( bit0 @ M5 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit0 @ N3 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M5 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M5: num] :
                        ( ( X
                          = ( bit0 @ M5 ) )
                       => ! [N3: num] :
                            ( ( Xa
                              = ( bit1 @ N3 ) )
                           => ( ( Y
                                = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M5 @ N3 ) ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M5: num] :
                          ( ( X
                            = ( bit1 @ M5 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y
                                = ( some @ num @ ( bit0 @ M5 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ one2 ) ) ) ) )
                     => ( ! [M5: num] :
                            ( ( X
                              = ( bit1 @ M5 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit0 @ N3 ) )
                               => ( ( Y
                                    = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M5 @ N3 ) ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X
                                = ( bit1 @ M5 ) )
                             => ! [N3: num] :
                                  ( ( Xa
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y
                                      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M5 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.pelims
thf(fact_5604_or__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( ( bit_un6697907153464112080or_num @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = one2 )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa
                    = ( bit0 @ N3 ) )
                 => ( ( Y
                      = ( bit1 @ N3 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa
                      = ( bit1 @ N3 ) )
                   => ( ( Y
                        = ( bit1 @ N3 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M5: num] :
                    ( ( X
                      = ( bit0 @ M5 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( bit1 @ M5 ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ one2 ) ) ) ) )
               => ( ! [M5: num] :
                      ( ( X
                        = ( bit0 @ M5 ) )
                     => ! [N3: num] :
                          ( ( Xa
                            = ( bit0 @ N3 ) )
                         => ( ( Y
                              = ( bit0 @ ( bit_un6697907153464112080or_num @ M5 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M5: num] :
                        ( ( X
                          = ( bit0 @ M5 ) )
                       => ! [N3: num] :
                            ( ( Xa
                              = ( bit1 @ N3 ) )
                           => ( ( Y
                                = ( bit1 @ ( bit_un6697907153464112080or_num @ M5 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M5 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M5: num] :
                          ( ( X
                            = ( bit1 @ M5 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y
                                = ( bit1 @ M5 ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ one2 ) ) ) ) )
                     => ( ! [M5: num] :
                            ( ( X
                              = ( bit1 @ M5 ) )
                           => ! [N3: num] :
                                ( ( Xa
                                  = ( bit0 @ N3 ) )
                               => ( ( Y
                                    = ( bit1 @ ( bit_un6697907153464112080or_num @ M5 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X
                                = ( bit1 @ M5 ) )
                             => ! [N3: num] :
                                  ( ( Xa
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y
                                      = ( bit1 @ ( bit_un6697907153464112080or_num @ M5 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M5 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_num.pelims
thf(fact_5605_take__bit__num__code,axiom,
    ( bit_take_bit_num
    = ( ^ [N5: nat,M3: num] :
          ( product_case_prod @ nat @ num @ ( option @ num )
          @ ^ [A5: nat,X3: num] :
              ( case_nat @ ( option @ num ) @ ( none @ num )
              @ ^ [O: nat] :
                  ( case_num @ ( option @ num ) @ ( some @ num @ one2 )
                  @ ^ [P6: num] :
                      ( case_option @ ( option @ num ) @ num @ ( none @ num )
                      @ ^ [Q8: num] : ( some @ num @ ( bit0 @ Q8 ) )
                      @ ( bit_take_bit_num @ O @ P6 ) )
                  @ ^ [P6: num] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ O @ P6 ) ) )
                  @ X3 )
              @ A5 )
          @ ( product_Pair @ nat @ num @ N5 @ M3 ) ) ) ) ).

% take_bit_num_code
thf(fact_5606_multiset_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q: B > $o,F: A > B,X: multiset @ A] :
      ( ( pred_mset @ B @ Q @ ( image_mset @ A @ B @ F @ X ) )
      = ( pred_mset @ A @ ( comp @ B @ $o @ A @ Q @ F ) @ X ) ) ).

% multiset.pred_map
thf(fact_5607_prod__mset_Ocomm__monoid__mset__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( comm_monoid_mset @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod_mset.comm_monoid_mset_axioms
thf(fact_5608_ac__operator_Osafe__commute,axiom,
    ! [A: $tType,F: A > A > A,X: A,Y: A,A3: A,B2: A] :
      ( ( syntax_ac_operator @ A @ F )
     => ( ( syntax7388354845996824322omatch @ A @ A @ ( F @ X @ Y ) @ A3 )
       => ( ( F @ A3 @ B2 )
          = ( F @ B2 @ A3 ) ) ) ) ).

% ac_operator.safe_commute
thf(fact_5609_mult_Oac__operator__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( syntax_ac_operator @ A @ ( times_times @ A ) ) ) ).

% mult.ac_operator_axioms
thf(fact_5610_ac__operator__def,axiom,
    ! [A: $tType] :
      ( ( syntax_ac_operator @ A )
      = ( ^ [F2: A > A > A] :
            ( ! [A5: A,B4: A,C5: A] :
                ( ( F2 @ ( F2 @ A5 @ B4 ) @ C5 )
                = ( F2 @ A5 @ ( F2 @ B4 @ C5 ) ) )
            & ! [A5: A,B4: A] :
                ( ( F2 @ A5 @ B4 )
                = ( F2 @ B4 @ A5 ) ) ) ) ) ).

% ac_operator_def
thf(fact_5611_ac__operator_Oright__commute,axiom,
    ! [A: $tType,F: A > A > A,A3: A,B2: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F )
     => ( ( F @ ( F @ A3 @ B2 ) @ C2 )
        = ( F @ ( F @ A3 @ C2 ) @ B2 ) ) ) ).

% ac_operator.right_commute
thf(fact_5612_ac__operator_Oleft__commute,axiom,
    ! [A: $tType,F: A > A > A,A3: A,B2: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F )
     => ( ( F @ A3 @ ( F @ B2 @ C2 ) )
        = ( F @ B2 @ ( F @ A3 @ C2 ) ) ) ) ).

% ac_operator.left_commute
thf(fact_5613_ac__operator_Oright__assoc,axiom,
    ! [A: $tType,F: A > A > A,A3: A,B2: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F )
     => ( ( F @ ( F @ A3 @ B2 ) @ C2 )
        = ( F @ A3 @ ( F @ B2 @ C2 ) ) ) ) ).

% ac_operator.right_assoc
thf(fact_5614_ac__operator_Oleft__assoc,axiom,
    ! [A: $tType,F: A > A > A,A3: A,B2: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F )
     => ( ( F @ A3 @ ( F @ B2 @ C2 ) )
        = ( F @ ( F @ A3 @ B2 ) @ C2 ) ) ) ).

% ac_operator.left_assoc
thf(fact_5615_ac__operator_Ocommute,axiom,
    ! [A: $tType,F: A > A > A,A3: A,B2: A] :
      ( ( syntax_ac_operator @ A @ F )
     => ( ( F @ A3 @ B2 )
        = ( F @ B2 @ A3 ) ) ) ).

% ac_operator.commute
thf(fact_5616_ac__operator_Ointro,axiom,
    ! [A: $tType,F: A > A > A] :
      ( ! [A8: A,B6: A,C4: A] :
          ( ( F @ ( F @ A8 @ B6 ) @ C4 )
          = ( F @ A8 @ ( F @ B6 @ C4 ) ) )
     => ( ! [A8: A,B6: A] :
            ( ( F @ A8 @ B6 )
            = ( F @ B6 @ A8 ) )
       => ( syntax_ac_operator @ A @ F ) ) ) ).

% ac_operator.intro
thf(fact_5617_add_Oac__operator__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( syntax_ac_operator @ A @ ( plus_plus @ A ) ) ) ).

% add.ac_operator_axioms
thf(fact_5618_successively_Opelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ( successively @ A @ X @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) )
         => ( ! [X2: A] :
                ( ( Xa
                  = ( cons @ A @ X2 @ ( nil @ A ) ) )
               => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )
           => ~ ! [X2: A,Y3: A,Xs4: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ X2 @ ( cons @ A @ Y3 @ Xs4 ) ) )
                 => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ ( cons @ A @ Y3 @ Xs4 ) ) ) )
                   => ~ ( ( X @ X2 @ Y3 )
                        & ( successively @ A @ X @ ( cons @ A @ Y3 @ Xs4 ) ) ) ) ) ) ) ) ) ).

% successively.pelims(2)
thf(fact_5619_successively_Opelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: $o] :
      ( ( ( successively @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
         => ( ! [X2: A] :
                ( ( Xa
                  = ( cons @ A @ X2 @ ( nil @ A ) ) )
               => ( Y
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) )
           => ~ ! [X2: A,Y3: A,Xs4: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ X2 @ ( cons @ A @ Y3 @ Xs4 ) ) )
                 => ( ( Y
                      = ( ( X @ X2 @ Y3 )
                        & ( successively @ A @ X @ ( cons @ A @ Y3 @ Xs4 ) ) ) )
                   => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ ( cons @ A @ Y3 @ Xs4 ) ) ) ) ) ) ) ) ) ) ).

% successively.pelims(1)
thf(fact_5620_bot__in__iterates,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [F: A > A] : ( member @ A @ ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) ) @ ( comple6359979572994053840erates @ A @ F ) ) ) ).

% bot_in_iterates
thf(fact_5621_successively_Opelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ~ ( successively @ A @ X @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ~ ! [X2: A,Y3: A,Xs4: list @ A] :
              ( ( Xa
                = ( cons @ A @ X2 @ ( cons @ A @ Y3 @ Xs4 ) ) )
             => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X2 @ ( cons @ A @ Y3 @ Xs4 ) ) ) )
               => ( ( X @ X2 @ Y3 )
                  & ( successively @ A @ X @ ( cons @ A @ Y3 @ Xs4 ) ) ) ) ) ) ) ).

% successively.pelims(3)
thf(fact_5622_sym__Int__converse,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] : ( sym @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( converse @ A @ A @ R4 ) ) ) ).

% sym_Int_converse
thf(fact_5623_comp__fun__idem__on__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite4980608107308702382axioms @ A @ B )
      = ( ^ [S7: set @ A,F2: A > B > B] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ S7 )
           => ( ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ X3 ) )
              = ( F2 @ X3 ) ) ) ) ) ).

% comp_fun_idem_on_axioms_def
thf(fact_5624_folding__idem__on__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite6916993218817215295axioms @ A @ B )
      = ( ^ [S7: set @ A,F2: A > B > B] :
          ! [X3: A,Y2: A] :
            ( ( member @ A @ X3 @ S7 )
           => ( ( member @ A @ Y2 @ S7 )
             => ( ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ X3 ) )
                = ( F2 @ X3 ) ) ) ) ) ) ).

% folding_idem_on_axioms_def
thf(fact_5625_symD,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B2: A,A3: A] :
      ( ( sym @ A @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A3 ) @ R4 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) ) ) ).

% symD
thf(fact_5626_symE,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),B2: A,A3: A] :
      ( ( sym @ A @ R4 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A3 ) @ R4 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) ) ) ).

% symE
thf(fact_5627_symI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ! [A8: A,B6: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A8 @ B6 ) @ R4 )
         => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A8 ) @ R4 ) )
     => ( sym @ A @ R4 ) ) ).

% symI
thf(fact_5628_sym__def,axiom,
    ! [A: $tType] :
      ( ( sym @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [X3: A,Y2: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R5 )
           => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X3 ) @ R5 ) ) ) ) ).

% sym_def
thf(fact_5629_sym__Int,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( sym @ A @ R4 )
     => ( ( sym @ A @ S )
       => ( sym @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S ) ) ) ) ).

% sym_Int
thf(fact_5630_folding__idem__on__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B] :
      ( ! [X2: A,Y3: A] :
          ( ( member @ A @ X2 @ S2 )
         => ( ( member @ A @ Y3 @ S2 )
           => ( ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ X2 ) )
              = ( F @ X2 ) ) ) )
     => ( finite6916993218817215295axioms @ A @ B @ S2 @ F ) ) ).

% folding_idem_on_axioms.intro
thf(fact_5631_comp__fun__idem__on__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ S2 )
         => ( ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ X2 ) )
            = ( F @ X2 ) ) )
     => ( finite4980608107308702382axioms @ A @ B @ S2 @ F ) ) ).

% comp_fun_idem_on_axioms.intro
thf(fact_5632_folding__idem__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType,F: A > B > B] :
      ( ! [X2: A] :
          ( ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ X2 ) )
          = ( F @ X2 ) )
     => ( finite7837460588564673216axioms @ A @ B @ F ) ) ).

% folding_idem_axioms.intro
thf(fact_5633_comp__fun__idem__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType,F: A > B > B] :
      ( ! [X2: A] :
          ( ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ X2 ) )
          = ( F @ X2 ) )
     => ( finite1981172056906289455axioms @ A @ B @ F ) ) ).

% comp_fun_idem_axioms.intro
thf(fact_5634_folding__idem__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite7837460588564673216axioms @ A @ B )
      = ( ^ [F2: A > B > B] :
          ! [X3: A] :
            ( ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ X3 ) )
            = ( F2 @ X3 ) ) ) ) ).

% folding_idem_axioms_def
thf(fact_5635_comp__fun__idem__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite1981172056906289455axioms @ A @ B )
      = ( ^ [F2: A > B > B] :
          ! [X3: A] :
            ( ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ X3 ) )
            = ( F2 @ X3 ) ) ) ) ).

% comp_fun_idem_axioms_def
thf(fact_5636_curry__conv,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_curry @ B @ C @ A )
      = ( ^ [F2: ( product_prod @ B @ C ) > A,A5: B,B4: C] : ( F2 @ ( product_Pair @ B @ C @ A5 @ B4 ) ) ) ) ).

% curry_conv
thf(fact_5637_vimage__right__total__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,B3: A > B > $o,A4: C > D > $o] :
      ( ( bi_unique @ A @ B @ B3 )
     => ( ( right_total @ C @ D @ A4 )
       => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( ( set @ A ) > ( set @ C ) ) @ ( ( set @ B ) > ( set @ D ) ) @ ( bNF_rel_fun @ C @ D @ A @ B @ A4 @ B3 ) @ ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( set @ C ) @ ( set @ D ) @ ( bNF_rel_set @ A @ B @ B3 ) @ ( bNF_rel_set @ C @ D @ A4 ) )
          @ ^ [F2: C > A,X8: set @ A] : ( inf_inf @ ( set @ C ) @ ( vimage @ C @ A @ F2 @ X8 ) @ ( collect @ C @ ( domainp @ C @ D @ A4 ) ) )
          @ ( vimage @ D @ B ) ) ) ) ).

% vimage_right_total_transfer
thf(fact_5638_uprod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( old_uprod @ A @ B )
      = ( ^ [A10: set @ ( set @ ( old_node @ A @ B ) ),B7: set @ ( set @ ( old_node @ A @ B ) )] :
            ( complete_Sup_Sup @ ( set @ ( set @ ( old_node @ A @ B ) ) )
            @ ( image2 @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( set @ ( old_node @ A @ B ) ) )
              @ ^ [X3: set @ ( old_node @ A @ B )] :
                  ( complete_Sup_Sup @ ( set @ ( set @ ( old_node @ A @ B ) ) )
                  @ ( image2 @ ( set @ ( old_node @ A @ B ) ) @ ( set @ ( set @ ( old_node @ A @ B ) ) )
                    @ ^ [Y2: set @ ( old_node @ A @ B )] : ( insert2 @ ( set @ ( old_node @ A @ B ) ) @ ( old_Scons @ A @ B @ X3 @ Y2 ) @ ( bot_bot @ ( set @ ( set @ ( old_node @ A @ B ) ) ) ) )
                    @ B7 ) )
              @ A10 ) ) ) ) ).

% uprod_def
thf(fact_5639_curryI,axiom,
    ! [A: $tType,B: $tType,F: ( product_prod @ A @ B ) > $o,A3: A,B2: B] :
      ( ( F @ ( product_Pair @ A @ B @ A3 @ B2 ) )
     => ( product_curry @ A @ B @ $o @ F @ A3 @ B2 ) ) ).

% curryI
thf(fact_5640_curryD,axiom,
    ! [A: $tType,B: $tType,F: ( product_prod @ A @ B ) > $o,A3: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A3 @ B2 )
     => ( F @ ( product_Pair @ A @ B @ A3 @ B2 ) ) ) ).

% curryD
thf(fact_5641_curryE,axiom,
    ! [A: $tType,B: $tType,F: ( product_prod @ A @ B ) > $o,A3: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A3 @ B2 )
     => ( F @ ( product_Pair @ A @ B @ A3 @ B2 ) ) ) ).

% curryE
thf(fact_5642_Heap_Obi__unique__rel,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( bi_unique @ A @ B @ R )
     => ( bi_unique @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ ( heap_Time_rel_Heap @ A @ B @ R ) ) ) ).

% Heap.bi_unique_rel
thf(fact_5643_Heap_Oright__total__rel,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( right_total @ A @ B @ R )
     => ( right_total @ ( heap_Time_Heap @ A ) @ ( heap_Time_Heap @ B ) @ ( heap_Time_rel_Heap @ A @ B @ R ) ) ) ).

% Heap.right_total_rel
thf(fact_5644_inter__transfer,axiom,
    ! [A: $tType,B: $tType,A4: A > B > $o] :
      ( ( bi_unique @ A @ B @ A4 )
     => ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( ( set @ A ) > ( set @ A ) ) @ ( ( set @ B ) > ( set @ B ) ) @ ( bNF_rel_set @ A @ B @ A4 ) @ ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A4 ) @ ( bNF_rel_set @ A @ B @ A4 ) ) @ ( inf_inf @ ( set @ A ) ) @ ( inf_inf @ ( set @ B ) ) ) ) ).

% inter_transfer
thf(fact_5645_right__total__Inter__transfer,axiom,
    ! [A: $tType,B: $tType,A4: A > B > $o] :
      ( ( bi_unique @ A @ B @ A4 )
     => ( ( right_total @ A @ B @ A4 )
       => ( bNF_rel_fun @ ( set @ ( set @ A ) ) @ ( set @ ( set @ B ) ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A4 ) ) @ ( bNF_rel_set @ A @ B @ A4 )
          @ ^ [S7: set @ ( set @ A )] : ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ S7 ) @ ( collect @ A @ ( domainp @ A @ B @ A4 ) ) )
          @ ( complete_Inf_Inf @ ( set @ B ) ) ) ) ) ).

% right_total_Inter_transfer
thf(fact_5646_right__total__Compl__transfer,axiom,
    ! [A: $tType,B: $tType,A4: A > B > $o] :
      ( ( bi_unique @ A @ B @ A4 )
     => ( ( right_total @ A @ B @ A4 )
       => ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A4 ) @ ( bNF_rel_set @ A @ B @ A4 )
          @ ^ [S7: set @ A] : ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ S7 ) @ ( collect @ A @ ( domainp @ A @ B @ A4 ) ) )
          @ ( uminus_uminus @ ( set @ B ) ) ) ) ) ).

% right_total_Compl_transfer
thf(fact_5647_curry__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_curry @ A @ B @ C )
      = ( ^ [C5: ( product_prod @ A @ B ) > C,X3: A,Y2: B] : ( C5 @ ( product_Pair @ A @ B @ X3 @ Y2 ) ) ) ) ).

% curry_def
thf(fact_5648_Rats__eq__range__of__rat__o__nat__to__rat__surj,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_Rats @ A )
        = ( image2 @ nat @ A @ ( comp @ rat @ A @ nat @ ( field_char_0_of_rat @ A ) @ nat_to_rat_surj ) @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% Rats_eq_range_of_rat_o_nat_to_rat_surj
thf(fact_5649_symp__sym__eq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( symp @ A
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) )
      = ( sym @ A @ R4 ) ) ).

% symp_sym_eq
thf(fact_5650_remove__rev__def,axiom,
    ! [A: $tType] :
      ( ( remove_rev @ A )
      = ( ^ [X3: A] :
            ( filter_rev @ A
            @ ( comp @ $o @ $o @ A @ (~)
              @ ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
                @ X3 ) ) ) ) ) ).

% remove_rev_def
thf(fact_5651_symp__inf,axiom,
    ! [A: $tType,R4: A > A > $o,S: A > A > $o] :
      ( ( symp @ A @ R4 )
     => ( ( symp @ A @ S )
       => ( symp @ A @ ( inf_inf @ ( A > A > $o ) @ R4 @ S ) ) ) ) ).

% symp_inf
thf(fact_5652_Heap_Orel__symp,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( ( symp @ A @ R )
     => ( symp @ ( heap_Time_Heap @ A ) @ ( heap_Time_rel_Heap @ A @ A @ R ) ) ) ).

% Heap.rel_symp
thf(fact_5653_Rats__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( member @ A @ A3 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( times_times @ A @ A3 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_mult
thf(fact_5654_Rats__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_1
thf(fact_5655_comm__monoid__set_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,M4: nat,N: nat,G: nat > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( ord_less_eq @ nat @ M4 @ N )
       => ( ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) )
          = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M4 ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ) ).

% comm_monoid_set.atLeastAtMost_shift_0
thf(fact_5656_comm__monoid__mult__class_Oprod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( groups_comm_monoid_F @ A @ B @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% comm_monoid_mult_class.prod_def
thf(fact_5657_eventually__prod__sequentially,axiom,
    ! [P: ( product_prod @ nat @ nat ) > $o] :
      ( ( eventually @ ( product_prod @ nat @ nat ) @ P @ ( prod_filter @ nat @ nat @ ( at_top @ nat ) @ ( at_top @ nat ) ) )
      = ( ? [N7: nat] :
          ! [M3: nat] :
            ( ( ord_less_eq @ nat @ N7 @ M3 )
           => ! [N5: nat] :
                ( ( ord_less_eq @ nat @ N7 @ N5 )
               => ( P @ ( product_Pair @ nat @ nat @ N5 @ M3 ) ) ) ) ) ) ).

% eventually_prod_sequentially
thf(fact_5658_trivial__limit__sequentially,axiom,
    ( at_top @ nat )
 != ( bot_bot @ ( filter @ nat ) ) ).

% trivial_limit_sequentially
thf(fact_5659_comm__monoid__set_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType,F: A > A > A,Z2: A,A4: set @ B,H2: B > C,G: C > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ! [X2: B,Y3: B] :
              ( ( member @ B @ X2 @ A4 )
             => ( ( member @ B @ Y3 @ A4 )
               => ( ( X2 != Y3 )
                 => ( ( ( H2 @ X2 )
                      = ( H2 @ Y3 ) )
                   => ( ( G @ ( H2 @ X2 ) )
                      = Z2 ) ) ) ) )
         => ( ( groups_comm_monoid_F @ A @ C @ F @ Z2 @ G @ ( image2 @ B @ C @ H2 @ A4 ) )
            = ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ ( comp @ C @ A @ B @ G @ H2 ) @ A4 ) ) ) ) ) ).

% comm_monoid_set.reindex_nontrivial
thf(fact_5660_comm__monoid__set_OUnion__comp,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,B3: set @ ( set @ B ),G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ! [X2: set @ B] :
            ( ( member @ ( set @ B ) @ X2 @ B3 )
           => ( finite_finite @ B @ X2 ) )
       => ( ! [A17: set @ B] :
              ( ( member @ ( set @ B ) @ A17 @ B3 )
             => ! [A25: set @ B] :
                  ( ( member @ ( set @ B ) @ A25 @ B3 )
                 => ( ( A17 != A25 )
                   => ! [X2: B] :
                        ( ( member @ B @ X2 @ A17 )
                       => ( ( member @ B @ X2 @ A25 )
                         => ( ( G @ X2 )
                            = Z2 ) ) ) ) ) )
         => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B3 ) )
            = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups_comm_monoid_F @ A @ ( set @ B ) @ F @ Z2 ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 ) @ G @ B3 ) ) ) ) ) ).

% comm_monoid_set.Union_comp
thf(fact_5661_comm__monoid__set_Oreindex,axiom,
    ! [C: $tType,A: $tType,B: $tType,F: A > A > A,Z2: A,H2: B > C,A4: set @ B,G: C > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( inj_on @ B @ C @ H2 @ A4 )
       => ( ( groups_comm_monoid_F @ A @ C @ F @ Z2 @ G @ ( image2 @ B @ C @ H2 @ A4 ) )
          = ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ ( comp @ C @ A @ B @ G @ H2 ) @ A4 ) ) ) ) ).

% comm_monoid_set.reindex
thf(fact_5662_comm__monoid__set_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,C3: set @ ( set @ B ),G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ! [X2: set @ B] :
            ( ( member @ ( set @ B ) @ X2 @ C3 )
           => ( finite_finite @ B @ X2 ) )
       => ( ! [X2: set @ B] :
              ( ( member @ ( set @ B ) @ X2 @ C3 )
             => ! [Xa3: set @ B] :
                  ( ( member @ ( set @ B ) @ Xa3 @ C3 )
                 => ( ( X2 != Xa3 )
                   => ( ( inf_inf @ ( set @ B ) @ X2 @ Xa3 )
                      = ( bot_bot @ ( set @ B ) ) ) ) ) )
         => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( complete_Sup_Sup @ ( set @ B ) @ C3 ) )
            = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups_comm_monoid_F @ A @ ( set @ B ) @ F @ Z2 ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 ) @ G @ C3 ) ) ) ) ) ).

% comm_monoid_set.Union_disjoint
thf(fact_5663_comm__monoid__set_OPlus,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: A > A > A,Z2: A,A4: set @ B,B3: set @ C,G: ( sum_sum @ B @ C ) > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ( finite_finite @ C @ B3 )
         => ( ( groups_comm_monoid_F @ A @ ( sum_sum @ B @ C ) @ F @ Z2 @ G @ ( sum_Plus @ B @ C @ A4 @ B3 ) )
            = ( F @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ ( comp @ ( sum_sum @ B @ C ) @ A @ B @ G @ ( sum_Inl @ B @ C ) ) @ A4 ) @ ( groups_comm_monoid_F @ A @ C @ F @ Z2 @ ( comp @ ( sum_sum @ B @ C ) @ A @ C @ G @ ( sum_Inr @ C @ B ) ) @ B3 ) ) ) ) ) ) ).

% comm_monoid_set.Plus
thf(fact_5664_comm__monoid__set_OatLeastLessThan__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F: A > A > A,Z2: A,H2: nat > B,M4: nat,N: nat,G: B > A] :
          ( ( groups778175481326437816id_set @ A @ F @ Z2 )
         => ( ( bij_betw @ nat @ B @ H2 @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) @ ( set_or7035219750837199246ssThan @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
           => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( set_or7035219750837199246ssThan @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
              = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ B @ A @ nat @ G @ H2 ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ) ) ).

% comm_monoid_set.atLeastLessThan_reindex
thf(fact_5665_comm__monoid__set_OatLeastAtMost__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F: A > A > A,Z2: A,H2: nat > B,M4: nat,N: nat,G: B > A] :
          ( ( groups778175481326437816id_set @ A @ F @ Z2 )
         => ( ( bij_betw @ nat @ B @ H2 @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) @ ( set_or1337092689740270186AtMost @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
           => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( set_or1337092689740270186AtMost @ B @ ( H2 @ M4 ) @ ( H2 @ N ) ) )
              = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ B @ A @ nat @ G @ H2 ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ) ) ).

% comm_monoid_set.atLeastAtMost_reindex
thf(fact_5666_comm__monoid__set_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: nat > A,M4: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% comm_monoid_set.atLeast_Suc_atMost_Suc_shift
thf(fact_5667_comm__monoid__set_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: nat > A,M4: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% comm_monoid_set.atLeast_Suc_lessThan_Suc_shift
thf(fact_5668_comm__monoid__set_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: int > A,M4: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ int @ F @ Z2 @ G @ ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% comm_monoid_set.atLeast_int_lessThan_int_shift
thf(fact_5669_comm__monoid__set_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: int > A,M4: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ int @ F @ Z2 @ G @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% comm_monoid_set.atLeast_int_atMost_int_shift
thf(fact_5670_comm__monoid__set_Oeq__fold,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,G: B > A,A4: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ A4 )
        = ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ F @ G ) @ Z2 @ A4 ) ) ) ).

% comm_monoid_set.eq_fold
thf(fact_5671_comm__monoid__set_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: nat > A,M4: nat,K: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M4 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% comm_monoid_set.atLeastAtMost_shift_bounds
thf(fact_5672_comm__monoid__set_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: nat > A,M4: nat,K: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M4 @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% comm_monoid_set.atLeastLessThan_shift_bounds
thf(fact_5673_comm__monoid__set_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
        = ( F @ ( G @ ( zero_zero @ nat ) ) @ ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% comm_monoid_set.atLeast0_atMost_Suc_shift
thf(fact_5674_comm__monoid__set_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: nat > A,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
        = ( F @ ( G @ ( zero_zero @ nat ) ) @ ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% comm_monoid_set.atLeast0_lessThan_Suc_shift
thf(fact_5675_comm__monoid__set_Ounion__inter,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,A4: set @ B,B3: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ( finite_finite @ B @ B3 )
         => ( ( F @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) )
            = ( F @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ A4 ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ B3 ) ) ) ) ) ) ).

% comm_monoid_set.union_inter
thf(fact_5676_comm__monoid__set_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,A4: set @ B,B3: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ( finite_finite @ B @ B3 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) )
               => ( ( G @ X2 )
                  = Z2 ) )
           => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
              = ( F @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ A4 ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ B3 ) ) ) ) ) ) ) ).

% comm_monoid_set.union_inter_neutral
thf(fact_5677_comm__monoid__set_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,A4: set @ B,B3: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ( finite_finite @ B @ B3 )
         => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
            = ( F @ ( F @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B3 ) ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ B3 @ A4 ) ) ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) ) ) ) ) ) ).

% comm_monoid_set.union_diff2
thf(fact_5678_prod_Ocomm__monoid__set__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( groups778175481326437816id_set @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod.comm_monoid_set_axioms
thf(fact_5679_comm__monoid__set_OIf__cases,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,A4: set @ B,P: B > $o,H2: B > A,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2
            @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( H2 @ X3 ) @ ( G @ X3 ) )
            @ A4 )
          = ( F @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ H2 @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A4 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% comm_monoid_set.If_cases
thf(fact_5680_comm__monoid__set_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,A4: set @ B,G: B > A,B3: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) )
          = ( groups_comm_monoid_F @ A @ B @ F @ Z2
            @ ^ [X3: B] : ( if @ A @ ( member @ B @ X3 @ B3 ) @ ( G @ X3 ) @ Z2 )
            @ A4 ) ) ) ) ).

% comm_monoid_set.inter_restrict
thf(fact_5681_comm__monoid__set_OInt__Diff,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,A4: set @ B,G: B > A,B3: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ A4 )
          = ( F @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ A4 @ B3 ) ) ) ) ) ) ).

% comm_monoid_set.Int_Diff
thf(fact_5682_comm__monoid__set_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,T3: set @ B,S2: set @ B,H2: B > A,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ T3 )
       => ( ( finite_finite @ B @ S2 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T3 @ S2 ) )
               => ( ( H2 @ I3 )
                  = Z2 ) )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S2 @ T3 ) )
                 => ( ( G @ I3 )
                    = Z2 ) )
             => ( ! [X2: B] :
                    ( ( member @ B @ X2 @ ( inf_inf @ ( set @ B ) @ S2 @ T3 ) )
                   => ( ( G @ X2 )
                      = ( H2 @ X2 ) ) )
               => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ S2 )
                  = ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ H2 @ T3 ) ) ) ) ) ) ) ) ).

% comm_monoid_set.mono_neutral_cong
thf(fact_5683_comm__monoid__set_Oremove,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,A4: set @ B,X: B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ( member @ B @ X @ A4 )
         => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ A4 )
            = ( F @ ( G @ X ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% comm_monoid_set.remove
thf(fact_5684_comm__monoid__set_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,A4: set @ B,G: B > A,X: B] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( insert2 @ B @ X @ A4 ) )
          = ( F @ ( G @ X ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% comm_monoid_set.insert_remove
thf(fact_5685_comm__monoid__set_Oempty,axiom,
    ! [B: $tType,A: $tType,F: A > A > A,Z2: A,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( bot_bot @ ( set @ B ) ) )
        = Z2 ) ) ).

% comm_monoid_set.empty
thf(fact_5686_comm__monoid__set_Odelta__remove,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,S2: set @ B,A3: B,B2: B > A,C2: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ S2 )
       => ( ( ( member @ B @ A3 @ S2 )
           => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2
                @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( C2 @ K4 ) )
                @ S2 )
              = ( F @ ( B2 @ A3 ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
          & ( ~ ( member @ B @ A3 @ S2 )
           => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2
                @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( C2 @ K4 ) )
                @ S2 )
              = ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% comm_monoid_set.delta_remove
thf(fact_5687_filtermap__sequentually__ne__bot,axiom,
    ! [A: $tType,F: nat > A] :
      ( ( filtermap @ nat @ A @ F @ ( at_top @ nat ) )
     != ( bot_bot @ ( filter @ A ) ) ) ).

% filtermap_sequentually_ne_bot
thf(fact_5688_trivial__limit__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( at_top @ A )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% trivial_limit_at_top_linorder
thf(fact_5689_comm__monoid__set_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType,F: A > A > A,Z2: A,A4: set @ B,B3: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ A4 )
       => ( ( finite_finite @ B @ B3 )
         => ( ( ( inf_inf @ ( set @ B ) @ A4 @ B3 )
              = ( bot_bot @ ( set @ B ) ) )
           => ( ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
              = ( F @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ A4 ) @ ( groups_comm_monoid_F @ A @ B @ F @ Z2 @ G @ B3 ) ) ) ) ) ) ) ).

% comm_monoid_set.union_disjoint
thf(fact_5690_comm__monoid__set_Oempty_H,axiom,
    ! [B: $tType,A: $tType,F: A > A > A,Z2: A,P4: B > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_G @ A @ B @ F @ Z2 @ P4 @ ( bot_bot @ ( set @ B ) ) )
        = Z2 ) ) ).

% comm_monoid_set.empty'
thf(fact_5691_comm__monoid__set_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: nat > A,M4: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) )
        = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M4 ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) ).

% comm_monoid_set.atLeastLessThan_shift_0
thf(fact_5692_comm__monoid__set_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: A > A > A,Z2: A,I4: set @ B,A4: B > ( set @ C ),G: C > A] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( finite_finite @ B @ I4 )
       => ( ! [X2: B] :
              ( ( member @ B @ X2 @ I4 )
             => ( finite_finite @ C @ ( A4 @ X2 ) ) )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ I4 )
               => ! [Xa3: B] :
                    ( ( member @ B @ Xa3 @ I4 )
                   => ( ( X2 != Xa3 )
                     => ( ( inf_inf @ ( set @ C ) @ ( A4 @ X2 ) @ ( A4 @ Xa3 ) )
                        = ( bot_bot @ ( set @ C ) ) ) ) ) )
           => ( ( groups_comm_monoid_F @ A @ C @ F @ Z2 @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A4 @ I4 ) ) )
              = ( groups_comm_monoid_F @ A @ B @ F @ Z2
                @ ^ [X3: B] : ( groups_comm_monoid_F @ A @ C @ F @ Z2 @ G @ ( A4 @ X3 ) )
                @ I4 ) ) ) ) ) ) ).

% comm_monoid_set.UNION_disjoint
thf(fact_5693_comm__monoid__set_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: nat > A,M4: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F @ Z2
          @ ( comp @ nat @ A @ nat @ G
            @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
          @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N ) ) ) ) ).

% comm_monoid_set.atLeast_atMost_pred_shift
thf(fact_5694_comm__monoid__set_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,G: nat > A,M4: nat,N: nat] :
      ( ( groups778175481326437816id_set @ A @ F @ Z2 )
     => ( ( groups_comm_monoid_F @ A @ nat @ F @ Z2
          @ ( comp @ nat @ A @ nat @ G
            @ ^ [N5: nat] : ( minus_minus @ nat @ N5 @ ( suc @ ( zero_zero @ nat ) ) ) )
          @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M4 ) @ ( suc @ N ) ) )
        = ( groups_comm_monoid_F @ A @ nat @ F @ Z2 @ G @ ( set_or7035219750837199246ssThan @ nat @ M4 @ N ) ) ) ) ).

% comm_monoid_set.atLeast_lessThan_pred_shift
thf(fact_5695_Nitpick_OEx1__unfold,axiom,
    ! [A: $tType] :
      ( ( ex1 @ A )
      = ( ^ [P3: A > $o] :
          ? [X3: A] :
            ( ( collect @ A @ P3 )
            = ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Nitpick.Ex1_unfold
thf(fact_5696_num__of__integer_Otransfer,axiom,
    ( bNF_rel_fun @ int @ code_integer @ num @ num @ code_pcr_integer
    @ ^ [Y4: num,Z5: num] : ( Y4 = Z5 )
    @ ( comp @ nat @ num @ int @ num_of_nat @ nat2 )
    @ code_num_of_integer ) ).

% num_of_integer.transfer
thf(fact_5697_num__of__integer__def,axiom,
    ( code_num_of_integer
    = ( map_fun @ code_integer @ int @ num @ num @ code_int_of_integer @ ( id @ num ) @ ( comp @ nat @ num @ int @ num_of_nat @ nat2 ) ) ) ).

% num_of_integer_def
thf(fact_5698_adm__wf__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( adm_wf @ A @ B )
      = ( ^ [R2: set @ ( product_prod @ A @ A ),F5: ( A > B ) > A > B] :
          ! [F2: A > B,G2: A > B,X3: A] :
            ( ! [Z4: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z4 @ X3 ) @ R2 )
               => ( ( F2 @ Z4 )
                  = ( G2 @ Z4 ) ) )
           => ( ( F5 @ F2 @ X3 )
              = ( F5 @ G2 @ X3 ) ) ) ) ) ).

% adm_wf_def
thf(fact_5699_list_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q: B > $o,F: A > B,X: list @ A] :
      ( ( list_all @ B @ Q @ ( map @ A @ B @ F @ X ) )
      = ( list_all @ A @ ( comp @ B @ $o @ A @ Q @ F ) @ X ) ) ).

% list.pred_map
thf(fact_5700_eventually__frequentlyE,axiom,
    ! [A: $tType,P: A > $o,F3: filter @ A,Q: A > $o] :
      ( ( eventually @ A @ P @ F3 )
     => ( ( eventually @ A
          @ ^ [X3: A] :
              ( ~ ( P @ X3 )
              | ( Q @ X3 ) )
          @ F3 )
       => ( ( F3
           != ( bot_bot @ ( filter @ A ) ) )
         => ( frequently @ A @ Q @ F3 ) ) ) ) ).

% eventually_frequentlyE
thf(fact_5701_frequently__const,axiom,
    ! [A: $tType,F3: filter @ A,P: $o] :
      ( ( F3
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( frequently @ A
          @ ^ [X3: A] : P
          @ F3 )
        = P ) ) ).

% frequently_const
thf(fact_5702_frequently__const__iff,axiom,
    ! [A: $tType,P: $o,F3: filter @ A] :
      ( ( frequently @ A
        @ ^ [X3: A] : P
        @ F3 )
      = ( P
        & ( F3
         != ( bot_bot @ ( filter @ A ) ) ) ) ) ).

% frequently_const_iff
thf(fact_5703_eventually__frequently,axiom,
    ! [A: $tType,F3: filter @ A,P: A > $o] :
      ( ( F3
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( eventually @ A @ P @ F3 )
       => ( frequently @ A @ P @ F3 ) ) ) ).

% eventually_frequently
thf(fact_5704_folding__idem_Ocomp__fun__idem,axiom,
    ! [B: $tType,A: $tType,F: A > B > B,X: A] :
      ( ( finite_folding_idem @ A @ B @ F )
     => ( ( comp @ B @ B @ B @ ( F @ X ) @ ( F @ X ) )
        = ( F @ X ) ) ) ).

% folding_idem.comp_fun_idem
thf(fact_5705_semilattice__neutr__set_Oremove,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,A4: set @ A,X: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F @ Z2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( member @ A @ X @ A4 )
         => ( ( lattic5214292709420241887eutr_F @ A @ F @ Z2 @ A4 )
            = ( F @ X @ ( lattic5214292709420241887eutr_F @ A @ F @ Z2 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% semilattice_neutr_set.remove
thf(fact_5706_semilattice__neutr__set_Oinsert__remove,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,A4: set @ A,X: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F @ Z2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( lattic5214292709420241887eutr_F @ A @ F @ Z2 @ ( insert2 @ A @ X @ A4 ) )
          = ( F @ X @ ( lattic5214292709420241887eutr_F @ A @ F @ Z2 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% semilattice_neutr_set.insert_remove
thf(fact_5707_semilattice__neutr__set_Ointro,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( semilattice_neutr @ A @ F @ Z2 )
     => ( lattic5652469242046573047tr_set @ A @ F @ Z2 ) ) ).

% semilattice_neutr_set.intro
thf(fact_5708_semilattice__neutr__set_Oaxioms,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F @ Z2 )
     => ( semilattice_neutr @ A @ F @ Z2 ) ) ).

% semilattice_neutr_set.axioms
thf(fact_5709_semilattice__neutr__set__def,axiom,
    ! [A: $tType] :
      ( ( lattic5652469242046573047tr_set @ A )
      = ( semilattice_neutr @ A ) ) ).

% semilattice_neutr_set_def
thf(fact_5710_semilattice__neutr__set_Oclosed,axiom,
    ! [A: $tType,F: A > A > A,Z2: A,A4: set @ A] :
      ( ( lattic5652469242046573047tr_set @ A @ F @ Z2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X2: A,Y3: A] : ( member @ A @ ( F @ X2 @ Y3 ) @ ( insert2 @ A @ X2 @ ( insert2 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
           => ( member @ A @ ( lattic5214292709420241887eutr_F @ A @ F @ Z2 @ A4 ) @ A4 ) ) ) ) ) ).

% semilattice_neutr_set.closed
thf(fact_5711_semilattice__neutr__set_Oempty,axiom,
    ! [A: $tType,F: A > A > A,Z2: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F @ Z2 )
     => ( ( lattic5214292709420241887eutr_F @ A @ F @ Z2 @ ( bot_bot @ ( set @ A ) ) )
        = Z2 ) ) ).

% semilattice_neutr_set.empty
thf(fact_5712_transp__trans__eq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( transp @ A
        @ ^ [X3: A,Y2: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R4 ) )
      = ( trans @ A @ R4 ) ) ).

% transp_trans_eq
thf(fact_5713_folding__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_folding @ A @ B )
      = ( ^ [F2: A > B > B] :
          ! [Y2: A,X3: A] :
            ( ( comp @ B @ B @ B @ ( F2 @ Y2 ) @ ( F2 @ X3 ) )
            = ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) ) ).

% folding_def
thf(fact_5714_folding__idem__on_Ocomp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F: A > B > B,X: A,Y: A] :
      ( ( finite1890593828518410140dem_on @ A @ B @ S2 @ F )
     => ( ( member @ A @ X @ S2 )
       => ( ( member @ A @ Y @ S2 )
         => ( ( comp @ B @ B @ B @ ( F @ X ) @ ( F @ X ) )
            = ( F @ X ) ) ) ) ) ).

% folding_idem_on.comp_fun_idem_on
thf(fact_5715_Heap_Orel__transp,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( ( transp @ A @ R )
     => ( transp @ ( heap_Time_Heap @ A ) @ ( heap_Time_rel_Heap @ A @ A @ R ) ) ) ).

% Heap.rel_transp
thf(fact_5716_transp__inf,axiom,
    ! [A: $tType,R4: A > A > $o,S: A > A > $o] :
      ( ( transp @ A @ R4 )
     => ( ( transp @ A @ S )
       => ( transp @ A @ ( inf_inf @ ( A > A > $o ) @ R4 @ S ) ) ) ) ).

% transp_inf
thf(fact_5717_folding_Ointro,axiom,
    ! [B: $tType,A: $tType,F: A > B > B] :
      ( ! [Y3: A,X2: A] :
          ( ( comp @ B @ B @ B @ ( F @ Y3 ) @ ( F @ X2 ) )
          = ( comp @ B @ B @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) )
     => ( finite_folding @ A @ B @ F ) ) ).

% folding.intro
thf(fact_5718_folding_Ocomp__fun__commute,axiom,
    ! [B: $tType,A: $tType,F: A > B > B,Y: A,X: A] :
      ( ( finite_folding @ A @ B @ F )
     => ( ( comp @ B @ B @ B @ ( F @ Y ) @ ( F @ X ) )
        = ( comp @ B @ B @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ).

% folding.comp_fun_commute
thf(fact_5719_random__aux__set_Ocases,axiom,
    ! [X: product_prod @ code_natural @ code_natural] :
      ( ! [J3: code_natural] :
          ( X
         != ( product_Pair @ code_natural @ code_natural @ ( zero_zero @ code_natural ) @ J3 ) )
     => ~ ! [I3: code_natural,J3: code_natural] :
            ( X
           != ( product_Pair @ code_natural @ code_natural @ ( code_Suc @ I3 ) @ J3 ) ) ) ).

% random_aux_set.cases
thf(fact_5720_is__empty__bot,axiom,
    ! [A: $tType] : ( is_empty @ A @ ( bot_bot @ ( pred @ A ) ) ) ).

% is_empty_bot
thf(fact_5721_Predicate_Ois__empty__def,axiom,
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A10: pred @ A] :
            ( A10
            = ( bot_bot @ ( pred @ A ) ) ) ) ) ).

% Predicate.is_empty_def
thf(fact_5722_trivial__limit__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( at_bot @ A )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% trivial_limit_at_bot_linorder

% Type constructors (840)
thf(tcon_Heap__Time__Monad_OHeap___Code__Evaluation_Oterm__of,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( heap_Time_Heap @ A20 ) ) ) ).

thf(tcon_Heap__Time__Monad_OHeap___Typerep_Otyperep,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( typerep2 @ ( heap_Time_Heap @ A20 ) ) ) ).

thf(tcon_Code__Numeral_Onatural___Code__Evaluation_Oterm__of_1,axiom,
    code_term_of @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Typerep_Otyperep_2,axiom,
    typerep2 @ code_natural ).

thf(tcon_Code__Numeral_Ointeger___Code__Evaluation_Oterm__of_3,axiom,
    code_term_of @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Typerep_Otyperep_4,axiom,
    typerep2 @ code_integer ).

thf(tcon_Code__Evaluation_Oterm___Code__Evaluation_Oterm__of_5,axiom,
    code_term_of @ code_term ).

thf(tcon_Code__Evaluation_Oterm___Typerep_Otyperep_6,axiom,
    typerep2 @ code_term ).

thf(tcon_Heap_Oheap_Oheap__ext___Code__Evaluation_Oterm__of_7,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( heap_ext @ A20 ) ) ) ).

thf(tcon_Heap_Oheap_Oheap__ext___Typerep_Otyperep_8,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( typerep2 @ ( heap_ext @ A20 ) ) ) ).

thf(tcon_Product__Type_Ounit___Code__Evaluation_Oterm__of_9,axiom,
    code_term_of @ product_unit ).

thf(tcon_Product__Type_Ounit___Enum_Oenum,axiom,
    enum @ product_unit ).

thf(tcon_Product__Type_Ounit___Typerep_Otyperep_10,axiom,
    typerep2 @ product_unit ).

thf(tcon_Product__Type_Oprod___Code__Evaluation_Oterm__of_11,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( typerep2 @ A20 )
        & ( typerep2 @ A21 ) )
     => ( code_term_of @ ( product_prod @ A20 @ A21 ) ) ) ).

thf(tcon_Product__Type_Oprod___Enum_Oenum_12,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( enum @ A20 )
        & ( enum @ A21 ) )
     => ( enum @ ( product_prod @ A20 @ A21 ) ) ) ).

thf(tcon_Product__Type_Oprod___Typerep_Otyperep_13,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( typerep2 @ A20 )
        & ( typerep2 @ A21 ) )
     => ( typerep2 @ ( product_prod @ A20 @ A21 ) ) ) ).

thf(tcon_Old__Datatype_Onode___Typerep_Otyperep_14,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( typerep2 @ A20 )
        & ( typerep2 @ A21 ) )
     => ( typerep2 @ ( old_node @ A20 @ A21 ) ) ) ).

thf(tcon_Multiset_Omultiset___Code__Evaluation_Oterm__of_15,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( multiset @ A20 ) ) ) ).

thf(tcon_Multiset_Omultiset___Typerep_Otyperep_16,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( typerep2 @ ( multiset @ A20 ) ) ) ).

thf(tcon_Typerep_Otyperep___Code__Evaluation_Oterm__of_17,axiom,
    code_term_of @ typerep ).

thf(tcon_Typerep_Otyperep___Typerep_Otyperep_18,axiom,
    typerep2 @ typerep ).

thf(tcon_Assertions_Oassn___Typerep_Otyperep_19,axiom,
    typerep2 @ assn ).

thf(tcon_Predicate_Opred___Code__Evaluation_Oterm__of_20,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( pred @ A20 ) ) ) ).

thf(tcon_Predicate_Opred___Typerep_Otyperep_21,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( typerep2 @ ( pred @ A20 ) ) ) ).

thf(tcon_Predicate_Oseq___Code__Evaluation_Oterm__of_22,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( seq @ A20 ) ) ) ).

thf(tcon_Predicate_Oseq___Typerep_Otyperep_23,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( typerep2 @ ( seq @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Code__Evaluation_Oterm__of_24,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Enum_Oenum_25,axiom,
    ! [A20: $tType] :
      ( ( enum @ A20 )
     => ( enum @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Typerep_Otyperep_26,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( typerep2 @ ( option @ A20 ) ) ) ).

thf(tcon_Filter_Ofilter___Code__Evaluation_Oterm__of_27,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( filter @ A20 ) ) ) ).

thf(tcon_Filter_Ofilter___Typerep_Otyperep_28,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( typerep2 @ ( filter @ A20 ) ) ) ).

thf(tcon_Sum__Type_Osum___Code__Evaluation_Oterm__of_29,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( typerep2 @ A20 )
        & ( typerep2 @ A21 ) )
     => ( code_term_of @ ( sum_sum @ A20 @ A21 ) ) ) ).

thf(tcon_Sum__Type_Osum___Enum_Oenum_30,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( enum @ A20 )
        & ( enum @ A21 ) )
     => ( enum @ ( sum_sum @ A20 @ A21 ) ) ) ).

thf(tcon_Sum__Type_Osum___Typerep_Otyperep_31,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( typerep2 @ A20 )
        & ( typerep2 @ A21 ) )
     => ( typerep2 @ ( sum_sum @ A20 @ A21 ) ) ) ).

thf(tcon_String_Ochar___Code__Evaluation_Oterm__of_32,axiom,
    code_term_of @ char ).

thf(tcon_String_Ochar___Enum_Oenum_33,axiom,
    enum @ char ).

thf(tcon_String_Ochar___Typerep_Otyperep_34,axiom,
    typerep2 @ char ).

thf(tcon_Heap_Oarray___Code__Evaluation_Oterm__of_35,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( array @ A20 ) ) ) ).

thf(tcon_Heap_Oarray___Typerep_Otyperep_36,axiom,
    ! [A20: $tType] : ( typerep2 @ ( array @ A20 ) ) ).

thf(tcon_List_Olist___Code__Evaluation_Oterm__of_37,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( list @ A20 ) ) ) ).

thf(tcon_List_Olist___Typerep_Otyperep_38,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( typerep2 @ ( list @ A20 ) ) ) ).

thf(tcon_Heap_Oref___Code__Evaluation_Oterm__of_39,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( ref @ A20 ) ) ) ).

thf(tcon_Heap_Oref___Typerep_Otyperep_40,axiom,
    ! [A20: $tType] : ( typerep2 @ ( ref @ A20 ) ) ).

thf(tcon_HOL_Obool___Code__Evaluation_Oterm__of_41,axiom,
    code_term_of @ $o ).

thf(tcon_HOL_Obool___Enum_Oenum_42,axiom,
    enum @ $o ).

thf(tcon_HOL_Obool___Typerep_Otyperep_43,axiom,
    typerep2 @ $o ).

thf(tcon_Set_Oset___Code__Evaluation_Oterm__of_44,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( set @ A20 ) ) ) ).

thf(tcon_Set_Oset___Enum_Oenum_45,axiom,
    ! [A20: $tType] :
      ( ( enum @ A20 )
     => ( enum @ ( set @ A20 ) ) ) ).

thf(tcon_Set_Oset___Typerep_Otyperep_46,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( typerep2 @ ( set @ A20 ) ) ) ).

thf(tcon_Rat_Orat___Code__Evaluation_Oterm__of_47,axiom,
    code_term_of @ rat ).

thf(tcon_Rat_Orat___Typerep_Otyperep_48,axiom,
    typerep2 @ rat ).

thf(tcon_Num_Onum___Code__Evaluation_Oterm__of_49,axiom,
    code_term_of @ num ).

thf(tcon_Num_Onum___Typerep_Otyperep_50,axiom,
    typerep2 @ num ).

thf(tcon_Nat_Onat___Code__Evaluation_Oterm__of_51,axiom,
    code_term_of @ nat ).

thf(tcon_Nat_Onat___Typerep_Otyperep_52,axiom,
    typerep2 @ nat ).

thf(tcon_Int_Oint___Code__Evaluation_Oterm__of_53,axiom,
    code_term_of @ int ).

thf(tcon_Int_Oint___Typerep_Otyperep_54,axiom,
    typerep2 @ int ).

thf(tcon_itself___Code__Evaluation_Oterm__of_55,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( code_term_of @ ( itself @ A20 ) ) ) ).

thf(tcon_itself___Typerep_Otyperep_56,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( typerep2 @ ( itself @ A20 ) ) ) ).

thf(tcon_fun___Code__Evaluation_Oterm__of_57,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( typerep2 @ A20 )
        & ( typerep2 @ A21 ) )
     => ( code_term_of @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Enum_Oenum_58,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( enum @ A20 )
        & ( enum @ A21 ) )
     => ( enum @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Typerep_Otyperep_59,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( typerep2 @ A20 )
        & ( typerep2 @ A21 ) )
     => ( typerep2 @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( comple6319245703460814977attice @ A21 )
     => ( condit1219197933456340205attice @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( comple592849572758109894attice @ A21 )
     => ( comple592849572758109894attice @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Quickcheck__Exhaustive_Ofull__exhaustive,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( cl_HOL_Oequal @ A20 )
        & ( quickc3360725361186068524ustive @ A20 )
        & ( quickc3360725361186068524ustive @ A21 ) )
     => ( quickc3360725361186068524ustive @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( bounded_lattice @ A21 )
     => ( bounde4967611905675639751up_bot @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( bounded_lattice @ A21 )
     => ( bounde4346867609351753570nf_top @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( comple6319245703460814977attice @ A21 )
     => ( comple6319245703460814977attice @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Quickcheck__Exhaustive_Oexhaustive,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( cl_HOL_Oequal @ A20 )
        & ( quickc658316121487927005ustive @ A20 )
        & ( quickc658316121487927005ustive @ A21 ) )
     => ( quickc658316121487927005ustive @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( boolea8198339166811842893lgebra @ A21 )
     => ( boolea8198339166811842893lgebra @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( bounded_lattice @ A21 )
     => ( bounded_lattice_top @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( bounded_lattice @ A21 )
     => ( bounded_lattice_bot @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Complete__Partial__Order_Occpo,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( comple6319245703460814977attice @ A21 )
     => ( comple9053668089753744459l_ccpo @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Quickcheck__Random_Orandom,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( code_term_of @ A20 )
        & ( cl_HOL_Oequal @ A20 )
        & ( quickcheck_random @ A21 ) )
     => ( quickcheck_random @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( semilattice_sup @ A21 )
     => ( semilattice_sup @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( semilattice_inf @ A21 )
     => ( semilattice_inf @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( distrib_lattice @ A21 )
     => ( distrib_lattice @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( bounded_lattice @ A21 )
     => ( bounded_lattice @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Complete__Lattices_OSup,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( complete_Sup @ A21 )
     => ( complete_Sup @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Complete__Lattices_OInf,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( complete_Inf @ A21 )
     => ( complete_Inf @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( order_top @ A21 )
     => ( order_top @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( order_bot @ A21 )
     => ( order_bot @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( preorder @ A21 )
     => ( preorder @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( lattice @ A21 )
     => ( lattice @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( order @ A21 )
     => ( order @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Orderings_Otop,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( top @ A21 )
     => ( top @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ord @ A21 )
     => ( ord @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Orderings_Obot,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( bot @ A21 )
     => ( bot @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( uminus @ A21 )
     => ( uminus @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Osup,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( semilattice_sup @ A21 )
     => ( sup @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Lattices_Oinf,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( semilattice_inf @ A21 )
     => ( inf @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___Groups_Ominus,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( minus @ A21 )
     => ( minus @ ( A20 > A21 ) ) ) ).

thf(tcon_fun___HOL_Oequal,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( enum @ A20 )
        & ( cl_HOL_Oequal @ A21 ) )
     => ( cl_HOL_Oequal @ ( A20 > A21 ) ) ) ).

thf(tcon_itself___Quickcheck__Random_Orandom_60,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( quickcheck_random @ ( itself @ A20 ) ) ) ).

thf(tcon_itself___HOL_Oequal_61,axiom,
    ! [A20: $tType] : ( cl_HOL_Oequal @ ( itself @ A20 ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_62,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Rings_Onormalization__semidom__multiplicative,axiom,
    normal6328177297339901930cative @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Quickcheck__Exhaustive_Ofull__exhaustive_63,axiom,
    quickc3360725361186068524ustive @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide__unit__factor,axiom,
    semido2269285787275462019factor @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Quickcheck__Exhaustive_Oexhaustive_64,axiom,
    quickc658316121487927005ustive @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Onormalization__semidom,axiom,
    normal8620421768224518004emidom @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Quickcheck__Random_Orandom_65,axiom,
    quickcheck_random @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_66,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_67,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Lattices_Odistrib__lattice_68,axiom,
    distrib_lattice @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Complete__Lattices_OSup_69,axiom,
    complete_Sup @ int ).

thf(tcon_Int_Oint___Complete__Lattices_OInf_70,axiom,
    complete_Inf @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_71,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_72,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_73,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Orderings_Oord_74,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_75,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Lattices_Osup_76,axiom,
    sup @ int ).

thf(tcon_Int_Oint___Lattices_Oinf_77,axiom,
    inf @ int ).

thf(tcon_Int_Oint___Groups_Otimes,axiom,
    times @ int ).

thf(tcon_Int_Oint___Groups_Ominus_78,axiom,
    minus @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Int_Oint___Heap_Oheap,axiom,
    heap @ int ).

thf(tcon_Int_Oint___HOL_Oequal_79,axiom,
    cl_HOL_Oequal @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_80,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_81,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_82,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_83,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_84,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_85,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_86,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_87,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Onormalization__semidom__multiplicative_88,axiom,
    normal6328177297339901930cative @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_89,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_90,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_91,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_92,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_93,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_94,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_95,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Quickcheck__Exhaustive_Ofull__exhaustive_96,axiom,
    quickc3360725361186068524ustive @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_97,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_98,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_99,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_100,axiom,
    linord4140545234300271783up_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_101,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide__unit__factor_102,axiom,
    semido2269285787275462019factor @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_103,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Quickcheck__Exhaustive_Oexhaustive_104,axiom,
    quickc658316121487927005ustive @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_105,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_106,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_107,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_108,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_109,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_110,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_111,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_112,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_113,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Rings_Onormalization__semidom_114,axiom,
    normal8620421768224518004emidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_115,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_116,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_117,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_118,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Quickcheck__Random_Orandom_119,axiom,
    quickcheck_random @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_120,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_121,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Lattices_Odistrib__lattice_122,axiom,
    distrib_lattice @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_123,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_124,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_125,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_126,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_127,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_128,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_129,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_130,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_131,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_132,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_133,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Complete__Lattices_OSup_134,axiom,
    complete_Sup @ nat ).

thf(tcon_Nat_Onat___Complete__Lattices_OInf_135,axiom,
    complete_Inf @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_136,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_137,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_138,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_139,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_140,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_141,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_142,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_143,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_144,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_145,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_146,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_147,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_148,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_149,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_150,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_151,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_152,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_153,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_154,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_155,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_156,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_157,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_158,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Orderings_Obot_159,axiom,
    bot @ nat ).

thf(tcon_Nat_Onat___Lattices_Osup_160,axiom,
    sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Oinf_161,axiom,
    inf @ nat ).

thf(tcon_Nat_Onat___Groups_Otimes_162,axiom,
    times @ nat ).

thf(tcon_Nat_Onat___Groups_Ominus_163,axiom,
    minus @ nat ).

thf(tcon_Nat_Onat___Power_Opower_164,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_165,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_166,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_167,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_168,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Heap_Oheap_169,axiom,
    heap @ nat ).

thf(tcon_Nat_Onat___HOL_Oequal_170,axiom,
    cl_HOL_Oequal @ nat ).

thf(tcon_Num_Onum___Quickcheck__Exhaustive_Ofull__exhaustive_171,axiom,
    quickc3360725361186068524ustive @ num ).

thf(tcon_Num_Onum___Quickcheck__Random_Orandom_172,axiom,
    quickcheck_random @ num ).

thf(tcon_Num_Onum___Orderings_Opreorder_173,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_174,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_175,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_176,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Otimes_177,axiom,
    times @ num ).

thf(tcon_Num_Onum___HOL_Oequal_178,axiom,
    cl_HOL_Oequal @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_179,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_180,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_181,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_182,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_183,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_184,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_185,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Quickcheck__Exhaustive_Ofull__exhaustive_186,axiom,
    quickc3360725361186068524ustive @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_187,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_188,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_189,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_190,axiom,
    linord4140545234300271783up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_191,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_192,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Quickcheck__Exhaustive_Oexhaustive_193,axiom,
    quickc658316121487927005ustive @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_194,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_195,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_196,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_197,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_198,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_199,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_200,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_201,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_202,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_203,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_204,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_205,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_206,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_207,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_208,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_209,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_210,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Quickcheck__Random_Orandom_211,axiom,
    quickcheck_random @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_212,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_213,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Lattices_Odistrib__lattice_214,axiom,
    distrib_lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_215,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_216,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_217,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_218,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_219,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_220,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_221,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_222,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_223,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_224,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_225,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_226,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_227,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_228,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_229,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_230,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_231,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_232,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_233,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_234,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_235,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_236,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_237,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_238,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_239,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_240,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_241,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_242,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_243,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_244,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_245,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_246,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_247,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_248,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_249,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_250,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_251,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_252,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_253,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_254,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_255,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Lattices_Osup_256,axiom,
    sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Oinf_257,axiom,
    inf @ rat ).

thf(tcon_Rat_Orat___Groups_Otimes_258,axiom,
    times @ rat ).

thf(tcon_Rat_Orat___Groups_Ominus_259,axiom,
    minus @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_260,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_261,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_262,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_263,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_264,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_265,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_266,axiom,
    dvd @ rat ).

thf(tcon_Rat_Orat___HOL_Oequal_267,axiom,
    cl_HOL_Oequal @ rat ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_268,axiom,
    ! [A20: $tType] : ( condit1219197933456340205attice @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_269,axiom,
    ! [A20: $tType] : ( comple592849572758109894attice @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Quickcheck__Exhaustive_Ofull__exhaustive_270,axiom,
    ! [A20: $tType] :
      ( ( quickc3360725361186068524ustive @ A20 )
     => ( quickc3360725361186068524ustive @ ( set @ A20 ) ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_271,axiom,
    ! [A20: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_272,axiom,
    ! [A20: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_273,axiom,
    ! [A20: $tType] : ( comple6319245703460814977attice @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Quickcheck__Exhaustive_Oexhaustive_274,axiom,
    ! [A20: $tType] :
      ( ( quickc658316121487927005ustive @ A20 )
     => ( quickc658316121487927005ustive @ ( set @ A20 ) ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_275,axiom,
    ! [A20: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_276,axiom,
    ! [A20: $tType] : ( bounded_lattice_top @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_277,axiom,
    ! [A20: $tType] : ( bounded_lattice_bot @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Complete__Partial__Order_Occpo_278,axiom,
    ! [A20: $tType] : ( comple9053668089753744459l_ccpo @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Quickcheck__Random_Orandom_279,axiom,
    ! [A20: $tType] :
      ( ( quickcheck_random @ A20 )
     => ( quickcheck_random @ ( set @ A20 ) ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_280,axiom,
    ! [A20: $tType] : ( semilattice_sup @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_281,axiom,
    ! [A20: $tType] : ( semilattice_inf @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_282,axiom,
    ! [A20: $tType] : ( distrib_lattice @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_283,axiom,
    ! [A20: $tType] : ( bounded_lattice @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_OSup_284,axiom,
    ! [A20: $tType] : ( complete_Sup @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_OInf_285,axiom,
    ! [A20: $tType] : ( complete_Inf @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_286,axiom,
    ! [A20: $tType] : ( order_top @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_287,axiom,
    ! [A20: $tType] : ( order_bot @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_288,axiom,
    ! [A20: $tType] : ( preorder @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_289,axiom,
    ! [A20: $tType] : ( lattice @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_290,axiom,
    ! [A20: $tType] : ( order @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Orderings_Otop_291,axiom,
    ! [A20: $tType] : ( top @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_292,axiom,
    ! [A20: $tType] : ( ord @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Orderings_Obot_293,axiom,
    ! [A20: $tType] : ( bot @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_294,axiom,
    ! [A20: $tType] : ( uminus @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Lattices_Osup_295,axiom,
    ! [A20: $tType] : ( sup @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Lattices_Oinf_296,axiom,
    ! [A20: $tType] : ( inf @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___Groups_Ominus_297,axiom,
    ! [A20: $tType] : ( minus @ ( set @ A20 ) ) ).

thf(tcon_Set_Oset___HOL_Oequal_298,axiom,
    ! [A20: $tType] :
      ( ( cl_HOL_Oequal @ A20 )
     => ( cl_HOL_Oequal @ ( set @ A20 ) ) ) ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_299,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_300,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Quickcheck__Exhaustive_Ofull__exhaustive_301,axiom,
    quickc3360725361186068524ustive @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_302,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_303,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_304,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_305,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_306,axiom,
    bounded_lattice_top @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_307,axiom,
    bounded_lattice_bot @ $o ).

thf(tcon_HOL_Obool___Complete__Partial__Order_Occpo_308,axiom,
    comple9053668089753744459l_ccpo @ $o ).

thf(tcon_HOL_Obool___Quickcheck__Random_Orandom_309,axiom,
    quickcheck_random @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_310,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_311,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_312,axiom,
    distrib_lattice @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_313,axiom,
    bounded_lattice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_OSup_314,axiom,
    complete_Sup @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_OInf_315,axiom,
    complete_Inf @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_316,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_317,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_318,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_319,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_320,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_321,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Otop_322,axiom,
    top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_323,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Orderings_Obot_324,axiom,
    bot @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_325,axiom,
    uminus @ $o ).

thf(tcon_HOL_Obool___Lattices_Osup_326,axiom,
    sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Oinf_327,axiom,
    inf @ $o ).

thf(tcon_HOL_Obool___Groups_Ominus_328,axiom,
    minus @ $o ).

thf(tcon_HOL_Obool___Heap_Oheap_329,axiom,
    heap @ $o ).

thf(tcon_HOL_Obool___HOL_Oequal_330,axiom,
    cl_HOL_Oequal @ $o ).

thf(tcon_Heap_Oref___Quickcheck__Exhaustive_Ofull__exhaustive_331,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( quickc3360725361186068524ustive @ ( ref @ A20 ) ) ) ).

thf(tcon_Heap_Oref___Quickcheck__Random_Orandom_332,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( quickcheck_random @ ( ref @ A20 ) ) ) ).

thf(tcon_Heap_Oref___Heap_Oheap_333,axiom,
    ! [A20: $tType] : ( heap @ ( ref @ A20 ) ) ).

thf(tcon_Heap_Oref___HOL_Oequal_334,axiom,
    ! [A20: $tType] : ( cl_HOL_Oequal @ ( ref @ A20 ) ) ).

thf(tcon_List_Olist___Quickcheck__Exhaustive_Ofull__exhaustive_335,axiom,
    ! [A20: $tType] :
      ( ( quickc3360725361186068524ustive @ A20 )
     => ( quickc3360725361186068524ustive @ ( list @ A20 ) ) ) ).

thf(tcon_List_Olist___Quickcheck__Random_Orandom_336,axiom,
    ! [A20: $tType] :
      ( ( quickcheck_random @ A20 )
     => ( quickcheck_random @ ( list @ A20 ) ) ) ).

thf(tcon_List_Olist___Heap_Oheap_337,axiom,
    ! [A20: $tType] :
      ( ( heap @ A20 )
     => ( heap @ ( list @ A20 ) ) ) ).

thf(tcon_List_Olist___HOL_Oequal_338,axiom,
    ! [A20: $tType] : ( cl_HOL_Oequal @ ( list @ A20 ) ) ).

thf(tcon_Heap_Oarray___Quickcheck__Exhaustive_Ofull__exhaustive_339,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( quickc3360725361186068524ustive @ ( array @ A20 ) ) ) ).

thf(tcon_Heap_Oarray___Quickcheck__Random_Orandom_340,axiom,
    ! [A20: $tType] :
      ( ( typerep2 @ A20 )
     => ( quickcheck_random @ ( array @ A20 ) ) ) ).

thf(tcon_Heap_Oarray___Heap_Oheap_341,axiom,
    ! [A20: $tType] : ( heap @ ( array @ A20 ) ) ).

thf(tcon_Heap_Oarray___HOL_Oequal_342,axiom,
    ! [A20: $tType] : ( cl_HOL_Oequal @ ( array @ A20 ) ) ).

thf(tcon_String_Ochar___Quickcheck__Exhaustive_Ofull__exhaustive_343,axiom,
    quickc3360725361186068524ustive @ char ).

thf(tcon_String_Ochar___Quickcheck__Random_Orandom_344,axiom,
    quickcheck_random @ char ).

thf(tcon_String_Ochar___Heap_Oheap_345,axiom,
    heap @ char ).

thf(tcon_String_Ochar___HOL_Oequal_346,axiom,
    cl_HOL_Oequal @ char ).

thf(tcon_Sum__Type_Osum___Quickcheck__Exhaustive_Ofull__exhaustive_347,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( quickc3360725361186068524ustive @ A20 )
        & ( quickc3360725361186068524ustive @ A21 ) )
     => ( quickc3360725361186068524ustive @ ( sum_sum @ A20 @ A21 ) ) ) ).

thf(tcon_Sum__Type_Osum___Quickcheck__Random_Orandom_348,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( quickcheck_random @ A20 )
        & ( quickcheck_random @ A21 ) )
     => ( quickcheck_random @ ( sum_sum @ A20 @ A21 ) ) ) ).

thf(tcon_Sum__Type_Osum___Heap_Oheap_349,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( heap @ A20 )
        & ( heap @ A21 ) )
     => ( heap @ ( sum_sum @ A20 @ A21 ) ) ) ).

thf(tcon_Sum__Type_Osum___HOL_Oequal_350,axiom,
    ! [A20: $tType,A21: $tType] : ( cl_HOL_Oequal @ ( sum_sum @ A20 @ A21 ) ) ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_351,axiom,
    ! [A20: $tType] : ( condit1219197933456340205attice @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_352,axiom,
    ! [A20: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_353,axiom,
    ! [A20: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_354,axiom,
    ! [A20: $tType] : ( comple6319245703460814977attice @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice__top_355,axiom,
    ! [A20: $tType] : ( bounded_lattice_top @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice__bot_356,axiom,
    ! [A20: $tType] : ( bounded_lattice_bot @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Partial__Order_Occpo_357,axiom,
    ! [A20: $tType] : ( comple9053668089753744459l_ccpo @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_358,axiom,
    ! [A20: $tType] : ( semilattice_sup @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_359,axiom,
    ! [A20: $tType] : ( semilattice_inf @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_360,axiom,
    ! [A20: $tType] : ( distrib_lattice @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_361,axiom,
    ! [A20: $tType] : ( bounded_lattice @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_OSup_362,axiom,
    ! [A20: $tType] : ( complete_Sup @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_OInf_363,axiom,
    ! [A20: $tType] : ( complete_Inf @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_364,axiom,
    ! [A20: $tType] : ( order_top @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_365,axiom,
    ! [A20: $tType] : ( order_bot @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_366,axiom,
    ! [A20: $tType] : ( preorder @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_367,axiom,
    ! [A20: $tType] : ( lattice @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_368,axiom,
    ! [A20: $tType] : ( order @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Otop_369,axiom,
    ! [A20: $tType] : ( top @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_370,axiom,
    ! [A20: $tType] : ( ord @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Obot_371,axiom,
    ! [A20: $tType] : ( bot @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osup_372,axiom,
    ! [A20: $tType] : ( sup @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Oinf_373,axiom,
    ! [A20: $tType] : ( inf @ ( filter @ A20 ) ) ).

thf(tcon_Filter_Ofilter___HOL_Oequal_374,axiom,
    ! [A20: $tType] :
      ( ( cl_HOL_Oequal @ A20 )
     => ( cl_HOL_Oequal @ ( filter @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_375,axiom,
    ! [A20: $tType] :
      ( ( comple5582772986160207858norder @ A20 )
     => ( condit6923001295902523014norder @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_376,axiom,
    ! [A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( condit1219197933456340205attice @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_Ocomplete__distrib__lattice_377,axiom,
    ! [A20: $tType] :
      ( ( comple592849572758109894attice @ A20 )
     => ( comple592849572758109894attice @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Quickcheck__Exhaustive_Ofull__exhaustive_378,axiom,
    ! [A20: $tType] :
      ( ( quickc3360725361186068524ustive @ A20 )
     => ( quickc3360725361186068524ustive @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__semilattice__sup__bot_379,axiom,
    ! [A20: $tType] :
      ( ( lattice @ A20 )
     => ( bounde4967611905675639751up_bot @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__semilattice__inf__top_380,axiom,
    ! [A20: $tType] :
      ( ( bounded_lattice_top @ A20 )
     => ( bounde4346867609351753570nf_top @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_Ocomplete__linorder,axiom,
    ! [A20: $tType] :
      ( ( comple5582772986160207858norder @ A20 )
     => ( comple5582772986160207858norder @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_Ocomplete__lattice_381,axiom,
    ! [A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( comple6319245703460814977attice @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__lattice__top_382,axiom,
    ! [A20: $tType] :
      ( ( bounded_lattice_top @ A20 )
     => ( bounded_lattice_top @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__lattice__bot_383,axiom,
    ! [A20: $tType] :
      ( ( lattice @ A20 )
     => ( bounded_lattice_bot @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Partial__Order_Occpo_384,axiom,
    ! [A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( comple9053668089753744459l_ccpo @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Quickcheck__Random_Orandom_385,axiom,
    ! [A20: $tType] :
      ( ( quickcheck_random @ A20 )
     => ( quickcheck_random @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Osemilattice__sup_386,axiom,
    ! [A20: $tType] :
      ( ( semilattice_sup @ A20 )
     => ( semilattice_sup @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Osemilattice__inf_387,axiom,
    ! [A20: $tType] :
      ( ( semilattice_inf @ A20 )
     => ( semilattice_inf @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Odistrib__lattice_388,axiom,
    ! [A20: $tType] :
      ( ( distrib_lattice @ A20 )
     => ( distrib_lattice @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__lattice_389,axiom,
    ! [A20: $tType] :
      ( ( bounded_lattice_top @ A20 )
     => ( bounded_lattice @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_OSup_390,axiom,
    ! [A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( complete_Sup @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_OInf_391,axiom,
    ! [A20: $tType] :
      ( ( comple6319245703460814977attice @ A20 )
     => ( complete_Inf @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Owellorder_392,axiom,
    ! [A20: $tType] :
      ( ( wellorder @ A20 )
     => ( wellorder @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Oorder__top_393,axiom,
    ! [A20: $tType] :
      ( ( order_top @ A20 )
     => ( order_top @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Oorder__bot_394,axiom,
    ! [A20: $tType] :
      ( ( order @ A20 )
     => ( order_bot @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Opreorder_395,axiom,
    ! [A20: $tType] :
      ( ( preorder @ A20 )
     => ( preorder @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Olinorder_396,axiom,
    ! [A20: $tType] :
      ( ( linorder @ A20 )
     => ( linorder @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Olattice_397,axiom,
    ! [A20: $tType] :
      ( ( lattice @ A20 )
     => ( lattice @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Oorder_398,axiom,
    ! [A20: $tType] :
      ( ( order @ A20 )
     => ( order @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Otop_399,axiom,
    ! [A20: $tType] :
      ( ( order_top @ A20 )
     => ( top @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Oord_400,axiom,
    ! [A20: $tType] :
      ( ( preorder @ A20 )
     => ( ord @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Obot_401,axiom,
    ! [A20: $tType] :
      ( ( order @ A20 )
     => ( bot @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Osup_402,axiom,
    ! [A20: $tType] :
      ( ( sup @ A20 )
     => ( sup @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Oinf_403,axiom,
    ! [A20: $tType] :
      ( ( inf @ A20 )
     => ( inf @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___Heap_Oheap_404,axiom,
    ! [A20: $tType] :
      ( ( heap @ A20 )
     => ( heap @ ( option @ A20 ) ) ) ).

thf(tcon_Option_Ooption___HOL_Oequal_405,axiom,
    ! [A20: $tType] : ( cl_HOL_Oequal @ ( option @ A20 ) ) ).

thf(tcon_Predicate_Oseq___HOL_Oequal_406,axiom,
    ! [A20: $tType] : ( cl_HOL_Oequal @ ( seq @ A20 ) ) ).

thf(tcon_Predicate_Opred___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_407,axiom,
    ! [A20: $tType] : ( condit1219197933456340205attice @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Complete__Lattices_Ocomplete__distrib__lattice_408,axiom,
    ! [A20: $tType] : ( comple592849572758109894attice @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Obounded__semilattice__sup__bot_409,axiom,
    ! [A20: $tType] : ( bounde4967611905675639751up_bot @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Obounded__semilattice__inf__top_410,axiom,
    ! [A20: $tType] : ( bounde4346867609351753570nf_top @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Complete__Lattices_Ocomplete__lattice_411,axiom,
    ! [A20: $tType] : ( comple6319245703460814977attice @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Boolean__Algebras_Oboolean__algebra_412,axiom,
    ! [A20: $tType] : ( boolea8198339166811842893lgebra @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Obounded__lattice__top_413,axiom,
    ! [A20: $tType] : ( bounded_lattice_top @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Obounded__lattice__bot_414,axiom,
    ! [A20: $tType] : ( bounded_lattice_bot @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Complete__Partial__Order_Occpo_415,axiom,
    ! [A20: $tType] : ( comple9053668089753744459l_ccpo @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Osemilattice__sup_416,axiom,
    ! [A20: $tType] : ( semilattice_sup @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Osemilattice__inf_417,axiom,
    ! [A20: $tType] : ( semilattice_inf @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Odistrib__lattice_418,axiom,
    ! [A20: $tType] : ( distrib_lattice @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Obounded__lattice_419,axiom,
    ! [A20: $tType] : ( bounded_lattice @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Complete__Lattices_OSup_420,axiom,
    ! [A20: $tType] : ( complete_Sup @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Complete__Lattices_OInf_421,axiom,
    ! [A20: $tType] : ( complete_Inf @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Orderings_Oorder__top_422,axiom,
    ! [A20: $tType] : ( order_top @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Orderings_Oorder__bot_423,axiom,
    ! [A20: $tType] : ( order_bot @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Orderings_Opreorder_424,axiom,
    ! [A20: $tType] : ( preorder @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Olattice_425,axiom,
    ! [A20: $tType] : ( lattice @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Orderings_Oorder_426,axiom,
    ! [A20: $tType] : ( order @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Orderings_Otop_427,axiom,
    ! [A20: $tType] : ( top @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Orderings_Oord_428,axiom,
    ! [A20: $tType] : ( ord @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Orderings_Obot_429,axiom,
    ! [A20: $tType] : ( bot @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Groups_Ouminus_430,axiom,
    ! [A20: $tType] : ( uminus @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Osup_431,axiom,
    ! [A20: $tType] : ( sup @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Oinf_432,axiom,
    ! [A20: $tType] : ( inf @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___Groups_Ominus_433,axiom,
    ! [A20: $tType] : ( minus @ ( pred @ A20 ) ) ).

thf(tcon_Predicate_Opred___HOL_Oequal_434,axiom,
    ! [A20: $tType] : ( cl_HOL_Oequal @ ( pred @ A20 ) ) ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__sup__bot_435,axiom,
    bounde4967611905675639751up_bot @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__inf__top_436,axiom,
    bounde4346867609351753570nf_top @ assn ).

thf(tcon_Assertions_Oassn___Boolean__Algebras_Oboolean__algebra_437,axiom,
    boolea8198339166811842893lgebra @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__lattice__top_438,axiom,
    bounded_lattice_top @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__lattice__bot_439,axiom,
    bounded_lattice_bot @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Osemilattice__sup_440,axiom,
    semilattice_sup @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Osemilattice__inf_441,axiom,
    semilattice_inf @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Odistrib__lattice_442,axiom,
    distrib_lattice @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__lattice_443,axiom,
    bounded_lattice @ assn ).

thf(tcon_Assertions_Oassn___Groups_Oab__semigroup__mult_444,axiom,
    ab_semigroup_mult @ assn ).

thf(tcon_Assertions_Oassn___Groups_Ocomm__monoid__mult_445,axiom,
    comm_monoid_mult @ assn ).

thf(tcon_Assertions_Oassn___Groups_Osemigroup__mult_446,axiom,
    semigroup_mult @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Oorder__top_447,axiom,
    order_top @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Oorder__bot_448,axiom,
    order_bot @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Opreorder_449,axiom,
    preorder @ assn ).

thf(tcon_Assertions_Oassn___Groups_Omonoid__mult_450,axiom,
    monoid_mult @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Olattice_451,axiom,
    lattice @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Oorder_452,axiom,
    order @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Otop_453,axiom,
    top @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Oord_454,axiom,
    ord @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Obot_455,axiom,
    bot @ assn ).

thf(tcon_Assertions_Oassn___Groups_Ouminus_456,axiom,
    uminus @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Osup_457,axiom,
    sup @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Oinf_458,axiom,
    inf @ assn ).

thf(tcon_Assertions_Oassn___Groups_Otimes_459,axiom,
    times @ assn ).

thf(tcon_Assertions_Oassn___Groups_Ominus_460,axiom,
    minus @ assn ).

thf(tcon_Assertions_Oassn___Power_Opower_461,axiom,
    power @ assn ).

thf(tcon_Assertions_Oassn___Groups_Oone_462,axiom,
    one @ assn ).

thf(tcon_Assertions_Oassn___Rings_Odvd_463,axiom,
    dvd @ assn ).

thf(tcon_Typerep_Otyperep___Heap_Oheap_464,axiom,
    heap @ typerep ).

thf(tcon_Typerep_Otyperep___HOL_Oequal_465,axiom,
    cl_HOL_Oequal @ typerep ).

thf(tcon_Multiset_Omultiset___Quickcheck__Exhaustive_Ofull__exhaustive_466,axiom,
    ! [A20: $tType] :
      ( ( quickc3360725361186068524ustive @ A20 )
     => ( quickc3360725361186068524ustive @ ( multiset @ A20 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Oordered__ab__semigroup__add_467,axiom,
    ! [A20: $tType] :
      ( ( preorder @ A20 )
     => ( ordere6658533253407199908up_add @ ( multiset @ A20 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocancel__ab__semigroup__add_468,axiom,
    ! [A20: $tType] : ( cancel2418104881723323429up_add @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocancel__comm__monoid__add_469,axiom,
    ! [A20: $tType] : ( cancel1802427076303600483id_add @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocancel__semigroup__add_470,axiom,
    ! [A20: $tType] : ( cancel_semigroup_add @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Quickcheck__Random_Orandom_471,axiom,
    ! [A20: $tType] :
      ( ( quickcheck_random @ A20 )
     => ( quickcheck_random @ ( multiset @ A20 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__diff_472,axiom,
    ! [A20: $tType] : ( comm_monoid_diff @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Oab__semigroup__add_473,axiom,
    ! [A20: $tType] : ( ab_semigroup_add @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__add_474,axiom,
    ! [A20: $tType] : ( comm_monoid_add @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Complete__Lattices_OSup_475,axiom,
    ! [A20: $tType] : ( complete_Sup @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Complete__Lattices_OInf_476,axiom,
    ! [A20: $tType] : ( complete_Inf @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Osemigroup__add_477,axiom,
    ! [A20: $tType] : ( semigroup_add @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Orderings_Opreorder_478,axiom,
    ! [A20: $tType] :
      ( ( preorder @ A20 )
     => ( preorder @ ( multiset @ A20 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Omonoid__add_479,axiom,
    ! [A20: $tType] : ( monoid_add @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Orderings_Oorder_480,axiom,
    ! [A20: $tType] :
      ( ( preorder @ A20 )
     => ( order @ ( multiset @ A20 ) ) ) ).

thf(tcon_Multiset_Omultiset___Orderings_Oord_481,axiom,
    ! [A20: $tType] :
      ( ( preorder @ A20 )
     => ( ord @ ( multiset @ A20 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ominus_482,axiom,
    ! [A20: $tType] : ( minus @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ozero_483,axiom,
    ! [A20: $tType] : ( zero @ ( multiset @ A20 ) ) ).

thf(tcon_Multiset_Omultiset___HOL_Oequal_484,axiom,
    ! [A20: $tType] :
      ( ( cl_HOL_Oequal @ A20 )
     => ( cl_HOL_Oequal @ ( multiset @ A20 ) ) ) ).

thf(tcon_Product__Type_Oprod___Quickcheck__Exhaustive_Ofull__exhaustive_485,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( quickc3360725361186068524ustive @ A20 )
        & ( quickc3360725361186068524ustive @ A21 ) )
     => ( quickc3360725361186068524ustive @ ( product_prod @ A20 @ A21 ) ) ) ).

thf(tcon_Product__Type_Oprod___Quickcheck__Exhaustive_Oexhaustive_486,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( quickc658316121487927005ustive @ A20 )
        & ( quickc658316121487927005ustive @ A21 ) )
     => ( quickc658316121487927005ustive @ ( product_prod @ A20 @ A21 ) ) ) ).

thf(tcon_Product__Type_Oprod___Quickcheck__Random_Orandom_487,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( quickcheck_random @ A20 )
        & ( quickcheck_random @ A21 ) )
     => ( quickcheck_random @ ( product_prod @ A20 @ A21 ) ) ) ).

thf(tcon_Product__Type_Oprod___Heap_Oheap_488,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( ( heap @ A20 )
        & ( heap @ A21 ) )
     => ( heap @ ( product_prod @ A20 @ A21 ) ) ) ).

thf(tcon_Product__Type_Oprod___HOL_Oequal_489,axiom,
    ! [A20: $tType,A21: $tType] : ( cl_HOL_Oequal @ ( product_prod @ A20 @ A21 ) ) ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_490,axiom,
    condit6923001295902523014norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_491,axiom,
    condit1219197933456340205attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_492,axiom,
    comple592849572758109894attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Quickcheck__Exhaustive_Ofull__exhaustive_493,axiom,
    quickc3360725361186068524ustive @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_494,axiom,
    bounde4967611905675639751up_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_495,axiom,
    bounde4346867609351753570nf_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_496,axiom,
    comple5582772986160207858norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_497,axiom,
    comple6319245703460814977attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_498,axiom,
    boolea8198339166811842893lgebra @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__top_499,axiom,
    bounded_lattice_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__bot_500,axiom,
    bounded_lattice_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Partial__Order_Occpo_501,axiom,
    comple9053668089753744459l_ccpo @ product_unit ).

thf(tcon_Product__Type_Ounit___Quickcheck__Random_Orandom_502,axiom,
    quickcheck_random @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_503,axiom,
    semilattice_sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_504,axiom,
    semilattice_inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Odistrib__lattice_505,axiom,
    distrib_lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice_506,axiom,
    bounded_lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_OSup_507,axiom,
    complete_Sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_OInf_508,axiom,
    complete_Inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Owellorder_509,axiom,
    wellorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__top_510,axiom,
    order_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__bot_511,axiom,
    order_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Opreorder_512,axiom,
    preorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Olinorder_513,axiom,
    linorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Olattice_514,axiom,
    lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder_515,axiom,
    order @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Otop_516,axiom,
    top @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oord_517,axiom,
    ord @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Obot_518,axiom,
    bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ouminus_519,axiom,
    uminus @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osup_520,axiom,
    sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Oinf_521,axiom,
    inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ominus_522,axiom,
    minus @ product_unit ).

thf(tcon_Product__Type_Ounit___Heap_Oheap_523,axiom,
    heap @ product_unit ).

thf(tcon_Product__Type_Ounit___HOL_Oequal_524,axiom,
    cl_HOL_Oequal @ product_unit ).

thf(tcon_Heap_Oheap_Oheap__ext___Quickcheck__Random_Orandom_525,axiom,
    ! [A20: $tType] :
      ( ( quickcheck_random @ A20 )
     => ( quickcheck_random @ ( heap_ext @ A20 ) ) ) ).

thf(tcon_Heap_Oheap_Oheap__ext___HOL_Oequal_526,axiom,
    ! [A20: $tType] : ( cl_HOL_Oequal @ ( heap_ext @ A20 ) ) ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_527,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_528,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_529,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_530,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_531,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_532,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_533,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_534,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_535,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_536,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_537,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_538,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_539,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_540,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_541,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Quickcheck__Exhaustive_Ofull__exhaustive_542,axiom,
    quickc3360725361186068524ustive @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_543,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_544,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_545,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_546,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_547,axiom,
    linord4140545234300271783up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_548,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_549,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_550,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Quickcheck__Exhaustive_Oexhaustive_551,axiom,
    quickc658316121487927005ustive @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_552,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_553,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_554,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_555,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_556,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_557,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_558,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_559,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_560,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_561,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_562,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_563,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_564,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_565,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_566,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_567,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_568,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_569,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Quickcheck__Random_Orandom_570,axiom,
    quickcheck_random @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_571,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_572,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_573,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_574,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_575,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_576,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_577,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_578,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_579,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_580,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_581,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_582,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_583,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_584,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_585,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_586,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_587,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_588,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_589,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_590,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_591,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_592,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_593,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_594,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_595,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_596,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_597,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_598,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_599,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_600,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_601,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_602,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_603,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_604,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_605,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_606,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_607,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_608,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_609,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_610,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_611,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_612,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Otimes_613,axiom,
    times @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ominus_614,axiom,
    minus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_615,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_616,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_617,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_618,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_619,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_620,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_621,axiom,
    dvd @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___HOL_Oequal_622,axiom,
    cl_HOL_Oequal @ code_integer ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_623,axiom,
    bit_un5681908812861735899ations @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring__with__nat_624,axiom,
    euclid5411537665997757685th_nat @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__monoid__add__imp__le_625,axiom,
    ordere1937475149494474687imp_le @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring_626,axiom,
    euclid3128863361964157862miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring__cancel_627,axiom,
    euclid4440199948858584721cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors__cancel_628,axiom,
    semiri6575147826004484403cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__ab__semigroup__add_629,axiom,
    strict9044650504122735259up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__ab__semigroup__add_630,axiom,
    ordere580206878836729694up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add__imp__le_631,axiom,
    ordere2412721322843649153imp_le @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bit__operations_632,axiom,
    bit_se359711467146920520ations @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__comm__semiring__strict_633,axiom,
    linord2810124833399127020strict @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Quickcheck__Exhaustive_Ofull__exhaustive_634,axiom,
    quickc3360725361186068524ustive @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__comm__monoid__add_635,axiom,
    strict7427464778891057005id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__comm__monoid__add_636,axiom,
    ordere8940638589300402666id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring_637,axiom,
    euclid3725896446679973847miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Olinordered__ab__semigroup__add_638,axiom,
    linord4140545234300271783up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__nonzero__semiring_639,axiom,
    linord181362715937106298miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring__strict_640,axiom,
    linord8928482502909563296strict @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Quickcheck__Exhaustive_Oexhaustive_641,axiom,
    quickc658316121487927005ustive @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors_642,axiom,
    semiri3467727345109120633visors @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_643,axiom,
    ordere6658533253407199908up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__comm__monoid__add_644,axiom,
    ordere6911136660526730532id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__ab__semigroup__add_645,axiom,
    cancel2418104881723323429up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_646,axiom,
    cancel1802427076303600483id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1__cancel_647,axiom,
    comm_s4317794764714335236cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bits_648,axiom,
    bit_semiring_bits @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__comm__semiring_649,axiom,
    ordere2520102378445227354miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_650,axiom,
    cancel_semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring_651,axiom,
    linordered_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring__0_652,axiom,
    ordered_semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semidom_653,axiom,
    linordered_semidom @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Quickcheck__Random_Orandom_654,axiom,
    quickcheck_random @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__mult_655,axiom,
    ab_semigroup_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oalgebraic__semidom_656,axiom,
    algebraic_semidom @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__mult_657,axiom,
    comm_monoid_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__diff_658,axiom,
    comm_monoid_diff @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_659,axiom,
    ab_semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring_660,axiom,
    ordered_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Parity_Osemiring__parity_661,axiom,
    semiring_parity @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_662,axiom,
    comm_monoid_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__modulo_663,axiom,
    semiring_modulo @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_664,axiom,
    comm_semiring_1 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__0_665,axiom,
    comm_semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__mult_666,axiom,
    semigroup_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemidom__modulo_667,axiom,
    semidom_modulo @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemidom__divide_668,axiom,
    semidom_divide @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Num_Osemiring__numeral_669,axiom,
    semiring_numeral @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_670,axiom,
    semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ozero__less__one_671,axiom,
    zero_less_one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring_672,axiom,
    comm_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Nat_Osemiring__char__0_673,axiom,
    semiring_char_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ozero__neq__one_674,axiom,
    zero_neq_one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Opreorder_675,axiom,
    preorder @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Olinorder_676,axiom,
    linorder @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__mult_677,axiom,
    monoid_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_678,axiom,
    monoid_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_679,axiom,
    semiring_1 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__0_680,axiom,
    semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Omult__zero_681,axiom,
    mult_zero @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Oorder_682,axiom,
    order @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring_683,axiom,
    semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Oord_684,axiom,
    ord @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Otimes_685,axiom,
    times @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ominus_686,axiom,
    minus @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Power_Opower_687,axiom,
    power @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Num_Onumeral_688,axiom,
    numeral @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ozero_689,axiom,
    zero @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oone_690,axiom,
    one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Odvd_691,axiom,
    dvd @ code_natural ).

thf(tcon_Code__Numeral_Onatural___HOL_Oequal_692,axiom,
    cl_HOL_Oequal @ code_natural ).

thf(tcon_Heap__Time__Monad_OHeap___Quickcheck__Random_Orandom_693,axiom,
    ! [A20: $tType] :
      ( ( quickcheck_random @ A20 )
     => ( quickcheck_random @ ( heap_Time_Heap @ A20 ) ) ) ).

thf(tcon_Heap__Time__Monad_OHeap___HOL_Oequal_694,axiom,
    ! [A20: $tType] : ( cl_HOL_Oequal @ ( heap_Time_Heap @ A20 ) ) ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X8: A] : ( P @ X8 ) ) ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    hoare_hoare_triple @ a @ p @ ( if @ ( heap_Time_Heap @ a ) @ b @ f @ g ) @ q ).

%------------------------------------------------------------------------------
