%------------------------------------------------------------------------------
% File     : VBT00010_2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem Hoare_Triple 00469_013750
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0025_Hoare_Triple_00469_013750 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 8769 (2008 unt;1582 typ;   0 def)
%            Number of atoms       : 19614 (6260 equ)
%            Maximal formula atoms :   38 (   2 avg)
%            Number of connectives : 14411 (1984   ~; 196   |;1213   &)
%                                         (1239 <=>;9779  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   31 (   6 avg)
%            Maximal term depth    :   40 (   2 avg)
%            Number of types       :   14 (  13 usr)
%            Number of type conns  : 1559 (1087   >; 472   *;   0   +;   0  <<)
%            Number of predicates  :  307 ( 304 usr;   2 prp; 0-7 aty)
%            Number of functors    : 1265 (1265 usr;  71 con; 0-8 aty)
%            Number of variables   : 27863 (25228   !; 342   ?;27863   :)
%                                         (2293  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TF1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 15:43:32.849
%------------------------------------------------------------------------------
% Could-be-implicit typings (29)
tff(ty_t_Heap__Time__Monad_OHeap,type,
    heap_Time_Heap: $tType > $tType ).

tff(ty_t_Code__Numeral_Onatural,type,
    code_natural: $tType ).

tff(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

tff(ty_t_Code__Evaluation_Oterm,type,
    code_term: $tType ).

tff(ty_t_Heap_Oheap_Oheap__ext,type,
    heap_ext: $tType > $tType ).

tff(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

tff(ty_t_Product__Type_Oprod,type,
    product_prod: ( $tType * $tType ) > $tType ).

tff(ty_t_Old__Datatype_Onode,type,
    old_node: ( $tType * $tType ) > $tType ).

tff(ty_t_Multiset_Omultiset,type,
    multiset: $tType > $tType ).

tff(ty_t_Typerep_Otyperep,type,
    typerep: $tType ).

tff(ty_t_Assertions_Oassn,type,
    assn: $tType ).

tff(ty_t_Predicate_Opred,type,
    pred: $tType > $tType ).

tff(ty_t_Sum__Type_Osum,type,
    sum_sum: ( $tType * $tType ) > $tType ).

tff(ty_t_Predicate_Oseq,type,
    seq: $tType > $tType ).

tff(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

tff(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

tff(ty_t_String_Ochar,type,
    char: $tType ).

tff(ty_t_Heap_Oarray,type,
    array: $tType > $tType ).

tff(ty_t_List_Olist,type,
    list: $tType > $tType ).

tff(ty_t_Heap_Oref,type,
    ref: $tType > $tType ).

tff(ty_t_HOL_Obool,type,
    bool: $tType ).

tff(ty_t_Set_Oset,type,
    set: $tType > $tType ).

tff(ty_t_Rat_Orat,type,
    rat: $tType ).

tff(ty_t_Num_Onum,type,
    num: $tType ).

tff(ty_t_Nat_Onat,type,
    nat: $tType ).

tff(ty_t_Int_Oint,type,
    int: $tType ).

tff(ty_t_itself,type,
    itself: $tType > $tType ).

tff(ty_t_fun,type,
    fun: ( $tType * $tType ) > $tType ).

tff(ty_tf_a,type,
    a: $tType ).

% Explicit typings (1553)
tff(sy_cl_Typerep_Otyperep,type,
    typerep2: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Oenum,type,
    enum: 
      !>[A: $tType] : $o ).

tff(sy_cl_Code__Evaluation_Oterm__of,type,
    code_term_of: 
      !>[A: $tType] : $o ).

tff(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

tff(sy_cl_HOL_Oequal,type,
    cl_HOL_Oequal: 
      !>[A: $tType] : $o ).

tff(sy_cl_Heap_Oheap,type,
    heap: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Otimes,type,
    times: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Oinf,type,
    inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osup,type,
    sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Obot,type,
    bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Otop,type,
    top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__lattice,type,
    finite_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_OInf,type,
    complete_Inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_OSup,type,
    complete_Sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Quickcheck__Random_Orandom,type,
    quickcheck_random: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Partial__Order_Occpo,type,
    comple9053668089753744459l_ccpo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Onormalization__semidom,type,
    normal8620421768224518004emidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice__bot,type,
    bounded_lattice_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice__top,type,
    bounded_lattice_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Quickcheck__Exhaustive_Oexhaustive,type,
    quickc658316121487927005ustive: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide__unit__factor,type,
    semido2269285787275462019factor: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Quickcheck__Exhaustive_Ofull__exhaustive,type,
    quickc3360725361186068524ustive: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Onormalization__semidom__multiplicative,type,
    normal6328177297339901930cative: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

tff(sy_c_ATP_058Lamp__a____,type,
    aTP_Lamp_a: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aa____,type,
    aTP_Lamp_aa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ab____,type,
    aTP_Lamp_ab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ac____,type,
    aTP_Lamp_ac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ad____,type,
    aTP_Lamp_ad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ae____,type,
    aTP_Lamp_ae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__af____,type,
    aTP_Lamp_af: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ag____,type,
    aTP_Lamp_ag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ah____,type,
    aTP_Lamp_ah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ai____,type,
    aTP_Lamp_ai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aj____,type,
    aTP_Lamp_aj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ak____,type,
    aTP_Lamp_ak: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__al____,type,
    aTP_Lamp_al: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__am____,type,
    aTP_Lamp_am: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__an____,type,
    aTP_Lamp_an: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ao____,type,
    aTP_Lamp_ao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ap____,type,
    aTP_Lamp_ap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aq____,type,
    aTP_Lamp_aq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ar____,type,
    aTP_Lamp_ar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__as____,type,
    aTP_Lamp_as: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__at____,type,
    aTP_Lamp_at: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__au____,type,
    aTP_Lamp_au: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__av____,type,
    aTP_Lamp_av: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aw____,type,
    aTP_Lamp_aw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ax____,type,
    aTP_Lamp_ax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ay____,type,
    aTP_Lamp_ay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__az____,type,
    aTP_Lamp_az: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ba____,type,
    aTP_Lamp_ba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bb____,type,
    aTP_Lamp_bb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bc____,type,
    aTP_Lamp_bc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bd____,type,
    aTP_Lamp_bd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__be____,type,
    aTP_Lamp_be: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bf____,type,
    aTP_Lamp_bf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bg____,type,
    aTP_Lamp_bg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bh____,type,
    aTP_Lamp_bh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bi____,type,
    aTP_Lamp_bi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bj____,type,
    aTP_Lamp_bj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bk____,type,
    aTP_Lamp_bk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bl____,type,
    aTP_Lamp_bl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bm____,type,
    aTP_Lamp_bm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bn____,type,
    aTP_Lamp_bn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bo____,type,
    aTP_Lamp_bo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bp____,type,
    aTP_Lamp_bp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bq____,type,
    aTP_Lamp_bq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__br____,type,
    aTP_Lamp_br: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bs____,type,
    aTP_Lamp_bs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bt____,type,
    aTP_Lamp_bt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bu____,type,
    aTP_Lamp_bu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bv____,type,
    aTP_Lamp_bv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bw____,type,
    aTP_Lamp_bw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bx____,type,
    aTP_Lamp_bx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__by____,type,
    aTP_Lamp_by: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bz____,type,
    aTP_Lamp_bz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ca____,type,
    aTP_Lamp_ca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cb____,type,
    aTP_Lamp_cb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cc____,type,
    aTP_Lamp_cc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cd____,type,
    aTP_Lamp_cd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ce____,type,
    aTP_Lamp_ce: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cf____,type,
    aTP_Lamp_cf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cg____,type,
    aTP_Lamp_cg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ch____,type,
    aTP_Lamp_ch: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ci____,type,
    aTP_Lamp_ci: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cj____,type,
    aTP_Lamp_cj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ck____,type,
    aTP_Lamp_ck: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cl____,type,
    aTP_Lamp_cl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cm____,type,
    aTP_Lamp_cm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cn____,type,
    aTP_Lamp_cn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__co____,type,
    aTP_Lamp_co: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cp____,type,
    aTP_Lamp_cp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cq____,type,
    aTP_Lamp_cq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cr____,type,
    aTP_Lamp_cr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cs____,type,
    aTP_Lamp_cs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ct____,type,
    aTP_Lamp_ct: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cu____,type,
    aTP_Lamp_cu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cv____,type,
    aTP_Lamp_cv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cw____,type,
    aTP_Lamp_cw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cx____,type,
    aTP_Lamp_cx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cy____,type,
    aTP_Lamp_cy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cz____,type,
    aTP_Lamp_cz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__da____,type,
    aTP_Lamp_da: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__db____,type,
    aTP_Lamp_db: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dc____,type,
    aTP_Lamp_dc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dd____,type,
    aTP_Lamp_dd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__de____,type,
    aTP_Lamp_de: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__df____,type,
    aTP_Lamp_df: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dg____,type,
    aTP_Lamp_dg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dh____,type,
    aTP_Lamp_dh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__di____,type,
    aTP_Lamp_di: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dj____,type,
    aTP_Lamp_dj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dk____,type,
    aTP_Lamp_dk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dl____,type,
    aTP_Lamp_dl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dm____,type,
    aTP_Lamp_dm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dn____,type,
    aTP_Lamp_dn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__do____,type,
    aTP_Lamp_do: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dp____,type,
    aTP_Lamp_dp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dq____,type,
    aTP_Lamp_dq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dr____,type,
    aTP_Lamp_dr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ds____,type,
    aTP_Lamp_ds: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dt____,type,
    aTP_Lamp_dt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__du____,type,
    aTP_Lamp_du: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dv____,type,
    aTP_Lamp_dv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dw____,type,
    aTP_Lamp_dw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dx____,type,
    aTP_Lamp_dx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dy____,type,
    aTP_Lamp_dy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dz____,type,
    aTP_Lamp_dz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ea____,type,
    aTP_Lamp_ea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eb____,type,
    aTP_Lamp_eb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ec____,type,
    aTP_Lamp_ec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ed____,type,
    aTP_Lamp_ed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ee____,type,
    aTP_Lamp_ee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ef____,type,
    aTP_Lamp_ef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eg____,type,
    aTP_Lamp_eg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eh____,type,
    aTP_Lamp_eh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ei____,type,
    aTP_Lamp_ei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ej____,type,
    aTP_Lamp_ej: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ek____,type,
    aTP_Lamp_ek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__el____,type,
    aTP_Lamp_el: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__em____,type,
    aTP_Lamp_em: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__en____,type,
    aTP_Lamp_en: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__eo____,type,
    aTP_Lamp_eo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ep____,type,
    aTP_Lamp_ep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eq____,type,
    aTP_Lamp_eq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__er____,type,
    aTP_Lamp_er: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__es____,type,
    aTP_Lamp_es: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__et____,type,
    aTP_Lamp_et: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eu____,type,
    aTP_Lamp_eu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ev____,type,
    aTP_Lamp_ev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ew____,type,
    aTP_Lamp_ew: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ex____,type,
    aTP_Lamp_ex: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ey____,type,
    aTP_Lamp_ey: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ez____,type,
    aTP_Lamp_ez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fa____,type,
    aTP_Lamp_fa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fb____,type,
    aTP_Lamp_fb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fc____,type,
    aTP_Lamp_fc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fd____,type,
    aTP_Lamp_fd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fe____,type,
    aTP_Lamp_fe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ff____,type,
    aTP_Lamp_ff: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fg____,type,
    aTP_Lamp_fg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fh____,type,
    aTP_Lamp_fh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fi____,type,
    aTP_Lamp_fi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fj____,type,
    aTP_Lamp_fj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fk____,type,
    aTP_Lamp_fk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fl____,type,
    aTP_Lamp_fl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fm____,type,
    aTP_Lamp_fm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fn____,type,
    aTP_Lamp_fn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fo____,type,
    aTP_Lamp_fo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fp____,type,
    aTP_Lamp_fp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fq____,type,
    aTP_Lamp_fq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fr____,type,
    aTP_Lamp_fr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fs____,type,
    aTP_Lamp_fs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ft____,type,
    aTP_Lamp_ft: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fu____,type,
    aTP_Lamp_fu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fv____,type,
    aTP_Lamp_fv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fw____,type,
    aTP_Lamp_fw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fx____,type,
    aTP_Lamp_fx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fy____,type,
    aTP_Lamp_fy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fz____,type,
    aTP_Lamp_fz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ga____,type,
    aTP_Lamp_ga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gb____,type,
    aTP_Lamp_gb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gc____,type,
    aTP_Lamp_gc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gd____,type,
    aTP_Lamp_gd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ge____,type,
    aTP_Lamp_ge: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gf____,type,
    aTP_Lamp_gf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gg____,type,
    aTP_Lamp_gg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gh____,type,
    aTP_Lamp_gh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gi____,type,
    aTP_Lamp_gi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gj____,type,
    aTP_Lamp_gj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gk____,type,
    aTP_Lamp_gk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gl____,type,
    aTP_Lamp_gl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gm____,type,
    aTP_Lamp_gm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gn____,type,
    aTP_Lamp_gn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__go____,type,
    aTP_Lamp_go: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gp____,type,
    aTP_Lamp_gp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gq____,type,
    aTP_Lamp_gq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gr____,type,
    aTP_Lamp_gr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gs____,type,
    aTP_Lamp_gs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gt____,type,
    aTP_Lamp_gt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gu____,type,
    aTP_Lamp_gu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gv____,type,
    aTP_Lamp_gv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gw____,type,
    aTP_Lamp_gw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gx____,type,
    aTP_Lamp_gx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gy____,type,
    aTP_Lamp_gy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gz____,type,
    aTP_Lamp_gz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ha____,type,
    aTP_Lamp_ha: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hb____,type,
    aTP_Lamp_hb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hc____,type,
    aTP_Lamp_hc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hd____,type,
    aTP_Lamp_hd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__he____,type,
    aTP_Lamp_he: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hf____,type,
    aTP_Lamp_hf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hg____,type,
    aTP_Lamp_hg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hh____,type,
    aTP_Lamp_hh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hi____,type,
    aTP_Lamp_hi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hj____,type,
    aTP_Lamp_hj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hk____,type,
    aTP_Lamp_hk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hl____,type,
    aTP_Lamp_hl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hm____,type,
    aTP_Lamp_hm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hn____,type,
    aTP_Lamp_hn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ho____,type,
    aTP_Lamp_ho: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hp____,type,
    aTP_Lamp_hp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hq____,type,
    aTP_Lamp_hq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hr____,type,
    aTP_Lamp_hr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hs____,type,
    aTP_Lamp_hs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ht____,type,
    aTP_Lamp_ht: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hu____,type,
    aTP_Lamp_hu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hv____,type,
    aTP_Lamp_hv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hw____,type,
    aTP_Lamp_hw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hx____,type,
    aTP_Lamp_hx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hy____,type,
    aTP_Lamp_hy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hz____,type,
    aTP_Lamp_hz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ia____,type,
    aTP_Lamp_ia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ib____,type,
    aTP_Lamp_ib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ic____,type,
    aTP_Lamp_ic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__id____,type,
    aTP_Lamp_id: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ie____,type,
    aTP_Lamp_ie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__if____,type,
    aTP_Lamp_if: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ig____,type,
    aTP_Lamp_ig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ih____,type,
    aTP_Lamp_ih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ii____,type,
    aTP_Lamp_ii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ij____,type,
    aTP_Lamp_ij: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ik____,type,
    aTP_Lamp_ik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__il____,type,
    aTP_Lamp_il: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__im____,type,
    aTP_Lamp_im: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__in____,type,
    aTP_Lamp_in: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__io____,type,
    aTP_Lamp_io: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ip____,type,
    aTP_Lamp_ip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iq____,type,
    aTP_Lamp_iq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ir____,type,
    aTP_Lamp_ir: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__is____,type,
    aTP_Lamp_is: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__it____,type,
    aTP_Lamp_it: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iu____,type,
    aTP_Lamp_iu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iv____,type,
    aTP_Lamp_iv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iw____,type,
    aTP_Lamp_iw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ix____,type,
    aTP_Lamp_ix: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iy____,type,
    aTP_Lamp_iy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iz____,type,
    aTP_Lamp_iz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ja____,type,
    aTP_Lamp_ja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jb____,type,
    aTP_Lamp_jb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jc____,type,
    aTP_Lamp_jc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jd____,type,
    aTP_Lamp_jd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__je____,type,
    aTP_Lamp_je: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jf____,type,
    aTP_Lamp_jf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jg____,type,
    aTP_Lamp_jg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jh____,type,
    aTP_Lamp_jh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ji____,type,
    aTP_Lamp_ji: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jj____,type,
    aTP_Lamp_jj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jk____,type,
    aTP_Lamp_jk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jl____,type,
    aTP_Lamp_jl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jm____,type,
    aTP_Lamp_jm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jn____,type,
    aTP_Lamp_jn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jo____,type,
    aTP_Lamp_jo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jp____,type,
    aTP_Lamp_jp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jq____,type,
    aTP_Lamp_jq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jr____,type,
    aTP_Lamp_jr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__js____,type,
    aTP_Lamp_js: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jt____,type,
    aTP_Lamp_jt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ju____,type,
    aTP_Lamp_ju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jv____,type,
    aTP_Lamp_jv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jw____,type,
    aTP_Lamp_jw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jx____,type,
    aTP_Lamp_jx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jy____,type,
    aTP_Lamp_jy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jz____,type,
    aTP_Lamp_jz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ka____,type,
    aTP_Lamp_ka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kb____,type,
    aTP_Lamp_kb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kc____,type,
    aTP_Lamp_kc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kd____,type,
    aTP_Lamp_kd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ke____,type,
    aTP_Lamp_ke: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kf____,type,
    aTP_Lamp_kf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kg____,type,
    aTP_Lamp_kg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kh____,type,
    aTP_Lamp_kh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ki____,type,
    aTP_Lamp_ki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kj____,type,
    aTP_Lamp_kj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kk____,type,
    aTP_Lamp_kk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kl____,type,
    aTP_Lamp_kl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__km____,type,
    aTP_Lamp_km: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kn____,type,
    aTP_Lamp_kn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ko____,type,
    aTP_Lamp_ko: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kp____,type,
    aTP_Lamp_kp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kq____,type,
    aTP_Lamp_kq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kr____,type,
    aTP_Lamp_kr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ks____,type,
    aTP_Lamp_ks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kt____,type,
    aTP_Lamp_kt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ku____,type,
    aTP_Lamp_ku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kv____,type,
    aTP_Lamp_kv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kw____,type,
    aTP_Lamp_kw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__kx____,type,
    aTP_Lamp_kx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ky____,type,
    aTP_Lamp_ky: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kz____,type,
    aTP_Lamp_kz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__la____,type,
    aTP_Lamp_la: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lb____,type,
    aTP_Lamp_lb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lc____,type,
    aTP_Lamp_lc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ld____,type,
    aTP_Lamp_ld: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__le____,type,
    aTP_Lamp_le: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lf____,type,
    aTP_Lamp_lf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lg____,type,
    aTP_Lamp_lg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lh____,type,
    aTP_Lamp_lh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__li____,type,
    aTP_Lamp_li: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__lj____,type,
    aTP_Lamp_lj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lk____,type,
    aTP_Lamp_lk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ll____,type,
    aTP_Lamp_ll: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lm____,type,
    aTP_Lamp_lm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ln____,type,
    aTP_Lamp_ln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lo____,type,
    aTP_Lamp_lo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lp____,type,
    aTP_Lamp_lp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lq____,type,
    aTP_Lamp_lq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lr____,type,
    aTP_Lamp_lr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ls____,type,
    aTP_Lamp_ls: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lt____,type,
    aTP_Lamp_lt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lu____,type,
    aTP_Lamp_lu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lv____,type,
    aTP_Lamp_lv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lw____,type,
    aTP_Lamp_lw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lx____,type,
    aTP_Lamp_lx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ly____,type,
    aTP_Lamp_ly: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lz____,type,
    aTP_Lamp_lz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ma____,type,
    aTP_Lamp_ma: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mb____,type,
    aTP_Lamp_mb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mc____,type,
    aTP_Lamp_mc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__md____,type,
    aTP_Lamp_md: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__me____,type,
    aTP_Lamp_me: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mf____,type,
    aTP_Lamp_mf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mg____,type,
    aTP_Lamp_mg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mh____,type,
    aTP_Lamp_mh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mi____,type,
    aTP_Lamp_mi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mj____,type,
    aTP_Lamp_mj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mk____,type,
    aTP_Lamp_mk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ml____,type,
    aTP_Lamp_ml: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mm____,type,
    aTP_Lamp_mm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mn____,type,
    aTP_Lamp_mn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mo____,type,
    aTP_Lamp_mo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mp____,type,
    aTP_Lamp_mp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mq____,type,
    aTP_Lamp_mq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mr____,type,
    aTP_Lamp_mr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ms____,type,
    aTP_Lamp_ms: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mt____,type,
    aTP_Lamp_mt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mu____,type,
    aTP_Lamp_mu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mv____,type,
    aTP_Lamp_mv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mw____,type,
    aTP_Lamp_mw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mx____,type,
    aTP_Lamp_mx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__my____,type,
    aTP_Lamp_my: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mz____,type,
    aTP_Lamp_mz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__na____,type,
    aTP_Lamp_na: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nb____,type,
    aTP_Lamp_nb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nc____,type,
    aTP_Lamp_nc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nd____,type,
    aTP_Lamp_nd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ne____,type,
    aTP_Lamp_ne: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nf____,type,
    aTP_Lamp_nf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ng____,type,
    aTP_Lamp_ng: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nh____,type,
    aTP_Lamp_nh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ni____,type,
    aTP_Lamp_ni: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nj____,type,
    aTP_Lamp_nj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nk____,type,
    aTP_Lamp_nk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nl____,type,
    aTP_Lamp_nl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nm____,type,
    aTP_Lamp_nm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nn____,type,
    aTP_Lamp_nn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__no____,type,
    aTP_Lamp_no: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__np____,type,
    aTP_Lamp_np: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nq____,type,
    aTP_Lamp_nq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nr____,type,
    aTP_Lamp_nr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ns____,type,
    aTP_Lamp_ns: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nt____,type,
    aTP_Lamp_nt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nu____,type,
    aTP_Lamp_nu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nv____,type,
    aTP_Lamp_nv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nw____,type,
    aTP_Lamp_nw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nx____,type,
    aTP_Lamp_nx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ny____,type,
    aTP_Lamp_ny: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nz____,type,
    aTP_Lamp_nz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oa____,type,
    aTP_Lamp_oa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ob____,type,
    aTP_Lamp_ob: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oc____,type,
    aTP_Lamp_oc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__od____,type,
    aTP_Lamp_od: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oe____,type,
    aTP_Lamp_oe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__of____,type,
    aTP_Lamp_of: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__og____,type,
    aTP_Lamp_og: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oh____,type,
    aTP_Lamp_oh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__oi____,type,
    aTP_Lamp_oi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__oj____,type,
    aTP_Lamp_oj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ok____,type,
    aTP_Lamp_ok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ol____,type,
    aTP_Lamp_ol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__om____,type,
    aTP_Lamp_om: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__on____,type,
    aTP_Lamp_on: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oo____,type,
    aTP_Lamp_oo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__op____,type,
    aTP_Lamp_op: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oq____,type,
    aTP_Lamp_oq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__or____,type,
    aTP_Lamp_or: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__os____,type,
    aTP_Lamp_os: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ot____,type,
    aTP_Lamp_ot: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ou____,type,
    aTP_Lamp_ou: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ov____,type,
    aTP_Lamp_ov: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ow____,type,
    aTP_Lamp_ow: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ox____,type,
    aTP_Lamp_ox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oy____,type,
    aTP_Lamp_oy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oz____,type,
    aTP_Lamp_oz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pa____,type,
    aTP_Lamp_pa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pb____,type,
    aTP_Lamp_pb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pc____,type,
    aTP_Lamp_pc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pd____,type,
    aTP_Lamp_pd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pe____,type,
    aTP_Lamp_pe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pf____,type,
    aTP_Lamp_pf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pg____,type,
    aTP_Lamp_pg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ph____,type,
    aTP_Lamp_ph: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pi____,type,
    aTP_Lamp_pi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pj____,type,
    aTP_Lamp_pj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pk____,type,
    aTP_Lamp_pk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pl____,type,
    aTP_Lamp_pl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pm____,type,
    aTP_Lamp_pm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pn____,type,
    aTP_Lamp_pn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__po____,type,
    aTP_Lamp_po: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pp____,type,
    aTP_Lamp_pp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pq____,type,
    aTP_Lamp_pq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pr____,type,
    aTP_Lamp_pr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ps____,type,
    aTP_Lamp_ps: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pt____,type,
    aTP_Lamp_pt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pu____,type,
    aTP_Lamp_pu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pv____,type,
    aTP_Lamp_pv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pw____,type,
    aTP_Lamp_pw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__px____,type,
    aTP_Lamp_px: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__py____,type,
    aTP_Lamp_py: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pz____,type,
    aTP_Lamp_pz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qa____,type,
    aTP_Lamp_qa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qb____,type,
    aTP_Lamp_qb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qc____,type,
    aTP_Lamp_qc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qd____,type,
    aTP_Lamp_qd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qe____,type,
    aTP_Lamp_qe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qf____,type,
    aTP_Lamp_qf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qg____,type,
    aTP_Lamp_qg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qh____,type,
    aTP_Lamp_qh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qi____,type,
    aTP_Lamp_qi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qj____,type,
    aTP_Lamp_qj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qk____,type,
    aTP_Lamp_qk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ql____,type,
    aTP_Lamp_ql: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qm____,type,
    aTP_Lamp_qm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qn____,type,
    aTP_Lamp_qn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qo____,type,
    aTP_Lamp_qo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qp____,type,
    aTP_Lamp_qp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qq____,type,
    aTP_Lamp_qq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qr____,type,
    aTP_Lamp_qr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qs____,type,
    aTP_Lamp_qs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qt____,type,
    aTP_Lamp_qt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qu____,type,
    aTP_Lamp_qu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qv____,type,
    aTP_Lamp_qv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qw____,type,
    aTP_Lamp_qw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qx____,type,
    aTP_Lamp_qx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qy____,type,
    aTP_Lamp_qy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qz____,type,
    aTP_Lamp_qz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ra____,type,
    aTP_Lamp_ra: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rb____,type,
    aTP_Lamp_rb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rc____,type,
    aTP_Lamp_rc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rd____,type,
    aTP_Lamp_rd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__re____,type,
    aTP_Lamp_re: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rf____,type,
    aTP_Lamp_rf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rg____,type,
    aTP_Lamp_rg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rh____,type,
    aTP_Lamp_rh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ri____,type,
    aTP_Lamp_ri: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rj____,type,
    aTP_Lamp_rj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rk____,type,
    aTP_Lamp_rk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rl____,type,
    aTP_Lamp_rl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rm____,type,
    aTP_Lamp_rm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rn____,type,
    aTP_Lamp_rn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ro____,type,
    aTP_Lamp_ro: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rp____,type,
    aTP_Lamp_rp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rq____,type,
    aTP_Lamp_rq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rr____,type,
    aTP_Lamp_rr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rs____,type,
    aTP_Lamp_rs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rt____,type,
    aTP_Lamp_rt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ru____,type,
    aTP_Lamp_ru: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rv____,type,
    aTP_Lamp_rv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rw____,type,
    aTP_Lamp_rw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rx____,type,
    aTP_Lamp_rx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ry____,type,
    aTP_Lamp_ry: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rz____,type,
    aTP_Lamp_rz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sa____,type,
    aTP_Lamp_sa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sb____,type,
    aTP_Lamp_sb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sc____,type,
    aTP_Lamp_sc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sd____,type,
    aTP_Lamp_sd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__se____,type,
    aTP_Lamp_se: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sf____,type,
    aTP_Lamp_sf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sg____,type,
    aTP_Lamp_sg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sh____,type,
    aTP_Lamp_sh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__si____,type,
    aTP_Lamp_si: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sj____,type,
    aTP_Lamp_sj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sk____,type,
    aTP_Lamp_sk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sl____,type,
    aTP_Lamp_sl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sm____,type,
    aTP_Lamp_sm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sn____,type,
    aTP_Lamp_sn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__so____,type,
    aTP_Lamp_so: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sp____,type,
    aTP_Lamp_sp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sq____,type,
    aTP_Lamp_sq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sr____,type,
    aTP_Lamp_sr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ss____,type,
    aTP_Lamp_ss: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__st____,type,
    aTP_Lamp_st: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__su____,type,
    aTP_Lamp_su: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sv____,type,
    aTP_Lamp_sv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sw____,type,
    aTP_Lamp_sw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sx____,type,
    aTP_Lamp_sx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sy____,type,
    aTP_Lamp_sy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sz____,type,
    aTP_Lamp_sz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ta____,type,
    aTP_Lamp_ta: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tb____,type,
    aTP_Lamp_tb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tc____,type,
    aTP_Lamp_tc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__td____,type,
    aTP_Lamp_td: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__te____,type,
    aTP_Lamp_te: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tf____,type,
    aTP_Lamp_tf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tg____,type,
    aTP_Lamp_tg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__th____,type,
    aTP_Lamp_th: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ti____,type,
    aTP_Lamp_ti: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tj____,type,
    aTP_Lamp_tj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tk____,type,
    aTP_Lamp_tk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tl____,type,
    aTP_Lamp_tl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tm____,type,
    aTP_Lamp_tm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tn____,type,
    aTP_Lamp_tn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__to____,type,
    aTP_Lamp_to: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tp____,type,
    aTP_Lamp_tp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tq____,type,
    aTP_Lamp_tq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tr____,type,
    aTP_Lamp_tr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ts____,type,
    aTP_Lamp_ts: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tt____,type,
    aTP_Lamp_tt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tu____,type,
    aTP_Lamp_tu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tv____,type,
    aTP_Lamp_tv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tw____,type,
    aTP_Lamp_tw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tx____,type,
    aTP_Lamp_tx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ty____,type,
    aTP_Lamp_ty: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tz____,type,
    aTP_Lamp_tz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ua____,type,
    aTP_Lamp_ua: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ub____,type,
    aTP_Lamp_ub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uc____,type,
    aTP_Lamp_uc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ud____,type,
    aTP_Lamp_ud: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ue____,type,
    aTP_Lamp_ue: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uf____,type,
    aTP_Lamp_uf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ug____,type,
    aTP_Lamp_ug: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uh____,type,
    aTP_Lamp_uh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ui____,type,
    aTP_Lamp_ui: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uj____,type,
    aTP_Lamp_uj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uk____,type,
    aTP_Lamp_uk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ul____,type,
    aTP_Lamp_ul: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__um____,type,
    aTP_Lamp_um: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__un____,type,
    aTP_Lamp_un: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uo____,type,
    aTP_Lamp_uo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__up____,type,
    aTP_Lamp_up: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uq____,type,
    aTP_Lamp_uq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ur____,type,
    aTP_Lamp_ur: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__us____,type,
    aTP_Lamp_us: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ut____,type,
    aTP_Lamp_ut: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uu____,type,
    aTP_Lamp_uu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uv____,type,
    aTP_Lamp_uv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uw____,type,
    aTP_Lamp_uw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ux____,type,
    aTP_Lamp_ux: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uy____,type,
    aTP_Lamp_uy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uz____,type,
    aTP_Lamp_uz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__va____,type,
    aTP_Lamp_va: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vb____,type,
    aTP_Lamp_vb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vc____,type,
    aTP_Lamp_vc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vd____,type,
    aTP_Lamp_vd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ve____,type,
    aTP_Lamp_ve: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vf____,type,
    aTP_Lamp_vf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vg____,type,
    aTP_Lamp_vg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vh____,type,
    aTP_Lamp_vh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vi____,type,
    aTP_Lamp_vi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vj____,type,
    aTP_Lamp_vj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vk____,type,
    aTP_Lamp_vk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vl____,type,
    aTP_Lamp_vl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vm____,type,
    aTP_Lamp_vm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vn____,type,
    aTP_Lamp_vn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vo____,type,
    aTP_Lamp_vo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vp____,type,
    aTP_Lamp_vp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vq____,type,
    aTP_Lamp_vq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vr____,type,
    aTP_Lamp_vr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vs____,type,
    aTP_Lamp_vs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vt____,type,
    aTP_Lamp_vt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vu____,type,
    aTP_Lamp_vu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vv____,type,
    aTP_Lamp_vv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vw____,type,
    aTP_Lamp_vw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vx____,type,
    aTP_Lamp_vx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vy____,type,
    aTP_Lamp_vy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vz____,type,
    aTP_Lamp_vz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wa____,type,
    aTP_Lamp_wa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wb____,type,
    aTP_Lamp_wb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wc____,type,
    aTP_Lamp_wc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wd____,type,
    aTP_Lamp_wd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__we____,type,
    aTP_Lamp_we: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wf____,type,
    aTP_Lamp_wf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wg____,type,
    aTP_Lamp_wg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wh____,type,
    aTP_Lamp_wh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wi____,type,
    aTP_Lamp_wi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wj____,type,
    aTP_Lamp_wj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wk____,type,
    aTP_Lamp_wk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wl____,type,
    aTP_Lamp_wl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wm____,type,
    aTP_Lamp_wm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wn____,type,
    aTP_Lamp_wn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wo____,type,
    aTP_Lamp_wo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wp____,type,
    aTP_Lamp_wp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wq____,type,
    aTP_Lamp_wq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wr____,type,
    aTP_Lamp_wr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ws____,type,
    aTP_Lamp_ws: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wt____,type,
    aTP_Lamp_wt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wu____,type,
    aTP_Lamp_wu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wv____,type,
    aTP_Lamp_wv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ww____,type,
    aTP_Lamp_ww: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wx____,type,
    aTP_Lamp_wx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wy____,type,
    aTP_Lamp_wy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wz____,type,
    aTP_Lamp_wz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xa____,type,
    aTP_Lamp_xa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xb____,type,
    aTP_Lamp_xb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xc____,type,
    aTP_Lamp_xc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xd____,type,
    aTP_Lamp_xd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xe____,type,
    aTP_Lamp_xe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xf____,type,
    aTP_Lamp_xf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xg____,type,
    aTP_Lamp_xg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xh____,type,
    aTP_Lamp_xh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Array__Time_Oalloc,type,
    array_alloc: 
      !>[A: $tType] : ( ( list(A) * heap_ext(product_unit) ) > product_prod(array(A),heap_ext(product_unit)) ) ).

tff(sy_c_Array__Time_Ofreeze,type,
    array_freeze: 
      !>[A: $tType] : ( array(A) > heap_Time_Heap(list(A)) ) ).

tff(sy_c_Array__Time_Oget,type,
    array_get: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * array(A) ) > list(A) ) ).

tff(sy_c_Array__Time_Olen,type,
    array_len: 
      !>[A: $tType] : ( array(A) > heap_Time_Heap(nat) ) ).

tff(sy_c_Array__Time_Olength,type,
    array_length: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * array(A) ) > nat ) ).

tff(sy_c_Array__Time_Omake,type,
    array_make: 
      !>[A: $tType] : ( ( nat * fun(nat,A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Omake_H,type,
    array_make2: 
      !>[B: $tType,A: $tType] : ( ( code_integer * fun(B,A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Omap__entry,type,
    array_map_entry: 
      !>[A: $tType] : ( ( nat * fun(A,A) * array(A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Onew,type,
    array_new: 
      !>[A: $tType] : fun(nat,fun(A,heap_Time_Heap(array(A)))) ).

tff(sy_c_Array__Time_Onew_H,type,
    array_new2: 
      !>[A: $tType] : fun(code_integer,fun(A,heap_Time_Heap(array(A)))) ).

tff(sy_c_Array__Time_Onth,type,
    array_nth: 
      !>[A: $tType] : ( array(A) > fun(nat,heap_Time_Heap(A)) ) ).

tff(sy_c_Array__Time_Onth_H,type,
    array_nth2: 
      !>[A: $tType] : ( array(A) > fun(code_integer,heap_Time_Heap(A)) ) ).

tff(sy_c_Array__Time_Oof__list,type,
    array_of_list: 
      !>[A: $tType] : ( list(A) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Oset,type,
    array_set: 
      !>[A: $tType] : ( ( array(A) * list(A) * heap_ext(product_unit) ) > heap_ext(product_unit) ) ).

tff(sy_c_Array__Time_Oswap,type,
    array_swap: 
      !>[A: $tType] : ( ( nat * A * array(A) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Array__Time_Oupd,type,
    array_upd: 
      !>[A: $tType] : ( ( nat * A * array(A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Oupdate,type,
    array_update: 
      !>[A: $tType] : ( ( array(A) * nat * A * heap_ext(product_unit) ) > heap_ext(product_unit) ) ).

tff(sy_c_Assertions_Oassn_OAbs__assn,type,
    abs_assn: fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn) ).

tff(sy_c_Assertions_Oassn_ORep__assn,type,
    rep_assn: fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool)) ).

tff(sy_c_Assertions_Oentails,type,
    entails: ( assn * assn ) > $o ).

tff(sy_c_Assertions_Oentailst,type,
    entailst: ( assn * assn ) > $o ).

tff(sy_c_Assertions_Oex__assn,type,
    ex_assn: 
      !>[A: $tType] : ( fun(A,assn) > assn ) ).

tff(sy_c_Assertions_Oin__range,type,
    in_range: fun(product_prod(heap_ext(product_unit),set(nat)),bool) ).

tff(sy_c_Assertions_Oin__range__rel,type,
    in_range_rel: fun(product_prod(heap_ext(product_unit),set(nat)),fun(product_prod(heap_ext(product_unit),set(nat)),bool)) ).

tff(sy_c_Assertions_Ois__pure__assn,type,
    is_pure_assn: assn > $o ).

tff(sy_c_Assertions_Oone__assn__raw,type,
    one_assn_raw: fun(product_prod(heap_ext(product_unit),set(nat)),bool) ).

tff(sy_c_Assertions_Oone__assn__raw__rel,type,
    one_assn_raw_rel: fun(product_prod(heap_ext(product_unit),set(nat)),fun(product_prod(heap_ext(product_unit),set(nat)),bool)) ).

tff(sy_c_Assertions_Oprecise,type,
    precise: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,assn)) > $o ) ).

tff(sy_c_Assertions_Oproper,type,
    proper: fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool) ).

tff(sy_c_Assertions_Opure__assn,type,
    pure_assn: bool > assn ).

tff(sy_c_Assertions_Opure__assn__raw,type,
    pure_assn_raw: 
      !>[A: $tType,B: $tType] : ( bool > fun(product_prod(A,set(B)),bool) ) ).

tff(sy_c_Assertions_Opure__assn__raw__rel,type,
    pure_assn_raw_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(bool,product_prod(A,set(B))),fun(product_prod(bool,product_prod(A,set(B))),bool)) ).

tff(sy_c_Assertions_OrelH,type,
    relH: ( set(nat) * heap_ext(product_unit) * heap_ext(product_unit) ) > $o ).

tff(sy_c_Assertions_Osnga__assn,type,
    snga_assn: 
      !>[A: $tType] : ( ( array(A) * list(A) ) > assn ) ).

tff(sy_c_Assertions_Osnga__assn__raw,type,
    snga_assn_raw: 
      !>[A: $tType] : ( ( array(A) * list(A) ) > fun(product_prod(heap_ext(product_unit),set(nat)),bool) ) ).

tff(sy_c_Assertions_Osnga__assn__raw__rel,type,
    snga_assn_raw_rel: 
      !>[A: $tType] : fun(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool)) ).

tff(sy_c_Assertions_Osngr__assn,type,
    sngr_assn: 
      !>[A: $tType] : ( ( ref(A) * A ) > assn ) ).

tff(sy_c_Assertions_Osngr__assn__raw,type,
    sngr_assn_raw: 
      !>[A: $tType] : ( ( ref(A) * A ) > fun(product_prod(heap_ext(product_unit),set(nat)),bool) ) ).

tff(sy_c_Assertions_Osngr__assn__raw__rel,type,
    sngr_assn_raw_rel: 
      !>[A: $tType] : fun(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool)) ).

tff(sy_c_Assertions_Otimes__assn__raw,type,
    times_assn_raw: ( fun(product_prod(heap_ext(product_unit),set(nat)),bool) * fun(product_prod(heap_ext(product_unit),set(nat)),bool) ) > fun(product_prod(heap_ext(product_unit),set(nat)),bool) ).

tff(sy_c_Assertions_Otimes__assn__raw__rel,type,
    times_assn_raw_rel: fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool)) ).

tff(sy_c_Assertions_Owand__assn,type,
    wand_assn: ( assn * assn ) > assn ).

tff(sy_c_Assertions_Owand__raw,type,
    wand_raw: ( fun(product_prod(heap_ext(product_unit),set(nat)),bool) * fun(product_prod(heap_ext(product_unit),set(nat)),bool) ) > fun(product_prod(heap_ext(product_unit),set(nat)),bool) ).

tff(sy_c_Assertions_Owand__raw__rel,type,
    wand_raw_rel: fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool)) ).

tff(sy_c_BNF__Cardinal__Arithmetic_OCsum,type,
    bNF_Cardinal_Csum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,set(product_prod(B,B))) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocexp,type,
    bNF_Cardinal_cexp: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * set(product_prod(A,A)) ) > set(product_prod(fun(A,B),fun(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocfinite,type,
    bNF_Cardinal_cfinite: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocinfinite,type,
    bNF_Ca4139267488887388095finite: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocone,type,
    bNF_Cardinal_cone: set(product_prod(product_unit,product_unit)) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocprod,type,
    bNF_Cardinal_cprod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocsum,type,
    bNF_Cardinal_csum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(sum_sum(A,B),sum_sum(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Octwo,type,
    bNF_Cardinal_ctwo: set(product_prod(bool,bool)) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Oczero,type,
    bNF_Cardinal_czero: 
      !>[A: $tType] : set(product_prod(A,A)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OcardSuc,type,
    bNF_Ca8387033319878233205ardSuc: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_Ocard__of,type,
    bNF_Ca6860139660246222851ard_of: 
      !>[A: $tType] : ( set(A) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_Ocard__order__on,type,
    bNF_Ca8970107618336181345der_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_Ocofinal,type,
    bNF_Ca7293521722713021262ofinal: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OisCardSuc,type,
    bNF_Ca6246979054910435723ardSuc: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(set(A),set(A))) ) > $o ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OnatLeq,type,
    bNF_Ca8665028551170535155natLeq: set(product_prod(nat,nat)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OregularCard,type,
    bNF_Ca7133664381575040944arCard: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OrelChain,type,
    bNF_Ca3754400796208372196lChain: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,B) ) > $o ) ).

tff(sy_c_BNF__Composition_Oid__bnf,type,
    bNF_id_bnf: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Def_OGrp,type,
    bNF_Grp: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > fun(A,fun(B,bool)) ) ).

tff(sy_c_BNF__Def_Ocollect,type,
    bNF_collect: 
      !>[B: $tType,A: $tType] : ( set(fun(B,set(A))) > fun(B,set(A)) ) ).

tff(sy_c_BNF__Def_Oconvol,type,
    bNF_convol: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,B) * fun(A,C) ) > fun(A,product_prod(B,C)) ) ).

tff(sy_c_BNF__Def_Oeq__onp,type,
    bNF_eq_onp: 
      !>[A: $tType] : ( fun(A,bool) > fun(A,fun(A,bool)) ) ).

tff(sy_c_BNF__Def_OfstOp,type,
    bNF_fstOp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,bool)) * fun(B,fun(C,bool)) ) > fun(product_prod(A,C),product_prod(A,B)) ) ).

tff(sy_c_BNF__Def_Opick__middlep,type,
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] : ( ( fun(B,fun(A,bool)) * fun(A,fun(C,bool)) * B * C ) > A ) ).

tff(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,fun(C,bool)) * fun(B,fun(D,bool)) ) > fun(fun(A,B),fun(fun(C,D),bool)) ) ).

tff(sy_c_BNF__Def_Orel__set,type,
    bNF_rel_set: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(set(A),fun(set(B),bool)) ) ).

tff(sy_c_BNF__Def_OsndOp,type,
    bNF_sndOp: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( fun(C,fun(A,bool)) * fun(A,fun(B,bool)) ) > fun(product_prod(C,B),product_prod(A,B)) ) ).

tff(sy_c_BNF__Def_Ovimage2p,type,
    bNF_vimage2p: 
      !>[A: $tType,D: $tType,B: $tType,E: $tType,C: $tType] : ( ( fun(A,D) * fun(B,E) ) > fun(fun(D,fun(E,C)),fun(A,fun(B,C))) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OfromCard,type,
    bNF_Gr5436034075474128252omCard: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) * B ) > A ) ).

tff(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set(C) * fun(C,A) * fun(C,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OrelImage,type,
    bNF_Gr4221423524335903396lImage: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * fun(B,A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OrelInvImage,type,
    bNF_Gr7122648621184425601vImage: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) * fun(A,B) ) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OtoCard,type,
    bNF_Greatest_toCard: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) ) > fun(A,B) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OtoCard__pred,type,
    bNF_Gr1419584066657907630d_pred: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) * fun(A,B) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(fun(A,B)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set(B) * fun(C,A) * fun(B,D) ) > fun(fun(D,C),fun(B,A)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Obsqr,type,
    bNF_Wellorder_bsqr: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(product_prod(A,A),product_prod(A,A))) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Ocurr,type,
    bNF_Wellorder_curr: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(A) * fun(product_prod(A,B),C) * A ) > fun(B,C) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Odir__image,type,
    bNF_We2720479622203943262_image: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * fun(A,A2) ) > set(product_prod(A2,A2)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OofilterIncl,type,
    bNF_We413866401316099525erIncl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OordIso,type,
    bNF_Wellorder_ordIso: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_OordLeq,type,
    bNF_Wellorder_ordLeq: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_OordLess,type,
    bNF_We4044943003108391690rdLess: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_Oord__to__filter,type,
    bNF_We8469521843155493636filter: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(set(product_prod(A,A)),set(A)) ) ).

tff(sy_c_BNF__Wellorder__Embedding_Ocompat,type,
    bNF_Wellorder_compat: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Embedding_Oembed,type,
    bNF_Wellorder_embed: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Embedding_OembedS,type,
    bNF_Wellorder_embedS: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Embedding_Oiso,type,
    bNF_Wellorder_iso: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel,type,
    bNF_Wellorder_wo_rel: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_OisMinim,type,
    bNF_We4791949203932849705sMinim: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) * A ) > $o ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Omax2,type,
    bNF_We1388413361240627857o_max2: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A * A ) > A ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Ominim,type,
    bNF_We6954850376910717587_minim: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > A ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Osuc,type,
    bNF_Wellorder_wo_suc: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > A ) ).

tff(sy_c_Basic__BNF__LFPs_Octor__rec,type,
    basic_BNF_ctor_rec: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( fun(A,nat) * fun(B,nat) ) > fun(product_prod(A,B),nat) ) ).

tff(sy_c_Basic__BNF__LFPs_Osum_Osize__sum,type,
    basic_BNF_size_sum: 
      !>[A: $tType,B: $tType] : ( ( fun(A,nat) * fun(B,nat) ) > fun(sum_sum(A,B),nat) ) ).

tff(sy_c_Basic__BNF__LFPs_Oxtor,type,
    basic_BNF_xtor: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Basic__BNFs_Ofsts,type,
    basic_fsts: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),set(A)) ).

tff(sy_c_Basic__BNFs_Opred__fun,type,
    basic_pred_fun: 
      !>[A: $tType,B: $tType] : ( ( fun(A,bool) * fun(B,bool) ) > fun(fun(A,B),bool) ) ).

tff(sy_c_Basic__BNFs_Opred__prod,type,
    basic_pred_prod: 
      !>[A: $tType,B: $tType] : ( ( fun(A,bool) * fun(B,bool) ) > fun(product_prod(A,B),bool) ) ).

tff(sy_c_Basic__BNFs_Opred__sum,type,
    basic_pred_sum: 
      !>[A: $tType,B: $tType] : ( ( fun(A,bool) * fun(B,bool) * sum_sum(A,B) ) > $o ) ).

tff(sy_c_Basic__BNFs_Orel__prod,type,
    basic_rel_prod: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( fun(A,fun(B,bool)) * fun(C,fun(D,bool)) ) > fun(product_prod(A,C),fun(product_prod(B,D),bool)) ) ).

tff(sy_c_Basic__BNFs_Osetl,type,
    basic_setl: 
      !>[A: $tType,B: $tType] : fun(sum_sum(A,B),set(A)) ).

tff(sy_c_Basic__BNFs_Osetr,type,
    basic_setr: 
      !>[A: $tType,B: $tType] : fun(sum_sum(A,B),set(B)) ).

tff(sy_c_Basic__BNFs_Osnds,type,
    basic_snds: 
      !>[A: $tType,B: $tType] : ( product_prod(A,B) > set(B) ) ).

tff(sy_c_Binomial_Obinomial,type,
    binomial: ( nat * nat ) > nat ).

tff(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > fun(nat,A) ) ).

tff(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: fun(product_prod(int,int),fun(product_prod(int,int),bool)) ).

tff(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: fun(product_prod(num,num),fun(product_prod(num,num),bool)) ).

tff(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: ( num * num ) > num ).

tff(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: fun(product_prod(num,num),fun(product_prod(num,num),bool)) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > fun(nat,bool) ) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself(A) * nat ) > bool ) ).

tff(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: ( nat * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: fun(product_prod(num,num),fun(product_prod(num,num),bool)) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oor__num,type,
    bit_un6697907153464112080or_num: ( num * num ) > num ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oor__num__rel,type,
    bit_un4773296044027857193um_rel: fun(product_prod(num,num),fun(product_prod(num,num),bool)) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num__rel,type,
    bit_un2901131394128224187um_rel: fun(product_prod(num,num),fun(product_prod(num,num),bool)) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__axioms,type,
    boolea6902313364301356556axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff__axioms,type,
    boolea5476839437570043046axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Code__Numeral_OSuc,type,
    code_Suc: code_natural > code_natural ).

tff(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > product_prod(code_integer,bool) ).

tff(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: fun(code_integer,int) ).

tff(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: fun(code_integer,nat) ).

tff(sy_c_Code__Numeral_Onatural_Onat__of__natural,type,
    code_nat_of_natural: code_natural > nat ).

tff(sy_c_Code__Numeral_Onatural_Onatural__of__nat,type,
    code_natural_of_nat: nat > code_natural ).

tff(sy_c_Code__Numeral_Onegative,type,
    code_negative: fun(num,code_integer) ).

tff(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: fun(code_integer,num) ).

tff(sy_c_Code__Numeral_Opcr__integer,type,
    code_pcr_integer: fun(int,fun(code_integer,bool)) ).

tff(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Partial__Order_Occpo_Oadmissible,type,
    comple1908693960933563346ssible: 
      !>[A: $tType] : ( ( fun(set(A),A) * fun(A,fun(A,bool)) * fun(A,bool) ) > $o ) ).

tff(sy_c_Complete__Partial__Order_Occpo_Ofixp,type,
    comple187402453842119260l_fixp: 
      !>[A: $tType] : ( ( fun(set(A),A) * fun(A,fun(A,bool)) * fun(A,A) ) > A ) ).

tff(sy_c_Complete__Partial__Order_Occpo__class_Ofixp,type,
    comple115746919287870866o_fixp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Complete__Partial__Order_Occpo__class_Oiterates,type,
    comple6359979572994053840erates: 
      !>[A: $tType] : ( fun(A,A) > set(A) ) ).

tff(sy_c_Complete__Partial__Order_Ochain,type,
    comple1602240252501008431_chain: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * set(A) ) > $o ) ).

tff(sy_c_Complete__Partial__Order_Omonotone,type,
    comple7038119648293358887notone: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,fun(B,bool)) * fun(A,B) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__above,type,
    condit8047198070973881523_above: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * set(A) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__below,type,
    condit8119078960628432327_below: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * set(A) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Countable_Ofrom__nat,type,
    from_nat: 
      !>[A: $tType] : fun(nat,A) ).

tff(sy_c_Countable_Onat__to__rat__surj,type,
    nat_to_rat_surj: fun(nat,rat) ).

tff(sy_c_Countable_Onth__item__rel,type,
    nth_item_rel: fun(nat,fun(nat,bool)) ).

tff(sy_c_Divides_Oadjust__div,type,
    adjust_div: product_prod(int,int) > int ).

tff(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: ( int * int * product_prod(int,int) ) > $o ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( product_prod(A,A) > $o ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( ( num * num ) > product_prod(A,A) ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( ( num * product_prod(A,A) ) > product_prod(A,A) ) ).

tff(sy_c_Equiv__Relations_Ocongruent,type,
    equiv_congruent: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,B) ) > $o ) ).

tff(sy_c_Equiv__Relations_Ocongruent2,type,
    equiv_congruent2: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) * fun(A,fun(B,C)) ) > $o ) ).

tff(sy_c_Equiv__Relations_Oequiv,type,
    equiv_equiv: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Equiv__Relations_Oequivp,type,
    equiv_equivp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Equiv__Relations_Oproj,type,
    equiv_proj: 
      !>[B: $tType,A: $tType] : ( set(product_prod(B,A)) > fun(B,set(A)) ) ).

tff(sy_c_Equiv__Relations_Oquotient,type,
    equiv_quotient: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > set(set(A)) ) ).

tff(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( ( A * nat ) > A ) ).

tff(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Ocofinite,type,
    cofinite: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( fun(A,bool) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofilter_OAbs__filter,type,
    abs_filter: 
      !>[A: $tType] : ( fun(fun(A,bool),bool) > filter(A) ) ).

tff(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) ) > filter(A) ) ).

tff(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( set(A) > filter(set(A)) ) ).

tff(sy_c_Filter_Ofrequently,type,
    frequently: 
      !>[A: $tType] : ( ( fun(A,bool) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( set(A) > filter(A) ) ).

tff(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * filter(B) ) > filter(product_prod(A,B)) ) ).

tff(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( set(B) > nat ) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__idem__axioms,type,
    finite1981172056906289455axioms: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__idem__on,type,
    finite673082921795544331dem_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__idem__on__axioms,type,
    finite4980608107308702382axioms: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : fun(set(A),bool) ).

tff(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > B ) ).

tff(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > fun(B,bool) ) ).

tff(sy_c_Finite__Set_Ofolding,type,
    finite_folding: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__idem,type,
    finite_folding_idem: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__idem__axioms,type,
    finite7837460588564673216axioms: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__idem__on,type,
    finite1890593828518410140dem_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__idem__on__axioms,type,
    finite6916993218817215295axioms: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > B ) ).

tff(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) * set(B) ) > $o ) ).

tff(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : fun(fun(B,C),fun(fun(A,B),fun(A,C))) ).

tff(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A * B ) > fun(A,B) ) ).

tff(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( fun(C,A) * fun(B,D) ) > fun(fun(A,B),fun(C,D)) ) ).

tff(sy_c_Fun_Ooverride__on,type,
    override_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(A,B) * set(A) ) > fun(A,B) ) ).

tff(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > fun(B,A) ) ).

tff(sy_c_Fun__Def_Ois__measure,type,
    fun_is_measure: 
      !>[A: $tType] : ( fun(A,nat) > $o ) ).

tff(sy_c_Fun__Def_Omax__strict,type,
    fun_max_strict: set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))) ).

tff(sy_c_Fun__Def_Omax__weak,type,
    fun_max_weak: set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))) ).

tff(sy_c_Fun__Def_Omin__strict,type,
    fun_min_strict: set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))) ).

tff(sy_c_Fun__Def_Omin__weak,type,
    fun_min_weak: set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))) ).

tff(sy_c_Fun__Def_Opair__leq,type,
    fun_pair_leq: set(product_prod(product_prod(nat,nat),product_prod(nat,nat))) ).

tff(sy_c_Fun__Def_Opair__less,type,
    fun_pair_less: set(product_prod(product_prod(nat,nat),product_prod(nat,nat))) ).

tff(sy_c_Fun__Def_Oreduction__pair,type,
    fun_reduction_pair: 
      !>[A: $tType] : ( product_prod(set(product_prod(A,A)),set(product_prod(A,A))) > $o ) ).

tff(sy_c_Fun__Def_Orp__inv__image,type,
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] : fun(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))) ).

tff(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_OGcd__class_OLcm,type,
    gcd_Lcm: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_Obezw,type,
    bezw: ( nat * nat ) > product_prod(int,int) ).

tff(sy_c_GCD_Obezw__rel,type,
    bezw_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)) ).

tff(sy_c_GCD_Obounded__quasi__semilattice,type,
    bounde8507323023520639062attice: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A ) > fun(set(A),A) ) ).

tff(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__class_Olcm,type,
    gcd_lcm: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)) ).

tff(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_GCD_Osemiring__gcd__class_OLcm__fin,type,
    semiring_gcd_Lcm_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Groups_Oabel__semigroup,type,
    abel_semigroup: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Oabel__semigroup__axioms,type,
    abel_s757365448890700780axioms: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ocomm__monoid,type,
    comm_monoid: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Ocomm__monoid__axioms,type,
    comm_monoid_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Ogroup,type,
    group: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,A) ) > $o ) ).

tff(sy_c_Groups_Ogroup__axioms,type,
    group_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,A) ) > $o ) ).

tff(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Omonoid,type,
    monoid: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Omonoid__axioms,type,
    monoid_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

tff(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Osemigroup,type,
    semigroup: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

tff(sy_c_Groups__Big_Ocomm__monoid__add_Osum,type,
    groups3894954378712506084id_sum: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A * fun(B,A) * set(B) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : fun(fun(C,A),fun(set(C),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set,type,
    groups778175481326437816id_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set_OF,type,
    groups_comm_monoid_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(fun(B,A),fun(set(B),A)) ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set_OG,type,
    groups_comm_monoid_G: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(fun(B,A),fun(set(B),A)) ) ).

tff(sy_c_Groups__List_Ocomm__monoid__list,type,
    groups1828464146339083142d_list: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Ocomm__monoid__list__set,type,
    groups4802862169904069756st_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(A,fun(list(B),A))) ).

tff(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_Groups__List_Omonoid__list,type,
    groups_monoid_list: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Omonoid__list_OF,type,
    groups_monoid_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(list(A),A) ) ).

tff(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_HOL_OUniq,type,
    uniq: 
      !>[A: $tType] : ( fun(A,bool) > $o ) ).

tff(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

tff(sy_c_Heap_Oaddr__of__array,type,
    addr_of_array: 
      !>[A: $tType] : ( array(A) > nat ) ).

tff(sy_c_Heap_Oaddr__of__ref,type,
    addr_of_ref: 
      !>[A: $tType] : fun(ref(A),nat) ).

tff(sy_c_Heap_Oarray_OArray,type,
    array2: 
      !>[A: $tType] : ( nat > array(A) ) ).

tff(sy_c_Heap_Oheap_Oarrays,type,
    arrays: 
      !>[Z: $tType] : ( ( heap_ext(Z) * typerep * nat ) > list(nat) ) ).

tff(sy_c_Heap_Oheap_Olim,type,
    lim: 
      !>[Z: $tType] : ( heap_ext(Z) > nat ) ).

tff(sy_c_Heap_Oheap_Olim__update,type,
    lim_update: 
      !>[Z: $tType] : ( ( fun(nat,nat) * heap_ext(Z) ) > heap_ext(Z) ) ).

tff(sy_c_Heap_Oheap_Orefs,type,
    refs: 
      !>[Z: $tType] : ( ( heap_ext(Z) * typerep ) > fun(nat,nat) ) ).

tff(sy_c_Heap_Oref_ORef,type,
    ref2: 
      !>[A: $tType] : ( nat > ref(A) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_OHeap,type,
    heap_Time_Heap2: 
      !>[A: $tType] : fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_OHeap_Ocase__Heap,type,
    heap_Time_case_Heap: 
      !>[A: $tType,B: $tType] : fun(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),fun(heap_Time_Heap(A),B)) ).

tff(sy_c_Heap__Time__Monad_OHeap_Omap__Heap,type,
    heap_Time_map_Heap: 
      !>[A: $tType,Aa: $tType] : fun(fun(A,Aa),fun(heap_Time_Heap(A),heap_Time_Heap(Aa))) ).

tff(sy_c_Heap__Time__Monad_OHeap_Opred__Heap,type,
    heap_Time_pred_Heap: 
      !>[A: $tType] : fun(fun(A,bool),fun(heap_Time_Heap(A),bool)) ).

tff(sy_c_Heap__Time__Monad_OHeap_Orec__Heap,type,
    heap_Time_rec_Heap: 
      !>[A: $tType,C: $tType] : fun(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(A),C)) ).

tff(sy_c_Heap__Time__Monad_OHeap_Orel__Heap,type,
    heap_Time_rel_Heap: 
      !>[A: $tType,B: $tType] : fun(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool))) ).

tff(sy_c_Heap__Time__Monad_OHeap_Oset__Heap,type,
    heap_Time_set_Heap: 
      !>[A: $tType] : fun(heap_Time_Heap(A),set(A)) ).

tff(sy_c_Heap__Time__Monad_OHeap_Osize__Heap,type,
    heap_Time_size_Heap: 
      !>[A: $tType] : ( fun(A,nat) > fun(heap_Time_Heap(A),nat) ) ).

tff(sy_c_Heap__Time__Monad_OHeap__lub,type,
    heap_Time_Heap_lub: 
      !>[A: $tType] : fun(set(heap_Time_Heap(A)),heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_OHeap__ord,type,
    heap_Time_Heap_ord: 
      !>[A: $tType] : fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool)) ).

tff(sy_c_Heap__Time__Monad_Oassert,type,
    heap_Time_assert: 
      !>[A: $tType] : ( ( fun(A,bool) * A ) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Obind,type,
    heap_Time_bind: 
      !>[A: $tType,B: $tType] : ( ( heap_Time_Heap(A) * fun(A,heap_Time_Heap(B)) ) > heap_Time_Heap(B) ) ).

tff(sy_c_Heap__Time__Monad_Oeffect,type,
    heap_Time_effect: 
      !>[A: $tType] : ( ( heap_Time_Heap(A) * heap_ext(product_unit) * heap_ext(product_unit) * A * nat ) > $o ) ).

tff(sy_c_Heap__Time__Monad_Oexecute,type,
    heap_Time_execute: 
      !>[A: $tType] : fun(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))) ).

tff(sy_c_Heap__Time__Monad_Oguard,type,
    heap_Time_guard: 
      !>[A: $tType] : ( ( fun(heap_ext(product_unit),bool) * fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Oheap,type,
    heap_Time_heap: 
      !>[A: $tType] : ( fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Olift,type,
    heap_Time_lift: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(A,heap_Time_Heap(B)) ) ).

tff(sy_c_Heap__Time__Monad_Oraise,type,
    heap_Time_raise: 
      !>[A: $tType] : ( list(char) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Oreturn,type,
    heap_Time_return: 
      !>[A: $tType] : fun(A,heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_Osuccess,type,
    heap_Time_success: 
      !>[A: $tType] : ( ( heap_Time_Heap(A) * heap_ext(product_unit) ) > $o ) ).

tff(sy_c_Heap__Time__Monad_Otap,type,
    heap_Time_tap: 
      !>[A: $tType] : ( fun(heap_ext(product_unit),A) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_OtimeFrame,type,
    heap_Time_timeFrame: 
      !>[A: $tType] : ( ( nat * option(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) > option(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ).

tff(sy_c_Heap__Time__Monad_OtimeFrame__rel,type,
    heap_T5500966940807335491me_rel: 
      !>[A: $tType] : fun(product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),bool)) ).

tff(sy_c_Heap__Time__Monad_Oureturn,type,
    heap_Time_ureturn: 
      !>[A: $tType] : fun(A,heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_Owait,type,
    heap_Time_wait: nat > heap_Time_Heap(product_unit) ).

tff(sy_c_Hilbert__Choice_Obijection,type,
    hilbert_bijection: 
      !>[A: $tType] : ( fun(A,A) > $o ) ).

tff(sy_c_Hilbert__Choice_Oinv__into,type,
    hilbert_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > fun(B,A) ) ).

tff(sy_c_Hoare__Triple_Ohoare__triple,type,
    hoare_hoare_triple: 
      !>[A: $tType] : ( ( assn * heap_Time_Heap(A) * fun(A,assn) ) > $o ) ).

tff(sy_c_Hoare__Triple_Onew__addrs,type,
    hoare_new_addrs: ( heap_ext(product_unit) * set(nat) * heap_ext(product_unit) ) > set(nat) ).

tff(sy_c_If,type,
    if: 
      !>[A: $tType] : ( ( bool * A * A ) > A ) ).

tff(sy_c_Inductive_Ocomplete__lattice__class_Ogfp,type,
    complete_lattice_gfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Inductive_Ocomplete__lattice__class_Olfp,type,
    complete_lattice_lfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set(A) * nat ) > A ) ).

tff(sy_c_Int_OAbs__Integ,type,
    abs_Integ: fun(product_prod(nat,nat),int) ).

tff(sy_c_Int_ORep__Integ,type,
    rep_Integ: fun(int,product_prod(nat,nat)) ).

tff(sy_c_Int_Ointrel,type,
    intrel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)) ).

tff(sy_c_Int_Onat,type,
    nat2: fun(int,nat) ).

tff(sy_c_Int_Opcr__int,type,
    pcr_int: fun(product_prod(nat,nat),fun(int,bool)) ).

tff(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( ( A * int ) > A ) ).

tff(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : fun(int,A) ).

tff(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices_Osemilattice,type,
    semilattice: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices_Osemilattice__axioms,type,
    semilattice_axioms: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices_Osemilattice__neutr,type,
    semilattice_neutr: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__order,type,
    semilattice_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__order__axioms,type,
    semila6385135966242565138axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Oord__class_Ois__arg__min,type,
    lattic501386751177426532rg_min: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(B,bool) * B ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf_OInf__fin,type,
    lattic8678736583308907530nf_fin: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Osemilattice__neutr__set,type,
    lattic5652469242046573047tr_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__neutr__set_OF,type,
    lattic5214292709420241887eutr_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__set,type,
    lattic149705377957585745ce_set: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__set_OF,type,
    lattic1715443433743089157tice_F: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup_OSup__fin,type,
    lattic4630905495605216202up_fin: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lifting_OQuotient,type,
    quotient: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,B) * fun(B,A) * fun(A,fun(B,bool)) ) > $o ) ).

tff(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : fun(list(A),fun(list(A),list(A))) ).

tff(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * list(A) ) > A ) ).

tff(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,B),list(A)),fun(product_prod(fun(A,B),list(A)),bool)) ).

tff(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( list(list(A)) > list(A) ) ).

tff(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( list(A) > set(A) ) ).

tff(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( list(A) > $o ) ).

tff(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(product_prod(nat,A)) ) ).

tff(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > option(product_prod(list(A),product_prod(A,list(A)))) ) ).

tff(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > list(A) ) ).

tff(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > option(A) ) ).

tff(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) * set(B) * fun(B,A) ) > $o ) ).

tff(sy_c_List_Ofoldl,type,
    foldl: 
      !>[B: $tType,A: $tType] : ( ( fun(B,fun(A,B)) * B * list(A) ) > B ) ).

tff(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * nat ) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,A) * B ) > fun(list(B),list(B)) ) ).

tff(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(B,A) * set(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * B ) > fun(list(B),list(B)) ) ).

tff(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( set(A) > list(A) ) ).

tff(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : fun(A,fun(list(A),list(A))) ).

tff(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : list(A) ).

tff(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,fun(list(A),B)) * list(A) ) > B ) ).

tff(sy_c_List_Olist_Olist__all,type,
    list_all: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > $o ) ).

tff(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(list(A),fun(list(B),bool)) ) ).

tff(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(list(A),list(Aa)) ) ).

tff(sy_c_List_Olist_Orec__list,type,
    rec_list: 
      !>[C: $tType,A: $tType] : ( ( C * fun(A,fun(list(A),fun(C,C))) ) > fun(list(A),C) ) ).

tff(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : fun(list(A),set(A)) ).

tff(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( fun(A,nat) > fun(list(A),nat) ) ).

tff(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list(A) * nat * A ) > list(A) ) ).

tff(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(list(A),list(B))) ) ).

tff(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(list(A),fun(list(B),bool)) ) ).

tff(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( set(A) > set(list(A)) ) ).

tff(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( list(set(A)) > set(list(A)) ) ).

tff(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * list(A) ) > list(B) ) ).

tff(sy_c_List_Omap__tailrec__rev,type,
    map_tailrec_rev: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * list(A) * list(B) ) > list(B) ) ).

tff(sy_c_List_Omap__tailrec__rev__rel,type,
    map_tailrec_rev_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,B),product_prod(list(A),list(B))),fun(product_prod(fun(A,B),product_prod(list(A),list(B))),bool)) ).

tff(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( list(fun(A,nat)) > set(product_prod(A,A)) ) ).

tff(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list(A) * nat ) > A ) ).

tff(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list(A) * set(nat) ) > list(A) ) ).

tff(sy_c_List_Oord__class_Olexordp,type,
    ord_lexordp: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( fun(A,bool) > fun(list(A),product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( ( nat * A ) > list(A) ) ).

tff(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > fun(list(A),list(A)) ) ).

tff(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set(A) * set(list(A)) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),bool)) ).

tff(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) ) > $o ) ).

tff(sy_c_List_Osorted__wrt__rel,type,
    sorted_wrt_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,bool)),list(A)),fun(product_prod(fun(A,fun(A,bool)),list(A)),bool)) ).

tff(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_List_Osplice__rel,type,
    splice_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),bool)) ).

tff(sy_c_List_Osuccessively,type,
    successively: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) ) > $o ) ).

tff(sy_c_List_Osuccessively__rel,type,
    successively_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,bool)),list(A)),fun(product_prod(fun(A,fun(A,bool)),list(A)),bool)) ).

tff(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( fun(A,bool) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oupt,type,
    upt: ( nat * nat ) > list(nat) ).

tff(sy_c_List_Oupto,type,
    upto: ( int * int ) > list(int) ).

tff(sy_c_List_Oupto__rel,type,
    upto_rel: fun(product_prod(int,int),fun(product_prod(int,int),bool)) ).

tff(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(A) ) ).

tff(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(product_prod(A,B)) ) ).

tff(sy_c_Map_Omap__add,type,
    map_add: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * fun(A,option(B)) ) > fun(A,option(B)) ) ).

tff(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( list(product_prod(A,B)) > fun(A,option(B)) ) ).

tff(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(B) ) ).

tff(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * set(A) ) > fun(A,option(B)) ) ).

tff(sy_c_Misc_OEps__Opt,type,
    eps_Opt: 
      !>[A: $tType] : ( fun(A,bool) > option(A) ) ).

tff(sy_c_Misc_Obijective,type,
    bijective: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > $o ) ).

tff(sy_c_Misc_Obrk__rel,type,
    brk_rel: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(product_prod(bool,A),product_prod(bool,B))) ) ).

tff(sy_c_Misc_Odflt__None__set,type,
    dflt_None_set: 
      !>[A: $tType] : ( set(A) > option(set(A)) ) ).

tff(sy_c_Misc_Ofilter__rev,type,
    filter_rev: 
      !>[A: $tType] : ( fun(A,bool) > fun(list(A),list(A)) ) ).

tff(sy_c_Misc_Ofun__of__rel,type,
    fun_of_rel: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,A)) * B ) > A ) ).

tff(sy_c_Misc_Olist__all__zip,type,
    list_all_zip: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,bool)) * list(A) * list(B) ) > $o ) ).

tff(sy_c_Misc_Olist__all__zip__rel,type,
    list_all_zip_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),fun(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool)) ).

tff(sy_c_Misc_Olist__collect__set,type,
    list_collect_set: 
      !>[B: $tType,A: $tType] : ( ( fun(B,set(A)) * list(B) ) > set(A) ) ).

tff(sy_c_Misc_Omap__mmupd,type,
    map_mmupd: 
      !>[B: $tType,A: $tType] : ( ( fun(B,option(A)) * set(B) * A ) > fun(B,option(A)) ) ).

tff(sy_c_Misc_Omap__to__set,type,
    map_to_set: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(product_prod(A,B)) ) ).

tff(sy_c_Misc_Omerge,type,
    merge: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Omerge__rel,type,
    merge_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),bool)) ).

tff(sy_c_Misc_Omergesort__by__rel,type,
    mergesort_by_rel: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Omergesort__by__rel__merge,type,
    merges9089515139780605204_merge: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Omergesort__by__rel__merge__rel,type,
    merges2244889521215249637ge_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),fun(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool)) ).

tff(sy_c_Misc_Omergesort__by__rel__rel,type,
    mergesort_by_rel_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,bool)),list(A)),fun(product_prod(fun(A,fun(A,bool)),list(A)),bool)) ).

tff(sy_c_Misc_Omergesort__by__rel__split,type,
    merges295452479951948502_split: 
      !>[A: $tType] : ( ( product_prod(list(A),list(A)) * list(A) ) > product_prod(list(A),list(A)) ) ).

tff(sy_c_Misc_Omergesort__by__rel__split__rel,type,
    merges7066485432131860899it_rel: 
      !>[A: $tType] : fun(product_prod(product_prod(list(A),list(A)),list(A)),fun(product_prod(product_prod(list(A),list(A)),list(A)),bool)) ).

tff(sy_c_Misc_Opairself,type,
    pairself: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(product_prod(A,A),product_prod(B,B)) ) ).

tff(sy_c_Misc_Opairself__rel,type,
    pairself_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,B),product_prod(A,A)),fun(product_prod(fun(A,B),product_prod(A,A)),bool)) ).

tff(sy_c_Misc_Opartition__rev,type,
    partition_rev: 
      !>[A: $tType] : ( ( fun(A,bool) * product_prod(list(A),list(A)) * list(A) ) > product_prod(list(A),list(A)) ) ).

tff(sy_c_Misc_Opartition__rev__rel,type,
    partition_rev_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),fun(product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),bool)) ).

tff(sy_c_Misc_Oquicksort__by__rel,type,
    quicksort_by_rel: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * list(A) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Oquicksort__by__rel__rel,type,
    quicksort_by_rel_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),fun(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool)) ).

tff(sy_c_Misc_Orel__of,type,
    rel_of: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * fun(product_prod(A,B),bool) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Misc_Orel__restrict,type,
    rel_restrict: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Misc_Oremove__rev,type,
    remove_rev: 
      !>[A: $tType] : ( A > fun(list(A),list(A)) ) ).

tff(sy_c_Misc_Orevg,type,
    revg: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Orevg__rel,type,
    revg_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),bool)) ).

tff(sy_c_Misc_Oset__to__map,type,
    set_to_map: 
      !>[B: $tType,A: $tType] : ( set(product_prod(B,A)) > fun(B,option(A)) ) ).

tff(sy_c_Misc_Osu__rel__fun,type,
    su_rel_fun: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,B)) * fun(A,B) ) > $o ) ).

tff(sy_c_Misc_Othe__default,type,
    the_default: 
      !>[A: $tType] : ( ( A * option(A) ) > A ) ).

tff(sy_c_Misc_Ouncurry,type,
    uncurry: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,C)) * product_prod(A,B) ) > C ) ).

tff(sy_c_Misc_Ozipf,type,
    zipf: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,C)) * list(A) * list(B) ) > list(C) ) ).

tff(sy_c_Misc_Ozipf__rel,type,
    zipf_rel: 
      !>[A: $tType,B: $tType,C: $tType] : fun(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),fun(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),bool)) ).

tff(sy_c_Multiset_Oadd__mset,type,
    add_mset: 
      !>[A: $tType] : fun(A,fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Ocomm__monoid__add__class_Osum__mset,type,
    comm_m7189776963980413722m_mset: 
      !>[A: $tType] : ( multiset(A) > A ) ).

tff(sy_c_Multiset_Ocomm__monoid__mset,type,
    comm_monoid_mset: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Multiset_Ocomm__monoid__mset_OF,type,
    comm_monoid_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(multiset(A),A) ) ).

tff(sy_c_Multiset_Ocomm__monoid__mult__class_Oprod__mset,type,
    comm_m9189036328036947845d_mset: 
      !>[A: $tType] : fun(multiset(A),A) ).

tff(sy_c_Multiset_Ofold__mset,type,
    fold_mset: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B ) > fun(multiset(A),B) ) ).

tff(sy_c_Multiset_Oimage__mset,type,
    image_mset: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(multiset(A),multiset(B)) ) ).

tff(sy_c_Multiset_Ointer__mset,type,
    inter_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Olinorder__class_Opart,type,
    linorder_part: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * A * list(B) ) > product_prod(list(B),product_prod(list(B),list(B))) ) ).

tff(sy_c_Multiset_Oms__strict,type,
    ms_strict: set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))) ).

tff(sy_c_Multiset_Oms__weak,type,
    ms_weak: set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))) ).

tff(sy_c_Multiset_Omset,type,
    mset: 
      !>[A: $tType] : fun(list(A),multiset(A)) ).

tff(sy_c_Multiset_Omset__set,type,
    mset_set: 
      !>[B: $tType] : ( set(B) > multiset(B) ) ).

tff(sy_c_Multiset_Omult,type,
    mult: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(multiset(A),multiset(A))) ) ).

tff(sy_c_Multiset_Omult1,type,
    mult1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(multiset(A),multiset(A))) ) ).

tff(sy_c_Multiset_Omulteqp__code,type,
    multeqp_code: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * multiset(A) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Omultiset_OAbs__multiset,type,
    abs_multiset: 
      !>[A: $tType] : fun(fun(A,nat),multiset(A)) ).

tff(sy_c_Multiset_Omultiset_Ocount,type,
    count: 
      !>[A: $tType] : fun(multiset(A),fun(A,nat)) ).

tff(sy_c_Multiset_Omultp,type,
    multp: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * multiset(A) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Omultp__code,type,
    multp_code: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * multiset(A) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Opcr__multiset,type,
    pcr_multiset: 
      !>[C: $tType,B: $tType] : ( fun(C,fun(B,bool)) > fun(fun(C,nat),fun(multiset(B),bool)) ) ).

tff(sy_c_Multiset_Opred__mset,type,
    pred_mset: 
      !>[A: $tType] : ( ( fun(A,bool) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Opw__leq,type,
    pw_leq: ( multiset(product_prod(nat,nat)) * multiset(product_prod(nat,nat)) ) > $o ).

tff(sy_c_Multiset_Oreplicate__mset,type,
    replicate_mset: 
      !>[A: $tType] : ( ( nat * A ) > multiset(A) ) ).

tff(sy_c_Multiset_Oset__mset,type,
    set_mset: 
      !>[A: $tType] : fun(multiset(A),set(A)) ).

tff(sy_c_Multiset_Osize__multiset,type,
    size_multiset: 
      !>[A: $tType] : ( fun(A,nat) > fun(multiset(A),nat) ) ).

tff(sy_c_Multiset_Osubset__eq__mset__impl,type,
    subset_eq_mset_impl: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > option(bool) ) ).

tff(sy_c_Multiset_Osubset__eq__mset__impl__rel,type,
    subset751672762298770561pl_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),bool)) ).

tff(sy_c_Multiset_Osubset__mset,type,
    subset_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),bool)) ).

tff(sy_c_Multiset_Osubseteq__mset,type,
    subseteq_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),bool)) ).

tff(sy_c_Multiset_Ounion__mset,type,
    union_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Owcount,type,
    wcount: 
      !>[A: $tType] : ( ( fun(A,nat) * multiset(A) ) > fun(A,nat) ) ).

tff(sy_c_Nat_OSuc,type,
    suc: fun(nat,nat) ).

tff(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( ( A * fun(nat,A) * nat ) > A ) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : fun(nat,A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( fun(A,A) * nat * A ) > A ) ).

tff(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

tff(sy_c_Nat__Bijection_Olist__decode__rel,type,
    nat_list_decode_rel: fun(nat,fun(nat,bool)) ).

tff(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: list(nat) > nat ).

tff(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: fun(list(nat),fun(list(nat),bool)) ).

tff(sy_c_Nat__Bijection_Oprod__decode,type,
    nat_prod_decode: nat > product_prod(nat,nat) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),bool)) ).

tff(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: product_prod(nat,nat) > nat ).

tff(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > set(nat) ).

tff(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: set(nat) > nat ).

tff(sy_c_Nat__Bijection_Osum__decode,type,
    nat_sum_decode: nat > sum_sum(nat,nat) ).

tff(sy_c_Num_OBitM,type,
    bitM: num > num ).

tff(sy_c_Num_Oinc,type,
    inc: num > num ).

tff(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Ois__num,type,
    neg_numeral_is_num: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( ( num * num ) > A ) ).

tff(sy_c_Num_Onum_OBit0,type,
    bit0: fun(num,num) ).

tff(sy_c_Num_Onum_OBit1,type,
    bit1: fun(num,num) ).

tff(sy_c_Num_Onum_OOne,type,
    one2: num ).

tff(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( ( A * fun(num,A) * fun(num,A) * num ) > A ) ).

tff(sy_c_Num_Onum__of__nat,type,
    num_of_nat: fun(nat,num) ).

tff(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : fun(num,A) ).

tff(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

tff(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Osqr,type,
    sqr: num > num ).

tff(sy_c_Old__Datatype_OAtom,type,
    old_Atom: 
      !>[A: $tType,B: $tType] : fun(sum_sum(A,nat),set(old_node(A,B))) ).

tff(sy_c_Old__Datatype_OIn0,type,
    old_In0: 
      !>[A: $tType,B: $tType] : ( set(old_node(A,B)) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OIn1,type,
    old_In1: 
      !>[A: $tType,B: $tType] : ( set(old_node(A,B)) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OLeaf,type,
    old_Leaf: 
      !>[A: $tType,B: $tType] : fun(A,set(old_node(A,B))) ).

tff(sy_c_Old__Datatype_ONode,type,
    old_Node: 
      !>[B: $tType,A: $tType] : set(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))) ).

tff(sy_c_Old__Datatype_ONumb,type,
    old_Numb: 
      !>[A: $tType,B: $tType] : fun(nat,set(old_node(A,B))) ).

tff(sy_c_Old__Datatype_OScons,type,
    old_Scons: 
      !>[A: $tType,B: $tType] : ( ( set(old_node(A,B)) * set(old_node(A,B)) ) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_Odprod,type,
    old_dprod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) * set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) > set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) ).

tff(sy_c_Old__Datatype_Odsum,type,
    old_dsum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) * set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) > set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) ).

tff(sy_c_Old__Datatype_Ondepth,type,
    old_ndepth: 
      !>[A: $tType,B: $tType] : ( old_node(A,B) > nat ) ).

tff(sy_c_Old__Datatype_Onode_OAbs__Node,type,
    old_Abs_Node: 
      !>[B: $tType,A: $tType] : ( product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)) > old_node(A,B) ) ).

tff(sy_c_Old__Datatype_Ontrunc,type,
    old_ntrunc: 
      !>[A: $tType,B: $tType] : ( nat > fun(set(old_node(A,B)),set(old_node(A,B))) ) ).

tff(sy_c_Old__Datatype_Ouprod,type,
    old_uprod: 
      !>[A: $tType,B: $tType] : ( ( set(set(old_node(A,B))) * set(set(old_node(A,B))) ) > set(set(old_node(A,B))) ) ).

tff(sy_c_Option_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( option(A) * fun(A,option(B)) ) > option(B) ) ).

tff(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : option(A) ).

tff(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : fun(A,option(A)) ).

tff(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,B) * option(A) ) > B ) ).

tff(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(option(A),option(Aa)) ) ).

tff(sy_c_Option_Ooption_Opred__option,type,
    pred_option: 
      !>[A: $tType] : ( fun(A,bool) > fun(option(A),bool) ) ).

tff(sy_c_Option_Ooption_Orec__option,type,
    rec_option: 
      !>[C: $tType,A: $tType] : ( ( C * fun(A,C) ) > fun(option(A),C) ) ).

tff(sy_c_Option_Ooption_Orel__option,type,
    rel_option: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(option(A),fun(option(B),bool)) ) ).

tff(sy_c_Option_Ooption_Oset__option,type,
    set_option: 
      !>[A: $tType] : fun(option(A),set(A)) ).

tff(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( fun(A,nat) > fun(option(A),nat) ) ).

tff(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : fun(option(A),A) ).

tff(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( set(option(A)) > set(A) ) ).

tff(sy_c_Order__Relation_OAbove,type,
    order_Above: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OAboveS,type,
    order_AboveS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OUnder,type,
    order_Under: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OUnderS,type,
    order_UnderS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_Oabove,type,
    order_above: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_OaboveS,type,
    order_aboveS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_Olinear__order__on,type,
    order_679001287576687338der_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Oofilter,type,
    order_ofilter: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > $o ) ).

tff(sy_c_Order__Relation_Opartial__order__on,type,
    order_7125193373082350890der_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Opreorder__on,type,
    order_preorder_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Orelation__of,type,
    order_relation_of: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * set(A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Order__Relation_Ounder,type,
    order_under: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_OunderS,type,
    order_underS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_Owell__order__on,type,
    order_well_order_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

tff(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(fun(A,bool),A) ) ).

tff(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oorder_Omono,type,
    mono: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(A,bool)) > fun(fun(A,B),bool) ) ).

tff(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oordering,type,
    ordering: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Orderings_Oordering__axioms,type,
    ordering_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) * A ) > $o ) ).

tff(sy_c_Orderings_Oordering__top__axioms,type,
    ordering_top_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A ) > $o ) ).

tff(sy_c_Orderings_Opartial__preordering,type,
    partial_preordering: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Orderings_Opreordering,type,
    preordering: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Orderings_Opreordering__axioms,type,
    preordering_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) ) > $o ) ).

tff(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

tff(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( A > fun(set(A),A) ) ).

tff(sy_c_Partial__Function_Oflat__ord,type,
    partial_flat_ord: 
      !>[A: $tType] : ( A > fun(A,fun(A,bool)) ) ).

tff(sy_c_Partial__Function_Ofun__lub,type,
    partial_fun_lub: 
      !>[C: $tType,B: $tType,A: $tType] : ( fun(set(C),B) > fun(set(fun(A,C)),fun(A,B)) ) ).

tff(sy_c_Partial__Function_Ofun__ord,type,
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,bool)) > fun(fun(C,A),fun(fun(C,B),bool)) ) ).

tff(sy_c_Partial__Function_Oimg__lub,type,
    partial_img_lub: 
      !>[A: $tType,C: $tType,D: $tType,B: $tType] : ( ( fun(A,C) * fun(D,B) * fun(set(C),D) ) > fun(set(A),B) ) ).

tff(sy_c_Partial__Function_Oimg__ord,type,
    partial_img_ord: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( fun(A,C) * fun(C,fun(C,B)) ) > fun(A,fun(A,B)) ) ).

tff(sy_c_Partial__Function_Opartial__function__definitions,type,
    partia7178651479351089652itions: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(set(A),A) ) > $o ) ).

tff(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : fun(A,fun(nat,A)) ).

tff(sy_c_Predicate_OSeq,type,
    seq2: 
      !>[A: $tType] : ( fun(product_unit,seq(A)) > pred(A) ) ).

tff(sy_c_Predicate_Obind,type,
    bind2: 
      !>[A: $tType,B: $tType] : ( ( pred(A) * fun(A,pred(B)) ) > pred(B) ) ).

tff(sy_c_Predicate_Oif__pred,type,
    if_pred: bool > pred(product_unit) ).

tff(sy_c_Predicate_Ois__empty,type,
    is_empty: 
      !>[A: $tType] : ( pred(A) > $o ) ).

tff(sy_c_Predicate_Oiterate__upto,type,
    iterate_upto: 
      !>[A: $tType] : ( ( fun(code_natural,A) * code_natural * code_natural ) > pred(A) ) ).

tff(sy_c_Predicate_Oiterate__upto__rel,type,
    iterate_upto_rel: 
      !>[A: $tType] : fun(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),fun(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),bool)) ).

tff(sy_c_Predicate_Omap,type,
    map2: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(pred(A),pred(B)) ) ).

tff(sy_c_Predicate_Onot__pred,type,
    not_pred: pred(product_unit) > pred(product_unit) ).

tff(sy_c_Predicate_Opred_OPred,type,
    pred2: 
      !>[A: $tType] : fun(fun(A,bool),pred(A)) ).

tff(sy_c_Predicate_Opred_Oeval,type,
    eval: 
      !>[A: $tType] : fun(pred(A),fun(A,bool)) ).

tff(sy_c_Predicate_Opred__of__seq,type,
    pred_of_seq: 
      !>[A: $tType] : fun(seq(A),pred(A)) ).

tff(sy_c_Predicate_Opred__of__set,type,
    pred_of_set: 
      !>[A: $tType] : fun(set(A),pred(A)) ).

tff(sy_c_Predicate_Oseq_OEmpty,type,
    empty: 
      !>[A: $tType] : seq(A) ).

tff(sy_c_Predicate_Oseq_OInsert,type,
    insert: 
      !>[A: $tType] : ( ( A * pred(A) ) > seq(A) ) ).

tff(sy_c_Predicate_Oseq_Ocase__seq,type,
    case_seq: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,fun(pred(A),B)) * fun(pred(A),fun(seq(A),B)) * seq(A) ) > B ) ).

tff(sy_c_Predicate_Oset__of__pred,type,
    set_of_pred: 
      !>[A: $tType] : fun(pred(A),set(A)) ).

tff(sy_c_Predicate_Oset__of__seq,type,
    set_of_seq: 
      !>[A: $tType] : fun(seq(A),set(A)) ).

tff(sy_c_Predicate_Osingle,type,
    single: 
      !>[A: $tType] : fun(A,pred(A)) ).

tff(sy_c_Predicate_Osingleton,type,
    singleton: 
      !>[A: $tType] : ( ( fun(product_unit,A) * pred(A) ) > A ) ).

tff(sy_c_Predicate__Compile_Ocontains__pred,type,
    predic7144156976422707464s_pred: 
      !>[A: $tType] : ( ( set(A) * A ) > pred(product_unit) ) ).

tff(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : fun(A,fun(B,product_prod(A,B))) ).

tff(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_OUnity,type,
    product_Unity: product_unit ).

tff(sy_c_Product__Type_Oapfst,type,
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] : ( fun(A,C) > fun(product_prod(A,B),product_prod(C,B)) ) ).

tff(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : fun(fun(B,C),fun(product_prod(A,B),product_prod(A,C))) ).

tff(sy_c_Product__Type_Ocurry,type,
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(product_prod(A,B),C) * A * B ) > C ) ).

tff(sy_c_Product__Type_Ointernal__case__prod,type,
    produc5280177257484947105e_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,C)) * product_prod(A,B) ) > C ) ).

tff(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,C) * fun(B,D) ) > fun(product_prod(A,B),product_prod(C,D)) ) ).

tff(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( fun(A,fun(B,T)) * product_prod(A,B) ) > T ) ).

tff(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : fun(fun(A,fun(B,C)),fun(product_prod(A,B),C)) ).

tff(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),A) ).

tff(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),B) ).

tff(sy_c_Product__Type_Oprod_Oswap,type,
    product_swap: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),product_prod(B,A)) ).

tff(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_Oscomp,type,
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( fun(A,product_prod(B,C)) * fun(B,fun(C,D)) ) > fun(A,D) ) ).

tff(sy_c_Product__Type_Ounit_OAbs__unit,type,
    product_Abs_unit: fun(bool,product_unit) ).

tff(sy_c_Product__Type_Ounit_ORep__unit,type,
    product_Rep_unit: fun(product_unit,bool) ).

tff(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : itself(A) ).

tff(sy_c_Quotient_OQuotient3,type,
    quotient3: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,B) * fun(B,A) ) > $o ) ).

tff(sy_c_Random_Oinc__shift,type,
    inc_shift: ( code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Oiterate,type,
    iterate: 
      !>[B: $tType,A: $tType] : ( ( code_natural * fun(B,fun(A,product_prod(B,A))) ) > fun(B,fun(A,product_prod(B,A))) ) ).

tff(sy_c_Random_Oiterate__rel,type,
    iterate_rel: 
      !>[B: $tType,A: $tType] : fun(product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),fun(product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),bool)) ).

tff(sy_c_Random_Olog,type,
    log: ( code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Olog__rel,type,
    log_rel: fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),bool)) ).

tff(sy_c_Random_Ominus__shift,type,
    minus_shift: ( code_natural * code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Onext,type,
    next: fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))) ).

tff(sy_c_Random_Opick,type,
    pick: 
      !>[A: $tType] : ( ( list(product_prod(code_natural,A)) * code_natural ) > A ) ).

tff(sy_c_Random_Orange,type,
    range: code_natural > fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))) ).

tff(sy_c_Random_Oselect,type,
    select: 
      !>[A: $tType] : ( list(A) > fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random_Oselect__weight,type,
    select_weight: 
      !>[A: $tType] : ( list(product_prod(code_natural,A)) > fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random_Osplit__seed,type,
    split_seed: product_prod(code_natural,code_natural) > product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)) ).

tff(sy_c_Random__Pred_ORandom,type,
    random_Random: 
      !>[A: $tType] : ( fun(product_prod(code_natural,code_natural),product_prod(product_prod(A,fun(product_unit,code_term)),product_prod(code_natural,code_natural))) > fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random__Pred_Obind,type,
    random_bind: 
      !>[A: $tType,B: $tType] : ( ( fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) * fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))) ) > fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random__Pred_Oempty,type,
    random_empty: 
      !>[A: $tType] : fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) ).

tff(sy_c_Random__Pred_Oiterate__upto,type,
    random_iterate_upto: 
      !>[A: $tType] : ( ( fun(code_natural,A) * code_natural * code_natural ) > fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random__Pred_Omap,type,
    random_map: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) ) > fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random__Pred_Onot__randompred,type,
    random6974930770145893639ompred: ( fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))) * product_prod(code_natural,code_natural) ) > product_prod(pred(product_unit),product_prod(code_natural,code_natural)) ).

tff(sy_c_Random__Pred_Osingle,type,
    random_single: 
      !>[A: $tType] : fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))) ).

tff(sy_c_Random__Pred_Ounion,type,
    random_union: 
      !>[A: $tType] : ( ( fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) * fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) * product_prod(code_natural,code_natural) ) > product_prod(pred(A),product_prod(code_natural,code_natural)) ) ).

tff(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: fun(product_prod(int,int),rat) ).

tff(sy_c_Rat_OFract,type,
    fract: fun(int,fun(int,rat)) ).

tff(sy_c_Rat_OFrct,type,
    frct: product_prod(int,int) > rat ).

tff(sy_c_Rat_ORep__Rat,type,
    rep_Rat: fun(rat,product_prod(int,int)) ).

tff(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : fun(rat,A) ).

tff(sy_c_Rat_Onormalize,type,
    normalize: product_prod(int,int) > product_prod(int,int) ).

tff(sy_c_Rat_Oof__int,type,
    of_int: int > rat ).

tff(sy_c_Rat_Opcr__rat,type,
    pcr_rat: fun(product_prod(int,int),fun(rat,bool)) ).

tff(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > product_prod(int,int) ).

tff(sy_c_Rat_Oratrel,type,
    ratrel: fun(product_prod(int,int),fun(product_prod(int,int),bool)) ).

tff(sy_c_Ref__Time_Oalloc,type,
    ref_alloc: 
      !>[A: $tType] : ( ( A * heap_ext(product_unit) ) > product_prod(ref(A),heap_ext(product_unit)) ) ).

tff(sy_c_Ref__Time_Ochange,type,
    ref_change: 
      !>[A: $tType] : ( ( fun(A,A) * ref(A) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Ref__Time_Oget,type,
    ref_get: 
      !>[A: $tType] : ( heap_ext(product_unit) > fun(ref(A),A) ) ).

tff(sy_c_Ref__Time_Olookup,type,
    ref_lookup: 
      !>[A: $tType] : ( ref(A) > heap_Time_Heap(A) ) ).

tff(sy_c_Ref__Time_Opresent,type,
    ref_present: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * ref(A) ) > $o ) ).

tff(sy_c_Ref__Time_Oref,type,
    ref_ref: 
      !>[A: $tType] : ( A > heap_Time_Heap(ref(A)) ) ).

tff(sy_c_Ref__Time_Oset,type,
    ref_set: 
      !>[A: $tType] : ( ( ref(A) * A * heap_ext(product_unit) ) > heap_ext(product_unit) ) ).

tff(sy_c_Ref__Time_Oupdate,type,
    ref_update: 
      !>[A: $tType] : ( ( ref(A) * A ) > heap_Time_Heap(product_unit) ) ).

tff(sy_c_Relation_ODomain,type,
    domain: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(A) ) ).

tff(sy_c_Relation_ODomainp,type,
    domainp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(A,bool) ) ).

tff(sy_c_Relation_OField,type,
    field2: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(A) ) ).

tff(sy_c_Relation_OId,type,
    id2: 
      !>[A: $tType] : set(product_prod(A,A)) ).

tff(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( set(A) > set(product_prod(A,A)) ) ).

tff(sy_c_Relation_OImage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,B)) * set(A) ) > set(B) ) ).

tff(sy_c_Relation_ORange,type,
    range2: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(B) ) ).

tff(sy_c_Relation_ORangep,type,
    rangep: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(B,bool) ) ).

tff(sy_c_Relation_Oantisym,type,
    antisym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oantisymp,type,
    antisymp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Relation_Oasym,type,
    asym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oasymp,type,
    asymp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Relation_Oconverse,type,
    converse: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(B,A)) ) ).

tff(sy_c_Relation_Oconversep,type,
    conversep: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > fun(B,fun(A,bool)) ) ).

tff(sy_c_Relation_Oinv__image,type,
    inv_image: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * fun(A,B) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oirreflp,type,
    irreflp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Relation_Orefl__on,type,
    refl_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Relation_Oreflp,type,
    reflp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(product_prod(A,B)) * set(product_prod(B,C)) ) > set(product_prod(A,C)) ) ).

tff(sy_c_Relation_Orelcompp,type,
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,bool)) * fun(B,fun(C,bool)) ) > fun(A,fun(C,bool)) ) ).

tff(sy_c_Relation_Osingle__valued,type,
    single_valued: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > $o ) ).

tff(sy_c_Relation_Osingle__valuedp,type,
    single_valuedp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > $o ) ).

tff(sy_c_Relation_Osym,type,
    sym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Osymp,type,
    symp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Relation_Ototal__on,type,
    total_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Relation_Otrans,type,
    trans: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( ( A * A ) > $o ) ).

tff(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( ( A * A ) > bool ) ).

tff(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Onormalization__semidom__class_Onormalize,type,
    normal6383669964737779283malize: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Rings_Ounit__factor__class_Ounit__factor,type,
    unit_f5069060285200089521factor: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : fun(bool,A) ).

tff(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : fun(fun(A,bool),set(A)) ).

tff(sy_c_Set_OPow,type,
    pow: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Set_Obind,type,
    bind3: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(B) ) ).

tff(sy_c_Set_Odisjnt,type,
    disjnt: 
      !>[A: $tType] : ( ( set(A) * set(A) ) > $o ) ).

tff(sy_c_Set_Ofilter,type,
    filter3: 
      !>[A: $tType] : ( ( fun(A,bool) * set(A) ) > set(A) ) ).

tff(sy_c_Set_Oimage,type,
    image2: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(set(A),set(B)) ) ).

tff(sy_c_Set_Oinsert,type,
    insert2: 
      !>[A: $tType] : ( A > fun(set(A),set(A)) ) ).

tff(sy_c_Set_Ois__empty,type,
    is_empty2: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Set_Ois__singleton,type,
    is_singleton: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Set_Opairwise,type,
    pairwise: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * set(A) ) > $o ) ).

tff(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : fun(A,fun(set(A),set(A))) ).

tff(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : fun(fun(A,B),fun(set(B),set(A))) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( fun(nat,fun(A,A)) * nat * nat * A ) > A ) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : fun(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),fun(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool)) ).

tff(sy_c_Set__Interval_Oord_OatLeast,type,
    set_atLeast: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatLeastAtMost,type,
    set_atLeastAtMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatLeastLessThan,type,
    set_atLeastLessThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatMost,type,
    set_atMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThan,type,
    set_greaterThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThanAtMost,type,
    set_gr3752724095348155675AtMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * fun(A,fun(A,bool)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,
    set_gr287244882034783167ssThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OlessThan,type,
    set_lessThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,bool)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_String_Ochar_OChar,type,
    char2: ( bool * bool * bool * bool * bool * bool * bool * bool ) > char ).

tff(sy_c_Sum__Type_OInl,type,
    sum_Inl: 
      !>[A: $tType,B: $tType] : fun(A,sum_sum(A,B)) ).

tff(sy_c_Sum__Type_OInr,type,
    sum_Inr: 
      !>[B: $tType,A: $tType] : fun(B,sum_sum(A,B)) ).

tff(sy_c_Sum__Type_OPlus,type,
    sum_Plus: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(sum_sum(A,B)) ) ).

tff(sy_c_Sum__Type_Omap__sum,type,
    sum_map_sum: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,C) * fun(B,D) ) > fun(sum_sum(A,B),sum_sum(C,D)) ) ).

tff(sy_c_Sum__Type_Osum_Ocase__sum,type,
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( fun(A,C) * fun(B,C) ) > fun(sum_sum(A,B),C) ) ).

tff(sy_c_Syntax__Match_Oac__operator,type,
    syntax_ac_operator: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Syntax__Match_Osyntax__fo__nomatch,type,
    syntax7388354845996824322omatch: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_Transfer_Obi__unique,type,
    bi_unique: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > $o ) ).

tff(sy_c_Transfer_Oleft__unique,type,
    left_unique: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > $o ) ).

tff(sy_c_Transfer_Oright__total,type,
    right_total: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,bool)) > $o ) ).

tff(sy_c_Transitive__Closure_Oacyclic,type,
    transitive_acyclic: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Ortranclp,type,
    transitive_rtranclp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(A,fun(A,bool)) ) ).

tff(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Otranclp,type,
    transitive_tranclp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(A,fun(A,bool)) ) ).

tff(sy_c_Typedef_Otype__definition,type,
    type_definition: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Typerep_Otyperep__class_Otyperep,type,
    typerep_typerep: 
      !>[A: $tType] : ( itself(A) > typerep ) ).

tff(sy_c_Wellfounded_Oacc,type,
    acc: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(A) ) ).

tff(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(A,bool) ) ).

tff(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : set(product_prod(set(A),set(A))) ).

tff(sy_c_Wellfounded_Oless__than,type,
    less_than: set(product_prod(nat,nat)) ).

tff(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_Wellfounded_Omax__extp,type,
    max_extp: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > fun(set(A),fun(set(A),bool)) ) ).

tff(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( fun(A,nat) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( fun(A,nat) * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set(product_prod(nat,nat)) ).

tff(sy_c_Wellfounded_Owf,type,
    wf: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Wellfounded_OwfP,type,
    wfP: 
      !>[A: $tType] : ( fun(A,fun(A,bool)) > $o ) ).

tff(sy_c_Wfrec_Oadm__wf,type,
    adm_wf: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(fun(A,B),fun(A,B)) ) > $o ) ).

tff(sy_c_Wfrec_Ocut,type,
    cut: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(product_prod(A,A)) * A ) > fun(A,B) ) ).

tff(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( fun(A,bool) * fun(A,set(product_prod(B,B))) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_Zorn_OChains,type,
    chains: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(set(A)) ) ).

tff(sy_c_Zorn_Ochains,type,
    chains2: 
      !>[A: $tType] : ( set(set(A)) > set(set(set(A))) ) ).

tff(sy_c_Zorn_Oinit__seg__of,type,
    init_seg_of: 
      !>[A: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))) ).

tff(sy_c_Zorn_Opred__on_Ochain,type,
    pred_chain: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,bool)) ) > fun(set(A),bool) ) ).

tff(sy_c_aa,type,
    aa: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A ) > B ) ).

tff(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( fun(A,bool) > A ) ).

tff(sy_c_fEx,type,
    fEx: 
      !>[A: $tType] : fun(fun(A,bool),bool) ).

tff(sy_c_fFalse,type,
    fFalse: bool ).

tff(sy_c_fNot,type,
    fNot: fun(bool,bool) ).

tff(sy_c_fTrue,type,
    fTrue: bool ).

tff(sy_c_fconj,type,
    fconj: ( bool * bool ) > bool ).

tff(sy_c_fdisj,type,
    fdisj: ( bool * bool ) > bool ).

tff(sy_c_fequal,type,
    fequal: 
      !>[A: $tType] : fun(A,fun(A,bool)) ).

tff(sy_c_member,type,
    member: 
      !>[A: $tType] : ( ( A * set(A) ) > bool ) ).

tff(sy_c_pp,type,
    pp: bool > $o ).

tff(sy_v_P,type,
    p: assn ).

tff(sy_v_Q,type,
    q: fun(a,assn) ).

tff(sy_v_Q1,type,
    q1: fun(a,assn) ).

tff(sy_v_Q2,type,
    q2: fun(a,assn) ).

tff(sy_v_b,type,
    b: bool ).

tff(sy_v_f,type,
    f: heap_Time_Heap(a) ).

tff(sy_v_g,type,
    g: heap_Time_Heap(a) ).

% Relevant facts (6330)
tff(fact_0_B,axiom,
    ( pp(b)
   => hoare_hoare_triple(a,p,f,q1) ) ).

% B
tff(fact_1_NB,axiom,
    ( ~ pp(b)
   => hoare_hoare_triple(a,p,g,q2) ) ).

% NB
tff(fact_2_if__rule,axiom,
    ! [A: $tType,B2: bool,P: assn,F: heap_Time_Heap(A),Q: fun(A,assn),G: heap_Time_Heap(A)] :
      ( ( pp(B2)
       => hoare_hoare_triple(A,P,F,Q) )
     => ( ( ~ pp(B2)
         => hoare_hoare_triple(A,P,G,Q) )
       => hoare_hoare_triple(A,P,if(heap_Time_Heap(A),B2,F,G),Q) ) ) ).

% if_rule
tff(fact_3_return__wp__rule,axiom,
    ! [A: $tType,Q: fun(A,assn),X: A] : hoare_hoare_triple(A,aa(A,assn,Q,X),aa(A,heap_Time_Heap(A),heap_Time_return(A),X),Q) ).

% return_wp_rule
tff(fact_4_M,axiom,
    ! [X: a] : entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(a,assn,q1,X)),pure_assn(b))),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(a,assn,q2,X)),pure_assn(aa(bool,bool,fNot,b)))),aa(a,assn,q,X)) ).

% M
tff(fact_5_bind__rule,axiom,
    ! [A: $tType,B: $tType,P: assn,F: heap_Time_Heap(A),R: fun(A,assn),G: fun(A,heap_Time_Heap(B)),Q: fun(B,assn)] :
      ( hoare_hoare_triple(A,P,F,R)
     => ( ! [X2: A] : hoare_hoare_triple(B,aa(A,assn,R,X2),aa(A,heap_Time_Heap(B),G,X2),Q)
       => hoare_hoare_triple(B,P,heap_Time_bind(A,B,F,G),Q) ) ) ).

% bind_rule
tff(fact_6_false__rule,axiom,
    ! [A: $tType,C2: heap_Time_Heap(A),Q: fun(A,assn)] : hoare_hoare_triple(A,bot_bot(assn),C2,Q) ).

% false_rule
tff(fact_7_cons__rule,axiom,
    ! [A: $tType,P: assn,P2: assn,Q: fun(A,assn),Q2: fun(A,assn),C2: heap_Time_Heap(A)] :
      ( entails(P,P2)
     => ( ! [X2: A] : entails(aa(A,assn,Q,X2),aa(A,assn,Q2,X2))
       => ( hoare_hoare_triple(A,P2,C2,Q)
         => hoare_hoare_triple(A,P,C2,Q2) ) ) ) ).

% cons_rule
tff(fact_8_cons__post__rule,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),Q2: fun(A,assn)] :
      ( hoare_hoare_triple(A,P,C2,Q)
     => ( ! [X2: A] : entails(aa(A,assn,Q,X2),aa(A,assn,Q2,X2))
       => hoare_hoare_triple(A,P,C2,Q2) ) ) ).

% cons_post_rule
tff(fact_9_hoare__triple__preI,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H))
         => hoare_hoare_triple(A,P,C2,Q) )
     => hoare_hoare_triple(A,P,C2,Q) ) ).

% hoare_triple_preI
tff(fact_10_new__addr__refl,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat)] : ( hoare_new_addrs(H2,As,H2) = As ) ).

% new_addr_refl
tff(fact_11_raise__iff,axiom,
    ! [A: $tType,P: assn,S: list(char),Q: fun(A,assn)] :
      ( hoare_hoare_triple(A,P,heap_Time_raise(A,S),Q)
    <=> ( P = bot_bot(assn) ) ) ).

% raise_iff
tff(fact_12_raise__rule,axiom,
    ! [A: $tType,S: list(char),Q: fun(A,assn)] : hoare_hoare_triple(A,bot_bot(assn),heap_Time_raise(A,S),Q) ).

% raise_rule
tff(fact_13_norm__pre__pure__iff__sng,axiom,
    ! [A: $tType,B2: bool,F: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( hoare_hoare_triple(A,pure_assn(B2),F,Q)
    <=> ( pp(B2)
       => hoare_hoare_triple(A,one_one(assn),F,Q) ) ) ).

% norm_pre_pure_iff_sng
tff(fact_14_norm__pre__pure__iff,axiom,
    ! [A: $tType,P: assn,B2: bool,F: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( hoare_hoare_triple(A,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),pure_assn(B2)),F,Q)
    <=> ( pp(B2)
       => hoare_hoare_triple(A,P,F,Q) ) ) ).

% norm_pre_pure_iff
tff(fact_15_norm__pre__pure__rule1,axiom,
    ! [A: $tType,B2: bool,P: assn,F: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( ( pp(B2)
       => hoare_hoare_triple(A,P,F,Q) )
     => hoare_hoare_triple(A,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),pure_assn(B2)),F,Q) ) ).

% norm_pre_pure_rule1
tff(fact_16_norm__pre__pure__rule2,axiom,
    ! [A: $tType,B2: bool,F: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( ( pp(B2)
       => hoare_hoare_triple(A,one_one(assn),F,Q) )
     => hoare_hoare_triple(A,pure_assn(B2),F,Q) ) ).

% norm_pre_pure_rule2
tff(fact_17_ent__pure__post__iff__sng,axiom,
    ! [P: assn,B2: bool] :
      ( entails(P,pure_assn(B2))
    <=> ( ! [H3: product_prod(heap_ext(product_unit),set(nat))] :
            ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H3))
           => pp(B2) )
        & entails(P,one_one(assn)) ) ) ).

% ent_pure_post_iff_sng
tff(fact_18_ent__pure__post__iff,axiom,
    ! [P: assn,Q: assn,B2: bool] :
      ( entails(P,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),pure_assn(B2)))
    <=> ( ! [H3: product_prod(heap_ext(product_unit),set(nat))] :
            ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H3))
           => pp(B2) )
        & entails(P,Q) ) ) ).

% ent_pure_post_iff
tff(fact_19_ent__pure__pre__iff__sng,axiom,
    ! [B2: bool,Q: assn] :
      ( entails(pure_assn(B2),Q)
    <=> ( pp(B2)
       => entails(one_one(assn),Q) ) ) ).

% ent_pure_pre_iff_sng
tff(fact_20_ent__false__iff,axiom,
    ! [P: assn] :
      ( entails(P,bot_bot(assn))
    <=> ! [H3: product_prod(heap_ext(product_unit),set(nat))] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H3)) ) ).

% ent_false_iff
tff(fact_21_ent__pure__pre__iff,axiom,
    ! [P: assn,B2: bool,Q: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),pure_assn(B2)),Q)
    <=> ( pp(B2)
       => entails(P,Q) ) ) ).

% ent_pure_pre_iff
tff(fact_22_mod__pure__star__dist,axiom,
    ! [P: assn,B2: bool,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),pure_assn(B2))),H2))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
        & pp(B2) ) ) ).

% mod_pure_star_dist
tff(fact_23_raise__bind,axiom,
    ! [B: $tType,A: $tType,E2: list(char),F: fun(B,heap_Time_Heap(A))] : ( heap_Time_bind(B,A,heap_Time_raise(B,E2),F) = heap_Time_raise(A,E2) ) ).

% raise_bind
tff(fact_24_assn__basic__inequalities_I3_J,axiom,
    bot_bot(assn) != one_one(assn) ).

% assn_basic_inequalities(3)
tff(fact_25_pure__false,axiom,
    pure_assn(fFalse) = bot_bot(assn) ).

% pure_false
tff(fact_26_pure__assn__eq__false__iff,axiom,
    ! [P: bool] :
      ( ( pure_assn(P) = bot_bot(assn) )
    <=> ~ pp(P) ) ).

% pure_assn_eq_false_iff
tff(fact_27_pure__true,axiom,
    pure_assn(fTrue) = one_one(assn) ).

% pure_true
tff(fact_28_pure__assn__eq__emp__iff,axiom,
    ! [P: bool] :
      ( ( pure_assn(P) = one_one(assn) )
    <=> pp(P) ) ).

% pure_assn_eq_emp_iff
tff(fact_29_Rep__assn__inject,axiom,
    ! [X: assn,Y: assn] :
      ( ( aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,X) = aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Y) )
    <=> ( X = Y ) ) ).

% Rep_assn_inject
tff(fact_30_pure__assn__eq__conv,axiom,
    ! [P: bool,Q: bool] :
      ( ( pure_assn(P) = pure_assn(Q) )
    <=> ( pp(P)
      <=> pp(Q) ) ) ).

% pure_assn_eq_conv
tff(fact_31_merge__pure__star,axiom,
    ! [A3: bool,B2: bool] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),pure_assn(A3)),pure_assn(B2)) = pure_assn(fconj(A3,B2)) ) ).

% merge_pure_star
tff(fact_32_mod__or__dist,axiom,
    ! [P: assn,Q: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),P),Q)),H2))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
        | pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H2)) ) ) ).

% mod_or_dist
tff(fact_33_star__false__right,axiom,
    ! [P: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),bot_bot(assn)) = bot_bot(assn) ) ).

% star_false_right
tff(fact_34_star__false__left,axiom,
    ! [P: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),bot_bot(assn)),P) = bot_bot(assn) ) ).

% star_false_left
tff(fact_35_merge__pure__or,axiom,
    ! [A3: bool,B2: bool] : ( aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),pure_assn(A3)),pure_assn(B2)) = pure_assn(fdisj(A3,B2)) ) ).

% merge_pure_or
tff(fact_36_assn__times__assoc,axiom,
    ! [P: assn,Q: assn,R: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q)),R) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),R)) ) ).

% assn_times_assoc
tff(fact_37_assn__times__comm,axiom,
    ! [P: assn,Q: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),P) ) ).

% assn_times_comm
tff(fact_38_ent__trans,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( entails(P,Q)
     => ( entails(Q,R)
       => entails(P,R) ) ) ).

% ent_trans
tff(fact_39_ent__refl,axiom,
    ! [P: assn] : entails(P,P) ).

% ent_refl
tff(fact_40_ent__iffI,axiom,
    ! [A4: assn,B3: assn] :
      ( entails(A4,B3)
     => ( entails(B3,A4)
       => ( A4 = B3 ) ) ) ).

% ent_iffI
tff(fact_41_fold__if__return,axiom,
    ! [A: $tType,B2: bool,C2: A,D2: A] :
      ( ( pp(B2)
       => ( aa(A,heap_Time_Heap(A),heap_Time_return(A),C2) = aa(A,heap_Time_Heap(A),heap_Time_return(A),if(A,B2,C2,D2)) ) )
      & ( ~ pp(B2)
       => ( aa(A,heap_Time_Heap(A),heap_Time_return(A),D2) = aa(A,heap_Time_Heap(A),heap_Time_return(A),if(A,B2,C2,D2)) ) ) ) ).

% fold_if_return
tff(fact_42_mod__starE,axiom,
    ! [A3: assn,B2: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),B2)),H2))
     => ~ ( ? [X_1: product_prod(heap_ext(product_unit),set(nat))] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,A3),X_1))
         => ! [H_2: product_prod(heap_ext(product_unit),set(nat))] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,B2),H_2)) ) ) ).

% mod_starE
tff(fact_43_mod__starD,axiom,
    ! [A4: assn,B3: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),B3)),H2))
     => ? [H1: product_prod(heap_ext(product_unit),set(nat)),H22: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,A4),H1))
          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,B3),H22)) ) ) ).

% mod_starD
tff(fact_44_entails__def,axiom,
    ! [P: assn,Q: assn] :
      ( entails(P,Q)
    <=> ! [H3: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H3))
         => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H3)) ) ) ).

% entails_def
tff(fact_45_mem__Collect__eq,axiom,
    ! [A: $tType,A3: A,P: fun(A,bool)] :
      ( pp(member(A,A3,aa(fun(A,bool),set(A),collect(A),P)))
    <=> pp(aa(A,bool,P,A3)) ) ).

% mem_Collect_eq
tff(fact_46_Collect__mem__eq,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),A4)) = A4 ) ).

% Collect_mem_eq
tff(fact_47_Collect__cong,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( ! [X2: A] :
          ( pp(aa(A,bool,P,X2))
        <=> pp(aa(A,bool,Q,X2)) )
     => ( aa(fun(A,bool),set(A),collect(A),P) = aa(fun(A,bool),set(A),collect(A),Q) ) ) ).

% Collect_cong
tff(fact_48_ext,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),G: fun(A,B)] :
      ( ! [X2: A] : ( aa(A,B,F,X2) = aa(A,B,G,X2) )
     => ( F = G ) ) ).

% ext
tff(fact_49_entailsI,axiom,
    ! [P: assn,Q: assn] :
      ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H))
         => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H)) )
     => entails(P,Q) ) ).

% entailsI
tff(fact_50_entailsD,axiom,
    ! [P: assn,Q: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( entails(P,Q)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H2)) ) ) ).

% entailsD
tff(fact_51_ent__fwd,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat)),Q: assn] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
     => ( entails(P,Q)
       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H2)) ) ) ).

% ent_fwd
tff(fact_52_ent__star__mono,axiom,
    ! [P: assn,P2: assn,Q: assn,Q2: assn] :
      ( entails(P,P2)
     => ( entails(Q,Q2)
       => entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P2),Q2)) ) ) ).

% ent_star_mono
tff(fact_53_star__or__dist2,axiom,
    ! [C3: assn,A4: assn,B3: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C3),aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B3)) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C3),A4)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C3),B3)) ) ).

% star_or_dist2
tff(fact_54_star__or__dist1,axiom,
    ! [A4: assn,B3: assn,C3: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B3)),C3) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),C3)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B3),C3)) ) ).

% star_or_dist1
tff(fact_55_ent__disjI2__direct,axiom,
    ! [B3: assn,A4: assn] : entails(B3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B3)) ).

% ent_disjI2_direct
tff(fact_56_ent__disjI1__direct,axiom,
    ! [A4: assn,B3: assn] : entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B3)) ).

% ent_disjI1_direct
tff(fact_57_ent__disjI2_H,axiom,
    ! [A4: assn,C3: assn,B3: assn] :
      ( entails(A4,C3)
     => entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B3),C3)) ) ).

% ent_disjI2'
tff(fact_58_ent__disjI1_H,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( entails(A4,B3)
     => entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B3),C3)) ) ).

% ent_disjI1'
tff(fact_59_ent__disjI2,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),P),Q),R)
     => entails(Q,R) ) ).

% ent_disjI2
tff(fact_60_ent__disjI1,axiom,
    ! [P: assn,Q: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),P),Q),R)
     => entails(P,R) ) ).

% ent_disjI1
tff(fact_61_ent__disjE,axiom,
    ! [A4: assn,C3: assn,B3: assn] :
      ( entails(A4,C3)
     => ( entails(B3,C3)
       => entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B3),C3) ) ) ).

% ent_disjE
tff(fact_62_mod__false,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,bot_bot(assn)),H2)) ).

% mod_false
tff(fact_63_assn__one__left,axiom,
    ! [P: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),one_one(assn)),P) = P ) ).

% assn_one_left
tff(fact_64_ent__false,axiom,
    ! [P: assn] : entails(bot_bot(assn),P) ).

% ent_false
tff(fact_65_sup__bot_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),bot_bot(A)) = A3 ) ) ).

% sup_bot.right_neutral
tff(fact_66_sup__bot_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [A3: A,B2: A] :
          ( ( bot_bot(A) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) )
        <=> ( ( A3 = bot_bot(A) )
            & ( B2 = bot_bot(A) ) ) ) ) ).

% sup_bot.neutr_eq_iff
tff(fact_67_sup__bot_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),bot_bot(A)),A3) = A3 ) ) ).

% sup_bot.left_neutral
tff(fact_68_sup__bot_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = bot_bot(A) )
        <=> ( ( A3 = bot_bot(A) )
            & ( B2 = bot_bot(A) ) ) ) ) ).

% sup_bot.eq_neutr_iff
tff(fact_69_sup__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) = bot_bot(A) )
        <=> ( ( X = bot_bot(A) )
            & ( Y = bot_bot(A) ) ) ) ) ).

% sup_eq_bot_iff
tff(fact_70_bot__eq__sup__iff,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [X: A,Y: A] :
          ( ( bot_bot(A) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) )
        <=> ( ( X = bot_bot(A) )
            & ( Y = bot_bot(A) ) ) ) ) ).

% bot_eq_sup_iff
tff(fact_71_sup__bot__right,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),bot_bot(A)) = X ) ) ).

% sup_bot_right
tff(fact_72_sup__bot__left,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),bot_bot(A)),X) = X ) ) ).

% sup_bot_left
tff(fact_73_mult__1,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A3) = A3 ) ) ).

% mult_1
tff(fact_74_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),one_one(A)) = A3 ) ) ).

% mult.right_neutral
tff(fact_75_lift__collapse,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),X: B] : ( aa(B,heap_Time_Heap(A),heap_Time_lift(B,A,F),X) = aa(A,heap_Time_Heap(A),heap_Time_return(A),aa(B,A,F,X)) ) ).

% lift_collapse
tff(fact_76_sup__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_sup(B)
     => ! [F: fun(A,B),G: fun(A,B),X: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),sup_sup(fun(A,B)),F),G),X) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(A,B,F,X)),aa(A,B,G,X)) ) ) ).

% sup_apply
tff(fact_77_sup_Oidem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),A3) = A3 ) ) ).

% sup.idem
tff(fact_78_sup__idem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),X) = X ) ) ).

% sup_idem
tff(fact_79_sup_Oleft__idem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) ) ) ).

% sup.left_idem
tff(fact_80_sup__left__idem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) ) ) ).

% sup_left_idem
tff(fact_81_sup_Oright__idem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)),B2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) ) ) ).

% sup.right_idem
tff(fact_82_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_mult(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% mult.assoc
tff(fact_83_ab__semigroup__mult__class_Omult_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3) ) ) ).

% ab_semigroup_mult_class.mult.commute
tff(fact_84_ab__semigroup__mult__class_Omult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% ab_semigroup_mult_class.mult.left_commute
tff(fact_85_one__reorient,axiom,
    ! [A: $tType] :
      ( one(A)
     => ! [X: A] :
          ( ( one_one(A) = X )
        <=> ( X = one_one(A) ) ) ) ).

% one_reorient
tff(fact_86_inf__sup__aci_I8_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) ) ) ).

% inf_sup_aci(8)
tff(fact_87_inf__sup__aci_I7_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Z2)) ) ) ).

% inf_sup_aci(7)
tff(fact_88_inf__sup__aci_I6_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)),Z2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) ) ) ).

% inf_sup_aci(6)
tff(fact_89_inf__sup__aci_I5_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),X) ) ) ).

% inf_sup_aci(5)
tff(fact_90_sup_Oassoc,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)) ) ) ).

% sup.assoc
tff(fact_91_sup__assoc,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)),Z2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) ) ) ).

% sup_assoc
tff(fact_92_sup_Ocommute,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),A3) ) ) ).

% sup.commute
tff(fact_93_sup__commute,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),X) ) ) ).

% sup_commute
tff(fact_94_sup_Oleft__commute,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)) ) ) ).

% sup.left_commute
tff(fact_95_sup__left__commute,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Z2)) ) ) ).

% sup_left_commute
tff(fact_96_sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_sup(B)
     => ! [F: fun(A,B),G: fun(A,B),X3: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),sup_sup(fun(A,B)),F),G),X3) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(A,B,F,X3)),aa(A,B,G,X3)) ) ) ).

% sup_fun_def
tff(fact_97_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A3) = A3 ) ) ).

% comm_monoid_mult_class.mult_1
tff(fact_98_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),one_one(A)) = A3 ) ) ).

% mult.comm_neutral
tff(fact_99_bot__apply,axiom,
    ! [D: $tType,C: $tType] :
      ( bot(C)
     => ! [X: D] : ( aa(D,C,bot_bot(fun(D,C)),X) = bot_bot(C) ) ) ).

% bot_apply
tff(fact_100_boolean__algebra_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),bot_bot(A)) = X ) ) ).

% boolean_algebra.disj_zero_right
tff(fact_101_sngr__same__false,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [P3: ref(A),X: A,Y: A] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),sngr_assn(A,P3,X)),sngr_assn(A,P3,Y)) = bot_bot(assn) ) ) ).

% sngr_same_false
tff(fact_102_ent__mp,axiom,
    ! [P: assn,Q: assn] : entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),wand_assn(P,Q)),Q) ).

% ent_mp
tff(fact_103_ent__wandI,axiom,
    ! [Q: assn,P: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),P),R)
     => entails(P,wand_assn(Q,R)) ) ).

% ent_wandI
tff(fact_104_snga__same__false,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [P3: array(A),X: list(A),Y: list(A)] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(A,P3,X)),snga_assn(A,P3,Y)) = bot_bot(assn) ) ) ).

% snga_same_false
tff(fact_105_preciseD_H,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,assn)),A3: A,P3: B,F2: assn,H2: product_prod(heap_ext(product_unit),set(nat)),A5: A,F3: assn] :
      ( precise(A,B,R)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A3),P3)),F2)),H2))
       => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A5),P3)),F3)),H2))
         => ( A3 = A5 ) ) ) ) ).

% preciseD'
tff(fact_106_is__pure__assn__pure,axiom,
    ! [P: bool] : is_pure_assn(pure_assn(P)) ).

% is_pure_assn_pure
tff(fact_107_is__pure__assn__starI,axiom,
    ! [A3: assn,B2: assn] :
      ( is_pure_assn(A3)
     => ( is_pure_assn(B2)
       => is_pure_assn(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),B2)) ) ) ).

% is_pure_assn_starI
tff(fact_108_boolean__algebra__cancel_Osup1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: A,K: A,A3: A,B2: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),sup_sup(A),K),A3) )
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B2) = aa(A,A,aa(A,fun(A,A),sup_sup(A),K),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)) ) ) ) ).

% boolean_algebra_cancel.sup1
tff(fact_109_boolean__algebra__cancel_Osup2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3 = aa(A,A,aa(A,fun(A,A),sup_sup(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B3) = aa(A,A,aa(A,fun(A,A),sup_sup(A),K),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)) ) ) ) ).

% boolean_algebra_cancel.sup2
tff(fact_110_bot__fun__def,axiom,
    ! [A: $tType,B: $tType] :
      ( bot(B)
     => ! [X3: A] : ( aa(A,B,bot_bot(fun(A,B)),X3) = bot_bot(B) ) ) ).

% bot_fun_def
tff(fact_111_is__pure__assn__def,axiom,
    ! [A3: assn] :
      ( is_pure_assn(A3)
    <=> ? [P4: bool] : ( A3 = pure_assn(P4) ) ) ).

% is_pure_assn_def
tff(fact_112_is__pure__assnE,axiom,
    ! [A3: assn] :
      ( is_pure_assn(A3)
     => ~ ! [P5: bool] : ( A3 != pure_assn(P5) ) ) ).

% is_pure_assnE
tff(fact_113_is__pure__assn__basic__simps_I2_J,axiom,
    is_pure_assn(one_one(assn)) ).

% is_pure_assn_basic_simps(2)
tff(fact_114_is__pure__assn__basic__simps_I1_J,axiom,
    is_pure_assn(bot_bot(assn)) ).

% is_pure_assn_basic_simps(1)
tff(fact_115_precise__def,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,assn))] :
      ( precise(A,B,R)
    <=> ! [A6: A,A7: A,H3: product_prod(heap_ext(product_unit),set(nat)),P6: B,F4: assn,F5: assn] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A6),P6)),F4)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A7),P6)),F5))),H3))
         => ( A6 = A7 ) ) ) ).

% precise_def
tff(fact_116_preciseI,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,assn))] :
      ( ! [A8: A,A9: A,H: product_prod(heap_ext(product_unit),set(nat)),P7: B,F6: assn,F7: assn] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A8),P7)),F6)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A9),P7)),F7))),H))
         => ( A8 = A9 ) )
     => precise(A,B,R) ) ).

% preciseI
tff(fact_117_preciseD,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,assn)),A3: A,P3: B,F2: assn,A5: A,F3: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( precise(A,B,R)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A3),P3)),F2)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),R,A5),P3)),F3))),H2))
       => ( A3 = A5 ) ) ) ).

% preciseD
tff(fact_118_mult_Oright__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2) ) ) ).

% mult.right_commute
tff(fact_119_mult_Oright__assoc,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% mult.right_assoc
tff(fact_120_mod__h__bot__iff_I3_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [P3: ref(A),X: A,H2: heap_ext(product_unit)] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,sngr_assn(A,P3,X)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ).

% mod_h_bot_iff(3)
tff(fact_121_sup__bot_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => semilattice_neutr(A,sup_sup(A),bot_bot(A)) ) ).

% sup_bot.semilattice_neutr_axioms
tff(fact_122_mod__h__bot__iff_I4_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Q3: array(B),Y: list(B),H2: heap_ext(product_unit)] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,snga_assn(B,Q3,Y)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ).

% mod_h_bot_iff(4)
tff(fact_123_sup__bot_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => monoid(A,sup_sup(A),bot_bot(A)) ) ).

% sup_bot.monoid_axioms
tff(fact_124_mod__h__bot__iff_I7_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),P),Q)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
        | pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ) ).

% mod_h_bot_iff(7)
tff(fact_125_lift__def,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] : ( heap_Time_lift(A,B,F) = aa(fun(A,B),fun(A,heap_Time_Heap(B)),aa(fun(B,heap_Time_Heap(B)),fun(fun(A,B),fun(A,heap_Time_Heap(B))),comp(B,heap_Time_Heap(B),A),heap_Time_return(B)),F) ) ).

% lift_def
tff(fact_126_mult_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => monoid(A,times_times(A),one_one(A)) ) ).

% mult.monoid_axioms
tff(fact_127_inf__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_inf(B)
     => ! [F: fun(A,B),G: fun(A,B),X: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),inf_inf(fun(A,B)),F),G),X) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,F,X)),aa(A,B,G,X)) ) ) ).

% inf_apply
tff(fact_128_inf__right__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),Y) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) ) ) ).

% inf_right_idem
tff(fact_129_inf_Oright__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),B2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) ) ) ).

% inf.right_idem
tff(fact_130_inf__left__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) ) ) ).

% inf_left_idem
tff(fact_131_inf_Oleft__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) ) ) ).

% inf.left_idem
tff(fact_132_inf__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),X) = X ) ) ).

% inf_idem
tff(fact_133_inf_Oidem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),A3) = A3 ) ) ).

% inf.idem
tff(fact_134_inf__bot__left,axiom,
    ! [A: $tType] :
      ( bounded_lattice_bot(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),bot_bot(A)),X) = bot_bot(A) ) ) ).

% inf_bot_left
tff(fact_135_inf__bot__right,axiom,
    ! [A: $tType] :
      ( bounded_lattice_bot(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),bot_bot(A)) = bot_bot(A) ) ) ).

% inf_bot_right
tff(fact_136_boolean__algebra_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),bot_bot(A)),X) = bot_bot(A) ) ) ).

% boolean_algebra.conj_zero_left
tff(fact_137_boolean__algebra_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),bot_bot(A)) = bot_bot(A) ) ) ).

% boolean_algebra.conj_zero_right
tff(fact_138_inf__sup__absorb,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)) = X ) ) ).

% inf_sup_absorb
tff(fact_139_sup__inf__absorb,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)) = X ) ) ).

% sup_inf_absorb
tff(fact_140_merge__pure__and,axiom,
    ! [A3: bool,B2: bool] : ( aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),pure_assn(A3)),pure_assn(B2)) = pure_assn(fconj(A3,B2)) ) ).

% merge_pure_and
tff(fact_141_mod__h__bot__iff_I5_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ) ).

% mod_h_bot_iff(5)
tff(fact_142_mod__h__bot__iff_I1_J,axiom,
    ! [B2: bool,H2: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,pure_assn(B2)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> pp(B2) ) ).

% mod_h_bot_iff(1)
tff(fact_143_mod__h__bot__iff_I6_J,axiom,
    ! [P: assn,Q: assn,H2: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),P),Q)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ) ).

% mod_h_bot_iff(6)
tff(fact_144_boolean__algebra__cancel_Oinf2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3 = aa(A,A,aa(A,fun(A,A),inf_inf(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B3) = aa(A,A,aa(A,fun(A,A),inf_inf(A),K),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)) ) ) ) ).

% boolean_algebra_cancel.inf2
tff(fact_145_boolean__algebra__cancel_Oinf1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: A,K: A,A3: A,B2: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),inf_inf(A),K),A3) )
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),K),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)) ) ) ) ).

% boolean_algebra_cancel.inf1
tff(fact_146_one__assn__raw_Ocases,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ~ ! [H: heap_ext(product_unit),As2: set(nat)] : ( X != aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) ) ).

% one_assn_raw.cases
tff(fact_147_inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_inf(B)
     => ! [F: fun(A,B),G: fun(A,B),X3: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),inf_inf(fun(A,B)),F),G),X3) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,F,X3)),aa(A,B,G,X3)) ) ) ).

% inf_fun_def
tff(fact_148_inf__left__commute,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Z2)) ) ) ).

% inf_left_commute
tff(fact_149_inf_Oleft__commute,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2)) ) ) ).

% inf.left_commute
tff(fact_150_inf__commute,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),X) ) ) ).

% inf_commute
tff(fact_151_inf_Ocommute,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),A3) ) ) ).

% inf.commute
tff(fact_152_inf__assoc,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),Z2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) ) ) ).

% inf_assoc
tff(fact_153_inf_Oassoc,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2)) ) ) ).

% inf.assoc
tff(fact_154_monoid_Oright__neutral,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,A3: A] :
      ( monoid(A,F,Z2)
     => ( aa(A,A,aa(A,fun(A,A),F,A3),Z2) = A3 ) ) ).

% monoid.right_neutral
tff(fact_155_monoid_Oleft__neutral,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,A3: A] :
      ( monoid(A,F,Z2)
     => ( aa(A,A,aa(A,fun(A,A),F,Z2),A3) = A3 ) ) ).

% monoid.left_neutral
tff(fact_156_inf__sup__aci_I1_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),X) ) ) ).

% inf_sup_aci(1)
tff(fact_157_inf__sup__aci_I2_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),Z2) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) ) ) ).

% inf_sup_aci(2)
tff(fact_158_inf__sup__aci_I3_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Z2)) ) ) ).

% inf_sup_aci(3)
tff(fact_159_inf__sup__aci_I4_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) ) ) ).

% inf_sup_aci(4)
tff(fact_160_distrib__imp1,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A,Z2: A] :
          ( ! [X2: A,Y2: A,Z3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y2),Z3)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Z3)) )
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Z2)) ) ) ) ).

% distrib_imp1
tff(fact_161_distrib__imp2,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A,Z2: A] :
          ( ! [X2: A,Y2: A,Z3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y2),Z3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Z3)) )
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Z2)) ) ) ) ).

% distrib_imp2
tff(fact_162_inf__sup__distrib1,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Z2)) ) ) ).

% inf_sup_distrib1
tff(fact_163_inf__sup__distrib2,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Y: A,Z2: A,X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)),X) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),X)),aa(A,A,aa(A,fun(A,A),inf_inf(A),Z2),X)) ) ) ).

% inf_sup_distrib2
tff(fact_164_sup__inf__distrib1,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Z2)) ) ) ).

% sup_inf_distrib1
tff(fact_165_sup__inf__distrib2,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Y: A,Z2: A,X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)),X) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),X)),aa(A,A,aa(A,fun(A,A),sup_sup(A),Z2),X)) ) ) ).

% sup_inf_distrib2
tff(fact_166_boolean__algebra_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Z2)) ) ) ).

% boolean_algebra.conj_disj_distrib
tff(fact_167_boolean__algebra_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Z2)) ) ) ).

% boolean_algebra.disj_conj_distrib
tff(fact_168_boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,Z2: A,X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)),X) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),X)),aa(A,A,aa(A,fun(A,A),inf_inf(A),Z2),X)) ) ) ).

% boolean_algebra.conj_disj_distrib2
tff(fact_169_boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,Z2: A,X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)),X) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),X)),aa(A,A,aa(A,fun(A,A),sup_sup(A),Z2),X)) ) ) ).

% boolean_algebra.disj_conj_distrib2
tff(fact_170_mod__and__dist,axiom,
    ! [P: assn,Q: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),P),Q)),H2))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),H2)) ) ) ).

% mod_and_dist
tff(fact_171_ent__conjI,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( entails(A4,B3)
     => ( entails(A4,C3)
       => entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),B3),C3)) ) ) ).

% ent_conjI
tff(fact_172_ent__conjE1,axiom,
    ! [A4: assn,C3: assn,B3: assn] :
      ( entails(A4,C3)
     => entails(aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A4),B3),C3) ) ).

% ent_conjE1
tff(fact_173_ent__conjE2,axiom,
    ! [B3: assn,C3: assn,A4: assn] :
      ( entails(B3,C3)
     => entails(aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A4),B3),C3) ) ).

% ent_conjE2
tff(fact_174_mod__h__bot__indep,axiom,
    ! [P: assn,H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),bot_bot(set(nat))))) ) ).

% mod_h_bot_indep
tff(fact_175_mod__emp__simp,axiom,
    ! [H2: heap_ext(product_unit)] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,one_one(assn)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ).

% mod_emp_simp
tff(fact_176_comp__apply,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(B,A),G: fun(C,B),X: C] : ( aa(C,A,aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),F),G),X) = aa(B,A,F,aa(C,B,G,X)) ) ).

% comp_apply
tff(fact_177_empty__Collect__eq,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ( bot_bot(set(A)) = aa(fun(A,bool),set(A),collect(A),P) )
    <=> ! [X4: A] : ~ pp(aa(A,bool,P,X4)) ) ).

% empty_Collect_eq
tff(fact_178_Collect__empty__eq,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ( aa(fun(A,bool),set(A),collect(A),P) = bot_bot(set(A)) )
    <=> ! [X4: A] : ~ pp(aa(A,bool,P,X4)) ) ).

% Collect_empty_eq
tff(fact_179_all__not__in__conv,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ! [X4: A] : ~ pp(member(A,X4,A4))
    <=> ( A4 = bot_bot(set(A)) ) ) ).

% all_not_in_conv
tff(fact_180_empty__iff,axiom,
    ! [A: $tType,C2: A] : ~ pp(member(A,C2,bot_bot(set(A)))) ).

% empty_iff
tff(fact_181_Un__empty,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3) = bot_bot(set(A)) )
    <=> ( ( A4 = bot_bot(set(A)) )
        & ( B3 = bot_bot(set(A)) ) ) ) ).

% Un_empty
tff(fact_182_prod_Oinject,axiom,
    ! [A: $tType,B: $tType,X1: A,X22: B,Y1: A,Y22: B] :
      ( ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X1),X22) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Y1),Y22) )
    <=> ( ( X1 = Y1 )
        & ( X22 = Y22 ) ) ) ).

% prod.inject
tff(fact_183_old_Oprod_Oinject,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,A5: A,B4: B] :
      ( ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A5),B4) )
    <=> ( ( A3 = A5 )
        & ( B2 = B4 ) ) ) ).

% old.prod.inject
tff(fact_184_hoare__triple__effect,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),H2: heap_ext(product_unit),As: set(nat)] :
      ( hoare_hoare_triple(A,P,C2,Q)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
       => ? [H5: heap_ext(product_unit),R2: A,T2: nat] :
            ( heap_Time_effect(A,C2,H2,H5,R2,T2)
            & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,Q,R2)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),hoare_new_addrs(H2,As,H5)))) ) ) ) ).

% hoare_triple_effect
tff(fact_185_pure__assn__raw_Oelims_I3_J,axiom,
    ! [B: $tType,A: $tType,X: bool,Xa: product_prod(A,set(B))] :
      ( ~ pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X),Xa))
     => ~ ! [H: A,As2: set(B)] :
            ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H),As2) )
           => ( ( As2 = bot_bot(set(B)) )
              & pp(X) ) ) ) ).

% pure_assn_raw.elims(3)
tff(fact_186_pure__assn__raw_Oelims_I2_J,axiom,
    ! [B: $tType,A: $tType,X: bool,Xa: product_prod(A,set(B))] :
      ( pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X),Xa))
     => ~ ! [H: A,As2: set(B)] :
            ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H),As2) )
           => ~ ( ( As2 = bot_bot(set(B)) )
                & pp(X) ) ) ) ).

% pure_assn_raw.elims(2)
tff(fact_187_pure__assn__raw_Oelims_I1_J,axiom,
    ! [B: $tType,A: $tType,X: bool,Xa: product_prod(A,set(B)),Y: bool] :
      ( ( pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X),Xa))
      <=> pp(Y) )
     => ~ ! [H: A,As2: set(B)] :
            ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H),As2) )
           => ( pp(Y)
            <=> ~ ( ( As2 = bot_bot(set(B)) )
                  & pp(X) ) ) ) ) ).

% pure_assn_raw.elims(1)
tff(fact_188_Int__Un__eq_I4_J,axiom,
    ! [A: $tType,T3: set(A),S2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),T3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),T3)) = T3 ) ).

% Int_Un_eq(4)
tff(fact_189_Int__Un__eq_I3_J,axiom,
    ! [A: $tType,S2: set(A),T3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),T3)) = S2 ) ).

% Int_Un_eq(3)
tff(fact_190_Int__Un__eq_I2_J,axiom,
    ! [A: $tType,S2: set(A),T3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),T3)),T3) = T3 ) ).

% Int_Un_eq(2)
tff(fact_191_Int__Un__eq_I1_J,axiom,
    ! [A: $tType,S2: set(A),T3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),T3)),S2) = S2 ) ).

% Int_Un_eq(1)
tff(fact_192_Un__Int__eq_I4_J,axiom,
    ! [A: $tType,T3: set(A),S2: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),T3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S2),T3)) = T3 ) ).

% Un_Int_eq(4)
tff(fact_193_Un__Int__eq_I3_J,axiom,
    ! [A: $tType,S2: set(A),T3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S2),T3)) = S2 ) ).

% Un_Int_eq(3)
tff(fact_194_Un__Int__eq_I2_J,axiom,
    ! [A: $tType,S2: set(A),T3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S2),T3)),T3) = T3 ) ).

% Un_Int_eq(2)
tff(fact_195_Un__Int__eq_I1_J,axiom,
    ! [A: $tType,S2: set(A),T3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S2),T3)),S2) = S2 ) ).

% Un_Int_eq(1)
tff(fact_196_Un__Int__crazy,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),A4)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),C3),A4)) ) ).

% Un_Int_crazy
tff(fact_197_Int__Un__distrib,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),C3)) ) ).

% Int_Un_distrib
tff(fact_198_Un__Int__distrib,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),C3)) ) ).

% Un_Int_distrib
tff(fact_199_Int__Un__distrib2,axiom,
    ! [A: $tType,B3: set(A),C3: set(A),A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C3)),A4) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),A4)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),A4)) ) ).

% Int_Un_distrib2
tff(fact_200_Un__Int__distrib2,axiom,
    ! [A: $tType,B3: set(A),C3: set(A),A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3)),A4) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),A4)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),C3),A4)) ) ).

% Un_Int_distrib2
tff(fact_201_effect__deterministic_I3_J,axiom,
    ! [A: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),A3: A,N: nat,H6: heap_ext(product_unit),B2: A,N2: nat] :
      ( heap_Time_effect(A,F,H2,H4,A3,N)
     => ( heap_Time_effect(A,F,H2,H6,B2,N2)
       => ( N = N2 ) ) ) ).

% effect_deterministic(3)
tff(fact_202_effect__deterministic_I2_J,axiom,
    ! [A: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),A3: A,N: nat,H6: heap_ext(product_unit),B2: A,N2: nat] :
      ( heap_Time_effect(A,F,H2,H4,A3,N)
     => ( heap_Time_effect(A,F,H2,H6,B2,N2)
       => ( H4 = H6 ) ) ) ).

% effect_deterministic(2)
tff(fact_203_effect__deterministic_I1_J,axiom,
    ! [A: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),A3: A,N: nat,H6: heap_ext(product_unit),B2: A,N2: nat] :
      ( heap_Time_effect(A,F,H2,H4,A3,N)
     => ( heap_Time_effect(A,F,H2,H6,B2,N2)
       => ( A3 = B2 ) ) ) ).

% effect_deterministic(1)
tff(fact_204_effect__ifE,axiom,
    ! [A: $tType,C2: bool,T4: heap_Time_Heap(A),E2: heap_Time_Heap(A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( heap_Time_effect(A,if(heap_Time_Heap(A),C2,T4,E2),H2,H4,R3,N)
     => ( ( pp(C2)
         => ~ heap_Time_effect(A,T4,H2,H4,R3,N) )
       => ~ ( ~ pp(C2)
           => ~ heap_Time_effect(A,E2,H2,H4,R3,N) ) ) ) ).

% effect_ifE
tff(fact_205_effect__ifI,axiom,
    ! [A: $tType,C2: bool,T4: heap_Time_Heap(A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat,E2: heap_Time_Heap(A)] :
      ( ( pp(C2)
       => heap_Time_effect(A,T4,H2,H4,R3,N) )
     => ( ( ~ pp(C2)
         => heap_Time_effect(A,E2,H2,H4,R3,N) )
       => heap_Time_effect(A,if(heap_Time_Heap(A),C2,T4,E2),H2,H4,R3,N) ) ) ).

% effect_ifI
tff(fact_206_times__assn__raw_Ocases,axiom,
    ! [X: product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))] :
      ~ ! [P5: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q4: fun(product_prod(heap_ext(product_unit),set(nat)),bool),H: heap_ext(product_unit),As2: set(nat)] : ( X != aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),P5),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Q4),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))) ) ).

% times_assn_raw.cases
tff(fact_207_sngr__assn__raw_Ocases,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))] :
          ~ ! [R2: ref(A),X2: A,H: heap_ext(product_unit),As2: set(nat)] : ( X != aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),R2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),X2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))) ) ) ).

% sngr_assn_raw.cases
tff(fact_208_snga__assn__raw_Ocases,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))] :
          ~ ! [R2: array(A),X2: list(A),H: heap_ext(product_unit),As2: set(nat)] : ( X != aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),R2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),X2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))) ) ) ).

% snga_assn_raw.cases
tff(fact_209_Int__emptyI,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ! [X2: A] :
          ( pp(member(A,X2,A4))
         => ~ pp(member(A,X2,B3)) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) ) ) ).

% Int_emptyI
tff(fact_210_disjoint__iff,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) )
    <=> ! [X4: A] :
          ( pp(member(A,X4,A4))
         => ~ pp(member(A,X4,B3)) ) ) ).

% disjoint_iff
tff(fact_211_Int__empty__left,axiom,
    ! [A: $tType,B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),bot_bot(set(A))),B3) = bot_bot(set(A)) ) ).

% Int_empty_left
tff(fact_212_Int__empty__right,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),bot_bot(set(A))) = bot_bot(set(A)) ) ).

% Int_empty_right
tff(fact_213_disjoint__iff__not__equal,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) )
    <=> ! [X4: A] :
          ( pp(member(A,X4,A4))
         => ! [Xa2: A] :
              ( pp(member(A,Xa2,B3))
             => ( X4 != Xa2 ) ) ) ) ).

% disjoint_iff_not_equal
tff(fact_214_pure__assn__raw_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod(bool,product_prod(A,set(B)))] :
      ~ ! [B5: bool,H: A,As2: set(B)] : ( X != aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),B5),aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H),As2)) ) ).

% pure_assn_raw.cases
tff(fact_215_effect__returnI,axiom,
    ! [A: $tType,H2: heap_ext(product_unit),H4: heap_ext(product_unit),X: A] :
      ( ( H2 = H4 )
     => heap_Time_effect(A,aa(A,heap_Time_Heap(A),heap_Time_return(A),X),H2,H4,X,one_one(nat)) ) ).

% effect_returnI
tff(fact_216_effect__returnE,axiom,
    ! [A: $tType,X: A,H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( heap_Time_effect(A,aa(A,heap_Time_Heap(A),heap_Time_return(A),X),H2,H4,R3,N)
     => ~ ( ( R3 = X )
         => ( ( H4 = H2 )
           => ( N != one_one(nat) ) ) ) ) ).

% effect_returnE
tff(fact_217_effect__raiseE,axiom,
    ! [A: $tType,X: list(char),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] : ~ heap_Time_effect(A,heap_Time_raise(A,X),H2,H4,R3,N) ).

% effect_raiseE
tff(fact_218_prod__induct7,axiom,
    ! [G2: $tType,F8: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: fun(product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))))),bool),X: product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))))] :
      ( ! [A8: A,B5: B,C4: C,D3: D,E3: E,F9: F8,G3: G2] : pp(aa(product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))))),bool,P,aa(product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))))),aa(A,fun(product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))))),product_Pair(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))))),A8),aa(product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))),aa(B,fun(product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))))),product_Pair(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))),B5),aa(product_prod(D,product_prod(E,product_prod(F8,G2))),product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))),aa(C,fun(product_prod(D,product_prod(E,product_prod(F8,G2))),product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))),product_Pair(C,product_prod(D,product_prod(E,product_prod(F8,G2)))),C4),aa(product_prod(E,product_prod(F8,G2)),product_prod(D,product_prod(E,product_prod(F8,G2))),aa(D,fun(product_prod(E,product_prod(F8,G2)),product_prod(D,product_prod(E,product_prod(F8,G2)))),product_Pair(D,product_prod(E,product_prod(F8,G2))),D3),aa(product_prod(F8,G2),product_prod(E,product_prod(F8,G2)),aa(E,fun(product_prod(F8,G2),product_prod(E,product_prod(F8,G2))),product_Pair(E,product_prod(F8,G2)),E3),aa(G2,product_prod(F8,G2),aa(F8,fun(G2,product_prod(F8,G2)),product_Pair(F8,G2),F9),G3))))))))
     => pp(aa(product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))))),bool,P,X)) ) ).

% prod_induct7
tff(fact_219_prod__induct6,axiom,
    ! [F8: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: fun(product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8))))),bool),X: product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8)))))] :
      ( ! [A8: A,B5: B,C4: C,D3: D,E3: E,F9: F8] : pp(aa(product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8))))),bool,P,aa(product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8)))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8))))),aa(A,fun(product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8)))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8)))))),product_Pair(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8))))),A8),aa(product_prod(C,product_prod(D,product_prod(E,F8))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8)))),aa(B,fun(product_prod(C,product_prod(D,product_prod(E,F8))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8))))),product_Pair(B,product_prod(C,product_prod(D,product_prod(E,F8)))),B5),aa(product_prod(D,product_prod(E,F8)),product_prod(C,product_prod(D,product_prod(E,F8))),aa(C,fun(product_prod(D,product_prod(E,F8)),product_prod(C,product_prod(D,product_prod(E,F8)))),product_Pair(C,product_prod(D,product_prod(E,F8))),C4),aa(product_prod(E,F8),product_prod(D,product_prod(E,F8)),aa(D,fun(product_prod(E,F8),product_prod(D,product_prod(E,F8))),product_Pair(D,product_prod(E,F8)),D3),aa(F8,product_prod(E,F8),aa(E,fun(F8,product_prod(E,F8)),product_Pair(E,F8),E3),F9)))))))
     => pp(aa(product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8))))),bool,P,X)) ) ).

% prod_induct6
tff(fact_220_prod__induct5,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: fun(product_prod(A,product_prod(B,product_prod(C,product_prod(D,E)))),bool),X: product_prod(A,product_prod(B,product_prod(C,product_prod(D,E))))] :
      ( ! [A8: A,B5: B,C4: C,D3: D,E3: E] : pp(aa(product_prod(A,product_prod(B,product_prod(C,product_prod(D,E)))),bool,P,aa(product_prod(B,product_prod(C,product_prod(D,E))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,E)))),aa(A,fun(product_prod(B,product_prod(C,product_prod(D,E))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,E))))),product_Pair(A,product_prod(B,product_prod(C,product_prod(D,E)))),A8),aa(product_prod(C,product_prod(D,E)),product_prod(B,product_prod(C,product_prod(D,E))),aa(B,fun(product_prod(C,product_prod(D,E)),product_prod(B,product_prod(C,product_prod(D,E)))),product_Pair(B,product_prod(C,product_prod(D,E))),B5),aa(product_prod(D,E),product_prod(C,product_prod(D,E)),aa(C,fun(product_prod(D,E),product_prod(C,product_prod(D,E))),product_Pair(C,product_prod(D,E)),C4),aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),D3),E3))))))
     => pp(aa(product_prod(A,product_prod(B,product_prod(C,product_prod(D,E)))),bool,P,X)) ) ).

% prod_induct5
tff(fact_221_prod__induct4,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: fun(product_prod(A,product_prod(B,product_prod(C,D))),bool),X: product_prod(A,product_prod(B,product_prod(C,D)))] :
      ( ! [A8: A,B5: B,C4: C,D3: D] : pp(aa(product_prod(A,product_prod(B,product_prod(C,D))),bool,P,aa(product_prod(B,product_prod(C,D)),product_prod(A,product_prod(B,product_prod(C,D))),aa(A,fun(product_prod(B,product_prod(C,D)),product_prod(A,product_prod(B,product_prod(C,D)))),product_Pair(A,product_prod(B,product_prod(C,D))),A8),aa(product_prod(C,D),product_prod(B,product_prod(C,D)),aa(B,fun(product_prod(C,D),product_prod(B,product_prod(C,D))),product_Pair(B,product_prod(C,D)),B5),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),C4),D3)))))
     => pp(aa(product_prod(A,product_prod(B,product_prod(C,D))),bool,P,X)) ) ).

% prod_induct4
tff(fact_222_prod__induct3,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: fun(product_prod(A,product_prod(B,C)),bool),X: product_prod(A,product_prod(B,C))] :
      ( ! [A8: A,B5: B,C4: C] : pp(aa(product_prod(A,product_prod(B,C)),bool,P,aa(product_prod(B,C),product_prod(A,product_prod(B,C)),aa(A,fun(product_prod(B,C),product_prod(A,product_prod(B,C))),product_Pair(A,product_prod(B,C)),A8),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),B5),C4))))
     => pp(aa(product_prod(A,product_prod(B,C)),bool,P,X)) ) ).

% prod_induct3
tff(fact_223_prod__cases7,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F8: $tType,G2: $tType,Y: product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))))] :
      ~ ! [A8: A,B5: B,C4: C,D3: D,E3: E,F9: F8,G3: G2] : ( Y != aa(product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))))),aa(A,fun(product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))))),product_Pair(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))))),A8),aa(product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))),aa(B,fun(product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))))),product_Pair(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))),B5),aa(product_prod(D,product_prod(E,product_prod(F8,G2))),product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2)))),aa(C,fun(product_prod(D,product_prod(E,product_prod(F8,G2))),product_prod(C,product_prod(D,product_prod(E,product_prod(F8,G2))))),product_Pair(C,product_prod(D,product_prod(E,product_prod(F8,G2)))),C4),aa(product_prod(E,product_prod(F8,G2)),product_prod(D,product_prod(E,product_prod(F8,G2))),aa(D,fun(product_prod(E,product_prod(F8,G2)),product_prod(D,product_prod(E,product_prod(F8,G2)))),product_Pair(D,product_prod(E,product_prod(F8,G2))),D3),aa(product_prod(F8,G2),product_prod(E,product_prod(F8,G2)),aa(E,fun(product_prod(F8,G2),product_prod(E,product_prod(F8,G2))),product_Pair(E,product_prod(F8,G2)),E3),aa(G2,product_prod(F8,G2),aa(F8,fun(G2,product_prod(F8,G2)),product_Pair(F8,G2),F9),G3)))))) ) ).

% prod_cases7
tff(fact_224_prod__cases6,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F8: $tType,Y: product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8)))))] :
      ~ ! [A8: A,B5: B,C4: C,D3: D,E3: E,F9: F8] : ( Y != aa(product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8)))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8))))),aa(A,fun(product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8)))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8)))))),product_Pair(A,product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8))))),A8),aa(product_prod(C,product_prod(D,product_prod(E,F8))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8)))),aa(B,fun(product_prod(C,product_prod(D,product_prod(E,F8))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,F8))))),product_Pair(B,product_prod(C,product_prod(D,product_prod(E,F8)))),B5),aa(product_prod(D,product_prod(E,F8)),product_prod(C,product_prod(D,product_prod(E,F8))),aa(C,fun(product_prod(D,product_prod(E,F8)),product_prod(C,product_prod(D,product_prod(E,F8)))),product_Pair(C,product_prod(D,product_prod(E,F8))),C4),aa(product_prod(E,F8),product_prod(D,product_prod(E,F8)),aa(D,fun(product_prod(E,F8),product_prod(D,product_prod(E,F8))),product_Pair(D,product_prod(E,F8)),D3),aa(F8,product_prod(E,F8),aa(E,fun(F8,product_prod(E,F8)),product_Pair(E,F8),E3),F9))))) ) ).

% prod_cases6
tff(fact_225_prod__cases5,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: product_prod(A,product_prod(B,product_prod(C,product_prod(D,E))))] :
      ~ ! [A8: A,B5: B,C4: C,D3: D,E3: E] : ( Y != aa(product_prod(B,product_prod(C,product_prod(D,E))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,E)))),aa(A,fun(product_prod(B,product_prod(C,product_prod(D,E))),product_prod(A,product_prod(B,product_prod(C,product_prod(D,E))))),product_Pair(A,product_prod(B,product_prod(C,product_prod(D,E)))),A8),aa(product_prod(C,product_prod(D,E)),product_prod(B,product_prod(C,product_prod(D,E))),aa(B,fun(product_prod(C,product_prod(D,E)),product_prod(B,product_prod(C,product_prod(D,E)))),product_Pair(B,product_prod(C,product_prod(D,E))),B5),aa(product_prod(D,E),product_prod(C,product_prod(D,E)),aa(C,fun(product_prod(D,E),product_prod(C,product_prod(D,E))),product_Pair(C,product_prod(D,E)),C4),aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),D3),E3)))) ) ).

% prod_cases5
tff(fact_226_prod__cases4,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: product_prod(A,product_prod(B,product_prod(C,D)))] :
      ~ ! [A8: A,B5: B,C4: C,D3: D] : ( Y != aa(product_prod(B,product_prod(C,D)),product_prod(A,product_prod(B,product_prod(C,D))),aa(A,fun(product_prod(B,product_prod(C,D)),product_prod(A,product_prod(B,product_prod(C,D)))),product_Pair(A,product_prod(B,product_prod(C,D))),A8),aa(product_prod(C,D),product_prod(B,product_prod(C,D)),aa(B,fun(product_prod(C,D),product_prod(B,product_prod(C,D))),product_Pair(B,product_prod(C,D)),B5),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),C4),D3))) ) ).

% prod_cases4
tff(fact_227_prod__cases3,axiom,
    ! [A: $tType,B: $tType,C: $tType,Y: product_prod(A,product_prod(B,C))] :
      ~ ! [A8: A,B5: B,C4: C] : ( Y != aa(product_prod(B,C),product_prod(A,product_prod(B,C)),aa(A,fun(product_prod(B,C),product_prod(A,product_prod(B,C))),product_Pair(A,product_prod(B,C)),A8),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),B5),C4)) ) ).

% prod_cases3
tff(fact_228_Pair__inject,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,A5: A,B4: B] :
      ( ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A5),B4) )
     => ~ ( ( A3 = A5 )
         => ( B2 != B4 ) ) ) ).

% Pair_inject
tff(fact_229_prod__cases,axiom,
    ! [B: $tType,A: $tType,P: fun(product_prod(A,B),bool),P3: product_prod(A,B)] :
      ( ! [A8: A,B5: B] : pp(aa(product_prod(A,B),bool,P,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)))
     => pp(aa(product_prod(A,B),bool,P,P3)) ) ).

% prod_cases
tff(fact_230_surj__pair,axiom,
    ! [A: $tType,B: $tType,P3: product_prod(A,B)] :
    ? [X2: A,Y2: B] : ( P3 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2) ) ).

% surj_pair
tff(fact_231_old_Oprod_Oexhaust,axiom,
    ! [A: $tType,B: $tType,Y: product_prod(A,B)] :
      ~ ! [A8: A,B5: B] : ( Y != aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5) ) ).

% old.prod.exhaust
tff(fact_232_emptyE,axiom,
    ! [A: $tType,A3: A] : ~ pp(member(A,A3,bot_bot(set(A)))) ).

% emptyE
tff(fact_233_equals0D,axiom,
    ! [A: $tType,A4: set(A),A3: A] :
      ( ( A4 = bot_bot(set(A)) )
     => ~ pp(member(A,A3,A4)) ) ).

% equals0D
tff(fact_234_equals0I,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ! [Y2: A] : ~ pp(member(A,Y2,A4))
     => ( A4 = bot_bot(set(A)) ) ) ).

% equals0I
tff(fact_235_ex__in__conv,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ? [X4: A] : pp(member(A,X4,A4))
    <=> ( A4 != bot_bot(set(A)) ) ) ).

% ex_in_conv
tff(fact_236_bot__set__def,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) = aa(fun(A,bool),set(A),collect(A),bot_bot(fun(A,bool))) ) ).

% bot_set_def
tff(fact_237_Un__empty__left,axiom,
    ! [A: $tType,B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),bot_bot(set(A))),B3) = B3 ) ).

% Un_empty_left
tff(fact_238_Un__empty__right,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),bot_bot(set(A))) = A4 ) ).

% Un_empty_right
tff(fact_239_comp__eq__dest__lhs,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: fun(C,B),B2: fun(A,C),C2: fun(A,B),V: A] :
      ( ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),A3),B2) = C2 )
     => ( aa(C,B,A3,aa(A,C,B2,V)) = aa(A,B,C2,V) ) ) ).

% comp_eq_dest_lhs
tff(fact_240_comp__eq__elim,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A3: fun(C,B),B2: fun(A,C),C2: fun(D,B),D2: fun(A,D)] :
      ( ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),A3),B2) = aa(fun(A,D),fun(A,B),aa(fun(D,B),fun(fun(A,D),fun(A,B)),comp(D,B,A),C2),D2) )
     => ! [V2: A] : ( aa(C,B,A3,aa(A,C,B2,V2)) = aa(D,B,C2,aa(A,D,D2,V2)) ) ) ).

% comp_eq_elim
tff(fact_241_comp__eq__dest,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A3: fun(C,B),B2: fun(A,C),C2: fun(D,B),D2: fun(A,D),V: A] :
      ( ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),A3),B2) = aa(fun(A,D),fun(A,B),aa(fun(D,B),fun(fun(A,D),fun(A,B)),comp(D,B,A),C2),D2) )
     => ( aa(C,B,A3,aa(A,C,B2,V)) = aa(D,B,C2,aa(A,D,D2,V)) ) ) ).

% comp_eq_dest
tff(fact_242_comp__assoc,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: fun(D,B),G: fun(C,D),H2: fun(A,C)] : ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),aa(fun(C,D),fun(C,B),aa(fun(D,B),fun(fun(C,D),fun(C,B)),comp(D,B,C),F),G)),H2) = aa(fun(A,D),fun(A,B),aa(fun(D,B),fun(fun(A,D),fun(A,B)),comp(D,B,A),F),aa(fun(A,C),fun(A,D),aa(fun(C,D),fun(fun(A,C),fun(A,D)),comp(C,D,A),G),H2)) ) ).

% comp_assoc
tff(fact_243_comp__def,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(B,C),G: fun(A,B),X3: A] : ( aa(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),G),X3) = aa(B,C,F,aa(A,B,G,X3)) ) ).

% comp_def
tff(fact_244_star__assnI,axiom,
    ! [P: assn,H2: heap_ext(product_unit),As: set(nat),Q: assn,As3: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3)))
       => ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As3) = bot_bot(set(nat)) )
         => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As3)))) ) ) ) ).

% star_assnI
tff(fact_245_mod__star__conv,axiom,
    ! [A4: assn,B3: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),B3)),H2))
    <=> ? [Hr: heap_ext(product_unit),As1: set(nat),As22: set(nat)] :
          ( ( H2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22)) )
          & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,A4),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),As1)))
          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,B3),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),As22))) ) ) ).

% mod_star_conv
tff(fact_246_pure__assn__raw_Osimps,axiom,
    ! [B: $tType,A: $tType,B2: bool,H2: A,As: set(B)] :
      ( pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,B2),aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H2),As)))
    <=> ( ( As = bot_bot(set(B)) )
        & pp(B2) ) ) ).

% pure_assn_raw.simps
tff(fact_247_old_Oprod_Orec,axiom,
    ! [A: $tType,T: $tType,B: $tType,F1: fun(A,fun(B,T)),A3: A,B2: B] : ( product_rec_prod(A,B,T,F1,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2)) = aa(B,T,aa(A,fun(B,T),F1,A3),B2) ) ).

% old.prod.rec
tff(fact_248_Set_Ois__empty__def,axiom,
    ! [A: $tType,A4: set(A)] :
      ( is_empty2(A,A4)
    <=> ( A4 = bot_bot(set(A)) ) ) ).

% Set.is_empty_def
tff(fact_249_internal__case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: fun(B,fun(C,A)),A3: B,B2: C] : ( produc5280177257484947105e_prod(B,C,A,C2,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),B2)) = aa(C,A,aa(B,fun(C,A),C2,A3),B2) ) ).

% internal_case_prod_conv
tff(fact_250_one__assn__raw_Osimps,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
    <=> ( As = bot_bot(set(nat)) ) ) ).

% one_assn_raw.simps
tff(fact_251_one__assn__raw_Oelims_I1_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X))
      <=> pp(Y) )
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( pp(Y)
            <=> ( As2 != bot_bot(set(nat)) ) ) ) ) ).

% one_assn_raw.elims(1)
tff(fact_252_one__assn__raw_Oelims_I2_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X))
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( As2 != bot_bot(set(nat)) ) ) ) ).

% one_assn_raw.elims(2)
tff(fact_253_one__assn__raw_Oelims_I3_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X))
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( As2 = bot_bot(set(nat)) ) ) ) ).

% one_assn_raw.elims(3)
tff(fact_254_hoare__triple__success,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),H2: heap_ext(product_unit),As: set(nat)] :
      ( hoare_hoare_triple(A,P,C2,Q)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
       => heap_Time_success(A,C2,H2) ) ) ).

% hoare_triple_success
tff(fact_255_times__assn__raw_Osimps,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool),H2: heap_ext(product_unit),As: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(P,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
    <=> ? [As1: set(nat),As22: set(nat)] :
          ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
          & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As1)))
          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Q,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As22))) ) ) ).

% times_assn_raw.simps
tff(fact_256_times__assn__raw_Oelims_I1_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X,Xa),Xb))
      <=> pp(Y) )
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( pp(Y)
            <=> ~ ? [As1: set(nat),As22: set(nat)] :
                    ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
                    & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As1)))
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As22))) ) ) ) ) ).

% times_assn_raw.elims(1)
tff(fact_257_times__assn__raw_Oelims_I2_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X,Xa),Xb))
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ~ ? [As12: set(nat),As23: set(nat)] :
                  ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As12),As23) )
                  & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As12),As23) = bot_bot(set(nat)) )
                  & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As12)))
                  & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As23))) ) ) ) ).

% times_assn_raw.elims(2)
tff(fact_258_IntI,axiom,
    ! [A: $tType,C2: A,A4: set(A),B3: set(A)] :
      ( pp(member(A,C2,A4))
     => ( pp(member(A,C2,B3))
       => pp(member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3))) ) ) ).

% IntI
tff(fact_259_Int__iff,axiom,
    ! [A: $tType,C2: A,A4: set(A),B3: set(A)] :
      ( pp(member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)))
    <=> ( pp(member(A,C2,A4))
        & pp(member(A,C2,B3)) ) ) ).

% Int_iff
tff(fact_260_IntE,axiom,
    ! [A: $tType,C2: A,A4: set(A),B3: set(A)] :
      ( pp(member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)))
     => ~ ( pp(member(A,C2,A4))
         => ~ pp(member(A,C2,B3)) ) ) ).

% IntE
tff(fact_261_IntD1,axiom,
    ! [A: $tType,C2: A,A4: set(A),B3: set(A)] :
      ( pp(member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)))
     => pp(member(A,C2,A4)) ) ).

% IntD1
tff(fact_262_IntD2,axiom,
    ! [A: $tType,C2: A,A4: set(A),B3: set(A)] :
      ( pp(member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)))
     => pp(member(A,C2,B3)) ) ).

% IntD2
tff(fact_263_Int__assoc,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3)) ) ).

% Int_assoc
tff(fact_264_Int__absorb,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),A4) = A4 ) ).

% Int_absorb
tff(fact_265_Int__commute,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),A4) ) ).

% Int_commute
tff(fact_266_Int__left__absorb,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) ) ).

% Int_left_absorb
tff(fact_267_Int__left__commute,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),C3)) ) ).

% Int_left_commute
tff(fact_268_success__ifI,axiom,
    ! [A: $tType,C2: bool,T4: heap_Time_Heap(A),H2: heap_ext(product_unit),E2: heap_Time_Heap(A)] :
      ( ( pp(C2)
       => heap_Time_success(A,T4,H2) )
     => ( ( ~ pp(C2)
         => heap_Time_success(A,E2,H2) )
       => heap_Time_success(A,if(heap_Time_Heap(A),C2,T4,E2),H2) ) ) ).

% success_ifI
tff(fact_269_success__effectE,axiom,
    ! [A: $tType,C2: heap_Time_Heap(A),H2: heap_ext(product_unit)] :
      ( heap_Time_success(A,C2,H2)
     => ~ ! [R2: A,H5: heap_ext(product_unit),N3: nat] : ~ heap_Time_effect(A,C2,H2,H5,R2,N3) ) ).

% success_effectE
tff(fact_270_effect__success,axiom,
    ! [A: $tType,C2: heap_Time_Heap(A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( heap_Time_effect(A,C2,H2,H4,R3,N)
     => heap_Time_success(A,C2,H2) ) ).

% effect_success
tff(fact_271_success__returnI,axiom,
    ! [A: $tType,X: A,H2: heap_ext(product_unit)] : heap_Time_success(A,aa(A,heap_Time_Heap(A),heap_Time_return(A),X),H2) ).

% success_returnI
tff(fact_272_success__bind__effectI,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),X: A,N: nat,G: fun(A,heap_Time_Heap(B))] :
      ( heap_Time_effect(A,F,H2,H4,X,N)
     => ( heap_Time_success(B,aa(A,heap_Time_Heap(B),G,X),H4)
       => heap_Time_success(B,heap_Time_bind(A,B,F,G),H2) ) ) ).

% success_bind_effectI
tff(fact_273_times__assn__raw_Oelims_I3_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X,Xa),Xb))
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ? [As13: set(nat),As24: set(nat)] :
                ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As13),As24) )
                & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As13),As24) = bot_bot(set(nat)) )
                & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As13)))
                & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As24))) ) ) ) ).

% times_assn_raw.elims(3)
tff(fact_274_Collect__empty__eq__bot,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ( aa(fun(A,bool),set(A),collect(A),P) = bot_bot(set(A)) )
    <=> ( P = bot_bot(fun(A,bool)) ) ) ).

% Collect_empty_eq_bot
tff(fact_275_bot__empty__eq,axiom,
    ! [A: $tType,X3: A] :
      ( pp(aa(A,bool,bot_bot(fun(A,bool)),X3))
    <=> pp(member(A,X3,bot_bot(set(A)))) ) ).

% bot_empty_eq
tff(fact_276_pairself_Ocases,axiom,
    ! [B: $tType,A: $tType,X: product_prod(fun(A,B),product_prod(A,A))] :
      ~ ! [F9: fun(A,B),A8: A,B5: A] : ( X != aa(product_prod(A,A),product_prod(fun(A,B),product_prod(A,A)),aa(fun(A,B),fun(product_prod(A,A),product_prod(fun(A,B),product_prod(A,A))),product_Pair(fun(A,B),product_prod(A,A)),F9),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A8),B5)) ) ).

% pairself.cases
tff(fact_277_disjointI,axiom,
    ! [A: $tType,A3: set(A),B2: set(A)] :
      ( ! [X2: A] :
          ( pp(member(A,X2,A3))
         => ~ pp(member(A,X2,B2)) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) ) ) ).

% disjointI
tff(fact_278_times__assn__raw_Opelims_I1_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X,Xa),Xb))
      <=> pp(Y) )
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( ( pp(Y)
                <=> ? [As1: set(nat),As22: set(nat)] :
                      ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
                      & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As1)))
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As22))) ) )
               => ~ pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))) ) ) ) ) ).

% times_assn_raw.pelims(1)
tff(fact_279_times__assn__raw_Opelims_I2_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X,Xa),Xb))
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))))
               => ~ ? [As12: set(nat),As23: set(nat)] :
                      ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As12),As23) )
                      & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As12),As23) = bot_bot(set(nat)) )
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As12)))
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As23))) ) ) ) ) ) ).

% times_assn_raw.pelims(2)
tff(fact_280_times__assn__raw_Opelims_I3_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,times_assn_raw(X,Xa),Xb))
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))))
               => ? [As13: set(nat),As24: set(nat)] :
                    ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As13),As24) )
                    & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As13),As24) = bot_bot(set(nat)) )
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As13)))
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As24))) ) ) ) ) ) ).

% times_assn_raw.pelims(3)
tff(fact_281_effect__tapI,axiom,
    ! [A: $tType,H4: heap_ext(product_unit),H2: heap_ext(product_unit),R3: A,F: fun(heap_ext(product_unit),A)] :
      ( ( H4 = H2 )
     => ( ( R3 = aa(heap_ext(product_unit),A,F,H2) )
       => heap_Time_effect(A,heap_Time_tap(A,F),H2,H4,R3,one_one(nat)) ) ) ).

% effect_tapI
tff(fact_282_effect__tapE,axiom,
    ! [A: $tType,F: fun(heap_ext(product_unit),A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( heap_Time_effect(A,heap_Time_tap(A,F),H2,H4,R3,N)
     => ~ ( ( H4 = H2 )
         => ( ( R3 = aa(heap_ext(product_unit),A,F,H2) )
           => ( N != one_one(nat) ) ) ) ) ).

% effect_tapE
tff(fact_283_times__assn__def,axiom,
    ! [P: assn,Q: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,times_assn_raw(aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q))) ) ).

% times_assn_def
tff(fact_284_effect__assertI,axiom,
    ! [A: $tType,P: fun(A,bool),X: A,H4: heap_ext(product_unit),H2: heap_ext(product_unit),R3: A,N: nat] :
      ( pp(aa(A,bool,P,X))
     => ( ( H4 = H2 )
       => ( ( R3 = X )
         => ( ( N = one_one(nat) )
           => heap_Time_effect(A,heap_Time_assert(A,P,X),H2,H4,R3,N) ) ) ) ) ).

% effect_assertI
tff(fact_285_Rep__assn__inverse,axiom,
    ! [X: assn] : ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,X)) = X ) ).

% Rep_assn_inverse
tff(fact_286_Abs__assn__eqI_I1_J,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Pr: assn] :
      ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,H))
        <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Pr),H)) )
     => ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,P) = Pr ) ) ).

% Abs_assn_eqI(1)
tff(fact_287_Abs__assn__eqI_I2_J,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Pr: assn] :
      ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,H))
        <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Pr),H)) )
     => ( Pr = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,P) ) ) ).

% Abs_assn_eqI(2)
tff(fact_288_pure__assn__def,axiom,
    ! [B2: bool] : ( pure_assn(B2) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,pure_assn_raw(heap_ext(product_unit),nat,B2)) ) ).

% pure_assn_def
tff(fact_289_assert__cong,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),P2: fun(A,bool),F: fun(A,heap_Time_Heap(B)),F10: fun(A,heap_Time_Heap(B)),X: A] :
      ( ( P = P2 )
     => ( ! [X2: A] :
            ( pp(aa(A,bool,P2,X2))
           => ( aa(A,heap_Time_Heap(B),F,X2) = aa(A,heap_Time_Heap(B),F10,X2) ) )
       => ( heap_Time_bind(A,B,heap_Time_assert(A,P,X),F) = heap_Time_bind(A,B,heap_Time_assert(A,P2,X),F10) ) ) ) ).

% assert_cong
tff(fact_290_success__assertI,axiom,
    ! [A: $tType,P: fun(A,bool),X: A,H2: heap_ext(product_unit)] :
      ( pp(aa(A,bool,P,X))
     => heap_Time_success(A,heap_Time_assert(A,P,X),H2) ) ).

% success_assertI
tff(fact_291_success__tapI,axiom,
    ! [A: $tType,F: fun(heap_ext(product_unit),A),H2: heap_ext(product_unit)] : heap_Time_success(A,heap_Time_tap(A,F),H2) ).

% success_tapI
tff(fact_292_bex2I,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,S2: set(product_prod(A,B)),P: fun(A,fun(B,bool))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),S2))
     => ( ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),S2))
         => pp(aa(B,bool,aa(A,fun(B,bool),P,A3),B2)) )
       => ? [A8: A,B5: B] :
            ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5),S2))
            & pp(aa(B,bool,aa(A,fun(B,bool),P,A8),B5)) ) ) ) ).

% bex2I
tff(fact_293_set__notEmptyE,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ( S2 != bot_bot(set(A)) )
     => ~ ! [X2: A] : ~ pp(member(A,X2,S2)) ) ).

% set_notEmptyE
tff(fact_294_memb__imp__not__empty,axiom,
    ! [A: $tType,X: A,S2: set(A)] :
      ( pp(member(A,X,S2))
     => ( S2 != bot_bot(set(A)) ) ) ).

% memb_imp_not_empty
tff(fact_295_fun__comp__eq__conv,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(C,B),G: fun(A,C),Fg: fun(A,B)] :
      ( ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),F),G) = Fg )
    <=> ! [X4: A] : ( aa(C,B,F,aa(A,C,G,X4)) = aa(A,B,Fg,X4) ) ) ).

% fun_comp_eq_conv
tff(fact_296_comp__cong__right,axiom,
    ! [C: $tType,B: $tType,A: $tType,X: fun(A,B),Y: fun(A,B),F: fun(B,C)] :
      ( ( X = Y )
     => ( aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),X) = aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),Y) ) ) ).

% comp_cong_right
tff(fact_297_comp__cong__left,axiom,
    ! [B: $tType,A: $tType,C: $tType,X: fun(A,B),Y: fun(A,B),F: fun(C,A)] :
      ( ( X = Y )
     => ( aa(fun(C,A),fun(C,B),aa(fun(A,B),fun(fun(C,A),fun(C,B)),comp(A,B,C),X),F) = aa(fun(C,A),fun(C,B),aa(fun(A,B),fun(fun(C,A),fun(C,B)),comp(A,B,C),Y),F) ) ) ).

% comp_cong_left
tff(fact_298_one__assn__def,axiom,
    one_one(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,one_assn_raw) ).

% one_assn_def
tff(fact_299_effect__assertE,axiom,
    ! [A: $tType,P: fun(A,bool),X: A,H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( heap_Time_effect(A,heap_Time_assert(A,P,X),H2,H4,R3,N)
     => ~ ( pp(aa(A,bool,P,X))
         => ( ( R3 = X )
           => ( ( H4 = H2 )
             => ( N != one_one(nat) ) ) ) ) ) ).

% effect_assertE
tff(fact_300_wand__assn__def,axiom,
    ! [P: assn,Q: assn] : ( wand_assn(P,Q) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,wand_raw(aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q))) ) ).

% wand_assn_def
tff(fact_301_uncurry__apply,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(B,fun(C,A)),A3: B,B2: C] : ( uncurry(B,C,A,F,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),B2)) = aa(C,A,aa(B,fun(C,A),F,A3),B2) ) ).

% uncurry_apply
tff(fact_302_sngr__assn__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),X: A] : ( sngr_assn(A,R3,X) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,sngr_assn_raw(A,R3,X)) ) ) ).

% sngr_assn_def
tff(fact_303_snga__assn__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: array(A),A3: list(A)] : ( snga_assn(A,R3,A3) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,snga_assn_raw(A,R3,A3)) ) ) ).

% snga_assn_def
tff(fact_304_pairself_Opelims,axiom,
    ! [B: $tType,A: $tType,X: fun(A,B),Xa: product_prod(A,A),Y: product_prod(B,B)] :
      ( ( aa(product_prod(A,A),product_prod(B,B),pairself(A,B,X),Xa) = Y )
     => ( pp(aa(product_prod(fun(A,B),product_prod(A,A)),bool,accp(product_prod(fun(A,B),product_prod(A,A)),pairself_rel(A,B)),aa(product_prod(A,A),product_prod(fun(A,B),product_prod(A,A)),aa(fun(A,B),fun(product_prod(A,A),product_prod(fun(A,B),product_prod(A,A))),product_Pair(fun(A,B),product_prod(A,A)),X),Xa)))
       => ~ ! [A8: A,B5: A] :
              ( ( Xa = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A8),B5) )
             => ( ( Y = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,X,A8)),aa(A,B,X,B5)) )
               => ~ pp(aa(product_prod(fun(A,B),product_prod(A,A)),bool,accp(product_prod(fun(A,B),product_prod(A,A)),pairself_rel(A,B)),aa(product_prod(A,A),product_prod(fun(A,B),product_prod(A,A)),aa(fun(A,B),fun(product_prod(A,A),product_prod(fun(A,B),product_prod(A,A))),product_Pair(fun(A,B),product_prod(A,A)),X),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A8),B5)))) ) ) ) ) ).

% pairself.pelims
tff(fact_305_wand__assnI,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat),Q: assn,R: assn] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
     => ( ! [H5: heap_ext(product_unit),As4: set(nat)] :
            ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As4) = bot_bot(set(nat)) )
           => ( relH(As,H2,H5)
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As)))
               => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As4)))
                 => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,R),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As4)))) ) ) ) )
       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,wand_assn(Q,R)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))) ) ) ).

% wand_assnI
tff(fact_306_mod__pure,axiom,
    ! [B2: bool,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,pure_assn(B2)),H2))
    <=> ( ( aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2) = bot_bot(set(nat)) )
        & pp(B2) ) ) ).

% mod_pure
tff(fact_307_pure__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X: bool,Xa: product_prod(A,set(B)),Y: bool] :
      ( ( pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X),Xa))
      <=> pp(Y) )
     => ( pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X),Xa)))
       => ~ ! [H: A,As2: set(B)] :
              ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H),As2) )
             => ( ( pp(Y)
                <=> ( ( As2 = bot_bot(set(B)) )
                    & pp(X) ) )
               => ~ pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X),aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H),As2)))) ) ) ) ) ).

% pure_assn_raw.pelims(1)
tff(fact_308_pure__assn__raw_Opelims_I2_J,axiom,
    ! [B: $tType,A: $tType,X: bool,Xa: product_prod(A,set(B))] :
      ( pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X),Xa))
     => ( pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X),Xa)))
       => ~ ! [H: A,As2: set(B)] :
              ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H),As2) )
             => ( pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X),aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H),As2))))
               => ~ ( ( As2 = bot_bot(set(B)) )
                    & pp(X) ) ) ) ) ) ).

% pure_assn_raw.pelims(2)
tff(fact_309_pure__assn__raw_Opelims_I3_J,axiom,
    ! [B: $tType,A: $tType,X: bool,Xa: product_prod(A,set(B))] :
      ( ~ pp(aa(product_prod(A,set(B)),bool,pure_assn_raw(A,B,X),Xa))
     => ( pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X),Xa)))
       => ~ ! [H: A,As2: set(B)] :
              ( ( Xa = aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H),As2) )
             => ( pp(aa(product_prod(bool,product_prod(A,set(B))),bool,accp(product_prod(bool,product_prod(A,set(B))),pure_assn_raw_rel(A,B)),aa(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B))),aa(bool,fun(product_prod(A,set(B)),product_prod(bool,product_prod(A,set(B)))),product_Pair(bool,product_prod(A,set(B))),X),aa(set(B),product_prod(A,set(B)),aa(A,fun(set(B),product_prod(A,set(B))),product_Pair(A,set(B)),H),As2))))
               => ( ( As2 = bot_bot(set(B)) )
                  & pp(X) ) ) ) ) ) ).

% pure_assn_raw.pelims(3)
tff(fact_310_monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( monoid(A,F,Z2)
     => monoid_axioms(A,F,Z2) ) ).

% monoid.axioms(2)
tff(fact_311_relH__dist__union,axiom,
    ! [As: set(nat),As3: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( relH(aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As3),H2,H4)
    <=> ( relH(As,H2,H4)
        & relH(As3,H2,H4) ) ) ).

% relH_dist_union
tff(fact_312_in__range__empty,axiom,
    ! [H2: heap_ext(product_unit)] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ).

% in_range_empty
tff(fact_313_in__range__dist__union,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat),As3: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As3))))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3))) ) ) ).

% in_range_dist_union
tff(fact_314_relH__trans,axiom,
    ! [As: set(nat),H12: heap_ext(product_unit),H23: heap_ext(product_unit),H32: heap_ext(product_unit)] :
      ( relH(As,H12,H23)
     => ( relH(As,H23,H32)
       => relH(As,H12,H32) ) ) ).

% relH_trans
tff(fact_315_relH__sym,axiom,
    ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( relH(As,H2,H4)
     => relH(As,H4,H2) ) ).

% relH_sym
tff(fact_316_relH__refl,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
     => relH(As,H2,H2) ) ).

% relH_refl
tff(fact_317_relH__in__rangeI_I1_J,axiom,
    ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( relH(As,H2,H4)
     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))) ) ).

% relH_in_rangeI(1)
tff(fact_318_relH__in__rangeI_I2_J,axiom,
    ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( relH(As,H2,H4)
     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ).

% relH_in_rangeI(2)
tff(fact_319_monoid__axioms_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( ! [A8: A] : ( aa(A,A,aa(A,fun(A,A),F,Z2),A8) = A8 )
     => ( ! [A8: A] : ( aa(A,A,aa(A,fun(A,A),F,A8),Z2) = A8 )
       => monoid_axioms(A,F,Z2) ) ) ).

% monoid_axioms.intro
tff(fact_320_monoid__axioms__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( monoid_axioms(A,F,Z2)
    <=> ( ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F,Z2),A6) = A6 )
        & ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F,A6),Z2) = A6 ) ) ) ).

% monoid_axioms_def
tff(fact_321_snd__eqD,axiom,
    ! [B: $tType,A: $tType,X: B,Y: A,A3: A] :
      ( ( aa(product_prod(B,A),A,product_snd(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X),Y)) = A3 )
     => ( Y = A3 ) ) ).

% snd_eqD
tff(fact_322_snd__conv,axiom,
    ! [Aa: $tType,A: $tType,X1: Aa,X22: A] : ( aa(product_prod(Aa,A),A,product_snd(Aa,A),aa(A,product_prod(Aa,A),aa(Aa,fun(A,product_prod(Aa,A)),product_Pair(Aa,A),X1),X22)) = X22 ) ).

% snd_conv
tff(fact_323_sndE,axiom,
    ! [A: $tType,B: $tType,X: product_prod(A,B),A3: A,B2: B,P: fun(B,bool)] :
      ( ( X = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2) )
     => ( pp(aa(B,bool,P,aa(product_prod(A,B),B,product_snd(A,B),X)))
       => pp(aa(B,bool,P,B2)) ) ) ).

% sndE
tff(fact_324_models__in__range,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,H2)) ) ).

% models_in_range
tff(fact_325_wand__raw_Oelims_I3_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X,Xa),Xb))
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
              & ! [H5: heap_ext(product_unit),As4: set(nat)] :
                  ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As4) = bot_bot(set(nat)) )
                    & relH(As2,H,H5)
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)))
                    & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As4))) )
                 => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As4)))) ) ) ) ) ).

% wand_raw.elims(3)
tff(fact_326_wand__raw_Oelims_I2_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X,Xa),Xb))
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ~ ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
                & ! [H7: heap_ext(product_unit),As5: set(nat)] :
                    ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As5) = bot_bot(set(nat)) )
                      & relH(As2,H,H7)
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As2)))
                      & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As5))) )
                   => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As5)))) ) ) ) ) ).

% wand_raw.elims(2)
tff(fact_327_wand__raw_Oelims_I1_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X,Xa),Xb))
      <=> pp(Y) )
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( pp(Y)
            <=> ~ ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
                  & ! [H8: heap_ext(product_unit),As6: set(nat)] :
                      ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As6) = bot_bot(set(nat)) )
                        & relH(As2,H,H8)
                        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As2)))
                        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As6))) )
                     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As6)))) ) ) ) ) ) ).

% wand_raw.elims(1)
tff(fact_328_wand__raw_Osimps,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool),H2: heap_ext(product_unit),As: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(P,Q),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
        & ! [H8: heap_ext(product_unit),As6: set(nat)] :
            ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As6) = bot_bot(set(nat)) )
              & relH(As,H2,H8)
              & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As)))
              & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As6))) )
           => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Q,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As6)))) ) ) ) ).

% wand_raw.simps
tff(fact_329_pairself_Oelims,axiom,
    ! [B: $tType,A: $tType,X: fun(A,B),Xa: product_prod(A,A),Y: product_prod(B,B)] :
      ( ( aa(product_prod(A,A),product_prod(B,B),pairself(A,B,X),Xa) = Y )
     => ~ ! [A8: A,B5: A] :
            ( ( Xa = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A8),B5) )
           => ( Y != aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,X,A8)),aa(A,B,X,B5)) ) ) ) ).

% pairself.elims
tff(fact_330_pairself_Osimps,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),A3: A,B2: A] : ( aa(product_prod(A,A),product_prod(B,B),pairself(A,B,F),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2)) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,F,A3)),aa(A,B,F,B2)) ) ).

% pairself.simps
tff(fact_331_mod__relH,axiom,
    ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit),P: assn] :
      ( relH(As,H2,H4)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
      <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ) ).

% mod_relH
tff(fact_332_mod__emp,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,one_one(assn)),H2))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2) = bot_bot(set(nat)) ) ) ).

% mod_emp
tff(fact_333_wand__raw_Opelims_I1_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X,Xa),Xb))
      <=> pp(Y) )
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( ( pp(Y)
                <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
                    & ! [H8: heap_ext(product_unit),As6: set(nat)] :
                        ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As6) = bot_bot(set(nat)) )
                          & relH(As2,H,H8)
                          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As2)))
                          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As6))) )
                       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As6)))) ) ) )
               => ~ pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))) ) ) ) ) ).

% wand_raw.pelims(1)
tff(fact_334_wand__raw_Opelims_I2_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X,Xa),Xb))
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))))
               => ~ ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
                    & ! [H7: heap_ext(product_unit),As5: set(nat)] :
                        ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As5) = bot_bot(set(nat)) )
                          & relH(As2,H,H7)
                          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As2)))
                          & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),As5))) )
                       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As5)))) ) ) ) ) ) ) ).

% wand_raw.pelims(2)
tff(fact_335_wand__raw_Opelims_I3_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,wand_raw(X,Xa),Xb))
     => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( pp(aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),bool),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))))
               => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
                  & ! [H5: heap_ext(product_unit),As4: set(nat)] :
                      ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As4) = bot_bot(set(nat)) )
                        & relH(As2,H,H5)
                        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)))
                        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As4))) )
                     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As4)))) ) ) ) ) ) ) ).

% wand_raw.pelims(3)
tff(fact_336_sndI,axiom,
    ! [A: $tType,B: $tType,X: product_prod(A,B),Y: A,Z2: B] :
      ( ( X = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Y),Z2) )
     => ( aa(product_prod(A,B),B,product_snd(A,B),X) = Z2 ) ) ).

% sndI
tff(fact_337_eq__snd__iff,axiom,
    ! [B: $tType,A: $tType,B2: A,P3: product_prod(B,A)] :
      ( ( B2 = aa(product_prod(B,A),A,product_snd(B,A),P3) )
    <=> ? [A6: B] : ( P3 = aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),A6),B2) ) ) ).

% eq_snd_iff
tff(fact_338_proper__iff,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( relH(As,H2,H4)
       => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
         => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
          <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ) ) ) ).

% proper_iff
tff(fact_339_proper__def,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
    <=> ! [H3: heap_ext(product_unit),H8: heap_ext(product_unit),As7: set(nat)] :
          ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As7)))
           => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As7))) )
          & ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As7)))
              & relH(As7,H3,H8)
              & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As7))) )
           => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As7))) ) ) ) ).

% proper_def
tff(fact_340_properD2,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),H2: heap_ext(product_unit),As: set(nat),H4: heap_ext(product_unit)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
       => ( relH(As,H2,H4)
         => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
           => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))) ) ) ) ) ).

% properD2
tff(fact_341_properI,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( ! [As2: set(nat),H: heap_ext(product_unit)] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
         => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))) )
     => ( ! [As2: set(nat),H: heap_ext(product_unit),H5: heap_ext(product_unit)] :
            ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
           => ( relH(As2,H,H5)
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)))
               => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))) ) ) )
       => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P)) ) ) ).

% properI
tff(fact_342_monoid__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( monoid(A,F,Z2)
    <=> ( semigroup(A,F)
        & monoid_axioms(A,F,Z2) ) ) ).

% monoid_def
tff(fact_343_monoid_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( semigroup(A,F)
     => ( monoid_axioms(A,F,Z2)
       => monoid(A,F,Z2) ) ) ).

% monoid.intro
tff(fact_344_bool__assn__proper_I1_J,axiom,
    pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,in_range)) ).

% bool_assn_proper(1)
tff(fact_345_one__assn__proper,axiom,
    pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,one_assn_raw)) ).

% one_assn_proper
tff(fact_346_times__assn__proper,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,Q))
       => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,times_assn_raw(P,Q))) ) ) ).

% times_assn_proper
tff(fact_347_wand__proper,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,wand_raw(P,Q))) ).

% wand_proper
tff(fact_348_snga__assn__proper,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: array(A),X: list(A)] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,snga_assn_raw(A,R3,X))) ) ).

% snga_assn_proper
tff(fact_349_sngr__assn__proper,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),X: A] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,sngr_assn_raw(A,R3,X))) ) ).

% sngr_assn_proper
tff(fact_350_pure__assn__proper,axiom,
    ! [B2: bool] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,pure_assn_raw(heap_ext(product_unit),nat,B2))) ).

% pure_assn_proper
tff(fact_351_semigroup_Oassoc,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A3: A,B2: A,C2: A] :
      ( semigroup(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),F,A3),aa(A,A,aa(A,fun(A,A),F,B2),C2)) ) ) ).

% semigroup.assoc
tff(fact_352_semigroup_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( ! [A8: A,B5: A,C4: A] : ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,A8),B5)),C4) = aa(A,A,aa(A,fun(A,A),F,A8),aa(A,A,aa(A,fun(A,A),F,B5),C4)) )
     => semigroup(A,F) ) ).

% semigroup.intro
tff(fact_353_semigroup__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( semigroup(A,F)
    <=> ! [A6: A,B6: A,C5: A] : ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,A6),B6)),C5) = aa(A,A,aa(A,fun(A,A),F,A6),aa(A,A,aa(A,fun(A,A),F,B6),C5)) ) ) ).

% semigroup_def
tff(fact_354_Rep__assn__induct,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),bool),P: fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool)] :
      ( pp(member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
     => ( ! [X2: assn] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,P,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,X2)))
       => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,P,Y)) ) ) ).

% Rep_assn_induct
tff(fact_355_Rep__assn__cases,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
     => ~ ! [X2: assn] : ( Y != aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,X2) ) ) ).

% Rep_assn_cases
tff(fact_356_Rep__assn,axiom,
    ! [X: assn] : pp(member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,X),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper))) ).

% Rep_assn
tff(fact_357_mult_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( semigroup_mult(A)
     => semigroup(A,times_times(A)) ) ).

% mult.semigroup_axioms
tff(fact_358_inf_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => semigroup(A,inf_inf(A)) ) ).

% inf.semigroup_axioms
tff(fact_359_sup_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => semigroup(A,sup_sup(A)) ) ).

% sup.semigroup_axioms
tff(fact_360_Abs__assn__cases,axiom,
    ! [X: assn] :
      ~ ! [Y2: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
          ( ( X = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,Y2) )
         => ~ pp(member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y2,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper))) ) ).

% Abs_assn_cases
tff(fact_361_Abs__assn__induct,axiom,
    ! [P: fun(assn,bool),X: assn] :
      ( ! [Y2: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
          ( pp(member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y2,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
         => pp(aa(assn,bool,P,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,Y2))) )
     => pp(aa(assn,bool,P,X)) ) ).

% Abs_assn_induct
tff(fact_362_Abs__assn__inject,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),X,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
     => ( pp(member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
       => ( ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,X) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,Y) )
        <=> ( X = Y ) ) ) ) ).

% Abs_assn_inject
tff(fact_363_monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( monoid(A,F,Z2)
     => semigroup(A,F) ) ).

% monoid.axioms(1)
tff(fact_364_properD1,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),H2: heap_ext(product_unit),As: set(nat)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,P,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))) ) ) ).

% properD1
tff(fact_365_Abs__assn__inverse,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(member(fun(product_prod(heap_ext(product_unit),set(nat)),bool),Y,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)))
     => ( aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,Y)) = Y ) ) ).

% Abs_assn_inverse
tff(fact_366_comp__apply__eq,axiom,
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: fun(B,A),G: fun(C,B),X: C,H2: fun(D,A),K: fun(C,D)] :
      ( ( aa(B,A,F,aa(C,B,G,X)) = aa(D,A,H2,aa(C,D,K,X)) )
     => ( aa(C,A,aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),F),G),X) = aa(C,A,aa(fun(C,D),fun(C,A),aa(fun(D,A),fun(fun(C,D),fun(C,A)),comp(D,A,C),H2),K),X) ) ) ).

% comp_apply_eq
tff(fact_367_type__definition__assn,axiom,
    type_definition(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,abs_assn,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool),set(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),bool)),proper)) ).

% type_definition_assn
tff(fact_368_rewriteR__comp__comp2,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G: fun(C,B),H2: fun(A,C),R1: fun(D,B),R22: fun(A,D),F: fun(B,E),L: fun(D,E)] :
      ( ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),G),H2) = aa(fun(A,D),fun(A,B),aa(fun(D,B),fun(fun(A,D),fun(A,B)),comp(D,B,A),R1),R22) )
     => ( ( aa(fun(D,B),fun(D,E),aa(fun(B,E),fun(fun(D,B),fun(D,E)),comp(B,E,D),F),R1) = L )
       => ( aa(fun(A,C),fun(A,E),aa(fun(C,E),fun(fun(A,C),fun(A,E)),comp(C,E,A),aa(fun(C,B),fun(C,E),aa(fun(B,E),fun(fun(C,B),fun(C,E)),comp(B,E,C),F),G)),H2) = aa(fun(A,D),fun(A,E),aa(fun(D,E),fun(fun(A,D),fun(A,E)),comp(D,E,A),L),R22) ) ) ) ).

% rewriteR_comp_comp2
tff(fact_369_rewriteL__comp__comp2,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: fun(C,B),G: fun(A,C),L1: fun(D,B),L2: fun(A,D),H2: fun(E,A),R3: fun(E,D)] :
      ( ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),F),G) = aa(fun(A,D),fun(A,B),aa(fun(D,B),fun(fun(A,D),fun(A,B)),comp(D,B,A),L1),L2) )
     => ( ( aa(fun(E,A),fun(E,D),aa(fun(A,D),fun(fun(E,A),fun(E,D)),comp(A,D,E),L2),H2) = R3 )
       => ( aa(fun(E,C),fun(E,B),aa(fun(C,B),fun(fun(E,C),fun(E,B)),comp(C,B,E),F),aa(fun(E,A),fun(E,C),aa(fun(A,C),fun(fun(E,A),fun(E,C)),comp(A,C,E),G),H2)) = aa(fun(E,D),fun(E,B),aa(fun(D,B),fun(fun(E,D),fun(E,B)),comp(D,B,E),L1),R3) ) ) ) ).

% rewriteL_comp_comp2
tff(fact_370_rewriteR__comp__comp,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: fun(C,B),H2: fun(A,C),R3: fun(A,B),F: fun(B,D)] :
      ( ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),G),H2) = R3 )
     => ( aa(fun(A,C),fun(A,D),aa(fun(C,D),fun(fun(A,C),fun(A,D)),comp(C,D,A),aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),F),G)),H2) = aa(fun(A,B),fun(A,D),aa(fun(B,D),fun(fun(A,B),fun(A,D)),comp(B,D,A),F),R3) ) ) ).

% rewriteR_comp_comp
tff(fact_371_rewriteL__comp__comp,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: fun(C,B),G: fun(A,C),L: fun(A,B),H2: fun(D,A)] :
      ( ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),F),G) = L )
     => ( aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),F),aa(fun(D,A),fun(D,C),aa(fun(A,C),fun(fun(D,A),fun(D,C)),comp(A,C,D),G),H2)) = aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),L),H2) ) ) ).

% rewriteL_comp_comp
tff(fact_372_type__copy__map__cong0,axiom,
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: fun(B,A),G: fun(C,B),X: C,N4: fun(D,A),H2: fun(C,D),F: fun(A,E)] :
      ( ( aa(B,A,M,aa(C,B,G,X)) = aa(D,A,N4,aa(C,D,H2,X)) )
     => ( aa(C,E,aa(fun(C,B),fun(C,E),aa(fun(B,E),fun(fun(C,B),fun(C,E)),comp(B,E,C),aa(fun(B,A),fun(B,E),aa(fun(A,E),fun(fun(B,A),fun(B,E)),comp(A,E,B),F),M)),G),X) = aa(C,E,aa(fun(C,D),fun(C,E),aa(fun(D,E),fun(fun(C,D),fun(C,E)),comp(D,E,C),aa(fun(D,A),fun(D,E),aa(fun(A,E),fun(fun(D,A),fun(D,E)),comp(A,E,D),F),N4)),H2),X) ) ) ).

% type_copy_map_cong0
tff(fact_373_comp__cong,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F: fun(B,A),G: fun(C,B),X: C,F10: fun(D,A),G4: fun(E,D),X5: E] :
      ( ( aa(B,A,F,aa(C,B,G,X)) = aa(D,A,F10,aa(E,D,G4,X5)) )
     => ( aa(C,A,aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),F),G),X) = aa(E,A,aa(fun(E,D),fun(E,A),aa(fun(D,A),fun(fun(E,D),fun(E,A)),comp(D,A,E),F10),G4),X5) ) ) ).

% comp_cong
tff(fact_374_fun_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G: fun(B,C),F: fun(A,B),V: fun(D,A)] : ( aa(fun(D,B),fun(D,C),aa(fun(B,C),fun(fun(D,B),fun(D,C)),comp(B,C,D),G),aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),F),V)) = aa(fun(D,A),fun(D,C),aa(fun(A,C),fun(fun(D,A),fun(D,C)),comp(A,C,D),aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),G),F)),V) ) ).

% fun.map_comp
tff(fact_375_mod__h__bot__iff_I2_J,axiom,
    ! [H2: heap_ext(product_unit)] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,top_top(assn)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ).

% mod_h_bot_iff(2)
tff(fact_376_override__on__emptyset,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),G: fun(A,B)] : ( override_on(A,B,F,G,bot_bot(set(A))) = F ) ).

% override_on_emptyset
tff(fact_377_mult_Osafe__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [X: A,Y: A,A3: A,B2: A] :
          ( syntax7388354845996824322omatch(A,A,aa(A,A,aa(A,fun(A,A),times_times(A),X),Y),A3)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3) ) ) ) ).

% mult.safe_commute
tff(fact_378_top__apply,axiom,
    ! [D: $tType,C: $tType] :
      ( top(C)
     => ! [X: D] : ( aa(D,C,top_top(fun(D,C)),X) = top_top(C) ) ) ).

% top_apply
tff(fact_379_inf__top_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),top_top(A)) = A3 ) ) ).

% inf_top.right_neutral
tff(fact_380_inf__top_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [A3: A,B2: A] :
          ( ( top_top(A) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) )
        <=> ( ( A3 = top_top(A) )
            & ( B2 = top_top(A) ) ) ) ) ).

% inf_top.neutr_eq_iff
tff(fact_381_inf__top_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),top_top(A)),A3) = A3 ) ) ).

% inf_top.left_neutral
tff(fact_382_inf__top_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = top_top(A) )
        <=> ( ( A3 = top_top(A) )
            & ( B2 = top_top(A) ) ) ) ) ).

% inf_top.eq_neutr_iff
tff(fact_383_top__eq__inf__iff,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [X: A,Y: A] :
          ( ( top_top(A) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) )
        <=> ( ( X = top_top(A) )
            & ( Y = top_top(A) ) ) ) ) ).

% top_eq_inf_iff
tff(fact_384_inf__eq__top__iff,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) = top_top(A) )
        <=> ( ( X = top_top(A) )
            & ( Y = top_top(A) ) ) ) ) ).

% inf_eq_top_iff
tff(fact_385_inf__top__right,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),top_top(A)) = X ) ) ).

% inf_top_right
tff(fact_386_inf__top__left,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),top_top(A)),X) = X ) ) ).

% inf_top_left
tff(fact_387_sup__top__left,axiom,
    ! [A: $tType] :
      ( bounded_lattice_top(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),top_top(A)),X) = top_top(A) ) ) ).

% sup_top_left
tff(fact_388_sup__top__right,axiom,
    ! [A: $tType] :
      ( bounded_lattice_top(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),top_top(A)) = top_top(A) ) ) ).

% sup_top_right
tff(fact_389_boolean__algebra_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),top_top(A)),X) = top_top(A) ) ) ).

% boolean_algebra.disj_one_left
tff(fact_390_boolean__algebra_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),top_top(A)) = top_top(A) ) ) ).

% boolean_algebra.disj_one_right
tff(fact_391_merge__true__star,axiom,
    aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),top_top(assn)),top_top(assn)) = top_top(assn) ).

% merge_true_star
tff(fact_392_assn__basic__inequalities_I1_J,axiom,
    top_top(assn) != one_one(assn) ).

% assn_basic_inequalities(1)
tff(fact_393_assn__basic__inequalities_I5_J,axiom,
    top_top(assn) != bot_bot(assn) ).

% assn_basic_inequalities(5)
tff(fact_394_mod__true,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,top_top(assn)),H2))
    <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,H2)) ) ).

% mod_true
tff(fact_395_syntax__fo__nomatch__def,axiom,
    ! [A: $tType,B: $tType,Pat: A,Obj: B] : syntax7388354845996824322omatch(A,B,Pat,Obj) ).

% syntax_fo_nomatch_def
tff(fact_396_boolean__algebra_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),top_top(A)) = X ) ) ).

% boolean_algebra.conj_one_right
tff(fact_397_ent__true,axiom,
    ! [P: assn] : entails(P,top_top(assn)) ).

% ent_true
tff(fact_398_mod__star__trueE,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),top_top(assn))),H2))
     => ~ ! [H5: product_prod(heap_ext(product_unit),set(nat))] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H5)) ) ).

% mod_star_trueE
tff(fact_399_mod__star__trueI,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2))
     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),top_top(assn))),H2)) ) ).

% mod_star_trueI
tff(fact_400_inf__top_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => monoid(A,inf_inf(A),top_top(A)) ) ).

% inf_top.monoid_axioms
tff(fact_401_inf__top_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => semilattice_neutr(A,inf_inf(A),top_top(A)) ) ).

% inf_top.semilattice_neutr_axioms
tff(fact_402_top__assn__def,axiom,
    top_top(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,in_range) ).

% top_assn_def
tff(fact_403_boolean__algebra_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [A3: A,X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),X) = bot_bot(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),X) = top_top(A) )
           => ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),Y) = bot_bot(A) )
             => ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),Y) = top_top(A) )
               => ( X = Y ) ) ) ) ) ) ).

% boolean_algebra.complement_unique
tff(fact_404_enttD,axiom,
    ! [A4: assn,B3: assn] :
      ( entailst(A4,B3)
     => entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B3),top_top(assn))) ) ).

% enttD
tff(fact_405_enttI,axiom,
    ! [A4: assn,B3: assn] :
      ( entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B3),top_top(assn)))
     => entailst(A4,B3) ) ).

% enttI
tff(fact_406_enttI__true,axiom,
    ! [P: assn,Q: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),top_top(assn)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),top_top(assn)))
     => entailst(P,Q) ) ).

% enttI_true
tff(fact_407_entailst__def,axiom,
    ! [A4: assn,B3: assn] :
      ( entailst(A4,B3)
    <=> entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B3),top_top(assn))) ) ).

% entailst_def
tff(fact_408_entt__def__true,axiom,
    ! [P: assn,Q: assn] :
      ( entailst(P,Q)
    <=> entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),top_top(assn)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),top_top(assn))) ) ).

% entt_def_true
tff(fact_409_boolean__algebra__class_Oboolean__algebra_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) = bot_bot(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) = top_top(A) )
           => ( aa(A,A,uminus_uminus(A),X) = Y ) ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_unique
tff(fact_410_entt__star__true__simp_I1_J,axiom,
    ! [A4: assn,B3: assn] :
      ( entailst(A4,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B3),top_top(assn)))
    <=> entailst(A4,B3) ) ).

% entt_star_true_simp(1)
tff(fact_411_entt__star__true__simp_I2_J,axiom,
    ! [A4: assn,B3: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),top_top(assn)),B3)
    <=> entailst(A4,B3) ) ).

% entt_star_true_simp(2)
tff(fact_412_snd__sndOp,axiom,
    ! [C: $tType,A: $tType,B: $tType,Bc: product_prod(B,A),P: fun(B,fun(C,bool)),Q: fun(C,fun(A,bool))] : ( aa(product_prod(B,A),A,product_snd(B,A),Bc) = aa(product_prod(B,A),A,aa(fun(product_prod(B,A),product_prod(C,A)),fun(product_prod(B,A),A),aa(fun(product_prod(C,A),A),fun(fun(product_prod(B,A),product_prod(C,A)),fun(product_prod(B,A),A)),comp(product_prod(C,A),A,product_prod(B,A)),product_snd(C,A)),bNF_sndOp(B,C,A,P,Q)),Bc) ) ).

% snd_sndOp
tff(fact_413_bijective__def,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B))] :
      ( bijective(A,B,R)
    <=> ( ! [X4: A,Y3: B,Z4: B] :
            ( ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Y3),R))
              & pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Z4),R)) )
           => ( Y3 = Z4 ) )
        & ! [X4: A,Y3: A,Z4: B] :
            ( ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Z4),R))
              & pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Y3),Z4),R)) )
           => ( X4 = Y3 ) ) ) ) ).

% bijective_def
tff(fact_414_ssubst__Pair__rhs,axiom,
    ! [B: $tType,A: $tType,R3: A,S: B,R: set(product_prod(A,B)),S3: B] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),R3),S),R))
     => ( ( S3 = S )
       => pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),R3),S3),R)) ) ) ).

% ssubst_Pair_rhs
tff(fact_415_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),A3)) = A3 ) ) ).

% add.inverse_inverse
tff(fact_416_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,uminus_uminus(A),B2) )
        <=> ( A3 = B2 ) ) ) ).

% neg_equal_iff_equal
tff(fact_417_uminus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( uminus(B)
     => ! [A4: fun(A,B),X: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),uminus_uminus(fun(A,B)),A4),X) = aa(B,B,uminus_uminus(B),aa(A,B,A4,X)) ) ) ).

% uminus_apply
tff(fact_418_boolean__algebra__class_Oboolean__algebra_Odouble__compl,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),X)) = X ) ) ).

% boolean_algebra_class.boolean_algebra.double_compl
tff(fact_419_boolean__algebra__class_Oboolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,uminus_uminus(A),X) = aa(A,A,uminus_uminus(A),Y) )
        <=> ( X = Y ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_eq_compl_iff
tff(fact_420_Int__UNIV,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = top_top(set(A)) )
    <=> ( ( A4 = top_top(set(A)) )
        & ( B3 = top_top(set(A)) ) ) ) ).

% Int_UNIV
tff(fact_421_entt__refl,axiom,
    ! [A4: assn] : entailst(A4,A4) ).

% entt_refl
tff(fact_422_bijective__Empty,axiom,
    ! [B: $tType,A: $tType] : bijective(A,B,bot_bot(set(product_prod(A,B)))) ).

% bijective_Empty
tff(fact_423_Compl__disjoint2,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A4)),A4) = bot_bot(set(A)) ) ).

% Compl_disjoint2
tff(fact_424_Compl__disjoint,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),uminus_uminus(set(A)),A4)) = bot_bot(set(A)) ) ).

% Compl_disjoint
tff(fact_425_mod__not__dist,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,uminus_uminus(assn),P)),H2))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,H2))
        & ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H2)) ) ) ).

% mod_not_dist
tff(fact_426_entt__true,axiom,
    ! [A4: assn] : entailst(A4,top_top(assn)) ).

% entt_true
tff(fact_427_entt__emp,axiom,
    ! [A4: assn] : entailst(A4,one_one(assn)) ).

% entt_emp
tff(fact_428_boolean__algebra_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ( aa(A,A,uminus_uminus(A),bot_bot(A)) = top_top(A) ) ) ).

% boolean_algebra.compl_zero
tff(fact_429_boolean__algebra_Ocompl__one,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ( aa(A,A,uminus_uminus(A),top_top(A)) = bot_bot(A) ) ) ).

% boolean_algebra.compl_one
tff(fact_430_boolean__algebra_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,uminus_uminus(A),X)) = bot_bot(A) ) ) ).

% boolean_algebra.conj_cancel_right
tff(fact_431_boolean__algebra_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X)),X) = bot_bot(A) ) ) ).

% boolean_algebra.conj_cancel_left
tff(fact_432_inf__compl__bot__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),aa(A,A,uminus_uminus(A),X))) = bot_bot(A) ) ) ).

% inf_compl_bot_right
tff(fact_433_inf__compl__bot__left2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X)),Y)) = bot_bot(A) ) ) ).

% inf_compl_bot_left2
tff(fact_434_inf__compl__bot__left1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)) = bot_bot(A) ) ) ).

% inf_compl_bot_left1
tff(fact_435_boolean__algebra_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,uminus_uminus(A),X)) = top_top(A) ) ) ).

% boolean_algebra.disj_cancel_right
tff(fact_436_boolean__algebra_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X)),X) = top_top(A) ) ) ).

% boolean_algebra.disj_cancel_left
tff(fact_437_sup__compl__top__left2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X)),Y)) = top_top(A) ) ) ).

% sup_compl_top_left2
tff(fact_438_sup__compl__top__left1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)) = top_top(A) ) ) ).

% sup_compl_top_left1
tff(fact_439_boolean__algebra_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% boolean_algebra.de_Morgan_disj
tff(fact_440_boolean__algebra_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% boolean_algebra.de_Morgan_conj
tff(fact_441_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,uminus_uminus(A),B2) )
        <=> ( B2 = aa(A,A,uminus_uminus(A),A3) ) ) ) ).

% equation_minus_iff
tff(fact_442_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A3) = B2 )
        <=> ( aa(A,A,uminus_uminus(A),B2) = A3 ) ) ) ).

% minus_equation_iff
tff(fact_443_fun__Compl__def,axiom,
    ! [B: $tType,A: $tType] :
      ( uminus(B)
     => ! [A4: fun(A,B),X3: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),uminus_uminus(fun(A,B)),A4),X3) = aa(B,B,uminus_uminus(B),aa(A,B,A4,X3)) ) ) ).

% fun_Compl_def
tff(fact_444_entt__trans,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( entailst(A4,B3)
     => ( entailst(B3,C3)
       => entailst(A4,C3) ) ) ).

% entt_trans
tff(fact_445_Compl__empty__eq,axiom,
    ! [A: $tType] : ( aa(set(A),set(A),uminus_uminus(set(A)),bot_bot(set(A))) = top_top(set(A)) ) ).

% Compl_empty_eq
tff(fact_446_Compl__UNIV__eq,axiom,
    ! [A: $tType] : ( aa(set(A),set(A),uminus_uminus(set(A)),top_top(set(A))) = bot_bot(set(A)) ) ).

% Compl_UNIV_eq
tff(fact_447_empty__not__UNIV,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) != top_top(set(A)) ) ).

% empty_not_UNIV
tff(fact_448_Int__UNIV__right,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),top_top(set(A))) = A4 ) ).

% Int_UNIV_right
tff(fact_449_Int__UNIV__left,axiom,
    ! [A: $tType,B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),top_top(set(A))),B3) = B3 ) ).

% Int_UNIV_left
tff(fact_450_type__copy__wit,axiom,
    ! [A: $tType,C: $tType,B: $tType,Rep: fun(A,B),Abs: fun(B,A),X: C,S2: fun(B,set(C)),Y: B] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( pp(member(C,X,aa(A,set(C),aa(fun(A,B),fun(A,set(C)),aa(fun(B,set(C)),fun(fun(A,B),fun(A,set(C))),comp(B,set(C),A),S2),Rep),aa(B,A,Abs,Y))))
       => pp(member(C,X,aa(B,set(C),S2,Y))) ) ) ).

% type_copy_wit
tff(fact_451_entt__star__mono,axiom,
    ! [A4: assn,B3: assn,C3: assn,D4: assn] :
      ( entailst(A4,B3)
     => ( entailst(C3,D4)
       => entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),C3),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B3),D4)) ) ) ).

% entt_star_mono
tff(fact_452_entt__frame__fwd,axiom,
    ! [P: assn,Q: assn,A4: assn,F2: assn,B3: assn] :
      ( entailst(P,Q)
     => ( entailst(A4,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),F2))
       => ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Q),F2),B3)
         => entailst(A4,B3) ) ) ) ).

% entt_frame_fwd
tff(fact_453_ent__imp__entt,axiom,
    ! [P: assn,Q: assn] :
      ( entails(P,Q)
     => entailst(P,Q) ) ).

% ent_imp_entt
tff(fact_454_entt__disjI2__direct,axiom,
    ! [B3: assn,A4: assn] : entailst(B3,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B3)) ).

% entt_disjI2_direct
tff(fact_455_entt__disjI1__direct,axiom,
    ! [A4: assn,B3: assn] : entailst(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B3)) ).

% entt_disjI1_direct
tff(fact_456_entt__disjI2_H,axiom,
    ! [A4: assn,C3: assn,B3: assn] :
      ( entailst(A4,C3)
     => entailst(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B3),C3)) ) ).

% entt_disjI2'
tff(fact_457_entt__disjI1_H,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( entailst(A4,B3)
     => entailst(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B3),C3)) ) ).

% entt_disjI1'
tff(fact_458_entt__disjD2,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B3),C3)
     => entailst(B3,C3) ) ).

% entt_disjD2
tff(fact_459_entt__disjD1,axiom,
    ! [A4: assn,B3: assn,C3: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B3),C3)
     => entailst(A4,C3) ) ).

% entt_disjD1
tff(fact_460_entt__disjE,axiom,
    ! [A4: assn,M: assn,B3: assn] :
      ( entailst(A4,M)
     => ( entailst(B3,M)
       => entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B3),M) ) ) ).

% entt_disjE
tff(fact_461_inf__cancel__left2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X)),A3)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),B2)) = bot_bot(A) ) ) ).

% inf_cancel_left2
tff(fact_462_inf__cancel__left1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),A3)),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,uminus_uminus(A),X)),B2)) = bot_bot(A) ) ) ).

% inf_cancel_left1
tff(fact_463_sup__cancel__left2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X)),A3)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),B2)) = top_top(A) ) ) ).

% sup_cancel_left2
tff(fact_464_sup__cancel__left1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),A3)),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),X)),B2)) = top_top(A) ) ) ).

% sup_cancel_left1
tff(fact_465_Compl__Un,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A4)),aa(set(A),set(A),uminus_uminus(set(A)),B3)) ) ).

% Compl_Un
tff(fact_466_Compl__Int,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A4)),aa(set(A),set(A),uminus_uminus(set(A)),B3)) ) ).

% Compl_Int
tff(fact_467_type__copy__map__comp0__undo,axiom,
    ! [E: $tType,A: $tType,C: $tType,B: $tType,D: $tType,F8: $tType,Rep: fun(A,B),Abs: fun(B,A),Rep2: fun(C,D),Abs2: fun(D,C),Rep3: fun(E,F8),Abs3: fun(F8,E),M: fun(F8,D),M1: fun(B,D),M2: fun(F8,B)] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( type_definition(C,D,Rep2,Abs2,top_top(set(D)))
       => ( type_definition(E,F8,Rep3,Abs3,top_top(set(F8)))
         => ( ( aa(fun(E,F8),fun(E,C),aa(fun(F8,C),fun(fun(E,F8),fun(E,C)),comp(F8,C,E),aa(fun(F8,D),fun(F8,C),aa(fun(D,C),fun(fun(F8,D),fun(F8,C)),comp(D,C,F8),Abs2),M)),Rep3) = aa(fun(E,A),fun(E,C),aa(fun(A,C),fun(fun(E,A),fun(E,C)),comp(A,C,E),aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Abs2),M1)),Rep)),aa(fun(E,F8),fun(E,A),aa(fun(F8,A),fun(fun(E,F8),fun(E,A)),comp(F8,A,E),aa(fun(F8,B),fun(F8,A),aa(fun(B,A),fun(fun(F8,B),fun(F8,A)),comp(B,A,F8),Abs),M2)),Rep3)) )
           => ( aa(fun(F8,B),fun(F8,D),aa(fun(B,D),fun(fun(F8,B),fun(F8,D)),comp(B,D,F8),M1),M2) = M ) ) ) ) ) ).

% type_copy_map_comp0_undo
tff(fact_468_type__copy__map__comp0,axiom,
    ! [F8: $tType,D: $tType,B: $tType,A: $tType,C: $tType,E: $tType,Rep: fun(A,B),Abs: fun(B,A),M: fun(C,D),M1: fun(B,D),M2: fun(C,B),F: fun(D,F8),G: fun(E,C)] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( ( M = aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),M1),M2) )
       => ( aa(fun(E,C),fun(E,F8),aa(fun(C,F8),fun(fun(E,C),fun(E,F8)),comp(C,F8,E),aa(fun(C,D),fun(C,F8),aa(fun(D,F8),fun(fun(C,D),fun(C,F8)),comp(D,F8,C),F),M)),G) = aa(fun(E,A),fun(E,F8),aa(fun(A,F8),fun(fun(E,A),fun(E,F8)),comp(A,F8,E),aa(fun(A,B),fun(A,F8),aa(fun(B,F8),fun(fun(A,B),fun(A,F8)),comp(B,F8,A),aa(fun(B,D),fun(B,F8),aa(fun(D,F8),fun(fun(B,D),fun(B,F8)),comp(D,F8,B),F),M1)),Rep)),aa(fun(E,C),fun(E,A),aa(fun(C,A),fun(fun(E,C),fun(E,A)),comp(C,A,E),aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),Abs),M2)),G)) ) ) ) ).

% type_copy_map_comp0
tff(fact_469_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z2),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),Z2) ) ) ).

% mult_minus1_right
tff(fact_470_mult__minus1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),one_one(A))),Z2) = aa(A,A,uminus_uminus(A),Z2) ) ) ).

% mult_minus1
tff(fact_471_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) ) ) ).

% mult_minus_right
tff(fact_472_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) ) ) ).

% minus_mult_minus
tff(fact_473_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A3)),B2) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) ) ) ).

% mult_minus_left
tff(fact_474_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [X: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X),X) = one_one(A) )
        <=> ( ( X = one_one(A) )
            | ( X = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% square_eq_1_iff
tff(fact_475_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( one_one(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% one_neq_neg_one
tff(fact_476_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A3)),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_mult_commute
tff(fact_477_square__eq__iff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),B2) )
        <=> ( ( A3 = B2 )
            | ( A3 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ).

% square_eq_iff
tff(fact_478_snd__comp__apsnd,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(B,C)] : ( aa(fun(product_prod(A,B),product_prod(A,C)),fun(product_prod(A,B),C),aa(fun(product_prod(A,C),C),fun(fun(product_prod(A,B),product_prod(A,C)),fun(product_prod(A,B),C)),comp(product_prod(A,C),C,product_prod(A,B)),product_snd(A,C)),aa(fun(B,C),fun(product_prod(A,B),product_prod(A,C)),product_apsnd(B,C,A),F)) = aa(fun(product_prod(A,B),B),fun(product_prod(A,B),C),aa(fun(B,C),fun(fun(product_prod(A,B),B),fun(product_prod(A,B),C)),comp(B,C,product_prod(A,B)),F),product_snd(A,B)) ) ).

% snd_comp_apsnd
tff(fact_479_boolean__algebra_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => boolea2506097494486148201lgebra(A,inf_inf(A),sup_sup(A),uminus_uminus(A),bot_bot(A),top_top(A)) ) ).

% boolean_algebra.abstract_boolean_algebra_axioms
tff(fact_480_apsnd__conv,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(C,B),X: A,Y: C] : ( aa(product_prod(A,C),product_prod(A,B),aa(fun(C,B),fun(product_prod(A,C),product_prod(A,B)),product_apsnd(C,B,A),F),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),X),Y)) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),aa(C,B,F,Y)) ) ).

% apsnd_conv
tff(fact_481_abstract__boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Y: A,Z2: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,Y),Z2)),X) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,Y),X)),aa(A,A,aa(A,fun(A,A),Disj,Z2),X)) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib2
tff(fact_482_abstract__boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Y: A,Z2: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,Y),Z2)),X) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,Y),X)),aa(A,A,aa(A,fun(A,A),Conj,Z2),X)) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib2
tff(fact_483_abstract__boolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A,Y: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( ( aa(A,A,Compl,X) = aa(A,A,Compl,Y) )
      <=> ( X = Y ) ) ) ).

% abstract_boolean_algebra.compl_eq_compl_iff
tff(fact_484_abstract__boolean__algebra_Odisj__conj__distrib,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A,Y: A,Z2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,X),aa(A,A,aa(A,fun(A,A),Conj,Y),Z2)) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,X),Y)),aa(A,A,aa(A,fun(A,A),Disj,X),Z2)) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib
tff(fact_485_abstract__boolean__algebra_Odisj__cancel__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,X),aa(A,A,Compl,X)) = One ) ) ).

% abstract_boolean_algebra.disj_cancel_right
tff(fact_486_abstract__boolean__algebra_Oconj__disj__distrib,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A,Y: A,Z2: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,X),aa(A,A,aa(A,fun(A,A),Disj,Y),Z2)) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X),Y)),aa(A,A,aa(A,fun(A,A),Conj,X),Z2)) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib
tff(fact_487_abstract__boolean__algebra_Oconj__cancel__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,X),aa(A,A,Compl,X)) = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_right
tff(fact_488_abstract__boolean__algebra_Ocomplement__unique,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,A3: A,X: A,Y: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( ( aa(A,A,aa(A,fun(A,A),Conj,A3),X) = Zero )
       => ( ( aa(A,A,aa(A,fun(A,A),Disj,A3),X) = One )
         => ( ( aa(A,A,aa(A,fun(A,A),Conj,A3),Y) = Zero )
           => ( ( aa(A,A,aa(A,fun(A,A),Disj,A3),Y) = One )
             => ( X = Y ) ) ) ) ) ) ).

% abstract_boolean_algebra.complement_unique
tff(fact_489_abstract__boolean__algebra_Odisj__cancel__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,Compl,X)),X) = One ) ) ).

% abstract_boolean_algebra.disj_cancel_left
tff(fact_490_abstract__boolean__algebra_Oconj__cancel__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,Compl,X)),X) = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_left
tff(fact_491_abstract__boolean__algebra_Odisj__zero__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,X),Zero) = X ) ) ).

% abstract_boolean_algebra.disj_zero_right
tff(fact_492_abstract__boolean__algebra_Oconj__zero__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,X),Zero) = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_right
tff(fact_493_abstract__boolean__algebra_Odisj__one__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,X),One) = One ) ) ).

% abstract_boolean_algebra.disj_one_right
tff(fact_494_abstract__boolean__algebra_Ode__Morgan__disj,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A,Y: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,Compl,aa(A,A,aa(A,fun(A,A),Disj,X),Y)) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,Compl,X)),aa(A,A,Compl,Y)) ) ) ).

% abstract_boolean_algebra.de_Morgan_disj
tff(fact_495_abstract__boolean__algebra_Ode__Morgan__conj,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A,Y: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,Compl,aa(A,A,aa(A,fun(A,A),Conj,X),Y)) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,Compl,X)),aa(A,A,Compl,Y)) ) ) ).

% abstract_boolean_algebra.de_Morgan_conj
tff(fact_496_abstract__boolean__algebra_Oconj__zero__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,Zero),X) = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_left
tff(fact_497_abstract__boolean__algebra_Oconj__one__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Conj,X),One) = X ) ) ).

% abstract_boolean_algebra.conj_one_right
tff(fact_498_abstract__boolean__algebra_Odisj__one__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,aa(A,fun(A,A),Disj,One),X) = One ) ) ).

% abstract_boolean_algebra.disj_one_left
tff(fact_499_abstract__boolean__algebra_Odouble__compl,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,Compl,aa(A,A,Compl,X)) = X ) ) ).

% abstract_boolean_algebra.double_compl
tff(fact_500_abstract__boolean__algebra_Ocompl__unique,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,X: A,Y: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( ( aa(A,A,aa(A,fun(A,A),Conj,X),Y) = Zero )
       => ( ( aa(A,A,aa(A,fun(A,A),Disj,X),Y) = One )
         => ( aa(A,A,Compl,X) = Y ) ) ) ) ).

% abstract_boolean_algebra.compl_unique
tff(fact_501_abstract__boolean__algebra_Ocompl__zero,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,Compl,Zero) = One ) ) ).

% abstract_boolean_algebra.compl_zero
tff(fact_502_abstract__boolean__algebra_Ocompl__one,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( aa(A,A,Compl,One) = Zero ) ) ).

% abstract_boolean_algebra.compl_one
tff(fact_503_apsnd__compose,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F: fun(C,B),G: fun(D,C),X: product_prod(A,D)] : ( aa(product_prod(A,C),product_prod(A,B),aa(fun(C,B),fun(product_prod(A,C),product_prod(A,B)),product_apsnd(C,B,A),F),aa(product_prod(A,D),product_prod(A,C),aa(fun(D,C),fun(product_prod(A,D),product_prod(A,C)),product_apsnd(D,C,A),G),X)) = aa(product_prod(A,D),product_prod(A,B),aa(fun(D,B),fun(product_prod(A,D),product_prod(A,B)),product_apsnd(D,B,A),aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),F),G)),X) ) ).

% apsnd_compose
tff(fact_504_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_inc_simps(4)
tff(fact_505_snd__comp__map__prod,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: fun(A,D),G: fun(B,C)] : ( aa(fun(product_prod(A,B),product_prod(D,C)),fun(product_prod(A,B),C),aa(fun(product_prod(D,C),C),fun(fun(product_prod(A,B),product_prod(D,C)),fun(product_prod(A,B),C)),comp(product_prod(D,C),C,product_prod(A,B)),product_snd(D,C)),product_map_prod(A,D,B,C,F,G)) = aa(fun(product_prod(A,B),B),fun(product_prod(A,B),C),aa(fun(B,C),fun(fun(product_prod(A,B),B),fun(product_prod(A,B),C)),comp(B,C,product_prod(A,B)),G),product_snd(A,B)) ) ).

% snd_comp_map_prod
tff(fact_506_type__copy__set__map0,axiom,
    ! [A: $tType,B: $tType,D: $tType,E: $tType,C: $tType,F8: $tType,Rep: fun(A,B),Abs: fun(B,A),S2: fun(B,set(D)),M: fun(C,B),F: fun(E,D),S4: fun(C,set(E)),G: fun(F8,C)] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( ( aa(fun(C,B),fun(C,set(D)),aa(fun(B,set(D)),fun(fun(C,B),fun(C,set(D))),comp(B,set(D),C),S2),M) = aa(fun(C,set(E)),fun(C,set(D)),aa(fun(set(E),set(D)),fun(fun(C,set(E)),fun(C,set(D))),comp(set(E),set(D),C),image2(E,D,F)),S4) )
       => ( aa(fun(F8,A),fun(F8,set(D)),aa(fun(A,set(D)),fun(fun(F8,A),fun(F8,set(D))),comp(A,set(D),F8),aa(fun(A,B),fun(A,set(D)),aa(fun(B,set(D)),fun(fun(A,B),fun(A,set(D))),comp(B,set(D),A),S2),Rep)),aa(fun(F8,C),fun(F8,A),aa(fun(C,A),fun(fun(F8,C),fun(F8,A)),comp(C,A,F8),aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),Abs),M)),G)) = aa(fun(F8,set(E)),fun(F8,set(D)),aa(fun(set(E),set(D)),fun(fun(F8,set(E)),fun(F8,set(D))),comp(set(E),set(D),F8),image2(E,D,F)),aa(fun(F8,C),fun(F8,set(E)),aa(fun(C,set(E)),fun(fun(F8,C),fun(F8,set(E))),comp(C,set(E),F8),S4),G)) ) ) ) ).

% type_copy_set_map0
tff(fact_507_snd__comp__apfst,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,C)] : ( aa(fun(product_prod(A,B),product_prod(C,B)),fun(product_prod(A,B),B),aa(fun(product_prod(C,B),B),fun(fun(product_prod(A,B),product_prod(C,B)),fun(product_prod(A,B),B)),comp(product_prod(C,B),B,product_prod(A,B)),product_snd(C,B)),product_apfst(A,C,B,F)) = product_snd(A,B) ) ).

% snd_comp_apfst
tff(fact_508_Id__on__empty,axiom,
    ! [A: $tType] : ( id_on(A,bot_bot(set(A))) = bot_bot(set(product_prod(A,A))) ) ).

% Id_on_empty
tff(fact_509_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,one_one(A)) = one_one(A) ) ) ).

% dbl_dec_simps(3)
tff(fact_510_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) )
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),uminus_uminus(set(A)),B3))) ) ).

% disjoint_eq_subset_Compl
tff(fact_511_snd__convol,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,C),G: fun(A,B)] : ( aa(fun(A,product_prod(C,B)),fun(A,B),aa(fun(product_prod(C,B),B),fun(fun(A,product_prod(C,B)),fun(A,B)),comp(product_prod(C,B),B,A),product_snd(C,B)),bNF_convol(A,C,B,F,G)) = G ) ).

% snd_convol
tff(fact_512_abstract__boolean__algebra_Oaxioms_I3_J,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => boolea6902313364301356556axioms(A,Conj,Disj,Compl,Zero,One) ) ).

% abstract_boolean_algebra.axioms(3)
tff(fact_513_minus__assn__def,axiom,
    ! [A3: assn,B2: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),minus_minus(assn),A3),B2) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A3),aa(assn,assn,uminus_uminus(assn),B2)) ) ).

% minus_assn_def
tff(fact_514_order__refl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),X)) ) ).

% order_refl
tff(fact_515_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),A3)) ) ).

% dual_order.refl
tff(fact_516_minus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( minus(B)
     => ! [A4: fun(A,B),B3: fun(A,B),X: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),minus_minus(fun(A,B)),A4),B3),X) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A4,X)),aa(A,B,B3,X)) ) ) ).

% minus_apply
tff(fact_517_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% neg_le_iff_le
tff(fact_518_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,uminus_uminus(A),Y)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X)) ) ) ).

% compl_le_compl_iff
tff(fact_519_le__inf__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Z2)) ) ) ) ).

% le_inf_iff
tff(fact_520_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% inf.bounded_iff
tff(fact_521_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3)) ) ) ) ).

% sup.bounded_iff
tff(fact_522_le__sup__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)),Z2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Z2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ) ).

% le_sup_iff
tff(fact_523_image__empty,axiom,
    ! [B: $tType,A: $tType,F: fun(B,A)] : ( aa(set(B),set(A),image2(B,A,F),bot_bot(set(B))) = bot_bot(set(A)) ) ).

% image_empty
tff(fact_524_empty__is__image,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),A4: set(B)] :
      ( ( bot_bot(set(A)) = aa(set(B),set(A),image2(B,A,F),A4) )
    <=> ( A4 = bot_bot(set(B)) ) ) ).

% empty_is_image
tff(fact_525_image__is__empty,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),A4: set(B)] :
      ( ( aa(set(B),set(A),image2(B,A,F),A4) = bot_bot(set(A)) )
    <=> ( A4 = bot_bot(set(B)) ) ) ).

% image_is_empty
tff(fact_526_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3) ) ) ).

% minus_diff_eq
tff(fact_527_subset__empty,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),bot_bot(set(A))))
    <=> ( A4 = bot_bot(set(A)) ) ) ).

% subset_empty
tff(fact_528_empty__subsetI,axiom,
    ! [A: $tType,A4: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),bot_bot(set(A))),A4)) ).

% empty_subsetI
tff(fact_529_img__snd,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,S2: set(product_prod(A,B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),S2))
     => pp(member(B,B2,aa(set(product_prod(A,B)),set(B),image2(product_prod(A,B),B,product_snd(A,B)),S2))) ) ).

% img_snd
tff(fact_530_Int__subset__iff,axiom,
    ! [A: $tType,C3: set(A),A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),A4))
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),B3)) ) ) ).

% Int_subset_iff
tff(fact_531_map__prod__imageI,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,A3: A,B2: B,R: set(product_prod(A,B)),F: fun(A,C),G: fun(B,D)] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),R))
     => pp(member(product_prod(C,D),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(A,C,F,A3)),aa(B,D,G,B2)),aa(set(product_prod(A,B)),set(product_prod(C,D)),image2(product_prod(A,B),product_prod(C,D),product_map_prod(A,C,B,D,F,G)),R))) ) ).

% map_prod_imageI
tff(fact_532_map__prod__simp,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: fun(C,A),G: fun(D,B),A3: C,B2: D] : ( aa(product_prod(C,D),product_prod(A,B),product_map_prod(C,A,D,B,F,G),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),A3),B2)) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,F,A3)),aa(D,B,G,B2)) ) ).

% map_prod_simp
tff(fact_533_apfst__conv,axiom,
    ! [C: $tType,A: $tType,B: $tType,F: fun(C,A),X: C,Y: B] : ( aa(product_prod(C,B),product_prod(A,B),product_apfst(C,A,B,F),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X),Y)) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,F,X)),Y) ) ).

% apfst_conv
tff(fact_534_Id__onI,axiom,
    ! [A: $tType,A3: A,A4: set(A)] :
      ( pp(member(A,A3,A4))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),A3),id_on(A,A4))) ) ).

% Id_onI
tff(fact_535_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( ( A3 = B2 )
          <=> ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
tff(fact_536_diff__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,D2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2))) ) ) ) ).

% diff_mono
tff(fact_537_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))) ) ) ).

% diff_left_mono
tff(fact_538_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2))) ) ) ).

% diff_right_mono
tff(fact_539_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2)) ) ) ) ).

% diff_eq_diff_less_eq
tff(fact_540_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A3: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) ) ) ).

% cancel_ab_semigroup_add_class.diff_right_commute
tff(fact_541_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( minus(B)
     => ! [A4: fun(A,B),B3: fun(A,B),X3: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),minus_minus(fun(A,B)),A4),B3),X3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A4,X3)),aa(A,B,B3,X3)) ) ) ).

% fun_diff_def
tff(fact_542_nle__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & ( B2 != A3 ) ) ) ) ).

% nle_le
tff(fact_543_le__cases3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A,Z2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) )
         => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Z2)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Z2))
               => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),Y)) )
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),Y))
                 => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X)) )
               => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2))
                   => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),X)) )
                 => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),X))
                     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y)) ) ) ) ) ) ) ) ).

% le_cases3
tff(fact_544_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( ( X = Y )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X)) ) ) ) ).

% order_class.order_eq_iff
tff(fact_545_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = B2 )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% ord_eq_le_trans
tff(fact_546_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( ( B2 = C2 )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% ord_le_eq_trans
tff(fact_547_order__antisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X))
           => ( X = Y ) ) ) ) ).

% order_antisym
tff(fact_548_order_Otrans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% order.trans
tff(fact_549_order__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Z2)) ) ) ) ).

% order_trans
tff(fact_550_linorder__wlog,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,fun(A,bool)),A3: A,B2: A] :
          ( ! [A8: A,B5: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A8),B5))
             => pp(aa(A,bool,aa(A,fun(A,bool),P,A8),B5)) )
         => ( ! [A8: A,B5: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),P,B5),A8))
               => pp(aa(A,bool,aa(A,fun(A,bool),P,A8),B5)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),P,A3),B2)) ) ) ) ).

% linorder_wlog
tff(fact_551_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% dual_order.eq_iff
tff(fact_552_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( A3 = B2 ) ) ) ) ).

% dual_order.antisym
tff(fact_553_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3)) ) ) ) ).

% dual_order.trans
tff(fact_554_antisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
           => ( A3 = B2 ) ) ) ) ).

% antisym
tff(fact_555_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F: fun(A,B),G: fun(A,B),X: A] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F),G))
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,X)),aa(A,B,G,X))) ) ) ).

% le_funD
tff(fact_556_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F: fun(A,B),G: fun(A,B),X: A] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F),G))
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,X)),aa(A,B,G,X))) ) ) ).

% le_funE
tff(fact_557_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F: fun(A,B),G: fun(A,B)] :
          ( ! [X2: A] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,X2)),aa(A,B,G,X2)))
         => pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F),G)) ) ) ).

% le_funI
tff(fact_558_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F: fun(A,B),G: fun(A,B)] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F),G))
        <=> ! [X4: A] : pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,X4)),aa(A,B,G,X4))) ) ) ).

% le_fun_def
tff(fact_559_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% Orderings.order_eq_iff
tff(fact_560_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A3: A,F: fun(B,A),B2: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(B,A,F,B2)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,X2)),aa(B,A,F,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(B,A,F,C2))) ) ) ) ) ).

% order_subst1
tff(fact_561_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A3: A,B2: A,F: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F,B2)),C2))
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F,X2)),aa(A,C,F,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F,A3)),C2)) ) ) ) ) ).

% order_subst2
tff(fact_562_order__eq__refl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y)) ) ) ).

% order_eq_refl
tff(fact_563_linorder__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
          | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X)) ) ) ).

% linorder_linear
tff(fact_564_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A3: A,F: fun(B,A),B2: B,C2: B] :
          ( ( A3 = aa(B,A,F,B2) )
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,X2)),aa(B,A,F,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(B,A,F,C2))) ) ) ) ) ).

% ord_eq_le_subst
tff(fact_565_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A3: A,B2: A,F: fun(A,B),C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( ( aa(A,B,F,B2) = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,X2)),aa(A,B,F,Y2))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,A3)),C2)) ) ) ) ) ).

% ord_le_eq_subst
tff(fact_566_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X)) ) ) ).

% linorder_le_cases
tff(fact_567_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
          <=> ( X = Y ) ) ) ) ).

% order_antisym_conv
tff(fact_568_prod__fun__imageE,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,C2: product_prod(A,B),F: fun(C,A),G: fun(D,B),R: set(product_prod(C,D))] :
      ( pp(member(product_prod(A,B),C2,aa(set(product_prod(C,D)),set(product_prod(A,B)),image2(product_prod(C,D),product_prod(A,B),product_map_prod(C,A,D,B,F,G)),R)))
     => ~ ! [X2: C,Y2: D] :
            ( ( C2 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,F,X2)),aa(D,B,G,Y2)) )
           => ~ pp(member(product_prod(C,D),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),X2),Y2),R)) ) ) ).

% prod_fun_imageE
tff(fact_569_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y) = bot_bot(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y)) ) ) ).

% diff_shunt_var
tff(fact_570_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),A4: set(B),B3: set(B)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image2(B,A,F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),image2(B,A,F),A4)),aa(set(B),set(A),image2(B,A,F),B3)))) ).

% image_Int_subset
tff(fact_571_map__prod__o__convol,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,A: $tType,H12: fun(D,B),H23: fun(E,C),F: fun(A,D),G: fun(A,E)] : ( aa(fun(A,product_prod(D,E)),fun(A,product_prod(B,C)),aa(fun(product_prod(D,E),product_prod(B,C)),fun(fun(A,product_prod(D,E)),fun(A,product_prod(B,C))),comp(product_prod(D,E),product_prod(B,C),A),product_map_prod(D,B,E,C,H12,H23)),bNF_convol(A,D,E,F,G)) = bNF_convol(A,B,C,aa(fun(A,D),fun(A,B),aa(fun(D,B),fun(fun(A,D),fun(A,B)),comp(D,B,A),H12),F),aa(fun(A,E),fun(A,C),aa(fun(E,C),fun(fun(A,E),fun(A,C)),comp(E,C,A),H23),G)) ) ).

% map_prod_o_convol
tff(fact_572_abstract__boolean__algebra__axioms__def,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea6902313364301356556axioms(A,Conj,Disj,Compl,Zero,One)
    <=> ( ! [X4: A,Y3: A,Z4: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X4),aa(A,A,aa(A,fun(A,A),Disj,Y3),Z4)) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X4),Y3)),aa(A,A,aa(A,fun(A,A),Conj,X4),Z4)) )
        & ! [X4: A,Y3: A,Z4: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X4),aa(A,A,aa(A,fun(A,A),Conj,Y3),Z4)) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,X4),Y3)),aa(A,A,aa(A,fun(A,A),Disj,X4),Z4)) )
        & ! [X4: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X4),One) = X4 )
        & ! [X4: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X4),Zero) = X4 )
        & ! [X4: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X4),aa(A,A,Compl,X4)) = Zero )
        & ! [X4: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X4),aa(A,A,Compl,X4)) = One ) ) ) ).

% abstract_boolean_algebra_axioms_def
tff(fact_573_abstract__boolean__algebra__axioms_Ointro,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),One: A,Zero: A,Compl: fun(A,A)] :
      ( ! [X2: A,Y2: A,Z3: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X2),aa(A,A,aa(A,fun(A,A),Disj,Y2),Z3)) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X2),Y2)),aa(A,A,aa(A,fun(A,A),Conj,X2),Z3)) )
     => ( ! [X2: A,Y2: A,Z3: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X2),aa(A,A,aa(A,fun(A,A),Conj,Y2),Z3)) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,X2),Y2)),aa(A,A,aa(A,fun(A,A),Disj,X2),Z3)) )
       => ( ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X2),One) = X2 )
         => ( ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X2),Zero) = X2 )
           => ( ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),Conj,X2),aa(A,A,Compl,X2)) = Zero )
             => ( ! [X2: A] : ( aa(A,A,aa(A,fun(A,A),Disj,X2),aa(A,A,Compl,X2)) = One )
               => boolea6902313364301356556axioms(A,Conj,Disj,Compl,Zero,One) ) ) ) ) ) ) ).

% abstract_boolean_algebra_axioms.intro
tff(fact_574_snd__image__mp,axiom,
    ! [B: $tType,A: $tType,A4: set(product_prod(B,A)),B3: set(A),X: B,Y: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(product_prod(B,A)),set(A),image2(product_prod(B,A),A,product_snd(B,A)),A4)),B3))
     => ( pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X),Y),A4))
       => pp(member(A,Y,B3)) ) ) ).

% snd_image_mp
tff(fact_575_image__eq__imp__comp,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: fun(B,A),A4: set(B),G: fun(C,A),B3: set(C),H2: fun(A,D)] :
      ( ( aa(set(B),set(A),image2(B,A,F),A4) = aa(set(C),set(A),image2(C,A,G),B3) )
     => ( aa(set(B),set(D),image2(B,D,aa(fun(B,A),fun(B,D),aa(fun(A,D),fun(fun(B,A),fun(B,D)),comp(A,D,B),H2),F)),A4) = aa(set(C),set(D),image2(C,D,aa(fun(C,A),fun(C,D),aa(fun(A,D),fun(fun(C,A),fun(C,D)),comp(A,D,C),H2),G)),B3) ) ) ).

% image_eq_imp_comp
tff(fact_576_image__comp,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(B,A),G: fun(C,B),R3: set(C)] : ( aa(set(B),set(A),image2(B,A,F),aa(set(C),set(B),image2(C,B,G),R3)) = aa(set(C),set(A),image2(C,A,aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),F),G)),R3) ) ).

% image_comp
tff(fact_577_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ).

% right_diff_distrib'
tff(fact_578_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [B2: A,C2: A,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)) ) ) ).

% left_diff_distrib'
tff(fact_579_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ).

% right_diff_distrib
tff(fact_580_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% left_diff_distrib
tff(fact_581_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B2: A,A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),B2)),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A3)),B2) ) ) ).

% minus_diff_commute
tff(fact_582_map__prod__compose,axiom,
    ! [D: $tType,C: $tType,A: $tType,E: $tType,F8: $tType,B: $tType,F1: fun(E,C),F22: fun(A,E),G1: fun(F8,D),G22: fun(B,F8)] : ( product_map_prod(A,C,B,D,aa(fun(A,E),fun(A,C),aa(fun(E,C),fun(fun(A,E),fun(A,C)),comp(E,C,A),F1),F22),aa(fun(B,F8),fun(B,D),aa(fun(F8,D),fun(fun(B,F8),fun(B,D)),comp(F8,D,B),G1),G22)) = aa(fun(product_prod(A,B),product_prod(E,F8)),fun(product_prod(A,B),product_prod(C,D)),aa(fun(product_prod(E,F8),product_prod(C,D)),fun(fun(product_prod(A,B),product_prod(E,F8)),fun(product_prod(A,B),product_prod(C,D))),comp(product_prod(E,F8),product_prod(C,D),product_prod(A,B)),product_map_prod(E,C,F8,D,F1,G1)),product_map_prod(A,E,B,F8,F22,G22)) ) ).

% map_prod_compose
tff(fact_583_map__prod_Ocompositionality,axiom,
    ! [D: $tType,F8: $tType,E: $tType,C: $tType,B: $tType,A: $tType,F: fun(C,E),G: fun(D,F8),H2: fun(A,C),I: fun(B,D),Prod: product_prod(A,B)] : ( aa(product_prod(C,D),product_prod(E,F8),product_map_prod(C,E,D,F8,F,G),aa(product_prod(A,B),product_prod(C,D),product_map_prod(A,C,B,D,H2,I),Prod)) = aa(product_prod(A,B),product_prod(E,F8),product_map_prod(A,E,B,F8,aa(fun(A,C),fun(A,E),aa(fun(C,E),fun(fun(A,C),fun(A,E)),comp(C,E,A),F),H2),aa(fun(B,D),fun(B,F8),aa(fun(D,F8),fun(fun(B,D),fun(B,F8)),comp(D,F8,B),G),I)),Prod) ) ).

% map_prod.compositionality
tff(fact_584_map__prod_Ocomp,axiom,
    ! [A: $tType,C: $tType,E: $tType,F8: $tType,D: $tType,B: $tType,F: fun(C,E),G: fun(D,F8),H2: fun(A,C),I: fun(B,D)] : ( aa(fun(product_prod(A,B),product_prod(C,D)),fun(product_prod(A,B),product_prod(E,F8)),aa(fun(product_prod(C,D),product_prod(E,F8)),fun(fun(product_prod(A,B),product_prod(C,D)),fun(product_prod(A,B),product_prod(E,F8))),comp(product_prod(C,D),product_prod(E,F8),product_prod(A,B)),product_map_prod(C,E,D,F8,F,G)),product_map_prod(A,C,B,D,H2,I)) = product_map_prod(A,E,B,F8,aa(fun(A,C),fun(A,E),aa(fun(C,E),fun(fun(A,C),fun(A,E)),comp(C,E,A),F),H2),aa(fun(B,D),fun(B,F8),aa(fun(D,F8),fun(fun(B,D),fun(B,F8)),comp(D,F8,B),G),I)) ) ).

% map_prod.comp
tff(fact_585_prod_Omap__comp,axiom,
    ! [D: $tType,F8: $tType,E: $tType,C: $tType,B: $tType,A: $tType,G1: fun(C,E),G22: fun(D,F8),F1: fun(A,C),F22: fun(B,D),V: product_prod(A,B)] : ( aa(product_prod(C,D),product_prod(E,F8),product_map_prod(C,E,D,F8,G1,G22),aa(product_prod(A,B),product_prod(C,D),product_map_prod(A,C,B,D,F1,F22),V)) = aa(product_prod(A,B),product_prod(E,F8),product_map_prod(A,E,B,F8,aa(fun(A,C),fun(A,E),aa(fun(C,E),fun(fun(A,C),fun(A,E)),comp(C,E,A),G1),F1),aa(fun(B,D),fun(B,F8),aa(fun(D,F8),fun(fun(B,D),fun(B,F8)),comp(D,F8,B),G22),F22)),V) ) ).

% prod.map_comp
tff(fact_586_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),one_one(A))) ) ).

% le_numeral_extra(4)
tff(fact_587_subrelI,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B)),S: set(product_prod(A,B))] :
      ( ! [X2: A,Y2: B] :
          ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2),R3))
         => pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2),S)) )
     => pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),R3),S)) ) ).

% subrelI
tff(fact_588_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),bot_bot(A)))
         => ( A3 = bot_bot(A) ) ) ) ).

% bot.extremum_uniqueI
tff(fact_589_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),bot_bot(A)))
        <=> ( A3 = bot_bot(A) ) ) ) ).

% bot.extremum_unique
tff(fact_590_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),bot_bot(A)),A3)) ) ).

% bot.extremum
tff(fact_591_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,uminus_uminus(A),A3))) ) ) ).

% le_minus_iff
tff(fact_592_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),A3)) ) ) ).

% minus_le_iff
tff(fact_593_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A3))) ) ) ).

% le_imp_neg_le
tff(fact_594_compl__mono,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),Y)),aa(A,A,uminus_uminus(A),X))) ) ) ).

% compl_mono
tff(fact_595_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),aa(A,A,uminus_uminus(A),X)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,uminus_uminus(A),Y))) ) ) ).

% compl_le_swap1
tff(fact_596_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),Y)),X))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),X)),Y)) ) ) ).

% compl_le_swap2
tff(fact_597_subset__emptyI,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ! [X2: A] : ~ pp(member(A,X2,A4))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),bot_bot(set(A)))) ) ).

% subset_emptyI
tff(fact_598_top__greatest,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),top_top(A))) ) ).

% top_greatest
tff(fact_599_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),top_top(A)),A3))
        <=> ( A3 = top_top(A) ) ) ) ).

% top.extremum_unique
tff(fact_600_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),top_top(A)),A3))
         => ( A3 = top_top(A) ) ) ) ).

% top.extremum_uniqueI
tff(fact_601_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),Y)) ) ).

% inf_sup_ord(2)
tff(fact_602_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),X)) ) ).

% inf_sup_ord(1)
tff(fact_603_inf__le1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),X)) ) ).

% inf_le1
tff(fact_604_inf__le2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),Y)) ) ).

% inf_le2
tff(fact_605_le__infE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),A3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),B2)) ) ) ) ).

% le_infE
tff(fact_606_le__infI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2))) ) ) ) ).

% le_infI
tff(fact_607_inf__mono,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),aa(A,A,aa(A,fun(A,A),inf_inf(A),C2),D2))) ) ) ) ).

% inf_mono
tff(fact_608_le__infI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,X: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),X)) ) ) ).

% le_infI1
tff(fact_609_le__infI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,X: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),X))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),X)) ) ) ).

% le_infI2
tff(fact_610_inf_OorderE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( A3 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) ) ) ) ).

% inf.orderE
tff(fact_611_inf_OorderI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% inf.orderI
tff(fact_612_inf__unique,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [F: fun(A,fun(A,A)),X: A,Y: A] :
          ( ! [X2: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F,X2),Y2)),X2))
         => ( ! [X2: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F,X2),Y2)),Y2))
           => ( ! [X2: A,Y2: A,Z3: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),F,Y2),Z3))) ) )
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) = aa(A,A,aa(A,fun(A,A),F,X),Y) ) ) ) ) ) ).

% inf_unique
tff(fact_613_le__iff__inf,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) = X ) ) ) ).

% le_iff_inf
tff(fact_614_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = A3 ) ) ) ).

% inf.absorb1
tff(fact_615_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = B2 ) ) ) ).

% inf.absorb2
tff(fact_616_inf__absorb1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) = X ) ) ) ).

% inf_absorb1
tff(fact_617_inf__absorb2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Y: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) = Y ) ) ) ).

% inf_absorb2
tff(fact_618_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% inf.boundedE
tff(fact_619_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2))) ) ) ) ).

% inf.boundedI
tff(fact_620_inf__greatest,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2))) ) ) ) ).

% inf_greatest
tff(fact_621_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( A3 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) ) ) ) ).

% inf.order_iff
tff(fact_622_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),A3)) ) ).

% inf.cobounded1
tff(fact_623_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),B2)) ) ).

% inf.cobounded2
tff(fact_624_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = A3 ) ) ) ).

% inf.absorb_iff1
tff(fact_625_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = B2 ) ) ) ).

% inf.absorb_iff2
tff(fact_626_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),C2)) ) ) ).

% inf.coboundedI1
tff(fact_627_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),C2)) ) ) ).

% inf.coboundedI2
tff(fact_628_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% sup.coboundedI2
tff(fact_629_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% sup.coboundedI1
tff(fact_630_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = B2 ) ) ) ).

% sup.absorb_iff2
tff(fact_631_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = A3 ) ) ) ).

% sup.absorb_iff1
tff(fact_632_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ).

% sup.cobounded2
tff(fact_633_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ).

% sup.cobounded1
tff(fact_634_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( A3 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) ) ) ) ).

% sup.order_iff
tff(fact_635_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A3)) ) ) ) ).

% sup.boundedI
tff(fact_636_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A3))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3)) ) ) ) ).

% sup.boundedE
tff(fact_637_sup__absorb2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) = Y ) ) ) ).

% sup_absorb2
tff(fact_638_sup__absorb1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) = X ) ) ) ).

% sup_absorb1
tff(fact_639_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = B2 ) ) ) ).

% sup.absorb2
tff(fact_640_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = A3 ) ) ) ).

% sup.absorb1
tff(fact_641_sup__unique,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [F: fun(A,fun(A,A)),X: A,Y: A] :
          ( ! [X2: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),aa(A,A,aa(A,fun(A,A),F,X2),Y2)))
         => ( ! [X2: A,Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),aa(A,A,aa(A,fun(A,A),F,X2),Y2)))
           => ( ! [X2: A,Y2: A,Z3: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X2))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z3),X2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F,Y2),Z3)),X2)) ) )
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) = aa(A,A,aa(A,fun(A,A),F,X),Y) ) ) ) ) ) ).

% sup_unique
tff(fact_642_sup_OorderI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% sup.orderI
tff(fact_643_sup_OorderE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( A3 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) ) ) ) ).

% sup.orderE
tff(fact_644_le__iff__sup,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) = Y ) ) ) ).

% le_iff_sup
tff(fact_645_sup__least,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y: A,X: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),X))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)),X)) ) ) ) ).

% sup_least
tff(fact_646_sup__mono,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),C2),D2))) ) ) ) ).

% sup_mono
tff(fact_647_sup_Omono,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A3: A,D2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),C2),D2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ) ).

% sup.mono
tff(fact_648_le__supI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% le_supI2
tff(fact_649_le__supI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% le_supI1
tff(fact_650_sup__ge2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y: A,X: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y))) ) ).

% sup_ge2
tff(fact_651_sup__ge1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y))) ) ).

% sup_ge1
tff(fact_652_le__supI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,X: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),X))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)),X)) ) ) ) ).

% le_supI
tff(fact_653_le__supE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2)),X))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),X)) ) ) ) ).

% le_supE
tff(fact_654_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y))) ) ).

% inf_sup_ord(3)
tff(fact_655_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [Y: A,X: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y))) ) ).

% inf_sup_ord(4)
tff(fact_656_inter__eq__subsetI,axiom,
    ! [A: $tType,S2: set(A),S4: set(A),A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),S2),S4))
     => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),S4) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),S4) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),S2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),S2) ) ) ) ).

% inter_eq_subsetI
tff(fact_657_Int__Collect__mono,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),P: fun(A,bool),Q: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
     => ( ! [X2: A] :
            ( pp(member(A,X2,A4))
           => ( pp(aa(A,bool,P,X2))
             => pp(aa(A,bool,Q,X2)) ) )
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(fun(A,bool),set(A),collect(A),P))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),aa(fun(A,bool),set(A),collect(A),Q)))) ) ) ).

% Int_Collect_mono
tff(fact_658_Int__greatest,axiom,
    ! [A: $tType,C3: set(A),A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),A4))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),B3))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3))) ) ) ).

% Int_greatest
tff(fact_659_Int__absorb2,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = A4 ) ) ).

% Int_absorb2
tff(fact_660_Int__absorb1,axiom,
    ! [A: $tType,B3: set(A),A4: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A4))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = B3 ) ) ).

% Int_absorb1
tff(fact_661_Int__lower2,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)),B3)) ).

% Int_lower2
tff(fact_662_Int__lower1,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)),A4)) ).

% Int_lower1
tff(fact_663_Int__mono,axiom,
    ! [A: $tType,A4: set(A),C3: set(A),B3: set(A),D4: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),C3))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),D4))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),D4))) ) ) ).

% Int_mono
tff(fact_664_less__by__empty,axiom,
    ! [A: $tType,A4: set(product_prod(A,A)),B3: set(product_prod(A,A))] :
      ( ( A4 = bot_bot(set(product_prod(A,A))) )
     => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),A4),B3)) ) ).

% less_by_empty
tff(fact_665_relH__subset,axiom,
    ! [Bs: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit),As: set(nat)] :
      ( relH(Bs,H2,H4)
     => ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),As),Bs))
       => relH(As,H2,H4) ) ) ).

% relH_subset
tff(fact_666_apfst__compose,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: fun(C,A),G: fun(D,C),X: product_prod(D,B)] : ( aa(product_prod(C,B),product_prod(A,B),product_apfst(C,A,B,F),aa(product_prod(D,B),product_prod(C,B),product_apfst(D,C,B,G),X)) = aa(product_prod(D,B),product_prod(A,B),product_apfst(D,A,B,aa(fun(D,C),fun(D,A),aa(fun(C,A),fun(fun(D,C),fun(D,A)),comp(C,A,D),F),G)),X) ) ).

% apfst_compose
tff(fact_667_Id__on__iff,axiom,
    ! [A: $tType,X: A,Y: A,A4: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),id_on(A,A4)))
    <=> ( ( X = Y )
        & pp(member(A,X,A4)) ) ) ).

% Id_on_iff
tff(fact_668_Id__on__eqI,axiom,
    ! [A: $tType,A3: A,B2: A,A4: set(A)] :
      ( ( A3 = B2 )
     => ( pp(member(A,A3,A4))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),id_on(A,A4))) ) ) ).

% Id_on_eqI
tff(fact_669_Id__onE,axiom,
    ! [A: $tType,C2: product_prod(A,A),A4: set(A)] :
      ( pp(member(product_prod(A,A),C2,id_on(A,A4)))
     => ~ ! [X2: A] :
            ( pp(member(A,X2,A4))
           => ( C2 != aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2) ) ) ) ).

% Id_onE
tff(fact_670_convol__def,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(A,B),G: fun(A,C),X3: A] : ( aa(A,product_prod(B,C),bNF_convol(A,B,C,F,G),X3) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(A,B,F,X3)),aa(A,C,G,X3)) ) ).

% convol_def
tff(fact_671_convol__o,axiom,
    ! [B: $tType,C: $tType,D: $tType,A: $tType,F: fun(D,B),G: fun(D,C),H2: fun(A,D)] : ( aa(fun(A,D),fun(A,product_prod(B,C)),aa(fun(D,product_prod(B,C)),fun(fun(A,D),fun(A,product_prod(B,C))),comp(D,product_prod(B,C),A),bNF_convol(D,B,C,F,G)),H2) = bNF_convol(A,B,C,aa(fun(A,D),fun(A,B),aa(fun(D,B),fun(fun(A,D),fun(A,B)),comp(D,B,A),F),H2),aa(fun(A,D),fun(A,C),aa(fun(D,C),fun(fun(A,D),fun(A,C)),comp(D,C,A),G),H2)) ) ).

% convol_o
tff(fact_672_in__snd__imageE,axiom,
    ! [A: $tType,B: $tType,Y: A,S2: set(product_prod(B,A))] :
      ( pp(member(A,Y,aa(set(product_prod(B,A)),set(A),image2(product_prod(B,A),A,product_snd(B,A)),S2)))
     => ~ ! [X2: B] : ~ pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X2),Y),S2)) ) ).

% in_snd_imageE
tff(fact_673_surj__fun__eq,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(B,A),X6: set(B),G1: fun(A,C),G22: fun(A,C)] :
      ( ( aa(set(B),set(A),image2(B,A,F),X6) = top_top(set(A)) )
     => ( ! [X2: B] :
            ( pp(member(B,X2,X6))
           => ( aa(B,C,aa(fun(B,A),fun(B,C),aa(fun(A,C),fun(fun(B,A),fun(B,C)),comp(A,C,B),G1),F),X2) = aa(B,C,aa(fun(B,A),fun(B,C),aa(fun(A,C),fun(fun(B,A),fun(B,C)),comp(A,C,B),G22),F),X2) ) )
       => ( G1 = G22 ) ) ) ).

% surj_fun_eq
tff(fact_674_comp__surj,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(B,A),G: fun(A,C)] :
      ( ( aa(set(B),set(A),image2(B,A,F),top_top(set(B))) = top_top(set(A)) )
     => ( ( aa(set(A),set(C),image2(A,C,G),top_top(set(A))) = top_top(set(C)) )
       => ( aa(set(B),set(C),image2(B,C,aa(fun(B,A),fun(B,C),aa(fun(A,C),fun(fun(B,A),fun(B,C)),comp(A,C,B),G),F)),top_top(set(B))) = top_top(set(C)) ) ) ) ).

% comp_surj
tff(fact_675_fun_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,D: $tType,X: fun(D,A),Xa: fun(D,A),F: fun(A,B),Fa: fun(A,B)] :
      ( ! [Z3: A,Za: A] :
          ( pp(member(A,Z3,aa(set(D),set(A),image2(D,A,X),top_top(set(D)))))
         => ( pp(member(A,Za,aa(set(D),set(A),image2(D,A,Xa),top_top(set(D)))))
           => ( ( aa(A,B,F,Z3) = aa(A,B,Fa,Za) )
             => ( Z3 = Za ) ) ) )
     => ( ( aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),F),X) = aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),Fa),Xa) )
       => ( X = Xa ) ) ) ).

% fun.inj_map_strong
tff(fact_676_fun_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,D: $tType,X: fun(D,A),F: fun(A,B),G: fun(A,B)] :
      ( ! [Z3: A] :
          ( pp(member(A,Z3,aa(set(D),set(A),image2(D,A,X),top_top(set(D)))))
         => ( aa(A,B,F,Z3) = aa(A,B,G,Z3) ) )
     => ( aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),F),X) = aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),G),X) ) ) ).

% fun.map_cong0
tff(fact_677_fun_Omap__cong,axiom,
    ! [B: $tType,A: $tType,D: $tType,X: fun(D,A),Ya: fun(D,A),F: fun(A,B),G: fun(A,B)] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( pp(member(A,Z3,aa(set(D),set(A),image2(D,A,Ya),top_top(set(D)))))
           => ( aa(A,B,F,Z3) = aa(A,B,G,Z3) ) )
       => ( aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),F),X) = aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),G),Ya) ) ) ) ).

% fun.map_cong
tff(fact_678_fun_Oset__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,F: fun(A,B),V: fun(D,A)] : ( aa(set(D),set(B),image2(D,B,aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),F),V)),top_top(set(D))) = aa(set(A),set(B),image2(A,B,F),aa(set(D),set(A),image2(D,A,V),top_top(set(D)))) ) ).

% fun.set_map
tff(fact_679_diff__eq,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% diff_eq
tff(fact_680_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% le_minus_one_simps(4)
tff(fact_681_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A))) ) ).

% le_minus_one_simps(2)
tff(fact_682_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A,Z2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Z2))),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2)))) ) ).

% distrib_inf_le
tff(fact_683_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [X: A,Y: A,Z2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z2))),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Z2)))) ) ).

% distrib_sup_le
tff(fact_684_disjoint__mono,axiom,
    ! [A: $tType,A3: set(A),A5: set(A),B2: set(A),B4: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A3),A5))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B2),B4))
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A5),B4) = bot_bot(set(A)) )
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B2) = bot_bot(set(A)) ) ) ) ) ).

% disjoint_mono
tff(fact_685_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),C3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C3)) )
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),A4)) ) ).

% Un_Int_assoc_eq
tff(fact_686_subset__Compl__self__eq,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),uminus_uminus(set(A)),A4)))
    <=> ( A4 = bot_bot(set(A)) ) ) ).

% subset_Compl_self_eq
tff(fact_687_in__range__subset,axiom,
    ! [As: set(nat),As3: set(nat),H2: heap_ext(product_unit)] :
      ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),As),As3))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3)))
       => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))) ) ) ).

% in_range_subset
tff(fact_688_inf__shunt,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y) = bot_bot(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,uminus_uminus(A),Y))) ) ) ).

% inf_shunt
tff(fact_689_sup__shunt,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y) = top_top(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),X)),Y)) ) ) ).

% sup_shunt
tff(fact_690_shunt1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)),Z2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),Y)),Z2))) ) ) ).

% shunt1
tff(fact_691_shunt2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(A,A,uminus_uminus(A),Y))),Z2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z2))) ) ) ).

% shunt2
tff(fact_692_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [P3: A,Q3: A,R3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),P3),aa(A,A,aa(A,fun(A,A),sup_sup(A),Q3),R3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),P3),aa(A,A,uminus_uminus(A),Q3))),R3)) ) ) ).

% sup_neg_inf
tff(fact_693_apfst__convE,axiom,
    ! [C: $tType,A: $tType,B: $tType,Q3: product_prod(A,B),F: fun(C,A),P3: product_prod(C,B)] :
      ( ( Q3 = aa(product_prod(C,B),product_prod(A,B),product_apfst(C,A,B,F),P3) )
     => ~ ! [X2: C,Y2: B] :
            ( ( P3 = aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X2),Y2) )
           => ( Q3 != aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,F,X2)),Y2) ) ) ) ).

% apfst_convE
tff(fact_694_Sup_OSUP__image,axiom,
    ! [B: $tType,A: $tType,C: $tType,Sup: fun(set(A),A),G: fun(B,A),F: fun(C,B),A4: set(C)] : ( aa(set(A),A,Sup,aa(set(B),set(A),image2(B,A,G),aa(set(C),set(B),image2(C,B,F),A4))) = aa(set(A),A,Sup,aa(set(C),set(A),image2(C,A,aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),G),F)),A4)) ) ).

% Sup.SUP_image
tff(fact_695_Inf_OINF__image,axiom,
    ! [B: $tType,A: $tType,C: $tType,Inf: fun(set(A),A),G: fun(B,A),F: fun(C,B),A4: set(C)] : ( aa(set(A),A,Inf,aa(set(B),set(A),image2(B,A,G),aa(set(C),set(B),image2(C,B,F),A4))) = aa(set(A),A,Inf,aa(set(C),set(A),image2(C,A,aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),G),F)),A4)) ) ).

% Inf.INF_image
tff(fact_696_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,bool),D4: A,Q: fun(A,bool)] :
          ( ! [X2: A,K2: A] :
              ( pp(aa(A,bool,P,X2))
            <=> pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4)))) )
         => ( ! [X2: A,K2: A] :
                ( pp(aa(A,bool,Q,X2))
              <=> pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4)))) )
           => ! [X3: A,K3: A] :
                ( ( pp(aa(A,bool,P,X3))
                  & pp(aa(A,bool,Q,X3)) )
              <=> ( pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D4))))
                  & pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D4)))) ) ) ) ) ) ).

% inf_period(1)
tff(fact_697_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,bool),D4: A,Q: fun(A,bool)] :
          ( ! [X2: A,K2: A] :
              ( pp(aa(A,bool,P,X2))
            <=> pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4)))) )
         => ( ! [X2: A,K2: A] :
                ( pp(aa(A,bool,Q,X2))
              <=> pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),aa(A,A,aa(A,fun(A,A),times_times(A),K2),D4)))) )
           => ! [X3: A,K3: A] :
                ( ( pp(aa(A,bool,P,X3))
                  | pp(aa(A,bool,Q,X3)) )
              <=> ( pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D4))))
                  | pp(aa(A,bool,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D4)))) ) ) ) ) ) ).

% inf_period(2)
tff(fact_698_apsnd__apfst,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F: fun(C,B),G: fun(D,A),X: product_prod(D,C)] : ( aa(product_prod(A,C),product_prod(A,B),aa(fun(C,B),fun(product_prod(A,C),product_prod(A,B)),product_apsnd(C,B,A),F),aa(product_prod(D,C),product_prod(A,C),product_apfst(D,A,C,G),X)) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(D,A,G,aa(product_prod(D,C),D,product_fst(D,C),X))),aa(C,B,F,aa(product_prod(D,C),C,product_snd(D,C),X))) ) ).

% apsnd_apfst
tff(fact_699_apfst__apsnd,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,F: fun(C,A),G: fun(D,B),X: product_prod(C,D)] : ( aa(product_prod(C,B),product_prod(A,B),product_apfst(C,A,B,F),aa(product_prod(C,D),product_prod(C,B),aa(fun(D,B),fun(product_prod(C,D),product_prod(C,B)),product_apsnd(D,B,C),G),X)) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,F,aa(product_prod(C,D),C,product_fst(C,D),X))),aa(D,B,G,aa(product_prod(C,D),D,product_snd(C,D),X))) ) ).

% apfst_apsnd
tff(fact_700_the__elem__image__unique,axiom,
    ! [B: $tType,A: $tType,A4: set(A),F: fun(A,B),X: A] :
      ( ( A4 != bot_bot(set(A)) )
     => ( ! [Y2: A] :
            ( pp(member(A,Y2,A4))
           => ( aa(A,B,F,Y2) = aa(A,B,F,X) ) )
       => ( the_elem(B,aa(set(A),set(B),image2(A,B,F),A4)) = aa(A,B,F,X) ) ) ) ).

% the_elem_image_unique
tff(fact_701_mod__star__trueE_H,axiom,
    ! [P: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),top_top(assn))),H2))
     => ~ ! [H5: product_prod(heap_ext(product_unit),set(nat))] :
            ( ( aa(product_prod(heap_ext(product_unit),set(nat)),heap_ext(product_unit),product_fst(heap_ext(product_unit),set(nat)),H5) = aa(product_prod(heap_ext(product_unit),set(nat)),heap_ext(product_unit),product_fst(heap_ext(product_unit),set(nat)),H2) )
           => ( pp(aa(set(nat),bool,aa(set(nat),fun(set(nat),bool),ord_less_eq(set(nat)),aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H5)),aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2)))
             => ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),H5)) ) ) ) ).

% mod_star_trueE'
tff(fact_702_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_dec_simps(2)
tff(fact_703_Diff__cancel,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),A4) = bot_bot(set(A)) ) ).

% Diff_cancel
tff(fact_704_empty__Diff,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),bot_bot(set(A))),A4) = bot_bot(set(A)) ) ).

% empty_Diff
tff(fact_705_Diff__empty,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),bot_bot(set(A))) = A4 ) ).

% Diff_empty
tff(fact_706_le__zero__eq,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),N),zero_zero(A)))
        <=> ( N = zero_zero(A) ) ) ) ).

% le_zero_eq
tff(fact_707_mult__zero__left,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),zero_zero(A)),A3) = zero_zero(A) ) ) ).

% mult_zero_left
tff(fact_708_mult__zero__right,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),zero_zero(A)) = zero_zero(A) ) ) ).

% mult_zero_right
tff(fact_709_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = zero_zero(A) )
        <=> ( ( A3 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% mult_eq_0_iff
tff(fact_710_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A3 = B2 ) ) ) ) ).

% mult_cancel_left
tff(fact_711_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [A3: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A3 = B2 ) ) ) ) ).

% mult_cancel_right
tff(fact_712_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),A3) = zero_zero(A) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
tff(fact_713_diff__zero,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),zero_zero(A)) = A3 ) ) ).

% diff_zero
tff(fact_714_zero__diff,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A3) = zero_zero(A) ) ) ).

% zero_diff
tff(fact_715_diff__0__right,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),zero_zero(A)) = A3 ) ) ).

% diff_0_right
tff(fact_716_diff__self,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),A3) = zero_zero(A) ) ) ).

% diff_self
tff(fact_717_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( ( aa(A,A,uminus_uminus(A),A3) = A3 )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% neg_equal_zero
tff(fact_718_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( ( A3 = aa(A,A,uminus_uminus(A),A3) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% equal_neg_zero
tff(fact_719_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] :
          ( ( aa(A,A,uminus_uminus(A),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% neg_equal_0_iff_equal
tff(fact_720_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] :
          ( ( zero_zero(A) = aa(A,A,uminus_uminus(A),A3) )
        <=> ( zero_zero(A) = A3 ) ) ) ).

% neg_0_equal_iff_equal
tff(fact_721_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ( aa(A,A,uminus_uminus(A),zero_zero(A)) = zero_zero(A) ) ) ).

% add.inverse_neutral
tff(fact_722_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3) = bot_bot(set(A)) )
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3)) ) ).

% Diff_eq_empty_iff
tff(fact_723_Diff__UNIV,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),top_top(set(A))) = bot_bot(set(A)) ) ).

% Diff_UNIV
tff(fact_724_Diff__disjoint,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A4)) = bot_bot(set(A)) ) ).

% Diff_disjoint
tff(fact_725_Diff__Compl,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),uminus_uminus(set(A)),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) ) ).

% Diff_Compl
tff(fact_726_inter__compl__diff__conv,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),uminus_uminus(set(A)),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3) ) ).

% inter_compl_diff_conv
tff(fact_727_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% diff_ge_0_iff_ge
tff(fact_728_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% neg_less_eq_nonneg
tff(fact_729_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% less_eq_neg_nonpos
tff(fact_730_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% neg_le_0_iff_le
tff(fact_731_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% neg_0_le_iff_le
tff(fact_732_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B2: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B2 = one_one(A) ) ) ) ) ).

% mult_cancel_left1
tff(fact_733_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A3 = one_one(A) ) ) ) ) ).

% mult_cancel_left2
tff(fact_734_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B2: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B2 = one_one(A) ) ) ) ) ).

% mult_cancel_right1
tff(fact_735_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A3 = one_one(A) ) ) ) ) ).

% mult_cancel_right2
tff(fact_736_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),one_one(A)) = zero_zero(A) ) ) ).

% diff_numeral_special(9)
tff(fact_737_diff__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A3) = aa(A,A,uminus_uminus(A),A3) ) ) ).

% diff_0
tff(fact_738_prod_Ocollapse,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod(A,B)] : ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(product_prod(A,B),A,product_fst(A,B),Prod)),aa(product_prod(A,B),B,product_snd(A,B),Prod)) = Prod ) ).

% prod.collapse
tff(fact_739_img__fst,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,S2: set(product_prod(A,B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),S2))
     => pp(member(A,A3,aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),S2))) ) ).

% img_fst
tff(fact_740_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,zero_zero(A)) = one_one(A) ) ) ).

% dbl_inc_simps(2)
tff(fact_741_fst__comp__apsnd,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(B,C)] : ( aa(fun(product_prod(A,B),product_prod(A,C)),fun(product_prod(A,B),A),aa(fun(product_prod(A,C),A),fun(fun(product_prod(A,B),product_prod(A,C)),fun(product_prod(A,B),A)),comp(product_prod(A,C),A,product_prod(A,B)),product_fst(A,C)),aa(fun(B,C),fun(product_prod(A,B),product_prod(A,C)),product_apsnd(B,C,A),F)) = product_fst(A,B) ) ).

% fst_comp_apsnd
tff(fact_742_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% diff_numeral_special(12)
tff(fact_743_fst__comp__map__prod,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: fun(A,C),G: fun(B,D)] : ( aa(fun(product_prod(A,B),product_prod(C,D)),fun(product_prod(A,B),C),aa(fun(product_prod(C,D),C),fun(fun(product_prod(A,B),product_prod(C,D)),fun(product_prod(A,B),C)),comp(product_prod(C,D),C,product_prod(A,B)),product_fst(C,D)),product_map_prod(A,C,B,D,F,G)) = aa(fun(product_prod(A,B),A),fun(product_prod(A,B),C),aa(fun(A,C),fun(fun(product_prod(A,B),A),fun(product_prod(A,B),C)),comp(A,C,product_prod(A,B)),F),product_fst(A,B)) ) ).

% fst_comp_map_prod
tff(fact_744_fst__comp__apfst,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,C)] : ( aa(fun(product_prod(A,B),product_prod(C,B)),fun(product_prod(A,B),C),aa(fun(product_prod(C,B),C),fun(fun(product_prod(A,B),product_prod(C,B)),fun(product_prod(A,B),C)),comp(product_prod(C,B),C,product_prod(A,B)),product_fst(C,B)),product_apfst(A,C,B,F)) = aa(fun(product_prod(A,B),A),fun(product_prod(A,B),C),aa(fun(A,C),fun(fun(product_prod(A,B),A),fun(product_prod(A,B),C)),comp(A,C,product_prod(A,B)),F),product_fst(A,B)) ) ).

% fst_comp_apfst
tff(fact_745_zero__reorient,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [X: A] :
          ( ( zero_zero(A) = X )
        <=> ( X = zero_zero(A) ) ) ) ).

% zero_reorient
tff(fact_746_fst__eqD,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,A3: A] :
      ( ( aa(product_prod(A,B),A,product_fst(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)) = A3 )
     => ( X = A3 ) ) ).

% fst_eqD
tff(fact_747_fst__conv,axiom,
    ! [B: $tType,A: $tType,X1: A,X22: B] : ( aa(product_prod(A,B),A,product_fst(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X1),X22)) = X1 ) ).

% fst_conv
tff(fact_748_fstE,axiom,
    ! [B: $tType,A: $tType,X: product_prod(A,B),A3: A,B2: B,P: fun(A,bool)] :
      ( ( X = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2) )
     => ( pp(aa(A,bool,P,aa(product_prod(A,B),A,product_fst(A,B),X)))
       => pp(aa(A,bool,P,A3)) ) ) ).

% fstE
tff(fact_749_fstI,axiom,
    ! [B: $tType,A: $tType,X: product_prod(A,B),Y: A,Z2: B] :
      ( ( X = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Y),Z2) )
     => ( aa(product_prod(A,B),A,product_fst(A,B),X) = Y ) ) ).

% fstI
tff(fact_750_eq__fst__iff,axiom,
    ! [A: $tType,B: $tType,A3: A,P3: product_prod(A,B)] :
      ( ( A3 = aa(product_prod(A,B),A,product_fst(A,B),P3) )
    <=> ? [B6: B] : ( P3 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B6) ) ) ).

% eq_fst_iff
tff(fact_751_in__fst__imageE,axiom,
    ! [B: $tType,A: $tType,X: A,S2: set(product_prod(A,B))] :
      ( pp(member(A,X,aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),S2)))
     => ~ ! [Y2: B] : ~ pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y2),S2)) ) ).

% in_fst_imageE
tff(fact_752_Int__Diff,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),C3)) ) ).

% Int_Diff
tff(fact_753_Diff__Int2,axiom,
    ! [A: $tType,A4: set(A),C3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),C3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),C3)),B3) ) ).

% Diff_Int2
tff(fact_754_Diff__Diff__Int,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) ) ).

% Diff_Diff_Int
tff(fact_755_Diff__Int__distrib,axiom,
    ! [A: $tType,C3: set(A),A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),A4)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C3),B3)) ) ).

% Diff_Int_distrib
tff(fact_756_Diff__Int__distrib2,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),C3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3)) ) ).

% Diff_Int_distrib2
tff(fact_757_zero__le,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X)) ) ).

% zero_le
tff(fact_758_mult__not__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) != zero_zero(A) )
         => ( ( A3 != zero_zero(A) )
            & ( B2 != zero_zero(A) ) ) ) ) ).

% mult_not_zero
tff(fact_759_divisors__zero,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = zero_zero(A) )
         => ( ( A3 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divisors_zero
tff(fact_760_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) != zero_zero(A) ) ) ) ) ).

% no_zero_divisors
tff(fact_761_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
          <=> ( A3 = B2 ) ) ) ) ).

% mult_left_cancel
tff(fact_762_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
          <=> ( A3 = B2 ) ) ) ) ).

% mult_right_cancel
tff(fact_763_zero__neq__one,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( zero_zero(A) != one_one(A) ) ) ).

% zero_neq_one
tff(fact_764_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
        <=> ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = zero_zero(A) ) ) ) ).

% eq_iff_diff_eq_0
tff(fact_765_less__eq__assn__def,axiom,
    ! [A3: assn,B2: assn] :
      ( pp(aa(assn,bool,aa(assn,fun(assn,bool),ord_less_eq(assn),A3),B2))
    <=> ( A3 = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A3),B2) ) ) ).

% less_eq_assn_def
tff(fact_766_fst__image__mp,axiom,
    ! [B: $tType,A: $tType,A4: set(product_prod(A,B)),B3: set(A),X: A,Y: B] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),A4)),B3))
     => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y),A4))
       => pp(member(A,X,B3)) ) ) ).

% fst_image_mp
tff(fact_767_surjective__pairing,axiom,
    ! [B: $tType,A: $tType,T4: product_prod(A,B)] : ( T4 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(product_prod(A,B),A,product_fst(A,B),T4)),aa(product_prod(A,B),B,product_snd(A,B),T4)) ) ).

% surjective_pairing
tff(fact_768_prod_Oexhaust__sel,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod(A,B)] : ( Prod = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(product_prod(A,B),A,product_fst(A,B),Prod)),aa(product_prod(A,B),B,product_snd(A,B),Prod)) ) ).

% prod.exhaust_sel
tff(fact_769_subset__minus__empty,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3) = bot_bot(set(A)) ) ) ).

% subset_minus_empty
tff(fact_770_Diff__triv,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3) = A4 ) ) ).

% Diff_triv
tff(fact_771_Int__Diff__disjoint,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)) = bot_bot(set(A)) ) ).

% Int_Diff_disjoint
tff(fact_772_disjoint__alt__simp1,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3) = A4 )
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) ) ) ).

% disjoint_alt_simp1
tff(fact_773_disjoint__alt__simp2,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3) != A4 )
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) != bot_bot(set(A)) ) ) ).

% disjoint_alt_simp2
tff(fact_774_Un__Diff__Int,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) = A4 ) ).

% Un_Diff_Int
tff(fact_775_Int__Diff__Un,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)) = A4 ) ).

% Int_Diff_Un
tff(fact_776_Diff__Int,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),C3)) ) ).

% Diff_Int
tff(fact_777_Diff__Un,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),C3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),C3)) ) ).

% Diff_Un
tff(fact_778_mult__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_mono
tff(fact_779_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_mono'
tff(fact_780_zero__le__square,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3))) ) ).

% zero_le_square
tff(fact_781_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,B2: A] :
          ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ) ).

% split_mult_pos_le
tff(fact_782_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% mult_left_mono_neg
tff(fact_783_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ) ) ).

% mult_nonpos_nonpos
tff(fact_784_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% mult_left_mono
tff(fact_785_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ) ).

% mult_right_mono_neg
tff(fact_786_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ) ).

% mult_right_mono
tff(fact_787_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) ) ) ) ) ).

% mult_le_0_iff
tff(fact_788_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A3: A,B2: A] :
          ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A))) ) ) ).

% split_mult_neg_le
tff(fact_789_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ) ) ).

% mult_nonneg_nonneg
tff(fact_790_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A))) ) ) ) ).

% mult_nonneg_nonpos
tff(fact_791_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A))) ) ) ) ).

% mult_nonpos_nonneg
tff(fact_792_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),zero_zero(A))) ) ) ) ).

% mult_nonneg_nonpos2
tff(fact_793_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) ) ) ) ) ).

% zero_le_mult_iff
tff(fact_794_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordere2520102378445227354miring(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
tff(fact_795_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),zero_zero(A))) ) ).

% not_one_le_zero
tff(fact_796_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),one_one(A))) ) ).

% linordered_nonzero_semiring_class.zero_le_one
tff(fact_797_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),one_one(A))) ) ).

% zero_less_one_class.zero_le_one
tff(fact_798_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),zero_zero(A))) ) ) ).

% le_iff_diff_le_0
tff(fact_799_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( zero_zero(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% zero_neq_neg_one
tff(fact_800_fst__convol,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,B),G: fun(A,C)] : ( aa(fun(A,product_prod(B,C)),fun(A,B),aa(fun(product_prod(B,C),B),fun(fun(A,product_prod(B,C)),fun(A,B)),comp(product_prod(B,C),B,A),product_fst(B,C)),bNF_convol(A,B,C,F,G)) = F ) ).

% fst_convol
tff(fact_801_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y),X)),X)) ) ) ) ) ).

% mult_left_le_one_le
tff(fact_802_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Y)),X)) ) ) ) ) ).

% mult_right_le_one_le
tff(fact_803_mult__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),one_one(A))) ) ) ) ) ).

% mult_le_one
tff(fact_804_mult__left__le,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),one_one(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),A3)) ) ) ) ).

% mult_left_le
tff(fact_805_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A))) ) ).

% le_minus_one_simps(1)
tff(fact_806_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% le_minus_one_simps(3)
tff(fact_807_convol__expand__snd,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,product_prod(B,C)),G: fun(A,B)] :
      ( ( aa(fun(A,product_prod(B,C)),fun(A,B),aa(fun(product_prod(B,C),B),fun(fun(A,product_prod(B,C)),fun(A,B)),comp(product_prod(B,C),B,A),product_fst(B,C)),F) = G )
     => ( bNF_convol(A,B,C,G,aa(fun(A,product_prod(B,C)),fun(A,C),aa(fun(product_prod(B,C),C),fun(fun(A,product_prod(B,C)),fun(A,C)),comp(product_prod(B,C),C,A),product_snd(B,C)),F)) = F ) ) ).

% convol_expand_snd
tff(fact_808_convol__expand__snd_H,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,product_prod(B,C)),G: fun(A,B),H2: fun(A,C)] :
      ( ( aa(fun(A,product_prod(B,C)),fun(A,B),aa(fun(product_prod(B,C),B),fun(fun(A,product_prod(B,C)),fun(A,B)),comp(product_prod(B,C),B,A),product_fst(B,C)),F) = G )
     => ( ( H2 = aa(fun(A,product_prod(B,C)),fun(A,C),aa(fun(product_prod(B,C),C),fun(fun(A,product_prod(B,C)),fun(A,C)),comp(product_prod(B,C),C,A),product_snd(B,C)),F) )
      <=> ( bNF_convol(A,B,C,G,H2) = F ) ) ) ).

% convol_expand_snd'
tff(fact_809_sndOp__def,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: fun(C,fun(A,bool)),Q: fun(A,fun(B,bool)),Ac: product_prod(C,B)] : ( aa(product_prod(C,B),product_prod(A,B),bNF_sndOp(C,A,B,P,Q),Ac) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),bNF_pick_middlep(C,A,B,P,Q,aa(product_prod(C,B),C,product_fst(C,B),Ac),aa(product_prod(C,B),B,product_snd(C,B),Ac))),aa(product_prod(C,B),B,product_snd(C,B),Ac)) ) ).

% sndOp_def
tff(fact_810_exI__realizer,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool)),Y: A,X: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),P,Y),X))
     => pp(aa(B,bool,aa(A,fun(B,bool),P,aa(product_prod(B,A),A,product_snd(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X),Y))),aa(product_prod(B,A),B,product_fst(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X),Y)))) ) ).

% exI_realizer
tff(fact_811_conjI__realizer,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),P3: A,Q: fun(B,bool),Q3: B] :
      ( pp(aa(A,bool,P,P3))
     => ( pp(aa(B,bool,Q,Q3))
       => ( pp(aa(A,bool,P,aa(product_prod(A,B),A,product_fst(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),P3),Q3))))
          & pp(aa(B,bool,Q,aa(product_prod(A,B),B,product_snd(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),P3),Q3)))) ) ) ) ).

% conjI_realizer
tff(fact_812_BNF__Greatest__Fixpoint_Osubst__Pair,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool)),X: A,Y: B,A3: product_prod(A,B)] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),P,X),Y))
     => ( ( A3 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y) )
       => pp(aa(B,bool,aa(A,fun(B,bool),P,aa(product_prod(A,B),A,product_fst(A,B),A3)),aa(product_prod(A,B),B,product_snd(A,B),A3))) ) ) ).

% BNF_Greatest_Fixpoint.subst_Pair
tff(fact_813_fst__fstOp,axiom,
    ! [C: $tType,B: $tType,A: $tType,Bc: product_prod(A,B),P: fun(A,fun(C,bool)),Q: fun(C,fun(B,bool))] : ( aa(product_prod(A,B),A,product_fst(A,B),Bc) = aa(product_prod(A,B),A,aa(fun(product_prod(A,B),product_prod(A,C)),fun(product_prod(A,B),A),aa(fun(product_prod(A,C),A),fun(fun(product_prod(A,B),product_prod(A,C)),fun(product_prod(A,B),A)),comp(product_prod(A,C),A,product_prod(A,B)),product_fst(A,C)),bNF_fstOp(A,C,B,P,Q)),Bc) ) ).

% fst_fstOp
tff(fact_814_pair__in__swap__image,axiom,
    ! [A: $tType,B: $tType,Y: A,X: B,A4: set(product_prod(B,A))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Y),X),aa(set(product_prod(B,A)),set(product_prod(A,B)),image2(product_prod(B,A),product_prod(A,B),product_swap(B,A)),A4)))
    <=> pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X),Y),A4)) ) ).

% pair_in_swap_image
tff(fact_815_prod_Oswap__def,axiom,
    ! [B: $tType,A: $tType,P3: product_prod(A,B)] : ( aa(product_prod(A,B),product_prod(B,A),product_swap(A,B),P3) = aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),aa(product_prod(A,B),B,product_snd(A,B),P3)),aa(product_prod(A,B),A,product_fst(A,B),P3)) ) ).

% prod.swap_def
tff(fact_816_map__prod__o__convol__id,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(C,A),G: fun(C,B),X: C] : ( aa(C,product_prod(A,B),aa(fun(C,product_prod(C,B)),fun(C,product_prod(A,B)),aa(fun(product_prod(C,B),product_prod(A,B)),fun(fun(C,product_prod(C,B)),fun(C,product_prod(A,B))),comp(product_prod(C,B),product_prod(A,B),C),product_map_prod(C,A,B,B,F,id(B))),bNF_convol(C,C,B,id(C),G)),X) = aa(C,product_prod(A,B),bNF_convol(C,A,B,aa(fun(C,A),fun(C,A),aa(fun(A,A),fun(fun(C,A),fun(C,A)),comp(A,A,C),id(A)),F),G),X) ) ).

% map_prod_o_convol_id
tff(fact_817_prod_Osize__gen__o__map,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: fun(C,nat),Fa: fun(D,nat),G: fun(A,C),Ga: fun(B,D)] : ( aa(fun(product_prod(A,B),product_prod(C,D)),fun(product_prod(A,B),nat),aa(fun(product_prod(C,D),nat),fun(fun(product_prod(A,B),product_prod(C,D)),fun(product_prod(A,B),nat)),comp(product_prod(C,D),nat,product_prod(A,B)),basic_BNF_size_prod(C,D,F,Fa)),product_map_prod(A,C,B,D,G,Ga)) = basic_BNF_size_prod(A,B,aa(fun(A,C),fun(A,nat),aa(fun(C,nat),fun(fun(A,C),fun(A,nat)),comp(C,nat,A),F),G),aa(fun(B,D),fun(B,nat),aa(fun(D,nat),fun(fun(B,D),fun(B,nat)),comp(D,nat,B),Fa),Ga)) ) ).

% prod.size_gen_o_map
tff(fact_818_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q3: A,R3: A] :
          ( unique5940410009612947441es_aux(A,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),R3))
        <=> ( R3 = zero_zero(A) ) ) ) ).

% divides_aux_eq
tff(fact_819_id__comp,axiom,
    ! [B: $tType,A: $tType,G: fun(A,B)] : ( aa(fun(A,B),fun(A,B),aa(fun(B,B),fun(fun(A,B),fun(A,B)),comp(B,B,A),id(B)),G) = G ) ).

% id_comp
tff(fact_820_comp__id,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] : ( aa(fun(A,A),fun(A,B),aa(fun(A,B),fun(fun(A,A),fun(A,B)),comp(A,B,A),F),id(A)) = F ) ).

% comp_id
tff(fact_821_fun_Omap__id,axiom,
    ! [A: $tType,D: $tType,T4: fun(D,A)] : ( aa(fun(D,A),fun(D,A),aa(fun(A,A),fun(fun(D,A),fun(D,A)),comp(A,A,D),id(A)),T4) = T4 ) ).

% fun.map_id
tff(fact_822_swap__simp,axiom,
    ! [A: $tType,B: $tType,X: B,Y: A] : ( aa(product_prod(B,A),product_prod(A,B),product_swap(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X),Y)) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Y),X) ) ).

% swap_simp
tff(fact_823_group__add__class_Ominus__comp__minus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ( aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),uminus_uminus(A)),uminus_uminus(A)) = id(A) ) ) ).

% group_add_class.minus_comp_minus
tff(fact_824_boolean__algebra__class_Ominus__comp__minus,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ( aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),uminus_uminus(A)),uminus_uminus(A)) = id(A) ) ) ).

% boolean_algebra_class.minus_comp_minus
tff(fact_825_swap__comp__swap,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(B,A)),fun(product_prod(A,B),product_prod(A,B)),aa(fun(product_prod(B,A),product_prod(A,B)),fun(fun(product_prod(A,B),product_prod(B,A)),fun(product_prod(A,B),product_prod(A,B))),comp(product_prod(B,A),product_prod(A,B),product_prod(A,B)),product_swap(B,A)),product_swap(A,B)) = id(product_prod(A,B)) ) ).

% swap_comp_swap
tff(fact_826_fun_Omap__id0,axiom,
    ! [A: $tType,D: $tType] : ( aa(fun(A,A),fun(fun(D,A),fun(D,A)),comp(A,A,D),id(A)) = id(fun(D,A)) ) ).

% fun.map_id0
tff(fact_827_comp__eq__id__dest,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: fun(C,B),B2: fun(A,C),C2: fun(A,B),V: A] :
      ( ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),A3),B2) = aa(fun(A,B),fun(A,B),aa(fun(B,B),fun(fun(A,B),fun(A,B)),comp(B,B,A),id(B)),C2) )
     => ( aa(C,B,A3,aa(A,C,B2,V)) = aa(A,B,C2,V) ) ) ).

% comp_eq_id_dest
tff(fact_828_pointfree__idE,axiom,
    ! [B: $tType,A: $tType,F: fun(B,A),G: fun(A,B),X: A] :
      ( ( aa(fun(A,B),fun(A,A),aa(fun(B,A),fun(fun(A,B),fun(A,A)),comp(B,A,A),F),G) = id(A) )
     => ( aa(B,A,F,aa(A,B,G,X)) = X ) ) ).

% pointfree_idE
tff(fact_829_type__copy__Rep__o__Abs,axiom,
    ! [A: $tType,B: $tType,Rep: fun(A,B),Abs: fun(B,A)] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( aa(fun(B,A),fun(B,B),aa(fun(A,B),fun(fun(B,A),fun(B,B)),comp(A,B,B),Rep),Abs) = id(B) ) ) ).

% type_copy_Rep_o_Abs
tff(fact_830_type__copy__Abs__o__Rep,axiom,
    ! [B: $tType,A: $tType,Rep: fun(A,B),Abs: fun(B,A)] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( aa(fun(A,B),fun(A,A),aa(fun(B,A),fun(fun(A,B),fun(A,A)),comp(B,A,A),Abs),Rep) = id(A) ) ) ).

% type_copy_Abs_o_Rep
tff(fact_831_type__copy__map__id0,axiom,
    ! [B: $tType,A: $tType,Rep: fun(A,B),Abs: fun(B,A),M: fun(B,B)] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( ( M = id(B) )
       => ( aa(fun(A,B),fun(A,A),aa(fun(B,A),fun(fun(A,B),fun(A,A)),comp(B,A,A),aa(fun(B,B),fun(B,A),aa(fun(B,A),fun(fun(B,B),fun(B,A)),comp(B,A,B),Abs),M)),Rep) = id(A) ) ) ) ).

% type_copy_map_id0
tff(fact_832_fstOp__def,axiom,
    ! [B: $tType,C: $tType,A: $tType,P: fun(A,fun(B,bool)),Q: fun(B,fun(C,bool)),Ac: product_prod(A,C)] : ( aa(product_prod(A,C),product_prod(A,B),bNF_fstOp(A,B,C,P,Q),Ac) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(product_prod(A,C),A,product_fst(A,C),Ac)),bNF_pick_middlep(A,B,C,P,Q,aa(product_prod(A,C),A,product_fst(A,C),Ac),aa(product_prod(A,C),C,product_snd(A,C),Ac))) ) ).

% fstOp_def
tff(fact_833_inj__on__Un,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B),A4: set(A),B3: set(A)] :
      ( inj_on(A,B,F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3))
    <=> ( inj_on(A,B,F,A4)
        & inj_on(A,B,F,B3)
        & ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image2(A,B,F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3))),aa(set(A),set(B),image2(A,B,F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A4))) = bot_bot(set(B)) ) ) ) ).

% inj_on_Un
tff(fact_834_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),one_one(A))) ) ) ) ) ).

% mult_le_cancel_left1
tff(fact_835_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3)) ) ) ) ) ).

% mult_le_cancel_left2
tff(fact_836_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),one_one(A))) ) ) ) ) ).

% mult_le_cancel_right1
tff(fact_837_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3)) ) ) ) ) ).

% mult_le_cancel_right2
tff(fact_838_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),one_one(A))) ) ) ) ) ).

% mult_less_cancel_left1
tff(fact_839_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3)) ) ) ) ) ).

% mult_less_cancel_left2
tff(fact_840_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),one_one(A))) ) ) ) ) ).

% mult_less_cancel_right1
tff(fact_841_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),C2))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3)) ) ) ) ) ).

% mult_less_cancel_right2
tff(fact_842_relChain__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [R3: set(product_prod(A,A)),As8: fun(A,B)] :
          ( bNF_Ca3754400796208372196lChain(A,B,R3,As8)
        <=> ! [I2: A,J: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),I2),J),R3))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,As8,I2)),aa(A,B,As8,J))) ) ) ) ).

% relChain_def
tff(fact_843_not__gr__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),N))
        <=> ( N = zero_zero(A) ) ) ) ).

% not_gr_zero
tff(fact_844_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,uminus_uminus(A),Y)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ).

% compl_less_compl_iff
tff(fact_845_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% neg_less_iff_less
tff(fact_846_inj__on__empty,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] : inj_on(A,B,F,bot_bot(set(A))) ).

% inj_on_empty
tff(fact_847_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ).

% diff_gt_0_iff_gt
tff(fact_848_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% neg_less_0_iff_less
tff(fact_849_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% neg_0_less_iff_less
tff(fact_850_neg__less__pos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A3)),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% neg_less_pos
tff(fact_851_less__neg__neg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% less_neg_neg
tff(fact_852_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ).

% order_less_imp_not_less
tff(fact_853_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ( Y != X ) ) ) ).

% order_less_imp_not_eq2
tff(fact_854_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ( X != Y ) ) ) ).

% order_less_imp_not_eq
tff(fact_855_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
          | ( X = Y )
          | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ).

% linorder_less_linear
tff(fact_856_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A,P: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X))
           => pp(P) ) ) ) ).

% order_less_imp_triv
tff(fact_857_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ).

% order_less_not_sym
tff(fact_858_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A3: A,B2: A,F: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F,B2)),C2))
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F,X2)),aa(A,C,F,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F,A3)),C2)) ) ) ) ) ).

% order_less_subst2
tff(fact_859_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A3: A,F: fun(B,A),B2: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F,B2)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F,X2)),aa(B,A,F,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F,C2))) ) ) ) ) ).

% order_less_subst1
tff(fact_860_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),X)) ) ).

% order_less_irrefl
tff(fact_861_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A3: A,B2: A,F: fun(A,B),C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( ( aa(A,B,F,B2) = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F,X2)),aa(A,B,F,Y2))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F,A3)),C2)) ) ) ) ) ).

% ord_less_eq_subst
tff(fact_862_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A3: A,F: fun(B,A),B2: B,C2: B] :
          ( ( A3 = aa(B,A,F,B2) )
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F,X2)),aa(B,A,F,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F,C2))) ) ) ) ) ).

% ord_eq_less_subst
tff(fact_863_order__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z2)) ) ) ) ).

% order_less_trans
tff(fact_864_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ).

% order_less_asym'
tff(fact_865_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ( X != Y )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ) ).

% linorder_neq_iff
tff(fact_866_order__less__asym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ).

% order_less_asym
tff(fact_867_linorder__neqE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ) ).

% linorder_neqE
tff(fact_868_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( A3 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
tff(fact_869_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( A3 != B2 ) ) ) ).

% order.strict_implies_not_eq
tff(fact_870_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3)) ) ) ) ).

% dual_order.strict_trans
tff(fact_871_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X))
            | ( X = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
tff(fact_872_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% order.strict_trans
tff(fact_873_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,fun(A,bool)),A3: A,B2: A] :
          ( ! [A8: A,B5: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A8),B5))
             => pp(aa(A,bool,aa(A,fun(A,bool),P,A8),B5)) )
         => ( ! [A8: A] : pp(aa(A,bool,aa(A,fun(A,bool),P,A8),A8))
           => ( ! [A8: A,B5: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),P,B5),A8))
                 => pp(aa(A,bool,aa(A,fun(A,bool),P,A8),B5)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),P,A3),B2)) ) ) ) ) ).

% linorder_less_wlog
tff(fact_874_exists__least__iff,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool)] :
          ( ? [X_12: A] : pp(aa(A,bool,P,X_12))
        <=> ? [N5: A] :
              ( pp(aa(A,bool,P,N5))
              & ! [M3: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M3),N5))
                 => ~ pp(aa(A,bool,P,M3)) ) ) ) ) ).

% exists_least_iff
tff(fact_875_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),A3)) ) ).

% dual_order.irrefl
tff(fact_876_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% dual_order.asym
tff(fact_877_linorder__cases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ( ( X != Y )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ) ).

% linorder_cases
tff(fact_878_antisym__conv3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,X: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X))
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
          <=> ( X = Y ) ) ) ) ).

% antisym_conv3
tff(fact_879_less__induct,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),A3: A] :
          ( ! [X2: A] :
              ( ! [Y4: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y4),X2))
                 => pp(aa(A,bool,P,Y4)) )
             => pp(aa(A,bool,P,X2)) )
         => pp(aa(A,bool,P,A3)) ) ) ).

% less_induct
tff(fact_880_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( ( B2 = C2 )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% ord_less_eq_trans
tff(fact_881_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = B2 )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% ord_eq_less_trans
tff(fact_882_order_Oasym,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ).

% order.asym
tff(fact_883_less__imp__neq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ( X != Y ) ) ) ).

% less_imp_neq
tff(fact_884_dense,axiom,
    ! [A: $tType] :
      ( dense_order(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ? [Z3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z3),Y)) ) ) ) ).

% dense
tff(fact_885_gt__ex,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [X: A] :
        ? [X_1: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),X_1)) ) ).

% gt_ex
tff(fact_886_lt__ex,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [X: A] :
        ? [Y2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y2),X)) ) ).

% lt_ex
tff(fact_887_fun_Oinj__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,F: fun(A,B)] :
      ( inj_on(A,B,F,top_top(set(A)))
     => inj_on(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),F),top_top(set(fun(D,A)))) ) ).

% fun.inj_map
tff(fact_888_inj__on__imageI2,axiom,
    ! [B: $tType,C: $tType,A: $tType,F10: fun(C,B),F: fun(A,C),A4: set(A)] :
      ( inj_on(A,B,aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),F10),F),A4)
     => inj_on(A,C,F,A4) ) ).

% inj_on_imageI2
tff(fact_889_inj__on__Int,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),A4: set(A),B3: set(A)] :
      ( ( inj_on(A,B,F,A4)
        | inj_on(A,B,F,B3) )
     => inj_on(A,B,F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) ).

% inj_on_Int
tff(fact_890_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
            | ( X = Y ) ) ) ) ).

% order_le_imp_less_or_eq
tff(fact_891_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
          | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ).

% linorder_le_less_linear
tff(fact_892_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A3: A,B2: A,F: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F,B2)),C2))
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F,X2)),aa(A,C,F,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F,A3)),C2)) ) ) ) ) ).

% order_less_le_subst2
tff(fact_893_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A3: A,F: fun(B,A),B2: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F,B2)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,X2)),aa(B,A,F,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F,C2))) ) ) ) ) ).

% order_less_le_subst1
tff(fact_894_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [A3: A,B2: A,F: fun(A,C),C2: C] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F,B2)),C2))
           => ( ! [X2: A,Y2: A] :
                  ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
                 => pp(aa(C,bool,aa(C,fun(C,bool),ord_less_eq(C),aa(A,C,F,X2)),aa(A,C,F,Y2))) )
             => pp(aa(C,bool,aa(C,fun(C,bool),ord_less(C),aa(A,C,F,A3)),C2)) ) ) ) ) ).

% order_le_less_subst2
tff(fact_895_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A3: A,F: fun(B,A),B2: B,C2: B] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(B,A,F,B2)))
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),B2),C2))
           => ( ! [X2: B,Y2: B] :
                  ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),X2),Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F,X2)),aa(B,A,F,Y2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F,C2))) ) ) ) ) ).

% order_le_less_subst1
tff(fact_896_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z2)) ) ) ) ).

% order_less_le_trans
tff(fact_897_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z2)) ) ) ) ).

% order_le_less_trans
tff(fact_898_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != B2 )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% order_neq_le_trans
tff(fact_899_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( ( A3 != B2 )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% order_le_neq_trans
tff(fact_900_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y)) ) ) ).

% order_less_imp_le
tff(fact_901_linorder__not__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X)) ) ) ).

% linorder_not_less
tff(fact_902_linorder__not__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X)) ) ) ).

% linorder_not_le
tff(fact_903_order__less__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
            & ( X != Y ) ) ) ) ).

% order_less_le
tff(fact_904_order__le__less,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
            | ( X = Y ) ) ) ) ).

% order_le_less
tff(fact_905_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% dual_order.strict_implies_order
tff(fact_906_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% order.strict_implies_order
tff(fact_907_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% dual_order.strict_iff_not
tff(fact_908_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3)) ) ) ) ).

% dual_order.strict_trans2
tff(fact_909_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3)) ) ) ) ).

% dual_order.strict_trans1
tff(fact_910_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & ( A3 != B2 ) ) ) ) ).

% dual_order.strict_iff_order
tff(fact_911_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
            | ( A3 = B2 ) ) ) ) ).

% dual_order.order_iff_strict
tff(fact_912_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ( ! [W: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),W))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),W),Y))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),W),Z2)) ) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ) ).

% dense_le_bounded
tff(fact_913_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z2: A,X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),X))
         => ( ! [W: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),W))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),W),X))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),W)) ) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ) ).

% dense_ge_bounded
tff(fact_914_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% order.strict_iff_not
tff(fact_915_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% order.strict_trans2
tff(fact_916_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% order.strict_trans1
tff(fact_917_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & ( A3 != B2 ) ) ) ) ).

% order.strict_iff_order
tff(fact_918_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
            | ( A3 = B2 ) ) ) ) ).

% order.order_iff_strict
tff(fact_919_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,X: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y)) ) ) ).

% not_le_imp_less
tff(fact_920_less__le__not__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X)) ) ) ) ).

% less_le_not_le
tff(fact_921_dense__le,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Y: A,Z2: A] :
          ( ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Y))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z2)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ).

% dense_le
tff(fact_922_dense__ge,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z2: A,Y: A] :
          ( ! [X2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),X2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X2)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ).

% dense_ge
tff(fact_923_antisym__conv2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
          <=> ( X = Y ) ) ) ) ).

% antisym_conv2
tff(fact_924_antisym__conv1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
          <=> ( X = Y ) ) ) ) ).

% antisym_conv1
tff(fact_925_nless__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            | ( A3 = B2 ) ) ) ) ).

% nless_le
tff(fact_926_leI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X)) ) ) ).

% leI
tff(fact_927_leD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X))
         => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y)) ) ) ).

% leD
tff(fact_928_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),N))
        <=> ( N != zero_zero(A) ) ) ) ).

% zero_less_iff_neq_zero
tff(fact_929_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [M4: A,N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),M4),N))
         => ( N != zero_zero(A) ) ) ) ).

% gr_implies_not_zero
tff(fact_930_not__less__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),N),zero_zero(A))) ) ).

% not_less_zero
tff(fact_931_gr__zeroI,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( ( N != zero_zero(A) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),N)) ) ) ).

% gr_zeroI
tff(fact_932_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),one_one(A))) ) ).

% less_numeral_extra(4)
tff(fact_933_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2))) ) ) ).

% diff_strict_right_mono
tff(fact_934_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))) ) ) ).

% diff_strict_left_mono
tff(fact_935_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2)) ) ) ) ).

% diff_eq_diff_less
tff(fact_936_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,D2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),D2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2))) ) ) ) ).

% diff_strict_mono
tff(fact_937_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),bot_bot(A))) ) ).

% bot.extremum_strict
tff(fact_938_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A3: A] :
          ( ( A3 != bot_bot(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),bot_bot(A)),A3)) ) ) ).

% bot.not_eq_extremum
tff(fact_939_not__psubset__empty,axiom,
    ! [A: $tType,A4: set(A)] : ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A4),bot_bot(set(A)))) ).

% not_psubset_empty
tff(fact_940_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),Y)),X))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),X)),Y)) ) ) ).

% compl_less_swap2
tff(fact_941_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(A,A,uminus_uminus(A),X)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),aa(A,A,uminus_uminus(A),Y))) ) ) ).

% compl_less_swap1
tff(fact_942_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),A3)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),A3)) ) ) ).

% minus_less_iff
tff(fact_943_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,uminus_uminus(A),A3))) ) ) ).

% less_minus_iff
tff(fact_944_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A3: A] :
          ( ( A3 != top_top(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),top_top(A))) ) ) ).

% top.not_eq_extremum
tff(fact_945_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),top_top(A)),A3)) ) ).

% top.extremum_strict
tff(fact_946_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),C2)) ) ) ).

% inf.strict_coboundedI2
tff(fact_947_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),C2)) ) ) ).

% inf.strict_coboundedI1
tff(fact_948_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> ( ( A3 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) )
            & ( A3 != B2 ) ) ) ) ).

% inf.strict_order_iff
tff(fact_949_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% inf.strict_boundedE
tff(fact_950_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = B2 ) ) ) ).

% inf.absorb4
tff(fact_951_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2) = A3 ) ) ) ).

% inf.absorb3
tff(fact_952_less__infI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,X: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),X))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),X)) ) ) ).

% less_infI2
tff(fact_953_less__infI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: A,X: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),X))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B2)),X)) ) ) ).

% less_infI1
tff(fact_954_less__supI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% less_supI1
tff(fact_955_less__supI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% less_supI2
tff(fact_956_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = A3 ) ) ) ).

% sup.absorb3
tff(fact_957_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) = B2 ) ) ) ).

% sup.absorb4
tff(fact_958_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A3))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3)) ) ) ) ).

% sup.strict_boundedE
tff(fact_959_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
        <=> ( ( A3 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2) )
            & ( A3 != B2 ) ) ) ) ).

% sup.strict_order_iff
tff(fact_960_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% sup.strict_coboundedI1
tff(fact_961_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B2))) ) ) ).

% sup.strict_coboundedI2
tff(fact_962_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F: fun(A,B),G: fun(A,B)] :
          ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less(fun(A,B)),F),G))
        <=> ( pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),F),G))
            & ~ pp(aa(fun(A,B),bool,aa(fun(A,B),fun(fun(A,B),bool),ord_less_eq(fun(A,B)),G),F)) ) ) ) ).

% less_fun_def
tff(fact_963_inj__on__mult,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A,A4: set(A)] :
          ( ( A3 != zero_zero(A) )
         => inj_on(A,A,aa(A,fun(A,A),times_times(A),A3),A4) ) ) ).

% inj_on_mult
tff(fact_964_comp__inj__on,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(A,B),A4: set(A),G: fun(B,C)] :
      ( inj_on(A,B,F,A4)
     => ( inj_on(B,C,G,aa(set(A),set(B),image2(A,B,F),A4))
       => inj_on(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),G),F),A4) ) ) ).

% comp_inj_on
tff(fact_965_inj__on__imageI,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: fun(C,B),F: fun(A,C),A4: set(A)] :
      ( inj_on(A,B,aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),G),F),A4)
     => inj_on(C,B,G,aa(set(A),set(C),image2(A,C,F),A4)) ) ).

% inj_on_imageI
tff(fact_966_comp__inj__on__iff,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(A,B),A4: set(A),F10: fun(B,C)] :
      ( inj_on(A,B,F,A4)
     => ( inj_on(B,C,F10,aa(set(A),set(B),image2(A,B,F),A4))
      <=> inj_on(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F10),F),A4) ) ) ).

% comp_inj_on_iff
tff(fact_967_inj__compose,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(A,B),G: fun(C,A)] :
      ( inj_on(A,B,F,top_top(set(A)))
     => ( inj_on(C,A,G,top_top(set(C)))
       => inj_on(C,B,aa(fun(C,A),fun(C,B),aa(fun(A,B),fun(fun(C,A),fun(C,B)),comp(A,B,C),F),G),top_top(set(C))) ) ) ).

% inj_compose
tff(fact_968_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ) ) ).

% mult_neg_neg
tff(fact_969_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3)),zero_zero(A))) ) ).

% not_square_less_zero
tff(fact_970_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A))) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ) ) ).

% mult_less_0_iff
tff(fact_971_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A))) ) ) ) ).

% mult_neg_pos
tff(fact_972_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A))) ) ) ) ).

% mult_pos_neg
tff(fact_973_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ) ) ).

% mult_pos_pos
tff(fact_974_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),zero_zero(A))) ) ) ) ).

% mult_pos_neg2
tff(fact_975_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A))) ) ) ) ) ).

% zero_less_mult_iff
tff(fact_976_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ) ).

% zero_less_mult_pos
tff(fact_977_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ) ).

% zero_less_mult_pos2
tff(fact_978_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ).

% mult_less_cancel_left_neg
tff(fact_979_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% mult_less_cancel_left_pos
tff(fact_980_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% mult_strict_left_mono_neg
tff(fact_981_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% mult_strict_left_mono
tff(fact_982_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% mult_less_cancel_left_disj
tff(fact_983_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ) ).

% mult_strict_right_mono_neg
tff(fact_984_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ) ).

% mult_strict_right_mono
tff(fact_985_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% mult_less_cancel_right_disj
tff(fact_986_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord2810124833399127020strict(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
tff(fact_987_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),zero_zero(A))) ) ).

% not_one_less_zero
tff(fact_988_zero__less__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),one_one(A))) ) ).

% zero_less_one
tff(fact_989_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),one_one(A))) ) ).

% less_numeral_extra(1)
tff(fact_990_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),zero_zero(A))) ) ) ).

% less_iff_diff_less_0
tff(fact_991_less__1__mult,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [M4: A,N: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),M4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),M4),N))) ) ) ) ).

% less_1_mult
tff(fact_992_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A))) ) ).

% less_minus_one_simps(2)
tff(fact_993_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% less_minus_one_simps(4)
tff(fact_994_less__assn__def,axiom,
    ! [A3: assn,B2: assn] :
      ( pp(aa(assn,bool,aa(assn,fun(assn,bool),ord_less(assn),A3),B2))
    <=> ( pp(aa(assn,bool,aa(assn,fun(assn,bool),ord_less_eq(assn),A3),B2))
        & ( A3 != B2 ) ) ) ).

% less_assn_def
tff(fact_995_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),C3: set(A),A4: set(A),B3: set(A)] :
      ( inj_on(A,B,F,C3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),C3))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),C3))
         => ( aa(set(A),set(B),image2(A,B,F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image2(A,B,F),A4)),aa(set(A),set(B),image2(A,B,F),B3)) ) ) ) ) ).

% inj_on_image_Int
tff(fact_996_image__Int,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),A4: set(A),B3: set(A)] :
      ( inj_on(A,B,F,top_top(set(A)))
     => ( aa(set(A),set(B),image2(A,B,F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image2(A,B,F),A4)),aa(set(A),set(B),image2(A,B,F),B3)) ) ) ).

% image_Int
tff(fact_997_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_less_le_imp_less
tff(fact_998_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_le_less_imp_less
tff(fact_999_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% mult_right_le_imp_le
tff(fact_1000_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% mult_left_le_imp_le
tff(fact_1001_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% mult_le_cancel_left_pos
tff(fact_1002_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% mult_le_cancel_left_neg
tff(fact_1003_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% mult_less_cancel_right
tff(fact_1004_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_strict_mono'
tff(fact_1005_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% mult_right_less_imp_less
tff(fact_1006_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% mult_less_cancel_left
tff(fact_1007_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ) ) ).

% mult_strict_mono
tff(fact_1008_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% mult_left_less_imp_less
tff(fact_1009_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ) ).

% mult_le_cancel_right
tff(fact_1010_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ) ).

% mult_le_cancel_left
tff(fact_1011_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A))) ) ).

% less_minus_one_simps(1)
tff(fact_1012_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% less_minus_one_simps(3)
tff(fact_1013_disjoint__alt__simp3,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)),A4))
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) != bot_bot(set(A)) ) ) ).

% disjoint_alt_simp3
tff(fact_1014_inj__mult__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A3: A] :
          ( inj_on(A,A,aa(A,fun(A,A),times_times(A),A3),top_top(set(A)))
        <=> ( A3 != zero_zero(A) ) ) ) ).

% inj_mult_left
tff(fact_1015_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A] :
          ( ! [Z3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z3))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z3),one_one(A)))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z3),X)),Y)) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y)) ) ) ).

% field_le_mult_one_interval
tff(fact_1016_inj__on__iff__surj,axiom,
    ! [B: $tType,A: $tType,A4: set(A),A10: set(B)] :
      ( ( A4 != bot_bot(set(A)) )
     => ( ? [F11: fun(A,B)] :
            ( inj_on(A,B,F11,A4)
            & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image2(A,B,F11),A4)),A10)) )
      <=> ? [G5: fun(B,A)] : ( aa(set(B),set(A),image2(B,A,G5),A10) = A4 ) ) ) ).

% inj_on_iff_surj
tff(fact_1017_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: A,X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y)) ) ) ) ).

% mult_le_cancel_iff1
tff(fact_1018_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: A,X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y)) ) ) ) ).

% mult_le_cancel_iff2
tff(fact_1019_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: A,X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Z2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y)) ) ) ) ).

% mult_less_iff1
tff(fact_1020_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => semila1105856199041335345_order(A,inf_inf(A),top_top(A),ord_less_eq(A),ord_less(A)) ) ).

% inf_top.semilattice_neutr_order_axioms
tff(fact_1021_the__inv__f__o__f__id,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),Z2: A] :
      ( inj_on(A,B,F,top_top(set(A)))
     => ( aa(A,A,aa(fun(A,B),fun(A,A),aa(fun(B,A),fun(fun(A,B),fun(A,A)),comp(B,A,A),the_inv_into(A,B,top_top(set(A)),F)),F),Z2) = aa(A,A,id(A),Z2) ) ) ).

% the_inv_f_o_f_id
tff(fact_1022_sgn__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( aa(A,A,sgn_sgn(A),A3) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% sgn_neg
tff(fact_1023_sgn__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),one_one(A)) = one_one(A) ) ) ).

% sgn_1
tff(fact_1024_sgn__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( aa(A,A,sgn_sgn(A),A3) = one_one(A) ) ) ) ).

% sgn_pos
tff(fact_1025_semilattice__neutr__order_Oeq__neutr__iff,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semila1105856199041335345_order(A,F,Z2,Less_eq,Less)
     => ( ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = Z2 )
      <=> ( ( A3 = Z2 )
          & ( B2 = Z2 ) ) ) ) ).

% semilattice_neutr_order.eq_neutr_iff
tff(fact_1026_semilattice__neutr__order_Oneutr__eq__iff,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semila1105856199041335345_order(A,F,Z2,Less_eq,Less)
     => ( ( Z2 = aa(A,A,aa(A,fun(A,A),F,A3),B2) )
      <=> ( ( A3 = Z2 )
          & ( B2 = Z2 ) ) ) ) ).

% semilattice_neutr_order.neutr_eq_iff
tff(fact_1027_sgn__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A,B2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A3)),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% sgn_mult
tff(fact_1028_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% sgn_minus_1
tff(fact_1029_semilattice__neutr__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semila1105856199041335345_order(A,F,Z2,Less_eq,Less)
     => semilattice_neutr(A,F,Z2) ) ).

% semilattice_neutr_order.axioms(1)
tff(fact_1030_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( ( aa(A,A,sgn_sgn(A),A3) = one_one(A) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% sgn_1_pos
tff(fact_1031_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( ( aa(A,A,sgn_sgn(A),A3) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% sgn_1_neg
tff(fact_1032_sgn__if,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( ( ( X = zero_zero(A) )
           => ( aa(A,A,sgn_sgn(A),X) = zero_zero(A) ) )
          & ( ( X != zero_zero(A) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X))
               => ( aa(A,A,sgn_sgn(A),X) = one_one(A) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X))
               => ( aa(A,A,sgn_sgn(A),X) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ) ) ).

% sgn_if
tff(fact_1033_the__inv__into__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: fun(A,B),G: fun(C,A),A4: set(C),X: B] :
      ( inj_on(A,B,F,aa(set(C),set(A),image2(C,A,G),A4))
     => ( inj_on(C,A,G,A4)
       => ( pp(member(B,X,aa(set(A),set(B),image2(A,B,F),aa(set(C),set(A),image2(C,A,G),A4))))
         => ( aa(B,C,the_inv_into(C,B,A4,aa(fun(C,A),fun(C,B),aa(fun(A,B),fun(fun(C,A),fun(C,B)),comp(A,B,C),F),G)),X) = aa(B,C,aa(fun(B,A),fun(B,C),aa(fun(A,C),fun(fun(B,A),fun(B,C)),comp(A,C,B),the_inv_into(C,A,A4,G)),the_inv_into(A,B,aa(set(C),set(A),image2(C,A,G),A4),F)),X) ) ) ) ) ).

% the_inv_into_comp
tff(fact_1034_top_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ordering_top(A,ord_less_eq(A),ord_less(A),top_top(A)) ) ).

% top.ordering_top_axioms
tff(fact_1035_inj__on__insert,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),A3: A,A4: set(A)] :
      ( inj_on(A,B,F,aa(set(A),set(A),insert2(A,A3),A4))
    <=> ( inj_on(A,B,F,A4)
        & ~ pp(member(B,aa(A,B,F,A3),aa(set(A),set(B),image2(A,B,F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))))) ) ) ).

% inj_on_insert
tff(fact_1036_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( linord715952674999750819strict(A)
     => ! [X: A,A3: A,Y: A,U: A,V: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),U))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),V))
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),X)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y))),A3)) ) ) ) ) ) ) ).

% convex_bound_lt
tff(fact_1037_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% pos_minus_divide_le_eq
tff(fact_1038_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% pos_le_minus_divide_eq
tff(fact_1039_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% neg_minus_divide_le_eq
tff(fact_1040_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% neg_le_minus_divide_eq
tff(fact_1041_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A3))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ) ) ) ) ).

% minus_divide_le_eq
tff(fact_1042_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ) ) ) ) ).

% le_minus_divide_eq
tff(fact_1043_add__right__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3) )
        <=> ( B2 = C2 ) ) ) ).

% add_right_cancel
tff(fact_1044_add__left__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2) )
        <=> ( B2 = C2 ) ) ) ).

% add_left_cancel
tff(fact_1045_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% add_le_cancel_right
tff(fact_1046_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% add_le_cancel_left
tff(fact_1047_add__0,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A3) = A3 ) ) ).

% add_0
tff(fact_1048_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X: A,Y: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y) )
        <=> ( ( X = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
tff(fact_1049_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y) = zero_zero(A) )
        <=> ( ( X = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
tff(fact_1050_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_right_right
tff(fact_1051_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_right_left
tff(fact_1052_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = A3 )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_left_right
tff(fact_1053_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [B2: A,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) = A3 )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_left_left
tff(fact_1054_double__zero__sym,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% double_zero_sym
tff(fact_1055_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),zero_zero(A)) = A3 ) ) ).

% add.right_neutral
tff(fact_1056_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% add_less_cancel_right
tff(fact_1057_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% add_less_cancel_left
tff(fact_1058_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),B2) = A3 ) ) ).

% add_diff_cancel_right'
tff(fact_1059_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A3: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) ) ) ).

% add_diff_cancel_right
tff(fact_1060_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),A3) = B2 ) ) ).

% add_diff_cancel_left'
tff(fact_1061_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) ) ) ).

% add_diff_cancel_left
tff(fact_1062_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),B2) = A3 ) ) ).

% diff_add_cancel
tff(fact_1063_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),B2) = A3 ) ) ).

% add_diff_cancel
tff(fact_1064_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_add_distrib
tff(fact_1065_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = B2 ) ) ).

% minus_add_cancel
tff(fact_1066_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),B2)) = B2 ) ) ).

% add_minus_cancel
tff(fact_1067_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B2: A,C2: A,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,B2,C2)),A3) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3),C2) ) ) ).

% times_divide_eq_left
tff(fact_1068_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A,C2: A] : ( divide_divide(A,divide_divide(A,A3,B2),C2) = divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% divide_divide_eq_left
tff(fact_1069_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A,C2: A] : ( divide_divide(A,A3,divide_divide(A,B2,C2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),B2) ) ) ).

% divide_divide_eq_right
tff(fact_1070_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),divide_divide(A,B2,C2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) ) ) ).

% times_divide_eq_right
tff(fact_1071_div__by__1,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A] : ( divide_divide(A,A3,one_one(A)) = A3 ) ) ).

% div_by_1
tff(fact_1072_singletonI,axiom,
    ! [A: $tType,A3: A] : pp(member(A,A3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))) ).

% singletonI
tff(fact_1073_Int__insert__left__if0,axiom,
    ! [A: $tType,A3: A,C3: set(A),B3: set(A)] :
      ( ~ pp(member(A,A3,C3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert2(A,A3),B3)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3) ) ) ).

% Int_insert_left_if0
tff(fact_1074_Int__insert__left__if1,axiom,
    ! [A: $tType,A3: A,C3: set(A),B3: set(A)] :
      ( pp(member(A,A3,C3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert2(A,A3),B3)),C3) = aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3)) ) ) ).

% Int_insert_left_if1
tff(fact_1075_insert__inter__insert,axiom,
    ! [A: $tType,A3: A,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert2(A,A3),A4)),aa(set(A),set(A),insert2(A,A3),B3)) = aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) ).

% insert_inter_insert
tff(fact_1076_Int__insert__right__if0,axiom,
    ! [A: $tType,A3: A,A4: set(A),B3: set(A)] :
      ( ~ pp(member(A,A3,A4))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),insert2(A,A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) ) ) ).

% Int_insert_right_if0
tff(fact_1077_Int__insert__right__if1,axiom,
    ! [A: $tType,A3: A,A4: set(A),B3: set(A)] :
      ( pp(member(A,A3,A4))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),insert2(A,A3),B3)) = aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) ) ).

% Int_insert_right_if1
tff(fact_1078_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
tff(fact_1079_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
tff(fact_1080_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) ) ) ).

% le_add_same_cancel2
tff(fact_1081_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2)) ) ) ).

% le_add_same_cancel1
tff(fact_1082_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% add_le_same_cancel2
tff(fact_1083_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% add_le_same_cancel1
tff(fact_1084_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% add_less_same_cancel1
tff(fact_1085_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% add_less_same_cancel2
tff(fact_1086_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ).

% less_add_same_cancel1
tff(fact_1087_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2)) ) ) ).

% less_add_same_cancel2
tff(fact_1088_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
tff(fact_1089_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
tff(fact_1090_diff__add__zero,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = zero_zero(A) ) ) ).

% diff_add_zero
tff(fact_1091_ab__left__minus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),A3) = zero_zero(A) ) ) ).

% ab_left_minus
tff(fact_1092_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,uminus_uminus(A),A3)) = zero_zero(A) ) ) ).

% add.right_inverse
tff(fact_1093_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),A3) = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
tff(fact_1094_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),B2) = A3 ) ) ) ).

% nonzero_mult_div_cancel_right
tff(fact_1095_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( C2 = zero_zero(A) )
           => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = zero_zero(A) ) )
          & ( ( C2 != zero_zero(A) )
           => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = divide_divide(A,A3,B2) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
tff(fact_1096_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = divide_divide(A,A3,B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
tff(fact_1097_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,A3,B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
tff(fact_1098_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,A3,B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
tff(fact_1099_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = divide_divide(A,A3,B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
tff(fact_1100_div__self,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( divide_divide(A,A3,A3) = one_one(A) ) ) ) ).

% div_self
tff(fact_1101_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( ( zero_zero(A) = divide_divide(A,one_one(A),A3) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% zero_eq_1_divide_iff
tff(fact_1102_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( ( divide_divide(A,one_one(A),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% one_divide_eq_0_iff
tff(fact_1103_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( ( one_one(A) = divide_divide(A,B2,A3) )
        <=> ( ( A3 != zero_zero(A) )
            & ( A3 = B2 ) ) ) ) ).

% eq_divide_eq_1
tff(fact_1104_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( ( divide_divide(A,B2,A3) = one_one(A) )
        <=> ( ( A3 != zero_zero(A) )
            & ( A3 = B2 ) ) ) ) ).

% divide_eq_eq_1
tff(fact_1105_divide__self__if,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( ( A3 = zero_zero(A) )
           => ( divide_divide(A,A3,A3) = zero_zero(A) ) )
          & ( ( A3 != zero_zero(A) )
           => ( divide_divide(A,A3,A3) = one_one(A) ) ) ) ) ).

% divide_self_if
tff(fact_1106_divide__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( divide_divide(A,A3,A3) = one_one(A) ) ) ) ).

% divide_self
tff(fact_1107_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( one_one(A) = divide_divide(A,A3,B2) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A3 = B2 ) ) ) ) ).

% one_eq_divide_iff
tff(fact_1108_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( divide_divide(A,A3,B2) = one_one(A) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A3 = B2 ) ) ) ) ).

% divide_eq_1_iff
tff(fact_1109_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3) ) ) ).

% uminus_add_conv_diff
tff(fact_1110_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) ) ) ).

% diff_minus_eq_add
tff(fact_1111_divide__minus1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A] : ( divide_divide(A,X,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),X) ) ) ).

% divide_minus1
tff(fact_1112_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A3: A,A4: set(A)] :
      ( ( aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))) = aa(set(A),set(A),insert2(A,A3),A4) )
    <=> ( ( A3 = B2 )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))) ) ) ).

% singleton_insert_inj_eq
tff(fact_1113_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A3: A,A4: set(A),B2: A] :
      ( ( aa(set(A),set(A),insert2(A,A3),A4) = aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))) )
    <=> ( ( A3 = B2 )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))) ) ) ).

% singleton_insert_inj_eq'
tff(fact_1114_disjoint__insert_I2_J,axiom,
    ! [A: $tType,A4: set(A),B2: A,B3: set(A)] :
      ( ( bot_bot(set(A)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),insert2(A,B2),B3)) )
    <=> ( ~ pp(member(A,B2,A4))
        & ( bot_bot(set(A)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) ) ) ) ).

% disjoint_insert(2)
tff(fact_1115_disjoint__insert_I1_J,axiom,
    ! [A: $tType,B3: set(A),A3: A,A4: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),aa(set(A),set(A),insert2(A,A3),A4)) = bot_bot(set(A)) )
    <=> ( ~ pp(member(A,A3,B3))
        & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),A4) = bot_bot(set(A)) ) ) ) ).

% disjoint_insert(1)
tff(fact_1116_insert__disjoint_I2_J,axiom,
    ! [A: $tType,A3: A,A4: set(A),B3: set(A)] :
      ( ( bot_bot(set(A)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert2(A,A3),A4)),B3) )
    <=> ( ~ pp(member(A,A3,B3))
        & ( bot_bot(set(A)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) ) ) ) ).

% insert_disjoint(2)
tff(fact_1117_insert__disjoint_I1_J,axiom,
    ! [A: $tType,A3: A,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert2(A,A3),A4)),B3) = bot_bot(set(A)) )
    <=> ( ~ pp(member(A,A3,B3))
        & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) ) ) ) ).

% insert_disjoint(1)
tff(fact_1118_insert__Diff__single,axiom,
    ! [A: $tType,A3: A,A4: set(A)] : ( aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))) = aa(set(A),set(A),insert2(A,A3),A4) ) ).

% insert_Diff_single
tff(fact_1119_divide__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] : ( divide_divide(A,A3,aa(A,A,sgn_sgn(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% divide_sgn
tff(fact_1120_the__elem__eq,axiom,
    ! [A: $tType,X: A] : ( the_elem(A,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = X ) ).

% the_elem_eq
tff(fact_1121_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),divide_divide(A,one_one(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% zero_le_divide_1_iff
tff(fact_1122_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,one_one(A),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ).

% divide_le_0_1_iff
tff(fact_1123_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),divide_divide(A,one_one(A),A3)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ).

% zero_less_divide_1_iff
tff(fact_1124_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),divide_divide(A,B2,A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% less_divide_eq_1_pos
tff(fact_1125_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),divide_divide(A,B2,A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ).

% less_divide_eq_1_neg
tff(fact_1126_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,B2,A3)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ).

% divide_less_eq_1_pos
tff(fact_1127_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,B2,A3)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ).

% divide_less_eq_1_neg
tff(fact_1128_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,one_one(A),A3)),zero_zero(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ).

% divide_less_0_1_iff
tff(fact_1129_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% add_neg_numeral_special(7)
tff(fact_1130_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = zero_zero(A) ) ) ).

% add_neg_numeral_special(8)
tff(fact_1131_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = divide_divide(A,one_one(A),B2) ) ) ) ).

% nonzero_divide_mult_cancel_left
tff(fact_1132_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,B2,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = divide_divide(A,one_one(A),A3) ) ) ) ).

% nonzero_divide_mult_cancel_right
tff(fact_1133_subset__Compl__singleton,axiom,
    ! [A: $tType,A4: set(A),B2: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))))
    <=> ~ pp(member(A,B2,A4)) ) ).

% subset_Compl_singleton
tff(fact_1134_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,B2,A3)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% divide_le_eq_1_neg
tff(fact_1135_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,B2,A3)),one_one(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% divide_le_eq_1_pos
tff(fact_1136_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),divide_divide(A,B2,A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ).

% le_divide_eq_1_neg
tff(fact_1137_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),divide_divide(A,B2,A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ).

% le_divide_eq_1_pos
tff(fact_1138_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
tff(fact_1139_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
tff(fact_1140_ab__semigroup__add__class_Oadd_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% ab_semigroup_add_class.add.left_commute
tff(fact_1141_ab__semigroup__add__class_Oadd_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) ) ) ).

% ab_semigroup_add_class.add.commute
tff(fact_1142_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3) )
        <=> ( B2 = C2 ) ) ) ).

% add.right_cancel
tff(fact_1143_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2) )
        <=> ( B2 = C2 ) ) ) ).

% add.left_cancel
tff(fact_1144_add_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add.assoc
tff(fact_1145_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) ) ) ) ).

% group_cancel.add2
tff(fact_1146_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: A,K: A,A3: A,B2: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A3) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) ) ) ) ).

% group_cancel.add1
tff(fact_1147_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( I = J2 )
            & ( K = L ) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
tff(fact_1148_add_Oright__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),B2) ) ) ).

% add.right_commute
tff(fact_1149_add_Oright__assoc,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add.right_assoc
tff(fact_1150_ordering__top_Oextremum__uniqueI,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A,A3: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,Top),A3))
       => ( A3 = Top ) ) ) ).

% ordering_top.extremum_uniqueI
tff(fact_1151_ordering__top_Onot__eq__extremum,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A,A3: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ( ( A3 != Top )
      <=> pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),Top)) ) ) ).

% ordering_top.not_eq_extremum
tff(fact_1152_ordering__top_Oextremum__unique,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A,A3: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,Top),A3))
      <=> ( A3 = Top ) ) ) ).

% ordering_top.extremum_unique
tff(fact_1153_ordering__top_Oextremum__strict,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A,A3: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,Top),A3)) ) ).

% ordering_top.extremum_strict
tff(fact_1154_ordering__top_Oextremum,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A,A3: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),Top)) ) ).

% ordering_top.extremum
tff(fact_1155_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A3,Z2)),B2) = B2 ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A3,Z2)),B2) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z2)),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(2)
tff(fact_1156_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),divide_divide(A,B2,Z2)) = A3 ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),divide_divide(A,B2,Z2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),Z2)),B2),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(1)
tff(fact_1157_add__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,X,Y)),divide_divide(A,W2,Z2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)) ) ) ) ) ).

% add_frac_eq
tff(fact_1158_add__frac__num,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,X: A,Z2: A] :
          ( ( Y != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,X,Y)),Z2) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)),Y) ) ) ) ).

% add_frac_num
tff(fact_1159_add__num__frac,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z2: A,X: A] :
          ( ( Y != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),divide_divide(A,X,Y)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)),Y) ) ) ) ).

% add_num_frac
tff(fact_1160_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),divide_divide(A,Y,Z2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2)),Y),Z2) ) ) ) ).

% add_divide_eq_iff
tff(fact_1161_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,X,Z2)),Y) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)),Z2) ) ) ) ).

% divide_add_eq_iff
tff(fact_1162_less__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A))))) ) ) ).

% less_half_sum
tff(fact_1163_gt__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))),B2)) ) ) ).

% gt_half_sum
tff(fact_1164_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% add_le_imp_le_right
tff(fact_1165_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% add_le_imp_le_left
tff(fact_1166_le__iff__add,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ? [C5: A] : ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C5) ) ) ) ).

% le_iff_add
tff(fact_1167_add__right__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))) ) ) ).

% add_right_mono
tff(fact_1168_less__eqE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ~ ! [C4: A] : ( B2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C4) ) ) ) ).

% less_eqE
tff(fact_1169_add__left__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))) ) ) ).

% add_left_mono
tff(fact_1170_add__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2))) ) ) ) ).

% add_mono
tff(fact_1171_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),J2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_semiring(1)
tff(fact_1172_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( I = J2 )
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_semiring(2)
tff(fact_1173_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),J2))
            & ( K = L ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_semiring(3)
tff(fact_1174_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A3) = A3 ) ) ).

% add.group_left_neutral
tff(fact_1175_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),zero_zero(A)) = A3 ) ) ).

% add.comm_neutral
tff(fact_1176_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A3) = A3 ) ) ).

% comm_monoid_add_class.add_0
tff(fact_1177_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,Y: A,Z2: A,W2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,X,Y)),divide_divide(A,Z2,W2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2),aa(A,A,aa(A,fun(A,A),times_times(A),Y),W2)) ) ) ).

% times_divide_times_eq
tff(fact_1178_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,Y: A,Z2: A,W2: A] : ( divide_divide(A,divide_divide(A,X,Y),divide_divide(A,Z2,W2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),X),W2),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)) ) ) ).

% divide_divide_times_eq
tff(fact_1179_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,C2: A] : ( divide_divide(A,divide_divide(A,A3,B2),C2) = divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% divide_divide_eq_left'
tff(fact_1180_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% add_less_imp_less_right
tff(fact_1181_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% add_less_imp_less_left
tff(fact_1182_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))) ) ) ).

% add_strict_right_mono
tff(fact_1183_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))) ) ) ).

% add_strict_left_mono
tff(fact_1184_add__strict__mono,axiom,
    ! [A: $tType] :
      ( strict9044650504122735259up_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2))) ) ) ) ).

% add_strict_mono
tff(fact_1185_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I),J2))
            & ( K = L ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_field(1)
tff(fact_1186_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( I = J2 )
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_field(2)
tff(fact_1187_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I),J2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_field(5)
tff(fact_1188_singleton__inject,axiom,
    ! [A: $tType,A3: A,B2: A] :
      ( ( aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) = aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))) )
     => ( A3 = B2 ) ) ).

% singleton_inject
tff(fact_1189_insert__not__empty,axiom,
    ! [A: $tType,A3: A,A4: set(A)] : ( aa(set(A),set(A),insert2(A,A3),A4) != bot_bot(set(A)) ) ).

% insert_not_empty
tff(fact_1190_doubleton__eq__iff,axiom,
    ! [A: $tType,A3: A,B2: A,C2: A,D2: A] :
      ( ( aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))) = aa(set(A),set(A),insert2(A,C2),aa(set(A),set(A),insert2(A,D2),bot_bot(set(A)))) )
    <=> ( ( ( A3 = C2 )
          & ( B2 = D2 ) )
        | ( ( A3 = D2 )
          & ( B2 = C2 ) ) ) ) ).

% doubleton_eq_iff
tff(fact_1191_singleton__iff,axiom,
    ! [A: $tType,B2: A,A3: A] :
      ( pp(member(A,B2,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))
    <=> ( B2 = A3 ) ) ).

% singleton_iff
tff(fact_1192_singletonD,axiom,
    ! [A: $tType,B2: A,A3: A] :
      ( pp(member(A,B2,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))
     => ( B2 = A3 ) ) ).

% singletonD
tff(fact_1193_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% ring_class.ring_distribs(2)
tff(fact_1194_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ).

% ring_class.ring_distribs(1)
tff(fact_1195_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( comm_semiring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% comm_semiring_class.distrib
tff(fact_1196_distrib__left,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ).

% distrib_left
tff(fact_1197_distrib__right,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% distrib_right
tff(fact_1198_combine__common__factor,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A3: A,E2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),E2)),C2) ) ) ).

% combine_common_factor
tff(fact_1199_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% diff_diff_eq
tff(fact_1200_add__implies__diff,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [C2: A,B2: A,A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2) = A3 )
         => ( C2 = aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) ) ) ) ).

% add_implies_diff
tff(fact_1201_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2)),B2) ) ) ).

% diff_add_eq_diff_diff_swap
tff(fact_1202_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),B2) ) ) ).

% diff_add_eq
tff(fact_1203_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),B2) ) ) ).

% diff_diff_eq2
tff(fact_1204_add__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) ) ) ).

% add_diff_eq
tff(fact_1205_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,C2: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = C2 ) ) ) ).

% eq_diff_eq
tff(fact_1206_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = C2 )
        <=> ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2) ) ) ) ).

% diff_eq_eq
tff(fact_1207_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A,K: A,A3: A,B2: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A3) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A4),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) ) ) ) ).

% group_cancel.sub1
tff(fact_1208_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A3)) ) ) ).

% add.inverse_distrib_swap
tff(fact_1209_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A4: A,K: A,A3: A] :
          ( ( A4 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A3) )
         => ( aa(A,A,uminus_uminus(A),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,uminus_uminus(A),A3)) ) ) ) ).

% group_cancel.neg1
tff(fact_1210_Int__insert__left,axiom,
    ! [A: $tType,A3: A,C3: set(A),B3: set(A)] :
      ( ( pp(member(A,A3,C3))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert2(A,A3),B3)),C3) = aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3)) ) )
      & ( ~ pp(member(A,A3,C3))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),insert2(A,A3),B3)),C3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C3) ) ) ) ).

% Int_insert_left
tff(fact_1211_Int__insert__right,axiom,
    ! [A: $tType,A3: A,A4: set(A),B3: set(A)] :
      ( ( pp(member(A,A3,A4))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),insert2(A,A3),B3)) = aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) )
      & ( ~ pp(member(A,A3,A4))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(A),set(A),insert2(A,A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) ) ) ) ).

% Int_insert_right
tff(fact_1212_add_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( semigroup_add(A)
     => semigroup(A,plus_plus(A)) ) ).

% add.semigroup_axioms
tff(fact_1213_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),divide_divide(A,A3,Z2))),B2) = B2 ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),divide_divide(A,A3,Z2))),B2) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z2)),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(3)
tff(fact_1214_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),divide_divide(A,X,Z2))),Y) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)),Z2) ) ) ) ).

% minus_divide_add_eq_iff
tff(fact_1215_add_Osafe__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [X: A,Y: A,A3: A,B2: A] :
          ( syntax7388354845996824322omatch(A,A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y),A3)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3) ) ) ) ).

% add.safe_commute
tff(fact_1216_scaling__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [U: A,V: A,R3: A,S: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),V))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),R3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),R3),S))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),U),divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),R3),aa(A,A,aa(A,fun(A,A),minus_minus(A),V),U)),S))),V)) ) ) ) ) ).

% scaling_mono
tff(fact_1217_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z2 != zero_zero(A) )
           => ( ( divide_divide(A,X,Y) = divide_divide(A,W2,Z2) )
            <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2) = aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y) ) ) ) ) ) ).

% frac_eq_eq
tff(fact_1218_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A3: A] :
          ( ( divide_divide(A,B2,C2) = A3 )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq
tff(fact_1219_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = divide_divide(A,B2,C2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = B2 ) )
            & ( ( C2 = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq
tff(fact_1220_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) )
           => ( divide_divide(A,B2,C2) = A3 ) ) ) ) ).

% divide_eq_imp
tff(fact_1221_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = B2 )
           => ( A3 = divide_divide(A,B2,C2) ) ) ) ) ).

% eq_divide_imp
tff(fact_1222_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( divide_divide(A,B2,C2) = A3 )
          <=> ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) ) ) ) ) ).

% nonzero_divide_eq_eq
tff(fact_1223_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( A3 = divide_divide(A,B2,C2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
tff(fact_1224_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( divide_divide(A,A3,B2) = one_one(A) )
          <=> ( A3 = B2 ) ) ) ) ).

% right_inverse_eq
tff(fact_1225_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),zero_zero(A)))
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y) = zero_zero(A) )
            <=> ( ( X = zero_zero(A) )
                & ( Y = zero_zero(A) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
tff(fact_1226_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),Y))
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y) = zero_zero(A) )
            <=> ( ( X = zero_zero(A) )
                & ( Y = zero_zero(A) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
tff(fact_1227_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),zero_zero(A))) ) ) ) ).

% add_nonpos_nonpos
tff(fact_1228_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))) ) ) ) ).

% add_nonneg_nonneg
tff(fact_1229_add__increasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2))) ) ) ) ).

% add_increasing2
tff(fact_1230_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),B2)) ) ) ) ).

% add_decreasing2
tff(fact_1231_add__increasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2))) ) ) ) ).

% add_increasing
tff(fact_1232_add__decreasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),B2)) ) ) ) ).

% add_decreasing
tff(fact_1233_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),I),J2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_field(4)
tff(fact_1234_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),I),J2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K),L)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J2),L))) ) ) ).

% add_mono_thms_linordered_field(3)
tff(fact_1235_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2))) ) ) ) ).

% add_le_less_mono
tff(fact_1236_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2))) ) ) ) ).

% add_less_le_mono
tff(fact_1237_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),zero_zero(A))) ) ) ) ).

% add_neg_neg
tff(fact_1238_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))) ) ) ) ).

% add_pos_pos
tff(fact_1239_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ~ ! [C4: A] :
                ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C4) )
               => ( C4 = zero_zero(A) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
tff(fact_1240_pos__add__strict,axiom,
    ! [A: $tType] :
      ( strict7427464778891057005id_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2))) ) ) ) ).

% pos_add_strict
tff(fact_1241_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3) = C2 )
            <=> ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
tff(fact_1242_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)) = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
tff(fact_1243_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),B2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
tff(fact_1244_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),C2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
tff(fact_1245_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A3) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
tff(fact_1246_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
tff(fact_1247_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)),A3) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
tff(fact_1248_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A3)),B2)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
tff(fact_1249_le__add__diff,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A3))) ) ) ).

% le_add_diff
tff(fact_1250_ordered__cancel__comm__monoid__diff__class_Odiff__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),A3) = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add
tff(fact_1251_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2)) ) ) ).

% le_diff_eq
tff(fact_1252_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))) ) ) ).

% diff_le_eq
tff(fact_1253_less__add__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A)))) ) ).

% less_add_one
tff(fact_1254_add__mono1,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),one_one(A)))) ) ) ).

% add_mono1
tff(fact_1255_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2)) ) ) ).

% less_diff_eq
tff(fact_1256_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))) ) ) ).

% diff_less_eq
tff(fact_1257_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A3) = B2 )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = zero_zero(A) ) ) ) ).

% neg_eq_iff_add_eq_0
tff(fact_1258_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,uminus_uminus(A),B2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = zero_zero(A) ) ) ) ).

% eq_neg_iff_add_eq_0
tff(fact_1259_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = zero_zero(A) )
         => ( aa(A,A,uminus_uminus(A),A3) = B2 ) ) ) ).

% add.inverse_unique
tff(fact_1260_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A3)),A3) = zero_zero(A) ) ) ).

% ab_group_add_class.ab_left_minus
tff(fact_1261_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = zero_zero(A) )
        <=> ( B2 = aa(A,A,uminus_uminus(A),A3) ) ) ) ).

% add_eq_0_iff
tff(fact_1262_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),E2)),C2) = D2 ) ) ) ).

% eq_add_iff1
tff(fact_1263_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2) )
        <=> ( C2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),E2)),D2) ) ) ) ).

% eq_add_iff2
tff(fact_1264_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( comm_ring(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)) ) ) ).

% square_diff_square_factored
tff(fact_1265_subset__singletonD,axiom,
    ! [A: $tType,A4: set(A),X: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))
     => ( ( A4 = bot_bot(set(A)) )
        | ( A4 = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ) ) ).

% subset_singletonD
tff(fact_1266_subset__singleton__iff,axiom,
    ! [A: $tType,X6: set(A),A3: A] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X6),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))
    <=> ( ( X6 = bot_bot(set(A)) )
        | ( X6 = aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) ) ) ) ).

% subset_singleton_iff
tff(fact_1267_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
tff(fact_1268_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% diff_conv_add_uminus
tff(fact_1269_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B3: A,K: A,B2: A,A3: A] :
          ( ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) ) ) ) ).

% group_cancel.sub2
tff(fact_1270_singleton__Un__iff,axiom,
    ! [A: $tType,X: A,A4: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3) )
    <=> ( ( ( A4 = bot_bot(set(A)) )
          & ( B3 = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) )
        | ( ( A4 = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) )
          & ( B3 = bot_bot(set(A)) ) )
        | ( ( A4 = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) )
          & ( B3 = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ) ) ) ).

% singleton_Un_iff
tff(fact_1271_Un__singleton__iff,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),X: A] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) )
    <=> ( ( ( A4 = bot_bot(set(A)) )
          & ( B3 = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) )
        | ( ( A4 = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) )
          & ( B3 = bot_bot(set(A)) ) )
        | ( ( A4 = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) )
          & ( B3 = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ) ) ) ).

% Un_singleton_iff
tff(fact_1272_insert__is__Un,axiom,
    ! [A: $tType,A3: A,A4: set(A)] : ( aa(set(A),set(A),insert2(A,A3),A4) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))),A4) ) ).

% insert_is_Un
tff(fact_1273_Diff__insert,axiom,
    ! [A: $tType,A4: set(A),A3: A,B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) ) ).

% Diff_insert
tff(fact_1274_insert__Diff,axiom,
    ! [A: $tType,A3: A,A4: set(A)] :
      ( pp(member(A,A3,A4))
     => ( aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))) = A4 ) ) ).

% insert_Diff
tff(fact_1275_Diff__insert2,axiom,
    ! [A: $tType,A4: set(A),A3: A,B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))),B3) ) ).

% Diff_insert2
tff(fact_1276_Diff__insert__absorb,axiom,
    ! [A: $tType,X: A,A4: set(A)] :
      ( ~ pp(member(A,X,A4))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert2(A,X),A4)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = A4 ) ) ).

% Diff_insert_absorb
tff(fact_1277_insert__minus__eq,axiom,
    ! [A: $tType,X: A,Y: A,A4: set(A)] :
      ( ( X != Y )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert2(A,X),A4)),aa(set(A),set(A),insert2(A,Y),bot_bot(set(A)))) = aa(set(A),set(A),insert2(A,X),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,Y),bot_bot(set(A))))) ) ) ).

% insert_minus_eq
tff(fact_1278_set__minus__singleton__eq,axiom,
    ! [A: $tType,X: A,X6: set(A)] :
      ( ~ pp(member(A,X,X6))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),X6),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = X6 ) ) ).

% set_minus_singleton_eq
tff(fact_1279_in__image__insert__iff,axiom,
    ! [A: $tType,B3: set(set(A)),X: A,A4: set(A)] :
      ( ! [C6: set(A)] :
          ( pp(member(set(A),C6,B3))
         => ~ pp(member(A,X,C6)) )
     => ( pp(member(set(A),A4,aa(set(set(A)),set(set(A)),image2(set(A),set(A),insert2(A,X)),B3)))
      <=> ( pp(member(A,X,A4))
          & pp(member(set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))),B3)) ) ) ) ).

% in_image_insert_iff
tff(fact_1280_translation__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,S: set(A),T4: set(A)] : ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),plus_plus(A),A3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T4)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),plus_plus(A),A3)),S)),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),plus_plus(A),A3)),T4)) ) ) ).

% translation_Int
tff(fact_1281_add_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => monoid(A,plus_plus(A),zero_zero(A)) ) ).

% add.monoid_axioms
tff(fact_1282_effect__bindI,axiom,
    ! [B: $tType,A: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat,G: fun(A,heap_Time_Heap(B)),H6: heap_ext(product_unit),R4: B,N2: nat] :
      ( heap_Time_effect(A,F,H2,H4,R3,N)
     => ( heap_Time_effect(B,aa(A,heap_Time_Heap(B),G,R3),H4,H6,R4,N2)
       => heap_Time_effect(B,heap_Time_bind(A,B,F,G),H2,H6,R4,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N2)) ) ) ).

% effect_bindI
tff(fact_1283_effect__bindE,axiom,
    ! [B: $tType,A: $tType,F: heap_Time_Heap(B),G: fun(B,heap_Time_Heap(A)),H2: heap_ext(product_unit),H6: heap_ext(product_unit),R4: A,N: nat] :
      ( heap_Time_effect(A,heap_Time_bind(B,A,F,G),H2,H6,R4,N)
     => ~ ! [H5: heap_ext(product_unit),R2: B,N1: nat] :
            ( heap_Time_effect(B,F,H2,H5,R2,N1)
           => ! [N22: nat] :
                ( heap_Time_effect(A,aa(B,heap_Time_Heap(A),G,R2),H5,H6,R4,N22)
               => ( N != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N1),N22) ) ) ) ) ).

% effect_bindE
tff(fact_1284_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X: A] : ( neg_numeral_dbl_inc(A,X) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),X)),one_one(A)) ) ) ).

% dbl_inc_def
tff(fact_1285_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
         => ( divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,divide_divide(A,A3,B2),C2) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
tff(fact_1286_divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,B2,C2)),A3))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ) ) ) ) ).

% divide_less_eq
tff(fact_1287_less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),divide_divide(A,B2,C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ) ) ) ) ).

% less_divide_eq
tff(fact_1288_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,B2,C2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) ) ) ) ).

% neg_divide_less_eq
tff(fact_1289_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),divide_divide(A,B2,C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% neg_less_divide_eq
tff(fact_1290_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,B2,C2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% pos_divide_less_eq
tff(fact_1291_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),divide_divide(A,B2,C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) ) ) ) ).

% pos_less_divide_eq
tff(fact_1292_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,X: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,X,Y)),Z2)) ) ) ) ).

% mult_imp_div_pos_less
tff(fact_1293_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z2: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)),X))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),divide_divide(A,X,Y))) ) ) ) ).

% mult_imp_less_div_pos
tff(fact_1294_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,C2,A3)),divide_divide(A,C2,B2))) ) ) ) ) ).

% divide_strict_left_mono
tff(fact_1295_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,C2,A3)),divide_divide(A,C2,B2))) ) ) ) ) ).

% divide_strict_left_mono_neg
tff(fact_1296_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),divide_divide(A,B2,A3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) ) ) ) ) ).

% less_divide_eq_1
tff(fact_1297_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,B2,A3)),one_one(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) )
            | ( A3 = zero_zero(A) ) ) ) ) ).

% divide_less_eq_1
tff(fact_1298_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),divide_divide(A,B2,Z2)) = A3 ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),divide_divide(A,B2,Z2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),Z2)),B2),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(4)
tff(fact_1299_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,X,Y)),divide_divide(A,W2,Z2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)) ) ) ) ) ).

% diff_frac_eq
tff(fact_1300_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),X),divide_divide(A,Y,Z2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2)),Y),Z2) ) ) ) ).

% diff_divide_eq_iff
tff(fact_1301_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,X,Z2)),Y) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)),Z2) ) ) ) ).

% divide_diff_eq_iff
tff(fact_1302_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),zero_zero(A))) ) ) ) ).

% add_neg_nonpos
tff(fact_1303_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))) ) ) ) ).

% add_nonneg_pos
tff(fact_1304_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),zero_zero(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),zero_zero(A))) ) ) ) ).

% add_nonpos_neg
tff(fact_1305_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))) ) ) ) ).

% add_pos_nonneg
tff(fact_1306_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2))) ) ) ) ).

% add_strict_increasing
tff(fact_1307_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2))) ) ) ) ).

% add_strict_increasing2
tff(fact_1308_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X: A,Y: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)))) ) ).

% sum_squares_ge_zero
tff(fact_1309_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2)) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) = aa(A,A,uminus_uminus(A),B2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% eq_minus_divide_eq
tff(fact_1310_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A3: A] :
          ( ( aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2)) = A3 )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,uminus_uminus(A),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% minus_divide_eq_eq
tff(fact_1311_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( aa(A,A,uminus_uminus(A),divide_divide(A,A3,B2)) = C2 )
          <=> ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
tff(fact_1312_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( C2 = aa(A,A,uminus_uminus(A),divide_divide(A,A3,B2)) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) = aa(A,A,uminus_uminus(A),A3) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
tff(fact_1313_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( divide_divide(A,A3,B2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A3 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ).

% divide_eq_minus_1_iff
tff(fact_1314_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [X: A,Y: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))),zero_zero(A))) ) ).

% not_sum_squares_lt_zero
tff(fact_1315_discrete,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),B2)) ) ) ).

% discrete
tff(fact_1316_zero__less__two,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))) ) ).

% zero_less_two
tff(fact_1317_le__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),E2)),D2))) ) ) ).

% le_add_iff2
tff(fact_1318_le__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),E2)),C2)),D2)) ) ) ).

% le_add_iff1
tff(fact_1319_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)),E2)),D2))) ) ) ).

% less_add_iff2
tff(fact_1320_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A3: A,E2: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),E2)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E2)),D2)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),E2)),C2)),D2)) ) ) ).

% less_add_iff1
tff(fact_1321_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),one_one(A))) ) ) ).

% square_diff_one_factored
tff(fact_1322_range__eq__singletonD,axiom,
    ! [B: $tType,A: $tType,F: fun(B,A),A3: A,X: B] :
      ( ( aa(set(B),set(A),image2(B,A,F),top_top(set(B))) = aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) )
     => ( aa(B,A,F,X) = A3 ) ) ).

% range_eq_singletonD
tff(fact_1323_Diff__single__insert,axiom,
    ! [A: $tType,A4: set(A),X: A,B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))),B3))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),insert2(A,X),B3))) ) ).

% Diff_single_insert
tff(fact_1324_subset__insert__iff,axiom,
    ! [A: $tType,A4: set(A),X: A,B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),insert2(A,X),B3)))
    <=> ( ( pp(member(A,X,A4))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))),B3)) )
        & ( ~ pp(member(A,X,A4))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3)) ) ) ) ).

% subset_insert_iff
tff(fact_1325_remove__subset,axiom,
    ! [A: $tType,X: A,S2: set(A)] :
      ( pp(member(A,X,S2))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))),S2)) ) ).

% remove_subset
tff(fact_1326_Compl__insert,axiom,
    ! [A: $tType,X: A,A4: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert2(A,X),A4)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A4)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) ) ).

% Compl_insert
tff(fact_1327_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [X: A] : ( neg_numeral_dbl_dec(A,X) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),X)),one_one(A)) ) ) ).

% dbl_dec_def
tff(fact_1328_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),zero_zero(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,C2,A3)),divide_divide(A,C2,B2))) ) ) ) ) ).

% divide_left_mono_neg
tff(fact_1329_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z2: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)),X))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),divide_divide(A,X,Y))) ) ) ) ).

% mult_imp_le_div_pos
tff(fact_1330_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,X: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Y))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),Y)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,X,Y)),Z2)) ) ) ) ).

% mult_imp_div_pos_le
tff(fact_1331_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),divide_divide(A,B2,C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) ) ) ) ).

% pos_le_divide_eq
tff(fact_1332_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,B2,C2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% pos_divide_le_eq
tff(fact_1333_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),divide_divide(A,B2,C2)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% neg_le_divide_eq
tff(fact_1334_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,B2,C2)),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) ) ) ) ).

% neg_divide_le_eq
tff(fact_1335_divide__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,C2,A3)),divide_divide(A,C2,B2))) ) ) ) ) ).

% divide_left_mono
tff(fact_1336_le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),divide_divide(A,B2,C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) ) ) ) ) ) ) ).

% le_divide_eq
tff(fact_1337_divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,B2,C2)),A3))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ) ) ) ) ).

% divide_le_eq
tff(fact_1338_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,B2,A3)),one_one(A)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) )
            | ( A3 = zero_zero(A) ) ) ) ) ).

% divide_le_eq_1
tff(fact_1339_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),divide_divide(A,B2,A3)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) )
            | ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
              & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ) ) ).

% le_divide_eq_1
tff(fact_1340_frac__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z2 != zero_zero(A) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,X,Y)),divide_divide(A,W2,Z2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2))),zero_zero(A))) ) ) ) ) ).

% frac_le_eq
tff(fact_1341_frac__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z2: A,X: A,W2: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z2 != zero_zero(A) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,X,Y)),divide_divide(A,W2,Z2)))
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2))),zero_zero(A))) ) ) ) ) ).

% frac_less_eq
tff(fact_1342_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ) ) ) ) ).

% less_minus_divide_eq
tff(fact_1343_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A3))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3)) ) ) ) ) ) ) ).

% minus_divide_less_eq
tff(fact_1344_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% neg_less_minus_divide_eq
tff(fact_1345_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% neg_minus_divide_less_eq
tff(fact_1346_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,uminus_uminus(A),B2))) ) ) ) ).

% pos_less_minus_divide_eq
tff(fact_1347_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A3))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2))) ) ) ) ).

% pos_minus_divide_less_eq
tff(fact_1348_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),divide_divide(A,A3,Z2))),B2) = aa(A,A,uminus_uminus(A),B2) ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),divide_divide(A,A3,Z2))),B2) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z2)),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(6)
tff(fact_1349_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2 = zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,A3,Z2)),B2) = aa(A,A,uminus_uminus(A),B2) ) )
          & ( ( Z2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,A3,Z2)),B2) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z2)),Z2) ) ) ) ) ).

% add_divide_eq_if_simps(5)
tff(fact_1350_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),divide_divide(A,X,Z2))),Y) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z2)),Z2) ) ) ) ).

% minus_divide_diff_eq_iff
tff(fact_1351_convex__bound__le,axiom,
    ! [A: $tType] :
      ( linord6961819062388156250ring_1(A)
     => ! [X: A,A3: A,Y: A,U: A,V: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),U))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),V))
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),X)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y))),A3)) ) ) ) ) ) ) ).

% convex_bound_le
tff(fact_1352_psubset__insert__iff,axiom,
    ! [A: $tType,A4: set(A),X: A,B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A4),aa(set(A),set(A),insert2(A,X),B3)))
    <=> ( ( pp(member(A,X,B3))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A4),B3)) )
        & ( ~ pp(member(A,X,B3))
         => ( ( pp(member(A,X,A4))
             => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))),B3)) )
            & ( ~ pp(member(A,X,A4))
             => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3)) ) ) ) ) ) ).

% psubset_insert_iff
tff(fact_1353_div__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),divide_divide(A,A3,B2)) ) ) ) ).

% div_mult_self1
tff(fact_1354_div__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),divide_divide(A,A3,B2)) ) ) ) ).

% div_mult_self2
tff(fact_1355_div__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),divide_divide(A,A3,B2)) ) ) ) ).

% div_mult_self3
tff(fact_1356_div__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),divide_divide(A,A3,B2)) ) ) ) ).

% div_mult_self4
tff(fact_1357_div__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A] : ( divide_divide(A,A3,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),A3) ) ) ).

% div_minus1_right
tff(fact_1358_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = divide_divide(A,A3,B2) ) ) ) ).

% div_mult_mult1
tff(fact_1359_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,A3,B2) ) ) ) ).

% div_mult_mult2
tff(fact_1360_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( C2 = zero_zero(A) )
           => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = zero_zero(A) ) )
          & ( ( C2 != zero_zero(A) )
           => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = divide_divide(A,A3,B2) ) ) ) ) ).

% div_mult_mult1_if
tff(fact_1361_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] : ( divide_divide(A,A3,one_one(A)) = A3 ) ) ).

% bits_div_by_1
tff(fact_1362_div__add__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A3,B2)),one_one(A)) ) ) ) ).

% div_add_self1
tff(fact_1363_div__add__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A3,B2)),one_one(A)) ) ) ) ).

% div_add_self2
tff(fact_1364_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))))
        <=> ( ( X != zero_zero(A) )
            | ( Y != zero_zero(A) ) ) ) ) ).

% sum_squares_gt_zero_iff
tff(fact_1365_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))),zero_zero(A)))
        <=> ( ( X = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_squares_le_zero_iff
tff(fact_1366_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [R3: A,A3: A,B2: A,C2: A,D2: A] :
          ( ( R3 != zero_zero(A) )
         => ( ( ( A3 = B2 )
              & ( C2 != D2 ) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),R3),C2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),R3),D2)) ) ) ) ) ).

% add_scale_eq_noteq
tff(fact_1367_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)) = zero_zero(A) )
        <=> ( ( X = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_squares_eq_zero_iff
tff(fact_1368_is__singleton__the__elem,axiom,
    ! [A: $tType,A4: set(A)] :
      ( is_singleton(A,A4)
    <=> ( A4 = aa(set(A),set(A),insert2(A,the_elem(A,A4)),bot_bot(set(A))) ) ) ).

% is_singleton_the_elem
tff(fact_1369_is__singletonI,axiom,
    ! [A: $tType,X: A] : is_singleton(A,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) ).

% is_singletonI
tff(fact_1370_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [W2: A,Y: A,X: A,Z2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),X),Z2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W2),Z2)),aa(A,A,aa(A,fun(A,A),times_times(A),X),Y)) )
        <=> ( ( W2 = X )
            | ( Y = Z2 ) ) ) ) ).

% crossproduct_eq
tff(fact_1371_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( ( A3 != B2 )
            & ( C2 != D2 ) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),D2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% crossproduct_noteq
tff(fact_1372_is__singletonI_H,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ( A4 != bot_bot(set(A)) )
     => ( ! [X2: A,Y2: A] :
            ( pp(member(A,X2,A4))
           => ( pp(member(A,Y2,A4))
             => ( X2 = Y2 ) ) )
       => is_singleton(A,A4) ) ) ).

% is_singletonI'
tff(fact_1373_is__singletonE,axiom,
    ! [A: $tType,A4: set(A)] :
      ( is_singleton(A,A4)
     => ~ ! [X2: A] : ( A4 != aa(set(A),set(A),insert2(A,X2),bot_bot(set(A))) ) ) ).

% is_singletonE
tff(fact_1374_is__singleton__def,axiom,
    ! [A: $tType,A4: set(A)] :
      ( is_singleton(A,A4)
    <=> ? [X4: A] : ( A4 = aa(set(A),set(A),insert2(A,X4),bot_bot(set(A))) ) ) ).

% is_singleton_def
tff(fact_1375_remove__def,axiom,
    ! [A: $tType,X: A,A4: set(A)] : ( aa(set(A),set(A),aa(A,fun(set(A),set(A)),remove(A),X),A4) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) ) ).

% remove_def
tff(fact_1376_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,B2,C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
tff(fact_1377_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W2: num,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),divide_divide(A,B2,C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),zero_zero(A))) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
tff(fact_1378_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ring(A)
     => ! [X: B,Y: B,A3: A,B2: A,C2: A] :
          ( nO_MATCH(B,A,divide_divide(B,X,Y),A3)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ) ).

% right_diff_distrib_NO_MATCH
tff(fact_1379_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ring(A)
     => ! [X: B,Y: B,C2: A,A3: A,B2: A] :
          ( nO_MATCH(B,A,divide_divide(B,X,Y),C2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% left_diff_distrib_NO_MATCH
tff(fact_1380_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring(A)
     => ! [X: B,Y: B,C2: A,A3: A,B2: A] :
          ( nO_MATCH(B,A,divide_divide(B,X,Y),C2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% distrib_right_NO_MATCH
tff(fact_1381_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring(A)
     => ! [X: B,Y: B,A3: A,B2: A,C2: A] :
          ( nO_MATCH(B,A,divide_divide(B,X,Y),A3)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)) ) ) ) ).

% distrib_left_NO_MATCH
tff(fact_1382_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel(A)
        & field(B) )
     => ! [X: B,B2: A,A3: A] :
          ( nO_MATCH(B,A,X,B2)
         => ( ( B2 != zero_zero(A) )
           => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A3,B2)),one_one(A)) ) ) ) ) ).

% div_add_self1_no_field
tff(fact_1383_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [V: num,W2: num,Z2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),Z2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2))),Z2) ) ) ).

% mult_numeral_left_semiring_numeral
tff(fact_1384_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [M4: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),M4)),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M4),N)) ) ) ).

% numeral_times_numeral
tff(fact_1385_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [V: num,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% distrib_left_numeral
tff(fact_1386_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [A3: A,B2: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(num,A,numeral_numeral(A),V))) ) ) ).

% distrib_right_numeral
tff(fact_1387_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [V: num,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% right_diff_distrib_numeral
tff(fact_1388_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [A3: A,B2: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(num,A,numeral_numeral(A),V))) ) ) ).

% left_diff_distrib_numeral
tff(fact_1389_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M4: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M4),N)) ) ) ).

% mult_neg_numeral_simps(1)
tff(fact_1390_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M4: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M4),N))) ) ) ).

% mult_neg_numeral_simps(2)
tff(fact_1391_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M4: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),M4)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M4),N))) ) ) ).

% mult_neg_numeral_simps(3)
tff(fact_1392_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W2: num,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,B2,aa(num,A,numeral_numeral(A),W2))),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W2)))) ) ) ).

% divide_le_eq_numeral1(1)
tff(fact_1393_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),divide_divide(A,B2,aa(num,A,numeral_numeral(A),W2))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W2))),B2)) ) ) ).

% le_divide_eq_numeral1(1)
tff(fact_1394_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,W2: num,A3: A] :
          ( ( divide_divide(A,B2,aa(num,A,numeral_numeral(A),W2)) = A3 )
        <=> ( ( ( aa(num,A,numeral_numeral(A),W2) != zero_zero(A) )
             => ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W2)) ) )
            & ( ( aa(num,A,numeral_numeral(A),W2) = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
tff(fact_1395_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,W2: num] :
          ( ( A3 = divide_divide(A,B2,aa(num,A,numeral_numeral(A),W2)) )
        <=> ( ( ( aa(num,A,numeral_numeral(A),W2) != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W2)) = B2 ) )
            & ( ( aa(num,A,numeral_numeral(A),W2) = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
tff(fact_1396_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W2: num,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,B2,aa(num,A,numeral_numeral(A),W2))),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W2)))) ) ) ).

% divide_less_eq_numeral1(1)
tff(fact_1397_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),divide_divide(A,B2,aa(num,A,numeral_numeral(A),W2))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),W2))),B2)) ) ) ).

% less_divide_eq_numeral1(1)
tff(fact_1398_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W2: num,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))),B2)) ) ) ).

% divide_le_eq_numeral1(2)
tff(fact_1399_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))))) ) ) ).

% le_divide_eq_numeral1(2)
tff(fact_1400_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,W2: num,A3: A] :
          ( ( divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) = A3 )
        <=> ( ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) != zero_zero(A) )
             => ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) ) )
            & ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
tff(fact_1401_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A,W2: num] :
          ( ( A3 = divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) )
        <=> ( ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) = B2 ) )
            & ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) = zero_zero(A) )
             => ( A3 = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
tff(fact_1402_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W2: num,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))),B2)) ) ) ).

% divide_less_eq_numeral1(2)
tff(fact_1403_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))))) ) ) ).

% less_divide_eq_numeral1(2)
tff(fact_1404_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel(A)
        & field(B) )
     => ! [X: B,B2: A,A3: A] :
          ( nO_MATCH(B,A,X,B2)
         => ( ( B2 != zero_zero(A) )
           => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A3,B2)),one_one(A)) ) ) ) ) ).

% div_add_self2_no_field
tff(fact_1405_one__le__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(num,A,numeral_numeral(A),N))) ) ).

% one_le_numeral
tff(fact_1406_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),N)),one_one(A))) ) ).

% not_numeral_less_one
tff(fact_1407_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),X)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),X)),one_one(A)) ) ) ).

% one_plus_numeral_commute
tff(fact_1408_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),N) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% numeral_neq_neg_one
tff(fact_1409_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] : ( one_one(A) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) ) ) ).

% one_neq_neg_numeral
tff(fact_1410_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))),one_one(A))) ) ).

% neg_numeral_le_one
tff(fact_1411_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),M4))) ) ).

% neg_one_le_numeral
tff(fact_1412_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% neg_numeral_le_neg_one
tff(fact_1413_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),M4)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% not_numeral_le_neg_one
tff(fact_1414_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4)))) ) ).

% not_one_le_neg_numeral
tff(fact_1415_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,W2: num] :
          ( ( divide_divide(A,B2,C2) = aa(num,A,numeral_numeral(A),W2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(num,A,numeral_numeral(A),W2) = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
tff(fact_1416_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W2: num,B2: A,C2: A] :
          ( ( aa(num,A,numeral_numeral(A),W2) = divide_divide(A,B2,C2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2) = B2 ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(num,A,numeral_numeral(A),W2) = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
tff(fact_1417_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))),one_one(A))) ) ).

% neg_numeral_less_one
tff(fact_1418_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),M4))) ) ).

% neg_one_less_numeral
tff(fact_1419_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),M4)),aa(A,A,uminus_uminus(A),one_one(A)))) ) ).

% not_numeral_less_neg_one
tff(fact_1420_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4)))) ) ).

% not_one_less_neg_numeral
tff(fact_1421_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4)))) ) ).

% not_neg_one_less_neg_numeral
tff(fact_1422_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,B2,C2)),aa(num,A,numeral_numeral(A),W2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W2))) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
tff(fact_1423_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W2: num,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),W2)),divide_divide(A,B2,C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(num,A,numeral_numeral(A),W2)),zero_zero(A))) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
tff(fact_1424_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,W2: num] :
          ( ( divide_divide(A,B2,C2) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2) ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) = zero_zero(A) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
tff(fact_1425_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W2: num,B2: A,C2: A] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) = divide_divide(A,B2,C2) )
        <=> ( ( ( C2 != zero_zero(A) )
             => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2) = B2 ) )
            & ( ( C2 = zero_zero(A) )
             => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)) = zero_zero(A) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
tff(fact_1426_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W2: num,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),W2)),divide_divide(A,B2,C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),W2)),zero_zero(A))) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
tff(fact_1427_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,B2,C2)),aa(num,A,numeral_numeral(A),W2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W2))) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
tff(fact_1428_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W2: num,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),divide_divide(A,B2,C2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2)),B2)) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2))) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),zero_zero(A))) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
tff(fact_1429_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W2: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,B2,C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2))) )
            & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
             => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),C2)),B2)) )
                & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),zero_zero(A)))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2)))) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
tff(fact_1430_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W2: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2)))),Y) ) ) ).

% semiring_norm(170)
tff(fact_1431_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W2: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2)))),Y) ) ) ).

% semiring_norm(171)
tff(fact_1432_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W2: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2))),Y) ) ) ).

% semiring_norm(172)
tff(fact_1433_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [W2: num,X: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),aa(A,A,uminus_uminus(A),X)) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) ) ) ).

% numeral_times_minus_swap
tff(fact_1434_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M4: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M4)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),inc(M4)) ) ) ).

% diff_numeral_special(6)
tff(fact_1435_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(N))) ) ) ).

% diff_numeral_special(5)
tff(fact_1436_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M4: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(M4))) ) ) ).

% add_neg_numeral_special(6)
tff(fact_1437_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(N))) ) ) ).

% add_neg_numeral_special(5)
tff(fact_1438_numeral__inc,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [X: num] : ( aa(num,A,numeral_numeral(A),inc(X)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),X)),one_one(A)) ) ) ).

% numeral_inc
tff(fact_1439_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% diff_numeral_special(3)
tff(fact_1440_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M4: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M4),one2))) ) ) ).

% diff_numeral_special(4)
tff(fact_1441_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))),aa(A,A,uminus_uminus(A),one_one(A))))
        <=> ( M4 != one2 ) ) ) ).

% neg_numeral_less_neg_one_iff
tff(fact_1442_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M4: num] :
          ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))))
        <=> ( M4 != one2 ) ) ) ).

% not_neg_one_le_neg_numeral_iff
tff(fact_1443_prod__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B] : ( aa(product_prod(A,B),set(A),basic_fsts(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ).

% prod_set_simps(1)
tff(fact_1444_prod__set__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] : ( basic_snds(A,B,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)) = aa(set(B),set(B),insert2(B,Y),bot_bot(set(B))) ) ).

% prod_set_simps(2)
tff(fact_1445_total__on__singleton,axiom,
    ! [A: $tType,X: A] : total_on(A,aa(set(A),set(A),insert2(A,X),bot_bot(set(A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),X)),bot_bot(set(product_prod(A,A))))) ).

% total_on_singleton
tff(fact_1446_Field__insert,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A))] : ( field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2)),R3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))),field2(A,R3)) ) ).

% Field_insert
tff(fact_1447_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),N) )
        <=> ( one2 = N ) ) ) ).

% one_eq_numeral_iff
tff(fact_1448_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: num] :
          ( ( aa(num,A,numeral_numeral(A),N) = one_one(A) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_one_iff
tff(fact_1449_Field__empty,axiom,
    ! [A: $tType] : ( field2(A,bot_bot(set(product_prod(A,A)))) = bot_bot(set(A)) ) ).

% Field_empty
tff(fact_1450_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),N)),one_one(A)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),N),one2)) ) ) ).

% numeral_le_one_iff
tff(fact_1451_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(num,A,numeral_numeral(A),N)))
        <=> pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),one2),N)) ) ) ).

% one_less_numeral_iff
tff(fact_1452_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] :
          ( ( aa(A,A,uminus_uminus(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) )
        <=> ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
tff(fact_1453_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
tff(fact_1454_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% one_plus_numeral
tff(fact_1455_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2)) ) ) ).

% numeral_plus_one
tff(fact_1456_FieldI2,axiom,
    ! [A: $tType,I: A,J2: A,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),I),J2),R))
     => pp(member(A,J2,field2(A,R))) ) ).

% FieldI2
tff(fact_1457_FieldI1,axiom,
    ! [A: $tType,I: A,J2: A,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),I),J2),R))
     => pp(member(A,I,field2(A,R))) ) ).

% FieldI1
tff(fact_1458_total__on__def,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( total_on(A,A4,R3)
    <=> ! [X4: A] :
          ( pp(member(A,X4,A4))
         => ! [Xa2: A] :
              ( pp(member(A,Xa2,A4))
             => ( ( X4 != Xa2 )
               => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa2),R3))
                  | pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa2),X4),R3)) ) ) ) ) ) ).

% total_on_def
tff(fact_1459_total__onI,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( ! [X2: A,Y2: A] :
          ( pp(member(A,X2,A4))
         => ( pp(member(A,Y2,A4))
           => ( ( X2 != Y2 )
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),R3))
                | pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),X2),R3)) ) ) ) )
     => total_on(A,A4,R3) ) ).

% total_onI
tff(fact_1460_total__on__empty,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : total_on(A,bot_bot(set(A)),R3) ).

% total_on_empty
tff(fact_1461_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),one2)),A3) = A3 ) ) ).

% mult_numeral_1
tff(fact_1462_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),one2)) = A3 ) ) ).

% mult_numeral_1_right
tff(fact_1463_numeral__One,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(num,A,numeral_numeral(A),one2) = one_one(A) ) ) ).

% numeral_One
tff(fact_1464_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))),B2) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% mult_1s_ring_1(1)
tff(fact_1465_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% mult_1s_ring_1(2)
tff(fact_1466_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% uminus_numeral_One
tff(fact_1467_prod__set__defs_I1_J,axiom,
    ! [B: $tType,A: $tType,X3: product_prod(A,B)] : ( aa(product_prod(A,B),set(A),basic_fsts(A,B),X3) = aa(set(A),set(A),insert2(A,aa(product_prod(A,B),A,product_fst(A,B),X3)),bot_bot(set(A))) ) ).

% prod_set_defs(1)
tff(fact_1468_prod__set__defs_I2_J,axiom,
    ! [C: $tType,D: $tType,X3: product_prod(C,D)] : ( basic_snds(C,D,X3) = aa(set(D),set(D),insert2(D,aa(product_prod(C,D),D,product_snd(C,D),X3)),bot_bot(set(D))) ) ).

% prod_set_defs(2)
tff(fact_1469_one__div__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),N)) = aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,one2,N)) ) ) ).

% one_div_numeral
tff(fact_1470_cofinal__def,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( bNF_Ca7293521722713021262ofinal(A,A4,R3)
    <=> ! [X4: A] :
          ( pp(member(A,X4,field2(A,R3)))
         => ? [Xa2: A] :
              ( pp(member(A,Xa2,A4))
              & ( X4 != Xa2 )
              & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa2),R3)) ) ) ) ).

% cofinal_def
tff(fact_1471_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M4: num] : ( unique8689654367752047608divmod(A,M4,one2) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(num,A,numeral_numeral(A),M4)),zero_zero(A)) ) ) ).

% divmod_algorithm_code(2)
tff(fact_1472_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M4: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,one2,M4) ) ) ).

% diff_numeral_special(8)
tff(fact_1473_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = neg_numeral_sub(A,N,one2) ) ) ).

% diff_numeral_special(7)
tff(fact_1474_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M4: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),neg_numeral_sub(A,M4,one2))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4)) ) ) ).

% minus_sub_one_diff_one
tff(fact_1475_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,N,one2) ) ) ).

% add_neg_numeral_special(4)
tff(fact_1476_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M4: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M4)),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,M4,one2) ) ) ).

% add_neg_numeral_special(3)
tff(fact_1477_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M4: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M4)),one_one(A)) = neg_numeral_sub(A,M4,one2) ) ) ).

% diff_numeral_special(2)
tff(fact_1478_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,one2,N) ) ) ).

% diff_numeral_special(1)
tff(fact_1479_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M4: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))) = neg_numeral_sub(A,one2,M4) ) ) ).

% add_neg_numeral_special(1)
tff(fact_1480_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M4: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M4))),one_one(A)) = neg_numeral_sub(A,one2,M4) ) ) ).

% add_neg_numeral_special(2)
tff(fact_1481_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),X)) = one_one(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),X),one2))) ) ) ).

% eq_numeral_iff_iszero(7)
tff(fact_1482_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( one_one(A) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Y))) ) ) ).

% eq_numeral_iff_iszero(8)
tff(fact_1483_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))) ) ) ).

% dbl_dec_simps(4)
tff(fact_1484_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( unique8689654367752047608divmod(A,one2,aa(num,num,bit0,N)) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),zero_zero(A)),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% divmod_algorithm_code(3)
tff(fact_1485_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,R3: A,Q3: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),L)),R3))
           => ( unique1321980374590559556d_step(A,L,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),R3)) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Q3)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),R3),aa(num,A,numeral_numeral(A),L))) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),L)),R3))
           => ( unique1321980374590559556d_step(A,L,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),R3)) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Q3)),R3) ) ) ) ) ).

% divmod_step_eq
tff(fact_1486_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% diff_numeral_special(10)
tff(fact_1487_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% diff_numeral_special(11)
tff(fact_1488_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% add_neg_numeral_special(9)
tff(fact_1489_one__add__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% one_add_one
tff(fact_1490_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2)) ) ) ).

% dbl_inc_simps(3)
tff(fact_1491_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% one_div_two_eq_zero
tff(fact_1492_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ).

% bits_1_div_2
tff(fact_1493_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( unique8689654367752047608divmod(A,one2,aa(num,num,bit1,N)) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),zero_zero(A)),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% divmod_algorithm_code(4)
tff(fact_1494_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M4: num,N: num] :
          ( ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),M4),N))
           => ( unique8689654367752047608divmod(A,aa(num,num,bit0,M4),aa(num,num,bit1,N)) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),zero_zero(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,M4))) ) )
          & ( ~ pp(aa(num,bool,aa(num,fun(num,bool),ord_less_eq(num),M4),N))
           => ( unique8689654367752047608divmod(A,aa(num,num,bit0,M4),aa(num,num,bit1,N)) = unique1321980374590559556d_step(A,aa(num,num,bit1,N),unique8689654367752047608divmod(A,aa(num,num,bit0,M4),aa(num,num,bit0,aa(num,num,bit1,N)))) ) ) ) ) ).

% divmod_algorithm_code(7)
tff(fact_1495_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M4: num,N: num] :
          ( ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M4),N))
           => ( unique8689654367752047608divmod(A,aa(num,num,bit1,M4),aa(num,num,bit1,N)) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),zero_zero(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,M4))) ) )
          & ( ~ pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M4),N))
           => ( unique8689654367752047608divmod(A,aa(num,num,bit1,M4),aa(num,num,bit1,N)) = unique1321980374590559556d_step(A,aa(num,num,bit1,N),unique8689654367752047608divmod(A,aa(num,num,bit1,M4),aa(num,num,bit0,aa(num,num,bit1,N)))) ) ) ) ) ).

% divmod_algorithm_code(8)
tff(fact_1496_xor__num_Ocases,axiom,
    ! [X: product_prod(num,num)] :
      ( ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2) )
     => ( ! [N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N3)) )
       => ( ! [N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N3)) )
         => ( ! [M5: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),one2) )
           => ( ! [M5: num,N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit0,N3)) )
             => ( ! [M5: num,N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit1,N3)) )
               => ( ! [M5: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),one2) )
                 => ( ! [M5: num,N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit0,N3)) )
                   => ~ ! [M5: num,N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit1,N3)) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
tff(fact_1497_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,one_one(A)) ) ).

% not_iszero_1
tff(fact_1498_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_iszero_neg_1
tff(fact_1499_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),aa(num,num,bit1,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N))),one_one(A)) ) ) ).

% numeral_Bit1
tff(fact_1500_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M4: num,N: num] :
          ( ( pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M4),N))
           => ( unique8689654367752047608divmod(A,M4,N) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),zero_zero(A)),aa(num,A,numeral_numeral(A),M4)) ) )
          & ( ~ pp(aa(num,bool,aa(num,fun(num,bool),ord_less(num),M4),N))
           => ( unique8689654367752047608divmod(A,M4,N) = unique1321980374590559556d_step(A,N,unique8689654367752047608divmod(A,M4,aa(num,num,bit0,N))) ) ) ) ) ).

% divmod_divmod_step
tff(fact_1501_left__add__twice,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A3)),B2) ) ) ).

% left_add_twice
tff(fact_1502_mult__2__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z2),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),Z2) ) ) ).

% mult_2_right
tff(fact_1503_mult__2,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Z2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),Z2) ) ) ).

% mult_2
tff(fact_1504_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: num] :
          ( ( aa(num,A,numeral_numeral(A),X) = one_one(A) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,X,one2)) ) ) ).

% eq_numeral_iff_iszero(5)
tff(fact_1505_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),Y) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,one2,Y)) ) ) ).

% eq_numeral_iff_iszero(6)
tff(fact_1506_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( divide_divide(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% minus_1_div_2_eq
tff(fact_1507_set__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( bit_se5668285175392031749et_bit(A,zero_zero(nat),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% set_bit_0
tff(fact_1508_unset__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( bit_se2638667681897837118et_bit(A,zero_zero(nat),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% unset_bit_0
tff(fact_1509_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% dbl_simps(4)
tff(fact_1510_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)) ) ) ).

% dbl_simps(3)
tff(fact_1511_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))))
             => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)))),one_one(A)) = divide_divide(A,A3,B2) ) ) ) ) ) ).

% divmod_digit_1(1)
tff(fact_1512_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% xor_numerals(6)
tff(fact_1513_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% xor_numerals(4)
tff(fact_1514_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3),B2) = zero_zero(A) ) ) ).

% mod_mult_self1_is_0
tff(fact_1515_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),B2) = zero_zero(A) ) ) ).

% mod_mult_self2_is_0
tff(fact_1516_mod__by__1,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A3: A] : ( modulo_modulo(A,A3,one_one(A)) = zero_zero(A) ) ) ).

% mod_by_1
tff(fact_1517_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] : ( modulo_modulo(A,A3,one_one(A)) = zero_zero(A) ) ) ).

% bits_mod_by_1
tff(fact_1518_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_mult_self1
tff(fact_1519_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_mult_self2
tff(fact_1520_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),A3),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_mult_self3
tff(fact_1521_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A3: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A3),B2) = modulo_modulo(A,A3,B2) ) ) ).

% mod_mult_self4
tff(fact_1522_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A] : ( modulo_modulo(A,A3,aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% mod_minus1_right
tff(fact_1523_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% one_mod_two_eq_one
tff(fact_1524_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% bits_one_mod_two_eq_one
tff(fact_1525_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% xor_numerals(3)
tff(fact_1526_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% xor_numerals(1)
tff(fact_1527_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y)) ) ) ).

% xor_numerals(2)
tff(fact_1528_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X)) ) ) ).

% xor_numerals(5)
tff(fact_1529_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit0,X)) ) ) ).

% xor_numerals(8)
tff(fact_1530_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != zero_zero(A) )
        <=> ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ) ).

% not_mod_2_eq_0_eq_1
tff(fact_1531_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != one_one(A) )
        <=> ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) ) ) ).

% not_mod_2_eq_1_eq_0
tff(fact_1532_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% minus_1_mod_2_eq
tff(fact_1533_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% bits_minus_1_mod_2_eq
tff(fact_1534_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% xor_numerals(7)
tff(fact_1535_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),N)) = aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,one2,N)) ) ) ).

% one_mod_numeral
tff(fact_1536_divmod__int__def,axiom,
    ! [M4: num,N: num] : ( unique8689654367752047608divmod(int,M4,N) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),divide_divide(int,aa(num,int,numeral_numeral(int),M4),aa(num,int,numeral_numeral(int),N))),modulo_modulo(int,aa(num,int,numeral_numeral(int),M4),aa(num,int,numeral_numeral(int),N))) ) ).

% divmod_int_def
tff(fact_1537_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) ) ) ).

% mod_mult_right_eq
tff(fact_1538_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A3,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) ) ) ).

% mod_mult_left_eq
tff(fact_1539_mult__mod__right,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),modulo_modulo(A,A3,B2)) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% mult_mod_right
tff(fact_1540_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A3,B2)),C2) ) ) ).

% mod_mult_mult2
tff(fact_1541_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,A5: A,B2: A,B4: A] :
          ( ( modulo_modulo(A,A3,C2) = modulo_modulo(A,A5,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B4,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A5),B4),C2) ) ) ) ) ).

% mod_mult_cong
tff(fact_1542_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A3,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) ) ) ).

% mod_mult_eq
tff(fact_1543_mod__eqE,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo(A,A3,C2) = modulo_modulo(A,B2,C2) )
         => ~ ! [D3: A] : ( B2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D3)) ) ) ) ).

% mod_eqE
tff(fact_1544_xor_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => monoid(A,bit_se5824344971392196577ns_xor(A),zero_zero(A)) ) ).

% xor.monoid_axioms
tff(fact_1545_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [B2: A,A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,A3,B2))),modulo_modulo(A,A3,B2)) = A3 ) ) ).

% mult_div_mod_eq
tff(fact_1546_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,B2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,A3,B2))) = A3 ) ) ).

% mod_mult_div_eq
tff(fact_1547_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,B2)),aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,B2)),B2)) = A3 ) ) ).

% mod_div_mult_eq
tff(fact_1548_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,B2)),B2)),modulo_modulo(A,A3,B2)) = A3 ) ) ).

% div_mult_mod_eq
tff(fact_1549_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,B2)),B2)),modulo_modulo(A,A3,B2)) ) ) ).

% mod_div_decomp
tff(fact_1550_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,B2)),B2)),modulo_modulo(A,A3,B2))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2) ) ) ).

% cancel_div_mod_rules(1)
tff(fact_1551_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,A3,B2))),modulo_modulo(A,A3,B2))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),C2) ) ) ).

% cancel_div_mod_rules(2)
tff(fact_1552_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A3: A,B2: A,C2: A] : ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),divide_divide(A,B2,C2))),divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),modulo_modulo(A,B2,C2)),C2)) ) ) ).

% div_mult1_eq
tff(fact_1553_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,A3,B2))) = modulo_modulo(A,A3,B2) ) ) ).

% minus_mult_div_eq_mod
tff(fact_1554_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),modulo_modulo(A,A3,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,A3,B2)) ) ) ).

% minus_mod_eq_mult_div
tff(fact_1555_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),modulo_modulo(A,A3,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,B2)),B2) ) ) ).

% minus_mod_eq_div_mult
tff(fact_1556_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,B2)),B2)) = modulo_modulo(A,A3,B2) ) ) ).

% minus_div_mult_eq_mod
tff(fact_1557_divmod__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M4: num,N: num] : ( unique8689654367752047608divmod(A,M4,N) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),divide_divide(A,aa(num,A,numeral_numeral(A),M4),aa(num,A,numeral_numeral(A),N))),modulo_modulo(A,aa(num,A,numeral_numeral(A),M4),aa(num,A,numeral_numeral(A),N))) ) ) ).

% divmod_def
tff(fact_1558_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),C2))
         => ( modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),modulo_modulo(A,divide_divide(A,A3,B2),C2))),modulo_modulo(A,A3,B2)) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
tff(fact_1559_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),B2))
           => ( modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)) = modulo_modulo(A,A3,B2) ) ) ) ) ).

% divmod_digit_0(2)
tff(fact_1560_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),B2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))) = divide_divide(A,A3,B2) ) ) ) ) ).

% divmod_digit_0(1)
tff(fact_1561_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M4: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),M4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X))
           => ( ( modulo_modulo(A,X,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)) = modulo_modulo(A,X,M4) )
              | ( modulo_modulo(A,X,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,X,M4)),M4) ) ) ) ) ) ).

% mod_double_modulus
tff(fact_1562_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))))
             => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),B2) = modulo_modulo(A,A3,B2) ) ) ) ) ) ).

% divmod_digit_1(2)
tff(fact_1563_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] :
          ( ( ( N = zero_zero(nat) )
           => ( bit_ri4674362597316999326ke_bit(A,N,A3) = aa(A,A,uminus_uminus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) )
          & ( ( N != zero_zero(nat) )
           => ( bit_ri4674362597316999326ke_bit(A,N,A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_ri4674362597316999326ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ) ) ).

% signed_take_bit_rec
tff(fact_1564_take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] :
          ( ( ( N = zero_zero(nat) )
           => ( bit_se2584673776208193580ke_bit(A,N,A3) = zero_zero(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( bit_se2584673776208193580ke_bit(A,N,A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ) ) ).

% take_bit_rec
tff(fact_1565_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se5668285175392031749et_bit(A,aa(nat,nat,suc,N),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se5668285175392031749et_bit(A,N,divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% set_bit_Suc
tff(fact_1566_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se2638667681897837118et_bit(A,aa(nat,nat,suc,N),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2638667681897837118et_bit(A,N,divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% unset_bit_Suc
tff(fact_1567_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A] :
          ( ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),one_one(A)) = A3 ) ) ) ).

% odd_two_times_div_two_succ
tff(fact_1568_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(4)
tff(fact_1569_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(6)
tff(fact_1570_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(7)
tff(fact_1571_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num] : ( bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L),one_one(A)) = one_one(A) ) ) ).

% take_bit_numeral_1
tff(fact_1572_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( bit_ri4674362597316999326ke_bit(A,aa(num,nat,numeral_numeral(nat),K),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_numeral_of_1
tff(fact_1573_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 != zero_zero(A) )
         => ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)))
          <=> pp(dvd_dvd(A,B2,C2)) ) ) ) ).

% dvd_times_right_cancel_iff
tff(fact_1574_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 != zero_zero(A) )
         => ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)))
          <=> pp(dvd_dvd(A,B2,C2)) ) ) ) ).

% dvd_times_left_cancel_iff
tff(fact_1575_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
        <=> ( ( C2 = zero_zero(A) )
            | pp(dvd_dvd(A,A3,B2)) ) ) ) ).

% dvd_mult_cancel_right
tff(fact_1576_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
        <=> ( ( C2 = zero_zero(A) )
            | pp(dvd_dvd(A,A3,B2)) ) ) ) ).

% dvd_mult_cancel_left
tff(fact_1577_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),B2)))
        <=> pp(dvd_dvd(A,A3,B2)) ) ) ).

% dvd_add_times_triv_left_iff
tff(fact_1578_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3))))
        <=> pp(dvd_dvd(A,A3,B2)) ) ) ).

% dvd_add_times_triv_right_iff
tff(fact_1579_unit__prod,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( pp(dvd_dvd(A,B2,one_one(A)))
           => pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),one_one(A))) ) ) ) ).

% unit_prod
tff(fact_1580_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,B2))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,B2,A3)),A3) = B2 ) ) ) ).

% dvd_div_mult_self
tff(fact_1581_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,B2))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),divide_divide(A,B2,A3)) = B2 ) ) ) ).

% dvd_mult_div_cancel
tff(fact_1582_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( divide_divide(A,one_one(A),divide_divide(A,one_one(A),A3)) = A3 ) ) ) ).

% unit_div_1_div_1
tff(fact_1583_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => pp(dvd_dvd(A,divide_divide(A,one_one(A),A3),one_one(A))) ) ) ).

% unit_div_1_unit
tff(fact_1584_unit__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( pp(dvd_dvd(A,B2,one_one(A)))
           => pp(dvd_dvd(A,divide_divide(A,A3,B2),one_one(A))) ) ) ) ).

% unit_div
tff(fact_1585_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),one_one(A)) = one_one(A) ) ) ).

% take_bit_Suc_1
tff(fact_1586_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,uminus_uminus(A),one_one(A))),X) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_left
tff(fact_1587_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_right
tff(fact_1588_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( bit_ri4674362597316999326ke_bit(A,N,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% signed_take_bit_of_minus_1
tff(fact_1589_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,N),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_Suc_1
tff(fact_1590_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,B2,A3)),A3) = B2 ) ) ) ).

% unit_div_mult_self
tff(fact_1591_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,one_one(A),A3)) = divide_divide(A,B2,A3) ) ) ) ).

% unit_mult_div_div
tff(fact_1592_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit(A,N,one_one(A)) = zero_zero(A) )
        <=> ( N = zero_zero(nat) ) ) ) ).

% take_bit_of_1_eq_0_iff
tff(fact_1593_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(2)
tff(fact_1594_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X)) ) ) ).

% or_numerals(8)
tff(fact_1595_even__mult__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
        <=> ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
            | pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),B2)) ) ) ) ).

% even_mult_iff
tff(fact_1596_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% or_numerals(3)
tff(fact_1597_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,X)) ) ) ).

% or_numerals(5)
tff(fact_1598_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(1)
tff(fact_1599_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))))
        <=> ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3)) ) ) ).

% even_plus_one_iff
tff(fact_1600_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_2
tff(fact_1601_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A] :
          ( ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ) ).

% odd_succ_div_two
tff(fact_1602_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_two
tff(fact_1603_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A] : pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3))) ) ).

% dvd_triv_right
tff(fact_1604_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2))
         => pp(dvd_dvd(A,B2,C2)) ) ) ).

% dvd_mult_right
tff(fact_1605_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( pp(dvd_dvd(A,A3,B2))
         => ( pp(dvd_dvd(A,C2,D2))
           => pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2))) ) ) ) ).

% mult_dvd_mono
tff(fact_1606_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A] : pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))) ) ).

% dvd_triv_left
tff(fact_1607_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2))
         => pp(dvd_dvd(A,A3,C2)) ) ) ).

% dvd_mult_left
tff(fact_1608_dvd__mult2,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,B2))
         => pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ).

% dvd_mult2
tff(fact_1609_dvd__mult,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(dvd_dvd(A,A3,C2))
         => pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))) ) ) ).

% dvd_mult
tff(fact_1610_dvd__def,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B2: A,A3: A] :
          ( pp(dvd_dvd(A,B2,A3))
        <=> ? [K4: A] : ( A3 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),K4) ) ) ) ).

% dvd_def
tff(fact_1611_dvdI,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [A3: A,B2: A,K: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),K) )
         => pp(dvd_dvd(A,B2,A3)) ) ) ).

% dvdI
tff(fact_1612_dvdE,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B2: A,A3: A] :
          ( pp(dvd_dvd(A,B2,A3))
         => ~ ! [K2: A] : ( A3 != aa(A,A,aa(A,fun(A,A),times_times(A),B2),K2) ) ) ) ).

% dvdE
tff(fact_1613_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,B2))
         => ( pp(dvd_dvd(A,B2,one_one(A)))
           => pp(dvd_dvd(A,A3,one_one(A))) ) ) ) ).

% dvd_unit_imp_unit
tff(fact_1614_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => pp(dvd_dvd(A,B2,A3)) ) ) ).

% unit_imp_dvd
tff(fact_1615_one__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A] : pp(dvd_dvd(A,one_one(A),A3)) ) ).

% one_dvd
tff(fact_1616_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,N,aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_Suc_bit0
tff(fact_1617_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ~ pp(dvd_dvd(A,zero_zero(A),one_one(A))) ) ).

% not_is_unit_0
tff(fact_1618_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
tff(fact_1619_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
tff(fact_1620_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2))
          <=> pp(dvd_dvd(A,B2,C2)) ) ) ) ).

% mult_unit_dvd_iff'
tff(fact_1621_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
          <=> pp(dvd_dvd(A,A3,C2)) ) ) ) ).

% dvd_mult_unit_iff'
tff(fact_1622_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2))
          <=> pp(dvd_dvd(A,A3,C2)) ) ) ) ).

% mult_unit_dvd_iff
tff(fact_1623_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(dvd_dvd(A,A3,C2)) ) ) ) ).

% dvd_mult_unit_iff
tff(fact_1624_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),one_one(A)))
        <=> ( pp(dvd_dvd(A,A3,one_one(A)))
            & pp(dvd_dvd(A,B2,one_one(A))) ) ) ) ).

% is_unit_mult_iff
tff(fact_1625_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(dvd_dvd(A,C2,B2))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,B2,C2)),A3) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3),C2) ) ) ) ).

% dvd_div_mult
tff(fact_1626_div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(dvd_dvd(A,C2,B2))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),divide_divide(A,B2,C2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) ) ) ) ).

% div_mult_swap
tff(fact_1627_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(dvd_dvd(A,C2,B2))
         => ( pp(dvd_dvd(A,B2,A3))
           => ( divide_divide(A,A3,divide_divide(A,B2,C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,B2)),C2) ) ) ) ) ).

% div_div_eq_right
tff(fact_1628_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2),A3))
         => ( divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,divide_divide(A,A3,B2),C2) ) ) ) ).

% dvd_div_mult2_eq
tff(fact_1629_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),B2))
         => pp(dvd_dvd(A,A3,divide_divide(A,B2,C2))) ) ) ).

% dvd_mult_imp_div
tff(fact_1630_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,D2: A,C2: A] :
          ( pp(dvd_dvd(A,B2,A3))
         => ( pp(dvd_dvd(A,D2,C2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,B2)),divide_divide(A,C2,D2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ).

% div_mult_div_if_dvd
tff(fact_1631_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( pp(dvd_dvd(A,A3,divide_divide(A,C2,B2)))
          <=> pp(dvd_dvd(A,A3,C2)) ) ) ) ).

% dvd_div_unit_iff
tff(fact_1632_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( pp(dvd_dvd(A,divide_divide(A,A3,B2),C2))
          <=> pp(dvd_dvd(A,A3,C2)) ) ) ) ).

% div_unit_dvd_iff
tff(fact_1633_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( ( divide_divide(A,B2,A3) = divide_divide(A,C2,A3) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
tff(fact_1634_or_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => monoid(A,bit_se1065995026697491101ons_or(A),zero_zero(A)) ) ).

% or.monoid_axioms
tff(fact_1635_or_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => semilattice_neutr(A,bit_se1065995026697491101ons_or(A),zero_zero(A)) ) ).

% or.semilattice_neutr_axioms
tff(fact_1636_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( dvd(A)
        & semiring_0(A) )
     => ! [P: fun(A,bool),L: A] :
          ( ? [X4: A] : pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),times_times(A),L),X4)))
        <=> ? [X4: A] :
              ( pp(dvd_dvd(A,L,aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),zero_zero(A))))
              & pp(aa(A,bool,P,X4)) ) ) ) ).

% unity_coeff_ex
tff(fact_1637_unit__dvdE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ~ ( ( A3 != zero_zero(A) )
             => ! [C4: A] : ( B2 != aa(A,A,aa(A,fun(A,A),times_times(A),A3),C4) ) ) ) ) ).

% unit_dvdE
tff(fact_1638_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D2: A,D4: A,T4: A] :
          ( pp(dvd_dvd(A,D2,D4))
         => ! [X3: A,K3: A] :
              ( pp(dvd_dvd(A,D2,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),T4)))
            <=> pp(dvd_dvd(A,D2,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D4))),T4))) ) ) ) ).

% inf_period(3)
tff(fact_1639_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D2: A,D4: A,T4: A] :
          ( pp(dvd_dvd(A,D2,D4))
         => ! [X3: A,K3: A] :
              ( ~ pp(dvd_dvd(A,D2,aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),T4)))
            <=> ~ pp(dvd_dvd(A,D2,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D4))),T4))) ) ) ) ).

% inf_period(4)
tff(fact_1640_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 != zero_zero(A) )
         => ( pp(dvd_dvd(A,A3,B2))
           => ( ( divide_divide(A,B2,A3) = C2 )
            <=> ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3) ) ) ) ) ) ).

% dvd_div_eq_mult
tff(fact_1641_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( pp(dvd_dvd(A,B2,A3))
           => ( pp(dvd_dvd(A,divide_divide(A,A3,B2),C2))
            <=> pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ) ) ).

% div_dvd_iff_mult
tff(fact_1642_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2 != zero_zero(A) )
         => ( pp(dvd_dvd(A,C2,B2))
           => ( pp(dvd_dvd(A,A3,divide_divide(A,B2,C2)))
            <=> pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),B2)) ) ) ) ) ).

% dvd_div_iff_mult
tff(fact_1643_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( C2 != zero_zero(A) )
           => ( pp(dvd_dvd(A,A3,B2))
             => ( pp(dvd_dvd(A,C2,D2))
               => ( ( divide_divide(A,B2,A3) = divide_divide(A,D2,C2) )
                <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),D2) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
tff(fact_1644_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( ( divide_divide(A,A3,B2) = zero_zero(A) )
          <=> ( A3 = zero_zero(A) ) ) ) ) ).

% unit_div_eq_0_iff
tff(fact_1645_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( pp(dvd_dvd(A,C2,one_one(A)))
           => ( divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,divide_divide(A,A3,B2),C2) ) ) ) ) ).

% is_unit_div_mult2_eq
tff(fact_1646_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(dvd_dvd(A,C2,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),divide_divide(A,B2,C2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) ) ) ) ).

% unit_div_mult_swap
tff(fact_1647_unit__div__commute,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,B2)),C2) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),B2) ) ) ) ).

% unit_div_commute
tff(fact_1648_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(dvd_dvd(A,C2,one_one(A)))
         => ( pp(dvd_dvd(A,B2,A3))
           => ( divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,divide_divide(A,A3,B2),C2) ) ) ) ) ).

% div_mult_unit2
tff(fact_1649_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( ( A3 = divide_divide(A,C2,B2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = C2 ) ) ) ) ).

% unit_eq_div2
tff(fact_1650_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( ( divide_divide(A,A3,B2) = C2 )
          <=> ( A3 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) ) ) ) ) ).

% unit_eq_div1
tff(fact_1651_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A3: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( modulo_modulo(A,A3,B2) = zero_zero(A) ) ) ) ).

% unit_imp_mod_eq_0
tff(fact_1652_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,N,aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% take_bit_Suc_bit1
tff(fact_1653_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,N,divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% take_bit_Suc
tff(fact_1654_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,N),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_ri4674362597316999326ke_bit(A,N,divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% signed_take_bit_Suc
tff(fact_1655_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( pp(dvd_dvd(A,B2,one_one(A)))
           => ( divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)) = divide_divide(A,one_one(A),B2) ) ) ) ) ).

% is_unit_div_mult_cancel_right
tff(fact_1656_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( pp(dvd_dvd(A,B2,one_one(A)))
           => ( divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = divide_divide(A,one_one(A),B2) ) ) ) ) ).

% is_unit_div_mult_cancel_left
tff(fact_1657_is__unitE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ~ ( ( A3 != zero_zero(A) )
             => ! [B5: A] :
                  ( ( B5 != zero_zero(A) )
                 => ( pp(dvd_dvd(A,B5,one_one(A)))
                   => ( ( divide_divide(A,one_one(A),A3) = B5 )
                     => ( ( divide_divide(A,one_one(A),B5) = A3 )
                       => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B5) = one_one(A) )
                         => ( divide_divide(A,C2,A3) != aa(A,A,aa(A,fun(A,A),times_times(A),C2),B5) ) ) ) ) ) ) ) ) ) ).

% is_unitE
tff(fact_1658_evenE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ~ ! [B5: A] : ( A3 != aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B5) ) ) ) ).

% evenE
tff(fact_1659_odd__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),one_one(A))) ) ).

% odd_one
tff(fact_1660_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = A3 ) ) ) ).

% even_two_times_div_two
tff(fact_1661_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
        <=> ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ) ).

% odd_iff_mod_2_eq_one
tff(fact_1662_oddE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ~ ! [B5: A] : ( A3 != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B5)),one_one(A)) ) ) ) ).

% oddE
tff(fact_1663_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
           => ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = zero_zero(A) ) )
          & ( ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
           => ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = one_one(A) ) ) ) ) ).

% mod2_eq_if
tff(fact_1664_parity__cases,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A3: A] :
          ( ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
           => ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != zero_zero(A) ) )
         => ~ ( ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
             => ( modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) != one_one(A) ) ) ) ) ).

% parity_cases
tff(fact_1665_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se8732182000553998342ip_bit(A,aa(nat,nat,suc,N),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se8732182000553998342ip_bit(A,N,divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ) ).

% flip_bit_Suc
tff(fact_1666_divmod__BitM__2__eq,axiom,
    ! [M4: num] : ( unique8689654367752047608divmod(int,bitM(M4),aa(num,num,bit0,one2)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M4)),one_one(int))),one_one(int)) ) ).

% divmod_BitM_2_eq
tff(fact_1667_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),modulo_modulo(A,A3,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N))) ) ) ) ) ).

% even_succ_mod_exp
tff(fact_1668_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = divide_divide(A,A3,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) ) ) ) ) ).

% even_succ_div_exp
tff(fact_1669_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] :
          ( ( divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A3 )
         => ( ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
             => ( bit_se2584673776208193580ke_bit(A,N,A3) = zero_zero(A) ) )
            & ( ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
             => ( bit_se2584673776208193580ke_bit(A,N,A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)),one_one(A)) ) ) ) ) ) ).

% stable_imp_take_bit_eq
tff(fact_1670_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(A,N))) ) ) ).

% mask_Suc_double
tff(fact_1671_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A3: int,Q3: int,R3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),B2),zero_zero(int)))
     => ( eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),A3),one_one(int)),B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R3))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A3)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),R3)),one_one(int)))) ) ) ).

% neg_eucl_rel_int_mult_2
tff(fact_1672_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A3: int,Q3: int,R3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),B2))
     => ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R3))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A3)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),B2),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),R3)))) ) ) ).

% pos_eucl_rel_int_mult_2
tff(fact_1673_power__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),one_one(A)),N) = one_one(A) ) ) ).

% power_one
tff(fact_1674_power__inject__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,M4: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),M4) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N) )
          <=> ( M4 = N ) ) ) ) ).

% power_inject_exp
tff(fact_1675_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,X: nat,Y: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Y)))
          <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),X),Y)) ) ) ) ).

% power_increasing_iff
tff(fact_1676_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,X: nat,Y: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Y)))
          <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X),Y)) ) ) ) ).

% power_strict_increasing_iff
tff(fact_1677_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)) = one_one(A) ) ) ).

% minus_one_mult_self
tff(fact_1678_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),A3)) = A3 ) ) ).

% left_minus_one_mult_self
tff(fact_1679_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% mask_Suc_0
tff(fact_1680_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,M4: num,N: num,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(num,nat,numeral_numeral(nat),M4))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(num,nat,numeral_numeral(nat),N))),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M4),N)))),B2) ) ) ).

% power_add_numeral2
tff(fact_1681_power__add__numeral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,M4: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(num,nat,numeral_numeral(nat),M4))),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(num,nat,numeral_numeral(nat),N))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M4),N))) ) ) ).

% power_add_numeral
tff(fact_1682_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(A,N,aa(A,A,uminus_uminus(A),one_one(A))) = bit_se2239418461657761734s_mask(A,N) ) ) ).

% take_bit_minus_one_eq_mask
tff(fact_1683_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,M4: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),one_one(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),M4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)))
            <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M4)) ) ) ) ) ).

% power_decreasing_iff
tff(fact_1684_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,M4: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),one_one(A)))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),M4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)))
            <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M4)) ) ) ) ) ).

% power_strict_decreasing_iff
tff(fact_1685_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = one_one(A) ) ) ).

% power_minus1_even
tff(fact_1686_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( ~ pp(dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),N))
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% neg_one_odd_power
tff(fact_1687_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( pp(dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),N))
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N) = one_one(A) ) ) ) ).

% neg_one_even_power
tff(fact_1688_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: nat] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)),one_one(A))))
        <=> ( N = zero_zero(nat) ) ) ) ).

% semiring_parity_class.even_mask_iff
tff(fact_1689_divmod_H__nat__def,axiom,
    ! [M4: num,N: num] : ( unique8689654367752047608divmod(nat,M4,N) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),divide_divide(nat,aa(num,nat,numeral_numeral(nat),M4),aa(num,nat,numeral_numeral(nat),N))),modulo_modulo(nat,aa(num,nat,numeral_numeral(nat),M4),aa(num,nat,numeral_numeral(nat),N))) ) ).

% divmod'_nat_def
tff(fact_1690_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X: A,Y: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),X) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)) ) ) ) ).

% power_commuting_commutes
tff(fact_1691_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: A,B2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)) ) ) ).

% power_mult_distrib
tff(fact_1692_power__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)) ) ) ).

% power_commutes
tff(fact_1693_unique__quotient,axiom,
    ! [A3: int,B2: int,Q3: int,R3: int,Q5: int,R4: int] :
      ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R3))
     => ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q5),R4))
       => ( Q3 = Q5 ) ) ) ).

% unique_quotient
tff(fact_1694_unique__remainder,axiom,
    ! [A3: int,B2: int,Q3: int,R3: int,Q5: int,R4: int] :
      ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R3))
     => ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q5),R4))
       => ( R3 = R4 ) ) ) ).

% unique_remainder
tff(fact_1695_power__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N4: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N4))) ) ) ) ).

% power_increasing
tff(fact_1696_one__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N))) ) ) ).

% one_le_power
tff(fact_1697_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N4: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N4))) ) ) ) ).

% power_strict_increasing
tff(fact_1698_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,M4: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),M4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M4),N)) ) ) ) ).

% power_less_imp_less_exp
tff(fact_1699_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X: A,Y: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),X),Y) = one_one(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),N)) = one_one(A) ) ) ) ).

% left_right_inverse_power
tff(fact_1700_power__Suc,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)) ) ) ).

% power_Suc
tff(fact_1701_power__Suc2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)),A3) ) ) ).

% power_Suc2
tff(fact_1702_power__0,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A3: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),zero_zero(nat)) = one_one(A) ) ) ).

% power_0
tff(fact_1703_power__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),divide_divide(A,one_one(A),A3)),N) = divide_divide(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)) ) ) ).

% power_one_over
tff(fact_1704_power__add,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,M4: nat,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),M4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)) ) ) ).

% power_add
tff(fact_1705_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(A,N) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)),one_one(A)) ) ) ).

% mask_eq_exp_minus_1
tff(fact_1706_power__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N4: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N))) ) ) ) ) ).

% power_decreasing
tff(fact_1707_power__le__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)),one_one(A))) ) ) ) ).

% power_le_one
tff(fact_1708_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,M4: nat,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),M4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)))
           => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N)) ) ) ) ).

% power_le_imp_le_exp
tff(fact_1709_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N4: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N))) ) ) ) ) ).

% power_strict_decreasing
tff(fact_1710_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)))) ) ) ).

% power_gt1_lemma
tff(fact_1711_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)))) ) ) ).

% power_less_power_Suc
tff(fact_1712_self__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N))) ) ) ) ).

% self_le_power
tff(fact_1713_power__0__left,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( ( ( N = zero_zero(nat) )
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),N) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),N) = zero_zero(A) ) ) ) ) ).

% power_0_left
tff(fact_1714_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [X: A,M4: nat,N: nat] :
          ( ( X != zero_zero(A) )
         => ( pp(dvd_dvd(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M4),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)))
          <=> ( pp(dvd_dvd(A,X,one_one(A)))
              | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N)) ) ) ) ) ).

% dvd_power_iff
tff(fact_1715_one__less__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N))) ) ) ) ).

% one_less_power
tff(fact_1716_power__gt1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,suc,N)))) ) ) ).

% power_gt1
tff(fact_1717_power__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A3)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)) ) ) ).

% power_minus
tff(fact_1718_power2__eq__square,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3) ) ) ).

% power2_eq_square
tff(fact_1719_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),X)),X)),X) ) ) ).

% power4_eq_xxxx
tff(fact_1720_one__power2,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),one_one(A)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) ) ) ).

% one_power2
tff(fact_1721_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(dvd_dvd(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N),one_one(A)))
        <=> ( pp(dvd_dvd(A,A3,one_one(A)))
            | ( N = zero_zero(nat) ) ) ) ) ).

% is_unit_power_iff
tff(fact_1722_dvd__power,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat,X: A] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
            | ( X = one_one(A) ) )
         => pp(dvd_dvd(A,X,aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N))) ) ) ).

% dvd_power
tff(fact_1723_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3)),A3) ) ) ).

% power3_eq_cube
tff(fact_1724_eucl__rel__int__by0,axiom,
    ! [K: int] : eucl_rel_int(K,zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),K)) ).

% eucl_rel_int_by0
tff(fact_1725_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q3: int] :
      ( ( L != zero_zero(int) )
     => ( ( K = aa(int,int,aa(int,fun(int,int),times_times(int),Q3),L) )
       => eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),zero_zero(int))) ) ) ).

% eucl_rel_int_dividesI
tff(fact_1726_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q3: int,R3: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R3))
    <=> ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),L),Q3)),R3) )
        & ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),L))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),R3))
            & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),R3),L)) ) )
        & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),L))
         => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int)))
             => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),R3))
                & pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),R3),zero_zero(int))) ) )
            & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),L),zero_zero(int)))
             => ( Q3 = zero_zero(int) ) ) ) ) ) ) ).

% eucl_rel_int_iff
tff(fact_1727_div__int__unique,axiom,
    ! [K: int,L: int,Q3: int,R3: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R3))
     => ( divide_divide(int,K,L) = Q3 ) ) ).

% div_int_unique
tff(fact_1728_mod__int__unique,axiom,
    ! [K: int,L: int,Q3: int,R3: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R3))
     => ( modulo_modulo(int,K,L) = R3 ) ) ).

% mod_int_unique
tff(fact_1729_power__Suc__less,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N))) ) ) ) ).

% power_Suc_less
tff(fact_1730_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,suc,N))),A3)) ) ) ) ).

% power_Suc_le_self
tff(fact_1731_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,suc,N))),one_one(A))) ) ) ) ).

% power_Suc_less_one
tff(fact_1732_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A3: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A3)),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A3)),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) ) ) ).

% minus_power_mult_self
tff(fact_1733_power__odd__eq,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A3: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% power_odd_eq
tff(fact_1734_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A3: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) )
        <=> ( ( A3 = one_one(A) )
            | ( A3 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% power2_eq_1_iff
tff(fact_1735_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( ( pp(dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),N))
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N) = one_one(A) ) )
          & ( ~ pp(dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),N))
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% minus_one_power_iff
tff(fact_1736_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A3: A,N: nat,M4: nat] :
          ( ( A3 != zero_zero(A) )
         => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M4))
             => ( divide_divide(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),M4),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),N)) ) )
            & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M4))
             => ( divide_divide(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),M4),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N)) = divide_divide(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ) ) ) ).

% power_diff_power_eq
tff(fact_1737_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
tff(fact_1738_power__minus__mult,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [N: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),A3) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),N) ) ) ) ).

% power_minus_mult
tff(fact_1739_power__minus_H,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: A,N: nat] :
          ( nO_MATCH(A,A,one_one(A),X)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),X)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)) ) ) ) ).

% power_minus'
tff(fact_1740_numeral__BitM,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),bitM(N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,N))),one_one(A)) ) ) ).

% numeral_BitM
tff(fact_1741_eucl__rel__int,axiom,
    ! [K: int,L: int] : eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),divide_divide(int,K,L)),modulo_modulo(int,K,L))) ).

% eucl_rel_int
tff(fact_1742_power2__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [X: A,Y: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)),Y)) ) ) ).

% power2_sum
tff(fact_1743_square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A))) ) ) ) ).

% square_le_1
tff(fact_1744_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% power_minus1_odd
tff(fact_1745_power__eq__if,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [M4: nat,P3: A] :
          ( ( ( M4 = zero_zero(nat) )
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),P3),M4) = one_one(A) ) )
          & ( ( M4 != zero_zero(nat) )
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),P3),M4) = aa(A,A,aa(A,fun(A,A),times_times(A),P3),aa(nat,A,aa(A,fun(nat,A),power_power(A),P3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),one_one(nat)))) ) ) ) ) ).

% power_eq_if
tff(fact_1746_power2__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [X: A,Y: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),X)),Y)) ) ) ).

% power2_diff
tff(fact_1747_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M4: nat,N: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A3,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)) ) ) ) ).

% mult_exp_mod_exp_eq
tff(fact_1748_zminus1__lemma,axiom,
    ! [A3: int,B2: int,Q3: int,R3: int] :
      ( eucl_rel_int(A3,B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R3))
     => ( ( B2 != zero_zero(int) )
       => eucl_rel_int(aa(int,int,uminus_uminus(int),A3),B2,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),if(int,aa(int,bool,aa(int,fun(int,bool),fequal(int),R3),zero_zero(int)),aa(int,int,uminus_uminus(int),Q3),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),Q3)),one_one(int)))),if(int,aa(int,bool,aa(int,fun(int,bool),fequal(int),R3),zero_zero(int)),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),R3)))) ) ) ).

% zminus1_lemma
tff(fact_1749_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M4: nat,N: nat] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N))))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N)) ) ) ).

% even_mask_div_iff'
tff(fact_1750_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),K),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),K))),one_one(A)) ) ) ).

% take_bit_numeral_minus_1_eq
tff(fact_1751_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M4: nat,N: nat] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N))))
        <=> ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N) = zero_zero(A) )
            | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N)) ) ) ) ).

% even_mask_div_iff
tff(fact_1752_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,M4: nat,N: nat] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N))))
        <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M4))
            | ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N) = zero_zero(A) )
            | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
              & pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),divide_divide(A,A3,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))))) ) ) ) ) ).

% even_mult_exp_div_exp_iff
tff(fact_1753_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,suc,N))),one_one(A)) ) ) ).

% take_bit_Suc_minus_1_eq
tff(fact_1754_flip__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( bit_se8732182000553998342ip_bit(A,zero_zero(nat),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(bool,A,zero_neq_one_of_bool(A),dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),divide_divide(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% flip_bit_0
tff(fact_1755_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,pred_numeral(L),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),one_one(A)) ) ) ).

% take_bit_numeral_bit1
tff(fact_1756_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( modulo_modulo(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% one_mod_2_pow_eq
tff(fact_1757_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: num] : ( bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),N),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),N))) ) ) ).

% push_bit_numeral_minus_1
tff(fact_1758_mask__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: num] : ( bit_se2239418461657761734s_mask(A,aa(num,nat,numeral_numeral(nat),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(A,pred_numeral(N)))) ) ) ).

% mask_numeral
tff(fact_1759_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M4: nat,N: nat] : ( bit_se2584673776208193580ke_bit(A,M4,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M4))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) ) ) ).

% take_bit_of_exp
tff(fact_1760_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( divide_divide(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat))) ) ) ).

% one_div_2_pow_eq
tff(fact_1761_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat] : ( divide_divide(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat))) ) ) ).

% bits_1_div_exp
tff(fact_1762_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: bool] :
          ( ( aa(bool,A,zero_neq_one_of_bool(A),P) = one_one(A) )
        <=> pp(P) ) ) ).

% of_bool_eq_1_iff
tff(fact_1763_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa(bool,A,zero_neq_one_of_bool(A),fTrue) = one_one(A) ) ) ).

% of_bool_eq(2)
tff(fact_1764_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(bool,A,zero_neq_one_of_bool(A),P)),one_one(A)))
        <=> ~ pp(P) ) ) ).

% of_bool_less_one_iff
tff(fact_1765_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [P: bool] : ( aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,P)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(bool,A,zero_neq_one_of_bool(A),P)) ) ) ).

% of_bool_not_iff
tff(fact_1766_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A3)),aa(A,A,sgn_sgn(A),A3)) = aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),A3),zero_zero(A)))) ) ) ).

% sgn_mult_self_eq
tff(fact_1767_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(A,N,one_one(A)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% take_bit_of_1
tff(fact_1768_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N),A3) = bit_se4730199178511100633sh_bit(A,N,aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% push_bit_Suc
tff(fact_1769_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se4730199178511100633sh_bit(A,N,one_one(A)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N) ) ) ).

% push_bit_of_1
tff(fact_1770_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(A,N,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_of_2
tff(fact_1771_of__bool__conj,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [P: bool,Q: bool] : ( aa(bool,A,zero_neq_one_of_bool(A),fconj(P,Q)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),P)),aa(bool,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_conj
tff(fact_1772_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: bool] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(bool,A,zero_neq_one_of_bool(A),P)),one_one(A))) ) ).

% of_bool_less_eq_one
tff(fact_1773_of__bool__def,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P3: bool] :
          ( ( pp(P3)
           => ( aa(bool,A,zero_neq_one_of_bool(A),P3) = one_one(A) ) )
          & ( ~ pp(P3)
           => ( aa(bool,A,zero_neq_one_of_bool(A),P3) = zero_zero(A) ) ) ) ) ).

% of_bool_def
tff(fact_1774_split__of__bool,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,bool),P3: bool] :
          ( pp(aa(A,bool,P,aa(bool,A,zero_neq_one_of_bool(A),P3)))
        <=> ( ( pp(P3)
             => pp(aa(A,bool,P,one_one(A))) )
            & ( ~ pp(P3)
             => pp(aa(A,bool,P,zero_zero(A))) ) ) ) ) ).

% split_of_bool
tff(fact_1775_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,bool),P3: bool] :
          ( pp(aa(A,bool,P,aa(bool,A,zero_neq_one_of_bool(A),P3)))
        <=> ~ ( ( pp(P3)
                & ~ pp(aa(A,bool,P,one_one(A))) )
              | ( ~ pp(P3)
                & ~ pp(aa(A,bool,P,zero_zero(A))) ) ) ) ) ).

% split_of_bool_asm
tff(fact_1776_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se5668285175392031749et_bit(A,N,A3) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),bit_se4730199178511100633sh_bit(A,N,one_one(A))) ) ) ).

% set_bit_eq_or
tff(fact_1777_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se8732182000553998342ip_bit(A,N,A3) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),bit_se4730199178511100633sh_bit(A,N,one_one(A))) ) ) ).

% flip_bit_eq_xor
tff(fact_1778_push__bit__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se4730199178511100633sh_bit(A,N,aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),bit_se4730199178511100633sh_bit(A,N,A3)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% push_bit_double
tff(fact_1779_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se4730199178511100633sh_bit(A,N,A3) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) ) ) ).

% push_bit_eq_mult
tff(fact_1780_bits__induct,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [P: fun(A,bool),A3: A] :
          ( ! [A8: A] :
              ( ( divide_divide(A,A8,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A8 )
             => pp(aa(A,bool,P,A8)) )
         => ( ! [A8: A,B5: bool] :
                ( pp(aa(A,bool,P,A8))
               => ( ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(bool,A,zero_neq_one_of_bool(A),B5)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A8)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) = A8 )
                 => pp(aa(A,bool,P,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(bool,A,zero_neq_one_of_bool(A),B5)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A8)))) ) )
           => pp(aa(A,bool,P,A3)) ) ) ) ).

% bits_induct
tff(fact_1781_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L),aa(num,A,numeral_numeral(A),aa(num,num,bit0,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),bit_se2584673776208193580ke_bit(A,pred_numeral(L),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% take_bit_numeral_bit0
tff(fact_1782_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M4: nat,N: nat] : ( modulo_modulo(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M4),N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)) ) ) ).

% exp_mod_exp
tff(fact_1783_or__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),one_one(A)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(bool,A,zero_neq_one_of_bool(A),dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))) ) ) ).

% or_one_eq
tff(fact_1784_one__or__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(bool,A,zero_neq_one_of_bool(A),dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))) ) ) ).

% one_or_eq
tff(fact_1785_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M4: nat,N: nat] : ( divide_divide(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),fconj(aa(bool,bool,fNot,aa(A,bool,aa(A,fun(A,bool),fequal(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)),zero_zero(A))),aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),M4)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),N))) ) ) ).

% exp_div_exp_eq
tff(fact_1786_one__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(bool,A,zero_neq_one_of_bool(A),dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3)))),aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3)))) ) ) ).

% one_xor_eq
tff(fact_1787_xor__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A3),one_one(A)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(bool,A,zero_neq_one_of_bool(A),dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3)))),aa(bool,A,zero_neq_one_of_bool(A),aa(bool,bool,fNot,dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3)))) ) ) ).

% xor_one_eq
tff(fact_1788_Divides_Oadjust__div__eq,axiom,
    ! [Q3: int,R3: int] : ( adjust_div(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R3)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Q3),aa(bool,int,zero_neq_one_of_bool(int),aa(bool,bool,fNot,aa(int,bool,aa(int,fun(int,bool),fequal(int),R3),zero_zero(int))))) ) ).

% Divides.adjust_div_eq
tff(fact_1789_and__int_Oelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Xa) = Y )
     => ( ( ( pp(member(int,X,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
            & pp(member(int,Xa,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( Y = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),X)),aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),Xa))))) ) )
        & ( ~ ( pp(member(int,X,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
              & pp(member(int,Xa,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( Y = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),X)),aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),Xa))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,X,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),divide_divide(int,Xa,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ) ).

% and_int.elims
tff(fact_1790_and__int_Osimps,axiom,
    ! [K: int,L: int] :
      ( ( ( pp(member(int,K,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
          & pp(member(int,L,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
       => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),K)),aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),L))))) ) )
      & ( ~ ( pp(member(int,K,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
            & pp(member(int,L,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
       => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),K)),aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ).

% and_int.simps
tff(fact_1791_normalize__negative,axiom,
    ! [Q3: int,P3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Q3),zero_zero(int)))
     => ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),Q3)) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),P3)),aa(int,int,uminus_uminus(int),Q3))) ) ) ).

% normalize_negative
tff(fact_1792_divmod__nat__def,axiom,
    ! [M4: nat,N: nat] : ( divmod_nat(M4,N) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),divide_divide(nat,M4,N)),modulo_modulo(nat,M4,N)) ) ).

% divmod_nat_def
tff(fact_1793_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: fun(int,fun(int,bool))] :
      ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A0),A1)))
     => ( ! [K2: int,L3: int] :
            ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),K2),L3)))
           => ( ( ~ ( pp(member(int,K2,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
                    & pp(member(int,L3,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
               => pp(aa(int,bool,aa(int,fun(int,bool),P,divide_divide(int,K2,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),divide_divide(int,L3,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))))) )
             => pp(aa(int,bool,aa(int,fun(int,bool),P,K2),L3)) ) )
       => pp(aa(int,bool,aa(int,fun(int,bool),P,A0),A1)) ) ) ).

% and_int.pinduct
tff(fact_1794_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% and_numerals(7)
tff(fact_1795_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),aa(A,A,uminus_uminus(A),one_one(A))) = X ) ) ).

% bit.conj_one_right
tff(fact_1796_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(A,A,uminus_uminus(A),one_one(A))) = A3 ) ) ).

% and.right_neutral
tff(fact_1797_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))),A3) = A3 ) ) ).

% and.left_neutral
tff(fact_1798_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),one_one(A)) = one_one(A) ) ) ).

% and_numerals(8)
tff(fact_1799_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = one_one(A) ) ) ).

% and_numerals(2)
tff(fact_1800_normalize__denom__zero,axiom,
    ! [P3: int] : ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),zero_zero(int))) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)) ) ).

% normalize_denom_zero
tff(fact_1801_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = zero_zero(A) ) ) ).

% and_numerals(1)
tff(fact_1802_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),one_one(A)) = zero_zero(A) ) ) ).

% and_numerals(5)
tff(fact_1803_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(3)
tff(fact_1804_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(4)
tff(fact_1805_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [X: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,X))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),X)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(6)
tff(fact_1806_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),B2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( A3 = aa(A,A,uminus_uminus(A),one_one(A)) )
            & ( B2 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% and_eq_minus_1_iff
tff(fact_1807_and_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => monoid(A,bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% and.monoid_axioms
tff(fact_1808_and_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => semilattice_neutr(A,bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% and.semilattice_neutr_axioms
tff(fact_1809_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),X) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),X) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),Y) = zero_zero(A) )
             => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A3),Y) = aa(A,A,uminus_uminus(A),one_one(A)) )
               => ( X = Y ) ) ) ) ) ) ).

% bit.complement_unique
tff(fact_1810_one__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),A3) = modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% one_and_eq
tff(fact_1811_and__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),one_one(A)) = modulo_modulo(A,A3,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% and_one_eq
tff(fact_1812_normalize__denom__pos,axiom,
    ! [R3: product_prod(int,int),P3: int,Q3: int] :
      ( ( normalize(R3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),Q3) )
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Q3)) ) ).

% normalize_denom_pos
tff(fact_1813_normalize__crossproduct,axiom,
    ! [Q3: int,S: int,P3: int,R3: int] :
      ( ( Q3 != zero_zero(int) )
     => ( ( S != zero_zero(int) )
       => ( ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),Q3)) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),R3),S)) )
         => ( aa(int,int,aa(int,fun(int,int),times_times(int),P3),S) = aa(int,int,aa(int,fun(int,int),times_times(int),R3),Q3) ) ) ) ) ).

% normalize_crossproduct
tff(fact_1814_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),K),L)))
     => ( ( ( pp(member(int,K,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
            & pp(member(int,L,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),K)),aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),L))))) ) )
        & ( ~ ( pp(member(int,K,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
              & pp(member(int,L,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
         => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),K)),aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ) ).

% and_int.psimps
tff(fact_1815_and__int_Opelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Xa) = Y )
     => ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X),Xa)))
       => ~ ( ( ( ( pp(member(int,X,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
                  & pp(member(int,Xa,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
               => ( Y = aa(int,int,uminus_uminus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),X)),aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),Xa))))) ) )
              & ( ~ ( pp(member(int,X,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))))
                    & pp(member(int,Xa,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))) )
               => ( Y = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(bool,int,zero_neq_one_of_bool(int),fconj(aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),X)),aa(bool,bool,fNot,dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),Xa))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,X,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),divide_divide(int,Xa,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) )
           => ~ pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X),Xa))) ) ) ) ).

% and_int.pelims
tff(fact_1816_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: fun(int,fun(int,bool))] :
      ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A0),A1)))
     => ( ! [I3: int,J3: int] :
            ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),I3),J3)))
           => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I3),J3))
               => pp(aa(int,bool,aa(int,fun(int,bool),P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int))),J3)) )
             => pp(aa(int,bool,aa(int,fun(int,bool),P,I3),J3)) ) )
       => pp(aa(int,bool,aa(int,fun(int,bool),P,A0),A1)) ) ) ).

% upto.pinduct
tff(fact_1817_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,B2: A,N: nat] :
          ( ! [J3: nat] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),aa(nat,nat,suc,J3)))
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2))),N))
          <=> ( ( ( N = zero_zero(nat) )
               => ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3)) )
              & ( ( N != zero_zero(nat) )
               => pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),B2)),N)) ) ) ) ) ) ).

% bit_sum_mult_2_cases
tff(fact_1818_dvd__productE,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [P3: A,A3: A,B2: A] :
          ( pp(dvd_dvd(A,P3,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
         => ~ ! [X2: A,Y2: A] :
                ( ( P3 = aa(A,A,aa(A,fun(A,A),times_times(A),X2),Y2) )
               => ( pp(dvd_dvd(A,X2,A3))
                 => ~ pp(dvd_dvd(A,Y2,B2)) ) ) ) ) ).

% dvd_productE
tff(fact_1819_division__decomp,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
         => ? [B7: A,C7: A] :
              ( ( A3 = aa(A,A,aa(A,fun(A,A),times_times(A),B7),C7) )
              & pp(dvd_dvd(A,B7,B2))
              & pp(dvd_dvd(A,C7,C2)) ) ) ) ).

% division_decomp
tff(fact_1820_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(A,X)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),X)) ) ) ).

% neg_numeral_le_ceiling
tff(fact_1821_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A)))) ) ) ).

% ceiling_less_neg_numeral
tff(fact_1822_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat,M4: nat] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M4),N))),one_one(A)) ) ) ).

% mask_mod_exp
tff(fact_1823_min_Oidem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),A3) = A3 ) ) ).

% min.idem
tff(fact_1824_min_Oleft__idem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) ) ) ).

% min.left_idem
tff(fact_1825_min_Oright__idem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),B2) = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) ) ) ).

% min.right_idem
tff(fact_1826_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = A3 ) ) ) ).

% min.absorb1
tff(fact_1827_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = B2 ) ) ) ).

% min.absorb2
tff(fact_1828_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% min.bounded_iff
tff(fact_1829_bit__0__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( bit_se5641148757651400278ts_bit(A,zero_zero(A)) = bot_bot(fun(nat,bool)) ) ) ).

% bit_0_eq
tff(fact_1830_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = A3 ) ) ) ).

% min.absorb3
tff(fact_1831_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = B2 ) ) ) ).

% min.absorb4
tff(fact_1832_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z2: A,X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),X))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),Y)) ) ) ) ).

% min_less_iff_conj
tff(fact_1833_min__bot2,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),X),bot_bot(A)) = bot_bot(A) ) ) ).

% min_bot2
tff(fact_1834_min__bot,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),bot_bot(A)),X) = bot_bot(A) ) ) ).

% min_bot
tff(fact_1835_min__top,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),top_top(A)),X) = X ) ) ).

% min_top
tff(fact_1836_min__top2,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),X),top_top(A)) = X ) ) ).

% min_top2
tff(fact_1837_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),zero_zero(A)) = zero_zero(A) ) ) ).

% min_0_1(2)
tff(fact_1838_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),zero_zero(A)),one_one(A)) = zero_zero(A) ) ) ).

% min_0_1(1)
tff(fact_1839_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),aa(num,A,numeral_numeral(A),X)) = one_one(A) ) ) ).

% min_0_1(5)
tff(fact_1840_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),X)),one_one(A)) = one_one(A) ) ) ).

% min_0_1(6)
tff(fact_1841_ceiling__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_ceiling(A,one_one(A)) = one_one(int) ) ) ).

% ceiling_one
tff(fact_1842_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,X)),one_one(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),one_one(A))) ) ) ).

% ceiling_le_one
tff(fact_1843_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),one_one(int)),archimedean_ceiling(A,X)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X)) ) ) ).

% one_less_ceiling
tff(fact_1844_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),one_one(A))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,X)),one_one(int)) ) ) ).

% ceiling_add_one
tff(fact_1845_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),one_one(A))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,X)),one_one(int)) ) ) ).

% ceiling_diff_one
tff(fact_1846_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X)),zero_zero(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,uminus_uminus(A),one_one(A)))) ) ) ).

% ceiling_less_zero
tff(fact_1847_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),archimedean_ceiling(A,X)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),X)) ) ) ).

% zero_le_ceiling
tff(fact_1848_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X)),aa(num,int,numeral_numeral(int),V)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A)))) ) ) ).

% ceiling_less_numeral
tff(fact_1849_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(A,X)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),X)) ) ) ).

% numeral_le_ceiling
tff(fact_1850_min_Oassoc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)) ) ) ).

% min.assoc
tff(fact_1851_min_Ocommute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = aa(A,A,aa(A,fun(A,A),ord_min(A),B2),A3) ) ) ).

% min.commute
tff(fact_1852_min_Oleft__commute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),B2),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)) ) ) ).

% min.left_commute
tff(fact_1853_min_Omono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),aa(A,A,aa(A,fun(A,A),ord_min(A),C2),D2))) ) ) ) ).

% min.mono
tff(fact_1854_min_OorderE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( A3 = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) ) ) ) ).

% min.orderE
tff(fact_1855_min_OorderI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% min.orderI
tff(fact_1856_min_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2)) ) ) ) ).

% min.boundedE
tff(fact_1857_min_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2))) ) ) ) ).

% min.boundedI
tff(fact_1858_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( A3 = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) ) ) ) ).

% min.order_iff
tff(fact_1859_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),A3)) ) ).

% min.cobounded1
tff(fact_1860_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),B2)) ) ).

% min.cobounded2
tff(fact_1861_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = A3 ) ) ) ).

% min.absorb_iff1
tff(fact_1862_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = B2 ) ) ) ).

% min.absorb_iff2
tff(fact_1863_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),C2)) ) ) ).

% min.coboundedI1
tff(fact_1864_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),C2)) ) ) ).

% min.coboundedI2
tff(fact_1865_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),Z2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Z2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),Z2)) ) ) ) ).

% min_le_iff_disj
tff(fact_1866_min__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = A3 ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) = B2 ) ) ) ) ).

% min_def
tff(fact_1867_min__absorb1,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y) = X ) ) ) ).

% min_absorb1
tff(fact_1868_min__absorb2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X))
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y) = Y ) ) ) ).

% min_absorb2
tff(fact_1869_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),Z2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),Z2)) ) ) ) ).

% min_less_iff_disj
tff(fact_1870_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2)) ) ) ) ).

% min.strict_boundedE
tff(fact_1871_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
        <=> ( ( A3 = aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2) )
            & ( A3 != B2 ) ) ) ) ).

% min.strict_order_iff
tff(fact_1872_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),C2)) ) ) ).

% min.strict_coboundedI1
tff(fact_1873_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),C2)) ) ) ).

% min.strict_coboundedI2
tff(fact_1874_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),Z2) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Z2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y),Z2)) ) ) ).

% min_add_distrib_left
tff(fact_1875_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),ord_min(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Z2)) ) ) ).

% min_add_distrib_right
tff(fact_1876_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),Z2) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Z2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z2)) ) ) ).

% min_diff_distrib_left
tff(fact_1877_inf__min,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf(A)
        & linorder(A) )
     => ( inf_inf(A) = ord_min(A) ) ) ).

% inf_min
tff(fact_1878_complete__linorder__inf__min,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ( inf_inf(A) = ord_min(A) ) ) ).

% complete_linorder_inf_min
tff(fact_1879_min_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semigroup(A,ord_min(A)) ) ).

% min.semigroup_axioms
tff(fact_1880_bit__1__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,one_one(A)),N))
        <=> ( N = zero_zero(nat) ) ) ) ).

% bit_1_iff
tff(fact_1881_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(nat,nat,suc,N))) ) ).

% not_bit_1_Suc
tff(fact_1882_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: num] : ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(num,nat,numeral_numeral(nat),N))) ) ).

% bit_numeral_simps(1)
tff(fact_1883_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(A,A3)),archimedean_ceiling(A,B2)))) ) ) ) ).

% mult_ceiling_le
tff(fact_1884_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),bit_se4730199178511100633sh_bit(A,N,one_one(A))) != zero_zero(A) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
tff(fact_1885_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3)),N))
          <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% even_bit_succ_iff
tff(fact_1886_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( ~ pp(dvd_dvd(A,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)),A3))
         => ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
          <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),N))
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
tff(fact_1887_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A)))) ) ) ).

% floor_le_neg_numeral
tff(fact_1888_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(A,X)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),X)) ) ) ).

% neg_numeral_less_floor
tff(fact_1889_bezw__0,axiom,
    ! [X: nat] : ( bezw(X,zero_zero(nat)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)) ) ).

% bezw_0
tff(fact_1890_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( bit_ri4674362597316999326ke_bit(A,N,A3) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),bit_se2584673776208193580ke_bit(A,N,A3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)))) ) ) ).

% signed_take_bit_def
tff(fact_1891_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,V: num] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X)),aa(num,int,numeral_numeral(int),V)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A)))) ) ) ).

% floor_le_numeral
tff(fact_1892_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(A,X)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),X)) ) ) ).

% numeral_less_floor
tff(fact_1893_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q3: A,P3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,divide_divide(A,P3,Q3)))),one_one(A))),Q3)),P3)) ) ) ).

% ceiling_divide_lower
tff(fact_1894_floor__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archim6421214686448440834_floor(A,one_one(A)) = one_one(int) ) ) ).

% floor_one
tff(fact_1895_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.compl_zero
tff(fact_1896_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% bit.compl_one
tff(fact_1897_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),aa(A,A,bit_ri4277139882892585799ns_not(A),X)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_right
tff(fact_1898_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)),X) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_left
tff(fact_1899_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),aa(A,A,bit_ri4277139882892585799ns_not(A),X)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_right
tff(fact_1900_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_ri4277139882892585799ns_not(A),X)),X) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_left
tff(fact_1901_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),X),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),X) ) ) ).

% bit.xor_one_right
tff(fact_1902_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,uminus_uminus(A),one_one(A))),X) = aa(A,A,bit_ri4277139882892585799ns_not(A),X) ) ) ).

% bit.xor_one_left
tff(fact_1903_zero__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),archim6421214686448440834_floor(A,X)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X)) ) ) ).

% zero_less_floor
tff(fact_1904_floor__le__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X)),zero_zero(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),one_one(A))) ) ) ).

% floor_le_zero
tff(fact_1905_one__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),one_one(int)),archim6421214686448440834_floor(A,X)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X)) ) ) ).

% one_le_floor
tff(fact_1906_floor__less__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archim6421214686448440834_floor(A,X)),one_one(int)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),one_one(A))) ) ) ).

% floor_less_one
tff(fact_1907_floor__diff__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),one_one(A))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(A,X)),one_one(int)) ) ) ).

% floor_diff_one
tff(fact_1908_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( bit_se4730199178511100633sh_bit(A,N,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)) ) ) ).

% push_bit_minus_one_eq_not_mask
tff(fact_1909_not__one__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% not_one_eq
tff(fact_1910_floor__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,bool),T4: A] :
          ( pp(aa(int,bool,P,archim6421214686448440834_floor(A,T4)))
        <=> ! [I2: int] :
              ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),I2)),T4))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),T4),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),I2)),one_one(A)))) )
             => pp(aa(int,bool,P,I2)) ) ) ) ).

% floor_split
tff(fact_1911_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,A3: int] :
          ( ( archim6421214686448440834_floor(A,X) = A3 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A3)),X))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),A3)),one_one(A)))) ) ) ) ).

% floor_eq_iff
tff(fact_1912_floor__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z2: int,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z2)),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A))))
           => ( archim6421214686448440834_floor(A,X) = Z2 ) ) ) ) ).

% floor_unique
tff(fact_1913_less__floor__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z2: int,X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z2),archim6421214686448440834_floor(A,X)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A))),X)) ) ) ).

% less_floor_iff
tff(fact_1914_floor__le__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Z2: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),archim6421214686448440834_floor(A,X)),Z2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A)))) ) ) ).

% floor_le_iff
tff(fact_1915_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q3: A,P3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,divide_divide(A,P3,Q3)))),Q3)),P3)) ) ) ).

% floor_divide_lower
tff(fact_1916_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q3: A,P3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),P3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,divide_divide(A,P3,Q3)))),one_one(A))),Q3))) ) ) ).

% floor_divide_upper
tff(fact_1917_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A3)),one_one(A)) ) ) ).

% minus_eq_not_plus_1
tff(fact_1918_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))) ) ) ).

% minus_eq_not_minus_1
tff(fact_1919_not__eq__complement,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A3)),one_one(A)) ) ) ).

% not_eq_complement
tff(fact_1920_one__add__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),one_one(int)) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),one_one(A))) ) ) ).

% one_add_floor
tff(fact_1921_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( bit_se2638667681897837118et_bit(A,N,A3) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A3),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se4730199178511100633sh_bit(A,N,one_one(A)))) ) ) ).

% unset_bit_eq_and_not
tff(fact_1922_le__mult__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
           => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(A,A3)),archim6421214686448440834_floor(A,B2))),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))) ) ) ) ).

% le_mult_floor
tff(fact_1923_ceiling__correct,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X))),one_one(A))),X))
          & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,X)))) ) ) ).

% ceiling_correct
tff(fact_1924_ceiling__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z2: int,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A))),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(int,A,ring_1_of_int(A),Z2)))
           => ( archimedean_ceiling(A,X) = Z2 ) ) ) ) ).

% ceiling_unique
tff(fact_1925_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,A3: int] :
          ( ( archimedean_ceiling(A,X) = A3 )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),A3)),one_one(A))),X))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(int,A,ring_1_of_int(A),A3))) ) ) ) ).

% ceiling_eq_iff
tff(fact_1926_ceiling__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,bool),T4: A] :
          ( pp(aa(int,bool,P,archimedean_ceiling(A,T4)))
        <=> ! [I2: int] :
              ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),I2)),one_one(A))),T4))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),T4),aa(int,A,ring_1_of_int(A),I2))) )
             => pp(aa(int,bool,P,I2)) ) ) ) ).

% ceiling_split
tff(fact_1927_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Z2: int] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),archimedean_ceiling(A,X)),Z2))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A)))) ) ) ).

% ceiling_less_iff
tff(fact_1928_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z2: int,X: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z2),archimedean_ceiling(A,X)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A))),X)) ) ) ).

% le_ceiling_iff
tff(fact_1929_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [X: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),X),Y) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),X),Y) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( aa(A,A,bit_ri4277139882892585799ns_not(A),X) = Y ) ) ) ) ).

% bit.compl_unique
tff(fact_1930_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q3: A,P3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),Q3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),P3),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,divide_divide(A,P3,Q3)))),Q3))) ) ) ).

% ceiling_divide_upper
tff(fact_1931_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea2506097494486148201lgebra(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% bit.abstract_boolean_algebra_axioms
tff(fact_1932_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),Z2),one_one(int))) ) ) ).

% of_int_less_1_iff
tff(fact_1933_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(int,A,ring_1_of_int(A),Z2)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),one_one(int)),Z2)) ) ) ).

% of_int_1_less_iff
tff(fact_1934_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z2)),one_one(A)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),Z2),one_one(int))) ) ) ).

% of_int_le_1_iff
tff(fact_1935_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z2: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(int,A,ring_1_of_int(A),Z2)))
        <=> pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),one_one(int)),Z2)) ) ) ).

% of_int_1_le_iff
tff(fact_1936_of__int__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W2: int,Z2: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),W2),Z2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),W2)),aa(int,A,ring_1_of_int(A),Z2)) ) ) ).

% of_int_mult
tff(fact_1937_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z2: int] :
          ( ( aa(int,A,ring_1_of_int(A),Z2) = one_one(A) )
        <=> ( Z2 = one_one(int) ) ) ) ).

% of_int_eq_1_iff
tff(fact_1938_of__int__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( aa(int,A,ring_1_of_int(A),one_one(int)) = one_one(A) ) ) ).

% of_int_1
tff(fact_1939_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [X: int,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),X)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(int,A,ring_1_of_int(A),X)) ) ) ).

% mult_of_int_commute
tff(fact_1940_round__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(int,A,ring_1_of_int(A),Y)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))))
           => ( archimedean_round(A,X) = Y ) ) ) ) ).

% round_unique
tff(fact_1941_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(int,A,ring_1_of_int(A),archimedean_round(A,X)))) ) ).

% of_int_round_gt
tff(fact_1942_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))),aa(int,A,ring_1_of_int(A),archimedean_round(A,X)))) ) ).

% of_int_round_ge
tff(fact_1943_of__int__round__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_round(A,X))),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))) ) ).

% of_int_round_le
tff(fact_1944_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea3799213064322606851m_diff(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A)),bit_se5824344971392196577ns_xor(A)) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
tff(fact_1945_round__def,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archimedean_round(A,X) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ) ).

% round_def
tff(fact_1946_bezw_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(int,int)] :
      ( ( bezw(X,Xa) = Y )
     => ( ( ( Xa = zero_zero(nat) )
         => ( Y = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)) ) )
        & ( ( Xa != zero_zero(nat) )
         => ( Y = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,X,Xa))))) ) ) ) ) ).

% bezw.elims
tff(fact_1947_round__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_round(A,one_one(A)) = one_one(int) ) ) ).

% round_1
tff(fact_1948_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib2,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),Y: A,Z2: A,X: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Xor,Y),Z2)),X) = aa(A,A,aa(A,fun(A,A),Xor,aa(A,A,aa(A,fun(A,A),Conj,Y),X)),aa(A,A,aa(A,fun(A,A),Conj,Z2),X)) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib2
tff(fact_1949_abstract__boolean__algebra__sym__diff_Oxor__cancel__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X),aa(A,A,Compl,X)) = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_right
tff(fact_1950_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A,Y: A,Z2: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Conj,X),aa(A,A,aa(A,fun(A,A),Xor,Y),Z2)) = aa(A,A,aa(A,fun(A,A),Xor,aa(A,A,aa(A,fun(A,A),Conj,X),Y)),aa(A,A,aa(A,fun(A,A),Conj,X),Z2)) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib
tff(fact_1951_abstract__boolean__algebra__sym__diff_Oxor__compl__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A,Y: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X),aa(A,A,Compl,Y)) = aa(A,A,Compl,aa(A,A,aa(A,fun(A,A),Xor,X),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_right
tff(fact_1952_abstract__boolean__algebra__sym__diff_Oxor__cancel__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,aa(A,A,Compl,X)),X) = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_left
tff(fact_1953_abstract__boolean__algebra__sym__diff_Oxor__compl__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A,Y: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,aa(A,A,Compl,X)),Y) = aa(A,A,Compl,aa(A,A,aa(A,fun(A,A),Xor,X),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_left
tff(fact_1954_abstract__boolean__algebra__sym__diff_Oxor__one__right,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X),One) = aa(A,A,Compl,X) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_right
tff(fact_1955_abstract__boolean__algebra__sym__diff_Oxor__left__self,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A,Y: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X),aa(A,A,aa(A,fun(A,A),Xor,X),Y)) = Y ) ) ).

% abstract_boolean_algebra_sym_diff.xor_left_self
tff(fact_1956_abstract__boolean__algebra__sym__diff_Oxor__one__left,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,One),X) = aa(A,A,Compl,X) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_left
tff(fact_1957_abstract__boolean__algebra__sym__diff_Oxor__self,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X),X) = Zero ) ) ).

% abstract_boolean_algebra_sym_diff.xor_self
tff(fact_1958_abstract__boolean__algebra__sym__diff_Oxor__def2,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A,Y: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X),Y) = aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,aa(A,fun(A,A),Disj,X),Y)),aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,Compl,X)),aa(A,A,Compl,Y))) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def2
tff(fact_1959_abstract__boolean__algebra__sym__diff_Oxor__def,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A)),X: A,Y: A] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(A,A,aa(A,fun(A,A),Xor,X),Y) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X),aa(A,A,Compl,Y))),aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,Compl,X)),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def
tff(fact_1960_abstract__boolean__algebra__sym__diff_Oaxioms_I1_J,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A))] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One) ) ).

% abstract_boolean_algebra_sym_diff.axioms(1)
tff(fact_1961_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A,M4: nat,N: nat] : ( divide_divide(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M4)),aa(nat,A,semiring_1_of_nat(A),N))) = divide_divide(A,divide_divide(A,A3,aa(nat,A,semiring_1_of_nat(A),M4)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% div_mult2_eq'
tff(fact_1962_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X))
         => ? [N3: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N3)),X))) ) ) ).

% ex_less_of_nat_mult
tff(fact_1963_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A,M4: nat,N: nat] : ( modulo_modulo(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M4)),aa(nat,A,semiring_1_of_nat(A),N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M4)),modulo_modulo(A,divide_divide(A,A3,aa(nat,A,semiring_1_of_nat(A),M4)),aa(nat,A,semiring_1_of_nat(A),N)))),modulo_modulo(A,A3,aa(nat,A,semiring_1_of_nat(A),M4))) ) ) ).

% mod_mult2_eq'
tff(fact_1964_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [E2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),E2))
         => ~ ! [N3: nat] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),divide_divide(A,one_one(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N3)))),E2)) ) ) ).

% nat_approx_posE
tff(fact_1965_bezw__non__0,axiom,
    ! [Y: nat,X: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),Y))
     => ( bezw(X,Y) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,X,Y))))) ) ) ).

% bezw_non_0
tff(fact_1966_bezw_Osimps,axiom,
    ! [Y: nat,X: nat] :
      ( ( ( Y = zero_zero(nat) )
       => ( bezw(X,Y) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)) ) )
      & ( ( Y != zero_zero(nat) )
       => ( bezw(X,Y) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,X,Y))))) ) ) ) ).

% bezw.simps
tff(fact_1967_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M4: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,M4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),M4)) ) ) ).

% of_nat_Suc
tff(fact_1968_of__nat__1,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),one_one(nat)) = one_one(A) ) ) ).

% of_nat_1
tff(fact_1969_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( ( one_one(A) = aa(nat,A,semiring_1_of_nat(A),N) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_1_eq_iff
tff(fact_1970_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),N) = one_one(A) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_eq_1_iff
tff(fact_1971_of__nat__mult,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M4: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M4),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M4)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_mult
tff(fact_1972_bezw_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(int,int)] :
      ( ( bezw(X,Xa) = Y )
     => ( pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),bezw_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa)))
       => ~ ( ( ( ( Xa = zero_zero(nat) )
               => ( Y = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)) ) )
              & ( ( Xa != zero_zero(nat) )
               => ( Y = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,X,Xa))))) ) ) )
           => ~ pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),bezw_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa))) ) ) ) ).

% bezw.pelims
tff(fact_1973_round__altdef,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),archimedean_frac(A,X)))
           => ( archimedean_round(A,X) = archimedean_ceiling(A,X) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),archimedean_frac(A,X)))
           => ( archimedean_round(A,X) = archim6421214686448440834_floor(A,X) ) ) ) ) ).

% round_altdef
tff(fact_1974_frac__lt__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),archimedean_frac(A,X)),one_one(A))) ) ).

% frac_lt_1
tff(fact_1975_frac__1__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),one_one(A))) = archimedean_frac(A,X) ) ) ).

% frac_1_eq
tff(fact_1976_bot__nat__def,axiom,
    bot_bot(nat) = zero_zero(nat) ).

% bot_nat_def
tff(fact_1977_inf__nat__def,axiom,
    inf_inf(nat) = ord_min(nat) ).

% inf_nat_def
tff(fact_1978_frac__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( ( archimedean_frac(A,X) = X )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),one_one(A))) ) ) ) ).

% frac_eq
tff(fact_1979_frac__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X)),archimedean_frac(A,Y))),one_one(A)))
           => ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X)),archimedean_frac(A,Y)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X)),archimedean_frac(A,Y))),one_one(A)))
           => ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X)),archimedean_frac(A,Y))),one_one(A)) ) ) ) ) ).

% frac_add
tff(fact_1980_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [X: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),X)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(nat,A,semiring_1_of_nat(A),X)) ) ) ).

% mult_of_nat_commute
tff(fact_1981_floor__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X)),archimedean_frac(A,Y))),one_one(A)))
           => ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),archim6421214686448440834_floor(A,Y)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,X)),archimedean_frac(A,Y))),one_one(A)))
           => ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,X)),archim6421214686448440834_floor(A,Y))),one_one(int)) ) ) ) ) ).

% floor_add
tff(fact_1982_pochhammer__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z2: A,N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Z2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))),comm_s3205402744901411588hammer(A,Z2,N))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),N)) ) ) ).

% pochhammer_double
tff(fact_1983_round__unique_H,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(int,A,ring_1_of_int(A),N)))),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))))
         => ( archimedean_round(A,X) = N ) ) ) ).

% round_unique'
tff(fact_1984_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_round(A,X))),X))),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))))) ) ).

% of_int_round_abs_le
tff(fact_1985_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B2: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K)) ) ) ).

% pochhammer_minus
tff(fact_1986_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B2: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B2),K)) ) ) ).

% pochhammer_minus'
tff(fact_1987_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & linordered_idom(A) )
     => ! [A3: B,B2: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),A3))
         => ( pp(member(B,A3,ring_1_Ints(B)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),B2)))),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(B,A3)),archimedean_ceiling(B,B2))))) ) ) ) ).

% mult_ceiling_le_Ints
tff(fact_1988_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & linordered_idom(A) )
     => ! [A3: B,B2: B] :
          ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),A3))
         => ( pp(member(B,A3,ring_1_Ints(B)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(B,A3)),archim6421214686448440834_floor(B,B2)))),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),B2))))) ) ) ) ).

% le_mult_floor_Ints
tff(fact_1989_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A3)) = aa(A,A,abs_abs(A),A3) ) ) ).

% abs_idempotent
tff(fact_1990_abs__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_zero
tff(fact_1991_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( ( aa(A,A,abs_abs(A),A3) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% abs_eq_0
tff(fact_1992_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( ( zero_zero(A) = aa(A,A,abs_abs(A),A3) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% abs_0_eq
tff(fact_1993_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_add_abs
tff(fact_1994_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),A3)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),A3) ) ) ).

% abs_mult_self_eq
tff(fact_1995_abs__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_1
tff(fact_1996_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A3)) = aa(A,A,abs_abs(A),A3) ) ) ).

% abs_minus_cancel
tff(fact_1997_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),zero_zero(A)))
        <=> ( A3 = zero_zero(A) ) ) ) ).

% abs_le_zero_iff
tff(fact_1998_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),A3))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3)) ) ) ).

% abs_le_self_iff
tff(fact_1999_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => ( aa(A,A,abs_abs(A),A3) = A3 ) ) ) ).

% abs_of_nonneg
tff(fact_2000_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,abs_abs(A),A3)))
        <=> ( A3 != zero_zero(A) ) ) ) ).

% zero_less_abs_iff
tff(fact_2001_abs__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),one_one(A))) = one_one(A) ) ) ).

% abs_neg_one
tff(fact_2002_pochhammer__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A] : ( comm_s3205402744901411588hammer(A,A3,zero_zero(nat)) = one_one(A) ) ) ).

% pochhammer_0
tff(fact_2003_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A)))
         => ( aa(A,A,abs_abs(A),A3) = aa(A,A,uminus_uminus(A),A3) ) ) ) ).

% abs_of_nonpos
tff(fact_2004_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A3)) = one_one(A) ) ) ) ).

% abs_sgn_eq_1
tff(fact_2005_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,abs_abs(A),A3))) ) ).

% abs_ge_self
tff(fact_2006_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% abs_le_D1
tff(fact_2007_abs__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_mult
tff(fact_2008_abs__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_one
tff(fact_2009_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)) ) ) ).

% abs_minus_commute
tff(fact_2010_Ints__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A3: A,B2: A] :
          ( pp(member(A,A3,ring_1_Ints(A)))
         => ( pp(member(A,B2,ring_1_Ints(A)))
           => pp(member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),ring_1_Ints(A))) ) ) ) ).

% Ints_mult
tff(fact_2011_Ints__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => pp(member(A,one_one(A),ring_1_Ints(A))) ) ).

% Ints_1
tff(fact_2012_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( pp(member(A,X,ring_1_Ints(A)))
         => ( ( X != zero_zero(A) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,abs_abs(A),X))) ) ) ) ).

% Ints_nonzero_abs_ge1
tff(fact_2013_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( pp(member(A,X,ring_1_Ints(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),X)),one_one(A)))
           => ( X = zero_zero(A) ) ) ) ) ).

% Ints_nonzero_abs_less1
tff(fact_2014_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( pp(member(A,X,ring_1_Ints(A)))
         => ( pp(member(A,Y,ring_1_Ints(A)))
           => ( ( X = Y )
            <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y))),one_one(A))) ) ) ) ) ).

% Ints_eq_abs_less1
tff(fact_2015_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(A,A,abs_abs(A),A3))) ) ).

% abs_ge_zero
tff(fact_2016_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( aa(A,A,abs_abs(A),A3) = A3 ) ) ) ).

% abs_of_pos
tff(fact_2017_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),A3)),zero_zero(A))) ) ).

% abs_not_less_zero
tff(fact_2018_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)))) ) ).

% abs_triangle_ineq
tff(fact_2019_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3)))) ) ).

% abs_triangle_ineq2_sym
tff(fact_2020_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))) ) ).

% abs_triangle_ineq3
tff(fact_2021_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2)))) ) ).

% abs_triangle_ineq2
tff(fact_2022_abs__mult__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A,C2: A,B2: A,D2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),A3)),C2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),B2)),D2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2))),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D2))) ) ) ) ).

% abs_mult_less
tff(fact_2023_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),aa(A,A,abs_abs(A),A3))) ) ).

% abs_ge_minus_self
tff(fact_2024_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),B2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),B2)) ) ) ) ).

% abs_le_iff
tff(fact_2025_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),B2)) ) ) ).

% abs_le_D2
tff(fact_2026_abs__leI,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),A3)),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),A3)),B2)) ) ) ) ).

% abs_leI
tff(fact_2027_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),X)),aa(A,A,abs_abs(A),X)) = X ) ) ).

% mult_sgn_abs
tff(fact_2028_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A3)),aa(A,A,abs_abs(A),A3)) = A3 ) ) ).

% sgn_mult_abs
tff(fact_2029_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A3)),aa(A,A,sgn_sgn(A),A3)) = A3 ) ) ).

% abs_mult_sgn
tff(fact_2030_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [K: A] : ( aa(A,A,abs_abs(A),K) = aa(A,A,aa(A,fun(A,A),times_times(A),K),aa(A,A,sgn_sgn(A),K)) ) ) ).

% linordered_idom_class.abs_sgn
tff(fact_2031_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs(A)
        & dense_linorder(A) )
     => ! [X: A] :
          ( ! [E3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),E3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X)),E3)) )
         => ( X = zero_zero(A) ) ) ) ).

% dense_eq0_I
tff(fact_2032_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ordered_ring_abs(A)
     => ! [A3: A,B2: A] :
          ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
              | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),zero_zero(A))) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),B2))
              | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),zero_zero(A))) ) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% abs_eq_mult
tff(fact_2033_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),Y)),X) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y),X)) ) ) ) ).

% abs_mult_pos
tff(fact_2034_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,abs_abs(A),A3))),zero_zero(A))) ) ).

% abs_minus_le_zero
tff(fact_2035_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A,C2: A,D2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),C2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2))))) ) ).

% abs_diff_triangle_ineq
tff(fact_2036_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A3)),aa(A,A,abs_abs(A),B2)))) ) ).

% abs_triangle_ineq4
tff(fact_2037_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A)))
         => ( aa(A,A,abs_abs(A),A3) = aa(A,A,uminus_uminus(A),A3) ) ) ) ).

% abs_of_neg
tff(fact_2038_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( ( ( A3 = zero_zero(A) )
           => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A3)) = zero_zero(A) ) )
          & ( ( A3 != zero_zero(A) )
           => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A3)) = one_one(A) ) ) ) ) ).

% abs_sgn_eq
tff(fact_2039_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] :
          ( ( ( N = zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,zero_zero(A),N) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,zero_zero(A),N) = zero_zero(A) ) ) ) ) ).

% pochhammer_0_left
tff(fact_2040_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [A3: A] :
          ( pp(member(A,A3,ring_1_Ints(A)))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3)),A3) != zero_zero(A) ) ) ) ).

% Ints_odd_nonzero
tff(fact_2041_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,abs_abs(A),X)))) ) ).

% abs_add_one_gt_zero
tff(fact_2042_of__int__leD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: int,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),N))),X))
         => ( ( N = zero_zero(int) )
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X)) ) ) ) ).

% of_int_leD
tff(fact_2043_of__int__lessD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: int,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),N))),X))
         => ( ( N = zero_zero(int) )
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X)) ) ) ) ).

% of_int_lessD
tff(fact_2044_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,N: nat] : ( comm_s3205402744901411588hammer(A,A3,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A)),N)) ) ) ).

% pochhammer_rec
tff(fact_2045_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z2: A,N: nat] : ( comm_s3205402744901411588hammer(A,Z2,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),aa(nat,A,semiring_1_of_nat(A),N))),comm_s3205402744901411588hammer(A,Z2,N)) ) ) ).

% pochhammer_rec'
tff(fact_2046_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,N: nat] : ( comm_s3205402744901411588hammer(A,A3,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,A3,N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(nat,A,semiring_1_of_nat(A),N))) ) ) ).

% pochhammer_Suc
tff(fact_2047_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z2: A,N: nat,M4: nat] : ( comm_s3205402744901411588hammer(A,Z2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M4)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z2,N)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),aa(nat,A,semiring_1_of_nat(A),N)),M4)) ) ) ).

% pochhammer_product'
tff(fact_2048_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A3: A] :
          ( pp(member(A,A3,ring_1_Ints(A)))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A3)),A3)),zero_zero(A)))
          <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),zero_zero(A))) ) ) ) ).

% Ints_odd_less_0
tff(fact_2049_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(A) )
        <=> ( aa(A,A,abs_abs(A),X) = one_one(A) ) ) ) ).

% abs_square_eq_1
tff(fact_2050_pochhammer__product,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [M4: nat,N: nat,Z2: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( comm_s3205402744901411588hammer(A,Z2,N) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z2,M4)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),aa(nat,A,semiring_1_of_nat(A),M4)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ) ).

% pochhammer_product
tff(fact_2051_eucl__rel__int__remainderI,axiom,
    ! [R3: int,L: int,K: int,Q3: int] :
      ( ( aa(int,int,sgn_sgn(int),R3) = aa(int,int,sgn_sgn(int),L) )
     => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,abs_abs(int),R3)),aa(int,int,abs_abs(int),L)))
       => ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q3),L)),R3) )
         => eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q3),R3)) ) ) ) ).

% eucl_rel_int_remainderI
tff(fact_2052_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X)),one_one(A))) ) ) ).

% abs_square_le_1
tff(fact_2053_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(A)))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,abs_abs(A),X)),one_one(A))) ) ) ).

% abs_square_less_1
tff(fact_2054_frac__neg,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A] :
          ( ( pp(member(A,X,ring_1_Ints(A)))
           => ( archimedean_frac(A,aa(A,A,uminus_uminus(A),X)) = zero_zero(A) ) )
          & ( ~ pp(member(A,X,ring_1_Ints(A)))
           => ( archimedean_frac(A,aa(A,A,uminus_uminus(A),X)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),archimedean_frac(A,X)) ) ) ) ) ).

% frac_neg
tff(fact_2055_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [R3: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),R3),aa(nat,A,semiring_1_of_nat(A),K))),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),R3),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),R3),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),R3)),one_one(A)),K)) ) ) ).

% pochhammer_absorb_comp
tff(fact_2056_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
     => ( ( ( A22 = zero_zero(int) )
         => ( A32 != aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),A1) ) )
       => ( ! [Q6: int] :
              ( ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q6),zero_zero(int)) )
             => ( ( A22 != zero_zero(int) )
               => ( A1 != aa(int,int,aa(int,fun(int,int),times_times(int),Q6),A22) ) ) )
         => ~ ! [R2: int,Q6: int] :
                ( ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q6),R2) )
               => ( ( aa(int,int,sgn_sgn(int),R2) = aa(int,int,sgn_sgn(int),A22) )
                 => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,abs_abs(int),R2)),aa(int,int,abs_abs(int),A22)))
                   => ( A1 != aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q6),A22)),R2) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
tff(fact_2057_eucl__rel__int_Osimps,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
    <=> ( ? [K4: int] :
            ( ( A1 = K4 )
            & ( A22 = zero_zero(int) )
            & ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),K4) ) )
        | ? [L4: int,K4: int,Q7: int] :
            ( ( A1 = K4 )
            & ( A22 = L4 )
            & ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q7),zero_zero(int)) )
            & ( L4 != zero_zero(int) )
            & ( K4 = aa(int,int,aa(int,fun(int,int),times_times(int),Q7),L4) ) )
        | ? [R5: int,L4: int,K4: int,Q7: int] :
            ( ( A1 = K4 )
            & ( A22 = L4 )
            & ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q7),R5) )
            & ( aa(int,int,sgn_sgn(int),R5) = aa(int,int,sgn_sgn(int),L4) )
            & pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),aa(int,int,abs_abs(int),R5)),aa(int,int,abs_abs(int),L4)))
            & ( K4 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q7),L4)),R5) ) ) ) ) ).

% eucl_rel_int.simps
tff(fact_2058_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [X: A,A3: A] :
          ( ( archimedean_frac(A,X) = A3 )
        <=> ( pp(member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A3),ring_1_Ints(A)))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A))) ) ) ) ).

% frac_unique_iff
tff(fact_2059_fact__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))),comm_s3205402744901411588hammer(A,divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N))),semiring_char_0_fact(A,N)) ) ) ).

% fact_double
tff(fact_2060_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
         => ( aa(nat,A,gbinomial(A,A3),K) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ) ).

% gbinomial_absorption'
tff(fact_2061_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: set(A)] :
          ( ( gcd_Gcd(A,A4) = zero_zero(A) )
        <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),insert2(A,zero_zero(A)),bot_bot(set(A))))) ) ) ).

% Gcd_0_iff
tff(fact_2062_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_ring_1(A)
        & semiri3467727345109120633visors(A) )
     => ! [N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),semiring_char_0_fact(A,N)) ) ) ).

% pochhammer_same
tff(fact_2063_fact__reduce,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( semiring_char_0_fact(A,N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ) ) ).

% fact_reduce
tff(fact_2064_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M4: nat] :
          ( ( ( M4 = zero_zero(nat) )
           => ( semiring_char_0_fact(A,M4) = one_one(A) ) )
          & ( ( M4 != zero_zero(nat) )
           => ( semiring_char_0_fact(A,M4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M4)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),one_one(nat)))) ) ) ) ) ).

% fact_num_eq_if
tff(fact_2065_abstract__boolean__algebra__sym__diff__def,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A))] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
    <=> ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
        & boolea5476839437570043046axioms(A,Conj,Disj,Compl,Xor) ) ) ).

% abstract_boolean_algebra_sym_diff_def
tff(fact_2066_fact__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,zero_zero(nat)) = one_one(A) ) ) ).

% fact_0
tff(fact_2067_Gcd__empty,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Gcd(A,bot_bot(set(A))) = zero_zero(A) ) ) ).

% Gcd_empty
tff(fact_2068_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A3: A] : ( aa(nat,A,gbinomial(A,A3),zero_zero(nat)) = one_one(A) ) ) ).

% gbinomial_0(1)
tff(fact_2069_fact__1,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,one_one(nat)) = one_one(A) ) ) ).

% fact_1
tff(fact_2070_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Gcd(A,top_top(set(A))) = one_one(A) ) ) ).

% Gcd_UNIV
tff(fact_2071_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% fact_Suc_0
tff(fact_2072_fact__Suc,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N))),semiring_char_0_fact(A,N)) ) ) ).

% fact_Suc
tff(fact_2073_abstract__boolean__algebra__sym__diff__axioms_Ointro,axiom,
    ! [A: $tType,Xor: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Conj: fun(A,fun(A,A)),Compl: fun(A,A)] :
      ( ! [X2: A,Y2: A] : ( aa(A,A,aa(A,fun(A,A),Xor,X2),Y2) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X2),aa(A,A,Compl,Y2))),aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,Compl,X2)),Y2)) )
     => boolea5476839437570043046axioms(A,Conj,Disj,Compl,Xor) ) ).

% abstract_boolean_algebra_sym_diff_axioms.intro
tff(fact_2074_abstract__boolean__algebra__sym__diff__axioms__def,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Xor: fun(A,fun(A,A))] :
      ( boolea5476839437570043046axioms(A,Conj,Disj,Compl,Xor)
    <=> ! [X4: A,Y3: A] : ( aa(A,A,aa(A,fun(A,A),Xor,X4),Y3) = aa(A,A,aa(A,fun(A,A),Disj,aa(A,A,aa(A,fun(A,A),Conj,X4),aa(A,A,Compl,Y3))),aa(A,A,aa(A,fun(A,A),Conj,aa(A,A,Compl,X4)),Y3)) ) ) ).

% abstract_boolean_algebra_sym_diff_axioms_def
tff(fact_2075_Gcd__1,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: set(A)] :
          ( pp(member(A,one_one(A),A4))
         => ( gcd_Gcd(A,A4) = one_one(A) ) ) ) ).

% Gcd_1
tff(fact_2076_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,A3),K)),aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc_Suc
tff(fact_2077_fact__ge__1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),semiring_char_0_fact(A,N))) ) ).

% fact_ge_1
tff(fact_2078_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,N: nat] : pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,N)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N)))) ) ).

% fact_fact_dvd_fact
tff(fact_2079_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_semiring_1(A) )
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = comm_s3205402744901411588hammer(A,one_one(A),N) ) ) ).

% pochhammer_fact
tff(fact_2080_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),K) = divide_divide(A,comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer'
tff(fact_2081_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),K) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),A3),K)),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer
tff(fact_2082_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: A,A4: set(A)] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( pp(member(A,A3,A4))
           => ( gcd_Gcd(A,A4) = one_one(A) ) ) ) ) ).

% Gcd_eq_1_I
tff(fact_2083_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),K)) ) ) ).

% gbinomial_addition_formula
tff(fact_2084_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,A3),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),K)) ) ) ).

% gbinomial_absorb_comp
tff(fact_2085_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A3),K)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A3),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1'
tff(fact_2086_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,gbinomial(A,A3),K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A3),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1
tff(fact_2087_choose__dvd,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))),semiring_char_0_fact(A,N))) ) ) ).

% choose_dvd
tff(fact_2088_abstract__boolean__algebra__sym__diff_Oaxioms_I2_J,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A))] :
      ( boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor)
     => boolea5476839437570043046axioms(A,Conj,Disj,Compl,Xor) ) ).

% abstract_boolean_algebra_sym_diff.axioms(2)
tff(fact_2089_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,A,gbinomial(A,A3),K)) ) ) ).

% Suc_times_gbinomial
tff(fact_2090_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A3),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),K)) ) ) ).

% gbinomial_absorption
tff(fact_2091_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,M4: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),M4))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A3),M4)),aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),M4)),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A3),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),K))) ) ) ) ).

% gbinomial_trinomial_revision
tff(fact_2092_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A3),K)),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_rec
tff(fact_2093_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))),aa(nat,A,gbinomial(A,A3),K)) ) ) ).

% gbinomial_factors
tff(fact_2094_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N))),one_one(A))),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),N)) ) ) ).

% gbinomial_index_swap
tff(fact_2095_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,A3),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),K)),A3)),one_one(A))),K)) ) ) ).

% gbinomial_negated_upper
tff(fact_2096_fact__numeral,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: num] : ( semiring_char_0_fact(A,aa(num,nat,numeral_numeral(nat),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),semiring_char_0_fact(A,pred_numeral(K))) ) ) ).

% fact_numeral
tff(fact_2097_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),A3)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),K)) ) ) ).

% gbinomial_minus
tff(fact_2098_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),K))
         => ( aa(nat,A,gbinomial(A,A3),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),K)) ) ) ) ).

% gbinomial_reduce_nat
tff(fact_2099_abstract__boolean__algebra__sym__diff_Ointro,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A,Xor: fun(A,fun(A,A))] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => ( boolea5476839437570043046axioms(A,Conj,Disj,Compl,Xor)
       => boolea3799213064322606851m_diff(A,Conj,Disj,Compl,Zero,One,Xor) ) ) ).

% abstract_boolean_algebra_sym_diff.intro
tff(fact_2100_quotient__of__number_I5_J,axiom,
    ! [K: num] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),K))) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)) ) ).

% quotient_of_number(5)
tff(fact_2101_binomial__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(nat,A,semiring_1_of_nat(A),binomial(N,K)) = divide_divide(A,semiring_char_0_fact(A,N),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))) ) ) ) ).

% binomial_fact
tff(fact_2102_fact__binomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,semiring_1_of_nat(A),binomial(N,K))) = divide_divide(A,semiring_char_0_fact(A,N),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_binomial
tff(fact_2103_card__doubleton__eq__2__iff,axiom,
    ! [A: $tType,A3: A,B2: A] :
      ( ( finite_card(A,aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ( A3 != B2 ) ) ).

% card_doubleton_eq_2_iff
tff(fact_2104_refl__on__singleton,axiom,
    ! [A: $tType,X: A] : refl_on(A,aa(set(A),set(A),insert2(A,X),bot_bot(set(A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),X)),bot_bot(set(product_prod(A,A))))) ).

% refl_on_singleton
tff(fact_2105_pair__lessI2,axiom,
    ! [A3: nat,B2: nat,S: nat,T4: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),B2))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),S),T4))
       => pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),S)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),B2),T4)),fun_pair_less)) ) ) ).

% pair_lessI2
tff(fact_2106_euclidean__size__times__nonunit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( ~ pp(dvd_dvd(A,A3,one_one(A)))
             => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),B2)),aa(A,nat,euclid6346220572633701492n_size(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))) ) ) ) ) ).

% euclidean_size_times_nonunit
tff(fact_2107_euclidean__size__1,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( aa(A,nat,euclid6346220572633701492n_size(A),one_one(A)) = one_one(nat) ) ) ).

% euclidean_size_1
tff(fact_2108_rat__one__code,axiom,
    quotient_of(one_one(rat)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int)) ).

% rat_one_code
tff(fact_2109_rat__zero__code,axiom,
    quotient_of(zero_zero(rat)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)) ).

% rat_zero_code
tff(fact_2110_pair__less__iff1,axiom,
    ! [X: nat,Y: nat,Z2: nat] :
      ( pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Y)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Z2)),fun_pair_less))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Y),Z2)) ) ).

% pair_less_iff1
tff(fact_2111_quotient__of__number_I4_J,axiom,
    quotient_of(aa(rat,rat,uminus_uminus(rat),one_one(rat))) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),one_one(int))),one_one(int)) ).

% quotient_of_number(4)
tff(fact_2112_quotient__of__number_I3_J,axiom,
    ! [K: num] : ( quotient_of(aa(num,rat,numeral_numeral(rat),K)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(num,int,numeral_numeral(int),K)),one_one(int)) ) ).

% quotient_of_number(3)
tff(fact_2113_refl__onD,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),A3: A] :
      ( refl_on(A,A4,R3)
     => ( pp(member(A,A3,A4))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),A3),R3)) ) ) ).

% refl_onD
tff(fact_2114_refl__onD1,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X: A,Y: A] :
      ( refl_on(A,A4,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
       => pp(member(A,X,A4)) ) ) ).

% refl_onD1
tff(fact_2115_refl__onD2,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X: A,Y: A] :
      ( refl_on(A,A4,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
       => pp(member(A,Y,A4)) ) ) ).

% refl_onD2
tff(fact_2116_refl__on__Int,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),B3: set(A),S: set(product_prod(A,A))] :
      ( refl_on(A,A4,R3)
     => ( refl_on(A,B3,S)
       => refl_on(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),S)) ) ) ).

% refl_on_Int
tff(fact_2117_quotient__of__div,axiom,
    ! [R3: rat,N: int,D2: int] :
      ( ( quotient_of(R3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),N),D2) )
     => ( R3 = divide_divide(rat,aa(int,rat,ring_1_of_int(rat),N),aa(int,rat,ring_1_of_int(rat),D2)) ) ) ).

% quotient_of_div
tff(fact_2118_euclidean__size__unit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,nat,euclid6346220572633701492n_size(A),A3) = aa(A,nat,euclid6346220572633701492n_size(A),one_one(A)) ) ) ) ).

% euclidean_size_unit
tff(fact_2119_euclidean__size__mult,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A3: A,B2: A] : ( aa(A,nat,euclid6346220572633701492n_size(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,euclid6346220572633701492n_size(A),A3)),aa(A,nat,euclid6346220572633701492n_size(A),B2)) ) ) ).

% euclidean_size_mult
tff(fact_2120_refl__on__empty,axiom,
    ! [A: $tType] : refl_on(A,bot_bot(set(A)),bot_bot(set(product_prod(A,A)))) ).

% refl_on_empty
tff(fact_2121_unit__iff__euclidean__size,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
        <=> ( ( aa(A,nat,euclid6346220572633701492n_size(A),A3) = aa(A,nat,euclid6346220572633701492n_size(A),one_one(A)) )
            & ( A3 != zero_zero(A) ) ) ) ) ).

% unit_iff_euclidean_size
tff(fact_2122_size__mult__mono_H,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,euclid6346220572633701492n_size(A),A3)),aa(A,nat,euclid6346220572633701492n_size(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)))) ) ) ).

% size_mult_mono'
tff(fact_2123_size__mult__mono,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,euclid6346220572633701492n_size(A),A3)),aa(A,nat,euclid6346220572633701492n_size(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))) ) ) ).

% size_mult_mono
tff(fact_2124_euclidean__size__times__unit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,nat,euclid6346220572633701492n_size(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,nat,euclid6346220572633701492n_size(A),B2) ) ) ) ).

% euclidean_size_times_unit
tff(fact_2125_quotient__of__denom__pos,axiom,
    ! [R3: rat,P3: int,Q3: int] :
      ( ( quotient_of(R3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),Q3) )
     => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Q3)) ) ).

% quotient_of_denom_pos
tff(fact_2126_pair__lessI1,axiom,
    ! [A3: nat,B2: nat,S: nat,T4: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),A3),B2))
     => pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),S)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),B2),T4)),fun_pair_less)) ) ).

% pair_lessI1
tff(fact_2127_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ~ pp(dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),finite_card(A,A4)))
     => ( A4 != bot_bot(set(A)) ) ) ).

% odd_card_imp_not_empty
tff(fact_2128_rat__sgn__code,axiom,
    ! [P3: rat] : ( quotient_of(aa(rat,rat,sgn_sgn(rat),P3)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,sgn_sgn(int),aa(product_prod(int,int),int,product_fst(int,int),quotient_of(P3)))),one_one(int)) ) ).

% rat_sgn_code
tff(fact_2129_card_Oempty,axiom,
    ! [A: $tType] : ( finite_card(A,bot_bot(set(A))) = zero_zero(nat) ) ).

% card.empty
tff(fact_2130_card__Diff__singleton,axiom,
    ! [A: $tType,X: A,A4: set(A)] :
      ( pp(member(A,X,A4))
     => ( finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(A,A4)),one_one(nat)) ) ) ).

% card_Diff_singleton
tff(fact_2131_card__Diff__singleton__if,axiom,
    ! [A: $tType,X: A,A4: set(A)] :
      ( ( pp(member(A,X,A4))
       => ( finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(A,A4)),one_one(nat)) ) )
      & ( ~ pp(member(A,X,A4))
       => ( finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))) = finite_card(A,A4) ) ) ) ).

% card_Diff_singleton_if
tff(fact_2132_card__3__iff,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ( finite_card(A,S2) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) )
    <=> ? [X4: A,Y3: A,Z4: A] :
          ( ( S2 = aa(set(A),set(A),insert2(A,X4),aa(set(A),set(A),insert2(A,Y3),aa(set(A),set(A),insert2(A,Z4),bot_bot(set(A))))) )
          & ( X4 != Y3 )
          & ( Y3 != Z4 )
          & ( X4 != Z4 ) ) ) ).

% card_3_iff
tff(fact_2133_card__2__iff,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ( finite_card(A,S2) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ? [X4: A,Y3: A] :
          ( ( S2 = aa(set(A),set(A),insert2(A,X4),aa(set(A),set(A),insert2(A,Y3),bot_bot(set(A)))) )
          & ( X4 != Y3 ) ) ) ).

% card_2_iff
tff(fact_2134_card__Diff1__le,axiom,
    ! [A: $tType,A4: set(A),X: A] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))),finite_card(A,A4))) ).

% card_Diff1_le
tff(fact_2135_card__Suc__eq,axiom,
    ! [A: $tType,A4: set(A),K: nat] :
      ( ( finite_card(A,A4) = aa(nat,nat,suc,K) )
    <=> ? [B6: A,B8: set(A)] :
          ( ( A4 = aa(set(A),set(A),insert2(A,B6),B8) )
          & ~ pp(member(A,B6,B8))
          & ( finite_card(A,B8) = K )
          & ( ( K = zero_zero(nat) )
           => ( B8 = bot_bot(set(A)) ) ) ) ) ).

% card_Suc_eq
tff(fact_2136_card_Ocomp__fun__commute__on,axiom,
    aa(fun(nat,nat),fun(nat,nat),aa(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),comp(nat,nat,nat),suc),suc) = aa(fun(nat,nat),fun(nat,nat),aa(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),comp(nat,nat,nat),suc),suc) ).

% card.comp_fun_commute_on
tff(fact_2137_fold__atLeastAtMost__nat_Ocases,axiom,
    ! [A: $tType,X: product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)))] :
      ~ ! [F9: fun(nat,fun(A,A)),A8: nat,B5: nat,Acc: A] : ( X != aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),aa(fun(nat,fun(A,A)),fun(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),F9),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),aa(nat,fun(product_prod(nat,A),product_prod(nat,product_prod(nat,A))),product_Pair(nat,product_prod(nat,A)),A8),aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),B5),Acc))) ) ).

% fold_atLeastAtMost_nat.cases
tff(fact_2138_card__1__singletonE,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ( finite_card(A,A4) = one_one(nat) )
     => ~ ! [X2: A] : ( A4 != aa(set(A),set(A),insert2(A,X2),bot_bot(set(A))) ) ) ).

% card_1_singletonE
tff(fact_2139_card__1__singleton__iff,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ( finite_card(A,A4) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ? [X4: A] : ( A4 = aa(set(A),set(A),insert2(A,X4),bot_bot(set(A))) ) ) ).

% card_1_singleton_iff
tff(fact_2140_card__eq__SucD,axiom,
    ! [A: $tType,A4: set(A),K: nat] :
      ( ( finite_card(A,A4) = aa(nat,nat,suc,K) )
     => ? [B5: A,B9: set(A)] :
          ( ( A4 = aa(set(A),set(A),insert2(A,B5),B9) )
          & ~ pp(member(A,B5,B9))
          & ( finite_card(A,B9) = K )
          & ( ( K = zero_zero(nat) )
           => ( B9 = bot_bot(set(A)) ) ) ) ) ).

% card_eq_SucD
tff(fact_2141_quotient__of__int,axiom,
    ! [A3: int] : ( quotient_of(of_int(A3)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),one_one(int)) ) ).

% quotient_of_int
tff(fact_2142_Frct__code__post_I5_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),aa(num,int,numeral_numeral(int),K))) = divide_divide(rat,one_one(rat),aa(num,rat,numeral_numeral(rat),K)) ) ).

% Frct_code_post(5)
tff(fact_2143_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: fun(nat,fun(A,A)),A1: nat,A22: nat,A32: A,P: fun(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,bool))))] :
      ( pp(aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),aa(fun(nat,fun(A,A)),fun(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),A0),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),aa(nat,fun(product_prod(nat,A),product_prod(nat,product_prod(nat,A))),product_Pair(nat,product_prod(nat,A)),A1),aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),A22),A32)))))
     => ( ! [F9: fun(nat,fun(A,A)),A8: nat,B5: nat,Acc: A] :
            ( pp(aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),aa(fun(nat,fun(A,A)),fun(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),F9),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),aa(nat,fun(product_prod(nat,A),product_prod(nat,product_prod(nat,A))),product_Pair(nat,product_prod(nat,A)),A8),aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),B5),Acc)))))
           => ( ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),B5),A8))
               => pp(aa(A,bool,aa(nat,fun(A,bool),aa(nat,fun(nat,fun(A,bool)),aa(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,bool))),P,F9),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A8),one_one(nat))),B5),aa(A,A,aa(nat,fun(A,A),F9,A8),Acc))) )
             => pp(aa(A,bool,aa(nat,fun(A,bool),aa(nat,fun(nat,fun(A,bool)),aa(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,bool))),P,F9),A8),B5),Acc)) ) )
       => pp(aa(A,bool,aa(nat,fun(A,bool),aa(nat,fun(nat,fun(A,bool)),aa(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,bool))),P,A0),A1),A22),A32)) ) ) ).

% fold_atLeastAtMost_nat.pinduct
tff(fact_2144_divmod__cases,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,A3: A] :
          ( ( ( B2 != zero_zero(A) )
           => ( ( modulo_modulo(A,A3,B2) = zero_zero(A) )
             => ( A3 != aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A3,B2)),B2) ) ) )
         => ( ( ( B2 != zero_zero(A) )
             => ! [Q6: A,R2: A] :
                  ( ( euclid7384307370059645450egment(A,R2) = euclid7384307370059645450egment(A,B2) )
                 => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),R2)),aa(A,nat,euclid6346220572633701492n_size(A),B2)))
                   => ( ( R2 != zero_zero(A) )
                     => ( ( divide_divide(A,A3,B2) = Q6 )
                       => ( ( modulo_modulo(A,A3,B2) = R2 )
                         => ( A3 != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q6),B2)),R2) ) ) ) ) ) ) )
           => ( B2 = zero_zero(A) ) ) ) ) ).

% divmod_cases
tff(fact_2145_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(num,int,numeral_numeral(int),K)),aa(num,int,numeral_numeral(int),L))) = divide_divide(rat,aa(num,rat,numeral_numeral(rat),K),aa(num,rat,numeral_numeral(rat),L)) ) ).

% Frct_code_post(6)
tff(fact_2146_mod__eqI,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,R3: A,Q3: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R3) = euclid7384307370059645450egment(A,B2) )
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),R3)),aa(A,nat,euclid6346220572633701492n_size(A),B2)))
             => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q3),B2)),R3) = A3 )
               => ( modulo_modulo(A,A3,B2) = R3 ) ) ) ) ) ) ).

% mod_eqI
tff(fact_2147_div__eqI,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,R3: A,Q3: A,A3: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R3) = euclid7384307370059645450egment(A,B2) )
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),R3)),aa(A,nat,euclid6346220572633701492n_size(A),B2)))
             => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q3),B2)),R3) = A3 )
               => ( divide_divide(A,A3,B2) = Q3 ) ) ) ) ) ) ).

% div_eqI
tff(fact_2148_division__segment__1,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( euclid7384307370059645450egment(A,one_one(A)) = one_one(A) ) ) ).

% division_segment_1
tff(fact_2149_division__segment__numeral,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [K: num] : ( euclid7384307370059645450egment(A,aa(num,A,numeral_numeral(A),K)) = one_one(A) ) ) ).

% division_segment_numeral
tff(fact_2150_division__segment__of__nat,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( euclid7384307370059645450egment(A,aa(nat,A,semiring_1_of_nat(A),N)) = one_one(A) ) ) ).

% division_segment_of_nat
tff(fact_2151_division__segment__euclidean__size,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),euclid7384307370059645450egment(A,A3)),aa(nat,A,semiring_1_of_nat(A),aa(A,nat,euclid6346220572633701492n_size(A),A3))) = A3 ) ) ).

% division_segment_euclidean_size
tff(fact_2152_division__segment__mult,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( euclid7384307370059645450egment(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),euclid7384307370059645450egment(A,A3)),euclid7384307370059645450egment(A,B2)) ) ) ) ) ).

% division_segment_mult
tff(fact_2153_is__unit__division__segment,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A3: A] : pp(dvd_dvd(A,euclid7384307370059645450egment(A,A3),one_one(A))) ) ).

% is_unit_division_segment
tff(fact_2154_Frct__code__post_I2_J,axiom,
    ! [A3: int] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),zero_zero(int))) = zero_zero(rat) ) ).

% Frct_code_post(2)
tff(fact_2155_Frct__code__post_I1_J,axiom,
    ! [A3: int] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),A3)) = zero_zero(rat) ) ).

% Frct_code_post(1)
tff(fact_2156_Frct__code__post_I3_J,axiom,
    frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int))) = one_one(rat) ).

% Frct_code_post(3)
tff(fact_2157_Frct__code__post_I7_J,axiom,
    ! [A3: int,B2: int] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),A3)),B2)) = aa(rat,rat,uminus_uminus(rat),frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),B2))) ) ).

% Frct_code_post(7)
tff(fact_2158_Frct__code__post_I8_J,axiom,
    ! [A3: int,B2: int] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),aa(int,int,uminus_uminus(int),B2))) = aa(rat,rat,uminus_uminus(rat),frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),B2))) ) ).

% Frct_code_post(8)
tff(fact_2159_Frct__code__post_I4_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(num,int,numeral_numeral(int),K)),one_one(int))) = aa(num,rat,numeral_numeral(rat),K) ) ).

% Frct_code_post(4)
tff(fact_2160_div__bounded,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,R3: A,Q3: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R3) = euclid7384307370059645450egment(A,B2) )
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,euclid6346220572633701492n_size(A),R3)),aa(A,nat,euclid6346220572633701492n_size(A),B2)))
             => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q3),B2)),R3),B2) = Q3 ) ) ) ) ) ).

% div_bounded
tff(fact_2161_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X: fun(nat,fun(A,A)),Xa: nat,Xb: nat,Xc: A,Y: A] :
      ( ( set_fo6178422350223883121st_nat(A,X,Xa,Xb,Xc) = Y )
     => ( pp(aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),aa(fun(nat,fun(A,A)),fun(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),X),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),aa(nat,fun(product_prod(nat,A),product_prod(nat,product_prod(nat,A))),product_Pair(nat,product_prod(nat,A)),Xa),aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),Xb),Xc)))))
       => ~ ( ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Xb),Xa))
               => ( Y = Xc ) )
              & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Xb),Xa))
               => ( Y = set_fo6178422350223883121st_nat(A,X,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Xa),one_one(nat)),Xb,aa(A,A,aa(nat,fun(A,A),X,Xa),Xc)) ) ) )
           => ~ pp(aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),aa(fun(nat,fun(A,A)),fun(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),X),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),aa(nat,fun(product_prod(nat,A),product_prod(nat,product_prod(nat,A))),product_Pair(nat,product_prod(nat,A)),Xa),aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),Xb),Xc))))) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
tff(fact_2162_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F: fun(nat,fun(A,A)),A3: nat,B2: nat,Acc2: A] :
      ( pp(aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),bool,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),aa(fun(nat,fun(A,A)),fun(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),F),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),aa(nat,fun(product_prod(nat,A),product_prod(nat,product_prod(nat,A))),product_Pair(nat,product_prod(nat,A)),A3),aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),B2),Acc2)))))
     => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),B2),A3))
         => ( set_fo6178422350223883121st_nat(A,F,A3,B2,Acc2) = Acc2 ) )
        & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),B2),A3))
         => ( set_fo6178422350223883121st_nat(A,F,A3,B2,Acc2) = set_fo6178422350223883121st_nat(A,F,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),one_one(nat)),B2,aa(A,A,aa(nat,fun(A,A),F,A3),Acc2)) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
tff(fact_2163_refl__on__domain,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( refl_on(A,A4,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
       => ( pp(member(A,A3,A4))
          & pp(member(A,B2,A4)) ) ) ) ).

% refl_on_domain
tff(fact_2164_smin__insertI,axiom,
    ! [X: product_prod(nat,nat),XS: set(product_prod(nat,nat)),Y: product_prod(nat,nat),YS: set(product_prod(nat,nat))] :
      ( pp(member(product_prod(nat,nat),X,XS))
     => ( pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_less))
       => ( pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),XS),YS),fun_min_strict))
         => pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),XS),aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),insert2(product_prod(nat,nat),Y),YS)),fun_min_strict)) ) ) ) ).

% smin_insertI
tff(fact_2165_pair__leqI2,axiom,
    ! [A3: nat,B2: nat,S: nat,T4: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),B2))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),S),T4))
       => pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),S)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),B2),T4)),fun_pair_leq)) ) ) ).

% pair_leqI2
tff(fact_2166_pair__leqI1,axiom,
    ! [A3: nat,B2: nat,S: nat,T4: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),A3),B2))
     => pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),S)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),B2),T4)),fun_pair_leq)) ) ).

% pair_leqI1
tff(fact_2167_zero__rat__def,axiom,
    zero_zero(rat) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int))) ).

% zero_rat_def
tff(fact_2168_smin__emptyI,axiom,
    ! [X6: set(product_prod(nat,nat))] :
      ( ( X6 != bot_bot(set(product_prod(nat,nat))) )
     => pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),X6),bot_bot(set(product_prod(nat,nat)))),fun_min_strict)) ) ).

% smin_emptyI
tff(fact_2169_one__rat__def,axiom,
    one_one(rat) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int))) ).

% one_rat_def
tff(fact_2170_wmin__insertI,axiom,
    ! [X: product_prod(nat,nat),XS: set(product_prod(nat,nat)),Y: product_prod(nat,nat),YS: set(product_prod(nat,nat))] :
      ( pp(member(product_prod(nat,nat),X,XS))
     => ( pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_leq))
       => ( pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),XS),YS),fun_min_weak))
         => pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),XS),aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),insert2(product_prod(nat,nat),Y),YS)),fun_min_weak)) ) ) ) ).

% wmin_insertI
tff(fact_2171_wmax__insertI,axiom,
    ! [Y: product_prod(nat,nat),YS: set(product_prod(nat,nat)),X: product_prod(nat,nat),XS: set(product_prod(nat,nat))] :
      ( pp(member(product_prod(nat,nat),Y,YS))
     => ( pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_leq))
       => ( pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),XS),YS),fun_max_weak))
         => pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),insert2(product_prod(nat,nat),X),XS)),YS),fun_max_weak)) ) ) ) ).

% wmax_insertI
tff(fact_2172_smax__insertI,axiom,
    ! [Y: product_prod(nat,nat),Y5: set(product_prod(nat,nat)),X: product_prod(nat,nat),X6: set(product_prod(nat,nat))] :
      ( pp(member(product_prod(nat,nat),Y,Y5))
     => ( pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_less))
       => ( pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),X6),Y5),fun_max_strict))
         => pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),insert2(product_prod(nat,nat),X),X6)),Y5),fun_max_strict)) ) ) ) ).

% smax_insertI
tff(fact_2173_linear__order__on__singleton,axiom,
    ! [A: $tType,X: A] : order_679001287576687338der_on(A,aa(set(A),set(A),insert2(A,X),bot_bot(set(A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),X)),bot_bot(set(product_prod(A,A))))) ).

% linear_order_on_singleton
tff(fact_2174_uminus__rat_Oabs__eq,axiom,
    ! [X: product_prod(int,int)] :
      ( pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,X),X))
     => ( aa(rat,rat,uminus_uminus(rat),aa(product_prod(int,int),rat,abs_Rat,X)) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),aa(product_prod(int,int),int,product_fst(int,int),X))),aa(product_prod(int,int),int,product_snd(int,int),X))) ) ) ).

% uminus_rat.abs_eq
tff(fact_2175_Total__subset__Id,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( total_on(A,field2(A,R3),R3)
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R3),id2(A)))
       => ( ( R3 = bot_bot(set(product_prod(A,A))) )
          | ? [A8: A] : ( R3 = aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A8),A8)),bot_bot(set(product_prod(A,A)))) ) ) ) ) ).

% Total_subset_Id
tff(fact_2176_plus__rat_Oabs__eq,axiom,
    ! [Xa: product_prod(int,int),X: product_prod(int,int)] :
      ( pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,Xa),Xa))
     => ( pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,X),X))
       => ( aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),aa(product_prod(int,int),rat,abs_Rat,Xa)),aa(product_prod(int,int),rat,abs_Rat,X)) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),X))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),X)),aa(product_prod(int,int),int,product_snd(int,int),Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),X)))) ) ) ) ).

% plus_rat.abs_eq
tff(fact_2177_IdI,axiom,
    ! [A: $tType,A3: A] : pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),A3),id2(A))) ).

% IdI
tff(fact_2178_pair__in__Id__conv,axiom,
    ! [A: $tType,A3: A,B2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),id2(A)))
    <=> ( A3 = B2 ) ) ).

% pair_in_Id_conv
tff(fact_2179_Linear__order__in__diff__Id,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( order_679001287576687338der_on(A,field2(A,R3),R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => ( pp(member(A,B2,field2(A,R3)))
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
          <=> ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),A3),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R3),id2(A)))) ) ) ) ) ).

% Linear_order_in_diff_Id
tff(fact_2180_IdE,axiom,
    ! [A: $tType,P3: product_prod(A,A)] :
      ( pp(member(product_prod(A,A),P3,id2(A)))
     => ~ ! [X2: A] : ( P3 != aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2) ) ) ).

% IdE
tff(fact_2181_BNF__Greatest__Fixpoint_OIdD,axiom,
    ! [A: $tType,A3: A,B2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),id2(A)))
     => ( A3 = B2 ) ) ).

% BNF_Greatest_Fixpoint.IdD
tff(fact_2182_one__rat_Orsp,axiom,
    pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int))),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int)))) ).

% one_rat.rsp
tff(fact_2183_lnear__order__on__empty,axiom,
    ! [A: $tType] : order_679001287576687338der_on(A,bot_bot(set(A)),bot_bot(set(product_prod(A,A)))) ).

% lnear_order_on_empty
tff(fact_2184_zero__rat_Orsp,axiom,
    pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int))),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)))) ).

% zero_rat.rsp
tff(fact_2185_wmin__emptyI,axiom,
    ! [X6: set(product_prod(nat,nat))] : pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),X6),bot_bot(set(product_prod(nat,nat)))),fun_min_weak)) ).

% wmin_emptyI
tff(fact_2186_times__rat_Oabs__eq,axiom,
    ! [Xa: product_prod(int,int),X: product_prod(int,int)] :
      ( pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,Xa),Xa))
     => ( pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,X),X))
       => ( aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),aa(product_prod(int,int),rat,abs_Rat,Xa)),aa(product_prod(int,int),rat,abs_Rat,X)) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa)),aa(product_prod(int,int),int,product_fst(int,int),X))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),X)))) ) ) ) ).

% times_rat.abs_eq
tff(fact_2187_min__weak__def,axiom,
    fun_min_weak = aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),fun(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),sup_sup(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),min_ext(product_prod(nat,nat),fun_pair_leq)),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),insert2(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bot_bot(set(product_prod(nat,nat)))),bot_bot(set(product_prod(nat,nat))))),bot_bot(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))))) ).

% min_weak_def
tff(fact_2188_max__weak__def,axiom,
    fun_max_weak = aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),fun(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),sup_sup(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),max_ext(product_prod(nat,nat),fun_pair_leq)),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),insert2(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bot_bot(set(product_prod(nat,nat)))),bot_bot(set(product_prod(nat,nat))))),bot_bot(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))))) ).

% max_weak_def
tff(fact_2189_inverse__rat_Oabs__eq,axiom,
    ! [X: product_prod(int,int)] :
      ( pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,X),X))
     => ( aa(rat,rat,inverse_inverse(rat),aa(product_prod(int,int),rat,abs_Rat,X)) = aa(product_prod(int,int),rat,abs_Rat,if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),fequal(int),aa(product_prod(int,int),int,product_fst(int,int),X)),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),X)),aa(product_prod(int,int),int,product_fst(int,int),X)))) ) ) ).

% inverse_rat.abs_eq
tff(fact_2190_min__rpair__set,axiom,
    fun_reduction_pair(set(product_prod(nat,nat)),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_prod(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),fun(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_prod(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))))),product_Pair(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),fun_min_strict),fun_min_weak)) ).

% min_rpair_set
tff(fact_2191_max__rpair__set,axiom,
    fun_reduction_pair(set(product_prod(nat,nat)),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_prod(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),fun(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_prod(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))))),product_Pair(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),fun_max_strict),fun_max_weak)) ).

% max_rpair_set
tff(fact_2192_Linear__order__wf__diff__Id,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( order_679001287576687338der_on(A,field2(A,R3),R3)
     => ( wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R3),id2(A)))
      <=> ! [A11: set(A)] :
            ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A11),field2(A,R3)))
           => ( ( A11 != bot_bot(set(A)) )
             => ? [X4: A] :
                  ( pp(member(A,X4,A11))
                  & ! [Xa2: A] :
                      ( pp(member(A,Xa2,A11))
                     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa2),R3)) ) ) ) ) ) ) ).

% Linear_order_wf_diff_Id
tff(fact_2193_zero__rat_Otransfer,axiom,
    pp(aa(rat,bool,aa(product_prod(int,int),fun(rat,bool),pcr_rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int))),zero_zero(rat))) ).

% zero_rat.transfer
tff(fact_2194_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% inverse_mult_distrib
tff(fact_2195_inverse__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),one_one(A)) = one_one(A) ) ) ).

% inverse_1
tff(fact_2196_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A] :
          ( ( aa(A,A,inverse_inverse(A),X) = one_one(A) )
        <=> ( X = one_one(A) ) ) ) ).

% inverse_eq_1_iff
tff(fact_2197_right__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,inverse_inverse(A),A3)) = one_one(A) ) ) ) ).

% right_inverse
tff(fact_2198_left__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),A3) = one_one(A) ) ) ) ).

% left_inverse
tff(fact_2199_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W2: num] : ( aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),W2)) = divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),W2)) ) ) ).

% inverse_eq_divide_numeral
tff(fact_2200_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W2: num] : ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) = divide_divide(A,one_one(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W2))) ) ) ).

% inverse_eq_divide_neg_numeral
tff(fact_2201_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Y: A,X: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Y),X) = aa(A,A,aa(A,fun(A,A),times_times(A),X),Y) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Y)),X) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(A,A,inverse_inverse(A),Y)) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
tff(fact_2202_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A3)) ) ) ) ) ).

% nonzero_inverse_mult_distrib
tff(fact_2203_inverse__unique,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2) = one_one(A) )
         => ( aa(A,A,inverse_inverse(A),A3) = B2 ) ) ) ).

% inverse_unique
tff(fact_2204_wf__iff__no__infinite__down__chain,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( wf(A,R3)
    <=> ~ ? [F11: fun(nat,A)] :
          ! [I2: nat] : pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(nat,A,F11,aa(nat,nat,suc,I2))),aa(nat,A,F11,I2)),R3)) ) ).

% wf_iff_no_infinite_down_chain
tff(fact_2205_wf__no__infinite__down__chainE,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),F: fun(nat,A)] :
      ( wf(A,R3)
     => ~ ! [K2: nat] : pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(nat,A,F,aa(nat,nat,suc,K2))),aa(nat,A,F,K2)),R3)) ) ).

% wf_no_infinite_down_chainE
tff(fact_2206_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] : ( divide_divide(A,A3,B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% field_class.field_divide_inverse
tff(fact_2207_divide__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] : ( divide_divide(A,A3,B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% divide_inverse
tff(fact_2208_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] : ( divide_divide(A,A3,B2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B2)),A3) ) ) ).

% divide_inverse_commute
tff(fact_2209_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] : ( aa(A,A,inverse_inverse(A),A3) = divide_divide(A,one_one(A),A3) ) ) ).

% inverse_eq_divide
tff(fact_2210_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M4: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M4)),aa(A,A,inverse_inverse(A),X)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),X)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M4)) ) ) ).

% power_mult_inverse_distrib
tff(fact_2211_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M4: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X)),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X)),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M4)) ) ) ).

% power_mult_power_inverse_commute
tff(fact_2212_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: nat,X: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa))),X) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa))) ) ) ).

% mult_inverse_of_nat_commute
tff(fact_2213_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: int,X: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(int,A,ring_1_of_int(A),Xa))),X) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(A,A,inverse_inverse(A),aa(int,A,ring_1_of_int(A),Xa))) ) ) ).

% mult_inverse_of_int_commute
tff(fact_2214_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),X)),one_one(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),zero_zero(A)))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X)) ) ) ) ).

% inverse_le_1_iff
tff(fact_2215_one__less__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),A3))) ) ) ) ).

% one_less_inverse
tff(fact_2216_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),X)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),one_one(A))) ) ) ) ).

% one_less_inverse_iff
tff(fact_2217_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% division_ring_inverse_add
tff(fact_2218_inverse__add,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),aa(A,A,inverse_inverse(A),A3))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% inverse_add
tff(fact_2219_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),A3) = one_one(A) ) ) ) ).

% field_class.field_inverse
tff(fact_2220_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A3))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% division_ring_inverse_diff
tff(fact_2221_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),A3) = divide_divide(A,one_one(A),A3) ) ) ) ).

% nonzero_inverse_eq_divide
tff(fact_2222_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ) ) ).

% inverse_le_iff
tff(fact_2223_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),A3)),aa(A,A,inverse_inverse(A),B2)))
        <=> ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3)) )
            & ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)),zero_zero(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ) ) ).

% inverse_less_iff
tff(fact_2224_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),X)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),X))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),one_one(A))) ) ) ) ).

% one_le_inverse_iff
tff(fact_2225_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,inverse_inverse(A),X)),one_one(A)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),zero_zero(A)))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X)) ) ) ) ).

% inverse_less_1_iff
tff(fact_2226_one__le__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),A3))) ) ) ) ).

% one_le_inverse
tff(fact_2227_wf__eq__minimal2,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( wf(A,R3)
    <=> ! [A11: set(A)] :
          ( ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A11),field2(A,R3)))
            & ( A11 != bot_bot(set(A)) ) )
         => ? [X4: A] :
              ( pp(member(A,X4,A11))
              & ! [Xa2: A] :
                  ( pp(member(A,Xa2,A11))
                 => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa2),X4),R3)) ) ) ) ) ).

% wf_eq_minimal2
tff(fact_2228_one__rat_Otransfer,axiom,
    pp(aa(rat,bool,aa(product_prod(int,int),fun(rat,bool),pcr_rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int))),one_one(rat))) ).

% one_rat.transfer
tff(fact_2229_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M4: nat,N: nat] :
          ( ( X != zero_zero(A) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),X)),M4)) ) ) ) ) ).

% power_diff_conv_inverse
tff(fact_2230_wf__empty,axiom,
    ! [A: $tType] : wf(A,bot_bot(set(product_prod(A,A)))) ).

% wf_empty
tff(fact_2231_wf__bounded__measure,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),Ub: fun(A,nat),F: fun(A,nat)] :
      ( ! [A8: A,B5: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B5),A8),R3))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,Ub,B5)),aa(A,nat,Ub,A8)))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,F,B5)),aa(A,nat,Ub,A8)))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F,A8)),aa(A,nat,F,B5))) ) )
     => wf(A,R3) ) ).

% wf_bounded_measure
tff(fact_2232_max__ext__additive,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),R: set(product_prod(A,A)),C3: set(A),D4: set(A)] :
      ( pp(member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),A4),B3),max_ext(A,R)))
     => ( pp(member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),C3),D4),max_ext(A,R)))
       => pp(member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),C3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),D4)),max_ext(A,R))) ) ) ).

% max_ext_additive
tff(fact_2233_wfE__min_H,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),Q: set(A)] :
      ( wf(A,R)
     => ( ( Q != bot_bot(set(A)) )
       => ~ ! [Z3: A] :
              ( pp(member(A,Z3,Q))
             => ~ ! [Y4: A] :
                    ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),Z3),R))
                   => ~ pp(member(A,Y4,Q)) ) ) ) ) ).

% wfE_min'
tff(fact_2234_wf__Int1,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(A,A))] :
      ( wf(A,R3)
     => wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),R4)) ) ).

% wf_Int1
tff(fact_2235_wf__Int2,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(A,A))] :
      ( wf(A,R3)
     => wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R4),R3)) ) ).

% wf_Int2
tff(fact_2236_wf__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( wf(A,R3)
    <=> ! [P4: fun(A,bool)] :
          ( ! [X4: A] :
              ( ! [Y3: A] :
                  ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y3),X4),R3))
                 => pp(aa(A,bool,P4,Y3)) )
             => pp(aa(A,bool,P4,X4)) )
         => ! [X_12: A] : pp(aa(A,bool,P4,X_12)) ) ) ).

% wf_def
tff(fact_2237_wf__induct__rule,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),P: fun(A,bool),A3: A] :
      ( wf(A,R3)
     => ( ! [X2: A] :
            ( ! [Y4: A] :
                ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),X2),R3))
               => pp(aa(A,bool,P,Y4)) )
           => pp(aa(A,bool,P,X2)) )
       => pp(aa(A,bool,P,A3)) ) ) ).

% wf_induct_rule
tff(fact_2238_wf__eq__minimal,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( wf(A,R3)
    <=> ! [Q8: set(A)] :
          ( ? [X4: A] : pp(member(A,X4,Q8))
         => ? [X4: A] :
              ( pp(member(A,X4,Q8))
              & ! [Y3: A] :
                  ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y3),X4),R3))
                 => ~ pp(member(A,Y3,Q8)) ) ) ) ) ).

% wf_eq_minimal
tff(fact_2239_wf__not__refl,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] :
      ( wf(A,R3)
     => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),A3),R3)) ) ).

% wf_not_refl
tff(fact_2240_wf__not__sym,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,X: A] :
      ( wf(A,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),X),R3))
       => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),A3),R3)) ) ) ).

% wf_not_sym
tff(fact_2241_wf__irrefl,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] :
      ( wf(A,R3)
     => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),A3),R3)) ) ).

% wf_irrefl
tff(fact_2242_wf__induct,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),P: fun(A,bool),A3: A] :
      ( wf(A,R3)
     => ( ! [X2: A] :
            ( ! [Y4: A] :
                ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),X2),R3))
               => pp(aa(A,bool,P,Y4)) )
           => pp(aa(A,bool,P,X2)) )
       => pp(aa(A,bool,P,A3)) ) ) ).

% wf_induct
tff(fact_2243_wf__asym,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,X: A] :
      ( wf(A,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),X),R3))
       => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),A3),R3)) ) ) ).

% wf_asym
tff(fact_2244_wfUNIVI,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ! [P5: fun(A,bool),X2: A] :
          ( ! [Xa3: A] :
              ( ! [Y2: A] :
                  ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Xa3),R3))
                 => pp(aa(A,bool,P5,Y2)) )
             => pp(aa(A,bool,P5,Xa3)) )
         => pp(aa(A,bool,P5,X2)) )
     => wf(A,R3) ) ).

% wfUNIVI
tff(fact_2245_wfI__min,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( ! [X2: A,Q4: set(A)] :
          ( pp(member(A,X2,Q4))
         => ? [Xa3: A] :
              ( pp(member(A,Xa3,Q4))
              & ! [Y2: A] :
                  ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Xa3),R))
                 => ~ pp(member(A,Y2,Q4)) ) ) )
     => wf(A,R) ) ).

% wfI_min
tff(fact_2246_wfE__min,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),X: A,Q: set(A)] :
      ( wf(A,R)
     => ( pp(member(A,X,Q))
       => ~ ! [Z3: A] :
              ( pp(member(A,Z3,Q))
             => ~ ! [Y4: A] :
                    ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),Z3),R))
                   => ~ pp(member(A,Y4,Q)) ) ) ) ) ).

% wfE_min
tff(fact_2247_in__measure,axiom,
    ! [A: $tType,X: A,Y: A,F: fun(A,nat)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),measure(A,F)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F,X)),aa(A,nat,F,Y))) ) ).

% in_measure
tff(fact_2248_in__lex__prod,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,A5: A,B4: B,R3: set(product_prod(A,A)),S: set(product_prod(B,B))] :
      ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A5),B4)),lex_prod(A,B,R3,S)))
    <=> ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),A5),R3))
        | ( ( A3 = A5 )
          & pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B2),B4),S)) ) ) ) ).

% in_lex_prod
tff(fact_2249_dependent__wf__choice,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,A)),P: fun(fun(A,B),fun(A,fun(B,bool)))] :
      ( wf(A,R)
     => ( ! [F9: fun(A,B),G3: fun(A,B),X2: A,R2: B] :
            ( ! [Z5: A] :
                ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z5),X2),R))
               => ( aa(A,B,F9,Z5) = aa(A,B,G3,Z5) ) )
           => ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,B),fun(A,fun(B,bool)),P,F9),X2),R2))
            <=> pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,B),fun(A,fun(B,bool)),P,G3),X2),R2)) ) )
       => ( ! [X2: A,F9: fun(A,B)] :
              ( ! [Y4: A] :
                  ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),X2),R))
                 => pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,B),fun(A,fun(B,bool)),P,F9),Y4),aa(A,B,F9,Y4))) )
             => ? [X_13: B] : pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,B),fun(A,fun(B,bool)),P,F9),X2),X_13)) )
         => ? [F9: fun(A,B)] :
            ! [X3: A] : pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,B),fun(A,fun(B,bool)),P,F9),X3),aa(A,B,F9,X3))) ) ) ) ).

% dependent_wf_choice
tff(fact_2250_wo__rel_Ocases__Total3,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A,Phi: fun(A,fun(A,bool))] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))),field2(A,R3)))
       => ( ( ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R3),id2(A))))
              | pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),A3),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R3),id2(A)))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A3),B2)) )
         => ( ( ( A3 = B2 )
             => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A3),B2)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A3),B2)) ) ) ) ) ).

% wo_rel.cases_Total3
tff(fact_2251_of__rat__neg__one,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,uminus_uminus(rat),one_one(rat))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% of_rat_neg_one
tff(fact_2252_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( ( ( N = zero_zero(nat) )
           => ( aa(num,A,numeral_numeral(A),aa(nat,num,num_of_nat,N)) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( aa(num,A,numeral_numeral(A),aa(nat,num,num_of_nat,N)) = aa(nat,A,semiring_1_of_nat(A),N) ) ) ) ) ).

% numeral_num_of_nat_unfold
tff(fact_2253_of__rat__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( aa(rat,A,field_char_0_of_rat(A),one_one(rat)) = one_one(A) ) ) ).

% of_rat_1
tff(fact_2254_of__rat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: rat] :
          ( ( aa(rat,A,field_char_0_of_rat(A),A3) = one_one(A) )
        <=> ( A3 = one_one(rat) ) ) ) ).

% of_rat_eq_1_iff
tff(fact_2255_one__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: rat] :
          ( ( one_one(A) = aa(rat,A,field_char_0_of_rat(A),A3) )
        <=> ( one_one(rat) = A3 ) ) ) ).

% one_eq_of_rat_iff
tff(fact_2256_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R3: rat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(rat,A,field_char_0_of_rat(A),R3)),one_one(A)))
        <=> pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),R3),one_one(rat))) ) ) ).

% of_rat_le_1_iff
tff(fact_2257_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R3: rat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(rat,A,field_char_0_of_rat(A),R3)))
        <=> pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less_eq(rat),one_one(rat)),R3)) ) ) ).

% one_le_of_rat_iff
tff(fact_2258_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R3: rat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(rat,A,field_char_0_of_rat(A),R3)),one_one(A)))
        <=> pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),R3),one_one(rat))) ) ) ).

% of_rat_less_1_iff
tff(fact_2259_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R3: rat] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),aa(rat,A,field_char_0_of_rat(A),R3)))
        <=> pp(aa(rat,bool,aa(rat,fun(rat,bool),ord_less(rat),one_one(rat)),R3)) ) ) ).

% one_less_of_rat_iff
tff(fact_2260_wo__rel_Owell__order__induct,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),P: fun(A,bool),A3: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( ! [X2: A] :
            ( ! [Y4: A] :
                ( ( ( Y4 != X2 )
                  & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),X2),R3)) )
               => pp(aa(A,bool,P,Y4)) )
           => pp(aa(A,bool,P,X2)) )
       => pp(aa(A,bool,P,A3)) ) ) ).

% wo_rel.well_order_induct
tff(fact_2261_wo__rel_OTOTALS,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ! [X3: A] :
          ( pp(member(A,X3,field2(A,R3)))
         => ! [Xa3: A] :
              ( pp(member(A,Xa3,field2(A,R3)))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa3),R3))
                | pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa3),X3),R3)) ) ) ) ) ).

% wo_rel.TOTALS
tff(fact_2262_well__order__induct__imp,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),P: fun(A,bool),A3: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( ! [X2: A] :
            ( ! [Y4: A] :
                ( ( ( Y4 != X2 )
                  & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),X2),R3)) )
               => ( pp(member(A,Y4,field2(A,R3)))
                 => pp(aa(A,bool,P,Y4)) ) )
           => ( pp(member(A,X2,field2(A,R3)))
             => pp(aa(A,bool,P,X2)) ) )
       => ( pp(member(A,A3,field2(A,R3)))
         => pp(aa(A,bool,P,A3)) ) ) ) ).

% well_order_induct_imp
tff(fact_2263_of__rat__mult,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: rat,B2: rat] : ( aa(rat,A,field_char_0_of_rat(A),aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(rat,A,field_char_0_of_rat(A),A3)),aa(rat,A,field_char_0_of_rat(A),B2)) ) ) ).

% of_rat_mult
tff(fact_2264_wo__rel_Ocases__Total,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A,Phi: fun(A,fun(A,bool))] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))),field2(A,R3)))
       => ( ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
           => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A3),B2)) )
         => ( ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),A3),R3))
             => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A3),B2)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),Phi,A3),B2)) ) ) ) ) ).

% wo_rel.cases_Total
tff(fact_2265_wo__rel_OWell__order__isMinim__exists,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B3: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
       => ( ( B3 != bot_bot(set(A)) )
         => ? [X_1: A] : bNF_We4791949203932849705sMinim(A,R3,B3,X_1) ) ) ) ).

% wo_rel.Well_order_isMinim_exists
tff(fact_2266_wo__rel_Ominim__in,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B3: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
       => ( ( B3 != bot_bot(set(A)) )
         => pp(member(A,bNF_We6954850376910717587_minim(A,R3,B3),B3)) ) ) ) ).

% wo_rel.minim_in
tff(fact_2267_wo__rel_Ominim__inField,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B3: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
       => ( ( B3 != bot_bot(set(A)) )
         => pp(member(A,bNF_We6954850376910717587_minim(A,R3,B3),field2(A,R3))) ) ) ) ).

% wo_rel.minim_inField
tff(fact_2268_wo__rel_Oequals__minim,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B3: set(A),A3: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
       => ( pp(member(A,A3,B3))
         => ( ! [B5: A] :
                ( pp(member(A,B5,B3))
               => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B5),R3)) )
           => ( A3 = bNF_We6954850376910717587_minim(A,R3,B3) ) ) ) ) ) ).

% wo_rel.equals_minim
tff(fact_2269_wo__rel_Ominim__least,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B3: set(A),B2: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
       => ( pp(member(A,B2,B3))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),bNF_We6954850376910717587_minim(A,R3,B3)),B2),R3)) ) ) ) ).

% wo_rel.minim_least
tff(fact_2270_wo__rel_Omax2__greater__among,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => ( pp(member(A,B2,field2(A,R3)))
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),bNF_We1388413361240627857o_max2(A,R3,A3,B2)),R3))
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),bNF_We1388413361240627857o_max2(A,R3,A3,B2)),R3))
            & pp(member(A,bNF_We1388413361240627857o_max2(A,R3,A3,B2),aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))))) ) ) ) ) ).

% wo_rel.max2_greater_among
tff(fact_2271_wo__rel_Omax2__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
         => ( bNF_We1388413361240627857o_max2(A,R3,A3,B2) = B2 ) )
        & ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
         => ( bNF_We1388413361240627857o_max2(A,R3,A3,B2) = A3 ) ) ) ) ).

% wo_rel.max2_def
tff(fact_2272_wo__rel_Ominim__isMinim,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B3: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
       => ( ( B3 != bot_bot(set(A)) )
         => bNF_We4791949203932849705sMinim(A,R3,B3,bNF_We6954850376910717587_minim(A,R3,B3)) ) ) ) ).

% wo_rel.minim_isMinim
tff(fact_2273_wo__rel_OisMinim__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B2: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( bNF_We4791949203932849705sMinim(A,R3,A4,B2)
      <=> ( pp(member(A,B2,A4))
          & ! [X4: A] :
              ( pp(member(A,X4,A4))
             => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),X4),R3)) ) ) ) ) ).

% wo_rel.isMinim_def
tff(fact_2274_wo__rel_Omax2__equals1,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => ( pp(member(A,B2,field2(A,R3)))
         => ( ( bNF_We1388413361240627857o_max2(A,R3,A3,B2) = A3 )
          <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),A3),R3)) ) ) ) ) ).

% wo_rel.max2_equals1
tff(fact_2275_wo__rel_Omax2__equals2,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => ( pp(member(A,B2,field2(A,R3)))
         => ( ( bNF_We1388413361240627857o_max2(A,R3,A3,B2) = B2 )
          <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3)) ) ) ) ) ).

% wo_rel.max2_equals2
tff(fact_2276_wo__rel_Omax2__greater,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => ( pp(member(A,B2,field2(A,R3)))
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),bNF_We1388413361240627857o_max2(A,R3,A3,B2)),R3))
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),bNF_We1388413361240627857o_max2(A,R3,A3,B2)),R3)) ) ) ) ) ).

% wo_rel.max2_greater
tff(fact_2277_wo__rel_Omax2__among,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => ( pp(member(A,B2,field2(A,R3)))
         => pp(member(A,bNF_We1388413361240627857o_max2(A,R3,A3,B2),aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))))) ) ) ) ).

% wo_rel.max2_among
tff(fact_2278_simp__from__to,axiom,
    ! [J2: int,I: int] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J2),I))
       => ( set_or1337092689740270186AtMost(int,I,J2) = bot_bot(set(int)) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),J2),I))
       => ( set_or1337092689740270186AtMost(int,I,J2) = aa(set(int),set(int),insert2(int,I),set_or1337092689740270186AtMost(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J2)) ) ) ) ).

% simp_from_to
tff(fact_2279_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,X: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,X,Y)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),X),aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,X,Y)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y),aa(A,A,aa(A,fun(A,A),times_times(A),C2),X)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,X,Y)) = bot_bot(set(A)) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
tff(fact_2280_one__int_Otransfer,axiom,
    pp(aa(int,bool,aa(product_prod(nat,nat),fun(int,bool),pcr_int,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),one_one(nat)),zero_zero(nat))),one_one(int))) ).

% one_int.transfer
tff(fact_2281_less__than__iff,axiom,
    ! [X: nat,Y: nat] :
      ( pp(member(product_prod(nat,nat),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Y),less_than))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X),Y)) ) ).

% less_than_iff
tff(fact_2282_card__Un__disjoint,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(aa(set(A),bool,finite_finite(A),B3))
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) )
         => ( finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(A,A4)),finite_card(A,B3)) ) ) ) ) ).

% card_Un_disjoint
tff(fact_2283_reduction__pairI,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( wf(A,R)
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,R,S2)),R))
       => fun_reduction_pair(A,aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R),S2)) ) ) ).

% reduction_pairI
tff(fact_2284_finite__Int,axiom,
    ! [A: $tType,F2: set(A),G6: set(A)] :
      ( ( pp(aa(set(A),bool,finite_finite(A),F2))
        | pp(aa(set(A),bool,finite_finite(A),G6)) )
     => pp(aa(set(A),bool,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),F2),G6))) ) ).

% finite_Int
tff(fact_2285_relcomp__empty1,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set(product_prod(C,B))] : ( relcomp(A,C,B,bot_bot(set(product_prod(A,C))),R) = bot_bot(set(product_prod(A,B))) ) ).

% relcomp_empty1
tff(fact_2286_relcomp__empty2,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set(product_prod(A,C))] : ( relcomp(A,C,B,R,bot_bot(set(product_prod(C,B)))) = bot_bot(set(product_prod(A,B))) ) ).

% relcomp_empty2
tff(fact_2287_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% atLeastatMost_empty_iff
tff(fact_2288_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( ( bot_bot(set(A)) = set_or1337092689740270186AtMost(A,A3,B2) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2)) ) ) ).

% atLeastatMost_empty_iff2
tff(fact_2289_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) ) ) ) ).

% atLeastatMost_empty
tff(fact_2290_atLeastAtMost__singleton,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A] : ( set_or1337092689740270186AtMost(A,A3,A3) = aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) ) ) ).

% atLeastAtMost_singleton
tff(fact_2291_atLeastAtMost__singleton__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( set_or1337092689740270186AtMost(A,A3,B2) = aa(set(A),set(A),insert2(A,C2),bot_bot(set(A))) )
        <=> ( ( A3 = B2 )
            & ( B2 = C2 ) ) ) ) ).

% atLeastAtMost_singleton_iff
tff(fact_2292_card__0__eq,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( ( finite_card(A,A4) = zero_zero(nat) )
      <=> ( A4 = bot_bot(set(A)) ) ) ) ).

% card_0_eq
tff(fact_2293_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),D2))
         => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),D2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),D2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),D2),B2)) ) ) ) ).

% image_mult_atLeastAtMost
tff(fact_2294_relcompEpair,axiom,
    ! [A: $tType,B: $tType,C: $tType,A3: A,C2: B,R3: set(product_prod(A,C)),S: set(product_prod(C,B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),C2),relcomp(A,C,B,R3,S)))
     => ~ ! [B5: C] :
            ( pp(member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),A3),B5),R3))
           => ~ pp(member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),B5),C2),S)) ) ) ).

% relcompEpair
tff(fact_2295_relcompE,axiom,
    ! [A: $tType,B: $tType,C: $tType,Xz: product_prod(A,B),R3: set(product_prod(A,C)),S: set(product_prod(C,B))] :
      ( pp(member(product_prod(A,B),Xz,relcomp(A,C,B,R3,S)))
     => ~ ! [X2: A,Y2: C,Z3: B] :
            ( ( Xz = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Z3) )
           => ( pp(member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),X2),Y2),R3))
             => ~ pp(member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Y2),Z3),S)) ) ) ) ).

% relcompE
tff(fact_2296_relcomp_OrelcompI,axiom,
    ! [A: $tType,C: $tType,B: $tType,A3: A,B2: B,R3: set(product_prod(A,B)),C2: C,S: set(product_prod(B,C))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),R3))
     => ( pp(member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),B2),C2),S))
       => pp(member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),A3),C2),relcomp(A,B,C,R3,S))) ) ) ).

% relcomp.relcompI
tff(fact_2297_relcomp_Osimps,axiom,
    ! [A: $tType,C: $tType,B: $tType,A1: A,A22: C,R3: set(product_prod(A,B)),S: set(product_prod(B,C))] :
      ( pp(member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),A1),A22),relcomp(A,B,C,R3,S)))
    <=> ? [A6: A,B6: B,C5: C] :
          ( ( A1 = A6 )
          & ( A22 = C5 )
          & pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A6),B6),R3))
          & pp(member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),B6),C5),S)) ) ) ).

% relcomp.simps
tff(fact_2298_relcomp_Ocases,axiom,
    ! [A: $tType,C: $tType,B: $tType,A1: A,A22: C,R3: set(product_prod(A,B)),S: set(product_prod(B,C))] :
      ( pp(member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),A1),A22),relcomp(A,B,C,R3,S)))
     => ~ ! [B5: B] :
            ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A1),B5),R3))
           => ~ pp(member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),B5),A22),S)) ) ) ).

% relcomp.cases
tff(fact_2299_finite_OemptyI,axiom,
    ! [A: $tType] : pp(aa(set(A),bool,finite_finite(A),bot_bot(set(A)))) ).

% finite.emptyI
tff(fact_2300_infinite__imp__nonempty,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),S2))
     => ( S2 != bot_bot(set(A)) ) ) ).

% infinite_imp_nonempty
tff(fact_2301_atLeastAtMost__singleton_H,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = B2 )
         => ( set_or1337092689740270186AtMost(A,A3,B2) = aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) ) ) ) ).

% atLeastAtMost_singleton'
tff(fact_2302_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ? [X2: A] :
                ( pp(member(A,X2,A4))
                & ! [Xa3: A] :
                    ( pp(member(A,Xa3,A4))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Xa3))
                     => ( X2 = Xa3 ) ) ) ) ) ) ) ).

% finite_has_maximal
tff(fact_2303_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ? [X2: A] :
                ( pp(member(A,X2,A4))
                & ! [Xa3: A] :
                    ( pp(member(A,Xa3,A4))
                   => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Xa3),X2))
                     => ( X2 = Xa3 ) ) ) ) ) ) ) ).

% finite_has_minimal
tff(fact_2304_wf__no__loop,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ( relcomp(B,B,B,R,R) = bot_bot(set(product_prod(B,B))) )
     => wf(B,R) ) ).

% wf_no_loop
tff(fact_2305_finite_Ocases,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A3))
     => ( ( A3 != bot_bot(set(A)) )
       => ~ ! [A12: set(A)] :
              ( ? [A8: A] : ( A3 = aa(set(A),set(A),insert2(A,A8),A12) )
             => ~ pp(aa(set(A),bool,finite_finite(A),A12)) ) ) ) ).

% finite.cases
tff(fact_2306_finite_Osimps,axiom,
    ! [A: $tType,A3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A3))
    <=> ( ( A3 = bot_bot(set(A)) )
        | ? [A11: set(A),A6: A] :
            ( ( A3 = aa(set(A),set(A),insert2(A,A6),A11) )
            & pp(aa(set(A),bool,finite_finite(A),A11)) ) ) ) ).

% finite.simps
tff(fact_2307_finite__induct,axiom,
    ! [A: $tType,F2: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite(A),F2))
     => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
       => ( ! [X2: A,F6: set(A)] :
              ( pp(aa(set(A),bool,finite_finite(A),F6))
             => ( ~ pp(member(A,X2,F6))
               => ( pp(aa(set(A),bool,P,F6))
                 => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,X2),F6))) ) ) )
         => pp(aa(set(A),bool,P,F2)) ) ) ) ).

% finite_induct
tff(fact_2308_finite__ne__induct,axiom,
    ! [A: $tType,F2: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite(A),F2))
     => ( ( F2 != bot_bot(set(A)) )
       => ( ! [X2: A] : pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,X2),bot_bot(set(A)))))
         => ( ! [X2: A,F6: set(A)] :
                ( pp(aa(set(A),bool,finite_finite(A),F6))
               => ( ( F6 != bot_bot(set(A)) )
                 => ( ~ pp(member(A,X2,F6))
                   => ( pp(aa(set(A),bool,P,F6))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,X2),F6))) ) ) ) )
           => pp(aa(set(A),bool,P,F2)) ) ) ) ) ).

% finite_ne_induct
tff(fact_2309_infinite__finite__induct,axiom,
    ! [A: $tType,P: fun(set(A),bool),A4: set(A)] :
      ( ! [A12: set(A)] :
          ( ~ pp(aa(set(A),bool,finite_finite(A),A12))
         => pp(aa(set(A),bool,P,A12)) )
     => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
       => ( ! [X2: A,F6: set(A)] :
              ( pp(aa(set(A),bool,finite_finite(A),F6))
             => ( ~ pp(member(A,X2,F6))
               => ( pp(aa(set(A),bool,P,F6))
                 => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,X2),F6))) ) ) )
         => pp(aa(set(A),bool,P,A4)) ) ) ) ).

% infinite_finite_induct
tff(fact_2310_union__comp__emptyL,axiom,
    ! [A: $tType,A4: set(product_prod(A,A)),C3: set(product_prod(A,A)),B3: set(product_prod(A,A))] :
      ( ( relcomp(A,A,A,A4,C3) = bot_bot(set(product_prod(A,A))) )
     => ( ( relcomp(A,A,A,B3,C3) = bot_bot(set(product_prod(A,A))) )
       => ( relcomp(A,A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),A4),B3),C3) = bot_bot(set(product_prod(A,A))) ) ) ) ).

% union_comp_emptyL
tff(fact_2311_union__comp__emptyR,axiom,
    ! [A: $tType,A4: set(product_prod(A,A)),B3: set(product_prod(A,A)),C3: set(product_prod(A,A))] :
      ( ( relcomp(A,A,A,A4,B3) = bot_bot(set(product_prod(A,A))) )
     => ( ( relcomp(A,A,A,A4,C3) = bot_bot(set(product_prod(A,A))) )
       => ( relcomp(A,A,A,A4,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),B3),C3)) = bot_bot(set(product_prod(A,A))) ) ) ) ).

% union_comp_emptyR
tff(fact_2312_Gcd__remove0__nat,axiom,
    ! [M: set(nat)] :
      ( pp(aa(set(nat),bool,finite_finite(nat),M))
     => ( gcd_Gcd(nat,M) = gcd_Gcd(nat,aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),M),aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat))))) ) ) ).

% Gcd_remove0_nat
tff(fact_2313_atLeastAtMost__eq__UNIV__iff,axiom,
    ! [A: $tType] :
      ( bounded_lattice(A)
     => ! [X: A,Y: A] :
          ( ( set_or1337092689740270186AtMost(A,X,Y) = top_top(set(A)) )
        <=> ( ( X = bot_bot(A) )
            & ( Y = top_top(A) ) ) ) ) ).

% atLeastAtMost_eq_UNIV_iff
tff(fact_2314_finite__subset__induct,axiom,
    ! [A: $tType,F2: set(A),A4: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite(A),F2))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),F2),A4))
       => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
         => ( ! [A8: A,F6: set(A)] :
                ( pp(aa(set(A),bool,finite_finite(A),F6))
               => ( pp(member(A,A8,A4))
                 => ( ~ pp(member(A,A8,F6))
                   => ( pp(aa(set(A),bool,P,F6))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,A8),F6))) ) ) ) )
           => pp(aa(set(A),bool,P,F2)) ) ) ) ) ).

% finite_subset_induct
tff(fact_2315_finite__subset__induct_H,axiom,
    ! [A: $tType,F2: set(A),A4: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite(A),F2))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),F2),A4))
       => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
         => ( ! [A8: A,F6: set(A)] :
                ( pp(aa(set(A),bool,finite_finite(A),F6))
               => ( pp(member(A,A8,A4))
                 => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),F6),A4))
                   => ( ~ pp(member(A,A8,F6))
                     => ( pp(aa(set(A),bool,P,F6))
                       => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,A8),F6))) ) ) ) ) )
           => pp(aa(set(A),bool,P,F2)) ) ) ) ) ).

% finite_subset_induct'
tff(fact_2316_infinite__remove,axiom,
    ! [A: $tType,S2: set(A),A3: A] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),S2))
     => ~ pp(aa(set(A),bool,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))) ) ).

% infinite_remove
tff(fact_2317_infinite__coinduct,axiom,
    ! [A: $tType,X6: fun(set(A),bool),A4: set(A)] :
      ( pp(aa(set(A),bool,X6,A4))
     => ( ! [A12: set(A)] :
            ( pp(aa(set(A),bool,X6,A12))
           => ? [X3: A] :
                ( pp(member(A,X3,A12))
                & ( pp(aa(set(A),bool,X6,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A12),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A))))))
                  | ~ pp(aa(set(A),bool,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A12),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))))) ) ) )
       => ~ pp(aa(set(A),bool,finite_finite(A),A4)) ) ) ).

% infinite_coinduct
tff(fact_2318_finite__empty__induct,axiom,
    ! [A: $tType,A4: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(aa(set(A),bool,P,A4))
       => ( ! [A8: A,A12: set(A)] :
              ( pp(aa(set(A),bool,finite_finite(A),A12))
             => ( pp(member(A,A8,A12))
               => ( pp(aa(set(A),bool,P,A12))
                 => pp(aa(set(A),bool,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A12),aa(set(A),set(A),insert2(A,A8),bot_bot(set(A)))))) ) ) )
         => pp(aa(set(A),bool,P,bot_bot(set(A)))) ) ) ) ).

% finite_empty_induct
tff(fact_2319_card__eq__0__iff,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ( finite_card(A,A4) = zero_zero(nat) )
    <=> ( ( A4 = bot_bot(set(A)) )
        | ~ pp(aa(set(A),bool,finite_finite(A),A4)) ) ) ).

% card_eq_0_iff
tff(fact_2320_finite__range__prod,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: fun(B,product_prod(A,C))] :
      ( pp(aa(set(A),bool,finite_finite(A),aa(set(B),set(A),image2(B,A,aa(fun(B,product_prod(A,C)),fun(B,A),aa(fun(product_prod(A,C),A),fun(fun(B,product_prod(A,C)),fun(B,A)),comp(product_prod(A,C),A,B),product_fst(A,C)),F)),top_top(set(B)))))
     => ( pp(aa(set(C),bool,finite_finite(C),aa(set(B),set(C),image2(B,C,aa(fun(B,product_prod(A,C)),fun(B,C),aa(fun(product_prod(A,C),C),fun(fun(B,product_prod(A,C)),fun(B,C)),comp(product_prod(A,C),C,B),product_snd(A,C)),F)),top_top(set(B)))))
       => pp(aa(set(product_prod(A,C)),bool,finite_finite(product_prod(A,C)),aa(set(B),set(product_prod(A,C)),image2(B,product_prod(A,C),F),top_top(set(B))))) ) ) ).

% finite_range_prod
tff(fact_2321_zero__int_Otransfer,axiom,
    pp(aa(int,bool,aa(product_prod(nat,nat),fun(int,bool),pcr_int,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),zero_zero(nat))),zero_zero(int))) ).

% zero_int.transfer
tff(fact_2322_max__ext__compat,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,R,S2)),R))
     => pp(aa(set(product_prod(set(A),set(A))),bool,aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),bool),ord_less_eq(set(product_prod(set(A),set(A)))),relcomp(set(A),set(A),set(A),max_ext(A,R),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),sup_sup(set(product_prod(set(A),set(A)))),max_ext(A,S2)),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),insert2(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),bot_bot(set(A))),bot_bot(set(A)))),bot_bot(set(product_prod(set(A),set(A)))))))),max_ext(A,R))) ) ).

% max_ext_compat
tff(fact_2323_finite__remove__induct,axiom,
    ! [A: $tType,B3: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite(A),B3))
     => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
       => ( ! [A12: set(A)] :
              ( pp(aa(set(A),bool,finite_finite(A),A12))
             => ( ( A12 != bot_bot(set(A)) )
               => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A12),B3))
                 => ( ! [X3: A] :
                        ( pp(member(A,X3,A12))
                       => pp(aa(set(A),bool,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A12),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))))) )
                   => pp(aa(set(A),bool,P,A12)) ) ) ) )
         => pp(aa(set(A),bool,P,B3)) ) ) ) ).

% finite_remove_induct
tff(fact_2324_remove__induct,axiom,
    ! [A: $tType,P: fun(set(A),bool),B3: set(A)] :
      ( pp(aa(set(A),bool,P,bot_bot(set(A))))
     => ( ( ~ pp(aa(set(A),bool,finite_finite(A),B3))
         => pp(aa(set(A),bool,P,B3)) )
       => ( ! [A12: set(A)] :
              ( pp(aa(set(A),bool,finite_finite(A),A12))
             => ( ( A12 != bot_bot(set(A)) )
               => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A12),B3))
                 => ( ! [X3: A] :
                        ( pp(member(A,X3,A12))
                       => pp(aa(set(A),bool,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A12),aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))))) )
                   => pp(aa(set(A),bool,P,A12)) ) ) ) )
         => pp(aa(set(A),bool,P,B3)) ) ) ) ).

% remove_induct
tff(fact_2325_card__gt__0__iff,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),finite_card(A,A4)))
    <=> ( ( A4 != bot_bot(set(A)) )
        & pp(aa(set(A),bool,finite_finite(A),A4)) ) ) ).

% card_gt_0_iff
tff(fact_2326_min__ext__compat,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,R,S2)),R))
     => pp(aa(set(product_prod(set(A),set(A))),bool,aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),bool),ord_less_eq(set(product_prod(set(A),set(A)))),relcomp(set(A),set(A),set(A),min_ext(A,R),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),sup_sup(set(product_prod(set(A),set(A)))),min_ext(A,S2)),aa(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))),insert2(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),bot_bot(set(A))),bot_bot(set(A)))),bot_bot(set(product_prod(set(A),set(A)))))))),min_ext(A,R))) ) ).

% min_ext_compat
tff(fact_2327_card__1__singletonI,axiom,
    ! [A: $tType,S2: set(A),X: A] :
      ( pp(aa(set(A),bool,finite_finite(A),S2))
     => ( ( finite_card(A,S2) = one_one(nat) )
       => ( pp(member(A,X,S2))
         => ( S2 = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ) ) ) ).

% card_1_singletonI
tff(fact_2328_finite__induct__select,axiom,
    ! [A: $tType,S2: set(A),P: fun(set(A),bool)] :
      ( pp(aa(set(A),bool,finite_finite(A),S2))
     => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
       => ( ! [T5: set(A)] :
              ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),T5),S2))
             => ( pp(aa(set(A),bool,P,T5))
               => ? [X3: A] :
                    ( pp(member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),T5)))
                    & pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,X3),T5))) ) ) )
         => pp(aa(set(A),bool,P,S2)) ) ) ) ).

% finite_induct_select
tff(fact_2329_card__Un__Int,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(aa(set(A),bool,finite_finite(A),B3))
       => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(A,A4)),finite_card(A,B3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3))),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3))) ) ) ) ).

% card_Un_Int
tff(fact_2330_wf__bounded__set,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),Ub: fun(A,set(B)),F: fun(A,set(B))] :
      ( ! [A8: A,B5: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B5),A8),R3))
         => ( pp(aa(set(B),bool,finite_finite(B),aa(A,set(B),Ub,A8)))
            & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),Ub,B5)),aa(A,set(B),Ub,A8)))
            & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F,B5)),aa(A,set(B),Ub,A8)))
            & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less(set(B)),aa(A,set(B),F,A8)),aa(A,set(B),F,B5))) ) )
     => wf(A,R3) ) ).

% wf_bounded_set
tff(fact_2331_smax__emptyI,axiom,
    ! [Y5: set(product_prod(nat,nat))] :
      ( pp(aa(set(product_prod(nat,nat)),bool,finite_finite(product_prod(nat,nat)),Y5))
     => ( ( Y5 != bot_bot(set(product_prod(nat,nat))) )
       => pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bot_bot(set(product_prod(nat,nat)))),Y5),fun_max_strict)) ) ) ).

% smax_emptyI
tff(fact_2332_card__Diff__subset__Int,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)))
     => ( finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(A,A4)),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3))) ) ) ).

% card_Diff_subset_Int
tff(fact_2333_max__ext_Ocases,axiom,
    ! [A: $tType,A1: set(A),A22: set(A),R: set(product_prod(A,A))] :
      ( pp(member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),A1),A22),max_ext(A,R)))
     => ~ ( pp(aa(set(A),bool,finite_finite(A),A1))
         => ( pp(aa(set(A),bool,finite_finite(A),A22))
           => ( ( A22 != bot_bot(set(A)) )
             => ~ ! [X3: A] :
                    ( pp(member(A,X3,A1))
                   => ? [Xa4: A] :
                        ( pp(member(A,Xa4,A22))
                        & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa4),R)) ) ) ) ) ) ) ).

% max_ext.cases
tff(fact_2334_max__ext_Osimps,axiom,
    ! [A: $tType,A1: set(A),A22: set(A),R: set(product_prod(A,A))] :
      ( pp(member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),A1),A22),max_ext(A,R)))
    <=> ( pp(aa(set(A),bool,finite_finite(A),A1))
        & pp(aa(set(A),bool,finite_finite(A),A22))
        & ( A22 != bot_bot(set(A)) )
        & ! [X4: A] :
            ( pp(member(A,X4,A1))
           => ? [Xa2: A] :
                ( pp(member(A,Xa2,A22))
                & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa2),R)) ) ) ) ) ).

% max_ext.simps
tff(fact_2335_max__ext_Omax__extI,axiom,
    ! [A: $tType,X6: set(A),Y5: set(A),R: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,finite_finite(A),X6))
     => ( pp(aa(set(A),bool,finite_finite(A),Y5))
       => ( ( Y5 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,X6))
               => ? [Xa3: A] :
                    ( pp(member(A,Xa3,Y5))
                    & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Xa3),R)) ) )
           => pp(member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),X6),Y5),max_ext(A,R))) ) ) ) ) ).

% max_ext.max_extI
tff(fact_2336_wmax__emptyI,axiom,
    ! [X6: set(product_prod(nat,nat))] :
      ( pp(aa(set(product_prod(nat,nat)),bool,finite_finite(product_prod(nat,nat)),X6))
     => pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bot_bot(set(product_prod(nat,nat)))),X6),fun_max_weak)) ) ).

% wmax_emptyI
tff(fact_2337_card__Suc__Diff1,axiom,
    ! [A: $tType,A4: set(A),X: A] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(member(A,X,A4))
       => ( aa(nat,nat,suc,finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) = finite_card(A,A4) ) ) ) ).

% card_Suc_Diff1
tff(fact_2338_card_Oinsert__remove,axiom,
    ! [A: $tType,A4: set(A),X: A] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( finite_card(A,aa(set(A),set(A),insert2(A,X),A4)) = aa(nat,nat,suc,finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ).

% card.insert_remove
tff(fact_2339_card_Oremove,axiom,
    ! [A: $tType,A4: set(A),X: A] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(member(A,X,A4))
       => ( finite_card(A,A4) = aa(nat,nat,suc,finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ).

% card.remove
tff(fact_2340_card__Diff1__less__iff,axiom,
    ! [A: $tType,A4: set(A),X: A] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))),finite_card(A,A4)))
    <=> ( pp(aa(set(A),bool,finite_finite(A),A4))
        & pp(member(A,X,A4)) ) ) ).

% card_Diff1_less_iff
tff(fact_2341_card__Diff2__less,axiom,
    ! [A: $tType,A4: set(A),X: A,Y: A] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(member(A,X,A4))
       => ( pp(member(A,Y,A4))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))),aa(set(A),set(A),insert2(A,Y),bot_bot(set(A)))))),finite_card(A,A4))) ) ) ) ).

% card_Diff2_less
tff(fact_2342_card__Diff1__less,axiom,
    ! [A: $tType,A4: set(A),X: A] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(member(A,X,A4))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))),finite_card(A,A4))) ) ) ).

% card_Diff1_less
tff(fact_2343_in__finite__psubset,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( pp(member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),A4),B3),finite_psubset(A)))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A4),B3))
        & pp(aa(set(A),bool,finite_finite(A),B3)) ) ) ).

% in_finite_psubset
tff(fact_2344_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),P: fun(set(A),bool)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
           => ( ! [B5: A,A12: set(A)] :
                  ( pp(aa(set(A),bool,finite_finite(A),A12))
                 => ( ! [X3: A] :
                        ( pp(member(A,X3,A12))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X3),B5)) )
                   => ( pp(aa(set(A),bool,P,A12))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,B5),A12))) ) ) )
             => pp(aa(set(A),bool,P,A4)) ) ) ) ) ).

% finite_linorder_max_induct
tff(fact_2345_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),P: fun(set(A),bool)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(aa(set(A),bool,P,bot_bot(set(A))))
           => ( ! [B5: A,A12: set(A)] :
                  ( pp(aa(set(A),bool,finite_finite(A),A12))
                 => ( ! [X3: A] :
                        ( pp(member(A,X3,A12))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B5),X3)) )
                   => ( pp(aa(set(A),bool,P,A12))
                     => pp(aa(set(A),bool,P,aa(set(A),set(A),insert2(A,B5),A12))) ) ) )
             => pp(aa(set(A),bool,P,A4)) ) ) ) ) ).

% finite_linorder_min_induct
tff(fact_2346_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [S2: set(B),P: fun(set(B),bool),F: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),S2))
         => ( pp(aa(set(B),bool,P,bot_bot(set(B))))
           => ( ! [X2: B,S5: set(B)] :
                  ( pp(aa(set(B),bool,finite_finite(B),S5))
                 => ( ! [Y4: B] :
                        ( pp(member(B,Y4,S5))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,Y4)),aa(B,A,F,X2))) )
                   => ( pp(aa(set(B),bool,P,S5))
                     => pp(aa(set(B),bool,P,aa(set(B),set(B),insert2(B,X2),S5))) ) ) )
             => pp(aa(set(B),bool,P,S2)) ) ) ) ) ).

% finite_ranking_induct
tff(fact_2347_infinite__growing,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X6: set(A)] :
          ( ( X6 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,X6))
               => ? [Xa3: A] :
                    ( pp(member(A,Xa3,X6))
                    & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Xa3)) ) )
           => ~ pp(aa(set(A),bool,finite_finite(A),X6)) ) ) ) ).

% infinite_growing
tff(fact_2348_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [S2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( ( S2 != bot_bot(set(A)) )
           => ? [X2: A] :
                ( pp(member(A,X2,S2))
                & ~ ? [Xa3: A] :
                      ( pp(member(A,Xa3,S2))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Xa3),X2)) ) ) ) ) ) ).

% ex_min_if_finite
tff(fact_2349_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [S2: set(A),F: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( ( S2 != bot_bot(set(A)) )
           => ~ ? [X3: A] :
                  ( pp(member(A,X3,S2))
                  & pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F,X3)),aa(A,B,F,lattic7623131987881927897min_on(A,B,F,S2)))) ) ) ) ) ).

% arg_min_if_finite(2)
tff(fact_2350_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [S2: set(A),Y: A,F: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( ( S2 != bot_bot(set(A)) )
           => ( pp(member(A,Y,S2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,lattic7623131987881927897min_on(A,B,F,S2))),aa(A,B,F,Y))) ) ) ) ) ).

% arg_min_least
tff(fact_2351_finite__transitivity__chain,axiom,
    ! [A: $tType,A4: set(A),R: fun(A,fun(A,bool))] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( ! [X2: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),R,X2),X2))
       => ( ! [X2: A,Y2: A,Z3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),R,X2),Y2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),R,Y2),Z3))
               => pp(aa(A,bool,aa(A,fun(A,bool),R,X2),Z3)) ) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,A4))
               => ? [Y4: A] :
                    ( pp(member(A,Y4,A4))
                    & pp(aa(A,bool,aa(A,fun(A,bool),R,X2),Y4)) ) )
           => ( A4 = bot_bot(set(A)) ) ) ) ) ) ).

% finite_transitivity_chain
tff(fact_2352_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: set(A)] :
          ( ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A4) = zero_zero(A) )
        <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),insert2(A,zero_zero(A)),bot_bot(set(A)))))
            & pp(aa(set(A),bool,finite_finite(A),A4)) ) ) ) ).

% Gcd_fin_0_iff
tff(fact_2353_greaterThan__Suc,axiom,
    ! [K: nat] : ( aa(nat,set(nat),set_ord_greaterThan(nat),aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_greaterThan(nat),K)),aa(set(nat),set(nat),insert2(nat,aa(nat,nat,suc,K)),bot_bot(set(nat)))) ) ).

% greaterThan_Suc
tff(fact_2354_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) )
             => ( aa(set(A),A,lattic5882676163264333800up_fin(A),aa(set(A),set(A),insert2(A,X),A4)) = X ) )
            & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic5882676163264333800up_fin(A),aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(set(A),A,lattic5882676163264333800up_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ).

% Sup_fin.insert_remove
tff(fact_2355_Gcd__fin_Oempty,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),bot_bot(set(A))) = zero_zero(A) ) ) ).

% Gcd_fin.empty
tff(fact_2356_Sup__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A] : ( aa(set(A),A,lattic5882676163264333800up_fin(A),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = X ) ) ).

% Sup_fin.singleton
tff(fact_2357_Gcd__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: set(A)] :
          ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A4) = one_one(A) ) ) ) ).

% Gcd_fin.infinite
tff(fact_2358_inf__Sup__absorb,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [A4: set(A),A3: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,A3,A4))
           => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)) = A3 ) ) ) ) ).

% inf_Sup_absorb
tff(fact_2359_is__unit__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: set(A)] :
          ( pp(dvd_dvd(A,aa(set(A),A,semiring_gcd_Gcd_fin(A),A4),one_one(A)))
        <=> ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A4) = one_one(A) ) ) ) ).

% is_unit_Gcd_fin_iff
tff(fact_2360_Sup__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic5882676163264333800up_fin(A),aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)) ) ) ) ) ).

% Sup_fin.insert
tff(fact_2361_greaterThan__non__empty,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [X: A] : ( aa(A,set(A),set_ord_greaterThan(A),X) != bot_bot(set(A)) ) ) ).

% greaterThan_non_empty
tff(fact_2362_Sup__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,X,A4))
           => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)) = aa(set(A),A,lattic5882676163264333800up_fin(A),A4) ) ) ) ) ).

% Sup_fin.in_idem
tff(fact_2363_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)),X))
            <=> ! [X4: A] :
                  ( pp(member(A,X4,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),X)) ) ) ) ) ) ).

% Sup_fin.bounded_iff
tff(fact_2364_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [A8: A] :
                  ( pp(member(A,A8,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A8),X)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)),X)) ) ) ) ) ).

% Sup_fin.boundedI
tff(fact_2365_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)),X))
             => ! [A13: A] :
                  ( pp(member(A,A13,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A13),X)) ) ) ) ) ) ).

% Sup_fin.boundedE
tff(fact_2366_ivl__disj__int__one_I7_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,L,U)),aa(A,set(A),set_ord_greaterThan(A),U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(7)
tff(fact_2367_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)),aa(set(A),A,lattic5882676163264333800up_fin(A),B3))) ) ) ) ) ).

% Sup_fin.subset_imp
tff(fact_2368_Sup__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [H2: fun(A,A),N4: set(A)] :
          ( ! [X2: A,Y2: A] : ( aa(A,A,H2,aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,H2,X2)),aa(A,A,H2,Y2)) )
         => ( pp(aa(set(A),bool,finite_finite(A),N4))
           => ( ( N4 != bot_bot(set(A)) )
             => ( aa(A,A,H2,aa(set(A),A,lattic5882676163264333800up_fin(A),N4)) = aa(set(A),A,lattic5882676163264333800up_fin(A),aa(set(A),set(A),image2(A,A,H2),N4)) ) ) ) ) ) ).

% Sup_fin.hom_commute
tff(fact_2369_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( B3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A4))
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,lattic5882676163264333800up_fin(A),B3)),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)) = aa(set(A),A,lattic5882676163264333800up_fin(A),A4) ) ) ) ) ) ).

% Sup_fin.subset
tff(fact_2370_Sup__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [X2: A,Y2: A] : pp(member(A,aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y2),aa(set(A),set(A),insert2(A,X2),aa(set(A),set(A),insert2(A,Y2),bot_bot(set(A))))))
             => pp(member(A,aa(set(A),A,lattic5882676163264333800up_fin(A),A4),A4)) ) ) ) ) ).

% Sup_fin.closed
tff(fact_2371_Sup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ~ pp(member(A,X,A4))
           => ( ( A4 != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic5882676163264333800up_fin(A),aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
tff(fact_2372_Sup__fin_Ounion,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => ( ( B3 != bot_bot(set(A)) )
               => ( aa(set(A),A,lattic5882676163264333800up_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)),aa(set(A),A,lattic5882676163264333800up_fin(A),B3)) ) ) ) ) ) ) ).

% Sup_fin.union
tff(fact_2373_arg__min__if__finite_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [S2: set(A),F: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( ( S2 != bot_bot(set(A)) )
           => pp(member(A,lattic7623131987881927897min_on(A,B,F,S2),S2)) ) ) ) ).

% arg_min_if_finite(1)
tff(fact_2374_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,X,A4))
           => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) )
               => ( aa(set(A),A,lattic5882676163264333800up_fin(A),A4) = X ) )
              & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) != bot_bot(set(A)) )
               => ( aa(set(A),A,lattic5882676163264333800up_fin(A),A4) = aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(set(A),A,lattic5882676163264333800up_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ) ).

% Sup_fin.remove
tff(fact_2375_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S2: set(A),N: nat] : ( infini527867602293511546merate(A,S2,aa(nat,nat,suc,N)) = infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert2(A,infini527867602293511546merate(A,S2,zero_zero(nat))),bot_bot(set(A)))),N) ) ) ).

% enumerate_Suc'
tff(fact_2376_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,X,A4))
           => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) )
               => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),A4) = X ) )
              & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) != bot_bot(set(A)) )
               => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),A4) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ) ).

% Inf_fin.remove
tff(fact_2377_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) )
             => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert2(A,X),A4)) = X ) )
            & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ).

% Inf_fin.insert_remove
tff(fact_2378_Inf__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)) ) ) ) ) ).

% Inf_fin.insert
tff(fact_2379_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_atMost(nat,N)),aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_atMost_eq_remove0
tff(fact_2380_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert2(A,L),bot_bot(set(A)))),set_or3652927894154168847AtMost(A,L,U)) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(5)
tff(fact_2381_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,K: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),K))
         => ( set_or3652927894154168847AtMost(A,K,L) = bot_bot(set(A)) ) ) ) ).

% greaterThanAtMost_empty
tff(fact_2382_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A,L: A] :
          ( ( bot_bot(set(A)) = set_or3652927894154168847AtMost(A,K,L) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) ) ) ).

% greaterThanAtMost_empty_iff2
tff(fact_2383_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A,L: A] :
          ( ( set_or3652927894154168847AtMost(A,K,L) = bot_bot(set(A)) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),L)) ) ) ).

% greaterThanAtMost_empty_iff
tff(fact_2384_Int__atMost,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_atMost(A,A3)),set_ord_atMost(A,B2)) = set_ord_atMost(A,aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)) ) ) ).

% Int_atMost
tff(fact_2385_Inf__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A] : ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = X ) ) ).

% Inf_fin.singleton
tff(fact_2386_sup__Inf__absorb,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [A4: set(A),A3: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,A3,A4))
           => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)),A3) = A3 ) ) ) ) ).

% sup_Inf_absorb
tff(fact_2387_Int__atLeastAtMostL1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,D2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,A3,B2)),set_ord_atMost(A,D2)) = set_or1337092689740270186AtMost(A,A3,aa(A,A,aa(A,fun(A,A),ord_min(A),B2),D2)) ) ) ).

% Int_atLeastAtMostL1
tff(fact_2388_Int__atLeastAtMostR1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,D2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_atMost(A,B2)),set_or1337092689740270186AtMost(A,C2,D2)) = set_or1337092689740270186AtMost(A,C2,aa(A,A,aa(A,fun(A,A),ord_min(A),B2),D2)) ) ) ).

% Int_atLeastAtMostR1
tff(fact_2389_atMost__0,axiom,
    set_ord_atMost(nat,zero_zero(nat)) = aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat))) ).

% atMost_0
tff(fact_2390_ivl__disj__int__one_I3_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_atMost(A,L)),set_or3652927894154168847AtMost(A,L,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(3)
tff(fact_2391_greaterThanAtMost__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A,U: A] : ( set_or3652927894154168847AtMost(A,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_greaterThan(A),L)),set_ord_atMost(A,U)) ) ) ).

% greaterThanAtMost_def
tff(fact_2392_not__empty__eq__Iic__eq__empty,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [H2: A] : ( bot_bot(set(A)) != set_ord_atMost(A,H2) ) ) ).

% not_empty_eq_Iic_eq_empty
tff(fact_2393_ivl__disj__int__two_I6_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M4: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,L,M4)),set_or3652927894154168847AtMost(A,M4,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(6)
tff(fact_2394_Inf__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,X,A4))
           => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)) = aa(set(A),A,lattic7752659483105999362nf_fin(A),A4) ) ) ) ) ).

% Inf_fin.in_idem
tff(fact_2395_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] :
          ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,A3,B2)),set_or3652927894154168847AtMost(A,C2,D2)) = bot_bot(set(A)) )
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),C2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),C2))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),A3)) ) ) ) ).

% Ioc_disjoint
tff(fact_2396_ivl__disj__int__two_I8_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M4: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,L,M4)),set_or3652927894154168847AtMost(A,M4,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(8)
tff(fact_2397_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)))
             => ! [A13: A] :
                  ( pp(member(A,A13,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),A13)) ) ) ) ) ) ).

% Inf_fin.boundedE
tff(fact_2398_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [A8: A] :
                  ( pp(member(A,A8,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),A8)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4))) ) ) ) ) ).

% Inf_fin.boundedI
tff(fact_2399_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)))
            <=> ! [X4: A] :
                  ( pp(member(A,X4,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),X4)) ) ) ) ) ) ).

% Inf_fin.bounded_iff
tff(fact_2400_ivl__disj__int__one_I5_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,L,U)),aa(A,set(A),set_ord_greaterThan(A),U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(5)
tff(fact_2401_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] : ( set_or3652927894154168847AtMost(A,A3,B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A3,B2)),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
tff(fact_2402_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),B3)),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4))) ) ) ) ) ).

% Inf_fin.subset_imp
tff(fact_2403_Inf__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [H2: fun(A,A),N4: set(A)] :
          ( ! [X2: A,Y2: A] : ( aa(A,A,H2,aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,H2,X2)),aa(A,A,H2,Y2)) )
         => ( pp(aa(set(A),bool,finite_finite(A),N4))
           => ( ( N4 != bot_bot(set(A)) )
             => ( aa(A,A,H2,aa(set(A),A,lattic7752659483105999362nf_fin(A),N4)) = aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),image2(A,A,H2),N4)) ) ) ) ) ) ).

% Inf_fin.hom_commute
tff(fact_2404_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( B3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A4))
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),B3)),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)) = aa(set(A),A,lattic7752659483105999362nf_fin(A),A4) ) ) ) ) ) ).

% Inf_fin.subset
tff(fact_2405_Inf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ~ pp(member(A,X,A4))
           => ( ( A4 != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
tff(fact_2406_Inf__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [X2: A,Y2: A] : pp(member(A,aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y2),aa(set(A),set(A),insert2(A,X2),aa(set(A),set(A),insert2(A,Y2),bot_bot(set(A))))))
             => pp(member(A,aa(set(A),A,lattic7752659483105999362nf_fin(A),A4),A4)) ) ) ) ) ).

% Inf_fin.closed
tff(fact_2407_Inf__fin_Ounion,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => ( ( B3 != bot_bot(set(A)) )
               => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)),aa(set(A),A,lattic7752659483105999362nf_fin(A),B3)) ) ) ) ) ) ) ).

% Inf_fin.union
tff(fact_2408_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)),aa(set(A),A,lattic5882676163264333800up_fin(A),A4))) ) ) ) ).

% Inf_fin_le_Sup_fin
tff(fact_2409_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M4: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ) ).

% sum.atLeastAtMost_shift_0
tff(fact_2410_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S2: set(A),N: nat,S: A] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),set_ord_lessThan(A,S)))))
           => ( infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),set_ord_lessThan(A,S)),N) = infini527867602293511546merate(A,S2,N) ) ) ) ) ).

% finite_enumerate_initial_segment
tff(fact_2411_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M4: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ) ).

% prod.atLeastAtMost_shift_0
tff(fact_2412_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,U)),aa(set(A),set(A),insert2(A,U),bot_bot(set(A)))) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(4)
tff(fact_2413_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [N: nat,M4: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),M4))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,aa(nat,nat,suc,N))) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(nat,nat,suc,N)),M4))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ) ) ).

% prod.cl_ivl_Suc
tff(fact_2414_atLeastLessThan__nat__numeral,axiom,
    ! [M4: nat,K: num] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),pred_numeral(K)))
       => ( set_or7035219750837199246ssThan(nat,M4,aa(num,nat,numeral_numeral(nat),K)) = aa(set(nat),set(nat),insert2(nat,pred_numeral(K)),set_or7035219750837199246ssThan(nat,M4,pred_numeral(K))) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),pred_numeral(K)))
       => ( set_or7035219750837199246ssThan(nat,M4,aa(num,nat,numeral_numeral(nat),K)) = bot_bot(set(nat)) ) ) ) ).

% atLeastLessThan_nat_numeral
tff(fact_2415_lessThan__0,axiom,
    set_ord_lessThan(nat,zero_zero(nat)) = bot_bot(set(nat)) ).

% lessThan_0
tff(fact_2416_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( set_or7035219750837199246ssThan(A,A3,B2) = bot_bot(set(A)) ) ) ) ).

% atLeastLessThan_empty
tff(fact_2417_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( ( set_or7035219750837199246ssThan(A,A3,B2) = bot_bot(set(A)) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% atLeastLessThan_empty_iff
tff(fact_2418_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: A,B2: A] :
          ( ( bot_bot(set(A)) = set_or7035219750837199246ssThan(A,A3,B2) )
        <=> ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2)) ) ) ).

% atLeastLessThan_empty_iff2
tff(fact_2419_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,N))),aa(nat,A,G,N)) ) ) ).

% prod.lessThan_Suc
tff(fact_2420_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,K: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),K))
         => ( set_or5935395276787703475ssThan(A,K,L) = bot_bot(set(A)) ) ) ) ).

% greaterThanLessThan_empty
tff(fact_2421_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( ( set_or5935395276787703475ssThan(A,A3,B2) = bot_bot(set(A)) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% greaterThanLessThan_empty_iff
tff(fact_2422_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A3: A,B2: A] :
          ( ( bot_bot(set(A)) = set_or5935395276787703475ssThan(A,A3,B2) )
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% greaterThanLessThan_empty_iff2
tff(fact_2423_single__Diff__lessThan,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert2(A,K),bot_bot(set(A)))),set_ord_lessThan(A,K)) = aa(set(A),set(A),insert2(A,K),bot_bot(set(A))) ) ) ).

% single_Diff_lessThan
tff(fact_2424_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% prod.atMost_Suc
tff(fact_2425_atLeastLessThan__singleton,axiom,
    ! [M4: nat] : ( set_or7035219750837199246ssThan(nat,M4,aa(nat,nat,suc,M4)) = aa(set(nat),set(nat),insert2(nat,M4),bot_bot(set(nat))) ) ).

% atLeastLessThan_singleton
tff(fact_2426_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [N: nat,M4: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M4))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M4,aa(nat,nat,suc,N))) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M4))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M4,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M4,N))),aa(nat,A,G,N)) ) ) ) ) ).

% prod.op_ivl_Suc
tff(fact_2427_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M4: nat,N: nat,P3: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N),P3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M4,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,N,P3))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M4,P3)) ) ) ) ) ).

% prod.atLeastLessThan_concat
tff(fact_2428_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
tff(fact_2429_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
tff(fact_2430_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M4: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% prod.atLeastLessThan_shift_bounds
tff(fact_2431_ivl__disj__int__one_I2_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,L)),set_or7035219750837199246ssThan(A,L,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(2)
tff(fact_2432_ivl__disj__int__two_I1_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M4: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or5935395276787703475ssThan(A,L,M4)),set_or7035219750837199246ssThan(A,M4,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(1)
tff(fact_2433_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M4: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% sum.atLeastLessThan_shift_bounds
tff(fact_2434_greaterThanLessThan__eq,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A] : ( set_or5935395276787703475ssThan(A,A3,B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_greaterThan(A),A3)),set_ord_lessThan(A,B2)) ) ) ).

% greaterThanLessThan_eq
tff(fact_2435_greaterThanLessThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A,U: A] : ( set_or5935395276787703475ssThan(A,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_greaterThan(A),L)),set_ord_lessThan(A,U)) ) ) ).

% greaterThanLessThan_def
tff(fact_2436_lessThan__non__empty,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [X: A] : ( set_ord_lessThan(A,X) != bot_bot(set(A)) ) ) ).

% lessThan_non_empty
tff(fact_2437_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(nat,A,G,N)) ) ) ).

% prod.atLeast0_lessThan_Suc
tff(fact_2438_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M4: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M4),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M4,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M4)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),N))) ) ) ) ).

% prod.atLeast_Suc_lessThan
tff(fact_2439_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: nat,B2: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),B2))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,A3,aa(nat,nat,suc,B2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,A3,B2))),aa(nat,A,G,B2)) ) ) ) ).

% prod.atLeastLessThan_Suc
tff(fact_2440_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M4: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,N)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M4,N))) ) ) ) ).

% prod.last_plus
tff(fact_2441_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [N: nat,M4: nat,G: fun(nat,A)] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M4))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N)) = one_one(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M4))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M4,N))),aa(nat,A,G,N)) ) ) ) ) ).

% prod.head_if
tff(fact_2442_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
tff(fact_2443_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
tff(fact_2444_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M4,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ).

% prod.atLeastLessThan_shift_0
tff(fact_2445_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M4,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ).

% sum.atLeastLessThan_shift_0
tff(fact_2446_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert2(A,L),bot_bot(set(A)))),set_or5935395276787703475ssThan(A,L,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(3)
tff(fact_2447_ivl__disj__int__two_I3_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M4: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or7035219750837199246ssThan(A,L,M4)),set_or7035219750837199246ssThan(A,M4,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(3)
tff(fact_2448_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( set_ord_lessThan(nat,N) = bot_bot(set(nat)) )
    <=> ( N = zero_zero(nat) ) ) ).

% lessThan_empty_iff
tff(fact_2449_atLeastLessThan0,axiom,
    ! [M4: nat] : ( set_or7035219750837199246ssThan(nat,M4,zero_zero(nat)) = bot_bot(set(nat)) ) ).

% atLeastLessThan0
tff(fact_2450_Iio__eq__empty__iff,axiom,
    ! [A: $tType] :
      ( ( linorder(A)
        & order_bot(A) )
     => ! [N: A] :
          ( ( set_ord_lessThan(A,N) = bot_bot(set(A)) )
        <=> ( N = bot_bot(A) ) ) ) ).

% Iio_eq_empty_iff
tff(fact_2451_greaterThan__Int__greaterThan,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,A3)),set_ord_lessThan(A,B2)) = set_ord_lessThan(A,aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)) ) ) ).

% greaterThan_Int_greaterThan
tff(fact_2452_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_lessThan(nat,N)),aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_lessThan_eq_remove0
tff(fact_2453_fact__split,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: nat,N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),N))
         => ( semiring_char_0_fact(A,N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K),N)))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_split
tff(fact_2454_prod_Ohead,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M4: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M4)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or3652927894154168847AtMost(nat,M4,N))) ) ) ) ).

% prod.head
tff(fact_2455_ivl__disj__int__two_I7_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M4: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or7035219750837199246ssThan(A,L,M4)),set_or1337092689740270186AtMost(A,M4,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(7)
tff(fact_2456_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
tff(fact_2457_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M4: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% prod.atLeastAtMost_shift_bounds
tff(fact_2458_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
tff(fact_2459_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M4: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% sum.atLeastAtMost_shift_bounds
tff(fact_2460_ivl__disj__int__one_I4_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,L)),set_or1337092689740270186AtMost(A,L,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(4)
tff(fact_2461_ivl__disj__int__two_I5_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M4: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or5935395276787703475ssThan(A,L,M4)),set_or1337092689740270186AtMost(A,M4,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(5)
tff(fact_2462_ivl__disj__int__two_I4_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M4: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,L,M4)),set_or5935395276787703475ssThan(A,M4,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(4)
tff(fact_2463_ivl__disj__int__one_I1_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_atMost(A,L)),set_or5935395276787703475ssThan(A,L,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(1)
tff(fact_2464_ivl__disj__int__two_I2_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,M4: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,L,M4)),set_or5935395276787703475ssThan(A,M4,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_two(2)
tff(fact_2465_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% prod.atLeast0_atMost_Suc
tff(fact_2466_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M4: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),aa(nat,nat,suc,N)))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,aa(nat,nat,suc,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N))) ) ) ) ).

% prod.nat_ivl_Suc'
tff(fact_2467_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M4: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M4)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),N))) ) ) ) ).

% prod.atLeast_Suc_atMost
tff(fact_2468_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: A,B2: A] : ( set_or7035219750837199246ssThan(A,A3,B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A3,B2)),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
tff(fact_2469_atLeastLessThanSuc,axiom,
    ! [M4: nat,N: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
       => ( set_or7035219750837199246ssThan(nat,M4,aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert2(nat,N),set_or7035219750837199246ssThan(nat,M4,N)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
       => ( set_or7035219750837199246ssThan(nat,M4,aa(nat,nat,suc,N)) = bot_bot(set(nat)) ) ) ) ).

% atLeastLessThanSuc
tff(fact_2470_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X: A,K: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),K))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,K)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),K))
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,K)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) ) ) ) ) ).

% Iio_Int_singleton
tff(fact_2471_atLeastAtMost__diff__ends,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A3,B2)),aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))) = set_or5935395276787703475ssThan(A,A3,B2) ) ) ).

% atLeastAtMost_diff_ends
tff(fact_2472_ivl__disj__un__singleton_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_ord_lessThan(A,U)),aa(set(A),set(A),insert2(A,U),bot_bot(set(A)))) = set_ord_atMost(A,U) ) ) ).

% ivl_disj_un_singleton(2)
tff(fact_2473_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M4: nat,N: nat,G: fun(nat,A),P3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P3))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P3)))) ) ) ) ).

% prod.ub_add_nat
tff(fact_2474_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_atMost_Suc_shift
tff(fact_2475_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),L),U))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or7035219750837199246ssThan(A,L,U)),aa(set(A),set(A),insert2(A,U),bot_bot(set(A)))) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(6)
tff(fact_2476_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% sum.atLeast0_atMost_Suc_shift
tff(fact_2477_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),X: B,G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ~ pp(member(B,X,A4))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),insert2(B,X),A4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4)) ) ) ) ) ).

% prod.insert
tff(fact_2478_prod_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),G: fun(B,A)] :
          ( ~ pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) = one_one(A) ) ) ) ).

% prod.infinite
tff(fact_2479_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),bot_bot(set(B))) = one_one(A) ) ) ).

% prod.empty
tff(fact_2480_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty
tff(fact_2481_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & semiring_1(A) )
     => ! [A4: set(B),F: fun(B,A),K5: A] :
          ( ! [I3: B] :
              ( pp(member(B,I3,A4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F,I3)),K5)) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),finite_card(B,A4)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),finite_card(B,A4))),K5))) ) ) ) ).

% sum_bounded_above_strict
tff(fact_2482_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [A4: set(B),B3: set(B),F: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),B3))
           => ( ! [X2: B] :
                  ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3)))
                 => ( aa(B,A,F,X2) != zero_zero(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),B3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))) ) ) ) ) ) ).

% prod_Un
tff(fact_2483_sum_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(int,A),M4: nat,N: nat] : ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7311177749621191930dd_sum(int,A),G),set_or7035219750837199246ssThan(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,int),fun(nat,A),aa(fun(int,A),fun(fun(nat,int),fun(nat,A)),comp(int,A,nat),G),semiring_1_of_nat(int))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% sum.atLeast_int_lessThan_int_shift
tff(fact_2484_prod_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(int,A),M4: nat,N: nat] : ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7121269368397514597t_prod(int,A),G),set_or7035219750837199246ssThan(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,int),fun(nat,A),aa(fun(int,A),fun(fun(nat,int),fun(nat,A)),comp(int,A,nat),G),semiring_1_of_nat(int))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% prod.atLeast_int_lessThan_int_shift
tff(fact_2485_sum__diff1__nat,axiom,
    ! [A: $tType,A3: A,A4: set(A),F: fun(A,nat)] :
      ( ( pp(member(A,A3,A4))
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F),A4)),aa(A,nat,F,A3)) ) )
      & ( ~ pp(member(A,A3,A4))
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F),A4) ) ) ) ).

% sum_diff1_nat
tff(fact_2486_sum__Un__nat,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),F: fun(A,nat)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(aa(set(A),bool,finite_finite(A),B3))
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F),A4)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F),B3))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3))) ) ) ) ).

% sum_Un_nat
tff(fact_2487_prod_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(int,A),M4: nat,N: nat] : ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7121269368397514597t_prod(int,A),G),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,int),fun(nat,A),aa(fun(int,A),fun(fun(nat,int),fun(nat,A)),comp(int,A,nat),G),semiring_1_of_nat(int))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% prod.atLeast_int_atMost_int_shift
tff(fact_2488_sum_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(int,A),M4: nat,N: nat] : ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7311177749621191930dd_sum(int,A),G),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,int),fun(nat,A),aa(fun(int,A),fun(fun(nat,int),fun(nat,A)),comp(int,A,nat),G),semiring_1_of_nat(int))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% sum.atLeast_int_atMost_int_shift
tff(fact_2489_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),A4: set(B)] :
          ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) != one_one(A) )
         => ~ ! [A8: B] :
                ( pp(member(B,A8,A4))
               => ( aa(B,A,G,A8) = one_one(A) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
tff(fact_2490_prod_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),G: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(member(B,X2,A4))
             => ( aa(B,A,G,X2) = one_one(A) ) )
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) = one_one(A) ) ) ) ).

% prod.neutral
tff(fact_2491_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A4: set(B),F: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(member(B,X2,A4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(B,A,F,X2))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),A4))) ) ) ).

% prod_ge_1
tff(fact_2492_prod__inversef,axiom,
    ! [A: $tType,B: $tType] :
      ( field(A)
     => ! [F: fun(B,A),A4: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aa(fun(A,A),fun(fun(B,A),fun(B,A)),comp(A,A,B),inverse_inverse(A)),F)),A4) = aa(A,A,inverse_inverse(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),A4)) ) ) ).

% prod_inversef
tff(fact_2493_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A4: set(B),F: fun(B,A)] :
          ( ! [X2: B] :
              ( pp(member(B,X2,A4))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F,X2)))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,X2)),one_one(A))) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),A4)),one_one(A))) ) ) ).

% prod_le_1
tff(fact_2494_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( strict7427464778891057005id_add(A)
     => ! [A4: set(B),F: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [X2: B] :
                  ( pp(member(B,X2,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F,X2)),aa(B,A,G,X2))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A4))) ) ) ) ) ).

% sum_strict_mono
tff(fact_2495_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add(B)
        & comm_monoid_add(A) )
     => ! [H2: fun(B,A),G: fun(C,B),A4: set(C)] :
          ( ( aa(B,A,H2,zero_zero(B)) = zero_zero(A) )
         => ( ! [X2: B,Y2: B] : ( aa(B,A,H2,aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,H2,X2)),aa(B,A,H2,Y2)) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),H2),G)),A4) = aa(B,A,H2,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),A4)) ) ) ) ) ).

% sum_comp_morphism
tff(fact_2496_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [R: fun(A,fun(A,bool)),S2: set(B),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),R,one_one(A)),one_one(A)))
         => ( ! [X12: A,Y12: A,X23: A,Y23: A] :
                ( ( pp(aa(A,bool,aa(A,fun(A,bool),R,X12),X23))
                  & pp(aa(A,bool,aa(A,fun(A,bool),R,Y12),Y23)) )
               => pp(aa(A,bool,aa(A,fun(A,bool),R,aa(A,A,aa(A,fun(A,A),times_times(A),X12),Y12)),aa(A,A,aa(A,fun(A,A),times_times(A),X23),Y23))) )
           => ( pp(aa(set(B),bool,finite_finite(B),S2))
             => ( ! [X2: B] :
                    ( pp(member(B,X2,S2))
                   => pp(aa(A,bool,aa(A,fun(A,bool),R,aa(B,A,H2,X2)),aa(B,A,G,X2))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),R,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),S2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S2))) ) ) ) ) ) ).

% prod.related
tff(fact_2497_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),X: B,G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ( pp(member(B,X,A4))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),insert2(B,X),A4)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) ) )
            & ( ~ pp(member(B,X,A4))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),insert2(B,X),A4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4)) ) ) ) ) ) ).

% prod.insert_if
tff(fact_2498_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [S4: set(B),T6: set(C),S2: set(B),I: fun(C,B),J2: fun(B,C),T3: set(C),G: fun(B,A),H2: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),S4))
         => ( pp(aa(set(C),bool,finite_finite(C),T6))
           => ( ! [A8: B] :
                  ( pp(member(B,A8,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4)))
                 => ( aa(C,B,I,aa(B,C,J2,A8)) = A8 ) )
             => ( ! [A8: B] :
                    ( pp(member(B,A8,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4)))
                   => pp(member(C,aa(B,C,J2,A8),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T3),T6))) )
               => ( ! [B5: C] :
                      ( pp(member(C,B5,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T3),T6)))
                     => ( aa(B,C,J2,aa(C,B,I,B5)) = B5 ) )
                 => ( ! [B5: C] :
                        ( pp(member(C,B5,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T3),T6)))
                       => pp(member(B,aa(C,B,I,B5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4))) )
                   => ( ! [A8: B] :
                          ( pp(member(B,A8,S4))
                         => ( aa(B,A,G,A8) = one_one(A) ) )
                     => ( ! [B5: C] :
                            ( pp(member(C,B5,T6))
                           => ( aa(C,A,H2,B5) = one_one(A) ) )
                       => ( ! [A8: B] :
                              ( pp(member(B,A8,S2))
                             => ( aa(C,A,H2,aa(B,C,J2,A8)) = aa(B,A,G,A8) ) )
                         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S2) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),H2),T3) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
tff(fact_2499_sum_Oreindex,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [H2: fun(B,C),A4: set(B),G: fun(C,A)] :
          ( inj_on(B,C,H2,A4)
         => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),aa(set(B),set(C),image2(B,C,H2),A4)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,C),fun(B,A),aa(fun(C,A),fun(fun(B,C),fun(B,A)),comp(C,A,B),G),H2)),A4) ) ) ) ).

% sum.reindex
tff(fact_2500_prod_Oreindex,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [H2: fun(B,C),A4: set(B),G: fun(C,A)] :
          ( inj_on(B,C,H2,A4)
         => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),G),aa(set(B),set(C),image2(B,C,H2),A4)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,C),fun(B,A),aa(fun(C,A),fun(fun(B,C),fun(B,A)),comp(C,A,B),G),H2)),A4) ) ) ) ).

% prod.reindex
tff(fact_2501_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [I4: set(B),F: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),I4))
         => ( ( I4 != bot_bot(set(B)) )
           => ( ! [I3: B] :
                  ( pp(member(B,I3,I4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(B,A,F,I3))) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),I4))) ) ) ) ) ).

% sum_pos
tff(fact_2502_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I4: set(A),I: A,F: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite(A),I4))
         => ( pp(member(A,I,I4))
           => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),aa(A,B,F,I)))
             => ( ! [I3: A] :
                    ( pp(member(A,I3,I4))
                   => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),one_one(B)),aa(A,B,F,I3))) )
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F),I4))) ) ) ) ) ) ).

% less_1_prod2
tff(fact_2503_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I4: set(A),F: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite(A),I4))
         => ( ( I4 != bot_bot(set(A)) )
           => ( ! [I3: A] :
                  ( pp(member(A,I3,I4))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),aa(A,B,F,I3))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),one_one(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F),I4))) ) ) ) ) ).

% less_1_prod
tff(fact_2504_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),H2: fun(B,C),G: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ! [X2: B,Y2: B] :
                ( pp(member(B,X2,A4))
               => ( pp(member(B,Y2,A4))
                 => ( ( X2 != Y2 )
                   => ( ( aa(B,C,H2,X2) = aa(B,C,H2,Y2) )
                     => ( aa(C,A,G,aa(B,C,H2,X2)) = zero_zero(A) ) ) ) ) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),aa(set(B),set(C),image2(B,C,H2),A4)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,C),fun(B,A),aa(fun(C,A),fun(fun(B,C),fun(B,A)),comp(C,A,B),G),H2)),A4) ) ) ) ) ).

% sum.reindex_nontrivial
tff(fact_2505_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),H2: fun(B,C),G: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ! [X2: B,Y2: B] :
                ( pp(member(B,X2,A4))
               => ( pp(member(B,Y2,A4))
                 => ( ( X2 != Y2 )
                   => ( ( aa(B,C,H2,X2) = aa(B,C,H2,Y2) )
                     => ( aa(C,A,G,aa(B,C,H2,X2)) = one_one(A) ) ) ) ) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),G),aa(set(B),set(C),image2(B,C,H2),A4)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,C),fun(B,A),aa(fun(C,A),fun(fun(B,C),fun(B,A)),comp(C,A,B),G),H2)),A4) ) ) ) ) ).

% prod.reindex_nontrivial
tff(fact_2506_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & semiring_1(A) )
     => ! [A4: set(B),K5: A,F: fun(B,A)] :
          ( ! [I3: B] :
              ( pp(member(B,I3,A4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),K5),aa(B,A,F,I3))) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),finite_card(B,A4))),K5)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4))) ) ) ).

% sum_bounded_below
tff(fact_2507_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & semiring_1(A) )
     => ! [A4: set(B),F: fun(B,A),K5: A] :
          ( ! [I3: B] :
              ( pp(member(B,I3,A4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,I3)),K5)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),finite_card(B,A4))),K5))) ) ) ).

% sum_bounded_above
tff(fact_2508_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [T3: set(B),S2: set(B),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),T3))
         => ( pp(aa(set(B),bool,finite_finite(B),S2))
           => ( ! [I3: B] :
                  ( pp(member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
                 => ( aa(B,A,H2,I3) = zero_zero(A) ) )
             => ( ! [I3: B] :
                    ( pp(member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),T3)))
                   => ( aa(B,A,G,I3) = zero_zero(A) ) )
               => ( ! [X2: B] :
                      ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3)))
                     => ( aa(B,A,G,X2) = aa(B,A,H2,X2) ) )
                 => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H2),T3) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
tff(fact_2509_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [B3: set(B),A4: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),A4))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),B3)) ) ) ) ) ).

% prod.subset_diff
tff(fact_2510_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C3: set(B),A4: set(B),B3: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),C3))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A4),C3))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),C3))
             => ( ! [A8: B] :
                    ( pp(member(B,A8,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),A4)))
                   => ( aa(B,A,G,A8) = one_one(A) ) )
               => ( ! [B5: B] :
                      ( pp(member(B,B5,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),B3)))
                     => ( aa(B,A,H2,B5) = one_one(A) ) )
                 => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),B3) )
                  <=> ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),C3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),C3) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
tff(fact_2511_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C3: set(B),A4: set(B),B3: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),C3))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A4),C3))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),C3))
             => ( ! [A8: B] :
                    ( pp(member(B,A8,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),A4)))
                   => ( aa(B,A,G,A8) = one_one(A) ) )
               => ( ! [B5: B] :
                      ( pp(member(B,B5,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),B3)))
                     => ( aa(B,A,H2,B5) = one_one(A) ) )
                 => ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),C3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),C3) )
                   => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),B3) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
tff(fact_2512_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T3: set(B),S2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),T3))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T3))
           => ( ! [X2: B] :
                  ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
                 => ( aa(B,A,G,X2) = one_one(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),T3) ) ) ) ) ) ).

% prod.mono_neutral_left
tff(fact_2513_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T3: set(B),S2: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),T3))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T3))
           => ( ! [X2: B] :
                  ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
                 => ( aa(B,A,G,X2) = one_one(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),T3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S2) ) ) ) ) ) ).

% prod.mono_neutral_right
tff(fact_2514_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T3: set(B),S2: set(B),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),T3))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T3))
           => ( ! [X2: B] :
                  ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
                 => ( aa(B,A,H2,X2) = one_one(A) ) )
             => ( ! [X2: B] :
                    ( pp(member(B,X2,S2))
                   => ( aa(B,A,G,X2) = aa(B,A,H2,X2) ) )
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),T3) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
tff(fact_2515_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T3: set(B),S2: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),T3))
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T3))
           => ( ! [X2: B] :
                  ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
                 => ( aa(B,A,G,X2) = one_one(A) ) )
             => ( ! [X2: B] :
                    ( pp(member(B,X2,S2))
                   => ( aa(B,A,G,X2) = aa(B,A,H2,X2) ) )
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),T3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),S2) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
tff(fact_2516_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),B3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),B3))
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),B3)) ) ) ) ) ).

% sum.union_inter
tff(fact_2517_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),G: fun(B,A),B3: set(B)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B3))) ) ) ) ).

% sum.Int_Diff
tff(fact_2518_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),B3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),B3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),B3)) ) ) ) ) ).

% prod.union_inter
tff(fact_2519_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),G: fun(B,A),B3: set(B)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B3))) ) ) ) ).

% prod.Int_Diff
tff(fact_2520_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [T3: set(B),S2: set(B),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),T3))
         => ( pp(aa(set(B),bool,finite_finite(B),S2))
           => ( ! [I3: B] :
                  ( pp(member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
                 => ( aa(B,A,H2,I3) = one_one(A) ) )
             => ( ! [I3: B] :
                    ( pp(member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),T3)))
                   => ( aa(B,A,G,I3) = one_one(A) ) )
               => ( ! [X2: B] :
                      ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3)))
                     => ( aa(B,A,G,X2) = aa(B,A,H2,X2) ) )
                 => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),T3) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
tff(fact_2521_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_semidom(A)
     => ! [A4: set(B),F: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ! [I3: B] :
                ( pp(member(B,I3,A4))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F,I3)))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F,I3)),aa(B,A,G,I3))) ) )
           => ( ( A4 != bot_bot(set(B)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4))) ) ) ) ) ).

% prod_mono_strict
tff(fact_2522_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I4: set(C),G: fun(A,B),F: fun(C,A)] :
          ( pp(aa(set(C),bool,finite_finite(C),I4))
         => ( ! [I3: C] :
                ( pp(member(C,I3,I4))
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(A,B,G,aa(C,A,F,I3)))) )
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(C),set(A),image2(C,A,F),I4))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(fun(C,A),fun(C,B),aa(fun(A,B),fun(fun(C,A),fun(C,B)),comp(A,B,C),G),F)),I4))) ) ) ) ).

% sum_image_le
tff(fact_2523_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),B3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),B3))
           => ( ! [X2: B] :
                  ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3)))
                 => ( aa(B,A,G,X2) = zero_zero(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),B3)) ) ) ) ) ) ).

% sum.union_inter_neutral
tff(fact_2524_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),X: B,G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(member(B,X,A4))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,G,X)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% sum.remove
tff(fact_2525_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),G: fun(B,A),X: B] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),insert2(B,X),A4)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,G,X)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ).

% sum.insert_remove
tff(fact_2526_sum__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [A4: set(B),A3: B,F: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ( pp(member(B,A3,A4))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4)),aa(B,A,F,A3)) ) )
            & ( ~ pp(member(B,A3,A4))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4) ) ) ) ) ) ).

% sum_diff1
tff(fact_2527_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [A4: set(B),B3: set(B),F: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),B3))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))) ) ) ) ) ).

% sum_Un
tff(fact_2528_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),B3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),B3))
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3) = bot_bot(set(B)) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),B3)) ) ) ) ) ) ).

% sum.union_disjoint
tff(fact_2529_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),G: fun(B,A),X: B] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),insert2(B,X),A4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ).

% prod.insert_remove
tff(fact_2530_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),X: B,G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(member(B,X,A4))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% prod.remove
tff(fact_2531_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),B3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),B3))
           => ( ! [X2: B] :
                  ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3)))
                 => ( aa(B,A,G,X2) = one_one(A) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),B3)) ) ) ) ) ) ).

% prod.union_inter_neutral
tff(fact_2532_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),B3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),B3))
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3) = bot_bot(set(B)) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),B3)) ) ) ) ) ) ).

% prod.union_disjoint
tff(fact_2533_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A4: set(A),B3: set(A),F: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)))
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A4)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3))) ) ) ) ).

% sum_Un2
tff(fact_2534_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),B3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),B3))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B3),A4)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))) ) ) ) ) ).

% sum.union_diff2
tff(fact_2535_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),B3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),B3))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B3),A4)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))) ) ) ) ) ).

% prod.union_diff2
tff(fact_2536_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add(B)
        & semiring_1(B) )
     => ! [I: C,A4: set(C),F: fun(C,B)] :
          ( pp(member(C,I,A4))
         => ( ! [X2: C] :
                ( pp(member(C,X2,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A4),aa(set(C),set(C),insert2(C,I),bot_bot(set(C))))))
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(C,B,F,X2))) )
           => ( pp(aa(set(C),bool,finite_finite(C),A4))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(C,B,F,I)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),F),A4))) ) ) ) ) ).

% member_le_sum
tff(fact_2537_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [B3: set(A),A4: set(A),F: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite(A),B3))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
           => ( ! [B5: A] :
                  ( pp(member(A,B5,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A4)))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),one_one(B)),aa(A,B,F,B5))) )
             => ( ! [A8: A] :
                    ( pp(member(A,A8,A4))
                   => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(A,B,F,A8))) )
               => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F),A4)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F),B3))) ) ) ) ) ) ).

% prod_mono2
tff(fact_2538_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(A)
     => ! [A4: set(B),F: fun(B,A),N: A,K: nat] :
          ( ! [I3: B] :
              ( pp(member(B,I3,A4))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),aa(B,A,F,I3)))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,I3)),N)) ) )
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),finite_card(B,A4)),K))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),N))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),A4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),N),K))) ) ) ) ) ).

% prod_le_power
tff(fact_2539_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( semidom_divide(A)
     => ! [A4: set(B),F: fun(B,A),A3: B] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ( aa(B,A,F,A3) != zero_zero(A) )
           => ( ( pp(member(B,A3,A4))
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) = divide_divide(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),A4),aa(B,A,F,A3)) ) )
              & ( ~ pp(member(B,A3,A4))
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F),A4) ) ) ) ) ) ) ).

% prod_diff1
tff(fact_2540_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_field(A)
     => ! [A4: set(B),F: fun(B,A),K5: A] :
          ( ! [I3: B] :
              ( pp(member(B,I3,A4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,I3)),divide_divide(A,K5,aa(nat,A,semiring_1_of_nat(A),finite_card(B,A4))))) )
         => ( pp(aa(set(B),bool,finite_finite(B),A4))
           => ( ( A4 != bot_bot(set(B)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4)),K5)) ) ) ) ) ).

% sum_bounded_above_divide
tff(fact_2541_interval__cases,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [S2: set(A)] :
          ( ! [A8: A,B5: A,X2: A] :
              ( pp(member(A,A8,S2))
             => ( pp(member(A,B5,S2))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A8),X2))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),B5))
                   => pp(member(A,X2,S2)) ) ) ) )
         => ? [A8: A,B5: A] :
              ( ( S2 = bot_bot(set(A)) )
              | ( S2 = top_top(set(A)) )
              | ( S2 = set_ord_lessThan(A,B5) )
              | ( S2 = set_ord_atMost(A,B5) )
              | ( S2 = aa(A,set(A),set_ord_greaterThan(A),A8) )
              | ( S2 = set_ord_atLeast(A,A8) )
              | ( S2 = set_or5935395276787703475ssThan(A,A8,B5) )
              | ( S2 = set_or3652927894154168847AtMost(A,A8,B5) )
              | ( S2 = set_or7035219750837199246ssThan(A,A8,B5) )
              | ( S2 = set_or1337092689740270186AtMost(A,A8,B5) ) ) ) ) ).

% interval_cases
tff(fact_2542_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z2,aa(nat,nat,suc,N))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z2),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_aa(A,fun(nat,A),Z2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)),one_one(nat)))) ) ) ).

% pochhammer_times_pochhammer_half
tff(fact_2543_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ab(nat,fun(nat,A),N)),set_ord_atMost(nat,N))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N) ) ) ) ).

% choose_odd_sum
tff(fact_2544_choose__even__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ac(nat,fun(nat,A),N)),set_ord_atMost(nat,N))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N) ) ) ) ).

% choose_even_sum
tff(fact_2545_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,M4: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ad(A,fun(nat,A),A3)),set_ord_atMost(nat,M4)) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),M4)),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,gbinomial(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),one_one(nat)))) ) ) ).

% gbinomial_partial_row_sum
tff(fact_2546_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M4: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,A,semiring_1_of_nat(A),M4))),one_one(A)))),set_ord_atMost(nat,M4)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4)) ) ) ).

% gbinomial_r_part_sum
tff(fact_2547_atLeast__empty__triv,axiom,
    ! [A: $tType] : ( set_ord_atLeast(set(A),bot_bot(set(A))) = top_top(set(set(A))) ) ).

% atLeast_empty_triv
tff(fact_2548_Heap__Time__Monad_Obind__bind,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: heap_Time_Heap(A),G: fun(A,heap_Time_Heap(C)),K: fun(C,heap_Time_Heap(B))] : ( heap_Time_bind(C,B,heap_Time_bind(A,C,F,G),K) = heap_Time_bind(A,B,F,aa(fun(C,heap_Time_Heap(B)),fun(A,heap_Time_Heap(B)),aTP_Lamp_ae(fun(A,heap_Time_Heap(C)),fun(fun(C,heap_Time_Heap(B)),fun(A,heap_Time_Heap(B))),G),K)) ) ).

% Heap_Time_Monad.bind_bind
tff(fact_2549_bool__assn__proper_I2_J,axiom,
    pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aTP_Lamp_af(product_prod(heap_ext(product_unit),set(nat)),bool))) ).

% bool_assn_proper(2)
tff(fact_2550_bool__assn__proper_I3_J,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,Q))
       => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_ag(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool)),P),Q))) ) ) ).

% bool_assn_proper(3)
tff(fact_2551_bool__assn__proper_I4_J,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Q: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,Q))
       => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_ah(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool)),P),Q))) ) ) ).

% bool_assn_proper(4)
tff(fact_2552_singleton__conv2,axiom,
    ! [A: $tType,A3: A] : ( aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),fequal(A),A3)) = aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) ) ).

% singleton_conv2
tff(fact_2553_singleton__conv,axiom,
    ! [A: $tType,A3: A] : ( aa(fun(A,bool),set(A),collect(A),aTP_Lamp_ai(A,fun(A,bool),A3)) = aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) ) ).

% singleton_conv
tff(fact_2554_Collect__const,axiom,
    ! [A: $tType,P: bool] :
      ( ( pp(P)
       => ( aa(fun(A,bool),set(A),collect(A),aTP_Lamp_aj(bool,fun(A,bool),P)) = top_top(set(A)) ) )
      & ( ~ pp(P)
       => ( aa(fun(A,bool),set(A),collect(A),aTP_Lamp_aj(bool,fun(A,bool),P)) = bot_bot(set(A)) ) ) ) ).

% Collect_const
tff(fact_2555_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_ak(B,A)),A4) = one_one(A) ) ) ).

% prod.neutral_const
tff(fact_2556_bool__assn__proper_I5_J,axiom,
    ! [P: fun(product_prod(heap_ext(product_unit),set(nat)),bool)] :
      ( pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,P))
     => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aTP_Lamp_al(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),P))) ) ).

% bool_assn_proper(5)
tff(fact_2557_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),A3: B,B2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),S2))
         => ( ( pp(member(B,A3,S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_am(B,fun(fun(B,A),fun(B,A)),A3),B2)),S2) = aa(B,A,B2,A3) ) )
            & ( ~ pp(member(B,A3,S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_am(B,fun(fun(B,A),fun(B,A)),A3),B2)),S2) = one_one(A) ) ) ) ) ) ).

% prod.delta
tff(fact_2558_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),A3: B,B2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),S2))
         => ( ( pp(member(B,A3,S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_an(B,fun(fun(B,A),fun(B,A)),A3),B2)),S2) = aa(B,A,B2,A3) ) )
            & ( ~ pp(member(B,A3,S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_an(B,fun(fun(B,A),fun(B,A)),A3),B2)),S2) = one_one(A) ) ) ) ) ) ).

% prod.delta'
tff(fact_2559_if__image__distrib,axiom,
    ! [A: $tType,B: $tType,P: fun(B,bool),F: fun(B,A),G: fun(B,A),S2: set(B)] : ( aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_ao(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),F),G)),S2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(B),set(A),image2(B,A,F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),aa(fun(B,bool),set(B),collect(B),P)))),aa(set(B),set(A),image2(B,A,G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),aa(fun(B,bool),set(B),collect(B),aTP_Lamp_ap(fun(B,bool),fun(B,bool),P))))) ) ).

% if_image_distrib
tff(fact_2560_precise__extr__pure_I1_J,axiom,
    ! [B: $tType,A: $tType,P: bool,R: fun(A,fun(B,assn))] :
      ( precise(A,B,aa(fun(A,fun(B,assn)),fun(A,fun(B,assn)),aTP_Lamp_aq(bool,fun(fun(A,fun(B,assn)),fun(A,fun(B,assn))),P),R))
    <=> ( pp(P)
       => precise(A,B,R) ) ) ).

% precise_extr_pure(1)
tff(fact_2561_precise__extr__pure_I2_J,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,assn)),P: bool] :
      ( precise(A,B,aa(bool,fun(A,fun(B,assn)),aTP_Lamp_ar(fun(A,fun(B,assn)),fun(bool,fun(A,fun(B,assn))),R),P))
    <=> ( pp(P)
       => precise(A,B,R) ) ) ).

% precise_extr_pure(2)
tff(fact_2562_range__constant,axiom,
    ! [B: $tType,A: $tType,X: A] : ( aa(set(B),set(A),image2(B,A,aTP_Lamp_as(A,fun(B,A),X)),top_top(set(B))) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ).

% range_constant
tff(fact_2563_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Y: A,A4: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_at(A,fun(B,A),Y)),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),finite_card(B,A4))),Y) ) ) ).

% sum_constant
tff(fact_2564_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [A4: set(B),P: fun(B,bool),F: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_au(fun(B,bool),fun(fun(B,A),fun(B,A)),P),F)),A4) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,bool),set(B),collect(B),P))) ) ) ) ).

% sum_of_bool_mult_eq
tff(fact_2565_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [A4: set(B),F: fun(B,A),P: fun(B,bool)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,bool),fun(B,A),aTP_Lamp_av(fun(B,A),fun(fun(B,bool),fun(B,A)),F),P)),A4) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,bool),set(B),collect(B),P))) ) ) ) ).

% sum_mult_of_bool_eq
tff(fact_2566_sum__zero__power,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A4: set(nat),C2: fun(nat,A)] :
          ( ( ( pp(aa(set(nat),bool,finite_finite(nat),A4))
              & pp(member(nat,zero_zero(nat),A4)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,A),C2)),A4) = aa(nat,A,C2,zero_zero(nat)) ) )
          & ( ~ ( pp(aa(set(nat),bool,finite_finite(nat),A4))
                & pp(member(nat,zero_zero(nat),A4)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_aw(fun(nat,A),fun(nat,A),C2)),A4) = zero_zero(A) ) ) ) ) ).

% sum_zero_power
tff(fact_2567_sum__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [A4: set(B),P: fun(B,bool)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(B),bool,finite_finite(B),A4))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_ax(fun(B,bool),fun(B,A),P)),A4) = aa(nat,A,semiring_1_of_nat(A),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,bool),set(B),collect(B),P)))) ) ) ) ) ).

% sum_of_bool_eq
tff(fact_2568_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A4: set(nat),C2: fun(nat,A),D2: fun(nat,A)] :
          ( ( ( pp(aa(set(nat),bool,finite_finite(nat),A4))
              & pp(member(nat,zero_zero(nat),A4)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_ay(fun(nat,A),fun(fun(nat,A),fun(nat,A)),C2),D2)),A4) = divide_divide(A,aa(nat,A,C2,zero_zero(nat)),aa(nat,A,D2,zero_zero(nat))) ) )
          & ( ~ ( pp(aa(set(nat),bool,finite_finite(nat),A4))
                & pp(member(nat,zero_zero(nat),A4)) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_ay(fun(nat,A),fun(fun(nat,A),fun(nat,A)),C2),D2)),A4) = zero_zero(A) ) ) ) ) ).

% sum_zero_power'
tff(fact_2569_sum__product,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( semiring_0(B)
     => ! [F: fun(A,B),A4: set(A),G: fun(C,B),B3: set(C)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F),A4)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),B3)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(set(C),fun(A,B),aa(fun(C,B),fun(set(C),fun(A,B)),aTP_Lamp_ba(fun(A,B),fun(fun(C,B),fun(set(C),fun(A,B))),F),G),B3)),A4) ) ) ).

% sum_product
tff(fact_2570_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),H2: fun(B,A),A4: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_bb(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2)),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),A4)) ) ) ).

% prod.distrib
tff(fact_2571_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [F: fun(B,A),A4: set(B),R3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4)),R3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_bc(fun(B,A),fun(A,fun(B,A)),F),R3)),A4) ) ) ).

% sum_distrib_right
tff(fact_2572_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [R3: A,F: fun(B,A),A4: set(B)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),R3),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_bd(A,fun(fun(B,A),fun(B,A)),R3),F)),A4) ) ) ).

% sum_distrib_left
tff(fact_2573_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S2: set(product_prod(A,B))] :
      ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),R)),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),S2)))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),R),S2)) ) ).

% pred_subset_eq2
tff(fact_2574_bot__empty__eq2,axiom,
    ! [B: $tType,A: $tType,X3: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),bot_bot(fun(A,fun(B,bool))),X3),Xa3))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3),bot_bot(set(product_prod(A,B))))) ) ).

% bot_empty_eq2
tff(fact_2575_inj__singleton,axiom,
    ! [A: $tType,A4: set(A)] : inj_on(A,set(A),aTP_Lamp_bf(A,set(A)),A4) ).

% inj_singleton
tff(fact_2576_Collect__conv__if2,axiom,
    ! [A: $tType,P: fun(A,bool),A3: A] :
      ( ( pp(aa(A,bool,P,A3))
       => ( aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_bg(fun(A,bool),fun(A,fun(A,bool)),P),A3)) = aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) ) )
      & ( ~ pp(aa(A,bool,P,A3))
       => ( aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_bg(fun(A,bool),fun(A,fun(A,bool)),P),A3)) = bot_bot(set(A)) ) ) ) ).

% Collect_conv_if2
tff(fact_2577_Collect__conv__if,axiom,
    ! [A: $tType,P: fun(A,bool),A3: A] :
      ( ( pp(aa(A,bool,P,A3))
       => ( aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_bh(fun(A,bool),fun(A,fun(A,bool)),P),A3)) = aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) ) )
      & ( ~ pp(aa(A,bool,P,A3))
       => ( aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_bh(fun(A,bool),fun(A,fun(A,bool)),P),A3)) = bot_bot(set(A)) ) ) ) ).

% Collect_conv_if
tff(fact_2578_Set_Oempty__def,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_bi(A,bool)) ) ).

% Set.empty_def
tff(fact_2579_inf__Int__eq2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S2: set(product_prod(A,B)),X3: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),R)),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),S2)),X3),Xa3))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),R),S2))) ) ).

% inf_Int_eq2
tff(fact_2580_sup__Un__eq2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S2: set(product_prod(A,B)),X3: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),sup_sup(fun(A,fun(B,bool))),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),R)),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),S2)),X3),Xa3))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),sup_sup(set(product_prod(A,B))),R),S2))) ) ).

% sup_Un_eq2
tff(fact_2581_sngr__prec,axiom,
    ! [A: $tType] :
      ( heap(A)
     => precise(A,ref(A),aTP_Lamp_bj(A,fun(ref(A),assn))) ) ).

% sngr_prec
tff(fact_2582_effect__LetI,axiom,
    ! [B: $tType,A: $tType,X: A,T4: A,F: fun(A,heap_Time_Heap(B)),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( ( X = T4 )
     => ( heap_Time_effect(B,aa(A,heap_Time_Heap(B),F,X),H2,H4,R3,N)
       => heap_Time_effect(B,aa(A,heap_Time_Heap(B),F,T4),H2,H4,R3,N) ) ) ).

% effect_LetI
tff(fact_2583_distrib__if__bind,axiom,
    ! [A: $tType,B: $tType,B2: bool,C2: heap_Time_Heap(B),D2: heap_Time_Heap(B),F: fun(B,heap_Time_Heap(A))] :
      ( ( pp(B2)
       => ( heap_Time_bind(B,A,if(heap_Time_Heap(B),B2,C2,D2),F) = heap_Time_bind(B,A,C2,F) ) )
      & ( ~ pp(B2)
       => ( heap_Time_bind(B,A,if(heap_Time_Heap(B),B2,C2,D2),F) = heap_Time_bind(B,A,D2,F) ) ) ) ).

% distrib_if_bind
tff(fact_2584_success__LetI,axiom,
    ! [A: $tType,B: $tType,X: A,T4: A,F: fun(A,heap_Time_Heap(B)),H2: heap_ext(product_unit)] :
      ( ( X = T4 )
     => ( heap_Time_success(B,aa(A,heap_Time_Heap(B),F,X),H2)
       => heap_Time_success(B,aa(A,heap_Time_Heap(B),F,T4),H2) ) ) ).

% success_LetI
tff(fact_2585_snga__prec,axiom,
    ! [A: $tType] :
      ( heap(A)
     => precise(list(A),array(A),aTP_Lamp_bk(list(A),fun(array(A),assn))) ) ).

% snga_prec
tff(fact_2586_Int__def,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_bl(set(A),fun(set(A),fun(A,bool)),A4),B3)) ) ).

% Int_def
tff(fact_2587_Int__Collect,axiom,
    ! [A: $tType,X: A,A4: set(A),P: fun(A,bool)] :
      ( pp(member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(fun(A,bool),set(A),collect(A),P))))
    <=> ( pp(member(A,X,A4))
        & pp(aa(A,bool,P,X)) ) ) ).

% Int_Collect
tff(fact_2588_inf__set__def,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),A4)),aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),B3))) ) ).

% inf_set_def
tff(fact_2589_Collect__conj__eq,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] : ( aa(fun(A,bool),set(A),collect(A),aa(fun(A,bool),fun(A,bool),aTP_Lamp_bm(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(fun(A,bool),set(A),collect(A),P)),aa(fun(A,bool),set(A),collect(A),Q)) ) ).

% Collect_conj_eq
tff(fact_2590_inf__Int__eq,axiom,
    ! [A: $tType,R: set(A),S2: set(A),X3: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),R)),aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),S2)),X3))
    <=> pp(member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),R),S2))) ) ).

% inf_Int_eq
tff(fact_2591_lambda__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( aTP_Lamp_bn(A,A) = aa(A,fun(A,A),times_times(A),one_one(A)) ) ) ).

% lambda_one
tff(fact_2592_lambda__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ( aTP_Lamp_bo(A,A) = aa(A,fun(A,A),times_times(A),zero_zero(A)) ) ) ).

% lambda_zero
tff(fact_2593_pred__equals__eq2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S2: set(product_prod(A,B))] :
      ( ! [X4: A,Xa2: B] :
          ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa2),R))
        <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Xa2),S2)) )
    <=> ( R = S2 ) ) ).

% pred_equals_eq2
tff(fact_2594_top__empty__eq2,axiom,
    ! [B: $tType,A: $tType,X3: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),top_top(fun(A,fun(B,bool))),X3),Xa3))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3),top_top(set(product_prod(A,B))))) ) ).

% top_empty_eq2
tff(fact_2595_inj__on__convol__ident,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),X6: set(A)] : inj_on(A,product_prod(A,B),aTP_Lamp_bp(fun(A,B),fun(A,product_prod(A,B)),F),X6) ).

% inj_on_convol_ident
tff(fact_2596_inj__Pair_I1_J,axiom,
    ! [B: $tType,A: $tType,C2: fun(A,B),S2: set(A)] : inj_on(A,product_prod(A,B),aTP_Lamp_bp(fun(A,B),fun(A,product_prod(A,B)),C2),S2) ).

% inj_Pair(1)
tff(fact_2597_inj__Pair_I2_J,axiom,
    ! [B: $tType,A: $tType,C2: fun(A,B),S2: set(A)] : inj_on(A,product_prod(B,A),aTP_Lamp_bq(fun(A,B),fun(A,product_prod(B,A)),C2),S2) ).

% inj_Pair(2)
tff(fact_2598_fun_Omap__ident,axiom,
    ! [A: $tType,D: $tType,T4: fun(D,A)] : ( aa(fun(D,A),fun(D,A),aa(fun(A,A),fun(fun(D,A),fun(D,A)),comp(A,A,D),aTP_Lamp_br(A,A)),T4) = T4 ) ).

% fun.map_ident
tff(fact_2599_frame__rule,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),R: assn] :
      ( hoare_hoare_triple(A,P,C2,Q)
     => hoare_hoare_triple(A,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),R),C2,aa(assn,fun(A,assn),aTP_Lamp_bs(fun(A,assn),fun(assn,fun(A,assn)),Q),R)) ) ).

% frame_rule
tff(fact_2600_cons__pre__rule,axiom,
    ! [A: $tType,P: assn,P2: assn,C2: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( entails(P,P2)
     => ( hoare_hoare_triple(A,P2,C2,Q)
       => hoare_hoare_triple(A,P,C2,Q) ) ) ).

% cons_pre_rule
tff(fact_2601_bot__assn__def,axiom,
    bot_bot(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aTP_Lamp_af(product_prod(heap_ext(product_unit),set(nat)),bool)) ).

% bot_assn_def
tff(fact_2602_not__empty__eq__Ici__eq__empty,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [L: A] : ( bot_bot(set(A)) != set_ord_atLeast(A,L) ) ) ).

% not_empty_eq_Ici_eq_empty
tff(fact_2603_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I4: set(B),X: fun(B,A),Y: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_bt(set(B),fun(fun(B,A),fun(B,bool)),I4),X))))
         => ( pp(aa(set(B),bool,finite_finite(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_bt(set(B),fun(fun(B,A),fun(B,bool)),I4),Y))))
           => pp(aa(set(B),bool,finite_finite(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aTP_Lamp_bu(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),I4),X),Y)))) ) ) ) ).

% prod.finite_Collect_op
tff(fact_2604_image__constant__conv,axiom,
    ! [B: $tType,A: $tType,A4: set(B),C2: A] :
      ( ( ( A4 = bot_bot(set(B)) )
       => ( aa(set(B),set(A),image2(B,A,aTP_Lamp_as(A,fun(B,A),C2)),A4) = bot_bot(set(A)) ) )
      & ( ( A4 != bot_bot(set(B)) )
       => ( aa(set(B),set(A),image2(B,A,aTP_Lamp_as(A,fun(B,A),C2)),A4) = aa(set(A),set(A),insert2(A,C2),bot_bot(set(A))) ) ) ) ).

% image_constant_conv
tff(fact_2605_image__constant,axiom,
    ! [A: $tType,B: $tType,X: A,A4: set(A),C2: B] :
      ( pp(member(A,X,A4))
     => ( aa(set(A),set(B),image2(A,B,aTP_Lamp_bv(B,fun(A,B),C2)),A4) = aa(set(B),set(B),insert2(B,C2),bot_bot(set(B))) ) ) ).

% image_constant
tff(fact_2606_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,S: set(A),T4: set(A)] : ( aa(set(A),set(A),image2(A,A,aTP_Lamp_bw(A,fun(A,A),A3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T4)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),image2(A,A,aTP_Lamp_bw(A,fun(A,A),A3)),S)),aa(set(A),set(A),image2(A,A,aTP_Lamp_bw(A,fun(A,A),A3)),T4)) ) ) ).

% translation_subtract_Int
tff(fact_2607_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),G: fun(B,A),P: fun(B,bool)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(fun(B,bool),set(B),collect(B),aa(fun(B,bool),fun(B,bool),aTP_Lamp_bx(set(B),fun(fun(B,bool),fun(B,bool)),A4),P))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,bool),fun(B,A),aTP_Lamp_by(fun(B,A),fun(fun(B,bool),fun(B,A)),G),P)),A4) ) ) ) ).

% prod.inter_filter
tff(fact_2608_bind__rule_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: assn,F: heap_Time_Heap(B),R: fun(B,assn),G: fun(B,heap_Time_Heap(C)),Q: fun(C,assn)] :
      ( ! [R2: A] : hoare_hoare_triple(B,P,F,aa(fun(B,assn),fun(B,assn),aTP_Lamp_bz(assn,fun(fun(B,assn),fun(B,assn)),P),R))
     => ( ! [X2: B] : hoare_hoare_triple(C,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,R,X2)),P),aa(B,heap_Time_Heap(C),G,X2),Q)
       => hoare_hoare_triple(C,P,heap_Time_bind(B,C,F,G),Q) ) ) ).

% bind_rule'
tff(fact_2609_sup__assn__def,axiom,
    ! [P: assn,Q: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),P),Q) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_ca(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),P),Q)) ) ).

% sup_assn_def
tff(fact_2610_inf__assn__def,axiom,
    ! [P: assn,Q: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),P),Q) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_cb(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),P),Q)) ) ).

% inf_assn_def
tff(fact_2611_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),aa(num,num,bit1,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N))),one_one(A)) ) ) ).

% numeral_code(3)
tff(fact_2612_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),G: fun(B,A),B3: set(B)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(set(B),fun(B,A),aTP_Lamp_cc(fun(B,A),fun(set(B),fun(B,A)),G),B3)),A4) ) ) ) ).

% sum.inter_restrict
tff(fact_2613_power__numeral__even,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z2: A,W2: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,W2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),W2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),W2))) ) ) ).

% power_numeral_even
tff(fact_2614_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z2: A,W2: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,W2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z2),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),W2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z2),aa(num,nat,numeral_numeral(nat),W2))) ) ) ).

% power_numeral_odd
tff(fact_2615_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),G: fun(B,A),B3: set(B)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(set(B),fun(B,A),aTP_Lamp_cd(fun(B,A),fun(set(B),fun(B,A)),G),B3)),A4) ) ) ) ).

% prod.inter_restrict
tff(fact_2616_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(fun(B,bool),set(B),collect(B),aTP_Lamp_ce(fun(B,A),fun(B,bool),G)))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) ) ) ) ).

% prod.setdiff_irrelevant
tff(fact_2617_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,M4: nat,I4: set(nat)] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_cf(A,fun(nat,fun(nat,A)),X),M4)),I4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M4)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),I4)) ) ) ).

% sum_power_add
tff(fact_2618_fst__diag__id,axiom,
    ! [A: $tType,Z2: A] : ( aa(A,A,aa(fun(A,product_prod(A,A)),fun(A,A),aa(fun(product_prod(A,A),A),fun(fun(A,product_prod(A,A)),fun(A,A)),comp(product_prod(A,A),A,A),product_fst(A,A)),aTP_Lamp_cg(A,product_prod(A,A))),Z2) = aa(A,A,id(A),Z2) ) ).

% fst_diag_id
tff(fact_2619_snd__diag__id,axiom,
    ! [A: $tType,Z2: A] : ( aa(A,A,aa(fun(A,product_prod(A,A)),fun(A,A),aa(fun(product_prod(A,A),A),fun(fun(A,product_prod(A,A)),fun(A,A)),comp(product_prod(A,A),A,A),product_snd(A,A)),aTP_Lamp_cg(A,product_prod(A,A))),Z2) = aa(A,A,id(A),Z2) ) ).

% snd_diag_id
tff(fact_2620_bot_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ordering_top(A,aTP_Lamp_ch(A,fun(A,bool)),aTP_Lamp_ci(A,fun(A,bool)),bot_bot(A)) ) ).

% bot.ordering_top_axioms
tff(fact_2621_bind__lift,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap(B),G: fun(B,A)] : ( heap_Time_bind(B,A,F,heap_Time_lift(B,A,G)) = heap_Time_bind(B,A,F,aTP_Lamp_cj(fun(B,A),fun(B,heap_Time_Heap(A)),G)) ) ).

% bind_lift
tff(fact_2622_empty__natural,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F: fun(A,C),G: fun(D,B)] : ( aa(fun(A,C),fun(A,set(B)),aa(fun(C,set(B)),fun(fun(A,C),fun(A,set(B))),comp(C,set(B),A),aTP_Lamp_ck(C,set(B))),F) = aa(fun(A,set(D)),fun(A,set(B)),aa(fun(set(D),set(B)),fun(fun(A,set(D)),fun(A,set(B))),comp(set(D),set(B),A),image2(D,B,G)),aTP_Lamp_cl(A,set(D))) ) ).

% empty_natural
tff(fact_2623_cons__rulet,axiom,
    ! [A: $tType,P: assn,P2: assn,Q: fun(A,assn),Q2: fun(A,assn),C2: heap_Time_Heap(A)] :
      ( entailst(P,P2)
     => ( ! [X2: A] : entailst(aa(A,assn,Q,X2),aa(A,assn,Q2,X2))
       => ( hoare_hoare_triple(A,P2,C2,aTP_Lamp_cm(fun(A,assn),fun(A,assn),Q))
         => hoare_hoare_triple(A,P,C2,aTP_Lamp_cm(fun(A,assn),fun(A,assn),Q2)) ) ) ) ).

% cons_rulet
tff(fact_2624_cons__pre__rulet,axiom,
    ! [A: $tType,P: assn,P2: assn,C2: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( entailst(P,P2)
     => ( hoare_hoare_triple(A,P2,C2,aTP_Lamp_cm(fun(A,assn),fun(A,assn),Q))
       => hoare_hoare_triple(A,P,C2,aTP_Lamp_cm(fun(A,assn),fun(A,assn),Q)) ) ) ).

% cons_pre_rulet
tff(fact_2625_cons__post__rulet,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),Q2: fun(A,assn)] :
      ( hoare_hoare_triple(A,P,C2,aTP_Lamp_cm(fun(A,assn),fun(A,assn),Q))
     => ( ! [X2: A] : entailst(aa(A,assn,Q,X2),aa(A,assn,Q2,X2))
       => hoare_hoare_triple(A,P,C2,aTP_Lamp_cm(fun(A,assn),fun(A,assn),Q2)) ) ) ).

% cons_post_rulet
tff(fact_2626_return__sp__rule,axiom,
    ! [A: $tType,P: assn,X: A] : hoare_hoare_triple(A,P,aa(A,heap_Time_Heap(A),heap_Time_return(A),X),aa(A,fun(A,assn),aTP_Lamp_cn(assn,fun(A,fun(A,assn)),P),X)) ).

% return_sp_rule
tff(fact_2627_fst__diag__fst,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(A,A)),fun(product_prod(A,B),A),aa(fun(product_prod(A,A),A),fun(fun(product_prod(A,B),product_prod(A,A)),fun(product_prod(A,B),A)),comp(product_prod(A,A),A,product_prod(A,B)),product_fst(A,A)),aa(fun(product_prod(A,B),A),fun(product_prod(A,B),product_prod(A,A)),aa(fun(A,product_prod(A,A)),fun(fun(product_prod(A,B),A),fun(product_prod(A,B),product_prod(A,A))),comp(A,product_prod(A,A),product_prod(A,B)),aTP_Lamp_cg(A,product_prod(A,A))),product_fst(A,B))) = product_fst(A,B) ) ).

% fst_diag_fst
tff(fact_2628_snd__diag__snd,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(B,B)),fun(product_prod(A,B),B),aa(fun(product_prod(B,B),B),fun(fun(product_prod(A,B),product_prod(B,B)),fun(product_prod(A,B),B)),comp(product_prod(B,B),B,product_prod(A,B)),product_snd(B,B)),aa(fun(product_prod(A,B),B),fun(product_prod(A,B),product_prod(B,B)),aa(fun(B,product_prod(B,B)),fun(fun(product_prod(A,B),B),fun(product_prod(A,B),product_prod(B,B))),comp(B,product_prod(B,B),product_prod(A,B)),aTP_Lamp_co(B,product_prod(B,B))),product_snd(A,B))) = product_snd(A,B) ) ).

% snd_diag_snd
tff(fact_2629_inj__on__disjoint__Un,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),A4: set(A),G: fun(A,B),B3: set(A)] :
      ( inj_on(A,B,F,A4)
     => ( inj_on(A,B,G,B3)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image2(A,B,F),A4)),aa(set(A),set(B),image2(A,B,G),B3)) = bot_bot(set(B)) )
         => inj_on(A,B,aa(fun(A,B),fun(A,B),aa(set(A),fun(fun(A,B),fun(A,B)),aTP_Lamp_cp(fun(A,B),fun(set(A),fun(fun(A,B),fun(A,B))),F),A4),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) ) ) ) ).

% inj_on_disjoint_Un
tff(fact_2630_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),P: fun(B,bool),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_cq(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),H2),G)),A4) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,bool),set(B),collect(B),P)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,bool),set(B),collect(B),P))))) ) ) ) ).

% sum.If_cases
tff(fact_2631_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M4: nat,N: nat,G: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N))),aa(nat,A,G,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M4)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_cr(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M4,N))) ) ) ) ).

% prod.Suc_reindex_ivl
tff(fact_2632_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),P: fun(B,bool),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_cs(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),H2),G)),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,bool),set(B),collect(B),P)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,bool),set(B),collect(B),P))))) ) ) ) ).

% prod.If_cases
tff(fact_2633_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_cr(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,N))) ) ) ).

% prod.atMost_Suc_shift
tff(fact_2634_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_cr(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N))) ) ) ).

% prod.lessThan_Suc_shift
tff(fact_2635_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => semila1105856199041335345_order(A,sup_sup(A),bot_bot(A),aTP_Lamp_ct(A,fun(A,bool)),aTP_Lamp_cu(A,fun(A,bool))) ) ).

% sup_bot.semilattice_neutr_order_axioms
tff(fact_2636_atLeast__eq__UNIV__iff,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [X: A] :
          ( ( set_ord_atLeast(A,X) = top_top(set(A)) )
        <=> ( X = bot_bot(A) ) ) ) ).

% atLeast_eq_UNIV_iff
tff(fact_2637_If__the__inv__into__f__f,axiom,
    ! [B: $tType,A: $tType,I: A,C3: set(A),G: fun(A,B),X: A] :
      ( pp(member(A,I,C3))
     => ( inj_on(A,B,G,C3)
       => ( aa(A,A,aa(fun(A,B),fun(A,A),aa(fun(B,A),fun(fun(A,B),fun(A,A)),comp(B,A,A),aa(A,fun(B,A),aa(fun(A,B),fun(A,fun(B,A)),aTP_Lamp_cv(set(A),fun(fun(A,B),fun(A,fun(B,A))),C3),G),X)),G),I) = aa(A,A,id(A),I) ) ) ) ).

% If_the_inv_into_f_f
tff(fact_2638_uminus__assn__def,axiom,
    ! [P: assn] : ( aa(assn,assn,uminus_uminus(assn),P) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aTP_Lamp_cw(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),P)) ) ).

% uminus_assn_def
tff(fact_2639_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [F: fun(nat,A),A3: nat,B2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),F),set_or1337092689740270186AtMost(nat,A3,B2)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_cx(fun(nat,A),fun(nat,fun(A,A)),F),A3,B2,one_one(A)) ) ) ).

% prod_atLeastAtMost_code
tff(fact_2640_snd__diag__fst,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(A,A)),fun(product_prod(A,B),A),aa(fun(product_prod(A,A),A),fun(fun(product_prod(A,B),product_prod(A,A)),fun(product_prod(A,B),A)),comp(product_prod(A,A),A,product_prod(A,B)),product_snd(A,A)),aa(fun(product_prod(A,B),A),fun(product_prod(A,B),product_prod(A,A)),aa(fun(A,product_prod(A,A)),fun(fun(product_prod(A,B),A),fun(product_prod(A,B),product_prod(A,A))),comp(A,product_prod(A,A),product_prod(A,B)),aTP_Lamp_cg(A,product_prod(A,A))),product_fst(A,B))) = product_fst(A,B) ) ).

% snd_diag_fst
tff(fact_2641_fst__diag__snd,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(product_prod(A,B),product_prod(B,B)),fun(product_prod(A,B),B),aa(fun(product_prod(B,B),B),fun(fun(product_prod(A,B),product_prod(B,B)),fun(product_prod(A,B),B)),comp(product_prod(B,B),B,product_prod(A,B)),product_fst(B,B)),aa(fun(product_prod(A,B),B),fun(product_prod(A,B),product_prod(B,B)),aa(fun(B,product_prod(B,B)),fun(fun(product_prod(A,B),B),fun(product_prod(A,B),product_prod(B,B))),comp(B,product_prod(B,B),product_prod(A,B)),aTP_Lamp_co(B,product_prod(B,B))),product_snd(A,B))) = product_snd(A,B) ) ).

% fst_diag_snd
tff(fact_2642_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(B),A3: B,B2: fun(B,A),C2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),S2))
         => ( ( pp(member(B,A3,S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_cy(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A3),B2),C2)),S2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,B2,A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) )
            & ( ~ pp(member(B,A3,S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_cy(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A3),B2),C2)),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) ) ) ) ) ) ).

% sum.delta_remove
tff(fact_2643_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A4: set(B),F: fun(B,A),B2: A] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( divide_divide(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),A4),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_cz(fun(B,A),fun(A,fun(B,A)),F),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,bool),set(B),collect(B),aa(A,fun(B,bool),aTP_Lamp_da(fun(B,A),fun(A,fun(B,bool)),F),B2))))),divide_divide(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,bool),set(B),collect(B),aa(A,fun(B,bool),aTP_Lamp_db(fun(B,A),fun(A,fun(B,bool)),F),B2)))),B2)) ) ) ) ).

% sum_div_partition
tff(fact_2644_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),A3: B,B2: fun(B,A),C2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),S2))
         => ( ( pp(member(B,A3,S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_dc(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A3),B2),C2)),S2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,B2,A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) )
            & ( ~ pp(member(B,A3,S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_dc(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A3),B2),C2)),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) ) ) ) ) ) ).

% prod.delta_remove
tff(fact_2645_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),one_one(A))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_lessThan(nat,N))) ) ) ).

% power_diff_1_eq
tff(fact_2646_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_lessThan(nat,N))) ) ) ).

% one_diff_power_eq
tff(fact_2647_geometric__sum,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,N: nat] :
          ( ( X != one_one(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_lessThan(nat,N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)),one_one(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),one_one(A))) ) ) ) ).

% geometric_sum
tff(fact_2648_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dd(A,fun(nat,A),A3)),set_ord_atMost(nat,N)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),aa(nat,A,semiring_1_of_nat(A),N))),one_one(A))),N) ) ) ).

% gbinomial_parallel_sum
tff(fact_2649_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_cr(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N))) ) ) ).

% prod.atMost_shift
tff(fact_2650_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aTP_Lamp_de(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% sum.atLeast_atMost_pred_shift
tff(fact_2651_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aTP_Lamp_de(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% sum.atLeast_lessThan_pred_shift
tff(fact_2652_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aTP_Lamp_de(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% prod.atLeast_atMost_pred_shift
tff(fact_2653_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aTP_Lamp_de(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% prod.atLeast_lessThan_pred_shift
tff(fact_2654_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y: nat,X: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),C2),Y))
       => ( aa(set(nat),set(nat),image2(nat,nat,aTP_Lamp_df(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X,Y)) = set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Y),C2)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),C2),Y))
       => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X),Y))
           => ( aa(set(nat),set(nat),image2(nat,nat,aTP_Lamp_df(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X,Y)) = aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat))) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X),Y))
           => ( aa(set(nat),set(nat),image2(nat,nat,aTP_Lamp_df(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X,Y)) = bot_bot(set(nat)) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
tff(fact_2655_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,Y: A,C2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
               => ( aa(set(A),set(A),image2(A,A,aTP_Lamp_dg(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,X,Y)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),X),C2),aa(A,A,aa(A,fun(A,A),times_times(A),Y),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),C2))
               => ( aa(set(A),set(A),image2(A,A,aTP_Lamp_dg(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,X,Y)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),Y),C2),aa(A,A,aa(A,fun(A,A),times_times(A),X),C2)) ) ) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
           => ( aa(set(A),set(A),image2(A,A,aTP_Lamp_dg(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,X,Y)) = bot_bot(set(A)) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
tff(fact_2656_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,M4: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_dh(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A3,B2) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M4))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_dh(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M4),A3)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M4),B2)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M4))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_dh(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M4),B2)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M4),A3)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
tff(fact_2657_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,M4: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_di(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A3,B2) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M4))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_di(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M4),A3)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M4),B2)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M4))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_di(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M4),B2)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M4),A3)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
tff(fact_2658_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,M4: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_dj(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A3,B2) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M4))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_dj(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A3,M4)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,B2,M4)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M4))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_dj(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,B2,M4)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A3,M4)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
tff(fact_2659_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,B2: A,M4: A,C2: A] :
          ( ( ( set_or1337092689740270186AtMost(A,A3,B2) = bot_bot(set(A)) )
           => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_dk(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = bot_bot(set(A)) ) )
          & ( ( set_or1337092689740270186AtMost(A,A3,B2) != bot_bot(set(A)) )
           => ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M4))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_dk(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,A3,M4)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,B2,M4)),C2)) ) )
              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),M4))
               => ( aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),aTP_Lamp_dk(A,fun(A,fun(A,A)),M4),C2)),set_or1337092689740270186AtMost(A,A3,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,B2,M4)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,A3,M4)),C2)) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
tff(fact_2660_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_idom(B)
     => ! [I4: set(A),X: fun(A,B),A3: fun(A,B),B2: B,Delta: B] :
          ( ! [I3: A] :
              ( pp(member(A,I3,I4))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),zero_zero(B)),aa(A,B,X,I3))) )
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),X),I4) = one_one(B) )
           => ( ! [I3: A] :
                  ( pp(member(A,I3,I4))
                 => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A3,I3)),B2))),Delta)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_dl(fun(A,B),fun(fun(A,B),fun(A,B)),X),A3)),I4)),B2))),Delta)) ) ) ) ) ).

% convex_sum_bound_le
tff(fact_2661_sum__fun__comp,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [S2: set(A),R: set(B),G: fun(A,B),F: fun(B,C)] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( pp(aa(set(B),bool,finite_finite(B),R))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image2(A,B,G),S2)),R))
             => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_dm(fun(A,B),fun(fun(B,C),fun(A,C)),G),F)),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aa(fun(A,B),fun(fun(B,C),fun(B,C)),aTP_Lamp_do(set(A),fun(fun(A,B),fun(fun(B,C),fun(B,C))),S2),G),F)),R) ) ) ) ) ) ).

% sum_fun_comp
tff(fact_2662_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_atMost(nat,N))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,N))) ) ) ).

% sum_gp_basic
tff(fact_2663_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),A3: B,B2: fun(B,A),C2: A] :
          ( pp(aa(set(B),bool,finite_finite(B),S2))
         => ( ( pp(member(B,A3,S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(A,fun(B,A),aa(fun(B,A),fun(A,fun(B,A)),aTP_Lamp_dp(B,fun(fun(B,A),fun(A,fun(B,A))),A3),B2),C2)),S2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,B2,A3)),aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(B,S2)),one_one(nat)))) ) )
            & ( ~ pp(member(B,A3,S2))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(A,fun(B,A),aa(fun(B,A),fun(A,fun(B,A)),aTP_Lamp_dp(B,fun(fun(B,A),fun(A,fun(B,A))),A3),B2),C2)),S2) = aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),finite_card(B,S2)) ) ) ) ) ) ).

% prod_gen_delta
tff(fact_2664_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X: A,N: nat] :
          ( ( ( X = one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_lessThan(nat,N)) = aa(nat,A,semiring_1_of_nat(A),N) ) )
          & ( ( X != one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_lessThan(nat,N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)) ) ) ) ) ).

% sum_gp_strict
tff(fact_2665_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,N: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_dq(A,fun(nat,fun(A,fun(nat,A))),X),N),Y)),set_ord_lessThan(nat,N))) ) ) ).

% power_diff_sumr2
tff(fact_2666_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,N: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_dr(A,fun(nat,fun(A,fun(nat,A))),X),N),Y)),set_ord_lessThan(nat,aa(nat,nat,suc,N)))) ) ) ).

% diff_power_eq_sum
tff(fact_2667_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [M4: nat,N: nat,X: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M4,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M4)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4)))) ) ) ) ).

% sum_power_shift
tff(fact_2668_ivl__disj__int__one_I8_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or7035219750837199246ssThan(A,L,U)),set_ord_atLeast(A,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(8)
tff(fact_2669_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)),one_one(A)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_ds(nat,fun(nat,bool),N))) ) ) ).

% mask_eq_sum_exp
tff(fact_2670_atLeastAtMost__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A,U: A] : ( set_or1337092689740270186AtMost(A,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_atLeast(A,L)),set_ord_atMost(A,U)) ) ) ).

% atLeastAtMost_def
tff(fact_2671_atLeastLessThan__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A,U: A] : ( set_or7035219750837199246ssThan(A,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_atLeast(A,L)),set_ord_lessThan(A,U)) ) ) ).

% atLeastLessThan_def
tff(fact_2672_ivl__disj__int__one_I6_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,U: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or5935395276787703475ssThan(A,L,U)),set_ord_atLeast(A,U)) = bot_bot(set(A)) ) ) ).

% ivl_disj_int_one(6)
tff(fact_2673_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [M4: nat,N: nat,X: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M4,N))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,N))) ) ) ) ).

% sum_gp_multiplied
tff(fact_2674_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M4: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_dt(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% prod.in_pairs
tff(fact_2675_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [X: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_du(A,fun(nat,fun(nat,A)),X),N)),set_ord_lessThan(nat,N))) ) ) ).

% one_diff_power_eq'
tff(fact_2676_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_dt(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,N)) ) ) ).

% prod.in_pairs_0
tff(fact_2677_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,M4: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_dv(A,fun(nat,A),A3)),set_ord_atMost(nat,M4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),M4)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),M4)) ) ) ).

% gbinomial_sum_lower_neg
tff(fact_2678_binomial__ring,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,B2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2)),N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_dw(A,fun(A,fun(nat,fun(nat,A))),A3),B2),N)),set_ord_atMost(nat,N)) ) ) ).

% binomial_ring
tff(fact_2679_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A3: A] : ( bit_ri4674362597316999326ke_bit(A,N,A3) = if(A,aa(nat,bool,bit_se5641148757651400278ts_bit(A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),A3)),N),aa(A,A,aa(A,fun(A,A),plus_plus(A),bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),A3)),bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N),aa(A,A,uminus_uminus(A),one_one(A)))),bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N),A3)) ) ) ).

% signed_take_bit_code
tff(fact_2680_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A3),K)),semiring_char_0_fact(A,K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_dx(A,fun(nat,A),A3)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact'
tff(fact_2681_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,gbinomial(A,A3),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_dx(A,fun(nat,A),A3)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact
tff(fact_2682_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A3: A,B2: A,N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2),N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_dy(A,fun(A,fun(nat,fun(nat,A))),A3),B2),N)),set_ord_atMost(nat,N)) ) ) ).

% pochhammer_binomial_sum
tff(fact_2683_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P3: nat,K: nat,G: fun(nat,A),H2: fun(nat,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),one_one(nat)),P3))
         => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),K),P3))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_dz(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H2)),set_ord_atMost(nat,P3)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_ea(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H2)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P3),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% prod.zero_middle
tff(fact_2684_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_eb(nat,fun(nat,A),K)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))) ) ) ).

% gbinomial_sum_up_index
tff(fact_2685_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M4: nat,A3: A,X: A,Y: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ec(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M4),A3),X),Y)),set_ord_atMost(nat,M4)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ed(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M4),A3),X),Y)),set_ord_atMost(nat,M4)) ) ) ).

% gbinomial_partial_sum_poly
tff(fact_2686_pochhammer__code,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat,A3: A] :
          ( ( ( N = zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,A3,N) = one_one(A) ) )
          & ( ( N != zero_zero(nat) )
           => ( comm_s3205402744901411588hammer(A,A3,N) = set_fo6178422350223883121st_nat(A,aTP_Lamp_ee(A,fun(nat,fun(A,A)),A3),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),one_one(A)) ) ) ) ) ).

% pochhammer_code
tff(fact_2687_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))) ) ) ).

% double_gauss_sum
tff(fact_2688_double__arith__series,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A3: A,D2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ef(A,fun(A,fun(nat,A)),A3),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),D2))) ) ) ).

% double_arith_series
tff(fact_2689_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X: A,N: nat] :
          ( ( ( X = one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_atMost(nat,N)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) )
          & ( ( X != one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_ord_atMost(nat,N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,N))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)) ) ) ) ) ).

% sum_gp0
tff(fact_2690_atMost__Int__atLeast,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [N: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_atMost(A,N)),set_ord_atLeast(A,N)) = aa(set(A),set(A),insert2(A,N),bot_bot(set(A))) ) ) ).

% atMost_Int_atLeast
tff(fact_2691_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M4: nat,A3: A,X: A,Y: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ec(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M4),A3),X),Y)),set_ord_atMost(nat,M4)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_eg(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M4),A3),X),Y)),set_ord_atMost(nat,M4)) ) ) ).

% gbinomial_partial_sum_poly_xpos
tff(fact_2692_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( ( N != one_one(nat) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_eh(nat,fun(nat,A),N)),set_ord_atMost(nat,N)) = zero_zero(A) ) ) ) ).

% choose_alternating_linear_sum
tff(fact_2693_ivl__disj__un__singleton_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert2(A,L),bot_bot(set(A)))),aa(A,set(A),set_ord_greaterThan(A),L)) = set_ord_atLeast(A,L) ) ) ).

% ivl_disj_un_singleton(1)
tff(fact_2694_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))) ) ) ).

% double_gauss_sum_from_Suc_0
tff(fact_2695_gauss__sum,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum
tff(fact_2696_arith__series,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A3: A,D2: A,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ei(A,fun(A,fun(nat,A)),A3),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),D2))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% arith_series
tff(fact_2697_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [X: A,M4: nat,N: nat] :
          ( ( ( X = one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M4,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A)) ) )
          & ( ( X != one_one(A) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M4,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),N))) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M4)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,N)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)) ) ) ) ) ).

% sum_gp_offset
tff(fact_2698_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ej(nat,fun(nat,A),N)),set_ord_atMost(nat,N)) = zero_zero(A) ) ) ) ).

% choose_alternating_sum
tff(fact_2699_gbinomial__code,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A3: A] :
          ( ( ( K = zero_zero(nat) )
           => ( aa(nat,A,gbinomial(A,A3),K) = one_one(A) ) )
          & ( ( K != zero_zero(nat) )
           => ( aa(nat,A,gbinomial(A,A3),K) = divide_divide(A,set_fo6178422350223883121st_nat(A,aTP_Lamp_ek(A,fun(nat,fun(A,A)),A3),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)),one_one(A)),semiring_char_0_fact(A,K)) ) ) ) ) ).

% gbinomial_code
tff(fact_2700_atLeast__Suc,axiom,
    ! [K: nat] : ( set_ord_atLeast(nat,aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_atLeast(nat,K)),aa(set(nat),set(nat),insert2(nat,K),bot_bot(set(nat)))) ) ).

% atLeast_Suc
tff(fact_2701_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum_from_Suc_0
tff(fact_2702_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [R3: A,M4: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ad(A,fun(nat,A),R3)),set_or1337092689740270186AtMost(nat,zero_zero(nat),M4)) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,M4)),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,gbinomial(A,R3),aa(nat,nat,suc,M4))) ) ) ).

% gchoose_row_sum_weighted
tff(fact_2703_sum__gp,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [N: nat,M4: nat,X: A] :
          ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M4))
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M4,N)) = zero_zero(A) ) )
          & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M4))
           => ( ( ( X = one_one(A) )
               => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M4,N)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))),M4)) ) )
              & ( ( X != one_one(A) )
               => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),X)),set_or1337092689740270186AtMost(nat,M4,N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),M4)),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(nat,nat,suc,N))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),X)) ) ) ) ) ) ) ).

% sum_gp
tff(fact_2704_reflcl__set__eq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X3: A,Xa3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),sup_sup(fun(A,fun(A,bool))),aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3)),fequal(A)),X3),Xa3))
    <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa3),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R3),id2(A)))) ) ).

% reflcl_set_eq
tff(fact_2705_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: fun(A,B),C3: set(A),B3: set(A),X: A] :
      ( inj_on(A,B,G,C3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),C3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))))
       => pp(member(fun(B,A),aa(A,fun(B,A),aa(set(A),fun(A,fun(B,A)),aTP_Lamp_em(fun(A,B),fun(set(A),fun(A,fun(B,A))),G),C3),X),bNF_Wellorder_Func(B,A,top_top(set(B)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))))) ) ) ).

% If_the_inv_into_in_Func
tff(fact_2706_of__nat__code,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),N) = semiri8178284476397505188at_aux(A,aTP_Lamp_en(A,A),N,zero_zero(A)) ) ) ).

% of_nat_code
tff(fact_2707_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M4: num,N: num] : ( unique8689654367752047608divmod(A,aa(num,num,bit1,M4),aa(num,num,bit0,N)) = aa(product_prod(A,A),product_prod(A,A),aa(fun(A,fun(A,product_prod(A,A))),fun(product_prod(A,A),product_prod(A,A)),product_case_prod(A,A,product_prod(A,A)),aTP_Lamp_eo(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,M4,N)) ) ) ).

% divmod_algorithm_code(6)
tff(fact_2708_lookup__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [P3: ref(A),X: A] : hoare_hoare_triple(A,sngr_assn(A,P3,X),ref_lookup(A,P3),aa(A,fun(A,assn),aTP_Lamp_ep(ref(A),fun(A,fun(A,assn)),P3),X)) ) ).

% lookup_rule
tff(fact_2709_divmod__step__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,Qr: product_prod(A,A)] : ( unique1321980374590559556d_step(A,L,Qr) = aa(product_prod(A,A),product_prod(A,A),aa(fun(A,fun(A,product_prod(A,A))),fun(product_prod(A,A),product_prod(A,A)),product_case_prod(A,A,product_prod(A,A)),aTP_Lamp_eq(num,fun(A,fun(A,product_prod(A,A))),L)),Qr) ) ) ).

% divmod_step_def
tff(fact_2710_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,bool)),Q: fun(A,fun(B,bool))] :
      ( ! [X2: A,Y2: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),P,X2),Y2))
         => pp(aa(B,bool,aa(A,fun(B,bool),Q,X2),Y2)) )
     => pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),P),Q)) ) ).

% predicate2I
tff(fact_2711_inf1I,axiom,
    ! [A: $tType,A4: fun(A,bool),X: A,B3: fun(A,bool)] :
      ( pp(aa(A,bool,A4,X))
     => ( pp(aa(A,bool,B3,X))
       => pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),A4),B3),X)) ) ) ).

% inf1I
tff(fact_2712_inf2I,axiom,
    ! [A: $tType,B: $tType,A4: fun(A,fun(B,bool)),X: A,Y: B,B3: fun(A,fun(B,bool))] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),A4,X),Y))
     => ( pp(aa(B,bool,aa(A,fun(B,bool),B3,X),Y))
       => pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),A4),B3),X),Y)) ) ) ).

% inf2I
tff(fact_2713_top2I,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] : pp(aa(B,bool,aa(A,fun(B,bool),top_top(fun(A,fun(B,bool))),X),Y)) ).

% top2I
tff(fact_2714_case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(B,fun(C,A)),A3: B,B2: C] : ( aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),F),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),B2)) = aa(C,A,aa(B,fun(C,A),F,A3),B2) ) ).

% case_prod_conv
tff(fact_2715_case__prod__Pair,axiom,
    ! [B: $tType,A: $tType] : ( aa(fun(A,fun(B,product_prod(A,B))),fun(product_prod(A,B),product_prod(A,B)),product_case_prod(A,B,product_prod(A,B)),product_Pair(A,B)) = id(product_prod(A,B)) ) ).

% case_prod_Pair
tff(fact_2716_pair__imageI,axiom,
    ! [C: $tType,B: $tType,A: $tType,A3: A,B2: B,A4: set(product_prod(A,B)),F: fun(A,fun(B,C))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),A4))
     => pp(member(C,aa(B,C,aa(A,fun(B,C),F,A3),B2),aa(set(product_prod(A,B)),set(C),image2(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F)),A4))) ) ).

% pair_imageI
tff(fact_2717_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M4: num,N: num] : ( unique8689654367752047608divmod(A,aa(num,num,bit0,M4),aa(num,num,bit0,N)) = aa(product_prod(A,A),product_prod(A,A),aa(fun(A,fun(A,product_prod(A,A))),fun(product_prod(A,A),product_prod(A,A)),product_case_prod(A,A,product_prod(A,A)),aTP_Lamp_er(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,M4,N)) ) ) ).

% divmod_algorithm_code(5)
tff(fact_2718_inf1E,axiom,
    ! [A: $tType,A4: fun(A,bool),B3: fun(A,bool),X: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),A4),B3),X))
     => ~ ( pp(aa(A,bool,A4,X))
         => ~ pp(aa(A,bool,B3,X)) ) ) ).

% inf1E
tff(fact_2719_inf2E,axiom,
    ! [A: $tType,B: $tType,A4: fun(A,fun(B,bool)),B3: fun(A,fun(B,bool)),X: A,Y: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),A4),B3),X),Y))
     => ~ ( pp(aa(B,bool,aa(A,fun(B,bool),A4,X),Y))
         => ~ pp(aa(B,bool,aa(A,fun(B,bool),B3,X),Y)) ) ) ).

% inf2E
tff(fact_2720_inf1D1,axiom,
    ! [A: $tType,A4: fun(A,bool),B3: fun(A,bool),X: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),A4),B3),X))
     => pp(aa(A,bool,A4,X)) ) ).

% inf1D1
tff(fact_2721_inf1D2,axiom,
    ! [A: $tType,A4: fun(A,bool),B3: fun(A,bool),X: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),A4),B3),X))
     => pp(aa(A,bool,B3,X)) ) ).

% inf1D2
tff(fact_2722_inf2D1,axiom,
    ! [A: $tType,B: $tType,A4: fun(A,fun(B,bool)),B3: fun(A,fun(B,bool)),X: A,Y: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),A4),B3),X),Y))
     => pp(aa(B,bool,aa(A,fun(B,bool),A4,X),Y)) ) ).

% inf2D1
tff(fact_2723_inf2D2,axiom,
    ! [A: $tType,B: $tType,A4: fun(A,fun(B,bool)),B3: fun(A,fun(B,bool)),X: A,Y: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),A4),B3),X),Y))
     => pp(aa(B,bool,aa(A,fun(B,bool),B3,X),Y)) ) ).

% inf2D2
tff(fact_2724_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,bool)),X: A,Y: B,Q: fun(A,fun(B,bool))] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),P,X),Y))
     => ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),P),Q))
       => pp(aa(B,bool,aa(A,fun(B,bool),Q,X),Y)) ) ) ).

% rev_predicate2D
tff(fact_2725_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,bool)),Q: fun(A,fun(B,bool)),X: A,Y: B] :
      ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),P),Q))
     => ( pp(aa(B,bool,aa(A,fun(B,bool),P,X),Y))
       => pp(aa(B,bool,aa(A,fun(B,bool),Q,X),Y)) ) ) ).

% predicate2D
tff(fact_2726_bot2E,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] : ~ pp(aa(B,bool,aa(A,fun(B,bool),bot_bot(fun(A,fun(B,bool))),X),Y)) ).

% bot2E
tff(fact_2727_split__cong,axiom,
    ! [C: $tType,B: $tType,A: $tType,Q3: product_prod(A,B),F: fun(A,fun(B,C)),G: fun(A,fun(B,C)),P3: product_prod(A,B)] :
      ( ! [X2: A,Y2: B] :
          ( ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2) = Q3 )
         => ( aa(B,C,aa(A,fun(B,C),F,X2),Y2) = aa(B,C,aa(A,fun(B,C),G,X2),Y2) ) )
     => ( ( P3 = Q3 )
       => ( aa(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F),P3) = aa(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),G),Q3) ) ) ) ).

% split_cong
tff(fact_2728_old_Oprod_Ocase,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: fun(A,fun(B,C)),X1: A,X22: B] : ( aa(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X1),X22)) = aa(B,C,aa(A,fun(B,C),F,X1),X22) ) ).

% old.prod.case
tff(fact_2729_swap__inj__on,axiom,
    ! [B: $tType,A: $tType,A4: set(product_prod(A,B))] : inj_on(product_prod(A,B),product_prod(B,A),aa(fun(A,fun(B,product_prod(B,A))),fun(product_prod(A,B),product_prod(B,A)),product_case_prod(A,B,product_prod(B,A)),aTP_Lamp_es(A,fun(B,product_prod(B,A)))),A4) ).

% swap_inj_on
tff(fact_2730_case__prod__Pair__iden,axiom,
    ! [B: $tType,A: $tType,P3: product_prod(A,B)] : ( aa(product_prod(A,B),product_prod(A,B),aa(fun(A,fun(B,product_prod(A,B))),fun(product_prod(A,B),product_prod(A,B)),product_case_prod(A,B,product_prod(A,B)),product_Pair(A,B)),P3) = P3 ) ).

% case_prod_Pair_iden
tff(fact_2731_case__prodE2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Q: fun(A,bool),P: fun(B,fun(C,A)),Z2: product_prod(B,C)] :
      ( pp(aa(A,bool,Q,aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),P),Z2)))
     => ~ ! [X2: B,Y2: C] :
            ( ( Z2 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2) )
           => ~ pp(aa(A,bool,Q,aa(C,A,aa(B,fun(C,A),P,X2),Y2))) ) ) ).

% case_prodE2
tff(fact_2732_case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(product_prod(A,B),C)] : ( aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),aTP_Lamp_et(fun(product_prod(A,B),C),fun(A,fun(B,C)),F)) = F ) ).

% case_prod_eta
tff(fact_2733_cond__case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,fun(B,C)),G: fun(product_prod(A,B),C)] :
      ( ! [X2: A,Y2: B] : ( aa(B,C,aa(A,fun(B,C),F,X2),Y2) = aa(product_prod(A,B),C,G,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2)) )
     => ( aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F) = G ) ) ).

% cond_case_prod_eta
tff(fact_2734_map__prod__def,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: fun(A,C),G: fun(B,D)] : ( product_map_prod(A,C,B,D,F,G) = aa(fun(A,fun(B,product_prod(C,D))),fun(product_prod(A,B),product_prod(C,D)),product_case_prod(A,B,product_prod(C,D)),aa(fun(B,D),fun(A,fun(B,product_prod(C,D))),aTP_Lamp_eu(fun(A,C),fun(fun(B,D),fun(A,fun(B,product_prod(C,D)))),F),G)) ) ).

% map_prod_def
tff(fact_2735_case__prod__comp,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F: fun(D,fun(C,A)),G: fun(B,D),X: product_prod(B,C)] : ( aa(product_prod(B,C),A,aa(fun(B,fun(C,A)),fun(product_prod(B,C),A),product_case_prod(B,C,A),aa(fun(B,D),fun(B,fun(C,A)),aa(fun(D,fun(C,A)),fun(fun(B,D),fun(B,fun(C,A))),comp(D,fun(C,A),B),F),G)),X) = aa(C,A,aa(D,fun(C,A),F,aa(B,D,G,aa(product_prod(B,C),B,product_fst(B,C),X))),aa(product_prod(B,C),C,product_snd(B,C),X)) ) ).

% case_prod_comp
tff(fact_2736_case__prod__o__map__prod,axiom,
    ! [A: $tType,D: $tType,C: $tType,E: $tType,B: $tType,F: fun(D,fun(E,C)),G1: fun(A,D),G22: fun(B,E)] : ( aa(fun(product_prod(A,B),product_prod(D,E)),fun(product_prod(A,B),C),aa(fun(product_prod(D,E),C),fun(fun(product_prod(A,B),product_prod(D,E)),fun(product_prod(A,B),C)),comp(product_prod(D,E),C,product_prod(A,B)),aa(fun(D,fun(E,C)),fun(product_prod(D,E),C),product_case_prod(D,E,C),F)),product_map_prod(A,D,B,E,G1,G22)) = aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),aa(fun(B,E),fun(A,fun(B,C)),aa(fun(A,D),fun(fun(B,E),fun(A,fun(B,C))),aTP_Lamp_ev(fun(D,fun(E,C)),fun(fun(A,D),fun(fun(B,E),fun(A,fun(B,C)))),F),G1),G22)) ) ).

% case_prod_o_map_prod
tff(fact_2737_prod_Osplit__sel,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: fun(C,bool),F: fun(A,fun(B,C)),Prod: product_prod(A,B)] :
      ( pp(aa(C,bool,P,aa(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F),Prod)))
    <=> ( ( Prod = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(product_prod(A,B),A,product_fst(A,B),Prod)),aa(product_prod(A,B),B,product_snd(A,B),Prod)) )
       => pp(aa(C,bool,P,aa(B,C,aa(A,fun(B,C),F,aa(product_prod(A,B),A,product_fst(A,B),Prod)),aa(product_prod(A,B),B,product_snd(A,B),Prod)))) ) ) ).

% prod.split_sel
tff(fact_2738_prod_Osplit__sel__asm,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: fun(C,bool),F: fun(A,fun(B,C)),Prod: product_prod(A,B)] :
      ( pp(aa(C,bool,P,aa(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F),Prod)))
    <=> ~ ( ( Prod = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(product_prod(A,B),A,product_fst(A,B),Prod)),aa(product_prod(A,B),B,product_snd(A,B),Prod)) )
          & ~ pp(aa(C,bool,P,aa(B,C,aa(A,fun(B,C),F,aa(product_prod(A,B),A,product_fst(A,B),Prod)),aa(product_prod(A,B),B,product_snd(A,B),Prod)))) ) ) ).

% prod.split_sel_asm
tff(fact_2739_rat__abs__code,axiom,
    ! [P3: rat] : ( quotient_of(aa(rat,rat,abs_abs(rat),P3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_ew(int,fun(int,product_prod(int,int)))),quotient_of(P3)) ) ).

% rat_abs_code
tff(fact_2740_fst__snd__flip,axiom,
    ! [B: $tType,A: $tType,Xy: product_prod(A,B)] : ( aa(product_prod(A,B),A,product_fst(A,B),Xy) = aa(product_prod(A,B),A,aa(fun(product_prod(A,B),product_prod(B,A)),fun(product_prod(A,B),A),aa(fun(product_prod(B,A),A),fun(fun(product_prod(A,B),product_prod(B,A)),fun(product_prod(A,B),A)),comp(product_prod(B,A),A,product_prod(A,B)),product_snd(B,A)),aa(fun(A,fun(B,product_prod(B,A))),fun(product_prod(A,B),product_prod(B,A)),product_case_prod(A,B,product_prod(B,A)),aTP_Lamp_es(A,fun(B,product_prod(B,A))))),Xy) ) ).

% fst_snd_flip
tff(fact_2741_snd__fst__flip,axiom,
    ! [A: $tType,B: $tType,Xy: product_prod(B,A)] : ( aa(product_prod(B,A),A,product_snd(B,A),Xy) = aa(product_prod(B,A),A,aa(fun(product_prod(B,A),product_prod(A,B)),fun(product_prod(B,A),A),aa(fun(product_prod(A,B),A),fun(fun(product_prod(B,A),product_prod(A,B)),fun(product_prod(B,A),A)),comp(product_prod(A,B),A,product_prod(B,A)),product_fst(A,B)),aa(fun(B,fun(A,product_prod(A,B))),fun(product_prod(B,A),product_prod(A,B)),product_case_prod(B,A,product_prod(A,B)),aTP_Lamp_ex(B,fun(A,product_prod(A,B))))),Xy) ) ).

% snd_fst_flip
tff(fact_2742_rat__uminus__code,axiom,
    ! [P3: rat] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),P3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_ey(int,fun(int,product_prod(int,int)))),quotient_of(P3)) ) ).

% rat_uminus_code
tff(fact_2743_rat__minus__code,axiom,
    ! [P3: rat,Q3: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),P3),Q3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fa(rat,fun(int,fun(int,product_prod(int,int))),Q3)),quotient_of(P3)) ) ).

% rat_minus_code
tff(fact_2744_rat__divide__code,axiom,
    ! [P3: rat,Q3: rat] : ( quotient_of(divide_divide(rat,P3,Q3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fc(rat,fun(int,fun(int,product_prod(int,int))),Q3)),quotient_of(P3)) ) ).

% rat_divide_code
tff(fact_2745_rat__times__code,axiom,
    ! [P3: rat,Q3: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),P3),Q3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fe(rat,fun(int,fun(int,product_prod(int,int))),Q3)),quotient_of(P3)) ) ).

% rat_times_code
tff(fact_2746_divmod__nat__if,axiom,
    ! [N: nat,M4: nat] :
      ( ( ( ( N = zero_zero(nat) )
          | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M4),N)) )
       => ( divmod_nat(M4,N) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),M4) ) )
      & ( ~ ( ( N = zero_zero(nat) )
            | pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M4),N)) )
       => ( divmod_nat(M4,N) = aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_ff(nat,fun(nat,product_prod(nat,nat)))),divmod_nat(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),N),N)) ) ) ) ).

% divmod_nat_if
tff(fact_2747_rat__plus__code,axiom,
    ! [P3: rat,Q3: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),P3),Q3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fh(rat,fun(int,fun(int,product_prod(int,int))),Q3)),quotient_of(P3)) ) ).

% rat_plus_code
tff(fact_2748_divmod__step__nat__def,axiom,
    ! [L: num,Qr: product_prod(nat,nat)] : ( unique1321980374590559556d_step(nat,L,Qr) = aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_fi(num,fun(nat,fun(nat,product_prod(nat,nat))),L)),Qr) ) ).

% divmod_step_nat_def
tff(fact_2749_rat__inverse__code,axiom,
    ! [P3: rat] : ( quotient_of(aa(rat,rat,inverse_inverse(rat),P3)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fj(int,fun(int,product_prod(int,int)))),quotient_of(P3)) ) ).

% rat_inverse_code
tff(fact_2750_divmod__step__int__def,axiom,
    ! [L: num,Qr: product_prod(int,int)] : ( unique1321980374590559556d_step(int,L,Qr) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fk(num,fun(int,fun(int,product_prod(int,int))),L)),Qr) ) ).

% divmod_step_int_def
tff(fact_2751_normalize__def,axiom,
    ! [P3: product_prod(int,int)] :
      ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P3)))
       => ( normalize(P3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),divide_divide(int,aa(product_prod(int,int),int,product_fst(int,int),P3),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),aa(product_prod(int,int),int,product_snd(int,int),P3)))),divide_divide(int,aa(product_prod(int,int),int,product_snd(int,int),P3),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),aa(product_prod(int,int),int,product_snd(int,int),P3)))) ) )
      & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P3)))
       => ( ( ( aa(product_prod(int,int),int,product_snd(int,int),P3) = zero_zero(int) )
           => ( normalize(P3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)) ) )
          & ( ( aa(product_prod(int,int),int,product_snd(int,int),P3) != zero_zero(int) )
           => ( normalize(P3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),divide_divide(int,aa(product_prod(int,int),int,product_fst(int,int),P3),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),aa(product_prod(int,int),int,product_snd(int,int),P3))))),divide_divide(int,aa(product_prod(int,int),int,product_snd(int,int),P3),aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P3)),aa(product_prod(int,int),int,product_snd(int,int),P3))))) ) ) ) ) ) ).

% normalize_def
tff(fact_2752_freeze__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A3: array(A),Xs: list(A)] : hoare_hoare_triple(list(A),snga_assn(A,A3,Xs),array_freeze(A,A3),aa(list(A),fun(list(A),assn),aTP_Lamp_fl(array(A),fun(list(A),fun(list(A),assn)),A3),Xs)) ) ).

% freeze_rule
tff(fact_2753_bind__return,axiom,
    ! [A: $tType,F: heap_Time_Heap(A)] : ( heap_Time_bind(A,A,F,heap_Time_return(A)) = heap_Time_bind(product_unit,A,heap_Time_wait(one_one(nat)),aTP_Lamp_fm(heap_Time_Heap(A),fun(product_unit,heap_Time_Heap(A)),F)) ) ).

% bind_return
tff(fact_2754_return__bind,axiom,
    ! [A: $tType,B: $tType,X: B,F: fun(B,heap_Time_Heap(A))] : ( heap_Time_bind(B,A,aa(B,heap_Time_Heap(B),heap_Time_return(B),X),F) = heap_Time_bind(product_unit,A,heap_Time_wait(one_one(nat)),aa(fun(B,heap_Time_Heap(A)),fun(product_unit,heap_Time_Heap(A)),aTP_Lamp_fn(B,fun(fun(B,heap_Time_Heap(A)),fun(product_unit,heap_Time_Heap(A))),X),F)) ) ).

% return_bind
tff(fact_2755_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [F2: set(A),I4: set(A),F: fun(A,B),I: A] :
          ( pp(aa(set(A),bool,finite_finite(A),F2))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(fun(A,bool),set(A),collect(A),aa(fun(A,B),fun(A,bool),aTP_Lamp_fo(set(A),fun(fun(A,B),fun(A,bool)),I4),F))),F2))
           => ( ( pp(member(A,I,I4))
               => ( groups1027152243600224163dd_sum(A,B,F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I4),aa(set(A),set(A),insert2(A,I),bot_bot(set(A))))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F,I4)),aa(A,B,F,I)) ) )
              & ( ~ pp(member(A,I,I4))
               => ( groups1027152243600224163dd_sum(A,B,F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I4),aa(set(A),set(A),insert2(A,I),bot_bot(set(A))))) = groups1027152243600224163dd_sum(A,B,F,I4) ) ) ) ) ) ) ).

% sum_diff1'_aux
tff(fact_2756_divmod__step__integer__def,axiom,
    ! [L: num,Qr: product_prod(code_integer,code_integer)] : ( unique1321980374590559556d_step(code_integer,L,Qr) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_fp(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),Qr) ) ).

% divmod_step_integer_def
tff(fact_2757_case__prodI2,axiom,
    ! [B: $tType,A: $tType,P3: product_prod(A,B),C2: fun(A,fun(B,bool))] :
      ( ! [A8: A,B5: B] :
          ( ( P3 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5) )
         => pp(aa(B,bool,aa(A,fun(B,bool),C2,A8),B5)) )
     => pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),C2),P3)) ) ).

% case_prodI2
tff(fact_2758_case__prodI,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(B,bool)),A3: A,B2: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),F,A3),B2))
     => pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),F),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2))) ) ).

% case_prodI
tff(fact_2759_mem__case__prodI2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P3: product_prod(A,B),Z2: C,C2: fun(A,fun(B,set(C)))] :
      ( ! [A8: A,B5: B] :
          ( ( P3 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5) )
         => pp(member(C,Z2,aa(B,set(C),aa(A,fun(B,set(C)),C2,A8),B5))) )
     => pp(member(C,Z2,aa(product_prod(A,B),set(C),aa(fun(A,fun(B,set(C))),fun(product_prod(A,B),set(C)),product_case_prod(A,B,set(C)),C2),P3))) ) ).

% mem_case_prodI2
tff(fact_2760_mem__case__prodI,axiom,
    ! [A: $tType,B: $tType,C: $tType,Z2: A,C2: fun(B,fun(C,set(A))),A3: B,B2: C] :
      ( pp(member(A,Z2,aa(C,set(A),aa(B,fun(C,set(A)),C2,A3),B2)))
     => pp(member(A,Z2,aa(product_prod(B,C),set(A),aa(fun(B,fun(C,set(A))),fun(product_prod(B,C),set(A)),product_case_prod(B,C,set(A)),C2),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),B2)))) ) ).

% mem_case_prodI
tff(fact_2761_case__prodI2_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P3: product_prod(A,B),C2: fun(A,fun(B,fun(C,bool))),X: C] :
      ( ! [A8: A,B5: B] :
          ( ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5) = P3 )
         => pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),C2,A8),B5),X)) )
     => pp(aa(C,bool,aa(product_prod(A,B),fun(C,bool),aa(fun(A,fun(B,fun(C,bool))),fun(product_prod(A,B),fun(C,bool)),product_case_prod(A,B,fun(C,bool)),C2),P3),X)) ) ).

% case_prodI2'
tff(fact_2762_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),one_one(A)) = one_one(A) ) ) ).

% gcd.bottom_right_bottom
tff(fact_2763_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),one_one(A)),A3) = one_one(A) ) ) ).

% gcd.bottom_left_bottom
tff(fact_2764_Collect__const__case__prod,axiom,
    ! [B: $tType,A: $tType,P: bool] :
      ( ( pp(P)
       => ( aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_fq(bool,fun(A,fun(B,bool)),P))) = top_top(set(product_prod(A,B))) ) )
      & ( ~ pp(P)
       => ( aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_fq(bool,fun(A,fun(B,bool)),P))) = bot_bot(set(product_prod(A,B))) ) ) ) ).

% Collect_const_case_prod
tff(fact_2765_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2),one_one(A)))
        <=> ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) = one_one(A) ) ) ) ).

% is_unit_gcd_iff
tff(fact_2766_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [P3: fun(B,A)] : ( groups1027152243600224163dd_sum(B,A,P3,bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty'
tff(fact_2767_Gcd__2,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: A,B2: A] : ( gcd_Gcd(A,aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) ) ) ).

% Gcd_2
tff(fact_2768_lex__prod__def,axiom,
    ! [A: $tType,B: $tType,Ra: set(product_prod(A,A)),Rb: set(product_prod(B,B))] : ( lex_prod(A,B,Ra,Rb) = aa(fun(product_prod(product_prod(A,B),product_prod(A,B)),bool),set(product_prod(product_prod(A,B),product_prod(A,B))),collect(product_prod(product_prod(A,B),product_prod(A,B))),aa(fun(product_prod(A,B),fun(product_prod(A,B),bool)),fun(product_prod(product_prod(A,B),product_prod(A,B)),bool),product_case_prod(product_prod(A,B),product_prod(A,B),bool),aa(fun(A,fun(B,fun(product_prod(A,B),bool))),fun(product_prod(A,B),fun(product_prod(A,B),bool)),product_case_prod(A,B,fun(product_prod(A,B),bool)),aa(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),bool))),aTP_Lamp_fs(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),bool)))),Ra),Rb)))) ) ).

% lex_prod_def
tff(fact_2769_divmod__integer_H__def,axiom,
    ! [M4: num,N: num] : ( unique8689654367752047608divmod(code_integer,M4,N) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),divide_divide(code_integer,aa(num,code_integer,numeral_numeral(code_integer),M4),aa(num,code_integer,numeral_numeral(code_integer),N))),modulo_modulo(code_integer,aa(num,code_integer,numeral_numeral(code_integer),M4),aa(num,code_integer,numeral_numeral(code_integer),N))) ) ).

% divmod_integer'_def
tff(fact_2770_mem__case__prodE,axiom,
    ! [B: $tType,A: $tType,C: $tType,Z2: A,C2: fun(B,fun(C,set(A))),P3: product_prod(B,C)] :
      ( pp(member(A,Z2,aa(product_prod(B,C),set(A),aa(fun(B,fun(C,set(A))),fun(product_prod(B,C),set(A)),product_case_prod(B,C,set(A)),C2),P3)))
     => ~ ! [X2: B,Y2: C] :
            ( ( P3 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2) )
           => ~ pp(member(A,Z2,aa(C,set(A),aa(B,fun(C,set(A)),C2,X2),Y2))) ) ) ).

% mem_case_prodE
tff(fact_2771_case__prodE,axiom,
    ! [A: $tType,B: $tType,C2: fun(A,fun(B,bool)),P3: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),C2),P3))
     => ~ ! [X2: A,Y2: B] :
            ( ( P3 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2) )
           => ~ pp(aa(B,bool,aa(A,fun(B,bool),C2,X2),Y2)) ) ) ).

% case_prodE
tff(fact_2772_case__prodD,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(B,bool)),A3: A,B2: B] :
      ( pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),F),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2)))
     => pp(aa(B,bool,aa(A,fun(B,bool),F,A3),B2)) ) ).

% case_prodD
tff(fact_2773_case__prodE_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: fun(A,fun(B,fun(C,bool))),P3: product_prod(A,B),Z2: C] :
      ( pp(aa(C,bool,aa(product_prod(A,B),fun(C,bool),aa(fun(A,fun(B,fun(C,bool))),fun(product_prod(A,B),fun(C,bool)),product_case_prod(A,B,fun(C,bool)),C2),P3),Z2))
     => ~ ! [X2: A,Y2: B] :
            ( ( P3 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2) )
           => ~ pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),C2,X2),Y2),Z2)) ) ) ).

% case_prodE'
tff(fact_2774_case__prodD_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,R: fun(A,fun(B,fun(C,bool))),A3: A,B2: B,C2: C] :
      ( pp(aa(C,bool,aa(product_prod(A,B),fun(C,bool),aa(fun(A,fun(B,fun(C,bool))),fun(product_prod(A,B),fun(C,bool)),product_case_prod(A,B,fun(C,bool)),R),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2)),C2))
     => pp(aa(C,bool,aa(B,fun(C,bool),aa(A,fun(B,fun(C,bool)),R,A3),B2),C2)) ) ).

% case_prodD'
tff(fact_2775_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M4: A,K: A,N: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M4),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),K),M4)),N)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M4),N) ) ) ).

% gcd_add_mult
tff(fact_2776_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,K: A] : pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2),aa(A,A,aa(A,fun(A,A),times_times(A),K),B2))) ) ).

% gcd_dvd_prod
tff(fact_2777_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_mult_unit1
tff(fact_2778_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_mult_unit2
tff(fact_2779_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),divide_divide(A,B2,A3)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_div_unit1
tff(fact_2780_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),divide_divide(A,C2,A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_div_unit2
tff(fact_2781_wait__bind__decon,axiom,
    ! [A: $tType,P: assn,M4: heap_Time_Heap(A),Q: fun(A,assn),N: nat] :
      ( hoare_hoare_triple(A,P,M4,Q)
     => hoare_hoare_triple(A,P,heap_Time_bind(product_unit,A,heap_Time_wait(N),aTP_Lamp_fm(heap_Time_Heap(A),fun(product_unit,heap_Time_Heap(A)),M4)),Q) ) ).

% wait_bind_decon
tff(fact_2782_Gcd__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,A4: set(A)] : ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),insert2(A,A3),A4)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))) ) ) ).

% Gcd_fin.insert_remove
tff(fact_2783_Gcd__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,A4: set(A)] :
          ( pp(member(A,A3,A4))
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A4) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))) ) ) ) ).

% Gcd_fin.remove
tff(fact_2784_wait__rule,axiom,
    ! [N: nat] : hoare_hoare_triple(product_unit,one_one(assn),heap_Time_wait(N),aTP_Lamp_ft(product_unit,assn)) ).

% wait_rule
tff(fact_2785_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [I4: set(A),F: fun(A,B),I: A] :
          ( pp(aa(set(A),bool,finite_finite(A),aa(fun(A,bool),set(A),collect(A),aa(fun(A,B),fun(A,bool),aTP_Lamp_fo(set(A),fun(fun(A,B),fun(A,bool)),I4),F))))
         => ( ( pp(member(A,I,I4))
             => ( groups1027152243600224163dd_sum(A,B,F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I4),aa(set(A),set(A),insert2(A,I),bot_bot(set(A))))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F,I4)),aa(A,B,F,I)) ) )
            & ( ~ pp(member(A,I,I4))
             => ( groups1027152243600224163dd_sum(A,B,F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I4),aa(set(A),set(A),insert2(A,I),bot_bot(set(A))))) = groups1027152243600224163dd_sum(A,B,F,I4) ) ) ) ) ) ).

% sum_diff1'
tff(fact_2786_lookup__chain,axiom,
    ! [B: $tType,A: $tType] :
      ( heap(B)
     => ! [R3: ref(B),F: heap_Time_Heap(A)] : ( heap_Time_bind(B,A,ref_lookup(B,R3),aTP_Lamp_fu(heap_Time_Heap(A),fun(B,heap_Time_Heap(A)),F)) = heap_Time_bind(product_unit,A,heap_Time_wait(one_one(nat)),aTP_Lamp_fm(heap_Time_Heap(A),fun(product_unit,heap_Time_Heap(A)),F)) ) ) ).

% lookup_chain
tff(fact_2787_bsqr__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( bNF_Wellorder_bsqr(A,R3) = aa(fun(product_prod(product_prod(A,A),product_prod(A,A)),bool),set(product_prod(product_prod(A,A),product_prod(A,A))),collect(product_prod(product_prod(A,A),product_prod(A,A))),aa(fun(product_prod(A,A),fun(product_prod(A,A),bool)),fun(product_prod(product_prod(A,A),product_prod(A,A)),bool),product_case_prod(product_prod(A,A),product_prod(A,A),bool),aa(fun(A,fun(A,fun(product_prod(A,A),bool))),fun(product_prod(A,A),fun(product_prod(A,A),bool)),product_case_prod(A,A,fun(product_prod(A,A),bool)),aTP_Lamp_fw(set(product_prod(A,A)),fun(A,fun(A,fun(product_prod(A,A),bool))),R3)))) ) ).

% bsqr_def
tff(fact_2788_Code__Numeral_Onegative__def,axiom,
    code_negative = aa(fun(num,code_integer),fun(num,code_integer),aa(fun(code_integer,code_integer),fun(fun(num,code_integer),fun(num,code_integer)),comp(code_integer,code_integer,num),uminus_uminus(code_integer)),numeral_numeral(code_integer)) ).

% Code_Numeral.negative_def
tff(fact_2789_insert__relcomp__union__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S2: set(product_prod(A,B)),X: product_prod(C,A),X6: set(product_prod(C,B))] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite(product_prod(A,B)),S2))
     => ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),set(product_prod(C,B))),sup_sup(set(product_prod(C,B))),relcomp(C,A,B,aa(set(product_prod(C,A)),set(product_prod(C,A)),insert2(product_prod(C,A),X),bot_bot(set(product_prod(C,A)))),S2)),X6) = finite_fold(product_prod(A,B),set(product_prod(C,B)),aa(fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(A,B),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(A,B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_fx(product_prod(C,A),fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),X)),X6,S2) ) ) ).

% insert_relcomp_union_fold
tff(fact_2790_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: fun(B,A),A14: set(B),B1: set(A),F22: fun(C,D),B22: set(C),A23: set(D)] :
      ( ( aa(set(B),set(A),image2(B,A,F1),A14) = B1 )
     => ( inj_on(C,D,F22,B22)
       => ( pp(aa(set(D),bool,aa(set(D),fun(set(D),bool),ord_less_eq(set(D)),aa(set(C),set(D),image2(C,D,F22),B22)),A23))
         => ( ( ( B22 = bot_bot(set(C)) )
             => ( A23 = bot_bot(set(D)) ) )
           => ( bNF_Wellorder_Func(C,A,B22,B1) = aa(set(fun(D,B)),set(fun(C,A)),image2(fun(D,B),fun(C,A),bNF_We4925052301507509544nc_map(C,B,A,D,B22,F1,F22)),bNF_Wellorder_Func(D,B,A23,A14)) ) ) ) ) ) ).

% Func_map_surj
tff(fact_2791_Func__non__emp,axiom,
    ! [A: $tType,B: $tType,B3: set(A),A4: set(B)] :
      ( ( B3 != bot_bot(set(A)) )
     => ( bNF_Wellorder_Func(B,A,A4,B3) != bot_bot(set(fun(B,A))) ) ) ).

% Func_non_emp
tff(fact_2792_fold__empty,axiom,
    ! [B: $tType,A: $tType,F: fun(B,fun(A,A)),Z2: A] : ( finite_fold(B,A,F,Z2,bot_bot(set(B))) = Z2 ) ).

% fold_empty
tff(fact_2793_gcd__nat_Osemilattice__neutr__axioms,axiom,
    semilattice_neutr(nat,gcd_gcd(nat),zero_zero(nat)) ).

% gcd_nat.semilattice_neutr_axioms
tff(fact_2794_gcd__nat_Omonoid__axioms,axiom,
    monoid(nat,gcd_gcd(nat),zero_zero(nat)) ).

% gcd_nat.monoid_axioms
tff(fact_2795_Gcd__in,axiom,
    ! [A4: set(nat)] :
      ( ! [A8: nat,B5: nat] :
          ( pp(member(nat,A8,A4))
         => ( pp(member(nat,B5,A4))
           => pp(member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A8),B5),A4)) ) )
     => ( ( A4 != bot_bot(set(nat)) )
       => pp(member(nat,gcd_Gcd(nat,A4),A4)) ) ) ).

% Gcd_in
tff(fact_2796_fold__image,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: fun(A,B),A4: set(A),F: fun(B,fun(C,C)),Z2: C] :
      ( inj_on(A,B,G,A4)
     => ( finite_fold(B,C,F,Z2,aa(set(A),set(B),image2(A,B,G),A4)) = finite_fold(A,C,aa(fun(A,B),fun(A,fun(C,C)),aa(fun(B,fun(C,C)),fun(fun(A,B),fun(A,fun(C,C))),comp(B,fun(C,C),A),F),G),Z2,A4) ) ) ).

% fold_image
tff(fact_2797_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),A4: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A4) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),aa(fun(A,fun(A,A)),fun(fun(B,A),fun(B,fun(A,A))),comp(A,fun(A,A),B),plus_plus(A)),G),zero_zero(A),A4) ) ) ).

% sum.eq_fold
tff(fact_2798_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),A4: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A4) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),aa(fun(A,fun(A,A)),fun(fun(B,A),fun(B,fun(A,A))),comp(A,fun(A,A),B),times_times(A)),G),one_one(A),A4) ) ) ).

% prod.eq_fold
tff(fact_2799_Inf__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(set(A),set(A),insert2(A,X),A4)) = finite_fold(A,A,inf_inf(A),X,A4) ) ) ) ).

% Inf_fin.eq_fold
tff(fact_2800_Sup__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( aa(set(A),A,lattic5882676163264333800up_fin(A),aa(set(A),set(A),insert2(A,X),A4)) = finite_fold(A,A,sup_sup(A),X,A4) ) ) ) ).

% Sup_fin.eq_fold
tff(fact_2801_image__fold__insert,axiom,
    ! [B: $tType,A: $tType,A4: set(A),F: fun(A,B)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( aa(set(A),set(B),image2(A,B,F),A4) = finite_fold(A,set(B),aTP_Lamp_fy(fun(A,B),fun(A,fun(set(B),set(B))),F),bot_bot(set(B)),A4) ) ) ).

% image_fold_insert
tff(fact_2802_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: set(A)] :
          ( ( pp(aa(set(A),bool,finite_finite(A),A4))
           => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A4) = finite_fold(A,A,gcd_gcd(A),zero_zero(A),A4) ) )
          & ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
           => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A4) = one_one(A) ) ) ) ) ).

% Gcd_fin.eq_fold
tff(fact_2803_relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set(product_prod(A,B)),S2: set(product_prod(B,C))] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite(product_prod(A,B)),R))
     => ( pp(aa(set(product_prod(B,C)),bool,finite_finite(product_prod(B,C)),S2))
       => ( relcomp(A,B,C,R,S2) = finite_fold(product_prod(A,B),set(product_prod(A,C)),aa(fun(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C))))),fun(product_prod(A,B),fun(set(product_prod(A,C)),set(product_prod(A,C)))),product_case_prod(A,B,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aTP_Lamp_ga(set(product_prod(B,C)),fun(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C))))),S2)),bot_bot(set(product_prod(A,C))),R) ) ) ) ).

% relcomp_fold
tff(fact_2804_Id__on__fold,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( id_on(A,A4) = finite_fold(A,set(product_prod(A,A)),aTP_Lamp_gb(A,fun(set(product_prod(A,A)),set(product_prod(A,A)))),bot_bot(set(product_prod(A,A))),A4) ) ) ).

% Id_on_fold
tff(fact_2805_insert__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S2: set(product_prod(A,B)),X: product_prod(C,A),R: set(product_prod(C,A))] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite(product_prod(A,B)),S2))
     => ( relcomp(C,A,B,aa(set(product_prod(C,A)),set(product_prod(C,A)),insert2(product_prod(C,A),X),R),S2) = finite_fold(product_prod(A,B),set(product_prod(C,B)),aa(fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(A,B),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(A,B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_fx(product_prod(C,A),fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),X)),relcomp(C,A,B,R,S2),S2) ) ) ).

% insert_relcomp_fold
tff(fact_2806_Func__is__emp,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ( bNF_Wellorder_Func(A,B,A4,B3) = bot_bot(set(fun(A,B))) )
    <=> ( ( A4 != bot_bot(set(A)) )
        & ( B3 = bot_bot(set(B)) ) ) ) ).

% Func_is_emp
tff(fact_2807_gcd__nat_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Xa) = Y )
     => ( pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),gcd_nat_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa)))
       => ~ ( ( ( ( Xa = zero_zero(nat) )
               => ( Y = X ) )
              & ( ( Xa != zero_zero(nat) )
               => ( Y = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),modulo_modulo(nat,X,Xa)) ) ) )
           => ~ pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),gcd_nat_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa))) ) ) ) ).

% gcd_nat.pelims
tff(fact_2808_Set__filter__fold,axiom,
    ! [A: $tType,A4: set(A),P: fun(A,bool)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( filter3(A,P,A4) = finite_fold(A,set(A),aTP_Lamp_gc(fun(A,bool),fun(A,fun(set(A),set(A))),P),bot_bot(set(A)),A4) ) ) ).

% Set_filter_fold
tff(fact_2809_comp__fun__commute__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S2: set(product_prod(A,B))] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite(product_prod(A,B)),S2))
     => finite6289374366891150609ommute(product_prod(C,A),set(product_prod(C,B)),aa(fun(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(C,A),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(C,A,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_ge(set(product_prod(A,B)),fun(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B))))),S2))) ) ).

% comp_fun_commute_relcomp_fold
tff(fact_2810_bit__cut__integer__def,axiom,
    ! [K: code_integer] : ( code_bit_cut_integer(K) = aa(bool,product_prod(code_integer,bool),aa(code_integer,fun(bool,product_prod(code_integer,bool)),product_Pair(code_integer,bool),divide_divide(code_integer,K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),aa(bool,bool,fNot,dvd_dvd(code_integer,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)),K))) ) ).

% bit_cut_integer_def
tff(fact_2811_divmod__integer__def,axiom,
    ! [K: code_integer,L: code_integer] : ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),divide_divide(code_integer,K,L)),modulo_modulo(code_integer,K,L)) ) ).

% divmod_integer_def
tff(fact_2812_convol__image__vimage2p,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,F: fun(C,A),G: fun(D,B),R: fun(A,fun(B,bool))] : pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),aa(set(product_prod(C,D)),set(product_prod(A,B)),image2(product_prod(C,D),product_prod(A,B),bNF_convol(product_prod(C,D),A,B,aa(fun(product_prod(C,D),C),fun(product_prod(C,D),A),aa(fun(C,A),fun(fun(product_prod(C,D),C),fun(product_prod(C,D),A)),comp(C,A,product_prod(C,D)),F),product_fst(C,D)),aa(fun(product_prod(C,D),D),fun(product_prod(C,D),B),aa(fun(D,B),fun(fun(product_prod(C,D),D),fun(product_prod(C,D),B)),comp(D,B,product_prod(C,D)),G),product_snd(C,D)))),aa(fun(product_prod(C,D),bool),set(product_prod(C,D)),collect(product_prod(C,D)),aa(fun(C,fun(D,bool)),fun(product_prod(C,D),bool),product_case_prod(C,D,bool),aa(fun(A,fun(B,bool)),fun(C,fun(D,bool)),bNF_vimage2p(C,A,D,B,bool,F,G),R))))),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),R)))) ).

% convol_image_vimage2p
tff(fact_2813_comp__fun__commute_Ointro,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B))] :
      ( ! [Y2: A,X2: A] : ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y2)),aa(A,fun(B,B),F,X2)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,Y2)) )
     => finite6289374366891150609ommute(A,B,F) ) ).

% comp_fun_commute.intro
tff(fact_2814_comp__fun__commute_Ocomp__fun__commute,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B)),Y: A,X: A] :
      ( finite6289374366891150609ommute(A,B,F)
     => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y)),aa(A,fun(B,B),F,X)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X)),aa(A,fun(B,B),F,Y)) ) ) ).

% comp_fun_commute.comp_fun_commute
tff(fact_2815_comp__fun__commute__def,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B))] :
      ( finite6289374366891150609ommute(A,B,F)
    <=> ! [Y3: A,X4: A] : ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y3)),aa(A,fun(B,B),F,X4)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X4)),aa(A,fun(B,B),F,Y3)) ) ) ).

% comp_fun_commute_def
tff(fact_2816_comp__fun__commute_Ocomp__comp__fun__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(A,fun(B,B)),G: fun(C,A)] :
      ( finite6289374366891150609ommute(A,B,F)
     => finite6289374366891150609ommute(C,B,aa(fun(C,A),fun(C,fun(B,B)),aa(fun(A,fun(B,B)),fun(fun(C,A),fun(C,fun(B,B))),comp(A,fun(B,B),C),F),G)) ) ).

% comp_fun_commute.comp_comp_fun_commute
tff(fact_2817_vimage2p__comp,axiom,
    ! [E: $tType,D: $tType,F8: $tType,A: $tType,C: $tType,B: $tType,G2: $tType,F1: fun(F8,A),F22: fun(D,F8),G1: fun(G2,B),G22: fun(E,G2)] : ( bNF_vimage2p(D,A,E,B,C,aa(fun(D,F8),fun(D,A),aa(fun(F8,A),fun(fun(D,F8),fun(D,A)),comp(F8,A,D),F1),F22),aa(fun(E,G2),fun(E,B),aa(fun(G2,B),fun(fun(E,G2),fun(E,B)),comp(G2,B,E),G1),G22)) = aa(fun(fun(A,fun(B,C)),fun(F8,fun(G2,C))),fun(fun(A,fun(B,C)),fun(D,fun(E,C))),aa(fun(fun(F8,fun(G2,C)),fun(D,fun(E,C))),fun(fun(fun(A,fun(B,C)),fun(F8,fun(G2,C))),fun(fun(A,fun(B,C)),fun(D,fun(E,C)))),comp(fun(F8,fun(G2,C)),fun(D,fun(E,C)),fun(A,fun(B,C))),bNF_vimage2p(D,F8,E,G2,C,F22,G22)),bNF_vimage2p(F8,A,G2,B,C,F1,G1)) ) ).

% vimage2p_comp
tff(fact_2818_inter__Set__filter,axiom,
    ! [A: $tType,B3: set(A),A4: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),B3))
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = filter3(A,aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),A4),B3) ) ) ).

% inter_Set_filter
tff(fact_2819_comp__fun__commute__product__fold,axiom,
    ! [B: $tType,A: $tType,B3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),B3))
     => finite6289374366891150609ommute(B,set(product_prod(B,A)),aTP_Lamp_gg(set(A),fun(B,fun(set(product_prod(B,A)),set(product_prod(B,A)))),B3)) ) ).

% comp_fun_commute_product_fold
tff(fact_2820_bit__cut__integer__code,axiom,
    ! [K: code_integer] :
      ( ( ( K = zero_zero(code_integer) )
       => ( code_bit_cut_integer(K) = aa(bool,product_prod(code_integer,bool),aa(code_integer,fun(bool,product_prod(code_integer,bool)),product_Pair(code_integer,bool),zero_zero(code_integer)),fFalse) ) )
      & ( ( K != zero_zero(code_integer) )
       => ( code_bit_cut_integer(K) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,bool),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,bool))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,bool)),product_case_prod(code_integer,code_integer,product_prod(code_integer,bool)),aTP_Lamp_gh(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,bool))),K)),code_divmod_abs(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))) ) ) ) ).

% bit_cut_integer_code
tff(fact_2821_divmod__integer__eq__cases,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( ( K = zero_zero(code_integer) )
       => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ) )
      & ( ( K != zero_zero(code_integer) )
       => ( ( ( L = zero_zero(code_integer) )
           => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),K) ) )
          & ( ( L != zero_zero(code_integer) )
           => ( code_divmod_integer(K,L) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),aa(fun(code_integer,code_integer),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),aa(fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),fun(fun(code_integer,code_integer),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)))),comp(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer),aa(fun(code_integer,fun(code_integer,code_integer)),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),aa(fun(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),fun(fun(code_integer,fun(code_integer,code_integer)),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)))),comp(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer),product_apsnd(code_integer,code_integer,code_integer)),times_times(code_integer))),sgn_sgn(code_integer)),L),if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),aa(code_integer,code_integer,sgn_sgn(code_integer),K)),aa(code_integer,code_integer,sgn_sgn(code_integer),L)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gi(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ) ).

% divmod_integer_eq_cases
tff(fact_2822_divmod__integer__code,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( ( K = zero_zero(code_integer) )
       => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ) )
      & ( ( K != zero_zero(code_integer) )
       => ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),L))
           => ( ( pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),K))
               => ( code_divmod_integer(K,L) = code_divmod_abs(K,L) ) )
              & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),K))
               => ( code_divmod_integer(K,L) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gj(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)) ) ) ) )
          & ( ~ pp(aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),L))
           => ( ( ( L = zero_zero(code_integer) )
               => ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),K) ) )
              & ( ( L != zero_zero(code_integer) )
               => ( code_divmod_integer(K,L) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_apsnd(code_integer,code_integer,code_integer),uminus_uminus(code_integer)),if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),K),zero_zero(code_integer)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gk(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ) ) ) ).

% divmod_integer_code
tff(fact_2823_inverse__rat_Otransfer,axiom,
    pp(aa(fun(rat,rat),bool,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(rat,rat),bool),bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat),aTP_Lamp_gl(product_prod(int,int),product_prod(int,int))),inverse_inverse(rat))) ).

% inverse_rat.transfer
tff(fact_2824_max__extp__max__ext__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),X3: set(A),Xa3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),max_extp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R)),X3),Xa3))
    <=> pp(member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),X3),Xa3),max_ext(A,R))) ) ).

% max_extp_max_ext_eq
tff(fact_2825_same__fst__def,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),R: fun(A,set(product_prod(B,B)))] : ( same_fst(A,B,P,R) = aa(fun(product_prod(product_prod(A,B),product_prod(A,B)),bool),set(product_prod(product_prod(A,B),product_prod(A,B))),collect(product_prod(product_prod(A,B),product_prod(A,B))),aa(fun(product_prod(A,B),fun(product_prod(A,B),bool)),fun(product_prod(product_prod(A,B),product_prod(A,B)),bool),product_case_prod(product_prod(A,B),product_prod(A,B),bool),aa(fun(A,fun(B,fun(product_prod(A,B),bool))),fun(product_prod(A,B),fun(product_prod(A,B),bool)),product_case_prod(A,B,fun(product_prod(A,B),bool)),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),bool))),aTP_Lamp_gn(fun(A,bool),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),bool)))),P),R)))) ) ).

% same_fst_def
tff(fact_2826_same__fstI,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),X: A,Y6: B,Y: B,R: fun(A,set(product_prod(B,B)))] :
      ( pp(aa(A,bool,P,X))
     => ( pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y6),Y),aa(A,set(product_prod(B,B)),R,X)))
       => pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y6)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)),same_fst(A,B,P,R))) ) ) ).

% same_fstI
tff(fact_2827_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & power(A) )
     => ! [R: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,one_one(A)),one_one(B)))
         => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R,bNF_rel_fun(A,B,A,B,R,R)),times_times(A)),times_times(B)))
           => pp(aa(fun(B,fun(nat,B)),bool,aa(fun(A,fun(nat,A)),fun(fun(B,fun(nat,B)),bool),bNF_rel_fun(A,B,fun(nat,A),fun(nat,B),R,bNF_rel_fun(nat,nat,A,B,fequal(nat),R)),power_power(A)),power_power(B))) ) ) ) ).

% power_transfer
tff(fact_2828_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add(B)
        & semiring_numeral(B)
        & monoid_add(A)
        & semiring_numeral(A) )
     => ! [R: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(B,bool,aa(A,fun(B,bool),R,one_one(A)),one_one(B)))
           => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R,bNF_rel_fun(A,B,A,B,R,R)),plus_plus(A)),plus_plus(B)))
             => pp(aa(fun(num,B),bool,aa(fun(num,A),fun(fun(num,B),bool),bNF_rel_fun(num,num,A,B,fequal(num),R),numeral_numeral(A)),numeral_numeral(B))) ) ) ) ) ).

% transfer_rule_numeral
tff(fact_2829_fun_Omap__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,G2: $tType,F8: $tType,Rb2: fun(A,fun(F8,bool)),Sd: fun(B,fun(G2,bool))] : pp(aa(fun(fun(F8,G2),fun(fun(D,F8),fun(D,G2))),bool,aa(fun(fun(A,B),fun(fun(D,A),fun(D,B))),fun(fun(fun(F8,G2),fun(fun(D,F8),fun(D,G2))),bool),bNF_rel_fun(fun(A,B),fun(F8,G2),fun(fun(D,A),fun(D,B)),fun(fun(D,F8),fun(D,G2)),bNF_rel_fun(A,F8,B,G2,Rb2,Sd),bNF_rel_fun(fun(D,A),fun(D,F8),fun(D,B),fun(D,G2),bNF_rel_fun(D,D,A,F8,fequal(D),Rb2),bNF_rel_fun(D,D,B,G2,fequal(D),Sd))),comp(A,B,D)),comp(F8,G2,D))) ).

% fun.map_transfer
tff(fact_2830_comp__transfer,axiom,
    ! [A: $tType,B: $tType,E: $tType,F8: $tType,D: $tType,C: $tType,B3: fun(A,fun(C,bool)),C3: fun(B,fun(D,bool)),A4: fun(E,fun(F8,bool))] : pp(aa(fun(fun(C,D),fun(fun(F8,C),fun(F8,D))),bool,aa(fun(fun(A,B),fun(fun(E,A),fun(E,B))),fun(fun(fun(C,D),fun(fun(F8,C),fun(F8,D))),bool),bNF_rel_fun(fun(A,B),fun(C,D),fun(fun(E,A),fun(E,B)),fun(fun(F8,C),fun(F8,D)),bNF_rel_fun(A,C,B,D,B3,C3),bNF_rel_fun(fun(E,A),fun(F8,C),fun(E,B),fun(F8,D),bNF_rel_fun(E,F8,A,C,A4,B3),bNF_rel_fun(E,F8,B,D,A4,C3))),comp(A,B,E)),comp(C,D,F8))) ).

% comp_transfer
tff(fact_2831_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1(B)
        & ring_1(A) )
     => ! [R: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(B,bool,aa(A,fun(B,bool),R,one_one(A)),one_one(B)))
           => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R,bNF_rel_fun(A,B,A,B,R,R)),plus_plus(A)),plus_plus(B)))
             => ( pp(aa(fun(B,B),bool,aa(fun(A,A),fun(fun(B,B),bool),bNF_rel_fun(A,B,A,B,R,R),uminus_uminus(A)),uminus_uminus(B)))
               => pp(aa(fun(int,B),bool,aa(fun(int,A),fun(fun(int,B),bool),bNF_rel_fun(int,int,A,B,fequal(int),R),ring_1_of_int(A)),ring_1_of_int(B))) ) ) ) ) ) ).

% transfer_rule_of_int
tff(fact_2832_fun_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Sa: fun(A,fun(C,bool)),X: fun(D,A),G: fun(B,C),Y: fun(D,B)] :
      ( pp(aa(fun(D,C),bool,aa(fun(D,A),fun(fun(D,C),bool),bNF_rel_fun(D,D,A,C,fequal(D),Sa),X),aa(fun(D,B),fun(D,C),aa(fun(B,C),fun(fun(D,B),fun(D,C)),comp(B,C,D),G),Y)))
    <=> pp(aa(fun(D,B),bool,aa(fun(D,A),fun(fun(D,B),bool),bNF_rel_fun(D,D,A,B,fequal(D),aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_go(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Sa),G)),X),Y)) ) ).

% fun.rel_map(2)
tff(fact_2833_fun_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Sb: fun(C,fun(B,bool)),I: fun(A,C),X: fun(D,A),Y: fun(D,B)] :
      ( pp(aa(fun(D,B),bool,aa(fun(D,C),fun(fun(D,B),bool),bNF_rel_fun(D,D,C,B,fequal(D),Sb),aa(fun(D,A),fun(D,C),aa(fun(A,C),fun(fun(D,A),fun(D,C)),comp(A,C,D),I),X)),Y))
    <=> pp(aa(fun(D,B),bool,aa(fun(D,A),fun(fun(D,B),bool),bNF_rel_fun(D,D,A,B,fequal(D),aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_gp(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Sb),I)),X),Y)) ) ).

% fun.rel_map(1)
tff(fact_2834_divmod__abs__code_I5_J,axiom,
    ! [J2: code_integer] : ( code_divmod_abs(J2,zero_zero(code_integer)) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),aa(code_integer,code_integer,abs_abs(code_integer),J2)) ) ).

% divmod_abs_code(5)
tff(fact_2835_divmod__abs__code_I6_J,axiom,
    ! [J2: code_integer] : ( code_divmod_abs(zero_zero(code_integer),J2) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ) ).

% divmod_abs_code(6)
tff(fact_2836_rel__fun__Collect__case__prodD,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,A4: fun(A,fun(B,bool)),B3: fun(C,fun(D,bool)),F: fun(A,C),G: fun(B,D),X6: set(product_prod(A,B)),X: product_prod(A,B)] :
      ( pp(aa(fun(B,D),bool,aa(fun(A,C),fun(fun(B,D),bool),bNF_rel_fun(A,B,C,D,A4,B3),F),G))
     => ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),X6),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),A4))))
       => ( pp(member(product_prod(A,B),X,X6))
         => pp(aa(D,bool,aa(C,fun(D,bool),B3,aa(product_prod(A,B),C,aa(fun(product_prod(A,B),A),fun(product_prod(A,B),C),aa(fun(A,C),fun(fun(product_prod(A,B),A),fun(product_prod(A,B),C)),comp(A,C,product_prod(A,B)),F),product_fst(A,B)),X)),aa(product_prod(A,B),D,aa(fun(product_prod(A,B),B),fun(product_prod(A,B),D),aa(fun(B,D),fun(fun(product_prod(A,B),B),fun(product_prod(A,B),D)),comp(B,D,product_prod(A,B)),G),product_snd(A,B)),X))) ) ) ) ).

% rel_fun_Collect_case_prodD
tff(fact_2837_max__ext__def,axiom,
    ! [A: $tType,X3: set(product_prod(A,A))] : ( max_ext(A,X3) = aa(fun(product_prod(set(A),set(A)),bool),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aa(fun(set(A),fun(set(A),bool)),fun(product_prod(set(A),set(A)),bool),product_case_prod(set(A),set(A),bool),max_extp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),X3)))) ) ).

% max_ext_def
tff(fact_2838_divmod__abs__def,axiom,
    ! [K: code_integer,L: code_integer] : ( code_divmod_abs(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),divide_divide(code_integer,aa(code_integer,code_integer,abs_abs(code_integer),K),aa(code_integer,code_integer,abs_abs(code_integer),L))),modulo_modulo(code_integer,aa(code_integer,code_integer,abs_abs(code_integer),K),aa(code_integer,code_integer,abs_abs(code_integer),L))) ) ).

% divmod_abs_def
tff(fact_2839_uminus__rat_Otransfer,axiom,
    pp(aa(fun(rat,rat),bool,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(rat,rat),bool),bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat),aTP_Lamp_gq(product_prod(int,int),product_prod(int,int))),uminus_uminus(rat))) ).

% uminus_rat.transfer
tff(fact_2840_fun_Oin__rel,axiom,
    ! [A: $tType,B: $tType,D: $tType,R: fun(A,fun(B,bool)),A3: fun(D,A),B2: fun(D,B)] :
      ( pp(aa(fun(D,B),bool,aa(fun(D,A),fun(fun(D,B),bool),bNF_rel_fun(D,D,A,B,fequal(D),R),A3),B2))
    <=> ? [Z4: fun(D,product_prod(A,B))] :
          ( pp(member(fun(D,product_prod(A,B)),Z4,aa(fun(fun(D,product_prod(A,B)),bool),set(fun(D,product_prod(A,B))),collect(fun(D,product_prod(A,B))),aTP_Lamp_gr(fun(A,fun(B,bool)),fun(fun(D,product_prod(A,B)),bool),R))))
          & ( aa(fun(D,product_prod(A,B)),fun(D,A),aa(fun(product_prod(A,B),A),fun(fun(D,product_prod(A,B)),fun(D,A)),comp(product_prod(A,B),A,D),product_fst(A,B)),Z4) = A3 )
          & ( aa(fun(D,product_prod(A,B)),fun(D,B),aa(fun(product_prod(A,B),B),fun(fun(D,product_prod(A,B)),fun(D,B)),comp(product_prod(A,B),B,D),product_snd(A,B)),Z4) = B2 ) ) ) ).

% fun.in_rel
tff(fact_2841_max__extp__eq,axiom,
    ! [A: $tType,R3: fun(A,fun(A,bool)),X: set(A),Y: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),max_extp(A,R3),X),Y))
    <=> pp(member(product_prod(set(A),set(A)),aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),X),Y),max_ext(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R3))))) ) ).

% max_extp_eq
tff(fact_2842_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1(B)
        & semiring_1(A) )
     => ! [R: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(B,bool,aa(A,fun(B,bool),R,one_one(A)),one_one(B)))
           => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R,bNF_rel_fun(A,B,A,B,R,R)),plus_plus(A)),plus_plus(B)))
             => pp(aa(fun(nat,B),bool,aa(fun(nat,A),fun(fun(nat,B),bool),bNF_rel_fun(nat,nat,A,B,fequal(nat),R),semiring_1_of_nat(A)),semiring_1_of_nat(B))) ) ) ) ) ).

% transfer_rule_of_nat
tff(fact_2843_plus__rat_Otransfer,axiom,
    pp(aa(fun(rat,fun(rat,rat)),bool,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(rat,fun(rat,rat)),bool),bNF_rel_fun(product_prod(int,int),rat,fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),pcr_rat,bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat)),aTP_Lamp_gs(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),plus_plus(rat))) ).

% plus_rat.transfer
tff(fact_2844_times__rat_Otransfer,axiom,
    pp(aa(fun(rat,fun(rat,rat)),bool,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(rat,fun(rat,rat)),bool),bNF_rel_fun(product_prod(int,int),rat,fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),pcr_rat,bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat)),aTP_Lamp_gt(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),times_times(rat))) ).

% times_rat.transfer
tff(fact_2845_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B)),A4: set(A),B3: set(A),Z2: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),S2))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),S2))
         => ( pp(aa(set(A),bool,finite_finite(A),A4))
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) )
               => ( finite_fold(A,B,F,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = finite_fold(A,B,F,finite_fold(A,B,F,Z2,A4),B3) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
tff(fact_2846_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B)),A4: set(A),X: A,Z2: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),S2))
       => ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,X,A4))
           => ( finite_fold(A,B,F,Z2,A4) = aa(B,B,aa(A,fun(B,B),F,X),finite_fold(A,B,F,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
tff(fact_2847_comp__fun__commute__on_Ointro,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B))] :
      ( ! [X2: A,Y2: A] :
          ( pp(member(A,X2,S2))
         => ( pp(member(A,Y2,S2))
           => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y2)),aa(A,fun(B,B),F,X2)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,Y2)) ) ) )
     => finite4664212375090638736ute_on(A,B,S2,F) ) ).

% comp_fun_commute_on.intro
tff(fact_2848_comp__fun__commute__on_Ocommute__left__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,S2: set(A),F: fun(A,fun(B,B)),X: A,Y: A,G: fun(C,B)] :
      ( finite4664212375090638736ute_on(A,B,S2,F)
     => ( pp(member(A,X,S2))
       => ( pp(member(A,Y,S2))
         => ( aa(fun(C,B),fun(C,B),aa(fun(B,B),fun(fun(C,B),fun(C,B)),comp(B,B,C),aa(A,fun(B,B),F,Y)),aa(fun(C,B),fun(C,B),aa(fun(B,B),fun(fun(C,B),fun(C,B)),comp(B,B,C),aa(A,fun(B,B),F,X)),G)) = aa(fun(C,B),fun(C,B),aa(fun(B,B),fun(fun(C,B),fun(C,B)),comp(B,B,C),aa(A,fun(B,B),F,X)),aa(fun(C,B),fun(C,B),aa(fun(B,B),fun(fun(C,B),fun(C,B)),comp(B,B,C),aa(A,fun(B,B),F,Y)),G)) ) ) ) ) ).

% comp_fun_commute_on.commute_left_comp
tff(fact_2849_comp__fun__commute__on_Ocomp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B)),X: A,Y: A] :
      ( finite4664212375090638736ute_on(A,B,S2,F)
     => ( pp(member(A,X,S2))
       => ( pp(member(A,Y,S2))
         => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y)),aa(A,fun(B,B),F,X)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X)),aa(A,fun(B,B),F,Y)) ) ) ) ) ).

% comp_fun_commute_on.comp_fun_commute_on
tff(fact_2850_comp__fun__commute__on__def,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B))] :
      ( finite4664212375090638736ute_on(A,B,S2,F)
    <=> ! [X4: A,Y3: A] :
          ( pp(member(A,X4,S2))
         => ( pp(member(A,Y3,S2))
           => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y3)),aa(A,fun(B,B),F,X4)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X4)),aa(A,fun(B,B),F,Y3)) ) ) ) ) ).

% comp_fun_commute_on_def
tff(fact_2851_Fract_Orsp,axiom,
    pp(aa(fun(int,fun(int,product_prod(int,int))),bool,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,product_prod(int,int))),bool),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,product_prod(int,int)),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),product_prod(int,int),fequal(int),ratrel)),aTP_Lamp_gu(int,fun(int,product_prod(int,int)))),aTP_Lamp_gu(int,fun(int,product_prod(int,int))))) ).

% Fract.rsp
tff(fact_2852_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( zero_neq_one(B)
        & zero_neq_one(A) )
     => ! [R: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),R,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(B,bool,aa(A,fun(B,bool),R,one_one(A)),one_one(B)))
           => pp(aa(fun(bool,B),bool,aa(fun(bool,A),fun(fun(bool,B),bool),bNF_rel_fun(bool,bool,A,B,fequal(bool),R),zero_neq_one_of_bool(A)),zero_neq_one_of_bool(B))) ) ) ) ).

% transfer_rule_of_bool
tff(fact_2853_times__rat_Orsp,axiom,
    pp(aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),bool,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(product_prod(int,int),product_prod(int,int)),ratrel,bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel)),aTP_Lamp_gt(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),aTP_Lamp_gt(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))))) ).

% times_rat.rsp
tff(fact_2854_plus__int_Otransfer,axiom,
    pp(aa(fun(int,fun(int,int)),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),bool),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),plus_plus(int))) ).

% plus_int.transfer
tff(fact_2855_minus__int_Otransfer,axiom,
    pp(aa(fun(int,fun(int,int)),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),bool),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),minus_minus(int))) ).

% minus_int.transfer
tff(fact_2856_plus__rat_Orsp,axiom,
    pp(aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),bool,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(product_prod(int,int),product_prod(int,int)),ratrel,bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel)),aTP_Lamp_gs(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),aTP_Lamp_gs(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))))) ).

% plus_rat.rsp
tff(fact_2857_times__int_Otransfer,axiom,
    pp(aa(fun(int,fun(int,int)),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),bool),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),times_times(int))) ).

% times_int.transfer
tff(fact_2858_int__transfer,axiom,
    pp(aa(fun(nat,int),bool,aa(fun(nat,product_prod(nat,nat)),fun(fun(nat,int),bool),bNF_rel_fun(nat,nat,product_prod(nat,nat),int,fequal(nat),pcr_int),aTP_Lamp_hb(nat,product_prod(nat,nat))),semiring_1_of_nat(int))) ).

% int_transfer
tff(fact_2859_uminus__int_Otransfer,axiom,
    pp(aa(fun(int,int),bool,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(int,int),bool),bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat))))),uminus_uminus(int))) ).

% uminus_int.transfer
tff(fact_2860_comp__fun__commute__on_Ocomp__comp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set(A),F: fun(A,fun(B,B)),G: fun(C,A),R: set(C)] :
      ( finite4664212375090638736ute_on(A,B,S2,F)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(C),set(A),image2(C,A,G),top_top(set(C)))),S2))
       => finite4664212375090638736ute_on(C,B,R,aa(fun(C,A),fun(C,fun(B,B)),aa(fun(A,fun(B,B)),fun(fun(C,A),fun(C,fun(B,B))),comp(A,fun(B,B),C),F),G)) ) ) ).

% comp_fun_commute_on.comp_comp_fun_commute_on
tff(fact_2861_uminus__rat_Orsp,axiom,
    pp(aa(fun(product_prod(int,int),product_prod(int,int)),bool,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(product_prod(int,int),product_prod(int,int)),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel),aTP_Lamp_gq(product_prod(int,int),product_prod(int,int))),aTP_Lamp_gq(product_prod(int,int),product_prod(int,int)))) ).

% uminus_rat.rsp
tff(fact_2862_inverse__rat_Orsp,axiom,
    pp(aa(fun(product_prod(int,int),product_prod(int,int)),bool,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(product_prod(int,int),product_prod(int,int)),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel),aTP_Lamp_gl(product_prod(int,int),product_prod(int,int))),aTP_Lamp_gl(product_prod(int,int),product_prod(int,int)))) ).

% inverse_rat.rsp
tff(fact_2863_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B)),X: A,A4: set(A),Z2: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,X),A4)),S2))
       => ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( finite_fold(A,B,F,Z2,aa(set(A),set(A),insert2(A,X),A4)) = aa(B,B,aa(A,fun(B,B),F,X),finite_fold(A,B,F,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
tff(fact_2864_o__rsp_I2_J,axiom,
    ! [E: $tType,F8: $tType,H9: $tType,G2: $tType,R12: fun(E,fun(F8,bool))] : pp(aa(fun(fun(G2,H9),fun(fun(F8,G2),fun(F8,H9))),bool,aa(fun(fun(G2,H9),fun(fun(E,G2),fun(E,H9))),fun(fun(fun(G2,H9),fun(fun(F8,G2),fun(F8,H9))),bool),bNF_rel_fun(fun(G2,H9),fun(G2,H9),fun(fun(E,G2),fun(E,H9)),fun(fun(F8,G2),fun(F8,H9)),fequal(fun(G2,H9)),bNF_rel_fun(fun(E,G2),fun(F8,G2),fun(E,H9),fun(F8,H9),bNF_rel_fun(E,F8,G2,G2,R12,fequal(G2)),bNF_rel_fun(E,F8,H9,H9,R12,fequal(H9)))),comp(G2,H9,E)),comp(G2,H9,F8))) ).

% o_rsp(2)
tff(fact_2865_o__rsp_I1_J,axiom,
    ! [A: $tType,B: $tType,E: $tType,F8: $tType,D: $tType,C: $tType,R23: fun(A,fun(C,bool)),R32: fun(B,fun(D,bool)),R12: fun(E,fun(F8,bool))] : pp(aa(fun(fun(C,D),fun(fun(F8,C),fun(F8,D))),bool,aa(fun(fun(A,B),fun(fun(E,A),fun(E,B))),fun(fun(fun(C,D),fun(fun(F8,C),fun(F8,D))),bool),bNF_rel_fun(fun(A,B),fun(C,D),fun(fun(E,A),fun(E,B)),fun(fun(F8,C),fun(F8,D)),bNF_rel_fun(A,C,B,D,R23,R32),bNF_rel_fun(fun(E,A),fun(F8,C),fun(E,B),fun(F8,D),bNF_rel_fun(E,F8,A,C,R12,R23),bNF_rel_fun(E,F8,B,D,R12,R32))),comp(A,B,E)),comp(C,D,F8))) ).

% o_rsp(1)
tff(fact_2866_mlex__eq,axiom,
    ! [A: $tType,F: fun(A,nat),R: set(product_prod(A,A))] : ( mlex_prod(A,F,R) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aTP_Lamp_hd(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,bool))),F),R))) ) ).

% mlex_eq
tff(fact_2867_update__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [P3: ref(A),Y: A,X: A] : hoare_hoare_triple(product_unit,sngr_assn(A,P3,Y),ref_update(A,P3,X),aa(A,fun(product_unit,assn),aTP_Lamp_he(ref(A),fun(A,fun(product_unit,assn)),P3),X)) ) ).

% update_rule
tff(fact_2868_enumerate__Suc,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S2: set(A),N: nat] : ( infini527867602293511546merate(A,S2,aa(nat,nat,suc,N)) = infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert2(A,ord_Least(A,aTP_Lamp_hf(set(A),fun(A,bool),S2))),bot_bot(set(A)))),N) ) ) ).

% enumerate_Suc
tff(fact_2869_LeastI,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),K: A] :
          ( pp(aa(A,bool,P,K))
         => pp(aa(A,bool,P,ord_Least(A,P))) ) ) ).

% LeastI
tff(fact_2870_LeastI2__ex,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),Q: fun(A,bool)] :
          ( ? [X_13: A] : pp(aa(A,bool,P,X_13))
         => ( ! [X2: A] :
                ( pp(aa(A,bool,P,X2))
               => pp(aa(A,bool,Q,X2)) )
           => pp(aa(A,bool,Q,ord_Least(A,P))) ) ) ) ).

% LeastI2_ex
tff(fact_2871_LeastI__ex,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool)] :
          ( ? [X_13: A] : pp(aa(A,bool,P,X_13))
         => pp(aa(A,bool,P,ord_Least(A,P))) ) ) ).

% LeastI_ex
tff(fact_2872_LeastI2,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),A3: A,Q: fun(A,bool)] :
          ( pp(aa(A,bool,P,A3))
         => ( ! [X2: A] :
                ( pp(aa(A,bool,P,X2))
               => pp(aa(A,bool,Q,X2)) )
           => pp(aa(A,bool,Q,ord_Least(A,P))) ) ) ) ).

% LeastI2
tff(fact_2873_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),Q: fun(A,bool)] :
          ( ? [X_13: A] : pp(aa(A,bool,P,X_13))
         => ( ! [A8: A] :
                ( pp(aa(A,bool,P,A8))
               => ( ! [B10: A] :
                      ( pp(aa(A,bool,P,B10))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A8),B10)) )
                 => pp(aa(A,bool,Q,A8)) ) )
           => pp(aa(A,bool,Q,ord_Least(A,P))) ) ) ) ).

% LeastI2_wellorder_ex
tff(fact_2874_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),A3: A,Q: fun(A,bool)] :
          ( pp(aa(A,bool,P,A3))
         => ( ! [A8: A] :
                ( pp(aa(A,bool,P,A8))
               => ( ! [B10: A] :
                      ( pp(aa(A,bool,P,B10))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A8),B10)) )
                 => pp(aa(A,bool,Q,A8)) ) )
           => pp(aa(A,bool,Q,ord_Least(A,P))) ) ) ) ).

% LeastI2_wellorder
tff(fact_2875_Least__equality,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),X: A] :
          ( pp(aa(A,bool,P,X))
         => ( ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2)) )
           => ( ord_Least(A,P) = X ) ) ) ) ).

% Least_equality
tff(fact_2876_LeastI2__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),X: A,Q: fun(A,bool)] :
          ( pp(aa(A,bool,P,X))
         => ( ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y2)) )
           => ( ! [X2: A] :
                  ( pp(aa(A,bool,P,X2))
                 => ( ! [Y4: A] :
                        ( pp(aa(A,bool,P,Y4))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y4)) )
                   => pp(aa(A,bool,Q,X2)) ) )
             => pp(aa(A,bool,Q,ord_Least(A,P))) ) ) ) ) ).

% LeastI2_order
tff(fact_2877_Least1__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),Z2: A] :
          ( ? [X3: A] :
              ( pp(aa(A,bool,P,X3))
              & ! [Y2: A] :
                  ( pp(aa(A,bool,P,Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y2)) )
              & ! [Y2: A] :
                  ( ( pp(aa(A,bool,P,Y2))
                    & ! [Ya2: A] :
                        ( pp(aa(A,bool,P,Ya2))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),Ya2)) ) )
                 => ( Y2 = X3 ) ) )
         => ( pp(aa(A,bool,P,Z2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),ord_Least(A,P)),Z2)) ) ) ) ).

% Least1_le
tff(fact_2878_Least1I,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool)] :
          ( ? [X3: A] :
              ( pp(aa(A,bool,P,X3))
              & ! [Y2: A] :
                  ( pp(aa(A,bool,P,Y2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y2)) )
              & ! [Y2: A] :
                  ( ( pp(aa(A,bool,P,Y2))
                    & ! [Ya2: A] :
                        ( pp(aa(A,bool,P,Ya2))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),Ya2)) ) )
                 => ( Y2 = X3 ) ) )
         => pp(aa(A,bool,P,ord_Least(A,P))) ) ) ).

% Least1I
tff(fact_2879_Least__le,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,bool),K: A] :
          ( pp(aa(A,bool,P,K))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),ord_Least(A,P)),K)) ) ) ).

% Least_le
tff(fact_2880_not__less__Least,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [K: A,P: fun(A,bool)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),K),ord_Least(A,P)))
         => ~ pp(aa(A,bool,P,K)) ) ) ).

% not_less_Least
tff(fact_2881_mlex__iff,axiom,
    ! [A: $tType,X: A,Y: A,F: fun(A,nat),R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),mlex_prod(A,F,R)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F,X)),aa(A,nat,F,Y)))
        | ( ( aa(A,nat,F,X) = aa(A,nat,F,Y) )
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R)) ) ) ) ).

% mlex_iff
tff(fact_2882_mlex__less,axiom,
    ! [A: $tType,F: fun(A,nat),X: A,Y: A,R: set(product_prod(A,A))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F,X)),aa(A,nat,F,Y)))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),mlex_prod(A,F,R))) ) ).

% mlex_less
tff(fact_2883_mlex__leq,axiom,
    ! [A: $tType,F: fun(A,nat),X: A,Y: A,R: set(product_prod(A,A))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,F,X)),aa(A,nat,F,Y)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),mlex_prod(A,F,R))) ) ) ).

% mlex_leq
tff(fact_2884_change__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [F: fun(A,A),R3: ref(A)] : ( ref_change(A,F,R3) = heap_Time_bind(A,A,ref_lookup(A,R3),aa(ref(A),fun(A,heap_Time_Heap(A)),aTP_Lamp_hh(fun(A,A),fun(ref(A),fun(A,heap_Time_Heap(A))),F),R3)) ) ) ).

% change_def
tff(fact_2885_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X)) ) ).

% times_int.abs_eq
tff(fact_2886_update__wp__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),Y: A,X: A,Q: fun(product_unit,assn)] : hoare_hoare_triple(product_unit,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),sngr_assn(A,R3,Y)),wand_assn(sngr_assn(A,R3,X),aa(product_unit,assn,Q,product_Unity))),ref_update(A,R3,X),Q) ) ).

% update_wp_rule
tff(fact_2887_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X)) ) ).

% minus_int.abs_eq
tff(fact_2888_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X)) ) ).

% plus_int.abs_eq
tff(fact_2889_UNIV__unit,axiom,
    top_top(set(product_unit)) = aa(set(product_unit),set(product_unit),insert2(product_unit,product_Unity),bot_bot(set(product_unit))) ).

% UNIV_unit
tff(fact_2890_bot__unit__def,axiom,
    bot_bot(product_unit) = product_Unity ).

% bot_unit_def
tff(fact_2891_inf__unit__def,axiom,
    ! [Uu: product_unit,Uv: product_unit] : ( aa(product_unit,product_unit,aa(product_unit,fun(product_unit,product_unit),inf_inf(product_unit),Uu),Uv) = product_Unity ) ).

% inf_unit_def
tff(fact_2892_eq__Abs__Integ,axiom,
    ! [Z2: int] :
      ~ ! [X2: nat,Y2: nat] : ( Z2 != aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),Y2)) ) ).

% eq_Abs_Integ
tff(fact_2893_zero__int__def,axiom,
    zero_zero(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),zero_zero(nat))) ).

% zero_int_def
tff(fact_2894_int__def,axiom,
    ! [N: nat] : ( aa(nat,int,semiring_1_of_nat(int),N) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),N),zero_zero(nat))) ) ).

% int_def
tff(fact_2895_uminus__int_Oabs__eq,axiom,
    ! [X: product_prod(nat,nat)] : ( aa(int,int,uminus_uminus(int),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat)))),X)) ) ).

% uminus_int.abs_eq
tff(fact_2896_one__int__def,axiom,
    one_one(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),one_one(nat)),zero_zero(nat))) ).

% one_int_def
tff(fact_2897_range__prod,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(C,product_prod(A,B))] : pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),aa(set(C),set(product_prod(A,B)),image2(C,product_prod(A,B),F),top_top(set(C)))),product_Sigma(A,B,aa(set(C),set(A),image2(C,A,aa(fun(C,product_prod(A,B)),fun(C,A),aa(fun(product_prod(A,B),A),fun(fun(C,product_prod(A,B)),fun(C,A)),comp(product_prod(A,B),A,C),product_fst(A,B)),F)),top_top(set(C))),aTP_Lamp_hi(fun(C,product_prod(A,B)),fun(A,set(B)),F)))) ).

% range_prod
tff(fact_2898_fold__union__pair,axiom,
    ! [B: $tType,A: $tType,B3: set(A),X: B,A4: set(product_prod(B,A))] :
      ( pp(aa(set(A),bool,finite_finite(A),B3))
     => ( aa(set(product_prod(B,A)),set(product_prod(B,A)),aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),set(product_prod(B,A))),sup_sup(set(product_prod(B,A))),aa(set(set(product_prod(B,A))),set(product_prod(B,A)),complete_Sup_Sup(set(product_prod(B,A))),aa(set(A),set(set(product_prod(B,A))),image2(A,set(product_prod(B,A)),aTP_Lamp_hj(B,fun(A,set(product_prod(B,A))),X)),B3))),A4) = finite_fold(A,set(product_prod(B,A)),aTP_Lamp_gf(B,fun(A,fun(set(product_prod(B,A)),set(product_prod(B,A)))),X),A4,B3) ) ) ).

% fold_union_pair
tff(fact_2899_mlex__prod__def,axiom,
    ! [A: $tType,F: fun(A,nat),R: set(product_prod(A,A))] : ( mlex_prod(A,F,R) = inv_image(product_prod(nat,A),A,lex_prod(nat,A,less_than,R),aTP_Lamp_hk(fun(A,nat),fun(A,product_prod(nat,A)),F)) ) ).

% mlex_prod_def
tff(fact_2900_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I4: set(B),P3: fun(B,A),I: B] :
          ( pp(aa(set(B),bool,finite_finite(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_bt(set(B),fun(fun(B,A),fun(B,bool)),I4),P3))))
         => ( ( pp(member(B,I,I4))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P3),aa(set(B),set(B),insert2(B,I),I4)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P3),I4) ) )
            & ( ~ pp(member(B,I,I4))
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P3),aa(set(B),set(B),insert2(B,I),I4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,P3,I)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P3),I4)) ) ) ) ) ) ).

% prod.insert'
tff(fact_2901_times__int_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))))) ).

% times_int.rsp
tff(fact_2902_Sup__bot__conv_I2_J,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A)] :
          ( ( bot_bot(A) = aa(set(A),A,complete_Sup_Sup(A),A4) )
        <=> ! [X4: A] :
              ( pp(member(A,X4,A4))
             => ( X4 = bot_bot(A) ) ) ) ) ).

% Sup_bot_conv(2)
tff(fact_2903_Sup__bot__conv_I1_J,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),A4) = bot_bot(A) )
        <=> ! [X4: A] :
              ( pp(member(A,X4,A4))
             => ( X4 = bot_bot(A) ) ) ) ) ).

% Sup_bot_conv(1)
tff(fact_2904_SigmaI,axiom,
    ! [B: $tType,A: $tType,A3: A,A4: set(A),B2: B,B3: fun(A,set(B))] :
      ( pp(member(A,A3,A4))
     => ( pp(member(B,B2,aa(A,set(B),B3,A3)))
       => pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),product_Sigma(A,B,A4,B3))) ) ) ).

% SigmaI
tff(fact_2905_mem__Sigma__iff,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,A4: set(A),B3: fun(A,set(B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),product_Sigma(A,B,A4,B3)))
    <=> ( pp(member(A,A3,A4))
        & pp(member(B,B2,aa(A,set(B),B3,A3))) ) ) ).

% mem_Sigma_iff
tff(fact_2906_in__inv__image,axiom,
    ! [A: $tType,B: $tType,X: A,Y: A,R3: set(product_prod(B,B)),F: fun(A,B)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),inv_image(B,A,R3,F)))
    <=> pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,F,X)),aa(A,B,F,Y)),R3)) ) ).

% in_inv_image
tff(fact_2907_Sup__empty,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(A),A,complete_Sup_Sup(A),bot_bot(set(A))) = bot_bot(A) ) ) ).

% Sup_empty
tff(fact_2908_cSup__singleton,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X: A] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = X ) ) ).

% cSup_singleton
tff(fact_2909_Sup__insert,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: A,A4: set(A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert2(A,A3),A4)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(set(A),A,complete_Sup_Sup(A),A4)) ) ) ).

% Sup_insert
tff(fact_2910_Sigma__empty1,axiom,
    ! [B: $tType,A: $tType,B3: fun(A,set(B))] : ( product_Sigma(A,B,bot_bot(set(A)),B3) = bot_bot(set(product_prod(A,B))) ) ).

% Sigma_empty1
tff(fact_2911_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P3: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P3),bot_bot(set(B))) = one_one(A) ) ) ).

% prod.empty'
tff(fact_2912_intrel__iff,axiom,
    ! [X: nat,Y: nat,U: nat,V: nat] :
      ( pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),intrel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Y)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),U),V)))
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X),V) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),U),Y) ) ) ).

% intrel_iff
tff(fact_2913_SUP__bot__conv_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B3: fun(B,A),A4: set(B)] :
          ( ( bot_bot(A) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,B3),A4)) )
        <=> ! [X4: B] :
              ( pp(member(B,X4,A4))
             => ( aa(B,A,B3,X4) = bot_bot(A) ) ) ) ) ).

% SUP_bot_conv(2)
tff(fact_2914_SUP__bot__conv_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B3: fun(B,A),A4: set(B)] :
          ( ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,B3),A4)) = bot_bot(A) )
        <=> ! [X4: B] :
              ( pp(member(B,X4,A4))
             => ( aa(B,A,B3,X4) = bot_bot(A) ) ) ) ) ).

% SUP_bot_conv(1)
tff(fact_2915_SUP__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hl(B,A)),A4)) = bot_bot(A) ) ) ).

% SUP_bot
tff(fact_2916_cSUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),C2: A] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hm(A,fun(B,A),C2)),A4)) = C2 ) ) ) ).

% cSUP_const
tff(fact_2917_SUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(B),F: A] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hn(A,fun(B,A),F)),A4)) = F ) ) ) ).

% SUP_const
tff(fact_2918_UN__constant,axiom,
    ! [B: $tType,A: $tType,A4: set(B),C2: set(A)] :
      ( ( ( A4 = bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_ho(set(A),fun(B,set(A)),C2)),A4)) = bot_bot(set(A)) ) )
      & ( ( A4 != bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_ho(set(A),fun(B,set(A)),C2)),A4)) = C2 ) ) ) ).

% UN_constant
tff(fact_2919_Sigma__empty2,axiom,
    ! [B: $tType,A: $tType,A4: set(A)] : ( product_Sigma(A,B,A4,aTP_Lamp_hp(A,set(B))) = bot_bot(set(product_prod(A,B))) ) ).

% Sigma_empty2
tff(fact_2920_Times__empty,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ( product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)) = bot_bot(set(product_prod(A,B))) )
    <=> ( ( A4 = bot_bot(set(A)) )
        | ( B3 = bot_bot(set(B)) ) ) ) ).

% Times_empty
tff(fact_2921_UN__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set(B),A3: A,B3: fun(B,set(A))] :
      ( ( ( C3 = bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_hr(A,fun(fun(B,set(A)),fun(B,set(A))),A3),B3)),C3)) = bot_bot(set(A)) ) )
      & ( ( C3 != bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_hr(A,fun(fun(B,set(A)),fun(B,set(A))),A3),B3)),C3)) = aa(set(A),set(A),insert2(A,A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),C3))) ) ) ) ).

% UN_simps(1)
tff(fact_2922_UN__singleton,axiom,
    ! [A: $tType,A4: set(A)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(A),set(set(A)),image2(A,set(A),aTP_Lamp_bf(A,set(A))),A4)) = A4 ) ).

% UN_singleton
tff(fact_2923_UN__simps_I3_J,axiom,
    ! [E: $tType,F8: $tType,C3: set(F8),A4: set(E),B3: fun(F8,set(E))] :
      ( ( ( C3 = bot_bot(set(F8)) )
       => ( aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F8),set(set(E)),image2(F8,set(E),aa(fun(F8,set(E)),fun(F8,set(E)),aTP_Lamp_hs(set(E),fun(fun(F8,set(E)),fun(F8,set(E))),A4),B3)),C3)) = bot_bot(set(E)) ) )
      & ( ( C3 != bot_bot(set(F8)) )
       => ( aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F8),set(set(E)),image2(F8,set(E),aa(fun(F8,set(E)),fun(F8,set(E)),aTP_Lamp_hs(set(E),fun(fun(F8,set(E)),fun(F8,set(E))),A4),B3)),C3)) = aa(set(E),set(E),aa(set(E),fun(set(E),set(E)),sup_sup(set(E)),A4),aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F8),set(set(E)),image2(F8,set(E),B3),C3))) ) ) ) ).

% UN_simps(3)
tff(fact_2924_UN__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set(C),A4: fun(C,set(D)),B3: set(D)] :
      ( ( ( C3 = bot_bot(set(C)) )
       => ( aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),aa(set(D),fun(C,set(D)),aTP_Lamp_ht(fun(C,set(D)),fun(set(D),fun(C,set(D))),A4),B3)),C3)) = bot_bot(set(D)) ) )
      & ( ( C3 != bot_bot(set(C)) )
       => ( aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),aa(set(D),fun(C,set(D)),aTP_Lamp_ht(fun(C,set(D)),fun(set(D),fun(C,set(D))),A4),B3)),C3)) = aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),sup_sup(set(D)),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A4),C3))),B3) ) ) ) ).

% UN_simps(2)
tff(fact_2925_fst__image__times,axiom,
    ! [B: $tType,A: $tType,B3: set(B),A4: set(A)] :
      ( ( ( B3 = bot_bot(set(B)) )
       => ( aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3))) = bot_bot(set(A)) ) )
      & ( ( B3 != bot_bot(set(B)) )
       => ( aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3))) = A4 ) ) ) ).

% fst_image_times
tff(fact_2926_snd__image__times,axiom,
    ! [B: $tType,A: $tType,A4: set(B),B3: set(A)] :
      ( ( ( A4 = bot_bot(set(B)) )
       => ( aa(set(product_prod(B,A)),set(A),image2(product_prod(B,A),A,product_snd(B,A)),product_Sigma(B,A,A4,aTP_Lamp_ho(set(A),fun(B,set(A)),B3))) = bot_bot(set(A)) ) )
      & ( ( A4 != bot_bot(set(B)) )
       => ( aa(set(product_prod(B,A)),set(A),image2(product_prod(B,A),A,product_snd(B,A)),product_Sigma(B,A,A4,aTP_Lamp_ho(set(A),fun(B,set(A)),B3))) = B3 ) ) ) ).

% snd_image_times
tff(fact_2927_Sigma__UNIV__cancel,axiom,
    ! [B: $tType,A: $tType,A4: set(A),X6: set(B)] : ( aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),X6))),product_Sigma(A,B,A4,aTP_Lamp_hu(A,set(B)))) = bot_bot(set(product_prod(A,B))) ) ).

% Sigma_UNIV_cancel
tff(fact_2928_insert__Times__insert,axiom,
    ! [A: $tType,B: $tType,A3: A,A4: set(A),B2: B,B3: set(B)] : ( product_Sigma(A,B,aa(set(A),set(A),insert2(A,A3),A4),aa(set(B),fun(A,set(B)),aTP_Lamp_hv(B,fun(set(B),fun(A,set(B))),B2),B3)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),insert2(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2)),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),sup_sup(set(product_prod(A,B))),product_Sigma(A,B,A4,aa(set(B),fun(A,set(B)),aTP_Lamp_hv(B,fun(set(B),fun(A,set(B))),B2),B3))),product_Sigma(A,B,aa(set(A),set(A),insert2(A,A3),A4),aTP_Lamp_hq(set(B),fun(A,set(B)),B3)))) ) ).

% insert_Times_insert
tff(fact_2929_SigmaE2,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,A4: set(A),B3: fun(A,set(B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),product_Sigma(A,B,A4,B3)))
     => ~ ( pp(member(A,A3,A4))
         => ~ pp(member(B,B2,aa(A,set(B),B3,A3))) ) ) ).

% SigmaE2
tff(fact_2930_SigmaD2,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,A4: set(A),B3: fun(A,set(B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),product_Sigma(A,B,A4,B3)))
     => pp(member(B,B2,aa(A,set(B),B3,A3))) ) ).

% SigmaD2
tff(fact_2931_SigmaD1,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,A4: set(A),B3: fun(A,set(B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),product_Sigma(A,B,A4,B3)))
     => pp(member(A,A3,A4)) ) ).

% SigmaD1
tff(fact_2932_SigmaE,axiom,
    ! [A: $tType,B: $tType,C2: product_prod(A,B),A4: set(A),B3: fun(A,set(B))] :
      ( pp(member(product_prod(A,B),C2,product_Sigma(A,B,A4,B3)))
     => ~ ! [X2: A] :
            ( pp(member(A,X2,A4))
           => ! [Y2: B] :
                ( pp(member(B,Y2,aa(A,set(B),B3,X2)))
               => ( C2 != aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2) ) ) ) ) ).

% SigmaE
tff(fact_2933_empty__Union__conv,axiom,
    ! [A: $tType,A4: set(set(A))] :
      ( ( bot_bot(set(A)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A4) )
    <=> ! [X4: set(A)] :
          ( pp(member(set(A),X4,A4))
         => ( X4 = bot_bot(set(A)) ) ) ) ).

% empty_Union_conv
tff(fact_2934_Union__empty__conv,axiom,
    ! [A: $tType,A4: set(set(A))] :
      ( ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A4) = bot_bot(set(A)) )
    <=> ! [X4: set(A)] :
          ( pp(member(set(A),X4,A4))
         => ( X4 = bot_bot(set(A)) ) ) ) ).

% Union_empty_conv
tff(fact_2935_Union__empty,axiom,
    ! [A: $tType] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),bot_bot(set(set(A)))) = bot_bot(set(A)) ) ).

% Union_empty
tff(fact_2936_times__eq__iff,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B),C3: set(A),D4: set(B)] :
      ( ( product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)) = product_Sigma(A,B,C3,aTP_Lamp_hq(set(B),fun(A,set(B)),D4)) )
    <=> ( ( ( A4 = C3 )
          & ( B3 = D4 ) )
        | ( ( ( A4 = bot_bot(set(A)) )
            | ( B3 = bot_bot(set(B)) ) )
          & ( ( C3 = bot_bot(set(A)) )
            | ( D4 = bot_bot(set(B)) ) ) ) ) ) ).

% times_eq_iff
tff(fact_2937_SUP__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: fun(bool,A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(bool),set(A),image2(bool,A,A4),top_top(set(bool)))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(bool,A,A4,fTrue)),aa(bool,A,A4,fFalse)) ) ) ).

% SUP_UNIV_bool_expand
tff(fact_2938_Sigma__def,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: fun(A,set(B))] : ( product_Sigma(A,B,A4,B3) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(A),set(set(product_prod(A,B))),image2(A,set(product_prod(A,B)),aTP_Lamp_hx(fun(A,set(B)),fun(A,set(product_prod(A,B))),B3)),A4)) ) ).

% Sigma_def
tff(fact_2939_in__Union__o__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,X: A,Gset: fun(B,set(set(A))),Gmap: fun(C,B),A4: C] :
      ( pp(member(A,X,aa(C,set(A),aa(fun(C,B),fun(C,set(A)),aa(fun(B,set(A)),fun(fun(C,B),fun(C,set(A))),comp(B,set(A),C),aa(fun(B,set(set(A))),fun(B,set(A)),aa(fun(set(set(A)),set(A)),fun(fun(B,set(set(A))),fun(B,set(A))),comp(set(set(A)),set(A),B),complete_Sup_Sup(set(A))),Gset)),Gmap),A4)))
     => pp(member(A,X,aa(C,set(A),aa(fun(C,set(set(A))),fun(C,set(A)),aa(fun(set(set(A)),set(A)),fun(fun(C,set(set(A))),fun(C,set(A))),comp(set(set(A)),set(A),C),complete_Sup_Sup(set(A))),aa(fun(C,B),fun(C,set(set(A))),aa(fun(B,set(set(A))),fun(fun(C,B),fun(C,set(set(A)))),comp(B,set(set(A)),C),Gset),Gmap)),A4))) ) ).

% in_Union_o_assoc
tff(fact_2940_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),I4: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),aa(fun(B,bool),set(B),collect(B),aa(set(B),fun(B,bool),aTP_Lamp_hy(fun(B,A),fun(set(B),fun(B,bool)),G),I4))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),I4) ) ) ).

% prod.non_neutral'
tff(fact_2941_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A),U: A] :
          ( ! [V3: A] :
              ( pp(member(A,V3,A4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),V3)) )
         => ( ( A4 != bot_bot(set(A)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Sup_Sup(A),A4))) ) ) ) ).

% less_eq_Sup
tff(fact_2942_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),A3: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,X6))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),A3)) )
           => ( ! [Y2: A] :
                  ( ! [X3: A] :
                      ( pp(member(A,X3,X6))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),Y2)) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),Y2)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),X6) = A3 ) ) ) ) ) ).

% cSup_eq_non_empty
tff(fact_2943_cSup__least,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),Z2: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,X6))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Z2)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),X6)),Z2)) ) ) ) ).

% cSup_least
tff(fact_2944_less__cSupE,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [Y: A,X6: set(A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(set(A),A,complete_Sup_Sup(A),X6)))
         => ( ( X6 != bot_bot(set(A)) )
           => ~ ! [X2: A] :
                  ( pp(member(A,X2,X6))
                 => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X2)) ) ) ) ) ).

% less_cSupE
tff(fact_2945_less__cSupD,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X6: set(A),Z2: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),aa(set(A),A,complete_Sup_Sup(A),X6)))
           => ? [X2: A] :
                ( pp(member(A,X2,X6))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),X2)) ) ) ) ) ).

% less_cSupD
tff(fact_2946_SUP__eq__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I4: set(B),F: fun(B,A),X: A] :
          ( ( I4 != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( pp(member(B,I3,I4))
               => ( aa(B,A,F,I3) = X ) )
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),I4)) = X ) ) ) ) ).

% SUP_eq_const
tff(fact_2947_Sup__inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B3: set(A),A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),B3)),A3) = bot_bot(A) )
        <=> ! [X4: A] :
              ( pp(member(A,X4,B3))
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X4),A3) = bot_bot(A) ) ) ) ) ).

% Sup_inf_eq_bot_iff
tff(fact_2948_inf__Sup,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: A,B3: set(A)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(set(A),A,complete_Sup_Sup(A),B3)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),inf_inf(A),A3)),B3)) ) ) ).

% inf_Sup
tff(fact_2949_SUP__image,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( complete_Sup(A)
     => ! [G: fun(B,A),F: fun(C,B),A4: set(C)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,G),aa(set(C),set(B),image2(C,B,F),A4))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),G),F)),A4)) ) ) ).

% SUP_image
tff(fact_2950_Sup__finite__insert,axiom,
    ! [A: $tType] :
      ( finite_lattice(A)
     => ! [A3: A,A4: set(A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert2(A,A3),A4)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(set(A),A,complete_Sup_Sup(A),A4)) ) ) ).

% Sup_finite_insert
tff(fact_2951_Sup__union__distrib,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A),B3: set(A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),A4)),aa(set(A),A,complete_Sup_Sup(A),B3)) ) ) ).

% Sup_union_distrib
tff(fact_2952_Sigma__Int__distrib1,axiom,
    ! [B: $tType,A: $tType,I4: set(A),J4: set(A),C3: fun(A,set(B))] : ( product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),I4),J4),C3) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),product_Sigma(A,B,I4,C3)),product_Sigma(A,B,J4,C3)) ) ).

% Sigma_Int_distrib1
tff(fact_2953_Union__disjoint,axiom,
    ! [A: $tType,C3: set(set(A)),A4: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C3)),A4) = bot_bot(set(A)) )
    <=> ! [X4: set(A)] :
          ( pp(member(set(A),X4,C3))
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X4),A4) = bot_bot(set(A)) ) ) ) ).

% Union_disjoint
tff(fact_2954_insert__partition,axiom,
    ! [A: $tType,X: set(A),F2: set(set(A))] :
      ( ~ pp(member(set(A),X,F2))
     => ( ! [X2: set(A)] :
            ( pp(member(set(A),X2,aa(set(set(A)),set(set(A)),insert2(set(A),X),F2)))
           => ! [Xa4: set(A)] :
                ( pp(member(set(A),Xa4,aa(set(set(A)),set(set(A)),insert2(set(A),X),F2)))
               => ( ( X2 != Xa4 )
                 => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X2),Xa4) = bot_bot(set(A)) ) ) ) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),F2)) = bot_bot(set(A)) ) ) ) ).

% insert_partition
tff(fact_2955_Union__Int__subset,axiom,
    ! [A: $tType,A4: set(set(A)),B3: set(set(A))] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),A4),B3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A4)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3)))) ).

% Union_Int_subset
tff(fact_2956_Sigma__empty__iff,axiom,
    ! [A: $tType,B: $tType,I4: set(A),X6: fun(A,set(B))] :
      ( ( product_Sigma(A,B,I4,X6) = bot_bot(set(product_prod(A,B))) )
    <=> ! [X4: A] :
          ( pp(member(A,X4,I4))
         => ( aa(A,set(B),X6,X4) = bot_bot(set(B)) ) ) ) ).

% Sigma_empty_iff
tff(fact_2957_SUP__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F: fun(B,A),B3: set(B),A3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),B3))),A3) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_hz(fun(B,A),fun(A,fun(B,A)),F),A3)),B3)) ) ) ).

% SUP_inf
tff(fact_2958_Sup__inf,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B3: set(A),A3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),B3)),A3) = aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),image2(A,A,aTP_Lamp_ia(A,fun(A,A),A3)),B3)) ) ) ).

% Sup_inf
tff(fact_2959_inf__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: A,F: fun(B,A),B3: set(B)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),B3))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ib(A,fun(fun(B,A),fun(B,A)),A3),F)),B3)) ) ) ).

% inf_SUP
tff(fact_2960_SUP__inf__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F: fun(B,A),A4: set(B),G: fun(C,A),B3: set(C)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,G),B3))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_id(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),F),G),B3)),A4)) ) ) ).

% SUP_inf_distrib2
tff(fact_2961_complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(B,A),A4: set(B),G: fun(B,A)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,G),A4))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ie(fun(B,A),fun(fun(B,A),fun(B,A)),F),G)),A4)) ) ) ).

% complete_lattice_class.SUP_sup_distrib
tff(fact_2962_SUP__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [K: B,I4: set(B),A4: fun(B,A)] :
          ( pp(member(B,K,I4))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,A4,K)),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,A4),I4))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,A4),I4)) ) ) ) ).

% SUP_absorb
tff(fact_2963_Restr__subset,axiom,
    ! [A: $tType,A4: set(A),B3: set(A),R3: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
     => ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,B3,aTP_Lamp_if(set(A),fun(A,set(A)),B3)))),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))) ) ) ).

% Restr_subset
tff(fact_2964_Restr__Field,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,field2(A,R3),aTP_Lamp_ig(set(product_prod(A,A)),fun(A,set(A)),R3))) = R3 ) ).

% Restr_Field
tff(fact_2965_Times__Int__distrib1,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(A),C3: set(B)] : ( product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3),aTP_Lamp_hq(set(B),fun(A,set(B)),C3)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),C3))),product_Sigma(A,B,B3,aTP_Lamp_hq(set(B),fun(A,set(B)),C3))) ) ).

% Times_Int_distrib1
tff(fact_2966_Sigma__Int__distrib2,axiom,
    ! [B: $tType,A: $tType,I4: set(A),A4: fun(A,set(B)),B3: fun(A,set(B))] : ( product_Sigma(A,B,I4,aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_ih(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),A4),B3)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),product_Sigma(A,B,I4,A4)),product_Sigma(A,B,I4,B3)) ) ).

% Sigma_Int_distrib2
tff(fact_2967_Times__Int__Times,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B),C3: set(A),D4: set(B)] : ( aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3))),product_Sigma(A,B,C3,aTP_Lamp_hq(set(B),fun(A,set(B)),D4))) = product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),C3),aa(set(B),fun(A,set(B)),aTP_Lamp_ii(set(B),fun(set(B),fun(A,set(B))),B3),D4)) ) ).

% Times_Int_Times
tff(fact_2968_zero__int_Orsp,axiom,
    pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),intrel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),zero_zero(nat))),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),zero_zero(nat)))) ).

% zero_int.rsp
tff(fact_2969_UNION__empty__conv_I2_J,axiom,
    ! [B: $tType,A: $tType,B3: fun(B,set(A)),A4: set(B)] :
      ( ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),A4)) = bot_bot(set(A)) )
    <=> ! [X4: B] :
          ( pp(member(B,X4,A4))
         => ( aa(B,set(A),B3,X4) = bot_bot(set(A)) ) ) ) ).

% UNION_empty_conv(2)
tff(fact_2970_UNION__empty__conv_I1_J,axiom,
    ! [B: $tType,A: $tType,B3: fun(B,set(A)),A4: set(B)] :
      ( ( bot_bot(set(A)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),A4)) )
    <=> ! [X4: B] :
          ( pp(member(B,X4,A4))
         => ( aa(B,set(A),B3,X4) = bot_bot(set(A)) ) ) ) ).

% UNION_empty_conv(1)
tff(fact_2971_UN__empty,axiom,
    ! [B: $tType,A: $tType,B3: fun(B,set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),bot_bot(set(B)))) = bot_bot(set(A)) ) ).

% UN_empty
tff(fact_2972_UN__empty2,axiom,
    ! [B: $tType,A: $tType,A4: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_ij(B,set(A))),A4)) = bot_bot(set(A)) ) ).

% UN_empty2
tff(fact_2973_Int__UN__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType,A4: fun(B,set(A)),I4: set(B),B3: fun(C,set(A)),J4: set(C)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A4),I4))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),B3),J4))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(set(C),fun(B,set(A)),aa(fun(C,set(A)),fun(set(C),fun(B,set(A))),aTP_Lamp_il(fun(B,set(A)),fun(fun(C,set(A)),fun(set(C),fun(B,set(A)))),A4),B3),J4)),I4)) ) ).

% Int_UN_distrib2
tff(fact_2974_Int__UN__distrib,axiom,
    ! [A: $tType,B: $tType,B3: set(A),A4: fun(B,set(A)),I4: set(B)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A4),I4))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_im(set(A),fun(fun(B,set(A)),fun(B,set(A))),B3),A4)),I4)) ) ).

% Int_UN_distrib
tff(fact_2975_UN__extend__simps_I4_J,axiom,
    ! [H9: $tType,G2: $tType,A4: fun(G2,set(H9)),C3: set(G2),B3: set(H9)] : ( aa(set(H9),set(H9),aa(set(H9),fun(set(H9),set(H9)),inf_inf(set(H9)),aa(set(set(H9)),set(H9),complete_Sup_Sup(set(H9)),aa(set(G2),set(set(H9)),image2(G2,set(H9),A4),C3))),B3) = aa(set(set(H9)),set(H9),complete_Sup_Sup(set(H9)),aa(set(G2),set(set(H9)),image2(G2,set(H9),aa(set(H9),fun(G2,set(H9)),aTP_Lamp_in(fun(G2,set(H9)),fun(set(H9),fun(G2,set(H9))),A4),B3)),C3)) ) ).

% UN_extend_simps(4)
tff(fact_2976_UN__extend__simps_I5_J,axiom,
    ! [I5: $tType,J5: $tType,A4: set(I5),B3: fun(J5,set(I5)),C3: set(J5)] : ( aa(set(I5),set(I5),aa(set(I5),fun(set(I5),set(I5)),inf_inf(set(I5)),A4),aa(set(set(I5)),set(I5),complete_Sup_Sup(set(I5)),aa(set(J5),set(set(I5)),image2(J5,set(I5),B3),C3))) = aa(set(set(I5)),set(I5),complete_Sup_Sup(set(I5)),aa(set(J5),set(set(I5)),image2(J5,set(I5),aa(fun(J5,set(I5)),fun(J5,set(I5)),aTP_Lamp_io(set(I5),fun(fun(J5,set(I5)),fun(J5,set(I5))),A4),B3)),C3)) ) ).

% UN_extend_simps(5)
tff(fact_2977_Union__natural,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] : ( aa(fun(set(set(A)),set(set(B))),fun(set(set(A)),set(B)),aa(fun(set(set(B)),set(B)),fun(fun(set(set(A)),set(set(B))),fun(set(set(A)),set(B))),comp(set(set(B)),set(B),set(set(A))),complete_Sup_Sup(set(B))),image2(set(A),set(B),image2(A,B,F))) = aa(fun(set(set(A)),set(A)),fun(set(set(A)),set(B)),aa(fun(set(A),set(B)),fun(fun(set(set(A)),set(A)),fun(set(set(A)),set(B))),comp(set(A),set(B),set(set(A))),image2(A,B,F)),complete_Sup_Sup(set(A))) ) ).

% Union_natural
tff(fact_2978_Int__Union2,axiom,
    ! [A: $tType,B3: set(set(A)),A4: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3)),A4) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(A)),set(set(A)),image2(set(A),set(A),aTP_Lamp_ip(set(A),fun(set(A),set(A)),A4)),B3)) ) ).

% Int_Union2
tff(fact_2979_Int__Union,axiom,
    ! [A: $tType,A4: set(A),B3: set(set(A))] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(A)),set(set(A)),image2(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4)),B3)) ) ).

% Int_Union
tff(fact_2980_SUP__eq__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I4: set(B),C2: A,F: fun(B,A)] :
          ( ( I4 != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( pp(member(B,I3,I4))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(B,A,F,I3))) )
           => ( ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),I4)) = C2 )
            <=> ! [X4: B] :
                  ( pp(member(B,X4,I4))
                 => ( aa(B,A,F,X4) = C2 ) ) ) ) ) ) ).

% SUP_eq_iff
tff(fact_2981_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),F: fun(B,A),M: A] :
          ( ( A4 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( pp(member(B,X2,A4))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,X2)),M)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))),M)) ) ) ) ).

% cSUP_least
tff(fact_2982_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X6: set(A),A3: A] :
          ( pp(aa(set(A),bool,finite_finite(A),X6))
         => ( ( X6 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Sup_Sup(A),X6)),A3))
            <=> ! [X4: A] :
                  ( pp(member(A,X4,X6))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),A3)) ) ) ) ) ) ).

% finite_Sup_less_iff
tff(fact_2983_finite__Sup__in,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [X2: A,Y2: A] :
                  ( pp(member(A,X2,A4))
                 => ( pp(member(A,Y2,A4))
                   => pp(member(A,aa(A,A,aa(A,fun(A,A),sup_sup(A),X2),Y2),A4)) ) )
             => pp(member(A,aa(set(A),A,complete_Sup_Sup(A),A4),A4)) ) ) ) ) ).

% finite_Sup_in
tff(fact_2984_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),A3: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X2)),A3)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(set(A),A,complete_Sup_Sup(A),S2))),A3)) ) ) ) ).

% cSup_abs_le
tff(fact_2985_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A),B3: set(A)] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3))),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),A4)),aa(set(A),A,complete_Sup_Sup(A),B3)))) ) ).

% Sup_inter_less_eq
tff(fact_2986_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [B3: set(set(B)),G: fun(B,A)] :
          ( ! [X2: set(B)] :
              ( pp(member(set(B),X2,B3))
             => pp(aa(set(B),bool,finite_finite(B),X2)) )
         => ( ! [A15: set(B)] :
                ( pp(member(set(B),A15,B3))
               => ! [A24: set(B)] :
                    ( pp(member(set(B),A24,B3))
                   => ( ( A15 != A24 )
                     => ! [X2: B] :
                          ( pp(member(B,X2,A15))
                         => ( pp(member(B,X2,A24))
                           => ( aa(B,A,G,X2) = zero_zero(A) ) ) ) ) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B3)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),aa(fun(fun(set(B),A),fun(set(set(B)),A)),fun(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A))),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A)),groups7311177749621191930dd_sum(set(B),A)),groups7311177749621191930dd_sum(B,A)),G),B3) ) ) ) ) ).

% sum.Union_comp
tff(fact_2987_sup__Sup__fold__sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A),B3: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),A4)),B3) = finite_fold(A,A,sup_sup(A),B3,A4) ) ) ) ).

% sup_Sup_fold_sup
tff(fact_2988_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I4: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),I4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_bb(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2)),I4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),I4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),H2),I4)) ) ) ) ).

% prod.distrib_triv'
tff(fact_2989_prod_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [B3: set(set(B)),G: fun(B,A)] :
          ( ! [X2: set(B)] :
              ( pp(member(set(B),X2,B3))
             => pp(aa(set(B),bool,finite_finite(B),X2)) )
         => ( ! [A15: set(B)] :
                ( pp(member(set(B),A15,B3))
               => ! [A24: set(B)] :
                    ( pp(member(set(B),A24,B3))
                   => ( ( A15 != A24 )
                     => ! [X2: B] :
                          ( pp(member(B,X2,A15))
                         => ( pp(member(B,X2,A24))
                           => ( aa(B,A,G,X2) = one_one(A) ) ) ) ) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B3)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),aa(fun(fun(set(B),A),fun(set(set(B)),A)),fun(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A))),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A)),groups7121269368397514597t_prod(set(B),A)),groups7121269368397514597t_prod(B,A)),G),B3) ) ) ) ) ).

% prod.Union_comp
tff(fact_2990_Sup__fin__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic5882676163264333800up_fin(A),A4) = aa(set(A),A,complete_Sup_Sup(A),A4) ) ) ) ) ).

% Sup_fin_Sup
tff(fact_2991_cSup__eq__Sup__fin,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),X6))
         => ( ( X6 != bot_bot(set(A)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),X6) = aa(set(A),A,lattic5882676163264333800up_fin(A),X6) ) ) ) ) ).

% cSup_eq_Sup_fin
tff(fact_2992_Union__image__empty,axiom,
    ! [B: $tType,A: $tType,A4: set(A),F: fun(B,set(A))] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),F),bot_bot(set(B))))) = A4 ) ).

% Union_image_empty
tff(fact_2993_uminus__int_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),product_prod(nat,nat)),bool,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(product_prod(nat,nat),product_prod(nat,nat)),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat))))),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat)))))) ).

% uminus_int.rsp
tff(fact_2994_card__cartesian__product__singleton,axiom,
    ! [A: $tType,B: $tType,X: A,A4: set(B)] : ( finite_card(product_prod(A,B),product_Sigma(A,B,aa(set(A),set(A),insert2(A,X),bot_bot(set(A))),aTP_Lamp_hq(set(B),fun(A,set(B)),A4))) = finite_card(B,A4) ) ).

% card_cartesian_product_singleton
tff(fact_2995_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A4: set(A),C3: set(B),B3: set(A),D4: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),C3))),product_Sigma(A,B,B3,aTP_Lamp_hq(set(B),fun(A,set(B)),D4))))
    <=> ( ( A4 = bot_bot(set(A)) )
        | ( C3 = bot_bot(set(B)) )
        | ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
          & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),C3),D4)) ) ) ) ).

% times_subset_iff
tff(fact_2996_wfI,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B3: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),B3))))
     => ( ! [X2: A,P5: fun(A,bool)] :
            ( ! [Xa3: A] :
                ( ! [Y2: A] :
                    ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Xa3),R3))
                   => pp(aa(A,bool,P5,Y2)) )
               => pp(aa(A,bool,P5,Xa3)) )
           => ( pp(member(A,X2,A4))
             => ( pp(member(A,X2,B3))
               => pp(aa(A,bool,P5,X2)) ) ) )
       => wf(A,R3) ) ) ).

% wfI
tff(fact_2997_SUP__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(B,A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),bot_bot(set(B)))) = bot_bot(A) ) ) ).

% SUP_empty
tff(fact_2998_SUP__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(B),C2: A] :
          ( ( ( A4 = bot_bot(set(B)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hn(A,fun(B,A),C2)),A4)) = bot_bot(A) ) )
          & ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hn(A,fun(B,A),C2)),A4)) = C2 ) ) ) ) ).

% SUP_constant
tff(fact_2999_Field__Restr__subset,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))))),A4)) ).

% Field_Restr_subset
tff(fact_3000_finite__cartesian__product__iff,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite(product_prod(A,B)),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3))))
    <=> ( ( A4 = bot_bot(set(A)) )
        | ( B3 = bot_bot(set(B)) )
        | ( pp(aa(set(A),bool,finite_finite(A),A4))
          & pp(aa(set(B),bool,finite_finite(B),B3)) ) ) ) ).

% finite_cartesian_product_iff
tff(fact_3001_finite__cartesian__productD2,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite(product_prod(A,B)),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3))))
     => ( ( A4 != bot_bot(set(A)) )
       => pp(aa(set(B),bool,finite_finite(B),B3)) ) ) ).

% finite_cartesian_productD2
tff(fact_3002_finite__cartesian__productD1,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite(product_prod(A,B)),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3))))
     => ( ( B3 != bot_bot(set(B)) )
       => pp(aa(set(A),bool,finite_finite(A),A4)) ) ) ).

% finite_cartesian_productD1
tff(fact_3003_finite__SigmaI2,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: fun(A,set(B))] :
      ( pp(aa(set(A),bool,finite_finite(A),aa(fun(A,bool),set(A),collect(A),aa(fun(A,set(B)),fun(A,bool),aTP_Lamp_iq(set(A),fun(fun(A,set(B)),fun(A,bool)),A4),B3))))
     => ( ! [A8: A] :
            ( pp(member(A,A8,A4))
           => pp(aa(set(B),bool,finite_finite(B),aa(A,set(B),B3,A8))) )
       => pp(aa(set(product_prod(A,B)),bool,finite_finite(product_prod(A,B)),product_Sigma(A,B,A4,B3))) ) ) ).

% finite_SigmaI2
tff(fact_3004_fst__image__Sigma,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: fun(A,set(B))] : ( aa(set(product_prod(A,B)),set(A),image2(product_prod(A,B),A,product_fst(A,B)),product_Sigma(A,B,A4,B3)) = aa(fun(A,bool),set(A),collect(A),aa(fun(A,set(B)),fun(A,bool),aTP_Lamp_iq(set(A),fun(fun(A,set(B)),fun(A,bool)),A4),B3)) ) ).

% fst_image_Sigma
tff(fact_3005_SUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(B,A),A3: B,A4: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),aa(set(B),set(B),insert2(B,A3),A4))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,F,A3)),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))) ) ) ).

% SUP_insert
tff(fact_3006_SUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [M: fun(B,A),A4: set(B),B3: set(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,M),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,M),A4))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,M),B3))) ) ) ).

% SUP_union
tff(fact_3007_refl__on__def,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( refl_on(A,A4,R3)
    <=> ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))))
        & ! [X4: A] :
            ( pp(member(A,X4,A4))
           => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),X4),R3)) ) ) ) ).

% refl_on_def
tff(fact_3008_refl__onI,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))))
     => ( ! [X2: A] :
            ( pp(member(A,X2,A4))
           => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2),R3)) )
       => refl_on(A,A4,R3) ) ) ).

% refl_onI
tff(fact_3009_Refl__Restr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( refl_on(A,field2(A,R3),R3)
     => refl_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) ) ).

% Refl_Restr
tff(fact_3010_Total__Restr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( total_on(A,field2(A,R3),R3)
     => total_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) ) ).

% Total_Restr
tff(fact_3011_total__on__imp__Total__Restr,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( total_on(A,A4,R3)
     => total_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) ) ).

% total_on_imp_Total_Restr
tff(fact_3012_UN__extend__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set(B),A3: A,B3: fun(B,set(A))] :
      ( ( ( C3 = bot_bot(set(B)) )
       => ( aa(set(A),set(A),insert2(A,A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),C3))) = aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))) ) )
      & ( ( C3 != bot_bot(set(B)) )
       => ( aa(set(A),set(A),insert2(A,A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),C3))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_hr(A,fun(fun(B,set(A)),fun(B,set(A))),A3),B3)),C3)) ) ) ) ).

% UN_extend_simps(1)
tff(fact_3013_UN__extend__simps_I2_J,axiom,
    ! [D: $tType,C: $tType,C3: set(C),A4: fun(C,set(D)),B3: set(D)] :
      ( ( ( C3 = bot_bot(set(C)) )
       => ( aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),sup_sup(set(D)),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A4),C3))),B3) = B3 ) )
      & ( ( C3 != bot_bot(set(C)) )
       => ( aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),sup_sup(set(D)),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A4),C3))),B3) = aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),aa(set(D),fun(C,set(D)),aTP_Lamp_ht(fun(C,set(D)),fun(set(D),fun(C,set(D))),A4),B3)),C3)) ) ) ) ).

% UN_extend_simps(2)
tff(fact_3014_UN__extend__simps_I3_J,axiom,
    ! [E: $tType,F8: $tType,C3: set(F8),A4: set(E),B3: fun(F8,set(E))] :
      ( ( ( C3 = bot_bot(set(F8)) )
       => ( aa(set(E),set(E),aa(set(E),fun(set(E),set(E)),sup_sup(set(E)),A4),aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F8),set(set(E)),image2(F8,set(E),B3),C3))) = A4 ) )
      & ( ( C3 != bot_bot(set(F8)) )
       => ( aa(set(E),set(E),aa(set(E),fun(set(E),set(E)),sup_sup(set(E)),A4),aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F8),set(set(E)),image2(F8,set(E),B3),C3))) = aa(set(set(E)),set(E),complete_Sup_Sup(set(E)),aa(set(F8),set(set(E)),image2(F8,set(E),aa(fun(F8,set(E)),fun(F8,set(E)),aTP_Lamp_hs(set(E),fun(fun(F8,set(E)),fun(F8,set(E))),A4),B3)),C3)) ) ) ) ).

% UN_extend_simps(3)
tff(fact_3015_Linear__order__Restr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( order_679001287576687338der_on(A,field2(A,R3),R3)
     => order_679001287576687338der_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) ) ).

% Linear_order_Restr
tff(fact_3016_swap__product,axiom,
    ! [A: $tType,B: $tType,A4: set(B),B3: set(A)] : ( aa(set(product_prod(B,A)),set(product_prod(A,B)),image2(product_prod(B,A),product_prod(A,B),aa(fun(B,fun(A,product_prod(A,B))),fun(product_prod(B,A),product_prod(A,B)),product_case_prod(B,A,product_prod(A,B)),aTP_Lamp_ex(B,fun(A,product_prod(A,B))))),product_Sigma(B,A,A4,aTP_Lamp_ho(set(A),fun(B,set(A)),B3))) = product_Sigma(A,B,B3,aTP_Lamp_hq(set(B),fun(A,set(B)),A4)) ) ).

% swap_product
tff(fact_3017_one__int_Orsp,axiom,
    pp(aa(product_prod(nat,nat),bool,aa(product_prod(nat,nat),fun(product_prod(nat,nat),bool),intrel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),one_one(nat)),zero_zero(nat))),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),one_one(nat)),zero_zero(nat)))) ).

% one_int.rsp
tff(fact_3018_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),T3: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T3))
         => ( ! [X2: B] :
                ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
               => ( aa(B,A,G,X2) = one_one(A) ) )
           => ( ! [X2: B] :
                  ( pp(member(B,X2,S2))
                 => ( aa(B,A,G,X2) = aa(B,A,H2,X2) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),T3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),H2),S2) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
tff(fact_3019_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),T3: set(B),H2: fun(B,A),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T3))
         => ( ! [I3: B] :
                ( pp(member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
               => ( aa(B,A,H2,I3) = one_one(A) ) )
           => ( ! [X2: B] :
                  ( pp(member(B,X2,S2))
                 => ( aa(B,A,G,X2) = aa(B,A,H2,X2) ) )
             => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),H2),T3) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
tff(fact_3020_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),T3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T3))
         => ( ! [X2: B] :
                ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
               => ( aa(B,A,G,X2) = one_one(A) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),T3) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),S2) ) ) ) ) ).

% prod.mono_neutral_right'
tff(fact_3021_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [S2: set(B),T3: set(B),G: fun(B,A)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),S2),T3))
         => ( ! [X2: B] :
                ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
               => ( aa(B,A,G,X2) = one_one(A) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),T3) ) ) ) ) ).

% prod.mono_neutral_left'
tff(fact_3022_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),L: A,E2: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),L))),E2)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(A),A,complete_Sup_Sup(A),S2)),L))),E2)) ) ) ) ).

% cSup_asclose
tff(fact_3023_Sup__fold__sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( aa(set(A),A,complete_Sup_Sup(A),A4) = finite_fold(A,A,sup_sup(A),bot_bot(A),A4) ) ) ) ).

% Sup_fold_sup
tff(fact_3024_sum_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [C3: set(set(B)),G: fun(B,A)] :
          ( ! [X2: set(B)] :
              ( pp(member(set(B),X2,C3))
             => pp(aa(set(B),bool,finite_finite(B),X2)) )
         => ( ! [X2: set(B)] :
                ( pp(member(set(B),X2,C3))
               => ! [Xa4: set(B)] :
                    ( pp(member(set(B),Xa4,C3))
                   => ( ( X2 != Xa4 )
                     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X2),Xa4) = bot_bot(set(B)) ) ) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),aa(fun(fun(set(B),A),fun(set(set(B)),A)),fun(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A))),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A)),groups7311177749621191930dd_sum(set(B),A)),groups7311177749621191930dd_sum(B,A)),G),C3) ) ) ) ) ).

% sum.Union_disjoint
tff(fact_3025_prod_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [C3: set(set(B)),G: fun(B,A)] :
          ( ! [X2: set(B)] :
              ( pp(member(set(B),X2,C3))
             => pp(aa(set(B),bool,finite_finite(B),X2)) )
         => ( ! [X2: set(B)] :
                ( pp(member(set(B),X2,C3))
               => ! [Xa4: set(B)] :
                    ( pp(member(set(B),Xa4,C3))
                   => ( ( X2 != Xa4 )
                     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X2),Xa4) = bot_bot(set(B)) ) ) ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),aa(fun(fun(set(B),A),fun(set(set(B)),A)),fun(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A))),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A)),groups7121269368397514597t_prod(set(B),A)),groups7121269368397514597t_prod(B,A)),G),C3) ) ) ) ) ).

% prod.Union_disjoint
tff(fact_3026_inv__image__def,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(B,B)),F: fun(A,B)] : ( inv_image(B,A,R3,F) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(fun(A,B),fun(A,fun(A,bool)),aTP_Lamp_ir(set(product_prod(B,B)),fun(fun(A,B),fun(A,fun(A,bool))),R3),F))) ) ).

% inv_image_def
tff(fact_3027_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I4: set(B),G: fun(B,A),H2: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_bt(set(B),fun(fun(B,A),fun(B,bool)),I4),G))))
         => ( pp(aa(set(B),bool,finite_finite(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_bt(set(B),fun(fun(B,A),fun(B,bool)),I4),H2))))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_bb(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2)),I4) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),G),I4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),H2),I4)) ) ) ) ) ).

% prod.distrib'
tff(fact_3028_prod_OG__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [I4: set(B),P3: fun(B,A)] :
          ( ( pp(aa(set(B),bool,finite_finite(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_bt(set(B),fun(fun(B,A),fun(B,bool)),I4),P3))))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P3),I4) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),P3),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_bt(set(B),fun(fun(B,A),fun(B,bool)),I4),P3))) ) )
          & ( ~ pp(aa(set(B),bool,finite_finite(B),aa(fun(B,bool),set(B),collect(B),aa(fun(B,A),fun(B,bool),aTP_Lamp_bt(set(B),fun(fun(B,A),fun(B,bool)),I4),P3))))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups1962203154675924110t_prod(B,A),P3),I4) = one_one(A) ) ) ) ) ).

% prod.G_def
tff(fact_3029_Refl__Field__Restr2,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( refl_on(A,field2(A,R3),R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),field2(A,R3)))
       => ( field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) = A4 ) ) ) ).

% Refl_Field_Restr2
tff(fact_3030_Refl__Field__Restr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( refl_on(A,field2(A,R3),R3)
     => ( field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),field2(A,R3)),A4) ) ) ).

% Refl_Field_Restr
tff(fact_3031_image__paired__Times,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: fun(C,A),G: fun(D,B),A4: set(C),B3: set(D)] : ( aa(set(product_prod(C,D)),set(product_prod(A,B)),image2(product_prod(C,D),product_prod(A,B),aa(fun(C,fun(D,product_prod(A,B))),fun(product_prod(C,D),product_prod(A,B)),product_case_prod(C,D,product_prod(A,B)),aa(fun(D,B),fun(C,fun(D,product_prod(A,B))),aTP_Lamp_is(fun(C,A),fun(fun(D,B),fun(C,fun(D,product_prod(A,B)))),F),G))),product_Sigma(C,D,A4,aTP_Lamp_it(set(D),fun(C,set(D)),B3))) = product_Sigma(A,B,aa(set(C),set(A),image2(C,A,F),A4),aa(set(D),fun(A,set(B)),aTP_Lamp_iu(fun(D,B),fun(set(D),fun(A,set(B))),G),B3)) ) ).

% image_paired_Times
tff(fact_3032_UNION__singleton__eq__range,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),A4: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_iv(fun(B,A),fun(B,set(A)),F)),A4)) = aa(set(B),set(A),image2(B,A,F),A4) ) ).

% UNION_singleton_eq_range
tff(fact_3033_Id__on__def,axiom,
    ! [A: $tType,A4: set(A)] : ( id_on(A,A4) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(A),set(set(product_prod(A,A))),image2(A,set(product_prod(A,A)),aTP_Lamp_iw(A,set(product_prod(A,A)))),A4)) ) ).

% Id_on_def
tff(fact_3034_sup__SUP__fold__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(B),B3: A,F: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),B3),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),aa(fun(A,fun(A,A)),fun(fun(B,A),fun(B,fun(A,A))),comp(A,fun(A,A),B),sup_sup(A)),F),B3,A4) ) ) ) ).

% sup_SUP_fold_sup
tff(fact_3035_card__partition,axiom,
    ! [A: $tType,C3: set(set(A)),K: nat] :
      ( pp(aa(set(set(A)),bool,finite_finite(set(A)),C3))
     => ( pp(aa(set(A),bool,finite_finite(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C3)))
       => ( ! [C4: set(A)] :
              ( pp(member(set(A),C4,C3))
             => ( finite_card(A,C4) = K ) )
         => ( ! [C1: set(A),C22: set(A)] :
                ( pp(member(set(A),C1,C3))
               => ( pp(member(set(A),C22,C3))
                 => ( ( C1 != C22 )
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C1),C22) = bot_bot(set(A)) ) ) ) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),finite_card(set(A),C3)) = finite_card(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C3)) ) ) ) ) ) ).

% card_partition
tff(fact_3036_dvd__partition,axiom,
    ! [A: $tType,C3: set(set(A)),K: nat] :
      ( pp(aa(set(A),bool,finite_finite(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C3)))
     => ( ! [X2: set(A)] :
            ( pp(member(set(A),X2,C3))
           => pp(dvd_dvd(nat,K,finite_card(A,X2))) )
       => ( ! [X2: set(A)] :
              ( pp(member(set(A),X2,C3))
             => ! [Xa4: set(A)] :
                  ( pp(member(set(A),Xa4,C3))
                 => ( ( X2 != Xa4 )
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X2),Xa4) = bot_bot(set(A)) ) ) ) )
         => pp(dvd_dvd(nat,K,finite_card(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C3)))) ) ) ) ).

% dvd_partition
tff(fact_3037_sum_OUNION__disjoint,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [I4: set(B),A4: fun(B,set(C)),G: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),I4))
         => ( ! [X2: B] :
                ( pp(member(B,X2,I4))
               => pp(aa(set(C),bool,finite_finite(C),aa(B,set(C),A4,X2))) )
           => ( ! [X2: B] :
                  ( pp(member(B,X2,I4))
                 => ! [Xa4: B] :
                      ( pp(member(B,Xa4,I4))
                     => ( ( X2 != Xa4 )
                       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A4,X2)),aa(B,set(C),A4,Xa4)) = bot_bot(set(C)) ) ) ) )
             => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(C,A),fun(B,A),aTP_Lamp_ix(fun(B,set(C)),fun(fun(C,A),fun(B,A)),A4),G)),I4) ) ) ) ) ) ).

% sum.UNION_disjoint
tff(fact_3038_prod_OUNION__disjoint,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [I4: set(B),A4: fun(B,set(C)),G: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),I4))
         => ( ! [X2: B] :
                ( pp(member(B,X2,I4))
               => pp(aa(set(C),bool,finite_finite(C),aa(B,set(C),A4,X2))) )
           => ( ! [X2: B] :
                  ( pp(member(B,X2,I4))
                 => ! [Xa4: B] :
                      ( pp(member(B,Xa4,I4))
                     => ( ( X2 != Xa4 )
                       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A4,X2)),aa(B,set(C),A4,Xa4)) = bot_bot(set(C)) ) ) ) )
             => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),G),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(C,A),fun(B,A),aTP_Lamp_iy(fun(B,set(C)),fun(fun(C,A),fun(B,A)),A4),G)),I4) ) ) ) ) ) ).

% prod.UNION_disjoint
tff(fact_3039_product__fold,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(aa(set(B),bool,finite_finite(B),B3))
       => ( product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)) = finite_fold(A,set(product_prod(A,B)),aTP_Lamp_ja(set(B),fun(A,fun(set(product_prod(A,B)),set(product_prod(A,B)))),B3),bot_bot(set(product_prod(A,B))),A4) ) ) ) ).

% product_fold
tff(fact_3040_plus__int_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))))) ).

% plus_int.rsp
tff(fact_3041_minus__int_Orsp,axiom,
    pp(aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),bool),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))))) ).

% minus_int.rsp
tff(fact_3042_SUP__fold__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(B),F: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4)) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),aa(fun(A,fun(A,A)),fun(fun(B,A),fun(B,fun(A,A))),comp(A,fun(A,A),B),sup_sup(A)),F),bot_bot(A),A4) ) ) ) ).

% SUP_fold_sup
tff(fact_3043_card__UN__disjoint,axiom,
    ! [B: $tType,A: $tType,I4: set(A),A4: fun(A,set(B))] :
      ( pp(aa(set(A),bool,finite_finite(A),I4))
     => ( ! [X2: A] :
            ( pp(member(A,X2,I4))
           => pp(aa(set(B),bool,finite_finite(B),aa(A,set(B),A4,X2))) )
       => ( ! [X2: A] :
              ( pp(member(A,X2,I4))
             => ! [Xa4: A] :
                  ( pp(member(A,Xa4,I4))
                 => ( ( X2 != Xa4 )
                   => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),A4,X2)),aa(A,set(B),A4,Xa4)) = bot_bot(set(B)) ) ) ) )
         => ( finite_card(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A4),I4))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_jb(fun(A,set(B)),fun(A,nat),A4)),I4) ) ) ) ) ).

% card_UN_disjoint
tff(fact_3044_ccpo__Sup__singleton,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [X: A] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = X ) ) ).

% ccpo_Sup_singleton
tff(fact_3045_linear__order__on__Restr,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X: A] :
      ( order_679001287576687338der_on(A,A4,R3)
     => order_679001287576687338der_on(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),order_above(A,R3,X)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,order_above(A,R3,X),aa(A,fun(A,set(A)),aTP_Lamp_jc(set(product_prod(A,A)),fun(A,fun(A,set(A))),R3),X)))) ) ).

% linear_order_on_Restr
tff(fact_3046_rp__inv__image__def,axiom,
    ! [B: $tType,A: $tType] : ( fun_rp_inv_image(A,B) = aa(fun(set(product_prod(A,A)),fun(set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))))),fun(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))),product_case_prod(set(product_prod(A,A)),set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))),aTP_Lamp_jd(set(product_prod(A,A)),fun(set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))))) ) ).

% rp_inv_image_def
tff(fact_3047_UNION__fun__upd,axiom,
    ! [B: $tType,A: $tType,A4: fun(B,set(A)),I: B,B3: set(A),J4: set(B)] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),fun_upd(B,set(A),A4,I,B3)),J4)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),J4),aa(set(B),set(B),insert2(B,I),bot_bot(set(B))))))),if(set(A),member(B,I,J4),B3,bot_bot(set(A)))) ) ).

% UNION_fun_upd
tff(fact_3048_rtrancl__last__visit__node,axiom,
    ! [A: $tType,S: A,S3: A,R: set(product_prod(A,A)),Sh: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),S),S3),transitive_rtrancl(A,R)))
     => ( ( ( S != Sh )
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),S),S3),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_je(A,fun(A,set(A)),Sh)))))) )
        | ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),S),Sh),transitive_rtrancl(A,R)))
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Sh),S3),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_je(A,fun(A,set(A)),Sh)))))) ) ) ) ).

% rtrancl_last_visit_node
tff(fact_3049_Sup__nat__empty,axiom,
    aa(set(nat),nat,complete_Sup_Sup(nat),bot_bot(set(nat))) = zero_zero(nat) ).

% Sup_nat_empty
tff(fact_3050_rtrancl__empty,axiom,
    ! [A: $tType] : ( transitive_rtrancl(A,bot_bot(set(product_prod(A,A)))) = id2(A) ) ).

% rtrancl_empty
tff(fact_3051_wf__insert,axiom,
    ! [A: $tType,Y: A,X: A,R3: set(product_prod(A,A))] :
      ( wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),X)),R3))
    <=> ( wf(A,R3)
        & ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,R3))) ) ) ).

% wf_insert
tff(fact_3052_UNIV__bool,axiom,
    top_top(set(bool)) = aa(set(bool),set(bool),insert2(bool,fFalse),aa(set(bool),set(bool),insert2(bool,fTrue),bot_bot(set(bool)))) ).

% UNIV_bool
tff(fact_3053_converse__rtrancl__into__rtrancl,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),C2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),C2),transitive_rtrancl(A,R3)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),C2),transitive_rtrancl(A,R3))) ) ) ).

% converse_rtrancl_into_rtrancl
tff(fact_3054_converse__rtrancl__induct,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),P: fun(A,bool)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,R3)))
     => ( pp(aa(A,bool,P,B2))
       => ( ! [Y2: A,Z3: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z3),R3))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z3),B2),transitive_rtrancl(A,R3)))
               => ( pp(aa(A,bool,P,Z3))
                 => pp(aa(A,bool,P,Y2)) ) ) )
         => pp(aa(A,bool,P,A3)) ) ) ) ).

% converse_rtrancl_induct
tff(fact_3055_converse__rtranclE,axiom,
    ! [A: $tType,X: A,Z2: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),transitive_rtrancl(A,R3)))
     => ( ( X != Z2 )
       => ~ ! [Y2: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y2),R3))
             => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z2),transitive_rtrancl(A,R3))) ) ) ) ).

% converse_rtranclE
tff(fact_3056_rtrancl__induct,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),P: fun(A,bool)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,R3)))
     => ( pp(aa(A,bool,P,A3))
       => ( ! [Y2: A,Z3: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),Y2),transitive_rtrancl(A,R3)))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z3),R3))
               => ( pp(aa(A,bool,P,Y2))
                 => pp(aa(A,bool,P,Z3)) ) ) )
         => pp(aa(A,bool,P,B2)) ) ) ) ).

% rtrancl_induct
tff(fact_3057_rtrancl__trans,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A)),Z2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,R3)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),Z2),transitive_rtrancl(A,R3)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),transitive_rtrancl(A,R3))) ) ) ).

% rtrancl_trans
tff(fact_3058_rtranclE,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,R3)))
     => ( ( A3 != B2 )
       => ~ ! [Y2: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),Y2),transitive_rtrancl(A,R3)))
             => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),B2),R3)) ) ) ) ).

% rtranclE
tff(fact_3059_rtrancl_Ortrancl__into__rtrancl,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),C2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,R3)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),C2),R3))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),C2),transitive_rtrancl(A,R3))) ) ) ).

% rtrancl.rtrancl_into_rtrancl
tff(fact_3060_rtrancl_Ortrancl__refl,axiom,
    ! [A: $tType,A3: A,R3: set(product_prod(A,A))] : pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),A3),transitive_rtrancl(A,R3))) ).

% rtrancl.rtrancl_refl
tff(fact_3061_rtrancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A1),A22),transitive_rtrancl(A,R3)))
    <=> ( ? [A6: A] :
            ( ( A1 = A6 )
            & ( A22 = A6 ) )
        | ? [A6: A,B6: A,C5: A] :
            ( ( A1 = A6 )
            & ( A22 = C5 )
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),B6),transitive_rtrancl(A,R3)))
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B6),C5),R3)) ) ) ) ).

% rtrancl.simps
tff(fact_3062_rtrancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A1),A22),transitive_rtrancl(A,R3)))
     => ( ( A22 != A1 )
       => ~ ! [B5: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A1),B5),transitive_rtrancl(A,R3)))
             => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B5),A22),R3)) ) ) ) ).

% rtrancl.cases
tff(fact_3063_converse__rtranclE_H,axiom,
    ! [A: $tType,U: A,V: A,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V),transitive_rtrancl(A,R)))
     => ( ( U != V )
       => ~ ! [Vh: A] :
              ( ( U != Vh )
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),Vh),R))
               => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Vh),V),transitive_rtrancl(A,R))) ) ) ) ) ).

% converse_rtranclE'
tff(fact_3064_fun__upd__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(C,B),G: fun(A,C),X: A,Y: C] : ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),F),fun_upd(A,C,G,X,Y)) = fun_upd(A,B,aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),F),G),X,aa(C,B,F,Y)) ) ).

% fun_upd_comp
tff(fact_3065_rtrancl__Un__separatorE,axiom,
    ! [A: $tType,A3: A,B2: A,P: set(product_prod(A,A)),Q: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),P),Q))))
     => ( ! [X2: A,Y2: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),X2),transitive_rtrancl(A,P)))
           => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),Q))
             => ( X2 = Y2 ) ) )
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,P))) ) ) ).

% rtrancl_Un_separatorE
tff(fact_3066_rtrancl__Un__separator__converseE,axiom,
    ! [A: $tType,A3: A,B2: A,P: set(product_prod(A,A)),Q: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),P),Q))))
     => ( ! [X2: A,Y2: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),B2),transitive_rtrancl(A,P)))
           => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),X2),Q))
             => ( Y2 = X2 ) ) )
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,P))) ) ) ).

% rtrancl_Un_separator_converseE
tff(fact_3067_converse__rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R3: set(product_prod(product_prod(A,B),product_prod(A,B))),P: fun(A,fun(B,bool))] :
      ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Bx),By)),transitive_rtrancl(product_prod(A,B),R3)))
     => ( pp(aa(B,bool,aa(A,fun(B,bool),P,Bx),By))
       => ( ! [A8: A,B5: B,Aa2: A,Ba: B] :
              ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Aa2),Ba)),R3))
             => ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Aa2),Ba)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Bx),By)),transitive_rtrancl(product_prod(A,B),R3)))
               => ( pp(aa(B,bool,aa(A,fun(B,bool),P,Aa2),Ba))
                 => pp(aa(B,bool,aa(A,fun(B,bool),P,A8),B5)) ) ) )
         => pp(aa(B,bool,aa(A,fun(B,bool),P,Ax),Ay)) ) ) ) ).

% converse_rtrancl_induct2
tff(fact_3068_converse__rtranclE2,axiom,
    ! [B: $tType,A: $tType,Xa: A,Xb: B,Za2: A,Zb: B,R3: set(product_prod(product_prod(A,B),product_prod(A,B)))] :
      ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Xa),Xb)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Za2),Zb)),transitive_rtrancl(product_prod(A,B),R3)))
     => ( ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Xa),Xb) != aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Za2),Zb) )
       => ~ ! [A8: A,B5: B] :
              ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Xa),Xb)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),R3))
             => ~ pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Za2),Zb)),transitive_rtrancl(product_prod(A,B),R3))) ) ) ) ).

% converse_rtranclE2
tff(fact_3069_rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R3: set(product_prod(product_prod(A,B),product_prod(A,B))),P: fun(A,fun(B,bool))] :
      ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Bx),By)),transitive_rtrancl(product_prod(A,B),R3)))
     => ( pp(aa(B,bool,aa(A,fun(B,bool),P,Ax),Ay))
       => ( ! [A8: A,B5: B,Aa2: A,Ba: B] :
              ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),transitive_rtrancl(product_prod(A,B),R3)))
             => ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Aa2),Ba)),R3))
               => ( pp(aa(B,bool,aa(A,fun(B,bool),P,A8),B5))
                 => pp(aa(B,bool,aa(A,fun(B,bool),P,Aa2),Ba)) ) ) )
         => pp(aa(B,bool,aa(A,fun(B,bool),P,Bx),By)) ) ) ) ).

% rtrancl_induct2
tff(fact_3070_SUP__Sup__eq2,axiom,
    ! [B: $tType,A: $tType,S2: set(set(product_prod(A,B))),X3: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Sup_Sup(fun(A,fun(B,bool))),aa(set(set(product_prod(A,B))),set(fun(A,fun(B,bool))),image2(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool)))),S2)),X3),Xa3))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),S2))) ) ).

% SUP_Sup_eq2
tff(fact_3071_Sup__SUP__eq2,axiom,
    ! [B: $tType,A: $tType,S2: set(fun(A,fun(B,bool))),X3: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Sup_Sup(fun(A,fun(B,bool))),S2),X3),Xa3))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(fun(product_prod(A,B),bool)),set(set(product_prod(A,B))),image2(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B))),aa(set(fun(A,fun(B,bool))),set(fun(product_prod(A,B),bool)),image2(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool)),S2))))) ) ).

% Sup_SUP_eq2
tff(fact_3072_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),A4: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,R3)))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))))
       => ( ( A3 = B2 )
          | pp(member(A,A3,A4)) ) ) ) ).

% trancl_subset_Sigma_aux
tff(fact_3073_Restr__rtrancl__mono,axiom,
    ! [A: $tType,V: A,W2: A,E4: set(product_prod(A,A)),U2: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),E4),product_Sigma(A,A,U2,aTP_Lamp_if(set(A),fun(A,set(A)),U2))))))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2),transitive_rtrancl(A,E4))) ) ).

% Restr_rtrancl_mono
tff(fact_3074_SUP__UN__eq2,axiom,
    ! [A: $tType,B: $tType,C: $tType,R3: fun(C,set(product_prod(A,B))),S2: set(C),X3: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Sup_Sup(fun(A,fun(B,bool))),aa(set(C),set(fun(A,fun(B,bool))),image2(C,fun(A,fun(B,bool)),aTP_Lamp_jf(fun(C,set(product_prod(A,B))),fun(C,fun(A,fun(B,bool))),R3)),S2)),X3),Xa3))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(C),set(set(product_prod(A,B))),image2(C,set(product_prod(A,B)),R3),S2)))) ) ).

% SUP_UN_eq2
tff(fact_3075_rtrancl__mapI,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: A,E4: set(product_prod(A,A)),F: fun(A,B)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,E4)))
     => pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,F,A3)),aa(A,B,F,B2)),transitive_rtrancl(B,aa(set(product_prod(A,A)),set(product_prod(B,B)),image2(product_prod(A,A),product_prod(B,B),pairself(A,B,F)),E4)))) ) ).

% rtrancl_mapI
tff(fact_3076_above__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] : ( order_above(A,R3,A3) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3),A3)) ) ).

% above_def
tff(fact_3077_rtrancl__Int__subset,axiom,
    ! [A: $tType,S: set(product_prod(A,A)),R3: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),id2(A)),S))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),transitive_rtrancl(A,R3)),S),R3)),S))
       => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),transitive_rtrancl(A,R3)),S)) ) ) ).

% rtrancl_Int_subset
tff(fact_3078_rtrancl__last__touch,axiom,
    ! [A: $tType,Q3: A,Q5: A,R: set(product_prod(A,A)),S2: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Q5),transitive_rtrancl(A,R)))
     => ( pp(member(A,Q3,S2))
       => ~ ! [Qt: A] :
              ( pp(member(A,Qt,S2))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Qt),transitive_rtrancl(A,R)))
               => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Qt),Q5),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_if(set(A),fun(A,set(A)),S2)))))) ) ) ) ) ).

% rtrancl_last_touch
tff(fact_3079_rtrancl__last__visit_H,axiom,
    ! [A: $tType,Q3: A,Q5: A,R: set(product_prod(A,A)),S2: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Q5),transitive_rtrancl(A,R)))
     => ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Q5),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_if(set(A),fun(A,set(A)),S2))))))
       => ~ ! [Qt: A] :
              ( pp(member(A,Qt,S2))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Qt),transitive_rtrancl(A,R)))
               => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Qt),Q5),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_if(set(A),fun(A,set(A)),S2)))))) ) ) ) ) ).

% rtrancl_last_visit'
tff(fact_3080_rtrancl__insert,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A))] : ( transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2)),R3)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_rtrancl(A,R3)),aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool))),aTP_Lamp_jg(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool)))),A3),B2),R3)))) ) ).

% rtrancl_insert
tff(fact_3081_fun__upd__image,axiom,
    ! [A: $tType,B: $tType,X: B,A4: set(B),F: fun(B,A),Y: A] :
      ( ( pp(member(B,X,A4))
       => ( aa(set(B),set(A),image2(B,A,fun_upd(B,A,F,X,Y)),A4) = aa(set(A),set(A),insert2(A,Y),aa(set(B),set(A),image2(B,A,F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) )
      & ( ~ pp(member(B,X,A4))
       => ( aa(set(B),set(A),image2(B,A,fun_upd(B,A,F,X,Y)),A4) = aa(set(B),set(A),image2(B,A,F),A4) ) ) ) ).

% fun_upd_image
tff(fact_3082_subset__mset_OcSUP__const,axiom,
    ! [B: $tType,A: $tType,A4: set(B),C2: multiset(A)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),aTP_Lamp_jh(multiset(A),fun(B,multiset(A)),C2)),A4)) = C2 ) ) ).

% subset_mset.cSUP_const
tff(fact_3083_Pow__fold,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pow(A,A4) = finite_fold(A,set(set(A)),aTP_Lamp_ji(A,fun(set(set(A)),set(set(A)))),aa(set(set(A)),set(set(A)),insert2(set(A),bot_bot(set(A))),bot_bot(set(set(A)))),A4) ) ) ).

% Pow_fold
tff(fact_3084_chains__extend,axiom,
    ! [A: $tType,C2: set(set(A)),S2: set(set(A)),Z2: set(A)] :
      ( pp(member(set(set(A)),C2,chains2(A,S2)))
     => ( pp(member(set(A),Z2,S2))
       => ( ! [X2: set(A)] :
              ( pp(member(set(A),X2,C2))
             => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X2),Z2)) )
         => pp(member(set(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),aa(set(set(A)),set(set(A)),insert2(set(A),Z2),bot_bot(set(set(A))))),C2),chains2(A,S2))) ) ) ) ).

% chains_extend
tff(fact_3085_rtrancl__restrictI,axiom,
    ! [A: $tType,U: A,V: A,E4: set(product_prod(A,A)),R: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),E4),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_if(set(A),fun(A,set(A)),R))))))
     => ( ~ pp(member(A,U,R))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V),transitive_rtrancl(A,rel_restrict(A,E4,R)))) ) ) ).

% rtrancl_restrictI
tff(fact_3086_image__split__eq__Sigma,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(C,A),G: fun(C,B),A4: set(C)] : ( aa(set(C),set(product_prod(A,B)),image2(C,product_prod(A,B),aa(fun(C,B),fun(C,product_prod(A,B)),aTP_Lamp_jj(fun(C,A),fun(fun(C,B),fun(C,product_prod(A,B))),F),G)),A4) = product_Sigma(A,B,aa(set(C),set(A),image2(C,A,F),A4),aa(set(C),fun(A,set(B)),aa(fun(C,B),fun(set(C),fun(A,set(B))),aTP_Lamp_jk(fun(C,A),fun(fun(C,B),fun(set(C),fun(A,set(B)))),F),G),A4)) ) ).

% image_split_eq_Sigma
tff(fact_3087_subset__mset_OcSup__singleton,axiom,
    ! [A: $tType,X: multiset(A)] : ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) = X ) ).

% subset_mset.cSup_singleton
tff(fact_3088_vimage__empty,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),bot_bot(set(B))) = bot_bot(set(A)) ) ).

% vimage_empty
tff(fact_3089_vimage__Int,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B),A4: set(B),B3: set(B)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),A4)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),B3)) ) ).

% vimage_Int
tff(fact_3090_rel__restrict__empty,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( rel_restrict(A,R,bot_bot(set(A))) = R ) ).

% rel_restrict_empty
tff(fact_3091_vimage__const,axiom,
    ! [B: $tType,A: $tType,C2: B,A4: set(B)] :
      ( ( pp(member(B,C2,A4))
       => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aTP_Lamp_bv(B,fun(A,B),C2)),A4) = top_top(set(A)) ) )
      & ( ~ pp(member(B,C2,A4))
       => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aTP_Lamp_bv(B,fun(A,B),C2)),A4) = bot_bot(set(A)) ) ) ) ).

% vimage_const
tff(fact_3092_Pow__Int__eq,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( pow(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) = aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),pow(A,A4)),pow(A,B3)) ) ).

% Pow_Int_eq
tff(fact_3093_image__vimage__eq,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),A4: set(A)] : ( aa(set(B),set(A),image2(B,A,F),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F),A4)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(B),set(A),image2(B,A,F),top_top(set(B)))) ) ).

% image_vimage_eq
tff(fact_3094_vimage__if,axiom,
    ! [B: $tType,A: $tType,C2: B,A4: set(B),D2: B,B3: set(A)] :
      ( ( pp(member(B,C2,A4))
       => ( ( pp(member(B,D2,A4))
           => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aa(set(A),fun(A,B),aa(B,fun(set(A),fun(A,B)),aTP_Lamp_jl(B,fun(B,fun(set(A),fun(A,B))),C2),D2),B3)),A4) = top_top(set(A)) ) )
          & ( ~ pp(member(B,D2,A4))
           => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aa(set(A),fun(A,B),aa(B,fun(set(A),fun(A,B)),aTP_Lamp_jl(B,fun(B,fun(set(A),fun(A,B))),C2),D2),B3)),A4) = B3 ) ) ) )
      & ( ~ pp(member(B,C2,A4))
       => ( ( pp(member(B,D2,A4))
           => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aa(set(A),fun(A,B),aa(B,fun(set(A),fun(A,B)),aTP_Lamp_jl(B,fun(B,fun(set(A),fun(A,B))),C2),D2),B3)),A4) = aa(set(A),set(A),uminus_uminus(set(A)),B3) ) )
          & ( ~ pp(member(B,D2,A4))
           => ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aa(set(A),fun(A,B),aa(B,fun(set(A),fun(A,B)),aTP_Lamp_jl(B,fun(B,fun(set(A),fun(A,B))),C2),D2),B3)),A4) = bot_bot(set(A)) ) ) ) ) ) ).

% vimage_if
tff(fact_3095_Pow__singleton__iff,axiom,
    ! [A: $tType,X6: set(A),Y5: set(A)] :
      ( ( pow(A,X6) = aa(set(set(A)),set(set(A)),insert2(set(A),Y5),bot_bot(set(set(A)))) )
    <=> ( ( X6 = bot_bot(set(A)) )
        & ( Y5 = bot_bot(set(A)) ) ) ) ).

% Pow_singleton_iff
tff(fact_3096_Pow__empty,axiom,
    ! [A: $tType] : ( pow(A,bot_bot(set(A))) = aa(set(set(A)),set(set(A)),insert2(set(A),bot_bot(set(A))),bot_bot(set(set(A)))) ) ).

% Pow_empty
tff(fact_3097_vimage__inter__cong,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,B),G: fun(A,B),Y: set(B)] :
      ( ! [W: A] :
          ( pp(member(A,W,S2))
         => ( aa(A,B,F,W) = aa(A,B,G,W) ) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),Y)),S2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),G),Y)),S2) ) ) ).

% vimage_inter_cong
tff(fact_3098_Sup__multiset__empty,axiom,
    ! [A: $tType] : ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),bot_bot(set(multiset(A)))) = zero_zero(multiset(A)) ) ).

% Sup_multiset_empty
tff(fact_3099_vimage__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(A,B),G: fun(B,C),X: set(C)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),G),X)) = aa(set(C),set(A),aa(fun(A,C),fun(set(C),set(A)),vimage(A,C),aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),G),F)),X) ) ).

% vimage_comp
tff(fact_3100_set_Ocompositionality,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(C,B),G: fun(B,A),Set: set(A)] : ( aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),F),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),G),Set)) = aa(set(A),set(C),aa(fun(C,A),fun(set(A),set(C)),vimage(C,A),aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),G),F)),Set) ) ).

% set.compositionality
tff(fact_3101_Pow__bottom,axiom,
    ! [A: $tType,B3: set(A)] : pp(member(set(A),bot_bot(set(A)),pow(A,B3))) ).

% Pow_bottom
tff(fact_3102_rel__restrict__notR_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,A4: set(product_prod(A,A)),R: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),rel_restrict(A,A4,R)))
     => ~ pp(member(A,Y,R)) ) ).

% rel_restrict_notR(2)
tff(fact_3103_rel__restrict__notR_I1_J,axiom,
    ! [A: $tType,X: A,Y: A,A4: set(product_prod(A,A)),R: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),rel_restrict(A,A4,R)))
     => ~ pp(member(A,X,R)) ) ).

% rel_restrict_notR(1)
tff(fact_3104_rel__restrictI,axiom,
    ! [A: $tType,X: A,R: set(A),Y: A,E4: set(product_prod(A,A))] :
      ( ~ pp(member(A,X,R))
     => ( ~ pp(member(A,Y,R))
       => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),E4))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),rel_restrict(A,E4,R))) ) ) ) ).

% rel_restrictI
tff(fact_3105_rel__restrict__lift,axiom,
    ! [A: $tType,X: A,Y: A,E4: set(product_prod(A,A)),R: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),rel_restrict(A,E4,R)))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),E4)) ) ).

% rel_restrict_lift
tff(fact_3106_Pow__not__empty,axiom,
    ! [A: $tType,A4: set(A)] : ( pow(A,A4) != bot_bot(set(set(A))) ) ).

% Pow_not_empty
tff(fact_3107_vimage__singleton__eq,axiom,
    ! [A: $tType,B: $tType,A3: A,F: fun(A,B),B2: B] :
      ( pp(member(A,A3,aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),aa(set(B),set(B),insert2(B,B2),bot_bot(set(B))))))
    <=> ( aa(A,B,F,A3) = B2 ) ) ).

% vimage_singleton_eq
tff(fact_3108_vimage__Times,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(A,product_prod(B,C)),A4: set(B),B3: set(C)] : ( aa(set(product_prod(B,C)),set(A),aa(fun(A,product_prod(B,C)),fun(set(product_prod(B,C)),set(A)),vimage(A,product_prod(B,C)),F),product_Sigma(B,C,A4,aTP_Lamp_jm(set(C),fun(B,set(C)),B3))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),aa(fun(A,product_prod(B,C)),fun(A,B),aa(fun(product_prod(B,C),B),fun(fun(A,product_prod(B,C)),fun(A,B)),comp(product_prod(B,C),B,A),product_fst(B,C)),F)),A4)),aa(set(C),set(A),aa(fun(A,C),fun(set(C),set(A)),vimage(A,C),aa(fun(A,product_prod(B,C)),fun(A,C),aa(fun(product_prod(B,C),C),fun(fun(A,product_prod(B,C)),fun(A,C)),comp(product_prod(B,C),C,A),product_snd(B,C)),F)),B3)) ) ).

% vimage_Times
tff(fact_3109_set_Ocomp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(C,B),G: fun(B,A)] : ( aa(fun(set(A),set(B)),fun(set(A),set(C)),aa(fun(set(B),set(C)),fun(fun(set(A),set(B)),fun(set(A),set(C))),comp(set(B),set(C),set(A)),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),F)),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),G)) = aa(fun(C,A),fun(set(A),set(C)),vimage(C,A),aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),G),F)) ) ).

% set.comp
tff(fact_3110_Pair__vimage__Sigma,axiom,
    ! [B: $tType,A: $tType,X: B,A4: set(B),F: fun(B,set(A))] :
      ( ( pp(member(B,X,A4))
       => ( aa(set(product_prod(B,A)),set(A),aa(fun(A,product_prod(B,A)),fun(set(product_prod(B,A)),set(A)),vimage(A,product_prod(B,A)),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X)),product_Sigma(B,A,A4,F)) = aa(B,set(A),F,X) ) )
      & ( ~ pp(member(B,X,A4))
       => ( aa(set(product_prod(B,A)),set(A),aa(fun(A,product_prod(B,A)),fun(set(product_prod(B,A)),set(A)),vimage(A,product_prod(B,A)),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X)),product_Sigma(B,A,A4,F)) = bot_bot(set(A)) ) ) ) ).

% Pair_vimage_Sigma
tff(fact_3111_surj__vimage__empty,axiom,
    ! [B: $tType,A: $tType,F: fun(B,A),A4: set(A)] :
      ( ( aa(set(B),set(A),image2(B,A,F),top_top(set(B))) = top_top(set(A)) )
     => ( ( aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F),A4) = bot_bot(set(B)) )
      <=> ( A4 = bot_bot(set(A)) ) ) ) ).

% surj_vimage_empty
tff(fact_3112_vimage__insert,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B),A3: B,B3: set(B)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),aa(set(B),set(B),insert2(B,A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),B3)) ) ).

% vimage_insert
tff(fact_3113_finite__vimage__IntI,axiom,
    ! [A: $tType,B: $tType,F2: set(A),H2: fun(B,A),A4: set(B)] :
      ( pp(aa(set(A),bool,finite_finite(A),F2))
     => ( inj_on(B,A,H2,A4)
       => pp(aa(set(B),bool,finite_finite(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),H2),F2)),A4))) ) ) ).

% finite_vimage_IntI
tff(fact_3114_rel__restrict__def,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),A4: set(A)] : ( rel_restrict(A,R,A4) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(A),fun(A,fun(A,bool)),aTP_Lamp_jn(set(product_prod(A,A)),fun(set(A),fun(A,fun(A,bool))),R),A4))) ) ).

% rel_restrict_def
tff(fact_3115_inf__img__fin__domE,axiom,
    ! [B: $tType,A: $tType,F: fun(B,A),A4: set(B)] :
      ( pp(aa(set(A),bool,finite_finite(A),aa(set(B),set(A),image2(B,A,F),A4)))
     => ( ~ pp(aa(set(B),bool,finite_finite(B),A4))
       => ~ ! [Y2: A] :
              ( pp(member(A,Y2,aa(set(B),set(A),image2(B,A,F),A4)))
             => pp(aa(set(B),bool,finite_finite(B),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F),aa(set(A),set(A),insert2(A,Y2),bot_bot(set(A)))))) ) ) ) ).

% inf_img_fin_domE
tff(fact_3116_inf__img__fin__dom,axiom,
    ! [B: $tType,A: $tType,F: fun(B,A),A4: set(B)] :
      ( pp(aa(set(A),bool,finite_finite(A),aa(set(B),set(A),image2(B,A,F),A4)))
     => ( ~ pp(aa(set(B),bool,finite_finite(B),A4))
       => ? [X2: A] :
            ( pp(member(A,X2,aa(set(B),set(A),image2(B,A,F),A4)))
            & ~ pp(aa(set(B),bool,finite_finite(B),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F),aa(set(A),set(A),insert2(A,X2),bot_bot(set(A)))))) ) ) ) ).

% inf_img_fin_dom
tff(fact_3117_finite__finite__vimage__IntI,axiom,
    ! [A: $tType,B: $tType,F2: set(A),H2: fun(B,A),A4: set(B)] :
      ( pp(aa(set(A),bool,finite_finite(A),F2))
     => ( ! [Y2: A] :
            ( pp(member(A,Y2,F2))
           => pp(aa(set(B),bool,finite_finite(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),H2),aa(set(A),set(A),insert2(A,Y2),bot_bot(set(A))))),A4))) )
       => pp(aa(set(B),bool,finite_finite(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),H2),F2)),A4))) ) ) ).

% finite_finite_vimage_IntI
tff(fact_3118_rel__restrict__Int__empty,axiom,
    ! [A: $tType,A4: set(A),R: set(product_prod(A,A))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),field2(A,R)) = bot_bot(set(A)) )
     => ( rel_restrict(A,R,A4) = R ) ) ).

% rel_restrict_Int_empty
tff(fact_3119_vimage__eq__UN,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B),B3: set(B)] : ( aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),B3) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_jo(fun(A,B),fun(B,set(A)),F)),B3)) ) ).

% vimage_eq_UN
tff(fact_3120_rel__restrict__compl,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),A4: set(A)] : ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),rel_restrict(A,R,A4)),rel_restrict(A,R,aa(set(A),set(A),uminus_uminus(set(A)),A4))) = bot_bot(set(product_prod(A,A))) ) ).

% rel_restrict_compl
tff(fact_3121_inf__img__fin__domE_H,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),A4: set(B)] :
      ( pp(aa(set(A),bool,finite_finite(A),aa(set(B),set(A),image2(B,A,F),A4)))
     => ( ~ pp(aa(set(B),bool,finite_finite(B),A4))
       => ~ ! [Y2: A] :
              ( pp(member(A,Y2,aa(set(B),set(A),image2(B,A,F),A4)))
             => pp(aa(set(B),bool,finite_finite(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F),aa(set(A),set(A),insert2(A,Y2),bot_bot(set(A))))),A4))) ) ) ) ).

% inf_img_fin_domE'
tff(fact_3122_inf__img__fin__dom_H,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),A4: set(B)] :
      ( pp(aa(set(A),bool,finite_finite(A),aa(set(B),set(A),image2(B,A,F),A4)))
     => ( ~ pp(aa(set(B),bool,finite_finite(B),A4))
       => ? [X2: A] :
            ( pp(member(A,X2,aa(set(B),set(A),image2(B,A,F),A4)))
            & ~ pp(aa(set(B),bool,finite_finite(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F),aa(set(A),set(A),insert2(A,X2),bot_bot(set(A))))),A4))) ) ) ) ).

% inf_img_fin_dom'
tff(fact_3123_rel__restrict__alt__def,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),A4: set(A)] : ( rel_restrict(A,R,A4) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R),product_Sigma(A,A,aa(set(A),set(A),uminus_uminus(set(A)),A4),aTP_Lamp_jp(set(A),fun(A,set(A)),A4))) ) ).

% rel_restrict_alt_def
tff(fact_3124_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B),D4: set(A),A4: set(B)] :
      ( inj_on(A,B,F,D4)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),A4)),D4))),finite_card(B,A4))) ) ) ).

% card_vimage_inj_on_le
tff(fact_3125_Fpow__Pow__finite,axiom,
    ! [A: $tType,A4: set(A)] : ( finite_Fpow(A,A4) = aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),pow(A,A4)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),finite_finite(A))) ) ).

% Fpow_Pow_finite
tff(fact_3126_inj__on__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),A4: set(A),A3: B] :
      ( inj_on(A,B,F,A4)
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))),A4)),aa(set(A),set(A),insert2(A,the(A,aa(B,fun(A,bool),aa(set(A),fun(B,fun(A,bool)),aTP_Lamp_jq(fun(A,B),fun(set(A),fun(B,fun(A,bool))),F),A4),A3))),bot_bot(set(A))))) ) ).

% inj_on_vimage_singleton
tff(fact_3127_inj__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),A3: B] :
      ( inj_on(A,B,F,top_top(set(A)))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),F),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))),aa(set(A),set(A),insert2(A,the(A,aa(B,fun(A,bool),aTP_Lamp_jr(fun(A,B),fun(B,fun(A,bool)),F),A3))),bot_bot(set(A))))) ) ).

% inj_vimage_singleton
tff(fact_3128_comp__fun__idem__on_Ocomp__comp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set(A),F: fun(A,fun(B,B)),G: fun(C,A),R: set(C)] :
      ( finite673082921795544331dem_on(A,B,S2,F)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(C),set(A),image2(C,A,G),top_top(set(C)))),S2))
       => finite673082921795544331dem_on(C,B,R,aa(fun(C,A),fun(C,fun(B,B)),aa(fun(A,fun(B,B)),fun(fun(C,A),fun(C,fun(B,B))),comp(A,fun(B,B),C),F),G)) ) ) ).

% comp_fun_idem_on.comp_comp_fun_idem_on
tff(fact_3129_ref__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: A] : hoare_hoare_triple(ref(A),one_one(assn),ref_ref(A,X),aa(A,fun(ref(A),assn),aTP_Lamp_bj(A,fun(ref(A),assn)),X)) ) ).

% ref_rule
tff(fact_3130_The__split__eq,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] : ( the(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(B,fun(A,fun(B,bool)),aTP_Lamp_js(A,fun(B,fun(A,fun(B,bool))),X),Y))) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y) ) ).

% The_split_eq
tff(fact_3131_comp__fun__idem__on_Ocomp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B)),X: A] :
      ( finite673082921795544331dem_on(A,B,S2,F)
     => ( pp(member(A,X,S2))
       => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X)),aa(A,fun(B,B),F,X)) = aa(A,fun(B,B),F,X) ) ) ) ).

% comp_fun_idem_on.comp_fun_idem_on
tff(fact_3132_empty__in__Fpow,axiom,
    ! [A: $tType,A4: set(A)] : pp(member(set(A),bot_bot(set(A)),finite_Fpow(A,A4))) ).

% empty_in_Fpow
tff(fact_3133_Fpow__not__empty,axiom,
    ! [A: $tType,A4: set(A)] : ( finite_Fpow(A,A4) != bot_bot(set(set(A))) ) ).

% Fpow_not_empty
tff(fact_3134_the__elem__def,axiom,
    ! [A: $tType,X6: set(A)] : ( the_elem(A,X6) = the(A,aTP_Lamp_jt(set(A),fun(A,bool),X6)) ) ).

% the_elem_def
tff(fact_3135_image__o__collect,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: fun(C,B),F2: set(fun(A,set(C)))] : ( bNF_collect(A,B,aa(set(fun(A,set(C))),set(fun(A,set(B))),image2(fun(A,set(C)),fun(A,set(B)),aa(fun(set(C),set(B)),fun(fun(A,set(C)),fun(A,set(B))),comp(set(C),set(B),A),image2(C,B,G))),F2)) = aa(fun(A,set(C)),fun(A,set(B)),aa(fun(set(C),set(B)),fun(fun(A,set(C)),fun(A,set(B))),comp(set(C),set(B),A),image2(C,B,G)),bNF_collect(A,C,F2)) ) ).

% image_o_collect
tff(fact_3136_of__list__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Xs: list(A)] : hoare_hoare_triple(array(A),one_one(assn),array_of_list(A,Xs),aa(list(A),fun(array(A),assn),aTP_Lamp_bk(list(A),fun(array(A),assn)),Xs)) ) ).

% of_list_rule
tff(fact_3137_INT__simps_I4_J,axiom,
    ! [G2: $tType,H9: $tType,C3: set(H9),A4: set(G2),B3: fun(H9,set(G2))] :
      ( ( ( C3 = bot_bot(set(H9)) )
       => ( aa(set(set(G2)),set(G2),complete_Inf_Inf(set(G2)),aa(set(H9),set(set(G2)),image2(H9,set(G2),aa(fun(H9,set(G2)),fun(H9,set(G2)),aTP_Lamp_ju(set(G2),fun(fun(H9,set(G2)),fun(H9,set(G2))),A4),B3)),C3)) = top_top(set(G2)) ) )
      & ( ( C3 != bot_bot(set(H9)) )
       => ( aa(set(set(G2)),set(G2),complete_Inf_Inf(set(G2)),aa(set(H9),set(set(G2)),image2(H9,set(G2),aa(fun(H9,set(G2)),fun(H9,set(G2)),aTP_Lamp_ju(set(G2),fun(fun(H9,set(G2)),fun(H9,set(G2))),A4),B3)),C3)) = aa(set(G2),set(G2),aa(set(G2),fun(set(G2),set(G2)),minus_minus(set(G2)),A4),aa(set(set(G2)),set(G2),complete_Sup_Sup(set(G2)),aa(set(H9),set(set(G2)),image2(H9,set(G2),B3),C3))) ) ) ) ).

% INT_simps(4)
tff(fact_3138_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [F: fun(A,B),G: fun(C,B),A4: set(A),B3: set(C)] :
          ( inj_on(product_prod(A,C),B,aa(fun(A,fun(C,B)),fun(product_prod(A,C),B),product_case_prod(A,C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_az(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),F),G)),product_Sigma(A,C,A4,aTP_Lamp_jv(set(C),fun(A,set(C)),B3)))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F),A4)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),B3)) = aa(set(B),B,aa(fun(B,B),fun(set(B),B),groups7311177749621191930dd_sum(B,B),id(B)),aa(fun(B,bool),set(B),collect(B),aa(set(C),fun(B,bool),aa(set(A),fun(set(C),fun(B,bool)),aa(fun(C,B),fun(set(A),fun(set(C),fun(B,bool))),aTP_Lamp_jw(fun(A,B),fun(fun(C,B),fun(set(A),fun(set(C),fun(B,bool)))),F),G),A4),B3))) ) ) ) ).

% sum_mult_sum_if_inj
tff(fact_3139_card__UNION,axiom,
    ! [A: $tType,A4: set(set(A))] :
      ( pp(aa(set(set(A)),bool,finite_finite(set(A)),A4))
     => ( ! [X2: set(A)] :
            ( pp(member(set(A),X2,A4))
           => pp(aa(set(A),bool,finite_finite(A),X2)) )
       => ( finite_card(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A4)) = aa(int,nat,nat2,aa(set(set(set(A))),int,aa(fun(set(set(A)),int),fun(set(set(set(A))),int),groups7311177749621191930dd_sum(set(set(A)),int),aTP_Lamp_jx(set(set(A)),int)),aa(fun(set(set(A)),bool),set(set(set(A))),collect(set(set(A))),aTP_Lamp_jy(set(set(A)),fun(set(set(A)),bool),A4)))) ) ) ) ).

% card_UNION
tff(fact_3140_ex__assn__proper,axiom,
    ! [A: $tType,P: fun(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool))] :
      ( ! [X2: A] : pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool),P,X2)))
     => pp(aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),bool,proper,aTP_Lamp_jz(fun(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),fun(product_prod(heap_ext(product_unit),set(nat)),bool),P))) ) ).

% ex_assn_proper
tff(fact_3141_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A4: set(A)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),A4) = bot_bot(A) )
        <=> ! [X4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),bot_bot(A)),X4))
             => ? [Xa2: A] :
                  ( pp(member(A,Xa2,A4))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Xa2),X4)) ) ) ) ) ).

% Inf_eq_bot_iff
tff(fact_3142_Inf__empty,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(A),A,complete_Inf_Inf(A),bot_bot(set(A))) = top_top(A) ) ) ).

% Inf_empty
tff(fact_3143_Inf__UNIV,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(A),A,complete_Inf_Inf(A),top_top(set(A))) = bot_bot(A) ) ) ).

% Inf_UNIV
tff(fact_3144_cInf__singleton,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X: A] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = X ) ) ).

% cInf_singleton
tff(fact_3145_Inf__insert,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: A,A4: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert2(A,A3),A4)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(set(A),A,complete_Inf_Inf(A),A4)) ) ) ).

% Inf_insert
tff(fact_3146_Inf__atMost,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X: A] : ( aa(set(A),A,complete_Inf_Inf(A),set_ord_atMost(A,X)) = bot_bot(A) ) ) ).

% Inf_atMost
tff(fact_3147_cINF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),C2: A] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hm(A,fun(B,A),C2)),A4)) = C2 ) ) ) ).

% cINF_const
tff(fact_3148_INF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(B),F: A] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hn(A,fun(B,A),F)),A4)) = F ) ) ) ).

% INF_const
tff(fact_3149_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F: fun(B,A),A4: set(B)] :
          ( ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4)) = bot_bot(A) )
        <=> ! [X4: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),bot_bot(A)),X4))
             => ? [Xa2: B] :
                  ( pp(member(B,Xa2,A4))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F,Xa2)),X4)) ) ) ) ) ).

% INF_eq_bot_iff
tff(fact_3150_INT__constant,axiom,
    ! [B: $tType,A: $tType,A4: set(B),C2: set(A)] :
      ( ( ( A4 = bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_ho(set(A),fun(B,set(A)),C2)),A4)) = top_top(set(A)) ) )
      & ( ( A4 != bot_bot(set(B)) )
       => ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_ho(set(A),fun(B,set(A)),C2)),A4)) = C2 ) ) ) ).

% INT_constant
tff(fact_3151_INT__insert,axiom,
    ! [A: $tType,B: $tType,B3: fun(B,set(A)),A3: B,A4: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),aa(set(B),set(B),insert2(B,A3),A4))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(B,set(A),B3,A3)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),A4))) ) ).

% INT_insert
tff(fact_3152_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),top_top(A)),X))
         => ( aa(set(A),A,complete_Inf_Inf(A),set_ord_lessThan(A,X)) = bot_bot(A) ) ) ) ).

% Inf_atMostLessThan
tff(fact_3153_INT__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set(D),A4: set(C),B3: fun(D,set(C))] :
      ( ( ( C3 = bot_bot(set(D)) )
       => ( aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),aa(fun(D,set(C)),fun(D,set(C)),aTP_Lamp_ka(set(C),fun(fun(D,set(C)),fun(D,set(C))),A4),B3)),C3)) = top_top(set(C)) ) )
      & ( ( C3 != bot_bot(set(D)) )
       => ( aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),aa(fun(D,set(C)),fun(D,set(C)),aTP_Lamp_ka(set(C),fun(fun(D,set(C)),fun(D,set(C))),A4),B3)),C3)) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B3),C3))) ) ) ) ).

% INT_simps(2)
tff(fact_3154_INT__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C3: set(A),A4: fun(A,set(B)),B3: set(B)] :
      ( ( ( C3 = bot_bot(set(A)) )
       => ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_kb(fun(A,set(B)),fun(set(B),fun(A,set(B))),A4),B3)),C3)) = top_top(set(B)) ) )
      & ( ( C3 != bot_bot(set(A)) )
       => ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_kb(fun(A,set(B)),fun(set(B),fun(A,set(B))),A4),B3)),C3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A4),C3))),B3) ) ) ) ).

% INT_simps(1)
tff(fact_3155_INT__simps_I3_J,axiom,
    ! [E: $tType,F8: $tType,C3: set(E),A4: fun(E,set(F8)),B3: set(F8)] :
      ( ( ( C3 = bot_bot(set(E)) )
       => ( aa(set(set(F8)),set(F8),complete_Inf_Inf(set(F8)),aa(set(E),set(set(F8)),image2(E,set(F8),aa(set(F8),fun(E,set(F8)),aTP_Lamp_kc(fun(E,set(F8)),fun(set(F8),fun(E,set(F8))),A4),B3)),C3)) = top_top(set(F8)) ) )
      & ( ( C3 != bot_bot(set(E)) )
       => ( aa(set(set(F8)),set(F8),complete_Inf_Inf(set(F8)),aa(set(E),set(set(F8)),image2(E,set(F8),aa(set(F8),fun(E,set(F8)),aTP_Lamp_kc(fun(E,set(F8)),fun(set(F8),fun(E,set(F8))),A4),B3)),C3)) = aa(set(F8),set(F8),aa(set(F8),fun(set(F8),set(F8)),minus_minus(set(F8)),aa(set(set(F8)),set(F8),complete_Inf_Inf(set(F8)),aa(set(E),set(set(F8)),image2(E,set(F8),A4),C3))),B3) ) ) ) ).

% INT_simps(3)
tff(fact_3156_pairself__image__eq,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),P: fun(B,fun(B,bool))] : ( aa(set(product_prod(B,B)),set(product_prod(A,A)),image2(product_prod(B,B),product_prod(A,A),pairself(B,A,F)),aa(fun(product_prod(B,B),bool),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,bool)),fun(product_prod(B,B),bool),product_case_prod(B,B,bool),P))) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(B,fun(B,bool)),fun(product_prod(A,A),bool),aTP_Lamp_kd(fun(B,A),fun(fun(B,fun(B,bool)),fun(product_prod(A,A),bool)),F),P)) ) ).

% pairself_image_eq
tff(fact_3157_euclidean__size__int__def,axiom,
    euclid6346220572633701492n_size(int) = aa(fun(int,int),fun(int,nat),aa(fun(int,nat),fun(fun(int,int),fun(int,nat)),comp(int,nat,int),nat2),abs_abs(int)) ).

% euclidean_size_int_def
tff(fact_3158_num__of__integer_Orsp,axiom,
    pp(aa(fun(int,num),bool,aa(fun(int,num),fun(fun(int,num),bool),bNF_rel_fun(int,int,num,num,fequal(int),fequal(num)),aa(fun(int,nat),fun(int,num),aa(fun(nat,num),fun(fun(int,nat),fun(int,num)),comp(nat,num,int),num_of_nat),nat2)),aa(fun(int,nat),fun(int,num),aa(fun(nat,num),fun(fun(int,nat),fun(int,num)),comp(nat,num,int),num_of_nat),nat2))) ).

% num_of_integer.rsp
tff(fact_3159_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A),U: A] :
          ( ! [V3: A] :
              ( pp(member(A,V3,A4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),V3),U)) )
         => ( ( A4 != bot_bot(set(A)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A4)),U)) ) ) ) ).

% Inf_less_eq
tff(fact_3160_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),A3: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,X6))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X2)) )
           => ( ! [Y2: A] :
                  ( ! [X3: A] :
                      ( pp(member(A,X3,X6))
                     => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X3)) )
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),A3)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),X6) = A3 ) ) ) ) ) ).

% cInf_eq_non_empty
tff(fact_3161_cInf__greatest,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),Z2: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,X6))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),X2)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),aa(set(A),A,complete_Inf_Inf(A),X6))) ) ) ) ).

% cInf_greatest
tff(fact_3162_cInf__lessD,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X6: set(A),Z2: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),X6)),Z2))
           => ? [X2: A] :
                ( pp(member(A,X2,X6))
                & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X2),Z2)) ) ) ) ) ).

% cInf_lessD
tff(fact_3163_INF__eq__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I4: set(B),F: fun(B,A),X: A] :
          ( ( I4 != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( pp(member(B,I3,I4))
               => ( aa(B,A,F,I3) = X ) )
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),I4)) = X ) ) ) ) ).

% INF_eq_const
tff(fact_3164_bot__finite__def,axiom,
    ! [A: $tType] :
      ( finite_lattice(A)
     => ( bot_bot(A) = aa(set(A),A,complete_Inf_Inf(A),top_top(set(A))) ) ) ).

% bot_finite_def
tff(fact_3165_sup__Inf,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: A,B3: set(A)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(set(A),A,complete_Inf_Inf(A),B3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),sup_sup(A),A3)),B3)) ) ) ).

% sup_Inf
tff(fact_3166_INF__image,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( complete_Inf(A)
     => ! [G: fun(B,A),F: fun(C,B),A4: set(C)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),aa(set(C),set(B),image2(C,B,F),A4))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),G),F)),A4)) ) ) ).

% INF_image
tff(fact_3167_Inf__sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B3: set(A),A3: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),B3)),A3) = top_top(A) )
        <=> ! [X4: A] :
              ( pp(member(A,X4,B3))
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X4),A3) = top_top(A) ) ) ) ) ).

% Inf_sup_eq_top_iff
tff(fact_3168_Inf__finite__insert,axiom,
    ! [A: $tType] :
      ( finite_lattice(A)
     => ! [A3: A,A4: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert2(A,A3),A4)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(set(A),A,complete_Inf_Inf(A),A4)) ) ) ).

% Inf_finite_insert
tff(fact_3169_Inf__union__distrib,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A),B3: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),A4)),aa(set(A),A,complete_Inf_Inf(A),B3)) ) ) ).

% Inf_union_distrib
tff(fact_3170_infinite__int__iff__infinite__nat__abs,axiom,
    ! [S2: set(int)] :
      ( ~ pp(aa(set(int),bool,finite_finite(int),S2))
    <=> ~ pp(aa(set(nat),bool,finite_finite(nat),aa(set(int),set(nat),image2(int,nat,aa(fun(int,int),fun(int,nat),aa(fun(int,nat),fun(fun(int,int),fun(int,nat)),comp(int,nat,int),nat2),abs_abs(int))),S2))) ) ).

% infinite_int_iff_infinite_nat_abs
tff(fact_3171_Inter__subset,axiom,
    ! [A: $tType,A4: set(set(A)),B3: set(A)] :
      ( ! [X7: set(A)] :
          ( pp(member(set(A),X7,A4))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X7),B3)) )
     => ( ( A4 != bot_bot(set(set(A))) )
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A4)),B3)) ) ) ).

% Inter_subset
tff(fact_3172_Inter__empty,axiom,
    ! [A: $tType] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),bot_bot(set(set(A)))) = top_top(set(A)) ) ).

% Inter_empty
tff(fact_3173_inj__on__Inter,axiom,
    ! [B: $tType,A: $tType,S2: set(set(A)),F: fun(A,B)] :
      ( ( S2 != bot_bot(set(set(A))) )
     => ( ! [A12: set(A)] :
            ( pp(member(set(A),A12,S2))
           => inj_on(A,B,F,A12) )
       => inj_on(A,B,F,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),S2)) ) ) ).

% inj_on_Inter
tff(fact_3174_finite__inf__Sup,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [A3: A,A4: set(A)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(set(A),A,complete_Sup_Sup(A),A4)) = aa(set(A),A,complete_Sup_Sup(A),aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_ke(A,fun(set(A),fun(A,bool)),A3),A4))) ) ) ).

% finite_inf_Sup
tff(fact_3175_INF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(B,A),A4: set(B),G: fun(B,A)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),A4))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kf(fun(B,A),fun(fun(B,A),fun(B,A)),F),G)),A4)) ) ) ).

% INF_inf_distrib
tff(fact_3176_INF__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [K: B,I4: set(B),A4: fun(B,A)] :
          ( pp(member(B,K,I4))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,A4,K)),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,A4),I4))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,A4),I4)) ) ) ) ).

% INF_absorb
tff(fact_3177_INF__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F: fun(B,A),B3: set(B),A3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),B3))),A3) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_kg(fun(B,A),fun(A,fun(B,A)),F),A3)),B3)) ) ) ).

% INF_sup
tff(fact_3178_Inf__sup,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B3: set(A),A3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),B3)),A3) = aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),image2(A,A,aTP_Lamp_kh(A,fun(A,A),A3)),B3)) ) ) ).

% Inf_sup
tff(fact_3179_sup__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: A,F: fun(B,A),B3: set(B)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),B3))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ki(A,fun(fun(B,A),fun(B,A)),A3),F)),B3)) ) ) ).

% sup_INF
tff(fact_3180_INF__sup__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F: fun(B,A),A4: set(B),G: fun(C,A),B3: set(C)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,G),B3))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_kk(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),F),G),B3)),A4)) ) ) ).

% INF_sup_distrib2
tff(fact_3181_Inter__insert,axiom,
    ! [A: $tType,A3: set(A),B3: set(set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),insert2(set(A),A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B3)) ) ).

% Inter_insert
tff(fact_3182_Id__def,axiom,
    ! [A: $tType] : ( id2(A) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aTP_Lamp_kl(product_prod(A,A),bool)) ) ).

% Id_def
tff(fact_3183_Inter__UNIV,axiom,
    ! [A: $tType] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),top_top(set(set(A)))) = bot_bot(set(A)) ) ).

% Inter_UNIV
tff(fact_3184_Inter__Un__distrib,axiom,
    ! [A: $tType,A4: set(set(A)),B3: set(set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),A4),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A4)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B3)) ) ).

% Inter_Un_distrib
tff(fact_3185_Int__Inter__image,axiom,
    ! [A: $tType,B: $tType,A4: fun(B,set(A)),B3: fun(B,set(A)),C3: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_km(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),A4),B3)),C3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A4),C3))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),C3))) ) ).

% Int_Inter_image
tff(fact_3186_INT__Int__distrib,axiom,
    ! [A: $tType,B: $tType,A4: fun(B,set(A)),B3: fun(B,set(A)),I4: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_km(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),A4),B3)),I4)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A4),I4))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),I4))) ) ).

% INT_Int_distrib
tff(fact_3187_INT__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I4: set(A),A4: fun(A,set(B))] :
      ( pp(member(A,K,I4))
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),A4,K)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A4),I4))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A4),I4)) ) ) ).

% INT_absorb
tff(fact_3188_INT__bool__eq,axiom,
    ! [A: $tType,A4: fun(bool,set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(bool),set(set(A)),image2(bool,set(A),A4),top_top(set(bool)))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(bool,set(A),A4,fTrue)),aa(bool,set(A),A4,fFalse)) ) ).

% INT_bool_eq
tff(fact_3189_INF__eq__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I4: set(B),F: fun(B,A),C2: A] :
          ( ( I4 != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( pp(member(B,I3,I4))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,I3)),C2)) )
           => ( ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),I4)) = C2 )
            <=> ! [X4: B] :
                  ( pp(member(B,X4,I4))
                 => ( aa(B,A,F,X4) = C2 ) ) ) ) ) ) ).

% INF_eq_iff
tff(fact_3190_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),M4: A,F: fun(B,A)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( pp(member(B,X2,A4))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M4),aa(B,A,F,X2))) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M4),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4)))) ) ) ) ).

% cINF_greatest
tff(fact_3191_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X6: set(A),A3: A] :
          ( pp(aa(set(A),bool,finite_finite(A),X6))
         => ( ( X6 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(set(A),A,complete_Inf_Inf(A),X6)))
            <=> ! [X4: A] :
                  ( pp(member(A,X4,X6))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),X4)) ) ) ) ) ) ).

% finite_less_Inf_iff
tff(fact_3192_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A)] :
          ( ( A4 != bot_bot(set(A)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A4)),aa(set(A),A,complete_Sup_Sup(A),A4))) ) ) ).

% Inf_le_Sup
tff(fact_3193_finite__Inf__in,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [X2: A,Y2: A] :
                  ( pp(member(A,X2,A4))
                 => ( pp(member(A,Y2,A4))
                   => pp(member(A,aa(A,A,aa(A,fun(A,A),inf_inf(A),X2),Y2),A4)) ) )
             => pp(member(A,aa(set(A),A,complete_Inf_Inf(A),A4),A4)) ) ) ) ) ).

% finite_Inf_in
tff(fact_3194_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),A3: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),X2)),A3)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(set(A),A,complete_Inf_Inf(A),S2))),A3)) ) ) ) ).

% cInf_abs_ge
tff(fact_3195_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A),B3: set(A)] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),A4)),aa(set(A),A,complete_Inf_Inf(A),B3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)))) ) ).

% less_eq_Inf_inter
tff(fact_3196_Inf__finite__empty,axiom,
    ! [A: $tType] :
      ( finite_lattice(A)
     => ( aa(set(A),A,complete_Inf_Inf(A),bot_bot(set(A))) = aa(set(A),A,complete_Sup_Sup(A),top_top(set(A))) ) ) ).

% Inf_finite_empty
tff(fact_3197_Sup__finite__empty,axiom,
    ! [A: $tType] :
      ( finite_lattice(A)
     => ( aa(set(A),A,complete_Sup_Sup(A),bot_bot(set(A))) = aa(set(A),A,complete_Inf_Inf(A),top_top(set(A))) ) ) ).

% Sup_finite_empty
tff(fact_3198_inf__Inf__fold__inf,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A),B3: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),A4)),B3) = finite_fold(A,A,inf_inf(A),B3,A4) ) ) ) ).

% inf_Inf_fold_inf
tff(fact_3199_Inf__fin__Inf,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic7752659483105999362nf_fin(A),A4) = aa(set(A),A,complete_Inf_Inf(A),A4) ) ) ) ) ).

% Inf_fin_Inf
tff(fact_3200_cInf__eq__Inf__fin,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),X6))
         => ( ( X6 != bot_bot(set(A)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),X6) = aa(set(A),A,lattic7752659483105999362nf_fin(A),X6) ) ) ) ) ).

% cInf_eq_Inf_fin
tff(fact_3201_INT__greaterThan__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),set_ord_greaterThan(nat)),top_top(set(nat)))) = bot_bot(set(nat)) ).

% INT_greaterThan_UNIV
tff(fact_3202_INF__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(B,A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),bot_bot(set(B)))) = top_top(A) ) ) ).

% INF_empty
tff(fact_3203_INF__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(B),C2: A] :
          ( ( ( A4 = bot_bot(set(B)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hn(A,fun(B,A),C2)),A4)) = top_top(A) ) )
          & ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aTP_Lamp_hn(A,fun(B,A),C2)),A4)) = C2 ) ) ) ) ).

% INF_constant
tff(fact_3204_INF__inf__const2,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I4: set(B),F: fun(B,A),X: A] :
          ( ( I4 != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_kn(fun(B,A),fun(A,fun(B,A)),F),X)),I4)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),I4))),X) ) ) ) ).

% INF_inf_const2
tff(fact_3205_INF__inf__const1,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [I4: set(B),X: A,F: fun(B,A)] :
          ( ( I4 != bot_bot(set(B)) )
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ko(A,fun(fun(B,A),fun(B,A)),X),F)),I4)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),I4))) ) ) ) ).

% INF_inf_const1
tff(fact_3206_INF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(B,A),A3: B,A4: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),aa(set(B),set(B),insert2(B,A3),A4))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,F,A3)),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4))) ) ) ).

% INF_insert
tff(fact_3207_INF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [M: fun(B,A),A4: set(B),B3: set(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,M),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,M),A4))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,M),B3))) ) ) ).

% INF_union
tff(fact_3208_relcomp__unfold,axiom,
    ! [A: $tType,B: $tType,C: $tType,R3: set(product_prod(A,C)),S: set(product_prod(C,B))] : ( relcomp(A,C,B,R3,S) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(set(product_prod(C,B)),fun(A,fun(B,bool)),aTP_Lamp_kp(set(product_prod(A,C)),fun(set(product_prod(C,B)),fun(A,fun(B,bool))),R3),S))) ) ).

% relcomp_unfold
tff(fact_3209_INT__empty,axiom,
    ! [B: $tType,A: $tType,B3: fun(B,set(A))] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),bot_bot(set(B)))) = top_top(set(A)) ) ).

% INT_empty
tff(fact_3210_INT__extend__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C3: set(D),A4: set(C),B3: fun(D,set(C))] :
      ( ( ( C3 = bot_bot(set(D)) )
       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B3),C3))) = A4 ) )
      & ( ( C3 != bot_bot(set(D)) )
       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B3),C3))) = aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),aa(fun(D,set(C)),fun(D,set(C)),aTP_Lamp_ka(set(C),fun(fun(D,set(C)),fun(D,set(C))),A4),B3)),C3)) ) ) ) ).

% INT_extend_simps(2)
tff(fact_3211_INT__extend__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,C3: set(A),A4: fun(A,set(B)),B3: set(B)] :
      ( ( ( C3 = bot_bot(set(A)) )
       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A4),C3))),B3) = B3 ) )
      & ( ( C3 != bot_bot(set(A)) )
       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A4),C3))),B3) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_kb(fun(A,set(B)),fun(set(B),fun(A,set(B))),A4),B3)),C3)) ) ) ) ).

% INT_extend_simps(1)
tff(fact_3212_inj__on__INTER,axiom,
    ! [C: $tType,B: $tType,A: $tType,I4: set(A),F: fun(B,C),A4: fun(A,set(B))] :
      ( ( I4 != bot_bot(set(A)) )
     => ( ! [I3: A] :
            ( pp(member(A,I3,I4))
           => inj_on(B,C,F,aa(A,set(B),A4,I3)) )
       => inj_on(B,C,F,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image2(A,set(B),A4),I4))) ) ) ).

% inj_on_INTER
tff(fact_3213_INT__Un,axiom,
    ! [A: $tType,B: $tType,M: fun(B,set(A)),A4: set(B),B3: set(B)] : ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),M),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),M),A4))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image2(B,set(A),M),B3))) ) ).

% INT_Un
tff(fact_3214_Inter__Un__subset,axiom,
    ! [A: $tType,A4: set(set(A)),B3: set(set(A))] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A4)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B3))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),A4),B3)))) ).

% Inter_Un_subset
tff(fact_3215_Gcd__int__def,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(int,K5) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,aa(set(int),set(nat),image2(int,nat,aa(fun(int,int),fun(int,nat),aa(fun(int,nat),fun(fun(int,int),fun(int,nat)),comp(int,nat,int),nat2),abs_abs(int))),K5))) ) ).

% Gcd_int_def
tff(fact_3216_Int__Inter__eq_I1_J,axiom,
    ! [A: $tType,B11: set(set(A)),A4: set(A)] :
      ( ( ( B11 = bot_bot(set(set(A))) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B11)) = A4 ) )
      & ( ( B11 != bot_bot(set(set(A))) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B11)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),image2(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4)),B11)) ) ) ) ).

% Int_Inter_eq(1)
tff(fact_3217_Int__Inter__eq_I2_J,axiom,
    ! [A: $tType,B11: set(set(A)),A4: set(A)] :
      ( ( ( B11 = bot_bot(set(set(A))) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B11)),A4) = A4 ) )
      & ( ( B11 != bot_bot(set(set(A))) )
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B11)),A4) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),image2(set(A),set(A),aTP_Lamp_ip(set(A),fun(set(A),set(A)),A4)),B11)) ) ) ) ).

% Int_Inter_eq(2)
tff(fact_3218_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(B),F: fun(B,A)] :
          ( ( A4 != bot_bot(set(B)) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4)))) ) ) ).

% INF_le_SUP
tff(fact_3219_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),L: A,E2: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,S2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X2),L))),E2)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(A),A,complete_Inf_Inf(A),S2)),L))),E2)) ) ) ) ).

% cInf_asclose
tff(fact_3220_Inf__insert__finite,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [S2: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( ( ( S2 = bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert2(A,X),S2)) = X ) )
            & ( ( S2 != bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert2(A,X),S2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),X),aa(set(A),A,complete_Inf_Inf(A),S2)) ) ) ) ) ) ).

% Inf_insert_finite
tff(fact_3221_Inf__fold__inf,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( aa(set(A),A,complete_Inf_Inf(A),A4) = finite_fold(A,A,inf_inf(A),top_top(A),A4) ) ) ) ).

% Inf_fold_inf
tff(fact_3222_collect__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: set(fun(C,set(B))),G: fun(A,C)] : ( aa(fun(A,C),fun(A,set(B)),aa(fun(C,set(B)),fun(fun(A,C),fun(A,set(B))),comp(C,set(B),A),bNF_collect(C,B,F2)),G) = bNF_collect(A,B,aa(set(fun(C,set(B))),set(fun(A,set(B))),image2(fun(C,set(B)),fun(A,set(B)),aTP_Lamp_kq(fun(A,C),fun(fun(C,set(B)),fun(A,set(B))),G)),F2)) ) ).

% collect_comp
tff(fact_3223_INF__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: fun(bool,A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(bool),set(A),image2(bool,A,A4),top_top(set(bool)))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(bool,A,A4,fTrue)),aa(bool,A,A4,fFalse)) ) ) ).

% INF_UNIV_bool_expand
tff(fact_3224_inf__Sup2__distrib,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => ( ( B3 != bot_bot(set(A)) )
               => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)),aa(set(A),A,lattic5882676163264333800up_fin(A),B3)) = aa(set(A),A,lattic5882676163264333800up_fin(A),aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_kr(set(A),fun(set(A),fun(A,bool)),A4),B3))) ) ) ) ) ) ) ).

% inf_Sup2_distrib
tff(fact_3225_inf__Sup1__distrib,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X),aa(set(A),A,lattic5882676163264333800up_fin(A),A4)) = aa(set(A),A,lattic5882676163264333800up_fin(A),aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_ks(set(A),fun(A,fun(A,bool)),A4),X))) ) ) ) ) ).

% inf_Sup1_distrib
tff(fact_3226_sup__Inf1__distrib,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)) = aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_kt(set(A),fun(A,fun(A,bool)),A4),X))) ) ) ) ) ).

% sup_Inf1_distrib
tff(fact_3227_sup__Inf2__distrib,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => ( ( B3 != bot_bot(set(A)) )
               => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,lattic7752659483105999362nf_fin(A),A4)),aa(set(A),A,lattic7752659483105999362nf_fin(A),B3)) = aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_ku(set(A),fun(set(A),fun(A,bool)),A4),B3))) ) ) ) ) ) ) ).

% sup_Inf2_distrib
tff(fact_3228_INT__extend__simps_I3_J,axiom,
    ! [F8: $tType,E: $tType,C3: set(E),A4: fun(E,set(F8)),B3: set(F8)] :
      ( ( ( C3 = bot_bot(set(E)) )
       => ( aa(set(F8),set(F8),aa(set(F8),fun(set(F8),set(F8)),minus_minus(set(F8)),aa(set(set(F8)),set(F8),complete_Inf_Inf(set(F8)),aa(set(E),set(set(F8)),image2(E,set(F8),A4),C3))),B3) = aa(set(F8),set(F8),aa(set(F8),fun(set(F8),set(F8)),minus_minus(set(F8)),top_top(set(F8))),B3) ) )
      & ( ( C3 != bot_bot(set(E)) )
       => ( aa(set(F8),set(F8),aa(set(F8),fun(set(F8),set(F8)),minus_minus(set(F8)),aa(set(set(F8)),set(F8),complete_Inf_Inf(set(F8)),aa(set(E),set(set(F8)),image2(E,set(F8),A4),C3))),B3) = aa(set(set(F8)),set(F8),complete_Inf_Inf(set(F8)),aa(set(E),set(set(F8)),image2(E,set(F8),aa(set(F8),fun(E,set(F8)),aTP_Lamp_kc(fun(E,set(F8)),fun(set(F8),fun(E,set(F8))),A4),B3)),C3)) ) ) ) ).

% INT_extend_simps(3)
tff(fact_3229_INT__extend__simps_I4_J,axiom,
    ! [G2: $tType,H9: $tType,C3: set(H9),A4: set(G2),B3: fun(H9,set(G2))] :
      ( ( ( C3 = bot_bot(set(H9)) )
       => ( aa(set(G2),set(G2),aa(set(G2),fun(set(G2),set(G2)),minus_minus(set(G2)),A4),aa(set(set(G2)),set(G2),complete_Sup_Sup(set(G2)),aa(set(H9),set(set(G2)),image2(H9,set(G2),B3),C3))) = A4 ) )
      & ( ( C3 != bot_bot(set(H9)) )
       => ( aa(set(G2),set(G2),aa(set(G2),fun(set(G2),set(G2)),minus_minus(set(G2)),A4),aa(set(set(G2)),set(G2),complete_Sup_Sup(set(G2)),aa(set(H9),set(set(G2)),image2(H9,set(G2),B3),C3))) = aa(set(set(G2)),set(G2),complete_Inf_Inf(set(G2)),aa(set(H9),set(set(G2)),image2(H9,set(G2),aa(fun(H9,set(G2)),fun(H9,set(G2)),aTP_Lamp_ju(set(G2),fun(fun(H9,set(G2)),fun(H9,set(G2))),A4),B3)),C3)) ) ) ) ).

% INT_extend_simps(4)
tff(fact_3230_inf__INF__fold__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(B),B3: A,F: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),B3),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4))) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),aa(fun(A,fun(A,A)),fun(fun(B,A),fun(B,fun(A,A))),comp(A,fun(A,A),B),inf_inf(A)),F),B3,A4) ) ) ) ).

% inf_INF_fold_inf
tff(fact_3231_INF__fold__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(B),F: fun(B,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4)) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),aa(fun(A,fun(A,A)),fun(fun(B,A),fun(B,fun(A,A))),comp(A,fun(A,A),B),inf_inf(A)),F),top_top(A),A4) ) ) ) ).

% INF_fold_inf
tff(fact_3232_brk__rel__def,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B))] : ( brk_rel(A,B,R) = aa(set(product_prod(product_prod(bool,A),product_prod(bool,B))),set(product_prod(product_prod(bool,A),product_prod(bool,B))),aa(set(product_prod(product_prod(bool,A),product_prod(bool,B))),fun(set(product_prod(product_prod(bool,A),product_prod(bool,B))),set(product_prod(product_prod(bool,A),product_prod(bool,B)))),sup_sup(set(product_prod(product_prod(bool,A),product_prod(bool,B)))),aa(fun(product_prod(product_prod(bool,A),product_prod(bool,B)),bool),set(product_prod(product_prod(bool,A),product_prod(bool,B))),collect(product_prod(product_prod(bool,A),product_prod(bool,B))),aTP_Lamp_kv(set(product_prod(A,B)),fun(product_prod(product_prod(bool,A),product_prod(bool,B)),bool),R))),aa(fun(product_prod(product_prod(bool,A),product_prod(bool,B)),bool),set(product_prod(product_prod(bool,A),product_prod(bool,B))),collect(product_prod(product_prod(bool,A),product_prod(bool,B))),aTP_Lamp_kw(product_prod(product_prod(bool,A),product_prod(bool,B)),bool))) ) ).

% brk_rel_def
tff(fact_3233_image2__def,axiom,
    ! [A: $tType,B: $tType,C: $tType,A4: set(C),F: fun(C,A),G: fun(C,B)] : ( bNF_Greatest_image2(C,A,B,A4,F,G) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(C,B),fun(product_prod(A,B),bool),aa(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),bool)),aTP_Lamp_kx(set(C),fun(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),bool))),A4),F),G)) ) ).

% image2_def
tff(fact_3234_card__quotient__disjoint,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( inj_on(A,set(set(A)),aTP_Lamp_ky(set(product_prod(A,A)),fun(A,set(set(A))),R3),A4)
       => ( finite_card(set(A),equiv_quotient(A,A4,R3)) = finite_card(A,A4) ) ) ) ).

% card_quotient_disjoint
tff(fact_3235_Preorder__Restr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( order_preorder_on(A,field2(A,R3),R3)
     => order_preorder_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) ) ).

% Preorder_Restr
tff(fact_3236_mod__h__bot__iff_I8_J,axiom,
    ! [C: $tType,R: fun(C,assn),H2: heap_ext(product_unit)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,ex_assn(C,R)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
    <=> ? [X4: C] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(C,assn,R,X4)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))) ) ).

% mod_h_bot_iff(8)
tff(fact_3237_ex__assn__const,axiom,
    ! [A: $tType,C2: assn] : ( ex_assn(A,aTP_Lamp_kz(assn,fun(A,assn),C2)) = C2 ) ).

% ex_assn_const
tff(fact_3238_subset__mset_OcInf__singleton,axiom,
    ! [A: $tType,X: multiset(A)] : ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) = X ) ).

% subset_mset.cInf_singleton
tff(fact_3239_subset__mset_OcINF__const,axiom,
    ! [B: $tType,A: $tType,A4: set(B),C2: multiset(A)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),aTP_Lamp_jh(multiset(A),fun(B,multiset(A)),C2)),A4)) = C2 ) ) ).

% subset_mset.cINF_const
tff(fact_3240_mod__ex__dist,axiom,
    ! [A: $tType,P: fun(A,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,ex_assn(A,P)),H2))
    <=> ? [X4: A] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,P,X4)),H2)) ) ).

% mod_ex_dist
tff(fact_3241_triv__exI,axiom,
    ! [A: $tType,Q: fun(A,assn),X: A] : entails(aa(A,assn,Q,X),ex_assn(A,Q)) ).

% triv_exI
tff(fact_3242_Inf__nat__def1,axiom,
    ! [K5: set(nat)] :
      ( ( K5 != bot_bot(set(nat)) )
     => pp(member(nat,aa(set(nat),nat,complete_Inf_Inf(nat),K5),K5)) ) ).

% Inf_nat_def1
tff(fact_3243_ex__one__point__gen,axiom,
    ! [A: $tType,P: fun(A,assn),V: A] :
      ( ! [H: product_prod(heap_ext(product_unit),set(nat)),X2: A] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,P,X2)),H))
         => ( X2 = V ) )
     => ( ex_assn(A,P) = aa(A,assn,P,V) ) ) ).

% ex_one_point_gen
tff(fact_3244_mod__exI,axiom,
    ! [A: $tType,P: fun(A,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ? [X3: A] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,P,X3)),H2))
     => pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,ex_assn(A,P)),H2)) ) ).

% mod_exI
tff(fact_3245_mod__exE,axiom,
    ! [A: $tType,P: fun(A,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,ex_assn(A,P)),H2))
     => ~ ! [X2: A] : ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,P,X2)),H2)) ) ).

% mod_exE
tff(fact_3246_Inf__multiset__empty,axiom,
    ! [A: $tType] : ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),bot_bot(set(multiset(A)))) = zero_zero(multiset(A)) ) ).

% Inf_multiset_empty
tff(fact_3247_ex__distrib__star,axiom,
    ! [A: $tType,P: fun(A,assn),Q: assn] : ( ex_assn(A,aa(assn,fun(A,assn),aTP_Lamp_bs(fun(A,assn),fun(assn,fun(A,assn)),P),Q)) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),ex_assn(A,P)),Q) ) ).

% ex_distrib_star
tff(fact_3248_post__exI__rule,axiom,
    ! [B: $tType,A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,fun(B,assn)),X: B] :
      ( hoare_hoare_triple(A,P,C2,aa(B,fun(A,assn),aTP_Lamp_la(fun(A,fun(B,assn)),fun(B,fun(A,assn)),Q),X))
     => hoare_hoare_triple(A,P,C2,aTP_Lamp_lb(fun(A,fun(B,assn)),fun(A,assn),Q)) ) ).

% post_exI_rule
tff(fact_3249_norm__pre__ex__rule,axiom,
    ! [A: $tType,B: $tType,P: fun(A,assn),F: heap_Time_Heap(B),Q: fun(B,assn)] :
      ( ! [X2: A] : hoare_hoare_triple(B,aa(A,assn,P,X2),F,Q)
     => hoare_hoare_triple(B,ex_assn(A,P),F,Q) ) ).

% norm_pre_ex_rule
tff(fact_3250_ent__ex__postI,axiom,
    ! [A: $tType,P: assn,Q: fun(A,assn),X: A] :
      ( entails(P,aa(A,assn,Q,X))
     => entails(P,ex_assn(A,Q)) ) ).

% ent_ex_postI
tff(fact_3251_ent__ex__preI,axiom,
    ! [A: $tType,P: fun(A,assn),Q: assn] :
      ( ! [X2: A] : entails(aa(A,assn,P,X2),Q)
     => entails(ex_assn(A,P),Q) ) ).

% ent_ex_preI
tff(fact_3252_ex__join__or,axiom,
    ! [A: $tType,P: fun(A,assn),Q: fun(A,assn)] : ( ex_assn(A,aa(fun(A,assn),fun(A,assn),aTP_Lamp_lc(fun(A,assn),fun(fun(A,assn),fun(A,assn)),P),Q)) = ex_assn(A,aa(fun(A,assn),fun(A,assn),aTP_Lamp_ld(fun(A,assn),fun(fun(A,assn),fun(A,assn)),P),Q)) ) ).

% ex_join_or
tff(fact_3253_ex__distrib__or,axiom,
    ! [A: $tType,P: fun(A,assn),Q: assn] : ( ex_assn(A,aa(assn,fun(A,assn),aTP_Lamp_le(fun(A,assn),fun(assn,fun(A,assn)),P),Q)) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),ex_assn(A,P)),Q) ) ).

% ex_distrib_or
tff(fact_3254_INF__filter__not__bot,axiom,
    ! [I5: $tType,A: $tType,B3: set(I5),F2: fun(I5,filter(A))] :
      ( ! [X7: set(I5)] :
          ( pp(aa(set(I5),bool,aa(set(I5),fun(set(I5),bool),ord_less_eq(set(I5)),X7),B3))
         => ( pp(aa(set(I5),bool,finite_finite(I5),X7))
           => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(I5),set(filter(A)),image2(I5,filter(A),F2),X7)) != bot_bot(filter(A)) ) ) )
     => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(I5),set(filter(A)),image2(I5,filter(A),F2),B3)) != bot_bot(filter(A)) ) ) ).

% INF_filter_not_bot
tff(fact_3255_ex__distrib__and,axiom,
    ! [A: $tType,P: fun(A,assn),Q: assn] : ( ex_assn(A,aa(assn,fun(A,assn),aTP_Lamp_lf(fun(A,assn),fun(assn,fun(A,assn)),P),Q)) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),ex_assn(A,P)),Q) ) ).

% ex_distrib_and
tff(fact_3256_INF__Int__eq2,axiom,
    ! [B: $tType,A: $tType,S2: set(set(product_prod(A,B))),X3: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Inf_Inf(fun(A,fun(B,bool))),aa(set(set(product_prod(A,B))),set(fun(A,fun(B,bool))),image2(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool)))),S2)),X3),Xa3))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Inf_Inf(set(product_prod(A,B))),S2))) ) ).

% INF_Int_eq2
tff(fact_3257_INF__INT__eq2,axiom,
    ! [A: $tType,B: $tType,C: $tType,R3: fun(C,set(product_prod(A,B))),S2: set(C),X3: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Inf_Inf(fun(A,fun(B,bool))),aa(set(C),set(fun(A,fun(B,bool))),image2(C,fun(A,fun(B,bool)),aTP_Lamp_jf(fun(C,set(product_prod(A,B))),fun(C,fun(A,fun(B,bool))),R3)),S2)),X3),Xa3))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Inf_Inf(set(product_prod(A,B))),aa(set(C),set(set(product_prod(A,B))),image2(C,set(product_prod(A,B)),R3),S2)))) ) ).

% INF_INT_eq2
tff(fact_3258_image2__eqI,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: A,F: fun(B,A),X: B,C2: C,G: fun(B,C),A4: set(B)] :
      ( ( B2 = aa(B,A,F,X) )
     => ( ( C2 = aa(B,C,G,X) )
       => ( pp(member(B,X,A4))
         => pp(member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),B2),C2),bNF_Greatest_image2(B,A,C,A4,F,G))) ) ) ) ).

% image2_eqI
tff(fact_3259_preorder__on__empty,axiom,
    ! [A: $tType] : order_preorder_on(A,bot_bot(set(A)),bot_bot(set(product_prod(A,A)))) ).

% preorder_on_empty
tff(fact_3260_ex__assn__def,axiom,
    ! [A: $tType,P: fun(A,assn)] : ( ex_assn(A,P) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),assn,abs_assn,aTP_Lamp_lg(fun(A,assn),fun(product_prod(heap_ext(product_unit),set(nat)),bool),P)) ) ).

% ex_assn_def
tff(fact_3261_Inf__INT__eq2,axiom,
    ! [B: $tType,A: $tType,S2: set(fun(A,fun(B,bool))),X3: A,Xa3: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(fun(A,fun(B,bool))),fun(A,fun(B,bool)),complete_Inf_Inf(fun(A,fun(B,bool))),S2),X3),Xa3))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3),aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Inf_Inf(set(product_prod(A,B))),aa(set(fun(product_prod(A,B),bool)),set(set(product_prod(A,B))),image2(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B))),aa(set(fun(A,fun(B,bool))),set(fun(product_prod(A,B),bool)),image2(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool)),S2))))) ) ).

% Inf_INT_eq2
tff(fact_3262_quotient__is__empty2,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( ( bot_bot(set(set(A))) = equiv_quotient(A,A4,R3) )
    <=> ( A4 = bot_bot(set(A)) ) ) ).

% quotient_is_empty2
tff(fact_3263_quotient__is__empty,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( ( equiv_quotient(A,A4,R3) = bot_bot(set(set(A))) )
    <=> ( A4 = bot_bot(set(A)) ) ) ).

% quotient_is_empty
tff(fact_3264_quotient__empty,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( equiv_quotient(A,bot_bot(set(A)),R3) = bot_bot(set(set(A))) ) ).

% quotient_empty
tff(fact_3265_quotient__diff1,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),A3: A] :
      ( inj_on(A,set(set(A)),aTP_Lamp_ky(set(product_prod(A,A)),fun(A,set(set(A))),R3),A4)
     => ( pp(member(A,A3,A4))
       => ( equiv_quotient(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))),R3) = aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),minus_minus(set(set(A))),equiv_quotient(A,A4,R3)),equiv_quotient(A,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))),R3)) ) ) ) ).

% quotient_diff1
tff(fact_3266_Gcd__eq__Max,axiom,
    ! [M: set(nat)] :
      ( pp(aa(set(nat),bool,finite_finite(nat),M))
     => ( ( M != bot_bot(set(nat)) )
       => ( ~ pp(member(nat,zero_zero(nat),M))
         => ( gcd_Gcd(nat,M) = lattic643756798349783984er_Max(nat,aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),aTP_Lamp_li(nat,set(nat))),M))) ) ) ) ) ).

% Gcd_eq_Max
tff(fact_3267_Max__singleton,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A] : ( lattic643756798349783984er_Max(A,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = X ) ) ).

% Max_singleton
tff(fact_3268_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic643756798349783984er_Max(A,A4)),X))
            <=> ! [X4: A] :
                  ( pp(member(A,X4,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),X)) ) ) ) ) ) ).

% Max.bounded_iff
tff(fact_3269_Max__less__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),lattic643756798349783984er_Max(A,A4)),X))
            <=> ! [X4: A] :
                  ( pp(member(A,X4,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),X)) ) ) ) ) ) ).

% Max_less_iff
tff(fact_3270_Max__const,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [A4: set(B),C2: A] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ( A4 != bot_bot(set(B)) )
           => ( lattic643756798349783984er_Max(A,aa(set(B),set(A),image2(B,A,aTP_Lamp_lj(A,fun(B,A),C2)),A4)) = C2 ) ) ) ) ).

% Max_const
tff(fact_3271_INF__filter__bot__base,axiom,
    ! [A: $tType,B: $tType,I4: set(A),F2: fun(A,filter(B))] :
      ( ! [I3: A] :
          ( pp(member(A,I3,I4))
         => ! [J3: A] :
              ( pp(member(A,J3,I4))
             => ? [X3: A] :
                  ( pp(member(A,X3,I4))
                  & pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),aa(A,filter(B),F2,X3)),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),aa(A,filter(B),F2,I3)),aa(A,filter(B),F2,J3)))) ) ) )
     => ( ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),F2),I4)) = bot_bot(filter(B)) )
      <=> ? [X4: A] :
            ( pp(member(A,X4,I4))
            & ( aa(A,filter(B),F2,X4) = bot_bot(filter(B)) ) ) ) ) ).

% INF_filter_bot_base
tff(fact_3272_Inf__filter__not__bot,axiom,
    ! [A: $tType,B3: set(filter(A))] :
      ( ! [X7: set(filter(A))] :
          ( pp(aa(set(filter(A)),bool,aa(set(filter(A)),fun(set(filter(A)),bool),ord_less_eq(set(filter(A))),X7),B3))
         => ( pp(aa(set(filter(A)),bool,finite_finite(filter(A)),X7))
           => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),X7) != bot_bot(filter(A)) ) ) )
     => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),B3) != bot_bot(filter(A)) ) ) ).

% Inf_filter_not_bot
tff(fact_3273_Max__in,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => pp(member(A,lattic643756798349783984er_Max(A,A4),A4)) ) ) ) ).

% Max_in
tff(fact_3274_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [A8: A] :
                  ( pp(member(A,A8,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A8),X)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic643756798349783984er_Max(A,A4)),X)) ) ) ) ) ).

% Max.boundedI
tff(fact_3275_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic643756798349783984er_Max(A,A4)),X))
             => ! [A13: A] :
                  ( pp(member(A,A13,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A13),X)) ) ) ) ) ) ).

% Max.boundedE
tff(fact_3276_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),M4: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ( M4 = lattic643756798349783984er_Max(A,A4) )
            <=> ( pp(member(A,M4,A4))
                & ! [X4: A] :
                    ( pp(member(A,X4,A4))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),M4)) ) ) ) ) ) ) ).

% eq_Max_iff
tff(fact_3277_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),lattic643756798349783984er_Max(A,A4)))
            <=> ? [X4: A] :
                  ( pp(member(A,X4,A4))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),X4)) ) ) ) ) ) ).

% Max_ge_iff
tff(fact_3278_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),M4: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ( lattic643756798349783984er_Max(A,A4) = M4 )
            <=> ( pp(member(A,M4,A4))
                & ! [X4: A] :
                    ( pp(member(A,X4,A4))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),M4)) ) ) ) ) ) ) ).

% Max_eq_iff
tff(fact_3279_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),lattic643756798349783984er_Max(A,A4)))
            <=> ? [X4: A] :
                  ( pp(member(A,X4,A4))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),X4)) ) ) ) ) ) ).

% Max_gr_iff
tff(fact_3280_cSup__eq__Max,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X6: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),X6))
         => ( ( X6 != bot_bot(set(A)) )
           => ( aa(set(A),A,complete_Sup_Sup(A),X6) = lattic643756798349783984er_Max(A,X6) ) ) ) ) ).

% cSup_eq_Max
tff(fact_3281_Max__Sup,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( lattic643756798349783984er_Max(A,A4) = aa(set(A),A,complete_Sup_Sup(A),A4) ) ) ) ) ).

% Max_Sup
tff(fact_3282_Sup__nat__def,axiom,
    ! [X6: set(nat)] :
      ( ( ( X6 = bot_bot(set(nat)) )
       => ( aa(set(nat),nat,complete_Sup_Sup(nat),X6) = zero_zero(nat) ) )
      & ( ( X6 != bot_bot(set(nat)) )
       => ( aa(set(nat),nat,complete_Sup_Sup(nat),X6) = lattic643756798349783984er_Max(nat,X6) ) ) ) ).

% Sup_nat_def
tff(fact_3283_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic643756798349783984er_Max(A,A4)),lattic643756798349783984er_Max(A,B3))) ) ) ) ) ).

% Max.subset_imp
tff(fact_3284_Max__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [M: set(A),N4: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),M),N4))
         => ( ( M != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),N4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic643756798349783984er_Max(A,M)),lattic643756798349783984er_Max(A,N4))) ) ) ) ) ).

% Max_mono
tff(fact_3285_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( linord4140545234300271783up_add(A)
     => ! [S2: set(B),F: fun(B,A),K: A] :
          ( pp(aa(set(B),bool,finite_finite(B),S2))
         => ( ( S2 != bot_bot(set(B)) )
           => ( lattic643756798349783984er_Max(A,aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_lk(fun(B,A),fun(A,fun(B,A)),F),K)),S2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),lattic643756798349783984er_Max(A,aa(set(B),set(A),image2(B,A,F),S2))),K) ) ) ) ) ).

% Max_add_commute
tff(fact_3286_measure__function__int,axiom,
    fun_is_measure(int,aa(fun(int,int),fun(int,nat),aa(fun(int,nat),fun(fun(int,int),fun(int,nat)),comp(int,nat,int),nat2),abs_abs(int))) ).

% measure_function_int
tff(fact_3287_minus__Max__eq__Min,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [S2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( ( S2 != bot_bot(set(A)) )
           => ( aa(A,A,uminus_uminus(A),lattic643756798349783984er_Max(A,S2)) = lattic643756798350308766er_Min(A,aa(set(A),set(A),image2(A,A,uminus_uminus(A)),S2)) ) ) ) ) ).

% minus_Max_eq_Min
tff(fact_3288_minus__Min__eq__Max,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [S2: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( ( S2 != bot_bot(set(A)) )
           => ( aa(A,A,uminus_uminus(A),lattic643756798350308766er_Min(A,S2)) = lattic643756798349783984er_Max(A,aa(set(A),set(A),image2(A,A,uminus_uminus(A)),S2)) ) ) ) ) ).

% minus_Min_eq_Max
tff(fact_3289_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [A: $tType,B: $tType,S2: set(A),F: fun(A,fun(B,B)),A4: set(A),Z2: B,Y: B,A3: A] :
      ( finite4664212375090638736ute_on(A,B,S2,F)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),S2))
       => ( pp(aa(B,bool,finite_fold_graph(A,B,F,Z2,A4),Y))
         => ( pp(member(A,A3,A4))
           => ? [Y7: B] :
                ( ( Y = aa(B,B,aa(A,fun(B,B),F,A3),Y7) )
                & pp(aa(B,bool,finite_fold_graph(A,B,F,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))),Y7)) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
tff(fact_3290_Image__fold,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S2: set(A)] :
      ( pp(aa(set(product_prod(A,B)),bool,finite_finite(product_prod(A,B)),R))
     => ( image(A,B,R,S2) = finite_fold(product_prod(A,B),set(B),aa(fun(A,fun(B,fun(set(B),set(B)))),fun(product_prod(A,B),fun(set(B),set(B))),product_case_prod(A,B,fun(set(B),set(B))),aTP_Lamp_ll(set(A),fun(A,fun(B,fun(set(B),set(B)))),S2)),bot_bot(set(B)),R) ) ) ).

% Image_fold
tff(fact_3291_ImageI,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,R3: set(product_prod(A,B)),A4: set(A)] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),R3))
     => ( pp(member(A,A3,A4))
       => pp(member(B,B2,image(A,B,R3,A4))) ) ) ).

% ImageI
tff(fact_3292_Image__empty2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(B,A))] : ( image(B,A,R,bot_bot(set(B))) = bot_bot(set(A)) ) ).

% Image_empty2
tff(fact_3293_Min__singleton,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A] : ( lattic643756798350308766er_Min(A,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = X ) ) ).

% Min_singleton
tff(fact_3294_Image__empty1,axiom,
    ! [B: $tType,A: $tType,X6: set(B)] : ( image(B,A,bot_bot(set(product_prod(B,A))),X6) = bot_bot(set(A)) ) ).

% Image_empty1
tff(fact_3295_Image__Id__on,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( image(A,A,id_on(A,A4),B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) ) ).

% Image_Id_on
tff(fact_3296_Image__singleton__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,R3: set(product_prod(B,A)),A3: B] :
      ( pp(member(A,B2,image(B,A,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))))
    <=> pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),A3),B2),R3)) ) ).

% Image_singleton_iff
tff(fact_3297_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),lattic643756798350308766er_Min(A,A4)))
            <=> ! [X4: A] :
                  ( pp(member(A,X4,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),X4)) ) ) ) ) ) ).

% Min.bounded_iff
tff(fact_3298_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),lattic643756798350308766er_Min(A,A4)))
            <=> ! [X4: A] :
                  ( pp(member(A,X4,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),X4)) ) ) ) ) ) ).

% Min_gr_iff
tff(fact_3299_Min__const,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [A4: set(B),C2: A] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ( A4 != bot_bot(set(B)) )
           => ( lattic643756798350308766er_Min(A,aa(set(B),set(A),image2(B,A,aTP_Lamp_lj(A,fun(B,A),C2)),A4)) = C2 ) ) ) ) ).

% Min_const
tff(fact_3300_Min__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( lattic643756798350308766er_Min(A,aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),ord_min(A),X),lattic643756798350308766er_Min(A,A4)) ) ) ) ) ).

% Min_insert
tff(fact_3301_pair__vimage__is__Image,axiom,
    ! [A: $tType,B: $tType,U: B,E4: set(product_prod(B,A))] : ( aa(set(product_prod(B,A)),set(A),aa(fun(A,product_prod(B,A)),fun(set(product_prod(B,A)),set(A)),vimage(A,product_prod(B,A)),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),U)),E4) = image(B,A,E4,aa(set(B),set(B),insert2(B,U),bot_bot(set(B)))) ) ).

% pair_vimage_is_Image
tff(fact_3302_ImageE,axiom,
    ! [A: $tType,B: $tType,B2: A,R3: set(product_prod(B,A)),A4: set(B)] :
      ( pp(member(A,B2,image(B,A,R3,A4)))
     => ~ ! [X2: B] :
            ( pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X2),B2),R3))
           => ~ pp(member(B,X2,A4)) ) ) ).

% ImageE
tff(fact_3303_Image__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,R3: set(product_prod(B,A)),A4: set(B)] :
      ( pp(member(A,B2,image(B,A,R3,A4)))
    <=> ? [X4: B] :
          ( pp(member(B,X4,A4))
          & pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X4),B2),R3)) ) ) ).

% Image_iff
tff(fact_3304_rev__ImageI,axiom,
    ! [B: $tType,A: $tType,A3: A,A4: set(A),B2: B,R3: set(product_prod(A,B))] :
      ( pp(member(A,A3,A4))
     => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),R3))
       => pp(member(B,B2,image(A,B,R3,A4))) ) ) ).

% rev_ImageI
tff(fact_3305_fold__graph_OemptyI,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(B,B)),Z2: B] : pp(aa(B,bool,finite_fold_graph(A,B,F,Z2,bot_bot(set(A))),Z2)) ).

% fold_graph.emptyI
tff(fact_3306_empty__fold__graphE,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(B,B)),Z2: B,X: B] :
      ( pp(aa(B,bool,finite_fold_graph(A,B,F,Z2,bot_bot(set(A))),X))
     => ( X = Z2 ) ) ).

% empty_fold_graphE
tff(fact_3307_Image__Int__subset,axiom,
    ! [A: $tType,B: $tType,R: set(product_prod(B,A)),A4: set(B),B3: set(B)] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),image(B,A,R,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),image(B,A,R,A4)),image(B,A,R,B3)))) ).

% Image_Int_subset
tff(fact_3308_rtrancl__image__advance__rtrancl,axiom,
    ! [A: $tType,Q3: A,R: set(product_prod(A,A)),Q0: set(A),X: A] :
      ( pp(member(A,Q3,image(A,A,transitive_rtrancl(A,R),Q0)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),X),transitive_rtrancl(A,R)))
       => pp(member(A,X,image(A,A,transitive_rtrancl(A,R),Q0))) ) ) ).

% rtrancl_image_advance_rtrancl
tff(fact_3309_rtrancl__image__advance,axiom,
    ! [A: $tType,Q3: A,R: set(product_prod(A,A)),Q0: set(A),X: A] :
      ( pp(member(A,Q3,image(A,A,transitive_rtrancl(A,R),Q0)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),X),R))
       => pp(member(A,X,image(A,A,transitive_rtrancl(A,R),Q0))) ) ) ).

% rtrancl_image_advance
tff(fact_3310_Min__in,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => pp(member(A,lattic643756798350308766er_Min(A,A4),A4)) ) ) ) ).

% Min_in
tff(fact_3311_fold__graph_Ocases,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(B,B)),Z2: B,A1: set(A),A22: B] :
      ( pp(aa(B,bool,finite_fold_graph(A,B,F,Z2,A1),A22))
     => ( ( ( A1 = bot_bot(set(A)) )
         => ( A22 != Z2 ) )
       => ~ ! [X2: A,A12: set(A)] :
              ( ( A1 = aa(set(A),set(A),insert2(A,X2),A12) )
             => ! [Y2: B] :
                  ( ( A22 = aa(B,B,aa(A,fun(B,B),F,X2),Y2) )
                 => ( ~ pp(member(A,X2,A12))
                   => ~ pp(aa(B,bool,finite_fold_graph(A,B,F,Z2,A12),Y2)) ) ) ) ) ) ).

% fold_graph.cases
tff(fact_3312_fold__graph_Osimps,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(B,B)),Z2: B,A1: set(A),A22: B] :
      ( pp(aa(B,bool,finite_fold_graph(A,B,F,Z2,A1),A22))
    <=> ( ( ( A1 = bot_bot(set(A)) )
          & ( A22 = Z2 ) )
        | ? [X4: A,A11: set(A),Y3: B] :
            ( ( A1 = aa(set(A),set(A),insert2(A,X4),A11) )
            & ( A22 = aa(B,B,aa(A,fun(B,B),F,X4),Y3) )
            & ~ pp(member(A,X4,A11))
            & pp(aa(B,bool,finite_fold_graph(A,B,F,Z2,A11),Y3)) ) ) ) ).

% fold_graph.simps
tff(fact_3313_Image__empty__rtrancl__Image__id,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),V: A] :
      ( ( image(A,A,R,aa(set(A),set(A),insert2(A,V),bot_bot(set(A)))) = bot_bot(set(A)) )
     => ( image(A,A,transitive_rtrancl(A,R),aa(set(A),set(A),insert2(A,V),bot_bot(set(A)))) = aa(set(A),set(A),insert2(A,V),bot_bot(set(A))) ) ) ).

% Image_empty_rtrancl_Image_id
tff(fact_3314_wfE__pf,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),A4: set(A)] :
      ( wf(A,R)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),image(A,A,R,A4)))
       => ( A4 = bot_bot(set(A)) ) ) ) ).

% wfE_pf
tff(fact_3315_wfI__pf,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( ! [A12: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A12),image(A,A,R,A12)))
         => ( A12 = bot_bot(set(A)) ) )
     => wf(A,R) ) ).

% wfI_pf
tff(fact_3316_quotientI,axiom,
    ! [A: $tType,X: A,A4: set(A),R3: set(product_prod(A,A))] :
      ( pp(member(A,X,A4))
     => pp(member(set(A),image(A,A,R3,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))),equiv_quotient(A,A4,R3))) ) ).

% quotientI
tff(fact_3317_quotientE,axiom,
    ! [A: $tType,X6: set(A),A4: set(A),R3: set(product_prod(A,A))] :
      ( pp(member(set(A),X6,equiv_quotient(A,A4,R3)))
     => ~ ! [X2: A] :
            ( ( X6 = image(A,A,R3,aa(set(A),set(A),insert2(A,X2),bot_bot(set(A)))) )
           => ~ pp(member(A,X2,A4)) ) ) ).

% quotientE
tff(fact_3318_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),M4: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ( lattic643756798350308766er_Min(A,A4) = M4 )
            <=> ( pp(member(A,M4,A4))
                & ! [X4: A] :
                    ( pp(member(A,X4,A4))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M4),X4)) ) ) ) ) ) ) ).

% Min_eq_iff
tff(fact_3319_Min__le__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic643756798350308766er_Min(A,A4)),X))
            <=> ? [X4: A] :
                  ( pp(member(A,X4,A4))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),X)) ) ) ) ) ) ).

% Min_le_iff
tff(fact_3320_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),M4: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ( M4 = lattic643756798350308766er_Min(A,A4) )
            <=> ( pp(member(A,M4,A4))
                & ! [X4: A] :
                    ( pp(member(A,X4,A4))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),M4),X4)) ) ) ) ) ) ) ).

% eq_Min_iff
tff(fact_3321_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),lattic643756798350308766er_Min(A,A4)))
             => ! [A13: A] :
                  ( pp(member(A,A13,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),A13)) ) ) ) ) ) ).

% Min.boundedE
tff(fact_3322_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [A8: A] :
                  ( pp(member(A,A8,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),A8)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),lattic643756798350308766er_Min(A,A4))) ) ) ) ) ).

% Min.boundedI
tff(fact_3323_Min__less__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),lattic643756798350308766er_Min(A,A4)),X))
            <=> ? [X4: A] :
                  ( pp(member(A,X4,A4))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),X)) ) ) ) ) ) ).

% Min_less_iff
tff(fact_3324_Min__Inf,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( lattic643756798350308766er_Min(A,A4) = aa(set(A),A,complete_Inf_Inf(A),A4) ) ) ) ) ).

% Min_Inf
tff(fact_3325_cInf__eq__Min,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X6: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),X6))
         => ( ( X6 != bot_bot(set(A)) )
           => ( aa(set(A),A,complete_Inf_Inf(A),X6) = lattic643756798350308766er_Min(A,X6) ) ) ) ) ).

% cInf_eq_Min
tff(fact_3326_Image__singleton,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(B,A)),A3: B] : ( image(B,A,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) = aa(fun(A,bool),set(A),collect(A),aa(B,fun(A,bool),aTP_Lamp_lm(set(product_prod(B,A)),fun(B,fun(A,bool)),R3),A3)) ) ).

% Image_singleton
tff(fact_3327_rtrancl__apply__insert,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),X: A,S2: set(A)] : ( image(A,A,transitive_rtrancl(A,R),aa(set(A),set(A),insert2(A,X),S2)) = aa(set(A),set(A),insert2(A,X),image(A,A,transitive_rtrancl(A,R),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S2),image(A,A,R,aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))))) ) ).

% rtrancl_apply_insert
tff(fact_3328_fold__graph__image,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: fun(A,B),A4: set(A),F: fun(B,fun(C,C)),Z2: C] :
      ( inj_on(A,B,G,A4)
     => ( finite_fold_graph(B,C,F,Z2,aa(set(A),set(B),image2(A,B,G),A4)) = finite_fold_graph(A,C,aa(fun(A,B),fun(A,fun(C,C)),aa(fun(B,fun(C,C)),fun(fun(A,B),fun(A,fun(C,C))),comp(B,fun(C,C),A),F),G),Z2,A4) ) ) ).

% fold_graph_image
tff(fact_3329_E__closed__restr__reach__cases,axiom,
    ! [A: $tType,U: A,V: A,E4: set(product_prod(A,A)),R: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V),transitive_rtrancl(A,E4)))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),image(A,A,E4,R)),R))
       => ( ~ pp(member(A,V,R))
         => ~ ( ~ pp(member(A,U,R))
             => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V),transitive_rtrancl(A,rel_restrict(A,E4,R)))) ) ) ) ) ).

% E_closed_restr_reach_cases
tff(fact_3330_Min__antimono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [M: set(A),N4: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),M),N4))
         => ( ( M != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),N4))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic643756798350308766er_Min(A,N4)),lattic643756798350308766er_Min(A,M))) ) ) ) ) ).

% Min_antimono
tff(fact_3331_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),lattic643756798350308766er_Min(A,B3)),lattic643756798350308766er_Min(A,A4))) ) ) ) ) ).

% Min.subset_imp
tff(fact_3332_subset__Image__Image__iff,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B3: set(A)] :
      ( order_preorder_on(A,field2(A,R3),R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),field2(A,R3)))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),image(A,A,R3,A4)),image(A,A,R3,B3)))
          <=> ! [X4: A] :
                ( pp(member(A,X4,A4))
               => ? [Xa2: A] :
                    ( pp(member(A,Xa2,B3))
                    & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa2),X4),R3)) ) ) ) ) ) ) ).

% subset_Image_Image_iff
tff(fact_3333_Image__eq__UN,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(B,A)),B3: set(B)] : ( image(B,A,R3,B3) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aTP_Lamp_ln(set(product_prod(B,A)),fun(B,set(A)),R3)),B3)) ) ).

% Image_eq_UN
tff(fact_3334_hom__Min__commute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [H2: fun(A,A),N4: set(A)] :
          ( ! [X2: A,Y2: A] : ( aa(A,A,H2,aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,H2,X2)),aa(A,A,H2,Y2)) )
         => ( pp(aa(set(A),bool,finite_finite(A),N4))
           => ( ( N4 != bot_bot(set(A)) )
             => ( aa(A,A,H2,lattic643756798350308766er_Min(A,N4)) = lattic643756798350308766er_Min(A,aa(set(A),set(A),image2(A,A,H2),N4)) ) ) ) ) ) ).

% hom_Min_commute
tff(fact_3335_Min_Osubset,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( B3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A4))
             => ( aa(A,A,aa(A,fun(A,A),ord_min(A),lattic643756798350308766er_Min(A,B3)),lattic643756798350308766er_Min(A,A4)) = lattic643756798350308766er_Min(A,A4) ) ) ) ) ) ).

% Min.subset
tff(fact_3336_Min_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ~ pp(member(A,X,A4))
           => ( ( A4 != bot_bot(set(A)) )
             => ( lattic643756798350308766er_Min(A,aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),ord_min(A),X),lattic643756798350308766er_Min(A,A4)) ) ) ) ) ) ).

% Min.insert_not_elem
tff(fact_3337_Min_Oclosed,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [X2: A,Y2: A] : pp(member(A,aa(A,A,aa(A,fun(A,A),ord_min(A),X2),Y2),aa(set(A),set(A),insert2(A,X2),aa(set(A),set(A),insert2(A,Y2),bot_bot(set(A))))))
             => pp(member(A,lattic643756798350308766er_Min(A,A4),A4)) ) ) ) ) ).

% Min.closed
tff(fact_3338_Min_Ounion,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => ( ( B3 != bot_bot(set(A)) )
               => ( lattic643756798350308766er_Min(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(A,A,aa(A,fun(A,A),ord_min(A),lattic643756798350308766er_Min(A,A4)),lattic643756798350308766er_Min(A,B3)) ) ) ) ) ) ) ).

% Min.union
tff(fact_3339_Sigma__Image,axiom,
    ! [A: $tType,B: $tType,A4: set(B),B3: fun(B,set(A)),X6: set(B)] : ( image(B,A,product_Sigma(B,A,A4,B3),X6) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),B3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X6),A4))) ) ).

% Sigma_Image
tff(fact_3340_Min__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( linord4140545234300271783up_add(A)
     => ! [S2: set(B),F: fun(B,A),K: A] :
          ( pp(aa(set(B),bool,finite_finite(B),S2))
         => ( ( S2 != bot_bot(set(B)) )
           => ( lattic643756798350308766er_Min(A,aa(set(B),set(A),image2(B,A,aa(A,fun(B,A),aTP_Lamp_lk(fun(B,A),fun(A,fun(B,A)),F),K)),S2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),lattic643756798350308766er_Min(A,aa(set(B),set(A),image2(B,A,F),S2))),K) ) ) ) ) ).

% Min_add_commute
tff(fact_3341_finite__reachable__advance,axiom,
    ! [A: $tType,E4: set(product_prod(A,A)),V0: A,V: A] :
      ( pp(aa(set(A),bool,finite_finite(A),image(A,A,transitive_rtrancl(A,E4),aa(set(A),set(A),insert2(A,V0),bot_bot(set(A))))))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V0),V),transitive_rtrancl(A,E4)))
       => pp(aa(set(A),bool,finite_finite(A),image(A,A,transitive_rtrancl(A,E4),aa(set(A),set(A),insert2(A,V),bot_bot(set(A)))))) ) ) ).

% finite_reachable_advance
tff(fact_3342_rtrancl__Image__advance__ss,axiom,
    ! [A: $tType,U: A,V: A,E4: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V),E4))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),image(A,A,transitive_rtrancl(A,E4),aa(set(A),set(A),insert2(A,V),bot_bot(set(A))))),image(A,A,transitive_rtrancl(A,E4),aa(set(A),set(A),insert2(A,U),bot_bot(set(A)))))) ) ).

% rtrancl_Image_advance_ss
tff(fact_3343_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) )
             => ( lattic643756798350308766er_Min(A,aa(set(A),set(A),insert2(A,X),A4)) = X ) )
            & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) != bot_bot(set(A)) )
             => ( lattic643756798350308766er_Min(A,aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),ord_min(A),X),lattic643756798350308766er_Min(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ).

% Min.insert_remove
tff(fact_3344_Min_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,X,A4))
           => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) )
               => ( lattic643756798350308766er_Min(A,A4) = X ) )
              & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) != bot_bot(set(A)) )
               => ( lattic643756798350308766er_Min(A,A4) = aa(A,A,aa(A,fun(A,A),ord_min(A),X),lattic643756798350308766er_Min(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ) ).

% Min.remove
tff(fact_3345_singleton__quotient,axiom,
    ! [A: $tType,X: A,R3: set(product_prod(A,A))] : ( equiv_quotient(A,aa(set(A),set(A),insert2(A,X),bot_bot(set(A))),R3) = aa(set(set(A)),set(set(A)),insert2(set(A),image(A,A,R3,aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))),bot_bot(set(set(A)))) ) ).

% singleton_quotient
tff(fact_3346_quotient__def,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] : ( equiv_quotient(A,A4,R3) = aa(set(set(set(A))),set(set(A)),complete_Sup_Sup(set(set(A))),aa(set(A),set(set(set(A))),image2(A,set(set(A)),aTP_Lamp_lo(set(product_prod(A,A)),fun(A,set(set(A))),R3)),A4)) ) ).

% quotient_def
tff(fact_3347_subset__Image1__Image1__iff,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( order_preorder_on(A,field2(A,R3),R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => ( pp(member(A,B2,field2(A,R3)))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))),image(A,A,R3,aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))))
          <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),A3),R3)) ) ) ) ) ).

% subset_Image1_Image1_iff
tff(fact_3348_Refl__antisym__eq__Image1__Image1__iff,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( refl_on(A,field2(A,R3),R3)
     => ( antisym(A,R3)
       => ( pp(member(A,A3,field2(A,R3)))
         => ( pp(member(A,B2,field2(A,R3)))
           => ( ( image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) = image(A,A,R3,aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))) )
            <=> ( A3 = B2 ) ) ) ) ) ) ).

% Refl_antisym_eq_Image1_Image1_iff
tff(fact_3349_trancl__multi__insert2,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),M4: A,X6: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R3),product_Sigma(A,A,aa(set(A),set(A),insert2(A,M4),bot_bot(set(A))),aTP_Lamp_if(set(A),fun(A,set(A)),X6))))))
     => ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,R3)))
       => ~ ! [X2: A] :
              ( pp(member(A,X2,X6))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),M4),transitive_rtrancl(A,R3)))
               => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),B2),transitive_rtrancl(A,R3))) ) ) ) ) ).

% trancl_multi_insert2
tff(fact_3350_trancl__multi__insert,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),X6: set(A),M4: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R3),product_Sigma(A,A,X6,aTP_Lamp_lp(A,fun(A,set(A)),M4))))))
     => ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,R3)))
       => ~ ! [X2: A] :
              ( pp(member(A,X2,X6))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),X2),transitive_rtrancl(A,R3)))
               => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),M4),B2),transitive_rtrancl(A,R3))) ) ) ) ) ).

% trancl_multi_insert
tff(fact_3351_relation__of__def,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),A4: set(A)] : ( order_relation_of(A,P,A4) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(A),fun(A,fun(A,bool)),aTP_Lamp_lq(fun(A,fun(A,bool)),fun(set(A),fun(A,fun(A,bool))),P),A4))) ) ).

% relation_of_def
tff(fact_3352_pred__nat__trancl__eq__le,axiom,
    ! [M4: nat,N: nat] :
      ( pp(member(product_prod(nat,nat),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),M4),N),transitive_rtrancl(nat,pred_nat)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N)) ) ).

% pred_nat_trancl_eq_le
tff(fact_3353_trancl__empty,axiom,
    ! [A: $tType] : ( transitive_trancl(A,bot_bot(set(product_prod(A,A)))) = bot_bot(set(product_prod(A,A))) ) ).

% trancl_empty
tff(fact_3354_trancl__single,axiom,
    ! [A: $tType,A3: A,B2: A] : ( transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2)),bot_bot(set(product_prod(A,A))))) = aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2)),bot_bot(set(product_prod(A,A)))) ) ).

% trancl_single
tff(fact_3355_trancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A1),A22),transitive_trancl(A,R3)))
     => ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A1),A22),R3))
       => ~ ! [B5: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A1),B5),transitive_trancl(A,R3)))
             => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B5),A22),R3)) ) ) ) ).

% trancl.cases
tff(fact_3356_trancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A1),A22),transitive_trancl(A,R3)))
    <=> ( ? [A6: A,B6: A] :
            ( ( A1 = A6 )
            & ( A22 = B6 )
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),B6),R3)) )
        | ? [A6: A,B6: A,C5: A] :
            ( ( A1 = A6 )
            & ( A22 = C5 )
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),B6),transitive_trancl(A,R3)))
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B6),C5),R3)) ) ) ) ).

% trancl.simps
tff(fact_3357_trancl_Or__into__trancl,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,R3))) ) ).

% trancl.r_into_trancl
tff(fact_3358_tranclE,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,R3)))
     => ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
       => ~ ! [C4: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),C4),transitive_trancl(A,R3)))
             => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),C4),B2),R3)) ) ) ) ).

% tranclE
tff(fact_3359_trancl__trans,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A)),Z2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_trancl(A,R3)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),Z2),transitive_trancl(A,R3)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),transitive_trancl(A,R3))) ) ) ).

% trancl_trans
tff(fact_3360_trancl__induct,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),P: fun(A,bool)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,R3)))
     => ( ! [Y2: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),Y2),R3))
           => pp(aa(A,bool,P,Y2)) )
       => ( ! [Y2: A,Z3: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),Y2),transitive_trancl(A,R3)))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z3),R3))
               => ( pp(aa(A,bool,P,Y2))
                 => pp(aa(A,bool,P,Z3)) ) ) )
         => pp(aa(A,bool,P,B2)) ) ) ) ).

% trancl_induct
tff(fact_3361_r__r__into__trancl,axiom,
    ! [A: $tType,A3: A,B2: A,R: set(product_prod(A,A)),C2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),C2),R))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),C2),transitive_trancl(A,R))) ) ) ).

% r_r_into_trancl
tff(fact_3362_converse__tranclE,axiom,
    ! [A: $tType,X: A,Z2: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),transitive_trancl(A,R3)))
     => ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),R3))
       => ~ ! [Y2: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y2),R3))
             => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z2),transitive_trancl(A,R3))) ) ) ) ).

% converse_tranclE
tff(fact_3363_irrefl__trancl__rD,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X: A,Y: A] :
      ( ! [X2: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2),transitive_trancl(A,R3)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
       => ( X != Y ) ) ) ).

% irrefl_trancl_rD
tff(fact_3364_Transitive__Closure_Otrancl__into__trancl,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),C2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,R3)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),C2),R3))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),C2),transitive_trancl(A,R3))) ) ) ).

% Transitive_Closure.trancl_into_trancl
tff(fact_3365_trancl__into__trancl2,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),C2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),C2),transitive_trancl(A,R3)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),C2),transitive_trancl(A,R3))) ) ) ).

% trancl_into_trancl2
tff(fact_3366_trancl__trans__induct,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A)),P: fun(A,fun(A,bool))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_trancl(A,R3)))
     => ( ! [X2: A,Y2: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),R3))
           => pp(aa(A,bool,aa(A,fun(A,bool),P,X2),Y2)) )
       => ( ! [X2: A,Y2: A,Z3: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),transitive_trancl(A,R3)))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),P,X2),Y2))
               => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z3),transitive_trancl(A,R3)))
                 => ( pp(aa(A,bool,aa(A,fun(A,bool),P,Y2),Z3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),P,X2),Z3)) ) ) ) )
         => pp(aa(A,bool,aa(A,fun(A,bool),P,X),Y)) ) ) ) ).

% trancl_trans_induct
tff(fact_3367_converse__trancl__induct,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),P: fun(A,bool)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,R3)))
     => ( ! [Y2: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),B2),R3))
           => pp(aa(A,bool,P,Y2)) )
       => ( ! [Y2: A,Z3: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z3),R3))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z3),B2),transitive_trancl(A,R3)))
               => ( pp(aa(A,bool,P,Z3))
                 => pp(aa(A,bool,P,Y2)) ) ) )
         => pp(aa(A,bool,P,A3)) ) ) ) ).

% converse_trancl_induct
tff(fact_3368_less__eq,axiom,
    ! [M4: nat,N: nat] :
      ( pp(member(product_prod(nat,nat),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),M4),N),transitive_trancl(nat,pred_nat)))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M4),N)) ) ).

% less_eq
tff(fact_3369_antisymD,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( antisym(A,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
       => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),A3),R3))
         => ( A3 = B2 ) ) ) ) ).

% antisymD
tff(fact_3370_antisymI,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ! [X2: A,Y2: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),R3))
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),X2),R3))
           => ( X2 = Y2 ) ) )
     => antisym(A,R3) ) ).

% antisymI
tff(fact_3371_antisym__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( antisym(A,R3)
    <=> ! [X4: A,Y3: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Y3),R3))
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y3),X4),R3))
           => ( X4 = Y3 ) ) ) ) ).

% antisym_def
tff(fact_3372_antisym__empty,axiom,
    ! [A: $tType] : antisym(A,bot_bot(set(product_prod(A,A)))) ).

% antisym_empty
tff(fact_3373_trancl__rtrancl__trancl,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),C2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,R3)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),C2),transitive_rtrancl(A,R3)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),C2),transitive_trancl(A,R3))) ) ) ).

% trancl_rtrancl_trancl
tff(fact_3374_rtrancl__trancl__trancl,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A)),Z2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,R3)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),Z2),transitive_trancl(A,R3)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),transitive_trancl(A,R3))) ) ) ).

% rtrancl_trancl_trancl
tff(fact_3375_rtrancl__into__trancl2,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),C2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),C2),transitive_rtrancl(A,R3)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),C2),transitive_trancl(A,R3))) ) ) ).

% rtrancl_into_trancl2
tff(fact_3376_rtrancl__into__trancl1,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),C2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,R3)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),C2),R3))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),C2),transitive_trancl(A,R3))) ) ) ).

% rtrancl_into_trancl1
tff(fact_3377_rtrancl__eq__or__trancl,axiom,
    ! [A: $tType,X: A,Y: A,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,R)))
    <=> ( ( X = Y )
        | ( ( X != Y )
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_trancl(A,R))) ) ) ) ).

% rtrancl_eq_or_trancl
tff(fact_3378_trancl__into__rtrancl,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,R3)))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,R3))) ) ).

% trancl_into_rtrancl
tff(fact_3379_tranclD2,axiom,
    ! [A: $tType,X: A,Y: A,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_trancl(A,R)))
     => ? [Z3: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z3),transitive_rtrancl(A,R)))
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z3),Y),R)) ) ) ).

% tranclD2
tff(fact_3380_rtranclD,axiom,
    ! [A: $tType,A3: A,B2: A,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_rtrancl(A,R)))
     => ( ( A3 = B2 )
        | ( ( A3 != B2 )
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,R))) ) ) ) ).

% rtranclD
tff(fact_3381_tranclD,axiom,
    ! [A: $tType,X: A,Y: A,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_trancl(A,R)))
     => ? [Z3: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z3),R))
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z3),Y),transitive_rtrancl(A,R))) ) ) ).

% tranclD
tff(fact_3382_rel__restrict__trancl__notR_I2_J,axiom,
    ! [A: $tType,V: A,W2: A,E4: set(product_prod(A,A)),R: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2),transitive_trancl(A,rel_restrict(A,E4,R))))
     => ~ pp(member(A,W2,R)) ) ).

% rel_restrict_trancl_notR(2)
tff(fact_3383_rel__restrict__trancl__notR_I1_J,axiom,
    ! [A: $tType,V: A,W2: A,E4: set(product_prod(A,A)),R: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2),transitive_trancl(A,rel_restrict(A,E4,R))))
     => ~ pp(member(A,V,R)) ) ).

% rel_restrict_trancl_notR(1)
tff(fact_3384_rel__restrict__trancl__mem,axiom,
    ! [A: $tType,A3: A,B2: A,A4: set(product_prod(A,A)),R: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,rel_restrict(A,A4,R))))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),rel_restrict(A,transitive_trancl(A,A4),R))) ) ).

% rel_restrict_trancl_mem
tff(fact_3385_trancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R3: set(product_prod(product_prod(A,B),product_prod(A,B))),P: fun(A,fun(B,bool))] :
      ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Bx),By)),transitive_trancl(product_prod(A,B),R3)))
     => ( ! [A8: A,B5: B] :
            ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),R3))
           => pp(aa(B,bool,aa(A,fun(B,bool),P,A8),B5)) )
       => ( ! [A8: A,B5: B,Aa2: A,Ba: B] :
              ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),transitive_trancl(product_prod(A,B),R3)))
             => ( pp(member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),fun(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B))),product_Pair(product_prod(A,B),product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Aa2),Ba)),R3))
               => ( pp(aa(B,bool,aa(A,fun(B,bool),P,A8),B5))
                 => pp(aa(B,bool,aa(A,fun(B,bool),P,Aa2),Ba)) ) ) )
         => pp(aa(B,bool,aa(A,fun(B,bool),P,Bx),By)) ) ) ) ).

% trancl_induct2
tff(fact_3386_Image__empty__trancl__Image__empty,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),V: A] :
      ( ( image(A,A,R,aa(set(A),set(A),insert2(A,V),bot_bot(set(A)))) = bot_bot(set(A)) )
     => ( image(A,A,transitive_trancl(A,R),aa(set(A),set(A),insert2(A,V),bot_bot(set(A)))) = bot_bot(set(A)) ) ) ).

% Image_empty_trancl_Image_empty
tff(fact_3387_wf__linord__ex__has__least,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),P: fun(B,bool),K: B,M4: fun(B,A)] :
      ( wf(A,R3)
     => ( ! [X2: A,Y2: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),transitive_trancl(A,R3)))
          <=> ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),X2),transitive_rtrancl(A,R3))) )
       => ( pp(aa(B,bool,P,K))
         => ? [X2: B] :
              ( pp(aa(B,bool,P,X2))
              & ! [Y4: B] :
                  ( pp(aa(B,bool,P,Y4))
                 => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(B,A,M4,X2)),aa(B,A,M4,Y4)),transitive_rtrancl(A,R3))) ) ) ) ) ) ).

% wf_linord_ex_has_least
tff(fact_3388_trancl__union__outside,axiom,
    ! [A: $tType,V: A,W2: A,E4: set(product_prod(A,A)),U2: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2),transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),E4),U2))))
     => ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2),transitive_trancl(A,E4)))
       => ? [X2: A,Y2: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),X2),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),E4),U2))))
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),U2))
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),W2),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),E4),U2)))) ) ) ) ).

% trancl_union_outside
tff(fact_3389_trancl__over__edgeE,axiom,
    ! [A: $tType,U: A,W2: A,V1: A,V22: A,E4: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),W2),transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V1),V22)),E4))))
     => ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),W2),transitive_trancl(A,E4)))
       => ~ ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V1),transitive_rtrancl(A,E4)))
           => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V22),W2),transitive_rtrancl(A,E4))) ) ) ) ).

% trancl_over_edgeE
tff(fact_3390_antisym__singleton,axiom,
    ! [A: $tType,X: product_prod(A,A)] : antisym(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),X),bot_bot(set(product_prod(A,A))))) ).

% antisym_singleton
tff(fact_3391_trancl__Int__subset,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R3),S))
     => ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),relcomp(A,A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),transitive_trancl(A,R3)),S),R3)),S))
       => pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),transitive_trancl(A,R3)),S)) ) ) ).

% trancl_Int_subset
tff(fact_3392_Restr__trancl__mono,axiom,
    ! [A: $tType,V: A,W2: A,E4: set(product_prod(A,A)),U2: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2),transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),E4),product_Sigma(A,A,U2,aTP_Lamp_if(set(A),fun(A,set(A)),U2))))))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),V),W2),transitive_trancl(A,E4))) ) ).

% Restr_trancl_mono
tff(fact_3393_antisym__Restr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( antisym(A,R3)
     => antisym(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) ) ).

% antisym_Restr
tff(fact_3394_rel__restrict__tranclI,axiom,
    ! [A: $tType,X: A,Y: A,E4: set(product_prod(A,A)),R: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_trancl(A,E4)))
     => ( ~ pp(member(A,X,R))
       => ( ~ pp(member(A,Y,R))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),image(A,A,E4,R)),R))
           => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_trancl(A,rel_restrict(A,E4,R)))) ) ) ) ) ).

% rel_restrict_tranclI
tff(fact_3395_trancl__insert2,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A))] : ( transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2)),R3)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_trancl(A,R3)),aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool))),aTP_Lamp_lr(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool)))),A3),B2),R3)))) ) ).

% trancl_insert2
tff(fact_3396_trancl__Image__advance__ss,axiom,
    ! [A: $tType,U: A,V: A,E4: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V),E4))
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),image(A,A,transitive_trancl(A,E4),aa(set(A),set(A),insert2(A,V),bot_bot(set(A))))),image(A,A,transitive_trancl(A,E4),aa(set(A),set(A),insert2(A,U),bot_bot(set(A)))))) ) ).

% trancl_Image_advance_ss
tff(fact_3397_trancl__restrict__reachable,axiom,
    ! [A: $tType,U: A,V: A,E4: set(product_prod(A,A)),S2: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V),transitive_trancl(A,E4)))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),image(A,A,E4,S2)),S2))
       => ( pp(member(A,U,S2))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),U),V),transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),E4),product_Sigma(A,A,S2,aTP_Lamp_if(set(A),fun(A,set(A)),S2)))))) ) ) ) ).

% trancl_restrict_reachable
tff(fact_3398_rtrancl__last__visit,axiom,
    ! [A: $tType,Q3: A,Q5: A,R: set(product_prod(A,A)),S2: set(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Q5),transitive_rtrancl(A,R)))
     => ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Q5),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_if(set(A),fun(A,set(A)),S2))))))
       => ~ ! [Qt: A] :
              ( pp(member(A,Qt,S2))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Q3),Qt),transitive_trancl(A,R)))
               => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Qt),Q5),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),R),product_Sigma(A,A,top_top(set(A)),aTP_Lamp_if(set(A),fun(A,set(A)),S2)))))) ) ) ) ) ).

% rtrancl_last_visit
tff(fact_3399_trancl__insert,axiom,
    ! [A: $tType,Y: A,X: A,R3: set(product_prod(A,A))] : ( transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),X)),R3)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_trancl(A,R3)),aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool))),aTP_Lamp_jg(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool)))),Y),X),R3)))) ) ).

% trancl_insert
tff(fact_3400_new__addrs__def,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat),H4: heap_ext(product_unit)] : ( hoare_new_addrs(H2,As,H4) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),aa(fun(nat,bool),set(nat),collect(nat),aa(heap_ext(product_unit),fun(nat,bool),aTP_Lamp_ls(heap_ext(product_unit),fun(heap_ext(product_unit),fun(nat,bool)),H2),H4))) ) ).

% new_addrs_def
tff(fact_3401_flat__lub__def,axiom,
    ! [A: $tType,A4: set(A),B2: A] :
      ( ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))))
       => ( aa(set(A),A,partial_flat_lub(A,B2),A4) = B2 ) )
      & ( ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))))
       => ( aa(set(A),A,partial_flat_lub(A,B2),A4) = the(A,aa(A,fun(A,bool),aTP_Lamp_lt(set(A),fun(A,fun(A,bool)),A4),B2)) ) ) ) ).

% flat_lub_def
tff(fact_3402_Rep__unit,axiom,
    ! [X: product_unit] : pp(member(bool,aa(product_unit,bool,product_Rep_unit,X),aa(set(bool),set(bool),insert2(bool,fTrue),bot_bot(set(bool))))) ).

% Rep_unit
tff(fact_3403_Abs__unit__cases,axiom,
    ! [X: product_unit] :
      ~ ! [Y2: bool] :
          ( ( X = aa(bool,product_unit,product_Abs_unit,Y2) )
         => ~ pp(member(bool,Y2,aa(set(bool),set(bool),insert2(bool,fTrue),bot_bot(set(bool))))) ) ).

% Abs_unit_cases
tff(fact_3404_Rep__unit__cases,axiom,
    ! [Y: bool] :
      ( pp(member(bool,Y,aa(set(bool),set(bool),insert2(bool,fTrue),bot_bot(set(bool)))))
     => ~ ! [X2: product_unit] :
            ( pp(Y)
          <=> ~ pp(aa(product_unit,bool,product_Rep_unit,X2)) ) ) ).

% Rep_unit_cases
tff(fact_3405_type__definition__unit,axiom,
    type_definition(product_unit,bool,product_Rep_unit,product_Abs_unit,aa(set(bool),set(bool),insert2(bool,fTrue),bot_bot(set(bool)))) ).

% type_definition_unit
tff(fact_3406_Abs__unit__inverse,axiom,
    ! [Y: bool] :
      ( pp(member(bool,Y,aa(set(bool),set(bool),insert2(bool,fTrue),bot_bot(set(bool)))))
     => ( pp(aa(product_unit,bool,product_Rep_unit,aa(bool,product_unit,product_Abs_unit,Y)))
      <=> pp(Y) ) ) ).

% Abs_unit_inverse
tff(fact_3407_in__range_Oelims_I3_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X))
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ! [X2: nat] :
                ( pp(member(nat,X2,As2))
               => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X2),lim(product_unit,H))) ) ) ) ).

% in_range.elims(3)
tff(fact_3408_in__range_Oelims_I2_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X))
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ~ ! [X3: nat] :
                  ( pp(member(nat,X3,As2))
                 => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),lim(product_unit,H))) ) ) ) ).

% in_range.elims(2)
tff(fact_3409_in__range_Oelims_I1_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X))
      <=> pp(Y) )
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( pp(Y)
            <=> ~ ! [X4: nat] :
                    ( pp(member(nat,X4,As2))
                   => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X4),lim(product_unit,H))) ) ) ) ) ).

% in_range.elims(1)
tff(fact_3410_in__range_Osimps,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat)] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
    <=> ! [X4: nat] :
          ( pp(member(nat,X4,As))
         => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X4),lim(product_unit,H2))) ) ) ).

% in_range.simps
tff(fact_3411_Rep__unit__induct,axiom,
    ! [Y: bool,P: fun(bool,bool)] :
      ( pp(member(bool,Y,aa(set(bool),set(bool),insert2(bool,fTrue),bot_bot(set(bool)))))
     => ( ! [X2: product_unit] : pp(aa(bool,bool,P,aa(product_unit,bool,product_Rep_unit,X2)))
       => pp(aa(bool,bool,P,Y)) ) ) ).

% Rep_unit_induct
tff(fact_3412_Abs__unit__inject,axiom,
    ! [X: bool,Y: bool] :
      ( pp(member(bool,X,aa(set(bool),set(bool),insert2(bool,fTrue),bot_bot(set(bool)))))
     => ( pp(member(bool,Y,aa(set(bool),set(bool),insert2(bool,fTrue),bot_bot(set(bool)))))
       => ( ( aa(bool,product_unit,product_Abs_unit,X) = aa(bool,product_unit,product_Abs_unit,Y) )
        <=> ( pp(X)
          <=> pp(Y) ) ) ) ) ).

% Abs_unit_inject
tff(fact_3413_Abs__unit__induct,axiom,
    ! [P: fun(product_unit,bool),X: product_unit] :
      ( ! [Y2: bool] :
          ( pp(member(bool,Y2,aa(set(bool),set(bool),insert2(bool,fTrue),bot_bot(set(bool)))))
         => pp(aa(product_unit,bool,P,aa(bool,product_unit,product_Abs_unit,Y2))) )
     => pp(aa(product_unit,bool,P,X)) ) ).

% Abs_unit_induct
tff(fact_3414_Partial__order__eq__Image1__Image1__iff,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( order_7125193373082350890der_on(A,field2(A,R3),R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => ( pp(member(A,B2,field2(A,R3)))
         => ( ( image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) = image(A,A,R3,aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))) )
          <=> ( A3 = B2 ) ) ) ) ) ).

% Partial_order_eq_Image1_Image1_iff
tff(fact_3415_return__def,axiom,
    ! [A: $tType,X: A] : ( aa(A,heap_Time_Heap(A),heap_Time_return(A),X) = heap_Time_heap(A,aTP_Lamp_lu(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),X)) ) ).

% return_def
tff(fact_3416_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B3: set(A),F2: fun(A,filter(B)),P: fun(B,bool)] :
      ( ( B3 != bot_bot(set(A)) )
     => ( ! [A8: A] :
            ( pp(member(A,A8,B3))
           => ! [B5: A] :
                ( pp(member(A,B5,B3))
               => ? [X3: A] :
                    ( pp(member(A,X3,B3))
                    & pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),aa(A,filter(B),F2,X3)),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),aa(A,filter(B),F2,A8)),aa(A,filter(B),F2,B5)))) ) ) )
       => ( eventually(B,P,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),F2),B3)))
        <=> ? [X4: A] :
              ( pp(member(A,X4,B3))
              & eventually(B,P,aa(A,filter(B),F2,X4)) ) ) ) ) ).

% eventually_INF_base
tff(fact_3417_proj__def,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(B,A)),X: B] : ( aa(B,set(A),equiv_proj(B,A,R3),X) = image(B,A,R3,aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) ) ).

% proj_def
tff(fact_3418_cSUP__UNION,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A4: set(C),B3: fun(C,set(D)),F: fun(D,B)] :
          ( ( A4 != bot_bot(set(C)) )
         => ( ! [X2: C] :
                ( pp(member(C,X2,A4))
               => ( aa(C,set(D),B3,X2) != bot_bot(set(D)) ) )
           => ( condit941137186595557371_above(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(D,B),fun(C,set(B)),aTP_Lamp_lv(fun(C,set(D)),fun(fun(D,B),fun(C,set(B))),B3),F)),A4)))
             => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,F),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),B3),A4)))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(D,B),fun(C,B),aTP_Lamp_lw(fun(C,set(D)),fun(fun(D,B),fun(C,B)),B3),F)),A4)) ) ) ) ) ) ).

% cSUP_UNION
tff(fact_3419_bdd__above__empty,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => condit941137186595557371_above(A,bot_bot(set(A))) ) ).

% bdd_above_empty
tff(fact_3420_eventually__const,axiom,
    ! [A: $tType,F2: filter(A),P: bool] :
      ( ( F2 != bot_bot(filter(A)) )
     => ( eventually(A,aTP_Lamp_aj(bool,fun(A,bool),P),F2)
      <=> pp(P) ) ) ).

% eventually_const
tff(fact_3421_bdd__above__image__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [F: fun(B,A),G: fun(B,A),A4: set(B)] :
          ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_lx(fun(B,A),fun(fun(B,A),fun(B,A)),F),G)),A4))
        <=> ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F),A4))
            & condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,G),A4)) ) ) ) ).

% bdd_above_image_sup
tff(fact_3422_bdd__above__Int2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: set(A),A4: set(A)] :
          ( condit941137186595557371_above(A,B3)
         => condit941137186595557371_above(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) ) ).

% bdd_above_Int2
tff(fact_3423_bdd__above__Int1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: set(A),B3: set(A)] :
          ( condit941137186595557371_above(A,A4)
         => condit941137186595557371_above(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) ) ).

% bdd_above_Int1
tff(fact_3424_eventually__happens_H,axiom,
    ! [A: $tType,F2: filter(A),P: fun(A,bool)] :
      ( ( F2 != bot_bot(filter(A)) )
     => ( eventually(A,P,F2)
       => ? [X_1: A] : pp(aa(A,bool,P,X_1)) ) ) ).

% eventually_happens'
tff(fact_3425_eventually__happens,axiom,
    ! [A: $tType,P: fun(A,bool),Net: filter(A)] :
      ( eventually(A,P,Net)
     => ( ( Net = bot_bot(filter(A)) )
        | ? [X_1: A] : pp(aa(A,bool,P,X_1)) ) ) ).

% eventually_happens
tff(fact_3426_eventually__bot,axiom,
    ! [A: $tType,P: fun(A,bool)] : eventually(A,P,bot_bot(filter(A))) ).

% eventually_bot
tff(fact_3427_eventually__inf,axiom,
    ! [A: $tType,P: fun(A,bool),F2: filter(A),F3: filter(A)] :
      ( eventually(A,P,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F2),F3))
    <=> ? [Q8: fun(A,bool),R6: fun(A,bool)] :
          ( eventually(A,Q8,F2)
          & eventually(A,R6,F3)
          & ! [X4: A] :
              ( ( pp(aa(A,bool,Q8,X4))
                & pp(aa(A,bool,R6,X4)) )
             => pp(aa(A,bool,P,X4)) ) ) ) ).

% eventually_inf
tff(fact_3428_trivial__limit__def,axiom,
    ! [A: $tType,F2: filter(A)] :
      ( ( F2 = bot_bot(filter(A)) )
    <=> eventually(A,aTP_Lamp_bi(A,bool),F2) ) ).

% trivial_limit_def
tff(fact_3429_eventually__const__iff,axiom,
    ! [A: $tType,P: bool,F2: filter(A)] :
      ( eventually(A,aTP_Lamp_aj(bool,fun(A,bool),P),F2)
    <=> ( pp(P)
        | ( F2 = bot_bot(filter(A)) ) ) ) ).

% eventually_const_iff
tff(fact_3430_False__imp__not__eventually,axiom,
    ! [A: $tType,P: fun(A,bool),Net: filter(A)] :
      ( ! [X2: A] : ~ pp(aa(A,bool,P,X2))
     => ( ( Net != bot_bot(filter(A)) )
       => ~ eventually(A,P,Net) ) ) ).

% False_imp_not_eventually
tff(fact_3431_effect__heapE,axiom,
    ! [A: $tType,F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( heap_Time_effect(A,heap_Time_heap(A,F),H2,H4,R3,N)
     => ~ ( ( H4 = aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2))) )
         => ( ( N = aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2))) )
           => ( R3 != aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),A,product_fst(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2)) ) ) ) ) ).

% effect_heapE
tff(fact_3432_effect__heapI,axiom,
    ! [A: $tType,N: nat,F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A] :
      ( ( N = aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2))) )
     => ( ( H4 = aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2))) )
       => ( ( R3 = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),A,product_fst(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2)) )
         => heap_Time_effect(A,heap_Time_heap(A,F),H2,H4,R3,N) ) ) ) ).

% effect_heapI
tff(fact_3433_success__heapI,axiom,
    ! [A: $tType,F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),H2: heap_ext(product_unit)] : heap_Time_success(A,heap_Time_heap(A,F),H2) ).

% success_heapI
tff(fact_3434_cSup__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [B3: set(A),A4: set(A)] :
          ( ( B3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,A4)
           => ( ! [B5: A] :
                  ( pp(member(A,B5,B3))
                 => ? [X3: A] :
                      ( pp(member(A,X3,A4))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B5),X3)) ) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),B3)),aa(set(A),A,complete_Sup_Sup(A),A4))) ) ) ) ) ).

% cSup_mono
tff(fact_3435_cSup__le__iff,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S2: set(A),A3: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,S2)
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),S2)),A3))
            <=> ! [X4: A] :
                  ( pp(member(A,X4,S2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),A3)) ) ) ) ) ) ).

% cSup_le_iff
tff(fact_3436_less__cSup__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X6: set(A),Y: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,X6)
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),aa(set(A),A,complete_Sup_Sup(A),X6)))
            <=> ? [X4: A] :
                  ( pp(member(A,X4,X6))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),X4)) ) ) ) ) ) ).

% less_cSup_iff
tff(fact_3437_partial__order__on__empty,axiom,
    ! [A: $tType] : order_7125193373082350890der_on(A,bot_bot(set(A)),bot_bot(set(product_prod(A,A)))) ).

% partial_order_on_empty
tff(fact_3438_eventually__Inf__base,axiom,
    ! [A: $tType,B3: set(filter(A)),P: fun(A,bool)] :
      ( ( B3 != bot_bot(set(filter(A))) )
     => ( ! [F6: filter(A)] :
            ( pp(member(filter(A),F6,B3))
           => ! [G7: filter(A)] :
                ( pp(member(filter(A),G7,B3))
               => ? [X3: filter(A)] :
                    ( pp(member(filter(A),X3,B3))
                    & pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),X3),aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F6),G7))) ) ) )
       => ( eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),B3))
        <=> ? [X4: filter(A)] :
              ( pp(member(filter(A),X4,B3))
              & eventually(A,P,X4) ) ) ) ) ).

% eventually_Inf_base
tff(fact_3439_cSUP__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),F: fun(B,A),U: A] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))),U))
            <=> ! [X4: B] :
                  ( pp(member(B,X4,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,X4)),U)) ) ) ) ) ) ).

% cSUP_le_iff
tff(fact_3440_cSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),G: fun(C,A),B3: set(C),F: fun(B,A)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(C),set(A),image2(C,A,G),B3))
           => ( ! [N3: B] :
                  ( pp(member(B,N3,A4))
                 => ? [X3: C] :
                      ( pp(member(C,X3,B3))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,N3)),aa(C,A,G,X3))) ) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,G),B3)))) ) ) ) ) ).

% cSUP_mono
tff(fact_3441_cSup__subset__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(A),B3: set(A)] :
          ( ( A4 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,B3)
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A4)),aa(set(A),A,complete_Sup_Sup(A),B3))) ) ) ) ) ).

% cSup_subset_mono
tff(fact_3442_cSup__insert__If,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),A3: A] :
          ( condit941137186595557371_above(A,X6)
         => ( ( ( X6 = bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert2(A,A3),X6)) = A3 ) )
            & ( ( X6 != bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert2(A,A3),X6)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(set(A),A,complete_Sup_Sup(A),X6)) ) ) ) ) ) ).

% cSup_insert_If
tff(fact_3443_cSup__insert,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),A3: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,X6)
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert2(A,A3),X6)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(set(A),A,complete_Sup_Sup(A),X6)) ) ) ) ) ).

% cSup_insert
tff(fact_3444_cSup__union__distrib,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(A),B3: set(A)] :
          ( ( A4 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,A4)
           => ( ( B3 != bot_bot(set(A)) )
             => ( condit941137186595557371_above(A,B3)
               => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),A4)),aa(set(A),A,complete_Sup_Sup(A),B3)) ) ) ) ) ) ) ).

% cSup_union_distrib
tff(fact_3445_less__cSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [A4: set(B),F: fun(B,A),A3: A] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))))
            <=> ? [X4: B] :
                  ( pp(member(B,X4,A4))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),aa(B,A,F,X4))) ) ) ) ) ) ).

% less_cSUP_iff
tff(fact_3446_conditionally__complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),F: fun(B,A),G: fun(B,A)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F),A4))
           => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,G),A4))
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,G),A4))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ly(fun(B,A),fun(fun(B,A),fun(B,A)),F),G)),A4)) ) ) ) ) ) ).

% conditionally_complete_lattice_class.SUP_sup_distrib
tff(fact_3447_cSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),G: fun(B,A),B3: set(B),F: fun(B,A)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,G),B3))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A4),B3))
             => ( ! [X2: B] :
                    ( pp(member(B,X2,A4))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,F,X2)),aa(B,A,G,X2))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,G),B3)))) ) ) ) ) ) ).

% cSUP_subset_mono
tff(fact_3448_cSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(A),B3: set(A)] :
          ( condit941137186595557371_above(A,A4)
         => ( condit941137186595557371_above(A,B3)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) != bot_bot(set(A)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3))),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),A4)),aa(set(A),A,complete_Sup_Sup(A),B3)))) ) ) ) ) ).

% cSup_inter_less_eq
tff(fact_3449_cSUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),F: fun(B,A),A3: B] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F),A4))
           => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),aa(set(B),set(B),insert2(B,A3),A4))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,F,A3)),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))) ) ) ) ) ).

% cSUP_insert
tff(fact_3450_Partial__order__Restr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( order_7125193373082350890der_on(A,field2(A,R3),R3)
     => order_7125193373082350890der_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) ) ).

% Partial_order_Restr
tff(fact_3451_cSUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),F: fun(B,A),B3: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F),A4))
           => ( ( B3 != bot_bot(set(B)) )
             => ( condit941137186595557371_above(A,aa(set(B),set(A),image2(B,A,F),B3))
               => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),B3))) ) ) ) ) ) ) ).

% cSUP_union
tff(fact_3452_ureturn__def,axiom,
    ! [A: $tType,X: A] : ( aa(A,heap_Time_Heap(A),heap_Time_ureturn(A),X) = heap_Time_heap(A,aTP_Lamp_lz(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),X)) ) ).

% ureturn_def
tff(fact_3453_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: fun(B,A),Y5: set(B),X6: set(A),F2: filter(B),F: fun(A,C)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(B),set(A),image2(B,A,G),Y5)),X6))
     => ( eventually(B,aTP_Lamp_ma(set(B),fun(B,bool),Y5),F2)
       => ( map_filter_on(A,C,X6,F,map_filter_on(B,A,Y5,G,F2)) = map_filter_on(B,C,Y5,aa(fun(B,A),fun(B,C),aa(fun(A,C),fun(fun(B,A),fun(B,C)),comp(A,C,B),F),G),F2) ) ) ) ).

% map_filter_on_comp
tff(fact_3454_Ref__Time_Oupdate__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),V: A] : ( ref_update(A,R3,V) = heap_Time_heap(product_unit,aa(A,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mb(ref(A),fun(A,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),R3),V)) ) ) ).

% Ref_Time.update_def
tff(fact_3455_Zorns__po__lemma,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( order_7125193373082350890der_on(A,field2(A,R3),R3)
     => ( ! [C6: set(A)] :
            ( pp(member(set(A),C6,chains(A,R3)))
           => ? [X3: A] :
                ( pp(member(A,X3,field2(A,R3)))
                & ! [Xa4: A] :
                    ( pp(member(A,Xa4,C6))
                   => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa4),X3),R3)) ) ) )
       => ? [X2: A] :
            ( pp(member(A,X2,field2(A,R3)))
            & ! [Xa3: A] :
                ( pp(member(A,Xa3,field2(A,R3)))
               => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Xa3),R3))
                 => ( Xa3 = X2 ) ) ) ) ) ) ).

% Zorns_po_lemma
tff(fact_3456_hoare__tripleE,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn),H2: heap_ext(product_unit),As: set(nat)] :
      ( hoare_hoare_triple(A,P,C2,Q)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
       => ~ ! [R2: A,H5: heap_ext(product_unit)] :
              ( ? [T2: nat] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),C2),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H5),T2))) )
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,Q,R2)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),hoare_new_addrs(H2,As,H5))))
               => ( relH(aa(fun(nat,bool),set(nat),collect(nat),aa(set(nat),fun(nat,bool),aTP_Lamp_mc(heap_ext(product_unit),fun(set(nat),fun(nat,bool)),H2),As)),H2,H5)
                 => ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),lim(product_unit,H2)),lim(product_unit,H5))) ) ) ) ) ) ).

% hoare_tripleE
tff(fact_3457_successE,axiom,
    ! [A: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit)] :
      ( heap_Time_success(A,F,H2)
     => ~ ! [R2: A,H5: product_prod(heap_ext(product_unit),nat)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2) != aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R2),H5)) ) ) ).

% successE
tff(fact_3458_execute__heap,axiom,
    ! [A: $tType,F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))] : ( aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),heap_Time_heap(A,F)) = aa(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(fun(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),comp(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),some(product_prod(A,product_prod(heap_ext(product_unit),nat)))),F) ) ).

% execute_heap
tff(fact_3459_Heap__eqI,axiom,
    ! [A: $tType,F: heap_Time_Heap(A),G: heap_Time_Heap(A)] :
      ( ! [H: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H) = aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),G),H) )
     => ( F = G ) ) ).

% Heap_eqI
tff(fact_3460_execute__ureturn,axiom,
    ! [A: $tType,X: A] : ( aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),aa(A,heap_Time_Heap(A),heap_Time_ureturn(A),X)) = aa(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(fun(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),comp(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),some(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_lz(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),X)) ) ).

% execute_ureturn
tff(fact_3461_execute__update,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),V: A,H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(product_unit),fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(product_unit),ref_update(A,R3,V)),H2) = aa(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),some(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(product_unit,fun(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),product_Pair(product_unit,product_prod(heap_ext(product_unit),nat)),product_Unity),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),ref_set(A,R3,V,H2)),one_one(nat)))) ) ) ).

% execute_update
tff(fact_3462_effect__def,axiom,
    ! [A: $tType,C2: heap_Time_Heap(A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( heap_Time_effect(A,C2,H2,H4,R3,N)
    <=> ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),C2),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H4),N))) ) ) ).

% effect_def
tff(fact_3463_effectI,axiom,
    ! [A: $tType,C2: heap_Time_Heap(A),H2: heap_ext(product_unit),R3: A,H4: heap_ext(product_unit),N: nat] :
      ( ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),C2),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H4),N))) )
     => heap_Time_effect(A,C2,H2,H4,R3,N) ) ).

% effectI
tff(fact_3464_execute__bind__eq__SomeI,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit),X: A,H4: heap_ext(product_unit),N: nat,G: fun(A,heap_Time_Heap(B)),Y: B,H6: heap_ext(product_unit),N2: nat] :
      ( ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),X),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H4),N))) )
     => ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),aa(A,heap_Time_Heap(B),G,X)),H4) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),Y),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H6),N2))) )
       => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_bind(A,B,F,G)),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),Y),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H6),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N2)))) ) ) ) ).

% execute_bind_eq_SomeI
tff(fact_3465_success__bind__executeI,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit),X: A,H4: heap_ext(product_unit),N: nat,G: fun(A,heap_Time_Heap(B))] :
      ( ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),X),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H4),N))) )
     => ( heap_Time_success(B,aa(A,heap_Time_Heap(B),G,X),H4)
       => heap_Time_success(B,heap_Time_bind(A,B,F,G),H2) ) ) ).

% success_bind_executeI
tff(fact_3466_execute__assert_I1_J,axiom,
    ! [A: $tType,P: fun(A,bool),X: A,H2: heap_ext(product_unit)] :
      ( pp(aa(A,bool,P,X))
     => ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),heap_Time_assert(A,P,X)),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),X),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),one_one(nat)))) ) ) ).

% execute_assert(1)
tff(fact_3467_execute__tap,axiom,
    ! [A: $tType,F: fun(heap_ext(product_unit),A),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),heap_Time_tap(A,F)),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),A,F,H2)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),one_one(nat)))) ) ).

% execute_tap
tff(fact_3468_execute__return,axiom,
    ! [A: $tType,X: A] : ( aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),aa(A,heap_Time_Heap(A),heap_Time_return(A),X)) = aa(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(fun(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),comp(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),some(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_lu(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),X)) ) ).

% execute_return
tff(fact_3469_ureturn__bind,axiom,
    ! [A: $tType,B: $tType,X: B,F: fun(B,heap_Time_Heap(A))] : ( heap_Time_bind(B,A,aa(B,heap_Time_Heap(B),heap_Time_ureturn(B),X),F) = aa(B,heap_Time_Heap(A),F,X) ) ).

% ureturn_bind
tff(fact_3470_bind__ureturn,axiom,
    ! [A: $tType,F: heap_Time_Heap(A)] : ( heap_Time_bind(A,A,F,heap_Time_ureturn(A)) = F ) ).

% bind_ureturn
tff(fact_3471_success__ureturnI,axiom,
    ! [A: $tType,X: A,H2: heap_ext(product_unit)] : heap_Time_success(A,aa(A,heap_Time_Heap(A),heap_Time_ureturn(A),X),H2) ).

% success_ureturnI
tff(fact_3472_effect__ureturnE,axiom,
    ! [A: $tType,X: A,H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( heap_Time_effect(A,aa(A,heap_Time_Heap(A),heap_Time_ureturn(A),X),H2,H4,R3,N)
     => ~ ( ( R3 = X )
         => ( ( H4 = H2 )
           => ( N != zero_zero(nat) ) ) ) ) ).

% effect_ureturnE
tff(fact_3473_effect__ureturnI,axiom,
    ! [A: $tType,H2: heap_ext(product_unit),H4: heap_ext(product_unit),X: A] :
      ( ( H2 = H4 )
     => heap_Time_effect(A,aa(A,heap_Time_Heap(A),heap_Time_ureturn(A),X),H2,H4,X,zero_zero(nat)) ) ).

% effect_ureturnI
tff(fact_3474_hoare__triple__def,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( hoare_hoare_triple(A,P,C2,Q)
    <=> ! [H3: heap_ext(product_unit),As7: set(nat)] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As7)))
         => ? [R5: A,H8: heap_ext(product_unit)] :
              ( ? [T7: nat] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),C2),H3) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R5),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H8),T7))) )
              & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,Q,R5)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),hoare_new_addrs(H3,As7,H8))))
              & relH(aa(fun(nat,bool),set(nat),collect(nat),aa(set(nat),fun(nat,bool),aTP_Lamp_mc(heap_ext(product_unit),fun(set(nat),fun(nat,bool)),H3),As7)),H3,H8)
              & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),lim(product_unit,H3)),lim(product_unit,H8))) ) ) ) ).

% hoare_triple_def
tff(fact_3475_hoare__tripleI,axiom,
    ! [A: $tType,P: assn,C2: heap_Time_Heap(A),Q: fun(A,assn)] :
      ( ! [H: heap_ext(product_unit),As2: set(nat)] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
         => ? [R7: A,H7: heap_ext(product_unit),T8: nat] :
              ( ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),C2),H) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R7),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H7),T8))) )
              & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,Q,R7)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H7),hoare_new_addrs(H,As2,H7))))
              & relH(aa(fun(nat,bool),set(nat),collect(nat),aa(set(nat),fun(nat,bool),aTP_Lamp_mc(heap_ext(product_unit),fun(set(nat),fun(nat,bool)),H),As2)),H,H7)
              & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),lim(product_unit,H)),lim(product_unit,H7))) ) )
     => hoare_hoare_triple(A,P,C2,Q) ) ).

% hoare_tripleI
tff(fact_3476_sup__Some,axiom,
    ! [A: $tType] :
      ( sup(A)
     => ! [X: A,Y: A] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),sup_sup(option(A)),aa(A,option(A),some(A),X)),aa(A,option(A),some(A),Y)) = aa(A,option(A),some(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X),Y)) ) ) ).

% sup_Some
tff(fact_3477_inf__Some,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [X: A,Y: A] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),inf_inf(option(A)),aa(A,option(A),some(A),X)),aa(A,option(A),some(A),Y)) = aa(A,option(A),some(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),X),Y)) ) ) ).

% inf_Some
tff(fact_3478_Some__SUP,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(A),F: fun(A,B)] :
          ( ( A4 != bot_bot(set(A)) )
         => ( aa(B,option(B),some(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image2(A,B,F),A4))) = aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),aa(set(A),set(option(B)),image2(A,option(B),aTP_Lamp_md(fun(A,B),fun(A,option(B)),F)),A4)) ) ) ) ).

% Some_SUP
tff(fact_3479_rel__of__def,axiom,
    ! [B: $tType,A: $tType,M4: fun(A,option(B)),P: fun(product_prod(A,B),bool)] : ( rel_of(A,B,M4,P) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(fun(product_prod(A,B),bool),fun(A,fun(B,bool)),aTP_Lamp_me(fun(A,option(B)),fun(fun(product_prod(A,B),bool),fun(A,fun(B,bool))),M4),P))) ) ).

% rel_of_def
tff(fact_3480_effect__guardI,axiom,
    ! [A: $tType,P: fun(heap_ext(product_unit),bool),H2: heap_ext(product_unit),H4: heap_ext(product_unit),F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),N: nat,R3: A] :
      ( pp(aa(heap_ext(product_unit),bool,P,H2))
     => ( ( H4 = aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2))) )
       => ( ( N = aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2))) )
         => ( ( R3 = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),A,product_fst(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2)) )
           => heap_Time_effect(A,heap_Time_guard(A,P,F),H2,H4,R3,N) ) ) ) ) ).

% effect_guardI
tff(fact_3481_success__guardI,axiom,
    ! [A: $tType,P: fun(heap_ext(product_unit),bool),H2: heap_ext(product_unit),F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))] :
      ( pp(aa(heap_ext(product_unit),bool,P,H2))
     => heap_Time_success(A,heap_Time_guard(A,P,F),H2) ) ).

% success_guardI
tff(fact_3482_execute__guard_I2_J,axiom,
    ! [A: $tType,P: fun(heap_ext(product_unit),bool),H2: heap_ext(product_unit),F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))] :
      ( pp(aa(heap_ext(product_unit),bool,P,H2))
     => ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),heap_Time_guard(A,P,F)),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2)) ) ) ).

% execute_guard(2)
tff(fact_3483_Some__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(A)] :
          ( ( A4 != bot_bot(set(A)) )
         => ( aa(A,option(A),some(A),aa(set(A),A,complete_Sup_Sup(A),A4)) = aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),aa(set(A),set(option(A)),image2(A,option(A),some(A)),A4)) ) ) ) ).

% Some_Sup
tff(fact_3484_effect__guardE,axiom,
    ! [A: $tType,P: fun(heap_ext(product_unit),bool),F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( heap_Time_effect(A,heap_Time_guard(A,P,F),H2,H4,R3,N)
     => ~ ( ( H4 = aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2))) )
         => ( ( N = aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2))) )
           => ( ( R3 = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),A,product_fst(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),F,H2)) )
             => ~ pp(aa(heap_ext(product_unit),bool,P,H2)) ) ) ) ) ).

% effect_guardE
tff(fact_3485_execute__change,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [F: fun(A,A),R3: ref(A),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),ref_change(A,F,R3)),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),aa(A,A,F,aa(ref(A),A,ref_get(A,H2),R3))),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),ref_set(A,R3,aa(A,A,F,aa(ref(A),A,ref_get(A,H2),R3)),H2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))))) ) ) ).

% execute_change
tff(fact_3486_map__to__set__upd,axiom,
    ! [B: $tType,A: $tType,M4: fun(A,option(B)),K: A,V: B] : ( map_to_set(A,B,fun_upd(A,option(B),M4,K,aa(B,option(B),some(B),V))) = aa(set(product_prod(A,B)),set(product_prod(A,B)),insert2(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V)),aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),map_to_set(A,B,M4)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aTP_Lamp_mf(A,fun(product_prod(A,B),bool),K)))) ) ).

% map_to_set_upd
tff(fact_3487_effectE,axiom,
    ! [A: $tType,C2: heap_Time_Heap(A),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( heap_Time_effect(A,C2,H2,H4,R3,N)
     => ~ ( ( R3 = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),A,product_fst(A,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(A,product_prod(heap_ext(product_unit),nat)),the2(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),C2),H2))) )
         => ( ( H4 = aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(A,product_prod(heap_ext(product_unit),nat)),the2(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),C2),H2)))) )
           => ( ( N = aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(A,product_prod(heap_ext(product_unit),nat)),the2(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),C2),H2)))) )
             => ~ heap_Time_success(A,C2,H2) ) ) ) ) ).

% effectE
tff(fact_3488_execute__bind_I1_J,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit),X: A,H4: heap_ext(product_unit),N: nat,G: fun(A,heap_Time_Heap(B))] :
      ( ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),X),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H4),N))) )
     => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_bind(A,B,F,G)),H2) = heap_Time_timeFrame(B,N,aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),aa(A,heap_Time_Heap(B),G,X)),H4)) ) ) ).

% execute_bind(1)
tff(fact_3489_wait__def,axiom,
    ! [N: nat] : ( heap_Time_wait(N) = aa(fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(product_unit),heap_Time_Heap2(product_unit),aTP_Lamp_mg(nat,fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),N)) ) ).

% wait_def
tff(fact_3490_Heap_Oinject,axiom,
    ! [A: $tType,X: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),Ya: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] :
      ( ( aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X) = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),Ya) )
    <=> ( X = Ya ) ) ).

% Heap.inject
tff(fact_3491_Heap__execute,axiom,
    ! [A: $tType,F: heap_Time_Heap(A)] : ( aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F)) = F ) ).

% Heap_execute
tff(fact_3492_timeFrame__zero,axiom,
    ! [A: $tType,H2: option(product_prod(A,product_prod(heap_ext(product_unit),nat)))] : ( heap_Time_timeFrame(A,zero_zero(nat),H2) = H2 ) ).

% timeFrame_zero
tff(fact_3493_timeFrame__assoc,axiom,
    ! [A: $tType,N: nat,N2: nat,F: option(product_prod(A,product_prod(heap_ext(product_unit),nat)))] : ( heap_Time_timeFrame(A,N,heap_Time_timeFrame(A,N2,F)) = heap_Time_timeFrame(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N2),F) ) ).

% timeFrame_assoc
tff(fact_3494_Heap_Oexhaust,axiom,
    ! [A: $tType,Y: heap_Time_Heap(A)] :
      ~ ! [X2: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( Y != aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X2) ) ).

% Heap.exhaust
tff(fact_3495_execute_Osimps,axiom,
    ! [A: $tType,F: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),F)) = F ) ).

% execute.simps
tff(fact_3496_heap__def,axiom,
    ! [A: $tType,F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))] : ( heap_Time_heap(A,F) = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),aa(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(fun(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),comp(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),some(product_prod(A,product_prod(heap_ext(product_unit),nat)))),F)) ) ).

% heap_def
tff(fact_3497_execute__bind__success,axiom,
    ! [B: $tType,A: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit),G: fun(A,heap_Time_Heap(B))] :
      ( heap_Time_success(A,F,H2)
     => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_bind(A,B,F,G)),H2) = heap_Time_timeFrame(B,aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(A,product_prod(heap_ext(product_unit),nat)),the2(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2)))),aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),aa(A,heap_Time_Heap(B),G,aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),A,product_fst(A,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(A,product_prod(heap_ext(product_unit),nat)),the2(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2))))),aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(A,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(A,product_prod(heap_ext(product_unit),nat)),the2(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2)))))) ) ) ).

% execute_bind_success
tff(fact_3498_tap__def,axiom,
    ! [A: $tType,F: fun(heap_ext(product_unit),A)] : ( heap_Time_tap(A,F) = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),aTP_Lamp_mh(fun(heap_ext(product_unit),A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),F)) ) ).

% tap_def
tff(fact_3499_timeFrame_Osimps_I1_J,axiom,
    ! [A: $tType,N: nat,R3: A,H2: heap_ext(product_unit),N2: nat] : ( heap_Time_timeFrame(A,N,aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),N2)))) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N2)))) ) ).

% timeFrame.simps(1)
tff(fact_3500_execute__lookup,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),ref_lookup(A,R3)),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),aa(ref(A),A,ref_get(A,H2),R3)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),one_one(nat)))) ) ) ).

% execute_lookup
tff(fact_3501_comp__the__Some,axiom,
    ! [A: $tType] : ( aa(fun(A,option(A)),fun(A,A),aa(fun(option(A),A),fun(fun(A,option(A)),fun(A,A)),comp(option(A),A,A),the2(A)),some(A)) = id(A) ) ).

% comp_the_Some
tff(fact_3502_sngr__assn__raw_Osimps,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),X: A,H2: heap_ext(product_unit),As: set(nat)] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,R3,X),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
        <=> ( ( aa(ref(A),A,ref_get(A,H2),R3) = X )
            & ( As = aa(set(nat),set(nat),insert2(nat,aa(ref(A),nat,addr_of_ref(A),R3)),bot_bot(set(nat))) )
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(ref(A),nat,addr_of_ref(A),R3)),lim(product_unit,H2))) ) ) ) ).

% sngr_assn_raw.simps
tff(fact_3503_sngr__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
          ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X,Xa),Xb))
          <=> pp(Y) )
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ( pp(Y)
                <=> ~ ( ( aa(ref(A),A,ref_get(A,H),X) = Xa )
                      & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(A),nat,addr_of_ref(A),X)),bot_bot(set(nat))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(ref(A),nat,addr_of_ref(A),X)),lim(product_unit,H))) ) ) ) ) ) ).

% sngr_assn_raw.elims(1)
tff(fact_3504_sngr__assn__raw_Oelims_I2_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X,Xa),Xb))
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ~ ( ( aa(ref(A),A,ref_get(A,H),X) = Xa )
                    & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(A),nat,addr_of_ref(A),X)),bot_bot(set(nat))) )
                    & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(ref(A),nat,addr_of_ref(A),X)),lim(product_unit,H))) ) ) ) ) ).

% sngr_assn_raw.elims(2)
tff(fact_3505_sngr__assn__raw_Oelims_I3_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X,Xa),Xb))
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ( ( aa(ref(A),A,ref_get(A,H),X) = Xa )
                  & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(A),nat,addr_of_ref(A),X)),bot_bot(set(nat))) )
                  & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(ref(A),nat,addr_of_ref(A),X)),lim(product_unit,H))) ) ) ) ) ).

% sngr_assn_raw.elims(3)
tff(fact_3506_relH__ref,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: ref(A)] :
          ( relH(As,H2,H4)
         => ( pp(member(nat,aa(ref(A),nat,addr_of_ref(A),R3),As))
           => ( aa(ref(A),A,ref_get(A,H2),R3) = aa(ref(A),A,ref_get(A,H4),R3) ) ) ) ) ).

% relH_ref
tff(fact_3507_relH__set__ref,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),As: set(nat),H2: heap_ext(product_unit),X: A] :
          ( ~ pp(member(nat,aa(ref(A),nat,addr_of_ref(A),R3),As))
         => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
           => relH(As,H2,ref_set(A,R3,X,H2)) ) ) ) ).

% relH_set_ref
tff(fact_3508_Heap_Osize__gen,axiom,
    ! [A: $tType,Xa: fun(A,nat),X: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(A),nat,heap_Time_size_Heap(A,Xa),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% Heap.size_gen
tff(fact_3509_sngr__assn__raw_Opelims_I3_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X,Xa),Xb))
         => ( pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))))
                   => ( ( aa(ref(A),A,ref_get(A,H),X) = Xa )
                      & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(A),nat,addr_of_ref(A),X)),bot_bot(set(nat))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(ref(A),nat,addr_of_ref(A),X)),lim(product_unit,H))) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(3)
tff(fact_3510_sngr__assn__raw_Opelims_I2_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X,Xa),Xb))
         => ( pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))))
                   => ~ ( ( aa(ref(A),A,ref_get(A,H),X) = Xa )
                        & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(A),nat,addr_of_ref(A),X)),bot_bot(set(nat))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(ref(A),nat,addr_of_ref(A),X)),lim(product_unit,H))) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(2)
tff(fact_3511_sngr__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: ref(A),Xa: A,Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
          ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,sngr_assn_raw(A,X,Xa),Xb))
          <=> pp(Y) )
         => ( pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( ( pp(Y)
                    <=> ( ( aa(ref(A),A,ref_get(A,H),X) = Xa )
                        & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(A),nat,addr_of_ref(A),X)),bot_bot(set(nat))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(ref(A),nat,addr_of_ref(A),X)),lim(product_unit,H))) ) )
                   => ~ pp(aa(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(A)),aa(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(A),fun(product_prod(A,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat))),aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(A,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))) ) ) ) ) ) ).

% sngr_assn_raw.pelims(1)
tff(fact_3512_Heap_Osize_I2_J,axiom,
    ! [A: $tType,X: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( size_size(heap_Time_Heap(A),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% Heap.size(2)
tff(fact_3513_Heap_Osize__neq,axiom,
    ! [A: $tType,X: heap_Time_Heap(A)] : ( size_size(heap_Time_Heap(A),X) != zero_zero(nat) ) ).

% Heap.size_neq
tff(fact_3514_set__to__map__simp,axiom,
    ! [B: $tType,A: $tType,S2: set(product_prod(A,B)),K: A,V: B] :
      ( inj_on(product_prod(A,B),A,product_fst(A,B),S2)
     => ( ( aa(A,option(B),set_to_map(A,B,S2),K) = aa(B,option(B),some(B),V) )
      <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V),S2)) ) ) ).

% set_to_map_simp
tff(fact_3515_Chains__subset_H,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( refl_on(A,top_top(set(A)),R3)
     => pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),aa(fun(set(A),bool),set(set(A)),collect(set(A)),pred_chain(A,top_top(set(A)),aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3)))),chains(A,R3))) ) ).

% Chains_subset'
tff(fact_3516_timeFrame_Oelims,axiom,
    ! [A: $tType,X: nat,Xa: option(product_prod(A,product_prod(heap_ext(product_unit),nat))),Y: option(product_prod(A,product_prod(heap_ext(product_unit),nat)))] :
      ( ( heap_Time_timeFrame(A,X,Xa) = Y )
     => ( ! [R2: A,H: heap_ext(product_unit),N6: nat] :
            ( ( Xa = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),N6))) )
           => ( Y != aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X),N6)))) ) )
       => ~ ( ( Xa = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) )
           => ( Y != none(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ) ) ) ).

% timeFrame.elims
tff(fact_3517_the__dflt__None__nonempty,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ( S2 != bot_bot(set(A)) )
     => ( dflt_None_set(A,S2) = aa(set(A),option(set(A)),some(set(A)),S2) ) ) ).

% the_dflt_None_nonempty
tff(fact_3518_Chains__subset,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),chains(A,R3)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),pred_chain(A,top_top(set(A)),aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3))))) ).

% Chains_subset
tff(fact_3519_singleton__None__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),aa(set(option(A)),set(option(A)),insert2(option(A),none(A)),bot_bot(set(option(A))))) = none(A) ) ) ).

% singleton_None_Sup
tff(fact_3520_empty__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ( aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),bot_bot(set(option(A)))) = none(A) ) ) ).

% empty_Sup
tff(fact_3521_inf__None__2,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [X: option(A)] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),inf_inf(option(A)),X),none(A)) = none(A) ) ) ).

% inf_None_2
tff(fact_3522_inf__None__1,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [Y: option(A)] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),inf_inf(option(A)),none(A)),Y) = none(A) ) ) ).

% inf_None_1
tff(fact_3523_not__Some__eq2,axiom,
    ! [B: $tType,A: $tType,V: option(product_prod(A,B))] :
      ( ! [X4: A,Y3: B] : ( V != aa(product_prod(A,B),option(product_prod(A,B)),some(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Y3)) )
    <=> ( V = none(product_prod(A,B)) ) ) ).

% not_Some_eq2
tff(fact_3524_set__to__map__empty,axiom,
    ! [A: $tType,B: $tType,X3: A] : ( aa(A,option(B),set_to_map(A,B,bot_bot(set(product_prod(A,B)))),X3) = none(B) ) ).

% set_to_map_empty
tff(fact_3525_map__to__set__empty,axiom,
    ! [B: $tType,A: $tType] : ( map_to_set(A,B,aTP_Lamp_mi(A,option(B))) = bot_bot(set(product_prod(A,B))) ) ).

% map_to_set_empty
tff(fact_3526_rel__of__empty,axiom,
    ! [B: $tType,A: $tType,P: fun(product_prod(A,B),bool)] : ( rel_of(A,B,aTP_Lamp_mi(A,option(B)),P) = bot_bot(set(product_prod(A,B))) ) ).

% rel_of_empty
tff(fact_3527_set__to__map__empty__iff_I2_J,axiom,
    ! [B: $tType,A: $tType,S2: set(product_prod(A,B))] :
      ( ( aTP_Lamp_mi(A,option(B)) = set_to_map(A,B,S2) )
    <=> ( S2 = bot_bot(set(product_prod(A,B))) ) ) ).

% set_to_map_empty_iff(2)
tff(fact_3528_set__to__map__empty__iff_I1_J,axiom,
    ! [B: $tType,A: $tType,S2: set(product_prod(A,B))] :
      ( ! [X4: A] : ( aa(A,option(B),set_to_map(A,B,S2),X4) = none(B) )
    <=> ( S2 = bot_bot(set(product_prod(A,B))) ) ) ).

% set_to_map_empty_iff(1)
tff(fact_3529_bot__option__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ( bot_bot(option(A)) = none(A) ) ) ).

% bot_option_def
tff(fact_3530_pred__on_Ochain__empty,axiom,
    ! [A: $tType,A4: set(A),P: fun(A,fun(A,bool))] : pp(aa(set(A),bool,pred_chain(A,A4,P),bot_bot(set(A)))) ).

% pred_on.chain_empty
tff(fact_3531_timeFrame_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat] : ( heap_Time_timeFrame(A,N,none(product_prod(A,product_prod(heap_ext(product_unit),nat)))) = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ).

% timeFrame.simps(2)
tff(fact_3532_subset_Ochain__empty,axiom,
    ! [A: $tType,A4: set(set(A))] : pp(aa(set(set(A)),bool,pred_chain(set(A),A4,ord_less(set(A))),bot_bot(set(set(A))))) ).

% subset.chain_empty
tff(fact_3533_execute__bind_I2_J,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit),G: fun(A,heap_Time_Heap(B))] :
      ( ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2) = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) )
     => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_bind(A,B,F,G)),H2) = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) ) ) ).

% execute_bind(2)
tff(fact_3534_successI,axiom,
    ! [A: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit)] :
      ( ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2) != none(product_prod(A,product_prod(heap_ext(product_unit),nat))) )
     => heap_Time_success(A,F,H2) ) ).

% successI
tff(fact_3535_success__def,axiom,
    ! [A: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit)] :
      ( heap_Time_success(A,F,H2)
    <=> ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2) != none(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ) ).

% success_def
tff(fact_3536_map__to__set__empty__iff_I2_J,axiom,
    ! [A: $tType,B: $tType,M4: fun(A,option(B))] :
      ( ( bot_bot(set(product_prod(A,B))) = map_to_set(A,B,M4) )
    <=> ! [X4: A] : ( aa(A,option(B),M4,X4) = none(B) ) ) ).

% map_to_set_empty_iff(2)
tff(fact_3537_map__to__set__empty__iff_I1_J,axiom,
    ! [A: $tType,B: $tType,M4: fun(A,option(B))] :
      ( ( map_to_set(A,B,M4) = bot_bot(set(product_prod(A,B))) )
    <=> ! [X4: A] : ( aa(A,option(B),M4,X4) = none(B) ) ) ).

% map_to_set_empty_iff(1)
tff(fact_3538_execute__guard_I1_J,axiom,
    ! [A: $tType,P: fun(heap_ext(product_unit),bool),H2: heap_ext(product_unit),F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))] :
      ( ~ pp(aa(heap_ext(product_unit),bool,P,H2))
     => ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),heap_Time_guard(A,P,F)),H2) = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ) ).

% execute_guard(1)
tff(fact_3539_execute__assert_I2_J,axiom,
    ! [A: $tType,P: fun(A,bool),X: A,H2: heap_ext(product_unit)] :
      ( ~ pp(aa(A,bool,P,X))
     => ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),heap_Time_assert(A,P,X)),H2) = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ) ).

% execute_assert(2)
tff(fact_3540_execute__raise,axiom,
    ! [A: $tType,S: list(char),X3: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),heap_Time_raise(A,S)),X3) = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ).

% execute_raise
tff(fact_3541_raise__def,axiom,
    ! [A: $tType,S: list(char)] : ( heap_Time_raise(A,S) = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),aTP_Lamp_mj(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))) ) ).

% raise_def
tff(fact_3542_Heap__cases,axiom,
    ! [A: $tType,F: heap_Time_Heap(A),H2: heap_ext(product_unit)] :
      ( ! [X2: A,H5: product_prod(heap_ext(product_unit),nat)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2) != aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),X2),H5)) )
     => ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),F),H2) = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ) ).

% Heap_cases
tff(fact_3543_timeFrame_Ocases,axiom,
    ! [A: $tType,X: product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] :
      ( ! [N3: nat,R2: A,H: heap_ext(product_unit),N6: nat] : ( X != aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(nat,fun(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),product_Pair(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),N3),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),N6)))) )
     => ~ ! [N3: nat] : ( X != aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(nat,fun(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),product_Pair(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),N3),none(product_prod(A,product_prod(heap_ext(product_unit),nat)))) ) ) ).

% timeFrame.cases
tff(fact_3544_subset__Zorn__nonempty,axiom,
    ! [A: $tType,A16: set(set(A))] :
      ( ( A16 != bot_bot(set(set(A))) )
     => ( ! [C8: set(set(A))] :
            ( ( C8 != bot_bot(set(set(A))) )
           => ( pp(aa(set(set(A)),bool,pred_chain(set(A),A16,ord_less(set(A))),C8))
             => pp(member(set(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C8),A16)) ) )
       => ? [X2: set(A)] :
            ( pp(member(set(A),X2,A16))
            & ! [Xa3: set(A)] :
                ( pp(member(set(A),Xa3,A16))
               => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X2),Xa3))
                 => ( Xa3 = X2 ) ) ) ) ) ) ).

% subset_Zorn_nonempty
tff(fact_3545_guard__def,axiom,
    ! [A: $tType,P: fun(heap_ext(product_unit),bool),F: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))] : ( heap_Time_guard(A,P,F) = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),aa(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mk(fun(heap_ext(product_unit),bool),fun(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),P),F)) ) ).

% guard_def
tff(fact_3546_Union__in__chain,axiom,
    ! [A: $tType,B11: set(set(A)),A16: set(set(A))] :
      ( pp(aa(set(set(A)),bool,finite_finite(set(A)),B11))
     => ( ( B11 != bot_bot(set(set(A))) )
       => ( pp(aa(set(set(A)),bool,pred_chain(set(A),A16,ord_less(set(A))),B11))
         => pp(member(set(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B11),B11)) ) ) ) ).

% Union_in_chain
tff(fact_3547_Inter__in__chain,axiom,
    ! [A: $tType,B11: set(set(A)),A16: set(set(A))] :
      ( pp(aa(set(set(A)),bool,finite_finite(set(A)),B11))
     => ( ( B11 != bot_bot(set(set(A))) )
       => ( pp(aa(set(set(A)),bool,pred_chain(set(A),A16,ord_less(set(A))),B11))
         => pp(member(set(A),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B11),B11)) ) ) ) ).

% Inter_in_chain
tff(fact_3548_subset_Ochain__extend,axiom,
    ! [A: $tType,A4: set(set(A)),C3: set(set(A)),Z2: set(A)] :
      ( pp(aa(set(set(A)),bool,pred_chain(set(A),A4,ord_less(set(A))),C3))
     => ( pp(member(set(A),Z2,A4))
       => ( ! [X2: set(A)] :
              ( pp(member(set(A),X2,C3))
             => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aa(fun(set(A),fun(set(A),bool)),fun(set(A),fun(set(A),bool)),aa(fun(set(A),fun(set(A),bool)),fun(fun(set(A),fun(set(A),bool)),fun(set(A),fun(set(A),bool))),sup_sup(fun(set(A),fun(set(A),bool))),ord_less(set(A))),fequal(set(A))),X2),Z2)) )
         => pp(aa(set(set(A)),bool,pred_chain(set(A),A4,ord_less(set(A))),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),aa(set(set(A)),set(set(A)),insert2(set(A),Z2),bot_bot(set(set(A))))),C3))) ) ) ) ).

% subset.chain_extend
tff(fact_3549_pred__on_Ochain__extend,axiom,
    ! [A: $tType,A4: set(A),P: fun(A,fun(A,bool)),C3: set(A),Z2: A] :
      ( pp(aa(set(A),bool,pred_chain(A,A4,P),C3))
     => ( pp(member(A,Z2,A4))
       => ( ! [X2: A] :
              ( pp(member(A,X2,C3))
             => pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),sup_sup(fun(A,fun(A,bool))),P),fequal(A)),X2),Z2)) )
         => pp(aa(set(A),bool,pred_chain(A,A4,P),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert2(A,Z2),bot_bot(set(A)))),C3))) ) ) ) ).

% pred_on.chain_extend
tff(fact_3550_finite__subset__Union__chain,axiom,
    ! [A: $tType,A4: set(A),B11: set(set(A)),A16: set(set(A))] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B11)))
       => ( ( B11 != bot_bot(set(set(A))) )
         => ( pp(aa(set(set(A)),bool,pred_chain(set(A),A16,ord_less(set(A))),B11))
           => ~ ! [B9: set(A)] :
                  ( pp(member(set(A),B9,B11))
                 => ~ pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B9)) ) ) ) ) ) ).

% finite_subset_Union_chain
tff(fact_3551_Chains__alt__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( refl_on(A,top_top(set(A)),R3)
     => ( chains(A,R3) = aa(fun(set(A),bool),set(set(A)),collect(set(A)),pred_chain(A,top_top(set(A)),aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3))) ) ) ).

% Chains_alt_def
tff(fact_3552_the__dflt__None__set,axiom,
    ! [A: $tType,X: set(A)] : ( the_default(set(A),bot_bot(set(A)),dflt_None_set(A,X)) = X ) ).

% the_dflt_None_set
tff(fact_3553_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A4: set(A)] : ( aa(set(A),A,lattic5882676163264333800up_fin(A),A4) = aa(option(A),A,the2(A),finite_fold(A,option(A),aTP_Lamp_ml(A,fun(option(A),option(A))),none(A),A4)) ) ) ).

% Sup_fin.eq_fold'
tff(fact_3554_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A4: set(A)] : ( aa(set(A),A,lattic7752659483105999362nf_fin(A),A4) = aa(option(A),A,the2(A),finite_fold(A,option(A),aTP_Lamp_mm(A,fun(option(A),option(A))),none(A),A4)) ) ) ).

% Inf_fin.eq_fold'
tff(fact_3555_Heap__Time__Monad_Obind__def,axiom,
    ! [B: $tType,A: $tType,F: heap_Time_Heap(A),G: fun(A,heap_Time_Heap(B))] : ( heap_Time_bind(A,B,F,G) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),aa(fun(A,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mp(heap_Time_Heap(A),fun(fun(A,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),F),G)) ) ).

% Heap_Time_Monad.bind_def
tff(fact_3556_Sup__option__def,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: set(option(A))] :
          ( ( ( ( A4 = bot_bot(set(option(A))) )
              | ( A4 = aa(set(option(A)),set(option(A)),insert2(option(A),none(A)),bot_bot(set(option(A)))) ) )
           => ( aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),A4) = none(A) ) )
          & ( ~ ( ( A4 = bot_bot(set(option(A))) )
                | ( A4 = aa(set(option(A)),set(option(A)),insert2(option(A),none(A)),bot_bot(set(option(A)))) ) )
           => ( aa(set(option(A)),option(A),complete_Sup_Sup(option(A)),A4) = aa(A,option(A),some(A),aa(set(A),A,complete_Sup_Sup(A),these(A,A4))) ) ) ) ) ).

% Sup_option_def
tff(fact_3557_the__dflt__None__empty,axiom,
    ! [A: $tType] : ( dflt_None_set(A,bot_bot(set(A))) = none(set(A)) ) ).

% the_dflt_None_empty
tff(fact_3558_these__empty,axiom,
    ! [A: $tType] : ( these(A,bot_bot(set(option(A)))) = bot_bot(set(A)) ) ).

% these_empty
tff(fact_3559_these__empty__eq,axiom,
    ! [A: $tType,B3: set(option(A))] :
      ( ( these(A,B3) = bot_bot(set(A)) )
    <=> ( ( B3 = bot_bot(set(option(A))) )
        | ( B3 = aa(set(option(A)),set(option(A)),insert2(option(A),none(A)),bot_bot(set(option(A)))) ) ) ) ).

% these_empty_eq
tff(fact_3560_these__not__empty__eq,axiom,
    ! [A: $tType,B3: set(option(A))] :
      ( ( these(A,B3) != bot_bot(set(A)) )
    <=> ( ( B3 != bot_bot(set(option(A))) )
        & ( B3 != aa(set(option(A)),set(option(A)),insert2(option(A),none(A)),bot_bot(set(option(A)))) ) ) ) ).

% these_not_empty_eq
tff(fact_3561_dflt__None__set__def,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ( ( S2 = bot_bot(set(A)) )
       => ( dflt_None_set(A,S2) = none(set(A)) ) )
      & ( ( S2 != bot_bot(set(A)) )
       => ( dflt_None_set(A,S2) = aa(set(A),option(set(A)),some(set(A)),S2) ) ) ) ).

% dflt_None_set_def
tff(fact_3562_sup__option__def,axiom,
    ! [A: $tType] :
      ( sup(A)
     => ! [X: option(A),Y: option(A)] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),sup_sup(option(A)),X),Y) = case_option(option(A),A,Y,aa(option(A),fun(A,option(A)),aTP_Lamp_mr(option(A),fun(option(A),fun(A,option(A))),X),Y),X) ) ) ).

% sup_option_def
tff(fact_3563_execute__bind__case,axiom,
    ! [A: $tType,B: $tType,F: heap_Time_Heap(B),G: fun(B,heap_Time_Heap(A)),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),heap_Time_bind(B,A,F,G)),H2) = case_option(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(B,product_prod(heap_ext(product_unit),nat)),none(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(fun(B,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),product_case_prod(B,product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mt(fun(B,heap_Time_Heap(A)),fun(B,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),G)),aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),F),H2)) ) ).

% execute_bind_case
tff(fact_3564_inf__option__def,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [X: option(A),Y: option(A)] : ( aa(option(A),option(A),aa(option(A),fun(option(A),option(A)),inf_inf(option(A)),X),Y) = case_option(option(A),A,none(A),aTP_Lamp_mv(option(A),fun(A,option(A)),Y),X) ) ) ).

% inf_option_def
tff(fact_3565_timeFrame_Opelims,axiom,
    ! [A: $tType,X: nat,Xa: option(product_prod(A,product_prod(heap_ext(product_unit),nat))),Y: option(product_prod(A,product_prod(heap_ext(product_unit),nat)))] :
      ( ( heap_Time_timeFrame(A,X,Xa) = Y )
     => ( pp(aa(product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),bool,accp(product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_T5500966940807335491me_rel(A)),aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(nat,fun(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),product_Pair(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),X),Xa)))
       => ( ! [R2: A,H: heap_ext(product_unit),N6: nat] :
              ( ( Xa = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),N6))) )
             => ( ( Y = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X),N6)))) )
               => ~ pp(aa(product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),bool,accp(product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_T5500966940807335491me_rel(A)),aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(nat,fun(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),product_Pair(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),X),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),N6)))))) ) )
         => ~ ( ( Xa = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) )
             => ( ( Y = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) )
               => ~ pp(aa(product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),bool,accp(product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_T5500966940807335491me_rel(A)),aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(nat,fun(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),product_Pair(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),X),none(product_prod(A,product_prod(heap_ext(product_unit),nat)))))) ) ) ) ) ) ).

% timeFrame.pelims
tff(fact_3566_execute__ref,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [V: A,H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(ref(A)),fun(heap_ext(product_unit),option(product_prod(ref(A),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(ref(A)),ref_ref(A,V)),H2) = aa(product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(ref(A),heap_ext(product_unit)),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),aa(fun(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(ref(A),heap_ext(product_unit)),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(ref(A),heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mw(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))))),ref_alloc(A,V,H2))) ) ) ).

% execute_ref
tff(fact_3567_ref__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [V: A] : ( ref_ref(A,V) = heap_Time_heap(ref(A),aTP_Lamp_mx(A,fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),V)) ) ) ).

% ref_def
tff(fact_3568_map__upd__eq__restrict,axiom,
    ! [B: $tType,A: $tType,M4: fun(A,option(B)),X: A] : ( fun_upd(A,option(B),M4,X,none(B)) = restrict_map(A,B,M4,aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))) ) ).

% map_upd_eq_restrict
tff(fact_3569_proj__iff,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X: A,Y: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,X),aa(set(A),set(A),insert2(A,Y),bot_bot(set(A))))),A4))
       => ( ( aa(A,set(A),equiv_proj(A,A,R3),X) = aa(A,set(A),equiv_proj(A,A,R3),Y) )
        <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3)) ) ) ) ).

% proj_iff
tff(fact_3570_quotient__eqI,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X6: set(A),Y5: set(A),X: A,Y: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(set(A),X6,equiv_quotient(A,A4,R3)))
       => ( pp(member(set(A),Y5,equiv_quotient(A,A4,R3)))
         => ( pp(member(A,X,X6))
           => ( pp(member(A,Y,Y5))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
               => ( X6 = Y5 ) ) ) ) ) ) ) ).

% quotient_eqI
tff(fact_3571_quotient__eq__iff,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X6: set(A),Y5: set(A),X: A,Y: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(set(A),X6,equiv_quotient(A,A4,R3)))
       => ( pp(member(set(A),Y5,equiv_quotient(A,A4,R3)))
         => ( pp(member(A,X,X6))
           => ( pp(member(A,Y,Y5))
             => ( ( X6 = Y5 )
              <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3)) ) ) ) ) ) ) ).

% quotient_eq_iff
tff(fact_3572_in__quotient__imp__closed,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X6: set(A),X: A,Y: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(set(A),X6,equiv_quotient(A,A4,R3)))
       => ( pp(member(A,X,X6))
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
           => pp(member(A,Y,X6)) ) ) ) ) ).

% in_quotient_imp_closed
tff(fact_3573_in__quotient__imp__non__empty,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X6: set(A)] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(set(A),X6,equiv_quotient(A,A4,R3)))
       => ( X6 != bot_bot(set(A)) ) ) ) ).

% in_quotient_imp_non_empty
tff(fact_3574_equiv__class__self,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),A3: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(A,A3,A4))
       => pp(member(A,A3,image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))) ) ) ).

% equiv_class_self
tff(fact_3575_quotient__disj,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X6: set(A),Y5: set(A)] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(set(A),X6,equiv_quotient(A,A4,R3)))
       => ( pp(member(set(A),Y5,equiv_quotient(A,A4,R3)))
         => ( ( X6 = Y5 )
            | ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),X6),Y5) = bot_bot(set(A)) ) ) ) ) ) ).

% quotient_disj
tff(fact_3576_effect__refI,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),H4: heap_ext(product_unit),V: A,H2: heap_ext(product_unit),N: nat] :
          ( ( aa(heap_ext(product_unit),product_prod(ref(A),heap_ext(product_unit)),aa(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),heap_ext(product_unit))),product_Pair(ref(A),heap_ext(product_unit)),R3),H4) = ref_alloc(A,V,H2) )
         => ( ( N = one_one(nat) )
           => heap_Time_effect(ref(A),ref_ref(A,V),H2,H4,R3,N) ) ) ) ).

% effect_refI
tff(fact_3577_equiv__proj,axiom,
    ! [A: $tType,A4: set(A),R: set(product_prod(A,A)),Z2: product_prod(A,A)] :
      ( equiv_equiv(A,A4,R)
     => ( pp(member(product_prod(A,A),Z2,R))
       => ( aa(product_prod(A,A),set(A),aa(fun(product_prod(A,A),A),fun(product_prod(A,A),set(A)),aa(fun(A,set(A)),fun(fun(product_prod(A,A),A),fun(product_prod(A,A),set(A))),comp(A,set(A),product_prod(A,A)),equiv_proj(A,A,R)),product_fst(A,A)),Z2) = aa(product_prod(A,A),set(A),aa(fun(product_prod(A,A),A),fun(product_prod(A,A),set(A)),aa(fun(A,set(A)),fun(fun(product_prod(A,A),A),fun(product_prod(A,A),set(A))),comp(A,set(A),product_prod(A,A)),equiv_proj(A,A,R)),product_snd(A,A)),Z2) ) ) ) ).

% equiv_proj
tff(fact_3578_equiv__class__eq__iff,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X: A,Y: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
      <=> ( ( image(A,A,R3,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = image(A,A,R3,aa(set(A),set(A),insert2(A,Y),bot_bot(set(A)))) )
          & pp(member(A,X,A4))
          & pp(member(A,Y,A4)) ) ) ) ).

% equiv_class_eq_iff
tff(fact_3579_eq__equiv__class__iff,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X: A,Y: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(A,X,A4))
       => ( pp(member(A,Y,A4))
         => ( ( image(A,A,R3,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = image(A,A,R3,aa(set(A),set(A),insert2(A,Y),bot_bot(set(A)))) )
          <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3)) ) ) ) ) ).

% eq_equiv_class_iff
tff(fact_3580_equiv__class__eq,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
       => ( image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) = image(A,A,R3,aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))) ) ) ) ).

% equiv_class_eq
tff(fact_3581_eq__equiv__class,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A,A4: set(A)] :
      ( ( image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) = image(A,A,R3,aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))) )
     => ( equiv_equiv(A,A4,R3)
       => ( pp(member(A,B2,A4))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3)) ) ) ) ).

% eq_equiv_class
tff(fact_3582_eq__equiv__class__iff2,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X: A,Y: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(A,X,A4))
       => ( pp(member(A,Y,A4))
         => ( ( equiv_quotient(A,aa(set(A),set(A),insert2(A,X),bot_bot(set(A))),R3) = equiv_quotient(A,aa(set(A),set(A),insert2(A,Y),bot_bot(set(A))),R3) )
          <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3)) ) ) ) ) ).

% eq_equiv_class_iff2
tff(fact_3583_refines__equiv__class__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S2: set(product_prod(A,A)),A4: set(A),A3: A] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R),S2))
     => ( equiv_equiv(A,A4,R)
       => ( equiv_equiv(A,A4,S2)
         => ( image(A,A,R,image(A,A,S2,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))) = image(A,A,S2,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) ) ) ) ) ).

% refines_equiv_class_eq
tff(fact_3584_refines__equiv__class__eq2,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S2: set(product_prod(A,A)),A4: set(A),A3: A] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),R),S2))
     => ( equiv_equiv(A,A4,R)
       => ( equiv_equiv(A,A4,S2)
         => ( image(A,A,S2,image(A,A,R,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))) = image(A,A,S2,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) ) ) ) ) ).

% refines_equiv_class_eq2
tff(fact_3585_equiv__class__subset,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))),image(A,A,R3,aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))))) ) ) ).

% equiv_class_subset
tff(fact_3586_subset__equiv__class,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),B2: A,A3: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),image(A,A,R3,aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))),image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))))
       => ( pp(member(A,B2,A4))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3)) ) ) ) ).

% subset_equiv_class
tff(fact_3587_equiv__class__nondisjoint,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X: A,A3: A,B2: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))),image(A,A,R3,aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))))))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3)) ) ) ).

% equiv_class_nondisjoint
tff(fact_3588_in__quotient__imp__in__rel,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),X6: set(A),X: A,Y: A] :
      ( equiv_equiv(A,A4,R3)
     => ( pp(member(set(A),X6,equiv_quotient(A,A4,R3)))
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,X),aa(set(A),set(A),insert2(A,Y),bot_bot(set(A))))),X6))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3)) ) ) ) ).

% in_quotient_imp_in_rel
tff(fact_3589_restrict__upd__same,axiom,
    ! [B: $tType,A: $tType,M4: fun(A,option(B)),X: A,Y: B] : ( restrict_map(A,B,fun_upd(A,option(B),M4,X,aa(B,option(B),some(B),Y)),aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))) = restrict_map(A,B,M4,aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))) ) ).

% restrict_upd_same
tff(fact_3590_fun__upd__None__restrict,axiom,
    ! [B: $tType,A: $tType,X: A,D4: set(A),M4: fun(A,option(B))] :
      ( ( pp(member(A,X,D4))
       => ( fun_upd(A,option(B),restrict_map(A,B,M4,D4),X,none(B)) = restrict_map(A,B,M4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))) ) )
      & ( ~ pp(member(A,X,D4))
       => ( fun_upd(A,option(B),restrict_map(A,B,M4,D4),X,none(B)) = restrict_map(A,B,M4,D4) ) ) ) ).

% fun_upd_None_restrict
tff(fact_3591_restrict__fun__upd,axiom,
    ! [B: $tType,A: $tType,X: A,D4: set(A),M4: fun(A,option(B)),Y: option(B)] :
      ( ( pp(member(A,X,D4))
       => ( restrict_map(A,B,fun_upd(A,option(B),M4,X,Y),D4) = fun_upd(A,option(B),restrict_map(A,B,M4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))),X,Y) ) )
      & ( ~ pp(member(A,X,D4))
       => ( restrict_map(A,B,fun_upd(A,option(B),M4,X,Y),D4) = restrict_map(A,B,M4,D4) ) ) ) ).

% restrict_fun_upd
tff(fact_3592_fun__upd__restrict__conv,axiom,
    ! [A: $tType,B: $tType,X: A,D4: set(A),M4: fun(A,option(B)),Y: option(B)] :
      ( pp(member(A,X,D4))
     => ( fun_upd(A,option(B),restrict_map(A,B,M4,D4),X,Y) = fun_upd(A,option(B),restrict_map(A,B,M4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))),X,Y) ) ) ).

% fun_upd_restrict_conv
tff(fact_3593_restrict__map__to__empty,axiom,
    ! [A: $tType,B: $tType,M4: fun(A,option(B)),X3: A] : ( aa(A,option(B),restrict_map(A,B,M4,bot_bot(set(A))),X3) = none(B) ) ).

% restrict_map_to_empty
tff(fact_3594_restrict__restrict,axiom,
    ! [B: $tType,A: $tType,M4: fun(A,option(B)),A4: set(A),B3: set(A)] : ( restrict_map(A,B,restrict_map(A,B,M4,A4),B3) = restrict_map(A,B,M4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) ).

% restrict_restrict
tff(fact_3595_fun__upd__restrict,axiom,
    ! [A: $tType,B: $tType,M4: fun(A,option(B)),D4: set(A),X: A,Y: option(B)] : ( fun_upd(A,option(B),restrict_map(A,B,M4,D4),X,Y) = fun_upd(A,option(B),restrict_map(A,B,M4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),D4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))),X,Y) ) ).

% fun_upd_restrict
tff(fact_3596_restrict__complement__singleton__eq,axiom,
    ! [A: $tType,B: $tType,F: fun(A,option(B)),X: A] : ( restrict_map(A,B,F,aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))) = fun_upd(A,option(B),F,X,none(B)) ) ).

% restrict_complement_singleton_eq
tff(fact_3597_UN__equiv__class2,axiom,
    ! [A: $tType,C: $tType,B: $tType,A14: set(A),R1: set(product_prod(A,A)),A23: set(B),R22: set(product_prod(B,B)),F: fun(A,fun(B,set(C))),A1: A,A22: B] :
      ( equiv_equiv(A,A14,R1)
     => ( equiv_equiv(B,A23,R22)
       => ( equiv_congruent2(A,B,set(C),R1,R22,F)
         => ( pp(member(A,A1,A14))
           => ( pp(member(B,A22,A23))
             => ( aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image2(A,set(C),aa(B,fun(A,set(C)),aa(fun(A,fun(B,set(C))),fun(B,fun(A,set(C))),aTP_Lamp_my(set(product_prod(B,B)),fun(fun(A,fun(B,set(C))),fun(B,fun(A,set(C)))),R22),F),A22)),image(A,A,R1,aa(set(A),set(A),insert2(A,A1),bot_bot(set(A)))))) = aa(B,set(C),aa(A,fun(B,set(C)),F,A1),A22) ) ) ) ) ) ) ).

% UN_equiv_class2
tff(fact_3598_UN__equiv__class,axiom,
    ! [B: $tType,A: $tType,A4: set(A),R3: set(product_prod(A,A)),F: fun(A,set(B)),A3: A] :
      ( equiv_equiv(A,A4,R3)
     => ( equiv_congruent(A,set(B),R3,F)
       => ( pp(member(A,A3,A4))
         => ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F),image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))) = aa(A,set(B),F,A3) ) ) ) ) ).

% UN_equiv_class
tff(fact_3599_UN__equiv__class__inject,axiom,
    ! [B: $tType,A: $tType,A4: set(A),R3: set(product_prod(A,A)),F: fun(A,set(B)),X6: set(A),Y5: set(A)] :
      ( equiv_equiv(A,A4,R3)
     => ( equiv_congruent(A,set(B),R3,F)
       => ( ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F),X6)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),F),Y5)) )
         => ( pp(member(set(A),X6,equiv_quotient(A,A4,R3)))
           => ( pp(member(set(A),Y5,equiv_quotient(A,A4,R3)))
             => ( ! [X2: A,Y2: A] :
                    ( pp(member(A,X2,A4))
                   => ( pp(member(A,Y2,A4))
                     => ( ( aa(A,set(B),F,X2) = aa(A,set(B),F,Y2) )
                       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),R3)) ) ) )
               => ( X6 = Y5 ) ) ) ) ) ) ) ).

% UN_equiv_class_inject
tff(fact_3600_graph__map__upd,axiom,
    ! [A: $tType,B: $tType,M4: fun(A,option(B)),K: A,V: B] : ( graph(A,B,fun_upd(A,option(B),M4,K,aa(B,option(B),some(B),V))) = aa(set(product_prod(A,B)),set(product_prod(A,B)),insert2(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V)),graph(A,B,fun_upd(A,option(B),M4,K,none(B)))) ) ).

% graph_map_upd
tff(fact_3601_Ref__Time_Oalloc__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: A,H2: heap_ext(product_unit)] : ( ref_alloc(A,X,H2) = aa(heap_ext(product_unit),product_prod(ref(A),heap_ext(product_unit)),aa(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),heap_ext(product_unit))),product_Pair(ref(A),heap_ext(product_unit)),ref2(A,lim(product_unit,H2))),ref_set(A,ref2(A,lim(product_unit,H2)),X,lim_update(product_unit,aTP_Lamp_mz(heap_ext(product_unit),fun(nat,nat),H2),H2))) ) ) ).

% Ref_Time.alloc_def
tff(fact_3602_graph__empty,axiom,
    ! [B: $tType,A: $tType] : ( graph(A,B,aTP_Lamp_mi(A,option(B))) = bot_bot(set(product_prod(A,B))) ) ).

% graph_empty
tff(fact_3603_congruent2I_H,axiom,
    ! [C: $tType,B: $tType,A: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B)),F: fun(A,fun(B,C))] :
      ( ! [Y12: A,Z1: A,Y23: B,Z22: B] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y12),Z1),R1))
         => ( pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y23),Z22),R22))
           => ( aa(B,C,aa(A,fun(B,C),F,Y12),Y23) = aa(B,C,aa(A,fun(B,C),F,Z1),Z22) ) ) )
     => equiv_congruent2(A,B,C,R1,R22,F) ) ).

% congruent2I'
tff(fact_3604_congruent2D,axiom,
    ! [A: $tType,C: $tType,B: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B)),F: fun(A,fun(B,C)),Y1: A,Z12: A,Y22: B,Z23: B] :
      ( equiv_congruent2(A,B,C,R1,R22,F)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y1),Z12),R1))
       => ( pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y22),Z23),R22))
         => ( aa(B,C,aa(A,fun(B,C),F,Y1),Y22) = aa(B,C,aa(A,fun(B,C),F,Z12),Z23) ) ) ) ) ).

% congruent2D
tff(fact_3605_congruentI,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),F: fun(A,B)] :
      ( ! [Y2: A,Z3: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z3),R3))
         => ( aa(A,B,F,Y2) = aa(A,B,F,Z3) ) )
     => equiv_congruent(A,B,R3,F) ) ).

% congruentI
tff(fact_3606_congruentD,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),F: fun(A,B),Y: A,Z2: A] :
      ( equiv_congruent(A,B,R3,F)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),Z2),R3))
       => ( aa(A,B,F,Y) = aa(A,B,F,Z2) ) ) ) ).

% congruentD
tff(fact_3607_in__graphD,axiom,
    ! [A: $tType,B: $tType,K: A,V: B,M4: fun(A,option(B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V),graph(A,B,M4)))
     => ( aa(A,option(B),M4,K) = aa(B,option(B),some(B),V) ) ) ).

% in_graphD
tff(fact_3608_in__graphI,axiom,
    ! [A: $tType,B: $tType,M4: fun(B,option(A)),K: B,V: A] :
      ( ( aa(B,option(A),M4,K) = aa(A,option(A),some(A),V) )
     => pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),K),V),graph(B,A,M4))) ) ).

% in_graphI
tff(fact_3609_graph__restrictD_I1_J,axiom,
    ! [B: $tType,A: $tType,K: A,V: B,M4: fun(A,option(B)),A4: set(A)] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V),graph(A,B,restrict_map(A,B,M4,A4))))
     => pp(member(A,K,A4)) ) ).

% graph_restrictD(1)
tff(fact_3610_graph__restrictD_I2_J,axiom,
    ! [A: $tType,B: $tType,K: A,V: B,M4: fun(A,option(B)),A4: set(A)] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V),graph(A,B,restrict_map(A,B,M4,A4))))
     => ( aa(A,option(B),M4,K) = aa(B,option(B),some(B),V) ) ) ).

% graph_restrictD(2)
tff(fact_3611_graph__def,axiom,
    ! [B: $tType,A: $tType,M4: fun(A,option(B))] : ( graph(A,B,M4) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aTP_Lamp_na(fun(A,option(B)),fun(product_prod(A,B),bool),M4)) ) ).

% graph_def
tff(fact_3612_congruent2__commuteI,axiom,
    ! [B: $tType,A: $tType,A4: set(A),R3: set(product_prod(A,A)),F: fun(A,fun(A,B))] :
      ( equiv_equiv(A,A4,R3)
     => ( ! [Y2: A,Z3: A] :
            ( pp(member(A,Y2,A4))
           => ( pp(member(A,Z3,A4))
             => ( aa(A,B,aa(A,fun(A,B),F,Y2),Z3) = aa(A,B,aa(A,fun(A,B),F,Z3),Y2) ) ) )
       => ( ! [Y2: A,Z3: A,W: A] :
              ( pp(member(A,W,A4))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z3),R3))
               => ( aa(A,B,aa(A,fun(A,B),F,W),Y2) = aa(A,B,aa(A,fun(A,B),F,W),Z3) ) ) )
         => equiv_congruent2(A,A,B,R3,R3,F) ) ) ) ).

% congruent2_commuteI
tff(fact_3613_congruent2I,axiom,
    ! [C: $tType,B: $tType,A: $tType,A14: set(A),R1: set(product_prod(A,A)),A23: set(B),R22: set(product_prod(B,B)),F: fun(A,fun(B,C))] :
      ( equiv_equiv(A,A14,R1)
     => ( equiv_equiv(B,A23,R22)
       => ( ! [Y2: A,Z3: A,W: B] :
              ( pp(member(B,W,A23))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z3),R1))
               => ( aa(B,C,aa(A,fun(B,C),F,Y2),W) = aa(B,C,aa(A,fun(B,C),F,Z3),W) ) ) )
         => ( ! [Y2: B,Z3: B,W: A] :
                ( pp(member(A,W,A14))
               => ( pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),R22))
                 => ( aa(B,C,aa(A,fun(B,C),F,W),Y2) = aa(B,C,aa(A,fun(B,C),F,W),Z3) ) ) )
           => equiv_congruent2(A,B,C,R1,R22,F) ) ) ) ) ).

% congruent2I
tff(fact_3614_congruent2__implies__congruent__UN,axiom,
    ! [A: $tType,C: $tType,B: $tType,A14: set(A),R1: set(product_prod(A,A)),A23: set(B),R22: set(product_prod(B,B)),F: fun(A,fun(B,set(C))),A3: B] :
      ( equiv_equiv(A,A14,R1)
     => ( equiv_equiv(B,A23,R22)
       => ( equiv_congruent2(A,B,set(C),R1,R22,F)
         => ( pp(member(B,A3,A23))
           => equiv_congruent(A,set(C),R1,aa(B,fun(A,set(C)),aa(fun(A,fun(B,set(C))),fun(B,fun(A,set(C))),aTP_Lamp_my(set(product_prod(B,B)),fun(fun(A,fun(B,set(C))),fun(B,fun(A,set(C)))),R22),F),A3)) ) ) ) ) ).

% congruent2_implies_congruent_UN
tff(fact_3615_disjnt__equiv__class,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( equiv_equiv(A,A4,R3)
     => ( disjnt(A,image(A,A,R3,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))),image(A,A,R3,aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))))
      <=> ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3)) ) ) ).

% disjnt_equiv_class
tff(fact_3616_cINF__UNION,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A4: set(C),B3: fun(C,set(D)),F: fun(D,B)] :
          ( ( A4 != bot_bot(set(C)) )
         => ( ! [X2: C] :
                ( pp(member(C,X2,A4))
               => ( aa(C,set(D),B3,X2) != bot_bot(set(D)) ) )
           => ( condit1013018076250108175_below(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(D,B),fun(C,set(B)),aTP_Lamp_lv(fun(C,set(D)),fun(fun(D,B),fun(C,set(B))),B3),F)),A4)))
             => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,F),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),B3),A4)))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(D,B),fun(C,B),aTP_Lamp_nb(fun(C,set(D)),fun(fun(D,B),fun(C,B)),B3),F)),A4)) ) ) ) ) ) ).

% cINF_UNION
tff(fact_3617_finite__def,axiom,
    ! [A: $tType] : ( finite_finite(A) = complete_lattice_lfp(fun(set(A),bool),aTP_Lamp_nc(fun(set(A),bool),fun(set(A),bool))) ) ).

% finite_def
tff(fact_3618_bsqr__max2,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A1: A,A22: A,B12: A,B23: A] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( pp(member(product_prod(product_prod(A,A),product_prod(A,A)),aa(product_prod(A,A),product_prod(product_prod(A,A),product_prod(A,A)),aa(product_prod(A,A),fun(product_prod(A,A),product_prod(product_prod(A,A),product_prod(A,A))),product_Pair(product_prod(A,A),product_prod(A,A)),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A1),A22)),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B12),B23)),bNF_Wellorder_bsqr(A,R3)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),bNF_We1388413361240627857o_max2(A,R3,A1,A22)),bNF_We1388413361240627857o_max2(A,R3,B12,B23)),R3)) ) ) ).

% bsqr_max2
tff(fact_3619_bdd__below__empty,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => condit1013018076250108175_below(A,bot_bot(set(A))) ) ).

% bdd_below_empty
tff(fact_3620_disjnt__self__iff__empty,axiom,
    ! [A: $tType,S2: set(A)] :
      ( disjnt(A,S2,S2)
    <=> ( S2 = bot_bot(set(A)) ) ) ).

% disjnt_self_iff_empty
tff(fact_3621_bdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [F: fun(B,A),G: fun(B,A),A4: set(B)] :
          ( condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_nd(fun(B,A),fun(fun(B,A),fun(B,A)),F),G)),A4))
        <=> ( condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,F),A4))
            & condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,G),A4)) ) ) ) ).

% bdd_below_image_inf
tff(fact_3622_disjnt__Times1__iff,axiom,
    ! [A: $tType,B: $tType,C3: set(A),A4: set(B),B3: set(B)] :
      ( disjnt(product_prod(A,B),product_Sigma(A,B,C3,aTP_Lamp_hq(set(B),fun(A,set(B)),A4)),product_Sigma(A,B,C3,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)))
    <=> ( ( C3 = bot_bot(set(A)) )
        | disjnt(B,A4,B3) ) ) ).

% disjnt_Times1_iff
tff(fact_3623_disjnt__Times2__iff,axiom,
    ! [B: $tType,A: $tType,A4: set(A),C3: set(B),B3: set(A)] :
      ( disjnt(product_prod(A,B),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),C3)),product_Sigma(A,B,B3,aTP_Lamp_hq(set(B),fun(A,set(B)),C3)))
    <=> ( ( C3 = bot_bot(set(B)) )
        | disjnt(A,A4,B3) ) ) ).

% disjnt_Times2_iff
tff(fact_3624_disjnt__empty2,axiom,
    ! [A: $tType,A4: set(A)] : disjnt(A,A4,bot_bot(set(A))) ).

% disjnt_empty2
tff(fact_3625_disjnt__empty1,axiom,
    ! [A: $tType,A4: set(A)] : disjnt(A,bot_bot(set(A)),A4) ).

% disjnt_empty1
tff(fact_3626_bdd__below__Int2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: set(A),A4: set(A)] :
          ( condit1013018076250108175_below(A,B3)
         => condit1013018076250108175_below(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) ) ).

% bdd_below_Int2
tff(fact_3627_bdd__below__Int1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A4: set(A),B3: set(A)] :
          ( condit1013018076250108175_below(A,A4)
         => condit1013018076250108175_below(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) ) ).

% bdd_below_Int1
tff(fact_3628_well__order__on__domain,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( order_well_order_on(A,A4,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
       => ( pp(member(A,A3,A4))
          & pp(member(A,B2,A4)) ) ) ) ).

% well_order_on_domain
tff(fact_3629_disjnt__Sigma__iff,axiom,
    ! [B: $tType,A: $tType,A4: set(A),C3: fun(A,set(B)),B3: set(A)] :
      ( disjnt(product_prod(A,B),product_Sigma(A,B,A4,C3),product_Sigma(A,B,B3,C3))
    <=> ( ! [X4: A] :
            ( pp(member(A,X4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)))
           => ( aa(A,set(B),C3,X4) = bot_bot(set(B)) ) )
        | disjnt(A,A4,B3) ) ) ).

% disjnt_Sigma_iff
tff(fact_3630_well__order__on__empty,axiom,
    ! [A: $tType] : order_well_order_on(A,bot_bot(set(A)),bot_bot(set(product_prod(A,A)))) ).

% well_order_on_empty
tff(fact_3631_disjnt__def,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( disjnt(A,A4,B3)
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) ) ) ).

% disjnt_def
tff(fact_3632_le__cInf__iff,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S2: set(A),A3: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,S2)
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(set(A),A,complete_Inf_Inf(A),S2)))
            <=> ! [X4: A] :
                  ( pp(member(A,X4,S2))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),X4)) ) ) ) ) ) ).

% le_cInf_iff
tff(fact_3633_cInf__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [B3: set(A),A4: set(A)] :
          ( ( B3 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,A4)
           => ( ! [B5: A] :
                  ( pp(member(A,B5,B3))
                 => ? [X3: A] :
                      ( pp(member(A,X3,A4))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X3),B5)) ) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A4)),aa(set(A),A,complete_Inf_Inf(A),B3))) ) ) ) ) ).

% cInf_mono
tff(fact_3634_cInf__less__iff,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [X6: set(A),Y: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,X6)
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),X6)),Y))
            <=> ? [X4: A] :
                  ( pp(member(A,X4,X6))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X4),Y)) ) ) ) ) ) ).

% cInf_less_iff
tff(fact_3635_Well__order__Restr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => order_well_order_on(A,field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) ) ).

% Well_order_Restr
tff(fact_3636_cINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [B3: set(B),F: fun(C,A),A4: set(C),G: fun(B,A)] :
          ( ( B3 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(A,aa(set(C),set(A),image2(C,A,F),A4))
           => ( ! [M5: B] :
                  ( pp(member(B,M5,B3))
                 => ? [X3: C] :
                      ( pp(member(C,X3,A4))
                      & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(C,A,F,X3)),aa(B,A,G,M5))) ) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,F),A4))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),B3)))) ) ) ) ) ).

% cINF_mono
tff(fact_3637_le__cINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),F: fun(B,A),U: A] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,F),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4))))
            <=> ! [X4: B] :
                  ( pp(member(B,X4,A4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),U),aa(B,A,F,X4))) ) ) ) ) ) ).

% le_cINF_iff
tff(fact_3638_cInf__superset__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(A),B3: set(A)] :
          ( ( A4 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,B3)
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),B3)),aa(set(A),A,complete_Inf_Inf(A),A4))) ) ) ) ) ).

% cInf_superset_mono
tff(fact_3639_cInf__insert,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),A3: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,X6)
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert2(A,A3),X6)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(set(A),A,complete_Inf_Inf(A),X6)) ) ) ) ) ).

% cInf_insert
tff(fact_3640_cInf__insert__If,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),A3: A] :
          ( condit1013018076250108175_below(A,X6)
         => ( ( ( X6 = bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert2(A,A3),X6)) = A3 ) )
            & ( ( X6 != bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),insert2(A,A3),X6)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(set(A),A,complete_Inf_Inf(A),X6)) ) ) ) ) ) ).

% cInf_insert_If
tff(fact_3641_cInf__union__distrib,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(A),B3: set(A)] :
          ( ( A4 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,A4)
           => ( ( B3 != bot_bot(set(A)) )
             => ( condit1013018076250108175_below(A,B3)
               => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),A4)),aa(set(A),A,complete_Inf_Inf(A),B3)) ) ) ) ) ) ) ).

% cInf_union_distrib
tff(fact_3642_well__order__on__Restr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),field2(A,R3)))
       => order_well_order_on(A,A4,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) ) ) ).

% well_order_on_Restr
tff(fact_3643_cINF__less__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [A4: set(B),F: fun(B,A),A3: A] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,F),A4))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4))),A3))
            <=> ? [X4: B] :
                  ( pp(member(B,X4,A4))
                  & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F,X4)),A3)) ) ) ) ) ) ).

% cINF_less_iff
tff(fact_3644_cINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),F: fun(B,A),G: fun(B,A)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,F),A4))
           => ( condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,G),A4))
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),A4))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ne(fun(B,A),fun(fun(B,A),fun(B,A)),F),G)),A4)) ) ) ) ) ) ).

% cINF_inf_distrib
tff(fact_3645_Linear__order__Well__order__iff,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( order_679001287576687338der_on(A,field2(A,R3),R3)
     => ( order_well_order_on(A,field2(A,R3),R3)
      <=> ! [A11: set(A)] :
            ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A11),field2(A,R3)))
           => ( ( A11 != bot_bot(set(A)) )
             => ? [X4: A] :
                  ( pp(member(A,X4,A11))
                  & ! [Xa2: A] :
                      ( pp(member(A,Xa2,A11))
                     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa2),R3)) ) ) ) ) ) ) ).

% Linear_order_Well_order_iff
tff(fact_3646_cINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),G: fun(B,A),B3: set(B),F: fun(B,A)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,G),B3))
           => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A4),B3))
             => ( ! [X2: B] :
                    ( pp(member(B,X2,B3))
                   => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(B,A,G,X2)),aa(B,A,F,X2))) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,G),B3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4)))) ) ) ) ) ) ).

% cINF_superset_mono
tff(fact_3647_less__eq__cInf__inter,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(A),B3: set(A)] :
          ( condit1013018076250108175_below(A,A4)
         => ( condit1013018076250108175_below(A,B3)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) != bot_bot(set(A)) )
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),A4)),aa(set(A),A,complete_Inf_Inf(A),B3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)))) ) ) ) ) ).

% less_eq_cInf_inter
tff(fact_3648_cINF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),F: fun(B,A),A3: B] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,F),A4))
           => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),aa(set(B),set(B),insert2(B,A3),A4))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,F,A3)),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4))) ) ) ) ) ).

% cINF_insert
tff(fact_3649_cINF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(B),F: fun(B,A),B3: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,F),A4))
           => ( ( B3 != bot_bot(set(B)) )
             => ( condit1013018076250108175_below(A,aa(set(B),set(A),image2(B,A,F),B3))
               => ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),A4))),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),B3))) ) ) ) ) ) ) ).

% cINF_union
tff(fact_3650_cInf__le__cSup,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A4: set(A)] :
          ( ( A4 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,A4)
           => ( condit1013018076250108175_below(A,A4)
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A4)),aa(set(A),A,complete_Sup_Sup(A),A4))) ) ) ) ) ).

% cInf_le_cSup
tff(fact_3651_ofilter__Restr__Int,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B3: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
       => order_ofilter(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,B3,aTP_Lamp_if(set(A),fun(A,set(A)),B3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) ) ).

% ofilter_Restr_Int
tff(fact_3652_ofilter__Restr__subset,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B3: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
         => order_ofilter(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,B3,aTP_Lamp_if(set(A),fun(A,set(A)),B3))),A4) ) ) ) ).

% ofilter_Restr_subset
tff(fact_3653_inverse__rat__def,axiom,
    inverse_inverse(rat) = aa(fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat),aTP_Lamp_gl(product_prod(int,int),product_prod(int,int))) ).

% inverse_rat_def
tff(fact_3654_set__to__map__def,axiom,
    ! [A: $tType,B: $tType,S2: set(product_prod(B,A)),K: B] : ( aa(B,option(A),set_to_map(B,A,S2),K) = eps_Opt(A,aa(B,fun(A,bool),aTP_Lamp_lm(set(product_prod(B,A)),fun(B,fun(A,bool)),S2),K)) ) ).

% set_to_map_def
tff(fact_3655_map__fun_Ocompositionality,axiom,
    ! [D: $tType,F8: $tType,C: $tType,E: $tType,B: $tType,A: $tType,F: fun(E,C),G: fun(D,F8),H2: fun(C,A),I: fun(B,D),Fun: fun(A,B)] : ( aa(fun(C,D),fun(E,F8),map_fun(E,C,D,F8,F,G),aa(fun(A,B),fun(C,D),map_fun(C,A,B,D,H2,I),Fun)) = aa(fun(A,B),fun(E,F8),map_fun(E,A,B,F8,aa(fun(E,C),fun(E,A),aa(fun(C,A),fun(fun(E,C),fun(E,A)),comp(C,A,E),H2),F),aa(fun(B,D),fun(B,F8),aa(fun(D,F8),fun(fun(B,D),fun(B,F8)),comp(D,F8,B),G),I)),Fun) ) ).

% map_fun.compositionality
tff(fact_3656_map__fun__def,axiom,
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: fun(C,A),G: fun(B,D),H2: fun(A,B)] : ( aa(fun(A,B),fun(C,D),map_fun(C,A,B,D,F,G),H2) = aa(fun(C,A),fun(C,D),aa(fun(A,D),fun(fun(C,A),fun(C,D)),comp(A,D,C),aa(fun(A,B),fun(A,D),aa(fun(B,D),fun(fun(A,B),fun(A,D)),comp(B,D,A),G),H2)),F) ) ).

% map_fun_def
tff(fact_3657_map__fun_Ocomp,axiom,
    ! [E: $tType,C: $tType,A: $tType,F8: $tType,D: $tType,B: $tType,F: fun(E,C),G: fun(D,F8),H2: fun(C,A),I: fun(B,D)] : ( aa(fun(fun(A,B),fun(C,D)),fun(fun(A,B),fun(E,F8)),aa(fun(fun(C,D),fun(E,F8)),fun(fun(fun(A,B),fun(C,D)),fun(fun(A,B),fun(E,F8))),comp(fun(C,D),fun(E,F8),fun(A,B)),map_fun(E,C,D,F8,F,G)),map_fun(C,A,B,D,H2,I)) = map_fun(E,A,B,F8,aa(fun(E,C),fun(E,A),aa(fun(C,A),fun(fun(E,C),fun(E,A)),comp(C,A,E),H2),F),aa(fun(B,D),fun(B,F8),aa(fun(D,F8),fun(fun(B,D),fun(B,F8)),comp(D,F8,B),G),I)) ) ).

% map_fun.comp
tff(fact_3658_uminus__rat__def,axiom,
    uminus_uminus(rat) = aa(fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat),aTP_Lamp_gq(product_prod(int,int),product_prod(int,int))) ).

% uminus_rat_def
tff(fact_3659_Field__Restr__ofilter,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
       => ( field2(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) = A4 ) ) ) ).

% Field_Restr_ofilter
tff(fact_3660_plus__rat__def,axiom,
    plus_plus(rat) = aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(rat,fun(rat,rat)),map_fun(rat,product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),rep_Rat,map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat)),aTP_Lamp_gs(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% plus_rat_def
tff(fact_3661_ofilter__subset__embedS,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B3: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
       => ( order_ofilter(A,R3,B3)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A4),B3))
          <=> bNF_Wellorder_embedS(A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,B3,aTP_Lamp_if(set(A),fun(A,set(A)),B3))),id(A)) ) ) ) ) ).

% ofilter_subset_embedS
tff(fact_3662_times__rat__def,axiom,
    times_times(rat) = aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(rat,fun(rat,rat)),map_fun(rat,product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),rep_Rat,map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat)),aTP_Lamp_gt(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% times_rat_def
tff(fact_3663_ofilter__subset__ordLess,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B3: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
       => ( order_ofilter(A,R3,B3)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A4),B3))
          <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,B3,aTP_Lamp_if(set(A),fun(A,set(A)),B3)))),bNF_We4044943003108391690rdLess(A,A))) ) ) ) ) ).

% ofilter_subset_ordLess
tff(fact_3664_ordLess__transitive,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),R8: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R8),bNF_We4044943003108391690rdLess(B,C)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(A,A)),fun(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C)))),product_Pair(set(product_prod(A,A)),set(product_prod(C,C))),R3),R8),bNF_We4044943003108391690rdLess(A,C))) ) ) ).

% ordLess_transitive
tff(fact_3665_ordLess__irreflexive,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),R3),bNF_We4044943003108391690rdLess(A,A))) ).

% ordLess_irreflexive
tff(fact_3666_finite__ordLess__infinite,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
         => ( ~ pp(aa(set(B),bool,finite_finite(B),field2(B,R4)))
           => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B))) ) ) ) ) ).

% finite_ordLess_infinite
tff(fact_3667_ofilter__ordLess,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
       => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A4),field2(A,R3)))
        <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),R3),bNF_We4044943003108391690rdLess(A,A))) ) ) ) ).

% ofilter_ordLess
tff(fact_3668_times__int__def,axiom,
    times_times(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int_def
tff(fact_3669_ofilter__subset__embedS__iso,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B3: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
       => ( order_ofilter(A,R3,B3)
         => ( ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),A4),B3))
            <=> bNF_Wellorder_embedS(A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,B3,aTP_Lamp_if(set(A),fun(A,set(A)),B3))),id(A)) )
            & ( ( A4 = B3 )
            <=> bNF_Wellorder_iso(A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,B3,aTP_Lamp_if(set(A),fun(A,set(A)),B3))),id(A)) ) ) ) ) ) ).

% ofilter_subset_embedS_iso
tff(fact_3670_minus__int__def,axiom,
    minus_minus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int_def
tff(fact_3671_plus__int__def,axiom,
    plus_plus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int_def
tff(fact_3672_uminus__int__def,axiom,
    uminus_uminus(int) = aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int_def
tff(fact_3673_iso__comp__embedS,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(A,B),R8: set(product_prod(C,C)),F10: fun(B,C)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( bNF_Wellorder_iso(A,B,R3,R4,F)
         => ( bNF_Wellorder_embedS(B,C,R4,R8,F10)
           => bNF_Wellorder_embedS(A,C,R3,R8,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F10),F)) ) ) ) ) ).

% iso_comp_embedS
tff(fact_3674_embedS__comp__iso,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(A,B),R8: set(product_prod(C,C)),F10: fun(B,C)] :
      ( bNF_Wellorder_embedS(A,B,R3,R4,F)
     => ( bNF_Wellorder_iso(B,C,R4,R8,F10)
       => bNF_Wellorder_embedS(A,C,R3,R8,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F10),F)) ) ) ).

% embedS_comp_iso
tff(fact_3675_underS__Restr__ordLess,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( ( field2(A,R3) != bot_bot(set(A)) )
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,order_underS(A,R3,A3),aa(A,fun(A,set(A)),aTP_Lamp_nf(set(product_prod(A,A)),fun(A,fun(A,set(A))),R3),A3)))),R3),bNF_We4044943003108391690rdLess(A,A))) ) ) ).

% underS_Restr_ordLess
tff(fact_3676_comp__iso,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(A,B),R8: set(product_prod(C,C)),F10: fun(B,C)] :
      ( bNF_Wellorder_iso(A,B,R3,R4,F)
     => ( bNF_Wellorder_iso(B,C,R4,R8,F10)
       => bNF_Wellorder_iso(A,C,R3,R8,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F10),F)) ) ) ).

% comp_iso
tff(fact_3677_underS__I,axiom,
    ! [A: $tType,I: A,J2: A,R: set(product_prod(A,A))] :
      ( ( I != J2 )
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),I),J2),R))
       => pp(member(A,I,order_underS(A,R,J2))) ) ) ).

% underS_I
tff(fact_3678_underS__E,axiom,
    ! [A: $tType,I: A,R: set(product_prod(A,A)),J2: A] :
      ( pp(member(A,I,order_underS(A,R,J2)))
     => ( ( I != J2 )
        & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),I),J2),R)) ) ) ).

% underS_E
tff(fact_3679_underS__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] : ( order_underS(A,R3,A3) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_ng(set(product_prod(A,A)),fun(A,fun(A,bool)),R3),A3)) ) ).

% underS_def
tff(fact_3680_underS__empty,axiom,
    ! [A: $tType,A3: A,R3: set(product_prod(A,A))] :
      ( ~ pp(member(A,A3,field2(A,R3)))
     => ( order_underS(A,R3,A3) = bot_bot(set(A)) ) ) ).

% underS_empty
tff(fact_3681_underS__Field3,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] :
      ( ( field2(A,R3) != bot_bot(set(A)) )
     => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less(set(A)),order_underS(A,R3,A3)),field2(A,R3))) ) ).

% underS_Field3
tff(fact_3682_underS__incl__iff,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( order_679001287576687338der_on(A,field2(A,R3),R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => ( pp(member(A,B2,field2(A,R3)))
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),order_underS(A,R3,A3)),order_underS(A,R3,B2)))
          <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3)) ) ) ) ) ).

% underS_incl_iff
tff(fact_3683_iso__forward,axiom,
    ! [A: $tType,B: $tType,X: A,Y: A,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(A,B)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
     => ( bNF_Wellorder_iso(A,B,R3,R4,F)
       => pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,F,X)),aa(A,B,F,Y)),R4)) ) ) ).

% iso_forward
tff(fact_3684_ordLess__iff__ordIso__Restr,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),R3),bNF_We4044943003108391690rdLess(B,A)))
        <=> ? [X4: A] :
              ( pp(member(A,X4,field2(A,R3)))
              & pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,order_underS(A,R3,X4),aa(A,fun(A,set(A)),aTP_Lamp_nf(set(product_prod(A,A)),fun(A,fun(A,set(A))),R3),X4)))),bNF_Wellorder_ordIso(B,A))) ) ) ) ) ).

% ordLess_iff_ordIso_Restr
tff(fact_3685_ordLeq__iff__ordLess__Restr,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
        <=> ! [X4: A] :
              ( pp(member(A,X4,field2(A,R3)))
             => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,order_underS(A,R3,X4),aa(A,fun(A,set(A)),aTP_Lamp_nf(set(product_prod(A,A)),fun(A,fun(A,set(A))),R3),X4)))),R4),bNF_We4044943003108391690rdLess(A,B))) ) ) ) ) ).

% ordLeq_iff_ordLess_Restr
tff(fact_3686_ofilter__subset__embed,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B3: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
       => ( order_ofilter(A,R3,B3)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
          <=> bNF_Wellorder_embed(A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,B3,aTP_Lamp_if(set(A),fun(A,set(A)),B3))),id(A)) ) ) ) ) ).

% ofilter_subset_embed
tff(fact_3687_ofilter__embed,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
      <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),field2(A,R3)))
          & bNF_Wellorder_embed(A,A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))),R3,id(A)) ) ) ) ).

% ofilter_embed
tff(fact_3688_comp__embed,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(A,B),R8: set(product_prod(C,C)),F10: fun(B,C)] :
      ( bNF_Wellorder_embed(A,B,R3,R4,F)
     => ( bNF_Wellorder_embed(B,C,R4,R8,F10)
       => bNF_Wellorder_embed(A,C,R3,R8,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F10),F)) ) ) ).

% comp_embed
tff(fact_3689_ordLeq__iff__ordLess__or__ordIso,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
    <=> ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
        | pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B))) ) ) ).

% ordLeq_iff_ordLess_or_ordIso
tff(fact_3690_ordLeq__transitive,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),R8: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R8),bNF_Wellorder_ordLeq(B,C)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(A,A)),fun(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C)))),product_Pair(set(product_prod(A,A)),set(product_prod(C,C))),R3),R8),bNF_Wellorder_ordLeq(A,C))) ) ) ).

% ordLeq_transitive
tff(fact_3691_ordLeq__ordIso__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),R8: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R8),bNF_Wellorder_ordIso(B,C)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(A,A)),fun(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C)))),product_Pair(set(product_prod(A,A)),set(product_prod(C,C))),R3),R8),bNF_Wellorder_ordLeq(A,C))) ) ) ).

% ordLeq_ordIso_trans
tff(fact_3692_ordIso__ordLeq__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),R8: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R8),bNF_Wellorder_ordLeq(B,C)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(A,A)),fun(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C)))),product_Pair(set(product_prod(A,A)),set(product_prod(C,C))),R3),R8),bNF_Wellorder_ordLeq(A,C))) ) ) ).

% ordIso_ordLeq_trans
tff(fact_3693_ordIso__imp__ordLeq,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B))) ) ).

% ordIso_imp_ordLeq
tff(fact_3694_ordIso__iff__ordLeq,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
    <=> ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
        & pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),R3),bNF_Wellorder_ordLeq(B,A))) ) ) ).

% ordIso_iff_ordLeq
tff(fact_3695_ordIso__symmetric,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),R3),bNF_Wellorder_ordIso(B,A))) ) ).

% ordIso_symmetric
tff(fact_3696_ordIso__transitive,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),R8: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R8),bNF_Wellorder_ordIso(B,C)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(A,A)),fun(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C)))),product_Pair(set(product_prod(A,A)),set(product_prod(C,C))),R3),R8),bNF_Wellorder_ordIso(A,C))) ) ) ).

% ordIso_transitive
tff(fact_3697_internalize__ordLeq,axiom,
    ! [A: $tType,B: $tType,R4: set(product_prod(A,A)),R3: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R4),R3),bNF_Wellorder_ordLeq(A,B)))
    <=> ? [P6: set(product_prod(B,B))] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),field2(B,P6)),field2(B,R3)))
          & pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R4),P6),bNF_Wellorder_ordIso(A,B)))
          & pp(member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),P6),R3),bNF_Wellorder_ordLeq(B,B))) ) ) ).

% internalize_ordLeq
tff(fact_3698_ordLess__ordLeq__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),R8: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R8),bNF_Wellorder_ordLeq(B,C)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(A,A)),fun(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C)))),product_Pair(set(product_prod(A,A)),set(product_prod(C,C))),R3),R8),bNF_We4044943003108391690rdLess(A,C))) ) ) ).

% ordLess_ordLeq_trans
tff(fact_3699_ordLeq__ordLess__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),R8: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R8),bNF_We4044943003108391690rdLess(B,C)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(A,A)),fun(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C)))),product_Pair(set(product_prod(A,A)),set(product_prod(C,C))),R3),R8),bNF_We4044943003108391690rdLess(A,C))) ) ) ).

% ordLeq_ordLess_trans
tff(fact_3700_ordLess__imp__ordLeq,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B))) ) ).

% ordLess_imp_ordLeq
tff(fact_3701_not__ordLess__ordLeq,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
     => ~ pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),R3),bNF_Wellorder_ordLeq(B,A))) ) ).

% not_ordLess_ordLeq
tff(fact_3702_ordLess__ordIso__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),R8: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R8),bNF_Wellorder_ordIso(B,C)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(A,A)),fun(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C)))),product_Pair(set(product_prod(A,A)),set(product_prod(C,C))),R3),R8),bNF_We4044943003108391690rdLess(A,C))) ) ) ).

% ordLess_ordIso_trans
tff(fact_3703_ordIso__ordLess__trans,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),R8: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R8),bNF_We4044943003108391690rdLess(B,C)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C))),aa(set(product_prod(A,A)),fun(set(product_prod(C,C)),product_prod(set(product_prod(A,A)),set(product_prod(C,C)))),product_Pair(set(product_prod(A,A)),set(product_prod(C,C))),R3),R8),bNF_We4044943003108391690rdLess(A,C))) ) ) ).

% ordIso_ordLess_trans
tff(fact_3704_not__ordLess__ordIso,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
     => ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B))) ) ).

% not_ordLess_ordIso
tff(fact_3705_ordLess__not__embed,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
     => ~ ? [X_13: fun(B,A)] : bNF_Wellorder_embed(B,A,R4,R3,X_13) ) ).

% ordLess_not_embed
tff(fact_3706_iso__comp__embed,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(A,B),R8: set(product_prod(C,C)),F10: fun(B,C)] :
      ( bNF_Wellorder_iso(A,B,R3,R4,F)
     => ( bNF_Wellorder_embed(B,C,R4,R8,F10)
       => bNF_Wellorder_embed(A,C,R3,R8,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F10),F)) ) ) ).

% iso_comp_embed
tff(fact_3707_embed__comp__iso,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(A,B),R8: set(product_prod(C,C)),F10: fun(B,C)] :
      ( bNF_Wellorder_embed(A,B,R3,R4,F)
     => ( bNF_Wellorder_iso(B,C,R4,R8,F10)
       => bNF_Wellorder_embed(A,C,R3,R8,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F10),F)) ) ) ).

% embed_comp_iso
tff(fact_3708_finite__well__order__on__ordIso,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),R4: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( order_well_order_on(A,A4,R3)
       => ( order_well_order_on(A,A4,R4)
         => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),R4),bNF_Wellorder_ordIso(A,A))) ) ) ) ).

% finite_well_order_on_ordIso
tff(fact_3709_exists__minim__Well__order,axiom,
    ! [A: $tType,R: set(set(product_prod(A,A)))] :
      ( ( R != bot_bot(set(set(product_prod(A,A)))) )
     => ( ! [X2: set(product_prod(A,A))] :
            ( pp(member(set(product_prod(A,A)),X2,R))
           => order_well_order_on(A,field2(A,X2),X2) )
       => ? [X2: set(product_prod(A,A))] :
            ( pp(member(set(product_prod(A,A)),X2,R))
            & ! [Xa3: set(product_prod(A,A))] :
                ( pp(member(set(product_prod(A,A)),Xa3,R))
               => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),X2),Xa3),bNF_Wellorder_ordLeq(A,A))) ) ) ) ) ).

% exists_minim_Well_order
tff(fact_3710_ordLeq__total,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
          | pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),R3),bNF_Wellorder_ordLeq(B,A))) ) ) ) ).

% ordLeq_total
tff(fact_3711_ordLeq__reflexive,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),R3),bNF_Wellorder_ordLeq(A,A))) ) ).

% ordLeq_reflexive
tff(fact_3712_ordLeq__Well__order__simp,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
     => ( order_well_order_on(A,field2(A,R3),R3)
        & order_well_order_on(B,field2(B,R4),R4) ) ) ).

% ordLeq_Well_order_simp
tff(fact_3713_ordIso__reflexive,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),R3),bNF_Wellorder_ordIso(A,A))) ) ).

% ordIso_reflexive
tff(fact_3714_BNF__Wellorder__Constructions_OordLess__Field,axiom,
    ! [A: $tType,B: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B)),F: fun(A,B)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R1),R22),bNF_We4044943003108391690rdLess(A,B)))
     => ( bNF_Wellorder_embed(A,B,R1,R22,F)
       => ( aa(set(A),set(B),image2(A,B,F),field2(A,R1)) != field2(B,R22) ) ) ) ).

% BNF_Wellorder_Constructions.ordLess_Field
tff(fact_3715_internalize__ordLess,axiom,
    ! [A: $tType,B: $tType,R4: set(product_prod(A,A)),R3: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R4),R3),bNF_We4044943003108391690rdLess(A,B)))
    <=> ? [P6: set(product_prod(B,B))] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less(set(B)),field2(B,P6)),field2(B,R3)))
          & pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R4),P6),bNF_Wellorder_ordIso(A,B)))
          & pp(member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),P6),R3),bNF_We4044943003108391690rdLess(B,B))) ) ) ).

% internalize_ordLess
tff(fact_3716_ordLess__or__ordLeq,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
          | pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),R3),bNF_Wellorder_ordLeq(B,A))) ) ) ) ).

% ordLess_or_ordLeq
tff(fact_3717_not__ordLeq__iff__ordLess,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( ~ pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),R3),bNF_Wellorder_ordLeq(B,A)))
        <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B))) ) ) ) ).

% not_ordLeq_iff_ordLess
tff(fact_3718_not__ordLess__iff__ordLeq,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( ~ pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),R3),bNF_We4044943003108391690rdLess(B,A)))
        <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B))) ) ) ) ).

% not_ordLess_iff_ordLeq
tff(fact_3719_ordLess__iff,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
    <=> ( order_well_order_on(A,field2(A,R3),R3)
        & order_well_order_on(B,field2(B,R4),R4)
        & ~ ? [X_12: fun(B,A)] : bNF_Wellorder_embed(B,A,R4,R3,X_12) ) ) ).

% ordLess_iff
tff(fact_3720_embed__comp__embedS,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(A,B),R8: set(product_prod(C,C)),F10: fun(B,C)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( bNF_Wellorder_embed(A,B,R3,R4,F)
         => ( bNF_Wellorder_embedS(B,C,R4,R8,F10)
           => bNF_Wellorder_embedS(A,C,R3,R8,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F10),F)) ) ) ) ) ).

% embed_comp_embedS
tff(fact_3721_embedS__comp__embed,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(A,B),R8: set(product_prod(C,C)),F10: fun(B,C)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( bNF_Wellorder_embedS(A,B,R3,R4,F)
         => ( bNF_Wellorder_embed(B,C,R4,R8,F10)
           => bNF_Wellorder_embedS(A,C,R3,R8,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F10),F)) ) ) ) ) ).

% embedS_comp_embed
tff(fact_3722_embed__implies__iso__Restr,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(B,A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_well_order_on(B,field2(B,R4),R4)
       => ( bNF_Wellorder_embed(B,A,R4,R3,F)
         => bNF_Wellorder_iso(B,A,R4,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,aa(set(B),set(A),image2(B,A,F),field2(B,R4)),aa(fun(B,A),fun(A,set(A)),aTP_Lamp_nh(set(product_prod(B,B)),fun(fun(B,A),fun(A,set(A))),R4),F))),F) ) ) ) ).

% embed_implies_iso_Restr
tff(fact_3723_ofilter__subset__ordLeq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B3: set(A)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
       => ( order_ofilter(A,R3,B3)
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
          <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,B3,aTP_Lamp_if(set(A),fun(A,set(A)),B3)))),bNF_Wellorder_ordLeq(A,A))) ) ) ) ) ).

% ofilter_subset_ordLeq
tff(fact_3724_embed__ordLess__ofilterIncl,axiom,
    ! [B: $tType,A: $tType,C: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B)),R33: set(product_prod(C,C)),F13: fun(A,C),F23: fun(B,C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R1),R22),bNF_We4044943003108391690rdLess(A,B)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R22),R33),bNF_We4044943003108391690rdLess(B,C)))
       => ( bNF_Wellorder_embed(A,C,R1,R33,F13)
         => ( bNF_Wellorder_embed(B,C,R22,R33,F23)
           => pp(member(product_prod(set(C),set(C)),aa(set(C),product_prod(set(C),set(C)),aa(set(C),fun(set(C),product_prod(set(C),set(C))),product_Pair(set(C),set(C)),aa(set(A),set(C),image2(A,C,F13),field2(A,R1))),aa(set(B),set(C),image2(B,C,F23),field2(B,R22))),bNF_We413866401316099525erIncl(C,R33))) ) ) ) ) ).

% embed_ordLess_ofilterIncl
tff(fact_3725_Refl__under__underS,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] :
      ( refl_on(A,field2(A,R3),R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => ( order_under(A,R3,A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),order_underS(A,R3,A3)),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) ) ) ) ).

% Refl_under_underS
tff(fact_3726_ofilter__Restr__under,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),A3: A] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( order_ofilter(A,R3,A4)
       => ( pp(member(A,A3,A4))
         => ( order_under(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4))),A3) = order_under(A,R3,A3) ) ) ) ) ).

% ofilter_Restr_under
tff(fact_3727_comp__set__bd__Union__o__collect,axiom,
    ! [C: $tType,B: $tType,A: $tType,X: C,X6: set(fun(C,set(set(A)))),Hbd: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(set(A))),set(set(A)),complete_Sup_Sup(set(set(A))),aa(set(fun(C,set(set(A)))),set(set(set(A))),image2(fun(C,set(set(A))),set(set(A)),aTP_Lamp_ni(C,fun(fun(C,set(set(A))),set(set(A))),X)),X6))))),Hbd),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,aa(C,set(A),aa(fun(C,set(set(A))),fun(C,set(A)),aa(fun(set(set(A)),set(A)),fun(fun(C,set(set(A))),fun(C,set(A))),comp(set(set(A)),set(A),C),complete_Sup_Sup(set(A))),bNF_collect(C,set(A),X6)),X))),Hbd),bNF_Wellorder_ordLeq(A,B))) ) ).

% comp_set_bd_Union_o_collect
tff(fact_3728_card__of__Times1,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ( A4 != bot_bot(set(A)) )
     => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,B3,aTP_Lamp_ho(set(A),fun(B,set(A)),A4)))),bNF_Wellorder_ordLeq(B,product_prod(B,A)))) ) ).

% card_of_Times1
tff(fact_3729_card__of__Times2,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ( A4 != bot_bot(set(A)) )
     => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B)))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)))),bNF_Wellorder_ordLeq(B,product_prod(A,B)))) ) ).

% card_of_Times2
tff(fact_3730_card__of__Times3,axiom,
    ! [A: $tType,A4: set(A)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,A),product_prod(A,A)))),aa(set(product_prod(product_prod(A,A),product_prod(A,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,A),product_prod(A,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(A,A),product_prod(A,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,A),product_prod(A,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(A,A),product_prod(A,A)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(product_prod(A,A),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),bNF_Wellorder_ordLeq(A,product_prod(A,A)))) ).

% card_of_Times3
tff(fact_3731_card__of__Func__Times,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: set(A),B3: set(B),C3: set(C)] : pp(member(product_prod(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C))))),aa(set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C)))),product_prod(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C))))),aa(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),fun(set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C)))),product_prod(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C)))))),product_Pair(set(product_prod(fun(product_prod(A,B),C),fun(product_prod(A,B),C))),set(product_prod(fun(A,fun(B,C)),fun(A,fun(B,C))))),bNF_Ca6860139660246222851ard_of(fun(product_prod(A,B),C),bNF_Wellorder_Func(product_prod(A,B),C,product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)),C3))),bNF_Ca6860139660246222851ard_of(fun(A,fun(B,C)),bNF_Wellorder_Func(A,fun(B,C),A4,bNF_Wellorder_Func(B,C,B3,C3)))),bNF_Wellorder_ordIso(fun(product_prod(A,B),C),fun(A,fun(B,C))))) ).

% card_of_Func_Times
tff(fact_3732_Func__Times__Range,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: set(A),B3: set(B),C3: set(C)] : pp(member(product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C))))),aa(set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C)))),product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C))))),aa(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),fun(set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C)))),product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C)))))),product_Pair(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C))))),bNF_Ca6860139660246222851ard_of(fun(A,product_prod(B,C)),bNF_Wellorder_Func(A,product_prod(B,C),A4,product_Sigma(B,C,B3,aTP_Lamp_jm(set(C),fun(B,set(C)),C3))))),bNF_Ca6860139660246222851ard_of(product_prod(fun(A,B),fun(A,C)),product_Sigma(fun(A,B),fun(A,C),bNF_Wellorder_Func(A,B,A4,B3),aa(set(C),fun(fun(A,B),set(fun(A,C))),aTP_Lamp_nj(set(A),fun(set(C),fun(fun(A,B),set(fun(A,C)))),A4),C3)))),bNF_Wellorder_ordIso(fun(A,product_prod(B,C)),product_prod(fun(A,B),fun(A,C))))) ).

% Func_Times_Range
tff(fact_3733_card__of__Pow__Func,axiom,
    ! [A: $tType,A4: set(A)] : pp(member(product_prod(set(product_prod(set(A),set(A))),set(product_prod(fun(A,bool),fun(A,bool)))),aa(set(product_prod(fun(A,bool),fun(A,bool))),product_prod(set(product_prod(set(A),set(A))),set(product_prod(fun(A,bool),fun(A,bool)))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(fun(A,bool),fun(A,bool))),product_prod(set(product_prod(set(A),set(A))),set(product_prod(fun(A,bool),fun(A,bool))))),product_Pair(set(product_prod(set(A),set(A))),set(product_prod(fun(A,bool),fun(A,bool)))),bNF_Ca6860139660246222851ard_of(set(A),pow(A,A4))),bNF_Ca6860139660246222851ard_of(fun(A,bool),bNF_Wellorder_Func(A,bool,A4,top_top(set(bool))))),bNF_Wellorder_ordIso(set(A),fun(A,bool)))) ).

% card_of_Pow_Func
tff(fact_3734_card__of__Times__same__infinite,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => pp(member(product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,A),product_prod(A,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(A,A),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(product_prod(A,A),A))) ) ).

% card_of_Times_same_infinite
tff(fact_3735_card__of__Pow,axiom,
    ! [A: $tType,A4: set(A)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(A,A)),fun(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A))))),product_Pair(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(set(A),pow(A,A4))),bNF_We4044943003108391690rdLess(A,set(A)))) ).

% card_of_Pow
tff(fact_3736_card__of__Times__commute,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] : pp(member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)))),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,B3,aTP_Lamp_ho(set(A),fun(B,set(A)),A4)))),bNF_Wellorder_ordIso(product_prod(A,B),product_prod(B,A)))) ).

% card_of_Times_commute
tff(fact_3737_infinite__iff__card__of__nat,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
    <=> pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(nat,nat)),set(product_prod(A,A))),aa(set(product_prod(nat,nat)),fun(set(product_prod(A,A)),product_prod(set(product_prod(nat,nat)),set(product_prod(A,A)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(nat,top_top(set(nat)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(nat,A))) ) ).

% infinite_iff_card_of_nat
tff(fact_3738_card__of__bool,axiom,
    ! [A: $tType,A1: A,A22: A] :
      ( ( A1 != A22 )
     => pp(member(product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(bool,bool)),fun(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A)))),product_Pair(set(product_prod(bool,bool)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(bool,top_top(set(bool)))),bNF_Ca6860139660246222851ard_of(A,aa(set(A),set(A),insert2(A,A1),aa(set(A),set(A),insert2(A,A22),bot_bot(set(A)))))),bNF_Wellorder_ordIso(bool,A))) ) ).

% card_of_bool
tff(fact_3739_card__of__UNION__Sigma,axiom,
    ! [B: $tType,A: $tType,A4: fun(B,set(A)),I4: set(B)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Ca6860139660246222851ard_of(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),A4),I4)))),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,I4,A4))),bNF_Wellorder_ordLeq(A,product_prod(B,A)))) ).

% card_of_UNION_Sigma
tff(fact_3740_card__of__Times__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,A4: set(A),B3: set(B),C3: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,A),product_prod(C,A))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(product_prod(C,A),product_Sigma(C,A,C3,aTP_Lamp_nk(set(A),fun(C,set(A)),A4)))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,C3,aTP_Lamp_nl(set(B),fun(C,set(B)),B3)))),bNF_Wellorder_ordLeq(product_prod(C,A),product_prod(C,B)))) ) ).

% card_of_Times_mono2
tff(fact_3741_card__of__Times__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,A4: set(A),B3: set(B),C3: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(product_prod(A,C),product_Sigma(A,C,A4,aTP_Lamp_jv(set(C),fun(A,set(C)),C3)))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,B3,aTP_Lamp_jm(set(C),fun(B,set(C)),C3)))),bNF_Wellorder_ordLeq(product_prod(A,C),product_prod(B,C)))) ) ).

% card_of_Times_mono1
tff(fact_3742_card__of__Sigma__mono1,axiom,
    ! [C: $tType,B: $tType,A: $tType,I4: set(A),A4: fun(A,set(B)),B3: fun(A,set(C))] :
      ( ! [X2: A] :
          ( pp(member(A,X2,I4))
         => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(A,set(B),A4,X2))),bNF_Ca6860139660246222851ard_of(C,aa(A,set(C),B3,X2))),bNF_Wellorder_ordLeq(B,C))) )
     => pp(member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(product_prod(A,C),product_prod(A,C))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C))))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,I4,A4))),bNF_Ca6860139660246222851ard_of(product_prod(A,C),product_Sigma(A,C,I4,B3))),bNF_Wellorder_ordLeq(product_prod(A,B),product_prod(A,C)))) ) ).

% card_of_Sigma_mono1
tff(fact_3743_under__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] : ( order_under(A,R3,A3) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_nm(set(product_prod(A,A)),fun(A,fun(A,bool)),R3),A3)) ) ).

% under_def
tff(fact_3744_card__of__Sigma__ordLeq__infinite,axiom,
    ! [A: $tType,C: $tType,B: $tType,B3: set(A),I4: set(B),A4: fun(B,set(C))] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),B3))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,I4)),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_Wellorder_ordLeq(B,A)))
       => ( ! [X2: B] :
              ( pp(member(B,X2,I4))
             => pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A4,X2))),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_Wellorder_ordLeq(C,A))) )
         => pp(member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,I4,A4))),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_Wellorder_ordLeq(product_prod(B,C),A))) ) ) ) ).

% card_of_Sigma_ordLeq_infinite
tff(fact_3745_card__of__refl,axiom,
    ! [A: $tType,A4: set(A)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(A,A))) ).

% card_of_refl
tff(fact_3746_card__of__Times__infinite__simps_I4_J,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ( ( B3 != bot_bot(set(B)) )
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(B,A)))
         => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,B3,aTP_Lamp_ho(set(A),fun(B,set(A)),A4)))),bNF_Wellorder_ordIso(A,product_prod(B,A)))) ) ) ) ).

% card_of_Times_infinite_simps(4)
tff(fact_3747_card__of__Times__infinite__simps_I3_J,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ( ( B3 != bot_bot(set(B)) )
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(B,A)))
         => pp(member(product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,B3,aTP_Lamp_ho(set(A),fun(B,set(A)),A4)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(product_prod(B,A),A))) ) ) ) ).

% card_of_Times_infinite_simps(3)
tff(fact_3748_card__of__Times__infinite__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ( ( B3 != bot_bot(set(B)) )
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(B,A)))
         => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)))),bNF_Wellorder_ordIso(A,product_prod(A,B)))) ) ) ) ).

% card_of_Times_infinite_simps(2)
tff(fact_3749_card__of__Times__infinite__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ( ( B3 != bot_bot(set(B)) )
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(B,A)))
         => pp(member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(product_prod(A,B),A))) ) ) ) ).

% card_of_Times_infinite_simps(1)
tff(fact_3750_card__of__Times__infinite,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ( ( B3 != bot_bot(set(B)) )
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(B,A)))
         => ( pp(member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(product_prod(A,B),A)))
            & pp(member(product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,B3,aTP_Lamp_ho(set(A),fun(B,set(A)),A4)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(product_prod(B,A),A))) ) ) ) ) ).

% card_of_Times_infinite
tff(fact_3751_card__of__image,axiom,
    ! [B: $tType,A: $tType,F: fun(B,A),A4: set(B)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,aa(set(B),set(A),image2(B,A,F),A4))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(A,B))) ).

% card_of_image
tff(fact_3752_card__of__empty3,axiom,
    ! [B: $tType,A: $tType,A4: set(A)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),bNF_Wellorder_ordLeq(A,B)))
     => ( A4 = bot_bot(set(A)) ) ) ).

% card_of_empty3
tff(fact_3753_card__of__empty,axiom,
    ! [B: $tType,A: $tType,A4: set(B)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,bot_bot(set(A)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(A,B))) ).

% card_of_empty
tff(fact_3754_card__of__ordLeq__finite,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(aa(set(B),bool,finite_finite(B),B3))
       => pp(aa(set(A),bool,finite_finite(A),A4)) ) ) ).

% card_of_ordLeq_finite
tff(fact_3755_card__of__ordLeq__infinite,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B)))
     => ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
       => ~ pp(aa(set(B),bool,finite_finite(B),B3)) ) ) ).

% card_of_ordLeq_infinite
tff(fact_3756_card__of__mono1,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_Wellorder_ordLeq(A,A))) ) ).

% card_of_mono1
tff(fact_3757_card__of__empty__ordIso,axiom,
    ! [B: $tType,A: $tType] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,bot_bot(set(A)))),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),bNF_Wellorder_ordIso(A,B))) ).

% card_of_empty_ordIso
tff(fact_3758_card__of__empty2,axiom,
    ! [B: $tType,A: $tType,A4: set(A)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),bNF_Wellorder_ordIso(A,B)))
     => ( A4 = bot_bot(set(A)) ) ) ).

% card_of_empty2
tff(fact_3759_card__of__ordIso__finite,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordIso(A,B)))
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
      <=> pp(aa(set(B),bool,finite_finite(B),B3)) ) ) ).

% card_of_ordIso_finite
tff(fact_3760_card__of__mono2,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,field2(A,R3))),bNF_Ca6860139660246222851ard_of(B,field2(B,R4))),bNF_Wellorder_ordLeq(A,B))) ) ).

% card_of_mono2
tff(fact_3761_card__of__cong,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,field2(A,R3))),bNF_Ca6860139660246222851ard_of(B,field2(B,R4))),bNF_Wellorder_ordIso(A,B))) ) ).

% card_of_cong
tff(fact_3762_card__of__ordLeqI,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),A4: set(A),B3: set(B)] :
      ( inj_on(A,B,F,A4)
     => ( ! [A8: A] :
            ( pp(member(A,A8,A4))
           => pp(member(B,aa(A,B,F,A8),B3)) )
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B))) ) ) ).

% card_of_ordLeqI
tff(fact_3763_card__of__least,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( order_well_order_on(A,A4,R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(A,A4)),R3),bNF_Wellorder_ordLeq(A,A))) ) ).

% card_of_least
tff(fact_3764_BNF__Cardinal__Order__Relation_OordLess__Field,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,field2(A,R3))),R4),bNF_We4044943003108391690rdLess(A,B))) ) ).

% BNF_Cardinal_Order_Relation.ordLess_Field
tff(fact_3765_type__copy__set__bd,axiom,
    ! [A: $tType,D: $tType,C: $tType,B: $tType,S2: fun(A,set(B)),Bd: set(product_prod(C,C)),Rep: fun(D,A),X: D] :
      ( ! [Y2: A] : pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(A,set(B),S2,Y2))),Bd),bNF_Wellorder_ordLeq(B,C)))
     => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(D,set(B),aa(fun(D,A),fun(D,set(B)),aa(fun(A,set(B)),fun(fun(D,A),fun(D,set(B))),comp(A,set(B),D),S2),Rep),X))),Bd),bNF_Wellorder_ordLeq(B,C))) ) ).

% type_copy_set_bd
tff(fact_3766_card__of__ordLeq2,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] :
      ( ( A4 != bot_bot(set(A)) )
     => ( ? [G5: fun(B,A)] : ( aa(set(B),set(A),image2(B,A,G5),B3) = A4 )
      <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B))) ) ) ).

% card_of_ordLeq2
tff(fact_3767_surj__imp__ordLeq,axiom,
    ! [B: $tType,A: $tType,B3: set(A),F: fun(B,A),A4: set(B)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),aa(set(B),set(A),image2(B,A,F),A4)))
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(A,B))) ) ).

% surj_imp_ordLeq
tff(fact_3768_card__of__singl__ordLeq,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B2: B] :
      ( ( A4 != bot_bot(set(A)) )
     => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,aa(set(B),set(B),insert2(B,B2),bot_bot(set(B))))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(B,A))) ) ).

% card_of_singl_ordLeq
tff(fact_3769_card__of__ordLess2,axiom,
    ! [A: $tType,B: $tType,B3: set(A),A4: set(B)] :
      ( ( B3 != bot_bot(set(A)) )
     => ( ~ ? [F11: fun(B,A)] : ( aa(set(B),set(A),image2(B,A,F11),A4) = B3 )
      <=> pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_We4044943003108391690rdLess(B,A))) ) ) ).

% card_of_ordLess2
tff(fact_3770_internalize__card__of__ordLeq2,axiom,
    ! [A: $tType,B: $tType,A4: set(A),C3: set(B)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,C3)),bNF_Wellorder_ordLeq(A,B)))
    <=> ? [B8: set(B)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B8),C3))
          & pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B8)),bNF_Wellorder_ordIso(A,B)))
          & pp(member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,B8)),bNF_Ca6860139660246222851ard_of(B,C3)),bNF_Wellorder_ordLeq(B,B))) ) ) ).

% internalize_card_of_ordLeq2
tff(fact_3771_card__of__Field__ordLess,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(A,field2(A,R3))),R3),bNF_Wellorder_ordLeq(A,A))) ) ).

% card_of_Field_ordLess
tff(fact_3772_card__of__Func__UNIV,axiom,
    ! [B: $tType,A: $tType,B3: set(B)] : pp(member(product_prod(set(product_prod(fun(A,B),fun(A,B))),set(product_prod(fun(A,B),fun(A,B)))),aa(set(product_prod(fun(A,B),fun(A,B))),product_prod(set(product_prod(fun(A,B),fun(A,B))),set(product_prod(fun(A,B),fun(A,B)))),aa(set(product_prod(fun(A,B),fun(A,B))),fun(set(product_prod(fun(A,B),fun(A,B))),product_prod(set(product_prod(fun(A,B),fun(A,B))),set(product_prod(fun(A,B),fun(A,B))))),product_Pair(set(product_prod(fun(A,B),fun(A,B))),set(product_prod(fun(A,B),fun(A,B)))),bNF_Ca6860139660246222851ard_of(fun(A,B),bNF_Wellorder_Func(A,B,top_top(set(A)),B3))),bNF_Ca6860139660246222851ard_of(fun(A,B),aa(fun(fun(A,B),bool),set(fun(A,B)),collect(fun(A,B)),aTP_Lamp_nn(set(B),fun(fun(A,B),bool),B3)))),bNF_Wellorder_ordIso(fun(A,B),fun(A,B)))) ).

% card_of_Func_UNIV
tff(fact_3773_ordLeq__Times__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),C3: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(product_prod(A,C),product_Sigma(A,C,field2(A,R3),aTP_Lamp_jv(set(C),fun(A,set(C)),C3)))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,field2(B,R4),aTP_Lamp_jm(set(C),fun(B,set(C)),C3)))),bNF_Wellorder_ordLeq(product_prod(A,C),product_prod(B,C)))) ) ).

% ordLeq_Times_mono1
tff(fact_3774_ordLeq__Times__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),A4: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,A),product_prod(C,A))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(product_prod(C,A),product_Sigma(C,A,A4,aTP_Lamp_no(set(product_prod(A,A)),fun(C,set(A)),R3)))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,A4,aTP_Lamp_np(set(product_prod(B,B)),fun(C,set(B)),R4)))),bNF_Wellorder_ordLeq(product_prod(C,A),product_prod(C,B)))) ) ).

% ordLeq_Times_mono2
tff(fact_3775_card__of__ordLeq,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] :
      ( ? [F11: fun(A,B)] :
          ( inj_on(A,B,F11,A4)
          & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image2(A,B,F11),A4)),B3)) )
    <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B))) ) ).

% card_of_ordLeq
tff(fact_3776_internalize__card__of__ordLeq,axiom,
    ! [A: $tType,B: $tType,A4: set(A),R3: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),R3),bNF_Wellorder_ordLeq(A,B)))
    <=> ? [B8: set(B)] :
          ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B8),field2(B,R3)))
          & pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B8)),bNF_Wellorder_ordIso(A,B)))
          & pp(member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,B8)),R3),bNF_Wellorder_ordLeq(B,B))) ) ) ).

% internalize_card_of_ordLeq
tff(fact_3777_card__of__ordLess,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ~ ? [F11: fun(A,B)] :
            ( inj_on(A,B,F11,A4)
            & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image2(A,B,F11),A4)),B3)) )
    <=> pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_We4044943003108391690rdLess(B,A))) ) ).

% card_of_ordLess
tff(fact_3778_card__of__UNION__ordLeq__infinite,axiom,
    ! [B: $tType,A: $tType,C: $tType,B3: set(A),I4: set(B),A4: fun(B,set(C))] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),B3))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,I4)),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_Wellorder_ordLeq(B,A)))
       => ( ! [X2: B] :
              ( pp(member(B,X2,I4))
             => pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A4,X2))),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_Wellorder_ordLeq(C,A))) )
         => pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4)))),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_Wellorder_ordLeq(C,A))) ) ) ) ).

% card_of_UNION_ordLeq_infinite
tff(fact_3779_regularCard__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca7133664381575040944arCard(A,R3)
    <=> ! [K6: set(A)] :
          ( ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),K6),field2(A,R3)))
            & bNF_Ca7293521722713021262ofinal(A,K6,R3) )
         => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(A,K6)),R3),bNF_Wellorder_ordIso(A,A))) ) ) ).

% regularCard_def
tff(fact_3780_card__of__ordIso__subst,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( ( A4 = B3 )
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_Wellorder_ordIso(A,A))) ) ).

% card_of_ordIso_subst
tff(fact_3781_Card__order__iff__Restr__underS,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
      <=> ! [X4: A] :
            ( pp(member(A,X4,field2(A,R3)))
           => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,order_underS(A,R3,X4),aa(A,fun(A,set(A)),aTP_Lamp_nf(set(product_prod(A,A)),fun(A,fun(A,set(A))),R3),X4)))),bNF_Ca6860139660246222851ard_of(A,field2(A,R3))),bNF_We4044943003108391690rdLess(A,A))) ) ) ) ).

% Card_order_iff_Restr_underS
tff(fact_3782_card__of__Plus__Times__aux,axiom,
    ! [B: $tType,A: $tType,A1: A,A22: A,A4: set(A),B3: set(B)] :
      ( ( ( A1 != A22 )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,A1),aa(set(A),set(A),insert2(A,A22),bot_bot(set(A))))),A4)) )
     => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B)))
       => pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A4,B3))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)))),bNF_Wellorder_ordLeq(sum_sum(A,B),product_prod(A,B)))) ) ) ).

% card_of_Plus_Times_aux
tff(fact_3783_Card__order__Plus1,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),B3: set(B)] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),R3),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,field2(A,R3),B3))),bNF_Wellorder_ordLeq(A,sum_sum(A,B)))) ) ).

% Card_order_Plus1
tff(fact_3784_Card__order__Plus2,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),A4: set(B)] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),R3),bNF_Ca6860139660246222851ard_of(sum_sum(B,A),sum_Plus(B,A,A4,field2(A,R3)))),bNF_Wellorder_ordLeq(A,sum_sum(B,A)))) ) ).

% Card_order_Plus2
tff(fact_3785_card__of__Plus__commute,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] : pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(B,A),sum_sum(B,A))))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A4,B3))),bNF_Ca6860139660246222851ard_of(sum_sum(B,A),sum_Plus(B,A,B3,A4))),bNF_Wellorder_ordIso(sum_sum(A,B),sum_sum(B,A)))) ).

% card_of_Plus_commute
tff(fact_3786_card__of__Plus__assoc,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: set(A),B3: set(B),C3: set(C)] : pp(member(product_prod(set(product_prod(sum_sum(sum_sum(A,B),C),sum_sum(sum_sum(A,B),C))),set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C))))),aa(set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C)))),product_prod(set(product_prod(sum_sum(sum_sum(A,B),C),sum_sum(sum_sum(A,B),C))),set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C))))),aa(set(product_prod(sum_sum(sum_sum(A,B),C),sum_sum(sum_sum(A,B),C))),fun(set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C)))),product_prod(set(product_prod(sum_sum(sum_sum(A,B),C),sum_sum(sum_sum(A,B),C))),set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C)))))),product_Pair(set(product_prod(sum_sum(sum_sum(A,B),C),sum_sum(sum_sum(A,B),C))),set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C))))),bNF_Ca6860139660246222851ard_of(sum_sum(sum_sum(A,B),C),sum_Plus(sum_sum(A,B),C,sum_Plus(A,B,A4,B3),C3))),bNF_Ca6860139660246222851ard_of(sum_sum(A,sum_sum(B,C)),sum_Plus(A,sum_sum(B,C),A4,sum_Plus(B,C,B3,C3)))),bNF_Wellorder_ordIso(sum_sum(sum_sum(A,B),C),sum_sum(A,sum_sum(B,C))))) ).

% card_of_Plus_assoc
tff(fact_3787_card__of__Plus2,axiom,
    ! [B: $tType,A: $tType,B3: set(A),A4: set(B)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),bNF_Ca6860139660246222851ard_of(A,B3)),bNF_Ca6860139660246222851ard_of(sum_sum(B,A),sum_Plus(B,A,A4,B3))),bNF_Wellorder_ordLeq(A,sum_sum(B,A)))) ).

% card_of_Plus2
tff(fact_3788_card__of__Plus1,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A4,B3))),bNF_Wellorder_ordLeq(A,sum_sum(A,B)))) ).

% card_of_Plus1
tff(fact_3789_card__of__Times__Plus__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,A4: set(A),B3: set(B),C3: set(C)] : pp(member(product_prod(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C))))),aa(set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))),product_prod(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C))))),aa(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),fun(set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))),product_prod(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))))),product_Pair(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C))))),bNF_Ca6860139660246222851ard_of(product_prod(A,sum_sum(B,C)),product_Sigma(A,sum_sum(B,C),A4,aa(set(C),fun(A,set(sum_sum(B,C))),aTP_Lamp_nq(set(B),fun(set(C),fun(A,set(sum_sum(B,C)))),B3),C3)))),bNF_Ca6860139660246222851ard_of(sum_sum(product_prod(A,B),product_prod(A,C)),sum_Plus(product_prod(A,B),product_prod(A,C),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)),product_Sigma(A,C,A4,aTP_Lamp_jv(set(C),fun(A,set(C)),C3))))),bNF_Wellorder_ordIso(product_prod(A,sum_sum(B,C)),sum_sum(product_prod(A,B),product_prod(A,C))))) ).

% card_of_Times_Plus_distrib
tff(fact_3790_Card__order__Plus__infinite,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),P3: set(product_prod(B,B))] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
     => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),P3),R3),bNF_Wellorder_ordLeq(B,A)))
         => ( pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,field2(A,R3),field2(B,P3)))),R3),bNF_Wellorder_ordIso(sum_sum(A,B),A)))
            & pp(member(product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(sum_sum(B,A),sum_Plus(B,A,field2(B,P3),field2(A,R3)))),R3),bNF_Wellorder_ordIso(sum_sum(B,A),A))) ) ) ) ) ).

% Card_order_Plus_infinite
tff(fact_3791_card__of__Plus__Times__bool,axiom,
    ! [A: $tType,A4: set(A)] : pp(member(product_prod(set(product_prod(sum_sum(A,A),sum_sum(A,A))),set(product_prod(product_prod(A,bool),product_prod(A,bool)))),aa(set(product_prod(product_prod(A,bool),product_prod(A,bool))),product_prod(set(product_prod(sum_sum(A,A),sum_sum(A,A))),set(product_prod(product_prod(A,bool),product_prod(A,bool)))),aa(set(product_prod(sum_sum(A,A),sum_sum(A,A))),fun(set(product_prod(product_prod(A,bool),product_prod(A,bool))),product_prod(set(product_prod(sum_sum(A,A),sum_sum(A,A))),set(product_prod(product_prod(A,bool),product_prod(A,bool))))),product_Pair(set(product_prod(sum_sum(A,A),sum_sum(A,A))),set(product_prod(product_prod(A,bool),product_prod(A,bool)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,A),sum_Plus(A,A,A4,A4))),bNF_Ca6860139660246222851ard_of(product_prod(A,bool),product_Sigma(A,bool,A4,aTP_Lamp_nr(A,set(bool))))),bNF_Wellorder_ordIso(sum_sum(A,A),product_prod(A,bool)))) ).

% card_of_Plus_Times_bool
tff(fact_3792_Card__order__trans,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X: A,Y: A,Z2: A] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( ( X != Y )
       => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
         => ( ( Y != Z2 )
           => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),Z2),R3))
             => ( ( X != Z2 )
                & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),R3)) ) ) ) ) ) ) ).

% Card_order_trans
tff(fact_3793_ordLeq__refl,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),R3),bNF_Wellorder_ordLeq(A,A))) ) ).

% ordLeq_refl
tff(fact_3794_ordIso__refl,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),R3),bNF_Wellorder_ordIso(A,A))) ) ).

% ordIso_refl
tff(fact_3795_card__order__on__ordIso,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A)),R4: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,A4,R3)
     => ( bNF_Ca8970107618336181345der_on(A,A4,R4)
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),R4),bNF_Wellorder_ordIso(A,A))) ) ) ).

% card_order_on_ordIso
tff(fact_3796_card__of__Plus__empty2,axiom,
    ! [B: $tType,A: $tType,A4: set(A)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(sum_sum(B,A),sum_Plus(B,A,bot_bot(set(B)),A4))),bNF_Wellorder_ordIso(A,sum_sum(B,A)))) ).

% card_of_Plus_empty2
tff(fact_3797_card__of__Plus__empty1,axiom,
    ! [B: $tType,A: $tType,A4: set(A)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A4,bot_bot(set(B))))),bNF_Wellorder_ordIso(A,sum_sum(A,B)))) ).

% card_of_Plus_empty1
tff(fact_3798_card__of__Un__Plus__ordLeq,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,A),sum_sum(A,A)))),aa(set(product_prod(sum_sum(A,A),sum_sum(A,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,A),sum_sum(A,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(A,A),sum_sum(A,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,A),sum_sum(A,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(A,A),sum_sum(A,A)))),bNF_Ca6860139660246222851ard_of(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3))),bNF_Ca6860139660246222851ard_of(sum_sum(A,A),sum_Plus(A,A,A4,B3))),bNF_Wellorder_ordLeq(A,sum_sum(A,A)))) ).

% card_of_Un_Plus_ordLeq
tff(fact_3799_card__of__Plus__ordLeq__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set(product_prod(A,A)),A4: set(B),B3: set(C)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,A)))
       => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,B3)),R3),bNF_Wellorder_ordLeq(C,A)))
         => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
           => pp(member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,B3))),R3),bNF_Wellorder_ordLeq(sum_sum(B,C),A))) ) ) ) ) ).

% card_of_Plus_ordLeq_infinite_Field
tff(fact_3800_card__of__Plus__ordLess__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set(product_prod(A,A)),A4: set(B),B3: set(C)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
     => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_We4044943003108391690rdLess(B,A)))
         => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,B3)),R3),bNF_We4044943003108391690rdLess(C,A)))
           => pp(member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,B3))),R3),bNF_We4044943003108391690rdLess(sum_sum(B,C),A))) ) ) ) ) ).

% card_of_Plus_ordLess_infinite_Field
tff(fact_3801_infinite__Card__order__limit,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
       => ( pp(member(A,A3,field2(A,R3)))
         => ? [X2: A] :
              ( pp(member(A,X2,field2(A,R3)))
              & ( A3 != X2 )
              & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),X2),R3)) ) ) ) ) ).

% infinite_Card_order_limit
tff(fact_3802_Card__order__ordIso,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),R3),bNF_Wellorder_ordIso(B,A)))
       => bNF_Ca8970107618336181345der_on(B,field2(B,R4),R4) ) ) ).

% Card_order_ordIso
tff(fact_3803_Card__order__ordIso2,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
       => bNF_Ca8970107618336181345der_on(B,field2(B,R4),R4) ) ) ).

% Card_order_ordIso2
tff(fact_3804_card__of__unique,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,A4,R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(A,A))) ) ).

% card_of_unique
tff(fact_3805_card__order__on__def,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,A4,R3)
    <=> ( order_well_order_on(A,A4,R3)
        & ! [R9: set(product_prod(A,A))] :
            ( order_well_order_on(A,A4,R9)
           => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),R9),bNF_Wellorder_ordLeq(A,A))) ) ) ) ).

% card_order_on_def
tff(fact_3806_ordLeq__Plus__mono,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),P3: set(product_prod(C,C)),P8: set(product_prod(D,D))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),P3),P8),bNF_Wellorder_ordLeq(C,D)))
       => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,C),sum_Plus(A,C,field2(A,R3),field2(C,P3)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,field2(B,R4),field2(D,P8)))),bNF_Wellorder_ordLeq(sum_sum(A,C),sum_sum(B,D)))) ) ) ).

% ordLeq_Plus_mono
tff(fact_3807_ordLeq__Plus__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),C3: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,C),sum_Plus(A,C,field2(A,R3),C3))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,field2(B,R4),C3))),bNF_Wellorder_ordLeq(sum_sum(A,C),sum_sum(B,C)))) ) ).

% ordLeq_Plus_mono1
tff(fact_3808_ordLeq__Plus__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),A4: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,A),sum_sum(C,A))),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Ca6860139660246222851ard_of(sum_sum(C,A),sum_Plus(C,A,A4,field2(A,R3)))),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,A4,field2(B,R4)))),bNF_Wellorder_ordLeq(sum_sum(C,A),sum_sum(C,B)))) ) ).

% ordLeq_Plus_mono2
tff(fact_3809_ordIso__Plus__cong,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),P3: set(product_prod(C,C)),P8: set(product_prod(D,D))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),P3),P8),bNF_Wellorder_ordIso(C,D)))
       => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,C),sum_Plus(A,C,field2(A,R3),field2(C,P3)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,field2(B,R4),field2(D,P8)))),bNF_Wellorder_ordIso(sum_sum(A,C),sum_sum(B,D)))) ) ) ).

% ordIso_Plus_cong
tff(fact_3810_ordIso__Plus__cong1,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),C3: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,C),sum_Plus(A,C,field2(A,R3),C3))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,field2(B,R4),C3))),bNF_Wellorder_ordIso(sum_sum(A,C),sum_sum(B,C)))) ) ).

% ordIso_Plus_cong1
tff(fact_3811_ordIso__Plus__cong2,axiom,
    ! [B: $tType,A: $tType,C: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),A4: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,A),sum_sum(C,A))),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Ca6860139660246222851ard_of(sum_sum(C,A),sum_Plus(C,A,A4,field2(A,R3)))),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,A4,field2(B,R4)))),bNF_Wellorder_ordIso(sum_sum(C,A),sum_sum(C,B)))) ) ).

% ordIso_Plus_cong2
tff(fact_3812_card__of__Plus__mono,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,A4: set(A),B3: set(B),C3: set(C),D4: set(D)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),bNF_Ca6860139660246222851ard_of(C,C3)),bNF_Ca6860139660246222851ard_of(D,D4)),bNF_Wellorder_ordLeq(C,D)))
       => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,C),sum_Plus(A,C,A4,C3))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,B3,D4))),bNF_Wellorder_ordLeq(sum_sum(A,C),sum_sum(B,D)))) ) ) ).

% card_of_Plus_mono
tff(fact_3813_card__of__Plus__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,A4: set(A),B3: set(B),C3: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,C),sum_Plus(A,C,A4,C3))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,B3,C3))),bNF_Wellorder_ordLeq(sum_sum(A,C),sum_sum(B,C)))) ) ).

% card_of_Plus_mono1
tff(fact_3814_card__of__Plus__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,A4: set(A),B3: set(B),C3: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,A),sum_sum(C,A))),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Ca6860139660246222851ard_of(sum_sum(C,A),sum_Plus(C,A,C3,A4))),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,C3,B3))),bNF_Wellorder_ordLeq(sum_sum(C,A),sum_sum(C,B)))) ) ).

% card_of_Plus_mono2
tff(fact_3815_card__of__Plus__cong,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,A4: set(A),B3: set(B),C3: set(C),D4: set(D)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordIso(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),bNF_Ca6860139660246222851ard_of(C,C3)),bNF_Ca6860139660246222851ard_of(D,D4)),bNF_Wellorder_ordIso(C,D)))
       => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,C),sum_Plus(A,C,A4,C3))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,B3,D4))),bNF_Wellorder_ordIso(sum_sum(A,C),sum_sum(B,D)))) ) ) ).

% card_of_Plus_cong
tff(fact_3816_card__of__Plus__cong1,axiom,
    ! [B: $tType,C: $tType,A: $tType,A4: set(A),B3: set(B),C3: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,C),sum_Plus(A,C,A4,C3))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,B3,C3))),bNF_Wellorder_ordIso(sum_sum(A,C),sum_sum(B,C)))) ) ).

% card_of_Plus_cong1
tff(fact_3817_card__of__Plus__cong2,axiom,
    ! [B: $tType,A: $tType,C: $tType,A4: set(A),B3: set(B),C3: set(C)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,A),sum_sum(C,A))),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Ca6860139660246222851ard_of(sum_sum(C,A),sum_Plus(C,A,C3,A4))),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,C3,B3))),bNF_Wellorder_ordIso(sum_sum(C,A),sum_sum(C,B)))) ) ).

% card_of_Plus_cong2
tff(fact_3818_Card__order__Times2,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),A4: set(B)] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( ( A4 != bot_bot(set(B)) )
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(B,A),product_prod(B,A)))),R3),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,A4,aTP_Lamp_ns(set(product_prod(A,A)),fun(B,set(A)),R3)))),bNF_Wellorder_ordLeq(A,product_prod(B,A)))) ) ) ).

% Card_order_Times2
tff(fact_3819_Card__order__Times1,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),B3: set(B)] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( ( B3 != bot_bot(set(B)) )
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(A,A)),set(product_prod(product_prod(A,B),product_prod(A,B)))),R3),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,field2(A,R3),aTP_Lamp_hq(set(B),fun(A,set(B)),B3)))),bNF_Wellorder_ordLeq(A,product_prod(A,B)))) ) ) ).

% Card_order_Times1
tff(fact_3820_Card__order__Times__same__infinite,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
       => pp(member(product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,A),product_prod(A,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(A,A),product_Sigma(A,A,field2(A,R3),aTP_Lamp_ig(set(product_prod(A,A)),fun(A,set(A)),R3)))),R3),bNF_Wellorder_ordLeq(product_prod(A,A),A))) ) ) ).

% Card_order_Times_same_infinite
tff(fact_3821_Card__order__Pow,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(A,A)),fun(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A))))),product_Pair(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),R3),bNF_Ca6860139660246222851ard_of(set(A),pow(A,field2(A,R3)))),bNF_We4044943003108391690rdLess(A,set(A)))) ) ).

% Card_order_Pow
tff(fact_3822_Card__order__iff__ordLeq__card__of,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
    <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),bNF_Ca6860139660246222851ard_of(A,field2(A,R3))),bNF_Wellorder_ordLeq(A,A))) ) ).

% Card_order_iff_ordLeq_card_of
tff(fact_3823_card__of__Field__ordIso,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(A,field2(A,R3))),R3),bNF_Wellorder_ordIso(A,A))) ) ).

% card_of_Field_ordIso
tff(fact_3824_Card__order__iff__ordIso__card__of,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
    <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),bNF_Ca6860139660246222851ard_of(A,field2(A,R3))),bNF_Wellorder_ordIso(A,A))) ) ).

% Card_order_iff_ordIso_card_of
tff(fact_3825_ordIso__card__of__imp__Card__order,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),A4: set(B)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(A,B)))
     => bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) ) ).

% ordIso_card_of_imp_Card_order
tff(fact_3826_card__of__Plus__infinite2,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(B,A)))
       => pp(member(product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(sum_sum(B,A),sum_Plus(B,A,B3,A4))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(sum_sum(B,A),A))) ) ) ).

% card_of_Plus_infinite2
tff(fact_3827_card__of__Plus__infinite1,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(B,A)))
       => pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A4,B3))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(sum_sum(A,B),A))) ) ) ).

% card_of_Plus_infinite1
tff(fact_3828_card__of__Plus__infinite,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(B,A)))
       => ( pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A4,B3))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(sum_sum(A,B),A)))
          & pp(member(product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(sum_sum(B,A),sum_Plus(B,A,B3,A4))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordIso(sum_sum(B,A),A))) ) ) ) ).

% card_of_Plus_infinite
tff(fact_3829_card__of__Plus__ordLess__infinite,axiom,
    ! [A: $tType,C: $tType,B: $tType,C3: set(A),A4: set(B),B3: set(C)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),C3))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(A,C3)),bNF_We4044943003108391690rdLess(B,A)))
       => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,B3)),bNF_Ca6860139660246222851ard_of(A,C3)),bNF_We4044943003108391690rdLess(C,A)))
         => pp(member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,B3))),bNF_Ca6860139660246222851ard_of(A,C3)),bNF_We4044943003108391690rdLess(sum_sum(B,C),A))) ) ) ) ).

% card_of_Plus_ordLess_infinite
tff(fact_3830_card__of__Plus__Times,axiom,
    ! [B: $tType,A: $tType,A1: A,A22: A,A4: set(A),B12: B,B23: B,B3: set(B)] :
      ( ( ( A1 != A22 )
        & pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,A1),aa(set(A),set(A),insert2(A,A22),bot_bot(set(A))))),A4)) )
     => ( ( ( B12 != B23 )
          & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,B12),aa(set(B),set(B),insert2(B,B23),bot_bot(set(B))))),B3)) )
       => pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(product_prod(A,B),product_prod(A,B)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A4,B3))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)))),bNF_Wellorder_ordLeq(sum_sum(A,B),product_prod(A,B)))) ) ) ).

% card_of_Plus_Times
tff(fact_3831_exists__minim__Card__order,axiom,
    ! [A: $tType,R: set(set(product_prod(A,A)))] :
      ( ( R != bot_bot(set(set(product_prod(A,A)))) )
     => ( ! [X2: set(product_prod(A,A))] :
            ( pp(member(set(product_prod(A,A)),X2,R))
           => bNF_Ca8970107618336181345der_on(A,field2(A,X2),X2) )
       => ? [X2: set(product_prod(A,A))] :
            ( pp(member(set(product_prod(A,A)),X2,R))
            & ! [Xa3: set(product_prod(A,A))] :
                ( pp(member(set(product_prod(A,A)),Xa3,R))
               => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),X2),Xa3),bNF_Wellorder_ordLeq(A,A))) ) ) ) ) ).

% exists_minim_Card_order
tff(fact_3832_Card__order__empty,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),R3),bNF_Wellorder_ordLeq(B,A))) ) ).

% Card_order_empty
tff(fact_3833_card__of__ordIso__finite__Field,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),A4: set(B)] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(A,B)))
       => ( pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
        <=> pp(aa(set(B),bool,finite_finite(B),A4)) ) ) ) ).

% card_of_ordIso_finite_Field
tff(fact_3834_card__of__underS,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( pp(member(A,A3,field2(A,R3)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(A,order_underS(A,R3,A3))),R3),bNF_We4044943003108391690rdLess(A,A))) ) ) ).

% card_of_underS
tff(fact_3835_regularCard__UNION,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),As8: fun(A,set(B)),B3: set(B)] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( bNF_Ca7133664381575040944arCard(A,R3)
       => ( bNF_Ca3754400796208372196lChain(A,set(B),R3,As8)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image2(A,set(B),As8),field2(A,R3)))))
           => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),R3),bNF_We4044943003108391690rdLess(B,A)))
             => ? [X2: A] :
                  ( pp(member(A,X2,field2(A,R3)))
                  & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),aa(A,set(B),As8,X2))) ) ) ) ) ) ) ).

% regularCard_UNION
tff(fact_3836_Card__order__singl__ordLeq,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),B2: B] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( ( field2(A,R3) != bot_bot(set(A)) )
       => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,aa(set(B),set(B),insert2(B,B2),bot_bot(set(B))))),R3),bNF_Wellorder_ordLeq(B,A))) ) ) ).

% Card_order_singl_ordLeq
tff(fact_3837_card__of__Un__ordLeq__infinite__Field,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),A4: set(B),B3: set(B)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,A)))
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),R3),bNF_Wellorder_ordLeq(B,A)))
         => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
           => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))),R3),bNF_Wellorder_ordLeq(B,A))) ) ) ) ) ).

% card_of_Un_ordLeq_infinite_Field
tff(fact_3838_card__of__empty1,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A))] :
      ( ( order_well_order_on(A,field2(A,R3),R3)
        | bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),R3),bNF_Wellorder_ordLeq(B,A))) ) ).

% card_of_empty1
tff(fact_3839_Card__order__Times__infinite,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),P3: set(product_prod(B,B))] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
     => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
       => ( ( field2(B,P3) != bot_bot(set(B)) )
         => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),P3),R3),bNF_Wellorder_ordLeq(B,A)))
           => ( pp(member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(A,B),product_Sigma(A,B,field2(A,R3),aTP_Lamp_nt(set(product_prod(B,B)),fun(A,set(B)),P3)))),R3),bNF_Wellorder_ordIso(product_prod(A,B),A)))
              & pp(member(product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,A),product_prod(B,A))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,A),product_Sigma(B,A,field2(B,P3),aTP_Lamp_ns(set(product_prod(A,A)),fun(B,set(A)),R3)))),R3),bNF_Wellorder_ordIso(product_prod(B,A),A))) ) ) ) ) ) ).

% Card_order_Times_infinite
tff(fact_3840_card__of__Sigma__ordLeq__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set(product_prod(A,A)),I4: set(B),A4: fun(B,set(C))] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
     => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,I4)),R3),bNF_Wellorder_ordLeq(B,A)))
         => ( ! [X2: B] :
                ( pp(member(B,X2,I4))
               => pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A4,X2))),R3),bNF_Wellorder_ordLeq(C,A))) )
           => pp(member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,I4,A4))),R3),bNF_Wellorder_ordLeq(product_prod(B,C),A))) ) ) ) ) ).

% card_of_Sigma_ordLeq_infinite_Field
tff(fact_3841_card__of__Times__ordLeq__infinite__Field,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set(product_prod(A,A)),A4: set(B),B3: set(C)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,A)))
       => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,B3)),R3),bNF_Wellorder_ordLeq(C,A)))
         => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
           => pp(member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A4,aTP_Lamp_jm(set(C),fun(B,set(C)),B3)))),R3),bNF_Wellorder_ordLeq(product_prod(B,C),A))) ) ) ) ) ).

% card_of_Times_ordLeq_infinite_Field
tff(fact_3842_card__of__UNION__ordLeq__infinite__Field,axiom,
    ! [B: $tType,A: $tType,C: $tType,R3: set(product_prod(A,A)),I4: set(B),A4: fun(B,set(C))] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
     => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,I4)),R3),bNF_Wellorder_ordLeq(B,A)))
         => ( ! [X2: B] :
                ( pp(member(B,X2,I4))
               => pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A4,X2))),R3),bNF_Wellorder_ordLeq(C,A))) )
           => pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4)))),R3),bNF_Wellorder_ordLeq(C,A))) ) ) ) ) ).

% card_of_UNION_ordLeq_infinite_Field
tff(fact_3843_Plus__eq__empty__conv,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ( sum_Plus(A,B,A4,B3) = bot_bot(set(sum_sum(A,B))) )
    <=> ( ( A4 = bot_bot(set(A)) )
        & ( B3 = bot_bot(set(B)) ) ) ) ).

% Plus_eq_empty_conv
tff(fact_3844_ex__toCard__pred,axiom,
    ! [B: $tType,A: $tType,A4: set(A),R3: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),R3),bNF_Wellorder_ordLeq(A,B)))
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => ? [X_1: fun(A,B)] : bNF_Gr1419584066657907630d_pred(A,B,A4,R3,X_1) ) ) ).

% ex_toCard_pred
tff(fact_3845_cardSuc__UNION,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),As8: fun(set(A),set(B)),B3: set(B)] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( ~ pp(aa(set(A),bool,finite_finite(A),field2(A,R3)))
       => ( bNF_Ca3754400796208372196lChain(set(A),set(B),bNF_Ca8387033319878233205ardSuc(A,R3),As8)
         => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(A)),set(set(B)),image2(set(A),set(B),As8),field2(set(A),bNF_Ca8387033319878233205ardSuc(A,R3))))))
           => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),R3),bNF_Wellorder_ordLeq(B,A)))
             => ? [X2: set(A)] :
                  ( pp(member(set(A),X2,field2(set(A),bNF_Ca8387033319878233205ardSuc(A,R3))))
                  & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),aa(set(A),set(B),As8,X2))) ) ) ) ) ) ) ).

% cardSuc_UNION
tff(fact_3846_isCardSuc__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(set(A),set(A)))] :
      ( bNF_Ca6246979054910435723ardSuc(A,R3,R4)
    <=> ( bNF_Ca8970107618336181345der_on(set(A),field2(set(A),R4),R4)
        & pp(member(product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(A,A)),fun(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A))))),product_Pair(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),R3),R4),bNF_We4044943003108391690rdLess(A,set(A))))
        & ! [R10: set(product_prod(set(A),set(A)))] :
            ( ( bNF_Ca8970107618336181345der_on(set(A),field2(set(A),R10),R10)
              & pp(member(product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(A,A)),fun(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A))))),product_Pair(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),R3),R10),bNF_We4044943003108391690rdLess(A,set(A)))) )
           => pp(member(product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))))),product_Pair(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),R4),R10),bNF_Wellorder_ordLeq(set(A),set(A)))) ) ) ) ).

% isCardSuc_def
tff(fact_3847_cardSuc__ordLeq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(A,A)),fun(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A))))),product_Pair(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),R3),bNF_Ca8387033319878233205ardSuc(A,R3)),bNF_Wellorder_ordLeq(A,set(A)))) ) ).

% cardSuc_ordLeq
tff(fact_3848_cardSuc__greater,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(A,A)),fun(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A))))),product_Pair(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),R3),bNF_Ca8387033319878233205ardSuc(A,R3)),bNF_We4044943003108391690rdLess(A,set(A)))) ) ).

% cardSuc_greater
tff(fact_3849_cardSuc__ordLess__ordLeq,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R4),R4)
       => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
        <=> pp(member(product_prod(set(product_prod(set(A),set(A))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(set(A),set(A))),set(product_prod(B,B))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(B,B)),product_prod(set(product_prod(set(A),set(A))),set(product_prod(B,B)))),product_Pair(set(product_prod(set(A),set(A))),set(product_prod(B,B))),bNF_Ca8387033319878233205ardSuc(A,R3)),R4),bNF_Wellorder_ordLeq(set(A),B))) ) ) ) ).

% cardSuc_ordLess_ordLeq
tff(fact_3850_cardSuc__least,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R4),R4)
       => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_We4044943003108391690rdLess(A,B)))
         => pp(member(product_prod(set(product_prod(set(A),set(A))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(set(A),set(A))),set(product_prod(B,B))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(B,B)),product_prod(set(product_prod(set(A),set(A))),set(product_prod(B,B)))),product_Pair(set(product_prod(set(A),set(A))),set(product_prod(B,B))),bNF_Ca8387033319878233205ardSuc(A,R3)),R4),bNF_Wellorder_ordLeq(set(A),B))) ) ) ) ).

% cardSuc_least
tff(fact_3851_cardSuc__mono__ordLeq,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R4),R4)
       => ( pp(member(product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(set(A),set(A))),set(product_prod(set(B),set(B)))),bNF_Ca8387033319878233205ardSuc(A,R3)),bNF_Ca8387033319878233205ardSuc(B,R4)),bNF_Wellorder_ordLeq(set(A),set(B))))
        <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordLeq(A,B))) ) ) ) ).

% cardSuc_mono_ordLeq
tff(fact_3852_cardSuc__invar__ordIso,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R4),R4)
       => ( pp(member(product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(set(A),set(A))),set(product_prod(set(B),set(B)))),bNF_Ca8387033319878233205ardSuc(A,R3)),bNF_Ca8387033319878233205ardSuc(B,R4)),bNF_Wellorder_ordIso(set(A),set(B))))
        <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(A,B))) ) ) ) ).

% cardSuc_invar_ordIso
tff(fact_3853_cardSuc__least__aux,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(set(A),set(A)))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(set(A),field2(set(A),R4),R4)
       => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),aa(set(product_prod(A,A)),fun(set(product_prod(set(A),set(A))),product_prod(set(product_prod(A,A)),set(product_prod(set(A),set(A))))),product_Pair(set(product_prod(A,A)),set(product_prod(set(A),set(A)))),R3),R4),bNF_We4044943003108391690rdLess(A,set(A))))
         => pp(member(product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),fun(set(product_prod(set(A),set(A))),product_prod(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A))))),product_Pair(set(product_prod(set(A),set(A))),set(product_prod(set(A),set(A)))),bNF_Ca8387033319878233205ardSuc(A,R3)),R4),bNF_Wellorder_ordLeq(set(A),set(A)))) ) ) ) ).

% cardSuc_least_aux
tff(fact_3854_cardSuc__ordLeq__ordLess,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R4),R4)
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(set(A),set(A)))),aa(set(product_prod(set(A),set(A))),product_prod(set(product_prod(B,B)),set(product_prod(set(A),set(A)))),aa(set(product_prod(B,B)),fun(set(product_prod(set(A),set(A))),product_prod(set(product_prod(B,B)),set(product_prod(set(A),set(A))))),product_Pair(set(product_prod(B,B)),set(product_prod(set(A),set(A)))),R4),bNF_Ca8387033319878233205ardSuc(A,R3)),bNF_We4044943003108391690rdLess(B,set(A))))
        <=> pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R4),R3),bNF_Wellorder_ordLeq(B,A))) ) ) ) ).

% cardSuc_ordLeq_ordLess
tff(fact_3855_toCard__pred__toCard,axiom,
    ! [A: $tType,B: $tType,A4: set(A),R3: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),R3),bNF_Wellorder_ordLeq(A,B)))
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => bNF_Gr1419584066657907630d_pred(A,B,A4,R3,bNF_Greatest_toCard(A,B,A4,R3)) ) ) ).

% toCard_pred_toCard
tff(fact_3856_cardSuc__UNION__Cinfinite,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),As8: fun(set(A),set(B)),B3: set(B)] :
      ( ( bNF_Ca4139267488887388095finite(A,R3)
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => ( bNF_Ca3754400796208372196lChain(set(A),set(B),bNF_Ca8387033319878233205ardSuc(A,R3),As8)
       => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(A)),set(set(B)),image2(set(A),set(B),As8),field2(set(A),bNF_Ca8387033319878233205ardSuc(A,R3))))))
         => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(B,B3)),R3),bNF_Wellorder_ordLeq(B,A)))
           => ? [X2: set(A)] :
                ( pp(member(set(A),X2,field2(set(A),bNF_Ca8387033319878233205ardSuc(A,R3))))
                & pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),B3),aa(set(A),set(B),As8,X2))) ) ) ) ) ) ).

% cardSuc_UNION_Cinfinite
tff(fact_3857_toCard__inj,axiom,
    ! [B: $tType,A: $tType,A4: set(A),R3: set(product_prod(B,B)),X: A,Y: A] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),R3),bNF_Wellorder_ordLeq(A,B)))
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => ( pp(member(A,X,A4))
         => ( pp(member(A,Y,A4))
           => ( ( aa(A,B,bNF_Greatest_toCard(A,B,A4,R3),X) = aa(A,B,bNF_Greatest_toCard(A,B,A4,R3),Y) )
            <=> ( X = Y ) ) ) ) ) ) ).

% toCard_inj
tff(fact_3858_comp__single__set__bd,axiom,
    ! [B: $tType,D: $tType,A: $tType,E: $tType,C: $tType,Fbd: set(product_prod(A,A)),Fset: fun(B,set(C)),Gset: fun(D,set(B)),Gbd: set(product_prod(E,E)),X: D] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,Fbd),Fbd)
     => ( ! [X2: B] : pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),Fset,X2))),Fbd),bNF_Wellorder_ordLeq(C,A)))
       => ( ! [X2: D] : pp(member(product_prod(set(product_prod(B,B)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(B,B)),set(product_prod(E,E))),aa(set(product_prod(B,B)),fun(set(product_prod(E,E)),product_prod(set(product_prod(B,B)),set(product_prod(E,E)))),product_Pair(set(product_prod(B,B)),set(product_prod(E,E))),bNF_Ca6860139660246222851ard_of(B,aa(D,set(B),Gset,X2))),Gbd),bNF_Wellorder_ordLeq(B,E)))
         => pp(member(product_prod(set(product_prod(C,C)),set(product_prod(product_prod(E,A),product_prod(E,A)))),aa(set(product_prod(product_prod(E,A),product_prod(E,A))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(E,A),product_prod(E,A)))),aa(set(product_prod(C,C)),fun(set(product_prod(product_prod(E,A),product_prod(E,A))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(E,A),product_prod(E,A))))),product_Pair(set(product_prod(C,C)),set(product_prod(product_prod(E,A),product_prod(E,A)))),bNF_Ca6860139660246222851ard_of(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),Fset),aa(D,set(B),Gset,X))))),bNF_Cardinal_cprod(E,A,Gbd,Fbd)),bNF_Wellorder_ordLeq(C,product_prod(E,A)))) ) ) ) ).

% comp_single_set_bd
tff(fact_3859_cinfinite__mono,axiom,
    ! [A: $tType,B: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R1),R22),bNF_Wellorder_ordLeq(A,B)))
     => ( bNF_Ca4139267488887388095finite(A,R1)
       => bNF_Ca4139267488887388095finite(B,R22) ) ) ).

% cinfinite_mono
tff(fact_3860_cprod__infinite,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ( bNF_Ca4139267488887388095finite(A,R3)
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => pp(member(product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,A),product_prod(A,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,A),product_prod(A,A))),set(product_prod(A,A))),bNF_Cardinal_cprod(A,A,R3,R3)),R3),bNF_Wellorder_ordIso(product_prod(A,A),A))) ) ).

% cprod_infinite
tff(fact_3861_cprod__com,axiom,
    ! [B: $tType,A: $tType,P1: set(product_prod(A,A)),P22: set(product_prod(B,B))] : pp(member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Cardinal_cprod(A,B,P1,P22)),bNF_Cardinal_cprod(B,A,P22,P1)),bNF_Wellorder_ordIso(product_prod(A,B),product_prod(B,A)))) ).

% cprod_com
tff(fact_3862_Cinfinite__limit,axiom,
    ! [A: $tType,X: A,R3: set(product_prod(A,A))] :
      ( pp(member(A,X,field2(A,R3)))
     => ( ( bNF_Ca4139267488887388095finite(A,R3)
          & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
       => ? [X2: A] :
            ( pp(member(A,X2,field2(A,R3)))
            & ( X != X2 )
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),X2),R3)) ) ) ) ).

% Cinfinite_limit
tff(fact_3863_Cinfinite__limit2,axiom,
    ! [A: $tType,X1: A,R3: set(product_prod(A,A)),X22: A] :
      ( pp(member(A,X1,field2(A,R3)))
     => ( pp(member(A,X22,field2(A,R3)))
       => ( ( bNF_Ca4139267488887388095finite(A,R3)
            & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
         => ? [X2: A] :
              ( pp(member(A,X2,field2(A,R3)))
              & ( X1 != X2 )
              & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X1),X2),R3))
              & ( X22 != X2 )
              & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X22),X2),R3)) ) ) ) ) ).

% Cinfinite_limit2
tff(fact_3864_cprod__cinfinite__bound,axiom,
    ! [B: $tType,C: $tType,A: $tType,P3: set(product_prod(A,A)),R3: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P3),R3),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),Q3),R3),bNF_Wellorder_ordLeq(C,B)))
       => ( bNF_Ca8970107618336181345der_on(A,field2(A,P3),P3)
         => ( bNF_Ca8970107618336181345der_on(C,field2(C,Q3),Q3)
           => ( ( bNF_Ca4139267488887388095finite(B,R3)
                & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
             => pp(member(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(B,B))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(B,B))),bNF_Cardinal_cprod(A,C,P3,Q3)),R3),bNF_Wellorder_ordLeq(product_prod(A,C),B))) ) ) ) ) ) ).

% cprod_cinfinite_bound
tff(fact_3865_cprod__dup,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set(product_prod(A,A)),P3: set(product_prod(B,B)),P8: set(product_prod(C,C))] :
      ( bNF_Ca4139267488887388095finite(A,R3)
     => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
       => ( pp(member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(A,A),product_prod(A,A)))),aa(set(product_prod(product_prod(A,A),product_prod(A,A))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(A,A),product_prod(A,A)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(product_prod(A,A),product_prod(A,A))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(A,A),product_prod(A,A))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(A,A),product_prod(A,A)))),bNF_Cardinal_cprod(B,C,P3,P8)),bNF_Cardinal_cprod(A,A,R3,R3)),bNF_Wellorder_ordIso(product_prod(B,C),product_prod(A,A))))
         => pp(member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(A,A))),bNF_Cardinal_cprod(B,C,P3,P8)),R3),bNF_Wellorder_ordIso(product_prod(B,C),A))) ) ) ) ).

% cprod_dup
tff(fact_3866_Cinfinite__cong,axiom,
    ! [A: $tType,B: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R1),R22),bNF_Wellorder_ordIso(A,B)))
     => ( ( bNF_Ca4139267488887388095finite(A,R1)
          & bNF_Ca8970107618336181345der_on(A,field2(A,R1),R1) )
       => ( bNF_Ca4139267488887388095finite(B,R22)
          & bNF_Ca8970107618336181345der_on(B,field2(B,R22),R22) ) ) ) ).

% Cinfinite_cong
tff(fact_3867_Cinfinite__limit__finite,axiom,
    ! [A: $tType,X6: set(A),R3: set(product_prod(A,A))] :
      ( pp(aa(set(A),bool,finite_finite(A),X6))
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),X6),field2(A,R3)))
       => ( ( bNF_Ca4139267488887388095finite(A,R3)
            & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
         => ? [X2: A] :
              ( pp(member(A,X2,field2(A,R3)))
              & ! [Xa3: A] :
                  ( pp(member(A,Xa3,X6))
                 => ( ( Xa3 != X2 )
                    & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa3),X2),R3)) ) ) ) ) ) ) ).

% Cinfinite_limit_finite
tff(fact_3868_cprod__mono,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),P22: set(product_prod(C,C)),R22: set(product_prod(D,D))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),P22),R22),bNF_Wellorder_ordLeq(C,D)))
       => pp(member(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),fun(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,D),product_prod(B,D))))),product_Pair(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),bNF_Cardinal_cprod(A,C,P1,P22)),bNF_Cardinal_cprod(B,D,R1,R22)),bNF_Wellorder_ordLeq(product_prod(A,C),product_prod(B,D)))) ) ) ).

% cprod_mono
tff(fact_3869_cprod__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Cardinal_cprod(A,C,P1,Q3)),bNF_Cardinal_cprod(B,C,R1,Q3)),bNF_Wellorder_ordLeq(product_prod(A,C),product_prod(B,C)))) ) ).

% cprod_mono1
tff(fact_3870_cprod__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,P22: set(product_prod(A,A)),R22: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P22),R22),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,A),product_prod(C,A))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Cardinal_cprod(C,A,Q3,P22)),bNF_Cardinal_cprod(C,B,Q3,R22)),bNF_Wellorder_ordLeq(product_prod(C,A),product_prod(C,B)))) ) ).

% cprod_mono2
tff(fact_3871_cprod__cong,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),P22: set(product_prod(C,C)),R22: set(product_prod(D,D))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordIso(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),P22),R22),bNF_Wellorder_ordIso(C,D)))
       => pp(member(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),fun(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,D),product_prod(B,D))))),product_Pair(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),bNF_Cardinal_cprod(A,C,P1,P22)),bNF_Cardinal_cprod(B,D,R1,R22)),bNF_Wellorder_ordIso(product_prod(A,C),product_prod(B,D)))) ) ) ).

% cprod_cong
tff(fact_3872_cprod__cong1,axiom,
    ! [B: $tType,C: $tType,A: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),P22: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(product_prod(A,C),product_prod(A,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Cardinal_cprod(A,C,P1,P22)),bNF_Cardinal_cprod(B,C,R1,P22)),bNF_Wellorder_ordIso(product_prod(A,C),product_prod(B,C)))) ) ).

% cprod_cong1
tff(fact_3873_cprod__cong2,axiom,
    ! [B: $tType,A: $tType,C: $tType,P22: set(product_prod(A,A)),R22: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P22),R22),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,A),product_prod(C,A))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(C,A),product_prod(C,A))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Cardinal_cprod(C,A,Q3,P22)),bNF_Cardinal_cprod(C,B,Q3,R22)),bNF_Wellorder_ordIso(product_prod(C,A),product_prod(C,B)))) ) ).

% cprod_cong2
tff(fact_3874_Un__Cinfinite__bound,axiom,
    ! [B: $tType,A: $tType,A4: set(A),R3: set(product_prod(B,B)),B3: set(A)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),R3),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,B3)),R3),bNF_Wellorder_ordLeq(A,B)))
       => ( ( bNF_Ca4139267488887388095finite(B,R3)
            & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
         => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3))),R3),bNF_Wellorder_ordLeq(A,B))) ) ) ) ).

% Un_Cinfinite_bound
tff(fact_3875_UNION__Cinfinite__bound,axiom,
    ! [A: $tType,B: $tType,C: $tType,I4: set(A),R3: set(product_prod(B,B)),A4: fun(A,set(C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,I4)),R3),bNF_Wellorder_ordLeq(A,B)))
     => ( ! [X2: A] :
            ( pp(member(A,X2,I4))
           => pp(member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,aa(A,set(C),A4,X2))),R3),bNF_Wellorder_ordLeq(C,B))) )
       => ( ( bNF_Ca4139267488887388095finite(B,R3)
            & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
         => pp(member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image2(A,set(C),A4),I4)))),R3),bNF_Wellorder_ordLeq(C,B))) ) ) ) ).

% UNION_Cinfinite_bound
tff(fact_3876_fromCard__toCard,axiom,
    ! [B: $tType,A: $tType,A4: set(A),R3: set(product_prod(B,B)),B2: A] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),R3),bNF_Wellorder_ordLeq(A,B)))
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => ( pp(member(A,B2,A4))
         => ( bNF_Gr5436034075474128252omCard(A,B,A4,R3,aa(A,B,bNF_Greatest_toCard(A,B,A4,R3),B2)) = B2 ) ) ) ) ).

% fromCard_toCard
tff(fact_3877_card__of__Csum__Times_H,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set(product_prod(A,A)),I4: set(B),A4: fun(B,set(C))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( ! [X2: B] :
            ( pp(member(B,X2,I4))
           => pp(member(product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A))),aa(set(product_prod(C,C)),fun(set(product_prod(A,A)),product_prod(set(product_prod(C,C)),set(product_prod(A,A)))),product_Pair(set(product_prod(C,C)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A4,X2))),R3),bNF_Wellorder_ordLeq(C,A))) )
       => pp(member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,A),product_prod(B,A)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(product_prod(B,A),product_prod(B,A))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,A),product_prod(B,A))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,A),product_prod(B,A)))),bNF_Cardinal_Csum(B,C,bNF_Ca6860139660246222851ard_of(B,I4),aTP_Lamp_nu(fun(B,set(C)),fun(B,set(product_prod(C,C))),A4))),bNF_Cardinal_cprod(B,A,bNF_Ca6860139660246222851ard_of(B,I4),R3)),bNF_Wellorder_ordLeq(product_prod(B,C),product_prod(B,A)))) ) ) ).

% card_of_Csum_Times'
tff(fact_3878_card__of__Csum__Times,axiom,
    ! [C: $tType,B: $tType,A: $tType,I4: set(A),A4: fun(A,set(B)),B3: set(C)] :
      ( ! [X2: A] :
          ( pp(member(A,X2,I4))
         => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(A,set(B),A4,X2))),bNF_Ca6860139660246222851ard_of(C,B3)),bNF_Wellorder_ordLeq(B,C))) )
     => pp(member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),aa(set(product_prod(product_prod(A,C),product_prod(A,C))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(product_prod(A,C),product_prod(A,C))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C))))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(product_prod(A,C),product_prod(A,C)))),bNF_Cardinal_Csum(A,B,bNF_Ca6860139660246222851ard_of(A,I4),aTP_Lamp_nv(fun(A,set(B)),fun(A,set(product_prod(B,B))),A4))),bNF_Cardinal_cprod(A,C,bNF_Ca6860139660246222851ard_of(A,I4),bNF_Ca6860139660246222851ard_of(C,B3))),bNF_Wellorder_ordLeq(product_prod(A,B),product_prod(A,C)))) ) ).

% card_of_Csum_Times
tff(fact_3879_Cfinite__cprod__Cinfinite,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),S: set(product_prod(B,B))] :
      ( ( bNF_Cardinal_cfinite(A,R3)
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => ( ( bNF_Ca4139267488887388095finite(B,S)
          & bNF_Ca8970107618336181345der_on(B,field2(B,S),S) )
       => pp(member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(B,B))),bNF_Cardinal_cprod(A,B,R3,S)),S),bNF_Wellorder_ordLeq(product_prod(A,B),B))) ) ) ).

% Cfinite_cprod_Cinfinite
tff(fact_3880_Cfinite__ordLess__Cinfinite,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),S: set(product_prod(B,B))] :
      ( ( bNF_Cardinal_cfinite(A,R3)
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => ( ( bNF_Ca4139267488887388095finite(B,S)
          & bNF_Ca8970107618336181345der_on(B,field2(B,S),S) )
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),S),bNF_We4044943003108391690rdLess(A,B))) ) ) ).

% Cfinite_ordLess_Cinfinite
tff(fact_3881_cprod__infinite1_H,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),P3: set(product_prod(B,B))] :
      ( ( bNF_Ca4139267488887388095finite(A,R3)
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => ( ( ~ pp(member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),P3),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B)))
          & bNF_Ca8970107618336181345der_on(B,field2(B,P3),P3) )
       => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),P3),R3),bNF_Wellorder_ordLeq(B,A)))
         => pp(member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(A,A))),bNF_Cardinal_cprod(A,B,R3,P3)),R3),bNF_Wellorder_ordIso(product_prod(A,B),A))) ) ) ) ).

% cprod_infinite1'
tff(fact_3882_ordLeq__cprod2,axiom,
    ! [A: $tType,B: $tType,P1: set(product_prod(A,A)),P22: set(product_prod(B,B))] :
      ( ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),P1),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
        & bNF_Ca8970107618336181345der_on(A,field2(A,P1),P1) )
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,P22),P22)
       => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(A,B),product_prod(A,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(A,B),product_prod(A,B)))),P22),bNF_Cardinal_cprod(A,B,P1,P22)),bNF_Wellorder_ordLeq(B,product_prod(A,B)))) ) ) ).

% ordLeq_cprod2
tff(fact_3883_cone__def,axiom,
    bNF_Cardinal_cone = bNF_Ca6860139660246222851ard_of(product_unit,aa(set(product_unit),set(product_unit),insert2(product_unit,product_Unity),bot_bot(set(product_unit)))) ).

% cone_def
tff(fact_3884_cinfinite__cprod2,axiom,
    ! [A: $tType,B: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B))] :
      ( ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R1),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
        & bNF_Ca8970107618336181345der_on(A,field2(A,R1),R1) )
     => ( ( bNF_Ca4139267488887388095finite(B,R22)
          & bNF_Ca8970107618336181345der_on(B,field2(B,R22),R22) )
       => bNF_Ca4139267488887388095finite(product_prod(A,B),bNF_Cardinal_cprod(A,B,R1,R22)) ) ) ).

% cinfinite_cprod2
tff(fact_3885_cone__not__czero,axiom,
    ! [A: $tType] : ~ pp(member(product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(A,A))),aa(set(product_prod(product_unit,product_unit)),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(A,A)))),product_Pair(set(product_prod(product_unit,product_unit)),set(product_prod(A,A))),bNF_Cardinal_cone),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(product_unit,A))) ).

% cone_not_czero
tff(fact_3886_czero__def,axiom,
    ! [A: $tType] : ( bNF_Cardinal_czero(A) = bNF_Ca6860139660246222851ard_of(A,bot_bot(set(A))) ) ).

% czero_def
tff(fact_3887_czero__ordIso,axiom,
    ! [B: $tType,A: $tType] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Cardinal_czero(A)),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(A,B))) ).

% czero_ordIso
tff(fact_3888_cone__ordLeq__Cnotzero,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => pp(member(product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(A,A))),aa(set(product_prod(product_unit,product_unit)),fun(set(product_prod(A,A)),product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(A,A)))),product_Pair(set(product_prod(product_unit,product_unit)),set(product_prod(A,A))),bNF_Cardinal_cone),R3),bNF_Wellorder_ordLeq(product_unit,A))) ) ).

% cone_ordLeq_Cnotzero
tff(fact_3889_cinfinite__not__czero,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca4139267488887388095finite(B,R3)
     => ~ pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R3),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(B,A))) ) ).

% cinfinite_not_czero
tff(fact_3890_czeroE,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(A,B)))
     => ( field2(A,R3) = bot_bot(set(A)) ) ) ).

% czeroE
tff(fact_3891_card__of__ordIso__czero__iff__empty,axiom,
    ! [B: $tType,A: $tType,A4: set(A)] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(A,B)))
    <=> ( A4 = bot_bot(set(A)) ) ) ).

% card_of_ordIso_czero_iff_empty
tff(fact_3892_czeroI,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( ( field2(A,R3) = bot_bot(set(A)) )
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(A,B))) ) ) ).

% czeroI
tff(fact_3893_Cnotzero__imp__not__empty,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => ( field2(A,R3) != bot_bot(set(A)) ) ) ).

% Cnotzero_imp_not_empty
tff(fact_3894_Cnotzero__mono,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),Q3: set(product_prod(B,B))] :
      ( ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,Q3),Q3)
       => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),Q3),bNF_Wellorder_ordLeq(A,B)))
         => ( ~ pp(member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),Q3),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B)))
            & bNF_Ca8970107618336181345der_on(B,field2(B,Q3),Q3) ) ) ) ) ).

% Cnotzero_mono
tff(fact_3895_Cinfinite__Cnotzero,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ( bNF_Ca4139267488887388095finite(A,R3)
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) ) ) ).

% Cinfinite_Cnotzero
tff(fact_3896_Cnotzero__UNIV,axiom,
    ! [A: $tType] :
      ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),bNF_Ca6860139660246222851ard_of(A,top_top(set(A)))),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
      & bNF_Ca8970107618336181345der_on(A,field2(A,bNF_Ca6860139660246222851ard_of(A,top_top(set(A)))),bNF_Ca6860139660246222851ard_of(A,top_top(set(A)))) ) ).

% Cnotzero_UNIV
tff(fact_3897_Cinfinite__cprod2,axiom,
    ! [A: $tType,B: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B))] :
      ( ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R1),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
        & bNF_Ca8970107618336181345der_on(A,field2(A,R1),R1) )
     => ( ( bNF_Ca4139267488887388095finite(B,R22)
          & bNF_Ca8970107618336181345der_on(B,field2(B,R22),R22) )
       => ( bNF_Ca4139267488887388095finite(product_prod(A,B),bNF_Cardinal_cprod(A,B,R1,R22))
          & bNF_Ca8970107618336181345der_on(product_prod(A,B),field2(product_prod(A,B),bNF_Cardinal_cprod(A,B,R1,R22)),bNF_Cardinal_cprod(A,B,R1,R22)) ) ) ) ).

% Cinfinite_cprod2
tff(fact_3898_cexp__mono,axiom,
    ! [E: $tType,F8: $tType,B: $tType,D: $tType,A: $tType,C: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),P22: set(product_prod(C,C)),R22: set(product_prod(D,D))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),P22),R22),bNF_Wellorder_ordLeq(C,D)))
       => ( ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(C,C)),set(product_prod(E,E))),aa(set(product_prod(C,C)),fun(set(product_prod(E,E)),product_prod(set(product_prod(C,C)),set(product_prod(E,E)))),product_Pair(set(product_prod(C,C)),set(product_prod(E,E))),P22),bNF_Cardinal_czero(E)),bNF_Wellorder_ordIso(C,E)))
           => pp(member(product_prod(set(product_prod(D,D)),set(product_prod(F8,F8))),aa(set(product_prod(F8,F8)),product_prod(set(product_prod(D,D)),set(product_prod(F8,F8))),aa(set(product_prod(D,D)),fun(set(product_prod(F8,F8)),product_prod(set(product_prod(D,D)),set(product_prod(F8,F8)))),product_Pair(set(product_prod(D,D)),set(product_prod(F8,F8))),R22),bNF_Cardinal_czero(F8)),bNF_Wellorder_ordIso(D,F8))) )
         => ( bNF_Ca8970107618336181345der_on(C,field2(C,P22),P22)
           => pp(member(product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),aa(set(product_prod(fun(D,B),fun(D,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),aa(set(product_prod(fun(C,A),fun(C,A))),fun(set(product_prod(fun(D,B),fun(D,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B))))),product_Pair(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),bNF_Cardinal_cexp(A,C,P1,P22)),bNF_Cardinal_cexp(B,D,R1,R22)),bNF_Wellorder_ordLeq(fun(C,A),fun(D,B)))) ) ) ) ) ).

% cexp_mono
tff(fact_3899_cexp__mono2,axiom,
    ! [D: $tType,E: $tType,B: $tType,C: $tType,A: $tType,P22: set(product_prod(A,A)),R22: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P22),R22),bNF_Wellorder_ordLeq(A,B)))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,Q3),Q3)
       => ( ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(A,A)),set(product_prod(D,D))),aa(set(product_prod(A,A)),fun(set(product_prod(D,D)),product_prod(set(product_prod(A,A)),set(product_prod(D,D)))),product_Pair(set(product_prod(A,A)),set(product_prod(D,D))),P22),bNF_Cardinal_czero(D)),bNF_Wellorder_ordIso(A,D)))
           => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(B,B)),set(product_prod(E,E))),aa(set(product_prod(B,B)),fun(set(product_prod(E,E)),product_prod(set(product_prod(B,B)),set(product_prod(E,E)))),product_Pair(set(product_prod(B,B)),set(product_prod(E,E))),R22),bNF_Cardinal_czero(E)),bNF_Wellorder_ordIso(B,E))) )
         => ( bNF_Ca8970107618336181345der_on(A,field2(A,P22),P22)
           => pp(member(product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(A,C),fun(A,C))),fun(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C))))),product_Pair(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),bNF_Cardinal_cexp(C,A,Q3,P22)),bNF_Cardinal_cexp(C,B,Q3,R22)),bNF_Wellorder_ordLeq(fun(A,C),fun(B,C)))) ) ) ) ) ).

% cexp_mono2
tff(fact_3900_cexp__mono2__Cnotzero,axiom,
    ! [B: $tType,C: $tType,A: $tType,P22: set(product_prod(A,A)),R22: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P22),R22),bNF_Wellorder_ordLeq(A,B)))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,Q3),Q3)
       => ( ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),P22),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
            & bNF_Ca8970107618336181345der_on(A,field2(A,P22),P22) )
         => pp(member(product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(A,C),fun(A,C))),fun(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C))))),product_Pair(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),bNF_Cardinal_cexp(C,A,Q3,P22)),bNF_Cardinal_cexp(C,B,Q3,R22)),bNF_Wellorder_ordLeq(fun(A,C),fun(B,C)))) ) ) ) ).

% cexp_mono2_Cnotzero
tff(fact_3901_csum__dup,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set(product_prod(A,A)),P3: set(product_prod(B,B)),P8: set(product_prod(C,C))] :
      ( bNF_Ca4139267488887388095finite(A,R3)
     => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
       => ( pp(member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(A,A),sum_sum(A,A)))),aa(set(product_prod(sum_sum(A,A),sum_sum(A,A))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(A,A),sum_sum(A,A)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(sum_sum(A,A),sum_sum(A,A))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(A,A),sum_sum(A,A))))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(A,A),sum_sum(A,A)))),bNF_Cardinal_csum(B,C,P3,P8)),bNF_Cardinal_csum(A,A,R3,R3)),bNF_Wellorder_ordIso(sum_sum(B,C),sum_sum(A,A))))
         => pp(member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(A,A))),bNF_Cardinal_csum(B,C,P3,P8)),R3),bNF_Wellorder_ordIso(sum_sum(B,C),A))) ) ) ) ).

% csum_dup
tff(fact_3902_cprod__csum__distrib1,axiom,
    ! [C: $tType,B: $tType,A: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B)),R33: set(product_prod(C,C))] : pp(member(product_prod(set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))),set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C))))),aa(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),product_prod(set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))),set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C))))),aa(set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))),fun(set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))),product_prod(set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))),set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C)))))),product_Pair(set(product_prod(sum_sum(product_prod(A,B),product_prod(A,C)),sum_sum(product_prod(A,B),product_prod(A,C)))),set(product_prod(product_prod(A,sum_sum(B,C)),product_prod(A,sum_sum(B,C))))),bNF_Cardinal_csum(product_prod(A,B),product_prod(A,C),bNF_Cardinal_cprod(A,B,R1,R22),bNF_Cardinal_cprod(A,C,R1,R33))),bNF_Cardinal_cprod(A,sum_sum(B,C),R1,bNF_Cardinal_csum(B,C,R22,R33))),bNF_Wellorder_ordIso(sum_sum(product_prod(A,B),product_prod(A,C)),product_prod(A,sum_sum(B,C))))) ).

% cprod_csum_distrib1
tff(fact_3903_csum__assoc,axiom,
    ! [C: $tType,B: $tType,A: $tType,P1: set(product_prod(A,A)),P22: set(product_prod(B,B)),P32: set(product_prod(C,C))] : pp(member(product_prod(set(product_prod(sum_sum(sum_sum(A,B),C),sum_sum(sum_sum(A,B),C))),set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C))))),aa(set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C)))),product_prod(set(product_prod(sum_sum(sum_sum(A,B),C),sum_sum(sum_sum(A,B),C))),set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C))))),aa(set(product_prod(sum_sum(sum_sum(A,B),C),sum_sum(sum_sum(A,B),C))),fun(set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C)))),product_prod(set(product_prod(sum_sum(sum_sum(A,B),C),sum_sum(sum_sum(A,B),C))),set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C)))))),product_Pair(set(product_prod(sum_sum(sum_sum(A,B),C),sum_sum(sum_sum(A,B),C))),set(product_prod(sum_sum(A,sum_sum(B,C)),sum_sum(A,sum_sum(B,C))))),bNF_Cardinal_csum(sum_sum(A,B),C,bNF_Cardinal_csum(A,B,P1,P22),P32)),bNF_Cardinal_csum(A,sum_sum(B,C),P1,bNF_Cardinal_csum(B,C,P22,P32))),bNF_Wellorder_ordIso(sum_sum(sum_sum(A,B),C),sum_sum(A,sum_sum(B,C))))) ).

% csum_assoc
tff(fact_3904_csum__csum,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B)),R33: set(product_prod(C,C)),R42: set(product_prod(D,D))] : pp(member(product_prod(set(product_prod(sum_sum(sum_sum(A,B),sum_sum(C,D)),sum_sum(sum_sum(A,B),sum_sum(C,D)))),set(product_prod(sum_sum(sum_sum(A,C),sum_sum(B,D)),sum_sum(sum_sum(A,C),sum_sum(B,D))))),aa(set(product_prod(sum_sum(sum_sum(A,C),sum_sum(B,D)),sum_sum(sum_sum(A,C),sum_sum(B,D)))),product_prod(set(product_prod(sum_sum(sum_sum(A,B),sum_sum(C,D)),sum_sum(sum_sum(A,B),sum_sum(C,D)))),set(product_prod(sum_sum(sum_sum(A,C),sum_sum(B,D)),sum_sum(sum_sum(A,C),sum_sum(B,D))))),aa(set(product_prod(sum_sum(sum_sum(A,B),sum_sum(C,D)),sum_sum(sum_sum(A,B),sum_sum(C,D)))),fun(set(product_prod(sum_sum(sum_sum(A,C),sum_sum(B,D)),sum_sum(sum_sum(A,C),sum_sum(B,D)))),product_prod(set(product_prod(sum_sum(sum_sum(A,B),sum_sum(C,D)),sum_sum(sum_sum(A,B),sum_sum(C,D)))),set(product_prod(sum_sum(sum_sum(A,C),sum_sum(B,D)),sum_sum(sum_sum(A,C),sum_sum(B,D)))))),product_Pair(set(product_prod(sum_sum(sum_sum(A,B),sum_sum(C,D)),sum_sum(sum_sum(A,B),sum_sum(C,D)))),set(product_prod(sum_sum(sum_sum(A,C),sum_sum(B,D)),sum_sum(sum_sum(A,C),sum_sum(B,D))))),bNF_Cardinal_csum(sum_sum(A,B),sum_sum(C,D),bNF_Cardinal_csum(A,B,R1,R22),bNF_Cardinal_csum(C,D,R33,R42))),bNF_Cardinal_csum(sum_sum(A,C),sum_sum(B,D),bNF_Cardinal_csum(A,C,R1,R33),bNF_Cardinal_csum(B,D,R22,R42))),bNF_Wellorder_ordIso(sum_sum(sum_sum(A,B),sum_sum(C,D)),sum_sum(sum_sum(A,C),sum_sum(B,D))))) ).

% csum_csum
tff(fact_3905_cexp__cprod,axiom,
    ! [A: $tType,C: $tType,B: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(C,C)),R33: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R1),R1)
     => pp(member(product_prod(set(product_prod(fun(B,fun(C,A)),fun(B,fun(C,A)))),set(product_prod(fun(product_prod(C,B),A),fun(product_prod(C,B),A)))),aa(set(product_prod(fun(product_prod(C,B),A),fun(product_prod(C,B),A))),product_prod(set(product_prod(fun(B,fun(C,A)),fun(B,fun(C,A)))),set(product_prod(fun(product_prod(C,B),A),fun(product_prod(C,B),A)))),aa(set(product_prod(fun(B,fun(C,A)),fun(B,fun(C,A)))),fun(set(product_prod(fun(product_prod(C,B),A),fun(product_prod(C,B),A))),product_prod(set(product_prod(fun(B,fun(C,A)),fun(B,fun(C,A)))),set(product_prod(fun(product_prod(C,B),A),fun(product_prod(C,B),A))))),product_Pair(set(product_prod(fun(B,fun(C,A)),fun(B,fun(C,A)))),set(product_prod(fun(product_prod(C,B),A),fun(product_prod(C,B),A)))),bNF_Cardinal_cexp(fun(C,A),B,bNF_Cardinal_cexp(A,C,R1,R22),R33)),bNF_Cardinal_cexp(A,product_prod(C,B),R1,bNF_Cardinal_cprod(C,B,R22,R33))),bNF_Wellorder_ordIso(fun(B,fun(C,A)),fun(product_prod(C,B),A)))) ) ).

% cexp_cprod
tff(fact_3906_cprod__cexp__csum__cexp__Cinfinite,axiom,
    ! [C: $tType,B: $tType,A: $tType,T4: set(product_prod(A,A)),R3: set(product_prod(B,B)),S: set(product_prod(C,C))] :
      ( ( bNF_Ca4139267488887388095finite(A,T4)
        & bNF_Ca8970107618336181345der_on(A,field2(A,T4),T4) )
     => pp(member(product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(fun(A,sum_sum(B,C)),fun(A,sum_sum(B,C))))),aa(set(product_prod(fun(A,sum_sum(B,C)),fun(A,sum_sum(B,C)))),product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(fun(A,sum_sum(B,C)),fun(A,sum_sum(B,C))))),aa(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),fun(set(product_prod(fun(A,sum_sum(B,C)),fun(A,sum_sum(B,C)))),product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(fun(A,sum_sum(B,C)),fun(A,sum_sum(B,C)))))),product_Pair(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(fun(A,sum_sum(B,C)),fun(A,sum_sum(B,C))))),bNF_Cardinal_cexp(product_prod(B,C),A,bNF_Cardinal_cprod(B,C,R3,S),T4)),bNF_Cardinal_cexp(sum_sum(B,C),A,bNF_Cardinal_csum(B,C,R3,S),T4)),bNF_Wellorder_ordLeq(fun(A,product_prod(B,C)),fun(A,sum_sum(B,C))))) ) ).

% cprod_cexp_csum_cexp_Cinfinite
tff(fact_3907_csum__com,axiom,
    ! [B: $tType,A: $tType,P1: set(product_prod(A,A)),P22: set(product_prod(B,B))] : pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(B,A),sum_sum(B,A))))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),bNF_Cardinal_csum(A,B,P1,P22)),bNF_Cardinal_csum(B,A,P22,P1)),bNF_Wellorder_ordIso(sum_sum(A,B),sum_sum(B,A)))) ).

% csum_com
tff(fact_3908_cprod__cexp,axiom,
    ! [C: $tType,B: $tType,A: $tType,R3: set(product_prod(B,B)),S: set(product_prod(C,C)),T4: set(product_prod(A,A))] : pp(member(product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C))))),aa(set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C)))),product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C))))),aa(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),fun(set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C)))),product_prod(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C)))))),product_Pair(set(product_prod(fun(A,product_prod(B,C)),fun(A,product_prod(B,C)))),set(product_prod(product_prod(fun(A,B),fun(A,C)),product_prod(fun(A,B),fun(A,C))))),bNF_Cardinal_cexp(product_prod(B,C),A,bNF_Cardinal_cprod(B,C,R3,S),T4)),bNF_Cardinal_cprod(fun(A,B),fun(A,C),bNF_Cardinal_cexp(B,A,R3,T4),bNF_Cardinal_cexp(C,A,S,T4))),bNF_Wellorder_ordIso(fun(A,product_prod(B,C)),product_prod(fun(A,B),fun(A,C))))) ).

% cprod_cexp
tff(fact_3909_cexp__cone,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(fun(product_unit,A),fun(product_unit,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(fun(product_unit,A),fun(product_unit,A))),set(product_prod(A,A))),aa(set(product_prod(fun(product_unit,A),fun(product_unit,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(fun(product_unit,A),fun(product_unit,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(fun(product_unit,A),fun(product_unit,A))),set(product_prod(A,A))),bNF_Cardinal_cexp(A,product_unit,R3,bNF_Cardinal_cone)),R3),bNF_Wellorder_ordIso(fun(product_unit,A),A))) ) ).

% cexp_cone
tff(fact_3910_cexp__cprod__ordLeq,axiom,
    ! [A: $tType,B: $tType,C: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B)),R33: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R1),R1)
     => ( ( bNF_Ca4139267488887388095finite(B,R22)
          & bNF_Ca8970107618336181345der_on(B,field2(B,R22),R22) )
       => ( ( ~ pp(member(product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),fun(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),product_Pair(set(product_prod(C,C)),set(product_prod(C,C))),R33),bNF_Cardinal_czero(C)),bNF_Wellorder_ordIso(C,C)))
            & bNF_Ca8970107618336181345der_on(C,field2(C,R33),R33) )
         => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R33),R22),bNF_Wellorder_ordLeq(C,B)))
           => pp(member(product_prod(set(product_prod(fun(C,fun(B,A)),fun(C,fun(B,A)))),set(product_prod(fun(B,A),fun(B,A)))),aa(set(product_prod(fun(B,A),fun(B,A))),product_prod(set(product_prod(fun(C,fun(B,A)),fun(C,fun(B,A)))),set(product_prod(fun(B,A),fun(B,A)))),aa(set(product_prod(fun(C,fun(B,A)),fun(C,fun(B,A)))),fun(set(product_prod(fun(B,A),fun(B,A))),product_prod(set(product_prod(fun(C,fun(B,A)),fun(C,fun(B,A)))),set(product_prod(fun(B,A),fun(B,A))))),product_Pair(set(product_prod(fun(C,fun(B,A)),fun(C,fun(B,A)))),set(product_prod(fun(B,A),fun(B,A)))),bNF_Cardinal_cexp(fun(B,A),C,bNF_Cardinal_cexp(A,B,R1,R22),R33)),bNF_Cardinal_cexp(A,B,R1,R22)),bNF_Wellorder_ordIso(fun(C,fun(B,A)),fun(B,A)))) ) ) ) ) ).

% cexp_cprod_ordLeq
tff(fact_3911_Un__csum,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,A),sum_sum(A,A)))),aa(set(product_prod(sum_sum(A,A),sum_sum(A,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,A),sum_sum(A,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(A,A),sum_sum(A,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,A),sum_sum(A,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(A,A),sum_sum(A,A)))),bNF_Ca6860139660246222851ard_of(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3))),bNF_Cardinal_csum(A,A,bNF_Ca6860139660246222851ard_of(A,A4),bNF_Ca6860139660246222851ard_of(A,B3))),bNF_Wellorder_ordLeq(A,sum_sum(A,A)))) ).

% Un_csum
tff(fact_3912_ordLeq__csum2,axiom,
    ! [B: $tType,A: $tType,P22: set(product_prod(A,A)),P1: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,P22),P22)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(B,A),sum_sum(B,A))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(B,A),sum_sum(B,A)))),P22),bNF_Cardinal_csum(B,A,P1,P22)),bNF_Wellorder_ordLeq(A,sum_sum(B,A)))) ) ).

% ordLeq_csum2
tff(fact_3913_ordLeq__csum1,axiom,
    ! [B: $tType,A: $tType,P1: set(product_prod(A,A)),P22: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,P1),P1)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B))))),product_Pair(set(product_prod(A,A)),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),P1),bNF_Cardinal_csum(A,B,P1,P22)),bNF_Wellorder_ordLeq(A,sum_sum(A,B)))) ) ).

% ordLeq_csum1
tff(fact_3914_csum__cong2,axiom,
    ! [B: $tType,A: $tType,C: $tType,P22: set(product_prod(A,A)),R22: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P22),R22),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,A),sum_sum(C,A))),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Cardinal_csum(C,A,Q3,P22)),bNF_Cardinal_csum(C,B,Q3,R22)),bNF_Wellorder_ordIso(sum_sum(C,A),sum_sum(C,B)))) ) ).

% csum_cong2
tff(fact_3915_csum__cong1,axiom,
    ! [B: $tType,C: $tType,A: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordIso(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Cardinal_csum(A,C,P1,Q3)),bNF_Cardinal_csum(B,C,R1,Q3)),bNF_Wellorder_ordIso(sum_sum(A,C),sum_sum(B,C)))) ) ).

% csum_cong1
tff(fact_3916_csum__cong,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),P22: set(product_prod(C,C)),R22: set(product_prod(D,D))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordIso(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),P22),R22),bNF_Wellorder_ordIso(C,D)))
       => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),bNF_Cardinal_csum(A,C,P1,P22)),bNF_Cardinal_csum(B,D,R1,R22)),bNF_Wellorder_ordIso(sum_sum(A,C),sum_sum(B,D)))) ) ) ).

% csum_cong
tff(fact_3917_csum__mono2,axiom,
    ! [B: $tType,A: $tType,C: $tType,P22: set(product_prod(A,A)),R22: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P22),R22),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,A),sum_sum(C,A))),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(sum_sum(C,A),sum_sum(C,A))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Cardinal_csum(C,A,Q3,P22)),bNF_Cardinal_csum(C,B,Q3,R22)),bNF_Wellorder_ordLeq(sum_sum(C,A),sum_sum(C,B)))) ) ).

% csum_mono2
tff(fact_3918_csum__mono1,axiom,
    ! [B: $tType,C: $tType,A: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordLeq(A,B)))
     => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Cardinal_csum(A,C,P1,Q3)),bNF_Cardinal_csum(B,C,R1,Q3)),bNF_Wellorder_ordLeq(sum_sum(A,C),sum_sum(B,C)))) ) ).

% csum_mono1
tff(fact_3919_csum__mono,axiom,
    ! [D: $tType,B: $tType,C: $tType,A: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),P22: set(product_prod(C,C)),R22: set(product_prod(D,D))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),P22),R22),bNF_Wellorder_ordLeq(C,D)))
       => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(sum_sum(B,D),sum_sum(B,D))),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D))))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(sum_sum(B,D),sum_sum(B,D)))),bNF_Cardinal_csum(A,C,P1,P22)),bNF_Cardinal_csum(B,D,R1,R22)),bNF_Wellorder_ordLeq(sum_sum(A,C),sum_sum(B,D)))) ) ) ).

% csum_mono
tff(fact_3920_Plus__csum,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] : pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(A,B),sum_sum(A,B))))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),bNF_Ca6860139660246222851ard_of(sum_sum(A,B),sum_Plus(A,B,A4,B3))),bNF_Cardinal_csum(A,B,bNF_Ca6860139660246222851ard_of(A,A4),bNF_Ca6860139660246222851ard_of(B,B3))),bNF_Wellorder_ordIso(sum_sum(A,B),sum_sum(A,B)))) ).

% Plus_csum
tff(fact_3921_cexp__mono_H,axiom,
    ! [B: $tType,D: $tType,A: $tType,C: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),P22: set(product_prod(C,C)),R22: set(product_prod(D,D))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),P22),R22),bNF_Wellorder_ordLeq(C,D)))
       => ( ( ( field2(C,P22) = bot_bot(set(C)) )
           => ( field2(D,R22) = bot_bot(set(D)) ) )
         => pp(member(product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),aa(set(product_prod(fun(D,B),fun(D,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),aa(set(product_prod(fun(C,A),fun(C,A))),fun(set(product_prod(fun(D,B),fun(D,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B))))),product_Pair(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),bNF_Cardinal_cexp(A,C,P1,P22)),bNF_Cardinal_cexp(B,D,R1,R22)),bNF_Wellorder_ordLeq(fun(C,A),fun(D,B)))) ) ) ) ).

% cexp_mono'
tff(fact_3922_cexp__mono1,axiom,
    ! [B: $tType,A: $tType,C: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordLeq(A,B)))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,Q3),Q3)
       => pp(member(product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(C,B),fun(C,B)))),aa(set(product_prod(fun(C,B),fun(C,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(C,B),fun(C,B)))),aa(set(product_prod(fun(C,A),fun(C,A))),fun(set(product_prod(fun(C,B),fun(C,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(C,B),fun(C,B))))),product_Pair(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(C,B),fun(C,B)))),bNF_Cardinal_cexp(A,C,P1,Q3)),bNF_Cardinal_cexp(B,C,R1,Q3)),bNF_Wellorder_ordLeq(fun(C,A),fun(C,B)))) ) ) ).

% cexp_mono1
tff(fact_3923_cexp__mono2_H,axiom,
    ! [B: $tType,C: $tType,A: $tType,P22: set(product_prod(A,A)),R22: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P22),R22),bNF_Wellorder_ordLeq(A,B)))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,Q3),Q3)
       => ( ( ( field2(A,P22) = bot_bot(set(A)) )
           => ( field2(B,R22) = bot_bot(set(B)) ) )
         => pp(member(product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(A,C),fun(A,C))),fun(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C))))),product_Pair(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),bNF_Cardinal_cexp(C,A,Q3,P22)),bNF_Cardinal_cexp(C,B,Q3,R22)),bNF_Wellorder_ordLeq(fun(A,C),fun(B,C)))) ) ) ) ).

% cexp_mono2'
tff(fact_3924_csum__absorb2_H,axiom,
    ! [A: $tType,B: $tType,R22: set(product_prod(A,A)),R1: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R22),R22)
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R1),R22),bNF_Wellorder_ordLeq(B,A)))
       => ( ( bNF_Ca4139267488887388095finite(B,R1)
            | bNF_Ca4139267488887388095finite(A,R22) )
         => pp(member(product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(B,A),sum_sum(B,A))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(B,A),sum_sum(B,A))),set(product_prod(A,A))),bNF_Cardinal_csum(B,A,R1,R22)),R22),bNF_Wellorder_ordIso(sum_sum(B,A),A))) ) ) ) ).

% csum_absorb2'
tff(fact_3925_csum__absorb1_H,axiom,
    ! [B: $tType,A: $tType,R22: set(product_prod(A,A)),R1: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R22),R22)
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R1),R22),bNF_Wellorder_ordLeq(B,A)))
       => ( ( bNF_Ca4139267488887388095finite(B,R1)
            | bNF_Ca4139267488887388095finite(A,R22) )
         => pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),bNF_Cardinal_csum(A,B,R22,R1)),R22),bNF_Wellorder_ordIso(sum_sum(A,B),A))) ) ) ) ).

% csum_absorb1'
tff(fact_3926_csum__absorb1,axiom,
    ! [B: $tType,A: $tType,R22: set(product_prod(A,A)),R1: set(product_prod(B,B))] :
      ( ( bNF_Ca4139267488887388095finite(A,R22)
        & bNF_Ca8970107618336181345der_on(A,field2(A,R22),R22) )
     => ( pp(member(product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A))),aa(set(product_prod(B,B)),fun(set(product_prod(A,A)),product_prod(set(product_prod(B,B)),set(product_prod(A,A)))),product_Pair(set(product_prod(B,B)),set(product_prod(A,A))),R1),R22),bNF_Wellorder_ordLeq(B,A)))
       => pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(A,A)),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A)))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(A,A))),bNF_Cardinal_csum(A,B,R22,R1)),R22),bNF_Wellorder_ordIso(sum_sum(A,B),A))) ) ) ).

% csum_absorb1
tff(fact_3927_ordLeq__cexp1,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),Q3: set(product_prod(B,B))] :
      ( ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,Q3),Q3)
       => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(fun(A,B),fun(A,B)))),aa(set(product_prod(fun(A,B),fun(A,B))),product_prod(set(product_prod(B,B)),set(product_prod(fun(A,B),fun(A,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(fun(A,B),fun(A,B))),product_prod(set(product_prod(B,B)),set(product_prod(fun(A,B),fun(A,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(fun(A,B),fun(A,B)))),Q3),bNF_Cardinal_cexp(B,A,Q3,R3)),bNF_Wellorder_ordLeq(B,fun(A,B)))) ) ) ).

% ordLeq_cexp1
tff(fact_3928_csum__cinfinite__bound,axiom,
    ! [B: $tType,C: $tType,A: $tType,P3: set(product_prod(A,A)),R3: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P3),R3),bNF_Wellorder_ordLeq(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),Q3),R3),bNF_Wellorder_ordLeq(C,B)))
       => ( bNF_Ca8970107618336181345der_on(A,field2(A,P3),P3)
         => ( bNF_Ca8970107618336181345der_on(C,field2(C,Q3),Q3)
           => ( ( bNF_Ca4139267488887388095finite(B,R3)
                & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
             => pp(member(product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(A,C),sum_sum(A,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(A,C),sum_sum(A,C))),set(product_prod(B,B))),bNF_Cardinal_csum(A,C,P3,Q3)),R3),bNF_Wellorder_ordLeq(sum_sum(A,C),B))) ) ) ) ) ) ).

% csum_cinfinite_bound
tff(fact_3929_csum__Cnotzero1,axiom,
    ! [A: $tType,B: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B))] :
      ( ( ~ pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R1),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(A,A)))
        & bNF_Ca8970107618336181345der_on(A,field2(A,R1),R1) )
     => ( ~ pp(member(product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),aa(set(product_prod(sum_sum(A,B),sum_sum(A,B))),fun(set(product_prod(sum_sum(A,B),sum_sum(A,B))),product_prod(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(A,B),sum_sum(A,B))))),product_Pair(set(product_prod(sum_sum(A,B),sum_sum(A,B))),set(product_prod(sum_sum(A,B),sum_sum(A,B)))),bNF_Cardinal_csum(A,B,R1,R22)),bNF_Cardinal_czero(sum_sum(A,B))),bNF_Wellorder_ordIso(sum_sum(A,B),sum_sum(A,B))))
        & bNF_Ca8970107618336181345der_on(sum_sum(A,B),field2(sum_sum(A,B),bNF_Cardinal_csum(A,B,R1,R22)),bNF_Cardinal_csum(A,B,R1,R22)) ) ) ).

% csum_Cnotzero1
tff(fact_3930_cexp__cong2,axiom,
    ! [B: $tType,C: $tType,A: $tType,P22: set(product_prod(A,A)),R22: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P22),R22),bNF_Wellorder_ordIso(A,B)))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,Q3),Q3)
       => ( bNF_Ca8970107618336181345der_on(A,field2(A,P22),P22)
         => pp(member(product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(A,C),fun(A,C))),fun(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C))))),product_Pair(set(product_prod(fun(A,C),fun(A,C))),set(product_prod(fun(B,C),fun(B,C)))),bNF_Cardinal_cexp(C,A,Q3,P22)),bNF_Cardinal_cexp(C,B,Q3,R22)),bNF_Wellorder_ordIso(fun(A,C),fun(B,C)))) ) ) ) ).

% cexp_cong2
tff(fact_3931_cexp__cong1,axiom,
    ! [B: $tType,A: $tType,C: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),Q3: set(product_prod(C,C))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordIso(A,B)))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,Q3),Q3)
       => pp(member(product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(C,B),fun(C,B)))),aa(set(product_prod(fun(C,B),fun(C,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(C,B),fun(C,B)))),aa(set(product_prod(fun(C,A),fun(C,A))),fun(set(product_prod(fun(C,B),fun(C,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(C,B),fun(C,B))))),product_Pair(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(C,B),fun(C,B)))),bNF_Cardinal_cexp(A,C,P1,Q3)),bNF_Cardinal_cexp(B,C,R1,Q3)),bNF_Wellorder_ordIso(fun(C,A),fun(C,B)))) ) ) ).

% cexp_cong1
tff(fact_3932_cexp__cong,axiom,
    ! [B: $tType,D: $tType,A: $tType,C: $tType,P1: set(product_prod(A,A)),R1: set(product_prod(B,B)),P22: set(product_prod(C,C)),R22: set(product_prod(D,D))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),P1),R1),bNF_Wellorder_ordIso(A,B)))
     => ( pp(member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),P22),R22),bNF_Wellorder_ordIso(C,D)))
       => ( bNF_Ca8970107618336181345der_on(D,field2(D,R22),R22)
         => ( bNF_Ca8970107618336181345der_on(C,field2(C,P22),P22)
           => pp(member(product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),aa(set(product_prod(fun(D,B),fun(D,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),aa(set(product_prod(fun(C,A),fun(C,A))),fun(set(product_prod(fun(D,B),fun(D,B))),product_prod(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B))))),product_Pair(set(product_prod(fun(C,A),fun(C,A))),set(product_prod(fun(D,B),fun(D,B)))),bNF_Cardinal_cexp(A,C,P1,P22)),bNF_Cardinal_cexp(B,D,R1,R22)),bNF_Wellorder_ordIso(fun(C,A),fun(D,B)))) ) ) ) ) ).

% cexp_cong
tff(fact_3933_ordLeq__cexp2,axiom,
    ! [A: $tType,B: $tType,Q3: set(product_prod(A,A)),R3: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(bool,bool)),fun(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A)))),product_Pair(set(product_prod(bool,bool)),set(product_prod(A,A))),bNF_Cardinal_ctwo),Q3),bNF_Wellorder_ordLeq(bool,A)))
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => pp(member(product_prod(set(product_prod(B,B)),set(product_prod(fun(B,A),fun(B,A)))),aa(set(product_prod(fun(B,A),fun(B,A))),product_prod(set(product_prod(B,B)),set(product_prod(fun(B,A),fun(B,A)))),aa(set(product_prod(B,B)),fun(set(product_prod(fun(B,A),fun(B,A))),product_prod(set(product_prod(B,B)),set(product_prod(fun(B,A),fun(B,A))))),product_Pair(set(product_prod(B,B)),set(product_prod(fun(B,A),fun(B,A)))),R3),bNF_Cardinal_cexp(A,B,Q3,R3)),bNF_Wellorder_ordLeq(B,fun(B,A)))) ) ) ).

% ordLeq_cexp2
tff(fact_3934_Cfinite__cexp__Cinfinite,axiom,
    ! [A: $tType,B: $tType,S: set(product_prod(A,A)),T4: set(product_prod(B,B))] :
      ( ( bNF_Cardinal_cfinite(A,S)
        & bNF_Ca8970107618336181345der_on(A,field2(A,S),S) )
     => ( ( bNF_Ca4139267488887388095finite(B,T4)
          & bNF_Ca8970107618336181345der_on(B,field2(B,T4),T4) )
       => pp(member(product_prod(set(product_prod(fun(B,A),fun(B,A))),set(product_prod(fun(B,bool),fun(B,bool)))),aa(set(product_prod(fun(B,bool),fun(B,bool))),product_prod(set(product_prod(fun(B,A),fun(B,A))),set(product_prod(fun(B,bool),fun(B,bool)))),aa(set(product_prod(fun(B,A),fun(B,A))),fun(set(product_prod(fun(B,bool),fun(B,bool))),product_prod(set(product_prod(fun(B,A),fun(B,A))),set(product_prod(fun(B,bool),fun(B,bool))))),product_Pair(set(product_prod(fun(B,A),fun(B,A))),set(product_prod(fun(B,bool),fun(B,bool)))),bNF_Cardinal_cexp(A,B,S,T4)),bNF_Cardinal_cexp(bool,B,bNF_Cardinal_ctwo,T4)),bNF_Wellorder_ordLeq(fun(B,A),fun(B,bool)))) ) ) ).

% Cfinite_cexp_Cinfinite
tff(fact_3935_cinfinite__cexp,axiom,
    ! [A: $tType,B: $tType,Q3: set(product_prod(A,A)),R3: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(bool,bool)),fun(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A)))),product_Pair(set(product_prod(bool,bool)),set(product_prod(A,A))),bNF_Cardinal_ctwo),Q3),bNF_Wellorder_ordLeq(bool,A)))
     => ( ( bNF_Ca4139267488887388095finite(B,R3)
          & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
       => bNF_Ca4139267488887388095finite(fun(B,A),bNF_Cardinal_cexp(A,B,Q3,R3)) ) ) ).

% cinfinite_cexp
tff(fact_3936_Cinfinite__cexp,axiom,
    ! [A: $tType,B: $tType,Q3: set(product_prod(A,A)),R3: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(bool,bool)),fun(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A)))),product_Pair(set(product_prod(bool,bool)),set(product_prod(A,A))),bNF_Cardinal_ctwo),Q3),bNF_Wellorder_ordLeq(bool,A)))
     => ( ( bNF_Ca4139267488887388095finite(B,R3)
          & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
       => ( bNF_Ca4139267488887388095finite(fun(B,A),bNF_Cardinal_cexp(A,B,Q3,R3))
          & bNF_Ca8970107618336181345der_on(fun(B,A),field2(fun(B,A),bNF_Cardinal_cexp(A,B,Q3,R3)),bNF_Cardinal_cexp(A,B,Q3,R3)) ) ) ) ).

% Cinfinite_cexp
tff(fact_3937_ctwo__Cnotzero,axiom,
    ( ~ pp(member(product_prod(set(product_prod(bool,bool)),set(product_prod(bool,bool))),aa(set(product_prod(bool,bool)),product_prod(set(product_prod(bool,bool)),set(product_prod(bool,bool))),aa(set(product_prod(bool,bool)),fun(set(product_prod(bool,bool)),product_prod(set(product_prod(bool,bool)),set(product_prod(bool,bool)))),product_Pair(set(product_prod(bool,bool)),set(product_prod(bool,bool))),bNF_Cardinal_ctwo),bNF_Cardinal_czero(bool)),bNF_Wellorder_ordIso(bool,bool)))
    & bNF_Ca8970107618336181345der_on(bool,field2(bool,bNF_Cardinal_ctwo),bNF_Cardinal_ctwo) ) ).

% ctwo_Cnotzero
tff(fact_3938_cprod__csum__cexp,axiom,
    ! [B: $tType,A: $tType,R1: set(product_prod(A,A)),R22: set(product_prod(B,B))] : pp(member(product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(fun(bool,sum_sum(A,B)),fun(bool,sum_sum(A,B))))),aa(set(product_prod(fun(bool,sum_sum(A,B)),fun(bool,sum_sum(A,B)))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(fun(bool,sum_sum(A,B)),fun(bool,sum_sum(A,B))))),aa(set(product_prod(product_prod(A,B),product_prod(A,B))),fun(set(product_prod(fun(bool,sum_sum(A,B)),fun(bool,sum_sum(A,B)))),product_prod(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(fun(bool,sum_sum(A,B)),fun(bool,sum_sum(A,B)))))),product_Pair(set(product_prod(product_prod(A,B),product_prod(A,B))),set(product_prod(fun(bool,sum_sum(A,B)),fun(bool,sum_sum(A,B))))),bNF_Cardinal_cprod(A,B,R1,R22)),bNF_Cardinal_cexp(sum_sum(A,B),bool,bNF_Cardinal_csum(A,B,R1,R22),bNF_Cardinal_ctwo)),bNF_Wellorder_ordLeq(product_prod(A,B),fun(bool,sum_sum(A,B))))) ).

% cprod_csum_cexp
tff(fact_3939_ordLess__ctwo__cexp,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(fun(A,bool),fun(A,bool)))),aa(set(product_prod(fun(A,bool),fun(A,bool))),product_prod(set(product_prod(A,A)),set(product_prod(fun(A,bool),fun(A,bool)))),aa(set(product_prod(A,A)),fun(set(product_prod(fun(A,bool),fun(A,bool))),product_prod(set(product_prod(A,A)),set(product_prod(fun(A,bool),fun(A,bool))))),product_Pair(set(product_prod(A,A)),set(product_prod(fun(A,bool),fun(A,bool)))),R3),bNF_Cardinal_cexp(bool,A,bNF_Cardinal_ctwo,R3)),bNF_We4044943003108391690rdLess(A,fun(A,bool)))) ) ).

% ordLess_ctwo_cexp
tff(fact_3940_ctwo__not__czero,axiom,
    ! [A: $tType] : ~ pp(member(product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(bool,bool)),fun(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A)))),product_Pair(set(product_prod(bool,bool)),set(product_prod(A,A))),bNF_Cardinal_ctwo),bNF_Cardinal_czero(A)),bNF_Wellorder_ordIso(bool,A))) ).

% ctwo_not_czero
tff(fact_3941_ctwo__ordLess__Cinfinite,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ( bNF_Ca4139267488887388095finite(A,R3)
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => pp(member(product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(bool,bool)),fun(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A)))),product_Pair(set(product_prod(bool,bool)),set(product_prod(A,A))),bNF_Cardinal_ctwo),R3),bNF_We4044943003108391690rdLess(bool,A))) ) ).

% ctwo_ordLess_Cinfinite
tff(fact_3942_ctwo__ordLeq__Cinfinite,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ( bNF_Ca4139267488887388095finite(A,R3)
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => pp(member(product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A))),aa(set(product_prod(bool,bool)),fun(set(product_prod(A,A)),product_prod(set(product_prod(bool,bool)),set(product_prod(A,A)))),product_Pair(set(product_prod(bool,bool)),set(product_prod(A,A))),bNF_Cardinal_ctwo),R3),bNF_Wellorder_ordLeq(bool,A))) ) ).

% ctwo_ordLeq_Cinfinite
tff(fact_3943_csum__Cfinite__cexp__Cinfinite,axiom,
    ! [B: $tType,A: $tType,C: $tType,R3: set(product_prod(A,A)),S: set(product_prod(B,B)),T4: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
     => ( ( bNF_Cardinal_cfinite(B,S)
          & bNF_Ca8970107618336181345der_on(B,field2(B,S),S) )
       => ( ( bNF_Ca4139267488887388095finite(C,T4)
            & bNF_Ca8970107618336181345der_on(C,field2(C,T4),T4) )
         => pp(member(product_prod(set(product_prod(fun(C,sum_sum(A,B)),fun(C,sum_sum(A,B)))),set(product_prod(fun(C,sum_sum(A,bool)),fun(C,sum_sum(A,bool))))),aa(set(product_prod(fun(C,sum_sum(A,bool)),fun(C,sum_sum(A,bool)))),product_prod(set(product_prod(fun(C,sum_sum(A,B)),fun(C,sum_sum(A,B)))),set(product_prod(fun(C,sum_sum(A,bool)),fun(C,sum_sum(A,bool))))),aa(set(product_prod(fun(C,sum_sum(A,B)),fun(C,sum_sum(A,B)))),fun(set(product_prod(fun(C,sum_sum(A,bool)),fun(C,sum_sum(A,bool)))),product_prod(set(product_prod(fun(C,sum_sum(A,B)),fun(C,sum_sum(A,B)))),set(product_prod(fun(C,sum_sum(A,bool)),fun(C,sum_sum(A,bool)))))),product_Pair(set(product_prod(fun(C,sum_sum(A,B)),fun(C,sum_sum(A,B)))),set(product_prod(fun(C,sum_sum(A,bool)),fun(C,sum_sum(A,bool))))),bNF_Cardinal_cexp(sum_sum(A,B),C,bNF_Cardinal_csum(A,B,R3,S),T4)),bNF_Cardinal_cexp(sum_sum(A,bool),C,bNF_Cardinal_csum(A,bool,R3,bNF_Cardinal_ctwo),T4)),bNF_Wellorder_ordLeq(fun(C,sum_sum(A,B)),fun(C,sum_sum(A,bool))))) ) ) ) ).

% csum_Cfinite_cexp_Cinfinite
tff(fact_3944_natLeq__ordLeq__cinfinite,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ( bNF_Ca4139267488887388095finite(A,R3)
        & bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3) )
     => pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(nat,nat)),set(product_prod(A,A))),aa(set(product_prod(nat,nat)),fun(set(product_prod(A,A)),product_prod(set(product_prod(nat,nat)),set(product_prod(A,A)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(A,A))),bNF_Ca8665028551170535155natLeq),R3),bNF_Wellorder_ordLeq(nat,A))) ) ).

% natLeq_ordLeq_cinfinite
tff(fact_3945_infinite__iff__natLeq__ordLeq,axiom,
    ! [A: $tType,A4: set(A)] :
      ~ ( pp(aa(set(A),bool,finite_finite(A),A4))
      <=> pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(nat,nat)),set(product_prod(A,A))),aa(set(product_prod(nat,nat)),fun(set(product_prod(A,A)),product_prod(set(product_prod(nat,nat)),set(product_prod(A,A)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(A,A))),bNF_Ca8665028551170535155natLeq),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Wellorder_ordLeq(nat,A))) ) ).

% infinite_iff_natLeq_ordLeq
tff(fact_3946_dir__image__ordIso,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,A)),F: fun(A,B)] :
      ( order_well_order_on(A,field2(A,R3),R3)
     => ( inj_on(A,B,F,field2(A,R3))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),bNF_We2720479622203943262_image(A,B,R3,F)),bNF_Wellorder_ordIso(A,B))) ) ) ).

% dir_image_ordIso
tff(fact_3947_card__of__nat,axiom,
    pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bNF_Ca6860139660246222851ard_of(nat,top_top(set(nat)))),bNF_Ca8665028551170535155natLeq),bNF_Wellorder_ordIso(nat,nat))) ).

% card_of_nat
tff(fact_3948_ctwo__ordLess__natLeq,axiom,
    pp(member(product_prod(set(product_prod(bool,bool)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(bool,bool)),set(product_prod(nat,nat))),aa(set(product_prod(bool,bool)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(bool,bool)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(bool,bool)),set(product_prod(nat,nat))),bNF_Cardinal_ctwo),bNF_Ca8665028551170535155natLeq),bNF_We4044943003108391690rdLess(bool,nat))) ).

% ctwo_ordLess_natLeq
tff(fact_3949_dir__image__def,axiom,
    ! [A2: $tType,A: $tType,R3: set(product_prod(A,A)),F: fun(A,A2)] : ( bNF_We2720479622203943262_image(A,A2,R3,F) = aa(fun(product_prod(A2,A2),bool),set(product_prod(A2,A2)),collect(product_prod(A2,A2)),aa(fun(A,A2),fun(product_prod(A2,A2),bool),aTP_Lamp_nw(set(product_prod(A,A)),fun(fun(A,A2),fun(product_prod(A2,A2),bool)),R3),F)) ) ).

% dir_image_def
tff(fact_3950_Restr__natLeq2,axiom,
    ! [N: nat] : ( aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),inf_inf(set(product_prod(nat,nat))),bNF_Ca8665028551170535155natLeq),product_Sigma(nat,nat,order_underS(nat,bNF_Ca8665028551170535155natLeq,N),aTP_Lamp_nx(nat,fun(nat,set(nat)),N))) = aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_ny(nat,fun(nat,fun(nat,bool)),N))) ) ).

% Restr_natLeq2
tff(fact_3951_Restr__natLeq,axiom,
    ! [N: nat] : ( aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),inf_inf(set(product_prod(nat,nat))),bNF_Ca8665028551170535155natLeq),product_Sigma(nat,nat,aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_ds(nat,fun(nat,bool),N)),aTP_Lamp_nz(nat,fun(nat,set(nat)),N))) = aa(fun(product_prod(nat,nat),bool),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,bool)),fun(product_prod(nat,nat),bool),product_case_prod(nat,nat,bool),aTP_Lamp_ny(nat,fun(nat,fun(nat,bool)),N))) ) ).

% Restr_natLeq
tff(fact_3952_card__of__Field__natLeq,axiom,
    pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bNF_Ca6860139660246222851ard_of(nat,field2(nat,bNF_Ca8665028551170535155natLeq))),bNF_Ca8665028551170535155natLeq),bNF_Wellorder_ordIso(nat,nat))) ).

% card_of_Field_natLeq
tff(fact_3953_finite__iff__ordLess__natLeq,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
    <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(A,A)),set(product_prod(nat,nat))),aa(set(product_prod(A,A)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(A,A)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(A,A)),set(product_prod(nat,nat))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca8665028551170535155natLeq),bNF_We4044943003108391690rdLess(A,nat))) ) ).

% finite_iff_ordLess_natLeq
tff(fact_3954_dir__image,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),R3: set(product_prod(A,A))] :
      ( ! [X2: A,Y2: A] :
          ( ( aa(A,B,F,X2) = aa(A,B,F,Y2) )
        <=> ( X2 = Y2 ) )
     => ( bNF_Ca8970107618336181345der_on(A,field2(A,R3),R3)
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),bNF_We2720479622203943262_image(A,B,R3,F)),bNF_Wellorder_ordIso(A,B))) ) ) ).

% dir_image
tff(fact_3955_subset__singleton__iff__Uniq,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ? [A6: A] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),aa(set(A),set(A),insert2(A,A6),bot_bot(set(A)))))
    <=> uniq(A,aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),A4)) ) ).

% subset_singleton_iff_Uniq
tff(fact_3956_Gcd__fin__def,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( semiring_gcd_Gcd_fin(A) = bounde2362111253966948842tice_F(A,gcd_gcd(A),zero_zero(A),one_one(A)) ) ) ).

% Gcd_fin_def
tff(fact_3957_dom__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y: option(B),F: fun(A,option(B)),X: A] :
      ( ( ( Y = none(B) )
       => ( dom(A,B,fun_upd(A,option(B),F,X,Y)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),dom(A,B,F)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) ) )
      & ( ( Y != none(B) )
       => ( dom(A,B,fun_upd(A,option(B),F,X,Y)) = aa(set(A),set(A),insert2(A,X),dom(A,B,F)) ) ) ) ).

% dom_fun_upd
tff(fact_3958_ex__is__arg__min__if__finite,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [S2: set(A),F: fun(A,B)] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( ( S2 != bot_bot(set(A)) )
           => ? [X_1: A] : lattic501386751177426532rg_min(A,B,F,aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),S2),X_1) ) ) ) ).

% ex_is_arg_min_if_finite
tff(fact_3959_dom__eq__empty__conv,axiom,
    ! [A: $tType,B: $tType,F: fun(A,option(B))] :
      ( ( dom(A,B,F) = bot_bot(set(A)) )
    <=> ! [X4: A] : ( aa(A,option(B),F,X4) = none(B) ) ) ).

% dom_eq_empty_conv
tff(fact_3960_dom__restrict,axiom,
    ! [B: $tType,A: $tType,M4: fun(A,option(B)),A4: set(A)] : ( dom(A,B,restrict_map(A,B,M4,A4)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,M4)),A4) ) ).

% dom_restrict
tff(fact_3961_dom__empty,axiom,
    ! [B: $tType,A: $tType] : ( dom(A,B,aTP_Lamp_mi(A,option(B))) = bot_bot(set(A)) ) ).

% dom_empty
tff(fact_3962_dom__override__on,axiom,
    ! [B: $tType,A: $tType,F: fun(A,option(B)),G: fun(A,option(B)),A4: set(A)] : ( dom(A,B,override_on(A,option(B),F,G,A4)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),dom(A,B,F)),aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_oa(fun(A,option(B)),fun(set(A),fun(A,bool)),G),A4)))),aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_ob(fun(A,option(B)),fun(set(A),fun(A,bool)),G),A4))) ) ).

% dom_override_on
tff(fact_3963_dom__if,axiom,
    ! [B: $tType,A: $tType,P: fun(A,bool),F: fun(A,option(B)),G: fun(A,option(B))] : ( dom(A,B,aa(fun(A,option(B)),fun(A,option(B)),aa(fun(A,option(B)),fun(fun(A,option(B)),fun(A,option(B))),aTP_Lamp_oc(fun(A,bool),fun(fun(A,option(B)),fun(fun(A,option(B)),fun(A,option(B)))),P),F),G)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,F)),aa(fun(A,bool),set(A),collect(A),P))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,G)),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_od(fun(A,bool),fun(A,bool),P)))) ) ).

% dom_if
tff(fact_3964_restrict__map__eq_I1_J,axiom,
    ! [A: $tType,B: $tType,M4: fun(B,option(A)),A4: set(B),K: B] :
      ( ( aa(B,option(A),restrict_map(B,A,M4,A4),K) = none(A) )
    <=> ~ pp(member(B,K,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,A,M4)),A4))) ) ).

% restrict_map_eq(1)
tff(fact_3965_inj__on__map__the,axiom,
    ! [B: $tType,A: $tType,D4: set(A),M4: fun(A,option(B))] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),D4),dom(A,B,M4)))
     => ( inj_on(A,option(B),M4,D4)
       => inj_on(A,B,aa(fun(A,option(B)),fun(A,B),aa(fun(option(B),B),fun(fun(A,option(B)),fun(A,B)),comp(option(B),B,A),the2(B)),M4),D4) ) ) ).

% inj_on_map_the
tff(fact_3966_graph__eq__to__snd__dom,axiom,
    ! [B: $tType,A: $tType,M4: fun(A,option(B))] : ( graph(A,B,M4) = aa(set(A),set(product_prod(A,B)),image2(A,product_prod(A,B),aTP_Lamp_oe(fun(A,option(B)),fun(A,product_prod(A,B)),M4)),dom(A,B,M4)) ) ).

% graph_eq_to_snd_dom
tff(fact_3967_dom__eq__singleton__conv,axiom,
    ! [A: $tType,B: $tType,F: fun(A,option(B)),X: A] :
      ( ( dom(A,B,F) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) )
    <=> ? [V4: B] : ( F = fun_upd(A,option(B),aTP_Lamp_mi(A,option(B)),X,aa(B,option(B),some(B),V4)) ) ) ).

% dom_eq_singleton_conv
tff(fact_3968_ran__map__upd__Some,axiom,
    ! [B: $tType,A: $tType,M4: fun(B,option(A)),X: B,Y: A,Z2: A] :
      ( ( aa(B,option(A),M4,X) = aa(A,option(A),some(A),Y) )
     => ( inj_on(B,option(A),M4,dom(B,A,M4))
       => ( ~ pp(member(A,Z2,ran(B,A,M4)))
         => ( ran(B,A,fun_upd(B,option(A),M4,X,aa(A,option(A),some(A),Z2))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),ran(B,A,M4)),aa(set(A),set(A),insert2(A,Y),bot_bot(set(A))))),aa(set(A),set(A),insert2(A,Z2),bot_bot(set(A)))) ) ) ) ) ).

% ran_map_upd_Some
tff(fact_3969_bounded__quasi__semilattice__set_Oremove,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A3: A,A4: set(A)] :
      ( bounde6485984586167503788ce_set(A,F,Top,Bot,Normalize)
     => ( pp(member(A,A3,A4))
       => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F,Top,Bot),A4) = aa(A,A,aa(A,fun(A,A),F,A3),aa(set(A),A,bounde2362111253966948842tice_F(A,F,Top,Bot),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))) ) ) ) ).

% bounded_quasi_semilattice_set.remove
tff(fact_3970_bounded__quasi__semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A3: A,A4: set(A)] :
      ( bounde6485984586167503788ce_set(A,F,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F,Top,Bot),aa(set(A),set(A),insert2(A,A3),A4)) = aa(A,A,aa(A,fun(A,A),F,A3),aa(set(A),A,bounde2362111253966948842tice_F(A,F,Top,Bot),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))) ) ) ).

% bounded_quasi_semilattice_set.insert_remove
tff(fact_3971_graph__map__add,axiom,
    ! [B: $tType,A: $tType,M12: fun(A,option(B)),M22: fun(A,option(B))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,M12)),dom(A,B,M22)) = bot_bot(set(A)) )
     => ( graph(A,B,map_add(A,B,M12,M22)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),sup_sup(set(product_prod(A,B))),graph(A,B,M12)),graph(A,B,M22)) ) ) ).

% graph_map_add
tff(fact_3972_ran__empty,axiom,
    ! [B: $tType,A: $tType] : ( ran(B,A,aTP_Lamp_of(B,option(A))) = bot_bot(set(A)) ) ).

% ran_empty
tff(fact_3973_ran__add,axiom,
    ! [B: $tType,A: $tType,F: fun(A,option(B)),G: fun(A,option(B))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,F)),dom(A,B,G)) = bot_bot(set(A)) )
     => ( ran(A,B,map_add(A,B,F,G)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),ran(A,B,F)),ran(A,B,G)) ) ) ).

% ran_add
tff(fact_3974_ran__map__add,axiom,
    ! [B: $tType,A: $tType,M12: fun(A,option(B)),M22: fun(A,option(B))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,M12)),dom(A,B,M22)) = bot_bot(set(A)) )
     => ( ran(A,B,map_add(A,B,M12,M22)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),ran(A,B,M12)),ran(A,B,M22)) ) ) ).

% ran_map_add
tff(fact_3975_map__add__left__comm,axiom,
    ! [B: $tType,A: $tType,A4: fun(A,option(B)),B3: fun(A,option(B)),C3: fun(A,option(B))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,A4)),dom(A,B,B3)) = bot_bot(set(A)) )
     => ( map_add(A,B,A4,map_add(A,B,B3,C3)) = map_add(A,B,B3,map_add(A,B,A4,C3)) ) ) ).

% map_add_left_comm
tff(fact_3976_map__add__distinct__le,axiom,
    ! [B: $tType,A: $tType] :
      ( preorder(B)
     => ! [M4: fun(A,option(B)),M6: fun(A,option(B)),N: fun(A,option(B)),N2: fun(A,option(B))] :
          ( pp(aa(fun(A,option(B)),bool,aa(fun(A,option(B)),fun(fun(A,option(B)),bool),ord_less_eq(fun(A,option(B))),M4),M6))
         => ( pp(aa(fun(A,option(B)),bool,aa(fun(A,option(B)),fun(fun(A,option(B)),bool),ord_less_eq(fun(A,option(B))),N),N2))
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,M6)),dom(A,B,N2)) = bot_bot(set(A)) )
             => pp(aa(fun(A,option(B)),bool,aa(fun(A,option(B)),fun(fun(A,option(B)),bool),ord_less_eq(fun(A,option(B))),map_add(A,B,M4,N)),map_add(A,B,M6,N2))) ) ) ) ) ).

% map_add_distinct_le
tff(fact_3977_map__add__comm,axiom,
    ! [B: $tType,A: $tType,M12: fun(A,option(B)),M22: fun(A,option(B))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),dom(A,B,M12)),dom(A,B,M22)) = bot_bot(set(A)) )
     => ( map_add(A,B,M12,M22) = map_add(A,B,M22,M12) ) ) ).

% map_add_comm
tff(fact_3978_bounded__quasi__semilattice__set_Oempty,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A)] :
      ( bounde6485984586167503788ce_set(A,F,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F,Top,Bot),bot_bot(set(A))) = Top ) ) ).

% bounded_quasi_semilattice_set.empty
tff(fact_3979_ran__is__image,axiom,
    ! [A: $tType,B: $tType,M: fun(B,option(A))] : ( ran(B,A,M) = aa(set(B),set(A),image2(B,A,aa(fun(B,option(A)),fun(B,A),aa(fun(option(A),A),fun(fun(B,option(A)),fun(B,A)),comp(option(A),A,B),the2(A)),M)),dom(B,A,M)) ) ).

% ran_is_image
tff(fact_3980_relImage__def,axiom,
    ! [A: $tType,B: $tType,R: set(product_prod(B,B)),F: fun(B,A)] : ( bNF_Gr4221423524335903396lImage(B,A,R,F) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(B,A),fun(product_prod(A,A),bool),aTP_Lamp_og(set(product_prod(B,B)),fun(fun(B,A),fun(product_prod(A,A),bool)),R),F)) ) ).

% relImage_def
tff(fact_3981_Sup__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => lattic4895041142388067077er_set(A,sup_sup(A),aTP_Lamp_oh(A,fun(A,bool)),aTP_Lamp_oi(A,fun(A,bool))) ) ).

% Sup_fin.semilattice_order_set_axioms
tff(fact_3982_type__copy__vimage2p__Grp__Abs,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Rep: fun(A,B),Abs: fun(B,A),G: fun(D,C),P: fun(C,bool),H2: fun(C,A)] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( aa(fun(C,fun(A,bool)),fun(D,fun(B,bool)),bNF_vimage2p(D,C,B,A,bool,G,Abs),bNF_Grp(C,A,aa(fun(C,bool),set(C),collect(C),P),H2)) = bNF_Grp(D,B,aa(fun(D,bool),set(D),collect(D),aa(fun(C,bool),fun(D,bool),aTP_Lamp_oj(fun(D,C),fun(fun(C,bool),fun(D,bool)),G),P)),aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),aa(fun(C,A),fun(C,B),aa(fun(A,B),fun(fun(C,A),fun(C,B)),comp(A,B,C),Rep),H2)),G)) ) ) ).

% type_copy_vimage2p_Grp_Abs
tff(fact_3983_type__copy__vimage2p__Grp__Rep,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,Rep: fun(A,B),Abs: fun(B,A),F: fun(C,D),P: fun(D,bool),H2: fun(D,B)] :
      ( type_definition(A,B,Rep,Abs,top_top(set(B)))
     => ( aa(fun(D,fun(B,bool)),fun(C,fun(A,bool)),bNF_vimage2p(C,D,A,B,bool,F,Rep),bNF_Grp(D,B,aa(fun(D,bool),set(D),collect(D),P),H2)) = bNF_Grp(C,A,aa(fun(C,bool),set(C),collect(C),aa(fun(D,bool),fun(C,bool),aTP_Lamp_ok(fun(C,D),fun(fun(D,bool),fun(C,bool)),F),P)),aa(fun(C,D),fun(C,A),aa(fun(D,A),fun(fun(C,D),fun(C,A)),comp(D,A,C),aa(fun(D,B),fun(D,A),aa(fun(B,A),fun(fun(D,B),fun(D,A)),comp(B,A,D),Abs),H2)),F)) ) ) ).

% type_copy_vimage2p_Grp_Rep
tff(fact_3984_fun_Orel__Grp,axiom,
    ! [D: $tType,B: $tType,A: $tType,A4: set(A),F: fun(A,B)] : ( bNF_rel_fun(D,D,A,B,fequal(D),bNF_Grp(A,B,A4,F)) = bNF_Grp(fun(D,A),fun(D,B),aa(fun(fun(D,A),bool),set(fun(D,A)),collect(fun(D,A)),aTP_Lamp_ol(set(A),fun(fun(D,A),bool),A4)),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),F)) ) ).

% fun.rel_Grp
tff(fact_3985_Collect__case__prod__Grp__eqD,axiom,
    ! [B: $tType,A: $tType,Z2: product_prod(A,B),A4: set(A),F: fun(A,B)] :
      ( pp(member(product_prod(A,B),Z2,aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),bNF_Grp(A,B,A4,F)))))
     => ( aa(product_prod(A,B),B,aa(fun(product_prod(A,B),A),fun(product_prod(A,B),B),aa(fun(A,B),fun(fun(product_prod(A,B),A),fun(product_prod(A,B),B)),comp(A,B,product_prod(A,B)),F),product_fst(A,B)),Z2) = aa(product_prod(A,B),B,product_snd(A,B),Z2) ) ) ).

% Collect_case_prod_Grp_eqD
tff(fact_3986_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => lattic4895041142388067077er_set(A,inf_inf(A),ord_less_eq(A),ord_less(A)) ) ).

% Inf_fin.semilattice_order_set_axioms
tff(fact_3987_mono__cINF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(A) )
     => ! [F: fun(A,B),A4: fun(C,A),I4: set(C)] :
          ( order_mono(A,B,F)
         => ( condit1013018076250108175_below(A,aa(set(C),set(A),image2(C,A,A4),I4))
           => ( ( I4 != bot_bot(set(C)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,A4),I4)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_om(fun(A,B),fun(fun(C,A),fun(C,B)),F),A4)),I4)))) ) ) ) ) ).

% mono_cINF
tff(fact_3988_mono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F: fun(A,B),A4: set(A)] :
          ( order_mono(A,B,F)
         => ( condit1013018076250108175_below(A,A4)
           => ( ( A4 != bot_bot(set(A)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,aa(set(A),A,complete_Inf_Inf(A),A4))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image2(A,B,F),A4)))) ) ) ) ) ).

% mono_cInf
tff(fact_3989_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F: fun(A,B),A4: fun(C,A),I4: set(C)] :
          ( order_mono(A,B,F)
         => ( condit941137186595557371_above(A,aa(set(C),set(A),image2(C,A,A4),I4))
           => ( ( I4 != bot_bot(set(C)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_om(fun(A,B),fun(fun(C,A),fun(C,B)),F),A4)),I4))),aa(A,B,F,aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,A4),I4))))) ) ) ) ) ).

% mono_cSUP
tff(fact_3990_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F: fun(A,B),A4: set(A)] :
          ( order_mono(A,B,F)
         => ( condit941137186595557371_above(A,A4)
           => ( ( A4 != bot_bot(set(A)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image2(A,B,F),A4))),aa(A,B,F,aa(set(A),A,complete_Sup_Sup(A),A4)))) ) ) ) ) ).

% mono_cSup
tff(fact_3991_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F: fun(A,B),X: A,Y: A] :
          ( order_mono(A,B,F)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,X)),aa(A,B,F,Y))) ) ) ) ).

% monoD
tff(fact_3992_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F: fun(A,B),X: A,Y: A] :
          ( order_mono(A,B,F)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,X)),aa(A,B,F,Y))) ) ) ) ).

% monoE
tff(fact_3993_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F: fun(A,B)] :
          ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,X2)),aa(A,B,F,Y2))) )
         => order_mono(A,B,F) ) ) ).

% monoI
tff(fact_3994_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F: fun(A,B)] :
          ( order_mono(A,B,F)
        <=> ! [X4: A,Y3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Y3))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,X4)),aa(A,B,F,Y3))) ) ) ) ).

% mono_def
tff(fact_3995_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F: fun(A,B),X: A,Y: A] :
          ( order_mono(A,B,F)
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F,X)),aa(A,B,F,Y)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Y)) ) ) ) ).

% mono_strict_invE
tff(fact_3996_mono__add,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A3: A] : order_mono(A,A,aa(A,fun(A,A),plus_plus(A),A3)) ) ).

% mono_add
tff(fact_3997_min__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F: fun(A,B),M4: A,N: A] :
          ( order_mono(A,B,F)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(A,B,F,M4)),aa(A,B,F,N)) = aa(A,B,F,aa(A,A,aa(A,fun(A,A),ord_min(A),M4),N)) ) ) ) ).

% min_of_mono
tff(fact_3998_mono__Int,axiom,
    ! [B: $tType,A: $tType,F: fun(set(A),set(B)),A4: set(A),B3: set(A)] :
      ( order_mono(set(A),set(B),F)
     => pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),F,A4)),aa(set(A),set(B),F,B3)))) ) ).

% mono_Int
tff(fact_3999_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F: fun(A,B),X: A,Y: A] :
          ( order_mono(A,B,F)
         => ( pp(aa(B,bool,aa(B,fun(B,bool),ord_less(B),aa(A,B,F,X)),aa(A,B,F,Y)))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y)) ) ) ) ).

% mono_invE
tff(fact_4000_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf(A)
        & semilattice_inf(B) )
     => ! [F: fun(A,B),A4: A,B3: A] :
          ( order_mono(A,B,F)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),B3))),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,F,A4)),aa(A,B,F,B3)))) ) ) ).

% mono_inf
tff(fact_4001_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup(A)
        & semilattice_sup(B) )
     => ! [F: fun(A,B),A4: A,B3: A] :
          ( order_mono(A,B,F)
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(A,B,F,A4)),aa(A,B,F,B3))),aa(A,B,F,aa(A,A,aa(A,fun(A,A),sup_sup(A),A4),B3)))) ) ) ).

% mono_sup
tff(fact_4002_Rings_Omono__mult,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
         => order_mono(A,A,aa(A,fun(A,A),times_times(A),A3)) ) ) ).

% Rings.mono_mult
tff(fact_4003_mono__Max__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F: fun(A,B),A4: set(A)] :
          ( order_mono(A,B,F)
         => ( pp(aa(set(A),bool,finite_finite(A),A4))
           => ( ( A4 != bot_bot(set(A)) )
             => ( aa(A,B,F,lattic643756798349783984er_Max(A,A4)) = lattic643756798349783984er_Max(B,aa(set(A),set(B),image2(A,B,F),A4)) ) ) ) ) ) ).

% mono_Max_commute
tff(fact_4004_mono__Min__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F: fun(A,B),A4: set(A)] :
          ( order_mono(A,B,F)
         => ( pp(aa(set(A),bool,finite_finite(A),A4))
           => ( ( A4 != bot_bot(set(A)) )
             => ( aa(A,B,F,lattic643756798350308766er_Min(A,A4)) = lattic643756798350308766er_Min(B,aa(set(A),set(B),image2(A,B,F),A4)) ) ) ) ) ) ).

% mono_Min_commute
tff(fact_4005_finite_Omono,axiom,
    ! [A: $tType] : order_mono(fun(set(A),bool),fun(set(A),bool),aTP_Lamp_nc(fun(set(A),bool),fun(set(A),bool))) ).

% finite.mono
tff(fact_4006_lfp__induct,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(A,A),P: A] :
          ( order_mono(A,A,F)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,F,aa(A,A,aa(A,fun(A,A),inf_inf(A),complete_lattice_lfp(A,F)),P))),P))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),complete_lattice_lfp(A,F)),P)) ) ) ) ).

% lfp_induct
tff(fact_4007_def__lfp__induct,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: A,F: fun(A,A),P: A] :
          ( ( A4 = complete_lattice_lfp(A,F) )
         => ( order_mono(A,A,F)
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,F,aa(A,A,aa(A,fun(A,A),inf_inf(A),A4),P))),P))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A4),P)) ) ) ) ) ).

% def_lfp_induct
tff(fact_4008_cInf__cSup,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S2: set(A)] :
          ( ( S2 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,S2)
           => ( aa(set(A),A,complete_Inf_Inf(A),S2) = aa(set(A),A,complete_Sup_Sup(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_on(set(A),fun(A,bool),S2))) ) ) ) ) ).

% cInf_cSup
tff(fact_4009_cSup__cInf,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S2: set(A)] :
          ( ( S2 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,S2)
           => ( aa(set(A),A,complete_Sup_Sup(A),S2) = aa(set(A),A,complete_Inf_Inf(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_oo(set(A),fun(A,bool),S2))) ) ) ) ) ).

% cSup_cInf
tff(fact_4010_ball__empty,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A] :
      ( pp(member(A,X3,bot_bot(set(A))))
     => pp(aa(A,bool,P,X3)) ) ).

% ball_empty
tff(fact_4011_def__lfp__induct__set,axiom,
    ! [A: $tType,A4: set(A),F: fun(set(A),set(A)),A3: A,P: fun(A,bool)] :
      ( ( A4 = complete_lattice_lfp(set(A),F) )
     => ( order_mono(set(A),set(A),F)
       => ( pp(member(A,A3,A4))
         => ( ! [X2: A] :
                ( pp(member(A,X2,aa(set(A),set(A),F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(fun(A,bool),set(A),collect(A),P)))))
               => pp(aa(A,bool,P,X2)) )
           => pp(aa(A,bool,P,A3)) ) ) ) ) ).

% def_lfp_induct_set
tff(fact_4012_lfp__induct__set,axiom,
    ! [A: $tType,A3: A,F: fun(set(A),set(A)),P: fun(A,bool)] :
      ( pp(member(A,A3,complete_lattice_lfp(set(A),F)))
     => ( order_mono(set(A),set(A),F)
       => ( ! [X2: A] :
              ( pp(member(A,X2,aa(set(A),set(A),F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),complete_lattice_lfp(set(A),F)),aa(fun(A,bool),set(A),collect(A),P)))))
             => pp(aa(A,bool,P,X2)) )
         => pp(aa(A,bool,P,A3)) ) ) ) ).

% lfp_induct_set
tff(fact_4013_mono__compose,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [Q: fun(A,fun(B,C)),F: fun(D,B)] :
          ( order_mono(A,fun(B,C),Q)
         => order_mono(A,fun(D,C),aa(fun(D,B),fun(A,fun(D,C)),aTP_Lamp_op(fun(A,fun(B,C)),fun(fun(D,B),fun(A,fun(D,C))),Q),F)) ) ) ).

% mono_compose
tff(fact_4014_Ball__image__comp,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),A4: set(B),G: fun(A,bool)] :
      ( ! [X4: A] :
          ( pp(member(A,X4,aa(set(B),set(A),image2(B,A,F),A4)))
         => pp(aa(A,bool,G,X4)) )
    <=> ! [X4: B] :
          ( pp(member(B,X4,A4))
         => pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aa(fun(A,bool),fun(fun(B,A),fun(B,bool)),comp(A,bool,B),G),F),X4)) ) ) ).

% Ball_image_comp
tff(fact_4015_Ball__comp__iff,axiom,
    ! [A: $tType,B: $tType,C: $tType,A4: fun(B,set(C)),F: fun(C,bool),G: fun(A,B),X3: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),aa(fun(C,bool),fun(B,bool),aTP_Lamp_oq(fun(B,set(C)),fun(fun(C,bool),fun(B,bool)),A4),F)),G),X3))
    <=> ! [Xa2: C] :
          ( pp(member(C,Xa2,aa(A,set(C),aa(fun(A,B),fun(A,set(C)),aa(fun(B,set(C)),fun(fun(A,B),fun(A,set(C))),comp(B,set(C),A),A4),G),X3)))
         => pp(aa(C,bool,F,Xa2)) ) ) ).

% Ball_comp_iff
tff(fact_4016_Chains__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( chains(A,R3) = aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_or(set(product_prod(A,A)),fun(set(A),bool),R3)) ) ).

% Chains_def
tff(fact_4017_refl__on__def_H,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] :
      ( refl_on(A,A4,R3)
    <=> ( ! [X4: product_prod(A,A)] :
            ( pp(member(product_prod(A,A),X4,R3))
           => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aTP_Lamp_os(set(A),fun(A,fun(A,bool)),A4)),X4)) )
        & ! [X4: A] :
            ( pp(member(A,X4,A4))
           => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),X4),R3)) ) ) ) ).

% refl_on_def'
tff(fact_4018_lfp__induct2,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,F: fun(set(product_prod(A,B)),set(product_prod(A,B))),P: fun(A,fun(B,bool))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),complete_lattice_lfp(set(product_prod(A,B)),F)))
     => ( order_mono(set(product_prod(A,B)),set(product_prod(A,B)),F)
       => ( ! [A8: A,B5: B] :
              ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5),aa(set(product_prod(A,B)),set(product_prod(A,B)),F,aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),complete_lattice_lfp(set(product_prod(A,B)),F)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),P))))))
             => pp(aa(B,bool,aa(A,fun(B,bool),P,A8),B5)) )
         => pp(aa(B,bool,aa(A,fun(B,bool),P,A3),B2)) ) ) ) ).

% lfp_induct2
tff(fact_4019_UnderS__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] : ( order_UnderS(A,R3,A4) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_ot(set(product_prod(A,A)),fun(set(A),fun(A,bool)),R3),A4)) ) ).

% UnderS_def
tff(fact_4020_Under__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] : ( order_Under(A,R3,A4) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_ou(set(product_prod(A,A)),fun(set(A),fun(A,bool)),R3),A4)) ) ).

% Under_def
tff(fact_4021_Above__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] : ( order_Above(A,R3,A4) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_ov(set(product_prod(A,A)),fun(set(A),fun(A,bool)),R3),A4)) ) ).

% Above_def
tff(fact_4022_min__ext__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( min_ext(A,R3) = aa(fun(product_prod(set(A),set(A)),bool),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aTP_Lamp_ow(set(product_prod(A,A)),fun(product_prod(set(A),set(A)),bool),R3)) ) ).

% min_ext_def
tff(fact_4023_bex__empty,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ~ ? [X3: A] :
          ( pp(member(A,X3,bot_bot(set(A))))
          & pp(aa(A,bool,P,X3)) ) ).

% bex_empty
tff(fact_4024_conj__comp__iff,axiom,
    ! [B: $tType,A: $tType,P: fun(B,bool),Q: fun(B,bool),G: fun(A,B),X3: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),aa(fun(B,bool),fun(B,bool),aTP_Lamp_ox(fun(B,bool),fun(fun(B,bool),fun(B,bool)),P),Q)),G),X3))
    <=> ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),P),G),X3))
        & pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),Q),G),X3)) ) ) ).

% conj_comp_iff
tff(fact_4025_Image__def,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B)),S: set(A)] : ( image(A,B,R3,S) = aa(fun(B,bool),set(B),collect(B),aa(set(A),fun(B,bool),aTP_Lamp_oy(set(product_prod(A,B)),fun(set(A),fun(B,bool)),R3),S)) ) ).

% Image_def
tff(fact_4026_max__extp_Ocases,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),A1: set(A),A22: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),max_extp(A,R),A1),A22))
     => ~ ( pp(aa(set(A),bool,finite_finite(A),A1))
         => ( pp(aa(set(A),bool,finite_finite(A),A22))
           => ( ( A22 != aa(fun(A,bool),set(A),collect(A),bot_bot(fun(A,bool))) )
             => ~ ! [X3: A] :
                    ( pp(member(A,X3,A1))
                   => ? [Xa4: A] :
                        ( pp(member(A,Xa4,A22))
                        & pp(aa(A,bool,aa(A,fun(A,bool),R,X3),Xa4)) ) ) ) ) ) ) ).

% max_extp.cases
tff(fact_4027_max__extp_Osimps,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),A1: set(A),A22: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),max_extp(A,R),A1),A22))
    <=> ( pp(aa(set(A),bool,finite_finite(A),A1))
        & pp(aa(set(A),bool,finite_finite(A),A22))
        & ( A22 != aa(fun(A,bool),set(A),collect(A),bot_bot(fun(A,bool))) )
        & ! [X4: A] :
            ( pp(member(A,X4,A1))
           => ? [Xa2: A] :
                ( pp(member(A,Xa2,A22))
                & pp(aa(A,bool,aa(A,fun(A,bool),R,X4),Xa2)) ) ) ) ) ).

% max_extp.simps
tff(fact_4028_max__extp_Omax__extI,axiom,
    ! [A: $tType,X6: set(A),Y5: set(A),R: fun(A,fun(A,bool))] :
      ( pp(aa(set(A),bool,finite_finite(A),X6))
     => ( pp(aa(set(A),bool,finite_finite(A),Y5))
       => ( ( Y5 != aa(fun(A,bool),set(A),collect(A),bot_bot(fun(A,bool))) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,X6))
               => ? [Xa3: A] :
                    ( pp(member(A,Xa3,Y5))
                    & pp(aa(A,bool,aa(A,fun(A,bool),R,X2),Xa3)) ) )
           => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),max_extp(A,R),X6),Y5)) ) ) ) ) ).

% max_extp.max_extI
tff(fact_4029_max__ext__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( max_ext(A,R) = aa(fun(product_prod(set(A),set(A)),bool),set(product_prod(set(A),set(A))),collect(product_prod(set(A),set(A))),aa(fun(set(A),fun(set(A),bool)),fun(product_prod(set(A),set(A)),bool),product_case_prod(set(A),set(A),bool),aTP_Lamp_oz(set(product_prod(A,A)),fun(set(A),fun(set(A),bool)),R))) ) ).

% max_ext_eq
tff(fact_4030_AboveS__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] : ( order_AboveS(A,R3,A4) = aa(fun(A,bool),set(A),collect(A),aa(set(A),fun(A,bool),aTP_Lamp_pa(set(product_prod(A,A)),fun(set(A),fun(A,bool)),R3),A4)) ) ).

% AboveS_def
tff(fact_4031_flip__pred,axiom,
    ! [A: $tType,B: $tType,A4: set(product_prod(A,B)),R: fun(B,fun(A,bool))] :
      ( pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),A4),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),conversep(B,A,R)))))
     => pp(aa(set(product_prod(B,A)),bool,aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),bool),ord_less_eq(set(product_prod(B,A))),aa(set(product_prod(A,B)),set(product_prod(B,A)),image2(product_prod(A,B),product_prod(B,A),aa(fun(A,fun(B,product_prod(B,A))),fun(product_prod(A,B),product_prod(B,A)),product_case_prod(A,B,product_prod(B,A)),aTP_Lamp_es(A,fun(B,product_prod(B,A))))),A4)),aa(fun(product_prod(B,A),bool),set(product_prod(B,A)),collect(product_prod(B,A)),aa(fun(B,fun(A,bool)),fun(product_prod(B,A),bool),product_case_prod(B,A,bool),R)))) ) ).

% flip_pred
tff(fact_4032_acyclic__insert,axiom,
    ! [A: $tType,Y: A,X: A,R3: set(product_prod(A,A))] :
      ( transitive_acyclic(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),X)),R3))
    <=> ( transitive_acyclic(A,R3)
        & ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,R3))) ) ) ).

% acyclic_insert
tff(fact_4033_acyclic__empty,axiom,
    ! [A: $tType] : transitive_acyclic(A,bot_bot(set(product_prod(A,A)))) ).

% acyclic_empty
tff(fact_4034_converse__meet,axiom,
    ! [A: $tType,B: $tType,R3: fun(B,fun(A,bool)),S: fun(B,fun(A,bool))] : ( conversep(B,A,aa(fun(B,fun(A,bool)),fun(B,fun(A,bool)),aa(fun(B,fun(A,bool)),fun(fun(B,fun(A,bool)),fun(B,fun(A,bool))),inf_inf(fun(B,fun(A,bool))),R3),S)) = aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),conversep(B,A,R3)),conversep(B,A,S)) ) ).

% converse_meet
tff(fact_4035_acyclicI__order,axiom,
    ! [A: $tType,B: $tType] :
      ( preorder(A)
     => ! [R3: set(product_prod(B,B)),F: fun(B,A)] :
          ( ! [A8: B,B5: B] :
              ( pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),B5),R3))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,F,B5)),aa(B,A,F,A8))) )
         => transitive_acyclic(B,R3) ) ) ).

% acyclicI_order
tff(fact_4036_acyclicI,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ! [X2: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2),transitive_trancl(A,R3)))
     => transitive_acyclic(A,R3) ) ).

% acyclicI
tff(fact_4037_acyclic__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( transitive_acyclic(A,R3)
    <=> ! [X4: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),X4),transitive_trancl(A,R3))) ) ).

% acyclic_def
tff(fact_4038_cyclicE,axiom,
    ! [A: $tType,G: set(product_prod(A,A))] :
      ( ~ transitive_acyclic(A,G)
     => ~ ! [X2: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2),transitive_trancl(A,G))) ) ).

% cyclicE
tff(fact_4039_AboveS__disjoint,axiom,
    ! [A: $tType,A4: set(A),R3: set(product_prod(A,A))] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),order_AboveS(A,R3,A4)) = bot_bot(set(A)) ) ).

% AboveS_disjoint
tff(fact_4040_Least__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [P: fun(A,bool)] : ( ord_Least(A,P) = the(A,aTP_Lamp_pb(fun(A,bool),fun(A,bool),P)) ) ) ).

% Least_def
tff(fact_4041_acyclic__insert__cyclic,axiom,
    ! [A: $tType,G: set(product_prod(A,A)),X: A,Y: A] :
      ( transitive_acyclic(A,G)
     => ( ~ transitive_acyclic(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y)),G))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),X),transitive_rtrancl(A,G))) ) ) ).

% acyclic_insert_cyclic
tff(fact_4042_Greatest__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool)] : ( order_Greatest(A,P) = the(A,aTP_Lamp_pc(fun(A,bool),fun(A,bool),P)) ) ) ).

% Greatest_def
tff(fact_4043_wo__rel_Osuc__greater,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B3: set(A),B2: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
       => ( ( order_AboveS(A,R3,B3) != bot_bot(set(A)) )
         => ( pp(member(A,B2,B3))
           => ( ( bNF_Wellorder_wo_suc(A,R3,B3) != B2 )
              & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),bNF_Wellorder_wo_suc(A,R3,B3)),R3)) ) ) ) ) ) ).

% wo_rel.suc_greater
tff(fact_4044_wo__rel_Osuc__ofilter__in,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A),B2: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( order_ofilter(A,R3,A4)
       => ( ( order_AboveS(A,R3,A4) != bot_bot(set(A)) )
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),bNF_Wellorder_wo_suc(A,R3,A4)),R3))
           => ( ( B2 != bNF_Wellorder_wo_suc(A,R3,A4) )
             => pp(member(A,B2,A4)) ) ) ) ) ) ).

% wo_rel.suc_ofilter_in
tff(fact_4045_wo__rel_Osuc__AboveS,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B3: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
       => ( ( order_AboveS(A,R3,B3) != bot_bot(set(A)) )
         => pp(member(A,bNF_Wellorder_wo_suc(A,R3,B3),order_AboveS(A,R3,B3))) ) ) ) ).

% wo_rel.suc_AboveS
tff(fact_4046_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),X: A,Q: fun(A,bool)] :
          ( pp(aa(A,bool,P,X))
         => ( ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X)) )
           => ( ! [X2: A] :
                  ( pp(aa(A,bool,P,X2))
                 => ( ! [Y4: A] :
                        ( pp(aa(A,bool,P,Y4))
                       => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y4),X2)) )
                   => pp(aa(A,bool,Q,X2)) ) )
             => pp(aa(A,bool,Q,order_Greatest(A,P))) ) ) ) ) ).

% GreatestI2_order
tff(fact_4047_Greatest__equality,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,bool),X: A] :
          ( pp(aa(A,bool,P,X))
         => ( ! [Y2: A] :
                ( pp(aa(A,bool,P,Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y2),X)) )
           => ( order_Greatest(A,P) = X ) ) ) ) ).

% Greatest_equality
tff(fact_4048_wo__rel_Osuc__least__AboveS,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B3: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(member(A,A3,order_AboveS(A,R3,B3)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),bNF_Wellorder_wo_suc(A,R3,B3)),A3),R3)) ) ) ).

% wo_rel.suc_least_AboveS
tff(fact_4049_wo__rel_Oequals__suc__AboveS,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B3: set(A),A3: A] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
       => ( pp(member(A,A3,order_AboveS(A,R3,B3)))
         => ( ! [A9: A] :
                ( pp(member(A,A9,order_AboveS(A,R3,B3)))
               => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),A9),R3)) )
           => ( A3 = bNF_Wellorder_wo_suc(A,R3,B3) ) ) ) ) ) ).

% wo_rel.equals_suc_AboveS
tff(fact_4050_wo__rel_Osuc__inField,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B3: set(A)] :
      ( bNF_Wellorder_wo_rel(A,R3)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),field2(A,R3)))
       => ( ( order_AboveS(A,R3,B3) != bot_bot(set(A)) )
         => pp(member(A,bNF_Wellorder_wo_suc(A,R3,B3),field2(A,R3))) ) ) ) ).

% wo_rel.suc_inField
tff(fact_4051_ord_OLeast__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),P: fun(A,bool)] : ( aa(fun(A,bool),A,least(A,Less_eq),P) = the(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_pd(fun(A,fun(A,bool)),fun(fun(A,bool),fun(A,bool)),Less_eq),P)) ) ).

% ord.Least_def
tff(fact_4052_fun_Orel__compp__Grp,axiom,
    ! [D: $tType,B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( bNF_rel_fun(D,D,A,B,fequal(D),R) = relcompp(fun(D,A),fun(D,product_prod(A,B)),fun(D,B),conversep(fun(D,product_prod(A,B)),fun(D,A),bNF_Grp(fun(D,product_prod(A,B)),fun(D,A),aa(fun(fun(D,product_prod(A,B)),bool),set(fun(D,product_prod(A,B))),collect(fun(D,product_prod(A,B))),aTP_Lamp_gr(fun(A,fun(B,bool)),fun(fun(D,product_prod(A,B)),bool),R)),aa(fun(product_prod(A,B),A),fun(fun(D,product_prod(A,B)),fun(D,A)),comp(product_prod(A,B),A,D),product_fst(A,B)))),bNF_Grp(fun(D,product_prod(A,B)),fun(D,B),aa(fun(fun(D,product_prod(A,B)),bool),set(fun(D,product_prod(A,B))),collect(fun(D,product_prod(A,B))),aTP_Lamp_gr(fun(A,fun(B,bool)),fun(fun(D,product_prod(A,B)),bool),R)),aa(fun(product_prod(A,B),B),fun(fun(D,product_prod(A,B)),fun(D,B)),comp(product_prod(A,B),B,D),product_snd(A,B)))) ) ).

% fun.rel_compp_Grp
tff(fact_4053_init__seg__of__def,axiom,
    ! [A: $tType] : ( init_seg_of(A) = aa(fun(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),bool),set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),collect(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),aa(fun(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool)),fun(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),bool),product_case_prod(set(product_prod(A,A)),set(product_prod(A,A)),bool),aTP_Lamp_pe(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool)))) ) ).

% init_seg_of_def
tff(fact_4054_inf__filter__def,axiom,
    ! [A: $tType,F2: filter(A),F3: filter(A)] : ( aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F2),F3) = abs_filter(A,aa(filter(A),fun(fun(A,bool),bool),aTP_Lamp_pf(filter(A),fun(filter(A),fun(fun(A,bool),bool)),F2),F3)) ) ).

% inf_filter_def
tff(fact_4055_relcompp__bot1,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: fun(C,fun(B,bool))] : ( relcompp(A,C,B,bot_bot(fun(A,fun(C,bool))),R) = bot_bot(fun(A,fun(B,bool))) ) ).

% relcompp_bot1
tff(fact_4056_relcompp__bot2,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: fun(A,fun(C,bool))] : ( relcompp(A,C,B,R,bot_bot(fun(C,fun(B,bool)))) = bot_bot(fun(A,fun(B,bool))) ) ).

% relcompp_bot2
tff(fact_4057_ord_OLeast_Ocong,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool))] : ( least(A,Less_eq) = least(A,Less_eq) ) ).

% ord.Least.cong
tff(fact_4058_refl__on__init__seg__of,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),R3),init_seg_of(A))) ).

% refl_on_init_seg_of
tff(fact_4059_antisym__init__seg__of,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),S),init_seg_of(A)))
     => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),S),R3),init_seg_of(A)))
       => ( R3 = S ) ) ) ).

% antisym_init_seg_of
tff(fact_4060_trans__init__seg__of,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),S: set(product_prod(A,A)),T4: set(product_prod(A,A))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),S),init_seg_of(A)))
     => ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),S),T4),init_seg_of(A)))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),T4),init_seg_of(A))) ) ) ).

% trans_init_seg_of
tff(fact_4061_bot__filter__def,axiom,
    ! [A: $tType] : ( bot_bot(filter(A)) = abs_filter(A,aTP_Lamp_pg(fun(A,bool),bool)) ) ).

% bot_filter_def
tff(fact_4062_relcompp__relcomp__eq,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set(product_prod(A,B)),S: set(product_prod(B,C)),X3: A,Xa3: C] :
      ( pp(aa(C,bool,aa(A,fun(C,bool),relcompp(A,B,C,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),R3),aTP_Lamp_ph(set(product_prod(B,C)),fun(B,fun(C,bool)),S)),X3),Xa3))
    <=> pp(member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),X3),Xa3),relcomp(A,B,C,R3,S))) ) ).

% relcompp_relcomp_eq
tff(fact_4063_relcomp__def,axiom,
    ! [A: $tType,C: $tType,B: $tType,X3: set(product_prod(A,B)),Xa3: set(product_prod(B,C))] : ( relcomp(A,B,C,X3,Xa3) = aa(fun(product_prod(A,C),bool),set(product_prod(A,C)),collect(product_prod(A,C)),aa(fun(A,fun(C,bool)),fun(product_prod(A,C),bool),product_case_prod(A,C,bool),relcompp(A,B,C,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),X3),aTP_Lamp_ph(set(product_prod(B,C)),fun(B,fun(C,bool)),Xa3)))) ) ).

% relcomp_def
tff(fact_4064_Chains__init__seg__of__Union,axiom,
    ! [A: $tType,R: set(set(product_prod(A,A))),R3: set(product_prod(A,A))] :
      ( pp(member(set(set(product_prod(A,A))),R,chains(set(product_prod(A,A)),init_seg_of(A))))
     => ( pp(member(set(product_prod(A,A)),R3,R))
       => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),R3),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),R)),init_seg_of(A))) ) ) ).

% Chains_init_seg_of_Union
tff(fact_4065_initial__segment__of__Diff,axiom,
    ! [A: $tType,P3: set(product_prod(A,A)),Q3: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),P3),Q3),init_seg_of(A)))
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),product_Pair(set(product_prod(A,A)),set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),P3),S)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),Q3),S)),init_seg_of(A))) ) ).

% initial_segment_of_Diff
tff(fact_4066_irrefl__tranclI,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X: A] :
      ( ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),converse(A,A,R3)),transitive_rtrancl(A,R3)) = bot_bot(set(product_prod(A,A))) )
     => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),X),transitive_trancl(A,R3))) ) ).

% irrefl_tranclI
tff(fact_4067_su__rel__fun_Of__def,axiom,
    ! [B: $tType,A: $tType,F2: set(product_prod(A,B)),F: fun(A,B),A4: A] :
      ( su_rel_fun(A,B,F2,F)
     => ( aa(A,B,F,A4) = the(B,aa(A,fun(B,bool),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),F2),A4)) ) ) ).

% su_rel_fun.f_def
tff(fact_4068_su__rel__fun_Ointro,axiom,
    ! [B: $tType,A: $tType,F2: set(product_prod(A,B)),F: fun(A,B)] :
      ( ! [A12: A,B9: B,B13: B] :
          ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A12),B9),F2))
         => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A12),B13),F2))
           => ( B9 = B13 ) ) )
     => ( ! [A12: A,P5: bool] :
            ( ! [B14: B] :
                ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A12),B14),F2))
               => pp(P5) )
           => pp(P5) )
       => ( ! [A12: A] : ( aa(A,B,F,A12) = the(B,aa(A,fun(B,bool),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),F2),A12)) )
         => su_rel_fun(A,B,F2,F) ) ) ) ).

% su_rel_fun.intro
tff(fact_4069_su__rel__fun__def,axiom,
    ! [B: $tType,A: $tType,F2: set(product_prod(A,B)),F: fun(A,B)] :
      ( su_rel_fun(A,B,F2,F)
    <=> ( ! [A11: A,B8: B,B15: B] :
            ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A11),B8),F2))
           => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A11),B15),F2))
             => ( B8 = B15 ) ) )
        & ! [A11: A,P4: bool] :
            ( ! [B8: B] :
                ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A11),B8),F2))
               => pp(P4) )
           => pp(P4) )
        & ! [A11: A] : ( aa(A,B,F,A11) = the(B,aa(A,fun(B,bool),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),F2),A11)) ) ) ) ).

% su_rel_fun_def
tff(fact_4070_converse__iff,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,R3: set(product_prod(B,A))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),converse(B,A,R3)))
    <=> pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),B2),A3),R3)) ) ).

% converse_iff
tff(fact_4071_converse__empty,axiom,
    ! [B: $tType,A: $tType] : ( converse(B,A,bot_bot(set(product_prod(B,A)))) = bot_bot(set(product_prod(A,B))) ) ).

% converse_empty
tff(fact_4072_converse_Ocases,axiom,
    ! [B: $tType,A: $tType,A1: B,A22: A,R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),A1),A22),converse(A,B,R3)))
     => pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A22),A1),R3)) ) ).

% converse.cases
tff(fact_4073_converse_Osimps,axiom,
    ! [B: $tType,A: $tType,A1: B,A22: A,R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),A1),A22),converse(A,B,R3)))
    <=> ? [A6: A,B6: B] :
          ( ( A1 = B6 )
          & ( A22 = A6 )
          & pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A6),B6),R3)) ) ) ).

% converse.simps
tff(fact_4074_converseD,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,R3: set(product_prod(B,A))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),converse(B,A,R3)))
     => pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),B2),A3),R3)) ) ).

% converseD
tff(fact_4075_converseE,axiom,
    ! [A: $tType,B: $tType,Yx: product_prod(A,B),R3: set(product_prod(B,A))] :
      ( pp(member(product_prod(A,B),Yx,converse(B,A,R3)))
     => ~ ! [X2: B,Y2: A] :
            ( ( Yx = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Y2),X2) )
           => ~ pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X2),Y2),R3)) ) ) ).

% converseE
tff(fact_4076_converseI,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),R3))
     => pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),B2),A3),converse(A,B,R3))) ) ).

% converseI
tff(fact_4077_converse__Int,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(B,A)),S: set(product_prod(B,A))] : ( converse(B,A,aa(set(product_prod(B,A)),set(product_prod(B,A)),aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),set(product_prod(B,A))),inf_inf(set(product_prod(B,A))),R3),S)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),converse(B,A,R3)),converse(B,A,S)) ) ).

% converse_Int
tff(fact_4078_rtrancl__converseD,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,converse(A,A,R3))))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),X),transitive_rtrancl(A,R3))) ) ).

% rtrancl_converseD
tff(fact_4079_rtrancl__converseI,axiom,
    ! [A: $tType,Y: A,X: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),X),transitive_rtrancl(A,R3)))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,converse(A,A,R3)))) ) ).

% rtrancl_converseI
tff(fact_4080_trancl__converseI,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),converse(A,A,transitive_trancl(A,R3))))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_trancl(A,converse(A,A,R3)))) ) ).

% trancl_converseI
tff(fact_4081_trancl__converseD,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_trancl(A,converse(A,A,R3))))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),converse(A,A,transitive_trancl(A,R3)))) ) ).

% trancl_converseD
tff(fact_4082_su__rel__fun_Osurjective,axiom,
    ! [B: $tType,A: $tType,F2: set(product_prod(A,B)),F: fun(A,B),A4: A] :
      ( su_rel_fun(A,B,F2,F)
     => ~ ! [B9: B] : ~ pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B9),F2)) ) ).

% su_rel_fun.surjective
tff(fact_4083_su__rel__fun_Ounique,axiom,
    ! [A: $tType,B: $tType,F2: set(product_prod(A,B)),F: fun(A,B),A4: A,B3: B,B16: B] :
      ( su_rel_fun(A,B,F2,F)
     => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3),F2))
       => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B16),F2))
         => ( B3 = B16 ) ) ) ) ).

% su_rel_fun.unique
tff(fact_4084_su__rel__fun_Orepr2,axiom,
    ! [B: $tType,A: $tType,F2: set(product_prod(A,B)),F: fun(A,B),A4: A,B3: B] :
      ( su_rel_fun(A,B,F2,F)
     => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3),F2))
       => ( B3 = aa(A,B,F,A4) ) ) ) ).

% su_rel_fun.repr2
tff(fact_4085_su__rel__fun_Orepr1,axiom,
    ! [B: $tType,A: $tType,F2: set(product_prod(A,B)),F: fun(A,B),A4: A] :
      ( su_rel_fun(A,B,F2,F)
     => pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),aa(A,B,F,A4)),F2)) ) ).

% su_rel_fun.repr1
tff(fact_4086_su__rel__fun_Orepr,axiom,
    ! [B: $tType,A: $tType,F2: set(product_prod(A,B)),F: fun(A,B),A4: A,B3: B] :
      ( su_rel_fun(A,B,F2,F)
     => ( ( aa(A,B,F,A4) = B3 )
      <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A4),B3),F2)) ) ) ).

% su_rel_fun.repr
tff(fact_4087_converse__unfold,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(B,A))] : ( converse(B,A,R3) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_pi(set(product_prod(B,A)),fun(A,fun(B,bool)),R3))) ) ).

% converse_unfold
tff(fact_4088_conversep__converse__eq,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B)),X3: B,Xa3: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),conversep(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),R3)),X3),Xa3))
    <=> pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X3),Xa3),converse(A,B,R3))) ) ).

% conversep_converse_eq
tff(fact_4089_converse__def,axiom,
    ! [B: $tType,A: $tType,X3: set(product_prod(A,B))] : ( converse(A,B,X3) = aa(fun(product_prod(B,A),bool),set(product_prod(B,A)),collect(product_prod(B,A)),aa(fun(B,fun(A,bool)),fun(product_prod(B,A),bool),product_case_prod(B,A,bool),conversep(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),X3)))) ) ).

% converse_def
tff(fact_4090_trans__wf__iff,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( trans(A,R3)
     => ( wf(A,R3)
      <=> ! [A6: A] : wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,image(A,A,converse(A,A,R3),aa(set(A),set(A),insert2(A,A6),bot_bot(set(A)))),aa(A,fun(A,set(A)),aTP_Lamp_pj(set(product_prod(A,A)),fun(A,fun(A,set(A))),R3),A6)))) ) ) ).

% trans_wf_iff
tff(fact_4091_Image__INT__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType,R3: set(product_prod(B,A)),A4: set(C),B3: fun(C,set(B))] :
      ( single_valued(A,B,converse(B,A,R3))
     => ( ( A4 != bot_bot(set(C)) )
       => ( image(B,A,R3,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B3),A4))) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_pk(set(product_prod(B,A)),fun(fun(C,set(B)),fun(C,set(A))),R3),B3)),A4)) ) ) ) ).

% Image_INT_eq
tff(fact_4092_ord__to__filter__compat,axiom,
    ! [A: $tType,R0: set(product_prod(A,A))] : bNF_Wellorder_compat(set(product_prod(A,A)),set(A),aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),aa(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),fun(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))),set(product_prod(set(product_prod(A,A)),set(product_prod(A,A))))),inf_inf(set(product_prod(set(product_prod(A,A)),set(product_prod(A,A))))),bNF_We4044943003108391690rdLess(A,A)),product_Sigma(set(product_prod(A,A)),set(product_prod(A,A)),image(set(product_prod(A,A)),set(product_prod(A,A)),converse(set(product_prod(A,A)),set(product_prod(A,A)),bNF_We4044943003108391690rdLess(A,A)),aa(set(set(product_prod(A,A))),set(set(product_prod(A,A))),insert2(set(product_prod(A,A)),R0),bot_bot(set(set(product_prod(A,A)))))),aTP_Lamp_pl(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(set(product_prod(A,A)))),R0))),bNF_We413866401316099525erIncl(A,R0),bNF_We8469521843155493636filter(A,R0)) ).

% ord_to_filter_compat
tff(fact_4093_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(nat,nat)] :
      ( ( nat_prod_decode_aux(X,Xa) = Y )
     => ( pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa)))
       => ~ ( ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Xa),X))
               => ( Y = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Xa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),Xa)) ) )
              & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Xa),X))
               => ( Y = nat_prod_decode_aux(aa(nat,nat,suc,X),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),aa(nat,nat,suc,X))) ) ) )
           => ~ pp(aa(product_prod(nat,nat),bool,accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa))) ) ) ) ).

% prod_decode_aux.pelims
tff(fact_4094_trans__empty,axiom,
    ! [A: $tType] : trans(A,bot_bot(set(product_prod(A,A)))) ).

% trans_empty
tff(fact_4095_trans__Int,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( trans(A,R3)
     => ( trans(A,S)
       => trans(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),S)) ) ) ).

% trans_Int
tff(fact_4096_transD,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X: A,Y: A,Z2: A] :
      ( trans(A,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
       => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),Z2),R3))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),R3)) ) ) ) ).

% transD
tff(fact_4097_transE,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X: A,Y: A,Z2: A] :
      ( trans(A,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
       => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),Z2),R3))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),R3)) ) ) ) ).

% transE
tff(fact_4098_transI,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ! [X2: A,Y2: A,Z3: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),R3))
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z3),R3))
           => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Z3),R3)) ) )
     => trans(A,R3) ) ).

% transI
tff(fact_4099_trans__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( trans(A,R3)
    <=> ! [X4: A,Y3: A,Z4: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Y3),R3))
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y3),Z4),R3))
           => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Z4),R3)) ) ) ) ).

% trans_def
tff(fact_4100_single__valuedD,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,B)),X: A,Y: B,Z2: B] :
      ( single_valued(A,B,R3)
     => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y),R3))
       => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Z2),R3))
         => ( Y = Z2 ) ) ) ) ).

% single_valuedD
tff(fact_4101_single__valuedI,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B))] :
      ( ! [X2: A,Y2: B,Z3: B] :
          ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2),R3))
         => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Z3),R3))
           => ( Y2 = Z3 ) ) )
     => single_valued(A,B,R3) ) ).

% single_valuedI
tff(fact_4102_single__valued__def,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,B))] :
      ( single_valued(A,B,R3)
    <=> ! [X4: A,Y3: B] :
          ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Y3),R3))
         => ! [Z4: B] :
              ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Z4),R3))
             => ( Y3 = Z4 ) ) ) ) ).

% single_valued_def
tff(fact_4103_single__valued__empty,axiom,
    ! [B: $tType,A: $tType] : single_valued(A,B,bot_bot(set(product_prod(A,B)))) ).

% single_valued_empty
tff(fact_4104_single__valued__inter2,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S2: set(product_prod(A,B))] :
      ( single_valued(A,B,R)
     => single_valued(A,B,aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),S2),R)) ) ).

% single_valued_inter2
tff(fact_4105_single__valued__inter1,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S2: set(product_prod(A,B))] :
      ( single_valued(A,B,R)
     => single_valued(A,B,aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),R),S2)) ) ).

% single_valued_inter1
tff(fact_4106_compat__def,axiom,
    ! [A: $tType,A2: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(A2,A2)),F: fun(A,A2)] :
      ( bNF_Wellorder_compat(A,A2,R3,R4,F)
    <=> ! [A6: A,B6: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),B6),R3))
         => pp(member(product_prod(A2,A2),aa(A2,product_prod(A2,A2),aa(A2,fun(A2,product_prod(A2,A2)),product_Pair(A2,A2),aa(A,A2,F,A6)),aa(A,A2,F,B6)),R4)) ) ) ).

% compat_def
tff(fact_4107_trans__Restr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A4: set(A)] :
      ( trans(A,R3)
     => trans(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),product_Sigma(A,A,A4,aTP_Lamp_if(set(A),fun(A,set(A)),A4)))) ) ).

% trans_Restr
tff(fact_4108_single__valued__confluent,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X: A,Y: A,Z2: A] :
      ( single_valued(A,A,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,R3)))
       => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),transitive_rtrancl(A,R3)))
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),Z2),transitive_rtrancl(A,R3)))
            | pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z2),Y),transitive_rtrancl(A,R3))) ) ) ) ) ).

% single_valued_confluent
tff(fact_4109_under__incr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( trans(A,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
       => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),order_under(A,R3,A3)),order_under(A,R3,B2))) ) ) ).

% under_incr
tff(fact_4110_trans__singleton,axiom,
    ! [A: $tType,A3: A] : trans(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),A3)),bot_bot(set(product_prod(A,A))))) ).

% trans_singleton
tff(fact_4111_trans__join,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( trans(A,R3)
    <=> ! [X4: product_prod(A,A)] :
          ( pp(member(product_prod(A,A),X4,R3))
         => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aTP_Lamp_pn(set(product_prod(A,A)),fun(A,fun(A,bool)),R3)),X4)) ) ) ).

% trans_join
tff(fact_4112_prod__decode__aux_Ocases,axiom,
    ! [X: product_prod(nat,nat)] :
      ~ ! [K2: nat,M5: nat] : ( X != aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),K2),M5) ) ).

% prod_decode_aux.cases
tff(fact_4113_underS__incr,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A,B2: A] :
      ( trans(A,R3)
     => ( antisym(A,R3)
       => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
         => pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),order_underS(A,R3,A3)),order_underS(A,R3,B2))) ) ) ) ).

% underS_incr
tff(fact_4114_Image__Int__eq,axiom,
    ! [A: $tType,B: $tType,R: set(product_prod(B,A)),A4: set(B),B3: set(B)] :
      ( single_valued(A,B,converse(B,A,R))
     => ( image(B,A,R,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),image(B,A,R,A4)),image(B,A,R,B3)) ) ) ).

% Image_Int_eq
tff(fact_4115_prod__decode__aux_Osimps,axiom,
    ! [M4: nat,K: nat] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),K))
       => ( nat_prod_decode_aux(K,M4) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),M4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),M4)) ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),K))
       => ( nat_prod_decode_aux(K,M4) = nat_prod_decode_aux(aa(nat,nat,suc,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),aa(nat,nat,suc,K))) ) ) ) ).

% prod_decode_aux.simps
tff(fact_4116_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(nat,nat)] :
      ( ( nat_prod_decode_aux(X,Xa) = Y )
     => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Xa),X))
         => ( Y = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Xa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),Xa)) ) )
        & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Xa),X))
         => ( Y = nat_prod_decode_aux(aa(nat,nat,suc,X),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),aa(nat,nat,suc,X))) ) ) ) ) ).

% prod_decode_aux.elims
tff(fact_4117_wf__finite__segments,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( irrefl(A,R3)
     => ( trans(A,R3)
       => ( ! [X2: A] : pp(aa(set(A),bool,finite_finite(A),aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_nm(set(product_prod(A,A)),fun(A,fun(A,bool)),R3),X2))))
         => wf(A,R3) ) ) ) ).

% wf_finite_segments
tff(fact_4118_single__valuedp__single__valued__eq,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B))] :
      ( single_valuedp(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),R3))
    <=> single_valued(A,B,R3) ) ).

% single_valuedp_single_valued_eq
tff(fact_4119_set__encode__empty,axiom,
    nat_set_encode(bot_bot(set(nat))) = zero_zero(nat) ).

% set_encode_empty
tff(fact_4120_aboveS__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),A3: A] : ( order_aboveS(A,R3,A3) = aa(fun(A,bool),set(A),collect(A),aa(A,fun(A,bool),aTP_Lamp_po(set(product_prod(A,A)),fun(A,fun(A,bool)),R3),A3)) ) ).

% aboveS_def
tff(fact_4121_irrefl__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( irrefl(A,R3)
    <=> ! [A6: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),A6),R3)) ) ).

% irrefl_def
tff(fact_4122_irreflI,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( ! [A8: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A8),A8),R))
     => irrefl(A,R) ) ).

% irreflI
tff(fact_4123_single__valuedp__bot,axiom,
    ! [B: $tType,A: $tType] : single_valuedp(A,B,bot_bot(fun(A,fun(B,bool)))) ).

% single_valuedp_bot
tff(fact_4124_relInvImage__def,axiom,
    ! [B: $tType,A: $tType,A4: set(A),R: set(product_prod(B,B)),F: fun(A,B)] : ( bNF_Gr7122648621184425601vImage(A,B,A4,R,F) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,B),fun(product_prod(A,A),bool),aa(set(product_prod(B,B)),fun(fun(A,B),fun(product_prod(A,A),bool)),aTP_Lamp_pp(set(A),fun(set(product_prod(B,B)),fun(fun(A,B),fun(product_prod(A,A),bool))),A4),R),F)) ) ).

% relInvImage_def
tff(fact_4125_Heap__lub__empty,axiom,
    ! [A: $tType] : ( aa(set(heap_Time_Heap(A)),heap_Time_Heap(A),heap_Time_Heap_lub(A),bot_bot(set(heap_Time_Heap(A)))) = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),aTP_Lamp_mj(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))) ) ).

% Heap_lub_empty
tff(fact_4126_normalize__stable,axiom,
    ! [Q3: int,P3: int] :
      ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),Q3))
     => ( algebr8660921524188924756oprime(int,P3,Q3)
       => ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),Q3)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),Q3) ) ) ) ).

% normalize_stable
tff(fact_4127_semilattice__order__set_Osubset__imp,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: set(A),B3: set(A)] :
      ( lattic4895041142388067077er_set(A,F,Less_eq,Less)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),B3))
       => ( ( A4 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,finite_finite(A),B3))
           => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(set(A),A,lattic1715443433743089157tice_F(A,F),B3)),aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4))) ) ) ) ) ).

% semilattice_order_set.subset_imp
tff(fact_4128_coprime__mult__right__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A3: A,B2: A] :
          ( algebr8660921524188924756oprime(A,C2,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2))
        <=> ( algebr8660921524188924756oprime(A,C2,A3)
            & algebr8660921524188924756oprime(A,C2,B2) ) ) ) ).

% coprime_mult_right_iff
tff(fact_4129_coprime__mult__left__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2)
        <=> ( algebr8660921524188924756oprime(A,A3,C2)
            & algebr8660921524188924756oprime(A,B2,C2) ) ) ) ).

% coprime_mult_left_iff
tff(fact_4130_coprime__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A] :
          ( algebr8660921524188924756oprime(A,A3,A3)
        <=> pp(dvd_dvd(A,A3,one_one(A))) ) ) ).

% coprime_self
tff(fact_4131_coprime__imp__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A3,B2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) = one_one(A) ) ) ) ).

% coprime_imp_gcd_eq_1
tff(fact_4132_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A] :
          ( algebr8660921524188924756oprime(A,zero_zero(A),A3)
        <=> pp(dvd_dvd(A,A3,one_one(A))) ) ) ).

% coprime_0_left_iff
tff(fact_4133_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A] :
          ( algebr8660921524188924756oprime(A,A3,zero_zero(A))
        <=> pp(dvd_dvd(A,A3,one_one(A))) ) ) ).

% coprime_0_right_iff
tff(fact_4134_coprime__mult__self__left__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A3: A,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( pp(dvd_dvd(A,C2,one_one(A)))
            & algebr8660921524188924756oprime(A,A3,B2) ) ) ) ).

% coprime_mult_self_left_iff
tff(fact_4135_coprime__mult__self__right__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( pp(dvd_dvd(A,C2,one_one(A)))
            & algebr8660921524188924756oprime(A,A3,B2) ) ) ) ).

% coprime_mult_self_right_iff
tff(fact_4136_is__unit__gcd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2),one_one(A)))
        <=> algebr8660921524188924756oprime(A,A3,B2) ) ) ).

% is_unit_gcd
tff(fact_4137_coprime__1__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A] : algebr8660921524188924756oprime(A,A3,one_one(A)) ) ).

% coprime_1_right
tff(fact_4138_coprime__1__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A] : algebr8660921524188924756oprime(A,one_one(A),A3) ) ).

% coprime_1_left
tff(fact_4139_coprime__add__one__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A] : algebr8660921524188924756oprime(A,A3,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A))) ) ).

% coprime_add_one_right
tff(fact_4140_coprime__add__one__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A] : algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),one_one(A)),A3) ) ).

% coprime_add_one_left
tff(fact_4141_coprime__doff__one__right,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A3: A] : algebr8660921524188924756oprime(A,A3,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))) ) ).

% coprime_doff_one_right
tff(fact_4142_coprime__diff__one__left,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A3: A] : algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A)),A3) ) ).

% coprime_diff_one_left
tff(fact_4143_coprime__dvd__mult__right__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A3,C2)
         => ( pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)))
          <=> pp(dvd_dvd(A,A3,B2)) ) ) ) ).

% coprime_dvd_mult_right_iff
tff(fact_4144_coprime__dvd__mult__left__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A3,C2)
         => ( pp(dvd_dvd(A,A3,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)))
          <=> pp(dvd_dvd(A,A3,B2)) ) ) ) ).

% coprime_dvd_mult_left_iff
tff(fact_4145_divides__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,C2: A,B2: A] :
          ( pp(dvd_dvd(A,A3,C2))
         => ( pp(dvd_dvd(A,B2,C2))
           => ( algebr8660921524188924756oprime(A,A3,B2)
             => pp(dvd_dvd(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2)) ) ) ) ) ).

% divides_mult
tff(fact_4146_is__unit__right__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A3: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => algebr8660921524188924756oprime(A,A3,B2) ) ) ).

% is_unit_right_imp_coprime
tff(fact_4147_is__unit__left__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => algebr8660921524188924756oprime(A,A3,B2) ) ) ).

% is_unit_left_imp_coprime
tff(fact_4148_coprime__common__divisor,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A,C2: A] :
          ( algebr8660921524188924756oprime(A,A3,B2)
         => ( pp(dvd_dvd(A,C2,A3))
           => ( pp(dvd_dvd(A,C2,B2))
             => pp(dvd_dvd(A,C2,one_one(A))) ) ) ) ) ).

% coprime_common_divisor
tff(fact_4149_coprime__absorb__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [Y: A,X: A] :
          ( pp(dvd_dvd(A,Y,X))
         => ( algebr8660921524188924756oprime(A,X,Y)
          <=> pp(dvd_dvd(A,Y,one_one(A))) ) ) ) ).

% coprime_absorb_right
tff(fact_4150_coprime__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,D2: A,A3: A,B2: A] :
          ( algebr8660921524188924756oprime(A,C2,D2)
         => ( ! [E3: A] :
                ( ~ pp(dvd_dvd(A,E3,one_one(A)))
               => ( pp(dvd_dvd(A,E3,A3))
                 => ( pp(dvd_dvd(A,E3,B2))
                   => pp(dvd_dvd(A,E3,C2)) ) ) )
           => ( ! [E3: A] :
                  ( ~ pp(dvd_dvd(A,E3,one_one(A)))
                 => ( pp(dvd_dvd(A,E3,A3))
                   => ( pp(dvd_dvd(A,E3,B2))
                     => pp(dvd_dvd(A,E3,D2)) ) ) )
             => algebr8660921524188924756oprime(A,A3,B2) ) ) ) ) ).

% coprime_imp_coprime
tff(fact_4151_coprime__absorb__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [X: A,Y: A] :
          ( pp(dvd_dvd(A,X,Y))
         => ( algebr8660921524188924756oprime(A,X,Y)
          <=> pp(dvd_dvd(A,X,one_one(A))) ) ) ) ).

% coprime_absorb_left
tff(fact_4152_not__coprimeI,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(dvd_dvd(A,C2,A3))
         => ( pp(dvd_dvd(A,C2,B2))
           => ( ~ pp(dvd_dvd(A,C2,one_one(A)))
             => ~ algebr8660921524188924756oprime(A,A3,B2) ) ) ) ) ).

% not_coprimeI
tff(fact_4153_not__coprimeE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( ~ algebr8660921524188924756oprime(A,A3,B2)
         => ~ ! [C4: A] :
                ( pp(dvd_dvd(A,C4,A3))
               => ( pp(dvd_dvd(A,C4,B2))
                 => pp(dvd_dvd(A,C4,one_one(A))) ) ) ) ) ).

% not_coprimeE
tff(fact_4154_coprime__def,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A3,B2)
        <=> ! [C5: A] :
              ( pp(dvd_dvd(A,C5,A3))
             => ( pp(dvd_dvd(A,C5,B2))
               => pp(dvd_dvd(A,C5,one_one(A))) ) ) ) ) ).

% coprime_def
tff(fact_4155_coprimeI,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A3: A,B2: A] :
          ( ! [C4: A] :
              ( pp(dvd_dvd(A,C4,A3))
             => ( pp(dvd_dvd(A,C4,B2))
               => pp(dvd_dvd(A,C4,one_one(A))) ) )
         => algebr8660921524188924756oprime(A,A3,B2) ) ) ).

% coprimeI
tff(fact_4156_mult__mod__cancel__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel(A)
        & semiring_gcd(A) )
     => ! [A3: A,N: A,M4: A,B2: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),N),M4) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),N),M4) )
         => ( algebr8660921524188924756oprime(A,M4,N)
           => ( modulo_modulo(A,A3,M4) = modulo_modulo(A,B2,M4) ) ) ) ) ).

% mult_mod_cancel_right
tff(fact_4157_mult__mod__cancel__left,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel(A)
        & semiring_gcd(A) )
     => ! [N: A,A3: A,M4: A,B2: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),N),A3),M4) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),N),B2),M4) )
         => ( algebr8660921524188924756oprime(A,M4,N)
           => ( modulo_modulo(A,A3,M4) = modulo_modulo(A,B2,M4) ) ) ) ) ).

% mult_mod_cancel_left
tff(fact_4158_gcd__mult__right__right__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A3,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) ) ) ) ).

% gcd_mult_right_right_cancel
tff(fact_4159_gcd__mult__right__left__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A3,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) ) ) ) ).

% gcd_mult_right_left_cancel
tff(fact_4160_gcd__mult__left__right__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,C2: A,A3: A] :
          ( algebr8660921524188924756oprime(A,B2,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) ) ) ) ).

% gcd_mult_left_right_cancel
tff(fact_4161_gcd__mult__left__left__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,C2: A,A3: A] :
          ( algebr8660921524188924756oprime(A,B2,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) ) ) ) ).

% gcd_mult_left_left_cancel
tff(fact_4162_coprime__iff__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A3,B2)
        <=> ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) = one_one(A) ) ) ) ).

% coprime_iff_gcd_eq_1
tff(fact_4163_gcd__eq__1__imp__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) = one_one(A) )
         => algebr8660921524188924756oprime(A,A3,B2) ) ) ).

% gcd_eq_1_imp_coprime
tff(fact_4164_quotient__of__coprime,axiom,
    ! [R3: rat,P3: int,Q3: int] :
      ( ( quotient_of(R3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),Q3) )
     => algebr8660921524188924756oprime(int,P3,Q3) ) ).

% quotient_of_coprime
tff(fact_4165_normalize__coprime,axiom,
    ! [R3: product_prod(int,int),P3: int,Q3: int] :
      ( ( normalize(R3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),Q3) )
     => algebr8660921524188924756oprime(int,P3,Q3) ) ).

% normalize_coprime
tff(fact_4166_Inf__fin__def,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ( lattic7752659483105999362nf_fin(A) = lattic1715443433743089157tice_F(A,inf_inf(A)) ) ) ).

% Inf_fin_def
tff(fact_4167_Sup__fin__def,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ( lattic5882676163264333800up_fin(A) = lattic1715443433743089157tice_F(A,sup_sup(A)) ) ) ).

% Sup_fin_def
tff(fact_4168_invertible__coprime,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A3: A,B2: A,C2: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),C2) = one_one(A) )
         => algebr8660921524188924756oprime(A,A3,C2) ) ) ).

% invertible_coprime
tff(fact_4169_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) != zero_zero(A) )
         => ? [A9: A,B7: A] :
              ( ( A3 = aa(A,A,aa(A,fun(A,A),times_times(A),A9),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) )
              & ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),B7),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) )
              & algebr8660921524188924756oprime(A,A9,B7) ) ) ) ).

% gcd_coprime_exists
tff(fact_4170_gcd__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,A5: A,B4: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) != zero_zero(A) )
         => ( ( A3 = aa(A,A,aa(A,fun(A,A),times_times(A),A5),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) )
           => ( ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),B4),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) )
             => algebr8660921524188924756oprime(A,A5,B4) ) ) ) ) ).

% gcd_coprime
tff(fact_4171_semilattice__order__set_Obounded__iff,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: set(A),X: A] :
      ( lattic4895041142388067077er_set(A,F,Less_eq,Less)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( ( A4 != bot_bot(set(A)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X),aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4)))
          <=> ! [X4: A] :
                ( pp(member(A,X4,A4))
               => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X),X4)) ) ) ) ) ) ).

% semilattice_order_set.bounded_iff
tff(fact_4172_semilattice__order__set_OboundedI,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: set(A),X: A] :
      ( lattic4895041142388067077er_set(A,F,Less_eq,Less)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( ( A4 != bot_bot(set(A)) )
         => ( ! [A8: A] :
                ( pp(member(A,A8,A4))
               => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X),A8)) )
           => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X),aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4))) ) ) ) ) ).

% semilattice_order_set.boundedI
tff(fact_4173_semilattice__order__set_OboundedE,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A4: set(A),X: A] :
      ( lattic4895041142388067077er_set(A,F,Less_eq,Less)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( ( A4 != bot_bot(set(A)) )
         => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X),aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4)))
           => ! [A13: A] :
                ( pp(member(A,A13,A4))
               => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,X),A13)) ) ) ) ) ) ).

% semilattice_order_set.boundedE
tff(fact_4174_semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A4: set(A),X: A] :
      ( lattic149705377957585745ce_set(A,F)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) )
           => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F),aa(set(A),set(A),insert2(A,X),A4)) = X ) )
          & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F),aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),F,X),aa(set(A),A,lattic1715443433743089157tice_F(A,F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ).

% semilattice_set.insert_remove
tff(fact_4175_semilattice__set_Oremove,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A4: set(A),X: A] :
      ( lattic149705377957585745ce_set(A,F)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( pp(member(A,X,A4))
         => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) )
             => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4) = X ) )
            & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4) = aa(A,A,aa(A,fun(A,A),F,X),aa(set(A),A,lattic1715443433743089157tice_F(A,F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ) ).

% semilattice_set.remove
tff(fact_4176_semilattice__set_Ounion,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A4: set(A),B3: set(A)] :
      ( lattic149705377957585745ce_set(A,F)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( ( A4 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,finite_finite(A),B3))
           => ( ( B3 != bot_bot(set(A)) )
             => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(A,A,aa(A,fun(A,A),F,aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4)),aa(set(A),A,lattic1715443433743089157tice_F(A,F),B3)) ) ) ) ) ) ) ).

% semilattice_set.union
tff(fact_4177_semilattice__set_Oinsert__not__elem,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A4: set(A),X: A] :
      ( lattic149705377957585745ce_set(A,F)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( ~ pp(member(A,X,A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F),aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),F,X),aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4)) ) ) ) ) ) ).

% semilattice_set.insert_not_elem
tff(fact_4178_Sup__fin_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => lattic149705377957585745ce_set(A,sup_sup(A)) ) ).

% Sup_fin.semilattice_set_axioms
tff(fact_4179_Inf__fin_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => lattic149705377957585745ce_set(A,inf_inf(A)) ) ).

% Inf_fin.semilattice_set_axioms
tff(fact_4180_semilattice__set_Osingleton,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),X: A] :
      ( lattic149705377957585745ce_set(A,F)
     => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = X ) ) ).

% semilattice_set.singleton
tff(fact_4181_semilattice__set_Ohom__commute,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),H2: fun(A,A),N4: set(A)] :
      ( lattic149705377957585745ce_set(A,F)
     => ( ! [X2: A,Y2: A] : ( aa(A,A,H2,aa(A,A,aa(A,fun(A,A),F,X2),Y2)) = aa(A,A,aa(A,fun(A,A),F,aa(A,A,H2,X2)),aa(A,A,H2,Y2)) )
       => ( pp(aa(set(A),bool,finite_finite(A),N4))
         => ( ( N4 != bot_bot(set(A)) )
           => ( aa(A,A,H2,aa(set(A),A,lattic1715443433743089157tice_F(A,F),N4)) = aa(set(A),A,lattic1715443433743089157tice_F(A,F),aa(set(A),set(A),image2(A,A,H2),N4)) ) ) ) ) ) ).

% semilattice_set.hom_commute
tff(fact_4182_semilattice__set_Osubset,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A4: set(A),B3: set(A)] :
      ( lattic149705377957585745ce_set(A,F)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( ( B3 != bot_bot(set(A)) )
         => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A4))
           => ( aa(A,A,aa(A,fun(A,A),F,aa(set(A),A,lattic1715443433743089157tice_F(A,F),B3)),aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4)) = aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4) ) ) ) ) ) ).

% semilattice_set.subset
tff(fact_4183_semilattice__set_Oclosed,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A4: set(A)] :
      ( lattic149705377957585745ce_set(A,F)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( ( A4 != bot_bot(set(A)) )
         => ( ! [X2: A,Y2: A] : pp(member(A,aa(A,A,aa(A,fun(A,A),F,X2),Y2),aa(set(A),set(A),insert2(A,X2),aa(set(A),set(A),insert2(A,Y2),bot_bot(set(A))))))
           => pp(member(A,aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4),A4)) ) ) ) ) ).

% semilattice_set.closed
tff(fact_4184_semilattice__set_Oinsert,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A4: set(A),X: A] :
      ( lattic149705377957585745ce_set(A,F)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( ( A4 != bot_bot(set(A)) )
         => ( aa(set(A),A,lattic1715443433743089157tice_F(A,F),aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),F,X),aa(set(A),A,lattic1715443433743089157tice_F(A,F),A4)) ) ) ) ) ).

% semilattice_set.insert
tff(fact_4185_prod_OatLeastLessThan__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(A)
        & ord(B) )
     => ! [H2: fun(nat,B),M4: nat,N: nat,G: fun(B,A)] :
          ( bij_betw(nat,B,H2,set_or7035219750837199246ssThan(nat,M4,N),set_or7035219750837199246ssThan(B,aa(nat,B,H2,M4),aa(nat,B,H2,N)))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),set_or7035219750837199246ssThan(B,aa(nat,B,H2,M4),aa(nat,B,H2,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,B),fun(nat,A),aa(fun(B,A),fun(fun(nat,B),fun(nat,A)),comp(B,A,nat),G),H2)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ) ).

% prod.atLeastLessThan_reindex
tff(fact_4186_antisymp__antisym__eq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( antisymp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3))
    <=> antisym(A,R3) ) ).

% antisymp_antisym_eq
tff(fact_4187_prod_OatLeastAtMost__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(A)
        & ord(B) )
     => ! [H2: fun(nat,B),M4: nat,N: nat,G: fun(B,A)] :
          ( bij_betw(nat,B,H2,set_or1337092689740270186AtMost(nat,M4,N),set_or1337092689740270186AtMost(B,aa(nat,B,H2,M4),aa(nat,B,H2,N)))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),set_or1337092689740270186AtMost(B,aa(nat,B,H2,M4),aa(nat,B,H2,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,B),fun(nat,A),aa(fun(B,A),fun(fun(nat,B),fun(nat,A)),comp(B,A,nat),G),H2)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ) ).

% prod.atLeastAtMost_reindex
tff(fact_4188_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) )
             => ( lattic643756798349783984er_Max(A,aa(set(A),set(A),insert2(A,X),A4)) = X ) )
            & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) != bot_bot(set(A)) )
             => ( lattic643756798349783984er_Max(A,aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),ord_max(A),X),lattic643756798349783984er_Max(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ).

% Max.insert_remove
tff(fact_4189_max_Oright__idem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2)),B2) = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) ) ) ).

% max.right_idem
tff(fact_4190_max_Oleft__idem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) ) ) ).

% max.left_idem
tff(fact_4191_max_Oidem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),A3) = A3 ) ) ).

% max.idem
tff(fact_4192_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A3))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3)) ) ) ) ).

% max.bounded_iff
tff(fact_4193_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = B2 ) ) ) ).

% max.absorb2
tff(fact_4194_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = A3 ) ) ) ).

% max.absorb1
tff(fact_4195_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = A3 ) ) ) ).

% max.absorb3
tff(fact_4196_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),B2))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = B2 ) ) ) ).

% max.absorb4
tff(fact_4197_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A,Z2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)),Z2))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X),Z2))
            & pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Y),Z2)) ) ) ) ).

% max_less_iff_conj
tff(fact_4198_max__bot2,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),X),bot_bot(A)) = X ) ) ).

% max_bot2
tff(fact_4199_max__bot,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),bot_bot(A)),X) = X ) ) ).

% max_bot
tff(fact_4200_max__top,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),top_top(A)),X) = top_top(A) ) ) ).

% max_top
tff(fact_4201_max__top2,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [X: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),X),top_top(A)) = top_top(A) ) ) ).

% max_top2
tff(fact_4202_max__min__same_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,X: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),Y),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)) = Y ) ) ).

% max_min_same(4)
tff(fact_4203_max__min__same_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),Y) = Y ) ) ).

% max_min_same(3)
tff(fact_4204_max__min__same_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),X) = X ) ) ).

% max_min_same(2)
tff(fact_4205_max__min__same_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),X),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)) = X ) ) ).

% max_min_same(1)
tff(fact_4206_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),zero_zero(A)),one_one(A)) = one_one(A) ) ) ).

% max_0_1(1)
tff(fact_4207_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),zero_zero(A)) = one_one(A) ) ) ).

% max_0_1(2)
tff(fact_4208_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),X)),one_one(A)) = aa(num,A,numeral_numeral(A),X) ) ) ).

% max_0_1(6)
tff(fact_4209_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [X: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),aa(num,A,numeral_numeral(A),X)) = aa(num,A,numeral_numeral(A),X) ) ) ).

% max_0_1(5)
tff(fact_4210_Int__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,A3,B2)),set_or1337092689740270186AtMost(A,C2,D2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A3),C2),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),D2)) ) ) ).

% Int_atLeastAtMost
tff(fact_4211_Int__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or7035219750837199246ssThan(A,A3,B2)),set_or7035219750837199246ssThan(A,C2,D2)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A3),C2),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),D2)) ) ) ).

% Int_atLeastLessThan
tff(fact_4212_Int__atLeastAtMostR2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,C2: A,D2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_atLeast(A,A3)),set_or1337092689740270186AtMost(A,C2,D2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A3),C2),D2) ) ) ).

% Int_atLeastAtMostR2
tff(fact_4213_Int__atLeastAtMostL2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or1337092689740270186AtMost(A,A3,B2)),set_ord_atLeast(A,C2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A3),C2),B2) ) ) ).

% Int_atLeastAtMostL2
tff(fact_4214_Int__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,A3,B2)),set_or3652927894154168847AtMost(A,C2,D2)) = set_or3652927894154168847AtMost(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A3),C2),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),D2)) ) ) ).

% Int_greaterThanAtMost
tff(fact_4215_Int__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A,D2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or5935395276787703475ssThan(A,A3,B2)),set_or5935395276787703475ssThan(A,C2,D2)) = set_or5935395276787703475ssThan(A,aa(A,A,aa(A,fun(A,A),ord_max(A),A3),C2),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),D2)) ) ) ).

% Int_greaterThanLessThan
tff(fact_4216_Max__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( lattic643756798349783984er_Max(A,aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),ord_max(A),X),lattic643756798349783984er_Max(A,A4)) ) ) ) ) ).

% Max_insert
tff(fact_4217_max__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F: fun(A,B),M4: A,N: A] :
          ( order_mono(A,B,F)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(A,B,F,M4)),aa(A,B,F,N)) = aa(A,B,F,aa(A,A,aa(A,fun(A,A),ord_max(A),M4),N)) ) ) ) ).

% max_of_mono
tff(fact_4218_bij__betw__trans,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(A,B),A4: set(A),B3: set(B),G: fun(B,C),C3: set(C)] :
      ( bij_betw(A,B,F,A4,B3)
     => ( bij_betw(B,C,G,B3,C3)
       => bij_betw(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),G),F),A4,C3) ) ) ).

% bij_betw_trans
tff(fact_4219_bij__betw__comp__iff,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(A,B),A4: set(A),A10: set(B),F10: fun(B,C),A17: set(C)] :
      ( bij_betw(A,B,F,A4,A10)
     => ( bij_betw(B,C,F10,A10,A17)
      <=> bij_betw(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F10),F),A4,A17) ) ) ).

% bij_betw_comp_iff
tff(fact_4220_sup__max,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup(A)
        & linorder(A) )
     => ( sup_sup(A) = ord_max(A) ) ) ).

% sup_max
tff(fact_4221_complete__linorder__sup__max,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ( sup_sup(A) = ord_max(A) ) ) ).

% complete_linorder_sup_max
tff(fact_4222_max__min__distrib1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)),A3) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),A3)),aa(A,A,aa(A,fun(A,A),ord_max(A),C2),A3)) ) ) ).

% max_min_distrib1
tff(fact_4223_max__min__distrib2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2)),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),C2)) ) ) ).

% max_min_distrib2
tff(fact_4224_min__max__distrib1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A3) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),A3)),aa(A,A,aa(A,fun(A,A),ord_min(A),C2),A3)) ) ) ).

% min_max_distrib1
tff(fact_4225_min__max__distrib2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),A3),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),B2)),aa(A,A,aa(A,fun(A,A),ord_min(A),A3),C2)) ) ) ).

% min_max_distrib2
tff(fact_4226_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)),Z2) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Z2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y),Z2)) ) ) ).

% max_add_distrib_left
tff(fact_4227_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),X),aa(A,A,aa(A,fun(A,A),ord_max(A),Y),Z2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Z2)) ) ) ).

% max_add_distrib_right
tff(fact_4228_max_Oleft__commute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),B2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),C2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)) ) ) ).

% max.left_commute
tff(fact_4229_max_Ocommute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = aa(A,A,aa(A,fun(A,A),ord_max(A),B2),A3) ) ) ).

% max.commute
tff(fact_4230_max_Oassoc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)) ) ) ).

% max.assoc
tff(fact_4231_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ) ).

% max.strict_coboundedI2
tff(fact_4232_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ) ).

% max.strict_coboundedI1
tff(fact_4233_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
        <=> ( ( A3 = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) )
            & ( A3 != B2 ) ) ) ) ).

% max.strict_order_iff
tff(fact_4234_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A3))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),B2),A3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),C2),A3)) ) ) ) ).

% max.strict_boundedE
tff(fact_4235_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z2: A,X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),X))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Z2),Y)) ) ) ) ).

% less_max_iff_disj
tff(fact_4236_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [X: A,Y: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)),Z2) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),Z2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z2)) ) ) ).

% max_diff_distrib_left
tff(fact_4237_max_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semigroup(A,ord_max(A)) ) ).

% max.semigroup_axioms
tff(fact_4238_max_Omono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A3: A,D2: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),D2),B2))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),C2),D2)),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ) ) ).

% max.mono
tff(fact_4239_max_OorderE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( A3 = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) ) ) ) ).

% max.orderE
tff(fact_4240_max_OorderI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) )
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3)) ) ) ).

% max.orderI
tff(fact_4241_max_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A3))
         => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
             => ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3)) ) ) ) ).

% max.boundedE
tff(fact_4242_max_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A,C2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A3)) ) ) ) ).

% max.boundedI
tff(fact_4243_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( A3 = aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) ) ) ) ).

% max.order_iff
tff(fact_4244_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ).

% max.cobounded1
tff(fact_4245_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] : pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ).

% max.cobounded2
tff(fact_4246_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z2: A,X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),X))
            | pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Z2),Y)) ) ) ) ).

% le_max_iff_disj
tff(fact_4247_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),B2),A3))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = A3 ) ) ) ).

% max.absorb_iff1
tff(fact_4248_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
        <=> ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = B2 ) ) ) ).

% max.absorb_iff2
tff(fact_4249_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A3: A,B2: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),A3))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ) ).

% max.coboundedI1
tff(fact_4250_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,B2: A,A3: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2))) ) ) ).

% max.coboundedI2
tff(fact_4251_max__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A3: A,B2: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = B2 ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),B2))
           => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2) = A3 ) ) ) ) ).

% max_def
tff(fact_4252_max__absorb1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,X: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y),X))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y) = X ) ) ) ).

% max_absorb1
tff(fact_4253_max__absorb2,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X: A,Y: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y) = Y ) ) ) ).

% max_absorb2
tff(fact_4254_bij__betw__empty2,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),A4: set(A)] :
      ( bij_betw(A,B,F,A4,bot_bot(set(B)))
     => ( A4 = bot_bot(set(A)) ) ) ).

% bij_betw_empty2
tff(fact_4255_bij__betw__empty1,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B),A4: set(B)] :
      ( bij_betw(A,B,F,bot_bot(set(A)),A4)
     => ( A4 = bot_bot(set(B)) ) ) ).

% bij_betw_empty1
tff(fact_4256_bij__comp,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(A,B),G: fun(B,C)] :
      ( bij_betw(A,B,F,top_top(set(A)),top_top(set(B)))
     => ( bij_betw(B,C,G,top_top(set(B)),top_top(set(C)))
       => bij_betw(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),G),F),top_top(set(A)),top_top(set(C))) ) ) ).

% bij_comp
tff(fact_4257_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [X: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% minus_max_eq_min
tff(fact_4258_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [X: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),X)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% minus_min_eq_max
tff(fact_4259_lessThan__Int__lessThan,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: A,B2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(A,set(A),set_ord_greaterThan(A),A3)),aa(A,set(A),set_ord_greaterThan(A),B2)) = aa(A,set(A),set_ord_greaterThan(A),aa(A,A,aa(A,fun(A,A),ord_max(A),A3),B2)) ) ) ).

% lessThan_Int_lessThan
tff(fact_4260_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F10: fun(A,B),A10: set(A),A17: set(B),F: fun(C,A),A4: set(C)] :
      ( bij_betw(A,B,F10,A10,A17)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(C),set(A),image2(C,A,F),A4)),A10))
       => ( bij_betw(C,A,F,A4,A10)
        <=> bij_betw(C,B,aa(fun(C,A),fun(C,B),aa(fun(A,B),fun(fun(C,A),fun(C,B)),comp(A,B,C),F10),F),A4,A17) ) ) ) ).

% bij_betw_comp_iff2
tff(fact_4261_notIn__Un__bij__betw,axiom,
    ! [A: $tType,B: $tType,B2: A,A4: set(A),F: fun(A,B),A10: set(B)] :
      ( ~ pp(member(A,B2,A4))
     => ( ~ pp(member(B,aa(A,B,F,B2),A10))
       => ( bij_betw(A,B,F,A4,A10)
         => bij_betw(A,B,F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A10),aa(set(B),set(B),insert2(B,aa(A,B,F,B2)),bot_bot(set(B))))) ) ) ) ).

% notIn_Un_bij_betw
tff(fact_4262_notIn__Un__bij__betw3,axiom,
    ! [A: $tType,B: $tType,B2: A,A4: set(A),F: fun(A,B),A10: set(B)] :
      ( ~ pp(member(A,B2,A4))
     => ( ~ pp(member(B,aa(A,B,F,B2),A10))
       => ( bij_betw(A,B,F,A4,A10)
        <=> bij_betw(A,B,F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A)))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A10),aa(set(B),set(B),insert2(B,aa(A,B,F,B2)),bot_bot(set(B))))) ) ) ) ).

% notIn_Un_bij_betw3
tff(fact_4263_bij__betw__combine,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B),A4: set(A),B3: set(B),C3: set(A),D4: set(B)] :
      ( bij_betw(A,B,F,A4,B3)
     => ( bij_betw(A,B,F,C3,D4)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B3),D4) = bot_bot(set(B)) )
         => bij_betw(A,B,F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),C3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B3),D4)) ) ) ) ).

% bij_betw_combine
tff(fact_4264_bij__betw__partition,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B),A4: set(A),C3: set(A),B3: set(B),D4: set(B)] :
      ( bij_betw(A,B,F,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),C3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B3),D4))
     => ( bij_betw(A,B,F,C3,D4)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),C3) = bot_bot(set(A)) )
         => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B3),D4) = bot_bot(set(B)) )
           => bij_betw(A,B,F,A4,B3) ) ) ) ) ).

% bij_betw_partition
tff(fact_4265_o__bij,axiom,
    ! [A: $tType,B: $tType,G: fun(B,A),F: fun(A,B)] :
      ( ( aa(fun(A,B),fun(A,A),aa(fun(B,A),fun(fun(A,B),fun(A,A)),comp(B,A,A),G),F) = id(A) )
     => ( ( aa(fun(B,A),fun(B,B),aa(fun(A,B),fun(fun(B,A),fun(B,B)),comp(A,B,B),F),G) = id(B) )
       => bij_betw(A,B,F,top_top(set(A)),top_top(set(B))) ) ) ).

% o_bij
tff(fact_4266_ex__bij__betw,axiom,
    ! [B: $tType,A: $tType,A4: set(A),R3: set(product_prod(B,B))] :
      ( pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),R3),bNF_Wellorder_ordLeq(A,B)))
     => ? [F9: fun(B,A),B9: set(B)] : bij_betw(B,A,F9,B9,A4) ) ).

% ex_bij_betw
tff(fact_4267_card__of__ordIso,axiom,
    ! [B: $tType,A: $tType,A4: set(A),B3: set(B)] :
      ( ? [F11: fun(A,B)] : bij_betw(A,B,F11,A4,B3)
    <=> pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordIso(A,B))) ) ).

% card_of_ordIso
tff(fact_4268_card__of__ordIsoI,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),A4: set(A),B3: set(B)] :
      ( bij_betw(A,B,F,A4,B3)
     => pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(A,A4)),bNF_Ca6860139660246222851ard_of(B,B3)),bNF_Wellorder_ordIso(A,B))) ) ).

% card_of_ordIsoI
tff(fact_4269_antisym__bot,axiom,
    ! [A: $tType] : antisymp(A,bot_bot(fun(A,fun(A,bool)))) ).

% antisym_bot
tff(fact_4270_Well__order__iso__copy,axiom,
    ! [B: $tType,A: $tType,A4: set(A),R3: set(product_prod(A,A)),F: fun(A,B),A10: set(B)] :
      ( order_well_order_on(A,A4,R3)
     => ( bij_betw(A,B,F,A4,A10)
       => ? [R11: set(product_prod(B,B))] :
            ( order_well_order_on(B,A10,R11)
            & pp(member(product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(set(product_prod(B,B)),product_prod(set(product_prod(A,A)),set(product_prod(B,B)))),product_Pair(set(product_prod(A,A)),set(product_prod(B,B))),R3),R11),bNF_Wellorder_ordIso(A,B))) ) ) ) ).

% Well_order_iso_copy
tff(fact_4271_iso__iff2,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),R4: set(product_prod(B,B)),F: fun(A,B)] :
      ( bNF_Wellorder_iso(A,B,R3,R4,F)
    <=> ( bij_betw(A,B,F,field2(A,R3),field2(B,R4))
        & ! [X4: A] :
            ( pp(member(A,X4,field2(A,R3)))
           => ! [Xa2: A] :
                ( pp(member(A,Xa2,field2(A,R3)))
               => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa2),R3))
                <=> pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,F,X4)),aa(A,B,F,Xa2)),R4)) ) ) ) ) ) ).

% iso_iff2
tff(fact_4272_max__nat_Osemilattice__neutr__axioms,axiom,
    semilattice_neutr(nat,ord_max(nat),zero_zero(nat)) ).

% max_nat.semilattice_neutr_axioms
tff(fact_4273_max__nat_Omonoid__axioms,axiom,
    monoid(nat,ord_max(nat),zero_zero(nat)) ).

% max_nat.monoid_axioms
tff(fact_4274_bij__betw__disjoint__Un,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B),A4: set(A),C3: set(B),G: fun(A,B),B3: set(A),D4: set(B)] :
      ( bij_betw(A,B,F,A4,C3)
     => ( bij_betw(A,B,G,B3,D4)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) )
         => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C3),D4) = bot_bot(set(B)) )
           => bij_betw(A,B,aa(fun(A,B),fun(A,B),aa(set(A),fun(fun(A,B),fun(A,B)),aTP_Lamp_cp(fun(A,B),fun(set(A),fun(fun(A,B),fun(A,B))),F),A4),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),C3),D4)) ) ) ) ) ).

% bij_betw_disjoint_Un
tff(fact_4275_infinite__imp__bij__betw2,axiom,
    ! [A: $tType,A4: set(A),A3: A] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ? [H: fun(A,A)] : bij_betw(A,A,H,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))) ) ).

% infinite_imp_bij_betw2
tff(fact_4276_infinite__imp__bij__betw,axiom,
    ! [A: $tType,A4: set(A),A3: A] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ? [H: fun(A,A)] : bij_betw(A,A,H,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A))))) ) ).

% infinite_imp_bij_betw
tff(fact_4277_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P3: A,X: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),P3) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),P3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P3)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)),P3) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),P3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P3)) ) ) ) ) ).

% min_mult_distrib_right
tff(fact_4278_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P3: A,X: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)),P3) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),P3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P3)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)),P3) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),X),P3)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P3)) ) ) ) ) ).

% max_mult_distrib_right
tff(fact_4279_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P3: A,X: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P3),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P3),X)),aa(A,A,aa(A,fun(A,A),times_times(A),P3),Y)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P3),aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P3),X)),aa(A,A,aa(A,fun(A,A),times_times(A),P3),Y)) ) ) ) ) ).

% min_mult_distrib_left
tff(fact_4280_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P3: A,X: A,Y: A] :
          ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P3),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P3),X)),aa(A,A,aa(A,fun(A,A),times_times(A),P3),Y)) ) )
          & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),P3))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),P3),aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P3),X)),aa(A,A,aa(A,fun(A,A),times_times(A),P3),Y)) ) ) ) ) ).

% max_mult_distrib_left
tff(fact_4281_Sup__insert__finite,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [S2: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),S2))
         => ( ( ( S2 = bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert2(A,X),S2)) = X ) )
            & ( ( S2 != bot_bot(set(A)) )
             => ( aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),insert2(A,X),S2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),X),aa(set(A),A,complete_Sup_Sup(A),S2)) ) ) ) ) ) ).

% Sup_insert_finite
tff(fact_4282_hom__Max__commute,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [H2: fun(A,A),N4: set(A)] :
          ( ! [X2: A,Y2: A] : ( aa(A,A,H2,aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y2)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,H2,X2)),aa(A,A,H2,Y2)) )
         => ( pp(aa(set(A),bool,finite_finite(A),N4))
           => ( ( N4 != bot_bot(set(A)) )
             => ( aa(A,A,H2,lattic643756798349783984er_Max(A,N4)) = lattic643756798349783984er_Max(A,aa(set(A),set(A),image2(A,A,H2),N4)) ) ) ) ) ) ).

% hom_Max_commute
tff(fact_4283_Max_Osubset,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( B3 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),B3),A4))
             => ( aa(A,A,aa(A,fun(A,A),ord_max(A),lattic643756798349783984er_Max(A,B3)),lattic643756798349783984er_Max(A,A4)) = lattic643756798349783984er_Max(A,A4) ) ) ) ) ) ).

% Max.subset
tff(fact_4284_Max_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ~ pp(member(A,X,A4))
           => ( ( A4 != bot_bot(set(A)) )
             => ( lattic643756798349783984er_Max(A,aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),ord_max(A),X),lattic643756798349783984er_Max(A,A4)) ) ) ) ) ) ).

% Max.insert_not_elem
tff(fact_4285_Max_Oclosed,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [X2: A,Y2: A] : pp(member(A,aa(A,A,aa(A,fun(A,A),ord_max(A),X2),Y2),aa(set(A),set(A),insert2(A,X2),aa(set(A),set(A),insert2(A,Y2),bot_bot(set(A))))))
             => pp(member(A,lattic643756798349783984er_Max(A,A4),A4)) ) ) ) ) ).

% Max.closed
tff(fact_4286_Max_Ounion,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),B3: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( pp(aa(set(A),bool,finite_finite(A),B3))
             => ( ( B3 != bot_bot(set(A)) )
               => ( lattic643756798349783984er_Max(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(A,A,aa(A,fun(A,A),ord_max(A),lattic643756798349783984er_Max(A,A4)),lattic643756798349783984er_Max(A,B3)) ) ) ) ) ) ) ).

% Max.union
tff(fact_4287_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [S4: set(B),T6: set(C),H2: fun(B,C),S2: set(B),T3: set(C),G: fun(C,A)] :
          ( pp(aa(set(B),bool,finite_finite(B),S4))
         => ( pp(aa(set(C),bool,finite_finite(C),T6))
           => ( bij_betw(B,C,H2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T3),T6))
             => ( ! [A8: B] :
                    ( pp(member(B,A8,S4))
                   => ( aa(C,A,G,aa(B,C,H2,A8)) = one_one(A) ) )
               => ( ! [B5: C] :
                      ( pp(member(C,B5,T6))
                     => ( aa(C,A,G,B5) = one_one(A) ) )
                 => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(C,A),fun(B,A),aTP_Lamp_pq(fun(B,C),fun(fun(C,A),fun(B,A)),H2),G)),S2) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),G),T3) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
tff(fact_4288_sum_OatLeastAtMost__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add(A)
        & ord(B) )
     => ! [H2: fun(nat,B),M4: nat,N: nat,G: fun(B,A)] :
          ( bij_betw(nat,B,H2,set_or1337092689740270186AtMost(nat,M4,N),set_or1337092689740270186AtMost(B,aa(nat,B,H2,M4),aa(nat,B,H2,N)))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),set_or1337092689740270186AtMost(B,aa(nat,B,H2,M4),aa(nat,B,H2,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,B),fun(nat,A),aa(fun(B,A),fun(fun(nat,B),fun(nat,A)),comp(B,A,nat),G),H2)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ) ).

% sum.atLeastAtMost_reindex
tff(fact_4289_sum_OatLeastLessThan__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add(A)
        & ord(B) )
     => ! [H2: fun(nat,B),M4: nat,N: nat,G: fun(B,A)] :
          ( bij_betw(nat,B,H2,set_or7035219750837199246ssThan(nat,M4,N),set_or7035219750837199246ssThan(B,aa(nat,B,H2,M4),aa(nat,B,H2,N)))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),set_or7035219750837199246ssThan(B,aa(nat,B,H2,M4),aa(nat,B,H2,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,B),fun(nat,A),aa(fun(B,A),fun(fun(nat,B),fun(nat,A)),comp(B,A,nat),G),H2)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ) ).

% sum.atLeastLessThan_reindex
tff(fact_4290_Max_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,X,A4))
           => ( ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) = bot_bot(set(A)) )
               => ( lattic643756798349783984er_Max(A,A4) = X ) )
              & ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) != bot_bot(set(A)) )
               => ( lattic643756798349783984er_Max(A,A4) = aa(A,A,aa(A,fun(A,A),ord_max(A),X),lattic643756798349783984er_Max(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ) ).

% Max.remove
tff(fact_4291_next__present,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),H4: heap_ext(product_unit),X: A,H2: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),product_prod(ref(A),heap_ext(product_unit)),aa(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),heap_ext(product_unit))),product_Pair(ref(A),heap_ext(product_unit)),R3),H4) = ref_alloc(A,X,H2) )
         => ref_present(A,H4,R3) ) ) ).

% next_present
tff(fact_4292_next__fresh,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: ref(A),H4: heap_ext(product_unit),X: A,H2: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),product_prod(ref(A),heap_ext(product_unit)),aa(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),heap_ext(product_unit))),product_Pair(ref(A),heap_ext(product_unit)),R3),H4) = ref_alloc(A,X,H2) )
         => ~ ref_present(A,H2,R3) ) ) ).

% next_fresh
tff(fact_4293_K__record__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,C2: B,F: fun(A,C),X3: A] : ( aa(A,B,aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),aTP_Lamp_pr(B,fun(C,B),C2)),F),X3) = C2 ) ).

% K_record_comp
tff(fact_4294_bind__singleton__conv__image,axiom,
    ! [A: $tType,B: $tType,A4: set(B),F: fun(B,A)] : ( bind3(B,A,A4,aTP_Lamp_iv(fun(B,A),fun(B,set(A)),F)) = aa(set(B),set(A),image2(B,A,F),A4) ) ).

% bind_singleton_conv_image
tff(fact_4295_empty__bind,axiom,
    ! [B: $tType,A: $tType,F: fun(B,set(A))] : ( bind3(B,A,bot_bot(set(B)),F) = bot_bot(set(A)) ) ).

% empty_bind
tff(fact_4296_bind__const,axiom,
    ! [B: $tType,A: $tType,A4: set(B),B3: set(A)] :
      ( ( ( A4 = bot_bot(set(B)) )
       => ( bind3(B,A,A4,aTP_Lamp_ho(set(A),fun(B,set(A)),B3)) = bot_bot(set(A)) ) )
      & ( ( A4 != bot_bot(set(B)) )
       => ( bind3(B,A,A4,aTP_Lamp_ho(set(A),fun(B,set(A)),B3)) = B3 ) ) ) ).

% bind_const
tff(fact_4297_nonempty__bind__const,axiom,
    ! [A: $tType,B: $tType,A4: set(A),B3: set(B)] :
      ( ( A4 != bot_bot(set(A)) )
     => ( bind3(A,B,A4,aTP_Lamp_hq(set(B),fun(A,set(B)),B3)) = B3 ) ) ).

% nonempty_bind_const
tff(fact_4298_bind__image,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(C,B),A4: set(C),G: fun(B,set(A))] : ( bind3(B,A,aa(set(C),set(B),image2(C,B,F),A4),G) = bind3(C,A,A4,aa(fun(C,B),fun(C,set(A)),aa(fun(B,set(A)),fun(fun(C,B),fun(C,set(A))),comp(B,set(A),C),G),F)) ) ).

% bind_image
tff(fact_4299_image__bind,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(B,A),A4: set(C),G: fun(C,set(B))] : ( aa(set(B),set(A),image2(B,A,F),bind3(C,B,A4,G)) = bind3(C,A,A4,aa(fun(C,set(B)),fun(C,set(A)),aa(fun(set(B),set(A)),fun(fun(C,set(B)),fun(C,set(A))),comp(set(B),set(A),C),image2(B,A,F)),G)) ) ).

% image_bind
tff(fact_4300_set__decode__zero,axiom,
    nat_set_decode(zero_zero(nat)) = bot_bot(set(nat)) ).

% set_decode_zero
tff(fact_4301_Func__empty,axiom,
    ! [B: $tType,A: $tType,B3: set(B)] : ( bNF_Wellorder_Func(A,B,bot_bot(set(A)),B3) = aa(set(fun(A,B)),set(fun(A,B)),insert2(fun(A,B),aTP_Lamp_ps(A,B)),bot_bot(set(fun(A,B)))) ) ).

% Func_empty
tff(fact_4302_power__int__add__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M4: int] :
          ( ( ( X != zero_zero(A) )
            | ( M4 != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(A,X,aa(int,int,aa(int,fun(int,int),plus_plus(int),M4),one_one(int))) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,M4)),X) ) ) ) ).

% power_int_add_1
tff(fact_4303_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M4: int] :
          ( ( ( X != zero_zero(A) )
            | ( M4 != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(A,X,aa(int,int,aa(int,fun(int,int),plus_plus(int),M4),one_one(int))) = aa(A,A,aa(A,fun(A,A),times_times(A),X),power_int(A,X,M4)) ) ) ) ).

% power_int_add_1'
tff(fact_4304_power__int__1__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [N: int] : ( power_int(A,one_one(A),N) = one_one(A) ) ) ).

% power_int_1_left
tff(fact_4305_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [W2: num,Y: A,M4: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W2)),Y),M4) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(num,A,numeral_numeral(A),W2),M4)),power_int(A,Y,M4)) ) ) ).

% power_int_mult_distrib_numeral1
tff(fact_4306_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,W2: num,M4: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(num,A,numeral_numeral(A),W2)),M4) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,M4)),power_int(A,aa(num,A,numeral_numeral(A),W2),M4)) ) ) ).

% power_int_mult_distrib_numeral2
tff(fact_4307_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( inverse(B)
        & power(B) )
     => ! [X: B] : ( power_int(B,X,zero_zero(int)) = one_one(B) ) ) ).

% power_int_0_right
tff(fact_4308_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M4: int] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M4)),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M4)) = one_one(A) ) ) ).

% power_int_minus_one_mult_self
tff(fact_4309_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M4: int,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M4)),aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M4)),B2)) = B2 ) ) ).

% power_int_minus_one_mult_self'
tff(fact_4310_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M4: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,aa(num,int,numeral_numeral(int),M4))),power_int(A,X,aa(num,int,numeral_numeral(int),N))) = power_int(A,X,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M4),N))) ) ) ).

% power_int_add_numeral
tff(fact_4311_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M4: num,N: num,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,aa(num,int,numeral_numeral(int),M4))),aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,aa(num,int,numeral_numeral(int),N))),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M4),N)))),B2) ) ) ).

% power_int_add_numeral2
tff(fact_4312_mod__h__bot__normalize,axiom,
    ! [A: $tType,H2: heap_ext(product_unit),P: assn] :
      ( syntax7388354845996824322omatch(A,heap_ext(product_unit),undefined(A),H2)
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))))
      <=> pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,P),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),undefined(heap_ext(product_unit))),bot_bot(set(nat))))) ) ) ).

% mod_h_bot_normalize
tff(fact_4313_power__int__commutes,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,N: int] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,N)),X) = aa(A,A,aa(A,fun(A,A),times_times(A),X),power_int(A,X,N)) ) ) ).

% power_int_commutes
tff(fact_4314_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,Y: A,M4: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),X),Y),M4) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,M4)),power_int(A,Y,M4)) ) ) ).

% power_int_mult_distrib
tff(fact_4315_power__int__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,N: int] : ( power_int(A,divide_divide(A,one_one(A),X),N) = divide_divide(A,one_one(A),power_int(A,X,N)) ) ) ).

% power_int_one_over
tff(fact_4316_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M4: int] :
          ( ( ( M4 = zero_zero(int) )
           => ( power_int(A,zero_zero(A),M4) = one_one(A) ) )
          & ( ( M4 != zero_zero(int) )
           => ( power_int(A,zero_zero(A),M4) = zero_zero(A) ) ) ) ) ).

% power_int_0_left_If
tff(fact_4317_power__int__increasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N4: int,A3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,A3,N)),power_int(A,A3,N4))) ) ) ) ).

% power_int_increasing
tff(fact_4318_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N4: int,A3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,A3,N)),power_int(A,A3,N4))) ) ) ) ).

% power_int_strict_increasing
tff(fact_4319_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [N: int] : ( power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,uminus_uminus(int),N)) = power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),N) ) ) ).

% power_int_minus_one_minus
tff(fact_4320_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A3: int,B2: int] : ( power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,aa(int,fun(int,int),minus_minus(int),A3),B2)) = power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),A3)) ) ) ).

% power_int_minus_one_diff_commute
tff(fact_4321_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N4: int,A3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),A3),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,A3,N4)),power_int(A,A3,N))) ) ) ) ) ).

% power_int_strict_decreasing
tff(fact_4322_one__le__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),X))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),one_one(A)),power_int(A,X,N))) ) ) ) ).

% one_le_power_int
tff(fact_4323_one__less__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A3: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),A3))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),zero_zero(int)),N))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),power_int(A,A3,N))) ) ) ) ).

% one_less_power_int
tff(fact_4324_power__int__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [X: A,M4: int,N: int] :
          ( ( ( X != zero_zero(A) )
            | ( aa(int,int,aa(int,fun(int,int),plus_plus(int),M4),N) != zero_zero(int) ) )
         => ( power_int(A,X,aa(int,int,aa(int,fun(int,int),plus_plus(int),M4),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,M4)),power_int(A,X,N)) ) ) ) ).

% power_int_add
tff(fact_4325_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( division_ring(A)
        & one(B)
        & uminus(B) )
     => ! [X: C,A3: A,N: int] :
          ( nO_MATCH(B,C,aa(B,B,uminus_uminus(B),one_one(B)),X)
         => ( power_int(A,aa(A,A,uminus_uminus(A),A3),N) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),N)),power_int(A,A3,N)) ) ) ) ).

% power_int_minus_left_distrib
tff(fact_4326_power__int__le__one,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),X))
         => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),one_one(A)))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,X,N)),one_one(A))) ) ) ) ) ).

% power_int_le_one
tff(fact_4327_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N4: int,A3: A] :
          ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),N),N4))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),zero_zero(A)),A3))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),A3),one_one(A)))
             => ( ( ( A3 != zero_zero(A) )
                  | ( N4 != zero_zero(int) )
                  | ( N = zero_zero(int) ) )
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,A3,N4)),power_int(A,A3,N))) ) ) ) ) ) ).

% power_int_decreasing
tff(fact_4328_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,M4: int,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),power_int(A,X,M4)),power_int(A,X,N)))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
             => pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),M4),N)) ) ) ) ) ).

% power_int_le_imp_le_exp
tff(fact_4329_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [X: A,M4: int,N: int] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),one_one(A)),X))
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),power_int(A,X,M4)),power_int(A,X,N)))
           => ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),zero_zero(int)),N))
             => pp(aa(int,bool,aa(int,fun(int,bool),ord_less(int),M4),N)) ) ) ) ) ).

% power_int_le_imp_less_exp
tff(fact_4330_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [X: A,N: int] :
          ( ( ( X != zero_zero(A) )
            | ( N != zero_zero(int) ) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,X,aa(int,int,aa(int,fun(int,int),minus_minus(int),N),one_one(int)))),X) = power_int(A,X,N) ) ) ) ).

% power_int_minus_mult
tff(fact_4331_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),K) = aa(A,A,compow(fun(A,A),aa(num,nat,numeral_numeral(nat),K),aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% numeral_unfold_funpow
tff(fact_4332_Fract__def,axiom,
    fract = aa(fun(int,fun(int,product_prod(int,int))),fun(int,fun(int,rat)),map_fun(int,int,fun(int,product_prod(int,int)),fun(int,rat),id(int),map_fun(int,int,product_prod(int,int),rat,id(int),abs_Rat)),aTP_Lamp_gu(int,fun(int,product_prod(int,int)))) ).

% Fract_def
tff(fact_4333_Fract_Otransfer,axiom,
    pp(aa(fun(int,fun(int,rat)),bool,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,rat)),bool),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,rat),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),rat,fequal(int),pcr_rat)),aTP_Lamp_gu(int,fun(int,product_prod(int,int)))),fract)) ).

% Fract.transfer
tff(fact_4334_mset__set__Union,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(aa(set(A),bool,finite_finite(A),B3))
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3) = bot_bot(set(A)) )
         => ( mset_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A4),B3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),mset_set(A,A4)),mset_set(A,B3)) ) ) ) ) ).

% mset_set_Union
tff(fact_4335_mset__set_Oempty,axiom,
    ! [A: $tType] : ( mset_set(A,bot_bot(set(A))) = zero_zero(multiset(A)) ) ).

% mset_set.empty
tff(fact_4336_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N: nat,F: fun(A,A)] : ( compow(fun(fun(B,A),fun(B,A)),N,aa(fun(A,A),fun(fun(B,A),fun(B,A)),comp(A,A,B),F)) = aa(fun(A,A),fun(fun(B,A),fun(B,A)),comp(A,A,B),compow(fun(A,A),N,F)) ) ).

% comp_funpow
tff(fact_4337_funpow__times__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [F: fun(A,nat),X: A] : ( compow(fun(A,A),aa(A,nat,F,X),aa(A,fun(A,A),times_times(A),X)) = aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(A,nat,F,X))) ) ) ).

% funpow_times_power
tff(fact_4338_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F: fun(A,A)] : ( compow(fun(A,A),aa(nat,nat,suc,N),F) = aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),F),compow(fun(A,A),N,F)) ) ).

% funpow.simps(2)
tff(fact_4339_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F: fun(A,A)] : ( compow(fun(A,A),aa(nat,nat,suc,N),F) = aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),compow(fun(A,A),N,F)),F) ) ).

% funpow_Suc_right
tff(fact_4340_funpow__add,axiom,
    ! [A: $tType,M4: nat,N: nat,F: fun(A,A)] : ( compow(fun(A,A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),N),F) = aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),compow(fun(A,A),M4,F)),compow(fun(A,A),N,F)) ) ).

% funpow_add
tff(fact_4341_quotient__of__eq,axiom,
    ! [A3: int,B2: int,P3: int,Q3: int] :
      ( ( quotient_of(aa(int,rat,aa(int,fun(int,rat),fract,A3),B2)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),Q3) )
     => ( aa(int,rat,aa(int,fun(int,rat),fract,P3),Q3) = aa(int,rat,aa(int,fun(int,rat),fract,A3),B2) ) ) ).

% quotient_of_eq
tff(fact_4342_normalize__eq,axiom,
    ! [A3: int,B2: int,P3: int,Q3: int] :
      ( ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),B2)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P3),Q3) )
     => ( aa(int,rat,aa(int,fun(int,rat),fract,P3),Q3) = aa(int,rat,aa(int,fun(int,rat),fract,A3),B2) ) ) ).

% normalize_eq
tff(fact_4343_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Q: fun(A,A)] :
          ( order_mono(A,A,Q)
         => order_mono(nat,A,aTP_Lamp_pt(fun(A,A),fun(nat,A),Q)) ) ) ).

% mono_funpow
tff(fact_4344_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [F: fun(A,A),P3: A,K: nat] :
          ( order_mono(A,A,F)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,F,P3)),P3))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,compow(fun(A,A),K,F),bot_bot(A))),P3)) ) ) ) ).

% Kleene_iter_lpfp
tff(fact_4345_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( compow(fun(A,fun(A,bool)),N,bot_bot(fun(A,fun(A,bool)))) = bot_bot(fun(A,fun(A,bool))) ) ) ).

% relpowp_bot
tff(fact_4346_mset__set__empty__iff,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ( mset_set(A,A4) = zero_zero(multiset(A)) )
    <=> ( ( A4 = bot_bot(set(A)) )
        | ~ pp(aa(set(A),bool,finite_finite(A),A4)) ) ) ).

% mset_set_empty_iff
tff(fact_4347_quotient__of__Fract,axiom,
    ! [A3: int,B2: int] : ( quotient_of(aa(int,rat,aa(int,fun(int,rat),fract,A3),B2)) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),B2)) ) ).

% quotient_of_Fract
tff(fact_4348_of__nat__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),N) = aa(A,A,compow(fun(A,A),N,aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% of_nat_def
tff(fact_4349_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num,A3: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),K)),A3) = aa(A,A,compow(fun(A,A),aa(num,nat,numeral_numeral(nat),K),aa(A,fun(A,A),plus_plus(A),one_one(A))),A3) ) ) ).

% numeral_add_unfold_funpow
tff(fact_4350_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [M4: nat,N: nat,F: fun(A,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
         => ( order_mono(A,A,F)
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,compow(fun(A,A),M4,F),bot_bot(A))),aa(A,A,compow(fun(A,A),N,F),bot_bot(A)))) ) ) ) ).

% funpow_decreasing
tff(fact_4351_lfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(A,A),K: nat] :
          ( order_mono(A,A,F)
         => ( ( aa(A,A,compow(fun(A,A),aa(nat,nat,suc,K),F),bot_bot(A)) = aa(A,A,compow(fun(A,A),K,F),bot_bot(A)) )
           => ( complete_lattice_lfp(A,F) = aa(A,A,compow(fun(A,A),K,F),bot_bot(A)) ) ) ) ) ).

% lfp_Kleene_iter
tff(fact_4352_Fract_Oabs__eq,axiom,
    ! [Xa: int,X: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,Xa),X) = aa(product_prod(int,int),rat,abs_Rat,if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),fequal(int),X),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Xa),X))) ) ).

% Fract.abs_eq
tff(fact_4353_mset__set_Oinsert__remove,axiom,
    ! [A: $tType,A4: set(A),X: A] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( mset_set(A,aa(set(A),set(A),insert2(A,X),A4)) = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X),mset_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ).

% mset_set.insert_remove
tff(fact_4354_mset__set_Oremove,axiom,
    ! [A: $tType,A4: set(A),X: A] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( pp(member(A,X,A4))
       => ( mset_set(A,A4) = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X),mset_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ).

% mset_set.remove
tff(fact_4355_mult__cancel,axiom,
    ! [A: $tType,S: set(product_prod(A,A)),X6: multiset(A),Z6: multiset(A),Y5: multiset(A)] :
      ( trans(A,S)
     => ( irrefl(A,S)
       => ( pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),X6),Z6)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),Y5),Z6)),mult(A,S)))
        <=> pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),X6),Y5),mult(A,S))) ) ) ) ).

% mult_cancel
tff(fact_4356_o__prs_I2_J,axiom,
    ! [F8: $tType,E: $tType,C: $tType,D: $tType,A: $tType,B: $tType,H9: $tType,G2: $tType,R12: fun(A,fun(A,bool)),Abs1: fun(A,B),Rep1: fun(B,A),R23: fun(C,fun(C,bool)),Abs22: fun(C,D),Rep22: fun(D,C),R32: fun(E,fun(E,bool)),Abs32: fun(E,F8),Rep32: fun(F8,E)] :
      ( quotient3(A,B,R12,Abs1,Rep1)
     => ( quotient3(C,D,R23,Abs22,Rep22)
       => ( quotient3(E,F8,R32,Abs32,Rep32)
         => ( aa(fun(fun(G2,H9),fun(fun(A,G2),fun(A,H9))),fun(fun(G2,H9),fun(fun(B,G2),fun(B,H9))),map_fun(fun(G2,H9),fun(G2,H9),fun(fun(A,G2),fun(A,H9)),fun(fun(B,G2),fun(B,H9)),id(fun(G2,H9)),map_fun(fun(B,G2),fun(A,G2),fun(A,H9),fun(B,H9),map_fun(A,B,G2,G2,Abs1,id(G2)),map_fun(B,A,H9,H9,Rep1,id(H9)))),comp(G2,H9,A)) = comp(G2,H9,B) ) ) ) ) ).

% o_prs(2)
tff(fact_4357_mult__cancel__add__mset,axiom,
    ! [A: $tType,S: set(product_prod(A,A)),Uu: A,X6: multiset(A),Y5: multiset(A)] :
      ( trans(A,S)
     => ( irrefl(A,S)
       => ( pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),Uu),X6)),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),Uu),Y5)),mult(A,S)))
        <=> pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),X6),Y5),mult(A,S))) ) ) ) ).

% mult_cancel_add_mset
tff(fact_4358_mset__set_Ocomp__fun__commute__on,axiom,
    ! [A: $tType,Y: A,X: A] : ( aa(fun(multiset(A),multiset(A)),fun(multiset(A),multiset(A)),aa(fun(multiset(A),multiset(A)),fun(fun(multiset(A),multiset(A)),fun(multiset(A),multiset(A))),comp(multiset(A),multiset(A),multiset(A)),aa(A,fun(multiset(A),multiset(A)),add_mset(A),Y)),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X)) = aa(fun(multiset(A),multiset(A)),fun(multiset(A),multiset(A)),aa(fun(multiset(A),multiset(A)),fun(fun(multiset(A),multiset(A)),fun(multiset(A),multiset(A))),comp(multiset(A),multiset(A),multiset(A)),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X)),aa(A,fun(multiset(A),multiset(A)),add_mset(A),Y)) ) ).

% mset_set.comp_fun_commute_on
tff(fact_4359_comp__fun__commute__mset__image,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] : finite6289374366891150609ommute(A,multiset(B),aa(fun(A,B),fun(A,fun(multiset(B),multiset(B))),aa(fun(B,fun(multiset(B),multiset(B))),fun(fun(A,B),fun(A,fun(multiset(B),multiset(B)))),comp(B,fun(multiset(B),multiset(B)),A),add_mset(B)),F)) ).

% comp_fun_commute_mset_image
tff(fact_4360_abs__o__rep,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(A,bool)),Abs: fun(A,B),Rep: fun(B,A)] :
      ( quotient3(A,B,R,Abs,Rep)
     => ( aa(fun(B,A),fun(B,B),aa(fun(A,B),fun(fun(B,A),fun(B,B)),comp(A,B,B),Abs),Rep) = id(B) ) ) ).

% abs_o_rep
tff(fact_4361_o__prs_I1_J,axiom,
    ! [C: $tType,E: $tType,A: $tType,B: $tType,F8: $tType,D: $tType,R12: fun(A,fun(A,bool)),Abs1: fun(A,B),Rep1: fun(B,A),R23: fun(C,fun(C,bool)),Abs22: fun(C,D),Rep22: fun(D,C),R32: fun(E,fun(E,bool)),Abs32: fun(E,F8),Rep32: fun(F8,E)] :
      ( quotient3(A,B,R12,Abs1,Rep1)
     => ( quotient3(C,D,R23,Abs22,Rep22)
       => ( quotient3(E,F8,R32,Abs32,Rep32)
         => ( aa(fun(fun(C,E),fun(fun(A,C),fun(A,E))),fun(fun(D,F8),fun(fun(B,D),fun(B,F8))),map_fun(fun(D,F8),fun(C,E),fun(fun(A,C),fun(A,E)),fun(fun(B,D),fun(B,F8)),map_fun(C,D,F8,E,Abs22,Rep32),map_fun(fun(B,D),fun(A,C),fun(A,E),fun(B,F8),map_fun(A,B,D,C,Abs1,Rep22),map_fun(B,A,E,F8,Rep1,Abs32))),comp(C,E,A)) = comp(D,F8,B) ) ) ) ) ).

% o_prs(1)
tff(fact_4362_OOO__eq__quotient3,axiom,
    ! [A: $tType,B: $tType,C: $tType,R12: fun(A,fun(A,bool)),Abs1: fun(A,B),Rep1: fun(B,A),Abs22: fun(B,C),Rep22: fun(C,B)] :
      ( quotient3(A,B,R12,Abs1,Rep1)
     => ( quotient3(B,C,fequal(B),Abs22,Rep22)
       => quotient3(A,C,relcompp(A,A,A,R12,relcompp(A,A,A,fequal(A),R12)),aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),Abs22),Abs1),aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),Rep1),Rep22)) ) ) ).

% OOO_eq_quotient3
tff(fact_4363_OOO__quotient3,axiom,
    ! [A: $tType,B: $tType,C: $tType,R12: fun(A,fun(A,bool)),Abs1: fun(A,B),Rep1: fun(B,A),R23: fun(B,fun(B,bool)),Abs22: fun(B,C),Rep22: fun(C,B),R24: fun(A,fun(A,bool))] :
      ( quotient3(A,B,R12,Abs1,Rep1)
     => ( quotient3(B,C,R23,Abs22,Rep22)
       => ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),R24,X2),Y2))
             => ( pp(aa(A,bool,aa(A,fun(A,bool),R12,X2),X2))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),R12,Y2),Y2))
                 => pp(aa(B,bool,aa(B,fun(B,bool),R23,aa(A,B,Abs1,X2)),aa(A,B,Abs1,Y2))) ) ) )
         => ( ! [X2: B,Y2: B] :
                ( pp(aa(B,bool,aa(B,fun(B,bool),R23,X2),Y2))
               => pp(aa(A,bool,aa(A,fun(A,bool),R24,aa(B,A,Rep1,X2)),aa(B,A,Rep1,Y2))) )
           => quotient3(A,C,relcompp(A,A,A,R12,relcompp(A,A,A,R24,R12)),aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),Abs22),Abs1),aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),Rep1),Rep22)) ) ) ) ) ).

% OOO_quotient3
tff(fact_4364_mult__cancel__max,axiom,
    ! [A: $tType,S: set(product_prod(A,A)),X6: multiset(A),Y5: multiset(A)] :
      ( trans(A,S)
     => ( irrefl(A,S)
       => ( pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),X6),Y5),mult(A,S)))
        <=> pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),X6),Y5)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),Y5),X6)),mult(A,S))) ) ) ) ).

% mult_cancel_max
tff(fact_4365_multeqp__code__iff__reflcl__mult,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),P: fun(A,fun(A,bool)),N4: multiset(A),M: multiset(A)] :
      ( irrefl(A,R)
     => ( trans(A,R)
       => ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),P,X2),Y2))
            <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),R)) )
         => ( multeqp_code(A,P,N4,M)
          <=> pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),N4),M),aa(set(product_prod(multiset(A),multiset(A))),set(product_prod(multiset(A),multiset(A))),aa(set(product_prod(multiset(A),multiset(A))),fun(set(product_prod(multiset(A),multiset(A))),set(product_prod(multiset(A),multiset(A)))),sup_sup(set(product_prod(multiset(A),multiset(A)))),mult(A,R)),id2(multiset(A))))) ) ) ) ) ).

% multeqp_code_iff_reflcl_mult
tff(fact_4366_multp__code__iff__mult,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),P: fun(A,fun(A,bool)),N4: multiset(A),M: multiset(A)] :
      ( irrefl(A,R)
     => ( trans(A,R)
       => ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),P,X2),Y2))
            <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),R)) )
         => ( multp_code(A,P,N4,M)
          <=> pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),N4),M),mult(A,R))) ) ) ) ) ).

% multp_code_iff_mult
tff(fact_4367_mult__implies__one__step,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),M: multiset(A),N4: multiset(A)] :
      ( trans(A,R3)
     => ( pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),M),N4),mult(A,R3)))
       => ? [I6: multiset(A),J6: multiset(A)] :
            ( ( N4 = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),I6),J6) )
            & ? [K7: multiset(A)] :
                ( ( M = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),I6),K7) )
                & ( J6 != zero_zero(multiset(A)) )
                & ! [X3: A] :
                    ( pp(member(A,X3,aa(multiset(A),set(A),set_mset(A),K7)))
                   => ? [Xa4: A] :
                        ( pp(member(A,Xa4,aa(multiset(A),set(A),set_mset(A),J6)))
                        & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa4),R3)) ) ) ) ) ) ) ).

% mult_implies_one_step
tff(fact_4368_multp__def,axiom,
    ! [A: $tType,R3: fun(A,fun(A,bool)),M: multiset(A),N4: multiset(A)] :
      ( multp(A,R3,M,N4)
    <=> pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),M),N4),mult(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R3))))) ) ).

% multp_def
tff(fact_4369_set__mset__eq__empty__iff,axiom,
    ! [A: $tType,M: multiset(A)] :
      ( ( aa(multiset(A),set(A),set_mset(A),M) = bot_bot(set(A)) )
    <=> ( M = zero_zero(multiset(A)) ) ) ).

% set_mset_eq_empty_iff
tff(fact_4370_set__mset__empty,axiom,
    ! [A: $tType] : ( aa(multiset(A),set(A),set_mset(A),zero_zero(multiset(A))) = bot_bot(set(A)) ) ).

% set_mset_empty
tff(fact_4371_in__Inf__multiset__iff,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: A] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( pp(member(A,X,aa(multiset(A),set(A),set_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A4))))
      <=> ! [X4: multiset(A)] :
            ( pp(member(multiset(A),X4,A4))
           => pp(member(A,X,aa(multiset(A),set(A),set_mset(A),X4))) ) ) ) ).

% in_Inf_multiset_iff
tff(fact_4372_infinite__set__mset__mset__set,axiom,
    ! [A: $tType,A4: set(A)] :
      ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
     => ( aa(multiset(A),set(A),set_mset(A),mset_set(A,A4)) = bot_bot(set(A)) ) ) ).

% infinite_set_mset_mset_set
tff(fact_4373_set__mset__Inf,axiom,
    ! [A: $tType,A4: set(multiset(A))] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( aa(multiset(A),set(A),set_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A4)) = aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(multiset(A)),set(set(A)),image2(multiset(A),set(A),set_mset(A)),A4)) ) ) ).

% set_mset_Inf
tff(fact_4374_set__mset__single,axiom,
    ! [A: $tType,B2: A] : ( aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),B2),zero_zero(multiset(A)))) = aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))) ) ).

% set_mset_single
tff(fact_4375_at__most__one__mset__mset__diff,axiom,
    ! [A: $tType,A3: A,M: multiset(A)] :
      ( ~ pp(member(A,A3,aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),M),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A3),zero_zero(multiset(A)))))))
     => ( aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),M),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A3),zero_zero(multiset(A))))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(multiset(A),set(A),set_mset(A),M)),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) ) ) ).

% at_most_one_mset_mset_diff
tff(fact_4376_one__step__implies__mult,axiom,
    ! [A: $tType,J4: multiset(A),K5: multiset(A),R3: set(product_prod(A,A)),I4: multiset(A)] :
      ( ( J4 != zero_zero(multiset(A)) )
     => ( ! [X2: A] :
            ( pp(member(A,X2,aa(multiset(A),set(A),set_mset(A),K5)))
           => ? [Xa3: A] :
                ( pp(member(A,Xa3,aa(multiset(A),set(A),set_mset(A),J4)))
                & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Xa3),R3)) ) )
       => pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),I4),K5)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),I4),J4)),mult(A,R3))) ) ) ).

% one_step_implies_mult
tff(fact_4377_mult1__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( mult1(A,R3) = aa(fun(product_prod(multiset(A),multiset(A)),bool),set(product_prod(multiset(A),multiset(A))),collect(product_prod(multiset(A),multiset(A))),aa(fun(multiset(A),fun(multiset(A),bool)),fun(product_prod(multiset(A),multiset(A)),bool),product_case_prod(multiset(A),multiset(A),bool),aTP_Lamp_pu(set(product_prod(A,A)),fun(multiset(A),fun(multiset(A),bool)),R3))) ) ).

% mult1_def
tff(fact_4378_less__add,axiom,
    ! [A: $tType,N4: multiset(A),A3: A,M0: multiset(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),N4),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A3),M0)),mult1(A,R3)))
     => ( ? [M7: multiset(A)] :
            ( pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),M7),M0),mult1(A,R3)))
            & ( N4 = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A3),M7) ) )
        | ? [K7: multiset(A)] :
            ( ! [B10: A] :
                ( pp(member(A,B10,aa(multiset(A),set(A),set_mset(A),K7)))
               => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B10),A3),R3)) )
            & ( N4 = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),M0),K7) ) ) ) ) ).

% less_add
tff(fact_4379_mult1I,axiom,
    ! [A: $tType,M: multiset(A),A3: A,M0: multiset(A),N4: multiset(A),K5: multiset(A),R3: set(product_prod(A,A))] :
      ( ( M = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A3),M0) )
     => ( ( N4 = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),M0),K5) )
       => ( ! [B5: A] :
              ( pp(member(A,B5,aa(multiset(A),set(A),set_mset(A),K5)))
             => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B5),A3),R3)) )
         => pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),N4),M),mult1(A,R3))) ) ) ) ).

% mult1I
tff(fact_4380_mult1E,axiom,
    ! [A: $tType,N4: multiset(A),M: multiset(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),N4),M),mult1(A,R3)))
     => ~ ! [A8: A,M02: multiset(A)] :
            ( ( M = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A8),M02) )
           => ! [K7: multiset(A)] :
                ( ( N4 = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),M02),K7) )
               => ~ ! [B10: A] :
                      ( pp(member(A,B10,aa(multiset(A),set(A),set_mset(A),K7)))
                     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B10),A8),R3)) ) ) ) ) ).

% mult1E
tff(fact_4381_not__less__empty,axiom,
    ! [A: $tType,M: multiset(A),R3: set(product_prod(A,A))] : ~ pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),M),zero_zero(multiset(A))),mult1(A,R3))) ).

% not_less_empty
tff(fact_4382_mult1__union,axiom,
    ! [A: $tType,B3: multiset(A),D4: multiset(A),R3: set(product_prod(A,A)),C3: multiset(A)] :
      ( pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),B3),D4),mult1(A,R3)))
     => pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),C3),B3)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),C3),D4)),mult1(A,R3))) ) ).

% mult1_union
tff(fact_4383_mult1__lessE,axiom,
    ! [A: $tType,N4: multiset(A),M: multiset(A),R3: fun(A,fun(A,bool))] :
      ( pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),N4),M),mult1(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R3)))))
     => ( asymp(A,R3)
       => ~ ! [A8: A,M02: multiset(A)] :
              ( ( M = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A8),M02) )
             => ! [K7: multiset(A)] :
                  ( ( N4 = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),M02),K7) )
                 => ( ~ pp(member(A,A8,aa(multiset(A),set(A),set_mset(A),K7)))
                   => ~ ! [B10: A] :
                          ( pp(member(A,B10,aa(multiset(A),set(A),set_mset(A),K7)))
                         => pp(aa(A,bool,aa(A,fun(A,bool),R3,B10),A8)) ) ) ) ) ) ) ).

% mult1_lessE
tff(fact_4384_sum__wcount__Int,axiom,
    ! [A: $tType,A4: set(A),F: fun(A,nat),N4: multiset(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),wcount(A,F,N4)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(multiset(A),set(A),set_mset(A),N4))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),wcount(A,F,N4)),A4) ) ) ).

% sum_wcount_Int
tff(fact_4385_wmsI,axiom,
    ! [A4: multiset(product_prod(nat,nat)),B3: multiset(product_prod(nat,nat)),Z6: multiset(product_prod(nat,nat))] :
      ( ( pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),A4)),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),B3)),fun_max_strict))
        | ( ( A4 = zero_zero(multiset(product_prod(nat,nat))) )
          & ( B3 = zero_zero(multiset(product_prod(nat,nat))) ) ) )
     => pp(member(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_Pair(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),A4)),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),B3)),ms_weak)) ) ).

% wmsI
tff(fact_4386_smsI,axiom,
    ! [A4: multiset(product_prod(nat,nat)),B3: multiset(product_prod(nat,nat)),Z6: multiset(product_prod(nat,nat))] :
      ( pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),A4)),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),B3)),fun_max_strict))
     => pp(member(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_Pair(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),A4)),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),B3)),ms_strict)) ) ).

% smsI
tff(fact_4387_ms__reduction__pair,axiom,
    fun_reduction_pair(multiset(product_prod(nat,nat)),aa(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_prod(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))))),aa(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),fun(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_prod(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))))),product_Pair(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))))),ms_strict),ms_weak)) ).

% ms_reduction_pair
tff(fact_4388_ms__strictI,axiom,
    ! [Z6: multiset(product_prod(nat,nat)),Z7: multiset(product_prod(nat,nat)),A4: multiset(product_prod(nat,nat)),B3: multiset(product_prod(nat,nat))] :
      ( pw_leq(Z6,Z7)
     => ( pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),A4)),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),B3)),fun_max_strict))
       => pp(member(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_Pair(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),A4)),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z7),B3)),ms_strict)) ) ) ).

% ms_strictI
tff(fact_4389_ms__weakI1,axiom,
    ! [Z6: multiset(product_prod(nat,nat)),Z7: multiset(product_prod(nat,nat)),A4: multiset(product_prod(nat,nat)),B3: multiset(product_prod(nat,nat))] :
      ( pw_leq(Z6,Z7)
     => ( pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),A4)),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),B3)),fun_max_strict))
       => pp(member(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_Pair(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),A4)),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z7),B3)),ms_weak)) ) ) ).

% ms_weakI1
tff(fact_4390_pw__leq__split,axiom,
    ! [X6: multiset(product_prod(nat,nat)),Y5: multiset(product_prod(nat,nat))] :
      ( pw_leq(X6,Y5)
     => ? [A12: multiset(product_prod(nat,nat)),B9: multiset(product_prod(nat,nat)),Z8: multiset(product_prod(nat,nat))] :
          ( ( X6 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),A12),Z8) )
          & ( Y5 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),B9),Z8) )
          & ( pp(member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),A12)),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),B9)),fun_max_strict))
            | ( ( B9 = zero_zero(multiset(product_prod(nat,nat))) )
              & ( A12 = zero_zero(multiset(product_prod(nat,nat))) ) ) ) ) ) ).

% pw_leq_split
tff(fact_4391_ms__weakI2,axiom,
    ! [Z6: multiset(product_prod(nat,nat)),Z7: multiset(product_prod(nat,nat))] :
      ( pw_leq(Z6,Z7)
     => pp(member(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_Pair(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),zero_zero(multiset(product_prod(nat,nat))))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z7),zero_zero(multiset(product_prod(nat,nat))))),ms_weak)) ) ).

% ms_weakI2
tff(fact_4392_pw__leq__lstep,axiom,
    ! [X: product_prod(nat,nat),Y: product_prod(nat,nat)] :
      ( pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_leq))
     => pw_leq(aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),X),zero_zero(multiset(product_prod(nat,nat)))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),Y),zero_zero(multiset(product_prod(nat,nat))))) ) ).

% pw_leq_lstep
tff(fact_4393_pw__leq__step,axiom,
    ! [X: product_prod(nat,nat),Y: product_prod(nat,nat),X6: multiset(product_prod(nat,nat)),Y5: multiset(product_prod(nat,nat))] :
      ( pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_leq))
     => ( pw_leq(X6,Y5)
       => pw_leq(aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),X),zero_zero(multiset(product_prod(nat,nat))))),X6),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),Y),zero_zero(multiset(product_prod(nat,nat))))),Y5)) ) ) ).

% pw_leq_step
tff(fact_4394_pw__leq_Osimps,axiom,
    ! [A1: multiset(product_prod(nat,nat)),A22: multiset(product_prod(nat,nat))] :
      ( pw_leq(A1,A22)
    <=> ( ( ( A1 = zero_zero(multiset(product_prod(nat,nat))) )
          & ( A22 = zero_zero(multiset(product_prod(nat,nat))) ) )
        | ? [X4: product_prod(nat,nat),Y3: product_prod(nat,nat),X8: multiset(product_prod(nat,nat)),Y8: multiset(product_prod(nat,nat))] :
            ( ( A1 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),X4),zero_zero(multiset(product_prod(nat,nat))))),X8) )
            & ( A22 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),Y3),zero_zero(multiset(product_prod(nat,nat))))),Y8) )
            & pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X4),Y3),fun_pair_leq))
            & pw_leq(X8,Y8) ) ) ) ).

% pw_leq.simps
tff(fact_4395_pw__leq_Ocases,axiom,
    ! [A1: multiset(product_prod(nat,nat)),A22: multiset(product_prod(nat,nat))] :
      ( pw_leq(A1,A22)
     => ( ( ( A1 = zero_zero(multiset(product_prod(nat,nat))) )
         => ( A22 != zero_zero(multiset(product_prod(nat,nat))) ) )
       => ~ ! [X2: product_prod(nat,nat),Y2: product_prod(nat,nat),X7: multiset(product_prod(nat,nat))] :
              ( ( A1 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),X2),zero_zero(multiset(product_prod(nat,nat))))),X7) )
             => ! [Y9: multiset(product_prod(nat,nat))] :
                  ( ( A22 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),Y2),zero_zero(multiset(product_prod(nat,nat))))),Y9) )
                 => ( pp(member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X2),Y2),fun_pair_leq))
                   => ~ pw_leq(X7,Y9) ) ) ) ) ) ).

% pw_leq.cases
tff(fact_4396_set__mset__replicate__mset__subset,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N = zero_zero(nat) )
       => ( aa(multiset(A),set(A),set_mset(A),replicate_mset(A,N,X)) = bot_bot(set(A)) ) )
      & ( ( N != zero_zero(nat) )
       => ( aa(multiset(A),set(A),set_mset(A),replicate_mset(A,N,X)) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ) ) ).

% set_mset_replicate_mset_subset
tff(fact_4397_mult__cancel__max0,axiom,
    ! [A: $tType,S: set(product_prod(A,A)),X6: multiset(A),Y5: multiset(A)] :
      ( trans(A,S)
     => ( irrefl(A,S)
       => ( pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),X6),Y5),mult(A,S)))
        <=> pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),X6),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X6),Y5))),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),Y5),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X6),Y5))),mult(A,S))) ) ) ) ).

% mult_cancel_max0
tff(fact_4398_prod__mset_Oremove,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [X: A,A4: multiset(A)] :
          ( pp(member(A,X,aa(multiset(A),set(A),set_mset(A),A4)))
         => ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),A4) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),minus_minus(multiset(A)),A4),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X),zero_zero(multiset(A)))))) ) ) ) ).

% prod_mset.remove
tff(fact_4399_add_Ogroup__axioms,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => group(A,plus_plus(A),zero_zero(A),uminus_uminus(A)) ) ).

% add.group_axioms
tff(fact_4400_set__mset__inter,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A)] : ( aa(multiset(A),set(A),set_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),A4),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(multiset(A),set(A),set_mset(A),A4)),aa(multiset(A),set(A),set_mset(A),B3)) ) ).

% set_mset_inter
tff(fact_4401_prod__mset__empty,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),zero_zero(multiset(A))) = one_one(A) ) ) ).

% prod_mset_empty
tff(fact_4402_prod__mset_Oadd__mset,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [X: A,N4: multiset(A)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),X),N4)) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),N4)) ) ) ).

% prod_mset.add_mset
tff(fact_4403_prod__mset__Un,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: multiset(A),B3: multiset(A)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),A4),B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),A4)),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),B3)) ) ) ).

% prod_mset_Un
tff(fact_4404_prod__mset_Ounion,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: multiset(A),N4: multiset(A)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),M),N4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),M)),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),N4)) ) ) ).

% prod_mset.union
tff(fact_4405_group_Oleft__cancel,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A3: A,B2: A,C2: A] :
      ( group(A,F,Z2,Inverse)
     => ( ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = aa(A,A,aa(A,fun(A,A),F,A3),C2) )
      <=> ( B2 = C2 ) ) ) ).

% group.left_cancel
tff(fact_4406_group_Oleft__inverse,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A3: A] :
      ( group(A,F,Z2,Inverse)
     => ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,Inverse,A3)),A3) = Z2 ) ) ).

% group.left_inverse
tff(fact_4407_group_Oright__cancel,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),B2: A,A3: A,C2: A] :
      ( group(A,F,Z2,Inverse)
     => ( ( aa(A,A,aa(A,fun(A,A),F,B2),A3) = aa(A,A,aa(A,fun(A,A),F,C2),A3) )
      <=> ( B2 = C2 ) ) ) ).

% group.right_cancel
tff(fact_4408_group_Oright__inverse,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A3: A] :
      ( group(A,F,Z2,Inverse)
     => ( aa(A,A,aa(A,fun(A,A),F,A3),aa(A,A,Inverse,A3)) = Z2 ) ) ).

% group.right_inverse
tff(fact_4409_group_Oinverse__unique,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A3: A,B2: A] :
      ( group(A,F,Z2,Inverse)
     => ( ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = Z2 )
       => ( aa(A,A,Inverse,A3) = B2 ) ) ) ).

% group.inverse_unique
tff(fact_4410_group_Oinverse__inverse,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A3: A] :
      ( group(A,F,Z2,Inverse)
     => ( aa(A,A,Inverse,aa(A,A,Inverse,A3)) = A3 ) ) ).

% group.inverse_inverse
tff(fact_4411_group_Oinverse__neutral,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( group(A,F,Z2,Inverse)
     => ( aa(A,A,Inverse,Z2) = Z2 ) ) ).

% group.inverse_neutral
tff(fact_4412_group_Ogroup__left__neutral,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A3: A] :
      ( group(A,F,Z2,Inverse)
     => ( aa(A,A,aa(A,fun(A,A),F,Z2),A3) = A3 ) ) ).

% group.group_left_neutral
tff(fact_4413_group_Oinverse__distrib__swap,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A),A3: A,B2: A] :
      ( group(A,F,Z2,Inverse)
     => ( aa(A,A,Inverse,aa(A,A,aa(A,fun(A,A),F,A3),B2)) = aa(A,A,aa(A,fun(A,A),F,aa(A,A,Inverse,B2)),aa(A,A,Inverse,A3)) ) ) ).

% group.inverse_distrib_swap
tff(fact_4414_group_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( group(A,F,Z2,Inverse)
     => semigroup(A,F) ) ).

% group.axioms(1)
tff(fact_4415_prod__mset_Oneutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: multiset(A)] :
          ( ! [X2: A] :
              ( pp(member(A,X2,aa(multiset(A),set(A),set_mset(A),A4)))
             => ( X2 = one_one(A) ) )
         => ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),A4) = one_one(A) ) ) ) ).

% prod_mset.neutral
tff(fact_4416_is__unit__prod__mset__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A4: multiset(A)] :
          ( pp(dvd_dvd(A,aa(multiset(A),A,comm_m9189036328036947845d_mset(A),A4),one_one(A)))
        <=> ! [X4: A] :
              ( pp(member(A,X4,aa(multiset(A),set(A),set_mset(A),A4)))
             => pp(dvd_dvd(A,X4,one_one(A))) ) ) ) ).

% is_unit_prod_mset_iff
tff(fact_4417_group__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( group(A,F,Z2,Inverse)
    <=> ( semigroup(A,F)
        & group_axioms(A,F,Z2,Inverse) ) ) ).

% group_def
tff(fact_4418_group_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( semigroup(A,F)
     => ( group_axioms(A,F,Z2,Inverse)
       => group(A,F,Z2,Inverse) ) ) ).

% group.intro
tff(fact_4419_prod__mset_Oeq__fold,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: multiset(A)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),M) = aa(multiset(A),A,fold_mset(A,A,times_times(A),one_one(A)),M) ) ) ).

% prod_mset.eq_fold
tff(fact_4420_subset__mset_OInf__fin_Oinsert,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),A4)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4)) ) ) ) ).

% subset_mset.Inf_fin.insert
tff(fact_4421_subset__mset_OInf__fin_Osingleton,axiom,
    ! [A: $tType,X: multiset(A)] : ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) = X ) ).

% subset_mset.Inf_fin.singleton
tff(fact_4422_group__axioms__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( group_axioms(A,F,Z2,Inverse)
    <=> ( ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F,Z2),A6) = A6 )
        & ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,Inverse,A6)),A6) = Z2 ) ) ) ).

% group_axioms_def
tff(fact_4423_group__axioms_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( ! [A8: A] : ( aa(A,A,aa(A,fun(A,A),F,Z2),A8) = A8 )
     => ( ! [A8: A] : ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,Inverse,A8)),A8) = Z2 )
       => group_axioms(A,F,Z2,Inverse) ) ) ).

% group_axioms.intro
tff(fact_4424_subset__mset_OInf__fin_Ounion,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),B3))
         => ( ( B3 != bot_bot(set(multiset(A))) )
           => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),sup_sup(set(multiset(A))),A4),B3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4)),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),B3)) ) ) ) ) ) ).

% subset_mset.Inf_fin.union
tff(fact_4425_subset__mset_OInf__fin_Osubset,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( B3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),B3),A4))
         => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),B3)),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4)) = lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4) ) ) ) ) ).

% subset_mset.Inf_fin.subset
tff(fact_4426_subset__mset_OInf__fin_Ohom__commute,axiom,
    ! [A: $tType,H2: fun(multiset(A),multiset(A)),N4: set(multiset(A))] :
      ( ! [X2: multiset(A),Y2: multiset(A)] : ( aa(multiset(A),multiset(A),H2,aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X2),Y2)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(multiset(A),multiset(A),H2,X2)),aa(multiset(A),multiset(A),H2,Y2)) )
     => ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),N4))
       => ( ( N4 != bot_bot(set(multiset(A))) )
         => ( aa(multiset(A),multiset(A),H2,lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),N4)) = lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),image2(multiset(A),multiset(A),H2),N4)) ) ) ) ) ).

% subset_mset.Inf_fin.hom_commute
tff(fact_4427_group_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Inverse: fun(A,A)] :
      ( group(A,F,Z2,Inverse)
     => group_axioms(A,F,Z2,Inverse) ) ).

% group.axioms(2)
tff(fact_4428_subset__mset_OcInf__eq__Inf__fin,axiom,
    ! [A: $tType,X6: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),X6))
     => ( ( X6 != bot_bot(set(multiset(A))) )
       => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X6) = lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),X6) ) ) ) ).

% subset_mset.cInf_eq_Inf_fin
tff(fact_4429_subset__mset_OInf__fin_Oremove,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( pp(member(multiset(A),X,A4))
       => ( ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) = bot_bot(set(multiset(A))) )
           => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4) = X ) )
          & ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) != bot_bot(set(multiset(A))) )
           => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))))) ) ) ) ) ) ).

% subset_mset.Inf_fin.remove
tff(fact_4430_subset__mset_OInf__fin_Oinsert__remove,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) = bot_bot(set(multiset(A))) )
         => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),A4)) = X ) )
        & ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) != bot_bot(set(multiset(A))) )
         => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),A4)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))))) ) ) ) ) ).

% subset_mset.Inf_fin.insert_remove
tff(fact_4431_subset__mset_OInf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ~ pp(member(multiset(A),X,A4))
       => ( ( A4 != bot_bot(set(multiset(A))) )
         => ( lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),A4)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4)) ) ) ) ) ).

% subset_mset.Inf_fin.insert_not_elem
tff(fact_4432_subset__mset_OInf__fin_Oclosed,axiom,
    ! [A: $tType,A4: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( ! [X2: multiset(A),Y2: multiset(A)] : pp(member(multiset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X2),Y2),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X2),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),Y2),bot_bot(set(multiset(A)))))))
         => pp(member(multiset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4),A4)) ) ) ) ).

% subset_mset.Inf_fin.closed
tff(fact_4433_subset__mset_Osup__Inf1__distrib,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4)) = lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_pv(set(multiset(A)),fun(multiset(A),fun(multiset(A),bool)),A4),X))) ) ) ) ).

% subset_mset.sup_Inf1_distrib
tff(fact_4434_subset__mset_Osup__Inf2__distrib,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),B3))
         => ( ( B3 != bot_bot(set(multiset(A))) )
           => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4)),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),B3)) = lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(set(multiset(A)),fun(multiset(A),bool),aTP_Lamp_pw(set(multiset(A)),fun(set(multiset(A)),fun(multiset(A),bool)),A4),B3))) ) ) ) ) ) ).

% subset_mset.sup_Inf2_distrib
tff(fact_4435_subset__mset_OInf__fin_Obounded__iff,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4)))
        <=> ! [X4: multiset(A)] :
              ( pp(member(multiset(A),X4,A4))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X),X4)) ) ) ) ) ).

% subset_mset.Inf_fin.bounded_iff
tff(fact_4436_subset__mset_OInf__fin_OboundedI,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( ! [A8: multiset(A)] :
              ( pp(member(multiset(A),A8,A4))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X),A8)) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4))) ) ) ) ).

% subset_mset.Inf_fin.boundedI
tff(fact_4437_subset__mset_Omonoid__axioms,axiom,
    ! [A: $tType] : monoid(multiset(A),union_mset(A),zero_zero(multiset(A))) ).

% subset_mset.monoid_axioms
tff(fact_4438_subset__mset_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] : semilattice_neutr(multiset(A),union_mset(A),zero_zero(multiset(A))) ).

% subset_mset.semilattice_neutr_axioms
tff(fact_4439_subset__mset_OcInf__eq__non__empty,axiom,
    ! [A: $tType,X6: set(multiset(A)),A3: multiset(A)] :
      ( ( X6 != bot_bot(set(multiset(A))) )
     => ( ! [X2: multiset(A)] :
            ( pp(member(multiset(A),X2,X6))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A3),X2)) )
       => ( ! [Y2: multiset(A)] :
              ( ! [X3: multiset(A)] :
                  ( pp(member(multiset(A),X3,X6))
                 => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Y2),X3)) )
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Y2),A3)) )
         => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X6) = A3 ) ) ) ) ).

% subset_mset.cInf_eq_non_empty
tff(fact_4440_subset__mset_OcInf__greatest,axiom,
    ! [A: $tType,X6: set(multiset(A)),Z2: multiset(A)] :
      ( ( X6 != bot_bot(set(multiset(A))) )
     => ( ! [X2: multiset(A)] :
            ( pp(member(multiset(A),X2,X6))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Z2),X2)) )
       => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Z2),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X6))) ) ) ).

% subset_mset.cInf_greatest
tff(fact_4441_subset__mset_OcSup__least,axiom,
    ! [A: $tType,X6: set(multiset(A)),Z2: multiset(A)] :
      ( ( X6 != bot_bot(set(multiset(A))) )
     => ( ! [X2: multiset(A)] :
            ( pp(member(multiset(A),X2,X6))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X2),Z2)) )
       => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),X6)),Z2)) ) ) ).

% subset_mset.cSup_least
tff(fact_4442_subset__mset_OcSup__eq__non__empty,axiom,
    ! [A: $tType,X6: set(multiset(A)),A3: multiset(A)] :
      ( ( X6 != bot_bot(set(multiset(A))) )
     => ( ! [X2: multiset(A)] :
            ( pp(member(multiset(A),X2,X6))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X2),A3)) )
       => ( ! [Y2: multiset(A)] :
              ( ! [X3: multiset(A)] :
                  ( pp(member(multiset(A),X3,X6))
                 => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X3),Y2)) )
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A3),Y2)) )
         => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),X6) = A3 ) ) ) ) ).

% subset_mset.cSup_eq_non_empty
tff(fact_4443_subset__mset_Ofinite__has__minimal,axiom,
    ! [A: $tType,A4: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ? [X2: multiset(A)] :
            ( pp(member(multiset(A),X2,A4))
            & ! [Xa3: multiset(A)] :
                ( pp(member(multiset(A),Xa3,A4))
               => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Xa3),X2))
                 => ( X2 = Xa3 ) ) ) ) ) ) ).

% subset_mset.finite_has_minimal
tff(fact_4444_subset__mset_Ofinite__has__maximal,axiom,
    ! [A: $tType,A4: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ? [X2: multiset(A)] :
            ( pp(member(multiset(A),X2,A4))
            & ! [Xa3: multiset(A)] :
                ( pp(member(multiset(A),Xa3,A4))
               => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X2),Xa3))
                 => ( X2 = Xa3 ) ) ) ) ) ) ).

% subset_mset.finite_has_maximal
tff(fact_4445_subset__mset_OcINF__greatest,axiom,
    ! [A: $tType,B: $tType,A4: set(B),M4: multiset(A),F: fun(B,multiset(A))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( ! [X2: B] :
            ( pp(member(B,X2,A4))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),M4),aa(B,multiset(A),F,X2))) )
       => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),M4),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4)))) ) ) ).

% subset_mset.cINF_greatest
tff(fact_4446_subset__mset_OcSUP__least,axiom,
    ! [B: $tType,A: $tType,A4: set(B),F: fun(B,multiset(A)),M: multiset(A)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( ! [X2: B] :
            ( pp(member(B,X2,A4))
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),F,X2)),M)) )
       => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))),M)) ) ) ).

% subset_mset.cSUP_least
tff(fact_4447_subset__mset_OInf__fin_Osubset__imp,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),A4),B3))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),B3))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),B3)),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4))) ) ) ) ).

% subset_mset.Inf_fin.subset_imp
tff(fact_4448_subset__mset_OInf__fin_OboundedE,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4)))
         => ! [A13: multiset(A)] :
              ( pp(member(multiset(A),A13,A4))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X),A13)) ) ) ) ) ).

% subset_mset.Inf_fin.boundedE
tff(fact_4449_subset__mset_OInf__fin__le__Sup__fin,axiom,
    ! [A: $tType,A4: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic8678736583308907530nf_fin(multiset(A),inter_mset(A),A4)),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4))) ) ) ).

% subset_mset.Inf_fin_le_Sup_fin
tff(fact_4450_subset__mset_OSup__fin_Oinsert__remove,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) = bot_bot(set(multiset(A))) )
         => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),A4)) = X ) )
        & ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) != bot_bot(set(multiset(A))) )
         => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),A4)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X),lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))))) ) ) ) ) ).

% subset_mset.Sup_fin.insert_remove
tff(fact_4451_subset__mset_OSup__fin_Oremove,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( pp(member(multiset(A),X,A4))
       => ( ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) = bot_bot(set(multiset(A))) )
           => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4) = X ) )
          & ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) != bot_bot(set(multiset(A))) )
           => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X),lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),A4),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))))) ) ) ) ) ) ).

% subset_mset.Sup_fin.remove
tff(fact_4452_subset__mset_Oinf__Sup2__distrib,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),B3))
         => ( ( B3 != bot_bot(set(multiset(A))) )
           => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4)),lattic4630905495605216202up_fin(multiset(A),union_mset(A),B3)) = lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(set(multiset(A)),fun(multiset(A),bool),aTP_Lamp_px(set(multiset(A)),fun(set(multiset(A)),fun(multiset(A),bool)),A4),B3))) ) ) ) ) ) ).

% subset_mset.inf_Sup2_distrib
tff(fact_4453_subset__mset_OSup__fin_Osingleton,axiom,
    ! [A: $tType,X: multiset(A)] : ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) = X ) ).

% subset_mset.Sup_fin.singleton
tff(fact_4454_subset__mset_OSup__fin_Oinsert,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),A4)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4)) ) ) ) ).

% subset_mset.Sup_fin.insert
tff(fact_4455_subset__mset_OSup__fin_Obounded__iff,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4)),X))
        <=> ! [X4: multiset(A)] :
              ( pp(member(multiset(A),X4,A4))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X4),X)) ) ) ) ) ).

% subset_mset.Sup_fin.bounded_iff
tff(fact_4456_subset__mset_OSup__fin_OboundedI,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( ! [A8: multiset(A)] :
              ( pp(member(multiset(A),A8,A4))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A8),X)) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4)),X)) ) ) ) ).

% subset_mset.Sup_fin.boundedI
tff(fact_4457_subset__mset_OSup__fin_OboundedE,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4)),X))
         => ! [A13: multiset(A)] :
              ( pp(member(multiset(A),A13,A4))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A13),X)) ) ) ) ) ).

% subset_mset.Sup_fin.boundedE
tff(fact_4458_subset__mset_OcSup__eq__Sup__fin,axiom,
    ! [A: $tType,X6: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),X6))
     => ( ( X6 != bot_bot(set(multiset(A))) )
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),X6) = lattic4630905495605216202up_fin(multiset(A),union_mset(A),X6) ) ) ) ).

% subset_mset.cSup_eq_Sup_fin
tff(fact_4459_subset__mset_OSup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ~ pp(member(multiset(A),X,A4))
       => ( ( A4 != bot_bot(set(multiset(A))) )
         => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),A4)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4)) ) ) ) ) ).

% subset_mset.Sup_fin.insert_not_elem
tff(fact_4460_subset__mset_OSup__fin_Oclosed,axiom,
    ! [A: $tType,A4: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( ! [X2: multiset(A),Y2: multiset(A)] : pp(member(multiset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X2),Y2),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X2),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),Y2),bot_bot(set(multiset(A)))))))
         => pp(member(multiset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4),A4)) ) ) ) ).

% subset_mset.Sup_fin.closed
tff(fact_4461_subset__mset_OSup__fin_Osubset,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( B3 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),B3),A4))
         => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),B3)),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4)) = lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4) ) ) ) ) ).

% subset_mset.Sup_fin.subset
tff(fact_4462_subset__mset_OSup__fin_Ounion,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),B3))
         => ( ( B3 != bot_bot(set(multiset(A))) )
           => ( lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),sup_sup(set(multiset(A))),A4),B3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4)),lattic4630905495605216202up_fin(multiset(A),union_mset(A),B3)) ) ) ) ) ) ).

% subset_mset.Sup_fin.union
tff(fact_4463_subset__mset_OSup__fin_Ohom__commute,axiom,
    ! [A: $tType,H2: fun(multiset(A),multiset(A)),N4: set(multiset(A))] :
      ( ! [X2: multiset(A),Y2: multiset(A)] : ( aa(multiset(A),multiset(A),H2,aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),X2),Y2)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(multiset(A),multiset(A),H2,X2)),aa(multiset(A),multiset(A),H2,Y2)) )
     => ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),N4))
       => ( ( N4 != bot_bot(set(multiset(A))) )
         => ( aa(multiset(A),multiset(A),H2,lattic4630905495605216202up_fin(multiset(A),union_mset(A),N4)) = lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(set(multiset(A)),set(multiset(A)),image2(multiset(A),multiset(A),H2),N4)) ) ) ) ) ).

% subset_mset.Sup_fin.hom_commute
tff(fact_4464_subset__mset_OSup__fin_Osubset__imp,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),A4),B3))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),B3))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4)),lattic4630905495605216202up_fin(multiset(A),union_mset(A),B3))) ) ) ) ).

% subset_mset.Sup_fin.subset_imp
tff(fact_4465_subset__mset_Oinf__Sup1__distrib,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: multiset(A)] :
      ( pp(aa(set(multiset(A)),bool,finite_finite(multiset(A)),A4))
     => ( ( A4 != bot_bot(set(multiset(A))) )
       => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),X),lattic4630905495605216202up_fin(multiset(A),union_mset(A),A4)) = lattic4630905495605216202up_fin(multiset(A),union_mset(A),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_py(set(multiset(A)),fun(multiset(A),fun(multiset(A),bool)),A4),X))) ) ) ) ).

% subset_mset.inf_Sup1_distrib
tff(fact_4466_subset__mset_Omono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_sup(B)
     => ! [F: fun(multiset(A),B),A4: multiset(A),B3: multiset(A)] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F))
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(multiset(A),B,F,A4)),aa(multiset(A),B,F,B3))),aa(multiset(A),B,F,aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),A4),B3)))) ) ) ).

% subset_mset.mono_sup
tff(fact_4467_subset__mset_Omono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( semilattice_inf(B)
     => ! [F: fun(multiset(A),B),A4: multiset(A),B3: multiset(A)] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F))
         => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(multiset(A),B,F,aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),A4),B3))),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(multiset(A),B,F,A4)),aa(multiset(A),B,F,B3)))) ) ) ).

% subset_mset.mono_inf
tff(fact_4468_subset__mset_OcINF__union,axiom,
    ! [A: $tType,B: $tType,A4: set(B),F: fun(B,multiset(A)),B3: set(B)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))
       => ( ( B3 != bot_bot(set(B)) )
         => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),B3))
           => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),B3))) ) ) ) ) ) ).

% subset_mset.cINF_union
tff(fact_4469_subset__mset_OcINF__insert,axiom,
    ! [A: $tType,B: $tType,A4: set(B),F: fun(B,multiset(A)),A3: B] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))
       => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),aa(set(B),set(B),insert2(B,A3),A4))) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(B,multiset(A),F,A3)),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))) ) ) ) ).

% subset_mset.cINF_insert
tff(fact_4470_subset__mset_Obdd__below__empty,axiom,
    ! [A: $tType] : condit8119078960628432327_below(multiset(A),subseteq_mset(A),bot_bot(set(multiset(A)))) ).

% subset_mset.bdd_below_empty
tff(fact_4471_order_Omono_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [Less_eq: fun(A,fun(A,bool))] : ( mono(A,B,Less_eq) = mono(A,B,Less_eq) ) ) ).

% order.mono.cong
tff(fact_4472_subset__mset_Obdd__below__Int2,axiom,
    ! [A: $tType,B3: set(multiset(A)),A4: set(multiset(A))] :
      ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),B3)
     => condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A4),B3)) ) ).

% subset_mset.bdd_below_Int2
tff(fact_4473_subset__mset_Obdd__below__Int1,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),A4)
     => condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A4),B3)) ) ).

% subset_mset.bdd_below_Int1
tff(fact_4474_subset__mset_OcInf__mono,axiom,
    ! [A: $tType,B3: set(multiset(A)),A4: set(multiset(A))] :
      ( ( B3 != bot_bot(set(multiset(A))) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),A4)
       => ( ! [B5: multiset(A)] :
              ( pp(member(multiset(A),B5,B3))
             => ? [X3: multiset(A)] :
                  ( pp(member(multiset(A),X3,A4))
                  & pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X3),B5)) ) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A4)),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),B3))) ) ) ) ).

% subset_mset.cInf_mono
tff(fact_4475_subset__mset_Ole__cInf__iff,axiom,
    ! [A: $tType,S2: set(multiset(A)),A3: multiset(A)] :
      ( ( S2 != bot_bot(set(multiset(A))) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),S2)
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A3),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),S2)))
        <=> ! [X4: multiset(A)] :
              ( pp(member(multiset(A),X4,S2))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A3),X4)) ) ) ) ) ).

% subset_mset.le_cInf_iff
tff(fact_4476_subset__mset_Omono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F: fun(multiset(A),B),A4: set(multiset(A))] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F))
         => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),A4)
           => ( ( A4 != bot_bot(set(multiset(A))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(multiset(A),B,F,aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A4))),aa(set(B),B,complete_Inf_Inf(B),aa(set(multiset(A)),set(B),image2(multiset(A),B,F),A4)))) ) ) ) ) ).

% subset_mset.mono_cInf
tff(fact_4477_subset__mset_Ole__cINF__iff,axiom,
    ! [A: $tType,B: $tType,A4: set(B),F: fun(B,multiset(A)),U: multiset(A)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),U),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))))
        <=> ! [X4: B] :
              ( pp(member(B,X4,A4))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),U),aa(B,multiset(A),F,X4))) ) ) ) ) ).

% subset_mset.le_cINF_iff
tff(fact_4478_subset__mset_OcINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType,B3: set(B),F: fun(C,multiset(A)),A4: set(C),G: fun(B,multiset(A))] :
      ( ( B3 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(C),set(multiset(A)),image2(C,multiset(A),F),A4))
       => ( ! [M5: B] :
              ( pp(member(B,M5,B3))
             => ? [X3: C] :
                  ( pp(member(C,X3,A4))
                  & pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(C,multiset(A),F,X3)),aa(B,multiset(A),G,M5))) ) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(C),set(multiset(A)),image2(C,multiset(A),F),A4))),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),B3)))) ) ) ) ).

% subset_mset.cINF_mono
tff(fact_4479_subset__mset_Oless__eq__cInf__inter,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),A4)
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),B3)
       => ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A4),B3) != bot_bot(set(multiset(A))) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A4)),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),B3))),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A4),B3)))) ) ) ) ).

% subset_mset.less_eq_cInf_inter
tff(fact_4480_subset__mset_Omono__cINF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F: fun(multiset(A),B),A4: fun(C,multiset(A)),I4: set(C)] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F))
         => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(C),set(multiset(A)),image2(C,multiset(A),A4),I4))
           => ( ( I4 != bot_bot(set(C)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(multiset(A),B,F,aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(C),set(multiset(A)),image2(C,multiset(A),A4),I4)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(C,multiset(A)),fun(C,B),aTP_Lamp_pz(fun(multiset(A),B),fun(fun(C,multiset(A)),fun(C,B)),F),A4)),I4)))) ) ) ) ) ).

% subset_mset.mono_cINF
tff(fact_4481_subset__mset_OcInf__superset__mono,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),B3)
       => ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),A4),B3))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),B3)),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A4))) ) ) ) ).

% subset_mset.cInf_superset_mono
tff(fact_4482_subset__mset_OcInf__cSup,axiom,
    ! [A: $tType,S2: set(multiset(A))] :
      ( ( S2 != bot_bot(set(multiset(A))) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),S2)
       => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),S2) = aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aTP_Lamp_qa(set(multiset(A)),fun(multiset(A),bool),S2))) ) ) ) ).

% subset_mset.cInf_cSup
tff(fact_4483_subset__mset_OcINF__superset__mono,axiom,
    ! [A: $tType,B: $tType,A4: set(B),G: fun(B,multiset(A)),B3: set(B),F: fun(B,multiset(A))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),B3))
       => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A4),B3))
         => ( ! [X2: B] :
                ( pp(member(B,X2,B3))
               => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),G,X2)),aa(B,multiset(A),F,X2))) )
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),B3))),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4)))) ) ) ) ) ).

% subset_mset.cINF_superset_mono
tff(fact_4484_subset__mset_OcInf__insert__If,axiom,
    ! [A: $tType,X6: set(multiset(A)),A3: multiset(A)] :
      ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),X6)
     => ( ( ( X6 = bot_bot(set(multiset(A))) )
         => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),A3),X6)) = A3 ) )
        & ( ( X6 != bot_bot(set(multiset(A))) )
         => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),A3),X6)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),A3),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X6)) ) ) ) ) ).

% subset_mset.cInf_insert_If
tff(fact_4485_subset__mset_OcInf__insert,axiom,
    ! [A: $tType,X6: set(multiset(A)),A3: multiset(A)] :
      ( ( X6 != bot_bot(set(multiset(A))) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),X6)
       => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),A3),X6)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),A3),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X6)) ) ) ) ).

% subset_mset.cInf_insert
tff(fact_4486_subset__mset_OcINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType,A4: set(B),F: fun(B,multiset(A)),G: fun(B,multiset(A))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))
       => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),A4))
         => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),A4))) = aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),aa(fun(B,multiset(A)),fun(B,multiset(A)),aTP_Lamp_qb(fun(B,multiset(A)),fun(fun(B,multiset(A)),fun(B,multiset(A))),F),G)),A4)) ) ) ) ) ).

% subset_mset.cINF_inf_distrib
tff(fact_4487_subset__mset_OcInf__union__distrib,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),A4)
       => ( ( B3 != bot_bot(set(multiset(A))) )
         => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),B3)
           => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),sup_sup(set(multiset(A))),A4),B3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A4)),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),B3)) ) ) ) ) ) ).

% subset_mset.cInf_union_distrib
tff(fact_4488_subset__mset_Omono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F: fun(multiset(A),B),A4: fun(C,multiset(A)),I4: set(C)] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F))
         => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(C),set(multiset(A)),image2(C,multiset(A),A4),I4))
           => ( ( I4 != bot_bot(set(C)) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(C,multiset(A)),fun(C,B),aTP_Lamp_pz(fun(multiset(A),B),fun(fun(C,multiset(A)),fun(C,B)),F),A4)),I4))),aa(multiset(A),B,F,aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(C),set(multiset(A)),image2(C,multiset(A),A4),I4))))) ) ) ) ) ).

% subset_mset.mono_cSUP
tff(fact_4489_subset__mset_Omono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [F: fun(multiset(A),B),A4: set(multiset(A))] :
          ( pp(aa(fun(multiset(A),B),bool,mono(multiset(A),B,subseteq_mset(A)),F))
         => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4)
           => ( ( A4 != bot_bot(set(multiset(A))) )
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(multiset(A)),set(B),image2(multiset(A),B,F),A4))),aa(multiset(A),B,F,aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A4)))) ) ) ) ) ).

% subset_mset.mono_cSup
tff(fact_4490_subset__mset_OcSUP__union,axiom,
    ! [A: $tType,B: $tType,A4: set(B),F: fun(B,multiset(A)),B3: set(B)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))
       => ( ( B3 != bot_bot(set(B)) )
         => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),B3))
           => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),B3))) ) ) ) ) ) ).

% subset_mset.cSUP_union
tff(fact_4491_subset__mset_OcSUP__insert,axiom,
    ! [A: $tType,B: $tType,A4: set(B),F: fun(B,multiset(A)),A3: B] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),aa(set(B),set(B),insert2(B,A3),A4))) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(B,multiset(A),F,A3)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))) ) ) ) ).

% subset_mset.cSUP_insert
tff(fact_4492_subset__mset_Obdd__above__empty,axiom,
    ! [A: $tType] : condit8047198070973881523_above(multiset(A),subseteq_mset(A),bot_bot(set(multiset(A)))) ).

% subset_mset.bdd_above_empty
tff(fact_4493_subset__mset_Obdd__above__Int1,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4)
     => condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A4),B3)) ) ).

% subset_mset.bdd_above_Int1
tff(fact_4494_subset__mset_Obdd__above__Int2,axiom,
    ! [A: $tType,B3: set(multiset(A)),A4: set(multiset(A))] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),B3)
     => condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A4),B3)) ) ).

% subset_mset.bdd_above_Int2
tff(fact_4495_subset__mset_OcSup__le__iff,axiom,
    ! [A: $tType,S2: set(multiset(A)),A3: multiset(A)] :
      ( ( S2 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),S2)
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),S2)),A3))
        <=> ! [X4: multiset(A)] :
              ( pp(member(multiset(A),X4,S2))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X4),A3)) ) ) ) ) ).

% subset_mset.cSup_le_iff
tff(fact_4496_subset__mset_OcSup__mono,axiom,
    ! [A: $tType,B3: set(multiset(A)),A4: set(multiset(A))] :
      ( ( B3 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4)
       => ( ! [B5: multiset(A)] :
              ( pp(member(multiset(A),B5,B3))
             => ? [X3: multiset(A)] :
                  ( pp(member(multiset(A),X3,A4))
                  & pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),B5),X3)) ) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),B3)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A4))) ) ) ) ).

% subset_mset.cSup_mono
tff(fact_4497_subset__mset_OcSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType,A4: set(B),G: fun(C,multiset(A)),B3: set(C),F: fun(B,multiset(A))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(C),set(multiset(A)),image2(C,multiset(A),G),B3))
       => ( ! [N3: B] :
              ( pp(member(B,N3,A4))
             => ? [X3: C] :
                  ( pp(member(C,X3,B3))
                  & pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),F,N3)),aa(C,multiset(A),G,X3))) ) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(C),set(multiset(A)),image2(C,multiset(A),G),B3)))) ) ) ) ).

% subset_mset.cSUP_mono
tff(fact_4498_subset__mset_OcSUP__le__iff,axiom,
    ! [B: $tType,A: $tType,A4: set(B),F: fun(B,multiset(A)),U: multiset(A)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))
       => ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))),U))
        <=> ! [X4: B] :
              ( pp(member(B,X4,A4))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),F,X4)),U)) ) ) ) ) ).

% subset_mset.cSUP_le_iff
tff(fact_4499_subset__mset_OcSup__inter__less__eq,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4)
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),B3)
       => ( ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A4),B3) != bot_bot(set(multiset(A))) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),A4),B3))),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A4)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),B3)))) ) ) ) ).

% subset_mset.cSup_inter_less_eq
tff(fact_4500_subset__mset_OcSup__subset__mono,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),B3)
       => ( pp(aa(set(multiset(A)),bool,aa(set(multiset(A)),fun(set(multiset(A)),bool),ord_less_eq(set(multiset(A))),A4),B3))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A4)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),B3))) ) ) ) ).

% subset_mset.cSup_subset_mono
tff(fact_4501_subset__mset_OcSup__cInf,axiom,
    ! [A: $tType,S2: set(multiset(A))] :
      ( ( S2 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),S2)
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),S2) = aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(fun(multiset(A),bool),set(multiset(A)),collect(multiset(A)),aTP_Lamp_qc(set(multiset(A)),fun(multiset(A),bool),S2))) ) ) ) ).

% subset_mset.cSup_cInf
tff(fact_4502_subset__mset_OcSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType,A4: set(B),G: fun(B,multiset(A)),B3: set(B),F: fun(B,multiset(A))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),B3))
       => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A4),B3))
         => ( ! [X2: B] :
                ( pp(member(B,X2,A4))
               => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(B,multiset(A),F,X2)),aa(B,multiset(A),G,X2))) )
           => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),B3)))) ) ) ) ) ).

% subset_mset.cSUP_subset_mono
tff(fact_4503_subset__mset_OcSup__insert,axiom,
    ! [A: $tType,X6: set(multiset(A)),A3: multiset(A)] :
      ( ( X6 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),X6)
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),A3),X6)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),A3),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),X6)) ) ) ) ).

% subset_mset.cSup_insert
tff(fact_4504_subset__mset_OcSup__insert__If,axiom,
    ! [A: $tType,X6: set(multiset(A)),A3: multiset(A)] :
      ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),X6)
     => ( ( ( X6 = bot_bot(set(multiset(A))) )
         => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),A3),X6)) = A3 ) )
        & ( ( X6 != bot_bot(set(multiset(A))) )
         => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),A3),X6)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),A3),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),X6)) ) ) ) ) ).

% subset_mset.cSup_insert_If
tff(fact_4505_subset__mset_OcInf__le__cSup,axiom,
    ! [A: $tType,A4: set(multiset(A))] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4)
       => ( condit8119078960628432327_below(multiset(A),subseteq_mset(A),A4)
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A4)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A4))) ) ) ) ).

% subset_mset.cInf_le_cSup
tff(fact_4506_subset__mset_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType,A4: set(B),F: fun(B,multiset(A)),G: fun(B,multiset(A))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))
       => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),A4))
         => ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),F),A4))),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),G),A4))) = aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(B),set(multiset(A)),image2(B,multiset(A),aa(fun(B,multiset(A)),fun(B,multiset(A)),aTP_Lamp_qd(fun(B,multiset(A)),fun(fun(B,multiset(A)),fun(B,multiset(A))),F),G)),A4)) ) ) ) ) ).

% subset_mset.SUP_sup_distrib
tff(fact_4507_subset__mset_OcSup__union__distrib,axiom,
    ! [A: $tType,A4: set(multiset(A)),B3: set(multiset(A))] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4)
       => ( ( B3 != bot_bot(set(multiset(A))) )
         => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),B3)
           => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),sup_sup(set(multiset(A))),A4),B3)) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A4)),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),B3)) ) ) ) ) ) ).

% subset_mset.cSup_union_distrib
tff(fact_4508_bdd__above__multiset__imp__finite__support,axiom,
    ! [A: $tType,A4: set(multiset(A))] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4)
       => pp(aa(set(A),bool,finite_finite(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(multiset(A)),set(set(A)),image2(multiset(A),set(A),aTP_Lamp_qf(multiset(A),set(A))),A4)))) ) ) ).

% bdd_above_multiset_imp_finite_support
tff(fact_4509_Sup__multiset__in__multiset,axiom,
    ! [A: $tType,A4: set(multiset(A))] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4)
       => pp(aa(set(A),bool,finite_finite(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_qh(set(multiset(A)),fun(A,bool),A4)))) ) ) ).

% Sup_multiset_in_multiset
tff(fact_4510_count__Sup__multiset__nonempty,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: A] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4)
       => ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A4)),X) = aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(A)),set(nat),image2(multiset(A),nat,aTP_Lamp_qg(A,fun(multiset(A),nat),X)),A4)) ) ) ) ).

% count_Sup_multiset_nonempty
tff(fact_4511_subset__mset_OatLeastAtMost__singleton__iff,axiom,
    ! [A: $tType,A3: multiset(A),B2: multiset(A),C2: multiset(A)] :
      ( ( set_atLeastAtMost(multiset(A),subseteq_mset(A),A3,B2) = aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),C2),bot_bot(set(multiset(A)))) )
    <=> ( ( A3 = B2 )
        & ( B2 = C2 ) ) ) ).

% subset_mset.atLeastAtMost_singleton_iff
tff(fact_4512_subset__mset_OatLeastatMost__empty__iff,axiom,
    ! [A: $tType,A3: multiset(A),B2: multiset(A)] :
      ( ( set_atLeastAtMost(multiset(A),subseteq_mset(A),A3,B2) = bot_bot(set(multiset(A))) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A3),B2)) ) ).

% subset_mset.atLeastatMost_empty_iff
tff(fact_4513_subset__mset_OatLeastatMost__empty__iff2,axiom,
    ! [A: $tType,A3: multiset(A),B2: multiset(A)] :
      ( ( bot_bot(set(multiset(A))) = set_atLeastAtMost(multiset(A),subseteq_mset(A),A3,B2) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),A3),B2)) ) ).

% subset_mset.atLeastatMost_empty_iff2
tff(fact_4514_subset__mset_OatLeastAtMost__singleton,axiom,
    ! [A: $tType,A3: multiset(A)] : ( set_atLeastAtMost(multiset(A),subseteq_mset(A),A3,A3) = aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),A3),bot_bot(set(multiset(A)))) ) ).

% subset_mset.atLeastAtMost_singleton
tff(fact_4515_Inf__multiset_Orep__eq,axiom,
    ! [A: $tType,X: set(multiset(A)),X3: A] :
      ( ( ( aa(set(multiset(A)),set(fun(A,nat)),image2(multiset(A),fun(A,nat),count(A)),X) = bot_bot(set(fun(A,nat))) )
       => ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X)),X3) = zero_zero(nat) ) )
      & ( ( aa(set(multiset(A)),set(fun(A,nat)),image2(multiset(A),fun(A,nat),count(A)),X) != bot_bot(set(fun(A,nat))) )
       => ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),X)),X3) = aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(fun(A,nat)),set(nat),image2(fun(A,nat),nat,aTP_Lamp_qi(A,fun(fun(A,nat),nat),X3)),aa(set(multiset(A)),set(fun(A,nat)),image2(multiset(A),fun(A,nat),count(A)),X))) ) ) ) ).

% Inf_multiset.rep_eq
tff(fact_4516_count__Inf__multiset__nonempty,axiom,
    ! [A: $tType,A4: set(multiset(A)),X: A] :
      ( ( A4 != bot_bot(set(multiset(A))) )
     => ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),A4)),X) = aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(multiset(A)),set(nat),image2(multiset(A),nat,aTP_Lamp_qg(A,fun(multiset(A),nat),X)),A4)) ) ) ).

% count_Inf_multiset_nonempty
tff(fact_4517_subset__mset_OatLeastAtMost__singleton_H,axiom,
    ! [A: $tType,A3: multiset(A),B2: multiset(A)] :
      ( ( A3 = B2 )
     => ( set_atLeastAtMost(multiset(A),subseteq_mset(A),A3,B2) = aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),A3),bot_bot(set(multiset(A)))) ) ) ).

% subset_mset.atLeastAtMost_singleton'
tff(fact_4518_Sup__multiset__def,axiom,
    ! [A: $tType,A4: set(multiset(A))] :
      ( ( ( ( A4 != bot_bot(set(multiset(A))) )
          & condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4) )
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A4) = aa(fun(A,nat),multiset(A),abs_multiset(A),aTP_Lamp_qj(set(multiset(A)),fun(A,nat),A4)) ) )
      & ( ~ ( ( A4 != bot_bot(set(multiset(A))) )
            & condit8047198070973881523_above(multiset(A),subseteq_mset(A),A4) )
       => ( aa(set(multiset(A)),multiset(A),complete_Sup_Sup(multiset(A)),A4) = zero_zero(multiset(A)) ) ) ) ).

% Sup_multiset_def
tff(fact_4519_count__image__mset,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),A4: multiset(B),X: A] : ( aa(A,nat,aa(multiset(A),fun(A,nat),count(A),aa(multiset(B),multiset(A),image_mset(B,A,F),A4)),X) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aa(multiset(B),fun(B,nat),count(B),A4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),aa(fun(B,A),fun(set(A),set(B)),vimage(B,A),F),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))),aa(multiset(B),set(B),set_mset(B),A4))) ) ).

% count_image_mset
tff(fact_4520_Inf__multiset__def,axiom,
    ! [A: $tType] : ( complete_Inf_Inf(multiset(A)) = aa(fun(set(fun(A,nat)),fun(A,nat)),fun(set(multiset(A)),multiset(A)),map_fun(set(multiset(A)),set(fun(A,nat)),fun(A,nat),multiset(A),image2(multiset(A),fun(A,nat),count(A)),abs_multiset(A)),aTP_Lamp_qk(set(fun(A,nat)),fun(A,nat))) ) ).

% Inf_multiset_def
tff(fact_4521_prod__mset_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: multiset(B),B3: multiset(B),G: fun(B,A)] :
          ( ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A4),B3) = zero_zero(multiset(B)) )
         => ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A4),B3))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),A4))),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),B3))) ) ) ) ).

% prod_mset.union_disjoint
tff(fact_4522_prod__mset_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aTP_Lamp_ak(B,A)),A4)) = one_one(A) ) ) ).

% prod_mset.neutral_const
tff(fact_4523_prod__mset_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),X: B,A4: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X),A4))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,G,X)),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),A4))) ) ) ).

% prod_mset.insert
tff(fact_4524_multiset_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: fun(B,C),F: fun(A,B),V: multiset(A)] : ( aa(multiset(B),multiset(C),image_mset(B,C,G),aa(multiset(A),multiset(B),image_mset(A,B,F),V)) = aa(multiset(A),multiset(C),image_mset(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),G),F)),V) ) ).

% multiset.map_comp
tff(fact_4525_image__mset_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(B,C),G: fun(A,B),Multiset: multiset(A)] : ( aa(multiset(B),multiset(C),image_mset(B,C,F),aa(multiset(A),multiset(B),image_mset(A,B,G),Multiset)) = aa(multiset(A),multiset(C),image_mset(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),G)),Multiset) ) ).

% image_mset.compositionality
tff(fact_4526_prod__mset_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),H2: fun(B,A),A4: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_bb(fun(B,A),fun(fun(B,A),fun(B,A)),G),H2)),A4)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,G),A4))),aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,H2),A4))) ) ) ).

% prod_mset.distrib
tff(fact_4527_image__mset_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(B,C),G: fun(A,B)] : ( aa(fun(multiset(A),multiset(B)),fun(multiset(A),multiset(C)),aa(fun(multiset(B),multiset(C)),fun(fun(multiset(A),multiset(B)),fun(multiset(A),multiset(C))),comp(multiset(B),multiset(C),multiset(A)),image_mset(B,C,F)),image_mset(A,B,G)) = image_mset(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),G)) ) ).

% image_mset.comp
tff(fact_4528_image__mset__cong__pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,M: multiset(product_prod(A,B)),F: fun(A,fun(B,C)),G: fun(A,fun(B,C))] :
      ( ! [X2: A,Y2: B] :
          ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2),aa(multiset(product_prod(A,B)),set(product_prod(A,B)),set_mset(product_prod(A,B)),M)))
         => ( aa(B,C,aa(A,fun(B,C),F,X2),Y2) = aa(B,C,aa(A,fun(B,C),G,X2),Y2) ) )
     => ( aa(multiset(product_prod(A,B)),multiset(C),image_mset(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),F)),M) = aa(multiset(product_prod(A,B)),multiset(C),image_mset(product_prod(A,B),C,aa(fun(A,fun(B,C)),fun(product_prod(A,B),C),product_case_prod(A,B,C),G)),M) ) ) ).

% image_mset_cong_pair
tff(fact_4529_image__mset__def,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B)] : ( image_mset(A,B,F) = fold_mset(A,multiset(B),aa(fun(A,B),fun(A,fun(multiset(B),multiset(B))),aa(fun(B,fun(multiset(B),multiset(B))),fun(fun(A,B),fun(A,fun(multiset(B),multiset(B)))),comp(B,fun(multiset(B),multiset(B)),A),add_mset(B)),F),zero_zero(multiset(B))) ) ).

% image_mset_def
tff(fact_4530_prod__mset__delta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Y: B,C2: A,A4: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_ql(B,fun(A,fun(B,A)),Y),C2)),A4)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),A4),Y)) ) ) ).

% prod_mset_delta'
tff(fact_4531_prod__mset__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Y: B,C2: A,A4: multiset(B)] : ( aa(multiset(A),A,comm_m9189036328036947845d_mset(A),aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_qm(B,fun(A,fun(B,A)),Y),C2)),A4)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),C2),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),A4),Y)) ) ) ).

% prod_mset_delta
tff(fact_4532_sum__mset__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Y: B,C2: A,A4: multiset(B)] : ( comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_qn(B,fun(A,fun(B,A)),Y),C2)),A4)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(nat,A,semiring_1_of_nat(A),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),A4),Y))) ) ) ).

% sum_mset_delta
tff(fact_4533_sum__mset__delta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Y: B,C2: A,A4: multiset(B)] : ( comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_qo(B,fun(A,fun(B,A)),Y),C2)),A4)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(nat,A,semiring_1_of_nat(A),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),A4),Y))) ) ) ).

% sum_mset_delta'
tff(fact_4534_inv__o__cancel,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] :
      ( inj_on(A,B,F,top_top(set(A)))
     => ( aa(fun(A,B),fun(A,A),aa(fun(B,A),fun(fun(A,B),fun(A,A)),comp(B,A,A),hilbert_inv_into(A,B,top_top(set(A)),F)),F) = id(A) ) ) ).

% inv_o_cancel
tff(fact_4535_prod__filter__INF,axiom,
    ! [B: $tType,D: $tType,C: $tType,A: $tType,I4: set(A),J4: set(B),A4: fun(A,filter(C)),B3: fun(B,filter(D))] :
      ( ( I4 != bot_bot(set(A)) )
     => ( ( J4 != bot_bot(set(B)) )
       => ( prod_filter(C,D,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(A),set(filter(C)),image2(A,filter(C),A4),I4)),aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(B),set(filter(D)),image2(B,filter(D),B3),J4))) = aa(set(filter(product_prod(C,D))),filter(product_prod(C,D)),complete_Inf_Inf(filter(product_prod(C,D))),aa(set(A),set(filter(product_prod(C,D))),image2(A,filter(product_prod(C,D)),aa(fun(B,filter(D)),fun(A,filter(product_prod(C,D))),aa(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D)))),aTP_Lamp_qq(set(B),fun(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D))))),J4),A4),B3)),I4)) ) ) ) ).

% prod_filter_INF
tff(fact_4536_o__inv__o__cancel,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(A,B),G: fun(A,C)] :
      ( inj_on(A,B,F,top_top(set(A)))
     => ( aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),aa(fun(B,A),fun(B,C),aa(fun(A,C),fun(fun(B,A),fun(B,C)),comp(A,C,B),G),hilbert_inv_into(A,B,top_top(set(A)),F))),F) = G ) ) ).

% o_inv_o_cancel
tff(fact_4537_sum__mset__replicate__mset,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat,A3: A] : ( comm_m7189776963980413722m_mset(A,replicate_mset(A,N,A3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),A3) ) ) ).

% sum_mset_replicate_mset
tff(fact_4538_prod__filter__eq__bot,axiom,
    ! [A: $tType,B: $tType,A4: filter(A),B3: filter(B)] :
      ( ( prod_filter(A,B,A4,B3) = bot_bot(filter(product_prod(A,B))) )
    <=> ( ( A4 = bot_bot(filter(A)) )
        | ( B3 = bot_bot(filter(B)) ) ) ) ).

% prod_filter_eq_bot
tff(fact_4539_eventually__prod__same,axiom,
    ! [A: $tType,P: fun(product_prod(A,A),bool),F2: filter(A)] :
      ( eventually(product_prod(A,A),P,prod_filter(A,A,F2,F2))
    <=> ? [Q8: fun(A,bool)] :
          ( eventually(A,Q8,F2)
          & ! [X4: A,Y3: A] :
              ( pp(aa(A,bool,Q8,X4))
             => ( pp(aa(A,bool,Q8,Y3))
               => pp(aa(product_prod(A,A),bool,P,aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Y3))) ) ) ) ) ).

% eventually_prod_same
tff(fact_4540_eventually__prod__filter,axiom,
    ! [A: $tType,B: $tType,P: fun(product_prod(A,B),bool),F2: filter(A),G6: filter(B)] :
      ( eventually(product_prod(A,B),P,prod_filter(A,B,F2,G6))
    <=> ? [Pf: fun(A,bool),Pg: fun(B,bool)] :
          ( eventually(A,Pf,F2)
          & eventually(B,Pg,G6)
          & ! [X4: A,Y3: B] :
              ( pp(aa(A,bool,Pf,X4))
             => ( pp(aa(B,bool,Pg,Y3))
               => pp(aa(product_prod(A,B),bool,P,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Y3))) ) ) ) ) ).

% eventually_prod_filter
tff(fact_4541_sum__mset__product,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( comm_monoid_add(A)
        & times(A)
        & semiring_0(B) )
     => ! [F: fun(A,B),A4: multiset(A),G: fun(C,B),B3: multiset(C)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),comm_m7189776963980413722m_mset(B,aa(multiset(A),multiset(B),image_mset(A,B,F),A4))),comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,G),B3))) = comm_m7189776963980413722m_mset(B,aa(multiset(A),multiset(B),image_mset(A,B,aa(multiset(C),fun(A,B),aa(fun(C,B),fun(multiset(C),fun(A,B)),aTP_Lamp_qs(fun(A,B),fun(fun(C,B),fun(multiset(C),fun(A,B))),F),G),B3)),A4)) ) ) ).

% sum_mset_product
tff(fact_4542_sum__mset__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [F: fun(B,A),M: multiset(B),C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,F),M))),C2) = comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(A,fun(B,A),aTP_Lamp_bc(fun(B,A),fun(A,fun(B,A)),F),C2)),M)) ) ) ).

% sum_mset_distrib_right
tff(fact_4543_sum__mset__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [C2: A,F: fun(B,A),M: multiset(B)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,F),M))) = comm_m7189776963980413722m_mset(A,aa(multiset(B),multiset(A),image_mset(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_bd(A,fun(fun(B,A),fun(B,A)),C2),F)),M)) ) ) ).

% sum_mset_distrib_left
tff(fact_4544_inv__into__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: fun(A,B),G: fun(C,A),A4: set(C),X: B] :
      ( inj_on(A,B,F,aa(set(C),set(A),image2(C,A,G),A4))
     => ( inj_on(C,A,G,A4)
       => ( pp(member(B,X,aa(set(A),set(B),image2(A,B,F),aa(set(C),set(A),image2(C,A,G),A4))))
         => ( aa(B,C,hilbert_inv_into(C,B,A4,aa(fun(C,A),fun(C,B),aa(fun(A,B),fun(fun(C,A),fun(C,B)),comp(A,B,C),F),G)),X) = aa(B,C,aa(fun(B,A),fun(B,C),aa(fun(A,C),fun(fun(B,A),fun(B,C)),comp(A,C,B),hilbert_inv_into(C,A,A4,G)),hilbert_inv_into(A,B,aa(set(C),set(A),image2(C,A,G),A4),F)),X) ) ) ) ) ).

% inv_into_comp
tff(fact_4545_inv__unique__comp,axiom,
    ! [B: $tType,A: $tType,F: fun(B,A),G: fun(A,B)] :
      ( ( aa(fun(A,B),fun(A,A),aa(fun(B,A),fun(fun(A,B),fun(A,A)),comp(B,A,A),F),G) = id(A) )
     => ( ( aa(fun(B,A),fun(B,B),aa(fun(A,B),fun(fun(B,A),fun(B,B)),comp(A,B,B),G),F) = id(B) )
       => ( hilbert_inv_into(B,A,top_top(set(B)),F) = G ) ) ) ).

% inv_unique_comp
tff(fact_4546_o__inv__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,B),G: fun(C,A)] :
      ( bij_betw(A,B,F,top_top(set(A)),top_top(set(B)))
     => ( bij_betw(C,A,G,top_top(set(C)),top_top(set(A)))
       => ( hilbert_inv_into(C,B,top_top(set(C)),aa(fun(C,A),fun(C,B),aa(fun(A,B),fun(fun(C,A),fun(C,B)),comp(A,B,C),F),G)) = aa(fun(B,A),fun(B,C),aa(fun(A,C),fun(fun(B,A),fun(B,C)),comp(A,C,B),hilbert_inv_into(C,A,top_top(set(C)),G)),hilbert_inv_into(A,B,top_top(set(A)),F)) ) ) ) ).

% o_inv_distrib
tff(fact_4547_prod__filter__mono__iff,axiom,
    ! [A: $tType,B: $tType,A4: filter(A),B3: filter(B),C3: filter(A),D4: filter(B)] :
      ( ( A4 != bot_bot(filter(A)) )
     => ( ( B3 != bot_bot(filter(B)) )
       => ( pp(aa(filter(product_prod(A,B)),bool,aa(filter(product_prod(A,B)),fun(filter(product_prod(A,B)),bool),ord_less_eq(filter(product_prod(A,B))),prod_filter(A,B,A4,B3)),prod_filter(A,B,C3,D4)))
        <=> ( pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),A4),C3))
            & pp(aa(filter(B),bool,aa(filter(B),fun(filter(B),bool),ord_less_eq(filter(B)),B3),D4)) ) ) ) ) ).

% prod_filter_mono_iff
tff(fact_4548_iso__backward,axiom,
    ! [A: $tType,B: $tType,X: A,Y: A,R4: set(product_prod(A,A)),R3: set(product_prod(B,B)),F: fun(B,A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R4))
     => ( bNF_Wellorder_iso(B,A,R3,R4,F)
       => pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,hilbert_inv_into(B,A,field2(B,R3),F),X)),aa(A,B,hilbert_inv_into(B,A,field2(B,R3),F),Y)),R3)) ) ) ).

% iso_backward
tff(fact_4549_surj__iff,axiom,
    ! [B: $tType,A: $tType,F: fun(B,A)] :
      ( ( aa(set(B),set(A),image2(B,A,F),top_top(set(B))) = top_top(set(A)) )
    <=> ( aa(fun(A,B),fun(A,A),aa(fun(B,A),fun(fun(A,B),fun(A,A)),comp(B,A,A),F),hilbert_inv_into(B,A,top_top(set(B)),F)) = id(A) ) ) ).

% surj_iff
tff(fact_4550_inj__iff,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] :
      ( inj_on(A,B,F,top_top(set(A)))
    <=> ( aa(fun(A,B),fun(A,A),aa(fun(B,A),fun(fun(A,B),fun(A,A)),comp(B,A,A),hilbert_inv_into(A,B,top_top(set(A)),F)),F) = id(A) ) ) ).

% inj_iff
tff(fact_4551_fn__o__inv__fn__is__id,axiom,
    ! [A: $tType,F: fun(A,A),N: nat] :
      ( bij_betw(A,A,F,top_top(set(A)),top_top(set(A)))
     => ! [X3: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),compow(fun(A,A),N,F)),compow(fun(A,A),N,hilbert_inv_into(A,A,top_top(set(A)),F))),X3) = X3 ) ) ).

% fn_o_inv_fn_is_id
tff(fact_4552_inv__fn__o__fn__is__id,axiom,
    ! [A: $tType,F: fun(A,A),N: nat] :
      ( bij_betw(A,A,F,top_top(set(A)),top_top(set(A)))
     => ! [X3: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),compow(fun(A,A),N,hilbert_inv_into(A,A,top_top(set(A)),F))),compow(fun(A,A),N,F)),X3) = X3 ) ) ).

% inv_fn_o_fn_is_id
tff(fact_4553_eventually__prod1,axiom,
    ! [A: $tType,B: $tType,B3: filter(A),P: fun(B,bool),A4: filter(B)] :
      ( ( B3 != bot_bot(filter(A)) )
     => ( eventually(product_prod(B,A),aa(fun(B,fun(A,bool)),fun(product_prod(B,A),bool),product_case_prod(B,A,bool),aTP_Lamp_qt(fun(B,bool),fun(B,fun(A,bool)),P)),prod_filter(B,A,A4,B3))
      <=> eventually(B,P,A4) ) ) ).

% eventually_prod1
tff(fact_4554_eventually__prod2,axiom,
    ! [A: $tType,B: $tType,A4: filter(A),P: fun(B,bool),B3: filter(B)] :
      ( ( A4 != bot_bot(filter(A)) )
     => ( eventually(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_qu(fun(B,bool),fun(A,fun(B,bool)),P)),prod_filter(A,B,A4,B3))
      <=> eventually(B,P,B3) ) ) ).

% eventually_prod2
tff(fact_4555_prod__filter__INF2,axiom,
    ! [C: $tType,B: $tType,A: $tType,J4: set(A),A4: filter(B),B3: fun(A,filter(C))] :
      ( ( J4 != bot_bot(set(A)) )
     => ( prod_filter(B,C,A4,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(A),set(filter(C)),image2(A,filter(C),B3),J4))) = aa(set(filter(product_prod(B,C))),filter(product_prod(B,C)),complete_Inf_Inf(filter(product_prod(B,C))),aa(set(A),set(filter(product_prod(B,C))),image2(A,filter(product_prod(B,C)),aa(fun(A,filter(C)),fun(A,filter(product_prod(B,C))),aTP_Lamp_qv(filter(B),fun(fun(A,filter(C)),fun(A,filter(product_prod(B,C)))),A4),B3)),J4)) ) ) ).

% prod_filter_INF2
tff(fact_4556_prod__filter__INF1,axiom,
    ! [C: $tType,B: $tType,A: $tType,I4: set(A),A4: fun(A,filter(B)),B3: filter(C)] :
      ( ( I4 != bot_bot(set(A)) )
     => ( prod_filter(B,C,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),A4),I4)),B3) = aa(set(filter(product_prod(B,C))),filter(product_prod(B,C)),complete_Inf_Inf(filter(product_prod(B,C))),aa(set(A),set(filter(product_prod(B,C))),image2(A,filter(product_prod(B,C)),aa(filter(C),fun(A,filter(product_prod(B,C))),aTP_Lamp_qw(fun(A,filter(B)),fun(filter(C),fun(A,filter(product_prod(B,C)))),A4),B3)),I4)) ) ) ).

% prod_filter_INF1
tff(fact_4557_bijection_Oinv__comp__left,axiom,
    ! [A: $tType,F: fun(A,A)] :
      ( hilbert_bijection(A,F)
     => ( aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),hilbert_inv_into(A,A,top_top(set(A)),F)),F) = id(A) ) ) ).

% bijection.inv_comp_left
tff(fact_4558_bijection_Oinv__comp__right,axiom,
    ! [A: $tType,F: fun(A,A)] :
      ( hilbert_bijection(A,F)
     => ( aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),F),hilbert_inv_into(A,A,top_top(set(A)),F)) = id(A) ) ) ).

% bijection.inv_comp_right
tff(fact_4559_sum__mset__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Y: B,A4: multiset(A)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(A),multiset(B),image_mset(A,B,aTP_Lamp_qx(B,fun(A,B),Y)),A4)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),size_size(multiset(A),A4))),Y) ) ) ).

% sum_mset_constant
tff(fact_4560_relpow__fun__conv,axiom,
    ! [A: $tType,A3: A,B2: A,N: nat,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),compow(set(product_prod(A,A)),N,R)))
    <=> ? [F11: fun(nat,A)] :
          ( ( aa(nat,A,F11,zero_zero(nat)) = A3 )
          & ( aa(nat,A,F11,N) = B2 )
          & ! [I2: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),N))
             => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(nat,A,F11,I2)),aa(nat,A,F11,aa(nat,nat,suc,I2))),R)) ) ) ) ).

% relpow_fun_conv
tff(fact_4561_relpow__Suc__D2_H,axiom,
    ! [A: $tType,N: nat,R: set(product_prod(A,A)),X3: A,Y4: A,Z5: A] :
      ( ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Y4),compow(set(product_prod(A,A)),N,R)))
        & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),Z5),R)) )
     => ? [W: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),W),R))
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),W),Z5),compow(set(product_prod(A,A)),N,R))) ) ) ).

% relpow_Suc_D2'
tff(fact_4562_relpow__0__I,axiom,
    ! [A: $tType,X: A,R: set(product_prod(A,A))] : pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),X),compow(set(product_prod(A,A)),zero_zero(nat),R))) ).

% relpow_0_I
tff(fact_4563_relpow__0__E,axiom,
    ! [A: $tType,X: A,Y: A,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),compow(set(product_prod(A,A)),zero_zero(nat),R)))
     => ( X = Y ) ) ).

% relpow_0_E
tff(fact_4564_relpow__Suc__I2,axiom,
    ! [A: $tType,X: A,Y: A,R: set(product_prod(A,A)),Z2: A,N: nat] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),Z2),compow(set(product_prod(A,A)),N,R)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),compow(set(product_prod(A,A)),aa(nat,nat,suc,N),R))) ) ) ).

% relpow_Suc_I2
tff(fact_4565_relpow__Suc__E2,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),compow(set(product_prod(A,A)),aa(nat,nat,suc,N),R)))
     => ~ ! [Y2: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y2),R))
           => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z2),compow(set(product_prod(A,A)),N,R))) ) ) ).

% relpow_Suc_E2
tff(fact_4566_relpow__Suc__D2,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),compow(set(product_prod(A,A)),aa(nat,nat,suc,N),R)))
     => ? [Y2: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y2),R))
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z2),compow(set(product_prod(A,A)),N,R))) ) ) ).

% relpow_Suc_D2
tff(fact_4567_relpow__Suc__I,axiom,
    ! [A: $tType,X: A,Y: A,N: nat,R: set(product_prod(A,A)),Z2: A] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),compow(set(product_prod(A,A)),N,R)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),Z2),R))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),compow(set(product_prod(A,A)),aa(nat,nat,suc,N),R))) ) ) ).

% relpow_Suc_I
tff(fact_4568_relpow__Suc__E,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),compow(set(product_prod(A,A)),aa(nat,nat,suc,N),R)))
     => ~ ! [Y2: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y2),compow(set(product_prod(A,A)),N,R)))
           => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z2),R)) ) ) ).

% relpow_Suc_E
tff(fact_4569_relpowp__relpow__eq,axiom,
    ! [A: $tType,N: nat,R: set(product_prod(A,A)),X3: A,Xa3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),compow(fun(A,fun(A,bool)),N,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R)),X3),Xa3))
    <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa3),compow(set(product_prod(A,A)),N,R))) ) ).

% relpowp_relpow_eq
tff(fact_4570_relpow__E,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),compow(set(product_prod(A,A)),N,R)))
     => ( ( ( N = zero_zero(nat) )
         => ( X != Z2 ) )
       => ~ ! [Y2: A,M5: nat] :
              ( ( N = aa(nat,nat,suc,M5) )
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y2),compow(set(product_prod(A,A)),M5,R)))
               => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z2),R)) ) ) ) ) ).

% relpow_E
tff(fact_4571_relpow__E2,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Z2),compow(set(product_prod(A,A)),N,R)))
     => ( ( ( N = zero_zero(nat) )
         => ( X != Z2 ) )
       => ~ ! [Y2: A,M5: nat] :
              ( ( N = aa(nat,nat,suc,M5) )
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y2),R))
               => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z2),compow(set(product_prod(A,A)),M5,R))) ) ) ) ) ).

% relpow_E2
tff(fact_4572_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),N))
     => ( compow(set(product_prod(A,A)),N,bot_bot(set(product_prod(A,A)))) = bot_bot(set(product_prod(A,A))) ) ) ).

% relpow_empty
tff(fact_4573_exhaustive__integer_H_Ocases,axiom,
    ! [X: product_prod(fun(code_integer,option(product_prod(bool,list(code_term)))),product_prod(code_integer,code_integer))] :
      ~ ! [F9: fun(code_integer,option(product_prod(bool,list(code_term)))),D3: code_integer,I3: code_integer] : ( X != aa(product_prod(code_integer,code_integer),product_prod(fun(code_integer,option(product_prod(bool,list(code_term)))),product_prod(code_integer,code_integer)),aa(fun(code_integer,option(product_prod(bool,list(code_term)))),fun(product_prod(code_integer,code_integer),product_prod(fun(code_integer,option(product_prod(bool,list(code_term)))),product_prod(code_integer,code_integer))),product_Pair(fun(code_integer,option(product_prod(bool,list(code_term)))),product_prod(code_integer,code_integer)),F9),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),D3),I3)) ) ).

% exhaustive_integer'.cases
tff(fact_4574_full__exhaustive__integer_H_Ocases,axiom,
    ! [X: product_prod(fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_integer,code_integer))] :
      ~ ! [F9: fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),D3: code_integer,I3: code_integer] : ( X != aa(product_prod(code_integer,code_integer),product_prod(fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_integer,code_integer)),aa(fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),fun(product_prod(code_integer,code_integer),product_prod(fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_integer,code_integer))),product_Pair(fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_integer,code_integer)),F9),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),D3),I3)) ) ).

% full_exhaustive_integer'.cases
tff(fact_4575_Inf__multiset_Oabs__eq,axiom,
    ! [A: $tType,X: set(fun(A,nat))] :
      ( pp(aa(set(fun(A,nat)),bool,aa(set(fun(A,nat)),fun(set(fun(A,nat)),bool),bNF_rel_set(fun(A,nat),fun(A,nat),bNF_eq_onp(fun(A,nat),aTP_Lamp_qz(fun(A,nat),bool))),X),X))
     => ( aa(set(multiset(A)),multiset(A),complete_Inf_Inf(multiset(A)),aa(set(fun(A,nat)),set(multiset(A)),image2(fun(A,nat),multiset(A),abs_multiset(A)),X)) = aa(fun(A,nat),multiset(A),abs_multiset(A),aa(set(fun(A,nat)),fun(A,nat),aTP_Lamp_qk(set(fun(A,nat)),fun(A,nat)),X)) ) ) ).

% Inf_multiset.abs_eq
tff(fact_4576_irreflp__irrefl__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( irreflp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R))
    <=> irrefl(A,R) ) ).

% irreflp_irrefl_eq
tff(fact_4577_Inf__multiset_Orsp,axiom,
    ! [A: $tType] : pp(aa(fun(set(fun(A,nat)),fun(A,nat)),bool,aa(fun(set(fun(A,nat)),fun(A,nat)),fun(fun(set(fun(A,nat)),fun(A,nat)),bool),bNF_rel_fun(set(fun(A,nat)),set(fun(A,nat)),fun(A,nat),fun(A,nat),bNF_rel_set(fun(A,nat),fun(A,nat),bNF_eq_onp(fun(A,nat),aTP_Lamp_qz(fun(A,nat),bool))),bNF_eq_onp(fun(A,nat),aTP_Lamp_qz(fun(A,nat),bool))),aTP_Lamp_qk(set(fun(A,nat)),fun(A,nat))),aTP_Lamp_qk(set(fun(A,nat)),fun(A,nat)))) ).

% Inf_multiset.rsp
tff(fact_4578_exhaustive__int_H_Ocases,axiom,
    ! [X: product_prod(fun(int,option(product_prod(bool,list(code_term)))),product_prod(int,int))] :
      ~ ! [F9: fun(int,option(product_prod(bool,list(code_term)))),D3: int,I3: int] : ( X != aa(product_prod(int,int),product_prod(fun(int,option(product_prod(bool,list(code_term)))),product_prod(int,int)),aa(fun(int,option(product_prod(bool,list(code_term)))),fun(product_prod(int,int),product_prod(fun(int,option(product_prod(bool,list(code_term)))),product_prod(int,int))),product_Pair(fun(int,option(product_prod(bool,list(code_term)))),product_prod(int,int)),F9),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),D3),I3)) ) ).

% exhaustive_int'.cases
tff(fact_4579_full__exhaustive__int_H_Ocases,axiom,
    ! [X: product_prod(fun(product_prod(int,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(int,int))] :
      ~ ! [F9: fun(product_prod(int,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),D3: int,I3: int] : ( X != aa(product_prod(int,int),product_prod(fun(product_prod(int,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(int,int)),aa(fun(product_prod(int,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),fun(product_prod(int,int),product_prod(fun(product_prod(int,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(int,int))),product_Pair(fun(product_prod(int,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(int,int)),F9),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),D3),I3)) ) ).

% full_exhaustive_int'.cases
tff(fact_4580_empty__transfer,axiom,
    ! [A: $tType,B: $tType,A4: fun(A,fun(B,bool))] : pp(aa(set(B),bool,aa(set(A),fun(set(B),bool),bNF_rel_set(A,B,A4),bot_bot(set(A))),bot_bot(set(B)))) ).

% empty_transfer
tff(fact_4581_equivp__equiv,axiom,
    ! [A: $tType,A4: set(product_prod(A,A))] :
      ( equiv_equiv(A,top_top(set(A)),A4)
    <=> equiv_equivp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),A4)) ) ).

% equivp_equiv
tff(fact_4582_asymp__asym__eq,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( asymp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R))
    <=> asym(A,R) ) ).

% asymp_asym_eq
tff(fact_4583_asym_Ocases,axiom,
    ! [A: $tType,A3: set(product_prod(A,A))] :
      ( asym(A,A3)
     => ! [A13: A,B10: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A13),B10),A3))
         => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B10),A13),A3)) ) ) ).

% asym.cases
tff(fact_4584_asym_Osimps,axiom,
    ! [A: $tType,A3: set(product_prod(A,A))] :
      ( asym(A,A3)
    <=> ? [R6: set(product_prod(A,A))] :
          ( ( A3 = R6 )
          & ! [X4: A,Xa2: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa2),R6))
             => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa2),X4),R6)) ) ) ) ).

% asym.simps
tff(fact_4585_asym_Ointros,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( ! [A8: A,B5: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A8),B5),R))
         => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B5),A8),R)) )
     => asym(A,R) ) ).

% asym.intros
tff(fact_4586_asymD,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),X: A,Y: A] :
      ( asym(A,R)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R))
       => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y),X),R)) ) ) ).

% asymD
tff(fact_4587_asym__iff,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( asym(A,R)
    <=> ! [X4: A,Y3: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Y3),R))
         => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y3),X4),R)) ) ) ).

% asym_iff
tff(fact_4588_Inf__multiset_Otransfer,axiom,
    ! [A: $tType] : pp(aa(fun(set(multiset(A)),multiset(A)),bool,aa(fun(set(fun(A,nat)),fun(A,nat)),fun(fun(set(multiset(A)),multiset(A)),bool),bNF_rel_fun(set(fun(A,nat)),set(multiset(A)),fun(A,nat),multiset(A),bNF_rel_set(fun(A,nat),multiset(A),pcr_multiset(A,A,fequal(A))),pcr_multiset(A,A,fequal(A))),aTP_Lamp_qk(set(fun(A,nat)),fun(A,nat))),complete_Inf_Inf(multiset(A)))) ).

% Inf_multiset.transfer
tff(fact_4589_min__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F: fun(A,B),X: A,Y: A] :
          ( order_antimono(A,B,F)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(A,B,F,X)),aa(A,B,F,Y)) = aa(A,B,F,aa(A,A,aa(A,fun(A,A),ord_max(A),X),Y)) ) ) ) ).

% min_of_antimono
tff(fact_4590_max__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [F: fun(A,B),X: A,Y: A] :
          ( order_antimono(A,B,F)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(A,B,F,X)),aa(A,B,F,Y)) = aa(A,B,F,aa(A,A,aa(A,fun(A,A),ord_min(A),X),Y)) ) ) ) ).

% max_of_antimono
tff(fact_4591_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F: fun(A,B),X: A,Y: A] :
          ( order_antimono(A,B,F)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,Y)),aa(A,B,F,X))) ) ) ) ).

% antimonoD
tff(fact_4592_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F: fun(A,B),X: A,Y: A] :
          ( order_antimono(A,B,F)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X),Y))
           => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,Y)),aa(A,B,F,X))) ) ) ) ).

% antimonoE
tff(fact_4593_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F: fun(A,B)] :
          ( ! [X2: A,Y2: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X2),Y2))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,Y2)),aa(A,B,F,X2))) )
         => order_antimono(A,B,F) ) ) ).

% antimonoI
tff(fact_4594_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F: fun(A,B)] :
          ( order_antimono(A,B,F)
        <=> ! [X4: A,Y3: A] :
              ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Y3))
             => pp(aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,F,Y3)),aa(A,B,F,X4))) ) ) ) ).

% antimono_def
tff(fact_4595_Range__insert,axiom,
    ! [A: $tType,B: $tType,A3: B,B2: A,R3: set(product_prod(B,A))] : ( range2(B,A,aa(set(product_prod(B,A)),set(product_prod(B,A)),insert2(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),A3),B2)),R3)) = aa(set(A),set(A),insert2(A,B2),range2(B,A,R3)) ) ).

% Range_insert
tff(fact_4596_in__chain__finite,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [A4: set(A)] :
          ( comple1602240252501008431_chain(A,ord_less_eq(A),A4)
         => ( pp(aa(set(A),bool,finite_finite(A),A4))
           => ( ( A4 != bot_bot(set(A)) )
             => pp(member(A,aa(set(A),A,complete_Sup_Sup(A),A4),A4)) ) ) ) ) ).

% in_chain_finite
tff(fact_4597_Range__empty,axiom,
    ! [B: $tType,A: $tType] : ( range2(B,A,bot_bot(set(product_prod(B,A)))) = bot_bot(set(A)) ) ).

% Range_empty
tff(fact_4598_chain__empty,axiom,
    ! [A: $tType,Ord: fun(A,fun(A,bool))] : comple1602240252501008431_chain(A,Ord,bot_bot(set(A))) ).

% chain_empty
tff(fact_4599_Range_Ocases,axiom,
    ! [B: $tType,A: $tType,A3: B,R3: set(product_prod(A,B))] :
      ( pp(member(B,A3,range2(A,B,R3)))
     => ~ ! [A8: A] : ~ pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),A3),R3)) ) ).

% Range.cases
tff(fact_4600_Range_Osimps,axiom,
    ! [B: $tType,A: $tType,A3: B,R3: set(product_prod(A,B))] :
      ( pp(member(B,A3,range2(A,B,R3)))
    <=> ? [A6: A,B6: B] :
          ( ( A3 = B6 )
          & pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A6),B6),R3)) ) ) ).

% Range.simps
tff(fact_4601_Range_Ointros,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),R3))
     => pp(member(B,B2,range2(A,B,R3))) ) ).

% Range.intros
tff(fact_4602_RangeE,axiom,
    ! [A: $tType,B: $tType,B2: A,R3: set(product_prod(B,A))] :
      ( pp(member(A,B2,range2(B,A,R3)))
     => ~ ! [A8: B] : ~ pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),A8),B2),R3)) ) ).

% RangeE
tff(fact_4603_Range__iff,axiom,
    ! [A: $tType,B: $tType,A3: A,R3: set(product_prod(B,A))] :
      ( pp(member(A,A3,range2(B,A,R3)))
    <=> ? [Y3: B] : pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Y3),A3),R3)) ) ).

% Range_iff
tff(fact_4604_Range__empty__iff,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(B,A))] :
      ( ( range2(B,A,R3) = bot_bot(set(A)) )
    <=> ( R3 = bot_bot(set(product_prod(B,A))) ) ) ).

% Range_empty_iff
tff(fact_4605_chain__singleton,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [X: A] : comple1602240252501008431_chain(A,ord_less_eq(A),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) ) ).

% chain_singleton
tff(fact_4606_Range__Int__subset,axiom,
    ! [A: $tType,B: $tType,A4: set(product_prod(B,A)),B3: set(product_prod(B,A))] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),range2(B,A,aa(set(product_prod(B,A)),set(product_prod(B,A)),aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),set(product_prod(B,A))),inf_inf(set(product_prod(B,A))),A4),B3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),range2(B,A,A4)),range2(B,A,B3)))) ).

% Range_Int_subset
tff(fact_4607_wf__UN,axiom,
    ! [B: $tType,A: $tType,I4: set(A),R3: fun(A,set(product_prod(B,B)))] :
      ( ! [I3: A] :
          ( pp(member(A,I3,I4))
         => wf(B,aa(A,set(product_prod(B,B)),R3,I3)) )
     => ( ! [I3: A,J3: A] :
            ( pp(member(A,I3,I4))
           => ( pp(member(A,J3,I4))
             => ( ( aa(A,set(product_prod(B,B)),R3,I3) != aa(A,set(product_prod(B,B)),R3,J3) )
               => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),domain(B,B,aa(A,set(product_prod(B,B)),R3,I3))),range2(B,B,aa(A,set(product_prod(B,B)),R3,J3))) = bot_bot(set(B)) ) ) ) )
       => wf(B,aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(A),set(set(product_prod(B,B))),image2(A,set(product_prod(B,B)),R3),I4))) ) ) ).

% wf_UN
tff(fact_4608_dom__ran__disj__comp,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),domain(A,A,R)),range2(A,A,R)) = bot_bot(set(A)) )
     => ( relcomp(A,A,A,R,R) = bot_bot(set(product_prod(A,A))) ) ) ).

% dom_ran_disj_comp
tff(fact_4609_wf__max,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( wf(A,converse(A,A,R))
     => ( ( R != bot_bot(set(product_prod(A,A))) )
       => ~ ! [M5: A] : ~ pp(member(A,M5,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),range2(A,A,R)),domain(A,A,R)))) ) ) ).

% wf_max
tff(fact_4610_Domain__empty,axiom,
    ! [B: $tType,A: $tType] : ( domain(A,B,bot_bot(set(product_prod(A,B)))) = bot_bot(set(A)) ) ).

% Domain_empty
tff(fact_4611_Domain__insert,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,R3: set(product_prod(A,B))] : ( domain(A,B,aa(set(product_prod(A,B)),set(product_prod(A,B)),insert2(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2)),R3)) = aa(set(A),set(A),insert2(A,A3),domain(A,B,R3)) ) ).

% Domain_insert
tff(fact_4612_Domain__iff,axiom,
    ! [B: $tType,A: $tType,A3: A,R3: set(product_prod(A,B))] :
      ( pp(member(A,A3,domain(A,B,R3)))
    <=> ? [Y3: B] : pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),Y3),R3)) ) ).

% Domain_iff
tff(fact_4613_DomainE,axiom,
    ! [B: $tType,A: $tType,A3: A,R3: set(product_prod(A,B))] :
      ( pp(member(A,A3,domain(A,B,R3)))
     => ~ ! [B5: B] : ~ pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B5),R3)) ) ).

% DomainE
tff(fact_4614_Domain_ODomainI,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: B,R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),R3))
     => pp(member(A,A3,domain(A,B,R3))) ) ).

% Domain.DomainI
tff(fact_4615_Domain_Osimps,axiom,
    ! [B: $tType,A: $tType,A3: A,R3: set(product_prod(A,B))] :
      ( pp(member(A,A3,domain(A,B,R3)))
    <=> ? [A6: A,B6: B] :
          ( ( A3 = A6 )
          & pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A6),B6),R3)) ) ) ).

% Domain.simps
tff(fact_4616_Domain_Ocases,axiom,
    ! [B: $tType,A: $tType,A3: A,R3: set(product_prod(A,B))] :
      ( pp(member(A,A3,domain(A,B,R3)))
     => ~ ! [B5: B] : ~ pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B5),R3)) ) ).

% Domain.cases
tff(fact_4617_Not__Domain__rtrancl,axiom,
    ! [A: $tType,X: A,R: set(product_prod(A,A)),Y: A] :
      ( ~ pp(member(A,X,domain(A,A,R)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,R)))
      <=> ( X = Y ) ) ) ).

% Not_Domain_rtrancl
tff(fact_4618_Domain__empty__iff,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B))] :
      ( ( domain(A,B,R3) = bot_bot(set(A)) )
    <=> ( R3 = bot_bot(set(product_prod(A,B))) ) ) ).

% Domain_empty_iff
tff(fact_4619_Domain__unfold,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B))] : ( domain(A,B,R3) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_ra(set(product_prod(A,B)),fun(A,bool),R3)) ) ).

% Domain_unfold
tff(fact_4620_Domain__Int__subset,axiom,
    ! [B: $tType,A: $tType,A4: set(product_prod(A,B)),B3: set(product_prod(A,B))] : pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),domain(A,B,aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),A4),B3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),domain(A,B,A4)),domain(A,B,B3)))) ).

% Domain_Int_subset
tff(fact_4621_wf__no__path,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),domain(A,A,R)),range2(A,A,R)) = bot_bot(set(A)) )
     => wf(A,R) ) ).

% wf_no_path
tff(fact_4622_wf__min,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( wf(A,R)
     => ( ( R != bot_bot(set(product_prod(A,A))) )
       => ~ ! [M5: A] : ~ pp(member(A,M5,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),domain(A,A,R)),range2(A,A,R)))) ) ) ).

% wf_min
tff(fact_4623_wf__Un,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( wf(A,R3)
     => ( wf(A,S)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),domain(A,A,R3)),range2(A,A,S)) = bot_bot(set(A)) )
         => wf(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R3),S)) ) ) ) ).

% wf_Un
tff(fact_4624_wf__Union,axiom,
    ! [A: $tType,R: set(set(product_prod(A,A)))] :
      ( ! [X2: set(product_prod(A,A))] :
          ( pp(member(set(product_prod(A,A)),X2,R))
         => wf(A,X2) )
     => ( ! [X2: set(product_prod(A,A))] :
            ( pp(member(set(product_prod(A,A)),X2,R))
           => ! [Xa4: set(product_prod(A,A))] :
                ( pp(member(set(product_prod(A,A)),Xa4,R))
               => ( ( X2 != Xa4 )
                 => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),domain(A,A,X2)),range2(A,A,Xa4)) = bot_bot(set(A)) ) ) ) )
       => wf(A,aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),R)) ) ) ).

% wf_Union
tff(fact_4625_for__in__RI,axiom,
    ! [B: $tType,A: $tType,X: A,R: set(product_prod(A,B))] :
      ( pp(member(A,X,domain(A,B,R)))
     => pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),fun_of_rel(A,B,R,X)),R)) ) ).

% for_in_RI
tff(fact_4626_Rangep__Range__eq,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B)),X3: B] :
      ( pp(aa(B,bool,rangep(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),R3)),X3))
    <=> pp(member(B,X3,range2(A,B,R3))) ) ).

% Rangep_Range_eq
tff(fact_4627_Range__def,axiom,
    ! [B: $tType,A: $tType,X3: set(product_prod(A,B))] : ( range2(A,B,X3) = aa(fun(B,bool),set(B),collect(B),rangep(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),X3))) ) ).

% Range_def
tff(fact_4628_cofinite__bot,axiom,
    ! [A: $tType] :
      ( ( cofinite(A) = bot_bot(filter(A)) )
    <=> pp(aa(set(A),bool,finite_finite(A),top_top(set(A)))) ) ).

% cofinite_bot
tff(fact_4629_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se4197421643247451524op_bit(A,N,one_one(A)) = aa(bool,A,zero_neq_one_of_bool(A),aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),N),zero_zero(nat))) ) ) ).

% drop_bit_of_1
tff(fact_4630_wfP__SUP,axiom,
    ! [B: $tType,A: $tType,R3: fun(A,fun(B,fun(B,bool)))] :
      ( ! [I3: A] : wfP(B,aa(A,fun(B,fun(B,bool)),R3,I3))
     => ( ! [I3: A,J3: A] :
            ( ( aa(A,fun(B,fun(B,bool)),R3,I3) != aa(A,fun(B,fun(B,bool)),R3,J3) )
           => ( aa(fun(B,bool),fun(B,bool),aa(fun(B,bool),fun(fun(B,bool),fun(B,bool)),inf_inf(fun(B,bool)),domainp(B,B,aa(A,fun(B,fun(B,bool)),R3,I3))),rangep(B,B,aa(A,fun(B,fun(B,bool)),R3,J3))) = bot_bot(fun(B,bool)) ) )
       => wfP(B,aa(set(fun(B,fun(B,bool))),fun(B,fun(B,bool)),complete_Sup_Sup(fun(B,fun(B,bool))),aa(set(A),set(fun(B,fun(B,bool))),image2(A,fun(B,fun(B,bool)),R3),top_top(set(A))))) ) ) ).

% wfP_SUP
tff(fact_4631_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A3: A] : ( bit_se5641148757651400278ts_bit(A,bit_se4197421643247451524op_bit(A,N,A3)) = aa(fun(nat,nat),fun(nat,bool),aa(fun(nat,bool),fun(fun(nat,nat),fun(nat,bool)),comp(nat,bool,nat),bit_se5641148757651400278ts_bit(A,A3)),aa(nat,fun(nat,nat),plus_plus(nat),N)) ) ) ).

% bit_drop_bit_eq
tff(fact_4632_Domainp__Domain__eq,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B)),X3: A] :
      ( pp(aa(A,bool,domainp(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),R3)),X3))
    <=> pp(member(A,X3,domain(A,B,R3))) ) ).

% Domainp_Domain_eq
tff(fact_4633_Domain__def,axiom,
    ! [B: $tType,A: $tType,X3: set(product_prod(A,B))] : ( domain(A,B,X3) = aa(fun(A,bool),set(A),collect(A),domainp(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),X3))) ) ).

% Domain_def
tff(fact_4634_wfP__wf__eq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( wfP(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3))
    <=> wf(A,R3) ) ).

% wfP_wf_eq
tff(fact_4635_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] : ( divide_divide(A,A3,bit_se4730199178511100633sh_bit(A,N,one_one(A))) = bit_se4197421643247451524op_bit(A,N,A3) ) ) ).

% div_push_bit_of_1_eq_drop_bit
tff(fact_4636_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),N))
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se4197421643247451524op_bit(A,N,A3)),one_one(A)) = one_one(A) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
tff(fact_4637_pcr__Domainp__par,axiom,
    ! [A: $tType,B: $tType,C: $tType,B3: fun(A,fun(B,bool)),P23: fun(A,bool),A4: fun(C,fun(A,bool)),P12: fun(C,bool),P24: fun(C,bool)] :
      ( ( domainp(A,B,B3) = P23 )
     => ( ( domainp(C,A,A4) = P12 )
       => ( pp(aa(fun(A,bool),bool,aa(fun(C,bool),fun(fun(A,bool),bool),bNF_rel_fun(C,A,bool,bool,A4,fequal(bool)),P24),P23))
         => ( domainp(C,B,relcompp(C,A,B,A4,B3)) = aa(fun(C,bool),fun(C,bool),aa(fun(C,bool),fun(fun(C,bool),fun(C,bool)),inf_inf(fun(C,bool)),P12),P24) ) ) ) ) ).

% pcr_Domainp_par
tff(fact_4638_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M4: nat,N: nat] : ( bit_se4197421643247451524op_bit(A,M4,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),fconj(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N),bit_se6407376104438227557le_bit(A,type2(A),N)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ).

% drop_bit_exp_eq
tff(fact_4639_composed__equiv__rel__eq__onp,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool)),P: fun(A,bool),P2: fun(B,bool),P9: fun(A,bool)] :
      ( left_unique(A,B,R)
     => ( pp(aa(fun(B,bool),bool,aa(fun(A,bool),fun(fun(B,bool),bool),bNF_rel_fun(A,B,bool,bool,R,fequal(bool)),P),P2))
       => ( ( domainp(A,B,R) = P9 )
         => ( relcompp(A,B,A,R,relcompp(B,B,A,bNF_eq_onp(B,P2),conversep(A,B,R))) = bNF_eq_onp(A,aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),P9),P)) ) ) ) ) ).

% composed_equiv_rel_eq_onp
tff(fact_4640_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),one_one(A))),N))
        <=> pp(bit_se6407376104438227557le_bit(A,type2(A),N)) ) ) ).

% bit_minus_1_iff
tff(fact_4641_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),A3)),N))
        <=> ( pp(bit_se6407376104438227557le_bit(A,type2(A),N))
            & ~ pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),one_one(A))),N)) ) ) ) ).

% bit_minus_iff
tff(fact_4642_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M4: nat,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),M4)),one_one(A))),N))
        <=> ( pp(bit_se6407376104438227557le_bit(A,type2(A),N))
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),M4)) ) ) ) ).

% bit_mask_sub_iff
tff(fact_4643_bit__double__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A3: A,N: nat] :
          ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),A3)),N))
        <=> ( pp(aa(nat,bool,bit_se5641148757651400278ts_bit(A,A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))))
            & ( N != zero_zero(nat) )
            & pp(bit_se6407376104438227557le_bit(A,type2(A),N)) ) ) ) ).

% bit_double_iff
tff(fact_4644_multiset_Odomain__par,axiom,
    ! [B: $tType,C: $tType,T3: fun(C,fun(B,bool)),DT: fun(C,bool),DS: fun(nat,bool),P24: fun(fun(C,nat),bool)] :
      ( ( domainp(C,B,T3) = DT )
     => ( ( domainp(nat,nat,fequal(nat)) = DS )
       => ( left_unique(C,B,T3)
         => ( pp(aa(fun(fun(B,nat),bool),bool,aa(fun(fun(C,nat),bool),fun(fun(fun(B,nat),bool),bool),bNF_rel_fun(fun(C,nat),fun(B,nat),bool,bool,bNF_rel_fun(C,B,nat,nat,T3,fequal(nat)),fequal(bool)),P24),aTP_Lamp_rc(fun(B,nat),bool)))
           => ( domainp(fun(C,nat),multiset(B),pcr_multiset(C,B,T3)) = aa(fun(fun(C,nat),bool),fun(fun(C,nat),bool),aa(fun(fun(C,nat),bool),fun(fun(fun(C,nat),bool),fun(fun(C,nat),bool)),inf_inf(fun(fun(C,nat),bool)),basic_pred_fun(C,nat,DT,DS)),P24) ) ) ) ) ) ).

% multiset.domain_par
tff(fact_4645_cut__def,axiom,
    ! [A: $tType,B: $tType,X: A,R: set(product_prod(A,A)),F: fun(A,B),X3: A] :
      ( ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),X),R))
       => ( aa(A,B,cut(A,B,F,R,X),X3) = aa(A,B,F,X3) ) )
      & ( ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),X),R))
       => ( aa(A,B,cut(A,B,F,R,X),X3) = undefined(B) ) ) ) ).

% cut_def
tff(fact_4646_pairwise__alt,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),S2: set(A)] :
      ( pairwise(A,R,S2)
    <=> ! [X4: A] :
          ( pp(member(A,X4,S2))
         => ! [Xa2: A] :
              ( pp(member(A,Xa2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert2(A,X4),bot_bot(set(A))))))
             => pp(aa(A,bool,aa(A,fun(A,bool),R,X4),Xa2)) ) ) ) ).

% pairwise_alt
tff(fact_4647_pairwise__empty,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool))] : pairwise(A,P,bot_bot(set(A))) ).

% pairwise_empty
tff(fact_4648_pred__fun__True__id,axiom,
    ! [A: $tType,B: $tType,C: $tType,P3: fun(B,bool),F: fun(C,B)] :
      ( nO_MATCH(fun(A,A),fun(B,bool),id(A),P3)
     => ( pp(aa(fun(C,B),bool,basic_pred_fun(C,B,aTP_Lamp_rd(C,bool),P3),F))
      <=> pp(aa(fun(C,bool),bool,basic_pred_fun(C,bool,aTP_Lamp_rd(C,bool),id(bool)),aa(fun(C,B),fun(C,bool),aa(fun(B,bool),fun(fun(C,B),fun(C,bool)),comp(B,bool,C),P3),F))) ) ) ).

% pred_fun_True_id
tff(fact_4649_fun_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,D: $tType,X: fun(D,A),Ya: fun(D,A),F: fun(A,B),G: fun(A,B)] :
      ( ( X = Ya )
     => ( pp(aa(fun(D,A),bool,basic_pred_fun(D,A,aTP_Lamp_re(D,bool),aa(fun(A,B),fun(A,bool),aTP_Lamp_rf(fun(A,B),fun(fun(A,B),fun(A,bool)),F),G)),Ya))
       => ( aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),F),X) = aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),G),Ya) ) ) ) ).

% fun.map_cong_pred
tff(fact_4650_cuts__eq,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),R: set(product_prod(A,A)),X: A,G: fun(A,B)] :
      ( ( cut(A,B,F,R,X) = cut(A,B,G,R,X) )
    <=> ! [Y3: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y3),X),R))
         => ( aa(A,B,F,Y3) = aa(A,B,G,Y3) ) ) ) ).

% cuts_eq
tff(fact_4651_cut__apply,axiom,
    ! [B: $tType,A: $tType,X: A,A3: A,R: set(product_prod(A,A)),F: fun(A,B)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),A3),R))
     => ( aa(A,B,cut(A,B,F,R,A3),X) = aa(A,B,F,X) ) ) ).

% cut_apply
tff(fact_4652_pairwise__singleton,axiom,
    ! [A: $tType,P: fun(A,fun(A,bool)),A4: A] : pairwise(A,P,aa(set(A),set(A),insert2(A,A4),bot_bot(set(A)))) ).

% pairwise_singleton
tff(fact_4653_fun_Opred__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,Q: fun(B,bool),F: fun(A,B),X: fun(D,A)] :
      ( pp(aa(fun(D,B),bool,basic_pred_fun(D,B,aTP_Lamp_re(D,bool),Q),aa(fun(D,A),fun(D,B),aa(fun(A,B),fun(fun(D,A),fun(D,B)),comp(A,B,D),F),X)))
    <=> pp(aa(fun(D,A),bool,basic_pred_fun(D,A,aTP_Lamp_re(D,bool),aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),Q),F)),X)) ) ).

% fun.pred_map
tff(fact_4654_ID_Oin__rel,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A3: A,B2: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),bNF_id_bnf(fun(A,fun(B,bool))),R),A3),B2))
    <=> ? [Z4: product_prod(A,B)] :
          ( pp(member(product_prod(A,B),Z4,aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aTP_Lamp_rg(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),R))))
          & ( aa(product_prod(A,B),A,aa(fun(product_prod(A,B),A),fun(product_prod(A,B),A),bNF_id_bnf(fun(product_prod(A,B),A)),product_fst(A,B)),Z4) = A3 )
          & ( aa(product_prod(A,B),B,aa(fun(product_prod(A,B),B),fun(product_prod(A,B),B),bNF_id_bnf(fun(product_prod(A,B),B)),product_snd(A,B)),Z4) = B2 ) ) ) ).

% ID.in_rel
tff(fact_4655_is__num_Ocases,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A3: A] :
          ( neg_numeral_is_num(A,A3)
         => ( ( A3 != one_one(A) )
           => ( ! [X2: A] :
                  ( ( A3 = aa(A,A,uminus_uminus(A),X2) )
                 => ~ neg_numeral_is_num(A,X2) )
             => ~ ! [X2: A,Y2: A] :
                    ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),X2),Y2) )
                   => ( neg_numeral_is_num(A,X2)
                     => ~ neg_numeral_is_num(A,Y2) ) ) ) ) ) ) ).

% is_num.cases
tff(fact_4656_is__num_Osimps,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A3: A] :
          ( neg_numeral_is_num(A,A3)
        <=> ( ( A3 = one_one(A) )
            | ? [X4: A] :
                ( ( A3 = aa(A,A,uminus_uminus(A),X4) )
                & neg_numeral_is_num(A,X4) )
            | ? [X4: A,Y3: A] :
                ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),Y3) )
                & neg_numeral_is_num(A,X4)
                & neg_numeral_is_num(A,Y3) ) ) ) ) ).

% is_num.simps
tff(fact_4657_is__num__normalize_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => neg_numeral_is_num(A,one_one(A)) ) ).

% is_num_normalize(4)
tff(fact_4658_ID_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q: fun(B,bool),F: fun(A,B),X: A] :
      ( pp(aa(B,bool,aa(fun(B,bool),fun(B,bool),bNF_id_bnf(fun(B,bool)),Q),aa(A,B,aa(fun(A,B),fun(A,B),bNF_id_bnf(fun(A,B)),F),X)))
    <=> pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),bNF_id_bnf(fun(A,bool)),aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),Q),F)),X)) ) ).

% ID.pred_map
tff(fact_4659_ID_Orel__refl__strong,axiom,
    ! [A: $tType,X: A,Ra2: fun(A,fun(A,bool))] :
      ( ! [Z3: A] :
          ( pp(member(A,Z3,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))
         => pp(aa(A,bool,aa(A,fun(A,bool),Ra2,Z3),Z3)) )
     => pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),bNF_id_bnf(fun(A,fun(A,bool))),Ra2),X),X)) ) ).

% ID.rel_refl_strong
tff(fact_4660_ID_Orel__mono__strong,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),X: A,Y: B,Ra2: fun(A,fun(B,bool))] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),bNF_id_bnf(fun(A,fun(B,bool))),R),X),Y))
     => ( ! [Z3: A,Yb: B] :
            ( pp(member(A,Z3,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))
           => ( pp(member(B,Yb,aa(set(B),set(B),insert2(B,Y),bot_bot(set(B)))))
             => ( pp(aa(B,bool,aa(A,fun(B,bool),R,Z3),Yb))
               => pp(aa(B,bool,aa(A,fun(B,bool),Ra2,Z3),Yb)) ) ) )
       => pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),bNF_id_bnf(fun(A,fun(B,bool))),Ra2),X),Y)) ) ) ).

% ID.rel_mono_strong
tff(fact_4661_ID_Orel__cong,axiom,
    ! [A: $tType,B: $tType,X: A,Ya: A,Y: B,Xa: B,R: fun(A,fun(B,bool)),Ra2: fun(A,fun(B,bool))] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z3: A,Yb: B] :
              ( pp(member(A,Z3,aa(set(A),set(A),insert2(A,Ya),bot_bot(set(A)))))
             => ( pp(member(B,Yb,aa(set(B),set(B),insert2(B,Xa),bot_bot(set(B)))))
               => ( pp(aa(B,bool,aa(A,fun(B,bool),R,Z3),Yb))
                <=> pp(aa(B,bool,aa(A,fun(B,bool),Ra2,Z3),Yb)) ) ) )
         => ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),bNF_id_bnf(fun(A,fun(B,bool))),R),X),Y))
          <=> pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),bNF_id_bnf(fun(A,fun(B,bool))),Ra2),Ya),Xa)) ) ) ) ) ).

% ID.rel_cong
tff(fact_4662_Basic__BNF__LFPs_Octor__rec__o__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(C,B),G: fun(A,C)] : ( aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),basic_BNF_ctor_rec(fun(C,B),F)),G) = basic_BNF_ctor_rec(fun(A,B),aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),F),aa(fun(A,A),fun(A,C),aa(fun(A,C),fun(fun(A,A),fun(A,C)),comp(A,C,A),aa(fun(A,C),fun(A,C),aa(fun(C,C),fun(fun(A,C),fun(A,C)),comp(C,C,A),bNF_id_bnf(C)),G)),bNF_id_bnf(A)))) ) ).

% Basic_BNF_LFPs.ctor_rec_o_map
tff(fact_4663_Basic__BNF__LFPs_Octor__rec__def__alt,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] : ( F = basic_BNF_ctor_rec(fun(A,B),aa(fun(A,A),fun(A,B),aa(fun(A,B),fun(fun(A,A),fun(A,B)),comp(A,B,A),F),bNF_id_bnf(A))) ) ).

% Basic_BNF_LFPs.ctor_rec_def_alt
tff(fact_4664_snga__assn__raw_Oelims_I3_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X,Xa),Xb))
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ( ( array_get(A,H,X) = Xa )
                  & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(A,X)),bot_bot(set(nat))) )
                  & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X)),lim(product_unit,H))) ) ) ) ) ).

% snga_assn_raw.elims(3)
tff(fact_4665_relH__array,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: array(A)] :
          ( relH(As,H2,H4)
         => ( pp(member(nat,addr_of_array(A,R3),As))
           => ( array_get(A,H2,R3) = array_get(A,H4,R3) ) ) ) ) ).

% relH_array
tff(fact_4666_ID_Opred__cong,axiom,
    ! [A: $tType,X: A,Ya: A,P: fun(A,bool),Pa: fun(A,bool)] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( pp(member(A,Z3,aa(set(A),set(A),insert2(A,Ya),bot_bot(set(A)))))
           => ( pp(aa(A,bool,P,Z3))
            <=> pp(aa(A,bool,Pa,Z3)) ) )
       => ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),bNF_id_bnf(fun(A,bool)),P),X))
        <=> pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),bNF_id_bnf(fun(A,bool)),Pa),Ya)) ) ) ) ).

% ID.pred_cong
tff(fact_4667_ID_Opred__mono__strong,axiom,
    ! [A: $tType,P: fun(A,bool),X: A,Pa: fun(A,bool)] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),bNF_id_bnf(fun(A,bool)),P),X))
     => ( ! [Z3: A] :
            ( pp(member(A,Z3,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))
           => ( pp(aa(A,bool,P,Z3))
             => pp(aa(A,bool,Pa,Z3)) ) )
       => pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),bNF_id_bnf(fun(A,bool)),Pa),X)) ) ) ).

% ID.pred_mono_strong
tff(fact_4668_ID_Opred__set,axiom,
    ! [A: $tType,P: fun(A,bool),X3: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),bNF_id_bnf(fun(A,bool)),P),X3))
    <=> ! [Xa2: A] :
          ( pp(member(A,Xa2,aa(set(A),set(A),insert2(A,X3),bot_bot(set(A)))))
         => pp(aa(A,bool,P,Xa2)) ) ) ).

% ID.pred_set
tff(fact_4669_snga__assn__raw_Osimps,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: array(A),X: list(A),H2: heap_ext(product_unit),As: set(nat)] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,R3,X),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
        <=> ( ( array_get(A,H2,R3) = X )
            & ( As = aa(set(nat),set(nat),insert2(nat,addr_of_array(A,R3)),bot_bot(set(nat))) )
            & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,R3)),lim(product_unit,H2))) ) ) ) ).

% snga_assn_raw.simps
tff(fact_4670_snga__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
          ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X,Xa),Xb))
          <=> pp(Y) )
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ( pp(Y)
                <=> ~ ( ( array_get(A,H,X) = Xa )
                      & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(A,X)),bot_bot(set(nat))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X)),lim(product_unit,H))) ) ) ) ) ) ).

% snga_assn_raw.elims(1)
tff(fact_4671_snga__assn__raw_Oelims_I2_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X,Xa),Xb))
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ~ ( ( array_get(A,H,X) = Xa )
                    & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(A,X)),bot_bot(set(nat))) )
                    & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X)),lim(product_unit,H))) ) ) ) ) ).

% snga_assn_raw.elims(2)
tff(fact_4672_snga__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
          ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X,Xa),Xb))
          <=> pp(Y) )
         => ( pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( ( pp(Y)
                    <=> ( ( array_get(A,H,X) = Xa )
                        & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(A,X)),bot_bot(set(nat))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X)),lim(product_unit,H))) ) )
                   => ~ pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))) ) ) ) ) ) ).

% snga_assn_raw.pelims(1)
tff(fact_4673_snga__assn__raw_Opelims_I2_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X,Xa),Xb))
         => ( pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))))
                   => ~ ( ( array_get(A,H,X) = Xa )
                        & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(A,X)),bot_bot(set(nat))) )
                        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X)),lim(product_unit,H))) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(2)
tff(fact_4674_snga__assn__raw_Opelims_I3_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [X: array(A),Xa: list(A),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,snga_assn_raw(A,X,Xa),Xb))
         => ( pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb))))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( pp(aa(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),bool,accp(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(A)),aa(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),aa(array(A),fun(product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat))),aa(list(A),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(A),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))))
                   => ( ( array_get(A,H,X) = Xa )
                      & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(A,X)),bot_bot(set(nat))) )
                      & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),addr_of_array(A,X)),lim(product_unit,H))) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(3)
tff(fact_4675_relH__set__array,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [R3: array(A),As: set(nat),H2: heap_ext(product_unit),X: list(A)] :
          ( ~ pp(member(nat,addr_of_array(A,R3),As))
         => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
           => relH(As,H2,array_set(A,R3,X,H2)) ) ) ) ).

% relH_set_array
tff(fact_4676_ctor__rec__unique,axiom,
    ! [B: $tType,A: $tType,G: fun(A,A),F: fun(A,B),S: fun(A,B)] :
      ( ( G = id(A) )
     => ( ( aa(fun(A,A),fun(A,B),aa(fun(A,B),fun(fun(A,A),fun(A,B)),comp(A,B,A),F),basic_BNF_xtor(A)) = aa(fun(A,A),fun(A,B),aa(fun(A,B),fun(fun(A,A),fun(A,B)),comp(A,B,A),S),aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),bNF_id_bnf(A)),G)),bNF_id_bnf(A))) )
       => ( F = basic_BNF_ctor_rec(fun(A,B),S) ) ) ) ).

% ctor_rec_unique
tff(fact_4677_Basic__BNF__LFPs_Octor__rec,axiom,
    ! [B: $tType,A: $tType,G: fun(A,A),F: fun(A,B),X: A] :
      ( ( G = id(A) )
     => ( aa(A,B,basic_BNF_ctor_rec(fun(A,B),F),aa(A,A,basic_BNF_xtor(A),X)) = aa(A,B,F,aa(A,A,aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),bNF_id_bnf(A)),G)),bNF_id_bnf(A)),X)) ) ) ).

% Basic_BNF_LFPs.ctor_rec
tff(fact_4678_xtor__map__unique,axiom,
    ! [B: $tType,A: $tType,U: fun(A,B),F: fun(A,B)] :
      ( ( aa(fun(A,A),fun(A,B),aa(fun(A,B),fun(fun(A,A),fun(A,B)),comp(A,B,A),U),basic_BNF_xtor(A)) = aa(fun(A,B),fun(A,B),aa(fun(B,B),fun(fun(A,B),fun(A,B)),comp(B,B,A),basic_BNF_xtor(B)),F) )
     => ( U = F ) ) ).

% xtor_map_unique
tff(fact_4679_Basic__BNF__LFPs_OPair__def__alt,axiom,
    ! [A: $tType,B: $tType,X3: A,Xa3: B] : ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3) = aa(product_prod(A,B),product_prod(A,B),basic_BNF_xtor(product_prod(A,B)),aa(product_prod(A,B),product_prod(A,B),bNF_id_bnf(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X3),Xa3))) ) ).

% Basic_BNF_LFPs.Pair_def_alt
tff(fact_4680_freeze__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A3: array(A)] : ( array_freeze(A,A3) = heap_Time_heap(list(A),aTP_Lamp_rh(array(A),fun(heap_ext(product_unit),product_prod(list(A),product_prod(heap_ext(product_unit),nat))),A3)) ) ) ).

% freeze_def
tff(fact_4681_execute__freeze,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A3: array(A),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(list(A),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(list(A)),fun(heap_ext(product_unit),option(product_prod(list(A),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(list(A)),array_freeze(A,A3)),H2) = aa(product_prod(list(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(list(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(list(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(list(A),product_prod(heap_ext(product_unit),nat)),aa(list(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(list(A),product_prod(heap_ext(product_unit),nat))),product_Pair(list(A),product_prod(heap_ext(product_unit),nat)),array_get(A,H2,A3)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),array_length(A,H2,A3))))) ) ) ).

% execute_freeze
tff(fact_4682_subset__mset_OatLeastatMost__empty,axiom,
    ! [A: $tType,B2: multiset(A),A3: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),B2),A3))
     => ( set_atLeastAtMost(multiset(A),subseteq_mset(A),A3,B2) = bot_bot(set(multiset(A))) ) ) ).

% subset_mset.atLeastatMost_empty
tff(fact_4683_subset__mset_OacyclicI__order,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(B,B)),F: fun(B,multiset(A))] :
      ( ! [A8: B,B5: B] :
          ( pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),B5),R3))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),aa(B,multiset(A),F,B5)),aa(B,multiset(A),F,A8))) )
     => transitive_acyclic(B,R3) ) ).

% subset_mset.acyclicI_order
tff(fact_4684_subset__implies__mult,axiom,
    ! [A: $tType,A4: multiset(A),B3: multiset(A),R3: set(product_prod(A,A))] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),A4),B3))
     => pp(member(product_prod(multiset(A),multiset(A)),aa(multiset(A),product_prod(multiset(A),multiset(A)),aa(multiset(A),fun(multiset(A),product_prod(multiset(A),multiset(A))),product_Pair(multiset(A),multiset(A)),A4),B3),mult(A,R3))) ) ).

% subset_implies_mult
tff(fact_4685_subset__mset_OgreaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType,A3: multiset(A),B2: multiset(A)] : ( set_gr3752724095348155675AtMost(multiset(A),subseteq_mset(A),subset_mset(A),A3,B2) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),set_atLeastAtMost(multiset(A),subseteq_mset(A),A3,B2)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),A3),bot_bot(set(multiset(A))))) ) ).

% subset_mset.greaterThanAtMost_eq_atLeastAtMost_diff
tff(fact_4686_subset__mset_OatLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType,A3: multiset(A),B2: multiset(A)] : ( set_atLeastLessThan(multiset(A),subseteq_mset(A),subset_mset(A),A3,B2) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),minus_minus(set(multiset(A))),set_atLeastAtMost(multiset(A),subseteq_mset(A),A3,B2)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),B2),bot_bot(set(multiset(A))))) ) ).

% subset_mset.atLeastLessThan_eq_atLeastAtMost_diff
tff(fact_4687_subset__mset_OgreaterThanLessThan__empty,axiom,
    ! [A: $tType,L: multiset(A),K: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),L),K))
     => ( set_gr287244882034783167ssThan(multiset(A),subset_mset(A),K,L) = bot_bot(set(multiset(A))) ) ) ).

% subset_mset.greaterThanLessThan_empty
tff(fact_4688_subset__mset_OatLeastLessThan__empty__iff2,axiom,
    ! [A: $tType,A3: multiset(A),B2: multiset(A)] :
      ( ( bot_bot(set(multiset(A))) = set_atLeastLessThan(multiset(A),subseteq_mset(A),subset_mset(A),A3,B2) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),A3),B2)) ) ).

% subset_mset.atLeastLessThan_empty_iff2
tff(fact_4689_subset__mset_OatLeastLessThan__empty__iff,axiom,
    ! [A: $tType,A3: multiset(A),B2: multiset(A)] :
      ( ( set_atLeastLessThan(multiset(A),subseteq_mset(A),subset_mset(A),A3,B2) = bot_bot(set(multiset(A))) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),A3),B2)) ) ).

% subset_mset.atLeastLessThan_empty_iff
tff(fact_4690_subset__mset_OatLeastLessThan__empty,axiom,
    ! [A: $tType,B2: multiset(A),A3: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),B2),A3))
     => ( set_atLeastLessThan(multiset(A),subseteq_mset(A),subset_mset(A),A3,B2) = bot_bot(set(multiset(A))) ) ) ).

% subset_mset.atLeastLessThan_empty
tff(fact_4691_subset__mset_OgreaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType,K: multiset(A),L: multiset(A)] :
      ( ( bot_bot(set(multiset(A))) = set_gr3752724095348155675AtMost(multiset(A),subseteq_mset(A),subset_mset(A),K,L) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),K),L)) ) ).

% subset_mset.greaterThanAtMost_empty_iff2
tff(fact_4692_subset__mset_OgreaterThanAtMost__empty__iff,axiom,
    ! [A: $tType,K: multiset(A),L: multiset(A)] :
      ( ( set_gr3752724095348155675AtMost(multiset(A),subseteq_mset(A),subset_mset(A),K,L) = bot_bot(set(multiset(A))) )
    <=> ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),K),L)) ) ).

% subset_mset.greaterThanAtMost_empty_iff
tff(fact_4693_subset__mset_OgreaterThanAtMost__empty,axiom,
    ! [A: $tType,L: multiset(A),K: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),L),K))
     => ( set_gr3752724095348155675AtMost(multiset(A),subseteq_mset(A),subset_mset(A),K,L) = bot_bot(set(multiset(A))) ) ) ).

% subset_mset.greaterThanAtMost_empty
tff(fact_4694_execute__len,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A3: array(A),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(nat,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(nat),fun(heap_ext(product_unit),option(product_prod(nat,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(nat),array_len(A,A3)),H2) = aa(product_prod(nat,product_prod(heap_ext(product_unit),nat)),option(product_prod(nat,product_prod(heap_ext(product_unit),nat))),some(product_prod(nat,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(nat,product_prod(heap_ext(product_unit),nat)),aa(nat,fun(product_prod(heap_ext(product_unit),nat),product_prod(nat,product_prod(heap_ext(product_unit),nat))),product_Pair(nat,product_prod(heap_ext(product_unit),nat)),array_length(A,H2,A3)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),one_one(nat)))) ) ) ).

% execute_len
tff(fact_4695_subset__mset_OIio__Int__singleton,axiom,
    ! [A: $tType,X: multiset(A),K: multiset(A)] :
      ( ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),X),K))
       => ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_lessThan(multiset(A),subset_mset(A),K)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) = aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A)))) ) )
      & ( ~ pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),X),K))
       => ( aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_lessThan(multiset(A),subset_mset(A),K)),aa(set(multiset(A)),set(multiset(A)),insert2(multiset(A),X),bot_bot(set(multiset(A))))) = bot_bot(set(multiset(A))) ) ) ) ).

% subset_mset.Iio_Int_singleton
tff(fact_4696_subset__mset_Osum__pos,axiom,
    ! [A: $tType,B: $tType,I4: set(B),F: fun(B,multiset(A))] :
      ( pp(aa(set(B),bool,finite_finite(B),I4))
     => ( ( I4 != bot_bot(set(B)) )
       => ( ! [I3: B] :
              ( pp(member(B,I3,I4))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),zero_zero(multiset(A))),aa(B,multiset(A),F,I3))) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),zero_zero(multiset(A))),groups3894954378712506084id_sum(multiset(A),B,plus_plus(multiset(A)),zero_zero(multiset(A)),F,I4))) ) ) ) ).

% subset_mset.sum_pos
tff(fact_4697_subset__mset_Osum__strict__mono,axiom,
    ! [A: $tType,B: $tType,A4: set(B),F: fun(B,multiset(A)),G: fun(B,multiset(A))] :
      ( pp(aa(set(B),bool,finite_finite(B),A4))
     => ( ( A4 != bot_bot(set(B)) )
       => ( ! [X2: B] :
              ( pp(member(B,X2,A4))
             => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),aa(B,multiset(A),F,X2)),aa(B,multiset(A),G,X2))) )
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subset_mset(A),groups3894954378712506084id_sum(multiset(A),B,plus_plus(multiset(A)),zero_zero(multiset(A)),F,A4)),groups3894954378712506084id_sum(multiset(A),B,plus_plus(multiset(A)),zero_zero(multiset(A)),G,A4))) ) ) ) ).

% subset_mset.sum_strict_mono
tff(fact_4698_subset__mset_OatLeastLessThan__def,axiom,
    ! [A: $tType,L: multiset(A),U: multiset(A)] : ( set_atLeastLessThan(multiset(A),subseteq_mset(A),subset_mset(A),L,U) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_atLeast(multiset(A),subseteq_mset(A),L)),set_lessThan(multiset(A),subset_mset(A),U)) ) ).

% subset_mset.atLeastLessThan_def
tff(fact_4699_subset__mset_OgreaterThanLessThan__eq,axiom,
    ! [A: $tType,A3: multiset(A),B2: multiset(A)] : ( set_gr287244882034783167ssThan(multiset(A),subset_mset(A),A3,B2) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_greaterThan(multiset(A),subset_mset(A),A3)),set_lessThan(multiset(A),subset_mset(A),B2)) ) ).

% subset_mset.greaterThanLessThan_eq
tff(fact_4700_subset__mset_OgreaterThanLessThan__def,axiom,
    ! [A: $tType,L: multiset(A),U: multiset(A)] : ( set_gr287244882034783167ssThan(multiset(A),subset_mset(A),L,U) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_greaterThan(multiset(A),subset_mset(A),L)),set_lessThan(multiset(A),subset_mset(A),U)) ) ).

% subset_mset.greaterThanLessThan_def
tff(fact_4701_subset__mset_Onot__empty__eq__Ici__eq__empty,axiom,
    ! [A: $tType,L: multiset(A)] : ( bot_bot(set(multiset(A))) != set_atLeast(multiset(A),subseteq_mset(A),L) ) ).

% subset_mset.not_empty_eq_Ici_eq_empty
tff(fact_4702_ord_OgreaterThanLessThan__def,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool)),L: A,U: A] : ( set_gr287244882034783167ssThan(A,Less,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_greaterThan(A,Less,L)),set_lessThan(A,Less,U)) ) ).

% ord.greaterThanLessThan_def
tff(fact_4703_ord_OgreaterThanLessThan__eq,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool)),A3: A,B2: A] : ( set_gr287244882034783167ssThan(A,Less,A3,B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_greaterThan(A,Less,A3)),set_lessThan(A,Less,B2)) ) ).

% ord.greaterThanLessThan_eq
tff(fact_4704_ord_OatLeastLessThan__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),L: A,U: A] : ( set_atLeastLessThan(A,Less_eq,Less,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_atLeast(A,Less_eq,L)),set_lessThan(A,Less,U)) ) ).

% ord.atLeastLessThan_def
tff(fact_4705_subset__mset_OgreaterThanAtMost__def,axiom,
    ! [A: $tType,L: multiset(A),U: multiset(A)] : ( set_gr3752724095348155675AtMost(multiset(A),subseteq_mset(A),subset_mset(A),L,U) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_greaterThan(multiset(A),subset_mset(A),L)),set_atMost(multiset(A),subseteq_mset(A),U)) ) ).

% subset_mset.greaterThanAtMost_def
tff(fact_4706_ord_OgreaterThanAtMost__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),L: A,U: A] : ( set_gr3752724095348155675AtMost(A,Less_eq,Less,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_greaterThan(A,Less,L)),set_atMost(A,Less_eq,U)) ) ).

% ord.greaterThanAtMost_def
tff(fact_4707_ord_OatLeastAtMost__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),L: A,U: A] : ( set_atLeastAtMost(A,Less_eq,L,U) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_atLeast(A,Less_eq,L)),set_atMost(A,Less_eq,U)) ) ).

% ord.atLeastAtMost_def
tff(fact_4708_subset__mset_Onot__empty__eq__Iic__eq__empty,axiom,
    ! [A: $tType,H2: multiset(A)] : ( bot_bot(set(multiset(A))) != set_atMost(multiset(A),subseteq_mset(A),H2) ) ).

% subset_mset.not_empty_eq_Iic_eq_empty
tff(fact_4709_subset__mset_OatLeastAtMost__def,axiom,
    ! [A: $tType,L: multiset(A),U: multiset(A)] : ( set_atLeastAtMost(multiset(A),subseteq_mset(A),L,U) = aa(set(multiset(A)),set(multiset(A)),aa(set(multiset(A)),fun(set(multiset(A)),set(multiset(A))),inf_inf(set(multiset(A))),set_atLeast(multiset(A),subseteq_mset(A),L)),set_atMost(multiset(A),subseteq_mset(A),U)) ) ).

% subset_mset.atLeastAtMost_def
tff(fact_4710_execute__nth_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I: nat,H2: heap_ext(product_unit),A3: array(A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),array_length(A,H2,A3)))
         => ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),aa(nat,heap_Time_Heap(A),array_nth(A,A3),I)),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),nth(A,array_get(A,H2,A3),I)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),one_one(nat)))) ) ) ) ).

% execute_nth(1)
tff(fact_4711_length__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A3: array(A),Xs: list(A)] : hoare_hoare_triple(nat,snga_assn(A,A3,Xs),array_len(A,A3),aa(list(A),fun(nat,assn),aTP_Lamp_ri(array(A),fun(list(A),fun(nat,assn)),A3),Xs)) ) ).

% length_rule
tff(fact_4712_Array__Time_Onth__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A3: array(A),I: nat] : ( aa(nat,heap_Time_Heap(A),array_nth(A,A3),I) = heap_Time_guard(A,aa(nat,fun(heap_ext(product_unit),bool),aTP_Lamp_rj(array(A),fun(nat,fun(heap_ext(product_unit),bool)),A3),I),aa(nat,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rk(array(A),fun(nat,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))),A3),I)) ) ) ).

% Array_Time.nth_def
tff(fact_4713_nth__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I: nat,Xs: list(A),A3: array(A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),size_size(list(A),Xs)))
         => hoare_hoare_triple(A,snga_assn(A,A3,Xs),aa(nat,heap_Time_Heap(A),array_nth(A,A3),I),aa(array(A),fun(A,assn),aa(list(A),fun(array(A),fun(A,assn)),aTP_Lamp_rl(nat,fun(list(A),fun(array(A),fun(A,assn))),I),Xs),A3)) ) ) ).

% nth_rule
tff(fact_4714_nth__step__trancl,axiom,
    ! [A: $tType,Xs: list(A),R: set(product_prod(A,A)),N: nat,M4: nat] :
      ( ! [N3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),size_size(list(A),Xs)),one_one(nat))))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),nth(A,Xs,aa(nat,nat,suc,N3))),nth(A,Xs,N3)),R)) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),size_size(list(A),Xs)))
       => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M4),N))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),nth(A,Xs,N)),nth(A,Xs,M4)),transitive_trancl(A,R))) ) ) ) ).

% nth_step_trancl
tff(fact_4715_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list(A),Ys: list(B)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),size_size(list(A),Xs)),size_size(list(B),Ys))))
     => ( nth(product_prod(A,B),product(A,B,Xs,Ys),N) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),nth(A,Xs,divide_divide(nat,N,size_size(list(B),Ys)))),nth(B,Ys,modulo_modulo(nat,N,size_size(list(B),Ys)))) ) ) ).

% product_nth
tff(fact_4716_mergesort__by__rel__split__length,axiom,
    ! [A: $tType,Xs1: list(A),Xs2: list(A),Xs: list(A)] :
      ( ( size_size(list(A),aa(product_prod(list(A),list(A)),list(A),product_fst(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs1),Xs2),Xs))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_size(list(A),Xs1)),divide_divide(nat,size_size(list(A),Xs),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),modulo_modulo(nat,size_size(list(A),Xs),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) )
      & ( size_size(list(A),aa(product_prod(list(A),list(A)),list(A),product_snd(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs1),Xs2),Xs))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_size(list(A),Xs2)),divide_divide(nat,size_size(list(A),Xs),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% mergesort_by_rel_split_length
tff(fact_4717_execute__swap_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I: nat,H2: heap_ext(product_unit),A3: array(A),X: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),array_length(A,H2,A3)))
         => ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),array_swap(A,I,X,A3)),H2) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),nth(A,array_get(A,H2,A3),I)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(A,A3,I,X,H2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ).

% execute_swap(1)
tff(fact_4718_swap__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I: nat,X: A,A3: array(A)] : ( array_swap(A,I,X,A3) = heap_Time_guard(A,aa(array(A),fun(heap_ext(product_unit),bool),aTP_Lamp_rm(nat,fun(array(A),fun(heap_ext(product_unit),bool)),I),A3),aa(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(A,fun(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_rn(nat,fun(A,fun(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))))),I),X),A3)) ) ) ).

% swap_def
tff(fact_4719_map__entry__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I: nat,F: fun(A,A),A3: array(A)] : ( array_map_entry(A,I,F,A3) = heap_Time_guard(array(A),aa(array(A),fun(heap_ext(product_unit),bool),aTP_Lamp_rm(nat,fun(array(A),fun(heap_ext(product_unit),bool)),I),A3),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(fun(A,A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_ro(nat,fun(fun(A,A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))))),I),F),A3)) ) ) ).

% map_entry_def
tff(fact_4720_execute__map__entry_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I: nat,H2: heap_ext(product_unit),A3: array(A),F: fun(A,A)] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),array_length(A,H2,A3)))
         => ( aa(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(array(A)),fun(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(array(A)),array_map_entry(A,I,F,A3)),H2) = aa(product_prod(array(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_Pair(array(A),product_prod(heap_ext(product_unit),nat)),A3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(A,A3,I,aa(A,A,F,nth(A,array_get(A,H2,A3),I)),H2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ).

% execute_map_entry(1)
tff(fact_4721_mergesort__by__rel__split_Osimps_I1_J,axiom,
    ! [A: $tType,Xs1: list(A),Xs2: list(A)] : ( merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs1),Xs2),nil(A)) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs1),Xs2) ) ).

% mergesort_by_rel_split.simps(1)
tff(fact_4722_execute__upd_I1_J,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I: nat,H2: heap_ext(product_unit),A3: array(A),X: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),array_length(A,H2,A3)))
         => ( aa(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(array(A)),fun(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(array(A)),array_upd(A,I,X,A3)),H2) = aa(product_prod(array(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_Pair(array(A),product_prod(heap_ext(product_unit),nat)),A3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(A,A3,I,X,H2)),one_one(nat)))) ) ) ) ).

% execute_upd(1)
tff(fact_4723_upd__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I: nat,X: A,A3: array(A)] : ( array_upd(A,I,X,A3) = heap_Time_guard(array(A),aa(array(A),fun(heap_ext(product_unit),bool),aTP_Lamp_rm(nat,fun(array(A),fun(heap_ext(product_unit),bool)),I),A3),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(A,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_rp(nat,fun(A,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))))),I),X),A3)) ) ) ).

% upd_def
tff(fact_4724_execute__of__list,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Xs: list(A),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(array(A)),fun(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(array(A)),array_of_list(A,Xs)),H2) = aa(product_prod(array(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rq(list(A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Xs)),array_alloc(A,Xs,H2))) ) ) ).

% execute_of_list
tff(fact_4725_effect__of__listI,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A3: array(A),H4: heap_ext(product_unit),Xs: list(A),H2: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),product_prod(array(A),heap_ext(product_unit)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),heap_ext(product_unit))),product_Pair(array(A),heap_ext(product_unit)),A3),H4) = array_alloc(A,Xs,H2) )
         => heap_Time_effect(array(A),array_of_list(A,Xs),H2,H4,A3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),size_size(list(A),Xs))) ) ) ).

% effect_of_listI
tff(fact_4726_of__list__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Xs: list(A)] : ( array_of_list(A,Xs) = heap_Time_heap(array(A),aTP_Lamp_rr(list(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),Xs)) ) ) ).

% of_list_def
tff(fact_4727_Array__Time_Oalloc__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Xs: list(A),H2: heap_ext(product_unit)] : ( array_alloc(A,Xs,H2) = aa(heap_ext(product_unit),product_prod(array(A),heap_ext(product_unit)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),heap_ext(product_unit))),product_Pair(array(A),heap_ext(product_unit)),array2(A,lim(product_unit,H2))),array_set(A,array2(A,lim(product_unit,H2)),Xs,lim_update(product_unit,aTP_Lamp_mz(heap_ext(product_unit),fun(nat,nat),H2),H2))) ) ) ).

% Array_Time.alloc_def
tff(fact_4728_upd__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [I: nat,Xs: list(A),A3: array(A),X: A] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),size_size(list(A),Xs)))
         => hoare_hoare_triple(array(A),snga_assn(A,A3,Xs),array_upd(A,I,X,A3),aa(A,fun(array(A),assn),aa(array(A),fun(A,fun(array(A),assn)),aa(list(A),fun(array(A),fun(A,fun(array(A),assn))),aTP_Lamp_rs(nat,fun(list(A),fun(array(A),fun(A,fun(array(A),assn)))),I),Xs),A3),X)) ) ) ).

% upd_rule
tff(fact_4729_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F: fun(B,A),A3: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F),A3),Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_rt(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F),A3),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),size_size(list(B),Xs))) ) ) ).

% horner_sum_eq_sum_funpow
tff(fact_4730_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F: fun(B,A),A3: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F),A3),Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_ru(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F),A3),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),size_size(list(B),Xs))) ) ) ).

% horner_sum_eq_sum
tff(fact_4731_nth__enumerate__eq,axiom,
    ! [A: $tType,M4: nat,Xs: list(A),N: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),M4),size_size(list(A),Xs)))
     => ( nth(product_prod(nat,A),enumerate(A,N,Xs),M4) = aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M4)),nth(A,Xs,M4)) ) ) ).

% nth_enumerate_eq
tff(fact_4732_mergesort__by__rel_Opinduct,axiom,
    ! [A: $tType,A0: fun(A,fun(A,bool)),A1: list(A),P: fun(fun(A,fun(A,bool)),fun(list(A),bool))] :
      ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),mergesort_by_rel_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),A0),A1)))
     => ( ! [R13: fun(A,fun(A,bool)),Xs3: list(A)] :
            ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),mergesort_by_rel_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),R13),Xs3)))
           => ( ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Xs3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
               => pp(aa(list(A),bool,aa(fun(A,fun(A,bool)),fun(list(A),bool),P,R13),aa(product_prod(list(A),list(A)),list(A),product_fst(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs3)))) )
             => ( ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Xs3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
                 => pp(aa(list(A),bool,aa(fun(A,fun(A,bool)),fun(list(A),bool),P,R13),aa(product_prod(list(A),list(A)),list(A),product_snd(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs3)))) )
               => pp(aa(list(A),bool,aa(fun(A,fun(A,bool)),fun(list(A),bool),P,R13),Xs3)) ) ) )
       => pp(aa(list(A),bool,aa(fun(A,fun(A,bool)),fun(list(A),bool),P,A0),A1)) ) ) ).

% mergesort_by_rel.pinduct
tff(fact_4733_mergesort__by__rel_Oelims,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A),Y: list(A)] :
      ( ( mergesort_by_rel(A,X,Xa) = Y )
     => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Xa)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => ( Y = Xa ) )
        & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Xa)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => ( Y = merges9089515139780605204_merge(A,X,mergesort_by_rel(A,X,aa(product_prod(list(A),list(A)),list(A),product_fst(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xa))),mergesort_by_rel(A,X,aa(product_prod(list(A),list(A)),list(A),product_snd(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xa)))) ) ) ) ) ).

% mergesort_by_rel.elims
tff(fact_4734_mergesort__by__rel_Ocases,axiom,
    ! [A: $tType,X: product_prod(fun(A,fun(A,bool)),list(A))] :
      ~ ! [R13: fun(A,fun(A,bool)),Xs3: list(A)] : ( X != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),R13),Xs3) ) ).

% mergesort_by_rel.cases
tff(fact_4735_mergesort__by__rel_Opsimps,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),Xs: list(A)] :
      ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),mergesort_by_rel_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),R),Xs)))
     => ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Xs)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => ( mergesort_by_rel(A,R,Xs) = Xs ) )
        & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Xs)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
         => ( mergesort_by_rel(A,R,Xs) = merges9089515139780605204_merge(A,R,mergesort_by_rel(A,R,aa(product_prod(list(A),list(A)),list(A),product_fst(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs))),mergesort_by_rel(A,R,aa(product_prod(list(A),list(A)),list(A),product_snd(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs)))) ) ) ) ) ).

% mergesort_by_rel.psimps
tff(fact_4736_mergesort__by__rel_Opelims,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A),Y: list(A)] :
      ( ( mergesort_by_rel(A,X,Xa) = Y )
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),mergesort_by_rel_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),Xa)))
       => ~ ( ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Xa)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
               => ( Y = Xa ) )
              & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Xa)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
               => ( Y = merges9089515139780605204_merge(A,X,mergesort_by_rel(A,X,aa(product_prod(list(A),list(A)),list(A),product_fst(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xa))),mergesort_by_rel(A,X,aa(product_prod(list(A),list(A)),list(A),product_snd(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xa)))) ) ) )
           => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),mergesort_by_rel_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),Xa))) ) ) ) ).

% mergesort_by_rel.pelims
tff(fact_4737_mergesort__by__rel_Osimps,axiom,
    ! [A: $tType,Xs: list(A),R: fun(A,fun(A,bool))] :
      ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Xs)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
       => ( mergesort_by_rel(A,R,Xs) = Xs ) )
      & ( ~ pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Xs)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))
       => ( mergesort_by_rel(A,R,Xs) = merges9089515139780605204_merge(A,R,mergesort_by_rel(A,R,aa(product_prod(list(A),list(A)),list(A),product_fst(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs))),mergesort_by_rel(A,R,aa(product_prod(list(A),list(A)),list(A),product_snd(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs)))) ) ) ) ).

% mergesort_by_rel.simps
tff(fact_4738_mergesort__by__rel__simps_I3_J,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),X1: A,X22: A,Xs: list(A)] : ( mergesort_by_rel(A,R,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X1),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X22),Xs))) = aa(product_prod(list(A),list(A)),list(A),aa(fun(list(A),fun(list(A),list(A))),fun(product_prod(list(A),list(A)),list(A)),product_case_prod(list(A),list(A),list(A)),aTP_Lamp_rv(fun(A,fun(A,bool)),fun(list(A),fun(list(A),list(A))),R)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X1),nil(A))),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X22),nil(A))),Xs)) ) ).

% mergesort_by_rel_simps(3)
tff(fact_4739_execute__new,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,X: A,H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(array(A)),fun(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(array(A)),aa(A,heap_Time_Heap(array(A)),aa(nat,fun(A,heap_Time_Heap(array(A))),array_new(A),N),X)),H2) = aa(product_prod(array(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rw(nat,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),N)),array_alloc(A,replicate(A,N,X),H2))) ) ) ).

% execute_new
tff(fact_4740_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel1(A,R3)))
    <=> ? [Y3: A,N5: nat] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),nth(A,Xs,N5)),Y3),R3))
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N5),size_size(list(A),Xs)))
          & ( Ys = list_update(A,Xs,N5,Y3) ) ) ) ).

% listrel1_iff_update
tff(fact_4741_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X: A,Xs: list(A),Y: A,Ys: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Ys)),listrel1(A,R3)))
    <=> ( ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
          & ( Xs = Ys ) )
        | ( ( X = Y )
          & pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel1(A,R3))) ) ) ) ).

% Cons_listrel1_Cons
tff(fact_4742_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F: fun(B,A),A3: A,X: B,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F),A3),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,F,X)),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F),A3),Xs))) ) ) ).

% horner_sum_simps(2)
tff(fact_4743_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs: list(B)] : ( enumerate(B,N,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)) = aa(list(product_prod(nat,B)),list(product_prod(nat,B)),aa(product_prod(nat,B),fun(list(product_prod(nat,B)),list(product_prod(nat,B))),cons(product_prod(nat,B)),aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),N),X)),enumerate(B,aa(nat,nat,suc,N),Xs)) ) ).

% enumerate_simps(2)
tff(fact_4744_listrel1I1,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A)),Xs: list(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
     => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Xs)),listrel1(A,R3))) ) ).

% listrel1I1
tff(fact_4745_listrel1I2,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A)),X: A] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel1(A,R3)))
     => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Ys)),listrel1(A,R3))) ) ).

% listrel1I2
tff(fact_4746_Cons__listrel1E1,axiom,
    ! [A: $tType,X: A,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)),Ys),listrel1(A,R3)))
     => ( ! [Y2: A] :
            ( ( Ys = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs) )
           => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y2),R3)) )
       => ~ ! [Zs: list(A)] :
              ( ( Ys = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Zs) )
             => ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Zs),listrel1(A,R3))) ) ) ) ).

% Cons_listrel1E1
tff(fact_4747_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list(A),Y: A,Ys: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Ys)),listrel1(A,R3)))
     => ( ! [X2: A] :
            ( ( Xs = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Ys) )
           => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y),R3)) )
       => ~ ! [Zs: list(A)] :
              ( ( Xs = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Zs) )
             => ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Zs),Ys),listrel1(A,R3))) ) ) ) ).

% Cons_listrel1E2
tff(fact_4748_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A)),Xs: list(A),Ys: list(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,R3)))
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),transitive_rtrancl(list(A),listrel1(A,R3))))
       => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Ys)),transitive_rtrancl(list(A),listrel1(A,R3)))) ) ) ).

% rtrancl_listrel1_ConsI2
tff(fact_4749_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A)),X: A] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),transitive_rtrancl(list(A),listrel1(A,R3))))
     => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Ys)),transitive_rtrancl(list(A),listrel1(A,R3)))) ) ).

% rtrancl_listrel1_ConsI1
tff(fact_4750_zipf_Ocases,axiom,
    ! [C: $tType,A: $tType,B: $tType,X: product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B)))] :
      ( ! [F9: fun(A,fun(B,C))] : ( X != aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),aa(fun(A,fun(B,C)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,C)),product_prod(list(A),list(B))),F9),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),nil(B))) )
     => ( ! [F9: fun(A,fun(B,C)),A8: A,As2: list(A),B5: B,Bs2: list(B)] : ( X != aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),aa(fun(A,fun(B,C)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,C)),product_prod(list(A),list(B))),F9),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),Bs2))) )
       => ( ! [A8: fun(A,fun(B,C)),V3: A,Va: list(A)] : ( X != aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),aa(fun(A,fun(B,C)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,C)),product_prod(list(A),list(B))),A8),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va)),nil(B))) )
         => ~ ! [A8: fun(A,fun(B,C)),V3: B,Va: list(B)] : ( X != aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),aa(fun(A,fun(B,C)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,C)),product_prod(list(A),list(B))),A8),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va))) ) ) ) ) ).

% zipf.cases
tff(fact_4751_merge_Ocases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: product_prod(list(A),list(A))] :
          ( ! [L22: list(A)] : ( X != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),L22) )
         => ( ! [V3: A,Va: list(A)] : ( X != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va)),nil(A)) )
           => ~ ! [X12: A,L12: list(A),X23: A,L22: list(A)] : ( X != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),L12)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),L22)) ) ) ) ) ).

% merge.cases
tff(fact_4752_list__all__zip_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))] :
      ( ! [P5: fun(A,fun(B,bool))] : ( X != aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),P5),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),nil(B))) )
     => ( ! [P5: fun(A,fun(B,bool)),A8: A,As2: list(A),B5: B,Bs2: list(B)] : ( X != aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),P5),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),Bs2))) )
       => ( ! [P5: fun(A,fun(B,bool)),V3: A,Va: list(A)] : ( X != aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),P5),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va)),nil(B))) )
         => ~ ! [P5: fun(A,fun(B,bool)),V3: B,Va: list(B)] : ( X != aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),P5),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va))) ) ) ) ) ).

% list_all_zip.cases
tff(fact_4753_partition__rev_Ocases,axiom,
    ! [A: $tType,X: product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A)))] :
      ( ! [P5: fun(A,bool),Yes: list(A),No: list(A)] : ( X != aa(product_prod(product_prod(list(A),list(A)),list(A)),product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),aa(fun(A,bool),fun(product_prod(product_prod(list(A),list(A)),list(A)),product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A)))),product_Pair(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),P5),aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No)),nil(A))) )
     => ~ ! [P5: fun(A,bool),Yes: list(A),No: list(A),X2: A,Xs3: list(A)] : ( X != aa(product_prod(product_prod(list(A),list(A)),list(A)),product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),aa(fun(A,bool),fun(product_prod(product_prod(list(A),list(A)),list(A)),product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A)))),product_Pair(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),P5),aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3))) ) ) ).

% partition_rev.cases
tff(fact_4754_quicksort__by__rel_Ocases,axiom,
    ! [A: $tType,X: product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))] :
      ( ! [R13: fun(A,fun(A,bool)),Sl: list(A)] : ( X != aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R13),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Sl),nil(A))) )
     => ~ ! [R13: fun(A,fun(A,bool)),Sl: list(A),X2: A,Xs3: list(A)] : ( X != aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R13),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Sl),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3))) ) ) ).

% quicksort_by_rel.cases
tff(fact_4755_mergesort__by__rel__merge_Ocases,axiom,
    ! [A: $tType,X: product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))] :
      ( ! [R13: fun(A,fun(A,bool)),X2: A,Xs3: list(A),Y2: A,Ys2: list(A)] : ( X != aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R13),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2))) )
     => ( ! [R13: fun(A,fun(A,bool)),Xs3: list(A)] : ( X != aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R13),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs3),nil(A))) )
       => ~ ! [R13: fun(A,fun(A,bool)),V3: A,Va: list(A)] : ( X != aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R13),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va))) ) ) ) ).

% mergesort_by_rel_merge.cases
tff(fact_4756_mergesort__by__rel__split_Ocases,axiom,
    ! [A: $tType,X: product_prod(product_prod(list(A),list(A)),list(A))] :
      ( ! [Xs12: list(A),Xs22: list(A)] : ( X != aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22)),nil(A)) )
     => ( ! [Xs12: list(A),Xs22: list(A),X2: A] : ( X != aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A))) )
       => ~ ! [Xs12: list(A),Xs22: list(A),X12: A,X23: A,Xs3: list(A)] : ( X != aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),Xs3))) ) ) ) ).

% mergesort_by_rel_split.cases
tff(fact_4757_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod(fun(A,B),product_prod(list(A),list(B)))] :
      ( ! [F9: fun(A,B),Bs2: list(B)] : ( X != aa(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B))),aa(fun(A,B),fun(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B)))),product_Pair(fun(A,B),product_prod(list(A),list(B))),F9),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),Bs2)) )
     => ~ ! [F9: fun(A,B),A8: A,As2: list(A),Bs2: list(B)] : ( X != aa(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B))),aa(fun(A,B),fun(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B)))),product_Pair(fun(A,B),product_prod(list(A),list(B))),F9),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2)),Bs2)) ) ) ).

% map_tailrec_rev.cases
tff(fact_4758_shuffles_Ocases,axiom,
    ! [A: $tType,X: product_prod(list(A),list(A))] :
      ( ! [Ys2: list(A)] : ( X != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys2) )
     => ( ! [Xs3: list(A)] : ( X != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs3),nil(A)) )
       => ~ ! [X2: A,Xs3: list(A),Y2: A,Ys2: list(A)] : ( X != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2)) ) ) ) ).

% shuffles.cases
tff(fact_4759_subset__eq__mset__impl_Ocases,axiom,
    ! [A: $tType,X: product_prod(list(A),list(A))] :
      ( ! [Ys2: list(A)] : ( X != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys2) )
     => ~ ! [X2: A,Xs3: list(A),Ys2: list(A)] : ( X != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),Ys2) ) ) ).

% subset_eq_mset_impl.cases
tff(fact_4760_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [X: product_prod(fun(A,B),list(A))] :
          ( ! [F9: fun(A,B),X2: A] : ( X != aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),F9),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A))) )
         => ( ! [F9: fun(A,B),X2: A,Y2: A,Zs: list(A)] : ( X != aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),F9),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs))) )
           => ~ ! [A8: fun(A,B)] : ( X != aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),A8),nil(A)) ) ) ) ) ).

% arg_min_list.cases
tff(fact_4761_successively_Ocases,axiom,
    ! [A: $tType,X: product_prod(fun(A,fun(A,bool)),list(A))] :
      ( ! [P5: fun(A,fun(A,bool))] : ( X != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),P5),nil(A)) )
     => ( ! [P5: fun(A,fun(A,bool)),X2: A] : ( X != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),P5),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A))) )
       => ~ ! [P5: fun(A,fun(A,bool)),X2: A,Y2: A,Xs3: list(A)] : ( X != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),P5),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs3))) ) ) ) ).

% successively.cases
tff(fact_4762_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X: product_prod(fun(A,fun(A,bool)),list(A))] :
      ( ! [P5: fun(A,fun(A,bool))] : ( X != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),P5),nil(A)) )
     => ~ ! [P5: fun(A,fun(A,bool)),X2: A,Ys2: list(A)] : ( X != aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),P5),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Ys2)) ) ) ).

% sorted_wrt.cases
tff(fact_4763_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list(A),R3: set(product_prod(A,A))] : ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),nil(A)),listrel1(A,R3))) ).

% not_listrel1_Nil
tff(fact_4764_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list(A),R3: set(product_prod(A,A))] : ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Xs),listrel1(A,R3))) ).

% not_Nil_listrel1
tff(fact_4765_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X: list(A),Y: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Y),transitive_rtrancl(list(A),listrel1(A,R3))))
     => ( size_size(list(A),X) = size_size(list(A),Y) ) ) ).

% rtrancl_listrel1_eq_len
tff(fact_4766_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel1(A,R3)))
     => ( size_size(list(A),Xs) = size_size(list(A),Ys) ) ) ).

% listrel1_eq_len
tff(fact_4767_mergesort__by__rel__split_Osimps_I3_J,axiom,
    ! [A: $tType,Xs1: list(A),Xs2: list(A),X1: A,X22: A,Xs: list(A)] : ( merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs1),Xs2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X1),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X22),Xs))) = merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X1),Xs1)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X22),Xs2)),Xs) ) ).

% mergesort_by_rel_split.simps(3)
tff(fact_4768_in__listrel1__converse,axiom,
    ! [A: $tType,X: list(A),Y: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Y),listrel1(A,converse(A,A,R3))))
    <=> pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Y),converse(list(A),list(A),listrel1(A,R3)))) ) ).

% in_listrel1_converse
tff(fact_4769_new__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,X: A] : hoare_hoare_triple(array(A),one_one(assn),aa(A,heap_Time_Heap(array(A)),aa(nat,fun(A,heap_Time_Heap(array(A))),array_new(A),N),X),aa(A,fun(array(A),assn),aTP_Lamp_rx(nat,fun(A,fun(array(A),assn)),N),X)) ) ).

% new_rule
tff(fact_4770_mergesort__by__rel__split_Osimps_I2_J,axiom,
    ! [A: $tType,Xs1: list(A),Xs2: list(A),X: A] : ( merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs1),Xs2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),nil(A))) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs1)),Xs2) ) ).

% mergesort_by_rel_split.simps(2)
tff(fact_4771_mergesort__by__rel__split_Oelims,axiom,
    ! [A: $tType,X: product_prod(list(A),list(A)),Xa: list(A),Y: product_prod(list(A),list(A))] :
      ( ( merges295452479951948502_split(A,X,Xa) = Y )
     => ( ! [Xs12: list(A),Xs22: list(A)] :
            ( ( X = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22) )
           => ( ( Xa = nil(A) )
             => ( Y != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22) ) ) )
       => ( ! [Xs12: list(A),Xs22: list(A)] :
              ( ( X = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22) )
             => ! [X2: A] :
                  ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A)) )
                 => ( Y != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs12)),Xs22) ) ) )
         => ~ ! [Xs12: list(A),Xs22: list(A)] :
                ( ( X = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22) )
               => ! [X12: A,X23: A,Xs3: list(A)] :
                    ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),Xs3)) )
                   => ( Y != merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),Xs12)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),Xs22)),Xs3) ) ) ) ) ) ) ).

% mergesort_by_rel_split.elims
tff(fact_4772_effect__newI,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A3: array(A),H4: heap_ext(product_unit),N: nat,X: A,H2: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),product_prod(array(A),heap_ext(product_unit)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),heap_ext(product_unit))),product_Pair(array(A),heap_ext(product_unit)),A3),H4) = array_alloc(A,replicate(A,N,X),H2) )
         => heap_Time_effect(array(A),aa(A,heap_Time_Heap(array(A)),aa(nat,fun(A,heap_Time_Heap(array(A))),array_new(A),N),X),H2,H4,A3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) ) ).

% effect_newI
tff(fact_4773_new__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,X: A] : ( aa(A,heap_Time_Heap(array(A)),aa(nat,fun(A,heap_Time_Heap(array(A))),array_new(A),N),X) = heap_Time_heap(array(A),aa(A,fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_ry(nat,fun(A,fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),N),X)) ) ) ).

% new_def
tff(fact_4774_listrel1p__def,axiom,
    ! [A: $tType,R3: fun(A,fun(A,bool)),Xs: list(A),Ys: list(A)] :
      ( listrel1p(A,R3,Xs,Ys)
    <=> pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel1(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R3))))) ) ).

% listrel1p_def
tff(fact_4775_mergesort__by__rel__merge_Opelims,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A),Xb: list(A),Y: list(A)] :
      ( ( merges9089515139780605204_merge(A,X,Xa,Xb) = Y )
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),merges2244889521215249637ge_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xa),Xb))))
       => ( ! [X2: A,Xs3: list(A)] :
              ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
             => ! [Y2: A,Ys2: list(A)] :
                  ( ( Xb = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2) )
                 => ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),X,X2),Y2))
                       => ( Y = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),merges9089515139780605204_merge(A,X,Xs3,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2))) ) )
                      & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),X,X2),Y2))
                       => ( Y = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),merges9089515139780605204_merge(A,X,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3),Ys2)) ) ) )
                   => ~ pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),merges2244889521215249637ge_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2))))) ) ) )
         => ( ( ( Xb = nil(A) )
             => ( ( Y = Xa )
               => ~ pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),merges2244889521215249637ge_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xa),nil(A))))) ) )
           => ~ ( ( Xa = nil(A) )
               => ! [V3: A,Va: list(A)] :
                    ( ( Xb = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va) )
                   => ( ( Y = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va) )
                     => ~ pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),merges2244889521215249637ge_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va))))) ) ) ) ) ) ) ) ).

% mergesort_by_rel_merge.pelims
tff(fact_4776_lexn_Osimps_I2_J,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),N: nat] : ( lexn(A,R3,aa(nat,nat,suc,N)) = aa(set(product_prod(list(A),list(A))),set(product_prod(list(A),list(A))),aa(set(product_prod(list(A),list(A))),fun(set(product_prod(list(A),list(A))),set(product_prod(list(A),list(A)))),inf_inf(set(product_prod(list(A),list(A)))),aa(set(product_prod(product_prod(A,list(A)),product_prod(A,list(A)))),set(product_prod(list(A),list(A))),image2(product_prod(product_prod(A,list(A)),product_prod(A,list(A))),product_prod(list(A),list(A)),product_map_prod(product_prod(A,list(A)),list(A),product_prod(A,list(A)),list(A),aa(fun(A,fun(list(A),list(A))),fun(product_prod(A,list(A)),list(A)),product_case_prod(A,list(A),list(A)),cons(A)),aa(fun(A,fun(list(A),list(A))),fun(product_prod(A,list(A)),list(A)),product_case_prod(A,list(A),list(A)),cons(A)))),lex_prod(A,list(A),R3,lexn(A,R3,N)))),aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_rz(nat,fun(list(A),fun(list(A),bool)),N)))) ) ).

% lexn.simps(2)
tff(fact_4777_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( lexn(A,R3,zero_zero(nat)) = bot_bot(set(product_prod(list(A),list(A)))) ) ).

% lexn.simps(1)
tff(fact_4778_lexn__length,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A)),N: nat] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),lexn(A,R3,N)))
     => ( ( size_size(list(A),Xs) = N )
        & ( size_size(list(A),Ys) = N ) ) ) ).

% lexn_length
tff(fact_4779_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A4: set(A)] : ( set_Cons(A,A4,aa(set(list(A)),set(list(A)),insert2(list(A),nil(A)),bot_bot(set(list(A))))) = aa(set(A),set(list(A)),image2(A,list(A),aTP_Lamp_sa(A,list(A))),A4) ) ).

% set_Cons_sing_Nil
tff(fact_4780_part__code_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F: fun(B,A),Pivot: A,X: B,Xs: list(B)] : ( linorder_part(B,A,F,Pivot,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)) = aa(product_prod(list(B),product_prod(list(B),list(B))),product_prod(list(B),product_prod(list(B),list(B))),aa(fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),fun(product_prod(list(B),product_prod(list(B),list(B))),product_prod(list(B),product_prod(list(B),list(B)))),product_case_prod(list(B),product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),aa(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),aa(A,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))))),aTP_Lamp_sc(fun(B,A),fun(A,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))))),F),Pivot),X)),linorder_part(B,A,F,Pivot,Xs)) ) ) ).

% part_code(2)
tff(fact_4781_part__code_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F: fun(B,A),Pivot: A] : ( linorder_part(B,A,F,Pivot,nil(B)) = aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),nil(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B))) ) ) ).

% part_code(1)
tff(fact_4782_listrel__Cons,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(B,A)),X: B,Xs: list(B)] : ( image(list(B),list(A),listrel(B,A,R3),aa(set(list(B)),set(list(B)),insert2(list(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),bot_bot(set(list(B))))) = set_Cons(A,image(B,A,R3,aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))),image(list(B),list(A),listrel(B,A,R3),aa(set(list(B)),set(list(B)),insert2(list(B),Xs),bot_bot(set(list(B)))))) ) ).

% listrel_Cons
tff(fact_4783_listset_Osimps_I1_J,axiom,
    ! [A: $tType] : ( listset(A,nil(set(A))) = aa(set(list(A)),set(list(A)),insert2(list(A),nil(A)),bot_bot(set(list(A)))) ) ).

% listset.simps(1)
tff(fact_4784_extract__Cons__code,axiom,
    ! [A: $tType,P: fun(A,bool),X: A,Xs: list(A)] :
      ( ( pp(aa(A,bool,P,X))
       => ( extract(A,P,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),nil(A)),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),X),Xs))) ) )
      & ( ~ pp(aa(A,bool,P,X))
       => ( extract(A,P,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)) = case_option(option(product_prod(list(A),product_prod(A,list(A)))),product_prod(list(A),product_prod(A,list(A))),none(product_prod(list(A),product_prod(A,list(A)))),aa(fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),fun(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A))))),product_case_prod(list(A),product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A))))),aTP_Lamp_se(A,fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),X)),extract(A,P,Xs)) ) ) ) ).

% extract_Cons_code
tff(fact_4785_listrel__rtrancl__refl,axiom,
    ! [A: $tType,Xs: list(A),R3: set(product_prod(A,A))] : pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Xs),listrel(A,A,transitive_rtrancl(A,R3)))) ).

% listrel_rtrancl_refl
tff(fact_4786_listrel__Nil,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(B,A))] : ( image(list(B),list(A),listrel(B,A,R3),aa(set(list(B)),set(list(B)),insert2(list(B),nil(B)),bot_bot(set(list(B))))) = aa(set(list(A)),set(list(A)),insert2(list(A),nil(A)),bot_bot(set(list(A)))) ) ).

% listrel_Nil
tff(fact_4787_listrel_ONil,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B))] : pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),nil(B)),listrel(A,B,R3))) ).

% listrel.Nil
tff(fact_4788_listrel__Nil1,axiom,
    ! [A: $tType,B: $tType,Xs: list(B),R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),Xs),listrel(A,B,R3)))
     => ( Xs = nil(B) ) ) ).

% listrel_Nil1
tff(fact_4789_listrel__Nil2,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xs),nil(B)),listrel(A,B,R3)))
     => ( Xs = nil(A) ) ) ).

% listrel_Nil2
tff(fact_4790_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xs),Ys),listrel(A,B,R3)))
     => ( size_size(list(A),Xs) = size_size(list(B),Ys) ) ) ).

% listrel_eq_len
tff(fact_4791_listrel__rtrancl__trans,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A)),Zs2: list(A)] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel(A,A,transitive_rtrancl(A,R3))))
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs2),listrel(A,A,transitive_rtrancl(A,R3))))
       => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Zs2),listrel(A,A,transitive_rtrancl(A,R3)))) ) ) ).

% listrel_rtrancl_trans
tff(fact_4792_listrel__Cons2,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Y: B,Ys: list(B),R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xs),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)),listrel(A,B,R3)))
     => ~ ! [X2: A,Xs3: list(A)] :
            ( ( Xs = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
           => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y),R3))
             => ~ pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xs3),Ys),listrel(A,B,R3))) ) ) ) ).

% listrel_Cons2
tff(fact_4793_listrel__Cons1,axiom,
    ! [B: $tType,A: $tType,Y: A,Ys: list(A),Xs: list(B),R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Ys)),Xs),listrel(A,B,R3)))
     => ~ ! [Y2: B,Ys2: list(B)] :
            ( ( Xs = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2) )
           => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Y),Y2),R3))
             => ~ pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Ys),Ys2),listrel(A,B,R3))) ) ) ) ).

% listrel_Cons1
tff(fact_4794_listrel_OCons,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,R3: set(product_prod(A,B)),Xs: list(A),Ys: list(B)] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y),R3))
     => ( pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xs),Ys),listrel(A,B,R3)))
       => pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)),listrel(A,B,R3))) ) ) ).

% listrel.Cons
tff(fact_4795_listrel__reflcl__if__listrel1,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel1(A,R3)))
     => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel(A,A,transitive_rtrancl(A,R3)))) ) ).

% listrel_reflcl_if_listrel1
tff(fact_4796_rtrancl__listrel1__if__listrel,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel(A,A,R3)))
     => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),transitive_rtrancl(list(A),listrel1(A,R3)))) ) ).

% rtrancl_listrel1_if_listrel
tff(fact_4797_listrel_Osimps,axiom,
    ! [B: $tType,A: $tType,A1: list(A),A22: list(B),R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),A1),A22),listrel(A,B,R3)))
    <=> ( ( ( A1 = nil(A) )
          & ( A22 = nil(B) ) )
        | ? [X4: A,Y3: B,Xs4: list(A),Ys3: list(B)] :
            ( ( A1 = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X4),Xs4) )
            & ( A22 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y3),Ys3) )
            & pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Y3),R3))
            & pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xs4),Ys3),listrel(A,B,R3))) ) ) ) ).

% listrel.simps
tff(fact_4798_listrel_Ocases,axiom,
    ! [B: $tType,A: $tType,A1: list(A),A22: list(B),R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),A1),A22),listrel(A,B,R3)))
     => ( ( ( A1 = nil(A) )
         => ( A22 != nil(B) ) )
       => ~ ! [X2: A,Y2: B,Xs3: list(A)] :
              ( ( A1 = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
             => ! [Ys2: list(B)] :
                  ( ( A22 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2) )
                 => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2),R3))
                   => ~ pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xs3),Ys2),listrel(A,B,R3))) ) ) ) ) ) ).

% listrel.cases
tff(fact_4799_listrel__iff__nth,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B),R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xs),Ys),listrel(A,B,R3)))
    <=> ( ( size_size(list(A),Xs) = size_size(list(B),Ys) )
        & ! [N5: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N5),size_size(list(A),Xs)))
           => pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),nth(A,Xs,N5)),nth(B,Ys,N5)),R3)) ) ) ) ).

% listrel_iff_nth
tff(fact_4800_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( linord4507533701916653071of_set(A,A4) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),lattic643756798350308766er_Min(A,A4)),linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,lattic643756798350308766er_Min(A,A4)),bot_bot(set(A)))))) ) ) ) ) ).

% sorted_list_of_set_nonempty
tff(fact_4801_upto_Opelims,axiom,
    ! [X: int,Xa: int,Y: list(int)] :
      ( ( upto(X,Xa) = Y )
     => ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X),Xa)))
       => ~ ( ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X),Xa))
               => ( Y = aa(list(int),list(int),aa(int,fun(list(int),list(int)),cons(int),X),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),X),one_one(int)),Xa)) ) )
              & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),X),Xa))
               => ( Y = nil(int) ) ) )
           => ~ pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X),Xa))) ) ) ) ).

% upto.pelims
tff(fact_4802_upto_Opsimps,axiom,
    ! [I: int,J2: int] :
      ( pp(aa(product_prod(int,int),bool,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),I),J2)))
     => ( ( pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J2))
         => ( upto(I,J2) = aa(list(int),list(int),aa(int,fun(list(int),list(int)),cons(int),I),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J2)) ) )
        & ( ~ pp(aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),I),J2))
         => ( upto(I,J2) = nil(int) ) ) ) ) ).

% upto.psimps
tff(fact_4803_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( linord4507533701916653071of_set(A,bot_bot(set(A))) = nil(A) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
tff(fact_4804_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( linord4507533701916653071of_set(A,A4) = nil(A) )
          <=> ( A4 = bot_bot(set(A)) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
tff(fact_4805_Cons__lenlex__iff,axiom,
    ! [A: $tType,M4: A,Ms: list(A),N: A,Ns: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),M4),Ms)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),N),Ns)),lenlex(A,R3)))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Ms)),size_size(list(A),Ns)))
        | ( ( size_size(list(A),Ms) = size_size(list(A),Ns) )
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),M4),N),R3)) )
        | ( ( M4 = N )
          & pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ms),Ns),lenlex(A,R3))) ) ) ) ).

% Cons_lenlex_iff
tff(fact_4806_lexn__conv,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),N: nat] : ( lexn(A,R3,N) = aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aa(nat,fun(list(A),fun(list(A),bool)),aTP_Lamp_sf(set(product_prod(A,A)),fun(nat,fun(list(A),fun(list(A),bool))),R3),N))) ) ).

% lexn_conv
tff(fact_4807_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ns),lenlex(A,R3)))
    <=> ( Ns != nil(A) ) ) ).

% Nil_lenlex_iff1
tff(fact_4808_lenlex__append2,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),Us: list(A),Xs: list(A),Ys: list(A)] :
      ( irrefl(A,R)
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),Xs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),Ys)),lenlex(A,R)))
      <=> pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),lenlex(A,R))) ) ) ).

% lenlex_append2
tff(fact_4809_append_Omonoid__axioms,axiom,
    ! [A: $tType] : monoid(list(A),append(A),nil(A)) ).

% append.monoid_axioms
tff(fact_4810_lenlex__append1,axiom,
    ! [A: $tType,Us: list(A),Xs: list(A),R: set(product_prod(A,A)),Vs: list(A),Ys: list(A)] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Us),Xs),lenlex(A,R)))
     => ( ( size_size(list(A),Vs) = size_size(list(A),Ys) )
       => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),Vs)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),lenlex(A,R))) ) ) ).

% lenlex_append1
tff(fact_4811_append__listrel1I,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A)),Us: list(A),Vs: list(A)] :
      ( ( ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel1(A,R3)))
          & ( Us = Vs ) )
        | ( ( Xs = Ys )
          & pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Us),Vs),listrel1(A,R3))) ) )
     => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Us)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Vs)),listrel1(A,R3))) ) ).

% append_listrel1I
tff(fact_4812_lenlex__irreflexive,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),Xs: list(A)] :
      ( ! [X2: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2),R3))
     => ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Xs),lenlex(A,R3))) ) ).

% lenlex_irreflexive
tff(fact_4813_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list(A),R3: set(product_prod(A,A))] : ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ns),nil(A)),lenlex(A,R3))) ).

% Nil_lenlex_iff2
tff(fact_4814_lenlex__trans,axiom,
    ! [A: $tType,X: list(A),Y: list(A),R3: set(product_prod(A,A)),Z2: list(A)] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Y),lenlex(A,R3)))
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Y),Z2),lenlex(A,R3)))
       => ( trans(A,R3)
         => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Z2),lenlex(A,R3))) ) ) ) ).

% lenlex_trans
tff(fact_4815_listrel1I,axiom,
    ! [A: $tType,X: A,Y: A,R3: set(product_prod(A,A)),Xs: list(A),Us: list(A),Vs: list(A),Ys: list(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
     => ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Vs)) )
       => ( ( Ys = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Vs)) )
         => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel1(A,R3))) ) ) ) ).

% listrel1I
tff(fact_4816_listrel1E,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel1(A,R3)))
     => ~ ! [X2: A,Y2: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),R3))
           => ! [Us2: list(A),Vs2: list(A)] :
                ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Vs2)) )
               => ( Ys != aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Vs2)) ) ) ) ) ).

% listrel1E
tff(fact_4817_lenlex__length,axiom,
    ! [A: $tType,Ms: list(A),Ns: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ms),Ns),lenlex(A,R3)))
     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),size_size(list(A),Ms)),size_size(list(A),Ns))) ) ).

% lenlex_length
tff(fact_4818_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list(A),X: A,Ys: list(A),Y: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),nil(A)))),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),nil(A)))),listrel1(A,R3)))
    <=> ( ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),listrel1(A,R3)))
          & ( X = Y ) )
        | ( ( Xs = Ys )
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3)) ) ) ) ).

% snoc_listrel1_snoc_iff
tff(fact_4819_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F: fun(B,A),A3: A,Xs: list(B),Ys: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F),A3),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F),A3),Xs)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A3),size_size(list(B),Xs))),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F),A3),Ys))) ) ) ).

% horner_sum_append
tff(fact_4820_listrel1__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( listrel1(A,R3) = aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_sg(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R3))) ) ).

% listrel1_def
tff(fact_4821_lex__conv,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( lex(A,R3) = aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_sh(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R3))) ) ).

% lex_conv
tff(fact_4822_lenlex__conv,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( lenlex(A,R3) = aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_si(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R3))) ) ).

% lenlex_conv
tff(fact_4823_lexord__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( lexord(A,R3) = aa(fun(product_prod(list(A),list(A)),bool),set(product_prod(list(A),list(A))),collect(product_prod(list(A),list(A))),aa(fun(list(A),fun(list(A),bool)),fun(product_prod(list(A),list(A)),bool),product_case_prod(list(A),list(A),bool),aTP_Lamp_sj(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),R3))) ) ).

% lexord_def
tff(fact_4824_lexord__cons__cons,axiom,
    ! [A: $tType,A3: A,X: list(A),B2: A,Y: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A3),X)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),B2),Y)),lexord(A,R3)))
    <=> ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
        | ( ( A3 = B2 )
          & pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Y),lexord(A,R3))) ) ) ) ).

% lexord_cons_cons
tff(fact_4825_lexord__Nil__left,axiom,
    ! [A: $tType,Y: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Y),lexord(A,R3)))
    <=> ? [A6: A,X4: list(A)] : ( Y = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A6),X4) ) ) ).

% lexord_Nil_left
tff(fact_4826_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),Xs: list(A),Ys: list(A),Zs2: list(A)] :
      ( irrefl(A,R3)
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs2)),lexord(A,R3)))
      <=> pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs2),lexord(A,R3))) ) ) ).

% lexord_same_pref_if_irrefl
tff(fact_4827_Cons__in__lex,axiom,
    ! [A: $tType,X: A,Xs: list(A),Y: A,Ys: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Ys)),lex(A,R3)))
    <=> ( ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),R3))
          & ( size_size(list(A),Xs) = size_size(list(A),Ys) ) )
        | ( ( X = Y )
          & pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),lex(A,R3))) ) ) ) ).

% Cons_in_lex
tff(fact_4828_lexord__lex,axiom,
    ! [A: $tType,X: list(A),Y: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Y),lex(A,R3)))
    <=> ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Y),lexord(A,R3)))
        & ( size_size(list(A),X) = size_size(list(A),Y) ) ) ) ).

% lexord_lex
tff(fact_4829_lexord__linear,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X: list(A),Y: list(A)] :
      ( ! [A8: A,B5: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A8),B5),R3))
          | ( A8 = B5 )
          | pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B5),A8),R3)) )
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Y),lexord(A,R3)))
        | ( X = Y )
        | pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Y),X),lexord(A,R3))) ) ) ).

% lexord_linear
tff(fact_4830_lexord__irreflexive,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),Xs: list(A)] :
      ( ! [X2: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2),R3))
     => ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Xs),lexord(A,R3))) ) ).

% lexord_irreflexive
tff(fact_4831_lexord__Nil__right,axiom,
    ! [A: $tType,X: list(A),R3: set(product_prod(A,A))] : ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),nil(A)),lexord(A,R3))) ).

% lexord_Nil_right
tff(fact_4832_lexord__append__leftI,axiom,
    ! [A: $tType,U: list(A),V: list(A),R3: set(product_prod(A,A)),X: list(A)] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),U),V),lexord(A,R3)))
     => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X),U)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X),V)),lexord(A,R3))) ) ).

% lexord_append_leftI
tff(fact_4833_lexord__trans,axiom,
    ! [A: $tType,X: list(A),Y: list(A),R3: set(product_prod(A,A)),Z2: list(A)] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Y),lexord(A,R3)))
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Y),Z2),lexord(A,R3)))
       => ( trans(A,R3)
         => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Z2),lexord(A,R3))) ) ) ) ).

% lexord_trans
tff(fact_4834_lexord__asymmetric,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),A3: list(A),B2: list(A)] :
      ( asym(A,R)
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),A3),B2),lexord(A,R)))
       => ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),B2),A3),lexord(A,R))) ) ) ).

% lexord_asymmetric
tff(fact_4835_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list(A),R3: set(product_prod(A,A))] : ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),nil(A)),lex(A,R3))) ).

% Nil2_notin_lex
tff(fact_4836_Nil__notin__lex,axiom,
    ! [A: $tType,Ys: list(A),R3: set(product_prod(A,A))] : ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys),lex(A,R3))) ).

% Nil_notin_lex
tff(fact_4837_lex__append__leftI,axiom,
    ! [A: $tType,Ys: list(A),Zs2: list(A),R3: set(product_prod(A,A)),Xs: list(A)] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs2),lex(A,R3)))
     => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs2)),lex(A,R3))) ) ).

% lex_append_leftI
tff(fact_4838_lexl__not__refl,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X: list(A)] :
      ( irrefl(A,R3)
     => ~ pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),X),lex(A,R3))) ) ).

% lexl_not_refl
tff(fact_4839_lexord__append__leftD,axiom,
    ! [A: $tType,X: list(A),U: list(A),V: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X),U)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X),V)),lexord(A,R3)))
     => ( ! [A8: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A8),A8),R3))
       => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),U),V),lexord(A,R3))) ) ) ).

% lexord_append_leftD
tff(fact_4840_lexord__append__rightI,axiom,
    ! [A: $tType,Y: list(A),X: list(A),R3: set(product_prod(A,A))] :
      ( ? [B10: A,Z5: list(A)] : ( Y = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),B10),Z5) )
     => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),X),Y)),lexord(A,R3))) ) ).

% lexord_append_rightI
tff(fact_4841_lexord__sufE,axiom,
    ! [A: $tType,Xs: list(A),Zs2: list(A),Ys: list(A),Qs: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs2)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Qs)),lexord(A,R3)))
     => ( ( Xs != Ys )
       => ( ( size_size(list(A),Xs) = size_size(list(A),Ys) )
         => ( ( size_size(list(A),Zs2) = size_size(list(A),Qs) )
           => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),lexord(A,R3))) ) ) ) ) ).

% lexord_sufE
tff(fact_4842_lex__append__left__iff,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),Xs: list(A),Ys: list(A),Zs2: list(A)] :
      ( ! [X2: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2),R3))
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs2)),lex(A,R3)))
      <=> pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs2),lex(A,R3))) ) ) ).

% lex_append_left_iff
tff(fact_4843_lex__append__leftD,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),Xs: list(A),Ys: list(A),Zs2: list(A)] :
      ( ! [X2: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),X2),R3))
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs2)),lex(A,R3)))
       => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs2),lex(A,R3))) ) ) ).

% lex_append_leftD
tff(fact_4844_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A)),Vs: list(A),Us: list(A)] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),lex(A,R3)))
     => ( ( size_size(list(A),Vs) = size_size(list(A),Us) )
       => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Us)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),Vs)),lex(A,R3))) ) ) ).

% lex_append_rightI
tff(fact_4845_lexord__append__left__rightI,axiom,
    ! [A: $tType,A3: A,B2: A,R3: set(product_prod(A,A)),U: list(A),X: list(A),Y: list(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
     => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A3),X))),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),B2),Y))),lexord(A,R3))) ) ).

% lexord_append_left_rightI
tff(fact_4846_lexord__sufI,axiom,
    ! [A: $tType,U: list(A),W2: list(A),R3: set(product_prod(A,A)),V: list(A),Z2: list(A)] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),U),W2),lexord(A,R3)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),size_size(list(A),W2)),size_size(list(A),U)))
       => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U),V)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),W2),Z2)),lexord(A,R3))) ) ) ).

% lexord_sufI
tff(fact_4847_lenlex__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : ( lenlex(A,R3) = inv_image(product_prod(nat,list(A)),list(A),lex_prod(nat,list(A),less_than,lex(A,R3)),aTP_Lamp_sk(list(A),product_prod(nat,list(A)))) ) ).

% lenlex_def
tff(fact_4848_List_Olexordp__def,axiom,
    ! [A: $tType,R3: fun(A,fun(A,bool)),Xs: list(A),Ys: list(A)] :
      ( lexordp(A,R3,Xs,Ys)
    <=> pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),lexord(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R3))))) ) ).

% List.lexordp_def
tff(fact_4849_extract__Some__iff,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Ys: list(A),Y: A,Zs2: list(A)] :
      ( ( extract(A,P,Xs) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),Ys),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),Y),Zs2))) )
    <=> ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Zs2)) )
        & pp(aa(A,bool,P,Y))
        & ~ ? [X4: A] :
              ( pp(member(A,X4,aa(list(A),set(A),set2(A),Ys)))
              & pp(aa(A,bool,P,X4)) ) ) ) ).

% extract_Some_iff
tff(fact_4850_extract__SomeE,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Ys: list(A),Y: A,Zs2: list(A)] :
      ( ( extract(A,P,Xs) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),Ys),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),Y),Zs2))) )
     => ( ( Xs = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Ys),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Zs2)) )
        & pp(aa(A,bool,P,Y))
        & ~ ? [X3: A] :
              ( pp(member(A,X3,aa(list(A),set(A),set2(A),Ys)))
              & pp(aa(A,bool,P,X3)) ) ) ) ).

% extract_SomeE
tff(fact_4851_set__empty,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),set(A),set2(A),Xs) = bot_bot(set(A)) )
    <=> ( Xs = nil(A) ) ) ).

% set_empty
tff(fact_4852_set__empty2,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( bot_bot(set(A)) = aa(list(A),set(A),set2(A),Xs) )
    <=> ( Xs = nil(A) ) ) ).

% set_empty2
tff(fact_4853_set__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N != zero_zero(nat) )
     => ( aa(list(A),set(A),set2(A),replicate(A,N,X)) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ) ).

% set_replicate
tff(fact_4854_empty__set,axiom,
    ! [A: $tType] : ( bot_bot(set(A)) = aa(list(A),set(A),set2(A),nil(A)) ) ).

% empty_set
tff(fact_4855_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list(A),R3: set(product_prod(A,A)),Ys: list(A),Zs2: list(A)] :
      ( ! [X2: A,Y2: A,Z3: A] :
          ( pp(member(A,X2,aa(list(A),set(A),set2(A),Xs)))
         => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Y2),R3))
           => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),Z3),R3))
             => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X2),Z3),R3)) ) ) )
     => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),lexord(A,R3)))
       => ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs2),lexord(A,R3)))
         => pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Zs2),lexord(A,R3))) ) ) ) ).

% lexord_partial_trans
tff(fact_4856_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N = zero_zero(nat) )
       => ( aa(list(A),set(A),set2(A),replicate(A,N,X)) = bot_bot(set(A)) ) )
      & ( ( N != zero_zero(nat) )
       => ( aa(list(A),set(A),set2(A),replicate(A,N,X)) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ) ) ).

% set_replicate_conv_if
tff(fact_4857_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] : ( aa(list(A),set(A),set2(A),replicate(A,aa(nat,nat,suc,N),X)) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ).

% set_replicate_Suc
tff(fact_4858_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs2: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Zs2)),lexord(A,R3)))
    <=> ( ? [X4: A] :
            ( pp(member(A,X4,aa(list(A),set(A),set2(A),Xs)))
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),X4),R3)) )
        | pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Ys),Zs2),lexord(A,R3))) ) ) ).

% lexord_same_pref_iff
tff(fact_4859_Pow__set_I1_J,axiom,
    ! [A: $tType] : ( pow(A,aa(list(A),set(A),set2(A),nil(A))) = aa(set(set(A)),set(set(A)),insert2(set(A),bot_bot(set(A))),bot_bot(set(set(A)))) ) ).

% Pow_set(1)
tff(fact_4860_set__update__distinct,axiom,
    ! [A: $tType,Xs: list(A),N: nat,X: A] :
      ( distinct(A,Xs)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),N),size_size(list(A),Xs)))
       => ( aa(list(A),set(A),set2(A),list_update(A,Xs,N,X)) = aa(set(A),set(A),insert2(A,X),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert2(A,nth(A,Xs,N)),bot_bot(set(A))))) ) ) ) ).

% set_update_distinct
tff(fact_4861_arg__min__list_Opelims,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [X: fun(A,B),Xa: list(A),Y: A] :
          ( ( arg_min_list(A,B,X,Xa) = Y )
         => ( pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),X),Xa)))
           => ( ! [X2: A] :
                  ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A)) )
                 => ( ( Y = X2 )
                   => ~ pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A))))) ) )
             => ( ! [X2: A,Y2: A,Zs: list(A)] :
                    ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs)) )
                   => ( ( Y = if(A,aa(B,bool,aa(B,fun(B,bool),ord_less_eq(B),aa(A,B,X,X2)),aa(A,B,X,arg_min_list(A,B,X,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs)))),X2,arg_min_list(A,B,X,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs))) )
                     => ~ pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Zs))))) ) )
               => ~ ( ( Xa = nil(A) )
                   => ( ( Y = undefined(A) )
                     => ~ pp(aa(product_prod(fun(A,B),list(A)),bool,accp(product_prod(fun(A,B),list(A)),arg_min_list_rel(A,B)),aa(list(A),product_prod(fun(A,B),list(A)),aa(fun(A,B),fun(list(A),product_prod(fun(A,B),list(A))),product_Pair(fun(A,B),list(A)),X),nil(A)))) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
tff(fact_4862_set__removeAll,axiom,
    ! [A: $tType,X: A,Xs: list(A)] : ( aa(list(A),set(A),set2(A),removeAll(A,X,Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) ) ).

% set_removeAll
tff(fact_4863_distinct__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( distinct(A,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys))
    <=> ( distinct(A,Xs)
        & distinct(A,Ys)
        & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) ) ) ) ).

% distinct_append
tff(fact_4864_distinct__list__update,axiom,
    ! [A: $tType,Xs: list(A),A3: A,I: nat] :
      ( distinct(A,Xs)
     => ( ~ pp(member(A,A3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert2(A,nth(A,Xs,I)),bot_bot(set(A))))))
       => distinct(A,list_update(A,Xs,I,A3)) ) ) ).

% distinct_list_update
tff(fact_4865_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list(A),X: A] :
      ( distinct(A,Xs)
     => ( aa(list(A),set(A),set2(A),remove1(A,X,Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))) ) ) ).

% set_remove1_eq
tff(fact_4866_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( linord4507533701916653071of_set(A,aa(set(A),set(A),insert2(A,X),A4)) = aa(list(A),list(A),linorder_insort_key(A,A,aTP_Lamp_sl(A,A),X),linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
tff(fact_4867_distinct__foldl__invar,axiom,
    ! [B: $tType,A: $tType,S2: list(A),I4: fun(set(A),fun(B,bool)),Sigma_0: B,F: fun(B,fun(A,B))] :
      ( distinct(A,S2)
     => ( pp(aa(B,bool,aa(set(A),fun(B,bool),I4,aa(list(A),set(A),set2(A),S2)),Sigma_0))
       => ( ! [X2: A,It: set(A),Sigma: B] :
              ( pp(member(A,X2,It))
             => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),It),aa(list(A),set(A),set2(A),S2)))
               => ( pp(aa(B,bool,aa(set(A),fun(B,bool),I4,It),Sigma))
                 => pp(aa(B,bool,aa(set(A),fun(B,bool),I4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),It),aa(set(A),set(A),insert2(A,X2),bot_bot(set(A))))),aa(A,B,aa(B,fun(A,B),F,Sigma),X2))) ) ) )
         => pp(aa(B,bool,aa(set(A),fun(B,bool),I4,bot_bot(set(A))),foldl(B,A,F,Sigma_0,S2))) ) ) ) ).

% distinct_foldl_invar
tff(fact_4868_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,X: A] : ( aa(fun(list(A),list(A)),fun(list(A),list(A)),aa(fun(list(A),list(A)),fun(fun(list(A),list(A)),fun(list(A),list(A))),comp(list(A),list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_sl(A,A),Y)),linorder_insort_key(A,A,aTP_Lamp_sl(A,A),X)) = aa(fun(list(A),list(A)),fun(list(A),list(A)),aa(fun(list(A),list(A)),fun(fun(list(A),list(A)),fun(list(A),list(A))),comp(list(A),list(A),list(A)),linorder_insort_key(A,A,aTP_Lamp_sl(A,A),X)),linorder_insort_key(A,A,aTP_Lamp_sl(A,A),Y)) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
tff(fact_4869_fst__foldl,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(A,fun(C,A)),G: fun(A,fun(B,fun(C,B))),A3: A,B2: B,Xs: list(C)] : ( aa(product_prod(A,B),A,product_fst(A,B),foldl(product_prod(A,B),C,aa(fun(A,fun(B,fun(C,product_prod(A,B)))),fun(product_prod(A,B),fun(C,product_prod(A,B))),product_case_prod(A,B,fun(C,product_prod(A,B))),aa(fun(A,fun(B,fun(C,B))),fun(A,fun(B,fun(C,product_prod(A,B)))),aTP_Lamp_sm(fun(A,fun(C,A)),fun(fun(A,fun(B,fun(C,B))),fun(A,fun(B,fun(C,product_prod(A,B))))),F),G)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2),Xs)) = foldl(A,C,F,A3,Xs) ) ).

% fst_foldl
tff(fact_4870_foldl__absorb1,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X: A,Zs2: list(A)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),X),foldl(A,A,times_times(A),one_one(A),Zs2)) = foldl(A,A,times_times(A),X,Zs2) ) ) ).

% foldl_absorb1
tff(fact_4871_foldl__un__empty__eq,axiom,
    ! [A: $tType,I: set(A),Ww: list(set(A))] : ( foldl(set(A),set(A),sup_sup(set(A)),I,Ww) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),I),foldl(set(A),set(A),sup_sup(set(A)),bot_bot(set(A)),Ww)) ) ).

% foldl_un_empty_eq
tff(fact_4872_foldl__set,axiom,
    ! [A: $tType,L: list(set(A))] : ( foldl(set(A),set(A),sup_sup(set(A)),bot_bot(set(A)),L) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(fun(set(A),bool),set(set(A)),collect(set(A)),aTP_Lamp_sn(list(set(A)),fun(set(A),bool),L))) ) ).

% foldl_set
tff(fact_4873_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,X,A4))
           => ( linord4507533701916653071of_set(A,A4) = aa(list(A),list(A),linorder_insort_key(A,A,aTP_Lamp_sl(A,A),X),linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
tff(fact_4874_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A4: set(A),X: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A))))) = remove1(A,X,linord4507533701916653071of_set(A,A4)) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
tff(fact_4875_lexord__take__index__conv,axiom,
    ! [A: $tType,X: list(A),Y: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Y),lexord(A,R3)))
    <=> ( ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),X)),size_size(list(A),Y)))
          & ( take(A,size_size(list(A),X),Y) = X ) )
        | ? [I2: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),size_size(list(A),X)),size_size(list(A),Y))))
            & ( take(A,I2,X) = take(A,I2,Y) )
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),nth(A,X,I2)),nth(A,Y,I2)),R3)) ) ) ) ).

% lexord_take_index_conv
tff(fact_4876_mset__mergesort__by__rel__split,axiom,
    ! [A: $tType,Xs1: list(A),Xs2: list(A),Xs: list(A)] : ( aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),aa(list(A),multiset(A),mset(A),aa(product_prod(list(A),list(A)),list(A),product_fst(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs1),Xs2),Xs)))),aa(list(A),multiset(A),mset(A),aa(product_prod(list(A),list(A)),list(A),product_snd(list(A),list(A)),merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs1),Xs2),Xs)))) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),aa(list(A),multiset(A),mset(A),Xs)),aa(list(A),multiset(A),mset(A),Xs1))),aa(list(A),multiset(A),mset(A),Xs2)) ) ).

% mset_mergesort_by_rel_split
tff(fact_4877_listrel__def,axiom,
    ! [B: $tType,A: $tType,X3: set(product_prod(A,B))] : ( listrel(A,B,X3) = aa(fun(product_prod(list(A),list(B)),bool),set(product_prod(list(A),list(B))),collect(product_prod(list(A),list(B))),aa(fun(list(A),fun(list(B),bool)),fun(product_prod(list(A),list(B)),bool),product_case_prod(list(A),list(B),bool),listrelp(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),X3)))) ) ).

% listrel_def
tff(fact_4878_set__mset__comp__mset,axiom,
    ! [A: $tType] : ( aa(fun(list(A),multiset(A)),fun(list(A),set(A)),aa(fun(multiset(A),set(A)),fun(fun(list(A),multiset(A)),fun(list(A),set(A))),comp(multiset(A),set(A),list(A)),set_mset(A)),mset(A)) = set2(A) ) ).

% set_mset_comp_mset
tff(fact_4879_lex__take__index,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),lex(A,R3)))
     => ~ ! [I3: nat] :
            ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),size_size(list(A),Xs)))
           => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I3),size_size(list(A),Ys)))
             => ( ( take(A,I3,Xs) = take(A,I3,Ys) )
               => ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),nth(A,Xs,I3)),nth(A,Ys,I3)),R3)) ) ) ) ) ).

% lex_take_index
tff(fact_4880_listrelp__listrel__eq,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(A,B)),X3: list(A),Xa3: list(B)] :
      ( pp(aa(list(B),bool,aa(list(A),fun(list(B),bool),listrelp(A,B,aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),R3)),X3),Xa3))
    <=> pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),X3),Xa3),listrel(A,B,R3))) ) ).

% listrelp_listrel_eq
tff(fact_4881_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( finite_card(list(A),shuffles(A,Xs,Ys)) = binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_size(list(A),Xs)),size_size(list(A),Ys)),size_size(list(A),Xs)) ) ) ).

% card_disjoint_shuffles
tff(fact_4882_nth__zip,axiom,
    ! [A: $tType,B: $tType,I: nat,Xs: list(A),Ys: list(B)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),size_size(list(A),Xs)))
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I),size_size(list(B),Ys)))
       => ( nth(product_prod(A,B),zip(A,B,Xs,Ys),I) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),nth(A,Xs,I)),nth(B,Ys,I)) ) ) ) ).

% nth_zip
tff(fact_4883_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B),R3: set(product_prod(A,B))] :
      ( pp(member(product_prod(list(A),list(B)),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xs),Ys),listrel(A,B,R3)))
    <=> ( ( size_size(list(A),Xs) = size_size(list(B),Ys) )
        & ! [X4: product_prod(A,B)] :
            ( pp(member(product_prod(A,B),X4,aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys))))
           => pp(aa(product_prod(A,B),bool,aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),R3)),X4)) ) ) ) ).

% listrel_iff_zip
tff(fact_4884_zip__Cons__Cons,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list(A),Y: B,Ys: list(B)] : ( zip(A,B,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)),zip(A,B,Xs,Ys)) ) ).

% zip_Cons_Cons
tff(fact_4885_zip__replicate,axiom,
    ! [A: $tType,B: $tType,I: nat,X: A,J2: nat,Y: B] : ( zip(A,B,replicate(A,I,X),replicate(B,J2,Y)) = replicate(product_prod(A,B),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),I),J2),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)) ) ).

% zip_replicate
tff(fact_4886_zip__same,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list(A)] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),zip(A,A,Xs,Xs))))
    <=> ( pp(member(A,A3,aa(list(A),set(A),set2(A),Xs)))
        & ( A3 = B2 ) ) ) ).

% zip_same
tff(fact_4887_in__set__zipE,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list(A),Ys: list(B)] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys))))
     => ~ ( pp(member(A,X,aa(list(A),set(A),set2(A),Xs)))
         => ~ pp(member(B,Y,aa(list(B),set(B),set2(B),Ys))) ) ) ).

% in_set_zipE
tff(fact_4888_set__zip__leftD,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,Xs: list(A),Ys: list(B)] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys))))
     => pp(member(A,X,aa(list(A),set(A),set2(A),Xs))) ) ).

% set_zip_leftD
tff(fact_4889_set__zip__rightD,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list(A),Ys: list(B)] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys))))
     => pp(member(B,Y,aa(list(B),set(B),set2(B),Ys))) ) ).

% set_zip_rightD
tff(fact_4890_zip__update,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),I: nat,X: A,Ys: list(B),Y: B] : ( zip(A,B,list_update(A,Xs,I,X),list_update(B,Ys,I,Y)) = list_update(product_prod(A,B),zip(A,B,Xs,Ys),I,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)) ) ).

% zip_update
tff(fact_4891_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),Y: B] :
      ( ( size_size(list(A),Xs) = size_size(list(B),Ys) )
     => ( pp(member(B,Y,aa(list(B),set(B),set2(B),Ys)))
       => ~ ! [X2: A] : ~ pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys)))) ) ) ).

% in_set_impl_in_set_zip2
tff(fact_4892_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),X: A] :
      ( ( size_size(list(A),Xs) = size_size(list(B),Ys) )
     => ( pp(member(A,X,aa(list(A),set(A),set2(A),Xs)))
       => ~ ! [Y2: B] : ~ pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y2),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys)))) ) ) ).

% in_set_impl_in_set_zip1
tff(fact_4893_zip__eq__ConsE,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),Xy: product_prod(A,B),Xys: list(product_prod(A,B))] :
      ( ( zip(A,B,Xs,Ys) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),Xy),Xys) )
     => ~ ! [X2: A,Xs5: list(A)] :
            ( ( Xs = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs5) )
           => ! [Y2: B,Ys4: list(B)] :
                ( ( Ys = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys4) )
               => ( ( Xy = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X2),Y2) )
                 => ( Xys != zip(A,B,Xs5,Ys4) ) ) ) ) ) ).

% zip_eq_ConsE
tff(fact_4894_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] : ( shuffles(A,Xs,nil(A)) = aa(set(list(A)),set(list(A)),insert2(list(A),Xs),bot_bot(set(list(A)))) ) ).

% shuffles.simps(2)
tff(fact_4895_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list(A)] : ( shuffles(A,nil(A),Ys) = aa(set(list(A)),set(list(A)),insert2(list(A),Ys),bot_bot(set(list(A)))) ) ).

% shuffles.simps(1)
tff(fact_4896_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs2: list(A)] :
      ( distinct(A,Xs)
     => ( distinct(A,Ys)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
         => ( pp(member(list(A),Zs2,shuffles(A,Xs,Ys)))
           => distinct(A,Zs2) ) ) ) ) ).

% distinct_disjoint_shuffles
tff(fact_4897_shuffles_Oelims,axiom,
    ! [A: $tType,X: list(A),Xa: list(A),Y: set(list(A))] :
      ( ( shuffles(A,X,Xa) = Y )
     => ( ( ( X = nil(A) )
         => ( Y != aa(set(list(A)),set(list(A)),insert2(list(A),Xa),bot_bot(set(list(A)))) ) )
       => ( ( ( Xa = nil(A) )
           => ( Y != aa(set(list(A)),set(list(A)),insert2(list(A),X),bot_bot(set(list(A)))) ) )
         => ~ ! [X2: A,Xs3: list(A)] :
                ( ( X = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
               => ! [Y2: A,Ys2: list(A)] :
                    ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2) )
                   => ( Y != aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image2(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2)),shuffles(A,Xs3,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2)))),aa(set(list(A)),set(list(A)),image2(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2)),shuffles(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3),Ys2))) ) ) ) ) ) ) ).

% shuffles.elims
tff(fact_4898_set__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] : ( aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),zip(A,B,Xs,Ys)) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(list(B),fun(product_prod(A,B),bool),aTP_Lamp_so(list(A),fun(list(B),fun(product_prod(A,B),bool)),Xs),Ys)) ) ).

% set_zip
tff(fact_4899_inv__image__partition,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool),Ys: list(A)] :
      ( ! [X2: A] :
          ( pp(member(A,X2,aa(list(A),set(A),set2(A),Xs)))
         => pp(aa(A,bool,P,X2)) )
     => ( ! [Y2: A] :
            ( pp(member(A,Y2,aa(list(A),set(A),set2(A),Ys)))
           => ~ pp(aa(A,bool,P,Y2)) )
       => ( aa(set(product_prod(list(A),list(A))),set(list(A)),aa(fun(list(A),product_prod(list(A),list(A))),fun(set(product_prod(list(A),list(A))),set(list(A))),vimage(list(A),product_prod(list(A),list(A))),partition(A,P)),aa(set(product_prod(list(A),list(A))),set(product_prod(list(A),list(A))),insert2(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys)),bot_bot(set(product_prod(list(A),list(A)))))) = shuffles(A,Xs,Ys) ) ) ) ).

% inv_image_partition
tff(fact_4900_mset__zip__take__Cons__drop__twice,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B),J2: nat,X: A,Y: B] :
      ( ( size_size(list(A),Xs) = size_size(list(B),Ys) )
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),J2),size_size(list(A),Xs)))
       => ( aa(list(product_prod(A,B)),multiset(product_prod(A,B)),mset(product_prod(A,B)),zip(A,B,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),take(A,J2,Xs)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),drop(A,J2,Xs))),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),take(B,J2,Ys)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),drop(B,J2,Ys))))) = aa(multiset(product_prod(A,B)),multiset(product_prod(A,B)),aa(product_prod(A,B),fun(multiset(product_prod(A,B)),multiset(product_prod(A,B))),add_mset(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)),aa(list(product_prod(A,B)),multiset(product_prod(A,B)),mset(product_prod(A,B)),zip(A,B,Xs,Ys))) ) ) ) ).

% mset_zip_take_Cons_drop_twice
tff(fact_4901_lists__empty,axiom,
    ! [A: $tType] : ( lists(A,bot_bot(set(A))) = aa(set(list(A)),set(list(A)),insert2(list(A),nil(A)),bot_bot(set(list(A)))) ) ).

% lists_empty
tff(fact_4902_lists__Int__eq,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( lists(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) = aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),inf_inf(set(list(A))),lists(A,A4)),lists(A,B3)) ) ).

% lists_Int_eq
tff(fact_4903_lists__IntI,axiom,
    ! [A: $tType,L: list(A),A4: set(A),B3: set(A)] :
      ( pp(member(list(A),L,lists(A,A4)))
     => ( pp(member(list(A),L,lists(A,B3)))
       => pp(member(list(A),L,lists(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)))) ) ) ).

% lists_IntI
tff(fact_4904_lists__of__len__fin1,axiom,
    ! [A: $tType,P: set(A),N: nat] :
      ( pp(aa(set(A),bool,finite_finite(A),P))
     => pp(aa(set(list(A)),bool,finite_finite(list(A)),aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),inf_inf(set(list(A))),lists(A,P)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aTP_Lamp_sp(nat,fun(list(A),bool),N))))) ) ).

% lists_of_len_fin1
tff(fact_4905_lists__of__len__fin2,axiom,
    ! [A: $tType,P: set(A),N: nat] :
      ( pp(aa(set(A),bool,finite_finite(A),P))
     => pp(aa(set(list(A)),bool,finite_finite(list(A)),aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),inf_inf(set(list(A))),lists(A,P)),aa(fun(list(A),bool),set(list(A)),collect(list(A)),aTP_Lamp_sq(nat,fun(list(A),bool),N))))) ) ).

% lists_of_len_fin2
tff(fact_4906_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( aa(list(A),product_prod(list(A),list(A)),partition(A,P),nil(A)) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)) ) ).

% partition.simps(1)
tff(fact_4907_partition__P,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Yes2: list(A),No2: list(A)] :
      ( ( aa(list(A),product_prod(list(A),list(A)),partition(A,P),Xs) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes2),No2) )
     => ( ! [X3: A] :
            ( pp(member(A,X3,aa(list(A),set(A),set2(A),Yes2)))
           => pp(aa(A,bool,P,X3)) )
        & ! [X3: A] :
            ( pp(member(A,X3,aa(list(A),set(A),set2(A),No2)))
           => ~ pp(aa(A,bool,P,X3)) ) ) ) ).

% partition_P
tff(fact_4908_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,bool),X: A,Xs: list(A)] : ( aa(list(A),product_prod(list(A),list(A)),partition(A,P),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)) = aa(product_prod(list(A),list(A)),product_prod(list(A),list(A)),aa(fun(list(A),fun(list(A),product_prod(list(A),list(A)))),fun(product_prod(list(A),list(A)),product_prod(list(A),list(A))),product_case_prod(list(A),list(A),product_prod(list(A),list(A))),aa(A,fun(list(A),fun(list(A),product_prod(list(A),list(A)))),aTP_Lamp_sr(fun(A,bool),fun(A,fun(list(A),fun(list(A),product_prod(list(A),list(A))))),P),X)),aa(list(A),product_prod(list(A),list(A)),partition(A,P),Xs)) ) ).

% partition.simps(2)
tff(fact_4909_partition__set,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A),Yes2: list(A),No2: list(A)] :
      ( ( aa(list(A),product_prod(list(A),list(A)),partition(A,P),Xs) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes2),No2) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Yes2)),aa(list(A),set(A),set2(A),No2)) = aa(list(A),set(A),set2(A),Xs) ) ) ).

% partition_set
tff(fact_4910_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list(A),I: nat,J2: nat] :
      ( distinct(A,Vs)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),I),J2))
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),take(A,I,Vs))),aa(list(A),set(A),set2(A),drop(A,J2,Vs))) = bot_bot(set(A)) ) ) ) ).

% set_take_disj_set_drop_if_distinct
tff(fact_4911_INF__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(B,A),Xs: list(B)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image2(B,A,F),aa(list(B),set(B),set2(B),Xs))) = aa(A,A,fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),aa(fun(A,fun(A,A)),fun(fun(B,A),fun(B,fun(A,A))),comp(A,fun(A,A),B),inf_inf(A)),F),Xs),top_top(A)) ) ) ).

% INF_set_fold
tff(fact_4912_SUP__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(B,A),Xs: list(B)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image2(B,A,F),aa(list(B),set(B),set2(B),Xs))) = aa(A,A,fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),aa(fun(A,fun(A,A)),fun(fun(B,A),fun(B,fun(A,A))),comp(A,fun(A,A),B),sup_sup(A)),F),Xs),bot_bot(A)) ) ) ).

% SUP_set_fold
tff(fact_4913_shuffles_Opelims,axiom,
    ! [A: $tType,X: list(A),Xa: list(A),Y: set(list(A))] :
      ( ( shuffles(A,X,Xa) = Y )
     => ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Xa)))
       => ( ( ( X = nil(A) )
           => ( ( Y = aa(set(list(A)),set(list(A)),insert2(list(A),Xa),bot_bot(set(list(A)))) )
             => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Xa))) ) )
         => ( ( ( Xa = nil(A) )
             => ( ( Y = aa(set(list(A)),set(list(A)),insert2(list(A),X),bot_bot(set(list(A)))) )
               => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),nil(A)))) ) )
           => ~ ! [X2: A,Xs3: list(A)] :
                  ( ( X = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
                 => ! [Y2: A,Ys2: list(A)] :
                      ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2) )
                     => ( ( Y = aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image2(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2)),shuffles(A,Xs3,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2)))),aa(set(list(A)),set(list(A)),image2(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2)),shuffles(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3),Ys2))) )
                       => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2)))) ) ) ) ) ) ) ) ).

% shuffles.pelims
tff(fact_4914_fold__append,axiom,
    ! [A: $tType,B: $tType,F: fun(B,fun(A,A)),Xs: list(B),Ys: list(B)] : ( fold(B,A,F,aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)) = aa(fun(A,A),fun(A,A),aa(fun(A,A),fun(fun(A,A),fun(A,A)),comp(A,A,A),fold(B,A,F,Ys)),fold(B,A,F,Xs)) ) ).

% fold_append
tff(fact_4915_shuffles_Opinduct,axiom,
    ! [A: $tType,A0: list(A),A1: list(A),P: fun(list(A),fun(list(A),bool))] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),A0),A1)))
     => ( ! [Ys2: list(A)] :
            ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys2)))
           => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,nil(A)),Ys2)) )
       => ( ! [Xs3: list(A)] :
              ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs3),nil(A))))
             => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,Xs3),nil(A))) )
         => ( ! [X2: A,Xs3: list(A),Y2: A,Ys2: list(A)] :
                ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2))))
               => ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,Xs3),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2)))
                 => ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),Ys2))
                   => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Ys2))) ) ) )
           => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,A0),A1)) ) ) ) ) ).

% shuffles.pinduct
tff(fact_4916_fold__Cons,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B)),X: A,Xs: list(A)] : ( fold(A,B,F,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),fold(A,B,F,Xs)),aa(A,fun(B,B),F,X)) ) ).

% fold_Cons
tff(fact_4917_fold__commute,axiom,
    ! [A: $tType,C: $tType,B: $tType,Xs: list(A),H2: fun(B,C),G: fun(A,fun(B,B)),F: fun(A,fun(C,C))] :
      ( ! [X2: A] :
          ( pp(member(A,X2,aa(list(A),set(A),set2(A),Xs)))
         => ( aa(fun(B,B),fun(B,C),aa(fun(B,C),fun(fun(B,B),fun(B,C)),comp(B,C,B),H2),aa(A,fun(B,B),G,X2)) = aa(fun(B,C),fun(B,C),aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),aa(A,fun(C,C),F,X2)),H2) ) )
     => ( aa(fun(B,B),fun(B,C),aa(fun(B,C),fun(fun(B,B),fun(B,C)),comp(B,C,B),H2),fold(A,B,G,Xs)) = aa(fun(B,C),fun(B,C),aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),fold(A,C,F,Xs)),H2) ) ) ).

% fold_commute
tff(fact_4918_fold__commute__apply,axiom,
    ! [A: $tType,C: $tType,B: $tType,Xs: list(A),H2: fun(B,C),G: fun(A,fun(B,B)),F: fun(A,fun(C,C)),S: B] :
      ( ! [X2: A] :
          ( pp(member(A,X2,aa(list(A),set(A),set2(A),Xs)))
         => ( aa(fun(B,B),fun(B,C),aa(fun(B,C),fun(fun(B,B),fun(B,C)),comp(B,C,B),H2),aa(A,fun(B,B),G,X2)) = aa(fun(B,C),fun(B,C),aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),aa(A,fun(C,C),F,X2)),H2) ) )
     => ( aa(B,C,H2,aa(B,B,fold(A,B,G,Xs),S)) = aa(C,C,fold(A,C,F,Xs),aa(B,C,H2,S)) ) ) ).

% fold_commute_apply
tff(fact_4919_fold__multiset__equiv,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),F: fun(A,fun(B,B)),Ys: list(A)] :
      ( ! [X2: A,Y2: A] :
          ( pp(member(A,X2,aa(list(A),set(A),set2(A),Xs)))
         => ( pp(member(A,Y2,aa(list(A),set(A),set2(A),Xs)))
           => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,Y2)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y2)),aa(A,fun(B,B),F,X2)) ) ) )
     => ( ( aa(list(A),multiset(A),mset(A),Xs) = aa(list(A),multiset(A),mset(A),Ys) )
       => ( fold(A,B,F,Xs) = fold(A,B,F,Ys) ) ) ) ).

% fold_multiset_equiv
tff(fact_4920_fold__remove1__split,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),F: fun(A,fun(B,B)),X: A] :
      ( ! [X2: A,Y2: A] :
          ( pp(member(A,X2,aa(list(A),set(A),set2(A),Xs)))
         => ( pp(member(A,Y2,aa(list(A),set(A),set2(A),Xs)))
           => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,Y2)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y2)),aa(A,fun(B,B),F,X2)) ) ) )
     => ( pp(member(A,X,aa(list(A),set(A),set2(A),Xs)))
       => ( fold(A,B,F,Xs) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),fold(A,B,F,remove1(A,X,Xs))),aa(A,fun(B,B),F,X)) ) ) ) ).

% fold_remove1_split
tff(fact_4921_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys)))
     => ( shuffles(A,nil(A),Ys) = aa(set(list(A)),set(list(A)),insert2(list(A),Ys),bot_bot(set(list(A)))) ) ) ).

% shuffles.psimps(1)
tff(fact_4922_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),nil(A))))
     => ( shuffles(A,Xs,nil(A)) = aa(set(list(A)),set(list(A)),insert2(list(A),Xs),bot_bot(set(list(A)))) ) ) ).

% shuffles.psimps(2)
tff(fact_4923_shuffles_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list(A),Y: A,Ys: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),shuffles_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Ys))))
     => ( shuffles(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Ys)) = aa(set(list(A)),set(list(A)),aa(set(list(A)),fun(set(list(A)),set(list(A))),sup_sup(set(list(A))),aa(set(list(A)),set(list(A)),image2(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X)),shuffles(A,Xs,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y),Ys)))),aa(set(list(A)),set(list(A)),image2(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y)),shuffles(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs),Ys))) ) ) ).

% shuffles.psimps(3)
tff(fact_4924_Sup__set__fold,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Xs: list(A)] : ( aa(set(A),A,complete_Sup_Sup(A),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,sup_sup(A),Xs),bot_bot(A)) ) ) ).

% Sup_set_fold
tff(fact_4925_Inf__set__fold,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Xs: list(A)] : ( aa(set(A),A,complete_Inf_Inf(A),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,inf_inf(A),Xs),top_top(A)) ) ) ).

% Inf_set_fold
tff(fact_4926_Inf__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [X: A,Xs: list(A)] : ( aa(set(A),A,lattic7752659483105999362nf_fin(A),aa(list(A),set(A),set2(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs))) = aa(A,A,fold(A,A,inf_inf(A),Xs),X) ) ) ).

% Inf_fin.set_eq_fold
tff(fact_4927_Sup__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [X: A,Xs: list(A)] : ( aa(set(A),A,lattic5882676163264333800up_fin(A),aa(list(A),set(A),set2(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs))) = aa(A,A,fold(A,A,sup_sup(A),Xs),X) ) ) ).

% Sup_fin.set_eq_fold
tff(fact_4928_splice_Opinduct,axiom,
    ! [A: $tType,A0: list(A),A1: list(A),P: fun(list(A),fun(list(A),bool))] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),A0),A1)))
     => ( ! [Ys2: list(A)] :
            ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys2)))
           => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,nil(A)),Ys2)) )
       => ( ! [X2: A,Xs3: list(A),Ys2: list(A)] :
              ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),Ys2)))
             => ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,Ys2),Xs3))
               => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),Ys2)) ) )
         => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),P,A0),A1)) ) ) ) ).

% splice.pinduct
tff(fact_4929_subset__eq__mset__impl_Opelims,axiom,
    ! [A: $tType,X: list(A),Xa: list(A),Y: option(bool)] :
      ( ( subset_eq_mset_impl(A,X,Xa) = Y )
     => ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),subset751672762298770561pl_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Xa)))
       => ( ( ( X = nil(A) )
           => ( ( Y = aa(bool,option(bool),some(bool),aa(bool,bool,fNot,aa(list(A),bool,aa(list(A),fun(list(A),bool),fequal(list(A)),Xa),nil(A)))) )
             => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),subset751672762298770561pl_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Xa))) ) )
         => ~ ! [X2: A,Xs3: list(A)] :
                ( ( X = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
               => ( ( Y = case_option(option(bool),product_prod(list(A),product_prod(A,list(A))),none(bool),aa(fun(list(A),fun(product_prod(A,list(A)),option(bool))),fun(product_prod(list(A),product_prod(A,list(A))),option(bool)),product_case_prod(list(A),product_prod(A,list(A)),option(bool)),aTP_Lamp_st(list(A),fun(list(A),fun(product_prod(A,list(A)),option(bool))),Xs3)),extract(A,aa(A,fun(A,bool),fequal(A),X2),Xa)) )
                 => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),subset751672762298770561pl_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),Xa))) ) ) ) ) ) ).

% subset_eq_mset_impl.pelims
tff(fact_4930_zipf__zip,axiom,
    ! [A: $tType,B: $tType,L1: list(A),L2: list(B)] :
      ( ( size_size(list(A),L1) = size_size(list(B),L2) )
     => ( zipf(A,B,product_prod(A,B),product_Pair(A,B),L1,L2) = zip(A,B,L1,L2) ) ) ).

% zipf_zip
tff(fact_4931_zipf_Opelims,axiom,
    ! [C: $tType,A: $tType,B: $tType,X: fun(A,fun(B,C)),Xa: list(A),Xb: list(B),Y: list(C)] :
      ( ( zipf(A,B,C,X,Xa,Xb) = Y )
     => ( pp(aa(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),zipf_rel(A,B,C)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),aa(fun(A,fun(B,C)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,C)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xa),Xb))))
       => ( ( ( Xa = nil(A) )
           => ( ( Xb = nil(B) )
             => ( ( Y = nil(C) )
               => ~ pp(aa(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),zipf_rel(A,B,C)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),aa(fun(A,fun(B,C)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,C)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),nil(B))))) ) ) )
         => ( ! [A8: A,As2: list(A)] :
                ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2) )
               => ! [B5: B,Bs2: list(B)] :
                    ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),Bs2) )
                   => ( ( Y = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),aa(B,C,aa(A,fun(B,C),X,A8),B5)),zipf(A,B,C,X,As2,Bs2)) )
                     => ~ pp(aa(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),zipf_rel(A,B,C)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),aa(fun(A,fun(B,C)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,C)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),Bs2))))) ) ) )
           => ( ! [V3: A,Va: list(A)] :
                  ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va) )
                 => ( ( Xb = nil(B) )
                   => ( ( Y = undefined(list(C)) )
                     => ~ pp(aa(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),zipf_rel(A,B,C)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),aa(fun(A,fun(B,C)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,C)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va)),nil(B))))) ) ) )
             => ~ ( ( Xa = nil(A) )
                 => ! [V3: B,Va: list(B)] :
                      ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va) )
                     => ( ( Y = undefined(list(C)) )
                       => ~ pp(aa(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),zipf_rel(A,B,C)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),aa(fun(A,fun(B,C)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,C)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va))))) ) ) ) ) ) ) ) ) ).

% zipf.pelims
tff(fact_4932_splice_Opelims,axiom,
    ! [A: $tType,X: list(A),Xa: list(A),Y: list(A)] :
      ( ( splice(A,X,Xa) = Y )
     => ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Xa)))
       => ( ( ( X = nil(A) )
           => ( ( Y = Xa )
             => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Xa))) ) )
         => ~ ! [X2: A,Xs3: list(A)] :
                ( ( X = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
               => ( ( Y = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),splice(A,Xa,Xs3)) )
                 => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)),Xa))) ) ) ) ) ) ).

% splice.pelims
tff(fact_4933_splice_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Ys)))
     => ( splice(A,nil(A),Ys) = Ys ) ) ).

% splice.psimps(1)
tff(fact_4934_splice_Opsimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list(A),Ys: list(A)] :
      ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),splice_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)),Ys)))
     => ( splice(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs),Ys) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),splice(A,Ys,Xs)) ) ) ).

% splice.psimps(2)
tff(fact_4935_set__rec,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),set(A),set2(A),Xs) = aa(list(A),set(A),rec_list(set(A),A,bot_bot(set(A)),aTP_Lamp_su(A,fun(list(A),fun(set(A),set(A))))),Xs) ) ).

% set_rec
tff(fact_4936_map__tailrec__rev_Opelims,axiom,
    ! [A: $tType,B: $tType,X: fun(A,B),Xa: list(A),Xb: list(B),Y: list(B)] :
      ( ( map_tailrec_rev(A,B,X,Xa,Xb) = Y )
     => ( pp(aa(product_prod(fun(A,B),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,B),product_prod(list(A),list(B))),map_tailrec_rev_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B))),aa(fun(A,B),fun(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B)))),product_Pair(fun(A,B),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xa),Xb))))
       => ( ( ( Xa = nil(A) )
           => ( ( Y = Xb )
             => ~ pp(aa(product_prod(fun(A,B),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,B),product_prod(list(A),list(B))),map_tailrec_rev_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B))),aa(fun(A,B),fun(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B)))),product_Pair(fun(A,B),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),Xb)))) ) )
         => ~ ! [A8: A,As2: list(A)] :
                ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2) )
               => ( ( Y = map_tailrec_rev(A,B,X,As2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),aa(A,B,X,A8)),Xb)) )
                 => ~ pp(aa(product_prod(fun(A,B),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,B),product_prod(list(A),list(B))),map_tailrec_rev_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B))),aa(fun(A,B),fun(product_prod(list(A),list(B)),product_prod(fun(A,B),product_prod(list(A),list(B)))),product_Pair(fun(A,B),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2)),Xb)))) ) ) ) ) ) ).

% map_tailrec_rev.pelims
tff(fact_4937_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),Ys: list(B),Zs2: list(C)] : ( zip(A,product_prod(B,C),Xs,zip(B,C,Ys,Zs2)) = aa(list(product_prod(B,product_prod(A,C))),list(product_prod(A,product_prod(B,C))),map(product_prod(B,product_prod(A,C)),product_prod(A,product_prod(B,C)),aa(fun(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C)))),fun(product_prod(B,product_prod(A,C)),product_prod(A,product_prod(B,C))),product_case_prod(B,product_prod(A,C),product_prod(A,product_prod(B,C))),aTP_Lamp_sw(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C)))))),zip(B,product_prod(A,C),Ys,zip(A,C,Xs,Zs2))) ) ).

% zip_left_commute
tff(fact_4938_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(B,A),G: fun(C,B),Xs: list(C)] : ( aa(list(B),list(A),map(B,A,F),aa(list(C),list(B),map(C,B,G),Xs)) = aa(list(C),list(A),map(C,A,aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),F),G)),Xs) ) ).

% map_map
tff(fact_4939_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(B,C),G: fun(A,B),List: list(A)] : ( aa(list(B),list(C),map(B,C,F),aa(list(A),list(B),map(A,B,G),List)) = aa(list(A),list(C),map(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),G)),List) ) ).

% List.map.compositionality
tff(fact_4940_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: fun(B,C),F: fun(A,B),V: list(A)] : ( aa(list(B),list(C),map(B,C,G),aa(list(A),list(B),map(A,B,F),V)) = aa(list(A),list(C),map(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),G),F)),V) ) ).

% list.map_comp
tff(fact_4941_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(C,B),G: fun(A,C)] : ( aa(fun(list(A),list(C)),fun(list(A),list(B)),aa(fun(list(C),list(B)),fun(fun(list(A),list(C)),fun(list(A),list(B))),comp(list(C),list(B),list(A)),map(C,B,F)),map(A,C,G)) = map(A,B,aa(fun(A,C),fun(A,B),aa(fun(C,B),fun(fun(A,C),fun(A,B)),comp(C,B,A),F),G)) ) ).

% map_comp_map
tff(fact_4942_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(B,C),G: fun(A,B)] : ( aa(fun(list(A),list(B)),fun(list(A),list(C)),aa(fun(list(B),list(C)),fun(fun(list(A),list(B)),fun(list(A),list(C))),comp(list(B),list(C),list(A)),map(B,C,F)),map(A,B,G)) = map(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),G)) ) ).

% List.map.comp
tff(fact_4943_map__fst__mk__snd,axiom,
    ! [B: $tType,A: $tType,K: B,L: list(A)] : ( aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_ex(B,fun(A,product_prod(A,B))),K)),L)) = L ) ).

% map_fst_mk_snd
tff(fact_4944_map__snd__mk__fst,axiom,
    ! [B: $tType,A: $tType,K: B,L: list(A)] : ( aa(list(product_prod(B,A)),list(A),map(product_prod(B,A),A,product_snd(B,A)),aa(list(A),list(product_prod(B,A)),map(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),K)),L)) = L ) ).

% map_snd_mk_fst
tff(fact_4945_map__fst__mk__fst,axiom,
    ! [B: $tType,A: $tType,K: A,L: list(B)] : ( aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K)),L)) = replicate(A,size_size(list(B),L),K) ) ).

% map_fst_mk_fst
tff(fact_4946_map__snd__mk__snd,axiom,
    ! [B: $tType,A: $tType,K: A,L: list(B)] : ( aa(list(product_prod(B,A)),list(A),map(product_prod(B,A),A,product_snd(B,A)),aa(list(B),list(product_prod(B,A)),map(B,product_prod(B,A),aa(A,fun(B,product_prod(B,A)),aTP_Lamp_es(A,fun(B,product_prod(B,A))),K)),L)) = replicate(A,size_size(list(B),L),K) ) ).

% map_snd_mk_snd
tff(fact_4947_list_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: C,Ga: fun(B,fun(list(B),fun(C,C))),F: fun(A,B)] : ( aa(fun(list(A),list(B)),fun(list(A),C),aa(fun(list(B),C),fun(fun(list(A),list(B)),fun(list(A),C)),comp(list(B),C,list(A)),rec_list(C,B,G,Ga)),map(A,B,F)) = rec_list(C,A,G,aa(fun(A,B),fun(A,fun(list(A),fun(C,C))),aTP_Lamp_sx(fun(B,fun(list(B),fun(C,C))),fun(fun(A,B),fun(A,fun(list(A),fun(C,C)))),Ga),F)) ) ).

% list.rec_o_map
tff(fact_4948_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: fun(C,A),Xs: list(C),Ys: list(B)] : ( zip(A,B,aa(list(C),list(A),map(C,A,F),Xs),Ys) = aa(list(product_prod(C,B)),list(product_prod(A,B)),map(product_prod(C,B),product_prod(A,B),aa(fun(C,fun(B,product_prod(A,B))),fun(product_prod(C,B),product_prod(A,B)),product_case_prod(C,B,product_prod(A,B)),aTP_Lamp_sy(fun(C,A),fun(C,fun(B,product_prod(A,B))),F))),zip(C,B,Xs,Ys)) ) ).

% zip_map1
tff(fact_4949_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),F: fun(C,B),Ys: list(C)] : ( zip(A,B,Xs,aa(list(C),list(B),map(C,B,F),Ys)) = aa(list(product_prod(A,C)),list(product_prod(A,B)),map(product_prod(A,C),product_prod(A,B),aa(fun(A,fun(C,product_prod(A,B))),fun(product_prod(A,C),product_prod(A,B)),product_case_prod(A,C,product_prod(A,B)),aTP_Lamp_sz(fun(C,B),fun(A,fun(C,product_prod(A,B))),F))),zip(A,C,Xs,Ys)) ) ).

% zip_map2
tff(fact_4950_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: fun(product_prod(B,C),A),G: fun(D,B),Xs: list(D),Ys: list(C)] : ( aa(list(product_prod(B,C)),list(A),map(product_prod(B,C),A,F),zip(B,C,aa(list(D),list(B),map(D,B,G),Xs),Ys)) = aa(list(product_prod(D,C)),list(A),map(product_prod(D,C),A,aa(fun(D,fun(C,A)),fun(product_prod(D,C),A),product_case_prod(D,C,A),aa(fun(D,B),fun(D,fun(C,A)),aTP_Lamp_ta(fun(product_prod(B,C),A),fun(fun(D,B),fun(D,fun(C,A))),F),G))),zip(D,C,Xs,Ys)) ) ).

% map_zip_map
tff(fact_4951_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: fun(product_prod(B,C),A),Xs: list(B),G: fun(D,C),Ys: list(D)] : ( aa(list(product_prod(B,C)),list(A),map(product_prod(B,C),A,F),zip(B,C,Xs,aa(list(D),list(C),map(D,C,G),Ys))) = aa(list(product_prod(B,D)),list(A),map(product_prod(B,D),A,aa(fun(B,fun(D,A)),fun(product_prod(B,D),A),product_case_prod(B,D,A),aa(fun(D,C),fun(B,fun(D,A)),aTP_Lamp_tb(fun(product_prod(B,C),A),fun(fun(D,C),fun(B,fun(D,A))),F),G))),zip(B,D,Xs,Ys)) ) ).

% map_zip_map2
tff(fact_4952_map__prod__fun__zip,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: fun(C,A),G: fun(D,B),Xs: list(C),Ys: list(D)] : ( aa(list(product_prod(C,D)),list(product_prod(A,B)),map(product_prod(C,D),product_prod(A,B),aa(fun(C,fun(D,product_prod(A,B))),fun(product_prod(C,D),product_prod(A,B)),product_case_prod(C,D,product_prod(A,B)),aa(fun(D,B),fun(C,fun(D,product_prod(A,B))),aTP_Lamp_is(fun(C,A),fun(fun(D,B),fun(C,fun(D,product_prod(A,B)))),F),G))),zip(C,D,Xs,Ys)) = zip(A,B,aa(list(C),list(A),map(C,A,F),Xs),aa(list(D),list(B),map(D,B,G),Ys)) ) ).

% map_prod_fun_zip
tff(fact_4953_set__oo__map__alt,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),X3: list(A)] : ( aa(list(A),set(B),aa(fun(list(A),list(B)),fun(list(A),set(B)),aa(fun(list(B),set(B)),fun(fun(list(A),list(B)),fun(list(A),set(B))),comp(list(B),set(B),list(A)),set2(B)),map(A,B,F)),X3) = aa(set(A),set(B),image2(A,B,F),aa(list(A),set(A),set2(A),X3)) ) ).

% set_oo_map_alt
tff(fact_4954_fold__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: fun(B,fun(A,A)),F: fun(C,B),Xs: list(C)] : ( fold(B,A,G,aa(list(C),list(B),map(C,B,F),Xs)) = fold(C,A,aa(fun(C,B),fun(C,fun(A,A)),aa(fun(B,fun(A,A)),fun(fun(C,B),fun(C,fun(A,A))),comp(B,fun(A,A),C),G),F),Xs) ) ).

% fold_map
tff(fact_4955_zip__same__conv__map,axiom,
    ! [A: $tType,Xs: list(A)] : ( zip(A,A,Xs,Xs) = aa(list(A),list(product_prod(A,A)),map(A,product_prod(A,A),aTP_Lamp_cg(A,product_prod(A,A))),Xs) ) ).

% zip_same_conv_map
tff(fact_4956_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list(A),Ys: list(B)] : ( product(A,B,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs),Ys) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X)),Ys)),product(A,B,Xs,Ys)) ) ).

% product.simps(2)
tff(fact_4957_zip__commute,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] : ( zip(A,B,Xs,Ys) = aa(list(product_prod(B,A)),list(product_prod(A,B)),map(product_prod(B,A),product_prod(A,B),aa(fun(B,fun(A,product_prod(A,B))),fun(product_prod(B,A),product_prod(A,B)),product_case_prod(B,A,product_prod(A,B)),aTP_Lamp_ex(B,fun(A,product_prod(A,B))))),zip(B,A,Ys,Xs)) ) ).

% zip_commute
tff(fact_4958_distinct__map__fstD,axiom,
    ! [A: $tType,B: $tType,Xs: list(product_prod(A,B)),X: A,Y: B,Z2: B] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))
     => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xs)))
       => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Z2),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xs)))
         => ( Y = Z2 ) ) ) ) ).

% distinct_map_fstD
tff(fact_4959_eq__key__imp__eq__value,axiom,
    ! [A: $tType,B: $tType,Xs: list(product_prod(A,B)),K: A,V1: B,V22: B] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))
     => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V1),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xs)))
       => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),V22),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xs)))
         => ( V1 = V22 ) ) ) ) ).

% eq_key_imp_eq_value
tff(fact_4960_zip__replicate1,axiom,
    ! [A: $tType,B: $tType,N: nat,X: A,Ys: list(B)] : ( zip(A,B,replicate(A,N,X),Ys) = aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X)),take(B,N,Ys)) ) ).

% zip_replicate1
tff(fact_4961_map__zip2,axiom,
    ! [A: $tType,B: $tType,K: A,L: list(B)] : ( aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K)),L) = zip(A,B,replicate(A,size_size(list(B),L),K),L) ) ).

% map_zip2
tff(fact_4962_map__zip1,axiom,
    ! [A: $tType,B: $tType,K: B,L: list(A)] : ( aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_ex(B,fun(A,product_prod(A,B))),K)),L) = zip(A,B,L,replicate(B,size_size(list(A),L),K)) ) ).

% map_zip1
tff(fact_4963_zip__replicate2,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),N: nat,Y: B] : ( zip(A,B,Xs,replicate(B,N,Y)) = aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_ex(B,fun(A,product_prod(A,B))),Y)),take(A,N,Xs)) ) ).

% zip_replicate2
tff(fact_4964_Id__on__set,axiom,
    ! [A: $tType,Xs: list(A)] : ( id_on(A,aa(list(A),set(A),set2(A),Xs)) = aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),aa(list(A),list(product_prod(A,A)),map(A,product_prod(A,A),aTP_Lamp_cg(A,product_prod(A,A))),Xs)) ) ).

% Id_on_set
tff(fact_4965_map__of__eq__Some__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list(product_prod(A,B)),X: A,Y: B] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xys))
     => ( ( aa(A,option(B),map_of(A,B,Xys),X) = aa(B,option(B),some(B),Y) )
      <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xys))) ) ) ).

% map_of_eq_Some_iff
tff(fact_4966_Some__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list(product_prod(A,B)),Y: B,X: A] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xys))
     => ( ( aa(B,option(B),some(B),Y) = aa(A,option(B),map_of(A,B,Xys),X) )
      <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xys))) ) ) ).

% Some_eq_map_of_iff
tff(fact_4967_map__of__is__SomeI,axiom,
    ! [A: $tType,B: $tType,Xys: list(product_prod(A,B)),X: A,Y: B] :
      ( distinct(A,aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xys))
     => ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Xys)))
       => ( aa(A,option(B),map_of(A,B,Xys),X) = aa(B,option(B),some(B),Y) ) ) ) ).

% map_of_is_SomeI
tff(fact_4968_weak__map__of__SomeI,axiom,
    ! [A: $tType,B: $tType,K: A,X: B,L: list(product_prod(A,B))] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),K),X),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),L)))
     => ? [X2: B] : ( aa(A,option(B),map_of(A,B,L),K) = aa(B,option(B),some(B),X2) ) ) ).

% weak_map_of_SomeI
tff(fact_4969_map__of__SomeD,axiom,
    ! [A: $tType,B: $tType,Xs: list(product_prod(B,A)),K: B,Y: A] :
      ( ( aa(B,option(A),map_of(B,A,Xs),K) = aa(A,option(A),some(A),Y) )
     => pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),K),Y),aa(list(product_prod(B,A)),set(product_prod(B,A)),set2(product_prod(B,A)),Xs))) ) ).

% map_of_SomeD
tff(fact_4970_map__of__Cons__code_I2_J,axiom,
    ! [C: $tType,B: $tType,L: B,K: B,V: C,Ps: list(product_prod(B,C))] :
      ( ( ( L = K )
       => ( aa(B,option(C),map_of(B,C,aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),L),V)),Ps)),K) = aa(C,option(C),some(C),V) ) )
      & ( ( L != K )
       => ( aa(B,option(C),map_of(B,C,aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),L),V)),Ps)),K) = aa(B,option(C),map_of(B,C,Ps),K) ) ) ) ).

% map_of_Cons_code(2)
tff(fact_4971_map__of__Some__split,axiom,
    ! [B: $tType,A: $tType,Xs: list(product_prod(B,A)),K: B,V: A] :
      ( ( aa(B,option(A),map_of(B,A,Xs),K) = aa(A,option(A),some(A),V) )
     => ? [Ys2: list(product_prod(B,A)),Zs: list(product_prod(B,A))] :
          ( ( Xs = aa(list(product_prod(B,A)),list(product_prod(B,A)),aa(list(product_prod(B,A)),fun(list(product_prod(B,A)),list(product_prod(B,A))),append(product_prod(B,A)),Ys2),aa(list(product_prod(B,A)),list(product_prod(B,A)),aa(product_prod(B,A),fun(list(product_prod(B,A)),list(product_prod(B,A))),cons(product_prod(B,A)),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),K),V)),Zs)) )
          & ( aa(B,option(A),map_of(B,A,Ys2),K) = none(A) ) ) ) ).

% map_of_Some_split
tff(fact_4972_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list(A),Ys: list(B),Zs2: list(C)] : ( zip(A,product_prod(B,C),Xs,zip(B,C,Ys,Zs2)) = aa(list(product_prod(product_prod(A,B),C)),list(product_prod(A,product_prod(B,C))),map(product_prod(product_prod(A,B),C),product_prod(A,product_prod(B,C)),aa(fun(product_prod(A,B),fun(C,product_prod(A,product_prod(B,C)))),fun(product_prod(product_prod(A,B),C),product_prod(A,product_prod(B,C))),product_case_prod(product_prod(A,B),C,product_prod(A,product_prod(B,C))),aa(fun(A,fun(B,fun(C,product_prod(A,product_prod(B,C))))),fun(product_prod(A,B),fun(C,product_prod(A,product_prod(B,C)))),product_case_prod(A,B,fun(C,product_prod(A,product_prod(B,C)))),aTP_Lamp_tc(A,fun(B,fun(C,product_prod(A,product_prod(B,C)))))))),zip(product_prod(A,B),C,zip(A,B,Xs,Ys),Zs2)) ) ).

% zip_assoc
tff(fact_4973_map__of__map__keys,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),M4: fun(A,option(B))] :
      ( ( aa(list(A),set(A),set2(A),Xs) = dom(A,B,M4) )
     => ( map_of(A,B,aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aTP_Lamp_oe(fun(A,option(B)),fun(A,product_prod(A,B)),M4)),Xs)) = M4 ) ) ).

% map_of_map_keys
tff(fact_4974_map__of__distinct__lookup,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list(product_prod(A,B)),Ys: list(product_prod(A,B)),Y: B] :
      ( ~ pp(member(A,X,aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))))
     => ( ~ pp(member(A,X,aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Ys))))
       => ( aa(A,option(B),map_of(A,B,aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),Xs),aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)),Ys))),X) = aa(B,option(B),some(B),Y) ) ) ) ).

% map_of_distinct_lookup
tff(fact_4975_map__of__mapk__SomeI,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(A,B),T4: list(product_prod(A,C)),K: A,X: C] :
      ( inj_on(A,B,F,top_top(set(A)))
     => ( ( aa(A,option(C),map_of(A,C,T4),K) = aa(C,option(C),some(C),X) )
       => ( aa(B,option(C),map_of(B,C,aa(list(product_prod(A,C)),list(product_prod(B,C)),map(product_prod(A,C),product_prod(B,C),aa(fun(A,fun(C,product_prod(B,C))),fun(product_prod(A,C),product_prod(B,C)),product_case_prod(A,C,product_prod(B,C)),aTP_Lamp_td(fun(A,B),fun(A,fun(C,product_prod(B,C))),F))),T4)),aa(A,B,F,K)) = aa(C,option(C),some(C),X) ) ) ) ).

% map_of_mapk_SomeI
tff(fact_4976_map__of__map__restrict,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),Ks: list(A)] : ( map_of(A,B,aa(list(A),list(product_prod(A,B)),map(A,product_prod(A,B),aTP_Lamp_bp(fun(A,B),fun(A,product_prod(A,B)),F)),Ks)) = restrict_map(A,B,aa(fun(A,B),fun(A,option(B)),aa(fun(B,option(B)),fun(fun(A,B),fun(A,option(B))),comp(B,option(B),A),some(B)),F),aa(list(A),set(A),set2(A),Ks)) ) ).

% map_of_map_restrict
tff(fact_4977_map__of__distinct__upd3,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list(product_prod(A,B)),Ys: list(product_prod(A,B)),Y: B,Y6: B] :
      ( ~ pp(member(A,X,aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))))
     => ( ~ pp(member(A,X,aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Ys))))
       => ( map_of(A,B,aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),Xs),aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)),Ys))) = fun_upd(A,option(B),map_of(A,B,aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),Xs),aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y6)),Ys))),X,aa(B,option(B),some(B),Y)) ) ) ) ).

% map_of_distinct_upd3
tff(fact_4978_map__of__distinct__upd2,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list(product_prod(A,B)),Ys: list(product_prod(A,B)),Y: B] :
      ( ~ pp(member(A,X,aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))))
     => ( ~ pp(member(A,X,aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Ys))))
       => ( map_of(A,B,aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),Xs),aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)),Ys))) = fun_upd(A,option(B),map_of(A,B,aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),Xs),Ys)),X,aa(B,option(B),some(B),Y)) ) ) ) ).

% map_of_distinct_upd2
tff(fact_4979_map__of__distinct__upd4,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list(product_prod(A,B)),Ys: list(product_prod(A,B)),Y: B] :
      ( ~ pp(member(A,X,aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Xs))))
     => ( ~ pp(member(A,X,aa(list(A),set(A),set2(A),aa(list(product_prod(A,B)),list(A),map(product_prod(A,B),A,product_fst(A,B)),Ys))))
       => ( map_of(A,B,aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),Xs),Ys)) = fun_upd(A,option(B),map_of(A,B,aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(list(product_prod(A,B)),fun(list(product_prod(A,B)),list(product_prod(A,B))),append(product_prod(A,B)),Xs),aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y)),Ys))),X,none(B)) ) ) ) ).

% map_of_distinct_upd4
tff(fact_4980_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys: list(product_prod(A,C)),Yzs: list(product_prod(C,B))] : ( relcomp(A,C,B,aa(list(product_prod(A,C)),set(product_prod(A,C)),set2(product_prod(A,C)),Xys),aa(list(product_prod(C,B)),set(product_prod(C,B)),set2(product_prod(C,B)),Yzs)) = aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),concat(product_prod(A,B),aa(list(product_prod(A,C)),list(list(product_prod(A,B))),map(product_prod(A,C),list(product_prod(A,B)),aTP_Lamp_tf(list(product_prod(C,B)),fun(product_prod(A,C),list(product_prod(A,B))),Yzs)),Xys))) ) ).

% set_relcomp
tff(fact_4981_execute__make,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,F: fun(nat,A),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(array(A)),fun(heap_ext(product_unit),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(array(A)),array_make(A,N,F)),H2) = aa(product_prod(array(A),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rw(nat,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),N)),array_alloc(A,aa(list(nat),list(A),map(nat,A,F),upt(zero_zero(nat),N)),H2))) ) ) ).

% execute_make
tff(fact_4982_map__of__Some__filter__not__in,axiom,
    ! [B: $tType,A: $tType,Xs: list(product_prod(B,A)),K: B,V: A,P: fun(product_prod(B,A),bool)] :
      ( ( aa(B,option(A),map_of(B,A,Xs),K) = aa(A,option(A),some(A),V) )
     => ( ~ pp(aa(product_prod(B,A),bool,P,aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),K),V)))
       => ( distinct(B,aa(list(product_prod(B,A)),list(B),map(product_prod(B,A),B,product_fst(B,A)),Xs))
         => ( aa(B,option(A),map_of(B,A,filter2(product_prod(B,A),P,Xs)),K) = none(A) ) ) ) ) ).

% map_of_Some_filter_not_in
tff(fact_4983_partition__filter__conv,axiom,
    ! [A: $tType,F: fun(A,bool),Xs: list(A)] : ( aa(list(A),product_prod(list(A),list(A)),partition(A,F),Xs) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),filter2(A,F,Xs)),filter2(A,aa(fun(A,bool),fun(A,bool),aa(fun(bool,bool),fun(fun(A,bool),fun(A,bool)),comp(bool,bool,A),fNot),F),Xs)) ) ).

% partition_filter_conv
tff(fact_4984_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F: fun(B,A),Xs: list(B)] : ( size_size(list(A),filter2(A,P,aa(list(B),list(A),map(B,A,F),Xs))) = size_size(list(B),filter2(B,aa(fun(B,A),fun(B,bool),aa(fun(A,bool),fun(fun(B,A),fun(B,bool)),comp(A,bool,B),P),F),Xs)) ) ).

% length_filter_map
tff(fact_4985_filter__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F: fun(B,A),Xs: list(B)] : ( filter2(A,P,aa(list(B),list(A),map(B,A,F),Xs)) = aa(list(B),list(A),map(B,A,F),filter2(B,aa(fun(B,A),fun(B,bool),aa(fun(A,bool),fun(fun(B,A),fun(B,bool)),comp(A,bool,B),P),F),Xs)) ) ).

% filter_map
tff(fact_4986_inter__set__filter,axiom,
    ! [A: $tType,A4: set(A),Xs: list(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),aa(list(A),set(A),set2(A),Xs)) = aa(list(A),set(A),set2(A),filter2(A,aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),A4),Xs)) ) ).

% inter_set_filter
tff(fact_4987_partition__filter2,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( aa(product_prod(list(A),list(A)),list(A),product_snd(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),partition(A,P),Xs)) = filter2(A,aa(fun(A,bool),fun(A,bool),aa(fun(bool,bool),fun(fun(A,bool),fun(A,bool)),comp(bool,bool,A),fNot),P),Xs) ) ).

% partition_filter2
tff(fact_4988_enumerate__map__upt,axiom,
    ! [A: $tType,N: nat,F: fun(nat,A),M4: nat] : ( enumerate(A,N,aa(list(nat),list(A),map(nat,A,F),upt(N,M4))) = aa(list(nat),list(product_prod(nat,A)),map(nat,product_prod(nat,A),aTP_Lamp_tg(fun(nat,A),fun(nat,product_prod(nat,A)),F)),upt(N,M4)) ) ).

% enumerate_map_upt
tff(fact_4989_make__rule,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,F: fun(nat,A)] : hoare_hoare_triple(array(A),one_one(assn),array_make(A,N,F),aa(fun(nat,A),fun(array(A),assn),aTP_Lamp_th(nat,fun(fun(nat,A),fun(array(A),assn)),N),F)) ) ).

% make_rule
tff(fact_4990_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list(A),Y: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert2(A,Y),bot_bot(set(A)))) = aa(list(A),set(A),set2(A),filter2(A,aTP_Lamp_ti(A,fun(A,bool),Y),Xs)) ) ).

% set_minus_filter_out
tff(fact_4991_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs2: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( pp(member(list(A),Zs2,shuffles(A,Xs,Ys)))
       => ( filter2(A,aTP_Lamp_tj(list(A),fun(A,bool),Xs),Zs2) = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
tff(fact_4992_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs2: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( pp(member(list(A),Zs2,shuffles(A,Xs,Ys)))
       => ( filter2(A,aTP_Lamp_tk(list(A),fun(A,bool),Xs),Zs2) = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
tff(fact_4993_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs2: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( pp(member(list(A),Zs2,shuffles(A,Xs,Ys)))
       => ( filter2(A,aTP_Lamp_tj(list(A),fun(A,bool),Ys),Zs2) = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
tff(fact_4994_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Zs2: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( pp(member(list(A),Zs2,shuffles(A,Xs,Ys)))
       => ( filter2(A,aTP_Lamp_tk(list(A),fun(A,bool),Ys),Zs2) = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
tff(fact_4995_product__concat__map,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] : ( product(A,B,Xs,Ys) = concat(product_prod(A,B),aa(list(A),list(list(product_prod(A,B))),map(A,list(product_prod(A,B)),aTP_Lamp_tl(list(B),fun(A,list(product_prod(A,B))),Ys)),Xs)) ) ).

% product_concat_map
tff(fact_4996_distinct__concat,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( distinct(list(A),Xs)
     => ( ! [Ys2: list(A)] :
            ( pp(member(list(A),Ys2,aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
           => distinct(A,Ys2) )
       => ( ! [Ys2: list(A),Zs: list(A)] :
              ( pp(member(list(A),Ys2,aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
             => ( pp(member(list(A),Zs,aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
               => ( ( Ys2 != Zs )
                 => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Ys2)),aa(list(A),set(A),set2(A),Zs)) = bot_bot(set(A)) ) ) ) )
         => distinct(A,concat(A,Xs)) ) ) ) ).

% distinct_concat
tff(fact_4997_effect__makeI,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A3: array(A),H4: heap_ext(product_unit),F: fun(nat,A),N: nat,H2: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),product_prod(array(A),heap_ext(product_unit)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),heap_ext(product_unit))),product_Pair(array(A),heap_ext(product_unit)),A3),H4) = array_alloc(A,aa(list(nat),list(A),map(nat,A,F),upt(zero_zero(nat),N)),H2) )
         => heap_Time_effect(array(A),array_make(A,N,F),H2,H4,A3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) ) ).

% effect_makeI
tff(fact_4998_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M4: nat,A3: A] : ( enumerate(A,N,replicate(A,M4,A3)) = aa(list(nat),list(product_prod(nat,A)),map(nat,product_prod(nat,A),aTP_Lamp_tm(A,fun(nat,product_prod(nat,A)),A3)),upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M4))) ) ).

% enumerate_replicate_eq
tff(fact_4999_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,bool)] :
      ( distinct(A,Xs)
     => ( size_size(list(A),filter2(A,P,Xs)) = finite_card(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(fun(A,bool),set(A),collect(A),P)),aa(list(A),set(A),set2(A),Xs))) ) ) ).

% distinct_length_filter
tff(fact_5000_part__def,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F: fun(B,A),Pivot: A,Xs: list(B)] : ( linorder_part(B,A,F,Pivot,Xs) = aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),filter2(B,aa(A,fun(B,bool),aTP_Lamp_tn(fun(B,A),fun(A,fun(B,bool)),F),Pivot),Xs)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),filter2(B,aa(A,fun(B,bool),aTP_Lamp_to(fun(B,A),fun(A,fun(B,bool)),F),Pivot),Xs)),filter2(B,aa(A,fun(B,bool),aTP_Lamp_tp(fun(B,A),fun(A,fun(B,bool)),F),Pivot),Xs))) ) ) ).

% part_def
tff(fact_5001_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( distinct(A,concat(A,Xs))
    <=> ( distinct(list(A),removeAll(list(A),nil(A),Xs))
        & ! [Ys3: list(A)] :
            ( pp(member(list(A),Ys3,aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
           => distinct(A,Ys3) )
        & ! [Ys3: list(A),Zs3: list(A)] :
            ( ( pp(member(list(A),Ys3,aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
              & pp(member(list(A),Zs3,aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
              & ( Ys3 != Zs3 ) )
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Ys3)),aa(list(A),set(A),set2(A),Zs3)) = bot_bot(set(A)) ) ) ) ) ).

% distinct_concat_iff
tff(fact_5002_Array__Time_Omake__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [N: nat,F: fun(nat,A)] : ( array_make(A,N,F) = heap_Time_heap(array(A),aa(fun(nat,A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_tq(nat,fun(fun(nat,A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),N),F)) ) ) ).

% Array_Time.make_def
tff(fact_5003_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Ys: list(B)] : ( product_product(A,B,aa(list(A),set(A),set2(A),Xs),aa(list(B),set(B),set2(B),Ys)) = aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),concat(product_prod(A,B),aa(list(A),list(list(product_prod(A,B))),map(A,list(product_prod(A,B)),aTP_Lamp_tl(list(B),fun(A,list(product_prod(A,B))),Ys)),Xs))) ) ).

% product_code
tff(fact_5004_map__filter__def,axiom,
    ! [B: $tType,A: $tType,F: fun(A,option(B)),Xs: list(A)] : ( map_filter(A,B,F,Xs) = aa(list(A),list(B),map(A,B,aa(fun(A,option(B)),fun(A,B),aa(fun(option(B),B),fun(fun(A,option(B)),fun(A,B)),comp(option(B),B,A),the2(B)),F)),filter2(A,aTP_Lamp_tr(fun(A,option(B)),fun(A,bool),F),Xs)) ) ).

% map_filter_def
tff(fact_5005_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list(A),Ys: list(B)] : ( zip(A,B,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs),Ys) = case_list(list(product_prod(A,B)),B,nil(product_prod(A,B)),aa(list(A),fun(B,fun(list(B),list(product_prod(A,B)))),aTP_Lamp_ts(A,fun(list(A),fun(B,fun(list(B),list(product_prod(A,B))))),X),Xs),Ys) ) ).

% zip_Cons1
tff(fact_5006_distinct__concat_H,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( distinct(list(A),filter2(list(A),aTP_Lamp_tt(list(A),bool),Xs))
     => ( ! [Ys2: list(A)] :
            ( pp(member(list(A),Ys2,aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
           => distinct(A,Ys2) )
       => ( ! [Ys2: list(A),Zs: list(A)] :
              ( pp(member(list(A),Ys2,aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
             => ( pp(member(list(A),Zs,aa(list(list(A)),set(list(A)),set2(list(A)),Xs)))
               => ( ( Ys2 != Zs )
                 => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Ys2)),aa(list(A),set(A),set2(A),Zs)) = bot_bot(set(A)) ) ) ) )
         => distinct(A,concat(A,Xs)) ) ) ) ).

% distinct_concat'
tff(fact_5007_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),Y: B,Ys: list(B)] : ( zip(A,B,Xs,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)) = case_list(list(product_prod(A,B)),A,nil(product_prod(A,B)),aa(list(B),fun(A,fun(list(A),list(product_prod(A,B)))),aTP_Lamp_tu(B,fun(list(B),fun(A,fun(list(A),list(product_prod(A,B))))),Y),Ys),Xs) ) ).

% zip_Cons
tff(fact_5008_in__measures_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,F: fun(A,nat),Fs: list(fun(A,nat))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),measures(A,aa(list(fun(A,nat)),list(fun(A,nat)),aa(fun(A,nat),fun(list(fun(A,nat)),list(fun(A,nat))),cons(fun(A,nat)),F),Fs))))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F,X)),aa(A,nat,F,Y)))
        | ( ( aa(A,nat,F,X) = aa(A,nat,F,Y) )
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),measures(A,Fs))) ) ) ) ).

% in_measures(2)
tff(fact_5009_partition__rev_Opelims,axiom,
    ! [A: $tType,X: fun(A,bool),Xa: product_prod(list(A),list(A)),Xb: list(A),Y: product_prod(list(A),list(A))] :
      ( ( partition_rev(A,X,Xa,Xb) = Y )
     => ( pp(aa(product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),bool,accp(product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),partition_rev_rel(A)),aa(product_prod(product_prod(list(A),list(A)),list(A)),product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),aa(fun(A,bool),fun(product_prod(product_prod(list(A),list(A)),list(A)),product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A)))),product_Pair(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),X),aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),Xa),Xb))))
       => ( ! [Yes: list(A),No: list(A)] :
              ( ( Xa = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No) )
             => ( ( Xb = nil(A) )
               => ( ( Y = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No) )
                 => ~ pp(aa(product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),bool,accp(product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),partition_rev_rel(A)),aa(product_prod(product_prod(list(A),list(A)),list(A)),product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),aa(fun(A,bool),fun(product_prod(product_prod(list(A),list(A)),list(A)),product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A)))),product_Pair(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),X),aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No)),nil(A))))) ) ) )
         => ~ ! [Yes: list(A),No: list(A)] :
                ( ( Xa = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No) )
               => ! [X2: A,Xs3: list(A)] :
                    ( ( Xb = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
                   => ( ( Y = partition_rev(A,X,if(product_prod(list(A),list(A)),aa(A,bool,X,X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Yes)),No),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),No))),Xs3) )
                     => ~ pp(aa(product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),bool,accp(product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),partition_rev_rel(A)),aa(product_prod(product_prod(list(A),list(A)),list(A)),product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),aa(fun(A,bool),fun(product_prod(product_prod(list(A),list(A)),list(A)),product_prod(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A)))),product_Pair(fun(A,bool),product_prod(product_prod(list(A),list(A)),list(A))),X),aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3))))) ) ) ) ) ) ) ).

% partition_rev.pelims
tff(fact_5010_list__collect__set__map__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(B,set(A)),X: fun(C,B)] : ( list_collect_set(B,A,F,aa(list(C),list(B),map(C,B,X),nil(C))) = bot_bot(set(A)) ) ).

% list_collect_set_map_simps(1)
tff(fact_5011_in__measures_I1_J,axiom,
    ! [A: $tType,X: A,Y: A] : ~ pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),measures(A,nil(fun(A,nat))))) ).

% in_measures(1)
tff(fact_5012_list__collect__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F: fun(B,set(A))] : ( list_collect_set(B,A,F,nil(B)) = bot_bot(set(A)) ) ).

% list_collect_set_simps(1)
tff(fact_5013_partition__rev_Osimps_I2_J,axiom,
    ! [A: $tType,P: fun(A,bool),Yes2: list(A),No2: list(A),X: A,Xs: list(A)] : ( partition_rev(A,P,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes2),No2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)) = partition_rev(A,P,if(product_prod(list(A),list(A)),aa(A,bool,P,X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Yes2)),No2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),No2))),Xs) ) ).

% partition_rev.simps(2)
tff(fact_5014_partition__rev_Osimps_I1_J,axiom,
    ! [A: $tType,P: fun(A,bool),Yes2: list(A),No2: list(A)] : ( partition_rev(A,P,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes2),No2),nil(A)) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes2),No2) ) ).

% partition_rev.simps(1)
tff(fact_5015_measures__less,axiom,
    ! [A: $tType,F: fun(A,nat),X: A,Y: A,Fs: list(fun(A,nat))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,F,X)),aa(A,nat,F,Y)))
     => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),measures(A,aa(list(fun(A,nat)),list(fun(A,nat)),aa(fun(A,nat),fun(list(fun(A,nat)),list(fun(A,nat))),cons(fun(A,nat)),F),Fs)))) ) ).

% measures_less
tff(fact_5016_measures__lesseq,axiom,
    ! [A: $tType,F: fun(A,nat),X: A,Y: A,Fs: list(fun(A,nat))] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,F,X)),aa(A,nat,F,Y)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),measures(A,Fs)))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),measures(A,aa(list(fun(A,nat)),list(fun(A,nat)),aa(fun(A,nat),fun(list(fun(A,nat)),list(fun(A,nat))),cons(fun(A,nat)),F),Fs)))) ) ) ).

% measures_lesseq
tff(fact_5017_partition__rev_Oelims,axiom,
    ! [A: $tType,X: fun(A,bool),Xa: product_prod(list(A),list(A)),Xb: list(A),Y: product_prod(list(A),list(A))] :
      ( ( partition_rev(A,X,Xa,Xb) = Y )
     => ( ! [Yes: list(A),No: list(A)] :
            ( ( Xa = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No) )
           => ( ( Xb = nil(A) )
             => ( Y != aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No) ) ) )
       => ~ ! [Yes: list(A),No: list(A)] :
              ( ( Xa = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),No) )
             => ! [X2: A,Xs3: list(A)] :
                  ( ( Xb = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
                 => ( Y != partition_rev(A,X,if(product_prod(list(A),list(A)),aa(A,bool,X,X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Yes)),No),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),No))),Xs3) ) ) ) ) ) ).

% partition_rev.elims
tff(fact_5018_quicksort__by__rel_Osimps_I2_J,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),Sl2: list(A),X: A,Xs: list(A)] : ( quicksort_by_rel(A,R,Sl2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)) = aa(product_prod(list(A),list(A)),list(A),aa(fun(list(A),fun(list(A),list(A))),fun(product_prod(list(A),list(A)),list(A)),product_case_prod(list(A),list(A),list(A)),aa(A,fun(list(A),fun(list(A),list(A))),aa(list(A),fun(A,fun(list(A),fun(list(A),list(A)))),aTP_Lamp_tv(fun(A,fun(A,bool)),fun(list(A),fun(A,fun(list(A),fun(list(A),list(A))))),R),Sl2),X)),partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),R),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs)) ) ).

% quicksort_by_rel.simps(2)
tff(fact_5019_quicksort__by__rel_Oelims,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A),Xb: list(A),Y: list(A)] :
      ( ( quicksort_by_rel(A,X,Xa,Xb) = Y )
     => ( ( ( Xb = nil(A) )
         => ( Y != Xa ) )
       => ~ ! [X2: A,Xs3: list(A)] :
              ( ( Xb = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
             => ( Y != aa(product_prod(list(A),list(A)),list(A),aa(fun(list(A),fun(list(A),list(A))),fun(product_prod(list(A),list(A)),list(A)),product_case_prod(list(A),list(A),list(A)),aa(A,fun(list(A),fun(list(A),list(A))),aa(list(A),fun(A,fun(list(A),fun(list(A),list(A)))),aTP_Lamp_tv(fun(A,fun(A,bool)),fun(list(A),fun(A,fun(list(A),fun(list(A),list(A))))),X),Xa),X2)),partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),X),X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs3)) ) ) ) ) ).

% quicksort_by_rel.elims
tff(fact_5020_quicksort__by__rel_Opelims,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A),Xb: list(A),Y: list(A)] :
      ( ( quicksort_by_rel(A,X,Xa,Xb) = Y )
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xa),Xb))))
       => ( ( ( Xb = nil(A) )
           => ( ( Y = Xa )
             => ~ pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xa),nil(A))))) ) )
         => ~ ! [X2: A,Xs3: list(A)] :
                ( ( Xb = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3) )
               => ( ( Y = aa(product_prod(list(A),list(A)),list(A),aa(fun(list(A),fun(list(A),list(A))),fun(product_prod(list(A),list(A)),list(A)),product_case_prod(list(A),list(A),list(A)),aa(A,fun(list(A),fun(list(A),list(A))),aa(list(A),fun(A,fun(list(A),fun(list(A),list(A)))),aTP_Lamp_tv(fun(A,fun(A,bool)),fun(list(A),fun(A,fun(list(A),fun(list(A),list(A))))),X),Xa),X2)),partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),X),X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs3)) )
                 => ~ pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xa),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3))))) ) ) ) ) ) ).

% quicksort_by_rel.pelims
tff(fact_5021_quicksort__by__rel_Opsimps_I1_J,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),Sl2: list(A)] :
      ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Sl2),nil(A)))))
     => ( quicksort_by_rel(A,R,Sl2,nil(A)) = Sl2 ) ) ).

% quicksort_by_rel.psimps(1)
tff(fact_5022_quicksort__by__rel_Opinduct,axiom,
    ! [A: $tType,A0: fun(A,fun(A,bool)),A1: list(A),A22: list(A),P: fun(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)))] :
      ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),A0),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),A1),A22))))
     => ( ! [R13: fun(A,fun(A,bool)),Sl: list(A)] :
            ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R13),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Sl),nil(A)))))
           => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)),P,R13),Sl),nil(A))) )
       => ( ! [R13: fun(A,fun(A,bool)),Sl: list(A),X2: A,Xs3: list(A)] :
              ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R13),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Sl),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3)))))
             => ( ! [Xa3: product_prod(list(A),list(A)),Xb2: list(A),Y4: list(A)] :
                    ( ( Xa3 = partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),R13),X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs3) )
                   => ( ( aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xb2),Y4) = Xa3 )
                     => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)),P,R13),Sl),Y4)) ) )
               => ( ! [Xa3: product_prod(list(A),list(A)),Xb2: list(A),Y4: list(A)] :
                      ( ( Xa3 = partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),R13),X2),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs3) )
                     => ( ( aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xb2),Y4) = Xa3 )
                       => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)),P,R13),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),quicksort_by_rel(A,R13,Sl,Y4))),Xb2)) ) )
                 => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)),P,R13),Sl),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs3))) ) ) )
         => pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(fun(A,fun(A,bool)),fun(list(A),fun(list(A),bool)),P,A0),A1),A22)) ) ) ) ).

% quicksort_by_rel.pinduct
tff(fact_5023_quicksort__by__rel_Opsimps_I2_J,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool)),Sl2: list(A),X: A,Xs: list(A)] :
      ( pp(aa(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),bool,accp(product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),quicksort_by_rel_rel(A)),aa(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A))),aa(fun(A,fun(A,bool)),fun(product_prod(list(A),list(A)),product_prod(fun(A,fun(A,bool)),product_prod(list(A),list(A)))),product_Pair(fun(A,fun(A,bool)),product_prod(list(A),list(A))),R),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Sl2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)))))
     => ( quicksort_by_rel(A,R,Sl2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)) = aa(product_prod(list(A),list(A)),list(A),aa(fun(list(A),fun(list(A),list(A))),fun(product_prod(list(A),list(A)),list(A)),product_case_prod(list(A),list(A),list(A)),aa(A,fun(list(A),fun(list(A),list(A))),aa(list(A),fun(A,fun(list(A),fun(list(A),list(A)))),aTP_Lamp_tv(fun(A,fun(A,bool)),fun(list(A),fun(A,fun(list(A),fun(list(A),list(A))))),R),Sl2),X)),partition_rev(A,aa(A,fun(A,bool),aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),R),X),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),nil(A)),Xs)) ) ) ).

% quicksort_by_rel.psimps(2)
tff(fact_5024_horner__sum__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F: fun(B,A),A3: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F),A3),Xs) = aa(A,A,foldr(B,A,aa(A,fun(B,fun(A,A)),aTP_Lamp_tx(fun(B,A),fun(A,fun(B,fun(A,A))),F),A3),Xs),zero_zero(A)) ) ) ).

% horner_sum_foldr
tff(fact_5025_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( comm_semiring_0(B)
        & comm_semiring_0(A) )
     => ! [A4: fun(A,fun(B,bool)),B3: fun(C,fun(D,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),A4,zero_zero(A)),zero_zero(B)))
         => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A4,bNF_rel_fun(A,B,A,B,A4,A4)),plus_plus(A)),plus_plus(B)))
           => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A4,bNF_rel_fun(A,B,A,B,A4,A4)),times_times(A)),times_times(B)))
             => pp(aa(fun(fun(D,B),fun(B,fun(list(D),B))),bool,aa(fun(fun(C,A),fun(A,fun(list(C),A))),fun(fun(fun(D,B),fun(B,fun(list(D),B))),bool),bNF_rel_fun(fun(C,A),fun(D,B),fun(A,fun(list(C),A)),fun(B,fun(list(D),B)),bNF_rel_fun(C,D,A,B,B3,A4),bNF_rel_fun(A,B,fun(list(C),A),fun(list(D),B),A4,bNF_rel_fun(list(C),list(D),A,B,list_all2(C,D,B3),A4))),groups4207007520872428315er_sum(C,A)),groups4207007520872428315er_sum(D,B))) ) ) ) ) ).

% horner_sum_transfer
tff(fact_5026_partition__rev__filter__conv,axiom,
    ! [A: $tType,P: fun(A,bool),Yes2: list(A),No2: list(A),Xs: list(A)] : ( partition_rev(A,P,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Yes2),No2),Xs) = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),rev(A,filter2(A,P,Xs))),Yes2)),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),rev(A,filter2(A,aa(fun(A,bool),fun(A,bool),aa(fun(bool,bool),fun(fun(A,bool),fun(A,bool)),comp(bool,bool,A),fNot),P),Xs))),No2)) ) ).

% partition_rev_filter_conv
tff(fact_5027_foldr_Ofoldr__Cons,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B)),X: A,Xs: list(A)] : ( foldr(A,B,F,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X)),foldr(A,B,F,Xs)) ) ).

% foldr.foldr_Cons
tff(fact_5028_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: fun(B,fun(A,A)),F: fun(C,B),Xs: list(C),A3: A] : ( aa(A,A,foldr(B,A,G,aa(list(C),list(B),map(C,B,F),Xs)),A3) = aa(A,A,foldr(C,A,aa(fun(C,B),fun(C,fun(A,A)),aa(fun(B,fun(A,A)),fun(fun(C,B),fun(C,fun(A,A))),comp(B,fun(A,A),C),G),F),Xs),A3) ) ).

% foldr_map
tff(fact_5029_fold__rev,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),F: fun(A,fun(B,B))] :
      ( ! [X2: A,Y2: A] :
          ( pp(member(A,X2,aa(list(A),set(A),set2(A),Xs)))
         => ( pp(member(A,Y2,aa(list(A),set(A),set2(A),Xs)))
           => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y2)),aa(A,fun(B,B),F,X2)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,Y2)) ) ) )
     => ( fold(A,B,F,rev(A,Xs)) = fold(A,B,F,Xs) ) ) ).

% fold_rev
tff(fact_5030_foldr__fold,axiom,
    ! [B: $tType,A: $tType,Xs: list(A),F: fun(A,fun(B,B))] :
      ( ! [X2: A,Y2: A] :
          ( pp(member(A,X2,aa(list(A),set(A),set2(A),Xs)))
         => ( pp(member(A,Y2,aa(list(A),set(A),set2(A),Xs)))
           => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y2)),aa(A,fun(B,B),F,X2)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,Y2)) ) ) )
     => ( foldr(A,B,F,Xs) = fold(A,B,F,Xs) ) ) ).

% foldr_fold
tff(fact_5031_prod__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_mult(B)
        & monoid_mult(A) )
     => ! [A4: fun(A,fun(B,bool))] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),A4,one_one(A)),one_one(B)))
         => ( pp(aa(fun(B,fun(B,B)),bool,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),bool),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A4,bNF_rel_fun(A,B,A,B,A4,A4)),times_times(A)),times_times(B)))
           => pp(aa(fun(list(B),B),bool,aa(fun(list(A),A),fun(fun(list(B),B),bool),bNF_rel_fun(list(A),list(B),A,B,list_all2(A,B,A4),A4),groups5270119922927024881d_list(A)),groups5270119922927024881d_list(B))) ) ) ) ).

% prod_list_transfer
tff(fact_5032_lexordp__conv__lexord,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( ord_lexordp(A,Xs,Ys)
        <=> pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs),Ys),lexord(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),ord_less(A)))))) ) ) ).

% lexordp_conv_lexord
tff(fact_5033_revg_Opelims,axiom,
    ! [A: $tType,X: list(A),Xa: list(A),Y: list(A)] :
      ( ( revg(A,X,Xa) = Y )
     => ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),revg_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Xa)))
       => ( ( ( X = nil(A) )
           => ( ( Y = Xa )
             => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),revg_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Xa))) ) )
         => ~ ! [A8: A,As2: list(A)] :
                ( ( X = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2) )
               => ( ( Y = revg(A,As2,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),Xa)) )
                 => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),revg_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2)),Xa))) ) ) ) ) ) ).

% revg.pelims
tff(fact_5034_prod__list_OCons,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [X: A,Xs: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),X),aa(list(A),A,groups5270119922927024881d_list(A),Xs)) ) ) ).

% prod_list.Cons
tff(fact_5035_prod__list_ONil,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( aa(list(A),A,groups5270119922927024881d_list(A),nil(A)) = one_one(A) ) ) ).

% prod_list.Nil
tff(fact_5036_prod__list_Oappend,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xs: list(A),Ys: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xs),Ys)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(list(A),A,groups5270119922927024881d_list(A),Xs)),aa(list(A),A,groups5270119922927024881d_list(A),Ys)) ) ) ).

% prod_list.append
tff(fact_5037_prod__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),Xs) = aa(A,A,foldr(A,A,times_times(A),Xs),one_one(A)) ) ) ).

% prod_list.eq_foldr
tff(fact_5038_map__of__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(C,B),Xs: list(product_prod(A,C))] : ( map_of(A,B,aa(list(product_prod(A,C)),list(product_prod(A,B)),map(product_prod(A,C),product_prod(A,B),aa(fun(A,fun(C,product_prod(A,B))),fun(product_prod(A,C),product_prod(A,B)),product_case_prod(A,C,product_prod(A,B)),aTP_Lamp_sz(fun(C,B),fun(A,fun(C,product_prod(A,B))),F))),Xs)) = aa(fun(A,option(C)),fun(A,option(B)),aa(fun(option(C),option(B)),fun(fun(A,option(C)),fun(A,option(B))),comp(option(C),option(B),A),map_option(C,B,F)),map_of(A,C,Xs)) ) ).

% map_of_map
tff(fact_5039_assert__def,axiom,
    ! [A: $tType,P: fun(A,bool),X: A] :
      ( ( pp(aa(A,bool,P,X))
       => ( heap_Time_assert(A,P,X) = aa(A,heap_Time_Heap(A),heap_Time_return(A),X) ) )
      & ( ~ pp(aa(A,bool,P,X))
       => ( heap_Time_assert(A,P,X) = heap_Time_raise(A,aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2(fTrue,fFalse,fFalse,fFalse,fFalse,fTrue,fTrue,fFalse)),aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2(fTrue,fTrue,fFalse,fFalse,fTrue,fTrue,fTrue,fFalse)),aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2(fTrue,fTrue,fFalse,fFalse,fTrue,fTrue,fTrue,fFalse)),aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2(fTrue,fFalse,fTrue,fFalse,fFalse,fTrue,fTrue,fFalse)),aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2(fFalse,fTrue,fFalse,fFalse,fTrue,fTrue,fTrue,fFalse)),aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2(fFalse,fFalse,fTrue,fFalse,fTrue,fTrue,fTrue,fFalse)),nil(char)))))))) ) ) ) ).

% assert_def
tff(fact_5040_prod__list__def,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( groups5270119922927024881d_list(A) = groups_monoid_F(A,times_times(A),one_one(A)) ) ) ).

% prod_list_def
tff(fact_5041_case__map__option,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: A,H2: fun(B,A),F: fun(C,B),X: option(C)] : ( case_option(A,B,G,H2,aa(option(C),option(B),map_option(C,B,F),X)) = case_option(A,C,G,aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),H2),F),X) ) ).

% case_map_option
tff(fact_5042_dom__map__option__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: fun(C,B),M4: fun(A,option(C))] : ( dom(A,B,aa(fun(A,option(C)),fun(A,option(B)),aa(fun(option(C),option(B)),fun(fun(A,option(C)),fun(A,option(B))),comp(option(C),option(B),A),map_option(C,B,G)),M4)) = dom(A,C,M4) ) ).

% dom_map_option_comp
tff(fact_5043_map__option__o__empty,axiom,
    ! [A: $tType,C: $tType,B: $tType,F: fun(C,B),X3: A] : ( aa(A,option(B),aa(fun(A,option(C)),fun(A,option(B)),aa(fun(option(C),option(B)),fun(fun(A,option(C)),fun(A,option(B))),comp(option(C),option(B),A),map_option(C,B,F)),aTP_Lamp_ty(A,option(C))),X3) = none(B) ) ).

% map_option_o_empty
tff(fact_5044_map__option__o__map__upd,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(C,B),M4: fun(A,option(C)),A3: A,B2: C] : ( aa(fun(A,option(C)),fun(A,option(B)),aa(fun(option(C),option(B)),fun(fun(A,option(C)),fun(A,option(B))),comp(option(C),option(B),A),map_option(C,B,F)),fun_upd(A,option(C),M4,A3,aa(C,option(C),some(C),B2))) = fun_upd(A,option(B),aa(fun(A,option(C)),fun(A,option(B)),aa(fun(option(C),option(B)),fun(fun(A,option(C)),fun(A,option(B))),comp(option(C),option(B),A),map_option(C,B,F)),M4),A3,aa(B,option(B),some(B),aa(C,B,F,B2))) ) ).

% map_option_o_map_upd
tff(fact_5045_map__option_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(B,C),G: fun(A,B),Option: option(A)] : ( aa(option(B),option(C),map_option(B,C,F),aa(option(A),option(B),map_option(A,B,G),Option)) = aa(option(A),option(C),map_option(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),G)),Option) ) ).

% map_option.compositionality
tff(fact_5046_option_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: fun(B,C),F: fun(A,B),V: option(A)] : ( aa(option(B),option(C),map_option(B,C,G),aa(option(A),option(B),map_option(A,B,F),V)) = aa(option(A),option(C),map_option(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),G),F)),V) ) ).

% option.map_comp
tff(fact_5047_map__option_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(B,C),G: fun(A,B)] : ( aa(fun(option(A),option(B)),fun(option(A),option(C)),aa(fun(option(B),option(C)),fun(fun(option(A),option(B)),fun(option(A),option(C))),comp(option(B),option(C),option(A)),map_option(B,C,F)),map_option(A,B,G)) = map_option(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),G)) ) ).

% map_option.comp
tff(fact_5048_option_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F: fun(B,nat),G: fun(A,B)] : ( aa(fun(option(A),option(B)),fun(option(A),nat),aa(fun(option(B),nat),fun(fun(option(A),option(B)),fun(option(A),nat)),comp(option(B),nat,option(A)),size_option(B,F)),map_option(A,B,G)) = size_option(A,aa(fun(A,B),fun(A,nat),aa(fun(B,nat),fun(fun(A,B),fun(A,nat)),comp(B,nat,A),F),G)) ) ).

% option.size_gen_o_map
tff(fact_5049_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [R3: B,Xs: list(C)] : ( groups8242544230860333062m_list(B,aa(list(C),list(B),map(C,B,aTP_Lamp_tz(B,fun(C,B),R3)),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),size_size(list(C),Xs))),R3) ) ) ).

% sum_list_triv
tff(fact_5050_merge_Opelims,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [X: list(A),Xa: list(A),Y: list(A)] :
          ( ( merge(A,X,Xa) = Y )
         => ( pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),merge_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),X),Xa)))
           => ( ( ( X = nil(A) )
               => ( ( Y = Xa )
                 => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),merge_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),nil(A)),Xa))) ) )
             => ( ! [V3: A,Va: list(A)] :
                    ( ( X = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va) )
                   => ( ( Xa = nil(A) )
                     => ( ( Y = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va) )
                       => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),merge_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va)),nil(A)))) ) ) )
               => ~ ! [X12: A,L12: list(A)] :
                      ( ( X = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),L12) )
                     => ! [X23: A,L22: list(A)] :
                          ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),L22) )
                         => ( ( ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X12),X23))
                               => ( Y = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),merge(A,L12,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),L22))) ) )
                              & ( ~ pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),X12),X23))
                               => ( ( ( X12 = X23 )
                                   => ( Y = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),merge(A,L12,L22)) ) )
                                  & ( ( X12 != X23 )
                                   => ( Y = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),merge(A,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),L12),L22)) ) ) ) ) )
                           => ~ pp(aa(product_prod(list(A),list(A)),bool,accp(product_prod(list(A),list(A)),merge_rel(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),L12)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),L22)))) ) ) ) ) ) ) ) ) ).

% merge.pelims
tff(fact_5051_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [C2: A,F: fun(B,A),Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_bd(A,fun(fun(B,A),fun(B,A)),C2),F)),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F),Xs))) ) ) ).

% sum_list_const_mult
tff(fact_5052_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_0(A)
     => ! [F: fun(B,A),C2: A,Xs: list(B)] : ( groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(A,fun(B,A),aTP_Lamp_bc(fun(B,A),fun(A,fun(B,A)),F),C2)),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F),Xs))),C2) ) ) ).

% sum_list_mult_const
tff(fact_5053_uminus__sum__list__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F: fun(B,A),Xs: list(B)] : ( aa(A,A,uminus_uminus(A),groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,F),Xs))) = groups8242544230860333062m_list(A,aa(list(B),list(A),map(B,A,aa(fun(B,A),fun(B,A),aa(fun(A,A),fun(fun(B,A),fun(B,A)),comp(A,A,B),uminus_uminus(A)),F)),Xs)) ) ) ).

% uminus_sum_list_map
tff(fact_5054_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat,C2: A] : ( groups8242544230860333062m_list(A,replicate(A,N,C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),C2) ) ) ).

% sum_list_replicate
tff(fact_5055_option_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: C,Ga: fun(B,C),F: fun(A,B)] : ( aa(fun(option(A),option(B)),fun(option(A),C),aa(fun(option(B),C),fun(fun(option(A),option(B)),fun(option(A),C)),comp(option(B),C,option(A)),rec_option(C,B,G,Ga)),map_option(A,B,F)) = rec_option(C,A,G,aa(fun(A,B),fun(A,C),aTP_Lamp_ua(fun(B,C),fun(fun(A,B),fun(A,C)),Ga),F)) ) ).

% option.rec_o_map
tff(fact_5056_mergesort__by__rel__split_Opelims,axiom,
    ! [A: $tType,X: product_prod(list(A),list(A)),Xa: list(A),Y: product_prod(list(A),list(A))] :
      ( ( merges295452479951948502_split(A,X,Xa) = Y )
     => ( pp(aa(product_prod(product_prod(list(A),list(A)),list(A)),bool,accp(product_prod(product_prod(list(A),list(A)),list(A)),merges7066485432131860899it_rel(A)),aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),X),Xa)))
       => ( ! [Xs12: list(A),Xs22: list(A)] :
              ( ( X = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22) )
             => ( ( Xa = nil(A) )
               => ( ( Y = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22) )
                 => ~ pp(aa(product_prod(product_prod(list(A),list(A)),list(A)),bool,accp(product_prod(product_prod(list(A),list(A)),list(A)),merges7066485432131860899it_rel(A)),aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22)),nil(A)))) ) ) )
         => ( ! [Xs12: list(A),Xs22: list(A)] :
                ( ( X = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22) )
               => ! [X2: A] :
                    ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A)) )
                   => ( ( Y = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Xs12)),Xs22) )
                     => ~ pp(aa(product_prod(product_prod(list(A),list(A)),list(A)),bool,accp(product_prod(product_prod(list(A),list(A)),list(A)),merges7066485432131860899it_rel(A)),aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A))))) ) ) )
           => ~ ! [Xs12: list(A),Xs22: list(A)] :
                  ( ( X = aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22) )
                 => ! [X12: A,X23: A,Xs3: list(A)] :
                      ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),Xs3)) )
                     => ( ( Y = merges295452479951948502_split(A,aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),Xs12)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),Xs22)),Xs3) )
                       => ~ pp(aa(product_prod(product_prod(list(A),list(A)),list(A)),bool,accp(product_prod(product_prod(list(A),list(A)),list(A)),merges7066485432131860899it_rel(A)),aa(list(A),product_prod(product_prod(list(A),list(A)),list(A)),aa(product_prod(list(A),list(A)),fun(list(A),product_prod(product_prod(list(A),list(A)),list(A))),product_Pair(product_prod(list(A),list(A)),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Xs12),Xs22)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X12),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X23),Xs3))))) ) ) ) ) ) ) ) ).

% mergesort_by_rel_split.pelims
tff(fact_5057_size__list__map,axiom,
    ! [A: $tType,B: $tType,F: fun(A,nat),G: fun(B,A),Xs: list(B)] : ( aa(list(A),nat,size_list(A,F),aa(list(B),list(A),map(B,A,G),Xs)) = aa(list(B),nat,size_list(B,aa(fun(B,A),fun(B,nat),aa(fun(A,nat),fun(fun(B,A),fun(B,nat)),comp(A,nat,B),F),G)),Xs) ) ).

% size_list_map
tff(fact_5058_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F: fun(B,nat),G: fun(A,B)] : ( aa(fun(list(A),list(B)),fun(list(A),nat),aa(fun(list(B),nat),fun(fun(list(A),list(B)),fun(list(A),nat)),comp(list(B),nat,list(A)),size_list(B,F)),map(A,B,G)) = size_list(A,aa(fun(A,B),fun(A,nat),aa(fun(B,nat),fun(fun(A,B),fun(A,nat)),comp(B,nat,A),F),G)) ) ).

% list.size_gen_o_map
tff(fact_5059_make_H__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1(B)
        & heap(A) )
     => ! [I: code_integer,F: fun(B,A)] : ( array_make2(B,A,I,F) = array_make(A,aa(code_integer,nat,code_nat_of_integer,I),aa(fun(nat,B),fun(nat,A),aa(fun(B,A),fun(fun(nat,B),fun(nat,A)),comp(B,A,nat),F),semiring_1_of_nat(B))) ) ) ).

% make'_def
tff(fact_5060_next_Osimps,axiom,
    ! [V: code_natural,W2: code_natural] : ( aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),V),W2)) = aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,V,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),divide_divide(code_natural,V,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,one2)))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,W2,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),divide_divide(code_natural,W2,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))),one_one(code_natural)))),one_one(code_natural))),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,V,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),divide_divide(code_natural,V,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,one2))))))))))))))))),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,W2,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),divide_divide(code_natural,W2,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,one2)))))))))))))))) ) ).

% next.simps
tff(fact_5061_inter__coset__fold,axiom,
    ! [A: $tType,A4: set(A),Xs: list(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),coset(A,Xs)) = aa(set(A),set(A),fold(A,set(A),remove(A),Xs),A4) ) ).

% inter_coset_fold
tff(fact_5062_log_Ocases,axiom,
    ! [X: product_prod(code_natural,code_natural)] :
      ~ ! [B5: code_natural,I3: code_natural] : ( X != aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),B5),I3) ) ).

% log.cases
tff(fact_5063_iter_Ocases,axiom,
    ! [A: $tType,X: product_prod(fun(product_prod(code_natural,code_natural),product_prod(product_prod(A,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),product_prod(code_natural,product_prod(code_natural,code_natural)))] :
      ~ ! [Random: fun(product_prod(code_natural,code_natural),product_prod(product_prod(A,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),Nrandom: code_natural,Seed: product_prod(code_natural,code_natural)] : ( X != aa(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(fun(product_prod(code_natural,code_natural),product_prod(product_prod(A,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),product_prod(code_natural,product_prod(code_natural,code_natural))),aa(fun(product_prod(code_natural,code_natural),product_prod(product_prod(A,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),fun(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(fun(product_prod(code_natural,code_natural),product_prod(product_prod(A,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),product_prod(code_natural,product_prod(code_natural,code_natural)))),product_Pair(fun(product_prod(code_natural,code_natural),product_prod(product_prod(A,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),product_prod(code_natural,product_prod(code_natural,code_natural))),Random),aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),Nrandom),Seed)) ) ).

% iter.cases
tff(fact_5064_exhaustive__fun_H_Ocases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( quickc658316121487927005ustive(B)
        & cl_HOL_Oequal(A)
        & quickc658316121487927005ustive(A) )
     => ! [X: product_prod(fun(fun(A,B),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural))] :
          ~ ! [F9: fun(fun(A,B),option(product_prod(bool,list(code_term)))),I3: code_natural,D3: code_natural] : ( X != aa(product_prod(code_natural,code_natural),product_prod(fun(fun(A,B),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural)),aa(fun(fun(A,B),option(product_prod(bool,list(code_term)))),fun(product_prod(code_natural,code_natural),product_prod(fun(fun(A,B),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural))),product_Pair(fun(fun(A,B),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural)),F9),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),I3),D3)) ) ) ).

% exhaustive_fun'.cases
tff(fact_5065_exhaustive__natural_H_Ocases,axiom,
    ! [X: product_prod(fun(code_natural,option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural))] :
      ~ ! [F9: fun(code_natural,option(product_prod(bool,list(code_term)))),D3: code_natural,I3: code_natural] : ( X != aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural)),aa(fun(code_natural,option(product_prod(bool,list(code_term)))),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural)),F9),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),D3),I3)) ) ).

% exhaustive_natural'.cases
tff(fact_5066_full__exhaustive__fun_H_Ocases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( quickc3360725361186068524ustive(B)
        & cl_HOL_Oequal(A)
        & quickc3360725361186068524ustive(A) )
     => ! [X: product_prod(fun(product_prod(fun(A,B),fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural))] :
          ~ ! [F9: fun(product_prod(fun(A,B),fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),I3: code_natural,D3: code_natural] : ( X != aa(product_prod(code_natural,code_natural),product_prod(fun(product_prod(fun(A,B),fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural)),aa(fun(product_prod(fun(A,B),fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),fun(product_prod(code_natural,code_natural),product_prod(fun(product_prod(fun(A,B),fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural))),product_Pair(fun(product_prod(fun(A,B),fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural)),F9),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),I3),D3)) ) ) ).

% full_exhaustive_fun'.cases
tff(fact_5067_full__exhaustive__natural_H_Ocases,axiom,
    ! [X: product_prod(fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural))] :
      ~ ! [F9: fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),D3: code_natural,I3: code_natural] : ( X != aa(product_prod(code_natural,code_natural),product_prod(fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural)),aa(fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),fun(product_prod(code_natural,code_natural),product_prod(fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural))),product_Pair(fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod(bool,list(code_term)))),product_prod(code_natural,code_natural)),F9),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),D3),I3)) ) ).

% full_exhaustive_natural'.cases
tff(fact_5068_nth_H__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [A3: array(A)] : ( array_nth2(A,A3) = aa(fun(code_integer,nat),fun(code_integer,heap_Time_Heap(A)),aa(fun(nat,heap_Time_Heap(A)),fun(fun(code_integer,nat),fun(code_integer,heap_Time_Heap(A))),comp(nat,heap_Time_Heap(A),code_integer),array_nth(A,A3)),code_nat_of_integer) ) ) ).

% nth'_def
tff(fact_5069_new_H__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ( array_new2(A) = aa(fun(code_integer,nat),fun(code_integer,fun(A,heap_Time_Heap(array(A)))),aa(fun(nat,fun(A,heap_Time_Heap(array(A)))),fun(fun(code_integer,nat),fun(code_integer,fun(A,heap_Time_Heap(array(A))))),comp(nat,fun(A,heap_Time_Heap(array(A))),code_integer),array_new(A)),code_nat_of_integer) ) ) ).

% new'_def
tff(fact_5070_split__seed__def,axiom,
    ! [S: product_prod(code_natural,code_natural)] : ( split_seed(S) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_case_prod(code_natural,code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aTP_Lamp_uc(product_prod(code_natural,code_natural),fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),S)),S) ) ).

% split_seed_def
tff(fact_5071_Lazy__Sequence_Oiterate__upto_Ocases,axiom,
    ! [A: $tType,X: product_prod(fun(code_natural,A),product_prod(code_natural,code_natural))] :
      ~ ! [F9: fun(code_natural,A),N3: code_natural,M5: code_natural] : ( X != aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),aa(fun(code_natural,A),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,A),product_prod(code_natural,code_natural)),F9),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),N3),M5)) ) ).

% Lazy_Sequence.iterate_upto.cases
tff(fact_5072_Predicate_Oiterate__upto_Opinduct,axiom,
    ! [A: $tType,A0: fun(code_natural,A),A1: code_natural,A22: code_natural,P: fun(fun(code_natural,A),fun(code_natural,fun(code_natural,bool)))] :
      ( pp(aa(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),bool,accp(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),iterate_upto_rel(A)),aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),aa(fun(code_natural,A),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,A),product_prod(code_natural,code_natural)),A0),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),A1),A22))))
     => ( ! [F9: fun(code_natural,A),N3: code_natural,M5: code_natural] :
            ( pp(aa(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),bool,accp(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),iterate_upto_rel(A)),aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),aa(fun(code_natural,A),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,A),product_prod(code_natural,code_natural)),F9),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),N3),M5))))
           => ( ! [X3: product_unit] :
                  ( ~ pp(aa(code_natural,bool,aa(code_natural,fun(code_natural,bool),ord_less(code_natural),M5),N3))
                 => pp(aa(code_natural,bool,aa(code_natural,fun(code_natural,bool),aa(fun(code_natural,A),fun(code_natural,fun(code_natural,bool)),P,F9),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),N3),one_one(code_natural))),M5)) )
             => pp(aa(code_natural,bool,aa(code_natural,fun(code_natural,bool),aa(fun(code_natural,A),fun(code_natural,fun(code_natural,bool)),P,F9),N3),M5)) ) )
       => pp(aa(code_natural,bool,aa(code_natural,fun(code_natural,bool),aa(fun(code_natural,A),fun(code_natural,fun(code_natural,bool)),P,A0),A1),A22)) ) ) ).

% Predicate.iterate_upto.pinduct
tff(fact_5073_Random_Orange__def,axiom,
    ! [K: code_natural] : ( range(K) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),iterate(code_natural,product_prod(code_natural,code_natural),log(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),K),aTP_Lamp_ue(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))))),one_one(code_natural)),aTP_Lamp_uf(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),K)) ) ).

% Random.range_def
tff(fact_5074_scomp__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,X: fun(A,product_prod(B,C))] : ( product_scomp(A,B,C,product_prod(B,C),X,product_Pair(B,C)) = X ) ).

% scomp_Pair
tff(fact_5075_Pair__scomp,axiom,
    ! [A: $tType,B: $tType,C: $tType,X: C,F: fun(C,fun(A,B))] : ( product_scomp(A,C,A,B,aa(C,fun(A,product_prod(C,A)),product_Pair(C,A),X),F) = aa(C,fun(A,B),F,X) ) ).

% Pair_scomp
tff(fact_5076_small__lazy_H_Ocases,axiom,
    ! [X: product_prod(int,int)] :
      ~ ! [D3: int,I3: int] : ( X != aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),D3),I3) ) ).

% small_lazy'.cases
tff(fact_5077_iterate_Osimps,axiom,
    ! [A: $tType,B: $tType,K: code_natural,F: fun(B,fun(A,product_prod(B,A))),X: B] :
      ( ( ( K = zero_zero(code_natural) )
       => ( aa(B,fun(A,product_prod(B,A)),iterate(B,A,K,F),X) = aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),X) ) )
      & ( ( K != zero_zero(code_natural) )
       => ( aa(B,fun(A,product_prod(B,A)),iterate(B,A,K,F),X) = product_scomp(A,B,A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),F,X),iterate(B,A,aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),minus_minus(code_natural),K),one_one(code_natural)),F)) ) ) ) ).

% iterate.simps
tff(fact_5078_iterate_Oelims,axiom,
    ! [A: $tType,B: $tType,X: code_natural,Xa: fun(B,fun(A,product_prod(B,A))),Xb: B,Y: fun(A,product_prod(B,A))] :
      ( ( aa(B,fun(A,product_prod(B,A)),iterate(B,A,X,Xa),Xb) = Y )
     => ( ( ( X = zero_zero(code_natural) )
         => ( Y = aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Xb) ) )
        & ( ( X != zero_zero(code_natural) )
         => ( Y = product_scomp(A,B,A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),Xa,Xb),iterate(B,A,aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),minus_minus(code_natural),X),one_one(code_natural)),Xa)) ) ) ) ) ).

% iterate.elims
tff(fact_5079_log_Opelims,axiom,
    ! [X: code_natural,Xa: code_natural,Y: code_natural] :
      ( ( log(X,Xa) = Y )
     => ( pp(aa(product_prod(code_natural,code_natural),bool,accp(product_prod(code_natural,code_natural),log_rel),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),X),Xa)))
       => ~ ( ( ( ( pp(aa(code_natural,bool,aa(code_natural,fun(code_natural,bool),ord_less_eq(code_natural),X),one_one(code_natural)))
                  | pp(aa(code_natural,bool,aa(code_natural,fun(code_natural,bool),ord_less(code_natural),Xa),X)) )
               => ( Y = one_one(code_natural) ) )
              & ( ~ ( pp(aa(code_natural,bool,aa(code_natural,fun(code_natural,bool),ord_less_eq(code_natural),X),one_one(code_natural)))
                    | pp(aa(code_natural,bool,aa(code_natural,fun(code_natural,bool),ord_less(code_natural),Xa),X)) )
               => ( Y = aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),one_one(code_natural)),log(X,divide_divide(code_natural,Xa,X))) ) ) )
           => ~ pp(aa(product_prod(code_natural,code_natural),bool,accp(product_prod(code_natural,code_natural),log_rel),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),X),Xa))) ) ) ) ).

% log.pelims
tff(fact_5080_iterate_Opelims,axiom,
    ! [A: $tType,B: $tType,X: code_natural,Xa: fun(B,fun(A,product_prod(B,A))),Xb: B,Y: fun(A,product_prod(B,A))] :
      ( ( aa(B,fun(A,product_prod(B,A)),iterate(B,A,X,Xa),Xb) = Y )
     => ( pp(aa(product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),bool,accp(product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),iterate_rel(B,A)),aa(product_prod(fun(B,fun(A,product_prod(B,A))),B),product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),aa(code_natural,fun(product_prod(fun(B,fun(A,product_prod(B,A))),B),product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B))),product_Pair(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),X),aa(B,product_prod(fun(B,fun(A,product_prod(B,A))),B),aa(fun(B,fun(A,product_prod(B,A))),fun(B,product_prod(fun(B,fun(A,product_prod(B,A))),B)),product_Pair(fun(B,fun(A,product_prod(B,A))),B),Xa),Xb))))
       => ~ ( ( ( ( X = zero_zero(code_natural) )
               => ( Y = aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Xb) ) )
              & ( ( X != zero_zero(code_natural) )
               => ( Y = product_scomp(A,B,A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),Xa,Xb),iterate(B,A,aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),minus_minus(code_natural),X),one_one(code_natural)),Xa)) ) ) )
           => ~ pp(aa(product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),bool,accp(product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),iterate_rel(B,A)),aa(product_prod(fun(B,fun(A,product_prod(B,A))),B),product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),aa(code_natural,fun(product_prod(fun(B,fun(A,product_prod(B,A))),B),product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B))),product_Pair(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),X),aa(B,product_prod(fun(B,fun(A,product_prod(B,A))),B),aa(fun(B,fun(A,product_prod(B,A))),fun(B,product_prod(fun(B,fun(A,product_prod(B,A))),B)),product_Pair(fun(B,fun(A,product_prod(B,A))),B),Xa),Xb)))) ) ) ) ).

% iterate.pelims
tff(fact_5081_iter_H_Ocases,axiom,
    ! [A: $tType] :
      ( quickcheck_random(A)
     => ! [X: product_prod(itself(A),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))))] :
          ~ ! [T5: itself(A),Nrandom: code_natural,Sz: code_natural,Seed: product_prod(code_natural,code_natural)] : ( X != aa(product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))),product_prod(itself(A),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural)))),aa(itself(A),fun(product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))),product_prod(itself(A),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))))),product_Pair(itself(A),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural)))),T5),aa(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))),aa(code_natural,fun(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural)))),product_Pair(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))),Nrandom),aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),Sz),Seed))) ) ) ).

% iter'.cases
tff(fact_5082_iterate_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B))] :
      ~ ! [K2: code_natural,F9: fun(B,fun(A,product_prod(B,A))),X2: B] : ( X != aa(product_prod(fun(B,fun(A,product_prod(B,A))),B),product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),aa(code_natural,fun(product_prod(fun(B,fun(A,product_prod(B,A))),B),product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B))),product_Pair(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),K2),aa(B,product_prod(fun(B,fun(A,product_prod(B,A))),B),aa(fun(B,fun(A,product_prod(B,A))),fun(B,product_prod(fun(B,fun(A,product_prod(B,A))),B)),product_Pair(fun(B,fun(A,product_prod(B,A))),B),F9),X2)) ) ).

% iterate.cases
tff(fact_5083_prod__filter__assoc,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: filter(A),G6: filter(B),H10: filter(C)] : ( prod_filter(product_prod(A,B),C,prod_filter(A,B,F2,G6),H10) = filtermap(product_prod(A,product_prod(B,C)),product_prod(product_prod(A,B),C),aa(fun(A,fun(product_prod(B,C),product_prod(product_prod(A,B),C))),fun(product_prod(A,product_prod(B,C)),product_prod(product_prod(A,B),C)),product_case_prod(A,product_prod(B,C),product_prod(product_prod(A,B),C)),aTP_Lamp_uh(A,fun(product_prod(B,C),product_prod(product_prod(A,B),C)))),prod_filter(A,product_prod(B,C),F2,prod_filter(B,C,G6,H10))) ) ).

% prod_filter_assoc
tff(fact_5084_select__weight__cons__zero,axiom,
    ! [A: $tType,X: A,Xs: list(product_prod(code_natural,A))] : ( select_weight(A,aa(list(product_prod(code_natural,A)),list(product_prod(code_natural,A)),aa(product_prod(code_natural,A),fun(list(product_prod(code_natural,A)),list(product_prod(code_natural,A))),cons(product_prod(code_natural,A)),aa(A,product_prod(code_natural,A),aa(code_natural,fun(A,product_prod(code_natural,A)),product_Pair(code_natural,A),zero_zero(code_natural)),X)),Xs)) = select_weight(A,Xs) ) ).

% select_weight_cons_zero
tff(fact_5085_select__weight__def,axiom,
    ! [A: $tType,Xs: list(product_prod(code_natural,A))] : ( select_weight(A,Xs) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)),range(groups8242544230860333062m_list(code_natural,aa(list(product_prod(code_natural,A)),list(code_natural),map(product_prod(code_natural,A),code_natural,product_fst(code_natural,A)),Xs))),aTP_Lamp_ui(list(product_prod(code_natural,A)),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)))),Xs)) ) ).

% select_weight_def
tff(fact_5086_filtermap__bot,axiom,
    ! [B: $tType,A: $tType,F: fun(B,A)] : ( filtermap(B,A,F,bot_bot(filter(B))) = bot_bot(filter(A)) ) ).

% filtermap_bot
tff(fact_5087_filtermap__bot__iff,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),F2: filter(B)] :
      ( ( filtermap(B,A,F,F2) = bot_bot(filter(A)) )
    <=> ( F2 = bot_bot(filter(B)) ) ) ).

% filtermap_bot_iff
tff(fact_5088_filtermap__Pair,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(C,A),G: fun(C,B),F2: filter(C)] : pp(aa(filter(product_prod(A,B)),bool,aa(filter(product_prod(A,B)),fun(filter(product_prod(A,B)),bool),ord_less_eq(filter(product_prod(A,B))),filtermap(C,product_prod(A,B),aa(fun(C,B),fun(C,product_prod(A,B)),aTP_Lamp_jj(fun(C,A),fun(fun(C,B),fun(C,product_prod(A,B))),F),G),F2)),prod_filter(A,B,filtermap(C,A,F,F2),filtermap(C,B,G,F2)))) ).

% filtermap_Pair
tff(fact_5089_filtermap__inf,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),F12: filter(B),F24: filter(B)] : pp(aa(filter(A),bool,aa(filter(A),fun(filter(A),bool),ord_less_eq(filter(A)),filtermap(B,A,F,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F12),F24))),aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),filtermap(B,A,F,F12)),filtermap(B,A,F,F24)))) ).

% filtermap_inf
tff(fact_5090_select__weight__select,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( select_weight(A,aa(list(A),list(product_prod(code_natural,A)),map(A,product_prod(code_natural,A),aa(code_natural,fun(A,product_prod(code_natural,A)),product_Pair(code_natural,A),one_one(code_natural))),Xs)) = select(A,Xs) ) ) ).

% select_weight_select
tff(fact_5091_prod__filter__principal__singleton2,axiom,
    ! [B: $tType,A: $tType,F2: filter(A),X: B] : ( prod_filter(A,B,F2,principal(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))) = filtermap(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_ex(B,fun(A,product_prod(A,B))),X),F2) ) ).

% prod_filter_principal_singleton2
tff(fact_5092_pick__same,axiom,
    ! [A: $tType,L: nat,Xs: list(A)] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),L),size_size(list(A),Xs)))
     => ( pick(A,aa(list(A),list(product_prod(code_natural,A)),map(A,product_prod(code_natural,A),aa(code_natural,fun(A,product_prod(code_natural,A)),product_Pair(code_natural,A),one_one(code_natural))),Xs),code_natural_of_nat(L)) = nth(A,Xs,L) ) ) ).

% pick_same
tff(fact_5093_inf__principal,axiom,
    ! [A: $tType,A4: set(A),B3: set(A)] : ( aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),principal(A,A4)),principal(A,B3)) = principal(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A4),B3)) ) ).

% inf_principal
tff(fact_5094_principal__eq__bot__iff,axiom,
    ! [A: $tType,X6: set(A)] :
      ( ( principal(A,X6) = bot_bot(filter(A)) )
    <=> ( X6 = bot_bot(set(A)) ) ) ).

% principal_eq_bot_iff
tff(fact_5095_bot__eq__principal__empty,axiom,
    ! [A: $tType] : ( bot_bot(filter(A)) = principal(A,bot_bot(set(A))) ) ).

% bot_eq_principal_empty
tff(fact_5096_eventually__inf__principal,axiom,
    ! [A: $tType,P: fun(A,bool),F2: filter(A),S: set(A)] :
      ( eventually(A,P,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F2),principal(A,S)))
    <=> eventually(A,aa(set(A),fun(A,bool),aTP_Lamp_uj(fun(A,bool),fun(set(A),fun(A,bool)),P),S),F2) ) ).

% eventually_inf_principal
tff(fact_5097_prod__filter__principal__singleton,axiom,
    ! [A: $tType,B: $tType,X: A,F2: filter(B)] : ( prod_filter(A,B,principal(A,aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))),F2) = filtermap(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),F2) ) ).

% prod_filter_principal_singleton
tff(fact_5098_select__def,axiom,
    ! [A: $tType,Xs: list(A)] : ( select(A,Xs) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)),range(code_natural_of_nat(size_size(list(A),Xs))),aTP_Lamp_uk(list(A),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)))),Xs)) ) ).

% select_def
tff(fact_5099_finite__subsets__at__top__finite,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( finite5375528669736107172at_top(A,A4) = principal(set(A),aa(set(set(A)),set(set(A)),insert2(set(A),A4),bot_bot(set(set(A))))) ) ) ).

% finite_subsets_at_top_finite
tff(fact_5100_filterlim__base__iff,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,I4: set(A),F2: fun(A,set(B)),F: fun(B,C),G6: fun(D,set(C)),J4: set(D)] :
      ( ( I4 != bot_bot(set(A)) )
     => ( ! [I3: A] :
            ( pp(member(A,I3,I4))
           => ! [J3: A] :
                ( pp(member(A,J3,I4))
               => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F2,I3)),aa(A,set(B),F2,J3)))
                  | pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(A,set(B),F2,J3)),aa(A,set(B),F2,I3))) ) ) )
       => ( filterlim(B,C,F,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(D),set(filter(C)),image2(D,filter(C),aTP_Lamp_ul(fun(D,set(C)),fun(D,filter(C)),G6)),J4)),aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image2(A,filter(B),aTP_Lamp_um(fun(A,set(B)),fun(A,filter(B)),F2)),I4)))
        <=> ! [X4: D] :
              ( pp(member(D,X4,J4))
             => ? [Xa2: A] :
                  ( pp(member(A,Xa2,I4))
                  & ! [Xb3: B] :
                      ( pp(member(B,Xb3,aa(A,set(B),F2,Xa2)))
                     => pp(member(C,aa(B,C,F,Xb3),aa(D,set(C),G6,X4))) ) ) ) ) ) ) ).

% filterlim_base_iff
tff(fact_5101_filterlim__inf,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),F24: filter(B),F32: filter(B),F12: filter(A)] :
      ( filterlim(A,B,F,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F24),F32),F12)
    <=> ( filterlim(A,B,F,F24,F12)
        & filterlim(A,B,F,F32,F12) ) ) ).

% filterlim_inf
tff(fact_5102_finite__subsets__at__top__neq__bot,axiom,
    ! [A: $tType,A4: set(A)] : ( finite5375528669736107172at_top(A,A4) != bot_bot(filter(set(A))) ) ).

% finite_subsets_at_top_neq_bot
tff(fact_5103_filterlim__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,B),G6: filter(B),F2: filter(A),G: fun(A,C),H10: filter(C)] :
      ( filterlim(A,B,F,G6,F2)
     => ( filterlim(A,C,G,H10,F2)
       => filterlim(A,product_prod(B,C),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_un(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),F),G),prod_filter(B,C,G6,H10),F2) ) ) ).

% filterlim_Pair
tff(fact_5104_filterlim__If,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),G6: filter(B),F2: filter(A),P: fun(A,bool),G: fun(A,B)] :
      ( filterlim(A,B,F,G6,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F2),principal(A,aa(fun(A,bool),set(A),collect(A),P))))
     => ( filterlim(A,B,G,G6,aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F2),principal(A,aa(fun(A,bool),set(A),collect(A),aTP_Lamp_od(fun(A,bool),fun(A,bool),P)))))
       => filterlim(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,bool),fun(fun(A,B),fun(A,B)),aTP_Lamp_uo(fun(A,B),fun(fun(A,bool),fun(fun(A,B),fun(A,B))),F),P),G),G6,F2) ) ) ).

% filterlim_If
tff(fact_5105_map__conv__bind__option,axiom,
    ! [A: $tType,B: $tType,F: fun(B,A),X: option(B)] : ( aa(option(B),option(A),map_option(B,A,F),X) = bind(B,A,X,aa(fun(B,A),fun(B,option(A)),aa(fun(A,option(A)),fun(fun(B,A),fun(B,option(A))),comp(A,option(A),B),some(A)),F)) ) ).

% map_conv_bind_option
tff(fact_5106_Random__Pred_Ounion__def,axiom,
    ! [A: $tType,R12: fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),R23: fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),X3: product_prod(code_natural,code_natural)] : ( random_union(A,R12,R23,X3) = aa(product_prod(pred(A),product_prod(code_natural,code_natural)),product_prod(pred(A),product_prod(code_natural,code_natural)),aa(fun(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))),fun(product_prod(pred(A),product_prod(code_natural,code_natural)),product_prod(pred(A),product_prod(code_natural,code_natural))),product_case_prod(pred(A),product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),aTP_Lamp_uq(fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),fun(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))),R23)),aa(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)),R12,X3)) ) ).

% Random_Pred.union_def
tff(fact_5107_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F: fun(B,A),X: B,A4: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,X),A4)),S2))
       => ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( sorted8670434370408473282of_set(A,B,Less_eq,F,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))) = remove1(B,X,sorted8670434370408473282of_set(A,B,Less_eq,F,A4)) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
tff(fact_5108_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F: fun(B,A)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F)
     => ( sorted8670434370408473282of_set(A,B,Less_eq,F,bot_bot(set(B))) = nil(B) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
tff(fact_5109_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F: fun(B,A),A4: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),A4),S2))
       => ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( ( sorted8670434370408473282of_set(A,B,Less_eq,F,A4) = nil(B) )
          <=> ( A4 = bot_bot(set(B)) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
tff(fact_5110_bind__map__option,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(C,B),X: option(C),G: fun(B,option(A))] : ( bind(B,A,aa(option(C),option(B),map_option(C,B,F),X),G) = bind(C,A,X,aa(fun(C,B),fun(C,option(A)),aa(fun(B,option(A)),fun(fun(C,B),fun(C,option(A))),comp(B,option(A),C),G),F)) ) ).

% bind_map_option
tff(fact_5111_map__option__bind,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(B,A),X: option(C),G: fun(C,option(B))] : ( aa(option(B),option(A),map_option(B,A,F),bind(C,B,X,G)) = bind(C,A,X,aa(fun(C,option(B)),fun(C,option(A)),aa(fun(option(B),option(A)),fun(fun(C,option(B)),fun(C,option(A))),comp(option(B),option(A),C),map_option(B,A,F)),G)) ) ).

% map_option_bind
tff(fact_5112_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F: fun(B,A),X: B,A4: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F)
     => ( pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,X),A4)),S2))
       => ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( sorted8670434370408473282of_set(A,B,Less_eq,F,aa(set(B),set(B),insert2(B,X),A4)) = aa(list(B),list(B),insort_key(A,B,Less_eq,F,X),sorted8670434370408473282of_set(A,B,Less_eq,F,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
tff(fact_5113_Random__Pred_Oempty__def,axiom,
    ! [A: $tType] : ( random_empty(A) = aa(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),product_Pair(pred(A),product_prod(code_natural,code_natural)),bot_bot(pred(A))) ) ).

% Random_Pred.empty_def
tff(fact_5114_Random__Pred_Obind__def,axiom,
    ! [B: $tType,A: $tType,R: fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),F: fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),X3: product_prod(code_natural,code_natural)] : ( aa(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)),random_bind(A,B,R,F),X3) = aa(product_prod(pred(A),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(fun(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(product_prod(pred(A),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural))),product_case_prod(pred(A),product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aTP_Lamp_ut(fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),F)),aa(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)),R,X3)) ) ).

% Random_Pred.bind_def
tff(fact_5115_bottom__bind,axiom,
    ! [B: $tType,A: $tType,P: fun(B,pred(A))] : ( bind2(B,A,bot_bot(pred(B)),P) = bot_bot(pred(A)) ) ).

% bottom_bind
tff(fact_5116_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),S2: set(B),F: fun(B,A),X: B,Y: B] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F)
     => ( pp(member(B,X,S2))
       => ( pp(member(B,Y,S2))
         => ( aa(fun(list(B),list(B)),fun(list(B),list(B)),aa(fun(list(B),list(B)),fun(fun(list(B),list(B)),fun(list(B),list(B))),comp(list(B),list(B),list(B)),insort_key(A,B,Less_eq,F,Y)),insort_key(A,B,Less_eq,F,X)) = aa(fun(list(B),list(B)),fun(list(B),list(B)),aa(fun(list(B),list(B)),fun(fun(list(B),list(B)),fun(list(B),list(B))),comp(list(B),list(B),list(B)),insort_key(A,B,Less_eq,F,X)),insort_key(A,B,Less_eq,F,Y)) ) ) ) ) ).

% folding_insort_key.insort_key_commute
tff(fact_5117_Random__Pred_Omap__def,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),P: fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))] : ( random_map(A,B,F,P) = random_bind(A,B,P,aa(fun(A,B),fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),aa(fun(B,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(fun(A,B),fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))))),comp(B,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),A),random_single(B)),F)) ) ).

% Random_Pred.map_def
tff(fact_5118_set__bind__option,axiom,
    ! [A: $tType,B: $tType,X: option(B),F: fun(B,option(A))] : ( aa(option(A),set(A),set_option(A),bind(B,A,X,F)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image2(B,set(A),aa(fun(B,option(A)),fun(B,set(A)),aa(fun(option(A),set(A)),fun(fun(B,option(A)),fun(B,set(A))),comp(option(A),set(A),B),set_option(A)),F)),aa(option(B),set(B),set_option(B),X))) ) ).

% set_bind_option
tff(fact_5119_singleton__sup,axiom,
    ! [A: $tType,A4: pred(A),Default: fun(product_unit,A),B3: pred(A)] :
      ( ( ( A4 = bot_bot(pred(A)) )
       => ( singleton(A,Default,aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),sup_sup(pred(A)),A4),B3)) = singleton(A,Default,B3) ) )
      & ( ( A4 != bot_bot(pred(A)) )
       => ( ( ( B3 = bot_bot(pred(A)) )
           => ( singleton(A,Default,aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),sup_sup(pred(A)),A4),B3)) = singleton(A,Default,A4) ) )
          & ( ( B3 != bot_bot(pred(A)) )
           => ( ( ( singleton(A,Default,A4) = singleton(A,Default,B3) )
               => ( singleton(A,Default,aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),sup_sup(pred(A)),A4),B3)) = singleton(A,Default,A4) ) )
              & ( ( singleton(A,Default,A4) != singleton(A,Default,B3) )
               => ( singleton(A,Default,aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),sup_sup(pred(A)),A4),B3)) = aa(product_unit,A,Default,product_Unity) ) ) ) ) ) ) ) ).

% singleton_sup
tff(fact_5120_set__empty__eq,axiom,
    ! [A: $tType,Xo: option(A)] :
      ( ( aa(option(A),set(A),set_option(A),Xo) = bot_bot(set(A)) )
    <=> ( Xo = none(A) ) ) ).

% set_empty_eq
tff(fact_5121_option_Osimps_I14_J,axiom,
    ! [A: $tType] : ( aa(option(A),set(A),set_option(A),none(A)) = bot_bot(set(A)) ) ).

% option.simps(14)
tff(fact_5122_singleton__bot,axiom,
    ! [A: $tType,Default: fun(product_unit,A)] : ( singleton(A,Default,bot_bot(pred(A))) = aa(product_unit,A,Default,product_Unity) ) ).

% singleton_bot
tff(fact_5123_option_Osimps_I15_J,axiom,
    ! [A: $tType,X22: A] : ( aa(option(A),set(A),set_option(A),aa(A,option(A),some(A),X22)) = aa(set(A),set(A),insert2(A,X22),bot_bot(set(A))) ) ).

% option.simps(15)
tff(fact_5124_singleton__sup__aux,axiom,
    ! [A: $tType,A4: pred(A),Default: fun(product_unit,A),B3: pred(A)] :
      ( ( ( A4 = bot_bot(pred(A)) )
       => ( singleton(A,Default,aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),sup_sup(pred(A)),A4),B3)) = singleton(A,Default,B3) ) )
      & ( ( A4 != bot_bot(pred(A)) )
       => ( ( ( B3 = bot_bot(pred(A)) )
           => ( singleton(A,Default,aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),sup_sup(pred(A)),A4),B3)) = singleton(A,Default,A4) ) )
          & ( ( B3 != bot_bot(pred(A)) )
           => ( singleton(A,Default,aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),sup_sup(pred(A)),A4),B3)) = singleton(A,Default,aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),sup_sup(pred(A)),aa(A,pred(A),single(A),singleton(A,Default,A4))),aa(A,pred(A),single(A),singleton(A,Default,B3)))) ) ) ) ) ) ).

% singleton_sup_aux
tff(fact_5125_Random__Pred_Osingle__def,axiom,
    ! [A: $tType,X: A] : ( aa(A,fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),random_single(A),X) = aa(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),product_Pair(pred(A),product_prod(code_natural,code_natural)),aa(A,pred(A),single(A),X)) ) ).

% Random_Pred.single_def
tff(fact_5126_mult__one__div__unit__factor,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),divide_divide(A,one_one(A),unit_f5069060285200089521factor(A,B2))) = divide_divide(A,A3,unit_f5069060285200089521factor(A,B2)) ) ) ).

% mult_one_div_unit_factor
tff(fact_5127_unit__factor__1,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ( unit_f5069060285200089521factor(A,one_one(A)) = one_one(A) ) ) ).

% unit_factor_1
tff(fact_5128_inv__unit__factor__eq__0__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A] :
          ( ( divide_divide(A,one_one(A),unit_f5069060285200089521factor(A,A3)) = zero_zero(A) )
        <=> ( A3 = zero_zero(A) ) ) ) ).

% inv_unit_factor_eq_0_iff
tff(fact_5129_unit__factor__mult__unit__left,axiom,
    ! [A: $tType] :
      ( semido2269285787275462019factor(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),unit_f5069060285200089521factor(A,B2)) ) ) ) ).

% unit_factor_mult_unit_left
tff(fact_5130_unit__factor__mult__unit__right,axiom,
    ! [A: $tType] :
      ( semido2269285787275462019factor(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)) = aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,B2)),A3) ) ) ) ).

% unit_factor_mult_unit_right
tff(fact_5131_unit__factor__mult,axiom,
    ! [A: $tType] :
      ( normal6328177297339901930cative(A)
     => ! [A3: A,B2: A] : ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,A3)),unit_f5069060285200089521factor(A,B2)) ) ) ).

% unit_factor_mult
tff(fact_5132_unit__pred__cases,axiom,
    ! [P: fun(pred(product_unit),bool),Q: pred(product_unit)] :
      ( pp(aa(pred(product_unit),bool,P,bot_bot(pred(product_unit))))
     => ( pp(aa(pred(product_unit),bool,P,aa(product_unit,pred(product_unit),single(product_unit),product_Unity)))
       => pp(aa(pred(product_unit),bool,P,Q)) ) ) ).

% unit_pred_cases
tff(fact_5133_single__not__bot,axiom,
    ! [A: $tType,X: A] : ( aa(A,pred(A),single(A),X) != bot_bot(pred(A)) ) ).

% single_not_bot
tff(fact_5134_is__unit__unit__factor,axiom,
    ! [A: $tType] :
      ( semido2269285787275462019factor(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( unit_f5069060285200089521factor(A,A3) = A3 ) ) ) ).

% is_unit_unit_factor
tff(fact_5135_gcd__mult__distrib,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [K: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),K),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),K),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),K),B2))),unit_f5069060285200089521factor(A,K)) ) ) ).

% gcd_mult_distrib
tff(fact_5136_mult__gcd__right,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))),unit_f5069060285200089521factor(A,C2)) ) ) ).

% mult_gcd_right
tff(fact_5137_mult__gcd__left,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,C2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ).

% mult_gcd_left
tff(fact_5138_unit__factor__is__unit,axiom,
    ! [A: $tType] :
      ( semido2269285787275462019factor(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => pp(dvd_dvd(A,unit_f5069060285200089521factor(A,A3),one_one(A))) ) ) ).

% unit_factor_is_unit
tff(fact_5139_unit__factor__gcd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( ( ( ( A3 = zero_zero(A) )
              & ( B2 = zero_zero(A) ) )
           => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) = zero_zero(A) ) )
          & ( ~ ( ( A3 = zero_zero(A) )
                & ( B2 = zero_zero(A) ) )
           => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) = one_one(A) ) ) ) ) ).

% unit_factor_gcd
tff(fact_5140_coprime__crossproduct_H,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [B2: A,D2: A,A3: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( unit_f5069060285200089521factor(A,B2) = unit_f5069060285200089521factor(A,D2) )
           => ( algebr8660921524188924756oprime(A,A3,B2)
             => ( algebr8660921524188924756oprime(A,C2,D2)
               => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A3),D2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
                <=> ( ( A3 = C2 )
                    & ( B2 = D2 ) ) ) ) ) ) ) ) ).

% coprime_crossproduct'
tff(fact_5141_unit__factor__Gcd,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: set(A)] :
          ( ( ( gcd_Gcd(A,A4) = zero_zero(A) )
           => ( unit_f5069060285200089521factor(A,gcd_Gcd(A,A4)) = zero_zero(A) ) )
          & ( ( gcd_Gcd(A,A4) != zero_zero(A) )
           => ( unit_f5069060285200089521factor(A,gcd_Gcd(A,A4)) = one_one(A) ) ) ) ) ).

% unit_factor_Gcd
tff(fact_5142_Random__Pred_ORandom__def,axiom,
    ! [A: $tType,G: fun(product_prod(code_natural,code_natural),product_prod(product_prod(A,fun(product_unit,code_term)),product_prod(code_natural,code_natural)))] : ( random_Random(A,G) = product_scomp(product_prod(code_natural,code_natural),product_prod(A,fun(product_unit,code_term)),product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)),G,aa(fun(product_prod(A,fun(product_unit,code_term)),pred(A)),fun(product_prod(A,fun(product_unit,code_term)),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))),aa(fun(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))),fun(fun(product_prod(A,fun(product_unit,code_term)),pred(A)),fun(product_prod(A,fun(product_unit,code_term)),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))))),comp(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),product_prod(A,fun(product_unit,code_term))),product_Pair(pred(A),product_prod(code_natural,code_natural))),aa(fun(product_prod(A,fun(product_unit,code_term)),A),fun(product_prod(A,fun(product_unit,code_term)),pred(A)),aa(fun(A,pred(A)),fun(fun(product_prod(A,fun(product_unit,code_term)),A),fun(product_prod(A,fun(product_unit,code_term)),pred(A))),comp(A,pred(A),product_prod(A,fun(product_unit,code_term))),single(A)),product_fst(A,fun(product_unit,code_term))))) ) ).

% Random_Pred.Random_def
tff(fact_5143_pred__of__set__set__foldr__sup,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(set(A),pred(A),pred_of_set(A),aa(list(A),set(A),set2(A),Xs)) = aa(pred(A),pred(A),foldr(pred(A),pred(A),sup_sup(pred(A)),aa(list(A),list(pred(A)),map(A,pred(A),single(A)),Xs)),bot_bot(pred(A))) ) ).

% pred_of_set_set_foldr_sup
tff(fact_5144_pred__of__set__set__fold__sup,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(set(A),pred(A),pred_of_set(A),aa(list(A),set(A),set2(A),Xs)) = aa(pred(A),pred(A),fold(pred(A),pred(A),sup_sup(pred(A)),aa(list(A),list(pred(A)),map(A,pred(A),single(A)),Xs)),bot_bot(pred(A))) ) ).

% pred_of_set_set_fold_sup
tff(fact_5145_pred__of__set__fold__sup,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(aa(set(A),bool,finite_finite(A),A4))
     => ( aa(set(A),pred(A),pred_of_set(A),A4) = finite_fold(pred(A),pred(A),sup_sup(pred(A)),bot_bot(pred(A)),aa(set(A),set(pred(A)),image2(A,pred(A),single(A)),A4)) ) ) ).

% pred_of_set_fold_sup
tff(fact_5146_if__pred__eq,axiom,
    ! [B2: bool] :
      ( ( pp(B2)
       => ( if_pred(B2) = aa(product_unit,pred(product_unit),single(product_unit),product_Unity) ) )
      & ( ~ pp(B2)
       => ( if_pred(B2) = bot_bot(pred(product_unit)) ) ) ) ).

% if_pred_eq
tff(fact_5147_Predicate_Omap__def,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),P: pred(A)] : ( aa(pred(A),pred(B),map2(A,B,F),P) = bind2(A,B,P,aa(fun(A,B),fun(A,pred(B)),aa(fun(B,pred(B)),fun(fun(A,B),fun(A,pred(B))),comp(B,pred(B),A),single(B)),F)) ) ).

% Predicate.map_def
tff(fact_5148_contains__pred__def,axiom,
    ! [A: $tType,X: A,A4: set(A)] :
      ( ( pp(member(A,X,A4))
       => ( predic7144156976422707464s_pred(A,A4,X) = aa(product_unit,pred(product_unit),single(product_unit),product_Unity) ) )
      & ( ~ pp(member(A,X,A4))
       => ( predic7144156976422707464s_pred(A,A4,X) = bot_bot(pred(product_unit)) ) ) ) ).

% contains_pred_def
tff(fact_5149_Predicate_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(B,C),G: fun(A,B)] : ( aa(fun(pred(A),pred(B)),fun(pred(A),pred(C)),aa(fun(pred(B),pred(C)),fun(fun(pred(A),pred(B)),fun(pred(A),pred(C))),comp(pred(B),pred(C),pred(A)),map2(B,C,F)),map2(A,B,G)) = map2(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),G)) ) ).

% Predicate.map.comp
tff(fact_5150_Predicate_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(B,C),G: fun(A,B),Pred: pred(A)] : ( aa(pred(B),pred(C),map2(B,C,F),aa(pred(A),pred(B),map2(A,B,G),Pred)) = aa(pred(A),pred(C),map2(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),F),G)),Pred) ) ).

% Predicate.map.compositionality
tff(fact_5151_Gcd__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde6485984586167503788ce_set(A,gcd_gcd(A),zero_zero(A),one_one(A),normal6383669964737779283malize(A)) ) ).

% Gcd_fin.bounded_quasi_semilattice_set_axioms
tff(fact_5152_Lcm__no__units,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: set(A)] : ( gcd_Lcm(A,A4) = gcd_Lcm(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_uu(A,bool)))) ) ) ).

% Lcm_no_units
tff(fact_5153_Heap__lub__def,axiom,
    ! [A: $tType] : ( heap_Time_Heap_lub(A) = partial_img_lub(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_execute(A),heap_Time_Heap2(A),partial_fun_lub(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit),partial_flat_lub(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),none(product_prod(A,product_prod(heap_ext(product_unit),nat)))))) ) ).

% Heap_lub_def
tff(fact_5154_normalize__mult__normalize__right,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A,B2: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,normal6383669964737779283malize(A),B2))) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) ) ) ).

% normalize_mult_normalize_right
tff(fact_5155_normalize__mult__normalize__left,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A,B2: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A3)),B2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) ) ) ).

% normalize_mult_normalize_left
tff(fact_5156_gcd_Onormalize__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(A,A,normal6383669964737779283malize(A),one_one(A)) = one_one(A) ) ) ).

% gcd.normalize_bottom
tff(fact_5157_normalize__1,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ( aa(A,A,normal6383669964737779283malize(A),one_one(A)) = one_one(A) ) ) ).

% normalize_1
tff(fact_5158_Lcm__empty,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Lcm(A,bot_bot(set(A))) = one_one(A) ) ) ).

% Lcm_empty
tff(fact_5159_Lcm__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: set(A)] :
          ( ( gcd_Lcm(A,A4) = one_one(A) )
        <=> ! [X4: A] :
              ( pp(member(A,X4,A4))
             => pp(dvd_dvd(A,X4,one_one(A))) ) ) ) ).

% Lcm_1_iff
tff(fact_5160_normalize__mult__unit__factor,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A3)),unit_f5069060285200089521factor(A,A3)) = A3 ) ) ).

% normalize_mult_unit_factor
tff(fact_5161_unit__factor__mult__normalize,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,A3)),aa(A,A,normal6383669964737779283malize(A),A3)) = A3 ) ) ).

% unit_factor_mult_normalize
tff(fact_5162_normalize__mult__unit__right,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [B2: A,A3: A] :
          ( pp(dvd_dvd(A,B2,one_one(A)))
         => ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,normal6383669964737779283malize(A),A3) ) ) ) ).

% normalize_mult_unit_right
tff(fact_5163_normalize__mult__unit__left,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A,B2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,normal6383669964737779283malize(A),B2) ) ) ) ).

% normalize_mult_unit_left
tff(fact_5164_normalize__unit__factor,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( aa(A,A,normal6383669964737779283malize(A),unit_f5069060285200089521factor(A,A3)) = one_one(A) ) ) ) ).

% normalize_unit_factor
tff(fact_5165_unit__factor__normalize,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A] :
          ( ( A3 != zero_zero(A) )
         => ( unit_f5069060285200089521factor(A,aa(A,A,normal6383669964737779283malize(A),A3)) = one_one(A) ) ) ) ).

% unit_factor_normalize
tff(fact_5166_Lcm__singleton,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: A] : ( gcd_Lcm(A,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) = aa(A,A,normal6383669964737779283malize(A),A3) ) ) ).

% Lcm_singleton
tff(fact_5167_normalize__div,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A] : ( divide_divide(A,aa(A,A,normal6383669964737779283malize(A),A3),A3) = divide_divide(A,one_one(A),unit_f5069060285200089521factor(A,A3)) ) ) ).

% normalize_div
tff(fact_5168_Gcd__singleton,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: A] : ( gcd_Gcd(A,aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))) = aa(A,A,normal6383669964737779283malize(A),A3) ) ) ).

% Gcd_singleton
tff(fact_5169_Lcm__mult,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: set(A),C2: A] :
          ( ( A4 != bot_bot(set(A)) )
         => ( gcd_Lcm(A,aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),C2)),A4)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),gcd_Lcm(A,A4))) ) ) ) ).

% Lcm_mult
tff(fact_5170_normalize__mult,axiom,
    ! [A: $tType] :
      ( normal6328177297339901930cative(A)
     => ! [A3: A,B2: A] : ( aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A3)),aa(A,A,normal6383669964737779283malize(A),B2)) ) ) ).

% normalize_mult
tff(fact_5171_associated__unit,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A3) = aa(A,A,normal6383669964737779283malize(A),B2) )
         => ( pp(dvd_dvd(A,A3,one_one(A)))
           => pp(dvd_dvd(A,B2,one_one(A))) ) ) ) ).

% associated_unit
tff(fact_5172_normalize__1__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A3) = one_one(A) )
        <=> pp(dvd_dvd(A,A3,one_one(A))) ) ) ).

% normalize_1_iff
tff(fact_5173_is__unit__normalize,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,normal6383669964737779283malize(A),A3) = one_one(A) ) ) ) ).

% is_unit_normalize
tff(fact_5174_normalize__idem__imp__is__unit__iff,axiom,
    ! [A: $tType] :
      ( normal8620421768224518004emidom(A)
     => ! [A3: A] :
          ( ( aa(A,A,normal6383669964737779283malize(A),A3) = A3 )
         => ( pp(dvd_dvd(A,A3,one_one(A)))
          <=> ( A3 = one_one(A) ) ) ) ) ).

% normalize_idem_imp_is_unit_iff
tff(fact_5175_gcd__mult__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2))) ) ) ).

% gcd_mult_left
tff(fact_5176_gcd__mult__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),A3)),C2)) ) ) ).

% gcd_mult_right
tff(fact_5177_gcd__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),C2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% gcd_mult_distrib'
tff(fact_5178_coprime__crossproduct,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,D2: A,B2: A,C2: A] :
          ( algebr8660921524188924756oprime(A,A3,D2)
         => ( algebr8660921524188924756oprime(A,B2,C2)
           => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A3)),aa(A,A,normal6383669964737779283malize(A),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),B2)),aa(A,A,normal6383669964737779283malize(A),D2)) )
            <=> ( ( aa(A,A,normal6383669964737779283malize(A),A3) = aa(A,A,normal6383669964737779283malize(A),B2) )
                & ( aa(A,A,normal6383669964737779283malize(A),C2) = aa(A,A,normal6383669964737779283malize(A),D2) ) ) ) ) ) ) ).

% coprime_crossproduct
tff(fact_5179_Lcm__coprime,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: set(A)] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( ( A4 != bot_bot(set(A)) )
           => ( ! [A8: A,B5: A] :
                  ( pp(member(A,A8,A4))
                 => ( pp(member(A,B5,A4))
                   => ( ( A8 != B5 )
                     => algebr8660921524188924756oprime(A,A8,B5) ) ) )
             => ( gcd_Lcm(A,A4) = aa(A,A,normal6383669964737779283malize(A),aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7121269368397514597t_prod(A,A),aTP_Lamp_uv(A,A)),A4)) ) ) ) ) ) ).

% Lcm_coprime
tff(fact_5180_Lcm__nat__empty,axiom,
    gcd_Lcm(nat,bot_bot(set(nat))) = one_one(nat) ).

% Lcm_nat_empty
tff(fact_5181_Gcd__mult,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [C2: A,A4: set(A)] : ( gcd_Gcd(A,aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),C2)),A4)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),gcd_Gcd(A,A4))) ) ) ).

% Gcd_mult
tff(fact_5182_Lcm__int__def,axiom,
    ! [K5: set(int)] : ( gcd_Lcm(int,K5) = aa(nat,int,semiring_1_of_nat(int),gcd_Lcm(nat,aa(set(int),set(nat),image2(int,nat,aa(fun(int,int),fun(int,nat),aa(fun(int,nat),fun(fun(int,int),fun(int,nat)),comp(int,nat,int),nat2),abs_abs(int))),K5))) ) ).

% Lcm_int_def
tff(fact_5183_unit__factor__Lcm,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A4: set(A)] :
          ( ( ( gcd_Lcm(A,A4) = zero_zero(A) )
           => ( unit_f5069060285200089521factor(A,gcd_Lcm(A,A4)) = zero_zero(A) ) )
          & ( ( gcd_Lcm(A,A4) != zero_zero(A) )
           => ( unit_f5069060285200089521factor(A,gcd_Lcm(A,A4)) = one_one(A) ) ) ) ) ).

% unit_factor_Lcm
tff(fact_5184_Gcd__fin__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: set(A),B2: A] :
          ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),B2)),A4)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(set(A),A,semiring_gcd_Gcd_fin(A),A4))) ) ) ) ).

% Gcd_fin_mult
tff(fact_5185_gcd_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde8507323023520639062attice(A,gcd_gcd(A),zero_zero(A),one_one(A),normal6383669964737779283malize(A)) ) ).

% gcd.bounded_quasi_semilattice_axioms
tff(fact_5186_Lcm__fin__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: set(A),B2: A] :
          ( ( A4 != bot_bot(set(A)) )
         => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),image2(A,A,aa(A,fun(A,A),times_times(A),B2)),A4)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(set(A),A,semiring_gcd_Lcm_fin(A),A4))) ) ) ) ).

% Lcm_fin_mult
tff(fact_5187_gcd__lcm,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( ( A3 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2) = aa(A,A,normal6383669964737779283malize(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2))) ) ) ) ) ).

% gcd_lcm
tff(fact_5188_lcm__eq__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2) = one_one(A) )
        <=> ( pp(dvd_dvd(A,A3,one_one(A)))
            & pp(dvd_dvd(A,B2,one_one(A))) ) ) ) ).

% lcm_eq_1_iff
tff(fact_5189_lcm_Otop__left__normalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),one_one(A)),A3) = aa(A,A,normal6383669964737779283malize(A),A3) ) ) ).

% lcm.top_left_normalize
tff(fact_5190_lcm_Otop__right__normalize,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),one_one(A)) = aa(A,A,normal6383669964737779283malize(A),A3) ) ) ).

% lcm.top_right_normalize
tff(fact_5191_Lcm__fin_Oempty,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),bot_bot(set(A))) = one_one(A) ) ) ).

% Lcm_fin.empty
tff(fact_5192_is__unit__Lcm__fin__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: set(A)] :
          ( pp(dvd_dvd(A,aa(set(A),A,semiring_gcd_Lcm_fin(A),A4),one_one(A)))
        <=> ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A4) = one_one(A) ) ) ) ).

% is_unit_Lcm_fin_iff
tff(fact_5193_unit__factor__lcm,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( ( ( ( A3 = zero_zero(A) )
              | ( B2 = zero_zero(A) ) )
           => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2)) = zero_zero(A) ) )
          & ( ~ ( ( A3 = zero_zero(A) )
                | ( B2 = zero_zero(A) ) )
           => ( unit_f5069060285200089521factor(A,aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2)) = one_one(A) ) ) ) ) ).

% unit_factor_lcm
tff(fact_5194_lcm__mult__gcd,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A3)),aa(A,A,normal6383669964737779283malize(A),B2)) ) ) ).

% lcm_mult_gcd
tff(fact_5195_gcd__mult__lcm,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),A3)),aa(A,A,normal6383669964737779283malize(A),B2)) ) ) ).

% gcd_mult_lcm
tff(fact_5196_Lcm__2,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: A,B2: A] : ( gcd_Lcm(A,aa(set(A),set(A),insert2(A,A3),aa(set(A),set(A),insert2(A,B2),bot_bot(set(A))))) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2) ) ) ).

% Lcm_2
tff(fact_5197_lcm_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde8507323023520639062attice(A,gcd_lcm(A),one_one(A),zero_zero(A),normal6383669964737779283malize(A)) ) ).

% lcm.bounded_quasi_semilattice_axioms
tff(fact_5198_Lcm__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,A4: set(A)] :
          ( pp(member(A,A3,A4))
         => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A4) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))) ) ) ) ).

% Lcm_fin.remove
tff(fact_5199_Lcm__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,A4: set(A)] : ( aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),insert2(A,A3),A4)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,A3),bot_bot(set(A)))))) ) ) ).

% Lcm_fin.insert_remove
tff(fact_5200_Lcm__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Xs: list(A)] : ( aa(set(A),A,semiring_gcd_Lcm_fin(A),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,gcd_lcm(A),Xs),one_one(A)) ) ) ).

% Lcm_fin.set_eq_fold
tff(fact_5201_Lcm__fin__def,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( semiring_gcd_Lcm_fin(A) = bounde2362111253966948842tice_F(A,gcd_lcm(A),one_one(A),zero_zero(A)) ) ) ).

% Lcm_fin_def
tff(fact_5202_lcm__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,normal6383669964737779283malize(A),C2)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% lcm_mult_distrib'
tff(fact_5203_lcm__mult__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),A3)),C2)) ) ) ).

% lcm_mult_right
tff(fact_5204_lcm__mult__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2))) ) ) ).

% lcm_mult_left
tff(fact_5205_Lcm__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: set(A)] :
          ( ( pp(aa(set(A),bool,finite_finite(A),A4))
           => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A4) = finite_fold(A,A,gcd_lcm(A),one_one(A),A4) ) )
          & ( ~ pp(aa(set(A),bool,finite_finite(A),A4))
           => ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A4) = zero_zero(A) ) ) ) ) ).

% Lcm_fin.eq_fold
tff(fact_5206_lcm__mult__distrib,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [K: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),K),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),K),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),K),B2))),unit_f5069060285200089521factor(A,K)) ) ) ).

% lcm_mult_distrib
tff(fact_5207_mult__lcm__right,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A3: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))),unit_f5069060285200089521factor(A,C2)) ) ) ).

% mult_lcm_right
tff(fact_5208_mult__lcm__left,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [C2: A,A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),unit_f5069060285200089521factor(A,C2)),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))) ) ) ).

% mult_lcm_left
tff(fact_5209_Lcm__in__lcm__closed__set__nat,axiom,
    ! [M: set(nat)] :
      ( pp(aa(set(nat),bool,finite_finite(nat),M))
     => ( ( M != bot_bot(set(nat)) )
       => ( ! [M5: nat,N3: nat] :
              ( pp(member(nat,M5,M))
             => ( pp(member(nat,N3,M))
               => pp(member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M5),N3),M)) ) )
         => pp(member(nat,gcd_Lcm(nat,M),M)) ) ) ) ).

% Lcm_in_lcm_closed_set_nat
tff(fact_5210_lcm__mult__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2) ) ) ) ).

% lcm_mult_unit2
tff(fact_5211_lcm__mult__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A3)),C2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2) ) ) ) ).

% lcm_mult_unit1
tff(fact_5212_lcm__div__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),divide_divide(A,C2,A3)) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2) ) ) ) ).

% lcm_div_unit2
tff(fact_5213_lcm__div__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A,C2: A] :
          ( pp(dvd_dvd(A,A3,one_one(A)))
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),divide_divide(A,B2,A3)),C2) = aa(A,A,aa(A,fun(A,A),gcd_lcm(A),B2),C2) ) ) ) ).

% lcm_div_unit1
tff(fact_5214_lcm__gcd__prod,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2)) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) ) ) ).

% lcm_gcd_prod
tff(fact_5215_lcm__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A3,B2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2) = aa(A,A,normal6383669964737779283malize(A),aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2)) ) ) ) ).

% lcm_coprime
tff(fact_5216_Lcm__fin__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A4: set(A)] :
          ( ( aa(set(A),A,semiring_gcd_Lcm_fin(A),A4) = one_one(A) )
        <=> ( ! [X4: A] :
                ( pp(member(A,X4,A4))
               => pp(dvd_dvd(A,X4,one_one(A))) )
            & pp(aa(set(A),bool,finite_finite(A),A4)) ) ) ) ).

% Lcm_fin_1_iff
tff(fact_5217_lcm__gcd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_lcm(A),A3),B2) = aa(A,A,normal6383669964737779283malize(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A3),B2))) ) ) ).

% lcm_gcd
tff(fact_5218_Lcm__set__eq__fold,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Xs: list(A)] : ( gcd_Lcm(A,aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,gcd_lcm(A),Xs),one_one(A)) ) ) ).

% Lcm_set_eq_fold
tff(fact_5219_Lcm__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => bounde6485984586167503788ce_set(A,gcd_lcm(A),one_one(A),zero_zero(A),normal6383669964737779283malize(A)) ) ).

% Lcm_fin.bounded_quasi_semilattice_set_axioms
tff(fact_5220_Lcm__eq__Max__nat,axiom,
    ! [M: set(nat)] :
      ( pp(aa(set(nat),bool,finite_finite(nat),M))
     => ( ( M != bot_bot(set(nat)) )
       => ( ~ pp(member(nat,zero_zero(nat),M))
         => ( ! [M5: nat,N3: nat] :
                ( pp(member(nat,M5,M))
               => ( pp(member(nat,N3,M))
                 => pp(member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M5),N3),M)) ) )
           => ( gcd_Lcm(nat,M) = lattic643756798349783984er_Max(nat,M) ) ) ) ) ) ).

% Lcm_eq_Max_nat
tff(fact_5221_prod_Ocomm__monoid__list__set__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => groups4802862169904069756st_set(A,times_times(A),one_one(A)) ) ).

% prod.comm_monoid_list_set_axioms
tff(fact_5222_prod_H__def,axiom,
    ! [C: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ( groups1962203154675924110t_prod(C,A) = groups_comm_monoid_G(A,C,times_times(A),one_one(A)) ) ) ).

% prod'_def
tff(fact_5223_Gr__def,axiom,
    ! [B: $tType,A: $tType,A4: set(A),F: fun(A,B)] : ( bNF_Gr(A,B,A4,F) = aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,B),fun(product_prod(A,B),bool),aTP_Lamp_uw(set(A),fun(fun(A,B),fun(product_prod(A,B),bool)),A4),F)) ) ).

% Gr_def
tff(fact_5224_GrD1,axiom,
    ! [B: $tType,A: $tType,X: A,Fx: B,A4: set(A),F: fun(A,B)] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Fx),bNF_Gr(A,B,A4,F)))
     => pp(member(A,X,A4)) ) ).

% GrD1
tff(fact_5225_GrD2,axiom,
    ! [A: $tType,B: $tType,X: A,Fx: B,A4: set(A),F: fun(A,B)] :
      ( pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Fx),bNF_Gr(A,B,A4,F)))
     => ( aa(A,B,F,X) = Fx ) ) ).

% GrD2
tff(fact_5226_and_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => comm_monoid(A,bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% and.comm_monoid_axioms
tff(fact_5227_Heap_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F: fun(B,nat),G: fun(A,B)] : ( aa(fun(heap_Time_Heap(A),heap_Time_Heap(B)),fun(heap_Time_Heap(A),nat),aa(fun(heap_Time_Heap(B),nat),fun(fun(heap_Time_Heap(A),heap_Time_Heap(B)),fun(heap_Time_Heap(A),nat)),comp(heap_Time_Heap(B),nat,heap_Time_Heap(A)),heap_Time_size_Heap(B,F)),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),G)) = heap_Time_size_Heap(A,aa(fun(A,B),fun(A,nat),aa(fun(B,nat),fun(fun(A,B),fun(A,nat)),comp(B,nat,A),F),G)) ) ).

% Heap.size_gen_o_map
tff(fact_5228_max_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semilattice_order(A,ord_max(A),aTP_Lamp_ux(A,fun(A,bool)),aTP_Lamp_uy(A,fun(A,bool))) ) ).

% max.semilattice_order_axioms
tff(fact_5229_Heap_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: fun(B,C),F: fun(A,B),V: heap_Time_Heap(A)] : ( aa(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),G),aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F),V)) = aa(heap_Time_Heap(A),heap_Time_Heap(C),aa(fun(A,C),fun(heap_Time_Heap(A),heap_Time_Heap(C)),heap_Time_map_Heap(A,C),aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),G),F)),V) ) ).

% Heap.map_comp
tff(fact_5230_Heap_Omap,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),X: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X)) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(fun(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),comp(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),map_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),product_map_prod(A,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),F,id(product_prod(heap_ext(product_unit),nat))))),X)) ) ).

% Heap.map
tff(fact_5231_Heap_Omap__ident,axiom,
    ! [A: $tType,T4: heap_Time_Heap(A)] : ( aa(heap_Time_Heap(A),heap_Time_Heap(A),aa(fun(A,A),fun(heap_Time_Heap(A),heap_Time_Heap(A)),heap_Time_map_Heap(A,A),aTP_Lamp_br(A,A)),T4) = T4 ) ).

% Heap.map_ident
tff(fact_5232_semilattice__order_Ostrict__coboundedI2,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B2: A,C2: A,A3: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B2),C2))
       => pp(aa(A,bool,aa(A,fun(A,bool),Less,aa(A,A,aa(A,fun(A,A),F,A3),B2)),C2)) ) ) ).

% semilattice_order.strict_coboundedI2
tff(fact_5233_semilattice__order_Ostrict__coboundedI1,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,C2: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),C2))
       => pp(aa(A,bool,aa(A,fun(A,bool),Less,aa(A,A,aa(A,fun(A,A),F,A3),B2)),C2)) ) ) ).

% semilattice_order.strict_coboundedI1
tff(fact_5234_semilattice__order_Ostrict__order__iff,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
      <=> ( ( A3 = aa(A,A,aa(A,fun(A,A),F,A3),B2) )
          & ( A3 != B2 ) ) ) ) ).

% semilattice_order.strict_order_iff
tff(fact_5235_semilattice__order_Ostrict__boundedE,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A,C2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),aa(A,A,aa(A,fun(A,A),F,B2),C2)))
       => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),C2)) ) ) ) ).

% semilattice_order.strict_boundedE
tff(fact_5236_semilattice__order_OcoboundedI2,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B2: A,C2: A,A3: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B2),C2))
       => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(A,A,aa(A,fun(A,A),F,A3),B2)),C2)) ) ) ).

% semilattice_order.coboundedI2
tff(fact_5237_semilattice__order_OcoboundedI1,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,C2: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),C2))
       => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(A,A,aa(A,fun(A,A),F,A3),B2)),C2)) ) ) ).

% semilattice_order.coboundedI1
tff(fact_5238_semilattice__order_Obounded__iff,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A,C2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),aa(A,A,aa(A,fun(A,A),F,B2),C2)))
      <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
          & pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),C2)) ) ) ) ).

% semilattice_order.bounded_iff
tff(fact_5239_semilattice__order_Oabsorb__iff2,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B2: A,A3: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B2),A3))
      <=> ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = B2 ) ) ) ).

% semilattice_order.absorb_iff2
tff(fact_5240_semilattice__order_Oabsorb__iff1,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
      <=> ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = A3 ) ) ) ).

% semilattice_order.absorb_iff1
tff(fact_5241_semilattice__order_Ocobounded2,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(A,A,aa(A,fun(A,A),F,A3),B2)),B2)) ) ).

% semilattice_order.cobounded2
tff(fact_5242_semilattice__order_Ocobounded1,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(A,A,aa(A,fun(A,A),F,A3),B2)),A3)) ) ).

% semilattice_order.cobounded1
tff(fact_5243_semilattice__order_Oorder__iff,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
      <=> ( A3 = aa(A,A,aa(A,fun(A,A),F,A3),B2) ) ) ) ).

% semilattice_order.order_iff
tff(fact_5244_semilattice__order_OboundedI,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A,C2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),aa(A,A,aa(A,fun(A,A),F,B2),C2))) ) ) ) ).

% semilattice_order.boundedI
tff(fact_5245_semilattice__order_OboundedE,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A,C2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),aa(A,A,aa(A,fun(A,A),F,B2),C2)))
       => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),C2)) ) ) ) ).

% semilattice_order.boundedE
tff(fact_5246_semilattice__order_Oabsorb4,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B2: A,A3: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B2),A3))
       => ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = B2 ) ) ) ).

% semilattice_order.absorb4
tff(fact_5247_semilattice__order_Oabsorb3,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
       => ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = A3 ) ) ) ).

% semilattice_order.absorb3
tff(fact_5248_semilattice__order_Oabsorb2,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),B2: A,A3: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B2),A3))
       => ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = B2 ) ) ) ).

% semilattice_order.absorb2
tff(fact_5249_semilattice__order_Oabsorb1,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
       => ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = A3 ) ) ) ).

% semilattice_order.absorb1
tff(fact_5250_semilattice__order_OorderI,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( ( A3 = aa(A,A,aa(A,fun(A,A),F,A3),B2) )
       => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2)) ) ) ).

% semilattice_order.orderI
tff(fact_5251_semilattice__order_OorderE,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
       => ( A3 = aa(A,A,aa(A,fun(A,A),F,A3),B2) ) ) ) ).

% semilattice_order.orderE
tff(fact_5252_semilattice__order_Omono,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,C2: A,B2: A,D2: A] :
      ( semilattice_order(A,F,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),C2))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B2),D2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,aa(A,A,aa(A,fun(A,A),F,A3),B2)),aa(A,A,aa(A,fun(A,A),F,C2),D2))) ) ) ) ).

% semilattice_order.mono
tff(fact_5253_comm__monoid_Ocomm__neutral,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,A3: A] :
      ( comm_monoid(A,F,Z2)
     => ( aa(A,A,aa(A,fun(A,A),F,A3),Z2) = A3 ) ) ).

% comm_monoid.comm_neutral
tff(fact_5254_semilattice__neutr__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semila1105856199041335345_order(A,F,Z2,Less_eq,Less)
     => semilattice_order(A,F,Less_eq,Less) ) ).

% semilattice_neutr_order.axioms(2)
tff(fact_5255_Heap_Omap__id,axiom,
    ! [A: $tType,T4: heap_Time_Heap(A)] : ( aa(heap_Time_Heap(A),heap_Time_Heap(A),aa(fun(A,A),fun(heap_Time_Heap(A),heap_Time_Heap(A)),heap_Time_map_Heap(A,A),id(A)),T4) = T4 ) ).

% Heap.map_id
tff(fact_5256_Heap_Omap__id0,axiom,
    ! [A: $tType] : ( aa(fun(A,A),fun(heap_Time_Heap(A),heap_Time_Heap(A)),heap_Time_map_Heap(A,A),id(A)) = id(heap_Time_Heap(A)) ) ).

% Heap.map_id0
tff(fact_5257_semilattice__neutr_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( semilattice_neutr(A,F,Z2)
     => comm_monoid(A,F,Z2) ) ).

% semilattice_neutr.axioms(2)
tff(fact_5258_add_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => comm_monoid(A,plus_plus(A),zero_zero(A)) ) ).

% add.comm_monoid_axioms
tff(fact_5259_mult_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => comm_monoid(A,times_times(A),one_one(A)) ) ).

% mult.comm_monoid_axioms
tff(fact_5260_Heap_Oinj__map,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] :
      ( inj_on(A,B,F,top_top(set(A)))
     => inj_on(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F),top_top(set(heap_Time_Heap(A)))) ) ).

% Heap.inj_map
tff(fact_5261_sup__bot_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => comm_monoid(A,sup_sup(A),bot_bot(A)) ) ).

% sup_bot.comm_monoid_axioms
tff(fact_5262_inf__top_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => comm_monoid(A,inf_inf(A),top_top(A)) ) ).

% inf_top.comm_monoid_axioms
tff(fact_5263_semilattice__neutr__order__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semila1105856199041335345_order(A,F,Z2,Less_eq,Less)
    <=> ( semilattice_neutr(A,F,Z2)
        & semilattice_order(A,F,Less_eq,Less) ) ) ).

% semilattice_neutr_order_def
tff(fact_5264_semilattice__neutr__order_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semilattice_neutr(A,F,Z2)
     => ( semilattice_order(A,F,Less_eq,Less)
       => semila1105856199041335345_order(A,F,Z2,Less_eq,Less) ) ) ).

% semilattice_neutr_order.intro
tff(fact_5265_inf_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => semilattice_order(A,inf_inf(A),ord_less_eq(A),ord_less(A)) ) ).

% inf.semilattice_order_axioms
tff(fact_5266_min_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semilattice_order(A,ord_min(A),ord_less_eq(A),ord_less(A)) ) ).

% min.semilattice_order_axioms
tff(fact_5267_sup_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => semilattice_order(A,sup_sup(A),aTP_Lamp_oh(A,fun(A,bool)),aTP_Lamp_oi(A,fun(A,bool))) ) ).

% sup.semilattice_order_axioms
tff(fact_5268_Heap_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),F: fun(A,B)] : ( aa(fun(heap_Time_Heap(A),heap_Time_Heap(B)),fun(heap_Time_Heap(A),C),aa(fun(heap_Time_Heap(B),C),fun(fun(heap_Time_Heap(A),heap_Time_Heap(B)),fun(heap_Time_Heap(A),C)),comp(heap_Time_Heap(B),C,heap_Time_Heap(A)),aa(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(B),C),heap_Time_rec_Heap(B,C),G)),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F)) = aa(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(A),C),heap_Time_rec_Heap(A,C),aa(fun(A,B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),aTP_Lamp_uz(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(A,B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C)),G),F)) ) ).

% Heap.rec_o_map
tff(fact_5269_prod__mset__def,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ( comm_m9189036328036947845d_mset(A) = comm_monoid_F(A,times_times(A),one_one(A)) ) ) ).

% prod_mset_def
tff(fact_5270_Heap_Oset,axiom,
    ! [A: $tType,X: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),set(set(A)),image2(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(A),aTP_Lamp_va(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(A))),aa(set(heap_ext(product_unit)),set(option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),image2(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),X),top_top(set(heap_ext(product_unit)))))) ) ).

% Heap.set
tff(fact_5271_Heap_Oset__intros,axiom,
    ! [A: $tType,Y: option(product_prod(A,product_prod(heap_ext(product_unit),nat))),X: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),Ya: product_prod(A,product_prod(heap_ext(product_unit),nat)),Yb2: A] :
      ( pp(member(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),Y,aa(set(heap_ext(product_unit)),set(option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),image2(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),X),top_top(set(heap_ext(product_unit))))))
     => ( pp(member(product_prod(A,product_prod(heap_ext(product_unit),nat)),Ya,aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(product_prod(A,product_prod(heap_ext(product_unit),nat))),set_option(product_prod(A,product_prod(heap_ext(product_unit),nat))),Y)))
       => ( pp(member(A,Yb2,aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),set(A),basic_fsts(A,product_prod(heap_ext(product_unit),nat)),Ya)))
         => pp(member(A,Yb2,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X)))) ) ) ) ).

% Heap.set_intros
tff(fact_5272_Heap_Oset__cases,axiom,
    ! [A: $tType,E2: A,A3: heap_Time_Heap(A)] :
      ( pp(member(A,E2,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),A3)))
     => ~ ! [Z3: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] :
            ( ( A3 = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),Z3) )
           => ! [Xa4: option(product_prod(A,product_prod(heap_ext(product_unit),nat)))] :
                ( pp(member(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),Xa4,aa(set(heap_ext(product_unit)),set(option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),image2(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),Z3),top_top(set(heap_ext(product_unit))))))
               => ! [Xb4: product_prod(A,product_prod(heap_ext(product_unit),nat))] :
                    ( pp(member(product_prod(A,product_prod(heap_ext(product_unit),nat)),Xb4,aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(product_prod(A,product_prod(heap_ext(product_unit),nat))),set_option(product_prod(A,product_prod(heap_ext(product_unit),nat))),Xa4)))
                   => ~ pp(member(A,E2,aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),set(A),basic_fsts(A,product_prod(heap_ext(product_unit),nat)),Xb4))) ) ) ) ) ).

% Heap.set_cases
tff(fact_5273_Heap_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X: heap_Time_Heap(A),Ya: heap_Time_Heap(A),F: fun(A,B),G: fun(A,B)] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( pp(member(A,Z3,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),Ya)))
           => ( aa(A,B,F,Z3) = aa(A,B,G,Z3) ) )
       => ( aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F),X) = aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),G),Ya) ) ) ) ).

% Heap.map_cong
tff(fact_5274_Heap_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X: heap_Time_Heap(A),F: fun(A,B),G: fun(A,B)] :
      ( ! [Z3: A] :
          ( pp(member(A,Z3,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),X)))
         => ( aa(A,B,F,Z3) = aa(A,B,G,Z3) ) )
     => ( aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F),X) = aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),G),X) ) ) ).

% Heap.map_cong0
tff(fact_5275_Heap_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X: heap_Time_Heap(A),Xa: heap_Time_Heap(A),F: fun(A,B),Fa: fun(A,B)] :
      ( ! [Z3: A,Za: A] :
          ( pp(member(A,Z3,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),X)))
         => ( pp(member(A,Za,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),Xa)))
           => ( ( aa(A,B,F,Z3) = aa(A,B,Fa,Za) )
             => ( Z3 = Za ) ) ) )
     => ( ( aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F),X) = aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),Fa),Xa) )
       => ( X = Xa ) ) ) ).

% Heap.inj_map_strong
tff(fact_5276_Heap_Orec,axiom,
    ! [C: $tType,A: $tType,F: fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),X: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(A),C,aa(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(A),C),heap_Time_rec_Heap(A,C),F),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X)) = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C,F,X) ) ).

% Heap.rec
tff(fact_5277_Heap_Oset__map,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B),V: heap_Time_Heap(A)] : ( aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F),V)) = aa(set(A),set(B),image2(A,B,F),aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),V)) ) ).

% Heap.set_map
tff(fact_5278_Heap_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A4: set(A),F: fun(A,B)] : ( aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),bNF_Grp(A,B,A4,F)) = bNF_Grp(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(heap_Time_Heap(A),bool),set(heap_Time_Heap(A)),collect(heap_Time_Heap(A)),aTP_Lamp_vb(set(A),fun(heap_Time_Heap(A),bool),A4)),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F)) ) ).

% Heap.rel_Grp
tff(fact_5279_Heap_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R) = relcompp(heap_Time_Heap(A),heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(B),conversep(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(A),bNF_Grp(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(A),aa(fun(heap_Time_Heap(product_prod(A,B)),bool),set(heap_Time_Heap(product_prod(A,B))),collect(heap_Time_Heap(product_prod(A,B))),aTP_Lamp_vc(fun(A,fun(B,bool)),fun(heap_Time_Heap(product_prod(A,B)),bool),R)),aa(fun(product_prod(A,B),A),fun(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(A)),heap_Time_map_Heap(product_prod(A,B),A),product_fst(A,B)))),bNF_Grp(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(B),aa(fun(heap_Time_Heap(product_prod(A,B)),bool),set(heap_Time_Heap(product_prod(A,B))),collect(heap_Time_Heap(product_prod(A,B))),aTP_Lamp_vc(fun(A,fun(B,bool)),fun(heap_Time_Heap(product_prod(A,B)),bool),R)),aa(fun(product_prod(A,B),B),fun(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(B)),heap_Time_map_Heap(product_prod(A,B),B),product_snd(A,B)))) ) ).

% Heap.rel_compp_Grp
tff(fact_5280_Heap_Oin__rel,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A3: heap_Time_Heap(A),B2: heap_Time_Heap(B)] :
      ( pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),A3),B2))
    <=> ? [Z4: heap_Time_Heap(product_prod(A,B))] :
          ( pp(member(heap_Time_Heap(product_prod(A,B)),Z4,aa(fun(heap_Time_Heap(product_prod(A,B)),bool),set(heap_Time_Heap(product_prod(A,B))),collect(heap_Time_Heap(product_prod(A,B))),aTP_Lamp_vc(fun(A,fun(B,bool)),fun(heap_Time_Heap(product_prod(A,B)),bool),R))))
          & ( aa(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(A),aa(fun(product_prod(A,B),A),fun(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(A)),heap_Time_map_Heap(product_prod(A,B),A),product_fst(A,B)),Z4) = A3 )
          & ( aa(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(B),aa(fun(product_prod(A,B),B),fun(heap_Time_Heap(product_prod(A,B)),heap_Time_Heap(B)),heap_Time_map_Heap(product_prod(A,B),B),product_snd(A,B)),Z4) = B2 ) ) ) ).

% Heap.in_rel
tff(fact_5281_Heap_Orel__cong,axiom,
    ! [A: $tType,B: $tType,X: heap_Time_Heap(A),Ya: heap_Time_Heap(A),Y: heap_Time_Heap(B),Xa: heap_Time_Heap(B),R: fun(A,fun(B,bool)),Ra2: fun(A,fun(B,bool))] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z3: A,Yb: B] :
              ( pp(member(A,Z3,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),Ya)))
             => ( pp(member(B,Yb,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),Xa)))
               => ( pp(aa(B,bool,aa(A,fun(B,bool),R,Z3),Yb))
                <=> pp(aa(B,bool,aa(A,fun(B,bool),Ra2,Z3),Yb)) ) ) )
         => ( pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),X),Y))
          <=> pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),Ra2),Ya),Xa)) ) ) ) ) ).

% Heap.rel_cong
tff(fact_5282_Heap_Orel__mono__strong,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),X: heap_Time_Heap(A),Y: heap_Time_Heap(B),Ra2: fun(A,fun(B,bool))] :
      ( pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),X),Y))
     => ( ! [Z3: A,Yb: B] :
            ( pp(member(A,Z3,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),X)))
           => ( pp(member(B,Yb,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),Y)))
             => ( pp(aa(B,bool,aa(A,fun(B,bool),R,Z3),Yb))
               => pp(aa(B,bool,aa(A,fun(B,bool),Ra2,Z3),Yb)) ) ) )
       => pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),Ra2),X),Y)) ) ) ).

% Heap.rel_mono_strong
tff(fact_5283_Heap_Orel__refl__strong,axiom,
    ! [A: $tType,X: heap_Time_Heap(A),Ra2: fun(A,fun(A,bool))] :
      ( ! [Z3: A] :
          ( pp(member(A,Z3,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),X)))
         => pp(aa(A,bool,aa(A,fun(A,bool),Ra2,Z3),Z3)) )
     => pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),aa(fun(A,fun(A,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool)),heap_Time_rel_Heap(A,A),Ra2),X),X)) ) ).

% Heap.rel_refl_strong
tff(fact_5284_Heap_Orel__mono,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool)),Ra2: fun(A,fun(B,bool))] :
      ( pp(aa(fun(A,fun(B,bool)),bool,aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),bool),ord_less_eq(fun(A,fun(B,bool))),R),Ra2))
     => pp(aa(fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),bool,aa(fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),fun(fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),bool),ord_less_eq(fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool))),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R)),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),Ra2))) ) ).

% Heap.rel_mono
tff(fact_5285_Heap_Orel__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Sa: fun(A,fun(C,bool)),Sc: fun(B,fun(D,bool))] : pp(aa(fun(fun(C,fun(D,bool)),fun(heap_Time_Heap(C),fun(heap_Time_Heap(D),bool))),bool,aa(fun(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool))),fun(fun(fun(C,fun(D,bool)),fun(heap_Time_Heap(C),fun(heap_Time_Heap(D),bool))),bool),bNF_rel_fun(fun(A,fun(B,bool)),fun(C,fun(D,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),fun(heap_Time_Heap(C),fun(heap_Time_Heap(D),bool)),bNF_rel_fun(A,C,fun(B,bool),fun(D,bool),Sa,bNF_rel_fun(B,D,bool,bool,Sc,fequal(bool))),bNF_rel_fun(heap_Time_Heap(A),heap_Time_Heap(C),fun(heap_Time_Heap(B),bool),fun(heap_Time_Heap(D),bool),aa(fun(A,fun(C,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(C),bool)),heap_Time_rel_Heap(A,C),Sa),bNF_rel_fun(heap_Time_Heap(B),heap_Time_Heap(D),bool,bool,aa(fun(B,fun(D,bool)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(D),bool)),heap_Time_rel_Heap(B,D),Sc),fequal(bool)))),heap_Time_rel_Heap(A,B)),heap_Time_rel_Heap(C,D))) ).

% Heap.rel_transfer
tff(fact_5286_Heap_Orel__compp,axiom,
    ! [A: $tType,C: $tType,B: $tType,R: fun(A,fun(B,bool)),S2: fun(B,fun(C,bool))] : ( aa(fun(A,fun(C,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(C),bool)),heap_Time_rel_Heap(A,C),relcompp(A,B,C,R,S2)) = relcompp(heap_Time_Heap(A),heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),aa(fun(B,fun(C,bool)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),bool)),heap_Time_rel_Heap(B,C),S2)) ) ).

% Heap.rel_compp
tff(fact_5287_Heap_Orel__refl,axiom,
    ! [B: $tType,Ra2: fun(B,fun(B,bool)),X: heap_Time_Heap(B)] :
      ( ! [X2: B] : pp(aa(B,bool,aa(B,fun(B,bool),Ra2,X2),X2))
     => pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),bool),aa(fun(B,fun(B,bool)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(B,B),Ra2),X),X)) ) ).

% Heap.rel_refl
tff(fact_5288_Heap_Orel__eq,axiom,
    ! [A: $tType] : ( aa(fun(A,fun(A,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool)),heap_Time_rel_Heap(A,A),fequal(A)) = fequal(heap_Time_Heap(A)) ) ).

% Heap.rel_eq
tff(fact_5289_Heap_Orel__conversep,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( aa(fun(B,fun(A,bool)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(A),bool)),heap_Time_rel_Heap(B,A),conversep(A,B,R)) = conversep(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R)) ) ).

% Heap.rel_conversep
tff(fact_5290_Heap_Orel__flip,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A3: heap_Time_Heap(B),B2: heap_Time_Heap(A)] :
      ( pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(B),fun(heap_Time_Heap(A),bool),aa(fun(B,fun(A,bool)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(A),bool)),heap_Time_rel_Heap(B,A),conversep(A,B,R)),A3),B2))
    <=> pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),B2),A3)) ) ).

% Heap.rel_flip
tff(fact_5291_Heap_Oleft__unique__rel,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] :
      ( left_unique(A,B,R)
     => left_unique(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R)) ) ).

% Heap.left_unique_rel
tff(fact_5292_Heap_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: fun(A,fun(C,bool)),X: heap_Time_Heap(A),G: fun(B,C),Y: heap_Time_Heap(B)] :
      ( pp(aa(heap_Time_Heap(C),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(C),bool),aa(fun(A,fun(C,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(C),bool)),heap_Time_rel_Heap(A,C),Sa),X),aa(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),G),Y)))
    <=> pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_go(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Sa),G)),X),Y)) ) ).

% Heap.rel_map(2)
tff(fact_5293_Heap_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: fun(C,fun(B,bool)),I: fun(A,C),X: heap_Time_Heap(A),Y: heap_Time_Heap(B)] :
      ( pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(C),fun(heap_Time_Heap(B),bool),aa(fun(C,fun(B,bool)),fun(heap_Time_Heap(C),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(C,B),Sb),aa(heap_Time_Heap(A),heap_Time_Heap(C),aa(fun(A,C),fun(heap_Time_Heap(A),heap_Time_Heap(C)),heap_Time_map_Heap(A,C),I),X)),Y))
    <=> pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_gp(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Sb),I)),X),Y)) ) ).

% Heap.rel_map(1)
tff(fact_5294_Heap_Omap__transfer,axiom,
    ! [A: $tType,B: $tType,F8: $tType,E: $tType,Rb2: fun(A,fun(E,bool)),Sd: fun(B,fun(F8,bool))] : pp(aa(fun(fun(E,F8),fun(heap_Time_Heap(E),heap_Time_Heap(F8))),bool,aa(fun(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B))),fun(fun(fun(E,F8),fun(heap_Time_Heap(E),heap_Time_Heap(F8))),bool),bNF_rel_fun(fun(A,B),fun(E,F8),fun(heap_Time_Heap(A),heap_Time_Heap(B)),fun(heap_Time_Heap(E),heap_Time_Heap(F8)),bNF_rel_fun(A,E,B,F8,Rb2,Sd),bNF_rel_fun(heap_Time_Heap(A),heap_Time_Heap(E),heap_Time_Heap(B),heap_Time_Heap(F8),aa(fun(A,fun(E,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(E),bool)),heap_Time_rel_Heap(A,E),Rb2),aa(fun(B,fun(F8,bool)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(F8),bool)),heap_Time_rel_Heap(B,F8),Sd))),heap_Time_map_Heap(A,B)),heap_Time_map_Heap(E,F8))) ).

% Heap.map_transfer
tff(fact_5295_Heap_Oset__transfer,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool))] : pp(aa(fun(heap_Time_Heap(B),set(B)),bool,aa(fun(heap_Time_Heap(A),set(A)),fun(fun(heap_Time_Heap(B),set(B)),bool),bNF_rel_fun(heap_Time_Heap(A),heap_Time_Heap(B),set(A),set(B),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),bNF_rel_set(A,B,R)),heap_Time_set_Heap(A)),heap_Time_set_Heap(B))) ).

% Heap.set_transfer
tff(fact_5296_sorted__wrt_Opelims_I1_J,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A),Y: bool] :
      ( ( sorted_wrt(A,X,Xa)
      <=> pp(Y) )
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),Xa)))
       => ( ( ( Xa = nil(A) )
           => ( pp(Y)
             => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),nil(A)))) ) )
         => ~ ! [X2: A,Ys2: list(A)] :
                ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Ys2) )
               => ( ( pp(Y)
                  <=> ( ! [Xa2: A] :
                          ( pp(member(A,Xa2,aa(list(A),set(A),set2(A),Ys2)))
                         => pp(aa(A,bool,aa(A,fun(A,bool),X,X2),Xa2)) )
                      & sorted_wrt(A,X,Ys2) ) )
                 => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Ys2)))) ) ) ) ) ) ).

% sorted_wrt.pelims(1)
tff(fact_5297_sorted__wrt_Opelims_I2_J,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A)] :
      ( sorted_wrt(A,X,Xa)
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),Xa)))
       => ( ( ( Xa = nil(A) )
           => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),nil(A)))) )
         => ~ ! [X2: A,Ys2: list(A)] :
                ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Ys2) )
               => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Ys2))))
                 => ~ ( ! [Xa3: A] :
                          ( pp(member(A,Xa3,aa(list(A),set(A),set2(A),Ys2)))
                         => pp(aa(A,bool,aa(A,fun(A,bool),X,X2),Xa3)) )
                      & sorted_wrt(A,X,Ys2) ) ) ) ) ) ) ).

% sorted_wrt.pelims(2)
tff(fact_5298_size__multiset__o__map,axiom,
    ! [B: $tType,A: $tType,G: fun(B,nat),F: fun(A,B)] : ( aa(fun(multiset(A),multiset(B)),fun(multiset(A),nat),aa(fun(multiset(B),nat),fun(fun(multiset(A),multiset(B)),fun(multiset(A),nat)),comp(multiset(B),nat,multiset(A)),size_multiset(B,G)),image_mset(A,B,F)) = size_multiset(A,aa(fun(A,B),fun(A,nat),aa(fun(B,nat),fun(fun(A,B),fun(A,nat)),comp(B,nat,A),G),F)) ) ).

% size_multiset_o_map
tff(fact_5299_sorted__wrt_Opelims_I3_J,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A)] :
      ( ~ sorted_wrt(A,X,Xa)
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),Xa)))
       => ~ ! [X2: A,Ys2: list(A)] :
              ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Ys2) )
             => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),sorted_wrt_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),Ys2))))
               => ( ! [Xa4: A] :
                      ( pp(member(A,Xa4,aa(list(A),set(A),set2(A),Ys2)))
                     => pp(aa(A,bool,aa(A,fun(A,bool),X,X2),Xa4)) )
                  & sorted_wrt(A,X,Ys2) ) ) ) ) ) ).

% sorted_wrt.pelims(3)
tff(fact_5300_Heap_Opred__transfer,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool))] : pp(aa(fun(fun(B,bool),fun(heap_Time_Heap(B),bool)),bool,aa(fun(fun(A,bool),fun(heap_Time_Heap(A),bool)),fun(fun(fun(B,bool),fun(heap_Time_Heap(B),bool)),bool),bNF_rel_fun(fun(A,bool),fun(B,bool),fun(heap_Time_Heap(A),bool),fun(heap_Time_Heap(B),bool),bNF_rel_fun(A,B,bool,bool,R,fequal(bool)),bNF_rel_fun(heap_Time_Heap(A),heap_Time_Heap(B),bool,bool,aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),fequal(bool))),heap_Time_pred_Heap(A)),heap_Time_pred_Heap(B))) ).

% Heap.pred_transfer
tff(fact_5301_numeral__sqr,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),sqr(K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),K)) ) ) ).

% numeral_sqr
tff(fact_5302_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B)),A4: set(A),X: A,Z2: B] :
      ( finite_folding_on(A,B,S2,F)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),A4),S2))
       => ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( pp(member(A,X,A4))
           => ( finite_folding_F(A,B,F,Z2,A4) = aa(B,B,aa(A,fun(B,B),F,X),finite_folding_F(A,B,F,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ) ).

% folding_on.remove
tff(fact_5303_Heap_Opred__mono,axiom,
    ! [A: $tType,P: fun(A,bool),Pa: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Pa))
     => pp(aa(fun(heap_Time_Heap(A),bool),bool,aa(fun(heap_Time_Heap(A),bool),fun(fun(heap_Time_Heap(A),bool),bool),ord_less_eq(fun(heap_Time_Heap(A),bool)),aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),P)),aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),Pa))) ) ).

% Heap.pred_mono
tff(fact_5304_folding__on_Ointro,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B))] :
      ( ! [X2: A,Y2: A] :
          ( pp(member(A,X2,S2))
         => ( pp(member(A,Y2,S2))
           => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y2)),aa(A,fun(B,B),F,X2)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,Y2)) ) ) )
     => finite_folding_on(A,B,S2,F) ) ).

% folding_on.intro
tff(fact_5305_folding__on_Ocomp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B)),X: A,Y: A] :
      ( finite_folding_on(A,B,S2,F)
     => ( pp(member(A,X,S2))
       => ( pp(member(A,Y,S2))
         => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y)),aa(A,fun(B,B),F,X)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X)),aa(A,fun(B,B),F,Y)) ) ) ) ) ).

% folding_on.comp_fun_commute_on
tff(fact_5306_folding__on__def,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B))] :
      ( finite_folding_on(A,B,S2,F)
    <=> ! [X4: A,Y3: A] :
          ( pp(member(A,X4,S2))
         => ( pp(member(A,Y3,S2))
           => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y3)),aa(A,fun(B,B),F,X4)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X4)),aa(A,fun(B,B),F,Y3)) ) ) ) ) ).

% folding_on_def
tff(fact_5307_folding__on_Oempty,axiom,
    ! [A: $tType,B: $tType,S2: set(A),F: fun(A,fun(B,B)),Z2: B] :
      ( finite_folding_on(A,B,S2,F)
     => ( finite_folding_F(A,B,F,Z2,bot_bot(set(A))) = Z2 ) ) ).

% folding_on.empty
tff(fact_5308_Heap_Opred__True,axiom,
    ! [A: $tType,X3: heap_Time_Heap(A)] : pp(aa(heap_Time_Heap(A),bool,aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),aTP_Lamp_vd(A,bool)),X3)) ).

% Heap.pred_True
tff(fact_5309_Heap_Opred__mono__strong,axiom,
    ! [A: $tType,P: fun(A,bool),X: heap_Time_Heap(A),Pa: fun(A,bool)] :
      ( pp(aa(heap_Time_Heap(A),bool,aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),P),X))
     => ( ! [Z3: A] :
            ( pp(member(A,Z3,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),X)))
           => ( pp(aa(A,bool,P,Z3))
             => pp(aa(A,bool,Pa,Z3)) ) )
       => pp(aa(heap_Time_Heap(A),bool,aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),Pa),X)) ) ) ).

% Heap.pred_mono_strong
tff(fact_5310_Heap_Opred__cong,axiom,
    ! [A: $tType,X: heap_Time_Heap(A),Ya: heap_Time_Heap(A),P: fun(A,bool),Pa: fun(A,bool)] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( pp(member(A,Z3,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),Ya)))
           => ( pp(aa(A,bool,P,Z3))
            <=> pp(aa(A,bool,Pa,Z3)) ) )
       => ( pp(aa(heap_Time_Heap(A),bool,aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),P),X))
        <=> pp(aa(heap_Time_Heap(A),bool,aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),Pa),Ya)) ) ) ) ).

% Heap.pred_cong
tff(fact_5311_Heap_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X: heap_Time_Heap(A),Ya: heap_Time_Heap(A),F: fun(A,B),G: fun(A,B)] :
      ( ( X = Ya )
     => ( pp(aa(heap_Time_Heap(A),bool,aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),aa(fun(A,B),fun(A,bool),aTP_Lamp_rf(fun(A,B),fun(fun(A,B),fun(A,bool)),F),G)),Ya))
       => ( aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F),X) = aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),G),Ya) ) ) ) ).

% Heap.map_cong_pred
tff(fact_5312_Heap_Orel__eq__onp,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( aa(fun(A,fun(A,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool)),heap_Time_rel_Heap(A,A),bNF_eq_onp(A,P)) = bNF_eq_onp(heap_Time_Heap(A),aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),P)) ) ).

% Heap.rel_eq_onp
tff(fact_5313_Heap_Opred__rel,axiom,
    ! [A: $tType,P: fun(A,bool),X: heap_Time_Heap(A)] :
      ( pp(aa(heap_Time_Heap(A),bool,aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),P),X))
    <=> pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),aa(fun(A,fun(A,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool)),heap_Time_rel_Heap(A,A),bNF_eq_onp(A,P)),X),X)) ) ).

% Heap.pred_rel
tff(fact_5314_Heap_Opred__set,axiom,
    ! [A: $tType,P: fun(A,bool),X3: heap_Time_Heap(A)] :
      ( pp(aa(heap_Time_Heap(A),bool,aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),P),X3))
    <=> ! [Xa2: A] :
          ( pp(member(A,Xa2,aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),X3)))
         => pp(aa(A,bool,P,Xa2)) ) ) ).

% Heap.pred_set
tff(fact_5315_Heap_ODomainp__rel,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] : ( domainp(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R)) = aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),domainp(A,B,R)) ) ).

% Heap.Domainp_rel
tff(fact_5316_Heap_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q: fun(B,bool),F: fun(A,B),X: heap_Time_Heap(A)] :
      ( pp(aa(heap_Time_Heap(B),bool,aa(fun(B,bool),fun(heap_Time_Heap(B),bool),heap_Time_pred_Heap(B),Q),aa(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),F),X)))
    <=> pp(aa(heap_Time_Heap(A),bool,aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),Q),F)),X)) ) ).

% Heap.pred_map
tff(fact_5317_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B)),X: A,A4: set(A),Z2: B] :
      ( finite_folding_on(A,B,S2,F)
     => ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,X),A4)),S2))
       => ( pp(aa(set(A),bool,finite_finite(A),A4))
         => ( finite_folding_F(A,B,F,Z2,aa(set(A),set(A),insert2(A,X),A4)) = aa(B,B,aa(A,fun(B,B),F,X),finite_folding_F(A,B,F,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ).

% folding_on.insert_remove
tff(fact_5318_coinduct,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F: fun(A,A),X6: A] :
          ( order_mono(A,A,F)
         => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X6),aa(A,A,F,aa(A,A,aa(A,fun(A,A),sup_sup(A),X6),complete_lattice_gfp(A,F)))))
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X6),complete_lattice_gfp(A,F))) ) ) ) ).

% coinduct
tff(fact_5319_def__coinduct,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A4: A,F: fun(A,A),X6: A] :
          ( ( A4 = complete_lattice_gfp(A,F) )
         => ( order_mono(A,A,F)
           => ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X6),aa(A,A,F,aa(A,A,aa(A,fun(A,A),sup_sup(A),X6),A4))))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X6),A4)) ) ) ) ) ).

% def_coinduct
tff(fact_5320_coinduct__lemma,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [X6: A,F: fun(A,A)] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X6),aa(A,A,F,aa(A,A,aa(A,fun(A,A),sup_sup(A),X6),complete_lattice_gfp(A,F)))))
         => ( order_mono(A,A,F)
           => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),X6),complete_lattice_gfp(A,F))),aa(A,A,F,aa(A,A,aa(A,fun(A,A),sup_sup(A),X6),complete_lattice_gfp(A,F))))) ) ) ) ).

% coinduct_lemma
tff(fact_5321_predicate1I,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool)] :
      ( ! [X2: A] :
          ( pp(aa(A,bool,P,X2))
         => pp(aa(A,bool,Q,X2)) )
     => pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Q)) ) ).

% predicate1I
tff(fact_5322_rev__predicate1D,axiom,
    ! [A: $tType,P: fun(A,bool),X: A,Q: fun(A,bool)] :
      ( pp(aa(A,bool,P,X))
     => ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Q))
       => pp(aa(A,bool,Q,X)) ) ) ).

% rev_predicate1D
tff(fact_5323_predicate1D,axiom,
    ! [A: $tType,P: fun(A,bool),Q: fun(A,bool),X: A] :
      ( pp(aa(fun(A,bool),bool,aa(fun(A,bool),fun(fun(A,bool),bool),ord_less_eq(fun(A,bool)),P),Q))
     => ( pp(aa(A,bool,P,X))
       => pp(aa(A,bool,Q,X)) ) ) ).

% predicate1D
tff(fact_5324_Random__Pred_Onot__randompred__def,axiom,
    ! [P: fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),X3: product_prod(code_natural,code_natural)] : ( random6974930770145893639ompred(P,X3) = aa(product_prod(pred(product_unit),product_prod(code_natural,code_natural)),product_prod(pred(product_unit),product_prod(code_natural,code_natural)),aa(fun(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)))),fun(product_prod(pred(product_unit),product_prod(code_natural,code_natural)),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),product_case_prod(pred(product_unit),product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),aTP_Lamp_ve(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))))),aa(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)),P,X3)) ) ).

% Random_Pred.not_randompred_def
tff(fact_5325_filtercomap__neq__bot__surj,axiom,
    ! [A: $tType,B: $tType,F2: filter(A),F: fun(B,A)] :
      ( ( F2 != bot_bot(filter(A)) )
     => ( ( aa(set(B),set(A),image2(B,A,F),top_top(set(B))) = top_top(set(A)) )
       => ( filtercomap(B,A,F,F2) != bot_bot(filter(B)) ) ) ) ).

% filtercomap_neq_bot_surj
tff(fact_5326_trancl__def,axiom,
    ! [A: $tType,X3: set(product_prod(A,A))] : ( transitive_trancl(A,X3) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),transitive_tranclp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),X3)))) ) ).

% trancl_def
tff(fact_5327_filtercomap__bot,axiom,
    ! [B: $tType,A: $tType,F: fun(A,B)] : ( filtercomap(A,B,F,bot_bot(filter(B))) = bot_bot(filter(A)) ) ).

% filtercomap_bot
tff(fact_5328_eval__inf,axiom,
    ! [A: $tType,P: pred(A),Q: pred(A)] : ( aa(pred(A),fun(A,bool),eval(A),aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),inf_inf(pred(A)),P),Q)) = aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),aa(pred(A),fun(A,bool),eval(A),P)),aa(pred(A),fun(A,bool),eval(A),Q)) ) ).

% eval_inf
tff(fact_5329_eval__bot,axiom,
    ! [A: $tType] : ( aa(pred(A),fun(A,bool),eval(A),bot_bot(pred(A))) = bot_bot(fun(A,bool)) ) ).

% eval_bot
tff(fact_5330_eval__INF,axiom,
    ! [A: $tType,B: $tType,F: fun(B,pred(A)),A4: set(B)] : ( aa(pred(A),fun(A,bool),eval(A),aa(set(pred(A)),pred(A),complete_Inf_Inf(pred(A)),aa(set(B),set(pred(A)),image2(B,pred(A),F),A4))) = aa(set(fun(A,bool)),fun(A,bool),complete_Inf_Inf(fun(A,bool)),aa(set(B),set(fun(A,bool)),image2(B,fun(A,bool),aa(fun(B,pred(A)),fun(B,fun(A,bool)),aa(fun(pred(A),fun(A,bool)),fun(fun(B,pred(A)),fun(B,fun(A,bool))),comp(pred(A),fun(A,bool),B),eval(A)),F)),A4)) ) ).

% eval_INF
tff(fact_5331_eval__SUP,axiom,
    ! [A: $tType,B: $tType,F: fun(B,pred(A)),A4: set(B)] : ( aa(pred(A),fun(A,bool),eval(A),aa(set(pred(A)),pred(A),complete_Sup_Sup(pred(A)),aa(set(B),set(pred(A)),image2(B,pred(A),F),A4))) = aa(set(fun(A,bool)),fun(A,bool),complete_Sup_Sup(fun(A,bool)),aa(set(B),set(fun(A,bool)),image2(B,fun(A,bool),aa(fun(B,pred(A)),fun(B,fun(A,bool)),aa(fun(pred(A),fun(A,bool)),fun(fun(B,pred(A)),fun(B,fun(A,bool))),comp(pred(A),fun(A,bool),B),eval(A)),F)),A4)) ) ).

% eval_SUP
tff(fact_5332_botE,axiom,
    ! [A: $tType,X: A] : ~ pp(aa(A,bool,aa(pred(A),fun(A,bool),eval(A),bot_bot(pred(A))),X)) ).

% botE
tff(fact_5333_not__bot,axiom,
    ! [A: $tType,A4: pred(A)] :
      ( ( A4 != bot_bot(pred(A)) )
     => ~ ! [X2: A] : ~ pp(aa(A,bool,aa(pred(A),fun(A,bool),eval(A),A4),X2)) ) ).

% not_bot
tff(fact_5334_tranclp__induct2,axiom,
    ! [A: $tType,B: $tType,R3: fun(product_prod(A,B),fun(product_prod(A,B),bool)),Ax: A,Ay: B,Bx: A,By: B,P: fun(A,fun(B,bool))] :
      ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),transitive_tranclp(product_prod(A,B),R3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Bx),By)))
     => ( ! [A8: A,B5: B] :
            ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),R3,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)))
           => pp(aa(B,bool,aa(A,fun(B,bool),P,A8),B5)) )
       => ( ! [A8: A,B5: B,Aa2: A,Ba: B] :
              ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),transitive_tranclp(product_prod(A,B),R3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)))
             => ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),R3,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Aa2),Ba)))
               => ( pp(aa(B,bool,aa(A,fun(B,bool),P,A8),B5))
                 => pp(aa(B,bool,aa(A,fun(B,bool),P,Aa2),Ba)) ) ) )
         => pp(aa(B,bool,aa(A,fun(B,bool),P,Bx),By)) ) ) ) ).

% tranclp_induct2
tff(fact_5335_filtercomap__inf,axiom,
    ! [A: $tType,B: $tType,F: fun(A,B),F12: filter(B),F24: filter(B)] : ( filtercomap(A,B,F,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F12),F24)) = aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),filtercomap(A,B,F,F12)),filtercomap(A,B,F,F24)) ) ).

% filtercomap_inf
tff(fact_5336_filterlim__filtercomap__iff,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,B),G: fun(B,C),G6: filter(C),F2: filter(A)] :
      ( filterlim(A,B,F,filtercomap(B,C,G,G6),F2)
    <=> filterlim(A,C,aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),G),F),G6,F2) ) ).

% filterlim_filtercomap_iff
tff(fact_5337_tranclp__trancl__eq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X3: A,Xa3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),transitive_tranclp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3)),X3),Xa3))
    <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa3),transitive_trancl(A,R3))) ) ).

% tranclp_trancl_eq
tff(fact_5338_filtercomap__neq__bot,axiom,
    ! [A: $tType,B: $tType,F2: filter(A),F: fun(B,A)] :
      ( ! [P5: fun(A,bool)] :
          ( eventually(A,P5,F2)
         => ? [X3: B] : pp(aa(A,bool,P5,aa(B,A,F,X3))) )
     => ( filtercomap(B,A,F,F2) != bot_bot(filter(B)) ) ) ).

% filtercomap_neq_bot
tff(fact_5339_Nitpick_Otranclp__unfold,axiom,
    ! [A: $tType,R3: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),transitive_tranclp(A,R3),A3),B2))
    <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),transitive_trancl(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R3))))) ) ).

% Nitpick.tranclp_unfold
tff(fact_5340_not__pred__eq,axiom,
    ! [P: pred(product_unit)] :
      ( ( pp(aa(product_unit,bool,aa(pred(product_unit),fun(product_unit,bool),eval(product_unit),P),product_Unity))
       => ( not_pred(P) = bot_bot(pred(product_unit)) ) )
      & ( ~ pp(aa(product_unit,bool,aa(pred(product_unit),fun(product_unit,bool),eval(product_unit),P),product_Unity))
       => ( not_pred(P) = aa(product_unit,pred(product_unit),single(product_unit),product_Unity) ) ) ) ).

% not_pred_eq
tff(fact_5341_reflp__refl__eq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( reflp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3))
    <=> refl_on(A,top_top(set(A)),R3) ) ).

% reflp_refl_eq
tff(fact_5342_Heap_Orel__reflp,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool))] :
      ( reflp(A,R)
     => reflp(heap_Time_Heap(A),aa(fun(A,fun(A,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool)),heap_Time_rel_Heap(A,A),R)) ) ).

% Heap.rel_reflp
tff(fact_5343_reflp__inf,axiom,
    ! [A: $tType,R3: fun(A,fun(A,bool)),S: fun(A,fun(A,bool))] :
      ( reflp(A,R3)
     => ( reflp(A,S)
       => reflp(A,aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),inf_inf(fun(A,fun(A,bool))),R3),S)) ) ) ).

% reflp_inf
tff(fact_5344_inf__pred__def,axiom,
    ! [A: $tType,P: pred(A),Q: pred(A)] : ( aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),inf_inf(pred(A)),P),Q) = aa(fun(A,bool),pred(A),pred2(A),aa(fun(A,bool),fun(A,bool),aa(fun(A,bool),fun(fun(A,bool),fun(A,bool)),inf_inf(fun(A,bool)),aa(pred(A),fun(A,bool),eval(A),P)),aa(pred(A),fun(A,bool),eval(A),Q))) ) ).

% inf_pred_def
tff(fact_5345_fun__of__rel__def,axiom,
    ! [A: $tType,B: $tType,R: set(product_prod(B,A)),X: B] : ( fun_of_rel(B,A,R,X) = fChoice(A,aa(B,fun(A,bool),aTP_Lamp_lm(set(product_prod(B,A)),fun(B,fun(A,bool)),R),X)) ) ).

% fun_of_rel_def
tff(fact_5346_le__prod__encode__1,axiom,
    ! [A3: nat,B2: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),A3),nat_prod_encode(aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),B2)))) ).

% le_prod_encode_1
tff(fact_5347_Eps__case__prod__eq,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] : ( fChoice(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(B,fun(A,fun(B,bool)),aTP_Lamp_js(A,fun(B,fun(A,fun(B,bool))),X),Y))) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X),Y) ) ).

% Eps_case_prod_eq
tff(fact_5348_some__insert__self,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ( S2 != bot_bot(set(A)) )
     => ( aa(set(A),set(A),insert2(A,fChoice(A,aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),S2))),S2) = S2 ) ) ).

% some_insert_self
tff(fact_5349_some__elem,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ( S2 != bot_bot(set(A)) )
     => pp(member(A,fChoice(A,aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),S2)),S2)) ) ).

% some_elem
tff(fact_5350_some__in__eq,axiom,
    ! [A: $tType,A4: set(A)] :
      ( pp(member(A,fChoice(A,aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),A4)),A4))
    <=> ( A4 != bot_bot(set(A)) ) ) ).

% some_in_eq
tff(fact_5351_split__paired__Eps,axiom,
    ! [B: $tType,A: $tType,P: fun(product_prod(A,B),bool)] : ( fChoice(product_prod(A,B),P) = fChoice(product_prod(A,B),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aTP_Lamp_vf(fun(product_prod(A,B),bool),fun(A,fun(B,bool)),P))) ) ).

% split_paired_Eps
tff(fact_5352_pred__of__set__def,axiom,
    ! [A: $tType] : ( pred_of_set(A) = aa(fun(set(A),fun(A,bool)),fun(set(A),pred(A)),aa(fun(fun(A,bool),pred(A)),fun(fun(set(A),fun(A,bool)),fun(set(A),pred(A))),comp(fun(A,bool),pred(A),set(A)),pred2(A)),aTP_Lamp_a(set(A),fun(A,bool))) ) ).

% pred_of_set_def
tff(fact_5353_bot__pred__def,axiom,
    ! [A: $tType] : ( bot_bot(pred(A)) = aa(fun(A,bool),pred(A),pred2(A),bot_bot(fun(A,bool))) ) ).

% bot_pred_def
tff(fact_5354_le__prod__encode__2,axiom,
    ! [B2: nat,A3: nat] : pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),B2),nat_prod_encode(aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),B2)))) ).

% le_prod_encode_2
tff(fact_5355_list__encode_Oelims,axiom,
    ! [X: list(nat),Y: nat] :
      ( ( nat_list_encode(X) = Y )
     => ( ( ( X = nil(nat) )
         => ( Y != zero_zero(nat) ) )
       => ~ ! [X2: nat,Xs3: list(nat)] :
              ( ( X = aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),X2),Xs3) )
             => ( Y != aa(nat,nat,suc,nat_prod_encode(aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),nat_list_encode(Xs3)))) ) ) ) ) ).

% list_encode.elims
tff(fact_5356_list__encode_Osimps_I2_J,axiom,
    ! [X: nat,Xs: list(nat)] : ( nat_list_encode(aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),X),Xs)) = aa(nat,nat,suc,nat_prod_encode(aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),nat_list_encode(Xs)))) ) ).

% list_encode.simps(2)
tff(fact_5357_prod__list_Ocomm__monoid__list__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => groups1828464146339083142d_list(A,times_times(A),one_one(A)) ) ).

% prod_list.comm_monoid_list_axioms
tff(fact_5358_list__encode_Opelims,axiom,
    ! [X: list(nat),Y: nat] :
      ( ( nat_list_encode(X) = Y )
     => ( pp(aa(list(nat),bool,accp(list(nat),nat_list_encode_rel),X))
       => ( ( ( X = nil(nat) )
           => ( ( Y = zero_zero(nat) )
             => ~ pp(aa(list(nat),bool,accp(list(nat),nat_list_encode_rel),nil(nat))) ) )
         => ~ ! [X2: nat,Xs3: list(nat)] :
                ( ( X = aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),X2),Xs3) )
               => ( ( Y = aa(nat,nat,suc,nat_prod_encode(aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),nat_list_encode(Xs3)))) )
                 => ~ pp(aa(list(nat),bool,accp(list(nat),nat_list_encode_rel),aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),X2),Xs3))) ) ) ) ) ) ).

% list_encode.pelims
tff(fact_5359_map__option__o__case__sum,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: fun(D,C),G: fun(A,option(D)),H2: fun(B,option(D))] : ( aa(fun(sum_sum(A,B),option(D)),fun(sum_sum(A,B),option(C)),aa(fun(option(D),option(C)),fun(fun(sum_sum(A,B),option(D)),fun(sum_sum(A,B),option(C))),comp(option(D),option(C),sum_sum(A,B)),map_option(D,C,F)),sum_case_sum(A,option(D),B,G,H2)) = sum_case_sum(A,option(C),B,aa(fun(A,option(D)),fun(A,option(C)),aa(fun(option(D),option(C)),fun(fun(A,option(D)),fun(A,option(C))),comp(option(D),option(C),A),map_option(D,C,F)),G),aa(fun(B,option(D)),fun(B,option(C)),aa(fun(option(D),option(C)),fun(fun(B,option(D)),fun(B,option(C))),comp(option(D),option(C),B),map_option(D,C,F)),H2)) ) ).

% map_option_o_case_sum
tff(fact_5360_Pair__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A4: fun(A,fun(B,bool)),B3: fun(C,fun(D,bool))] : pp(aa(fun(B,fun(D,product_prod(B,D))),bool,aa(fun(A,fun(C,product_prod(A,C))),fun(fun(B,fun(D,product_prod(B,D))),bool),bNF_rel_fun(A,B,fun(C,product_prod(A,C)),fun(D,product_prod(B,D)),A4,bNF_rel_fun(C,D,product_prod(A,C),product_prod(B,D),B3,basic_rel_prod(A,B,C,D,A4,B3))),product_Pair(A,C)),product_Pair(B,D))) ).

% Pair_transfer
tff(fact_5361_rel__prod__inject,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,R12: fun(A,fun(B,bool)),R23: fun(C,fun(D,bool)),A3: A,B2: C,C2: B,D2: D] :
      ( pp(aa(product_prod(B,D),bool,aa(product_prod(A,C),fun(product_prod(B,D),bool),basic_rel_prod(A,B,C,D,R12,R23),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),A3),B2)),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),C2),D2)))
    <=> ( pp(aa(B,bool,aa(A,fun(B,bool),R12,A3),C2))
        & pp(aa(D,bool,aa(C,fun(D,bool),R23,B2),D2)) ) ) ).

% rel_prod_inject
tff(fact_5362_o__case__sum,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,H2: fun(D,C),F: fun(A,D),G: fun(B,D)] : ( aa(fun(sum_sum(A,B),D),fun(sum_sum(A,B),C),aa(fun(D,C),fun(fun(sum_sum(A,B),D),fun(sum_sum(A,B),C)),comp(D,C,sum_sum(A,B)),H2),sum_case_sum(A,D,B,F,G)) = sum_case_sum(A,C,B,aa(fun(A,D),fun(A,C),aa(fun(D,C),fun(fun(A,D),fun(A,C)),comp(D,C,A),H2),F),aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),H2),G)) ) ).

% o_case_sum
tff(fact_5363_rel__prod_Ocases,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,R12: fun(A,fun(B,bool)),R23: fun(C,fun(D,bool)),A1: product_prod(A,C),A22: product_prod(B,D)] :
      ( pp(aa(product_prod(B,D),bool,aa(product_prod(A,C),fun(product_prod(B,D),bool),basic_rel_prod(A,B,C,D,R12,R23),A1),A22))
     => ~ ! [A8: A,B5: B,C4: C] :
            ( ( A1 = aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),A8),C4) )
           => ! [D3: D] :
                ( ( A22 = aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),B5),D3) )
               => ( pp(aa(B,bool,aa(A,fun(B,bool),R12,A8),B5))
                 => ~ pp(aa(D,bool,aa(C,fun(D,bool),R23,C4),D3)) ) ) ) ) ).

% rel_prod.cases
tff(fact_5364_rel__prod_Osimps,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,R12: fun(A,fun(B,bool)),R23: fun(C,fun(D,bool)),A1: product_prod(A,C),A22: product_prod(B,D)] :
      ( pp(aa(product_prod(B,D),bool,aa(product_prod(A,C),fun(product_prod(B,D),bool),basic_rel_prod(A,B,C,D,R12,R23),A1),A22))
    <=> ? [A6: A,B6: B,C5: C,D5: D] :
          ( ( A1 = aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),A6),C5) )
          & ( A22 = aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),B6),D5) )
          & pp(aa(B,bool,aa(A,fun(B,bool),R12,A6),B6))
          & pp(aa(D,bool,aa(C,fun(D,bool),R23,C5),D5)) ) ) ).

% rel_prod.simps
tff(fact_5365_rel__prod_Ointros,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,R12: fun(A,fun(B,bool)),A3: A,B2: B,R23: fun(C,fun(D,bool)),C2: C,D2: D] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),R12,A3),B2))
     => ( pp(aa(D,bool,aa(C,fun(D,bool),R23,C2),D2))
       => pp(aa(product_prod(B,D),bool,aa(product_prod(A,C),fun(product_prod(B,D),bool),basic_rel_prod(A,B,C,D,R12,R23),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),A3),C2)),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),B2),D2))) ) ) ).

% rel_prod.intros
tff(fact_5366_Heap_Orec__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R: fun(A,fun(B,bool)),S2: fun(C,fun(D,bool))] : pp(aa(fun(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),D),fun(heap_Time_Heap(B),D)),bool,aa(fun(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(A),C)),fun(fun(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),D),fun(heap_Time_Heap(B),D)),bool),bNF_rel_fun(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),D),fun(heap_Time_Heap(A),C),fun(heap_Time_Heap(B),D),bNF_rel_fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C,D,bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(A,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),S2),bNF_rel_fun(heap_Time_Heap(A),heap_Time_Heap(B),C,D,aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),S2)),heap_Time_rec_Heap(A,C)),heap_Time_rec_Heap(B,D))) ).

% Heap.rec_transfer
tff(fact_5367_ordering__top_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ordering_top_axioms(A,Less_eq,Top) ) ).

% ordering_top.axioms(2)
tff(fact_5368_heap__step__admissible,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,P: fun(E,fun(A,fun(C,fun(B,fun(D,bool))))),X: E] : comple1908693960933563346ssible(fun(A,option(product_prod(B,product_prod(C,D)))),partial_fun_lub(option(product_prod(B,product_prod(C,D))),option(product_prod(B,product_prod(C,D))),A,partial_flat_lub(option(product_prod(B,product_prod(C,D))),none(product_prod(B,product_prod(C,D))))),partial_fun_ord(option(product_prod(B,product_prod(C,D))),option(product_prod(B,product_prod(C,D))),A,partial_flat_ord(option(product_prod(B,product_prod(C,D))),none(product_prod(B,product_prod(C,D))))),aa(E,fun(fun(A,option(product_prod(B,product_prod(C,D)))),bool),aTP_Lamp_vg(fun(E,fun(A,fun(C,fun(B,fun(D,bool))))),fun(E,fun(fun(A,option(product_prod(B,product_prod(C,D)))),bool)),P),X)) ).

% heap_step_admissible
tff(fact_5369_rel__option__iff,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),X: option(A),Y: option(B)] :
      ( pp(aa(option(B),bool,aa(option(A),fun(option(B),bool),rel_option(A,B,R),X),Y))
    <=> pp(aa(product_prod(option(A),option(B)),bool,aa(fun(option(A),fun(option(B),bool)),fun(product_prod(option(A),option(B)),bool),product_case_prod(option(A),option(B),bool),aTP_Lamp_vj(fun(A,fun(B,bool)),fun(option(A),fun(option(B),bool)),R)),aa(option(B),product_prod(option(A),option(B)),aa(option(A),fun(option(B),product_prod(option(A),option(B))),product_Pair(option(A),option(B)),X),Y))) ) ).

% rel_option_iff
tff(fact_5370_ordering__top__axioms_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Top: A] :
      ( ! [A8: A] : pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A8),Top))
     => ordering_top_axioms(A,Less_eq,Top) ) ).

% ordering_top_axioms.intro
tff(fact_5371_ordering__top__axioms__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Top: A] :
      ( ordering_top_axioms(A,Less_eq,Top)
    <=> ! [A6: A] : pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),Top)) ) ).

% ordering_top_axioms_def
tff(fact_5372_rel__option__inf,axiom,
    ! [B: $tType,A: $tType,A4: fun(A,fun(B,bool)),B3: fun(A,fun(B,bool))] : ( aa(fun(option(A),fun(option(B),bool)),fun(option(A),fun(option(B),bool)),aa(fun(option(A),fun(option(B),bool)),fun(fun(option(A),fun(option(B),bool)),fun(option(A),fun(option(B),bool))),inf_inf(fun(option(A),fun(option(B),bool))),rel_option(A,B,A4)),rel_option(A,B,B3)) = rel_option(A,B,aa(fun(A,fun(B,bool)),fun(A,fun(B,bool)),aa(fun(A,fun(B,bool)),fun(fun(A,fun(B,bool)),fun(A,fun(B,bool))),inf_inf(fun(A,fun(B,bool))),A4),B3)) ) ).

% rel_option_inf
tff(fact_5373_Heap_Orel__cases,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),A3: heap_Time_Heap(A),B2: heap_Time_Heap(B)] :
      ( pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),A3),B2))
     => ~ ! [Xa4: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] :
            ( ( A3 = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),Xa4) )
           => ! [Ya3: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] :
                ( ( B2 = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),Ya3) )
               => ~ pp(aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),bool,aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),bool),bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(A,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),Xa4),Ya3)) ) ) ) ).

% Heap.rel_cases
tff(fact_5374_Heap_Orel__induct,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),X: heap_Time_Heap(A),Y: heap_Time_Heap(B),Q: fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool))] :
      ( pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),X),Y))
     => ( ! [A8: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B5: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] :
            ( pp(aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),bool,aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),bool),bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(A,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),A8),B5))
           => pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),Q,aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),A8)),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),B5))) )
       => pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),Q,X),Y)) ) ) ).

% Heap.rel_induct
tff(fact_5375_Heap_Orel__inject,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),X: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),Y: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] :
      ( pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X)),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),Y)))
    <=> pp(aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),bool,aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),bool),bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(A,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),X),Y)) ) ).

% Heap.rel_inject
tff(fact_5376_Heap_Orel__intros,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool)),X: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),Y: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] :
      ( pp(aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),bool,aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),bool),bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(A,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),X),Y))
     => pp(aa(heap_Time_Heap(B),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X)),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),Y))) ) ).

% Heap.rel_intros
tff(fact_5377_Heap_Octr__transfer,axiom,
    ! [A: $tType,B: $tType,R: fun(A,fun(B,bool))] : pp(aa(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B)),bool,aa(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A)),fun(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B)),bool),bNF_rel_fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap(B),bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(A,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R)),heap_Time_Heap2(A)),heap_Time_Heap2(B))) ).

% Heap.ctr_transfer
tff(fact_5378_ccpo_OadmissibleD,axiom,
    ! [A: $tType,Lub: fun(set(A),A),Ord: fun(A,fun(A,bool)),P: fun(A,bool),A4: set(A)] :
      ( comple1908693960933563346ssible(A,Lub,Ord,P)
     => ( comple1602240252501008431_chain(A,Ord,A4)
       => ( ( A4 != bot_bot(set(A)) )
         => ( ! [X2: A] :
                ( pp(member(A,X2,A4))
               => pp(aa(A,bool,P,X2)) )
           => pp(aa(A,bool,P,aa(set(A),A,Lub,A4))) ) ) ) ) ).

% ccpo.admissibleD
tff(fact_5379_ccpo_OadmissibleI,axiom,
    ! [A: $tType,Ord: fun(A,fun(A,bool)),P: fun(A,bool),Lub: fun(set(A),A)] :
      ( ! [A12: set(A)] :
          ( comple1602240252501008431_chain(A,Ord,A12)
         => ( ( A12 != bot_bot(set(A)) )
           => ( ! [X3: A] :
                  ( pp(member(A,X3,A12))
                 => pp(aa(A,bool,P,X3)) )
             => pp(aa(A,bool,P,aa(set(A),A,Lub,A12))) ) ) )
     => comple1908693960933563346ssible(A,Lub,Ord,P) ) ).

% ccpo.admissibleI
tff(fact_5380_ccpo_Oadmissible__def,axiom,
    ! [A: $tType,Lub: fun(set(A),A),Ord: fun(A,fun(A,bool)),P: fun(A,bool)] :
      ( comple1908693960933563346ssible(A,Lub,Ord,P)
    <=> ! [A11: set(A)] :
          ( comple1602240252501008431_chain(A,Ord,A11)
         => ( ( A11 != bot_bot(set(A)) )
           => ( ! [X4: A] :
                  ( pp(member(A,X4,A11))
                 => pp(aa(A,bool,P,X4)) )
             => pp(aa(A,bool,P,aa(set(A),A,Lub,A11))) ) ) ) ) ).

% ccpo.admissible_def
tff(fact_5381_Heap_Ocase__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R: fun(A,fun(B,bool)),S2: fun(C,fun(D,bool))] : pp(aa(fun(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),D),fun(heap_Time_Heap(B),D)),bool,aa(fun(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(A),C)),fun(fun(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),D),fun(heap_Time_Heap(B),D)),bool),bNF_rel_fun(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),D),fun(heap_Time_Heap(A),C),fun(heap_Time_Heap(B),D),bNF_rel_fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C,D,bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(A,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),S2),bNF_rel_fun(heap_Time_Heap(A),heap_Time_Heap(B),C,D,aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R),S2)),heap_Time_case_Heap(A,C)),heap_Time_case_Heap(B,D))) ).

% Heap.case_transfer
tff(fact_5382_ordering__top__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A] :
      ( ordering_top(A,Less_eq,Less,Top)
    <=> ( ordering(A,Less_eq,Less)
        & ordering_top_axioms(A,Less_eq,Top) ) ) ).

% ordering_top_def
tff(fact_5383_ordering__top_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A] :
      ( ordering(A,Less_eq,Less)
     => ( ordering_top_axioms(A,Less_eq,Top)
       => ordering_top(A,Less_eq,Less,Top) ) ) ).

% ordering_top.intro
tff(fact_5384_Heap_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H2: fun(B,C),F: fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),Heap: heap_Time_Heap(A)] : ( aa(B,C,H2,aa(heap_Time_Heap(A),B,aa(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),fun(heap_Time_Heap(A),B),heap_Time_case_Heap(A,B),F),Heap)) = aa(heap_Time_Heap(A),C,aa(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(A),C),heap_Time_case_Heap(A,C),aa(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),aTP_Lamp_vk(fun(B,C),fun(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C)),H2),F)),Heap) ) ).

% Heap.case_distrib
tff(fact_5385_ordering__dualI,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ordering(A,aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Less_eq),aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Less))
     => ordering(A,Less_eq,Less) ) ).

% ordering_dualI
tff(fact_5386_ordering__strictI,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ! [A8: A,B5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A8),B5))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),B5))
            | ( A8 = B5 ) ) )
     => ( ! [A8: A,B5: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),B5))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,B5),A8)) )
       => ( ! [A8: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),A8))
         => ( ! [A8: A,B5: A,C4: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),B5))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B5),C4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),C4)) ) )
           => ordering(A,Less_eq,Less) ) ) ) ) ).

% ordering_strictI
tff(fact_5387_ordering_Onot__eq__order__implies__strict,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( ordering(A,Less_eq,Less)
     => ( ( A3 != B2 )
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2)) ) ) ) ).

% ordering.not_eq_order_implies_strict
tff(fact_5388_ordering_Ostrict__implies__not__eq,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( ordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
       => ( A3 != B2 ) ) ) ).

% ordering.strict_implies_not_eq
tff(fact_5389_ordering_Ostrict__iff__order,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( ordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
      <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
          & ( A3 != B2 ) ) ) ) ).

% ordering.strict_iff_order
tff(fact_5390_ordering_Oorder__iff__strict,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( ordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
      <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
          | ( A3 = B2 ) ) ) ) ).

% ordering.order_iff_strict
tff(fact_5391_ordering_Oantisym,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( ordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B2),A3))
         => ( A3 = B2 ) ) ) ) ).

% ordering.antisym
tff(fact_5392_ordering_Oeq__iff,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( ordering(A,Less_eq,Less)
     => ( ( A3 = B2 )
      <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
          & pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B2),A3)) ) ) ) ).

% ordering.eq_iff
tff(fact_5393_ordering__top_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),Top: A] :
      ( ordering_top(A,Less_eq,Less,Top)
     => ordering(A,Less_eq,Less) ) ).

% ordering_top.axioms(1)
tff(fact_5394_order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( order(A)
     => ordering(A,ord_less_eq(A),ord_less(A)) ) ).

% order.ordering_axioms
tff(fact_5395_Heap_Ocase,axiom,
    ! [B: $tType,A: $tType,F: fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),X: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(A),B,aa(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),fun(heap_Time_Heap(A),B),heap_Time_case_Heap(A,B),F),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),X)) = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B,F,X) ) ).

% Heap.case
tff(fact_5396_dual__order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( order(A)
     => ordering(A,aTP_Lamp_vl(A,fun(A,bool)),aTP_Lamp_vm(A,fun(A,bool))) ) ).

% dual_order.ordering_axioms
tff(fact_5397_admissible__image,axiom,
    ! [A: $tType,B: $tType,Le: fun(A,fun(A,bool)),Lub: fun(set(A),A),P: fun(B,bool),G: fun(A,B),F: fun(B,A)] :
      ( partia7178651479351089652itions(A,Le,Lub)
     => ( comple1908693960933563346ssible(A,Lub,Le,aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),P),G))
       => ( ! [X2: B,Y2: B] :
              ( ( aa(B,A,F,X2) = aa(B,A,F,Y2) )
             => ( X2 = Y2 ) )
         => ( ! [X2: A] : ( aa(B,A,F,aa(A,B,G,X2)) = X2 )
           => comple1908693960933563346ssible(B,partial_img_lub(B,A,A,B,F,G,Lub),partial_img_ord(B,A,bool,F,Le),P) ) ) ) ) ).

% admissible_image
tff(fact_5398_list__all__zip_Opelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X: fun(A,fun(B,bool)),Xa: list(A),Xb: list(B),Y: bool] :
      ( ( list_all_zip(A,B,X,Xa,Xb)
      <=> pp(Y) )
     => ( pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xa),Xb))))
       => ( ( ( Xa = nil(A) )
           => ( ( Xb = nil(B) )
             => ( pp(Y)
               => ~ pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),nil(B))))) ) ) )
         => ( ! [A8: A,As2: list(A)] :
                ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2) )
               => ! [B5: B,Bs2: list(B)] :
                    ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),Bs2) )
                   => ( ( pp(Y)
                      <=> ( pp(aa(B,bool,aa(A,fun(B,bool),X,A8),B5))
                          & list_all_zip(A,B,X,As2,Bs2) ) )
                     => ~ pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),Bs2))))) ) ) )
           => ( ! [V3: A,Va: list(A)] :
                  ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va) )
                 => ( ( Xb = nil(B) )
                   => ( ~ pp(Y)
                     => ~ pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va)),nil(B))))) ) ) )
             => ~ ( ( Xa = nil(A) )
                 => ! [V3: B,Va: list(B)] :
                      ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va) )
                     => ( ~ pp(Y)
                       => ~ pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va))))) ) ) ) ) ) ) ) ) ).

% list_all_zip.pelims(1)
tff(fact_5399_list__all__zip_Opelims_I2_J,axiom,
    ! [A: $tType,B: $tType,X: fun(A,fun(B,bool)),Xa: list(A),Xb: list(B)] :
      ( list_all_zip(A,B,X,Xa,Xb)
     => ( pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xa),Xb))))
       => ( ( ( Xa = nil(A) )
           => ( ( Xb = nil(B) )
             => ~ pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),nil(B))))) ) )
         => ~ ! [A8: A,As2: list(A)] :
                ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2) )
               => ! [B5: B,Bs2: list(B)] :
                    ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),Bs2) )
                   => ( pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),Bs2)))))
                     => ~ ( pp(aa(B,bool,aa(A,fun(B,bool),X,A8),B5))
                          & list_all_zip(A,B,X,As2,Bs2) ) ) ) ) ) ) ) ).

% list_all_zip.pelims(2)
tff(fact_5400_list__all__zip_Opelims_I3_J,axiom,
    ! [A: $tType,B: $tType,X: fun(A,fun(B,bool)),Xa: list(A),Xb: list(B)] :
      ( ~ list_all_zip(A,B,X,Xa,Xb)
     => ( pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),Xa),Xb))))
       => ( ! [A8: A,As2: list(A)] :
              ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2) )
             => ! [B5: B,Bs2: list(B)] :
                  ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),Bs2) )
                 => ( pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A8),As2)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),Bs2)))))
                   => ( pp(aa(B,bool,aa(A,fun(B,bool),X,A8),B5))
                      & list_all_zip(A,B,X,As2,Bs2) ) ) ) )
         => ( ! [V3: A,Va: list(A)] :
                ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va) )
               => ( ( Xb = nil(B) )
                 => ~ pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),V3),Va)),nil(B))))) ) )
           => ~ ( ( Xa = nil(A) )
               => ! [V3: B,Va: list(B)] :
                    ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va) )
                   => ~ pp(aa(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),bool,accp(product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),list_all_zip_rel(A,B)),aa(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B))),aa(fun(A,fun(B,bool)),fun(product_prod(list(A),list(B)),product_prod(fun(A,fun(B,bool)),product_prod(list(A),list(B)))),product_Pair(fun(A,fun(B,bool)),product_prod(list(A),list(B))),X),aa(list(B),product_prod(list(A),list(B)),aa(list(A),fun(list(B),product_prod(list(A),list(B))),product_Pair(list(A),list(B)),nil(A)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va))))) ) ) ) ) ) ) ).

% list_all_zip.pelims(3)
tff(fact_5401_partial__function__definitions_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Leq: fun(A,fun(A,bool)),Lub: fun(set(A),A),U2: fun(C,fun(B,A)),F2: fun(C,C),C3: fun(fun(B,A),C),F: C,P: fun(fun(B,A),bool)] :
      ( partia7178651479351089652itions(A,Leq,Lub)
     => ( ! [X2: B] : comple7038119648293358887notone(fun(B,A),A,partial_fun_ord(A,A,B,Leq),Leq,aa(B,fun(fun(B,A),A),aa(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A))),aTP_Lamp_vn(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)))),U2),F2),C3),X2))
       => ( ( F = aa(fun(B,A),C,C3,comple187402453842119260l_fixp(fun(B,A),partial_fun_lub(A,A,B,Lub),partial_fun_ord(A,A,B,Leq),aa(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A))),aTP_Lamp_vo(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)))),U2),F2),C3))) )
         => ( ! [F9: fun(B,A)] : ( aa(C,fun(B,A),U2,aa(fun(B,A),C,C3,F9)) = F9 )
           => ( comple1908693960933563346ssible(fun(B,A),partial_fun_lub(A,A,B,Lub),partial_fun_ord(A,A,B,Leq),P)
             => ( pp(aa(fun(B,A),bool,P,aTP_Lamp_vp(fun(set(A),A),fun(B,A),Lub)))
               => ( ! [F9: C] :
                      ( pp(aa(fun(B,A),bool,P,aa(C,fun(B,A),U2,F9)))
                     => pp(aa(fun(B,A),bool,P,aa(C,fun(B,A),U2,aa(C,C,F2,F9)))) )
                 => pp(aa(fun(B,A),bool,P,aa(C,fun(B,A),U2,F))) ) ) ) ) ) ) ) ).

% partial_function_definitions.fixp_induct_uc
tff(fact_5402_rat_Odomain__par,axiom,
    ! [DR1: fun(int,bool),DR2: fun(int,bool),P24: fun(product_prod(int,int),bool)] :
      ( ( domainp(int,int,fequal(int)) = DR1 )
     => ( ( domainp(int,int,fequal(int)) = DR2 )
       => ( pp(aa(fun(product_prod(int,int),bool),bool,aa(fun(product_prod(int,int),bool),fun(fun(product_prod(int,int),bool),bool),bNF_rel_fun(product_prod(int,int),product_prod(int,int),bool,bool,basic_rel_prod(int,int,int,int,fequal(int),fequal(int)),fequal(bool)),P24),aTP_Lamp_vq(product_prod(int,int),bool)))
         => ( domainp(product_prod(int,int),rat,pcr_rat) = aa(fun(product_prod(int,int),bool),fun(product_prod(int,int),bool),aa(fun(product_prod(int,int),bool),fun(fun(product_prod(int,int),bool),fun(product_prod(int,int),bool)),inf_inf(fun(product_prod(int,int),bool)),basic_pred_prod(int,int,DR1,DR2)),P24) ) ) ) ) ).

% rat.domain_par
tff(fact_5403_Predicate_Oiterate__upto_Opelims,axiom,
    ! [A: $tType,X: fun(code_natural,A),Xa: code_natural,Xb: code_natural,Y: pred(A)] :
      ( ( iterate_upto(A,X,Xa,Xb) = Y )
     => ( pp(aa(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),bool,accp(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),iterate_upto_rel(A)),aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),aa(fun(code_natural,A),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,A),product_prod(code_natural,code_natural)),X),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),Xa),Xb))))
       => ~ ( ( Y = seq2(A,aa(code_natural,fun(product_unit,seq(A)),aa(code_natural,fun(code_natural,fun(product_unit,seq(A))),aTP_Lamp_vr(fun(code_natural,A),fun(code_natural,fun(code_natural,fun(product_unit,seq(A)))),X),Xa),Xb)) )
           => ~ pp(aa(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),bool,accp(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),iterate_upto_rel(A)),aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),aa(fun(code_natural,A),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,A),product_prod(code_natural,code_natural)),X),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),Xa),Xb)))) ) ) ) ).

% Predicate.iterate_upto.pelims
tff(fact_5404_pred__prod__inject,axiom,
    ! [A: $tType,B: $tType,P12: fun(A,bool),P23: fun(B,bool),A3: A,B2: B] :
      ( pp(aa(product_prod(A,B),bool,basic_pred_prod(A,B,P12,P23),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2)))
    <=> ( pp(aa(A,bool,P12,A3))
        & pp(aa(B,bool,P23,B2)) ) ) ).

% pred_prod_inject
tff(fact_5405_Predicate_Osingle__code,axiom,
    ! [A: $tType,X: A] : ( aa(A,pred(A),single(A),X) = seq2(A,aTP_Lamp_vs(A,fun(product_unit,seq(A)),X)) ) ).

% Predicate.single_code
tff(fact_5406_bot__set__code,axiom,
    ! [A: $tType] : ( bot_bot(pred(A)) = seq2(A,aTP_Lamp_vt(product_unit,seq(A))) ) ).

% bot_set_code
tff(fact_5407_pred__prod_Ocases,axiom,
    ! [A: $tType,B: $tType,P12: fun(A,bool),P23: fun(B,bool),A3: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,basic_pred_prod(A,B,P12,P23),A3))
     => ~ ! [A8: A,B5: B] :
            ( ( A3 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5) )
           => ( pp(aa(A,bool,P12,A8))
             => ~ pp(aa(B,bool,P23,B5)) ) ) ) ).

% pred_prod.cases
tff(fact_5408_pred__prod_Osimps,axiom,
    ! [A: $tType,B: $tType,P12: fun(A,bool),P23: fun(B,bool),A3: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,basic_pred_prod(A,B,P12,P23),A3))
    <=> ? [A6: A,B6: B] :
          ( ( A3 = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A6),B6) )
          & pp(aa(A,bool,P12,A6))
          & pp(aa(B,bool,P23,B6)) ) ) ).

% pred_prod.simps
tff(fact_5409_pred__prod_Ointros,axiom,
    ! [A: $tType,B: $tType,P12: fun(A,bool),A3: A,P23: fun(B,bool),B2: B] :
      ( pp(aa(A,bool,P12,A3))
     => ( pp(aa(B,bool,P23,B2))
       => pp(aa(product_prod(A,B),bool,basic_pred_prod(A,B,P12,P23),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2))) ) ) ).

% pred_prod.intros
tff(fact_5410_pred__prod__split,axiom,
    ! [A: $tType,B: $tType,P: fun(bool,bool),Q: fun(A,bool),R: fun(B,bool),Xy: product_prod(A,B)] :
      ( pp(aa(bool,bool,P,aa(product_prod(A,B),bool,basic_pred_prod(A,B,Q,R),Xy)))
    <=> ! [X4: A,Y3: B] :
          ( ( Xy = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Y3) )
         => pp(aa(bool,bool,P,fconj(aa(A,bool,Q,X4),aa(B,bool,R,Y3)))) ) ) ).

% pred_prod_split
tff(fact_5411_prod_Opred__map,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,Q1: fun(C,bool),Q22: fun(D,bool),F1: fun(A,C),F22: fun(B,D),X: product_prod(A,B)] :
      ( pp(aa(product_prod(C,D),bool,basic_pred_prod(C,D,Q1,Q22),aa(product_prod(A,B),product_prod(C,D),product_map_prod(A,C,B,D,F1,F22),X)))
    <=> pp(aa(product_prod(A,B),bool,basic_pred_prod(A,B,aa(fun(A,C),fun(A,bool),aa(fun(C,bool),fun(fun(A,C),fun(A,bool)),comp(C,bool,A),Q1),F1),aa(fun(B,D),fun(B,bool),aa(fun(D,bool),fun(fun(B,D),fun(B,bool)),comp(D,bool,B),Q22),F22)),X)) ) ).

% prod.pred_map
tff(fact_5412_Predicate_Oiterate__upto_Opsimps,axiom,
    ! [A: $tType,F: fun(code_natural,A),N: code_natural,M4: code_natural] :
      ( pp(aa(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),bool,accp(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),iterate_upto_rel(A)),aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),aa(fun(code_natural,A),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,A),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,A),product_prod(code_natural,code_natural)),F),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),N),M4))))
     => ( iterate_upto(A,F,N,M4) = seq2(A,aa(code_natural,fun(product_unit,seq(A)),aa(code_natural,fun(code_natural,fun(product_unit,seq(A))),aTP_Lamp_vr(fun(code_natural,A),fun(code_natural,fun(code_natural,fun(product_unit,seq(A)))),F),N),M4)) ) ) ).

% Predicate.iterate_upto.psimps
tff(fact_5413_Random__Pred_Oiterate__upto__def,axiom,
    ! [A: $tType,F: fun(code_natural,A),N: code_natural,M4: code_natural] : ( random_iterate_upto(A,F,N,M4) = aa(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),product_Pair(pred(A),product_prod(code_natural,code_natural)),iterate_upto(A,F,N,M4)) ) ).

% Random_Pred.iterate_upto_def
tff(fact_5414_fixp__induct,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [P: fun(A,bool),F: fun(A,A)] :
          ( comple1908693960933563346ssible(A,complete_Sup_Sup(A),ord_less_eq(A),P)
         => ( comple7038119648293358887notone(A,A,ord_less_eq(A),ord_less_eq(A),F)
           => ( pp(aa(A,bool,P,aa(set(A),A,complete_Sup_Sup(A),bot_bot(set(A)))))
             => ( ! [X2: A] :
                    ( pp(aa(A,bool,P,X2))
                   => pp(aa(A,bool,P,aa(A,A,F,X2))) )
               => pp(aa(A,bool,P,comple115746919287870866o_fixp(A,F))) ) ) ) ) ) ).

% fixp_induct
tff(fact_5415_heap_Ofixp__induct__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U2: fun(C,fun(B,heap_Time_Heap(A))),F2: fun(C,C),C3: fun(fun(B,heap_Time_Heap(A)),C),F: C,P: fun(fun(B,heap_Time_Heap(A)),bool)] :
      ( ! [X2: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),heap_Time_Heap_ord(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)))),aTP_Lamp_vu(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))))),U2),F2),C3),X2))
     => ( ( F = aa(fun(B,heap_Time_Heap(A)),C,C3,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)))),aTP_Lamp_vv(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))))),U2),F2),C3))) )
       => ( ! [F9: fun(B,heap_Time_Heap(A))] : ( aa(C,fun(B,heap_Time_Heap(A)),U2,aa(fun(B,heap_Time_Heap(A)),C,C3,F9)) = F9 )
         => ( comple1908693960933563346ssible(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),P)
           => ( pp(aa(fun(B,heap_Time_Heap(A)),bool,P,aTP_Lamp_vw(B,heap_Time_Heap(A))))
             => ( ! [F9: C] :
                    ( pp(aa(fun(B,heap_Time_Heap(A)),bool,P,aa(C,fun(B,heap_Time_Heap(A)),U2,F9)))
                   => pp(aa(fun(B,heap_Time_Heap(A)),bool,P,aa(C,fun(B,heap_Time_Heap(A)),U2,aa(C,C,F2,F9)))) )
               => pp(aa(fun(B,heap_Time_Heap(A)),bool,P,aa(C,fun(B,heap_Time_Heap(A)),U2,F))) ) ) ) ) ) ) ).

% heap.fixp_induct_uc
tff(fact_5416_heap_Oconst__mono,axiom,
    ! [B: $tType,A: $tType,Ord: fun(B,fun(B,bool)),C2: heap_Time_Heap(A)] : comple7038119648293358887notone(B,heap_Time_Heap(A),Ord,heap_Time_Heap_ord(A),aTP_Lamp_vx(heap_Time_Heap(A),fun(B,heap_Time_Heap(A)),C2)) ).

% heap.const_mono
tff(fact_5417_heap_Oleq__refl,axiom,
    ! [A: $tType,X: heap_Time_Heap(A)] : pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),X),X)) ).

% heap.leq_refl
tff(fact_5418_heap_Oleq__trans,axiom,
    ! [A: $tType,X: heap_Time_Heap(A),Y: heap_Time_Heap(A),Z2: heap_Time_Heap(A)] :
      ( pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),X),Y))
     => ( pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),Y),Z2))
       => pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),X),Z2)) ) ) ).

% heap.leq_trans
tff(fact_5419_heap_Oleq__antisym,axiom,
    ! [A: $tType,X: heap_Time_Heap(A),Y: heap_Time_Heap(A)] :
      ( pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),X),Y))
     => ( pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),Y),X))
       => ( X = Y ) ) ) ).

% heap.leq_antisym
tff(fact_5420_heap_Olub__least,axiom,
    ! [A: $tType,A4: set(heap_Time_Heap(A)),Z2: heap_Time_Heap(A)] :
      ( comple1602240252501008431_chain(heap_Time_Heap(A),heap_Time_Heap_ord(A),A4)
     => ( ! [X2: heap_Time_Heap(A)] :
            ( pp(member(heap_Time_Heap(A),X2,A4))
           => pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),X2),Z2)) )
       => pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),aa(set(heap_Time_Heap(A)),heap_Time_Heap(A),heap_Time_Heap_lub(A),A4)),Z2)) ) ) ).

% heap.lub_least
tff(fact_5421_heap_Olub__upper,axiom,
    ! [A: $tType,A4: set(heap_Time_Heap(A)),X: heap_Time_Heap(A)] :
      ( comple1602240252501008431_chain(heap_Time_Heap(A),heap_Time_Heap_ord(A),A4)
     => ( pp(member(heap_Time_Heap(A),X,A4))
       => pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),X),aa(set(heap_Time_Heap(A)),heap_Time_Heap(A),heap_Time_Heap_lub(A),A4))) ) ) ).

% heap.lub_upper
tff(fact_5422_heap__interpretation,axiom,
    ! [A: $tType] : partia7178651479351089652itions(heap_Time_Heap(A),heap_Time_Heap_ord(A),heap_Time_Heap_lub(A)) ).

% heap_interpretation
tff(fact_5423_heap_Omono__body__fixp,axiom,
    ! [A: $tType,B: $tType,F2: fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)))] :
      ( ! [X2: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),heap_Time_Heap_ord(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aTP_Lamp_vy(fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),F2),X2))
     => ( comple187402453842119260l_fixp(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),F2) = aa(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)),F2,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),F2)) ) ) ).

% heap.mono_body_fixp
tff(fact_5424_heap_Ofixp__rule__uc,axiom,
    ! [B: $tType,A: $tType,C: $tType,U2: fun(C,fun(B,heap_Time_Heap(A))),F2: fun(C,C),C3: fun(fun(B,heap_Time_Heap(A)),C),F: C] :
      ( ! [X2: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),heap_Time_Heap_ord(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)))),aTP_Lamp_vu(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))))),U2),F2),C3),X2))
     => ( ( F = aa(fun(B,heap_Time_Heap(A)),C,C3,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)))),aTP_Lamp_vv(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))))),U2),F2),C3))) )
       => ( ! [F9: C] : ( aa(fun(B,heap_Time_Heap(A)),C,C3,aa(C,fun(B,heap_Time_Heap(A)),U2,F9)) = F9 )
         => ( F = aa(C,C,F2,F) ) ) ) ) ).

% heap.fixp_rule_uc
tff(fact_5425_Heap__Time__Monad_Obind__mono,axiom,
    ! [D: $tType,B: $tType,A: $tType,C: $tType,B3: fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C)),C3: fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D)))] :
      ( comple7038119648293358887notone(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C),partial_fun_ord(heap_Time_Heap(B),heap_Time_Heap(B),A,heap_Time_Heap_ord(B)),heap_Time_Heap_ord(C),B3)
     => ( ! [Y2: C] : comple7038119648293358887notone(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D),partial_fun_ord(heap_Time_Heap(B),heap_Time_Heap(B),A,heap_Time_Heap_ord(B)),heap_Time_Heap_ord(D),aa(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D)),C3,Y2))
       => comple7038119648293358887notone(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D),partial_fun_ord(heap_Time_Heap(B),heap_Time_Heap(B),A,heap_Time_Heap_ord(B)),heap_Time_Heap_ord(D),aa(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D)),aTP_Lamp_wa(fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C)),fun(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),B3),C3)) ) ) ).

% Heap_Time_Monad.bind_mono
tff(fact_5426_Heap__ord__def,axiom,
    ! [A: $tType] : ( heap_Time_Heap_ord(A) = partial_img_ord(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),bool,heap_Time_execute(A),partial_fun_ord(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit),partial_flat_ord(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),none(product_prod(A,product_prod(heap_ext(product_unit),nat)))))) ) ).

% Heap_ord_def
tff(fact_5427_Heap__ordE,axiom,
    ! [A: $tType,X: heap_Time_Heap(A),Y: heap_Time_Heap(A),H2: heap_ext(product_unit)] :
      ( pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),X),Y))
     => ( ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),X),H2) != none(product_prod(A,product_prod(heap_ext(product_unit),nat))) )
       => ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),X),H2) = aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),Y),H2) ) ) ) ).

% Heap_ordE
tff(fact_5428_Heap__ordI,axiom,
    ! [A: $tType,X: heap_Time_Heap(A),Y: heap_Time_Heap(A)] :
      ( ! [H: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),X),H) = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) )
          | ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),X),H) = aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),Y),H) ) )
     => pp(aa(heap_Time_Heap(A),bool,aa(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool),heap_Time_Heap_ord(A),X),Y)) ) ).

% Heap_ordI
tff(fact_5429_fixp__induct__heap,axiom,
    ! [C: $tType,A: $tType,B: $tType,U2: fun(C,fun(B,heap_Time_Heap(A))),F2: fun(C,C),C3: fun(fun(B,heap_Time_Heap(A)),C),F: C,P: fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool))))),X: B,H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: A,N: nat] :
      ( ! [X2: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),heap_Time_Heap_ord(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)))),aTP_Lamp_vu(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))))),U2),F2),C3),X2))
     => ( ( F = aa(fun(B,heap_Time_Heap(A)),C,C3,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(A)),partial_fun_lub(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_lub(A)),partial_fun_ord(heap_Time_Heap(A),heap_Time_Heap(A),B,heap_Time_Heap_ord(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)))),aTP_Lamp_vv(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))))),U2),F2),C3))) )
       => ( ! [F9: fun(B,heap_Time_Heap(A))] : ( aa(C,fun(B,heap_Time_Heap(A)),U2,aa(fun(B,heap_Time_Heap(A)),C,C3,F9)) = F9 )
         => ( ! [F9: C,X2: B,H: heap_ext(product_unit),H5: heap_ext(product_unit),R2: A,N3: nat] :
                ( ! [Xa3: B,Ha: heap_ext(product_unit),H_a: heap_ext(product_unit),Ra3: A,Na: nat] :
                    ( heap_Time_effect(A,aa(B,heap_Time_Heap(A),aa(C,fun(B,heap_Time_Heap(A)),U2,F9),Xa3),Ha,H_a,Ra3,Na)
                   => pp(aa(nat,bool,aa(A,fun(nat,bool),aa(heap_ext(product_unit),fun(A,fun(nat,bool)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool)))),P,Xa3),Ha),H_a),Ra3),Na)) )
               => ( heap_Time_effect(A,aa(B,heap_Time_Heap(A),aa(C,fun(B,heap_Time_Heap(A)),U2,aa(C,C,F2,F9)),X2),H,H5,R2,N3)
                 => pp(aa(nat,bool,aa(A,fun(nat,bool),aa(heap_ext(product_unit),fun(A,fun(nat,bool)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool)))),P,X2),H),H5),R2),N3)) ) )
           => ( heap_Time_effect(A,aa(B,heap_Time_Heap(A),aa(C,fun(B,heap_Time_Heap(A)),U2,F),X),H2,H4,R3,N)
             => pp(aa(nat,bool,aa(A,fun(nat,bool),aa(heap_ext(product_unit),fun(A,fun(nat,bool)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(A,fun(nat,bool)))),P,X),H2),H4),R3),N)) ) ) ) ) ) ).

% fixp_induct_heap
tff(fact_5430_admissible__heap,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool)))))] : comple1908693960933563346ssible(fun(A,heap_Time_Heap(B)),partial_fun_lub(heap_Time_Heap(B),heap_Time_Heap(B),A,heap_Time_Heap_lub(B)),partial_fun_ord(heap_Time_Heap(B),heap_Time_Heap(B),A,heap_Time_Heap_ord(B)),aTP_Lamp_wb(fun(A,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool))))),fun(fun(A,heap_Time_Heap(B)),bool),P)) ).

% admissible_heap
tff(fact_5431_Heap_Opred__inject,axiom,
    ! [A: $tType,P: fun(A,bool),A3: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] :
      ( pp(aa(heap_Time_Heap(A),bool,aa(fun(A,bool),fun(heap_Time_Heap(A),bool),heap_Time_pred_Heap(A),P),aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),A3)))
    <=> pp(aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),bool,basic_pred_fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_wc(heap_ext(product_unit),bool),pred_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),basic_pred_prod(A,product_prod(heap_ext(product_unit),nat),P,top_top(fun(product_prod(heap_ext(product_unit),nat),bool))))),A3)) ) ).

% Heap.pred_inject
tff(fact_5432_of__seq__code_I1_J,axiom,
    ! [A: $tType] : ( aa(seq(A),set(A),set_of_seq(A),empty(A)) = bot_bot(set(A)) ) ).

% of_seq_code(1)
tff(fact_5433_pred__of__seq_Osimps_I1_J,axiom,
    ! [A: $tType] : ( aa(seq(A),pred(A),pred_of_seq(A),empty(A)) = bot_bot(pred(A)) ) ).

% pred_of_seq.simps(1)
tff(fact_5434_top1I,axiom,
    ! [A: $tType,X: A] : pp(aa(A,bool,top_top(fun(A,bool)),X)) ).

% top1I
tff(fact_5435_option_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q: fun(B,bool),F: fun(A,B),X: option(A)] :
      ( pp(aa(option(B),bool,pred_option(B,Q),aa(option(A),option(B),map_option(A,B,F),X)))
    <=> pp(aa(option(A),bool,pred_option(A,aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),Q),F)),X)) ) ).

% option.pred_map
tff(fact_5436_of__pred__code,axiom,
    ! [A: $tType,F: fun(product_unit,seq(A))] : ( aa(pred(A),set(A),set_of_pred(A),seq2(A,F)) = case_seq(set(A),A,bot_bot(set(A)),aTP_Lamp_wd(A,fun(pred(A),set(A))),aTP_Lamp_we(pred(A),fun(seq(A),set(A))),aa(product_unit,seq(A),F,product_Unity)) ) ).

% of_pred_code
tff(fact_5437_set__of__seq__def,axiom,
    ! [A: $tType] : ( set_of_seq(A) = aa(fun(seq(A),pred(A)),fun(seq(A),set(A)),aa(fun(pred(A),set(A)),fun(fun(seq(A),pred(A)),fun(seq(A),set(A))),comp(pred(A),set(A),seq(A)),set_of_pred(A)),pred_of_seq(A)) ) ).

% set_of_seq_def
tff(fact_5438_nths__empty,axiom,
    ! [A: $tType,Xs: list(A)] : ( nths(A,Xs,bot_bot(set(nat))) = nil(A) ) ).

% nths_empty
tff(fact_5439_set__of__pred__def,axiom,
    ! [A: $tType] : ( set_of_pred(A) = aa(fun(pred(A),fun(A,bool)),fun(pred(A),set(A)),aa(fun(fun(A,bool),set(A)),fun(fun(pred(A),fun(A,bool)),fun(pred(A),set(A))),comp(fun(A,bool),set(A),pred(A)),collect(A)),eval(A)) ) ).

% set_of_pred_def
tff(fact_5440_ordering_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ordering(A,Less_eq,Less)
     => ordering_axioms(A,Less_eq,Less) ) ).

% ordering.axioms(2)
tff(fact_5441_abstract__boolean__algebra_Ointro,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( abel_semigroup(A,Conj)
     => ( abel_semigroup(A,Disj)
       => ( boolea6902313364301356556axioms(A,Conj,Disj,Compl,Zero,One)
         => boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One) ) ) ) ).

% abstract_boolean_algebra.intro
tff(fact_5442_abstract__boolean__algebra__def,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
    <=> ( abel_semigroup(A,Conj)
        & abel_semigroup(A,Disj)
        & boolea6902313364301356556axioms(A,Conj,Disj,Compl,Zero,One) ) ) ).

% abstract_boolean_algebra_def
tff(fact_5443_sup_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => abel_semigroup(A,sup_sup(A)) ) ).

% sup.abel_semigroup_axioms
tff(fact_5444_max_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => abel_semigroup(A,ord_max(A)) ) ).

% max.abel_semigroup_axioms
tff(fact_5445_ordering__axioms__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ordering_axioms(A,Less_eq,Less)
    <=> ( ! [A6: A,B6: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A6),B6))
          <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),B6))
              & ( A6 != B6 ) ) )
        & ! [A6: A,B6: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),B6))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B6),A6))
             => ( A6 = B6 ) ) ) ) ) ).

% ordering_axioms_def
tff(fact_5446_ordering__axioms_Ointro,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool)),Less_eq: fun(A,fun(A,bool))] :
      ( ! [A8: A,B5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),B5))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A8),B5))
            & ( A8 != B5 ) ) )
     => ( ! [A8: A,B5: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A8),B5))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B5),A8))
             => ( A8 = B5 ) ) )
       => ordering_axioms(A,Less_eq,Less) ) ) ).

% ordering_axioms.intro
tff(fact_5447_abel__semigroup_Oleft__commute,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),B2: A,A3: A,C2: A] :
      ( abel_semigroup(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,B2),aa(A,A,aa(A,fun(A,A),F,A3),C2)) = aa(A,A,aa(A,fun(A,A),F,A3),aa(A,A,aa(A,fun(A,A),F,B2),C2)) ) ) ).

% abel_semigroup.left_commute
tff(fact_5448_abel__semigroup_Ocommute,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A3: A,B2: A] :
      ( abel_semigroup(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = aa(A,A,aa(A,fun(A,A),F,B2),A3) ) ) ).

% abel_semigroup.commute
tff(fact_5449_min_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => abel_semigroup(A,ord_min(A)) ) ).

% min.abel_semigroup_axioms
tff(fact_5450_abstract__boolean__algebra_Oaxioms_I2_J,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => abel_semigroup(A,Disj) ) ).

% abstract_boolean_algebra.axioms(2)
tff(fact_5451_abstract__boolean__algebra_Oaxioms_I1_J,axiom,
    ! [A: $tType,Conj: fun(A,fun(A,A)),Disj: fun(A,fun(A,A)),Compl: fun(A,A),Zero: A,One: A] :
      ( boolea2506097494486148201lgebra(A,Conj,Disj,Compl,Zero,One)
     => abel_semigroup(A,Conj) ) ).

% abstract_boolean_algebra.axioms(1)
tff(fact_5452_abel__semigroup_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( abel_semigroup(A,F)
     => semigroup(A,F) ) ).

% abel_semigroup.axioms(1)
tff(fact_5453_mult_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => abel_semigroup(A,times_times(A)) ) ).

% mult.abel_semigroup_axioms
tff(fact_5454_add_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => abel_semigroup(A,plus_plus(A)) ) ).

% add.abel_semigroup_axioms
tff(fact_5455_comm__monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid(A,F,Z2)
     => abel_semigroup(A,F) ) ).

% comm_monoid.axioms(1)
tff(fact_5456_inf_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => abel_semigroup(A,inf_inf(A)) ) ).

% inf.abel_semigroup_axioms
tff(fact_5457_abel__semigroup_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( semigroup(A,F)
     => ( abel_s757365448890700780axioms(A,F)
       => abel_semigroup(A,F) ) ) ).

% abel_semigroup.intro
tff(fact_5458_abel__semigroup__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( abel_semigroup(A,F)
    <=> ( semigroup(A,F)
        & abel_s757365448890700780axioms(A,F) ) ) ).

% abel_semigroup_def
tff(fact_5459_comm__monoid_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( abel_semigroup(A,F)
     => ( comm_monoid_axioms(A,F,Z2)
       => comm_monoid(A,F,Z2) ) ) ).

% comm_monoid.intro
tff(fact_5460_comm__monoid__axioms_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( ! [A8: A] : ( aa(A,A,aa(A,fun(A,A),F,A8),Z2) = A8 )
     => comm_monoid_axioms(A,F,Z2) ) ).

% comm_monoid_axioms.intro
tff(fact_5461_abel__semigroup__axioms_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( ! [A8: A,B5: A] : ( aa(A,A,aa(A,fun(A,A),F,A8),B5) = aa(A,A,aa(A,fun(A,A),F,B5),A8) )
     => abel_s757365448890700780axioms(A,F) ) ).

% abel_semigroup_axioms.intro
tff(fact_5462_comm__monoid__axioms__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid_axioms(A,F,Z2)
    <=> ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F,A6),Z2) = A6 ) ) ).

% comm_monoid_axioms_def
tff(fact_5463_abel__semigroup__axioms__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( abel_s757365448890700780axioms(A,F)
    <=> ! [A6: A,B6: A] : ( aa(A,A,aa(A,fun(A,A),F,A6),B6) = aa(A,A,aa(A,fun(A,A),F,B6),A6) ) ) ).

% abel_semigroup_axioms_def
tff(fact_5464_abel__semigroup_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( abel_semigroup(A,F)
     => abel_s757365448890700780axioms(A,F) ) ).

% abel_semigroup.axioms(2)
tff(fact_5465_comm__monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid(A,F,Z2)
     => comm_monoid_axioms(A,F,Z2) ) ).

% comm_monoid.axioms(2)
tff(fact_5466_comm__monoid__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( comm_monoid(A,F,Z2)
    <=> ( abel_semigroup(A,F)
        & comm_monoid_axioms(A,F,Z2) ) ) ).

% comm_monoid_def
tff(fact_5467_ordering__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ordering(A,Less_eq,Less)
    <=> ( partial_preordering(A,Less_eq)
        & ordering_axioms(A,Less_eq,Less) ) ) ).

% ordering_def
tff(fact_5468_ordering_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( partial_preordering(A,Less_eq)
     => ( ordering_axioms(A,Less_eq,Less)
       => ordering(A,Less_eq,Less) ) ) ).

% ordering.intro
tff(fact_5469_prod__list_Omonoid__list__axioms,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => groups_monoid_list(A,times_times(A),one_one(A)) ) ).

% prod_list.monoid_list_axioms
tff(fact_5470_order_Opartial__preordering__axioms,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => partial_preordering(A,ord_less_eq(A)) ) ).

% order.partial_preordering_axioms
tff(fact_5471_partial__preordering__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool))] :
      ( partial_preordering(A,Less_eq)
    <=> ( ! [A6: A] : pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),A6))
        & ! [A6: A,B6: A,C5: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),B6))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B6),C5))
             => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),C5)) ) ) ) ) ).

% partial_preordering_def
tff(fact_5472_partial__preordering_Otrans,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),A3: A,B2: A,C2: A] :
      ( partial_preordering(A,Less_eq)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),C2)) ) ) ) ).

% partial_preordering.trans
tff(fact_5473_partial__preordering_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool))] :
      ( ! [A8: A] : pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A8),A8))
     => ( ! [A8: A,B5: A,C4: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A8),B5))
           => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B5),C4))
             => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A8),C4)) ) )
       => partial_preordering(A,Less_eq) ) ) ).

% partial_preordering.intro
tff(fact_5474_partial__preordering_Orefl,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),A3: A] :
      ( partial_preordering(A,Less_eq)
     => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),A3)) ) ).

% partial_preordering.refl
tff(fact_5475_monoid__list_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( monoid(A,F,Z2)
     => groups_monoid_list(A,F,Z2) ) ).

% monoid_list.intro
tff(fact_5476_monoid__list_Oaxioms,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( groups_monoid_list(A,F,Z2)
     => monoid(A,F,Z2) ) ).

% monoid_list.axioms
tff(fact_5477_monoid__list__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( groups_monoid_list(A,F,Z2)
    <=> monoid(A,F,Z2) ) ).

% monoid_list_def
tff(fact_5478_ordering_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ordering(A,Less_eq,Less)
     => partial_preordering(A,Less_eq) ) ).

% ordering.axioms(1)
tff(fact_5479_dual__order_Opartial__preordering__axioms,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => partial_preordering(A,aTP_Lamp_wf(A,fun(A,bool))) ) ).

% dual_order.partial_preordering_axioms
tff(fact_5480_semilattice__neutr_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( semilattice(A,F)
     => ( comm_monoid(A,F,Z2)
       => semilattice_neutr(A,F,Z2) ) ) ).

% semilattice_neutr.intro
tff(fact_5481_semilattice__neutr__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( semilattice_neutr(A,F,Z2)
    <=> ( semilattice(A,F)
        & comm_monoid(A,F,Z2) ) ) ).

% semilattice_neutr_def
tff(fact_5482_case__sum__o__map__sum__id,axiom,
    ! [A: $tType,B: $tType,C: $tType,G: fun(B,A),F: fun(C,A),X: sum_sum(C,B)] : ( aa(sum_sum(C,B),A,aa(fun(sum_sum(C,B),sum_sum(A,B)),fun(sum_sum(C,B),A),aa(fun(sum_sum(A,B),A),fun(fun(sum_sum(C,B),sum_sum(A,B)),fun(sum_sum(C,B),A)),comp(sum_sum(A,B),A,sum_sum(C,B)),sum_case_sum(A,A,B,id(A),G)),sum_map_sum(C,A,B,B,F,id(B))),X) = aa(sum_sum(C,B),A,sum_case_sum(C,A,B,aa(fun(C,C),fun(C,A),aa(fun(C,A),fun(fun(C,C),fun(C,A)),comp(C,A,C),F),id(C)),G),X) ) ).

% case_sum_o_map_sum_id
tff(fact_5483_map__sum_Ocomp,axiom,
    ! [A: $tType,C: $tType,E: $tType,F8: $tType,D: $tType,B: $tType,F: fun(C,E),G: fun(D,F8),H2: fun(A,C),I: fun(B,D)] : ( aa(fun(sum_sum(A,B),sum_sum(C,D)),fun(sum_sum(A,B),sum_sum(E,F8)),aa(fun(sum_sum(C,D),sum_sum(E,F8)),fun(fun(sum_sum(A,B),sum_sum(C,D)),fun(sum_sum(A,B),sum_sum(E,F8))),comp(sum_sum(C,D),sum_sum(E,F8),sum_sum(A,B)),sum_map_sum(C,E,D,F8,F,G)),sum_map_sum(A,C,B,D,H2,I)) = sum_map_sum(A,E,B,F8,aa(fun(A,C),fun(A,E),aa(fun(C,E),fun(fun(A,C),fun(A,E)),comp(C,E,A),F),H2),aa(fun(B,D),fun(B,F8),aa(fun(D,F8),fun(fun(B,D),fun(B,F8)),comp(D,F8,B),G),I)) ) ).

% map_sum.comp
tff(fact_5484_map__sum_Ocompositionality,axiom,
    ! [D: $tType,F8: $tType,E: $tType,C: $tType,B: $tType,A: $tType,F: fun(C,E),G: fun(D,F8),H2: fun(A,C),I: fun(B,D),Sum: sum_sum(A,B)] : ( aa(sum_sum(C,D),sum_sum(E,F8),sum_map_sum(C,E,D,F8,F,G),aa(sum_sum(A,B),sum_sum(C,D),sum_map_sum(A,C,B,D,H2,I),Sum)) = aa(sum_sum(A,B),sum_sum(E,F8),sum_map_sum(A,E,B,F8,aa(fun(A,C),fun(A,E),aa(fun(C,E),fun(fun(A,C),fun(A,E)),comp(C,E,A),F),H2),aa(fun(B,D),fun(B,F8),aa(fun(D,F8),fun(fun(B,D),fun(B,F8)),comp(D,F8,B),G),I)),Sum) ) ).

% map_sum.compositionality
tff(fact_5485_sum_Omap__comp,axiom,
    ! [D: $tType,F8: $tType,E: $tType,C: $tType,B: $tType,A: $tType,G1: fun(C,E),G22: fun(D,F8),F1: fun(A,C),F22: fun(B,D),V: sum_sum(A,B)] : ( aa(sum_sum(C,D),sum_sum(E,F8),sum_map_sum(C,E,D,F8,G1,G22),aa(sum_sum(A,B),sum_sum(C,D),sum_map_sum(A,C,B,D,F1,F22),V)) = aa(sum_sum(A,B),sum_sum(E,F8),sum_map_sum(A,E,B,F8,aa(fun(A,C),fun(A,E),aa(fun(C,E),fun(fun(A,C),fun(A,E)),comp(C,E,A),G1),F1),aa(fun(B,D),fun(B,F8),aa(fun(D,F8),fun(fun(B,D),fun(B,F8)),comp(D,F8,B),G22),F22)),V) ) ).

% sum.map_comp
tff(fact_5486_semilattice_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( semilattice(A,F)
     => abel_semigroup(A,F) ) ).

% semilattice.axioms(1)
tff(fact_5487_inf_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => semilattice(A,inf_inf(A)) ) ).

% inf.semilattice_axioms
tff(fact_5488_semilattice__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semilattice_order(A,F,Less_eq,Less)
     => semilattice(A,F) ) ).

% semilattice_order.axioms(1)
tff(fact_5489_max_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semilattice(A,ord_max(A)) ) ).

% max.semilattice_axioms
tff(fact_5490_semilattice_Oidem,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A3: A] :
      ( semilattice(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,A3),A3) = A3 ) ) ).

% semilattice.idem
tff(fact_5491_semilattice_Oleft__idem,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A3: A,B2: A] :
      ( semilattice(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,A3),aa(A,A,aa(A,fun(A,A),F,A3),B2)) = aa(A,A,aa(A,fun(A,A),F,A3),B2) ) ) ).

% semilattice.left_idem
tff(fact_5492_semilattice_Oright__idem,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A3: A,B2: A] :
      ( semilattice(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,A3),B2)),B2) = aa(A,A,aa(A,fun(A,A),F,A3),B2) ) ) ).

% semilattice.right_idem
tff(fact_5493_min_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => semilattice(A,ord_min(A)) ) ).

% min.semilattice_axioms
tff(fact_5494_semilattice__neutr_Oaxioms_I1_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( semilattice_neutr(A,F,Z2)
     => semilattice(A,F) ) ).

% semilattice_neutr.axioms(1)
tff(fact_5495_sup_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => semilattice(A,sup_sup(A)) ) ).

% sup.semilattice_axioms
tff(fact_5496_case__sum__o__map__sum,axiom,
    ! [A: $tType,D: $tType,C: $tType,E: $tType,B: $tType,F: fun(D,C),G: fun(E,C),H12: fun(A,D),H23: fun(B,E)] : ( aa(fun(sum_sum(A,B),sum_sum(D,E)),fun(sum_sum(A,B),C),aa(fun(sum_sum(D,E),C),fun(fun(sum_sum(A,B),sum_sum(D,E)),fun(sum_sum(A,B),C)),comp(sum_sum(D,E),C,sum_sum(A,B)),sum_case_sum(D,C,E,F,G)),sum_map_sum(A,D,B,E,H12,H23)) = sum_case_sum(A,C,B,aa(fun(A,D),fun(A,C),aa(fun(D,C),fun(fun(A,D),fun(A,C)),comp(D,C,A),F),H12),aa(fun(B,E),fun(B,C),aa(fun(E,C),fun(fun(B,E),fun(B,C)),comp(E,C,B),G),H23)) ) ).

% case_sum_o_map_sum
tff(fact_5497_case__sum__map__sum,axiom,
    ! [C: $tType,A: $tType,B: $tType,E: $tType,D: $tType,L: fun(B,A),R3: fun(C,A),F: fun(D,B),G: fun(E,C),X: sum_sum(D,E)] : ( aa(sum_sum(B,C),A,sum_case_sum(B,A,C,L,R3),aa(sum_sum(D,E),sum_sum(B,C),sum_map_sum(D,B,E,C,F,G),X)) = aa(sum_sum(D,E),A,sum_case_sum(D,A,E,aa(fun(D,B),fun(D,A),aa(fun(B,A),fun(fun(D,B),fun(D,A)),comp(B,A,D),L),F),aa(fun(E,C),fun(E,A),aa(fun(C,A),fun(fun(E,C),fun(E,A)),comp(C,A,E),R3),G)),X) ) ).

% case_sum_map_sum
tff(fact_5498_sum_Osize__gen__o__map,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: fun(C,nat),Fa: fun(D,nat),G: fun(A,C),Ga: fun(B,D)] : ( aa(fun(sum_sum(A,B),sum_sum(C,D)),fun(sum_sum(A,B),nat),aa(fun(sum_sum(C,D),nat),fun(fun(sum_sum(A,B),sum_sum(C,D)),fun(sum_sum(A,B),nat)),comp(sum_sum(C,D),nat,sum_sum(A,B)),basic_BNF_size_sum(C,D,F,Fa)),sum_map_sum(A,C,B,D,G,Ga)) = basic_BNF_size_sum(A,B,aa(fun(A,C),fun(A,nat),aa(fun(C,nat),fun(fun(A,C),fun(A,nat)),comp(C,nat,A),F),G),aa(fun(B,D),fun(B,nat),aa(fun(D,nat),fun(fun(B,D),fun(B,nat)),comp(D,nat,B),Fa),Ga)) ) ).

% sum.size_gen_o_map
tff(fact_5499_semilattice__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( semilattice(A,F)
    <=> ( abel_semigroup(A,F)
        & semilattice_axioms(A,F) ) ) ).

% semilattice_def
tff(fact_5500_semilattice_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( abel_semigroup(A,F)
     => ( semilattice_axioms(A,F)
       => semilattice(A,F) ) ) ).

% semilattice.intro
tff(fact_5501_semilattice__axioms__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( semilattice_axioms(A,F)
    <=> ! [A6: A] : ( aa(A,A,aa(A,fun(A,A),F,A6),A6) = A6 ) ) ).

% semilattice_axioms_def
tff(fact_5502_semilattice__axioms_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( ! [A8: A] : ( aa(A,A,aa(A,fun(A,A),F,A8),A8) = A8 )
     => semilattice_axioms(A,F) ) ).

% semilattice_axioms.intro
tff(fact_5503_semilattice_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( semilattice(A,F)
     => semilattice_axioms(A,F) ) ).

% semilattice.axioms(2)
tff(fact_5504_semilattice__order_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semilattice(A,F)
     => ( semila6385135966242565138axioms(A,F,Less_eq,Less)
       => semilattice_order(A,F,Less_eq,Less) ) ) ).

% semilattice_order.intro
tff(fact_5505_semilattice__order__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semilattice_order(A,F,Less_eq,Less)
    <=> ( semilattice(A,F)
        & semila6385135966242565138axioms(A,F,Less_eq,Less) ) ) ).

% semilattice_order_def
tff(fact_5506_map__sum__o__inj_I1_J,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: fun(A,B),G: fun(D,C)] : ( aa(fun(A,sum_sum(A,D)),fun(A,sum_sum(B,C)),aa(fun(sum_sum(A,D),sum_sum(B,C)),fun(fun(A,sum_sum(A,D)),fun(A,sum_sum(B,C))),comp(sum_sum(A,D),sum_sum(B,C),A),sum_map_sum(A,B,D,C,F,G)),sum_Inl(A,D)) = aa(fun(A,B),fun(A,sum_sum(B,C)),aa(fun(B,sum_sum(B,C)),fun(fun(A,B),fun(A,sum_sum(B,C))),comp(B,sum_sum(B,C),A),sum_Inl(B,C)),F) ) ).

% map_sum_o_inj(1)
tff(fact_5507_semilattice__order__axioms_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),F: fun(A,fun(A,A)),Less: fun(A,fun(A,bool))] :
      ( ! [A8: A,B5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A8),B5))
        <=> ( A8 = aa(A,A,aa(A,fun(A,A),F,A8),B5) ) )
     => ( ! [A8: A,B5: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),B5))
          <=> ( ( A8 = aa(A,A,aa(A,fun(A,A),F,A8),B5) )
              & ( A8 != B5 ) ) )
       => semila6385135966242565138axioms(A,F,Less_eq,Less) ) ) ).

% semilattice_order_axioms.intro
tff(fact_5508_semilattice__order__axioms__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semila6385135966242565138axioms(A,F,Less_eq,Less)
    <=> ( ! [A6: A,B6: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),B6))
          <=> ( A6 = aa(A,A,aa(A,fun(A,A),F,A6),B6) ) )
        & ! [A6: A,B6: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A6),B6))
          <=> ( ( A6 = aa(A,A,aa(A,fun(A,A),F,A6),B6) )
              & ( A6 != B6 ) ) ) ) ) ).

% semilattice_order_axioms_def
tff(fact_5509_case__sum__o__inj_I1_J,axiom,
    ! [C: $tType,B: $tType,A: $tType,F: fun(A,B),G: fun(C,B)] : ( aa(fun(A,sum_sum(A,C)),fun(A,B),aa(fun(sum_sum(A,C),B),fun(fun(A,sum_sum(A,C)),fun(A,B)),comp(sum_sum(A,C),B,A),sum_case_sum(A,B,C,F,G)),sum_Inl(A,C)) = F ) ).

% case_sum_o_inj(1)
tff(fact_5510_semilattice__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( semilattice_order(A,F,Less_eq,Less)
     => semila6385135966242565138axioms(A,F,Less_eq,Less) ) ).

% semilattice_order.axioms(2)
tff(fact_5511_prod_OPlus,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_mult(A)
     => ! [A4: set(B),B3: set(C),G: fun(sum_sum(B,C),A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(C),bool,finite_finite(C),B3))
           => ( aa(set(sum_sum(B,C)),A,aa(fun(sum_sum(B,C),A),fun(set(sum_sum(B,C)),A),groups7121269368397514597t_prod(sum_sum(B,C),A),G),sum_Plus(B,C,A4,B3)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,sum_sum(B,C)),fun(B,A),aa(fun(sum_sum(B,C),A),fun(fun(B,sum_sum(B,C)),fun(B,A)),comp(sum_sum(B,C),A,B),G),sum_Inl(B,C))),A4)),aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),aa(fun(C,sum_sum(B,C)),fun(C,A),aa(fun(sum_sum(B,C),A),fun(fun(C,sum_sum(B,C)),fun(C,A)),comp(sum_sum(B,C),A,C),G),sum_Inr(C,B))),B3)) ) ) ) ) ).

% prod.Plus
tff(fact_5512_sum_OPlus,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comm_monoid_add(A)
     => ! [A4: set(B),B3: set(C),G: fun(sum_sum(B,C),A)] :
          ( pp(aa(set(B),bool,finite_finite(B),A4))
         => ( pp(aa(set(C),bool,finite_finite(C),B3))
           => ( aa(set(sum_sum(B,C)),A,aa(fun(sum_sum(B,C),A),fun(set(sum_sum(B,C)),A),groups7311177749621191930dd_sum(sum_sum(B,C),A),G),sum_Plus(B,C,A4,B3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,sum_sum(B,C)),fun(B,A),aa(fun(sum_sum(B,C),A),fun(fun(B,sum_sum(B,C)),fun(B,A)),comp(sum_sum(B,C),A,B),G),sum_Inl(B,C))),A4)),aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(fun(C,sum_sum(B,C)),fun(C,A),aa(fun(sum_sum(B,C),A),fun(fun(C,sum_sum(B,C)),fun(C,A)),comp(sum_sum(B,C),A,C),G),sum_Inr(C,B))),B3)) ) ) ) ) ).

% sum.Plus
tff(fact_5513_card__order__csum__cone__cexp__def,axiom,
    ! [A: $tType,B: $tType,R3: set(product_prod(A,A)),A14: set(B)] :
      ( bNF_Ca8970107618336181345der_on(A,top_top(set(A)),R3)
     => ( bNF_Cardinal_cexp(sum_sum(B,product_unit),A,bNF_Cardinal_csum(B,product_unit,bNF_Ca6860139660246222851ard_of(B,A14),bNF_Cardinal_cone),R3) = bNF_Ca6860139660246222851ard_of(fun(A,sum_sum(B,product_unit)),bNF_Wellorder_Func(A,sum_sum(B,product_unit),top_top(set(A)),aa(set(sum_sum(B,product_unit)),set(sum_sum(B,product_unit)),aa(set(sum_sum(B,product_unit)),fun(set(sum_sum(B,product_unit)),set(sum_sum(B,product_unit))),sup_sup(set(sum_sum(B,product_unit))),aa(set(B),set(sum_sum(B,product_unit)),image2(B,sum_sum(B,product_unit),sum_Inl(B,product_unit)),A14)),aa(set(sum_sum(B,product_unit)),set(sum_sum(B,product_unit)),insert2(sum_sum(B,product_unit),aa(product_unit,sum_sum(B,product_unit),sum_Inr(product_unit,B),product_Unity)),bot_bot(set(sum_sum(B,product_unit))))))) ) ) ).

% card_order_csum_cone_cexp_def
tff(fact_5514_case__sum__o__inj_I2_J,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(A,B),G: fun(C,B)] : ( aa(fun(C,sum_sum(A,C)),fun(C,B),aa(fun(sum_sum(A,C),B),fun(fun(C,sum_sum(A,C)),fun(C,B)),comp(sum_sum(A,C),B,C),sum_case_sum(A,B,C,F,G)),sum_Inr(C,A)) = G ) ).

% case_sum_o_inj(2)
tff(fact_5515_case__sum__expand__Inr__pointfree,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(sum_sum(A,C),B),G: fun(A,B)] :
      ( ( aa(fun(A,sum_sum(A,C)),fun(A,B),aa(fun(sum_sum(A,C),B),fun(fun(A,sum_sum(A,C)),fun(A,B)),comp(sum_sum(A,C),B,A),F),sum_Inl(A,C)) = G )
     => ( sum_case_sum(A,B,C,G,aa(fun(C,sum_sum(A,C)),fun(C,B),aa(fun(sum_sum(A,C),B),fun(fun(C,sum_sum(A,C)),fun(C,B)),comp(sum_sum(A,C),B,C),F),sum_Inr(C,A))) = F ) ) ).

% case_sum_expand_Inr_pointfree
tff(fact_5516_case__sum__expand__Inr_H,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(sum_sum(A,C),B),G: fun(A,B),H2: fun(C,B)] :
      ( ( aa(fun(A,sum_sum(A,C)),fun(A,B),aa(fun(sum_sum(A,C),B),fun(fun(A,sum_sum(A,C)),fun(A,B)),comp(sum_sum(A,C),B,A),F),sum_Inl(A,C)) = G )
     => ( ( H2 = aa(fun(C,sum_sum(A,C)),fun(C,B),aa(fun(sum_sum(A,C),B),fun(fun(C,sum_sum(A,C)),fun(C,B)),comp(sum_sum(A,C),B,C),F),sum_Inr(C,A)) )
      <=> ( sum_case_sum(A,B,C,G,H2) = F ) ) ) ).

% case_sum_expand_Inr'
tff(fact_5517_case__sum__expand__Inr,axiom,
    ! [B: $tType,C: $tType,A: $tType,F: fun(sum_sum(A,C),B),G: fun(A,B),X: sum_sum(A,C)] :
      ( ( aa(fun(A,sum_sum(A,C)),fun(A,B),aa(fun(sum_sum(A,C),B),fun(fun(A,sum_sum(A,C)),fun(A,B)),comp(sum_sum(A,C),B,A),F),sum_Inl(A,C)) = G )
     => ( aa(sum_sum(A,C),B,F,X) = aa(sum_sum(A,C),B,sum_case_sum(A,B,C,G,aa(fun(C,sum_sum(A,C)),fun(C,B),aa(fun(sum_sum(A,C),B),fun(fun(C,sum_sum(A,C)),fun(C,B)),comp(sum_sum(A,C),B,C),F),sum_Inr(C,A))),X) ) ) ).

% case_sum_expand_Inr
tff(fact_5518_map__sum__o__inj_I2_J,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F: fun(A,B),G: fun(D,C)] : ( aa(fun(D,sum_sum(A,D)),fun(D,sum_sum(B,C)),aa(fun(sum_sum(A,D),sum_sum(B,C)),fun(fun(D,sum_sum(A,D)),fun(D,sum_sum(B,C))),comp(sum_sum(A,D),sum_sum(B,C),D),sum_map_sum(A,B,D,C,F,G)),sum_Inr(D,A)) = aa(fun(D,C),fun(D,sum_sum(B,C)),aa(fun(C,sum_sum(B,C)),fun(fun(D,C),fun(D,sum_sum(B,C))),comp(C,sum_sum(B,C),D),sum_Inr(C,B)),G) ) ).

% map_sum_o_inj(2)
tff(fact_5519_sum__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,X: A] : ( aa(sum_sum(A,B),set(A),basic_setl(A,B),aa(A,sum_sum(A,B),sum_Inl(A,B),X)) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ).

% sum_set_simps(1)
tff(fact_5520_sum__set__simps_I4_J,axiom,
    ! [E: $tType,A: $tType,X: A] : ( aa(sum_sum(E,A),set(A),basic_setr(E,A),aa(A,sum_sum(E,A),sum_Inr(A,E),X)) = aa(set(A),set(A),insert2(A,X),bot_bot(set(A))) ) ).

% sum_set_simps(4)
tff(fact_5521_Node__def,axiom,
    ! [A: $tType,B: $tType] : ( old_Node(B,A) = aa(fun(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),bool),set(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))),collect(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))),aTP_Lamp_wg(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),bool)) ) ).

% Node_def
tff(fact_5522_sum__set__simps_I2_J,axiom,
    ! [A: $tType,C: $tType,X: A] : ( aa(sum_sum(C,A),set(C),basic_setl(C,A),aa(A,sum_sum(C,A),sum_Inr(A,C),X)) = bot_bot(set(C)) ) ).

% sum_set_simps(2)
tff(fact_5523_sum__set__simps_I3_J,axiom,
    ! [A: $tType,D: $tType,X: A] : ( aa(sum_sum(A,D),set(D),basic_setr(A,D),aa(A,sum_sum(A,D),sum_Inl(A,D),X)) = bot_bot(set(D)) ) ).

% sum_set_simps(3)
tff(fact_5524_Node__K0__I,axiom,
    ! [B: $tType,A: $tType,A3: sum_sum(B,nat)] : pp(member(product_prod(fun(nat,sum_sum(A,nat)),sum_sum(B,nat)),aa(sum_sum(B,nat),product_prod(fun(nat,sum_sum(A,nat)),sum_sum(B,nat)),aa(fun(nat,sum_sum(A,nat)),fun(sum_sum(B,nat),product_prod(fun(nat,sum_sum(A,nat)),sum_sum(B,nat))),product_Pair(fun(nat,sum_sum(A,nat)),sum_sum(B,nat)),aTP_Lamp_wh(nat,sum_sum(A,nat))),A3),old_Node(A,B))) ).

% Node_K0_I
tff(fact_5525_sum__set__defs_I2_J,axiom,
    ! [C: $tType,D: $tType] : ( basic_setr(C,D) = sum_case_sum(C,set(D),D,aTP_Lamp_wi(C,set(D)),aTP_Lamp_wj(D,set(D))) ) ).

% sum_set_defs(2)
tff(fact_5526_sum__set__defs_I1_J,axiom,
    ! [A: $tType,B: $tType] : ( basic_setl(A,B) = sum_case_sum(A,set(A),B,aTP_Lamp_bf(A,set(A)),aTP_Lamp_ij(B,set(A))) ) ).

% sum_set_defs(1)
tff(fact_5527_ndepth__K0,axiom,
    ! [A: $tType,B: $tType,X: sum_sum(A,nat)] : ( old_ndepth(A,B,old_Abs_Node(B,A,aa(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))),product_Pair(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),aTP_Lamp_wk(nat,sum_sum(B,nat))),X))) = zero_zero(nat) ) ).

% ndepth_K0
tff(fact_5528_Atom__def,axiom,
    ! [B: $tType,A: $tType,X3: sum_sum(A,nat)] : ( aa(sum_sum(A,nat),set(old_node(A,B)),old_Atom(A,B),X3) = aa(set(old_node(A,B)),set(old_node(A,B)),insert2(old_node(A,B),old_Abs_Node(B,A,aa(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))),product_Pair(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),aTP_Lamp_wk(nat,sum_sum(B,nat))),X3))),bot_bot(set(old_node(A,B)))) ) ).

% Atom_def
tff(fact_5529_Leaf__def,axiom,
    ! [B: $tType,A: $tType] : ( old_Leaf(A,B) = aa(fun(A,sum_sum(A,nat)),fun(A,set(old_node(A,B))),aa(fun(sum_sum(A,nat),set(old_node(A,B))),fun(fun(A,sum_sum(A,nat)),fun(A,set(old_node(A,B)))),comp(sum_sum(A,nat),set(old_node(A,B)),A),old_Atom(A,B)),sum_Inl(A,nat)) ) ).

% Leaf_def
tff(fact_5530_nth__item_Opinduct,axiom,
    ! [A0: nat,P: fun(nat,bool)] :
      ( pp(aa(nat,bool,accp(nat,nth_item_rel),A0))
     => ( ( pp(aa(nat,bool,accp(nat,nth_item_rel),zero_zero(nat)))
         => pp(aa(nat,bool,P,zero_zero(nat))) )
       => ( ! [N3: nat] :
              ( pp(aa(nat,bool,accp(nat,nth_item_rel),aa(nat,nat,suc,N3)))
             => ( ! [A13: nat,Aa3: nat] :
                    ( ( nat_sum_decode(N3) = aa(nat,sum_sum(nat,nat),sum_Inl(nat,nat),A13) )
                   => ( ( nat_sum_decode(A13) = aa(nat,sum_sum(nat,nat),sum_Inl(nat,nat),Aa3) )
                     => pp(aa(nat,bool,P,Aa3)) ) )
               => ( ! [A13: nat,B10: nat] :
                      ( ( nat_sum_decode(N3) = aa(nat,sum_sum(nat,nat),sum_Inl(nat,nat),A13) )
                     => ( ( nat_sum_decode(A13) = aa(nat,sum_sum(nat,nat),sum_Inr(nat,nat),B10) )
                       => pp(aa(nat,bool,P,B10)) ) )
                 => ( ! [B10: nat,Ba2: nat,X3: nat,Y4: nat] :
                        ( ( nat_sum_decode(N3) = aa(nat,sum_sum(nat,nat),sum_Inr(nat,nat),B10) )
                       => ( ( nat_sum_decode(B10) = aa(nat,sum_sum(nat,nat),sum_Inr(nat,nat),Ba2) )
                         => ( ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X3),Y4) = nat_prod_decode(Ba2) )
                           => pp(aa(nat,bool,P,X3)) ) ) )
                   => ( ! [B10: nat,Ba2: nat,X3: nat,Y4: nat] :
                          ( ( nat_sum_decode(N3) = aa(nat,sum_sum(nat,nat),sum_Inr(nat,nat),B10) )
                         => ( ( nat_sum_decode(B10) = aa(nat,sum_sum(nat,nat),sum_Inr(nat,nat),Ba2) )
                           => ( ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X3),Y4) = nat_prod_decode(Ba2) )
                             => pp(aa(nat,bool,P,Y4)) ) ) )
                     => pp(aa(nat,bool,P,aa(nat,nat,suc,N3))) ) ) ) ) )
         => pp(aa(nat,bool,P,A0)) ) ) ) ).

% nth_item.pinduct
tff(fact_5531_ntrunc__0,axiom,
    ! [B: $tType,A: $tType,M: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(old_node(A,B)),old_ntrunc(A,B,zero_zero(nat)),M) = bot_bot(set(old_node(A,B))) ) ).

% ntrunc_0
tff(fact_5532_ntrunc__o__equality,axiom,
    ! [C: $tType,B: $tType,A: $tType,H12: fun(A,set(old_node(B,C))),H23: fun(A,set(old_node(B,C)))] :
      ( ! [K2: nat] : ( aa(fun(A,set(old_node(B,C))),fun(A,set(old_node(B,C))),aa(fun(set(old_node(B,C)),set(old_node(B,C))),fun(fun(A,set(old_node(B,C))),fun(A,set(old_node(B,C)))),comp(set(old_node(B,C)),set(old_node(B,C)),A),old_ntrunc(B,C,K2)),H12) = aa(fun(A,set(old_node(B,C))),fun(A,set(old_node(B,C))),aa(fun(set(old_node(B,C)),set(old_node(B,C))),fun(fun(A,set(old_node(B,C))),fun(A,set(old_node(B,C)))),comp(set(old_node(B,C)),set(old_node(B,C)),A),old_ntrunc(B,C,K2)),H23) )
     => ( H12 = H23 ) ) ).

% ntrunc_o_equality
tff(fact_5533_list__decode_Opinduct,axiom,
    ! [A0: nat,P: fun(nat,bool)] :
      ( pp(aa(nat,bool,accp(nat,nat_list_decode_rel),A0))
     => ( ( pp(aa(nat,bool,accp(nat,nat_list_decode_rel),zero_zero(nat)))
         => pp(aa(nat,bool,P,zero_zero(nat))) )
       => ( ! [N3: nat] :
              ( pp(aa(nat,bool,accp(nat,nat_list_decode_rel),aa(nat,nat,suc,N3)))
             => ( ! [X3: nat,Y4: nat] :
                    ( ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X3),Y4) = nat_prod_decode(N3) )
                   => pp(aa(nat,bool,P,Y4)) )
               => pp(aa(nat,bool,P,aa(nat,nat,suc,N3))) ) )
         => pp(aa(nat,bool,P,A0)) ) ) ) ).

% list_decode.pinduct
tff(fact_5534_ntrunc__one__In0,axiom,
    ! [B: $tType,A: $tType,M: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(old_node(A,B)),old_ntrunc(A,B,aa(nat,nat,suc,zero_zero(nat))),old_In0(A,B,M)) = bot_bot(set(old_node(A,B))) ) ).

% ntrunc_one_In0
tff(fact_5535_ntrunc__one__In1,axiom,
    ! [B: $tType,A: $tType,M: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(old_node(A,B)),old_ntrunc(A,B,aa(nat,nat,suc,zero_zero(nat))),old_In1(A,B,M)) = bot_bot(set(old_node(A,B))) ) ).

% ntrunc_one_In1
tff(fact_5536_dsum__def,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),S: set(product_prod(set(old_node(A,B)),set(old_node(A,B))))] : ( old_dsum(A,B,R3,S) = aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),sup_sup(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),complete_Sup_Sup(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),image2(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),fun(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),product_case_prod(set(old_node(A,B)),set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_wl(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))))),R3))),aa(set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),complete_Sup_Sup(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),image2(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),fun(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),product_case_prod(set(old_node(A,B)),set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_wm(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))))),S))) ) ).

% dsum_def
tff(fact_5537_Numb__def,axiom,
    ! [B: $tType,A: $tType] : ( old_Numb(A,B) = aa(fun(nat,sum_sum(A,nat)),fun(nat,set(old_node(A,B))),aa(fun(sum_sum(A,nat),set(old_node(A,B))),fun(fun(nat,sum_sum(A,nat)),fun(nat,set(old_node(A,B)))),comp(sum_sum(A,nat),set(old_node(A,B)),nat),old_Atom(A,B)),sum_Inr(nat,A)) ) ).

% Numb_def
tff(fact_5538_dsumE,axiom,
    ! [B: $tType,A: $tType,W2: product_prod(set(old_node(A,B)),set(old_node(A,B))),R3: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),S: set(product_prod(set(old_node(A,B)),set(old_node(A,B))))] :
      ( pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),W2,old_dsum(A,B,R3,S)))
     => ( ! [X2: set(old_node(A,B)),X9: set(old_node(A,B))] :
            ( pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),X2),X9),R3))
           => ( W2 != aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_In0(A,B,X2)),old_In0(A,B,X9)) ) )
       => ~ ! [Y2: set(old_node(A,B)),Y7: set(old_node(A,B))] :
              ( pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),Y2),Y7),S))
             => ( W2 != aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_In1(A,B,Y2)),old_In1(A,B,Y7)) ) ) ) ) ).

% dsumE
tff(fact_5539_dsum__In1I,axiom,
    ! [B: $tType,A: $tType,N4: set(old_node(A,B)),N7: set(old_node(A,B)),S: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),R3: set(product_prod(set(old_node(A,B)),set(old_node(A,B))))] :
      ( pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),N4),N7),S))
     => pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_In1(A,B,N4)),old_In1(A,B,N7)),old_dsum(A,B,R3,S))) ) ).

% dsum_In1I
tff(fact_5540_dsum__In0I,axiom,
    ! [B: $tType,A: $tType,M: set(old_node(A,B)),M8: set(old_node(A,B)),R3: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),S: set(product_prod(set(old_node(A,B)),set(old_node(A,B))))] :
      ( pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),M),M8),R3))
     => pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_In0(A,B,M)),old_In0(A,B,M8)),old_dsum(A,B,R3,S))) ) ).

% dsum_In0I
tff(fact_5541_dprod__def,axiom,
    ! [B: $tType,A: $tType,R3: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),S: set(product_prod(set(old_node(A,B)),set(old_node(A,B))))] : ( old_dprod(A,B,R3,S) = aa(set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),complete_Sup_Sup(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),image2(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),fun(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),product_case_prod(set(old_node(A,B)),set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_wo(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),S))),R3)) ) ).

% dprod_def
tff(fact_5542_dual__order_Opreordering__axioms,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => preordering(A,aTP_Lamp_wf(A,fun(A,bool)),aTP_Lamp_wp(A,fun(A,bool))) ) ).

% dual_order.preordering_axioms
tff(fact_5543_curr__def,axiom,
    ! [A: $tType,C: $tType,B: $tType,A4: set(A),F: fun(product_prod(A,B),C),X3: A] :
      ( ( pp(member(A,X3,A4))
       => ( bNF_Wellorder_curr(A,B,C,A4,F,X3) = aa(A,fun(B,C),aTP_Lamp_et(fun(product_prod(A,B),C),fun(A,fun(B,C)),F),X3) ) )
      & ( ~ pp(member(A,X3,A4))
       => ( bNF_Wellorder_curr(A,B,C,A4,F,X3) = undefined(fun(B,C)) ) ) ) ).

% curr_def
tff(fact_5544_dprodI,axiom,
    ! [B: $tType,A: $tType,M: set(old_node(A,B)),M8: set(old_node(A,B)),R3: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),N4: set(old_node(A,B)),N7: set(old_node(A,B)),S: set(product_prod(set(old_node(A,B)),set(old_node(A,B))))] :
      ( pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),M),M8),R3))
     => ( pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),N4),N7),S))
       => pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_Scons(A,B,M,N4)),old_Scons(A,B,M8,N7)),old_dprod(A,B,R3,S))) ) ) ).

% dprodI
tff(fact_5545_dprodE,axiom,
    ! [B: $tType,A: $tType,C2: product_prod(set(old_node(A,B)),set(old_node(A,B))),R3: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),S: set(product_prod(set(old_node(A,B)),set(old_node(A,B))))] :
      ( pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),C2,old_dprod(A,B,R3,S)))
     => ~ ! [X2: set(old_node(A,B)),Y2: set(old_node(A,B)),X9: set(old_node(A,B))] :
            ( pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),X2),X9),R3))
           => ! [Y7: set(old_node(A,B))] :
                ( pp(member(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),Y2),Y7),S))
               => ( C2 != aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_Scons(A,B,X2,Y2)),old_Scons(A,B,X9,Y7)) ) ) ) ) ).

% dprodE
tff(fact_5546_preordering__dualI,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( preordering(A,aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Less_eq),aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Less))
     => preordering(A,Less_eq,Less) ) ).

% preordering_dualI
tff(fact_5547_preordering__strictI,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( ! [A8: A,B5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A8),B5))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),B5))
            | ( A8 = B5 ) ) )
     => ( ! [A8: A,B5: A] :
            ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),B5))
           => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,B5),A8)) )
       => ( ! [A8: A] : ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),A8))
         => ( ! [A8: A,B5: A,C4: A] :
                ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),B5))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B5),C4))
                 => pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),C4)) ) )
           => preordering(A,Less_eq,Less) ) ) ) ) ).

% preordering_strictI
tff(fact_5548_preordering_Ostrict__implies__order,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
       => pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2)) ) ) ).

% preordering.strict_implies_order
tff(fact_5549_preordering_Ostrict__iff__not,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
      <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
          & ~ pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B2),A3)) ) ) ) ).

% preordering.strict_iff_not
tff(fact_5550_preordering_Ostrict__trans2,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A,C2: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),C2)) ) ) ) ).

% preordering.strict_trans2
tff(fact_5551_preordering_Ostrict__trans1,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A,C2: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A3),B2))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),C2)) ) ) ) ).

% preordering.strict_trans1
tff(fact_5552_preordering_Ostrict__trans,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A,C2: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
       => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,B2),C2))
         => pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),C2)) ) ) ) ).

% preordering.strict_trans
tff(fact_5553_preordering_Oirrefl,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A] :
      ( preordering(A,Less_eq,Less)
     => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),A3)) ) ).

% preordering.irrefl
tff(fact_5554_preordering_Oasym,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool)),A3: A,B2: A] :
      ( preordering(A,Less_eq,Less)
     => ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A3),B2))
       => ~ pp(aa(A,bool,aa(A,fun(A,bool),Less,B2),A3)) ) ) ).

% preordering.asym
tff(fact_5555_preordering_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( preordering(A,Less_eq,Less)
     => partial_preordering(A,Less_eq) ) ).

% preordering.axioms(1)
tff(fact_5556_order_Opreordering__axioms,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => preordering(A,ord_less_eq(A),ord_less(A)) ) ).

% order.preordering_axioms
tff(fact_5557_preordering_Ointro,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( partial_preordering(A,Less_eq)
     => ( preordering_axioms(A,Less_eq,Less)
       => preordering(A,Less_eq,Less) ) ) ).

% preordering.intro
tff(fact_5558_preordering__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( preordering(A,Less_eq,Less)
    <=> ( partial_preordering(A,Less_eq)
        & preordering_axioms(A,Less_eq,Less) ) ) ).

% preordering_def
tff(fact_5559_preordering_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( preordering(A,Less_eq,Less)
     => preordering_axioms(A,Less_eq,Less) ) ).

% preordering.axioms(2)
tff(fact_5560_preordering__axioms_Ointro,axiom,
    ! [A: $tType,Less: fun(A,fun(A,bool)),Less_eq: fun(A,fun(A,bool))] :
      ( ! [A8: A,B5: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A8),B5))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A8),B5))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B5),A8)) ) )
     => preordering_axioms(A,Less_eq,Less) ) ).

% preordering_axioms.intro
tff(fact_5561_preordering__axioms__def,axiom,
    ! [A: $tType,Less_eq: fun(A,fun(A,bool)),Less: fun(A,fun(A,bool))] :
      ( preordering_axioms(A,Less_eq,Less)
    <=> ! [A6: A,B6: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),Less,A6),B6))
        <=> ( pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,A6),B6))
            & ~ pp(aa(A,bool,aa(A,fun(A,bool),Less_eq,B6),A6)) ) ) ) ).

% preordering_axioms_def
tff(fact_5562_rotate__add,axiom,
    ! [A: $tType,M4: nat,N: nat] : ( rotate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),N)) = aa(fun(list(A),list(A)),fun(list(A),list(A)),aa(fun(list(A),list(A)),fun(fun(list(A),list(A)),fun(list(A),list(A))),comp(list(A),list(A),list(A)),rotate(A,M4)),rotate(A,N)) ) ).

% rotate_add
tff(fact_5563_extract__def,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( extract(A,P,Xs) = case_list(option(product_prod(list(A),product_prod(A,list(A)))),A,none(product_prod(list(A),product_prod(A,list(A)))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_wq(fun(A,bool),fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),P),Xs),dropWhile(A,aa(fun(A,bool),fun(A,bool),aa(fun(bool,bool),fun(fun(A,bool),fun(A,bool)),comp(bool,bool,A),fNot),P),Xs)) ) ).

% extract_def
tff(fact_5564_relH__def,axiom,
    ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( relH(As,H2,H4)
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)))
        & ! [T7: typerep,X4: nat] :
            ( pp(member(nat,X4,As))
           => ( ( aa(nat,nat,refs(product_unit,H2,T7),X4) = aa(nat,nat,refs(product_unit,H4,T7),X4) )
              & ( arrays(product_unit,H2,T7,X4) = arrays(product_unit,H4,T7,X4) ) ) ) ) ) ).

% relH_def
tff(fact_5565_zip__takeWhile__snd,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),P: fun(B,bool),Ys: list(B)] : ( zip(A,B,Xs,takeWhile(B,P,Ys)) = takeWhile(product_prod(A,B),aa(fun(product_prod(A,B),B),fun(product_prod(A,B),bool),aa(fun(B,bool),fun(fun(product_prod(A,B),B),fun(product_prod(A,B),bool)),comp(B,bool,product_prod(A,B)),P),product_snd(A,B)),zip(A,B,Xs,Ys)) ) ).

% zip_takeWhile_snd
tff(fact_5566_zip__takeWhile__fst,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),Xs: list(A),Ys: list(B)] : ( zip(A,B,takeWhile(A,P,Xs),Ys) = takeWhile(product_prod(A,B),aa(fun(product_prod(A,B),A),fun(product_prod(A,B),bool),aa(fun(A,bool),fun(fun(product_prod(A,B),A),fun(product_prod(A,B),bool)),comp(A,bool,product_prod(A,B)),P),product_fst(A,B)),zip(A,B,Xs,Ys)) ) ).

% zip_takeWhile_fst
tff(fact_5567_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F: fun(B,A),Xs: list(B)] : ( takeWhile(A,P,aa(list(B),list(A),map(B,A,F),Xs)) = aa(list(B),list(A),map(B,A,F),takeWhile(B,aa(fun(B,A),fun(B,bool),aa(fun(A,bool),fun(fun(B,A),fun(B,bool)),comp(A,bool,B),P),F),Xs)) ) ).

% takeWhile_map
tff(fact_5568_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P: fun(A,bool),F: fun(B,A),Xs: list(B)] : ( dropWhile(A,P,aa(list(B),list(A),map(B,A,F),Xs)) = aa(list(B),list(A),map(B,A,F),dropWhile(B,aa(fun(B,A),fun(B,bool),aa(fun(A,bool),fun(fun(B,A),fun(B,bool)),comp(A,bool,B),P),F),Xs)) ) ).

% dropWhile_map
tff(fact_5569_find__dropWhile,axiom,
    ! [A: $tType,P: fun(A,bool),Xs: list(A)] : ( find(A,P,Xs) = case_list(option(A),A,none(A),aTP_Lamp_wr(A,fun(list(A),option(A))),dropWhile(A,aa(fun(A,bool),fun(A,bool),aa(fun(bool,bool),fun(fun(A,bool),fun(A,bool)),comp(bool,bool,A),fNot),P),Xs)) ) ).

% find_dropWhile
tff(fact_5570_Ref__Time_Oget__def,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [H2: heap_ext(product_unit)] : ( ref_get(A,H2) = aa(fun(ref(A),nat),fun(ref(A),A),aa(fun(nat,A),fun(fun(ref(A),nat),fun(ref(A),A)),comp(nat,A,ref(A)),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),from_nat(A)),refs(product_unit,H2,typerep_typerep(A,type2(A))))),addr_of_ref(A)) ) ) ).

% Ref_Time.get_def
tff(fact_5571_sum_Opred__map,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,Q1: fun(C,bool),Q22: fun(D,bool),F1: fun(A,C),F22: fun(B,D),X: sum_sum(A,B)] :
      ( basic_pred_sum(C,D,Q1,Q22,aa(sum_sum(A,B),sum_sum(C,D),sum_map_sum(A,C,B,D,F1,F22),X))
    <=> basic_pred_sum(A,B,aa(fun(A,C),fun(A,bool),aa(fun(C,bool),fun(fun(A,C),fun(A,bool)),comp(C,bool,A),Q1),F1),aa(fun(B,D),fun(B,bool),aa(fun(D,bool),fun(fun(B,D),fun(B,bool)),comp(D,bool,B),Q22),F22),X) ) ).

% sum.pred_map
tff(fact_5572_in__range_Opelims_I3_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
               => ! [X2: nat] :
                    ( pp(member(nat,X2,As2))
                   => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X2),lim(product_unit,H))) ) ) ) ) ) ).

% in_range.pelims(3)
tff(fact_5573_in__range_Opelims_I2_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
               => ~ ! [X3: nat] :
                      ( pp(member(nat,X3,As2))
                     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X3),lim(product_unit,H))) ) ) ) ) ) ).

% in_range.pelims(2)
tff(fact_5574_in__range_Opelims_I1_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,X))
      <=> pp(Y) )
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( ( pp(Y)
                <=> ! [X4: nat] :
                      ( pp(member(nat,X4,As2))
                     => pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),X4),lim(product_unit,H))) ) )
               => ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))) ) ) ) ) ).

% in_range.pelims(1)
tff(fact_5575_one__assn__raw_Opelims_I3_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
               => ( As2 = bot_bot(set(nat)) ) ) ) ) ) ).

% one_assn_raw.pelims(3)
tff(fact_5576_one__assn__raw_Opelims_I2_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X))
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))
               => ( As2 != bot_bot(set(nat)) ) ) ) ) ) ).

% one_assn_raw.pelims(2)
tff(fact_5577_one__assn__raw_Opelims_I1_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat)),Y: bool] :
      ( ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,one_assn_raw,X))
      <=> pp(Y) )
     => ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( ( pp(Y)
                <=> ( As2 = bot_bot(set(nat)) ) )
               => ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))) ) ) ) ) ).

% one_assn_raw.pelims(1)
tff(fact_5578_Enum_Ortranclp__rtrancl__eq,axiom,
    ! [A: $tType,R3: fun(A,fun(A,bool)),X: A,Y: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),transitive_rtranclp(A,R3),X),Y))
    <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X),Y),transitive_rtrancl(A,aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),R3))))) ) ).

% Enum.rtranclp_rtrancl_eq
tff(fact_5579_rtrancl__def,axiom,
    ! [A: $tType,X3: set(product_prod(A,A))] : ( transitive_rtrancl(A,X3) = aa(fun(product_prod(A,A),bool),set(product_prod(A,A)),collect(product_prod(A,A)),aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),transitive_rtranclp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),X3)))) ) ).

% rtrancl_def
tff(fact_5580_Quotient__compose,axiom,
    ! [A: $tType,C: $tType,B: $tType,R12: fun(A,fun(A,bool)),Abs1: fun(A,B),Rep1: fun(B,A),T1: fun(A,fun(B,bool)),R23: fun(B,fun(B,bool)),Abs22: fun(B,C),Rep22: fun(C,B),T22: fun(B,fun(C,bool))] :
      ( quotient(A,B,R12,Abs1,Rep1,T1)
     => ( quotient(B,C,R23,Abs22,Rep22,T22)
       => quotient(A,C,relcompp(A,B,A,T1,relcompp(B,B,A,R23,conversep(A,B,T1))),aa(fun(A,B),fun(A,C),aa(fun(B,C),fun(fun(A,B),fun(A,C)),comp(B,C,A),Abs22),Abs1),aa(fun(C,B),fun(C,A),aa(fun(B,A),fun(fun(C,B),fun(C,A)),comp(B,A,C),Rep1),Rep22),relcompp(A,B,C,T1,T22)) ) ) ).

% Quotient_compose
tff(fact_5581_rtranclp__induct2,axiom,
    ! [A: $tType,B: $tType,R3: fun(product_prod(A,B),fun(product_prod(A,B),bool)),Ax: A,Ay: B,Bx: A,By: B,P: fun(A,fun(B,bool))] :
      ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),transitive_rtranclp(product_prod(A,B),R3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Bx),By)))
     => ( pp(aa(B,bool,aa(A,fun(B,bool),P,Ax),Ay))
       => ( ! [A8: A,B5: B,Aa2: A,Ba: B] :
              ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),transitive_rtranclp(product_prod(A,B),R3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)))
             => ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),R3,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Aa2),Ba)))
               => ( pp(aa(B,bool,aa(A,fun(B,bool),P,A8),B5))
                 => pp(aa(B,bool,aa(A,fun(B,bool),P,Aa2),Ba)) ) ) )
         => pp(aa(B,bool,aa(A,fun(B,bool),P,Bx),By)) ) ) ) ).

% rtranclp_induct2
tff(fact_5582_converse__rtranclpE2,axiom,
    ! [A: $tType,B: $tType,R3: fun(product_prod(A,B),fun(product_prod(A,B),bool)),Xa: A,Xb: B,Za2: A,Zb: B] :
      ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),transitive_rtranclp(product_prod(A,B),R3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Xa),Xb)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Za2),Zb)))
     => ( ( aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Xa),Xb) != aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Za2),Zb) )
       => ~ ! [A8: A,B5: B] :
              ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),R3,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Xa),Xb)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)))
             => ~ pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),transitive_rtranclp(product_prod(A,B),R3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Za2),Zb))) ) ) ) ).

% converse_rtranclpE2
tff(fact_5583_converse__rtranclp__induct2,axiom,
    ! [A: $tType,B: $tType,R3: fun(product_prod(A,B),fun(product_prod(A,B),bool)),Ax: A,Ay: B,Bx: A,By: B,P: fun(A,fun(B,bool))] :
      ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),transitive_rtranclp(product_prod(A,B),R3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Ax),Ay)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Bx),By)))
     => ( pp(aa(B,bool,aa(A,fun(B,bool),P,Bx),By))
       => ( ! [A8: A,B5: B,Aa2: A,Ba: B] :
              ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),R3,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A8),B5)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Aa2),Ba)))
             => ( pp(aa(product_prod(A,B),bool,aa(product_prod(A,B),fun(product_prod(A,B),bool),transitive_rtranclp(product_prod(A,B),R3),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Aa2),Ba)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Bx),By)))
               => ( pp(aa(B,bool,aa(A,fun(B,bool),P,Aa2),Ba))
                 => pp(aa(B,bool,aa(A,fun(B,bool),P,A8),B5)) ) ) )
         => pp(aa(B,bool,aa(A,fun(B,bool),P,Ax),Ay)) ) ) ) ).

% converse_rtranclp_induct2
tff(fact_5584_Heap_OQuotient,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(A,bool)),Abs: fun(A,B),Rep: fun(B,A),T3: fun(A,fun(B,bool))] :
      ( quotient(A,B,R,Abs,Rep,T3)
     => quotient(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,fun(A,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool)),heap_Time_rel_Heap(A,A),R),aa(fun(A,B),fun(heap_Time_Heap(A),heap_Time_Heap(B)),heap_Time_map_Heap(A,B),Abs),aa(fun(B,A),fun(heap_Time_Heap(B),heap_Time_Heap(A)),heap_Time_map_Heap(B,A),Rep),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),T3)) ) ).

% Heap.Quotient
tff(fact_5585_rtranclp__r__diff__Id,axiom,
    ! [A: $tType,R3: fun(A,fun(A,bool))] : ( transitive_rtranclp(A,aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),inf_inf(fun(A,fun(A,bool))),R3),aTP_Lamp_ws(A,fun(A,bool)))) = transitive_rtranclp(A,R3) ) ).

% rtranclp_r_diff_Id
tff(fact_5586_Transitive__Closure_Ortranclp__rtrancl__eq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X3: A,Xa3: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),transitive_rtranclp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3)),X3),Xa3))
    <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X3),Xa3),transitive_rtrancl(A,R3))) ) ).

% Transitive_Closure.rtranclp_rtrancl_eq
tff(fact_5587_accp__acc__eq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),X3: A] :
      ( pp(aa(A,bool,accp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3)),X3))
    <=> pp(member(A,X3,acc(A,R3))) ) ).

% accp_acc_eq
tff(fact_5588_acc__def,axiom,
    ! [A: $tType,X3: set(product_prod(A,A))] : ( acc(A,X3) = aa(fun(A,bool),set(A),collect(A),accp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),X3))) ) ).

% acc_def
tff(fact_5589_map__mmupd__empty,axiom,
    ! [B: $tType,A: $tType,M4: fun(A,option(B)),V: B] : ( map_mmupd(A,B,M4,bot_bot(set(A)),V) = M4 ) ).

% map_mmupd_empty
tff(fact_5590_acc_Ocases,axiom,
    ! [A: $tType,A3: A,R3: set(product_prod(A,A))] :
      ( pp(member(A,A3,acc(A,R3)))
     => ! [Y4: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),A3),R3))
         => pp(member(A,Y4,acc(A,R3))) ) ) ).

% acc.cases
tff(fact_5591_acc_Osimps,axiom,
    ! [A: $tType,A3: A,R3: set(product_prod(A,A))] :
      ( pp(member(A,A3,acc(A,R3)))
    <=> ? [X4: A] :
          ( ( A3 = X4 )
          & ! [Xa2: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa2),X4),R3))
             => pp(member(A,Xa2,acc(A,R3))) ) ) ) ).

% acc.simps
tff(fact_5592_acc_Ointros,axiom,
    ! [A: $tType,X: A,R3: set(product_prod(A,A))] :
      ( ! [Y2: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y2),X),R3))
         => pp(member(A,Y2,acc(A,R3))) )
     => pp(member(A,X,acc(A,R3))) ) ).

% acc.intros
tff(fact_5593_acc__induct,axiom,
    ! [A: $tType,A3: A,R3: set(product_prod(A,A)),P: fun(A,bool)] :
      ( pp(member(A,A3,acc(A,R3)))
     => ( ! [X2: A] :
            ( pp(member(A,X2,acc(A,R3)))
           => ( ! [Y4: A] :
                  ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),X2),R3))
                 => pp(aa(A,bool,P,Y4)) )
             => pp(aa(A,bool,P,X2)) ) )
       => pp(aa(A,bool,P,A3)) ) ) ).

% acc_induct
tff(fact_5594_acc__downward,axiom,
    ! [A: $tType,B2: A,R3: set(product_prod(A,A)),A3: A] :
      ( pp(member(A,B2,acc(A,R3)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3))
       => pp(member(A,A3,acc(A,R3))) ) ) ).

% acc_downward
tff(fact_5595_not__acc__down,axiom,
    ! [A: $tType,X: A,R: set(product_prod(A,A))] :
      ( ~ pp(member(A,X,acc(A,R)))
     => ~ ! [Z3: A] :
            ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z3),X),R))
           => pp(member(A,Z3,acc(A,R))) ) ) ).

% not_acc_down
tff(fact_5596_acc__induct__rule,axiom,
    ! [A: $tType,A3: A,R3: set(product_prod(A,A)),P: fun(A,bool)] :
      ( pp(member(A,A3,acc(A,R3)))
     => ( ! [X2: A] :
            ( pp(member(A,X2,acc(A,R3)))
           => ( ! [Y4: A] :
                  ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y4),X2),R3))
                 => pp(aa(A,bool,P,Y4)) )
             => pp(aa(A,bool,P,X2)) ) )
       => pp(aa(A,bool,P,A3)) ) ) ).

% acc_induct_rule
tff(fact_5597_acc__subset__induct,axiom,
    ! [A: $tType,D4: set(A),R: set(product_prod(A,A)),X: A,P: fun(A,bool)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),D4),acc(A,R)))
     => ( ! [X2: A,Z3: A] :
            ( pp(member(A,X2,D4))
           => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z3),X2),R))
             => pp(member(A,Z3,D4)) ) )
       => ( pp(member(A,X,D4))
         => ( ! [X2: A] :
                ( pp(member(A,X2,D4))
               => ( ! [Z5: A] :
                      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z5),X2),R))
                     => pp(aa(A,bool,P,Z5)) )
                 => pp(aa(A,bool,P,X2)) ) )
           => pp(aa(A,bool,P,X)) ) ) ) ) ).

% acc_subset_induct
tff(fact_5598_acc__downwards__aux,axiom,
    ! [A: $tType,B2: A,A3: A,R3: set(product_prod(A,A))] :
      ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),A3),transitive_rtrancl(A,R3)))
     => ( pp(member(A,A3,acc(A,R3)))
       => pp(member(A,B2,acc(A,R3))) ) ) ).

% acc_downwards_aux
tff(fact_5599_acc__downwards,axiom,
    ! [A: $tType,A3: A,R3: set(product_prod(A,A)),B2: A] :
      ( pp(member(A,A3,acc(A,R3)))
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),A3),transitive_rtrancl(A,R3)))
       => pp(member(A,B2,acc(A,R3))) ) ) ).

% acc_downwards
tff(fact_5600_or__not__num__neg_Opelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( bit_or_not_num_neg(X,Xa) = Y )
     => ( pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X),Xa)))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = one2 )
               => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2))) ) ) )
         => ( ( ( X = one2 )
             => ! [M5: num] :
                  ( ( Xa = aa(num,num,bit0,M5) )
                 => ( ( Y = aa(num,num,bit1,M5) )
                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,M5)))) ) ) )
           => ( ( ( X = one2 )
               => ! [M5: num] :
                    ( ( Xa = aa(num,num,bit1,M5) )
                   => ( ( Y = aa(num,num,bit1,M5) )
                     => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,M5)))) ) ) )
             => ( ! [N3: num] :
                    ( ( X = aa(num,num,bit0,N3) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,num,bit0,one2) )
                       => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,N3)),one2))) ) ) )
               => ( ! [N3: num] :
                      ( ( X = aa(num,num,bit0,N3) )
                     => ! [M5: num] :
                          ( ( Xa = aa(num,num,bit0,M5) )
                         => ( ( Y = bitM(bit_or_not_num_neg(N3,M5)) )
                           => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,N3)),aa(num,num,bit0,M5)))) ) ) )
                 => ( ! [N3: num] :
                        ( ( X = aa(num,num,bit0,N3) )
                       => ! [M5: num] :
                            ( ( Xa = aa(num,num,bit1,M5) )
                           => ( ( Y = aa(num,num,bit0,bit_or_not_num_neg(N3,M5)) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,N3)),aa(num,num,bit1,M5)))) ) ) )
                   => ( ! [N3: num] :
                          ( ( X = aa(num,num,bit1,N3) )
                         => ( ( Xa = one2 )
                           => ( ( Y = one2 )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,N3)),one2))) ) ) )
                     => ( ! [N3: num] :
                            ( ( X = aa(num,num,bit1,N3) )
                           => ! [M5: num] :
                                ( ( Xa = aa(num,num,bit0,M5) )
                               => ( ( Y = bitM(bit_or_not_num_neg(N3,M5)) )
                                 => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,N3)),aa(num,num,bit0,M5)))) ) ) )
                       => ~ ! [N3: num] :
                              ( ( X = aa(num,num,bit1,N3) )
                             => ! [M5: num] :
                                  ( ( Xa = aa(num,num,bit1,M5) )
                                 => ( ( Y = bitM(bit_or_not_num_neg(N3,M5)) )
                                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,N3)),aa(num,num,bit1,M5)))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
tff(fact_5601_and__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( bit_un7362597486090784418nd_num(X,Xa) = Y )
     => ( pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X),Xa)))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = aa(num,option(num),some(num),one2) )
               => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2))) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa = aa(num,num,bit0,N3) )
                 => ( ( Y = none(num) )
                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N3)))) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa = aa(num,num,bit1,N3) )
                   => ( ( Y = aa(num,option(num),some(num),one2) )
                     => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N3)))) ) ) )
             => ( ! [M5: num] :
                    ( ( X = aa(num,num,bit0,M5) )
                   => ( ( Xa = one2 )
                     => ( ( Y = none(num) )
                       => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),one2))) ) ) )
               => ( ! [M5: num] :
                      ( ( X = aa(num,num,bit0,M5) )
                     => ! [N3: num] :
                          ( ( Xa = aa(num,num,bit0,N3) )
                         => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M5,N3)) )
                           => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit0,N3)))) ) ) )
                 => ( ! [M5: num] :
                        ( ( X = aa(num,num,bit0,M5) )
                       => ! [N3: num] :
                            ( ( Xa = aa(num,num,bit1,N3) )
                           => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M5,N3)) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit1,N3)))) ) ) )
                   => ( ! [M5: num] :
                          ( ( X = aa(num,num,bit1,M5) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,option(num),some(num),one2) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),one2))) ) ) )
                     => ( ! [M5: num] :
                            ( ( X = aa(num,num,bit1,M5) )
                           => ! [N3: num] :
                                ( ( Xa = aa(num,num,bit0,N3) )
                               => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M5,N3)) )
                                 => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit0,N3)))) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X = aa(num,num,bit1,M5) )
                             => ! [N3: num] :
                                  ( ( Xa = aa(num,num,bit1,N3) )
                                 => ( ( Y = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_wt(num,option(num)),bit_un7362597486090784418nd_num(M5,N3)) )
                                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit1,N3)))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
tff(fact_5602_and__not__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( bit_and_not_num(X,Xa) = Y )
     => ( pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X),Xa)))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = none(num) )
               => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2))) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa = aa(num,num,bit0,N3) )
                 => ( ( Y = aa(num,option(num),some(num),one2) )
                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N3)))) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa = aa(num,num,bit1,N3) )
                   => ( ( Y = none(num) )
                     => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N3)))) ) ) )
             => ( ! [M5: num] :
                    ( ( X = aa(num,num,bit0,M5) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,M5)) )
                       => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),one2))) ) ) )
               => ( ! [M5: num] :
                      ( ( X = aa(num,num,bit0,M5) )
                     => ! [N3: num] :
                          ( ( Xa = aa(num,num,bit0,N3) )
                         => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M5,N3)) )
                           => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit0,N3)))) ) ) )
                 => ( ! [M5: num] :
                        ( ( X = aa(num,num,bit0,M5) )
                       => ! [N3: num] :
                            ( ( Xa = aa(num,num,bit1,N3) )
                           => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M5,N3)) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit1,N3)))) ) ) )
                   => ( ! [M5: num] :
                          ( ( X = aa(num,num,bit1,M5) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,M5)) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),one2))) ) ) )
                     => ( ! [M5: num] :
                            ( ( X = aa(num,num,bit1,M5) )
                           => ! [N3: num] :
                                ( ( Xa = aa(num,num,bit0,N3) )
                               => ( ( Y = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_wt(num,option(num)),bit_and_not_num(M5,N3)) )
                                 => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit0,N3)))) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X = aa(num,num,bit1,M5) )
                             => ! [N3: num] :
                                  ( ( Xa = aa(num,num,bit1,N3) )
                                 => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M5,N3)) )
                                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit1,N3)))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
tff(fact_5603_xor__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( bit_un2480387367778600638or_num(X,Xa) = Y )
     => ( pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X),Xa)))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = none(num) )
               => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2))) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa = aa(num,num,bit0,N3) )
                 => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit1,N3)) )
                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N3)))) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa = aa(num,num,bit1,N3) )
                   => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,N3)) )
                     => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N3)))) ) ) )
             => ( ! [M5: num] :
                    ( ( X = aa(num,num,bit0,M5) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit1,M5)) )
                       => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),one2))) ) ) )
               => ( ! [M5: num] :
                      ( ( X = aa(num,num,bit0,M5) )
                     => ! [N3: num] :
                          ( ( Xa = aa(num,num,bit0,N3) )
                         => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un2480387367778600638or_num(M5,N3)) )
                           => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit0,N3)))) ) ) )
                 => ( ! [M5: num] :
                        ( ( X = aa(num,num,bit0,M5) )
                       => ! [N3: num] :
                            ( ( Xa = aa(num,num,bit1,N3) )
                           => ( ( Y = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_un2480387367778600638or_num(M5,N3))) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit1,N3)))) ) ) )
                   => ( ! [M5: num] :
                          ( ( X = aa(num,num,bit1,M5) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,M5)) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),one2))) ) ) )
                     => ( ! [M5: num] :
                            ( ( X = aa(num,num,bit1,M5) )
                           => ! [N3: num] :
                                ( ( Xa = aa(num,num,bit0,N3) )
                               => ( ( Y = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_un2480387367778600638or_num(M5,N3))) )
                                 => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit0,N3)))) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X = aa(num,num,bit1,M5) )
                             => ! [N3: num] :
                                  ( ( Xa = aa(num,num,bit1,N3) )
                                 => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un2480387367778600638or_num(M5,N3)) )
                                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit1,N3)))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.pelims
tff(fact_5604_or__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( bit_un6697907153464112080or_num(X,Xa) = Y )
     => ( pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X),Xa)))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = one2 )
               => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2))) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa = aa(num,num,bit0,N3) )
                 => ( ( Y = aa(num,num,bit1,N3) )
                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N3)))) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa = aa(num,num,bit1,N3) )
                   => ( ( Y = aa(num,num,bit1,N3) )
                     => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N3)))) ) ) )
             => ( ! [M5: num] :
                    ( ( X = aa(num,num,bit0,M5) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,num,bit1,M5) )
                       => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),one2))) ) ) )
               => ( ! [M5: num] :
                      ( ( X = aa(num,num,bit0,M5) )
                     => ! [N3: num] :
                          ( ( Xa = aa(num,num,bit0,N3) )
                         => ( ( Y = aa(num,num,bit0,bit_un6697907153464112080or_num(M5,N3)) )
                           => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit0,N3)))) ) ) )
                 => ( ! [M5: num] :
                        ( ( X = aa(num,num,bit0,M5) )
                       => ! [N3: num] :
                            ( ( Xa = aa(num,num,bit1,N3) )
                           => ( ( Y = aa(num,num,bit1,bit_un6697907153464112080or_num(M5,N3)) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit1,N3)))) ) ) )
                   => ( ! [M5: num] :
                          ( ( X = aa(num,num,bit1,M5) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,num,bit1,M5) )
                             => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),one2))) ) ) )
                     => ( ! [M5: num] :
                            ( ( X = aa(num,num,bit1,M5) )
                           => ! [N3: num] :
                                ( ( Xa = aa(num,num,bit0,N3) )
                               => ( ( Y = aa(num,num,bit1,bit_un6697907153464112080or_num(M5,N3)) )
                                 => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit0,N3)))) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X = aa(num,num,bit1,M5) )
                             => ! [N3: num] :
                                  ( ( Xa = aa(num,num,bit1,N3) )
                                 => ( ( Y = aa(num,num,bit1,bit_un6697907153464112080or_num(M5,N3)) )
                                   => ~ pp(aa(product_prod(num,num),bool,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit1,N3)))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_num.pelims
tff(fact_5605_take__bit__num__code,axiom,
    ! [N: nat,M4: num] : ( bit_take_bit_num(N,M4) = aa(product_prod(nat,num),option(num),aa(fun(nat,fun(num,option(num))),fun(product_prod(nat,num),option(num)),product_case_prod(nat,num,option(num)),aTP_Lamp_wy(nat,fun(num,option(num)))),aa(num,product_prod(nat,num),aa(nat,fun(num,product_prod(nat,num)),product_Pair(nat,num),N),M4)) ) ).

% take_bit_num_code
tff(fact_5606_multiset_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q: fun(B,bool),F: fun(A,B),X: multiset(A)] :
      ( pred_mset(B,Q,aa(multiset(A),multiset(B),image_mset(A,B,F),X))
    <=> pred_mset(A,aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),Q),F),X) ) ).

% multiset.pred_map
tff(fact_5607_prod__mset_Ocomm__monoid__mset__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => comm_monoid_mset(A,times_times(A),one_one(A)) ) ).

% prod_mset.comm_monoid_mset_axioms
tff(fact_5608_ac__operator_Osafe__commute,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),X: A,Y: A,A3: A,B2: A] :
      ( syntax_ac_operator(A,F)
     => ( syntax7388354845996824322omatch(A,A,aa(A,A,aa(A,fun(A,A),F,X),Y),A3)
       => ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = aa(A,A,aa(A,fun(A,A),F,B2),A3) ) ) ) ).

% ac_operator.safe_commute
tff(fact_5609_mult_Oac__operator__axioms,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => syntax_ac_operator(A,times_times(A)) ) ).

% mult.ac_operator_axioms
tff(fact_5610_ac__operator__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( syntax_ac_operator(A,F)
    <=> ( ! [A6: A,B6: A,C5: A] : ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,A6),B6)),C5) = aa(A,A,aa(A,fun(A,A),F,A6),aa(A,A,aa(A,fun(A,A),F,B6),C5)) )
        & ! [A6: A,B6: A] : ( aa(A,A,aa(A,fun(A,A),F,A6),B6) = aa(A,A,aa(A,fun(A,A),F,B6),A6) ) ) ) ).

% ac_operator_def
tff(fact_5611_ac__operator_Oright__commute,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A3: A,B2: A,C2: A] :
      ( syntax_ac_operator(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,A3),C2)),B2) ) ) ).

% ac_operator.right_commute
tff(fact_5612_ac__operator_Oleft__commute,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A3: A,B2: A,C2: A] :
      ( syntax_ac_operator(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,A3),aa(A,A,aa(A,fun(A,A),F,B2),C2)) = aa(A,A,aa(A,fun(A,A),F,B2),aa(A,A,aa(A,fun(A,A),F,A3),C2)) ) ) ).

% ac_operator.left_commute
tff(fact_5613_ac__operator_Oright__assoc,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A3: A,B2: A,C2: A] :
      ( syntax_ac_operator(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,A3),B2)),C2) = aa(A,A,aa(A,fun(A,A),F,A3),aa(A,A,aa(A,fun(A,A),F,B2),C2)) ) ) ).

% ac_operator.right_assoc
tff(fact_5614_ac__operator_Oleft__assoc,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A3: A,B2: A,C2: A] :
      ( syntax_ac_operator(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,A3),aa(A,A,aa(A,fun(A,A),F,B2),C2)) = aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,A3),B2)),C2) ) ) ).

% ac_operator.left_assoc
tff(fact_5615_ac__operator_Ocommute,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),A3: A,B2: A] :
      ( syntax_ac_operator(A,F)
     => ( aa(A,A,aa(A,fun(A,A),F,A3),B2) = aa(A,A,aa(A,fun(A,A),F,B2),A3) ) ) ).

% ac_operator.commute
tff(fact_5616_ac__operator_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A))] :
      ( ! [A8: A,B5: A,C4: A] : ( aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,A8),B5)),C4) = aa(A,A,aa(A,fun(A,A),F,A8),aa(A,A,aa(A,fun(A,A),F,B5),C4)) )
     => ( ! [A8: A,B5: A] : ( aa(A,A,aa(A,fun(A,A),F,A8),B5) = aa(A,A,aa(A,fun(A,A),F,B5),A8) )
       => syntax_ac_operator(A,F) ) ) ).

% ac_operator.intro
tff(fact_5617_add_Oac__operator__axioms,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => syntax_ac_operator(A,plus_plus(A)) ) ).

% add.ac_operator_axioms
tff(fact_5618_successively_Opelims_I2_J,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A)] :
      ( successively(A,X,Xa)
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),successively_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),Xa)))
       => ( ( ( Xa = nil(A) )
           => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),successively_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),nil(A)))) )
         => ( ! [X2: A] :
                ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A)) )
               => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),successively_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A))))) )
           => ~ ! [X2: A,Y2: A,Xs3: list(A)] :
                  ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs3)) )
                 => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),successively_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs3)))))
                   => ~ ( pp(aa(A,bool,aa(A,fun(A,bool),X,X2),Y2))
                        & successively(A,X,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs3)) ) ) ) ) ) ) ) ).

% successively.pelims(2)
tff(fact_5619_successively_Opelims_I1_J,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A),Y: bool] :
      ( ( successively(A,X,Xa)
      <=> pp(Y) )
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),successively_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),Xa)))
       => ( ( ( Xa = nil(A) )
           => ( pp(Y)
             => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),successively_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),nil(A)))) ) )
         => ( ! [X2: A] :
                ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A)) )
               => ( pp(Y)
                 => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),successively_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),nil(A))))) ) )
           => ~ ! [X2: A,Y2: A,Xs3: list(A)] :
                  ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs3)) )
                 => ( ( pp(Y)
                    <=> ( pp(aa(A,bool,aa(A,fun(A,bool),X,X2),Y2))
                        & successively(A,X,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs3)) ) )
                   => ~ pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),successively_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs3))))) ) ) ) ) ) ) ).

% successively.pelims(1)
tff(fact_5620_bot__in__iterates,axiom,
    ! [A: $tType] :
      ( comple9053668089753744459l_ccpo(A)
     => ! [F: fun(A,A)] : pp(member(A,aa(set(A),A,complete_Sup_Sup(A),bot_bot(set(A))),comple6359979572994053840erates(A,F))) ) ).

% bot_in_iterates
tff(fact_5621_successively_Opelims_I3_J,axiom,
    ! [A: $tType,X: fun(A,fun(A,bool)),Xa: list(A)] :
      ( ~ successively(A,X,Xa)
     => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),successively_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),Xa)))
       => ~ ! [X2: A,Y2: A,Xs3: list(A)] :
              ( ( Xa = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs3)) )
             => ( pp(aa(product_prod(fun(A,fun(A,bool)),list(A)),bool,accp(product_prod(fun(A,fun(A,bool)),list(A)),successively_rel(A)),aa(list(A),product_prod(fun(A,fun(A,bool)),list(A)),aa(fun(A,fun(A,bool)),fun(list(A),product_prod(fun(A,fun(A,bool)),list(A))),product_Pair(fun(A,fun(A,bool)),list(A)),X),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs3)))))
               => ( pp(aa(A,bool,aa(A,fun(A,bool),X,X2),Y2))
                  & successively(A,X,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y2),Xs3)) ) ) ) ) ) ).

% successively.pelims(3)
tff(fact_5622_sym__Int__converse,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] : sym(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),converse(A,A,R3))) ).

% sym_Int_converse
tff(fact_5623_comp__fun__idem__on__axioms__def,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B))] :
      ( finite4980608107308702382axioms(A,B,S2,F)
    <=> ! [X4: A] :
          ( pp(member(A,X4,S2))
         => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X4)),aa(A,fun(B,B),F,X4)) = aa(A,fun(B,B),F,X4) ) ) ) ).

% comp_fun_idem_on_axioms_def
tff(fact_5624_folding__idem__on__axioms__def,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B))] :
      ( finite6916993218817215295axioms(A,B,S2,F)
    <=> ! [X4: A,Y3: A] :
          ( pp(member(A,X4,S2))
         => ( pp(member(A,Y3,S2))
           => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X4)),aa(A,fun(B,B),F,X4)) = aa(A,fun(B,B),F,X4) ) ) ) ) ).

% folding_idem_on_axioms_def
tff(fact_5625_symD,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B2: A,A3: A] :
      ( sym(A,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),A3),R3))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3)) ) ) ).

% symD
tff(fact_5626_symE,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),B2: A,A3: A] :
      ( sym(A,R3)
     => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B2),A3),R3))
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A3),B2),R3)) ) ) ).

% symE
tff(fact_5627_symI,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( ! [A8: A,B5: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A8),B5),R3))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B5),A8),R3)) )
     => sym(A,R3) ) ).

% symI
tff(fact_5628_sym__def,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( sym(A,R3)
    <=> ! [X4: A,Y3: A] :
          ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Y3),R3))
         => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Y3),X4),R3)) ) ) ).

% sym_def
tff(fact_5629_sym__Int,axiom,
    ! [A: $tType,R3: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( sym(A,R3)
     => ( sym(A,S)
       => sym(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R3),S)) ) ) ).

% sym_Int
tff(fact_5630_folding__idem__on__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B))] :
      ( ! [X2: A,Y2: A] :
          ( pp(member(A,X2,S2))
         => ( pp(member(A,Y2,S2))
           => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,X2)) = aa(A,fun(B,B),F,X2) ) ) )
     => finite6916993218817215295axioms(A,B,S2,F) ) ).

% folding_idem_on_axioms.intro
tff(fact_5631_comp__fun__idem__on__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B))] :
      ( ! [X2: A] :
          ( pp(member(A,X2,S2))
         => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,X2)) = aa(A,fun(B,B),F,X2) ) )
     => finite4980608107308702382axioms(A,B,S2,F) ) ).

% comp_fun_idem_on_axioms.intro
tff(fact_5632_folding__idem__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B))] :
      ( ! [X2: A] : ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,X2)) = aa(A,fun(B,B),F,X2) )
     => finite7837460588564673216axioms(A,B,F) ) ).

% folding_idem_axioms.intro
tff(fact_5633_comp__fun__idem__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B))] :
      ( ! [X2: A] : ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,X2)) = aa(A,fun(B,B),F,X2) )
     => finite1981172056906289455axioms(A,B,F) ) ).

% comp_fun_idem_axioms.intro
tff(fact_5634_folding__idem__axioms__def,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B))] :
      ( finite7837460588564673216axioms(A,B,F)
    <=> ! [X4: A] : ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X4)),aa(A,fun(B,B),F,X4)) = aa(A,fun(B,B),F,X4) ) ) ).

% folding_idem_axioms_def
tff(fact_5635_comp__fun__idem__axioms__def,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B))] :
      ( finite1981172056906289455axioms(A,B,F)
    <=> ! [X4: A] : ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X4)),aa(A,fun(B,B),F,X4)) = aa(A,fun(B,B),F,X4) ) ) ).

% comp_fun_idem_axioms_def
tff(fact_5636_curry__conv,axiom,
    ! [A: $tType,B: $tType,C: $tType,F: fun(product_prod(B,C),A),A3: B,B2: C] : ( product_curry(B,C,A,F,A3,B2) = aa(product_prod(B,C),A,F,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),B2)) ) ).

% curry_conv
tff(fact_5637_vimage__right__total__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,B3: fun(A,fun(B,bool)),A4: fun(C,fun(D,bool))] :
      ( bi_unique(A,B,B3)
     => ( right_total(C,D,A4)
       => pp(aa(fun(fun(D,B),fun(set(B),set(D))),bool,aa(fun(fun(C,A),fun(set(A),set(C))),fun(fun(fun(D,B),fun(set(B),set(D))),bool),bNF_rel_fun(fun(C,A),fun(D,B),fun(set(A),set(C)),fun(set(B),set(D)),bNF_rel_fun(C,D,A,B,A4,B3),bNF_rel_fun(set(A),set(B),set(C),set(D),bNF_rel_set(A,B,B3),bNF_rel_set(C,D,A4))),aTP_Lamp_wz(fun(C,fun(D,bool)),fun(fun(C,A),fun(set(A),set(C))),A4)),vimage(D,B))) ) ) ).

% vimage_right_total_transfer
tff(fact_5638_uprod__def,axiom,
    ! [B: $tType,A: $tType,A4: set(set(old_node(A,B))),B3: set(set(old_node(A,B)))] : ( old_uprod(A,B,A4,B3) = aa(set(set(set(old_node(A,B)))),set(set(old_node(A,B))),complete_Sup_Sup(set(set(old_node(A,B)))),aa(set(set(old_node(A,B))),set(set(set(old_node(A,B)))),image2(set(old_node(A,B)),set(set(old_node(A,B))),aTP_Lamp_xb(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),B3)),A4)) ) ).

% uprod_def
tff(fact_5639_curryI,axiom,
    ! [A: $tType,B: $tType,F: fun(product_prod(A,B),bool),A3: A,B2: B] :
      ( pp(aa(product_prod(A,B),bool,F,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2)))
     => pp(product_curry(A,B,bool,F,A3,B2)) ) ).

% curryI
tff(fact_5640_curryD,axiom,
    ! [A: $tType,B: $tType,F: fun(product_prod(A,B),bool),A3: A,B2: B] :
      ( pp(product_curry(A,B,bool,F,A3,B2))
     => pp(aa(product_prod(A,B),bool,F,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2))) ) ).

% curryD
tff(fact_5641_curryE,axiom,
    ! [A: $tType,B: $tType,F: fun(product_prod(A,B),bool),A3: A,B2: B] :
      ( pp(product_curry(A,B,bool,F,A3,B2))
     => pp(aa(product_prod(A,B),bool,F,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A3),B2))) ) ).

% curryE
tff(fact_5642_Heap_Obi__unique__rel,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] :
      ( bi_unique(A,B,R)
     => bi_unique(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R)) ) ).

% Heap.bi_unique_rel
tff(fact_5643_Heap_Oright__total__rel,axiom,
    ! [B: $tType,A: $tType,R: fun(A,fun(B,bool))] :
      ( right_total(A,B,R)
     => right_total(heap_Time_Heap(A),heap_Time_Heap(B),aa(fun(A,fun(B,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),bool)),heap_Time_rel_Heap(A,B),R)) ) ).

% Heap.right_total_rel
tff(fact_5644_inter__transfer,axiom,
    ! [A: $tType,B: $tType,A4: fun(A,fun(B,bool))] :
      ( bi_unique(A,B,A4)
     => pp(aa(fun(set(B),fun(set(B),set(B))),bool,aa(fun(set(A),fun(set(A),set(A))),fun(fun(set(B),fun(set(B),set(B))),bool),bNF_rel_fun(set(A),set(B),fun(set(A),set(A)),fun(set(B),set(B)),bNF_rel_set(A,B,A4),bNF_rel_fun(set(A),set(B),set(A),set(B),bNF_rel_set(A,B,A4),bNF_rel_set(A,B,A4))),inf_inf(set(A))),inf_inf(set(B)))) ) ).

% inter_transfer
tff(fact_5645_right__total__Inter__transfer,axiom,
    ! [A: $tType,B: $tType,A4: fun(A,fun(B,bool))] :
      ( bi_unique(A,B,A4)
     => ( right_total(A,B,A4)
       => pp(aa(fun(set(set(B)),set(B)),bool,aa(fun(set(set(A)),set(A)),fun(fun(set(set(B)),set(B)),bool),bNF_rel_fun(set(set(A)),set(set(B)),set(A),set(B),bNF_rel_set(set(A),set(B),bNF_rel_set(A,B,A4)),bNF_rel_set(A,B,A4)),aTP_Lamp_xc(fun(A,fun(B,bool)),fun(set(set(A)),set(A)),A4)),complete_Inf_Inf(set(B)))) ) ) ).

% right_total_Inter_transfer
tff(fact_5646_right__total__Compl__transfer,axiom,
    ! [A: $tType,B: $tType,A4: fun(A,fun(B,bool))] :
      ( bi_unique(A,B,A4)
     => ( right_total(A,B,A4)
       => pp(aa(fun(set(B),set(B)),bool,aa(fun(set(A),set(A)),fun(fun(set(B),set(B)),bool),bNF_rel_fun(set(A),set(B),set(A),set(B),bNF_rel_set(A,B,A4),bNF_rel_set(A,B,A4)),aTP_Lamp_xd(fun(A,fun(B,bool)),fun(set(A),set(A)),A4)),uminus_uminus(set(B)))) ) ) ).

% right_total_Compl_transfer
tff(fact_5647_curry__def,axiom,
    ! [C: $tType,A: $tType,B: $tType,X3: fun(product_prod(A,B),C),Xa3: A,Xb2: B] : ( product_curry(A,B,C,X3,Xa3,Xb2) = aa(product_prod(A,B),C,X3,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Xa3),Xb2)) ) ).

% curry_def
tff(fact_5648_Rats__eq__range__of__rat__o__nat__to__rat__surj,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( field_char_0_Rats(A) = aa(set(nat),set(A),image2(nat,A,aa(fun(nat,rat),fun(nat,A),aa(fun(rat,A),fun(fun(nat,rat),fun(nat,A)),comp(rat,A,nat),field_char_0_of_rat(A)),nat_to_rat_surj)),top_top(set(nat))) ) ) ).

% Rats_eq_range_of_rat_o_nat_to_rat_surj
tff(fact_5649_symp__sym__eq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( symp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3))
    <=> sym(A,R3) ) ).

% symp_sym_eq
tff(fact_5650_remove__rev__def,axiom,
    ! [A: $tType,X: A] : ( remove_rev(A,X) = filter_rev(A,aa(fun(A,bool),fun(A,bool),aa(fun(bool,bool),fun(fun(A,bool),fun(A,bool)),comp(bool,bool,A),fNot),aa(A,fun(A,bool),fequal(A),X))) ) ).

% remove_rev_def
tff(fact_5651_symp__inf,axiom,
    ! [A: $tType,R3: fun(A,fun(A,bool)),S: fun(A,fun(A,bool))] :
      ( symp(A,R3)
     => ( symp(A,S)
       => symp(A,aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),inf_inf(fun(A,fun(A,bool))),R3),S)) ) ) ).

% symp_inf
tff(fact_5652_Heap_Orel__symp,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool))] :
      ( symp(A,R)
     => symp(heap_Time_Heap(A),aa(fun(A,fun(A,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool)),heap_Time_rel_Heap(A,A),R)) ) ).

% Heap.rel_symp
tff(fact_5653_Rats__mult,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A3: A,B2: A] :
          ( pp(member(A,A3,field_char_0_Rats(A)))
         => ( pp(member(A,B2,field_char_0_Rats(A)))
           => pp(member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A3),B2),field_char_0_Rats(A))) ) ) ) ).

% Rats_mult
tff(fact_5654_Rats__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => pp(member(A,one_one(A),field_char_0_Rats(A))) ) ).

% Rats_1
tff(fact_5655_comm__monoid__set_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,M4: nat,N: nat,G: fun(nat,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),M4),N))
       => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),G),set_or1337092689740270186AtMost(nat,M4,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ) ).

% comm_monoid_set.atLeastAtMost_shift_0
tff(fact_5656_comm__monoid__mult__class_Oprod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ( groups7121269368397514597t_prod(B,A) = groups_comm_monoid_F(A,B,times_times(A),one_one(A)) ) ) ).

% comm_monoid_mult_class.prod_def
tff(fact_5657_eventually__prod__sequentially,axiom,
    ! [P: fun(product_prod(nat,nat),bool)] :
      ( eventually(product_prod(nat,nat),P,prod_filter(nat,nat,at_top(nat),at_top(nat)))
    <=> ? [N8: nat] :
        ! [M3: nat] :
          ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N8),M3))
         => ! [N5: nat] :
              ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),N8),N5))
             => pp(aa(product_prod(nat,nat),bool,P,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),N5),M3))) ) ) ) ).

% eventually_prod_sequentially
tff(fact_5658_trivial__limit__sequentially,axiom,
    at_top(nat) != bot_bot(filter(nat)) ).

% trivial_limit_sequentially
tff(fact_5659_comm__monoid__set_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),H2: fun(B,C),G: fun(C,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( ! [X2: B,Y2: B] :
              ( pp(member(B,X2,A4))
             => ( pp(member(B,Y2,A4))
               => ( ( X2 != Y2 )
                 => ( ( aa(B,C,H2,X2) = aa(B,C,H2,Y2) )
                   => ( aa(C,A,G,aa(B,C,H2,X2)) = Z2 ) ) ) ) )
         => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F,Z2),G),aa(set(B),set(C),image2(B,C,H2),A4)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),aa(fun(B,C),fun(B,A),aa(fun(C,A),fun(fun(B,C),fun(B,A)),comp(C,A,B),G),H2)),A4) ) ) ) ) ).

% comm_monoid_set.reindex_nontrivial
tff(fact_5660_comm__monoid__set_OUnion__comp,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,B3: set(set(B)),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( ! [X2: set(B)] :
            ( pp(member(set(B),X2,B3))
           => pp(aa(set(B),bool,finite_finite(B),X2)) )
       => ( ! [A15: set(B)] :
              ( pp(member(set(B),A15,B3))
             => ! [A24: set(B)] :
                  ( pp(member(set(B),A24,B3))
                 => ( ( A15 != A24 )
                   => ! [X2: B] :
                        ( pp(member(B,X2,A15))
                       => ( pp(member(B,X2,A24))
                         => ( aa(B,A,G,X2) = Z2 ) ) ) ) ) )
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B3)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),aa(fun(fun(set(B),A),fun(set(set(B)),A)),fun(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A))),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A)),groups_comm_monoid_F(A,set(B),F,Z2)),groups_comm_monoid_F(A,B,F,Z2)),G),B3) ) ) ) ) ).

% comm_monoid_set.Union_comp
tff(fact_5661_comm__monoid__set_Oreindex,axiom,
    ! [C: $tType,A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,H2: fun(B,C),A4: set(B),G: fun(C,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( inj_on(B,C,H2,A4)
       => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F,Z2),G),aa(set(B),set(C),image2(B,C,H2),A4)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),aa(fun(B,C),fun(B,A),aa(fun(C,A),fun(fun(B,C),fun(B,A)),comp(C,A,B),G),H2)),A4) ) ) ) ).

% comm_monoid_set.reindex
tff(fact_5662_comm__monoid__set_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,C3: set(set(B)),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( ! [X2: set(B)] :
            ( pp(member(set(B),X2,C3))
           => pp(aa(set(B),bool,finite_finite(B),X2)) )
       => ( ! [X2: set(B)] :
              ( pp(member(set(B),X2,C3))
             => ! [Xa4: set(B)] :
                  ( pp(member(set(B),Xa4,C3))
                 => ( ( X2 != Xa4 )
                   => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X2),Xa4) = bot_bot(set(B)) ) ) ) )
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3)) = aa(set(set(B)),A,aa(fun(B,A),fun(set(set(B)),A),aa(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A)),aa(fun(fun(set(B),A),fun(set(set(B)),A)),fun(fun(fun(B,A),fun(set(B),A)),fun(fun(B,A),fun(set(set(B)),A))),comp(fun(set(B),A),fun(set(set(B)),A),fun(B,A)),groups_comm_monoid_F(A,set(B),F,Z2)),groups_comm_monoid_F(A,B,F,Z2)),G),C3) ) ) ) ) ).

% comm_monoid_set.Union_disjoint
tff(fact_5663_comm__monoid__set_OPlus,axiom,
    ! [B: $tType,A: $tType,C: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),B3: set(C),G: fun(sum_sum(B,C),A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( pp(aa(set(C),bool,finite_finite(C),B3))
         => ( aa(set(sum_sum(B,C)),A,aa(fun(sum_sum(B,C),A),fun(set(sum_sum(B,C)),A),groups_comm_monoid_F(A,sum_sum(B,C),F,Z2),G),sum_Plus(B,C,A4,B3)) = aa(A,A,aa(A,fun(A,A),F,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),aa(fun(B,sum_sum(B,C)),fun(B,A),aa(fun(sum_sum(B,C),A),fun(fun(B,sum_sum(B,C)),fun(B,A)),comp(sum_sum(B,C),A,B),G),sum_Inl(B,C))),A4)),aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F,Z2),aa(fun(C,sum_sum(B,C)),fun(C,A),aa(fun(sum_sum(B,C),A),fun(fun(C,sum_sum(B,C)),fun(C,A)),comp(sum_sum(B,C),A,C),G),sum_Inr(C,B))),B3)) ) ) ) ) ).

% comm_monoid_set.Plus
tff(fact_5664_comm__monoid__set_OatLeastLessThan__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F: fun(A,fun(A,A)),Z2: A,H2: fun(nat,B),M4: nat,N: nat,G: fun(B,A)] :
          ( groups778175481326437816id_set(A,F,Z2)
         => ( bij_betw(nat,B,H2,set_or7035219750837199246ssThan(nat,M4,N),set_or7035219750837199246ssThan(B,aa(nat,B,H2,M4),aa(nat,B,H2,N)))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),set_or7035219750837199246ssThan(B,aa(nat,B,H2,M4),aa(nat,B,H2,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,B),fun(nat,A),aa(fun(B,A),fun(fun(nat,B),fun(nat,A)),comp(B,A,nat),G),H2)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ) ) ).

% comm_monoid_set.atLeastLessThan_reindex
tff(fact_5665_comm__monoid__set_OatLeastAtMost__reindex,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F: fun(A,fun(A,A)),Z2: A,H2: fun(nat,B),M4: nat,N: nat,G: fun(B,A)] :
          ( groups778175481326437816id_set(A,F,Z2)
         => ( bij_betw(nat,B,H2,set_or1337092689740270186AtMost(nat,M4,N),set_or1337092689740270186AtMost(B,aa(nat,B,H2,M4),aa(nat,B,H2,N)))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),set_or1337092689740270186AtMost(B,aa(nat,B,H2,M4),aa(nat,B,H2,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,B),fun(nat,A),aa(fun(B,A),fun(fun(nat,B),fun(nat,A)),comp(B,A,nat),G),H2)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ) ) ).

% comm_monoid_set.atLeastAtMost_reindex
tff(fact_5666_comm__monoid__set_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M4: nat,N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_Suc_atMost_Suc_shift
tff(fact_5667_comm__monoid__set_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M4: nat,N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_Suc_lessThan_Suc_shift
tff(fact_5668_comm__monoid__set_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(int,A),M4: nat,N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups_comm_monoid_F(A,int,F,Z2),G),set_or7035219750837199246ssThan(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,int),fun(nat,A),aa(fun(int,A),fun(fun(nat,int),fun(nat,A)),comp(int,A,nat),G),semiring_1_of_nat(int))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_int_lessThan_int_shift
tff(fact_5669_comm__monoid__set_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(int,A),M4: nat,N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups_comm_monoid_F(A,int,F,Z2),G),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,int),fun(nat,A),aa(fun(int,A),fun(fun(nat,int),fun(nat,A)),comp(int,A,nat),G),semiring_1_of_nat(int))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_int_atMost_int_shift
tff(fact_5670_comm__monoid__set_Oeq__fold,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(B,A),A4: set(B)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),A4) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),aa(fun(A,fun(A,A)),fun(fun(B,A),fun(B,fun(A,A))),comp(A,fun(A,A),B),F),G),Z2,A4) ) ) ).

% comm_monoid_set.eq_fold
tff(fact_5671_comm__monoid__set_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M4: nat,K: nat,N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeastAtMost_shift_bounds
tff(fact_5672_comm__monoid__set_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M4: nat,K: nat,N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeastLessThan_shift_bounds
tff(fact_5673_comm__monoid__set_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),F,aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% comm_monoid_set.atLeast0_atMost_Suc_shift
tff(fact_5674_comm__monoid__set_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),F,aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% comm_monoid_set.atLeast0_lessThan_Suc_shift
tff(fact_5675_comm__monoid__set_Ounion__inter,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),B3: set(B),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( pp(aa(set(B),bool,finite_finite(B),B3))
         => ( aa(A,A,aa(A,fun(A,A),F,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))) = aa(A,A,aa(A,fun(A,A),F,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),B3)) ) ) ) ) ).

% comm_monoid_set.union_inter
tff(fact_5676_comm__monoid__set_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),B3: set(B),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( pp(aa(set(B),bool,finite_finite(B),B3))
         => ( ! [X2: B] :
                ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3)))
               => ( aa(B,A,G,X2) = Z2 ) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = aa(A,A,aa(A,fun(A,A),F,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),B3)) ) ) ) ) ) ).

% comm_monoid_set.union_inter_neutral
tff(fact_5677_comm__monoid__set_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),B3: set(B),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( pp(aa(set(B),bool,finite_finite(B),B3))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = aa(A,A,aa(A,fun(A,A),F,aa(A,A,aa(A,fun(A,A),F,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B3),A4)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))) ) ) ) ) ).

% comm_monoid_set.union_diff2
tff(fact_5678_prod_Ocomm__monoid__set__axioms,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => groups778175481326437816id_set(A,times_times(A),one_one(A)) ) ).

% prod.comm_monoid_set_axioms
tff(fact_5679_comm__monoid__set_OIf__cases,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),P: fun(B,bool),H2: fun(B,A),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_ao(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),P),H2),G)),A4) = aa(A,A,aa(A,fun(A,A),F,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),H2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,bool),set(B),collect(B),P)))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,bool),set(B),collect(B),P))))) ) ) ) ).

% comm_monoid_set.If_cases
tff(fact_5680_comm__monoid__set_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),G: fun(B,A),B3: set(B)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),aa(set(B),fun(B,A),aa(fun(B,A),fun(set(B),fun(B,A)),aTP_Lamp_xe(A,fun(fun(B,A),fun(set(B),fun(B,A))),Z2),G),B3)),A4) ) ) ) ).

% comm_monoid_set.inter_restrict
tff(fact_5681_comm__monoid__set_OInt__Diff,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),G: fun(B,A),B3: set(B)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),A4) = aa(A,A,aa(A,fun(A,A),F,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B3))) ) ) ) ).

% comm_monoid_set.Int_Diff
tff(fact_5682_comm__monoid__set_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,T3: set(B),S2: set(B),H2: fun(B,A),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),T3))
       => ( pp(aa(set(B),bool,finite_finite(B),S2))
         => ( ! [I3: B] :
                ( pp(member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2)))
               => ( aa(B,A,H2,I3) = Z2 ) )
           => ( ! [I3: B] :
                  ( pp(member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),T3)))
                 => ( aa(B,A,G,I3) = Z2 ) )
             => ( ! [X2: B] :
                    ( pp(member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3)))
                   => ( aa(B,A,G,X2) = aa(B,A,H2,X2) ) )
               => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),H2),T3) ) ) ) ) ) ) ) ).

% comm_monoid_set.mono_neutral_cong
tff(fact_5683_comm__monoid__set_Oremove,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),X: B,G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( pp(member(B,X,A4))
         => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),A4) = aa(A,A,aa(A,fun(A,A),F,aa(B,A,G,X)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% comm_monoid_set.remove
tff(fact_5684_comm__monoid__set_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),G: fun(B,A),X: B] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),insert2(B,X),A4)) = aa(A,A,aa(A,fun(A,A),F,aa(B,A,G,X)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ).

% comm_monoid_set.insert_remove
tff(fact_5685_comm__monoid__set_Oempty,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),bot_bot(set(B))) = Z2 ) ) ).

% comm_monoid_set.empty
tff(fact_5686_comm__monoid__set_Odelta__remove,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,S2: set(B),A3: B,B2: fun(B,A),C2: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),S2))
       => ( ( pp(member(B,A3,S2))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_xf(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A3),B2),C2)),S2) = aa(A,A,aa(A,fun(A,A),F,aa(B,A,B2,A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) )
          & ( ~ pp(member(B,A3,S2))
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_xf(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),A3),B2),C2)),S2) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) ) ) ) ) ) ).

% comm_monoid_set.delta_remove
tff(fact_5687_filtermap__sequentually__ne__bot,axiom,
    ! [A: $tType,F: fun(nat,A)] : ( filtermap(nat,A,F,at_top(nat)) != bot_bot(filter(A)) ) ).

% filtermap_sequentually_ne_bot
tff(fact_5688_trivial__limit__at__top__linorder,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( at_top(A) != bot_bot(filter(A)) ) ) ).

% trivial_limit_at_top_linorder
tff(fact_5689_comm__monoid__set_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(B),B3: set(B),G: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),A4))
       => ( pp(aa(set(B),bool,finite_finite(B),B3))
         => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B3) = bot_bot(set(B)) )
           => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B3)) = aa(A,A,aa(A,fun(A,A),F,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),A4)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),G),B3)) ) ) ) ) ) ).

% comm_monoid_set.union_disjoint
tff(fact_5690_comm__monoid__set_Oempty_H,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(A,A)),Z2: A,P3: fun(B,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_G(A,B,F,Z2),P3),bot_bot(set(B))) = Z2 ) ) ).

% comm_monoid_set.empty'
tff(fact_5691_comm__monoid__set_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M4: nat,N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),G),set_or7035219750837199246ssThan(nat,M4,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ).

% comm_monoid_set.atLeastLessThan_shift_0
tff(fact_5692_comm__monoid__set_OUNION__disjoint,axiom,
    ! [C: $tType,A: $tType,B: $tType,F: fun(A,fun(A,A)),Z2: A,I4: set(B),A4: fun(B,set(C)),G: fun(C,A)] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( pp(aa(set(B),bool,finite_finite(B),I4))
       => ( ! [X2: B] :
              ( pp(member(B,X2,I4))
             => pp(aa(set(C),bool,finite_finite(C),aa(B,set(C),A4,X2))) )
         => ( ! [X2: B] :
                ( pp(member(B,X2,I4))
               => ! [Xa4: B] :
                    ( pp(member(B,Xa4,I4))
                   => ( ( X2 != Xa4 )
                     => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A4,X2)),aa(B,set(C),A4,Xa4)) = bot_bot(set(C)) ) ) ) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,F,Z2),G),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4))) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups_comm_monoid_F(A,B,F,Z2),aa(fun(C,A),fun(B,A),aa(fun(B,set(C)),fun(fun(C,A),fun(B,A)),aa(A,fun(fun(B,set(C)),fun(fun(C,A),fun(B,A))),aTP_Lamp_xg(fun(A,fun(A,A)),fun(A,fun(fun(B,set(C)),fun(fun(C,A),fun(B,A)))),F),Z2),A4),G)),I4) ) ) ) ) ) ).

% comm_monoid_set.UNION_disjoint
tff(fact_5693_comm__monoid__set_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M4: nat,N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aTP_Lamp_de(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),G),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_atMost_pred_shift
tff(fact_5694_comm__monoid__set_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,G: fun(nat,A),M4: nat,N: nat] :
      ( groups778175481326437816id_set(A,F,Z2)
     => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),aa(fun(nat,nat),fun(nat,A),aa(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),comp(nat,A,nat),G),aTP_Lamp_de(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups_comm_monoid_F(A,nat,F,Z2),G),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_lessThan_pred_shift
tff(fact_5695_Nitpick_OEx1__unfold,axiom,
    ! [A: $tType,P: fun(A,bool)] :
      ( ? [X4: A] :
          ( pp(aa(A,bool,P,X4))
          & ! [Y3: A] :
              ( pp(aa(A,bool,P,Y3))
             => ( Y3 = X4 ) ) )
    <=> ? [X4: A] : ( aa(fun(A,bool),set(A),collect(A),P) = aa(set(A),set(A),insert2(A,X4),bot_bot(set(A))) ) ) ).

% Nitpick.Ex1_unfold
tff(fact_5696_num__of__integer_Otransfer,axiom,
    pp(aa(fun(code_integer,num),bool,aa(fun(int,num),fun(fun(code_integer,num),bool),bNF_rel_fun(int,code_integer,num,num,code_pcr_integer,fequal(num)),aa(fun(int,nat),fun(int,num),aa(fun(nat,num),fun(fun(int,nat),fun(int,num)),comp(nat,num,int),num_of_nat),nat2)),code_num_of_integer)) ).

% num_of_integer.transfer
tff(fact_5697_num__of__integer__def,axiom,
    code_num_of_integer = aa(fun(int,num),fun(code_integer,num),map_fun(code_integer,int,num,num,code_int_of_integer,id(num)),aa(fun(int,nat),fun(int,num),aa(fun(nat,num),fun(fun(int,nat),fun(int,num)),comp(nat,num,int),num_of_nat),nat2)) ).

% num_of_integer_def
tff(fact_5698_adm__wf__def,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,A)),F2: fun(fun(A,B),fun(A,B))] :
      ( adm_wf(A,B,R,F2)
    <=> ! [F11: fun(A,B),G5: fun(A,B),X4: A] :
          ( ! [Z4: A] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z4),X4),R))
             => ( aa(A,B,F11,Z4) = aa(A,B,G5,Z4) ) )
         => ( aa(A,B,aa(fun(A,B),fun(A,B),F2,F11),X4) = aa(A,B,aa(fun(A,B),fun(A,B),F2,G5),X4) ) ) ) ).

% adm_wf_def
tff(fact_5699_list_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q: fun(B,bool),F: fun(A,B),X: list(A)] :
      ( list_all(B,Q,aa(list(A),list(B),map(A,B,F),X))
    <=> list_all(A,aa(fun(A,B),fun(A,bool),aa(fun(B,bool),fun(fun(A,B),fun(A,bool)),comp(B,bool,A),Q),F),X) ) ).

% list.pred_map
tff(fact_5700_eventually__frequentlyE,axiom,
    ! [A: $tType,P: fun(A,bool),F2: filter(A),Q: fun(A,bool)] :
      ( eventually(A,P,F2)
     => ( eventually(A,aa(fun(A,bool),fun(A,bool),aTP_Lamp_xh(fun(A,bool),fun(fun(A,bool),fun(A,bool)),P),Q),F2)
       => ( ( F2 != bot_bot(filter(A)) )
         => frequently(A,Q,F2) ) ) ) ).

% eventually_frequentlyE
tff(fact_5701_frequently__const,axiom,
    ! [A: $tType,F2: filter(A),P: bool] :
      ( ( F2 != bot_bot(filter(A)) )
     => ( frequently(A,aTP_Lamp_aj(bool,fun(A,bool),P),F2)
      <=> pp(P) ) ) ).

% frequently_const
tff(fact_5702_frequently__const__iff,axiom,
    ! [A: $tType,P: bool,F2: filter(A)] :
      ( frequently(A,aTP_Lamp_aj(bool,fun(A,bool),P),F2)
    <=> ( pp(P)
        & ( F2 != bot_bot(filter(A)) ) ) ) ).

% frequently_const_iff
tff(fact_5703_eventually__frequently,axiom,
    ! [A: $tType,F2: filter(A),P: fun(A,bool)] :
      ( ( F2 != bot_bot(filter(A)) )
     => ( eventually(A,P,F2)
       => frequently(A,P,F2) ) ) ).

% eventually_frequently
tff(fact_5704_folding__idem_Ocomp__fun__idem,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B)),X: A] :
      ( finite_folding_idem(A,B,F)
     => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X)),aa(A,fun(B,B),F,X)) = aa(A,fun(B,B),F,X) ) ) ).

% folding_idem.comp_fun_idem
tff(fact_5705_semilattice__neutr__set_Oremove,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(A),X: A] :
      ( lattic5652469242046573047tr_set(A,F,Z2)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( pp(member(A,X,A4))
         => ( lattic5214292709420241887eutr_F(A,F,Z2,A4) = aa(A,A,aa(A,fun(A,A),F,X),lattic5214292709420241887eutr_F(A,F,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ) ).

% semilattice_neutr_set.remove
tff(fact_5706_semilattice__neutr__set_Oinsert__remove,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(A),X: A] :
      ( lattic5652469242046573047tr_set(A,F,Z2)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( lattic5214292709420241887eutr_F(A,F,Z2,aa(set(A),set(A),insert2(A,X),A4)) = aa(A,A,aa(A,fun(A,A),F,X),lattic5214292709420241887eutr_F(A,F,Z2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A4),aa(set(A),set(A),insert2(A,X),bot_bot(set(A)))))) ) ) ) ).

% semilattice_neutr_set.insert_remove
tff(fact_5707_semilattice__neutr__set_Ointro,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( semilattice_neutr(A,F,Z2)
     => lattic5652469242046573047tr_set(A,F,Z2) ) ).

% semilattice_neutr_set.intro
tff(fact_5708_semilattice__neutr__set_Oaxioms,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( lattic5652469242046573047tr_set(A,F,Z2)
     => semilattice_neutr(A,F,Z2) ) ).

% semilattice_neutr_set.axioms
tff(fact_5709_semilattice__neutr__set__def,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( lattic5652469242046573047tr_set(A,F,Z2)
    <=> semilattice_neutr(A,F,Z2) ) ).

% semilattice_neutr_set_def
tff(fact_5710_semilattice__neutr__set_Oclosed,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A,A4: set(A)] :
      ( lattic5652469242046573047tr_set(A,F,Z2)
     => ( pp(aa(set(A),bool,finite_finite(A),A4))
       => ( ( A4 != bot_bot(set(A)) )
         => ( ! [X2: A,Y2: A] : pp(member(A,aa(A,A,aa(A,fun(A,A),F,X2),Y2),aa(set(A),set(A),insert2(A,X2),aa(set(A),set(A),insert2(A,Y2),bot_bot(set(A))))))
           => pp(member(A,lattic5214292709420241887eutr_F(A,F,Z2,A4),A4)) ) ) ) ) ).

% semilattice_neutr_set.closed
tff(fact_5711_semilattice__neutr__set_Oempty,axiom,
    ! [A: $tType,F: fun(A,fun(A,A)),Z2: A] :
      ( lattic5652469242046573047tr_set(A,F,Z2)
     => ( lattic5214292709420241887eutr_F(A,F,Z2,bot_bot(set(A))) = Z2 ) ) ).

% semilattice_neutr_set.empty
tff(fact_5712_transp__trans__eq,axiom,
    ! [A: $tType,R3: set(product_prod(A,A))] :
      ( transp(A,aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),R3))
    <=> trans(A,R3) ) ).

% transp_trans_eq
tff(fact_5713_folding__def,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B))] :
      ( finite_folding(A,B,F)
    <=> ! [Y3: A,X4: A] : ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y3)),aa(A,fun(B,B),F,X4)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X4)),aa(A,fun(B,B),F,Y3)) ) ) ).

% folding_def
tff(fact_5714_folding__idem__on_Ocomp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F: fun(A,fun(B,B)),X: A,Y: A] :
      ( finite1890593828518410140dem_on(A,B,S2,F)
     => ( pp(member(A,X,S2))
       => ( pp(member(A,Y,S2))
         => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X)),aa(A,fun(B,B),F,X)) = aa(A,fun(B,B),F,X) ) ) ) ) ).

% folding_idem_on.comp_fun_idem_on
tff(fact_5715_Heap_Orel__transp,axiom,
    ! [A: $tType,R: fun(A,fun(A,bool))] :
      ( transp(A,R)
     => transp(heap_Time_Heap(A),aa(fun(A,fun(A,bool)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),bool)),heap_Time_rel_Heap(A,A),R)) ) ).

% Heap.rel_transp
tff(fact_5716_transp__inf,axiom,
    ! [A: $tType,R3: fun(A,fun(A,bool)),S: fun(A,fun(A,bool))] :
      ( transp(A,R3)
     => ( transp(A,S)
       => transp(A,aa(fun(A,fun(A,bool)),fun(A,fun(A,bool)),aa(fun(A,fun(A,bool)),fun(fun(A,fun(A,bool)),fun(A,fun(A,bool))),inf_inf(fun(A,fun(A,bool))),R3),S)) ) ) ).

% transp_inf
tff(fact_5717_folding_Ointro,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B))] :
      ( ! [Y2: A,X2: A] : ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y2)),aa(A,fun(B,B),F,X2)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X2)),aa(A,fun(B,B),F,Y2)) )
     => finite_folding(A,B,F) ) ).

% folding.intro
tff(fact_5718_folding_Ocomp__fun__commute,axiom,
    ! [B: $tType,A: $tType,F: fun(A,fun(B,B)),Y: A,X: A] :
      ( finite_folding(A,B,F)
     => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,Y)),aa(A,fun(B,B),F,X)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(A,fun(B,B),F,X)),aa(A,fun(B,B),F,Y)) ) ) ).

% folding.comp_fun_commute
tff(fact_5719_random__aux__set_Ocases,axiom,
    ! [X: product_prod(code_natural,code_natural)] :
      ( ! [J3: code_natural] : ( X != aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),zero_zero(code_natural)),J3) )
     => ~ ! [I3: code_natural,J3: code_natural] : ( X != aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),code_Suc(I3)),J3) ) ) ).

% random_aux_set.cases
tff(fact_5720_is__empty__bot,axiom,
    ! [A: $tType] : is_empty(A,bot_bot(pred(A))) ).

% is_empty_bot
tff(fact_5721_Predicate_Ois__empty__def,axiom,
    ! [A: $tType,A4: pred(A)] :
      ( is_empty(A,A4)
    <=> ( A4 = bot_bot(pred(A)) ) ) ).

% Predicate.is_empty_def
tff(fact_5722_trivial__limit__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( at_bot(A) != bot_bot(filter(A)) ) ) ).

% trivial_limit_at_bot_linorder
tff(fact_5723_ATP_Olambda__1,axiom,
    ! [Uu: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aTP_Lamp_gl(product_prod(int,int),product_prod(int,int)),Uu) = if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),fequal(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uu))) ) ).

% ATP.lambda_1
tff(fact_5724_ATP_Olambda__2,axiom,
    ! [A: $tType,Uu: set(set(A))] : ( aa(set(set(A)),int,aTP_Lamp_jx(set(set(A)),int),Uu) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(set(A),Uu)),one_one(nat)))),aa(nat,int,semiring_1_of_nat(int),finite_card(A,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),Uu)))) ) ).

% ATP.lambda_2
tff(fact_5725_ATP_Olambda__3,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,set(product_prod(A,A)),aTP_Lamp_iw(A,set(product_prod(A,A))),Uu) = aa(set(product_prod(A,A)),set(product_prod(A,A)),insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),Uu)),bot_bot(set(product_prod(A,A)))) ) ).

% ATP.lambda_3
tff(fact_5726_ATP_Olambda__4,axiom,
    ! [Uu: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aTP_Lamp_gq(product_prod(int,int),product_prod(int,int)),Uu) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),aa(product_prod(int,int),int,product_fst(int,int),Uu))),aa(product_prod(int,int),int,product_snd(int,int),Uu)) ) ).

% ATP.lambda_4
tff(fact_5727_ATP_Olambda__5,axiom,
    ! [A: $tType,Uu: list(A)] : ( aa(list(A),product_prod(nat,list(A)),aTP_Lamp_sk(list(A),product_prod(nat,list(A))),Uu) = aa(list(A),product_prod(nat,list(A)),aa(nat,fun(list(A),product_prod(nat,list(A))),product_Pair(nat,list(A)),size_size(list(A),Uu)),Uu) ) ).

% ATP.lambda_5
tff(fact_5728_ATP_Olambda__6,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_de(nat,nat),Uu) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),aa(nat,nat,suc,zero_zero(nat))) ) ).

% ATP.lambda_6
tff(fact_5729_ATP_Olambda__7,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,product_prod(B,B),aTP_Lamp_co(B,product_prod(B,B)),Uu) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),Uu) ) ).

% ATP.lambda_7
tff(fact_5730_ATP_Olambda__8,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,product_prod(A,A),aTP_Lamp_cg(A,product_prod(A,A)),Uu) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),Uu) ) ).

% ATP.lambda_8
tff(fact_5731_ATP_Olambda__9,axiom,
    ! [Uu: product_prod(int,int)] :
      ( pp(aa(product_prod(int,int),bool,aTP_Lamp_vq(product_prod(int,int),bool),Uu))
    <=> pp(aa(product_prod(int,int),bool,aa(product_prod(int,int),fun(product_prod(int,int),bool),ratrel,Uu),Uu)) ) ).

% ATP.lambda_9
tff(fact_5732_ATP_Olambda__10,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_en(A,A),Uu) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),one_one(A)) ) ) ).

% ATP.lambda_10
tff(fact_5733_ATP_Olambda__11,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Uu: A] :
          ( pp(aa(A,bool,aTP_Lamp_uu(A,bool),Uu))
        <=> pp(dvd_dvd(A,Uu,one_one(A))) ) ) ).

% ATP.lambda_11
tff(fact_5734_ATP_Olambda__12,axiom,
    ! [Uu: nat] : ( aa(nat,product_prod(nat,nat),aTP_Lamp_hb(nat,product_prod(nat,nat)),Uu) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Uu),zero_zero(nat)) ) ).

% ATP.lambda_12
tff(fact_5735_ATP_Olambda__13,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,list(A),aTP_Lamp_sa(A,list(A)),Uu) = aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uu),nil(A)) ) ).

% ATP.lambda_13
tff(fact_5736_ATP_Olambda__14,axiom,
    ! [D: $tType,Uu: D] : ( aa(D,set(D),aTP_Lamp_wj(D,set(D)),Uu) = aa(set(D),set(D),insert2(D,Uu),bot_bot(set(D))) ) ).

% ATP.lambda_14
tff(fact_5737_ATP_Olambda__15,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,set(A),aTP_Lamp_bf(A,set(A)),Uu) = aa(set(A),set(A),insert2(A,Uu),bot_bot(set(A))) ) ).

% ATP.lambda_15
tff(fact_5738_ATP_Olambda__16,axiom,
    ! [Uu: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_ue(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,aTP_Lamp_ud(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu)) ) ).

% ATP.lambda_16
tff(fact_5739_ATP_Olambda__17,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,fun(set(product_prod(A,A)),set(product_prod(A,A))),aTP_Lamp_gb(A,fun(set(product_prod(A,A)),set(product_prod(A,A)))),Uu) = insert2(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),Uu)) ) ).

% ATP.lambda_17
tff(fact_5740_ATP_Olambda__18,axiom,
    ! [A: $tType,Uu: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_tt(list(A),bool),Uu))
    <=> ( Uu != nil(A) ) ) ).

% ATP.lambda_18
tff(fact_5741_ATP_Olambda__19,axiom,
    ! [A: $tType,Uu: option(product_prod(A,product_prod(heap_ext(product_unit),nat)))] : ( aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(A),aTP_Lamp_va(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(A)),Uu) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(set(A)),image2(product_prod(A,product_prod(heap_ext(product_unit),nat)),set(A),basic_fsts(A,product_prod(heap_ext(product_unit),nat))),aa(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),set(product_prod(A,product_prod(heap_ext(product_unit),nat))),set_option(product_prod(A,product_prod(heap_ext(product_unit),nat))),Uu))) ) ).

% ATP.lambda_19
tff(fact_5742_ATP_Olambda__20,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: A] : ( aa(A,fun(product_prod(B,C),product_prod(product_prod(A,B),C)),aTP_Lamp_uh(A,fun(product_prod(B,C),product_prod(product_prod(A,B),C))),Uu) = aa(fun(B,fun(C,product_prod(product_prod(A,B),C))),fun(product_prod(B,C),product_prod(product_prod(A,B),C)),product_case_prod(B,C,product_prod(product_prod(A,B),C)),aTP_Lamp_ug(A,fun(B,fun(C,product_prod(product_prod(A,B),C))),Uu)) ) ).

% ATP.lambda_20
tff(fact_5743_ATP_Olambda__21,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: B] : ( aa(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C))),aTP_Lamp_sw(B,fun(product_prod(A,C),product_prod(A,product_prod(B,C)))),Uu) = aa(fun(A,fun(C,product_prod(A,product_prod(B,C)))),fun(product_prod(A,C),product_prod(A,product_prod(B,C))),product_case_prod(A,C,product_prod(A,product_prod(B,C))),aTP_Lamp_sv(B,fun(A,fun(C,product_prod(A,product_prod(B,C)))),Uu)) ) ).

% ATP.lambda_21
tff(fact_5744_ATP_Olambda__22,axiom,
    ! [A: $tType,Uu: multiset(A)] : ( aa(multiset(A),set(A),aTP_Lamp_qf(multiset(A),set(A)),Uu) = aa(fun(A,bool),set(A),collect(A),aTP_Lamp_qe(multiset(A),fun(A,bool),Uu)) ) ).

% ATP.lambda_22
tff(fact_5745_ATP_Olambda__23,axiom,
    ! [Uu: nat] : ( aa(nat,set(nat),aTP_Lamp_li(nat,set(nat)),Uu) = aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_lh(nat,fun(nat,bool),Uu)) ) ).

% ATP.lambda_23
tff(fact_5746_ATP_Olambda__24,axiom,
    ! [B: $tType,Uu: fun(B,nat)] :
      ( pp(aa(fun(B,nat),bool,aTP_Lamp_rc(fun(B,nat),bool),Uu))
    <=> pp(aa(set(B),bool,finite_finite(B),aa(fun(B,bool),set(B),collect(B),aTP_Lamp_rb(fun(B,nat),fun(B,bool),Uu)))) ) ).

% ATP.lambda_24
tff(fact_5747_ATP_Olambda__25,axiom,
    ! [A: $tType,Uu: fun(A,nat)] :
      ( pp(aa(fun(A,nat),bool,aTP_Lamp_qz(fun(A,nat),bool),Uu))
    <=> pp(aa(set(A),bool,finite_finite(A),aa(fun(A,bool),set(A),collect(A),aTP_Lamp_qy(fun(A,nat),fun(A,bool),Uu)))) ) ).

% ATP.lambda_25
tff(fact_5748_ATP_Olambda__26,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_wt(num,option(num)),Uu) = aa(num,option(num),some(num),aa(num,num,bit1,Uu)) ) ).

% ATP.lambda_26
tff(fact_5749_ATP_Olambda__27,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_wu(num,option(num)),Uu) = aa(num,option(num),some(num),aa(num,num,bit0,Uu)) ) ).

% ATP.lambda_27
tff(fact_5750_ATP_Olambda__28,axiom,
    ! [Uu: int] : ( aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ey(int,fun(int,product_prod(int,int))),Uu) = aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),Uu)) ) ).

% ATP.lambda_28
tff(fact_5751_ATP_Olambda__29,axiom,
    ! [Uu: int] : ( aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ew(int,fun(int,product_prod(int,int))),Uu) = aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,abs_abs(int),Uu)) ) ).

% ATP.lambda_29
tff(fact_5752_ATP_Olambda__30,axiom,
    ! [Uu: nat] : ( aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_ff(nat,fun(nat,product_prod(nat,nat))),Uu) = aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_30
tff(fact_5753_ATP_Olambda__31,axiom,
    ! [A: $tType,Uu: product_prod(A,A)] :
      ( pp(aa(product_prod(A,A),bool,aTP_Lamp_kl(product_prod(A,A),bool),Uu))
    <=> ? [X4: A] : ( Uu = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),X4) ) ) ).

% ATP.lambda_31
tff(fact_5754_ATP_Olambda__32,axiom,
    ! [A: $tType,B: $tType,Uu: product_prod(product_prod(bool,A),product_prod(bool,B))] :
      ( pp(aa(product_prod(product_prod(bool,A),product_prod(bool,B)),bool,aTP_Lamp_kw(product_prod(product_prod(bool,A),product_prod(bool,B)),bool),Uu))
    <=> ? [X4: A,Y3: B] : ( Uu = aa(product_prod(bool,B),product_prod(product_prod(bool,A),product_prod(bool,B)),aa(product_prod(bool,A),fun(product_prod(bool,B),product_prod(product_prod(bool,A),product_prod(bool,B))),product_Pair(product_prod(bool,A),product_prod(bool,B)),aa(A,product_prod(bool,A),aa(bool,fun(A,product_prod(bool,A)),product_Pair(bool,A),fTrue),X4)),aa(B,product_prod(bool,B),aa(bool,fun(B,product_prod(bool,B)),product_Pair(bool,B),fFalse),Y3)) ) ) ).

% ATP.lambda_32
tff(fact_5755_ATP_Olambda__33,axiom,
    ! [A: $tType,B: $tType,Uu: product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))] :
      ( pp(aa(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),bool,aTP_Lamp_wg(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),bool),Uu))
    <=> ? [F11: fun(nat,sum_sum(B,nat)),X4: sum_sum(A,nat),K4: nat] :
          ( ( Uu = aa(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(A,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))),product_Pair(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)),F11),X4) )
          & ( aa(nat,sum_sum(B,nat),F11,K4) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) ) ) ) ).

% ATP.lambda_33
tff(fact_5756_ATP_Olambda__34,axiom,
    ! [B: $tType,A: $tType,Uu: B] : ( aa(B,heap_Time_Heap(A),aTP_Lamp_vw(B,heap_Time_Heap(A)),Uu) = aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A),heap_Time_Heap2(A),aTP_Lamp_mj(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))) ) ).

% ATP.lambda_34
tff(fact_5757_ATP_Olambda__35,axiom,
    ! [B: $tType,Uu: nat] : ( aa(nat,sum_sum(B,nat),aTP_Lamp_wk(nat,sum_sum(B,nat)),Uu) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) ) ).

% ATP.lambda_35
tff(fact_5758_ATP_Olambda__36,axiom,
    ! [A: $tType,Uu: nat] : ( aa(nat,sum_sum(A,nat),aTP_Lamp_wh(nat,sum_sum(A,nat)),Uu) = aa(nat,sum_sum(A,nat),sum_Inr(nat,A),zero_zero(nat)) ) ).

% ATP.lambda_36
tff(fact_5759_ATP_Olambda__37,axiom,
    ! [Uu: num,Uua: nat] : ( aa(nat,option(num),aTP_Lamp_wx(num,fun(nat,option(num)),Uu),Uua) = case_num(option(num),aa(num,option(num),some(num),one2),aTP_Lamp_wv(nat,fun(num,option(num)),Uua),aTP_Lamp_ww(nat,fun(num,option(num)),Uua),Uu) ) ).

% ATP.lambda_37
tff(fact_5760_ATP_Olambda__38,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_ac(nat,fun(nat,A),Uu),Uua) = if(A,dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),Uua),aa(nat,A,semiring_1_of_nat(A),binomial(Uu,Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_38
tff(fact_5761_ATP_Olambda__39,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: product_prod(A,C),Uua: product_prod(C,B)] : ( aa(product_prod(C,B),list(product_prod(A,B)),aTP_Lamp_te(product_prod(A,C),fun(product_prod(C,B),list(product_prod(A,B))),Uu),Uua) = if(list(product_prod(A,B)),aa(C,bool,aa(C,fun(C,bool),fequal(C),aa(product_prod(A,C),C,product_snd(A,C),Uu)),aa(product_prod(C,B),C,product_fst(C,B),Uua)),aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(product_prod(A,C),A,product_fst(A,C),Uu)),aa(product_prod(C,B),B,product_snd(C,B),Uua))),nil(product_prod(A,B))),nil(product_prod(A,B))) ) ).

% ATP.lambda_39
tff(fact_5762_ATP_Olambda__40,axiom,
    ! [Uu: pred(product_unit),Uua: product_prod(code_natural,code_natural)] : ( aa(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)),aa(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),aTP_Lamp_ve(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)))),Uu),Uua) = if(product_prod(pred(product_unit),product_prod(code_natural,code_natural)),aa(product_unit,bool,aa(pred(product_unit),fun(product_unit,bool),eval(product_unit),Uu),product_Unity),aa(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)),aa(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),product_Pair(pred(product_unit),product_prod(code_natural,code_natural)),bot_bot(pred(product_unit))),Uua),aa(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)),aa(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),product_Pair(pred(product_unit),product_prod(code_natural,code_natural)),aa(product_unit,pred(product_unit),single(product_unit),product_Unity)),Uua)) ) ).

% ATP.lambda_40
tff(fact_5763_ATP_Olambda__41,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fj(int,fun(int,product_prod(int,int))),Uu),Uua) = if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),fequal(int),Uu),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),Uu)),Uua)),aa(int,int,abs_abs(int),Uu))) ) ).

% ATP.lambda_41
tff(fact_5764_ATP_Olambda__42,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_gu(int,fun(int,product_prod(int,int))),Uu),Uua) = if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),fequal(int),Uua),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Uu),Uua)) ) ).

% ATP.lambda_42
tff(fact_5765_ATP_Olambda__43,axiom,
    ! [A: $tType,Uu: set(fun(A,nat)),Uua: A] : ( aa(A,nat,aa(set(fun(A,nat)),fun(A,nat),aTP_Lamp_qk(set(fun(A,nat)),fun(A,nat)),Uu),Uua) = if(nat,aa(set(fun(A,nat)),bool,aa(set(fun(A,nat)),fun(set(fun(A,nat)),bool),fequal(set(fun(A,nat))),Uu),bot_bot(set(fun(A,nat)))),zero_zero(nat),aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(fun(A,nat)),set(nat),image2(fun(A,nat),nat,aTP_Lamp_qi(A,fun(fun(A,nat),nat),Uua)),Uu))) ) ).

% ATP.lambda_43
tff(fact_5766_ATP_Olambda__44,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_ab(nat,fun(nat,A),Uu),Uua) = if(A,aa(bool,bool,fNot,dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),Uua)),aa(nat,A,semiring_1_of_nat(A),binomial(Uu,Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_44
tff(fact_5767_ATP_Olambda__45,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_pt(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,compow(fun(A,A),Uua,Uu),bot_bot(A)) ) ) ).

% ATP.lambda_45
tff(fact_5768_ATP_Olambda__46,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [Uu: option(A),Uua: A] : ( aa(A,option(A),aTP_Lamp_mv(option(A),fun(A,option(A)),Uu),Uua) = case_option(option(A),A,none(A),aTP_Lamp_mu(A,fun(A,option(A)),Uua),Uu) ) ) ).

% ATP.lambda_46
tff(fact_5769_ATP_Olambda__47,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aa(nat,fun(num,option(num)),aTP_Lamp_wy(nat,fun(num,option(num))),Uu),Uua) = case_nat(option(num),none(num),aTP_Lamp_wx(num,fun(nat,option(num)),Uua),Uu) ) ).

% ATP.lambda_47
tff(fact_5770_ATP_Olambda__48,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_wv(nat,fun(num,option(num)),Uu),Uua) = case_option(option(num),num,none(num),aTP_Lamp_wu(num,option(num)),bit_take_bit_num(Uu,Uua)) ) ).

% ATP.lambda_48
tff(fact_5771_ATP_Olambda__49,axiom,
    ! [Uu: product_prod(int,int),Uua: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aa(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),aTP_Lamp_gs(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),Uu),Uua) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uua)),aa(product_prod(int,int),int,product_snd(int,int),Uu)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))) ) ).

% ATP.lambda_49
tff(fact_5772_ATP_Olambda__50,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_eh(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),Uua))),aa(nat,A,semiring_1_of_nat(A),binomial(Uu,Uua))) ) ) ).

% ATP.lambda_50
tff(fact_5773_ATP_Olambda__51,axiom,
    ! [Uu: product_prod(int,int),Uua: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aa(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),aTP_Lamp_gt(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),Uu),Uua) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))) ) ).

% ATP.lambda_51
tff(fact_5774_ATP_Olambda__52,axiom,
    ! [B: $tType,A: $tType,Uu: set(old_node(A,B)),Uua: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_wm(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),Uu),Uua) = aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),insert2(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_In1(A,B,Uu)),old_In1(A,B,Uua))),bot_bot(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))) ) ).

% ATP.lambda_52
tff(fact_5775_ATP_Olambda__53,axiom,
    ! [B: $tType,A: $tType,Uu: set(old_node(A,B)),Uua: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_wl(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),Uu),Uua) = aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),insert2(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_In0(A,B,Uu)),old_In0(A,B,Uua))),bot_bot(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))) ) ).

% ATP.lambda_53
tff(fact_5776_ATP_Olambda__54,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_ej(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),binomial(Uu,Uua))) ) ) ).

% ATP.lambda_54
tff(fact_5777_ATP_Olambda__55,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A] : ( aa(A,set(set(A)),aTP_Lamp_lo(set(product_prod(A,A)),fun(A,set(set(A))),Uu),Uua) = aa(set(set(A)),set(set(A)),insert2(set(A),image(A,A,Uu,aa(set(A),set(A),insert2(A,Uua),bot_bot(set(A))))),bot_bot(set(set(A)))) ) ).

% ATP.lambda_55
tff(fact_5778_ATP_Olambda__56,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_dd(A,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))),Uua) ) ) ).

% ATP.lambda_56
tff(fact_5779_ATP_Olambda__57,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ad(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,Uu,aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_57
tff(fact_5780_ATP_Olambda__58,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_dv(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)) ) ) ).

% ATP.lambda_58
tff(fact_5781_ATP_Olambda__59,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(list(A),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_rh(array(A),fun(heap_ext(product_unit),product_prod(list(A),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(list(A),product_prod(heap_ext(product_unit),nat)),aa(list(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(list(A),product_prod(heap_ext(product_unit),nat))),product_Pair(list(A),product_prod(heap_ext(product_unit),nat)),array_get(A,Uua,Uu)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),array_length(A,Uua,Uu)))) ) ) ).

% ATP.lambda_59
tff(fact_5782_ATP_Olambda__60,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(set(A))] :
      ( pp(aa(set(set(A)),bool,aTP_Lamp_jy(set(set(A)),fun(set(set(A)),bool),Uu),Uua))
    <=> ( pp(aa(set(set(A)),bool,aa(set(set(A)),fun(set(set(A)),bool),ord_less_eq(set(set(A))),Uua),Uu))
        & ( Uua != bot_bot(set(set(A))) ) ) ) ).

% ATP.lambda_60
tff(fact_5783_ATP_Olambda__61,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(A,A))] :
      ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),aTP_Lamp_pe(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool)),Uu),Uua))
    <=> ( pp(aa(set(product_prod(A,A)),bool,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),bool),ord_less_eq(set(product_prod(A,A))),Uu),Uua))
        & ! [A6: A,B6: A,C5: A] :
            ( ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),B6),Uua))
              & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B6),C5),Uu)) )
           => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),B6),Uu)) ) ) ) ).

% ATP.lambda_61
tff(fact_5784_ATP_Olambda__62,axiom,
    ! [B: $tType,A: $tType,Uu: set(old_node(A,B)),Uua: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(set(old_node(A,B))),aTP_Lamp_xa(set(old_node(A,B)),fun(set(old_node(A,B)),set(set(old_node(A,B)))),Uu),Uua) = aa(set(set(old_node(A,B))),set(set(old_node(A,B))),insert2(set(old_node(A,B)),old_Scons(A,B,Uu,Uua)),bot_bot(set(set(old_node(A,B))))) ) ).

% ATP.lambda_62
tff(fact_5785_ATP_Olambda__63,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: A] : ( aa(A,set(product_prod(B,A)),aTP_Lamp_hj(B,fun(A,set(product_prod(B,A))),Uu),Uua) = aa(set(product_prod(B,A)),set(product_prod(B,A)),insert2(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uu),Uua)),bot_bot(set(product_prod(B,A)))) ) ).

% ATP.lambda_63
tff(fact_5786_ATP_Olambda__64,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] : ( aa(B,set(product_prod(A,B)),aTP_Lamp_hw(A,fun(B,set(product_prod(A,B))),Uu),Uua) = aa(set(product_prod(A,B)),set(product_prod(A,B)),insert2(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uu),Uua)),bot_bot(set(product_prod(A,B)))) ) ).

% ATP.lambda_64
tff(fact_5787_ATP_Olambda__65,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aTP_Lamp_rg(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),aa(set(product_prod(A,B)),set(product_prod(A,B)),insert2(product_prod(A,B),Uua),bot_bot(set(product_prod(A,B))))),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_65
tff(fact_5788_ATP_Olambda__66,axiom,
    ! [D: $tType,B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: fun(D,product_prod(A,B))] :
      ( pp(aa(fun(D,product_prod(A,B)),bool,aTP_Lamp_gr(fun(A,fun(B,bool)),fun(fun(D,product_prod(A,B)),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),aa(set(D),set(product_prod(A,B)),image2(D,product_prod(A,B),Uua),top_top(set(D)))),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_66
tff(fact_5789_ATP_Olambda__67,axiom,
    ! [A: $tType,Uu: fun(set(A),bool),Uua: set(A)] :
      ( pp(aa(set(A),bool,aa(fun(set(A),bool),fun(set(A),bool),aTP_Lamp_nc(fun(set(A),bool),fun(set(A),bool)),Uu),Uua))
    <=> ( ( Uua = bot_bot(set(A)) )
        | ? [A11: set(A),A6: A] :
            ( ( Uua = aa(set(A),set(A),insert2(A,A6),A11) )
            & pp(aa(set(A),bool,Uu,A11)) ) ) ) ).

% ATP.lambda_67
tff(fact_5790_ATP_Olambda__68,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: fun(A,B)] :
      ( pp(aa(fun(A,B),bool,aTP_Lamp_nn(set(B),fun(fun(A,B),bool),Uu),Uua))
    <=> pp(aa(set(B),bool,aa(set(B),fun(set(B),bool),ord_less_eq(set(B)),aa(set(A),set(B),image2(A,B,Uua),top_top(set(A)))),Uu)) ) ).

% ATP.lambda_68
tff(fact_5791_ATP_Olambda__69,axiom,
    ! [D: $tType,A: $tType,Uu: set(A),Uua: fun(D,A)] :
      ( pp(aa(fun(D,A),bool,aTP_Lamp_ol(set(A),fun(fun(D,A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(D),set(A),image2(D,A,Uua),top_top(set(D)))),Uu)) ) ).

% ATP.lambda_69
tff(fact_5792_ATP_Olambda__70,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A] : ( aa(A,set(set(A)),aTP_Lamp_ky(set(product_prod(A,A)),fun(A,set(set(A))),Uu),Uua) = equiv_quotient(A,aa(set(A),set(A),insert2(A,Uua),bot_bot(set(A))),Uu) ) ).

% ATP.lambda_70
tff(fact_5793_ATP_Olambda__71,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,product_prod(A,B)),Uua: A] : ( aa(A,set(B),aTP_Lamp_hi(fun(C,product_prod(A,B)),fun(A,set(B)),Uu),Uua) = aa(set(C),set(B),image2(C,B,aa(fun(C,product_prod(A,B)),fun(C,B),aa(fun(product_prod(A,B),B),fun(fun(C,product_prod(A,B)),fun(C,B)),comp(product_prod(A,B),B,C),product_snd(A,B)),Uu)),top_top(set(C))) ) ).

% ATP.lambda_71
tff(fact_5794_ATP_Olambda__72,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_dt(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ) ).

% ATP.lambda_72
tff(fact_5795_ATP_Olambda__73,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_aw(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_73
tff(fact_5796_ATP_Olambda__74,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(A,bool),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_pb(fun(A,bool),fun(A,bool),Uu),Uua))
        <=> ( pp(aa(A,bool,Uu,Uua))
            & ! [Y3: A] :
                ( pp(aa(A,bool,Uu,Y3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Y3)) ) ) ) ) ).

% ATP.lambda_74
tff(fact_5797_ATP_Olambda__75,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: fun(A,bool),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_pc(fun(A,bool),fun(A,bool),Uu),Uua))
        <=> ( pp(aa(A,bool,Uu,Uua))
            & ! [Y3: A] :
                ( pp(aa(A,bool,Uu,Y3))
               => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Y3),Uua)) ) ) ) ) ).

% ATP.lambda_75
tff(fact_5798_ATP_Olambda__76,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,product_prod(nat,A),aTP_Lamp_hk(fun(A,nat),fun(A,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),aa(A,nat,Uu,Uua)),Uua) ) ).

% ATP.lambda_76
tff(fact_5799_ATP_Olambda__77,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,product_prod(B,A),aTP_Lamp_bq(fun(A,B),fun(A,product_prod(B,A)),Uu),Uua) = aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),aa(A,B,Uu,Uua)),Uua) ) ).

% ATP.lambda_77
tff(fact_5800_ATP_Olambda__78,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: A] : ( aa(A,assn,aTP_Lamp_cm(fun(A,assn),fun(A,assn),Uu),Uua) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(A,assn,Uu,Uua)),top_top(assn)) ) ).

% ATP.lambda_78
tff(fact_5801_ATP_Olambda__79,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,A),Uua: B] : ( aa(B,set(A),aTP_Lamp_iv(fun(B,A),fun(B,set(A)),Uu),Uua) = aa(set(A),set(A),insert2(A,aa(B,A,Uu,Uua)),bot_bot(set(A))) ) ).

% ATP.lambda_79
tff(fact_5802_ATP_Olambda__80,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: B] :
          ( pp(aa(B,bool,aTP_Lamp_ce(fun(B,A),fun(B,bool),Uu),Uua))
        <=> ( aa(B,A,Uu,Uua) = one_one(A) ) ) ) ).

% ATP.lambda_80
tff(fact_5803_ATP_Olambda__81,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: list(A),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_rr(list(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rq(list(A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(A,Uu,Uua)) ) ) ).

% ATP.lambda_81
tff(fact_5804_ATP_Olambda__82,axiom,
    ! [Uu: assn,Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aTP_Lamp_cw(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uu),Uua))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,Uua))
        & ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Uu),Uua)) ) ) ).

% ATP.lambda_82
tff(fact_5805_ATP_Olambda__83,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aTP_Lamp_al(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uu),Uua))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,in_range,Uua))
        & ~ pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Uu,Uua)) ) ) ).

% ATP.lambda_83
tff(fact_5806_ATP_Olambda__84,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: heap_Time_Heap(product_prod(A,B))] :
      ( pp(aa(heap_Time_Heap(product_prod(A,B)),bool,aTP_Lamp_vc(fun(A,fun(B,bool)),fun(heap_Time_Heap(product_prod(A,B)),bool),Uu),Uua))
    <=> pp(aa(set(product_prod(A,B)),bool,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),bool),ord_less_eq(set(product_prod(A,B))),aa(heap_Time_Heap(product_prod(A,B)),set(product_prod(A,B)),heap_Time_set_Heap(product_prod(A,B)),Uua)),aa(fun(product_prod(A,B),bool),set(product_prod(A,B)),collect(product_prod(A,B)),aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),Uu)))) ) ).

% ATP.lambda_84
tff(fact_5807_ATP_Olambda__85,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: set(set(A))] : ( aa(set(set(A)),set(A),aTP_Lamp_xc(fun(A,fun(B,bool)),fun(set(set(A)),set(A)),Uu),Uua) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),Uua)),aa(fun(A,bool),set(A),collect(A),domainp(A,B,Uu))) ) ).

% ATP.lambda_85
tff(fact_5808_ATP_Olambda__86,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: set(A)] : ( aa(set(A),set(A),aTP_Lamp_xd(fun(A,fun(B,bool)),fun(set(A),set(A)),Uu),Uua) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),Uua)),aa(fun(A,bool),set(A),collect(A),domainp(A,B,Uu))) ) ).

% ATP.lambda_86
tff(fact_5809_ATP_Olambda__87,axiom,
    ! [A: $tType,Uu: pred(A),Uua: seq(A)] : ( aa(seq(A),set(A),aa(pred(A),fun(seq(A),set(A)),aTP_Lamp_we(pred(A),fun(seq(A),set(A))),Uu),Uua) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(pred(A),set(A),set_of_pred(A),Uu)),aa(seq(A),set(A),set_of_seq(A),Uua)) ) ).

% ATP.lambda_87
tff(fact_5810_ATP_Olambda__88,axiom,
    ! [A: $tType,Uu: set(A),Uua: heap_Time_Heap(A)] :
      ( pp(aa(heap_Time_Heap(A),bool,aTP_Lamp_vb(set(A),fun(heap_Time_Heap(A),bool),Uu),Uua))
    <=> pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(heap_Time_Heap(A),set(A),heap_Time_set_Heap(A),Uua)),Uu)) ) ).

% ATP.lambda_88
tff(fact_5811_ATP_Olambda__89,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_eb(nat,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),Uua)),Uu) ) ) ).

% ATP.lambda_89
tff(fact_5812_ATP_Olambda__90,axiom,
    ! [A: $tType,B: $tType,Uu: list(B),Uua: A] : ( aa(A,list(product_prod(A,B)),aTP_Lamp_tl(list(B),fun(A,list(product_prod(A,B))),Uu),Uua) = aa(list(B),list(product_prod(A,B)),map(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua)),Uu) ) ).

% ATP.lambda_90
tff(fact_5813_ATP_Olambda__91,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_sp(nat,fun(list(A),bool),Uu),Uua))
    <=> ( size_size(list(A),Uua) = Uu ) ) ).

% ATP.lambda_91
tff(fact_5814_ATP_Olambda__92,axiom,
    ! [Uu: heap_ext(product_unit),Uua: nat] : ( aa(nat,nat,aTP_Lamp_mz(heap_ext(product_unit),fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),lim(product_unit,Uu)),one_one(nat)) ) ).

% ATP.lambda_92
tff(fact_5815_ATP_Olambda__93,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(A,A))] : ( aa(set(product_prod(A,A)),set(set(product_prod(A,A))),aTP_Lamp_pl(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(set(product_prod(A,A)))),Uu),Uua) = image(set(product_prod(A,A)),set(product_prod(A,A)),converse(set(product_prod(A,A)),set(product_prod(A,A)),bNF_We4044943003108391690rdLess(A,A)),aa(set(set(product_prod(A,A))),set(set(product_prod(A,A))),insert2(set(product_prod(A,A)),Uu),bot_bot(set(set(product_prod(A,A)))))) ) ).

% ATP.lambda_93
tff(fact_5816_ATP_Olambda__94,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_eo(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),one_one(A))) ) ) ).

% ATP.lambda_94
tff(fact_5817_ATP_Olambda__95,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_er(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)) ) ) ).

% ATP.lambda_95
tff(fact_5818_ATP_Olambda__96,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_aa(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),divide_divide(A,aa(nat,A,semiring_1_of_nat(A),Uua),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_96
tff(fact_5819_ATP_Olambda__97,axiom,
    ! [A: $tType,Uu: A,Uua: set(set(A))] : ( aa(set(set(A)),set(set(A)),aa(A,fun(set(set(A)),set(set(A))),aTP_Lamp_ji(A,fun(set(set(A)),set(set(A)))),Uu),Uua) = aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),Uua),aa(set(set(A)),set(set(A)),image2(set(A),set(A),insert2(A,Uu)),Uua)) ) ).

% ATP.lambda_97
tff(fact_5820_ATP_Olambda__98,axiom,
    ! [A: $tType,Uu: A,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),aTP_Lamp_lz(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),zero_zero(nat))) ) ).

% ATP.lambda_98
tff(fact_5821_ATP_Olambda__99,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: ref(A),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),aa(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mw(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),aa(ref(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),product_Pair(ref(A),product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat))) ) ) ).

% ATP.lambda_99
tff(fact_5822_ATP_Olambda__100,axiom,
    ! [A: $tType,Uu: A,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),aTP_Lamp_lu(A,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat))) ) ).

% ATP.lambda_100
tff(fact_5823_ATP_Olambda__101,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,A)),Uua: B] : ( aa(B,set(A),aTP_Lamp_ln(set(product_prod(B,A)),fun(B,set(A)),Uu),Uua) = image(B,A,Uu,aa(set(B),set(B),insert2(B,Uua),bot_bot(set(B)))) ) ).

% ATP.lambda_101
tff(fact_5824_ATP_Olambda__102,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: B] : ( aa(B,set(A),aTP_Lamp_jo(fun(A,B),fun(B,set(A)),Uu),Uua) = aa(set(B),set(A),aa(fun(A,B),fun(set(B),set(A)),vimage(A,B),Uu),aa(set(B),set(B),insert2(B,Uua),bot_bot(set(B)))) ) ).

% ATP.lambda_102
tff(fact_5825_ATP_Olambda__103,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_jt(set(A),fun(A,bool),Uu),Uua))
    <=> ( Uu = aa(set(A),set(A),insert2(A,Uua),bot_bot(set(A))) ) ) ).

% ATP.lambda_103
tff(fact_5826_ATP_Olambda__104,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat] : ( aa(nat,product_prod(nat,A),aTP_Lamp_tg(fun(nat,A),fun(nat,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),Uua),aa(nat,A,Uu,Uua)) ) ).

% ATP.lambda_104
tff(fact_5827_ATP_Olambda__105,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,product_prod(A,B),aTP_Lamp_bp(fun(A,B),fun(A,product_prod(A,B)),Uu),Uua) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),aa(A,B,Uu,Uua)) ) ).

% ATP.lambda_105
tff(fact_5828_ATP_Olambda__106,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: A] : ( aa(A,product_prod(A,B),aTP_Lamp_oe(fun(A,option(B)),fun(A,product_prod(A,B)),Uu),Uua) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),aa(option(B),B,the2(B),aa(A,option(B),Uu,Uua))) ) ).

% ATP.lambda_106
tff(fact_5829_ATP_Olambda__107,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_dx(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_107
tff(fact_5830_ATP_Olambda__108,axiom,
    ! [A: $tType,Uu: list(set(A)),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_sn(list(set(A)),fun(set(A),bool),Uu),Uua))
    <=> pp(member(set(A),Uua,aa(list(set(A)),set(set(A)),set2(set(A)),Uu))) ) ).

% ATP.lambda_108
tff(fact_5831_ATP_Olambda__109,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_tk(list(A),fun(A,bool),Uu),Uua))
    <=> pp(member(A,Uua,aa(list(A),set(A),set2(A),Uu))) ) ).

% ATP.lambda_109
tff(fact_5832_ATP_Olambda__110,axiom,
    ! [A: $tType,Uu: A,Uua: pred(A)] : ( aa(pred(A),set(A),aa(A,fun(pred(A),set(A)),aTP_Lamp_wd(A,fun(pred(A),set(A))),Uu),Uua) = aa(set(A),set(A),insert2(A,Uu),aa(pred(A),set(A),set_of_pred(A),Uua)) ) ).

% ATP.lambda_110
tff(fact_5833_ATP_Olambda__111,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] :
      ( pp(aa(list(A),bool,aTP_Lamp_sq(nat,fun(list(A),bool),Uu),Uua))
    <=> ( Uu = size_size(list(A),Uua) ) ) ).

% ATP.lambda_111
tff(fact_5834_ATP_Olambda__112,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ct(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_112
tff(fact_5835_ATP_Olambda__113,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_oh(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_113
tff(fact_5836_ATP_Olambda__114,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ch(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_114
tff(fact_5837_ATP_Olambda__115,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_wf(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_115
tff(fact_5838_ATP_Olambda__116,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ux(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_116
tff(fact_5839_ATP_Olambda__117,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_vl(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),Uu)) ) ) ).

% ATP.lambda_117
tff(fact_5840_ATP_Olambda__118,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_ds(nat,fun(nat,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uua),Uu)) ) ).

% ATP.lambda_118
tff(fact_5841_ATP_Olambda__119,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_cu(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_119
tff(fact_5842_ATP_Olambda__120,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_oi(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_120
tff(fact_5843_ATP_Olambda__121,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ci(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_121
tff(fact_5844_ATP_Olambda__122,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_wp(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_122
tff(fact_5845_ATP_Olambda__123,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_uy(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_123
tff(fact_5846_ATP_Olambda__124,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: A,Uua: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_vm(A,fun(A,bool)),Uu),Uua))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),Uu)) ) ) ).

% ATP.lambda_124
tff(fact_5847_ATP_Olambda__125,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_dg(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_125
tff(fact_5848_ATP_Olambda__126,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_df(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uu) ) ).

% ATP.lambda_126
tff(fact_5849_ATP_Olambda__127,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_bw(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_127
tff(fact_5850_ATP_Olambda__128,axiom,
    ! [A: $tType,Uu: A,Uua: multiset(A)] : ( aa(multiset(A),nat,aTP_Lamp_qg(A,fun(multiset(A),nat),Uu),Uua) = aa(A,nat,aa(multiset(A),fun(A,nat),count(A),Uua),Uu) ) ).

% ATP.lambda_128
tff(fact_5851_ATP_Olambda__129,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_kh(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Uua),Uu) ) ) ).

% ATP.lambda_129
tff(fact_5852_ATP_Olambda__130,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] : ( aa(set(A),set(A),aTP_Lamp_ip(set(A),fun(set(A),set(A)),Uu),Uua) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uua),Uu) ) ).

% ATP.lambda_130
tff(fact_5853_ATP_Olambda__131,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ia(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uua),Uu) ) ) ).

% ATP.lambda_131
tff(fact_5854_ATP_Olambda__132,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: A,Uua: ref(A)] : ( aa(ref(A),assn,aa(A,fun(ref(A),assn),aTP_Lamp_bj(A,fun(ref(A),assn)),Uu),Uua) = sngr_assn(A,Uua,Uu) ) ) ).

% ATP.lambda_132
tff(fact_5855_ATP_Olambda__133,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: list(A),Uua: array(A)] : ( aa(array(A),assn,aa(list(A),fun(array(A),assn),aTP_Lamp_bk(list(A),fun(array(A),assn)),Uu),Uua) = snga_assn(A,Uua,Uu) ) ) ).

% ATP.lambda_133
tff(fact_5856_ATP_Olambda__134,axiom,
    ! [Uu: nat,Uua: nat] :
      ( pp(aa(nat,bool,aTP_Lamp_lh(nat,fun(nat,bool),Uu),Uua))
    <=> pp(dvd_dvd(nat,Uua,Uu)) ) ).

% ATP.lambda_134
tff(fact_5857_ATP_Olambda__135,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat))),Uu),Uua) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Uua),Uu) ) ).

% ATP.lambda_135
tff(fact_5858_ATP_Olambda__136,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: A] : ( aa(A,product_prod(A,B),aa(B,fun(A,product_prod(A,B)),aTP_Lamp_ex(B,fun(A,product_prod(A,B))),Uu),Uua) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uu) ) ).

% ATP.lambda_136
tff(fact_5859_ATP_Olambda__137,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,product_prod(nat,A),aTP_Lamp_tm(A,fun(nat,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),aa(nat,fun(A,product_prod(nat,A)),product_Pair(nat,A),Uua),Uu) ) ).

% ATP.lambda_137
tff(fact_5860_ATP_Olambda__138,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] : ( aa(B,product_prod(B,A),aa(A,fun(B,product_prod(B,A)),aTP_Lamp_es(A,fun(B,product_prod(B,A))),Uu),Uua) = aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uua),Uu) ) ).

% ATP.lambda_138
tff(fact_5861_ATP_Olambda__139,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_ma(set(B),fun(B,bool),Uu),Uua))
    <=> pp(member(B,Uua,Uu)) ) ).

% ATP.lambda_139
tff(fact_5862_ATP_Olambda__140,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_hf(set(A),fun(A,bool),Uu),Uua))
        <=> pp(member(A,Uua,Uu)) ) ) ).

% ATP.lambda_140
tff(fact_5863_ATP_Olambda__141,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_a(set(A),fun(A,bool)),Uu),Uua))
    <=> pp(member(A,Uua,Uu)) ) ).

% ATP.lambda_141
tff(fact_5864_ATP_Olambda__142,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(A,C),Uua: fun(C,set(B))] : ( aa(fun(C,set(B)),fun(A,set(B)),aTP_Lamp_kq(fun(A,C),fun(fun(C,set(B)),fun(A,set(B))),Uu),Uua) = aa(fun(A,C),fun(A,set(B)),aa(fun(C,set(B)),fun(fun(A,C),fun(A,set(B))),comp(C,set(B),A),Uua),Uu) ) ).

% ATP.lambda_142
tff(fact_5865_ATP_Olambda__143,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ai(A,fun(A,bool),Uu),Uua))
    <=> ( Uua = Uu ) ) ).

% ATP.lambda_143
tff(fact_5866_ATP_Olambda__144,axiom,
    ! [A: $tType,Uu: A,Uua: product_unit] : ( aa(product_unit,seq(A),aTP_Lamp_vs(A,fun(product_unit,seq(A)),Uu),Uua) = insert(A,Uu,bot_bot(pred(A))) ) ).

% ATP.lambda_144
tff(fact_5867_ATP_Olambda__145,axiom,
    ! [A: $tType,Uu: A,Uua: A] : ( aa(A,set(A),aTP_Lamp_lp(A,fun(A,set(A)),Uu),Uua) = aa(set(A),set(A),insert2(A,Uu),bot_bot(set(A))) ) ).

% ATP.lambda_145
tff(fact_5868_ATP_Olambda__146,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: A,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_mx(A,fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(ref(A),heap_ext(product_unit)),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)),aa(fun(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(ref(A),heap_ext(product_unit)),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(ref(A),heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mw(ref(A),fun(heap_ext(product_unit),product_prod(ref(A),product_prod(heap_ext(product_unit),nat))))),ref_alloc(A,Uu,Uua)) ) ) ).

% ATP.lambda_146
tff(fact_5869_ATP_Olambda__147,axiom,
    ! [A: $tType,Uu: multiset(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_qe(multiset(A),fun(A,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(A,nat,aa(multiset(A),fun(A,nat),count(A),Uu),Uua))) ) ).

% ATP.lambda_147
tff(fact_5870_ATP_Olambda__148,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_rb(fun(B,nat),fun(B,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(B,nat,Uu,Uua))) ) ).

% ATP.lambda_148
tff(fact_5871_ATP_Olambda__149,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_qy(fun(A,nat),fun(A,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(A,nat,Uu,Uua))) ) ).

% ATP.lambda_149
tff(fact_5872_ATP_Olambda__150,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_qh(set(multiset(A)),fun(A,bool),Uu),Uua))
    <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),zero_zero(nat)),aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(A)),set(nat),image2(multiset(A),nat,aTP_Lamp_qg(A,fun(multiset(A),nat),Uua)),Uu)))) ) ).

% ATP.lambda_150
tff(fact_5873_ATP_Olambda__151,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_nx(nat,fun(nat,set(nat)),Uu),Uua) = order_underS(nat,bNF_Ca8665028551170535155natLeq,Uu) ) ).

% ATP.lambda_151
tff(fact_5874_ATP_Olambda__152,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_cr(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_152
tff(fact_5875_ATP_Olambda__153,axiom,
    ! [A: $tType,C: $tType,Uu: C,Uua: fun(C,set(set(A)))] : ( aa(fun(C,set(set(A))),set(set(A)),aTP_Lamp_ni(C,fun(fun(C,set(set(A))),set(set(A))),Uu),Uua) = aa(C,set(set(A)),Uua,Uu) ) ).

% ATP.lambda_153
tff(fact_5876_ATP_Olambda__154,axiom,
    ! [A: $tType,Uu: A,Uua: fun(A,nat)] : ( aa(fun(A,nat),nat,aTP_Lamp_qi(A,fun(fun(A,nat),nat),Uu),Uua) = aa(A,nat,Uua,Uu) ) ).

% ATP.lambda_154
tff(fact_5877_ATP_Olambda__155,axiom,
    ! [B: $tType,A: $tType,Uu: fun(set(A),A),Uua: B] : ( aa(B,A,aTP_Lamp_vp(fun(set(A),A),fun(B,A),Uu),Uua) = aa(set(A),A,Uu,bot_bot(set(A))) ) ).

% ATP.lambda_155
tff(fact_5878_ATP_Olambda__156,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: option(A)] : ( aa(option(A),option(A),aa(A,fun(option(A),option(A)),aTP_Lamp_ml(A,fun(option(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),case_option(A,A,Uu,aa(A,fun(A,A),sup_sup(A),Uu),Uua)) ) ) ).

% ATP.lambda_156
tff(fact_5879_ATP_Olambda__157,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Uu: A,Uua: option(A)] : ( aa(option(A),option(A),aa(A,fun(option(A),option(A)),aTP_Lamp_mm(A,fun(option(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),case_option(A,A,Uu,aa(A,fun(A,A),inf_inf(A),Uu),Uua)) ) ) ).

% ATP.lambda_157
tff(fact_5880_ATP_Olambda__158,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_ww(nat,fun(num,option(num)),Uu),Uua) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(Uu,Uua))) ) ).

% ATP.lambda_158
tff(fact_5881_ATP_Olambda__159,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] : ( aa(list(A),fun(product_prod(A,list(A)),option(bool)),aTP_Lamp_st(list(A),fun(list(A),fun(product_prod(A,list(A)),option(bool))),Uu),Uua) = aa(fun(A,fun(list(A),option(bool))),fun(product_prod(A,list(A)),option(bool)),product_case_prod(A,list(A),option(bool)),aa(list(A),fun(A,fun(list(A),option(bool))),aTP_Lamp_ss(list(A),fun(list(A),fun(A,fun(list(A),option(bool)))),Uu),Uua)) ) ).

% ATP.lambda_159
tff(fact_5882_ATP_Olambda__160,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A))))),aTP_Lamp_se(A,fun(list(A),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A)))))),Uu),Uua) = aa(fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),fun(product_prod(A,list(A)),option(product_prod(list(A),product_prod(A,list(A))))),product_case_prod(A,list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_sd(A,fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua)) ) ).

% ATP.lambda_160
tff(fact_5883_ATP_Olambda__161,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,heap_Time_Heap(A)),Uua: B] : ( aa(B,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mt(fun(B,heap_Time_Heap(A)),fun(B,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),Uu),Uua) = aa(fun(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(heap_ext(product_unit),nat),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),product_case_prod(heap_ext(product_unit),nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(B,fun(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_ms(fun(B,heap_Time_Heap(A)),fun(B,fun(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua)) ) ).

% ATP.lambda_161
tff(fact_5884_ATP_Olambda__162,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,heap_Time_Heap(B)),Uua: A] : ( aa(A,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mo(fun(A,heap_Time_Heap(B)),fun(A,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua) = aa(fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),product_case_prod(heap_ext(product_unit),nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(A,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_mn(fun(A,heap_Time_Heap(B)),fun(A,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua)) ) ).

% ATP.lambda_162
tff(fact_5885_ATP_Olambda__163,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gz(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_163
tff(fact_5886_ATP_Olambda__164,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gx(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_164
tff(fact_5887_ATP_Olambda__165,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gv(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_165
tff(fact_5888_ATP_Olambda__166,axiom,
    ! [A: $tType,Uu: fun(heap_ext(product_unit),A),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mh(fun(heap_ext(product_unit),A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),A,Uu,Uua)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat)))) ) ).

% ATP.lambda_166
tff(fact_5889_ATP_Olambda__167,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_tr(fun(A,option(B)),fun(A,bool),Uu),Uua))
    <=> ( aa(A,option(B),Uu,Uua) != none(B) ) ) ).

% ATP.lambda_167
tff(fact_5890_ATP_Olambda__168,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,set(product_prod(A,B)),aTP_Lamp_hx(fun(A,set(B)),fun(A,set(product_prod(A,B))),Uu),Uua) = aa(set(set(product_prod(A,B))),set(product_prod(A,B)),complete_Sup_Sup(set(product_prod(A,B))),aa(set(B),set(set(product_prod(A,B))),image2(B,set(product_prod(A,B)),aTP_Lamp_hw(A,fun(B,set(product_prod(A,B))),Uua)),aa(A,set(B),Uu,Uua))) ) ).

% ATP.lambda_168
tff(fact_5891_ATP_Olambda__169,axiom,
    ! [B: $tType,A: $tType,Uu: set(set(old_node(A,B))),Uua: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(set(old_node(A,B))),aTP_Lamp_xb(set(set(old_node(A,B))),fun(set(old_node(A,B)),set(set(old_node(A,B)))),Uu),Uua) = aa(set(set(set(old_node(A,B)))),set(set(old_node(A,B))),complete_Sup_Sup(set(set(old_node(A,B)))),aa(set(set(old_node(A,B))),set(set(set(old_node(A,B)))),image2(set(old_node(A,B)),set(set(old_node(A,B))),aTP_Lamp_xa(set(old_node(A,B)),fun(set(old_node(A,B)),set(set(old_node(A,B)))),Uua)),Uu)) ) ).

% ATP.lambda_169
tff(fact_5892_ATP_Olambda__170,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: A] : ( aa(A,nat,aTP_Lamp_qj(set(multiset(A)),fun(A,nat),Uu),Uua) = aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(A)),set(nat),image2(multiset(A),nat,aTP_Lamp_qg(A,fun(multiset(A),nat),Uua)),Uu)) ) ).

% ATP.lambda_170
tff(fact_5893_ATP_Olambda__171,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: list(product_prod(C,B)),Uua: product_prod(A,C)] : ( aa(product_prod(A,C),list(product_prod(A,B)),aTP_Lamp_tf(list(product_prod(C,B)),fun(product_prod(A,C),list(product_prod(A,B))),Uu),Uua) = concat(product_prod(A,B),aa(list(product_prod(C,B)),list(list(product_prod(A,B))),map(product_prod(C,B),list(product_prod(A,B)),aTP_Lamp_te(product_prod(A,C),fun(product_prod(C,B),list(product_prod(A,B))),Uua)),Uu)) ) ).

% ATP.lambda_171
tff(fact_5894_ATP_Olambda__172,axiom,
    ! [Uu: code_natural,Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_ud(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),Uua),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),Uu),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2)))))))))))))))))))))))))))))))))) ) ).

% ATP.lambda_172
tff(fact_5895_ATP_Olambda__173,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_ek(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_173
tff(fact_5896_ATP_Olambda__174,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_ee(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_174
tff(fact_5897_ATP_Olambda__175,axiom,
    ! [A: $tType,Uu: list(A),Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))),aTP_Lamp_uk(list(A),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(A,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))),product_Pair(A,product_prod(code_natural,code_natural)),nth(A,Uu,code_nat_of_natural(Uua))) ) ).

% ATP.lambda_175
tff(fact_5898_ATP_Olambda__176,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_tj(list(A),fun(A,bool),Uu),Uua))
    <=> ~ pp(member(A,Uua,aa(list(A),set(A),set2(A),Uu))) ) ).

% ATP.lambda_176
tff(fact_5899_ATP_Olambda__177,axiom,
    ! [A: $tType] :
      ( sup(A)
     => ! [Uu: A,Uua: A] : ( aa(A,option(A),aTP_Lamp_mq(A,fun(A,option(A)),Uu),Uua) = aa(A,option(A),some(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Uu),Uua)) ) ) ).

% ATP.lambda_177
tff(fact_5900_ATP_Olambda__178,axiom,
    ! [A: $tType] :
      ( inf(A)
     => ! [Uu: A,Uua: A] : ( aa(A,option(A),aTP_Lamp_mu(A,fun(A,option(A)),Uu),Uua) = aa(A,option(A),some(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),Uua)) ) ) ).

% ATP.lambda_178
tff(fact_5901_ATP_Olambda__179,axiom,
    ! [Uu: code_natural,Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_uf(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),modulo_modulo(code_natural,Uua,Uu)) ) ).

% ATP.lambda_179
tff(fact_5902_ATP_Olambda__180,axiom,
    ! [A: $tType,Uu: pred(A),Uua: pred(A)] : ( aa(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),aTP_Lamp_up(pred(A),fun(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))),Uu),Uua) = aa(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),product_Pair(pred(A),product_prod(code_natural,code_natural)),aa(pred(A),pred(A),aa(pred(A),fun(pred(A),pred(A)),sup_sup(pred(A)),Uu),Uua)) ) ).

% ATP.lambda_180
tff(fact_5903_ATP_Olambda__181,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: A,Uua: B] : ( aa(B,fun(C,product_prod(product_prod(A,B),C)),aTP_Lamp_ug(A,fun(B,fun(C,product_prod(product_prod(A,B),C))),Uu),Uua) = aa(product_prod(A,B),fun(C,product_prod(product_prod(A,B),C)),product_Pair(product_prod(A,B),C),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uu),Uua)) ) ).

% ATP.lambda_181
tff(fact_5904_ATP_Olambda__182,axiom,
    ! [A: $tType,Uu: list(product_prod(code_natural,A)),Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))),aTP_Lamp_ui(list(product_prod(code_natural,A)),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(A,fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))),product_Pair(A,product_prod(code_natural,code_natural)),pick(A,Uu,Uua)) ) ).

% ATP.lambda_182
tff(fact_5905_ATP_Olambda__183,axiom,
    ! [B: $tType,A: $tType,Uu: B,Uua: A] : ( aa(A,fun(set(product_prod(B,A)),set(product_prod(B,A))),aTP_Lamp_gf(B,fun(A,fun(set(product_prod(B,A)),set(product_prod(B,A)))),Uu),Uua) = insert2(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uu),Uua)) ) ).

% ATP.lambda_183
tff(fact_5906_ATP_Olambda__184,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: B] : ( aa(B,fun(set(product_prod(A,B)),set(product_prod(A,B))),aTP_Lamp_iz(A,fun(B,fun(set(product_prod(A,B)),set(product_prod(A,B)))),Uu),Uua) = insert2(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uu),Uua)) ) ).

% ATP.lambda_184
tff(fact_5907_ATP_Olambda__185,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ws(A,fun(A,bool)),Uu),Uua))
    <=> ( Uu != Uua ) ) ).

% ATP.lambda_185
tff(fact_5908_ATP_Olambda__186,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ti(A,fun(A,bool),Uu),Uua))
    <=> ( Uua != Uu ) ) ).

% ATP.lambda_186
tff(fact_5909_ATP_Olambda__187,axiom,
    ! [A: $tType,Uu: A,Uua: A] : ( aa(A,set(A),aTP_Lamp_je(A,fun(A,set(A)),Uu),Uua) = aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert2(A,Uu),bot_bot(set(A)))) ) ).

% ATP.lambda_187
tff(fact_5910_ATP_Olambda__188,axiom,
    ! [Uu: nat,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mg(nat,fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),some(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(product_unit,fun(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),product_Pair(product_unit,product_prod(heap_ext(product_unit),nat)),product_Unity),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),Uu))) ) ).

% ATP.lambda_188
tff(fact_5911_ATP_Olambda__189,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B] : ( aa(B,set(product_prod(C,C)),aTP_Lamp_nu(fun(B,set(C)),fun(B,set(product_prod(C,C))),Uu),Uua) = bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),Uu,Uua)) ) ).

% ATP.lambda_189
tff(fact_5912_ATP_Olambda__190,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,set(product_prod(B,B)),aTP_Lamp_nv(fun(A,set(B)),fun(A,set(product_prod(B,B))),Uu),Uua) = bNF_Ca6860139660246222851ard_of(B,aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_190
tff(fact_5913_ATP_Olambda__191,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,bool),Uua: B] : ( aa(B,A,aTP_Lamp_ax(fun(B,bool),fun(B,A),Uu),Uua) = aa(bool,A,zero_neq_one_of_bool(A),aa(B,bool,Uu,Uua)) ) ) ).

% ATP.lambda_191
tff(fact_5914_ATP_Olambda__192,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_cx(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_192
tff(fact_5915_ATP_Olambda__193,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: B] : ( aa(B,heap_Time_Heap(A),aTP_Lamp_cj(fun(B,A),fun(B,heap_Time_Heap(A)),Uu),Uua) = aa(A,heap_Time_Heap(A),heap_Time_return(A),aa(B,A,Uu,Uua)) ) ).

% ATP.lambda_193
tff(fact_5916_ATP_Olambda__194,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,option(B),aTP_Lamp_md(fun(A,B),fun(A,option(B)),Uu),Uua) = aa(B,option(B),some(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_194
tff(fact_5917_ATP_Olambda__195,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,assn)),Uua: A] : ( aa(A,assn,aTP_Lamp_lb(fun(A,fun(B,assn)),fun(A,assn),Uu),Uua) = ex_assn(B,aa(A,fun(B,assn),Uu,Uua)) ) ).

% ATP.lambda_195
tff(fact_5918_ATP_Olambda__196,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(C,A),Uua: C] : ( aa(C,fun(B,product_prod(A,B)),aTP_Lamp_sy(fun(C,A),fun(C,fun(B,product_prod(A,B))),Uu),Uua) = aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,Uu,Uua)) ) ).

% ATP.lambda_196
tff(fact_5919_ATP_Olambda__197,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,fun(C,product_prod(B,C)),aTP_Lamp_td(fun(A,B),fun(A,fun(C,product_prod(B,C))),Uu),Uua) = aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(A,B,Uu,Uua)) ) ).

% ATP.lambda_197
tff(fact_5920_ATP_Olambda__198,axiom,
    ! [C: $tType,D: $tType,Uu: fun(D,set(C)),Uua: D] : ( aa(D,filter(C),aTP_Lamp_ul(fun(D,set(C)),fun(D,filter(C)),Uu),Uua) = principal(C,aa(D,set(C),Uu,Uua)) ) ).

% ATP.lambda_198
tff(fact_5921_ATP_Olambda__199,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,filter(B),aTP_Lamp_um(fun(A,set(B)),fun(A,filter(B)),Uu),Uua) = principal(B,aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_199
tff(fact_5922_ATP_Olambda__200,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,nat,aTP_Lamp_jb(fun(A,set(B)),fun(A,nat),Uu),Uua) = finite_card(B,aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_200
tff(fact_5923_ATP_Olambda__201,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: A] : ( aa(A,fun(set(B),set(B)),aTP_Lamp_fy(fun(A,B),fun(A,fun(set(B),set(B))),Uu),Uua) = insert2(B,aa(A,B,Uu,Uua)) ) ).

% ATP.lambda_201
tff(fact_5924_ATP_Olambda__202,axiom,
    ! [B: $tType,Uu: fun(B,bool),Uua: B] :
      ( pp(aa(B,bool,aTP_Lamp_ap(fun(B,bool),fun(B,bool),Uu),Uua))
    <=> ~ pp(aa(B,bool,Uu,Uua)) ) ).

% ATP.lambda_202
tff(fact_5925_ATP_Olambda__203,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_od(fun(A,bool),fun(A,bool),Uu),Uua))
    <=> ~ pp(aa(A,bool,Uu,Uua)) ) ).

% ATP.lambda_203
tff(fact_5926_ATP_Olambda__204,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_nz(nat,fun(nat,set(nat)),Uu),Uua) = aa(fun(nat,bool),set(nat),collect(nat),aTP_Lamp_ds(nat,fun(nat,bool),Uu)) ) ).

% ATP.lambda_204
tff(fact_5927_ATP_Olambda__205,axiom,
    ! [A: $tType,Uu: fun(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aTP_Lamp_jz(fun(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uu),Uua))
    <=> ? [X4: A] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(A,fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uu,X4),Uua)) ) ).

% ATP.lambda_205
tff(fact_5928_ATP_Olambda__206,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_on(set(A),fun(A,bool),Uu),Uua))
        <=> ! [X4: A] :
              ( pp(member(A,X4,Uu))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),Uua),X4)) ) ) ) ).

% ATP.lambda_206
tff(fact_5929_ATP_Olambda__207,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( pp(aa(A,bool,aTP_Lamp_oo(set(A),fun(A,bool),Uu),Uua))
        <=> ! [X4: A] :
              ( pp(member(A,X4,Uu))
             => pp(aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),X4),Uua)) ) ) ) ).

% ATP.lambda_207
tff(fact_5930_ATP_Olambda__208,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: multiset(A)] :
      ( pp(aa(multiset(A),bool,aTP_Lamp_qa(set(multiset(A)),fun(multiset(A),bool),Uu),Uua))
    <=> ! [X4: multiset(A)] :
          ( pp(member(multiset(A),X4,Uu))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),Uua),X4)) ) ) ).

% ATP.lambda_208
tff(fact_5931_ATP_Olambda__209,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: multiset(A)] :
      ( pp(aa(multiset(A),bool,aTP_Lamp_qc(set(multiset(A)),fun(multiset(A),bool),Uu),Uua))
    <=> ! [X4: multiset(A)] :
          ( pp(member(multiset(A),X4,Uu))
         => pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),subseteq_mset(A),X4),Uua)) ) ) ).

% ATP.lambda_209
tff(fact_5932_ATP_Olambda__210,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A)] :
      ( pp(aa(set(A),bool,aTP_Lamp_or(set(product_prod(A,A)),fun(set(A),bool),Uu),Uua))
    <=> ! [X4: A] :
          ( pp(member(A,X4,Uua))
         => ! [Xa2: A] :
              ( pp(member(A,Xa2,Uua))
             => ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa2),Uu))
                | pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa2),X4),Uu)) ) ) ) ) ).

% ATP.lambda_210
tff(fact_5933_ATP_Olambda__211,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_ra(set(product_prod(A,B)),fun(A,bool),Uu),Uua))
    <=> ? [Y3: B] : pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Y3),Uu)) ) ).

% ATP.lambda_211
tff(fact_5934_ATP_Olambda__212,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aTP_Lamp_lg(fun(A,assn),fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uu),Uua))
    <=> ? [X4: A] : pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,aa(A,assn,Uu,X4)),Uua)) ) ).

% ATP.lambda_212
tff(fact_5935_ATP_Olambda__213,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aTP_Lamp_mf(A,fun(product_prod(A,B),bool),Uu),Uua))
    <=> ? [V5: B] : ( Uua = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uu),V5) ) ) ).

% ATP.lambda_213
tff(fact_5936_ATP_Olambda__214,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: product_prod(product_prod(bool,A),product_prod(bool,B))] :
      ( pp(aa(product_prod(product_prod(bool,A),product_prod(bool,B)),bool,aTP_Lamp_kv(set(product_prod(A,B)),fun(product_prod(product_prod(bool,A),product_prod(bool,B)),bool),Uu),Uua))
    <=> ? [X4: A,Y3: B] :
          ( ( Uua = aa(product_prod(bool,B),product_prod(product_prod(bool,A),product_prod(bool,B)),aa(product_prod(bool,A),fun(product_prod(bool,B),product_prod(product_prod(bool,A),product_prod(bool,B))),product_Pair(product_prod(bool,A),product_prod(bool,B)),aa(A,product_prod(bool,A),aa(bool,fun(A,product_prod(bool,A)),product_Pair(bool,A),fFalse),X4)),aa(B,product_prod(bool,B),aa(bool,fun(B,product_prod(bool,B)),product_Pair(bool,B),fFalse),Y3)) )
          & pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Y3),Uu)) ) ) ).

% ATP.lambda_214
tff(fact_5937_ATP_Olambda__215,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aTP_Lamp_na(fun(A,option(B)),fun(product_prod(A,B),bool),Uu),Uua))
    <=> ? [A6: A,B6: B] :
          ( ( Uua = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A6),B6) )
          & ( aa(A,option(B),Uu,A6) = aa(B,option(B),some(B),B6) ) ) ) ).

% ATP.lambda_215
tff(fact_5938_ATP_Olambda__216,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: product_prod(set(A),set(A))] :
      ( pp(aa(product_prod(set(A),set(A)),bool,aTP_Lamp_ow(set(product_prod(A,A)),fun(product_prod(set(A),set(A)),bool),Uu),Uua))
    <=> ? [X8: set(A),Y8: set(A)] :
          ( ( Uua = aa(set(A),product_prod(set(A),set(A)),aa(set(A),fun(set(A),product_prod(set(A),set(A))),product_Pair(set(A),set(A)),X8),Y8) )
          & ( X8 != bot_bot(set(A)) )
          & ! [X4: A] :
              ( pp(member(A,X4,Y8))
             => ? [Xa2: A] :
                  ( pp(member(A,Xa2,X8))
                  & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Xa2),X4),Uu)) ) ) ) ) ).

% ATP.lambda_216
tff(fact_5939_ATP_Olambda__217,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool))))),Uua: fun(A,heap_Time_Heap(B))] :
      ( pp(aa(fun(A,heap_Time_Heap(B)),bool,aTP_Lamp_wb(fun(A,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool))))),fun(fun(A,heap_Time_Heap(B)),bool),Uu),Uua))
    <=> ! [X4: A,H3: heap_ext(product_unit),H8: heap_ext(product_unit),R5: B,N5: nat] :
          ( heap_Time_effect(B,aa(A,heap_Time_Heap(B),Uua,X4),H3,H8,R5,N5)
         => pp(aa(nat,bool,aa(B,fun(nat,bool),aa(heap_ext(product_unit),fun(B,fun(nat,bool)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool))),aa(A,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(B,fun(nat,bool)))),Uu,X4),H3),H8),R5),N5)) ) ) ).

% ATP.lambda_217
tff(fact_5940_ATP_Olambda__218,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] : ( aa(A,set(A),aTP_Lamp_jp(set(A),fun(A,set(A)),Uu),Uua) = aa(set(A),set(A),uminus_uminus(set(A)),Uu) ) ).

% ATP.lambda_218
tff(fact_5941_ATP_Olambda__219,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),option(A),aa(A,fun(list(A),option(A)),aTP_Lamp_wr(A,fun(list(A),option(A))),Uu),Uua) = aa(A,option(A),some(A),Uu) ) ).

% ATP.lambda_219
tff(fact_5942_ATP_Olambda__220,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: C] : ( aa(C,set(B),aTP_Lamp_np(set(product_prod(B,B)),fun(C,set(B)),Uu),Uua) = field2(B,Uu) ) ).

% ATP.lambda_220
tff(fact_5943_ATP_Olambda__221,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: A] : ( aa(A,set(B),aTP_Lamp_nt(set(product_prod(B,B)),fun(A,set(B)),Uu),Uua) = field2(B,Uu) ) ).

% ATP.lambda_221
tff(fact_5944_ATP_Olambda__222,axiom,
    ! [C: $tType,A: $tType,Uu: set(product_prod(A,A)),Uua: C] : ( aa(C,set(A),aTP_Lamp_no(set(product_prod(A,A)),fun(C,set(A)),Uu),Uua) = field2(A,Uu) ) ).

% ATP.lambda_222
tff(fact_5945_ATP_Olambda__223,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,A)),Uua: B] : ( aa(B,set(A),aTP_Lamp_ns(set(product_prod(A,A)),fun(B,set(A)),Uu),Uua) = field2(A,Uu) ) ).

% ATP.lambda_223
tff(fact_5946_ATP_Olambda__224,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A] : ( aa(A,set(A),aTP_Lamp_ig(set(product_prod(A,A)),fun(A,set(A)),Uu),Uua) = field2(A,Uu) ) ).

% ATP.lambda_224
tff(fact_5947_ATP_Olambda__225,axiom,
    ! [A: $tType,Uu: A,Uua: list(A)] : ( aa(list(A),fun(set(A),set(A)),aa(A,fun(list(A),fun(set(A),set(A))),aTP_Lamp_su(A,fun(list(A),fun(set(A),set(A)))),Uu),Uua) = insert2(A,Uu) ) ).

% ATP.lambda_225
tff(fact_5948_ATP_Olambda__226,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,bool)),Uua: option(A),Uub: option(B)] :
      ( pp(aa(option(B),bool,aa(option(A),fun(option(B),bool),aTP_Lamp_vj(fun(A,fun(B,bool)),fun(option(A),fun(option(B),bool)),Uu),Uua),Uub))
    <=> pp(case_option(bool,A,case_option(bool,B,fTrue,aTP_Lamp_vh(B,bool),Uub),aa(option(B),fun(A,bool),aTP_Lamp_vi(fun(A,fun(B,bool)),fun(option(B),fun(A,bool)),Uu),Uub),Uua)) ) ).

% ATP.lambda_226
tff(fact_5949_ATP_Olambda__227,axiom,
    ! [Uu: num,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_fp(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less_eq(code_integer),aa(num,code_integer,numeral_numeral(code_integer),Uu)),Uub),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uub),aa(num,code_integer,numeral_numeral(code_integer),Uu))),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_227
tff(fact_5950_ATP_Olambda__228,axiom,
    ! [Uu: num,Uua: nat,Uub: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_fi(num,fun(nat,fun(nat,product_prod(nat,nat))),Uu),Uua),Uub) = if(product_prod(nat,nat),aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Uu)),Uub),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),Uu))),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_228
tff(fact_5951_ATP_Olambda__229,axiom,
    ! [Uu: num,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fk(num,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = if(product_prod(int,int),aa(int,bool,aa(int,fun(int,bool),ord_less_eq(int),aa(num,int,numeral_numeral(int),Uu)),Uub),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uub),aa(num,int,numeral_numeral(int),Uu))),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_229
tff(fact_5952_ATP_Olambda__230,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: num,Uua: A,Uub: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_eq(num,fun(A,fun(A,product_prod(A,A))),Uu),Uua),Uub) = if(product_prod(A,A),aa(A,bool,aa(A,fun(A,bool),ord_less_eq(A),aa(num,A,numeral_numeral(A),Uu)),Uub),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),aa(num,A,numeral_numeral(A),Uu))),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit0,one2))),Uua)),Uub)) ) ) ).

% ATP.lambda_230
tff(fact_5953_ATP_Olambda__231,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] : ( aa(B,A,aa(set(B),fun(B,A),aTP_Lamp_cc(fun(B,A),fun(set(B),fun(B,A)),Uu),Uua),Uub) = if(A,member(B,Uub,Uua),aa(B,A,Uu,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_231
tff(fact_5954_ATP_Olambda__232,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] : ( aa(B,A,aa(set(B),fun(B,A),aTP_Lamp_cd(fun(B,A),fun(set(B),fun(B,A)),Uu),Uua),Uub) = if(A,member(B,Uub,Uua),aa(B,A,Uu,Uub),one_one(A)) ) ) ).

% ATP.lambda_232
tff(fact_5955_ATP_Olambda__233,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_an(B,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uu),Uub),aa(B,A,Uua,Uub),one_one(A)) ) ) ).

% ATP.lambda_233
tff(fact_5956_ATP_Olambda__234,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_am(B,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uub),Uu),aa(B,A,Uua,Uub),one_one(A)) ) ) ).

% ATP.lambda_234
tff(fact_5957_ATP_Olambda__235,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Uu: B,Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_qo(B,fun(A,fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uu),Uub),Uua,zero_zero(A)) ) ) ).

% ATP.lambda_235
tff(fact_5958_ATP_Olambda__236,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_ql(B,fun(A,fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uu),Uub),Uua,one_one(A)) ) ) ).

% ATP.lambda_236
tff(fact_5959_ATP_Olambda__237,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Uu: B,Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_qn(B,fun(A,fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uub),Uu),Uua,zero_zero(A)) ) ) ).

% ATP.lambda_237
tff(fact_5960_ATP_Olambda__238,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_qm(B,fun(A,fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uub),Uu),Uua,one_one(A)) ) ) ).

% ATP.lambda_238
tff(fact_5961_ATP_Olambda__239,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gk(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_239
tff(fact_5962_ATP_Olambda__240,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gi(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_240
tff(fact_5963_ATP_Olambda__241,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gj(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub) = if(product_prod(code_integer,code_integer),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uu),Uub))) ) ).

% ATP.lambda_241
tff(fact_5964_ATP_Olambda__242,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: set(A)] : ( aa(set(A),set(A),aa(A,fun(set(A),set(A)),aTP_Lamp_gc(fun(A,bool),fun(A,fun(set(A),set(A))),Uu),Uua),Uub) = if(set(A),aa(A,bool,Uu,Uua),aa(set(A),set(A),insert2(A,Uua),Uub),Uub) ) ).

% ATP.lambda_242
tff(fact_5965_ATP_Olambda__243,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_by(fun(B,A),fun(fun(B,bool),fun(B,A)),Uu),Uua),Uub) = if(A,aa(B,bool,Uua,Uub),aa(B,A,Uu,Uub),one_one(A)) ) ) ).

% ATP.lambda_243
tff(fact_5966_ATP_Olambda__244,axiom,
    ! [A: $tType,Uu: fun(heap_ext(product_unit),bool),Uua: fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mk(fun(heap_ext(product_unit),bool),fun(fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub) = if(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),bool,Uu,Uub),aa(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),some(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),Uua,Uub)),none(product_prod(A,product_prod(heap_ext(product_unit),nat)))) ) ).

% ATP.lambda_244
tff(fact_5967_ATP_Olambda__245,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: A,Uub: set(product_prod(A,B))] : ( aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(A,fun(set(product_prod(A,B)),set(product_prod(A,B))),aTP_Lamp_ja(set(B),fun(A,fun(set(product_prod(A,B)),set(product_prod(A,B)))),Uu),Uua),Uub) = finite_fold(B,set(product_prod(A,B)),aTP_Lamp_iz(A,fun(B,fun(set(product_prod(A,B)),set(product_prod(A,B)))),Uua),Uub,Uu) ) ).

% ATP.lambda_245
tff(fact_5968_ATP_Olambda__246,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: B,Uub: set(product_prod(B,A))] : ( aa(set(product_prod(B,A)),set(product_prod(B,A)),aa(B,fun(set(product_prod(B,A)),set(product_prod(B,A))),aTP_Lamp_gg(set(A),fun(B,fun(set(product_prod(B,A)),set(product_prod(B,A)))),Uu),Uua),Uub) = finite_fold(A,set(product_prod(B,A)),aTP_Lamp_gf(B,fun(A,fun(set(product_prod(B,A)),set(product_prod(B,A)))),Uua),Uub,Uu) ) ).

% ATP.lambda_246
tff(fact_5969_ATP_Olambda__247,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: list(A),Uub: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),aTP_Lamp_rv(fun(A,fun(A,bool)),fun(list(A),fun(list(A),list(A))),Uu),Uua),Uub) = merges9089515139780605204_merge(A,Uu,mergesort_by_rel(A,Uu,Uua),mergesort_by_rel(A,Uu,Uub)) ) ).

% ATP.lambda_247
tff(fact_5970_ATP_Olambda__248,axiom,
    ! [A: $tType] :
      ( sup(A)
     => ! [Uu: option(A),Uua: option(A),Uub: A] : ( aa(A,option(A),aa(option(A),fun(A,option(A)),aTP_Lamp_mr(option(A),fun(option(A),fun(A,option(A))),Uu),Uua),Uub) = case_option(option(A),A,Uu,aTP_Lamp_mq(A,fun(A,option(A)),Uub),Uua) ) ) ).

% ATP.lambda_248
tff(fact_5971_ATP_Olambda__249,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,bool)),Uua: option(B),Uub: A] :
      ( pp(aa(A,bool,aa(option(B),fun(A,bool),aTP_Lamp_vi(fun(A,fun(B,bool)),fun(option(B),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(case_option(bool,B,fFalse,aa(A,fun(B,bool),Uu,Uub),Uua)) ) ).

% ATP.lambda_249
tff(fact_5972_ATP_Olambda__250,axiom,
    ! [B: $tType,A: $tType,Uu: heap_Time_Heap(A),Uua: fun(A,heap_Time_Heap(B)),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(A,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mp(heap_Time_Heap(A),fun(fun(A,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub) = case_option(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(A,product_prod(heap_ext(product_unit),nat)),none(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(A,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(A,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),product_case_prod(A,product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mo(fun(A,heap_Time_Heap(B)),fun(A,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uua)),aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),Uu),Uub)) ) ).

% ATP.lambda_250
tff(fact_5973_ATP_Olambda__251,axiom,
    ! [A: $tType,B: $tType,Uu: fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),Uua: B,Uub: fun(B,heap_Time_Heap(A))] : ( aa(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aTP_Lamp_vy(fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),Uu),Uua),Uub) = aa(B,heap_Time_Heap(A),aa(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)),Uu,Uub),Uua) ) ).

% ATP.lambda_251
tff(fact_5974_ATP_Olambda__252,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,Uu: fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),Uua: fun(A,heap_Time_Heap(B)),Uub: C] : ( aa(C,heap_Time_Heap(D),aa(fun(A,heap_Time_Heap(B)),fun(C,heap_Time_Heap(D)),aTP_Lamp_vz(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),fun(C,heap_Time_Heap(D))),Uu),Uua),Uub) = aa(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D),aa(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D)),Uu,Uub),Uua) ) ).

% ATP.lambda_252
tff(fact_5975_ATP_Olambda__253,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(B,assn)),Uua: B,Uub: A] : ( aa(A,assn,aa(B,fun(A,assn),aTP_Lamp_la(fun(A,fun(B,assn)),fun(B,fun(A,assn)),Uu),Uua),Uub) = aa(B,assn,aa(A,fun(B,assn),Uu,Uub),Uua) ) ).

% ATP.lambda_253
tff(fact_5976_ATP_Olambda__254,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_tw(fun(A,fun(A,bool)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(A,bool,aa(A,fun(A,bool),Uu,Uub),Uua)) ) ).

% ATP.lambda_254
tff(fact_5977_ATP_Olambda__255,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] : ( aa(code_integer,product_prod(code_integer,bool),aa(code_integer,fun(code_integer,product_prod(code_integer,bool)),aTP_Lamp_gh(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,bool))),Uu),Uua),Uub) = aa(bool,product_prod(code_integer,bool),aa(code_integer,fun(bool,product_prod(code_integer,bool)),product_Pair(code_integer,bool),if(code_integer,aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),ord_less(code_integer),zero_zero(code_integer)),Uu),Uua,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),Uub))),aa(code_integer,bool,aa(code_integer,fun(code_integer,bool),fequal(code_integer),Uub),one_one(code_integer))) ) ).

% ATP.lambda_255
tff(fact_5978_ATP_Olambda__256,axiom,
    ! [Uu: product_prod(code_natural,code_natural),Uua: code_natural,Uub: code_natural] : ( aa(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aTP_Lamp_uc(product_prod(code_natural,code_natural),fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),Uu),Uua),Uub) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_case_prod(code_natural,code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aa(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),aTP_Lamp_ub(code_natural,fun(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))))),Uua),Uub)),aa(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(code_natural,code_natural),product_snd(code_natural,product_prod(code_natural,code_natural)),aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,Uu))) ) ).

% ATP.lambda_256
tff(fact_5979_ATP_Olambda__257,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uua: pred(A),Uub: product_prod(code_natural,code_natural)] : ( aa(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aTP_Lamp_ut(fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uu),Uua),Uub) = aa(product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural))),product_case_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aa(pred(A),fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),aTP_Lamp_us(fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(pred(A),fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))))),Uu),Uua)),split_seed(Uub)) ) ).

% ATP.lambda_257
tff(fact_5980_ATP_Olambda__258,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fh(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fg(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_258
tff(fact_5981_ATP_Olambda__259,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fe(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fd(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_259
tff(fact_5982_ATP_Olambda__260,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fc(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fb(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_260
tff(fact_5983_ATP_Olambda__261,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fa(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_ez(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_261
tff(fact_5984_ATP_Olambda__262,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: nat,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(nat,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rk(array(A),fun(nat,fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),nth(A,array_get(A,Uub,Uu),Uua)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),one_one(nat))) ) ) ).

% ATP.lambda_262
tff(fact_5985_ATP_Olambda__263,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ay(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_263
tff(fact_5986_ATP_Olambda__264,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_si(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),size_size(list(A),Uua)),size_size(list(A),Uub)))
        | ( ( size_size(list(A),Uua) = size_size(list(A),Uub) )
          & pp(member(product_prod(list(A),list(A)),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Uua),Uub),lex(A,Uu))) ) ) ) ).

% ATP.lambda_264
tff(fact_5987_ATP_Olambda__265,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_rz(nat,fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( size_size(list(A),Uua) = aa(nat,nat,suc,Uu) )
        & ( size_size(list(A),Uub) = aa(nat,nat,suc,Uu) ) ) ) ).

% ATP.lambda_265
tff(fact_5988_ATP_Olambda__266,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_sh(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ( ( size_size(list(A),Uua) = size_size(list(A),Uub) )
        & ? [Xys2: list(A),X4: A,Y3: A,Xs6: list(A),Ys5: list(A)] :
            ( ( Uua = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X4),Xs6)) )
            & ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y3),Ys5)) )
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Y3),Uu)) ) ) ) ).

% ATP.lambda_266
tff(fact_5989_ATP_Olambda__267,axiom,
    ! [Uu: heap_ext(product_unit),Uua: heap_ext(product_unit),Uub: nat] :
      ( pp(aa(nat,bool,aa(heap_ext(product_unit),fun(nat,bool),aTP_Lamp_ls(heap_ext(product_unit),fun(heap_ext(product_unit),fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),lim(product_unit,Uu)),Uub))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),lim(product_unit,Uua))) ) ) ).

% ATP.lambda_267
tff(fact_5990_ATP_Olambda__268,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: fun(A,A),Uua: ref(A),Uub: A] : ( aa(A,heap_Time_Heap(A),aa(ref(A),fun(A,heap_Time_Heap(A)),aTP_Lamp_hh(fun(A,A),fun(ref(A),fun(A,heap_Time_Heap(A))),Uu),Uua),Uub) = heap_Time_bind(product_unit,A,ref_update(A,Uua,aa(A,A,Uu,Uub)),aa(A,fun(product_unit,heap_Time_Heap(A)),aTP_Lamp_hg(fun(A,A),fun(A,fun(product_unit,heap_Time_Heap(A))),Uu),Uub)) ) ) ).

% ATP.lambda_268
tff(fact_5991_ATP_Olambda__269,axiom,
    ! [Uu: heap_ext(product_unit),Uua: set(nat),Uub: nat] :
      ( pp(aa(nat,bool,aa(set(nat),fun(nat,bool),aTP_Lamp_mc(heap_ext(product_unit),fun(set(nat),fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),lim(product_unit,Uu)))
        & ~ pp(member(nat,Uub,Uua)) ) ) ).

% ATP.lambda_269
tff(fact_5992_ATP_Olambda__270,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_ou(set(product_prod(A,A)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(member(A,Uub,field2(A,Uu)))
        & ! [X4: A] :
            ( pp(member(A,X4,Uua))
           => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),X4),Uu)) ) ) ) ).

% ATP.lambda_270
tff(fact_5993_ATP_Olambda__271,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_ov(set(product_prod(A,A)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(member(A,Uub,field2(A,Uu)))
        & ! [X4: A] :
            ( pp(member(A,X4,Uua))
           => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Uub),Uu)) ) ) ) ).

% ATP.lambda_271
tff(fact_5994_ATP_Olambda__272,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_ot(set(product_prod(A,A)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(member(A,Uub,field2(A,Uu)))
        & ! [X4: A] :
            ( pp(member(A,X4,Uua))
           => ( ( Uub != X4 )
              & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),X4),Uu)) ) ) ) ) ).

% ATP.lambda_272
tff(fact_5995_ATP_Olambda__273,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_pa(set(product_prod(A,A)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(member(A,Uub,field2(A,Uu)))
        & ! [X4: A] :
            ( pp(member(A,X4,Uua))
           => ( ( Uub != X4 )
              & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Uub),Uu)) ) ) ) ) ).

% ATP.lambda_273
tff(fact_5996_ATP_Olambda__274,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( pp(aa(nat,bool,aa(nat,fun(nat,bool),aTP_Lamp_ny(nat,fun(nat,fun(nat,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uua),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uub),Uu))
        & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),Uua),Uub)) ) ) ).

% ATP.lambda_274
tff(fact_5997_ATP_Olambda__275,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(A,A)),Uub: fun(B,A)] : ( aa(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))),aTP_Lamp_jd(set(product_prod(A,A)),fun(set(product_prod(A,A)),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))))),Uu),Uua),Uub) = aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),inv_image(A,B,Uu,Uub)),inv_image(A,B,Uua,Uub)) ) ).

% ATP.lambda_275
tff(fact_5998_ATP_Olambda__276,axiom,
    ! [Uu: assn,Uua: assn,Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_ca(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Uu),Uub))
        | pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Uua),Uub)) ) ) ).

% ATP.lambda_276
tff(fact_5999_ATP_Olambda__277,axiom,
    ! [Uu: assn,Uua: assn,Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_cb(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Uu),Uub))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),bool),rep_assn,Uua),Uub)) ) ) ).

% ATP.lambda_277
tff(fact_6000_ATP_Olambda__278,axiom,
    ! [A: $tType,Uu: set(A),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_os(set(A),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(member(A,Uua,Uu))
        & pp(member(A,Uub,Uu)) ) ) ).

% ATP.lambda_278
tff(fact_6001_ATP_Olambda__279,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_bl(set(A),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(member(A,Uub,Uu))
        & pp(member(A,Uub,Uua)) ) ) ).

% ATP.lambda_279
tff(fact_6002_ATP_Olambda__280,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_uj(fun(A,bool),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(member(A,Uub,Uua))
       => pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_280
tff(fact_6003_ATP_Olambda__281,axiom,
    ! [B: $tType,Uu: set(B),Uua: fun(B,bool),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,bool),fun(B,bool),aTP_Lamp_bx(set(B),fun(fun(B,bool),fun(B,bool)),Uu),Uua),Uub))
    <=> ( pp(member(B,Uub,Uu))
        & pp(aa(B,bool,Uua,Uub)) ) ) ).

% ATP.lambda_281
tff(fact_6004_ATP_Olambda__282,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_bg(fun(A,bool),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uua = Uub )
        & pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_282
tff(fact_6005_ATP_Olambda__283,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_bh(fun(A,bool),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uub = Uua )
        & pp(aa(A,bool,Uu,Uub)) ) ) ).

% ATP.lambda_283
tff(fact_6006_ATP_Olambda__284,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,set(B)),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,set(B)),fun(A,bool),aTP_Lamp_iq(set(A),fun(fun(A,set(B)),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(member(A,Uub,Uu))
        & ( aa(A,set(B),Uua,Uub) != bot_bot(set(B)) ) ) ) ).

% ATP.lambda_284
tff(fact_6007_ATP_Olambda__285,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_fo(set(A),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
        <=> ( pp(member(A,Uub,Uu))
            & ( aa(A,B,Uua,Uub) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_285
tff(fact_6008_ATP_Olambda__286,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aTP_Lamp_bt(set(B),fun(fun(B,A),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(member(B,Uub,Uu))
            & ( aa(B,A,Uua,Uub) != one_one(A) ) ) ) ) ).

% ATP.lambda_286
tff(fact_6009_ATP_Olambda__287,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] :
          ( pp(aa(B,bool,aa(set(B),fun(B,bool),aTP_Lamp_hy(fun(B,A),fun(set(B),fun(B,bool)),Uu),Uua),Uub))
        <=> ( pp(member(B,Uub,Uua))
            & ( aa(B,A,Uu,Uub) != one_one(A) ) ) ) ) ).

% ATP.lambda_287
tff(fact_6010_ATP_Olambda__288,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: list(A),Uub: nat] : ( aa(nat,assn,aa(list(A),fun(nat,assn),aTP_Lamp_ri(array(A),fun(list(A),fun(nat,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(A,Uu,Uua)),pure_assn(aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uub),size_size(list(A),Uua)))) ) ) ).

% ATP.lambda_288
tff(fact_6011_ATP_Olambda__289,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: ref(A),Uua: A,Uub: A] : ( aa(A,assn,aa(A,fun(A,assn),aTP_Lamp_ep(ref(A),fun(A,fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),sngr_assn(A,Uu,Uua)),pure_assn(aa(A,bool,aa(A,fun(A,bool),fequal(A),Uub),Uua))) ) ) ).

% ATP.lambda_289
tff(fact_6012_ATP_Olambda__290,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: list(A),Uub: list(A)] : ( aa(list(A),assn,aa(list(A),fun(list(A),assn),aTP_Lamp_fl(array(A),fun(list(A),fun(list(A),assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(A,Uu,Uua)),pure_assn(aa(list(A),bool,aa(list(A),fun(list(A),bool),fequal(list(A)),Uub),Uua))) ) ) ).

% ATP.lambda_290
tff(fact_6013_ATP_Olambda__291,axiom,
    ! [A: $tType,D: $tType,C: $tType,Uu: fun(C,fun(D,bool)),Uua: fun(C,A),Uub: set(A)] : ( aa(set(A),set(C),aa(fun(C,A),fun(set(A),set(C)),aTP_Lamp_wz(fun(C,fun(D,bool)),fun(fun(C,A),fun(set(A),set(C))),Uu),Uua),Uub) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(A),set(C),aa(fun(C,A),fun(set(A),set(C)),vimage(C,A),Uua),Uub)),aa(fun(C,bool),set(C),collect(C),domainp(C,D,Uu))) ) ).

% ATP.lambda_291
tff(fact_6014_ATP_Olambda__292,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_dk(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,Uub,Uu)),Uua) ) ) ).

% ATP.lambda_292
tff(fact_6015_ATP_Olambda__293,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_di(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_293
tff(fact_6016_ATP_Olambda__294,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_dj(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,Uub,Uu)),Uua) ) ) ).

% ATP.lambda_294
tff(fact_6017_ATP_Olambda__295,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_dh(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_295
tff(fact_6018_ATP_Olambda__296,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: B,Uub: C] :
      ( pp(aa(C,bool,aa(B,fun(C,bool),aTP_Lamp_ph(set(product_prod(B,C)),fun(B,fun(C,bool)),Uu),Uua),Uub))
    <=> pp(member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uub),Uu)) ) ).

% ATP.lambda_296
tff(fact_6019_ATP_Olambda__297,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,A)),Uua: B,Uub: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_lm(set(product_prod(B,A)),fun(B,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uua),Uub),Uu)) ) ).

% ATP.lambda_297
tff(fact_6020_ATP_Olambda__298,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(product_prod(A,B)),fun(A,fun(B,bool)),aTP_Lamp_be(set(product_prod(A,B)),fun(A,fun(B,bool))),Uu),Uua),Uub))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uub),Uu)) ) ).

% ATP.lambda_298
tff(fact_6021_ATP_Olambda__299,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_el(set(product_prod(A,A)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uub),Uu)) ) ).

% ATP.lambda_299
tff(fact_6022_ATP_Olambda__300,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,A)),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_pi(set(product_prod(B,A)),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> pp(member(product_prod(B,A),aa(A,product_prod(B,A),aa(B,fun(A,product_prod(B,A)),product_Pair(B,A),Uub),Uua),Uu)) ) ).

% ATP.lambda_300
tff(fact_6023_ATP_Olambda__301,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_nm(set(product_prod(A,A)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uua),Uu)) ) ).

% ATP.lambda_301
tff(fact_6024_ATP_Olambda__302,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,Uu: fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C)),Uua: fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),Uub: fun(A,heap_Time_Heap(B))] : ( aa(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D),aa(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D)),aTP_Lamp_wa(fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C)),fun(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),Uu),Uua),Uub) = heap_Time_bind(C,D,aa(fun(A,heap_Time_Heap(B)),heap_Time_Heap(C),Uu,Uub),aa(fun(A,heap_Time_Heap(B)),fun(C,heap_Time_Heap(D)),aTP_Lamp_vz(fun(C,fun(fun(A,heap_Time_Heap(B)),heap_Time_Heap(D))),fun(fun(A,heap_Time_Heap(B)),fun(C,heap_Time_Heap(D))),Uua),Uub)) ) ).

% ATP.lambda_302
tff(fact_6025_ATP_Olambda__303,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_bb(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_303
tff(fact_6026_ATP_Olambda__304,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_dl(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_304
tff(fact_6027_ATP_Olambda__305,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ly(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_305
tff(fact_6028_ATP_Olambda__306,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ie(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_306
tff(fact_6029_ATP_Olambda__307,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_lx(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_307
tff(fact_6030_ATP_Olambda__308,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: fun(A,assn),Uub: A] : ( aa(A,assn,aa(fun(A,assn),fun(A,assn),aTP_Lamp_ld(fun(A,assn),fun(fun(A,assn),fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(A,assn,Uu,Uub)),aa(A,assn,Uua,Uub)) ) ).

% ATP.lambda_308
tff(fact_6031_ATP_Olambda__309,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_km(fun(B,set(A)),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(B,set(A),Uu,Uub)),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_309
tff(fact_6032_ATP_Olambda__310,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ne(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_310
tff(fact_6033_ATP_Olambda__311,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_kf(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_311
tff(fact_6034_ATP_Olambda__312,axiom,
    ! [A: $tType,B: $tType] :
      ( lattice(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_nd(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_312
tff(fact_6035_ATP_Olambda__313,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: fun(A,set(B)),Uub: A] : ( aa(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_ih(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),Uu,Uub)),aa(A,set(B),Uua,Uub)) ) ).

% ATP.lambda_313
tff(fact_6036_ATP_Olambda__314,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,multiset(A)),Uua: fun(B,multiset(A)),Uub: B] : ( aa(B,multiset(A),aa(fun(B,multiset(A)),fun(B,multiset(A)),aTP_Lamp_qd(fun(B,multiset(A)),fun(fun(B,multiset(A)),fun(B,multiset(A))),Uu),Uua),Uub) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),aa(B,multiset(A),Uu,Uub)),aa(B,multiset(A),Uua,Uub)) ) ).

% ATP.lambda_314
tff(fact_6037_ATP_Olambda__315,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,multiset(A)),Uua: fun(B,multiset(A)),Uub: B] : ( aa(B,multiset(A),aa(fun(B,multiset(A)),fun(B,multiset(A)),aTP_Lamp_qb(fun(B,multiset(A)),fun(fun(B,multiset(A)),fun(B,multiset(A))),Uu),Uua),Uub) = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),aa(B,multiset(A),Uu,Uub)),aa(B,multiset(A),Uua,Uub)) ) ).

% ATP.lambda_315
tff(fact_6038_ATP_Olambda__316,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,A),Uua: fun(C,B),Uub: C] : ( aa(C,product_prod(A,B),aa(fun(C,B),fun(C,product_prod(A,B)),aTP_Lamp_jj(fun(C,A),fun(fun(C,B),fun(C,product_prod(A,B))),Uu),Uua),Uub) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,Uu,Uub)),aa(C,B,Uua,Uub)) ) ).

% ATP.lambda_316
tff(fact_6039_ATP_Olambda__317,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,C),Uub: A] : ( aa(A,product_prod(B,C),aa(fun(A,C),fun(A,product_prod(B,C)),aTP_Lamp_un(fun(A,B),fun(fun(A,C),fun(A,product_prod(B,C))),Uu),Uua),Uub) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(A,B,Uu,Uub)),aa(A,C,Uua,Uub)) ) ).

% ATP.lambda_317
tff(fact_6040_ATP_Olambda__318,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uua: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_ag(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Uu,Uub))
        | pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Uua,Uub)) ) ) ).

% ATP.lambda_318
tff(fact_6041_ATP_Olambda__319,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uua: fun(product_prod(heap_ext(product_unit),set(nat)),bool),Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aa(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool),aTP_Lamp_ah(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(fun(product_prod(heap_ext(product_unit),set(nat)),bool),fun(product_prod(heap_ext(product_unit),set(nat)),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Uu,Uub))
        & pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,Uua,Uub)) ) ) ).

% ATP.lambda_319
tff(fact_6042_ATP_Olambda__320,axiom,
    ! [B: $tType,Uu: fun(B,bool),Uua: fun(B,bool),Uub: B] :
      ( pp(aa(B,bool,aa(fun(B,bool),fun(B,bool),aTP_Lamp_ox(fun(B,bool),fun(fun(B,bool),fun(B,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(B,bool,Uu,Uub))
        & pp(aa(B,bool,Uua,Uub)) ) ) ).

% ATP.lambda_320
tff(fact_6043_ATP_Olambda__321,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_bm(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uu,Uub))
        & pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_321
tff(fact_6044_ATP_Olambda__322,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,B),fun(A,bool),aTP_Lamp_rf(fun(A,B),fun(fun(A,B),fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(A,B,Uu,Uub) = aa(A,B,Uua,Uub) ) ) ).

% ATP.lambda_322
tff(fact_6045_ATP_Olambda__323,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,A),Uua: fun(B,bool),Uub: B] : ( aa(B,A,aa(fun(B,bool),fun(B,A),aTP_Lamp_av(fun(B,A),fun(fun(B,bool),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(bool,A,zero_neq_one_of_bool(A),aa(B,bool,Uua,Uub))) ) ) ).

% ATP.lambda_323
tff(fact_6046_ATP_Olambda__324,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_pd(fun(A,fun(A,bool)),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( pp(aa(A,bool,Uua,Uub))
        & ! [Y3: A] :
            ( pp(aa(A,bool,Uua,Y3))
           => pp(aa(A,bool,aa(A,fun(A,bool),Uu,Uub),Y3)) ) ) ) ).

% ATP.lambda_324
tff(fact_6047_ATP_Olambda__325,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: fun(A,assn),Uub: A] : ( aa(A,assn,aa(fun(A,assn),fun(A,assn),aTP_Lamp_lc(fun(A,assn),fun(fun(A,assn),fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(A,assn,Uu,Uub)),ex_assn(A,Uua)) ) ).

% ATP.lambda_325
tff(fact_6048_ATP_Olambda__326,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_cz(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = divide_divide(A,aa(B,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_326
tff(fact_6049_ATP_Olambda__327,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_tn(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,Uu,Uub)),Uua)) ) ) ).

% ATP.lambda_327
tff(fact_6050_ATP_Olambda__328,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_bc(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_328
tff(fact_6051_ATP_Olambda__329,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: assn,Uub: A] : ( aa(A,assn,aa(assn,fun(A,assn),aTP_Lamp_bs(fun(A,assn),fun(assn,fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(A,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_329
tff(fact_6052_ATP_Olambda__330,axiom,
    ! [E: $tType,F8: $tType,Uu: fun(E,set(F8)),Uua: set(F8),Uub: E] : ( aa(E,set(F8),aa(set(F8),fun(E,set(F8)),aTP_Lamp_kc(fun(E,set(F8)),fun(set(F8),fun(E,set(F8))),Uu),Uua),Uub) = aa(set(F8),set(F8),aa(set(F8),fun(set(F8),set(F8)),minus_minus(set(F8)),aa(E,set(F8),Uu,Uub)),Uua) ) ).

% ATP.lambda_330
tff(fact_6053_ATP_Olambda__331,axiom,
    ! [C: $tType,D: $tType,Uu: fun(C,set(D)),Uua: set(D),Uub: C] : ( aa(C,set(D),aa(set(D),fun(C,set(D)),aTP_Lamp_ht(fun(C,set(D)),fun(set(D),fun(C,set(D))),Uu),Uua),Uub) = aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),sup_sup(set(D)),aa(C,set(D),Uu,Uub)),Uua) ) ).

% ATP.lambda_331
tff(fact_6054_ATP_Olambda__332,axiom,
    ! [B: $tType,A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_kg(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_332
tff(fact_6055_ATP_Olambda__333,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: assn,Uub: A] : ( aa(A,assn,aa(assn,fun(A,assn),aTP_Lamp_le(fun(A,assn),fun(assn,fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(A,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_333
tff(fact_6056_ATP_Olambda__334,axiom,
    ! [G2: $tType,H9: $tType,Uu: fun(G2,set(H9)),Uua: set(H9),Uub: G2] : ( aa(G2,set(H9),aa(set(H9),fun(G2,set(H9)),aTP_Lamp_in(fun(G2,set(H9)),fun(set(H9),fun(G2,set(H9))),Uu),Uua),Uub) = aa(set(H9),set(H9),aa(set(H9),fun(set(H9),set(H9)),inf_inf(set(H9)),aa(G2,set(H9),Uu,Uub)),Uua) ) ).

% ATP.lambda_334
tff(fact_6057_ATP_Olambda__335,axiom,
    ! [B: $tType,A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_hz(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_335
tff(fact_6058_ATP_Olambda__336,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_kn(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_336
tff(fact_6059_ATP_Olambda__337,axiom,
    ! [A: $tType,Uu: fun(A,assn),Uua: assn,Uub: A] : ( aa(A,assn,aa(assn,fun(A,assn),aTP_Lamp_lf(fun(A,assn),fun(assn,fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(A,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_337
tff(fact_6060_ATP_Olambda__338,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,set(B)),Uua: set(B),Uub: A] : ( aa(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_kb(fun(A,set(B)),fun(set(B),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(A,set(B),Uu,Uub)),Uua) ) ).

% ATP.lambda_338
tff(fact_6061_ATP_Olambda__339,axiom,
    ! [B: $tType,A: $tType] :
      ( linord4140545234300271783up_add(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_lk(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_339
tff(fact_6062_ATP_Olambda__340,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,heap_Time_Heap(C)),Uua: fun(C,heap_Time_Heap(B)),Uub: A] : ( aa(A,heap_Time_Heap(B),aa(fun(C,heap_Time_Heap(B)),fun(A,heap_Time_Heap(B)),aTP_Lamp_ae(fun(A,heap_Time_Heap(C)),fun(fun(C,heap_Time_Heap(B)),fun(A,heap_Time_Heap(B))),Uu),Uua),Uub) = heap_Time_bind(C,B,aa(A,heap_Time_Heap(C),Uu,Uub),Uua) ) ).

% ATP.lambda_340
tff(fact_6063_ATP_Olambda__341,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(A,filter(B)),Uua: filter(C),Uub: A] : ( aa(A,filter(product_prod(B,C)),aa(filter(C),fun(A,filter(product_prod(B,C))),aTP_Lamp_qw(fun(A,filter(B)),fun(filter(C),fun(A,filter(product_prod(B,C)))),Uu),Uua),Uub) = prod_filter(B,C,aa(A,filter(B),Uu,Uub),Uua) ) ).

% ATP.lambda_341
tff(fact_6064_ATP_Olambda__342,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_to(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> ( aa(B,A,Uu,Uub) = Uua ) ) ) ).

% ATP.lambda_342
tff(fact_6065_ATP_Olambda__343,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: B,Uub: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_jr(fun(A,B),fun(B,fun(A,bool)),Uu),Uua),Uub))
    <=> ( aa(A,B,Uu,Uub) = Uua ) ) ).

% ATP.lambda_343
tff(fact_6066_ATP_Olambda__344,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(nat,A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_tq(nat,fun(fun(nat,A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rw(nat,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(A,aa(list(nat),list(A),map(nat,A,Uua),upt(zero_zero(nat),Uu)),Uub)) ) ) ).

% ATP.lambda_344
tff(fact_6067_ATP_Olambda__345,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: A,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(A,fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_ry(nat,fun(A,fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(A),heap_ext(product_unit)),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(A),heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rw(nat,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(A,replicate(A,Uu,Uua),Uub)) ) ) ).

% ATP.lambda_345
tff(fact_6068_ATP_Olambda__346,axiom,
    ! [A: $tType,Uu: fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),Uua: pred(A),Uub: product_prod(code_natural,code_natural)] : ( aa(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)),aa(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),aTP_Lamp_uq(fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),fun(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))),Uu),Uua),Uub) = aa(product_prod(pred(A),product_prod(code_natural,code_natural)),product_prod(pred(A),product_prod(code_natural,code_natural)),aa(fun(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))),fun(product_prod(pred(A),product_prod(code_natural,code_natural)),product_prod(pred(A),product_prod(code_natural,code_natural))),product_case_prod(pred(A),product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))),aTP_Lamp_up(pred(A),fun(pred(A),fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))),Uua)),aa(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)),Uu,Uub)) ) ).

% ATP.lambda_346
tff(fact_6069_ATP_Olambda__347,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_po(set(product_prod(A,A)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uub != Uua )
        & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uub),Uu)) ) ) ).

% ATP.lambda_347
tff(fact_6070_ATP_Olambda__348,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ng(set(product_prod(A,A)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ( ( Uub != Uua )
        & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uua),Uu)) ) ) ).

% ATP.lambda_348
tff(fact_6071_ATP_Olambda__349,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,bool),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_au(fun(B,bool),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(bool,A,zero_neq_one_of_bool(A),aa(B,bool,Uu,Uub))),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_349
tff(fact_6072_ATP_Olambda__350,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: fun(A,bool),Uub: A] :
      ( pp(aa(A,bool,aa(fun(A,bool),fun(A,bool),aTP_Lamp_xh(fun(A,bool),fun(fun(A,bool),fun(A,bool)),Uu),Uua),Uub))
    <=> ( ~ pp(aa(A,bool,Uu,Uub))
        | pp(aa(A,bool,Uua,Uub)) ) ) ).

% ATP.lambda_350
tff(fact_6073_ATP_Olambda__351,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: set(A)] :
      ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),aTP_Lamp_oz(set(product_prod(A,A)),fun(set(A),fun(set(A),bool)),Uu),Uua),Uub))
    <=> ( pp(aa(set(A),bool,finite_finite(A),Uua))
        & pp(aa(set(A),bool,finite_finite(A),Uub))
        & ( Uub != bot_bot(set(A)) )
        & ! [X4: A] :
            ( pp(member(A,X4,Uua))
           => ? [Xa2: A] :
                ( pp(member(A,Xa2,Uub))
                & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Xa2),Uu)) ) ) ) ) ).

% ATP.lambda_351
tff(fact_6074_ATP_Olambda__352,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] : ( aa(A,set(A),aa(A,fun(A,set(A)),aTP_Lamp_pj(set(product_prod(A,A)),fun(A,fun(A,set(A))),Uu),Uua),Uub) = image(A,A,converse(A,A,Uu),aa(set(A),set(A),insert2(A,Uua),bot_bot(set(A)))) ) ).

% ATP.lambda_352
tff(fact_6075_ATP_Olambda__353,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ei(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_353
tff(fact_6076_ATP_Olambda__354,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ef(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_354
tff(fact_6077_ATP_Olambda__355,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: array(A),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rw(nat,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_Pair(array(A),product_prod(heap_ext(product_unit),nat)),Uua),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),one_one(nat)))) ) ) ).

% ATP.lambda_355
tff(fact_6078_ATP_Olambda__356,axiom,
    ! [A: $tType,Uu: set(A),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_lt(set(A),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(member(A,Uub,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uu),aa(set(A),set(A),insert2(A,Uua),bot_bot(set(A)))))) ) ).

% ATP.lambda_356
tff(fact_6079_ATP_Olambda__357,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: list(A),Uua: array(A),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rq(list(A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_Pair(array(A),product_prod(heap_ext(product_unit),nat)),Uua),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),size_size(list(A),Uu)))) ) ) ).

% ATP.lambda_357
tff(fact_6080_ATP_Olambda__358,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: array(A)] : ( aa(array(A),assn,aa(fun(nat,A),fun(array(A),assn),aTP_Lamp_th(nat,fun(fun(nat,A),fun(array(A),assn)),Uu),Uua),Uub) = snga_assn(A,Uub,aa(list(nat),list(A),map(nat,A,Uua),upt(zero_zero(nat),Uu))) ) ) ).

% ATP.lambda_358
tff(fact_6081_ATP_Olambda__359,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_du(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_359
tff(fact_6082_ATP_Olambda__360,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_oa(fun(A,option(B)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(member(A,Uub,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uua),dom(A,B,Uu)))) ) ).

% ATP.lambda_360
tff(fact_6083_ATP_Olambda__361,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,option(B)),Uua: set(A),Uub: A] :
      ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_ob(fun(A,option(B)),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
    <=> pp(member(A,Uub,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uua),dom(A,B,Uu)))) ) ).

% ATP.lambda_361
tff(fact_6084_ATP_Olambda__362,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: array(A),Uub: heap_ext(product_unit)] :
          ( pp(aa(heap_ext(product_unit),bool,aa(array(A),fun(heap_ext(product_unit),bool),aTP_Lamp_rm(nat,fun(array(A),fun(heap_ext(product_unit),bool)),Uu),Uua),Uub))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uu),array_length(A,Uub,Uua))) ) ) ).

% ATP.lambda_362
tff(fact_6085_ATP_Olambda__363,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: array(A),Uua: nat,Uub: heap_ext(product_unit)] :
          ( pp(aa(heap_ext(product_unit),bool,aa(nat,fun(heap_ext(product_unit),bool),aTP_Lamp_rj(array(A),fun(nat,fun(heap_ext(product_unit),bool)),Uu),Uua),Uub))
        <=> pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uua),array_length(A,Uub,Uu))) ) ) ).

% ATP.lambda_363
tff(fact_6086_ATP_Olambda__364,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_cf(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_364
tff(fact_6087_ATP_Olambda__365,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: A,Uub: array(A)] : ( aa(array(A),assn,aa(A,fun(array(A),assn),aTP_Lamp_rx(nat,fun(A,fun(array(A),assn)),Uu),Uua),Uub) = snga_assn(A,Uub,replicate(A,Uu,Uua)) ) ) ).

% ATP.lambda_365
tff(fact_6088_ATP_Olambda__366,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: A,Uua: B,Uub: C] : ( aa(C,product_prod(A,product_prod(B,C)),aa(B,fun(C,product_prod(A,product_prod(B,C))),aa(A,fun(B,fun(C,product_prod(A,product_prod(B,C)))),aTP_Lamp_tc(A,fun(B,fun(C,product_prod(A,product_prod(B,C))))),Uu),Uua),Uub) = aa(product_prod(B,C),product_prod(A,product_prod(B,C)),aa(A,fun(product_prod(B,C),product_prod(A,product_prod(B,C))),product_Pair(A,product_prod(B,C)),Uu),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uub)) ) ).

% ATP.lambda_366
tff(fact_6089_ATP_Olambda__367,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: B,Uua: A,Uub: C] : ( aa(C,product_prod(A,product_prod(B,C)),aa(A,fun(C,product_prod(A,product_prod(B,C))),aTP_Lamp_sv(B,fun(A,fun(C,product_prod(A,product_prod(B,C)))),Uu),Uua),Uub) = aa(product_prod(B,C),product_prod(A,product_prod(B,C)),aa(A,fun(product_prod(B,C),product_prod(A,product_prod(B,C))),product_Pair(A,product_prod(B,C)),Uua),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),Uub)) ) ).

% ATP.lambda_367
tff(fact_6090_ATP_Olambda__368,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,A),Uub: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aTP_Lamp_iy(fun(B,set(C)),fun(fun(C,A),fun(B,A)),Uu),Uua),Uub) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7121269368397514597t_prod(C,A),Uua),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_368
tff(fact_6091_ATP_Olambda__369,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,A),Uub: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aTP_Lamp_ix(fun(B,set(C)),fun(fun(C,A),fun(B,A)),Uu),Uua),Uub) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),Uua),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_369
tff(fact_6092_ATP_Olambda__370,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_tp(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_370
tff(fact_6093_ATP_Olambda__371,axiom,
    ! [B: $tType,Uu: assn,Uua: fun(B,assn),Uub: B] : ( aa(B,assn,aa(fun(B,assn),fun(B,assn),aTP_Lamp_bz(assn,fun(fun(B,assn),fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Uu),aa(B,assn,Uua,Uub)) ) ).

% ATP.lambda_371
tff(fact_6094_ATP_Olambda__372,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_bd(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_372
tff(fact_6095_ATP_Olambda__373,axiom,
    ! [G2: $tType,H9: $tType,Uu: set(G2),Uua: fun(H9,set(G2)),Uub: H9] : ( aa(H9,set(G2),aa(fun(H9,set(G2)),fun(H9,set(G2)),aTP_Lamp_ju(set(G2),fun(fun(H9,set(G2)),fun(H9,set(G2))),Uu),Uua),Uub) = aa(set(G2),set(G2),aa(set(G2),fun(set(G2),set(G2)),minus_minus(set(G2)),Uu),aa(H9,set(G2),Uua,Uub)) ) ).

% ATP.lambda_373
tff(fact_6096_ATP_Olambda__374,axiom,
    ! [E: $tType,F8: $tType,Uu: set(E),Uua: fun(F8,set(E)),Uub: F8] : ( aa(F8,set(E),aa(fun(F8,set(E)),fun(F8,set(E)),aTP_Lamp_hs(set(E),fun(fun(F8,set(E)),fun(F8,set(E))),Uu),Uua),Uub) = aa(set(E),set(E),aa(set(E),fun(set(E),set(E)),sup_sup(set(E)),Uu),aa(F8,set(E),Uua,Uub)) ) ).

% ATP.lambda_374
tff(fact_6097_ATP_Olambda__375,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ki(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_375
tff(fact_6098_ATP_Olambda__376,axiom,
    ! [I5: $tType,J5: $tType,Uu: set(I5),Uua: fun(J5,set(I5)),Uub: J5] : ( aa(J5,set(I5),aa(fun(J5,set(I5)),fun(J5,set(I5)),aTP_Lamp_io(set(I5),fun(fun(J5,set(I5)),fun(J5,set(I5))),Uu),Uua),Uub) = aa(set(I5),set(I5),aa(set(I5),fun(set(I5),set(I5)),inf_inf(set(I5)),Uu),aa(J5,set(I5),Uua,Uub)) ) ).

% ATP.lambda_376
tff(fact_6099_ATP_Olambda__377,axiom,
    ! [C: $tType,D: $tType,Uu: set(C),Uua: fun(D,set(C)),Uub: D] : ( aa(D,set(C),aa(fun(D,set(C)),fun(D,set(C)),aTP_Lamp_ka(set(C),fun(fun(D,set(C)),fun(D,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),Uu),aa(D,set(C),Uua,Uub)) ) ).

% ATP.lambda_377
tff(fact_6100_ATP_Olambda__378,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_im(set(A),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_378
tff(fact_6101_ATP_Olambda__379,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ib(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_379
tff(fact_6102_ATP_Olambda__380,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ko(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_380
tff(fact_6103_ATP_Olambda__381,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_da(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> pp(dvd_dvd(A,Uua,aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_381
tff(fact_6104_ATP_Olambda__382,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: filter(B),Uua: fun(A,filter(C)),Uub: A] : ( aa(A,filter(product_prod(B,C)),aa(fun(A,filter(C)),fun(A,filter(product_prod(B,C))),aTP_Lamp_qv(filter(B),fun(fun(A,filter(C)),fun(A,filter(product_prod(B,C)))),Uu),Uua),Uub) = prod_filter(B,C,Uu,aa(A,filter(C),Uua,Uub)) ) ).

% ATP.lambda_382
tff(fact_6105_ATP_Olambda__383,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,B),Uua: A,Uub: C] : ( aa(C,product_prod(A,B),aa(A,fun(C,product_prod(A,B)),aTP_Lamp_sz(fun(C,B),fun(A,fun(C,product_prod(A,B))),Uu),Uua),Uub) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),aa(C,B,Uu,Uub)) ) ).

% ATP.lambda_383
tff(fact_6106_ATP_Olambda__384,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: set(product_prod(B,A)),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(A),aa(fun(C,set(B)),fun(C,set(A)),aTP_Lamp_pk(set(product_prod(B,A)),fun(fun(C,set(B)),fun(C,set(A))),Uu),Uua),Uub) = image(B,A,Uu,aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_384
tff(fact_6107_ATP_Olambda__385,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_hr(A,fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),insert2(A,Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_385
tff(fact_6108_ATP_Olambda__386,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: fun(C,set(D)),Uua: fun(D,B),Uub: C] : ( aa(C,set(B),aa(fun(D,B),fun(C,set(B)),aTP_Lamp_lv(fun(C,set(D)),fun(fun(D,B),fun(C,set(B))),Uu),Uua),Uub) = aa(set(D),set(B),image2(D,B,Uua),aa(C,set(D),Uu,Uub)) ) ) ).

% ATP.lambda_386
tff(fact_6109_ATP_Olambda__387,axiom,
    ! [A: $tType,Uu: assn,Uua: A,Uub: A] : ( aa(A,assn,aa(A,fun(A,assn),aTP_Lamp_cn(assn,fun(A,fun(A,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Uu),pure_assn(aa(A,bool,aa(A,fun(A,bool),fequal(A),Uub),Uua))) ) ).

% ATP.lambda_387
tff(fact_6110_ATP_Olambda__388,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: fun(B,A),Uub: A] : ( aa(A,set(A),aa(fun(B,A),fun(A,set(A)),aTP_Lamp_nh(set(product_prod(B,B)),fun(fun(B,A),fun(A,set(A))),Uu),Uua),Uub) = aa(set(B),set(A),image2(B,A,Uua),field2(B,Uu)) ) ).

% ATP.lambda_388
tff(fact_6111_ATP_Olambda__389,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: set(A),Uua: set(C),Uub: fun(A,B)] : ( aa(fun(A,B),set(fun(A,C)),aa(set(C),fun(fun(A,B),set(fun(A,C))),aTP_Lamp_nj(set(A),fun(set(C),fun(fun(A,B),set(fun(A,C)))),Uu),Uua),Uub) = bNF_Wellorder_Func(A,C,Uu,Uua) ) ).

% ATP.lambda_389
tff(fact_6112_ATP_Olambda__390,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: set(B),Uub: A] : ( aa(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_ii(set(B),fun(set(B),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),Uu),Uua) ) ).

% ATP.lambda_390
tff(fact_6113_ATP_Olambda__391,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] : ( aa(A,set(A),aa(A,fun(A,set(A)),aTP_Lamp_nf(set(product_prod(A,A)),fun(A,fun(A,set(A))),Uu),Uua),Uub) = order_underS(A,Uu,Uua) ) ).

% ATP.lambda_391
tff(fact_6114_ATP_Olambda__392,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] : ( aa(A,set(A),aa(A,fun(A,set(A)),aTP_Lamp_jc(set(product_prod(A,A)),fun(A,fun(A,set(A))),Uu),Uua),Uub) = order_above(A,Uu,Uua) ) ).

% ATP.lambda_392
tff(fact_6115_ATP_Olambda__393,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: ref(A),Uua: A,Uub: product_unit] : ( aa(product_unit,assn,aa(A,fun(product_unit,assn),aTP_Lamp_he(ref(A),fun(A,fun(product_unit,assn)),Uu),Uua),Uub) = sngr_assn(A,Uu,Uua) ) ) ).

% ATP.lambda_393
tff(fact_6116_ATP_Olambda__394,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: set(B),Uua: set(C),Uub: A] : ( aa(A,set(sum_sum(B,C)),aa(set(C),fun(A,set(sum_sum(B,C))),aTP_Lamp_nq(set(B),fun(set(C),fun(A,set(sum_sum(B,C)))),Uu),Uua),Uub) = sum_Plus(B,C,Uu,Uua) ) ).

% ATP.lambda_394
tff(fact_6117_ATP_Olambda__395,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: set(B),Uub: A] : ( aa(A,set(B),aa(set(B),fun(A,set(B)),aTP_Lamp_hv(B,fun(set(B),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),insert2(B,Uu),Uua) ) ).

% ATP.lambda_395
tff(fact_6118_ATP_Olambda__396,axiom,
    ! [A: $tType,B: $tType,D: $tType,Uu: fun(D,B),Uua: set(D),Uub: A] : ( aa(A,set(B),aa(set(D),fun(A,set(B)),aTP_Lamp_iu(fun(D,B),fun(set(D),fun(A,set(B))),Uu),Uua),Uub) = aa(set(D),set(B),image2(D,B,Uu),Uua) ) ).

% ATP.lambda_396
tff(fact_6119_ATP_Olambda__397,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: ref(A),Uua: A,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(A,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mb(ref(A),fun(A,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(product_unit,fun(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),product_Pair(product_unit,product_prod(heap_ext(product_unit),nat)),product_Unity),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),ref_set(A,Uu,Uua,Uub)),one_one(nat))) ) ) ).

% ATP.lambda_397
tff(fact_6120_ATP_Olambda__398,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),Uua: fun(A,B),Uub: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C,aa(fun(A,B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),aTP_Lamp_uz(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(A,B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C)),Uu),Uua),Uub) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C,Uu,aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(fun(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),comp(option(product_prod(A,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),map_option(product_prod(A,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),product_map_prod(A,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),Uua,id(product_prod(heap_ext(product_unit),nat))))),Uub)) ) ).

% ATP.lambda_398
tff(fact_6121_ATP_Olambda__399,axiom,
    ! [A: $tType,B: $tType,Uu: fun(product_prod(A,B),bool),Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_vf(fun(product_prod(A,B),bool),fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> pp(aa(product_prod(A,B),bool,Uu,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uub))) ) ).

% ATP.lambda_399
tff(fact_6122_ATP_Olambda__400,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(product_prod(A,B),C),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_et(fun(product_prod(A,B),C),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(product_prod(A,B),C,Uu,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uua),Uub)) ) ).

% ATP.lambda_400
tff(fact_6123_ATP_Olambda__401,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: fun(multiset(A),B),Uua: fun(C,multiset(A)),Uub: C] : ( aa(C,B,aa(fun(C,multiset(A)),fun(C,B),aTP_Lamp_pz(fun(multiset(A),B),fun(fun(C,multiset(A)),fun(C,B)),Uu),Uua),Uub) = aa(multiset(A),B,Uu,aa(C,multiset(A),Uua,Uub)) ) ) ).

% ATP.lambda_401
tff(fact_6124_ATP_Olambda__402,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: fun(C,fun(B,bool)),Uua: fun(A,C),Uub: A] : ( aa(A,fun(B,bool),aa(fun(A,C),fun(A,fun(B,bool)),aTP_Lamp_gp(fun(C,fun(B,bool)),fun(fun(A,C),fun(A,fun(B,bool))),Uu),Uua),Uub) = aa(C,fun(B,bool),Uu,aa(A,C,Uua,Uub)) ) ).

% ATP.lambda_402
tff(fact_6125_ATP_Olambda__403,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(B,C),Uua: fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),Uub: fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))] : ( aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C,aa(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),aTP_Lamp_vk(fun(B,C),fun(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C)),Uu),Uua),Uub) = aa(B,C,Uu,aa(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B,Uua,Uub)) ) ).

% ATP.lambda_403
tff(fact_6126_ATP_Olambda__404,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(B,C),Uua: fun(A,B),Uub: A] : ( aa(A,C,aa(fun(A,B),fun(A,C),aTP_Lamp_ua(fun(B,C),fun(fun(A,B),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uu,aa(A,B,Uua,Uub)) ) ).

% ATP.lambda_404
tff(fact_6127_ATP_Olambda__405,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_om(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_405
tff(fact_6128_ATP_Olambda__406,axiom,
    ! [C: $tType,D: $tType,Uu: fun(D,C),Uua: fun(C,bool),Uub: D] :
      ( pp(aa(D,bool,aa(fun(C,bool),fun(D,bool),aTP_Lamp_oj(fun(D,C),fun(fun(C,bool),fun(D,bool)),Uu),Uua),Uub))
    <=> pp(aa(C,bool,Uua,aa(D,C,Uu,Uub))) ) ).

% ATP.lambda_406
tff(fact_6129_ATP_Olambda__407,axiom,
    ! [D: $tType,C: $tType,Uu: fun(C,D),Uua: fun(D,bool),Uub: C] :
      ( pp(aa(C,bool,aa(fun(D,bool),fun(C,bool),aTP_Lamp_ok(fun(C,D),fun(fun(D,bool),fun(C,bool)),Uu),Uua),Uub))
    <=> pp(aa(D,bool,Uua,aa(C,D,Uu,Uub))) ) ).

% ATP.lambda_407
tff(fact_6130_ATP_Olambda__408,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,C),Uua: fun(C,A),Uub: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aTP_Lamp_pq(fun(B,C),fun(fun(C,A),fun(B,A)),Uu),Uua),Uub) = aa(C,A,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_408
tff(fact_6131_ATP_Olambda__409,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_dm(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_409
tff(fact_6132_ATP_Olambda__410,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,bool),Uua: B,Uub: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aTP_Lamp_qt(fun(B,bool),fun(B,fun(A,bool)),Uu),Uua),Uub))
    <=> pp(aa(B,bool,Uu,Uua)) ) ).

% ATP.lambda_410
tff(fact_6133_ATP_Olambda__411,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: fun(B,heap_Time_Heap(A)),Uub: product_unit] : ( aa(product_unit,heap_Time_Heap(A),aa(fun(B,heap_Time_Heap(A)),fun(product_unit,heap_Time_Heap(A)),aTP_Lamp_fn(B,fun(fun(B,heap_Time_Heap(A)),fun(product_unit,heap_Time_Heap(A))),Uu),Uua),Uub) = aa(B,heap_Time_Heap(A),Uua,Uu) ) ).

% ATP.lambda_411
tff(fact_6134_ATP_Olambda__412,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] : ( aa(A,fun(product_prod(A,A),bool),aa(A,fun(A,fun(product_prod(A,A),bool)),aTP_Lamp_fw(set(product_prod(A,A)),fun(A,fun(A,fun(product_prod(A,A),bool))),Uu),Uua),Uub) = aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(A,fun(A,fun(A,bool)),aa(A,fun(A,fun(A,fun(A,bool))),aTP_Lamp_fv(set(product_prod(A,A)),fun(A,fun(A,fun(A,fun(A,bool)))),Uu),Uua),Uub)) ) ).

% ATP.lambda_412
tff(fact_6135_ATP_Olambda__413,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uua: product_prod(code_natural,code_natural),Uub: A] : ( aa(A,pred(B),aa(product_prod(code_natural,code_natural),fun(A,pred(B)),aTP_Lamp_ur(fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),fun(A,pred(B))),Uu),Uua),Uub) = aa(product_prod(pred(B),product_prod(code_natural,code_natural)),pred(B),product_fst(pred(B),product_prod(code_natural,code_natural)),aa(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),Uu,Uub),Uua)) ) ).

% ATP.lambda_413
tff(fact_6136_ATP_Olambda__414,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),Uua: set(old_node(A,B)),Uub: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aTP_Lamp_wo(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),Uu),Uua),Uub) = aa(set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),complete_Sup_Sup(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),image2(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),fun(product_prod(set(old_node(A,B)),set(old_node(A,B))),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),product_case_prod(set(old_node(A,B)),set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),aTP_Lamp_wn(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))))),Uua),Uub))),Uu)) ) ).

% ATP.lambda_414
tff(fact_6137_ATP_Olambda__415,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uua: pred(A),Uub: product_prod(code_natural,code_natural)] : ( aa(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aa(pred(A),fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),aTP_Lamp_us(fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(pred(A),fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))))),Uu),Uua),Uub) = aa(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),product_Pair(pred(B),product_prod(code_natural,code_natural)),bind2(A,B,Uua,aa(product_prod(code_natural,code_natural),fun(A,pred(B)),aTP_Lamp_ur(fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),fun(A,pred(B))),Uu),Uub))) ) ).

% ATP.lambda_415
tff(fact_6138_ATP_Olambda__416,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: fun(C,set(D)),Uua: fun(D,B),Uub: C] : ( aa(C,B,aa(fun(D,B),fun(C,B),aTP_Lamp_lw(fun(C,set(D)),fun(fun(D,B),fun(C,B)),Uu),Uua),Uub) = aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,Uua),aa(C,set(D),Uu,Uub))) ) ) ).

% ATP.lambda_416
tff(fact_6139_ATP_Olambda__417,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: fun(C,set(D)),Uua: fun(D,B),Uub: C] : ( aa(C,B,aa(fun(D,B),fun(C,B),aTP_Lamp_nb(fun(C,set(D)),fun(fun(D,B),fun(C,B)),Uu),Uua),Uub) = aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,Uua),aa(C,set(D),Uu,Uub))) ) ) ).

% ATP.lambda_417
tff(fact_6140_ATP_Olambda__418,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_db(fun(B,A),fun(A,fun(B,bool)),Uu),Uua),Uub))
        <=> ~ pp(dvd_dvd(A,Uua,aa(B,A,Uu,Uub))) ) ) ).

% ATP.lambda_418
tff(fact_6141_ATP_Olambda__419,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: product_unit] : ( aa(product_unit,heap_Time_Heap(A),aa(A,fun(product_unit,heap_Time_Heap(A)),aTP_Lamp_hg(fun(A,A),fun(A,fun(product_unit,heap_Time_Heap(A))),Uu),Uua),Uub) = aa(A,heap_Time_Heap(A),heap_Time_return(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_419
tff(fact_6142_ATP_Olambda__420,axiom,
    ! [A: $tType,B: $tType,Uu: list(A),Uua: list(B),Uub: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(list(B),fun(product_prod(A,B),bool),aTP_Lamp_so(list(A),fun(list(B),fun(product_prod(A,B),bool)),Uu),Uua),Uub))
    <=> ? [I2: nat] :
          ( ( Uub = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),nth(A,Uu,I2)),nth(B,Uua,I2)) )
          & pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),size_size(list(A),Uu)),size_size(list(B),Uua)))) ) ) ).

% ATP.lambda_420
tff(fact_6143_ATP_Olambda__421,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(A,B),Uub: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(fun(A,B),fun(product_prod(A,B),bool),aTP_Lamp_uw(set(A),fun(fun(A,B),fun(product_prod(A,B),bool)),Uu),Uua),Uub))
    <=> ? [A6: A] :
          ( ( Uub = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),A6),aa(A,B,Uua,A6)) )
          & pp(member(A,A6,Uu)) ) ) ).

% ATP.lambda_421
tff(fact_6144_ATP_Olambda__422,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Uu: set(A),Uua: A,Uub: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_kt(set(A),fun(A,fun(A,bool)),Uu),Uua),Uub))
        <=> ? [A6: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),sup_sup(A),Uua),A6) )
              & pp(member(A,A6,Uu)) ) ) ) ).

% ATP.lambda_422
tff(fact_6145_ATP_Olambda__423,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [Uu: A,Uua: set(A),Uub: A] :
          ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_ke(A,fun(set(A),fun(A,bool)),Uu),Uua),Uub))
        <=> ? [B6: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),B6) )
              & pp(member(A,B6,Uua)) ) ) ) ).

% ATP.lambda_423
tff(fact_6146_ATP_Olambda__424,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Uu: set(A),Uua: A,Uub: A] :
          ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_ks(set(A),fun(A,fun(A,bool)),Uu),Uua),Uub))
        <=> ? [A6: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uua),A6) )
              & pp(member(A,A6,Uu)) ) ) ) ).

% ATP.lambda_424
tff(fact_6147_ATP_Olambda__425,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: multiset(A),Uub: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_pv(set(multiset(A)),fun(multiset(A),fun(multiset(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: multiset(A)] :
          ( ( Uub = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),Uua),A6) )
          & pp(member(multiset(A),A6,Uu)) ) ) ).

% ATP.lambda_425
tff(fact_6148_ATP_Olambda__426,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: multiset(A),Uub: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_py(set(multiset(A)),fun(multiset(A),fun(multiset(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: multiset(A)] :
          ( ( Uub = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),Uua),A6) )
          & pp(member(multiset(A),A6,Uu)) ) ) ).

% ATP.lambda_426
tff(fact_6149_ATP_Olambda__427,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,set(C)),Uua: fun(C,bool),Uub: B] :
      ( pp(aa(B,bool,aa(fun(C,bool),fun(B,bool),aTP_Lamp_oq(fun(B,set(C)),fun(fun(C,bool),fun(B,bool)),Uu),Uua),Uub))
    <=> ! [X4: C] :
          ( pp(member(C,X4,aa(B,set(C),Uu,Uub)))
         => pp(aa(C,bool,Uua,X4)) ) ) ).

% ATP.lambda_427
tff(fact_6150_ATP_Olambda__428,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aTP_Lamp_pn(set(product_prod(A,A)),fun(A,fun(A,bool)),Uu),Uua),Uub))
    <=> ! [X4: product_prod(A,A)] :
          ( pp(member(product_prod(A,A),X4,Uu))
         => pp(aa(product_prod(A,A),bool,aa(fun(A,fun(A,bool)),fun(product_prod(A,A),bool),product_case_prod(A,A,bool),aa(A,fun(A,fun(A,bool)),aa(A,fun(A,fun(A,fun(A,bool))),aTP_Lamp_pm(set(product_prod(A,A)),fun(A,fun(A,fun(A,fun(A,bool)))),Uu),Uua),Uub)),X4)) ) ) ).

% ATP.lambda_428
tff(fact_6151_ATP_Olambda__429,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: set(A),Uub: B] :
      ( pp(aa(B,bool,aa(set(A),fun(B,bool),aTP_Lamp_oy(set(product_prod(A,B)),fun(set(A),fun(B,bool)),Uu),Uua),Uub))
    <=> ? [X4: A] :
          ( pp(member(A,X4,Uua))
          & pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),X4),Uub),Uu)) ) ) ).

% ATP.lambda_429
tff(fact_6152_ATP_Olambda__430,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(B,fun(B,bool)),Uub: product_prod(A,A)] :
      ( pp(aa(product_prod(A,A),bool,aa(fun(B,fun(B,bool)),fun(product_prod(A,A),bool),aTP_Lamp_kd(fun(B,A),fun(fun(B,fun(B,bool)),fun(product_prod(A,A),bool)),Uu),Uua),Uub))
    <=> ? [A6: B,B6: B] :
          ( ( Uub = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(B,A,Uu,A6)),aa(B,A,Uu,B6)) )
          & pp(aa(B,bool,aa(B,fun(B,bool),Uua,A6),B6)) ) ) ).

% ATP.lambda_430
tff(fact_6153_ATP_Olambda__431,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: fun(B,A),Uub: product_prod(A,A)] :
      ( pp(aa(product_prod(A,A),bool,aa(fun(B,A),fun(product_prod(A,A),bool),aTP_Lamp_og(set(product_prod(B,B)),fun(fun(B,A),fun(product_prod(A,A),bool)),Uu),Uua),Uub))
    <=> ? [A18: B,A25: B] :
          ( ( Uub = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),aa(B,A,Uua,A18)),aa(B,A,Uua,A25)) )
          & pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A18),A25),Uu)) ) ) ).

% ATP.lambda_431
tff(fact_6154_ATP_Olambda__432,axiom,
    ! [A2: $tType,A: $tType,Uu: set(product_prod(A,A)),Uua: fun(A,A2),Uub: product_prod(A2,A2)] :
      ( pp(aa(product_prod(A2,A2),bool,aa(fun(A,A2),fun(product_prod(A2,A2),bool),aTP_Lamp_nw(set(product_prod(A,A)),fun(fun(A,A2),fun(product_prod(A2,A2),bool)),Uu),Uua),Uub))
    <=> ? [A6: A,B6: A] :
          ( ( Uub = aa(A2,product_prod(A2,A2),aa(A2,fun(A2,product_prod(A2,A2)),product_Pair(A2,A2),aa(A,A2,Uua,A6)),aa(A,A2,Uua,B6)) )
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A6),B6),Uu)) ) ) ).

% ATP.lambda_432
tff(fact_6155_ATP_Olambda__433,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_sj(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: A,V4: list(A)] :
          ( ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Uua),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),A6),V4)) )
          | ? [U3: list(A),Aa4: A,B6: A,Va2: list(A),W3: list(A)] :
              ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Aa4),B6),Uu))
              & ( Uua = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U3),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Aa4),Va2)) )
              & ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),U3),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),B6),W3)) ) ) ) ) ).

% ATP.lambda_433
tff(fact_6156_ATP_Olambda__434,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Uu: set(A),Uua: set(A),Uub: A] :
          ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_ku(set(A),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
        <=> ? [A6: A,B6: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),sup_sup(A),A6),B6) )
              & pp(member(A,A6,Uu))
              & pp(member(A,B6,Uua)) ) ) ) ).

% ATP.lambda_434
tff(fact_6157_ATP_Olambda__435,axiom,
    ! [A: $tType] :
      ( distrib_lattice(A)
     => ! [Uu: set(A),Uua: set(A),Uub: A] :
          ( pp(aa(A,bool,aa(set(A),fun(A,bool),aTP_Lamp_kr(set(A),fun(set(A),fun(A,bool)),Uu),Uua),Uub))
        <=> ? [A6: A,B6: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),inf_inf(A),A6),B6) )
              & pp(member(A,A6,Uu))
              & pp(member(A,B6,Uua)) ) ) ) ).

% ATP.lambda_435
tff(fact_6158_ATP_Olambda__436,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: set(multiset(A)),Uub: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(set(multiset(A)),fun(multiset(A),bool),aTP_Lamp_pw(set(multiset(A)),fun(set(multiset(A)),fun(multiset(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: multiset(A),B6: multiset(A)] :
          ( ( Uub = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),union_mset(A),A6),B6) )
          & pp(member(multiset(A),A6,Uu))
          & pp(member(multiset(A),B6,Uua)) ) ) ).

% ATP.lambda_436
tff(fact_6159_ATP_Olambda__437,axiom,
    ! [A: $tType,Uu: set(multiset(A)),Uua: set(multiset(A)),Uub: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(set(multiset(A)),fun(multiset(A),bool),aTP_Lamp_px(set(multiset(A)),fun(set(multiset(A)),fun(multiset(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: multiset(A),B6: multiset(A)] :
          ( ( Uub = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),inter_mset(A),A6),B6) )
          & pp(member(multiset(A),A6,Uu))
          & pp(member(multiset(A),B6,Uua)) ) ) ).

% ATP.lambda_437
tff(fact_6160_ATP_Olambda__438,axiom,
    ! [A: $tType,Uu: filter(A),Uua: filter(A),Uub: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aa(filter(A),fun(fun(A,bool),bool),aTP_Lamp_pf(filter(A),fun(filter(A),fun(fun(A,bool),bool)),Uu),Uua),Uub))
    <=> ? [Q8: fun(A,bool),R6: fun(A,bool)] :
          ( eventually(A,Q8,Uu)
          & eventually(A,R6,Uua)
          & ! [X4: A] :
              ( ( pp(aa(A,bool,Q8,X4))
                & pp(aa(A,bool,R6,X4)) )
             => pp(aa(A,bool,Uub,X4)) ) ) ) ).

% ATP.lambda_438
tff(fact_6161_ATP_Olambda__439,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: multiset(A),Uub: multiset(A)] :
      ( pp(aa(multiset(A),bool,aa(multiset(A),fun(multiset(A),bool),aTP_Lamp_pu(set(product_prod(A,A)),fun(multiset(A),fun(multiset(A),bool)),Uu),Uua),Uub))
    <=> ? [A6: A,M03: multiset(A),K6: multiset(A)] :
          ( ( Uub = aa(multiset(A),multiset(A),aa(A,fun(multiset(A),multiset(A)),add_mset(A),A6),M03) )
          & ( Uua = aa(multiset(A),multiset(A),aa(multiset(A),fun(multiset(A),multiset(A)),plus_plus(multiset(A)),M03),K6) )
          & ! [B6: A] :
              ( pp(member(A,B6,aa(multiset(A),set(A),set_mset(A),K6)))
             => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),B6),A6),Uu)) ) ) ) ).

% ATP.lambda_439
tff(fact_6162_ATP_Olambda__440,axiom,
    ! [B: $tType,A: $tType,E: $tType,C: $tType,D: $tType,Uu: fun(E,fun(A,fun(C,fun(B,fun(D,bool))))),Uua: E,Uub: fun(A,option(product_prod(B,product_prod(C,D))))] :
      ( pp(aa(fun(A,option(product_prod(B,product_prod(C,D)))),bool,aa(E,fun(fun(A,option(product_prod(B,product_prod(C,D)))),bool),aTP_Lamp_vg(fun(E,fun(A,fun(C,fun(B,fun(D,bool))))),fun(E,fun(fun(A,option(product_prod(B,product_prod(C,D)))),bool)),Uu),Uua),Uub))
    <=> ! [H3: A,H8: C,R5: B,N5: D] :
          ( ( aa(A,option(product_prod(B,product_prod(C,D))),Uub,H3) = aa(product_prod(B,product_prod(C,D)),option(product_prod(B,product_prod(C,D))),some(product_prod(B,product_prod(C,D))),aa(product_prod(C,D),product_prod(B,product_prod(C,D)),aa(B,fun(product_prod(C,D),product_prod(B,product_prod(C,D))),product_Pair(B,product_prod(C,D)),R5),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),H8),N5))) )
         => pp(aa(D,bool,aa(B,fun(D,bool),aa(C,fun(B,fun(D,bool)),aa(A,fun(C,fun(B,fun(D,bool))),aa(E,fun(A,fun(C,fun(B,fun(D,bool)))),Uu,Uua),H3),H8),R5),N5)) ) ) ).

% ATP.lambda_440
tff(fact_6163_ATP_Olambda__441,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: list(A),Uub: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aTP_Lamp_sg(set(product_prod(A,A)),fun(list(A),fun(list(A),bool)),Uu),Uua),Uub))
    <=> ? [Us3: list(A),Z4: A,Z9: A,Vs3: list(A)] :
          ( ( Uua = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us3),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Z4),Vs3)) )
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Z4),Z9),Uu))
          & ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Us3),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Z9),Vs3)) ) ) ) ).

% ATP.lambda_441
tff(fact_6164_ATP_Olambda__442,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: product_prod(C,A),Uua: A,Uub: B,Uuc: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(B,fun(set(product_prod(C,B)),set(product_prod(C,B))),aa(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_fx(product_prod(C,A),fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),Uu),Uua),Uub),Uuc) = if(set(product_prod(C,B)),aa(A,bool,aa(A,fun(A,bool),fequal(A),aa(product_prod(C,A),A,product_snd(C,A),Uu)),Uua),aa(set(product_prod(C,B)),set(product_prod(C,B)),insert2(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),aa(product_prod(C,A),C,product_fst(C,A),Uu)),Uub)),Uuc),Uuc) ) ).

% ATP.lambda_442
tff(fact_6165_ATP_Olambda__443,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: A,Uuc: B] : ( aa(B,A,aa(A,fun(B,A),aa(set(A),fun(A,fun(B,A)),aTP_Lamp_em(fun(A,B),fun(set(A),fun(A,fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,member(B,Uuc,aa(set(A),set(B),image2(A,B,Uu),Uua)),aa(B,A,the_inv_into(A,B,Uua,Uu),Uuc),Uub) ) ).

% ATP.lambda_443
tff(fact_6166_ATP_Olambda__444,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: fun(A,B),Uub: A,Uuc: B] : ( aa(B,A,aa(A,fun(B,A),aa(fun(A,B),fun(A,fun(B,A)),aTP_Lamp_cv(set(A),fun(fun(A,B),fun(A,fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,member(B,Uuc,aa(set(A),set(B),image2(A,B,Uua),Uu)),aa(B,A,the_inv_into(A,B,Uu,Uua),Uuc),Uub) ) ).

% ATP.lambda_444
tff(fact_6167_ATP_Olambda__445,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: A,Uub: B,Uuc: set(B)] : ( aa(set(B),set(B),aa(B,fun(set(B),set(B)),aa(A,fun(B,fun(set(B),set(B))),aTP_Lamp_ll(set(A),fun(A,fun(B,fun(set(B),set(B)))),Uu),Uua),Uub),Uuc) = if(set(B),member(A,Uua,Uu),aa(set(B),set(B),insert2(B,Uub),Uuc),Uuc) ) ).

% ATP.lambda_445
tff(fact_6168_ATP_Olambda__446,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_dz(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),if(A,aa(nat,bool,aa(nat,fun(nat,bool),fequal(nat),Uuc),Uu),one_one(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat)))))) ) ) ).

% ATP.lambda_446
tff(fact_6169_ATP_Olambda__447,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_ea(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = if(A,aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_447
tff(fact_6170_ATP_Olambda__448,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: fun(A,B),Uuc: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(set(A),fun(fun(A,B),fun(A,B)),aTP_Lamp_cp(fun(A,B),fun(set(A),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc) = if(B,member(A,Uuc,Uua),aa(A,B,Uu,Uuc),aa(A,B,Uub,Uuc)) ) ).

% ATP.lambda_448
tff(fact_6171_ATP_Olambda__449,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_dc(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_449
tff(fact_6172_ATP_Olambda__450,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_cy(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_450
tff(fact_6173_ATP_Olambda__451,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_xf(B,fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ).

% ATP.lambda_451
tff(fact_6174_ATP_Olambda__452,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: fun(B,A),Uub: set(B),Uuc: B] : ( aa(B,A,aa(set(B),fun(B,A),aa(fun(B,A),fun(set(B),fun(B,A)),aTP_Lamp_xe(A,fun(fun(B,A),fun(set(B),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,member(B,Uuc,Uub),aa(B,A,Uua,Uuc),Uu) ) ).

% ATP.lambda_452
tff(fact_6175_ATP_Olambda__453,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B,Uua: fun(B,A),Uub: A,Uuc: B] : ( aa(B,A,aa(A,fun(B,A),aa(fun(B,A),fun(A,fun(B,A)),aTP_Lamp_dp(B,fun(fun(B,A),fun(A,fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,aa(B,fun(B,bool),fequal(B),Uuc),Uu),aa(B,A,Uua,Uuc),Uub) ) ) ).

% ATP.lambda_453
tff(fact_6176_ATP_Olambda__454,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: B,Uub: set(A),Uuc: A] : ( aa(A,B,aa(set(A),fun(A,B),aa(B,fun(set(A),fun(A,B)),aTP_Lamp_jl(B,fun(B,fun(set(A),fun(A,B))),Uu),Uua),Uub),Uuc) = if(B,member(A,Uuc,Uub),Uu,Uua) ) ).

% ATP.lambda_454
tff(fact_6177_ATP_Olambda__455,axiom,
    ! [A: $tType,Uu: fun(code_natural,A),Uua: code_natural,Uub: code_natural,Uuc: product_unit] : ( aa(product_unit,seq(A),aa(code_natural,fun(product_unit,seq(A)),aa(code_natural,fun(code_natural,fun(product_unit,seq(A))),aTP_Lamp_vr(fun(code_natural,A),fun(code_natural,fun(code_natural,fun(product_unit,seq(A)))),Uu),Uua),Uub),Uuc) = if(seq(A),aa(code_natural,bool,aa(code_natural,fun(code_natural,bool),ord_less(code_natural),Uub),Uua),empty(A),insert(A,aa(code_natural,A,Uu,Uua),iterate_upto(A,Uu,aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),Uua),one_one(code_natural)),Uub))) ) ).

% ATP.lambda_455
tff(fact_6178_ATP_Olambda__456,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: A,Uub: list(A),Uuc: list(A)] : ( aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),aa(A,fun(list(A),fun(list(A),product_prod(list(A),list(A)))),aTP_Lamp_sr(fun(A,bool),fun(A,fun(list(A),fun(list(A),product_prod(list(A),list(A))))),Uu),Uua),Uub),Uuc) = if(product_prod(list(A),list(A)),aa(A,bool,Uu,Uua),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua),Uub)),Uuc),aa(list(A),product_prod(list(A),list(A)),aa(list(A),fun(list(A),product_prod(list(A),list(A))),product_Pair(list(A),list(A)),Uub),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uua),Uuc))) ) ).

% ATP.lambda_456
tff(fact_6179_ATP_Olambda__457,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,bool),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_cs(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,Uu,Uuc),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_457
tff(fact_6180_ATP_Olambda__458,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,bool),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_cq(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,Uu,Uuc),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ) ).

% ATP.lambda_458
tff(fact_6181_ATP_Olambda__459,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,bool),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),aTP_Lamp_ao(fun(B,bool),fun(fun(B,A),fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = if(A,aa(B,bool,Uu,Uuc),aa(B,A,Uua,Uuc),aa(B,A,Uub,Uuc)) ) ).

% ATP.lambda_459
tff(fact_6182_ATP_Olambda__460,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,bool),Uua: fun(A,option(B)),Uub: fun(A,option(B)),Uuc: A] : ( aa(A,option(B),aa(fun(A,option(B)),fun(A,option(B)),aa(fun(A,option(B)),fun(fun(A,option(B)),fun(A,option(B))),aTP_Lamp_oc(fun(A,bool),fun(fun(A,option(B)),fun(fun(A,option(B)),fun(A,option(B)))),Uu),Uua),Uub),Uuc) = if(option(B),aa(A,bool,Uu,Uuc),aa(A,option(B),Uua,Uuc),aa(A,option(B),Uub,Uuc)) ) ).

% ATP.lambda_460
tff(fact_6183_ATP_Olambda__461,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,bool),Uub: fun(A,B),Uuc: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,bool),fun(fun(A,B),fun(A,B)),aTP_Lamp_uo(fun(A,B),fun(fun(A,bool),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc) = if(B,aa(A,bool,Uua,Uuc),aa(A,B,Uu,Uuc),aa(A,B,Uub,Uuc)) ) ).

% ATP.lambda_461
tff(fact_6184_ATP_Olambda__462,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: C,Uub: A,Uuc: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(A,fun(set(product_prod(C,B)),set(product_prod(C,B))),aa(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aTP_Lamp_ge(set(product_prod(A,B)),fun(C,fun(A,fun(set(product_prod(C,B)),set(product_prod(C,B))))),Uu),Uua),Uub),Uuc) = finite_fold(product_prod(A,B),set(product_prod(C,B)),aa(fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),fun(product_prod(A,B),fun(set(product_prod(C,B)),set(product_prod(C,B)))),product_case_prod(A,B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aa(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),aTP_Lamp_gd(C,fun(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))))),Uua),Uub)),Uuc,Uu) ) ).

% ATP.lambda_462
tff(fact_6185_ATP_Olambda__463,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: A,Uub: B,Uuc: set(product_prod(A,C))] : ( aa(set(product_prod(A,C)),set(product_prod(A,C)),aa(B,fun(set(product_prod(A,C)),set(product_prod(A,C))),aa(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aTP_Lamp_ga(set(product_prod(B,C)),fun(A,fun(B,fun(set(product_prod(A,C)),set(product_prod(A,C))))),Uu),Uua),Uub),Uuc) = finite_fold(product_prod(B,C),set(product_prod(A,C)),aa(fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C))))),fun(product_prod(B,C),fun(set(product_prod(A,C)),set(product_prod(A,C)))),product_case_prod(B,C,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aa(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C))))),aTP_Lamp_fz(A,fun(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C)))))),Uua),Uub)),Uuc,Uu) ) ).

% ATP.lambda_463
tff(fact_6186_ATP_Olambda__464,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_rt(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,compow(fun(A,A),Uuc,aa(A,fun(A,A),times_times(A),Uua)),aa(B,A,Uu,nth(B,Uub,Uuc))) ) ) ).

% ATP.lambda_464
tff(fact_6187_ATP_Olambda__465,axiom,
    ! [C: $tType,B: $tType,A: $tType,Uu: fun(B,fun(list(B),fun(C,C))),Uua: fun(A,B),Uub: A,Uuc: list(A)] : ( aa(list(A),fun(C,C),aa(A,fun(list(A),fun(C,C)),aa(fun(A,B),fun(A,fun(list(A),fun(C,C))),aTP_Lamp_sx(fun(B,fun(list(B),fun(C,C))),fun(fun(A,B),fun(A,fun(list(A),fun(C,C)))),Uu),Uua),Uub),Uuc) = aa(list(B),fun(C,C),aa(B,fun(list(B),fun(C,C)),Uu,aa(A,B,Uua,Uub)),aa(list(A),list(B),map(A,B,Uua),Uuc)) ) ).

% ATP.lambda_465
tff(fact_6188_ATP_Olambda__466,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( order(C)
        & order(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,B),Uub: A,Uuc: D] : ( aa(D,C,aa(A,fun(D,C),aa(fun(D,B),fun(A,fun(D,C)),aTP_Lamp_op(fun(A,fun(B,C)),fun(fun(D,B),fun(A,fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,Uub),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_466
tff(fact_6189_ATP_Olambda__467,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,fun(C,bool)),Uua: fun(B,C),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(B,C),fun(A,fun(B,bool)),aTP_Lamp_go(fun(A,fun(C,bool)),fun(fun(B,C),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(aa(C,bool,aa(A,fun(C,bool),Uu,Uub),aa(B,C,Uua,Uuc))) ) ).

% ATP.lambda_467
tff(fact_6190_ATP_Olambda__468,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: set(C),Uuc: A] : ( aa(A,B,aa(set(C),fun(A,B),aa(fun(C,B),fun(set(C),fun(A,B)),aTP_Lamp_ba(fun(A,B),fun(fun(C,B),fun(set(C),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(A,fun(C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_az(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),Uu),Uua),Uuc)),Uub) ) ) ).

% ATP.lambda_468
tff(fact_6191_ATP_Olambda__469,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,assn)),Uua: bool,Uub: A,Uuc: B] : ( aa(B,assn,aa(A,fun(B,assn),aa(bool,fun(A,fun(B,assn)),aTP_Lamp_ar(fun(A,fun(B,assn)),fun(bool,fun(A,fun(B,assn))),Uu),Uua),Uub),Uuc) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,aa(A,fun(B,assn),Uu,Uub),Uuc)),pure_assn(Uua)) ) ).

% ATP.lambda_469
tff(fact_6192_ATP_Olambda__470,axiom,
    ! [Uu: code_natural,Uua: code_natural,Uub: code_natural,Uuc: code_natural] : ( aa(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aa(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),aTP_Lamp_ub(code_natural,fun(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))))),Uu),Uua),Uub),Uuc) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_Pair(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),inc_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),Uu)),Uuc)),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),Uub),inc_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),Uua))) ) ).

% ATP.lambda_470
tff(fact_6193_ATP_Olambda__471,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: set(A),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(A),fun(A,fun(A,bool)),aTP_Lamp_lq(fun(A,fun(A,bool)),fun(set(A),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uuc),product_Sigma(A,A,Uua,aTP_Lamp_if(set(A),fun(A,set(A)),Uua))))
        & pp(aa(A,bool,aa(A,fun(A,bool),Uu,Uub),Uuc)) ) ) ).

% ATP.lambda_471
tff(fact_6194_ATP_Olambda__472,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gz(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uub))) ) ).

% ATP.lambda_472
tff(fact_6195_ATP_Olambda__473,axiom,
    ! [B: $tType,A: $tType,Uu: set(old_node(A,B)),Uua: set(old_node(A,B)),Uub: set(old_node(A,B)),Uuc: set(old_node(A,B))] : ( aa(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))),aTP_Lamp_wn(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),fun(set(old_node(A,B)),set(product_prod(set(old_node(A,B)),set(old_node(A,B))))))),Uu),Uua),Uub),Uuc) = aa(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),set(product_prod(set(old_node(A,B)),set(old_node(A,B)))),insert2(product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B))),aa(set(old_node(A,B)),fun(set(old_node(A,B)),product_prod(set(old_node(A,B)),set(old_node(A,B)))),product_Pair(set(old_node(A,B)),set(old_node(A,B))),old_Scons(A,B,Uu,Uub)),old_Scons(A,B,Uua,Uuc))),bot_bot(set(product_prod(set(old_node(A,B)),set(old_node(A,B)))))) ) ).

% ATP.lambda_473
tff(fact_6196_ATP_Olambda__474,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: A,Uub: array(A),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(A,fun(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_rn(nat,fun(A,fun(array(A),fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat)),aa(A,fun(product_prod(heap_ext(product_unit),nat),product_prod(A,product_prod(heap_ext(product_unit),nat))),product_Pair(A,product_prod(heap_ext(product_unit),nat)),nth(A,array_get(A,Uuc,Uub),Uu)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(A,Uub,Uu,Uua,Uuc)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_474
tff(fact_6197_ATP_Olambda__475,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: set(A),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(A),fun(A,fun(A,bool)),aTP_Lamp_jn(set(product_prod(A,A)),fun(set(A),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uuc),Uu))
        & ~ pp(member(A,Uub,Uua))
        & ~ pp(member(A,Uuc,Uua)) ) ) ).

% ATP.lambda_475
tff(fact_6198_ATP_Olambda__476,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: set(product_prod(A,A)),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aTP_Lamp_hd(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc)))
        | ( pp(aa(nat,bool,aa(nat,fun(nat,bool),ord_less_eq(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc)))
          & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uuc),Uua)) ) ) ) ).

% ATP.lambda_476
tff(fact_6199_ATP_Olambda__477,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: fun(A,B),Uub: A,Uuc: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(fun(A,B),fun(A,fun(A,bool)),aTP_Lamp_ir(set(product_prod(B,B)),fun(fun(A,B),fun(A,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,Uua,Uub)),aa(A,B,Uua,Uuc)),Uu)) ) ).

% ATP.lambda_477
tff(fact_6200_ATP_Olambda__478,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,option(B)),Uua: fun(product_prod(A,B),bool),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(fun(product_prod(A,B),bool),fun(A,fun(B,bool)),aTP_Lamp_me(fun(A,option(B)),fun(fun(product_prod(A,B),bool),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( ( aa(A,option(B),Uu,Uub) = aa(B,option(B),some(B),Uuc) )
        & pp(aa(product_prod(A,B),bool,Uua,aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uub),Uuc))) ) ) ).

% ATP.lambda_478
tff(fact_6201_ATP_Olambda__479,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_dy(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),binomial(Uub,Uuc))),comm_s3205402744901411588hammer(A,Uu,Uuc))),comm_s3205402744901411588hammer(A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_479
tff(fact_6202_ATP_Olambda__480,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_dw(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),binomial(Uub,Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_480
tff(fact_6203_ATP_Olambda__481,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat,Uub: list(A),Uuc: list(A)] :
      ( pp(aa(list(A),bool,aa(list(A),fun(list(A),bool),aa(nat,fun(list(A),fun(list(A),bool)),aTP_Lamp_sf(set(product_prod(A,A)),fun(nat,fun(list(A),fun(list(A),bool))),Uu),Uua),Uub),Uuc))
    <=> ( ( size_size(list(A),Uub) = Uua )
        & ( size_size(list(A),Uuc) = Uua )
        & ? [Xys2: list(A),X4: A,Y3: A,Xs6: list(A),Ys5: list(A)] :
            ( ( Uub = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),X4),Xs6)) )
            & ( Uuc = aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Xys2),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Y3),Ys5)) )
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),X4),Y3),Uu)) ) ) ) ).

% ATP.lambda_481
tff(fact_6204_ATP_Olambda__482,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_dq(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uuc)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc)) ) ) ).

% ATP.lambda_482
tff(fact_6205_ATP_Olambda__483,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,B),Uub: B,Uuc: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aa(fun(A,B),fun(B,fun(A,bool)),aTP_Lamp_dn(set(A),fun(fun(A,B),fun(B,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(member(A,Uuc,Uu))
        & ( aa(A,B,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_483
tff(fact_6206_ATP_Olambda__484,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: set(A),Uub: B,Uuc: A] :
      ( pp(aa(A,bool,aa(B,fun(A,bool),aa(set(A),fun(B,fun(A,bool)),aTP_Lamp_jq(fun(A,B),fun(set(A),fun(B,fun(A,bool))),Uu),Uua),Uub),Uuc))
    <=> ( pp(member(A,Uuc,Uua))
        & ( aa(A,B,Uu,Uuc) = Uub ) ) ) ).

% ATP.lambda_484
tff(fact_6207_ATP_Olambda__485,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_dr(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uuc))) ) ) ).

% ATP.lambda_485
tff(fact_6208_ATP_Olambda__486,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gv(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)) ) ).

% ATP.lambda_486
tff(fact_6209_ATP_Olambda__487,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gx(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ).

% ATP.lambda_487
tff(fact_6210_ATP_Olambda__488,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: list(A),Uub: B,Uuc: list(B)] : ( aa(list(B),list(product_prod(A,B)),aa(B,fun(list(B),list(product_prod(A,B))),aa(list(A),fun(B,fun(list(B),list(product_prod(A,B)))),aTP_Lamp_ts(A,fun(list(A),fun(B,fun(list(B),list(product_prod(A,B))))),Uu),Uua),Uub),Uuc) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uu),Uub)),zip(A,B,Uua,Uuc)) ) ).

% ATP.lambda_488
tff(fact_6211_ATP_Olambda__489,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: list(B),Uub: A,Uuc: list(A)] : ( aa(list(A),list(product_prod(A,B)),aa(A,fun(list(A),list(product_prod(A,B))),aa(list(B),fun(A,fun(list(A),list(product_prod(A,B)))),aTP_Lamp_tu(B,fun(list(B),fun(A,fun(list(A),list(product_prod(A,B))))),Uu),Uua),Uub),Uuc) = aa(list(product_prod(A,B)),list(product_prod(A,B)),aa(product_prod(A,B),fun(list(product_prod(A,B)),list(product_prod(A,B))),cons(product_prod(A,B)),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uub),Uu)),zip(A,B,Uuc,Uua)) ) ).

% ATP.lambda_489
tff(fact_6212_ATP_Olambda__490,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: B,Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(B,fun(A,fun(B,bool)),aTP_Lamp_js(A,fun(B,fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ( ( Uu = Uub )
        & ( Uua = Uuc ) ) ) ).

% ATP.lambda_490
tff(fact_6213_ATP_Olambda__491,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,set(product_prod(A,B))),Uua: C,Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(C,fun(A,fun(B,bool)),aTP_Lamp_jf(fun(C,set(product_prod(A,B))),fun(C,fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> pp(member(product_prod(A,B),aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),Uub),Uuc),aa(C,set(product_prod(A,B)),Uu,Uua))) ) ).

% ATP.lambda_491
tff(fact_6214_ATP_Olambda__492,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: set(B),Uua: fun(B,A),Uub: fun(B,A),Uuc: B] :
          ( pp(aa(B,bool,aa(fun(B,A),fun(B,bool),aa(fun(B,A),fun(fun(B,A),fun(B,bool)),aTP_Lamp_bu(set(B),fun(fun(B,A),fun(fun(B,A),fun(B,bool))),Uu),Uua),Uub),Uuc))
        <=> ( pp(member(B,Uuc,Uu))
            & ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uua,Uuc)),aa(B,A,Uub,Uuc)) != one_one(A) ) ) ) ) ).

% ATP.lambda_492
tff(fact_6215_ATP_Olambda__493,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: list(A),Uub: array(A),Uuc: A] : ( aa(A,assn,aa(array(A),fun(A,assn),aa(list(A),fun(array(A),fun(A,assn)),aTP_Lamp_rl(nat,fun(list(A),fun(array(A),fun(A,assn))),Uu),Uua),Uub),Uuc) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(A,Uub,Uua)),pure_assn(aa(A,bool,aa(A,fun(A,bool),fequal(A),Uuc),nth(A,Uua,Uu)))) ) ) ).

% ATP.lambda_493
tff(fact_6216_ATP_Olambda__494,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_ru(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,nth(B,Uub,Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uuc)) ) ) ).

% ATP.lambda_494
tff(fact_6217_ATP_Olambda__495,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B,Uuc: A] : ( aa(A,A,aa(B,fun(A,A),aa(A,fun(B,fun(A,A)),aTP_Lamp_tx(fun(B,A),fun(A,fun(B,fun(A,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uuc)) ) ) ).

% ATP.lambda_495
tff(fact_6218_ATP_Olambda__496,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( semiring_0(B)
        & comm_monoid_add(A)
        & times(A) )
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: A,Uuc: C] : ( aa(C,B,aa(A,fun(C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_qr(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(C,B,Uua,Uuc)) ) ) ).

% ATP.lambda_496
tff(fact_6219_ATP_Olambda__497,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: A,Uuc: C] : ( aa(C,B,aa(A,fun(C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_az(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(C,B,Uua,Uuc)) ) ) ).

% ATP.lambda_497
tff(fact_6220_ATP_Olambda__498,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_kj(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(C,A,Uua,Uuc)) ) ) ).

% ATP.lambda_498
tff(fact_6221_ATP_Olambda__499,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(A)),Uub: B,Uuc: C] : ( aa(C,set(A),aa(B,fun(C,set(A)),aa(fun(C,set(A)),fun(B,fun(C,set(A))),aTP_Lamp_ik(fun(B,set(A)),fun(fun(C,set(A)),fun(B,fun(C,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(B,set(A),Uu,Uub)),aa(C,set(A),Uua,Uuc)) ) ).

% ATP.lambda_499
tff(fact_6222_ATP_Olambda__500,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_ic(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(C,A,Uua,Uuc)) ) ) ).

% ATP.lambda_500
tff(fact_6223_ATP_Olambda__501,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Uu: fun(A,filter(C)),Uua: fun(B,filter(D)),Uub: A,Uuc: B] : ( aa(B,filter(product_prod(C,D)),aa(A,fun(B,filter(product_prod(C,D))),aa(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D)))),aTP_Lamp_qp(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D))))),Uu),Uua),Uub),Uuc) = prod_filter(C,D,aa(A,filter(C),Uu,Uub),aa(B,filter(D),Uua,Uuc)) ) ).

% ATP.lambda_501
tff(fact_6224_ATP_Olambda__502,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Uu: fun(C,A),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,product_prod(A,B),aa(C,fun(D,product_prod(A,B)),aa(fun(D,B),fun(C,fun(D,product_prod(A,B))),aTP_Lamp_is(fun(C,A),fun(fun(D,B),fun(C,fun(D,product_prod(A,B)))),Uu),Uua),Uub),Uuc) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ).

% ATP.lambda_502
tff(fact_6225_ATP_Olambda__503,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Uu: fun(A,C),Uua: fun(B,D),Uub: A,Uuc: B] : ( aa(B,product_prod(C,D),aa(A,fun(B,product_prod(C,D)),aa(fun(B,D),fun(A,fun(B,product_prod(C,D))),aTP_Lamp_eu(fun(A,C),fun(fun(B,D),fun(A,fun(B,product_prod(C,D)))),Uu),Uua),Uub),Uuc) = aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(A,C,Uu,Uub)),aa(B,D,Uua,Uuc)) ) ).

% ATP.lambda_503
tff(fact_6226_ATP_Olambda__504,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(B,C),Uuc: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(A,B),fun(fun(B,C),fun(B,C)),aTP_Lamp_do(set(A),fun(fun(A,B),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),finite_card(A,aa(fun(A,bool),set(A),collect(A),aa(B,fun(A,bool),aa(fun(A,B),fun(B,fun(A,bool)),aTP_Lamp_dn(set(A),fun(fun(A,B),fun(B,fun(A,bool))),Uu),Uua),Uuc))))),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_504
tff(fact_6227_ATP_Olambda__505,axiom,
    ! [A: $tType,B: $tType,Uu: bool,Uua: fun(A,fun(B,assn)),Uub: A,Uuc: B] : ( aa(B,assn,aa(A,fun(B,assn),aa(fun(A,fun(B,assn)),fun(A,fun(B,assn)),aTP_Lamp_aq(bool,fun(fun(A,fun(B,assn)),fun(A,fun(B,assn))),Uu),Uua),Uub),Uuc) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),pure_assn(Uu)),aa(B,assn,aa(A,fun(B,assn),Uua,Uub),Uuc)) ) ).

% ATP.lambda_505
tff(fact_6228_ATP_Olambda__506,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: fun(A,A),Uub: array(A),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(fun(A,A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_ro(nat,fun(fun(A,A),fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_Pair(array(A),product_prod(heap_ext(product_unit),nat)),Uub),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(A,Uub,Uu,aa(A,A,Uua,nth(A,array_get(A,Uuc,Uub),Uu)),Uuc)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_506
tff(fact_6229_ATP_Olambda__507,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: A,Uub: array(A),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),aa(A,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_rp(nat,fun(A,fun(array(A),fun(heap_ext(product_unit),product_prod(array(A),product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat)),aa(array(A),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(A),product_prod(heap_ext(product_unit),nat))),product_Pair(array(A),product_prod(heap_ext(product_unit),nat)),Uub),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(A,Uub,Uu,Uua,Uuc)),one_one(nat))) ) ) ).

% ATP.lambda_507
tff(fact_6230_ATP_Olambda__508,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(C,A),Uua: fun(C,B),Uub: set(C),Uuc: A] : ( aa(A,set(B),aa(set(C),fun(A,set(B)),aa(fun(C,B),fun(set(C),fun(A,set(B))),aTP_Lamp_jk(fun(C,A),fun(fun(C,B),fun(set(C),fun(A,set(B)))),Uu),Uua),Uub),Uuc) = aa(set(C),set(B),image2(C,B,Uua),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(A),set(C),aa(fun(C,A),fun(set(A),set(C)),vimage(C,A),Uu),aa(set(A),set(A),insert2(A,Uuc),bot_bot(set(A))))),Uub)) ) ).

% ATP.lambda_508
tff(fact_6231_ATP_Olambda__509,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,heap_Time_Heap(A)),Uua: B,Uub: heap_ext(product_unit),Uuc: nat] : ( aa(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),aa(B,fun(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_ms(fun(B,heap_Time_Heap(A)),fun(B,fun(heap_ext(product_unit),fun(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua),Uub),Uuc) = heap_Time_timeFrame(A,Uuc,aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(A),aa(B,heap_Time_Heap(A),Uu,Uua)),Uub)) ) ).

% ATP.lambda_509
tff(fact_6232_ATP_Olambda__510,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,heap_Time_Heap(B)),Uua: A,Uub: heap_ext(product_unit),Uuc: nat] : ( aa(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(A,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_mn(fun(A,heap_Time_Heap(B)),fun(A,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua),Uub),Uuc) = heap_Time_timeFrame(B,Uuc,aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),aa(A,heap_Time_Heap(B),Uu,Uua)),Uub)) ) ).

% ATP.lambda_510
tff(fact_6233_ATP_Olambda__511,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),option(bool),aa(A,fun(list(A),option(bool)),aa(list(A),fun(A,fun(list(A),option(bool))),aTP_Lamp_ss(list(A),fun(list(A),fun(A,fun(list(A),option(bool)))),Uu),Uua),Uub),Uuc) = subset_eq_mset_impl(A,Uu,aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),append(A),Uua),Uuc)) ) ).

% ATP.lambda_511
tff(fact_6234_ATP_Olambda__512,axiom,
    ! [A: $tType,D: $tType,B: $tType,C: $tType,Uu: fun(product_prod(B,C),A),Uua: fun(D,B),Uub: D,Uuc: C] : ( aa(C,A,aa(D,fun(C,A),aa(fun(D,B),fun(D,fun(C,A)),aTP_Lamp_ta(fun(product_prod(B,C),A),fun(fun(D,B),fun(D,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(product_prod(B,C),A,Uu,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Uua,Uub)),Uuc)) ) ).

% ATP.lambda_512
tff(fact_6235_ATP_Olambda__513,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Uu: fun(product_prod(B,C),A),Uua: fun(D,C),Uub: B,Uuc: D] : ( aa(D,A,aa(B,fun(D,A),aa(fun(D,C),fun(B,fun(D,A)),aTP_Lamp_tb(fun(product_prod(B,C),A),fun(fun(D,C),fun(B,fun(D,A))),Uu),Uua),Uub),Uuc) = aa(product_prod(B,C),A,Uu,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uub),aa(D,C,Uua,Uuc))) ) ).

% ATP.lambda_513
tff(fact_6236_ATP_Olambda__514,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(C,fun(B,heap_Time_Heap(A))),Uua: fun(C,C),Uub: fun(fun(B,heap_Time_Heap(A)),C),Uuc: fun(B,heap_Time_Heap(A))] : ( aa(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A)))),aTP_Lamp_vv(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(fun(B,heap_Time_Heap(A)),fun(B,heap_Time_Heap(A))))),Uu),Uua),Uub),Uuc) = aa(C,fun(B,heap_Time_Heap(A)),Uu,aa(C,C,Uua,aa(fun(B,heap_Time_Heap(A)),C,Uub,Uuc))) ) ).

% ATP.lambda_514
tff(fact_6237_ATP_Olambda__515,axiom,
    ! [C: $tType,A: $tType,B: $tType,Uu: fun(C,fun(B,A)),Uua: fun(C,C),Uub: fun(fun(B,A),C),Uuc: fun(B,A)] : ( aa(fun(B,A),fun(B,A),aa(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A))),aTP_Lamp_vo(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(fun(B,A),fun(B,A)))),Uu),Uua),Uub),Uuc) = aa(C,fun(B,A),Uu,aa(C,C,Uua,aa(fun(B,A),C,Uub,Uuc))) ) ).

% ATP.lambda_515
tff(fact_6238_ATP_Olambda__516,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B,Uuc: list(B)] : ( aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),aa(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),aa(A,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))))),aTP_Lamp_sc(fun(B,A),fun(A,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))))),Uu),Uua),Uub),Uuc) = aa(fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_case_prod(list(B),list(B),product_prod(list(B),product_prod(list(B),list(B)))),aa(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))),aa(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))),aa(A,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))))),aTP_Lamp_sb(fun(B,A),fun(A,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))))),Uu),Uua),Uub),Uuc)) ) ) ).

% ATP.lambda_516
tff(fact_6239_ATP_Olambda__517,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,bool),Uua: fun(A,set(product_prod(B,B))),Uub: A,Uuc: B] : ( aa(B,fun(product_prod(A,B),bool),aa(A,fun(B,fun(product_prod(A,B),bool)),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),bool))),aTP_Lamp_gn(fun(A,bool),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(product_prod(A,B),bool)))),Uu),Uua),Uub),Uuc) = aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(B,fun(A,fun(B,bool)),aa(A,fun(B,fun(A,fun(B,bool))),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,bool)))),aTP_Lamp_gm(fun(A,bool),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,bool))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_517
tff(fact_6240_ATP_Olambda__518,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(B,B)),Uub: A,Uuc: B] : ( aa(B,fun(product_prod(A,B),bool),aa(A,fun(B,fun(product_prod(A,B),bool)),aa(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),bool))),aTP_Lamp_fs(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(product_prod(A,B),bool)))),Uu),Uua),Uub),Uuc) = aa(fun(A,fun(B,bool)),fun(product_prod(A,B),bool),product_case_prod(A,B,bool),aa(B,fun(A,fun(B,bool)),aa(A,fun(B,fun(A,fun(B,bool))),aa(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,bool)))),aTP_Lamp_fr(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,bool))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_518
tff(fact_6241_ATP_Olambda__519,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( semiring_0(B)
        & comm_monoid_add(A)
        & times(A) )
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: multiset(C),Uuc: A] : ( aa(A,B,aa(multiset(C),fun(A,B),aa(fun(C,B),fun(multiset(C),fun(A,B)),aTP_Lamp_qs(fun(A,B),fun(fun(C,B),fun(multiset(C),fun(A,B))),Uu),Uua),Uub),Uuc) = comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(A,fun(C,B),aa(fun(C,B),fun(A,fun(C,B)),aTP_Lamp_qr(fun(A,B),fun(fun(C,B),fun(A,fun(C,B))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_519
tff(fact_6242_ATP_Olambda__520,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(B,set(A)),Uua: fun(C,set(A)),Uub: set(C),Uuc: B] : ( aa(B,set(A),aa(set(C),fun(B,set(A)),aa(fun(C,set(A)),fun(set(C),fun(B,set(A))),aTP_Lamp_il(fun(B,set(A)),fun(fun(C,set(A)),fun(set(C),fun(B,set(A)))),Uu),Uua),Uub),Uuc) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(C),set(set(A)),image2(C,set(A),aa(B,fun(C,set(A)),aa(fun(C,set(A)),fun(B,fun(C,set(A))),aTP_Lamp_ik(fun(B,set(A)),fun(fun(C,set(A)),fun(B,fun(C,set(A)))),Uu),Uua),Uuc)),Uub)) ) ).

% ATP.lambda_520
tff(fact_6243_ATP_Olambda__521,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: set(C),Uuc: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_id(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image2(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_ic(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_521
tff(fact_6244_ATP_Olambda__522,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Uu: set(B),Uua: fun(A,filter(C)),Uub: fun(B,filter(D)),Uuc: A] : ( aa(A,filter(product_prod(C,D)),aa(fun(B,filter(D)),fun(A,filter(product_prod(C,D))),aa(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D)))),aTP_Lamp_qq(set(B),fun(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,filter(product_prod(C,D))))),Uu),Uua),Uub),Uuc) = aa(set(filter(product_prod(C,D))),filter(product_prod(C,D)),complete_Inf_Inf(filter(product_prod(C,D))),aa(set(B),set(filter(product_prod(C,D))),image2(B,filter(product_prod(C,D)),aa(A,fun(B,filter(product_prod(C,D))),aa(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D)))),aTP_Lamp_qp(fun(A,filter(C)),fun(fun(B,filter(D)),fun(A,fun(B,filter(product_prod(C,D))))),Uua),Uub),Uuc)),Uu)) ) ).

% ATP.lambda_522
tff(fact_6245_ATP_Olambda__523,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: set(C),Uuc: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_kk(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image2(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_kj(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_523
tff(fact_6246_ATP_Olambda__524,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_ez(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_524
tff(fact_6247_ATP_Olambda__525,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fg(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_525
tff(fact_6248_ATP_Olambda__526,axiom,
    ! [A: $tType,Uu: fun(A,bool),Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),aa(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_wq(fun(A,bool),fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),takeWhile(A,aa(fun(A,bool),fun(A,bool),aa(fun(bool,bool),fun(fun(A,bool),fun(A,bool)),comp(bool,bool,A),fNot),Uu),Uua)),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),Uub),Uuc))) ) ).

% ATP.lambda_526
tff(fact_6249_ATP_Olambda__527,axiom,
    ! [A: $tType,Uu: A,Uua: list(A),Uub: A,Uuc: list(A)] : ( aa(list(A),option(product_prod(list(A),product_prod(A,list(A)))),aa(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))),aa(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A)))))),aTP_Lamp_sd(A,fun(list(A),fun(A,fun(list(A),option(product_prod(list(A),product_prod(A,list(A))))))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(A),product_prod(A,list(A))),option(product_prod(list(A),product_prod(A,list(A)))),some(product_prod(list(A),product_prod(A,list(A)))),aa(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A))),aa(list(A),fun(product_prod(A,list(A)),product_prod(list(A),product_prod(A,list(A)))),product_Pair(list(A),product_prod(A,list(A))),aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uu),Uua)),aa(list(A),product_prod(A,list(A)),aa(A,fun(list(A),product_prod(A,list(A))),product_Pair(A,list(A)),Uub),Uuc))) ) ).

% ATP.lambda_527
tff(fact_6250_ATP_Olambda__528,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fd(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uub)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_528
tff(fact_6251_ATP_Olambda__529,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fb(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_529
tff(fact_6252_ATP_Olambda__530,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: fun(A,fun(B,set(C))),Uub: B,Uuc: A] : ( aa(A,set(C),aa(B,fun(A,set(C)),aa(fun(A,fun(B,set(C))),fun(B,fun(A,set(C))),aTP_Lamp_my(set(product_prod(B,B)),fun(fun(A,fun(B,set(C))),fun(B,fun(A,set(C)))),Uu),Uua),Uub),Uuc) = aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),aa(A,fun(B,set(C)),Uua,Uuc)),image(B,B,Uu,aa(set(B),set(B),insert2(B,Uub),bot_bot(set(B)))))) ) ).

% ATP.lambda_530
tff(fact_6253_ATP_Olambda__531,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: set(product_prod(A,C)),Uua: set(product_prod(C,B)),Uub: A,Uuc: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(set(product_prod(C,B)),fun(A,fun(B,bool)),aTP_Lamp_kp(set(product_prod(A,C)),fun(set(product_prod(C,B)),fun(A,fun(B,bool))),Uu),Uua),Uub),Uuc))
    <=> ? [Y3: C] :
          ( pp(member(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),Uub),Y3),Uu))
          & pp(member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Y3),Uuc),Uua)) ) ) ).

% ATP.lambda_531
tff(fact_6254_ATP_Olambda__532,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: set(C),Uua: fun(C,A),Uub: fun(C,B),Uuc: product_prod(A,B)] :
      ( pp(aa(product_prod(A,B),bool,aa(fun(C,B),fun(product_prod(A,B),bool),aa(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),bool)),aTP_Lamp_kx(set(C),fun(fun(C,A),fun(fun(C,B),fun(product_prod(A,B),bool))),Uu),Uua),Uub),Uuc))
    <=> ? [A6: C] :
          ( ( Uuc = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,Uua,A6)),aa(C,B,Uub,A6)) )
          & pp(member(C,A6,Uu)) ) ) ).

% ATP.lambda_532
tff(fact_6255_ATP_Olambda__533,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: set(product_prod(B,B)),Uub: fun(A,B),Uuc: product_prod(A,A)] :
      ( pp(aa(product_prod(A,A),bool,aa(fun(A,B),fun(product_prod(A,A),bool),aa(set(product_prod(B,B)),fun(fun(A,B),fun(product_prod(A,A),bool)),aTP_Lamp_pp(set(A),fun(set(product_prod(B,B)),fun(fun(A,B),fun(product_prod(A,A),bool))),Uu),Uua),Uub),Uuc))
    <=> ? [A18: A,A25: A] :
          ( ( Uuc = aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),A18),A25) )
          & pp(member(A,A18,Uu))
          & pp(member(A,A25,Uu))
          & pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(A,B,Uub,A18)),aa(A,B,Uub,A25)),Uua)) ) ) ).

% ATP.lambda_533
tff(fact_6256_ATP_Olambda__534,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,fun(A,A)),Uua: A,Uub: fun(B,set(C)),Uuc: fun(C,A),Uud: B] : ( aa(B,A,aa(fun(C,A),fun(B,A),aa(fun(B,set(C)),fun(fun(C,A),fun(B,A)),aa(A,fun(fun(B,set(C)),fun(fun(C,A),fun(B,A))),aTP_Lamp_xg(fun(A,fun(A,A)),fun(A,fun(fun(B,set(C)),fun(fun(C,A),fun(B,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups_comm_monoid_F(A,C,Uu,Uua),Uuc),aa(B,set(C),Uub,Uud)) ) ).

% ATP.lambda_534
tff(fact_6257_ATP_Olambda__535,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: C,Uua: A,Uub: A,Uuc: B,Uud: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(B,fun(set(product_prod(C,B)),set(product_prod(C,B))),aa(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),aa(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B))))),aTP_Lamp_gd(C,fun(A,fun(A,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))))),Uu),Uua),Uub),Uuc),Uud) = if(set(product_prod(C,B)),aa(A,bool,aa(A,fun(A,bool),fequal(A),Uua),Uub),aa(set(product_prod(C,B)),set(product_prod(C,B)),insert2(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uu),Uuc)),Uud),Uud) ) ).

% ATP.lambda_535
tff(fact_6258_ATP_Olambda__536,axiom,
    ! [B: $tType,C: $tType,A: $tType,Uu: A,Uua: B,Uub: B,Uuc: C,Uud: set(product_prod(A,C))] : ( aa(set(product_prod(A,C)),set(product_prod(A,C)),aa(C,fun(set(product_prod(A,C)),set(product_prod(A,C))),aa(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C)))),aa(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C))))),aTP_Lamp_fz(A,fun(B,fun(B,fun(C,fun(set(product_prod(A,C)),set(product_prod(A,C)))))),Uu),Uua),Uub),Uuc),Uud) = if(set(product_prod(A,C)),aa(B,bool,aa(B,fun(B,bool),fequal(B),Uua),Uub),aa(set(product_prod(A,C)),set(product_prod(A,C)),insert2(product_prod(A,C),aa(C,product_prod(A,C),aa(A,fun(C,product_prod(A,C)),product_Pair(A,C),Uu),Uuc)),Uud),Uud) ) ).

% ATP.lambda_536
tff(fact_6259_ATP_Olambda__537,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,bool)),Uua: list(A),Uub: A,Uuc: list(A),Uud: list(A)] : ( aa(list(A),list(A),aa(list(A),fun(list(A),list(A)),aa(A,fun(list(A),fun(list(A),list(A))),aa(list(A),fun(A,fun(list(A),fun(list(A),list(A)))),aTP_Lamp_tv(fun(A,fun(A,bool)),fun(list(A),fun(A,fun(list(A),fun(list(A),list(A))))),Uu),Uua),Uub),Uuc),Uud) = quicksort_by_rel(A,Uu,aa(list(A),list(A),aa(A,fun(list(A),list(A)),cons(A),Uub),quicksort_by_rel(A,Uu,Uua,Uud)),Uuc) ) ).

% ATP.lambda_537
tff(fact_6260_ATP_Olambda__538,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,fun(B,heap_Time_Heap(A))),Uua: fun(C,C),Uub: fun(fun(B,heap_Time_Heap(A)),C),Uuc: B,Uud: fun(B,heap_Time_Heap(A))] : ( aa(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A),aa(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)),aa(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))),aa(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A)))),aTP_Lamp_vu(fun(C,fun(B,heap_Time_Heap(A))),fun(fun(C,C),fun(fun(fun(B,heap_Time_Heap(A)),C),fun(B,fun(fun(B,heap_Time_Heap(A)),heap_Time_Heap(A))))),Uu),Uua),Uub),Uuc),Uud) = aa(B,heap_Time_Heap(A),aa(C,fun(B,heap_Time_Heap(A)),Uu,aa(C,C,Uua,aa(fun(B,heap_Time_Heap(A)),C,Uub,Uud))),Uuc) ) ).

% ATP.lambda_538
tff(fact_6261_ATP_Olambda__539,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(C,fun(B,A)),Uua: fun(C,C),Uub: fun(fun(B,A),C),Uuc: B,Uud: fun(B,A)] : ( aa(fun(B,A),A,aa(B,fun(fun(B,A),A),aa(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)),aa(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A))),aTP_Lamp_vn(fun(C,fun(B,A)),fun(fun(C,C),fun(fun(fun(B,A),C),fun(B,fun(fun(B,A),A)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,A,aa(C,fun(B,A),Uu,aa(C,C,Uua,aa(fun(B,A),C,Uub,Uud))),Uuc) ) ).

% ATP.lambda_539
tff(fact_6262_ATP_Olambda__540,axiom,
    ! [A: $tType,D: $tType,C: $tType,E: $tType,B: $tType,Uu: fun(D,fun(E,C)),Uua: fun(A,D),Uub: fun(B,E),Uuc: A,Uud: B] : ( aa(B,C,aa(A,fun(B,C),aa(fun(B,E),fun(A,fun(B,C)),aa(fun(A,D),fun(fun(B,E),fun(A,fun(B,C))),aTP_Lamp_ev(fun(D,fun(E,C)),fun(fun(A,D),fun(fun(B,E),fun(A,fun(B,C)))),Uu),Uua),Uub),Uuc),Uud) = aa(E,C,aa(D,fun(E,C),Uu,aa(A,D,Uua,Uuc)),aa(B,E,Uub,Uud)) ) ).

% ATP.lambda_540
tff(fact_6263_ATP_Olambda__541,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,fun(C,A)),Uua: fun(A,fun(B,fun(C,B))),Uub: A,Uuc: B,Uud: C] : ( aa(C,product_prod(A,B),aa(B,fun(C,product_prod(A,B)),aa(A,fun(B,fun(C,product_prod(A,B))),aa(fun(A,fun(B,fun(C,B))),fun(A,fun(B,fun(C,product_prod(A,B)))),aTP_Lamp_sm(fun(A,fun(C,A)),fun(fun(A,fun(B,fun(C,B))),fun(A,fun(B,fun(C,product_prod(A,B))))),Uu),Uua),Uub),Uuc),Uud) = aa(B,product_prod(A,B),aa(A,fun(B,product_prod(A,B)),product_Pair(A,B),aa(C,A,aa(A,fun(C,A),Uu,Uub),Uud)),aa(C,B,aa(B,fun(C,B),aa(A,fun(B,fun(C,B)),Uua,Uub),Uuc),Uud)) ) ).

% ATP.lambda_541
tff(fact_6264_ATP_Olambda__542,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_eg(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uud)),Uua)),one_one(A))),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_542
tff(fact_6265_ATP_Olambda__543,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ec(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),Uua)),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uuc),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_543
tff(fact_6266_ATP_Olambda__544,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: set(product_prod(A,A)),Uuc: A,Uud: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool))),aTP_Lamp_lr(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uuc),Uu),transitive_trancl(A,Uub)))
          | ( Uuc = Uu ) )
        & ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uud),transitive_trancl(A,Uub)))
          | ( Uud = Uua ) ) ) ) ).

% ATP.lambda_544
tff(fact_6267_ATP_Olambda__545,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_ed(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),Uua)),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Uub)),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_545
tff(fact_6268_ATP_Olambda__546,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A,Uuc: A,Uud: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(A,fun(A,fun(A,bool)),aa(A,fun(A,fun(A,fun(A,bool))),aTP_Lamp_fv(set(product_prod(A,A)),fun(A,fun(A,fun(A,fun(A,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( pp(aa(set(A),bool,aa(set(A),fun(set(A),bool),ord_less_eq(set(A)),aa(set(A),set(A),insert2(A,Uua),aa(set(A),set(A),insert2(A,Uub),aa(set(A),set(A),insert2(A,Uuc),aa(set(A),set(A),insert2(A,Uud),bot_bot(set(A))))))),field2(A,Uu)))
        & ( ( ( Uua = Uuc )
            & ( Uub = Uud ) )
          | pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),bNF_We1388413361240627857o_max2(A,Uu,Uua,Uub)),bNF_We1388413361240627857o_max2(A,Uu,Uuc,Uud)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),Uu),id2(A))))
          | ( ( bNF_We1388413361240627857o_max2(A,Uu,Uua,Uub) = bNF_We1388413361240627857o_max2(A,Uu,Uuc,Uud) )
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uuc),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),Uu),id2(A)))) )
          | ( ( bNF_We1388413361240627857o_max2(A,Uu,Uua,Uub) = bNF_We1388413361240627857o_max2(A,Uu,Uuc,Uud) )
            & ( Uua = Uuc )
            & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uud),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),minus_minus(set(product_prod(A,A))),Uu),id2(A)))) ) ) ) ) ).

% ATP.lambda_546
tff(fact_6269_ATP_Olambda__547,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: set(product_prod(A,A)),Uuc: A,Uud: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(set(product_prod(A,A)),fun(A,fun(A,bool)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool))),aTP_Lamp_jg(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uuc),Uu),transitive_rtrancl(A,Uub)))
        & pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uud),transitive_rtrancl(A,Uub))) ) ) ).

% ATP.lambda_547
tff(fact_6270_ATP_Olambda__548,axiom,
    ! [A: $tType] :
      ( heap(A)
     => ! [Uu: nat,Uua: list(A),Uub: array(A),Uuc: A,Uud: array(A)] : ( aa(array(A),assn,aa(A,fun(array(A),assn),aa(array(A),fun(A,fun(array(A),assn)),aa(list(A),fun(array(A),fun(A,fun(array(A),assn))),aTP_Lamp_rs(nat,fun(list(A),fun(array(A),fun(A,fun(array(A),assn)))),Uu),Uua),Uub),Uuc),Uud) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(A,Uub,list_update(A,Uua,Uu,Uuc))),pure_assn(aa(array(A),bool,aa(array(A),fun(array(A),bool),fequal(array(A)),Uud),Uub))) ) ) ).

% ATP.lambda_548
tff(fact_6271_ATP_Olambda__549,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A,Uuc: A,Uud: A] :
      ( pp(aa(A,bool,aa(A,fun(A,bool),aa(A,fun(A,fun(A,bool)),aa(A,fun(A,fun(A,fun(A,bool))),aTP_Lamp_pm(set(product_prod(A,A)),fun(A,fun(A,fun(A,fun(A,bool)))),Uu),Uua),Uub),Uuc),Uud))
    <=> ( ( Uub = Uuc )
       => pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uua),Uud),Uu)) ) ) ).

% ATP.lambda_549
tff(fact_6272_ATP_Olambda__550,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(A,B),Uua: fun(C,B),Uub: set(A),Uuc: set(C),Uud: B] :
          ( pp(aa(B,bool,aa(set(C),fun(B,bool),aa(set(A),fun(set(C),fun(B,bool)),aa(fun(C,B),fun(set(A),fun(set(C),fun(B,bool))),aTP_Lamp_jw(fun(A,B),fun(fun(C,B),fun(set(A),fun(set(C),fun(B,bool)))),Uu),Uua),Uub),Uuc),Uud))
        <=> ? [A6: A,B6: C] :
              ( ( Uud = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,A6)),aa(C,B,Uua,B6)) )
              & pp(member(A,A6,Uub))
              & pp(member(C,B6,Uuc)) ) ) ) ).

% ATP.lambda_550
tff(fact_6273_ATP_Olambda__551,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B,Uuc: list(B),Uud: list(B),Uue: list(B)] : ( aa(list(B),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))),aa(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))),aa(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))),aa(A,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))))),aTP_Lamp_sb(fun(B,A),fun(A,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))))),Uu),Uua),Uub),Uuc),Uud),Uue) = if(product_prod(list(B),product_prod(list(B),list(B))),aa(A,bool,aa(A,fun(A,bool),ord_less(A),aa(B,A,Uu,Uub)),Uua),aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),Uuc)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Uud),Uue)),if(product_prod(list(B),product_prod(list(B),list(B))),aa(A,bool,aa(A,fun(A,bool),ord_less(A),Uua),aa(B,A,Uu,Uub)),aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),Uuc),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Uud),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),Uue))),aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),Uuc),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),Uud)),Uue)))) ) ) ).

% ATP.lambda_551
tff(fact_6274_ATP_Olambda__552,axiom,
    ! [A: $tType,B: $tType,Uu: set(product_prod(A,A)),Uua: set(product_prod(B,B)),Uub: A,Uuc: B,Uud: A,Uue: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(B,fun(A,fun(B,bool)),aa(A,fun(B,fun(A,fun(B,bool))),aa(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,bool)))),aTP_Lamp_fr(set(product_prod(A,A)),fun(set(product_prod(B,B)),fun(A,fun(B,fun(A,fun(B,bool))))),Uu),Uua),Uub),Uuc),Uud),Uue))
    <=> ( pp(member(product_prod(A,A),aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),product_Pair(A,A),Uub),Uud),Uu))
        | ( ( Uub = Uud )
          & pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uuc),Uue),Uua)) ) ) ) ).

% ATP.lambda_552
tff(fact_6275_ATP_Olambda__553,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,bool),Uua: fun(A,set(product_prod(B,B))),Uub: A,Uuc: B,Uud: A,Uue: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aa(B,fun(A,fun(B,bool)),aa(A,fun(B,fun(A,fun(B,bool))),aa(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,bool)))),aTP_Lamp_gm(fun(A,bool),fun(fun(A,set(product_prod(B,B))),fun(A,fun(B,fun(A,fun(B,bool))))),Uu),Uua),Uub),Uuc),Uud),Uue))
    <=> ( ( Uub = Uud )
        & pp(aa(A,bool,Uu,Uud))
        & pp(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uuc),Uue),aa(A,set(product_prod(B,B)),Uua,Uud))) ) ) ).

% ATP.lambda_553
tff(fact_6276_ATP_Olambda__554,axiom,
    ! [B: $tType,A: $tType,Uu: bool,Uua: A,Uub: B] :
      ( pp(aa(B,bool,aa(A,fun(B,bool),aTP_Lamp_fq(bool,fun(A,fun(B,bool)),Uu),Uua),Uub))
    <=> pp(Uu) ) ).

% ATP.lambda_554
tff(fact_6277_ATP_Olambda__555,axiom,
    ! [A: $tType,Uu: heap_Time_Heap(A),Uua: product_unit] : ( aa(product_unit,heap_Time_Heap(A),aTP_Lamp_fm(heap_Time_Heap(A),fun(product_unit,heap_Time_Heap(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_555
tff(fact_6278_ATP_Olambda__556,axiom,
    ! [B: $tType,A: $tType] :
      ( heap(B)
     => ! [Uu: heap_Time_Heap(A),Uua: B] : ( aa(B,heap_Time_Heap(A),aTP_Lamp_fu(heap_Time_Heap(A),fun(B,heap_Time_Heap(A)),Uu),Uua) = Uu ) ) ).

% ATP.lambda_556
tff(fact_6279_ATP_Olambda__557,axiom,
    ! [B: $tType,A: $tType,Uu: heap_Time_Heap(A),Uua: B] : ( aa(B,heap_Time_Heap(A),aTP_Lamp_vx(heap_Time_Heap(A),fun(B,heap_Time_Heap(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_557
tff(fact_6280_ATP_Olambda__558,axiom,
    ! [B: $tType,A: $tType,Uu: multiset(A),Uua: B] : ( aa(B,multiset(A),aTP_Lamp_jh(multiset(A),fun(B,multiset(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_558
tff(fact_6281_ATP_Olambda__559,axiom,
    ! [A: $tType,Uu: assn,Uua: A] : ( aa(A,assn,aTP_Lamp_kz(assn,fun(A,assn),Uu),Uua) = Uu ) ).

% ATP.lambda_559
tff(fact_6282_ATP_Olambda__560,axiom,
    ! [A: $tType,Uu: bool,Uua: A] :
      ( pp(aa(A,bool,aTP_Lamp_aj(bool,fun(A,bool),Uu),Uua))
    <=> pp(Uu) ) ).

% ATP.lambda_560
tff(fact_6283_ATP_Olambda__561,axiom,
    ! [C: $tType,D: $tType,Uu: set(D),Uua: C] : ( aa(C,set(D),aTP_Lamp_it(set(D),fun(C,set(D)),Uu),Uua) = Uu ) ).

% ATP.lambda_561
tff(fact_6284_ATP_Olambda__562,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: B] : ( aa(B,set(C),aTP_Lamp_jm(set(C),fun(B,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_562
tff(fact_6285_ATP_Olambda__563,axiom,
    ! [A: $tType,C: $tType,Uu: set(C),Uua: A] : ( aa(A,set(C),aTP_Lamp_jv(set(C),fun(A,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_563
tff(fact_6286_ATP_Olambda__564,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: C] : ( aa(C,set(B),aTP_Lamp_nl(set(B),fun(C,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_564
tff(fact_6287_ATP_Olambda__565,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: A] : ( aa(A,set(B),aTP_Lamp_hq(set(B),fun(A,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_565
tff(fact_6288_ATP_Olambda__566,axiom,
    ! [C: $tType,A: $tType,Uu: set(A),Uua: C] : ( aa(C,set(A),aTP_Lamp_nk(set(A),fun(C,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_566
tff(fact_6289_ATP_Olambda__567,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: B] : ( aa(B,set(A),aTP_Lamp_ho(set(A),fun(B,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_567
tff(fact_6290_ATP_Olambda__568,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] : ( aa(A,set(A),aTP_Lamp_if(set(A),fun(A,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_568
tff(fact_6291_ATP_Olambda__569,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,bool),Uua: A] : ( aa(A,fun(B,bool),aTP_Lamp_qu(fun(B,bool),fun(A,fun(B,bool)),Uu),Uua) = Uu ) ).

% ATP.lambda_569
tff(fact_6292_ATP_Olambda__570,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_tz(B,fun(C,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_570
tff(fact_6293_ATP_Olambda__571,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_qx(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_571
tff(fact_6294_ATP_Olambda__572,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_pr(B,fun(C,B),Uu),Uua) = Uu ) ).

% ATP.lambda_572
tff(fact_6295_ATP_Olambda__573,axiom,
    ! [A: $tType,B: $tType,Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_bv(B,fun(A,B),Uu),Uua) = Uu ) ).

% ATP.lambda_573
tff(fact_6296_ATP_Olambda__574,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_hm(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_574
tff(fact_6297_ATP_Olambda__575,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_hn(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_575
tff(fact_6298_ATP_Olambda__576,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_lj(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_576
tff(fact_6299_ATP_Olambda__577,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_at(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_577
tff(fact_6300_ATP_Olambda__578,axiom,
    ! [B: $tType,A: $tType,Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_as(A,fun(B,A),Uu),Uua) = Uu ) ).

% ATP.lambda_578
tff(fact_6301_ATP_Olambda__579,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_sl(A,A),Uu) = Uu ) ) ).

% ATP.lambda_579
tff(fact_6302_ATP_Olambda__580,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_bn(A,A),Uu) = Uu ) ) ).

% ATP.lambda_580
tff(fact_6303_ATP_Olambda__581,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_uv(A,A),Uu) = Uu ) ) ).

% ATP.lambda_581
tff(fact_6304_ATP_Olambda__582,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,A,aTP_Lamp_br(A,A),Uu) = Uu ) ).

% ATP.lambda_582
tff(fact_6305_ATP_Olambda__583,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,set(bool),aTP_Lamp_nr(A,set(bool)),Uu) = top_top(set(bool)) ) ).

% ATP.lambda_583
tff(fact_6306_ATP_Olambda__584,axiom,
    ! [A: $tType,B: $tType,Uu: A] : ( aa(A,set(B),aTP_Lamp_hu(A,set(B)),Uu) = top_top(set(B)) ) ).

% ATP.lambda_584
tff(fact_6307_ATP_Olambda__585,axiom,
    ! [C: $tType,D: $tType,Uu: C] : ( aa(C,set(D),aTP_Lamp_wi(C,set(D)),Uu) = bot_bot(set(D)) ) ).

% ATP.lambda_585
tff(fact_6308_ATP_Olambda__586,axiom,
    ! [C: $tType,B: $tType,Uu: C] : ( aa(C,set(B),aTP_Lamp_ck(C,set(B)),Uu) = bot_bot(set(B)) ) ).

% ATP.lambda_586
tff(fact_6309_ATP_Olambda__587,axiom,
    ! [B: $tType,A: $tType,Uu: B] : ( aa(B,set(A),aTP_Lamp_ij(B,set(A)),Uu) = bot_bot(set(A)) ) ).

% ATP.lambda_587
tff(fact_6310_ATP_Olambda__588,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_hl(B,A),Uu) = bot_bot(A) ) ) ).

% ATP.lambda_588
tff(fact_6311_ATP_Olambda__589,axiom,
    ! [A: $tType,D: $tType,Uu: A] : ( aa(A,set(D),aTP_Lamp_cl(A,set(D)),Uu) = bot_bot(set(D)) ) ).

% ATP.lambda_589
tff(fact_6312_ATP_Olambda__590,axiom,
    ! [A: $tType,B: $tType,Uu: A] : ( aa(A,set(B),aTP_Lamp_hp(A,set(B)),Uu) = bot_bot(set(B)) ) ).

% ATP.lambda_590
tff(fact_6313_ATP_Olambda__591,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_bo(A,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_591
tff(fact_6314_ATP_Olambda__592,axiom,
    ! [Uu: product_unit] : ( aa(product_unit,assn,aTP_Lamp_ft(product_unit,assn),Uu) = one_one(assn) ) ).

% ATP.lambda_592
tff(fact_6315_ATP_Olambda__593,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_ak(B,A),Uu) = one_one(A) ) ) ).

% ATP.lambda_593
tff(fact_6316_ATP_Olambda__594,axiom,
    ! [A: $tType,Uu: product_unit] : ( aa(product_unit,seq(A),aTP_Lamp_vt(product_unit,seq(A)),Uu) = empty(A) ) ).

% ATP.lambda_594
tff(fact_6317_ATP_Olambda__595,axiom,
    ! [A: $tType,Uu: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mj(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),Uu) = none(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ).

% ATP.lambda_595
tff(fact_6318_ATP_Olambda__596,axiom,
    ! [B: $tType,A: $tType,Uu: B] : ( aa(B,option(A),aTP_Lamp_of(B,option(A)),Uu) = none(A) ) ).

% ATP.lambda_596
tff(fact_6319_ATP_Olambda__597,axiom,
    ! [A: $tType,C: $tType,Uu: A] : ( aa(A,option(C),aTP_Lamp_ty(A,option(C)),Uu) = none(C) ) ).

% ATP.lambda_597
tff(fact_6320_ATP_Olambda__598,axiom,
    ! [A: $tType,B: $tType,Uu: A] : ( aa(A,option(B),aTP_Lamp_mi(A,option(B)),Uu) = none(B) ) ).

% ATP.lambda_598
tff(fact_6321_ATP_Olambda__599,axiom,
    ! [A: $tType,B: $tType,Uu: A] : ( aa(A,B,aTP_Lamp_ps(A,B),Uu) = undefined(B) ) ).

% ATP.lambda_599
tff(fact_6322_ATP_Olambda__600,axiom,
    ! [Uu: product_prod(heap_ext(product_unit),set(nat))] :
      ( pp(aa(product_prod(heap_ext(product_unit),set(nat)),bool,aTP_Lamp_af(product_prod(heap_ext(product_unit),set(nat)),bool),Uu))
    <=> $false ) ).

% ATP.lambda_600
tff(fact_6323_ATP_Olambda__601,axiom,
    ! [B: $tType,Uu: B] :
      ( pp(aa(B,bool,aTP_Lamp_vh(B,bool),Uu))
    <=> $false ) ).

% ATP.lambda_601
tff(fact_6324_ATP_Olambda__602,axiom,
    ! [A: $tType,Uu: A] :
      ( pp(aa(A,bool,aTP_Lamp_bi(A,bool),Uu))
    <=> $false ) ).

% ATP.lambda_602
tff(fact_6325_ATP_Olambda__603,axiom,
    ! [Uu: heap_ext(product_unit)] :
      ( pp(aa(heap_ext(product_unit),bool,aTP_Lamp_wc(heap_ext(product_unit),bool),Uu))
    <=> $true ) ).

% ATP.lambda_603
tff(fact_6326_ATP_Olambda__604,axiom,
    ! [A: $tType,Uu: fun(A,bool)] :
      ( pp(aa(fun(A,bool),bool,aTP_Lamp_pg(fun(A,bool),bool),Uu))
    <=> $true ) ).

% ATP.lambda_604
tff(fact_6327_ATP_Olambda__605,axiom,
    ! [D: $tType,Uu: D] :
      ( pp(aa(D,bool,aTP_Lamp_re(D,bool),Uu))
    <=> $true ) ).

% ATP.lambda_605
tff(fact_6328_ATP_Olambda__606,axiom,
    ! [C: $tType,Uu: C] :
      ( pp(aa(C,bool,aTP_Lamp_rd(C,bool),Uu))
    <=> $true ) ).

% ATP.lambda_606
tff(fact_6329_ATP_Olambda__607,axiom,
    ! [A: $tType,Uu: A] :
      ( pp(aa(A,bool,aTP_Lamp_vd(A,bool),Uu))
    <=> $true ) ).

% ATP.lambda_607

% Type constructors (840)
tff(tcon_Heap__Time__Monad_OHeap___Code__Evaluation_Oterm__of,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(heap_Time_Heap(A19)) ) ).

tff(tcon_Heap__Time__Monad_OHeap___Typerep_Otyperep,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(heap_Time_Heap(A19)) ) ).

tff(tcon_Code__Numeral_Onatural___Code__Evaluation_Oterm__of_1,axiom,
    code_term_of(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Typerep_Otyperep_2,axiom,
    typerep2(code_natural) ).

tff(tcon_Code__Numeral_Ointeger___Code__Evaluation_Oterm__of_3,axiom,
    code_term_of(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Typerep_Otyperep_4,axiom,
    typerep2(code_integer) ).

tff(tcon_Code__Evaluation_Oterm___Code__Evaluation_Oterm__of_5,axiom,
    code_term_of(code_term) ).

tff(tcon_Code__Evaluation_Oterm___Typerep_Otyperep_6,axiom,
    typerep2(code_term) ).

tff(tcon_Heap_Oheap_Oheap__ext___Code__Evaluation_Oterm__of_7,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(heap_ext(A19)) ) ).

tff(tcon_Heap_Oheap_Oheap__ext___Typerep_Otyperep_8,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(heap_ext(A19)) ) ).

tff(tcon_Product__Type_Ounit___Code__Evaluation_Oterm__of_9,axiom,
    code_term_of(product_unit) ).

tff(tcon_Product__Type_Ounit___Enum_Oenum,axiom,
    enum(product_unit) ).

tff(tcon_Product__Type_Ounit___Typerep_Otyperep_10,axiom,
    typerep2(product_unit) ).

tff(tcon_Product__Type_Oprod___Code__Evaluation_Oterm__of_11,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => code_term_of(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___Enum_Oenum_12,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( enum(A19)
        & enum(A20) )
     => enum(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___Typerep_Otyperep_13,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => typerep2(product_prod(A19,A20)) ) ).

tff(tcon_Old__Datatype_Onode___Typerep_Otyperep_14,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => typerep2(old_node(A19,A20)) ) ).

tff(tcon_Multiset_Omultiset___Code__Evaluation_Oterm__of_15,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Typerep_Otyperep_16,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(multiset(A19)) ) ).

tff(tcon_Typerep_Otyperep___Code__Evaluation_Oterm__of_17,axiom,
    code_term_of(typerep) ).

tff(tcon_Typerep_Otyperep___Typerep_Otyperep_18,axiom,
    typerep2(typerep) ).

tff(tcon_Assertions_Oassn___Typerep_Otyperep_19,axiom,
    typerep2(assn) ).

tff(tcon_Predicate_Opred___Code__Evaluation_Oterm__of_20,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(pred(A19)) ) ).

tff(tcon_Predicate_Opred___Typerep_Otyperep_21,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(pred(A19)) ) ).

tff(tcon_Predicate_Oseq___Code__Evaluation_Oterm__of_22,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(seq(A19)) ) ).

tff(tcon_Predicate_Oseq___Typerep_Otyperep_23,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(seq(A19)) ) ).

tff(tcon_Option_Ooption___Code__Evaluation_Oterm__of_24,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(option(A19)) ) ).

tff(tcon_Option_Ooption___Enum_Oenum_25,axiom,
    ! [A19: $tType] :
      ( enum(A19)
     => enum(option(A19)) ) ).

tff(tcon_Option_Ooption___Typerep_Otyperep_26,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(option(A19)) ) ).

tff(tcon_Filter_Ofilter___Code__Evaluation_Oterm__of_27,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(filter(A19)) ) ).

tff(tcon_Filter_Ofilter___Typerep_Otyperep_28,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(filter(A19)) ) ).

tff(tcon_Sum__Type_Osum___Code__Evaluation_Oterm__of_29,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => code_term_of(sum_sum(A19,A20)) ) ).

tff(tcon_Sum__Type_Osum___Enum_Oenum_30,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( enum(A19)
        & enum(A20) )
     => enum(sum_sum(A19,A20)) ) ).

tff(tcon_Sum__Type_Osum___Typerep_Otyperep_31,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => typerep2(sum_sum(A19,A20)) ) ).

tff(tcon_String_Ochar___Code__Evaluation_Oterm__of_32,axiom,
    code_term_of(char) ).

tff(tcon_String_Ochar___Enum_Oenum_33,axiom,
    enum(char) ).

tff(tcon_String_Ochar___Typerep_Otyperep_34,axiom,
    typerep2(char) ).

tff(tcon_Heap_Oarray___Code__Evaluation_Oterm__of_35,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(array(A19)) ) ).

tff(tcon_Heap_Oarray___Typerep_Otyperep_36,axiom,
    ! [A19: $tType] : typerep2(array(A19)) ).

tff(tcon_List_Olist___Code__Evaluation_Oterm__of_37,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(list(A19)) ) ).

tff(tcon_List_Olist___Typerep_Otyperep_38,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(list(A19)) ) ).

tff(tcon_Heap_Oref___Code__Evaluation_Oterm__of_39,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(ref(A19)) ) ).

tff(tcon_Heap_Oref___Typerep_Otyperep_40,axiom,
    ! [A19: $tType] : typerep2(ref(A19)) ).

tff(tcon_HOL_Obool___Code__Evaluation_Oterm__of_41,axiom,
    code_term_of(bool) ).

tff(tcon_HOL_Obool___Enum_Oenum_42,axiom,
    enum(bool) ).

tff(tcon_HOL_Obool___Typerep_Otyperep_43,axiom,
    typerep2(bool) ).

tff(tcon_Set_Oset___Code__Evaluation_Oterm__of_44,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(set(A19)) ) ).

tff(tcon_Set_Oset___Enum_Oenum_45,axiom,
    ! [A19: $tType] :
      ( enum(A19)
     => enum(set(A19)) ) ).

tff(tcon_Set_Oset___Typerep_Otyperep_46,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(set(A19)) ) ).

tff(tcon_Rat_Orat___Code__Evaluation_Oterm__of_47,axiom,
    code_term_of(rat) ).

tff(tcon_Rat_Orat___Typerep_Otyperep_48,axiom,
    typerep2(rat) ).

tff(tcon_Num_Onum___Code__Evaluation_Oterm__of_49,axiom,
    code_term_of(num) ).

tff(tcon_Num_Onum___Typerep_Otyperep_50,axiom,
    typerep2(num) ).

tff(tcon_Nat_Onat___Code__Evaluation_Oterm__of_51,axiom,
    code_term_of(nat) ).

tff(tcon_Nat_Onat___Typerep_Otyperep_52,axiom,
    typerep2(nat) ).

tff(tcon_Int_Oint___Code__Evaluation_Oterm__of_53,axiom,
    code_term_of(int) ).

tff(tcon_Int_Oint___Typerep_Otyperep_54,axiom,
    typerep2(int) ).

tff(tcon_itself___Code__Evaluation_Oterm__of_55,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(itself(A19)) ) ).

tff(tcon_itself___Typerep_Otyperep_56,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(itself(A19)) ) ).

tff(tcon_fun___Code__Evaluation_Oterm__of_57,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => code_term_of(fun(A19,A20)) ) ).

tff(tcon_fun___Enum_Oenum_58,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( enum(A19)
        & enum(A20) )
     => enum(fun(A19,A20)) ) ).

tff(tcon_fun___Typerep_Otyperep_59,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => typerep2(fun(A19,A20)) ) ).

tff(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( comple6319245703460814977attice(A20)
     => condit1219197933456340205attice(fun(A19,A20)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( comple592849572758109894attice(A20)
     => comple592849572758109894attice(fun(A19,A20)) ) ).

tff(tcon_fun___Quickcheck__Exhaustive_Ofull__exhaustive,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( cl_HOL_Oequal(A19)
        & quickc3360725361186068524ustive(A19)
        & quickc3360725361186068524ustive(A20) )
     => quickc3360725361186068524ustive(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bounded_lattice(A20)
     => bounde4967611905675639751up_bot(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bounded_lattice(A20)
     => bounde4346867609351753570nf_top(fun(A19,A20)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( comple6319245703460814977attice(A20)
     => comple6319245703460814977attice(fun(A19,A20)) ) ).

tff(tcon_fun___Quickcheck__Exhaustive_Oexhaustive,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( cl_HOL_Oequal(A19)
        & quickc658316121487927005ustive(A19)
        & quickc658316121487927005ustive(A20) )
     => quickc658316121487927005ustive(fun(A19,A20)) ) ).

tff(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A19: $tType,A20: $tType] :
      ( boolea8198339166811842893lgebra(A20)
     => boolea8198339166811842893lgebra(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice__top,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bounded_lattice(A20)
     => bounded_lattice_top(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice__bot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bounded_lattice(A20)
     => bounded_lattice_bot(fun(A19,A20)) ) ).

tff(tcon_fun___Complete__Partial__Order_Occpo,axiom,
    ! [A19: $tType,A20: $tType] :
      ( comple6319245703460814977attice(A20)
     => comple9053668089753744459l_ccpo(fun(A19,A20)) ) ).

tff(tcon_fun___Quickcheck__Random_Orandom,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( code_term_of(A19)
        & cl_HOL_Oequal(A19)
        & quickcheck_random(A20) )
     => quickcheck_random(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A19: $tType,A20: $tType] :
      ( semilattice_sup(A20)
     => semilattice_sup(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A19: $tType,A20: $tType] :
      ( semilattice_inf(A20)
     => semilattice_inf(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( distrib_lattice(A20)
     => distrib_lattice(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bounded_lattice(A20)
     => bounded_lattice(fun(A19,A20)) ) ).

tff(tcon_fun___Complete__Lattices_OSup,axiom,
    ! [A19: $tType,A20: $tType] :
      ( complete_Sup(A20)
     => complete_Sup(fun(A19,A20)) ) ).

tff(tcon_fun___Complete__Lattices_OInf,axiom,
    ! [A19: $tType,A20: $tType] :
      ( complete_Inf(A20)
     => complete_Inf(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A19: $tType,A20: $tType] :
      ( order_top(A20)
     => order_top(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( order_bot(A20)
     => order_bot(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Opreorder,axiom,
    ! [A19: $tType,A20: $tType] :
      ( preorder(A20)
     => preorder(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Olattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( lattice(A20)
     => lattice(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Oorder,axiom,
    ! [A19: $tType,A20: $tType] :
      ( order(A20)
     => order(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Otop,axiom,
    ! [A19: $tType,A20: $tType] :
      ( top(A20)
     => top(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Oord,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ord(A20)
     => ord(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Obot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bot(A20)
     => bot(fun(A19,A20)) ) ).

tff(tcon_fun___Groups_Ouminus,axiom,
    ! [A19: $tType,A20: $tType] :
      ( uminus(A20)
     => uminus(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Osup,axiom,
    ! [A19: $tType,A20: $tType] :
      ( semilattice_sup(A20)
     => sup(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Oinf,axiom,
    ! [A19: $tType,A20: $tType] :
      ( semilattice_inf(A20)
     => inf(fun(A19,A20)) ) ).

tff(tcon_fun___Groups_Ominus,axiom,
    ! [A19: $tType,A20: $tType] :
      ( minus(A20)
     => minus(fun(A19,A20)) ) ).

tff(tcon_fun___HOL_Oequal,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( enum(A19)
        & cl_HOL_Oequal(A20) )
     => cl_HOL_Oequal(fun(A19,A20)) ) ).

tff(tcon_itself___Quickcheck__Random_Orandom_60,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => quickcheck_random(itself(A19)) ) ).

tff(tcon_itself___HOL_Oequal_61,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(itself(A19)) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder(int) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_62,axiom,
    condit1219197933456340205attice(int) ).

tff(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations(int) ).

tff(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel(int) ).

tff(tcon_Int_Oint___Rings_Onormalization__semidom__multiplicative,axiom,
    normal6328177297339901930cative(int) ).

tff(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict(int) ).

tff(tcon_Int_Oint___Quickcheck__Exhaustive_Ofull__exhaustive_63,axiom,
    quickc3360725361186068524ustive(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add(int) ).

tff(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide__unit__factor,axiom,
    semido2269285787275462019factor(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict(int) ).

tff(tcon_Int_Oint___Quickcheck__Exhaustive_Oexhaustive_64,axiom,
    quickc658316121487927005ustive(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize(int) ).

tff(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add(int) ).

tff(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits(int) ).

tff(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring(int) ).

tff(tcon_Int_Oint___Rings_Onormalization__semidom,axiom,
    normal8620421768224518004emidom(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom(int) ).

tff(tcon_Int_Oint___Quickcheck__Random_Orandom_65,axiom,
    quickcheck_random(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__sup_66,axiom,
    semilattice_sup(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__inf_67,axiom,
    semilattice_inf(int) ).

tff(tcon_Int_Oint___Lattices_Odistrib__lattice_68,axiom,
    distrib_lattice(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs(int) ).

tff(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult(int) ).

tff(tcon_Int_Oint___Complete__Lattices_OSup_69,axiom,
    complete_Sup(int) ).

tff(tcon_Int_Oint___Complete__Lattices_OInf_70,axiom,
    complete_Inf(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide(int) ).

tff(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring(int) ).

tff(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0(int) ).

tff(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn(int) ).

tff(tcon_Int_Oint___Orderings_Opreorder_71,axiom,
    preorder(int) ).

tff(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0(int) ).

tff(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top(int) ).

tff(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot(int) ).

tff(tcon_Int_Oint___Lattices_Olattice_72,axiom,
    lattice(int) ).

tff(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd(int) ).

tff(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring(int) ).

tff(tcon_Int_Oint___Orderings_Oorder_73,axiom,
    order(int) ).

tff(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral(int) ).

tff(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0(int) ).

tff(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring(int) ).

tff(tcon_Int_Oint___Orderings_Oord_74,axiom,
    ord(int) ).

tff(tcon_Int_Oint___Groups_Ouminus_75,axiom,
    uminus(int) ).

tff(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1(int) ).

tff(tcon_Int_Oint___Lattices_Osup_76,axiom,
    sup(int) ).

tff(tcon_Int_Oint___Lattices_Oinf_77,axiom,
    inf(int) ).

tff(tcon_Int_Oint___Groups_Otimes,axiom,
    times(int) ).

tff(tcon_Int_Oint___Groups_Ominus_78,axiom,
    minus(int) ).

tff(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd(int) ).

tff(tcon_Int_Oint___Power_Opower,axiom,
    power(int) ).

tff(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral(int) ).

tff(tcon_Int_Oint___Groups_Ozero,axiom,
    zero(int) ).

tff(tcon_Int_Oint___Rings_Oring,axiom,
    ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom,axiom,
    idom(int) ).

tff(tcon_Int_Oint___Groups_Oone,axiom,
    one(int) ).

tff(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd(int) ).

tff(tcon_Int_Oint___Heap_Oheap,axiom,
    heap(int) ).

tff(tcon_Int_Oint___HOL_Oequal_79,axiom,
    cl_HOL_Oequal(int) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_80,axiom,
    condit6923001295902523014norder(nat) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_81,axiom,
    condit1219197933456340205attice(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_82,axiom,
    bit_un5681908812861735899ations(nat) ).

tff(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_83,axiom,
    semiri1453513574482234551roduct(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_84,axiom,
    euclid5411537665997757685th_nat(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_85,axiom,
    ordere1937475149494474687imp_le(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_86,axiom,
    euclid3128863361964157862miring(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_87,axiom,
    euclid4440199948858584721cancel(nat) ).

tff(tcon_Nat_Onat___Rings_Onormalization__semidom__multiplicative_88,axiom,
    normal6328177297339901930cative(nat) ).

tff(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_89,axiom,
    unique1627219031080169319umeral(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_90,axiom,
    semiri6575147826004484403cancel(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_91,axiom,
    strict9044650504122735259up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_92,axiom,
    ordere580206878836729694up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_93,axiom,
    ordere2412721322843649153imp_le(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_94,axiom,
    bit_se359711467146920520ations(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_95,axiom,
    linord2810124833399127020strict(nat) ).

tff(tcon_Nat_Onat___Quickcheck__Exhaustive_Ofull__exhaustive_96,axiom,
    quickc3360725361186068524ustive(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_97,axiom,
    strict7427464778891057005id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_98,axiom,
    ordere8940638589300402666id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_99,axiom,
    euclid3725896446679973847miring(nat) ).

tff(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_100,axiom,
    linord4140545234300271783up_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_101,axiom,
    linord181362715937106298miring(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide__unit__factor_102,axiom,
    semido2269285787275462019factor(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_103,axiom,
    linord8928482502909563296strict(nat) ).

tff(tcon_Nat_Onat___Quickcheck__Exhaustive_Oexhaustive_104,axiom,
    quickc658316121487927005ustive(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_105,axiom,
    semiri3467727345109120633visors(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_106,axiom,
    ordere6658533253407199908up_add(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_107,axiom,
    semiri6843258321239162965malize(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_108,axiom,
    ordere6911136660526730532id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_109,axiom,
    cancel2418104881723323429up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_110,axiom,
    cancel1802427076303600483id_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_111,axiom,
    comm_s4317794764714335236cancel(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_112,axiom,
    bit_semiring_bits(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__comm__semiring_113,axiom,
    ordere2520102378445227354miring(nat) ).

tff(tcon_Nat_Onat___Rings_Onormalization__semidom_114,axiom,
    normal8620421768224518004emidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_115,axiom,
    cancel_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring_116,axiom,
    linordered_semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring__0_117,axiom,
    ordered_semiring_0(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semidom_118,axiom,
    linordered_semidom(nat) ).

tff(tcon_Nat_Onat___Quickcheck__Random_Orandom_119,axiom,
    quickcheck_random(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__sup_120,axiom,
    semilattice_sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__inf_121,axiom,
    semilattice_inf(nat) ).

tff(tcon_Nat_Onat___Lattices_Odistrib__lattice_122,axiom,
    distrib_lattice(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__mult_123,axiom,
    ab_semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Oalgebraic__semidom_124,axiom,
    algebraic_semidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_125,axiom,
    comm_monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__add_126,axiom,
    ab_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring_127,axiom,
    ordered_semiring(nat) ).

tff(tcon_Nat_Onat___Parity_Osemiring__parity_128,axiom,
    semiring_parity(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__add_129,axiom,
    comm_monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__modulo_130,axiom,
    semiring_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1_131,axiom,
    comm_semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__0_132,axiom,
    comm_semiring_0(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__mult_133,axiom,
    semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Complete__Lattices_OSup_134,axiom,
    complete_Sup(nat) ).

tff(tcon_Nat_Onat___Complete__Lattices_OInf_135,axiom,
    complete_Inf(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__modulo_136,axiom,
    semidom_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide_137,axiom,
    semidom_divide(nat) ).

tff(tcon_Nat_Onat___Num_Osemiring__numeral_138,axiom,
    semiring_numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__add_139,axiom,
    semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__less__one_140,axiom,
    zero_less_one(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring_141,axiom,
    comm_semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder__bot_142,axiom,
    order_bot(nat) ).

tff(tcon_Nat_Onat___Nat_Osemiring__char__0_143,axiom,
    semiring_char_0(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__neq__one_144,axiom,
    zero_neq_one(nat) ).

tff(tcon_Nat_Onat___Orderings_Opreorder_145,axiom,
    preorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Olinorder_146,axiom,
    linorder(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__mult_147,axiom,
    monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__add_148,axiom,
    monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1_149,axiom,
    semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__0_150,axiom,
    semiring_0(nat) ).

tff(tcon_Nat_Onat___Orderings_Ono__top_151,axiom,
    no_top(nat) ).

tff(tcon_Nat_Onat___Lattices_Olattice_152,axiom,
    lattice(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd_153,axiom,
    semiring_gcd(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__Gcd_154,axiom,
    semiring_Gcd(nat) ).

tff(tcon_Nat_Onat___Rings_Omult__zero_155,axiom,
    mult_zero(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder_156,axiom,
    order(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring_157,axiom,
    semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Oord_158,axiom,
    ord(nat) ).

tff(tcon_Nat_Onat___Orderings_Obot_159,axiom,
    bot(nat) ).

tff(tcon_Nat_Onat___Lattices_Osup_160,axiom,
    sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Oinf_161,axiom,
    inf(nat) ).

tff(tcon_Nat_Onat___Groups_Otimes_162,axiom,
    times(nat) ).

tff(tcon_Nat_Onat___Groups_Ominus_163,axiom,
    minus(nat) ).

tff(tcon_Nat_Onat___Power_Opower_164,axiom,
    power(nat) ).

tff(tcon_Nat_Onat___Num_Onumeral_165,axiom,
    numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Ozero_166,axiom,
    zero(nat) ).

tff(tcon_Nat_Onat___Groups_Oone_167,axiom,
    one(nat) ).

tff(tcon_Nat_Onat___Rings_Odvd_168,axiom,
    dvd(nat) ).

tff(tcon_Nat_Onat___Heap_Oheap_169,axiom,
    heap(nat) ).

tff(tcon_Nat_Onat___HOL_Oequal_170,axiom,
    cl_HOL_Oequal(nat) ).

tff(tcon_Num_Onum___Quickcheck__Exhaustive_Ofull__exhaustive_171,axiom,
    quickc3360725361186068524ustive(num) ).

tff(tcon_Num_Onum___Quickcheck__Random_Orandom_172,axiom,
    quickcheck_random(num) ).

tff(tcon_Num_Onum___Orderings_Opreorder_173,axiom,
    preorder(num) ).

tff(tcon_Num_Onum___Orderings_Olinorder_174,axiom,
    linorder(num) ).

tff(tcon_Num_Onum___Orderings_Oorder_175,axiom,
    order(num) ).

tff(tcon_Num_Onum___Orderings_Oord_176,axiom,
    ord(num) ).

tff(tcon_Num_Onum___Groups_Otimes_177,axiom,
    times(num) ).

tff(tcon_Num_Onum___HOL_Oequal_178,axiom,
    cl_HOL_Oequal(num) ).

tff(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_179,axiom,
    semiri1453513574482234551roduct(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_180,axiom,
    ordere1937475149494474687imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_181,axiom,
    semiri6575147826004484403cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_182,axiom,
    strict9044650504122735259up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_183,axiom,
    ordere580206878836729694up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_184,axiom,
    ordere2412721322843649153imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_185,axiom,
    linord2810124833399127020strict(rat) ).

tff(tcon_Rat_Orat___Quickcheck__Exhaustive_Ofull__exhaustive_186,axiom,
    quickc3360725361186068524ustive(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_187,axiom,
    strict7427464778891057005id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_188,axiom,
    ordere8940638589300402666id_add(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_189,axiom,
    linord715952674999750819strict(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_190,axiom,
    linord4140545234300271783up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_191,axiom,
    linord181362715937106298miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_192,axiom,
    linord8928482502909563296strict(rat) ).

tff(tcon_Rat_Orat___Quickcheck__Exhaustive_Oexhaustive_193,axiom,
    quickc658316121487927005ustive(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_194,axiom,
    semiri3467727345109120633visors(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_195,axiom,
    ordere6658533253407199908up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_196,axiom,
    ordere166539214618696060dd_abs(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_197,axiom,
    ordere6911136660526730532id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_198,axiom,
    linord5086331880401160121up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_199,axiom,
    cancel2418104881723323429up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_200,axiom,
    ring_15535105094025558882visors(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_201,axiom,
    cancel1802427076303600483id_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring__strict_202,axiom,
    linord4710134922213307826strict(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_203,axiom,
    comm_s4317794764714335236cancel(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__comm__semiring_204,axiom,
    ordere2520102378445227354miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1_205,axiom,
    linord6961819062388156250ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add_206,axiom,
    ordered_ab_group_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_207,axiom,
    cancel_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring_208,axiom,
    linordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring__0_209,axiom,
    ordered_semiring_0(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semidom_210,axiom,
    linordered_semidom(rat) ).

tff(tcon_Rat_Orat___Quickcheck__Random_Orandom_211,axiom,
    quickcheck_random(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__sup_212,axiom,
    semilattice_sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__inf_213,axiom,
    semilattice_inf(rat) ).

tff(tcon_Rat_Orat___Lattices_Odistrib__lattice_214,axiom,
    distrib_lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__mult_215,axiom,
    ab_semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_216,axiom,
    comm_monoid_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__add_217,axiom,
    ab_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring_218,axiom,
    ordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring__abs_219,axiom,
    ordered_ring_abs(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__add_220,axiom,
    comm_monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring_221,axiom,
    linordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__idom_222,axiom,
    linordered_idom(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1_223,axiom,
    comm_semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__0_224,axiom,
    comm_semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__mult_225,axiom,
    semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom__divide_226,axiom,
    semidom_divide(rat) ).

tff(tcon_Rat_Orat___Num_Osemiring__numeral_227,axiom,
    semiring_numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__add_228,axiom,
    semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__less__one_229,axiom,
    zero_less_one(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring_230,axiom,
    comm_semiring(rat) ).

tff(tcon_Rat_Orat___Nat_Osemiring__char__0_231,axiom,
    semiring_char_0(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__group__add_232,axiom,
    ab_group_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__neq__one_233,axiom,
    zero_neq_one(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring_234,axiom,
    ordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__abs__sgn_235,axiom,
    idom_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Orderings_Opreorder_236,axiom,
    preorder(rat) ).

tff(tcon_Rat_Orat___Orderings_Olinorder_237,axiom,
    linorder(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__mult_238,axiom,
    monoid_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring__1_239,axiom,
    comm_ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__add_240,axiom,
    monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1_241,axiom,
    semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__0_242,axiom,
    semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__top_243,axiom,
    no_top(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__bot_244,axiom,
    no_bot(rat) ).

tff(tcon_Rat_Orat___Lattices_Olattice_245,axiom,
    lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Ogroup__add_246,axiom,
    group_add(rat) ).

tff(tcon_Rat_Orat___Rings_Omult__zero_247,axiom,
    mult_zero(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring_248,axiom,
    comm_ring(rat) ).

tff(tcon_Rat_Orat___Orderings_Oorder_249,axiom,
    order(rat) ).

tff(tcon_Rat_Orat___Num_Oneg__numeral_250,axiom,
    neg_numeral(rat) ).

tff(tcon_Rat_Orat___Nat_Oring__char__0_251,axiom,
    ring_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring_252,axiom,
    semiring(rat) ).

tff(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse(rat) ).

tff(tcon_Rat_Orat___Orderings_Oord_253,axiom,
    ord(rat) ).

tff(tcon_Rat_Orat___Groups_Ouminus_254,axiom,
    uminus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1_255,axiom,
    ring_1(rat) ).

tff(tcon_Rat_Orat___Lattices_Osup_256,axiom,
    sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Oinf_257,axiom,
    inf(rat) ).

tff(tcon_Rat_Orat___Groups_Otimes_258,axiom,
    times(rat) ).

tff(tcon_Rat_Orat___Groups_Ominus_259,axiom,
    minus(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield,axiom,
    field(rat) ).

tff(tcon_Rat_Orat___Power_Opower_260,axiom,
    power(rat) ).

tff(tcon_Rat_Orat___Num_Onumeral_261,axiom,
    numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Ozero_262,axiom,
    zero(rat) ).

tff(tcon_Rat_Orat___Rings_Oring_263,axiom,
    ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom_264,axiom,
    idom(rat) ).

tff(tcon_Rat_Orat___Groups_Oone_265,axiom,
    one(rat) ).

tff(tcon_Rat_Orat___Rings_Odvd_266,axiom,
    dvd(rat) ).

tff(tcon_Rat_Orat___HOL_Oequal_267,axiom,
    cl_HOL_Oequal(rat) ).

tff(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_268,axiom,
    ! [A19: $tType] : condit1219197933456340205attice(set(A19)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_269,axiom,
    ! [A19: $tType] : comple592849572758109894attice(set(A19)) ).

tff(tcon_Set_Oset___Quickcheck__Exhaustive_Ofull__exhaustive_270,axiom,
    ! [A19: $tType] :
      ( quickc3360725361186068524ustive(A19)
     => quickc3360725361186068524ustive(set(A19)) ) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_271,axiom,
    ! [A19: $tType] : bounde4967611905675639751up_bot(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_272,axiom,
    ! [A19: $tType] : bounde4346867609351753570nf_top(set(A19)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_273,axiom,
    ! [A19: $tType] : comple6319245703460814977attice(set(A19)) ).

tff(tcon_Set_Oset___Quickcheck__Exhaustive_Oexhaustive_274,axiom,
    ! [A19: $tType] :
      ( quickc658316121487927005ustive(A19)
     => quickc658316121487927005ustive(set(A19)) ) ).

tff(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_275,axiom,
    ! [A19: $tType] : boolea8198339166811842893lgebra(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice__top_276,axiom,
    ! [A19: $tType] : bounded_lattice_top(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice__bot_277,axiom,
    ! [A19: $tType] : bounded_lattice_bot(set(A19)) ).

tff(tcon_Set_Oset___Complete__Partial__Order_Occpo_278,axiom,
    ! [A19: $tType] : comple9053668089753744459l_ccpo(set(A19)) ).

tff(tcon_Set_Oset___Quickcheck__Random_Orandom_279,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(set(A19)) ) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__sup_280,axiom,
    ! [A19: $tType] : semilattice_sup(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__inf_281,axiom,
    ! [A19: $tType] : semilattice_inf(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Odistrib__lattice_282,axiom,
    ! [A19: $tType] : distrib_lattice(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice_283,axiom,
    ! [A19: $tType] : bounded_lattice(set(A19)) ).

tff(tcon_Set_Oset___Complete__Lattices_OSup_284,axiom,
    ! [A19: $tType] : complete_Sup(set(A19)) ).

tff(tcon_Set_Oset___Complete__Lattices_OInf_285,axiom,
    ! [A19: $tType] : complete_Inf(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Oorder__top_286,axiom,
    ! [A19: $tType] : order_top(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Oorder__bot_287,axiom,
    ! [A19: $tType] : order_bot(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Opreorder_288,axiom,
    ! [A19: $tType] : preorder(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Olattice_289,axiom,
    ! [A19: $tType] : lattice(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Oorder_290,axiom,
    ! [A19: $tType] : order(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Otop_291,axiom,
    ! [A19: $tType] : top(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Oord_292,axiom,
    ! [A19: $tType] : ord(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Obot_293,axiom,
    ! [A19: $tType] : bot(set(A19)) ).

tff(tcon_Set_Oset___Groups_Ouminus_294,axiom,
    ! [A19: $tType] : uminus(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Osup_295,axiom,
    ! [A19: $tType] : sup(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Oinf_296,axiom,
    ! [A19: $tType] : inf(set(A19)) ).

tff(tcon_Set_Oset___Groups_Ominus_297,axiom,
    ! [A19: $tType] : minus(set(A19)) ).

tff(tcon_Set_Oset___HOL_Oequal_298,axiom,
    ! [A19: $tType] :
      ( cl_HOL_Oequal(A19)
     => cl_HOL_Oequal(set(A19)) ) ).

tff(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_299,axiom,
    condit1219197933456340205attice(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_300,axiom,
    comple592849572758109894attice(bool) ).

tff(tcon_HOL_Obool___Quickcheck__Exhaustive_Ofull__exhaustive_301,axiom,
    quickc3360725361186068524ustive(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_302,axiom,
    bounde4967611905675639751up_bot(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_303,axiom,
    bounde4346867609351753570nf_top(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_304,axiom,
    comple6319245703460814977attice(bool) ).

tff(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_305,axiom,
    boolea8198339166811842893lgebra(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice__top_306,axiom,
    bounded_lattice_top(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_307,axiom,
    bounded_lattice_bot(bool) ).

tff(tcon_HOL_Obool___Complete__Partial__Order_Occpo_308,axiom,
    comple9053668089753744459l_ccpo(bool) ).

tff(tcon_HOL_Obool___Quickcheck__Random_Orandom_309,axiom,
    quickcheck_random(bool) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__sup_310,axiom,
    semilattice_sup(bool) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__inf_311,axiom,
    semilattice_inf(bool) ).

tff(tcon_HOL_Obool___Lattices_Odistrib__lattice_312,axiom,
    distrib_lattice(bool) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice_313,axiom,
    bounded_lattice(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_OSup_314,axiom,
    complete_Sup(bool) ).

tff(tcon_HOL_Obool___Complete__Lattices_OInf_315,axiom,
    complete_Inf(bool) ).

tff(tcon_HOL_Obool___Orderings_Oorder__top_316,axiom,
    order_top(bool) ).

tff(tcon_HOL_Obool___Orderings_Oorder__bot_317,axiom,
    order_bot(bool) ).

tff(tcon_HOL_Obool___Orderings_Opreorder_318,axiom,
    preorder(bool) ).

tff(tcon_HOL_Obool___Orderings_Olinorder_319,axiom,
    linorder(bool) ).

tff(tcon_HOL_Obool___Lattices_Olattice_320,axiom,
    lattice(bool) ).

tff(tcon_HOL_Obool___Orderings_Oorder_321,axiom,
    order(bool) ).

tff(tcon_HOL_Obool___Orderings_Otop_322,axiom,
    top(bool) ).

tff(tcon_HOL_Obool___Orderings_Oord_323,axiom,
    ord(bool) ).

tff(tcon_HOL_Obool___Orderings_Obot_324,axiom,
    bot(bool) ).

tff(tcon_HOL_Obool___Groups_Ouminus_325,axiom,
    uminus(bool) ).

tff(tcon_HOL_Obool___Lattices_Osup_326,axiom,
    sup(bool) ).

tff(tcon_HOL_Obool___Lattices_Oinf_327,axiom,
    inf(bool) ).

tff(tcon_HOL_Obool___Groups_Ominus_328,axiom,
    minus(bool) ).

tff(tcon_HOL_Obool___Heap_Oheap_329,axiom,
    heap(bool) ).

tff(tcon_HOL_Obool___HOL_Oequal_330,axiom,
    cl_HOL_Oequal(bool) ).

tff(tcon_Heap_Oref___Quickcheck__Exhaustive_Ofull__exhaustive_331,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => quickc3360725361186068524ustive(ref(A19)) ) ).

tff(tcon_Heap_Oref___Quickcheck__Random_Orandom_332,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => quickcheck_random(ref(A19)) ) ).

tff(tcon_Heap_Oref___Heap_Oheap_333,axiom,
    ! [A19: $tType] : heap(ref(A19)) ).

tff(tcon_Heap_Oref___HOL_Oequal_334,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(ref(A19)) ).

tff(tcon_List_Olist___Quickcheck__Exhaustive_Ofull__exhaustive_335,axiom,
    ! [A19: $tType] :
      ( quickc3360725361186068524ustive(A19)
     => quickc3360725361186068524ustive(list(A19)) ) ).

tff(tcon_List_Olist___Quickcheck__Random_Orandom_336,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(list(A19)) ) ).

tff(tcon_List_Olist___Heap_Oheap_337,axiom,
    ! [A19: $tType] :
      ( heap(A19)
     => heap(list(A19)) ) ).

tff(tcon_List_Olist___HOL_Oequal_338,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(list(A19)) ).

tff(tcon_Heap_Oarray___Quickcheck__Exhaustive_Ofull__exhaustive_339,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => quickc3360725361186068524ustive(array(A19)) ) ).

tff(tcon_Heap_Oarray___Quickcheck__Random_Orandom_340,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => quickcheck_random(array(A19)) ) ).

tff(tcon_Heap_Oarray___Heap_Oheap_341,axiom,
    ! [A19: $tType] : heap(array(A19)) ).

tff(tcon_Heap_Oarray___HOL_Oequal_342,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(array(A19)) ).

tff(tcon_String_Ochar___Quickcheck__Exhaustive_Ofull__exhaustive_343,axiom,
    quickc3360725361186068524ustive(char) ).

tff(tcon_String_Ochar___Quickcheck__Random_Orandom_344,axiom,
    quickcheck_random(char) ).

tff(tcon_String_Ochar___Heap_Oheap_345,axiom,
    heap(char) ).

tff(tcon_String_Ochar___HOL_Oequal_346,axiom,
    cl_HOL_Oequal(char) ).

tff(tcon_Sum__Type_Osum___Quickcheck__Exhaustive_Ofull__exhaustive_347,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( quickc3360725361186068524ustive(A19)
        & quickc3360725361186068524ustive(A20) )
     => quickc3360725361186068524ustive(sum_sum(A19,A20)) ) ).

tff(tcon_Sum__Type_Osum___Quickcheck__Random_Orandom_348,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( quickcheck_random(A19)
        & quickcheck_random(A20) )
     => quickcheck_random(sum_sum(A19,A20)) ) ).

tff(tcon_Sum__Type_Osum___Heap_Oheap_349,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( heap(A19)
        & heap(A20) )
     => heap(sum_sum(A19,A20)) ) ).

tff(tcon_Sum__Type_Osum___HOL_Oequal_350,axiom,
    ! [A19: $tType,A20: $tType] : cl_HOL_Oequal(sum_sum(A19,A20)) ).

tff(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_351,axiom,
    ! [A19: $tType] : condit1219197933456340205attice(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_352,axiom,
    ! [A19: $tType] : bounde4967611905675639751up_bot(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_353,axiom,
    ! [A19: $tType] : bounde4346867609351753570nf_top(filter(A19)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_354,axiom,
    ! [A19: $tType] : comple6319245703460814977attice(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice__top_355,axiom,
    ! [A19: $tType] : bounded_lattice_top(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice__bot_356,axiom,
    ! [A19: $tType] : bounded_lattice_bot(filter(A19)) ).

tff(tcon_Filter_Ofilter___Complete__Partial__Order_Occpo_357,axiom,
    ! [A19: $tType] : comple9053668089753744459l_ccpo(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_358,axiom,
    ! [A19: $tType] : semilattice_sup(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_359,axiom,
    ! [A19: $tType] : semilattice_inf(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_360,axiom,
    ! [A19: $tType] : distrib_lattice(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice_361,axiom,
    ! [A19: $tType] : bounded_lattice(filter(A19)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_OSup_362,axiom,
    ! [A19: $tType] : complete_Sup(filter(A19)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_OInf_363,axiom,
    ! [A19: $tType] : complete_Inf(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__top_364,axiom,
    ! [A19: $tType] : order_top(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__bot_365,axiom,
    ! [A19: $tType] : order_bot(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Opreorder_366,axiom,
    ! [A19: $tType] : preorder(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Olattice_367,axiom,
    ! [A19: $tType] : lattice(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder_368,axiom,
    ! [A19: $tType] : order(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Otop_369,axiom,
    ! [A19: $tType] : top(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Oord_370,axiom,
    ! [A19: $tType] : ord(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Obot_371,axiom,
    ! [A19: $tType] : bot(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Osup_372,axiom,
    ! [A19: $tType] : sup(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Oinf_373,axiom,
    ! [A19: $tType] : inf(filter(A19)) ).

tff(tcon_Filter_Ofilter___HOL_Oequal_374,axiom,
    ! [A19: $tType] :
      ( cl_HOL_Oequal(A19)
     => cl_HOL_Oequal(filter(A19)) ) ).

tff(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_375,axiom,
    ! [A19: $tType] :
      ( comple5582772986160207858norder(A19)
     => condit6923001295902523014norder(option(A19)) ) ).

tff(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_376,axiom,
    ! [A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => condit1219197933456340205attice(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__distrib__lattice_377,axiom,
    ! [A19: $tType] :
      ( comple592849572758109894attice(A19)
     => comple592849572758109894attice(option(A19)) ) ).

tff(tcon_Option_Ooption___Quickcheck__Exhaustive_Ofull__exhaustive_378,axiom,
    ! [A19: $tType] :
      ( quickc3360725361186068524ustive(A19)
     => quickc3360725361186068524ustive(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__semilattice__sup__bot_379,axiom,
    ! [A19: $tType] :
      ( lattice(A19)
     => bounde4967611905675639751up_bot(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__semilattice__inf__top_380,axiom,
    ! [A19: $tType] :
      ( bounded_lattice_top(A19)
     => bounde4346867609351753570nf_top(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__linorder,axiom,
    ! [A19: $tType] :
      ( comple5582772986160207858norder(A19)
     => comple5582772986160207858norder(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__lattice_381,axiom,
    ! [A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => comple6319245703460814977attice(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice__top_382,axiom,
    ! [A19: $tType] :
      ( bounded_lattice_top(A19)
     => bounded_lattice_top(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice__bot_383,axiom,
    ! [A19: $tType] :
      ( lattice(A19)
     => bounded_lattice_bot(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Partial__Order_Occpo_384,axiom,
    ! [A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => comple9053668089753744459l_ccpo(option(A19)) ) ).

tff(tcon_Option_Ooption___Quickcheck__Random_Orandom_385,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Osemilattice__sup_386,axiom,
    ! [A19: $tType] :
      ( semilattice_sup(A19)
     => semilattice_sup(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Osemilattice__inf_387,axiom,
    ! [A19: $tType] :
      ( semilattice_inf(A19)
     => semilattice_inf(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Odistrib__lattice_388,axiom,
    ! [A19: $tType] :
      ( distrib_lattice(A19)
     => distrib_lattice(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice_389,axiom,
    ! [A19: $tType] :
      ( bounded_lattice_top(A19)
     => bounded_lattice(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_OSup_390,axiom,
    ! [A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => complete_Sup(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_OInf_391,axiom,
    ! [A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => complete_Inf(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Owellorder_392,axiom,
    ! [A19: $tType] :
      ( wellorder(A19)
     => wellorder(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder__top_393,axiom,
    ! [A19: $tType] :
      ( order_top(A19)
     => order_top(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder__bot_394,axiom,
    ! [A19: $tType] :
      ( order(A19)
     => order_bot(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Opreorder_395,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => preorder(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Olinorder_396,axiom,
    ! [A19: $tType] :
      ( linorder(A19)
     => linorder(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Olattice_397,axiom,
    ! [A19: $tType] :
      ( lattice(A19)
     => lattice(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder_398,axiom,
    ! [A19: $tType] :
      ( order(A19)
     => order(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Otop_399,axiom,
    ! [A19: $tType] :
      ( order_top(A19)
     => top(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Oord_400,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => ord(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Obot_401,axiom,
    ! [A19: $tType] :
      ( order(A19)
     => bot(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Osup_402,axiom,
    ! [A19: $tType] :
      ( sup(A19)
     => sup(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Oinf_403,axiom,
    ! [A19: $tType] :
      ( inf(A19)
     => inf(option(A19)) ) ).

tff(tcon_Option_Ooption___Heap_Oheap_404,axiom,
    ! [A19: $tType] :
      ( heap(A19)
     => heap(option(A19)) ) ).

tff(tcon_Option_Ooption___HOL_Oequal_405,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(option(A19)) ).

tff(tcon_Predicate_Oseq___HOL_Oequal_406,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(seq(A19)) ).

tff(tcon_Predicate_Opred___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_407,axiom,
    ! [A19: $tType] : condit1219197933456340205attice(pred(A19)) ).

tff(tcon_Predicate_Opred___Complete__Lattices_Ocomplete__distrib__lattice_408,axiom,
    ! [A19: $tType] : comple592849572758109894attice(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Obounded__semilattice__sup__bot_409,axiom,
    ! [A19: $tType] : bounde4967611905675639751up_bot(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Obounded__semilattice__inf__top_410,axiom,
    ! [A19: $tType] : bounde4346867609351753570nf_top(pred(A19)) ).

tff(tcon_Predicate_Opred___Complete__Lattices_Ocomplete__lattice_411,axiom,
    ! [A19: $tType] : comple6319245703460814977attice(pred(A19)) ).

tff(tcon_Predicate_Opred___Boolean__Algebras_Oboolean__algebra_412,axiom,
    ! [A19: $tType] : boolea8198339166811842893lgebra(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Obounded__lattice__top_413,axiom,
    ! [A19: $tType] : bounded_lattice_top(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Obounded__lattice__bot_414,axiom,
    ! [A19: $tType] : bounded_lattice_bot(pred(A19)) ).

tff(tcon_Predicate_Opred___Complete__Partial__Order_Occpo_415,axiom,
    ! [A19: $tType] : comple9053668089753744459l_ccpo(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Osemilattice__sup_416,axiom,
    ! [A19: $tType] : semilattice_sup(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Osemilattice__inf_417,axiom,
    ! [A19: $tType] : semilattice_inf(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Odistrib__lattice_418,axiom,
    ! [A19: $tType] : distrib_lattice(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Obounded__lattice_419,axiom,
    ! [A19: $tType] : bounded_lattice(pred(A19)) ).

tff(tcon_Predicate_Opred___Complete__Lattices_OSup_420,axiom,
    ! [A19: $tType] : complete_Sup(pred(A19)) ).

tff(tcon_Predicate_Opred___Complete__Lattices_OInf_421,axiom,
    ! [A19: $tType] : complete_Inf(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Oorder__top_422,axiom,
    ! [A19: $tType] : order_top(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Oorder__bot_423,axiom,
    ! [A19: $tType] : order_bot(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Opreorder_424,axiom,
    ! [A19: $tType] : preorder(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Olattice_425,axiom,
    ! [A19: $tType] : lattice(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Oorder_426,axiom,
    ! [A19: $tType] : order(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Otop_427,axiom,
    ! [A19: $tType] : top(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Oord_428,axiom,
    ! [A19: $tType] : ord(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Obot_429,axiom,
    ! [A19: $tType] : bot(pred(A19)) ).

tff(tcon_Predicate_Opred___Groups_Ouminus_430,axiom,
    ! [A19: $tType] : uminus(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Osup_431,axiom,
    ! [A19: $tType] : sup(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Oinf_432,axiom,
    ! [A19: $tType] : inf(pred(A19)) ).

tff(tcon_Predicate_Opred___Groups_Ominus_433,axiom,
    ! [A19: $tType] : minus(pred(A19)) ).

tff(tcon_Predicate_Opred___HOL_Oequal_434,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(pred(A19)) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__sup__bot_435,axiom,
    bounde4967611905675639751up_bot(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__inf__top_436,axiom,
    bounde4346867609351753570nf_top(assn) ).

tff(tcon_Assertions_Oassn___Boolean__Algebras_Oboolean__algebra_437,axiom,
    boolea8198339166811842893lgebra(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice__top_438,axiom,
    bounded_lattice_top(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice__bot_439,axiom,
    bounded_lattice_bot(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osemilattice__sup_440,axiom,
    semilattice_sup(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osemilattice__inf_441,axiom,
    semilattice_inf(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Odistrib__lattice_442,axiom,
    distrib_lattice(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice_443,axiom,
    bounded_lattice(assn) ).

tff(tcon_Assertions_Oassn___Groups_Oab__semigroup__mult_444,axiom,
    ab_semigroup_mult(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ocomm__monoid__mult_445,axiom,
    comm_monoid_mult(assn) ).

tff(tcon_Assertions_Oassn___Groups_Osemigroup__mult_446,axiom,
    semigroup_mult(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder__top_447,axiom,
    order_top(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder__bot_448,axiom,
    order_bot(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Opreorder_449,axiom,
    preorder(assn) ).

tff(tcon_Assertions_Oassn___Groups_Omonoid__mult_450,axiom,
    monoid_mult(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Olattice_451,axiom,
    lattice(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder_452,axiom,
    order(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Otop_453,axiom,
    top(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oord_454,axiom,
    ord(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Obot_455,axiom,
    bot(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ouminus_456,axiom,
    uminus(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osup_457,axiom,
    sup(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Oinf_458,axiom,
    inf(assn) ).

tff(tcon_Assertions_Oassn___Groups_Otimes_459,axiom,
    times(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ominus_460,axiom,
    minus(assn) ).

tff(tcon_Assertions_Oassn___Power_Opower_461,axiom,
    power(assn) ).

tff(tcon_Assertions_Oassn___Groups_Oone_462,axiom,
    one(assn) ).

tff(tcon_Assertions_Oassn___Rings_Odvd_463,axiom,
    dvd(assn) ).

tff(tcon_Typerep_Otyperep___Heap_Oheap_464,axiom,
    heap(typerep) ).

tff(tcon_Typerep_Otyperep___HOL_Oequal_465,axiom,
    cl_HOL_Oequal(typerep) ).

tff(tcon_Multiset_Omultiset___Quickcheck__Exhaustive_Ofull__exhaustive_466,axiom,
    ! [A19: $tType] :
      ( quickc3360725361186068524ustive(A19)
     => quickc3360725361186068524ustive(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Oordered__ab__semigroup__add_467,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => ordere6658533253407199908up_add(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__ab__semigroup__add_468,axiom,
    ! [A19: $tType] : cancel2418104881723323429up_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__comm__monoid__add_469,axiom,
    ! [A19: $tType] : cancel1802427076303600483id_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__semigroup__add_470,axiom,
    ! [A19: $tType] : cancel_semigroup_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Quickcheck__Random_Orandom_471,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__diff_472,axiom,
    ! [A19: $tType] : comm_monoid_diff(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Oab__semigroup__add_473,axiom,
    ! [A19: $tType] : ab_semigroup_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__add_474,axiom,
    ! [A19: $tType] : comm_monoid_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Complete__Lattices_OSup_475,axiom,
    ! [A19: $tType] : complete_Sup(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Complete__Lattices_OInf_476,axiom,
    ! [A19: $tType] : complete_Inf(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Osemigroup__add_477,axiom,
    ! [A19: $tType] : semigroup_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Orderings_Opreorder_478,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => preorder(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Omonoid__add_479,axiom,
    ! [A19: $tType] : monoid_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Orderings_Oorder_480,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => order(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Orderings_Oord_481,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => ord(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Ominus_482,axiom,
    ! [A19: $tType] : minus(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Ozero_483,axiom,
    ! [A19: $tType] : zero(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___HOL_Oequal_484,axiom,
    ! [A19: $tType] :
      ( cl_HOL_Oequal(A19)
     => cl_HOL_Oequal(multiset(A19)) ) ).

tff(tcon_Product__Type_Oprod___Quickcheck__Exhaustive_Ofull__exhaustive_485,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( quickc3360725361186068524ustive(A19)
        & quickc3360725361186068524ustive(A20) )
     => quickc3360725361186068524ustive(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___Quickcheck__Exhaustive_Oexhaustive_486,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( quickc658316121487927005ustive(A19)
        & quickc658316121487927005ustive(A20) )
     => quickc658316121487927005ustive(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___Quickcheck__Random_Orandom_487,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( quickcheck_random(A19)
        & quickcheck_random(A20) )
     => quickcheck_random(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___Heap_Oheap_488,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( heap(A19)
        & heap(A20) )
     => heap(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___HOL_Oequal_489,axiom,
    ! [A19: $tType,A20: $tType] : cl_HOL_Oequal(product_prod(A19,A20)) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_490,axiom,
    condit6923001295902523014norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_491,axiom,
    condit1219197933456340205attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_492,axiom,
    comple592849572758109894attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Quickcheck__Exhaustive_Ofull__exhaustive_493,axiom,
    quickc3360725361186068524ustive(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_494,axiom,
    bounde4967611905675639751up_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_495,axiom,
    bounde4346867609351753570nf_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_496,axiom,
    comple5582772986160207858norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_497,axiom,
    comple6319245703460814977attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_498,axiom,
    boolea8198339166811842893lgebra(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__top_499,axiom,
    bounded_lattice_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__bot_500,axiom,
    bounded_lattice_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Partial__Order_Occpo_501,axiom,
    comple9053668089753744459l_ccpo(product_unit) ).

tff(tcon_Product__Type_Ounit___Quickcheck__Random_Orandom_502,axiom,
    quickcheck_random(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_503,axiom,
    semilattice_sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_504,axiom,
    semilattice_inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Odistrib__lattice_505,axiom,
    distrib_lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice_506,axiom,
    bounded_lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_OSup_507,axiom,
    complete_Sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_OInf_508,axiom,
    complete_Inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Owellorder_509,axiom,
    wellorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__top_510,axiom,
    order_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__bot_511,axiom,
    order_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Opreorder_512,axiom,
    preorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Olinorder_513,axiom,
    linorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Olattice_514,axiom,
    lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder_515,axiom,
    order(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Otop_516,axiom,
    top(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oord_517,axiom,
    ord(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Obot_518,axiom,
    bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ouminus_519,axiom,
    uminus(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osup_520,axiom,
    sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Oinf_521,axiom,
    inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ominus_522,axiom,
    minus(product_unit) ).

tff(tcon_Product__Type_Ounit___Heap_Oheap_523,axiom,
    heap(product_unit) ).

tff(tcon_Product__Type_Ounit___HOL_Oequal_524,axiom,
    cl_HOL_Oequal(product_unit) ).

tff(tcon_Heap_Oheap_Oheap__ext___Quickcheck__Random_Orandom_525,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(heap_ext(A19)) ) ).

tff(tcon_Heap_Oheap_Oheap__ext___HOL_Oequal_526,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(heap_ext(A19)) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_527,axiom,
    bit_un5681908812861735899ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_528,axiom,
    semiri1453513574482234551roduct(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_529,axiom,
    euclid5411537665997757685th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_530,axiom,
    euclid8789492081693882211th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_531,axiom,
    ordere1937475149494474687imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_532,axiom,
    euclid3128863361964157862miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_533,axiom,
    euclid4440199948858584721cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_534,axiom,
    unique1627219031080169319umeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_535,axiom,
    euclid8851590272496341667cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_536,axiom,
    semiri6575147826004484403cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_537,axiom,
    strict9044650504122735259up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_538,axiom,
    ordere580206878836729694up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_539,axiom,
    ordere2412721322843649153imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_540,axiom,
    bit_se359711467146920520ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_541,axiom,
    linord2810124833399127020strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Quickcheck__Exhaustive_Ofull__exhaustive_542,axiom,
    quickc3360725361186068524ustive(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_543,axiom,
    strict7427464778891057005id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_544,axiom,
    ordere8940638589300402666id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_545,axiom,
    euclid3725896446679973847miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_546,axiom,
    linord715952674999750819strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_547,axiom,
    linord4140545234300271783up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_548,axiom,
    bit_ri3973907225187159222ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_549,axiom,
    linord181362715937106298miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_550,axiom,
    linord8928482502909563296strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Quickcheck__Exhaustive_Oexhaustive_551,axiom,
    quickc658316121487927005ustive(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_552,axiom,
    semiri3467727345109120633visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_553,axiom,
    ordere6658533253407199908up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_554,axiom,
    ordere166539214618696060dd_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_555,axiom,
    ordere6911136660526730532id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_556,axiom,
    linord5086331880401160121up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_557,axiom,
    cancel2418104881723323429up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_558,axiom,
    ring_15535105094025558882visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_559,axiom,
    cancel1802427076303600483id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_560,axiom,
    linord4710134922213307826strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_561,axiom,
    comm_s4317794764714335236cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_562,axiom,
    bit_semiring_bits(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_563,axiom,
    ordere2520102378445227354miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_564,axiom,
    linord6961819062388156250ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_565,axiom,
    ordered_ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_566,axiom,
    cancel_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_567,axiom,
    linordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_568,axiom,
    ordered_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_569,axiom,
    linordered_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Quickcheck__Random_Orandom_570,axiom,
    quickcheck_random(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_571,axiom,
    ab_semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_572,axiom,
    algebraic_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_573,axiom,
    comm_monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_574,axiom,
    ab_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_575,axiom,
    ordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_576,axiom,
    ordered_ring_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_577,axiom,
    semiring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_578,axiom,
    comm_monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_579,axiom,
    semiring_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_580,axiom,
    linordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_581,axiom,
    linordered_idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_582,axiom,
    comm_semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_583,axiom,
    comm_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_584,axiom,
    semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_585,axiom,
    semidom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_586,axiom,
    semidom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_587,axiom,
    semiring_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_588,axiom,
    semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_589,axiom,
    zero_less_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_590,axiom,
    comm_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_591,axiom,
    semiring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_592,axiom,
    ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_593,axiom,
    zero_neq_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_594,axiom,
    ordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_595,axiom,
    idom_abs_sgn(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_596,axiom,
    preorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_597,axiom,
    linorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_598,axiom,
    monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_599,axiom,
    comm_ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_600,axiom,
    monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_601,axiom,
    semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_602,axiom,
    semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_603,axiom,
    group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_604,axiom,
    mult_zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_605,axiom,
    comm_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oorder_606,axiom,
    order(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_607,axiom,
    neg_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_608,axiom,
    ring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring_609,axiom,
    semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oord_610,axiom,
    ord(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ouminus_611,axiom,
    uminus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1_612,axiom,
    ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Otimes_613,axiom,
    times(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ominus_614,axiom,
    minus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Power_Opower_615,axiom,
    power(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Onumeral_616,axiom,
    numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ozero_617,axiom,
    zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring_618,axiom,
    ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom_619,axiom,
    idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oone_620,axiom,
    one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Odvd_621,axiom,
    dvd(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___HOL_Oequal_622,axiom,
    cl_HOL_Oequal(code_integer) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_623,axiom,
    bit_un5681908812861735899ations(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring__with__nat_624,axiom,
    euclid5411537665997757685th_nat(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__monoid__add__imp__le_625,axiom,
    ordere1937475149494474687imp_le(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring_626,axiom,
    euclid3128863361964157862miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring__cancel_627,axiom,
    euclid4440199948858584721cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors__cancel_628,axiom,
    semiri6575147826004484403cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__ab__semigroup__add_629,axiom,
    strict9044650504122735259up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__ab__semigroup__add_630,axiom,
    ordere580206878836729694up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add__imp__le_631,axiom,
    ordere2412721322843649153imp_le(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bit__operations_632,axiom,
    bit_se359711467146920520ations(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__comm__semiring__strict_633,axiom,
    linord2810124833399127020strict(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Quickcheck__Exhaustive_Ofull__exhaustive_634,axiom,
    quickc3360725361186068524ustive(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__comm__monoid__add_635,axiom,
    strict7427464778891057005id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__comm__monoid__add_636,axiom,
    ordere8940638589300402666id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring_637,axiom,
    euclid3725896446679973847miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Olinordered__ab__semigroup__add_638,axiom,
    linord4140545234300271783up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__nonzero__semiring_639,axiom,
    linord181362715937106298miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring__strict_640,axiom,
    linord8928482502909563296strict(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Quickcheck__Exhaustive_Oexhaustive_641,axiom,
    quickc658316121487927005ustive(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors_642,axiom,
    semiri3467727345109120633visors(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_643,axiom,
    ordere6658533253407199908up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__comm__monoid__add_644,axiom,
    ordere6911136660526730532id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__ab__semigroup__add_645,axiom,
    cancel2418104881723323429up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_646,axiom,
    cancel1802427076303600483id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1__cancel_647,axiom,
    comm_s4317794764714335236cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bits_648,axiom,
    bit_semiring_bits(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__comm__semiring_649,axiom,
    ordere2520102378445227354miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_650,axiom,
    cancel_semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring_651,axiom,
    linordered_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring__0_652,axiom,
    ordered_semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semidom_653,axiom,
    linordered_semidom(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Quickcheck__Random_Orandom_654,axiom,
    quickcheck_random(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__mult_655,axiom,
    ab_semigroup_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oalgebraic__semidom_656,axiom,
    algebraic_semidom(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__mult_657,axiom,
    comm_monoid_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__diff_658,axiom,
    comm_monoid_diff(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_659,axiom,
    ab_semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring_660,axiom,
    ordered_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Parity_Osemiring__parity_661,axiom,
    semiring_parity(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_662,axiom,
    comm_monoid_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__modulo_663,axiom,
    semiring_modulo(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_664,axiom,
    comm_semiring_1(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__0_665,axiom,
    comm_semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Osemigroup__mult_666,axiom,
    semigroup_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemidom__modulo_667,axiom,
    semidom_modulo(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemidom__divide_668,axiom,
    semidom_divide(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Num_Osemiring__numeral_669,axiom,
    semiring_numeral(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_670,axiom,
    semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ozero__less__one_671,axiom,
    zero_less_one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring_672,axiom,
    comm_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Nat_Osemiring__char__0_673,axiom,
    semiring_char_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ozero__neq__one_674,axiom,
    zero_neq_one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Opreorder_675,axiom,
    preorder(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Olinorder_676,axiom,
    linorder(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Omonoid__mult_677,axiom,
    monoid_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_678,axiom,
    monoid_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_679,axiom,
    semiring_1(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__0_680,axiom,
    semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Omult__zero_681,axiom,
    mult_zero(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Oorder_682,axiom,
    order(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring_683,axiom,
    semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Oord_684,axiom,
    ord(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Otimes_685,axiom,
    times(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ominus_686,axiom,
    minus(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Power_Opower_687,axiom,
    power(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Num_Onumeral_688,axiom,
    numeral(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ozero_689,axiom,
    zero(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oone_690,axiom,
    one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Odvd_691,axiom,
    dvd(code_natural) ).

tff(tcon_Code__Numeral_Onatural___HOL_Oequal_692,axiom,
    cl_HOL_Oequal(code_natural) ).

tff(tcon_Heap__Time__Monad_OHeap___Quickcheck__Random_Orandom_693,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(heap_Time_Heap(A19)) ) ).

tff(tcon_Heap__Time__Monad_OHeap___HOL_Oequal_694,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(heap_Time_Heap(A19)) ).

% Helper facts (16)
tff(help_If_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] : ( if(A,fFalse,X,Y) = Y ) ).

tff(help_If_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] : ( if(A,fTrue,X,Y) = X ) ).

tff(help_fNot_2_1_U,axiom,
    ! [P: bool] :
      ( pp(P)
      | pp(aa(bool,bool,fNot,P)) ) ).

tff(help_fNot_1_1_U,axiom,
    ! [P: bool] :
      ( ~ pp(aa(bool,bool,fNot,P))
      | ~ pp(P) ) ).

tff(help_fTrue_1_1_U,axiom,
    pp(fTrue) ).

tff(help_fconj_3_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(fconj(P,Q))
      | pp(Q) ) ).

tff(help_fconj_2_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(fconj(P,Q))
      | pp(P) ) ).

tff(help_fconj_1_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(P)
      | ~ pp(Q)
      | pp(fconj(P,Q)) ) ).

tff(help_fdisj_3_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(fdisj(P,Q))
      | pp(P)
      | pp(Q) ) ).

tff(help_fdisj_2_1_U,axiom,
    ! [Q: bool,P: bool] :
      ( ~ pp(Q)
      | pp(fdisj(P,Q)) ) ).

tff(help_fdisj_1_1_U,axiom,
    ! [P: bool,Q: bool] :
      ( ~ pp(P)
      | pp(fdisj(P,Q)) ) ).

tff(help_fFalse_1_1_T,axiom,
    ! [P: bool] :
      ( ( P = fTrue )
      | ( P = fFalse ) ) ).

tff(help_fFalse_1_1_U,axiom,
    ~ pp(fFalse) ).

tff(help_fequal_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( X != Y )
      | pp(aa(A,bool,aa(A,fun(A,bool),fequal(A),X),Y)) ) ).

tff(help_fequal_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ~ pp(aa(A,bool,aa(A,fun(A,bool),fequal(A),X),Y))
      | ( X = Y ) ) ).

tff(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: fun(A,bool)] : ( aa(A,bool,P,fChoice(A,P)) = aa(fun(A,bool),bool,fEx(A),P) ) ).

% Conjectures (1)
tff(conj_0,conjecture,
    hoare_hoare_triple(a,p,if(heap_Time_Heap(a),b,f,g),q) ).

%------------------------------------------------------------------------------
