%------------------------------------------------------------------------------
% File     : VBT00010_4 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem Hoare_Triple 00469_013750
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0025_Hoare_Triple_00469_013750 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 8750 (2862 unt;1574 typ;   0 def)
%            Number of atoms       : 14547 (5963 equ)
%            Maximal formula atoms :   28 (   2 avg)
%            Number of connectives : 13392 (1753   ~; 184   |; 958   &)
%                                         (1239 <=>;9258  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   31 (   6 avg)
%            Maximal term depth    :   37 (   2 avg)
%            Number of FOOLs       :  579 ( 381 fml; 198 var)
%            Number of X terms     :  346 (   0  []; 331 ite;  15 let)
%            Number of types       :   15 (  14 usr)
%            Number of type conns  : 1549 (1081   >; 468   *;   0   +;   0  <<)
%            Number of predicates  :  310 ( 307 usr;   3 prp; 0-7 aty)
%            Number of functors    : 1262 (1262 usr;  77 con; 0-8 aty)
%            Number of variables   : 27829 (25201   !; 341   ?;27829   :)
%                                         (2287  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TX1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 15:43:34.810
%------------------------------------------------------------------------------
% Could-be-implicit typings (30)
tff(ty_t_Heap__Time__Monad_OHeap,type,
    heap_Time_Heap: $tType > $tType ).

tff(ty_t_Code__Numeral_Onatural,type,
    code_natural: $tType ).

tff(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

tff(ty_t_Code__Evaluation_Oterm,type,
    code_term: $tType ).

tff(ty_t_Heap_Oheap_Oheap__ext,type,
    heap_ext: $tType > $tType ).

tff(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

tff(ty_t_Product__Type_Oprod,type,
    product_prod: ( $tType * $tType ) > $tType ).

tff(ty_t_Old__Datatype_Onode,type,
    old_node: ( $tType * $tType ) > $tType ).

tff(ty_t_Multiset_Omultiset,type,
    multiset: $tType > $tType ).

tff(ty_t_Typerep_Otyperep,type,
    typerep: $tType ).

tff(ty_t_Assertions_Oassn,type,
    assn: $tType ).

tff(ty_t_Predicate_Opred,type,
    pred: $tType > $tType ).

tff(ty_t_Sum__Type_Osum,type,
    sum_sum: ( $tType * $tType ) > $tType ).

tff(ty_t_Predicate_Oseq,type,
    seq: $tType > $tType ).

tff(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

tff(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

tff(ty_t_String_Ochar,type,
    char: $tType ).

tff(ty_t_Heap_Oarray,type,
    array: $tType > $tType ).

tff(ty_t_List_Olist,type,
    list: $tType > $tType ).

tff(ty_t_Heap_Oref,type,
    ref: $tType > $tType ).

tff(ty_t_Set_Oset,type,
    set: $tType > $tType ).

tff(ty_t_Rat_Orat,type,
    rat: $tType ).

tff(ty_t_Num_Onum,type,
    num: $tType ).

tff(ty_t_Nat_Onat,type,
    nat: $tType ).

tff(ty_t_Int_Oint,type,
    int: $tType ).

tff(ty_t_itself,type,
    itself: $tType > $tType ).

tff(ty_t_fun,type,
    fun: ( $tType * $tType ) > $tType ).

tff(ty_tf_c,type,
    c: $tType ).

tff(ty_tf_b,type,
    b: $tType ).

tff(ty_tf_a,type,
    a: $tType ).

% Explicit typings (1544)
tff(sy_cl_Typerep_Otyperep,type,
    typerep2: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Oenum,type,
    enum: 
      !>[A: $tType] : $o ).

tff(sy_cl_Code__Evaluation_Oterm__of,type,
    code_term_of: 
      !>[A: $tType] : $o ).

tff(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

tff(sy_cl_HOL_Oequal,type,
    cl_HOL_Oequal: 
      !>[A: $tType] : $o ).

tff(sy_cl_Heap_Oheap,type,
    heap: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Otimes,type,
    times: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Oinf,type,
    inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osup,type,
    sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Obot,type,
    bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Otop,type,
    top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__lattice,type,
    finite_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_OInf,type,
    complete_Inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_OSup,type,
    complete_Sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Quickcheck__Random_Orandom,type,
    quickcheck_random: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Partial__Order_Occpo,type,
    comple9053668089753744459l_ccpo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Onormalization__semidom,type,
    normal8620421768224518004emidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice__bot,type,
    bounded_lattice_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__lattice__top,type,
    bounded_lattice_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Quickcheck__Exhaustive_Oexhaustive,type,
    quickc658316121487927005ustive: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide__unit__factor,type,
    semido2269285787275462019factor: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Quickcheck__Exhaustive_Ofull__exhaustive,type,
    quickc3360725361186068524ustive: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Onormalization__semidom__multiplicative,type,
    normal6328177297339901930cative: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

tff(sy_c_ATP_058Lamp__a____,type,
    aTP_Lamp_a: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aa____,type,
    aTP_Lamp_aa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ab____,type,
    aTP_Lamp_ab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ac____,type,
    aTP_Lamp_ac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ad____,type,
    aTP_Lamp_ad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ae____,type,
    aTP_Lamp_ae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__af____,type,
    aTP_Lamp_af: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ag____,type,
    aTP_Lamp_ag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ah____,type,
    aTP_Lamp_ah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ai____,type,
    aTP_Lamp_ai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aj____,type,
    aTP_Lamp_aj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ak____,type,
    aTP_Lamp_ak: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__al____,type,
    aTP_Lamp_al: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__am____,type,
    aTP_Lamp_am: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__an____,type,
    aTP_Lamp_an: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ao____,type,
    aTP_Lamp_ao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ap____,type,
    aTP_Lamp_ap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aq____,type,
    aTP_Lamp_aq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ar____,type,
    aTP_Lamp_ar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__as____,type,
    aTP_Lamp_as: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__at____,type,
    aTP_Lamp_at: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__au____,type,
    aTP_Lamp_au: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__av____,type,
    aTP_Lamp_av: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aw____,type,
    aTP_Lamp_aw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ax____,type,
    aTP_Lamp_ax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ay____,type,
    aTP_Lamp_ay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__az____,type,
    aTP_Lamp_az: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ba____,type,
    aTP_Lamp_ba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bb____,type,
    aTP_Lamp_bb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bc____,type,
    aTP_Lamp_bc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bd____,type,
    aTP_Lamp_bd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__be____,type,
    aTP_Lamp_be: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bf____,type,
    aTP_Lamp_bf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bg____,type,
    aTP_Lamp_bg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bh____,type,
    aTP_Lamp_bh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bi____,type,
    aTP_Lamp_bi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bj____,type,
    aTP_Lamp_bj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bk____,type,
    aTP_Lamp_bk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bl____,type,
    aTP_Lamp_bl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bm____,type,
    aTP_Lamp_bm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bn____,type,
    aTP_Lamp_bn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bo____,type,
    aTP_Lamp_bo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bp____,type,
    aTP_Lamp_bp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bq____,type,
    aTP_Lamp_bq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__br____,type,
    aTP_Lamp_br: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bs____,type,
    aTP_Lamp_bs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bt____,type,
    aTP_Lamp_bt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bu____,type,
    aTP_Lamp_bu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bv____,type,
    aTP_Lamp_bv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bw____,type,
    aTP_Lamp_bw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bx____,type,
    aTP_Lamp_bx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__by____,type,
    aTP_Lamp_by: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bz____,type,
    aTP_Lamp_bz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ca____,type,
    aTP_Lamp_ca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cb____,type,
    aTP_Lamp_cb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cc____,type,
    aTP_Lamp_cc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cd____,type,
    aTP_Lamp_cd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ce____,type,
    aTP_Lamp_ce: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cf____,type,
    aTP_Lamp_cf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cg____,type,
    aTP_Lamp_cg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ch____,type,
    aTP_Lamp_ch: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ci____,type,
    aTP_Lamp_ci: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cj____,type,
    aTP_Lamp_cj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ck____,type,
    aTP_Lamp_ck: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cl____,type,
    aTP_Lamp_cl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cm____,type,
    aTP_Lamp_cm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cn____,type,
    aTP_Lamp_cn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__co____,type,
    aTP_Lamp_co: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cp____,type,
    aTP_Lamp_cp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cq____,type,
    aTP_Lamp_cq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cr____,type,
    aTP_Lamp_cr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cs____,type,
    aTP_Lamp_cs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ct____,type,
    aTP_Lamp_ct: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cu____,type,
    aTP_Lamp_cu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__cv____,type,
    aTP_Lamp_cv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cw____,type,
    aTP_Lamp_cw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cx____,type,
    aTP_Lamp_cx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cy____,type,
    aTP_Lamp_cy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cz____,type,
    aTP_Lamp_cz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__da____,type,
    aTP_Lamp_da: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__db____,type,
    aTP_Lamp_db: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dc____,type,
    aTP_Lamp_dc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dd____,type,
    aTP_Lamp_dd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__de____,type,
    aTP_Lamp_de: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__df____,type,
    aTP_Lamp_df: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dg____,type,
    aTP_Lamp_dg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dh____,type,
    aTP_Lamp_dh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__di____,type,
    aTP_Lamp_di: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dj____,type,
    aTP_Lamp_dj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dk____,type,
    aTP_Lamp_dk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dl____,type,
    aTP_Lamp_dl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dm____,type,
    aTP_Lamp_dm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dn____,type,
    aTP_Lamp_dn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__do____,type,
    aTP_Lamp_do: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dp____,type,
    aTP_Lamp_dp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dq____,type,
    aTP_Lamp_dq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dr____,type,
    aTP_Lamp_dr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ds____,type,
    aTP_Lamp_ds: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dt____,type,
    aTP_Lamp_dt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__du____,type,
    aTP_Lamp_du: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dv____,type,
    aTP_Lamp_dv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dw____,type,
    aTP_Lamp_dw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dx____,type,
    aTP_Lamp_dx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dy____,type,
    aTP_Lamp_dy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dz____,type,
    aTP_Lamp_dz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ea____,type,
    aTP_Lamp_ea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eb____,type,
    aTP_Lamp_eb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ec____,type,
    aTP_Lamp_ec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ed____,type,
    aTP_Lamp_ed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ee____,type,
    aTP_Lamp_ee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ef____,type,
    aTP_Lamp_ef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eg____,type,
    aTP_Lamp_eg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eh____,type,
    aTP_Lamp_eh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ei____,type,
    aTP_Lamp_ei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ej____,type,
    aTP_Lamp_ej: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ek____,type,
    aTP_Lamp_ek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__el____,type,
    aTP_Lamp_el: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__em____,type,
    aTP_Lamp_em: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__en____,type,
    aTP_Lamp_en: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__eo____,type,
    aTP_Lamp_eo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ep____,type,
    aTP_Lamp_ep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eq____,type,
    aTP_Lamp_eq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__er____,type,
    aTP_Lamp_er: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__es____,type,
    aTP_Lamp_es: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__et____,type,
    aTP_Lamp_et: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eu____,type,
    aTP_Lamp_eu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ev____,type,
    aTP_Lamp_ev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ew____,type,
    aTP_Lamp_ew: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ex____,type,
    aTP_Lamp_ex: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ey____,type,
    aTP_Lamp_ey: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ez____,type,
    aTP_Lamp_ez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fa____,type,
    aTP_Lamp_fa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fb____,type,
    aTP_Lamp_fb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fc____,type,
    aTP_Lamp_fc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fd____,type,
    aTP_Lamp_fd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fe____,type,
    aTP_Lamp_fe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ff____,type,
    aTP_Lamp_ff: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fg____,type,
    aTP_Lamp_fg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fh____,type,
    aTP_Lamp_fh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fi____,type,
    aTP_Lamp_fi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fj____,type,
    aTP_Lamp_fj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fk____,type,
    aTP_Lamp_fk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fl____,type,
    aTP_Lamp_fl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fm____,type,
    aTP_Lamp_fm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fn____,type,
    aTP_Lamp_fn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fo____,type,
    aTP_Lamp_fo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fp____,type,
    aTP_Lamp_fp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fq____,type,
    aTP_Lamp_fq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fr____,type,
    aTP_Lamp_fr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fs____,type,
    aTP_Lamp_fs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ft____,type,
    aTP_Lamp_ft: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fu____,type,
    aTP_Lamp_fu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fv____,type,
    aTP_Lamp_fv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fw____,type,
    aTP_Lamp_fw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fx____,type,
    aTP_Lamp_fx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fy____,type,
    aTP_Lamp_fy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fz____,type,
    aTP_Lamp_fz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ga____,type,
    aTP_Lamp_ga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gb____,type,
    aTP_Lamp_gb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gc____,type,
    aTP_Lamp_gc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gd____,type,
    aTP_Lamp_gd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ge____,type,
    aTP_Lamp_ge: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gf____,type,
    aTP_Lamp_gf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gg____,type,
    aTP_Lamp_gg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gh____,type,
    aTP_Lamp_gh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gi____,type,
    aTP_Lamp_gi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gj____,type,
    aTP_Lamp_gj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gk____,type,
    aTP_Lamp_gk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gl____,type,
    aTP_Lamp_gl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gm____,type,
    aTP_Lamp_gm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gn____,type,
    aTP_Lamp_gn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__go____,type,
    aTP_Lamp_go: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gp____,type,
    aTP_Lamp_gp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gq____,type,
    aTP_Lamp_gq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gr____,type,
    aTP_Lamp_gr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gs____,type,
    aTP_Lamp_gs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gt____,type,
    aTP_Lamp_gt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gu____,type,
    aTP_Lamp_gu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gv____,type,
    aTP_Lamp_gv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gw____,type,
    aTP_Lamp_gw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gx____,type,
    aTP_Lamp_gx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gy____,type,
    aTP_Lamp_gy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__gz____,type,
    aTP_Lamp_gz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ha____,type,
    aTP_Lamp_ha: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hb____,type,
    aTP_Lamp_hb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hc____,type,
    aTP_Lamp_hc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hd____,type,
    aTP_Lamp_hd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__he____,type,
    aTP_Lamp_he: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hf____,type,
    aTP_Lamp_hf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hg____,type,
    aTP_Lamp_hg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hh____,type,
    aTP_Lamp_hh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hi____,type,
    aTP_Lamp_hi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hj____,type,
    aTP_Lamp_hj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hk____,type,
    aTP_Lamp_hk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hl____,type,
    aTP_Lamp_hl: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hm____,type,
    aTP_Lamp_hm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hn____,type,
    aTP_Lamp_hn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ho____,type,
    aTP_Lamp_ho: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hp____,type,
    aTP_Lamp_hp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hq____,type,
    aTP_Lamp_hq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hr____,type,
    aTP_Lamp_hr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hs____,type,
    aTP_Lamp_hs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ht____,type,
    aTP_Lamp_ht: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hu____,type,
    aTP_Lamp_hu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__hv____,type,
    aTP_Lamp_hv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hw____,type,
    aTP_Lamp_hw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hx____,type,
    aTP_Lamp_hx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hy____,type,
    aTP_Lamp_hy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hz____,type,
    aTP_Lamp_hz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ia____,type,
    aTP_Lamp_ia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ib____,type,
    aTP_Lamp_ib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ic____,type,
    aTP_Lamp_ic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__id____,type,
    aTP_Lamp_id: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ie____,type,
    aTP_Lamp_ie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__if____,type,
    aTP_Lamp_if: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ig____,type,
    aTP_Lamp_ig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ih____,type,
    aTP_Lamp_ih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ii____,type,
    aTP_Lamp_ii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ij____,type,
    aTP_Lamp_ij: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ik____,type,
    aTP_Lamp_ik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__il____,type,
    aTP_Lamp_il: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__im____,type,
    aTP_Lamp_im: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__in____,type,
    aTP_Lamp_in: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__io____,type,
    aTP_Lamp_io: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ip____,type,
    aTP_Lamp_ip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iq____,type,
    aTP_Lamp_iq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ir____,type,
    aTP_Lamp_ir: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__is____,type,
    aTP_Lamp_is: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__it____,type,
    aTP_Lamp_it: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iu____,type,
    aTP_Lamp_iu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iv____,type,
    aTP_Lamp_iv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iw____,type,
    aTP_Lamp_iw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ix____,type,
    aTP_Lamp_ix: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__iy____,type,
    aTP_Lamp_iy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iz____,type,
    aTP_Lamp_iz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ja____,type,
    aTP_Lamp_ja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jb____,type,
    aTP_Lamp_jb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jc____,type,
    aTP_Lamp_jc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jd____,type,
    aTP_Lamp_jd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__je____,type,
    aTP_Lamp_je: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jf____,type,
    aTP_Lamp_jf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jg____,type,
    aTP_Lamp_jg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jh____,type,
    aTP_Lamp_jh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ji____,type,
    aTP_Lamp_ji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jj____,type,
    aTP_Lamp_jj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jk____,type,
    aTP_Lamp_jk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jl____,type,
    aTP_Lamp_jl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jm____,type,
    aTP_Lamp_jm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jn____,type,
    aTP_Lamp_jn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jo____,type,
    aTP_Lamp_jo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jp____,type,
    aTP_Lamp_jp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jq____,type,
    aTP_Lamp_jq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jr____,type,
    aTP_Lamp_jr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__js____,type,
    aTP_Lamp_js: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jt____,type,
    aTP_Lamp_jt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ju____,type,
    aTP_Lamp_ju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jv____,type,
    aTP_Lamp_jv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jw____,type,
    aTP_Lamp_jw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jx____,type,
    aTP_Lamp_jx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jy____,type,
    aTP_Lamp_jy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jz____,type,
    aTP_Lamp_jz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ka____,type,
    aTP_Lamp_ka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kb____,type,
    aTP_Lamp_kb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kc____,type,
    aTP_Lamp_kc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kd____,type,
    aTP_Lamp_kd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ke____,type,
    aTP_Lamp_ke: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kf____,type,
    aTP_Lamp_kf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kg____,type,
    aTP_Lamp_kg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kh____,type,
    aTP_Lamp_kh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ki____,type,
    aTP_Lamp_ki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kj____,type,
    aTP_Lamp_kj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kk____,type,
    aTP_Lamp_kk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__kl____,type,
    aTP_Lamp_kl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__km____,type,
    aTP_Lamp_km: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kn____,type,
    aTP_Lamp_kn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ko____,type,
    aTP_Lamp_ko: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kp____,type,
    aTP_Lamp_kp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kq____,type,
    aTP_Lamp_kq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kr____,type,
    aTP_Lamp_kr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ks____,type,
    aTP_Lamp_ks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kt____,type,
    aTP_Lamp_kt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ku____,type,
    aTP_Lamp_ku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kv____,type,
    aTP_Lamp_kv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__kw____,type,
    aTP_Lamp_kw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kx____,type,
    aTP_Lamp_kx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ky____,type,
    aTP_Lamp_ky: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kz____,type,
    aTP_Lamp_kz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__la____,type,
    aTP_Lamp_la: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lb____,type,
    aTP_Lamp_lb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lc____,type,
    aTP_Lamp_lc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ld____,type,
    aTP_Lamp_ld: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__le____,type,
    aTP_Lamp_le: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lf____,type,
    aTP_Lamp_lf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lg____,type,
    aTP_Lamp_lg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lh____,type,
    aTP_Lamp_lh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__li____,type,
    aTP_Lamp_li: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lj____,type,
    aTP_Lamp_lj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lk____,type,
    aTP_Lamp_lk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ll____,type,
    aTP_Lamp_ll: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lm____,type,
    aTP_Lamp_lm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ln____,type,
    aTP_Lamp_ln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lo____,type,
    aTP_Lamp_lo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lp____,type,
    aTP_Lamp_lp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lq____,type,
    aTP_Lamp_lq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lr____,type,
    aTP_Lamp_lr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ls____,type,
    aTP_Lamp_ls: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lt____,type,
    aTP_Lamp_lt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lu____,type,
    aTP_Lamp_lu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lv____,type,
    aTP_Lamp_lv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lw____,type,
    aTP_Lamp_lw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lx____,type,
    aTP_Lamp_lx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ly____,type,
    aTP_Lamp_ly: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lz____,type,
    aTP_Lamp_lz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ma____,type,
    aTP_Lamp_ma: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mb____,type,
    aTP_Lamp_mb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mc____,type,
    aTP_Lamp_mc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__md____,type,
    aTP_Lamp_md: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__me____,type,
    aTP_Lamp_me: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mf____,type,
    aTP_Lamp_mf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mg____,type,
    aTP_Lamp_mg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mh____,type,
    aTP_Lamp_mh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mi____,type,
    aTP_Lamp_mi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mj____,type,
    aTP_Lamp_mj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mk____,type,
    aTP_Lamp_mk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ml____,type,
    aTP_Lamp_ml: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mm____,type,
    aTP_Lamp_mm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mn____,type,
    aTP_Lamp_mn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mo____,type,
    aTP_Lamp_mo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mp____,type,
    aTP_Lamp_mp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mq____,type,
    aTP_Lamp_mq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mr____,type,
    aTP_Lamp_mr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ms____,type,
    aTP_Lamp_ms: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mt____,type,
    aTP_Lamp_mt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mu____,type,
    aTP_Lamp_mu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mv____,type,
    aTP_Lamp_mv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mw____,type,
    aTP_Lamp_mw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mx____,type,
    aTP_Lamp_mx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__my____,type,
    aTP_Lamp_my: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mz____,type,
    aTP_Lamp_mz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__na____,type,
    aTP_Lamp_na: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nb____,type,
    aTP_Lamp_nb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nc____,type,
    aTP_Lamp_nc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nd____,type,
    aTP_Lamp_nd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ne____,type,
    aTP_Lamp_ne: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nf____,type,
    aTP_Lamp_nf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ng____,type,
    aTP_Lamp_ng: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nh____,type,
    aTP_Lamp_nh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ni____,type,
    aTP_Lamp_ni: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nj____,type,
    aTP_Lamp_nj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nk____,type,
    aTP_Lamp_nk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nl____,type,
    aTP_Lamp_nl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nm____,type,
    aTP_Lamp_nm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nn____,type,
    aTP_Lamp_nn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__no____,type,
    aTP_Lamp_no: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__np____,type,
    aTP_Lamp_np: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nq____,type,
    aTP_Lamp_nq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nr____,type,
    aTP_Lamp_nr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ns____,type,
    aTP_Lamp_ns: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nt____,type,
    aTP_Lamp_nt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nu____,type,
    aTP_Lamp_nu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nv____,type,
    aTP_Lamp_nv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nw____,type,
    aTP_Lamp_nw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nx____,type,
    aTP_Lamp_nx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ny____,type,
    aTP_Lamp_ny: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nz____,type,
    aTP_Lamp_nz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oa____,type,
    aTP_Lamp_oa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ob____,type,
    aTP_Lamp_ob: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oc____,type,
    aTP_Lamp_oc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__od____,type,
    aTP_Lamp_od: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__oe____,type,
    aTP_Lamp_oe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__of____,type,
    aTP_Lamp_of: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__og____,type,
    aTP_Lamp_og: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oh____,type,
    aTP_Lamp_oh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oi____,type,
    aTP_Lamp_oi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oj____,type,
    aTP_Lamp_oj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ok____,type,
    aTP_Lamp_ok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ol____,type,
    aTP_Lamp_ol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__om____,type,
    aTP_Lamp_om: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__on____,type,
    aTP_Lamp_on: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oo____,type,
    aTP_Lamp_oo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__op____,type,
    aTP_Lamp_op: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oq____,type,
    aTP_Lamp_oq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__or____,type,
    aTP_Lamp_or: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__os____,type,
    aTP_Lamp_os: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ot____,type,
    aTP_Lamp_ot: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ou____,type,
    aTP_Lamp_ou: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ov____,type,
    aTP_Lamp_ov: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ow____,type,
    aTP_Lamp_ow: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ox____,type,
    aTP_Lamp_ox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oy____,type,
    aTP_Lamp_oy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oz____,type,
    aTP_Lamp_oz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pa____,type,
    aTP_Lamp_pa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pb____,type,
    aTP_Lamp_pb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pc____,type,
    aTP_Lamp_pc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pd____,type,
    aTP_Lamp_pd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pe____,type,
    aTP_Lamp_pe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pf____,type,
    aTP_Lamp_pf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pg____,type,
    aTP_Lamp_pg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ph____,type,
    aTP_Lamp_ph: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pi____,type,
    aTP_Lamp_pi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pj____,type,
    aTP_Lamp_pj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pk____,type,
    aTP_Lamp_pk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pl____,type,
    aTP_Lamp_pl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pm____,type,
    aTP_Lamp_pm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pn____,type,
    aTP_Lamp_pn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__po____,type,
    aTP_Lamp_po: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pp____,type,
    aTP_Lamp_pp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__pq____,type,
    aTP_Lamp_pq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pr____,type,
    aTP_Lamp_pr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ps____,type,
    aTP_Lamp_ps: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pt____,type,
    aTP_Lamp_pt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pu____,type,
    aTP_Lamp_pu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pv____,type,
    aTP_Lamp_pv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pw____,type,
    aTP_Lamp_pw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__px____,type,
    aTP_Lamp_px: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__py____,type,
    aTP_Lamp_py: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pz____,type,
    aTP_Lamp_pz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qa____,type,
    aTP_Lamp_qa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qb____,type,
    aTP_Lamp_qb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qc____,type,
    aTP_Lamp_qc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qd____,type,
    aTP_Lamp_qd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qe____,type,
    aTP_Lamp_qe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qf____,type,
    aTP_Lamp_qf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qg____,type,
    aTP_Lamp_qg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qh____,type,
    aTP_Lamp_qh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qi____,type,
    aTP_Lamp_qi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qj____,type,
    aTP_Lamp_qj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qk____,type,
    aTP_Lamp_qk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ql____,type,
    aTP_Lamp_ql: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qm____,type,
    aTP_Lamp_qm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qn____,type,
    aTP_Lamp_qn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qo____,type,
    aTP_Lamp_qo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qp____,type,
    aTP_Lamp_qp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qq____,type,
    aTP_Lamp_qq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qr____,type,
    aTP_Lamp_qr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qs____,type,
    aTP_Lamp_qs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qt____,type,
    aTP_Lamp_qt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qu____,type,
    aTP_Lamp_qu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qv____,type,
    aTP_Lamp_qv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qw____,type,
    aTP_Lamp_qw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qx____,type,
    aTP_Lamp_qx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qy____,type,
    aTP_Lamp_qy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qz____,type,
    aTP_Lamp_qz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ra____,type,
    aTP_Lamp_ra: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rb____,type,
    aTP_Lamp_rb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rc____,type,
    aTP_Lamp_rc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rd____,type,
    aTP_Lamp_rd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__re____,type,
    aTP_Lamp_re: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rf____,type,
    aTP_Lamp_rf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rg____,type,
    aTP_Lamp_rg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rh____,type,
    aTP_Lamp_rh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ri____,type,
    aTP_Lamp_ri: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rj____,type,
    aTP_Lamp_rj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rk____,type,
    aTP_Lamp_rk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rl____,type,
    aTP_Lamp_rl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rm____,type,
    aTP_Lamp_rm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rn____,type,
    aTP_Lamp_rn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ro____,type,
    aTP_Lamp_ro: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rp____,type,
    aTP_Lamp_rp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rq____,type,
    aTP_Lamp_rq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rr____,type,
    aTP_Lamp_rr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rs____,type,
    aTP_Lamp_rs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rt____,type,
    aTP_Lamp_rt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ru____,type,
    aTP_Lamp_ru: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rv____,type,
    aTP_Lamp_rv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rw____,type,
    aTP_Lamp_rw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rx____,type,
    aTP_Lamp_rx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ry____,type,
    aTP_Lamp_ry: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rz____,type,
    aTP_Lamp_rz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sa____,type,
    aTP_Lamp_sa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sb____,type,
    aTP_Lamp_sb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sc____,type,
    aTP_Lamp_sc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sd____,type,
    aTP_Lamp_sd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__se____,type,
    aTP_Lamp_se: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sf____,type,
    aTP_Lamp_sf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sg____,type,
    aTP_Lamp_sg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sh____,type,
    aTP_Lamp_sh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__si____,type,
    aTP_Lamp_si: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sj____,type,
    aTP_Lamp_sj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sk____,type,
    aTP_Lamp_sk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sl____,type,
    aTP_Lamp_sl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sm____,type,
    aTP_Lamp_sm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sn____,type,
    aTP_Lamp_sn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__so____,type,
    aTP_Lamp_so: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sp____,type,
    aTP_Lamp_sp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sq____,type,
    aTP_Lamp_sq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sr____,type,
    aTP_Lamp_sr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ss____,type,
    aTP_Lamp_ss: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__st____,type,
    aTP_Lamp_st: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__su____,type,
    aTP_Lamp_su: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sv____,type,
    aTP_Lamp_sv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sw____,type,
    aTP_Lamp_sw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sx____,type,
    aTP_Lamp_sx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sy____,type,
    aTP_Lamp_sy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__sz____,type,
    aTP_Lamp_sz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ta____,type,
    aTP_Lamp_ta: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tb____,type,
    aTP_Lamp_tb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tc____,type,
    aTP_Lamp_tc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__td____,type,
    aTP_Lamp_td: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__te____,type,
    aTP_Lamp_te: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tf____,type,
    aTP_Lamp_tf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tg____,type,
    aTP_Lamp_tg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__th____,type,
    aTP_Lamp_th: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ti____,type,
    aTP_Lamp_ti: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tj____,type,
    aTP_Lamp_tj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tk____,type,
    aTP_Lamp_tk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tl____,type,
    aTP_Lamp_tl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tm____,type,
    aTP_Lamp_tm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tn____,type,
    aTP_Lamp_tn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__to____,type,
    aTP_Lamp_to: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tp____,type,
    aTP_Lamp_tp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tq____,type,
    aTP_Lamp_tq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tr____,type,
    aTP_Lamp_tr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ts____,type,
    aTP_Lamp_ts: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tt____,type,
    aTP_Lamp_tt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tu____,type,
    aTP_Lamp_tu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__tv____,type,
    aTP_Lamp_tv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tw____,type,
    aTP_Lamp_tw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tx____,type,
    aTP_Lamp_tx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ty____,type,
    aTP_Lamp_ty: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tz____,type,
    aTP_Lamp_tz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ua____,type,
    aTP_Lamp_ua: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ub____,type,
    aTP_Lamp_ub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uc____,type,
    aTP_Lamp_uc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ud____,type,
    aTP_Lamp_ud: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ue____,type,
    aTP_Lamp_ue: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uf____,type,
    aTP_Lamp_uf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ug____,type,
    aTP_Lamp_ug: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uh____,type,
    aTP_Lamp_uh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ui____,type,
    aTP_Lamp_ui: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uj____,type,
    aTP_Lamp_uj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uk____,type,
    aTP_Lamp_uk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ul____,type,
    aTP_Lamp_ul: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__um____,type,
    aTP_Lamp_um: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__un____,type,
    aTP_Lamp_un: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uo____,type,
    aTP_Lamp_uo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__up____,type,
    aTP_Lamp_up: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uq____,type,
    aTP_Lamp_uq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ur____,type,
    aTP_Lamp_ur: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__us____,type,
    aTP_Lamp_us: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ut____,type,
    aTP_Lamp_ut: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uu____,type,
    aTP_Lamp_uu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__uv____,type,
    aTP_Lamp_uv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uw____,type,
    aTP_Lamp_uw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ux____,type,
    aTP_Lamp_ux: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uy____,type,
    aTP_Lamp_uy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uz____,type,
    aTP_Lamp_uz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__va____,type,
    aTP_Lamp_va: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vb____,type,
    aTP_Lamp_vb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vc____,type,
    aTP_Lamp_vc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vd____,type,
    aTP_Lamp_vd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ve____,type,
    aTP_Lamp_ve: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vf____,type,
    aTP_Lamp_vf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vg____,type,
    aTP_Lamp_vg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vh____,type,
    aTP_Lamp_vh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vi____,type,
    aTP_Lamp_vi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vj____,type,
    aTP_Lamp_vj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vk____,type,
    aTP_Lamp_vk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vl____,type,
    aTP_Lamp_vl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vm____,type,
    aTP_Lamp_vm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vn____,type,
    aTP_Lamp_vn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vo____,type,
    aTP_Lamp_vo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vp____,type,
    aTP_Lamp_vp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vq____,type,
    aTP_Lamp_vq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vr____,type,
    aTP_Lamp_vr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vs____,type,
    aTP_Lamp_vs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vt____,type,
    aTP_Lamp_vt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vu____,type,
    aTP_Lamp_vu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vv____,type,
    aTP_Lamp_vv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__vw____,type,
    aTP_Lamp_vw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vx____,type,
    aTP_Lamp_vx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vy____,type,
    aTP_Lamp_vy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vz____,type,
    aTP_Lamp_vz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wa____,type,
    aTP_Lamp_wa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wb____,type,
    aTP_Lamp_wb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wc____,type,
    aTP_Lamp_wc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wd____,type,
    aTP_Lamp_wd: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__we____,type,
    aTP_Lamp_we: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wf____,type,
    aTP_Lamp_wf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wg____,type,
    aTP_Lamp_wg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wh____,type,
    aTP_Lamp_wh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wi____,type,
    aTP_Lamp_wi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wj____,type,
    aTP_Lamp_wj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wk____,type,
    aTP_Lamp_wk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wl____,type,
    aTP_Lamp_wl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wm____,type,
    aTP_Lamp_wm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wn____,type,
    aTP_Lamp_wn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wo____,type,
    aTP_Lamp_wo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wp____,type,
    aTP_Lamp_wp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wq____,type,
    aTP_Lamp_wq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wr____,type,
    aTP_Lamp_wr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ws____,type,
    aTP_Lamp_ws: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wt____,type,
    aTP_Lamp_wt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wu____,type,
    aTP_Lamp_wu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wv____,type,
    aTP_Lamp_wv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ww____,type,
    aTP_Lamp_ww: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wx____,type,
    aTP_Lamp_wx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wy____,type,
    aTP_Lamp_wy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wz____,type,
    aTP_Lamp_wz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xa____,type,
    aTP_Lamp_xa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xb____,type,
    aTP_Lamp_xb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xc____,type,
    aTP_Lamp_xc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xd____,type,
    aTP_Lamp_xd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xe____,type,
    aTP_Lamp_xe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xf____,type,
    aTP_Lamp_xf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Array__Time_Oalloc,type,
    array_alloc: 
      !>[A: $tType] : ( ( list(A) * heap_ext(product_unit) ) > product_prod(array(A),heap_ext(product_unit)) ) ).

tff(sy_c_Array__Time_Ofreeze,type,
    array_freeze: 
      !>[A: $tType] : ( array(A) > heap_Time_Heap(list(A)) ) ).

tff(sy_c_Array__Time_Oget,type,
    array_get: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * array(A) ) > list(A) ) ).

tff(sy_c_Array__Time_Olen,type,
    array_len: 
      !>[A: $tType] : ( array(A) > heap_Time_Heap(nat) ) ).

tff(sy_c_Array__Time_Olength,type,
    array_length: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * array(A) ) > nat ) ).

tff(sy_c_Array__Time_Omake,type,
    array_make: 
      !>[A: $tType] : ( ( nat * fun(nat,A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Omake_H,type,
    array_make2: 
      !>[B: $tType,A: $tType] : ( ( code_integer * fun(B,A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Omap__entry,type,
    array_map_entry: 
      !>[A: $tType] : ( ( nat * fun(A,A) * array(A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Onew,type,
    array_new: 
      !>[A: $tType] : fun(nat,fun(A,heap_Time_Heap(array(A)))) ).

tff(sy_c_Array__Time_Onew_H,type,
    array_new2: 
      !>[A: $tType] : fun(code_integer,fun(A,heap_Time_Heap(array(A)))) ).

tff(sy_c_Array__Time_Onth,type,
    array_nth: 
      !>[A: $tType] : ( array(A) > fun(nat,heap_Time_Heap(A)) ) ).

tff(sy_c_Array__Time_Onth_H,type,
    array_nth2: 
      !>[A: $tType] : ( array(A) > fun(code_integer,heap_Time_Heap(A)) ) ).

tff(sy_c_Array__Time_Oof__list,type,
    array_of_list: 
      !>[A: $tType] : ( list(A) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Oset,type,
    array_set: 
      !>[A: $tType] : ( ( array(A) * list(A) * heap_ext(product_unit) ) > heap_ext(product_unit) ) ).

tff(sy_c_Array__Time_Oswap,type,
    array_swap: 
      !>[A: $tType] : ( ( nat * A * array(A) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Array__Time_Oupd,type,
    array_upd: 
      !>[A: $tType] : ( ( nat * A * array(A) ) > heap_Time_Heap(array(A)) ) ).

tff(sy_c_Array__Time_Oupdate,type,
    array_update: 
      !>[A: $tType] : ( ( array(A) * nat * A * heap_ext(product_unit) ) > heap_ext(product_unit) ) ).

tff(sy_c_Assertions_Oassn_OAbs__assn,type,
    abs_assn: fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn) ).

tff(sy_c_Assertions_Oassn_ORep__assn,type,
    rep_assn: fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o)) ).

tff(sy_c_Assertions_Oentails,type,
    entails: ( assn * assn ) > $o ).

tff(sy_c_Assertions_Oentailst,type,
    entailst: ( assn * assn ) > $o ).

tff(sy_c_Assertions_Oex__assn,type,
    ex_assn: 
      !>[A: $tType] : ( fun(A,assn) > assn ) ).

tff(sy_c_Assertions_Oin__range,type,
    in_range: fun(product_prod(heap_ext(product_unit),set(nat)),$o) ).

tff(sy_c_Assertions_Oin__range__rel,type,
    in_range_rel: fun(product_prod(heap_ext(product_unit),set(nat)),fun(product_prod(heap_ext(product_unit),set(nat)),$o)) ).

tff(sy_c_Assertions_Ois__pure__assn,type,
    is_pure_assn: assn > $o ).

tff(sy_c_Assertions_Oone__assn__raw,type,
    one_assn_raw: fun(product_prod(heap_ext(product_unit),set(nat)),$o) ).

tff(sy_c_Assertions_Oone__assn__raw__rel,type,
    one_assn_raw_rel: fun(product_prod(heap_ext(product_unit),set(nat)),fun(product_prod(heap_ext(product_unit),set(nat)),$o)) ).

tff(sy_c_Assertions_Oprecise,type,
    precise: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,assn)) > $o ) ).

tff(sy_c_Assertions_Oproper,type,
    proper: fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o) ).

tff(sy_c_Assertions_Opure__assn,type,
    pure_assn: $o > assn ).

tff(sy_c_Assertions_Opure__assn__raw,type,
    pure_assn_raw: 
      !>[A: $tType,B: $tType] : ( $o > fun(product_prod(A,set(B)),$o) ) ).

tff(sy_c_Assertions_Opure__assn__raw__rel,type,
    pure_assn_raw_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod($o,product_prod(A,set(B))),fun(product_prod($o,product_prod(A,set(B))),$o)) ).

tff(sy_c_Assertions_OrelH,type,
    relH: ( set(nat) * heap_ext(product_unit) * heap_ext(product_unit) ) > $o ).

tff(sy_c_Assertions_Osnga__assn,type,
    snga_assn: 
      !>[A: $tType] : ( ( array(A) * list(A) ) > assn ) ).

tff(sy_c_Assertions_Osnga__assn__raw,type,
    snga_assn_raw: 
      !>[A: $tType] : ( ( array(A) * list(A) ) > fun(product_prod(heap_ext(product_unit),set(nat)),$o) ) ).

tff(sy_c_Assertions_Osnga__assn__raw__rel,type,
    snga_assn_raw_rel: 
      !>[A: $tType] : fun(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(array(A),product_prod(list(A),product_prod(heap_ext(product_unit),set(nat)))),$o)) ).

tff(sy_c_Assertions_Osngr__assn,type,
    sngr_assn: 
      !>[A: $tType] : ( ( ref(A) * A ) > assn ) ).

tff(sy_c_Assertions_Osngr__assn__raw,type,
    sngr_assn_raw: 
      !>[A: $tType] : ( ( ref(A) * A ) > fun(product_prod(heap_ext(product_unit),set(nat)),$o) ) ).

tff(sy_c_Assertions_Osngr__assn__raw__rel,type,
    sngr_assn_raw_rel: 
      !>[A: $tType] : fun(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(ref(A),product_prod(A,product_prod(heap_ext(product_unit),set(nat)))),$o)) ).

tff(sy_c_Assertions_Otimes__assn__raw,type,
    times_assn_raw: ( fun(product_prod(heap_ext(product_unit),set(nat)),$o) * fun(product_prod(heap_ext(product_unit),set(nat)),$o) ) > fun(product_prod(heap_ext(product_unit),set(nat)),$o) ).

tff(sy_c_Assertions_Otimes__assn__raw__rel,type,
    times_assn_raw_rel: fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o)) ).

tff(sy_c_Assertions_Owand__assn,type,
    wand_assn: ( assn * assn ) > assn ).

tff(sy_c_Assertions_Owand__raw,type,
    wand_raw: ( fun(product_prod(heap_ext(product_unit),set(nat)),$o) * fun(product_prod(heap_ext(product_unit),set(nat)),$o) ) > fun(product_prod(heap_ext(product_unit),set(nat)),$o) ).

tff(sy_c_Assertions_Owand__raw__rel,type,
    wand_raw_rel: fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o)) ).

tff(sy_c_BNF__Cardinal__Arithmetic_OCsum,type,
    bNF_Cardinal_Csum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,set(product_prod(B,B))) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocexp,type,
    bNF_Cardinal_cexp: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * set(product_prod(A,A)) ) > set(product_prod(fun(A,B),fun(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocfinite,type,
    bNF_Cardinal_cfinite: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocinfinite,type,
    bNF_Ca4139267488887388095finite: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocone,type,
    bNF_Cardinal_cone: set(product_prod(product_unit,product_unit)) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocprod,type,
    bNF_Cardinal_cprod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Ocsum,type,
    bNF_Cardinal_csum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(sum_sum(A,B),sum_sum(A,B))) ) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Octwo,type,
    bNF_Cardinal_ctwo: set(product_prod($o,$o)) ).

tff(sy_c_BNF__Cardinal__Arithmetic_Oczero,type,
    bNF_Cardinal_czero: 
      !>[A: $tType] : set(product_prod(A,A)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OcardSuc,type,
    bNF_Ca8387033319878233205ardSuc: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_Ocard__of,type,
    bNF_Ca6860139660246222851ard_of: 
      !>[A: $tType] : ( set(A) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_Ocard__order__on,type,
    bNF_Ca8970107618336181345der_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_Ocofinal,type,
    bNF_Ca7293521722713021262ofinal: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OisCardSuc,type,
    bNF_Ca6246979054910435723ardSuc: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(set(A),set(A))) ) > $o ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OnatLeq,type,
    bNF_Ca8665028551170535155natLeq: set(product_prod(nat,nat)) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OregularCard,type,
    bNF_Ca7133664381575040944arCard: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Cardinal__Order__Relation_OrelChain,type,
    bNF_Ca3754400796208372196lChain: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,B) ) > $o ) ).

tff(sy_c_BNF__Composition_Oid__bnf,type,
    bNF_id_bnf: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Def_OGrp,type,
    bNF_Grp: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > fun(A,fun(B,$o)) ) ).

tff(sy_c_BNF__Def_Ocollect,type,
    bNF_collect: 
      !>[B: $tType,A: $tType] : ( set(fun(B,set(A))) > fun(B,set(A)) ) ).

tff(sy_c_BNF__Def_Oconvol,type,
    bNF_convol: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,B) * fun(A,C) ) > fun(A,product_prod(B,C)) ) ).

tff(sy_c_BNF__Def_Oeq__onp,type,
    bNF_eq_onp: 
      !>[A: $tType] : ( fun(A,$o) > fun(A,fun(A,$o)) ) ).

tff(sy_c_BNF__Def_OfstOp,type,
    bNF_fstOp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,$o)) * fun(B,fun(C,$o)) ) > fun(product_prod(A,C),product_prod(A,B)) ) ).

tff(sy_c_BNF__Def_Opick__middlep,type,
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] : ( ( fun(B,fun(A,$o)) * fun(A,fun(C,$o)) * B * C ) > A ) ).

tff(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,fun(C,$o)) * fun(B,fun(D,$o)) ) > fun(fun(A,B),fun(fun(C,D),$o)) ) ).

tff(sy_c_BNF__Def_Orel__set,type,
    bNF_rel_set: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(set(A),fun(set(B),$o)) ) ).

tff(sy_c_BNF__Def_OsndOp,type,
    bNF_sndOp: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( fun(C,fun(A,$o)) * fun(A,fun(B,$o)) ) > fun(product_prod(C,B),product_prod(A,B)) ) ).

tff(sy_c_BNF__Def_Ovimage2p,type,
    bNF_vimage2p: 
      !>[A: $tType,D: $tType,B: $tType,E: $tType,C: $tType] : ( ( fun(A,D) * fun(B,E) ) > fun(fun(D,fun(E,C)),fun(A,fun(B,C))) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OfromCard,type,
    bNF_Gr5436034075474128252omCard: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) * B ) > A ) ).

tff(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set(C) * fun(C,A) * fun(C,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OrelImage,type,
    bNF_Gr4221423524335903396lImage: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * fun(B,A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OrelInvImage,type,
    bNF_Gr7122648621184425601vImage: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) * fun(A,B) ) > set(product_prod(A,A)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OtoCard,type,
    bNF_Greatest_toCard: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) ) > fun(A,B) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_OtoCard__pred,type,
    bNF_Gr1419584066657907630d_pred: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(product_prod(B,B)) * fun(A,B) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(fun(A,B)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set(B) * fun(C,A) * fun(B,D) ) > fun(fun(D,C),fun(B,A)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Obsqr,type,
    bNF_Wellorder_bsqr: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(product_prod(A,A),product_prod(A,A))) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Ocurr,type,
    bNF_Wellorder_curr: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(A) * fun(product_prod(A,B),C) * A ) > fun(B,C) ) ).

tff(sy_c_BNF__Wellorder__Constructions_Odir__image,type,
    bNF_We2720479622203943262_image: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * fun(A,A2) ) > set(product_prod(A2,A2)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OofilterIncl,type,
    bNF_We413866401316099525erIncl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OordIso,type,
    bNF_Wellorder_ordIso: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_OordLeq,type,
    bNF_Wellorder_ordLeq: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_OordLess,type,
    bNF_We4044943003108391690rdLess: 
      !>[A: $tType,A2: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A2,A2)))) ).

tff(sy_c_BNF__Wellorder__Constructions_Oord__to__filter,type,
    bNF_We8469521843155493636filter: 
      !>[A: $tType] : ( set(product_prod(A,A)) > fun(set(product_prod(A,A)),set(A)) ) ).

tff(sy_c_BNF__Wellorder__Embedding_Ocompat,type,
    bNF_Wellorder_compat: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Embedding_Oembed,type,
    bNF_Wellorder_embed: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Embedding_OembedS,type,
    bNF_Wellorder_embedS: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Embedding_Oiso,type,
    bNF_Wellorder_iso: 
      !>[A: $tType,A2: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(A2,A2)) * fun(A,A2) ) > $o ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel,type,
    bNF_Wellorder_wo_rel: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_OisMinim,type,
    bNF_We4791949203932849705sMinim: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) * A ) > $o ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Omax2,type,
    bNF_We1388413361240627857o_max2: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A * A ) > A ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Ominim,type,
    bNF_We6954850376910717587_minim: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > A ) ).

tff(sy_c_BNF__Wellorder__Relation_Owo__rel_Osuc,type,
    bNF_Wellorder_wo_suc: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > A ) ).

tff(sy_c_Basic__BNF__LFPs_Octor__rec,type,
    basic_BNF_ctor_rec: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( fun(A,nat) * fun(B,nat) ) > fun(product_prod(A,B),nat) ) ).

tff(sy_c_Basic__BNF__LFPs_Osum_Osize__sum,type,
    basic_BNF_size_sum: 
      !>[A: $tType,B: $tType] : ( ( fun(A,nat) * fun(B,nat) ) > fun(sum_sum(A,B),nat) ) ).

tff(sy_c_Basic__BNF__LFPs_Oxtor,type,
    basic_BNF_xtor: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Basic__BNFs_Ofsts,type,
    basic_fsts: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),set(A)) ).

tff(sy_c_Basic__BNFs_Opred__fun,type,
    basic_pred_fun: 
      !>[A: $tType,B: $tType] : ( ( fun(A,$o) * fun(B,$o) ) > fun(fun(A,B),$o) ) ).

tff(sy_c_Basic__BNFs_Opred__prod,type,
    basic_pred_prod: 
      !>[A: $tType,B: $tType] : ( ( fun(A,$o) * fun(B,$o) ) > fun(product_prod(A,B),$o) ) ).

tff(sy_c_Basic__BNFs_Opred__sum,type,
    basic_pred_sum: 
      !>[A: $tType,B: $tType] : ( ( fun(A,$o) * fun(B,$o) * sum_sum(A,B) ) > $o ) ).

tff(sy_c_Basic__BNFs_Orel__prod,type,
    basic_rel_prod: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( fun(A,fun(B,$o)) * fun(C,fun(D,$o)) ) > fun(product_prod(A,C),fun(product_prod(B,D),$o)) ) ).

tff(sy_c_Basic__BNFs_Osetl,type,
    basic_setl: 
      !>[A: $tType,B: $tType] : fun(sum_sum(A,B),set(A)) ).

tff(sy_c_Basic__BNFs_Osetr,type,
    basic_setr: 
      !>[A: $tType,B: $tType] : fun(sum_sum(A,B),set(B)) ).

tff(sy_c_Basic__BNFs_Osnds,type,
    basic_snds: 
      !>[A: $tType,B: $tType] : ( product_prod(A,B) > set(B) ) ).

tff(sy_c_Binomial_Obinomial,type,
    binomial: ( nat * nat ) > nat ).

tff(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > fun(nat,A) ) ).

tff(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: ( num * num ) > num ).

tff(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > fun(nat,$o) ) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself(A) * nat ) > $o ) ).

tff(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: ( nat * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oor__num,type,
    bit_un6697907153464112080or_num: ( num * num ) > num ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oor__num__rel,type,
    bit_un4773296044027857193um_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num__rel,type,
    bit_un2901131394128224187um_rel: fun(product_prod(num,num),fun(product_prod(num,num),$o)) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__axioms,type,
    boolea6902313364301356556axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff__axioms,type,
    boolea5476839437570043046axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Code__Numeral_OSuc,type,
    code_Suc: code_natural > code_natural ).

tff(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > product_prod(code_integer,$o) ).

tff(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: fun(code_integer,int) ).

tff(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: fun(code_integer,nat) ).

tff(sy_c_Code__Numeral_Onatural_Onat__of__natural,type,
    code_nat_of_natural: code_natural > nat ).

tff(sy_c_Code__Numeral_Onatural_Onatural__of__nat,type,
    code_natural_of_nat: nat > code_natural ).

tff(sy_c_Code__Numeral_Onegative,type,
    code_negative: fun(num,code_integer) ).

tff(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: fun(code_integer,num) ).

tff(sy_c_Code__Numeral_Opcr__integer,type,
    code_pcr_integer: fun(int,fun(code_integer,$o)) ).

tff(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Partial__Order_Occpo_Oadmissible,type,
    comple1908693960933563346ssible: 
      !>[A: $tType] : ( ( fun(set(A),A) * fun(A,fun(A,$o)) * fun(A,$o) ) > $o ) ).

tff(sy_c_Complete__Partial__Order_Occpo_Ofixp,type,
    comple187402453842119260l_fixp: 
      !>[A: $tType] : ( ( fun(set(A),A) * fun(A,fun(A,$o)) * fun(A,A) ) > A ) ).

tff(sy_c_Complete__Partial__Order_Occpo__class_Ofixp,type,
    comple115746919287870866o_fixp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Complete__Partial__Order_Occpo__class_Oiterates,type,
    comple6359979572994053840erates: 
      !>[A: $tType] : ( fun(A,A) > set(A) ) ).

tff(sy_c_Complete__Partial__Order_Ochain,type,
    comple1602240252501008431_chain: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * set(A) ) > $o ) ).

tff(sy_c_Complete__Partial__Order_Omonotone,type,
    comple7038119648293358887notone: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,fun(B,$o)) * fun(A,B) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__above,type,
    condit8047198070973881523_above: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * set(A) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__below,type,
    condit8119078960628432327_below: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * set(A) ) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Countable_Ofrom__nat,type,
    from_nat: 
      !>[A: $tType] : fun(nat,A) ).

tff(sy_c_Countable_Onat__to__rat__surj,type,
    nat_to_rat_surj: fun(nat,rat) ).

tff(sy_c_Countable_Onth__item__rel,type,
    nth_item_rel: fun(nat,fun(nat,$o)) ).

tff(sy_c_Divides_Oadjust__div,type,
    adjust_div: product_prod(int,int) > int ).

tff(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: ( int * int * product_prod(int,int) ) > $o ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( product_prod(A,A) > $o ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( ( num * num ) > product_prod(A,A) ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( ( num * product_prod(A,A) ) > product_prod(A,A) ) ).

tff(sy_c_Equiv__Relations_Ocongruent,type,
    equiv_congruent: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(A,B) ) > $o ) ).

tff(sy_c_Equiv__Relations_Ocongruent2,type,
    equiv_congruent2: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) * fun(A,fun(B,C)) ) > $o ) ).

tff(sy_c_Equiv__Relations_Oequiv,type,
    equiv_equiv: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Equiv__Relations_Oequivp,type,
    equiv_equivp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Equiv__Relations_Oproj,type,
    equiv_proj: 
      !>[B: $tType,A: $tType] : ( set(product_prod(B,A)) > fun(B,set(A)) ) ).

tff(sy_c_Equiv__Relations_Oquotient,type,
    equiv_quotient: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > set(set(A)) ) ).

tff(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( ( A * nat ) > A ) ).

tff(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Ocofinite,type,
    cofinite: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( fun(A,$o) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofilter_OAbs__filter,type,
    abs_filter: 
      !>[A: $tType] : ( fun(fun(A,$o),$o) > filter(A) ) ).

tff(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) ) > filter(A) ) ).

tff(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( set(A) > filter(set(A)) ) ).

tff(sy_c_Filter_Ofrequently,type,
    frequently: 
      !>[A: $tType] : ( ( fun(A,$o) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( set(A) > filter(A) ) ).

tff(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * filter(B) ) > filter(product_prod(A,B)) ) ).

tff(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( set(B) > nat ) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__idem__axioms,type,
    finite1981172056906289455axioms: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__idem__on,type,
    finite673082921795544331dem_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__idem__on__axioms,type,
    finite4980608107308702382axioms: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : fun(set(A),$o) ).

tff(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > B ) ).

tff(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > fun(B,$o) ) ).

tff(sy_c_Finite__Set_Ofolding,type,
    finite_folding: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__idem,type,
    finite_folding_idem: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__idem__axioms,type,
    finite7837460588564673216axioms: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,B)) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__idem__on,type,
    finite1890593828518410140dem_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__idem__on__axioms,type,
    finite6916993218817215295axioms: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > B ) ).

tff(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) * set(B) ) > $o ) ).

tff(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : fun(fun(B,C),fun(fun(A,B),fun(A,C))) ).

tff(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A * B ) > fun(A,B) ) ).

tff(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( fun(C,A) * fun(B,D) ) > fun(fun(A,B),fun(C,D)) ) ).

tff(sy_c_Fun_Ooverride__on,type,
    override_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(A,B) * set(A) ) > fun(A,B) ) ).

tff(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > fun(B,A) ) ).

tff(sy_c_Fun__Def_Ois__measure,type,
    fun_is_measure: 
      !>[A: $tType] : ( fun(A,nat) > $o ) ).

tff(sy_c_Fun__Def_Omax__strict,type,
    fun_max_strict: set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))) ).

tff(sy_c_Fun__Def_Omax__weak,type,
    fun_max_weak: set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))) ).

tff(sy_c_Fun__Def_Omin__strict,type,
    fun_min_strict: set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))) ).

tff(sy_c_Fun__Def_Omin__weak,type,
    fun_min_weak: set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))) ).

tff(sy_c_Fun__Def_Opair__leq,type,
    fun_pair_leq: set(product_prod(product_prod(nat,nat),product_prod(nat,nat))) ).

tff(sy_c_Fun__Def_Opair__less,type,
    fun_pair_less: set(product_prod(product_prod(nat,nat),product_prod(nat,nat))) ).

tff(sy_c_Fun__Def_Oreduction__pair,type,
    fun_reduction_pair: 
      !>[A: $tType] : ( product_prod(set(product_prod(A,A)),set(product_prod(A,A))) > $o ) ).

tff(sy_c_Fun__Def_Orp__inv__image,type,
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] : fun(product_prod(set(product_prod(A,A)),set(product_prod(A,A))),fun(fun(B,A),product_prod(set(product_prod(B,B)),set(product_prod(B,B))))) ).

tff(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_OGcd__class_OLcm,type,
    gcd_Lcm: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_Obezw,type,
    bezw: ( nat * nat ) > product_prod(int,int) ).

tff(sy_c_GCD_Obezw__rel,type,
    bezw_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_GCD_Obounded__quasi__semilattice,type,
    bounde8507323023520639062attice: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A ) > fun(set(A),A) ) ).

tff(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__class_Olcm,type,
    gcd_lcm: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_GCD_Osemiring__gcd__class_OLcm__fin,type,
    semiring_gcd_Lcm_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Groups_Oabel__semigroup,type,
    abel_semigroup: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Oabel__semigroup__axioms,type,
    abel_s757365448890700780axioms: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ocomm__monoid,type,
    comm_monoid: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Ocomm__monoid__axioms,type,
    comm_monoid_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Ogroup,type,
    group: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,A) ) > $o ) ).

tff(sy_c_Groups_Ogroup__axioms,type,
    group_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,A) ) > $o ) ).

tff(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Omonoid,type,
    monoid: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Omonoid__axioms,type,
    monoid_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

tff(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Osemigroup,type,
    semigroup: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

tff(sy_c_Groups__Big_Ocomm__monoid__add_Osum,type,
    groups3894954378712506084id_sum: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A * fun(B,A) * set(B) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : fun(fun(C,A),fun(set(C),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set,type,
    groups778175481326437816id_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set_OF,type,
    groups_comm_monoid_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(fun(B,A),fun(set(B),A)) ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__set_OG,type,
    groups_comm_monoid_G: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(fun(B,A),fun(set(B),A)) ) ).

tff(sy_c_Groups__List_Ocomm__monoid__list,type,
    groups1828464146339083142d_list: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Ocomm__monoid__list__set,type,
    groups4802862169904069756st_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(A,fun(list(B),A))) ).

tff(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_Groups__List_Omonoid__list,type,
    groups_monoid_list: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Groups__List_Omonoid__list_OF,type,
    groups_monoid_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(list(A),A) ) ).

tff(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_HOL_OUniq,type,
    uniq: 
      !>[A: $tType] : ( fun(A,$o) > $o ) ).

tff(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

tff(sy_c_Heap_Oaddr__of__array,type,
    addr_of_array: 
      !>[A: $tType] : ( array(A) > nat ) ).

tff(sy_c_Heap_Oaddr__of__ref,type,
    addr_of_ref: 
      !>[A: $tType] : fun(ref(A),nat) ).

tff(sy_c_Heap_Oarray_OArray,type,
    array2: 
      !>[A: $tType] : ( nat > array(A) ) ).

tff(sy_c_Heap_Oheap_Oarrays,type,
    arrays: 
      !>[Z: $tType] : ( ( heap_ext(Z) * typerep * nat ) > list(nat) ) ).

tff(sy_c_Heap_Oheap_Olim,type,
    lim: 
      !>[Z: $tType] : ( heap_ext(Z) > nat ) ).

tff(sy_c_Heap_Oheap_Olim__update,type,
    lim_update: 
      !>[Z: $tType] : ( ( fun(nat,nat) * heap_ext(Z) ) > heap_ext(Z) ) ).

tff(sy_c_Heap_Oheap_Orefs,type,
    refs: 
      !>[Z: $tType] : ( ( heap_ext(Z) * typerep ) > fun(nat,nat) ) ).

tff(sy_c_Heap_Oref_ORef,type,
    ref2: 
      !>[A: $tType] : ( nat > ref(A) ) ).

tff(sy_c_Heap__Time__Monad_OHeap_OHeap,type,
    heap_Time_Heap2: 
      !>[A: $tType] : fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_OHeap_Ocase__Heap,type,
    heap_Time_case_Heap: 
      !>[A: $tType,B: $tType] : fun(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),B),fun(heap_Time_Heap(A),B)) ).

tff(sy_c_Heap__Time__Monad_OHeap_Omap__Heap,type,
    heap_Time_map_Heap: 
      !>[A: $tType,Aa: $tType] : fun(fun(A,Aa),fun(heap_Time_Heap(A),heap_Time_Heap(Aa))) ).

tff(sy_c_Heap__Time__Monad_OHeap_Opred__Heap,type,
    heap_Time_pred_Heap: 
      !>[A: $tType] : fun(fun(A,$o),fun(heap_Time_Heap(A),$o)) ).

tff(sy_c_Heap__Time__Monad_OHeap_Orec__Heap,type,
    heap_Time_rec_Heap: 
      !>[A: $tType,C: $tType] : fun(fun(fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(A),C)) ).

tff(sy_c_Heap__Time__Monad_OHeap_Orel__Heap,type,
    heap_Time_rel_Heap: 
      !>[A: $tType,B: $tType] : fun(fun(A,fun(B,$o)),fun(heap_Time_Heap(A),fun(heap_Time_Heap(B),$o))) ).

tff(sy_c_Heap__Time__Monad_OHeap_Oset__Heap,type,
    heap_Time_set_Heap: 
      !>[A: $tType] : fun(heap_Time_Heap(A),set(A)) ).

tff(sy_c_Heap__Time__Monad_OHeap_Osize__Heap,type,
    heap_Time_size_Heap: 
      !>[A: $tType] : ( fun(A,nat) > fun(heap_Time_Heap(A),nat) ) ).

tff(sy_c_Heap__Time__Monad_OHeap__lub,type,
    heap_Time_Heap_lub: 
      !>[A: $tType] : fun(set(heap_Time_Heap(A)),heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_OHeap__ord,type,
    heap_Time_Heap_ord: 
      !>[A: $tType] : fun(heap_Time_Heap(A),fun(heap_Time_Heap(A),$o)) ).

tff(sy_c_Heap__Time__Monad_Oassert,type,
    heap_Time_assert: 
      !>[A: $tType] : ( ( fun(A,$o) * A ) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Obind,type,
    heap_Time_bind: 
      !>[A: $tType,B: $tType] : ( ( heap_Time_Heap(A) * fun(A,heap_Time_Heap(B)) ) > heap_Time_Heap(B) ) ).

tff(sy_c_Heap__Time__Monad_Oeffect,type,
    heap_Time_effect: 
      !>[A: $tType] : ( ( heap_Time_Heap(A) * heap_ext(product_unit) * heap_ext(product_unit) * A * nat ) > $o ) ).

tff(sy_c_Heap__Time__Monad_Oexecute,type,
    heap_Time_execute: 
      !>[A: $tType] : fun(heap_Time_Heap(A),fun(heap_ext(product_unit),option(product_prod(A,product_prod(heap_ext(product_unit),nat))))) ).

tff(sy_c_Heap__Time__Monad_Oguard,type,
    heap_Time_guard: 
      !>[A: $tType] : ( ( fun(heap_ext(product_unit),$o) * fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Oheap,type,
    heap_Time_heap: 
      !>[A: $tType] : ( fun(heap_ext(product_unit),product_prod(A,product_prod(heap_ext(product_unit),nat))) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Olift,type,
    heap_Time_lift: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(A,heap_Time_Heap(B)) ) ).

tff(sy_c_Heap__Time__Monad_Oraise,type,
    heap_Time_raise: 
      !>[A: $tType] : ( list(char) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_Oreturn,type,
    heap_Time_return: 
      !>[A: $tType] : fun(A,heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_Osuccess,type,
    heap_Time_success: 
      !>[A: $tType] : ( ( heap_Time_Heap(A) * heap_ext(product_unit) ) > $o ) ).

tff(sy_c_Heap__Time__Monad_Otap,type,
    heap_Time_tap: 
      !>[A: $tType] : ( fun(heap_ext(product_unit),A) > heap_Time_Heap(A) ) ).

tff(sy_c_Heap__Time__Monad_OtimeFrame,type,
    heap_Time_timeFrame: 
      !>[A: $tType] : ( ( nat * option(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) > option(product_prod(A,product_prod(heap_ext(product_unit),nat))) ) ).

tff(sy_c_Heap__Time__Monad_OtimeFrame__rel,type,
    heap_T5500966940807335491me_rel: 
      !>[A: $tType] : fun(product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),fun(product_prod(nat,option(product_prod(A,product_prod(heap_ext(product_unit),nat)))),$o)) ).

tff(sy_c_Heap__Time__Monad_Oureturn,type,
    heap_Time_ureturn: 
      !>[A: $tType] : fun(A,heap_Time_Heap(A)) ).

tff(sy_c_Heap__Time__Monad_Owait,type,
    heap_Time_wait: nat > heap_Time_Heap(product_unit) ).

tff(sy_c_Hilbert__Choice_Obijection,type,
    hilbert_bijection: 
      !>[A: $tType] : ( fun(A,A) > $o ) ).

tff(sy_c_Hilbert__Choice_Oinv__into,type,
    hilbert_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > fun(B,A) ) ).

tff(sy_c_Hoare__Triple_Ohoare__triple,type,
    hoare_hoare_triple: 
      !>[A: $tType] : ( ( assn * heap_Time_Heap(A) * fun(A,assn) ) > $o ) ).

tff(sy_c_Hoare__Triple_Onew__addrs,type,
    hoare_new_addrs: ( heap_ext(product_unit) * set(nat) * heap_ext(product_unit) ) > set(nat) ).

tff(sy_c_Inductive_Ocomplete__lattice__class_Ogfp,type,
    complete_lattice_gfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Inductive_Ocomplete__lattice__class_Olfp,type,
    complete_lattice_lfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set(A) * nat ) > A ) ).

tff(sy_c_Int_OAbs__Integ,type,
    abs_Integ: fun(product_prod(nat,nat),int) ).

tff(sy_c_Int_ORep__Integ,type,
    rep_Integ: fun(int,product_prod(nat,nat)) ).

tff(sy_c_Int_Ointrel,type,
    intrel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_Int_Onat,type,
    nat2: fun(int,nat) ).

tff(sy_c_Int_Opcr__int,type,
    pcr_int: fun(product_prod(nat,nat),fun(int,$o)) ).

tff(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( ( A * int ) > A ) ).

tff(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : fun(int,A) ).

tff(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices_Osemilattice,type,
    semilattice: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices_Osemilattice__axioms,type,
    semilattice_axioms: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices_Osemilattice__neutr,type,
    semilattice_neutr: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__order,type,
    semilattice_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices_Osemilattice__order__axioms,type,
    semila6385135966242565138axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Oord__class_Ois__arg__min,type,
    lattic501386751177426532rg_min: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(B,$o) * B ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf_OInf__fin,type,
    lattic8678736583308907530nf_fin: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Osemilattice__neutr__set,type,
    lattic5652469242046573047tr_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__neutr__set_OF,type,
    lattic5214292709420241887eutr_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__set,type,
    lattic149705377957585745ce_set: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__set_OF,type,
    lattic1715443433743089157tice_F: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup_OSup__fin,type,
    lattic4630905495605216202up_fin: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * set(A) ) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lifting_OQuotient,type,
    quotient: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,B) * fun(B,A) * fun(A,fun(B,$o)) ) > $o ) ).

tff(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : fun(list(A),fun(list(A),list(A))) ).

tff(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * list(A) ) > A ) ).

tff(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,B),list(A)),fun(product_prod(fun(A,B),list(A)),$o)) ).

tff(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( list(list(A)) > list(A) ) ).

tff(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( list(A) > set(A) ) ).

tff(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( list(A) > $o ) ).

tff(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(product_prod(nat,A)) ) ).

tff(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > option(product_prod(list(A),product_prod(A,list(A)))) ) ).

tff(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > option(A) ) ).

tff(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * set(B) * fun(B,A) ) > $o ) ).

tff(sy_c_List_Ofoldl,type,
    foldl: 
      !>[B: $tType,A: $tType] : ( ( fun(B,fun(A,B)) * B * list(A) ) > B ) ).

tff(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * nat ) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * B ) > fun(list(B),list(B)) ) ).

tff(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * set(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * B ) > fun(list(B),list(B)) ) ).

tff(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( set(A) > list(A) ) ).

tff(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : fun(A,fun(list(A),list(A))) ).

tff(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : list(A) ).

tff(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,fun(list(A),B)) * list(A) ) > B ) ).

tff(sy_c_List_Olist_Olist__all,type,
    list_all: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > $o ) ).

tff(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(list(A),fun(list(B),$o)) ) ).

tff(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(list(A),list(Aa)) ) ).

tff(sy_c_List_Olist_Orec__list,type,
    rec_list: 
      !>[C: $tType,A: $tType] : ( ( C * fun(A,fun(list(A),fun(C,C))) ) > fun(list(A),C) ) ).

tff(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : fun(list(A),set(A)) ).

tff(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( fun(A,nat) > fun(list(A),nat) ) ).

tff(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list(A) * nat * A ) > list(A) ) ).

tff(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(list(A),list(B))) ) ).

tff(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(list(A),fun(list(B),$o)) ) ).

tff(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( set(A) > set(list(A)) ) ).

tff(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( list(set(A)) > set(list(A)) ) ).

tff(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * list(A) ) > list(B) ) ).

tff(sy_c_List_Omap__tailrec__rev,type,
    map_tailrec_rev: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * list(A) * list(B) ) > list(B) ) ).

tff(sy_c_List_Omap__tailrec__rev__rel,type,
    map_tailrec_rev_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,B),product_prod(list(A),list(B))),fun(product_prod(fun(A,B),product_prod(list(A),list(B))),$o)) ).

tff(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( list(fun(A,nat)) > set(product_prod(A,A)) ) ).

tff(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list(A) * nat ) > A ) ).

tff(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list(A) * set(nat) ) > list(A) ) ).

tff(sy_c_List_Oord__class_Olexordp,type,
    ord_lexordp: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > $o ) ).

tff(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( fun(A,$o) > fun(list(A),product_prod(list(A),list(A))) ) ).

tff(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( ( nat * A ) > list(A) ) ).

tff(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > fun(list(A),list(A)) ) ).

tff(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set(A) * set(list(A)) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > set(list(A)) ) ).

tff(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),$o)) ).

tff(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) ) > $o ) ).

tff(sy_c_List_Osorted__wrt__rel,type,
    sorted_wrt_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,$o)),list(A)),fun(product_prod(fun(A,fun(A,$o)),list(A)),$o)) ).

tff(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_List_Osplice__rel,type,
    splice_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),$o)) ).

tff(sy_c_List_Osuccessively,type,
    successively: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) ) > $o ) ).

tff(sy_c_List_Osuccessively__rel,type,
    successively_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,$o)),list(A)),fun(product_prod(fun(A,fun(A,$o)),list(A)),$o)) ).

tff(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oupt,type,
    upt: ( nat * nat ) > list(nat) ).

tff(sy_c_List_Oupto,type,
    upto: ( int * int ) > list(int) ).

tff(sy_c_List_Oupto__rel,type,
    upto_rel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(A) ) ).

tff(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(product_prod(A,B)) ) ).

tff(sy_c_Map_Omap__add,type,
    map_add: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * fun(A,option(B)) ) > fun(A,option(B)) ) ).

tff(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( list(product_prod(A,B)) > fun(A,option(B)) ) ).

tff(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(B) ) ).

tff(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * set(A) ) > fun(A,option(B)) ) ).

tff(sy_c_Misc_OEps__Opt,type,
    eps_Opt: 
      !>[A: $tType] : ( fun(A,$o) > option(A) ) ).

tff(sy_c_Misc_Obijective,type,
    bijective: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > $o ) ).

tff(sy_c_Misc_Obrk__rel,type,
    brk_rel: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(product_prod($o,A),product_prod($o,B))) ) ).

tff(sy_c_Misc_Odflt__None__set,type,
    dflt_None_set: 
      !>[A: $tType] : ( set(A) > option(set(A)) ) ).

tff(sy_c_Misc_Ofilter__rev,type,
    filter_rev: 
      !>[A: $tType] : ( fun(A,$o) > fun(list(A),list(A)) ) ).

tff(sy_c_Misc_Ofun__of__rel,type,
    fun_of_rel: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,A)) * B ) > A ) ).

tff(sy_c_Misc_Olist__all__zip,type,
    list_all_zip: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,$o)) * list(A) * list(B) ) > $o ) ).

tff(sy_c_Misc_Olist__all__zip__rel,type,
    list_all_zip_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,fun(B,$o)),product_prod(list(A),list(B))),fun(product_prod(fun(A,fun(B,$o)),product_prod(list(A),list(B))),$o)) ).

tff(sy_c_Misc_Olist__collect__set,type,
    list_collect_set: 
      !>[B: $tType,A: $tType] : ( ( fun(B,set(A)) * list(B) ) > set(A) ) ).

tff(sy_c_Misc_Omap__mmupd,type,
    map_mmupd: 
      !>[B: $tType,A: $tType] : ( ( fun(B,option(A)) * set(B) * A ) > fun(B,option(A)) ) ).

tff(sy_c_Misc_Omap__to__set,type,
    map_to_set: 
      !>[A: $tType,B: $tType] : ( fun(A,option(B)) > set(product_prod(A,B)) ) ).

tff(sy_c_Misc_Omerge,type,
    merge: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Omerge__rel,type,
    merge_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),$o)) ).

tff(sy_c_Misc_Omergesort__by__rel,type,
    mergesort_by_rel: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Omergesort__by__rel__merge,type,
    merges9089515139780605204_merge: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Omergesort__by__rel__merge__rel,type,
    merges2244889521215249637ge_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,$o)),product_prod(list(A),list(A))),fun(product_prod(fun(A,fun(A,$o)),product_prod(list(A),list(A))),$o)) ).

tff(sy_c_Misc_Omergesort__by__rel__rel,type,
    mergesort_by_rel_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,$o)),list(A)),fun(product_prod(fun(A,fun(A,$o)),list(A)),$o)) ).

tff(sy_c_Misc_Omergesort__by__rel__split,type,
    merges295452479951948502_split: 
      !>[A: $tType] : ( ( product_prod(list(A),list(A)) * list(A) ) > product_prod(list(A),list(A)) ) ).

tff(sy_c_Misc_Omergesort__by__rel__split__rel,type,
    merges7066485432131860899it_rel: 
      !>[A: $tType] : fun(product_prod(product_prod(list(A),list(A)),list(A)),fun(product_prod(product_prod(list(A),list(A)),list(A)),$o)) ).

tff(sy_c_Misc_Opairself,type,
    pairself: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(product_prod(A,A),product_prod(B,B)) ) ).

tff(sy_c_Misc_Opairself__rel,type,
    pairself_rel: 
      !>[A: $tType,B: $tType] : fun(product_prod(fun(A,B),product_prod(A,A)),fun(product_prod(fun(A,B),product_prod(A,A)),$o)) ).

tff(sy_c_Misc_Opartition__rev,type,
    partition_rev: 
      !>[A: $tType] : ( ( fun(A,$o) * product_prod(list(A),list(A)) * list(A) ) > product_prod(list(A),list(A)) ) ).

tff(sy_c_Misc_Opartition__rev__rel,type,
    partition_rev_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,$o),product_prod(product_prod(list(A),list(A)),list(A))),fun(product_prod(fun(A,$o),product_prod(product_prod(list(A),list(A)),list(A))),$o)) ).

tff(sy_c_Misc_Oquicksort__by__rel,type,
    quicksort_by_rel: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Oquicksort__by__rel__rel,type,
    quicksort_by_rel_rel: 
      !>[A: $tType] : fun(product_prod(fun(A,fun(A,$o)),product_prod(list(A),list(A))),fun(product_prod(fun(A,fun(A,$o)),product_prod(list(A),list(A))),$o)) ).

tff(sy_c_Misc_Orel__of,type,
    rel_of: 
      !>[A: $tType,B: $tType] : ( ( fun(A,option(B)) * fun(product_prod(A,B),$o) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Misc_Orel__restrict,type,
    rel_restrict: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Misc_Oremove__rev,type,
    remove_rev: 
      !>[A: $tType] : ( A > fun(list(A),list(A)) ) ).

tff(sy_c_Misc_Orevg,type,
    revg: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_Misc_Orevg__rel,type,
    revg_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),$o)) ).

tff(sy_c_Misc_Oset__to__map,type,
    set_to_map: 
      !>[B: $tType,A: $tType] : ( set(product_prod(B,A)) > fun(B,option(A)) ) ).

tff(sy_c_Misc_Osu__rel__fun,type,
    su_rel_fun: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,B)) * fun(A,B) ) > $o ) ).

tff(sy_c_Misc_Othe__default,type,
    the_default: 
      !>[A: $tType] : ( ( A * option(A) ) > A ) ).

tff(sy_c_Misc_Ouncurry,type,
    uncurry: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,C)) * product_prod(A,B) ) > C ) ).

tff(sy_c_Misc_Ozipf,type,
    zipf: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,C)) * list(A) * list(B) ) > list(C) ) ).

tff(sy_c_Misc_Ozipf__rel,type,
    zipf_rel: 
      !>[A: $tType,B: $tType,C: $tType] : fun(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),fun(product_prod(fun(A,fun(B,C)),product_prod(list(A),list(B))),$o)) ).

tff(sy_c_Multiset_Oadd__mset,type,
    add_mset: 
      !>[A: $tType] : fun(A,fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Ocomm__monoid__add__class_Osum__mset,type,
    comm_m7189776963980413722m_mset: 
      !>[A: $tType] : ( multiset(A) > A ) ).

tff(sy_c_Multiset_Ocomm__monoid__mset,type,
    comm_monoid_mset: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > $o ) ).

tff(sy_c_Multiset_Ocomm__monoid__mset_OF,type,
    comm_monoid_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A ) > fun(multiset(A),A) ) ).

tff(sy_c_Multiset_Ocomm__monoid__mult__class_Oprod__mset,type,
    comm_m9189036328036947845d_mset: 
      !>[A: $tType] : fun(multiset(A),A) ).

tff(sy_c_Multiset_Ofold__mset,type,
    fold_mset: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B ) > fun(multiset(A),B) ) ).

tff(sy_c_Multiset_Oimage__mset,type,
    image_mset: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(multiset(A),multiset(B)) ) ).

tff(sy_c_Multiset_Ointer__mset,type,
    inter_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Olinorder__class_Opart,type,
    linorder_part: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * A * list(B) ) > product_prod(list(B),product_prod(list(B),list(B))) ) ).

tff(sy_c_Multiset_Oms__strict,type,
    ms_strict: set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))) ).

tff(sy_c_Multiset_Oms__weak,type,
    ms_weak: set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))) ).

tff(sy_c_Multiset_Omset,type,
    mset: 
      !>[A: $tType] : fun(list(A),multiset(A)) ).

tff(sy_c_Multiset_Omset__set,type,
    mset_set: 
      !>[B: $tType] : ( set(B) > multiset(B) ) ).

tff(sy_c_Multiset_Omult,type,
    mult: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(multiset(A),multiset(A))) ) ).

tff(sy_c_Multiset_Omult1,type,
    mult1: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(multiset(A),multiset(A))) ) ).

tff(sy_c_Multiset_Omulteqp__code,type,
    multeqp_code: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * multiset(A) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Omultiset_OAbs__multiset,type,
    abs_multiset: 
      !>[A: $tType] : fun(fun(A,nat),multiset(A)) ).

tff(sy_c_Multiset_Omultiset_Ocount,type,
    count: 
      !>[A: $tType] : fun(multiset(A),fun(A,nat)) ).

tff(sy_c_Multiset_Omultp,type,
    multp: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * multiset(A) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Omultp__code,type,
    multp_code: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * multiset(A) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Opcr__multiset,type,
    pcr_multiset: 
      !>[C: $tType,B: $tType] : ( fun(C,fun(B,$o)) > fun(fun(C,nat),fun(multiset(B),$o)) ) ).

tff(sy_c_Multiset_Opred__mset,type,
    pred_mset: 
      !>[A: $tType] : ( ( fun(A,$o) * multiset(A) ) > $o ) ).

tff(sy_c_Multiset_Opw__leq,type,
    pw_leq: ( multiset(product_prod(nat,nat)) * multiset(product_prod(nat,nat)) ) > $o ).

tff(sy_c_Multiset_Oreplicate__mset,type,
    replicate_mset: 
      !>[A: $tType] : ( ( nat * A ) > multiset(A) ) ).

tff(sy_c_Multiset_Oset__mset,type,
    set_mset: 
      !>[A: $tType] : fun(multiset(A),set(A)) ).

tff(sy_c_Multiset_Osize__multiset,type,
    size_multiset: 
      !>[A: $tType] : ( fun(A,nat) > fun(multiset(A),nat) ) ).

tff(sy_c_Multiset_Osubset__eq__mset__impl,type,
    subset_eq_mset_impl: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > option($o) ) ).

tff(sy_c_Multiset_Osubset__eq__mset__impl__rel,type,
    subset751672762298770561pl_rel: 
      !>[A: $tType] : fun(product_prod(list(A),list(A)),fun(product_prod(list(A),list(A)),$o)) ).

tff(sy_c_Multiset_Osubset__mset,type,
    subset_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),$o)) ).

tff(sy_c_Multiset_Osubseteq__mset,type,
    subseteq_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),$o)) ).

tff(sy_c_Multiset_Ounion__mset,type,
    union_mset: 
      !>[A: $tType] : fun(multiset(A),fun(multiset(A),multiset(A))) ).

tff(sy_c_Multiset_Owcount,type,
    wcount: 
      !>[A: $tType] : ( ( fun(A,nat) * multiset(A) ) > fun(A,nat) ) ).

tff(sy_c_Nat_OSuc,type,
    suc: fun(nat,nat) ).

tff(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( ( A * fun(nat,A) * nat ) > A ) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : fun(nat,A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( fun(A,A) * nat * A ) > A ) ).

tff(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

tff(sy_c_Nat__Bijection_Olist__decode__rel,type,
    nat_list_decode_rel: fun(nat,fun(nat,$o)) ).

tff(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: list(nat) > nat ).

tff(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: fun(list(nat),fun(list(nat),$o)) ).

tff(sy_c_Nat__Bijection_Oprod__decode,type,
    nat_prod_decode: nat > product_prod(nat,nat) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: product_prod(nat,nat) > nat ).

tff(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > set(nat) ).

tff(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: set(nat) > nat ).

tff(sy_c_Nat__Bijection_Osum__decode,type,
    nat_sum_decode: nat > sum_sum(nat,nat) ).

tff(sy_c_Num_OBitM,type,
    bitM: num > num ).

tff(sy_c_Num_Oinc,type,
    inc: num > num ).

tff(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Ois__num,type,
    neg_numeral_is_num: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( ( num * num ) > A ) ).

tff(sy_c_Num_Onum_OBit0,type,
    bit0: fun(num,num) ).

tff(sy_c_Num_Onum_OBit1,type,
    bit1: fun(num,num) ).

tff(sy_c_Num_Onum_OOne,type,
    one2: num ).

tff(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( ( A * fun(num,A) * fun(num,A) * num ) > A ) ).

tff(sy_c_Num_Onum__of__nat,type,
    num_of_nat: fun(nat,num) ).

tff(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : fun(num,A) ).

tff(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

tff(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Osqr,type,
    sqr: num > num ).

tff(sy_c_Old__Datatype_OAtom,type,
    old_Atom: 
      !>[A: $tType,B: $tType] : fun(sum_sum(A,nat),set(old_node(A,B))) ).

tff(sy_c_Old__Datatype_OIn0,type,
    old_In0: 
      !>[A: $tType,B: $tType] : ( set(old_node(A,B)) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OIn1,type,
    old_In1: 
      !>[A: $tType,B: $tType] : ( set(old_node(A,B)) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_OLeaf,type,
    old_Leaf: 
      !>[A: $tType,B: $tType] : fun(A,set(old_node(A,B))) ).

tff(sy_c_Old__Datatype_ONode,type,
    old_Node: 
      !>[B: $tType,A: $tType] : set(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat))) ).

tff(sy_c_Old__Datatype_ONumb,type,
    old_Numb: 
      !>[A: $tType,B: $tType] : fun(nat,set(old_node(A,B))) ).

tff(sy_c_Old__Datatype_OScons,type,
    old_Scons: 
      !>[A: $tType,B: $tType] : ( ( set(old_node(A,B)) * set(old_node(A,B)) ) > set(old_node(A,B)) ) ).

tff(sy_c_Old__Datatype_Odprod,type,
    old_dprod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) * set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) > set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) ).

tff(sy_c_Old__Datatype_Odsum,type,
    old_dsum: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) * set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) > set(product_prod(set(old_node(A,B)),set(old_node(A,B)))) ) ).

tff(sy_c_Old__Datatype_Ondepth,type,
    old_ndepth: 
      !>[A: $tType,B: $tType] : ( old_node(A,B) > nat ) ).

tff(sy_c_Old__Datatype_Onode_OAbs__Node,type,
    old_Abs_Node: 
      !>[B: $tType,A: $tType] : ( product_prod(fun(nat,sum_sum(B,nat)),sum_sum(A,nat)) > old_node(A,B) ) ).

tff(sy_c_Old__Datatype_Ontrunc,type,
    old_ntrunc: 
      !>[A: $tType,B: $tType] : ( nat > fun(set(old_node(A,B)),set(old_node(A,B))) ) ).

tff(sy_c_Old__Datatype_Ouprod,type,
    old_uprod: 
      !>[A: $tType,B: $tType] : ( ( set(set(old_node(A,B))) * set(set(old_node(A,B))) ) > set(set(old_node(A,B))) ) ).

tff(sy_c_Option_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( option(A) * fun(A,option(B)) ) > option(B) ) ).

tff(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : option(A) ).

tff(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : fun(A,option(A)) ).

tff(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,B) * option(A) ) > B ) ).

tff(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( fun(A,Aa) > fun(option(A),option(Aa)) ) ).

tff(sy_c_Option_Ooption_Opred__option,type,
    pred_option: 
      !>[A: $tType] : ( fun(A,$o) > fun(option(A),$o) ) ).

tff(sy_c_Option_Ooption_Orec__option,type,
    rec_option: 
      !>[C: $tType,A: $tType] : ( ( C * fun(A,C) ) > fun(option(A),C) ) ).

tff(sy_c_Option_Ooption_Orel__option,type,
    rel_option: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(option(A),fun(option(B),$o)) ) ).

tff(sy_c_Option_Ooption_Oset__option,type,
    set_option: 
      !>[A: $tType] : fun(option(A),set(A)) ).

tff(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( fun(A,nat) > fun(option(A),nat) ) ).

tff(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : fun(option(A),A) ).

tff(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( set(option(A)) > set(A) ) ).

tff(sy_c_Order__Relation_OAbove,type,
    order_Above: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OAboveS,type,
    order_AboveS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OUnder,type,
    order_Under: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_OUnderS,type,
    order_UnderS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > set(A) ) ).

tff(sy_c_Order__Relation_Oabove,type,
    order_above: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_OaboveS,type,
    order_aboveS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_Olinear__order__on,type,
    order_679001287576687338der_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Oofilter,type,
    order_ofilter: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * set(A) ) > $o ) ).

tff(sy_c_Order__Relation_Opartial__order__on,type,
    order_7125193373082350890der_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Opreorder__on,type,
    order_preorder_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Order__Relation_Orelation__of,type,
    order_relation_of: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * set(A) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Order__Relation_Ounder,type,
    order_under: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_OunderS,type,
    order_underS: 
      !>[A: $tType] : ( ( set(product_prod(A,A)) * A ) > set(A) ) ).

tff(sy_c_Order__Relation_Owell__order__on,type,
    order_well_order_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

tff(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(fun(A,$o),A) ) ).

tff(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oorder_Omono,type,
    mono: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(A,$o)) > fun(fun(A,B),$o) ) ).

tff(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oordering,type,
    ordering: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Orderings_Oordering__axioms,type,
    ordering_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * A ) > $o ) ).

tff(sy_c_Orderings_Oordering__top__axioms,type,
    ordering_top_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > $o ) ).

tff(sy_c_Orderings_Opartial__preordering,type,
    partial_preordering: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Orderings_Opreordering,type,
    preordering: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Orderings_Opreordering__axioms,type,
    preordering_axioms: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

tff(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( A > fun(set(A),A) ) ).

tff(sy_c_Partial__Function_Oflat__ord,type,
    partial_flat_ord: 
      !>[A: $tType] : ( A > fun(A,fun(A,$o)) ) ).

tff(sy_c_Partial__Function_Ofun__lub,type,
    partial_fun_lub: 
      !>[C: $tType,B: $tType,A: $tType] : ( fun(set(C),B) > fun(set(fun(A,C)),fun(A,B)) ) ).

tff(sy_c_Partial__Function_Ofun__ord,type,
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,$o)) > fun(fun(C,A),fun(fun(C,B),$o)) ) ).

tff(sy_c_Partial__Function_Oimg__lub,type,
    partial_img_lub: 
      !>[A: $tType,C: $tType,D: $tType,B: $tType] : ( ( fun(A,C) * fun(D,B) * fun(set(C),D) ) > fun(set(A),B) ) ).

tff(sy_c_Partial__Function_Oimg__ord,type,
    partial_img_ord: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( fun(A,C) * fun(C,fun(C,B)) ) > fun(A,fun(A,B)) ) ).

tff(sy_c_Partial__Function_Opartial__function__definitions,type,
    partia7178651479351089652itions: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(set(A),A) ) > $o ) ).

tff(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : fun(A,fun(nat,A)) ).

tff(sy_c_Predicate_OSeq,type,
    seq2: 
      !>[A: $tType] : ( fun(product_unit,seq(A)) > pred(A) ) ).

tff(sy_c_Predicate_Obind,type,
    bind2: 
      !>[A: $tType,B: $tType] : ( ( pred(A) * fun(A,pred(B)) ) > pred(B) ) ).

tff(sy_c_Predicate_Oif__pred,type,
    if_pred: $o > pred(product_unit) ).

tff(sy_c_Predicate_Ois__empty,type,
    is_empty: 
      !>[A: $tType] : ( pred(A) > $o ) ).

tff(sy_c_Predicate_Oiterate__upto,type,
    iterate_upto: 
      !>[A: $tType] : ( ( fun(code_natural,A) * code_natural * code_natural ) > pred(A) ) ).

tff(sy_c_Predicate_Oiterate__upto__rel,type,
    iterate_upto_rel: 
      !>[A: $tType] : fun(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),fun(product_prod(fun(code_natural,A),product_prod(code_natural,code_natural)),$o)) ).

tff(sy_c_Predicate_Omap,type,
    map2: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(pred(A),pred(B)) ) ).

tff(sy_c_Predicate_Onot__pred,type,
    not_pred: pred(product_unit) > pred(product_unit) ).

tff(sy_c_Predicate_Opred_OPred,type,
    pred2: 
      !>[A: $tType] : fun(fun(A,$o),pred(A)) ).

tff(sy_c_Predicate_Opred_Oeval,type,
    eval: 
      !>[A: $tType] : fun(pred(A),fun(A,$o)) ).

tff(sy_c_Predicate_Opred__of__seq,type,
    pred_of_seq: 
      !>[A: $tType] : fun(seq(A),pred(A)) ).

tff(sy_c_Predicate_Opred__of__set,type,
    pred_of_set: 
      !>[A: $tType] : fun(set(A),pred(A)) ).

tff(sy_c_Predicate_Oseq_OEmpty,type,
    empty: 
      !>[A: $tType] : seq(A) ).

tff(sy_c_Predicate_Oseq_OInsert,type,
    insert: 
      !>[A: $tType] : ( ( A * pred(A) ) > seq(A) ) ).

tff(sy_c_Predicate_Oseq_Ocase__seq,type,
    case_seq: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,fun(pred(A),B)) * fun(pred(A),fun(seq(A),B)) * seq(A) ) > B ) ).

tff(sy_c_Predicate_Oset__of__pred,type,
    set_of_pred: 
      !>[A: $tType] : fun(pred(A),set(A)) ).

tff(sy_c_Predicate_Oset__of__seq,type,
    set_of_seq: 
      !>[A: $tType] : fun(seq(A),set(A)) ).

tff(sy_c_Predicate_Osingle,type,
    single: 
      !>[A: $tType] : fun(A,pred(A)) ).

tff(sy_c_Predicate_Osingleton,type,
    singleton: 
      !>[A: $tType] : ( ( fun(product_unit,A) * pred(A) ) > A ) ).

tff(sy_c_Predicate__Compile_Ocontains__pred,type,
    predic7144156976422707464s_pred: 
      !>[A: $tType] : ( ( set(A) * A ) > pred(product_unit) ) ).

tff(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : fun(A,fun(B,product_prod(A,B))) ).

tff(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_OUnity,type,
    product_Unity: product_unit ).

tff(sy_c_Product__Type_Oapfst,type,
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] : ( fun(A,C) > fun(product_prod(A,B),product_prod(C,B)) ) ).

tff(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : fun(fun(B,C),fun(product_prod(A,B),product_prod(A,C))) ).

tff(sy_c_Product__Type_Ocurry,type,
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(product_prod(A,B),C) * A * B ) > C ) ).

tff(sy_c_Product__Type_Ointernal__case__prod,type,
    produc5280177257484947105e_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,C)) * product_prod(A,B) ) > C ) ).

tff(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,C) * fun(B,D) ) > fun(product_prod(A,B),product_prod(C,D)) ) ).

tff(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( fun(A,fun(B,T)) * product_prod(A,B) ) > T ) ).

tff(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : fun(fun(A,fun(B,C)),fun(product_prod(A,B),C)) ).

tff(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),A) ).

tff(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),B) ).

tff(sy_c_Product__Type_Oprod_Oswap,type,
    product_swap: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),product_prod(B,A)) ).

tff(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_Oscomp,type,
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( fun(A,product_prod(B,C)) * fun(B,fun(C,D)) ) > fun(A,D) ) ).

tff(sy_c_Product__Type_Ounit_OAbs__unit,type,
    product_Abs_unit: fun($o,product_unit) ).

tff(sy_c_Product__Type_Ounit_ORep__unit,type,
    product_Rep_unit: fun(product_unit,$o) ).

tff(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : itself(A) ).

tff(sy_c_Quotient_OQuotient3,type,
    quotient3: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,B) * fun(B,A) ) > $o ) ).

tff(sy_c_Random_Oinc__shift,type,
    inc_shift: ( code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Oiterate,type,
    iterate: 
      !>[B: $tType,A: $tType] : ( ( code_natural * fun(B,fun(A,product_prod(B,A))) ) > fun(B,fun(A,product_prod(B,A))) ) ).

tff(sy_c_Random_Oiterate__rel,type,
    iterate_rel: 
      !>[B: $tType,A: $tType] : fun(product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),fun(product_prod(code_natural,product_prod(fun(B,fun(A,product_prod(B,A))),B)),$o)) ).

tff(sy_c_Random_Olog,type,
    log: ( code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Olog__rel,type,
    log_rel: fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),$o)) ).

tff(sy_c_Random_Ominus__shift,type,
    minus_shift: ( code_natural * code_natural * code_natural ) > code_natural ).

tff(sy_c_Random_Onext,type,
    next: fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))) ).

tff(sy_c_Random_Opick,type,
    pick: 
      !>[A: $tType] : ( ( list(product_prod(code_natural,A)) * code_natural ) > A ) ).

tff(sy_c_Random_Orange,type,
    range: code_natural > fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))) ).

tff(sy_c_Random_Oselect,type,
    select: 
      !>[A: $tType] : ( list(A) > fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random_Oselect__weight,type,
    select_weight: 
      !>[A: $tType] : ( list(product_prod(code_natural,A)) > fun(product_prod(code_natural,code_natural),product_prod(A,product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random_Osplit__seed,type,
    split_seed: product_prod(code_natural,code_natural) > product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)) ).

tff(sy_c_Random__Pred_ORandom,type,
    random_Random: 
      !>[A: $tType] : ( fun(product_prod(code_natural,code_natural),product_prod(product_prod(A,fun(product_unit,code_term)),product_prod(code_natural,code_natural))) > fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random__Pred_Obind,type,
    random_bind: 
      !>[A: $tType,B: $tType] : ( ( fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) * fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))) ) > fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random__Pred_Oempty,type,
    random_empty: 
      !>[A: $tType] : fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) ).

tff(sy_c_Random__Pred_Oiterate__upto,type,
    random_iterate_upto: 
      !>[A: $tType] : ( ( fun(code_natural,A) * code_natural * code_natural ) > fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random__Pred_Omap,type,
    random_map: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) ) > fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))) ) ).

tff(sy_c_Random__Pred_Onot__randompred,type,
    random6974930770145893639ompred: ( fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))) * product_prod(code_natural,code_natural) ) > product_prod(pred(product_unit),product_prod(code_natural,code_natural)) ).

tff(sy_c_Random__Pred_Osingle,type,
    random_single: 
      !>[A: $tType] : fun(A,fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural)))) ).

tff(sy_c_Random__Pred_Ounion,type,
    random_union: 
      !>[A: $tType] : ( ( fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) * fun(product_prod(code_natural,code_natural),product_prod(pred(A),product_prod(code_natural,code_natural))) * product_prod(code_natural,code_natural) ) > product_prod(pred(A),product_prod(code_natural,code_natural)) ) ).

tff(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: fun(product_prod(int,int),rat) ).

tff(sy_c_Rat_OFract,type,
    fract: fun(int,fun(int,rat)) ).

tff(sy_c_Rat_OFrct,type,
    frct: product_prod(int,int) > rat ).

tff(sy_c_Rat_ORep__Rat,type,
    rep_Rat: fun(rat,product_prod(int,int)) ).

tff(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : fun(rat,A) ).

tff(sy_c_Rat_Onormalize,type,
    normalize: product_prod(int,int) > product_prod(int,int) ).

tff(sy_c_Rat_Oof__int,type,
    of_int: int > rat ).

tff(sy_c_Rat_Opcr__rat,type,
    pcr_rat: fun(product_prod(int,int),fun(rat,$o)) ).

tff(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > product_prod(int,int) ).

tff(sy_c_Rat_Oratrel,type,
    ratrel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_Ref__Time_Oalloc,type,
    ref_alloc: 
      !>[A: $tType] : ( ( A * heap_ext(product_unit) ) > product_prod(ref(A),heap_ext(product_unit)) ) ).

tff(sy_c_Ref__Time_Ochange,type,
    ref_change: 
      !>[A: $tType] : ( ( fun(A,A) * ref(A) ) > heap_Time_Heap(A) ) ).

tff(sy_c_Ref__Time_Oget,type,
    ref_get: 
      !>[A: $tType] : ( heap_ext(product_unit) > fun(ref(A),A) ) ).

tff(sy_c_Ref__Time_Olookup,type,
    ref_lookup: 
      !>[A: $tType] : ( ref(A) > heap_Time_Heap(A) ) ).

tff(sy_c_Ref__Time_Opresent,type,
    ref_present: 
      !>[A: $tType] : ( ( heap_ext(product_unit) * ref(A) ) > $o ) ).

tff(sy_c_Ref__Time_Oref,type,
    ref_ref: 
      !>[A: $tType] : ( A > heap_Time_Heap(ref(A)) ) ).

tff(sy_c_Ref__Time_Oset,type,
    ref_set: 
      !>[A: $tType] : ( ( ref(A) * A * heap_ext(product_unit) ) > heap_ext(product_unit) ) ).

tff(sy_c_Ref__Time_Oupdate,type,
    ref_update: 
      !>[A: $tType] : ( ( ref(A) * A ) > heap_Time_Heap(product_unit) ) ).

tff(sy_c_Relation_ODomain,type,
    domain: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(A) ) ).

tff(sy_c_Relation_ODomainp,type,
    domainp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(A,$o) ) ).

tff(sy_c_Relation_OField,type,
    field2: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(A) ) ).

tff(sy_c_Relation_OId,type,
    id2: 
      !>[A: $tType] : set(product_prod(A,A)) ).

tff(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( set(A) > set(product_prod(A,A)) ) ).

tff(sy_c_Relation_OImage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,B)) * set(A) ) > set(B) ) ).

tff(sy_c_Relation_ORange,type,
    range2: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(B) ) ).

tff(sy_c_Relation_ORangep,type,
    rangep: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(B,$o) ) ).

tff(sy_c_Relation_Oantisym,type,
    antisym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oantisymp,type,
    antisymp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Relation_Oasym,type,
    asym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oasymp,type,
    asymp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Relation_Oconverse,type,
    converse: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > set(product_prod(B,A)) ) ).

tff(sy_c_Relation_Oconversep,type,
    conversep: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(B,fun(A,$o)) ) ).

tff(sy_c_Relation_Oinv__image,type,
    inv_image: 
      !>[B: $tType,A: $tType] : ( ( set(product_prod(B,B)) * fun(A,B) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Oirreflp,type,
    irreflp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Relation_Orefl__on,type,
    refl_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Relation_Oreflp,type,
    reflp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set(product_prod(A,B)) * set(product_prod(B,C)) ) > set(product_prod(A,C)) ) ).

tff(sy_c_Relation_Orelcompp,type,
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( fun(A,fun(B,$o)) * fun(B,fun(C,$o)) ) > fun(A,fun(C,$o)) ) ).

tff(sy_c_Relation_Osingle__valued,type,
    single_valued: 
      !>[A: $tType,B: $tType] : ( set(product_prod(A,B)) > $o ) ).

tff(sy_c_Relation_Osingle__valuedp,type,
    single_valuedp: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Relation_Osym,type,
    sym: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Osymp,type,
    symp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Relation_Ototal__on,type,
    total_on: 
      !>[A: $tType] : ( ( set(A) * set(product_prod(A,A)) ) > $o ) ).

tff(sy_c_Relation_Otrans,type,
    trans: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( ( A * A ) > $o ) ).

tff(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( ( A * A ) > $o ) ).

tff(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Onormalization__semidom__class_Onormalize,type,
    normal6383669964737779283malize: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Rings_Ounit__factor__class_Ounit__factor,type,
    unit_f5069060285200089521factor: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : fun($o,A) ).

tff(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : fun(fun(A,$o),set(A)) ).

tff(sy_c_Set_OPow,type,
    pow: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Set_Obind,type,
    bind3: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(B) ) ).

tff(sy_c_Set_Odisjnt,type,
    disjnt: 
      !>[A: $tType] : ( ( set(A) * set(A) ) > $o ) ).

tff(sy_c_Set_Ofilter,type,
    filter3: 
      !>[A: $tType] : ( ( fun(A,$o) * set(A) ) > set(A) ) ).

tff(sy_c_Set_Oimage,type,
    image2: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(set(A),set(B)) ) ).

tff(sy_c_Set_Oinsert,type,
    insert2: 
      !>[A: $tType] : ( A > fun(set(A),set(A)) ) ).

tff(sy_c_Set_Ois__empty,type,
    is_empty2: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Set_Ois__singleton,type,
    is_singleton: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Set_Opairwise,type,
    pairwise: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * set(A) ) > $o ) ).

tff(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : fun(A,fun(set(A),set(A))) ).

tff(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : fun(fun(A,B),fun(set(B),set(A))) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( fun(nat,fun(A,A)) * nat * nat * A ) > A ) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : fun(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),fun(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),$o)) ).

tff(sy_c_Set__Interval_Oord_OatLeast,type,
    set_atLeast: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatLeastAtMost,type,
    set_atLeastAtMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatLeastLessThan,type,
    set_atLeastLessThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OatMost,type,
    set_atMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThan,type,
    set_greaterThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThanAtMost,type,
    set_gr3752724095348155675AtMost: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,
    set_gr287244882034783167ssThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord_OlessThan,type,
    set_lessThan: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : fun(A,set(A)) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_String_Ochar_OChar,type,
    char2: ( $o * $o * $o * $o * $o * $o * $o * $o ) > char ).

tff(sy_c_Sum__Type_OInl,type,
    sum_Inl: 
      !>[A: $tType,B: $tType] : fun(A,sum_sum(A,B)) ).

tff(sy_c_Sum__Type_OInr,type,
    sum_Inr: 
      !>[B: $tType,A: $tType] : fun(B,sum_sum(A,B)) ).

tff(sy_c_Sum__Type_OPlus,type,
    sum_Plus: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(sum_sum(A,B)) ) ).

tff(sy_c_Sum__Type_Omap__sum,type,
    sum_map_sum: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,C) * fun(B,D) ) > fun(sum_sum(A,B),sum_sum(C,D)) ) ).

tff(sy_c_Sum__Type_Osum_Ocase__sum,type,
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( fun(A,C) * fun(B,C) ) > fun(sum_sum(A,B),C) ) ).

tff(sy_c_Syntax__Match_Oac__operator,type,
    syntax_ac_operator: 
      !>[A: $tType] : ( fun(A,fun(A,A)) > $o ) ).

tff(sy_c_Syntax__Match_Osyntax__fo__nomatch,type,
    syntax7388354845996824322omatch: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_Transfer_Obi__unique,type,
    bi_unique: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Transfer_Oleft__unique,type,
    left_unique: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Transfer_Oright__total,type,
    right_total: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Transitive__Closure_Oacyclic,type,
    transitive_acyclic: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Ortranclp,type,
    transitive_rtranclp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,fun(A,$o)) ) ).

tff(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Otranclp,type,
    transitive_tranclp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,fun(A,$o)) ) ).

tff(sy_c_Typedef_Otype__definition,type,
    type_definition: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Typerep_Otyperep__class_Otyperep,type,
    typerep_typerep: 
      !>[A: $tType] : ( itself(A) > typerep ) ).

tff(sy_c_Wellfounded_Oacc,type,
    acc: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(A) ) ).

tff(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,$o) ) ).

tff(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : set(product_prod(set(A),set(A))) ).

tff(sy_c_Wellfounded_Oless__than,type,
    less_than: set(product_prod(nat,nat)) ).

tff(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * set(product_prod(B,B)) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_Wellfounded_Omax__extp,type,
    max_extp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(set(A),fun(set(A),$o)) ) ).

tff(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( fun(A,nat) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(set(A),set(A))) ) ).

tff(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( fun(A,nat) * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set(product_prod(nat,nat)) ).

tff(sy_c_Wellfounded_Owf,type,
    wf: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Wellfounded_OwfP,type,
    wfP: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Wfrec_Oadm__wf,type,
    adm_wf: 
      !>[A: $tType,B: $tType] : ( ( set(product_prod(A,A)) * fun(fun(A,B),fun(A,B)) ) > $o ) ).

tff(sy_c_Wfrec_Ocut,type,
    cut: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(product_prod(A,A)) * A ) > fun(A,B) ) ).

tff(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( fun(A,$o) * fun(A,set(product_prod(B,B))) ) > set(product_prod(product_prod(A,B),product_prod(A,B))) ) ).

tff(sy_c_Zorn_OChains,type,
    chains: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(set(A)) ) ).

tff(sy_c_Zorn_Ochains,type,
    chains2: 
      !>[A: $tType] : ( set(set(A)) > set(set(set(A))) ) ).

tff(sy_c_Zorn_Oinit__seg__of,type,
    init_seg_of: 
      !>[A: $tType] : set(product_prod(set(product_prod(A,A)),set(product_prod(A,A)))) ).

tff(sy_c_Zorn_Opred__on_Ochain,type,
    pred_chain: 
      !>[A: $tType] : ( ( set(A) * fun(A,fun(A,$o)) ) > fun(set(A),$o) ) ).

tff(sy_c_aa,type,
    aa: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A ) > B ) ).

tff(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_fNot,type,
    fNot: fun($o,$o) ).

tff(sy_c_fequal,type,
    fequal: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_member,type,
    member: 
      !>[A: $tType] : ( ( A * set(A) ) > $o ) ).

tff(sy_v_P,type,
    p: assn ).

tff(sy_v_Q,type,
    q: fun(a,assn) ).

tff(sy_v_Q1,type,
    q1: fun(a,assn) ).

tff(sy_v_Q2,type,
    q2: fun(a,assn) ).

tff(sy_v_b,type,
    b2: $o ).

tff(sy_v_f,type,
    f: heap_Time_Heap(a) ).

tff(sy_v_g,type,
    g: heap_Time_Heap(a) ).

% Relevant facts (6328)
tff(fact_0_B,axiom,
    ( b2
   => hoare_hoare_triple(a,p,f,q1) ) ).

% B
tff(fact_1_NB,axiom,
    ( ~ b2
   => hoare_hoare_triple(a,p,g,q2) ) ).

% NB
tff(fact_2_if__rule,axiom,
    ! [B: $tType,Ba: $o,Pa: assn,Fa: heap_Time_Heap(B),Qa: fun(B,assn),Ga: heap_Time_Heap(B)] :
      ( ( (Ba)
       => hoare_hoare_triple(B,Pa,Fa,Qa) )
     => ( ( ~ (Ba)
         => hoare_hoare_triple(B,Pa,Ga,Qa) )
       => hoare_hoare_triple(B,Pa,$ite((Ba),Fa,Ga),Qa) ) ) ).

% if_rule
tff(fact_3_return__wp__rule,axiom,
    ! [B: $tType,Qa: fun(B,assn),X: B] : hoare_hoare_triple(B,aa(B,assn,Qa,X),aa(B,heap_Time_Heap(B),heap_Time_return(B),X),Qa) ).

% return_wp_rule
tff(fact_4_M,axiom,
    ! [X: a] : entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(a,assn,q1,X)),pure_assn(b2))),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(a,assn,q2,X)),pure_assn(~ b2))),aa(a,assn,q,X)) ).

% M
tff(fact_5_bind__rule,axiom,
    ! [B: $tType,C: $tType,Pa: assn,Fa: heap_Time_Heap(B),R: fun(B,assn),Ga: fun(B,heap_Time_Heap(C)),Qa: fun(C,assn)] :
      ( hoare_hoare_triple(B,Pa,Fa,R)
     => ( ! [X2: B] : hoare_hoare_triple(C,aa(B,assn,R,X2),aa(B,heap_Time_Heap(C),Ga,X2),Qa)
       => hoare_hoare_triple(C,Pa,heap_Time_bind(B,C,Fa,Ga),Qa) ) ) ).

% bind_rule
tff(fact_6_false__rule,axiom,
    ! [B: $tType,C2: heap_Time_Heap(B),Qa: fun(B,assn)] : hoare_hoare_triple(B,bot_bot(assn),C2,Qa) ).

% false_rule
tff(fact_7_cons__rule,axiom,
    ! [B: $tType,Pa: assn,P: assn,Qa: fun(B,assn),Q: fun(B,assn),C2: heap_Time_Heap(B)] :
      ( entails(Pa,P)
     => ( ! [X2: B] : entails(aa(B,assn,Qa,X2),aa(B,assn,Q,X2))
       => ( hoare_hoare_triple(B,P,C2,Qa)
         => hoare_hoare_triple(B,Pa,C2,Q) ) ) ) ).

% cons_rule
tff(fact_8_cons__post__rule,axiom,
    ! [B: $tType,Pa: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn),Q: fun(B,assn)] :
      ( hoare_hoare_triple(B,Pa,C2,Qa)
     => ( ! [X2: B] : entails(aa(B,assn,Qa,X2),aa(B,assn,Q,X2))
       => hoare_hoare_triple(B,Pa,C2,Q) ) ) ).

% cons_post_rule
tff(fact_9_hoare__triple__preI,axiom,
    ! [B: $tType,Pa: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H)
         => hoare_hoare_triple(B,Pa,C2,Qa) )
     => hoare_hoare_triple(B,Pa,C2,Qa) ) ).

% hoare_triple_preI
tff(fact_10_new__addr__refl,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat)] : ( hoare_new_addrs(H2,As,H2) = As ) ).

% new_addr_refl
tff(fact_11_raise__iff,axiom,
    ! [B: $tType,Pa: assn,S: list(char),Qa: fun(B,assn)] :
      ( hoare_hoare_triple(B,Pa,heap_Time_raise(B,S),Qa)
    <=> ( Pa = bot_bot(assn) ) ) ).

% raise_iff
tff(fact_12_raise__rule,axiom,
    ! [B: $tType,S: list(char),Qa: fun(B,assn)] : hoare_hoare_triple(B,bot_bot(assn),heap_Time_raise(B,S),Qa) ).

% raise_rule
tff(fact_13_norm__pre__pure__iff__sng,axiom,
    ! [B: $tType,Ba: $o,Fa: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( hoare_hoare_triple(B,pure_assn(Ba),Fa,Qa)
    <=> ( (Ba)
       => hoare_hoare_triple(B,one_one(assn),Fa,Qa) ) ) ).

% norm_pre_pure_iff_sng
tff(fact_14_norm__pre__pure__iff,axiom,
    ! [B: $tType,Pa: assn,Ba: $o,Fa: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( hoare_hoare_triple(B,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),pure_assn(Ba)),Fa,Qa)
    <=> ( (Ba)
       => hoare_hoare_triple(B,Pa,Fa,Qa) ) ) ).

% norm_pre_pure_iff
tff(fact_15_norm__pre__pure__rule1,axiom,
    ! [B: $tType,Ba: $o,Pa: assn,Fa: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( ( (Ba)
       => hoare_hoare_triple(B,Pa,Fa,Qa) )
     => hoare_hoare_triple(B,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),pure_assn(Ba)),Fa,Qa) ) ).

% norm_pre_pure_rule1
tff(fact_16_norm__pre__pure__rule2,axiom,
    ! [B: $tType,Ba: $o,Fa: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( ( (Ba)
       => hoare_hoare_triple(B,one_one(assn),Fa,Qa) )
     => hoare_hoare_triple(B,pure_assn(Ba),Fa,Qa) ) ).

% norm_pre_pure_rule2
tff(fact_17_ent__pure__post__iff__sng,axiom,
    ! [Pa: assn,Ba: $o] :
      ( entails(Pa,pure_assn(Ba))
    <=> ( ! [H3: product_prod(heap_ext(product_unit),set(nat))] :
            ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H3)
           => (Ba) )
        & entails(Pa,one_one(assn)) ) ) ).

% ent_pure_post_iff_sng
tff(fact_18_ent__pure__post__iff,axiom,
    ! [Pa: assn,Qa: assn,Ba: $o] :
      ( entails(Pa,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),pure_assn(Ba)))
    <=> ( ! [H3: product_prod(heap_ext(product_unit),set(nat))] :
            ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H3)
           => (Ba) )
        & entails(Pa,Qa) ) ) ).

% ent_pure_post_iff
tff(fact_19_ent__pure__pre__iff__sng,axiom,
    ! [Ba: $o,Qa: assn] :
      ( entails(pure_assn(Ba),Qa)
    <=> ( (Ba)
       => entails(one_one(assn),Qa) ) ) ).

% ent_pure_pre_iff_sng
tff(fact_20_ent__false__iff,axiom,
    ! [Pa: assn] :
      ( entails(Pa,bot_bot(assn))
    <=> ! [H3: product_prod(heap_ext(product_unit),set(nat))] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H3) ) ).

% ent_false_iff
tff(fact_21_ent__pure__pre__iff,axiom,
    ! [Pa: assn,Ba: $o,Qa: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),pure_assn(Ba)),Qa)
    <=> ( (Ba)
       => entails(Pa,Qa) ) ) ).

% ent_pure_pre_iff
tff(fact_22_mod__pure__star__dist,axiom,
    ! [Pa: assn,Ba: $o,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),pure_assn(Ba))),H2)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
        & (Ba) ) ) ).

% mod_pure_star_dist
tff(fact_23_raise__bind,axiom,
    ! [C: $tType,B: $tType,E2: list(char),Fa: fun(C,heap_Time_Heap(B))] : ( heap_Time_bind(C,B,heap_Time_raise(C,E2),Fa) = heap_Time_raise(B,E2) ) ).

% raise_bind
tff(fact_24_assn__basic__inequalities_I3_J,axiom,
    bot_bot(assn) != one_one(assn) ).

% assn_basic_inequalities(3)
tff(fact_25_pure__false,axiom,
    pure_assn($false) = bot_bot(assn) ).

% pure_false
tff(fact_26_pure__assn__eq__false__iff,axiom,
    ! [Pa: $o] :
      ( ( pure_assn(Pa) = bot_bot(assn) )
    <=> ~ (Pa) ) ).

% pure_assn_eq_false_iff
tff(fact_27_pure__true,axiom,
    pure_assn($true) = one_one(assn) ).

% pure_true
tff(fact_28_pure__assn__eq__emp__iff,axiom,
    ! [Pa: $o] :
      ( ( pure_assn(Pa) = one_one(assn) )
    <=> (Pa) ) ).

% pure_assn_eq_emp_iff
tff(fact_29_Rep__assn__inject,axiom,
    ! [X: assn,Y: assn] :
      ( ( aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,X) = aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Y) )
    <=> ( X = Y ) ) ).

% Rep_assn_inject
tff(fact_30_pure__assn__eq__conv,axiom,
    ! [Pa: $o,Qa: $o] :
      ( ( pure_assn(Pa) = pure_assn(Qa) )
    <=> ( (Pa)
      <=> (Qa) ) ) ).

% pure_assn_eq_conv
tff(fact_31_merge__pure__star,axiom,
    ! [A3: $o,Ba: $o] :
      ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),pure_assn(A3)),pure_assn(Ba))
      = pure_assn(
          (A3)
        & (Ba)) ) ).

% merge_pure_star
tff(fact_32_mod__or__dist,axiom,
    ! [Pa: assn,Qa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),Pa),Qa)),H2)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
        | aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H2) ) ) ).

% mod_or_dist
tff(fact_33_star__false__right,axiom,
    ! [Pa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),bot_bot(assn)) = bot_bot(assn) ) ).

% star_false_right
tff(fact_34_star__false__left,axiom,
    ! [Pa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),bot_bot(assn)),Pa) = bot_bot(assn) ) ).

% star_false_left
tff(fact_35_merge__pure__or,axiom,
    ! [A3: $o,Ba: $o] :
      ( aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),pure_assn(A3)),pure_assn(Ba))
      = pure_assn(
          (A3)
        | (Ba)) ) ).

% merge_pure_or
tff(fact_36_assn__times__assoc,axiom,
    ! [Pa: assn,Qa: assn,R: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa)),R) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),R)) ) ).

% assn_times_assoc
tff(fact_37_assn__times__comm,axiom,
    ! [Pa: assn,Qa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),Pa) ) ).

% assn_times_comm
tff(fact_38_ent__trans,axiom,
    ! [Pa: assn,Qa: assn,R: assn] :
      ( entails(Pa,Qa)
     => ( entails(Qa,R)
       => entails(Pa,R) ) ) ).

% ent_trans
tff(fact_39_ent__refl,axiom,
    ! [Pa: assn] : entails(Pa,Pa) ).

% ent_refl
tff(fact_40_ent__iffI,axiom,
    ! [A4: assn,B2: assn] :
      ( entails(A4,B2)
     => ( entails(B2,A4)
       => ( A4 = B2 ) ) ) ).

% ent_iffI
tff(fact_41_fold__if__return,axiom,
    ! [B: $tType,Ba: $o,C2: B,D2: B] :
      ( $ite((Ba),aa(B,heap_Time_Heap(B),heap_Time_return(B),C2),aa(B,heap_Time_Heap(B),heap_Time_return(B),D2))
      = aa(B,heap_Time_Heap(B),heap_Time_return(B),$ite((Ba),C2,D2)) ) ).

% fold_if_return
tff(fact_42_mod__starE,axiom,
    ! [A3: assn,Ba: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),Ba)),H2)
     => ~ ( ? [X_1: product_prod(heap_ext(product_unit),set(nat))] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,A3),X_1)
         => ! [H_2: product_prod(heap_ext(product_unit),set(nat))] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Ba),H_2) ) ) ).

% mod_starE
tff(fact_43_mod__starD,axiom,
    ! [A4: assn,B2: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),B2)),H2)
     => ? [H1: product_prod(heap_ext(product_unit),set(nat)),H22: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,A4),H1)
          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,B2),H22) ) ) ).

% mod_starD
tff(fact_44_entails__def,axiom,
    ! [Pa: assn,Qa: assn] :
      ( entails(Pa,Qa)
    <=> ! [H3: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H3)
         => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H3) ) ) ).

% entails_def
tff(fact_45_mem__Collect__eq,axiom,
    ! [B: $tType,A3: B,Pa: fun(B,$o)] :
      ( member(B,A3,aa(fun(B,$o),set(B),collect(B),Pa))
    <=> aa(B,$o,Pa,A3) ) ).

% mem_Collect_eq
tff(fact_46_Collect__mem__eq,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),A4)) = A4 ) ).

% Collect_mem_eq
tff(fact_47_Collect__cong,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( ! [X2: B] :
          ( aa(B,$o,Pa,X2)
        <=> aa(B,$o,Qa,X2) )
     => ( aa(fun(B,$o),set(B),collect(B),Pa) = aa(fun(B,$o),set(B),collect(B),Qa) ) ) ).

% Collect_cong
tff(fact_48_ext,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),Ga: fun(B,C)] :
      ( ! [X2: B] : ( aa(B,C,Fa,X2) = aa(B,C,Ga,X2) )
     => ( Fa = Ga ) ) ).

% ext
tff(fact_49_entailsI,axiom,
    ! [Pa: assn,Qa: assn] :
      ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H)
         => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H) )
     => entails(Pa,Qa) ) ).

% entailsI
tff(fact_50_entailsD,axiom,
    ! [Pa: assn,Qa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( entails(Pa,Qa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H2) ) ) ).

% entailsD
tff(fact_51_ent__fwd,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat)),Qa: assn] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
     => ( entails(Pa,Qa)
       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H2) ) ) ).

% ent_fwd
tff(fact_52_ent__star__mono,axiom,
    ! [Pa: assn,P: assn,Qa: assn,Q: assn] :
      ( entails(Pa,P)
     => ( entails(Qa,Q)
       => entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),P),Q)) ) ) ).

% ent_star_mono
tff(fact_53_star__or__dist2,axiom,
    ! [C3: assn,A4: assn,B2: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C3),aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B2)) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C3),A4)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),C3),B2)) ) ).

% star_or_dist2
tff(fact_54_star__or__dist1,axiom,
    ! [A4: assn,B2: assn,C3: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B2)),C3) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),C3)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),C3)) ) ).

% star_or_dist1
tff(fact_55_ent__disjI2__direct,axiom,
    ! [B2: assn,A4: assn] : entails(B2,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B2)) ).

% ent_disjI2_direct
tff(fact_56_ent__disjI1__direct,axiom,
    ! [A4: assn,B2: assn] : entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B2)) ).

% ent_disjI1_direct
tff(fact_57_ent__disjI2_H,axiom,
    ! [A4: assn,C3: assn,B2: assn] :
      ( entails(A4,C3)
     => entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C3)) ) ).

% ent_disjI2'
tff(fact_58_ent__disjI1_H,axiom,
    ! [A4: assn,B2: assn,C3: assn] :
      ( entails(A4,B2)
     => entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C3)) ) ).

% ent_disjI1'
tff(fact_59_ent__disjI2,axiom,
    ! [Pa: assn,Qa: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),Pa),Qa),R)
     => entails(Qa,R) ) ).

% ent_disjI2
tff(fact_60_ent__disjI1,axiom,
    ! [Pa: assn,Qa: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),Pa),Qa),R)
     => entails(Pa,R) ) ).

% ent_disjI1
tff(fact_61_ent__disjE,axiom,
    ! [A4: assn,C3: assn,B2: assn] :
      ( entails(A4,C3)
     => ( entails(B2,C3)
       => entails(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B2),C3) ) ) ).

% ent_disjE
tff(fact_62_mod__false,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,bot_bot(assn)),H2) ).

% mod_false
tff(fact_63_assn__one__left,axiom,
    ! [Pa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),one_one(assn)),Pa) = Pa ) ).

% assn_one_left
tff(fact_64_ent__false,axiom,
    ! [Pa: assn] : entails(bot_bot(assn),Pa) ).

% ent_false
tff(fact_65_sup__bot_Oright__neutral,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),bot_bot(B)) = A3 ) ) ).

% sup_bot.right_neutral
tff(fact_66_sup__bot_Oneutr__eq__iff,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [A3: B,Ba: B] :
          ( ( bot_bot(B) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) )
        <=> ( ( A3 = bot_bot(B) )
            & ( Ba = bot_bot(B) ) ) ) ) ).

% sup_bot.neutr_eq_iff
tff(fact_67_sup__bot_Oleft__neutral,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),bot_bot(B)),A3) = A3 ) ) ).

% sup_bot.left_neutral
tff(fact_68_sup__bot_Oeq__neutr__iff,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) = bot_bot(B) )
        <=> ( ( A3 = bot_bot(B) )
            & ( Ba = bot_bot(B) ) ) ) ) ).

% sup_bot.eq_neutr_iff
tff(fact_69_sup__eq__bot__iff,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) = bot_bot(B) )
        <=> ( ( X = bot_bot(B) )
            & ( Y = bot_bot(B) ) ) ) ) ).

% sup_eq_bot_iff
tff(fact_70_bot__eq__sup__iff,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [X: B,Y: B] :
          ( ( bot_bot(B) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) )
        <=> ( ( X = bot_bot(B) )
            & ( Y = bot_bot(B) ) ) ) ) ).

% bot_eq_sup_iff
tff(fact_71_sup__bot__right,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),bot_bot(B)) = X ) ) ).

% sup_bot_right
tff(fact_72_sup__bot__left,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),bot_bot(B)),X) = X ) ) ).

% sup_bot_left
tff(fact_73_mult__1,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),one_one(B)),A3) = A3 ) ) ).

% mult_1
tff(fact_74_mult_Oright__neutral,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),one_one(B)) = A3 ) ) ).

% mult.right_neutral
tff(fact_75_lift__collapse,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),X: C] : ( aa(C,heap_Time_Heap(B),heap_Time_lift(C,B,Fa),X) = aa(B,heap_Time_Heap(B),heap_Time_return(B),aa(C,B,Fa,X)) ) ).

% lift_collapse
tff(fact_76_sup__apply,axiom,
    ! [B: $tType,C: $tType] :
      ( semilattice_sup(B)
     => ! [Fa: fun(C,B),Ga: fun(C,B),X: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),sup_sup(fun(C,B)),Fa),Ga),X) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,Fa,X)),aa(C,B,Ga,X)) ) ) ).

% sup_apply
tff(fact_77_sup_Oidem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),A3) = A3 ) ) ).

% sup.idem
tff(fact_78_sup__idem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),X) = X ) ) ).

% sup_idem
tff(fact_79_sup_Oleft__idem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) ) ) ).

% sup.left_idem
tff(fact_80_sup__left__idem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) ) ) ).

% sup_left_idem
tff(fact_81_sup_Oright__idem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)),Ba) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) ) ) ).

% sup.right_idem
tff(fact_82_mult_Oassoc,axiom,
    ! [B: $tType] :
      ( semigroup_mult(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ).

% mult.assoc
tff(fact_83_ab__semigroup__mult__class_Omult_Ocommute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3) ) ) ).

% ab_semigroup_mult_class.mult.commute
tff(fact_84_ab__semigroup__mult__class_Omult_Oleft__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => ! [Ba: B,A3: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ).

% ab_semigroup_mult_class.mult.left_commute
tff(fact_85_one__reorient,axiom,
    ! [B: $tType] :
      ( one(B)
     => ! [X: B] :
          ( ( one_one(B) = X )
        <=> ( X = one_one(B) ) ) ) ).

% one_reorient
tff(fact_86_inf__sup__aci_I8_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) ) ) ).

% inf_sup_aci(8)
tff(fact_87_inf__sup__aci_I7_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Z2)) ) ) ).

% inf_sup_aci(7)
tff(fact_88_inf__sup__aci_I6_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)),Z2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) ) ) ).

% inf_sup_aci(6)
tff(fact_89_inf__sup__aci_I5_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),X) ) ) ).

% inf_sup_aci(5)
tff(fact_90_sup_Oassoc,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),aa(B,B,aa(B,fun(B,B),sup_sup(B),Ba),C2)) ) ) ).

% sup.assoc
tff(fact_91_sup__assoc,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)),Z2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) ) ) ).

% sup_assoc
tff(fact_92_sup_Ocommute,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Ba),A3) ) ) ).

% sup.commute
tff(fact_93_sup__commute,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),X) ) ) ).

% sup_commute
tff(fact_94_sup_Oleft__commute,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,A3: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),Ba),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),C2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),aa(B,B,aa(B,fun(B,B),sup_sup(B),Ba),C2)) ) ) ).

% sup.left_commute
tff(fact_95_sup__left__commute,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Z2)) ) ) ).

% sup_left_commute
tff(fact_96_sup__fun__def,axiom,
    ! [C: $tType,B: $tType] :
      ( semilattice_sup(C)
     => ! [Fa: fun(B,C),Ga: fun(B,C),X3: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),sup_sup(fun(B,C)),Fa),Ga),X3) = aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(B,C,Fa,X3)),aa(B,C,Ga,X3)) ) ) ).

% sup_fun_def
tff(fact_97_comm__monoid__mult__class_Omult__1,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),one_one(B)),A3) = A3 ) ) ).

% comm_monoid_mult_class.mult_1
tff(fact_98_mult_Ocomm__neutral,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),one_one(B)) = A3 ) ) ).

% mult.comm_neutral
tff(fact_99_bot__apply,axiom,
    ! [C: $tType,B: $tType] :
      ( bot(B)
     => ! [X: C] : ( aa(C,B,bot_bot(fun(C,B)),X) = bot_bot(B) ) ) ).

% bot_apply
tff(fact_100_boolean__algebra_Odisj__zero__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),bot_bot(B)) = X ) ) ).

% boolean_algebra.disj_zero_right
tff(fact_101_sngr__same__false,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [P2: ref(B),X: B,Y: B] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),sngr_assn(B,P2,X)),sngr_assn(B,P2,Y)) = bot_bot(assn) ) ) ).

% sngr_same_false
tff(fact_102_ent__mp,axiom,
    ! [Pa: assn,Qa: assn] : entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),wand_assn(Pa,Qa)),Qa) ).

% ent_mp
tff(fact_103_ent__wandI,axiom,
    ! [Qa: assn,Pa: assn,R: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),Pa),R)
     => entails(Pa,wand_assn(Qa,R)) ) ).

% ent_wandI
tff(fact_104_snga__same__false,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [P2: array(B),X: list(B),Y: list(B)] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(B,P2,X)),snga_assn(B,P2,Y)) = bot_bot(assn) ) ) ).

% snga_same_false
tff(fact_105_preciseD_H,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,assn)),A3: B,P2: C,F: assn,H2: product_prod(heap_ext(product_unit),set(nat)),A5: B,F2: assn] :
      ( precise(B,C,R)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A3),P2)),F)),H2)
       => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A5),P2)),F2)),H2)
         => ( A3 = A5 ) ) ) ) ).

% preciseD'
tff(fact_106_is__pure__assn__pure,axiom,
    ! [Pa: $o] : is_pure_assn(pure_assn(Pa)) ).

% is_pure_assn_pure
tff(fact_107_is__pure__assn__starI,axiom,
    ! [A3: assn,Ba: assn] :
      ( is_pure_assn(A3)
     => ( is_pure_assn(Ba)
       => is_pure_assn(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A3),Ba)) ) ) ).

% is_pure_assn_starI
tff(fact_108_boolean__algebra__cancel_Osup1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: B,K: B,A3: B,Ba: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),sup_sup(B),K),A3) )
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),Ba) = aa(B,B,aa(B,fun(B,B),sup_sup(B),K),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ) ).

% boolean_algebra_cancel.sup1
tff(fact_109_boolean__algebra__cancel_Osup2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [B2: B,K: B,Ba: B,A3: B] :
          ( ( B2 = aa(B,B,aa(B,fun(B,B),sup_sup(B),K),Ba) )
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),B2) = aa(B,B,aa(B,fun(B,B),sup_sup(B),K),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ) ).

% boolean_algebra_cancel.sup2
tff(fact_110_bot__fun__def,axiom,
    ! [B: $tType,C: $tType] :
      ( bot(C)
     => ! [X3: B] : ( aa(B,C,bot_bot(fun(B,C)),X3) = bot_bot(C) ) ) ).

% bot_fun_def
tff(fact_111_is__pure__assn__def,axiom,
    ! [A3: assn] :
      ( is_pure_assn(A3)
    <=> ? [P3: $o] : ( A3 = pure_assn(P3) ) ) ).

% is_pure_assn_def
tff(fact_112_is__pure__assnE,axiom,
    ! [A3: assn] :
      ( is_pure_assn(A3)
     => ~ ! [P4: $o] : ( A3 != pure_assn(P4) ) ) ).

% is_pure_assnE
tff(fact_113_is__pure__assn__basic__simps_I2_J,axiom,
    is_pure_assn(one_one(assn)) ).

% is_pure_assn_basic_simps(2)
tff(fact_114_is__pure__assn__basic__simps_I1_J,axiom,
    is_pure_assn(bot_bot(assn)) ).

% is_pure_assn_basic_simps(1)
tff(fact_115_precise__def,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,assn))] :
      ( precise(B,C,R)
    <=> ! [A6: B,A7: B,H3: product_prod(heap_ext(product_unit),set(nat)),P5: C,F3: assn,F4: assn] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A6),P5)),F3)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A7),P5)),F4))),H3)
         => ( A6 = A7 ) ) ) ).

% precise_def
tff(fact_116_preciseI,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,assn))] :
      ( ! [A8: B,A9: B,H: product_prod(heap_ext(product_unit),set(nat)),P6: C,F5: assn,F6: assn] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A8),P6)),F5)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A9),P6)),F6))),H)
         => ( A8 = A9 ) )
     => precise(B,C,R) ) ).

% preciseI
tff(fact_117_preciseD,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,assn)),A3: B,P2: C,F: assn,A5: B,F2: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( precise(B,C,R)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A3),P2)),F)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),R,A5),P2)),F2))),H2)
       => ( A3 = A5 ) ) ) ).

% preciseD
tff(fact_118_mult_Oright__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),Ba) ) ) ).

% mult.right_commute
tff(fact_119_mult_Oright__assoc,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ).

% mult.right_assoc
tff(fact_120_mod__h__bot__iff_I3_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [P2: ref(B),X: B,H2: heap_ext(product_unit)] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,sngr_assn(B,P2,X)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ).

% mod_h_bot_iff(3)
tff(fact_121_sup__bot_Osemilattice__neutr__axioms,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => semilattice_neutr(B,sup_sup(B),bot_bot(B)) ) ).

% sup_bot.semilattice_neutr_axioms
tff(fact_122_mod__h__bot__iff_I4_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Q2: array(B),Y: list(B),H2: heap_ext(product_unit)] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,snga_assn(B,Q2,Y)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ).

% mod_h_bot_iff(4)
tff(fact_123_sup__bot_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => monoid(B,sup_sup(B),bot_bot(B)) ) ).

% sup_bot.monoid_axioms
tff(fact_124_mod__h__bot__iff_I7_J,axiom,
    ! [Pa: assn,Qa: assn,H2: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),Pa),Qa)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
        | aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ) ).

% mod_h_bot_iff(7)
tff(fact_125_lift__def,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] : ( heap_Time_lift(B,C,Fa) = aa(fun(B,C),fun(B,heap_Time_Heap(C)),aa(fun(C,heap_Time_Heap(C)),fun(fun(B,C),fun(B,heap_Time_Heap(C))),comp(C,heap_Time_Heap(C),B),heap_Time_return(C)),Fa) ) ).

% lift_def
tff(fact_126_mult_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => monoid(B,times_times(B),one_one(B)) ) ).

% mult.monoid_axioms
tff(fact_127_inf__apply,axiom,
    ! [B: $tType,C: $tType] :
      ( semilattice_inf(B)
     => ! [Fa: fun(C,B),Ga: fun(C,B),X: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),inf_inf(fun(C,B)),Fa),Ga),X) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,Fa,X)),aa(C,B,Ga,X)) ) ) ).

% inf_apply
tff(fact_128_inf__right__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),Y) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) ) ) ).

% inf_right_idem
tff(fact_129_inf_Oright__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),Ba) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) ) ) ).

% inf.right_idem
tff(fact_130_inf__left__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) ) ) ).

% inf_left_idem
tff(fact_131_inf_Oleft__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) ) ) ).

% inf.left_idem
tff(fact_132_inf__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),X) = X ) ) ).

% inf_idem
tff(fact_133_inf_Oidem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),A3) = A3 ) ) ).

% inf.idem
tff(fact_134_inf__bot__left,axiom,
    ! [B: $tType] :
      ( bounded_lattice_bot(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),bot_bot(B)),X) = bot_bot(B) ) ) ).

% inf_bot_left
tff(fact_135_inf__bot__right,axiom,
    ! [B: $tType] :
      ( bounded_lattice_bot(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),bot_bot(B)) = bot_bot(B) ) ) ).

% inf_bot_right
tff(fact_136_boolean__algebra_Oconj__zero__left,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),bot_bot(B)),X) = bot_bot(B) ) ) ).

% boolean_algebra.conj_zero_left
tff(fact_137_boolean__algebra_Oconj__zero__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),bot_bot(B)) = bot_bot(B) ) ) ).

% boolean_algebra.conj_zero_right
tff(fact_138_inf__sup__absorb,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)) = X ) ) ).

% inf_sup_absorb
tff(fact_139_sup__inf__absorb,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)) = X ) ) ).

% sup_inf_absorb
tff(fact_140_merge__pure__and,axiom,
    ! [A3: $o,Ba: $o] :
      ( aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),pure_assn(A3)),pure_assn(Ba))
      = pure_assn(
          (A3)
        & (Ba)) ) ).

% merge_pure_and
tff(fact_141_mod__h__bot__iff_I5_J,axiom,
    ! [Pa: assn,Qa: assn,H2: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ) ).

% mod_h_bot_iff(5)
tff(fact_142_mod__h__bot__iff_I1_J,axiom,
    ! [Ba: $o,H2: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,pure_assn(Ba)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> (Ba) ) ).

% mod_h_bot_iff(1)
tff(fact_143_mod__h__bot__iff_I6_J,axiom,
    ! [Pa: assn,Qa: assn,H2: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),Pa),Qa)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ) ).

% mod_h_bot_iff(6)
tff(fact_144_boolean__algebra__cancel_Oinf2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [B2: B,K: B,Ba: B,A3: B] :
          ( ( B2 = aa(B,B,aa(B,fun(B,B),inf_inf(B),K),Ba) )
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),B2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),K),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)) ) ) ) ).

% boolean_algebra_cancel.inf2
tff(fact_145_boolean__algebra__cancel_Oinf1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: B,K: B,A3: B,Ba: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),inf_inf(B),K),A3) )
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),Ba) = aa(B,B,aa(B,fun(B,B),inf_inf(B),K),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)) ) ) ) ).

% boolean_algebra_cancel.inf1
tff(fact_146_one__assn__raw_Ocases,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ~ ! [H: heap_ext(product_unit),As2: set(nat)] : ( X != aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) ) ).

% one_assn_raw.cases
tff(fact_147_inf__fun__def,axiom,
    ! [C: $tType,B: $tType] :
      ( semilattice_inf(C)
     => ! [Fa: fun(B,C),Ga: fun(B,C),X3: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),inf_inf(fun(B,C)),Fa),Ga),X3) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,Fa,X3)),aa(B,C,Ga,X3)) ) ) ).

% inf_fun_def
tff(fact_148_inf__left__commute,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Z2)) ) ) ).

% inf_left_commute
tff(fact_149_inf_Oleft__commute,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Ba: B,A3: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),Ba),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),C2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(B,B,aa(B,fun(B,B),inf_inf(B),Ba),C2)) ) ) ).

% inf.left_commute
tff(fact_150_inf__commute,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),X) ) ) ).

% inf_commute
tff(fact_151_inf_Ocommute,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Ba),A3) ) ) ).

% inf.commute
tff(fact_152_inf__assoc,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),Z2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) ) ) ).

% inf_assoc
tff(fact_153_inf_Oassoc,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(B,B,aa(B,fun(B,B),inf_inf(B),Ba),C2)) ) ) ).

% inf.assoc
tff(fact_154_monoid_Oright__neutral,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,A3: B] :
      ( monoid(B,Fa,Z2)
     => ( aa(B,B,aa(B,fun(B,B),Fa,A3),Z2) = A3 ) ) ).

% monoid.right_neutral
tff(fact_155_monoid_Oleft__neutral,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,A3: B] :
      ( monoid(B,Fa,Z2)
     => ( aa(B,B,aa(B,fun(B,B),Fa,Z2),A3) = A3 ) ) ).

% monoid.left_neutral
tff(fact_156_inf__sup__aci_I1_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),X) ) ) ).

% inf_sup_aci(1)
tff(fact_157_inf__sup__aci_I2_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),Z2) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) ) ) ).

% inf_sup_aci(2)
tff(fact_158_inf__sup__aci_I3_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Z2)) ) ) ).

% inf_sup_aci(3)
tff(fact_159_inf__sup__aci_I4_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) ) ) ).

% inf_sup_aci(4)
tff(fact_160_distrib__imp1,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B,Z2: B] :
          ( ! [X2: B,Y2: B,Z3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y2),Z3)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y2)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Z3)) )
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Z2)) ) ) ) ).

% distrib_imp1
tff(fact_161_distrib__imp2,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B,Z2: B] :
          ( ! [X2: B,Y2: B,Z3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y2),Z3)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y2)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Z3)) )
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Z2)) ) ) ) ).

% distrib_imp2
tff(fact_162_inf__sup__distrib1,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Z2)) ) ) ).

% inf_sup_distrib1
tff(fact_163_inf__sup__distrib2,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Y: B,Z2: B,X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)),X) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),X)),aa(B,B,aa(B,fun(B,B),inf_inf(B),Z2),X)) ) ) ).

% inf_sup_distrib2
tff(fact_164_sup__inf__distrib1,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Z2)) ) ) ).

% sup_inf_distrib1
tff(fact_165_sup__inf__distrib2,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Y: B,Z2: B,X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)),X) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),X)),aa(B,B,aa(B,fun(B,B),sup_sup(B),Z2),X)) ) ) ).

% sup_inf_distrib2
tff(fact_166_boolean__algebra_Oconj__disj__distrib,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Z2)) ) ) ).

% boolean_algebra.conj_disj_distrib
tff(fact_167_boolean__algebra_Odisj__conj__distrib,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Z2)) ) ) ).

% boolean_algebra.disj_conj_distrib
tff(fact_168_boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,Z2: B,X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)),X) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),X)),aa(B,B,aa(B,fun(B,B),inf_inf(B),Z2),X)) ) ) ).

% boolean_algebra.conj_disj_distrib2
tff(fact_169_boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,Z2: B,X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)),X) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),X)),aa(B,B,aa(B,fun(B,B),sup_sup(B),Z2),X)) ) ) ).

% boolean_algebra.disj_conj_distrib2
tff(fact_170_mod__and__dist,axiom,
    ! [Pa: assn,Qa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),Pa),Qa)),H2)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),H2) ) ) ).

% mod_and_dist
tff(fact_171_ent__conjI,axiom,
    ! [A4: assn,B2: assn,C3: assn] :
      ( entails(A4,B2)
     => ( entails(A4,C3)
       => entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),B2),C3)) ) ) ).

% ent_conjI
tff(fact_172_ent__conjE1,axiom,
    ! [A4: assn,C3: assn,B2: assn] :
      ( entails(A4,C3)
     => entails(aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A4),B2),C3) ) ).

% ent_conjE1
tff(fact_173_ent__conjE2,axiom,
    ! [B2: assn,C3: assn,A4: assn] :
      ( entails(B2,C3)
     => entails(aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A4),B2),C3) ) ).

% ent_conjE2
tff(fact_174_mod__h__bot__indep,axiom,
    ! [Pa: assn,H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),bot_bot(set(nat)))) ) ).

% mod_h_bot_indep
tff(fact_175_mod__emp__simp,axiom,
    ! [H2: heap_ext(product_unit)] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,one_one(assn)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ).

% mod_emp_simp
tff(fact_176_comp__apply,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(C,B),Ga: fun(D,C),X: D] : ( aa(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Fa),Ga),X) = aa(C,B,Fa,aa(D,C,Ga,X)) ) ).

% comp_apply
tff(fact_177_empty__Collect__eq,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ( bot_bot(set(B)) = aa(fun(B,$o),set(B),collect(B),Pa) )
    <=> ! [X4: B] : ~ aa(B,$o,Pa,X4) ) ).

% empty_Collect_eq
tff(fact_178_Collect__empty__eq,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ( aa(fun(B,$o),set(B),collect(B),Pa) = bot_bot(set(B)) )
    <=> ! [X4: B] : ~ aa(B,$o,Pa,X4) ) ).

% Collect_empty_eq
tff(fact_179_all__not__in__conv,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ! [X4: B] : ~ member(B,X4,A4)
    <=> ( A4 = bot_bot(set(B)) ) ) ).

% all_not_in_conv
tff(fact_180_empty__iff,axiom,
    ! [B: $tType,C2: B] : ~ member(B,C2,bot_bot(set(B))) ).

% empty_iff
tff(fact_181_Un__empty,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2) = bot_bot(set(B)) )
    <=> ( ( A4 = bot_bot(set(B)) )
        & ( B2 = bot_bot(set(B)) ) ) ) ).

% Un_empty
tff(fact_182_prod_Oinject,axiom,
    ! [B: $tType,C: $tType,X1: B,X22: C,Y1: B,Y22: C] :
      ( ( aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X1),X22) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Y1),Y22) )
    <=> ( ( X1 = Y1 )
        & ( X22 = Y22 ) ) ) ).

% prod.inject
tff(fact_183_old_Oprod_Oinject,axiom,
    ! [B: $tType,C: $tType,A3: B,Ba: C,A5: B,B3: C] :
      ( ( aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A5),B3) )
    <=> ( ( A3 = A5 )
        & ( Ba = B3 ) ) ) ).

% old.prod.inject
tff(fact_184_hoare__triple__effect,axiom,
    ! [B: $tType,Pa: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn),H2: heap_ext(product_unit),As: set(nat)] :
      ( hoare_hoare_triple(B,Pa,C2,Qa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
       => ? [H5: heap_ext(product_unit),R2: B,T2: nat] :
            ( heap_Time_effect(B,C2,H2,H5,R2,T2)
            & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Qa,R2)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),hoare_new_addrs(H2,As,H5))) ) ) ) ).

% hoare_triple_effect
tff(fact_185_pure__assn__raw_Oelims_I3_J,axiom,
    ! [C: $tType,B: $tType,X: $o,Xa: product_prod(B,set(C))] :
      ( ~ aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X),Xa)
     => ~ ! [H: B,As2: set(C)] :
            ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H),As2) )
           => ( ( As2 = bot_bot(set(C)) )
              & (X) ) ) ) ).

% pure_assn_raw.elims(3)
tff(fact_186_pure__assn__raw_Oelims_I2_J,axiom,
    ! [C: $tType,B: $tType,X: $o,Xa: product_prod(B,set(C))] :
      ( aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X),Xa)
     => ~ ! [H: B,As2: set(C)] :
            ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H),As2) )
           => ~ ( ( As2 = bot_bot(set(C)) )
                & (X) ) ) ) ).

% pure_assn_raw.elims(2)
tff(fact_187_pure__assn__raw_Oelims_I1_J,axiom,
    ! [C: $tType,B: $tType,X: $o,Xa: product_prod(B,set(C)),Y: $o] :
      ( ( aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X),Xa)
      <=> (Y) )
     => ~ ! [H: B,As2: set(C)] :
            ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H),As2) )
           => ( (Y)
            <=> ~ ( ( As2 = bot_bot(set(C)) )
                  & (X) ) ) ) ) ).

% pure_assn_raw.elims(1)
tff(fact_188_Int__Un__eq_I4_J,axiom,
    ! [B: $tType,T3: set(B),S2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),T3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3)) = T3 ) ).

% Int_Un_eq(4)
tff(fact_189_Int__Un__eq_I3_J,axiom,
    ! [B: $tType,S2: set(B),T3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3)) = S2 ) ).

% Int_Un_eq(3)
tff(fact_190_Int__Un__eq_I2_J,axiom,
    ! [B: $tType,S2: set(B),T3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3)),T3) = T3 ) ).

% Int_Un_eq(2)
tff(fact_191_Int__Un__eq_I1_J,axiom,
    ! [B: $tType,S2: set(B),T3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3)),S2) = S2 ) ).

% Int_Un_eq(1)
tff(fact_192_Un__Int__eq_I4_J,axiom,
    ! [B: $tType,T3: set(B),S2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),T3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S2),T3)) = T3 ) ).

% Un_Int_eq(4)
tff(fact_193_Un__Int__eq_I3_J,axiom,
    ! [B: $tType,S2: set(B),T3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S2),T3)) = S2 ) ).

% Un_Int_eq(3)
tff(fact_194_Un__Int__eq_I2_J,axiom,
    ! [B: $tType,S2: set(B),T3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S2),T3)),T3) = T3 ) ).

% Un_Int_eq(2)
tff(fact_195_Un__Int__eq_I1_J,axiom,
    ! [B: $tType,S2: set(B),T3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S2),T3)),S2) = S2 ) ).

% Un_Int_eq(1)
tff(fact_196_Un__Int__crazy,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),C3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C3),A4)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),C3))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),C3),A4)) ) ).

% Un_Int_crazy
tff(fact_197_Int__Un__distrib,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),C3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),C3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),C3)) ) ).

% Int_Un_distrib
tff(fact_198_Un__Int__distrib,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),C3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),C3)) ) ).

% Un_Int_distrib
tff(fact_199_Int__Un__distrib2,axiom,
    ! [B: $tType,B2: set(B),C3: set(B),A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),C3)),A4) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),A4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C3),A4)) ) ).

% Int_Un_distrib2
tff(fact_200_Un__Int__distrib2,axiom,
    ! [B: $tType,B2: set(B),C3: set(B),A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3)),A4) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),A4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),C3),A4)) ) ).

% Un_Int_distrib2
tff(fact_201_effect__deterministic_I3_J,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),A3: B,N: nat,H6: heap_ext(product_unit),Ba: B,N2: nat] :
      ( heap_Time_effect(B,Fa,H2,H4,A3,N)
     => ( heap_Time_effect(B,Fa,H2,H6,Ba,N2)
       => ( N = N2 ) ) ) ).

% effect_deterministic(3)
tff(fact_202_effect__deterministic_I2_J,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),A3: B,N: nat,H6: heap_ext(product_unit),Ba: B,N2: nat] :
      ( heap_Time_effect(B,Fa,H2,H4,A3,N)
     => ( heap_Time_effect(B,Fa,H2,H6,Ba,N2)
       => ( H4 = H6 ) ) ) ).

% effect_deterministic(2)
tff(fact_203_effect__deterministic_I1_J,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),A3: B,N: nat,H6: heap_ext(product_unit),Ba: B,N2: nat] :
      ( heap_Time_effect(B,Fa,H2,H4,A3,N)
     => ( heap_Time_effect(B,Fa,H2,H6,Ba,N2)
       => ( A3 = Ba ) ) ) ).

% effect_deterministic(1)
tff(fact_204_effect__ifE,axiom,
    ! [B: $tType,C2: $o,T4: heap_Time_Heap(B),E2: heap_Time_Heap(B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( heap_Time_effect(B,$ite((C2),T4,E2),H2,H4,R3,N)
     => ( ( (C2)
         => ~ heap_Time_effect(B,T4,H2,H4,R3,N) )
       => ~ ( ~ (C2)
           => ~ heap_Time_effect(B,E2,H2,H4,R3,N) ) ) ) ).

% effect_ifE
tff(fact_205_effect__ifI,axiom,
    ! [B: $tType,C2: $o,T4: heap_Time_Heap(B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat,E2: heap_Time_Heap(B)] :
      ( ( (C2)
       => heap_Time_effect(B,T4,H2,H4,R3,N) )
     => ( ( ~ (C2)
         => heap_Time_effect(B,E2,H2,H4,R3,N) )
       => heap_Time_effect(B,$ite((C2),T4,E2),H2,H4,R3,N) ) ) ).

% effect_ifI
tff(fact_206_times__assn__raw_Ocases,axiom,
    ! [X: product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))] :
      ~ ! [P4: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Q3: fun(product_prod(heap_ext(product_unit),set(nat)),$o),H: heap_ext(product_unit),As2: set(nat)] : ( X != aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),P4),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Q3),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))) ) ).

% times_assn_raw.cases
tff(fact_207_sngr__assn__raw_Ocases,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))] :
          ~ ! [R2: ref(B),X2: B,H: heap_ext(product_unit),As2: set(nat)] : ( X != aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),R2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),X2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))) ) ) ).

% sngr_assn_raw.cases
tff(fact_208_snga__assn__raw_Ocases,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))] :
          ~ ! [R2: array(B),X2: list(B),H: heap_ext(product_unit),As2: set(nat)] : ( X != aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),R2),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),X2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))) ) ) ).

% snga_assn_raw.cases
tff(fact_209_Int__emptyI,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ! [X2: B] :
          ( member(B,X2,A4)
         => ~ member(B,X2,B2) )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) ) ) ).

% Int_emptyI
tff(fact_210_disjoint__iff,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) )
    <=> ! [X4: B] :
          ( member(B,X4,A4)
         => ~ member(B,X4,B2) ) ) ).

% disjoint_iff
tff(fact_211_Int__empty__left,axiom,
    ! [B: $tType,B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),bot_bot(set(B))),B2) = bot_bot(set(B)) ) ).

% Int_empty_left
tff(fact_212_Int__empty__right,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),bot_bot(set(B))) = bot_bot(set(B)) ) ).

% Int_empty_right
tff(fact_213_disjoint__iff__not__equal,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) )
    <=> ! [X4: B] :
          ( member(B,X4,A4)
         => ! [Xa2: B] :
              ( member(B,Xa2,B2)
             => ( X4 != Xa2 ) ) ) ) ).

% disjoint_iff_not_equal
tff(fact_214_pure__assn__raw_Ocases,axiom,
    ! [B: $tType,C: $tType,X: product_prod($o,product_prod(B,set(C)))] :
      ~ ! [B4: $o,H: B,As2: set(C)] : ( X != aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),B4),aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H),As2)) ) ).

% pure_assn_raw.cases
tff(fact_215_effect__returnI,axiom,
    ! [B: $tType,H2: heap_ext(product_unit),H4: heap_ext(product_unit),X: B] :
      ( ( H2 = H4 )
     => heap_Time_effect(B,aa(B,heap_Time_Heap(B),heap_Time_return(B),X),H2,H4,X,one_one(nat)) ) ).

% effect_returnI
tff(fact_216_effect__returnE,axiom,
    ! [B: $tType,X: B,H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( heap_Time_effect(B,aa(B,heap_Time_Heap(B),heap_Time_return(B),X),H2,H4,R3,N)
     => ~ ( ( R3 = X )
         => ( ( H4 = H2 )
           => ( N != one_one(nat) ) ) ) ) ).

% effect_returnE
tff(fact_217_effect__raiseE,axiom,
    ! [B: $tType,X: list(char),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] : ~ heap_Time_effect(B,heap_Time_raise(B,X),H2,H4,R3,N) ).

% effect_raiseE
tff(fact_218_prod__induct7,axiom,
    ! [H7: $tType,G: $tType,F7: $tType,E: $tType,D: $tType,C: $tType,B: $tType,Pa: fun(product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))))),$o),X: product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))))] :
      ( ! [A8: B,B4: C,C4: D,D3: E,E3: F7,F8: G,G2: H7] : aa(product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))))),$o,Pa,aa(product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))))),aa(B,fun(product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))))),product_Pair(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))))),A8),aa(product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))),product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))),aa(C,fun(product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))),product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))))),product_Pair(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))),B4),aa(product_prod(E,product_prod(F7,product_prod(G,H7))),product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))),aa(D,fun(product_prod(E,product_prod(F7,product_prod(G,H7))),product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))),product_Pair(D,product_prod(E,product_prod(F7,product_prod(G,H7)))),C4),aa(product_prod(F7,product_prod(G,H7)),product_prod(E,product_prod(F7,product_prod(G,H7))),aa(E,fun(product_prod(F7,product_prod(G,H7)),product_prod(E,product_prod(F7,product_prod(G,H7)))),product_Pair(E,product_prod(F7,product_prod(G,H7))),D3),aa(product_prod(G,H7),product_prod(F7,product_prod(G,H7)),aa(F7,fun(product_prod(G,H7),product_prod(F7,product_prod(G,H7))),product_Pair(F7,product_prod(G,H7)),E3),aa(H7,product_prod(G,H7),aa(G,fun(H7,product_prod(G,H7)),product_Pair(G,H7),F8),G2)))))))
     => aa(product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))))),$o,Pa,X) ) ).

% prod_induct7
tff(fact_219_prod__induct6,axiom,
    ! [G: $tType,F7: $tType,E: $tType,D: $tType,C: $tType,B: $tType,Pa: fun(product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G))))),$o),X: product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G)))))] :
      ( ! [A8: B,B4: C,C4: D,D3: E,E3: F7,F8: G] : aa(product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G))))),$o,Pa,aa(product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G)))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G))))),aa(B,fun(product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G)))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G)))))),product_Pair(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G))))),A8),aa(product_prod(D,product_prod(E,product_prod(F7,G))),product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G)))),aa(C,fun(product_prod(D,product_prod(E,product_prod(F7,G))),product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G))))),product_Pair(C,product_prod(D,product_prod(E,product_prod(F7,G)))),B4),aa(product_prod(E,product_prod(F7,G)),product_prod(D,product_prod(E,product_prod(F7,G))),aa(D,fun(product_prod(E,product_prod(F7,G)),product_prod(D,product_prod(E,product_prod(F7,G)))),product_Pair(D,product_prod(E,product_prod(F7,G))),C4),aa(product_prod(F7,G),product_prod(E,product_prod(F7,G)),aa(E,fun(product_prod(F7,G),product_prod(E,product_prod(F7,G))),product_Pair(E,product_prod(F7,G)),D3),aa(G,product_prod(F7,G),aa(F7,fun(G,product_prod(F7,G)),product_Pair(F7,G),E3),F8))))))
     => aa(product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G))))),$o,Pa,X) ) ).

% prod_induct6
tff(fact_220_prod__induct5,axiom,
    ! [F7: $tType,E: $tType,D: $tType,C: $tType,B: $tType,Pa: fun(product_prod(B,product_prod(C,product_prod(D,product_prod(E,F7)))),$o),X: product_prod(B,product_prod(C,product_prod(D,product_prod(E,F7))))] :
      ( ! [A8: B,B4: C,C4: D,D3: E,E3: F7] : aa(product_prod(B,product_prod(C,product_prod(D,product_prod(E,F7)))),$o,Pa,aa(product_prod(C,product_prod(D,product_prod(E,F7))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,F7)))),aa(B,fun(product_prod(C,product_prod(D,product_prod(E,F7))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,F7))))),product_Pair(B,product_prod(C,product_prod(D,product_prod(E,F7)))),A8),aa(product_prod(D,product_prod(E,F7)),product_prod(C,product_prod(D,product_prod(E,F7))),aa(C,fun(product_prod(D,product_prod(E,F7)),product_prod(C,product_prod(D,product_prod(E,F7)))),product_Pair(C,product_prod(D,product_prod(E,F7))),B4),aa(product_prod(E,F7),product_prod(D,product_prod(E,F7)),aa(D,fun(product_prod(E,F7),product_prod(D,product_prod(E,F7))),product_Pair(D,product_prod(E,F7)),C4),aa(F7,product_prod(E,F7),aa(E,fun(F7,product_prod(E,F7)),product_Pair(E,F7),D3),E3)))))
     => aa(product_prod(B,product_prod(C,product_prod(D,product_prod(E,F7)))),$o,Pa,X) ) ).

% prod_induct5
tff(fact_221_prod__induct4,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,Pa: fun(product_prod(B,product_prod(C,product_prod(D,E))),$o),X: product_prod(B,product_prod(C,product_prod(D,E)))] :
      ( ! [A8: B,B4: C,C4: D,D3: E] : aa(product_prod(B,product_prod(C,product_prod(D,E))),$o,Pa,aa(product_prod(C,product_prod(D,E)),product_prod(B,product_prod(C,product_prod(D,E))),aa(B,fun(product_prod(C,product_prod(D,E)),product_prod(B,product_prod(C,product_prod(D,E)))),product_Pair(B,product_prod(C,product_prod(D,E))),A8),aa(product_prod(D,E),product_prod(C,product_prod(D,E)),aa(C,fun(product_prod(D,E),product_prod(C,product_prod(D,E))),product_Pair(C,product_prod(D,E)),B4),aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),C4),D3))))
     => aa(product_prod(B,product_prod(C,product_prod(D,E))),$o,Pa,X) ) ).

% prod_induct4
tff(fact_222_prod__induct3,axiom,
    ! [D: $tType,C: $tType,B: $tType,Pa: fun(product_prod(B,product_prod(C,D)),$o),X: product_prod(B,product_prod(C,D))] :
      ( ! [A8: B,B4: C,C4: D] : aa(product_prod(B,product_prod(C,D)),$o,Pa,aa(product_prod(C,D),product_prod(B,product_prod(C,D)),aa(B,fun(product_prod(C,D),product_prod(B,product_prod(C,D))),product_Pair(B,product_prod(C,D)),A8),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),B4),C4)))
     => aa(product_prod(B,product_prod(C,D)),$o,Pa,X) ) ).

% prod_induct3
tff(fact_223_prod__cases7,axiom,
    ! [B: $tType,C: $tType,D: $tType,E: $tType,F7: $tType,G: $tType,H7: $tType,Y: product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))))] :
      ~ ! [A8: B,B4: C,C4: D,D3: E,E3: F7,F8: G,G2: H7] : ( Y != aa(product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))))),aa(B,fun(product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))))),product_Pair(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))))),A8),aa(product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))),product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))),aa(C,fun(product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))),product_prod(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))))),product_Pair(C,product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))),B4),aa(product_prod(E,product_prod(F7,product_prod(G,H7))),product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7)))),aa(D,fun(product_prod(E,product_prod(F7,product_prod(G,H7))),product_prod(D,product_prod(E,product_prod(F7,product_prod(G,H7))))),product_Pair(D,product_prod(E,product_prod(F7,product_prod(G,H7)))),C4),aa(product_prod(F7,product_prod(G,H7)),product_prod(E,product_prod(F7,product_prod(G,H7))),aa(E,fun(product_prod(F7,product_prod(G,H7)),product_prod(E,product_prod(F7,product_prod(G,H7)))),product_Pair(E,product_prod(F7,product_prod(G,H7))),D3),aa(product_prod(G,H7),product_prod(F7,product_prod(G,H7)),aa(F7,fun(product_prod(G,H7),product_prod(F7,product_prod(G,H7))),product_Pair(F7,product_prod(G,H7)),E3),aa(H7,product_prod(G,H7),aa(G,fun(H7,product_prod(G,H7)),product_Pair(G,H7),F8),G2)))))) ) ).

% prod_cases7
tff(fact_224_prod__cases6,axiom,
    ! [B: $tType,C: $tType,D: $tType,E: $tType,F7: $tType,G: $tType,Y: product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G)))))] :
      ~ ! [A8: B,B4: C,C4: D,D3: E,E3: F7,F8: G] : ( Y != aa(product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G)))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G))))),aa(B,fun(product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G)))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G)))))),product_Pair(B,product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G))))),A8),aa(product_prod(D,product_prod(E,product_prod(F7,G))),product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G)))),aa(C,fun(product_prod(D,product_prod(E,product_prod(F7,G))),product_prod(C,product_prod(D,product_prod(E,product_prod(F7,G))))),product_Pair(C,product_prod(D,product_prod(E,product_prod(F7,G)))),B4),aa(product_prod(E,product_prod(F7,G)),product_prod(D,product_prod(E,product_prod(F7,G))),aa(D,fun(product_prod(E,product_prod(F7,G)),product_prod(D,product_prod(E,product_prod(F7,G)))),product_Pair(D,product_prod(E,product_prod(F7,G))),C4),aa(product_prod(F7,G),product_prod(E,product_prod(F7,G)),aa(E,fun(product_prod(F7,G),product_prod(E,product_prod(F7,G))),product_Pair(E,product_prod(F7,G)),D3),aa(G,product_prod(F7,G),aa(F7,fun(G,product_prod(F7,G)),product_Pair(F7,G),E3),F8))))) ) ).

% prod_cases6
tff(fact_225_prod__cases5,axiom,
    ! [B: $tType,C: $tType,D: $tType,E: $tType,F7: $tType,Y: product_prod(B,product_prod(C,product_prod(D,product_prod(E,F7))))] :
      ~ ! [A8: B,B4: C,C4: D,D3: E,E3: F7] : ( Y != aa(product_prod(C,product_prod(D,product_prod(E,F7))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,F7)))),aa(B,fun(product_prod(C,product_prod(D,product_prod(E,F7))),product_prod(B,product_prod(C,product_prod(D,product_prod(E,F7))))),product_Pair(B,product_prod(C,product_prod(D,product_prod(E,F7)))),A8),aa(product_prod(D,product_prod(E,F7)),product_prod(C,product_prod(D,product_prod(E,F7))),aa(C,fun(product_prod(D,product_prod(E,F7)),product_prod(C,product_prod(D,product_prod(E,F7)))),product_Pair(C,product_prod(D,product_prod(E,F7))),B4),aa(product_prod(E,F7),product_prod(D,product_prod(E,F7)),aa(D,fun(product_prod(E,F7),product_prod(D,product_prod(E,F7))),product_Pair(D,product_prod(E,F7)),C4),aa(F7,product_prod(E,F7),aa(E,fun(F7,product_prod(E,F7)),product_Pair(E,F7),D3),E3)))) ) ).

% prod_cases5
tff(fact_226_prod__cases4,axiom,
    ! [B: $tType,C: $tType,D: $tType,E: $tType,Y: product_prod(B,product_prod(C,product_prod(D,E)))] :
      ~ ! [A8: B,B4: C,C4: D,D3: E] : ( Y != aa(product_prod(C,product_prod(D,E)),product_prod(B,product_prod(C,product_prod(D,E))),aa(B,fun(product_prod(C,product_prod(D,E)),product_prod(B,product_prod(C,product_prod(D,E)))),product_Pair(B,product_prod(C,product_prod(D,E))),A8),aa(product_prod(D,E),product_prod(C,product_prod(D,E)),aa(C,fun(product_prod(D,E),product_prod(C,product_prod(D,E))),product_Pair(C,product_prod(D,E)),B4),aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),C4),D3))) ) ).

% prod_cases4
tff(fact_227_prod__cases3,axiom,
    ! [B: $tType,C: $tType,D: $tType,Y: product_prod(B,product_prod(C,D))] :
      ~ ! [A8: B,B4: C,C4: D] : ( Y != aa(product_prod(C,D),product_prod(B,product_prod(C,D)),aa(B,fun(product_prod(C,D),product_prod(B,product_prod(C,D))),product_Pair(B,product_prod(C,D)),A8),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),B4),C4)) ) ).

% prod_cases3
tff(fact_228_Pair__inject,axiom,
    ! [B: $tType,C: $tType,A3: B,Ba: C,A5: B,B3: C] :
      ( ( aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A5),B3) )
     => ~ ( ( A3 = A5 )
         => ( Ba != B3 ) ) ) ).

% Pair_inject
tff(fact_229_prod__cases,axiom,
    ! [C: $tType,B: $tType,Pa: fun(product_prod(B,C),$o),P2: product_prod(B,C)] :
      ( ! [A8: B,B4: C] : aa(product_prod(B,C),$o,Pa,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4))
     => aa(product_prod(B,C),$o,Pa,P2) ) ).

% prod_cases
tff(fact_230_surj__pair,axiom,
    ! [B: $tType,C: $tType,P2: product_prod(B,C)] :
    ? [X2: B,Y2: C] : ( P2 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2) ) ).

% surj_pair
tff(fact_231_old_Oprod_Oexhaust,axiom,
    ! [B: $tType,C: $tType,Y: product_prod(B,C)] :
      ~ ! [A8: B,B4: C] : ( Y != aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4) ) ).

% old.prod.exhaust
tff(fact_232_emptyE,axiom,
    ! [B: $tType,A3: B] : ~ member(B,A3,bot_bot(set(B))) ).

% emptyE
tff(fact_233_equals0D,axiom,
    ! [B: $tType,A4: set(B),A3: B] :
      ( ( A4 = bot_bot(set(B)) )
     => ~ member(B,A3,A4) ) ).

% equals0D
tff(fact_234_equals0I,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ! [Y2: B] : ~ member(B,Y2,A4)
     => ( A4 = bot_bot(set(B)) ) ) ).

% equals0I
tff(fact_235_ex__in__conv,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ? [X4: B] : member(B,X4,A4)
    <=> ( A4 != bot_bot(set(B)) ) ) ).

% ex_in_conv
tff(fact_236_bot__set__def,axiom,
    ! [B: $tType] : ( bot_bot(set(B)) = aa(fun(B,$o),set(B),collect(B),bot_bot(fun(B,$o))) ) ).

% bot_set_def
tff(fact_237_Un__empty__left,axiom,
    ! [B: $tType,B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),bot_bot(set(B))),B2) = B2 ) ).

% Un_empty_left
tff(fact_238_Un__empty__right,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),bot_bot(set(B))) = A4 ) ).

% Un_empty_right
tff(fact_239_comp__eq__dest__lhs,axiom,
    ! [D: $tType,C: $tType,B: $tType,A3: fun(D,C),Ba: fun(B,D),C2: fun(B,C),V: B] :
      ( ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),A3),Ba) = C2 )
     => ( aa(D,C,A3,aa(B,D,Ba,V)) = aa(B,C,C2,V) ) ) ).

% comp_eq_dest_lhs
tff(fact_240_comp__eq__elim,axiom,
    ! [D: $tType,C: $tType,E: $tType,B: $tType,A3: fun(D,C),Ba: fun(B,D),C2: fun(E,C),D2: fun(B,E)] :
      ( ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),A3),Ba) = aa(fun(B,E),fun(B,C),aa(fun(E,C),fun(fun(B,E),fun(B,C)),comp(E,C,B),C2),D2) )
     => ! [V2: B] : ( aa(D,C,A3,aa(B,D,Ba,V2)) = aa(E,C,C2,aa(B,E,D2,V2)) ) ) ).

% comp_eq_elim
tff(fact_241_comp__eq__dest,axiom,
    ! [D: $tType,C: $tType,E: $tType,B: $tType,A3: fun(D,C),Ba: fun(B,D),C2: fun(E,C),D2: fun(B,E),V: B] :
      ( ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),A3),Ba) = aa(fun(B,E),fun(B,C),aa(fun(E,C),fun(fun(B,E),fun(B,C)),comp(E,C,B),C2),D2) )
     => ( aa(D,C,A3,aa(B,D,Ba,V)) = aa(E,C,C2,aa(B,E,D2,V)) ) ) ).

% comp_eq_dest
tff(fact_242_comp__assoc,axiom,
    ! [C: $tType,E: $tType,D: $tType,B: $tType,Fa: fun(E,C),Ga: fun(D,E),H2: fun(B,D)] : ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),aa(fun(D,E),fun(D,C),aa(fun(E,C),fun(fun(D,E),fun(D,C)),comp(E,C,D),Fa),Ga)),H2) = aa(fun(B,E),fun(B,C),aa(fun(E,C),fun(fun(B,E),fun(B,C)),comp(E,C,B),Fa),aa(fun(B,D),fun(B,E),aa(fun(D,E),fun(fun(B,D),fun(B,E)),comp(D,E,B),Ga),H2)) ) ).

% comp_assoc
tff(fact_243_comp__def,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(D,C),Ga: fun(B,D),X3: B] : ( aa(B,C,aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),Ga),X3) = aa(D,C,Fa,aa(B,D,Ga,X3)) ) ).

% comp_def
tff(fact_244_star__assnI,axiom,
    ! [Pa: assn,H2: heap_ext(product_unit),As: set(nat),Qa: assn,As3: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3))
       => ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As3) = bot_bot(set(nat)) )
         => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As3))) ) ) ) ).

% star_assnI
tff(fact_245_mod__star__conv,axiom,
    ! [A4: assn,B2: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),B2)),H2)
    <=> ? [Hr: heap_ext(product_unit),As1: set(nat),As22: set(nat)] :
          ( ( H2 = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22)) )
          & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,A4),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),As1))
          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,B2),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),Hr),As22)) ) ) ).

% mod_star_conv
tff(fact_246_pure__assn__raw_Osimps,axiom,
    ! [C: $tType,B: $tType,Ba: $o,H2: B,As: set(C)] :
      ( aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,Ba),aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H2),As))
    <=> ( ( As = bot_bot(set(C)) )
        & (Ba) ) ) ).

% pure_assn_raw.simps
tff(fact_247_old_Oprod_Orec,axiom,
    ! [C: $tType,B: $tType,D: $tType,F1: fun(C,fun(D,B)),A3: C,Ba: D] : ( product_rec_prod(C,D,B,F1,aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),A3),Ba)) = aa(D,B,aa(C,fun(D,B),F1,A3),Ba) ) ).

% old.prod.rec
tff(fact_248_Set_Ois__empty__def,axiom,
    ! [B: $tType,A4: set(B)] :
      ( is_empty2(B,A4)
    <=> ( A4 = bot_bot(set(B)) ) ) ).

% Set.is_empty_def
tff(fact_249_internal__case__prod__conv,axiom,
    ! [C: $tType,B: $tType,D: $tType,C2: fun(C,fun(D,B)),A3: C,Ba: D] : ( produc5280177257484947105e_prod(C,D,B,C2,aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),A3),Ba)) = aa(D,B,aa(C,fun(D,B),C2,A3),Ba) ) ).

% internal_case_prod_conv
tff(fact_250_one__assn__raw_Osimps,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
    <=> ( As = bot_bot(set(nat)) ) ) ).

% one_assn_raw.simps
tff(fact_251_one__assn__raw_Oelims_I1_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X)
      <=> (Y) )
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( (Y)
            <=> ( As2 != bot_bot(set(nat)) ) ) ) ) ).

% one_assn_raw.elims(1)
tff(fact_252_one__assn__raw_Oelims_I2_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X)
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( As2 != bot_bot(set(nat)) ) ) ) ).

% one_assn_raw.elims(2)
tff(fact_253_one__assn__raw_Oelims_I3_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X)
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( As2 = bot_bot(set(nat)) ) ) ) ).

% one_assn_raw.elims(3)
tff(fact_254_hoare__triple__success,axiom,
    ! [B: $tType,Pa: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn),H2: heap_ext(product_unit),As: set(nat)] :
      ( hoare_hoare_triple(B,Pa,C2,Qa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
       => heap_Time_success(B,C2,H2) ) ) ).

% hoare_triple_success
tff(fact_255_times__assn__raw_Osimps,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),H2: heap_ext(product_unit),As: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(Pa,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
    <=> ? [As1: set(nat),As22: set(nat)] :
          ( ( As = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
          & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As1))
          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Qa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As22)) ) ) ).

% times_assn_raw.simps
tff(fact_256_times__assn__raw_Oelims_I1_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X,Xa),Xb)
      <=> (Y) )
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( (Y)
            <=> ~ ? [As1: set(nat),As22: set(nat)] :
                    ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
                    & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As1))
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As22)) ) ) ) ) ).

% times_assn_raw.elims(1)
tff(fact_257_times__assn__raw_Oelims_I2_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X,Xa),Xb)
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ~ ? [As12: set(nat),As23: set(nat)] :
                  ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As12),As23) )
                  & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As12),As23) = bot_bot(set(nat)) )
                  & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As12))
                  & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As23)) ) ) ) ).

% times_assn_raw.elims(2)
tff(fact_258_IntI,axiom,
    ! [B: $tType,C2: B,A4: set(B),B2: set(B)] :
      ( member(B,C2,A4)
     => ( member(B,C2,B2)
       => member(B,C2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ) ).

% IntI
tff(fact_259_Int__iff,axiom,
    ! [B: $tType,C2: B,A4: set(B),B2: set(B)] :
      ( member(B,C2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))
    <=> ( member(B,C2,A4)
        & member(B,C2,B2) ) ) ).

% Int_iff
tff(fact_260_IntE,axiom,
    ! [B: $tType,C2: B,A4: set(B),B2: set(B)] :
      ( member(B,C2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))
     => ~ ( member(B,C2,A4)
         => ~ member(B,C2,B2) ) ) ).

% IntE
tff(fact_261_IntD1,axiom,
    ! [B: $tType,C2: B,A4: set(B),B2: set(B)] :
      ( member(B,C2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))
     => member(B,C2,A4) ) ).

% IntD1
tff(fact_262_IntD2,axiom,
    ! [B: $tType,C2: B,A4: set(B),B2: set(B)] :
      ( member(B,C2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))
     => member(B,C2,B2) ) ).

% IntD2
tff(fact_263_Int__assoc,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),C3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),C3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3)) ) ).

% Int_assoc
tff(fact_264_Int__absorb,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),A4) = A4 ) ).

% Int_absorb
tff(fact_265_Int__commute,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),A4) ) ).

% Int_commute
tff(fact_266_Int__left__absorb,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) ) ).

% Int_left_absorb
tff(fact_267_Int__left__commute,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),C3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),C3)) ) ).

% Int_left_commute
tff(fact_268_success__ifI,axiom,
    ! [B: $tType,C2: $o,T4: heap_Time_Heap(B),H2: heap_ext(product_unit),E2: heap_Time_Heap(B)] :
      ( ( (C2)
       => heap_Time_success(B,T4,H2) )
     => ( ( ~ (C2)
         => heap_Time_success(B,E2,H2) )
       => heap_Time_success(B,$ite((C2),T4,E2),H2) ) ) ).

% success_ifI
tff(fact_269_success__effectE,axiom,
    ! [B: $tType,C2: heap_Time_Heap(B),H2: heap_ext(product_unit)] :
      ( heap_Time_success(B,C2,H2)
     => ~ ! [R2: B,H5: heap_ext(product_unit),N3: nat] : ~ heap_Time_effect(B,C2,H2,H5,R2,N3) ) ).

% success_effectE
tff(fact_270_effect__success,axiom,
    ! [B: $tType,C2: heap_Time_Heap(B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( heap_Time_effect(B,C2,H2,H4,R3,N)
     => heap_Time_success(B,C2,H2) ) ).

% effect_success
tff(fact_271_success__returnI,axiom,
    ! [B: $tType,X: B,H2: heap_ext(product_unit)] : heap_Time_success(B,aa(B,heap_Time_Heap(B),heap_Time_return(B),X),H2) ).

% success_returnI
tff(fact_272_success__bind__effectI,axiom,
    ! [B: $tType,C: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),X: B,N: nat,Ga: fun(B,heap_Time_Heap(C))] :
      ( heap_Time_effect(B,Fa,H2,H4,X,N)
     => ( heap_Time_success(C,aa(B,heap_Time_Heap(C),Ga,X),H4)
       => heap_Time_success(C,heap_Time_bind(B,C,Fa,Ga),H2) ) ) ).

% success_bind_effectI
tff(fact_273_times__assn__raw_Oelims_I3_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X,Xa),Xb)
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ? [As13: set(nat),As24: set(nat)] :
                ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As13),As24) )
                & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As13),As24) = bot_bot(set(nat)) )
                & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As13))
                & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As24)) ) ) ) ).

% times_assn_raw.elims(3)
tff(fact_274_Collect__empty__eq__bot,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ( aa(fun(B,$o),set(B),collect(B),Pa) = bot_bot(set(B)) )
    <=> ( Pa = bot_bot(fun(B,$o)) ) ) ).

% Collect_empty_eq_bot
tff(fact_275_bot__empty__eq,axiom,
    ! [B: $tType,X3: B] :
      ( aa(B,$o,bot_bot(fun(B,$o)),X3)
    <=> member(B,X3,bot_bot(set(B))) ) ).

% bot_empty_eq
tff(fact_276_pairself_Ocases,axiom,
    ! [C: $tType,B: $tType,X: product_prod(fun(B,C),product_prod(B,B))] :
      ~ ! [F8: fun(B,C),A8: B,B4: B] : ( X != aa(product_prod(B,B),product_prod(fun(B,C),product_prod(B,B)),aa(fun(B,C),fun(product_prod(B,B),product_prod(fun(B,C),product_prod(B,B))),product_Pair(fun(B,C),product_prod(B,B)),F8),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),B4)) ) ).

% pairself.cases
tff(fact_277_disjointI,axiom,
    ! [B: $tType,A3: set(B),Ba: set(B)] :
      ( ! [X2: B] :
          ( member(B,X2,A3)
         => ~ member(B,X2,Ba) )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),Ba) = bot_bot(set(B)) ) ) ).

% disjointI
tff(fact_278_times__assn__raw_Opelims_I1_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X,Xa),Xb)
      <=> (Y) )
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( ( (Y)
                <=> ? [As1: set(nat),As22: set(nat)] :
                      ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As1),As22) )
                      & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As1),As22) = bot_bot(set(nat)) )
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As1))
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As22)) ) )
               => ~ aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))) ) ) ) ) ).

% times_assn_raw.pelims(1)
tff(fact_279_times__assn__raw_Opelims_I2_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X,Xa),Xb)
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))
               => ~ ? [As12: set(nat),As23: set(nat)] :
                      ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As12),As23) )
                      & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As12),As23) = bot_bot(set(nat)) )
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As12))
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As23)) ) ) ) ) ) ).

% times_assn_raw.pelims(2)
tff(fact_280_times__assn__raw_Opelims_I3_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,times_assn_raw(X,Xa),Xb)
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),times_assn_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))
               => ? [As13: set(nat),As24: set(nat)] :
                    ( ( As2 = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As13),As24) )
                    & ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As13),As24) = bot_bot(set(nat)) )
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As13))
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As24)) ) ) ) ) ) ).

% times_assn_raw.pelims(3)
tff(fact_281_effect__tapI,axiom,
    ! [B: $tType,H4: heap_ext(product_unit),H2: heap_ext(product_unit),R3: B,Fa: fun(heap_ext(product_unit),B)] :
      ( ( H4 = H2 )
     => ( ( R3 = aa(heap_ext(product_unit),B,Fa,H2) )
       => heap_Time_effect(B,heap_Time_tap(B,Fa),H2,H4,R3,one_one(nat)) ) ) ).

% effect_tapI
tff(fact_282_effect__tapE,axiom,
    ! [B: $tType,Fa: fun(heap_ext(product_unit),B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( heap_Time_effect(B,heap_Time_tap(B,Fa),H2,H4,R3,N)
     => ~ ( ( H4 = H2 )
         => ( ( R3 = aa(heap_ext(product_unit),B,Fa,H2) )
           => ( N != one_one(nat) ) ) ) ) ).

% effect_tapE
tff(fact_283_times__assn__def,axiom,
    ! [Pa: assn,Qa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),Qa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,times_assn_raw(aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa))) ) ).

% times_assn_def
tff(fact_284_effect__assertI,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: B,H4: heap_ext(product_unit),H2: heap_ext(product_unit),R3: B,N: nat] :
      ( aa(B,$o,Pa,X)
     => ( ( H4 = H2 )
       => ( ( R3 = X )
         => ( ( N = one_one(nat) )
           => heap_Time_effect(B,heap_Time_assert(B,Pa,X),H2,H4,R3,N) ) ) ) ) ).

% effect_assertI
tff(fact_285_Rep__assn__inverse,axiom,
    ! [X: assn] : ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,X)) = X ) ).

% Rep_assn_inverse
tff(fact_286_Abs__assn__eqI_I1_J,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pr: assn] :
      ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,H)
        <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pr),H) )
     => ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Pa) = Pr ) ) ).

% Abs_assn_eqI(1)
tff(fact_287_Abs__assn__eqI_I2_J,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pr: assn] :
      ( ! [H: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,H)
        <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pr),H) )
     => ( Pr = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Pa) ) ) ).

% Abs_assn_eqI(2)
tff(fact_288_pure__assn__def,axiom,
    ! [Ba: $o] : ( pure_assn(Ba) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,pure_assn_raw(heap_ext(product_unit),nat,Ba)) ) ).

% pure_assn_def
tff(fact_289_assert__cong,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),P: fun(B,$o),Fa: fun(B,heap_Time_Heap(C)),F9: fun(B,heap_Time_Heap(C)),X: B] :
      ( ( Pa = P )
     => ( ! [X2: B] :
            ( aa(B,$o,P,X2)
           => ( aa(B,heap_Time_Heap(C),Fa,X2) = aa(B,heap_Time_Heap(C),F9,X2) ) )
       => ( heap_Time_bind(B,C,heap_Time_assert(B,Pa,X),Fa) = heap_Time_bind(B,C,heap_Time_assert(B,P,X),F9) ) ) ) ).

% assert_cong
tff(fact_290_success__assertI,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: B,H2: heap_ext(product_unit)] :
      ( aa(B,$o,Pa,X)
     => heap_Time_success(B,heap_Time_assert(B,Pa,X),H2) ) ).

% success_assertI
tff(fact_291_success__tapI,axiom,
    ! [B: $tType,Fa: fun(heap_ext(product_unit),B),H2: heap_ext(product_unit)] : heap_Time_success(B,heap_Time_tap(B,Fa),H2) ).

% success_tapI
tff(fact_292_bex2I,axiom,
    ! [B: $tType,C: $tType,A3: B,Ba: C,S2: set(product_prod(B,C)),Pa: fun(B,fun(C,$o))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),S2)
     => ( ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),S2)
         => aa(C,$o,aa(B,fun(C,$o),Pa,A3),Ba) )
       => ? [A8: B,B4: C] :
            ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4),S2)
            & aa(C,$o,aa(B,fun(C,$o),Pa,A8),B4) ) ) ) ).

% bex2I
tff(fact_293_set__notEmptyE,axiom,
    ! [B: $tType,S2: set(B)] :
      ( ( S2 != bot_bot(set(B)) )
     => ~ ! [X2: B] : ~ member(B,X2,S2) ) ).

% set_notEmptyE
tff(fact_294_memb__imp__not__empty,axiom,
    ! [B: $tType,X: B,S2: set(B)] :
      ( member(B,X,S2)
     => ( S2 != bot_bot(set(B)) ) ) ).

% memb_imp_not_empty
tff(fact_295_fun__comp__eq__conv,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(D,C),Ga: fun(B,D),Fg: fun(B,C)] :
      ( ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),Ga) = Fg )
    <=> ! [X4: B] : ( aa(D,C,Fa,aa(B,D,Ga,X4)) = aa(B,C,Fg,X4) ) ) ).

% fun_comp_eq_conv
tff(fact_296_comp__cong__right,axiom,
    ! [D: $tType,C: $tType,B: $tType,X: fun(B,C),Y: fun(B,C),Fa: fun(C,D)] :
      ( ( X = Y )
     => ( aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Fa),X) = aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Fa),Y) ) ) ).

% comp_cong_right
tff(fact_297_comp__cong__left,axiom,
    ! [C: $tType,B: $tType,D: $tType,X: fun(B,C),Y: fun(B,C),Fa: fun(D,B)] :
      ( ( X = Y )
     => ( aa(fun(D,B),fun(D,C),aa(fun(B,C),fun(fun(D,B),fun(D,C)),comp(B,C,D),X),Fa) = aa(fun(D,B),fun(D,C),aa(fun(B,C),fun(fun(D,B),fun(D,C)),comp(B,C,D),Y),Fa) ) ) ).

% comp_cong_left
tff(fact_298_one__assn__def,axiom,
    one_one(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,one_assn_raw) ).

% one_assn_def
tff(fact_299_effect__assertE,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: B,H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( heap_Time_effect(B,heap_Time_assert(B,Pa,X),H2,H4,R3,N)
     => ~ ( aa(B,$o,Pa,X)
         => ( ( R3 = X )
           => ( ( H4 = H2 )
             => ( N != one_one(nat) ) ) ) ) ) ).

% effect_assertE
tff(fact_300_wand__assn__def,axiom,
    ! [Pa: assn,Qa: assn] : ( wand_assn(Pa,Qa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,wand_raw(aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa))) ) ).

% wand_assn_def
tff(fact_301_uncurry__apply,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(C,fun(D,B)),A3: C,Ba: D] : ( uncurry(C,D,B,Fa,aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),A3),Ba)) = aa(D,B,aa(C,fun(D,B),Fa,A3),Ba) ) ).

% uncurry_apply
tff(fact_302_sngr__assn__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),X: B] : ( sngr_assn(B,R3,X) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,sngr_assn_raw(B,R3,X)) ) ) ).

% sngr_assn_def
tff(fact_303_snga__assn__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: array(B),A3: list(B)] : ( snga_assn(B,R3,A3) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,snga_assn_raw(B,R3,A3)) ) ) ).

% snga_assn_def
tff(fact_304_pairself_Opelims,axiom,
    ! [B: $tType,C: $tType,X: fun(C,B),Xa: product_prod(C,C),Y: product_prod(B,B)] :
      ( ( aa(product_prod(C,C),product_prod(B,B),pairself(C,B,X),Xa) = Y )
     => ( aa(product_prod(fun(C,B),product_prod(C,C)),$o,accp(product_prod(fun(C,B),product_prod(C,C)),pairself_rel(C,B)),aa(product_prod(C,C),product_prod(fun(C,B),product_prod(C,C)),aa(fun(C,B),fun(product_prod(C,C),product_prod(fun(C,B),product_prod(C,C))),product_Pair(fun(C,B),product_prod(C,C)),X),Xa))
       => ~ ! [A8: C,B4: C] :
              ( ( Xa = aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),A8),B4) )
             => ( ( Y = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(C,B,X,A8)),aa(C,B,X,B4)) )
               => ~ aa(product_prod(fun(C,B),product_prod(C,C)),$o,accp(product_prod(fun(C,B),product_prod(C,C)),pairself_rel(C,B)),aa(product_prod(C,C),product_prod(fun(C,B),product_prod(C,C)),aa(fun(C,B),fun(product_prod(C,C),product_prod(fun(C,B),product_prod(C,C))),product_Pair(fun(C,B),product_prod(C,C)),X),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),A8),B4))) ) ) ) ) ).

% pairself.pelims
tff(fact_305_wand__assnI,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat),Qa: assn,R: assn] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
     => ( ! [H5: heap_ext(product_unit),As4: set(nat)] :
            ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As4) = bot_bot(set(nat)) )
           => ( relH(As,H2,H5)
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As))
               => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As4))
                 => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,R),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As4))) ) ) ) )
       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,wand_assn(Qa,R)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)) ) ) ).

% wand_assnI
tff(fact_306_mod__pure,axiom,
    ! [Ba: $o,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,pure_assn(Ba)),H2)
    <=> ( ( aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2) = bot_bot(set(nat)) )
        & (Ba) ) ) ).

% mod_pure
tff(fact_307_pure__assn__raw_Opelims_I1_J,axiom,
    ! [B: $tType,C: $tType,X: $o,Xa: product_prod(B,set(C)),Y: $o] :
      ( ( aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X),Xa)
      <=> (Y) )
     => ( aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X),Xa))
       => ~ ! [H: B,As2: set(C)] :
              ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H),As2) )
             => ( ( (Y)
                <=> ( ( As2 = bot_bot(set(C)) )
                    & (X) ) )
               => ~ aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X),aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H),As2))) ) ) ) ) ).

% pure_assn_raw.pelims(1)
tff(fact_308_pure__assn__raw_Opelims_I2_J,axiom,
    ! [C: $tType,B: $tType,X: $o,Xa: product_prod(B,set(C))] :
      ( aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X),Xa)
     => ( aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X),Xa))
       => ~ ! [H: B,As2: set(C)] :
              ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H),As2) )
             => ( aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X),aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H),As2)))
               => ~ ( ( As2 = bot_bot(set(C)) )
                    & (X) ) ) ) ) ) ).

% pure_assn_raw.pelims(2)
tff(fact_309_pure__assn__raw_Opelims_I3_J,axiom,
    ! [C: $tType,B: $tType,X: $o,Xa: product_prod(B,set(C))] :
      ( ~ aa(product_prod(B,set(C)),$o,pure_assn_raw(B,C,X),Xa)
     => ( aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X),Xa))
       => ~ ! [H: B,As2: set(C)] :
              ( ( Xa = aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H),As2) )
             => ( aa(product_prod($o,product_prod(B,set(C))),$o,accp(product_prod($o,product_prod(B,set(C))),pure_assn_raw_rel(B,C)),aa(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C))),aa($o,fun(product_prod(B,set(C)),product_prod($o,product_prod(B,set(C)))),product_Pair($o,product_prod(B,set(C))),X),aa(set(C),product_prod(B,set(C)),aa(B,fun(set(C),product_prod(B,set(C))),product_Pair(B,set(C)),H),As2)))
               => ( ( As2 = bot_bot(set(C)) )
                  & (X) ) ) ) ) ) ).

% pure_assn_raw.pelims(3)
tff(fact_310_monoid_Oaxioms_I2_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( monoid(B,Fa,Z2)
     => monoid_axioms(B,Fa,Z2) ) ).

% monoid.axioms(2)
tff(fact_311_relH__dist__union,axiom,
    ! [As: set(nat),As3: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( relH(aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As3),H2,H4)
    <=> ( relH(As,H2,H4)
        & relH(As3,H2,H4) ) ) ).

% relH_dist_union
tff(fact_312_in__range__empty,axiom,
    ! [H2: heap_ext(product_unit)] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ).

% in_range_empty
tff(fact_313_in__range__dist__union,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat),As3: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As3)))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3)) ) ) ).

% in_range_dist_union
tff(fact_314_relH__trans,axiom,
    ! [As: set(nat),H12: heap_ext(product_unit),H23: heap_ext(product_unit),H32: heap_ext(product_unit)] :
      ( relH(As,H12,H23)
     => ( relH(As,H23,H32)
       => relH(As,H12,H32) ) ) ).

% relH_trans
tff(fact_315_relH__sym,axiom,
    ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( relH(As,H2,H4)
     => relH(As,H4,H2) ) ).

% relH_sym
tff(fact_316_relH__refl,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
     => relH(As,H2,H2) ) ).

% relH_refl
tff(fact_317_relH__in__rangeI_I1_J,axiom,
    ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( relH(As,H2,H4)
     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)) ) ).

% relH_in_rangeI(1)
tff(fact_318_relH__in__rangeI_I2_J,axiom,
    ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( relH(As,H2,H4)
     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)) ) ).

% relH_in_rangeI(2)
tff(fact_319_monoid__axioms_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( ! [A8: B] : ( aa(B,B,aa(B,fun(B,B),Fa,Z2),A8) = A8 )
     => ( ! [A8: B] : ( aa(B,B,aa(B,fun(B,B),Fa,A8),Z2) = A8 )
       => monoid_axioms(B,Fa,Z2) ) ) ).

% monoid_axioms.intro
tff(fact_320_monoid__axioms__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( monoid_axioms(B,Fa,Z2)
    <=> ( ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),Fa,Z2),A6) = A6 )
        & ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),Fa,A6),Z2) = A6 ) ) ) ).

% monoid_axioms_def
tff(fact_321_snd__eqD,axiom,
    ! [C: $tType,B: $tType,X: C,Y: B,A3: B] :
      ( ( aa(product_prod(C,B),B,product_snd(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X),Y)) = A3 )
     => ( Y = A3 ) ) ).

% snd_eqD
tff(fact_322_snd__conv,axiom,
    ! [C: $tType,B: $tType,X1: C,X22: B] : ( aa(product_prod(C,B),B,product_snd(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X1),X22)) = X22 ) ).

% snd_conv
tff(fact_323_sndE,axiom,
    ! [B: $tType,C: $tType,X: product_prod(B,C),A3: B,Ba: C,Pa: fun(C,$o)] :
      ( ( X = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba) )
     => ( aa(C,$o,Pa,aa(product_prod(B,C),C,product_snd(B,C),X))
       => aa(C,$o,Pa,Ba) ) ) ).

% sndE
tff(fact_324_models__in__range,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,H2) ) ).

% models_in_range
tff(fact_325_wand__raw_Oelims_I3_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X,Xa),Xb)
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
              & ! [H5: heap_ext(product_unit),As4: set(nat)] :
                  ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As4) = bot_bot(set(nat)) )
                    & relH(As2,H,H5)
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))
                    & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As4)) )
                 => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As4))) ) ) ) ) ).

% wand_raw.elims(3)
tff(fact_326_wand__raw_Oelims_I2_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X,Xa),Xb)
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ~ ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
                & ! [H8: heap_ext(product_unit),As5: set(nat)] :
                    ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As5) = bot_bot(set(nat)) )
                      & relH(As2,H,H8)
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As2))
                      & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As5)) )
                   => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As5))) ) ) ) ) ).

% wand_raw.elims(2)
tff(fact_327_wand__raw_Oelims_I1_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X,Xa),Xb)
      <=> (Y) )
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( (Y)
            <=> ~ ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
                  & ! [H9: heap_ext(product_unit),As6: set(nat)] :
                      ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As6) = bot_bot(set(nat)) )
                        & relH(As2,H,H9)
                        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),As2))
                        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),As6)) )
                     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As6))) ) ) ) ) ) ).

% wand_raw.elims(1)
tff(fact_328_wand__raw_Osimps,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),H2: heap_ext(product_unit),As: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(Pa,Qa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
        & ! [H9: heap_ext(product_unit),As6: set(nat)] :
            ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As),As6) = bot_bot(set(nat)) )
              & relH(As,H2,H9)
              & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),As))
              & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),As6)) )
           => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Qa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),As6))) ) ) ) ).

% wand_raw.simps
tff(fact_329_pairself_Oelims,axiom,
    ! [B: $tType,C: $tType,X: fun(C,B),Xa: product_prod(C,C),Y: product_prod(B,B)] :
      ( ( aa(product_prod(C,C),product_prod(B,B),pairself(C,B,X),Xa) = Y )
     => ~ ! [A8: C,B4: C] :
            ( ( Xa = aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),A8),B4) )
           => ( Y != aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(C,B,X,A8)),aa(C,B,X,B4)) ) ) ) ).

% pairself.elims
tff(fact_330_pairself_Osimps,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),A3: C,Ba: C] : ( aa(product_prod(C,C),product_prod(B,B),pairself(C,B,Fa),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),A3),Ba)) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(C,B,Fa,A3)),aa(C,B,Fa,Ba)) ) ).

% pairself.simps
tff(fact_331_mod__relH,axiom,
    ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit),Pa: assn] :
      ( relH(As,H2,H4)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
      <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)) ) ) ).

% mod_relH
tff(fact_332_mod__emp,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,one_one(assn)),H2)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2) = bot_bot(set(nat)) ) ) ).

% mod_emp
tff(fact_333_wand__raw_Opelims_I1_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X,Xa),Xb)
      <=> (Y) )
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( ( (Y)
                <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
                    & ! [H9: heap_ext(product_unit),As6: set(nat)] :
                        ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As6) = bot_bot(set(nat)) )
                          & relH(As2,H,H9)
                          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),As2))
                          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),As6)) )
                       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As6))) ) ) )
               => ~ aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))) ) ) ) ) ).

% wand_raw.pelims(1)
tff(fact_334_wand__raw_Opelims_I2_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X,Xa),Xb)
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))
               => ~ ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
                    & ! [H8: heap_ext(product_unit),As5: set(nat)] :
                        ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As5) = bot_bot(set(nat)) )
                          & relH(As2,H,H8)
                          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As2))
                          & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),As5)) )
                       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As5))) ) ) ) ) ) ) ).

% wand_raw.pelims(2)
tff(fact_335_wand__raw_Opelims_I3_J,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Xb: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,wand_raw(X,Xa),Xb)
     => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),wand_raw_rel),aa(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(fun(product_prod(heap_ext(product_unit),set(nat)),$o),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))
               => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
                  & ! [H5: heap_ext(product_unit),As4: set(nat)] :
                      ( ( ( aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),inf_inf(set(nat)),As2),As4) = bot_bot(set(nat)) )
                        & relH(As2,H,H5)
                        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))
                        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,X,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As4)) )
                     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Xa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As2),As4))) ) ) ) ) ) ) ).

% wand_raw.pelims(3)
tff(fact_336_sndI,axiom,
    ! [B: $tType,C: $tType,X: product_prod(B,C),Y: B,Z2: C] :
      ( ( X = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Y),Z2) )
     => ( aa(product_prod(B,C),C,product_snd(B,C),X) = Z2 ) ) ).

% sndI
tff(fact_337_eq__snd__iff,axiom,
    ! [C: $tType,B: $tType,Ba: B,P2: product_prod(C,B)] :
      ( ( Ba = aa(product_prod(C,B),B,product_snd(C,B),P2) )
    <=> ? [A6: C] : ( P2 = aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),A6),Ba) ) ) ).

% eq_snd_iff
tff(fact_338_proper__iff,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( relH(As,H2,H4)
       => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
         => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
          <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)) ) ) ) ) ).

% proper_iff
tff(fact_339_proper__def,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
    <=> ! [H3: heap_ext(product_unit),H9: heap_ext(product_unit),As7: set(nat)] :
          ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As7))
           => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As7)) )
          & ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As7))
              & relH(As7,H3,H9)
              & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),As7)) )
           => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),As7)) ) ) ) ).

% proper_def
tff(fact_340_properD2,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),H2: heap_ext(product_unit),As: set(nat),H4: heap_ext(product_unit)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
       => ( relH(As,H2,H4)
         => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
           => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As)) ) ) ) ) ).

% properD2
tff(fact_341_properI,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( ! [As2: set(nat),H: heap_ext(product_unit)] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
         => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)) )
     => ( ! [As2: set(nat),H: heap_ext(product_unit),H5: heap_ext(product_unit)] :
            ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
           => ( relH(As2,H,H5)
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2))
               => aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),As2)) ) ) )
       => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa) ) ) ).

% properI
tff(fact_342_monoid__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( monoid(B,Fa,Z2)
    <=> ( semigroup(B,Fa)
        & monoid_axioms(B,Fa,Z2) ) ) ).

% monoid_def
tff(fact_343_monoid_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( semigroup(B,Fa)
     => ( monoid_axioms(B,Fa,Z2)
       => monoid(B,Fa,Z2) ) ) ).

% monoid.intro
tff(fact_344_bool__assn__proper_I1_J,axiom,
    aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,in_range) ).

% bool_assn_proper(1)
tff(fact_345_one__assn__proper,axiom,
    aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,one_assn_raw) ).

% one_assn_proper
tff(fact_346_times__assn__proper,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Qa)
       => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,times_assn_raw(Pa,Qa)) ) ) ).

% times_assn_proper
tff(fact_347_wand__proper,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,wand_raw(Pa,Qa)) ).

% wand_proper
tff(fact_348_snga__assn__proper,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: array(B),X: list(B)] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,snga_assn_raw(B,R3,X)) ) ).

% snga_assn_proper
tff(fact_349_sngr__assn__proper,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),X: B] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,sngr_assn_raw(B,R3,X)) ) ).

% sngr_assn_proper
tff(fact_350_pure__assn__proper,axiom,
    ! [Ba: $o] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,pure_assn_raw(heap_ext(product_unit),nat,Ba)) ).

% pure_assn_proper
tff(fact_351_semigroup_Oassoc,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A3: B,Ba: B,C2: B] :
      ( semigroup(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),Fa,A3),aa(B,B,aa(B,fun(B,B),Fa,Ba),C2)) ) ) ).

% semigroup.assoc
tff(fact_352_semigroup_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( ! [A8: B,B4: B,C4: B] : ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,A8),B4)),C4) = aa(B,B,aa(B,fun(B,B),Fa,A8),aa(B,B,aa(B,fun(B,B),Fa,B4),C4)) )
     => semigroup(B,Fa) ) ).

% semigroup.intro
tff(fact_353_semigroup__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( semigroup(B,Fa)
    <=> ! [A6: B,B5: B,C5: B] : ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,A6),B5)),C5) = aa(B,B,aa(B,fun(B,B),Fa,A6),aa(B,B,aa(B,fun(B,B),Fa,B5),C5)) ) ) ).

% semigroup_def
tff(fact_354_Rep__assn__induct,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa: fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o)] :
      ( member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
     => ( ! [X2: assn] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,Pa,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,X2))
       => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,Pa,Y) ) ) ).

% Rep_assn_induct
tff(fact_355_Rep__assn__cases,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
     => ~ ! [X2: assn] : ( Y != aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,X2) ) ) ).

% Rep_assn_cases
tff(fact_356_Rep__assn,axiom,
    ! [X: assn] : member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,X),aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper)) ).

% Rep_assn
tff(fact_357_mult_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( semigroup_mult(B)
     => semigroup(B,times_times(B)) ) ).

% mult.semigroup_axioms
tff(fact_358_inf_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => semigroup(B,inf_inf(B)) ) ).

% inf.semigroup_axioms
tff(fact_359_sup_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => semigroup(B,sup_sup(B)) ) ).

% sup.semigroup_axioms
tff(fact_360_Abs__assn__cases,axiom,
    ! [X: assn] :
      ~ ! [Y2: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
          ( ( X = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Y2) )
         => ~ member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y2,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper)) ) ).

% Abs_assn_cases
tff(fact_361_Abs__assn__induct,axiom,
    ! [Pa: fun(assn,$o),X: assn] :
      ( ! [Y2: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
          ( member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y2,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
         => aa(assn,$o,Pa,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Y2)) )
     => aa(assn,$o,Pa,X) ) ).

% Abs_assn_induct
tff(fact_362_Abs__assn__inject,axiom,
    ! [X: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),X,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
     => ( member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
       => ( ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,X) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Y) )
        <=> ( X = Y ) ) ) ) ).

% Abs_assn_inject
tff(fact_363_monoid_Oaxioms_I1_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( monoid(B,Fa,Z2)
     => semigroup(B,Fa) ) ).

% monoid.axioms(1)
tff(fact_364_properD1,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),H2: heap_ext(product_unit),As: set(nat)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Pa,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)) ) ) ).

% properD1
tff(fact_365_Abs__assn__inverse,axiom,
    ! [Y: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( member(fun(product_prod(heap_ext(product_unit),set(nat)),$o),Y,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper))
     => ( aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,Y)) = Y ) ) ).

% Abs_assn_inverse
tff(fact_366_comp__apply__eq,axiom,
    ! [C: $tType,E: $tType,B: $tType,D: $tType,Fa: fun(C,B),Ga: fun(D,C),X: D,H2: fun(E,B),K: fun(D,E)] :
      ( ( aa(C,B,Fa,aa(D,C,Ga,X)) = aa(E,B,H2,aa(D,E,K,X)) )
     => ( aa(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Fa),Ga),X) = aa(D,B,aa(fun(D,E),fun(D,B),aa(fun(E,B),fun(fun(D,E),fun(D,B)),comp(E,B,D),H2),K),X) ) ) ).

% comp_apply_eq
tff(fact_367_type__definition__assn,axiom,
    type_definition(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,abs_assn,aa(fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o),set(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),collect(fun(product_prod(heap_ext(product_unit),set(nat)),$o)),proper)) ).

% type_definition_assn
tff(fact_368_rewriteR__comp__comp2,axiom,
    ! [D: $tType,C: $tType,F7: $tType,E: $tType,B: $tType,Ga: fun(D,C),H2: fun(B,D),R1: fun(E,C),R22: fun(B,E),Fa: fun(C,F7),L: fun(E,F7)] :
      ( ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Ga),H2) = aa(fun(B,E),fun(B,C),aa(fun(E,C),fun(fun(B,E),fun(B,C)),comp(E,C,B),R1),R22) )
     => ( ( aa(fun(E,C),fun(E,F7),aa(fun(C,F7),fun(fun(E,C),fun(E,F7)),comp(C,F7,E),Fa),R1) = L )
       => ( aa(fun(B,D),fun(B,F7),aa(fun(D,F7),fun(fun(B,D),fun(B,F7)),comp(D,F7,B),aa(fun(D,C),fun(D,F7),aa(fun(C,F7),fun(fun(D,C),fun(D,F7)),comp(C,F7,D),Fa),Ga)),H2) = aa(fun(B,E),fun(B,F7),aa(fun(E,F7),fun(fun(B,E),fun(B,F7)),comp(E,F7,B),L),R22) ) ) ) ).

% rewriteR_comp_comp2
tff(fact_369_rewriteL__comp__comp2,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType,F7: $tType,Fa: fun(D,C),Ga: fun(B,D),L1: fun(E,C),L2: fun(B,E),H2: fun(F7,B),R3: fun(F7,E)] :
      ( ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),Ga) = aa(fun(B,E),fun(B,C),aa(fun(E,C),fun(fun(B,E),fun(B,C)),comp(E,C,B),L1),L2) )
     => ( ( aa(fun(F7,B),fun(F7,E),aa(fun(B,E),fun(fun(F7,B),fun(F7,E)),comp(B,E,F7),L2),H2) = R3 )
       => ( aa(fun(F7,D),fun(F7,C),aa(fun(D,C),fun(fun(F7,D),fun(F7,C)),comp(D,C,F7),Fa),aa(fun(F7,B),fun(F7,D),aa(fun(B,D),fun(fun(F7,B),fun(F7,D)),comp(B,D,F7),Ga),H2)) = aa(fun(F7,E),fun(F7,C),aa(fun(E,C),fun(fun(F7,E),fun(F7,C)),comp(E,C,F7),L1),R3) ) ) ) ).

% rewriteL_comp_comp2
tff(fact_370_rewriteR__comp__comp,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,Ga: fun(D,C),H2: fun(B,D),R3: fun(B,C),Fa: fun(C,E)] :
      ( ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Ga),H2) = R3 )
     => ( aa(fun(B,D),fun(B,E),aa(fun(D,E),fun(fun(B,D),fun(B,E)),comp(D,E,B),aa(fun(D,C),fun(D,E),aa(fun(C,E),fun(fun(D,C),fun(D,E)),comp(C,E,D),Fa),Ga)),H2) = aa(fun(B,C),fun(B,E),aa(fun(C,E),fun(fun(B,C),fun(B,E)),comp(C,E,B),Fa),R3) ) ) ).

% rewriteR_comp_comp
tff(fact_371_rewriteL__comp__comp,axiom,
    ! [D: $tType,C: $tType,B: $tType,E: $tType,Fa: fun(D,C),Ga: fun(B,D),L: fun(B,C),H2: fun(E,B)] :
      ( ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),Ga) = L )
     => ( aa(fun(E,D),fun(E,C),aa(fun(D,C),fun(fun(E,D),fun(E,C)),comp(D,C,E),Fa),aa(fun(E,B),fun(E,D),aa(fun(B,D),fun(fun(E,B),fun(E,D)),comp(B,D,E),Ga),H2)) = aa(fun(E,B),fun(E,C),aa(fun(B,C),fun(fun(E,B),fun(E,C)),comp(B,C,E),L),H2) ) ) ).

% rewriteL_comp_comp
tff(fact_372_type__copy__map__cong0,axiom,
    ! [C: $tType,E: $tType,F7: $tType,B: $tType,D: $tType,M: fun(C,B),Ga: fun(D,C),X: D,N4: fun(E,B),H2: fun(D,E),Fa: fun(B,F7)] :
      ( ( aa(C,B,M,aa(D,C,Ga,X)) = aa(E,B,N4,aa(D,E,H2,X)) )
     => ( aa(D,F7,aa(fun(D,C),fun(D,F7),aa(fun(C,F7),fun(fun(D,C),fun(D,F7)),comp(C,F7,D),aa(fun(C,B),fun(C,F7),aa(fun(B,F7),fun(fun(C,B),fun(C,F7)),comp(B,F7,C),Fa),M)),Ga),X) = aa(D,F7,aa(fun(D,E),fun(D,F7),aa(fun(E,F7),fun(fun(D,E),fun(D,F7)),comp(E,F7,D),aa(fun(E,B),fun(E,F7),aa(fun(B,F7),fun(fun(E,B),fun(E,F7)),comp(B,F7,E),Fa),N4)),H2),X) ) ) ).

% type_copy_map_cong0
tff(fact_373_comp__cong,axiom,
    ! [D: $tType,C: $tType,E: $tType,B: $tType,F7: $tType,Fa: fun(C,B),Ga: fun(D,C),X: D,F9: fun(E,B),G3: fun(F7,E),X5: F7] :
      ( ( aa(C,B,Fa,aa(D,C,Ga,X)) = aa(E,B,F9,aa(F7,E,G3,X5)) )
     => ( aa(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Fa),Ga),X) = aa(F7,B,aa(fun(F7,E),fun(F7,B),aa(fun(E,B),fun(fun(F7,E),fun(F7,B)),comp(E,B,F7),F9),G3),X5) ) ) ).

% comp_cong
tff(fact_374_fun_Omap__comp,axiom,
    ! [D: $tType,C: $tType,E: $tType,B: $tType,Ga: fun(D,C),Fa: fun(E,D),V: fun(B,E)] : ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Ga),aa(fun(B,E),fun(B,D),aa(fun(E,D),fun(fun(B,E),fun(B,D)),comp(E,D,B),Fa),V)) = aa(fun(B,E),fun(B,C),aa(fun(E,C),fun(fun(B,E),fun(B,C)),comp(E,C,B),aa(fun(E,D),fun(E,C),aa(fun(D,C),fun(fun(E,D),fun(E,C)),comp(D,C,E),Ga),Fa)),V) ) ).

% fun.map_comp
tff(fact_375_mod__h__bot__iff_I2_J,axiom,
    ! [H2: heap_ext(product_unit)] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,top_top(assn)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ).

% mod_h_bot_iff(2)
tff(fact_376_override__on__emptyset,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),Ga: fun(B,C)] : ( override_on(B,C,Fa,Ga,bot_bot(set(B))) = Fa ) ).

% override_on_emptyset
tff(fact_377_mult_Osafe__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => ! [X: B,Y: B,A3: B,Ba: B] :
          ( syntax7388354845996824322omatch(B,B,aa(B,B,aa(B,fun(B,B),times_times(B),X),Y),A3)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3) ) ) ) ).

% mult.safe_commute
tff(fact_378_top__apply,axiom,
    ! [C: $tType,B: $tType] :
      ( top(B)
     => ! [X: C] : ( aa(C,B,top_top(fun(C,B)),X) = top_top(B) ) ) ).

% top_apply
tff(fact_379_inf__top_Oright__neutral,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),top_top(B)) = A3 ) ) ).

% inf_top.right_neutral
tff(fact_380_inf__top_Oneutr__eq__iff,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [A3: B,Ba: B] :
          ( ( top_top(B) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) )
        <=> ( ( A3 = top_top(B) )
            & ( Ba = top_top(B) ) ) ) ) ).

% inf_top.neutr_eq_iff
tff(fact_381_inf__top_Oleft__neutral,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),top_top(B)),A3) = A3 ) ) ).

% inf_top.left_neutral
tff(fact_382_inf__top_Oeq__neutr__iff,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) = top_top(B) )
        <=> ( ( A3 = top_top(B) )
            & ( Ba = top_top(B) ) ) ) ) ).

% inf_top.eq_neutr_iff
tff(fact_383_top__eq__inf__iff,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [X: B,Y: B] :
          ( ( top_top(B) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) )
        <=> ( ( X = top_top(B) )
            & ( Y = top_top(B) ) ) ) ) ).

% top_eq_inf_iff
tff(fact_384_inf__eq__top__iff,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) = top_top(B) )
        <=> ( ( X = top_top(B) )
            & ( Y = top_top(B) ) ) ) ) ).

% inf_eq_top_iff
tff(fact_385_inf__top__right,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),top_top(B)) = X ) ) ).

% inf_top_right
tff(fact_386_inf__top__left,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),top_top(B)),X) = X ) ) ).

% inf_top_left
tff(fact_387_sup__top__left,axiom,
    ! [B: $tType] :
      ( bounded_lattice_top(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),top_top(B)),X) = top_top(B) ) ) ).

% sup_top_left
tff(fact_388_sup__top__right,axiom,
    ! [B: $tType] :
      ( bounded_lattice_top(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),top_top(B)) = top_top(B) ) ) ).

% sup_top_right
tff(fact_389_boolean__algebra_Odisj__one__left,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),top_top(B)),X) = top_top(B) ) ) ).

% boolean_algebra.disj_one_left
tff(fact_390_boolean__algebra_Odisj__one__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),top_top(B)) = top_top(B) ) ) ).

% boolean_algebra.disj_one_right
tff(fact_391_merge__true__star,axiom,
    aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),top_top(assn)),top_top(assn)) = top_top(assn) ).

% merge_true_star
tff(fact_392_assn__basic__inequalities_I1_J,axiom,
    top_top(assn) != one_one(assn) ).

% assn_basic_inequalities(1)
tff(fact_393_assn__basic__inequalities_I5_J,axiom,
    top_top(assn) != bot_bot(assn) ).

% assn_basic_inequalities(5)
tff(fact_394_mod__true,axiom,
    ! [H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,top_top(assn)),H2)
    <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,H2) ) ).

% mod_true
tff(fact_395_syntax__fo__nomatch__def,axiom,
    ! [B: $tType,C: $tType,Pat: B,Obj: C] : syntax7388354845996824322omatch(B,C,Pat,Obj) ).

% syntax_fo_nomatch_def
tff(fact_396_boolean__algebra_Oconj__one__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),top_top(B)) = X ) ) ).

% boolean_algebra.conj_one_right
tff(fact_397_ent__true,axiom,
    ! [Pa: assn] : entails(Pa,top_top(assn)) ).

% ent_true
tff(fact_398_mod__star__trueE,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),top_top(assn))),H2)
     => ~ ! [H5: product_prod(heap_ext(product_unit),set(nat))] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H5) ) ).

% mod_star_trueE
tff(fact_399_mod__star__trueI,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2)
     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),top_top(assn))),H2) ) ).

% mod_star_trueI
tff(fact_400_inf__top_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => monoid(B,inf_inf(B),top_top(B)) ) ).

% inf_top.monoid_axioms
tff(fact_401_inf__top_Osemilattice__neutr__axioms,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => semilattice_neutr(B,inf_inf(B),top_top(B)) ) ).

% inf_top.semilattice_neutr_axioms
tff(fact_402_top__assn__def,axiom,
    top_top(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,in_range) ).

% top_assn_def
tff(fact_403_boolean__algebra_Ocomplement__unique,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [A3: B,X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),X) = bot_bot(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),X) = top_top(B) )
           => ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Y) = bot_bot(B) )
             => ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Y) = top_top(B) )
               => ( X = Y ) ) ) ) ) ) ).

% boolean_algebra.complement_unique
tff(fact_404_enttD,axiom,
    ! [A4: assn,B2: assn] :
      ( entailst(A4,B2)
     => entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn))) ) ).

% enttD
tff(fact_405_enttI,axiom,
    ! [A4: assn,B2: assn] :
      ( entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn)))
     => entailst(A4,B2) ) ).

% enttI
tff(fact_406_enttI__true,axiom,
    ! [Pa: assn,Qa: assn] :
      ( entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),top_top(assn)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),top_top(assn)))
     => entailst(Pa,Qa) ) ).

% enttI_true
tff(fact_407_entailst__def,axiom,
    ! [A4: assn,B2: assn] :
      ( entailst(A4,B2)
    <=> entails(A4,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn))) ) ).

% entailst_def
tff(fact_408_entt__def__true,axiom,
    ! [Pa: assn,Qa: assn] :
      ( entailst(Pa,Qa)
    <=> entails(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),top_top(assn)),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),top_top(assn))) ) ).

% entt_def_true
tff(fact_409_boolean__algebra__class_Oboolean__algebra_Ocompl__unique,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) = bot_bot(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) = top_top(B) )
           => ( aa(B,B,uminus_uminus(B),X) = Y ) ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_unique
tff(fact_410_entt__star__true__simp_I1_J,axiom,
    ! [A4: assn,B2: assn] :
      ( entailst(A4,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),top_top(assn)))
    <=> entailst(A4,B2) ) ).

% entt_star_true_simp(1)
tff(fact_411_entt__star__true__simp_I2_J,axiom,
    ! [A4: assn,B2: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),top_top(assn)),B2)
    <=> entailst(A4,B2) ) ).

% entt_star_true_simp(2)
tff(fact_412_snd__sndOp,axiom,
    ! [D: $tType,B: $tType,C: $tType,Bc: product_prod(C,B),Pa: fun(C,fun(D,$o)),Qa: fun(D,fun(B,$o))] : ( aa(product_prod(C,B),B,product_snd(C,B),Bc) = aa(product_prod(C,B),B,aa(fun(product_prod(C,B),product_prod(D,B)),fun(product_prod(C,B),B),aa(fun(product_prod(D,B),B),fun(fun(product_prod(C,B),product_prod(D,B)),fun(product_prod(C,B),B)),comp(product_prod(D,B),B,product_prod(C,B)),product_snd(D,B)),bNF_sndOp(C,D,B,Pa,Qa)),Bc) ) ).

% snd_sndOp
tff(fact_413_bijective__def,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C))] :
      ( bijective(B,C,R)
    <=> ( ! [X4: B,Y3: C,Z4: C] :
            ( ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Y3),R)
              & member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Z4),R) )
           => ( Y3 = Z4 ) )
        & ! [X4: B,Y3: B,Z4: C] :
            ( ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Z4),R)
              & member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Y3),Z4),R) )
           => ( X4 = Y3 ) ) ) ) ).

% bijective_def
tff(fact_414_ssubst__Pair__rhs,axiom,
    ! [C: $tType,B: $tType,R3: B,S: C,R: set(product_prod(B,C)),S3: C] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),R3),S),R)
     => ( ( S3 = S )
       => member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),R3),S3),R) ) ) ).

% ssubst_Pair_rhs
tff(fact_415_add_Oinverse__inverse,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,uminus_uminus(B),A3)) = A3 ) ) ).

% add.inverse_inverse
tff(fact_416_neg__equal__iff__equal,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,uminus_uminus(B),A3) = aa(B,B,uminus_uminus(B),Ba) )
        <=> ( A3 = Ba ) ) ) ).

% neg_equal_iff_equal
tff(fact_417_uminus__apply,axiom,
    ! [B: $tType,C: $tType] :
      ( uminus(B)
     => ! [A4: fun(C,B),X: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),uminus_uminus(fun(C,B)),A4),X) = aa(B,B,uminus_uminus(B),aa(C,B,A4,X)) ) ) ).

% uminus_apply
tff(fact_418_boolean__algebra__class_Oboolean__algebra_Odouble__compl,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,uminus_uminus(B),X)) = X ) ) ).

% boolean_algebra_class.boolean_algebra.double_compl
tff(fact_419_boolean__algebra__class_Oboolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] :
          ( ( aa(B,B,uminus_uminus(B),X) = aa(B,B,uminus_uminus(B),Y) )
        <=> ( X = Y ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_eq_compl_iff
tff(fact_420_Int__UNIV,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = top_top(set(B)) )
    <=> ( ( A4 = top_top(set(B)) )
        & ( B2 = top_top(set(B)) ) ) ) ).

% Int_UNIV
tff(fact_421_entt__refl,axiom,
    ! [A4: assn] : entailst(A4,A4) ).

% entt_refl
tff(fact_422_bijective__Empty,axiom,
    ! [C: $tType,B: $tType] : bijective(B,C,bot_bot(set(product_prod(B,C)))) ).

% bijective_Empty
tff(fact_423_Compl__disjoint2,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),A4)),A4) = bot_bot(set(B)) ) ).

% Compl_disjoint2
tff(fact_424_Compl__disjoint,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),A4)) = bot_bot(set(B)) ) ).

% Compl_disjoint
tff(fact_425_mod__not__dist,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,uminus_uminus(assn),Pa)),H2)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,H2)
        & ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H2) ) ) ).

% mod_not_dist
tff(fact_426_entt__true,axiom,
    ! [A4: assn] : entailst(A4,top_top(assn)) ).

% entt_true
tff(fact_427_entt__emp,axiom,
    ! [A4: assn] : entailst(A4,one_one(assn)) ).

% entt_emp
tff(fact_428_boolean__algebra_Ocompl__zero,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ( aa(B,B,uminus_uminus(B),bot_bot(B)) = top_top(B) ) ) ).

% boolean_algebra.compl_zero
tff(fact_429_boolean__algebra_Ocompl__one,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ( aa(B,B,uminus_uminus(B),top_top(B)) = bot_bot(B) ) ) ).

% boolean_algebra.compl_one
tff(fact_430_boolean__algebra_Oconj__cancel__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,uminus_uminus(B),X)) = bot_bot(B) ) ) ).

% boolean_algebra.conj_cancel_right
tff(fact_431_boolean__algebra_Oconj__cancel__left,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X)),X) = bot_bot(B) ) ) ).

% boolean_algebra.conj_cancel_left
tff(fact_432_inf__compl__bot__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),aa(B,B,uminus_uminus(B),X))) = bot_bot(B) ) ) ).

% inf_compl_bot_right
tff(fact_433_inf__compl__bot__left2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X)),Y)) = bot_bot(B) ) ) ).

% inf_compl_bot_left2
tff(fact_434_inf__compl__bot__left1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)) = bot_bot(B) ) ) ).

% inf_compl_bot_left1
tff(fact_435_boolean__algebra_Odisj__cancel__right,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,uminus_uminus(B),X)) = top_top(B) ) ) ).

% boolean_algebra.disj_cancel_right
tff(fact_436_boolean__algebra_Odisj__cancel__left,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X)),X) = top_top(B) ) ) ).

% boolean_algebra.disj_cancel_left
tff(fact_437_sup__compl__top__left2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X)),Y)) = top_top(B) ) ) ).

% sup_compl_top_left2
tff(fact_438_sup__compl__top__left1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)) = top_top(B) ) ) ).

% sup_compl_top_left1
tff(fact_439_boolean__algebra_Ode__Morgan__disj,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X)),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% boolean_algebra.de_Morgan_disj
tff(fact_440_boolean__algebra_Ode__Morgan__conj,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X)),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% boolean_algebra.de_Morgan_conj
tff(fact_441_equation__minus__iff,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = aa(B,B,uminus_uminus(B),Ba) )
        <=> ( Ba = aa(B,B,uminus_uminus(B),A3) ) ) ) ).

% equation_minus_iff
tff(fact_442_minus__equation__iff,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,uminus_uminus(B),A3) = Ba )
        <=> ( aa(B,B,uminus_uminus(B),Ba) = A3 ) ) ) ).

% minus_equation_iff
tff(fact_443_fun__Compl__def,axiom,
    ! [C: $tType,B: $tType] :
      ( uminus(C)
     => ! [A4: fun(B,C),X3: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),uminus_uminus(fun(B,C)),A4),X3) = aa(C,C,uminus_uminus(C),aa(B,C,A4,X3)) ) ) ).

% fun_Compl_def
tff(fact_444_entt__trans,axiom,
    ! [A4: assn,B2: assn,C3: assn] :
      ( entailst(A4,B2)
     => ( entailst(B2,C3)
       => entailst(A4,C3) ) ) ).

% entt_trans
tff(fact_445_Compl__empty__eq,axiom,
    ! [B: $tType] : ( aa(set(B),set(B),uminus_uminus(set(B)),bot_bot(set(B))) = top_top(set(B)) ) ).

% Compl_empty_eq
tff(fact_446_Compl__UNIV__eq,axiom,
    ! [B: $tType] : ( aa(set(B),set(B),uminus_uminus(set(B)),top_top(set(B))) = bot_bot(set(B)) ) ).

% Compl_UNIV_eq
tff(fact_447_empty__not__UNIV,axiom,
    ! [B: $tType] : ( bot_bot(set(B)) != top_top(set(B)) ) ).

% empty_not_UNIV
tff(fact_448_Int__UNIV__right,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),top_top(set(B))) = A4 ) ).

% Int_UNIV_right
tff(fact_449_Int__UNIV__left,axiom,
    ! [B: $tType,B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),top_top(set(B))),B2) = B2 ) ).

% Int_UNIV_left
tff(fact_450_type__copy__wit,axiom,
    ! [B: $tType,D: $tType,C: $tType,Rep: fun(B,C),Abs: fun(C,B),X: D,S2: fun(C,set(D)),Y: C] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( member(D,X,aa(B,set(D),aa(fun(B,C),fun(B,set(D)),aa(fun(C,set(D)),fun(fun(B,C),fun(B,set(D))),comp(C,set(D),B),S2),Rep),aa(C,B,Abs,Y)))
       => member(D,X,aa(C,set(D),S2,Y)) ) ) ).

% type_copy_wit
tff(fact_451_entt__star__mono,axiom,
    ! [A4: assn,B2: assn,C3: assn,D4: assn] :
      ( entailst(A4,B2)
     => ( entailst(C3,D4)
       => entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),A4),C3),aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),B2),D4)) ) ) ).

% entt_star_mono
tff(fact_452_entt__frame__fwd,axiom,
    ! [Pa: assn,Qa: assn,A4: assn,F: assn,B2: assn] :
      ( entailst(Pa,Qa)
     => ( entailst(A4,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),F))
       => ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Qa),F),B2)
         => entailst(A4,B2) ) ) ) ).

% entt_frame_fwd
tff(fact_453_ent__imp__entt,axiom,
    ! [Pa: assn,Qa: assn] :
      ( entails(Pa,Qa)
     => entailst(Pa,Qa) ) ).

% ent_imp_entt
tff(fact_454_entt__disjI2__direct,axiom,
    ! [B2: assn,A4: assn] : entailst(B2,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B2)) ).

% entt_disjI2_direct
tff(fact_455_entt__disjI1__direct,axiom,
    ! [A4: assn,B2: assn] : entailst(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B2)) ).

% entt_disjI1_direct
tff(fact_456_entt__disjI2_H,axiom,
    ! [A4: assn,C3: assn,B2: assn] :
      ( entailst(A4,C3)
     => entailst(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C3)) ) ).

% entt_disjI2'
tff(fact_457_entt__disjI1_H,axiom,
    ! [A4: assn,B2: assn,C3: assn] :
      ( entailst(A4,B2)
     => entailst(A4,aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),B2),C3)) ) ).

% entt_disjI1'
tff(fact_458_entt__disjD2,axiom,
    ! [A4: assn,B2: assn,C3: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B2),C3)
     => entailst(B2,C3) ) ).

% entt_disjD2
tff(fact_459_entt__disjD1,axiom,
    ! [A4: assn,B2: assn,C3: assn] :
      ( entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B2),C3)
     => entailst(A4,C3) ) ).

% entt_disjD1
tff(fact_460_entt__disjE,axiom,
    ! [A4: assn,M: assn,B2: assn] :
      ( entailst(A4,M)
     => ( entailst(B2,M)
       => entailst(aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),A4),B2),M) ) ) ).

% entt_disjE
tff(fact_461_inf__cancel__left2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X)),A3)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Ba)) = bot_bot(B) ) ) ).

% inf_cancel_left2
tff(fact_462_inf__cancel__left1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),A3)),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,uminus_uminus(B),X)),Ba)) = bot_bot(B) ) ) ).

% inf_cancel_left1
tff(fact_463_sup__cancel__left2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X)),A3)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Ba)) = top_top(B) ) ) ).

% sup_cancel_left2
tff(fact_464_sup__cancel__left1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),A3)),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),X)),Ba)) = top_top(B) ) ) ).

% sup_cancel_left1
tff(fact_465_Compl__Un,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),A4)),aa(set(B),set(B),uminus_uminus(set(B)),B2)) ) ).

% Compl_Un
tff(fact_466_Compl__Int,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),A4)),aa(set(B),set(B),uminus_uminus(set(B)),B2)) ) ).

% Compl_Int
tff(fact_467_type__copy__map__comp0__undo,axiom,
    ! [F7: $tType,B: $tType,D: $tType,C: $tType,E: $tType,G: $tType,Rep: fun(B,C),Abs: fun(C,B),Rep2: fun(D,E),Abs2: fun(E,D),Rep3: fun(F7,G),Abs3: fun(G,F7),M: fun(G,E),M1: fun(C,E),M2: fun(G,C)] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( type_definition(D,E,Rep2,Abs2,top_top(set(E)))
       => ( type_definition(F7,G,Rep3,Abs3,top_top(set(G)))
         => ( ( aa(fun(F7,G),fun(F7,D),aa(fun(G,D),fun(fun(F7,G),fun(F7,D)),comp(G,D,F7),aa(fun(G,E),fun(G,D),aa(fun(E,D),fun(fun(G,E),fun(G,D)),comp(E,D,G),Abs2),M)),Rep3) = aa(fun(F7,B),fun(F7,D),aa(fun(B,D),fun(fun(F7,B),fun(F7,D)),comp(B,D,F7),aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),aa(fun(C,E),fun(C,D),aa(fun(E,D),fun(fun(C,E),fun(C,D)),comp(E,D,C),Abs2),M1)),Rep)),aa(fun(F7,G),fun(F7,B),aa(fun(G,B),fun(fun(F7,G),fun(F7,B)),comp(G,B,F7),aa(fun(G,C),fun(G,B),aa(fun(C,B),fun(fun(G,C),fun(G,B)),comp(C,B,G),Abs),M2)),Rep3)) )
           => ( aa(fun(G,C),fun(G,E),aa(fun(C,E),fun(fun(G,C),fun(G,E)),comp(C,E,G),M1),M2) = M ) ) ) ) ) ).

% type_copy_map_comp0_undo
tff(fact_468_type__copy__map__comp0,axiom,
    ! [G: $tType,E: $tType,C: $tType,B: $tType,D: $tType,F7: $tType,Rep: fun(B,C),Abs: fun(C,B),M: fun(D,E),M1: fun(C,E),M2: fun(D,C),Fa: fun(E,G),Ga: fun(F7,D)] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( ( M = aa(fun(D,C),fun(D,E),aa(fun(C,E),fun(fun(D,C),fun(D,E)),comp(C,E,D),M1),M2) )
       => ( aa(fun(F7,D),fun(F7,G),aa(fun(D,G),fun(fun(F7,D),fun(F7,G)),comp(D,G,F7),aa(fun(D,E),fun(D,G),aa(fun(E,G),fun(fun(D,E),fun(D,G)),comp(E,G,D),Fa),M)),Ga) = aa(fun(F7,B),fun(F7,G),aa(fun(B,G),fun(fun(F7,B),fun(F7,G)),comp(B,G,F7),aa(fun(B,C),fun(B,G),aa(fun(C,G),fun(fun(B,C),fun(B,G)),comp(C,G,B),aa(fun(C,E),fun(C,G),aa(fun(E,G),fun(fun(C,E),fun(C,G)),comp(E,G,C),Fa),M1)),Rep)),aa(fun(F7,D),fun(F7,B),aa(fun(D,B),fun(fun(F7,D),fun(F7,B)),comp(D,B,F7),aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Abs),M2)),Ga)) ) ) ) ).

% type_copy_map_comp0
tff(fact_469_mult__minus1__right,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Z2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),Z2),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),Z2) ) ) ).

% mult_minus1_right
tff(fact_470_mult__minus1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Z2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),one_one(B))),Z2) = aa(B,B,uminus_uminus(B),Z2) ) ) ).

% mult_minus1
tff(fact_471_mult__minus__right,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,uminus_uminus(B),Ba)) = aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ).

% mult_minus_right
tff(fact_472_minus__mult__minus,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),A3)),aa(B,B,uminus_uminus(B),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba) ) ) ).

% minus_mult_minus
tff(fact_473_mult__minus__left,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),A3)),Ba) = aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ).

% mult_minus_left
tff(fact_474_square__eq__1__iff,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [X: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),X),X) = one_one(B) )
        <=> ( ( X = one_one(B) )
            | ( X = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ) ) ).

% square_eq_1_iff
tff(fact_475_one__neq__neg__one,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ( one_one(B) != aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% one_neq_neg_one
tff(fact_476_minus__mult__commute,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),A3)),Ba) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,uminus_uminus(B),Ba)) ) ) ).

% minus_mult_commute
tff(fact_477_square__eq__iff,axiom,
    ! [B: $tType] :
      ( idom(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),Ba),Ba) )
        <=> ( ( A3 = Ba )
            | ( A3 = aa(B,B,uminus_uminus(B),Ba) ) ) ) ) ).

% square_eq_iff
tff(fact_478_snd__comp__apsnd,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(C,D)] : ( aa(fun(product_prod(B,C),product_prod(B,D)),fun(product_prod(B,C),D),aa(fun(product_prod(B,D),D),fun(fun(product_prod(B,C),product_prod(B,D)),fun(product_prod(B,C),D)),comp(product_prod(B,D),D,product_prod(B,C)),product_snd(B,D)),aa(fun(C,D),fun(product_prod(B,C),product_prod(B,D)),product_apsnd(C,D,B),Fa)) = aa(fun(product_prod(B,C),C),fun(product_prod(B,C),D),aa(fun(C,D),fun(fun(product_prod(B,C),C),fun(product_prod(B,C),D)),comp(C,D,product_prod(B,C)),Fa),product_snd(B,C)) ) ).

% snd_comp_apsnd
tff(fact_479_boolean__algebra_Oabstract__boolean__algebra__axioms,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => boolea2506097494486148201lgebra(B,inf_inf(B),sup_sup(B),uminus_uminus(B),bot_bot(B),top_top(B)) ) ).

% boolean_algebra.abstract_boolean_algebra_axioms
tff(fact_480_apsnd__conv,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(D,C),X: B,Y: D] : ( aa(product_prod(B,D),product_prod(B,C),aa(fun(D,C),fun(product_prod(B,D),product_prod(B,C)),product_apsnd(D,C,B),Fa),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),X),Y)) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),aa(D,C,Fa,Y)) ) ).

% apsnd_conv
tff(fact_481_abstract__boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Y: B,Z2: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,Y),Z2)),X) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,Y),X)),aa(B,B,aa(B,fun(B,B),Disj,Z2),X)) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib2
tff(fact_482_abstract__boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Y: B,Z2: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,Y),Z2)),X) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,Y),X)),aa(B,B,aa(B,fun(B,B),Conj,Z2),X)) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib2
tff(fact_483_abstract__boolean__algebra_Ocompl__eq__compl__iff,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B,Y: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( ( aa(B,B,Compl,X) = aa(B,B,Compl,Y) )
      <=> ( X = Y ) ) ) ).

% abstract_boolean_algebra.compl_eq_compl_iff
tff(fact_484_abstract__boolean__algebra_Odisj__conj__distrib,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B,Y: B,Z2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,X),aa(B,B,aa(B,fun(B,B),Conj,Y),Z2)) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,X),Y)),aa(B,B,aa(B,fun(B,B),Disj,X),Z2)) ) ) ).

% abstract_boolean_algebra.disj_conj_distrib
tff(fact_485_abstract__boolean__algebra_Odisj__cancel__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,X),aa(B,B,Compl,X)) = One ) ) ).

% abstract_boolean_algebra.disj_cancel_right
tff(fact_486_abstract__boolean__algebra_Oconj__disj__distrib,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B,Y: B,Z2: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,X),aa(B,B,aa(B,fun(B,B),Disj,Y),Z2)) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X),Y)),aa(B,B,aa(B,fun(B,B),Conj,X),Z2)) ) ) ).

% abstract_boolean_algebra.conj_disj_distrib
tff(fact_487_abstract__boolean__algebra_Oconj__cancel__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,X),aa(B,B,Compl,X)) = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_right
tff(fact_488_abstract__boolean__algebra_Ocomplement__unique,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,A3: B,X: B,Y: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( ( aa(B,B,aa(B,fun(B,B),Conj,A3),X) = Zero )
       => ( ( aa(B,B,aa(B,fun(B,B),Disj,A3),X) = One )
         => ( ( aa(B,B,aa(B,fun(B,B),Conj,A3),Y) = Zero )
           => ( ( aa(B,B,aa(B,fun(B,B),Disj,A3),Y) = One )
             => ( X = Y ) ) ) ) ) ) ).

% abstract_boolean_algebra.complement_unique
tff(fact_489_abstract__boolean__algebra_Odisj__cancel__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,Compl,X)),X) = One ) ) ).

% abstract_boolean_algebra.disj_cancel_left
tff(fact_490_abstract__boolean__algebra_Oconj__cancel__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,Compl,X)),X) = Zero ) ) ).

% abstract_boolean_algebra.conj_cancel_left
tff(fact_491_abstract__boolean__algebra_Odisj__zero__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,X),Zero) = X ) ) ).

% abstract_boolean_algebra.disj_zero_right
tff(fact_492_abstract__boolean__algebra_Oconj__zero__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,X),Zero) = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_right
tff(fact_493_abstract__boolean__algebra_Odisj__one__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,X),One) = One ) ) ).

% abstract_boolean_algebra.disj_one_right
tff(fact_494_abstract__boolean__algebra_Ode__Morgan__disj,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B,Y: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,Compl,aa(B,B,aa(B,fun(B,B),Disj,X),Y)) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,Compl,X)),aa(B,B,Compl,Y)) ) ) ).

% abstract_boolean_algebra.de_Morgan_disj
tff(fact_495_abstract__boolean__algebra_Ode__Morgan__conj,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B,Y: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,Compl,aa(B,B,aa(B,fun(B,B),Conj,X),Y)) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,Compl,X)),aa(B,B,Compl,Y)) ) ) ).

% abstract_boolean_algebra.de_Morgan_conj
tff(fact_496_abstract__boolean__algebra_Oconj__zero__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,Zero),X) = Zero ) ) ).

% abstract_boolean_algebra.conj_zero_left
tff(fact_497_abstract__boolean__algebra_Oconj__one__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Conj,X),One) = X ) ) ).

% abstract_boolean_algebra.conj_one_right
tff(fact_498_abstract__boolean__algebra_Odisj__one__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,aa(B,fun(B,B),Disj,One),X) = One ) ) ).

% abstract_boolean_algebra.disj_one_left
tff(fact_499_abstract__boolean__algebra_Odouble__compl,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,Compl,aa(B,B,Compl,X)) = X ) ) ).

% abstract_boolean_algebra.double_compl
tff(fact_500_abstract__boolean__algebra_Ocompl__unique,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,X: B,Y: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( ( aa(B,B,aa(B,fun(B,B),Conj,X),Y) = Zero )
       => ( ( aa(B,B,aa(B,fun(B,B),Disj,X),Y) = One )
         => ( aa(B,B,Compl,X) = Y ) ) ) ) ).

% abstract_boolean_algebra.compl_unique
tff(fact_501_abstract__boolean__algebra_Ocompl__zero,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,Compl,Zero) = One ) ) ).

% abstract_boolean_algebra.compl_zero
tff(fact_502_abstract__boolean__algebra_Ocompl__one,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( aa(B,B,Compl,One) = Zero ) ) ).

% abstract_boolean_algebra.compl_one
tff(fact_503_apsnd__compose,axiom,
    ! [D: $tType,C: $tType,E: $tType,B: $tType,Fa: fun(D,C),Ga: fun(E,D),X: product_prod(B,E)] : ( aa(product_prod(B,D),product_prod(B,C),aa(fun(D,C),fun(product_prod(B,D),product_prod(B,C)),product_apsnd(D,C,B),Fa),aa(product_prod(B,E),product_prod(B,D),aa(fun(E,D),fun(product_prod(B,E),product_prod(B,D)),product_apsnd(E,D,B),Ga),X)) = aa(product_prod(B,E),product_prod(B,C),aa(fun(E,C),fun(product_prod(B,E),product_prod(B,C)),product_apsnd(E,C,B),aa(fun(E,D),fun(E,C),aa(fun(D,C),fun(fun(E,D),fun(E,C)),comp(D,C,E),Fa),Ga)),X) ) ).

% apsnd_compose
tff(fact_504_dbl__inc__simps_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_inc(B,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% dbl_inc_simps(4)
tff(fact_505_snd__comp__map__prod,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,Fa: fun(B,E),Ga: fun(C,D)] : ( aa(fun(product_prod(B,C),product_prod(E,D)),fun(product_prod(B,C),D),aa(fun(product_prod(E,D),D),fun(fun(product_prod(B,C),product_prod(E,D)),fun(product_prod(B,C),D)),comp(product_prod(E,D),D,product_prod(B,C)),product_snd(E,D)),product_map_prod(B,E,C,D,Fa,Ga)) = aa(fun(product_prod(B,C),C),fun(product_prod(B,C),D),aa(fun(C,D),fun(fun(product_prod(B,C),C),fun(product_prod(B,C),D)),comp(C,D,product_prod(B,C)),Ga),product_snd(B,C)) ) ).

% snd_comp_map_prod
tff(fact_506_type__copy__set__map0,axiom,
    ! [B: $tType,C: $tType,E: $tType,F7: $tType,D: $tType,G: $tType,Rep: fun(B,C),Abs: fun(C,B),S2: fun(C,set(E)),M: fun(D,C),Fa: fun(F7,E),S4: fun(D,set(F7)),Ga: fun(G,D)] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( ( aa(fun(D,C),fun(D,set(E)),aa(fun(C,set(E)),fun(fun(D,C),fun(D,set(E))),comp(C,set(E),D),S2),M) = aa(fun(D,set(F7)),fun(D,set(E)),aa(fun(set(F7),set(E)),fun(fun(D,set(F7)),fun(D,set(E))),comp(set(F7),set(E),D),image2(F7,E,Fa)),S4) )
       => ( aa(fun(G,B),fun(G,set(E)),aa(fun(B,set(E)),fun(fun(G,B),fun(G,set(E))),comp(B,set(E),G),aa(fun(B,C),fun(B,set(E)),aa(fun(C,set(E)),fun(fun(B,C),fun(B,set(E))),comp(C,set(E),B),S2),Rep)),aa(fun(G,D),fun(G,B),aa(fun(D,B),fun(fun(G,D),fun(G,B)),comp(D,B,G),aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Abs),M)),Ga)) = aa(fun(G,set(F7)),fun(G,set(E)),aa(fun(set(F7),set(E)),fun(fun(G,set(F7)),fun(G,set(E))),comp(set(F7),set(E),G),image2(F7,E,Fa)),aa(fun(G,D),fun(G,set(F7)),aa(fun(D,set(F7)),fun(fun(G,D),fun(G,set(F7))),comp(D,set(F7),G),S4),Ga)) ) ) ) ).

% type_copy_set_map0
tff(fact_507_snd__comp__apfst,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,D)] : ( aa(fun(product_prod(B,C),product_prod(D,C)),fun(product_prod(B,C),C),aa(fun(product_prod(D,C),C),fun(fun(product_prod(B,C),product_prod(D,C)),fun(product_prod(B,C),C)),comp(product_prod(D,C),C,product_prod(B,C)),product_snd(D,C)),product_apfst(B,D,C,Fa)) = product_snd(B,C) ) ).

% snd_comp_apfst
tff(fact_508_Id__on__empty,axiom,
    ! [B: $tType] : ( id_on(B,bot_bot(set(B))) = bot_bot(set(product_prod(B,B))) ) ).

% Id_on_empty
tff(fact_509_dbl__dec__simps_I3_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_dec(B,one_one(B)) = one_one(B) ) ) ).

% dbl_dec_simps(3)
tff(fact_510_disjoint__eq__subset__Compl,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) )
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),B2)) ) ).

% disjoint_eq_subset_Compl
tff(fact_511_snd__convol,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,D),Ga: fun(B,C)] : ( aa(fun(B,product_prod(D,C)),fun(B,C),aa(fun(product_prod(D,C),C),fun(fun(B,product_prod(D,C)),fun(B,C)),comp(product_prod(D,C),C,B),product_snd(D,C)),bNF_convol(B,D,C,Fa,Ga)) = Ga ) ).

% snd_convol
tff(fact_512_abstract__boolean__algebra_Oaxioms_I3_J,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => boolea6902313364301356556axioms(B,Conj,Disj,Compl,Zero,One) ) ).

% abstract_boolean_algebra.axioms(3)
tff(fact_513_minus__assn__def,axiom,
    ! [A3: assn,Ba: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),minus_minus(assn),A3),Ba) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A3),aa(assn,assn,uminus_uminus(assn),Ba)) ) ).

% minus_assn_def
tff(fact_514_order__refl,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),X) ) ).

% order_refl
tff(fact_515_dual__order_Orefl,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),A3) ) ).

% dual_order.refl
tff(fact_516_minus__apply,axiom,
    ! [B: $tType,C: $tType] :
      ( minus(B)
     => ! [A4: fun(C,B),B2: fun(C,B),X: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),minus_minus(fun(C,B)),A4),B2),X) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(C,B,A4,X)),aa(C,B,B2,X)) ) ) ).

% minus_apply
tff(fact_517_neg__le__iff__le,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,uminus_uminus(B),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% neg_le_iff_le
tff(fact_518_compl__le__compl__iff,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),X)),aa(B,B,uminus_uminus(B),Y))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X) ) ) ).

% compl_le_compl_iff
tff(fact_519_le__inf__iff,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Z2) ) ) ) ).

% le_inf_iff
tff(fact_520_inf_Obounded__iff,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),inf_inf(B),Ba),C2))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2) ) ) ) ).

% inf.bounded_iff
tff(fact_521_sup_Obounded__iff,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Ba),C2)),A3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3) ) ) ) ).

% sup.bounded_iff
tff(fact_522_le__sup__iff,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)),Z2)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Z2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ) ).

% le_sup_iff
tff(fact_523_image__empty,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,B)] : ( aa(set(C),set(B),image2(C,B,Fa),bot_bot(set(C))) = bot_bot(set(B)) ) ).

% image_empty
tff(fact_524_empty__is__image,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),A4: set(C)] :
      ( ( bot_bot(set(B)) = aa(set(C),set(B),image2(C,B,Fa),A4) )
    <=> ( A4 = bot_bot(set(C)) ) ) ).

% empty_is_image
tff(fact_525_image__is__empty,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),A4: set(C)] :
      ( ( aa(set(C),set(B),image2(C,B,Fa),A4) = bot_bot(set(B)) )
    <=> ( A4 = bot_bot(set(C)) ) ) ).

% image_is_empty
tff(fact_526_minus__diff__eq,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3) ) ) ).

% minus_diff_eq
tff(fact_527_subset__empty,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),bot_bot(set(B)))
    <=> ( A4 = bot_bot(set(B)) ) ) ).

% subset_empty
tff(fact_528_empty__subsetI,axiom,
    ! [B: $tType,A4: set(B)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),bot_bot(set(B))),A4) ).

% empty_subsetI
tff(fact_529_img__snd,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,S2: set(product_prod(B,C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),S2)
     => member(C,Ba,aa(set(product_prod(B,C)),set(C),image2(product_prod(B,C),C,product_snd(B,C)),S2)) ) ).

% img_snd
tff(fact_530_Int__subset__iff,axiom,
    ! [B: $tType,C3: set(B),A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C3),A4)
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C3),B2) ) ) ).

% Int_subset_iff
tff(fact_531_map__prod__imageI,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A3: B,Ba: C,R: set(product_prod(B,C)),Fa: fun(B,D),Ga: fun(C,E)] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),R)
     => member(product_prod(D,E),aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),aa(B,D,Fa,A3)),aa(C,E,Ga,Ba)),aa(set(product_prod(B,C)),set(product_prod(D,E)),image2(product_prod(B,C),product_prod(D,E),product_map_prod(B,D,C,E,Fa,Ga)),R)) ) ).

% map_prod_imageI
tff(fact_532_map__prod__simp,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,Fa: fun(D,B),Ga: fun(E,C),A3: D,Ba: E] : ( aa(product_prod(D,E),product_prod(B,C),product_map_prod(D,B,E,C,Fa,Ga),aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),A3),Ba)) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Fa,A3)),aa(E,C,Ga,Ba)) ) ).

% map_prod_simp
tff(fact_533_apfst__conv,axiom,
    ! [D: $tType,B: $tType,C: $tType,Fa: fun(D,B),X: D,Y: C] : ( aa(product_prod(D,C),product_prod(B,C),product_apfst(D,B,C,Fa),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),X),Y)) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Fa,X)),Y) ) ).

% apfst_conv
tff(fact_534_Id__onI,axiom,
    ! [B: $tType,A3: B,A4: set(B)] :
      ( member(B,A3,A4)
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),A3),id_on(B,A4)) ) ).

% Id_onI
tff(fact_535_diff__eq__diff__eq,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),D2) )
         => ( ( A3 = Ba )
          <=> ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
tff(fact_536_diff__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B,D2: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),D2),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),D2)) ) ) ) ).

% diff_mono
tff(fact_537_diff__left__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),A3)),aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),Ba)) ) ) ).

% diff_left_mono
tff(fact_538_diff__right__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),C2)) ) ) ).

% diff_right_mono
tff(fact_539_diff__eq__diff__less__eq,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),D2) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),D2) ) ) ) ).

% diff_eq_diff_less_eq
tff(fact_540_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [A3: B,C2: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),C2)),Ba) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),C2) ) ) ).

% cancel_ab_semigroup_add_class.diff_right_commute
tff(fact_541_fun__diff__def,axiom,
    ! [C: $tType,B: $tType] :
      ( minus(C)
     => ! [A4: fun(B,C),B2: fun(B,C),X3: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),minus_minus(fun(B,C)),A4),B2),X3) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(B,C,A4,X3)),aa(B,C,B2,X3)) ) ) ).

% fun_diff_def
tff(fact_542_nle__le,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
            & ( Ba != A3 ) ) ) ) ).

% nle_le
tff(fact_543_le__cases3,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B,Z2: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
           => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) )
         => ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Z2) )
           => ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Z2)
               => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),Y) )
             => ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),Y)
                 => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X) )
               => ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2)
                   => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),X) )
                 => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),X)
                     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y) ) ) ) ) ) ) ) ).

% le_cases3
tff(fact_544_order__class_Oorder__eq__iff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X: B,Y: B] :
          ( ( X = Y )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X) ) ) ) ).

% order_class.order_eq_iff
tff(fact_545_ord__eq__le__trans,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( A3 = Ba )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2) ) ) ) ).

% ord_eq_le_trans
tff(fact_546_ord__le__eq__trans,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( ( Ba = C2 )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2) ) ) ) ).

% ord_le_eq_trans
tff(fact_547_order__antisym,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X)
           => ( X = Y ) ) ) ) ).

% order_antisym
tff(fact_548_order_Otrans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2) ) ) ) ).

% order.trans
tff(fact_549_order__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Z2) ) ) ) ).

% order_trans
tff(fact_550_linorder__wlog,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Pa: fun(B,fun(B,$o)),A3: B,Ba: B] :
          ( ! [A8: B,B4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A8),B4)
             => aa(B,$o,aa(B,fun(B,$o),Pa,A8),B4) )
         => ( ! [A8: B,B4: B] :
                ( aa(B,$o,aa(B,fun(B,$o),Pa,B4),A8)
               => aa(B,$o,aa(B,fun(B,$o),Pa,A8),B4) )
           => aa(B,$o,aa(B,fun(B,$o),Pa,A3),Ba) ) ) ) ).

% linorder_wlog
tff(fact_551_dual__order_Oeq__iff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = Ba )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ) ).

% dual_order.eq_iff
tff(fact_552_dual__order_Oantisym,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
           => ( A3 = Ba ) ) ) ) ).

% dual_order.antisym
tff(fact_553_dual__order_Otrans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3) ) ) ) ).

% dual_order.trans
tff(fact_554_antisym,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
           => ( A3 = Ba ) ) ) ) ).

% antisym
tff(fact_555_le__funD,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [Fa: fun(B,C),Ga: fun(B,C),X: B] :
          ( aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),Fa),Ga)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X)),aa(B,C,Ga,X)) ) ) ).

% le_funD
tff(fact_556_le__funE,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [Fa: fun(B,C),Ga: fun(B,C),X: B] :
          ( aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),Fa),Ga)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X)),aa(B,C,Ga,X)) ) ) ).

% le_funE
tff(fact_557_le__funI,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [Fa: fun(B,C),Ga: fun(B,C)] :
          ( ! [X2: B] : aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X2)),aa(B,C,Ga,X2))
         => aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),Fa),Ga) ) ) ).

% le_funI
tff(fact_558_le__fun__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [Fa: fun(B,C),Ga: fun(B,C)] :
          ( aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),Fa),Ga)
        <=> ! [X4: B] : aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X4)),aa(B,C,Ga,X4)) ) ) ).

% le_fun_def
tff(fact_559_Orderings_Oorder__eq__iff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = Ba )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ) ).

% Orderings.order_eq_iff
tff(fact_560_order__subst1,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A3: B,Fa: fun(C,B),Ba: C,C2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(C,B,Fa,Ba))
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),Ba),C2)
           => ( ! [X2: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),X2),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(C,B,Fa,X2)),aa(C,B,Fa,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(C,B,Fa,C2)) ) ) ) ) ).

% order_subst1
tff(fact_561_order__subst2,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A3: B,Ba: B,Fa: fun(B,C),C2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,Ba)),C2)
           => ( ! [X2: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X2)),aa(B,C,Fa,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,A3)),C2) ) ) ) ) ).

% order_subst2
tff(fact_562_order__eq__refl,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B] :
          ( ( X = Y )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y) ) ) ).

% order_eq_refl
tff(fact_563_linorder__linear,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
          | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X) ) ) ).

% linorder_linear
tff(fact_564_ord__eq__le__subst,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ord(C)
        & ord(B) )
     => ! [A3: B,Fa: fun(C,B),Ba: C,C2: C] :
          ( ( A3 = aa(C,B,Fa,Ba) )
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),Ba),C2)
           => ( ! [X2: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),X2),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(C,B,Fa,X2)),aa(C,B,Fa,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(C,B,Fa,C2)) ) ) ) ) ).

% ord_eq_le_subst
tff(fact_565_ord__le__eq__subst,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ord(C)
        & ord(B) )
     => ! [A3: B,Ba: B,Fa: fun(B,C),C2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( ( aa(B,C,Fa,Ba) = C2 )
           => ( ! [X2: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X2)),aa(B,C,Fa,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,A3)),C2) ) ) ) ) ).

% ord_le_eq_subst
tff(fact_566_linorder__le__cases,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X) ) ) ).

% linorder_le_cases
tff(fact_567_order__antisym__conv,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Y: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
          <=> ( X = Y ) ) ) ) ).

% order_antisym_conv
tff(fact_568_prod__fun__imageE,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,C2: product_prod(B,C),Fa: fun(D,B),Ga: fun(E,C),R: set(product_prod(D,E))] :
      ( member(product_prod(B,C),C2,aa(set(product_prod(D,E)),set(product_prod(B,C)),image2(product_prod(D,E),product_prod(B,C),product_map_prod(D,B,E,C,Fa,Ga)),R))
     => ~ ! [X2: D,Y2: E] :
            ( ( C2 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Fa,X2)),aa(E,C,Ga,Y2)) )
           => ~ member(product_prod(D,E),aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),X2),Y2),R) ) ) ).

% prod_fun_imageE
tff(fact_569_diff__shunt__var,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),X),Y) = bot_bot(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y) ) ) ).

% diff_shunt_var
tff(fact_570_image__Int__subset,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),A4: set(C),B2: set(C)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(C),set(B),image2(C,B,Fa),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),image2(C,B,Fa),A4)),aa(set(C),set(B),image2(C,B,Fa),B2))) ).

% image_Int_subset
tff(fact_571_map__prod__o__convol,axiom,
    ! [E: $tType,C: $tType,D: $tType,F7: $tType,B: $tType,H12: fun(E,C),H23: fun(F7,D),Fa: fun(B,E),Ga: fun(B,F7)] : ( aa(fun(B,product_prod(E,F7)),fun(B,product_prod(C,D)),aa(fun(product_prod(E,F7),product_prod(C,D)),fun(fun(B,product_prod(E,F7)),fun(B,product_prod(C,D))),comp(product_prod(E,F7),product_prod(C,D),B),product_map_prod(E,C,F7,D,H12,H23)),bNF_convol(B,E,F7,Fa,Ga)) = bNF_convol(B,C,D,aa(fun(B,E),fun(B,C),aa(fun(E,C),fun(fun(B,E),fun(B,C)),comp(E,C,B),H12),Fa),aa(fun(B,F7),fun(B,D),aa(fun(F7,D),fun(fun(B,F7),fun(B,D)),comp(F7,D,B),H23),Ga)) ) ).

% map_prod_o_convol
tff(fact_572_abstract__boolean__algebra__axioms__def,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea6902313364301356556axioms(B,Conj,Disj,Compl,Zero,One)
    <=> ( ! [X4: B,Y3: B,Z4: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X4),aa(B,B,aa(B,fun(B,B),Disj,Y3),Z4)) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X4),Y3)),aa(B,B,aa(B,fun(B,B),Conj,X4),Z4)) )
        & ! [X4: B,Y3: B,Z4: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X4),aa(B,B,aa(B,fun(B,B),Conj,Y3),Z4)) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,X4),Y3)),aa(B,B,aa(B,fun(B,B),Disj,X4),Z4)) )
        & ! [X4: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X4),One) = X4 )
        & ! [X4: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X4),Zero) = X4 )
        & ! [X4: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X4),aa(B,B,Compl,X4)) = Zero )
        & ! [X4: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X4),aa(B,B,Compl,X4)) = One ) ) ) ).

% abstract_boolean_algebra_axioms_def
tff(fact_573_abstract__boolean__algebra__axioms_Ointro,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),One: B,Zero: B,Compl: fun(B,B)] :
      ( ! [X2: B,Y2: B,Z3: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X2),aa(B,B,aa(B,fun(B,B),Disj,Y2),Z3)) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X2),Y2)),aa(B,B,aa(B,fun(B,B),Conj,X2),Z3)) )
     => ( ! [X2: B,Y2: B,Z3: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X2),aa(B,B,aa(B,fun(B,B),Conj,Y2),Z3)) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,X2),Y2)),aa(B,B,aa(B,fun(B,B),Disj,X2),Z3)) )
       => ( ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X2),One) = X2 )
         => ( ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X2),Zero) = X2 )
           => ( ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),Conj,X2),aa(B,B,Compl,X2)) = Zero )
             => ( ! [X2: B] : ( aa(B,B,aa(B,fun(B,B),Disj,X2),aa(B,B,Compl,X2)) = One )
               => boolea6902313364301356556axioms(B,Conj,Disj,Compl,Zero,One) ) ) ) ) ) ) ).

% abstract_boolean_algebra_axioms.intro
tff(fact_574_snd__image__mp,axiom,
    ! [C: $tType,B: $tType,A4: set(product_prod(C,B)),B2: set(B),X: C,Y: B] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(product_prod(C,B)),set(B),image2(product_prod(C,B),B,product_snd(C,B)),A4)),B2)
     => ( member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X),Y),A4)
       => member(B,Y,B2) ) ) ).

% snd_image_mp
tff(fact_575_image__eq__imp__comp,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,Fa: fun(C,B),A4: set(C),Ga: fun(D,B),B2: set(D),H2: fun(B,E)] :
      ( ( aa(set(C),set(B),image2(C,B,Fa),A4) = aa(set(D),set(B),image2(D,B,Ga),B2) )
     => ( aa(set(C),set(E),image2(C,E,aa(fun(C,B),fun(C,E),aa(fun(B,E),fun(fun(C,B),fun(C,E)),comp(B,E,C),H2),Fa)),A4) = aa(set(D),set(E),image2(D,E,aa(fun(D,B),fun(D,E),aa(fun(B,E),fun(fun(D,B),fun(D,E)),comp(B,E,D),H2),Ga)),B2) ) ) ).

% image_eq_imp_comp
tff(fact_576_image__comp,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(C,B),Ga: fun(D,C),R3: set(D)] : ( aa(set(C),set(B),image2(C,B,Fa),aa(set(D),set(C),image2(D,C,Ga),R3)) = aa(set(D),set(B),image2(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Fa),Ga)),R3) ) ).

% image_comp
tff(fact_577_right__diff__distrib_H,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ).

% right_diff_distrib'
tff(fact_578_left__diff__distrib_H,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [Ba: B,C2: B,A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),C2)),A3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)) ) ) ).

% left_diff_distrib'
tff(fact_579_right__diff__distrib,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ).

% right_diff_distrib
tff(fact_580_left__diff__distrib,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ).

% left_diff_distrib
tff(fact_581_minus__diff__commute,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [Ba: B,A3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),Ba)),A3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),A3)),Ba) ) ) ).

% minus_diff_commute
tff(fact_582_map__prod__compose,axiom,
    ! [E: $tType,D: $tType,B: $tType,F7: $tType,G: $tType,C: $tType,F1: fun(F7,D),F22: fun(B,F7),G1: fun(G,E),G22: fun(C,G)] : ( product_map_prod(B,D,C,E,aa(fun(B,F7),fun(B,D),aa(fun(F7,D),fun(fun(B,F7),fun(B,D)),comp(F7,D,B),F1),F22),aa(fun(C,G),fun(C,E),aa(fun(G,E),fun(fun(C,G),fun(C,E)),comp(G,E,C),G1),G22)) = aa(fun(product_prod(B,C),product_prod(F7,G)),fun(product_prod(B,C),product_prod(D,E)),aa(fun(product_prod(F7,G),product_prod(D,E)),fun(fun(product_prod(B,C),product_prod(F7,G)),fun(product_prod(B,C),product_prod(D,E))),comp(product_prod(F7,G),product_prod(D,E),product_prod(B,C)),product_map_prod(F7,D,G,E,F1,G1)),product_map_prod(B,F7,C,G,F22,G22)) ) ).

% map_prod_compose
tff(fact_583_map__prod_Ocompositionality,axiom,
    ! [E: $tType,C: $tType,B: $tType,D: $tType,G: $tType,F7: $tType,Fa: fun(D,B),Ga: fun(E,C),H2: fun(F7,D),I: fun(G,E),Prod: product_prod(F7,G)] : ( aa(product_prod(D,E),product_prod(B,C),product_map_prod(D,B,E,C,Fa,Ga),aa(product_prod(F7,G),product_prod(D,E),product_map_prod(F7,D,G,E,H2,I),Prod)) = aa(product_prod(F7,G),product_prod(B,C),product_map_prod(F7,B,G,C,aa(fun(F7,D),fun(F7,B),aa(fun(D,B),fun(fun(F7,D),fun(F7,B)),comp(D,B,F7),Fa),H2),aa(fun(G,E),fun(G,C),aa(fun(E,C),fun(fun(G,E),fun(G,C)),comp(E,C,G),Ga),I)),Prod) ) ).

% map_prod.compositionality
tff(fact_584_map__prod_Ocomp,axiom,
    ! [B: $tType,F7: $tType,D: $tType,E: $tType,G: $tType,C: $tType,Fa: fun(F7,D),Ga: fun(G,E),H2: fun(B,F7),I: fun(C,G)] : ( aa(fun(product_prod(B,C),product_prod(F7,G)),fun(product_prod(B,C),product_prod(D,E)),aa(fun(product_prod(F7,G),product_prod(D,E)),fun(fun(product_prod(B,C),product_prod(F7,G)),fun(product_prod(B,C),product_prod(D,E))),comp(product_prod(F7,G),product_prod(D,E),product_prod(B,C)),product_map_prod(F7,D,G,E,Fa,Ga)),product_map_prod(B,F7,C,G,H2,I)) = product_map_prod(B,D,C,E,aa(fun(B,F7),fun(B,D),aa(fun(F7,D),fun(fun(B,F7),fun(B,D)),comp(F7,D,B),Fa),H2),aa(fun(C,G),fun(C,E),aa(fun(G,E),fun(fun(C,G),fun(C,E)),comp(G,E,C),Ga),I)) ) ).

% map_prod.comp
tff(fact_585_prod_Omap__comp,axiom,
    ! [E: $tType,C: $tType,B: $tType,D: $tType,G: $tType,F7: $tType,G1: fun(D,B),G22: fun(E,C),F1: fun(F7,D),F22: fun(G,E),V: product_prod(F7,G)] : ( aa(product_prod(D,E),product_prod(B,C),product_map_prod(D,B,E,C,G1,G22),aa(product_prod(F7,G),product_prod(D,E),product_map_prod(F7,D,G,E,F1,F22),V)) = aa(product_prod(F7,G),product_prod(B,C),product_map_prod(F7,B,G,C,aa(fun(F7,D),fun(F7,B),aa(fun(D,B),fun(fun(F7,D),fun(F7,B)),comp(D,B,F7),G1),F1),aa(fun(G,E),fun(G,C),aa(fun(E,C),fun(fun(G,E),fun(G,C)),comp(E,C,G),G22),F22)),V) ) ).

% prod.map_comp
tff(fact_586_le__numeral__extra_I4_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),one_one(B)) ) ).

% le_numeral_extra(4)
tff(fact_587_subrelI,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,C)),S: set(product_prod(B,C))] :
      ( ! [X2: B,Y2: C] :
          ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2),R3)
         => member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2),S) )
     => aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),R3),S) ) ).

% subrelI
tff(fact_588_bot_Oextremum__uniqueI,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),bot_bot(B))
         => ( A3 = bot_bot(B) ) ) ) ).

% bot.extremum_uniqueI
tff(fact_589_bot_Oextremum__unique,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),bot_bot(B))
        <=> ( A3 = bot_bot(B) ) ) ) ).

% bot.extremum_unique
tff(fact_590_bot_Oextremum,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),bot_bot(B)),A3) ) ).

% bot.extremum
tff(fact_591_le__minus__iff,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,uminus_uminus(B),Ba))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,uminus_uminus(B),A3)) ) ) ).

% le_minus_iff
tff(fact_592_minus__le__iff,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A3)),Ba)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Ba)),A3) ) ) ).

% minus_le_iff
tff(fact_593_le__imp__neg__le,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,uminus_uminus(B),A3)) ) ) ).

% le_imp_neg_le
tff(fact_594_compl__mono,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Y)),aa(B,B,uminus_uminus(B),X)) ) ) ).

% compl_mono
tff(fact_595_compl__le__swap1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),aa(B,B,uminus_uminus(B),X))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% compl_le_swap1
tff(fact_596_compl__le__swap2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Y)),X)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),X)),Y) ) ) ).

% compl_le_swap2
tff(fact_597_subset__emptyI,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ! [X2: B] : ~ member(B,X2,A4)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),bot_bot(set(B))) ) ).

% subset_emptyI
tff(fact_598_top__greatest,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),top_top(B)) ) ).

% top_greatest
tff(fact_599_top_Oextremum__unique,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),top_top(B)),A3)
        <=> ( A3 = top_top(B) ) ) ) ).

% top.extremum_unique
tff(fact_600_top_Oextremum__uniqueI,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),top_top(B)),A3)
         => ( A3 = top_top(B) ) ) ) ).

% top.extremum_uniqueI
tff(fact_601_inf__sup__ord_I2_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),Y) ) ).

% inf_sup_ord(2)
tff(fact_602_inf__sup__ord_I1_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),X) ) ).

% inf_sup_ord(1)
tff(fact_603_inf__le1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),X) ) ).

% inf_le1
tff(fact_604_inf__le2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),Y) ) ).

% inf_le2
tff(fact_605_le__infE,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba))
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),A3)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Ba) ) ) ) ).

% le_infE
tff(fact_606_le__infI,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)) ) ) ) ).

% le_infI
tff(fact_607_inf__mono,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,C2: B,Ba: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),D2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),inf_inf(B),C2),D2)) ) ) ) ).

% inf_mono
tff(fact_608_le__infI1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,X: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),X)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),X) ) ) ).

% le_infI1
tff(fact_609_le__infI2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Ba: B,X: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),X)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),X) ) ) ).

% le_infI2
tff(fact_610_inf_OorderE,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( A3 = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) ) ) ) ).

% inf.orderE
tff(fact_611_inf_OorderI,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% inf.orderI
tff(fact_612_inf__unique,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Fa: fun(B,fun(B,B)),X: B,Y: B] :
          ( ! [X2: B,Y2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),Fa,X2),Y2)),X2)
         => ( ! [X2: B,Y2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),Fa,X2),Y2)),Y2)
           => ( ! [X2: B,Y2: B,Z3: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y2)
                 => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Z3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),Fa,Y2),Z3)) ) )
             => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) = aa(B,B,aa(B,fun(B,B),Fa,X),Y) ) ) ) ) ) ).

% inf_unique
tff(fact_613_le__iff__inf,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
        <=> ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) = X ) ) ) ).

% le_iff_inf
tff(fact_614_inf_Oabsorb1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) = A3 ) ) ) ).

% inf.absorb1
tff(fact_615_inf_Oabsorb2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) = Ba ) ) ) ).

% inf.absorb2
tff(fact_616_inf__absorb1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) = X ) ) ) ).

% inf_absorb1
tff(fact_617_inf__absorb2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Y: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) = Y ) ) ) ).

% inf_absorb2
tff(fact_618_inf_OboundedE,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),inf_inf(B),Ba),C2))
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2) ) ) ) ).

% inf.boundedE
tff(fact_619_inf_OboundedI,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),inf_inf(B),Ba),C2)) ) ) ) ).

% inf.boundedI
tff(fact_620_inf__greatest,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2)) ) ) ) ).

% inf_greatest
tff(fact_621_inf_Oorder__iff,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
        <=> ( A3 = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) ) ) ) ).

% inf.order_iff
tff(fact_622_inf_Ocobounded1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),A3) ) ).

% inf.cobounded1
tff(fact_623_inf_Ocobounded2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),Ba) ) ).

% inf.cobounded2
tff(fact_624_inf_Oabsorb__iff1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
        <=> ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) = A3 ) ) ) ).

% inf.absorb_iff1
tff(fact_625_inf_Oabsorb__iff2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
        <=> ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) = Ba ) ) ) ).

% inf.absorb_iff2
tff(fact_626_inf_OcoboundedI1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),C2) ) ) ).

% inf.coboundedI1
tff(fact_627_inf_OcoboundedI2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),C2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),C2) ) ) ).

% inf.coboundedI2
tff(fact_628_sup_OcoboundedI2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ).

% sup.coboundedI2
tff(fact_629_sup_OcoboundedI1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ).

% sup.coboundedI1
tff(fact_630_sup_Oabsorb__iff2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
        <=> ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) = Ba ) ) ) ).

% sup.absorb_iff2
tff(fact_631_sup_Oabsorb__iff1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
        <=> ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) = A3 ) ) ) ).

% sup.absorb_iff1
tff(fact_632_sup_Ocobounded2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ).

% sup.cobounded2
tff(fact_633_sup_Ocobounded1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ).

% sup.cobounded1
tff(fact_634_sup_Oorder__iff,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
        <=> ( A3 = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) ) ) ) ).

% sup.order_iff
tff(fact_635_sup_OboundedI,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Ba),C2)),A3) ) ) ) ).

% sup.boundedI
tff(fact_636_sup_OboundedE,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Ba),C2)),A3)
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3) ) ) ) ).

% sup.boundedE
tff(fact_637_sup__absorb2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) = Y ) ) ) ).

% sup_absorb2
tff(fact_638_sup__absorb1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Y: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) = X ) ) ) ).

% sup_absorb1
tff(fact_639_sup_Oabsorb2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) = Ba ) ) ) ).

% sup.absorb2
tff(fact_640_sup_Oabsorb1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) = A3 ) ) ) ).

% sup.absorb1
tff(fact_641_sup__unique,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Fa: fun(B,fun(B,B)),X: B,Y: B] :
          ( ! [X2: B,Y2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),aa(B,B,aa(B,fun(B,B),Fa,X2),Y2))
         => ( ! [X2: B,Y2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),aa(B,B,aa(B,fun(B,B),Fa,X2),Y2))
           => ( ! [X2: B,Y2: B,Z3: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),X2)
                 => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z3),X2)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),Fa,Y2),Z3)),X2) ) )
             => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) = aa(B,B,aa(B,fun(B,B),Fa,X),Y) ) ) ) ) ) ).

% sup_unique
tff(fact_642_sup_OorderI,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ).

% sup.orderI
tff(fact_643_sup_OorderE,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( A3 = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) ) ) ) ).

% sup.orderE
tff(fact_644_le__iff__sup,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
        <=> ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) = Y ) ) ) ).

% le_iff_sup
tff(fact_645_sup__least,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Y: B,X: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),X)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)),X) ) ) ) ).

% sup_least
tff(fact_646_sup__mono,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,C2: B,Ba: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),D2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),sup_sup(B),C2),D2)) ) ) ) ).

% sup_mono
tff(fact_647_sup_Omono,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [C2: B,A3: B,D2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),D2),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),C2),D2)),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ) ).

% sup.mono
tff(fact_648_le__supI2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ).

% le_supI2
tff(fact_649_le__supI1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ).

% le_supI1
tff(fact_650_sup__ge2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Y: B,X: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)) ) ).

% sup_ge2
tff(fact_651_sup__ge1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)) ) ).

% sup_ge1
tff(fact_652_le__supI,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,X: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),X)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)),X) ) ) ) ).

% le_supI
tff(fact_653_le__supE,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,Ba: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)),X)
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),X)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),X) ) ) ) ).

% le_supE
tff(fact_654_inf__sup__ord_I3_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)) ) ).

% inf_sup_ord(3)
tff(fact_655_inf__sup__ord_I4_J,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [Y: B,X: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)) ) ).

% inf_sup_ord(4)
tff(fact_656_inter__eq__subsetI,axiom,
    ! [B: $tType,S2: set(B),S4: set(B),A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S2),S4)
     => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),S4) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),S4) )
       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),S2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),S2) ) ) ) ).

% inter_eq_subsetI
tff(fact_657_Int__Collect__mono,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
     => ( ! [X2: B] :
            ( member(B,X2,A4)
           => ( aa(B,$o,Pa,X2)
             => aa(B,$o,Qa,X2) ) )
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,$o),set(B),collect(B),Pa))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),aa(fun(B,$o),set(B),collect(B),Qa))) ) ) ).

% Int_Collect_mono
tff(fact_658_Int__greatest,axiom,
    ! [B: $tType,C3: set(B),A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C3),A4)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C3),B2)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ) ).

% Int_greatest
tff(fact_659_Int__absorb2,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = A4 ) ) ).

% Int_absorb2
tff(fact_660_Int__absorb1,axiom,
    ! [B: $tType,B2: set(B),A4: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A4)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = B2 ) ) ).

% Int_absorb1
tff(fact_661_Int__lower2,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),B2) ).

% Int_lower2
tff(fact_662_Int__lower1,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),A4) ).

% Int_lower1
tff(fact_663_Int__mono,axiom,
    ! [B: $tType,A4: set(B),C3: set(B),B2: set(B),D4: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),C3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),D4)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C3),D4)) ) ) ).

% Int_mono
tff(fact_664_less__by__empty,axiom,
    ! [B: $tType,A4: set(product_prod(B,B)),B2: set(product_prod(B,B))] :
      ( ( A4 = bot_bot(set(product_prod(B,B))) )
     => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),A4),B2) ) ).

% less_by_empty
tff(fact_665_relH__subset,axiom,
    ! [Bs: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit),As: set(nat)] :
      ( relH(Bs,H2,H4)
     => ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),As),Bs)
       => relH(As,H2,H4) ) ) ).

% relH_subset
tff(fact_666_apfst__compose,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,Fa: fun(D,B),Ga: fun(E,D),X: product_prod(E,C)] : ( aa(product_prod(D,C),product_prod(B,C),product_apfst(D,B,C,Fa),aa(product_prod(E,C),product_prod(D,C),product_apfst(E,D,C,Ga),X)) = aa(product_prod(E,C),product_prod(B,C),product_apfst(E,B,C,aa(fun(E,D),fun(E,B),aa(fun(D,B),fun(fun(E,D),fun(E,B)),comp(D,B,E),Fa),Ga)),X) ) ).

% apfst_compose
tff(fact_667_Id__on__iff,axiom,
    ! [B: $tType,X: B,Y: B,A4: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),id_on(B,A4))
    <=> ( ( X = Y )
        & member(B,X,A4) ) ) ).

% Id_on_iff
tff(fact_668_Id__on__eqI,axiom,
    ! [B: $tType,A3: B,Ba: B,A4: set(B)] :
      ( ( A3 = Ba )
     => ( member(B,A3,A4)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),id_on(B,A4)) ) ) ).

% Id_on_eqI
tff(fact_669_Id__onE,axiom,
    ! [B: $tType,C2: product_prod(B,B),A4: set(B)] :
      ( member(product_prod(B,B),C2,id_on(B,A4))
     => ~ ! [X2: B] :
            ( member(B,X2,A4)
           => ( C2 != aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2) ) ) ) ).

% Id_onE
tff(fact_670_convol__def,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(B,C),Ga: fun(B,D),X3: B] : ( aa(B,product_prod(C,D),bNF_convol(B,C,D,Fa,Ga),X3) = aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(B,C,Fa,X3)),aa(B,D,Ga,X3)) ) ).

% convol_def
tff(fact_671_convol__o,axiom,
    ! [C: $tType,D: $tType,E: $tType,B: $tType,Fa: fun(E,C),Ga: fun(E,D),H2: fun(B,E)] : ( aa(fun(B,E),fun(B,product_prod(C,D)),aa(fun(E,product_prod(C,D)),fun(fun(B,E),fun(B,product_prod(C,D))),comp(E,product_prod(C,D),B),bNF_convol(E,C,D,Fa,Ga)),H2) = bNF_convol(B,C,D,aa(fun(B,E),fun(B,C),aa(fun(E,C),fun(fun(B,E),fun(B,C)),comp(E,C,B),Fa),H2),aa(fun(B,E),fun(B,D),aa(fun(E,D),fun(fun(B,E),fun(B,D)),comp(E,D,B),Ga),H2)) ) ).

% convol_o
tff(fact_672_in__snd__imageE,axiom,
    ! [B: $tType,C: $tType,Y: B,S2: set(product_prod(C,B))] :
      ( member(B,Y,aa(set(product_prod(C,B)),set(B),image2(product_prod(C,B),B,product_snd(C,B)),S2))
     => ~ ! [X2: C] : ~ member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X2),Y),S2) ) ).

% in_snd_imageE
tff(fact_673_surj__fun__eq,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(C,B),X6: set(C),G1: fun(B,D),G22: fun(B,D)] :
      ( ( aa(set(C),set(B),image2(C,B,Fa),X6) = top_top(set(B)) )
     => ( ! [X2: C] :
            ( member(C,X2,X6)
           => ( aa(C,D,aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),G1),Fa),X2) = aa(C,D,aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),G22),Fa),X2) ) )
       => ( G1 = G22 ) ) ) ).

% surj_fun_eq
tff(fact_674_comp__surj,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(C,B),Ga: fun(B,D)] :
      ( ( aa(set(C),set(B),image2(C,B,Fa),top_top(set(C))) = top_top(set(B)) )
     => ( ( aa(set(B),set(D),image2(B,D,Ga),top_top(set(B))) = top_top(set(D)) )
       => ( aa(set(C),set(D),image2(C,D,aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),Ga),Fa)),top_top(set(C))) = top_top(set(D)) ) ) ) ).

% comp_surj
tff(fact_675_fun_Oinj__map__strong,axiom,
    ! [D: $tType,B: $tType,C: $tType,X: fun(C,B),Xa: fun(C,B),Fa: fun(B,D),Faa: fun(B,D)] :
      ( ! [Z3: B,Za: B] :
          ( member(B,Z3,aa(set(C),set(B),image2(C,B,X),top_top(set(C))))
         => ( member(B,Za,aa(set(C),set(B),image2(C,B,Xa),top_top(set(C))))
           => ( ( aa(B,D,Fa,Z3) = aa(B,D,Faa,Za) )
             => ( Z3 = Za ) ) ) )
     => ( ( aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),Fa),X) = aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),Faa),Xa) )
       => ( X = Xa ) ) ) ).

% fun.inj_map_strong
tff(fact_676_fun_Omap__cong0,axiom,
    ! [D: $tType,B: $tType,C: $tType,X: fun(C,B),Fa: fun(B,D),Ga: fun(B,D)] :
      ( ! [Z3: B] :
          ( member(B,Z3,aa(set(C),set(B),image2(C,B,X),top_top(set(C))))
         => ( aa(B,D,Fa,Z3) = aa(B,D,Ga,Z3) ) )
     => ( aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),Fa),X) = aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),Ga),X) ) ) ).

% fun.map_cong0
tff(fact_677_fun_Omap__cong,axiom,
    ! [D: $tType,C: $tType,B: $tType,X: fun(B,C),Ya: fun(B,C),Fa: fun(C,D),Ga: fun(C,D)] :
      ( ( X = Ya )
     => ( ! [Z3: C] :
            ( member(C,Z3,aa(set(B),set(C),image2(B,C,Ya),top_top(set(B))))
           => ( aa(C,D,Fa,Z3) = aa(C,D,Ga,Z3) ) )
       => ( aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Fa),X) = aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),Ya) ) ) ) ).

% fun.map_cong
tff(fact_678_fun_Oset__map,axiom,
    ! [B: $tType,D: $tType,C: $tType,Fa: fun(D,B),V: fun(C,D)] : ( aa(set(C),set(B),image2(C,B,aa(fun(C,D),fun(C,B),aa(fun(D,B),fun(fun(C,D),fun(C,B)),comp(D,B,C),Fa),V)),top_top(set(C))) = aa(set(D),set(B),image2(D,B,Fa),aa(set(C),set(D),image2(C,D,V),top_top(set(C)))) ) ).

% fun.set_map
tff(fact_679_diff__eq,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),X),Y) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% diff_eq
tff(fact_680_le__minus__one__simps_I4_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% le_minus_one_simps(4)
tff(fact_681_le__minus__one__simps_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),one_one(B))),one_one(B)) ) ).

% le_minus_one_simps(2)
tff(fact_682_distrib__inf__le,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B,Z2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Z2))),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2))) ) ).

% distrib_inf_le
tff(fact_683_distrib__sup__le,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [X: B,Y: B,Z2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(B,B,aa(B,fun(B,B),inf_inf(B),Y),Z2))),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Z2))) ) ).

% distrib_sup_le
tff(fact_684_disjoint__mono,axiom,
    ! [B: $tType,A3: set(B),A5: set(B),Ba: set(B),B3: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),A5)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Ba),B3)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A5),B3) = bot_bot(set(B)) )
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),Ba) = bot_bot(set(B)) ) ) ) ) ).

% disjoint_mono
tff(fact_685_Un__Int__assoc__eq,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),C3: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),C3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),C3)) )
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C3),A4) ) ).

% Un_Int_assoc_eq
tff(fact_686_subset__Compl__self__eq,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),A4))
    <=> ( A4 = bot_bot(set(B)) ) ) ).

% subset_Compl_self_eq
tff(fact_687_in__range__subset,axiom,
    ! [As: set(nat),As3: set(nat),H2: heap_ext(product_unit)] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),As),As3)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As3))
       => aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As)) ) ) ).

% in_range_subset
tff(fact_688_inf__shunt,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y) = bot_bot(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% inf_shunt
tff(fact_689_sup__shunt,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y) = top_top(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),X)),Y) ) ) ).

% sup_shunt
tff(fact_690_shunt1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)),Z2)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,uminus_uminus(B),Y)),Z2)) ) ) ).

% shunt1
tff(fact_691_shunt2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(B,B,uminus_uminus(B),Y))),Z2)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),Y),Z2)) ) ) ).

% shunt2
tff(fact_692_sup__neg__inf,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [P2: B,Q2: B,R3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),P2),aa(B,B,aa(B,fun(B,B),sup_sup(B),Q2),R3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),P2),aa(B,B,uminus_uminus(B),Q2))),R3) ) ) ).

% sup_neg_inf
tff(fact_693_apfst__convE,axiom,
    ! [D: $tType,B: $tType,C: $tType,Q2: product_prod(B,C),Fa: fun(D,B),P2: product_prod(D,C)] :
      ( ( Q2 = aa(product_prod(D,C),product_prod(B,C),product_apfst(D,B,C,Fa),P2) )
     => ~ ! [X2: D,Y2: C] :
            ( ( P2 = aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),X2),Y2) )
           => ( Q2 != aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Fa,X2)),Y2) ) ) ) ).

% apfst_convE
tff(fact_694_Sup_OSUP__image,axiom,
    ! [C: $tType,B: $tType,D: $tType,Sup: fun(set(B),B),Ga: fun(C,B),Fa: fun(D,C),A4: set(D)] : ( aa(set(B),B,Sup,aa(set(C),set(B),image2(C,B,Ga),aa(set(D),set(C),image2(D,C,Fa),A4))) = aa(set(B),B,Sup,aa(set(D),set(B),image2(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Ga),Fa)),A4)) ) ).

% Sup.SUP_image
tff(fact_695_Inf_OINF__image,axiom,
    ! [C: $tType,B: $tType,D: $tType,Inf: fun(set(B),B),Ga: fun(C,B),Fa: fun(D,C),A4: set(D)] : ( aa(set(B),B,Inf,aa(set(C),set(B),image2(C,B,Ga),aa(set(D),set(C),image2(D,C,Fa),A4))) = aa(set(B),B,Inf,aa(set(D),set(B),image2(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Ga),Fa)),A4)) ) ).

% Inf.INF_image
tff(fact_696_inf__period_I1_J,axiom,
    ! [B: $tType] :
      ( ( comm_ring(B)
        & dvd(B) )
     => ! [Pa: fun(B,$o),D4: B,Qa: fun(B,$o)] :
          ( ! [X2: B,K2: B] :
              ( aa(B,$o,Pa,X2)
            <=> aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),aa(B,B,aa(B,fun(B,B),times_times(B),K2),D4))) )
         => ( ! [X2: B,K2: B] :
                ( aa(B,$o,Qa,X2)
              <=> aa(B,$o,Qa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),aa(B,B,aa(B,fun(B,B),times_times(B),K2),D4))) )
           => ! [X3: B,K3: B] :
                ( ( aa(B,$o,Pa,X3)
                  & aa(B,$o,Qa,X3) )
              <=> ( aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X3),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D4)))
                  & aa(B,$o,Qa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X3),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D4))) ) ) ) ) ) ).

% inf_period(1)
tff(fact_697_inf__period_I2_J,axiom,
    ! [B: $tType] :
      ( ( comm_ring(B)
        & dvd(B) )
     => ! [Pa: fun(B,$o),D4: B,Qa: fun(B,$o)] :
          ( ! [X2: B,K2: B] :
              ( aa(B,$o,Pa,X2)
            <=> aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),aa(B,B,aa(B,fun(B,B),times_times(B),K2),D4))) )
         => ( ! [X2: B,K2: B] :
                ( aa(B,$o,Qa,X2)
              <=> aa(B,$o,Qa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),aa(B,B,aa(B,fun(B,B),times_times(B),K2),D4))) )
           => ! [X3: B,K3: B] :
                ( ( aa(B,$o,Pa,X3)
                  | aa(B,$o,Qa,X3) )
              <=> ( aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X3),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D4)))
                  | aa(B,$o,Qa,aa(B,B,aa(B,fun(B,B),minus_minus(B),X3),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D4))) ) ) ) ) ) ).

% inf_period(2)
tff(fact_698_apsnd__apfst,axiom,
    ! [B: $tType,C: $tType,D: $tType,E: $tType,Fa: fun(D,C),Ga: fun(E,B),X: product_prod(E,D)] : ( aa(product_prod(B,D),product_prod(B,C),aa(fun(D,C),fun(product_prod(B,D),product_prod(B,C)),product_apsnd(D,C,B),Fa),aa(product_prod(E,D),product_prod(B,D),product_apfst(E,B,D,Ga),X)) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(E,B,Ga,aa(product_prod(E,D),E,product_fst(E,D),X))),aa(D,C,Fa,aa(product_prod(E,D),D,product_snd(E,D),X))) ) ).

% apsnd_apfst
tff(fact_699_apfst__apsnd,axiom,
    ! [B: $tType,C: $tType,E: $tType,D: $tType,Fa: fun(D,B),Ga: fun(E,C),X: product_prod(D,E)] : ( aa(product_prod(D,C),product_prod(B,C),product_apfst(D,B,C,Fa),aa(product_prod(D,E),product_prod(D,C),aa(fun(E,C),fun(product_prod(D,E),product_prod(D,C)),product_apsnd(E,C,D),Ga),X)) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Fa,aa(product_prod(D,E),D,product_fst(D,E),X))),aa(E,C,Ga,aa(product_prod(D,E),E,product_snd(D,E),X))) ) ).

% apfst_apsnd
tff(fact_700_the__elem__image__unique,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,C),X: B] :
      ( ( A4 != bot_bot(set(B)) )
     => ( ! [Y2: B] :
            ( member(B,Y2,A4)
           => ( aa(B,C,Fa,Y2) = aa(B,C,Fa,X) ) )
       => ( the_elem(C,aa(set(B),set(C),image2(B,C,Fa),A4)) = aa(B,C,Fa,X) ) ) ) ).

% the_elem_image_unique
tff(fact_701_mod__star__trueE_H,axiom,
    ! [Pa: assn,H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),top_top(assn))),H2)
     => ~ ! [H5: product_prod(heap_ext(product_unit),set(nat))] :
            ( ( aa(product_prod(heap_ext(product_unit),set(nat)),heap_ext(product_unit),product_fst(heap_ext(product_unit),set(nat)),H5) = aa(product_prod(heap_ext(product_unit),set(nat)),heap_ext(product_unit),product_fst(heap_ext(product_unit),set(nat)),H2) )
           => ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H5)),aa(product_prod(heap_ext(product_unit),set(nat)),set(nat),product_snd(heap_ext(product_unit),set(nat)),H2))
             => ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),H5) ) ) ) ).

% mod_star_trueE'
tff(fact_702_dbl__dec__simps_I2_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_dec(B,zero_zero(B)) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% dbl_dec_simps(2)
tff(fact_703_Diff__cancel,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),A4) = bot_bot(set(B)) ) ).

% Diff_cancel
tff(fact_704_empty__Diff,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),bot_bot(set(B))),A4) = bot_bot(set(B)) ) ).

% empty_Diff
tff(fact_705_Diff__empty,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),bot_bot(set(B))) = A4 ) ).

% Diff_empty
tff(fact_706_le__zero__eq,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [N: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),N),zero_zero(B))
        <=> ( N = zero_zero(B) ) ) ) ).

% le_zero_eq
tff(fact_707_mult__zero__left,axiom,
    ! [B: $tType] :
      ( mult_zero(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),zero_zero(B)),A3) = zero_zero(B) ) ) ).

% mult_zero_left
tff(fact_708_mult__zero__right,axiom,
    ! [B: $tType] :
      ( mult_zero(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),zero_zero(B)) = zero_zero(B) ) ) ).

% mult_zero_right
tff(fact_709_mult__eq__0__iff,axiom,
    ! [B: $tType] :
      ( semiri3467727345109120633visors(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba) = zero_zero(B) )
        <=> ( ( A3 = zero_zero(B) )
            | ( Ba = zero_zero(B) ) ) ) ) ).

% mult_eq_0_iff
tff(fact_710_mult__cancel__left,axiom,
    ! [B: $tType] :
      ( semiri6575147826004484403cancel(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba) )
        <=> ( ( C2 = zero_zero(B) )
            | ( A3 = Ba ) ) ) ) ).

% mult_cancel_left
tff(fact_711_mult__cancel__right,axiom,
    ! [B: $tType] :
      ( semiri6575147826004484403cancel(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2) = aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2) )
        <=> ( ( C2 = zero_zero(B) )
            | ( A3 = Ba ) ) ) ) ).

% mult_cancel_right
tff(fact_712_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),A3) = zero_zero(B) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
tff(fact_713_diff__zero,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),zero_zero(B)) = A3 ) ) ).

% diff_zero
tff(fact_714_zero__diff,axiom,
    ! [B: $tType] :
      ( comm_monoid_diff(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),zero_zero(B)),A3) = zero_zero(B) ) ) ).

% zero_diff
tff(fact_715_diff__0__right,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),zero_zero(B)) = A3 ) ) ).

% diff_0_right
tff(fact_716_diff__self,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),A3) = zero_zero(B) ) ) ).

% diff_self
tff(fact_717_neg__equal__zero,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( ( aa(B,B,uminus_uminus(B),A3) = A3 )
        <=> ( A3 = zero_zero(B) ) ) ) ).

% neg_equal_zero
tff(fact_718_equal__neg__zero,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( ( A3 = aa(B,B,uminus_uminus(B),A3) )
        <=> ( A3 = zero_zero(B) ) ) ) ).

% equal_neg_zero
tff(fact_719_neg__equal__0__iff__equal,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B] :
          ( ( aa(B,B,uminus_uminus(B),A3) = zero_zero(B) )
        <=> ( A3 = zero_zero(B) ) ) ) ).

% neg_equal_0_iff_equal
tff(fact_720_neg__0__equal__iff__equal,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B] :
          ( ( zero_zero(B) = aa(B,B,uminus_uminus(B),A3) )
        <=> ( zero_zero(B) = A3 ) ) ) ).

% neg_0_equal_iff_equal
tff(fact_721_add_Oinverse__neutral,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ( aa(B,B,uminus_uminus(B),zero_zero(B)) = zero_zero(B) ) ) ).

% add.inverse_neutral
tff(fact_722_Diff__eq__empty__iff,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2) = bot_bot(set(B)) )
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2) ) ).

% Diff_eq_empty_iff
tff(fact_723_Diff__UNIV,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),top_top(set(B))) = bot_bot(set(B)) ) ).

% Diff_UNIV
tff(fact_724_Diff__disjoint,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A4)) = bot_bot(set(B)) ) ).

% Diff_disjoint
tff(fact_725_Diff__Compl,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) ) ).

% Diff_Compl
tff(fact_726_inter__compl__diff__conv,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2) ) ).

% inter_compl_diff_conv
tff(fact_727_diff__ge__0__iff__ge,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ).

% diff_ge_0_iff_ge
tff(fact_728_neg__less__eq__nonneg,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A3)),A3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3) ) ) ).

% neg_less_eq_nonneg
tff(fact_729_less__eq__neg__nonpos,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,uminus_uminus(B),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B)) ) ) ).

% less_eq_neg_nonpos
tff(fact_730_neg__le__0__iff__le,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A3)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3) ) ) ).

% neg_le_0_iff_le
tff(fact_731_neg__0__le__iff__le,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,uminus_uminus(B),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B)) ) ) ).

% neg_0_le_iff_le
tff(fact_732_mult__cancel__left1,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [C2: B,Ba: B] :
          ( ( C2 = aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba) )
        <=> ( ( C2 = zero_zero(B) )
            | ( Ba = one_one(B) ) ) ) ) ).

% mult_cancel_left1
tff(fact_733_mult__cancel__left2,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [C2: B,A3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3) = C2 )
        <=> ( ( C2 = zero_zero(B) )
            | ( A3 = one_one(B) ) ) ) ) ).

% mult_cancel_left2
tff(fact_734_mult__cancel__right1,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [C2: B,Ba: B] :
          ( ( C2 = aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2) )
        <=> ( ( C2 = zero_zero(B) )
            | ( Ba = one_one(B) ) ) ) ) ).

% mult_cancel_right1
tff(fact_735_mult__cancel__right2,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [A3: B,C2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2) = C2 )
        <=> ( ( C2 = zero_zero(B) )
            | ( A3 = one_one(B) ) ) ) ) ).

% mult_cancel_right2
tff(fact_736_diff__numeral__special_I9_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),one_one(B)) = zero_zero(B) ) ) ).

% diff_numeral_special(9)
tff(fact_737_diff__0,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),zero_zero(B)),A3) = aa(B,B,uminus_uminus(B),A3) ) ) ).

% diff_0
tff(fact_738_prod_Ocollapse,axiom,
    ! [C: $tType,B: $tType,Prod: product_prod(B,C)] : ( aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(product_prod(B,C),B,product_fst(B,C),Prod)),aa(product_prod(B,C),C,product_snd(B,C),Prod)) = Prod ) ).

% prod.collapse
tff(fact_739_img__fst,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,S2: set(product_prod(B,C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),S2)
     => member(B,A3,aa(set(product_prod(B,C)),set(B),image2(product_prod(B,C),B,product_fst(B,C)),S2)) ) ).

% img_fst
tff(fact_740_dbl__inc__simps_I2_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_inc(B,zero_zero(B)) = one_one(B) ) ) ).

% dbl_inc_simps(2)
tff(fact_741_fst__comp__apsnd,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(C,D)] : ( aa(fun(product_prod(B,C),product_prod(B,D)),fun(product_prod(B,C),B),aa(fun(product_prod(B,D),B),fun(fun(product_prod(B,C),product_prod(B,D)),fun(product_prod(B,C),B)),comp(product_prod(B,D),B,product_prod(B,C)),product_fst(B,D)),aa(fun(C,D),fun(product_prod(B,C),product_prod(B,D)),product_apsnd(C,D,B),Fa)) = product_fst(B,C) ) ).

% fst_comp_apsnd
tff(fact_742_diff__numeral__special_I12_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),one_one(B))) = zero_zero(B) ) ) ).

% diff_numeral_special(12)
tff(fact_743_fst__comp__map__prod,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,Fa: fun(B,D),Ga: fun(C,E)] : ( aa(fun(product_prod(B,C),product_prod(D,E)),fun(product_prod(B,C),D),aa(fun(product_prod(D,E),D),fun(fun(product_prod(B,C),product_prod(D,E)),fun(product_prod(B,C),D)),comp(product_prod(D,E),D,product_prod(B,C)),product_fst(D,E)),product_map_prod(B,D,C,E,Fa,Ga)) = aa(fun(product_prod(B,C),B),fun(product_prod(B,C),D),aa(fun(B,D),fun(fun(product_prod(B,C),B),fun(product_prod(B,C),D)),comp(B,D,product_prod(B,C)),Fa),product_fst(B,C)) ) ).

% fst_comp_map_prod
tff(fact_744_fst__comp__apfst,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,D)] : ( aa(fun(product_prod(B,C),product_prod(D,C)),fun(product_prod(B,C),D),aa(fun(product_prod(D,C),D),fun(fun(product_prod(B,C),product_prod(D,C)),fun(product_prod(B,C),D)),comp(product_prod(D,C),D,product_prod(B,C)),product_fst(D,C)),product_apfst(B,D,C,Fa)) = aa(fun(product_prod(B,C),B),fun(product_prod(B,C),D),aa(fun(B,D),fun(fun(product_prod(B,C),B),fun(product_prod(B,C),D)),comp(B,D,product_prod(B,C)),Fa),product_fst(B,C)) ) ).

% fst_comp_apfst
tff(fact_745_zero__reorient,axiom,
    ! [B: $tType] :
      ( zero(B)
     => ! [X: B] :
          ( ( zero_zero(B) = X )
        <=> ( X = zero_zero(B) ) ) ) ).

% zero_reorient
tff(fact_746_fst__eqD,axiom,
    ! [C: $tType,B: $tType,X: B,Y: C,A3: B] :
      ( ( aa(product_prod(B,C),B,product_fst(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)) = A3 )
     => ( X = A3 ) ) ).

% fst_eqD
tff(fact_747_fst__conv,axiom,
    ! [C: $tType,B: $tType,X1: B,X22: C] : ( aa(product_prod(B,C),B,product_fst(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X1),X22)) = X1 ) ).

% fst_conv
tff(fact_748_fstE,axiom,
    ! [C: $tType,B: $tType,X: product_prod(B,C),A3: B,Ba: C,Pa: fun(B,$o)] :
      ( ( X = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba) )
     => ( aa(B,$o,Pa,aa(product_prod(B,C),B,product_fst(B,C),X))
       => aa(B,$o,Pa,A3) ) ) ).

% fstE
tff(fact_749_fstI,axiom,
    ! [C: $tType,B: $tType,X: product_prod(B,C),Y: B,Z2: C] :
      ( ( X = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Y),Z2) )
     => ( aa(product_prod(B,C),B,product_fst(B,C),X) = Y ) ) ).

% fstI
tff(fact_750_eq__fst__iff,axiom,
    ! [B: $tType,C: $tType,A3: B,P2: product_prod(B,C)] :
      ( ( A3 = aa(product_prod(B,C),B,product_fst(B,C),P2) )
    <=> ? [B5: C] : ( P2 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),B5) ) ) ).

% eq_fst_iff
tff(fact_751_in__fst__imageE,axiom,
    ! [C: $tType,B: $tType,X: B,S2: set(product_prod(B,C))] :
      ( member(B,X,aa(set(product_prod(B,C)),set(B),image2(product_prod(B,C),B,product_fst(B,C)),S2))
     => ~ ! [Y2: C] : ~ member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y2),S2) ) ).

% in_fst_imageE
tff(fact_752_Int__Diff,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),C3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),C3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),C3)) ) ).

% Int_Diff
tff(fact_753_Diff__Int2,axiom,
    ! [B: $tType,A4: set(B),C3: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),C3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),C3)),B2) ) ).

% Diff_Int2
tff(fact_754_Diff__Diff__Int,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) ) ).

% Diff_Diff_Int
tff(fact_755_Diff__Int__distrib,axiom,
    ! [B: $tType,C3: set(B),A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C3),A4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C3),B2)) ) ).

% Diff_Int_distrib
tff(fact_756_Diff__Int__distrib2,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),C3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)),C3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),C3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3)) ) ).

% Diff_Int_distrib2
tff(fact_757_zero__le,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [X: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X) ) ).

% zero_le
tff(fact_758_mult__not__zero,axiom,
    ! [B: $tType] :
      ( mult_zero(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba) != zero_zero(B) )
         => ( ( A3 != zero_zero(B) )
            & ( Ba != zero_zero(B) ) ) ) ) ).

% mult_not_zero
tff(fact_759_divisors__zero,axiom,
    ! [B: $tType] :
      ( semiri3467727345109120633visors(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba) = zero_zero(B) )
         => ( ( A3 = zero_zero(B) )
            | ( Ba = zero_zero(B) ) ) ) ) ).

% divisors_zero
tff(fact_760_no__zero__divisors,axiom,
    ! [B: $tType] :
      ( semiri3467727345109120633visors(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( ( Ba != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba) != zero_zero(B) ) ) ) ) ).

% no_zero_divisors
tff(fact_761_mult__left__cancel,axiom,
    ! [B: $tType] :
      ( semiri6575147826004484403cancel(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( C2 != zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba) )
          <=> ( A3 = Ba ) ) ) ) ).

% mult_left_cancel
tff(fact_762_mult__right__cancel,axiom,
    ! [B: $tType] :
      ( semiri6575147826004484403cancel(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( C2 != zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2) = aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2) )
          <=> ( A3 = Ba ) ) ) ) ).

% mult_right_cancel
tff(fact_763_zero__neq__one,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ( zero_zero(B) != one_one(B) ) ) ).

% zero_neq_one
tff(fact_764_eq__iff__diff__eq__0,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = Ba )
        <=> ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba) = zero_zero(B) ) ) ) ).

% eq_iff_diff_eq_0
tff(fact_765_less__eq__assn__def,axiom,
    ! [A3: assn,Ba: assn] :
      ( aa(assn,$o,aa(assn,fun(assn,$o),ord_less_eq(assn),A3),Ba)
    <=> ( A3 = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),A3),Ba) ) ) ).

% less_eq_assn_def
tff(fact_766_fst__image__mp,axiom,
    ! [C: $tType,B: $tType,A4: set(product_prod(B,C)),B2: set(B),X: B,Y: C] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(product_prod(B,C)),set(B),image2(product_prod(B,C),B,product_fst(B,C)),A4)),B2)
     => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y),A4)
       => member(B,X,B2) ) ) ).

% fst_image_mp
tff(fact_767_surjective__pairing,axiom,
    ! [C: $tType,B: $tType,T4: product_prod(B,C)] : ( T4 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(product_prod(B,C),B,product_fst(B,C),T4)),aa(product_prod(B,C),C,product_snd(B,C),T4)) ) ).

% surjective_pairing
tff(fact_768_prod_Oexhaust__sel,axiom,
    ! [C: $tType,B: $tType,Prod: product_prod(B,C)] : ( Prod = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(product_prod(B,C),B,product_fst(B,C),Prod)),aa(product_prod(B,C),C,product_snd(B,C),Prod)) ) ).

% prod.exhaust_sel
tff(fact_769_subset__minus__empty,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2) = bot_bot(set(B)) ) ) ).

% subset_minus_empty
tff(fact_770_Diff__triv,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2) = A4 ) ) ).

% Diff_triv
tff(fact_771_Int__Diff__disjoint,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)) = bot_bot(set(B)) ) ).

% Int_Diff_disjoint
tff(fact_772_disjoint__alt__simp1,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2) = A4 )
    <=> ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) ) ) ).

% disjoint_alt_simp1
tff(fact_773_disjoint__alt__simp2,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2) != A4 )
    <=> ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) != bot_bot(set(B)) ) ) ).

% disjoint_alt_simp2
tff(fact_774_Un__Diff__Int,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) = A4 ) ).

% Un_Diff_Int
tff(fact_775_Int__Diff__Un,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)) = A4 ) ).

% Int_Diff_Un
tff(fact_776_Diff__Int,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),C3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),C3)) ) ).

% Diff_Int
tff(fact_777_Diff__Un,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),C3: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),C3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),C3)) ) ).

% Diff_Un
tff(fact_778_mult__mono,axiom,
    ! [B: $tType] :
      ( ordered_semiring(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),D2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),D2)) ) ) ) ) ) ).

% mult_mono
tff(fact_779_mult__mono_H,axiom,
    ! [B: $tType] :
      ( ordered_semiring(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),D2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),D2)) ) ) ) ) ) ).

% mult_mono'
tff(fact_780_zero__le__square,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),A3)) ) ).

% zero_le_square
tff(fact_781_split__mult__pos__le,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A3: B,Ba: B] :
          ( ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),zero_zero(B)) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ).

% split_mult_pos_le
tff(fact_782_mult__left__mono__neg,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ) ).

% mult_left_mono_neg
tff(fact_783_mult__nonpos__nonpos,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ) ).

% mult_nonpos_nonpos
tff(fact_784_mult__left__mono,axiom,
    ! [B: $tType] :
      ( ordered_semiring(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ) ).

% mult_left_mono
tff(fact_785_mult__right__mono__neg,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ) ).

% mult_right_mono_neg
tff(fact_786_mult__right__mono,axiom,
    ! [B: $tType] :
      ( ordered_semiring(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ) ).

% mult_right_mono
tff(fact_787_mult__le__0__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),zero_zero(B))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),zero_zero(B)) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba) ) ) ) ) ).

% mult_le_0_iff
tff(fact_788_split__mult__neg__le,axiom,
    ! [B: $tType] :
      ( ordered_semiring_0(B)
     => ! [A3: B,Ba: B] :
          ( ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),zero_zero(B)) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),zero_zero(B)) ) ) ).

% split_mult_neg_le
tff(fact_789_mult__nonneg__nonneg,axiom,
    ! [B: $tType] :
      ( ordered_semiring_0(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ) ).

% mult_nonneg_nonneg
tff(fact_790_mult__nonneg__nonpos,axiom,
    ! [B: $tType] :
      ( ordered_semiring_0(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),zero_zero(B)) ) ) ) ).

% mult_nonneg_nonpos
tff(fact_791_mult__nonpos__nonneg,axiom,
    ! [B: $tType] :
      ( ordered_semiring_0(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),zero_zero(B)) ) ) ) ).

% mult_nonpos_nonneg
tff(fact_792_mult__nonneg__nonpos2,axiom,
    ! [B: $tType] :
      ( ordered_semiring_0(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3)),zero_zero(B)) ) ) ) ).

% mult_nonneg_nonpos2
tff(fact_793_zero__le__mult__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),zero_zero(B)) ) ) ) ) ).

% zero_le_mult_iff
tff(fact_794_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [B: $tType] :
      ( ordere2520102378445227354miring(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
tff(fact_795_not__one__le__zero,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),zero_zero(B)) ) ).

% not_one_le_zero
tff(fact_796_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),one_one(B)) ) ).

% linordered_nonzero_semiring_class.zero_le_one
tff(fact_797_zero__less__one__class_Ozero__le__one,axiom,
    ! [B: $tType] :
      ( zero_less_one(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),one_one(B)) ) ).

% zero_less_one_class.zero_le_one
tff(fact_798_le__iff__diff__le__0,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),zero_zero(B)) ) ) ).

% le_iff_diff_le_0
tff(fact_799_zero__neq__neg__one,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ( zero_zero(B) != aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% zero_neq_neg_one
tff(fact_800_fst__convol,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,C),Ga: fun(B,D)] : ( aa(fun(B,product_prod(C,D)),fun(B,C),aa(fun(product_prod(C,D),C),fun(fun(B,product_prod(C,D)),fun(B,C)),comp(product_prod(C,D),C,B),product_fst(C,D)),bNF_convol(B,C,D,Fa,Ga)) = Fa ) ).

% fst_convol
tff(fact_801_mult__left__le__one__le,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Y)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Y),X)),X) ) ) ) ) ).

% mult_left_le_one_le
tff(fact_802_mult__right__le__one__le,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Y)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),Y)),X) ) ) ) ) ).

% mult_right_le_one_le
tff(fact_803_mult__le__one,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),one_one(B)) ) ) ) ) ).

% mult_le_one
tff(fact_804_mult__left__le,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),one_one(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),A3) ) ) ) ).

% mult_left_le
tff(fact_805_le__minus__one__simps_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),one_one(B))),zero_zero(B)) ) ).

% le_minus_one_simps(1)
tff(fact_806_le__minus__one__simps_I3_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% le_minus_one_simps(3)
tff(fact_807_convol__expand__snd,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,product_prod(C,D)),Ga: fun(B,C)] :
      ( ( aa(fun(B,product_prod(C,D)),fun(B,C),aa(fun(product_prod(C,D),C),fun(fun(B,product_prod(C,D)),fun(B,C)),comp(product_prod(C,D),C,B),product_fst(C,D)),Fa) = Ga )
     => ( bNF_convol(B,C,D,Ga,aa(fun(B,product_prod(C,D)),fun(B,D),aa(fun(product_prod(C,D),D),fun(fun(B,product_prod(C,D)),fun(B,D)),comp(product_prod(C,D),D,B),product_snd(C,D)),Fa)) = Fa ) ) ).

% convol_expand_snd
tff(fact_808_convol__expand__snd_H,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,product_prod(C,D)),Ga: fun(B,C),H2: fun(B,D)] :
      ( ( aa(fun(B,product_prod(C,D)),fun(B,C),aa(fun(product_prod(C,D),C),fun(fun(B,product_prod(C,D)),fun(B,C)),comp(product_prod(C,D),C,B),product_fst(C,D)),Fa) = Ga )
     => ( ( H2 = aa(fun(B,product_prod(C,D)),fun(B,D),aa(fun(product_prod(C,D),D),fun(fun(B,product_prod(C,D)),fun(B,D)),comp(product_prod(C,D),D,B),product_snd(C,D)),Fa) )
      <=> ( bNF_convol(B,C,D,Ga,H2) = Fa ) ) ) ).

% convol_expand_snd'
tff(fact_809_sndOp__def,axiom,
    ! [B: $tType,C: $tType,D: $tType,Pa: fun(D,fun(B,$o)),Qa: fun(B,fun(C,$o)),Ac: product_prod(D,C)] : ( aa(product_prod(D,C),product_prod(B,C),bNF_sndOp(D,B,C,Pa,Qa),Ac) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),bNF_pick_middlep(D,B,C,Pa,Qa,aa(product_prod(D,C),D,product_fst(D,C),Ac),aa(product_prod(D,C),C,product_snd(D,C),Ac))),aa(product_prod(D,C),C,product_snd(D,C),Ac)) ) ).

% sndOp_def
tff(fact_810_exI__realizer,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o)),Y: B,X: C] :
      ( aa(C,$o,aa(B,fun(C,$o),Pa,Y),X)
     => aa(C,$o,aa(B,fun(C,$o),Pa,aa(product_prod(C,B),B,product_snd(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X),Y))),aa(product_prod(C,B),C,product_fst(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X),Y))) ) ).

% exI_realizer
tff(fact_811_conjI__realizer,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),P2: B,Qa: fun(C,$o),Q2: C] :
      ( aa(B,$o,Pa,P2)
     => ( aa(C,$o,Qa,Q2)
       => ( aa(B,$o,Pa,aa(product_prod(B,C),B,product_fst(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),P2),Q2)))
          & aa(C,$o,Qa,aa(product_prod(B,C),C,product_snd(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),P2),Q2))) ) ) ) ).

% conjI_realizer
tff(fact_812_BNF__Greatest__Fixpoint_Osubst__Pair,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o)),X: B,Y: C,A3: product_prod(B,C)] :
      ( aa(C,$o,aa(B,fun(C,$o),Pa,X),Y)
     => ( ( A3 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y) )
       => aa(C,$o,aa(B,fun(C,$o),Pa,aa(product_prod(B,C),B,product_fst(B,C),A3)),aa(product_prod(B,C),C,product_snd(B,C),A3)) ) ) ).

% BNF_Greatest_Fixpoint.subst_Pair
tff(fact_813_fst__fstOp,axiom,
    ! [D: $tType,C: $tType,B: $tType,Bc: product_prod(B,C),Pa: fun(B,fun(D,$o)),Qa: fun(D,fun(C,$o))] : ( aa(product_prod(B,C),B,product_fst(B,C),Bc) = aa(product_prod(B,C),B,aa(fun(product_prod(B,C),product_prod(B,D)),fun(product_prod(B,C),B),aa(fun(product_prod(B,D),B),fun(fun(product_prod(B,C),product_prod(B,D)),fun(product_prod(B,C),B)),comp(product_prod(B,D),B,product_prod(B,C)),product_fst(B,D)),bNF_fstOp(B,D,C,Pa,Qa)),Bc) ) ).

% fst_fstOp
tff(fact_814_pair__in__swap__image,axiom,
    ! [B: $tType,C: $tType,Y: B,X: C,A4: set(product_prod(C,B))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Y),X),aa(set(product_prod(C,B)),set(product_prod(B,C)),image2(product_prod(C,B),product_prod(B,C),product_swap(C,B)),A4))
    <=> member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X),Y),A4) ) ).

% pair_in_swap_image
tff(fact_815_prod_Oswap__def,axiom,
    ! [B: $tType,C: $tType,P2: product_prod(C,B)] : ( aa(product_prod(C,B),product_prod(B,C),product_swap(C,B),P2) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(product_prod(C,B),B,product_snd(C,B),P2)),aa(product_prod(C,B),C,product_fst(C,B),P2)) ) ).

% prod.swap_def
tff(fact_816_map__prod__o__convol__id,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(D,B),Ga: fun(D,C),X: D] : ( aa(D,product_prod(B,C),aa(fun(D,product_prod(D,C)),fun(D,product_prod(B,C)),aa(fun(product_prod(D,C),product_prod(B,C)),fun(fun(D,product_prod(D,C)),fun(D,product_prod(B,C))),comp(product_prod(D,C),product_prod(B,C),D),product_map_prod(D,B,C,C,Fa,id(C))),bNF_convol(D,D,C,id(D),Ga)),X) = aa(D,product_prod(B,C),bNF_convol(D,B,C,aa(fun(D,B),fun(D,B),aa(fun(B,B),fun(fun(D,B),fun(D,B)),comp(B,B,D),id(B)),Fa),Ga),X) ) ).

% map_prod_o_convol_id
tff(fact_817_prod_Osize__gen__o__map,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Fa: fun(D,nat),Faa: fun(E,nat),Ga: fun(B,D),Gaa: fun(C,E)] : ( aa(fun(product_prod(B,C),product_prod(D,E)),fun(product_prod(B,C),nat),aa(fun(product_prod(D,E),nat),fun(fun(product_prod(B,C),product_prod(D,E)),fun(product_prod(B,C),nat)),comp(product_prod(D,E),nat,product_prod(B,C)),basic_BNF_size_prod(D,E,Fa,Faa)),product_map_prod(B,D,C,E,Ga,Gaa)) = basic_BNF_size_prod(B,C,aa(fun(B,D),fun(B,nat),aa(fun(D,nat),fun(fun(B,D),fun(B,nat)),comp(D,nat,B),Fa),Ga),aa(fun(C,E),fun(C,nat),aa(fun(E,nat),fun(fun(C,E),fun(C,nat)),comp(E,nat,C),Faa),Gaa)) ) ).

% prod.size_gen_o_map
tff(fact_818_divides__aux__eq,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Q2: B,R3: B] :
          ( unique5940410009612947441es_aux(B,aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),R3))
        <=> ( R3 = zero_zero(B) ) ) ) ).

% divides_aux_eq
tff(fact_819_id__comp,axiom,
    ! [C: $tType,B: $tType,Ga: fun(B,C)] : ( aa(fun(B,C),fun(B,C),aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),id(C)),Ga) = Ga ) ).

% id_comp
tff(fact_820_comp__id,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] : ( aa(fun(B,B),fun(B,C),aa(fun(B,C),fun(fun(B,B),fun(B,C)),comp(B,C,B),Fa),id(B)) = Fa ) ).

% comp_id
tff(fact_821_fun_Omap__id,axiom,
    ! [C: $tType,B: $tType,T4: fun(B,C)] : ( aa(fun(B,C),fun(B,C),aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),id(C)),T4) = T4 ) ).

% fun.map_id
tff(fact_822_swap__simp,axiom,
    ! [B: $tType,C: $tType,X: C,Y: B] : ( aa(product_prod(C,B),product_prod(B,C),product_swap(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X),Y)) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Y),X) ) ).

% swap_simp
tff(fact_823_group__add__class_Ominus__comp__minus,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),uminus_uminus(B)),uminus_uminus(B)) = id(B) ) ) ).

% group_add_class.minus_comp_minus
tff(fact_824_boolean__algebra__class_Ominus__comp__minus,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),uminus_uminus(B)),uminus_uminus(B)) = id(B) ) ) ).

% boolean_algebra_class.minus_comp_minus
tff(fact_825_swap__comp__swap,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(product_prod(B,C),product_prod(C,B)),fun(product_prod(B,C),product_prod(B,C)),aa(fun(product_prod(C,B),product_prod(B,C)),fun(fun(product_prod(B,C),product_prod(C,B)),fun(product_prod(B,C),product_prod(B,C))),comp(product_prod(C,B),product_prod(B,C),product_prod(B,C)),product_swap(C,B)),product_swap(B,C)) = id(product_prod(B,C)) ) ).

% swap_comp_swap
tff(fact_826_fun_Omap__id0,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),id(C)) = id(fun(B,C)) ) ).

% fun.map_id0
tff(fact_827_comp__eq__id__dest,axiom,
    ! [D: $tType,C: $tType,B: $tType,A3: fun(D,C),Ba: fun(B,D),C2: fun(B,C),V: B] :
      ( ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),A3),Ba) = aa(fun(B,C),fun(B,C),aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),id(C)),C2) )
     => ( aa(D,C,A3,aa(B,D,Ba,V)) = aa(B,C,C2,V) ) ) ).

% comp_eq_id_dest
tff(fact_828_pointfree__idE,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,B),Ga: fun(B,C),X: B] :
      ( ( aa(fun(B,C),fun(B,B),aa(fun(C,B),fun(fun(B,C),fun(B,B)),comp(C,B,B),Fa),Ga) = id(B) )
     => ( aa(C,B,Fa,aa(B,C,Ga,X)) = X ) ) ).

% pointfree_idE
tff(fact_829_type__copy__Rep__o__Abs,axiom,
    ! [B: $tType,C: $tType,Rep: fun(B,C),Abs: fun(C,B)] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( aa(fun(C,B),fun(C,C),aa(fun(B,C),fun(fun(C,B),fun(C,C)),comp(B,C,C),Rep),Abs) = id(C) ) ) ).

% type_copy_Rep_o_Abs
tff(fact_830_type__copy__Abs__o__Rep,axiom,
    ! [C: $tType,B: $tType,Rep: fun(B,C),Abs: fun(C,B)] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( aa(fun(B,C),fun(B,B),aa(fun(C,B),fun(fun(B,C),fun(B,B)),comp(C,B,B),Abs),Rep) = id(B) ) ) ).

% type_copy_Abs_o_Rep
tff(fact_831_type__copy__map__id0,axiom,
    ! [C: $tType,B: $tType,Rep: fun(B,C),Abs: fun(C,B),M: fun(C,C)] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( ( M = id(C) )
       => ( aa(fun(B,C),fun(B,B),aa(fun(C,B),fun(fun(B,C),fun(B,B)),comp(C,B,B),aa(fun(C,C),fun(C,B),aa(fun(C,B),fun(fun(C,C),fun(C,B)),comp(C,B,C),Abs),M)),Rep) = id(B) ) ) ) ).

% type_copy_map_id0
tff(fact_832_fstOp__def,axiom,
    ! [C: $tType,D: $tType,B: $tType,Pa: fun(B,fun(C,$o)),Qa: fun(C,fun(D,$o)),Ac: product_prod(B,D)] : ( aa(product_prod(B,D),product_prod(B,C),bNF_fstOp(B,C,D,Pa,Qa),Ac) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(product_prod(B,D),B,product_fst(B,D),Ac)),bNF_pick_middlep(B,C,D,Pa,Qa,aa(product_prod(B,D),B,product_fst(B,D),Ac),aa(product_prod(B,D),D,product_snd(B,D),Ac))) ) ).

% fstOp_def
tff(fact_833_inj__on__Un,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),A4: set(B),B2: set(B)] :
      ( inj_on(B,C,Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))
    <=> ( inj_on(B,C,Fa,A4)
        & inj_on(B,C,Fa,B2)
        & ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),image2(B,C,Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2))),aa(set(B),set(C),image2(B,C,Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A4))) = bot_bot(set(C)) ) ) ) ).

% inj_on_Un
tff(fact_834_mult__le__cancel__left1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),Ba) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),one_one(B)) ) ) ) ) ).

% mult_le_cancel_left1
tff(fact_835_mult__le__cancel__left2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),C2)
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),one_one(B)) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A3) ) ) ) ) ).

% mult_le_cancel_left2
tff(fact_836_mult__le__cancel__right1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),Ba) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),one_one(B)) ) ) ) ) ).

% mult_le_cancel_right1
tff(fact_837_mult__le__cancel__right2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),C2)
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),one_one(B)) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A3) ) ) ) ) ).

% mult_le_cancel_right2
tff(fact_838_mult__less__cancel__left1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),Ba) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),one_one(B)) ) ) ) ) ).

% mult_less_cancel_left1
tff(fact_839_mult__less__cancel__left2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),C2)
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),one_one(B)) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3) ) ) ) ) ).

% mult_less_cancel_left2
tff(fact_840_mult__less__cancel__right1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),Ba) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),one_one(B)) ) ) ) ) ).

% mult_less_cancel_right1
tff(fact_841_mult__less__cancel__right2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),C2)
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),one_one(B)) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3) ) ) ) ) ).

% mult_less_cancel_right2
tff(fact_842_relChain__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [R3: set(product_prod(B,B)),As8: fun(B,C)] :
          ( bNF_Ca3754400796208372196lChain(B,C,R3,As8)
        <=> ! [I2: B,J: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),I2),J),R3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,As8,I2)),aa(B,C,As8,J)) ) ) ) ).

% relChain_def
tff(fact_843_not__gr__zero,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [N: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),N)
        <=> ( N = zero_zero(B) ) ) ) ).

% not_gr_zero
tff(fact_844_compl__less__compl__iff,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),X)),aa(B,B,uminus_uminus(B),Y))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ).

% compl_less_compl_iff
tff(fact_845_neg__less__iff__less,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,uminus_uminus(B),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ).

% neg_less_iff_less
tff(fact_846_inj__on__empty,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] : inj_on(B,C,Fa,bot_bot(set(B))) ).

% inj_on_empty
tff(fact_847_diff__gt__0__iff__gt,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ).

% diff_gt_0_iff_gt
tff(fact_848_neg__less__0__iff__less,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),A3)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3) ) ) ).

% neg_less_0_iff_less
tff(fact_849_neg__0__less__iff__less,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,uminus_uminus(B),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B)) ) ) ).

% neg_0_less_iff_less
tff(fact_850_neg__less__pos,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),A3)),A3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3) ) ) ).

% neg_less_pos
tff(fact_851_less__neg__neg,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,uminus_uminus(B),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B)) ) ) ).

% less_neg_neg
tff(fact_852_order__less__imp__not__less,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ).

% order_less_imp_not_less
tff(fact_853_order__less__imp__not__eq2,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ( Y != X ) ) ) ).

% order_less_imp_not_eq2
tff(fact_854_order__less__imp__not__eq,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ( X != Y ) ) ) ).

% order_less_imp_not_eq
tff(fact_855_linorder__less__linear,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
          | ( X = Y )
          | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ).

% linorder_less_linear
tff(fact_856_order__less__imp__triv,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B,Pa: $o] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X)
           => (Pa) ) ) ) ).

% order_less_imp_triv
tff(fact_857_order__less__not__sym,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ).

% order_less_not_sym
tff(fact_858_order__less__subst2,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A3: B,Ba: B,Fa: fun(B,C),C2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,Ba)),C2)
           => ( ! [X2: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,X2)),aa(B,C,Fa,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,A3)),C2) ) ) ) ) ).

% order_less_subst2
tff(fact_859_order__less__subst1,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A3: B,Fa: fun(C,B),Ba: C,C2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(C,B,Fa,Ba))
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),Ba),C2)
           => ( ! [X2: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),X2),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,Fa,X2)),aa(C,B,Fa,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(C,B,Fa,C2)) ) ) ) ) ).

% order_less_subst1
tff(fact_860_order__less__irrefl,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),X) ) ).

% order_less_irrefl
tff(fact_861_ord__less__eq__subst,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ord(C)
        & ord(B) )
     => ! [A3: B,Ba: B,Fa: fun(B,C),C2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( ( aa(B,C,Fa,Ba) = C2 )
           => ( ! [X2: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,X2)),aa(B,C,Fa,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,A3)),C2) ) ) ) ) ).

% ord_less_eq_subst
tff(fact_862_ord__eq__less__subst,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ord(C)
        & ord(B) )
     => ! [A3: B,Fa: fun(C,B),Ba: C,C2: C] :
          ( ( A3 = aa(C,B,Fa,Ba) )
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),Ba),C2)
           => ( ! [X2: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),X2),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,Fa,X2)),aa(C,B,Fa,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(C,B,Fa,C2)) ) ) ) ) ).

% ord_eq_less_subst
tff(fact_863_order__less__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Z2) ) ) ) ).

% order_less_trans
tff(fact_864_order__less__asym_H,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ).

% order_less_asym'
tff(fact_865_linorder__neq__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( ( X != Y )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ) ).

% linorder_neq_iff
tff(fact_866_order__less__asym,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ).

% order_less_asym
tff(fact_867_linorder__neqE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( ( X != Y )
         => ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ) ).

% linorder_neqE
tff(fact_868_dual__order_Ostrict__implies__not__eq,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( A3 != Ba ) ) ) ).

% dual_order.strict_implies_not_eq
tff(fact_869_order_Ostrict__implies__not__eq,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( A3 != Ba ) ) ) ).

% order.strict_implies_not_eq
tff(fact_870_dual__order_Ostrict__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),A3) ) ) ) ).

% dual_order.strict_trans
tff(fact_871_not__less__iff__gr__or__eq,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X)
            | ( X = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
tff(fact_872_order_Ostrict__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),C2) ) ) ) ).

% order.strict_trans
tff(fact_873_linorder__less__wlog,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Pa: fun(B,fun(B,$o)),A3: B,Ba: B] :
          ( ! [A8: B,B4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A8),B4)
             => aa(B,$o,aa(B,fun(B,$o),Pa,A8),B4) )
         => ( ! [A8: B] : aa(B,$o,aa(B,fun(B,$o),Pa,A8),A8)
           => ( ! [A8: B,B4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),Pa,B4),A8)
                 => aa(B,$o,aa(B,fun(B,$o),Pa,A8),B4) )
             => aa(B,$o,aa(B,fun(B,$o),Pa,A3),Ba) ) ) ) ) ).

% linorder_less_wlog
tff(fact_874_exists__least__iff,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o)] :
          ( ? [X_12: B] : aa(B,$o,Pa,X_12)
        <=> ? [N5: B] :
              ( aa(B,$o,Pa,N5)
              & ! [M3: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),M3),N5)
                 => ~ aa(B,$o,Pa,M3) ) ) ) ) ).

% exists_least_iff
tff(fact_875_dual__order_Oirrefl,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),A3) ) ).

% dual_order.irrefl
tff(fact_876_dual__order_Oasym,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ).

% dual_order.asym
tff(fact_877_linorder__cases,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ( ( X != Y )
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ) ).

% linorder_cases
tff(fact_878_antisym__conv3,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Y: B,X: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X)
         => ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
          <=> ( X = Y ) ) ) ) ).

% antisym_conv3
tff(fact_879_less__induct,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),A3: B] :
          ( ! [X2: B] :
              ( ! [Y4: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y4),X2)
                 => aa(B,$o,Pa,Y4) )
             => aa(B,$o,Pa,X2) )
         => aa(B,$o,Pa,A3) ) ) ).

% less_induct
tff(fact_880_ord__less__eq__trans,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( ( Ba = C2 )
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),C2) ) ) ) ).

% ord_less_eq_trans
tff(fact_881_ord__eq__less__trans,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( A3 = Ba )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),C2) ) ) ) ).

% ord_eq_less_trans
tff(fact_882_order_Oasym,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ).

% order.asym
tff(fact_883_less__imp__neq,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ( X != Y ) ) ) ).

% less_imp_neq
tff(fact_884_dense,axiom,
    ! [B: $tType] :
      ( dense_order(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ? [Z3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Z3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z3),Y) ) ) ) ).

% dense
tff(fact_885_gt__ex,axiom,
    ! [B: $tType] :
      ( no_top(B)
     => ! [X: B] :
        ? [X_1: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),X_1) ) ).

% gt_ex
tff(fact_886_lt__ex,axiom,
    ! [B: $tType] :
      ( no_bot(B)
     => ! [X: B] :
        ? [Y2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y2),X) ) ).

% lt_ex
tff(fact_887_fun_Oinj__map,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(B,C)] :
      ( inj_on(B,C,Fa,top_top(set(B)))
     => inj_on(fun(D,B),fun(D,C),aa(fun(B,C),fun(fun(D,B),fun(D,C)),comp(B,C,D),Fa),top_top(set(fun(D,B)))) ) ).

% fun.inj_map
tff(fact_888_inj__on__imageI2,axiom,
    ! [C: $tType,D: $tType,B: $tType,F9: fun(D,C),Fa: fun(B,D),A4: set(B)] :
      ( inj_on(B,C,aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),F9),Fa),A4)
     => inj_on(B,D,Fa,A4) ) ).

% inj_on_imageI2
tff(fact_889_inj__on__Int,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),A4: set(B),B2: set(B)] :
      ( ( inj_on(B,C,Fa,A4)
        | inj_on(B,C,Fa,B2) )
     => inj_on(B,C,Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ).

% inj_on_Int
tff(fact_890_order__le__imp__less__or__eq,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
            | ( X = Y ) ) ) ) ).

% order_le_imp_less_or_eq
tff(fact_891_linorder__le__less__linear,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
          | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ).

% linorder_le_less_linear
tff(fact_892_order__less__le__subst2,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A3: B,Ba: B,Fa: fun(B,C),C2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,Ba)),C2)
           => ( ! [X2: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,X2)),aa(B,C,Fa,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,A3)),C2) ) ) ) ) ).

% order_less_le_subst2
tff(fact_893_order__less__le__subst1,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A3: B,Fa: fun(C,B),Ba: C,C2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(C,B,Fa,Ba))
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),Ba),C2)
           => ( ! [X2: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),X2),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(C,B,Fa,X2)),aa(C,B,Fa,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(C,B,Fa,C2)) ) ) ) ) ).

% order_less_le_subst1
tff(fact_894_order__le__less__subst2,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A3: B,Ba: B,Fa: fun(B,C),C2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,Ba)),C2)
           => ( ! [X2: B,Y2: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X2)),aa(B,C,Fa,Y2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,A3)),C2) ) ) ) ) ).

% order_le_less_subst2
tff(fact_895_order__le__less__subst1,axiom,
    ! [B: $tType,C: $tType] :
      ( ( order(C)
        & order(B) )
     => ! [A3: B,Fa: fun(C,B),Ba: C,C2: C] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(C,B,Fa,Ba))
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),Ba),C2)
           => ( ! [X2: C,Y2: C] :
                  ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),X2),Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,Fa,X2)),aa(C,B,Fa,Y2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(C,B,Fa,C2)) ) ) ) ) ).

% order_le_less_subst1
tff(fact_896_order__less__le__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Z2) ) ) ) ).

% order_less_le_trans
tff(fact_897_order__le__less__trans,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Z2) ) ) ) ).

% order_le_less_trans
tff(fact_898_order__neq__le__trans,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != Ba )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ) ).

% order_neq_le_trans
tff(fact_899_order__le__neq__trans,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( ( A3 != Ba )
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ) ).

% order_le_neq_trans
tff(fact_900_order__less__imp__le,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y) ) ) ).

% order_less_imp_le
tff(fact_901_linorder__not__less,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X) ) ) ).

% linorder_not_less
tff(fact_902_linorder__not__le,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X) ) ) ).

% linorder_not_le
tff(fact_903_order__less__le,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
            & ( X != Y ) ) ) ) ).

% order_less_le
tff(fact_904_order__le__less,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
            | ( X = Y ) ) ) ) ).

% order_le_less
tff(fact_905_dual__order_Ostrict__implies__order,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ).

% dual_order.strict_implies_order
tff(fact_906_order_Ostrict__implies__order,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% order.strict_implies_order
tff(fact_907_dual__order_Ostrict__iff__not,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
            & ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ) ).

% dual_order.strict_iff_not
tff(fact_908_dual__order_Ostrict__trans2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),A3) ) ) ) ).

% dual_order.strict_trans2
tff(fact_909_dual__order_Ostrict__trans1,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),A3) ) ) ) ).

% dual_order.strict_trans1
tff(fact_910_dual__order_Ostrict__iff__order,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
            & ( A3 != Ba ) ) ) ) ).

% dual_order.strict_iff_order
tff(fact_911_dual__order_Oorder__iff__strict,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
            | ( A3 = Ba ) ) ) ) ).

% dual_order.order_iff_strict
tff(fact_912_dense__le__bounded,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ( ! [W: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),W)
               => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),W),Y)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),W),Z2) ) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ) ).

% dense_le_bounded
tff(fact_913_dense__ge__bounded,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [Z2: B,X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),X)
         => ( ! [W: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),W)
               => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),W),X)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),W) ) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ) ).

% dense_ge_bounded
tff(fact_914_order_Ostrict__iff__not,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
            & ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ) ).

% order.strict_iff_not
tff(fact_915_order_Ostrict__trans2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),C2) ) ) ) ).

% order.strict_trans2
tff(fact_916_order_Ostrict__trans1,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),C2) ) ) ) ).

% order.strict_trans1
tff(fact_917_order_Ostrict__iff__order,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
            & ( A3 != Ba ) ) ) ) ).

% order.strict_iff_order
tff(fact_918_order_Oorder__iff__strict,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
            | ( A3 = Ba ) ) ) ) ).

% order.order_iff_strict
tff(fact_919_not__le__imp__less,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Y: B,X: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y) ) ) ).

% not_le_imp_less
tff(fact_920_less__le__not__le,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
            & ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X) ) ) ) ).

% less_le_not_le
tff(fact_921_dense__le,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [Y: B,Z2: B] :
          ( ! [X2: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Y)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Z2) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ).

% dense_le
tff(fact_922_dense__ge,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [Z2: B,Y: B] :
          ( ! [X2: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),X2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X2) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ).

% dense_ge
tff(fact_923_antisym__conv2,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
          <=> ( X = Y ) ) ) ) ).

% antisym_conv2
tff(fact_924_antisym__conv1,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [X: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
          <=> ( X = Y ) ) ) ) ).

% antisym_conv1
tff(fact_925_nless__le,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
        <=> ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
            | ( A3 = Ba ) ) ) ) ).

% nless_le
tff(fact_926_leI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X) ) ) ).

% leI
tff(fact_927_leD,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Y: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X)
         => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y) ) ) ).

% leD
tff(fact_928_zero__less__iff__neq__zero,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [N: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),N)
        <=> ( N != zero_zero(B) ) ) ) ).

% zero_less_iff_neq_zero
tff(fact_929_gr__implies__not__zero,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [M4: B,N: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),M4),N)
         => ( N != zero_zero(B) ) ) ) ).

% gr_implies_not_zero
tff(fact_930_not__less__zero,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [N: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),N),zero_zero(B)) ) ).

% not_less_zero
tff(fact_931_gr__zeroI,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [N: B] :
          ( ( N != zero_zero(B) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),N) ) ) ).

% gr_zeroI
tff(fact_932_less__numeral__extra_I4_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),one_one(B)) ) ).

% less_numeral_extra(4)
tff(fact_933_diff__strict__right__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),C2)) ) ) ).

% diff_strict_right_mono
tff(fact_934_diff__strict__left__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),A3)),aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),Ba)) ) ) ).

% diff_strict_left_mono
tff(fact_935_diff__eq__diff__less,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),D2) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),D2) ) ) ) ).

% diff_eq_diff_less
tff(fact_936_diff__strict__mono,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B,D2: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),D2),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),D2)) ) ) ) ).

% diff_strict_mono
tff(fact_937_bot_Oextremum__strict,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [A3: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),bot_bot(B)) ) ).

% bot.extremum_strict
tff(fact_938_bot_Onot__eq__extremum,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [A3: B] :
          ( ( A3 != bot_bot(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),bot_bot(B)),A3) ) ) ).

% bot.not_eq_extremum
tff(fact_939_not__psubset__empty,axiom,
    ! [B: $tType,A4: set(B)] : ~ aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A4),bot_bot(set(B))) ).

% not_psubset_empty
tff(fact_940_compl__less__swap2,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),Y)),X)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),X)),Y) ) ) ).

% compl_less_swap2
tff(fact_941_compl__less__swap1,axiom,
    ! [B: $tType] :
      ( boolea8198339166811842893lgebra(B)
     => ! [Y: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(B,B,uminus_uminus(B),X))
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% compl_less_swap1
tff(fact_942_minus__less__iff,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),A3)),Ba)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),Ba)),A3) ) ) ).

% minus_less_iff
tff(fact_943_less__minus__iff,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,uminus_uminus(B),Ba))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,uminus_uminus(B),A3)) ) ) ).

% less_minus_iff
tff(fact_944_top_Onot__eq__extremum,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [A3: B] :
          ( ( A3 != top_top(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),top_top(B)) ) ) ).

% top.not_eq_extremum
tff(fact_945_top_Oextremum__strict,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [A3: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),top_top(B)),A3) ) ).

% top.extremum_strict
tff(fact_946_inf_Ostrict__coboundedI2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),C2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),C2) ) ) ).

% inf.strict_coboundedI2
tff(fact_947_inf_Ostrict__coboundedI1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),C2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),C2) ) ) ).

% inf.strict_coboundedI1
tff(fact_948_inf_Ostrict__order__iff,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
        <=> ( ( A3 = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) )
            & ( A3 != Ba ) ) ) ) ).

% inf.strict_order_iff
tff(fact_949_inf_Ostrict__boundedE,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,aa(B,fun(B,B),inf_inf(B),Ba),C2))
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),C2) ) ) ) ).

% inf.strict_boundedE
tff(fact_950_inf_Oabsorb4,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) = Ba ) ) ) ).

% inf.absorb4
tff(fact_951_inf_Oabsorb3,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba) = A3 ) ) ) ).

% inf.absorb3
tff(fact_952_less__infI2,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Ba: B,X: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),X)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),X) ) ) ).

% less_infI2
tff(fact_953_less__infI1,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A3: B,X: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),X)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),Ba)),X) ) ) ).

% less_infI1
tff(fact_954_less__supI1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ).

% less_supI1
tff(fact_955_less__supI2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ).

% less_supI2
tff(fact_956_sup_Oabsorb3,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) = A3 ) ) ) ).

% sup.absorb3
tff(fact_957_sup_Oabsorb4,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) = Ba ) ) ) ).

% sup.absorb4
tff(fact_958_sup_Ostrict__boundedE,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Ba),C2)),A3)
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),A3) ) ) ) ).

% sup.strict_boundedE
tff(fact_959_sup_Ostrict__order__iff,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
        <=> ( ( A3 = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba) )
            & ( A3 != Ba ) ) ) ) ).

% sup.strict_order_iff
tff(fact_960_sup_Ostrict__coboundedI1,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ).

% sup.strict_coboundedI1
tff(fact_961_sup_Ostrict__coboundedI2,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),Ba)) ) ) ).

% sup.strict_coboundedI2
tff(fact_962_less__fun__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [Fa: fun(B,C),Ga: fun(B,C)] :
          ( aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less(fun(B,C)),Fa),Ga)
        <=> ( aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),Fa),Ga)
            & ~ aa(fun(B,C),$o,aa(fun(B,C),fun(fun(B,C),$o),ord_less_eq(fun(B,C)),Ga),Fa) ) ) ) ).

% less_fun_def
tff(fact_963_inj__on__mult,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A3: B,A4: set(B)] :
          ( ( A3 != zero_zero(B) )
         => inj_on(B,B,aa(B,fun(B,B),times_times(B),A3),A4) ) ) ).

% inj_on_mult
tff(fact_964_comp__inj__on,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(B,C),A4: set(B),Ga: fun(C,D)] :
      ( inj_on(B,C,Fa,A4)
     => ( inj_on(C,D,Ga,aa(set(B),set(C),image2(B,C,Fa),A4))
       => inj_on(B,D,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),Fa),A4) ) ) ).

% comp_inj_on
tff(fact_965_inj__on__imageI,axiom,
    ! [C: $tType,D: $tType,B: $tType,Ga: fun(D,C),Fa: fun(B,D),A4: set(B)] :
      ( inj_on(B,C,aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Ga),Fa),A4)
     => inj_on(D,C,Ga,aa(set(B),set(D),image2(B,D,Fa),A4)) ) ).

% inj_on_imageI
tff(fact_966_comp__inj__on__iff,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(B,C),A4: set(B),F9: fun(C,D)] :
      ( inj_on(B,C,Fa,A4)
     => ( inj_on(C,D,F9,aa(set(B),set(C),image2(B,C,Fa),A4))
      <=> inj_on(B,D,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),F9),Fa),A4) ) ) ).

% comp_inj_on_iff
tff(fact_967_inj__compose,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(B,C),Ga: fun(D,B)] :
      ( inj_on(B,C,Fa,top_top(set(B)))
     => ( inj_on(D,B,Ga,top_top(set(D)))
       => inj_on(D,C,aa(fun(D,B),fun(D,C),aa(fun(B,C),fun(fun(D,B),fun(D,C)),comp(B,C,D),Fa),Ga),top_top(set(D))) ) ) ).

% inj_compose
tff(fact_968_mult__neg__neg,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ) ).

% mult_neg_neg
tff(fact_969_not__square__less__zero,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [A3: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),A3)),zero_zero(B)) ) ).

% not_square_less_zero
tff(fact_970_mult__less__0__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),zero_zero(B))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),zero_zero(B)) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba) ) ) ) ) ).

% mult_less_0_iff
tff(fact_971_mult__neg__pos,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),zero_zero(B)) ) ) ) ).

% mult_neg_pos
tff(fact_972_mult__pos__neg,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),zero_zero(B)) ) ) ) ).

% mult_pos_neg
tff(fact_973_mult__pos__pos,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ) ).

% mult_pos_pos
tff(fact_974_mult__pos__neg2,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3)),zero_zero(B)) ) ) ) ).

% mult_pos_neg2
tff(fact_975_zero__less__mult__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),zero_zero(B)) ) ) ) ) ).

% zero_less_mult_iff
tff(fact_976_zero__less__mult__pos,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba) ) ) ) ).

% zero_less_mult_pos
tff(fact_977_zero__less__mult__pos2,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba) ) ) ) ).

% zero_less_mult_pos2
tff(fact_978_mult__less__cancel__left__neg,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ) ).

% mult_less_cancel_left_neg
tff(fact_979_mult__less__cancel__left__pos,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ) ).

% mult_less_cancel_left_pos
tff(fact_980_mult__strict__left__mono__neg,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ) ).

% mult_strict_left_mono_neg
tff(fact_981_mult__strict__left__mono,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ) ).

% mult_strict_left_mono
tff(fact_982_mult__less__cancel__left__disj,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ) ) ).

% mult_less_cancel_left_disj
tff(fact_983_mult__strict__right__mono__neg,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ) ).

% mult_strict_right_mono_neg
tff(fact_984_mult__strict__right__mono,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ) ).

% mult_strict_right_mono
tff(fact_985_mult__less__cancel__right__disj,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ) ) ).

% mult_less_cancel_right_disj
tff(fact_986_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [B: $tType] :
      ( linord2810124833399127020strict(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
tff(fact_987_not__one__less__zero,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),zero_zero(B)) ) ).

% not_one_less_zero
tff(fact_988_zero__less__one,axiom,
    ! [B: $tType] :
      ( zero_less_one(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),one_one(B)) ) ).

% zero_less_one
tff(fact_989_less__numeral__extra_I1_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),one_one(B)) ) ).

% less_numeral_extra(1)
tff(fact_990_less__iff__diff__less__0,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),zero_zero(B)) ) ) ).

% less_iff_diff_less_0
tff(fact_991_less__1__mult,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [M4: B,N: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),M4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),M4),N)) ) ) ) ).

% less_1_mult
tff(fact_992_less__minus__one__simps_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),one_one(B))),one_one(B)) ) ).

% less_minus_one_simps(2)
tff(fact_993_less__minus__one__simps_I4_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% less_minus_one_simps(4)
tff(fact_994_less__assn__def,axiom,
    ! [A3: assn,Ba: assn] :
      ( aa(assn,$o,aa(assn,fun(assn,$o),ord_less(assn),A3),Ba)
    <=> ( aa(assn,$o,aa(assn,fun(assn,$o),ord_less_eq(assn),A3),Ba)
        & ( A3 != Ba ) ) ) ).

% less_assn_def
tff(fact_995_inj__on__image__Int,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),C3: set(B),A4: set(B),B2: set(B)] :
      ( inj_on(B,C,Fa,C3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),C3)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),C3)
         => ( aa(set(B),set(C),image2(B,C,Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),image2(B,C,Fa),A4)),aa(set(B),set(C),image2(B,C,Fa),B2)) ) ) ) ) ).

% inj_on_image_Int
tff(fact_996_image__Int,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),A4: set(B),B2: set(B)] :
      ( inj_on(B,C,Fa,top_top(set(B)))
     => ( aa(set(B),set(C),image2(B,C,Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),image2(B,C,Fa),A4)),aa(set(B),set(C),image2(B,C,Fa),B2)) ) ) ).

% image_Int
tff(fact_997_mult__less__le__imp__less,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),D2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),D2)) ) ) ) ) ) ).

% mult_less_le_imp_less
tff(fact_998_mult__le__less__imp__less,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),D2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),D2)) ) ) ) ) ) ).

% mult_le_less_imp_less
tff(fact_999_mult__right__le__imp__le,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ) ).

% mult_right_le_imp_le
tff(fact_1000_mult__left__le__imp__le,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ) ).

% mult_left_le_imp_le
tff(fact_1001_mult__le__cancel__left__pos,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ) ).

% mult_le_cancel_left_pos
tff(fact_1002_mult__le__cancel__left__neg,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ) ).

% mult_le_cancel_left_neg
tff(fact_1003_mult__less__cancel__right,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ) ) ).

% mult_less_cancel_right
tff(fact_1004_mult__strict__mono_H,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),D2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),D2)) ) ) ) ) ) ).

% mult_strict_mono'
tff(fact_1005_mult__right__less__imp__less,axiom,
    ! [B: $tType] :
      ( linordered_semiring(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ) ).

% mult_right_less_imp_less
tff(fact_1006_mult__less__cancel__left,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ) ) ).

% mult_less_cancel_left
tff(fact_1007_mult__strict__mono,axiom,
    ! [B: $tType] :
      ( linord8928482502909563296strict(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),D2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),D2)) ) ) ) ) ) ).

% mult_strict_mono
tff(fact_1008_mult__left__less__imp__less,axiom,
    ! [B: $tType] :
      ( linordered_semiring(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ) ).

% mult_left_less_imp_less
tff(fact_1009_mult__le__cancel__right,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ) ) ).

% mult_le_cancel_right
tff(fact_1010_mult__le__cancel__left,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ) ) ).

% mult_le_cancel_left
tff(fact_1011_less__minus__one__simps_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),one_one(B))),zero_zero(B)) ) ).

% less_minus_one_simps(1)
tff(fact_1012_less__minus__one__simps_I3_J,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% less_minus_one_simps(3)
tff(fact_1013_disjoint__alt__simp3,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)),A4)
    <=> ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) != bot_bot(set(B)) ) ) ).

% disjoint_alt_simp3
tff(fact_1014_inj__mult__left,axiom,
    ! [B: $tType] :
      ( idom(B)
     => ! [A3: B] :
          ( inj_on(B,B,aa(B,fun(B,B),times_times(B),A3),top_top(set(B)))
        <=> ( A3 != zero_zero(B) ) ) ) ).

% inj_mult_left
tff(fact_1015_field__le__mult__one__interval,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X: B,Y: B] :
          ( ! [Z3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Z3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z3),one_one(B))
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Z3),X)),Y) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y) ) ) ).

% field_le_mult_one_interval
tff(fact_1016_inj__on__iff__surj,axiom,
    ! [C: $tType,B: $tType,A4: set(B),A10: set(C)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( ? [F10: fun(B,C)] :
            ( inj_on(B,C,F10,A4)
            & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,F10),A4)),A10) )
      <=> ? [G4: fun(C,B)] : ( aa(set(C),set(B),image2(C,B,G4),A10) = A4 ) ) ) ).

% inj_on_iff_surj
tff(fact_1017_mult__le__cancel__iff1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: B,X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Z2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y) ) ) ) ).

% mult_le_cancel_iff1
tff(fact_1018_mult__le__cancel__iff2,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: B,X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Z2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),X)),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y) ) ) ) ).

% mult_le_cancel_iff2
tff(fact_1019_mult__less__iff1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: B,X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Z2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y) ) ) ) ).

% mult_less_iff1
tff(fact_1020_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => semila1105856199041335345_order(B,inf_inf(B),top_top(B),ord_less_eq(B),ord_less(B)) ) ).

% inf_top.semilattice_neutr_order_axioms
tff(fact_1021_the__inv__f__o__f__id,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),Z2: B] :
      ( inj_on(B,C,Fa,top_top(set(B)))
     => ( aa(B,B,aa(fun(B,C),fun(B,B),aa(fun(C,B),fun(fun(B,C),fun(B,B)),comp(C,B,B),the_inv_into(B,C,top_top(set(B)),Fa)),Fa),Z2) = aa(B,B,id(B),Z2) ) ) ).

% the_inv_f_o_f_id
tff(fact_1022_sgn__neg,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
         => ( aa(B,B,sgn_sgn(B),A3) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ) ).

% sgn_neg
tff(fact_1023_sgn__1,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ( aa(B,B,sgn_sgn(B),one_one(B)) = one_one(B) ) ) ).

% sgn_1
tff(fact_1024_sgn__pos,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,B,sgn_sgn(B),A3) = one_one(B) ) ) ) ).

% sgn_pos
tff(fact_1025_semilattice__neutr__order_Oeq__neutr__iff,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semila1105856199041335345_order(B,Fa,Z2,Less_eq,Less)
     => ( ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = Z2 )
      <=> ( ( A3 = Z2 )
          & ( Ba = Z2 ) ) ) ) ).

% semilattice_neutr_order.eq_neutr_iff
tff(fact_1026_semilattice__neutr__order_Oneutr__eq__iff,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semila1105856199041335345_order(B,Fa,Z2,Less_eq,Less)
     => ( ( Z2 = aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) )
      <=> ( ( A3 = Z2 )
          & ( Ba = Z2 ) ) ) ) ).

% semilattice_neutr_order.neutr_eq_iff
tff(fact_1027_sgn__mult,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,sgn_sgn(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,sgn_sgn(B),A3)),aa(B,B,sgn_sgn(B),Ba)) ) ) ).

% sgn_mult
tff(fact_1028_sgn__minus__1,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ( aa(B,B,sgn_sgn(B),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% sgn_minus_1
tff(fact_1029_semilattice__neutr__order_Oaxioms_I1_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semila1105856199041335345_order(B,Fa,Z2,Less_eq,Less)
     => semilattice_neutr(B,Fa,Z2) ) ).

% semilattice_neutr_order.axioms(1)
tff(fact_1030_sgn__1__pos,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B] :
          ( ( aa(B,B,sgn_sgn(B),A3) = one_one(B) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3) ) ) ).

% sgn_1_pos
tff(fact_1031_sgn__1__neg,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B] :
          ( ( aa(B,B,sgn_sgn(B),A3) = aa(B,B,uminus_uminus(B),one_one(B)) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B)) ) ) ).

% sgn_1_neg
tff(fact_1032_sgn__if,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B] :
          ( aa(B,B,sgn_sgn(B),X)
          = $ite(
              X = zero_zero(B),
              zero_zero(B),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),X),one_one(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ) ) ).

% sgn_if
tff(fact_1033_the__inv__into__comp,axiom,
    ! [B: $tType,D: $tType,C: $tType,Fa: fun(B,C),Ga: fun(D,B),A4: set(D),X: C] :
      ( inj_on(B,C,Fa,aa(set(D),set(B),image2(D,B,Ga),A4))
     => ( inj_on(D,B,Ga,A4)
       => ( member(C,X,aa(set(B),set(C),image2(B,C,Fa),aa(set(D),set(B),image2(D,B,Ga),A4)))
         => ( aa(C,D,the_inv_into(D,C,A4,aa(fun(D,B),fun(D,C),aa(fun(B,C),fun(fun(D,B),fun(D,C)),comp(B,C,D),Fa),Ga)),X) = aa(C,D,aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),the_inv_into(D,B,A4,Ga)),the_inv_into(B,C,aa(set(D),set(B),image2(D,B,Ga),A4),Fa)),X) ) ) ) ) ).

% the_inv_into_comp
tff(fact_1034_top_Oordering__top__axioms,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ordering_top(B,ord_less_eq(B),ord_less(B),top_top(B)) ) ).

% top.ordering_top_axioms
tff(fact_1035_inj__on__insert,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),A3: B,A4: set(B)] :
      ( inj_on(B,C,Fa,aa(set(B),set(B),insert2(B,A3),A4))
    <=> ( inj_on(B,C,Fa,A4)
        & ~ member(C,aa(B,C,Fa,A3),aa(set(B),set(C),image2(B,C,Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) ) ).

% inj_on_insert
tff(fact_1036_convex__bound__lt,axiom,
    ! [B: $tType] :
      ( linord715952674999750819strict(B)
     => ! [X: B,A3: B,Y: B,U: B,V: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),A3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),U)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),V)
               => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),U),V) = one_one(B) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),U),X)),aa(B,B,aa(B,fun(B,B),times_times(B),V),Y))),A3) ) ) ) ) ) ) ).

% convex_bound_lt
tff(fact_1037_pos__minus__divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2))),A3)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ) ).

% pos_minus_divide_le_eq
tff(fact_1038_pos__le__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2)))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,uminus_uminus(B),Ba)) ) ) ) ).

% pos_le_minus_divide_eq
tff(fact_1039_neg__minus__divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2))),A3)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,uminus_uminus(B),Ba)) ) ) ) ).

% neg_minus_divide_le_eq
tff(fact_1040_neg__le__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2)))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ) ).

% neg_le_minus_divide_eq
tff(fact_1041_minus__divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2))),A3)
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,uminus_uminus(B),Ba)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)) ) ) ) ).

% minus_divide_le_eq
tff(fact_1042_le__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2)))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,uminus_uminus(B),Ba)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))) ) ) ) ).

% le_minus_divide_eq
tff(fact_1043_add__right__cancel,axiom,
    ! [B: $tType] :
      ( cancel_semigroup_add(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3) )
        <=> ( Ba = C2 ) ) ) ).

% add_right_cancel
tff(fact_1044_add__left__cancel,axiom,
    ! [B: $tType] :
      ( cancel_semigroup_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2) )
        <=> ( Ba = C2 ) ) ) ).

% add_left_cancel
tff(fact_1045_add__le__cancel__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% add_le_cancel_right
tff(fact_1046_add__le__cancel__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% add_le_cancel_left
tff(fact_1047_add__0,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),zero_zero(B)),A3) = A3 ) ) ).

% add_0
tff(fact_1048_zero__eq__add__iff__both__eq__0,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [X: B,Y: B] :
          ( ( zero_zero(B) = aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y) )
        <=> ( ( X = zero_zero(B) )
            & ( Y = zero_zero(B) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
tff(fact_1049_add__eq__0__iff__both__eq__0,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y) = zero_zero(B) )
        <=> ( ( X = zero_zero(B) )
            & ( Y = zero_zero(B) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
tff(fact_1050_add__cancel__right__right,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) )
        <=> ( Ba = zero_zero(B) ) ) ) ).

% add_cancel_right_right
tff(fact_1051_add__cancel__right__left,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3) )
        <=> ( Ba = zero_zero(B) ) ) ) ).

% add_cancel_right_left
tff(fact_1052_add__cancel__left__right,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = A3 )
        <=> ( Ba = zero_zero(B) ) ) ) ).

% add_cancel_left_right
tff(fact_1053_add__cancel__left__left,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [Ba: B,A3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3) = A3 )
        <=> ( Ba = zero_zero(B) ) ) ) ).

% add_cancel_left_left
tff(fact_1054_double__zero__sym,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( ( zero_zero(B) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),A3) )
        <=> ( A3 = zero_zero(B) ) ) ) ).

% double_zero_sym
tff(fact_1055_add_Oright__neutral,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),zero_zero(B)) = A3 ) ) ).

% add.right_neutral
tff(fact_1056_add__less__cancel__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ).

% add_less_cancel_right
tff(fact_1057_add__less__cancel__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ).

% add_less_cancel_left
tff(fact_1058_add__diff__cancel__right_H,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),Ba) = A3 ) ) ).

% add_diff_cancel_right'
tff(fact_1059_add__diff__cancel__right,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [A3: B,C2: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba) ) ) ).

% add_diff_cancel_right
tff(fact_1060_add__diff__cancel__left_H,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),A3) = Ba ) ) ).

% add_diff_cancel_left'
tff(fact_1061_add__diff__cancel__left,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [C2: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba) ) ) ).

% add_diff_cancel_left
tff(fact_1062_diff__add__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),Ba) = A3 ) ) ).

% diff_add_cancel
tff(fact_1063_add__diff__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),Ba) = A3 ) ) ).

% add_diff_cancel
tff(fact_1064_minus__add__distrib,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A3)),aa(B,B,uminus_uminus(B),Ba)) ) ) ).

% minus_add_distrib
tff(fact_1065_minus__add__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) = Ba ) ) ).

% minus_add_cancel
tff(fact_1066_add__minus__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A3)),Ba)) = Ba ) ) ).

% add_minus_cancel
tff(fact_1067_times__divide__eq__left,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Ba: B,C2: B,A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,Ba,C2)),A3) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3),C2) ) ) ).

% times_divide_eq_left
tff(fact_1068_divide__divide__eq__left,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B,Ba: B,C2: B] : ( divide_divide(B,divide_divide(B,A3,Ba),C2) = divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ).

% divide_divide_eq_left
tff(fact_1069_divide__divide__eq__right,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B,Ba: B,C2: B] : ( divide_divide(B,A3,divide_divide(B,Ba,C2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),Ba) ) ) ).

% divide_divide_eq_right
tff(fact_1070_times__divide__eq__right,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),divide_divide(B,Ba,C2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2) ) ) ).

% times_divide_eq_right
tff(fact_1071_div__by__1,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A3: B] : ( divide_divide(B,A3,one_one(B)) = A3 ) ) ).

% div_by_1
tff(fact_1072_singletonI,axiom,
    ! [B: $tType,A3: B] : member(B,A3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) ).

% singletonI
tff(fact_1073_Int__insert__left__if0,axiom,
    ! [B: $tType,A3: B,C3: set(B),B2: set(B)] :
      ( ~ member(B,A3,C3)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert2(B,A3),B2)),C3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3) ) ) ).

% Int_insert_left_if0
tff(fact_1074_Int__insert__left__if1,axiom,
    ! [B: $tType,A3: B,C3: set(B),B2: set(B)] :
      ( member(B,A3,C3)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert2(B,A3),B2)),C3) = aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3)) ) ) ).

% Int_insert_left_if1
tff(fact_1075_insert__inter__insert,axiom,
    ! [B: $tType,A3: B,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert2(B,A3),A4)),aa(set(B),set(B),insert2(B,A3),B2)) = aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ).

% insert_inter_insert
tff(fact_1076_Int__insert__right__if0,axiom,
    ! [B: $tType,A3: B,A4: set(B),B2: set(B)] :
      ( ~ member(B,A3,A4)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),insert2(B,A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) ) ) ).

% Int_insert_right_if0
tff(fact_1077_Int__insert__right__if1,axiom,
    ! [B: $tType,A3: B,A4: set(B),B2: set(B)] :
      ( member(B,A3,A4)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),insert2(B,A3),B2)) = aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ) ).

% Int_insert_right_if1
tff(fact_1078_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
tff(fact_1079_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),A3)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B)) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
tff(fact_1080_le__add__same__cancel2,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba) ) ) ).

% le_add_same_cancel2
tff(fact_1081_le__add__same__cancel1,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba) ) ) ).

% le_add_same_cancel1
tff(fact_1082_add__le__same__cancel2,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),Ba)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B)) ) ) ).

% add_le_same_cancel2
tff(fact_1083_add__le__same__cancel1,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3)),Ba)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B)) ) ) ).

% add_le_same_cancel1
tff(fact_1084_add__less__same__cancel1,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3)),Ba)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B)) ) ) ).

% add_less_same_cancel1
tff(fact_1085_add__less__same__cancel2,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),Ba)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B)) ) ) ).

% add_less_same_cancel2
tff(fact_1086_less__add__same__cancel1,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba) ) ) ).

% less_add_same_cancel1
tff(fact_1087_less__add__same__cancel2,axiom,
    ! [B: $tType] :
      ( ordere1937475149494474687imp_le(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba) ) ) ).

% less_add_same_cancel2
tff(fact_1088_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),A3)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B)) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
tff(fact_1089_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
tff(fact_1090_diff__add__zero,axiom,
    ! [B: $tType] :
      ( comm_monoid_diff(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) = zero_zero(B) ) ) ).

% diff_add_zero
tff(fact_1091_ab__left__minus,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A3)),A3) = zero_zero(B) ) ) ).

% ab_left_minus
tff(fact_1092_add_Oright__inverse,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,uminus_uminus(B),A3)) = zero_zero(B) ) ) ).

% add.right_inverse
tff(fact_1093_nonzero__mult__div__cancel__left,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),A3) = Ba ) ) ) ).

% nonzero_mult_div_cancel_left
tff(fact_1094_nonzero__mult__div__cancel__right,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [Ba: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),Ba) = A3 ) ) ) ).

% nonzero_mult_div_cancel_right
tff(fact_1095_mult__divide__mult__cancel__left__if,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
          = $ite(C2 = zero_zero(B),zero_zero(B),divide_divide(B,A3,Ba)) ) ) ).

% mult_divide_mult_cancel_left_if
tff(fact_1096_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( C2 != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) = divide_divide(B,A3,Ba) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
tff(fact_1097_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( C2 != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = divide_divide(B,A3,Ba) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
tff(fact_1098_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( C2 != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = divide_divide(B,A3,Ba) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
tff(fact_1099_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( C2 != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) = divide_divide(B,A3,Ba) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
tff(fact_1100_div__self,axiom,
    ! [B: $tType] :
      ( semidom_divide(B)
     => ! [A3: B] :
          ( ( A3 != zero_zero(B) )
         => ( divide_divide(B,A3,A3) = one_one(B) ) ) ) ).

% div_self
tff(fact_1101_zero__eq__1__divide__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B] :
          ( ( zero_zero(B) = divide_divide(B,one_one(B),A3) )
        <=> ( A3 = zero_zero(B) ) ) ) ).

% zero_eq_1_divide_iff
tff(fact_1102_one__divide__eq__0__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B] :
          ( ( divide_divide(B,one_one(B),A3) = zero_zero(B) )
        <=> ( A3 = zero_zero(B) ) ) ) ).

% one_divide_eq_0_iff
tff(fact_1103_eq__divide__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,A3: B] :
          ( ( one_one(B) = divide_divide(B,Ba,A3) )
        <=> ( ( A3 != zero_zero(B) )
            & ( A3 = Ba ) ) ) ) ).

% eq_divide_eq_1
tff(fact_1104_divide__eq__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,A3: B] :
          ( ( divide_divide(B,Ba,A3) = one_one(B) )
        <=> ( ( A3 != zero_zero(B) )
            & ( A3 = Ba ) ) ) ) ).

% divide_eq_eq_1
tff(fact_1105_divide__self__if,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B] :
          ( divide_divide(B,A3,A3)
          = $ite(A3 = zero_zero(B),zero_zero(B),one_one(B)) ) ) ).

% divide_self_if
tff(fact_1106_divide__self,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B] :
          ( ( A3 != zero_zero(B) )
         => ( divide_divide(B,A3,A3) = one_one(B) ) ) ) ).

% divide_self
tff(fact_1107_one__eq__divide__iff,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B,Ba: B] :
          ( ( one_one(B) = divide_divide(B,A3,Ba) )
        <=> ( ( Ba != zero_zero(B) )
            & ( A3 = Ba ) ) ) ) ).

% one_eq_divide_iff
tff(fact_1108_divide__eq__1__iff,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B,Ba: B] :
          ( ( divide_divide(B,A3,Ba) = one_one(B) )
        <=> ( ( Ba != zero_zero(B) )
            & ( A3 = Ba ) ) ) ) ).

% divide_eq_1_iff
tff(fact_1109_uminus__add__conv__diff,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A3)),Ba) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3) ) ) ).

% uminus_add_conv_diff
tff(fact_1110_diff__minus__eq__add,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(B,B,uminus_uminus(B),Ba)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) ) ) ).

% diff_minus_eq_add
tff(fact_1111_divide__minus1,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X: B] : ( divide_divide(B,X,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),X) ) ) ).

% divide_minus1
tff(fact_1112_singleton__insert__inj__eq,axiom,
    ! [B: $tType,Ba: B,A3: B,A4: set(B)] :
      ( ( aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))) = aa(set(B),set(B),insert2(B,A3),A4) )
    <=> ( ( A3 = Ba )
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))) ) ) ).

% singleton_insert_inj_eq
tff(fact_1113_singleton__insert__inj__eq_H,axiom,
    ! [B: $tType,A3: B,A4: set(B),Ba: B] :
      ( ( aa(set(B),set(B),insert2(B,A3),A4) = aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))) )
    <=> ( ( A3 = Ba )
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))) ) ) ).

% singleton_insert_inj_eq'
tff(fact_1114_disjoint__insert_I2_J,axiom,
    ! [B: $tType,A4: set(B),Ba: B,B2: set(B)] :
      ( ( bot_bot(set(B)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),insert2(B,Ba),B2)) )
    <=> ( ~ member(B,Ba,A4)
        & ( bot_bot(set(B)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) ) ) ) ).

% disjoint_insert(2)
tff(fact_1115_disjoint__insert_I1_J,axiom,
    ! [B: $tType,B2: set(B),A3: B,A4: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),aa(set(B),set(B),insert2(B,A3),A4)) = bot_bot(set(B)) )
    <=> ( ~ member(B,A3,B2)
        & ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),A4) = bot_bot(set(B)) ) ) ) ).

% disjoint_insert(1)
tff(fact_1116_insert__disjoint_I2_J,axiom,
    ! [B: $tType,A3: B,A4: set(B),B2: set(B)] :
      ( ( bot_bot(set(B)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert2(B,A3),A4)),B2) )
    <=> ( ~ member(B,A3,B2)
        & ( bot_bot(set(B)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) ) ) ) ).

% insert_disjoint(2)
tff(fact_1117_insert__disjoint_I1_J,axiom,
    ! [B: $tType,A3: B,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert2(B,A3),A4)),B2) = bot_bot(set(B)) )
    <=> ( ~ member(B,A3,B2)
        & ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) ) ) ) ).

% insert_disjoint(1)
tff(fact_1118_insert__Diff__single,axiom,
    ! [B: $tType,A3: B,A4: set(B)] : ( aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) = aa(set(B),set(B),insert2(B,A3),A4) ) ).

% insert_Diff_single
tff(fact_1119_divide__sgn,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] : ( divide_divide(B,A3,aa(B,B,sgn_sgn(B),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,sgn_sgn(B),Ba)) ) ) ).

% divide_sgn
tff(fact_1120_the__elem__eq,axiom,
    ! [B: $tType,X: B] : ( the_elem(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = X ) ).

% the_elem_eq
tff(fact_1121_zero__le__divide__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),divide_divide(B,one_one(B),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3) ) ) ).

% zero_le_divide_1_iff
tff(fact_1122_divide__le__0__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,one_one(B),A3)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B)) ) ) ).

% divide_le_0_1_iff
tff(fact_1123_zero__less__divide__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),divide_divide(B,one_one(B),A3))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3) ) ) ).

% zero_less_divide_1_iff
tff(fact_1124_less__divide__eq__1__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),divide_divide(B,Ba,A3))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ) ).

% less_divide_eq_1_pos
tff(fact_1125_less__divide__eq__1__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),divide_divide(B,Ba,A3))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ) ).

% less_divide_eq_1_neg
tff(fact_1126_divide__less__eq__1__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,Ba,A3)),one_one(B))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ) ).

% divide_less_eq_1_pos
tff(fact_1127_divide__less__eq__1__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,Ba,A3)),one_one(B))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ) ).

% divide_less_eq_1_neg
tff(fact_1128_divide__less__0__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,one_one(B),A3)),zero_zero(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B)) ) ) ).

% divide_less_0_1_iff
tff(fact_1129_add__neg__numeral__special_I7_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,uminus_uminus(B),one_one(B))) = zero_zero(B) ) ) ).

% add_neg_numeral_special(7)
tff(fact_1130_add__neg__numeral__special_I8_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),one_one(B))),one_one(B)) = zero_zero(B) ) ) ).

% add_neg_numeral_special(8)
tff(fact_1131_nonzero__divide__mult__cancel__left,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = divide_divide(B,one_one(B),Ba) ) ) ) ).

% nonzero_divide_mult_cancel_left
tff(fact_1132_nonzero__divide__mult__cancel__right,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Ba: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => ( divide_divide(B,Ba,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = divide_divide(B,one_one(B),A3) ) ) ) ).

% nonzero_divide_mult_cancel_right
tff(fact_1133_subset__Compl__singleton,axiom,
    ! [B: $tType,A4: set(B),Ba: B] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))))
    <=> ~ member(B,Ba,A4) ) ).

% subset_Compl_singleton
tff(fact_1134_divide__le__eq__1__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,Ba,A3)),one_one(B))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ) ).

% divide_le_eq_1_neg
tff(fact_1135_divide__le__eq__1__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,Ba,A3)),one_one(B))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ) ).

% divide_le_eq_1_pos
tff(fact_1136_le__divide__eq__1__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),divide_divide(B,Ba,A3))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ) ).

% le_divide_eq_1_neg
tff(fact_1137_le__divide__eq__1__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),divide_divide(B,Ba,A3))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ) ).

% le_divide_eq_1_pos
tff(fact_1138_add__right__imp__eq,axiom,
    ! [B: $tType] :
      ( cancel_semigroup_add(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3) )
         => ( Ba = C2 ) ) ) ).

% add_right_imp_eq
tff(fact_1139_add__left__imp__eq,axiom,
    ! [B: $tType] :
      ( cancel_semigroup_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2) )
         => ( Ba = C2 ) ) ) ).

% add_left_imp_eq
tff(fact_1140_ab__semigroup__add__class_Oadd_Oleft__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => ! [Ba: B,A3: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) ) ) ).

% ab_semigroup_add_class.add.left_commute
tff(fact_1141_ab__semigroup__add__class_Oadd_Ocommute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3) ) ) ).

% ab_semigroup_add_class.add.commute
tff(fact_1142_add_Oright__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3) )
        <=> ( Ba = C2 ) ) ) ).

% add.right_cancel
tff(fact_1143_add_Oleft__cancel,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2) )
        <=> ( Ba = C2 ) ) ) ).

% add.left_cancel
tff(fact_1144_add_Oassoc,axiom,
    ! [B: $tType] :
      ( semigroup_add(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) ) ) ).

% add.assoc
tff(fact_1145_group__cancel_Oadd2,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [B2: B,K: B,Ba: B,A3: B] :
          ( ( B2 = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),Ba) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) ) ) ) ).

% group_cancel.add2
tff(fact_1146_group__cancel_Oadd1,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [A4: B,K: B,A3: B,Ba: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),A3) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A4),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) ) ) ) ).

% group_cancel.add1
tff(fact_1147_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [I: B,J2: B,K: B,L: B] :
          ( ( ( I = J2 )
            & ( K = L ) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),I),K) = aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
tff(fact_1148_add_Oright__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),Ba) ) ) ).

% add.right_commute
tff(fact_1149_add_Oright__assoc,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) ) ) ).

% add.right_assoc
tff(fact_1150_ordering__top_Oextremum__uniqueI,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B,A3: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Top),A3)
       => ( A3 = Top ) ) ) ).

% ordering_top.extremum_uniqueI
tff(fact_1151_ordering__top_Onot__eq__extremum,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B,A3: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ( ( A3 != Top )
      <=> aa(B,$o,aa(B,fun(B,$o),Less,A3),Top) ) ) ).

% ordering_top.not_eq_extremum
tff(fact_1152_ordering__top_Oextremum__unique,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B,A3: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Top),A3)
      <=> ( A3 = Top ) ) ) ).

% ordering_top.extremum_unique
tff(fact_1153_ordering__top_Oextremum__strict,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B,A3: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ~ aa(B,$o,aa(B,fun(B,$o),Less,Top),A3) ) ).

% ordering_top.extremum_strict
tff(fact_1154_ordering__top_Oextremum,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B,A3: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Top) ) ).

% ordering_top.extremum
tff(fact_1155_add__divide__eq__if__simps_I2_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Z2: B,Ba: B] :
          ( aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,A3,Z2)),Ba)
          = $ite(Z2 = zero_zero(B),Ba,divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),Z2)),Z2)) ) ) ).

% add_divide_eq_if_simps(2)
tff(fact_1156_add__divide__eq__if__simps_I1_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B,Z2: B] :
          ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),divide_divide(B,Ba,Z2))
          = $ite(Z2 = zero_zero(B),A3,divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Z2)),Ba),Z2)) ) ) ).

% add_divide_eq_if_simps(1)
tff(fact_1157_add__frac__eq,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Y: B,Z2: B,X: B,W2: B] :
          ( ( Y != zero_zero(B) )
         => ( ( Z2 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,X,Y)),divide_divide(B,W2,Z2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2)) ) ) ) ) ).

% add_frac_eq
tff(fact_1158_add__frac__num,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Y: B,X: B,Z2: B] :
          ( ( Y != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,X,Y)),Z2) = divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y)),Y) ) ) ) ).

% add_frac_num
tff(fact_1159_add__num__frac,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Y: B,Z2: B,X: B] :
          ( ( Y != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),divide_divide(B,X,Y)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y)),Y) ) ) ) ).

% add_num_frac
tff(fact_1160_add__divide__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X),divide_divide(B,Y,Z2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2)),Y),Z2) ) ) ) ).

% add_divide_eq_iff
tff(fact_1161_divide__add__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,X,Z2)),Y) = divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2)),Z2) ) ) ) ).

% divide_add_eq_iff
tff(fact_1162_less__half__sum,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),one_one(B)))) ) ) ).

% less_half_sum
tff(fact_1163_gt__half__sum,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),one_one(B)))),Ba) ) ) ).

% gt_half_sum
tff(fact_1164_add__le__imp__le__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% add_le_imp_le_right
tff(fact_1165_add__le__imp__le__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% add_le_imp_le_left
tff(fact_1166_le__iff__add,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
        <=> ? [C5: B] : ( Ba = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C5) ) ) ) ).

% le_iff_add
tff(fact_1167_add__right__mono,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) ) ) ).

% add_right_mono
tff(fact_1168_less__eqE,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ~ ! [C4: B] : ( Ba != aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C4) ) ) ) ).

% less_eqE
tff(fact_1169_add__left__mono,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba)) ) ) ).

% add_left_mono
tff(fact_1170_add__mono,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),D2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),D2)) ) ) ) ).

% add_mono
tff(fact_1171_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [I: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),I),J2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(1)
tff(fact_1172_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [I: B,J2: B,K: B,L: B] :
          ( ( ( I = J2 )
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(2)
tff(fact_1173_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [I: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),I),J2)
            & ( K = L ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_semiring(3)
tff(fact_1174_add_Ogroup__left__neutral,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),zero_zero(B)),A3) = A3 ) ) ).

% add.group_left_neutral
tff(fact_1175_add_Ocomm__neutral,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),zero_zero(B)) = A3 ) ) ).

% add.comm_neutral
tff(fact_1176_comm__monoid__add__class_Oadd__0,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),zero_zero(B)),A3) = A3 ) ) ).

% comm_monoid_add_class.add_0
tff(fact_1177_times__divide__times__eq,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X: B,Y: B,Z2: B,W2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,X,Y)),divide_divide(B,Z2,W2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2),aa(B,B,aa(B,fun(B,B),times_times(B),Y),W2)) ) ) ).

% times_divide_times_eq
tff(fact_1178_divide__divide__times__eq,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X: B,Y: B,Z2: B,W2: B] : ( divide_divide(B,divide_divide(B,X,Y),divide_divide(B,Z2,W2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),X),W2),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2)) ) ) ).

% divide_divide_times_eq
tff(fact_1179_divide__divide__eq__left_H,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B,C2: B] : ( divide_divide(B,divide_divide(B,A3,Ba),C2) = divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ).

% divide_divide_eq_left'
tff(fact_1180_add__less__imp__less__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2))
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ).

% add_less_imp_less_right
tff(fact_1181_add__less__imp__less__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba))
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ).

% add_less_imp_less_left
tff(fact_1182_add__strict__right__mono,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) ) ) ).

% add_strict_right_mono
tff(fact_1183_add__strict__left__mono,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba)) ) ) ).

% add_strict_left_mono
tff(fact_1184_add__strict__mono,axiom,
    ! [B: $tType] :
      ( strict9044650504122735259up_add(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),D2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),D2)) ) ) ) ).

% add_strict_mono
tff(fact_1185_add__mono__thms__linordered__field_I1_J,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [I: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),I),J2)
            & ( K = L ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_field(1)
tff(fact_1186_add__mono__thms__linordered__field_I2_J,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [I: B,J2: B,K: B,L: B] :
          ( ( ( I = J2 )
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_field(2)
tff(fact_1187_add__mono__thms__linordered__field_I5_J,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [I: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),I),J2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_field(5)
tff(fact_1188_singleton__inject,axiom,
    ! [B: $tType,A3: B,Ba: B] :
      ( ( aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))) = aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))) )
     => ( A3 = Ba ) ) ).

% singleton_inject
tff(fact_1189_insert__not__empty,axiom,
    ! [B: $tType,A3: B,A4: set(B)] : ( aa(set(B),set(B),insert2(B,A3),A4) != bot_bot(set(B)) ) ).

% insert_not_empty
tff(fact_1190_doubleton__eq__iff,axiom,
    ! [B: $tType,A3: B,Ba: B,C2: B,D2: B] :
      ( ( aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))) = aa(set(B),set(B),insert2(B,C2),aa(set(B),set(B),insert2(B,D2),bot_bot(set(B)))) )
    <=> ( ( ( A3 = C2 )
          & ( Ba = D2 ) )
        | ( ( A3 = D2 )
          & ( Ba = C2 ) ) ) ) ).

% doubleton_eq_iff
tff(fact_1191_singleton__iff,axiom,
    ! [B: $tType,Ba: B,A3: B] :
      ( member(B,Ba,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))
    <=> ( Ba = A3 ) ) ).

% singleton_iff
tff(fact_1192_singletonD,axiom,
    ! [B: $tType,Ba: B,A3: B] :
      ( member(B,Ba,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))
     => ( Ba = A3 ) ) ).

% singletonD
tff(fact_1193_ring__class_Oring__distribs_I2_J,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ).

% ring_class.ring_distribs(2)
tff(fact_1194_ring__class_Oring__distribs_I1_J,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ).

% ring_class.ring_distribs(1)
tff(fact_1195_comm__semiring__class_Odistrib,axiom,
    ! [B: $tType] :
      ( comm_semiring(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ).

% comm_semiring_class.distrib
tff(fact_1196_distrib__left,axiom,
    ! [B: $tType] :
      ( semiring(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ).

% distrib_left
tff(fact_1197_distrib__right,axiom,
    ! [B: $tType] :
      ( semiring(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ).

% distrib_right
tff(fact_1198_combine__common__factor,axiom,
    ! [B: $tType] :
      ( semiring(B)
     => ! [A3: B,E2: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),E2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),E2)),C2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),E2)),C2) ) ) ).

% combine_common_factor
tff(fact_1199_diff__diff__eq,axiom,
    ! [B: $tType] :
      ( cancel2418104881723323429up_add(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) ) ) ).

% diff_diff_eq
tff(fact_1200_add__implies__diff,axiom,
    ! [B: $tType] :
      ( cancel1802427076303600483id_add(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba) = A3 )
         => ( C2 = aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba) ) ) ) ).

% add_implies_diff
tff(fact_1201_diff__add__eq__diff__diff__swap,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),C2)),Ba) ) ) ).

% diff_add_eq_diff_diff_swap
tff(fact_1202_diff__add__eq,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),Ba) ) ) ).

% diff_add_eq
tff(fact_1203_diff__diff__eq2,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),Ba) ) ) ).

% diff_diff_eq2
tff(fact_1204_add__diff__eq,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),C2) ) ) ).

% add_diff_eq
tff(fact_1205_eq__diff__eq,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),Ba) )
        <=> ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = C2 ) ) ) ).

% eq_diff_eq
tff(fact_1206_diff__eq__eq,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba) = C2 )
        <=> ( A3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba) ) ) ) ).

% diff_eq_eq
tff(fact_1207_group__cancel_Osub1,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B,K: B,A3: B,Ba: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),A3) )
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A4),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)) ) ) ) ).

% group_cancel.sub1
tff(fact_1208_add_Oinverse__distrib__swap,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,uminus_uminus(B),A3)) ) ) ).

% add.inverse_distrib_swap
tff(fact_1209_group__cancel_Oneg1,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A4: B,K: B,A3: B] :
          ( ( A4 = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),A3) )
         => ( aa(B,B,uminus_uminus(B),A4) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),K)),aa(B,B,uminus_uminus(B),A3)) ) ) ) ).

% group_cancel.neg1
tff(fact_1210_Int__insert__left,axiom,
    ! [B: $tType,A3: B,B2: set(B),C3: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),insert2(B,A3),B2)),C3)
      = $ite(member(B,A3,C3),aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),C3)) ) ).

% Int_insert_left
tff(fact_1211_Int__insert__right,axiom,
    ! [B: $tType,A4: set(B),A3: B,B2: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),insert2(B,A3),B2))
      = $ite(member(B,A3,A4),aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ).

% Int_insert_right
tff(fact_1212_add_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( semigroup_add(B)
     => semigroup(B,plus_plus(B)) ) ).

% add.semigroup_axioms
tff(fact_1213_add__divide__eq__if__simps_I3_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Z2: B,Ba: B] :
          ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),divide_divide(B,A3,Z2))),Ba)
          = $ite(Z2 = zero_zero(B),Ba,divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),Z2)),Z2)) ) ) ).

% add_divide_eq_if_simps(3)
tff(fact_1214_minus__divide__add__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),divide_divide(B,X,Z2))),Y) = divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),X)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2)),Z2) ) ) ) ).

% minus_divide_add_eq_iff
tff(fact_1215_add_Osafe__commute,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => ! [X: B,Y: B,A3: B,Ba: B] :
          ( syntax7388354845996824322omatch(B,B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y),A3)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3) ) ) ) ).

% add.safe_commute
tff(fact_1216_scaling__mono,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [U: B,V: B,R3: B,S: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),V)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),R3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),R3),S)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),U),divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),R3),aa(B,B,aa(B,fun(B,B),minus_minus(B),V),U)),S))),V) ) ) ) ) ).

% scaling_mono
tff(fact_1217_frac__eq__eq,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Y: B,Z2: B,X: B,W2: B] :
          ( ( Y != zero_zero(B) )
         => ( ( Z2 != zero_zero(B) )
           => ( ( divide_divide(B,X,Y) = divide_divide(B,W2,Z2) )
            <=> ( aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2) = aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y) ) ) ) ) ) ).

% frac_eq_eq
tff(fact_1218_divide__eq__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( ( divide_divide(B,Ba,C2) = A3 )
        <=> $ite(C2 != zero_zero(B),Ba = aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),A3 = zero_zero(B)) ) ) ).

% divide_eq_eq
tff(fact_1219_eq__divide__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( A3 = divide_divide(B,Ba,C2) )
        <=> $ite(C2 != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2) = Ba,A3 = zero_zero(B)) ) ) ).

% eq_divide_eq
tff(fact_1220_divide__eq__imp,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( ( C2 != zero_zero(B) )
         => ( ( Ba = aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2) )
           => ( divide_divide(B,Ba,C2) = A3 ) ) ) ) ).

% divide_eq_imp
tff(fact_1221_eq__divide__imp,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( C2 != zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2) = Ba )
           => ( A3 = divide_divide(B,Ba,C2) ) ) ) ) ).

% eq_divide_imp
tff(fact_1222_nonzero__divide__eq__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( ( C2 != zero_zero(B) )
         => ( ( divide_divide(B,Ba,C2) = A3 )
          <=> ( Ba = aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2) ) ) ) ) ).

% nonzero_divide_eq_eq
tff(fact_1223_nonzero__eq__divide__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( C2 != zero_zero(B) )
         => ( ( A3 = divide_divide(B,Ba,C2) )
          <=> ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2) = Ba ) ) ) ) ).

% nonzero_eq_divide_eq
tff(fact_1224_right__inverse__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ba: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => ( ( divide_divide(B,A3,Ba) = one_one(B) )
          <=> ( A3 = Ba ) ) ) ) ).

% right_inverse_eq
tff(fact_1225_add__nonpos__eq__0__iff,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),zero_zero(B))
           => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y) = zero_zero(B) )
            <=> ( ( X = zero_zero(B) )
                & ( Y = zero_zero(B) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
tff(fact_1226_add__nonneg__eq__0__iff,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Y)
           => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y) = zero_zero(B) )
            <=> ( ( X = zero_zero(B) )
                & ( Y = zero_zero(B) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
tff(fact_1227_add__nonpos__nonpos,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),zero_zero(B)) ) ) ) ).

% add_nonpos_nonpos
tff(fact_1228_add__nonneg__nonneg,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) ) ) ) ).

% add_nonneg_nonneg
tff(fact_1229_add__increasing2,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)) ) ) ) ).

% add_increasing2
tff(fact_1230_add__decreasing2,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),Ba) ) ) ) ).

% add_decreasing2
tff(fact_1231_add__increasing,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)) ) ) ) ).

% add_increasing
tff(fact_1232_add__decreasing,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),Ba) ) ) ) ).

% add_decreasing
tff(fact_1233_add__mono__thms__linordered__field_I4_J,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [I: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),I),J2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_field(4)
tff(fact_1234_add__mono__thms__linordered__field_I3_J,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [I: B,J2: B,K: B,L: B] :
          ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),I),J2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),K),L) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),I),K)),aa(B,B,aa(B,fun(B,B),plus_plus(B),J2),L)) ) ) ).

% add_mono_thms_linordered_field(3)
tff(fact_1235_add__le__less__mono,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),D2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),D2)) ) ) ) ).

% add_le_less_mono
tff(fact_1236_add__less__le__mono,axiom,
    ! [B: $tType] :
      ( ordere580206878836729694up_add(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),D2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),D2)) ) ) ) ).

% add_less_le_mono
tff(fact_1237_add__neg__neg,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),zero_zero(B)) ) ) ) ).

% add_neg_neg
tff(fact_1238_add__pos__pos,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) ) ) ) ).

% add_pos_pos
tff(fact_1239_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ~ ! [C4: B] :
                ( ( Ba = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C4) )
               => ( C4 = zero_zero(B) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
tff(fact_1240_pos__add__strict,axiom,
    ! [B: $tType] :
      ( strict7427464778891057005id_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)) ) ) ) ).

% pos_add_strict
tff(fact_1241_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
           => ( ( aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3) = C2 )
            <=> ( Ba = aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
tff(fact_1242_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)) = Ba ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
tff(fact_1243_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3)),Ba) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
tff(fact_1244_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)),C2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
tff(fact_1245_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)),C2) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)),A3) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
tff(fact_1246_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba)),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
tff(fact_1247_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba)),A3) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
tff(fact_1248_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),A3)),Ba) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
tff(fact_1249_le__add__diff,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)),A3)) ) ) ).

% le_add_diff
tff(fact_1250_ordered__cancel__comm__monoid__diff__class_Odiff__add,axiom,
    ! [B: $tType] :
      ( ordere1170586879665033532d_diff(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)),A3) = Ba ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add
tff(fact_1251_le__diff__eq,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),Ba))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),C2) ) ) ).

% le_diff_eq
tff(fact_1252_diff__le__eq,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),C2)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba)) ) ) ).

% diff_le_eq
tff(fact_1253_less__add__one,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B))) ) ).

% less_add_one
tff(fact_1254_add__mono1,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B))),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),one_one(B))) ) ) ).

% add_mono1
tff(fact_1255_less__diff__eq,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,aa(B,fun(B,B),minus_minus(B),C2),Ba))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),C2) ) ) ).

% less_diff_eq
tff(fact_1256_diff__less__eq,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),C2)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),Ba)) ) ) ).

% diff_less_eq
tff(fact_1257_neg__eq__iff__add__eq__0,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,uminus_uminus(B),A3) = Ba )
        <=> ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = zero_zero(B) ) ) ) ).

% neg_eq_iff_add_eq_0
tff(fact_1258_eq__neg__iff__add__eq__0,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = aa(B,B,uminus_uminus(B),Ba) )
        <=> ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = zero_zero(B) ) ) ) ).

% eq_neg_iff_add_eq_0
tff(fact_1259_add_Oinverse__unique,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = zero_zero(B) )
         => ( aa(B,B,uminus_uminus(B),A3) = Ba ) ) ) ).

% add.inverse_unique
tff(fact_1260_ab__group__add__class_Oab__left__minus,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),A3)),A3) = zero_zero(B) ) ) ).

% ab_group_add_class.ab_left_minus
tff(fact_1261_add__eq__0__iff,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba) = zero_zero(B) )
        <=> ( Ba = aa(B,B,uminus_uminus(B),A3) ) ) ) ).

% add_eq_0_iff
tff(fact_1262_eq__add__iff1,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A3: B,E2: B,C2: B,Ba: B,D2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),E2)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),E2)),D2) )
        <=> ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),E2)),C2) = D2 ) ) ) ).

% eq_add_iff1
tff(fact_1263_eq__add__iff2,axiom,
    ! [B: $tType] :
      ( ring(B)
     => ! [A3: B,E2: B,C2: B,Ba: B,D2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),E2)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),E2)),D2) )
        <=> ( C2 = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)),E2)),D2) ) ) ) ).

% eq_add_iff2
tff(fact_1264_square__diff__square__factored,axiom,
    ! [B: $tType] :
      ( comm_ring(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),X)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y)),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),Y)) ) ) ).

% square_diff_square_factored
tff(fact_1265_subset__singletonD,axiom,
    ! [B: $tType,A4: set(B),X: B] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))
     => ( ( A4 = bot_bot(set(B)) )
        | ( A4 = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) ) ) ).

% subset_singletonD
tff(fact_1266_subset__singleton__iff,axiom,
    ! [B: $tType,X6: set(B),A3: B] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X6),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))
    <=> ( ( X6 = bot_bot(set(B)) )
        | ( X6 = aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))) ) ) ) ).

% subset_singleton_iff
tff(fact_1267_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,uminus_uminus(B),Ba)) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
tff(fact_1268_diff__conv__add__uminus,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,uminus_uminus(B),Ba)) ) ) ).

% diff_conv_add_uminus
tff(fact_1269_group__cancel_Osub2,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [B2: B,K: B,Ba: B,A3: B] :
          ( ( B2 = aa(B,B,aa(B,fun(B,B),plus_plus(B),K),Ba) )
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),K)),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)) ) ) ) ).

% group_cancel.sub2
tff(fact_1270_singleton__Un__iff,axiom,
    ! [B: $tType,X: B,A4: set(B),B2: set(B)] :
      ( ( aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2) )
    <=> ( ( ( A4 = bot_bot(set(B)) )
          & ( B2 = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) )
        | ( ( A4 = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) )
          & ( B2 = bot_bot(set(B)) ) )
        | ( ( A4 = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) )
          & ( B2 = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) ) ) ) ).

% singleton_Un_iff
tff(fact_1271_Un__singleton__iff,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),X: B] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2) = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) )
    <=> ( ( ( A4 = bot_bot(set(B)) )
          & ( B2 = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) )
        | ( ( A4 = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) )
          & ( B2 = bot_bot(set(B)) ) )
        | ( ( A4 = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) )
          & ( B2 = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) ) ) ) ).

% Un_singleton_iff
tff(fact_1272_insert__is__Un,axiom,
    ! [B: $tType,A3: B,A4: set(B)] : ( aa(set(B),set(B),insert2(B,A3),A4) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))),A4) ) ).

% insert_is_Un
tff(fact_1273_Diff__insert,axiom,
    ! [B: $tType,A4: set(B),A3: B,B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) ) ).

% Diff_insert
tff(fact_1274_insert__Diff,axiom,
    ! [B: $tType,A3: B,A4: set(B)] :
      ( member(B,A3,A4)
     => ( aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) = A4 ) ) ).

% insert_Diff
tff(fact_1275_Diff__insert2,axiom,
    ! [B: $tType,A4: set(B),A3: B,B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))),B2) ) ).

% Diff_insert2
tff(fact_1276_Diff__insert__absorb,axiom,
    ! [B: $tType,X: B,A4: set(B)] :
      ( ~ member(B,X,A4)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),insert2(B,X),A4)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = A4 ) ) ).

% Diff_insert_absorb
tff(fact_1277_insert__minus__eq,axiom,
    ! [B: $tType,X: B,Y: B,A4: set(B)] :
      ( ( X != Y )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),insert2(B,X),A4)),aa(set(B),set(B),insert2(B,Y),bot_bot(set(B)))) = aa(set(B),set(B),insert2(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,Y),bot_bot(set(B))))) ) ) ).

% insert_minus_eq
tff(fact_1278_set__minus__singleton__eq,axiom,
    ! [B: $tType,X: B,X6: set(B)] :
      ( ~ member(B,X,X6)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),X6),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = X6 ) ) ).

% set_minus_singleton_eq
tff(fact_1279_in__image__insert__iff,axiom,
    ! [B: $tType,B2: set(set(B)),X: B,A4: set(B)] :
      ( ! [C6: set(B)] :
          ( member(set(B),C6,B2)
         => ~ member(B,X,C6) )
     => ( member(set(B),A4,aa(set(set(B)),set(set(B)),image2(set(B),set(B),insert2(B,X)),B2))
      <=> ( member(B,X,A4)
          & member(set(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))),B2) ) ) ) ).

% in_image_insert_iff
tff(fact_1280_translation__Int,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A3: B,S: set(B),T4: set(B)] : ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),plus_plus(B),A3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T4)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),plus_plus(B),A3)),S)),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),plus_plus(B),A3)),T4)) ) ) ).

% translation_Int
tff(fact_1281_add_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( monoid_add(B)
     => monoid(B,plus_plus(B),zero_zero(B)) ) ).

% add.monoid_axioms
tff(fact_1282_effect__bindI,axiom,
    ! [C: $tType,B: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat,Ga: fun(B,heap_Time_Heap(C)),H6: heap_ext(product_unit),R4: C,N2: nat] :
      ( heap_Time_effect(B,Fa,H2,H4,R3,N)
     => ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),Ga,R3),H4,H6,R4,N2)
       => heap_Time_effect(C,heap_Time_bind(B,C,Fa,Ga),H2,H6,R4,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N2)) ) ) ).

% effect_bindI
tff(fact_1283_effect__bindE,axiom,
    ! [C: $tType,B: $tType,Fa: heap_Time_Heap(C),Ga: fun(C,heap_Time_Heap(B)),H2: heap_ext(product_unit),H6: heap_ext(product_unit),R4: B,N: nat] :
      ( heap_Time_effect(B,heap_Time_bind(C,B,Fa,Ga),H2,H6,R4,N)
     => ~ ! [H5: heap_ext(product_unit),R2: C,N1: nat] :
            ( heap_Time_effect(C,Fa,H2,H5,R2,N1)
           => ! [N22: nat] :
                ( heap_Time_effect(B,aa(C,heap_Time_Heap(B),Ga,R2),H5,H6,R4,N22)
               => ( N != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N1),N22) ) ) ) ) ).

% effect_bindE
tff(fact_1284_dbl__inc__def,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [X: B] : ( neg_numeral_dbl_inc(B,X) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),X)),one_one(B)) ) ) ).

% dbl_inc_def
tff(fact_1285_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
         => ( divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = divide_divide(B,divide_divide(B,A3,Ba),C2) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
tff(fact_1286_divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,Ba,C2)),A3)
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),Ba),aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)) ) ) ) ).

% divide_less_eq
tff(fact_1287_less__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),divide_divide(B,Ba,C2))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),Ba),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))) ) ) ) ).

% less_divide_eq
tff(fact_1288_neg__divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,Ba,C2)),A3)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),Ba) ) ) ) ).

% neg_divide_less_eq
tff(fact_1289_neg__less__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),divide_divide(B,Ba,C2))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ) ).

% neg_less_divide_eq
tff(fact_1290_pos__divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,Ba,C2)),A3)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ) ).

% pos_divide_less_eq
tff(fact_1291_pos__less__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),divide_divide(B,Ba,C2))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),Ba) ) ) ) ).

% pos_less_divide_eq
tff(fact_1292_mult__imp__div__pos__less,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,X: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,X,Y)),Z2) ) ) ) ).

% mult_imp_div_pos_less
tff(fact_1293_mult__imp__less__div__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,Z2: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y)),X)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),divide_divide(B,X,Y)) ) ) ) ).

% mult_imp_less_div_pos
tff(fact_1294_divide__strict__left__mono,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,C2,A3)),divide_divide(B,C2,Ba)) ) ) ) ) ).

% divide_strict_left_mono
tff(fact_1295_divide__strict__left__mono__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,C2,A3)),divide_divide(B,C2,Ba)) ) ) ) ) ).

% divide_strict_left_mono_neg
tff(fact_1296_less__divide__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),divide_divide(B,Ba,A3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) ) ) ) ) ).

% less_divide_eq_1
tff(fact_1297_divide__less__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,Ba,A3)),one_one(B))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) )
            | ( A3 = zero_zero(B) ) ) ) ) ).

% divide_less_eq_1
tff(fact_1298_add__divide__eq__if__simps_I4_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B,Z2: B] :
          ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),divide_divide(B,Ba,Z2))
          = $ite(Z2 = zero_zero(B),A3,divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Z2)),Ba),Z2)) ) ) ).

% add_divide_eq_if_simps(4)
tff(fact_1299_diff__frac__eq,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Y: B,Z2: B,X: B,W2: B] :
          ( ( Y != zero_zero(B) )
         => ( ( Z2 != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),divide_divide(B,X,Y)),divide_divide(B,W2,Z2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2)) ) ) ) ) ).

% diff_frac_eq
tff(fact_1300_diff__divide__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),X),divide_divide(B,Y,Z2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2)),Y),Z2) ) ) ) ).

% diff_divide_eq_iff
tff(fact_1301_divide__diff__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),divide_divide(B,X,Z2)),Y) = divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),X),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2)),Z2) ) ) ) ).

% divide_diff_eq_iff
tff(fact_1302_add__neg__nonpos,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),zero_zero(B)) ) ) ) ).

% add_neg_nonpos
tff(fact_1303_add__nonneg__pos,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) ) ) ) ).

% add_nonneg_pos
tff(fact_1304_add__nonpos__neg,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),zero_zero(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),zero_zero(B)) ) ) ) ).

% add_nonpos_neg
tff(fact_1305_add__pos__nonneg,axiom,
    ! [B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) ) ) ) ).

% add_pos_nonneg
tff(fact_1306_add__strict__increasing,axiom,
    ! [B: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)) ) ) ) ).

% add_strict_increasing
tff(fact_1307_add__strict__increasing2,axiom,
    ! [B: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2)) ) ) ) ).

% add_strict_increasing2
tff(fact_1308_sum__squares__ge__zero,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [X: B,Y: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),X)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y))) ) ).

% sum_squares_ge_zero
tff(fact_1309_eq__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( A3 = aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2)) )
        <=> $ite(C2 != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2) = aa(B,B,uminus_uminus(B),Ba),A3 = zero_zero(B)) ) ) ).

% eq_minus_divide_eq
tff(fact_1310_minus__divide__eq__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( ( aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2)) = A3 )
        <=> $ite(C2 != zero_zero(B),aa(B,B,uminus_uminus(B),Ba) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),A3 = zero_zero(B)) ) ) ).

% minus_divide_eq_eq
tff(fact_1311_nonzero__neg__divide__eq__eq,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( ( Ba != zero_zero(B) )
         => ( ( aa(B,B,uminus_uminus(B),divide_divide(B,A3,Ba)) = C2 )
          <=> ( aa(B,B,uminus_uminus(B),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
tff(fact_1312_nonzero__neg__divide__eq__eq2,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => ( ( C2 = aa(B,B,uminus_uminus(B),divide_divide(B,A3,Ba)) )
          <=> ( aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba) = aa(B,B,uminus_uminus(B),A3) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
tff(fact_1313_divide__eq__minus__1__iff,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B,Ba: B] :
          ( ( divide_divide(B,A3,Ba) = aa(B,B,uminus_uminus(B),one_one(B)) )
        <=> ( ( Ba != zero_zero(B) )
            & ( A3 = aa(B,B,uminus_uminus(B),Ba) ) ) ) ) ).

% divide_eq_minus_1_iff
tff(fact_1314_not__sum__squares__lt__zero,axiom,
    ! [B: $tType] :
      ( linordered_ring(B)
     => ! [X: B,Y: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),X)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y))),zero_zero(B)) ) ).

% not_sum_squares_lt_zero
tff(fact_1315_discrete,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B))),Ba) ) ) ).

% discrete
tff(fact_1316_zero__less__two,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),one_one(B))) ) ).

% zero_less_two
tff(fact_1317_le__add__iff2,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A3: B,E2: B,C2: B,Ba: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),E2)),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),E2)),D2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)),E2)),D2)) ) ) ).

% le_add_iff2
tff(fact_1318_le__add__iff1,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A3: B,E2: B,C2: B,Ba: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),E2)),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),E2)),D2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),E2)),C2)),D2) ) ) ).

% le_add_iff1
tff(fact_1319_less__add__iff2,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A3: B,E2: B,C2: B,Ba: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),E2)),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),E2)),D2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)),E2)),D2)) ) ) ).

% less_add_iff2
tff(fact_1320_less__add__iff1,axiom,
    ! [B: $tType] :
      ( ordered_ring(B)
     => ! [A3: B,E2: B,C2: B,Ba: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),E2)),C2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),E2)),D2))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),E2)),C2)),D2) ) ) ).

% less_add_iff1
tff(fact_1321_square__diff__one__factored,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),X)),one_one(B)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),one_one(B))),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),one_one(B))) ) ) ).

% square_diff_one_factored
tff(fact_1322_range__eq__singletonD,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,B),A3: B,X: C] :
      ( ( aa(set(C),set(B),image2(C,B,Fa),top_top(set(C))) = aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))) )
     => ( aa(C,B,Fa,X) = A3 ) ) ).

% range_eq_singletonD
tff(fact_1323_Diff__single__insert,axiom,
    ! [B: $tType,A4: set(B),X: B,B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),B2)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),insert2(B,X),B2)) ) ).

% Diff_single_insert
tff(fact_1324_subset__insert__iff,axiom,
    ! [B: $tType,A4: set(B),X: B,B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),insert2(B,X),B2))
    <=> $ite(member(B,X,A4),aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),B2),aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)) ) ).

% subset_insert_iff
tff(fact_1325_remove__subset,axiom,
    ! [B: $tType,X: B,S2: set(B)] :
      ( member(B,X,S2)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),S2) ) ).

% remove_subset
tff(fact_1326_Compl__insert,axiom,
    ! [B: $tType,X: B,A4: set(B)] : ( aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert2(B,X),A4)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),A4)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) ) ).

% Compl_insert
tff(fact_1327_dbl__dec__def,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [X: B] : ( neg_numeral_dbl_dec(B,X) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),X)),one_one(B)) ) ) ).

% dbl_dec_def
tff(fact_1328_divide__left__mono__neg,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),zero_zero(B))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,C2,A3)),divide_divide(B,C2,Ba)) ) ) ) ) ).

% divide_left_mono_neg
tff(fact_1329_mult__imp__le__div__pos,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,Z2: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y)),X)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),divide_divide(B,X,Y)) ) ) ) ).

% mult_imp_le_div_pos
tff(fact_1330_mult__imp__div__pos__le,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,X: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Y)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),Y))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,X,Y)),Z2) ) ) ) ).

% mult_imp_div_pos_le
tff(fact_1331_pos__le__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),divide_divide(B,Ba,C2))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),Ba) ) ) ) ).

% pos_le_divide_eq
tff(fact_1332_pos__divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,Ba,C2)),A3)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ) ).

% pos_divide_le_eq
tff(fact_1333_neg__le__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),divide_divide(B,Ba,C2))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ) ).

% neg_le_divide_eq
tff(fact_1334_neg__divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,Ba,C2)),A3)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),Ba) ) ) ) ).

% neg_divide_le_eq
tff(fact_1335_divide__left__mono,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,C2,A3)),divide_divide(B,C2,Ba)) ) ) ) ) ).

% divide_left_mono
tff(fact_1336_le__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),divide_divide(B,Ba,C2))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),Ba),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))) ) ) ) ).

% le_divide_eq
tff(fact_1337_divide__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,Ba,C2)),A3)
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),Ba),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)) ) ) ) ).

% divide_le_eq
tff(fact_1338_divide__le__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,Ba,A3)),one_one(B))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) )
            | ( A3 = zero_zero(B) ) ) ) ) ).

% divide_le_eq_1
tff(fact_1339_le__divide__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),divide_divide(B,Ba,A3))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) )
            | ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
              & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ) ) ).

% le_divide_eq_1
tff(fact_1340_frac__le__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,Z2: B,X: B,W2: B] :
          ( ( Y != zero_zero(B) )
         => ( ( Z2 != zero_zero(B) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,X,Y)),divide_divide(B,W2,Z2))
            <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))),zero_zero(B)) ) ) ) ) ).

% frac_le_eq
tff(fact_1341_frac__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Y: B,Z2: B,X: B,W2: B] :
          ( ( Y != zero_zero(B) )
         => ( ( Z2 != zero_zero(B) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,X,Y)),divide_divide(B,W2,Z2))
            <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2))),zero_zero(B)) ) ) ) ) ).

% frac_less_eq
tff(fact_1342_less__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2)))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,uminus_uminus(B),Ba)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))) ) ) ) ).

% less_minus_divide_eq
tff(fact_1343_minus__divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2))),A3)
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,uminus_uminus(B),Ba)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)) ) ) ) ).

% minus_divide_less_eq
tff(fact_1344_neg__less__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2)))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ) ).

% neg_less_minus_divide_eq
tff(fact_1345_neg__minus__divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2))),A3)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,uminus_uminus(B),Ba)) ) ) ) ).

% neg_minus_divide_less_eq
tff(fact_1346_pos__less__minus__divide__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2)))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,uminus_uminus(B),Ba)) ) ) ) ).

% pos_less_minus_divide_eq
tff(fact_1347_pos__minus__divide__less__eq,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),divide_divide(B,Ba,C2))),A3)
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)) ) ) ) ).

% pos_minus_divide_less_eq
tff(fact_1348_add__divide__eq__if__simps_I6_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Z2: B,Ba: B] :
          ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),divide_divide(B,A3,Z2))),Ba)
          = $ite(Z2 = zero_zero(B),aa(B,B,uminus_uminus(B),Ba),divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),Z2)),Z2)) ) ) ).

% add_divide_eq_if_simps(6)
tff(fact_1349_add__divide__eq__if__simps_I5_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Z2: B,Ba: B] :
          ( aa(B,B,aa(B,fun(B,B),minus_minus(B),divide_divide(B,A3,Z2)),Ba)
          = $ite(Z2 = zero_zero(B),aa(B,B,uminus_uminus(B),Ba),divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),Z2)),Z2)) ) ) ).

% add_divide_eq_if_simps(5)
tff(fact_1350_minus__divide__diff__eq__iff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Z2: B,X: B,Y: B] :
          ( ( Z2 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),divide_divide(B,X,Z2))),Y) = divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),X)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Z2)),Z2) ) ) ) ).

% minus_divide_diff_eq_iff
tff(fact_1351_convex__bound__le,axiom,
    ! [B: $tType] :
      ( linord6961819062388156250ring_1(B)
     => ! [X: B,A3: B,Y: B,U: B,V: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),A3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),U)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),V)
               => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),U),V) = one_one(B) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),U),X)),aa(B,B,aa(B,fun(B,B),times_times(B),V),Y))),A3) ) ) ) ) ) ) ).

% convex_bound_le
tff(fact_1352_psubset__insert__iff,axiom,
    ! [B: $tType,A4: set(B),X: B,B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A4),aa(set(B),set(B),insert2(B,X),B2))
    <=> $ite(
          member(B,X,B2),
          aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A4),B2),
          $ite(member(B,X,A4),aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),B2),aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)) ) ) ).

% psubset_insert_iff
tff(fact_1353_div__mult__self1,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( ( Ba != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),divide_divide(B,A3,Ba)) ) ) ) ).

% div_mult_self1
tff(fact_1354_div__mult__self2,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( ( Ba != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),divide_divide(B,A3,Ba)) ) ) ) ).

% div_mult_self2
tff(fact_1355_div__mult__self3,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)),A3),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),divide_divide(B,A3,Ba)) ) ) ) ).

% div_mult_self3
tff(fact_1356_div__mult__self4,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)),A3),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),divide_divide(B,A3,Ba)) ) ) ) ).

% div_mult_self4
tff(fact_1357_div__minus1__right,axiom,
    ! [B: $tType] :
      ( euclid8851590272496341667cancel(B)
     => ! [A3: B] : ( divide_divide(B,A3,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),A3) ) ) ).

% div_minus1_right
tff(fact_1358_div__mult__mult1,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( C2 != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) = divide_divide(B,A3,Ba) ) ) ) ).

% div_mult_mult1
tff(fact_1359_div__mult__mult2,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( ( C2 != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = divide_divide(B,A3,Ba) ) ) ) ).

% div_mult_mult2
tff(fact_1360_div__mult__mult1__if,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
          = $ite(C2 = zero_zero(B),zero_zero(B),divide_divide(B,A3,Ba)) ) ) ).

% div_mult_mult1_if
tff(fact_1361_bits__div__by__1,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A3: B] : ( divide_divide(B,A3,one_one(B)) = A3 ) ) ).

% bits_div_by_1
tff(fact_1362_div__add__self1,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ba: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),A3),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,A3,Ba)),one_one(B)) ) ) ) ).

% div_add_self1
tff(fact_1363_div__add__self2,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ba: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba),Ba) = aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,A3,Ba)),one_one(B)) ) ) ) ).

% div_add_self2
tff(fact_1364_sum__squares__gt__zero__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),X)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y)))
        <=> ( ( X != zero_zero(B) )
            | ( Y != zero_zero(B) ) ) ) ) ).

% sum_squares_gt_zero_iff
tff(fact_1365_sum__squares__le__zero__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),X)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y))),zero_zero(B))
        <=> ( ( X = zero_zero(B) )
            & ( Y = zero_zero(B) ) ) ) ) ).

% sum_squares_le_zero_iff
tff(fact_1366_add__scale__eq__noteq,axiom,
    ! [B: $tType] :
      ( semiri1453513574482234551roduct(B)
     => ! [R3: B,A3: B,Ba: B,C2: B,D2: B] :
          ( ( R3 != zero_zero(B) )
         => ( ( ( A3 = Ba )
              & ( C2 != D2 ) )
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),R3),C2)) != aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),R3),D2)) ) ) ) ) ).

% add_scale_eq_noteq
tff(fact_1367_sum__squares__eq__zero__iff,axiom,
    ! [B: $tType] :
      ( linord4710134922213307826strict(B)
     => ! [X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),X)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),Y)) = zero_zero(B) )
        <=> ( ( X = zero_zero(B) )
            & ( Y = zero_zero(B) ) ) ) ) ).

% sum_squares_eq_zero_iff
tff(fact_1368_is__singleton__the__elem,axiom,
    ! [B: $tType,A4: set(B)] :
      ( is_singleton(B,A4)
    <=> ( A4 = aa(set(B),set(B),insert2(B,the_elem(B,A4)),bot_bot(set(B))) ) ) ).

% is_singleton_the_elem
tff(fact_1369_is__singletonI,axiom,
    ! [B: $tType,X: B] : is_singleton(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) ).

% is_singletonI
tff(fact_1370_crossproduct__eq,axiom,
    ! [B: $tType] :
      ( semiri1453513574482234551roduct(B)
     => ! [W2: B,Y: B,X: B,Z2: B] :
          ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Y)),aa(B,B,aa(B,fun(B,B),times_times(B),X),Z2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),W2),Z2)),aa(B,B,aa(B,fun(B,B),times_times(B),X),Y)) )
        <=> ( ( W2 = X )
            | ( Y = Z2 ) ) ) ) ).

% crossproduct_eq
tff(fact_1371_crossproduct__noteq,axiom,
    ! [B: $tType] :
      ( semiri1453513574482234551roduct(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( ( ( A3 != Ba )
            & ( C2 != D2 ) )
        <=> ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),D2)) != aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),D2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ) ).

% crossproduct_noteq
tff(fact_1372_is__singletonI_H,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( ! [X2: B,Y2: B] :
            ( member(B,X2,A4)
           => ( member(B,Y2,A4)
             => ( X2 = Y2 ) ) )
       => is_singleton(B,A4) ) ) ).

% is_singletonI'
tff(fact_1373_is__singletonE,axiom,
    ! [B: $tType,A4: set(B)] :
      ( is_singleton(B,A4)
     => ~ ! [X2: B] : ( A4 != aa(set(B),set(B),insert2(B,X2),bot_bot(set(B))) ) ) ).

% is_singletonE
tff(fact_1374_is__singleton__def,axiom,
    ! [B: $tType,A4: set(B)] :
      ( is_singleton(B,A4)
    <=> ? [X4: B] : ( A4 = aa(set(B),set(B),insert2(B,X4),bot_bot(set(B))) ) ) ).

% is_singleton_def
tff(fact_1375_remove__def,axiom,
    ! [B: $tType,X: B,A4: set(B)] : ( aa(set(B),set(B),aa(B,fun(set(B),set(B)),remove(B),X),A4) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) ) ).

% remove_def
tff(fact_1376_divide__le__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,C2: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,Ba,C2)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),C2)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),C2)),Ba),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))) ) ) ) ).

% divide_le_eq_numeral(2)
tff(fact_1377_le__divide__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [W2: num,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),divide_divide(B,Ba,C2))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),C2)),Ba),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),C2)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),zero_zero(B))) ) ) ) ).

% le_divide_eq_numeral(2)
tff(fact_1378_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,C: $tType] :
      ( ring(C)
     => ! [X: B,Y: B,A3: C,Ba: C,C2: C] :
          ( nO_MATCH(B,C,divide_divide(B,X,Y),A3)
         => ( aa(C,C,aa(C,fun(C,C),times_times(C),A3),aa(C,C,aa(C,fun(C,C),minus_minus(C),Ba),C2)) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(C,C,aa(C,fun(C,C),times_times(C),A3),Ba)),aa(C,C,aa(C,fun(C,C),times_times(C),A3),C2)) ) ) ) ).

% right_diff_distrib_NO_MATCH
tff(fact_1379_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,C: $tType] :
      ( ring(C)
     => ! [X: B,Y: B,C2: C,A3: C,Ba: C] :
          ( nO_MATCH(B,C,divide_divide(B,X,Y),C2)
         => ( aa(C,C,aa(C,fun(C,C),times_times(C),aa(C,C,aa(C,fun(C,C),minus_minus(C),A3),Ba)),C2) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(C,C,aa(C,fun(C,C),times_times(C),A3),C2)),aa(C,C,aa(C,fun(C,C),times_times(C),Ba),C2)) ) ) ) ).

% left_diff_distrib_NO_MATCH
tff(fact_1380_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring(C)
     => ! [X: B,Y: B,C2: C,A3: C,Ba: C] :
          ( nO_MATCH(B,C,divide_divide(B,X,Y),C2)
         => ( aa(C,C,aa(C,fun(C,C),times_times(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),A3),Ba)),C2) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),times_times(C),A3),C2)),aa(C,C,aa(C,fun(C,C),times_times(C),Ba),C2)) ) ) ) ).

% distrib_right_NO_MATCH
tff(fact_1381_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring(C)
     => ! [X: B,Y: B,A3: C,Ba: C,C2: C] :
          ( nO_MATCH(B,C,divide_divide(B,X,Y),A3)
         => ( aa(C,C,aa(C,fun(C,C),times_times(C),A3),aa(C,C,aa(C,fun(C,C),plus_plus(C),Ba),C2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),times_times(C),A3),Ba)),aa(C,C,aa(C,fun(C,C),times_times(C),A3),C2)) ) ) ) ).

% distrib_left_NO_MATCH
tff(fact_1382_div__add__self1__no__field,axiom,
    ! [B: $tType,C: $tType] :
      ( ( euclid4440199948858584721cancel(C)
        & field(B) )
     => ! [X: B,Ba: C,A3: C] :
          ( nO_MATCH(B,C,X,Ba)
         => ( ( Ba != zero_zero(C) )
           => ( divide_divide(C,aa(C,C,aa(C,fun(C,C),plus_plus(C),Ba),A3),Ba) = aa(C,C,aa(C,fun(C,C),plus_plus(C),divide_divide(C,A3,Ba)),one_one(C)) ) ) ) ) ).

% div_add_self1_no_field
tff(fact_1383_mult__numeral__left__semiring__numeral,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [V: num,W2: num,Z2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Z2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2))),Z2) ) ) ).

% mult_numeral_left_semiring_numeral
tff(fact_1384_numeral__times__numeral,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [M4: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),M4)),aa(num,B,numeral_numeral(B),N)) = aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),M4),N)) ) ) ).

% numeral_times_numeral
tff(fact_1385_distrib__left__numeral,axiom,
    ! [B: $tType] :
      ( ( numeral(B)
        & semiring(B) )
     => ! [V: num,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),C2)) ) ) ).

% distrib_left_numeral
tff(fact_1386_distrib__right__numeral,axiom,
    ! [B: $tType] :
      ( ( numeral(B)
        & semiring(B) )
     => ! [A3: B,Ba: B,V: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),aa(num,B,numeral_numeral(B),V)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),V))),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),aa(num,B,numeral_numeral(B),V))) ) ) ).

% distrib_right_numeral
tff(fact_1387_right__diff__distrib__numeral,axiom,
    ! [B: $tType] :
      ( ( numeral(B)
        & ring(B) )
     => ! [V: num,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),C2)) ) ) ).

% right_diff_distrib_numeral
tff(fact_1388_left__diff__distrib__numeral,axiom,
    ! [B: $tType] :
      ( ( numeral(B)
        & ring(B) )
     => ! [A3: B,Ba: B,V: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)),aa(num,B,numeral_numeral(B),V)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),V))),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),aa(num,B,numeral_numeral(B),V))) ) ) ).

% left_diff_distrib_numeral
tff(fact_1389_mult__neg__numeral__simps_I1_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [M4: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N))) = aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),M4),N)) ) ) ).

% mult_neg_numeral_simps(1)
tff(fact_1390_mult__neg__numeral__simps_I2_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [M4: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))),aa(num,B,numeral_numeral(B),N)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),M4),N))) ) ) ).

% mult_neg_numeral_simps(2)
tff(fact_1391_mult__neg__numeral__simps_I3_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [M4: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),M4)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),M4),N))) ) ) ).

% mult_neg_numeral_simps(3)
tff(fact_1392_divide__le__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,W2: num,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,Ba,aa(num,B,numeral_numeral(B),W2))),A3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),W2))) ) ) ).

% divide_le_eq_numeral1(1)
tff(fact_1393_le__divide__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),divide_divide(B,Ba,aa(num,B,numeral_numeral(B),W2)))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),W2))),Ba) ) ) ).

% le_divide_eq_numeral1(1)
tff(fact_1394_divide__eq__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ba: B,W2: num,A3: B] :
          ( ( divide_divide(B,Ba,aa(num,B,numeral_numeral(B),W2)) = A3 )
        <=> $ite(aa(num,B,numeral_numeral(B),W2) != zero_zero(B),Ba = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),W2)),A3 = zero_zero(B)) ) ) ).

% divide_eq_eq_numeral1(1)
tff(fact_1395_eq__divide__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B,W2: num] :
          ( ( A3 = divide_divide(B,Ba,aa(num,B,numeral_numeral(B),W2)) )
        <=> $ite(aa(num,B,numeral_numeral(B),W2) != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),W2)) = Ba,A3 = zero_zero(B)) ) ) ).

% eq_divide_eq_numeral1(1)
tff(fact_1396_divide__less__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,W2: num,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,Ba,aa(num,B,numeral_numeral(B),W2))),A3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),W2))) ) ) ).

% divide_less_eq_numeral1(1)
tff(fact_1397_less__divide__eq__numeral1_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),divide_divide(B,Ba,aa(num,B,numeral_numeral(B),W2)))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),W2))),Ba) ) ) ).

% less_divide_eq_numeral1(1)
tff(fact_1398_divide__le__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,W2: num,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,Ba,aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))),A3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))),Ba) ) ) ).

% divide_le_eq_numeral1(2)
tff(fact_1399_le__divide__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),divide_divide(B,Ba,aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))) ) ) ).

% le_divide_eq_numeral1(2)
tff(fact_1400_divide__eq__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ba: B,W2: num,A3: B] :
          ( ( divide_divide(B,Ba,aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) = A3 )
        <=> $ite(aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) != zero_zero(B),Ba = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),A3 = zero_zero(B)) ) ) ).

% divide_eq_eq_numeral1(2)
tff(fact_1401_eq__divide__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B,W2: num] :
          ( ( A3 = divide_divide(B,Ba,aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) )
        <=> $ite(aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) = Ba,A3 = zero_zero(B)) ) ) ).

% eq_divide_eq_numeral1(2)
tff(fact_1402_divide__less__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,W2: num,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,Ba,aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))),A3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))),Ba) ) ) ).

% divide_less_eq_numeral1(2)
tff(fact_1403_less__divide__eq__numeral1_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),divide_divide(B,Ba,aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))) ) ) ).

% less_divide_eq_numeral1(2)
tff(fact_1404_div__add__self2__no__field,axiom,
    ! [B: $tType,C: $tType] :
      ( ( euclid4440199948858584721cancel(C)
        & field(B) )
     => ! [X: B,Ba: C,A3: C] :
          ( nO_MATCH(B,C,X,Ba)
         => ( ( Ba != zero_zero(C) )
           => ( divide_divide(C,aa(C,C,aa(C,fun(C,C),plus_plus(C),A3),Ba),Ba) = aa(C,C,aa(C,fun(C,C),plus_plus(C),divide_divide(C,A3,Ba)),one_one(C)) ) ) ) ) ).

% div_add_self2_no_field
tff(fact_1405_one__le__numeral,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [N: num] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(num,B,numeral_numeral(B),N)) ) ).

% one_le_numeral
tff(fact_1406_not__numeral__less__one,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [N: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(num,B,numeral_numeral(B),N)),one_one(B)) ) ).

% not_numeral_less_one
tff(fact_1407_one__plus__numeral__commute,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(num,B,numeral_numeral(B),X)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),X)),one_one(B)) ) ) ).

% one_plus_numeral_commute
tff(fact_1408_numeral__neq__neg__one,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [N: num] : ( aa(num,B,numeral_numeral(B),N) != aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% numeral_neq_neg_one
tff(fact_1409_one__neq__neg__numeral,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [N: num] : ( one_one(B) != aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N)) ) ) ).

% one_neq_neg_numeral
tff(fact_1410_neg__numeral__le__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))),one_one(B)) ) ).

% neg_numeral_le_one
tff(fact_1411_neg__one__le__numeral,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(num,B,numeral_numeral(B),M4)) ) ).

% neg_one_le_numeral
tff(fact_1412_neg__numeral__le__neg__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% neg_numeral_le_neg_one
tff(fact_1413_not__numeral__le__neg__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),M4)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% not_numeral_le_neg_one
tff(fact_1414_not__one__le__neg__numeral,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))) ) ).

% not_one_le_neg_numeral
tff(fact_1415_divide__eq__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ba: B,C2: B,W2: num] :
          ( ( divide_divide(B,Ba,C2) = aa(num,B,numeral_numeral(B),W2) )
        <=> $ite(C2 != zero_zero(B),Ba = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),C2),aa(num,B,numeral_numeral(B),W2) = zero_zero(B)) ) ) ).

% divide_eq_eq_numeral(1)
tff(fact_1416_eq__divide__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [W2: num,Ba: B,C2: B] :
          ( ( aa(num,B,numeral_numeral(B),W2) = divide_divide(B,Ba,C2) )
        <=> $ite(C2 != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),C2) = Ba,aa(num,B,numeral_numeral(B),W2) = zero_zero(B)) ) ) ).

% eq_divide_eq_numeral(1)
tff(fact_1417_neg__numeral__less__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))),one_one(B)) ) ).

% neg_numeral_less_one
tff(fact_1418_neg__one__less__numeral,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(num,B,numeral_numeral(B),M4)) ) ).

% neg_one_less_numeral
tff(fact_1419_not__numeral__less__neg__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(num,B,numeral_numeral(B),M4)),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% not_numeral_less_neg_one
tff(fact_1420_not__one__less__neg__numeral,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))) ) ).

% not_one_less_neg_numeral
tff(fact_1421_not__neg__one__less__neg__numeral,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))) ) ).

% not_neg_one_less_neg_numeral
tff(fact_1422_divide__less__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,C2: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,Ba,C2)),aa(num,B,numeral_numeral(B),W2))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),C2)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),C2)),Ba),aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(num,B,numeral_numeral(B),W2))) ) ) ) ).

% divide_less_eq_numeral(1)
tff(fact_1423_less__divide__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [W2: num,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(num,B,numeral_numeral(B),W2)),divide_divide(B,Ba,C2))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),C2)),Ba),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),C2)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(num,B,numeral_numeral(B),W2)),zero_zero(B))) ) ) ) ).

% less_divide_eq_numeral(1)
tff(fact_1424_divide__eq__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Ba: B,C2: B,W2: num] :
          ( ( divide_divide(B,Ba,C2) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) )
        <=> $ite(C2 != zero_zero(B),Ba = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),C2),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) = zero_zero(B)) ) ) ).

% divide_eq_eq_numeral(2)
tff(fact_1425_eq__divide__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [W2: num,Ba: B,C2: B] :
          ( ( aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) = divide_divide(B,Ba,C2) )
        <=> $ite(C2 != zero_zero(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),C2) = Ba,aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)) = zero_zero(B)) ) ) ).

% eq_divide_eq_numeral(2)
tff(fact_1426_le__divide__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [W2: num,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),W2)),divide_divide(B,Ba,C2))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),C2)),Ba),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),C2)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),W2)),zero_zero(B))) ) ) ) ).

% le_divide_eq_numeral(1)
tff(fact_1427_divide__le__eq__numeral_I1_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,C2: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,Ba,C2)),aa(num,B,numeral_numeral(B),W2))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),C2)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),C2)),Ba),aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(num,B,numeral_numeral(B),W2))) ) ) ) ).

% divide_le_eq_numeral(1)
tff(fact_1428_less__divide__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [W2: num,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),divide_divide(B,Ba,C2))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),C2)),Ba),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),C2)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),zero_zero(B))) ) ) ) ).

% less_divide_eq_numeral(2)
tff(fact_1429_divide__less__eq__numeral_I2_J,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Ba: B,C2: B,W2: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,Ba,C2)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))
        <=> $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),C2)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),zero_zero(B)),aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),C2)),Ba),aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2)))) ) ) ) ).

% divide_less_eq_numeral(2)
tff(fact_1430_semiring__norm_I170_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [V: num,W2: num,Y: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Y)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2)))),Y) ) ) ).

% semiring_norm(170)
tff(fact_1431_semiring__norm_I171_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [V: num,W2: num,Y: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),V)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Y)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2)))),Y) ) ) ).

% semiring_norm(171)
tff(fact_1432_semiring__norm_I172_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [V: num,W2: num,Y: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))),Y)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),times_times(num),V),W2))),Y) ) ) ).

% semiring_norm(172)
tff(fact_1433_numeral__times__minus__swap,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [W2: num,X: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),aa(B,B,uminus_uminus(B),X)) = aa(B,B,aa(B,fun(B,B),times_times(B),X),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) ) ) ).

% numeral_times_minus_swap
tff(fact_1434_diff__numeral__special_I6_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M4: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(num,B,numeral_numeral(B),M4)),aa(B,B,uminus_uminus(B),one_one(B))) = aa(num,B,numeral_numeral(B),inc(M4)) ) ) ).

% diff_numeral_special(6)
tff(fact_1435_diff__numeral__special_I5_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(num,B,numeral_numeral(B),N)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),inc(N))) ) ) ).

% diff_numeral_special(5)
tff(fact_1436_add__neg__numeral__special_I6_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M4: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),inc(M4))) ) ) ).

% add_neg_numeral_special(6)
tff(fact_1437_add__neg__numeral__special_I5_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),inc(N))) ) ) ).

% add_neg_numeral_special(5)
tff(fact_1438_numeral__inc,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [X: num] : ( aa(num,B,numeral_numeral(B),inc(X)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),X)),one_one(B)) ) ) ).

% numeral_inc
tff(fact_1439_diff__numeral__special_I3_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N))) = aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% diff_numeral_special(3)
tff(fact_1440_diff__numeral__special_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M4: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))),one_one(B)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),M4),one2))) ) ) ).

% diff_numeral_special(4)
tff(fact_1441_neg__numeral__less__neg__one__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))),aa(B,B,uminus_uminus(B),one_one(B)))
        <=> ( M4 != one2 ) ) ) ).

% neg_numeral_less_neg_one_iff
tff(fact_1442_not__neg__one__le__neg__numeral__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [M4: num] :
          ( ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4)))
        <=> ( M4 != one2 ) ) ) ).

% not_neg_one_le_neg_numeral_iff
tff(fact_1443_prod__set__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,X: B,Y: C] : ( aa(product_prod(B,C),set(B),basic_fsts(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)) = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) ).

% prod_set_simps(1)
tff(fact_1444_prod__set__simps_I2_J,axiom,
    ! [C: $tType,B: $tType,X: C,Y: B] : ( basic_snds(C,B,aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X),Y)) = aa(set(B),set(B),insert2(B,Y),bot_bot(set(B))) ) ).

% prod_set_simps(2)
tff(fact_1445_total__on__singleton,axiom,
    ! [B: $tType,X: B] : total_on(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),X)),bot_bot(set(product_prod(B,B))))) ).

% total_on_singleton
tff(fact_1446_Field__insert,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B))] : ( field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba)),R3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))),field2(B,R3)) ) ).

% Field_insert
tff(fact_1447_one__eq__numeral__iff,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: num] :
          ( ( one_one(B) = aa(num,B,numeral_numeral(B),N) )
        <=> ( one2 = N ) ) ) ).

% one_eq_numeral_iff
tff(fact_1448_numeral__eq__one__iff,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: num] :
          ( ( aa(num,B,numeral_numeral(B),N) = one_one(B) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_one_iff
tff(fact_1449_Field__empty,axiom,
    ! [B: $tType] : ( field2(B,bot_bot(set(product_prod(B,B)))) = bot_bot(set(B)) ) ).

% Field_empty
tff(fact_1450_numeral__le__one__iff,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [N: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),N)),one_one(B))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),N),one2) ) ) ).

% numeral_le_one_iff
tff(fact_1451_one__less__numeral__iff,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [N: num] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(num,B,numeral_numeral(B),N))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),N) ) ) ).

% one_less_numeral_iff
tff(fact_1452_neg__one__eq__numeral__iff,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [N: num] :
          ( ( aa(B,B,uminus_uminus(B),one_one(B)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N)) )
        <=> ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
tff(fact_1453_numeral__eq__neg__one__iff,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [N: num] :
          ( ( aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N)) = aa(B,B,uminus_uminus(B),one_one(B)) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
tff(fact_1454_one__plus__numeral,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(num,B,numeral_numeral(B),N)) = aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% one_plus_numeral
tff(fact_1455_numeral__plus__one,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),N)),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2)) ) ) ).

% numeral_plus_one
tff(fact_1456_FieldI2,axiom,
    ! [B: $tType,I: B,J2: B,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),I),J2),R)
     => member(B,J2,field2(B,R)) ) ).

% FieldI2
tff(fact_1457_FieldI1,axiom,
    ! [B: $tType,I: B,J2: B,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),I),J2),R)
     => member(B,I,field2(B,R)) ) ).

% FieldI1
tff(fact_1458_total__on__def,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( total_on(B,A4,R3)
    <=> ! [X4: B] :
          ( member(B,X4,A4)
         => ! [Xa2: B] :
              ( member(B,Xa2,A4)
             => ( ( X4 != Xa2 )
               => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa2),R3)
                  | member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa2),X4),R3) ) ) ) ) ) ).

% total_on_def
tff(fact_1459_total__onI,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( ! [X2: B,Y2: B] :
          ( member(B,X2,A4)
         => ( member(B,Y2,A4)
           => ( ( X2 != Y2 )
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),R3)
                | member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),X2),R3) ) ) ) )
     => total_on(B,A4,R3) ) ).

% total_onI
tff(fact_1460_total__on__empty,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : total_on(B,bot_bot(set(B)),R3) ).

% total_on_empty
tff(fact_1461_mult__numeral__1,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),one2)),A3) = A3 ) ) ).

% mult_numeral_1
tff(fact_1462_mult__numeral__1__right,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),one2)) = A3 ) ) ).

% mult_numeral_1_right
tff(fact_1463_numeral__One,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ( aa(num,B,numeral_numeral(B),one2) = one_one(B) ) ) ).

% numeral_One
tff(fact_1464_mult__1s__ring__1_I1_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),one2))),Ba) = aa(B,B,uminus_uminus(B),Ba) ) ) ).

% mult_1s_ring_1(1)
tff(fact_1465_mult__1s__ring__1_I2_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),Ba),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),one2))) = aa(B,B,uminus_uminus(B),Ba) ) ) ).

% mult_1s_ring_1(2)
tff(fact_1466_uminus__numeral__One,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),one2)) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% uminus_numeral_One
tff(fact_1467_prod__set__defs_I1_J,axiom,
    ! [C: $tType,B: $tType,X3: product_prod(B,C)] : ( aa(product_prod(B,C),set(B),basic_fsts(B,C),X3) = aa(set(B),set(B),insert2(B,aa(product_prod(B,C),B,product_fst(B,C),X3)),bot_bot(set(B))) ) ).

% prod_set_defs(1)
tff(fact_1468_prod__set__defs_I2_J,axiom,
    ! [B: $tType,C: $tType,X3: product_prod(B,C)] : ( basic_snds(B,C,X3) = aa(set(C),set(C),insert2(C,aa(product_prod(B,C),C,product_snd(B,C),X3)),bot_bot(set(C))) ) ).

% prod_set_defs(2)
tff(fact_1469_one__div__numeral,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [N: num] : ( divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),N)) = aa(product_prod(B,B),B,product_fst(B,B),unique8689654367752047608divmod(B,one2,N)) ) ) ).

% one_div_numeral
tff(fact_1470_cofinal__def,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( bNF_Ca7293521722713021262ofinal(B,A4,R3)
    <=> ! [X4: B] :
          ( member(B,X4,field2(B,R3))
         => ? [Xa2: B] :
              ( member(B,Xa2,A4)
              & ( X4 != Xa2 )
              & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa2),R3) ) ) ) ).

% cofinal_def
tff(fact_1471_divmod__algorithm__code_I2_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M4: num] : ( unique8689654367752047608divmod(B,M4,one2) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(num,B,numeral_numeral(B),M4)),zero_zero(B)) ) ) ).

% divmod_algorithm_code(2)
tff(fact_1472_diff__numeral__special_I8_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M4: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))),aa(B,B,uminus_uminus(B),one_one(B))) = neg_numeral_sub(B,one2,M4) ) ) ).

% diff_numeral_special(8)
tff(fact_1473_diff__numeral__special_I7_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),N))) = neg_numeral_sub(B,N,one2) ) ) ).

% diff_numeral_special(7)
tff(fact_1474_minus__sub__one__diff__one,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [M4: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),neg_numeral_sub(B,M4,one2))),one_one(B)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4)) ) ) ).

% minus_sub_one_diff_one
tff(fact_1475_add__neg__numeral__special_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(num,B,numeral_numeral(B),N)) = neg_numeral_sub(B,N,one2) ) ) ).

% add_neg_numeral_special(4)
tff(fact_1476_add__neg__numeral__special_I3_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M4: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),M4)),aa(B,B,uminus_uminus(B),one_one(B))) = neg_numeral_sub(B,M4,one2) ) ) ).

% add_neg_numeral_special(3)
tff(fact_1477_diff__numeral__special_I2_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M4: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(num,B,numeral_numeral(B),M4)),one_one(B)) = neg_numeral_sub(B,M4,one2) ) ) ).

% diff_numeral_special(2)
tff(fact_1478_diff__numeral__special_I1_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(num,B,numeral_numeral(B),N)) = neg_numeral_sub(B,one2,N) ) ) ).

% diff_numeral_special(1)
tff(fact_1479_add__neg__numeral__special_I1_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M4: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))) = neg_numeral_sub(B,one2,M4) ) ) ).

% add_neg_numeral_special(1)
tff(fact_1480_add__neg__numeral__special_I2_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [M4: num] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),M4))),one_one(B)) = neg_numeral_sub(B,one2,M4) ) ) ).

% add_neg_numeral_special(2)
tff(fact_1481_eq__numeral__iff__iszero_I7_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X: num] :
          ( ( aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),X)) = one_one(B) )
        <=> ring_1_iszero(B,aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),X),one2))) ) ) ).

% eq_numeral_iff_iszero(7)
tff(fact_1482_eq__numeral__iff__iszero_I8_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Y: num] :
          ( ( one_one(B) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),Y)) )
        <=> ring_1_iszero(B,aa(num,B,numeral_numeral(B),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Y))) ) ) ).

% eq_numeral_iff_iszero(8)
tff(fact_1483_dbl__dec__simps_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_dec(B,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,one2))) ) ) ).

% dbl_dec_simps(4)
tff(fact_1484_divmod__algorithm__code_I3_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [N: num] : ( unique8689654367752047608divmod(B,one2,aa(num,num,bit0,N)) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),zero_zero(B)),aa(num,B,numeral_numeral(B),one2)) ) ) ).

% divmod_algorithm_code(3)
tff(fact_1485_divmod__step__eq,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [L: num,Q2: B,R3: B] :
          ( unique1321980374590559556d_step(B,L,aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),R3))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),L)),R3),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Q2)),one_one(B))),aa(B,B,aa(B,fun(B,B),minus_minus(B),R3),aa(num,B,numeral_numeral(B),L))),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Q2)),R3)) ) ) ).

% divmod_step_eq
tff(fact_1486_diff__numeral__special_I10_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),one_one(B))),one_one(B)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% diff_numeral_special(10)
tff(fact_1487_diff__numeral__special_I11_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(B,B,uminus_uminus(B),one_one(B))) = aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)) ) ) ).

% diff_numeral_special(11)
tff(fact_1488_add__neg__numeral__special_I9_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% add_neg_numeral_special(9)
tff(fact_1489_one__add__one,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)) ) ) ).

% one_add_one
tff(fact_1490_dbl__inc__simps_I3_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl_inc(B,one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,one2)) ) ) ).

% dbl_inc_simps(3)
tff(fact_1491_one__div__two__eq__zero,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ( divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = zero_zero(B) ) ) ).

% one_div_two_eq_zero
tff(fact_1492_bits__1__div__2,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ( divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = zero_zero(B) ) ) ).

% bits_1_div_2
tff(fact_1493_divmod__algorithm__code_I4_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [N: num] : ( unique8689654367752047608divmod(B,one2,aa(num,num,bit1,N)) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),zero_zero(B)),aa(num,B,numeral_numeral(B),one2)) ) ) ).

% divmod_algorithm_code(4)
tff(fact_1494_divmod__algorithm__code_I7_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M4: num,N: num] :
          ( unique8689654367752047608divmod(B,aa(num,num,bit0,M4),aa(num,num,bit1,N))
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M4),N),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),zero_zero(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,M4))),unique1321980374590559556d_step(B,aa(num,num,bit1,N),unique8689654367752047608divmod(B,aa(num,num,bit0,M4),aa(num,num,bit0,aa(num,num,bit1,N))))) ) ) ).

% divmod_algorithm_code(7)
tff(fact_1495_divmod__algorithm__code_I8_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M4: num,N: num] :
          ( unique8689654367752047608divmod(B,aa(num,num,bit1,M4),aa(num,num,bit1,N))
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less(num),M4),N),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),zero_zero(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit1,M4))),unique1321980374590559556d_step(B,aa(num,num,bit1,N),unique8689654367752047608divmod(B,aa(num,num,bit1,M4),aa(num,num,bit0,aa(num,num,bit1,N))))) ) ) ).

% divmod_algorithm_code(8)
tff(fact_1496_xor__num_Ocases,axiom,
    ! [X: product_prod(num,num)] :
      ( ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2) )
     => ( ! [N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N3)) )
       => ( ! [N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N3)) )
         => ( ! [M5: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),one2) )
           => ( ! [M5: num,N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit0,N3)) )
             => ( ! [M5: num,N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit1,N3)) )
               => ( ! [M5: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),one2) )
                 => ( ! [M5: num,N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit0,N3)) )
                   => ~ ! [M5: num,N3: num] : ( X != aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit1,N3)) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
tff(fact_1497_not__iszero__1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ~ ring_1_iszero(B,one_one(B)) ) ).

% not_iszero_1
tff(fact_1498_not__iszero__neg__1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ~ ring_1_iszero(B,aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% not_iszero_neg_1
tff(fact_1499_numeral__Bit1,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [N: num] : ( aa(num,B,numeral_numeral(B),aa(num,num,bit1,N)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),N)),aa(num,B,numeral_numeral(B),N))),one_one(B)) ) ) ).

% numeral_Bit1
tff(fact_1500_divmod__divmod__step,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M4: num,N: num] :
          ( unique8689654367752047608divmod(B,M4,N)
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less(num),M4),N),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),zero_zero(B)),aa(num,B,numeral_numeral(B),M4)),unique1321980374590559556d_step(B,N,unique8689654367752047608divmod(B,M4,aa(num,num,bit0,N)))) ) ) ).

% divmod_divmod_step
tff(fact_1501_left__add__twice,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A3)),Ba) ) ) ).

% left_add_twice
tff(fact_1502_mult__2__right,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [Z2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),Z2),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),Z2) ) ) ).

% mult_2_right
tff(fact_1503_mult__2,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [Z2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Z2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),Z2) ) ) ).

% mult_2
tff(fact_1504_eq__numeral__iff__iszero_I5_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X: num] :
          ( ( aa(num,B,numeral_numeral(B),X) = one_one(B) )
        <=> ring_1_iszero(B,neg_numeral_sub(B,X,one2)) ) ) ).

% eq_numeral_iff_iszero(5)
tff(fact_1505_eq__numeral__iff__iszero_I6_J,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Y: num] :
          ( ( one_one(B) = aa(num,B,numeral_numeral(B),Y) )
        <=> ring_1_iszero(B,neg_numeral_sub(B,one2,Y)) ) ) ).

% eq_numeral_iff_iszero(6)
tff(fact_1506_minus__1__div__2__eq,axiom,
    ! [B: $tType] :
      ( euclid8789492081693882211th_nat(B)
     => ( divide_divide(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% minus_1_div_2_eq
tff(fact_1507_set__bit__0,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B] : ( bit_se5668285175392031749et_bit(B,zero_zero(nat),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))) ) ) ).

% set_bit_0
tff(fact_1508_unset__bit__0,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B] : ( bit_se2638667681897837118et_bit(B,zero_zero(nat),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) ) ) ).

% unset_bit_0
tff(fact_1509_dbl__simps_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl(B,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% dbl_simps(4)
tff(fact_1510_dbl__simps_I3_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ( neg_numeral_dbl(B,one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)) ) ) ).

% dbl_simps(3)
tff(fact_1511_divmod__digit__1_I1_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),modulo_modulo(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Ba)))
             => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Ba)))),one_one(B)) = divide_divide(B,A3,Ba) ) ) ) ) ) ).

% divmod_digit_1(1)
tff(fact_1512_xor__numerals_I6_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% xor_numerals(6)
tff(fact_1513_xor__numerals_I4_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% xor_numerals(4)
tff(fact_1514_mod__mult__self1__is__0,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ba: B,A3: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3),Ba) = zero_zero(B) ) ) ).

% mod_mult_self1_is_0
tff(fact_1515_mod__mult__self2__is__0,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: B,Ba: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),Ba) = zero_zero(B) ) ) ).

% mod_mult_self2_is_0
tff(fact_1516_mod__by__1,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [A3: B] : ( modulo_modulo(B,A3,one_one(B)) = zero_zero(B) ) ) ).

% mod_by_1
tff(fact_1517_bits__mod__by__1,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A3: B] : ( modulo_modulo(B,A3,one_one(B)) = zero_zero(B) ) ) ).

% bits_mod_by_1
tff(fact_1518_mod__mult__self1,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: B,C2: B,Ba: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)),Ba) = modulo_modulo(B,A3,Ba) ) ) ).

% mod_mult_self1
tff(fact_1519_mod__mult__self2,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: B,Ba: B,C2: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)),Ba) = modulo_modulo(B,A3,Ba) ) ) ).

% mod_mult_self2
tff(fact_1520_mod__mult__self3,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [C2: B,Ba: B,A3: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)),A3),Ba) = modulo_modulo(B,A3,Ba) ) ) ).

% mod_mult_self3
tff(fact_1521_mod__mult__self4,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Ba: B,C2: B,A3: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)),A3),Ba) = modulo_modulo(B,A3,Ba) ) ) ).

% mod_mult_self4
tff(fact_1522_mod__minus1__right,axiom,
    ! [B: $tType] :
      ( euclid8851590272496341667cancel(B)
     => ! [A3: B] : ( modulo_modulo(B,A3,aa(B,B,uminus_uminus(B),one_one(B))) = zero_zero(B) ) ) ).

% mod_minus1_right
tff(fact_1523_one__mod__two__eq__one,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ( modulo_modulo(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ).

% one_mod_two_eq_one
tff(fact_1524_bits__one__mod__two__eq__one,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ( modulo_modulo(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ).

% bits_one_mod_two_eq_one
tff(fact_1525_xor__numerals_I3_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% xor_numerals(3)
tff(fact_1526_xor__numerals_I1_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y)) ) ) ).

% xor_numerals(1)
tff(fact_1527_xor__numerals_I2_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y)) ) ) ).

% xor_numerals(2)
tff(fact_1528_xor__numerals_I5_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X))),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,X)) ) ) ).

% xor_numerals(5)
tff(fact_1529_xor__numerals_I8_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X))),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit0,X)) ) ) ).

% xor_numerals(8)
tff(fact_1530_not__mod__2__eq__0__eq__1,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A3: B] :
          ( ( modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) != zero_zero(B) )
        <=> ( modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ) ).

% not_mod_2_eq_0_eq_1
tff(fact_1531_not__mod__2__eq__1__eq__0,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A3: B] :
          ( ( modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) != one_one(B) )
        <=> ( modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = zero_zero(B) ) ) ) ).

% not_mod_2_eq_1_eq_0
tff(fact_1532_minus__1__mod__2__eq,axiom,
    ! [B: $tType] :
      ( euclid8789492081693882211th_nat(B)
     => ( modulo_modulo(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ).

% minus_1_mod_2_eq
tff(fact_1533_bits__minus__1__mod__2__eq,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ( modulo_modulo(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ).

% bits_minus_1_mod_2_eq
tff(fact_1534_xor__numerals_I7_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% xor_numerals(7)
tff(fact_1535_one__mod__numeral,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [N: num] : ( modulo_modulo(B,one_one(B),aa(num,B,numeral_numeral(B),N)) = aa(product_prod(B,B),B,product_snd(B,B),unique8689654367752047608divmod(B,one2,N)) ) ) ).

% one_mod_numeral
tff(fact_1536_divmod__int__def,axiom,
    ! [M4: num,N: num] : ( unique8689654367752047608divmod(int,M4,N) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),divide_divide(int,aa(num,int,numeral_numeral(int),M4),aa(num,int,numeral_numeral(int),N))),modulo_modulo(int,aa(num,int,numeral_numeral(int),M4),aa(num,int,numeral_numeral(int),N))) ) ).

% divmod_int_def
tff(fact_1537_mod__mult__right__eq,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: B,Ba: B,C2: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),modulo_modulo(B,Ba,C2)),C2) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2) ) ) ).

% mod_mult_right_eq
tff(fact_1538_mod__mult__left__eq,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: B,C2: B,Ba: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),modulo_modulo(B,A3,C2)),Ba),C2) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2) ) ) ).

% mod_mult_left_eq
tff(fact_1539_mult__mod__right,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [C2: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),C2),modulo_modulo(B,A3,Ba)) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ).

% mult_mod_right
tff(fact_1540_mod__mult__mult2,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: B,C2: B,Ba: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),times_times(B),modulo_modulo(B,A3,Ba)),C2) ) ) ).

% mod_mult_mult2
tff(fact_1541_mod__mult__cong,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: B,C2: B,A5: B,Ba: B,B3: B] :
          ( ( modulo_modulo(B,A3,C2) = modulo_modulo(B,A5,C2) )
         => ( ( modulo_modulo(B,Ba,C2) = modulo_modulo(B,B3,C2) )
           => ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A5),B3),C2) ) ) ) ) ).

% mod_mult_cong
tff(fact_1542_mod__mult__eq,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: B,C2: B,Ba: B] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),modulo_modulo(B,A3,C2)),modulo_modulo(B,Ba,C2)),C2) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2) ) ) ).

% mod_mult_eq
tff(fact_1543_mod__eqE,axiom,
    ! [B: $tType] :
      ( euclid8851590272496341667cancel(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( ( modulo_modulo(B,A3,C2) = modulo_modulo(B,Ba,C2) )
         => ~ ! [D3: B] : ( Ba != aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),D3)) ) ) ) ).

% mod_eqE
tff(fact_1544_xor_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => monoid(B,bit_se5824344971392196577ns_xor(B),zero_zero(B)) ) ).

% xor.monoid_axioms
tff(fact_1545_mult__div__mod__eq,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [Ba: B,A3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),divide_divide(B,A3,Ba))),modulo_modulo(B,A3,Ba)) = A3 ) ) ).

% mult_div_mod_eq
tff(fact_1546_mod__mult__div__eq,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A3,Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),divide_divide(B,A3,Ba))) = A3 ) ) ).

% mod_mult_div_eq
tff(fact_1547_mod__div__mult__eq,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A3,Ba)),aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,Ba)),Ba)) = A3 ) ) ).

% mod_div_mult_eq
tff(fact_1548_div__mult__mod__eq,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,Ba)),Ba)),modulo_modulo(B,A3,Ba)) = A3 ) ) ).

% div_mult_mod_eq
tff(fact_1549_mod__div__decomp,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A3: B,Ba: B] : ( A3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,Ba)),Ba)),modulo_modulo(B,A3,Ba)) ) ) ).

% mod_div_decomp
tff(fact_1550_cancel__div__mod__rules_I1_J,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,Ba)),Ba)),modulo_modulo(B,A3,Ba))),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2) ) ) ).

% cancel_div_mod_rules(1)
tff(fact_1551_cancel__div__mod__rules_I2_J,axiom,
    ! [B: $tType] :
      ( semidom_modulo(B)
     => ! [Ba: B,A3: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),divide_divide(B,A3,Ba))),modulo_modulo(B,A3,Ba))),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),C2) ) ) ).

% cancel_div_mod_rules(2)
tff(fact_1552_div__mult1__eq,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [A3: B,Ba: B,C2: B] : ( divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),divide_divide(B,Ba,C2))),divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),modulo_modulo(B,Ba,C2)),C2)) ) ) ).

% div_mult1_eq
tff(fact_1553_minus__mult__div__eq__mod,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),divide_divide(B,A3,Ba))) = modulo_modulo(B,A3,Ba) ) ) ).

% minus_mult_div_eq_mod
tff(fact_1554_minus__mod__eq__mult__div,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),modulo_modulo(B,A3,Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),Ba),divide_divide(B,A3,Ba)) ) ) ).

% minus_mod_eq_mult_div
tff(fact_1555_minus__mod__eq__div__mult,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),modulo_modulo(B,A3,Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,Ba)),Ba) ) ) ).

% minus_mod_eq_div_mult
tff(fact_1556_minus__div__mult__eq__mod,axiom,
    ! [B: $tType] :
      ( semiring_modulo(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,Ba)),Ba)) = modulo_modulo(B,A3,Ba) ) ) ).

% minus_div_mult_eq_mod
tff(fact_1557_divmod__def,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M4: num,N: num] : ( unique8689654367752047608divmod(B,M4,N) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),divide_divide(B,aa(num,B,numeral_numeral(B),M4),aa(num,B,numeral_numeral(B),N))),modulo_modulo(B,aa(num,B,numeral_numeral(B),M4),aa(num,B,numeral_numeral(B),N))) ) ) ).

% divmod_def
tff(fact_1558_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),C2)
         => ( modulo_modulo(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),modulo_modulo(B,divide_divide(B,A3,Ba),C2))),modulo_modulo(B,A3,Ba)) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
tff(fact_1559_divmod__digit__0_I2_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),modulo_modulo(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Ba))),Ba)
           => ( modulo_modulo(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Ba)) = modulo_modulo(B,A3,Ba) ) ) ) ) ).

% divmod_digit_0(2)
tff(fact_1560_divmod__digit__0_I1_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),modulo_modulo(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Ba))),Ba)
           => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Ba))) = divide_divide(B,A3,Ba) ) ) ) ) ).

% divmod_digit_0(1)
tff(fact_1561_mod__double__modulus,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M4: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),M4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X)
           => ( ( modulo_modulo(B,X,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4)) = modulo_modulo(B,X,M4) )
              | ( modulo_modulo(B,X,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,X,M4)),M4) ) ) ) ) ) ).

% mod_double_modulus
tff(fact_1562_divmod__digit__1_I2_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),modulo_modulo(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Ba)))
             => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),modulo_modulo(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Ba))),Ba) = modulo_modulo(B,A3,Ba) ) ) ) ) ) ).

% divmod_digit_1(2)
tff(fact_1563_signed__take__bit__rec,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat,A3: B] :
          ( bit_ri4674362597316999326ke_bit(B,N,A3)
          = $ite(N = zero_zero(nat),aa(B,B,uminus_uminus(B),modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_ri4674362597316999326ke_bit(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))))) ) ) ).

% signed_take_bit_rec
tff(fact_1564_take__bit__rec,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] :
          ( bit_se2584673776208193580ke_bit(B,N,A3)
          = $ite(N = zero_zero(nat),zero_zero(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))) ) ) ).

% take_bit_rec
tff(fact_1565_set__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] : ( bit_se5668285175392031749et_bit(B,aa(nat,nat,suc,N),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_se5668285175392031749et_bit(B,N,divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))))) ) ) ).

% set_bit_Suc
tff(fact_1566_unset__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] : ( bit_se2638667681897837118et_bit(B,aa(nat,nat,suc,N),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_se2638667681897837118et_bit(B,N,divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))))) ) ) ).

% unset_bit_Suc
tff(fact_1567_odd__two__times__div__two__succ,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A3: B] :
          ( ~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),one_one(B)) = A3 ) ) ) ).

% odd_two_times_div_two_succ
tff(fact_1568_or__numerals_I4_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% or_numerals(4)
tff(fact_1569_or__numerals_I6_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% or_numerals(6)
tff(fact_1570_or__numerals_I7_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% or_numerals(7)
tff(fact_1571_take__bit__numeral__1,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [L: num] : ( bit_se2584673776208193580ke_bit(B,aa(num,nat,numeral_numeral(nat),L),one_one(B)) = one_one(B) ) ) ).

% take_bit_numeral_1
tff(fact_1572_signed__take__bit__numeral__of__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [K: num] : ( bit_ri4674362597316999326ke_bit(B,aa(num,nat,numeral_numeral(nat),K),one_one(B)) = one_one(B) ) ) ).

% signed_take_bit_numeral_of_1
tff(fact_1573_dvd__times__right__cancel__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( A3 != zero_zero(B) )
         => ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3))
          <=> dvd_dvd(B,Ba,C2) ) ) ) ).

% dvd_times_right_cancel_iff
tff(fact_1574_dvd__times__left__cancel__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( A3 != zero_zero(B) )
         => ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2))
          <=> dvd_dvd(B,Ba,C2) ) ) ) ).

% dvd_times_left_cancel_iff
tff(fact_1575_dvd__mult__cancel__right,axiom,
    ! [B: $tType] :
      ( idom(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
        <=> ( ( C2 = zero_zero(B) )
            | dvd_dvd(B,A3,Ba) ) ) ) ).

% dvd_mult_cancel_right
tff(fact_1576_dvd__mult__cancel__left,axiom,
    ! [B: $tType] :
      ( idom(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
        <=> ( ( C2 = zero_zero(B) )
            | dvd_dvd(B,A3,Ba) ) ) ) ).

% dvd_mult_cancel_left
tff(fact_1577_dvd__add__times__triv__left__iff,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),Ba))
        <=> dvd_dvd(B,A3,Ba) ) ) ).

% dvd_add_times_triv_left_iff
tff(fact_1578_dvd__add__times__triv__right__iff,axiom,
    ! [B: $tType] :
      ( comm_s4317794764714335236cancel(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),plus_plus(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)))
        <=> dvd_dvd(B,A3,Ba) ) ) ).

% dvd_add_times_triv_right_iff
tff(fact_1579_unit__prod,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( dvd_dvd(B,Ba,one_one(B))
           => dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),one_one(B)) ) ) ) ).

% unit_prod
tff(fact_1580_dvd__div__mult__self,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,Ba)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,Ba,A3)),A3) = Ba ) ) ) ).

% dvd_div_mult_self
tff(fact_1581_dvd__mult__div__cancel,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,Ba)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),divide_divide(B,Ba,A3)) = Ba ) ) ) ).

% dvd_mult_div_cancel
tff(fact_1582_unit__div__1__div__1,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( divide_divide(B,one_one(B),divide_divide(B,one_one(B),A3)) = A3 ) ) ) ).

% unit_div_1_div_1
tff(fact_1583_unit__div__1__unit,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => dvd_dvd(B,divide_divide(B,one_one(B),A3),one_one(B)) ) ) ).

% unit_div_1_unit
tff(fact_1584_unit__div,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( dvd_dvd(B,Ba,one_one(B))
           => dvd_dvd(B,divide_divide(B,A3,Ba),one_one(B)) ) ) ) ).

% unit_div
tff(fact_1585_take__bit__Suc__1,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),one_one(B)) = one_one(B) ) ) ).

% take_bit_Suc_1
tff(fact_1586_bit_Odisj__one__left,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(B,B,uminus_uminus(B),one_one(B))),X) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.disj_one_left
tff(fact_1587_bit_Odisj__one__right,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),X),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.disj_one_right
tff(fact_1588_signed__take__bit__of__minus__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] : ( bit_ri4674362597316999326ke_bit(B,N,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% signed_take_bit_of_minus_1
tff(fact_1589_signed__take__bit__Suc__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] : ( bit_ri4674362597316999326ke_bit(B,aa(nat,nat,suc,N),one_one(B)) = one_one(B) ) ) ).

% signed_take_bit_Suc_1
tff(fact_1590_unit__div__mult__self,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,Ba,A3)),A3) = Ba ) ) ) ).

% unit_div_mult_self
tff(fact_1591_unit__mult__div__div,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),Ba),divide_divide(B,one_one(B),A3)) = divide_divide(B,Ba,A3) ) ) ) ).

% unit_mult_div_div
tff(fact_1592_take__bit__of__1__eq__0__iff,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit(B,N,one_one(B)) = zero_zero(B) )
        <=> ( N = zero_zero(nat) ) ) ) ).

% take_bit_of_1_eq_0_iff
tff(fact_1593_or__numerals_I2_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(2)
tff(fact_1594_or__numerals_I8_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X))),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,X)) ) ) ).

% or_numerals(8)
tff(fact_1595_even__mult__iff,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
        <=> ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
            | dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),Ba) ) ) ) ).

% even_mult_iff
tff(fact_1596_or__numerals_I3_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% or_numerals(3)
tff(fact_1597_or__numerals_I5_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X))),one_one(B)) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,X)) ) ) ).

% or_numerals(5)
tff(fact_1598_or__numerals_I1_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(1)
tff(fact_1599_even__plus__one__iff,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A3: B] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B)))
        <=> ~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3) ) ) ).

% even_plus_one_iff
tff(fact_1600_even__succ__div__2,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A3: B] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A3),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_2
tff(fact_1601_odd__succ__div__two,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A3: B] :
          ( ~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),one_one(B)) ) ) ) ).

% odd_succ_div_two
tff(fact_1602_even__succ__div__two,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A3: B] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ) ).

% even_succ_div_two
tff(fact_1603_dvd__triv__right,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B,Ba: B] : dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3)) ) ).

% dvd_triv_right
tff(fact_1604_dvd__mult__right,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2)
         => dvd_dvd(B,Ba,C2) ) ) ).

% dvd_mult_right
tff(fact_1605_mult__dvd__mono,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( dvd_dvd(B,A3,Ba)
         => ( dvd_dvd(B,C2,D2)
           => dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),D2)) ) ) ) ).

% mult_dvd_mono
tff(fact_1606_dvd__triv__left,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B,Ba: B] : dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ).

% dvd_triv_left
tff(fact_1607_dvd__mult__left,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2)
         => dvd_dvd(B,A3,C2) ) ) ).

% dvd_mult_left
tff(fact_1608_dvd__mult2,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,Ba)
         => dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ).

% dvd_mult2
tff(fact_1609_dvd__mult,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( dvd_dvd(B,A3,C2)
         => dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) ) ) ).

% dvd_mult
tff(fact_1610_dvd__def,axiom,
    ! [B: $tType] :
      ( dvd(B)
     => ! [Ba: B,A3: B] :
          ( dvd_dvd(B,Ba,A3)
        <=> ? [K4: B] : ( A3 = aa(B,B,aa(B,fun(B,B),times_times(B),Ba),K4) ) ) ) ).

% dvd_def
tff(fact_1611_dvdI,axiom,
    ! [B: $tType] :
      ( dvd(B)
     => ! [A3: B,Ba: B,K: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),times_times(B),Ba),K) )
         => dvd_dvd(B,Ba,A3) ) ) ).

% dvdI
tff(fact_1612_dvdE,axiom,
    ! [B: $tType] :
      ( dvd(B)
     => ! [Ba: B,A3: B] :
          ( dvd_dvd(B,Ba,A3)
         => ~ ! [K2: B] : ( A3 != aa(B,B,aa(B,fun(B,B),times_times(B),Ba),K2) ) ) ) ).

% dvdE
tff(fact_1613_dvd__unit__imp__unit,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,Ba)
         => ( dvd_dvd(B,Ba,one_one(B))
           => dvd_dvd(B,A3,one_one(B)) ) ) ) ).

% dvd_unit_imp_unit
tff(fact_1614_unit__imp__dvd,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => dvd_dvd(B,Ba,A3) ) ) ).

% unit_imp_dvd
tff(fact_1615_one__dvd,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B] : dvd_dvd(B,one_one(B),A3) ) ).

% one_dvd
tff(fact_1616_take__bit__Suc__bit0,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat,K: num] : ( bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),aa(num,B,numeral_numeral(B),aa(num,num,bit0,K))) = aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,N,aa(num,B,numeral_numeral(B),K))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% take_bit_Suc_bit0
tff(fact_1617_not__is__unit__0,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ~ dvd_dvd(B,zero_zero(B),one_one(B)) ) ).

% not_is_unit_0
tff(fact_1618_unit__mult__right__cancel,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3) )
          <=> ( Ba = C2 ) ) ) ) ).

% unit_mult_right_cancel
tff(fact_1619_unit__mult__left__cancel,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2) )
          <=> ( Ba = C2 ) ) ) ) ).

% unit_mult_left_cancel
tff(fact_1620_mult__unit__dvd__iff_H,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2)
          <=> dvd_dvd(B,Ba,C2) ) ) ) ).

% mult_unit_dvd_iff'
tff(fact_1621_dvd__mult__unit__iff_H,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
          <=> dvd_dvd(B,A3,C2) ) ) ) ).

% dvd_mult_unit_iff'
tff(fact_1622_mult__unit__dvd__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2)
          <=> dvd_dvd(B,A3,C2) ) ) ) ).

% mult_unit_dvd_iff
tff(fact_1623_dvd__mult__unit__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
          <=> dvd_dvd(B,A3,C2) ) ) ) ).

% dvd_mult_unit_iff
tff(fact_1624_is__unit__mult__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),one_one(B))
        <=> ( dvd_dvd(B,A3,one_one(B))
            & dvd_dvd(B,Ba,one_one(B)) ) ) ) ).

% is_unit_mult_iff
tff(fact_1625_dvd__div__mult,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( dvd_dvd(B,C2,Ba)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,Ba,C2)),A3) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3),C2) ) ) ) ).

% dvd_div_mult
tff(fact_1626_div__mult__swap,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( dvd_dvd(B,C2,Ba)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),divide_divide(B,Ba,C2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2) ) ) ) ).

% div_mult_swap
tff(fact_1627_div__div__eq__right,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( dvd_dvd(B,C2,Ba)
         => ( dvd_dvd(B,Ba,A3)
           => ( divide_divide(B,A3,divide_divide(B,Ba,C2)) = aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,Ba)),C2) ) ) ) ) ).

% div_div_eq_right
tff(fact_1628_dvd__div__mult2__eq,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2),A3)
         => ( divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = divide_divide(B,divide_divide(B,A3,Ba),C2) ) ) ) ).

% dvd_div_mult2_eq
tff(fact_1629_dvd__mult__imp__div,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),Ba)
         => dvd_dvd(B,A3,divide_divide(B,Ba,C2)) ) ) ).

% dvd_mult_imp_div
tff(fact_1630_div__mult__div__if__dvd,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B,D2: B,C2: B] :
          ( dvd_dvd(B,Ba,A3)
         => ( dvd_dvd(B,D2,C2)
           => ( aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,Ba)),divide_divide(B,C2,D2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),D2)) ) ) ) ) ).

% div_mult_div_if_dvd
tff(fact_1631_dvd__div__unit__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( dvd_dvd(B,A3,divide_divide(B,C2,Ba))
          <=> dvd_dvd(B,A3,C2) ) ) ) ).

% dvd_div_unit_iff
tff(fact_1632_div__unit__dvd__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( dvd_dvd(B,divide_divide(B,A3,Ba),C2)
          <=> dvd_dvd(B,A3,C2) ) ) ) ).

% div_unit_dvd_iff
tff(fact_1633_unit__div__cancel,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( ( divide_divide(B,Ba,A3) = divide_divide(B,C2,A3) )
          <=> ( Ba = C2 ) ) ) ) ).

% unit_div_cancel
tff(fact_1634_or_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => monoid(B,bit_se1065995026697491101ons_or(B),zero_zero(B)) ) ).

% or.monoid_axioms
tff(fact_1635_or_Osemilattice__neutr__axioms,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => semilattice_neutr(B,bit_se1065995026697491101ons_or(B),zero_zero(B)) ) ).

% or.semilattice_neutr_axioms
tff(fact_1636_unity__coeff__ex,axiom,
    ! [B: $tType] :
      ( ( dvd(B)
        & semiring_0(B) )
     => ! [Pa: fun(B,$o),L: B] :
          ( ? [X4: B] : aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),times_times(B),L),X4))
        <=> ? [X4: B] :
              ( dvd_dvd(B,L,aa(B,B,aa(B,fun(B,B),plus_plus(B),X4),zero_zero(B)))
              & aa(B,$o,Pa,X4) ) ) ) ).

% unity_coeff_ex
tff(fact_1637_unit__dvdE,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ~ ( ( A3 != zero_zero(B) )
             => ! [C4: B] : ( Ba != aa(B,B,aa(B,fun(B,B),times_times(B),A3),C4) ) ) ) ) ).

% unit_dvdE
tff(fact_1638_inf__period_I3_J,axiom,
    ! [B: $tType] :
      ( ( comm_ring(B)
        & dvd(B) )
     => ! [D2: B,D4: B,T4: B] :
          ( dvd_dvd(B,D2,D4)
         => ! [X3: B,K3: B] :
              ( dvd_dvd(B,D2,aa(B,B,aa(B,fun(B,B),plus_plus(B),X3),T4))
            <=> dvd_dvd(B,D2,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X3),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D4))),T4)) ) ) ) ).

% inf_period(3)
tff(fact_1639_inf__period_I4_J,axiom,
    ! [B: $tType] :
      ( ( comm_ring(B)
        & dvd(B) )
     => ! [D2: B,D4: B,T4: B] :
          ( dvd_dvd(B,D2,D4)
         => ! [X3: B,K3: B] :
              ( ~ dvd_dvd(B,D2,aa(B,B,aa(B,fun(B,B),plus_plus(B),X3),T4))
            <=> ~ dvd_dvd(B,D2,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X3),aa(B,B,aa(B,fun(B,B),times_times(B),K3),D4))),T4)) ) ) ) ).

% inf_period(4)
tff(fact_1640_dvd__div__eq__mult,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( A3 != zero_zero(B) )
         => ( dvd_dvd(B,A3,Ba)
           => ( ( divide_divide(B,Ba,A3) = C2 )
            <=> ( Ba = aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3) ) ) ) ) ) ).

% dvd_div_eq_mult
tff(fact_1641_div__dvd__iff__mult,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( ( Ba != zero_zero(B) )
         => ( dvd_dvd(B,Ba,A3)
           => ( dvd_dvd(B,divide_divide(B,A3,Ba),C2)
            <=> dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ) ) ).

% div_dvd_iff_mult
tff(fact_1642_dvd__div__iff__mult,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( ( C2 != zero_zero(B) )
         => ( dvd_dvd(B,C2,Ba)
           => ( dvd_dvd(B,A3,divide_divide(B,Ba,C2))
            <=> dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),Ba) ) ) ) ) ).

% dvd_div_iff_mult
tff(fact_1643_dvd__div__div__eq__mult,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,C2: B,Ba: B,D2: B] :
          ( ( A3 != zero_zero(B) )
         => ( ( C2 != zero_zero(B) )
           => ( dvd_dvd(B,A3,Ba)
             => ( dvd_dvd(B,C2,D2)
               => ( ( divide_divide(B,Ba,A3) = divide_divide(B,D2,C2) )
                <=> ( aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),D2) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
tff(fact_1644_unit__div__eq__0__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( ( divide_divide(B,A3,Ba) = zero_zero(B) )
          <=> ( A3 = zero_zero(B) ) ) ) ) ).

% unit_div_eq_0_iff
tff(fact_1645_is__unit__div__mult2__eq,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( dvd_dvd(B,C2,one_one(B))
           => ( divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = divide_divide(B,divide_divide(B,A3,Ba),C2) ) ) ) ) ).

% is_unit_div_mult2_eq
tff(fact_1646_unit__div__mult__swap,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( dvd_dvd(B,C2,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),divide_divide(B,Ba,C2)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2) ) ) ) ).

% unit_div_mult_swap
tff(fact_1647_unit__div__commute,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,Ba)),C2) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),Ba) ) ) ) ).

% unit_div_commute
tff(fact_1648_div__mult__unit2,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( dvd_dvd(B,C2,one_one(B))
         => ( dvd_dvd(B,Ba,A3)
           => ( divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = divide_divide(B,divide_divide(B,A3,Ba),C2) ) ) ) ) ).

% div_mult_unit2
tff(fact_1649_unit__eq__div2,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( ( A3 = divide_divide(B,C2,Ba) )
          <=> ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba) = C2 ) ) ) ) ).

% unit_eq_div2
tff(fact_1650_unit__eq__div1,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( ( divide_divide(B,A3,Ba) = C2 )
          <=> ( A3 = aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba) ) ) ) ) ).

% unit_eq_div1
tff(fact_1651_unit__imp__mod__eq__0,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [Ba: B,A3: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( modulo_modulo(B,A3,Ba) = zero_zero(B) ) ) ) ).

% unit_imp_mod_eq_0
tff(fact_1652_take__bit__Suc__bit1,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat,K: num] : ( bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),aa(num,B,numeral_numeral(B),aa(num,num,bit1,K))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,N,aa(num,B,numeral_numeral(B),K))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),one_one(B)) ) ) ).

% take_bit_Suc_bit1
tff(fact_1653_take__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] : ( bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,N,divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) ) ) ).

% take_bit_Suc
tff(fact_1654_signed__take__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat,A3: B] : ( bit_ri4674362597316999326ke_bit(B,aa(nat,nat,suc,N),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_ri4674362597316999326ke_bit(B,N,divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))))) ) ) ).

% signed_take_bit_Suc
tff(fact_1655_is__unit__div__mult__cancel__right,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( dvd_dvd(B,Ba,one_one(B))
           => ( divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3)) = divide_divide(B,one_one(B),Ba) ) ) ) ) ).

% is_unit_div_mult_cancel_right
tff(fact_1656_is__unit__div__mult__cancel__left,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( dvd_dvd(B,Ba,one_one(B))
           => ( divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = divide_divide(B,one_one(B),Ba) ) ) ) ) ).

% is_unit_div_mult_cancel_left
tff(fact_1657_is__unitE,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ~ ( ( A3 != zero_zero(B) )
             => ! [B4: B] :
                  ( ( B4 != zero_zero(B) )
                 => ( dvd_dvd(B,B4,one_one(B))
                   => ( ( divide_divide(B,one_one(B),A3) = B4 )
                     => ( ( divide_divide(B,one_one(B),B4) = A3 )
                       => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),B4) = one_one(B) )
                         => ( divide_divide(B,C2,A3) != aa(B,B,aa(B,fun(B,B),times_times(B),C2),B4) ) ) ) ) ) ) ) ) ) ).

% is_unitE
tff(fact_1658_evenE,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A3: B] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ~ ! [B4: B] : ( A3 != aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B4) ) ) ) ).

% evenE
tff(fact_1659_odd__one,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),one_one(B)) ) ).

% odd_one
tff(fact_1660_even__two__times__div__two,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A3: B] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) = A3 ) ) ) ).

% even_two_times_div_two
tff(fact_1661_odd__iff__mod__2__eq__one,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A3: B] :
          ( ~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
        <=> ( modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = one_one(B) ) ) ) ).

% odd_iff_mod_2_eq_one
tff(fact_1662_oddE,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A3: B] :
          ( ~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ~ ! [B4: B] : ( A3 != aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),B4)),one_one(B)) ) ) ) ).

% oddE
tff(fact_1663_mod2__eq__if,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A3: B] :
          ( modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))
          = $ite(dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3),zero_zero(B),one_one(B)) ) ) ).

% mod2_eq_if
tff(fact_1664_parity__cases,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [A3: B] :
          ( ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
           => ( modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) != zero_zero(B) ) )
         => ~ ( ~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
             => ( modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) != one_one(B) ) ) ) ) ).

% parity_cases
tff(fact_1665_flip__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] : ( bit_se8732182000553998342ip_bit(B,aa(nat,nat,suc,N),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_se8732182000553998342ip_bit(B,N,divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))))) ) ) ).

% flip_bit_Suc
tff(fact_1666_divmod__BitM__2__eq,axiom,
    ! [M4: num] : ( unique8689654367752047608divmod(int,bitM(M4),aa(num,num,bit0,one2)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M4)),one_one(int))),one_one(int)) ) ).

% divmod_BitM_2_eq
tff(fact_1667_even__succ__mod__exp,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A3: B,N: nat] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),modulo_modulo(B,A3,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N))) ) ) ) ) ).

% even_succ_mod_exp
tff(fact_1668_even__succ__div__exp,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A3: B,N: nat] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = divide_divide(B,A3,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) ) ) ) ) ).

% even_succ_div_exp
tff(fact_1669_stable__imp__take__bit__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B,N: nat] :
          ( ( divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = A3 )
         => ( bit_se2584673776208193580ke_bit(B,N,A3)
            = $ite(dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3),zero_zero(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)),one_one(B))) ) ) ) ).

% stable_imp_take_bit_eq
tff(fact_1670_mask__Suc__double,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(B,aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(B,N))) ) ) ).

% mask_Suc_double
tff(fact_1671_neg__eucl__rel__int__mult__2,axiom,
    ! [Ba: int,A3: int,Q2: int,R3: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Ba),zero_zero(int))
     => ( eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),A3),one_one(int)),Ba,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R3))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A3)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Ba),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),R3)),one_one(int)))) ) ) ).

% neg_eucl_rel_int_mult_2
tff(fact_1672_pos__eucl__rel__int__mult__2,axiom,
    ! [Ba: int,A3: int,Q2: int,R3: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Ba)
     => ( eucl_rel_int(A3,Ba,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R3))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),A3)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Ba),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),R3)))) ) ) ).

% pos_eucl_rel_int_mult_2
tff(fact_1673_power__one,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),one_one(B)),N) = one_one(B) ) ) ).

% power_one
tff(fact_1674_power__inject__exp,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,M4: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3)
         => ( ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),M4) = aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N) )
          <=> ( M4 = N ) ) ) ) ).

% power_inject_exp
tff(fact_1675_power__increasing__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Ba: B,X: nat,Y: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),Ba),X)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Ba),Y))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),Y) ) ) ) ).

% power_increasing_iff
tff(fact_1676_power__strict__increasing__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Ba: B,X: nat,Y: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),Ba),X)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Ba),Y))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),Y) ) ) ) ).

% power_strict_increasing_iff
tff(fact_1677_minus__one__mult__self,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)) = one_one(B) ) ) ).

% minus_one_mult_self
tff(fact_1678_left__minus__one__mult__self,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat,A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),A3)) = A3 ) ) ).

% left_minus_one_mult_self
tff(fact_1679_mask__Suc__0,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ( bit_se2239418461657761734s_mask(B,aa(nat,nat,suc,zero_zero(nat))) = one_one(B) ) ) ).

% mask_Suc_0
tff(fact_1680_power__add__numeral2,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A3: B,M4: num,N: num,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(num,nat,numeral_numeral(nat),M4))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(num,nat,numeral_numeral(nat),N))),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M4),N)))),Ba) ) ) ).

% power_add_numeral2
tff(fact_1681_power__add__numeral,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A3: B,M4: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(num,nat,numeral_numeral(nat),M4))),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(num,nat,numeral_numeral(nat),N))) = aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M4),N))) ) ) ).

% power_add_numeral
tff(fact_1682_take__bit__minus__one__eq__mask,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(B,N,aa(B,B,uminus_uminus(B),one_one(B))) = bit_se2239418461657761734s_mask(B,N) ) ) ).

% take_bit_minus_one_eq_mask
tff(fact_1683_power__decreasing__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Ba: B,M4: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),one_one(B))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),Ba),M4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Ba),N))
            <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M4) ) ) ) ) ).

% power_decreasing_iff
tff(fact_1684_power__strict__decreasing__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Ba: B,M4: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),one_one(B))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),Ba),M4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Ba),N))
            <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M4) ) ) ) ) ).

% power_strict_decreasing_iff
tff(fact_1685_power__minus1__even,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = one_one(B) ) ) ).

% power_minus1_even
tff(fact_1686_neg__one__odd__power,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [N: nat] :
          ( ~ dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),N)
         => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ) ).

% neg_one_odd_power
tff(fact_1687_neg__one__even__power,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [N: nat] :
          ( dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),N)
         => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N) = one_one(B) ) ) ) ).

% neg_one_even_power
tff(fact_1688_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [N: nat] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)),one_one(B)))
        <=> ( N = zero_zero(nat) ) ) ) ).

% semiring_parity_class.even_mask_iff
tff(fact_1689_divmod_H__nat__def,axiom,
    ! [M4: num,N: num] : ( unique8689654367752047608divmod(nat,M4,N) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),divide_divide(nat,aa(num,nat,numeral_numeral(nat),M4),aa(num,nat,numeral_numeral(nat),N))),modulo_modulo(nat,aa(num,nat,numeral_numeral(nat),M4),aa(num,nat,numeral_numeral(nat),N))) ) ).

% divmod'_nat_def
tff(fact_1690_power__commuting__commutes,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [X: B,Y: B,N: nat] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),X),Y) = aa(B,B,aa(B,fun(B,B),times_times(B),Y),X) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)),Y) = aa(B,B,aa(B,fun(B,B),times_times(B),Y),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)) ) ) ) ).

% power_commuting_commutes
tff(fact_1691_power__mult__distrib,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: B,Ba: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Ba),N)) ) ) ).

% power_mult_distrib
tff(fact_1692_power__commutes,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A3: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ).

% power_commutes
tff(fact_1693_unique__quotient,axiom,
    ! [A3: int,Ba: int,Q2: int,R3: int,Q4: int,R4: int] :
      ( eucl_rel_int(A3,Ba,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R3))
     => ( eucl_rel_int(A3,Ba,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q4),R4))
       => ( Q2 = Q4 ) ) ) ).

% unique_quotient
tff(fact_1694_unique__remainder,axiom,
    ! [A3: int,Ba: int,Q2: int,R3: int,Q4: int,R4: int] :
      ( eucl_rel_int(A3,Ba,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R3))
     => ( eucl_rel_int(A3,Ba,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q4),R4))
       => ( R3 = R4 ) ) ) ).

% unique_remainder
tff(fact_1695_power__increasing,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [N: nat,N4: nat,A3: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N4)) ) ) ) ).

% power_increasing
tff(fact_1696_one__le__power,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ).

% one_le_power
tff(fact_1697_power__strict__increasing,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [N: nat,N4: nat,A3: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N4)) ) ) ) ).

% power_strict_increasing
tff(fact_1698_power__less__imp__less__exp,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,M4: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),M4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N))
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N) ) ) ) ).

% power_less_imp_less_exp
tff(fact_1699_left__right__inverse__power,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [X: B,Y: B,N: nat] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),X),Y) = one_one(B) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),N)) = one_one(B) ) ) ) ).

% left_right_inverse_power
tff(fact_1700_power__Suc,axiom,
    ! [B: $tType] :
      ( power(B)
     => ! [A3: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ).

% power_Suc
tff(fact_1701_power__Suc2,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A3: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)),A3) ) ) ).

% power_Suc2
tff(fact_1702_power__0,axiom,
    ! [B: $tType] :
      ( power(B)
     => ! [A3: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),zero_zero(nat)) = one_one(B) ) ) ).

% power_0
tff(fact_1703_power__one__over,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),divide_divide(B,one_one(B),A3)),N) = divide_divide(B,one_one(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ).

% power_one_over
tff(fact_1704_power__add,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A3: B,M4: nat,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),M4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ).

% power_add
tff(fact_1705_mask__eq__exp__minus__1,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(B,N) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)),one_one(B)) ) ) ).

% mask_eq_exp_minus_1
tff(fact_1706_power__decreasing,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [N: nat,N4: nat,A3: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ) ) ).

% power_decreasing
tff(fact_1707_power__le__one,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)),one_one(B)) ) ) ) ).

% power_le_one
tff(fact_1708_power__le__imp__le__exp,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,M4: nat,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),M4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N))
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N) ) ) ) ).

% power_le_imp_le_exp
tff(fact_1709_power__strict__decreasing,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [N: nat,N4: nat,A3: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ) ) ).

% power_strict_decreasing
tff(fact_1710_power__gt1__lemma,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N))) ) ) ).

% power_gt1_lemma
tff(fact_1711_power__less__power__Suc,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N))) ) ) ).

% power_less_power_Suc
tff(fact_1712_self__le__power,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ) ).

% self_le_power
tff(fact_1713_power__0__left,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat] :
          ( aa(nat,B,aa(B,fun(nat,B),power_power(B),zero_zero(B)),N)
          = $ite(N = zero_zero(nat),one_one(B),zero_zero(B)) ) ) ).

% power_0_left
tff(fact_1714_dvd__power__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [X: B,M4: nat,N: nat] :
          ( ( X != zero_zero(B) )
         => ( dvd_dvd(B,aa(nat,B,aa(B,fun(nat,B),power_power(B),X),M4),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N))
          <=> ( dvd_dvd(B,X,one_one(B))
              | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N) ) ) ) ) ).

% dvd_power_iff
tff(fact_1715_one__less__power,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ) ).

% one_less_power
tff(fact_1716_power__gt1,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,suc,N))) ) ) ).

% power_gt1
tff(fact_1717_power__minus,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [A3: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),A3)),N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ).

% power_minus
tff(fact_1718_power2__eq__square,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A3: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),A3) ) ) ).

% power2_eq_square
tff(fact_1719_power4__eq__xxxx,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [X: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,aa(num,num,bit0,one2)))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),X)),X)),X) ) ) ).

% power4_eq_xxxx
tff(fact_1720_one__power2,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),one_one(B)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(B) ) ) ).

% one_power2
tff(fact_1721_is__unit__power__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,N: nat] :
          ( dvd_dvd(B,aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N),one_one(B))
        <=> ( dvd_dvd(B,A3,one_one(B))
            | ( N = zero_zero(nat) ) ) ) ) ).

% is_unit_power_iff
tff(fact_1722_dvd__power,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [N: nat,X: B] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
            | ( X = one_one(B) ) )
         => dvd_dvd(B,X,aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)) ) ) ).

% dvd_power
tff(fact_1723_power3__eq__cube,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A3: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),A3)),A3) ) ) ).

% power3_eq_cube
tff(fact_1724_eucl__rel__int__by0,axiom,
    ! [K: int] : eucl_rel_int(K,zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),K)) ).

% eucl_rel_int_by0
tff(fact_1725_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q2: int] :
      ( ( L != zero_zero(int) )
     => ( ( K = aa(int,int,aa(int,fun(int,int),times_times(int),Q2),L) )
       => eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),zero_zero(int))) ) ) ).

% eucl_rel_int_dividesI
tff(fact_1726_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q2: int,R3: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R3))
    <=> ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),L),Q2)),R3) )
        & $ite(
            aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L),
            ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R3)
            & aa(int,$o,aa(int,fun(int,$o),ord_less(int),R3),L) ),
            $ite(
              aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)),
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),R3)
              & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R3),zero_zero(int)) ),
              Q2 = zero_zero(int) ) ) ) ) ).

% eucl_rel_int_iff
tff(fact_1727_div__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R3: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R3))
     => ( divide_divide(int,K,L) = Q2 ) ) ).

% div_int_unique
tff(fact_1728_mod__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R3: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R3))
     => ( modulo_modulo(int,K,L) = R3 ) ) ).

% mod_int_unique
tff(fact_1729_power__Suc__less,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N))),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)) ) ) ) ).

% power_Suc_less
tff(fact_1730_power__Suc__le__self,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,suc,N))),A3) ) ) ) ).

% power_Suc_le_self
tff(fact_1731_power__Suc__less__one,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: B,N: nat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,suc,N))),one_one(B)) ) ) ) ).

% power_Suc_less_one
tff(fact_1732_minus__power__mult__self,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [A3: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),A3)),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),A3)),N)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) ) ) ).

% minus_power_mult_self
tff(fact_1733_power__odd__eq,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [A3: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% power_odd_eq
tff(fact_1734_power2__eq__1__iff,axiom,
    ! [B: $tType] :
      ( ring_15535105094025558882visors(B)
     => ! [A3: B] :
          ( ( aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(B) )
        <=> ( ( A3 = one_one(B) )
            | ( A3 = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ) ) ).

% power2_eq_1_iff
tff(fact_1735_minus__one__power__iff,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [N: nat] :
          ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)
          = $ite(dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),N),one_one(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ) ).

% minus_one_power_iff
tff(fact_1736_power__diff__power__eq,axiom,
    ! [B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: B,M4: nat,N: nat] :
          ( ( A3 != zero_zero(B) )
         => ( divide_divide(B,aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),M4),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N))
            = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M4),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),N)),divide_divide(B,one_one(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4)))) ) ) ) ).

% power_diff_power_eq
tff(fact_1737_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
tff(fact_1738_power__minus__mult,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [N: nat,A3: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),A3) = aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),N) ) ) ) ).

% power_minus_mult
tff(fact_1739_power__minus_H,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X: B,N: nat] :
          ( nO_MATCH(B,B,one_one(B),X)
         => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),X)),N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)) ) ) ) ).

% power_minus'
tff(fact_1740_numeral__BitM,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [N: num] : ( aa(num,B,numeral_numeral(B),bitM(N)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,N))),one_one(B)) ) ) ).

% numeral_BitM
tff(fact_1741_eucl__rel__int,axiom,
    ! [K: int,L: int] : eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),divide_divide(int,K,L)),modulo_modulo(int,K,L))) ).

% eucl_rel_int
tff(fact_1742_power2__sum,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [X: B,Y: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),X)),Y)) ) ) ).

% power2_sum
tff(fact_1743_square__le__1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),one_one(B))),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(B)) ) ) ) ).

% square_le_1
tff(fact_1744_power__minus1__odd,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% power_minus1_odd
tff(fact_1745_power__eq__if,axiom,
    ! [B: $tType] :
      ( power(B)
     => ! [P2: B,M4: nat] :
          ( aa(nat,B,aa(B,fun(nat,B),power_power(B),P2),M4)
          = $ite(M4 = zero_zero(nat),one_one(B),aa(B,B,aa(B,fun(B,B),times_times(B),P2),aa(nat,B,aa(B,fun(nat,B),power_power(B),P2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),one_one(nat))))) ) ) ).

% power_eq_if
tff(fact_1746_power2__diff,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [X: B,Y: B] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),Y)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),X)),Y)) ) ) ).

% power2_diff
tff(fact_1747_mult__exp__mod__exp__eq,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [M4: nat,N: nat,A3: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),modulo_modulo(B,A3,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4)))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4)) ) ) ) ).

% mult_exp_mod_exp_eq
tff(fact_1748_zminus1__lemma,axiom,
    ! [A3: int,Ba: int,Q2: int,R3: int] :
      ( eucl_rel_int(A3,Ba,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R3))
     => ( ( Ba != zero_zero(int) )
       => eucl_rel_int(aa(int,int,uminus_uminus(int),A3),Ba,
            aa(int,product_prod(int,int),
              aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),$ite(R3 = zero_zero(int),aa(int,int,uminus_uminus(int),Q2),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),Q2)),one_one(int)))),
              $ite(R3 = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),Ba),R3)))) ) ) ).

% zminus1_lemma
tff(fact_1749_even__mask__div__iff_H,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [M4: nat,N: nat] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4)),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N) ) ) ).

% even_mask_div_iff'
tff(fact_1750_take__bit__numeral__minus__1__eq,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [K: num] : ( bit_se2584673776208193580ke_bit(B,aa(num,nat,numeral_numeral(nat),K),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),K))),one_one(B)) ) ) ).

% take_bit_numeral_minus_1_eq
tff(fact_1751_even__mask__div__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [M4: nat,N: nat] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4)),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)))
        <=> ( ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N) = zero_zero(B) )
            | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N) ) ) ) ).

% even_mask_div_iff
tff(fact_1752_even__mult__exp__div__exp__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A3: B,M4: nat,N: nat] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M4)
            | ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N) = zero_zero(B) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
              & dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),divide_divide(B,A3,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4)))) ) ) ) ) ).

% even_mult_exp_div_exp_iff
tff(fact_1753_take__bit__Suc__minus__1__eq,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,suc,N))),one_one(B)) ) ) ).

% take_bit_Suc_minus_1_eq
tff(fact_1754_flip__bit__0,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B] : ( bit_se8732182000553998342ip_bit(B,zero_zero(nat),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa($o,B,zero_neq_one_of_bool(B),dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),divide_divide(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))) ) ) ).

% flip_bit_0
tff(fact_1755_take__bit__numeral__bit1,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [L: num,K: num] : ( bit_se2584673776208193580ke_bit(B,aa(num,nat,numeral_numeral(nat),L),aa(num,B,numeral_numeral(B),aa(num,num,bit1,K))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,pred_numeral(L),aa(num,B,numeral_numeral(B),K))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),one_one(B)) ) ) ).

% take_bit_numeral_bit1
tff(fact_1756_one__mod__2__pow__eq,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat] : ( modulo_modulo(B,one_one(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% one_mod_2_pow_eq
tff(fact_1757_push__bit__numeral__minus__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: num] : ( bit_se4730199178511100633sh_bit(B,aa(num,nat,numeral_numeral(nat),N),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,uminus_uminus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(num,nat,numeral_numeral(nat),N))) ) ) ).

% push_bit_numeral_minus_1
tff(fact_1758_mask__numeral,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: num] : ( bit_se2239418461657761734s_mask(B,aa(num,nat,numeral_numeral(nat),N)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),bit_se2239418461657761734s_mask(B,pred_numeral(N)))) ) ) ).

% mask_numeral
tff(fact_1759_take__bit__of__exp,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [M4: nat,N: nat] : ( bit_se2584673776208193580ke_bit(B,M4,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M4))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) ) ) ).

% take_bit_of_exp
tff(fact_1760_one__div__2__pow__eq,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat] : ( divide_divide(B,one_one(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa($o,B,zero_neq_one_of_bool(B),( N = zero_zero(nat) )) ) ) ).

% one_div_2_pow_eq
tff(fact_1761_bits__1__div__exp,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [N: nat] : ( divide_divide(B,one_one(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa($o,B,zero_neq_one_of_bool(B),( N = zero_zero(nat) )) ) ) ).

% bits_1_div_exp
tff(fact_1762_of__bool__eq__1__iff,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ! [Pa: $o] :
          ( ( aa($o,B,zero_neq_one_of_bool(B),Pa) = one_one(B) )
        <=> (Pa) ) ) ).

% of_bool_eq_1_iff
tff(fact_1763_of__bool__eq_I2_J,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ( aa($o,B,zero_neq_one_of_bool(B),$true) = one_one(B) ) ) ).

% of_bool_eq(2)
tff(fact_1764_of__bool__less__one__iff,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Pa: $o] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa($o,B,zero_neq_one_of_bool(B),Pa)),one_one(B))
        <=> ~ (Pa) ) ) ).

% of_bool_less_one_iff
tff(fact_1765_of__bool__not__iff,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [Pa: $o] : ( aa($o,B,zero_neq_one_of_bool(B),~ (Pa)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa($o,B,zero_neq_one_of_bool(B),Pa)) ) ) ).

% of_bool_not_iff
tff(fact_1766_sgn__mult__self__eq,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,sgn_sgn(B),A3)),aa(B,B,sgn_sgn(B),A3)) = aa($o,B,zero_neq_one_of_bool(B),( A3 != zero_zero(B) )) ) ) ).

% sgn_mult_self_eq
tff(fact_1767_take__bit__of__1,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(B,N,one_one(B)) = aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% take_bit_of_1
tff(fact_1768_push__bit__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] : ( bit_se4730199178511100633sh_bit(B,aa(nat,nat,suc,N),A3) = bit_se4730199178511100633sh_bit(B,N,aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) ) ) ).

% push_bit_Suc
tff(fact_1769_push__bit__of__1,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ( bit_se4730199178511100633sh_bit(B,N,one_one(B)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N) ) ) ).

% push_bit_of_1
tff(fact_1770_take__bit__of__2,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: nat] : ( bit_se2584673776208193580ke_bit(B,N,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% take_bit_of_2
tff(fact_1771_of__bool__conj,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [Pa: $o,Qa: $o] :
          ( aa($o,B,zero_neq_one_of_bool(B),
              (Pa)
            & (Qa))
          = aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),Pa)),aa($o,B,zero_neq_one_of_bool(B),Qa)) ) ) ).

% of_bool_conj
tff(fact_1772_of__bool__less__eq__one,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [Pa: $o] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa($o,B,zero_neq_one_of_bool(B),Pa)),one_one(B)) ) ).

% of_bool_less_eq_one
tff(fact_1773_of__bool__def,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ! [P2: $o] :
          ( aa($o,B,zero_neq_one_of_bool(B),P2)
          = $ite((P2),one_one(B),zero_zero(B)) ) ) ).

% of_bool_def
tff(fact_1774_split__of__bool,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ! [Pa: fun(B,$o),P2: $o] :
          ( aa(B,$o,Pa,aa($o,B,zero_neq_one_of_bool(B),P2))
        <=> ( ( (P2)
             => aa(B,$o,Pa,one_one(B)) )
            & ( ~ (P2)
             => aa(B,$o,Pa,zero_zero(B)) ) ) ) ) ).

% split_of_bool
tff(fact_1775_split__of__bool__asm,axiom,
    ! [B: $tType] :
      ( zero_neq_one(B)
     => ! [Pa: fun(B,$o),P2: $o] :
          ( aa(B,$o,Pa,aa($o,B,zero_neq_one_of_bool(B),P2))
        <=> ~ ( ( (P2)
                & ~ aa(B,$o,Pa,one_one(B)) )
              | ( ~ (P2)
                & ~ aa(B,$o,Pa,zero_zero(B)) ) ) ) ) ).

% split_of_bool_asm
tff(fact_1776_set__bit__eq__or,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] : ( bit_se5668285175392031749et_bit(B,N,A3) = aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),A3),bit_se4730199178511100633sh_bit(B,N,one_one(B))) ) ) ).

% set_bit_eq_or
tff(fact_1777_flip__bit__eq__xor,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] : ( bit_se8732182000553998342ip_bit(B,N,A3) = aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),A3),bit_se4730199178511100633sh_bit(B,N,one_one(B))) ) ) ).

% flip_bit_eq_xor
tff(fact_1778_push__bit__double,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] : ( bit_se4730199178511100633sh_bit(B,N,aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) = aa(B,B,aa(B,fun(B,B),times_times(B),bit_se4730199178511100633sh_bit(B,N,A3)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% push_bit_double
tff(fact_1779_push__bit__eq__mult,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] : ( bit_se4730199178511100633sh_bit(B,N,A3) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) ) ) ).

% push_bit_eq_mult
tff(fact_1780_bits__induct,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [Pa: fun(B,$o),A3: B] :
          ( ! [A8: B] :
              ( ( divide_divide(B,A8,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = A8 )
             => aa(B,$o,Pa,A8) )
         => ( ! [A8: B,B4: $o] :
                ( aa(B,$o,Pa,A8)
               => ( ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa($o,B,zero_neq_one_of_bool(B),B4)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A8)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) = A8 )
                 => aa(B,$o,Pa,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa($o,B,zero_neq_one_of_bool(B),B4)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A8))) ) )
           => aa(B,$o,Pa,A3) ) ) ) ).

% bits_induct
tff(fact_1781_take__bit__numeral__bit0,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [L: num,K: num] : ( bit_se2584673776208193580ke_bit(B,aa(num,nat,numeral_numeral(nat),L),aa(num,B,numeral_numeral(B),aa(num,num,bit0,K))) = aa(B,B,aa(B,fun(B,B),times_times(B),bit_se2584673776208193580ke_bit(B,pred_numeral(L),aa(num,B,numeral_numeral(B),K))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% take_bit_numeral_bit0
tff(fact_1782_exp__mod__exp,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [M4: nat,N: nat] : ( modulo_modulo(B,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4)) ) ) ).

% exp_mod_exp
tff(fact_1783_or__one__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),A3),one_one(B)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa($o,B,zero_neq_one_of_bool(B),dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3))) ) ) ).

% or_one_eq
tff(fact_1784_one__or__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),one_one(B)),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa($o,B,zero_neq_one_of_bool(B),dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3))) ) ) ).

% one_or_eq
tff(fact_1785_exp__div__exp__eq,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [M4: nat,N: nat] :
          ( divide_divide(B,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N))
          = aa(B,B,
              aa(B,fun(B,B),times_times(B),
                aa($o,B,zero_neq_one_of_bool(B),
                  ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4) != zero_zero(B) )
                & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M4))),
              aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),N))) ) ) ).

% exp_div_exp_eq
tff(fact_1786_one__xor__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),one_one(B)),A3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa($o,B,zero_neq_one_of_bool(B),dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)))),aa($o,B,zero_neq_one_of_bool(B),~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3))) ) ) ).

% one_xor_eq
tff(fact_1787_xor__one__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),A3),one_one(B)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa($o,B,zero_neq_one_of_bool(B),dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)))),aa($o,B,zero_neq_one_of_bool(B),~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3))) ) ) ).

% xor_one_eq
tff(fact_1788_Divides_Oadjust__div__eq,axiom,
    ! [Q2: int,R3: int] : ( adjust_div(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R3)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Q2),aa($o,int,zero_neq_one_of_bool(int),( R3 != zero_zero(int) ))) ) ).

% Divides.adjust_div_eq
tff(fact_1789_and__int_Oelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Xa) = Y )
     => ( Y
        = $ite(
            ( member(int,X,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
            & member(int,Xa,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
            aa(int,int,uminus_uminus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),X)
              & ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),Xa))),
            aa(int,int,
              aa(int,fun(int,int),plus_plus(int),
                aa($o,int,zero_neq_one_of_bool(int),
                  ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),X)
                & ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),Xa))),
              aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,X,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),divide_divide(int,Xa,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ).

% and_int.elims
tff(fact_1790_and__int_Osimps,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = $ite(
          ( member(int,K,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
          & member(int,L,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
          aa(int,int,uminus_uminus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),K)
            & ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),L))),
          aa(int,int,
            aa(int,fun(int,int),plus_plus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),K)
              & ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),L))),
            aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ).

% and_int.simps
tff(fact_1791_normalize__negative,axiom,
    ! [Q2: int,P2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Q2),zero_zero(int))
     => ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2)) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),P2)),aa(int,int,uminus_uminus(int),Q2))) ) ) ).

% normalize_negative
tff(fact_1792_divmod__nat__def,axiom,
    ! [M4: nat,N: nat] : ( divmod_nat(M4,N) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),divide_divide(nat,M4,N)),modulo_modulo(nat,M4,N)) ) ).

% divmod_nat_def
tff(fact_1793_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,Pa: fun(int,fun(int,$o))] :
      ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A0),A1))
     => ( ! [K2: int,L3: int] :
            ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),K2),L3))
           => ( ( ~ ( member(int,K2,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
                    & member(int,L3,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) )
               => aa(int,$o,aa(int,fun(int,$o),Pa,divide_divide(int,K2,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),divide_divide(int,L3,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))) )
             => aa(int,$o,aa(int,fun(int,$o),Pa,K2),L3) ) )
       => aa(int,$o,aa(int,fun(int,$o),Pa,A0),A1) ) ) ).

% and_int.pinduct
tff(fact_1794_and__numerals_I7_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y)))) ) ) ).

% and_numerals(7)
tff(fact_1795_bit_Oconj__one__right,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),X),aa(B,B,uminus_uminus(B),one_one(B))) = X ) ) ).

% bit.conj_one_right
tff(fact_1796_and_Oright__neutral,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A3),aa(B,B,uminus_uminus(B),one_one(B))) = A3 ) ) ).

% and.right_neutral
tff(fact_1797_and_Oleft__neutral,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(B,B,uminus_uminus(B),one_one(B))),A3) = A3 ) ) ).

% and.left_neutral
tff(fact_1798_and__numerals_I8_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X))),one_one(B)) = one_one(B) ) ) ).

% and_numerals(8)
tff(fact_1799_and__numerals_I2_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = one_one(B) ) ) ).

% and_numerals(2)
tff(fact_1800_normalize__denom__zero,axiom,
    ! [P2: int] : ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),zero_zero(int))) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)) ) ).

% normalize_denom_zero
tff(fact_1801_and__numerals_I1_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = zero_zero(B) ) ) ).

% and_numerals(1)
tff(fact_1802_and__numerals_I5_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X))),one_one(B)) = zero_zero(B) ) ) ).

% and_numerals(5)
tff(fact_1803_and__numerals_I3_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% and_numerals(3)
tff(fact_1804_and__numerals_I4_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit1,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% and_numerals(4)
tff(fact_1805_and__numerals_I6_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [X: num,Y: num] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),aa(num,num,bit1,X))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,Y))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),aa(num,B,numeral_numeral(B),X)),aa(num,B,numeral_numeral(B),Y))) ) ) ).

% and_numerals(6)
tff(fact_1806_and__eq__minus__1__iff,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A3),Ba) = aa(B,B,uminus_uminus(B),one_one(B)) )
        <=> ( ( A3 = aa(B,B,uminus_uminus(B),one_one(B)) )
            & ( Ba = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ) ) ).

% and_eq_minus_1_iff
tff(fact_1807_and_Omonoid__axioms,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => monoid(B,bit_se5824344872417868541ns_and(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% and.monoid_axioms
tff(fact_1808_and_Osemilattice__neutr__axioms,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => semilattice_neutr(B,bit_se5824344872417868541ns_and(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% and.semilattice_neutr_axioms
tff(fact_1809_bit_Ocomplement__unique,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A3: B,X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A3),X) = zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),A3),X) = aa(B,B,uminus_uminus(B),one_one(B)) )
           => ( ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A3),Y) = zero_zero(B) )
             => ( ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),A3),Y) = aa(B,B,uminus_uminus(B),one_one(B)) )
               => ( X = Y ) ) ) ) ) ) ).

% bit.complement_unique
tff(fact_1810_one__and__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),one_one(B)),A3) = modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% one_and_eq
tff(fact_1811_and__one__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A3),one_one(B)) = modulo_modulo(B,A3,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% and_one_eq
tff(fact_1812_normalize__denom__pos,axiom,
    ! [R3: product_prod(int,int),P2: int,Q2: int] :
      ( ( normalize(R3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q2) ) ).

% normalize_denom_pos
tff(fact_1813_normalize__crossproduct,axiom,
    ! [Q2: int,S: int,P2: int,R3: int] :
      ( ( Q2 != zero_zero(int) )
     => ( ( S != zero_zero(int) )
       => ( ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2)) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),R3),S)) )
         => ( aa(int,int,aa(int,fun(int,int),times_times(int),P2),S) = aa(int,int,aa(int,fun(int,int),times_times(int),R3),Q2) ) ) ) ) ).

% normalize_crossproduct
tff(fact_1814_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),K),L))
     => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
        = $ite(
            ( member(int,K,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
            & member(int,L,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
            aa(int,int,uminus_uminus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),K)
              & ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),L))),
            aa(int,int,
              aa(int,fun(int,int),plus_plus(int),
                aa($o,int,zero_neq_one_of_bool(int),
                  ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),K)
                & ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),L))),
              aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) ) ) ).

% and_int.psimps
tff(fact_1815_and__int_Opelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),X),Xa) = Y )
     => ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X),Xa))
       => ~ ( ( Y
              = $ite(
                  ( member(int,X,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
                  & member(int,Xa,aa(set(int),set(int),insert2(int,zero_zero(int)),aa(set(int),set(int),insert2(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
                  aa(int,int,uminus_uminus(int),
                    aa($o,int,zero_neq_one_of_bool(int),
                      ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),X)
                    & ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),Xa))),
                  aa(int,int,
                    aa(int,fun(int,int),plus_plus(int),
                      aa($o,int,zero_neq_one_of_bool(int),
                        ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),X)
                      & ~ dvd_dvd(int,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)),Xa))),
                    aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,X,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))),divide_divide(int,Xa,aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2)))))) ) )
           => ~ aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X),Xa)) ) ) ) ).

% and_int.pelims
tff(fact_1816_upto_Opinduct,axiom,
    ! [A0: int,A1: int,Pa: fun(int,fun(int,$o))] :
      ( aa(product_prod(int,int),$o,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A0),A1))
     => ( ! [I3: int,J3: int] :
            ( aa(product_prod(int,int),$o,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),I3),J3))
           => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I3),J3)
               => aa(int,$o,aa(int,fun(int,$o),Pa,aa(int,int,aa(int,fun(int,int),plus_plus(int),I3),one_one(int))),J3) )
             => aa(int,$o,aa(int,fun(int,$o),Pa,I3),J3) ) )
       => aa(int,$o,aa(int,fun(int,$o),Pa,A0),A1) ) ) ).

% upto.pinduct
tff(fact_1817_bit__sum__mult__2__cases,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B,Ba: B,N: nat] :
          ( ! [J3: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(B,A3),aa(nat,nat,suc,J3))
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Ba))),N)
          <=> $ite(N = zero_zero(nat),~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3),aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Ba)),N)) ) ) ) ).

% bit_sum_mult_2_cases
tff(fact_1818_dvd__productE,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [P2: B,A3: B,Ba: B] :
          ( dvd_dvd(B,P2,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
         => ~ ! [X2: B,Y2: B] :
                ( ( P2 = aa(B,B,aa(B,fun(B,B),times_times(B),X2),Y2) )
               => ( dvd_dvd(B,X2,A3)
                 => ~ dvd_dvd(B,Y2,Ba) ) ) ) ) ).

% dvd_productE
tff(fact_1819_division__decomp,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
         => ? [B6: B,C7: B] :
              ( ( A3 = aa(B,B,aa(B,fun(B,B),times_times(B),B6),C7) )
              & dvd_dvd(B,B6,Ba)
              & dvd_dvd(B,C7,C2) ) ) ) ).

% division_decomp
tff(fact_1820_neg__numeral__le__ceiling,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [V: num,X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(B,X))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),one_one(B))),X) ) ) ).

% neg_numeral_le_ceiling
tff(fact_1821_ceiling__less__neg__numeral,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(B,X)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),one_one(B))) ) ) ).

% ceiling_less_neg_numeral
tff(fact_1822_mask__mod__exp,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat,M4: nat] : ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M4),N))),one_one(B)) ) ) ).

% mask_mod_exp
tff(fact_1823_min_Oidem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),A3) = A3 ) ) ).

% min.idem
tff(fact_1824_min_Oleft__idem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) ) ) ).

% min.left_idem
tff(fact_1825_min_Oright__idem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)),Ba) = aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) ) ) ).

% min.right_idem
tff(fact_1826_min_Oabsorb1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) = A3 ) ) ) ).

% min.absorb1
tff(fact_1827_min_Oabsorb2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) = Ba ) ) ) ).

% min.absorb2
tff(fact_1828_min_Obounded__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),C2))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2) ) ) ) ).

% min.bounded_iff
tff(fact_1829_bit__0__eq,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ( bit_se5641148757651400278ts_bit(B,zero_zero(B)) = bot_bot(fun(nat,$o)) ) ) ).

% bit_0_eq
tff(fact_1830_min_Oabsorb3,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) = A3 ) ) ) ).

% min.absorb3
tff(fact_1831_min_Oabsorb4,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) = Ba ) ) ) ).

% min.absorb4
tff(fact_1832_min__less__iff__conj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Z2: B,X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),X)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),Y) ) ) ) ).

% min_less_iff_conj
tff(fact_1833_min__bot2,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),X),bot_bot(B)) = bot_bot(B) ) ) ).

% min_bot2
tff(fact_1834_min__bot,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),bot_bot(B)),X) = bot_bot(B) ) ) ).

% min_bot
tff(fact_1835_min__top,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),top_top(B)),X) = X ) ) ).

% min_top
tff(fact_1836_min__top2,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),X),top_top(B)) = X ) ) ).

% min_top2
tff(fact_1837_min__0__1_I2_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ( aa(B,B,aa(B,fun(B,B),ord_min(B),one_one(B)),zero_zero(B)) = zero_zero(B) ) ) ).

% min_0_1(2)
tff(fact_1838_min__0__1_I1_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ( aa(B,B,aa(B,fun(B,B),ord_min(B),zero_zero(B)),one_one(B)) = zero_zero(B) ) ) ).

% min_0_1(1)
tff(fact_1839_min__0__1_I5_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),one_one(B)),aa(num,B,numeral_numeral(B),X)) = one_one(B) ) ) ).

% min_0_1(5)
tff(fact_1840_min__0__1_I6_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(num,B,numeral_numeral(B),X)),one_one(B)) = one_one(B) ) ) ).

% min_0_1(6)
tff(fact_1841_ceiling__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ( archimedean_ceiling(B,one_one(B)) = one_one(int) ) ) ).

% ceiling_one
tff(fact_1842_ceiling__le__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(B,X)),one_one(int))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),one_one(B)) ) ) ).

% ceiling_le_one
tff(fact_1843_one__less__ceiling,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),archimedean_ceiling(B,X))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),X) ) ) ).

% one_less_ceiling
tff(fact_1844_ceiling__add__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : ( archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),one_one(B))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(B,X)),one_one(int)) ) ) ).

% ceiling_add_one
tff(fact_1845_ceiling__diff__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : ( archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),X),one_one(B))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(B,X)),one_one(int)) ) ) ).

% ceiling_diff_one
tff(fact_1846_ceiling__less__zero,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(B,X)),zero_zero(int))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,uminus_uminus(B),one_one(B))) ) ) ).

% ceiling_less_zero
tff(fact_1847_zero__le__ceiling,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),archimedean_ceiling(B,X))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,uminus_uminus(B),one_one(B))),X) ) ) ).

% zero_le_ceiling
tff(fact_1848_ceiling__less__numeral,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(B,X)),aa(num,int,numeral_numeral(int),V))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(num,B,numeral_numeral(B),V)),one_one(B))) ) ) ).

% ceiling_less_numeral
tff(fact_1849_numeral__le__ceiling,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [V: num,X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(B,X))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(num,B,numeral_numeral(B),V)),one_one(B))),X) ) ) ).

% numeral_le_ceiling
tff(fact_1850_min_Oassoc,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),ord_min(B),A3),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),C2)) ) ) ).

% min.assoc
tff(fact_1851_min_Ocommute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),A3) ) ) ).

% min.commute
tff(fact_1852_min_Oleft__commute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),C2)) = aa(B,B,aa(B,fun(B,B),ord_min(B),A3),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),C2)) ) ) ).

% min.left_commute
tff(fact_1853_min_Omono,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,C2: B,Ba: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),D2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),ord_min(B),C2),D2)) ) ) ) ).

% min.mono
tff(fact_1854_min_OorderE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( A3 = aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) ) ) ) ).

% min.orderE
tff(fact_1855_min_OorderI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% min.orderI
tff(fact_1856_min_OboundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),C2))
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2) ) ) ) ).

% min.boundedE
tff(fact_1857_min_OboundedI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),C2)) ) ) ) ).

% min.boundedI
tff(fact_1858_min_Oorder__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
        <=> ( A3 = aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) ) ) ) ).

% min.order_iff
tff(fact_1859_min_Ocobounded1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)),A3) ) ).

% min.cobounded1
tff(fact_1860_min_Ocobounded2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)),Ba) ) ).

% min.cobounded2
tff(fact_1861_min_Oabsorb__iff1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
        <=> ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) = A3 ) ) ) ).

% min.absorb_iff1
tff(fact_1862_min_Oabsorb__iff2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
        <=> ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) = Ba ) ) ) ).

% min.absorb_iff2
tff(fact_1863_min_OcoboundedI1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),C2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)),C2) ) ) ).

% min.coboundedI1
tff(fact_1864_min_OcoboundedI2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),C2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)),C2) ) ) ).

% min.coboundedI2
tff(fact_1865_min__le__iff__disj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)),Z2)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Z2)
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Z2) ) ) ) ).

% min_le_iff_disj
tff(fact_1866_min__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba),A3,Ba) ) ) ).

% min_def
tff(fact_1867_min__absorb1,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y) = X ) ) ) ).

% min_absorb1
tff(fact_1868_min__absorb2,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Y: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X)
         => ( aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y) = Y ) ) ) ).

% min_absorb2
tff(fact_1869_min__less__iff__disj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)),Z2)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Z2)
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),Z2) ) ) ) ).

% min_less_iff_disj
tff(fact_1870_min_Ostrict__boundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),C2))
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),C2) ) ) ) ).

% min.strict_boundedE
tff(fact_1871_min_Ostrict__order__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
        <=> ( ( A3 = aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba) )
            & ( A3 != Ba ) ) ) ) ).

% min.strict_order_iff
tff(fact_1872_min_Ostrict__coboundedI1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),C2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)),C2) ) ) ).

% min.strict_coboundedI1
tff(fact_1873_min_Ostrict__coboundedI2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),C2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)),C2) ) ) ).

% min.strict_coboundedI2
tff(fact_1874_min__add__distrib__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)),Z2) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Z2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Y),Z2)) ) ) ).

% min_add_distrib_left
tff(fact_1875_min__add__distrib__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X),aa(B,B,aa(B,fun(B,B),ord_min(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y)),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Z2)) ) ) ).

% min_add_distrib_right
tff(fact_1876_min__diff__distrib__left,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)),Z2) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),Z2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Y),Z2)) ) ) ).

% min_diff_distrib_left
tff(fact_1877_inf__min,axiom,
    ! [B: $tType] :
      ( ( semilattice_inf(B)
        & linorder(B) )
     => ( inf_inf(B) = ord_min(B) ) ) ).

% inf_min
tff(fact_1878_complete__linorder__inf__min,axiom,
    ! [B: $tType] :
      ( comple5582772986160207858norder(B)
     => ( inf_inf(B) = ord_min(B) ) ) ).

% complete_linorder_inf_min
tff(fact_1879_min_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semigroup(B,ord_min(B)) ) ).

% min.semigroup_axioms
tff(fact_1880_bit__1__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,one_one(B)),N)
        <=> ( N = zero_zero(nat) ) ) ) ).

% bit_1_iff
tff(fact_1881_not__bit__1__Suc,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(B,one_one(B)),aa(nat,nat,suc,N)) ) ).

% not_bit_1_Suc
tff(fact_1882_bit__numeral__simps_I1_J,axiom,
    ! [B: $tType] :
      ( bit_un5681908812861735899ations(B)
     => ! [N: num] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(B,one_one(B)),aa(num,nat,numeral_numeral(nat),N)) ) ).

% bit_numeral_simps(1)
tff(fact_1883_mult__ceiling__le,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(B,A3)),archimedean_ceiling(B,Ba))) ) ) ) ).

% mult_ceiling_le
tff(fact_1884_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,A3),N)
        <=> ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A3),bit_se4730199178511100633sh_bit(B,N,one_one(B))) != zero_zero(B) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
tff(fact_1885_even__bit__succ__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A3: B,N: nat] :
          ( dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A3)),N)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,A3),N)
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% even_bit_succ_iff
tff(fact_1886_odd__bit__iff__bit__pred,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A3: B,N: nat] :
          ( ~ dvd_dvd(B,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)),A3)
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,A3),N)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))),N)
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
tff(fact_1887_floor__le__neg__numeral,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(B,X)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),one_one(B))) ) ) ).

% floor_le_neg_numeral
tff(fact_1888_neg__numeral__less__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [V: num,X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(B,X))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),V))),one_one(B))),X) ) ) ).

% neg_numeral_less_floor
tff(fact_1889_bezw__0,axiom,
    ! [X: nat] : ( bezw(X,zero_zero(nat)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)) ) ).

% bezw_0
tff(fact_1890_signed__take__bit__def,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat,A3: B] : ( bit_ri4674362597316999326ke_bit(B,N,A3) = aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),bit_se2584673776208193580ke_bit(B,N,A3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),aa(nat,$o,bit_se5641148757651400278ts_bit(B,A3),N))),aa(B,B,bit_ri4277139882892585799ns_not(B),bit_se2239418461657761734s_mask(B,N)))) ) ) ).

% signed_take_bit_def
tff(fact_1891_floor__le__numeral,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(B,X)),aa(num,int,numeral_numeral(int),V))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),V)),one_one(B))) ) ) ).

% floor_le_numeral
tff(fact_1892_numeral__less__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [V: num,X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(B,X))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),V)),one_one(B))),X) ) ) ).

% numeral_less_floor
tff(fact_1893_ceiling__divide__lower,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Q2: B,P2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Q2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),archimedean_ceiling(B,divide_divide(B,P2,Q2)))),one_one(B))),Q2)),P2) ) ) ).

% ceiling_divide_lower
tff(fact_1894_floor__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ( archim6421214686448440834_floor(B,one_one(B)) = one_one(int) ) ) ).

% floor_one
tff(fact_1895_bit_Ocompl__zero,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ( aa(B,B,bit_ri4277139882892585799ns_not(B),zero_zero(B)) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.compl_zero
tff(fact_1896_bit_Ocompl__one,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ( aa(B,B,bit_ri4277139882892585799ns_not(B),aa(B,B,uminus_uminus(B),one_one(B))) = zero_zero(B) ) ) ).

% bit.compl_one
tff(fact_1897_bit_Odisj__cancel__right,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),X),aa(B,B,bit_ri4277139882892585799ns_not(B),X)) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.disj_cancel_right
tff(fact_1898_bit_Odisj__cancel__left,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),aa(B,B,bit_ri4277139882892585799ns_not(B),X)),X) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.disj_cancel_left
tff(fact_1899_bit_Oxor__cancel__right,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),X),aa(B,B,bit_ri4277139882892585799ns_not(B),X)) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.xor_cancel_right
tff(fact_1900_bit_Oxor__cancel__left,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(B,B,bit_ri4277139882892585799ns_not(B),X)),X) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% bit.xor_cancel_left
tff(fact_1901_bit_Oxor__one__right,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),X),aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,bit_ri4277139882892585799ns_not(B),X) ) ) ).

% bit.xor_one_right
tff(fact_1902_bit_Oxor__one__left,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),bit_se5824344971392196577ns_xor(B),aa(B,B,uminus_uminus(B),one_one(B))),X) = aa(B,B,bit_ri4277139882892585799ns_not(B),X) ) ) ).

% bit.xor_one_left
tff(fact_1903_zero__less__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),archim6421214686448440834_floor(B,X))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),X) ) ) ).

% zero_less_floor
tff(fact_1904_floor__le__zero,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(B,X)),zero_zero(int))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),one_one(B)) ) ) ).

% floor_le_zero
tff(fact_1905_one__le__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),archim6421214686448440834_floor(B,X))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),X) ) ) ).

% one_le_floor
tff(fact_1906_floor__less__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(B,X)),one_one(int))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),one_one(B)) ) ) ).

% floor_less_one
tff(fact_1907_floor__diff__one,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : ( archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),X),one_one(B))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(B,X)),one_one(int)) ) ) ).

% floor_diff_one
tff(fact_1908_push__bit__minus__one__eq__not__mask,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] : ( bit_se4730199178511100633sh_bit(B,N,aa(B,B,uminus_uminus(B),one_one(B))) = aa(B,B,bit_ri4277139882892585799ns_not(B),bit_se2239418461657761734s_mask(B,N)) ) ) ).

% push_bit_minus_one_eq_not_mask
tff(fact_1909_not__one__eq,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ( aa(B,B,bit_ri4277139882892585799ns_not(B),one_one(B)) = aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% not_one_eq
tff(fact_1910_floor__split,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Pa: fun(int,$o),T4: B] :
          ( aa(int,$o,Pa,archim6421214686448440834_floor(B,T4))
        <=> ! [I2: int] :
              ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),I2)),T4)
                & aa(B,$o,aa(B,fun(B,$o),ord_less(B),T4),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),I2)),one_one(B))) )
             => aa(int,$o,Pa,I2) ) ) ) ).

% floor_split
tff(fact_1911_floor__eq__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,A3: int] :
          ( ( archim6421214686448440834_floor(B,X) = A3 )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),A3)),X)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),A3)),one_one(B))) ) ) ) ).

% floor_eq_iff
tff(fact_1912_floor__unique,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Z2: int,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),Z2)),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B)))
           => ( archim6421214686448440834_floor(B,X) = Z2 ) ) ) ) ).

% floor_unique
tff(fact_1913_less__floor__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Z2: int,X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z2),archim6421214686448440834_floor(B,X))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))),X) ) ) ).

% less_floor_iff
tff(fact_1914_floor__le__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,Z2: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(B,X)),Z2)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))) ) ) ).

% floor_le_iff
tff(fact_1915_floor__divide__lower,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Q2: B,P2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Q2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(int,B,ring_1_of_int(B),archim6421214686448440834_floor(B,divide_divide(B,P2,Q2)))),Q2)),P2) ) ) ).

% floor_divide_lower
tff(fact_1916_floor__divide__upper,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Q2: B,P2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Q2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),P2),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(int,B,ring_1_of_int(B),archim6421214686448440834_floor(B,divide_divide(B,P2,Q2)))),one_one(B))),Q2)) ) ) ).

% floor_divide_upper
tff(fact_1917_minus__eq__not__plus__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A3: B] : ( aa(B,B,uminus_uminus(B),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,bit_ri4277139882892585799ns_not(B),A3)),one_one(B)) ) ) ).

% minus_eq_not_plus_1
tff(fact_1918_minus__eq__not__minus__1,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A3: B] : ( aa(B,B,uminus_uminus(B),A3) = aa(B,B,bit_ri4277139882892585799ns_not(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))) ) ) ).

% minus_eq_not_minus_1
tff(fact_1919_not__eq__complement,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A3: B] : ( aa(B,B,bit_ri4277139882892585799ns_not(B),A3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),A3)),one_one(B)) ) ) ).

% not_eq_complement
tff(fact_1920_one__add__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(B,X)),one_one(int)) = archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),one_one(B))) ) ) ).

% one_add_floor
tff(fact_1921_unset__bit__eq__and__not,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat,A3: B] : ( bit_se2638667681897837118et_bit(B,N,A3) = aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),A3),aa(B,B,bit_ri4277139882892585799ns_not(B),bit_se4730199178511100633sh_bit(B,N,one_one(B)))) ) ) ).

% unset_bit_eq_and_not
tff(fact_1922_le__mult__floor,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(B,A3)),archim6421214686448440834_floor(B,Ba))),archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))) ) ) ) ).

% le_mult_floor
tff(fact_1923_ceiling__correct,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),archimedean_ceiling(B,X))),one_one(B))),X)
          & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(int,B,ring_1_of_int(B),archimedean_ceiling(B,X))) ) ) ).

% ceiling_correct
tff(fact_1924_ceiling__unique,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Z2: int,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(int,B,ring_1_of_int(B),Z2))
           => ( archimedean_ceiling(B,X) = Z2 ) ) ) ) ).

% ceiling_unique
tff(fact_1925_ceiling__eq__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,A3: int] :
          ( ( archimedean_ceiling(B,X) = A3 )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),A3)),one_one(B))),X)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(int,B,ring_1_of_int(B),A3)) ) ) ) ).

% ceiling_eq_iff
tff(fact_1926_ceiling__split,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Pa: fun(int,$o),T4: B] :
          ( aa(int,$o,Pa,archimedean_ceiling(B,T4))
        <=> ! [I2: int] :
              ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),I2)),one_one(B))),T4)
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),T4),aa(int,B,ring_1_of_int(B),I2)) )
             => aa(int,$o,Pa,I2) ) ) ) ).

% ceiling_split
tff(fact_1927_ceiling__less__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,Z2: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(B,X)),Z2)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))) ) ) ).

% ceiling_less_iff
tff(fact_1928_le__ceiling__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Z2: int,X: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z2),archimedean_ceiling(B,X))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))),X) ) ) ).

% le_ceiling_iff
tff(fact_1929_bit_Ocompl__unique,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [X: B,Y: B] :
          ( ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),X),Y) = zero_zero(B) )
         => ( ( aa(B,B,aa(B,fun(B,B),bit_se1065995026697491101ons_or(B),X),Y) = aa(B,B,uminus_uminus(B),one_one(B)) )
           => ( aa(B,B,bit_ri4277139882892585799ns_not(B),X) = Y ) ) ) ) ).

% bit.compl_unique
tff(fact_1930_ceiling__divide__upper,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [Q2: B,P2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),Q2)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),P2),aa(B,B,aa(B,fun(B,B),times_times(B),aa(int,B,ring_1_of_int(B),archimedean_ceiling(B,divide_divide(B,P2,Q2)))),Q2)) ) ) ).

% ceiling_divide_upper
tff(fact_1931_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => boolea2506097494486148201lgebra(B,bit_se5824344872417868541ns_and(B),bit_se1065995026697491101ons_or(B),bit_ri4277139882892585799ns_not(B),zero_zero(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% bit.abstract_boolean_algebra_axioms
tff(fact_1932_of__int__less__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z2),one_one(int)) ) ) ).

% of_int_less_1_iff
tff(fact_1933_of__int__1__less__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(int,B,ring_1_of_int(B),Z2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),Z2) ) ) ).

% of_int_1_less_iff
tff(fact_1934_of__int__le__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),Z2)),one_one(B))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z2),one_one(int)) ) ) ).

% of_int_le_1_iff
tff(fact_1935_of__int__1__le__iff,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [Z2: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(int,B,ring_1_of_int(B),Z2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),Z2) ) ) ).

% of_int_1_le_iff
tff(fact_1936_of__int__mult,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [W2: int,Z2: int] : ( aa(int,B,ring_1_of_int(B),aa(int,int,aa(int,fun(int,int),times_times(int),W2),Z2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(int,B,ring_1_of_int(B),W2)),aa(int,B,ring_1_of_int(B),Z2)) ) ) ).

% of_int_mult
tff(fact_1937_of__int__eq__1__iff,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [Z2: int] :
          ( ( aa(int,B,ring_1_of_int(B),Z2) = one_one(B) )
        <=> ( Z2 = one_one(int) ) ) ) ).

% of_int_eq_1_iff
tff(fact_1938_of__int__1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ( aa(int,B,ring_1_of_int(B),one_one(int)) = one_one(B) ) ) ).

% of_int_1
tff(fact_1939_mult__of__int__commute,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [X: int,Y: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(int,B,ring_1_of_int(B),X)),Y) = aa(B,B,aa(B,fun(B,B),times_times(B),Y),aa(int,B,ring_1_of_int(B),X)) ) ) ).

% mult_of_int_commute
tff(fact_1940_round__unique,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,Y: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),aa(int,B,ring_1_of_int(B),Y))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),Y)),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))))
           => ( archimedean_round(B,X) = Y ) ) ) ) ).

% round_unique
tff(fact_1941_of__int__round__gt,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),aa(int,B,ring_1_of_int(B),archimedean_round(B,X))) ) ).

% of_int_round_gt
tff(fact_1942_of__int__round__ge,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))),aa(int,B,ring_1_of_int(B),archimedean_round(B,X))) ) ).

% of_int_round_ge
tff(fact_1943_of__int__round__le,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),archimedean_round(B,X))),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))) ) ).

% of_int_round_le
tff(fact_1944_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => boolea3799213064322606851m_diff(B,bit_se5824344872417868541ns_and(B),bit_se1065995026697491101ons_or(B),bit_ri4277139882892585799ns_not(B),zero_zero(B),aa(B,B,uminus_uminus(B),one_one(B)),bit_se5824344971392196577ns_xor(B)) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
tff(fact_1945_round__def,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : ( archimedean_round(B,X) = archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))) ) ) ).

% round_def
tff(fact_1946_bezw_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(int,int)] :
      ( ( bezw(X,Xa) = Y )
     => ( Y
        = $ite(Xa = zero_zero(nat),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,X,Xa)))))) ) ) ).

% bezw.elims
tff(fact_1947_round__1,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ( archimedean_round(B,one_one(B)) = one_one(int) ) ) ).

% round_1
tff(fact_1948_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib2,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),Y: B,Z2: B,X: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Xor,Y),Z2)),X) = aa(B,B,aa(B,fun(B,B),Xor,aa(B,B,aa(B,fun(B,B),Conj,Y),X)),aa(B,B,aa(B,fun(B,B),Conj,Z2),X)) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib2
tff(fact_1949_abstract__boolean__algebra__sym__diff_Oxor__cancel__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X),aa(B,B,Compl,X)) = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_right
tff(fact_1950_abstract__boolean__algebra__sym__diff_Oconj__xor__distrib,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B,Y: B,Z2: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Conj,X),aa(B,B,aa(B,fun(B,B),Xor,Y),Z2)) = aa(B,B,aa(B,fun(B,B),Xor,aa(B,B,aa(B,fun(B,B),Conj,X),Y)),aa(B,B,aa(B,fun(B,B),Conj,X),Z2)) ) ) ).

% abstract_boolean_algebra_sym_diff.conj_xor_distrib
tff(fact_1951_abstract__boolean__algebra__sym__diff_Oxor__compl__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B,Y: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X),aa(B,B,Compl,Y)) = aa(B,B,Compl,aa(B,B,aa(B,fun(B,B),Xor,X),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_right
tff(fact_1952_abstract__boolean__algebra__sym__diff_Oxor__cancel__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,aa(B,B,Compl,X)),X) = One ) ) ).

% abstract_boolean_algebra_sym_diff.xor_cancel_left
tff(fact_1953_abstract__boolean__algebra__sym__diff_Oxor__compl__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B,Y: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,aa(B,B,Compl,X)),Y) = aa(B,B,Compl,aa(B,B,aa(B,fun(B,B),Xor,X),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_compl_left
tff(fact_1954_abstract__boolean__algebra__sym__diff_Oxor__one__right,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X),One) = aa(B,B,Compl,X) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_right
tff(fact_1955_abstract__boolean__algebra__sym__diff_Oxor__left__self,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B,Y: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X),aa(B,B,aa(B,fun(B,B),Xor,X),Y)) = Y ) ) ).

% abstract_boolean_algebra_sym_diff.xor_left_self
tff(fact_1956_abstract__boolean__algebra__sym__diff_Oxor__one__left,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,One),X) = aa(B,B,Compl,X) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_one_left
tff(fact_1957_abstract__boolean__algebra__sym__diff_Oxor__self,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X),X) = Zero ) ) ).

% abstract_boolean_algebra_sym_diff.xor_self
tff(fact_1958_abstract__boolean__algebra__sym__diff_Oxor__def2,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B,Y: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X),Y) = aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,aa(B,fun(B,B),Disj,X),Y)),aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,Compl,X)),aa(B,B,Compl,Y))) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def2
tff(fact_1959_abstract__boolean__algebra__sym__diff_Oxor__def,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B)),X: B,Y: B] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => ( aa(B,B,aa(B,fun(B,B),Xor,X),Y) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X),aa(B,B,Compl,Y))),aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,Compl,X)),Y)) ) ) ).

% abstract_boolean_algebra_sym_diff.xor_def
tff(fact_1960_abstract__boolean__algebra__sym__diff_Oaxioms_I1_J,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B))] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One) ) ).

% abstract_boolean_algebra_sym_diff.axioms(1)
tff(fact_1961_div__mult2__eq_H,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A3: B,M4: nat,N: nat] : ( divide_divide(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),M4)),aa(nat,B,semiring_1_of_nat(B),N))) = divide_divide(B,divide_divide(B,A3,aa(nat,B,semiring_1_of_nat(B),M4)),aa(nat,B,semiring_1_of_nat(B),N)) ) ) ).

% div_mult2_eq'
tff(fact_1962_ex__less__of__nat__mult,axiom,
    ! [B: $tType] :
      ( archim462609752435547400_field(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),X)
         => ? [N3: nat] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N3)),X)) ) ) ).

% ex_less_of_nat_mult
tff(fact_1963_mod__mult2__eq_H,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A3: B,M4: nat,N: nat] : ( modulo_modulo(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),M4)),aa(nat,B,semiring_1_of_nat(B),N))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),M4)),modulo_modulo(B,divide_divide(B,A3,aa(nat,B,semiring_1_of_nat(B),M4)),aa(nat,B,semiring_1_of_nat(B),N)))),modulo_modulo(B,A3,aa(nat,B,semiring_1_of_nat(B),M4))) ) ) ).

% mod_mult2_eq'
tff(fact_1964_nat__approx__posE,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [E2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),E2)
         => ~ ! [N3: nat] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),divide_divide(B,one_one(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,N3)))),E2) ) ) ).

% nat_approx_posE
tff(fact_1965_bezw__non__0,axiom,
    ! [Y: nat,X: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Y)
     => ( bezw(X,Y) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,X,Y))))) ) ) ).

% bezw_non_0
tff(fact_1966_bezw_Osimps,axiom,
    ! [X: nat,Y: nat] :
      ( bezw(X,Y)
      = $ite(Y = zero_zero(nat),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,X,Y)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,X,Y)))))) ) ).

% bezw.simps
tff(fact_1967_of__nat__Suc,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [M4: nat] : ( aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,M4)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(nat,B,semiring_1_of_nat(B),M4)) ) ) ).

% of_nat_Suc
tff(fact_1968_of__nat__1,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ( aa(nat,B,semiring_1_of_nat(B),one_one(nat)) = one_one(B) ) ) ).

% of_nat_1
tff(fact_1969_of__nat__1__eq__iff,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: nat] :
          ( ( one_one(B) = aa(nat,B,semiring_1_of_nat(B),N) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_1_eq_iff
tff(fact_1970_of__nat__eq__1__iff,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: nat] :
          ( ( aa(nat,B,semiring_1_of_nat(B),N) = one_one(B) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_eq_1_iff
tff(fact_1971_of__nat__mult,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [M4: nat,N: nat] : ( aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M4),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),M4)),aa(nat,B,semiring_1_of_nat(B),N)) ) ) ).

% of_nat_mult
tff(fact_1972_bezw_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(int,int)] :
      ( ( bezw(X,Xa) = Y )
     => ( aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),bezw_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa))
       => ~ ( ( Y
              = $ite(Xa = zero_zero(nat),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,modulo_modulo(nat,X,Xa)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,X,Xa)))))) )
           => ~ aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),bezw_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa)) ) ) ) ).

% bezw.pelims
tff(fact_1973_round__altdef,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( archimedean_round(B,X)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),archimedean_frac(B,X)),archimedean_ceiling(B,X),archim6421214686448440834_floor(B,X)) ) ) ).

% round_altdef
tff(fact_1974_frac__lt__1,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),archimedean_frac(B,X)),one_one(B)) ) ).

% frac_lt_1
tff(fact_1975_frac__1__eq,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : ( archimedean_frac(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),one_one(B))) = archimedean_frac(B,X) ) ) ).

% frac_1_eq
tff(fact_1976_bot__nat__def,axiom,
    bot_bot(nat) = zero_zero(nat) ).

% bot_nat_def
tff(fact_1977_inf__nat__def,axiom,
    inf_inf(nat) = ord_min(nat) ).

% inf_nat_def
tff(fact_1978_frac__eq,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( ( archimedean_frac(B,X) = X )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),one_one(B)) ) ) ) ).

% frac_eq
tff(fact_1979_frac__add,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,Y: B] :
          ( archimedean_frac(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),archimedean_frac(B,X)),archimedean_frac(B,Y))),one_one(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),archimedean_frac(B,X)),archimedean_frac(B,Y)),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),archimedean_frac(B,X)),archimedean_frac(B,Y))),one_one(B))) ) ) ).

% frac_add
tff(fact_1980_mult__of__nat__commute,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [X: nat,Y: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),X)),Y) = aa(B,B,aa(B,fun(B,B),times_times(B),Y),aa(nat,B,semiring_1_of_nat(B),X)) ) ) ).

% mult_of_nat_commute
tff(fact_1981_floor__add,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,Y: B] :
          ( archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),archimedean_frac(B,X)),archimedean_frac(B,Y))),one_one(B)),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(B,X)),archim6421214686448440834_floor(B,Y)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(B,X)),archim6421214686448440834_floor(B,Y))),one_one(int))) ) ) ).

% floor_add
tff(fact_1982_pochhammer__double,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Z2: B,N: nat] : ( comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Z2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))),comm_s3205402744901411588hammer(B,Z2,N))),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),N)) ) ) ).

% pochhammer_double
tff(fact_1983_round__unique_H,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),aa(int,B,ring_1_of_int(B),N)))),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))))
         => ( archimedean_round(B,X) = N ) ) ) ).

% round_unique'
tff(fact_1984_of__int__round__abs__le,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(int,B,ring_1_of_int(B),archimedean_round(B,X))),X))),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) ) ).

% of_int_round_abs_le
tff(fact_1985_pochhammer__minus,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Ba: B,K: nat] : ( comm_s3205402744901411588hammer(B,aa(B,B,uminus_uminus(B),Ba),K) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),aa(nat,B,semiring_1_of_nat(B),K))),one_one(B)),K)) ) ) ).

% pochhammer_minus
tff(fact_1986_pochhammer__minus_H,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Ba: B,K: nat] : ( comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),aa(nat,B,semiring_1_of_nat(B),K))),one_one(B)),K) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),comm_s3205402744901411588hammer(B,aa(B,B,uminus_uminus(B),Ba),K)) ) ) ).

% pochhammer_minus'
tff(fact_1987_mult__ceiling__le__Ints,axiom,
    ! [C: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & linordered_idom(C) )
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( member(B,A3,ring_1_Ints(B))
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(int,C,ring_1_of_int(C),archimedean_ceiling(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)))),aa(int,C,ring_1_of_int(C),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(B,A3)),archimedean_ceiling(B,Ba)))) ) ) ) ).

% mult_ceiling_le_Ints
tff(fact_1988_le__mult__floor__Ints,axiom,
    ! [C: $tType,B: $tType] :
      ( ( archim2362893244070406136eiling(B)
        & linordered_idom(C) )
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( member(B,A3,ring_1_Ints(B))
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(int,C,ring_1_of_int(C),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(B,A3)),archim6421214686448440834_floor(B,Ba)))),aa(int,C,ring_1_of_int(C),archim6421214686448440834_floor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)))) ) ) ) ).

% le_mult_floor_Ints
tff(fact_1989_abs__idempotent,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] : ( aa(B,B,abs_abs(B),aa(B,B,abs_abs(B),A3)) = aa(B,B,abs_abs(B),A3) ) ) ).

% abs_idempotent
tff(fact_1990_abs__zero,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ( aa(B,B,abs_abs(B),zero_zero(B)) = zero_zero(B) ) ) ).

% abs_zero
tff(fact_1991_abs__eq__0,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] :
          ( ( aa(B,B,abs_abs(B),A3) = zero_zero(B) )
        <=> ( A3 = zero_zero(B) ) ) ) ).

% abs_eq_0
tff(fact_1992_abs__0__eq,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] :
          ( ( zero_zero(B) = aa(B,B,abs_abs(B),A3) )
        <=> ( A3 = zero_zero(B) ) ) ) ).

% abs_0_eq
tff(fact_1993_abs__add__abs,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),Ba))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),Ba)) ) ) ).

% abs_add_abs
tff(fact_1994_abs__mult__self__eq,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),A3) ) ) ).

% abs_mult_self_eq
tff(fact_1995_abs__1,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ( aa(B,B,abs_abs(B),one_one(B)) = one_one(B) ) ) ).

% abs_1
tff(fact_1996_abs__minus__cancel,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] : ( aa(B,B,abs_abs(B),aa(B,B,uminus_uminus(B),A3)) = aa(B,B,abs_abs(B),A3) ) ) ).

% abs_minus_cancel
tff(fact_1997_abs__le__zero__iff,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A3)),zero_zero(B))
        <=> ( A3 = zero_zero(B) ) ) ) ).

% abs_le_zero_iff
tff(fact_1998_abs__le__self__iff,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A3)),A3)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3) ) ) ).

% abs_le_self_iff
tff(fact_1999_abs__of__nonneg,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => ( aa(B,B,abs_abs(B),A3) = A3 ) ) ) ).

% abs_of_nonneg
tff(fact_2000_zero__less__abs__iff,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,abs_abs(B),A3))
        <=> ( A3 != zero_zero(B) ) ) ) ).

% zero_less_abs_iff
tff(fact_2001_abs__neg__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ( aa(B,B,abs_abs(B),aa(B,B,uminus_uminus(B),one_one(B))) = one_one(B) ) ) ).

% abs_neg_one
tff(fact_2002_pochhammer__0,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: B] : ( comm_s3205402744901411588hammer(B,A3,zero_zero(nat)) = one_one(B) ) ) ).

% pochhammer_0
tff(fact_2003_abs__of__nonpos,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B))
         => ( aa(B,B,abs_abs(B),A3) = aa(B,B,uminus_uminus(B),A3) ) ) ) ).

% abs_of_nonpos
tff(fact_2004_abs__sgn__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B] :
          ( ( A3 != zero_zero(B) )
         => ( aa(B,B,abs_abs(B),aa(B,B,sgn_sgn(B),A3)) = one_one(B) ) ) ) ).

% abs_sgn_eq_1
tff(fact_2005_abs__ge__self,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,abs_abs(B),A3)) ) ).

% abs_ge_self
tff(fact_2006_abs__le__D1,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A3)),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% abs_le_D1
tff(fact_2007_abs__mult,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),Ba)) ) ) ).

% abs_mult
tff(fact_2008_abs__one,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ( aa(B,B,abs_abs(B),one_one(B)) = one_one(B) ) ) ).

% abs_one
tff(fact_2009_abs__minus__commute,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba)) = aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3)) ) ) ).

% abs_minus_commute
tff(fact_2010_Ints__mult,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => ! [A3: B,Ba: B] :
          ( member(B,A3,ring_1_Ints(B))
         => ( member(B,Ba,ring_1_Ints(B))
           => member(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),ring_1_Ints(B)) ) ) ) ).

% Ints_mult
tff(fact_2011_Ints__1,axiom,
    ! [B: $tType] :
      ( ring_1(B)
     => member(B,one_one(B),ring_1_Ints(B)) ) ).

% Ints_1
tff(fact_2012_Ints__nonzero__abs__ge1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B] :
          ( member(B,X,ring_1_Ints(B))
         => ( ( X != zero_zero(B) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,abs_abs(B),X)) ) ) ) ).

% Ints_nonzero_abs_ge1
tff(fact_2013_Ints__nonzero__abs__less1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B] :
          ( member(B,X,ring_1_Ints(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),X)),one_one(B))
           => ( X = zero_zero(B) ) ) ) ) ).

% Ints_nonzero_abs_less1
tff(fact_2014_Ints__eq__abs__less1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B,Y: B] :
          ( member(B,X,ring_1_Ints(B))
         => ( member(B,Y,ring_1_Ints(B))
           => ( ( X = Y )
            <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),Y))),one_one(B)) ) ) ) ) ).

% Ints_eq_abs_less1
tff(fact_2015_abs__ge__zero,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(B,B,abs_abs(B),A3)) ) ).

% abs_ge_zero
tff(fact_2016_abs__of__pos,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,B,abs_abs(B),A3) = A3 ) ) ) ).

% abs_of_pos
tff(fact_2017_abs__not__less__zero,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] : ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),A3)),zero_zero(B)) ) ).

% abs_not_less_zero
tff(fact_2018_abs__triangle__ineq,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba))),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),Ba))) ) ).

% abs_triangle_ineq
tff(fact_2019_abs__triangle__ineq2__sym,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),Ba))),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3))) ) ).

% abs_triangle_ineq2_sym
tff(fact_2020_abs__triangle__ineq3,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),Ba)))),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba))) ) ).

% abs_triangle_ineq3
tff(fact_2021_abs__triangle__ineq2,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),Ba))),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba))) ) ).

% abs_triangle_ineq2
tff(fact_2022_abs__mult__less,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B,C2: B,Ba: B,D2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),A3)),C2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),Ba)),D2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),Ba))),aa(B,B,aa(B,fun(B,B),times_times(B),C2),D2)) ) ) ) ).

% abs_mult_less
tff(fact_2023_abs__ge__minus__self,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A3)),aa(B,B,abs_abs(B),A3)) ) ).

% abs_ge_minus_self
tff(fact_2024_abs__le__iff,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A3)),Ba)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A3)),Ba) ) ) ) ).

% abs_le_iff
tff(fact_2025_abs__le__D2,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A3)),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A3)),Ba) ) ) ).

% abs_le_D2
tff(fact_2026_abs__leI,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),A3)),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),A3)),Ba) ) ) ) ).

% abs_leI
tff(fact_2027_mult__sgn__abs,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,sgn_sgn(B),X)),aa(B,B,abs_abs(B),X)) = X ) ) ).

% mult_sgn_abs
tff(fact_2028_sgn__mult__abs,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,sgn_sgn(B),A3)),aa(B,B,abs_abs(B),A3)) = A3 ) ) ).

% sgn_mult_abs
tff(fact_2029_abs__mult__sgn,axiom,
    ! [B: $tType] :
      ( idom_abs_sgn(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),A3)),aa(B,B,sgn_sgn(B),A3)) = A3 ) ) ).

% abs_mult_sgn
tff(fact_2030_linordered__idom__class_Oabs__sgn,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [K: B] : ( aa(B,B,abs_abs(B),K) = aa(B,B,aa(B,fun(B,B),times_times(B),K),aa(B,B,sgn_sgn(B),K)) ) ) ).

% linordered_idom_class.abs_sgn
tff(fact_2031_dense__eq0__I,axiom,
    ! [B: $tType] :
      ( ( ordere166539214618696060dd_abs(B)
        & dense_linorder(B) )
     => ! [X: B] :
          ( ! [E3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),E3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),X)),E3) )
         => ( X = zero_zero(B) ) ) ) ).

% dense_eq0_I
tff(fact_2032_abs__eq__mult,axiom,
    ! [B: $tType] :
      ( ordered_ring_abs(B)
     => ! [A3: B,Ba: B] :
          ( ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
              | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),zero_zero(B)) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),Ba)
              | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),zero_zero(B)) ) )
         => ( aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),Ba)) ) ) ) ).

% abs_eq_mult
tff(fact_2033_abs__mult__pos,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,abs_abs(B),Y)),X) = aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),times_times(B),Y),X)) ) ) ) ).

% abs_mult_pos
tff(fact_2034_abs__minus__le__zero,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,uminus_uminus(B),aa(B,B,abs_abs(B),A3))),zero_zero(B)) ) ).

% abs_minus_le_zero
tff(fact_2035_abs__diff__triangle__ineq,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),D2)))),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),C2))),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),D2)))) ) ).

% abs_diff_triangle_ineq
tff(fact_2036_abs__triangle__ineq4,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),Ba))),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,abs_abs(B),A3)),aa(B,B,abs_abs(B),Ba))) ) ).

% abs_triangle_ineq4
tff(fact_2037_abs__of__neg,axiom,
    ! [B: $tType] :
      ( ordere166539214618696060dd_abs(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B))
         => ( aa(B,B,abs_abs(B),A3) = aa(B,B,uminus_uminus(B),A3) ) ) ) ).

% abs_of_neg
tff(fact_2038_abs__sgn__eq,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B] :
          ( aa(B,B,abs_abs(B),aa(B,B,sgn_sgn(B),A3))
          = $ite(A3 = zero_zero(B),zero_zero(B),one_one(B)) ) ) ).

% abs_sgn_eq
tff(fact_2039_pochhammer__0__left,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [N: nat] :
          ( comm_s3205402744901411588hammer(B,zero_zero(B),N)
          = $ite(N = zero_zero(nat),one_one(B),zero_zero(B)) ) ) ).

% pochhammer_0_left
tff(fact_2040_Ints__odd__nonzero,axiom,
    ! [B: $tType] :
      ( ring_char_0(B)
     => ! [A3: B] :
          ( member(B,A3,ring_1_Ints(B))
         => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A3)),A3) != zero_zero(B) ) ) ) ).

% Ints_odd_nonzero
tff(fact_2041_abs__add__one__gt__zero,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B] : aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),aa(B,B,abs_abs(B),X))) ) ).

% abs_add_one_gt_zero
tff(fact_2042_of__int__leD,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [N: int,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(int,B,ring_1_of_int(B),N))),X)
         => ( ( N = zero_zero(int) )
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),X) ) ) ) ).

% of_int_leD
tff(fact_2043_of__int__lessD,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [N: int,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),aa(int,B,ring_1_of_int(B),N))),X)
         => ( ( N = zero_zero(int) )
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),X) ) ) ) ).

% of_int_lessD
tff(fact_2044_pochhammer__rec,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: B,N: nat] : ( comm_s3205402744901411588hammer(B,A3,aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B)),N)) ) ) ).

% pochhammer_rec
tff(fact_2045_pochhammer__rec_H,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Z2: B,N: nat] : ( comm_s3205402744901411588hammer(B,Z2,aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),aa(nat,B,semiring_1_of_nat(B),N))),comm_s3205402744901411588hammer(B,Z2,N)) ) ) ).

% pochhammer_rec'
tff(fact_2046_pochhammer__Suc,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: B,N: nat] : ( comm_s3205402744901411588hammer(B,A3,aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),comm_s3205402744901411588hammer(B,A3,N)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(nat,B,semiring_1_of_nat(B),N))) ) ) ).

% pochhammer_Suc
tff(fact_2047_pochhammer__product_H,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Z2: B,N: nat,M4: nat] : ( comm_s3205402744901411588hammer(B,Z2,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M4)) = aa(B,B,aa(B,fun(B,B),times_times(B),comm_s3205402744901411588hammer(B,Z2,N)),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),aa(nat,B,semiring_1_of_nat(B),N)),M4)) ) ) ).

% pochhammer_product'
tff(fact_2048_Ints__odd__less__0,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [A3: B] :
          ( member(B,A3,ring_1_Ints(B))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),one_one(B)),A3)),A3)),zero_zero(B))
          <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),zero_zero(B)) ) ) ) ).

% Ints_odd_less_0
tff(fact_2049_abs__square__eq__1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B] :
          ( ( aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))) = one_one(B) )
        <=> ( aa(B,B,abs_abs(B),X) = one_one(B) ) ) ) ).

% abs_square_eq_1
tff(fact_2050_pochhammer__product,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [M4: nat,N: nat,Z2: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( comm_s3205402744901411588hammer(B,Z2,N) = aa(B,B,aa(B,fun(B,B),times_times(B),comm_s3205402744901411588hammer(B,Z2,M4)),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),aa(nat,B,semiring_1_of_nat(B),M4)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ) ).

% pochhammer_product
tff(fact_2051_eucl__rel__int__remainderI,axiom,
    ! [R3: int,L: int,K: int,Q2: int] :
      ( ( aa(int,int,sgn_sgn(int),R3) = aa(int,int,sgn_sgn(int),L) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R3)),aa(int,int,abs_abs(int),L))
       => ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q2),L)),R3) )
         => eucl_rel_int(K,L,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q2),R3)) ) ) ) ).

% eucl_rel_int_remainderI
tff(fact_2052_abs__square__le__1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),X)),one_one(B)) ) ) ).

% abs_square_le_1
tff(fact_2053_abs__square__less__1,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))),one_one(B))
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,abs_abs(B),X)),one_one(B)) ) ) ).

% abs_square_less_1
tff(fact_2054_frac__neg,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B] :
          ( archimedean_frac(B,aa(B,B,uminus_uminus(B),X))
          = $ite(member(B,X,ring_1_Ints(B)),zero_zero(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),archimedean_frac(B,X))) ) ) ).

% frac_neg
tff(fact_2055_pochhammer__absorb__comp,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [R3: B,K: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),R3),aa(nat,B,semiring_1_of_nat(B),K))),comm_s3205402744901411588hammer(B,aa(B,B,uminus_uminus(B),R3),K)) = aa(B,B,aa(B,fun(B,B),times_times(B),R3),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,uminus_uminus(B),R3)),one_one(B)),K)) ) ) ).

% pochhammer_absorb_comp
tff(fact_2056_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
     => ( ( ( A22 = zero_zero(int) )
         => ( A32 != aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),A1) ) )
       => ( ! [Q5: int] :
              ( ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q5),zero_zero(int)) )
             => ( ( A22 != zero_zero(int) )
               => ( A1 != aa(int,int,aa(int,fun(int,int),times_times(int),Q5),A22) ) ) )
         => ~ ! [R2: int,Q5: int] :
                ( ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q5),R2) )
               => ( ( aa(int,int,sgn_sgn(int),R2) = aa(int,int,sgn_sgn(int),A22) )
                 => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R2)),aa(int,int,abs_abs(int),A22))
                   => ( A1 != aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q5),A22)),R2) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
tff(fact_2057_eucl__rel__int_Osimps,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
    <=> ( ? [K4: int] :
            ( ( A1 = K4 )
            & ( A22 = zero_zero(int) )
            & ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),K4) ) )
        | ? [L4: int,K4: int,Q6: int] :
            ( ( A1 = K4 )
            & ( A22 = L4 )
            & ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q6),zero_zero(int)) )
            & ( L4 != zero_zero(int) )
            & ( K4 = aa(int,int,aa(int,fun(int,int),times_times(int),Q6),L4) ) )
        | ? [R5: int,L4: int,K4: int,Q6: int] :
            ( ( A1 = K4 )
            & ( A22 = L4 )
            & ( A32 = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Q6),R5) )
            & ( aa(int,int,sgn_sgn(int),R5) = aa(int,int,sgn_sgn(int),L4) )
            & aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R5)),aa(int,int,abs_abs(int),L4))
            & ( K4 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q6),L4)),R5) ) ) ) ) ).

% eucl_rel_int.simps
tff(fact_2058_frac__unique__iff,axiom,
    ! [B: $tType] :
      ( archim2362893244070406136eiling(B)
     => ! [X: B,A3: B] :
          ( ( archimedean_frac(B,X) = A3 )
        <=> ( member(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),X),A3),ring_1_Ints(B))
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),one_one(B)) ) ) ) ).

% frac_unique_iff
tff(fact_2059_fact__double,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [N: nat] : ( semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N))),comm_s3205402744901411588hammer(B,divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N))),semiring_char_0_fact(B,N)) ) ) ).

% fact_double
tff(fact_2060_gbinomial__absorption_H,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,A3: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
         => ( aa(nat,B,gbinomial(B,A3),K) = aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,aa(nat,B,semiring_1_of_nat(B),K))),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ) ).

% gbinomial_absorption'
tff(fact_2061_Gcd__0__iff,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: set(B)] :
          ( ( gcd_Gcd(B,A4) = zero_zero(B) )
        <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),insert2(B,zero_zero(B)),bot_bot(set(B)))) ) ) ).

% Gcd_0_iff
tff(fact_2062_pochhammer__same,axiom,
    ! [B: $tType] :
      ( ( semiring_char_0(B)
        & comm_ring_1(B)
        & semiri3467727345109120633visors(B) )
     => ! [N: nat] : ( comm_s3205402744901411588hammer(B,aa(B,B,uminus_uminus(B),aa(nat,B,semiring_1_of_nat(B),N)),N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),semiring_char_0_fact(B,N)) ) ) ).

% pochhammer_same
tff(fact_2063_fact__reduce,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( semiring_char_0_fact(B,N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ) ) ).

% fact_reduce
tff(fact_2064_fact__num__eq__if,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [M4: nat] :
          ( semiring_char_0_fact(B,M4)
          = $ite(M4 = zero_zero(nat),one_one(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),M4)),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),one_one(nat))))) ) ) ).

% fact_num_eq_if
tff(fact_2065_abstract__boolean__algebra__sym__diff__def,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B))] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
    <=> ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
        & boolea5476839437570043046axioms(B,Conj,Disj,Compl,Xor) ) ) ).

% abstract_boolean_algebra_sym_diff_def
tff(fact_2066_fact__0,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ( semiring_char_0_fact(B,zero_zero(nat)) = one_one(B) ) ) ).

% fact_0
tff(fact_2067_Gcd__empty,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ( gcd_Gcd(B,bot_bot(set(B))) = zero_zero(B) ) ) ).

% Gcd_empty
tff(fact_2068_gbinomial__0_I1_J,axiom,
    ! [B: $tType] :
      ( ( semiring_char_0(B)
        & semidom_divide(B) )
     => ! [A3: B] : ( aa(nat,B,gbinomial(B,A3),zero_zero(nat)) = one_one(B) ) ) ).

% gbinomial_0(1)
tff(fact_2069_fact__1,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ( semiring_char_0_fact(B,one_one(nat)) = one_one(B) ) ) ).

% fact_1
tff(fact_2070_Gcd__UNIV,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ( gcd_Gcd(B,top_top(set(B))) = one_one(B) ) ) ).

% Gcd_UNIV
tff(fact_2071_fact__Suc__0,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ( semiring_char_0_fact(B,aa(nat,nat,suc,zero_zero(nat))) = one_one(B) ) ) ).

% fact_Suc_0
tff(fact_2072_fact__Suc,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [N: nat] : ( semiring_char_0_fact(B,aa(nat,nat,suc,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,N))),semiring_char_0_fact(B,N)) ) ) ).

% fact_Suc
tff(fact_2073_abstract__boolean__algebra__sym__diff__axioms_Ointro,axiom,
    ! [B: $tType,Xor: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Conj: fun(B,fun(B,B)),Compl: fun(B,B)] :
      ( ! [X2: B,Y2: B] : ( aa(B,B,aa(B,fun(B,B),Xor,X2),Y2) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X2),aa(B,B,Compl,Y2))),aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,Compl,X2)),Y2)) )
     => boolea5476839437570043046axioms(B,Conj,Disj,Compl,Xor) ) ).

% abstract_boolean_algebra_sym_diff_axioms.intro
tff(fact_2074_abstract__boolean__algebra__sym__diff__axioms__def,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Xor: fun(B,fun(B,B))] :
      ( boolea5476839437570043046axioms(B,Conj,Disj,Compl,Xor)
    <=> ! [X4: B,Y3: B] : ( aa(B,B,aa(B,fun(B,B),Xor,X4),Y3) = aa(B,B,aa(B,fun(B,B),Disj,aa(B,B,aa(B,fun(B,B),Conj,X4),aa(B,B,Compl,Y3))),aa(B,B,aa(B,fun(B,B),Conj,aa(B,B,Compl,X4)),Y3)) ) ) ).

% abstract_boolean_algebra_sym_diff_axioms_def
tff(fact_2075_Gcd__1,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: set(B)] :
          ( member(B,one_one(B),A4)
         => ( gcd_Gcd(B,A4) = one_one(B) ) ) ) ).

% Gcd_1
tff(fact_2076_gbinomial__Suc__Suc,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B))),aa(nat,nat,suc,K)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,gbinomial(B,A3),K)),aa(nat,B,gbinomial(B,A3),aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc_Suc
tff(fact_2077_fact__ge__1,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [N: nat] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),semiring_char_0_fact(B,N)) ) ).

% fact_ge_1
tff(fact_2078_fact__fact__dvd__fact,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [K: nat,N: nat] : dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),semiring_char_0_fact(B,K)),semiring_char_0_fact(B,N)),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N))) ) ).

% fact_fact_dvd_fact
tff(fact_2079_pochhammer__fact,axiom,
    ! [B: $tType] :
      ( ( semiring_char_0(B)
        & comm_semiring_1(B) )
     => ! [N: nat] : ( semiring_char_0_fact(B,N) = comm_s3205402744901411588hammer(B,one_one(B),N) ) ) ).

% pochhammer_fact
tff(fact_2080_gbinomial__pochhammer_H,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(nat,B,gbinomial(B,A3),K) = divide_divide(B,comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(nat,B,semiring_1_of_nat(B),K))),one_one(B)),K),semiring_char_0_fact(B,K)) ) ) ).

% gbinomial_pochhammer'
tff(fact_2081_gbinomial__pochhammer,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(nat,B,gbinomial(B,A3),K) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),comm_s3205402744901411588hammer(B,aa(B,B,uminus_uminus(B),A3),K)),semiring_char_0_fact(B,K)) ) ) ).

% gbinomial_pochhammer
tff(fact_2082_Gcd__eq__1__I,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: B,A4: set(B)] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( member(B,A3,A4)
           => ( gcd_Gcd(B,A4) = one_one(B) ) ) ) ) ).

% Gcd_eq_1_I
tff(fact_2083_gbinomial__addition__formula,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(nat,B,gbinomial(B,A3),aa(nat,nat,suc,K)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))),aa(nat,nat,suc,K))),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))),K)) ) ) ).

% gbinomial_addition_formula
tff(fact_2084_gbinomial__absorb__comp,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(nat,B,semiring_1_of_nat(B),K))),aa(nat,B,gbinomial(B,A3),K)) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))),K)) ) ) ).

% gbinomial_absorb_comp
tff(fact_2085_gbinomial__mult__1_H,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,A3),K)),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),K)),aa(nat,B,gbinomial(B,A3),K))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K))),aa(nat,B,gbinomial(B,A3),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1'
tff(fact_2086_gbinomial__mult__1,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,gbinomial(B,A3),K)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),K)),aa(nat,B,gbinomial(B,A3),K))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K))),aa(nat,B,gbinomial(B,A3),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1
tff(fact_2087_choose__dvd,axiom,
    ! [B: $tType] :
      ( linordered_semidom(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),semiring_char_0_fact(B,K)),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))),semiring_char_0_fact(B,N)) ) ) ).

% choose_dvd
tff(fact_2088_abstract__boolean__algebra__sym__diff_Oaxioms_I2_J,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B))] :
      ( boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor)
     => boolea5476839437570043046axioms(B,Conj,Disj,Compl,Xor) ) ).

% abstract_boolean_algebra_sym_diff.axioms(2)
tff(fact_2089_Suc__times__gbinomial,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K))),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B))),aa(nat,nat,suc,K))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B))),aa(nat,B,gbinomial(B,A3),K)) ) ) ).

% Suc_times_gbinomial
tff(fact_2090_gbinomial__absorption,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K))),aa(nat,B,gbinomial(B,A3),aa(nat,nat,suc,K))) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))),K)) ) ) ).

% gbinomial_absorption
tff(fact_2091_gbinomial__trinomial__revision,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,M4: nat,A3: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M4)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,A3),M4)),aa(nat,B,gbinomial(B,aa(nat,B,semiring_1_of_nat(B),M4)),K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,A3),K)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),aa(nat,B,semiring_1_of_nat(B),K))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),K))) ) ) ) ).

% gbinomial_trinomial_revision
tff(fact_2092_gbinomial__rec,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B))),aa(nat,nat,suc,K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,A3),K)),divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B)),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_rec
tff(fact_2093_gbinomial__factors,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B))),aa(nat,nat,suc,K)) = aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B)),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,K)))),aa(nat,B,gbinomial(B,A3),K)) ) ) ).

% gbinomial_factors
tff(fact_2094_gbinomial__index__swap,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(nat,B,semiring_1_of_nat(B),N))),one_one(B))),K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),N)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,uminus_uminus(B),aa(nat,B,semiring_1_of_nat(B),K))),one_one(B))),N)) ) ) ).

% gbinomial_index_swap
tff(fact_2095_gbinomial__negated__upper,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(nat,B,gbinomial(B,A3),K) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,semiring_1_of_nat(B),K)),A3)),one_one(B))),K)) ) ) ).

% gbinomial_negated_upper
tff(fact_2096_fact__numeral,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [K: num] : ( semiring_char_0_fact(B,aa(num,nat,numeral_numeral(nat),K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),K)),semiring_char_0_fact(B,pred_numeral(K))) ) ) ).

% fact_numeral
tff(fact_2097_gbinomial__minus,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(nat,B,gbinomial(B,aa(B,B,uminus_uminus(B),A3)),K) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),K)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(nat,B,semiring_1_of_nat(B),K))),one_one(B))),K)) ) ) ).

% gbinomial_minus
tff(fact_2098_gbinomial__reduce__nat,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,A3: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
         => ( aa(nat,B,gbinomial(B,A3),K) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))),K)) ) ) ) ).

% gbinomial_reduce_nat
tff(fact_2099_abstract__boolean__algebra__sym__diff_Ointro,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B,Xor: fun(B,fun(B,B))] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => ( boolea5476839437570043046axioms(B,Conj,Disj,Compl,Xor)
       => boolea3799213064322606851m_diff(B,Conj,Disj,Compl,Zero,One,Xor) ) ) ).

% abstract_boolean_algebra_sym_diff.intro
tff(fact_2100_quotient__of__number_I5_J,axiom,
    ! [K: num] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),K))) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)) ) ).

% quotient_of_number(5)
tff(fact_2101_binomial__fact,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(nat,B,semiring_1_of_nat(B),binomial(N,K)) = divide_divide(B,semiring_char_0_fact(B,N),aa(B,B,aa(B,fun(B,B),times_times(B),semiring_char_0_fact(B,K)),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))) ) ) ) ).

% binomial_fact
tff(fact_2102_fact__binomial,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),semiring_char_0_fact(B,K)),aa(nat,B,semiring_1_of_nat(B),binomial(N,K))) = divide_divide(B,semiring_char_0_fact(B,N),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_binomial
tff(fact_2103_card__doubleton__eq__2__iff,axiom,
    ! [B: $tType,A3: B,Ba: B] :
      ( ( finite_card(B,aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ( A3 != Ba ) ) ).

% card_doubleton_eq_2_iff
tff(fact_2104_refl__on__singleton,axiom,
    ! [B: $tType,X: B] : refl_on(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),X)),bot_bot(set(product_prod(B,B))))) ).

% refl_on_singleton
tff(fact_2105_pair__lessI2,axiom,
    ! [A3: nat,Ba: nat,S: nat,T4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A3),Ba)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),S),T4)
       => member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),S)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Ba),T4)),fun_pair_less) ) ) ).

% pair_lessI2
tff(fact_2106_euclidean__size__times__nonunit,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( ( Ba != zero_zero(B) )
           => ( ~ dvd_dvd(B,A3,one_one(B))
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,euclid6346220572633701492n_size(B),Ba)),aa(B,nat,euclid6346220572633701492n_size(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))) ) ) ) ) ).

% euclidean_size_times_nonunit
tff(fact_2107_euclidean__size__1,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ( aa(B,nat,euclid6346220572633701492n_size(B),one_one(B)) = one_one(nat) ) ) ).

% euclidean_size_1
tff(fact_2108_rat__one__code,axiom,
    quotient_of(one_one(rat)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int)) ).

% rat_one_code
tff(fact_2109_rat__zero__code,axiom,
    quotient_of(zero_zero(rat)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)) ).

% rat_zero_code
tff(fact_2110_pair__less__iff1,axiom,
    ! [X: nat,Y: nat,Z2: nat] :
      ( member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Y)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Z2)),fun_pair_less)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y),Z2) ) ).

% pair_less_iff1
tff(fact_2111_quotient__of__number_I4_J,axiom,
    quotient_of(aa(rat,rat,uminus_uminus(rat),one_one(rat))) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),one_one(int))),one_one(int)) ).

% quotient_of_number(4)
tff(fact_2112_quotient__of__number_I3_J,axiom,
    ! [K: num] : ( quotient_of(aa(num,rat,numeral_numeral(rat),K)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(num,int,numeral_numeral(int),K)),one_one(int)) ) ).

% quotient_of_number(3)
tff(fact_2113_refl__onD,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),A3: B] :
      ( refl_on(B,A4,R3)
     => ( member(B,A3,A4)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),A3),R3) ) ) ).

% refl_onD
tff(fact_2114_refl__onD1,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X: B,Y: B] :
      ( refl_on(B,A4,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
       => member(B,X,A4) ) ) ).

% refl_onD1
tff(fact_2115_refl__onD2,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X: B,Y: B] :
      ( refl_on(B,A4,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
       => member(B,Y,A4) ) ) ).

% refl_onD2
tff(fact_2116_refl__on__Int,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),B2: set(B),S: set(product_prod(B,B))] :
      ( refl_on(B,A4,R3)
     => ( refl_on(B,B2,S)
       => refl_on(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),S)) ) ) ).

% refl_on_Int
tff(fact_2117_quotient__of__div,axiom,
    ! [R3: rat,N: int,D2: int] :
      ( ( quotient_of(R3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),N),D2) )
     => ( R3 = divide_divide(rat,aa(int,rat,ring_1_of_int(rat),N),aa(int,rat,ring_1_of_int(rat),D2)) ) ) ).

% quotient_of_div
tff(fact_2118_euclidean__size__unit,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [A3: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,nat,euclid6346220572633701492n_size(B),A3) = aa(B,nat,euclid6346220572633701492n_size(B),one_one(B)) ) ) ) ).

% euclidean_size_unit
tff(fact_2119_euclidean__size__mult,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [A3: B,Ba: B] : ( aa(B,nat,euclid6346220572633701492n_size(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(B,nat,euclid6346220572633701492n_size(B),A3)),aa(B,nat,euclid6346220572633701492n_size(B),Ba)) ) ) ).

% euclidean_size_mult
tff(fact_2120_refl__on__empty,axiom,
    ! [B: $tType] : refl_on(B,bot_bot(set(B)),bot_bot(set(product_prod(B,B)))) ).

% refl_on_empty
tff(fact_2121_unit__iff__euclidean__size,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [A3: B] :
          ( dvd_dvd(B,A3,one_one(B))
        <=> ( ( aa(B,nat,euclid6346220572633701492n_size(B),A3) = aa(B,nat,euclid6346220572633701492n_size(B),one_one(B)) )
            & ( A3 != zero_zero(B) ) ) ) ) ).

% unit_iff_euclidean_size
tff(fact_2122_size__mult__mono_H,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [Ba: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(B,nat,euclid6346220572633701492n_size(B),A3)),aa(B,nat,euclid6346220572633701492n_size(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3))) ) ) ).

% size_mult_mono'
tff(fact_2123_size__mult__mono,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [Ba: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(B,nat,euclid6346220572633701492n_size(B),A3)),aa(B,nat,euclid6346220572633701492n_size(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))) ) ) ).

% size_mult_mono
tff(fact_2124_euclidean__size__times__unit,axiom,
    ! [B: $tType] :
      ( euclid3725896446679973847miring(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,nat,euclid6346220572633701492n_size(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,nat,euclid6346220572633701492n_size(B),Ba) ) ) ) ).

% euclidean_size_times_unit
tff(fact_2125_quotient__of__denom__pos,axiom,
    ! [R3: rat,P2: int,Q2: int] :
      ( ( quotient_of(R3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q2) ) ).

% quotient_of_denom_pos
tff(fact_2126_pair__lessI1,axiom,
    ! [A3: nat,Ba: nat,S: nat,T4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A3),Ba)
     => member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),S)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Ba),T4)),fun_pair_less) ) ).

% pair_lessI1
tff(fact_2127_odd__card__imp__not__empty,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ~ dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),finite_card(B,A4))
     => ( A4 != bot_bot(set(B)) ) ) ).

% odd_card_imp_not_empty
tff(fact_2128_rat__sgn__code,axiom,
    ! [P2: rat] : ( quotient_of(aa(rat,rat,sgn_sgn(rat),P2)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,sgn_sgn(int),aa(product_prod(int,int),int,product_fst(int,int),quotient_of(P2)))),one_one(int)) ) ).

% rat_sgn_code
tff(fact_2129_card_Oempty,axiom,
    ! [B: $tType] : ( finite_card(B,bot_bot(set(B))) = zero_zero(nat) ) ).

% card.empty
tff(fact_2130_card__Diff__singleton,axiom,
    ! [B: $tType,X: B,A4: set(B)] :
      ( member(B,X,A4)
     => ( finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(B,A4)),one_one(nat)) ) ) ).

% card_Diff_singleton
tff(fact_2131_card__Diff__singleton__if,axiom,
    ! [B: $tType,A4: set(B),X: B] :
      ( finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))
      = $ite(member(B,X,A4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(B,A4)),one_one(nat)),finite_card(B,A4)) ) ).

% card_Diff_singleton_if
tff(fact_2132_card__3__iff,axiom,
    ! [B: $tType,S2: set(B)] :
      ( ( finite_card(B,S2) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) )
    <=> ? [X4: B,Y3: B,Z4: B] :
          ( ( S2 = aa(set(B),set(B),insert2(B,X4),aa(set(B),set(B),insert2(B,Y3),aa(set(B),set(B),insert2(B,Z4),bot_bot(set(B))))) )
          & ( X4 != Y3 )
          & ( Y3 != Z4 )
          & ( X4 != Z4 ) ) ) ).

% card_3_iff
tff(fact_2133_card__2__iff,axiom,
    ! [B: $tType,S2: set(B)] :
      ( ( finite_card(B,S2) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)) )
    <=> ? [X4: B,Y3: B] :
          ( ( S2 = aa(set(B),set(B),insert2(B,X4),aa(set(B),set(B),insert2(B,Y3),bot_bot(set(B)))) )
          & ( X4 != Y3 ) ) ) ).

% card_2_iff
tff(fact_2134_card__Diff1__le,axiom,
    ! [B: $tType,A4: set(B),X: B] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))),finite_card(B,A4)) ).

% card_Diff1_le
tff(fact_2135_card__Suc__eq,axiom,
    ! [B: $tType,A4: set(B),K: nat] :
      ( ( finite_card(B,A4) = aa(nat,nat,suc,K) )
    <=> ? [B5: B,B7: set(B)] :
          ( ( A4 = aa(set(B),set(B),insert2(B,B5),B7) )
          & ~ member(B,B5,B7)
          & ( finite_card(B,B7) = K )
          & ( ( K = zero_zero(nat) )
           => ( B7 = bot_bot(set(B)) ) ) ) ) ).

% card_Suc_eq
tff(fact_2136_card_Ocomp__fun__commute__on,axiom,
    aa(fun(nat,nat),fun(nat,nat),aa(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),comp(nat,nat,nat),suc),suc) = aa(fun(nat,nat),fun(nat,nat),aa(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),comp(nat,nat,nat),suc),suc) ).

% card.comp_fun_commute_on
tff(fact_2137_fold__atLeastAtMost__nat_Ocases,axiom,
    ! [B: $tType,X: product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B)))] :
      ~ ! [F8: fun(nat,fun(B,B)),A8: nat,B4: nat,Acc: B] : ( X != aa(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),aa(fun(nat,fun(B,B)),fun(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B)))),product_Pair(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),F8),aa(product_prod(nat,B),product_prod(nat,product_prod(nat,B)),aa(nat,fun(product_prod(nat,B),product_prod(nat,product_prod(nat,B))),product_Pair(nat,product_prod(nat,B)),A8),aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),B4),Acc))) ) ).

% fold_atLeastAtMost_nat.cases
tff(fact_2138_card__1__singletonE,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ( finite_card(B,A4) = one_one(nat) )
     => ~ ! [X2: B] : ( A4 != aa(set(B),set(B),insert2(B,X2),bot_bot(set(B))) ) ) ).

% card_1_singletonE
tff(fact_2139_card__1__singleton__iff,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ( finite_card(B,A4) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ? [X4: B] : ( A4 = aa(set(B),set(B),insert2(B,X4),bot_bot(set(B))) ) ) ).

% card_1_singleton_iff
tff(fact_2140_card__eq__SucD,axiom,
    ! [B: $tType,A4: set(B),K: nat] :
      ( ( finite_card(B,A4) = aa(nat,nat,suc,K) )
     => ? [B4: B,B8: set(B)] :
          ( ( A4 = aa(set(B),set(B),insert2(B,B4),B8) )
          & ~ member(B,B4,B8)
          & ( finite_card(B,B8) = K )
          & ( ( K = zero_zero(nat) )
           => ( B8 = bot_bot(set(B)) ) ) ) ) ).

% card_eq_SucD
tff(fact_2141_quotient__of__int,axiom,
    ! [A3: int] : ( quotient_of(of_int(A3)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),one_one(int)) ) ).

% quotient_of_int
tff(fact_2142_Frct__code__post_I5_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),aa(num,int,numeral_numeral(int),K))) = divide_divide(rat,one_one(rat),aa(num,rat,numeral_numeral(rat),K)) ) ).

% Frct_code_post(5)
tff(fact_2143_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [B: $tType,A0: fun(nat,fun(B,B)),A1: nat,A22: nat,A32: B,Pa: fun(fun(nat,fun(B,B)),fun(nat,fun(nat,fun(B,$o))))] :
      ( aa(product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),$o,accp(product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),set_fo1817059534552279752at_rel(B)),aa(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),aa(fun(nat,fun(B,B)),fun(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B)))),product_Pair(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),A0),aa(product_prod(nat,B),product_prod(nat,product_prod(nat,B)),aa(nat,fun(product_prod(nat,B),product_prod(nat,product_prod(nat,B))),product_Pair(nat,product_prod(nat,B)),A1),aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),A22),A32))))
     => ( ! [F8: fun(nat,fun(B,B)),A8: nat,B4: nat,Acc: B] :
            ( aa(product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),$o,accp(product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),set_fo1817059534552279752at_rel(B)),aa(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),aa(fun(nat,fun(B,B)),fun(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B)))),product_Pair(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),F8),aa(product_prod(nat,B),product_prod(nat,product_prod(nat,B)),aa(nat,fun(product_prod(nat,B),product_prod(nat,product_prod(nat,B))),product_Pair(nat,product_prod(nat,B)),A8),aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),B4),Acc))))
           => ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),B4),A8)
               => aa(B,$o,aa(nat,fun(B,$o),aa(nat,fun(nat,fun(B,$o)),aa(fun(nat,fun(B,B)),fun(nat,fun(nat,fun(B,$o))),Pa,F8),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A8),one_one(nat))),B4),aa(B,B,aa(nat,fun(B,B),F8,A8),Acc)) )
             => aa(B,$o,aa(nat,fun(B,$o),aa(nat,fun(nat,fun(B,$o)),aa(fun(nat,fun(B,B)),fun(nat,fun(nat,fun(B,$o))),Pa,F8),A8),B4),Acc) ) )
       => aa(B,$o,aa(nat,fun(B,$o),aa(nat,fun(nat,fun(B,$o)),aa(fun(nat,fun(B,B)),fun(nat,fun(nat,fun(B,$o))),Pa,A0),A1),A22),A32) ) ) ).

% fold_atLeastAtMost_nat.pinduct
tff(fact_2144_divmod__cases,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [Ba: B,A3: B] :
          ( ( ( Ba != zero_zero(B) )
           => ( ( modulo_modulo(B,A3,Ba) = zero_zero(B) )
             => ( A3 != aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,A3,Ba)),Ba) ) ) )
         => ( ( ( Ba != zero_zero(B) )
             => ! [Q5: B,R2: B] :
                  ( ( euclid7384307370059645450egment(B,R2) = euclid7384307370059645450egment(B,Ba) )
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,euclid6346220572633701492n_size(B),R2)),aa(B,nat,euclid6346220572633701492n_size(B),Ba))
                   => ( ( R2 != zero_zero(B) )
                     => ( ( divide_divide(B,A3,Ba) = Q5 )
                       => ( ( modulo_modulo(B,A3,Ba) = R2 )
                         => ( A3 != aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Q5),Ba)),R2) ) ) ) ) ) ) )
           => ( Ba = zero_zero(B) ) ) ) ) ).

% divmod_cases
tff(fact_2145_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(num,int,numeral_numeral(int),K)),aa(num,int,numeral_numeral(int),L))) = divide_divide(rat,aa(num,rat,numeral_numeral(rat),K),aa(num,rat,numeral_numeral(rat),L)) ) ).

% Frct_code_post(6)
tff(fact_2146_mod__eqI,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [Ba: B,R3: B,Q2: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => ( ( euclid7384307370059645450egment(B,R3) = euclid7384307370059645450egment(B,Ba) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,euclid6346220572633701492n_size(B),R3)),aa(B,nat,euclid6346220572633701492n_size(B),Ba))
             => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Q2),Ba)),R3) = A3 )
               => ( modulo_modulo(B,A3,Ba) = R3 ) ) ) ) ) ) ).

% mod_eqI
tff(fact_2147_div__eqI,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [Ba: B,R3: B,Q2: B,A3: B] :
          ( ( Ba != zero_zero(B) )
         => ( ( euclid7384307370059645450egment(B,R3) = euclid7384307370059645450egment(B,Ba) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,euclid6346220572633701492n_size(B),R3)),aa(B,nat,euclid6346220572633701492n_size(B),Ba))
             => ( ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Q2),Ba)),R3) = A3 )
               => ( divide_divide(B,A3,Ba) = Q2 ) ) ) ) ) ) ).

% div_eqI
tff(fact_2148_division__segment__1,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ( euclid7384307370059645450egment(B,one_one(B)) = one_one(B) ) ) ).

% division_segment_1
tff(fact_2149_division__segment__numeral,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [K: num] : ( euclid7384307370059645450egment(B,aa(num,B,numeral_numeral(B),K)) = one_one(B) ) ) ).

% division_segment_numeral
tff(fact_2150_division__segment__of__nat,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat] : ( euclid7384307370059645450egment(B,aa(nat,B,semiring_1_of_nat(B),N)) = one_one(B) ) ) ).

% division_segment_of_nat
tff(fact_2151_division__segment__euclidean__size,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),euclid7384307370059645450egment(B,A3)),aa(nat,B,semiring_1_of_nat(B),aa(B,nat,euclid6346220572633701492n_size(B),A3))) = A3 ) ) ).

% division_segment_euclidean_size
tff(fact_2152_division__segment__mult,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( ( Ba != zero_zero(B) )
           => ( euclid7384307370059645450egment(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),euclid7384307370059645450egment(B,A3)),euclid7384307370059645450egment(B,Ba)) ) ) ) ) ).

% division_segment_mult
tff(fact_2153_is__unit__division__segment,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [A3: B] : dvd_dvd(B,euclid7384307370059645450egment(B,A3),one_one(B)) ) ).

% is_unit_division_segment
tff(fact_2154_Frct__code__post_I2_J,axiom,
    ! [A3: int] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),zero_zero(int))) = zero_zero(rat) ) ).

% Frct_code_post(2)
tff(fact_2155_Frct__code__post_I1_J,axiom,
    ! [A3: int] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),A3)) = zero_zero(rat) ) ).

% Frct_code_post(1)
tff(fact_2156_Frct__code__post_I3_J,axiom,
    frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int))) = one_one(rat) ).

% Frct_code_post(3)
tff(fact_2157_Frct__code__post_I7_J,axiom,
    ! [A3: int,Ba: int] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),A3)),Ba)) = aa(rat,rat,uminus_uminus(rat),frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),Ba))) ) ).

% Frct_code_post(7)
tff(fact_2158_Frct__code__post_I8_J,axiom,
    ! [A3: int,Ba: int] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),aa(int,int,uminus_uminus(int),Ba))) = aa(rat,rat,uminus_uminus(rat),frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),Ba))) ) ).

% Frct_code_post(8)
tff(fact_2159_Frct__code__post_I4_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(num,int,numeral_numeral(int),K)),one_one(int))) = aa(num,rat,numeral_numeral(rat),K) ) ).

% Frct_code_post(4)
tff(fact_2160_div__bounded,axiom,
    ! [B: $tType] :
      ( euclid3128863361964157862miring(B)
     => ! [Ba: B,R3: B,Q2: B] :
          ( ( Ba != zero_zero(B) )
         => ( ( euclid7384307370059645450egment(B,R3) = euclid7384307370059645450egment(B,Ba) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,euclid6346220572633701492n_size(B),R3)),aa(B,nat,euclid6346220572633701492n_size(B),Ba))
             => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Q2),Ba)),R3),Ba) = Q2 ) ) ) ) ) ).

% div_bounded
tff(fact_2161_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [B: $tType,X: fun(nat,fun(B,B)),Xa: nat,Xb: nat,Xc: B,Y: B] :
      ( ( set_fo6178422350223883121st_nat(B,X,Xa,Xb,Xc) = Y )
     => ( aa(product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),$o,accp(product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),set_fo1817059534552279752at_rel(B)),aa(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),aa(fun(nat,fun(B,B)),fun(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B)))),product_Pair(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),X),aa(product_prod(nat,B),product_prod(nat,product_prod(nat,B)),aa(nat,fun(product_prod(nat,B),product_prod(nat,product_prod(nat,B))),product_Pair(nat,product_prod(nat,B)),Xa),aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),Xb),Xc))))
       => ~ ( ( Y
              = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xb),Xa),Xc,set_fo6178422350223883121st_nat(B,X,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Xa),one_one(nat)),Xb,aa(B,B,aa(nat,fun(B,B),X,Xa),Xc))) )
           => ~ aa(product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),$o,accp(product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),set_fo1817059534552279752at_rel(B)),aa(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),aa(fun(nat,fun(B,B)),fun(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B)))),product_Pair(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),X),aa(product_prod(nat,B),product_prod(nat,product_prod(nat,B)),aa(nat,fun(product_prod(nat,B),product_prod(nat,product_prod(nat,B))),product_Pair(nat,product_prod(nat,B)),Xa),aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),Xb),Xc)))) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
tff(fact_2162_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [B: $tType,Fa: fun(nat,fun(B,B)),A3: nat,Ba: nat,Acc2: B] :
      ( aa(product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),$o,accp(product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),set_fo1817059534552279752at_rel(B)),aa(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),aa(fun(nat,fun(B,B)),fun(product_prod(nat,product_prod(nat,B)),product_prod(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B)))),product_Pair(fun(nat,fun(B,B)),product_prod(nat,product_prod(nat,B))),Fa),aa(product_prod(nat,B),product_prod(nat,product_prod(nat,B)),aa(nat,fun(product_prod(nat,B),product_prod(nat,product_prod(nat,B))),product_Pair(nat,product_prod(nat,B)),A3),aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),Ba),Acc2))))
     => ( set_fo6178422350223883121st_nat(B,Fa,A3,Ba,Acc2)
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ba),A3),Acc2,set_fo6178422350223883121st_nat(B,Fa,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A3),one_one(nat)),Ba,aa(B,B,aa(nat,fun(B,B),Fa,A3),Acc2))) ) ) ).

% fold_atLeastAtMost_nat.psimps
tff(fact_2163_refl__on__domain,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( refl_on(B,A4,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
       => ( member(B,A3,A4)
          & member(B,Ba,A4) ) ) ) ).

% refl_on_domain
tff(fact_2164_smin__insertI,axiom,
    ! [X: product_prod(nat,nat),XS: set(product_prod(nat,nat)),Y: product_prod(nat,nat),YS: set(product_prod(nat,nat))] :
      ( member(product_prod(nat,nat),X,XS)
     => ( member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_less)
       => ( member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),XS),YS),fun_min_strict)
         => member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),XS),aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),insert2(product_prod(nat,nat),Y),YS)),fun_min_strict) ) ) ) ).

% smin_insertI
tff(fact_2165_pair__leqI2,axiom,
    ! [A3: nat,Ba: nat,S: nat,T4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A3),Ba)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),S),T4)
       => member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),S)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Ba),T4)),fun_pair_leq) ) ) ).

% pair_leqI2
tff(fact_2166_pair__leqI1,axiom,
    ! [A3: nat,Ba: nat,S: nat,T4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A3),Ba)
     => member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),S)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Ba),T4)),fun_pair_leq) ) ).

% pair_leqI1
tff(fact_2167_zero__rat__def,axiom,
    zero_zero(rat) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int))) ).

% zero_rat_def
tff(fact_2168_smin__emptyI,axiom,
    ! [X6: set(product_prod(nat,nat))] :
      ( ( X6 != bot_bot(set(product_prod(nat,nat))) )
     => member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),X6),bot_bot(set(product_prod(nat,nat)))),fun_min_strict) ) ).

% smin_emptyI
tff(fact_2169_one__rat__def,axiom,
    one_one(rat) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int))) ).

% one_rat_def
tff(fact_2170_wmin__insertI,axiom,
    ! [X: product_prod(nat,nat),XS: set(product_prod(nat,nat)),Y: product_prod(nat,nat),YS: set(product_prod(nat,nat))] :
      ( member(product_prod(nat,nat),X,XS)
     => ( member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_leq)
       => ( member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),XS),YS),fun_min_weak)
         => member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),XS),aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),insert2(product_prod(nat,nat),Y),YS)),fun_min_weak) ) ) ) ).

% wmin_insertI
tff(fact_2171_wmax__insertI,axiom,
    ! [Y: product_prod(nat,nat),YS: set(product_prod(nat,nat)),X: product_prod(nat,nat),XS: set(product_prod(nat,nat))] :
      ( member(product_prod(nat,nat),Y,YS)
     => ( member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_leq)
       => ( member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),XS),YS),fun_max_weak)
         => member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),insert2(product_prod(nat,nat),X),XS)),YS),fun_max_weak) ) ) ) ).

% wmax_insertI
tff(fact_2172_smax__insertI,axiom,
    ! [Y: product_prod(nat,nat),Y5: set(product_prod(nat,nat)),X: product_prod(nat,nat),X6: set(product_prod(nat,nat))] :
      ( member(product_prod(nat,nat),Y,Y5)
     => ( member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_less)
       => ( member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),X6),Y5),fun_max_strict)
         => member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),insert2(product_prod(nat,nat),X),X6)),Y5),fun_max_strict) ) ) ) ).

% smax_insertI
tff(fact_2173_linear__order__on__singleton,axiom,
    ! [B: $tType,X: B] : order_679001287576687338der_on(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),X)),bot_bot(set(product_prod(B,B))))) ).

% linear_order_on_singleton
tff(fact_2174_uminus__rat_Oabs__eq,axiom,
    ! [X: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X),X)
     => ( aa(rat,rat,uminus_uminus(rat),aa(product_prod(int,int),rat,abs_Rat,X)) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),aa(product_prod(int,int),int,product_fst(int,int),X))),aa(product_prod(int,int),int,product_snd(int,int),X))) ) ) ).

% uminus_rat.abs_eq
tff(fact_2175_Total__subset__Id,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( total_on(B,field2(B,R3),R3)
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R3),id2(B))
       => ( ( R3 = bot_bot(set(product_prod(B,B))) )
          | ? [A8: B] : ( R3 = aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),A8)),bot_bot(set(product_prod(B,B)))) ) ) ) ) ).

% Total_subset_Id
tff(fact_2176_plus__rat_Oabs__eq,axiom,
    ! [Xa: product_prod(int,int),X: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Xa),Xa)
     => ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X),X)
       => ( aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),aa(product_prod(int,int),rat,abs_Rat,Xa)),aa(product_prod(int,int),rat,abs_Rat,X)) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),X))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),X)),aa(product_prod(int,int),int,product_snd(int,int),Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),X)))) ) ) ) ).

% plus_rat.abs_eq
tff(fact_2177_IdI,axiom,
    ! [B: $tType,A3: B] : member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),A3),id2(B)) ).

% IdI
tff(fact_2178_pair__in__Id__conv,axiom,
    ! [B: $tType,A3: B,Ba: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),id2(B))
    <=> ( A3 = Ba ) ) ).

% pair_in_Id_conv
tff(fact_2179_Linear__order__in__diff__Id,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( order_679001287576687338der_on(B,field2(B,R3),R3)
     => ( member(B,A3,field2(B,R3))
       => ( member(B,Ba,field2(B,R3))
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
          <=> ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),A3),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R3),id2(B))) ) ) ) ) ).

% Linear_order_in_diff_Id
tff(fact_2180_IdE,axiom,
    ! [B: $tType,P2: product_prod(B,B)] :
      ( member(product_prod(B,B),P2,id2(B))
     => ~ ! [X2: B] : ( P2 != aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2) ) ) ).

% IdE
tff(fact_2181_BNF__Greatest__Fixpoint_OIdD,axiom,
    ! [B: $tType,A3: B,Ba: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),id2(B))
     => ( A3 = Ba ) ) ).

% BNF_Greatest_Fixpoint.IdD
tff(fact_2182_one__rat_Orsp,axiom,
    aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int))),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int))) ).

% one_rat.rsp
tff(fact_2183_lnear__order__on__empty,axiom,
    ! [B: $tType] : order_679001287576687338der_on(B,bot_bot(set(B)),bot_bot(set(product_prod(B,B)))) ).

% lnear_order_on_empty
tff(fact_2184_zero__rat_Orsp,axiom,
    aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int))),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int))) ).

% zero_rat.rsp
tff(fact_2185_wmin__emptyI,axiom,
    ! [X6: set(product_prod(nat,nat))] : member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),X6),bot_bot(set(product_prod(nat,nat)))),fun_min_weak) ).

% wmin_emptyI
tff(fact_2186_times__rat_Oabs__eq,axiom,
    ! [Xa: product_prod(int,int),X: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Xa),Xa)
     => ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X),X)
       => ( aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),aa(product_prod(int,int),rat,abs_Rat,Xa)),aa(product_prod(int,int),rat,abs_Rat,X)) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa)),aa(product_prod(int,int),int,product_fst(int,int),X))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),X)))) ) ) ) ).

% times_rat.abs_eq
tff(fact_2187_min__weak__def,axiom,
    fun_min_weak = aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),fun(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),sup_sup(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),min_ext(product_prod(nat,nat),fun_pair_leq)),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),insert2(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bot_bot(set(product_prod(nat,nat)))),bot_bot(set(product_prod(nat,nat))))),bot_bot(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))))) ).

% min_weak_def
tff(fact_2188_max__weak__def,axiom,
    fun_max_weak = aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),fun(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),sup_sup(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),max_ext(product_prod(nat,nat),fun_pair_leq)),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),insert2(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bot_bot(set(product_prod(nat,nat)))),bot_bot(set(product_prod(nat,nat))))),bot_bot(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))))) ).

% max_weak_def
tff(fact_2189_inverse__rat_Oabs__eq,axiom,
    ! [X: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X),X)
     => ( aa(rat,rat,inverse_inverse(rat),aa(product_prod(int,int),rat,abs_Rat,X))
        = aa(product_prod(int,int),rat,abs_Rat,$ite(aa(product_prod(int,int),int,product_fst(int,int),X) = zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),X)),aa(product_prod(int,int),int,product_fst(int,int),X)))) ) ) ).

% inverse_rat.abs_eq
tff(fact_2190_min__rpair__set,axiom,
    fun_reduction_pair(set(product_prod(nat,nat)),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_prod(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),fun(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_prod(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))))),product_Pair(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),fun_min_strict),fun_min_weak)) ).

% min_rpair_set
tff(fact_2191_max__rpair__set,axiom,
    fun_reduction_pair(set(product_prod(nat,nat)),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_prod(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),aa(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),fun(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_prod(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))))),product_Pair(set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),set(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))))),fun_max_strict),fun_max_weak)) ).

% max_rpair_set
tff(fact_2192_Linear__order__wf__diff__Id,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( order_679001287576687338der_on(B,field2(B,R3),R3)
     => ( wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R3),id2(B)))
      <=> ! [A11: set(B)] :
            ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A11),field2(B,R3))
           => ( ( A11 != bot_bot(set(B)) )
             => ? [X4: B] :
                  ( member(B,X4,A11)
                  & ! [Xa2: B] :
                      ( member(B,Xa2,A11)
                     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa2),R3) ) ) ) ) ) ) ).

% Linear_order_wf_diff_Id
tff(fact_2193_zero__rat_Otransfer,axiom,
    aa(rat,$o,aa(product_prod(int,int),fun(rat,$o),pcr_rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int))),zero_zero(rat)) ).

% zero_rat.transfer
tff(fact_2194_inverse__mult__distrib,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,inverse_inverse(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),A3)),aa(B,B,inverse_inverse(B),Ba)) ) ) ).

% inverse_mult_distrib
tff(fact_2195_inverse__1,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ( aa(B,B,inverse_inverse(B),one_one(B)) = one_one(B) ) ) ).

% inverse_1
tff(fact_2196_inverse__eq__1__iff,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X: B] :
          ( ( aa(B,B,inverse_inverse(B),X) = one_one(B) )
        <=> ( X = one_one(B) ) ) ) ).

% inverse_eq_1_iff
tff(fact_2197_right__inverse,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B] :
          ( ( A3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,inverse_inverse(B),A3)) = one_one(B) ) ) ) ).

% right_inverse
tff(fact_2198_left__inverse,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B] :
          ( ( A3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),A3)),A3) = one_one(B) ) ) ) ).

% left_inverse
tff(fact_2199_inverse__eq__divide__numeral,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [W2: num] : ( aa(B,B,inverse_inverse(B),aa(num,B,numeral_numeral(B),W2)) = divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),W2)) ) ) ).

% inverse_eq_divide_numeral
tff(fact_2200_inverse__eq__divide__neg__numeral,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [W2: num] : ( aa(B,B,inverse_inverse(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) = divide_divide(B,one_one(B),aa(B,B,uminus_uminus(B),aa(num,B,numeral_numeral(B),W2))) ) ) ).

% inverse_eq_divide_neg_numeral
tff(fact_2201_mult__commute__imp__mult__inverse__commute,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Y: B,X: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),Y),X) = aa(B,B,aa(B,fun(B,B),times_times(B),X),Y) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),Y)),X) = aa(B,B,aa(B,fun(B,B),times_times(B),X),aa(B,B,inverse_inverse(B),Y)) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
tff(fact_2202_nonzero__inverse__mult__distrib,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( ( Ba != zero_zero(B) )
           => ( aa(B,B,inverse_inverse(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),Ba)),aa(B,B,inverse_inverse(B),A3)) ) ) ) ) ).

% nonzero_inverse_mult_distrib
tff(fact_2203_inverse__unique,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba) = one_one(B) )
         => ( aa(B,B,inverse_inverse(B),A3) = Ba ) ) ) ).

% inverse_unique
tff(fact_2204_wf__iff__no__infinite__down__chain,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( wf(B,R3)
    <=> ~ ? [F10: fun(nat,B)] :
          ! [I2: nat] : member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(nat,B,F10,aa(nat,nat,suc,I2))),aa(nat,B,F10,I2)),R3) ) ).

% wf_iff_no_infinite_down_chain
tff(fact_2205_wf__no__infinite__down__chainE,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Fa: fun(nat,B)] :
      ( wf(B,R3)
     => ~ ! [K2: nat] : member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(nat,B,Fa,aa(nat,nat,suc,K2))),aa(nat,B,Fa,K2)),R3) ) ).

% wf_no_infinite_down_chainE
tff(fact_2206_field__class_Ofield__divide__inverse,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B,Ba: B] : ( divide_divide(B,A3,Ba) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,inverse_inverse(B),Ba)) ) ) ).

% field_class.field_divide_inverse
tff(fact_2207_divide__inverse,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B] : ( divide_divide(B,A3,Ba) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,inverse_inverse(B),Ba)) ) ) ).

% divide_inverse
tff(fact_2208_divide__inverse__commute,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B,Ba: B] : ( divide_divide(B,A3,Ba) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),Ba)),A3) ) ) ).

% divide_inverse_commute
tff(fact_2209_inverse__eq__divide,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B] : ( aa(B,B,inverse_inverse(B),A3) = divide_divide(B,one_one(B),A3) ) ) ).

% inverse_eq_divide
tff(fact_2210_power__mult__inverse__distrib,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X: B,M4: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),M4)),aa(B,B,inverse_inverse(B),X)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),X)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),M4)) ) ) ).

% power_mult_inverse_distrib
tff(fact_2211_power__mult__power__inverse__commute,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X: B,M4: nat,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),M4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,inverse_inverse(B),X)),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,inverse_inverse(B),X)),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),M4)) ) ) ).

% power_mult_power_inverse_commute
tff(fact_2212_mult__inverse__of__nat__commute,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Xa: nat,X: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),aa(nat,B,semiring_1_of_nat(B),Xa))),X) = aa(B,B,aa(B,fun(B,B),times_times(B),X),aa(B,B,inverse_inverse(B),aa(nat,B,semiring_1_of_nat(B),Xa))) ) ) ).

% mult_inverse_of_nat_commute
tff(fact_2213_mult__inverse__of__int__commute,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Xa: int,X: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),aa(int,B,ring_1_of_int(B),Xa))),X) = aa(B,B,aa(B,fun(B,B),times_times(B),X),aa(B,B,inverse_inverse(B),aa(int,B,ring_1_of_int(B),Xa))) ) ) ).

% mult_inverse_of_int_commute
tff(fact_2214_inverse__le__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,inverse_inverse(B),X)),one_one(B))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),zero_zero(B))
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),X) ) ) ) ).

% inverse_le_1_iff
tff(fact_2215_one__less__inverse,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,inverse_inverse(B),A3)) ) ) ) ).

% one_less_inverse
tff(fact_2216_one__less__inverse__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(B,B,inverse_inverse(B),X))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),X)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),one_one(B)) ) ) ) ).

% one_less_inverse_iff
tff(fact_2217_division__ring__inverse__add,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( ( Ba != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,inverse_inverse(B),A3)),aa(B,B,inverse_inverse(B),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),A3)),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba))),aa(B,B,inverse_inverse(B),Ba)) ) ) ) ) ).

% division_ring_inverse_add
tff(fact_2218_inverse__add,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( ( Ba != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,inverse_inverse(B),A3)),aa(B,B,inverse_inverse(B),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),aa(B,B,inverse_inverse(B),A3))),aa(B,B,inverse_inverse(B),Ba)) ) ) ) ) ).

% inverse_add
tff(fact_2219_field__class_Ofield__inverse,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [A3: B] :
          ( ( A3 != zero_zero(B) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),A3)),A3) = one_one(B) ) ) ) ).

% field_class.field_inverse
tff(fact_2220_division__ring__inverse__diff,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( ( Ba != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,inverse_inverse(B),A3)),aa(B,B,inverse_inverse(B),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),A3)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Ba),A3))),aa(B,B,inverse_inverse(B),Ba)) ) ) ) ) ).

% division_ring_inverse_diff
tff(fact_2221_nonzero__inverse__eq__divide,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: B] :
          ( ( A3 != zero_zero(B) )
         => ( aa(B,B,inverse_inverse(B),A3) = divide_divide(B,one_one(B),A3) ) ) ) ).

% nonzero_inverse_eq_divide
tff(fact_2222_inverse__le__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,inverse_inverse(B),A3)),aa(B,B,inverse_inverse(B),Ba))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ) ) ).

% inverse_le_iff
tff(fact_2223_inverse__less__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,inverse_inverse(B),A3)),aa(B,B,inverse_inverse(B),Ba))
        <=> ( ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3) )
            & ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)),zero_zero(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ) ) ).

% inverse_less_iff
tff(fact_2224_one__le__inverse__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,inverse_inverse(B),X))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),X)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),one_one(B)) ) ) ) ).

% one_le_inverse_iff
tff(fact_2225_inverse__less__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,inverse_inverse(B),X)),one_one(B))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),zero_zero(B))
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),X) ) ) ) ).

% inverse_less_1_iff
tff(fact_2226_one__le__inverse,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),one_one(B))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(B,B,inverse_inverse(B),A3)) ) ) ) ).

% one_le_inverse
tff(fact_2227_wf__eq__minimal2,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( wf(B,R3)
    <=> ! [A11: set(B)] :
          ( ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A11),field2(B,R3))
            & ( A11 != bot_bot(set(B)) ) )
         => ? [X4: B] :
              ( member(B,X4,A11)
              & ! [Xa2: B] :
                  ( member(B,Xa2,A11)
                 => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa2),X4),R3) ) ) ) ) ).

% wf_eq_minimal2
tff(fact_2228_one__rat_Otransfer,axiom,
    aa(rat,$o,aa(product_prod(int,int),fun(rat,$o),pcr_rat,aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),one_one(int)),one_one(int))),one_one(rat)) ).

% one_rat.transfer
tff(fact_2229_power__diff__conv__inverse,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X: B,M4: nat,N: nat] :
          ( ( X != zero_zero(B) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
           => ( aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,inverse_inverse(B),X)),M4)) ) ) ) ) ).

% power_diff_conv_inverse
tff(fact_2230_wf__empty,axiom,
    ! [B: $tType] : wf(B,bot_bot(set(product_prod(B,B)))) ).

% wf_empty
tff(fact_2231_wf__bounded__measure,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Ub: fun(B,nat),Fa: fun(B,nat)] :
      ( ! [A8: B,B4: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B4),A8),R3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(B,nat,Ub,B4)),aa(B,nat,Ub,A8))
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(B,nat,Fa,B4)),aa(B,nat,Ub,A8))
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,Fa,A8)),aa(B,nat,Fa,B4)) ) )
     => wf(B,R3) ) ).

% wf_bounded_measure
tff(fact_2232_max__ext__additive,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),R: set(product_prod(B,B)),C3: set(B),D4: set(B)] :
      ( member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),A4),B2),max_ext(B,R))
     => ( member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),C3),D4),max_ext(B,R))
       => member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),C3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),D4)),max_ext(B,R)) ) ) ).

% max_ext_additive
tff(fact_2233_wfE__min_H,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),Qa: set(B)] :
      ( wf(B,R)
     => ( ( Qa != bot_bot(set(B)) )
       => ~ ! [Z3: B] :
              ( member(B,Z3,Qa)
             => ~ ! [Y4: B] :
                    ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),Z3),R)
                   => ~ member(B,Y4,Qa) ) ) ) ) ).

% wfE_min'
tff(fact_2234_wf__Int1,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(B,B))] :
      ( wf(B,R3)
     => wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),R4)) ) ).

% wf_Int1
tff(fact_2235_wf__Int2,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(B,B))] :
      ( wf(B,R3)
     => wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R4),R3)) ) ).

% wf_Int2
tff(fact_2236_wf__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( wf(B,R3)
    <=> ! [P3: fun(B,$o)] :
          ( ! [X4: B] :
              ( ! [Y3: B] :
                  ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y3),X4),R3)
                 => aa(B,$o,P3,Y3) )
             => aa(B,$o,P3,X4) )
         => ! [X_12: B] : aa(B,$o,P3,X_12) ) ) ).

% wf_def
tff(fact_2237_wf__induct__rule,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Pa: fun(B,$o),A3: B] :
      ( wf(B,R3)
     => ( ! [X2: B] :
            ( ! [Y4: B] :
                ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),X2),R3)
               => aa(B,$o,Pa,Y4) )
           => aa(B,$o,Pa,X2) )
       => aa(B,$o,Pa,A3) ) ) ).

% wf_induct_rule
tff(fact_2238_wf__eq__minimal,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( wf(B,R3)
    <=> ! [Q7: set(B)] :
          ( ? [X4: B] : member(B,X4,Q7)
         => ? [X4: B] :
              ( member(B,X4,Q7)
              & ! [Y3: B] :
                  ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y3),X4),R3)
                 => ~ member(B,Y3,Q7) ) ) ) ) ).

% wf_eq_minimal
tff(fact_2239_wf__not__refl,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] :
      ( wf(B,R3)
     => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),A3),R3) ) ).

% wf_not_refl
tff(fact_2240_wf__not__sym,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,X: B] :
      ( wf(B,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),X),R3)
       => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),A3),R3) ) ) ).

% wf_not_sym
tff(fact_2241_wf__irrefl,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] :
      ( wf(B,R3)
     => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),A3),R3) ) ).

% wf_irrefl
tff(fact_2242_wf__induct,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Pa: fun(B,$o),A3: B] :
      ( wf(B,R3)
     => ( ! [X2: B] :
            ( ! [Y4: B] :
                ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),X2),R3)
               => aa(B,$o,Pa,Y4) )
           => aa(B,$o,Pa,X2) )
       => aa(B,$o,Pa,A3) ) ) ).

% wf_induct
tff(fact_2243_wf__asym,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,X: B] :
      ( wf(B,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),X),R3)
       => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),A3),R3) ) ) ).

% wf_asym
tff(fact_2244_wfUNIVI,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ! [P4: fun(B,$o),X2: B] :
          ( ! [Xa3: B] :
              ( ! [Y2: B] :
                  ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Xa3),R3)
                 => aa(B,$o,P4,Y2) )
             => aa(B,$o,P4,Xa3) )
         => aa(B,$o,P4,X2) )
     => wf(B,R3) ) ).

% wfUNIVI
tff(fact_2245_wfI__min,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ! [X2: B,Q3: set(B)] :
          ( member(B,X2,Q3)
         => ? [Xa3: B] :
              ( member(B,Xa3,Q3)
              & ! [Y2: B] :
                  ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Xa3),R)
                 => ~ member(B,Y2,Q3) ) ) )
     => wf(B,R) ) ).

% wfI_min
tff(fact_2246_wfE__min,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),X: B,Qa: set(B)] :
      ( wf(B,R)
     => ( member(B,X,Qa)
       => ~ ! [Z3: B] :
              ( member(B,Z3,Qa)
             => ~ ! [Y4: B] :
                    ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),Z3),R)
                   => ~ member(B,Y4,Qa) ) ) ) ) ).

% wfE_min
tff(fact_2247_in__measure,axiom,
    ! [B: $tType,X: B,Y: B,Fa: fun(B,nat)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),measure(B,Fa))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,Fa,X)),aa(B,nat,Fa,Y)) ) ).

% in_measure
tff(fact_2248_in__lex__prod,axiom,
    ! [B: $tType,C: $tType,A3: B,Ba: C,A5: B,B3: C,R3: set(product_prod(B,B)),S: set(product_prod(C,C))] :
      ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A5),B3)),lex_prod(B,C,R3,S))
    <=> ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),A5),R3)
        | ( ( A3 = A5 )
          & member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Ba),B3),S) ) ) ) ).

% in_lex_prod
tff(fact_2249_dependent__wf__choice,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,B)),Pa: fun(fun(B,C),fun(B,fun(C,$o)))] :
      ( wf(B,R)
     => ( ! [F8: fun(B,C),G2: fun(B,C),X2: B,R2: C] :
            ( ! [Z5: B] :
                ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z5),X2),R)
               => ( aa(B,C,F8,Z5) = aa(B,C,G2,Z5) ) )
           => ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,C),fun(B,fun(C,$o)),Pa,F8),X2),R2)
            <=> aa(C,$o,aa(B,fun(C,$o),aa(fun(B,C),fun(B,fun(C,$o)),Pa,G2),X2),R2) ) )
       => ( ! [X2: B,F8: fun(B,C)] :
              ( ! [Y4: B] :
                  ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),X2),R)
                 => aa(C,$o,aa(B,fun(C,$o),aa(fun(B,C),fun(B,fun(C,$o)),Pa,F8),Y4),aa(B,C,F8,Y4)) )
             => ? [X_13: C] : aa(C,$o,aa(B,fun(C,$o),aa(fun(B,C),fun(B,fun(C,$o)),Pa,F8),X2),X_13) )
         => ? [F8: fun(B,C)] :
            ! [X3: B] : aa(C,$o,aa(B,fun(C,$o),aa(fun(B,C),fun(B,fun(C,$o)),Pa,F8),X3),aa(B,C,F8,X3)) ) ) ) ).

% dependent_wf_choice
tff(fact_2250_wo__rel_Ocases__Total3,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B,Phi: fun(B,fun(B,$o))] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))),field2(B,R3))
       => ( ( ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R3),id2(B)))
              | member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),A3),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R3),id2(B))) )
           => aa(B,$o,aa(B,fun(B,$o),Phi,A3),Ba) )
         => ( ( ( A3 = Ba )
             => aa(B,$o,aa(B,fun(B,$o),Phi,A3),Ba) )
           => aa(B,$o,aa(B,fun(B,$o),Phi,A3),Ba) ) ) ) ) ).

% wo_rel.cases_Total3
tff(fact_2251_of__rat__neg__one,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ( aa(rat,B,field_char_0_of_rat(B),aa(rat,rat,uminus_uminus(rat),one_one(rat))) = aa(B,B,uminus_uminus(B),one_one(B)) ) ) ).

% of_rat_neg_one
tff(fact_2252_numeral__num__of__nat__unfold,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat] :
          ( aa(num,B,numeral_numeral(B),aa(nat,num,num_of_nat,N))
          = $ite(N = zero_zero(nat),one_one(B),aa(nat,B,semiring_1_of_nat(B),N)) ) ) ).

% numeral_num_of_nat_unfold
tff(fact_2253_of__rat__1,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ( aa(rat,B,field_char_0_of_rat(B),one_one(rat)) = one_one(B) ) ) ).

% of_rat_1
tff(fact_2254_of__rat__eq__1__iff,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: rat] :
          ( ( aa(rat,B,field_char_0_of_rat(B),A3) = one_one(B) )
        <=> ( A3 = one_one(rat) ) ) ) ).

% of_rat_eq_1_iff
tff(fact_2255_one__eq__of__rat__iff,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: rat] :
          ( ( one_one(B) = aa(rat,B,field_char_0_of_rat(B),A3) )
        <=> ( one_one(rat) = A3 ) ) ) ).

% one_eq_of_rat_iff
tff(fact_2256_of__rat__le__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [R3: rat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(rat,B,field_char_0_of_rat(B),R3)),one_one(B))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),R3),one_one(rat)) ) ) ).

% of_rat_le_1_iff
tff(fact_2257_one__le__of__rat__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [R3: rat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(rat,B,field_char_0_of_rat(B),R3))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),one_one(rat)),R3) ) ) ).

% one_le_of_rat_iff
tff(fact_2258_of__rat__less__1__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [R3: rat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(rat,B,field_char_0_of_rat(B),R3)),one_one(B))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R3),one_one(rat)) ) ) ).

% of_rat_less_1_iff
tff(fact_2259_one__less__of__rat__iff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [R3: rat] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(rat,B,field_char_0_of_rat(B),R3))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),one_one(rat)),R3) ) ) ).

% one_less_of_rat_iff
tff(fact_2260_wo__rel_Owell__order__induct,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Pa: fun(B,$o),A3: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( ! [X2: B] :
            ( ! [Y4: B] :
                ( ( ( Y4 != X2 )
                  & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),X2),R3) )
               => aa(B,$o,Pa,Y4) )
           => aa(B,$o,Pa,X2) )
       => aa(B,$o,Pa,A3) ) ) ).

% wo_rel.well_order_induct
tff(fact_2261_wo__rel_OTOTALS,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ! [X3: B] :
          ( member(B,X3,field2(B,R3))
         => ! [Xa3: B] :
              ( member(B,Xa3,field2(B,R3))
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa3),R3)
                | member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa3),X3),R3) ) ) ) ) ).

% wo_rel.TOTALS
tff(fact_2262_well__order__induct__imp,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Pa: fun(B,$o),A3: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( ! [X2: B] :
            ( ! [Y4: B] :
                ( ( ( Y4 != X2 )
                  & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),X2),R3) )
               => ( member(B,Y4,field2(B,R3))
                 => aa(B,$o,Pa,Y4) ) )
           => ( member(B,X2,field2(B,R3))
             => aa(B,$o,Pa,X2) ) )
       => ( member(B,A3,field2(B,R3))
         => aa(B,$o,Pa,A3) ) ) ) ).

% well_order_induct_imp
tff(fact_2263_of__rat__mult,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: rat,Ba: rat] : ( aa(rat,B,field_char_0_of_rat(B),aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(rat,B,field_char_0_of_rat(B),A3)),aa(rat,B,field_char_0_of_rat(B),Ba)) ) ) ).

% of_rat_mult
tff(fact_2264_wo__rel_Ocases__Total,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B,Phi: fun(B,fun(B,$o))] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))),field2(B,R3))
       => ( ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
           => aa(B,$o,aa(B,fun(B,$o),Phi,A3),Ba) )
         => ( ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),A3),R3)
             => aa(B,$o,aa(B,fun(B,$o),Phi,A3),Ba) )
           => aa(B,$o,aa(B,fun(B,$o),Phi,A3),Ba) ) ) ) ) ).

% wo_rel.cases_Total
tff(fact_2265_wo__rel_OWell__order__isMinim__exists,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
       => ( ( B2 != bot_bot(set(B)) )
         => ? [X_1: B] : bNF_We4791949203932849705sMinim(B,R3,B2,X_1) ) ) ) ).

% wo_rel.Well_order_isMinim_exists
tff(fact_2266_wo__rel_Ominim__in,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
       => ( ( B2 != bot_bot(set(B)) )
         => member(B,bNF_We6954850376910717587_minim(B,R3,B2),B2) ) ) ) ).

% wo_rel.minim_in
tff(fact_2267_wo__rel_Ominim__inField,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
       => ( ( B2 != bot_bot(set(B)) )
         => member(B,bNF_We6954850376910717587_minim(B,R3,B2),field2(B,R3)) ) ) ) ).

% wo_rel.minim_inField
tff(fact_2268_wo__rel_Oequals__minim,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),B2: set(B),A3: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
       => ( member(B,A3,B2)
         => ( ! [B4: B] :
                ( member(B,B4,B2)
               => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),B4),R3) )
           => ( A3 = bNF_We6954850376910717587_minim(B,R3,B2) ) ) ) ) ) ).

% wo_rel.equals_minim
tff(fact_2269_wo__rel_Ominim__least,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),B2: set(B),Ba: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
       => ( member(B,Ba,B2)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),bNF_We6954850376910717587_minim(B,R3,B2)),Ba),R3) ) ) ) ).

% wo_rel.minim_least
tff(fact_2270_wo__rel_Omax2__greater__among,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( member(B,A3,field2(B,R3))
       => ( member(B,Ba,field2(B,R3))
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),bNF_We1388413361240627857o_max2(B,R3,A3,Ba)),R3)
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),bNF_We1388413361240627857o_max2(B,R3,A3,Ba)),R3)
            & member(B,bNF_We1388413361240627857o_max2(B,R3,A3,Ba),aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))) ) ) ) ) ).

% wo_rel.max2_greater_among
tff(fact_2271_wo__rel_Omax2__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( bNF_We1388413361240627857o_max2(B,R3,A3,Ba)
        = $ite(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3),Ba,A3) ) ) ).

% wo_rel.max2_def
tff(fact_2272_wo__rel_Ominim__isMinim,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
       => ( ( B2 != bot_bot(set(B)) )
         => bNF_We4791949203932849705sMinim(B,R3,B2,bNF_We6954850376910717587_minim(B,R3,B2)) ) ) ) ).

% wo_rel.minim_isMinim
tff(fact_2273_wo__rel_OisMinim__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),Ba: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( bNF_We4791949203932849705sMinim(B,R3,A4,Ba)
      <=> ( member(B,Ba,A4)
          & ! [X4: B] :
              ( member(B,X4,A4)
             => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),X4),R3) ) ) ) ) ).

% wo_rel.isMinim_def
tff(fact_2274_wo__rel_Omax2__equals1,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( member(B,A3,field2(B,R3))
       => ( member(B,Ba,field2(B,R3))
         => ( ( bNF_We1388413361240627857o_max2(B,R3,A3,Ba) = A3 )
          <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),A3),R3) ) ) ) ) ).

% wo_rel.max2_equals1
tff(fact_2275_wo__rel_Omax2__equals2,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( member(B,A3,field2(B,R3))
       => ( member(B,Ba,field2(B,R3))
         => ( ( bNF_We1388413361240627857o_max2(B,R3,A3,Ba) = Ba )
          <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3) ) ) ) ) ).

% wo_rel.max2_equals2
tff(fact_2276_wo__rel_Omax2__greater,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( member(B,A3,field2(B,R3))
       => ( member(B,Ba,field2(B,R3))
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),bNF_We1388413361240627857o_max2(B,R3,A3,Ba)),R3)
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),bNF_We1388413361240627857o_max2(B,R3,A3,Ba)),R3) ) ) ) ) ).

% wo_rel.max2_greater
tff(fact_2277_wo__rel_Omax2__among,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( member(B,A3,field2(B,R3))
       => ( member(B,Ba,field2(B,R3))
         => member(B,bNF_We1388413361240627857o_max2(B,R3,A3,Ba),aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))) ) ) ) ).

% wo_rel.max2_among
tff(fact_2278_simp__from__to,axiom,
    ! [I: int,J2: int] :
      ( set_or1337092689740270186AtMost(int,I,J2)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),J2),I),bot_bot(set(int)),aa(set(int),set(int),insert2(int,I),set_or1337092689740270186AtMost(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J2))) ) ).

% simp_from_to
tff(fact_2279_image__mult__atLeastAtMost__if,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,X: B,Y: B] :
          ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),C2)),set_or1337092689740270186AtMost(B,X,Y))
          = $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),
              set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),X),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Y)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),Y),aa(B,B,aa(B,fun(B,B),times_times(B),C2),X)),bot_bot(set(B))) ) ) ) ).

% image_mult_atLeastAtMost_if
tff(fact_2280_one__int_Otransfer,axiom,
    aa(int,$o,aa(product_prod(nat,nat),fun(int,$o),pcr_int,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),one_one(nat)),zero_zero(nat))),one_one(int)) ).

% one_int.transfer
tff(fact_2281_less__than__iff,axiom,
    ! [X: nat,Y: nat] :
      ( member(product_prod(nat,nat),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Y),less_than)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),Y) ) ).

% less_than_iff
tff(fact_2282_card__Un__disjoint,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( aa(set(B),$o,finite_finite(B),B2)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) )
         => ( finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(B,A4)),finite_card(B,B2)) ) ) ) ) ).

% card_Un_disjoint
tff(fact_2283_reduction__pairI,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),S2: set(product_prod(B,B))] :
      ( wf(B,R)
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),relcomp(B,B,B,R,S2)),R)
       => fun_reduction_pair(B,aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R),S2)) ) ) ).

% reduction_pairI
tff(fact_2284_finite__Int,axiom,
    ! [B: $tType,F: set(B),G5: set(B)] :
      ( ( aa(set(B),$o,finite_finite(B),F)
        | aa(set(B),$o,finite_finite(B),G5) )
     => aa(set(B),$o,finite_finite(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),F),G5)) ) ).

% finite_Int
tff(fact_2285_relcomp__empty1,axiom,
    ! [D: $tType,C: $tType,B: $tType,R: set(product_prod(D,C))] : ( relcomp(B,D,C,bot_bot(set(product_prod(B,D))),R) = bot_bot(set(product_prod(B,C))) ) ).

% relcomp_empty1
tff(fact_2286_relcomp__empty2,axiom,
    ! [D: $tType,C: $tType,B: $tType,R: set(product_prod(B,D))] : ( relcomp(B,D,C,R,bot_bot(set(product_prod(D,C)))) = bot_bot(set(product_prod(B,C))) ) ).

% relcomp_empty2
tff(fact_2287_atLeastatMost__empty__iff,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B] :
          ( ( set_or1337092689740270186AtMost(B,A3,Ba) = bot_bot(set(B)) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% atLeastatMost_empty_iff
tff(fact_2288_atLeastatMost__empty__iff2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B] :
          ( ( bot_bot(set(B)) = set_or1337092689740270186AtMost(B,A3,Ba) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba) ) ) ).

% atLeastatMost_empty_iff2
tff(fact_2289_atLeastatMost__empty,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( set_or1337092689740270186AtMost(B,A3,Ba) = bot_bot(set(B)) ) ) ) ).

% atLeastatMost_empty
tff(fact_2290_atLeastAtMost__singleton,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B] : ( set_or1337092689740270186AtMost(B,A3,A3) = aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))) ) ) ).

% atLeastAtMost_singleton
tff(fact_2291_atLeastAtMost__singleton__iff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( set_or1337092689740270186AtMost(B,A3,Ba) = aa(set(B),set(B),insert2(B,C2),bot_bot(set(B))) )
        <=> ( ( A3 = Ba )
            & ( Ba = C2 ) ) ) ) ).

% atLeastAtMost_singleton_iff
tff(fact_2292_card__0__eq,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( ( finite_card(B,A4) = zero_zero(nat) )
      <=> ( A4 = bot_bot(set(B)) ) ) ) ).

% card_0_eq
tff(fact_2293_image__mult__atLeastAtMost,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [D2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),D2)
         => ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),D2)),set_or1337092689740270186AtMost(B,A3,Ba)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),times_times(B),D2),A3),aa(B,B,aa(B,fun(B,B),times_times(B),D2),Ba)) ) ) ) ).

% image_mult_atLeastAtMost
tff(fact_2294_relcompEpair,axiom,
    ! [B: $tType,C: $tType,D: $tType,A3: B,C2: C,R3: set(product_prod(B,D)),S: set(product_prod(D,C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),C2),relcomp(B,D,C,R3,S))
     => ~ ! [B4: D] :
            ( member(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),A3),B4),R3)
           => ~ member(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),B4),C2),S) ) ) ).

% relcompEpair
tff(fact_2295_relcompE,axiom,
    ! [B: $tType,C: $tType,D: $tType,Xz: product_prod(B,C),R3: set(product_prod(B,D)),S: set(product_prod(D,C))] :
      ( member(product_prod(B,C),Xz,relcomp(B,D,C,R3,S))
     => ~ ! [X2: B,Y2: D,Z3: C] :
            ( ( Xz = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Z3) )
           => ( member(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),X2),Y2),R3)
             => ~ member(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),Y2),Z3),S) ) ) ) ).

% relcompE
tff(fact_2296_relcomp_OrelcompI,axiom,
    ! [B: $tType,D: $tType,C: $tType,A3: B,Ba: C,R3: set(product_prod(B,C)),C2: D,S: set(product_prod(C,D))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),R3)
     => ( member(product_prod(C,D),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),Ba),C2),S)
       => member(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),A3),C2),relcomp(B,C,D,R3,S)) ) ) ).

% relcomp.relcompI
tff(fact_2297_relcomp_Osimps,axiom,
    ! [B: $tType,C: $tType,D: $tType,A1: B,A22: C,R3: set(product_prod(B,D)),S: set(product_prod(D,C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A1),A22),relcomp(B,D,C,R3,S))
    <=> ? [A6: B,B5: D,C5: C] :
          ( ( A1 = A6 )
          & ( A22 = C5 )
          & member(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),A6),B5),R3)
          & member(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),B5),C5),S) ) ) ).

% relcomp.simps
tff(fact_2298_relcomp_Ocases,axiom,
    ! [B: $tType,C: $tType,D: $tType,A1: B,A22: C,R3: set(product_prod(B,D)),S: set(product_prod(D,C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A1),A22),relcomp(B,D,C,R3,S))
     => ~ ! [B4: D] :
            ( member(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),A1),B4),R3)
           => ~ member(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),B4),A22),S) ) ) ).

% relcomp.cases
tff(fact_2299_finite_OemptyI,axiom,
    ! [B: $tType] : aa(set(B),$o,finite_finite(B),bot_bot(set(B))) ).

% finite.emptyI
tff(fact_2300_infinite__imp__nonempty,axiom,
    ! [B: $tType,S2: set(B)] :
      ( ~ aa(set(B),$o,finite_finite(B),S2)
     => ( S2 != bot_bot(set(B)) ) ) ).

% infinite_imp_nonempty
tff(fact_2301_atLeastAtMost__singleton_H,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = Ba )
         => ( set_or1337092689740270186AtMost(B,A3,Ba) = aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))) ) ) ) ).

% atLeastAtMost_singleton'
tff(fact_2302_finite__has__maximal,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ? [X2: B] :
                ( member(B,X2,A4)
                & ! [Xa3: B] :
                    ( member(B,Xa3,A4)
                   => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Xa3)
                     => ( X2 = Xa3 ) ) ) ) ) ) ) ).

% finite_has_maximal
tff(fact_2303_finite__has__minimal,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ? [X2: B] :
                ( member(B,X2,A4)
                & ! [Xa3: B] :
                    ( member(B,Xa3,A4)
                   => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Xa3),X2)
                     => ( X2 = Xa3 ) ) ) ) ) ) ) ).

% finite_has_minimal
tff(fact_2304_wf__no__loop,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ( relcomp(B,B,B,R,R) = bot_bot(set(product_prod(B,B))) )
     => wf(B,R) ) ).

% wf_no_loop
tff(fact_2305_finite_Ocases,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A3)
     => ( ( A3 != bot_bot(set(B)) )
       => ~ ! [A12: set(B)] :
              ( ? [A8: B] : ( A3 = aa(set(B),set(B),insert2(B,A8),A12) )
             => ~ aa(set(B),$o,finite_finite(B),A12) ) ) ) ).

% finite.cases
tff(fact_2306_finite_Osimps,axiom,
    ! [B: $tType,A3: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A3)
    <=> ( ( A3 = bot_bot(set(B)) )
        | ? [A11: set(B),A6: B] :
            ( ( A3 = aa(set(B),set(B),insert2(B,A6),A11) )
            & aa(set(B),$o,finite_finite(B),A11) ) ) ) ).

% finite.simps
tff(fact_2307_finite__induct,axiom,
    ! [B: $tType,F: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite(B),F)
     => ( aa(set(B),$o,Pa,bot_bot(set(B)))
       => ( ! [X2: B,F5: set(B)] :
              ( aa(set(B),$o,finite_finite(B),F5)
             => ( ~ member(B,X2,F5)
               => ( aa(set(B),$o,Pa,F5)
                 => aa(set(B),$o,Pa,aa(set(B),set(B),insert2(B,X2),F5)) ) ) )
         => aa(set(B),$o,Pa,F) ) ) ) ).

% finite_induct
tff(fact_2308_finite__ne__induct,axiom,
    ! [B: $tType,F: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite(B),F)
     => ( ( F != bot_bot(set(B)) )
       => ( ! [X2: B] : aa(set(B),$o,Pa,aa(set(B),set(B),insert2(B,X2),bot_bot(set(B))))
         => ( ! [X2: B,F5: set(B)] :
                ( aa(set(B),$o,finite_finite(B),F5)
               => ( ( F5 != bot_bot(set(B)) )
                 => ( ~ member(B,X2,F5)
                   => ( aa(set(B),$o,Pa,F5)
                     => aa(set(B),$o,Pa,aa(set(B),set(B),insert2(B,X2),F5)) ) ) ) )
           => aa(set(B),$o,Pa,F) ) ) ) ) ).

% finite_ne_induct
tff(fact_2309_infinite__finite__induct,axiom,
    ! [B: $tType,Pa: fun(set(B),$o),A4: set(B)] :
      ( ! [A12: set(B)] :
          ( ~ aa(set(B),$o,finite_finite(B),A12)
         => aa(set(B),$o,Pa,A12) )
     => ( aa(set(B),$o,Pa,bot_bot(set(B)))
       => ( ! [X2: B,F5: set(B)] :
              ( aa(set(B),$o,finite_finite(B),F5)
             => ( ~ member(B,X2,F5)
               => ( aa(set(B),$o,Pa,F5)
                 => aa(set(B),$o,Pa,aa(set(B),set(B),insert2(B,X2),F5)) ) ) )
         => aa(set(B),$o,Pa,A4) ) ) ) ).

% infinite_finite_induct
tff(fact_2310_union__comp__emptyL,axiom,
    ! [B: $tType,A4: set(product_prod(B,B)),C3: set(product_prod(B,B)),B2: set(product_prod(B,B))] :
      ( ( relcomp(B,B,B,A4,C3) = bot_bot(set(product_prod(B,B))) )
     => ( ( relcomp(B,B,B,B2,C3) = bot_bot(set(product_prod(B,B))) )
       => ( relcomp(B,B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),A4),B2),C3) = bot_bot(set(product_prod(B,B))) ) ) ) ).

% union_comp_emptyL
tff(fact_2311_union__comp__emptyR,axiom,
    ! [B: $tType,A4: set(product_prod(B,B)),B2: set(product_prod(B,B)),C3: set(product_prod(B,B))] :
      ( ( relcomp(B,B,B,A4,B2) = bot_bot(set(product_prod(B,B))) )
     => ( ( relcomp(B,B,B,A4,C3) = bot_bot(set(product_prod(B,B))) )
       => ( relcomp(B,B,B,A4,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),B2),C3)) = bot_bot(set(product_prod(B,B))) ) ) ) ).

% union_comp_emptyR
tff(fact_2312_Gcd__remove0__nat,axiom,
    ! [M: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),M)
     => ( gcd_Gcd(nat,M) = gcd_Gcd(nat,aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),M),aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat))))) ) ) ).

% Gcd_remove0_nat
tff(fact_2313_atLeastAtMost__eq__UNIV__iff,axiom,
    ! [B: $tType] :
      ( bounded_lattice(B)
     => ! [X: B,Y: B] :
          ( ( set_or1337092689740270186AtMost(B,X,Y) = top_top(set(B)) )
        <=> ( ( X = bot_bot(B) )
            & ( Y = top_top(B) ) ) ) ) ).

% atLeastAtMost_eq_UNIV_iff
tff(fact_2314_finite__subset__induct,axiom,
    ! [B: $tType,F: set(B),A4: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite(B),F)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),F),A4)
       => ( aa(set(B),$o,Pa,bot_bot(set(B)))
         => ( ! [A8: B,F5: set(B)] :
                ( aa(set(B),$o,finite_finite(B),F5)
               => ( member(B,A8,A4)
                 => ( ~ member(B,A8,F5)
                   => ( aa(set(B),$o,Pa,F5)
                     => aa(set(B),$o,Pa,aa(set(B),set(B),insert2(B,A8),F5)) ) ) ) )
           => aa(set(B),$o,Pa,F) ) ) ) ) ).

% finite_subset_induct
tff(fact_2315_finite__subset__induct_H,axiom,
    ! [B: $tType,F: set(B),A4: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite(B),F)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),F),A4)
       => ( aa(set(B),$o,Pa,bot_bot(set(B)))
         => ( ! [A8: B,F5: set(B)] :
                ( aa(set(B),$o,finite_finite(B),F5)
               => ( member(B,A8,A4)
                 => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),F5),A4)
                   => ( ~ member(B,A8,F5)
                     => ( aa(set(B),$o,Pa,F5)
                       => aa(set(B),$o,Pa,aa(set(B),set(B),insert2(B,A8),F5)) ) ) ) ) )
           => aa(set(B),$o,Pa,F) ) ) ) ) ).

% finite_subset_induct'
tff(fact_2316_infinite__remove,axiom,
    ! [B: $tType,S2: set(B),A3: B] :
      ( ~ aa(set(B),$o,finite_finite(B),S2)
     => ~ aa(set(B),$o,finite_finite(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) ) ).

% infinite_remove
tff(fact_2317_infinite__coinduct,axiom,
    ! [B: $tType,X6: fun(set(B),$o),A4: set(B)] :
      ( aa(set(B),$o,X6,A4)
     => ( ! [A12: set(B)] :
            ( aa(set(B),$o,X6,A12)
           => ? [X3: B] :
                ( member(B,X3,A12)
                & ( aa(set(B),$o,X6,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A12),aa(set(B),set(B),insert2(B,X3),bot_bot(set(B)))))
                  | ~ aa(set(B),$o,finite_finite(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A12),aa(set(B),set(B),insert2(B,X3),bot_bot(set(B))))) ) ) )
       => ~ aa(set(B),$o,finite_finite(B),A4) ) ) ).

% infinite_coinduct
tff(fact_2318_finite__empty__induct,axiom,
    ! [B: $tType,A4: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( aa(set(B),$o,Pa,A4)
       => ( ! [A8: B,A12: set(B)] :
              ( aa(set(B),$o,finite_finite(B),A12)
             => ( member(B,A8,A12)
               => ( aa(set(B),$o,Pa,A12)
                 => aa(set(B),$o,Pa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A12),aa(set(B),set(B),insert2(B,A8),bot_bot(set(B))))) ) ) )
         => aa(set(B),$o,Pa,bot_bot(set(B))) ) ) ) ).

% finite_empty_induct
tff(fact_2319_card__eq__0__iff,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ( finite_card(B,A4) = zero_zero(nat) )
    <=> ( ( A4 = bot_bot(set(B)) )
        | ~ aa(set(B),$o,finite_finite(B),A4) ) ) ).

% card_eq_0_iff
tff(fact_2320_finite__range__prod,axiom,
    ! [B: $tType,D: $tType,C: $tType,Fa: fun(C,product_prod(B,D))] :
      ( aa(set(B),$o,finite_finite(B),aa(set(C),set(B),image2(C,B,aa(fun(C,product_prod(B,D)),fun(C,B),aa(fun(product_prod(B,D),B),fun(fun(C,product_prod(B,D)),fun(C,B)),comp(product_prod(B,D),B,C),product_fst(B,D)),Fa)),top_top(set(C))))
     => ( aa(set(D),$o,finite_finite(D),aa(set(C),set(D),image2(C,D,aa(fun(C,product_prod(B,D)),fun(C,D),aa(fun(product_prod(B,D),D),fun(fun(C,product_prod(B,D)),fun(C,D)),comp(product_prod(B,D),D,C),product_snd(B,D)),Fa)),top_top(set(C))))
       => aa(set(product_prod(B,D)),$o,finite_finite(product_prod(B,D)),aa(set(C),set(product_prod(B,D)),image2(C,product_prod(B,D),Fa),top_top(set(C)))) ) ) ).

% finite_range_prod
tff(fact_2321_zero__int_Otransfer,axiom,
    aa(int,$o,aa(product_prod(nat,nat),fun(int,$o),pcr_int,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),zero_zero(nat))),zero_zero(int)) ).

% zero_int.transfer
tff(fact_2322_max__ext__compat,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),S2: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),relcomp(B,B,B,R,S2)),R)
     => aa(set(product_prod(set(B),set(B))),$o,aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(B),set(B))),$o),ord_less_eq(set(product_prod(set(B),set(B)))),relcomp(set(B),set(B),set(B),max_ext(B,R),aa(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B)))),sup_sup(set(product_prod(set(B),set(B)))),max_ext(B,S2)),aa(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B))),insert2(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),bot_bot(set(B))),bot_bot(set(B)))),bot_bot(set(product_prod(set(B),set(B)))))))),max_ext(B,R)) ) ).

% max_ext_compat
tff(fact_2323_finite__remove__induct,axiom,
    ! [B: $tType,B2: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite(B),B2)
     => ( aa(set(B),$o,Pa,bot_bot(set(B)))
       => ( ! [A12: set(B)] :
              ( aa(set(B),$o,finite_finite(B),A12)
             => ( ( A12 != bot_bot(set(B)) )
               => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A12),B2)
                 => ( ! [X3: B] :
                        ( member(B,X3,A12)
                       => aa(set(B),$o,Pa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A12),aa(set(B),set(B),insert2(B,X3),bot_bot(set(B))))) )
                   => aa(set(B),$o,Pa,A12) ) ) ) )
         => aa(set(B),$o,Pa,B2) ) ) ) ).

% finite_remove_induct
tff(fact_2324_remove__induct,axiom,
    ! [B: $tType,Pa: fun(set(B),$o),B2: set(B)] :
      ( aa(set(B),$o,Pa,bot_bot(set(B)))
     => ( ( ~ aa(set(B),$o,finite_finite(B),B2)
         => aa(set(B),$o,Pa,B2) )
       => ( ! [A12: set(B)] :
              ( aa(set(B),$o,finite_finite(B),A12)
             => ( ( A12 != bot_bot(set(B)) )
               => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A12),B2)
                 => ( ! [X3: B] :
                        ( member(B,X3,A12)
                       => aa(set(B),$o,Pa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A12),aa(set(B),set(B),insert2(B,X3),bot_bot(set(B))))) )
                   => aa(set(B),$o,Pa,A12) ) ) ) )
         => aa(set(B),$o,Pa,B2) ) ) ) ).

% remove_induct
tff(fact_2325_card__gt__0__iff,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),finite_card(B,A4))
    <=> ( ( A4 != bot_bot(set(B)) )
        & aa(set(B),$o,finite_finite(B),A4) ) ) ).

% card_gt_0_iff
tff(fact_2326_min__ext__compat,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),S2: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),relcomp(B,B,B,R,S2)),R)
     => aa(set(product_prod(set(B),set(B))),$o,aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(B),set(B))),$o),ord_less_eq(set(product_prod(set(B),set(B)))),relcomp(set(B),set(B),set(B),min_ext(B,R),aa(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B)))),sup_sup(set(product_prod(set(B),set(B)))),min_ext(B,S2)),aa(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B))),insert2(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),bot_bot(set(B))),bot_bot(set(B)))),bot_bot(set(product_prod(set(B),set(B)))))))),min_ext(B,R)) ) ).

% min_ext_compat
tff(fact_2327_card__1__singletonI,axiom,
    ! [B: $tType,S2: set(B),X: B] :
      ( aa(set(B),$o,finite_finite(B),S2)
     => ( ( finite_card(B,S2) = one_one(nat) )
       => ( member(B,X,S2)
         => ( S2 = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) ) ) ) ).

% card_1_singletonI
tff(fact_2328_finite__induct__select,axiom,
    ! [B: $tType,S2: set(B),Pa: fun(set(B),$o)] :
      ( aa(set(B),$o,finite_finite(B),S2)
     => ( aa(set(B),$o,Pa,bot_bot(set(B)))
       => ( ! [T5: set(B)] :
              ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),T5),S2)
             => ( aa(set(B),$o,Pa,T5)
               => ? [X3: B] :
                    ( member(B,X3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),T5))
                    & aa(set(B),$o,Pa,aa(set(B),set(B),insert2(B,X3),T5)) ) ) )
         => aa(set(B),$o,Pa,S2) ) ) ) ).

% finite_induct_select
tff(fact_2329_card__Un__Int,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( aa(set(B),$o,finite_finite(B),B2)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(B,A4)),finite_card(B,B2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ) ) ).

% card_Un_Int
tff(fact_2330_wf__bounded__set,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),Ub: fun(B,set(C)),Fa: fun(B,set(C))] :
      ( ! [A8: B,B4: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B4),A8),R3)
         => ( aa(set(C),$o,finite_finite(C),aa(B,set(C),Ub,A8))
            & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),Ub,B4)),aa(B,set(C),Ub,A8))
            & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),Fa,B4)),aa(B,set(C),Ub,A8))
            & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less(set(C)),aa(B,set(C),Fa,A8)),aa(B,set(C),Fa,B4)) ) )
     => wf(B,R3) ) ).

% wf_bounded_set
tff(fact_2331_smax__emptyI,axiom,
    ! [Y5: set(product_prod(nat,nat))] :
      ( aa(set(product_prod(nat,nat)),$o,finite_finite(product_prod(nat,nat)),Y5)
     => ( ( Y5 != bot_bot(set(product_prod(nat,nat))) )
       => member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bot_bot(set(product_prod(nat,nat)))),Y5),fun_max_strict) ) ) ).

% smax_emptyI
tff(fact_2332_card__Diff__subset__Int,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,finite_finite(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))
     => ( finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(B,A4)),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ) ).

% card_Diff_subset_Int
tff(fact_2333_max__ext_Ocases,axiom,
    ! [B: $tType,A1: set(B),A22: set(B),R: set(product_prod(B,B))] :
      ( member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),A1),A22),max_ext(B,R))
     => ~ ( aa(set(B),$o,finite_finite(B),A1)
         => ( aa(set(B),$o,finite_finite(B),A22)
           => ( ( A22 != bot_bot(set(B)) )
             => ~ ! [X3: B] :
                    ( member(B,X3,A1)
                   => ? [Xa4: B] :
                        ( member(B,Xa4,A22)
                        & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa4),R) ) ) ) ) ) ) ).

% max_ext.cases
tff(fact_2334_max__ext_Osimps,axiom,
    ! [B: $tType,A1: set(B),A22: set(B),R: set(product_prod(B,B))] :
      ( member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),A1),A22),max_ext(B,R))
    <=> ( aa(set(B),$o,finite_finite(B),A1)
        & aa(set(B),$o,finite_finite(B),A22)
        & ( A22 != bot_bot(set(B)) )
        & ! [X4: B] :
            ( member(B,X4,A1)
           => ? [Xa2: B] :
                ( member(B,Xa2,A22)
                & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa2),R) ) ) ) ) ).

% max_ext.simps
tff(fact_2335_max__ext_Omax__extI,axiom,
    ! [B: $tType,X6: set(B),Y5: set(B),R: set(product_prod(B,B))] :
      ( aa(set(B),$o,finite_finite(B),X6)
     => ( aa(set(B),$o,finite_finite(B),Y5)
       => ( ( Y5 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,X6)
               => ? [Xa3: B] :
                    ( member(B,Xa3,Y5)
                    & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Xa3),R) ) )
           => member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),X6),Y5),max_ext(B,R)) ) ) ) ) ).

% max_ext.max_extI
tff(fact_2336_wmax__emptyI,axiom,
    ! [X6: set(product_prod(nat,nat))] :
      ( aa(set(product_prod(nat,nat)),$o,finite_finite(product_prod(nat,nat)),X6)
     => member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bot_bot(set(product_prod(nat,nat)))),X6),fun_max_weak) ) ).

% wmax_emptyI
tff(fact_2337_card__Suc__Diff1,axiom,
    ! [B: $tType,A4: set(B),X: B] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( member(B,X,A4)
       => ( aa(nat,nat,suc,finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) = finite_card(B,A4) ) ) ) ).

% card_Suc_Diff1
tff(fact_2338_card_Oinsert__remove,axiom,
    ! [B: $tType,A4: set(B),X: B] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( finite_card(B,aa(set(B),set(B),insert2(B,X),A4)) = aa(nat,nat,suc,finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ).

% card.insert_remove
tff(fact_2339_card_Oremove,axiom,
    ! [B: $tType,A4: set(B),X: B] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( member(B,X,A4)
       => ( finite_card(B,A4) = aa(nat,nat,suc,finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ).

% card.remove
tff(fact_2340_card__Diff1__less__iff,axiom,
    ! [B: $tType,A4: set(B),X: B] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))),finite_card(B,A4))
    <=> ( aa(set(B),$o,finite_finite(B),A4)
        & member(B,X,A4) ) ) ).

% card_Diff1_less_iff
tff(fact_2341_card__Diff2__less,axiom,
    ! [B: $tType,A4: set(B),X: B,Y: B] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( member(B,X,A4)
       => ( member(B,Y,A4)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),aa(set(B),set(B),insert2(B,Y),bot_bot(set(B)))))),finite_card(B,A4)) ) ) ) ).

% card_Diff2_less
tff(fact_2342_card__Diff1__less,axiom,
    ! [B: $tType,A4: set(B),X: B] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( member(B,X,A4)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))),finite_card(B,A4)) ) ) ).

% card_Diff1_less
tff(fact_2343_in__finite__psubset,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),A4),B2),finite_psubset(B))
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A4),B2)
        & aa(set(B),$o,finite_finite(B),B2) ) ) ).

% in_finite_psubset
tff(fact_2344_finite__linorder__max__induct,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),Pa: fun(set(B),$o)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,Pa,bot_bot(set(B)))
           => ( ! [B4: B,A12: set(B)] :
                  ( aa(set(B),$o,finite_finite(B),A12)
                 => ( ! [X3: B] :
                        ( member(B,X3,A12)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X3),B4) )
                   => ( aa(set(B),$o,Pa,A12)
                     => aa(set(B),$o,Pa,aa(set(B),set(B),insert2(B,B4),A12)) ) ) )
             => aa(set(B),$o,Pa,A4) ) ) ) ) ).

% finite_linorder_max_induct
tff(fact_2345_finite__linorder__min__induct,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),Pa: fun(set(B),$o)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,Pa,bot_bot(set(B)))
           => ( ! [B4: B,A12: set(B)] :
                  ( aa(set(B),$o,finite_finite(B),A12)
                 => ( ! [X3: B] :
                        ( member(B,X3,A12)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less(B),B4),X3) )
                   => ( aa(set(B),$o,Pa,A12)
                     => aa(set(B),$o,Pa,aa(set(B),set(B),insert2(B,B4),A12)) ) ) )
             => aa(set(B),$o,Pa,A4) ) ) ) ) ).

% finite_linorder_min_induct
tff(fact_2346_finite__ranking__induct,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [S2: set(B),Pa: fun(set(B),$o),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( aa(set(B),$o,Pa,bot_bot(set(B)))
           => ( ! [X2: B,S5: set(B)] :
                  ( aa(set(B),$o,finite_finite(B),S5)
                 => ( ! [Y4: B] :
                        ( member(B,Y4,S5)
                       => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,Y4)),aa(B,C,Fa,X2)) )
                   => ( aa(set(B),$o,Pa,S5)
                     => aa(set(B),$o,Pa,aa(set(B),set(B),insert2(B,X2),S5)) ) ) )
             => aa(set(B),$o,Pa,S2) ) ) ) ) ).

% finite_ranking_induct
tff(fact_2347_infinite__growing,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X6: set(B)] :
          ( ( X6 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,X6)
               => ? [Xa3: B] :
                    ( member(B,Xa3,X6)
                    & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Xa3) ) )
           => ~ aa(set(B),$o,finite_finite(B),X6) ) ) ) ).

% infinite_growing
tff(fact_2348_ex__min__if__finite,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [S2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( ( S2 != bot_bot(set(B)) )
           => ? [X2: B] :
                ( member(B,X2,S2)
                & ~ ? [Xa3: B] :
                      ( member(B,Xa3,S2)
                      & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Xa3),X2) ) ) ) ) ) ).

% ex_min_if_finite
tff(fact_2349_arg__min__if__finite_I2_J,axiom,
    ! [C: $tType,B: $tType] :
      ( order(C)
     => ! [S2: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( ( S2 != bot_bot(set(B)) )
           => ~ ? [X3: B] :
                  ( member(B,X3,S2)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,X3)),aa(B,C,Fa,lattic7623131987881927897min_on(B,C,Fa,S2))) ) ) ) ) ).

% arg_min_if_finite(2)
tff(fact_2350_arg__min__least,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [S2: set(B),Y: B,Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( ( S2 != bot_bot(set(B)) )
           => ( member(B,Y,S2)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,lattic7623131987881927897min_on(B,C,Fa,S2))),aa(B,C,Fa,Y)) ) ) ) ) ).

% arg_min_least
tff(fact_2351_finite__transitivity__chain,axiom,
    ! [B: $tType,A4: set(B),R: fun(B,fun(B,$o))] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( ! [X2: B] : ~ aa(B,$o,aa(B,fun(B,$o),R,X2),X2)
       => ( ! [X2: B,Y2: B,Z3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),R,X2),Y2)
             => ( aa(B,$o,aa(B,fun(B,$o),R,Y2),Z3)
               => aa(B,$o,aa(B,fun(B,$o),R,X2),Z3) ) )
         => ( ! [X2: B] :
                ( member(B,X2,A4)
               => ? [Y4: B] :
                    ( member(B,Y4,A4)
                    & aa(B,$o,aa(B,fun(B,$o),R,X2),Y4) ) )
           => ( A4 = bot_bot(set(B)) ) ) ) ) ) ).

% finite_transitivity_chain
tff(fact_2352_Gcd__fin__0__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: set(B)] :
          ( ( aa(set(B),B,semiring_gcd_Gcd_fin(B),A4) = zero_zero(B) )
        <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),insert2(B,zero_zero(B)),bot_bot(set(B))))
            & aa(set(B),$o,finite_finite(B),A4) ) ) ) ).

% Gcd_fin_0_iff
tff(fact_2353_greaterThan__Suc,axiom,
    ! [K: nat] : ( aa(nat,set(nat),set_ord_greaterThan(nat),aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),aa(nat,set(nat),set_ord_greaterThan(nat),K)),aa(set(nat),set(nat),insert2(nat,aa(nat,nat,suc,K)),bot_bot(set(nat)))) ) ).

% greaterThan_Suc
tff(fact_2354_Sup__fin_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),B,lattic5882676163264333800up_fin(B),aa(set(B),set(B),insert2(B,X),A4))
            = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(set(B),B,lattic5882676163264333800up_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ) ) ).

% Sup_fin.insert_remove
tff(fact_2355_Gcd__fin_Oempty,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ( aa(set(B),B,semiring_gcd_Gcd_fin(B),bot_bot(set(B))) = zero_zero(B) ) ) ).

% Gcd_fin.empty
tff(fact_2356_Sup__fin_Osingleton,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B] : ( aa(set(B),B,lattic5882676163264333800up_fin(B),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = X ) ) ).

% Sup_fin.singleton
tff(fact_2357_Gcd__fin_Oinfinite,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: set(B)] :
          ( ~ aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),B,semiring_gcd_Gcd_fin(B),A4) = one_one(B) ) ) ) ).

% Gcd_fin.infinite
tff(fact_2358_inf__Sup__absorb,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [A4: set(B),A3: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,A3,A4)
           => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)) = A3 ) ) ) ) ).

% inf_Sup_absorb
tff(fact_2359_is__unit__Gcd__fin__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: set(B)] :
          ( dvd_dvd(B,aa(set(B),B,semiring_gcd_Gcd_fin(B),A4),one_one(B))
        <=> ( aa(set(B),B,semiring_gcd_Gcd_fin(B),A4) = one_one(B) ) ) ) ).

% is_unit_Gcd_fin_iff
tff(fact_2360_Sup__fin_Oinsert,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic5882676163264333800up_fin(B),aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)) ) ) ) ) ).

% Sup_fin.insert
tff(fact_2361_greaterThan__non__empty,axiom,
    ! [B: $tType] :
      ( no_top(B)
     => ! [X: B] : ( aa(B,set(B),set_ord_greaterThan(B),X) != bot_bot(set(B)) ) ) ).

% greaterThan_non_empty
tff(fact_2362_Sup__fin_Oin__idem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)) = aa(set(B),B,lattic5882676163264333800up_fin(B),A4) ) ) ) ) ).

% Sup_fin.in_idem
tff(fact_2363_Sup__fin_Obounded__iff,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)),X)
            <=> ! [X4: B] :
                  ( member(B,X4,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),X) ) ) ) ) ) ).

% Sup_fin.bounded_iff
tff(fact_2364_Sup__fin_OboundedI,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [A8: B] :
                  ( member(B,A8,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A8),X) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)),X) ) ) ) ) ).

% Sup_fin.boundedI
tff(fact_2365_Sup__fin_OboundedE,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)),X)
             => ! [A13: B] :
                  ( member(B,A13,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A13),X) ) ) ) ) ) ).

% Sup_fin.boundedE
tff(fact_2366_ivl__disj__int__one_I7_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,L,U)),aa(B,set(B),set_ord_greaterThan(B),U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(7)
tff(fact_2367_Sup__fin_Osubset__imp,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)),aa(set(B),B,lattic5882676163264333800up_fin(B),B2)) ) ) ) ) ).

% Sup_fin.subset_imp
tff(fact_2368_Sup__fin_Ohom__commute,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [H2: fun(B,B),N4: set(B)] :
          ( ! [X2: B,Y2: B] : ( aa(B,B,H2,aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(B,B,H2,X2)),aa(B,B,H2,Y2)) )
         => ( aa(set(B),$o,finite_finite(B),N4)
           => ( ( N4 != bot_bot(set(B)) )
             => ( aa(B,B,H2,aa(set(B),B,lattic5882676163264333800up_fin(B),N4)) = aa(set(B),B,lattic5882676163264333800up_fin(B),aa(set(B),set(B),image2(B,B,H2),N4)) ) ) ) ) ) ).

% Sup_fin.hom_commute
tff(fact_2369_Sup__fin_Osubset,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( B2 != bot_bot(set(B)) )
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A4)
             => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,lattic5882676163264333800up_fin(B),B2)),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)) = aa(set(B),B,lattic5882676163264333800up_fin(B),A4) ) ) ) ) ) ).

% Sup_fin.subset
tff(fact_2370_Sup__fin_Oclosed,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [X2: B,Y2: B] : member(B,aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y2),aa(set(B),set(B),insert2(B,X2),aa(set(B),set(B),insert2(B,Y2),bot_bot(set(B)))))
             => member(B,aa(set(B),B,lattic5882676163264333800up_fin(B),A4),A4) ) ) ) ) ).

% Sup_fin.closed
tff(fact_2371_Sup__fin_Oinsert__not__elem,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ~ member(B,X,A4)
           => ( ( A4 != bot_bot(set(B)) )
             => ( aa(set(B),B,lattic5882676163264333800up_fin(B),aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
tff(fact_2372_Sup__fin_Ounion,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( aa(set(B),B,lattic5882676163264333800up_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)),aa(set(B),B,lattic5882676163264333800up_fin(B),B2)) ) ) ) ) ) ) ).

% Sup_fin.union
tff(fact_2373_arg__min__if__finite_I1_J,axiom,
    ! [C: $tType,B: $tType] :
      ( order(C)
     => ! [S2: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( ( S2 != bot_bot(set(B)) )
           => member(B,lattic7623131987881927897min_on(B,C,Fa,S2),S2) ) ) ) ).

% arg_min_if_finite(1)
tff(fact_2374_Sup__fin_Oremove,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( aa(set(B),B,lattic5882676163264333800up_fin(B),A4)
              = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(set(B),B,lattic5882676163264333800up_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ) ) ) ).

% Sup_fin.remove
tff(fact_2375_enumerate__Suc_H,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [S2: set(B),N: nat] : ( infini527867602293511546merate(B,S2,aa(nat,nat,suc,N)) = infini527867602293511546merate(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,infini527867602293511546merate(B,S2,zero_zero(nat))),bot_bot(set(B)))),N) ) ) ).

% enumerate_Suc'
tff(fact_2376_Inf__fin_Oremove,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)
              = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ) ) ) ).

% Inf_fin.remove
tff(fact_2377_Inf__fin_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),insert2(B,X),A4))
            = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ) ) ).

% Inf_fin.insert_remove
tff(fact_2378_Inf__fin_Oinsert,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)) ) ) ) ) ).

% Inf_fin.insert
tff(fact_2379_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_atMost(nat,N)),aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_atMost_eq_remove0
tff(fact_2380_ivl__disj__un__singleton_I5_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: B,U: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),L),U)
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert2(B,L),bot_bot(set(B)))),set_or3652927894154168847AtMost(B,L,U)) = set_or1337092689740270186AtMost(B,L,U) ) ) ) ).

% ivl_disj_un_singleton(5)
tff(fact_2381_greaterThanAtMost__empty,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,K: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),L),K)
         => ( set_or3652927894154168847AtMost(B,K,L) = bot_bot(set(B)) ) ) ) ).

% greaterThanAtMost_empty
tff(fact_2382_greaterThanAtMost__empty__iff2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [K: B,L: B] :
          ( ( bot_bot(set(B)) = set_or3652927894154168847AtMost(B,K,L) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),L) ) ) ).

% greaterThanAtMost_empty_iff2
tff(fact_2383_greaterThanAtMost__empty__iff,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [K: B,L: B] :
          ( ( set_or3652927894154168847AtMost(B,K,L) = bot_bot(set(B)) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),L) ) ) ).

% greaterThanAtMost_empty_iff
tff(fact_2384_Int__atMost,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_atMost(B,A3)),set_ord_atMost(B,Ba)) = set_ord_atMost(B,aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)) ) ) ).

% Int_atMost
tff(fact_2385_Inf__fin_Osingleton,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B] : ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = X ) ) ).

% Inf_fin.singleton
tff(fact_2386_sup__Inf__absorb,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [A4: set(B),A3: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,A3,A4)
           => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)),A3) = A3 ) ) ) ) ).

% sup_Inf_absorb
tff(fact_2387_Int__atLeastAtMostL1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,D2: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,A3,Ba)),set_ord_atMost(B,D2)) = set_or1337092689740270186AtMost(B,A3,aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),D2)) ) ) ).

% Int_atLeastAtMostL1
tff(fact_2388_Int__atLeastAtMostR1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,C2: B,D2: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_atMost(B,Ba)),set_or1337092689740270186AtMost(B,C2,D2)) = set_or1337092689740270186AtMost(B,C2,aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),D2)) ) ) ).

% Int_atLeastAtMostR1
tff(fact_2389_atMost__0,axiom,
    set_ord_atMost(nat,zero_zero(nat)) = aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat))) ).

% atMost_0
tff(fact_2390_ivl__disj__int__one_I3_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_atMost(B,L)),set_or3652927894154168847AtMost(B,L,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(3)
tff(fact_2391_greaterThanAtMost__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [L: B,U: B] : ( set_or3652927894154168847AtMost(B,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_greaterThan(B),L)),set_ord_atMost(B,U)) ) ) ).

% greaterThanAtMost_def
tff(fact_2392_not__empty__eq__Iic__eq__empty,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [H2: B] : ( bot_bot(set(B)) != set_ord_atMost(B,H2) ) ) ).

% not_empty_eq_Iic_eq_empty
tff(fact_2393_ivl__disj__int__two_I6_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M4: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or3652927894154168847AtMost(B,L,M4)),set_or3652927894154168847AtMost(B,M4,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(6)
tff(fact_2394_Inf__fin_Oin__idem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)) = aa(set(B),B,lattic7752659483105999362nf_fin(B),A4) ) ) ) ) ).

% Inf_fin.in_idem
tff(fact_2395_Ioc__disjoint,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] :
          ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or3652927894154168847AtMost(B,A3,Ba)),set_or3652927894154168847AtMost(B,C2,D2)) = bot_bot(set(B)) )
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),D2),C2)
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),C2)
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),D2),A3) ) ) ) ).

% Ioc_disjoint
tff(fact_2396_ivl__disj__int__two_I8_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M4: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,L,M4)),set_or3652927894154168847AtMost(B,M4,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(8)
tff(fact_2397_Inf__fin_OboundedE,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4))
             => ! [A13: B] :
                  ( member(B,A13,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),A13) ) ) ) ) ) ).

% Inf_fin.boundedE
tff(fact_2398_Inf__fin_OboundedI,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [A8: B] :
                  ( member(B,A8,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),A8) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)) ) ) ) ) ).

% Inf_fin.boundedI
tff(fact_2399_Inf__fin_Obounded__iff,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4))
            <=> ! [X4: B] :
                  ( member(B,X4,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),X4) ) ) ) ) ) ).

% Inf_fin.bounded_iff
tff(fact_2400_ivl__disj__int__one_I5_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or3652927894154168847AtMost(B,L,U)),aa(B,set(B),set_ord_greaterThan(B),U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(5)
tff(fact_2401_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] : ( set_or3652927894154168847AtMost(B,A3,Ba) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),set_or1337092689740270186AtMost(B,A3,Ba)),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
tff(fact_2402_Inf__fin_Osubset__imp,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),B2)),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)) ) ) ) ) ).

% Inf_fin.subset_imp
tff(fact_2403_Inf__fin_Ohom__commute,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [H2: fun(B,B),N4: set(B)] :
          ( ! [X2: B,Y2: B] : ( aa(B,B,H2,aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(B,B,H2,X2)),aa(B,B,H2,Y2)) )
         => ( aa(set(B),$o,finite_finite(B),N4)
           => ( ( N4 != bot_bot(set(B)) )
             => ( aa(B,B,H2,aa(set(B),B,lattic7752659483105999362nf_fin(B),N4)) = aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),image2(B,B,H2),N4)) ) ) ) ) ) ).

% Inf_fin.hom_commute
tff(fact_2404_Inf__fin_Osubset,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( B2 != bot_bot(set(B)) )
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A4)
             => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),B2)),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)) = aa(set(B),B,lattic7752659483105999362nf_fin(B),A4) ) ) ) ) ) ).

% Inf_fin.subset
tff(fact_2405_Inf__fin_Oinsert__not__elem,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ~ member(B,X,A4)
           => ( ( A4 != bot_bot(set(B)) )
             => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
tff(fact_2406_Inf__fin_Oclosed,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [X2: B,Y2: B] : member(B,aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y2),aa(set(B),set(B),insert2(B,X2),aa(set(B),set(B),insert2(B,Y2),bot_bot(set(B)))))
             => member(B,aa(set(B),B,lattic7752659483105999362nf_fin(B),A4),A4) ) ) ) ) ).

% Inf_fin.closed
tff(fact_2407_Inf__fin_Ounion,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)),aa(set(B),B,lattic7752659483105999362nf_fin(B),B2)) ) ) ) ) ) ) ).

% Inf_fin.union
tff(fact_2408_Inf__fin__le__Sup__fin,axiom,
    ! [B: $tType] :
      ( lattice(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)) ) ) ) ).

% Inf_fin_le_Sup_fin
tff(fact_2409_sum_OatLeastAtMost__shift__0,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [M4: nat,N: nat,Ga: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ) ).

% sum.atLeastAtMost_shift_0
tff(fact_2410_finite__enumerate__initial__segment,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [S2: set(B),N: nat,S: B] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),set_ord_lessThan(B,S))))
           => ( infini527867602293511546merate(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),set_ord_lessThan(B,S)),N) = infini527867602293511546merate(B,S2,N) ) ) ) ) ).

% finite_enumerate_initial_segment
tff(fact_2411_prod_OatLeastAtMost__shift__0,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M4: nat,N: nat,Ga: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ) ).

% prod.atLeastAtMost_shift_0
tff(fact_2412_ivl__disj__un__singleton_I4_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: B,U: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),L),U)
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),set_or5935395276787703475ssThan(B,L,U)),aa(set(B),set(B),insert2(B,U),bot_bot(set(B)))) = set_or3652927894154168847AtMost(B,L,U) ) ) ) ).

% ivl_disj_un_singleton(4)
tff(fact_2413_prod_Ocl__ivl__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,aa(nat,nat,suc,N)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,N)),M4),one_one(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N))),aa(nat,B,Ga,aa(nat,nat,suc,N)))) ) ) ).

% prod.cl_ivl_Suc
tff(fact_2414_atLeastLessThan__nat__numeral,axiom,
    ! [M4: nat,K: num] :
      ( set_or7035219750837199246ssThan(nat,M4,aa(num,nat,numeral_numeral(nat),K))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),pred_numeral(K)),aa(set(nat),set(nat),insert2(nat,pred_numeral(K)),set_or7035219750837199246ssThan(nat,M4,pred_numeral(K))),bot_bot(set(nat))) ) ).

% atLeastLessThan_nat_numeral
tff(fact_2415_lessThan__0,axiom,
    set_ord_lessThan(nat,zero_zero(nat)) = bot_bot(set(nat)) ).

% lessThan_0
tff(fact_2416_atLeastLessThan__empty,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( set_or7035219750837199246ssThan(B,A3,Ba) = bot_bot(set(B)) ) ) ) ).

% atLeastLessThan_empty
tff(fact_2417_atLeastLessThan__empty__iff,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B] :
          ( ( set_or7035219750837199246ssThan(B,A3,Ba) = bot_bot(set(B)) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ).

% atLeastLessThan_empty_iff
tff(fact_2418_atLeastLessThan__empty__iff2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A3: B,Ba: B] :
          ( ( bot_bot(set(B)) = set_or7035219750837199246ssThan(B,A3,Ba) )
        <=> ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba) ) ) ).

% atLeastLessThan_empty_iff2
tff(fact_2419_prod_OlessThan__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_ord_lessThan(nat,N))),aa(nat,B,Ga,N)) ) ) ).

% prod.lessThan_Suc
tff(fact_2420_greaterThanLessThan__empty,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,K: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),L),K)
         => ( set_or5935395276787703475ssThan(B,K,L) = bot_bot(set(B)) ) ) ) ).

% greaterThanLessThan_empty
tff(fact_2421_greaterThanLessThan__empty__iff,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [A3: B,Ba: B] :
          ( ( set_or5935395276787703475ssThan(B,A3,Ba) = bot_bot(set(B)) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ).

% greaterThanLessThan_empty_iff
tff(fact_2422_greaterThanLessThan__empty__iff2,axiom,
    ! [B: $tType] :
      ( dense_linorder(B)
     => ! [A3: B,Ba: B] :
          ( ( bot_bot(set(B)) = set_or5935395276787703475ssThan(B,A3,Ba) )
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ).

% greaterThanLessThan_empty_iff2
tff(fact_2423_single__Diff__lessThan,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [K: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),insert2(B,K),bot_bot(set(B)))),set_ord_lessThan(B,K)) = aa(set(B),set(B),insert2(B,K),bot_bot(set(B))) ) ) ).

% single_Diff_lessThan
tff(fact_2424_prod_OatMost__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_ord_atMost(nat,N))),aa(nat,B,Ga,aa(nat,nat,suc,N))) ) ) ).

% prod.atMost_Suc
tff(fact_2425_atLeastLessThan__singleton,axiom,
    ! [M4: nat] : ( set_or7035219750837199246ssThan(nat,M4,aa(nat,nat,suc,M4)) = aa(set(nat),set(nat),insert2(nat,M4),bot_bot(set(nat))) ) ).

% atLeastLessThan_singleton
tff(fact_2426_prod_Oop__ivl__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,aa(nat,nat,suc,N)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M4),one_one(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,N))),aa(nat,B,Ga,N))) ) ) ).

% prod.op_ivl_Suc
tff(fact_2427_prod_OatLeastLessThan__concat,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M4: nat,N: nat,P2: nat,Ga: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),P2)
           => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,N))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,N,P2))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,P2)) ) ) ) ) ).

% prod.atLeastLessThan_concat
tff(fact_2428_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
tff(fact_2429_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Ga),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
tff(fact_2430_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% prod.atLeastLessThan_shift_bounds
tff(fact_2431_ivl__disj__int__one_I2_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_lessThan(B,L)),set_or7035219750837199246ssThan(B,L,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(2)
tff(fact_2432_ivl__disj__int__two_I1_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M4: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or5935395276787703475ssThan(B,L,M4)),set_or7035219750837199246ssThan(B,M4,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(1)
tff(fact_2433_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(nat,B),M4: nat,K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Ga),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% sum.atLeastLessThan_shift_bounds
tff(fact_2434_greaterThanLessThan__eq,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A3: B,Ba: B] : ( set_or5935395276787703475ssThan(B,A3,Ba) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_greaterThan(B),A3)),set_ord_lessThan(B,Ba)) ) ) ).

% greaterThanLessThan_eq
tff(fact_2435_greaterThanLessThan__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [L: B,U: B] : ( set_or5935395276787703475ssThan(B,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_greaterThan(B),L)),set_ord_lessThan(B,U)) ) ) ).

% greaterThanLessThan_def
tff(fact_2436_lessThan__non__empty,axiom,
    ! [B: $tType] :
      ( no_bot(B)
     => ! [X: B] : ( set_ord_lessThan(B,X) != bot_bot(set(B)) ) ) ).

% lessThan_non_empty
tff(fact_2437_prod_OatLeast0__lessThan__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(nat,B,Ga,N)) ) ) ).

% prod.atLeast0_lessThan_Suc
tff(fact_2438_prod_OatLeast__Suc__lessThan,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M4: nat,N: nat,Ga: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,M4)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),N))) ) ) ) ).

% prod.atLeast_Suc_lessThan
tff(fact_2439_prod_OatLeastLessThan__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: nat,Ba: nat,Ga: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A3),Ba)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,A3,aa(nat,nat,suc,Ba))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,A3,Ba))),aa(nat,B,Ga,Ba)) ) ) ) ).

% prod.atLeastLessThan_Suc
tff(fact_2440_prod_Olast__plus,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M4: nat,N: nat,Ga: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,N)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,N))) ) ) ) ).

% prod.last_plus
tff(fact_2441_prod_Ohead__if,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M4),one_one(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,N))),aa(nat,B,Ga,N))) ) ) ).

% prod.head_if
tff(fact_2442_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
tff(fact_2443_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Ga),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,Ga,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
tff(fact_2444_prod_OatLeastLessThan__shift__0,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ).

% prod.atLeastLessThan_shift_0
tff(fact_2445_sum_OatLeastLessThan__shift__0,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ).

% sum.atLeastLessThan_shift_0
tff(fact_2446_ivl__disj__un__singleton_I3_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: B,U: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),L),U)
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert2(B,L),bot_bot(set(B)))),set_or5935395276787703475ssThan(B,L,U)) = set_or7035219750837199246ssThan(B,L,U) ) ) ) ).

% ivl_disj_un_singleton(3)
tff(fact_2447_ivl__disj__int__two_I3_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M4: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or7035219750837199246ssThan(B,L,M4)),set_or7035219750837199246ssThan(B,M4,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(3)
tff(fact_2448_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( set_ord_lessThan(nat,N) = bot_bot(set(nat)) )
    <=> ( N = zero_zero(nat) ) ) ).

% lessThan_empty_iff
tff(fact_2449_atLeastLessThan0,axiom,
    ! [M4: nat] : ( set_or7035219750837199246ssThan(nat,M4,zero_zero(nat)) = bot_bot(set(nat)) ) ).

% atLeastLessThan0
tff(fact_2450_Iio__eq__empty__iff,axiom,
    ! [B: $tType] :
      ( ( linorder(B)
        & order_bot(B) )
     => ! [N: B] :
          ( ( set_ord_lessThan(B,N) = bot_bot(set(B)) )
        <=> ( N = bot_bot(B) ) ) ) ).

% Iio_eq_empty_iff
tff(fact_2451_greaterThan__Int__greaterThan,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_lessThan(B,A3)),set_ord_lessThan(B,Ba)) = set_ord_lessThan(B,aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)) ) ) ).

% greaterThan_Int_greaterThan
tff(fact_2452_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_lessThan(nat,N)),aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_lessThan_eq_remove0
tff(fact_2453_fact__split,axiom,
    ! [B: $tType] :
      ( semiring_char_0(B)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( semiring_char_0_fact(B,N) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K),N)))),semiring_char_0_fact(B,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_split
tff(fact_2454_prod_Ohead,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M4: nat,N: nat,Ga: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,M4)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or3652927894154168847AtMost(nat,M4,N))) ) ) ) ).

% prod.head
tff(fact_2455_ivl__disj__int__two_I7_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M4: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or7035219750837199246ssThan(B,L,M4)),set_or1337092689740270186AtMost(B,M4,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(7)
tff(fact_2456_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
tff(fact_2457_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% prod.atLeastAtMost_shift_bounds
tff(fact_2458_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Ga),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
tff(fact_2459_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(nat,B),M4: nat,K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Ga),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% sum.atLeastAtMost_shift_bounds
tff(fact_2460_ivl__disj__int__one_I4_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_lessThan(B,L)),set_or1337092689740270186AtMost(B,L,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(4)
tff(fact_2461_ivl__disj__int__two_I5_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M4: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or5935395276787703475ssThan(B,L,M4)),set_or1337092689740270186AtMost(B,M4,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(5)
tff(fact_2462_ivl__disj__int__two_I4_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M4: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,L,M4)),set_or5935395276787703475ssThan(B,M4,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(4)
tff(fact_2463_ivl__disj__int__one_I1_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_atMost(B,L)),set_or5935395276787703475ssThan(B,L,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(1)
tff(fact_2464_ivl__disj__int__two_I2_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,M4: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or3652927894154168847AtMost(B,L,M4)),set_or5935395276787703475ssThan(B,M4,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_two(2)
tff(fact_2465_prod_OatLeast0__atMost__Suc,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))),aa(nat,B,Ga,aa(nat,nat,suc,N))) ) ) ).

% prod.atLeast0_atMost_Suc
tff(fact_2466_prod_Onat__ivl__Suc_H,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M4: nat,N: nat,Ga: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),aa(nat,nat,suc,N))
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,aa(nat,nat,suc,N))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N))) ) ) ) ).

% prod.nat_ivl_Suc'
tff(fact_2467_prod_OatLeast__Suc__atMost,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M4: nat,N: nat,Ga: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,M4)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),N))) ) ) ) ).

% prod.atLeast_Suc_atMost
tff(fact_2468_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [A3: B,Ba: B] : ( set_or7035219750837199246ssThan(B,A3,Ba) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),set_or1337092689740270186AtMost(B,A3,Ba)),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
tff(fact_2469_atLeastLessThanSuc,axiom,
    ! [M4: nat,N: nat] :
      ( set_or7035219750837199246ssThan(nat,M4,aa(nat,nat,suc,N))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N),aa(set(nat),set(nat),insert2(nat,N),set_or7035219750837199246ssThan(nat,M4,N)),bot_bot(set(nat))) ) ).

% atLeastLessThanSuc
tff(fact_2470_Iio__Int__singleton,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [K: B,X: B] :
          ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_lessThan(B,K)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),K),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))),bot_bot(set(B))) ) ) ).

% Iio_Int_singleton
tff(fact_2471_atLeastAtMost__diff__ends,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),set_or1337092689740270186AtMost(B,A3,Ba)),aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))) = set_or5935395276787703475ssThan(B,A3,Ba) ) ) ).

% atLeastAtMost_diff_ends
tff(fact_2472_ivl__disj__un__singleton_I2_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),set_ord_lessThan(B,U)),aa(set(B),set(B),insert2(B,U),bot_bot(set(B)))) = set_ord_atMost(B,U) ) ) ).

% ivl_disj_un_singleton(2)
tff(fact_2473_prod_Oub__add__nat,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M4: nat,N: nat,Ga: fun(nat,B),P2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P2))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P2)))) ) ) ) ).

% prod.ub_add_nat
tff(fact_2474_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_atMost_Suc_shift
tff(fact_2475_ivl__disj__un__singleton_I6_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: B,U: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),L),U)
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),set_or7035219750837199246ssThan(B,L,U)),aa(set(B),set(B),insert2(B,U),bot_bot(set(B)))) = set_or1337092689740270186AtMost(B,L,U) ) ) ) ).

% ivl_disj_un_singleton(6)
tff(fact_2476_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Ga),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,Ga,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% sum.atLeast0_atMost_Suc_shift
tff(fact_2477_prod_Oinsert,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),X: B,Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ~ member(B,X,A4)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),insert2(B,X),A4)) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Ga,X)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4)) ) ) ) ) ).

% prod.insert
tff(fact_2478_prod_Oinfinite,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),Ga: fun(B,C)] :
          ( ~ aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4) = one_one(C) ) ) ) ).

% prod.infinite
tff(fact_2479_prod_Oempty,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(C,B)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),Ga),bot_bot(set(C))) = one_one(B) ) ) ).

% prod.empty
tff(fact_2480_sum_Oempty,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(C,B)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),Ga),bot_bot(set(C))) = zero_zero(B) ) ) ).

% sum.empty
tff(fact_2481_sum__bounded__above__strict,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ordere8940638589300402666id_add(C)
        & semiring_1(C) )
     => ! [A4: set(B),Fa: fun(B,C),K5: C] :
          ( ! [I3: B] :
              ( member(B,I3,A4)
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,I3)),K5) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),finite_card(B,A4))
           => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),A4)),aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),finite_card(B,A4))),K5)) ) ) ) ).

% sum_bounded_above_strict
tff(fact_2482_prod__Un,axiom,
    ! [C: $tType,B: $tType] :
      ( field(C)
     => ! [A4: set(B),B2: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( ! [X2: B] :
                  ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))
                 => ( aa(B,C,Fa,X2) != zero_zero(C) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = divide_divide(C,aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),B2)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ) ) ) ) ).

% prod_Un
tff(fact_2483_sum_OatLeast__int__lessThan__int__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(int,B),M4: nat,N: nat] : ( aa(set(int),B,aa(fun(int,B),fun(set(int),B),groups7311177749621191930dd_sum(int,B),Ga),set_or7035219750837199246ssThan(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,int),fun(nat,B),aa(fun(int,B),fun(fun(nat,int),fun(nat,B)),comp(int,B,nat),Ga),semiring_1_of_nat(int))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% sum.atLeast_int_lessThan_int_shift
tff(fact_2484_prod_OatLeast__int__lessThan__int__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(int,B),M4: nat,N: nat] : ( aa(set(int),B,aa(fun(int,B),fun(set(int),B),groups7121269368397514597t_prod(int,B),Ga),set_or7035219750837199246ssThan(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,int),fun(nat,B),aa(fun(int,B),fun(fun(nat,int),fun(nat,B)),comp(int,B,nat),Ga),semiring_1_of_nat(int))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% prod.atLeast_int_lessThan_int_shift
tff(fact_2485_sum__diff1__nat,axiom,
    ! [B: $tType,Fa: fun(B,nat),A4: set(B),A3: B] :
      ( aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))
      = $ite(member(B,A3,A4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),Fa),A4)),aa(B,nat,Fa,A3)),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),Fa),A4)) ) ).

% sum_diff1_nat
tff(fact_2486_sum__Un__nat,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),Fa: fun(B,nat)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( aa(set(B),$o,finite_finite(B),B2)
       => ( aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),Fa),A4)),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),Fa),B2))),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ) ) ).

% sum_Un_nat
tff(fact_2487_prod_OatLeast__int__atMost__int__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(int,B),M4: nat,N: nat] : ( aa(set(int),B,aa(fun(int,B),fun(set(int),B),groups7121269368397514597t_prod(int,B),Ga),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,int),fun(nat,B),aa(fun(int,B),fun(fun(nat,int),fun(nat,B)),comp(int,B,nat),Ga),semiring_1_of_nat(int))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% prod.atLeast_int_atMost_int_shift
tff(fact_2488_sum_OatLeast__int__atMost__int__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(int,B),M4: nat,N: nat] : ( aa(set(int),B,aa(fun(int,B),fun(set(int),B),groups7311177749621191930dd_sum(int,B),Ga),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,int),fun(nat,B),aa(fun(int,B),fun(fun(nat,int),fun(nat,B)),comp(int,B,nat),Ga),semiring_1_of_nat(int))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% sum.atLeast_int_atMost_int_shift
tff(fact_2489_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(C,B),A4: set(C)] :
          ( ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),Ga),A4) != one_one(B) )
         => ~ ! [A8: C] :
                ( member(C,A8,A4)
               => ( aa(C,B,Ga,A8) = one_one(B) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
tff(fact_2490_prod_Oneutral,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),Ga: fun(B,C)] :
          ( ! [X2: B] :
              ( member(B,X2,A4)
             => ( aa(B,C,Ga,X2) = one_one(C) ) )
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4) = one_one(C) ) ) ) ).

% prod.neutral
tff(fact_2491_prod__ge__1,axiom,
    ! [C: $tType,B: $tType] :
      ( linord181362715937106298miring(C)
     => ! [A4: set(B),Fa: fun(B,C)] :
          ( ! [X2: B] :
              ( member(B,X2,A4)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),one_one(C)),aa(B,C,Fa,X2)) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),one_one(C)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),A4)) ) ) ).

% prod_ge_1
tff(fact_2492_prod__inversef,axiom,
    ! [B: $tType,C: $tType] :
      ( field(B)
     => ! [Fa: fun(C,B),A4: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aa(fun(C,B),fun(C,B),aa(fun(B,B),fun(fun(C,B),fun(C,B)),comp(B,B,C),inverse_inverse(B)),Fa)),A4) = aa(B,B,inverse_inverse(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),Fa),A4)) ) ) ).

% prod_inversef
tff(fact_2493_prod__le__1,axiom,
    ! [B: $tType,C: $tType] :
      ( linord181362715937106298miring(C)
     => ! [A4: set(B),Fa: fun(B,C)] :
          ( ! [X2: B] :
              ( member(B,X2,A4)
             => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,Fa,X2))
                & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X2)),one_one(C)) ) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),A4)),one_one(C)) ) ) ).

% prod_le_1
tff(fact_2494_sum__strict__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( strict7427464778891057005id_add(C)
     => ! [A4: set(B),Fa: fun(B,C),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [X2: B] :
                  ( member(B,X2,A4)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,X2)),aa(B,C,Ga,X2)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),A4)) ) ) ) ) ).

% sum_strict_mono
tff(fact_2495_sum__comp__morphism,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( ( comm_monoid_add(C)
        & comm_monoid_add(B) )
     => ! [H2: fun(C,B),Ga: fun(D,C),A4: set(D)] :
          ( ( aa(C,B,H2,zero_zero(C)) = zero_zero(B) )
         => ( ! [X2: C,Y2: C] : ( aa(C,B,H2,aa(C,C,aa(C,fun(C,C),plus_plus(C),X2),Y2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(C,B,H2,X2)),aa(C,B,H2,Y2)) )
           => ( aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups7311177749621191930dd_sum(D,B),aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),H2),Ga)),A4) = aa(C,B,H2,aa(set(D),C,aa(fun(D,C),fun(set(D),C),groups7311177749621191930dd_sum(D,C),Ga),A4)) ) ) ) ) ).

% sum_comp_morphism
tff(fact_2496_prod_Orelated,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [R: fun(B,fun(B,$o)),S2: set(C),H2: fun(C,B),Ga: fun(C,B)] :
          ( aa(B,$o,aa(B,fun(B,$o),R,one_one(B)),one_one(B))
         => ( ! [X12: B,Y12: B,X23: B,Y23: B] :
                ( ( aa(B,$o,aa(B,fun(B,$o),R,X12),X23)
                  & aa(B,$o,aa(B,fun(B,$o),R,Y12),Y23) )
               => aa(B,$o,aa(B,fun(B,$o),R,aa(B,B,aa(B,fun(B,B),times_times(B),X12),Y12)),aa(B,B,aa(B,fun(B,B),times_times(B),X23),Y23)) )
           => ( aa(set(C),$o,finite_finite(C),S2)
             => ( ! [X2: C] :
                    ( member(C,X2,S2)
                   => aa(B,$o,aa(B,fun(B,$o),R,aa(C,B,H2,X2)),aa(C,B,Ga,X2)) )
               => aa(B,$o,aa(B,fun(B,$o),R,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),H2),S2)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),Ga),S2)) ) ) ) ) ) ).

% prod.related
tff(fact_2497_prod_Oinsert__if,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),Ga: fun(B,C),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),insert2(B,X),A4))
            = $ite(member(B,X,A4),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4),aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Ga,X)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4))) ) ) ) ).

% prod.insert_if
tff(fact_2498_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [S4: set(B),T6: set(C),S2: set(B),I: fun(C,B),J2: fun(B,C),T3: set(C),Ga: fun(B,D),H2: fun(C,D)] :
          ( aa(set(B),$o,finite_finite(B),S4)
         => ( aa(set(C),$o,finite_finite(C),T6)
           => ( ! [A8: B] :
                  ( member(B,A8,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4))
                 => ( aa(C,B,I,aa(B,C,J2,A8)) = A8 ) )
             => ( ! [A8: B] :
                    ( member(B,A8,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4))
                   => member(C,aa(B,C,J2,A8),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T3),T6)) )
               => ( ! [B4: C] :
                      ( member(C,B4,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T3),T6))
                     => ( aa(B,C,J2,aa(C,B,I,B4)) = B4 ) )
                 => ( ! [B4: C] :
                        ( member(C,B4,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T3),T6))
                       => member(B,aa(C,B,I,B4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4)) )
                   => ( ! [A8: B] :
                          ( member(B,A8,S4)
                         => ( aa(B,D,Ga,A8) = one_one(D) ) )
                     => ( ! [B4: C] :
                            ( member(C,B4,T6)
                           => ( aa(C,D,H2,B4) = one_one(D) ) )
                       => ( ! [A8: B] :
                              ( member(B,A8,S2)
                             => ( aa(C,D,H2,aa(B,C,J2,A8)) = aa(B,D,Ga,A8) ) )
                         => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),Ga),S2) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),H2),T3) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
tff(fact_2499_sum_Oreindex,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [H2: fun(B,C),A4: set(B),Ga: fun(C,D)] :
          ( inj_on(B,C,H2,A4)
         => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),Ga),aa(set(B),set(C),image2(B,C,H2),A4)) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),H2)),A4) ) ) ) ).

% sum.reindex
tff(fact_2500_prod_Oreindex,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [H2: fun(B,C),A4: set(B),Ga: fun(C,D)] :
          ( inj_on(B,C,H2,A4)
         => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),Ga),aa(set(B),set(C),image2(B,C,H2),A4)) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),H2)),A4) ) ) ) ).

% prod.reindex
tff(fact_2501_sum__pos,axiom,
    ! [C: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(C)
     => ! [I4: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),I4)
         => ( ( I4 != bot_bot(set(B)) )
           => ( ! [I3: B] :
                  ( member(B,I3,I4)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),zero_zero(C)),aa(B,C,Fa,I3)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),zero_zero(C)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),I4)) ) ) ) ) ).

% sum_pos
tff(fact_2502_less__1__prod2,axiom,
    ! [C: $tType,B: $tType] :
      ( linordered_idom(C)
     => ! [I4: set(B),I: B,Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),I4)
         => ( member(B,I,I4)
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),one_one(C)),aa(B,C,Fa,I))
             => ( ! [I3: B] :
                    ( member(B,I3,I4)
                   => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),one_one(C)),aa(B,C,Fa,I3)) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less(C),one_one(C)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),I4)) ) ) ) ) ) ).

% less_1_prod2
tff(fact_2503_less__1__prod,axiom,
    ! [C: $tType,B: $tType] :
      ( linordered_idom(C)
     => ! [I4: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),I4)
         => ( ( I4 != bot_bot(set(B)) )
           => ( ! [I3: B] :
                  ( member(B,I3,I4)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less(C),one_one(C)),aa(B,C,Fa,I3)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),one_one(C)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),I4)) ) ) ) ) ).

% less_1_prod
tff(fact_2504_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [A4: set(B),H2: fun(B,C),Ga: fun(C,D)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ! [X2: B,Y2: B] :
                ( member(B,X2,A4)
               => ( member(B,Y2,A4)
                 => ( ( X2 != Y2 )
                   => ( ( aa(B,C,H2,X2) = aa(B,C,H2,Y2) )
                     => ( aa(C,D,Ga,aa(B,C,H2,X2)) = zero_zero(D) ) ) ) ) )
           => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),Ga),aa(set(B),set(C),image2(B,C,H2),A4)) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),H2)),A4) ) ) ) ) ).

% sum.reindex_nontrivial
tff(fact_2505_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [A4: set(B),H2: fun(B,C),Ga: fun(C,D)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ! [X2: B,Y2: B] :
                ( member(B,X2,A4)
               => ( member(B,Y2,A4)
                 => ( ( X2 != Y2 )
                   => ( ( aa(B,C,H2,X2) = aa(B,C,H2,Y2) )
                     => ( aa(C,D,Ga,aa(B,C,H2,X2)) = one_one(D) ) ) ) ) )
           => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),Ga),aa(set(B),set(C),image2(B,C,H2),A4)) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),H2)),A4) ) ) ) ) ).

% prod.reindex_nontrivial
tff(fact_2506_sum__bounded__below,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add(C)
        & semiring_1(C) )
     => ! [A4: set(B),K5: C,Fa: fun(B,C)] :
          ( ! [I3: B] :
              ( member(B,I3,A4)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),K5),aa(B,C,Fa,I3)) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),finite_card(B,A4))),K5)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),A4)) ) ) ).

% sum_bounded_below
tff(fact_2507_sum__bounded__above,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add(C)
        & semiring_1(C) )
     => ! [A4: set(B),Fa: fun(B,C),K5: C] :
          ( ! [I3: B] :
              ( member(B,I3,A4)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,I3)),K5) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),A4)),aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),finite_card(B,A4))),K5)) ) ) ).

% sum_bounded_above
tff(fact_2508_sum_Omono__neutral__cong,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [T3: set(B),S2: set(B),H2: fun(B,C),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),T3)
         => ( aa(set(B),$o,finite_finite(B),S2)
           => ( ! [I3: B] :
                  ( member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2))
                 => ( aa(B,C,H2,I3) = zero_zero(C) ) )
             => ( ! [I3: B] :
                    ( member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),T3))
                   => ( aa(B,C,Ga,I3) = zero_zero(C) ) )
               => ( ! [X2: B] :
                      ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3))
                     => ( aa(B,C,Ga,X2) = aa(B,C,H2,X2) ) )
                 => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),H2),T3) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
tff(fact_2509_prod_Osubset__diff,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [B2: set(B),A4: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A4)
         => ( aa(set(B),$o,finite_finite(B),A4)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),B2)) ) ) ) ) ).

% prod.subset_diff
tff(fact_2510_prod_Osame__carrier,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [C3: set(B),A4: set(B),B2: set(B),Ga: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),C3)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),C3)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),C3)
             => ( ! [A8: B] :
                    ( member(B,A8,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),A4))
                   => ( aa(B,C,Ga,A8) = one_one(C) ) )
               => ( ! [B4: B] :
                      ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),B2))
                     => ( aa(B,C,H2,B4) = one_one(C) ) )
                 => ( ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),B2) )
                  <=> ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),C3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),C3) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
tff(fact_2511_prod_Osame__carrierI,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [C3: set(B),A4: set(B),B2: set(B),Ga: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),C3)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),C3)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),C3)
             => ( ! [A8: B] :
                    ( member(B,A8,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),A4))
                   => ( aa(B,C,Ga,A8) = one_one(C) ) )
               => ( ! [B4: B] :
                      ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),C3),B2))
                     => ( aa(B,C,H2,B4) = one_one(C) ) )
                 => ( ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),C3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),C3) )
                   => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),B2) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
tff(fact_2512_prod_Omono__neutral__left,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [T3: set(B),S2: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),T3)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S2),T3)
           => ( ! [X2: B] :
                  ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2))
                 => ( aa(B,C,Ga,X2) = one_one(C) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),T3) ) ) ) ) ) ).

% prod.mono_neutral_left
tff(fact_2513_prod_Omono__neutral__right,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [T3: set(B),S2: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),T3)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S2),T3)
           => ( ! [X2: B] :
                  ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2))
                 => ( aa(B,C,Ga,X2) = one_one(C) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),T3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),S2) ) ) ) ) ) ).

% prod.mono_neutral_right
tff(fact_2514_prod_Omono__neutral__cong__left,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [T3: set(B),S2: set(B),H2: fun(B,C),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),T3)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S2),T3)
           => ( ! [X2: B] :
                  ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2))
                 => ( aa(B,C,H2,X2) = one_one(C) ) )
             => ( ! [X2: B] :
                    ( member(B,X2,S2)
                   => ( aa(B,C,Ga,X2) = aa(B,C,H2,X2) ) )
               => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),T3) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
tff(fact_2515_prod_Omono__neutral__cong__right,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [T3: set(B),S2: set(B),Ga: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),T3)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S2),T3)
           => ( ! [X2: B] :
                  ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2))
                 => ( aa(B,C,Ga,X2) = one_one(C) ) )
             => ( ! [X2: B] :
                    ( member(B,X2,S2)
                   => ( aa(B,C,Ga,X2) = aa(B,C,H2,X2) ) )
               => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),T3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),S2) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
tff(fact_2516_sum_Ounion__inter,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A4: set(B),B2: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),B2)) ) ) ) ) ).

% sum.union_inter
tff(fact_2517_sum_OInt__Diff,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A4: set(B),Ga: fun(B,C),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),A4) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2))) ) ) ) ).

% sum.Int_Diff
tff(fact_2518_prod_Ounion__inter,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),B2: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),B2)) ) ) ) ) ).

% prod.union_inter
tff(fact_2519_prod_OInt__Diff,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),Ga: fun(B,C),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2))) ) ) ) ).

% prod.Int_Diff
tff(fact_2520_prod_Omono__neutral__cong,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [T3: set(B),S2: set(B),H2: fun(B,C),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),T3)
         => ( aa(set(B),$o,finite_finite(B),S2)
           => ( ! [I3: B] :
                  ( member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2))
                 => ( aa(B,C,H2,I3) = one_one(C) ) )
             => ( ! [I3: B] :
                    ( member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),T3))
                   => ( aa(B,C,Ga,I3) = one_one(C) ) )
               => ( ! [X2: B] :
                      ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S2),T3))
                     => ( aa(B,C,Ga,X2) = aa(B,C,H2,X2) ) )
                 => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),T3) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
tff(fact_2521_prod__mono__strict,axiom,
    ! [C: $tType,B: $tType] :
      ( linordered_semidom(C)
     => ! [A4: set(B),Fa: fun(B,C),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ! [I3: B] :
                ( member(B,I3,A4)
               => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,Fa,I3))
                  & aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,I3)),aa(B,C,Ga,I3)) ) )
           => ( ( A4 != bot_bot(set(B)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4)) ) ) ) ) ).

% prod_mono_strict
tff(fact_2522_sum__image__le,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(C)
     => ! [I4: set(B),Ga: fun(D,C),Fa: fun(B,D)] :
          ( aa(set(B),$o,finite_finite(B),I4)
         => ( ! [I3: B] :
                ( member(B,I3,I4)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(D,C,Ga,aa(B,D,Fa,I3))) )
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(D),C,aa(fun(D,C),fun(set(D),C),groups7311177749621191930dd_sum(D,C),Ga),aa(set(B),set(D),image2(B,D,Fa),I4))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Ga),Fa)),I4)) ) ) ) ).

% sum_image_le
tff(fact_2523_sum_Ounion__inter__neutral,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A4: set(B),B2: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( ! [X2: B] :
                  ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))
                 => ( aa(B,C,Ga,X2) = zero_zero(C) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),B2)) ) ) ) ) ) ).

% sum.union_inter_neutral
tff(fact_2524_sum_Oremove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A4: set(B),X: B,Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),A4) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,Ga,X)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% sum.remove
tff(fact_2525_sum_Oinsert__remove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A4: set(B),Ga: fun(B,C),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),insert2(B,X),A4)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,Ga,X)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ).

% sum.insert_remove
tff(fact_2526_sum__diff1,axiom,
    ! [C: $tType,B: $tType] :
      ( ab_group_add(C)
     => ! [A4: set(B),Fa: fun(B,C),A3: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))
            = $ite(member(B,A3,A4),aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),A4)),aa(B,C,Fa,A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),A4)) ) ) ) ).

% sum_diff1
tff(fact_2527_sum__Un,axiom,
    ! [C: $tType,B: $tType] :
      ( ab_group_add(C)
     => ! [A4: set(B),B2: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ) ) ) ).

% sum_Un
tff(fact_2528_sum_Ounion__disjoint,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A4: set(B),B2: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),B2)) ) ) ) ) ) ).

% sum.union_disjoint
tff(fact_2529_prod_Oinsert__remove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),Ga: fun(B,C),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),insert2(B,X),A4)) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Ga,X)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ).

% prod.insert_remove
tff(fact_2530_prod_Oremove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),X: B,Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Ga,X)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% prod.remove
tff(fact_2531_prod_Ounion__inter__neutral,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),B2: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( ! [X2: B] :
                  ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))
                 => ( aa(B,C,Ga,X2) = one_one(C) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),B2)) ) ) ) ) ) ).

% prod.union_inter_neutral
tff(fact_2532_prod_Ounion__disjoint,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),B2: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),B2)) ) ) ) ) ) ).

% prod.union_disjoint
tff(fact_2533_sum__Un2,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A4: set(B),B2: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A4)))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ) ) ).

% sum_Un2
tff(fact_2534_sum_Ounion__diff2,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A4: set(B),B2: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A4)))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ) ) ) ).

% sum.union_diff2
tff(fact_2535_prod_Ounion__diff2,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),B2: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),B2))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A4)))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ) ) ) ).

% prod.union_diff2
tff(fact_2536_member__le__sum,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add(C)
        & semiring_1(C) )
     => ! [I: B,A4: set(B),Fa: fun(B,C)] :
          ( member(B,I,A4)
         => ( ! [X2: B] :
                ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,I),bot_bot(set(B)))))
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,Fa,X2)) )
           => ( aa(set(B),$o,finite_finite(B),A4)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,I)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),A4)) ) ) ) ) ).

% member_le_sum
tff(fact_2537_prod__mono2,axiom,
    ! [C: $tType,B: $tType] :
      ( linordered_idom(C)
     => ! [B2: set(B),A4: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),B2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
           => ( ! [B4: B] :
                  ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),B2),A4))
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),one_one(C)),aa(B,C,Fa,B4)) )
             => ( ! [A8: B] :
                    ( member(B,A8,A4)
                   => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,Fa,A8)) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),A4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),B2)) ) ) ) ) ) ).

% prod_mono2
tff(fact_2538_prod__le__power,axiom,
    ! [B: $tType,C: $tType] :
      ( linordered_semidom(C)
     => ! [A4: set(B),Fa: fun(B,C),N: C,K: nat] :
          ( ! [I3: B] :
              ( member(B,I3,A4)
             => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,Fa,I3))
                & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,I3)),N) ) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(B,A4)),K)
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),one_one(C)),N)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),A4)),aa(nat,C,aa(C,fun(nat,C),power_power(C),N),K)) ) ) ) ) ).

% prod_le_power
tff(fact_2539_prod__diff1,axiom,
    ! [C: $tType,B: $tType] :
      ( semidom_divide(C)
     => ! [A4: set(B),Fa: fun(B,C),A3: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( aa(B,C,Fa,A3) != zero_zero(C) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))
              = $ite(member(B,A3,A4),divide_divide(C,aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),A4),aa(B,C,Fa,A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Fa),A4)) ) ) ) ) ).

% prod_diff1
tff(fact_2540_sum__bounded__above__divide,axiom,
    ! [B: $tType,C: $tType] :
      ( linordered_field(C)
     => ! [A4: set(B),Fa: fun(B,C),K5: C] :
          ( ! [I3: B] :
              ( member(B,I3,A4)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,I3)),divide_divide(C,K5,aa(nat,C,semiring_1_of_nat(C),finite_card(B,A4)))) )
         => ( aa(set(B),$o,finite_finite(B),A4)
           => ( ( A4 != bot_bot(set(B)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),A4)),K5) ) ) ) ) ).

% sum_bounded_above_divide
tff(fact_2541_interval__cases,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [S2: set(B)] :
          ( ! [A8: B,B4: B,X2: B] :
              ( member(B,A8,S2)
             => ( member(B,B4,S2)
               => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A8),X2)
                 => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),B4)
                   => member(B,X2,S2) ) ) ) )
         => ? [A8: B,B4: B] :
              ( ( S2 = bot_bot(set(B)) )
              | ( S2 = top_top(set(B)) )
              | ( S2 = set_ord_lessThan(B,B4) )
              | ( S2 = set_ord_atMost(B,B4) )
              | ( S2 = aa(B,set(B),set_ord_greaterThan(B),A8) )
              | ( S2 = set_ord_atLeast(B,A8) )
              | ( S2 = set_or5935395276787703475ssThan(B,A8,B4) )
              | ( S2 = set_or3652927894154168847AtMost(B,A8,B4) )
              | ( S2 = set_or7035219750837199246ssThan(B,A8,B4) )
              | ( S2 = set_or1337092689740270186AtMost(B,A8,B4) ) ) ) ) ).

% interval_cases
tff(fact_2542_pochhammer__times__pochhammer__half,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Z2: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),comm_s3205402744901411588hammer(B,Z2,aa(nat,nat,suc,N))),comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Z2),divide_divide(B,one_one(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_aa(B,fun(nat,B),Z2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)),one_one(nat)))) ) ) ).

% pochhammer_times_pochhammer_half
tff(fact_2543_choose__odd__sum,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_ab(nat,fun(nat,B),N)),set_ord_atMost(nat,N))) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N) ) ) ) ).

% choose_odd_sum
tff(fact_2544_choose__even__sum,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_ac(nat,fun(nat,B),N)),set_ord_atMost(nat,N))) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N) ) ) ) ).

% choose_even_sum
tff(fact_2545_gbinomial__partial__row__sum,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,M4: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_ad(B,fun(nat,B),A3)),set_ord_atMost(nat,M4)) = aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),M4)),one_one(B)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(nat,B,gbinomial(B,A3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),one_one(nat)))) ) ) ).

% gbinomial_partial_row_sum
tff(fact_2546_gbinomial__r__part__sum,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [M4: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,B,semiring_1_of_nat(B),M4))),one_one(B)))),set_ord_atMost(nat,M4)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4)) ) ) ).

% gbinomial_r_part_sum
tff(fact_2547_atLeast__empty__triv,axiom,
    ! [B: $tType] : ( set_ord_atLeast(set(B),bot_bot(set(B))) = top_top(set(set(B))) ) ).

% atLeast_empty_triv
tff(fact_2548_Heap__Time__Monad_Obind__bind,axiom,
    ! [D: $tType,B: $tType,C: $tType,Fa: heap_Time_Heap(D),Ga: fun(D,heap_Time_Heap(C)),K: fun(C,heap_Time_Heap(B))] : ( heap_Time_bind(C,B,heap_Time_bind(D,C,Fa,Ga),K) = heap_Time_bind(D,B,Fa,aa(fun(C,heap_Time_Heap(B)),fun(D,heap_Time_Heap(B)),aTP_Lamp_ae(fun(D,heap_Time_Heap(C)),fun(fun(C,heap_Time_Heap(B)),fun(D,heap_Time_Heap(B))),Ga),K)) ) ).

% Heap_Time_Monad.bind_bind
tff(fact_2549_bool__assn__proper_I2_J,axiom,
    aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aTP_Lamp_af(product_prod(heap_ext(product_unit),set(nat)),$o)) ).

% bool_assn_proper(2)
tff(fact_2550_bool__assn__proper_I3_J,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Qa)
       => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_ag(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Pa),Qa)) ) ) ).

% bool_assn_proper(3)
tff(fact_2551_bool__assn__proper_I4_J,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Qa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Qa)
       => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_ah(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Pa),Qa)) ) ) ).

% bool_assn_proper(4)
tff(fact_2552_singleton__conv2,axiom,
    ! [B: $tType,A3: B] : ( aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),fequal(B),A3)) = aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))) ) ).

% singleton_conv2
tff(fact_2553_singleton__conv,axiom,
    ! [B: $tType,A3: B] : ( aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ai(B,fun(B,$o),A3)) = aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))) ) ).

% singleton_conv
tff(fact_2554_Collect__const,axiom,
    ! [B: $tType,Pa: $o] :
      ( aa(fun(B,$o),set(B),collect(B),aTP_Lamp_aj($o,fun(B,$o),Pa))
      = $ite((Pa),top_top(set(B)),bot_bot(set(B))) ) ).

% Collect_const
tff(fact_2555_prod_Oneutral__const,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aTP_Lamp_ak(C,B)),A4) = one_one(B) ) ) ).

% prod.neutral_const
tff(fact_2556_bool__assn__proper_I5_J,axiom,
    ! [Pa: fun(product_prod(heap_ext(product_unit),set(nat)),$o)] :
      ( aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,Pa)
     => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aTP_Lamp_al(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa)) ) ).

% bool_assn_proper(5)
tff(fact_2557_prod_Odelta,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [S2: set(B),A3: B,Ba: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_am(B,fun(fun(B,C),fun(B,C)),A3),Ba)),S2)
            = $ite(member(B,A3,S2),aa(B,C,Ba,A3),one_one(C)) ) ) ) ).

% prod.delta
tff(fact_2558_prod_Odelta_H,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [S2: set(B),A3: B,Ba: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_an(B,fun(fun(B,C),fun(B,C)),A3),Ba)),S2)
            = $ite(member(B,A3,S2),aa(B,C,Ba,A3),one_one(C)) ) ) ) ).

% prod.delta'
tff(fact_2559_if__image__distrib,axiom,
    ! [B: $tType,C: $tType,Pa: fun(C,$o),Fa: fun(C,B),Ga: fun(C,B),S2: set(C)] : ( aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_ao(fun(C,$o),fun(fun(C,B),fun(fun(C,B),fun(C,B))),Pa),Fa),Ga)),S2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(C),set(B),image2(C,B,Fa),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),S2),aa(fun(C,$o),set(C),collect(C),Pa)))),aa(set(C),set(B),image2(C,B,Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),S2),aa(fun(C,$o),set(C),collect(C),aTP_Lamp_ap(fun(C,$o),fun(C,$o),Pa))))) ) ).

% if_image_distrib
tff(fact_2560_precise__extr__pure_I1_J,axiom,
    ! [C: $tType,B: $tType,Pa: $o,R: fun(B,fun(C,assn))] :
      ( precise(B,C,aa(fun(B,fun(C,assn)),fun(B,fun(C,assn)),aTP_Lamp_aq($o,fun(fun(B,fun(C,assn)),fun(B,fun(C,assn))),Pa),R))
    <=> ( (Pa)
       => precise(B,C,R) ) ) ).

% precise_extr_pure(1)
tff(fact_2561_precise__extr__pure_I2_J,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,assn)),Pa: $o] :
      ( precise(B,C,aa($o,fun(B,fun(C,assn)),aTP_Lamp_ar(fun(B,fun(C,assn)),fun($o,fun(B,fun(C,assn))),R),Pa))
    <=> ( (Pa)
       => precise(B,C,R) ) ) ).

% precise_extr_pure(2)
tff(fact_2562_range__constant,axiom,
    ! [C: $tType,B: $tType,X: B] : ( aa(set(C),set(B),image2(C,B,aTP_Lamp_as(B,fun(C,B),X)),top_top(set(C))) = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) ).

% range_constant
tff(fact_2563_sum__constant,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Y: B,A4: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aTP_Lamp_at(B,fun(C,B),Y)),A4) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),finite_card(C,A4))),Y) ) ) ).

% sum_constant
tff(fact_2564_sum__of__bool__mult__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [A4: set(B),Pa: fun(B,$o),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_au(fun(B,$o),fun(fun(B,C),fun(B,C)),Pa),Fa)),A4) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,$o),set(B),collect(B),Pa))) ) ) ) ).

% sum_of_bool_mult_eq
tff(fact_2565_sum__mult__of__bool__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [A4: set(B),Fa: fun(B,C),Pa: fun(B,$o)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,$o),fun(B,C),aTP_Lamp_av(fun(B,C),fun(fun(B,$o),fun(B,C)),Fa),Pa)),A4) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,$o),set(B),collect(B),Pa))) ) ) ) ).

% sum_mult_of_bool_eq
tff(fact_2566_sum__zero__power,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [C2: fun(nat,B),A4: set(nat)] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_aw(fun(nat,B),fun(nat,B),C2)),A4)
          = $ite(
              ( aa(set(nat),$o,finite_finite(nat),A4)
              & member(nat,zero_zero(nat),A4) ),
              aa(nat,B,C2,zero_zero(nat)),
              zero_zero(B) ) ) ) ).

% sum_zero_power
tff(fact_2567_sum__of__bool__eq,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [A4: set(B),Pa: fun(B,$o)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),$o,finite_finite(B),A4)
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aTP_Lamp_ax(fun(B,$o),fun(B,C),Pa)),A4) = aa(nat,C,semiring_1_of_nat(C),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,$o),set(B),collect(B),Pa)))) ) ) ) ) ).

% sum_of_bool_eq
tff(fact_2568_sum__zero__power_H,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [C2: fun(nat,B),D2: fun(nat,B),A4: set(nat)] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,B),fun(nat,B),aTP_Lamp_ay(fun(nat,B),fun(fun(nat,B),fun(nat,B)),C2),D2)),A4)
          = $ite(
              ( aa(set(nat),$o,finite_finite(nat),A4)
              & member(nat,zero_zero(nat),A4) ),
              divide_divide(B,aa(nat,B,C2,zero_zero(nat)),aa(nat,B,D2,zero_zero(nat))),
              zero_zero(B) ) ) ) ).

% sum_zero_power'
tff(fact_2569_sum__product,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Fa: fun(C,B),A4: set(C),Ga: fun(D,B),B2: set(D)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),Fa),A4)),aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups7311177749621191930dd_sum(D,B),Ga),B2)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_ba(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),Fa),Ga),B2)),A4) ) ) ).

% sum_product
tff(fact_2570_prod_Odistrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(C,B),H2: fun(C,B),A4: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),aa(fun(C,B),fun(C,B),aTP_Lamp_bb(fun(C,B),fun(fun(C,B),fun(C,B)),Ga),H2)),A4) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),Ga),A4)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),H2),A4)) ) ) ).

% prod.distrib
tff(fact_2571_sum__distrib__right,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Fa: fun(C,B),A4: set(C),R3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),Fa),A4)),R3) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(B,fun(C,B),aTP_Lamp_bc(fun(C,B),fun(B,fun(C,B)),Fa),R3)),A4) ) ) ).

% sum_distrib_right
tff(fact_2572_sum__distrib__left,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [R3: B,Fa: fun(C,B),A4: set(C)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),R3),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),Fa),A4)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),aa(fun(C,B),fun(C,B),aTP_Lamp_bd(B,fun(fun(C,B),fun(C,B)),R3),Fa)),A4) ) ) ).

% sum_distrib_left
tff(fact_2573_pred__subset__eq2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S2: set(product_prod(B,C))] :
      ( aa(fun(B,fun(C,$o)),$o,aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),$o),ord_less_eq(fun(B,fun(C,$o))),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),R)),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),S2))
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),R),S2) ) ).

% pred_subset_eq2
tff(fact_2574_bot__empty__eq2,axiom,
    ! [C: $tType,B: $tType,X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),bot_bot(fun(B,fun(C,$o))),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),bot_bot(set(product_prod(B,C)))) ) ).

% bot_empty_eq2
tff(fact_2575_inj__singleton,axiom,
    ! [B: $tType,A4: set(B)] : inj_on(B,set(B),aTP_Lamp_bf(B,set(B)),A4) ).

% inj_singleton
tff(fact_2576_Collect__conv__if2,axiom,
    ! [B: $tType,A3: B,Pa: fun(B,$o)] :
      ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_bg(B,fun(fun(B,$o),fun(B,$o)),A3),Pa))
      = $ite(aa(B,$o,Pa,A3),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))),bot_bot(set(B))) ) ).

% Collect_conv_if2
tff(fact_2577_Collect__conv__if,axiom,
    ! [B: $tType,A3: B,Pa: fun(B,$o)] :
      ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_bh(B,fun(fun(B,$o),fun(B,$o)),A3),Pa))
      = $ite(aa(B,$o,Pa,A3),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))),bot_bot(set(B))) ) ).

% Collect_conv_if
tff(fact_2578_Set_Oempty__def,axiom,
    ! [B: $tType] : ( bot_bot(set(B)) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_bi(B,$o)) ) ).

% Set.empty_def
tff(fact_2579_inf__Int__eq2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S2: set(product_prod(B,C)),X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),R)),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),S2)),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),R),S2)) ) ).

% inf_Int_eq2
tff(fact_2580_sup__Un__eq2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S2: set(product_prod(B,C)),X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),sup_sup(fun(B,fun(C,$o))),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),R)),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),S2)),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),sup_sup(set(product_prod(B,C))),R),S2)) ) ).

% sup_Un_eq2
tff(fact_2581_sngr__prec,axiom,
    ! [B: $tType] :
      ( heap(B)
     => precise(B,ref(B),aTP_Lamp_bj(B,fun(ref(B),assn))) ) ).

% sngr_prec
tff(fact_2582_effect__LetI,axiom,
    ! [C: $tType,B: $tType,X: B,T4: B,Fa: fun(B,heap_Time_Heap(C)),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: C,N: nat] :
      ( ( X = T4 )
     => ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),Fa,X),H2,H4,R3,N)
       => heap_Time_effect(C,aa(B,heap_Time_Heap(C),Fa,T4),H2,H4,R3,N) ) ) ).

% effect_LetI
tff(fact_2583_distrib__if__bind,axiom,
    ! [B: $tType,C: $tType,Ba: $o,C2: heap_Time_Heap(C),D2: heap_Time_Heap(C),Fa: fun(C,heap_Time_Heap(B))] :
      ( heap_Time_bind(C,B,$ite((Ba),C2,D2),Fa)
      = $ite((Ba),heap_Time_bind(C,B,C2,Fa),heap_Time_bind(C,B,D2,Fa)) ) ).

% distrib_if_bind
tff(fact_2584_success__LetI,axiom,
    ! [B: $tType,C: $tType,X: B,T4: B,Fa: fun(B,heap_Time_Heap(C)),H2: heap_ext(product_unit)] :
      ( ( X = T4 )
     => ( heap_Time_success(C,aa(B,heap_Time_Heap(C),Fa,X),H2)
       => heap_Time_success(C,aa(B,heap_Time_Heap(C),Fa,T4),H2) ) ) ).

% success_LetI
tff(fact_2585_snga__prec,axiom,
    ! [B: $tType] :
      ( heap(B)
     => precise(list(B),array(B),aTP_Lamp_bk(list(B),fun(array(B),assn))) ) ).

% snga_prec
tff(fact_2586_Int__def,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_bl(set(B),fun(set(B),fun(B,$o)),A4),B2)) ) ).

% Int_def
tff(fact_2587_Int__Collect,axiom,
    ! [B: $tType,X: B,A4: set(B),Pa: fun(B,$o)] :
      ( member(B,X,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,$o),set(B),collect(B),Pa)))
    <=> ( member(B,X,A4)
        & aa(B,$o,Pa,X) ) ) ).

% Int_Collect
tff(fact_2588_inf__set__def,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),A4)),aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),B2))) ) ).

% inf_set_def
tff(fact_2589_Collect__conj__eq,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] : ( aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_bm(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(fun(B,$o),set(B),collect(B),Pa)),aa(fun(B,$o),set(B),collect(B),Qa)) ) ).

% Collect_conj_eq
tff(fact_2590_inf__Int__eq,axiom,
    ! [B: $tType,R: set(B),S2: set(B),X3: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),R)),aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),S2)),X3)
    <=> member(B,X3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),R),S2)) ) ).

% inf_Int_eq
tff(fact_2591_lambda__one,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ( aTP_Lamp_bn(B,B) = aa(B,fun(B,B),times_times(B),one_one(B)) ) ) ).

% lambda_one
tff(fact_2592_lambda__zero,axiom,
    ! [B: $tType] :
      ( mult_zero(B)
     => ( aTP_Lamp_bo(B,B) = aa(B,fun(B,B),times_times(B),zero_zero(B)) ) ) ).

% lambda_zero
tff(fact_2593_pred__equals__eq2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S2: set(product_prod(B,C))] :
      ( ! [X4: B,Xa2: C] :
          ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa2),R)
        <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Xa2),S2) )
    <=> ( R = S2 ) ) ).

% pred_equals_eq2
tff(fact_2594_top__empty__eq2,axiom,
    ! [C: $tType,B: $tType,X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),top_top(fun(B,fun(C,$o))),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),top_top(set(product_prod(B,C)))) ) ).

% top_empty_eq2
tff(fact_2595_inj__on__convol__ident,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),X6: set(B)] : inj_on(B,product_prod(B,C),aTP_Lamp_bp(fun(B,C),fun(B,product_prod(B,C)),Fa),X6) ).

% inj_on_convol_ident
tff(fact_2596_inj__Pair_I1_J,axiom,
    ! [C: $tType,B: $tType,C2: fun(B,C),S2: set(B)] : inj_on(B,product_prod(B,C),aTP_Lamp_bp(fun(B,C),fun(B,product_prod(B,C)),C2),S2) ).

% inj_Pair(1)
tff(fact_2597_inj__Pair_I2_J,axiom,
    ! [C: $tType,B: $tType,C2: fun(B,C),S2: set(B)] : inj_on(B,product_prod(C,B),aTP_Lamp_bq(fun(B,C),fun(B,product_prod(C,B)),C2),S2) ).

% inj_Pair(2)
tff(fact_2598_fun_Omap__ident,axiom,
    ! [C: $tType,B: $tType,T4: fun(B,C)] : ( aa(fun(B,C),fun(B,C),aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),aTP_Lamp_br(C,C)),T4) = T4 ) ).

% fun.map_ident
tff(fact_2599_frame__rule,axiom,
    ! [B: $tType,Pa: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn),R: assn] :
      ( hoare_hoare_triple(B,Pa,C2,Qa)
     => hoare_hoare_triple(B,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Pa),R),C2,aa(assn,fun(B,assn),aTP_Lamp_bs(fun(B,assn),fun(assn,fun(B,assn)),Qa),R)) ) ).

% frame_rule
tff(fact_2600_cons__pre__rule,axiom,
    ! [B: $tType,Pa: assn,P: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( entails(Pa,P)
     => ( hoare_hoare_triple(B,P,C2,Qa)
       => hoare_hoare_triple(B,Pa,C2,Qa) ) ) ).

% cons_pre_rule
tff(fact_2601_bot__assn__def,axiom,
    bot_bot(assn) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aTP_Lamp_af(product_prod(heap_ext(product_unit),set(nat)),$o)) ).

% bot_assn_def
tff(fact_2602_not__empty__eq__Ici__eq__empty,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [L: B] : ( bot_bot(set(B)) != set_ord_atLeast(B,L) ) ) ).

% not_empty_eq_Ici_eq_empty
tff(fact_2603_prod_Ofinite__Collect__op,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [I4: set(B),X: fun(B,C),Y: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_bt(set(B),fun(fun(B,C),fun(B,$o)),I4),X)))
         => ( aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_bt(set(B),fun(fun(B,C),fun(B,$o)),I4),Y)))
           => aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aa(fun(B,C),fun(fun(B,C),fun(B,$o)),aTP_Lamp_bu(set(B),fun(fun(B,C),fun(fun(B,C),fun(B,$o))),I4),X),Y))) ) ) ) ).

% prod.finite_Collect_op
tff(fact_2604_image__constant__conv,axiom,
    ! [C: $tType,B: $tType,C2: B,A4: set(C)] :
      ( aa(set(C),set(B),image2(C,B,aTP_Lamp_as(B,fun(C,B),C2)),A4)
      = $ite(A4 = bot_bot(set(C)),bot_bot(set(B)),aa(set(B),set(B),insert2(B,C2),bot_bot(set(B)))) ) ).

% image_constant_conv
tff(fact_2605_image__constant,axiom,
    ! [B: $tType,C: $tType,X: B,A4: set(B),C2: C] :
      ( member(B,X,A4)
     => ( aa(set(B),set(C),image2(B,C,aTP_Lamp_bv(C,fun(B,C),C2)),A4) = aa(set(C),set(C),insert2(C,C2),bot_bot(set(C))) ) ) ).

% image_constant
tff(fact_2606_translation__subtract__Int,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [A3: B,S: set(B),T4: set(B)] : ( aa(set(B),set(B),image2(B,B,aTP_Lamp_bw(B,fun(B,B),A3)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S),T4)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),image2(B,B,aTP_Lamp_bw(B,fun(B,B),A3)),S)),aa(set(B),set(B),image2(B,B,aTP_Lamp_bw(B,fun(B,B),A3)),T4)) ) ) ).

% translation_subtract_Int
tff(fact_2607_prod_Ointer__filter,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),Ga: fun(B,C),Pa: fun(B,$o)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(fun(B,$o),set(B),collect(B),aa(fun(B,$o),fun(B,$o),aTP_Lamp_bx(set(B),fun(fun(B,$o),fun(B,$o)),A4),Pa))) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(B,$o),fun(B,C),aTP_Lamp_by(fun(B,C),fun(fun(B,$o),fun(B,C)),Ga),Pa)),A4) ) ) ) ).

% prod.inter_filter
tff(fact_2608_bind__rule_H,axiom,
    ! [B: $tType,C: $tType,D: $tType,Pa: assn,Fa: heap_Time_Heap(C),R: fun(C,assn),Ga: fun(C,heap_Time_Heap(D)),Qa: fun(D,assn)] :
      ( ! [R2: B] : hoare_hoare_triple(C,Pa,Fa,aa(fun(C,assn),fun(C,assn),aTP_Lamp_bz(assn,fun(fun(C,assn),fun(C,assn)),Pa),R))
     => ( ! [X2: C] : hoare_hoare_triple(D,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,R,X2)),Pa),aa(C,heap_Time_Heap(D),Ga,X2),Qa)
       => hoare_hoare_triple(D,Pa,heap_Time_bind(C,D,Fa,Ga),Qa) ) ) ).

% bind_rule'
tff(fact_2609_sup__assn__def,axiom,
    ! [Pa: assn,Qa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),Pa),Qa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_ca(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Pa),Qa)) ) ).

% sup_assn_def
tff(fact_2610_inf__assn__def,axiom,
    ! [Pa: assn,Qa: assn] : ( aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),Pa),Qa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_cb(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Pa),Qa)) ) ).

% inf_assn_def
tff(fact_2611_numeral__code_I3_J,axiom,
    ! [B: $tType] :
      ( numeral(B)
     => ! [N: num] :
          ( aa(num,B,numeral_numeral(B),aa(num,num,bit1,N))
          = $let(
              m: B,
              m := aa(num,B,numeral_numeral(B),N),
              aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),m),m)),one_one(B)) ) ) ) ).

% numeral_code(3)
tff(fact_2612_sum_Ointer__restrict,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A4: set(B),Ga: fun(B,C),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(set(B),fun(B,C),aTP_Lamp_cc(fun(B,C),fun(set(B),fun(B,C)),Ga),B2)),A4) ) ) ) ).

% sum.inter_restrict
tff(fact_2613_power__numeral__even,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Z2: B,W2: num] :
          ( aa(nat,B,aa(B,fun(nat,B),power_power(B),Z2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,W2)))
          = $let(
              w: B,
              w := aa(nat,B,aa(B,fun(nat,B),power_power(B),Z2),aa(num,nat,numeral_numeral(nat),W2)),
              aa(B,B,aa(B,fun(B,B),times_times(B),w),w) ) ) ) ).

% power_numeral_even
tff(fact_2614_power__numeral__odd,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Z2: B,W2: num] :
          ( aa(nat,B,aa(B,fun(nat,B),power_power(B),Z2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,W2)))
          = $let(
              w: B,
              w := aa(nat,B,aa(B,fun(nat,B),power_power(B),Z2),aa(num,nat,numeral_numeral(nat),W2)),
              aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),Z2),w)),w) ) ) ) ).

% power_numeral_odd
tff(fact_2615_prod_Ointer__restrict,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),Ga: fun(B,C),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(set(B),fun(B,C),aTP_Lamp_cd(fun(B,C),fun(set(B),fun(B,C)),Ga),B2)),A4) ) ) ) ).

% prod.inter_restrict
tff(fact_2616_prod_Osetdiff__irrelevant,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ce(fun(B,C),fun(B,$o),Ga)))) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),A4) ) ) ) ).

% prod.setdiff_irrelevant
tff(fact_2617_sum__power__add,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X: B,M4: nat,I4: set(nat)] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_cf(B,fun(nat,fun(nat,B)),X),M4)),I4) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),M4)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),I4)) ) ) ).

% sum_power_add
tff(fact_2618_fst__diag__id,axiom,
    ! [B: $tType,Z2: B] : ( aa(B,B,aa(fun(B,product_prod(B,B)),fun(B,B),aa(fun(product_prod(B,B),B),fun(fun(B,product_prod(B,B)),fun(B,B)),comp(product_prod(B,B),B,B),product_fst(B,B)),aTP_Lamp_cg(B,product_prod(B,B))),Z2) = aa(B,B,id(B),Z2) ) ).

% fst_diag_id
tff(fact_2619_snd__diag__id,axiom,
    ! [B: $tType,Z2: B] : ( aa(B,B,aa(fun(B,product_prod(B,B)),fun(B,B),aa(fun(product_prod(B,B),B),fun(fun(B,product_prod(B,B)),fun(B,B)),comp(product_prod(B,B),B,B),product_snd(B,B)),aTP_Lamp_cg(B,product_prod(B,B))),Z2) = aa(B,B,id(B),Z2) ) ).

% snd_diag_id
tff(fact_2620_bot_Oordering__top__axioms,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ordering_top(B,aTP_Lamp_ch(B,fun(B,$o)),aTP_Lamp_ci(B,fun(B,$o)),bot_bot(B)) ) ).

% bot.ordering_top_axioms
tff(fact_2621_bind__lift,axiom,
    ! [B: $tType,C: $tType,Fa: heap_Time_Heap(C),Ga: fun(C,B)] : ( heap_Time_bind(C,B,Fa,heap_Time_lift(C,B,Ga)) = heap_Time_bind(C,B,Fa,aTP_Lamp_cj(fun(C,B),fun(C,heap_Time_Heap(B)),Ga)) ) ).

% bind_lift
tff(fact_2622_empty__natural,axiom,
    ! [D: $tType,C: $tType,E: $tType,B: $tType,Fa: fun(B,D),Ga: fun(E,C)] : ( aa(fun(B,D),fun(B,set(C)),aa(fun(D,set(C)),fun(fun(B,D),fun(B,set(C))),comp(D,set(C),B),aTP_Lamp_ck(D,set(C))),Fa) = aa(fun(B,set(E)),fun(B,set(C)),aa(fun(set(E),set(C)),fun(fun(B,set(E)),fun(B,set(C))),comp(set(E),set(C),B),image2(E,C,Ga)),aTP_Lamp_cl(B,set(E))) ) ).

% empty_natural
tff(fact_2623_cons__rulet,axiom,
    ! [B: $tType,Pa: assn,P: assn,Qa: fun(B,assn),Q: fun(B,assn),C2: heap_Time_Heap(B)] :
      ( entailst(Pa,P)
     => ( ! [X2: B] : entailst(aa(B,assn,Qa,X2),aa(B,assn,Q,X2))
       => ( hoare_hoare_triple(B,P,C2,aTP_Lamp_cm(fun(B,assn),fun(B,assn),Qa))
         => hoare_hoare_triple(B,Pa,C2,aTP_Lamp_cm(fun(B,assn),fun(B,assn),Q)) ) ) ) ).

% cons_rulet
tff(fact_2624_cons__pre__rulet,axiom,
    ! [B: $tType,Pa: assn,P: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( entailst(Pa,P)
     => ( hoare_hoare_triple(B,P,C2,aTP_Lamp_cm(fun(B,assn),fun(B,assn),Qa))
       => hoare_hoare_triple(B,Pa,C2,aTP_Lamp_cm(fun(B,assn),fun(B,assn),Qa)) ) ) ).

% cons_pre_rulet
tff(fact_2625_cons__post__rulet,axiom,
    ! [B: $tType,Pa: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn),Q: fun(B,assn)] :
      ( hoare_hoare_triple(B,Pa,C2,aTP_Lamp_cm(fun(B,assn),fun(B,assn),Qa))
     => ( ! [X2: B] : entailst(aa(B,assn,Qa,X2),aa(B,assn,Q,X2))
       => hoare_hoare_triple(B,Pa,C2,aTP_Lamp_cm(fun(B,assn),fun(B,assn),Q)) ) ) ).

% cons_post_rulet
tff(fact_2626_return__sp__rule,axiom,
    ! [B: $tType,Pa: assn,X: B] : hoare_hoare_triple(B,Pa,aa(B,heap_Time_Heap(B),heap_Time_return(B),X),aa(B,fun(B,assn),aTP_Lamp_cn(assn,fun(B,fun(B,assn)),Pa),X)) ).

% return_sp_rule
tff(fact_2627_fst__diag__fst,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(product_prod(B,C),product_prod(B,B)),fun(product_prod(B,C),B),aa(fun(product_prod(B,B),B),fun(fun(product_prod(B,C),product_prod(B,B)),fun(product_prod(B,C),B)),comp(product_prod(B,B),B,product_prod(B,C)),product_fst(B,B)),aa(fun(product_prod(B,C),B),fun(product_prod(B,C),product_prod(B,B)),aa(fun(B,product_prod(B,B)),fun(fun(product_prod(B,C),B),fun(product_prod(B,C),product_prod(B,B))),comp(B,product_prod(B,B),product_prod(B,C)),aTP_Lamp_cg(B,product_prod(B,B))),product_fst(B,C))) = product_fst(B,C) ) ).

% fst_diag_fst
tff(fact_2628_snd__diag__snd,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(product_prod(B,C),product_prod(C,C)),fun(product_prod(B,C),C),aa(fun(product_prod(C,C),C),fun(fun(product_prod(B,C),product_prod(C,C)),fun(product_prod(B,C),C)),comp(product_prod(C,C),C,product_prod(B,C)),product_snd(C,C)),aa(fun(product_prod(B,C),C),fun(product_prod(B,C),product_prod(C,C)),aa(fun(C,product_prod(C,C)),fun(fun(product_prod(B,C),C),fun(product_prod(B,C),product_prod(C,C))),comp(C,product_prod(C,C),product_prod(B,C)),aTP_Lamp_co(C,product_prod(C,C))),product_snd(B,C))) = product_snd(B,C) ) ).

% snd_diag_snd
tff(fact_2629_inj__on__disjoint__Un,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),A4: set(B),Ga: fun(B,C),B2: set(B)] :
      ( inj_on(B,C,Fa,A4)
     => ( inj_on(B,C,Ga,B2)
       => ( ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),image2(B,C,Fa),A4)),aa(set(B),set(C),image2(B,C,Ga),B2)) = bot_bot(set(C)) )
         => inj_on(B,C,aa(fun(B,C),fun(B,C),aa(set(B),fun(fun(B,C),fun(B,C)),aTP_Lamp_cp(fun(B,C),fun(set(B),fun(fun(B,C),fun(B,C))),Fa),A4),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) ) ) ) ).

% inj_on_disjoint_Un
tff(fact_2630_sum_OIf__cases,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [A4: set(B),Pa: fun(B,$o),H2: fun(B,C),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_cq(fun(B,$o),fun(fun(B,C),fun(fun(B,C),fun(B,C))),Pa),H2),Ga)),A4) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),H2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,$o),set(B),collect(B),Pa)))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,$o),set(B),collect(B),Pa))))) ) ) ) ).

% sum.If_cases
tff(fact_2631_prod_OSuc__reindex__ivl,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M4: nat,N: nat,Ga: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N))),aa(nat,B,Ga,aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,M4)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_cr(fun(nat,B),fun(nat,B),Ga)),set_or1337092689740270186AtMost(nat,M4,N))) ) ) ) ).

% prod.Suc_reindex_ivl
tff(fact_2632_prod_OIf__cases,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: set(B),Pa: fun(B,$o),H2: fun(B,C),Ga: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_cs(fun(B,$o),fun(fun(B,C),fun(fun(B,C),fun(B,C))),Pa),H2),Ga)),A4) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,$o),set(B),collect(B),Pa)))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(B),set(B),uminus_uminus(set(B)),aa(fun(B,$o),set(B),collect(B),Pa))))) ) ) ) ).

% prod.If_cases
tff(fact_2633_prod_OatMost__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_cr(fun(nat,B),fun(nat,B),Ga)),set_ord_atMost(nat,N))) ) ) ).

% prod.atMost_Suc_shift
tff(fact_2634_prod_OlessThan__Suc__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_cr(fun(nat,B),fun(nat,B),Ga)),set_ord_lessThan(nat,N))) ) ) ).

% prod.lessThan_Suc_shift
tff(fact_2635_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => semila1105856199041335345_order(B,sup_sup(B),bot_bot(B),aTP_Lamp_ct(B,fun(B,$o)),aTP_Lamp_cu(B,fun(B,$o))) ) ).

% sup_bot.semilattice_neutr_order_axioms
tff(fact_2636_atLeast__eq__UNIV__iff,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [X: B] :
          ( ( set_ord_atLeast(B,X) = top_top(set(B)) )
        <=> ( X = bot_bot(B) ) ) ) ).

% atLeast_eq_UNIV_iff
tff(fact_2637_If__the__inv__into__f__f,axiom,
    ! [C: $tType,B: $tType,I: B,C3: set(B),Ga: fun(B,C),X: B] :
      ( member(B,I,C3)
     => ( inj_on(B,C,Ga,C3)
       => ( aa(B,B,aa(fun(B,C),fun(B,B),aa(fun(C,B),fun(fun(B,C),fun(B,B)),comp(C,B,B),aa(B,fun(C,B),aa(fun(B,C),fun(B,fun(C,B)),aTP_Lamp_cv(set(B),fun(fun(B,C),fun(B,fun(C,B))),C3),Ga),X)),Ga),I) = aa(B,B,id(B),I) ) ) ) ).

% If_the_inv_into_f_f
tff(fact_2638_uminus__assn__def,axiom,
    ! [Pa: assn] : ( aa(assn,assn,uminus_uminus(assn),Pa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aTP_Lamp_cw(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa)) ) ).

% uminus_assn_def
tff(fact_2639_prod__atLeastAtMost__code,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Fa: fun(nat,B),A3: nat,Ba: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Fa),set_or1337092689740270186AtMost(nat,A3,Ba)) = set_fo6178422350223883121st_nat(B,aTP_Lamp_cx(fun(nat,B),fun(nat,fun(B,B)),Fa),A3,Ba,one_one(B)) ) ) ).

% prod_atLeastAtMost_code
tff(fact_2640_snd__diag__fst,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(product_prod(B,C),product_prod(B,B)),fun(product_prod(B,C),B),aa(fun(product_prod(B,B),B),fun(fun(product_prod(B,C),product_prod(B,B)),fun(product_prod(B,C),B)),comp(product_prod(B,B),B,product_prod(B,C)),product_snd(B,B)),aa(fun(product_prod(B,C),B),fun(product_prod(B,C),product_prod(B,B)),aa(fun(B,product_prod(B,B)),fun(fun(product_prod(B,C),B),fun(product_prod(B,C),product_prod(B,B))),comp(B,product_prod(B,B),product_prod(B,C)),aTP_Lamp_cg(B,product_prod(B,B))),product_fst(B,C))) = product_fst(B,C) ) ).

% snd_diag_fst
tff(fact_2641_fst__diag__snd,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(product_prod(B,C),product_prod(C,C)),fun(product_prod(B,C),C),aa(fun(product_prod(C,C),C),fun(fun(product_prod(B,C),product_prod(C,C)),fun(product_prod(B,C),C)),comp(product_prod(C,C),C,product_prod(B,C)),product_fst(C,C)),aa(fun(product_prod(B,C),C),fun(product_prod(B,C),product_prod(C,C)),aa(fun(C,product_prod(C,C)),fun(fun(product_prod(B,C),C),fun(product_prod(B,C),product_prod(C,C))),comp(C,product_prod(C,C),product_prod(B,C)),aTP_Lamp_co(C,product_prod(C,C))),product_snd(B,C))) = product_snd(B,C) ) ).

% fst_diag_snd
tff(fact_2642_sum_Odelta__remove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [S2: set(B),A3: B,Ba: fun(B,C),C2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_cy(B,fun(fun(B,C),fun(fun(B,C),fun(B,C))),A3),Ba),C2)),S2)
            = $ite(member(B,A3,S2),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,Ba,A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) ) ) ).

% sum.delta_remove
tff(fact_2643_sum__div__partition,axiom,
    ! [B: $tType,C: $tType] :
      ( euclid4440199948858584721cancel(C)
     => ! [A4: set(B),Fa: fun(B,C),Ba: C] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( divide_divide(C,aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),A4),Ba) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(C,fun(B,C),aTP_Lamp_cz(fun(B,C),fun(C,fun(B,C)),Fa),Ba)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aTP_Lamp_da(fun(B,C),fun(C,fun(B,$o)),Fa),Ba))))),divide_divide(C,aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aTP_Lamp_db(fun(B,C),fun(C,fun(B,$o)),Fa),Ba)))),Ba)) ) ) ) ).

% sum_div_partition
tff(fact_2644_prod_Odelta__remove,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S2: set(B),A3: B,Ba: fun(B,C),C2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_dc(B,fun(fun(B,C),fun(fun(B,C),fun(B,C))),A3),Ba),C2)),S2)
            = $ite(member(B,A3,S2),aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Ba,A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),C2),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) ) ) ).

% prod.delta_remove
tff(fact_2645_power__diff__1__eq,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)),one_one(B)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),one_one(B))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_ord_lessThan(nat,N))) ) ) ).

% power_diff_1_eq
tff(fact_2646_one__diff__power__eq,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_ord_lessThan(nat,N))) ) ) ).

% one_diff_power_eq
tff(fact_2647_geometric__sum,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X: B,N: nat] :
          ( ( X != one_one(B) )
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_ord_lessThan(nat,N)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)),one_one(B)),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),one_one(B))) ) ) ) ).

% geometric_sum
tff(fact_2648_gbinomial__parallel__sum,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_dd(B,fun(nat,B),A3)),set_ord_atMost(nat,N)) = aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),aa(nat,B,semiring_1_of_nat(B),N))),one_one(B))),N) ) ) ).

% gbinomial_parallel_sum
tff(fact_2649_prod_OatMost__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_ord_atMost(nat,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Ga,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_cr(fun(nat,B),fun(nat,B),Ga)),set_ord_lessThan(nat,N))) ) ) ).

% prod.atMost_shift
tff(fact_2650_sum_OatLeast__atMost__pred__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aTP_Lamp_de(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% sum.atLeast_atMost_pred_shift
tff(fact_2651_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aTP_Lamp_de(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% sum.atLeast_lessThan_pred_shift
tff(fact_2652_prod_OatLeast__atMost__pred__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aTP_Lamp_de(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% prod.atLeast_atMost_pred_shift
tff(fact_2653_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aTP_Lamp_de(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% prod.atLeast_lessThan_pred_shift
tff(fact_2654_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,X: nat,Y: nat] :
      ( aa(set(nat),set(nat),image2(nat,nat,aTP_Lamp_df(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,X,Y))
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),C2),Y),
          set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Y),C2)),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),Y),aa(set(nat),set(nat),insert2(nat,zero_zero(nat)),bot_bot(set(nat))),bot_bot(set(nat))) ) ) ).

% image_minus_const_atLeastLessThan_nat
tff(fact_2655_image__mult__atLeastAtMost__if_H,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [C2: B,X: B,Y: B] :
          ( aa(set(B),set(B),image2(B,B,aTP_Lamp_dg(B,fun(B,B),C2)),set_or1337092689740270186AtMost(B,X,Y))
          = $ite(
              aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),times_times(B),X),C2),aa(B,B,aa(B,fun(B,B),times_times(B),Y),C2)),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),times_times(B),Y),C2),aa(B,B,aa(B,fun(B,B),times_times(B),X),C2))),
              bot_bot(set(B)) ) ) ) ).

% image_mult_atLeastAtMost_if'
tff(fact_2656_image__affinity__atLeastAtMost,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [M4: B,C2: B,A3: B,Ba: B] :
          ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),aTP_Lamp_dh(B,fun(B,fun(B,B)),M4),C2)),set_or1337092689740270186AtMost(B,A3,Ba))
          = $ite(
              set_or1337092689740270186AtMost(B,A3,Ba) = bot_bot(set(B)),
              bot_bot(set(B)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),M4),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M4),A3)),C2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M4),Ba)),C2)),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M4),Ba)),C2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M4),A3)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost
tff(fact_2657_image__affinity__atLeastAtMost__diff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [M4: B,C2: B,A3: B,Ba: B] :
          ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),aTP_Lamp_di(B,fun(B,fun(B,B)),M4),C2)),set_or1337092689740270186AtMost(B,A3,Ba))
          = $ite(
              set_or1337092689740270186AtMost(B,A3,Ba) = bot_bot(set(B)),
              bot_bot(set(B)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),M4),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M4),A3)),C2),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M4),Ba)),C2)),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M4),Ba)),C2),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),M4),A3)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_diff
tff(fact_2658_image__affinity__atLeastAtMost__div,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [M4: B,C2: B,A3: B,Ba: B] :
          ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),aTP_Lamp_dj(B,fun(B,fun(B,B)),M4),C2)),set_or1337092689740270186AtMost(B,A3,Ba))
          = $ite(
              set_or1337092689740270186AtMost(B,A3,Ba) = bot_bot(set(B)),
              bot_bot(set(B)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),M4),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,A3,M4)),C2),aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,Ba,M4)),C2)),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,Ba,M4)),C2),aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,A3,M4)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_div
tff(fact_2659_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [M4: B,C2: B,A3: B,Ba: B] :
          ( aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),aTP_Lamp_dk(B,fun(B,fun(B,B)),M4),C2)),set_or1337092689740270186AtMost(B,A3,Ba))
          = $ite(
              set_or1337092689740270186AtMost(B,A3,Ba) = bot_bot(set(B)),
              bot_bot(set(B)),
              $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),M4),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),divide_divide(B,A3,M4)),C2),aa(B,B,aa(B,fun(B,B),minus_minus(B),divide_divide(B,Ba,M4)),C2)),set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),divide_divide(B,Ba,M4)),C2),aa(B,B,aa(B,fun(B,B),minus_minus(B),divide_divide(B,A3,M4)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
tff(fact_2660_convex__sum__bound__le,axiom,
    ! [B: $tType,C: $tType] :
      ( linordered_idom(C)
     => ! [I4: set(B),X: fun(B,C),A3: fun(B,C),Ba: C,Delta: C] :
          ( ! [I3: B] :
              ( member(B,I3,I4)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,X,I3)) )
         => ( ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),X),I4) = one_one(C) )
           => ( ! [I3: B] :
                  ( member(B,I3,I4)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(C,C,abs_abs(C),aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(B,C,A3,I3)),Ba))),Delta) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(C,C,abs_abs(C),aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_dl(fun(B,C),fun(fun(B,C),fun(B,C)),X),A3)),I4)),Ba))),Delta) ) ) ) ) ).

% convex_sum_bound_le
tff(fact_2661_sum__fun__comp,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( semiring_1(D)
     => ! [S2: set(B),R: set(C),Ga: fun(B,C),Fa: fun(C,D)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( aa(set(C),$o,finite_finite(C),R)
           => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,Ga),S2)),R)
             => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_dm(fun(B,C),fun(fun(C,D),fun(B,D)),Ga),Fa)),S2) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),aa(fun(C,D),fun(C,D),aa(fun(B,C),fun(fun(C,D),fun(C,D)),aTP_Lamp_do(set(B),fun(fun(B,C),fun(fun(C,D),fun(C,D))),S2),Ga),Fa)),R) ) ) ) ) ) ).

% sum_fun_comp
tff(fact_2662_sum__gp__basic,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_ord_atMost(nat,N))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(nat,nat,suc,N))) ) ) ).

% sum_gp_basic
tff(fact_2663_prod__gen__delta,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S2: set(B),A3: B,Ba: fun(B,C),C2: C] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(C,fun(B,C),aa(fun(B,C),fun(C,fun(B,C)),aTP_Lamp_dp(B,fun(fun(B,C),fun(C,fun(B,C))),A3),Ba),C2)),S2)
            = $ite(member(B,A3,S2),aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Ba,A3)),aa(nat,C,aa(C,fun(nat,C),power_power(C),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),finite_card(B,S2)),one_one(nat)))),aa(nat,C,aa(C,fun(nat,C),power_power(C),C2),finite_card(B,S2))) ) ) ) ).

% prod_gen_delta
tff(fact_2664_sum__gp__strict,axiom,
    ! [B: $tType] :
      ( ( division_ring(B)
        & comm_ring(B) )
     => ! [X: B,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_ord_lessThan(nat,N))
          = $ite(X = one_one(B),aa(nat,B,semiring_1_of_nat(B),N),divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X))) ) ) ).

% sum_gp_strict
tff(fact_2665_power__diff__sumr2,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X: B,N: nat,Y: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),Y)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(nat,fun(B,fun(nat,B)),aTP_Lamp_dq(B,fun(nat,fun(B,fun(nat,B))),X),N),Y)),set_ord_lessThan(nat,N))) ) ) ).

% power_diff_sumr2
tff(fact_2666_diff__power__eq__sum,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X: B,N: nat,Y: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(nat,nat,suc,N))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Y),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),Y)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(nat,fun(B,fun(nat,B)),aTP_Lamp_dr(B,fun(nat,fun(B,fun(nat,B))),X),N),Y)),set_ord_lessThan(nat,aa(nat,nat,suc,N)))) ) ) ).

% diff_power_eq_sum
tff(fact_2667_sum__power__shift,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [M4: nat,N: nat,X: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_or1337092689740270186AtMost(nat,M4,N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),M4)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4)))) ) ) ) ).

% sum_power_shift
tff(fact_2668_ivl__disj__int__one_I8_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or7035219750837199246ssThan(B,L,U)),set_ord_atLeast(B,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(8)
tff(fact_2669_mask__eq__sum__exp,axiom,
    ! [B: $tType] :
      ( semiring_parity(B)
     => ! [N: nat] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N)),one_one(B)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_ds(nat,fun(nat,$o),N))) ) ) ).

% mask_eq_sum_exp
tff(fact_2670_atLeastAtMost__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [L: B,U: B] : ( set_or1337092689740270186AtMost(B,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_atLeast(B,L)),set_ord_atMost(B,U)) ) ) ).

% atLeastAtMost_def
tff(fact_2671_atLeastLessThan__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [L: B,U: B] : ( set_or7035219750837199246ssThan(B,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_atLeast(B,L)),set_ord_lessThan(B,U)) ) ) ).

% atLeastLessThan_def
tff(fact_2672_ivl__disj__int__one_I6_J,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [L: B,U: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or5935395276787703475ssThan(B,L,U)),set_ord_atLeast(B,U)) = bot_bot(set(B)) ) ) ).

% ivl_disj_int_one(6)
tff(fact_2673_sum__gp__multiplied,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [M4: nat,N: nat,X: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_or1337092689740270186AtMost(nat,M4,N))) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),M4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(nat,nat,suc,N))) ) ) ) ).

% sum_gp_multiplied
tff(fact_2674_prod_Oin__pairs,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),M4: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),M4),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_dt(fun(nat,B),fun(nat,B),Ga)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% prod.in_pairs
tff(fact_2675_one__diff__power__eq_H,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [X: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X)),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aTP_Lamp_du(B,fun(nat,fun(nat,B)),X),N)),set_ord_lessThan(nat,N))) ) ) ).

% one_diff_power_eq'
tff(fact_2676_prod_Oin__pairs__0,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(nat,B),N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),Ga),set_ord_atMost(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),N)))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_dt(fun(nat,B),fun(nat,B),Ga)),set_ord_atMost(nat,N)) ) ) ).

% prod.in_pairs_0
tff(fact_2677_gbinomial__sum__lower__neg,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,M4: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_dv(B,fun(nat,B),A3)),set_ord_atMost(nat,M4)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),M4)),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))),M4)) ) ) ).

% gbinomial_sum_lower_neg
tff(fact_2678_binomial__ring,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: B,Ba: B,N: nat] : ( aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba)),N) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aa(B,fun(nat,fun(nat,B)),aTP_Lamp_dw(B,fun(B,fun(nat,fun(nat,B))),A3),Ba),N)),set_ord_atMost(nat,N)) ) ) ).

% binomial_ring
tff(fact_2679_signed__take__bit__code,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat,A3: B] :
          ( bit_ri4674362597316999326ke_bit(B,N,A3)
          = $let(
              l: B,
              l := bit_se2584673776208193580ke_bit(B,aa(nat,nat,suc,N),A3),
              $ite(aa(nat,$o,bit_se5641148757651400278ts_bit(B,l),N),aa(B,B,aa(B,fun(B,B),plus_plus(B),l),bit_se4730199178511100633sh_bit(B,aa(nat,nat,suc,N),aa(B,B,uminus_uminus(B),one_one(B)))),l) ) ) ) ).

% signed_take_bit_code
tff(fact_2680_gbinomial__mult__fact_H,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,A3),K)),semiring_char_0_fact(B,K)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_dx(B,fun(nat,B),A3)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact'
tff(fact_2681_gbinomial__mult__fact,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),semiring_char_0_fact(B,K)),aa(nat,B,gbinomial(B,A3),K)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aTP_Lamp_dx(B,fun(nat,B),A3)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact
tff(fact_2682_pochhammer__binomial__sum,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [A3: B,Ba: B,N: nat] : ( comm_s3205402744901411588hammer(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),Ba),N) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(nat,fun(nat,B),aa(B,fun(nat,fun(nat,B)),aTP_Lamp_dy(B,fun(B,fun(nat,fun(nat,B))),A3),Ba),N)),set_ord_atMost(nat,N)) ) ) ).

% pochhammer_binomial_sum
tff(fact_2683_prod_Ozero__middle,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [P2: nat,K: nat,Ga: fun(nat,B),H2: fun(nat,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),P2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),P2)
           => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_dz(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),K),Ga),H2)),set_ord_atMost(nat,P2)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7121269368397514597t_prod(nat,B),aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_ea(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),K),Ga),H2)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P2),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% prod.zero_middle
tff(fact_2684_gbinomial__sum__up__index,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [K: nat,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_eb(nat,fun(nat,B),K)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))) ) ) ).

% gbinomial_sum_up_index
tff(fact_2685_gbinomial__partial__sum__poly,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [M4: nat,A3: B,X: B,Y: B] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_ec(nat,fun(B,fun(B,fun(B,fun(nat,B)))),M4),A3),X),Y)),set_ord_atMost(nat,M4)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_ed(nat,fun(B,fun(B,fun(B,fun(nat,B)))),M4),A3),X),Y)),set_ord_atMost(nat,M4)) ) ) ).

% gbinomial_partial_sum_poly
tff(fact_2686_pochhammer__code,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: B,N: nat] :
          ( comm_s3205402744901411588hammer(B,A3,N)
          = $ite(N = zero_zero(nat),one_one(B),set_fo6178422350223883121st_nat(B,aTP_Lamp_ee(B,fun(nat,fun(B,B)),A3),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),one_one(B))) ) ) ).

% pochhammer_code
tff(fact_2687_double__gauss__sum,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),semiring_1_of_nat(B)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))) ) ) ).

% double_gauss_sum
tff(fact_2688_double__arith__series,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: B,D2: B,N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aTP_Lamp_ef(B,fun(B,fun(nat,B)),A3),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),D2))) ) ) ).

% double_arith_series
tff(fact_2689_sum__gp0,axiom,
    ! [B: $tType] :
      ( ( division_ring(B)
        & comm_ring(B) )
     => ! [X: B,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_ord_atMost(nat,N))
          = $ite(X = one_one(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))),divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(nat,nat,suc,N))),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X))) ) ) ).

% sum_gp0
tff(fact_2690_atMost__Int__atLeast,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [N: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_atMost(B,N)),set_ord_atLeast(B,N)) = aa(set(B),set(B),insert2(B,N),bot_bot(set(B))) ) ) ).

% atMost_Int_atLeast
tff(fact_2691_gbinomial__partial__sum__poly__xpos,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [M4: nat,A3: B,X: B,Y: B] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_ec(nat,fun(B,fun(B,fun(B,fun(nat,B)))),M4),A3),X),Y)),set_ord_atMost(nat,M4)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_eg(nat,fun(B,fun(B,fun(B,fun(nat,B)))),M4),A3),X),Y)),set_ord_atMost(nat,M4)) ) ) ).

% gbinomial_partial_sum_poly_xpos
tff(fact_2692_choose__alternating__linear__sum,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat] :
          ( ( N != one_one(nat) )
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_eh(nat,fun(nat,B),N)),set_ord_atMost(nat,N)) = zero_zero(B) ) ) ) ).

% choose_alternating_linear_sum
tff(fact_2693_ivl__disj__un__singleton_I1_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [L: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert2(B,L),bot_bot(set(B)))),aa(B,set(B),set_ord_greaterThan(B),L)) = set_ord_atLeast(B,L) ) ) ).

% ivl_disj_un_singleton(1)
tff(fact_2694_double__gauss__sum__from__Suc__0,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [N: nat] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),semiring_1_of_nat(B)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))) ) ) ).

% double_gauss_sum_from_Suc_0
tff(fact_2695_gauss__sum,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),semiring_1_of_nat(B)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum
tff(fact_2696_arith__series,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [A3: B,D2: B,N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),aTP_Lamp_ei(B,fun(B,fun(nat,B)),A3),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),D2))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% arith_series
tff(fact_2697_sum__gp__offset,axiom,
    ! [B: $tType] :
      ( ( division_ring(B)
        & comm_ring(B) )
     => ! [X: B,M4: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_or1337092689740270186AtMost(nat,M4,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),N)))
          = $ite(X = one_one(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B)),divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),M4)),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(nat,nat,suc,N)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X))) ) ) ).

% sum_gp_offset
tff(fact_2698_choose__alternating__sum,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_ej(nat,fun(nat,B),N)),set_ord_atMost(nat,N)) = zero_zero(B) ) ) ) ).

% choose_alternating_sum
tff(fact_2699_gbinomial__code,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,K: nat] :
          ( aa(nat,B,gbinomial(B,A3),K)
          = $ite(K = zero_zero(nat),one_one(B),divide_divide(B,set_fo6178422350223883121st_nat(B,aTP_Lamp_ek(B,fun(nat,fun(B,B)),A3),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)),one_one(B)),semiring_char_0_fact(B,K))) ) ) ).

% gbinomial_code
tff(fact_2700_atLeast__Suc,axiom,
    ! [K: nat] : ( set_ord_atLeast(nat,aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_atLeast(nat,K)),aa(set(nat),set(nat),insert2(nat,K),bot_bot(set(nat)))) ) ).

% atLeast_Suc
tff(fact_2701_gauss__sum__from__Suc__0,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [N: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),semiring_1_of_nat(B)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),N)),one_one(B))),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))) ) ) ).

% gauss_sum_from_Suc_0
tff(fact_2702_gchoose__row__sum__weighted,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [R3: B,M4: nat] : ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aTP_Lamp_ad(B,fun(nat,B),R3)),set_or1337092689740270186AtMost(nat,zero_zero(nat),M4)) = aa(B,B,aa(B,fun(B,B),times_times(B),divide_divide(B,aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,suc,M4)),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(nat,B,gbinomial(B,R3),aa(nat,nat,suc,M4))) ) ) ).

% gchoose_row_sum_weighted
tff(fact_2703_sum__gp,axiom,
    ! [B: $tType] :
      ( ( division_ring(B)
        & comm_ring(B) )
     => ! [X: B,M4: nat,N: nat] :
          ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(B,fun(nat,B),power_power(B),X)),set_or1337092689740270186AtMost(nat,M4,N))
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M4),
              zero_zero(B),
              $ite(X = one_one(B),aa(nat,B,semiring_1_of_nat(B),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))),M4)),divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),M4)),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(nat,nat,suc,N))),aa(B,B,aa(B,fun(B,B),minus_minus(B),one_one(B)),X))) ) ) ) ).

% sum_gp
tff(fact_2704_reflcl__set__eq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X3: B,Xa3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),sup_sup(fun(B,fun(B,$o))),aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3)),fequal(B)),X3),Xa3)
    <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa3),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),R3),id2(B))) ) ).

% reflcl_set_eq
tff(fact_2705_If__the__inv__into__in__Func,axiom,
    ! [C: $tType,B: $tType,Ga: fun(B,C),C3: set(B),B2: set(B),X: B] :
      ( inj_on(B,C,Ga,C3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))
       => member(fun(C,B),aa(B,fun(C,B),aa(set(B),fun(B,fun(C,B)),aTP_Lamp_em(fun(B,C),fun(set(B),fun(B,fun(C,B))),Ga),C3),X),bNF_Wellorder_Func(C,B,top_top(set(C)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),B2),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ).

% If_the_inv_into_in_Func
tff(fact_2706_of__nat__code,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat] : ( aa(nat,B,semiring_1_of_nat(B),N) = semiri8178284476397505188at_aux(B,aTP_Lamp_en(B,B),N,zero_zero(B)) ) ) ).

% of_nat_code
tff(fact_2707_divmod__algorithm__code_I6_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M4: num,N: num] : ( unique8689654367752047608divmod(B,aa(num,num,bit1,M4),aa(num,num,bit0,N)) = aa(product_prod(B,B),product_prod(B,B),aa(fun(B,fun(B,product_prod(B,B))),fun(product_prod(B,B),product_prod(B,B)),product_case_prod(B,B,product_prod(B,B)),aTP_Lamp_eo(B,fun(B,product_prod(B,B)))),unique8689654367752047608divmod(B,M4,N)) ) ) ).

% divmod_algorithm_code(6)
tff(fact_2708_lookup__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [P2: ref(B),X: B] : hoare_hoare_triple(B,sngr_assn(B,P2,X),ref_lookup(B,P2),aa(B,fun(B,assn),aTP_Lamp_ep(ref(B),fun(B,fun(B,assn)),P2),X)) ) ).

% lookup_rule
tff(fact_2709_divmod__step__def,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [L: num,Qr: product_prod(B,B)] : ( unique1321980374590559556d_step(B,L,Qr) = aa(product_prod(B,B),product_prod(B,B),aa(fun(B,fun(B,product_prod(B,B))),fun(product_prod(B,B),product_prod(B,B)),product_case_prod(B,B,product_prod(B,B)),aTP_Lamp_eq(num,fun(B,fun(B,product_prod(B,B))),L)),Qr) ) ) ).

% divmod_step_def
tff(fact_2710_predicate2I,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(C,$o)),Qa: fun(B,fun(C,$o))] :
      ( ! [X2: B,Y2: C] :
          ( aa(C,$o,aa(B,fun(C,$o),Pa,X2),Y2)
         => aa(C,$o,aa(B,fun(C,$o),Qa,X2),Y2) )
     => aa(fun(B,fun(C,$o)),$o,aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),$o),ord_less_eq(fun(B,fun(C,$o))),Pa),Qa) ) ).

% predicate2I
tff(fact_2711_inf1I,axiom,
    ! [B: $tType,A4: fun(B,$o),X: B,B2: fun(B,$o)] :
      ( aa(B,$o,A4,X)
     => ( aa(B,$o,B2,X)
       => aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),A4),B2),X) ) ) ).

% inf1I
tff(fact_2712_inf2I,axiom,
    ! [B: $tType,C: $tType,A4: fun(B,fun(C,$o)),X: B,Y: C,B2: fun(B,fun(C,$o))] :
      ( aa(C,$o,aa(B,fun(C,$o),A4,X),Y)
     => ( aa(C,$o,aa(B,fun(C,$o),B2,X),Y)
       => aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),A4),B2),X),Y) ) ) ).

% inf2I
tff(fact_2713_top2I,axiom,
    ! [B: $tType,C: $tType,X: B,Y: C] : aa(C,$o,aa(B,fun(C,$o),top_top(fun(B,fun(C,$o))),X),Y) ).

% top2I
tff(fact_2714_case__prod__conv,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(C,fun(D,B)),A3: C,Ba: D] : ( aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),Fa),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),A3),Ba)) = aa(D,B,aa(C,fun(D,B),Fa,A3),Ba) ) ).

% case_prod_conv
tff(fact_2715_case__prod__Pair,axiom,
    ! [C: $tType,B: $tType] : ( aa(fun(B,fun(C,product_prod(B,C))),fun(product_prod(B,C),product_prod(B,C)),product_case_prod(B,C,product_prod(B,C)),product_Pair(B,C)) = id(product_prod(B,C)) ) ).

% case_prod_Pair
tff(fact_2716_pair__imageI,axiom,
    ! [D: $tType,C: $tType,B: $tType,A3: B,Ba: C,A4: set(product_prod(B,C)),Fa: fun(B,fun(C,D))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),A4)
     => member(D,aa(C,D,aa(B,fun(C,D),Fa,A3),Ba),aa(set(product_prod(B,C)),set(D),image2(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),Fa)),A4)) ) ).

% pair_imageI
tff(fact_2717_divmod__algorithm__code_I5_J,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [M4: num,N: num] : ( unique8689654367752047608divmod(B,aa(num,num,bit0,M4),aa(num,num,bit0,N)) = aa(product_prod(B,B),product_prod(B,B),aa(fun(B,fun(B,product_prod(B,B))),fun(product_prod(B,B),product_prod(B,B)),product_case_prod(B,B,product_prod(B,B)),aTP_Lamp_er(B,fun(B,product_prod(B,B)))),unique8689654367752047608divmod(B,M4,N)) ) ) ).

% divmod_algorithm_code(5)
tff(fact_2718_inf1E,axiom,
    ! [B: $tType,A4: fun(B,$o),B2: fun(B,$o),X: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),A4),B2),X)
     => ~ ( aa(B,$o,A4,X)
         => ~ aa(B,$o,B2,X) ) ) ).

% inf1E
tff(fact_2719_inf2E,axiom,
    ! [B: $tType,C: $tType,A4: fun(B,fun(C,$o)),B2: fun(B,fun(C,$o)),X: B,Y: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),A4),B2),X),Y)
     => ~ ( aa(C,$o,aa(B,fun(C,$o),A4,X),Y)
         => ~ aa(C,$o,aa(B,fun(C,$o),B2,X),Y) ) ) ).

% inf2E
tff(fact_2720_inf1D1,axiom,
    ! [B: $tType,A4: fun(B,$o),B2: fun(B,$o),X: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),A4),B2),X)
     => aa(B,$o,A4,X) ) ).

% inf1D1
tff(fact_2721_inf1D2,axiom,
    ! [B: $tType,A4: fun(B,$o),B2: fun(B,$o),X: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),A4),B2),X)
     => aa(B,$o,B2,X) ) ).

% inf1D2
tff(fact_2722_inf2D1,axiom,
    ! [B: $tType,C: $tType,A4: fun(B,fun(C,$o)),B2: fun(B,fun(C,$o)),X: B,Y: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),A4),B2),X),Y)
     => aa(C,$o,aa(B,fun(C,$o),A4,X),Y) ) ).

% inf2D1
tff(fact_2723_inf2D2,axiom,
    ! [B: $tType,C: $tType,A4: fun(B,fun(C,$o)),B2: fun(B,fun(C,$o)),X: B,Y: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),A4),B2),X),Y)
     => aa(C,$o,aa(B,fun(C,$o),B2,X),Y) ) ).

% inf2D2
tff(fact_2724_rev__predicate2D,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,fun(C,$o)),X: B,Y: C,Qa: fun(B,fun(C,$o))] :
      ( aa(C,$o,aa(B,fun(C,$o),Pa,X),Y)
     => ( aa(fun(B,fun(C,$o)),$o,aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),$o),ord_less_eq(fun(B,fun(C,$o))),Pa),Qa)
       => aa(C,$o,aa(B,fun(C,$o),Qa,X),Y) ) ) ).

% rev_predicate2D
tff(fact_2725_predicate2D,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,fun(C,$o)),Qa: fun(B,fun(C,$o)),X: B,Y: C] :
      ( aa(fun(B,fun(C,$o)),$o,aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),$o),ord_less_eq(fun(B,fun(C,$o))),Pa),Qa)
     => ( aa(C,$o,aa(B,fun(C,$o),Pa,X),Y)
       => aa(C,$o,aa(B,fun(C,$o),Qa,X),Y) ) ) ).

% predicate2D
tff(fact_2726_bot2E,axiom,
    ! [B: $tType,C: $tType,X: B,Y: C] : ~ aa(C,$o,aa(B,fun(C,$o),bot_bot(fun(B,fun(C,$o))),X),Y) ).

% bot2E
tff(fact_2727_split__cong,axiom,
    ! [D: $tType,C: $tType,B: $tType,Q2: product_prod(B,C),Fa: fun(B,fun(C,D)),Ga: fun(B,fun(C,D)),P2: product_prod(B,C)] :
      ( ! [X2: B,Y2: C] :
          ( ( aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2) = Q2 )
         => ( aa(C,D,aa(B,fun(C,D),Fa,X2),Y2) = aa(C,D,aa(B,fun(C,D),Ga,X2),Y2) ) )
     => ( ( P2 = Q2 )
       => ( aa(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),Fa),P2) = aa(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),Ga),Q2) ) ) ) ).

% split_cong
tff(fact_2728_old_Oprod_Ocase,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(C,fun(D,B)),X1: C,X22: D] : ( aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),Fa),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),X1),X22)) = aa(D,B,aa(C,fun(D,B),Fa,X1),X22) ) ).

% old.prod.case
tff(fact_2729_swap__inj__on,axiom,
    ! [C: $tType,B: $tType,A4: set(product_prod(B,C))] : inj_on(product_prod(B,C),product_prod(C,B),aa(fun(B,fun(C,product_prod(C,B))),fun(product_prod(B,C),product_prod(C,B)),product_case_prod(B,C,product_prod(C,B)),aTP_Lamp_es(B,fun(C,product_prod(C,B)))),A4) ).

% swap_inj_on
tff(fact_2730_case__prod__Pair__iden,axiom,
    ! [C: $tType,B: $tType,P2: product_prod(B,C)] : ( aa(product_prod(B,C),product_prod(B,C),aa(fun(B,fun(C,product_prod(B,C))),fun(product_prod(B,C),product_prod(B,C)),product_case_prod(B,C,product_prod(B,C)),product_Pair(B,C)),P2) = P2 ) ).

% case_prod_Pair_iden
tff(fact_2731_case__prodE2,axiom,
    ! [C: $tType,B: $tType,D: $tType,Qa: fun(B,$o),Pa: fun(C,fun(D,B)),Z2: product_prod(C,D)] :
      ( aa(B,$o,Qa,aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),Pa),Z2))
     => ~ ! [X2: C,Y2: D] :
            ( ( Z2 = aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),X2),Y2) )
           => ~ aa(B,$o,Qa,aa(D,B,aa(C,fun(D,B),Pa,X2),Y2)) ) ) ).

% case_prodE2
tff(fact_2732_case__prod__eta,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(product_prod(B,C),D)] : ( aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),aTP_Lamp_et(fun(product_prod(B,C),D),fun(B,fun(C,D)),Fa)) = Fa ) ).

% case_prod_eta
tff(fact_2733_cond__case__prod__eta,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,fun(C,D)),Ga: fun(product_prod(B,C),D)] :
      ( ! [X2: B,Y2: C] : ( aa(C,D,aa(B,fun(C,D),Fa,X2),Y2) = aa(product_prod(B,C),D,Ga,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2)) )
     => ( aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),Fa) = Ga ) ) ).

% cond_case_prod_eta
tff(fact_2734_map__prod__def,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Fa: fun(B,D),Ga: fun(C,E)] : ( product_map_prod(B,D,C,E,Fa,Ga) = aa(fun(B,fun(C,product_prod(D,E))),fun(product_prod(B,C),product_prod(D,E)),product_case_prod(B,C,product_prod(D,E)),aa(fun(C,E),fun(B,fun(C,product_prod(D,E))),aTP_Lamp_eu(fun(B,D),fun(fun(C,E),fun(B,fun(C,product_prod(D,E)))),Fa),Ga)) ) ).

% map_prod_def
tff(fact_2735_case__prod__comp,axiom,
    ! [E: $tType,B: $tType,D: $tType,C: $tType,Fa: fun(E,fun(D,B)),Ga: fun(C,E),X: product_prod(C,D)] : ( aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),aa(fun(C,E),fun(C,fun(D,B)),aa(fun(E,fun(D,B)),fun(fun(C,E),fun(C,fun(D,B))),comp(E,fun(D,B),C),Fa),Ga)),X) = aa(D,B,aa(E,fun(D,B),Fa,aa(C,E,Ga,aa(product_prod(C,D),C,product_fst(C,D),X))),aa(product_prod(C,D),D,product_snd(C,D),X)) ) ).

% case_prod_comp
tff(fact_2736_case__prod__o__map__prod,axiom,
    ! [B: $tType,E: $tType,D: $tType,F7: $tType,C: $tType,Fa: fun(E,fun(F7,D)),G1: fun(B,E),G22: fun(C,F7)] : ( aa(fun(product_prod(B,C),product_prod(E,F7)),fun(product_prod(B,C),D),aa(fun(product_prod(E,F7),D),fun(fun(product_prod(B,C),product_prod(E,F7)),fun(product_prod(B,C),D)),comp(product_prod(E,F7),D,product_prod(B,C)),aa(fun(E,fun(F7,D)),fun(product_prod(E,F7),D),product_case_prod(E,F7,D),Fa)),product_map_prod(B,E,C,F7,G1,G22)) = aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),aa(fun(C,F7),fun(B,fun(C,D)),aa(fun(B,E),fun(fun(C,F7),fun(B,fun(C,D))),aTP_Lamp_ev(fun(E,fun(F7,D)),fun(fun(B,E),fun(fun(C,F7),fun(B,fun(C,D)))),Fa),G1),G22)) ) ).

% case_prod_o_map_prod
tff(fact_2737_prod_Osplit__sel,axiom,
    ! [B: $tType,D: $tType,C: $tType,Pa: fun(B,$o),Fa: fun(C,fun(D,B)),Prod: product_prod(C,D)] :
      ( aa(B,$o,Pa,aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),Fa),Prod))
    <=> ( ( Prod = aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(product_prod(C,D),C,product_fst(C,D),Prod)),aa(product_prod(C,D),D,product_snd(C,D),Prod)) )
       => aa(B,$o,Pa,aa(D,B,aa(C,fun(D,B),Fa,aa(product_prod(C,D),C,product_fst(C,D),Prod)),aa(product_prod(C,D),D,product_snd(C,D),Prod))) ) ) ).

% prod.split_sel
tff(fact_2738_prod_Osplit__sel__asm,axiom,
    ! [B: $tType,D: $tType,C: $tType,Pa: fun(B,$o),Fa: fun(C,fun(D,B)),Prod: product_prod(C,D)] :
      ( aa(B,$o,Pa,aa(product_prod(C,D),B,aa(fun(C,fun(D,B)),fun(product_prod(C,D),B),product_case_prod(C,D,B),Fa),Prod))
    <=> ~ ( ( Prod = aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(product_prod(C,D),C,product_fst(C,D),Prod)),aa(product_prod(C,D),D,product_snd(C,D),Prod)) )
          & ~ aa(B,$o,Pa,aa(D,B,aa(C,fun(D,B),Fa,aa(product_prod(C,D),C,product_fst(C,D),Prod)),aa(product_prod(C,D),D,product_snd(C,D),Prod))) ) ) ).

% prod.split_sel_asm
tff(fact_2739_rat__abs__code,axiom,
    ! [P2: rat] : ( quotient_of(aa(rat,rat,abs_abs(rat),P2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_ew(int,fun(int,product_prod(int,int)))),quotient_of(P2)) ) ).

% rat_abs_code
tff(fact_2740_fst__snd__flip,axiom,
    ! [C: $tType,B: $tType,Xy: product_prod(B,C)] : ( aa(product_prod(B,C),B,product_fst(B,C),Xy) = aa(product_prod(B,C),B,aa(fun(product_prod(B,C),product_prod(C,B)),fun(product_prod(B,C),B),aa(fun(product_prod(C,B),B),fun(fun(product_prod(B,C),product_prod(C,B)),fun(product_prod(B,C),B)),comp(product_prod(C,B),B,product_prod(B,C)),product_snd(C,B)),aa(fun(B,fun(C,product_prod(C,B))),fun(product_prod(B,C),product_prod(C,B)),product_case_prod(B,C,product_prod(C,B)),aTP_Lamp_es(B,fun(C,product_prod(C,B))))),Xy) ) ).

% fst_snd_flip
tff(fact_2741_snd__fst__flip,axiom,
    ! [B: $tType,C: $tType,Xy: product_prod(C,B)] : ( aa(product_prod(C,B),B,product_snd(C,B),Xy) = aa(product_prod(C,B),B,aa(fun(product_prod(C,B),product_prod(B,C)),fun(product_prod(C,B),B),aa(fun(product_prod(B,C),B),fun(fun(product_prod(C,B),product_prod(B,C)),fun(product_prod(C,B),B)),comp(product_prod(B,C),B,product_prod(C,B)),product_fst(B,C)),aa(fun(C,fun(B,product_prod(B,C))),fun(product_prod(C,B),product_prod(B,C)),product_case_prod(C,B,product_prod(B,C)),aTP_Lamp_ex(C,fun(B,product_prod(B,C))))),Xy) ) ).

% snd_fst_flip
tff(fact_2742_rat__uminus__code,axiom,
    ! [P2: rat] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),P2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_ey(int,fun(int,product_prod(int,int)))),quotient_of(P2)) ) ).

% rat_uminus_code
tff(fact_2743_rat__minus__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fa(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_minus_code
tff(fact_2744_rat__divide__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(divide_divide(rat,P2,Q2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fc(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_divide_code
tff(fact_2745_rat__times__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fe(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_times_code
tff(fact_2746_divmod__nat__if,axiom,
    ! [M4: nat,N: nat] :
      ( divmod_nat(M4,N)
      = $ite(
          ( ( N = zero_zero(nat) )
          | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N) ),
          aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),M4),
          aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_ff(nat,fun(nat,product_prod(nat,nat)))),divmod_nat(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),N),N)) ) ) ).

% divmod_nat_if
tff(fact_2747_rat__plus__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fh(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_plus_code
tff(fact_2748_divmod__step__nat__def,axiom,
    ! [L: num,Qr: product_prod(nat,nat)] : ( unique1321980374590559556d_step(nat,L,Qr) = aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_fi(num,fun(nat,fun(nat,product_prod(nat,nat))),L)),Qr) ) ).

% divmod_step_nat_def
tff(fact_2749_rat__inverse__code,axiom,
    ! [P2: rat] : ( quotient_of(aa(rat,rat,inverse_inverse(rat),P2)) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fj(int,fun(int,product_prod(int,int)))),quotient_of(P2)) ) ).

% rat_inverse_code
tff(fact_2750_divmod__step__int__def,axiom,
    ! [L: num,Qr: product_prod(int,int)] : ( unique1321980374590559556d_step(int,L,Qr) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aTP_Lamp_fk(num,fun(int,fun(int,product_prod(int,int))),L)),Qr) ) ).

% divmod_step_int_def
tff(fact_2751_normalize__def,axiom,
    ! [P2: product_prod(int,int)] :
      ( normalize(P2)
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P2)),
          $let(
            a2: int,
            a2 := aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(product_prod(int,int),int,product_snd(int,int),P2)),
            aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),divide_divide(int,aa(product_prod(int,int),int,product_fst(int,int),P2),a2)),divide_divide(int,aa(product_prod(int,int),int,product_snd(int,int),P2),a2)) ),
          $ite(
            aa(product_prod(int,int),int,product_snd(int,int),P2) = zero_zero(int),
            aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),
            $let(
              a2: int,
              a2 := aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(product_prod(int,int),int,product_snd(int,int),P2))),
              aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),divide_divide(int,aa(product_prod(int,int),int,product_fst(int,int),P2),a2)),divide_divide(int,aa(product_prod(int,int),int,product_snd(int,int),P2),a2)) ) ) ) ) ).

% normalize_def
tff(fact_2752_freeze__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A3: array(B),Xs: list(B)] : hoare_hoare_triple(list(B),snga_assn(B,A3,Xs),array_freeze(B,A3),aa(list(B),fun(list(B),assn),aTP_Lamp_fl(array(B),fun(list(B),fun(list(B),assn)),A3),Xs)) ) ).

% freeze_rule
tff(fact_2753_bind__return,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B)] : ( heap_Time_bind(B,B,Fa,heap_Time_return(B)) = heap_Time_bind(product_unit,B,heap_Time_wait(one_one(nat)),aTP_Lamp_fm(heap_Time_Heap(B),fun(product_unit,heap_Time_Heap(B)),Fa)) ) ).

% bind_return
tff(fact_2754_return__bind,axiom,
    ! [B: $tType,C: $tType,X: C,Fa: fun(C,heap_Time_Heap(B))] : ( heap_Time_bind(C,B,aa(C,heap_Time_Heap(C),heap_Time_return(C),X),Fa) = heap_Time_bind(product_unit,B,heap_Time_wait(one_one(nat)),aa(fun(C,heap_Time_Heap(B)),fun(product_unit,heap_Time_Heap(B)),aTP_Lamp_fn(C,fun(fun(C,heap_Time_Heap(B)),fun(product_unit,heap_Time_Heap(B))),X),Fa)) ) ).

% return_bind
tff(fact_2755_sum__diff1_H__aux,axiom,
    ! [C: $tType,B: $tType] :
      ( ab_group_add(C)
     => ! [F: set(B),I4: set(B),Fa: fun(B,C),I: B] :
          ( aa(set(B),$o,finite_finite(B),F)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_fo(set(B),fun(fun(B,C),fun(B,$o)),I4),Fa))),F)
           => ( groups1027152243600224163dd_sum(B,C,Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),I4),aa(set(B),set(B),insert2(B,I),bot_bot(set(B)))))
              = $ite(member(B,I,I4),aa(C,C,aa(C,fun(C,C),minus_minus(C),groups1027152243600224163dd_sum(B,C,Fa,I4)),aa(B,C,Fa,I)),groups1027152243600224163dd_sum(B,C,Fa,I4)) ) ) ) ) ).

% sum_diff1'_aux
tff(fact_2756_divmod__step__integer__def,axiom,
    ! [L: num,Qr: product_prod(code_integer,code_integer)] : ( unique1321980374590559556d_step(code_integer,L,Qr) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_fp(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),Qr) ) ).

% divmod_step_integer_def
tff(fact_2757_case__prodI2,axiom,
    ! [C: $tType,B: $tType,P2: product_prod(B,C),C2: fun(B,fun(C,$o))] :
      ( ! [A8: B,B4: C] :
          ( ( P2 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4) )
         => aa(C,$o,aa(B,fun(C,$o),C2,A8),B4) )
     => aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),C2),P2) ) ).

% case_prodI2
tff(fact_2758_case__prodI,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(C,$o)),A3: B,Ba: C] :
      ( aa(C,$o,aa(B,fun(C,$o),Fa,A3),Ba)
     => aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Fa),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba)) ) ).

% case_prodI
tff(fact_2759_mem__case__prodI2,axiom,
    ! [D: $tType,C: $tType,B: $tType,P2: product_prod(B,C),Z2: D,C2: fun(B,fun(C,set(D)))] :
      ( ! [A8: B,B4: C] :
          ( ( P2 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4) )
         => member(D,Z2,aa(C,set(D),aa(B,fun(C,set(D)),C2,A8),B4)) )
     => member(D,Z2,aa(product_prod(B,C),set(D),aa(fun(B,fun(C,set(D))),fun(product_prod(B,C),set(D)),product_case_prod(B,C,set(D)),C2),P2)) ) ).

% mem_case_prodI2
tff(fact_2760_mem__case__prodI,axiom,
    ! [B: $tType,C: $tType,D: $tType,Z2: B,C2: fun(C,fun(D,set(B))),A3: C,Ba: D] :
      ( member(B,Z2,aa(D,set(B),aa(C,fun(D,set(B)),C2,A3),Ba))
     => member(B,Z2,aa(product_prod(C,D),set(B),aa(fun(C,fun(D,set(B))),fun(product_prod(C,D),set(B)),product_case_prod(C,D,set(B)),C2),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),A3),Ba))) ) ).

% mem_case_prodI
tff(fact_2761_case__prodI2_H,axiom,
    ! [B: $tType,C: $tType,D: $tType,P2: product_prod(B,C),C2: fun(B,fun(C,fun(D,$o))),X: D] :
      ( ! [A8: B,B4: C] :
          ( ( aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4) = P2 )
         => aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),C2,A8),B4),X) )
     => aa(D,$o,aa(product_prod(B,C),fun(D,$o),aa(fun(B,fun(C,fun(D,$o))),fun(product_prod(B,C),fun(D,$o)),product_case_prod(B,C,fun(D,$o)),C2),P2),X) ) ).

% case_prodI2'
tff(fact_2762_gcd_Obottom__right__bottom,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),one_one(B)) = one_one(B) ) ) ).

% gcd.bottom_right_bottom
tff(fact_2763_gcd_Obottom__left__bottom,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),one_one(B)),A3) = one_one(B) ) ) ).

% gcd.bottom_left_bottom
tff(fact_2764_Collect__const__case__prod,axiom,
    ! [C: $tType,B: $tType,Pa: $o] :
      ( aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_fq($o,fun(B,fun(C,$o)),Pa)))
      = $ite((Pa),top_top(set(product_prod(B,C))),bot_bot(set(product_prod(B,C)))) ) ).

% Collect_const_case_prod
tff(fact_2765_is__unit__gcd__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba),one_one(B))
        <=> ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) = one_one(B) ) ) ) ).

% is_unit_gcd_iff
tff(fact_2766_sum_Oempty_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [P2: fun(C,B)] : ( groups1027152243600224163dd_sum(C,B,P2,bot_bot(set(C))) = zero_zero(B) ) ) ).

% sum.empty'
tff(fact_2767_Gcd__2,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: B,Ba: B] : ( gcd_Gcd(B,aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) ) ) ).

% Gcd_2
tff(fact_2768_lex__prod__def,axiom,
    ! [B: $tType,C: $tType,Ra: set(product_prod(B,B)),Rb: set(product_prod(C,C))] : ( lex_prod(B,C,Ra,Rb) = aa(fun(product_prod(product_prod(B,C),product_prod(B,C)),$o),set(product_prod(product_prod(B,C),product_prod(B,C))),collect(product_prod(product_prod(B,C),product_prod(B,C))),aa(fun(product_prod(B,C),fun(product_prod(B,C),$o)),fun(product_prod(product_prod(B,C),product_prod(B,C)),$o),product_case_prod(product_prod(B,C),product_prod(B,C),$o),aa(fun(B,fun(C,fun(product_prod(B,C),$o))),fun(product_prod(B,C),fun(product_prod(B,C),$o)),product_case_prod(B,C,fun(product_prod(B,C),$o)),aa(set(product_prod(C,C)),fun(B,fun(C,fun(product_prod(B,C),$o))),aTP_Lamp_fs(set(product_prod(B,B)),fun(set(product_prod(C,C)),fun(B,fun(C,fun(product_prod(B,C),$o)))),Ra),Rb)))) ) ).

% lex_prod_def
tff(fact_2769_divmod__integer_H__def,axiom,
    ! [M4: num,N: num] : ( unique8689654367752047608divmod(code_integer,M4,N) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),divide_divide(code_integer,aa(num,code_integer,numeral_numeral(code_integer),M4),aa(num,code_integer,numeral_numeral(code_integer),N))),modulo_modulo(code_integer,aa(num,code_integer,numeral_numeral(code_integer),M4),aa(num,code_integer,numeral_numeral(code_integer),N))) ) ).

% divmod_integer'_def
tff(fact_2770_mem__case__prodE,axiom,
    ! [C: $tType,B: $tType,D: $tType,Z2: B,C2: fun(C,fun(D,set(B))),P2: product_prod(C,D)] :
      ( member(B,Z2,aa(product_prod(C,D),set(B),aa(fun(C,fun(D,set(B))),fun(product_prod(C,D),set(B)),product_case_prod(C,D,set(B)),C2),P2))
     => ~ ! [X2: C,Y2: D] :
            ( ( P2 = aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),X2),Y2) )
           => ~ member(B,Z2,aa(D,set(B),aa(C,fun(D,set(B)),C2,X2),Y2)) ) ) ).

% mem_case_prodE
tff(fact_2771_case__prodE,axiom,
    ! [B: $tType,C: $tType,C2: fun(B,fun(C,$o)),P2: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),C2),P2)
     => ~ ! [X2: B,Y2: C] :
            ( ( P2 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2) )
           => ~ aa(C,$o,aa(B,fun(C,$o),C2,X2),Y2) ) ) ).

% case_prodE
tff(fact_2772_case__prodD,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(C,$o)),A3: B,Ba: C] :
      ( aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Fa),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba))
     => aa(C,$o,aa(B,fun(C,$o),Fa,A3),Ba) ) ).

% case_prodD
tff(fact_2773_case__prodE_H,axiom,
    ! [C: $tType,B: $tType,D: $tType,C2: fun(B,fun(C,fun(D,$o))),P2: product_prod(B,C),Z2: D] :
      ( aa(D,$o,aa(product_prod(B,C),fun(D,$o),aa(fun(B,fun(C,fun(D,$o))),fun(product_prod(B,C),fun(D,$o)),product_case_prod(B,C,fun(D,$o)),C2),P2),Z2)
     => ~ ! [X2: B,Y2: C] :
            ( ( P2 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2) )
           => ~ aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),C2,X2),Y2),Z2) ) ) ).

% case_prodE'
tff(fact_2774_case__prodD_H,axiom,
    ! [C: $tType,B: $tType,D: $tType,R: fun(B,fun(C,fun(D,$o))),A3: B,Ba: C,C2: D] :
      ( aa(D,$o,aa(product_prod(B,C),fun(D,$o),aa(fun(B,fun(C,fun(D,$o))),fun(product_prod(B,C),fun(D,$o)),product_case_prod(B,C,fun(D,$o)),R),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba)),C2)
     => aa(D,$o,aa(C,fun(D,$o),aa(B,fun(C,fun(D,$o)),R,A3),Ba),C2) ) ).

% case_prodD'
tff(fact_2775_gcd__add__mult,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [M4: B,K: B,N: B] : ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),M4),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),K),M4)),N)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),M4),N) ) ) ).

% gcd_add_mult
tff(fact_2776_gcd__dvd__prod,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,K: B] : dvd_dvd(B,aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),K),Ba)) ) ).

% gcd_dvd_prod
tff(fact_2777_gcd__mult__unit1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3)),C2) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),Ba),C2) ) ) ) ).

% gcd_mult_unit1
tff(fact_2778_gcd__mult__unit2,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),Ba),C2) ) ) ) ).

% gcd_mult_unit2
tff(fact_2779_gcd__div__unit1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),divide_divide(B,Ba,A3)),C2) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),Ba),C2) ) ) ) ).

% gcd_div_unit1
tff(fact_2780_gcd__div__unit2,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),Ba),divide_divide(B,C2,A3)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),Ba),C2) ) ) ) ).

% gcd_div_unit2
tff(fact_2781_wait__bind__decon,axiom,
    ! [B: $tType,Pa: assn,M4: heap_Time_Heap(B),Qa: fun(B,assn),N: nat] :
      ( hoare_hoare_triple(B,Pa,M4,Qa)
     => hoare_hoare_triple(B,Pa,heap_Time_bind(product_unit,B,heap_Time_wait(N),aTP_Lamp_fm(heap_Time_Heap(B),fun(product_unit,heap_Time_Heap(B)),M4)),Qa) ) ).

% wait_bind_decon
tff(fact_2782_Gcd__fin_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,A4: set(B)] : ( aa(set(B),B,semiring_gcd_Gcd_fin(B),aa(set(B),set(B),insert2(B,A3),A4)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),aa(set(B),B,semiring_gcd_Gcd_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) ) ).

% Gcd_fin.insert_remove
tff(fact_2783_Gcd__fin_Oremove,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,A4: set(B)] :
          ( member(B,A3,A4)
         => ( aa(set(B),B,semiring_gcd_Gcd_fin(B),A4) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),aa(set(B),B,semiring_gcd_Gcd_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) ) ) ).

% Gcd_fin.remove
tff(fact_2784_wait__rule,axiom,
    ! [N: nat] : hoare_hoare_triple(product_unit,one_one(assn),heap_Time_wait(N),aTP_Lamp_ft(product_unit,assn)) ).

% wait_rule
tff(fact_2785_sum__diff1_H,axiom,
    ! [C: $tType,B: $tType] :
      ( ab_group_add(C)
     => ! [I4: set(B),Fa: fun(B,C),I: B] :
          ( aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_fo(set(B),fun(fun(B,C),fun(B,$o)),I4),Fa)))
         => ( groups1027152243600224163dd_sum(B,C,Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),I4),aa(set(B),set(B),insert2(B,I),bot_bot(set(B)))))
            = $ite(member(B,I,I4),aa(C,C,aa(C,fun(C,C),minus_minus(C),groups1027152243600224163dd_sum(B,C,Fa,I4)),aa(B,C,Fa,I)),groups1027152243600224163dd_sum(B,C,Fa,I4)) ) ) ) ).

% sum_diff1'
tff(fact_2786_lookup__chain,axiom,
    ! [C: $tType,B: $tType] :
      ( heap(C)
     => ! [R3: ref(C),Fa: heap_Time_Heap(B)] : ( heap_Time_bind(C,B,ref_lookup(C,R3),aTP_Lamp_fu(heap_Time_Heap(B),fun(C,heap_Time_Heap(B)),Fa)) = heap_Time_bind(product_unit,B,heap_Time_wait(one_one(nat)),aTP_Lamp_fm(heap_Time_Heap(B),fun(product_unit,heap_Time_Heap(B)),Fa)) ) ) ).

% lookup_chain
tff(fact_2787_bsqr__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( bNF_Wellorder_bsqr(B,R3) = aa(fun(product_prod(product_prod(B,B),product_prod(B,B)),$o),set(product_prod(product_prod(B,B),product_prod(B,B))),collect(product_prod(product_prod(B,B),product_prod(B,B))),aa(fun(product_prod(B,B),fun(product_prod(B,B),$o)),fun(product_prod(product_prod(B,B),product_prod(B,B)),$o),product_case_prod(product_prod(B,B),product_prod(B,B),$o),aa(fun(B,fun(B,fun(product_prod(B,B),$o))),fun(product_prod(B,B),fun(product_prod(B,B),$o)),product_case_prod(B,B,fun(product_prod(B,B),$o)),aTP_Lamp_fw(set(product_prod(B,B)),fun(B,fun(B,fun(product_prod(B,B),$o))),R3)))) ) ).

% bsqr_def
tff(fact_2788_Code__Numeral_Onegative__def,axiom,
    code_negative = aa(fun(num,code_integer),fun(num,code_integer),aa(fun(code_integer,code_integer),fun(fun(num,code_integer),fun(num,code_integer)),comp(code_integer,code_integer,num),uminus_uminus(code_integer)),numeral_numeral(code_integer)) ).

% Code_Numeral.negative_def
tff(fact_2789_insert__relcomp__union__fold,axiom,
    ! [D: $tType,C: $tType,B: $tType,S2: set(product_prod(B,C)),X: product_prod(D,B),X6: set(product_prod(D,C))] :
      ( aa(set(product_prod(B,C)),$o,finite_finite(product_prod(B,C)),S2)
     => ( aa(set(product_prod(D,C)),set(product_prod(D,C)),aa(set(product_prod(D,C)),fun(set(product_prod(D,C)),set(product_prod(D,C))),sup_sup(set(product_prod(D,C))),relcomp(D,B,C,aa(set(product_prod(D,B)),set(product_prod(D,B)),insert2(product_prod(D,B),X),bot_bot(set(product_prod(D,B)))),S2)),X6) = finite_fold(product_prod(B,C),set(product_prod(D,C)),aa(fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),fun(product_prod(B,C),fun(set(product_prod(D,C)),set(product_prod(D,C)))),product_case_prod(B,C,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aTP_Lamp_fx(product_prod(D,B),fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),X)),X6,S2) ) ) ).

% insert_relcomp_union_fold
tff(fact_2790_Func__map__surj,axiom,
    ! [D: $tType,B: $tType,E: $tType,C: $tType,F1: fun(C,B),A14: set(C),B1: set(B),F22: fun(D,E),B22: set(D),A23: set(E)] :
      ( ( aa(set(C),set(B),image2(C,B,F1),A14) = B1 )
     => ( inj_on(D,E,F22,B22)
       => ( aa(set(E),$o,aa(set(E),fun(set(E),$o),ord_less_eq(set(E)),aa(set(D),set(E),image2(D,E,F22),B22)),A23)
         => ( ( ( B22 = bot_bot(set(D)) )
             => ( A23 = bot_bot(set(E)) ) )
           => ( bNF_Wellorder_Func(D,B,B22,B1) = aa(set(fun(E,C)),set(fun(D,B)),image2(fun(E,C),fun(D,B),bNF_We4925052301507509544nc_map(D,C,B,E,B22,F1,F22)),bNF_Wellorder_Func(E,C,A23,A14)) ) ) ) ) ) ).

% Func_map_surj
tff(fact_2791_Func__non__emp,axiom,
    ! [B: $tType,C: $tType,B2: set(B),A4: set(C)] :
      ( ( B2 != bot_bot(set(B)) )
     => ( bNF_Wellorder_Func(C,B,A4,B2) != bot_bot(set(fun(C,B))) ) ) ).

% Func_non_emp
tff(fact_2792_fold__empty,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,fun(B,B)),Z2: B] : ( finite_fold(C,B,Fa,Z2,bot_bot(set(C))) = Z2 ) ).

% fold_empty
tff(fact_2793_gcd__nat_Osemilattice__neutr__axioms,axiom,
    semilattice_neutr(nat,gcd_gcd(nat),zero_zero(nat)) ).

% gcd_nat.semilattice_neutr_axioms
tff(fact_2794_gcd__nat_Omonoid__axioms,axiom,
    monoid(nat,gcd_gcd(nat),zero_zero(nat)) ).

% gcd_nat.monoid_axioms
tff(fact_2795_Gcd__in,axiom,
    ! [A4: set(nat)] :
      ( ! [A8: nat,B4: nat] :
          ( member(nat,A8,A4)
         => ( member(nat,B4,A4)
           => member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A8),B4),A4) ) )
     => ( ( A4 != bot_bot(set(nat)) )
       => member(nat,gcd_Gcd(nat,A4),A4) ) ) ).

% Gcd_in
tff(fact_2796_fold__image,axiom,
    ! [D: $tType,C: $tType,B: $tType,Ga: fun(B,C),A4: set(B),Fa: fun(C,fun(D,D)),Z2: D] :
      ( inj_on(B,C,Ga,A4)
     => ( finite_fold(C,D,Fa,Z2,aa(set(B),set(C),image2(B,C,Ga),A4)) = finite_fold(B,D,aa(fun(B,C),fun(B,fun(D,D)),aa(fun(C,fun(D,D)),fun(fun(B,C),fun(B,fun(D,D))),comp(C,fun(D,D),B),Fa),Ga),Z2,A4) ) ) ).

% fold_image
tff(fact_2797_sum_Oeq__fold,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(B)
     => ! [Ga: fun(C,B),A4: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),Ga),A4) = finite_fold(C,B,aa(fun(C,B),fun(C,fun(B,B)),aa(fun(B,fun(B,B)),fun(fun(C,B),fun(C,fun(B,B))),comp(B,fun(B,B),C),plus_plus(B)),Ga),zero_zero(B),A4) ) ) ).

% sum.eq_fold
tff(fact_2798_prod_Oeq__fold,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(C,B),A4: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),Ga),A4) = finite_fold(C,B,aa(fun(C,B),fun(C,fun(B,B)),aa(fun(B,fun(B,B)),fun(fun(C,B),fun(C,fun(B,B))),comp(B,fun(B,B),C),times_times(B)),Ga),one_one(B),A4) ) ) ).

% prod.eq_fold
tff(fact_2799_Inf__fin_Oeq__fold,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(set(B),set(B),insert2(B,X),A4)) = finite_fold(B,B,inf_inf(B),X,A4) ) ) ) ).

% Inf_fin.eq_fold
tff(fact_2800_Sup__fin_Oeq__fold,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),B,lattic5882676163264333800up_fin(B),aa(set(B),set(B),insert2(B,X),A4)) = finite_fold(B,B,sup_sup(B),X,A4) ) ) ) ).

% Sup_fin.eq_fold
tff(fact_2801_image__fold__insert,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,C)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( aa(set(B),set(C),image2(B,C,Fa),A4) = finite_fold(B,set(C),aTP_Lamp_fy(fun(B,C),fun(B,fun(set(C),set(C))),Fa),bot_bot(set(C)),A4) ) ) ).

% image_fold_insert
tff(fact_2802_Gcd__fin_Oeq__fold,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: set(B)] :
          ( aa(set(B),B,semiring_gcd_Gcd_fin(B),A4)
          = $ite(aa(set(B),$o,finite_finite(B),A4),finite_fold(B,B,gcd_gcd(B),zero_zero(B),A4),one_one(B)) ) ) ).

% Gcd_fin.eq_fold
tff(fact_2803_relcomp__fold,axiom,
    ! [D: $tType,C: $tType,B: $tType,R: set(product_prod(B,C)),S2: set(product_prod(C,D))] :
      ( aa(set(product_prod(B,C)),$o,finite_finite(product_prod(B,C)),R)
     => ( aa(set(product_prod(C,D)),$o,finite_finite(product_prod(C,D)),S2)
       => ( relcomp(B,C,D,R,S2) = finite_fold(product_prod(B,C),set(product_prod(B,D)),aa(fun(B,fun(C,fun(set(product_prod(B,D)),set(product_prod(B,D))))),fun(product_prod(B,C),fun(set(product_prod(B,D)),set(product_prod(B,D)))),product_case_prod(B,C,fun(set(product_prod(B,D)),set(product_prod(B,D)))),aTP_Lamp_ga(set(product_prod(C,D)),fun(B,fun(C,fun(set(product_prod(B,D)),set(product_prod(B,D))))),S2)),bot_bot(set(product_prod(B,D))),R) ) ) ) ).

% relcomp_fold
tff(fact_2804_Id__on__fold,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( id_on(B,A4) = finite_fold(B,set(product_prod(B,B)),aTP_Lamp_gb(B,fun(set(product_prod(B,B)),set(product_prod(B,B)))),bot_bot(set(product_prod(B,B))),A4) ) ) ).

% Id_on_fold
tff(fact_2805_insert__relcomp__fold,axiom,
    ! [D: $tType,C: $tType,B: $tType,S2: set(product_prod(B,C)),X: product_prod(D,B),R: set(product_prod(D,B))] :
      ( aa(set(product_prod(B,C)),$o,finite_finite(product_prod(B,C)),S2)
     => ( relcomp(D,B,C,aa(set(product_prod(D,B)),set(product_prod(D,B)),insert2(product_prod(D,B),X),R),S2) = finite_fold(product_prod(B,C),set(product_prod(D,C)),aa(fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),fun(product_prod(B,C),fun(set(product_prod(D,C)),set(product_prod(D,C)))),product_case_prod(B,C,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aTP_Lamp_fx(product_prod(D,B),fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),X)),relcomp(D,B,C,R,S2),S2) ) ) ).

% insert_relcomp_fold
tff(fact_2806_Func__is__emp,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ( bNF_Wellorder_Func(B,C,A4,B2) = bot_bot(set(fun(B,C))) )
    <=> ( ( A4 != bot_bot(set(B)) )
        & ( B2 = bot_bot(set(C)) ) ) ) ).

% Func_is_emp
tff(fact_2807_gcd__nat_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),X),Xa) = Y )
     => ( aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),gcd_nat_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa))
       => ~ ( ( Y
              = $ite(Xa = zero_zero(nat),X,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),modulo_modulo(nat,X,Xa))) )
           => ~ aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),gcd_nat_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa)) ) ) ) ).

% gcd_nat.pelims
tff(fact_2808_Set__filter__fold,axiom,
    ! [B: $tType,A4: set(B),Pa: fun(B,$o)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( filter3(B,Pa,A4) = finite_fold(B,set(B),aTP_Lamp_gc(fun(B,$o),fun(B,fun(set(B),set(B))),Pa),bot_bot(set(B)),A4) ) ) ).

% Set_filter_fold
tff(fact_2809_comp__fun__commute__relcomp__fold,axiom,
    ! [D: $tType,C: $tType,B: $tType,S2: set(product_prod(B,C))] :
      ( aa(set(product_prod(B,C)),$o,finite_finite(product_prod(B,C)),S2)
     => finite6289374366891150609ommute(product_prod(D,B),set(product_prod(D,C)),aa(fun(D,fun(B,fun(set(product_prod(D,C)),set(product_prod(D,C))))),fun(product_prod(D,B),fun(set(product_prod(D,C)),set(product_prod(D,C)))),product_case_prod(D,B,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aTP_Lamp_ge(set(product_prod(B,C)),fun(D,fun(B,fun(set(product_prod(D,C)),set(product_prod(D,C))))),S2))) ) ).

% comp_fun_commute_relcomp_fold
tff(fact_2810_bit__cut__integer__def,axiom,
    ! [K: code_integer] : ( code_bit_cut_integer(K) = aa($o,product_prod(code_integer,$o),aa(code_integer,fun($o,product_prod(code_integer,$o)),product_Pair(code_integer,$o),divide_divide(code_integer,K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)))),~ dvd_dvd(code_integer,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2)),K)) ) ).

% bit_cut_integer_def
tff(fact_2811_divmod__integer__def,axiom,
    ! [K: code_integer,L: code_integer] : ( code_divmod_integer(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),divide_divide(code_integer,K,L)),modulo_modulo(code_integer,K,L)) ) ).

% divmod_integer_def
tff(fact_2812_convol__image__vimage2p,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,Fa: fun(D,B),Ga: fun(E,C),R: fun(B,fun(C,$o))] : aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),aa(set(product_prod(D,E)),set(product_prod(B,C)),image2(product_prod(D,E),product_prod(B,C),bNF_convol(product_prod(D,E),B,C,aa(fun(product_prod(D,E),D),fun(product_prod(D,E),B),aa(fun(D,B),fun(fun(product_prod(D,E),D),fun(product_prod(D,E),B)),comp(D,B,product_prod(D,E)),Fa),product_fst(D,E)),aa(fun(product_prod(D,E),E),fun(product_prod(D,E),C),aa(fun(E,C),fun(fun(product_prod(D,E),E),fun(product_prod(D,E),C)),comp(E,C,product_prod(D,E)),Ga),product_snd(D,E)))),aa(fun(product_prod(D,E),$o),set(product_prod(D,E)),collect(product_prod(D,E)),aa(fun(D,fun(E,$o)),fun(product_prod(D,E),$o),product_case_prod(D,E,$o),aa(fun(B,fun(C,$o)),fun(D,fun(E,$o)),bNF_vimage2p(D,B,E,C,$o,Fa,Ga),R))))),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),R))) ).

% convol_image_vimage2p
tff(fact_2813_comp__fun__commute_Ointro,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C))] :
      ( ! [Y2: B,X2: B] : ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y2)),aa(B,fun(C,C),Fa,X2)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,Y2)) )
     => finite6289374366891150609ommute(B,C,Fa) ) ).

% comp_fun_commute.intro
tff(fact_2814_comp__fun__commute_Ocomp__fun__commute,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C)),Y: B,X: B] :
      ( finite6289374366891150609ommute(B,C,Fa)
     => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y)),aa(B,fun(C,C),Fa,X)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X)),aa(B,fun(C,C),Fa,Y)) ) ) ).

% comp_fun_commute.comp_fun_commute
tff(fact_2815_comp__fun__commute__def,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C))] :
      ( finite6289374366891150609ommute(B,C,Fa)
    <=> ! [Y3: B,X4: B] : ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y3)),aa(B,fun(C,C),Fa,X4)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X4)),aa(B,fun(C,C),Fa,Y3)) ) ) ).

% comp_fun_commute_def
tff(fact_2816_comp__fun__commute_Ocomp__comp__fun__commute,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(B,fun(C,C)),Ga: fun(D,B)] :
      ( finite6289374366891150609ommute(B,C,Fa)
     => finite6289374366891150609ommute(D,C,aa(fun(D,B),fun(D,fun(C,C)),aa(fun(B,fun(C,C)),fun(fun(D,B),fun(D,fun(C,C))),comp(B,fun(C,C),D),Fa),Ga)) ) ).

% comp_fun_commute.comp_comp_fun_commute
tff(fact_2817_vimage2p__comp,axiom,
    ! [F7: $tType,E: $tType,G: $tType,B: $tType,D: $tType,C: $tType,H7: $tType,F1: fun(G,B),F22: fun(E,G),G1: fun(H7,C),G22: fun(F7,H7)] : ( bNF_vimage2p(E,B,F7,C,D,aa(fun(E,G),fun(E,B),aa(fun(G,B),fun(fun(E,G),fun(E,B)),comp(G,B,E),F1),F22),aa(fun(F7,H7),fun(F7,C),aa(fun(H7,C),fun(fun(F7,H7),fun(F7,C)),comp(H7,C,F7),G1),G22)) = aa(fun(fun(B,fun(C,D)),fun(G,fun(H7,D))),fun(fun(B,fun(C,D)),fun(E,fun(F7,D))),aa(fun(fun(G,fun(H7,D)),fun(E,fun(F7,D))),fun(fun(fun(B,fun(C,D)),fun(G,fun(H7,D))),fun(fun(B,fun(C,D)),fun(E,fun(F7,D)))),comp(fun(G,fun(H7,D)),fun(E,fun(F7,D)),fun(B,fun(C,D))),bNF_vimage2p(E,G,F7,H7,D,F22,G22)),bNF_vimage2p(G,B,H7,C,D,F1,G1)) ) ).

% vimage2p_comp
tff(fact_2818_inter__Set__filter,axiom,
    ! [B: $tType,B2: set(B),A4: set(B)] :
      ( aa(set(B),$o,finite_finite(B),B2)
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = filter3(B,aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),A4),B2) ) ) ).

% inter_Set_filter
tff(fact_2819_comp__fun__commute__product__fold,axiom,
    ! [C: $tType,B: $tType,B2: set(B)] :
      ( aa(set(B),$o,finite_finite(B),B2)
     => finite6289374366891150609ommute(C,set(product_prod(C,B)),aTP_Lamp_gg(set(B),fun(C,fun(set(product_prod(C,B)),set(product_prod(C,B)))),B2)) ) ).

% comp_fun_commute_product_fold
tff(fact_2820_bit__cut__integer__code,axiom,
    ! [K: code_integer] :
      ( code_bit_cut_integer(K)
      = $ite(K = zero_zero(code_integer),aa($o,product_prod(code_integer,$o),aa(code_integer,fun($o,product_prod(code_integer,$o)),product_Pair(code_integer,$o),zero_zero(code_integer)),$false),aa(product_prod(code_integer,code_integer),product_prod(code_integer,$o),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,$o)),product_case_prod(code_integer,code_integer,product_prod(code_integer,$o)),aTP_Lamp_gh(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),K)),code_divmod_abs(K,aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))))) ) ).

% bit_cut_integer_code
tff(fact_2821_divmod__integer__eq__cases,axiom,
    ! [K: code_integer,L: code_integer] :
      ( code_divmod_integer(K,L)
      = $ite(
          K = zero_zero(code_integer),
          aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)),
          $ite(
            L = zero_zero(code_integer),
            aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),K),
            aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),aa(fun(code_integer,code_integer),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),aa(fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),fun(fun(code_integer,code_integer),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)))),comp(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer),aa(fun(code_integer,fun(code_integer,code_integer)),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),aa(fun(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),fun(fun(code_integer,fun(code_integer,code_integer)),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)))),comp(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer),product_apsnd(code_integer,code_integer,code_integer)),times_times(code_integer))),sgn_sgn(code_integer)),L),$ite(aa(code_integer,code_integer,sgn_sgn(code_integer),K) = aa(code_integer,code_integer,sgn_sgn(code_integer),L),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gi(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ).

% divmod_integer_eq_cases
tff(fact_2822_divmod__integer__code,axiom,
    ! [K: code_integer,L: code_integer] :
      ( code_divmod_integer(K,L)
      = $ite(
          K = zero_zero(code_integer),
          aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)),
          $ite(
            aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),L),
            $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),K),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gj(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L))),
            $ite(
              L = zero_zero(code_integer),
              aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),K),
              aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_apsnd(code_integer,code_integer,code_integer),uminus_uminus(code_integer)),$ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gk(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ).

% divmod_integer_code
tff(fact_2823_inverse__rat_Otransfer,axiom,
    aa(fun(rat,rat),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(rat,rat),$o),bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat),aTP_Lamp_gl(product_prod(int,int),product_prod(int,int))),inverse_inverse(rat)) ).

% inverse_rat.transfer
tff(fact_2824_max__extp__max__ext__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),X3: set(B),Xa3: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),max_extp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R)),X3),Xa3)
    <=> member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),X3),Xa3),max_ext(B,R)) ) ).

% max_extp_max_ext_eq
tff(fact_2825_same__fst__def,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),R: fun(B,set(product_prod(C,C)))] : ( same_fst(B,C,Pa,R) = aa(fun(product_prod(product_prod(B,C),product_prod(B,C)),$o),set(product_prod(product_prod(B,C),product_prod(B,C))),collect(product_prod(product_prod(B,C),product_prod(B,C))),aa(fun(product_prod(B,C),fun(product_prod(B,C),$o)),fun(product_prod(product_prod(B,C),product_prod(B,C)),$o),product_case_prod(product_prod(B,C),product_prod(B,C),$o),aa(fun(B,fun(C,fun(product_prod(B,C),$o))),fun(product_prod(B,C),fun(product_prod(B,C),$o)),product_case_prod(B,C,fun(product_prod(B,C),$o)),aa(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(product_prod(B,C),$o))),aTP_Lamp_gn(fun(B,$o),fun(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(product_prod(B,C),$o)))),Pa),R)))) ) ).

% same_fst_def
tff(fact_2826_same__fstI,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),X: B,Y6: C,Y: C,R: fun(B,set(product_prod(C,C)))] :
      ( aa(B,$o,Pa,X)
     => ( member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Y6),Y),aa(B,set(product_prod(C,C)),R,X))
       => member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y6)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)),same_fst(B,C,Pa,R)) ) ) ).

% same_fstI
tff(fact_2827_power__transfer,axiom,
    ! [B: $tType,C: $tType] :
      ( ( power(C)
        & power(B) )
     => ! [R: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),R,one_one(B)),one_one(C))
         => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),R,bNF_rel_fun(B,C,B,C,R,R)),times_times(B)),times_times(C))
           => aa(fun(C,fun(nat,C)),$o,aa(fun(B,fun(nat,B)),fun(fun(C,fun(nat,C)),$o),bNF_rel_fun(B,C,fun(nat,B),fun(nat,C),R,bNF_rel_fun(nat,nat,B,C,fequal(nat),R)),power_power(B)),power_power(C)) ) ) ) ).

% power_transfer
tff(fact_2828_transfer__rule__numeral,axiom,
    ! [B: $tType,C: $tType] :
      ( ( monoid_add(C)
        & semiring_numeral(C)
        & monoid_add(B)
        & semiring_numeral(B) )
     => ! [R: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),R,zero_zero(B)),zero_zero(C))
         => ( aa(C,$o,aa(B,fun(C,$o),R,one_one(B)),one_one(C))
           => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),R,bNF_rel_fun(B,C,B,C,R,R)),plus_plus(B)),plus_plus(C))
             => aa(fun(num,C),$o,aa(fun(num,B),fun(fun(num,C),$o),bNF_rel_fun(num,num,B,C,fequal(num),R),numeral_numeral(B)),numeral_numeral(C)) ) ) ) ) ).

% transfer_rule_numeral
tff(fact_2829_fun_Omap__transfer,axiom,
    ! [B: $tType,C: $tType,F7: $tType,E: $tType,D: $tType,Rb2: fun(B,fun(D,$o)),Sd: fun(C,fun(E,$o))] : aa(fun(fun(D,E),fun(fun(F7,D),fun(F7,E))),$o,aa(fun(fun(B,C),fun(fun(F7,B),fun(F7,C))),fun(fun(fun(D,E),fun(fun(F7,D),fun(F7,E))),$o),bNF_rel_fun(fun(B,C),fun(D,E),fun(fun(F7,B),fun(F7,C)),fun(fun(F7,D),fun(F7,E)),bNF_rel_fun(B,D,C,E,Rb2,Sd),bNF_rel_fun(fun(F7,B),fun(F7,D),fun(F7,C),fun(F7,E),bNF_rel_fun(F7,F7,B,D,fequal(F7),Rb2),bNF_rel_fun(F7,F7,C,E,fequal(F7),Sd))),comp(B,C,F7)),comp(D,E,F7)) ).

% fun.map_transfer
tff(fact_2830_comp__transfer,axiom,
    ! [B: $tType,C: $tType,F7: $tType,G: $tType,E: $tType,D: $tType,B2: fun(B,fun(D,$o)),C3: fun(C,fun(E,$o)),A4: fun(F7,fun(G,$o))] : aa(fun(fun(D,E),fun(fun(G,D),fun(G,E))),$o,aa(fun(fun(B,C),fun(fun(F7,B),fun(F7,C))),fun(fun(fun(D,E),fun(fun(G,D),fun(G,E))),$o),bNF_rel_fun(fun(B,C),fun(D,E),fun(fun(F7,B),fun(F7,C)),fun(fun(G,D),fun(G,E)),bNF_rel_fun(B,D,C,E,B2,C3),bNF_rel_fun(fun(F7,B),fun(G,D),fun(F7,C),fun(G,E),bNF_rel_fun(F7,G,B,D,A4,B2),bNF_rel_fun(F7,G,C,E,A4,C3))),comp(B,C,F7)),comp(D,E,G)) ).

% comp_transfer
tff(fact_2831_transfer__rule__of__int,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ring_1(C)
        & ring_1(B) )
     => ! [R: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),R,zero_zero(B)),zero_zero(C))
         => ( aa(C,$o,aa(B,fun(C,$o),R,one_one(B)),one_one(C))
           => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),R,bNF_rel_fun(B,C,B,C,R,R)),plus_plus(B)),plus_plus(C))
             => ( aa(fun(C,C),$o,aa(fun(B,B),fun(fun(C,C),$o),bNF_rel_fun(B,C,B,C,R,R),uminus_uminus(B)),uminus_uminus(C))
               => aa(fun(int,C),$o,aa(fun(int,B),fun(fun(int,C),$o),bNF_rel_fun(int,int,B,C,fequal(int),R),ring_1_of_int(B)),ring_1_of_int(C)) ) ) ) ) ) ).

% transfer_rule_of_int
tff(fact_2832_fun_Orel__map_I2_J,axiom,
    ! [C: $tType,D: $tType,E: $tType,B: $tType,Sa: fun(C,fun(D,$o)),X: fun(B,C),Ga: fun(E,D),Y: fun(B,E)] :
      ( aa(fun(B,D),$o,aa(fun(B,C),fun(fun(B,D),$o),bNF_rel_fun(B,B,C,D,fequal(B),Sa),X),aa(fun(B,E),fun(B,D),aa(fun(E,D),fun(fun(B,E),fun(B,D)),comp(E,D,B),Ga),Y))
    <=> aa(fun(B,E),$o,aa(fun(B,C),fun(fun(B,E),$o),bNF_rel_fun(B,B,C,E,fequal(B),aa(fun(E,D),fun(C,fun(E,$o)),aTP_Lamp_go(fun(C,fun(D,$o)),fun(fun(E,D),fun(C,fun(E,$o))),Sa),Ga)),X),Y) ) ).

% fun.rel_map(2)
tff(fact_2833_fun_Orel__map_I1_J,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,Sb: fun(C,fun(D,$o)),I: fun(E,C),X: fun(B,E),Y: fun(B,D)] :
      ( aa(fun(B,D),$o,aa(fun(B,C),fun(fun(B,D),$o),bNF_rel_fun(B,B,C,D,fequal(B),Sb),aa(fun(B,E),fun(B,C),aa(fun(E,C),fun(fun(B,E),fun(B,C)),comp(E,C,B),I),X)),Y)
    <=> aa(fun(B,D),$o,aa(fun(B,E),fun(fun(B,D),$o),bNF_rel_fun(B,B,E,D,fequal(B),aa(fun(E,C),fun(E,fun(D,$o)),aTP_Lamp_gp(fun(C,fun(D,$o)),fun(fun(E,C),fun(E,fun(D,$o))),Sb),I)),X),Y) ) ).

% fun.rel_map(1)
tff(fact_2834_divmod__abs__code_I5_J,axiom,
    ! [J2: code_integer] : ( code_divmod_abs(J2,zero_zero(code_integer)) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),aa(code_integer,code_integer,abs_abs(code_integer),J2)) ) ).

% divmod_abs_code(5)
tff(fact_2835_divmod__abs__code_I6_J,axiom,
    ! [J2: code_integer] : ( code_divmod_abs(zero_zero(code_integer),J2) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ) ).

% divmod_abs_code(6)
tff(fact_2836_rel__fun__Collect__case__prodD,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,A4: fun(B,fun(C,$o)),B2: fun(D,fun(E,$o)),Fa: fun(B,D),Ga: fun(C,E),X6: set(product_prod(B,C)),X: product_prod(B,C)] :
      ( aa(fun(C,E),$o,aa(fun(B,D),fun(fun(C,E),$o),bNF_rel_fun(B,C,D,E,A4,B2),Fa),Ga)
     => ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),X6),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),A4)))
       => ( member(product_prod(B,C),X,X6)
         => aa(E,$o,aa(D,fun(E,$o),B2,aa(product_prod(B,C),D,aa(fun(product_prod(B,C),B),fun(product_prod(B,C),D),aa(fun(B,D),fun(fun(product_prod(B,C),B),fun(product_prod(B,C),D)),comp(B,D,product_prod(B,C)),Fa),product_fst(B,C)),X)),aa(product_prod(B,C),E,aa(fun(product_prod(B,C),C),fun(product_prod(B,C),E),aa(fun(C,E),fun(fun(product_prod(B,C),C),fun(product_prod(B,C),E)),comp(C,E,product_prod(B,C)),Ga),product_snd(B,C)),X)) ) ) ) ).

% rel_fun_Collect_case_prodD
tff(fact_2837_max__ext__def,axiom,
    ! [B: $tType,X3: set(product_prod(B,B))] : ( max_ext(B,X3) = aa(fun(product_prod(set(B),set(B)),$o),set(product_prod(set(B),set(B))),collect(product_prod(set(B),set(B))),aa(fun(set(B),fun(set(B),$o)),fun(product_prod(set(B),set(B)),$o),product_case_prod(set(B),set(B),$o),max_extp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),X3)))) ) ).

% max_ext_def
tff(fact_2838_divmod__abs__def,axiom,
    ! [K: code_integer,L: code_integer] : ( code_divmod_abs(K,L) = aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),divide_divide(code_integer,aa(code_integer,code_integer,abs_abs(code_integer),K),aa(code_integer,code_integer,abs_abs(code_integer),L))),modulo_modulo(code_integer,aa(code_integer,code_integer,abs_abs(code_integer),K),aa(code_integer,code_integer,abs_abs(code_integer),L))) ) ).

% divmod_abs_def
tff(fact_2839_uminus__rat_Otransfer,axiom,
    aa(fun(rat,rat),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(rat,rat),$o),bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat),aTP_Lamp_gq(product_prod(int,int),product_prod(int,int))),uminus_uminus(rat)) ).

% uminus_rat.transfer
tff(fact_2840_fun_Oin__rel,axiom,
    ! [C: $tType,D: $tType,B: $tType,R: fun(C,fun(D,$o)),A3: fun(B,C),Ba: fun(B,D)] :
      ( aa(fun(B,D),$o,aa(fun(B,C),fun(fun(B,D),$o),bNF_rel_fun(B,B,C,D,fequal(B),R),A3),Ba)
    <=> ? [Z4: fun(B,product_prod(C,D))] :
          ( member(fun(B,product_prod(C,D)),Z4,aa(fun(fun(B,product_prod(C,D)),$o),set(fun(B,product_prod(C,D))),collect(fun(B,product_prod(C,D))),aTP_Lamp_gr(fun(C,fun(D,$o)),fun(fun(B,product_prod(C,D)),$o),R)))
          & ( aa(fun(B,product_prod(C,D)),fun(B,C),aa(fun(product_prod(C,D),C),fun(fun(B,product_prod(C,D)),fun(B,C)),comp(product_prod(C,D),C,B),product_fst(C,D)),Z4) = A3 )
          & ( aa(fun(B,product_prod(C,D)),fun(B,D),aa(fun(product_prod(C,D),D),fun(fun(B,product_prod(C,D)),fun(B,D)),comp(product_prod(C,D),D,B),product_snd(C,D)),Z4) = Ba ) ) ) ).

% fun.in_rel
tff(fact_2841_max__extp__eq,axiom,
    ! [B: $tType,R3: fun(B,fun(B,$o)),X: set(B),Y: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),max_extp(B,R3),X),Y)
    <=> member(product_prod(set(B),set(B)),aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),X),Y),max_ext(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R3)))) ) ).

% max_extp_eq
tff(fact_2842_transfer__rule__of__nat,axiom,
    ! [B: $tType,C: $tType] :
      ( ( semiring_1(C)
        & semiring_1(B) )
     => ! [R: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),R,zero_zero(B)),zero_zero(C))
         => ( aa(C,$o,aa(B,fun(C,$o),R,one_one(B)),one_one(C))
           => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),R,bNF_rel_fun(B,C,B,C,R,R)),plus_plus(B)),plus_plus(C))
             => aa(fun(nat,C),$o,aa(fun(nat,B),fun(fun(nat,C),$o),bNF_rel_fun(nat,nat,B,C,fequal(nat),R),semiring_1_of_nat(B)),semiring_1_of_nat(C)) ) ) ) ) ).

% transfer_rule_of_nat
tff(fact_2843_plus__rat_Otransfer,axiom,
    aa(fun(rat,fun(rat,rat)),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(rat,fun(rat,rat)),$o),bNF_rel_fun(product_prod(int,int),rat,fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),pcr_rat,bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat)),aTP_Lamp_gs(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),plus_plus(rat)) ).

% plus_rat.transfer
tff(fact_2844_times__rat_Otransfer,axiom,
    aa(fun(rat,fun(rat,rat)),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(rat,fun(rat,rat)),$o),bNF_rel_fun(product_prod(int,int),rat,fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),pcr_rat,bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat)),aTP_Lamp_gt(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),times_times(rat)) ).

% times_rat.transfer
tff(fact_2845_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C)),A4: set(B),B2: set(B),Z2: C] :
      ( finite4664212375090638736ute_on(B,C,S2,Fa)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),S2)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),S2)
         => ( aa(set(B),$o,finite_finite(B),A4)
           => ( aa(set(B),$o,finite_finite(B),B2)
             => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) )
               => ( finite_fold(B,C,Fa,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = finite_fold(B,C,Fa,finite_fold(B,C,Fa,Z2,A4),B2) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
tff(fact_2846_comp__fun__commute__on_Ofold__rec,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C)),A4: set(B),X: B,Z2: C] :
      ( finite4664212375090638736ute_on(B,C,S2,Fa)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),S2)
       => ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( finite_fold(B,C,Fa,Z2,A4) = aa(C,C,aa(B,fun(C,C),Fa,X),finite_fold(B,C,Fa,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
tff(fact_2847_comp__fun__commute__on_Ointro,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C))] :
      ( ! [X2: B,Y2: B] :
          ( member(B,X2,S2)
         => ( member(B,Y2,S2)
           => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y2)),aa(B,fun(C,C),Fa,X2)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,Y2)) ) ) )
     => finite4664212375090638736ute_on(B,C,S2,Fa) ) ).

% comp_fun_commute_on.intro
tff(fact_2848_comp__fun__commute__on_Ocommute__left__comp,axiom,
    ! [B: $tType,C: $tType,D: $tType,S2: set(B),Fa: fun(B,fun(C,C)),X: B,Y: B,Ga: fun(D,C)] :
      ( finite4664212375090638736ute_on(B,C,S2,Fa)
     => ( member(B,X,S2)
       => ( member(B,Y,S2)
         => ( aa(fun(D,C),fun(D,C),aa(fun(C,C),fun(fun(D,C),fun(D,C)),comp(C,C,D),aa(B,fun(C,C),Fa,Y)),aa(fun(D,C),fun(D,C),aa(fun(C,C),fun(fun(D,C),fun(D,C)),comp(C,C,D),aa(B,fun(C,C),Fa,X)),Ga)) = aa(fun(D,C),fun(D,C),aa(fun(C,C),fun(fun(D,C),fun(D,C)),comp(C,C,D),aa(B,fun(C,C),Fa,X)),aa(fun(D,C),fun(D,C),aa(fun(C,C),fun(fun(D,C),fun(D,C)),comp(C,C,D),aa(B,fun(C,C),Fa,Y)),Ga)) ) ) ) ) ).

% comp_fun_commute_on.commute_left_comp
tff(fact_2849_comp__fun__commute__on_Ocomp__fun__commute__on,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C)),X: B,Y: B] :
      ( finite4664212375090638736ute_on(B,C,S2,Fa)
     => ( member(B,X,S2)
       => ( member(B,Y,S2)
         => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y)),aa(B,fun(C,C),Fa,X)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X)),aa(B,fun(C,C),Fa,Y)) ) ) ) ) ).

% comp_fun_commute_on.comp_fun_commute_on
tff(fact_2850_comp__fun__commute__on__def,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C))] :
      ( finite4664212375090638736ute_on(B,C,S2,Fa)
    <=> ! [X4: B,Y3: B] :
          ( member(B,X4,S2)
         => ( member(B,Y3,S2)
           => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y3)),aa(B,fun(C,C),Fa,X4)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X4)),aa(B,fun(C,C),Fa,Y3)) ) ) ) ) ).

% comp_fun_commute_on_def
tff(fact_2851_Fract_Orsp,axiom,
    aa(fun(int,fun(int,product_prod(int,int))),$o,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,product_prod(int,int))),$o),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,product_prod(int,int)),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),product_prod(int,int),fequal(int),ratrel)),aTP_Lamp_gu(int,fun(int,product_prod(int,int)))),aTP_Lamp_gu(int,fun(int,product_prod(int,int)))) ).

% Fract.rsp
tff(fact_2852_transfer__rule__of__bool,axiom,
    ! [B: $tType,C: $tType] :
      ( ( zero_neq_one(C)
        & zero_neq_one(B) )
     => ! [R: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),R,zero_zero(B)),zero_zero(C))
         => ( aa(C,$o,aa(B,fun(C,$o),R,one_one(B)),one_one(C))
           => aa(fun($o,C),$o,aa(fun($o,B),fun(fun($o,C),$o),bNF_rel_fun($o,$o,B,C,fequal($o),R),zero_neq_one_of_bool(B)),zero_neq_one_of_bool(C)) ) ) ) ).

% transfer_rule_of_bool
tff(fact_2853_times__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(product_prod(int,int),product_prod(int,int)),ratrel,bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel)),aTP_Lamp_gt(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),aTP_Lamp_gt(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% times_rat.rsp
tff(fact_2854_plus__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),plus_plus(int)) ).

% plus_int.transfer
tff(fact_2855_minus__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),minus_minus(int)) ).

% minus_int.transfer
tff(fact_2856_plus__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(product_prod(int,int),product_prod(int,int)),ratrel,bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel)),aTP_Lamp_gs(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),aTP_Lamp_gs(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% plus_rat.rsp
tff(fact_2857_times__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),times_times(int)) ).

% times_int.transfer
tff(fact_2858_int__transfer,axiom,
    aa(fun(nat,int),$o,aa(fun(nat,product_prod(nat,nat)),fun(fun(nat,int),$o),bNF_rel_fun(nat,nat,product_prod(nat,nat),int,fequal(nat),pcr_int),aTP_Lamp_hb(nat,product_prod(nat,nat))),semiring_1_of_nat(int)) ).

% int_transfer
tff(fact_2859_uminus__int_Otransfer,axiom,
    aa(fun(int,int),$o,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(int,int),$o),bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat))))),uminus_uminus(int)) ).

% uminus_int.transfer
tff(fact_2860_comp__fun__commute__on_Ocomp__comp__fun__commute__on,axiom,
    ! [C: $tType,B: $tType,D: $tType,S2: set(B),Fa: fun(B,fun(C,C)),Ga: fun(D,B),R: set(D)] :
      ( finite4664212375090638736ute_on(B,C,S2,Fa)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(D),set(B),image2(D,B,Ga),top_top(set(D)))),S2)
       => finite4664212375090638736ute_on(D,C,R,aa(fun(D,B),fun(D,fun(C,C)),aa(fun(B,fun(C,C)),fun(fun(D,B),fun(D,fun(C,C))),comp(B,fun(C,C),D),Fa),Ga)) ) ) ).

% comp_fun_commute_on.comp_comp_fun_commute_on
tff(fact_2861_uminus__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),product_prod(int,int)),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(product_prod(int,int),product_prod(int,int)),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel),aTP_Lamp_gq(product_prod(int,int),product_prod(int,int))),aTP_Lamp_gq(product_prod(int,int),product_prod(int,int))) ).

% uminus_rat.rsp
tff(fact_2862_inverse__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),product_prod(int,int)),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(product_prod(int,int),product_prod(int,int)),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel),aTP_Lamp_gl(product_prod(int,int),product_prod(int,int))),aTP_Lamp_gl(product_prod(int,int),product_prod(int,int))) ).

% inverse_rat.rsp
tff(fact_2863_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C)),X: B,A4: set(B),Z2: C] :
      ( finite4664212375090638736ute_on(B,C,S2,Fa)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,X),A4)),S2)
       => ( aa(set(B),$o,finite_finite(B),A4)
         => ( finite_fold(B,C,Fa,Z2,aa(set(B),set(B),insert2(B,X),A4)) = aa(C,C,aa(B,fun(C,C),Fa,X),finite_fold(B,C,Fa,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
tff(fact_2864_o__rsp_I2_J,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,R12: fun(D,fun(E,$o))] : aa(fun(fun(B,C),fun(fun(E,B),fun(E,C))),$o,aa(fun(fun(B,C),fun(fun(D,B),fun(D,C))),fun(fun(fun(B,C),fun(fun(E,B),fun(E,C))),$o),bNF_rel_fun(fun(B,C),fun(B,C),fun(fun(D,B),fun(D,C)),fun(fun(E,B),fun(E,C)),fequal(fun(B,C)),bNF_rel_fun(fun(D,B),fun(E,B),fun(D,C),fun(E,C),bNF_rel_fun(D,E,B,B,R12,fequal(B)),bNF_rel_fun(D,E,C,C,R12,fequal(C)))),comp(B,C,D)),comp(B,C,E)) ).

% o_rsp(2)
tff(fact_2865_o__rsp_I1_J,axiom,
    ! [B: $tType,C: $tType,F7: $tType,G: $tType,E: $tType,D: $tType,R23: fun(B,fun(D,$o)),R32: fun(C,fun(E,$o)),R12: fun(F7,fun(G,$o))] : aa(fun(fun(D,E),fun(fun(G,D),fun(G,E))),$o,aa(fun(fun(B,C),fun(fun(F7,B),fun(F7,C))),fun(fun(fun(D,E),fun(fun(G,D),fun(G,E))),$o),bNF_rel_fun(fun(B,C),fun(D,E),fun(fun(F7,B),fun(F7,C)),fun(fun(G,D),fun(G,E)),bNF_rel_fun(B,D,C,E,R23,R32),bNF_rel_fun(fun(F7,B),fun(G,D),fun(F7,C),fun(G,E),bNF_rel_fun(F7,G,B,D,R12,R23),bNF_rel_fun(F7,G,C,E,R12,R32))),comp(B,C,F7)),comp(D,E,G)) ).

% o_rsp(1)
tff(fact_2866_mlex__eq,axiom,
    ! [B: $tType,Fa: fun(B,nat),R: set(product_prod(B,B))] : ( mlex_prod(B,Fa,R) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aTP_Lamp_hd(fun(B,nat),fun(set(product_prod(B,B)),fun(B,fun(B,$o))),Fa),R))) ) ).

% mlex_eq
tff(fact_2867_update__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [P2: ref(B),Y: B,X: B] : hoare_hoare_triple(product_unit,sngr_assn(B,P2,Y),ref_update(B,P2,X),aa(B,fun(product_unit,assn),aTP_Lamp_he(ref(B),fun(B,fun(product_unit,assn)),P2),X)) ) ).

% update_rule
tff(fact_2868_enumerate__Suc,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [S2: set(B),N: nat] : ( infini527867602293511546merate(B,S2,aa(nat,nat,suc,N)) = infini527867602293511546merate(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,ord_Least(B,aTP_Lamp_hf(set(B),fun(B,$o),S2))),bot_bot(set(B)))),N) ) ) ).

% enumerate_Suc
tff(fact_2869_LeastI,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),K: B] :
          ( aa(B,$o,Pa,K)
         => aa(B,$o,Pa,ord_Least(B,Pa)) ) ) ).

% LeastI
tff(fact_2870_LeastI2__ex,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),Qa: fun(B,$o)] :
          ( ? [X_13: B] : aa(B,$o,Pa,X_13)
         => ( ! [X2: B] :
                ( aa(B,$o,Pa,X2)
               => aa(B,$o,Qa,X2) )
           => aa(B,$o,Qa,ord_Least(B,Pa)) ) ) ) ).

% LeastI2_ex
tff(fact_2871_LeastI__ex,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o)] :
          ( ? [X_13: B] : aa(B,$o,Pa,X_13)
         => aa(B,$o,Pa,ord_Least(B,Pa)) ) ) ).

% LeastI_ex
tff(fact_2872_LeastI2,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),A3: B,Qa: fun(B,$o)] :
          ( aa(B,$o,Pa,A3)
         => ( ! [X2: B] :
                ( aa(B,$o,Pa,X2)
               => aa(B,$o,Qa,X2) )
           => aa(B,$o,Qa,ord_Least(B,Pa)) ) ) ) ).

% LeastI2
tff(fact_2873_LeastI2__wellorder__ex,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),Qa: fun(B,$o)] :
          ( ? [X_13: B] : aa(B,$o,Pa,X_13)
         => ( ! [A8: B] :
                ( aa(B,$o,Pa,A8)
               => ( ! [B9: B] :
                      ( aa(B,$o,Pa,B9)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A8),B9) )
                 => aa(B,$o,Qa,A8) ) )
           => aa(B,$o,Qa,ord_Least(B,Pa)) ) ) ) ).

% LeastI2_wellorder_ex
tff(fact_2874_LeastI2__wellorder,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),A3: B,Qa: fun(B,$o)] :
          ( aa(B,$o,Pa,A3)
         => ( ! [A8: B] :
                ( aa(B,$o,Pa,A8)
               => ( ! [B9: B] :
                      ( aa(B,$o,Pa,B9)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A8),B9) )
                 => aa(B,$o,Qa,A8) ) )
           => aa(B,$o,Qa,ord_Least(B,Pa)) ) ) ) ).

% LeastI2_wellorder
tff(fact_2875_Least__equality,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o),X: B] :
          ( aa(B,$o,Pa,X)
         => ( ! [Y2: B] :
                ( aa(B,$o,Pa,Y2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y2) )
           => ( ord_Least(B,Pa) = X ) ) ) ) ).

% Least_equality
tff(fact_2876_LeastI2__order,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o),X: B,Qa: fun(B,$o)] :
          ( aa(B,$o,Pa,X)
         => ( ! [Y2: B] :
                ( aa(B,$o,Pa,Y2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y2) )
           => ( ! [X2: B] :
                  ( aa(B,$o,Pa,X2)
                 => ( ! [Y4: B] :
                        ( aa(B,$o,Pa,Y4)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y4) )
                   => aa(B,$o,Qa,X2) ) )
             => aa(B,$o,Qa,ord_Least(B,Pa)) ) ) ) ) ).

% LeastI2_order
tff(fact_2877_Least1__le,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o),Z2: B] :
          ( ? [X3: B] :
              ( aa(B,$o,Pa,X3)
              & ! [Y2: B] :
                  ( aa(B,$o,Pa,Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),Y2) )
              & ! [Y2: B] :
                  ( ( aa(B,$o,Pa,Y2)
                    & ! [Ya2: B] :
                        ( aa(B,$o,Pa,Ya2)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),Ya2) ) )
                 => ( Y2 = X3 ) ) )
         => ( aa(B,$o,Pa,Z2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),ord_Least(B,Pa)),Z2) ) ) ) ).

% Least1_le
tff(fact_2878_Least1I,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o)] :
          ( ? [X3: B] :
              ( aa(B,$o,Pa,X3)
              & ! [Y2: B] :
                  ( aa(B,$o,Pa,Y2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),Y2) )
              & ! [Y2: B] :
                  ( ( aa(B,$o,Pa,Y2)
                    & ! [Ya2: B] :
                        ( aa(B,$o,Pa,Ya2)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),Ya2) ) )
                 => ( Y2 = X3 ) ) )
         => aa(B,$o,Pa,ord_Least(B,Pa)) ) ) ).

% Least1I
tff(fact_2879_Least__le,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Pa: fun(B,$o),K: B] :
          ( aa(B,$o,Pa,K)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),ord_Least(B,Pa)),K) ) ) ).

% Least_le
tff(fact_2880_not__less__Least,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [K: B,Pa: fun(B,$o)] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),K),ord_Least(B,Pa))
         => ~ aa(B,$o,Pa,K) ) ) ).

% not_less_Least
tff(fact_2881_mlex__iff,axiom,
    ! [B: $tType,X: B,Y: B,Fa: fun(B,nat),R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),mlex_prod(B,Fa,R))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,Fa,X)),aa(B,nat,Fa,Y))
        | ( ( aa(B,nat,Fa,X) = aa(B,nat,Fa,Y) )
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R) ) ) ) ).

% mlex_iff
tff(fact_2882_mlex__less,axiom,
    ! [B: $tType,Fa: fun(B,nat),X: B,Y: B,R: set(product_prod(B,B))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,Fa,X)),aa(B,nat,Fa,Y))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),mlex_prod(B,Fa,R)) ) ).

% mlex_less
tff(fact_2883_mlex__leq,axiom,
    ! [B: $tType,Fa: fun(B,nat),X: B,Y: B,R: set(product_prod(B,B))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(B,nat,Fa,X)),aa(B,nat,Fa,Y))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),mlex_prod(B,Fa,R)) ) ) ).

% mlex_leq
tff(fact_2884_change__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Fa: fun(B,B),R3: ref(B)] : ( ref_change(B,Fa,R3) = heap_Time_bind(B,B,ref_lookup(B,R3),aa(ref(B),fun(B,heap_Time_Heap(B)),aTP_Lamp_hh(fun(B,B),fun(ref(B),fun(B,heap_Time_Heap(B))),Fa),R3)) ) ) ).

% change_def
tff(fact_2885_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X)) ) ).

% times_int.abs_eq
tff(fact_2886_update__wp__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),Y: B,X: B,Qa: fun(product_unit,assn)] : hoare_hoare_triple(product_unit,aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),sngr_assn(B,R3,Y)),wand_assn(sngr_assn(B,R3,X),aa(product_unit,assn,Qa,product_Unity))),ref_update(B,R3,X),Qa) ) ).

% update_wp_rule
tff(fact_2887_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X)) ) ).

% minus_int.abs_eq
tff(fact_2888_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),X: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),X)) ) ).

% plus_int.abs_eq
tff(fact_2889_UNIV__unit,axiom,
    top_top(set(product_unit)) = aa(set(product_unit),set(product_unit),insert2(product_unit,product_Unity),bot_bot(set(product_unit))) ).

% UNIV_unit
tff(fact_2890_bot__unit__def,axiom,
    bot_bot(product_unit) = product_Unity ).

% bot_unit_def
tff(fact_2891_inf__unit__def,axiom,
    ! [Uu: product_unit,Uv: product_unit] : ( aa(product_unit,product_unit,aa(product_unit,fun(product_unit,product_unit),inf_inf(product_unit),Uu),Uv) = product_Unity ) ).

% inf_unit_def
tff(fact_2892_eq__Abs__Integ,axiom,
    ! [Z2: int] :
      ~ ! [X2: nat,Y2: nat] : ( Z2 != aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),Y2)) ) ).

% eq_Abs_Integ
tff(fact_2893_zero__int__def,axiom,
    zero_zero(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),zero_zero(nat))) ).

% zero_int_def
tff(fact_2894_int__def,axiom,
    ! [N: nat] : ( aa(nat,int,semiring_1_of_nat(int),N) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),N),zero_zero(nat))) ) ).

% int_def
tff(fact_2895_uminus__int_Oabs__eq,axiom,
    ! [X: product_prod(nat,nat)] : ( aa(int,int,uminus_uminus(int),aa(product_prod(nat,nat),int,abs_Integ,X)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat)))),X)) ) ).

% uminus_int.abs_eq
tff(fact_2896_one__int__def,axiom,
    one_one(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),one_one(nat)),zero_zero(nat))) ).

% one_int_def
tff(fact_2897_range__prod,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(D,product_prod(B,C))] : aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),aa(set(D),set(product_prod(B,C)),image2(D,product_prod(B,C),Fa),top_top(set(D)))),product_Sigma(B,C,aa(set(D),set(B),image2(D,B,aa(fun(D,product_prod(B,C)),fun(D,B),aa(fun(product_prod(B,C),B),fun(fun(D,product_prod(B,C)),fun(D,B)),comp(product_prod(B,C),B,D),product_fst(B,C)),Fa)),top_top(set(D))),aTP_Lamp_hi(fun(D,product_prod(B,C)),fun(B,set(C)),Fa))) ).

% range_prod
tff(fact_2898_fold__union__pair,axiom,
    ! [C: $tType,B: $tType,B2: set(B),X: C,A4: set(product_prod(C,B))] :
      ( aa(set(B),$o,finite_finite(B),B2)
     => ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),set(product_prod(C,B))),sup_sup(set(product_prod(C,B))),aa(set(set(product_prod(C,B))),set(product_prod(C,B)),complete_Sup_Sup(set(product_prod(C,B))),aa(set(B),set(set(product_prod(C,B))),image2(B,set(product_prod(C,B)),aTP_Lamp_hj(C,fun(B,set(product_prod(C,B))),X)),B2))),A4) = finite_fold(B,set(product_prod(C,B)),aTP_Lamp_gf(C,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),X),A4,B2) ) ) ).

% fold_union_pair
tff(fact_2899_mlex__prod__def,axiom,
    ! [B: $tType,Fa: fun(B,nat),R: set(product_prod(B,B))] : ( mlex_prod(B,Fa,R) = inv_image(product_prod(nat,B),B,lex_prod(nat,B,less_than,R),aTP_Lamp_hk(fun(B,nat),fun(B,product_prod(nat,B)),Fa)) ) ).

% mlex_prod_def
tff(fact_2900_prod_Oinsert_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [I4: set(B),P2: fun(B,C),I: B] :
          ( aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_bt(set(B),fun(fun(B,C),fun(B,$o)),I4),P2)))
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),P2),aa(set(B),set(B),insert2(B,I),I4))
            = $ite(member(B,I,I4),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),P2),I4),aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,P2,I)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),P2),I4))) ) ) ) ).

% prod.insert'
tff(fact_2901_times__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int.rsp
tff(fact_2902_Sup__bot__conv_I2_J,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B)] :
          ( ( bot_bot(B) = aa(set(B),B,complete_Sup_Sup(B),A4) )
        <=> ! [X4: B] :
              ( member(B,X4,A4)
             => ( X4 = bot_bot(B) ) ) ) ) ).

% Sup_bot_conv(2)
tff(fact_2903_Sup__bot__conv_I1_J,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B)] :
          ( ( aa(set(B),B,complete_Sup_Sup(B),A4) = bot_bot(B) )
        <=> ! [X4: B] :
              ( member(B,X4,A4)
             => ( X4 = bot_bot(B) ) ) ) ) ).

% Sup_bot_conv(1)
tff(fact_2904_SigmaI,axiom,
    ! [C: $tType,B: $tType,A3: B,A4: set(B),Ba: C,B2: fun(B,set(C))] :
      ( member(B,A3,A4)
     => ( member(C,Ba,aa(B,set(C),B2,A3))
       => member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),product_Sigma(B,C,A4,B2)) ) ) ).

% SigmaI
tff(fact_2905_mem__Sigma__iff,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,A4: set(B),B2: fun(B,set(C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),product_Sigma(B,C,A4,B2))
    <=> ( member(B,A3,A4)
        & member(C,Ba,aa(B,set(C),B2,A3)) ) ) ).

% mem_Sigma_iff
tff(fact_2906_in__inv__image,axiom,
    ! [B: $tType,C: $tType,X: B,Y: B,R3: set(product_prod(C,C)),Fa: fun(B,C)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),inv_image(C,B,R3,Fa))
    <=> member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),aa(B,C,Fa,X)),aa(B,C,Fa,Y)),R3) ) ).

% in_inv_image
tff(fact_2907_Sup__empty,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(B),B,complete_Sup_Sup(B),bot_bot(set(B))) = bot_bot(B) ) ) ).

% Sup_empty
tff(fact_2908_cSup__singleton,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X: B] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = X ) ) ).

% cSup_singleton
tff(fact_2909_Sup__insert,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: B,A4: set(B)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert2(B,A3),A4)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),aa(set(B),B,complete_Sup_Sup(B),A4)) ) ) ).

% Sup_insert
tff(fact_2910_Sigma__empty1,axiom,
    ! [C: $tType,B: $tType,B2: fun(B,set(C))] : ( product_Sigma(B,C,bot_bot(set(B)),B2) = bot_bot(set(product_prod(B,C))) ) ).

% Sigma_empty1
tff(fact_2911_prod_Oempty_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [P2: fun(C,B)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups1962203154675924110t_prod(C,B),P2),bot_bot(set(C))) = one_one(B) ) ) ).

% prod.empty'
tff(fact_2912_intrel__iff,axiom,
    ! [X: nat,Y: nat,U: nat,V: nat] :
      ( aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Y)),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),U),V))
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X),V) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),U),Y) ) ) ).

% intrel_iff
tff(fact_2913_SUP__bot__conv_I2_J,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [B2: fun(C,B),A4: set(C)] :
          ( ( bot_bot(B) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,B2),A4)) )
        <=> ! [X4: C] :
              ( member(C,X4,A4)
             => ( aa(C,B,B2,X4) = bot_bot(B) ) ) ) ) ).

% SUP_bot_conv(2)
tff(fact_2914_SUP__bot__conv_I1_J,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [B2: fun(C,B),A4: set(C)] :
          ( ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,B2),A4)) = bot_bot(B) )
        <=> ! [X4: C] :
              ( member(C,X4,A4)
             => ( aa(C,B,B2,X4) = bot_bot(B) ) ) ) ) ).

% SUP_bot_conv(1)
tff(fact_2915_SUP__bot,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(C)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_hl(C,B)),A4)) = bot_bot(B) ) ) ).

% SUP_bot
tff(fact_2916_cSUP__const,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),C2: C] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,aTP_Lamp_hm(C,fun(B,C),C2)),A4)) = C2 ) ) ) ).

% cSUP_const
tff(fact_2917_SUP__const,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A4: set(B),Fa: C] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,aTP_Lamp_hn(C,fun(B,C),Fa)),A4)) = Fa ) ) ) ).

% SUP_const
tff(fact_2918_UN__constant,axiom,
    ! [C: $tType,B: $tType,C2: set(B),A4: set(C)] :
      ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_ho(set(B),fun(C,set(B)),C2)),A4))
      = $ite(A4 = bot_bot(set(C)),bot_bot(set(B)),C2) ) ).

% UN_constant
tff(fact_2919_Sigma__empty2,axiom,
    ! [C: $tType,B: $tType,A4: set(B)] : ( product_Sigma(B,C,A4,aTP_Lamp_hp(B,set(C))) = bot_bot(set(product_prod(B,C))) ) ).

% Sigma_empty2
tff(fact_2920_Times__empty,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ( product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)) = bot_bot(set(product_prod(B,C))) )
    <=> ( ( A4 = bot_bot(set(B)) )
        | ( B2 = bot_bot(set(C)) ) ) ) ).

% Times_empty
tff(fact_2921_UN__simps_I1_J,axiom,
    ! [B: $tType,C: $tType,A3: B,B2: fun(C,set(B)),C3: set(C)] :
      ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_hr(B,fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C3))
      = $ite(C3 = bot_bot(set(C)),bot_bot(set(B)),aa(set(B),set(B),insert2(B,A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C3)))) ) ).

% UN_simps(1)
tff(fact_2922_UN__singleton,axiom,
    ! [B: $tType,A4: set(B)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(B),set(set(B)),image2(B,set(B),aTP_Lamp_bf(B,set(B))),A4)) = A4 ) ).

% UN_singleton
tff(fact_2923_UN__simps_I3_J,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: fun(C,set(B)),C3: set(C)] :
      ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_hs(set(B),fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C3))
      = $ite(C3 = bot_bot(set(C)),bot_bot(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C3)))) ) ).

% UN_simps(3)
tff(fact_2924_UN__simps_I2_J,axiom,
    ! [C: $tType,B: $tType,A4: fun(C,set(B)),B2: set(B),C3: set(C)] :
      ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_ht(fun(C,set(B)),fun(set(B),fun(C,set(B))),A4),B2)),C3))
      = $ite(C3 = bot_bot(set(C)),bot_bot(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),C3))),B2)) ) ).

% UN_simps(2)
tff(fact_2925_fst__image__times,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( aa(set(product_prod(B,C)),set(B),image2(product_prod(B,C),B,product_fst(B,C)),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))
      = $ite(B2 = bot_bot(set(C)),bot_bot(set(B)),A4) ) ).

% fst_image_times
tff(fact_2926_snd__image__times,axiom,
    ! [C: $tType,B: $tType,A4: set(C),B2: set(B)] :
      ( aa(set(product_prod(C,B)),set(B),image2(product_prod(C,B),B,product_snd(C,B)),product_Sigma(C,B,A4,aTP_Lamp_ho(set(B),fun(C,set(B)),B2)))
      = $ite(A4 = bot_bot(set(C)),bot_bot(set(B)),B2) ) ).

% snd_image_times
tff(fact_2927_Sigma__UNIV__cancel,axiom,
    ! [C: $tType,B: $tType,A4: set(B),X6: set(C)] : ( aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),minus_minus(set(product_prod(B,C))),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),X6))),product_Sigma(B,C,A4,aTP_Lamp_hu(B,set(C)))) = bot_bot(set(product_prod(B,C))) ) ).

% Sigma_UNIV_cancel
tff(fact_2928_insert__Times__insert,axiom,
    ! [B: $tType,C: $tType,A3: B,A4: set(B),Ba: C,B2: set(C)] : ( product_Sigma(B,C,aa(set(B),set(B),insert2(B,A3),A4),aa(set(C),fun(B,set(C)),aTP_Lamp_hv(C,fun(set(C),fun(B,set(C))),Ba),B2)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),insert2(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba)),aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),sup_sup(set(product_prod(B,C))),product_Sigma(B,C,A4,aa(set(C),fun(B,set(C)),aTP_Lamp_hv(C,fun(set(C),fun(B,set(C))),Ba),B2))),product_Sigma(B,C,aa(set(B),set(B),insert2(B,A3),A4),aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))) ) ).

% insert_Times_insert
tff(fact_2929_SigmaE2,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,A4: set(B),B2: fun(B,set(C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),product_Sigma(B,C,A4,B2))
     => ~ ( member(B,A3,A4)
         => ~ member(C,Ba,aa(B,set(C),B2,A3)) ) ) ).

% SigmaE2
tff(fact_2930_SigmaD2,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,A4: set(B),B2: fun(B,set(C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),product_Sigma(B,C,A4,B2))
     => member(C,Ba,aa(B,set(C),B2,A3)) ) ).

% SigmaD2
tff(fact_2931_SigmaD1,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,A4: set(B),B2: fun(B,set(C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),product_Sigma(B,C,A4,B2))
     => member(B,A3,A4) ) ).

% SigmaD1
tff(fact_2932_SigmaE,axiom,
    ! [B: $tType,C: $tType,C2: product_prod(B,C),A4: set(B),B2: fun(B,set(C))] :
      ( member(product_prod(B,C),C2,product_Sigma(B,C,A4,B2))
     => ~ ! [X2: B] :
            ( member(B,X2,A4)
           => ! [Y2: C] :
                ( member(C,Y2,aa(B,set(C),B2,X2))
               => ( C2 != aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2) ) ) ) ) ).

% SigmaE
tff(fact_2933_empty__Union__conv,axiom,
    ! [B: $tType,A4: set(set(B))] :
      ( ( bot_bot(set(B)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A4) )
    <=> ! [X4: set(B)] :
          ( member(set(B),X4,A4)
         => ( X4 = bot_bot(set(B)) ) ) ) ).

% empty_Union_conv
tff(fact_2934_Union__empty__conv,axiom,
    ! [B: $tType,A4: set(set(B))] :
      ( ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A4) = bot_bot(set(B)) )
    <=> ! [X4: set(B)] :
          ( member(set(B),X4,A4)
         => ( X4 = bot_bot(set(B)) ) ) ) ).

% Union_empty_conv
tff(fact_2935_Union__empty,axiom,
    ! [B: $tType] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),bot_bot(set(set(B)))) = bot_bot(set(B)) ) ).

% Union_empty
tff(fact_2936_times__eq__iff,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C),C3: set(B),D4: set(C)] :
      ( ( product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)) = product_Sigma(B,C,C3,aTP_Lamp_hq(set(C),fun(B,set(C)),D4)) )
    <=> ( ( ( A4 = C3 )
          & ( B2 = D4 ) )
        | ( ( ( A4 = bot_bot(set(B)) )
            | ( B2 = bot_bot(set(C)) ) )
          & ( ( C3 = bot_bot(set(B)) )
            | ( D4 = bot_bot(set(C)) ) ) ) ) ) ).

% times_eq_iff
tff(fact_2937_SUP__UNIV__bool__expand,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: fun($o,B)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set($o),set(B),image2($o,B,A4),top_top(set($o)))) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa($o,B,A4,$true)),aa($o,B,A4,$false)) ) ) ).

% SUP_UNIV_bool_expand
tff(fact_2938_Sigma__def,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: fun(B,set(C))] : ( product_Sigma(B,C,A4,B2) = aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(B),set(set(product_prod(B,C))),image2(B,set(product_prod(B,C)),aTP_Lamp_hx(fun(B,set(C)),fun(B,set(product_prod(B,C))),B2)),A4)) ) ).

% Sigma_def
tff(fact_2939_in__Union__o__assoc,axiom,
    ! [C: $tType,B: $tType,D: $tType,X: B,Gset: fun(C,set(set(B))),Gmap: fun(D,C),A4: D] :
      ( member(B,X,aa(D,set(B),aa(fun(D,C),fun(D,set(B)),aa(fun(C,set(B)),fun(fun(D,C),fun(D,set(B))),comp(C,set(B),D),aa(fun(C,set(set(B))),fun(C,set(B)),aa(fun(set(set(B)),set(B)),fun(fun(C,set(set(B))),fun(C,set(B))),comp(set(set(B)),set(B),C),complete_Sup_Sup(set(B))),Gset)),Gmap),A4))
     => member(B,X,aa(D,set(B),aa(fun(D,set(set(B))),fun(D,set(B)),aa(fun(set(set(B)),set(B)),fun(fun(D,set(set(B))),fun(D,set(B))),comp(set(set(B)),set(B),D),complete_Sup_Sup(set(B))),aa(fun(D,C),fun(D,set(set(B))),aa(fun(C,set(set(B))),fun(fun(D,C),fun(D,set(set(B)))),comp(C,set(set(B)),D),Gset),Gmap)),A4)) ) ).

% in_Union_o_assoc
tff(fact_2940_prod_Onon__neutral_H,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(C,B),I4: set(C)] : ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups1962203154675924110t_prod(C,B),Ga),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aTP_Lamp_hy(fun(C,B),fun(set(C),fun(C,$o)),Ga),I4))) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups1962203154675924110t_prod(C,B),Ga),I4) ) ) ).

% prod.non_neutral'
tff(fact_2941_less__eq__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B),U: B] :
          ( ! [V3: B] :
              ( member(B,V3,A4)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),V3) )
         => ( ( A4 != bot_bot(set(B)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Sup_Sup(B),A4)) ) ) ) ).

% less_eq_Sup
tff(fact_2942_cSup__eq__non__empty,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X6: set(B),A3: B] :
          ( ( X6 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,X6)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),A3) )
           => ( ! [Y2: B] :
                  ( ! [X3: B] :
                      ( member(B,X3,X6)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),Y2) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Y2) )
             => ( aa(set(B),B,complete_Sup_Sup(B),X6) = A3 ) ) ) ) ) ).

% cSup_eq_non_empty
tff(fact_2943_cSup__least,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X6: set(B),Z2: B] :
          ( ( X6 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,X6)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Z2) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),X6)),Z2) ) ) ) ).

% cSup_least
tff(fact_2944_less__cSupE,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [Y: B,X6: set(B)] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(set(B),B,complete_Sup_Sup(B),X6))
         => ( ( X6 != bot_bot(set(B)) )
           => ~ ! [X2: B] :
                  ( member(B,X2,X6)
                 => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X2) ) ) ) ) ).

% less_cSupE
tff(fact_2945_less__cSupD,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X6: set(B),Z2: B] :
          ( ( X6 != bot_bot(set(B)) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),aa(set(B),B,complete_Sup_Sup(B),X6))
           => ? [X2: B] :
                ( member(B,X2,X6)
                & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),X2) ) ) ) ) ).

% less_cSupD
tff(fact_2946_SUP__eq__const,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I4: set(B),Fa: fun(B,C),X: C] :
          ( ( I4 != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( member(B,I3,I4)
               => ( aa(B,C,Fa,I3) = X ) )
           => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),I4)) = X ) ) ) ) ).

% SUP_eq_const
tff(fact_2947_Sup__inf__eq__bot__iff,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [B2: set(B),A3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Sup_Sup(B),B2)),A3) = bot_bot(B) )
        <=> ! [X4: B] :
              ( member(B,X4,B2)
             => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X4),A3) = bot_bot(B) ) ) ) ) ).

% Sup_inf_eq_bot_iff
tff(fact_2948_inf__Sup,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A3: B,B2: set(B)] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(set(B),B,complete_Sup_Sup(B),B2)) = aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),inf_inf(B),A3)),B2)) ) ) ).

% inf_Sup
tff(fact_2949_SUP__image,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( complete_Sup(B)
     => ! [Ga: fun(C,B),Fa: fun(D,C),A4: set(D)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Ga),aa(set(D),set(C),image2(D,C,Fa),A4))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Ga),Fa)),A4)) ) ) ).

% SUP_image
tff(fact_2950_Sup__finite__insert,axiom,
    ! [B: $tType] :
      ( finite_lattice(B)
     => ! [A3: B,A4: set(B)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert2(B,A3),A4)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),aa(set(B),B,complete_Sup_Sup(B),A4)) ) ) ).

% Sup_finite_insert
tff(fact_2951_Sup__union__distrib,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B),B2: set(B)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),A4)),aa(set(B),B,complete_Sup_Sup(B),B2)) ) ) ).

% Sup_union_distrib
tff(fact_2952_Sigma__Int__distrib1,axiom,
    ! [C: $tType,B: $tType,I4: set(B),J4: set(B),C3: fun(B,set(C))] : ( product_Sigma(B,C,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),I4),J4),C3) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),product_Sigma(B,C,I4,C3)),product_Sigma(B,C,J4,C3)) ) ).

% Sigma_Int_distrib1
tff(fact_2953_Union__disjoint,axiom,
    ! [B: $tType,C3: set(set(B)),A4: set(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3)),A4) = bot_bot(set(B)) )
    <=> ! [X4: set(B)] :
          ( member(set(B),X4,C3)
         => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X4),A4) = bot_bot(set(B)) ) ) ) ).

% Union_disjoint
tff(fact_2954_insert__partition,axiom,
    ! [B: $tType,X: set(B),F: set(set(B))] :
      ( ~ member(set(B),X,F)
     => ( ! [X2: set(B)] :
            ( member(set(B),X2,aa(set(set(B)),set(set(B)),insert2(set(B),X),F))
           => ! [Xa4: set(B)] :
                ( member(set(B),Xa4,aa(set(set(B)),set(set(B)),insert2(set(B),X),F))
               => ( ( X2 != Xa4 )
                 => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X2),Xa4) = bot_bot(set(B)) ) ) ) )
       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),F)) = bot_bot(set(B)) ) ) ) ).

% insert_partition
tff(fact_2955_Union__Int__subset,axiom,
    ! [B: $tType,A4: set(set(B)),B2: set(set(B))] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),inf_inf(set(set(B))),A4),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A4)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B2))) ).

% Union_Int_subset
tff(fact_2956_Sigma__empty__iff,axiom,
    ! [B: $tType,C: $tType,I4: set(B),X6: fun(B,set(C))] :
      ( ( product_Sigma(B,C,I4,X6) = bot_bot(set(product_prod(B,C))) )
    <=> ! [X4: B] :
          ( member(B,X4,I4)
         => ( aa(B,set(C),X6,X4) = bot_bot(set(C)) ) ) ) ).

% Sigma_empty_iff
tff(fact_2957_SUP__inf,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Fa: fun(C,B),B2: set(C),A3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Fa),B2))),A3) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(B,fun(C,B),aTP_Lamp_hz(fun(C,B),fun(B,fun(C,B)),Fa),A3)),B2)) ) ) ).

% SUP_inf
tff(fact_2958_Sup__inf,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [B2: set(B),A3: B] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Sup_Sup(B),B2)),A3) = aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),image2(B,B,aTP_Lamp_ia(B,fun(B,B),A3)),B2)) ) ) ).

% Sup_inf
tff(fact_2959_inf__SUP,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A3: B,Fa: fun(C,B),B2: set(C)] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Fa),B2))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ib(B,fun(fun(C,B),fun(C,B)),A3),Fa)),B2)) ) ) ).

% inf_SUP
tff(fact_2960_SUP__inf__distrib2,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Fa: fun(C,B),A4: set(C),Ga: fun(D,B),B2: set(D)] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Fa),A4))),aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,Ga),B2))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_id(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),Fa),Ga),B2)),A4)) ) ) ).

% SUP_inf_distrib2
tff(fact_2961_complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(C,B),A4: set(C),Ga: fun(C,B)] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Fa),A4))),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Ga),A4))) = aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ie(fun(C,B),fun(fun(C,B),fun(C,B)),Fa),Ga)),A4)) ) ) ).

% complete_lattice_class.SUP_sup_distrib
tff(fact_2962_SUP__absorb,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [K: B,I4: set(B),A4: fun(B,C)] :
          ( member(B,K,I4)
         => ( aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(B,C,A4,K)),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,A4),I4))) = aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,A4),I4)) ) ) ) ).

% SUP_absorb
tff(fact_2963_Restr__subset,axiom,
    ! [B: $tType,A4: set(B),B2: set(B),R3: set(product_prod(B,B))] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
     => ( aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,B2,aTP_Lamp_if(set(B),fun(B,set(B)),B2)))),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4))) = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4))) ) ) ).

% Restr_subset
tff(fact_2964_Restr__Field,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,field2(B,R3),aTP_Lamp_ig(set(product_prod(B,B)),fun(B,set(B)),R3))) = R3 ) ).

% Restr_Field
tff(fact_2965_Times__Int__distrib1,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(B),C3: set(C)] : ( product_Sigma(B,C,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2),aTP_Lamp_hq(set(C),fun(B,set(C)),C3)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),C3))),product_Sigma(B,C,B2,aTP_Lamp_hq(set(C),fun(B,set(C)),C3))) ) ).

% Times_Int_distrib1
tff(fact_2966_Sigma__Int__distrib2,axiom,
    ! [C: $tType,B: $tType,I4: set(B),A4: fun(B,set(C)),B2: fun(B,set(C))] : ( product_Sigma(B,C,I4,aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_ih(fun(B,set(C)),fun(fun(B,set(C)),fun(B,set(C))),A4),B2)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),product_Sigma(B,C,I4,A4)),product_Sigma(B,C,I4,B2)) ) ).

% Sigma_Int_distrib2
tff(fact_2967_Times__Int__Times,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C),C3: set(B),D4: set(C)] : ( aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2))),product_Sigma(B,C,C3,aTP_Lamp_hq(set(C),fun(B,set(C)),D4))) = product_Sigma(B,C,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),C3),aa(set(C),fun(B,set(C)),aTP_Lamp_ii(set(C),fun(set(C),fun(B,set(C))),B2),D4)) ) ).

% Times_Int_Times
tff(fact_2968_zero__int_Orsp,axiom,
    aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),zero_zero(nat))),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),zero_zero(nat)),zero_zero(nat))) ).

% zero_int.rsp
tff(fact_2969_UNION__empty__conv_I2_J,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,set(B)),A4: set(C)] :
      ( ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A4)) = bot_bot(set(B)) )
    <=> ! [X4: C] :
          ( member(C,X4,A4)
         => ( aa(C,set(B),B2,X4) = bot_bot(set(B)) ) ) ) ).

% UNION_empty_conv(2)
tff(fact_2970_UNION__empty__conv_I1_J,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,set(B)),A4: set(C)] :
      ( ( bot_bot(set(B)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A4)) )
    <=> ! [X4: C] :
          ( member(C,X4,A4)
         => ( aa(C,set(B),B2,X4) = bot_bot(set(B)) ) ) ) ).

% UNION_empty_conv(1)
tff(fact_2971_UN__empty,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,set(B))] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),bot_bot(set(C)))) = bot_bot(set(B)) ) ).

% UN_empty
tff(fact_2972_UN__empty2,axiom,
    ! [C: $tType,B: $tType,A4: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_ij(C,set(B))),A4)) = bot_bot(set(B)) ) ).

% UN_empty2
tff(fact_2973_Int__UN__distrib2,axiom,
    ! [D: $tType,B: $tType,C: $tType,A4: fun(C,set(B)),I4: set(C),B2: fun(D,set(B)),J4: set(D)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),I4))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),B2),J4))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(D),fun(C,set(B)),aa(fun(D,set(B)),fun(set(D),fun(C,set(B))),aTP_Lamp_il(fun(C,set(B)),fun(fun(D,set(B)),fun(set(D),fun(C,set(B)))),A4),B2),J4)),I4)) ) ).

% Int_UN_distrib2
tff(fact_2974_Int__UN__distrib,axiom,
    ! [B: $tType,C: $tType,B2: set(B),A4: fun(C,set(B)),I4: set(C)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),B2),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),I4))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_im(set(B),fun(fun(C,set(B)),fun(C,set(B))),B2),A4)),I4)) ) ).

% Int_UN_distrib
tff(fact_2975_UN__extend__simps_I4_J,axiom,
    ! [B: $tType,C: $tType,A4: fun(C,set(B)),C3: set(C),B2: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),C3))),B2) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_in(fun(C,set(B)),fun(set(B),fun(C,set(B))),A4),B2)),C3)) ) ).

% UN_extend_simps(4)
tff(fact_2976_UN__extend__simps_I5_J,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: fun(C,set(B)),C3: set(C)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C3))) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_im(set(B),fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C3)) ) ).

% UN_extend_simps(5)
tff(fact_2977_Union__natural,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] : ( aa(fun(set(set(B)),set(set(C))),fun(set(set(B)),set(C)),aa(fun(set(set(C)),set(C)),fun(fun(set(set(B)),set(set(C))),fun(set(set(B)),set(C))),comp(set(set(C)),set(C),set(set(B))),complete_Sup_Sup(set(C))),image2(set(B),set(C),image2(B,C,Fa))) = aa(fun(set(set(B)),set(B)),fun(set(set(B)),set(C)),aa(fun(set(B),set(C)),fun(fun(set(set(B)),set(B)),fun(set(set(B)),set(C))),comp(set(B),set(C),set(set(B))),image2(B,C,Fa)),complete_Sup_Sup(set(B))) ) ).

% Union_natural
tff(fact_2978_Int__Union2,axiom,
    ! [B: $tType,B2: set(set(B)),A4: set(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B2)),A4) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(B)),set(set(B)),image2(set(B),set(B),aTP_Lamp_io(set(B),fun(set(B),set(B)),A4)),B2)) ) ).

% Int_Union2
tff(fact_2979_Int__Union,axiom,
    ! [B: $tType,A4: set(B),B2: set(set(B))] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B2)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(B)),set(set(B)),image2(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4)),B2)) ) ).

% Int_Union
tff(fact_2980_SUP__eq__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I4: set(B),C2: C,Fa: fun(B,C)] :
          ( ( I4 != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( member(B,I3,I4)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),C2),aa(B,C,Fa,I3)) )
           => ( ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),I4)) = C2 )
            <=> ! [X4: B] :
                  ( member(B,X4,I4)
                 => ( aa(B,C,Fa,X4) = C2 ) ) ) ) ) ) ).

% SUP_eq_iff
tff(fact_2981_cSUP__least,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Fa: fun(B,C),M: C] :
          ( ( A4 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,A4)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X2)),M) )
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))),M) ) ) ) ).

% cSUP_least
tff(fact_2982_finite__Sup__less__iff,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X6: set(B),A3: B] :
          ( aa(set(B),$o,finite_finite(B),X6)
         => ( ( X6 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,complete_Sup_Sup(B),X6)),A3)
            <=> ! [X4: B] :
                  ( member(B,X4,X6)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X4),A3) ) ) ) ) ) ).

% finite_Sup_less_iff
tff(fact_2983_finite__Sup__in,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [X2: B,Y2: B] :
                  ( member(B,X2,A4)
                 => ( member(B,Y2,A4)
                   => member(B,aa(B,B,aa(B,fun(B,B),sup_sup(B),X2),Y2),A4) ) )
             => member(B,aa(set(B),B,complete_Sup_Sup(B),A4),A4) ) ) ) ) ).

% finite_Sup_in
tff(fact_2984_cSup__abs__le,axiom,
    ! [B: $tType] :
      ( ( condit6923001295902523014norder(B)
        & linordered_idom(B) )
     => ! [S2: set(B),A3: B] :
          ( ( S2 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,S2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),X2)),A3) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(set(B),B,complete_Sup_Sup(B),S2))),A3) ) ) ) ).

% cSup_abs_le
tff(fact_2985_Sup__inter__less__eq,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B),B2: set(B)] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Sup_Sup(B),A4)),aa(set(B),B,complete_Sup_Sup(B),B2))) ) ).

% Sup_inter_less_eq
tff(fact_2986_sum_OUnion__comp,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [B2: set(set(B)),Ga: fun(B,C)] :
          ( ! [X2: set(B)] :
              ( member(set(B),X2,B2)
             => aa(set(B),$o,finite_finite(B),X2) )
         => ( ! [A15: set(B)] :
                ( member(set(B),A15,B2)
               => ! [A24: set(B)] :
                    ( member(set(B),A24,B2)
                   => ( ( A15 != A24 )
                     => ! [X2: B] :
                          ( member(B,X2,A15)
                         => ( member(B,X2,A24)
                           => ( aa(B,C,Ga,X2) = zero_zero(C) ) ) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B2)) = aa(set(set(B)),C,aa(fun(B,C),fun(set(set(B)),C),aa(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C)),aa(fun(fun(set(B),C),fun(set(set(B)),C)),fun(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C))),comp(fun(set(B),C),fun(set(set(B)),C),fun(B,C)),groups7311177749621191930dd_sum(set(B),C)),groups7311177749621191930dd_sum(B,C)),Ga),B2) ) ) ) ) ).

% sum.Union_comp
tff(fact_2987_sup__Sup__fold__sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B),B2: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),A4)),B2) = finite_fold(B,B,sup_sup(B),B2,A4) ) ) ) ).

% sup_Sup_fold_sup
tff(fact_2988_prod_Odistrib__triv_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [I4: set(B),Ga: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),I4)
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_ip(fun(B,C),fun(fun(B,C),fun(B,C)),Ga),H2)),I4) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),Ga),I4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),H2),I4)) ) ) ) ).

% prod.distrib_triv'
tff(fact_2989_prod_OUnion__comp,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [B2: set(set(B)),Ga: fun(B,C)] :
          ( ! [X2: set(B)] :
              ( member(set(B),X2,B2)
             => aa(set(B),$o,finite_finite(B),X2) )
         => ( ! [A15: set(B)] :
                ( member(set(B),A15,B2)
               => ! [A24: set(B)] :
                    ( member(set(B),A24,B2)
                   => ( ( A15 != A24 )
                     => ! [X2: B] :
                          ( member(B,X2,A15)
                         => ( member(B,X2,A24)
                           => ( aa(B,C,Ga,X2) = one_one(C) ) ) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B2)) = aa(set(set(B)),C,aa(fun(B,C),fun(set(set(B)),C),aa(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C)),aa(fun(fun(set(B),C),fun(set(set(B)),C)),fun(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C))),comp(fun(set(B),C),fun(set(set(B)),C),fun(B,C)),groups7121269368397514597t_prod(set(B),C)),groups7121269368397514597t_prod(B,C)),Ga),B2) ) ) ) ) ).

% prod.Union_comp
tff(fact_2990_Sup__fin__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic5882676163264333800up_fin(B),A4) = aa(set(B),B,complete_Sup_Sup(B),A4) ) ) ) ) ).

% Sup_fin_Sup
tff(fact_2991_cSup__eq__Sup__fin,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X6: set(B)] :
          ( aa(set(B),$o,finite_finite(B),X6)
         => ( ( X6 != bot_bot(set(B)) )
           => ( aa(set(B),B,complete_Sup_Sup(B),X6) = aa(set(B),B,lattic5882676163264333800up_fin(B),X6) ) ) ) ) ).

% cSup_eq_Sup_fin
tff(fact_2992_Union__image__empty,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(C,set(B))] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),Fa),bot_bot(set(C))))) = A4 ) ).

% Union_image_empty
tff(fact_2993_uminus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),product_prod(nat,nat)),$o,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(product_prod(nat,nat),product_prod(nat,nat)),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat))))),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int.rsp
tff(fact_2994_card__cartesian__product__singleton,axiom,
    ! [B: $tType,C: $tType,X: B,A4: set(C)] : ( finite_card(product_prod(B,C),product_Sigma(B,C,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))),aTP_Lamp_hq(set(C),fun(B,set(C)),A4))) = finite_card(C,A4) ) ).

% card_cartesian_product_singleton
tff(fact_2995_times__subset__iff,axiom,
    ! [B: $tType,C: $tType,A4: set(B),C3: set(C),B2: set(B),D4: set(C)] :
      ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),C3))),product_Sigma(B,C,B2,aTP_Lamp_hq(set(C),fun(B,set(C)),D4)))
    <=> ( ( A4 = bot_bot(set(B)) )
        | ( C3 = bot_bot(set(C)) )
        | ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
          & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),C3),D4) ) ) ) ).

% times_subset_iff
tff(fact_2996_wfI,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),B2: set(B)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),B2)))
     => ( ! [X2: B,P4: fun(B,$o)] :
            ( ! [Xa3: B] :
                ( ! [Y2: B] :
                    ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Xa3),R3)
                   => aa(B,$o,P4,Y2) )
               => aa(B,$o,P4,Xa3) )
           => ( member(B,X2,A4)
             => ( member(B,X2,B2)
               => aa(B,$o,P4,X2) ) ) )
       => wf(B,R3) ) ) ).

% wfI
tff(fact_2997_SUP__empty,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(C,B)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Fa),bot_bot(set(C)))) = bot_bot(B) ) ) ).

% SUP_empty
tff(fact_2998_SUP__constant,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [C2: B,A4: set(C)] :
          ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_iq(B,fun(C,B),C2)),A4))
          = $ite(A4 = bot_bot(set(C)),bot_bot(B),C2) ) ) ).

% SUP_constant
tff(fact_2999_Field__Restr__subset,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4))))),A4) ).

% Field_Restr_subset
tff(fact_3000_finite__cartesian__product__iff,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,finite_finite(product_prod(B,C)),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))
    <=> ( ( A4 = bot_bot(set(B)) )
        | ( B2 = bot_bot(set(C)) )
        | ( aa(set(B),$o,finite_finite(B),A4)
          & aa(set(C),$o,finite_finite(C),B2) ) ) ) ).

% finite_cartesian_product_iff
tff(fact_3001_finite__cartesian__productD2,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,finite_finite(product_prod(B,C)),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))
     => ( ( A4 != bot_bot(set(B)) )
       => aa(set(C),$o,finite_finite(C),B2) ) ) ).

% finite_cartesian_productD2
tff(fact_3002_finite__cartesian__productD1,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( aa(set(product_prod(B,C)),$o,finite_finite(product_prod(B,C)),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))
     => ( ( B2 != bot_bot(set(C)) )
       => aa(set(B),$o,finite_finite(B),A4) ) ) ).

% finite_cartesian_productD1
tff(fact_3003_finite__SigmaI2,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: fun(B,set(C))] :
      ( aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,set(C)),fun(B,$o),aTP_Lamp_ir(set(B),fun(fun(B,set(C)),fun(B,$o)),A4),B2)))
     => ( ! [A8: B] :
            ( member(B,A8,A4)
           => aa(set(C),$o,finite_finite(C),aa(B,set(C),B2,A8)) )
       => aa(set(product_prod(B,C)),$o,finite_finite(product_prod(B,C)),product_Sigma(B,C,A4,B2)) ) ) ).

% finite_SigmaI2
tff(fact_3004_fst__image__Sigma,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: fun(B,set(C))] : ( aa(set(product_prod(B,C)),set(B),image2(product_prod(B,C),B,product_fst(B,C)),product_Sigma(B,C,A4,B2)) = aa(fun(B,$o),set(B),collect(B),aa(fun(B,set(C)),fun(B,$o),aTP_Lamp_ir(set(B),fun(fun(B,set(C)),fun(B,$o)),A4),B2)) ) ).

% fst_image_Sigma
tff(fact_3005_SUP__insert,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(C,B),A3: C,A4: set(C)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Fa),aa(set(C),set(C),insert2(C,A3),A4))) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,Fa,A3)),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Fa),A4))) ) ) ).

% SUP_insert
tff(fact_3006_SUP__union,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [M: fun(C,B),A4: set(C),B2: set(C)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,M),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A4),B2))) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,M),A4))),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,M),B2))) ) ) ).

% SUP_union
tff(fact_3007_refl__on__def,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( refl_on(B,A4,R3)
    <=> ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))
        & ! [X4: B] :
            ( member(B,X4,A4)
           => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),X4),R3) ) ) ) ).

% refl_on_def
tff(fact_3008_refl__onI,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))
     => ( ! [X2: B] :
            ( member(B,X2,A4)
           => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2),R3) )
       => refl_on(B,A4,R3) ) ) ).

% refl_onI
tff(fact_3009_Refl__Restr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( refl_on(B,field2(B,R3),R3)
     => refl_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) ) ).

% Refl_Restr
tff(fact_3010_Total__Restr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( total_on(B,field2(B,R3),R3)
     => total_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) ) ).

% Total_Restr
tff(fact_3011_total__on__imp__Total__Restr,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( total_on(B,A4,R3)
     => total_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) ) ).

% total_on_imp_Total_Restr
tff(fact_3012_UN__extend__simps_I1_J,axiom,
    ! [B: $tType,C: $tType,A3: B,B2: fun(C,set(B)),C3: set(C)] :
      ( aa(set(B),set(B),insert2(B,A3),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C3)))
      = $ite(C3 = bot_bot(set(C)),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_hr(B,fun(fun(C,set(B)),fun(C,set(B))),A3),B2)),C3))) ) ).

% UN_extend_simps(1)
tff(fact_3013_UN__extend__simps_I2_J,axiom,
    ! [B: $tType,C: $tType,A4: fun(C,set(B)),C3: set(C),B2: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),C3))),B2)
      = $ite(C3 = bot_bot(set(C)),B2,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_ht(fun(C,set(B)),fun(set(B),fun(C,set(B))),A4),B2)),C3))) ) ).

% UN_extend_simps(2)
tff(fact_3014_UN__extend__simps_I3_J,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: fun(C,set(B)),C3: set(C)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C3)))
      = $ite(C3 = bot_bot(set(C)),A4,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_hs(set(B),fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C3))) ) ).

% UN_extend_simps(3)
tff(fact_3015_Linear__order__Restr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( order_679001287576687338der_on(B,field2(B,R3),R3)
     => order_679001287576687338der_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) ) ).

% Linear_order_Restr
tff(fact_3016_swap__product,axiom,
    ! [B: $tType,C: $tType,A4: set(C),B2: set(B)] : ( aa(set(product_prod(C,B)),set(product_prod(B,C)),image2(product_prod(C,B),product_prod(B,C),aa(fun(C,fun(B,product_prod(B,C))),fun(product_prod(C,B),product_prod(B,C)),product_case_prod(C,B,product_prod(B,C)),aTP_Lamp_ex(C,fun(B,product_prod(B,C))))),product_Sigma(C,B,A4,aTP_Lamp_ho(set(B),fun(C,set(B)),B2))) = product_Sigma(B,C,B2,aTP_Lamp_hq(set(C),fun(B,set(C)),A4)) ) ).

% swap_product
tff(fact_3017_one__int_Orsp,axiom,
    aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),one_one(nat)),zero_zero(nat))),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),one_one(nat)),zero_zero(nat))) ).

% one_int.rsp
tff(fact_3018_prod_Omono__neutral__cong__right_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S2: set(B),T3: set(B),Ga: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S2),T3)
         => ( ! [X2: B] :
                ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2))
               => ( aa(B,C,Ga,X2) = one_one(C) ) )
           => ( ! [X2: B] :
                  ( member(B,X2,S2)
                 => ( aa(B,C,Ga,X2) = aa(B,C,H2,X2) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),Ga),T3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),H2),S2) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
tff(fact_3019_prod_Omono__neutral__cong__left_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S2: set(B),T3: set(B),H2: fun(B,C),Ga: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S2),T3)
         => ( ! [I3: B] :
                ( member(B,I3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2))
               => ( aa(B,C,H2,I3) = one_one(C) ) )
           => ( ! [X2: B] :
                  ( member(B,X2,S2)
                 => ( aa(B,C,Ga,X2) = aa(B,C,H2,X2) ) )
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),Ga),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),H2),T3) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
tff(fact_3020_prod_Omono__neutral__right_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S2: set(B),T3: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S2),T3)
         => ( ! [X2: B] :
                ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2))
               => ( aa(B,C,Ga,X2) = one_one(C) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),Ga),T3) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),Ga),S2) ) ) ) ) ).

% prod.mono_neutral_right'
tff(fact_3021_prod_Omono__neutral__left_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S2: set(B),T3: set(B),Ga: fun(B,C)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),S2),T3)
         => ( ! [X2: B] :
                ( member(B,X2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T3),S2))
               => ( aa(B,C,Ga,X2) = one_one(C) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),Ga),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),Ga),T3) ) ) ) ) ).

% prod.mono_neutral_left'
tff(fact_3022_cSup__asclose,axiom,
    ! [B: $tType] :
      ( ( condit6923001295902523014norder(B)
        & linordered_idom(B) )
     => ! [S2: set(B),L: B,E2: B] :
          ( ( S2 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,S2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),L))),E2) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(B),B,complete_Sup_Sup(B),S2)),L))),E2) ) ) ) ).

% cSup_asclose
tff(fact_3023_Sup__fold__sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),B,complete_Sup_Sup(B),A4) = finite_fold(B,B,sup_sup(B),bot_bot(B),A4) ) ) ) ).

% Sup_fold_sup
tff(fact_3024_sum_OUnion__disjoint,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [C3: set(set(B)),Ga: fun(B,C)] :
          ( ! [X2: set(B)] :
              ( member(set(B),X2,C3)
             => aa(set(B),$o,finite_finite(B),X2) )
         => ( ! [X2: set(B)] :
                ( member(set(B),X2,C3)
               => ! [Xa4: set(B)] :
                    ( member(set(B),Xa4,C3)
                   => ( ( X2 != Xa4 )
                     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X2),Xa4) = bot_bot(set(B)) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3)) = aa(set(set(B)),C,aa(fun(B,C),fun(set(set(B)),C),aa(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C)),aa(fun(fun(set(B),C),fun(set(set(B)),C)),fun(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C))),comp(fun(set(B),C),fun(set(set(B)),C),fun(B,C)),groups7311177749621191930dd_sum(set(B),C)),groups7311177749621191930dd_sum(B,C)),Ga),C3) ) ) ) ) ).

% sum.Union_disjoint
tff(fact_3025_prod_OUnion__disjoint,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [C3: set(set(B)),Ga: fun(B,C)] :
          ( ! [X2: set(B)] :
              ( member(set(B),X2,C3)
             => aa(set(B),$o,finite_finite(B),X2) )
         => ( ! [X2: set(B)] :
                ( member(set(B),X2,C3)
               => ! [Xa4: set(B)] :
                    ( member(set(B),Xa4,C3)
                   => ( ( X2 != Xa4 )
                     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X2),Xa4) = bot_bot(set(B)) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3)) = aa(set(set(B)),C,aa(fun(B,C),fun(set(set(B)),C),aa(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C)),aa(fun(fun(set(B),C),fun(set(set(B)),C)),fun(fun(fun(B,C),fun(set(B),C)),fun(fun(B,C),fun(set(set(B)),C))),comp(fun(set(B),C),fun(set(set(B)),C),fun(B,C)),groups7121269368397514597t_prod(set(B),C)),groups7121269368397514597t_prod(B,C)),Ga),C3) ) ) ) ) ).

% prod.Union_disjoint
tff(fact_3026_inv__image__def,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(C,C)),Fa: fun(B,C)] : ( inv_image(C,B,R3,Fa) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(fun(B,C),fun(B,fun(B,$o)),aTP_Lamp_is(set(product_prod(C,C)),fun(fun(B,C),fun(B,fun(B,$o))),R3),Fa))) ) ).

% inv_image_def
tff(fact_3027_prod_Odistrib_H,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [I4: set(B),Ga: fun(B,C),H2: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_bt(set(B),fun(fun(B,C),fun(B,$o)),I4),Ga)))
         => ( aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_bt(set(B),fun(fun(B,C),fun(B,$o)),I4),H2)))
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),aa(fun(B,C),fun(B,C),aTP_Lamp_ip(fun(B,C),fun(fun(B,C),fun(B,C)),Ga),H2)),I4) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),Ga),I4)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups1962203154675924110t_prod(B,C),H2),I4)) ) ) ) ) ).

% prod.distrib'
tff(fact_3028_prod_OG__def,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [P2: fun(C,B),I4: set(C)] :
          ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups1962203154675924110t_prod(C,B),P2),I4)
          = $ite(aa(set(C),$o,finite_finite(C),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aTP_Lamp_hy(fun(C,B),fun(set(C),fun(C,$o)),P2),I4))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7121269368397514597t_prod(C,B),P2),aa(fun(C,$o),set(C),collect(C),aa(set(C),fun(C,$o),aTP_Lamp_hy(fun(C,B),fun(set(C),fun(C,$o)),P2),I4))),one_one(B)) ) ) ).

% prod.G_def
tff(fact_3029_Refl__Field__Restr2,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( refl_on(B,field2(B,R3),R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),field2(B,R3))
       => ( field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) = A4 ) ) ) ).

% Refl_Field_Restr2
tff(fact_3030_Refl__Field__Restr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( refl_on(B,field2(B,R3),R3)
     => ( field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),field2(B,R3)),A4) ) ) ).

% Refl_Field_Restr
tff(fact_3031_image__paired__Times,axiom,
    ! [D: $tType,C: $tType,B: $tType,E: $tType,Fa: fun(D,B),Ga: fun(E,C),A4: set(D),B2: set(E)] : ( aa(set(product_prod(D,E)),set(product_prod(B,C)),image2(product_prod(D,E),product_prod(B,C),aa(fun(D,fun(E,product_prod(B,C))),fun(product_prod(D,E),product_prod(B,C)),product_case_prod(D,E,product_prod(B,C)),aa(fun(E,C),fun(D,fun(E,product_prod(B,C))),aTP_Lamp_it(fun(D,B),fun(fun(E,C),fun(D,fun(E,product_prod(B,C)))),Fa),Ga))),product_Sigma(D,E,A4,aTP_Lamp_iu(set(E),fun(D,set(E)),B2))) = product_Sigma(B,C,aa(set(D),set(B),image2(D,B,Fa),A4),aa(set(E),fun(B,set(C)),aTP_Lamp_iv(fun(E,C),fun(set(E),fun(B,set(C))),Ga),B2)) ) ).

% image_paired_Times
tff(fact_3032_UNION__singleton__eq__range,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),A4: set(C)] : ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_iw(fun(C,B),fun(C,set(B)),Fa)),A4)) = aa(set(C),set(B),image2(C,B,Fa),A4) ) ).

% UNION_singleton_eq_range
tff(fact_3033_Id__on__def,axiom,
    ! [B: $tType,A4: set(B)] : ( id_on(B,A4) = aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),aa(set(B),set(set(product_prod(B,B))),image2(B,set(product_prod(B,B)),aTP_Lamp_ix(B,set(product_prod(B,B)))),A4)) ) ).

% Id_on_def
tff(fact_3034_sup__SUP__fold__sup,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A4: set(B),B2: C,Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(C,C,aa(C,fun(C,C),sup_sup(C),B2),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))) = finite_fold(B,C,aa(fun(B,C),fun(B,fun(C,C)),aa(fun(C,fun(C,C)),fun(fun(B,C),fun(B,fun(C,C))),comp(C,fun(C,C),B),sup_sup(C)),Fa),B2,A4) ) ) ) ).

% sup_SUP_fold_sup
tff(fact_3035_card__partition,axiom,
    ! [B: $tType,C3: set(set(B)),K: nat] :
      ( aa(set(set(B)),$o,finite_finite(set(B)),C3)
     => ( aa(set(B),$o,finite_finite(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3))
       => ( ! [C4: set(B)] :
              ( member(set(B),C4,C3)
             => ( finite_card(B,C4) = K ) )
         => ( ! [C1: set(B),C22: set(B)] :
                ( member(set(B),C1,C3)
               => ( member(set(B),C22,C3)
                 => ( ( C1 != C22 )
                   => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),C1),C22) = bot_bot(set(B)) ) ) ) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),finite_card(set(B),C3)) = finite_card(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3)) ) ) ) ) ) ).

% card_partition
tff(fact_3036_dvd__partition,axiom,
    ! [B: $tType,C3: set(set(B)),K: nat] :
      ( aa(set(B),$o,finite_finite(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3))
     => ( ! [X2: set(B)] :
            ( member(set(B),X2,C3)
           => dvd_dvd(nat,K,finite_card(B,X2)) )
       => ( ! [X2: set(B)] :
              ( member(set(B),X2,C3)
             => ! [Xa4: set(B)] :
                  ( member(set(B),Xa4,C3)
                 => ( ( X2 != Xa4 )
                   => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X2),Xa4) = bot_bot(set(B)) ) ) ) )
         => dvd_dvd(nat,K,finite_card(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C3))) ) ) ) ).

% dvd_partition
tff(fact_3037_sum_OUNION__disjoint,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [I4: set(B),A4: fun(B,set(C)),Ga: fun(C,D)] :
          ( aa(set(B),$o,finite_finite(B),I4)
         => ( ! [X2: B] :
                ( member(B,X2,I4)
               => aa(set(C),$o,finite_finite(C),aa(B,set(C),A4,X2)) )
           => ( ! [X2: B] :
                  ( member(B,X2,I4)
                 => ! [Xa4: B] :
                      ( member(B,Xa4,I4)
                     => ( ( X2 != Xa4 )
                       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A4,X2)),aa(B,set(C),A4,Xa4)) = bot_bot(set(C)) ) ) ) )
             => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),Ga),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4))) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_iy(fun(B,set(C)),fun(fun(C,D),fun(B,D)),A4),Ga)),I4) ) ) ) ) ) ).

% sum.UNION_disjoint
tff(fact_3038_prod_OUNION__disjoint,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [I4: set(B),A4: fun(B,set(C)),Ga: fun(C,D)] :
          ( aa(set(B),$o,finite_finite(B),I4)
         => ( ! [X2: B] :
                ( member(B,X2,I4)
               => aa(set(C),$o,finite_finite(C),aa(B,set(C),A4,X2)) )
           => ( ! [X2: B] :
                  ( member(B,X2,I4)
                 => ! [Xa4: B] :
                      ( member(B,Xa4,I4)
                     => ( ( X2 != Xa4 )
                       => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A4,X2)),aa(B,set(C),A4,Xa4)) = bot_bot(set(C)) ) ) ) )
             => ( aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),Ga),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4))) = aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_iz(fun(B,set(C)),fun(fun(C,D),fun(B,D)),A4),Ga)),I4) ) ) ) ) ) ).

% prod.UNION_disjoint
tff(fact_3039_product__fold,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( aa(set(C),$o,finite_finite(C),B2)
       => ( product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)) = finite_fold(B,set(product_prod(B,C)),aTP_Lamp_jb(set(C),fun(B,fun(set(product_prod(B,C)),set(product_prod(B,C)))),B2),bot_bot(set(product_prod(B,C))),A4) ) ) ) ).

% product_fold
tff(fact_3040_plus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int.rsp
tff(fact_3041_minus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int.rsp
tff(fact_3042_SUP__fold__sup,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A4: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4)) = finite_fold(B,C,aa(fun(B,C),fun(B,fun(C,C)),aa(fun(C,fun(C,C)),fun(fun(B,C),fun(B,fun(C,C))),comp(C,fun(C,C),B),sup_sup(C)),Fa),bot_bot(C),A4) ) ) ) ).

% SUP_fold_sup
tff(fact_3043_card__UN__disjoint,axiom,
    ! [C: $tType,B: $tType,I4: set(B),A4: fun(B,set(C))] :
      ( aa(set(B),$o,finite_finite(B),I4)
     => ( ! [X2: B] :
            ( member(B,X2,I4)
           => aa(set(C),$o,finite_finite(C),aa(B,set(C),A4,X2)) )
       => ( ! [X2: B] :
              ( member(B,X2,I4)
             => ! [Xa4: B] :
                  ( member(B,Xa4,I4)
                 => ( ( X2 != Xa4 )
                   => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A4,X2)),aa(B,set(C),A4,Xa4)) = bot_bot(set(C)) ) ) ) )
         => ( finite_card(C,aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4))) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),aTP_Lamp_jc(fun(B,set(C)),fun(B,nat),A4)),I4) ) ) ) ) ).

% card_UN_disjoint
tff(fact_3044_ccpo__Sup__singleton,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [X: B] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = X ) ) ).

% ccpo_Sup_singleton
tff(fact_3045_linear__order__on__Restr,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X: B] :
      ( order_679001287576687338der_on(B,A4,R3)
     => order_679001287576687338der_on(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),order_above(B,R3,X)),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,order_above(B,R3,X),aa(B,fun(B,set(B)),aTP_Lamp_jd(set(product_prod(B,B)),fun(B,fun(B,set(B))),R3),X)))) ) ).

% linear_order_on_Restr
tff(fact_3046_rp__inv__image__def,axiom,
    ! [C: $tType,B: $tType] : ( fun_rp_inv_image(B,C) = aa(fun(set(product_prod(B,B)),fun(set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))))),fun(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C))))),product_case_prod(set(product_prod(B,B)),set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C))))),aTP_Lamp_je(set(product_prod(B,B)),fun(set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C))))))) ) ).

% rp_inv_image_def
tff(fact_3047_UNION__fun__upd,axiom,
    ! [C: $tType,B: $tType,A4: fun(C,set(B)),I: C,B2: set(B),J4: set(C)] :
      ( aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),fun_upd(C,set(B),A4,I,B2)),J4))
      = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),J4),aa(set(C),set(C),insert2(C,I),bot_bot(set(C))))))),$ite(member(C,I,J4),B2,bot_bot(set(B)))) ) ).

% UNION_fun_upd
tff(fact_3048_rtrancl__last__visit__node,axiom,
    ! [B: $tType,S: B,S3: B,R: set(product_prod(B,B)),Sh: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),S),S3),transitive_rtrancl(B,R))
     => ( ( ( S != Sh )
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),S),S3),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_jf(B,fun(B,set(B)),Sh))))) )
        | ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),S),Sh),transitive_rtrancl(B,R))
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Sh),S3),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_jf(B,fun(B,set(B)),Sh))))) ) ) ) ).

% rtrancl_last_visit_node
tff(fact_3049_Sup__nat__empty,axiom,
    aa(set(nat),nat,complete_Sup_Sup(nat),bot_bot(set(nat))) = zero_zero(nat) ).

% Sup_nat_empty
tff(fact_3050_rtrancl__empty,axiom,
    ! [B: $tType] : ( transitive_rtrancl(B,bot_bot(set(product_prod(B,B)))) = id2(B) ) ).

% rtrancl_empty
tff(fact_3051_wf__insert,axiom,
    ! [B: $tType,Y: B,X: B,R3: set(product_prod(B,B))] :
      ( wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),X)),R3))
    <=> ( wf(B,R3)
        & ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,R3)) ) ) ).

% wf_insert
tff(fact_3052_UNIV__bool,axiom,
    top_top(set($o)) = aa(set($o),set($o),insert2($o,$false),aa(set($o),set($o),insert2($o,$true),bot_bot(set($o)))) ).

% UNIV_bool
tff(fact_3053_converse__rtrancl__into__rtrancl,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),C2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),C2),transitive_rtrancl(B,R3))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),C2),transitive_rtrancl(B,R3)) ) ) ).

% converse_rtrancl_into_rtrancl
tff(fact_3054_converse__rtrancl__induct,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),Pa: fun(B,$o)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,R3))
     => ( aa(B,$o,Pa,Ba)
       => ( ! [Y2: B,Z3: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),R3)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z3),Ba),transitive_rtrancl(B,R3))
               => ( aa(B,$o,Pa,Z3)
                 => aa(B,$o,Pa,Y2) ) ) )
         => aa(B,$o,Pa,A3) ) ) ) ).

% converse_rtrancl_induct
tff(fact_3055_converse__rtranclE,axiom,
    ! [B: $tType,X: B,Z2: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),transitive_rtrancl(B,R3))
     => ( ( X != Z2 )
       => ~ ! [Y2: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y2),R3)
             => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z2),transitive_rtrancl(B,R3)) ) ) ) ).

% converse_rtranclE
tff(fact_3056_rtrancl__induct,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),Pa: fun(B,$o)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,R3))
     => ( aa(B,$o,Pa,A3)
       => ( ! [Y2: B,Z3: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Y2),transitive_rtrancl(B,R3))
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),R3)
               => ( aa(B,$o,Pa,Y2)
                 => aa(B,$o,Pa,Z3) ) ) )
         => aa(B,$o,Pa,Ba) ) ) ) ).

% rtrancl_induct
tff(fact_3057_rtrancl__trans,axiom,
    ! [B: $tType,X: B,Y: B,R3: set(product_prod(B,B)),Z2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,R3))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),Z2),transitive_rtrancl(B,R3))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),transitive_rtrancl(B,R3)) ) ) ).

% rtrancl_trans
tff(fact_3058_rtranclE,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,R3))
     => ( ( A3 != Ba )
       => ~ ! [Y2: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Y2),transitive_rtrancl(B,R3))
             => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Ba),R3) ) ) ) ).

% rtranclE
tff(fact_3059_rtrancl_Ortrancl__into__rtrancl,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),C2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,R3))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),C2),R3)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),C2),transitive_rtrancl(B,R3)) ) ) ).

% rtrancl.rtrancl_into_rtrancl
tff(fact_3060_rtrancl_Ortrancl__refl,axiom,
    ! [B: $tType,A3: B,R3: set(product_prod(B,B))] : member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),A3),transitive_rtrancl(B,R3)) ).

% rtrancl.rtrancl_refl
tff(fact_3061_rtrancl_Osimps,axiom,
    ! [B: $tType,A1: B,A22: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A1),A22),transitive_rtrancl(B,R3))
    <=> ( ? [A6: B] :
            ( ( A1 = A6 )
            & ( A22 = A6 ) )
        | ? [A6: B,B5: B,C5: B] :
            ( ( A1 = A6 )
            & ( A22 = C5 )
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A6),B5),transitive_rtrancl(B,R3))
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B5),C5),R3) ) ) ) ).

% rtrancl.simps
tff(fact_3062_rtrancl_Ocases,axiom,
    ! [B: $tType,A1: B,A22: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A1),A22),transitive_rtrancl(B,R3))
     => ( ( A22 != A1 )
       => ~ ! [B4: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A1),B4),transitive_rtrancl(B,R3))
             => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B4),A22),R3) ) ) ) ).

% rtrancl.cases
tff(fact_3063_converse__rtranclE_H,axiom,
    ! [B: $tType,U: B,V: B,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V),transitive_rtrancl(B,R))
     => ( ( U != V )
       => ~ ! [Vh: B] :
              ( ( U != Vh )
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),Vh),R)
               => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Vh),V),transitive_rtrancl(B,R)) ) ) ) ) ).

% converse_rtranclE'
tff(fact_3064_fun__upd__comp,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(D,C),Ga: fun(B,D),X: B,Y: D] : ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),fun_upd(B,D,Ga,X,Y)) = fun_upd(B,C,aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),Ga),X,aa(D,C,Fa,Y)) ) ).

% fun_upd_comp
tff(fact_3065_rtrancl__Un__separatorE,axiom,
    ! [B: $tType,A3: B,Ba: B,Pa: set(product_prod(B,B)),Qa: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),Pa),Qa)))
     => ( ! [X2: B,Y2: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),X2),transitive_rtrancl(B,Pa))
           => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),Qa)
             => ( X2 = Y2 ) ) )
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,Pa)) ) ) ).

% rtrancl_Un_separatorE
tff(fact_3066_rtrancl__Un__separator__converseE,axiom,
    ! [B: $tType,A3: B,Ba: B,Pa: set(product_prod(B,B)),Qa: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),Pa),Qa)))
     => ( ! [X2: B,Y2: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Ba),transitive_rtrancl(B,Pa))
           => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),X2),Qa)
             => ( Y2 = X2 ) ) )
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,Pa)) ) ) ).

% rtrancl_Un_separator_converseE
tff(fact_3067_converse__rtrancl__induct2,axiom,
    ! [B: $tType,C: $tType,Ax: B,Ay: C,Bx: B,By: C,R3: set(product_prod(product_prod(B,C),product_prod(B,C))),Pa: fun(B,fun(C,$o))] :
      ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Bx),By)),transitive_rtrancl(product_prod(B,C),R3))
     => ( aa(C,$o,aa(B,fun(C,$o),Pa,Bx),By)
       => ( ! [A8: B,B4: C,Aa2: B,Ba2: C] :
              ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Aa2),Ba2)),R3)
             => ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Aa2),Ba2)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Bx),By)),transitive_rtrancl(product_prod(B,C),R3))
               => ( aa(C,$o,aa(B,fun(C,$o),Pa,Aa2),Ba2)
                 => aa(C,$o,aa(B,fun(C,$o),Pa,A8),B4) ) ) )
         => aa(C,$o,aa(B,fun(C,$o),Pa,Ax),Ay) ) ) ) ).

% converse_rtrancl_induct2
tff(fact_3068_converse__rtranclE2,axiom,
    ! [C: $tType,B: $tType,Xa: B,Xb: C,Za2: B,Zb: C,R3: set(product_prod(product_prod(B,C),product_prod(B,C)))] :
      ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Xa),Xb)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Za2),Zb)),transitive_rtrancl(product_prod(B,C),R3))
     => ( ( aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Xa),Xb) != aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Za2),Zb) )
       => ~ ! [A8: B,B4: C] :
              ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Xa),Xb)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),R3)
             => ~ member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Za2),Zb)),transitive_rtrancl(product_prod(B,C),R3)) ) ) ) ).

% converse_rtranclE2
tff(fact_3069_rtrancl__induct2,axiom,
    ! [B: $tType,C: $tType,Ax: B,Ay: C,Bx: B,By: C,R3: set(product_prod(product_prod(B,C),product_prod(B,C))),Pa: fun(B,fun(C,$o))] :
      ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Bx),By)),transitive_rtrancl(product_prod(B,C),R3))
     => ( aa(C,$o,aa(B,fun(C,$o),Pa,Ax),Ay)
       => ( ! [A8: B,B4: C,Aa2: B,Ba2: C] :
              ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),transitive_rtrancl(product_prod(B,C),R3))
             => ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Aa2),Ba2)),R3)
               => ( aa(C,$o,aa(B,fun(C,$o),Pa,A8),B4)
                 => aa(C,$o,aa(B,fun(C,$o),Pa,Aa2),Ba2) ) ) )
         => aa(C,$o,aa(B,fun(C,$o),Pa,Bx),By) ) ) ) ).

% rtrancl_induct2
tff(fact_3070_SUP__Sup__eq2,axiom,
    ! [C: $tType,B: $tType,S2: set(set(product_prod(B,C))),X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Sup_Sup(fun(B,fun(C,$o))),aa(set(set(product_prod(B,C))),set(fun(B,fun(C,$o))),image2(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o)))),S2)),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),S2)) ) ).

% SUP_Sup_eq2
tff(fact_3071_Sup__SUP__eq2,axiom,
    ! [C: $tType,B: $tType,S2: set(fun(B,fun(C,$o))),X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Sup_Sup(fun(B,fun(C,$o))),S2),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(fun(product_prod(B,C),$o)),set(set(product_prod(B,C))),image2(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C))),aa(set(fun(B,fun(C,$o))),set(fun(product_prod(B,C),$o)),image2(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o)),S2)))) ) ).

% Sup_SUP_eq2
tff(fact_3072_trancl__subset__Sigma__aux,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),A4: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,R3))
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))
       => ( ( A3 = Ba )
          | member(B,A3,A4) ) ) ) ).

% trancl_subset_Sigma_aux
tff(fact_3073_Restr__rtrancl__mono,axiom,
    ! [B: $tType,V: B,W2: B,E4: set(product_prod(B,B)),U2: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),E4),product_Sigma(B,B,U2,aTP_Lamp_if(set(B),fun(B,set(B)),U2)))))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2),transitive_rtrancl(B,E4)) ) ).

% Restr_rtrancl_mono
tff(fact_3074_SUP__UN__eq2,axiom,
    ! [B: $tType,C: $tType,D: $tType,R3: fun(D,set(product_prod(B,C))),S2: set(D),X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Sup_Sup(fun(B,fun(C,$o))),aa(set(D),set(fun(B,fun(C,$o))),image2(D,fun(B,fun(C,$o)),aTP_Lamp_jg(fun(D,set(product_prod(B,C))),fun(D,fun(B,fun(C,$o))),R3)),S2)),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(D),set(set(product_prod(B,C))),image2(D,set(product_prod(B,C)),R3),S2))) ) ).

% SUP_UN_eq2
tff(fact_3075_rtrancl__mapI,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: B,E4: set(product_prod(B,B)),Fa: fun(B,C)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,E4))
     => member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),aa(B,C,Fa,A3)),aa(B,C,Fa,Ba)),transitive_rtrancl(C,aa(set(product_prod(B,B)),set(product_prod(C,C)),image2(product_prod(B,B),product_prod(C,C),pairself(B,C,Fa)),E4))) ) ).

% rtrancl_mapI
tff(fact_3076_above__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] : ( order_above(B,R3,A3) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3),A3)) ) ).

% above_def
tff(fact_3077_rtrancl__Int__subset,axiom,
    ! [B: $tType,S: set(product_prod(B,B)),R3: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),id2(B)),S)
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),relcomp(B,B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),transitive_rtrancl(B,R3)),S),R3)),S)
       => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),transitive_rtrancl(B,R3)),S) ) ) ).

% rtrancl_Int_subset
tff(fact_3078_rtrancl__last__touch,axiom,
    ! [B: $tType,Q2: B,Q4: B,R: set(product_prod(B,B)),S2: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),Q4),transitive_rtrancl(B,R))
     => ( member(B,Q2,S2)
       => ~ ! [Qt: B] :
              ( member(B,Qt,S2)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),Qt),transitive_rtrancl(B,R))
               => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Qt),Q4),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_if(set(B),fun(B,set(B)),S2))))) ) ) ) ) ).

% rtrancl_last_touch
tff(fact_3079_rtrancl__last__visit_H,axiom,
    ! [B: $tType,Q2: B,Q4: B,R: set(product_prod(B,B)),S2: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),Q4),transitive_rtrancl(B,R))
     => ( ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),Q4),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_if(set(B),fun(B,set(B)),S2)))))
       => ~ ! [Qt: B] :
              ( member(B,Qt,S2)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),Qt),transitive_rtrancl(B,R))
               => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Qt),Q4),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_if(set(B),fun(B,set(B)),S2))))) ) ) ) ) ).

% rtrancl_last_visit'
tff(fact_3080_rtrancl__insert,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B))] : ( transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba)),R3)) = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),transitive_rtrancl(B,R3)),aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aa(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o))),aTP_Lamp_jh(B,fun(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o)))),A3),Ba),R3)))) ) ).

% rtrancl_insert
tff(fact_3081_fun__upd__image,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),X: C,Y: B,A4: set(C)] :
      ( aa(set(C),set(B),image2(C,B,fun_upd(C,B,Fa,X,Y)),A4)
      = $ite(member(C,X,A4),aa(set(B),set(B),insert2(B,Y),aa(set(C),set(B),image2(C,B,Fa),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A4),aa(set(C),set(C),insert2(C,X),bot_bot(set(C)))))),aa(set(C),set(B),image2(C,B,Fa),A4)) ) ).

% fun_upd_image
tff(fact_3082_subset__mset_OcSUP__const,axiom,
    ! [B: $tType,C: $tType,A4: set(B),C2: multiset(C)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),aTP_Lamp_ji(multiset(C),fun(B,multiset(C)),C2)),A4)) = C2 ) ) ).

% subset_mset.cSUP_const
tff(fact_3083_Pow__fold,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( pow(B,A4) = finite_fold(B,set(set(B)),aTP_Lamp_jj(B,fun(set(set(B)),set(set(B)))),aa(set(set(B)),set(set(B)),insert2(set(B),bot_bot(set(B))),bot_bot(set(set(B)))),A4) ) ) ).

% Pow_fold
tff(fact_3084_chains__extend,axiom,
    ! [B: $tType,C2: set(set(B)),S2: set(set(B)),Z2: set(B)] :
      ( member(set(set(B)),C2,chains2(B,S2))
     => ( member(set(B),Z2,S2)
       => ( ! [X2: set(B)] :
              ( member(set(B),X2,C2)
             => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X2),Z2) )
         => member(set(set(B)),aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),aa(set(set(B)),set(set(B)),insert2(set(B),Z2),bot_bot(set(set(B))))),C2),chains2(B,S2)) ) ) ) ).

% chains_extend
tff(fact_3085_rtrancl__restrictI,axiom,
    ! [B: $tType,U: B,V: B,E4: set(product_prod(B,B)),R: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),E4),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_if(set(B),fun(B,set(B)),R)))))
     => ( ~ member(B,U,R)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V),transitive_rtrancl(B,rel_restrict(B,E4,R))) ) ) ).

% rtrancl_restrictI
tff(fact_3086_image__split__eq__Sigma,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(D,B),Ga: fun(D,C),A4: set(D)] : ( aa(set(D),set(product_prod(B,C)),image2(D,product_prod(B,C),aa(fun(D,C),fun(D,product_prod(B,C)),aTP_Lamp_jk(fun(D,B),fun(fun(D,C),fun(D,product_prod(B,C))),Fa),Ga)),A4) = product_Sigma(B,C,aa(set(D),set(B),image2(D,B,Fa),A4),aa(set(D),fun(B,set(C)),aa(fun(D,C),fun(set(D),fun(B,set(C))),aTP_Lamp_jl(fun(D,B),fun(fun(D,C),fun(set(D),fun(B,set(C)))),Fa),Ga),A4)) ) ).

% image_split_eq_Sigma
tff(fact_3087_subset__mset_OcSup__singleton,axiom,
    ! [B: $tType,X: multiset(B)] : ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B))))) = X ) ).

% subset_mset.cSup_singleton
tff(fact_3088_vimage__empty,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),bot_bot(set(C))) = bot_bot(set(B)) ) ).

% vimage_empty
tff(fact_3089_vimage__Int,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),A4: set(C),B2: set(C)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),A4)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),B2)) ) ).

% vimage_Int
tff(fact_3090_rel__restrict__empty,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] : ( rel_restrict(B,R,bot_bot(set(B))) = R ) ).

% rel_restrict_empty
tff(fact_3091_vimage__const,axiom,
    ! [C: $tType,B: $tType,C2: C,A4: set(C)] :
      ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),aTP_Lamp_bv(C,fun(B,C),C2)),A4)
      = $ite(member(C,C2,A4),top_top(set(B)),bot_bot(set(B))) ) ).

% vimage_const
tff(fact_3092_Pow__Int__eq,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( pow(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) = aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),inf_inf(set(set(B))),pow(B,A4)),pow(B,B2)) ) ).

% Pow_Int_eq
tff(fact_3093_image__vimage__eq,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),A4: set(B)] : ( aa(set(C),set(B),image2(C,B,Fa),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),Fa),A4)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(C),set(B),image2(C,B,Fa),top_top(set(C)))) ) ).

% image_vimage_eq
tff(fact_3094_vimage__if,axiom,
    ! [C: $tType,B: $tType,B2: set(B),C2: C,D2: C,A4: set(C)] :
      ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),aa(C,fun(B,C),aa(C,fun(C,fun(B,C)),aTP_Lamp_jm(set(B),fun(C,fun(C,fun(B,C))),B2),C2),D2)),A4)
      = $ite(
          member(C,C2,A4),
          $ite(member(C,D2,A4),top_top(set(B)),B2),
          $ite(member(C,D2,A4),aa(set(B),set(B),uminus_uminus(set(B)),B2),bot_bot(set(B))) ) ) ).

% vimage_if
tff(fact_3095_Pow__singleton__iff,axiom,
    ! [B: $tType,X6: set(B),Y5: set(B)] :
      ( ( pow(B,X6) = aa(set(set(B)),set(set(B)),insert2(set(B),Y5),bot_bot(set(set(B)))) )
    <=> ( ( X6 = bot_bot(set(B)) )
        & ( Y5 = bot_bot(set(B)) ) ) ) ).

% Pow_singleton_iff
tff(fact_3096_Pow__empty,axiom,
    ! [B: $tType] : ( pow(B,bot_bot(set(B))) = aa(set(set(B)),set(set(B)),insert2(set(B),bot_bot(set(B))),bot_bot(set(set(B)))) ) ).

% Pow_empty
tff(fact_3097_vimage__inter__cong,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,C),Ga: fun(B,C),Y: set(C)] :
      ( ! [W: B] :
          ( member(B,W,S2)
         => ( aa(B,C,Fa,W) = aa(B,C,Ga,W) ) )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),Y)),S2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Ga),Y)),S2) ) ) ).

% vimage_inter_cong
tff(fact_3098_Sup__multiset__empty,axiom,
    ! [B: $tType] : ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),bot_bot(set(multiset(B)))) = zero_zero(multiset(B)) ) ).

% Sup_multiset_empty
tff(fact_3099_vimage__comp,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(B,C),Ga: fun(C,D),X: set(D)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),aa(set(D),set(C),aa(fun(C,D),fun(set(D),set(C)),vimage(C,D),Ga),X)) = aa(set(D),set(B),aa(fun(B,D),fun(set(D),set(B)),vimage(B,D),aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),Fa)),X) ) ).

% vimage_comp
tff(fact_3100_set_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(B,C),Ga: fun(C,D),Set: set(D)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),aa(set(D),set(C),aa(fun(C,D),fun(set(D),set(C)),vimage(C,D),Ga),Set)) = aa(set(D),set(B),aa(fun(B,D),fun(set(D),set(B)),vimage(B,D),aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),Fa)),Set) ) ).

% set.compositionality
tff(fact_3101_Pow__bottom,axiom,
    ! [B: $tType,B2: set(B)] : member(set(B),bot_bot(set(B)),pow(B,B2)) ).

% Pow_bottom
tff(fact_3102_rel__restrict__notR_I2_J,axiom,
    ! [B: $tType,X: B,Y: B,A4: set(product_prod(B,B)),R: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),rel_restrict(B,A4,R))
     => ~ member(B,Y,R) ) ).

% rel_restrict_notR(2)
tff(fact_3103_rel__restrict__notR_I1_J,axiom,
    ! [B: $tType,X: B,Y: B,A4: set(product_prod(B,B)),R: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),rel_restrict(B,A4,R))
     => ~ member(B,X,R) ) ).

% rel_restrict_notR(1)
tff(fact_3104_rel__restrictI,axiom,
    ! [B: $tType,X: B,R: set(B),Y: B,E4: set(product_prod(B,B))] :
      ( ~ member(B,X,R)
     => ( ~ member(B,Y,R)
       => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),E4)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),rel_restrict(B,E4,R)) ) ) ) ).

% rel_restrictI
tff(fact_3105_rel__restrict__lift,axiom,
    ! [B: $tType,X: B,Y: B,E4: set(product_prod(B,B)),R: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),rel_restrict(B,E4,R))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),E4) ) ).

% rel_restrict_lift
tff(fact_3106_Pow__not__empty,axiom,
    ! [B: $tType,A4: set(B)] : ( pow(B,A4) != bot_bot(set(set(B))) ) ).

% Pow_not_empty
tff(fact_3107_vimage__singleton__eq,axiom,
    ! [B: $tType,C: $tType,A3: B,Fa: fun(B,C),Ba: C] :
      ( member(B,A3,aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),aa(set(C),set(C),insert2(C,Ba),bot_bot(set(C)))))
    <=> ( aa(B,C,Fa,A3) = Ba ) ) ).

% vimage_singleton_eq
tff(fact_3108_vimage__Times,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(B,product_prod(C,D)),A4: set(C),B2: set(D)] : ( aa(set(product_prod(C,D)),set(B),aa(fun(B,product_prod(C,D)),fun(set(product_prod(C,D)),set(B)),vimage(B,product_prod(C,D)),Fa),product_Sigma(C,D,A4,aTP_Lamp_jn(set(D),fun(C,set(D)),B2))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),aa(fun(B,product_prod(C,D)),fun(B,C),aa(fun(product_prod(C,D),C),fun(fun(B,product_prod(C,D)),fun(B,C)),comp(product_prod(C,D),C,B),product_fst(C,D)),Fa)),A4)),aa(set(D),set(B),aa(fun(B,D),fun(set(D),set(B)),vimage(B,D),aa(fun(B,product_prod(C,D)),fun(B,D),aa(fun(product_prod(C,D),D),fun(fun(B,product_prod(C,D)),fun(B,D)),comp(product_prod(C,D),D,B),product_snd(C,D)),Fa)),B2)) ) ).

% vimage_Times
tff(fact_3109_set_Ocomp,axiom,
    ! [B: $tType,D: $tType,C: $tType,Fa: fun(C,D),Ga: fun(D,B)] : ( aa(fun(set(B),set(D)),fun(set(B),set(C)),aa(fun(set(D),set(C)),fun(fun(set(B),set(D)),fun(set(B),set(C))),comp(set(D),set(C),set(B)),aa(fun(C,D),fun(set(D),set(C)),vimage(C,D),Fa)),aa(fun(D,B),fun(set(B),set(D)),vimage(D,B),Ga)) = aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),aa(fun(C,D),fun(C,B),aa(fun(D,B),fun(fun(C,D),fun(C,B)),comp(D,B,C),Ga),Fa)) ) ).

% set.comp
tff(fact_3110_Pair__vimage__Sigma,axiom,
    ! [C: $tType,B: $tType,X: C,A4: set(C),Fa: fun(C,set(B))] :
      ( aa(set(product_prod(C,B)),set(B),aa(fun(B,product_prod(C,B)),fun(set(product_prod(C,B)),set(B)),vimage(B,product_prod(C,B)),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X)),product_Sigma(C,B,A4,Fa))
      = $ite(member(C,X,A4),aa(C,set(B),Fa,X),bot_bot(set(B))) ) ).

% Pair_vimage_Sigma
tff(fact_3111_surj__vimage__empty,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,B),A4: set(B)] :
      ( ( aa(set(C),set(B),image2(C,B,Fa),top_top(set(C))) = top_top(set(B)) )
     => ( ( aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),Fa),A4) = bot_bot(set(C)) )
      <=> ( A4 = bot_bot(set(B)) ) ) ) ).

% surj_vimage_empty
tff(fact_3112_vimage__insert,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),A3: C,B2: set(C)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),aa(set(C),set(C),insert2(C,A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),aa(set(C),set(C),insert2(C,A3),bot_bot(set(C))))),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),B2)) ) ).

% vimage_insert
tff(fact_3113_finite__vimage__IntI,axiom,
    ! [B: $tType,C: $tType,F: set(B),H2: fun(C,B),A4: set(C)] :
      ( aa(set(B),$o,finite_finite(B),F)
     => ( inj_on(C,B,H2,A4)
       => aa(set(C),$o,finite_finite(C),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),H2),F)),A4)) ) ) ).

% finite_vimage_IntI
tff(fact_3114_rel__restrict__def,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),A4: set(B)] : ( rel_restrict(B,R,A4) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(B),fun(B,fun(B,$o)),aTP_Lamp_jo(set(product_prod(B,B)),fun(set(B),fun(B,fun(B,$o))),R),A4))) ) ).

% rel_restrict_def
tff(fact_3115_inf__img__fin__domE,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,B),A4: set(C)] :
      ( aa(set(B),$o,finite_finite(B),aa(set(C),set(B),image2(C,B,Fa),A4))
     => ( ~ aa(set(C),$o,finite_finite(C),A4)
       => ~ ! [Y2: B] :
              ( member(B,Y2,aa(set(C),set(B),image2(C,B,Fa),A4))
             => aa(set(C),$o,finite_finite(C),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),Fa),aa(set(B),set(B),insert2(B,Y2),bot_bot(set(B))))) ) ) ) ).

% inf_img_fin_domE
tff(fact_3116_inf__img__fin__dom,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,B),A4: set(C)] :
      ( aa(set(B),$o,finite_finite(B),aa(set(C),set(B),image2(C,B,Fa),A4))
     => ( ~ aa(set(C),$o,finite_finite(C),A4)
       => ? [X2: B] :
            ( member(B,X2,aa(set(C),set(B),image2(C,B,Fa),A4))
            & ~ aa(set(C),$o,finite_finite(C),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),Fa),aa(set(B),set(B),insert2(B,X2),bot_bot(set(B))))) ) ) ) ).

% inf_img_fin_dom
tff(fact_3117_finite__finite__vimage__IntI,axiom,
    ! [B: $tType,C: $tType,F: set(B),H2: fun(C,B),A4: set(C)] :
      ( aa(set(B),$o,finite_finite(B),F)
     => ( ! [Y2: B] :
            ( member(B,Y2,F)
           => aa(set(C),$o,finite_finite(C),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),H2),aa(set(B),set(B),insert2(B,Y2),bot_bot(set(B))))),A4)) )
       => aa(set(C),$o,finite_finite(C),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),H2),F)),A4)) ) ) ).

% finite_finite_vimage_IntI
tff(fact_3118_rel__restrict__Int__empty,axiom,
    ! [B: $tType,A4: set(B),R: set(product_prod(B,B))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),field2(B,R)) = bot_bot(set(B)) )
     => ( rel_restrict(B,R,A4) = R ) ) ).

% rel_restrict_Int_empty
tff(fact_3119_vimage__eq__UN,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),B2: set(C)] : ( aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),B2) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_jp(fun(B,C),fun(C,set(B)),Fa)),B2)) ) ).

% vimage_eq_UN
tff(fact_3120_rel__restrict__compl,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),A4: set(B)] : ( aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),rel_restrict(B,R,A4)),rel_restrict(B,R,aa(set(B),set(B),uminus_uminus(set(B)),A4))) = bot_bot(set(product_prod(B,B))) ) ).

% rel_restrict_compl
tff(fact_3121_inf__img__fin__domE_H,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),A4: set(C)] :
      ( aa(set(B),$o,finite_finite(B),aa(set(C),set(B),image2(C,B,Fa),A4))
     => ( ~ aa(set(C),$o,finite_finite(C),A4)
       => ~ ! [Y2: B] :
              ( member(B,Y2,aa(set(C),set(B),image2(C,B,Fa),A4))
             => aa(set(C),$o,finite_finite(C),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),Fa),aa(set(B),set(B),insert2(B,Y2),bot_bot(set(B))))),A4)) ) ) ) ).

% inf_img_fin_domE'
tff(fact_3122_inf__img__fin__dom_H,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),A4: set(C)] :
      ( aa(set(B),$o,finite_finite(B),aa(set(C),set(B),image2(C,B,Fa),A4))
     => ( ~ aa(set(C),$o,finite_finite(C),A4)
       => ? [X2: B] :
            ( member(B,X2,aa(set(C),set(B),image2(C,B,Fa),A4))
            & ~ aa(set(C),$o,finite_finite(C),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),Fa),aa(set(B),set(B),insert2(B,X2),bot_bot(set(B))))),A4)) ) ) ) ).

% inf_img_fin_dom'
tff(fact_3123_rel__restrict__alt__def,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),A4: set(B)] : ( rel_restrict(B,R,A4) = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R),product_Sigma(B,B,aa(set(B),set(B),uminus_uminus(set(B)),A4),aTP_Lamp_jq(set(B),fun(B,set(B)),A4))) ) ).

% rel_restrict_alt_def
tff(fact_3124_card__vimage__inj__on__le,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),D4: set(B),A4: set(C)] :
      ( inj_on(B,C,Fa,D4)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),A4)),D4))),finite_card(C,A4)) ) ) ).

% card_vimage_inj_on_le
tff(fact_3125_Fpow__Pow__finite,axiom,
    ! [B: $tType,A4: set(B)] : ( finite_Fpow(B,A4) = aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),inf_inf(set(set(B))),pow(B,A4)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),finite_finite(B))) ) ).

% Fpow_Pow_finite
tff(fact_3126_inj__on__vimage__singleton,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),A4: set(B),A3: C] :
      ( inj_on(B,C,Fa,A4)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),aa(set(C),set(C),insert2(C,A3),bot_bot(set(C))))),A4)),aa(set(B),set(B),insert2(B,the(B,aa(C,fun(B,$o),aa(set(B),fun(C,fun(B,$o)),aTP_Lamp_jr(fun(B,C),fun(set(B),fun(C,fun(B,$o))),Fa),A4),A3))),bot_bot(set(B)))) ) ).

% inj_on_vimage_singleton
tff(fact_3127_inj__vimage__singleton,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),A3: C] :
      ( inj_on(B,C,Fa,top_top(set(B)))
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Fa),aa(set(C),set(C),insert2(C,A3),bot_bot(set(C))))),aa(set(B),set(B),insert2(B,the(B,aa(C,fun(B,$o),aTP_Lamp_js(fun(B,C),fun(C,fun(B,$o)),Fa),A3))),bot_bot(set(B)))) ) ).

% inj_vimage_singleton
tff(fact_3128_comp__fun__idem__on_Ocomp__comp__fun__idem__on,axiom,
    ! [C: $tType,B: $tType,D: $tType,S2: set(B),Fa: fun(B,fun(C,C)),Ga: fun(D,B),R: set(D)] :
      ( finite673082921795544331dem_on(B,C,S2,Fa)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(D),set(B),image2(D,B,Ga),top_top(set(D)))),S2)
       => finite673082921795544331dem_on(D,C,R,aa(fun(D,B),fun(D,fun(C,C)),aa(fun(B,fun(C,C)),fun(fun(D,B),fun(D,fun(C,C))),comp(B,fun(C,C),D),Fa),Ga)) ) ) ).

% comp_fun_idem_on.comp_comp_fun_idem_on
tff(fact_3129_ref__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: B] : hoare_hoare_triple(ref(B),one_one(assn),ref_ref(B,X),aa(B,fun(ref(B),assn),aTP_Lamp_bj(B,fun(ref(B),assn)),X)) ) ).

% ref_rule
tff(fact_3130_The__split__eq,axiom,
    ! [B: $tType,C: $tType,X: B,Y: C] : ( the(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(C,fun(B,fun(C,$o)),aTP_Lamp_jt(B,fun(C,fun(B,fun(C,$o))),X),Y))) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y) ) ).

% The_split_eq
tff(fact_3131_comp__fun__idem__on_Ocomp__fun__idem__on,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C)),X: B] :
      ( finite673082921795544331dem_on(B,C,S2,Fa)
     => ( member(B,X,S2)
       => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X)),aa(B,fun(C,C),Fa,X)) = aa(B,fun(C,C),Fa,X) ) ) ) ).

% comp_fun_idem_on.comp_fun_idem_on
tff(fact_3132_empty__in__Fpow,axiom,
    ! [B: $tType,A4: set(B)] : member(set(B),bot_bot(set(B)),finite_Fpow(B,A4)) ).

% empty_in_Fpow
tff(fact_3133_Fpow__not__empty,axiom,
    ! [B: $tType,A4: set(B)] : ( finite_Fpow(B,A4) != bot_bot(set(set(B))) ) ).

% Fpow_not_empty
tff(fact_3134_the__elem__def,axiom,
    ! [B: $tType,X6: set(B)] : ( the_elem(B,X6) = the(B,aTP_Lamp_ju(set(B),fun(B,$o),X6)) ) ).

% the_elem_def
tff(fact_3135_image__o__collect,axiom,
    ! [C: $tType,D: $tType,B: $tType,Ga: fun(D,C),F: set(fun(B,set(D)))] : ( bNF_collect(B,C,aa(set(fun(B,set(D))),set(fun(B,set(C))),image2(fun(B,set(D)),fun(B,set(C)),aa(fun(set(D),set(C)),fun(fun(B,set(D)),fun(B,set(C))),comp(set(D),set(C),B),image2(D,C,Ga))),F)) = aa(fun(B,set(D)),fun(B,set(C)),aa(fun(set(D),set(C)),fun(fun(B,set(D)),fun(B,set(C))),comp(set(D),set(C),B),image2(D,C,Ga)),bNF_collect(B,D,F)) ) ).

% image_o_collect
tff(fact_3136_of__list__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Xs: list(B)] : hoare_hoare_triple(array(B),one_one(assn),array_of_list(B,Xs),aa(list(B),fun(array(B),assn),aTP_Lamp_bk(list(B),fun(array(B),assn)),Xs)) ) ).

% of_list_rule
tff(fact_3137_INT__simps_I4_J,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: fun(C,set(B)),C3: set(C)] :
      ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_jv(set(B),fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C3))
      = $ite(C3 = bot_bot(set(C)),top_top(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C3)))) ) ).

% INT_simps(4)
tff(fact_3138_sum__mult__sum__if__inj,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( semiring_0(D)
     => ! [Fa: fun(B,D),Ga: fun(C,D),A4: set(B),B2: set(C)] :
          ( inj_on(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),aa(fun(C,D),fun(B,fun(C,D)),aTP_Lamp_jw(fun(B,D),fun(fun(C,D),fun(B,fun(C,D))),Fa),Ga)),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))
         => ( aa(D,D,aa(D,fun(D,D),times_times(D),aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),Fa),A4)),aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),Ga),B2)) = aa(set(D),D,aa(fun(D,D),fun(set(D),D),groups7311177749621191930dd_sum(D,D),id(D)),aa(fun(D,$o),set(D),collect(D),aa(set(C),fun(D,$o),aa(set(B),fun(set(C),fun(D,$o)),aa(fun(C,D),fun(set(B),fun(set(C),fun(D,$o))),aTP_Lamp_jx(fun(B,D),fun(fun(C,D),fun(set(B),fun(set(C),fun(D,$o)))),Fa),Ga),A4),B2))) ) ) ) ).

% sum_mult_sum_if_inj
tff(fact_3139_card__UNION,axiom,
    ! [B: $tType,A4: set(set(B))] :
      ( aa(set(set(B)),$o,finite_finite(set(B)),A4)
     => ( ! [X2: set(B)] :
            ( member(set(B),X2,A4)
           => aa(set(B),$o,finite_finite(B),X2) )
       => ( finite_card(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),A4)) = aa(int,nat,nat2,aa(set(set(set(B))),int,aa(fun(set(set(B)),int),fun(set(set(set(B))),int),groups7311177749621191930dd_sum(set(set(B)),int),aTP_Lamp_jy(set(set(B)),int)),aa(fun(set(set(B)),$o),set(set(set(B))),collect(set(set(B))),aTP_Lamp_jz(set(set(B)),fun(set(set(B)),$o),A4)))) ) ) ) ).

% card_UNION
tff(fact_3140_ex__assn__proper,axiom,
    ! [B: $tType,Pa: fun(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o))] :
      ( ! [X2: B] : aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa,X2))
     => aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),$o,proper,aTP_Lamp_ka(fun(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa)) ) ).

% ex_assn_proper
tff(fact_3141_Inf__eq__bot__iff,axiom,
    ! [B: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [A4: set(B)] :
          ( ( aa(set(B),B,complete_Inf_Inf(B),A4) = bot_bot(B) )
        <=> ! [X4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),bot_bot(B)),X4)
             => ? [Xa2: B] :
                  ( member(B,Xa2,A4)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Xa2),X4) ) ) ) ) ).

% Inf_eq_bot_iff
tff(fact_3142_Inf__empty,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(B),B,complete_Inf_Inf(B),bot_bot(set(B))) = top_top(B) ) ) ).

% Inf_empty
tff(fact_3143_Inf__UNIV,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(B),B,complete_Inf_Inf(B),top_top(set(B))) = bot_bot(B) ) ) ).

% Inf_UNIV
tff(fact_3144_cInf__singleton,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X: B] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = X ) ) ).

% cInf_singleton
tff(fact_3145_Inf__insert,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: B,A4: set(B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert2(B,A3),A4)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(set(B),B,complete_Inf_Inf(B),A4)) ) ) ).

% Inf_insert
tff(fact_3146_Inf__atMost,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [X: B] : ( aa(set(B),B,complete_Inf_Inf(B),set_ord_atMost(B,X)) = bot_bot(B) ) ) ).

% Inf_atMost
tff(fact_3147_cINF__const,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),C2: C] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,aTP_Lamp_hm(C,fun(B,C),C2)),A4)) = C2 ) ) ) ).

% cINF_const
tff(fact_3148_INF__const,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A4: set(B),Fa: C] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,aTP_Lamp_hn(C,fun(B,C),Fa)),A4)) = Fa ) ) ) ).

% INF_const
tff(fact_3149_INF__eq__bot__iff,axiom,
    ! [C: $tType,B: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [Fa: fun(C,B),A4: set(C)] :
          ( ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Fa),A4)) = bot_bot(B) )
        <=> ! [X4: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),bot_bot(B)),X4)
             => ? [Xa2: C] :
                  ( member(C,Xa2,A4)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(C,B,Fa,Xa2)),X4) ) ) ) ) ).

% INF_eq_bot_iff
tff(fact_3150_INT__constant,axiom,
    ! [C: $tType,B: $tType,C2: set(B),A4: set(C)] :
      ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_ho(set(B),fun(C,set(B)),C2)),A4))
      = $ite(A4 = bot_bot(set(C)),top_top(set(B)),C2) ) ).

% INT_constant
tff(fact_3151_INT__insert,axiom,
    ! [B: $tType,C: $tType,B2: fun(C,set(B)),A3: C,A4: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),aa(set(C),set(C),insert2(C,A3),A4))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(C,set(B),B2,A3)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),A4))) ) ).

% INT_insert
tff(fact_3152_Inf__atMostLessThan,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),top_top(B)),X)
         => ( aa(set(B),B,complete_Inf_Inf(B),set_ord_lessThan(B,X)) = bot_bot(B) ) ) ) ).

% Inf_atMostLessThan
tff(fact_3153_INT__simps_I2_J,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: fun(C,set(B)),C3: set(C)] :
      ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_im(set(B),fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C3))
      = $ite(C3 = bot_bot(set(C)),top_top(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C3)))) ) ).

% INT_simps(2)
tff(fact_3154_INT__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,A4: fun(C,set(B)),B2: set(B),C3: set(C)] :
      ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_in(fun(C,set(B)),fun(set(B),fun(C,set(B))),A4),B2)),C3))
      = $ite(C3 = bot_bot(set(C)),top_top(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),C3))),B2)) ) ).

% INT_simps(1)
tff(fact_3155_INT__simps_I3_J,axiom,
    ! [C: $tType,B: $tType,A4: fun(C,set(B)),B2: set(B),C3: set(C)] :
      ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_kb(fun(C,set(B)),fun(set(B),fun(C,set(B))),A4),B2)),C3))
      = $ite(C3 = bot_bot(set(C)),top_top(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),C3))),B2)) ) ).

% INT_simps(3)
tff(fact_3156_pairself__image__eq,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),Pa: fun(C,fun(C,$o))] : ( aa(set(product_prod(C,C)),set(product_prod(B,B)),image2(product_prod(C,C),product_prod(B,B),pairself(C,B,Fa)),aa(fun(product_prod(C,C),$o),set(product_prod(C,C)),collect(product_prod(C,C)),aa(fun(C,fun(C,$o)),fun(product_prod(C,C),$o),product_case_prod(C,C,$o),Pa))) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(C,fun(C,$o)),fun(product_prod(B,B),$o),aTP_Lamp_kc(fun(C,B),fun(fun(C,fun(C,$o)),fun(product_prod(B,B),$o)),Fa),Pa)) ) ).

% pairself_image_eq
tff(fact_3157_euclidean__size__int__def,axiom,
    euclid6346220572633701492n_size(int) = aa(fun(int,int),fun(int,nat),aa(fun(int,nat),fun(fun(int,int),fun(int,nat)),comp(int,nat,int),nat2),abs_abs(int)) ).

% euclidean_size_int_def
tff(fact_3158_num__of__integer_Orsp,axiom,
    aa(fun(int,num),$o,aa(fun(int,num),fun(fun(int,num),$o),bNF_rel_fun(int,int,num,num,fequal(int),fequal(num)),aa(fun(int,nat),fun(int,num),aa(fun(nat,num),fun(fun(int,nat),fun(int,num)),comp(nat,num,int),num_of_nat),nat2)),aa(fun(int,nat),fun(int,num),aa(fun(nat,num),fun(fun(int,nat),fun(int,num)),comp(nat,num,int),num_of_nat),nat2)) ).

% num_of_integer.rsp
tff(fact_3159_Inf__less__eq,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B),U: B] :
          ( ! [V3: B] :
              ( member(B,V3,A4)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),V3),U) )
         => ( ( A4 != bot_bot(set(B)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),A4)),U) ) ) ) ).

% Inf_less_eq
tff(fact_3160_cInf__eq__non__empty,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X6: set(B),A3: B] :
          ( ( X6 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,X6)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),X2) )
           => ( ! [Y2: B] :
                  ( ! [X3: B] :
                      ( member(B,X3,X6)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),X3) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),A3) )
             => ( aa(set(B),B,complete_Inf_Inf(B),X6) = A3 ) ) ) ) ) ).

% cInf_eq_non_empty
tff(fact_3161_cInf__greatest,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X6: set(B),Z2: B] :
          ( ( X6 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,X6)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),X2) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),aa(set(B),B,complete_Inf_Inf(B),X6)) ) ) ) ).

% cInf_greatest
tff(fact_3162_cInf__lessD,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X6: set(B),Z2: B] :
          ( ( X6 != bot_bot(set(B)) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,complete_Inf_Inf(B),X6)),Z2)
           => ? [X2: B] :
                ( member(B,X2,X6)
                & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X2),Z2) ) ) ) ) ).

% cInf_lessD
tff(fact_3163_INF__eq__const,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I4: set(B),Fa: fun(B,C),X: C] :
          ( ( I4 != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( member(B,I3,I4)
               => ( aa(B,C,Fa,I3) = X ) )
           => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),I4)) = X ) ) ) ) ).

% INF_eq_const
tff(fact_3164_bot__finite__def,axiom,
    ! [B: $tType] :
      ( finite_lattice(B)
     => ( bot_bot(B) = aa(set(B),B,complete_Inf_Inf(B),top_top(set(B))) ) ) ).

% bot_finite_def
tff(fact_3165_sup__Inf,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A3: B,B2: set(B)] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),aa(set(B),B,complete_Inf_Inf(B),B2)) = aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),sup_sup(B),A3)),B2)) ) ) ).

% sup_Inf
tff(fact_3166_INF__image,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( complete_Inf(B)
     => ! [Ga: fun(C,B),Fa: fun(D,C),A4: set(D)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Ga),aa(set(D),set(C),image2(D,C,Fa),A4))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Ga),Fa)),A4)) ) ) ).

% INF_image
tff(fact_3167_Inf__sup__eq__top__iff,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [B2: set(B),A3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Inf_Inf(B),B2)),A3) = top_top(B) )
        <=> ! [X4: B] :
              ( member(B,X4,B2)
             => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X4),A3) = top_top(B) ) ) ) ) ).

% Inf_sup_eq_top_iff
tff(fact_3168_Inf__finite__insert,axiom,
    ! [B: $tType] :
      ( finite_lattice(B)
     => ! [A3: B,A4: set(B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert2(B,A3),A4)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(set(B),B,complete_Inf_Inf(B),A4)) ) ) ).

% Inf_finite_insert
tff(fact_3169_Inf__union__distrib,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B),B2: set(B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),A4)),aa(set(B),B,complete_Inf_Inf(B),B2)) ) ) ).

% Inf_union_distrib
tff(fact_3170_infinite__int__iff__infinite__nat__abs,axiom,
    ! [S2: set(int)] :
      ( ~ aa(set(int),$o,finite_finite(int),S2)
    <=> ~ aa(set(nat),$o,finite_finite(nat),aa(set(int),set(nat),image2(int,nat,aa(fun(int,int),fun(int,nat),aa(fun(int,nat),fun(fun(int,int),fun(int,nat)),comp(int,nat,int),nat2),abs_abs(int))),S2)) ) ).

% infinite_int_iff_infinite_nat_abs
tff(fact_3171_Inter__subset,axiom,
    ! [B: $tType,A4: set(set(B)),B2: set(B)] :
      ( ! [X7: set(B)] :
          ( member(set(B),X7,A4)
         => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X7),B2) )
     => ( ( A4 != bot_bot(set(set(B))) )
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),A4)),B2) ) ) ).

% Inter_subset
tff(fact_3172_Inter__empty,axiom,
    ! [B: $tType] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),bot_bot(set(set(B)))) = top_top(set(B)) ) ).

% Inter_empty
tff(fact_3173_inj__on__Inter,axiom,
    ! [C: $tType,B: $tType,S2: set(set(B)),Fa: fun(B,C)] :
      ( ( S2 != bot_bot(set(set(B))) )
     => ( ! [A12: set(B)] :
            ( member(set(B),A12,S2)
           => inj_on(B,C,Fa,A12) )
       => inj_on(B,C,Fa,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),S2)) ) ) ).

% inj_on_Inter
tff(fact_3174_finite__inf__Sup,axiom,
    ! [B: $tType] :
      ( finite8700451911770168679attice(B)
     => ! [A3: B,A4: set(B)] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(set(B),B,complete_Sup_Sup(B),A4)) = aa(set(B),B,complete_Sup_Sup(B),aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_kd(B,fun(set(B),fun(B,$o)),A3),A4))) ) ) ).

% finite_inf_Sup
tff(fact_3175_INF__inf__distrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(C,B),A4: set(C),Ga: fun(C,B)] : ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Fa),A4))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Ga),A4))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ke(fun(C,B),fun(fun(C,B),fun(C,B)),Fa),Ga)),A4)) ) ) ).

% INF_inf_distrib
tff(fact_3176_INF__absorb,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [K: B,I4: set(B),A4: fun(B,C)] :
          ( member(B,K,I4)
         => ( aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,A4,K)),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,A4),I4))) = aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,A4),I4)) ) ) ) ).

% INF_absorb
tff(fact_3177_INF__sup,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Fa: fun(C,B),B2: set(C),A3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Fa),B2))),A3) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(B,fun(C,B),aTP_Lamp_kf(fun(C,B),fun(B,fun(C,B)),Fa),A3)),B2)) ) ) ).

% INF_sup
tff(fact_3178_Inf__sup,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [B2: set(B),A3: B] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Inf_Inf(B),B2)),A3) = aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),image2(B,B,aTP_Lamp_kg(B,fun(B,B),A3)),B2)) ) ) ).

% Inf_sup
tff(fact_3179_sup__INF,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [A3: B,Fa: fun(C,B),B2: set(C)] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Fa),B2))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_kh(B,fun(fun(C,B),fun(C,B)),A3),Fa)),B2)) ) ) ).

% sup_INF
tff(fact_3180_INF__sup__distrib2,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Fa: fun(C,B),A4: set(C),Ga: fun(D,B),B2: set(D)] : ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Fa),A4))),aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,Ga),B2))) = aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_kj(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),Fa),Ga),B2)),A4)) ) ) ).

% INF_sup_distrib2
tff(fact_3181_Inter__insert,axiom,
    ! [B: $tType,A3: set(B),B2: set(set(B))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),insert2(set(B),A3),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B2)) ) ).

% Inter_insert
tff(fact_3182_Id__def,axiom,
    ! [B: $tType] : ( id2(B) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aTP_Lamp_kk(product_prod(B,B),$o)) ) ).

% Id_def
tff(fact_3183_Inter__UNIV,axiom,
    ! [B: $tType] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),top_top(set(set(B)))) = bot_bot(set(B)) ) ).

% Inter_UNIV
tff(fact_3184_Inter__Un__distrib,axiom,
    ! [B: $tType,A4: set(set(B)),B2: set(set(B))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),A4)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B2)) ) ).

% Inter_Un_distrib
tff(fact_3185_Int__Inter__image,axiom,
    ! [B: $tType,C: $tType,A4: fun(C,set(B)),B2: fun(C,set(B)),C3: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_kl(fun(C,set(B)),fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),C3))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C3))) ) ).

% Int_Inter_image
tff(fact_3186_INT__Int__distrib,axiom,
    ! [B: $tType,C: $tType,A4: fun(C,set(B)),B2: fun(C,set(B)),I4: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_kl(fun(C,set(B)),fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),I4)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),I4))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),I4))) ) ).

% INT_Int_distrib
tff(fact_3187_INT__absorb,axiom,
    ! [C: $tType,B: $tType,K: B,I4: set(B),A4: fun(B,set(C))] :
      ( member(B,K,I4)
     => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),A4,K)),aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4))) = aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4)) ) ) ).

% INT_absorb
tff(fact_3188_INT__bool__eq,axiom,
    ! [B: $tType,A4: fun($o,set(B))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set($o),set(set(B)),image2($o,set(B),A4),top_top(set($o)))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa($o,set(B),A4,$true)),aa($o,set(B),A4,$false)) ) ).

% INT_bool_eq
tff(fact_3189_INF__eq__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I4: set(B),Fa: fun(B,C),C2: C] :
          ( ( I4 != bot_bot(set(B)) )
         => ( ! [I3: B] :
                ( member(B,I3,I4)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,I3)),C2) )
           => ( ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),I4)) = C2 )
            <=> ! [X4: B] :
                  ( member(B,X4,I4)
                 => ( aa(B,C,Fa,X4) = C2 ) ) ) ) ) ) ).

% INF_eq_iff
tff(fact_3190_cINF__greatest,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),M4: C,Fa: fun(B,C)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,A4)
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),M4),aa(B,C,Fa,X2)) )
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),M4),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4))) ) ) ) ).

% cINF_greatest
tff(fact_3191_finite__less__Inf__iff,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X6: set(B),A3: B] :
          ( aa(set(B),$o,finite_finite(B),X6)
         => ( ( X6 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),aa(set(B),B,complete_Inf_Inf(B),X6))
            <=> ! [X4: B] :
                  ( member(B,X4,X6)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),X4) ) ) ) ) ) ).

% finite_less_Inf_iff
tff(fact_3192_Inf__le__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),A4)),aa(set(B),B,complete_Sup_Sup(B),A4)) ) ) ).

% Inf_le_Sup
tff(fact_3193_finite__Inf__in,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [X2: B,Y2: B] :
                  ( member(B,X2,A4)
                 => ( member(B,Y2,A4)
                   => member(B,aa(B,B,aa(B,fun(B,B),inf_inf(B),X2),Y2),A4) ) )
             => member(B,aa(set(B),B,complete_Inf_Inf(B),A4),A4) ) ) ) ) ).

% finite_Inf_in
tff(fact_3194_cInf__abs__ge,axiom,
    ! [B: $tType] :
      ( ( condit6923001295902523014norder(B)
        & linordered_idom(B) )
     => ! [S2: set(B),A3: B] :
          ( ( S2 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,S2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),X2)),A3) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(set(B),B,complete_Inf_Inf(B),S2))),A3) ) ) ) ).

% cInf_abs_ge
tff(fact_3195_less__eq__Inf__inter,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B),B2: set(B)] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Inf_Inf(B),A4)),aa(set(B),B,complete_Inf_Inf(B),B2))),aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ).

% less_eq_Inf_inter
tff(fact_3196_Inf__finite__empty,axiom,
    ! [B: $tType] :
      ( finite_lattice(B)
     => ( aa(set(B),B,complete_Inf_Inf(B),bot_bot(set(B))) = aa(set(B),B,complete_Sup_Sup(B),top_top(set(B))) ) ) ).

% Inf_finite_empty
tff(fact_3197_Sup__finite__empty,axiom,
    ! [B: $tType] :
      ( finite_lattice(B)
     => ( aa(set(B),B,complete_Sup_Sup(B),bot_bot(set(B))) = aa(set(B),B,complete_Inf_Inf(B),top_top(set(B))) ) ) ).

% Sup_finite_empty
tff(fact_3198_inf__Inf__fold__inf,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B),B2: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),A4)),B2) = finite_fold(B,B,inf_inf(B),B2,A4) ) ) ) ).

% inf_Inf_fold_inf
tff(fact_3199_Inf__fin__Inf,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic7752659483105999362nf_fin(B),A4) = aa(set(B),B,complete_Inf_Inf(B),A4) ) ) ) ) ).

% Inf_fin_Inf
tff(fact_3200_cInf__eq__Inf__fin,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X6: set(B)] :
          ( aa(set(B),$o,finite_finite(B),X6)
         => ( ( X6 != bot_bot(set(B)) )
           => ( aa(set(B),B,complete_Inf_Inf(B),X6) = aa(set(B),B,lattic7752659483105999362nf_fin(B),X6) ) ) ) ) ).

% cInf_eq_Inf_fin
tff(fact_3201_INT__greaterThan__UNIV,axiom,
    aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),set_ord_greaterThan(nat)),top_top(set(nat)))) = bot_bot(set(nat)) ).

% INT_greaterThan_UNIV
tff(fact_3202_INF__empty,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(C,B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Fa),bot_bot(set(C)))) = top_top(B) ) ) ).

% INF_empty
tff(fact_3203_INF__constant,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [C2: B,A4: set(C)] :
          ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,aTP_Lamp_iq(B,fun(C,B),C2)),A4))
          = $ite(A4 = bot_bot(set(C)),top_top(B),C2) ) ) ).

% INF_constant
tff(fact_3204_INF__inf__const2,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I4: set(B),Fa: fun(B,C),X: C] :
          ( ( I4 != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,aa(C,fun(B,C),aTP_Lamp_km(fun(B,C),fun(C,fun(B,C)),Fa),X)),I4)) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),I4))),X) ) ) ) ).

% INF_inf_const2
tff(fact_3205_INF__inf__const1,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [I4: set(B),X: C,Fa: fun(B,C)] :
          ( ( I4 != bot_bot(set(B)) )
         => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_kn(C,fun(fun(B,C),fun(B,C)),X),Fa)),I4)) = aa(C,C,aa(C,fun(C,C),inf_inf(C),X),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),I4))) ) ) ) ).

% INF_inf_const1
tff(fact_3206_INF__insert,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(C,B),A3: C,A4: set(C)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Fa),aa(set(C),set(C),insert2(C,A3),A4))) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,Fa,A3)),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Fa),A4))) ) ) ).

% INF_insert
tff(fact_3207_INF__union,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [M: fun(C,B),A4: set(C),B2: set(C)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,M),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A4),B2))) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,M),A4))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,M),B2))) ) ) ).

% INF_union
tff(fact_3208_relcomp__unfold,axiom,
    ! [B: $tType,C: $tType,D: $tType,R3: set(product_prod(B,D)),S: set(product_prod(D,C))] : ( relcomp(B,D,C,R3,S) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(set(product_prod(D,C)),fun(B,fun(C,$o)),aTP_Lamp_ko(set(product_prod(B,D)),fun(set(product_prod(D,C)),fun(B,fun(C,$o))),R3),S))) ) ).

% relcomp_unfold
tff(fact_3209_INT__empty,axiom,
    ! [C: $tType,B: $tType,B2: fun(C,set(B))] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),bot_bot(set(C)))) = top_top(set(B)) ) ).

% INT_empty
tff(fact_3210_INT__extend__simps_I2_J,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: fun(C,set(B)),C3: set(C)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C3)))
      = $ite(C3 = bot_bot(set(C)),A4,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_im(set(B),fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C3))) ) ).

% INT_extend_simps(2)
tff(fact_3211_INT__extend__simps_I1_J,axiom,
    ! [B: $tType,C: $tType,A4: fun(C,set(B)),C3: set(C),B2: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),C3))),B2)
      = $ite(C3 = bot_bot(set(C)),B2,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_in(fun(C,set(B)),fun(set(B),fun(C,set(B))),A4),B2)),C3))) ) ).

% INT_extend_simps(1)
tff(fact_3212_inj__on__INTER,axiom,
    ! [D: $tType,C: $tType,B: $tType,I4: set(B),Fa: fun(C,D),A4: fun(B,set(C))] :
      ( ( I4 != bot_bot(set(B)) )
     => ( ! [I3: B] :
            ( member(B,I3,I4)
           => inj_on(C,D,Fa,aa(B,set(C),A4,I3)) )
       => inj_on(C,D,Fa,aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(B),set(set(C)),image2(B,set(C),A4),I4))) ) ) ).

% inj_on_INTER
tff(fact_3213_INT__Un,axiom,
    ! [B: $tType,C: $tType,M: fun(C,set(B)),A4: set(C),B2: set(C)] : ( aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),M),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A4),B2))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),M),A4))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),M),B2))) ) ).

% INT_Un
tff(fact_3214_Inter__Un__subset,axiom,
    ! [B: $tType,A4: set(set(B)),B2: set(set(B))] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),A4)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B2))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),inf_inf(set(set(B))),A4),B2))) ).

% Inter_Un_subset
tff(fact_3215_Gcd__int__def,axiom,
    ! [K5: set(int)] : ( gcd_Gcd(int,K5) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,aa(set(int),set(nat),image2(int,nat,aa(fun(int,int),fun(int,nat),aa(fun(int,nat),fun(fun(int,int),fun(int,nat)),comp(int,nat,int),nat2),abs_abs(int))),K5))) ) ).

% Gcd_int_def
tff(fact_3216_Int__Inter__eq_I1_J,axiom,
    ! [B: $tType,A4: set(B),B10: set(set(B))] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B10))
      = $ite(B10 = bot_bot(set(set(B))),A4,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),image2(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4)),B10))) ) ).

% Int_Inter_eq(1)
tff(fact_3217_Int__Inter__eq_I2_J,axiom,
    ! [B: $tType,B10: set(set(B)),A4: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B10)),A4)
      = $ite(B10 = bot_bot(set(set(B))),A4,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(set(B)),set(set(B)),image2(set(B),set(B),aTP_Lamp_io(set(B),fun(set(B),set(B)),A4)),B10))) ) ).

% Int_Inter_eq(2)
tff(fact_3218_INF__le__SUP,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A4: set(B),Fa: fun(B,C)] :
          ( ( A4 != bot_bot(set(B)) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))) ) ) ).

% INF_le_SUP
tff(fact_3219_cInf__asclose,axiom,
    ! [B: $tType] :
      ( ( condit6923001295902523014norder(B)
        & linordered_idom(B) )
     => ! [S2: set(B),L: B,E2: B] :
          ( ( S2 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,S2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X2),L))),E2) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(B),B,complete_Inf_Inf(B),S2)),L))),E2) ) ) ) ).

% cInf_asclose
tff(fact_3220_Inf__insert__finite,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [S2: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert2(B,X),S2))
            = $ite(S2 = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),ord_min(B),X),aa(set(B),B,complete_Inf_Inf(B),S2))) ) ) ) ).

% Inf_insert_finite
tff(fact_3221_Inf__fold__inf,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),B,complete_Inf_Inf(B),A4) = finite_fold(B,B,inf_inf(B),top_top(B),A4) ) ) ) ).

% Inf_fold_inf
tff(fact_3222_collect__comp,axiom,
    ! [B: $tType,C: $tType,D: $tType,F: set(fun(D,set(C))),Ga: fun(B,D)] : ( aa(fun(B,D),fun(B,set(C)),aa(fun(D,set(C)),fun(fun(B,D),fun(B,set(C))),comp(D,set(C),B),bNF_collect(D,C,F)),Ga) = bNF_collect(B,C,aa(set(fun(D,set(C))),set(fun(B,set(C))),image2(fun(D,set(C)),fun(B,set(C)),aTP_Lamp_kp(fun(B,D),fun(fun(D,set(C)),fun(B,set(C))),Ga)),F)) ) ).

% collect_comp
tff(fact_3223_INF__UNIV__bool__expand,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: fun($o,B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set($o),set(B),image2($o,B,A4),top_top(set($o)))) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa($o,B,A4,$true)),aa($o,B,A4,$false)) ) ) ).

% INF_UNIV_bool_expand
tff(fact_3224_inf__Sup2__distrib,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)),aa(set(B),B,lattic5882676163264333800up_fin(B),B2)) = aa(set(B),B,lattic5882676163264333800up_fin(B),aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_kq(set(B),fun(set(B),fun(B,$o)),A4),B2))) ) ) ) ) ) ) ).

% inf_Sup2_distrib
tff(fact_3225_inf__Sup1__distrib,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,B,aa(B,fun(B,B),inf_inf(B),X),aa(set(B),B,lattic5882676163264333800up_fin(B),A4)) = aa(set(B),B,lattic5882676163264333800up_fin(B),aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_kr(set(B),fun(B,fun(B,$o)),A4),X))) ) ) ) ) ).

% inf_Sup1_distrib
tff(fact_3226_sup__Inf1__distrib,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),X),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)) = aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_ks(set(B),fun(B,fun(B,$o)),A4),X))) ) ) ) ) ).

% sup_Inf1_distrib
tff(fact_3227_sup__Inf2__distrib,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,lattic7752659483105999362nf_fin(B),A4)),aa(set(B),B,lattic7752659483105999362nf_fin(B),B2)) = aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_kt(set(B),fun(set(B),fun(B,$o)),A4),B2))) ) ) ) ) ) ) ).

% sup_Inf2_distrib
tff(fact_3228_INT__extend__simps_I3_J,axiom,
    ! [B: $tType,C: $tType,A4: fun(C,set(B)),C3: set(C),B2: set(B)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),C3))),B2)
      = $ite(C3 = bot_bot(set(C)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),top_top(set(B))),B2),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_kb(fun(C,set(B)),fun(set(B),fun(C,set(B))),A4),B2)),C3))) ) ).

% INT_extend_simps(3)
tff(fact_3229_INT__extend__simps_I4_J,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: fun(C,set(B)),C3: set(C)] :
      ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),C3)))
      = $ite(C3 = bot_bot(set(C)),A4,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_jv(set(B),fun(fun(C,set(B)),fun(C,set(B))),A4),B2)),C3))) ) ).

% INT_extend_simps(4)
tff(fact_3230_inf__INF__fold__inf,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A4: set(B),B2: C,Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(C,C,aa(C,fun(C,C),inf_inf(C),B2),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4))) = finite_fold(B,C,aa(fun(B,C),fun(B,fun(C,C)),aa(fun(C,fun(C,C)),fun(fun(B,C),fun(B,fun(C,C))),comp(C,fun(C,C),B),inf_inf(C)),Fa),B2,A4) ) ) ) ).

% inf_INF_fold_inf
tff(fact_3231_INF__fold__inf,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A4: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4)) = finite_fold(B,C,aa(fun(B,C),fun(B,fun(C,C)),aa(fun(C,fun(C,C)),fun(fun(B,C),fun(B,fun(C,C))),comp(C,fun(C,C),B),inf_inf(C)),Fa),top_top(C),A4) ) ) ) ).

% INF_fold_inf
tff(fact_3232_brk__rel__def,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C))] : ( brk_rel(B,C,R) = aa(set(product_prod(product_prod($o,B),product_prod($o,C))),set(product_prod(product_prod($o,B),product_prod($o,C))),aa(set(product_prod(product_prod($o,B),product_prod($o,C))),fun(set(product_prod(product_prod($o,B),product_prod($o,C))),set(product_prod(product_prod($o,B),product_prod($o,C)))),sup_sup(set(product_prod(product_prod($o,B),product_prod($o,C)))),aa(fun(product_prod(product_prod($o,B),product_prod($o,C)),$o),set(product_prod(product_prod($o,B),product_prod($o,C))),collect(product_prod(product_prod($o,B),product_prod($o,C))),aTP_Lamp_ku(set(product_prod(B,C)),fun(product_prod(product_prod($o,B),product_prod($o,C)),$o),R))),aa(fun(product_prod(product_prod($o,B),product_prod($o,C)),$o),set(product_prod(product_prod($o,B),product_prod($o,C))),collect(product_prod(product_prod($o,B),product_prod($o,C))),aTP_Lamp_kv(product_prod(product_prod($o,B),product_prod($o,C)),$o))) ) ).

% brk_rel_def
tff(fact_3233_image2__def,axiom,
    ! [B: $tType,C: $tType,D: $tType,A4: set(D),Fa: fun(D,B),Ga: fun(D,C)] : ( bNF_Greatest_image2(D,B,C,A4,Fa,Ga) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(D,C),fun(product_prod(B,C),$o),aa(fun(D,B),fun(fun(D,C),fun(product_prod(B,C),$o)),aTP_Lamp_kw(set(D),fun(fun(D,B),fun(fun(D,C),fun(product_prod(B,C),$o))),A4),Fa),Ga)) ) ).

% image2_def
tff(fact_3234_card__quotient__disjoint,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( inj_on(B,set(set(B)),aTP_Lamp_kx(set(product_prod(B,B)),fun(B,set(set(B))),R3),A4)
       => ( finite_card(set(B),equiv_quotient(B,A4,R3)) = finite_card(B,A4) ) ) ) ).

% card_quotient_disjoint
tff(fact_3235_Preorder__Restr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( order_preorder_on(B,field2(B,R3),R3)
     => order_preorder_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) ) ).

% Preorder_Restr
tff(fact_3236_mod__h__bot__iff_I8_J,axiom,
    ! [B: $tType,R: fun(B,assn),H2: heap_ext(product_unit)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,ex_assn(B,R)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
    <=> ? [X4: B] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,R,X4)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat)))) ) ).

% mod_h_bot_iff(8)
tff(fact_3237_ex__assn__const,axiom,
    ! [B: $tType,C2: assn] : ( ex_assn(B,aTP_Lamp_ky(assn,fun(B,assn),C2)) = C2 ) ).

% ex_assn_const
tff(fact_3238_subset__mset_OcInf__singleton,axiom,
    ! [B: $tType,X: multiset(B)] : ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B))))) = X ) ).

% subset_mset.cInf_singleton
tff(fact_3239_subset__mset_OcINF__const,axiom,
    ! [B: $tType,C: $tType,A4: set(B),C2: multiset(C)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),aTP_Lamp_ji(multiset(C),fun(B,multiset(C)),C2)),A4)) = C2 ) ) ).

% subset_mset.cINF_const
tff(fact_3240_mod__ex__dist,axiom,
    ! [B: $tType,Pa: fun(B,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,ex_assn(B,Pa)),H2)
    <=> ? [X4: B] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Pa,X4)),H2) ) ).

% mod_ex_dist
tff(fact_3241_triv__exI,axiom,
    ! [B: $tType,Qa: fun(B,assn),X: B] : entails(aa(B,assn,Qa,X),ex_assn(B,Qa)) ).

% triv_exI
tff(fact_3242_Inf__nat__def1,axiom,
    ! [K5: set(nat)] :
      ( ( K5 != bot_bot(set(nat)) )
     => member(nat,aa(set(nat),nat,complete_Inf_Inf(nat),K5),K5) ) ).

% Inf_nat_def1
tff(fact_3243_ex__one__point__gen,axiom,
    ! [B: $tType,Pa: fun(B,assn),V: B] :
      ( ! [H: product_prod(heap_ext(product_unit),set(nat)),X2: B] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Pa,X2)),H)
         => ( X2 = V ) )
     => ( ex_assn(B,Pa) = aa(B,assn,Pa,V) ) ) ).

% ex_one_point_gen
tff(fact_3244_mod__exI,axiom,
    ! [B: $tType,Pa: fun(B,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( ? [X3: B] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Pa,X3)),H2)
     => aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,ex_assn(B,Pa)),H2) ) ).

% mod_exI
tff(fact_3245_mod__exE,axiom,
    ! [B: $tType,Pa: fun(B,assn),H2: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,ex_assn(B,Pa)),H2)
     => ~ ! [X2: B] : ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Pa,X2)),H2) ) ).

% mod_exE
tff(fact_3246_Inf__multiset__empty,axiom,
    ! [B: $tType] : ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),bot_bot(set(multiset(B)))) = zero_zero(multiset(B)) ) ).

% Inf_multiset_empty
tff(fact_3247_ex__distrib__star,axiom,
    ! [B: $tType,Pa: fun(B,assn),Qa: assn] : ( ex_assn(B,aa(assn,fun(B,assn),aTP_Lamp_bs(fun(B,assn),fun(assn,fun(B,assn)),Pa),Qa)) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),ex_assn(B,Pa)),Qa) ) ).

% ex_distrib_star
tff(fact_3248_post__exI__rule,axiom,
    ! [C: $tType,B: $tType,Pa: assn,C2: heap_Time_Heap(B),Qa: fun(B,fun(C,assn)),X: C] :
      ( hoare_hoare_triple(B,Pa,C2,aa(C,fun(B,assn),aTP_Lamp_kz(fun(B,fun(C,assn)),fun(C,fun(B,assn)),Qa),X))
     => hoare_hoare_triple(B,Pa,C2,aTP_Lamp_la(fun(B,fun(C,assn)),fun(B,assn),Qa)) ) ).

% post_exI_rule
tff(fact_3249_norm__pre__ex__rule,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,assn),Fa: heap_Time_Heap(C),Qa: fun(C,assn)] :
      ( ! [X2: B] : hoare_hoare_triple(C,aa(B,assn,Pa,X2),Fa,Qa)
     => hoare_hoare_triple(C,ex_assn(B,Pa),Fa,Qa) ) ).

% norm_pre_ex_rule
tff(fact_3250_ent__ex__postI,axiom,
    ! [B: $tType,Pa: assn,Qa: fun(B,assn),X: B] :
      ( entails(Pa,aa(B,assn,Qa,X))
     => entails(Pa,ex_assn(B,Qa)) ) ).

% ent_ex_postI
tff(fact_3251_ent__ex__preI,axiom,
    ! [B: $tType,Pa: fun(B,assn),Qa: assn] :
      ( ! [X2: B] : entails(aa(B,assn,Pa,X2),Qa)
     => entails(ex_assn(B,Pa),Qa) ) ).

% ent_ex_preI
tff(fact_3252_ex__join__or,axiom,
    ! [B: $tType,Pa: fun(B,assn),Qa: fun(B,assn)] : ( ex_assn(B,aa(fun(B,assn),fun(B,assn),aTP_Lamp_lb(fun(B,assn),fun(fun(B,assn),fun(B,assn)),Pa),Qa)) = ex_assn(B,aa(fun(B,assn),fun(B,assn),aTP_Lamp_lc(fun(B,assn),fun(fun(B,assn),fun(B,assn)),Pa),Qa)) ) ).

% ex_join_or
tff(fact_3253_ex__distrib__or,axiom,
    ! [B: $tType,Pa: fun(B,assn),Qa: assn] : ( ex_assn(B,aa(assn,fun(B,assn),aTP_Lamp_ld(fun(B,assn),fun(assn,fun(B,assn)),Pa),Qa)) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),ex_assn(B,Pa)),Qa) ) ).

% ex_distrib_or
tff(fact_3254_INF__filter__not__bot,axiom,
    ! [B: $tType,C: $tType,B2: set(B),F: fun(B,filter(C))] :
      ( ! [X7: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X7),B2)
         => ( aa(set(B),$o,finite_finite(B),X7)
           => ( aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),X7)) != bot_bot(filter(C)) ) ) )
     => ( aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),B2)) != bot_bot(filter(C)) ) ) ).

% INF_filter_not_bot
tff(fact_3255_ex__distrib__and,axiom,
    ! [B: $tType,Pa: fun(B,assn),Qa: assn] : ( ex_assn(B,aa(assn,fun(B,assn),aTP_Lamp_le(fun(B,assn),fun(assn,fun(B,assn)),Pa),Qa)) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),ex_assn(B,Pa)),Qa) ) ).

% ex_distrib_and
tff(fact_3256_INF__Int__eq2,axiom,
    ! [C: $tType,B: $tType,S2: set(set(product_prod(B,C))),X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Inf_Inf(fun(B,fun(C,$o))),aa(set(set(product_prod(B,C))),set(fun(B,fun(C,$o))),image2(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o)))),S2)),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Inf_Inf(set(product_prod(B,C))),S2)) ) ).

% INF_Int_eq2
tff(fact_3257_INF__INT__eq2,axiom,
    ! [B: $tType,C: $tType,D: $tType,R3: fun(D,set(product_prod(B,C))),S2: set(D),X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Inf_Inf(fun(B,fun(C,$o))),aa(set(D),set(fun(B,fun(C,$o))),image2(D,fun(B,fun(C,$o)),aTP_Lamp_jg(fun(D,set(product_prod(B,C))),fun(D,fun(B,fun(C,$o))),R3)),S2)),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Inf_Inf(set(product_prod(B,C))),aa(set(D),set(set(product_prod(B,C))),image2(D,set(product_prod(B,C)),R3),S2))) ) ).

% INF_INT_eq2
tff(fact_3258_image2__eqI,axiom,
    ! [B: $tType,D: $tType,C: $tType,Ba: B,Fa: fun(C,B),X: C,C2: D,Ga: fun(C,D),A4: set(C)] :
      ( ( Ba = aa(C,B,Fa,X) )
     => ( ( C2 = aa(C,D,Ga,X) )
       => ( member(C,X,A4)
         => member(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),Ba),C2),bNF_Greatest_image2(C,B,D,A4,Fa,Ga)) ) ) ) ).

% image2_eqI
tff(fact_3259_preorder__on__empty,axiom,
    ! [B: $tType] : order_preorder_on(B,bot_bot(set(B)),bot_bot(set(product_prod(B,B)))) ).

% preorder_on_empty
tff(fact_3260_ex__assn__def,axiom,
    ! [B: $tType,Pa: fun(B,assn)] : ( ex_assn(B,Pa) = aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),assn,abs_assn,aTP_Lamp_lf(fun(B,assn),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Pa)) ) ).

% ex_assn_def
tff(fact_3261_Inf__INT__eq2,axiom,
    ! [C: $tType,B: $tType,S2: set(fun(B,fun(C,$o))),X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(fun(B,fun(C,$o))),fun(B,fun(C,$o)),complete_Inf_Inf(fun(B,fun(C,$o))),S2),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Inf_Inf(set(product_prod(B,C))),aa(set(fun(product_prod(B,C),$o)),set(set(product_prod(B,C))),image2(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C))),aa(set(fun(B,fun(C,$o))),set(fun(product_prod(B,C),$o)),image2(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o)),S2)))) ) ).

% Inf_INT_eq2
tff(fact_3262_quotient__is__empty2,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( ( bot_bot(set(set(B))) = equiv_quotient(B,A4,R3) )
    <=> ( A4 = bot_bot(set(B)) ) ) ).

% quotient_is_empty2
tff(fact_3263_quotient__is__empty,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( ( equiv_quotient(B,A4,R3) = bot_bot(set(set(B))) )
    <=> ( A4 = bot_bot(set(B)) ) ) ).

% quotient_is_empty
tff(fact_3264_quotient__empty,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( equiv_quotient(B,bot_bot(set(B)),R3) = bot_bot(set(set(B))) ) ).

% quotient_empty
tff(fact_3265_quotient__diff1,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),A3: B] :
      ( inj_on(B,set(set(B)),aTP_Lamp_kx(set(product_prod(B,B)),fun(B,set(set(B))),R3),A4)
     => ( member(B,A3,A4)
       => ( equiv_quotient(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))),R3) = aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),minus_minus(set(set(B))),equiv_quotient(B,A4,R3)),equiv_quotient(B,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))),R3)) ) ) ) ).

% quotient_diff1
tff(fact_3266_Gcd__eq__Max,axiom,
    ! [M: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),M)
     => ( ( M != bot_bot(set(nat)) )
       => ( ~ member(nat,zero_zero(nat),M)
         => ( gcd_Gcd(nat,M) = lattic643756798349783984er_Max(nat,aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image2(nat,set(nat),aTP_Lamp_lh(nat,set(nat))),M))) ) ) ) ) ).

% Gcd_eq_Max
tff(fact_3267_Max__singleton,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B] : ( lattic643756798349783984er_Max(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = X ) ) ).

% Max_singleton
tff(fact_3268_Max_Obounded__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic643756798349783984er_Max(B,A4)),X)
            <=> ! [X4: B] :
                  ( member(B,X4,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),X) ) ) ) ) ) ).

% Max.bounded_iff
tff(fact_3269_Max__less__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),lattic643756798349783984er_Max(B,A4)),X)
            <=> ! [X4: B] :
                  ( member(B,X4,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X4),X) ) ) ) ) ) ).

% Max_less_iff
tff(fact_3270_Max__const,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [A4: set(B),C2: C] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( lattic643756798349783984er_Max(C,aa(set(B),set(C),image2(B,C,aTP_Lamp_li(C,fun(B,C),C2)),A4)) = C2 ) ) ) ) ).

% Max_const
tff(fact_3271_INF__filter__bot__base,axiom,
    ! [B: $tType,C: $tType,I4: set(B),F: fun(B,filter(C))] :
      ( ! [I3: B] :
          ( member(B,I3,I4)
         => ! [J3: B] :
              ( member(B,J3,I4)
             => ? [X3: B] :
                  ( member(B,X3,I4)
                  & aa(filter(C),$o,aa(filter(C),fun(filter(C),$o),ord_less_eq(filter(C)),aa(B,filter(C),F,X3)),aa(filter(C),filter(C),aa(filter(C),fun(filter(C),filter(C)),inf_inf(filter(C)),aa(B,filter(C),F,I3)),aa(B,filter(C),F,J3))) ) ) )
     => ( ( aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),I4)) = bot_bot(filter(C)) )
      <=> ? [X4: B] :
            ( member(B,X4,I4)
            & ( aa(B,filter(C),F,X4) = bot_bot(filter(C)) ) ) ) ) ).

% INF_filter_bot_base
tff(fact_3272_Inf__filter__not__bot,axiom,
    ! [B: $tType,B2: set(filter(B))] :
      ( ! [X7: set(filter(B))] :
          ( aa(set(filter(B)),$o,aa(set(filter(B)),fun(set(filter(B)),$o),ord_less_eq(set(filter(B))),X7),B2)
         => ( aa(set(filter(B)),$o,finite_finite(filter(B)),X7)
           => ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),X7) != bot_bot(filter(B)) ) ) )
     => ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),B2) != bot_bot(filter(B)) ) ) ).

% Inf_filter_not_bot
tff(fact_3273_Max__in,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => member(B,lattic643756798349783984er_Max(B,A4),A4) ) ) ) ).

% Max_in
tff(fact_3274_Max_OboundedI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [A8: B] :
                  ( member(B,A8,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A8),X) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic643756798349783984er_Max(B,A4)),X) ) ) ) ) ).

% Max.boundedI
tff(fact_3275_Max_OboundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic643756798349783984er_Max(B,A4)),X)
             => ! [A13: B] :
                  ( member(B,A13,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A13),X) ) ) ) ) ) ).

% Max.boundedE
tff(fact_3276_eq__Max__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),M4: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ( M4 = lattic643756798349783984er_Max(B,A4) )
            <=> ( member(B,M4,A4)
                & ! [X4: B] :
                    ( member(B,X4,A4)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),M4) ) ) ) ) ) ) ).

% eq_Max_iff
tff(fact_3277_Max__ge__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),lattic643756798349783984er_Max(B,A4))
            <=> ? [X4: B] :
                  ( member(B,X4,A4)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),X4) ) ) ) ) ) ).

% Max_ge_iff
tff(fact_3278_Max__eq__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),M4: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ( lattic643756798349783984er_Max(B,A4) = M4 )
            <=> ( member(B,M4,A4)
                & ! [X4: B] :
                    ( member(B,X4,A4)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),M4) ) ) ) ) ) ) ).

% Max_eq_iff
tff(fact_3279_Max__gr__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),lattic643756798349783984er_Max(B,A4))
            <=> ? [X4: B] :
                  ( member(B,X4,A4)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),X4) ) ) ) ) ) ).

% Max_gr_iff
tff(fact_3280_cSup__eq__Max,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X6: set(B)] :
          ( aa(set(B),$o,finite_finite(B),X6)
         => ( ( X6 != bot_bot(set(B)) )
           => ( aa(set(B),B,complete_Sup_Sup(B),X6) = lattic643756798349783984er_Max(B,X6) ) ) ) ) ).

% cSup_eq_Max
tff(fact_3281_Max__Sup,axiom,
    ! [B: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( lattic643756798349783984er_Max(B,A4) = aa(set(B),B,complete_Sup_Sup(B),A4) ) ) ) ) ).

% Max_Sup
tff(fact_3282_Sup__nat__def,axiom,
    ! [X6: set(nat)] :
      ( aa(set(nat),nat,complete_Sup_Sup(nat),X6)
      = $ite(X6 = bot_bot(set(nat)),zero_zero(nat),lattic643756798349783984er_Max(nat,X6)) ) ).

% Sup_nat_def
tff(fact_3283_Max_Osubset__imp,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic643756798349783984er_Max(B,A4)),lattic643756798349783984er_Max(B,B2)) ) ) ) ) ).

% Max.subset_imp
tff(fact_3284_Max__mono,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [M: set(B),N4: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),M),N4)
         => ( ( M != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),N4)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic643756798349783984er_Max(B,M)),lattic643756798349783984er_Max(B,N4)) ) ) ) ) ).

% Max_mono
tff(fact_3285_Max__add__commute,axiom,
    ! [B: $tType,C: $tType] :
      ( linord4140545234300271783up_add(C)
     => ! [S2: set(B),Fa: fun(B,C),K: C] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( ( S2 != bot_bot(set(B)) )
           => ( lattic643756798349783984er_Max(C,aa(set(B),set(C),image2(B,C,aa(C,fun(B,C),aTP_Lamp_lj(fun(B,C),fun(C,fun(B,C)),Fa),K)),S2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),lattic643756798349783984er_Max(C,aa(set(B),set(C),image2(B,C,Fa),S2))),K) ) ) ) ) ).

% Max_add_commute
tff(fact_3286_measure__function__int,axiom,
    fun_is_measure(int,aa(fun(int,int),fun(int,nat),aa(fun(int,nat),fun(fun(int,int),fun(int,nat)),comp(int,nat,int),nat2),abs_abs(int))) ).

% measure_function_int
tff(fact_3287_minus__Max__eq__Min,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [S2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( ( S2 != bot_bot(set(B)) )
           => ( aa(B,B,uminus_uminus(B),lattic643756798349783984er_Max(B,S2)) = lattic643756798350308766er_Min(B,aa(set(B),set(B),image2(B,B,uminus_uminus(B)),S2)) ) ) ) ) ).

% minus_Max_eq_Min
tff(fact_3288_minus__Min__eq__Max,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [S2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( ( S2 != bot_bot(set(B)) )
           => ( aa(B,B,uminus_uminus(B),lattic643756798350308766er_Min(B,S2)) = lattic643756798349783984er_Max(B,aa(set(B),set(B),image2(B,B,uminus_uminus(B)),S2)) ) ) ) ) ).

% minus_Min_eq_Max
tff(fact_3289_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [B: $tType,C: $tType,S2: set(B),Fa: fun(B,fun(C,C)),A4: set(B),Z2: C,Y: C,A3: B] :
      ( finite4664212375090638736ute_on(B,C,S2,Fa)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),S2)
       => ( aa(C,$o,finite_fold_graph(B,C,Fa,Z2,A4),Y)
         => ( member(B,A3,A4)
           => ? [Y7: C] :
                ( ( Y = aa(C,C,aa(B,fun(C,C),Fa,A3),Y7) )
                & aa(C,$o,finite_fold_graph(B,C,Fa,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))),Y7) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
tff(fact_3290_Image__fold,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S2: set(B)] :
      ( aa(set(product_prod(B,C)),$o,finite_finite(product_prod(B,C)),R)
     => ( image(B,C,R,S2) = finite_fold(product_prod(B,C),set(C),aa(fun(B,fun(C,fun(set(C),set(C)))),fun(product_prod(B,C),fun(set(C),set(C))),product_case_prod(B,C,fun(set(C),set(C))),aTP_Lamp_lk(set(B),fun(B,fun(C,fun(set(C),set(C)))),S2)),bot_bot(set(C)),R) ) ) ).

% Image_fold
tff(fact_3291_ImageI,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,R3: set(product_prod(B,C)),A4: set(B)] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),R3)
     => ( member(B,A3,A4)
       => member(C,Ba,image(B,C,R3,A4)) ) ) ).

% ImageI
tff(fact_3292_Image__empty2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(C,B))] : ( image(C,B,R,bot_bot(set(C))) = bot_bot(set(B)) ) ).

% Image_empty2
tff(fact_3293_Min__singleton,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B] : ( lattic643756798350308766er_Min(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = X ) ) ).

% Min_singleton
tff(fact_3294_Image__empty1,axiom,
    ! [C: $tType,B: $tType,X6: set(C)] : ( image(C,B,bot_bot(set(product_prod(C,B))),X6) = bot_bot(set(B)) ) ).

% Image_empty1
tff(fact_3295_Image__Id__on,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( image(B,B,id_on(B,A4),B2) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) ) ).

% Image_Id_on
tff(fact_3296_Image__singleton__iff,axiom,
    ! [B: $tType,C: $tType,Ba: B,R3: set(product_prod(C,B)),A3: C] :
      ( member(B,Ba,image(C,B,R3,aa(set(C),set(C),insert2(C,A3),bot_bot(set(C)))))
    <=> member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),A3),Ba),R3) ) ).

% Image_singleton_iff
tff(fact_3297_Min_Obounded__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),lattic643756798350308766er_Min(B,A4))
            <=> ! [X4: B] :
                  ( member(B,X4,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),X4) ) ) ) ) ) ).

% Min.bounded_iff
tff(fact_3298_Min__gr__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),lattic643756798350308766er_Min(B,A4))
            <=> ! [X4: B] :
                  ( member(B,X4,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),X4) ) ) ) ) ) ).

% Min_gr_iff
tff(fact_3299_Min__const,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [A4: set(B),C2: C] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( lattic643756798350308766er_Min(C,aa(set(B),set(C),image2(B,C,aTP_Lamp_li(C,fun(B,C),C2)),A4)) = C2 ) ) ) ) ).

% Min_const
tff(fact_3300_Min__insert,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( lattic643756798350308766er_Min(B,aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),ord_min(B),X),lattic643756798350308766er_Min(B,A4)) ) ) ) ) ).

% Min_insert
tff(fact_3301_pair__vimage__is__Image,axiom,
    ! [B: $tType,C: $tType,U: C,E4: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(B),aa(fun(B,product_prod(C,B)),fun(set(product_prod(C,B)),set(B)),vimage(B,product_prod(C,B)),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),U)),E4) = image(C,B,E4,aa(set(C),set(C),insert2(C,U),bot_bot(set(C)))) ) ).

% pair_vimage_is_Image
tff(fact_3302_ImageE,axiom,
    ! [B: $tType,C: $tType,Ba: B,R3: set(product_prod(C,B)),A4: set(C)] :
      ( member(B,Ba,image(C,B,R3,A4))
     => ~ ! [X2: C] :
            ( member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X2),Ba),R3)
           => ~ member(C,X2,A4) ) ) ).

% ImageE
tff(fact_3303_Image__iff,axiom,
    ! [B: $tType,C: $tType,Ba: B,R3: set(product_prod(C,B)),A4: set(C)] :
      ( member(B,Ba,image(C,B,R3,A4))
    <=> ? [X4: C] :
          ( member(C,X4,A4)
          & member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X4),Ba),R3) ) ) ).

% Image_iff
tff(fact_3304_rev__ImageI,axiom,
    ! [C: $tType,B: $tType,A3: B,A4: set(B),Ba: C,R3: set(product_prod(B,C))] :
      ( member(B,A3,A4)
     => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),R3)
       => member(C,Ba,image(B,C,R3,A4)) ) ) ).

% rev_ImageI
tff(fact_3305_fold__graph_OemptyI,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(C,C)),Z2: C] : aa(C,$o,finite_fold_graph(B,C,Fa,Z2,bot_bot(set(B))),Z2) ).

% fold_graph.emptyI
tff(fact_3306_empty__fold__graphE,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(C,C)),Z2: C,X: C] :
      ( aa(C,$o,finite_fold_graph(B,C,Fa,Z2,bot_bot(set(B))),X)
     => ( X = Z2 ) ) ).

% empty_fold_graphE
tff(fact_3307_Image__Int__subset,axiom,
    ! [B: $tType,C: $tType,R: set(product_prod(C,B)),A4: set(C),B2: set(C)] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),image(C,B,R,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),image(C,B,R,A4)),image(C,B,R,B2))) ).

% Image_Int_subset
tff(fact_3308_rtrancl__image__advance__rtrancl,axiom,
    ! [B: $tType,Q2: B,R: set(product_prod(B,B)),Q0: set(B),X: B] :
      ( member(B,Q2,image(B,B,transitive_rtrancl(B,R),Q0))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),X),transitive_rtrancl(B,R))
       => member(B,X,image(B,B,transitive_rtrancl(B,R),Q0)) ) ) ).

% rtrancl_image_advance_rtrancl
tff(fact_3309_rtrancl__image__advance,axiom,
    ! [B: $tType,Q2: B,R: set(product_prod(B,B)),Q0: set(B),X: B] :
      ( member(B,Q2,image(B,B,transitive_rtrancl(B,R),Q0))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),X),R)
       => member(B,X,image(B,B,transitive_rtrancl(B,R),Q0)) ) ) ).

% rtrancl_image_advance
tff(fact_3310_Min__in,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => member(B,lattic643756798350308766er_Min(B,A4),A4) ) ) ) ).

% Min_in
tff(fact_3311_fold__graph_Ocases,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(C,C)),Z2: C,A1: set(B),A22: C] :
      ( aa(C,$o,finite_fold_graph(B,C,Fa,Z2,A1),A22)
     => ( ( ( A1 = bot_bot(set(B)) )
         => ( A22 != Z2 ) )
       => ~ ! [X2: B,A12: set(B)] :
              ( ( A1 = aa(set(B),set(B),insert2(B,X2),A12) )
             => ! [Y2: C] :
                  ( ( A22 = aa(C,C,aa(B,fun(C,C),Fa,X2),Y2) )
                 => ( ~ member(B,X2,A12)
                   => ~ aa(C,$o,finite_fold_graph(B,C,Fa,Z2,A12),Y2) ) ) ) ) ) ).

% fold_graph.cases
tff(fact_3312_fold__graph_Osimps,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(C,C)),Z2: C,A1: set(B),A22: C] :
      ( aa(C,$o,finite_fold_graph(B,C,Fa,Z2,A1),A22)
    <=> ( ( ( A1 = bot_bot(set(B)) )
          & ( A22 = Z2 ) )
        | ? [X4: B,A11: set(B),Y3: C] :
            ( ( A1 = aa(set(B),set(B),insert2(B,X4),A11) )
            & ( A22 = aa(C,C,aa(B,fun(C,C),Fa,X4),Y3) )
            & ~ member(B,X4,A11)
            & aa(C,$o,finite_fold_graph(B,C,Fa,Z2,A11),Y3) ) ) ) ).

% fold_graph.simps
tff(fact_3313_Image__empty__rtrancl__Image__id,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),V: B] :
      ( ( image(B,B,R,aa(set(B),set(B),insert2(B,V),bot_bot(set(B)))) = bot_bot(set(B)) )
     => ( image(B,B,transitive_rtrancl(B,R),aa(set(B),set(B),insert2(B,V),bot_bot(set(B)))) = aa(set(B),set(B),insert2(B,V),bot_bot(set(B))) ) ) ).

% Image_empty_rtrancl_Image_id
tff(fact_3314_wfE__pf,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),A4: set(B)] :
      ( wf(B,R)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),image(B,B,R,A4))
       => ( A4 = bot_bot(set(B)) ) ) ) ).

% wfE_pf
tff(fact_3315_wfI__pf,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ! [A12: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A12),image(B,B,R,A12))
         => ( A12 = bot_bot(set(B)) ) )
     => wf(B,R) ) ).

% wfI_pf
tff(fact_3316_quotientI,axiom,
    ! [B: $tType,X: B,A4: set(B),R3: set(product_prod(B,B))] :
      ( member(B,X,A4)
     => member(set(B),image(B,B,R3,aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))),equiv_quotient(B,A4,R3)) ) ).

% quotientI
tff(fact_3317_quotientE,axiom,
    ! [B: $tType,X6: set(B),A4: set(B),R3: set(product_prod(B,B))] :
      ( member(set(B),X6,equiv_quotient(B,A4,R3))
     => ~ ! [X2: B] :
            ( ( X6 = image(B,B,R3,aa(set(B),set(B),insert2(B,X2),bot_bot(set(B)))) )
           => ~ member(B,X2,A4) ) ) ).

% quotientE
tff(fact_3318_Min__eq__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),M4: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ( lattic643756798350308766er_Min(B,A4) = M4 )
            <=> ( member(B,M4,A4)
                & ! [X4: B] :
                    ( member(B,X4,A4)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),M4),X4) ) ) ) ) ) ) ).

% Min_eq_iff
tff(fact_3319_Min__le__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic643756798350308766er_Min(B,A4)),X)
            <=> ? [X4: B] :
                  ( member(B,X4,A4)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),X) ) ) ) ) ) ).

% Min_le_iff
tff(fact_3320_eq__Min__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),M4: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ( M4 = lattic643756798350308766er_Min(B,A4) )
            <=> ( member(B,M4,A4)
                & ! [X4: B] :
                    ( member(B,X4,A4)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),M4),X4) ) ) ) ) ) ) ).

% eq_Min_iff
tff(fact_3321_Min_OboundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),lattic643756798350308766er_Min(B,A4))
             => ! [A13: B] :
                  ( member(B,A13,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),A13) ) ) ) ) ) ).

% Min.boundedE
tff(fact_3322_Min_OboundedI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [A8: B] :
                  ( member(B,A8,A4)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),A8) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),lattic643756798350308766er_Min(B,A4)) ) ) ) ) ).

% Min.boundedI
tff(fact_3323_Min__less__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),lattic643756798350308766er_Min(B,A4)),X)
            <=> ? [X4: B] :
                  ( member(B,X4,A4)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X4),X) ) ) ) ) ) ).

% Min_less_iff
tff(fact_3324_Min__Inf,axiom,
    ! [B: $tType] :
      ( comple5582772986160207858norder(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( lattic643756798350308766er_Min(B,A4) = aa(set(B),B,complete_Inf_Inf(B),A4) ) ) ) ) ).

% Min_Inf
tff(fact_3325_cInf__eq__Min,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X6: set(B)] :
          ( aa(set(B),$o,finite_finite(B),X6)
         => ( ( X6 != bot_bot(set(B)) )
           => ( aa(set(B),B,complete_Inf_Inf(B),X6) = lattic643756798350308766er_Min(B,X6) ) ) ) ) ).

% cInf_eq_Min
tff(fact_3326_Image__singleton,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,B)),A3: C] : ( image(C,B,R3,aa(set(C),set(C),insert2(C,A3),bot_bot(set(C)))) = aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aTP_Lamp_ll(set(product_prod(C,B)),fun(C,fun(B,$o)),R3),A3)) ) ).

% Image_singleton
tff(fact_3327_rtrancl__apply__insert,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),X: B,S2: set(B)] : ( image(B,B,transitive_rtrancl(B,R),aa(set(B),set(B),insert2(B,X),S2)) = aa(set(B),set(B),insert2(B,X),image(B,B,transitive_rtrancl(B,R),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),S2),image(B,B,R,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ).

% rtrancl_apply_insert
tff(fact_3328_fold__graph__image,axiom,
    ! [D: $tType,C: $tType,B: $tType,Ga: fun(B,C),A4: set(B),Fa: fun(C,fun(D,D)),Z2: D] :
      ( inj_on(B,C,Ga,A4)
     => ( finite_fold_graph(C,D,Fa,Z2,aa(set(B),set(C),image2(B,C,Ga),A4)) = finite_fold_graph(B,D,aa(fun(B,C),fun(B,fun(D,D)),aa(fun(C,fun(D,D)),fun(fun(B,C),fun(B,fun(D,D))),comp(C,fun(D,D),B),Fa),Ga),Z2,A4) ) ) ).

% fold_graph_image
tff(fact_3329_E__closed__restr__reach__cases,axiom,
    ! [B: $tType,U: B,V: B,E4: set(product_prod(B,B)),R: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V),transitive_rtrancl(B,E4))
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),image(B,B,E4,R)),R)
       => ( ~ member(B,V,R)
         => ~ ( ~ member(B,U,R)
             => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V),transitive_rtrancl(B,rel_restrict(B,E4,R))) ) ) ) ) ).

% E_closed_restr_reach_cases
tff(fact_3330_Min__antimono,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [M: set(B),N4: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),M),N4)
         => ( ( M != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),N4)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic643756798350308766er_Min(B,N4)),lattic643756798350308766er_Min(B,M)) ) ) ) ) ).

% Min_antimono
tff(fact_3331_Min_Osubset__imp,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),lattic643756798350308766er_Min(B,B2)),lattic643756798350308766er_Min(B,A4)) ) ) ) ) ).

% Min.subset_imp
tff(fact_3332_subset__Image__Image__iff,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),B2: set(B)] :
      ( order_preorder_on(B,field2(B,R3),R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),field2(B,R3))
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),image(B,B,R3,A4)),image(B,B,R3,B2))
          <=> ! [X4: B] :
                ( member(B,X4,A4)
               => ? [Xa2: B] :
                    ( member(B,Xa2,B2)
                    & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa2),X4),R3) ) ) ) ) ) ) ).

% subset_Image_Image_iff
tff(fact_3333_Image__eq__UN,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,B)),B2: set(C)] : ( image(C,B,R3,B2) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aTP_Lamp_lm(set(product_prod(C,B)),fun(C,set(B)),R3)),B2)) ) ).

% Image_eq_UN
tff(fact_3334_hom__Min__commute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [H2: fun(B,B),N4: set(B)] :
          ( ! [X2: B,Y2: B] : ( aa(B,B,H2,aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y2)) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,H2,X2)),aa(B,B,H2,Y2)) )
         => ( aa(set(B),$o,finite_finite(B),N4)
           => ( ( N4 != bot_bot(set(B)) )
             => ( aa(B,B,H2,lattic643756798350308766er_Min(B,N4)) = lattic643756798350308766er_Min(B,aa(set(B),set(B),image2(B,B,H2),N4)) ) ) ) ) ) ).

% hom_Min_commute
tff(fact_3335_Min_Osubset,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( B2 != bot_bot(set(B)) )
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A4)
             => ( aa(B,B,aa(B,fun(B,B),ord_min(B),lattic643756798350308766er_Min(B,B2)),lattic643756798350308766er_Min(B,A4)) = lattic643756798350308766er_Min(B,A4) ) ) ) ) ) ).

% Min.subset
tff(fact_3336_Min_Oinsert__not__elem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ~ member(B,X,A4)
           => ( ( A4 != bot_bot(set(B)) )
             => ( lattic643756798350308766er_Min(B,aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),ord_min(B),X),lattic643756798350308766er_Min(B,A4)) ) ) ) ) ) ).

% Min.insert_not_elem
tff(fact_3337_Min_Oclosed,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [X2: B,Y2: B] : member(B,aa(B,B,aa(B,fun(B,B),ord_min(B),X2),Y2),aa(set(B),set(B),insert2(B,X2),aa(set(B),set(B),insert2(B,Y2),bot_bot(set(B)))))
             => member(B,lattic643756798350308766er_Min(B,A4),A4) ) ) ) ) ).

% Min.closed
tff(fact_3338_Min_Ounion,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( lattic643756798350308766er_Min(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(B,B,aa(B,fun(B,B),ord_min(B),lattic643756798350308766er_Min(B,A4)),lattic643756798350308766er_Min(B,B2)) ) ) ) ) ) ) ).

% Min.union
tff(fact_3339_Sigma__Image,axiom,
    ! [B: $tType,C: $tType,A4: set(C),B2: fun(C,set(B)),X6: set(C)] : ( image(C,B,product_Sigma(C,B,A4,B2),X6) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),B2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),X6),A4))) ) ).

% Sigma_Image
tff(fact_3340_Min__add__commute,axiom,
    ! [B: $tType,C: $tType] :
      ( linord4140545234300271783up_add(C)
     => ! [S2: set(B),Fa: fun(B,C),K: C] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( ( S2 != bot_bot(set(B)) )
           => ( lattic643756798350308766er_Min(C,aa(set(B),set(C),image2(B,C,aa(C,fun(B,C),aTP_Lamp_lj(fun(B,C),fun(C,fun(B,C)),Fa),K)),S2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),lattic643756798350308766er_Min(C,aa(set(B),set(C),image2(B,C,Fa),S2))),K) ) ) ) ) ).

% Min_add_commute
tff(fact_3341_finite__reachable__advance,axiom,
    ! [B: $tType,E4: set(product_prod(B,B)),V0: B,V: B] :
      ( aa(set(B),$o,finite_finite(B),image(B,B,transitive_rtrancl(B,E4),aa(set(B),set(B),insert2(B,V0),bot_bot(set(B)))))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V0),V),transitive_rtrancl(B,E4))
       => aa(set(B),$o,finite_finite(B),image(B,B,transitive_rtrancl(B,E4),aa(set(B),set(B),insert2(B,V),bot_bot(set(B))))) ) ) ).

% finite_reachable_advance
tff(fact_3342_rtrancl__Image__advance__ss,axiom,
    ! [B: $tType,U: B,V: B,E4: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V),E4)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),image(B,B,transitive_rtrancl(B,E4),aa(set(B),set(B),insert2(B,V),bot_bot(set(B))))),image(B,B,transitive_rtrancl(B,E4),aa(set(B),set(B),insert2(B,U),bot_bot(set(B))))) ) ).

% rtrancl_Image_advance_ss
tff(fact_3343_Min_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( lattic643756798350308766er_Min(B,aa(set(B),set(B),insert2(B,X),A4))
            = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),ord_min(B),X),lattic643756798350308766er_Min(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ) ) ).

% Min.insert_remove
tff(fact_3344_Min_Oremove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( lattic643756798350308766er_Min(B,A4)
              = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),ord_min(B),X),lattic643756798350308766er_Min(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ) ) ) ).

% Min.remove
tff(fact_3345_singleton__quotient,axiom,
    ! [B: $tType,X: B,R3: set(product_prod(B,B))] : ( equiv_quotient(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))),R3) = aa(set(set(B)),set(set(B)),insert2(set(B),image(B,B,R3,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),bot_bot(set(set(B)))) ) ).

% singleton_quotient
tff(fact_3346_quotient__def,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] : ( equiv_quotient(B,A4,R3) = aa(set(set(set(B))),set(set(B)),complete_Sup_Sup(set(set(B))),aa(set(B),set(set(set(B))),image2(B,set(set(B)),aTP_Lamp_ln(set(product_prod(B,B)),fun(B,set(set(B))),R3)),A4)) ) ).

% quotient_def
tff(fact_3347_subset__Image1__Image1__iff,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( order_preorder_on(B,field2(B,R3),R3)
     => ( member(B,A3,field2(B,R3))
       => ( member(B,Ba,field2(B,R3))
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))),image(B,B,R3,aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))))
          <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),A3),R3) ) ) ) ) ).

% subset_Image1_Image1_iff
tff(fact_3348_Refl__antisym__eq__Image1__Image1__iff,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( refl_on(B,field2(B,R3),R3)
     => ( antisym(B,R3)
       => ( member(B,A3,field2(B,R3))
         => ( member(B,Ba,field2(B,R3))
           => ( ( image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) = image(B,B,R3,aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))) )
            <=> ( A3 = Ba ) ) ) ) ) ) ).

% Refl_antisym_eq_Image1_Image1_iff
tff(fact_3349_trancl__multi__insert2,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),M4: B,X6: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),R3),product_Sigma(B,B,aa(set(B),set(B),insert2(B,M4),bot_bot(set(B))),aTP_Lamp_if(set(B),fun(B,set(B)),X6)))))
     => ( ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,R3))
       => ~ ! [X2: B] :
              ( member(B,X2,X6)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),M4),transitive_rtrancl(B,R3))
               => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Ba),transitive_rtrancl(B,R3)) ) ) ) ) ).

% trancl_multi_insert2
tff(fact_3350_trancl__multi__insert,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),X6: set(B),M4: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),R3),product_Sigma(B,B,X6,aTP_Lamp_lo(B,fun(B,set(B)),M4)))))
     => ( ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,R3))
       => ~ ! [X2: B] :
              ( member(B,X2,X6)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),X2),transitive_rtrancl(B,R3))
               => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),M4),Ba),transitive_rtrancl(B,R3)) ) ) ) ) ).

% trancl_multi_insert
tff(fact_3351_relation__of__def,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o)),A4: set(B)] : ( order_relation_of(B,Pa,A4) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(B),fun(B,fun(B,$o)),aTP_Lamp_lp(fun(B,fun(B,$o)),fun(set(B),fun(B,fun(B,$o))),Pa),A4))) ) ).

% relation_of_def
tff(fact_3352_pred__nat__trancl__eq__le,axiom,
    ! [M4: nat,N: nat] :
      ( member(product_prod(nat,nat),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),M4),N),transitive_rtrancl(nat,pred_nat))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N) ) ).

% pred_nat_trancl_eq_le
tff(fact_3353_trancl__empty,axiom,
    ! [B: $tType] : ( transitive_trancl(B,bot_bot(set(product_prod(B,B)))) = bot_bot(set(product_prod(B,B))) ) ).

% trancl_empty
tff(fact_3354_trancl__single,axiom,
    ! [B: $tType,A3: B,Ba: B] : ( transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba)),bot_bot(set(product_prod(B,B))))) = aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba)),bot_bot(set(product_prod(B,B)))) ) ).

% trancl_single
tff(fact_3355_trancl_Ocases,axiom,
    ! [B: $tType,A1: B,A22: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A1),A22),transitive_trancl(B,R3))
     => ( ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A1),A22),R3)
       => ~ ! [B4: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A1),B4),transitive_trancl(B,R3))
             => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B4),A22),R3) ) ) ) ).

% trancl.cases
tff(fact_3356_trancl_Osimps,axiom,
    ! [B: $tType,A1: B,A22: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A1),A22),transitive_trancl(B,R3))
    <=> ( ? [A6: B,B5: B] :
            ( ( A1 = A6 )
            & ( A22 = B5 )
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A6),B5),R3) )
        | ? [A6: B,B5: B,C5: B] :
            ( ( A1 = A6 )
            & ( A22 = C5 )
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A6),B5),transitive_trancl(B,R3))
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B5),C5),R3) ) ) ) ).

% trancl.simps
tff(fact_3357_trancl_Or__into__trancl,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,R3)) ) ).

% trancl.r_into_trancl
tff(fact_3358_tranclE,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,R3))
     => ( ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
       => ~ ! [C4: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),C4),transitive_trancl(B,R3))
             => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),C4),Ba),R3) ) ) ) ).

% tranclE
tff(fact_3359_trancl__trans,axiom,
    ! [B: $tType,X: B,Y: B,R3: set(product_prod(B,B)),Z2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_trancl(B,R3))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),Z2),transitive_trancl(B,R3))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),transitive_trancl(B,R3)) ) ) ).

% trancl_trans
tff(fact_3360_trancl__induct,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),Pa: fun(B,$o)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,R3))
     => ( ! [Y2: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Y2),R3)
           => aa(B,$o,Pa,Y2) )
       => ( ! [Y2: B,Z3: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Y2),transitive_trancl(B,R3))
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),R3)
               => ( aa(B,$o,Pa,Y2)
                 => aa(B,$o,Pa,Z3) ) ) )
         => aa(B,$o,Pa,Ba) ) ) ) ).

% trancl_induct
tff(fact_3361_r__r__into__trancl,axiom,
    ! [B: $tType,A3: B,Ba: B,R: set(product_prod(B,B)),C2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),C2),R)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),C2),transitive_trancl(B,R)) ) ) ).

% r_r_into_trancl
tff(fact_3362_converse__tranclE,axiom,
    ! [B: $tType,X: B,Z2: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),transitive_trancl(B,R3))
     => ( ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),R3)
       => ~ ! [Y2: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y2),R3)
             => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z2),transitive_trancl(B,R3)) ) ) ) ).

% converse_tranclE
tff(fact_3363_irrefl__trancl__rD,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X: B,Y: B] :
      ( ! [X2: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2),transitive_trancl(B,R3))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
       => ( X != Y ) ) ) ).

% irrefl_trancl_rD
tff(fact_3364_Transitive__Closure_Otrancl__into__trancl,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),C2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,R3))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),C2),R3)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),C2),transitive_trancl(B,R3)) ) ) ).

% Transitive_Closure.trancl_into_trancl
tff(fact_3365_trancl__into__trancl2,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),C2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),C2),transitive_trancl(B,R3))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),C2),transitive_trancl(B,R3)) ) ) ).

% trancl_into_trancl2
tff(fact_3366_trancl__trans__induct,axiom,
    ! [B: $tType,X: B,Y: B,R3: set(product_prod(B,B)),Pa: fun(B,fun(B,$o))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_trancl(B,R3))
     => ( ! [X2: B,Y2: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),R3)
           => aa(B,$o,aa(B,fun(B,$o),Pa,X2),Y2) )
       => ( ! [X2: B,Y2: B,Z3: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),transitive_trancl(B,R3))
             => ( aa(B,$o,aa(B,fun(B,$o),Pa,X2),Y2)
               => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),transitive_trancl(B,R3))
                 => ( aa(B,$o,aa(B,fun(B,$o),Pa,Y2),Z3)
                   => aa(B,$o,aa(B,fun(B,$o),Pa,X2),Z3) ) ) ) )
         => aa(B,$o,aa(B,fun(B,$o),Pa,X),Y) ) ) ) ).

% trancl_trans_induct
tff(fact_3367_converse__trancl__induct,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),Pa: fun(B,$o)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,R3))
     => ( ! [Y2: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Ba),R3)
           => aa(B,$o,Pa,Y2) )
       => ( ! [Y2: B,Z3: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),R3)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z3),Ba),transitive_trancl(B,R3))
               => ( aa(B,$o,Pa,Z3)
                 => aa(B,$o,Pa,Y2) ) ) )
         => aa(B,$o,Pa,A3) ) ) ) ).

% converse_trancl_induct
tff(fact_3368_less__eq,axiom,
    ! [M4: nat,N: nat] :
      ( member(product_prod(nat,nat),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),M4),N),transitive_trancl(nat,pred_nat))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N) ) ).

% less_eq
tff(fact_3369_antisymD,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( antisym(B,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
       => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),A3),R3)
         => ( A3 = Ba ) ) ) ) ).

% antisymD
tff(fact_3370_antisymI,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ! [X2: B,Y2: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),R3)
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),X2),R3)
           => ( X2 = Y2 ) ) )
     => antisym(B,R3) ) ).

% antisymI
tff(fact_3371_antisym__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( antisym(B,R3)
    <=> ! [X4: B,Y3: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Y3),R3)
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y3),X4),R3)
           => ( X4 = Y3 ) ) ) ) ).

% antisym_def
tff(fact_3372_antisym__empty,axiom,
    ! [B: $tType] : antisym(B,bot_bot(set(product_prod(B,B)))) ).

% antisym_empty
tff(fact_3373_trancl__rtrancl__trancl,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),C2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,R3))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),C2),transitive_rtrancl(B,R3))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),C2),transitive_trancl(B,R3)) ) ) ).

% trancl_rtrancl_trancl
tff(fact_3374_rtrancl__trancl__trancl,axiom,
    ! [B: $tType,X: B,Y: B,R3: set(product_prod(B,B)),Z2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,R3))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),Z2),transitive_trancl(B,R3))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),transitive_trancl(B,R3)) ) ) ).

% rtrancl_trancl_trancl
tff(fact_3375_rtrancl__into__trancl2,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),C2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),C2),transitive_rtrancl(B,R3))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),C2),transitive_trancl(B,R3)) ) ) ).

% rtrancl_into_trancl2
tff(fact_3376_rtrancl__into__trancl1,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),C2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,R3))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),C2),R3)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),C2),transitive_trancl(B,R3)) ) ) ).

% rtrancl_into_trancl1
tff(fact_3377_rtrancl__eq__or__trancl,axiom,
    ! [B: $tType,X: B,Y: B,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,R))
    <=> ( ( X = Y )
        | ( ( X != Y )
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_trancl(B,R)) ) ) ) ).

% rtrancl_eq_or_trancl
tff(fact_3378_trancl__into__rtrancl,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,R3))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,R3)) ) ).

% trancl_into_rtrancl
tff(fact_3379_tranclD2,axiom,
    ! [B: $tType,X: B,Y: B,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_trancl(B,R))
     => ? [Z3: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z3),transitive_rtrancl(B,R))
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z3),Y),R) ) ) ).

% tranclD2
tff(fact_3380_rtranclD,axiom,
    ! [B: $tType,A3: B,Ba: B,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_rtrancl(B,R))
     => ( ( A3 = Ba )
        | ( ( A3 != Ba )
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,R)) ) ) ) ).

% rtranclD
tff(fact_3381_tranclD,axiom,
    ! [B: $tType,X: B,Y: B,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_trancl(B,R))
     => ? [Z3: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z3),R)
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z3),Y),transitive_rtrancl(B,R)) ) ) ).

% tranclD
tff(fact_3382_rel__restrict__trancl__notR_I2_J,axiom,
    ! [B: $tType,V: B,W2: B,E4: set(product_prod(B,B)),R: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2),transitive_trancl(B,rel_restrict(B,E4,R)))
     => ~ member(B,W2,R) ) ).

% rel_restrict_trancl_notR(2)
tff(fact_3383_rel__restrict__trancl__notR_I1_J,axiom,
    ! [B: $tType,V: B,W2: B,E4: set(product_prod(B,B)),R: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2),transitive_trancl(B,rel_restrict(B,E4,R)))
     => ~ member(B,V,R) ) ).

% rel_restrict_trancl_notR(1)
tff(fact_3384_rel__restrict__trancl__mem,axiom,
    ! [B: $tType,A3: B,Ba: B,A4: set(product_prod(B,B)),R: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,rel_restrict(B,A4,R)))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),rel_restrict(B,transitive_trancl(B,A4),R)) ) ).

% rel_restrict_trancl_mem
tff(fact_3385_trancl__induct2,axiom,
    ! [B: $tType,C: $tType,Ax: B,Ay: C,Bx: B,By: C,R3: set(product_prod(product_prod(B,C),product_prod(B,C))),Pa: fun(B,fun(C,$o))] :
      ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Bx),By)),transitive_trancl(product_prod(B,C),R3))
     => ( ! [A8: B,B4: C] :
            ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),R3)
           => aa(C,$o,aa(B,fun(C,$o),Pa,A8),B4) )
       => ( ! [A8: B,B4: C,Aa2: B,Ba2: C] :
              ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),transitive_trancl(product_prod(B,C),R3))
             => ( member(product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C)),aa(product_prod(B,C),fun(product_prod(B,C),product_prod(product_prod(B,C),product_prod(B,C))),product_Pair(product_prod(B,C),product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Aa2),Ba2)),R3)
               => ( aa(C,$o,aa(B,fun(C,$o),Pa,A8),B4)
                 => aa(C,$o,aa(B,fun(C,$o),Pa,Aa2),Ba2) ) ) )
         => aa(C,$o,aa(B,fun(C,$o),Pa,Bx),By) ) ) ) ).

% trancl_induct2
tff(fact_3386_Image__empty__trancl__Image__empty,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),V: B] :
      ( ( image(B,B,R,aa(set(B),set(B),insert2(B,V),bot_bot(set(B)))) = bot_bot(set(B)) )
     => ( image(B,B,transitive_trancl(B,R),aa(set(B),set(B),insert2(B,V),bot_bot(set(B)))) = bot_bot(set(B)) ) ) ).

% Image_empty_trancl_Image_empty
tff(fact_3387_wf__linord__ex__has__least,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),Pa: fun(C,$o),K: C,M4: fun(C,B)] :
      ( wf(B,R3)
     => ( ! [X2: B,Y2: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),transitive_trancl(B,R3))
          <=> ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),X2),transitive_rtrancl(B,R3)) )
       => ( aa(C,$o,Pa,K)
         => ? [X2: C] :
              ( aa(C,$o,Pa,X2)
              & ! [Y4: C] :
                  ( aa(C,$o,Pa,Y4)
                 => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(C,B,M4,X2)),aa(C,B,M4,Y4)),transitive_rtrancl(B,R3)) ) ) ) ) ) ).

% wf_linord_ex_has_least
tff(fact_3388_trancl__union__outside,axiom,
    ! [B: $tType,V: B,W2: B,E4: set(product_prod(B,B)),U2: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2),transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),E4),U2)))
     => ( ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2),transitive_trancl(B,E4))
       => ? [X2: B,Y2: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),X2),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),E4),U2)))
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),U2)
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),W2),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),E4),U2))) ) ) ) ).

% trancl_union_outside
tff(fact_3389_trancl__over__edgeE,axiom,
    ! [B: $tType,U: B,W2: B,V1: B,V22: B,E4: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),W2),transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V1),V22)),E4)))
     => ( ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),W2),transitive_trancl(B,E4))
       => ~ ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V1),transitive_rtrancl(B,E4))
           => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V22),W2),transitive_rtrancl(B,E4)) ) ) ) ).

% trancl_over_edgeE
tff(fact_3390_antisym__singleton,axiom,
    ! [B: $tType,X: product_prod(B,B)] : antisym(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),X),bot_bot(set(product_prod(B,B))))) ).

% antisym_singleton
tff(fact_3391_trancl__Int__subset,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),S: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R3),S)
     => ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),relcomp(B,B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),transitive_trancl(B,R3)),S),R3)),S)
       => aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),transitive_trancl(B,R3)),S) ) ) ).

% trancl_Int_subset
tff(fact_3392_Restr__trancl__mono,axiom,
    ! [B: $tType,V: B,W2: B,E4: set(product_prod(B,B)),U2: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2),transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),E4),product_Sigma(B,B,U2,aTP_Lamp_if(set(B),fun(B,set(B)),U2)))))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),V),W2),transitive_trancl(B,E4)) ) ).

% Restr_trancl_mono
tff(fact_3393_antisym__Restr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( antisym(B,R3)
     => antisym(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) ) ).

% antisym_Restr
tff(fact_3394_rel__restrict__tranclI,axiom,
    ! [B: $tType,X: B,Y: B,E4: set(product_prod(B,B)),R: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_trancl(B,E4))
     => ( ~ member(B,X,R)
       => ( ~ member(B,Y,R)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),image(B,B,E4,R)),R)
           => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_trancl(B,rel_restrict(B,E4,R))) ) ) ) ) ).

% rel_restrict_tranclI
tff(fact_3395_trancl__insert2,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B))] : ( transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba)),R3)) = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),transitive_trancl(B,R3)),aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aa(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o))),aTP_Lamp_lq(B,fun(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o)))),A3),Ba),R3)))) ) ).

% trancl_insert2
tff(fact_3396_trancl__Image__advance__ss,axiom,
    ! [B: $tType,U: B,V: B,E4: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V),E4)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),image(B,B,transitive_trancl(B,E4),aa(set(B),set(B),insert2(B,V),bot_bot(set(B))))),image(B,B,transitive_trancl(B,E4),aa(set(B),set(B),insert2(B,U),bot_bot(set(B))))) ) ).

% trancl_Image_advance_ss
tff(fact_3397_trancl__restrict__reachable,axiom,
    ! [B: $tType,U: B,V: B,E4: set(product_prod(B,B)),S2: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V),transitive_trancl(B,E4))
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),image(B,B,E4,S2)),S2)
       => ( member(B,U,S2)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),U),V),transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),E4),product_Sigma(B,B,S2,aTP_Lamp_if(set(B),fun(B,set(B)),S2))))) ) ) ) ).

% trancl_restrict_reachable
tff(fact_3398_rtrancl__last__visit,axiom,
    ! [B: $tType,Q2: B,Q4: B,R: set(product_prod(B,B)),S2: set(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),Q4),transitive_rtrancl(B,R))
     => ( ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),Q4),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_if(set(B),fun(B,set(B)),S2)))))
       => ~ ! [Qt: B] :
              ( member(B,Qt,S2)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Q2),Qt),transitive_trancl(B,R))
               => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Qt),Q4),transitive_rtrancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),R),product_Sigma(B,B,top_top(set(B)),aTP_Lamp_if(set(B),fun(B,set(B)),S2))))) ) ) ) ) ).

% rtrancl_last_visit
tff(fact_3399_trancl__insert,axiom,
    ! [B: $tType,Y: B,X: B,R3: set(product_prod(B,B))] : ( transitive_trancl(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),X)),R3)) = aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),transitive_trancl(B,R3)),aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aa(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o))),aTP_Lamp_jh(B,fun(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o)))),Y),X),R3)))) ) ).

% trancl_insert
tff(fact_3400_new__addrs__def,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat),H4: heap_ext(product_unit)] : ( hoare_new_addrs(H2,As,H4) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),As),aa(fun(nat,$o),set(nat),collect(nat),aa(heap_ext(product_unit),fun(nat,$o),aTP_Lamp_lr(heap_ext(product_unit),fun(heap_ext(product_unit),fun(nat,$o)),H2),H4))) ) ).

% new_addrs_def
tff(fact_3401_flat__lub__def,axiom,
    ! [B: $tType,Ba: B,A4: set(B)] :
      ( aa(set(B),B,partial_flat_lub(B,Ba),A4)
      = $ite(aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))),Ba,the(B,aa(set(B),fun(B,$o),aTP_Lamp_ls(B,fun(set(B),fun(B,$o)),Ba),A4))) ) ).

% flat_lub_def
tff(fact_3402_Rep__unit,axiom,
    ! [X: product_unit] : member($o,aa(product_unit,$o,product_Rep_unit,X),aa(set($o),set($o),insert2($o,$true),bot_bot(set($o)))) ).

% Rep_unit
tff(fact_3403_Abs__unit__cases,axiom,
    ! [X: product_unit] :
      ~ ! [Y2: $o] :
          ( ( X = aa($o,product_unit,product_Abs_unit,Y2) )
         => ~ member($o,Y2,aa(set($o),set($o),insert2($o,$true),bot_bot(set($o)))) ) ).

% Abs_unit_cases
tff(fact_3404_Rep__unit__cases,axiom,
    ! [Y: $o] :
      ( member($o,Y,aa(set($o),set($o),insert2($o,$true),bot_bot(set($o))))
     => ~ ! [X2: product_unit] :
            ( (Y)
          <=> ~ aa(product_unit,$o,product_Rep_unit,X2) ) ) ).

% Rep_unit_cases
tff(fact_3405_type__definition__unit,axiom,
    type_definition(product_unit,$o,product_Rep_unit,product_Abs_unit,aa(set($o),set($o),insert2($o,$true),bot_bot(set($o)))) ).

% type_definition_unit
tff(fact_3406_Abs__unit__inverse,axiom,
    ! [Y: $o] :
      ( member($o,Y,aa(set($o),set($o),insert2($o,$true),bot_bot(set($o))))
     => ( aa(product_unit,$o,product_Rep_unit,aa($o,product_unit,product_Abs_unit,Y))
      <=> (Y) ) ) ).

% Abs_unit_inverse
tff(fact_3407_in__range_Oelims_I3_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X)
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ! [X2: nat] :
                ( member(nat,X2,As2)
               => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),lim(product_unit,H)) ) ) ) ).

% in_range.elims(3)
tff(fact_3408_in__range_Oelims_I2_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X)
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ~ ! [X3: nat] :
                  ( member(nat,X3,As2)
                 => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),lim(product_unit,H)) ) ) ) ).

% in_range.elims(2)
tff(fact_3409_in__range_Oelims_I1_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X)
      <=> (Y) )
     => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
            ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
           => ( (Y)
            <=> ~ ! [X4: nat] :
                    ( member(nat,X4,As2)
                   => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),lim(product_unit,H)) ) ) ) ) ).

% in_range.elims(1)
tff(fact_3410_in__range_Osimps,axiom,
    ! [H2: heap_ext(product_unit),As: set(nat)] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
    <=> ! [X4: nat] :
          ( member(nat,X4,As)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),lim(product_unit,H2)) ) ) ).

% in_range.simps
tff(fact_3411_Rep__unit__induct,axiom,
    ! [Y: $o,Pa: fun($o,$o)] :
      ( member($o,Y,aa(set($o),set($o),insert2($o,$true),bot_bot(set($o))))
     => ( ! [X2: product_unit] : aa($o,$o,Pa,aa(product_unit,$o,product_Rep_unit,X2))
       => aa($o,$o,Pa,Y) ) ) ).

% Rep_unit_induct
tff(fact_3412_Abs__unit__inject,axiom,
    ! [X: $o,Y: $o] :
      ( member($o,X,aa(set($o),set($o),insert2($o,$true),bot_bot(set($o))))
     => ( member($o,Y,aa(set($o),set($o),insert2($o,$true),bot_bot(set($o))))
       => ( ( aa($o,product_unit,product_Abs_unit,X) = aa($o,product_unit,product_Abs_unit,Y) )
        <=> ( (X)
          <=> (Y) ) ) ) ) ).

% Abs_unit_inject
tff(fact_3413_Abs__unit__induct,axiom,
    ! [Pa: fun(product_unit,$o),X: product_unit] :
      ( ! [Y2: $o] :
          ( member($o,Y2,aa(set($o),set($o),insert2($o,$true),bot_bot(set($o))))
         => aa(product_unit,$o,Pa,aa($o,product_unit,product_Abs_unit,Y2)) )
     => aa(product_unit,$o,Pa,X) ) ).

% Abs_unit_induct
tff(fact_3414_Partial__order__eq__Image1__Image1__iff,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( order_7125193373082350890der_on(B,field2(B,R3),R3)
     => ( member(B,A3,field2(B,R3))
       => ( member(B,Ba,field2(B,R3))
         => ( ( image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) = image(B,B,R3,aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))) )
          <=> ( A3 = Ba ) ) ) ) ) ).

% Partial_order_eq_Image1_Image1_iff
tff(fact_3415_return__def,axiom,
    ! [B: $tType,X: B] : ( aa(B,heap_Time_Heap(B),heap_Time_return(B),X) = heap_Time_heap(B,aTP_Lamp_lt(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),X)) ) ).

% return_def
tff(fact_3416_eventually__INF__base,axiom,
    ! [C: $tType,B: $tType,B2: set(B),F: fun(B,filter(C)),Pa: fun(C,$o)] :
      ( ( B2 != bot_bot(set(B)) )
     => ( ! [A8: B] :
            ( member(B,A8,B2)
           => ! [B4: B] :
                ( member(B,B4,B2)
               => ? [X3: B] :
                    ( member(B,X3,B2)
                    & aa(filter(C),$o,aa(filter(C),fun(filter(C),$o),ord_less_eq(filter(C)),aa(B,filter(C),F,X3)),aa(filter(C),filter(C),aa(filter(C),fun(filter(C),filter(C)),inf_inf(filter(C)),aa(B,filter(C),F,A8)),aa(B,filter(C),F,B4))) ) ) )
       => ( eventually(C,Pa,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),F),B2)))
        <=> ? [X4: B] :
              ( member(B,X4,B2)
              & eventually(C,Pa,aa(B,filter(C),F,X4)) ) ) ) ) ).

% eventually_INF_base
tff(fact_3417_proj__def,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,B)),X: C] : ( aa(C,set(B),equiv_proj(C,B,R3),X) = image(C,B,R3,aa(set(C),set(C),insert2(C,X),bot_bot(set(C)))) ) ).

% proj_def
tff(fact_3418_cSUP__UNION,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( condit1219197933456340205attice(D)
     => ! [A4: set(B),B2: fun(B,set(C)),Fa: fun(C,D)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,A4)
               => ( aa(B,set(C),B2,X2) != bot_bot(set(C)) ) )
           => ( condit941137186595557371_above(D,aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),aa(fun(C,D),fun(B,set(D)),aTP_Lamp_lu(fun(B,set(C)),fun(fun(C,D),fun(B,set(D))),B2),Fa)),A4)))
             => ( aa(set(D),D,complete_Sup_Sup(D),aa(set(C),set(D),image2(C,D,Fa),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A4)))) = aa(set(D),D,complete_Sup_Sup(D),aa(set(B),set(D),image2(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_lv(fun(B,set(C)),fun(fun(C,D),fun(B,D)),B2),Fa)),A4)) ) ) ) ) ) ).

% cSUP_UNION
tff(fact_3419_bdd__above__empty,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => condit941137186595557371_above(B,bot_bot(set(B))) ) ).

% bdd_above_empty
tff(fact_3420_eventually__const,axiom,
    ! [B: $tType,F: filter(B),Pa: $o] :
      ( ( F != bot_bot(filter(B)) )
     => ( eventually(B,aTP_Lamp_aj($o,fun(B,$o),Pa),F)
      <=> (Pa) ) ) ).

% eventually_const
tff(fact_3421_bdd__above__image__sup,axiom,
    ! [B: $tType,C: $tType] :
      ( lattice(B)
     => ! [Fa: fun(C,B),Ga: fun(C,B),A4: set(C)] :
          ( condit941137186595557371_above(B,aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_lw(fun(C,B),fun(fun(C,B),fun(C,B)),Fa),Ga)),A4))
        <=> ( condit941137186595557371_above(B,aa(set(C),set(B),image2(C,B,Fa),A4))
            & condit941137186595557371_above(B,aa(set(C),set(B),image2(C,B,Ga),A4)) ) ) ) ).

% bdd_above_image_sup
tff(fact_3422_bdd__above__Int2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B2: set(B),A4: set(B)] :
          ( condit941137186595557371_above(B,B2)
         => condit941137186595557371_above(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ) ).

% bdd_above_Int2
tff(fact_3423_bdd__above__Int1,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: set(B),B2: set(B)] :
          ( condit941137186595557371_above(B,A4)
         => condit941137186595557371_above(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ) ).

% bdd_above_Int1
tff(fact_3424_eventually__happens_H,axiom,
    ! [B: $tType,F: filter(B),Pa: fun(B,$o)] :
      ( ( F != bot_bot(filter(B)) )
     => ( eventually(B,Pa,F)
       => ? [X_1: B] : aa(B,$o,Pa,X_1) ) ) ).

% eventually_happens'
tff(fact_3425_eventually__happens,axiom,
    ! [B: $tType,Pa: fun(B,$o),Net: filter(B)] :
      ( eventually(B,Pa,Net)
     => ( ( Net = bot_bot(filter(B)) )
        | ? [X_1: B] : aa(B,$o,Pa,X_1) ) ) ).

% eventually_happens
tff(fact_3426_eventually__bot,axiom,
    ! [B: $tType,Pa: fun(B,$o)] : eventually(B,Pa,bot_bot(filter(B))) ).

% eventually_bot
tff(fact_3427_eventually__inf,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),F2: filter(B)] :
      ( eventually(B,Pa,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F),F2))
    <=> ? [Q7: fun(B,$o),R6: fun(B,$o)] :
          ( eventually(B,Q7,F)
          & eventually(B,R6,F2)
          & ! [X4: B] :
              ( ( aa(B,$o,Q7,X4)
                & aa(B,$o,R6,X4) )
             => aa(B,$o,Pa,X4) ) ) ) ).

% eventually_inf
tff(fact_3428_trivial__limit__def,axiom,
    ! [B: $tType,F: filter(B)] :
      ( ( F = bot_bot(filter(B)) )
    <=> eventually(B,aTP_Lamp_bi(B,$o),F) ) ).

% trivial_limit_def
tff(fact_3429_eventually__const__iff,axiom,
    ! [B: $tType,Pa: $o,F: filter(B)] :
      ( eventually(B,aTP_Lamp_aj($o,fun(B,$o),Pa),F)
    <=> ( (Pa)
        | ( F = bot_bot(filter(B)) ) ) ) ).

% eventually_const_iff
tff(fact_3430_False__imp__not__eventually,axiom,
    ! [B: $tType,Pa: fun(B,$o),Net: filter(B)] :
      ( ! [X2: B] : ~ aa(B,$o,Pa,X2)
     => ( ( Net != bot_bot(filter(B)) )
       => ~ eventually(B,Pa,Net) ) ) ).

% False_imp_not_eventually
tff(fact_3431_effect__heapE,axiom,
    ! [B: $tType,Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( heap_Time_effect(B,heap_Time_heap(B,Fa),H2,H4,R3,N)
     => ~ ( ( H4 = aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2))) )
         => ( ( N = aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2))) )
           => ( R3 != aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),B,product_fst(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2)) ) ) ) ) ).

% effect_heapE
tff(fact_3432_effect__heapI,axiom,
    ! [B: $tType,N: nat,Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B] :
      ( ( N = aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2))) )
     => ( ( H4 = aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2))) )
       => ( ( R3 = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),B,product_fst(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2)) )
         => heap_Time_effect(B,heap_Time_heap(B,Fa),H2,H4,R3,N) ) ) ) ).

% effect_heapI
tff(fact_3433_success__heapI,axiom,
    ! [B: $tType,Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),H2: heap_ext(product_unit)] : heap_Time_success(B,heap_Time_heap(B,Fa),H2) ).

% success_heapI
tff(fact_3434_cSup__mono,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [B2: set(B),A4: set(B)] :
          ( ( B2 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,A4)
           => ( ! [B4: B] :
                  ( member(B,B4,B2)
                 => ? [X3: B] :
                      ( member(B,X3,A4)
                      & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B4),X3) ) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),B2)),aa(set(B),B,complete_Sup_Sup(B),A4)) ) ) ) ) ).

% cSup_mono
tff(fact_3435_cSup__le__iff,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [S2: set(B),A3: B] :
          ( ( S2 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,S2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),S2)),A3)
            <=> ! [X4: B] :
                  ( member(B,X4,S2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),A3) ) ) ) ) ) ).

% cSup_le_iff
tff(fact_3436_less__cSup__iff,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X6: set(B),Y: B] :
          ( ( X6 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,X6)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),aa(set(B),B,complete_Sup_Sup(B),X6))
            <=> ? [X4: B] :
                  ( member(B,X4,X6)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),X4) ) ) ) ) ) ).

% less_cSup_iff
tff(fact_3437_partial__order__on__empty,axiom,
    ! [B: $tType] : order_7125193373082350890der_on(B,bot_bot(set(B)),bot_bot(set(product_prod(B,B)))) ).

% partial_order_on_empty
tff(fact_3438_eventually__Inf__base,axiom,
    ! [B: $tType,B2: set(filter(B)),Pa: fun(B,$o)] :
      ( ( B2 != bot_bot(set(filter(B))) )
     => ( ! [F5: filter(B)] :
            ( member(filter(B),F5,B2)
           => ! [G6: filter(B)] :
                ( member(filter(B),G6,B2)
               => ? [X3: filter(B)] :
                    ( member(filter(B),X3,B2)
                    & aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),X3),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F5),G6)) ) ) )
       => ( eventually(B,Pa,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),B2))
        <=> ? [X4: filter(B)] :
              ( member(filter(B),X4,B2)
              & eventually(B,Pa,X4) ) ) ) ) ).

% eventually_Inf_base
tff(fact_3439_cSUP__le__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Fa: fun(B,C),U: C] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,Fa),A4))
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))),U)
            <=> ! [X4: B] :
                  ( member(B,X4,A4)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X4)),U) ) ) ) ) ) ).

% cSUP_le_iff
tff(fact_3440_cSUP__mono,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Ga: fun(D,C),B2: set(D),Fa: fun(B,C)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(D),set(C),image2(D,C,Ga),B2))
           => ( ! [N3: B] :
                  ( member(B,N3,A4)
                 => ? [X3: D] :
                      ( member(D,X3,B2)
                      & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,N3)),aa(D,C,Ga,X3)) ) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))),aa(set(C),C,complete_Sup_Sup(C),aa(set(D),set(C),image2(D,C,Ga),B2))) ) ) ) ) ).

% cSUP_mono
tff(fact_3441_cSup__subset__mono,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A4: set(B),B2: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,B2)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),A4)),aa(set(B),B,complete_Sup_Sup(B),B2)) ) ) ) ) ).

% cSup_subset_mono
tff(fact_3442_cSup__insert__If,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X6: set(B),A3: B] :
          ( condit941137186595557371_above(B,X6)
         => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert2(B,A3),X6))
            = $ite(X6 = bot_bot(set(B)),A3,aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),aa(set(B),B,complete_Sup_Sup(B),X6))) ) ) ) ).

% cSup_insert_If
tff(fact_3443_cSup__insert,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X6: set(B),A3: B] :
          ( ( X6 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,X6)
           => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert2(B,A3),X6)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),A3),aa(set(B),B,complete_Sup_Sup(B),X6)) ) ) ) ) ).

% cSup_insert
tff(fact_3444_cSup__union__distrib,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A4: set(B),B2: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,A4)
           => ( ( B2 != bot_bot(set(B)) )
             => ( condit941137186595557371_above(B,B2)
               => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),A4)),aa(set(B),B,complete_Sup_Sup(B),B2)) ) ) ) ) ) ) ).

% cSup_union_distrib
tff(fact_3445_less__cSUP__iff,axiom,
    ! [C: $tType,B: $tType] :
      ( condit6923001295902523014norder(C)
     => ! [A4: set(B),Fa: fun(B,C),A3: C] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,Fa),A4))
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),A3),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4)))
            <=> ? [X4: B] :
                  ( member(B,X4,A4)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less(C),A3),aa(B,C,Fa,X4)) ) ) ) ) ) ).

% less_cSUP_iff
tff(fact_3446_conditionally__complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Fa: fun(B,C),Ga: fun(B,C)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,Fa),A4))
           => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,Ga),A4))
             => ( aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Ga),A4))) = aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_lx(fun(B,C),fun(fun(B,C),fun(B,C)),Fa),Ga)),A4)) ) ) ) ) ) ).

% conditionally_complete_lattice_class.SUP_sup_distrib
tff(fact_3447_cSUP__subset__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Ga: fun(B,C),B2: set(B),Fa: fun(B,C)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,Ga),B2))
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
             => ( ! [X2: B] :
                    ( member(B,X2,A4)
                   => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X2)),aa(B,C,Ga,X2)) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Ga),B2))) ) ) ) ) ) ).

% cSUP_subset_mono
tff(fact_3448_cSup__inter__less__eq,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A4: set(B),B2: set(B)] :
          ( condit941137186595557371_above(B,A4)
         => ( condit941137186595557371_above(B,B2)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) != bot_bot(set(B)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(set(B),B,complete_Sup_Sup(B),A4)),aa(set(B),B,complete_Sup_Sup(B),B2))) ) ) ) ) ).

% cSup_inter_less_eq
tff(fact_3449_cSUP__insert,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Fa: fun(B,C),A3: B] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,Fa),A4))
           => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),aa(set(B),set(B),insert2(B,A3),A4))) = aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(B,C,Fa,A3)),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))) ) ) ) ) ).

% cSUP_insert
tff(fact_3450_Partial__order__Restr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( order_7125193373082350890der_on(B,field2(B,R3),R3)
     => order_7125193373082350890der_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) ) ).

% Partial_order_Restr
tff(fact_3451_cSUP__union,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Fa: fun(B,C),B2: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,Fa),A4))
           => ( ( B2 != bot_bot(set(B)) )
             => ( condit941137186595557371_above(C,aa(set(B),set(C),image2(B,C,Fa),B2))
               => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))) = aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),B2))) ) ) ) ) ) ) ).

% cSUP_union
tff(fact_3452_ureturn__def,axiom,
    ! [B: $tType,X: B] : ( aa(B,heap_Time_Heap(B),heap_Time_ureturn(B),X) = heap_Time_heap(B,aTP_Lamp_ly(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),X)) ) ).

% ureturn_def
tff(fact_3453_map__filter__on__comp,axiom,
    ! [B: $tType,D: $tType,C: $tType,Ga: fun(C,B),Y5: set(C),X6: set(B),F: filter(C),Fa: fun(B,D)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(C),set(B),image2(C,B,Ga),Y5)),X6)
     => ( eventually(C,aTP_Lamp_lz(set(C),fun(C,$o),Y5),F)
       => ( map_filter_on(B,D,X6,Fa,map_filter_on(C,B,Y5,Ga,F)) = map_filter_on(C,D,Y5,aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),Fa),Ga),F) ) ) ) ).

% map_filter_on_comp
tff(fact_3454_Ref__Time_Oupdate__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),V: B] : ( ref_update(B,R3,V) = heap_Time_heap(product_unit,aa(B,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_ma(ref(B),fun(B,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),R3),V)) ) ) ).

% Ref_Time.update_def
tff(fact_3455_Zorns__po__lemma,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( order_7125193373082350890der_on(B,field2(B,R3),R3)
     => ( ! [C6: set(B)] :
            ( member(set(B),C6,chains(B,R3))
           => ? [X3: B] :
                ( member(B,X3,field2(B,R3))
                & ! [Xa4: B] :
                    ( member(B,Xa4,C6)
                   => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa4),X3),R3) ) ) )
       => ? [X2: B] :
            ( member(B,X2,field2(B,R3))
            & ! [Xa3: B] :
                ( member(B,Xa3,field2(B,R3))
               => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Xa3),R3)
                 => ( Xa3 = X2 ) ) ) ) ) ) ).

% Zorns_po_lemma
tff(fact_3456_hoare__tripleE,axiom,
    ! [B: $tType,Pa: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn),H2: heap_ext(product_unit),As: set(nat)] :
      ( hoare_hoare_triple(B,Pa,C2,Qa)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
       => ~ ! [R2: B,H5: heap_ext(product_unit)] :
              ( ? [T2: nat] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),C2),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H5),T2))) )
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Qa,R2)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H5),hoare_new_addrs(H2,As,H5)))
               => ( relH(aa(fun(nat,$o),set(nat),collect(nat),aa(set(nat),fun(nat,$o),aTP_Lamp_mb(heap_ext(product_unit),fun(set(nat),fun(nat,$o)),H2),As)),H2,H5)
                 => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),lim(product_unit,H2)),lim(product_unit,H5)) ) ) ) ) ) ).

% hoare_tripleE
tff(fact_3457_successE,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit)] :
      ( heap_Time_success(B,Fa,H2)
     => ~ ! [R2: B,H5: product_prod(heap_ext(product_unit),nat)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2) != aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R2),H5)) ) ) ).

% successE
tff(fact_3458_execute__heap,axiom,
    ! [B: $tType,Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))] : ( aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_heap(B,Fa)) = aa(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(fun(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),comp(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),some(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Fa) ) ).

% execute_heap
tff(fact_3459_Heap__eqI,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B),Ga: heap_Time_Heap(B)] :
      ( ! [H: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H) = aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Ga),H) )
     => ( Fa = Ga ) ) ).

% Heap_eqI
tff(fact_3460_execute__ureturn,axiom,
    ! [B: $tType,X: B] : ( aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),aa(B,heap_Time_Heap(B),heap_Time_ureturn(B),X)) = aa(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(fun(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),comp(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),some(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_ly(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),X)) ) ).

% execute_ureturn
tff(fact_3461_execute__update,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),V: B,H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(product_unit),fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(product_unit),ref_update(B,R3,V)),H2) = aa(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),some(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(product_unit,fun(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),product_Pair(product_unit,product_prod(heap_ext(product_unit),nat)),product_Unity),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),ref_set(B,R3,V,H2)),one_one(nat)))) ) ) ).

% execute_update
tff(fact_3462_effect__def,axiom,
    ! [B: $tType,C2: heap_Time_Heap(B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( heap_Time_effect(B,C2,H2,H4,R3,N)
    <=> ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),C2),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H4),N))) ) ) ).

% effect_def
tff(fact_3463_effectI,axiom,
    ! [B: $tType,C2: heap_Time_Heap(B),H2: heap_ext(product_unit),R3: B,H4: heap_ext(product_unit),N: nat] :
      ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),C2),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H4),N))) )
     => heap_Time_effect(B,C2,H2,H4,R3,N) ) ).

% effectI
tff(fact_3464_execute__bind__eq__SomeI,axiom,
    ! [B: $tType,C: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit),X: B,H4: heap_ext(product_unit),N: nat,Ga: fun(B,heap_Time_Heap(C)),Y: C,H6: heap_ext(product_unit),N2: nat] :
      ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),X),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H4),N))) )
     => ( ( aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(C),fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(C),aa(B,heap_Time_Heap(C),Ga,X)),H4) = aa(product_prod(C,product_prod(heap_ext(product_unit),nat)),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),some(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(C,product_prod(heap_ext(product_unit),nat)),aa(C,fun(product_prod(heap_ext(product_unit),nat),product_prod(C,product_prod(heap_ext(product_unit),nat))),product_Pair(C,product_prod(heap_ext(product_unit),nat)),Y),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H6),N2))) )
       => ( aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(C),fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(C),heap_Time_bind(B,C,Fa,Ga)),H2) = aa(product_prod(C,product_prod(heap_ext(product_unit),nat)),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),some(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(C,product_prod(heap_ext(product_unit),nat)),aa(C,fun(product_prod(heap_ext(product_unit),nat),product_prod(C,product_prod(heap_ext(product_unit),nat))),product_Pair(C,product_prod(heap_ext(product_unit),nat)),Y),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H6),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N2)))) ) ) ) ).

% execute_bind_eq_SomeI
tff(fact_3465_success__bind__executeI,axiom,
    ! [B: $tType,C: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit),X: B,H4: heap_ext(product_unit),N: nat,Ga: fun(B,heap_Time_Heap(C))] :
      ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),X),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H4),N))) )
     => ( heap_Time_success(C,aa(B,heap_Time_Heap(C),Ga,X),H4)
       => heap_Time_success(C,heap_Time_bind(B,C,Fa,Ga),H2) ) ) ).

% success_bind_executeI
tff(fact_3466_execute__assert_I1_J,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: B,H2: heap_ext(product_unit)] :
      ( aa(B,$o,Pa,X)
     => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_assert(B,Pa,X)),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),X),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),one_one(nat)))) ) ) ).

% execute_assert(1)
tff(fact_3467_execute__tap,axiom,
    ! [B: $tType,Fa: fun(heap_ext(product_unit),B),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_tap(B,Fa)),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),B,Fa,H2)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),one_one(nat)))) ) ).

% execute_tap
tff(fact_3468_execute__return,axiom,
    ! [B: $tType,X: B] : ( aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),aa(B,heap_Time_Heap(B),heap_Time_return(B),X)) = aa(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(fun(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),comp(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),some(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_lt(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),X)) ) ).

% execute_return
tff(fact_3469_ureturn__bind,axiom,
    ! [B: $tType,C: $tType,X: C,Fa: fun(C,heap_Time_Heap(B))] : ( heap_Time_bind(C,B,aa(C,heap_Time_Heap(C),heap_Time_ureturn(C),X),Fa) = aa(C,heap_Time_Heap(B),Fa,X) ) ).

% ureturn_bind
tff(fact_3470_bind__ureturn,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B)] : ( heap_Time_bind(B,B,Fa,heap_Time_ureturn(B)) = Fa ) ).

% bind_ureturn
tff(fact_3471_success__ureturnI,axiom,
    ! [B: $tType,X: B,H2: heap_ext(product_unit)] : heap_Time_success(B,aa(B,heap_Time_Heap(B),heap_Time_ureturn(B),X),H2) ).

% success_ureturnI
tff(fact_3472_effect__ureturnE,axiom,
    ! [B: $tType,X: B,H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( heap_Time_effect(B,aa(B,heap_Time_Heap(B),heap_Time_ureturn(B),X),H2,H4,R3,N)
     => ~ ( ( R3 = X )
         => ( ( H4 = H2 )
           => ( N != zero_zero(nat) ) ) ) ) ).

% effect_ureturnE
tff(fact_3473_effect__ureturnI,axiom,
    ! [B: $tType,H2: heap_ext(product_unit),H4: heap_ext(product_unit),X: B] :
      ( ( H2 = H4 )
     => heap_Time_effect(B,aa(B,heap_Time_Heap(B),heap_Time_ureturn(B),X),H2,H4,X,zero_zero(nat)) ) ).

% effect_ureturnI
tff(fact_3474_hoare__triple__def,axiom,
    ! [B: $tType,Pa: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( hoare_hoare_triple(B,Pa,C2,Qa)
    <=> ! [H3: heap_ext(product_unit),As7: set(nat)] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H3),As7))
         => ? [R5: B,H9: heap_ext(product_unit)] :
              ( ? [T7: nat] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),C2),H3) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R5),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H9),T7))) )
              & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Qa,R5)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H9),hoare_new_addrs(H3,As7,H9)))
              & relH(aa(fun(nat,$o),set(nat),collect(nat),aa(set(nat),fun(nat,$o),aTP_Lamp_mb(heap_ext(product_unit),fun(set(nat),fun(nat,$o)),H3),As7)),H3,H9)
              & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),lim(product_unit,H3)),lim(product_unit,H9)) ) ) ) ).

% hoare_triple_def
tff(fact_3475_hoare__tripleI,axiom,
    ! [B: $tType,Pa: assn,C2: heap_Time_Heap(B),Qa: fun(B,assn)] :
      ( ! [H: heap_ext(product_unit),As2: set(nat)] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
         => ? [R7: B,H8: heap_ext(product_unit),T8: nat] :
              ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),C2),H) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R7),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H8),T8))) )
              & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Qa,R7)),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H8),hoare_new_addrs(H,As2,H8)))
              & relH(aa(fun(nat,$o),set(nat),collect(nat),aa(set(nat),fun(nat,$o),aTP_Lamp_mb(heap_ext(product_unit),fun(set(nat),fun(nat,$o)),H),As2)),H,H8)
              & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),lim(product_unit,H)),lim(product_unit,H8)) ) )
     => hoare_hoare_triple(B,Pa,C2,Qa) ) ).

% hoare_tripleI
tff(fact_3476_sup__Some,axiom,
    ! [B: $tType] :
      ( sup(B)
     => ! [X: B,Y: B] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),sup_sup(option(B)),aa(B,option(B),some(B),X)),aa(B,option(B),some(B),Y)) = aa(B,option(B),some(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X),Y)) ) ) ).

% sup_Some
tff(fact_3477_inf__Some,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [X: B,Y: B] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),inf_inf(option(B)),aa(B,option(B),some(B),X)),aa(B,option(B),some(B),Y)) = aa(B,option(B),some(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),X),Y)) ) ) ).

% inf_Some
tff(fact_3478_Some__SUP,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A4: set(B),Fa: fun(B,C)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(C,option(C),some(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))) = aa(set(option(C)),option(C),complete_Sup_Sup(option(C)),aa(set(B),set(option(C)),image2(B,option(C),aTP_Lamp_mc(fun(B,C),fun(B,option(C)),Fa)),A4)) ) ) ) ).

% Some_SUP
tff(fact_3479_rel__of__def,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C)),Pa: fun(product_prod(B,C),$o)] : ( rel_of(B,C,M4,Pa) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(fun(product_prod(B,C),$o),fun(B,fun(C,$o)),aTP_Lamp_md(fun(B,option(C)),fun(fun(product_prod(B,C),$o),fun(B,fun(C,$o))),M4),Pa))) ) ).

% rel_of_def
tff(fact_3480_effect__guardI,axiom,
    ! [B: $tType,Pa: fun(heap_ext(product_unit),$o),H2: heap_ext(product_unit),H4: heap_ext(product_unit),Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),N: nat,R3: B] :
      ( aa(heap_ext(product_unit),$o,Pa,H2)
     => ( ( H4 = aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2))) )
       => ( ( N = aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2))) )
         => ( ( R3 = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),B,product_fst(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2)) )
           => heap_Time_effect(B,heap_Time_guard(B,Pa,Fa),H2,H4,R3,N) ) ) ) ) ).

% effect_guardI
tff(fact_3481_success__guardI,axiom,
    ! [B: $tType,Pa: fun(heap_ext(product_unit),$o),H2: heap_ext(product_unit),Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))] :
      ( aa(heap_ext(product_unit),$o,Pa,H2)
     => heap_Time_success(B,heap_Time_guard(B,Pa,Fa),H2) ) ).

% success_guardI
tff(fact_3482_execute__guard_I2_J,axiom,
    ! [B: $tType,Pa: fun(heap_ext(product_unit),$o),H2: heap_ext(product_unit),Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))] :
      ( aa(heap_ext(product_unit),$o,Pa,H2)
     => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_guard(B,Pa,Fa)),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2)) ) ) ).

% execute_guard(2)
tff(fact_3483_Some__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(B,option(B),some(B),aa(set(B),B,complete_Sup_Sup(B),A4)) = aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),aa(set(B),set(option(B)),image2(B,option(B),some(B)),A4)) ) ) ) ).

% Some_Sup
tff(fact_3484_effect__guardE,axiom,
    ! [B: $tType,Pa: fun(heap_ext(product_unit),$o),Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( heap_Time_effect(B,heap_Time_guard(B,Pa,Fa),H2,H4,R3,N)
     => ~ ( ( H4 = aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2))) )
         => ( ( N = aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2))) )
           => ( ( R3 = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),B,product_fst(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Fa,H2)) )
             => ~ aa(heap_ext(product_unit),$o,Pa,H2) ) ) ) ) ).

% effect_guardE
tff(fact_3485_execute__change,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Fa: fun(B,B),R3: ref(B),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),ref_change(B,Fa,R3)),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),aa(B,B,Fa,aa(ref(B),B,ref_get(B,H2),R3))),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),ref_set(B,R3,aa(B,B,Fa,aa(ref(B),B,ref_get(B,H2),R3)),H2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))))) ) ) ).

% execute_change
tff(fact_3486_map__to__set__upd,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C)),K: B,V: C] : ( map_to_set(B,C,fun_upd(B,option(C),M4,K,aa(C,option(C),some(C),V))) = aa(set(product_prod(B,C)),set(product_prod(B,C)),insert2(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K),V)),aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),minus_minus(set(product_prod(B,C))),map_to_set(B,C,M4)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aTP_Lamp_me(B,fun(product_prod(B,C),$o),K)))) ) ).

% map_to_set_upd
tff(fact_3487_effectE,axiom,
    ! [B: $tType,C2: heap_Time_Heap(B),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: B,N: nat] :
      ( heap_Time_effect(B,C2,H2,H4,R3,N)
     => ~ ( ( R3 = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),B,product_fst(B,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(B,product_prod(heap_ext(product_unit),nat)),the2(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),C2),H2))) )
         => ( ( H4 = aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(B,product_prod(heap_ext(product_unit),nat)),the2(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),C2),H2)))) )
           => ( ( N = aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(B,product_prod(heap_ext(product_unit),nat)),the2(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),C2),H2)))) )
             => ~ heap_Time_success(B,C2,H2) ) ) ) ) ).

% effectE
tff(fact_3488_execute__bind_I1_J,axiom,
    ! [B: $tType,C: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit),X: B,H4: heap_ext(product_unit),N: nat,Ga: fun(B,heap_Time_Heap(C))] :
      ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),X),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H4),N))) )
     => ( aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(C),fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(C),heap_Time_bind(B,C,Fa,Ga)),H2) = heap_Time_timeFrame(C,N,aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(C),fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(C),aa(B,heap_Time_Heap(C),Ga,X)),H4)) ) ) ).

% execute_bind(1)
tff(fact_3489_wait__def,axiom,
    ! [N: nat] : ( heap_Time_wait(N) = aa(fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(product_unit),heap_Time_Heap2(product_unit),aTP_Lamp_mf(nat,fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),N)) ) ).

% wait_def
tff(fact_3490_Heap_Oinject,axiom,
    ! [B: $tType,X: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Ya: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] :
      ( ( aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),X) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),Ya) )
    <=> ( X = Ya ) ) ).

% Heap.inject
tff(fact_3491_Heap__execute,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B)] : ( aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa)) = Fa ) ).

% Heap_execute
tff(fact_3492_timeFrame__zero,axiom,
    ! [B: $tType,H2: option(product_prod(B,product_prod(heap_ext(product_unit),nat)))] : ( heap_Time_timeFrame(B,zero_zero(nat),H2) = H2 ) ).

% timeFrame_zero
tff(fact_3493_timeFrame__assoc,axiom,
    ! [B: $tType,N: nat,N2: nat,Fa: option(product_prod(B,product_prod(heap_ext(product_unit),nat)))] : ( heap_Time_timeFrame(B,N,heap_Time_timeFrame(B,N2,Fa)) = heap_Time_timeFrame(B,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N2),Fa) ) ).

% timeFrame_assoc
tff(fact_3494_Heap_Oexhaust,axiom,
    ! [B: $tType,Y: heap_Time_Heap(B)] :
      ~ ! [X2: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] : ( Y != aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),X2) ) ).

% Heap.exhaust
tff(fact_3495_execute_Osimps,axiom,
    ! [B: $tType,Fa: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),Fa)) = Fa ) ).

% execute.simps
tff(fact_3496_heap__def,axiom,
    ! [B: $tType,Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))] : ( heap_Time_heap(B,Fa) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),aa(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(fun(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),comp(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),some(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Fa)) ) ).

% heap_def
tff(fact_3497_execute__bind__success,axiom,
    ! [C: $tType,B: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit),Ga: fun(B,heap_Time_Heap(C))] :
      ( heap_Time_success(B,Fa,H2)
     => ( aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(C),fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(C),heap_Time_bind(B,C,Fa,Ga)),H2) = heap_Time_timeFrame(C,aa(product_prod(heap_ext(product_unit),nat),nat,product_snd(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(B,product_prod(heap_ext(product_unit),nat)),the2(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2)))),aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(C),fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(C),aa(B,heap_Time_Heap(C),Ga,aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),B,product_fst(B,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(B,product_prod(heap_ext(product_unit),nat)),the2(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2))))),aa(product_prod(heap_ext(product_unit),nat),heap_ext(product_unit),product_fst(heap_ext(product_unit),nat),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(heap_ext(product_unit),nat),product_snd(B,product_prod(heap_ext(product_unit),nat)),aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(B,product_prod(heap_ext(product_unit),nat)),the2(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2)))))) ) ) ).

% execute_bind_success
tff(fact_3498_tap__def,axiom,
    ! [B: $tType,Fa: fun(heap_ext(product_unit),B)] : ( heap_Time_tap(B,Fa) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),aTP_Lamp_mg(fun(heap_ext(product_unit),B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Fa)) ) ).

% tap_def
tff(fact_3499_timeFrame_Osimps_I1_J,axiom,
    ! [B: $tType,N: nat,R3: B,H2: heap_ext(product_unit),N2: nat] : ( heap_Time_timeFrame(B,N,aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),N2)))) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N2)))) ) ).

% timeFrame.simps(1)
tff(fact_3500_execute__lookup,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),ref_lookup(B,R3)),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),aa(ref(B),B,ref_get(B,H2),R3)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),one_one(nat)))) ) ) ).

% execute_lookup
tff(fact_3501_comp__the__Some,axiom,
    ! [B: $tType] : ( aa(fun(B,option(B)),fun(B,B),aa(fun(option(B),B),fun(fun(B,option(B)),fun(B,B)),comp(option(B),B,B),the2(B)),some(B)) = id(B) ) ).

% comp_the_Some
tff(fact_3502_sngr__assn__raw_Osimps,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),X: B,H2: heap_ext(product_unit),As: set(nat)] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,R3,X),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
        <=> ( ( aa(ref(B),B,ref_get(B,H2),R3) = X )
            & ( As = aa(set(nat),set(nat),insert2(nat,aa(ref(B),nat,addr_of_ref(B),R3)),bot_bot(set(nat))) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(ref(B),nat,addr_of_ref(B),R3)),lim(product_unit,H2)) ) ) ) ).

% sngr_assn_raw.simps
tff(fact_3503_sngr__assn__raw_Oelims_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
          ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X,Xa),Xb)
          <=> (Y) )
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ( (Y)
                <=> ~ ( ( aa(ref(B),B,ref_get(B,H),X) = Xa )
                      & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(B),nat,addr_of_ref(B),X)),bot_bot(set(nat))) )
                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(ref(B),nat,addr_of_ref(B),X)),lim(product_unit,H)) ) ) ) ) ) ).

% sngr_assn_raw.elims(1)
tff(fact_3504_sngr__assn__raw_Oelims_I2_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X,Xa),Xb)
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ~ ( ( aa(ref(B),B,ref_get(B,H),X) = Xa )
                    & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(B),nat,addr_of_ref(B),X)),bot_bot(set(nat))) )
                    & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(ref(B),nat,addr_of_ref(B),X)),lim(product_unit,H)) ) ) ) ) ).

% sngr_assn_raw.elims(2)
tff(fact_3505_sngr__assn__raw_Oelims_I3_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X,Xa),Xb)
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ( ( aa(ref(B),B,ref_get(B,H),X) = Xa )
                  & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(B),nat,addr_of_ref(B),X)),bot_bot(set(nat))) )
                  & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(ref(B),nat,addr_of_ref(B),X)),lim(product_unit,H)) ) ) ) ) ).

% sngr_assn_raw.elims(3)
tff(fact_3506_relH__ref,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: ref(B)] :
          ( relH(As,H2,H4)
         => ( member(nat,aa(ref(B),nat,addr_of_ref(B),R3),As)
           => ( aa(ref(B),B,ref_get(B,H2),R3) = aa(ref(B),B,ref_get(B,H4),R3) ) ) ) ) ).

% relH_ref
tff(fact_3507_relH__set__ref,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),As: set(nat),H2: heap_ext(product_unit),X: B] :
          ( ~ member(nat,aa(ref(B),nat,addr_of_ref(B),R3),As)
         => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
           => relH(As,H2,ref_set(B,R3,X,H2)) ) ) ) ).

% relH_set_ref
tff(fact_3508_Heap_Osize__gen,axiom,
    ! [B: $tType,Xa: fun(B,nat),X: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(B),nat,heap_Time_size_Heap(B,Xa),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),X)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% Heap.size_gen
tff(fact_3509_sngr__assn__raw_Opelims_I3_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X,Xa),Xb)
         => ( aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))
                   => ( ( aa(ref(B),B,ref_get(B,H),X) = Xa )
                      & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(B),nat,addr_of_ref(B),X)),bot_bot(set(nat))) )
                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(ref(B),nat,addr_of_ref(B),X)),lim(product_unit,H)) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(3)
tff(fact_3510_sngr__assn__raw_Opelims_I2_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X,Xa),Xb)
         => ( aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))
                   => ~ ( ( aa(ref(B),B,ref_get(B,H),X) = Xa )
                        & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(B),nat,addr_of_ref(B),X)),bot_bot(set(nat))) )
                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(ref(B),nat,addr_of_ref(B),X)),lim(product_unit,H)) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(2)
tff(fact_3511_sngr__assn__raw_Opelims_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: ref(B),Xa: B,Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
          ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,sngr_assn_raw(B,X,Xa),Xb)
          <=> (Y) )
         => ( aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( ( (Y)
                    <=> ( ( aa(ref(B),B,ref_get(B,H),X) = Xa )
                        & ( As2 = aa(set(nat),set(nat),insert2(nat,aa(ref(B),nat,addr_of_ref(B),X)),bot_bot(set(nat))) )
                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(ref(B),nat,addr_of_ref(B),X)),lim(product_unit,H)) ) )
                   => ~ aa(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),sngr_assn_raw_rel(B)),aa(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),aa(ref(B),fun(product_prod(B,product_prod(heap_ext(product_unit),set(nat))),product_prod(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat))))),product_Pair(ref(B),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat))),aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(B,product_prod(heap_ext(product_unit),set(nat)))),product_Pair(B,product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))) ) ) ) ) ) ).

% sngr_assn_raw.pelims(1)
tff(fact_3512_Heap_Osize_I2_J,axiom,
    ! [B: $tType,X: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] : ( size_size(heap_Time_Heap(B),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),X)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% Heap.size(2)
tff(fact_3513_Heap_Osize__neq,axiom,
    ! [B: $tType,X: heap_Time_Heap(B)] : ( size_size(heap_Time_Heap(B),X) != zero_zero(nat) ) ).

% Heap.size_neq
tff(fact_3514_set__to__map__simp,axiom,
    ! [C: $tType,B: $tType,S2: set(product_prod(B,C)),K: B,V: C] :
      ( inj_on(product_prod(B,C),B,product_fst(B,C),S2)
     => ( ( aa(B,option(C),set_to_map(B,C,S2),K) = aa(C,option(C),some(C),V) )
      <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K),V),S2) ) ) ).

% set_to_map_simp
tff(fact_3515_Chains__subset_H,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( refl_on(B,top_top(set(B)),R3)
     => aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),ord_less_eq(set(set(B))),aa(fun(set(B),$o),set(set(B)),collect(set(B)),pred_chain(B,top_top(set(B)),aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3)))),chains(B,R3)) ) ).

% Chains_subset'
tff(fact_3516_timeFrame_Oelims,axiom,
    ! [B: $tType,X: nat,Xa: option(product_prod(B,product_prod(heap_ext(product_unit),nat))),Y: option(product_prod(B,product_prod(heap_ext(product_unit),nat)))] :
      ( ( heap_Time_timeFrame(B,X,Xa) = Y )
     => ( ! [R2: B,H: heap_ext(product_unit),N6: nat] :
            ( ( Xa = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),N6))) )
           => ( Y != aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X),N6)))) ) )
       => ~ ( ( Xa = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) )
           => ( Y != none(product_prod(B,product_prod(heap_ext(product_unit),nat))) ) ) ) ) ).

% timeFrame.elims
tff(fact_3517_the__dflt__None__nonempty,axiom,
    ! [B: $tType,S2: set(B)] :
      ( ( S2 != bot_bot(set(B)) )
     => ( dflt_None_set(B,S2) = aa(set(B),option(set(B)),some(set(B)),S2) ) ) ).

% the_dflt_None_nonempty
tff(fact_3518_Chains__subset,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),ord_less_eq(set(set(B))),chains(B,R3)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),pred_chain(B,top_top(set(B)),aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3)))) ).

% Chains_subset
tff(fact_3519_singleton__None__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),aa(set(option(B)),set(option(B)),insert2(option(B),none(B)),bot_bot(set(option(B))))) = none(B) ) ) ).

% singleton_None_Sup
tff(fact_3520_empty__Sup,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ( aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),bot_bot(set(option(B)))) = none(B) ) ) ).

% empty_Sup
tff(fact_3521_inf__None__2,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [X: option(B)] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),inf_inf(option(B)),X),none(B)) = none(B) ) ) ).

% inf_None_2
tff(fact_3522_inf__None__1,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [Y: option(B)] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),inf_inf(option(B)),none(B)),Y) = none(B) ) ) ).

% inf_None_1
tff(fact_3523_not__Some__eq2,axiom,
    ! [C: $tType,B: $tType,V: option(product_prod(B,C))] :
      ( ! [X4: B,Y3: C] : ( V != aa(product_prod(B,C),option(product_prod(B,C)),some(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Y3)) )
    <=> ( V = none(product_prod(B,C)) ) ) ).

% not_Some_eq2
tff(fact_3524_set__to__map__empty,axiom,
    ! [B: $tType,C: $tType,X3: B] : ( aa(B,option(C),set_to_map(B,C,bot_bot(set(product_prod(B,C)))),X3) = none(C) ) ).

% set_to_map_empty
tff(fact_3525_map__to__set__empty,axiom,
    ! [C: $tType,B: $tType] : ( map_to_set(B,C,aTP_Lamp_mh(B,option(C))) = bot_bot(set(product_prod(B,C))) ) ).

% map_to_set_empty
tff(fact_3526_rel__of__empty,axiom,
    ! [C: $tType,B: $tType,Pa: fun(product_prod(B,C),$o)] : ( rel_of(B,C,aTP_Lamp_mh(B,option(C)),Pa) = bot_bot(set(product_prod(B,C))) ) ).

% rel_of_empty
tff(fact_3527_set__to__map__empty__iff_I2_J,axiom,
    ! [C: $tType,B: $tType,S2: set(product_prod(B,C))] :
      ( ( aTP_Lamp_mh(B,option(C)) = set_to_map(B,C,S2) )
    <=> ( S2 = bot_bot(set(product_prod(B,C))) ) ) ).

% set_to_map_empty_iff(2)
tff(fact_3528_set__to__map__empty__iff_I1_J,axiom,
    ! [C: $tType,B: $tType,S2: set(product_prod(B,C))] :
      ( ! [X4: B] : ( aa(B,option(C),set_to_map(B,C,S2),X4) = none(C) )
    <=> ( S2 = bot_bot(set(product_prod(B,C))) ) ) ).

% set_to_map_empty_iff(1)
tff(fact_3529_bot__option__def,axiom,
    ! [B: $tType] :
      ( order(B)
     => ( bot_bot(option(B)) = none(B) ) ) ).

% bot_option_def
tff(fact_3530_pred__on_Ochain__empty,axiom,
    ! [B: $tType,A4: set(B),Pa: fun(B,fun(B,$o))] : aa(set(B),$o,pred_chain(B,A4,Pa),bot_bot(set(B))) ).

% pred_on.chain_empty
tff(fact_3531_timeFrame_Osimps_I2_J,axiom,
    ! [B: $tType,N: nat] : ( heap_Time_timeFrame(B,N,none(product_prod(B,product_prod(heap_ext(product_unit),nat)))) = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) ) ).

% timeFrame.simps(2)
tff(fact_3532_subset_Ochain__empty,axiom,
    ! [B: $tType,A4: set(set(B))] : aa(set(set(B)),$o,pred_chain(set(B),A4,ord_less(set(B))),bot_bot(set(set(B)))) ).

% subset.chain_empty
tff(fact_3533_execute__bind_I2_J,axiom,
    ! [B: $tType,C: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit),Ga: fun(B,heap_Time_Heap(C))] :
      ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2) = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) )
     => ( aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(C),fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(C),heap_Time_bind(B,C,Fa,Ga)),H2) = none(product_prod(C,product_prod(heap_ext(product_unit),nat))) ) ) ).

% execute_bind(2)
tff(fact_3534_successI,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit)] :
      ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2) != none(product_prod(B,product_prod(heap_ext(product_unit),nat))) )
     => heap_Time_success(B,Fa,H2) ) ).

% successI
tff(fact_3535_success__def,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit)] :
      ( heap_Time_success(B,Fa,H2)
    <=> ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2) != none(product_prod(B,product_prod(heap_ext(product_unit),nat))) ) ) ).

% success_def
tff(fact_3536_map__to__set__empty__iff_I2_J,axiom,
    ! [B: $tType,C: $tType,M4: fun(B,option(C))] :
      ( ( bot_bot(set(product_prod(B,C))) = map_to_set(B,C,M4) )
    <=> ! [X4: B] : ( aa(B,option(C),M4,X4) = none(C) ) ) ).

% map_to_set_empty_iff(2)
tff(fact_3537_map__to__set__empty__iff_I1_J,axiom,
    ! [B: $tType,C: $tType,M4: fun(B,option(C))] :
      ( ( map_to_set(B,C,M4) = bot_bot(set(product_prod(B,C))) )
    <=> ! [X4: B] : ( aa(B,option(C),M4,X4) = none(C) ) ) ).

% map_to_set_empty_iff(1)
tff(fact_3538_execute__guard_I1_J,axiom,
    ! [B: $tType,Pa: fun(heap_ext(product_unit),$o),H2: heap_ext(product_unit),Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))] :
      ( ~ aa(heap_ext(product_unit),$o,Pa,H2)
     => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_guard(B,Pa,Fa)),H2) = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) ) ) ).

% execute_guard(1)
tff(fact_3539_execute__assert_I2_J,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: B,H2: heap_ext(product_unit)] :
      ( ~ aa(B,$o,Pa,X)
     => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_assert(B,Pa,X)),H2) = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) ) ) ).

% execute_assert(2)
tff(fact_3540_execute__raise,axiom,
    ! [B: $tType,S: list(char),X3: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_raise(B,S)),X3) = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) ) ).

% execute_raise
tff(fact_3541_raise__def,axiom,
    ! [B: $tType,S: list(char)] : ( heap_Time_raise(B,S) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),aTP_Lamp_mi(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))) ) ).

% raise_def
tff(fact_3542_Heap__cases,axiom,
    ! [B: $tType,Fa: heap_Time_Heap(B),H2: heap_ext(product_unit)] :
      ( ! [X2: B,H5: product_prod(heap_ext(product_unit),nat)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2) != aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),X2),H5)) )
     => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Fa),H2) = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) ) ) ).

% Heap_cases
tff(fact_3543_timeFrame_Ocases,axiom,
    ! [B: $tType,X: product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] :
      ( ! [N3: nat,R2: B,H: heap_ext(product_unit),N6: nat] : ( X != aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(nat,fun(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),product_Pair(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),N3),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),N6)))) )
     => ~ ! [N3: nat] : ( X != aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(nat,fun(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),product_Pair(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),N3),none(product_prod(B,product_prod(heap_ext(product_unit),nat)))) ) ) ).

% timeFrame.cases
tff(fact_3544_subset__Zorn__nonempty,axiom,
    ! [B: $tType,A16: set(set(B))] :
      ( ( A16 != bot_bot(set(set(B))) )
     => ( ! [C8: set(set(B))] :
            ( ( C8 != bot_bot(set(set(B))) )
           => ( aa(set(set(B)),$o,pred_chain(set(B),A16,ord_less(set(B))),C8)
             => member(set(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),C8),A16) ) )
       => ? [X2: set(B)] :
            ( member(set(B),X2,A16)
            & ! [Xa3: set(B)] :
                ( member(set(B),Xa3,A16)
               => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X2),Xa3)
                 => ( Xa3 = X2 ) ) ) ) ) ) ).

% subset_Zorn_nonempty
tff(fact_3545_guard__def,axiom,
    ! [B: $tType,Pa: fun(heap_ext(product_unit),$o),Fa: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))] : ( heap_Time_guard(B,Pa,Fa) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),aa(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mj(fun(heap_ext(product_unit),$o),fun(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Pa),Fa)) ) ).

% guard_def
tff(fact_3546_Union__in__chain,axiom,
    ! [B: $tType,B10: set(set(B)),A16: set(set(B))] :
      ( aa(set(set(B)),$o,finite_finite(set(B)),B10)
     => ( ( B10 != bot_bot(set(set(B))) )
       => ( aa(set(set(B)),$o,pred_chain(set(B),A16,ord_less(set(B))),B10)
         => member(set(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B10),B10) ) ) ) ).

% Union_in_chain
tff(fact_3547_Inter__in__chain,axiom,
    ! [B: $tType,B10: set(set(B)),A16: set(set(B))] :
      ( aa(set(set(B)),$o,finite_finite(set(B)),B10)
     => ( ( B10 != bot_bot(set(set(B))) )
       => ( aa(set(set(B)),$o,pred_chain(set(B),A16,ord_less(set(B))),B10)
         => member(set(B),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),B10),B10) ) ) ) ).

% Inter_in_chain
tff(fact_3548_subset_Ochain__extend,axiom,
    ! [B: $tType,A4: set(set(B)),C3: set(set(B)),Z2: set(B)] :
      ( aa(set(set(B)),$o,pred_chain(set(B),A4,ord_less(set(B))),C3)
     => ( member(set(B),Z2,A4)
       => ( ! [X2: set(B)] :
              ( member(set(B),X2,C3)
             => aa(set(B),$o,aa(set(B),fun(set(B),$o),aa(fun(set(B),fun(set(B),$o)),fun(set(B),fun(set(B),$o)),aa(fun(set(B),fun(set(B),$o)),fun(fun(set(B),fun(set(B),$o)),fun(set(B),fun(set(B),$o))),sup_sup(fun(set(B),fun(set(B),$o))),ord_less(set(B))),fequal(set(B))),X2),Z2) )
         => aa(set(set(B)),$o,pred_chain(set(B),A4,ord_less(set(B))),aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),aa(set(set(B)),set(set(B)),insert2(set(B),Z2),bot_bot(set(set(B))))),C3)) ) ) ) ).

% subset.chain_extend
tff(fact_3549_pred__on_Ochain__extend,axiom,
    ! [B: $tType,A4: set(B),Pa: fun(B,fun(B,$o)),C3: set(B),Z2: B] :
      ( aa(set(B),$o,pred_chain(B,A4,Pa),C3)
     => ( member(B,Z2,A4)
       => ( ! [X2: B] :
              ( member(B,X2,C3)
             => aa(B,$o,aa(B,fun(B,$o),aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),sup_sup(fun(B,fun(B,$o))),Pa),fequal(B)),X2),Z2) )
         => aa(set(B),$o,pred_chain(B,A4,Pa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),insert2(B,Z2),bot_bot(set(B)))),C3)) ) ) ) ).

% pred_on.chain_extend
tff(fact_3550_finite__subset__Union__chain,axiom,
    ! [B: $tType,A4: set(B),B10: set(set(B)),A16: set(set(B))] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),B10))
       => ( ( B10 != bot_bot(set(set(B))) )
         => ( aa(set(set(B)),$o,pred_chain(set(B),A16,ord_less(set(B))),B10)
           => ~ ! [B8: set(B)] :
                  ( member(set(B),B8,B10)
                 => ~ aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B8) ) ) ) ) ) ).

% finite_subset_Union_chain
tff(fact_3551_Chains__alt__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( refl_on(B,top_top(set(B)),R3)
     => ( chains(B,R3) = aa(fun(set(B),$o),set(set(B)),collect(set(B)),pred_chain(B,top_top(set(B)),aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3))) ) ) ).

% Chains_alt_def
tff(fact_3552_the__dflt__None__set,axiom,
    ! [B: $tType,X: set(B)] : ( the_default(set(B),bot_bot(set(B)),dflt_None_set(B,X)) = X ) ).

% the_dflt_None_set
tff(fact_3553_Sup__fin_Oeq__fold_H,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [A4: set(B)] : ( aa(set(B),B,lattic5882676163264333800up_fin(B),A4) = aa(option(B),B,the2(B),finite_fold(B,option(B),aTP_Lamp_mk(B,fun(option(B),option(B))),none(B),A4)) ) ) ).

% Sup_fin.eq_fold'
tff(fact_3554_Inf__fin_Oeq__fold_H,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [A4: set(B)] : ( aa(set(B),B,lattic7752659483105999362nf_fin(B),A4) = aa(option(B),B,the2(B),finite_fold(B,option(B),aTP_Lamp_ml(B,fun(option(B),option(B))),none(B),A4)) ) ) ).

% Inf_fin.eq_fold'
tff(fact_3555_Heap__Time__Monad_Obind__def,axiom,
    ! [B: $tType,C: $tType,Fa: heap_Time_Heap(C),Ga: fun(C,heap_Time_Heap(B))] : ( heap_Time_bind(C,B,Fa,Ga) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),aa(fun(C,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mo(heap_Time_Heap(C),fun(fun(C,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Fa),Ga)) ) ).

% Heap_Time_Monad.bind_def
tff(fact_3556_Sup__option__def,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: set(option(B))] :
          ( aa(set(option(B)),option(B),complete_Sup_Sup(option(B)),A4)
          = $ite(
              ( ( A4 = bot_bot(set(option(B))) )
              | ( A4 = aa(set(option(B)),set(option(B)),insert2(option(B),none(B)),bot_bot(set(option(B)))) ) ),
              none(B),
              aa(B,option(B),some(B),aa(set(B),B,complete_Sup_Sup(B),these(B,A4))) ) ) ) ).

% Sup_option_def
tff(fact_3557_the__dflt__None__empty,axiom,
    ! [B: $tType] : ( dflt_None_set(B,bot_bot(set(B))) = none(set(B)) ) ).

% the_dflt_None_empty
tff(fact_3558_these__empty,axiom,
    ! [B: $tType] : ( these(B,bot_bot(set(option(B)))) = bot_bot(set(B)) ) ).

% these_empty
tff(fact_3559_these__empty__eq,axiom,
    ! [B: $tType,B2: set(option(B))] :
      ( ( these(B,B2) = bot_bot(set(B)) )
    <=> ( ( B2 = bot_bot(set(option(B))) )
        | ( B2 = aa(set(option(B)),set(option(B)),insert2(option(B),none(B)),bot_bot(set(option(B)))) ) ) ) ).

% these_empty_eq
tff(fact_3560_these__not__empty__eq,axiom,
    ! [B: $tType,B2: set(option(B))] :
      ( ( these(B,B2) != bot_bot(set(B)) )
    <=> ( ( B2 != bot_bot(set(option(B))) )
        & ( B2 != aa(set(option(B)),set(option(B)),insert2(option(B),none(B)),bot_bot(set(option(B)))) ) ) ) ).

% these_not_empty_eq
tff(fact_3561_dflt__None__set__def,axiom,
    ! [B: $tType,S2: set(B)] :
      ( dflt_None_set(B,S2)
      = $ite(S2 = bot_bot(set(B)),none(set(B)),aa(set(B),option(set(B)),some(set(B)),S2)) ) ).

% dflt_None_set_def
tff(fact_3562_sup__option__def,axiom,
    ! [B: $tType] :
      ( sup(B)
     => ! [X: option(B),Y: option(B)] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),sup_sup(option(B)),X),Y) = case_option(option(B),B,Y,aa(option(B),fun(B,option(B)),aTP_Lamp_mq(option(B),fun(option(B),fun(B,option(B))),X),Y),X) ) ) ).

% sup_option_def
tff(fact_3563_execute__bind__case,axiom,
    ! [B: $tType,C: $tType,Fa: heap_Time_Heap(C),Ga: fun(C,heap_Time_Heap(B)),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),heap_Time_bind(C,B,Fa,Ga)),H2) = case_option(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(C,product_prod(heap_ext(product_unit),nat)),none(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(C,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),product_case_prod(C,product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mn(fun(C,heap_Time_Heap(B)),fun(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Ga)),aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(C),fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(C),Fa),H2)) ) ).

% execute_bind_case
tff(fact_3564_inf__option__def,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [X: option(B),Y: option(B)] : ( aa(option(B),option(B),aa(option(B),fun(option(B),option(B)),inf_inf(option(B)),X),Y) = case_option(option(B),B,none(B),aTP_Lamp_ms(option(B),fun(B,option(B)),Y),X) ) ) ).

% inf_option_def
tff(fact_3565_timeFrame_Opelims,axiom,
    ! [B: $tType,X: nat,Xa: option(product_prod(B,product_prod(heap_ext(product_unit),nat))),Y: option(product_prod(B,product_prod(heap_ext(product_unit),nat)))] :
      ( ( heap_Time_timeFrame(B,X,Xa) = Y )
     => ( aa(product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),$o,accp(product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_T5500966940807335491me_rel(B)),aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(nat,fun(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),product_Pair(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),X),Xa))
       => ( ! [R2: B,H: heap_ext(product_unit),N6: nat] :
              ( ( Xa = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),N6))) )
             => ( ( Y = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X),N6)))) )
               => ~ aa(product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),$o,accp(product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_T5500966940807335491me_rel(B)),aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(nat,fun(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),product_Pair(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),X),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),R2),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H),N6))))) ) )
         => ~ ( ( Xa = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) )
             => ( ( Y = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) )
               => ~ aa(product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),$o,accp(product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_T5500966940807335491me_rel(B)),aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(nat,fun(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),product_Pair(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),X),none(product_prod(B,product_prod(heap_ext(product_unit),nat))))) ) ) ) ) ) ).

% timeFrame.pelims
tff(fact_3566_execute__ref,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [V: B,H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(ref(B)),fun(heap_ext(product_unit),option(product_prod(ref(B),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(ref(B)),ref_ref(B,V)),H2) = aa(product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(ref(B),heap_ext(product_unit)),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),aa(fun(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(ref(B),heap_ext(product_unit)),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(ref(B),heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mt(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))))),ref_alloc(B,V,H2))) ) ) ).

% execute_ref
tff(fact_3567_ref__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [V: B] : ( ref_ref(B,V) = heap_Time_heap(ref(B),aTP_Lamp_mu(B,fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),V)) ) ) ).

% ref_def
tff(fact_3568_map__upd__eq__restrict,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C)),X: B] : ( fun_upd(B,option(C),M4,X,none(C)) = restrict_map(B,C,M4,aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))) ) ).

% map_upd_eq_restrict
tff(fact_3569_proj__iff,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X: B,Y: B] :
      ( equiv_equiv(B,A4,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,X),aa(set(B),set(B),insert2(B,Y),bot_bot(set(B))))),A4)
       => ( ( aa(B,set(B),equiv_proj(B,B,R3),X) = aa(B,set(B),equiv_proj(B,B,R3),Y) )
        <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3) ) ) ) ).

% proj_iff
tff(fact_3570_quotient__eqI,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X6: set(B),Y5: set(B),X: B,Y: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(set(B),X6,equiv_quotient(B,A4,R3))
       => ( member(set(B),Y5,equiv_quotient(B,A4,R3))
         => ( member(B,X,X6)
           => ( member(B,Y,Y5)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
               => ( X6 = Y5 ) ) ) ) ) ) ) ).

% quotient_eqI
tff(fact_3571_quotient__eq__iff,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X6: set(B),Y5: set(B),X: B,Y: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(set(B),X6,equiv_quotient(B,A4,R3))
       => ( member(set(B),Y5,equiv_quotient(B,A4,R3))
         => ( member(B,X,X6)
           => ( member(B,Y,Y5)
             => ( ( X6 = Y5 )
              <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3) ) ) ) ) ) ) ).

% quotient_eq_iff
tff(fact_3572_in__quotient__imp__closed,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X6: set(B),X: B,Y: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(set(B),X6,equiv_quotient(B,A4,R3))
       => ( member(B,X,X6)
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
           => member(B,Y,X6) ) ) ) ) ).

% in_quotient_imp_closed
tff(fact_3573_in__quotient__imp__non__empty,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X6: set(B)] :
      ( equiv_equiv(B,A4,R3)
     => ( member(set(B),X6,equiv_quotient(B,A4,R3))
       => ( X6 != bot_bot(set(B)) ) ) ) ).

% in_quotient_imp_non_empty
tff(fact_3574_equiv__class__self,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),A3: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(B,A3,A4)
       => member(B,A3,image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) ) ) ).

% equiv_class_self
tff(fact_3575_quotient__disj,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X6: set(B),Y5: set(B)] :
      ( equiv_equiv(B,A4,R3)
     => ( member(set(B),X6,equiv_quotient(B,A4,R3))
       => ( member(set(B),Y5,equiv_quotient(B,A4,R3))
         => ( ( X6 = Y5 )
            | ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),X6),Y5) = bot_bot(set(B)) ) ) ) ) ) ).

% quotient_disj
tff(fact_3576_effect__refI,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),H4: heap_ext(product_unit),V: B,H2: heap_ext(product_unit),N: nat] :
          ( ( aa(heap_ext(product_unit),product_prod(ref(B),heap_ext(product_unit)),aa(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),heap_ext(product_unit))),product_Pair(ref(B),heap_ext(product_unit)),R3),H4) = ref_alloc(B,V,H2) )
         => ( ( N = one_one(nat) )
           => heap_Time_effect(ref(B),ref_ref(B,V),H2,H4,R3,N) ) ) ) ).

% effect_refI
tff(fact_3577_equiv__proj,axiom,
    ! [B: $tType,A4: set(B),R: set(product_prod(B,B)),Z2: product_prod(B,B)] :
      ( equiv_equiv(B,A4,R)
     => ( member(product_prod(B,B),Z2,R)
       => ( aa(product_prod(B,B),set(B),aa(fun(product_prod(B,B),B),fun(product_prod(B,B),set(B)),aa(fun(B,set(B)),fun(fun(product_prod(B,B),B),fun(product_prod(B,B),set(B))),comp(B,set(B),product_prod(B,B)),equiv_proj(B,B,R)),product_fst(B,B)),Z2) = aa(product_prod(B,B),set(B),aa(fun(product_prod(B,B),B),fun(product_prod(B,B),set(B)),aa(fun(B,set(B)),fun(fun(product_prod(B,B),B),fun(product_prod(B,B),set(B))),comp(B,set(B),product_prod(B,B)),equiv_proj(B,B,R)),product_snd(B,B)),Z2) ) ) ) ).

% equiv_proj
tff(fact_3578_equiv__class__eq__iff,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X: B,Y: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
      <=> ( ( image(B,B,R3,aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = image(B,B,R3,aa(set(B),set(B),insert2(B,Y),bot_bot(set(B)))) )
          & member(B,X,A4)
          & member(B,Y,A4) ) ) ) ).

% equiv_class_eq_iff
tff(fact_3579_eq__equiv__class__iff,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X: B,Y: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(B,X,A4)
       => ( member(B,Y,A4)
         => ( ( image(B,B,R3,aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = image(B,B,R3,aa(set(B),set(B),insert2(B,Y),bot_bot(set(B)))) )
          <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3) ) ) ) ) ).

% eq_equiv_class_iff
tff(fact_3580_equiv__class__eq,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
       => ( image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) = image(B,B,R3,aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))) ) ) ) ).

% equiv_class_eq
tff(fact_3581_eq__equiv__class,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B,A4: set(B)] :
      ( ( image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) = image(B,B,R3,aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))) )
     => ( equiv_equiv(B,A4,R3)
       => ( member(B,Ba,A4)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3) ) ) ) ).

% eq_equiv_class
tff(fact_3582_eq__equiv__class__iff2,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X: B,Y: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(B,X,A4)
       => ( member(B,Y,A4)
         => ( ( equiv_quotient(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))),R3) = equiv_quotient(B,aa(set(B),set(B),insert2(B,Y),bot_bot(set(B))),R3) )
          <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3) ) ) ) ) ).

% eq_equiv_class_iff2
tff(fact_3583_refines__equiv__class__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),S2: set(product_prod(B,B)),A4: set(B),A3: B] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R),S2)
     => ( equiv_equiv(B,A4,R)
       => ( equiv_equiv(B,A4,S2)
         => ( image(B,B,R,image(B,B,S2,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) = image(B,B,S2,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) ) ) ) ) ).

% refines_equiv_class_eq
tff(fact_3584_refines__equiv__class__eq2,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),S2: set(product_prod(B,B)),A4: set(B),A3: B] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),R),S2)
     => ( equiv_equiv(B,A4,R)
       => ( equiv_equiv(B,A4,S2)
         => ( image(B,B,S2,image(B,B,R,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) = image(B,B,S2,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) ) ) ) ) ).

% refines_equiv_class_eq2
tff(fact_3585_equiv__class__subset,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))),image(B,B,R3,aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))) ) ) ).

% equiv_class_subset
tff(fact_3586_subset__equiv__class,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),Ba: B,A3: B] :
      ( equiv_equiv(B,A4,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),image(B,B,R3,aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))),image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))
       => ( member(B,Ba,A4)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3) ) ) ) ).

% subset_equiv_class
tff(fact_3587_equiv__class__nondisjoint,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X: B,A3: B,Ba: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(B,X,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))),image(B,B,R3,aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3) ) ) ).

% equiv_class_nondisjoint
tff(fact_3588_in__quotient__imp__in__rel,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),X6: set(B),X: B,Y: B] :
      ( equiv_equiv(B,A4,R3)
     => ( member(set(B),X6,equiv_quotient(B,A4,R3))
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,X),aa(set(B),set(B),insert2(B,Y),bot_bot(set(B))))),X6)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3) ) ) ) ).

% in_quotient_imp_in_rel
tff(fact_3589_restrict__upd__same,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C)),X: B,Y: C] : ( restrict_map(B,C,fun_upd(B,option(C),M4,X,aa(C,option(C),some(C),Y)),aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))) = restrict_map(B,C,M4,aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))) ) ).

% restrict_upd_same
tff(fact_3590_fun__upd__None__restrict,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C)),D4: set(B),X: B] :
      ( fun_upd(B,option(C),restrict_map(B,C,M4,D4),X,none(C))
      = $ite(member(B,X,D4),restrict_map(B,C,M4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),D4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),restrict_map(B,C,M4,D4)) ) ).

% fun_upd_None_restrict
tff(fact_3591_restrict__fun__upd,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C)),X: B,Y: option(C),D4: set(B)] :
      ( restrict_map(B,C,fun_upd(B,option(C),M4,X,Y),D4)
      = $ite(member(B,X,D4),fun_upd(B,option(C),restrict_map(B,C,M4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),D4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),X,Y),restrict_map(B,C,M4,D4)) ) ).

% restrict_fun_upd
tff(fact_3592_fun__upd__restrict__conv,axiom,
    ! [B: $tType,C: $tType,X: B,D4: set(B),M4: fun(B,option(C)),Y: option(C)] :
      ( member(B,X,D4)
     => ( fun_upd(B,option(C),restrict_map(B,C,M4,D4),X,Y) = fun_upd(B,option(C),restrict_map(B,C,M4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),D4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),X,Y) ) ) ).

% fun_upd_restrict_conv
tff(fact_3593_restrict__map__to__empty,axiom,
    ! [B: $tType,C: $tType,M4: fun(B,option(C)),X3: B] : ( aa(B,option(C),restrict_map(B,C,M4,bot_bot(set(B))),X3) = none(C) ) ).

% restrict_map_to_empty
tff(fact_3594_restrict__restrict,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C)),A4: set(B),B2: set(B)] : ( restrict_map(B,C,restrict_map(B,C,M4,A4),B2) = restrict_map(B,C,M4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ).

% restrict_restrict
tff(fact_3595_fun__upd__restrict,axiom,
    ! [B: $tType,C: $tType,M4: fun(B,option(C)),D4: set(B),X: B,Y: option(C)] : ( fun_upd(B,option(C),restrict_map(B,C,M4,D4),X,Y) = fun_upd(B,option(C),restrict_map(B,C,M4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),D4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),X,Y) ) ).

% fun_upd_restrict
tff(fact_3596_restrict__complement__singleton__eq,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,option(C)),X: B] : ( restrict_map(B,C,Fa,aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))) = fun_upd(B,option(C),Fa,X,none(C)) ) ).

% restrict_complement_singleton_eq
tff(fact_3597_UN__equiv__class2,axiom,
    ! [B: $tType,D: $tType,C: $tType,A14: set(B),R1: set(product_prod(B,B)),A23: set(C),R22: set(product_prod(C,C)),Fa: fun(B,fun(C,set(D))),A1: B,A22: C] :
      ( equiv_equiv(B,A14,R1)
     => ( equiv_equiv(C,A23,R22)
       => ( equiv_congruent2(B,C,set(D),R1,R22,Fa)
         => ( member(B,A1,A14)
           => ( member(C,A22,A23)
             => ( aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),aa(C,fun(B,set(D)),aa(fun(B,fun(C,set(D))),fun(C,fun(B,set(D))),aTP_Lamp_mv(set(product_prod(C,C)),fun(fun(B,fun(C,set(D))),fun(C,fun(B,set(D)))),R22),Fa),A22)),image(B,B,R1,aa(set(B),set(B),insert2(B,A1),bot_bot(set(B)))))) = aa(C,set(D),aa(B,fun(C,set(D)),Fa,A1),A22) ) ) ) ) ) ) ).

% UN_equiv_class2
tff(fact_3598_UN__equiv__class,axiom,
    ! [C: $tType,B: $tType,A4: set(B),R3: set(product_prod(B,B)),Fa: fun(B,set(C)),A3: B] :
      ( equiv_equiv(B,A4,R3)
     => ( equiv_congruent(B,set(C),R3,Fa)
       => ( member(B,A3,A4)
         => ( aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),Fa),image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) = aa(B,set(C),Fa,A3) ) ) ) ) ).

% UN_equiv_class
tff(fact_3599_UN__equiv__class__inject,axiom,
    ! [C: $tType,B: $tType,A4: set(B),R3: set(product_prod(B,B)),Fa: fun(B,set(C)),X6: set(B),Y5: set(B)] :
      ( equiv_equiv(B,A4,R3)
     => ( equiv_congruent(B,set(C),R3,Fa)
       => ( ( aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),Fa),X6)) = aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),Fa),Y5)) )
         => ( member(set(B),X6,equiv_quotient(B,A4,R3))
           => ( member(set(B),Y5,equiv_quotient(B,A4,R3))
             => ( ! [X2: B,Y2: B] :
                    ( member(B,X2,A4)
                   => ( member(B,Y2,A4)
                     => ( ( aa(B,set(C),Fa,X2) = aa(B,set(C),Fa,Y2) )
                       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),R3) ) ) )
               => ( X6 = Y5 ) ) ) ) ) ) ) ).

% UN_equiv_class_inject
tff(fact_3600_graph__map__upd,axiom,
    ! [B: $tType,C: $tType,M4: fun(B,option(C)),K: B,V: C] : ( graph(B,C,fun_upd(B,option(C),M4,K,aa(C,option(C),some(C),V))) = aa(set(product_prod(B,C)),set(product_prod(B,C)),insert2(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K),V)),graph(B,C,fun_upd(B,option(C),M4,K,none(C)))) ) ).

% graph_map_upd
tff(fact_3601_Ref__Time_Oalloc__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: B,H2: heap_ext(product_unit)] :
          ( ref_alloc(B,X,H2)
          = $let(
              l: nat,
              l := lim(product_unit,H2),
              $let(
                r: ref(B),
                r := ref2(B,l),
                aa(heap_ext(product_unit),product_prod(ref(B),heap_ext(product_unit)),aa(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),heap_ext(product_unit))),product_Pair(ref(B),heap_ext(product_unit)),r),ref_set(B,r,X,lim_update(product_unit,aTP_Lamp_mw(nat,fun(nat,nat),l),H2))) ) ) ) ) ).

% Ref_Time.alloc_def
tff(fact_3602_graph__empty,axiom,
    ! [C: $tType,B: $tType] : ( graph(B,C,aTP_Lamp_mh(B,option(C))) = bot_bot(set(product_prod(B,C))) ) ).

% graph_empty
tff(fact_3603_congruent2I_H,axiom,
    ! [D: $tType,C: $tType,B: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C)),Fa: fun(B,fun(C,D))] :
      ( ! [Y12: B,Z1: B,Y23: C,Z22: C] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y12),Z1),R1)
         => ( member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Y23),Z22),R22)
           => ( aa(C,D,aa(B,fun(C,D),Fa,Y12),Y23) = aa(C,D,aa(B,fun(C,D),Fa,Z1),Z22) ) ) )
     => equiv_congruent2(B,C,D,R1,R22,Fa) ) ).

% congruent2I'
tff(fact_3604_congruent2D,axiom,
    ! [B: $tType,D: $tType,C: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C)),Fa: fun(B,fun(C,D)),Y1: B,Z12: B,Y22: C,Z23: C] :
      ( equiv_congruent2(B,C,D,R1,R22,Fa)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y1),Z12),R1)
       => ( member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Y22),Z23),R22)
         => ( aa(C,D,aa(B,fun(C,D),Fa,Y1),Y22) = aa(C,D,aa(B,fun(C,D),Fa,Z12),Z23) ) ) ) ) ).

% congruent2D
tff(fact_3605_congruentI,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),Fa: fun(B,C)] :
      ( ! [Y2: B,Z3: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),R3)
         => ( aa(B,C,Fa,Y2) = aa(B,C,Fa,Z3) ) )
     => equiv_congruent(B,C,R3,Fa) ) ).

% congruentI
tff(fact_3606_congruentD,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),Fa: fun(B,C),Y: B,Z2: B] :
      ( equiv_congruent(B,C,R3,Fa)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),Z2),R3)
       => ( aa(B,C,Fa,Y) = aa(B,C,Fa,Z2) ) ) ) ).

% congruentD
tff(fact_3607_in__graphD,axiom,
    ! [B: $tType,C: $tType,K: B,V: C,M4: fun(B,option(C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K),V),graph(B,C,M4))
     => ( aa(B,option(C),M4,K) = aa(C,option(C),some(C),V) ) ) ).

% in_graphD
tff(fact_3608_in__graphI,axiom,
    ! [B: $tType,C: $tType,M4: fun(C,option(B)),K: C,V: B] :
      ( ( aa(C,option(B),M4,K) = aa(B,option(B),some(B),V) )
     => member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),K),V),graph(C,B,M4)) ) ).

% in_graphI
tff(fact_3609_graph__restrictD_I1_J,axiom,
    ! [C: $tType,B: $tType,K: B,V: C,M4: fun(B,option(C)),A4: set(B)] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K),V),graph(B,C,restrict_map(B,C,M4,A4)))
     => member(B,K,A4) ) ).

% graph_restrictD(1)
tff(fact_3610_graph__restrictD_I2_J,axiom,
    ! [B: $tType,C: $tType,K: B,V: C,M4: fun(B,option(C)),A4: set(B)] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K),V),graph(B,C,restrict_map(B,C,M4,A4)))
     => ( aa(B,option(C),M4,K) = aa(C,option(C),some(C),V) ) ) ).

% graph_restrictD(2)
tff(fact_3611_graph__def,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C))] : ( graph(B,C,M4) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aTP_Lamp_mx(fun(B,option(C)),fun(product_prod(B,C),$o),M4)) ) ).

% graph_def
tff(fact_3612_congruent2__commuteI,axiom,
    ! [C: $tType,B: $tType,A4: set(B),R3: set(product_prod(B,B)),Fa: fun(B,fun(B,C))] :
      ( equiv_equiv(B,A4,R3)
     => ( ! [Y2: B,Z3: B] :
            ( member(B,Y2,A4)
           => ( member(B,Z3,A4)
             => ( aa(B,C,aa(B,fun(B,C),Fa,Y2),Z3) = aa(B,C,aa(B,fun(B,C),Fa,Z3),Y2) ) ) )
       => ( ! [Y2: B,Z3: B,W: B] :
              ( member(B,W,A4)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),R3)
               => ( aa(B,C,aa(B,fun(B,C),Fa,W),Y2) = aa(B,C,aa(B,fun(B,C),Fa,W),Z3) ) ) )
         => equiv_congruent2(B,B,C,R3,R3,Fa) ) ) ) ).

% congruent2_commuteI
tff(fact_3613_congruent2I,axiom,
    ! [D: $tType,C: $tType,B: $tType,A14: set(B),R1: set(product_prod(B,B)),A23: set(C),R22: set(product_prod(C,C)),Fa: fun(B,fun(C,D))] :
      ( equiv_equiv(B,A14,R1)
     => ( equiv_equiv(C,A23,R22)
       => ( ! [Y2: B,Z3: B,W: C] :
              ( member(C,W,A23)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),R1)
               => ( aa(C,D,aa(B,fun(C,D),Fa,Y2),W) = aa(C,D,aa(B,fun(C,D),Fa,Z3),W) ) ) )
         => ( ! [Y2: C,Z3: C,W: B] :
                ( member(B,W,A14)
               => ( member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Y2),Z3),R22)
                 => ( aa(C,D,aa(B,fun(C,D),Fa,W),Y2) = aa(C,D,aa(B,fun(C,D),Fa,W),Z3) ) ) )
           => equiv_congruent2(B,C,D,R1,R22,Fa) ) ) ) ) ).

% congruent2I
tff(fact_3614_congruent2__implies__congruent__UN,axiom,
    ! [B: $tType,D: $tType,C: $tType,A14: set(B),R1: set(product_prod(B,B)),A23: set(C),R22: set(product_prod(C,C)),Fa: fun(B,fun(C,set(D))),A3: C] :
      ( equiv_equiv(B,A14,R1)
     => ( equiv_equiv(C,A23,R22)
       => ( equiv_congruent2(B,C,set(D),R1,R22,Fa)
         => ( member(C,A3,A23)
           => equiv_congruent(B,set(D),R1,aa(C,fun(B,set(D)),aa(fun(B,fun(C,set(D))),fun(C,fun(B,set(D))),aTP_Lamp_mv(set(product_prod(C,C)),fun(fun(B,fun(C,set(D))),fun(C,fun(B,set(D)))),R22),Fa),A3)) ) ) ) ) ).

% congruent2_implies_congruent_UN
tff(fact_3615_disjnt__equiv__class,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( equiv_equiv(B,A4,R3)
     => ( disjnt(B,image(B,B,R3,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))),image(B,B,R3,aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))))
      <=> ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3) ) ) ).

% disjnt_equiv_class
tff(fact_3616_cINF__UNION,axiom,
    ! [C: $tType,D: $tType,B: $tType] :
      ( condit1219197933456340205attice(D)
     => ! [A4: set(B),B2: fun(B,set(C)),Fa: fun(C,D)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,A4)
               => ( aa(B,set(C),B2,X2) != bot_bot(set(C)) ) )
           => ( condit1013018076250108175_below(D,aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),aa(fun(C,D),fun(B,set(D)),aTP_Lamp_lu(fun(B,set(C)),fun(fun(C,D),fun(B,set(D))),B2),Fa)),A4)))
             => ( aa(set(D),D,complete_Inf_Inf(D),aa(set(C),set(D),image2(C,D,Fa),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),B2),A4)))) = aa(set(D),D,complete_Inf_Inf(D),aa(set(B),set(D),image2(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_my(fun(B,set(C)),fun(fun(C,D),fun(B,D)),B2),Fa)),A4)) ) ) ) ) ) ).

% cINF_UNION
tff(fact_3617_finite__def,axiom,
    ! [B: $tType] : ( finite_finite(B) = complete_lattice_lfp(fun(set(B),$o),aTP_Lamp_mz(fun(set(B),$o),fun(set(B),$o))) ) ).

% finite_def
tff(fact_3618_bsqr__max2,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A1: B,A22: B,B12: B,B23: B] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( member(product_prod(product_prod(B,B),product_prod(B,B)),aa(product_prod(B,B),product_prod(product_prod(B,B),product_prod(B,B)),aa(product_prod(B,B),fun(product_prod(B,B),product_prod(product_prod(B,B),product_prod(B,B))),product_Pair(product_prod(B,B),product_prod(B,B)),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A1),A22)),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B12),B23)),bNF_Wellorder_bsqr(B,R3))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),bNF_We1388413361240627857o_max2(B,R3,A1,A22)),bNF_We1388413361240627857o_max2(B,R3,B12,B23)),R3) ) ) ).

% bsqr_max2
tff(fact_3619_bdd__below__empty,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => condit1013018076250108175_below(B,bot_bot(set(B))) ) ).

% bdd_below_empty
tff(fact_3620_disjnt__self__iff__empty,axiom,
    ! [B: $tType,S2: set(B)] :
      ( disjnt(B,S2,S2)
    <=> ( S2 = bot_bot(set(B)) ) ) ).

% disjnt_self_iff_empty
tff(fact_3621_bdd__below__image__inf,axiom,
    ! [B: $tType,C: $tType] :
      ( lattice(B)
     => ! [Fa: fun(C,B),Ga: fun(C,B),A4: set(C)] :
          ( condit1013018076250108175_below(B,aa(set(C),set(B),image2(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_na(fun(C,B),fun(fun(C,B),fun(C,B)),Fa),Ga)),A4))
        <=> ( condit1013018076250108175_below(B,aa(set(C),set(B),image2(C,B,Fa),A4))
            & condit1013018076250108175_below(B,aa(set(C),set(B),image2(C,B,Ga),A4)) ) ) ) ).

% bdd_below_image_inf
tff(fact_3622_disjnt__Times1__iff,axiom,
    ! [B: $tType,C: $tType,C3: set(B),A4: set(C),B2: set(C)] :
      ( disjnt(product_prod(B,C),product_Sigma(B,C,C3,aTP_Lamp_hq(set(C),fun(B,set(C)),A4)),product_Sigma(B,C,C3,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))
    <=> ( ( C3 = bot_bot(set(B)) )
        | disjnt(C,A4,B2) ) ) ).

% disjnt_Times1_iff
tff(fact_3623_disjnt__Times2__iff,axiom,
    ! [C: $tType,B: $tType,A4: set(B),C3: set(C),B2: set(B)] :
      ( disjnt(product_prod(B,C),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),C3)),product_Sigma(B,C,B2,aTP_Lamp_hq(set(C),fun(B,set(C)),C3)))
    <=> ( ( C3 = bot_bot(set(C)) )
        | disjnt(B,A4,B2) ) ) ).

% disjnt_Times2_iff
tff(fact_3624_disjnt__empty2,axiom,
    ! [B: $tType,A4: set(B)] : disjnt(B,A4,bot_bot(set(B))) ).

% disjnt_empty2
tff(fact_3625_disjnt__empty1,axiom,
    ! [B: $tType,A4: set(B)] : disjnt(B,bot_bot(set(B)),A4) ).

% disjnt_empty1
tff(fact_3626_bdd__below__Int2,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [B2: set(B),A4: set(B)] :
          ( condit1013018076250108175_below(B,B2)
         => condit1013018076250108175_below(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ) ).

% bdd_below_Int2
tff(fact_3627_bdd__below__Int1,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [A4: set(B),B2: set(B)] :
          ( condit1013018076250108175_below(B,A4)
         => condit1013018076250108175_below(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ) ).

% bdd_below_Int1
tff(fact_3628_well__order__on__domain,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( order_well_order_on(B,A4,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
       => ( member(B,A3,A4)
          & member(B,Ba,A4) ) ) ) ).

% well_order_on_domain
tff(fact_3629_disjnt__Sigma__iff,axiom,
    ! [C: $tType,B: $tType,A4: set(B),C3: fun(B,set(C)),B2: set(B)] :
      ( disjnt(product_prod(B,C),product_Sigma(B,C,A4,C3),product_Sigma(B,C,B2,C3))
    <=> ( ! [X4: B] :
            ( member(B,X4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))
           => ( aa(B,set(C),C3,X4) = bot_bot(set(C)) ) )
        | disjnt(B,A4,B2) ) ) ).

% disjnt_Sigma_iff
tff(fact_3630_well__order__on__empty,axiom,
    ! [B: $tType] : order_well_order_on(B,bot_bot(set(B)),bot_bot(set(product_prod(B,B)))) ).

% well_order_on_empty
tff(fact_3631_disjnt__def,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( disjnt(B,A4,B2)
    <=> ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) ) ) ).

% disjnt_def
tff(fact_3632_le__cInf__iff,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [S2: set(B),A3: B] :
          ( ( S2 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(B,S2)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(set(B),B,complete_Inf_Inf(B),S2))
            <=> ! [X4: B] :
                  ( member(B,X4,S2)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),X4) ) ) ) ) ) ).

% le_cInf_iff
tff(fact_3633_cInf__mono,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [B2: set(B),A4: set(B)] :
          ( ( B2 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(B,A4)
           => ( ! [B4: B] :
                  ( member(B,B4,B2)
                 => ? [X3: B] :
                      ( member(B,X3,A4)
                      & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X3),B4) ) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),A4)),aa(set(B),B,complete_Inf_Inf(B),B2)) ) ) ) ) ).

% cInf_mono
tff(fact_3634_cInf__less__iff,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [X6: set(B),Y: B] :
          ( ( X6 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(B,X6)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(B),B,complete_Inf_Inf(B),X6)),Y)
            <=> ? [X4: B] :
                  ( member(B,X4,X6)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),X4),Y) ) ) ) ) ) ).

% cInf_less_iff
tff(fact_3635_Well__order__Restr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => order_well_order_on(B,field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) ) ).

% Well_order_Restr
tff(fact_3636_cINF__mono,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [B2: set(B),Fa: fun(D,C),A4: set(D),Ga: fun(B,C)] :
          ( ( B2 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(C,aa(set(D),set(C),image2(D,C,Fa),A4))
           => ( ! [M5: B] :
                  ( member(B,M5,B2)
                 => ? [X3: D] :
                      ( member(D,X3,A4)
                      & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(D,C,Fa,X3)),aa(B,C,Ga,M5)) ) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(D),set(C),image2(D,C,Fa),A4))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Ga),B2))) ) ) ) ) ).

% cINF_mono
tff(fact_3637_le__cINF__iff,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Fa: fun(B,C),U: C] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(C,aa(set(B),set(C),image2(B,C,Fa),A4))
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),U),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4)))
            <=> ! [X4: B] :
                  ( member(B,X4,A4)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),U),aa(B,C,Fa,X4)) ) ) ) ) ) ).

% le_cINF_iff
tff(fact_3638_cInf__superset__mono,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A4: set(B),B2: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(B,B2)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),B2)),aa(set(B),B,complete_Inf_Inf(B),A4)) ) ) ) ) ).

% cInf_superset_mono
tff(fact_3639_cInf__insert,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X6: set(B),A3: B] :
          ( ( X6 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(B,X6)
           => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert2(B,A3),X6)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(set(B),B,complete_Inf_Inf(B),X6)) ) ) ) ) ).

% cInf_insert
tff(fact_3640_cInf__insert__If,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [X6: set(B),A3: B] :
          ( condit1013018076250108175_below(B,X6)
         => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),insert2(B,A3),X6))
            = $ite(X6 = bot_bot(set(B)),A3,aa(B,B,aa(B,fun(B,B),inf_inf(B),A3),aa(set(B),B,complete_Inf_Inf(B),X6))) ) ) ) ).

% cInf_insert_If
tff(fact_3641_cInf__union__distrib,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A4: set(B),B2: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(B,A4)
           => ( ( B2 != bot_bot(set(B)) )
             => ( condit1013018076250108175_below(B,B2)
               => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),A4)),aa(set(B),B,complete_Inf_Inf(B),B2)) ) ) ) ) ) ) ).

% cInf_union_distrib
tff(fact_3642_well__order__on__Restr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),field2(B,R3))
       => order_well_order_on(B,A4,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) ) ) ).

% well_order_on_Restr
tff(fact_3643_cINF__less__iff,axiom,
    ! [B: $tType,C: $tType] :
      ( condit6923001295902523014norder(C)
     => ! [A4: set(B),Fa: fun(B,C),A3: C] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(C,aa(set(B),set(C),image2(B,C,Fa),A4))
           => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4))),A3)
            <=> ? [X4: B] :
                  ( member(B,X4,A4)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,X4)),A3) ) ) ) ) ) ).

% cINF_less_iff
tff(fact_3644_cINF__inf__distrib,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Fa: fun(B,C),Ga: fun(B,C)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(C,aa(set(B),set(C),image2(B,C,Fa),A4))
           => ( condit1013018076250108175_below(C,aa(set(B),set(C),image2(B,C,Ga),A4))
             => ( aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Ga),A4))) = aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_nb(fun(B,C),fun(fun(B,C),fun(B,C)),Fa),Ga)),A4)) ) ) ) ) ) ).

% cINF_inf_distrib
tff(fact_3645_Linear__order__Well__order__iff,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( order_679001287576687338der_on(B,field2(B,R3),R3)
     => ( order_well_order_on(B,field2(B,R3),R3)
      <=> ! [A11: set(B)] :
            ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A11),field2(B,R3))
           => ( ( A11 != bot_bot(set(B)) )
             => ? [X4: B] :
                  ( member(B,X4,A11)
                  & ! [Xa2: B] :
                      ( member(B,Xa2,A11)
                     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa2),R3) ) ) ) ) ) ) ).

% Linear_order_Well_order_iff
tff(fact_3646_cINF__superset__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Ga: fun(B,C),B2: set(B),Fa: fun(B,C)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(C,aa(set(B),set(C),image2(B,C,Ga),B2))
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
             => ( ! [X2: B] :
                    ( member(B,X2,B2)
                   => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Ga,X2)),aa(B,C,Fa,X2)) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Ga),B2))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4))) ) ) ) ) ) ).

% cINF_superset_mono
tff(fact_3647_less__eq__cInf__inter,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A4: set(B),B2: set(B)] :
          ( condit1013018076250108175_below(B,A4)
         => ( condit1013018076250108175_below(B,B2)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) != bot_bot(set(B)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(set(B),B,complete_Inf_Inf(B),A4)),aa(set(B),B,complete_Inf_Inf(B),B2))),aa(set(B),B,complete_Inf_Inf(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ) ) ) ).

% less_eq_cInf_inter
tff(fact_3648_cINF__insert,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Fa: fun(B,C),A3: B] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(C,aa(set(B),set(C),image2(B,C,Fa),A4))
           => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),aa(set(B),set(B),insert2(B,A3),A4))) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,Fa,A3)),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4))) ) ) ) ) ).

% cINF_insert
tff(fact_3649_cINF__union,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [A4: set(B),Fa: fun(B,C),B2: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(C,aa(set(B),set(C),image2(B,C,Fa),A4))
           => ( ( B2 != bot_bot(set(B)) )
             => ( condit1013018076250108175_below(C,aa(set(B),set(C),image2(B,C,Fa),B2))
               => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),B2))) ) ) ) ) ) ) ).

% cINF_union
tff(fact_3650_cInf__le__cSup,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A4: set(B)] :
          ( ( A4 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,A4)
           => ( condit1013018076250108175_below(B,A4)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),A4)),aa(set(B),B,complete_Sup_Sup(B),A4)) ) ) ) ) ).

% cInf_le_cSup
tff(fact_3651_ofilter__Restr__Int,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
       => order_ofilter(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,B2,aTP_Lamp_if(set(B),fun(B,set(B)),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ) ).

% ofilter_Restr_Int
tff(fact_3652_ofilter__Restr__subset,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
         => order_ofilter(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,B2,aTP_Lamp_if(set(B),fun(B,set(B)),B2))),A4) ) ) ) ).

% ofilter_Restr_subset
tff(fact_3653_inverse__rat__def,axiom,
    inverse_inverse(rat) = aa(fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat),aTP_Lamp_gl(product_prod(int,int),product_prod(int,int))) ).

% inverse_rat_def
tff(fact_3654_set__to__map__def,axiom,
    ! [B: $tType,C: $tType,S2: set(product_prod(C,B)),K: C] : ( aa(C,option(B),set_to_map(C,B,S2),K) = eps_Opt(B,aa(C,fun(B,$o),aTP_Lamp_ll(set(product_prod(C,B)),fun(C,fun(B,$o)),S2),K)) ) ).

% set_to_map_def
tff(fact_3655_map__fun_Ocompositionality,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,G: $tType,F7: $tType,Fa: fun(B,D),Ga: fun(E,C),H2: fun(D,F7),I: fun(G,E),Fun: fun(F7,G)] : ( aa(fun(D,E),fun(B,C),map_fun(B,D,E,C,Fa,Ga),aa(fun(F7,G),fun(D,E),map_fun(D,F7,G,E,H2,I),Fun)) = aa(fun(F7,G),fun(B,C),map_fun(B,F7,G,C,aa(fun(B,D),fun(B,F7),aa(fun(D,F7),fun(fun(B,D),fun(B,F7)),comp(D,F7,B),H2),Fa),aa(fun(G,E),fun(G,C),aa(fun(E,C),fun(fun(G,E),fun(G,C)),comp(E,C,G),Ga),I)),Fun) ) ).

% map_fun.compositionality
tff(fact_3656_map__fun__def,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,Fa: fun(B,D),Ga: fun(E,C),H2: fun(D,E)] : ( aa(fun(D,E),fun(B,C),map_fun(B,D,E,C,Fa,Ga),H2) = aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),aa(fun(D,E),fun(D,C),aa(fun(E,C),fun(fun(D,E),fun(D,C)),comp(E,C,D),Ga),H2)),Fa) ) ).

% map_fun_def
tff(fact_3657_map__fun_Ocomp,axiom,
    ! [D: $tType,F7: $tType,B: $tType,E: $tType,G: $tType,C: $tType,Fa: fun(D,F7),Ga: fun(G,E),H2: fun(F7,B),I: fun(C,G)] : ( aa(fun(fun(B,C),fun(F7,G)),fun(fun(B,C),fun(D,E)),aa(fun(fun(F7,G),fun(D,E)),fun(fun(fun(B,C),fun(F7,G)),fun(fun(B,C),fun(D,E))),comp(fun(F7,G),fun(D,E),fun(B,C)),map_fun(D,F7,G,E,Fa,Ga)),map_fun(F7,B,C,G,H2,I)) = map_fun(D,B,C,E,aa(fun(D,F7),fun(D,B),aa(fun(F7,B),fun(fun(D,F7),fun(D,B)),comp(F7,B,D),H2),Fa),aa(fun(C,G),fun(C,E),aa(fun(G,E),fun(fun(C,G),fun(C,E)),comp(G,E,C),Ga),I)) ) ).

% map_fun.comp
tff(fact_3658_uminus__rat__def,axiom,
    uminus_uminus(rat) = aa(fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat),aTP_Lamp_gq(product_prod(int,int),product_prod(int,int))) ).

% uminus_rat_def
tff(fact_3659_Field__Restr__ofilter,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
       => ( field2(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) = A4 ) ) ) ).

% Field_Restr_ofilter
tff(fact_3660_plus__rat__def,axiom,
    plus_plus(rat) = aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(rat,fun(rat,rat)),map_fun(rat,product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),rep_Rat,map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat)),aTP_Lamp_gs(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% plus_rat_def
tff(fact_3661_ofilter__subset__embedS,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
       => ( order_ofilter(B,R3,B2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A4),B2)
          <=> bNF_Wellorder_embedS(B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,B2,aTP_Lamp_if(set(B),fun(B,set(B)),B2))),id(B)) ) ) ) ) ).

% ofilter_subset_embedS
tff(fact_3662_times__rat__def,axiom,
    times_times(rat) = aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(rat,fun(rat,rat)),map_fun(rat,product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),rep_Rat,map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat)),aTP_Lamp_gt(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% times_rat_def
tff(fact_3663_ofilter__subset__ordLess,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
       => ( order_ofilter(B,R3,B2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A4),B2)
          <=> member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,B2,aTP_Lamp_if(set(B),fun(B,set(B)),B2)))),bNF_We4044943003108391690rdLess(B,B)) ) ) ) ) ).

% ofilter_subset_ordLess
tff(fact_3664_ordLess__transitive,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),R8: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),R4),R8),bNF_We4044943003108391690rdLess(C,D))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(B,B)),fun(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D)))),product_Pair(set(product_prod(B,B)),set(product_prod(D,D))),R3),R8),bNF_We4044943003108391690rdLess(B,D)) ) ) ).

% ordLess_transitive
tff(fact_3665_ordLess__irreflexive,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),R3),bNF_We4044943003108391690rdLess(B,B)) ).

% ordLess_irreflexive
tff(fact_3666_finite__ordLess__infinite,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( aa(set(B),$o,finite_finite(B),field2(B,R3))
         => ( ~ aa(set(C),$o,finite_finite(C),field2(C,R4))
           => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C)) ) ) ) ) ).

% finite_ordLess_infinite
tff(fact_3667_ofilter__ordLess,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A4),field2(B,R3))
        <=> member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),R3),bNF_We4044943003108391690rdLess(B,B)) ) ) ) ).

% ofilter_ordLess
tff(fact_3668_times__int__def,axiom,
    times_times(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int_def
tff(fact_3669_ofilter__subset__embedS__iso,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
       => ( order_ofilter(B,R3,B2)
         => ( ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),A4),B2)
            <=> bNF_Wellorder_embedS(B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,B2,aTP_Lamp_if(set(B),fun(B,set(B)),B2))),id(B)) )
            & ( ( A4 = B2 )
            <=> bNF_Wellorder_iso(B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,B2,aTP_Lamp_if(set(B),fun(B,set(B)),B2))),id(B)) ) ) ) ) ) ).

% ofilter_subset_embedS_iso
tff(fact_3670_minus__int__def,axiom,
    minus_minus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int_def
tff(fact_3671_plus__int__def,axiom,
    plus_plus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),aa(fun(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int_def
tff(fact_3672_uminus__int__def,axiom,
    uminus_uminus(int) = aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ),aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int_def
tff(fact_3673_iso__comp__embedS,axiom,
    ! [D: $tType,C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C),R8: set(product_prod(D,D)),F9: fun(C,D)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( bNF_Wellorder_iso(B,C,R3,R4,Fa)
         => ( bNF_Wellorder_embedS(C,D,R4,R8,F9)
           => bNF_Wellorder_embedS(B,D,R3,R8,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),F9),Fa)) ) ) ) ) ).

% iso_comp_embedS
tff(fact_3674_embedS__comp__iso,axiom,
    ! [D: $tType,C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C),R8: set(product_prod(D,D)),F9: fun(C,D)] :
      ( bNF_Wellorder_embedS(B,C,R3,R4,Fa)
     => ( bNF_Wellorder_iso(C,D,R4,R8,F9)
       => bNF_Wellorder_embedS(B,D,R3,R8,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),F9),Fa)) ) ) ).

% embedS_comp_iso
tff(fact_3675_underS__Restr__ordLess,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( ( field2(B,R3) != bot_bot(set(B)) )
       => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,order_underS(B,R3,A3),aa(B,fun(B,set(B)),aTP_Lamp_nc(set(product_prod(B,B)),fun(B,fun(B,set(B))),R3),A3)))),R3),bNF_We4044943003108391690rdLess(B,B)) ) ) ).

% underS_Restr_ordLess
tff(fact_3676_comp__iso,axiom,
    ! [D: $tType,C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C),R8: set(product_prod(D,D)),F9: fun(C,D)] :
      ( bNF_Wellorder_iso(B,C,R3,R4,Fa)
     => ( bNF_Wellorder_iso(C,D,R4,R8,F9)
       => bNF_Wellorder_iso(B,D,R3,R8,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),F9),Fa)) ) ) ).

% comp_iso
tff(fact_3677_underS__I,axiom,
    ! [B: $tType,I: B,J2: B,R: set(product_prod(B,B))] :
      ( ( I != J2 )
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),I),J2),R)
       => member(B,I,order_underS(B,R,J2)) ) ) ).

% underS_I
tff(fact_3678_underS__E,axiom,
    ! [B: $tType,I: B,R: set(product_prod(B,B)),J2: B] :
      ( member(B,I,order_underS(B,R,J2))
     => ( ( I != J2 )
        & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),I),J2),R) ) ) ).

% underS_E
tff(fact_3679_underS__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] : ( order_underS(B,R3,A3) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_nd(set(product_prod(B,B)),fun(B,fun(B,$o)),R3),A3)) ) ).

% underS_def
tff(fact_3680_underS__empty,axiom,
    ! [B: $tType,A3: B,R3: set(product_prod(B,B))] :
      ( ~ member(B,A3,field2(B,R3))
     => ( order_underS(B,R3,A3) = bot_bot(set(B)) ) ) ).

% underS_empty
tff(fact_3681_underS__Field3,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] :
      ( ( field2(B,R3) != bot_bot(set(B)) )
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less(set(B)),order_underS(B,R3,A3)),field2(B,R3)) ) ).

% underS_Field3
tff(fact_3682_underS__incl__iff,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( order_679001287576687338der_on(B,field2(B,R3),R3)
     => ( member(B,A3,field2(B,R3))
       => ( member(B,Ba,field2(B,R3))
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),order_underS(B,R3,A3)),order_underS(B,R3,Ba))
          <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3) ) ) ) ) ).

% underS_incl_iff
tff(fact_3683_iso__forward,axiom,
    ! [B: $tType,C: $tType,X: B,Y: B,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
     => ( bNF_Wellorder_iso(B,C,R3,R4,Fa)
       => member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),aa(B,C,Fa,X)),aa(B,C,Fa,Y)),R4) ) ) ).

% iso_forward
tff(fact_3684_ordLess__iff__ordIso__Restr,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R3),bNF_We4044943003108391690rdLess(C,B))
        <=> ? [X4: B] :
              ( member(B,X4,field2(B,R3))
              & member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,order_underS(B,R3,X4),aa(B,fun(B,set(B)),aTP_Lamp_nc(set(product_prod(B,B)),fun(B,fun(B,set(B))),R3),X4)))),bNF_Wellorder_ordIso(C,B)) ) ) ) ) ).

% ordLess_iff_ordIso_Restr
tff(fact_3685_ordLeq__iff__ordLess__Restr,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
        <=> ! [X4: B] :
              ( member(B,X4,field2(B,R3))
             => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,order_underS(B,R3,X4),aa(B,fun(B,set(B)),aTP_Lamp_nc(set(product_prod(B,B)),fun(B,fun(B,set(B))),R3),X4)))),R4),bNF_We4044943003108391690rdLess(B,C)) ) ) ) ) ).

% ordLeq_iff_ordLess_Restr
tff(fact_3686_ofilter__subset__embed,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
       => ( order_ofilter(B,R3,B2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
          <=> bNF_Wellorder_embed(B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,B2,aTP_Lamp_if(set(B),fun(B,set(B)),B2))),id(B)) ) ) ) ) ).

% ofilter_subset_embed
tff(fact_3687_ofilter__embed,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
      <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),field2(B,R3))
          & bNF_Wellorder_embed(B,B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4))),R3,id(B)) ) ) ) ).

% ofilter_embed
tff(fact_3688_comp__embed,axiom,
    ! [D: $tType,C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C),R8: set(product_prod(D,D)),F9: fun(C,D)] :
      ( bNF_Wellorder_embed(B,C,R3,R4,Fa)
     => ( bNF_Wellorder_embed(C,D,R4,R8,F9)
       => bNF_Wellorder_embed(B,D,R3,R8,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),F9),Fa)) ) ) ).

% comp_embed
tff(fact_3689_ordLeq__iff__ordLess__or__ordIso,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
    <=> ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
        | member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C)) ) ) ).

% ordLeq_iff_ordLess_or_ordIso
tff(fact_3690_ordLeq__transitive,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),R8: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),R4),R8),bNF_Wellorder_ordLeq(C,D))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(B,B)),fun(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D)))),product_Pair(set(product_prod(B,B)),set(product_prod(D,D))),R3),R8),bNF_Wellorder_ordLeq(B,D)) ) ) ).

% ordLeq_transitive
tff(fact_3691_ordLeq__ordIso__trans,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),R8: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),R4),R8),bNF_Wellorder_ordIso(C,D))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(B,B)),fun(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D)))),product_Pair(set(product_prod(B,B)),set(product_prod(D,D))),R3),R8),bNF_Wellorder_ordLeq(B,D)) ) ) ).

% ordLeq_ordIso_trans
tff(fact_3692_ordIso__ordLeq__trans,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),R8: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),R4),R8),bNF_Wellorder_ordLeq(C,D))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(B,B)),fun(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D)))),product_Pair(set(product_prod(B,B)),set(product_prod(D,D))),R3),R8),bNF_Wellorder_ordLeq(B,D)) ) ) ).

% ordIso_ordLeq_trans
tff(fact_3693_ordIso__imp__ordLeq,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C)) ) ).

% ordIso_imp_ordLeq
tff(fact_3694_ordIso__iff__ordLeq,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
    <=> ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
        & member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R3),bNF_Wellorder_ordLeq(C,B)) ) ) ).

% ordIso_iff_ordLeq
tff(fact_3695_ordIso__symmetric,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R3),bNF_Wellorder_ordIso(C,B)) ) ).

% ordIso_symmetric
tff(fact_3696_ordIso__transitive,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),R8: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),R4),R8),bNF_Wellorder_ordIso(C,D))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(B,B)),fun(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D)))),product_Pair(set(product_prod(B,B)),set(product_prod(D,D))),R3),R8),bNF_Wellorder_ordIso(B,D)) ) ) ).

% ordIso_transitive
tff(fact_3697_internalize__ordLeq,axiom,
    ! [B: $tType,C: $tType,R4: set(product_prod(B,B)),R3: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R3),bNF_Wellorder_ordLeq(B,C))
    <=> ? [P5: set(product_prod(C,C))] :
          ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),field2(C,P5)),field2(C,R3))
          & member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),P5),bNF_Wellorder_ordIso(B,C))
          & member(product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),fun(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),product_Pair(set(product_prod(C,C)),set(product_prod(C,C))),P5),R3),bNF_Wellorder_ordLeq(C,C)) ) ) ).

% internalize_ordLeq
tff(fact_3698_ordLess__ordLeq__trans,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),R8: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),R4),R8),bNF_Wellorder_ordLeq(C,D))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(B,B)),fun(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D)))),product_Pair(set(product_prod(B,B)),set(product_prod(D,D))),R3),R8),bNF_We4044943003108391690rdLess(B,D)) ) ) ).

% ordLess_ordLeq_trans
tff(fact_3699_ordLeq__ordLess__trans,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),R8: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),R4),R8),bNF_We4044943003108391690rdLess(C,D))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(B,B)),fun(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D)))),product_Pair(set(product_prod(B,B)),set(product_prod(D,D))),R3),R8),bNF_We4044943003108391690rdLess(B,D)) ) ) ).

% ordLeq_ordLess_trans
tff(fact_3700_ordLess__imp__ordLeq,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
     => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C)) ) ).

% ordLess_imp_ordLeq
tff(fact_3701_not__ordLess__ordLeq,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
     => ~ member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R3),bNF_Wellorder_ordLeq(C,B)) ) ).

% not_ordLess_ordLeq
tff(fact_3702_ordLess__ordIso__trans,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),R8: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),R4),R8),bNF_Wellorder_ordIso(C,D))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(B,B)),fun(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D)))),product_Pair(set(product_prod(B,B)),set(product_prod(D,D))),R3),R8),bNF_We4044943003108391690rdLess(B,D)) ) ) ).

% ordLess_ordIso_trans
tff(fact_3703_ordIso__ordLess__trans,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),R8: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),R4),R8),bNF_We4044943003108391690rdLess(C,D))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D))),aa(set(product_prod(B,B)),fun(set(product_prod(D,D)),product_prod(set(product_prod(B,B)),set(product_prod(D,D)))),product_Pair(set(product_prod(B,B)),set(product_prod(D,D))),R3),R8),bNF_We4044943003108391690rdLess(B,D)) ) ) ).

% ordIso_ordLess_trans
tff(fact_3704_not__ordLess__ordIso,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
     => ~ member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C)) ) ).

% not_ordLess_ordIso
tff(fact_3705_ordLess__not__embed,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
     => ~ ? [X_13: fun(C,B)] : bNF_Wellorder_embed(C,B,R4,R3,X_13) ) ).

% ordLess_not_embed
tff(fact_3706_iso__comp__embed,axiom,
    ! [D: $tType,C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C),R8: set(product_prod(D,D)),F9: fun(C,D)] :
      ( bNF_Wellorder_iso(B,C,R3,R4,Fa)
     => ( bNF_Wellorder_embed(C,D,R4,R8,F9)
       => bNF_Wellorder_embed(B,D,R3,R8,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),F9),Fa)) ) ) ).

% iso_comp_embed
tff(fact_3707_embed__comp__iso,axiom,
    ! [D: $tType,C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C),R8: set(product_prod(D,D)),F9: fun(C,D)] :
      ( bNF_Wellorder_embed(B,C,R3,R4,Fa)
     => ( bNF_Wellorder_iso(C,D,R4,R8,F9)
       => bNF_Wellorder_embed(B,D,R3,R8,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),F9),Fa)) ) ) ).

% embed_comp_iso
tff(fact_3708_finite__well__order__on__ordIso,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),R4: set(product_prod(B,B))] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( order_well_order_on(B,A4,R3)
       => ( order_well_order_on(B,A4,R4)
         => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(B,B)) ) ) ) ).

% finite_well_order_on_ordIso
tff(fact_3709_exists__minim__Well__order,axiom,
    ! [B: $tType,R: set(set(product_prod(B,B)))] :
      ( ( R != bot_bot(set(set(product_prod(B,B)))) )
     => ( ! [X2: set(product_prod(B,B))] :
            ( member(set(product_prod(B,B)),X2,R)
           => order_well_order_on(B,field2(B,X2),X2) )
       => ? [X2: set(product_prod(B,B))] :
            ( member(set(product_prod(B,B)),X2,R)
            & ! [Xa3: set(product_prod(B,B))] :
                ( member(set(product_prod(B,B)),Xa3,R)
               => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),X2),Xa3),bNF_Wellorder_ordLeq(B,B)) ) ) ) ) ).

% exists_minim_Well_order
tff(fact_3710_ordLeq__total,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
          | member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R3),bNF_Wellorder_ordLeq(C,B)) ) ) ) ).

% ordLeq_total
tff(fact_3711_ordLeq__reflexive,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),R3),bNF_Wellorder_ordLeq(B,B)) ) ).

% ordLeq_reflexive
tff(fact_3712_ordLeq__Well__order__simp,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
     => ( order_well_order_on(B,field2(B,R3),R3)
        & order_well_order_on(C,field2(C,R4),R4) ) ) ).

% ordLeq_Well_order_simp
tff(fact_3713_ordIso__reflexive,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),R3),bNF_Wellorder_ordIso(B,B)) ) ).

% ordIso_reflexive
tff(fact_3714_BNF__Wellorder__Constructions_OordLess__Field,axiom,
    ! [B: $tType,C: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C)),Fa: fun(B,C)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R1),R22),bNF_We4044943003108391690rdLess(B,C))
     => ( bNF_Wellorder_embed(B,C,R1,R22,Fa)
       => ( aa(set(B),set(C),image2(B,C,Fa),field2(B,R1)) != field2(C,R22) ) ) ) ).

% BNF_Wellorder_Constructions.ordLess_Field
tff(fact_3715_internalize__ordLess,axiom,
    ! [B: $tType,C: $tType,R4: set(product_prod(B,B)),R3: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),R3),bNF_We4044943003108391690rdLess(B,C))
    <=> ? [P5: set(product_prod(C,C))] :
          ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less(set(C)),field2(C,P5)),field2(C,R3))
          & member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R4),P5),bNF_Wellorder_ordIso(B,C))
          & member(product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),fun(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),product_Pair(set(product_prod(C,C)),set(product_prod(C,C))),P5),R3),bNF_We4044943003108391690rdLess(C,C)) ) ) ).

% internalize_ordLess
tff(fact_3716_ordLess__or__ordLeq,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
          | member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R3),bNF_Wellorder_ordLeq(C,B)) ) ) ) ).

% ordLess_or_ordLeq
tff(fact_3717_not__ordLeq__iff__ordLess,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( ~ member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R3),bNF_Wellorder_ordLeq(C,B))
        <=> member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C)) ) ) ) ).

% not_ordLeq_iff_ordLess
tff(fact_3718_not__ordLess__iff__ordLeq,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( ~ member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R3),bNF_We4044943003108391690rdLess(C,B))
        <=> member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C)) ) ) ) ).

% not_ordLess_iff_ordLeq
tff(fact_3719_ordLess__iff,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
    <=> ( order_well_order_on(B,field2(B,R3),R3)
        & order_well_order_on(C,field2(C,R4),R4)
        & ~ ? [X_12: fun(C,B)] : bNF_Wellorder_embed(C,B,R4,R3,X_12) ) ) ).

% ordLess_iff
tff(fact_3720_embed__comp__embedS,axiom,
    ! [D: $tType,C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C),R8: set(product_prod(D,D)),F9: fun(C,D)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( bNF_Wellorder_embed(B,C,R3,R4,Fa)
         => ( bNF_Wellorder_embedS(C,D,R4,R8,F9)
           => bNF_Wellorder_embedS(B,D,R3,R8,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),F9),Fa)) ) ) ) ) ).

% embed_comp_embedS
tff(fact_3721_embedS__comp__embed,axiom,
    ! [D: $tType,C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C),R8: set(product_prod(D,D)),F9: fun(C,D)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( bNF_Wellorder_embedS(B,C,R3,R4,Fa)
         => ( bNF_Wellorder_embed(C,D,R4,R8,F9)
           => bNF_Wellorder_embedS(B,D,R3,R8,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),F9),Fa)) ) ) ) ) ).

% embedS_comp_embed
tff(fact_3722_embed__implies__iso__Restr,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(C,B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_well_order_on(C,field2(C,R4),R4)
       => ( bNF_Wellorder_embed(C,B,R4,R3,Fa)
         => bNF_Wellorder_iso(C,B,R4,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,aa(set(C),set(B),image2(C,B,Fa),field2(C,R4)),aa(fun(C,B),fun(B,set(B)),aTP_Lamp_ne(set(product_prod(C,C)),fun(fun(C,B),fun(B,set(B))),R4),Fa))),Fa) ) ) ) ).

% embed_implies_iso_Restr
tff(fact_3723_ofilter__subset__ordLeq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),B2: set(B)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
       => ( order_ofilter(B,R3,B2)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
          <=> member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,B2,aTP_Lamp_if(set(B),fun(B,set(B)),B2)))),bNF_Wellorder_ordLeq(B,B)) ) ) ) ) ).

% ofilter_subset_ordLeq
tff(fact_3724_embed__ordLess__ofilterIncl,axiom,
    ! [C: $tType,B: $tType,D: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C)),R33: set(product_prod(D,D)),F13: fun(B,D),F23: fun(C,D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R1),R22),bNF_We4044943003108391690rdLess(B,C))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),R22),R33),bNF_We4044943003108391690rdLess(C,D))
       => ( bNF_Wellorder_embed(B,D,R1,R33,F13)
         => ( bNF_Wellorder_embed(C,D,R22,R33,F23)
           => member(product_prod(set(D),set(D)),aa(set(D),product_prod(set(D),set(D)),aa(set(D),fun(set(D),product_prod(set(D),set(D))),product_Pair(set(D),set(D)),aa(set(B),set(D),image2(B,D,F13),field2(B,R1))),aa(set(C),set(D),image2(C,D,F23),field2(C,R22))),bNF_We413866401316099525erIncl(D,R33)) ) ) ) ) ).

% embed_ordLess_ofilterIncl
tff(fact_3725_Refl__under__underS,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] :
      ( refl_on(B,field2(B,R3),R3)
     => ( member(B,A3,field2(B,R3))
       => ( order_under(B,R3,A3) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),order_underS(B,R3,A3)),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) ) ) ) ).

% Refl_under_underS
tff(fact_3726_ofilter__Restr__under,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),A3: B] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( order_ofilter(B,R3,A4)
       => ( member(B,A3,A4)
         => ( order_under(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4))),A3) = order_under(B,R3,A3) ) ) ) ) ).

% ofilter_Restr_under
tff(fact_3727_comp__set__bd__Union__o__collect,axiom,
    ! [D: $tType,C: $tType,B: $tType,X: D,X6: set(fun(D,set(set(B)))),Hbd: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(set(set(B))),set(set(B)),complete_Sup_Sup(set(set(B))),aa(set(fun(D,set(set(B)))),set(set(set(B))),image2(fun(D,set(set(B))),set(set(B)),aTP_Lamp_nf(D,fun(fun(D,set(set(B))),set(set(B))),X)),X6))))),Hbd),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(D,set(B),aa(fun(D,set(set(B))),fun(D,set(B)),aa(fun(set(set(B)),set(B)),fun(fun(D,set(set(B))),fun(D,set(B))),comp(set(set(B)),set(B),D),complete_Sup_Sup(set(B))),bNF_collect(D,set(B),X6)),X))),Hbd),bNF_Wellorder_ordLeq(B,C)) ) ).

% comp_set_bd_Union_o_collect
tff(fact_3728_card__of__Times1,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ( A4 != bot_bot(set(B)) )
     => member(product_prod(set(product_prod(C,C)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(C,C)),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(C,C)),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,B2,aTP_Lamp_ho(set(B),fun(C,set(B)),A4)))),bNF_Wellorder_ordLeq(C,product_prod(C,B))) ) ).

% card_of_Times1
tff(fact_3729_card__of__Times2,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ( A4 != bot_bot(set(B)) )
     => member(product_prod(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(C,C)),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))),bNF_Wellorder_ordLeq(C,product_prod(B,C))) ) ).

% card_of_Times2
tff(fact_3730_card__of__Times3,axiom,
    ! [B: $tType,A4: set(B)] : member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,B),product_prod(B,B)))),aa(set(product_prod(product_prod(B,B),product_prod(B,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,B),product_prod(B,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(B,B),product_prod(B,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,B),product_prod(B,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(B,B),product_prod(B,B)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(product_prod(B,B),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),bNF_Wellorder_ordLeq(B,product_prod(B,B))) ).

% card_of_Times3
tff(fact_3731_card__of__Func__Times,axiom,
    ! [D: $tType,C: $tType,B: $tType,A4: set(B),B2: set(C),C3: set(D)] : member(product_prod(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D))))),aa(set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D)))),product_prod(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D))))),aa(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),fun(set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D)))),product_prod(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D)))))),product_Pair(set(product_prod(fun(product_prod(B,C),D),fun(product_prod(B,C),D))),set(product_prod(fun(B,fun(C,D)),fun(B,fun(C,D))))),bNF_Ca6860139660246222851ard_of(fun(product_prod(B,C),D),bNF_Wellorder_Func(product_prod(B,C),D,product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)),C3))),bNF_Ca6860139660246222851ard_of(fun(B,fun(C,D)),bNF_Wellorder_Func(B,fun(C,D),A4,bNF_Wellorder_Func(C,D,B2,C3)))),bNF_Wellorder_ordIso(fun(product_prod(B,C),D),fun(B,fun(C,D)))) ).

% card_of_Func_Times
tff(fact_3732_Func__Times__Range,axiom,
    ! [D: $tType,C: $tType,B: $tType,A4: set(B),B2: set(C),C3: set(D)] : member(product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D))))),aa(set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D)))),product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D))))),aa(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),fun(set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D)))),product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D)))))),product_Pair(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D))))),bNF_Ca6860139660246222851ard_of(fun(B,product_prod(C,D)),bNF_Wellorder_Func(B,product_prod(C,D),A4,product_Sigma(C,D,B2,aTP_Lamp_jn(set(D),fun(C,set(D)),C3))))),bNF_Ca6860139660246222851ard_of(product_prod(fun(B,C),fun(B,D)),product_Sigma(fun(B,C),fun(B,D),bNF_Wellorder_Func(B,C,A4,B2),aa(set(D),fun(fun(B,C),set(fun(B,D))),aTP_Lamp_ng(set(B),fun(set(D),fun(fun(B,C),set(fun(B,D)))),A4),C3)))),bNF_Wellorder_ordIso(fun(B,product_prod(C,D)),product_prod(fun(B,C),fun(B,D)))) ).

% Func_Times_Range
tff(fact_3733_card__of__Pow__Func,axiom,
    ! [B: $tType,A4: set(B)] : member(product_prod(set(product_prod(set(B),set(B))),set(product_prod(fun(B,$o),fun(B,$o)))),aa(set(product_prod(fun(B,$o),fun(B,$o))),product_prod(set(product_prod(set(B),set(B))),set(product_prod(fun(B,$o),fun(B,$o)))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(fun(B,$o),fun(B,$o))),product_prod(set(product_prod(set(B),set(B))),set(product_prod(fun(B,$o),fun(B,$o))))),product_Pair(set(product_prod(set(B),set(B))),set(product_prod(fun(B,$o),fun(B,$o)))),bNF_Ca6860139660246222851ard_of(set(B),pow(B,A4))),bNF_Ca6860139660246222851ard_of(fun(B,$o),bNF_Wellorder_Func(B,$o,A4,top_top(set($o))))),bNF_Wellorder_ordIso(set(B),fun(B,$o))) ).

% card_of_Pow_Func
tff(fact_3734_card__of__Times__same__infinite,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => member(product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,B),product_prod(B,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(B,B),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(product_prod(B,B),B)) ) ).

% card_of_Times_same_infinite
tff(fact_3735_card__of__Pow,axiom,
    ! [B: $tType,A4: set(B)] : member(product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(B,B)),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(set(B),pow(B,A4))),bNF_We4044943003108391690rdLess(B,set(B))) ).

% card_of_Pow
tff(fact_3736_card__of__Times__commute,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] : member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,B2,aTP_Lamp_ho(set(B),fun(C,set(B)),A4)))),bNF_Wellorder_ordIso(product_prod(B,C),product_prod(C,B))) ).

% card_of_Times_commute
tff(fact_3737_infinite__iff__card__of__nat,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
    <=> member(product_prod(set(product_prod(nat,nat)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(nat,nat)),set(product_prod(B,B))),aa(set(product_prod(nat,nat)),fun(set(product_prod(B,B)),product_prod(set(product_prod(nat,nat)),set(product_prod(B,B)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(nat,top_top(set(nat)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(nat,B)) ) ).

% infinite_iff_card_of_nat
tff(fact_3738_card__of__bool,axiom,
    ! [B: $tType,A1: B,A22: B] :
      ( ( A1 != A22 )
     => member(product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod($o,$o)),fun(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B)))),product_Pair(set(product_prod($o,$o)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of($o,top_top(set($o)))),bNF_Ca6860139660246222851ard_of(B,aa(set(B),set(B),insert2(B,A1),aa(set(B),set(B),insert2(B,A22),bot_bot(set(B)))))),bNF_Wellorder_ordIso($o,B)) ) ).

% card_of_bool
tff(fact_3739_card__of__UNION__Sigma,axiom,
    ! [C: $tType,B: $tType,A4: fun(C,set(B)),I4: set(C)] : member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(B,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),A4),I4)))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,I4,A4))),bNF_Wellorder_ordLeq(B,product_prod(C,B))) ).

% card_of_UNION_Sigma
tff(fact_3740_card__of__Times__mono2,axiom,
    ! [C: $tType,B: $tType,D: $tType,A4: set(B),B2: set(C),C3: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,B),product_prod(D,B))),fun(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C))))),product_Pair(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),bNF_Ca6860139660246222851ard_of(product_prod(D,B),product_Sigma(D,B,C3,aTP_Lamp_nh(set(B),fun(D,set(B)),A4)))),bNF_Ca6860139660246222851ard_of(product_prod(D,C),product_Sigma(D,C,C3,aTP_Lamp_ni(set(C),fun(D,set(C)),B2)))),bNF_Wellorder_ordLeq(product_prod(D,B),product_prod(D,C))) ) ).

% card_of_Times_mono2
tff(fact_3741_card__of__Times__mono1,axiom,
    ! [C: $tType,D: $tType,B: $tType,A4: set(B),B2: set(C),C3: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),fun(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D))))),product_Pair(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),bNF_Ca6860139660246222851ard_of(product_prod(B,D),product_Sigma(B,D,A4,aTP_Lamp_nj(set(D),fun(B,set(D)),C3)))),bNF_Ca6860139660246222851ard_of(product_prod(C,D),product_Sigma(C,D,B2,aTP_Lamp_jn(set(D),fun(C,set(D)),C3)))),bNF_Wellorder_ordLeq(product_prod(B,D),product_prod(C,D))) ) ).

% card_of_Times_mono1
tff(fact_3742_card__of__Sigma__mono1,axiom,
    ! [D: $tType,C: $tType,B: $tType,I4: set(B),A4: fun(B,set(C)),B2: fun(B,set(D))] :
      ( ! [X2: B] :
          ( member(B,X2,I4)
         => member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A4,X2))),bNF_Ca6860139660246222851ard_of(D,aa(B,set(D),B2,X2))),bNF_Wellorder_ordLeq(C,D)) )
     => member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,I4,A4))),bNF_Ca6860139660246222851ard_of(product_prod(B,D),product_Sigma(B,D,I4,B2))),bNF_Wellorder_ordLeq(product_prod(B,C),product_prod(B,D))) ) ).

% card_of_Sigma_mono1
tff(fact_3743_under__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] : ( order_under(B,R3,A3) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_nk(set(product_prod(B,B)),fun(B,fun(B,$o)),R3),A3)) ) ).

% under_def
tff(fact_3744_card__of__Sigma__ordLeq__infinite,axiom,
    ! [B: $tType,D: $tType,C: $tType,B2: set(B),I4: set(C),A4: fun(C,set(D))] :
      ( ~ aa(set(B),$o,finite_finite(B),B2)
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,I4)),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Wellorder_ordLeq(C,B))
       => ( ! [X2: C] :
              ( member(C,X2,I4)
             => member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),A4,X2))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Wellorder_ordLeq(D,B)) )
         => member(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,D),product_Sigma(C,D,I4,A4))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Wellorder_ordLeq(product_prod(C,D),B)) ) ) ) ).

% card_of_Sigma_ordLeq_infinite
tff(fact_3745_card__of__refl,axiom,
    ! [B: $tType,A4: set(B)] : member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(B,B)) ).

% card_of_refl
tff(fact_3746_card__of__Times__infinite__simps_I4_J,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ( ( B2 != bot_bot(set(C)) )
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(C,B))
         => member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,B2,aTP_Lamp_ho(set(B),fun(C,set(B)),A4)))),bNF_Wellorder_ordIso(B,product_prod(C,B))) ) ) ) ).

% card_of_Times_infinite_simps(4)
tff(fact_3747_card__of__Times__infinite__simps_I3_J,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ( ( B2 != bot_bot(set(C)) )
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(C,B))
         => member(product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,B2,aTP_Lamp_ho(set(B),fun(C,set(B)),A4)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(product_prod(C,B),B)) ) ) ) ).

% card_of_Times_infinite_simps(3)
tff(fact_3748_card__of__Times__infinite__simps_I2_J,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ( ( B2 != bot_bot(set(C)) )
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(C,B))
         => member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))),bNF_Wellorder_ordIso(B,product_prod(B,C))) ) ) ) ).

% card_of_Times_infinite_simps(2)
tff(fact_3749_card__of__Times__infinite__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ( ( B2 != bot_bot(set(C)) )
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(C,B))
         => member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(product_prod(B,C),B)) ) ) ) ).

% card_of_Times_infinite_simps(1)
tff(fact_3750_card__of__Times__infinite,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ( ( B2 != bot_bot(set(C)) )
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(C,B))
         => ( member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(product_prod(B,C),B))
            & member(product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,B2,aTP_Lamp_ho(set(B),fun(C,set(B)),A4)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(product_prod(C,B),B)) ) ) ) ) ).

% card_of_Times_infinite
tff(fact_3751_card__of__image,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,B),A4: set(C)] : member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(set(C),set(B),image2(C,B,Fa),A4))),bNF_Ca6860139660246222851ard_of(C,A4)),bNF_Wellorder_ordLeq(B,C)) ).

% card_of_image
tff(fact_3752_card__of__empty3,axiom,
    ! [C: $tType,B: $tType,A4: set(B)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,bot_bot(set(C)))),bNF_Wellorder_ordLeq(B,C))
     => ( A4 = bot_bot(set(B)) ) ) ).

% card_of_empty3
tff(fact_3753_card__of__empty,axiom,
    ! [C: $tType,B: $tType,A4: set(C)] : member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),bNF_Ca6860139660246222851ard_of(C,A4)),bNF_Wellorder_ordLeq(B,C)) ).

% card_of_empty
tff(fact_3754_card__of__ordLeq__finite,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C))
     => ( aa(set(C),$o,finite_finite(C),B2)
       => aa(set(B),$o,finite_finite(B),A4) ) ) ).

% card_of_ordLeq_finite
tff(fact_3755_card__of__ordLeq__infinite,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C))
     => ( ~ aa(set(B),$o,finite_finite(B),A4)
       => ~ aa(set(C),$o,finite_finite(C),B2) ) ) ).

% card_of_ordLeq_infinite
tff(fact_3756_card__of__mono1,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Wellorder_ordLeq(B,B)) ) ).

% card_of_mono1
tff(fact_3757_card__of__empty__ordIso,axiom,
    ! [C: $tType,B: $tType] : member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B)))),bNF_Ca6860139660246222851ard_of(C,bot_bot(set(C)))),bNF_Wellorder_ordIso(B,C)) ).

% card_of_empty_ordIso
tff(fact_3758_card__of__empty2,axiom,
    ! [C: $tType,B: $tType,A4: set(B)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,bot_bot(set(C)))),bNF_Wellorder_ordIso(B,C))
     => ( A4 = bot_bot(set(B)) ) ) ).

% card_of_empty2
tff(fact_3759_card__of__ordIso__finite,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordIso(B,C))
     => ( aa(set(B),$o,finite_finite(B),A4)
      <=> aa(set(C),$o,finite_finite(C),B2) ) ) ).

% card_of_ordIso_finite
tff(fact_3760_card__of__mono2,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,field2(B,R3))),bNF_Ca6860139660246222851ard_of(C,field2(C,R4))),bNF_Wellorder_ordLeq(B,C)) ) ).

% card_of_mono2
tff(fact_3761_card__of__cong,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,field2(B,R3))),bNF_Ca6860139660246222851ard_of(C,field2(C,R4))),bNF_Wellorder_ordIso(B,C)) ) ).

% card_of_cong
tff(fact_3762_card__of__ordLeqI,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),A4: set(B),B2: set(C)] :
      ( inj_on(B,C,Fa,A4)
     => ( ! [A8: B] :
            ( member(B,A8,A4)
           => member(C,aa(B,C,Fa,A8),B2) )
       => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C)) ) ) ).

% card_of_ordLeqI
tff(fact_3763_card__of__least,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( order_well_order_on(B,A4,R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,B)) ) ).

% card_of_least
tff(fact_3764_BNF__Cardinal__Order__Relation_OordLess__Field,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
     => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,field2(B,R3))),R4),bNF_We4044943003108391690rdLess(B,C)) ) ).

% BNF_Cardinal_Order_Relation.ordLess_Field
tff(fact_3765_type__copy__set__bd,axiom,
    ! [B: $tType,E: $tType,D: $tType,C: $tType,S2: fun(B,set(C)),Bd: set(product_prod(D,D)),Rep: fun(E,B),X: E] :
      ( ! [Y2: B] : member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),S2,Y2))),Bd),bNF_Wellorder_ordLeq(C,D))
     => member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),bNF_Ca6860139660246222851ard_of(C,aa(E,set(C),aa(fun(E,B),fun(E,set(C)),aa(fun(B,set(C)),fun(fun(E,B),fun(E,set(C))),comp(B,set(C),E),S2),Rep),X))),Bd),bNF_Wellorder_ordLeq(C,D)) ) ).

% type_copy_set_bd
tff(fact_3766_card__of__ordLeq2,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( ? [G4: fun(C,B)] : ( aa(set(C),set(B),image2(C,B,G4),B2) = A4 )
      <=> member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C)) ) ) ).

% card_of_ordLeq2
tff(fact_3767_surj__imp__ordLeq,axiom,
    ! [C: $tType,B: $tType,B2: set(B),Fa: fun(C,B),A4: set(C)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),aa(set(C),set(B),image2(C,B,Fa),A4))
     => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Ca6860139660246222851ard_of(C,A4)),bNF_Wellorder_ordLeq(B,C)) ) ).

% surj_imp_ordLeq
tff(fact_3768_card__of__singl__ordLeq,axiom,
    ! [B: $tType,C: $tType,A4: set(B),Ba: C] :
      ( ( A4 != bot_bot(set(B)) )
     => member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,aa(set(C),set(C),insert2(C,Ba),bot_bot(set(C))))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(C,B)) ) ).

% card_of_singl_ordLeq
tff(fact_3769_card__of__ordLess2,axiom,
    ! [B: $tType,C: $tType,B2: set(B),A4: set(C)] :
      ( ( B2 != bot_bot(set(B)) )
     => ( ~ ? [F10: fun(C,B)] : ( aa(set(C),set(B),image2(C,B,F10),A4) = B2 )
      <=> member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,A4)),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_We4044943003108391690rdLess(C,B)) ) ) ).

% card_of_ordLess2
tff(fact_3770_internalize__card__of__ordLeq2,axiom,
    ! [B: $tType,C: $tType,A4: set(B),C3: set(C)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,C3)),bNF_Wellorder_ordLeq(B,C))
    <=> ? [B7: set(C)] :
          ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B7),C3)
          & member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B7)),bNF_Wellorder_ordIso(B,C))
          & member(product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),fun(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),product_Pair(set(product_prod(C,C)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(C,B7)),bNF_Ca6860139660246222851ard_of(C,C3)),bNF_Wellorder_ordLeq(C,C)) ) ) ).

% internalize_card_of_ordLeq2
tff(fact_3771_card__of__Field__ordLess,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,field2(B,R3))),R3),bNF_Wellorder_ordLeq(B,B)) ) ).

% card_of_Field_ordLess
tff(fact_3772_card__of__Func__UNIV,axiom,
    ! [C: $tType,B: $tType,B2: set(C)] : member(product_prod(set(product_prod(fun(B,C),fun(B,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(B,C),fun(B,C))),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(B,C),fun(B,C))),fun(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(fun(B,C),fun(B,C))),set(product_prod(fun(B,C),fun(B,C))))),product_Pair(set(product_prod(fun(B,C),fun(B,C))),set(product_prod(fun(B,C),fun(B,C)))),bNF_Ca6860139660246222851ard_of(fun(B,C),bNF_Wellorder_Func(B,C,top_top(set(B)),B2))),bNF_Ca6860139660246222851ard_of(fun(B,C),aa(fun(fun(B,C),$o),set(fun(B,C)),collect(fun(B,C)),aTP_Lamp_nl(set(C),fun(fun(B,C),$o),B2)))),bNF_Wellorder_ordIso(fun(B,C),fun(B,C))) ).

% card_of_Func_UNIV
tff(fact_3773_ordLeq__Times__mono1,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),C3: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),fun(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D))))),product_Pair(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),bNF_Ca6860139660246222851ard_of(product_prod(B,D),product_Sigma(B,D,field2(B,R3),aTP_Lamp_nj(set(D),fun(B,set(D)),C3)))),bNF_Ca6860139660246222851ard_of(product_prod(C,D),product_Sigma(C,D,field2(C,R4),aTP_Lamp_jn(set(D),fun(C,set(D)),C3)))),bNF_Wellorder_ordLeq(product_prod(B,D),product_prod(C,D))) ) ).

% ordLeq_Times_mono1
tff(fact_3774_ordLeq__Times__mono2,axiom,
    ! [C: $tType,B: $tType,D: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),A4: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,B),product_prod(D,B))),fun(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C))))),product_Pair(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),bNF_Ca6860139660246222851ard_of(product_prod(D,B),product_Sigma(D,B,A4,aTP_Lamp_nm(set(product_prod(B,B)),fun(D,set(B)),R3)))),bNF_Ca6860139660246222851ard_of(product_prod(D,C),product_Sigma(D,C,A4,aTP_Lamp_nn(set(product_prod(C,C)),fun(D,set(C)),R4)))),bNF_Wellorder_ordLeq(product_prod(D,B),product_prod(D,C))) ) ).

% ordLeq_Times_mono2
tff(fact_3775_card__of__ordLeq,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( ? [F10: fun(B,C)] :
          ( inj_on(B,C,F10,A4)
          & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,F10),A4)),B2) )
    <=> member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C)) ) ).

% card_of_ordLeq
tff(fact_3776_internalize__card__of__ordLeq,axiom,
    ! [B: $tType,C: $tType,A4: set(B),R3: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,C))
    <=> ? [B7: set(C)] :
          ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B7),field2(C,R3))
          & member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B7)),bNF_Wellorder_ordIso(B,C))
          & member(product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),fun(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),product_Pair(set(product_prod(C,C)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(C,B7)),R3),bNF_Wellorder_ordLeq(C,C)) ) ) ).

% internalize_card_of_ordLeq
tff(fact_3777_card__of__ordLess,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ~ ? [F10: fun(B,C)] :
            ( inj_on(B,C,F10,A4)
            & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,F10),A4)),B2) )
    <=> member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_We4044943003108391690rdLess(C,B)) ) ).

% card_of_ordLess
tff(fact_3778_card__of__UNION__ordLeq__infinite,axiom,
    ! [C: $tType,B: $tType,D: $tType,B2: set(B),I4: set(C),A4: fun(C,set(D))] :
      ( ~ aa(set(B),$o,finite_finite(B),B2)
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,I4)),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Wellorder_ordLeq(C,B))
       => ( ! [X2: C] :
              ( member(C,X2,I4)
             => member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),A4,X2))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Wellorder_ordLeq(D,B)) )
         => member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A4),I4)))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Wellorder_ordLeq(D,B)) ) ) ) ).

% card_of_UNION_ordLeq_infinite
tff(fact_3779_regularCard__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca7133664381575040944arCard(B,R3)
    <=> ! [K6: set(B)] :
          ( ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),K6),field2(B,R3))
            & bNF_Ca7293521722713021262ofinal(B,K6,R3) )
         => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,K6)),R3),bNF_Wellorder_ordIso(B,B)) ) ) ).

% regularCard_def
tff(fact_3780_card__of__ordIso__subst,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( ( A4 = B2 )
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Wellorder_ordIso(B,B)) ) ).

% card_of_ordIso_subst
tff(fact_3781_Card__order__iff__Restr__underS,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
      <=> ! [X4: B] :
            ( member(B,X4,field2(B,R3))
           => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,order_underS(B,R3,X4),aa(B,fun(B,set(B)),aTP_Lamp_nc(set(product_prod(B,B)),fun(B,fun(B,set(B))),R3),X4)))),bNF_Ca6860139660246222851ard_of(B,field2(B,R3))),bNF_We4044943003108391690rdLess(B,B)) ) ) ) ).

% Card_order_iff_Restr_underS
tff(fact_3782_card__of__Plus__Times__aux,axiom,
    ! [C: $tType,B: $tType,A1: B,A22: B,A4: set(B),B2: set(C)] :
      ( ( ( A1 != A22 )
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,A1),aa(set(B),set(B),insert2(B,A22),bot_bot(set(B))))),A4) )
     => ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C))
       => member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,B2))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))),bNF_Wellorder_ordLeq(sum_sum(B,C),product_prod(B,C))) ) ) ).

% card_of_Plus_Times_aux
tff(fact_3783_Card__order__Plus1,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),B2: set(C)] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),R3),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,field2(B,R3),B2))),bNF_Wellorder_ordLeq(B,sum_sum(B,C))) ) ).

% Card_order_Plus1
tff(fact_3784_Card__order__Plus2,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),A4: set(C)] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),R3),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,A4,field2(B,R3)))),bNF_Wellorder_ordLeq(B,sum_sum(C,B))) ) ).

% Card_order_Plus2
tff(fact_3785_card__of__Plus__commute,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] : member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,B2))),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,B2,A4))),bNF_Wellorder_ordIso(sum_sum(B,C),sum_sum(C,B))) ).

% card_of_Plus_commute
tff(fact_3786_card__of__Plus__assoc,axiom,
    ! [D: $tType,C: $tType,B: $tType,A4: set(B),B2: set(C),C3: set(D)] : member(product_prod(set(product_prod(sum_sum(sum_sum(B,C),D),sum_sum(sum_sum(B,C),D))),set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D))))),aa(set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D)))),product_prod(set(product_prod(sum_sum(sum_sum(B,C),D),sum_sum(sum_sum(B,C),D))),set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D))))),aa(set(product_prod(sum_sum(sum_sum(B,C),D),sum_sum(sum_sum(B,C),D))),fun(set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D)))),product_prod(set(product_prod(sum_sum(sum_sum(B,C),D),sum_sum(sum_sum(B,C),D))),set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D)))))),product_Pair(set(product_prod(sum_sum(sum_sum(B,C),D),sum_sum(sum_sum(B,C),D))),set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D))))),bNF_Ca6860139660246222851ard_of(sum_sum(sum_sum(B,C),D),sum_Plus(sum_sum(B,C),D,sum_Plus(B,C,A4,B2),C3))),bNF_Ca6860139660246222851ard_of(sum_sum(B,sum_sum(C,D)),sum_Plus(B,sum_sum(C,D),A4,sum_Plus(C,D,B2,C3)))),bNF_Wellorder_ordIso(sum_sum(sum_sum(B,C),D),sum_sum(B,sum_sum(C,D)))) ).

% card_of_Plus_assoc
tff(fact_3787_card__of__Plus2,axiom,
    ! [C: $tType,B: $tType,B2: set(B),A4: set(C)] : member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Ca6860139660246222851ard_of(B,B2)),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,A4,B2))),bNF_Wellorder_ordLeq(B,sum_sum(C,B))) ).

% card_of_Plus2
tff(fact_3788_card__of__Plus1,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] : member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,B2))),bNF_Wellorder_ordLeq(B,sum_sum(B,C))) ).

% card_of_Plus1
tff(fact_3789_card__of__Times__Plus__distrib,axiom,
    ! [D: $tType,C: $tType,B: $tType,A4: set(B),B2: set(C),C3: set(D)] : member(product_prod(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D))))),aa(set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))),product_prod(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D))))),aa(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),fun(set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))),product_prod(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))))),product_Pair(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D))))),bNF_Ca6860139660246222851ard_of(product_prod(B,sum_sum(C,D)),product_Sigma(B,sum_sum(C,D),A4,aa(set(D),fun(B,set(sum_sum(C,D))),aTP_Lamp_no(set(C),fun(set(D),fun(B,set(sum_sum(C,D)))),B2),C3)))),bNF_Ca6860139660246222851ard_of(sum_sum(product_prod(B,C),product_prod(B,D)),sum_Plus(product_prod(B,C),product_prod(B,D),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)),product_Sigma(B,D,A4,aTP_Lamp_nj(set(D),fun(B,set(D)),C3))))),bNF_Wellorder_ordIso(product_prod(B,sum_sum(C,D)),sum_sum(product_prod(B,C),product_prod(B,D)))) ).

% card_of_Times_Plus_distrib
tff(fact_3790_Card__order__Plus__infinite,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),P2: set(product_prod(C,C))] :
      ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),P2),R3),bNF_Wellorder_ordLeq(C,B))
         => ( member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,field2(B,R3),field2(C,P2)))),R3),bNF_Wellorder_ordIso(sum_sum(B,C),B))
            & member(product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,field2(C,P2),field2(B,R3)))),R3),bNF_Wellorder_ordIso(sum_sum(C,B),B)) ) ) ) ) ).

% Card_order_Plus_infinite
tff(fact_3791_card__of__Plus__Times__bool,axiom,
    ! [B: $tType,A4: set(B)] : member(product_prod(set(product_prod(sum_sum(B,B),sum_sum(B,B))),set(product_prod(product_prod(B,$o),product_prod(B,$o)))),aa(set(product_prod(product_prod(B,$o),product_prod(B,$o))),product_prod(set(product_prod(sum_sum(B,B),sum_sum(B,B))),set(product_prod(product_prod(B,$o),product_prod(B,$o)))),aa(set(product_prod(sum_sum(B,B),sum_sum(B,B))),fun(set(product_prod(product_prod(B,$o),product_prod(B,$o))),product_prod(set(product_prod(sum_sum(B,B),sum_sum(B,B))),set(product_prod(product_prod(B,$o),product_prod(B,$o))))),product_Pair(set(product_prod(sum_sum(B,B),sum_sum(B,B))),set(product_prod(product_prod(B,$o),product_prod(B,$o)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,B),sum_Plus(B,B,A4,A4))),bNF_Ca6860139660246222851ard_of(product_prod(B,$o),product_Sigma(B,$o,A4,aTP_Lamp_np(B,set($o))))),bNF_Wellorder_ordIso(sum_sum(B,B),product_prod(B,$o))) ).

% card_of_Plus_Times_bool
tff(fact_3792_Card__order__trans,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X: B,Y: B,Z2: B] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( ( X != Y )
       => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
         => ( ( Y != Z2 )
           => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),Z2),R3)
             => ( ( X != Z2 )
                & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),R3) ) ) ) ) ) ) ).

% Card_order_trans
tff(fact_3793_ordLeq__refl,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),R3),bNF_Wellorder_ordLeq(B,B)) ) ).

% ordLeq_refl
tff(fact_3794_ordIso__refl,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),R3),bNF_Wellorder_ordIso(B,B)) ) ).

% ordIso_refl
tff(fact_3795_card__order__on__ordIso,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B)),R4: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,A4,R3)
     => ( bNF_Ca8970107618336181345der_on(B,A4,R4)
       => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),R4),bNF_Wellorder_ordIso(B,B)) ) ) ).

% card_order_on_ordIso
tff(fact_3796_card__of__Plus__empty2,axiom,
    ! [C: $tType,B: $tType,A4: set(B)] : member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,bot_bot(set(C)),A4))),bNF_Wellorder_ordIso(B,sum_sum(C,B))) ).

% card_of_Plus_empty2
tff(fact_3797_card__of__Plus__empty1,axiom,
    ! [C: $tType,B: $tType,A4: set(B)] : member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,bot_bot(set(C))))),bNF_Wellorder_ordIso(B,sum_sum(B,C))) ).

% card_of_Plus_empty1
tff(fact_3798_card__of__Un__Plus__ordLeq,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,B),sum_sum(B,B)))),aa(set(product_prod(sum_sum(B,B),sum_sum(B,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,B),sum_sum(B,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(B,B),sum_sum(B,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,B),sum_sum(B,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(B,B),sum_sum(B,B)))),bNF_Ca6860139660246222851ard_of(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))),bNF_Ca6860139660246222851ard_of(sum_sum(B,B),sum_Plus(B,B,A4,B2))),bNF_Wellorder_ordLeq(B,sum_sum(B,B))) ).

% card_of_Un_Plus_ordLeq
tff(fact_3799_card__of__Plus__ordLeq__infinite__Field,axiom,
    ! [B: $tType,D: $tType,C: $tType,R3: set(product_prod(B,B)),A4: set(C),B2: set(D)] :
      ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,A4)),R3),bNF_Wellorder_ordLeq(C,B))
       => ( member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,B2)),R3),bNF_Wellorder_ordLeq(D,B))
         => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
           => member(product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(sum_sum(C,D),sum_Plus(C,D,A4,B2))),R3),bNF_Wellorder_ordLeq(sum_sum(C,D),B)) ) ) ) ) ).

% card_of_Plus_ordLeq_infinite_Field
tff(fact_3800_card__of__Plus__ordLess__infinite__Field,axiom,
    ! [B: $tType,D: $tType,C: $tType,R3: set(product_prod(B,B)),A4: set(C),B2: set(D)] :
      ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,A4)),R3),bNF_We4044943003108391690rdLess(C,B))
         => ( member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,B2)),R3),bNF_We4044943003108391690rdLess(D,B))
           => member(product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(sum_sum(C,D),sum_Plus(C,D,A4,B2))),R3),bNF_We4044943003108391690rdLess(sum_sum(C,D),B)) ) ) ) ) ).

% card_of_Plus_ordLess_infinite_Field
tff(fact_3801_infinite__Card__order__limit,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
       => ( member(B,A3,field2(B,R3))
         => ? [X2: B] :
              ( member(B,X2,field2(B,R3))
              & ( A3 != X2 )
              & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),X2),R3) ) ) ) ) ).

% infinite_Card_order_limit
tff(fact_3802_Card__order__ordIso,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R3),bNF_Wellorder_ordIso(C,B))
       => bNF_Ca8970107618336181345der_on(C,field2(C,R4),R4) ) ) ).

% Card_order_ordIso
tff(fact_3803_Card__order__ordIso2,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
       => bNF_Ca8970107618336181345der_on(C,field2(C,R4),R4) ) ) ).

% Card_order_ordIso2
tff(fact_3804_card__of__unique,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,A4,R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(B,B)) ) ).

% card_of_unique
tff(fact_3805_card__order__on__def,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,A4,R3)
    <=> ( order_well_order_on(B,A4,R3)
        & ! [R9: set(product_prod(B,B))] :
            ( order_well_order_on(B,A4,R9)
           => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),R9),bNF_Wellorder_ordLeq(B,B)) ) ) ) ).

% card_order_on_def
tff(fact_3806_ordLeq__Plus__mono,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),P2: set(product_prod(D,D)),P7: set(product_prod(E,E))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),P2),P7),bNF_Wellorder_ordLeq(D,E))
       => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,field2(B,R3),field2(D,P2)))),bNF_Ca6860139660246222851ard_of(sum_sum(C,E),sum_Plus(C,E,field2(C,R4),field2(E,P7)))),bNF_Wellorder_ordLeq(sum_sum(B,D),sum_sum(C,E))) ) ) ).

% ordLeq_Plus_mono
tff(fact_3807_ordLeq__Plus__mono1,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),C3: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,field2(B,R3),C3))),bNF_Ca6860139660246222851ard_of(sum_sum(C,D),sum_Plus(C,D,field2(C,R4),C3))),bNF_Wellorder_ordLeq(sum_sum(B,D),sum_sum(C,D))) ) ).

% ordLeq_Plus_mono1
tff(fact_3808_ordLeq__Plus__mono2,axiom,
    ! [C: $tType,B: $tType,D: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),A4: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,B),sum_sum(D,B))),fun(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C))))),product_Pair(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(D,B),sum_Plus(D,B,A4,field2(B,R3)))),bNF_Ca6860139660246222851ard_of(sum_sum(D,C),sum_Plus(D,C,A4,field2(C,R4)))),bNF_Wellorder_ordLeq(sum_sum(D,B),sum_sum(D,C))) ) ).

% ordLeq_Plus_mono2
tff(fact_3809_ordIso__Plus__cong,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),P2: set(product_prod(D,D)),P7: set(product_prod(E,E))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),P2),P7),bNF_Wellorder_ordIso(D,E))
       => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,field2(B,R3),field2(D,P2)))),bNF_Ca6860139660246222851ard_of(sum_sum(C,E),sum_Plus(C,E,field2(C,R4),field2(E,P7)))),bNF_Wellorder_ordIso(sum_sum(B,D),sum_sum(C,E))) ) ) ).

% ordIso_Plus_cong
tff(fact_3810_ordIso__Plus__cong1,axiom,
    ! [C: $tType,D: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),C3: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,field2(B,R3),C3))),bNF_Ca6860139660246222851ard_of(sum_sum(C,D),sum_Plus(C,D,field2(C,R4),C3))),bNF_Wellorder_ordIso(sum_sum(B,D),sum_sum(C,D))) ) ).

% ordIso_Plus_cong1
tff(fact_3811_ordIso__Plus__cong2,axiom,
    ! [C: $tType,B: $tType,D: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),A4: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,B),sum_sum(D,B))),fun(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C))))),product_Pair(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(D,B),sum_Plus(D,B,A4,field2(B,R3)))),bNF_Ca6860139660246222851ard_of(sum_sum(D,C),sum_Plus(D,C,A4,field2(C,R4)))),bNF_Wellorder_ordIso(sum_sum(D,B),sum_sum(D,C))) ) ).

% ordIso_Plus_cong2
tff(fact_3812_card__of__Plus__mono,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,A4: set(B),B2: set(C),C3: set(D),D4: set(E)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),bNF_Ca6860139660246222851ard_of(D,C3)),bNF_Ca6860139660246222851ard_of(E,D4)),bNF_Wellorder_ordLeq(D,E))
       => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,A4,C3))),bNF_Ca6860139660246222851ard_of(sum_sum(C,E),sum_Plus(C,E,B2,D4))),bNF_Wellorder_ordLeq(sum_sum(B,D),sum_sum(C,E))) ) ) ).

% card_of_Plus_mono
tff(fact_3813_card__of__Plus__mono1,axiom,
    ! [C: $tType,D: $tType,B: $tType,A4: set(B),B2: set(C),C3: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,A4,C3))),bNF_Ca6860139660246222851ard_of(sum_sum(C,D),sum_Plus(C,D,B2,C3))),bNF_Wellorder_ordLeq(sum_sum(B,D),sum_sum(C,D))) ) ).

% card_of_Plus_mono1
tff(fact_3814_card__of__Plus__mono2,axiom,
    ! [C: $tType,B: $tType,D: $tType,A4: set(B),B2: set(C),C3: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,B),sum_sum(D,B))),fun(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C))))),product_Pair(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(D,B),sum_Plus(D,B,C3,A4))),bNF_Ca6860139660246222851ard_of(sum_sum(D,C),sum_Plus(D,C,C3,B2))),bNF_Wellorder_ordLeq(sum_sum(D,B),sum_sum(D,C))) ) ).

% card_of_Plus_mono2
tff(fact_3815_card__of__Plus__cong,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,A4: set(B),B2: set(C),C3: set(D),D4: set(E)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordIso(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),bNF_Ca6860139660246222851ard_of(D,C3)),bNF_Ca6860139660246222851ard_of(E,D4)),bNF_Wellorder_ordIso(D,E))
       => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,A4,C3))),bNF_Ca6860139660246222851ard_of(sum_sum(C,E),sum_Plus(C,E,B2,D4))),bNF_Wellorder_ordIso(sum_sum(B,D),sum_sum(C,E))) ) ) ).

% card_of_Plus_cong
tff(fact_3816_card__of__Plus__cong1,axiom,
    ! [C: $tType,D: $tType,B: $tType,A4: set(B),B2: set(C),C3: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,D),sum_Plus(B,D,A4,C3))),bNF_Ca6860139660246222851ard_of(sum_sum(C,D),sum_Plus(C,D,B2,C3))),bNF_Wellorder_ordIso(sum_sum(B,D),sum_sum(C,D))) ) ).

% card_of_Plus_cong1
tff(fact_3817_card__of__Plus__cong2,axiom,
    ! [C: $tType,B: $tType,D: $tType,A4: set(B),B2: set(C),C3: set(D)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,B),sum_sum(D,B))),fun(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C))))),product_Pair(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(D,B),sum_Plus(D,B,C3,A4))),bNF_Ca6860139660246222851ard_of(sum_sum(D,C),sum_Plus(D,C,C3,B2))),bNF_Wellorder_ordIso(sum_sum(D,B),sum_sum(D,C))) ) ).

% card_of_Plus_cong2
tff(fact_3818_Card__order__Times2,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),A4: set(C)] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( ( A4 != bot_bot(set(C)) )
       => member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(C,B),product_prod(C,B)))),R3),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,A4,aTP_Lamp_nq(set(product_prod(B,B)),fun(C,set(B)),R3)))),bNF_Wellorder_ordLeq(B,product_prod(C,B))) ) ) ).

% Card_order_Times2
tff(fact_3819_Card__order__Times1,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),B2: set(C)] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( ( B2 != bot_bot(set(C)) )
       => member(product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(B,B)),set(product_prod(product_prod(B,C),product_prod(B,C)))),R3),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,field2(B,R3),aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))),bNF_Wellorder_ordLeq(B,product_prod(B,C))) ) ) ).

% Card_order_Times1
tff(fact_3820_Card__order__Times__same__infinite,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
       => member(product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,B),product_prod(B,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(B,B),product_Sigma(B,B,field2(B,R3),aTP_Lamp_ig(set(product_prod(B,B)),fun(B,set(B)),R3)))),R3),bNF_Wellorder_ordLeq(product_prod(B,B),B)) ) ) ).

% Card_order_Times_same_infinite
tff(fact_3821_Card__order__Pow,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(B,B)),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),R3),bNF_Ca6860139660246222851ard_of(set(B),pow(B,field2(B,R3)))),bNF_We4044943003108391690rdLess(B,set(B))) ) ).

% Card_order_Pow
tff(fact_3822_Card__order__iff__ordLeq__card__of,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
    <=> member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),bNF_Ca6860139660246222851ard_of(B,field2(B,R3))),bNF_Wellorder_ordLeq(B,B)) ) ).

% Card_order_iff_ordLeq_card_of
tff(fact_3823_card__of__Field__ordIso,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,field2(B,R3))),R3),bNF_Wellorder_ordIso(B,B)) ) ).

% card_of_Field_ordIso
tff(fact_3824_Card__order__iff__ordIso__card__of,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
    <=> member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),bNF_Ca6860139660246222851ard_of(B,field2(B,R3))),bNF_Wellorder_ordIso(B,B)) ) ).

% Card_order_iff_ordIso_card_of
tff(fact_3825_ordIso__card__of__imp__Card__order,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),A4: set(C)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),bNF_Ca6860139660246222851ard_of(C,A4)),bNF_Wellorder_ordIso(B,C))
     => bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) ) ).

% ordIso_card_of_imp_Card_order
tff(fact_3826_card__of__Plus__infinite2,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(C,B))
       => member(product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,B2,A4))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(sum_sum(C,B),B)) ) ) ).

% card_of_Plus_infinite2
tff(fact_3827_card__of__Plus__infinite1,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(C,B))
       => member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,B2))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(sum_sum(B,C),B)) ) ) ).

% card_of_Plus_infinite1
tff(fact_3828_card__of__Plus__infinite,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(C,B))
       => ( member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,B2))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(sum_sum(B,C),B))
          & member(product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(sum_sum(C,B),sum_Plus(C,B,B2,A4))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordIso(sum_sum(C,B),B)) ) ) ) ).

% card_of_Plus_infinite
tff(fact_3829_card__of__Plus__ordLess__infinite,axiom,
    ! [B: $tType,D: $tType,C: $tType,C3: set(B),A4: set(C),B2: set(D)] :
      ( ~ aa(set(B),$o,finite_finite(B),C3)
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,A4)),bNF_Ca6860139660246222851ard_of(B,C3)),bNF_We4044943003108391690rdLess(C,B))
       => ( member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,B2)),bNF_Ca6860139660246222851ard_of(B,C3)),bNF_We4044943003108391690rdLess(D,B))
         => member(product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(sum_sum(C,D),sum_Plus(C,D,A4,B2))),bNF_Ca6860139660246222851ard_of(B,C3)),bNF_We4044943003108391690rdLess(sum_sum(C,D),B)) ) ) ) ).

% card_of_Plus_ordLess_infinite
tff(fact_3830_card__of__Plus__Times,axiom,
    ! [C: $tType,B: $tType,A1: B,A22: B,A4: set(B),B12: C,B23: C,B2: set(C)] :
      ( ( ( A1 != A22 )
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,A1),aa(set(B),set(B),insert2(B,A22),bot_bot(set(B))))),A4) )
     => ( ( ( B12 != B23 )
          & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(C),set(C),insert2(C,B12),aa(set(C),set(C),insert2(C,B23),bot_bot(set(C))))),B2) )
       => member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(product_prod(B,C),product_prod(B,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,B2))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)))),bNF_Wellorder_ordLeq(sum_sum(B,C),product_prod(B,C))) ) ) ).

% card_of_Plus_Times
tff(fact_3831_exists__minim__Card__order,axiom,
    ! [B: $tType,R: set(set(product_prod(B,B)))] :
      ( ( R != bot_bot(set(set(product_prod(B,B)))) )
     => ( ! [X2: set(product_prod(B,B))] :
            ( member(set(product_prod(B,B)),X2,R)
           => bNF_Ca8970107618336181345der_on(B,field2(B,X2),X2) )
       => ? [X2: set(product_prod(B,B))] :
            ( member(set(product_prod(B,B)),X2,R)
            & ! [Xa3: set(product_prod(B,B))] :
                ( member(set(product_prod(B,B)),Xa3,R)
               => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),X2),Xa3),bNF_Wellorder_ordLeq(B,B)) ) ) ) ) ).

% exists_minim_Card_order
tff(fact_3832_Card__order__empty,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,bot_bot(set(C)))),R3),bNF_Wellorder_ordLeq(C,B)) ) ).

% Card_order_empty
tff(fact_3833_card__of__ordIso__finite__Field,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),A4: set(C)] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),bNF_Ca6860139660246222851ard_of(C,A4)),bNF_Wellorder_ordIso(B,C))
       => ( aa(set(B),$o,finite_finite(B),field2(B,R3))
        <=> aa(set(C),$o,finite_finite(C),A4) ) ) ) ).

% card_of_ordIso_finite_Field
tff(fact_3834_card__of__underS,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( member(B,A3,field2(B,R3))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,order_underS(B,R3,A3))),R3),bNF_We4044943003108391690rdLess(B,B)) ) ) ).

% card_of_underS
tff(fact_3835_regularCard__UNION,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),As8: fun(B,set(C)),B2: set(C)] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( bNF_Ca7133664381575040944arCard(B,R3)
       => ( bNF_Ca3754400796208372196lChain(B,set(C),R3,As8)
         => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(B),set(set(C)),image2(B,set(C),As8),field2(B,R3))))
           => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),R3),bNF_We4044943003108391690rdLess(C,B))
             => ? [X2: B] :
                  ( member(B,X2,field2(B,R3))
                  & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(B,set(C),As8,X2)) ) ) ) ) ) ) ).

% regularCard_UNION
tff(fact_3836_Card__order__singl__ordLeq,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),Ba: C] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( ( field2(B,R3) != bot_bot(set(B)) )
       => member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,aa(set(C),set(C),insert2(C,Ba),bot_bot(set(C))))),R3),bNF_Wellorder_ordLeq(C,B)) ) ) ).

% Card_order_singl_ordLeq
tff(fact_3837_card__of__Un__ordLeq__infinite__Field,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),A4: set(C),B2: set(C)] :
      ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,A4)),R3),bNF_Wellorder_ordLeq(C,B))
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),R3),bNF_Wellorder_ordLeq(C,B))
         => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
           => member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A4),B2))),R3),bNF_Wellorder_ordLeq(C,B)) ) ) ) ) ).

% card_of_Un_ordLeq_infinite_Field
tff(fact_3838_card__of__empty1,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B))] :
      ( ( order_well_order_on(B,field2(B,R3),R3)
        | bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,bot_bot(set(C)))),R3),bNF_Wellorder_ordLeq(C,B)) ) ).

% card_of_empty1
tff(fact_3839_Card__order__Times__infinite,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),P2: set(product_prod(C,C))] :
      ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => ( ( field2(C,P2) != bot_bot(set(C)) )
         => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),P2),R3),bNF_Wellorder_ordLeq(C,B))
           => ( member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(B,C),product_Sigma(B,C,field2(B,R3),aTP_Lamp_nr(set(product_prod(C,C)),fun(B,set(C)),P2)))),R3),bNF_Wellorder_ordIso(product_prod(B,C),B))
              & member(product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,B),product_prod(C,B))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,B),product_Sigma(C,B,field2(C,P2),aTP_Lamp_nq(set(product_prod(B,B)),fun(C,set(B)),R3)))),R3),bNF_Wellorder_ordIso(product_prod(C,B),B)) ) ) ) ) ) ).

% Card_order_Times_infinite
tff(fact_3840_card__of__Sigma__ordLeq__infinite__Field,axiom,
    ! [B: $tType,D: $tType,C: $tType,R3: set(product_prod(B,B)),I4: set(C),A4: fun(C,set(D))] :
      ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,I4)),R3),bNF_Wellorder_ordLeq(C,B))
         => ( ! [X2: C] :
                ( member(C,X2,I4)
               => member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),A4,X2))),R3),bNF_Wellorder_ordLeq(D,B)) )
           => member(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,D),product_Sigma(C,D,I4,A4))),R3),bNF_Wellorder_ordLeq(product_prod(C,D),B)) ) ) ) ) ).

% card_of_Sigma_ordLeq_infinite_Field
tff(fact_3841_card__of__Times__ordLeq__infinite__Field,axiom,
    ! [B: $tType,D: $tType,C: $tType,R3: set(product_prod(B,B)),A4: set(C),B2: set(D)] :
      ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,A4)),R3),bNF_Wellorder_ordLeq(C,B))
       => ( member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,B2)),R3),bNF_Wellorder_ordLeq(D,B))
         => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
           => member(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(product_prod(C,D),product_Sigma(C,D,A4,aTP_Lamp_jn(set(D),fun(C,set(D)),B2)))),R3),bNF_Wellorder_ordLeq(product_prod(C,D),B)) ) ) ) ) ).

% card_of_Times_ordLeq_infinite_Field
tff(fact_3842_card__of__UNION__ordLeq__infinite__Field,axiom,
    ! [C: $tType,B: $tType,D: $tType,R3: set(product_prod(B,B)),I4: set(C),A4: fun(C,set(D))] :
      ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,I4)),R3),bNF_Wellorder_ordLeq(C,B))
         => ( ! [X2: C] :
                ( member(C,X2,I4)
               => member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),A4,X2))),R3),bNF_Wellorder_ordLeq(D,B)) )
           => member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A4),I4)))),R3),bNF_Wellorder_ordLeq(D,B)) ) ) ) ) ).

% card_of_UNION_ordLeq_infinite_Field
tff(fact_3843_Plus__eq__empty__conv,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ( sum_Plus(B,C,A4,B2) = bot_bot(set(sum_sum(B,C))) )
    <=> ( ( A4 = bot_bot(set(B)) )
        & ( B2 = bot_bot(set(C)) ) ) ) ).

% Plus_eq_empty_conv
tff(fact_3844_ex__toCard__pred,axiom,
    ! [C: $tType,B: $tType,A4: set(B),R3: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,C))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3)
       => ? [X_1: fun(B,C)] : bNF_Gr1419584066657907630d_pred(B,C,A4,R3,X_1) ) ) ).

% ex_toCard_pred
tff(fact_3845_cardSuc__UNION,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),As8: fun(set(B),set(C)),B2: set(C)] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( ~ aa(set(B),$o,finite_finite(B),field2(B,R3))
       => ( bNF_Ca3754400796208372196lChain(set(B),set(C),bNF_Ca8387033319878233205ardSuc(B,R3),As8)
         => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(set(B)),set(set(C)),image2(set(B),set(C),As8),field2(set(B),bNF_Ca8387033319878233205ardSuc(B,R3)))))
           => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),R3),bNF_Wellorder_ordLeq(C,B))
             => ? [X2: set(B)] :
                  ( member(set(B),X2,field2(set(B),bNF_Ca8387033319878233205ardSuc(B,R3)))
                  & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(set(B),set(C),As8,X2)) ) ) ) ) ) ) ).

% cardSuc_UNION
tff(fact_3846_isCardSuc__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(set(B),set(B)))] :
      ( bNF_Ca6246979054910435723ardSuc(B,R3,R4)
    <=> ( bNF_Ca8970107618336181345der_on(set(B),field2(set(B),R4),R4)
        & member(product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(B,B)),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),R3),R4),bNF_We4044943003108391690rdLess(B,set(B)))
        & ! [R10: set(product_prod(set(B),set(B)))] :
            ( ( bNF_Ca8970107618336181345der_on(set(B),field2(set(B),R10),R10)
              & member(product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(B,B)),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),R3),R10),bNF_We4044943003108391690rdLess(B,set(B))) )
           => member(product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B)))),R4),R10),bNF_Wellorder_ordLeq(set(B),set(B))) ) ) ) ).

% isCardSuc_def
tff(fact_3847_cardSuc__ordLeq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(B,B)),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),R3),bNF_Ca8387033319878233205ardSuc(B,R3)),bNF_Wellorder_ordLeq(B,set(B))) ) ).

% cardSuc_ordLeq
tff(fact_3848_cardSuc__greater,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(B,B)),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),R3),bNF_Ca8387033319878233205ardSuc(B,R3)),bNF_We4044943003108391690rdLess(B,set(B))) ) ).

% cardSuc_greater
tff(fact_3849_cardSuc__ordLess__ordLeq,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,R4),R4)
       => ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
        <=> member(product_prod(set(product_prod(set(B),set(B))),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(set(B),set(B))),set(product_prod(C,C))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(C,C)),product_prod(set(product_prod(set(B),set(B))),set(product_prod(C,C)))),product_Pair(set(product_prod(set(B),set(B))),set(product_prod(C,C))),bNF_Ca8387033319878233205ardSuc(B,R3)),R4),bNF_Wellorder_ordLeq(set(B),C)) ) ) ) ).

% cardSuc_ordLess_ordLeq
tff(fact_3850_cardSuc__least,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,R4),R4)
       => ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_We4044943003108391690rdLess(B,C))
         => member(product_prod(set(product_prod(set(B),set(B))),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(set(B),set(B))),set(product_prod(C,C))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(C,C)),product_prod(set(product_prod(set(B),set(B))),set(product_prod(C,C)))),product_Pair(set(product_prod(set(B),set(B))),set(product_prod(C,C))),bNF_Ca8387033319878233205ardSuc(B,R3)),R4),bNF_Wellorder_ordLeq(set(B),C)) ) ) ) ).

% cardSuc_least
tff(fact_3851_cardSuc__mono__ordLeq,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,R4),R4)
       => ( member(product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(C),set(C)))),aa(set(product_prod(set(C),set(C))),product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(C),set(C)))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(C),set(C))),product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(C),set(C))))),product_Pair(set(product_prod(set(B),set(B))),set(product_prod(set(C),set(C)))),bNF_Ca8387033319878233205ardSuc(B,R3)),bNF_Ca8387033319878233205ardSuc(C,R4)),bNF_Wellorder_ordLeq(set(B),set(C)))
        <=> member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordLeq(B,C)) ) ) ) ).

% cardSuc_mono_ordLeq
tff(fact_3852_cardSuc__invar__ordIso,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,R4),R4)
       => ( member(product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(C),set(C)))),aa(set(product_prod(set(C),set(C))),product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(C),set(C)))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(C),set(C))),product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(C),set(C))))),product_Pair(set(product_prod(set(B),set(B))),set(product_prod(set(C),set(C)))),bNF_Ca8387033319878233205ardSuc(B,R3)),bNF_Ca8387033319878233205ardSuc(C,R4)),bNF_Wellorder_ordIso(set(B),set(C)))
        <=> member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R4),bNF_Wellorder_ordIso(B,C)) ) ) ) ).

% cardSuc_invar_ordIso
tff(fact_3853_cardSuc__least__aux,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(set(B),set(B)))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(set(B),field2(set(B),R4),R4)
       => ( member(product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),aa(set(product_prod(B,B)),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(B,B)),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(B,B)),set(product_prod(set(B),set(B)))),R3),R4),bNF_We4044943003108391690rdLess(B,set(B)))
         => member(product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(set(B),set(B))),set(product_prod(set(B),set(B)))),bNF_Ca8387033319878233205ardSuc(B,R3)),R4),bNF_Wellorder_ordLeq(set(B),set(B))) ) ) ) ).

% cardSuc_least_aux
tff(fact_3854_cardSuc__ordLeq__ordLess,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,R4),R4)
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(set(B),set(B)))),aa(set(product_prod(set(B),set(B))),product_prod(set(product_prod(C,C)),set(product_prod(set(B),set(B)))),aa(set(product_prod(C,C)),fun(set(product_prod(set(B),set(B))),product_prod(set(product_prod(C,C)),set(product_prod(set(B),set(B))))),product_Pair(set(product_prod(C,C)),set(product_prod(set(B),set(B)))),R4),bNF_Ca8387033319878233205ardSuc(B,R3)),bNF_We4044943003108391690rdLess(C,set(B)))
        <=> member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R4),R3),bNF_Wellorder_ordLeq(C,B)) ) ) ) ).

% cardSuc_ordLeq_ordLess
tff(fact_3855_toCard__pred__toCard,axiom,
    ! [B: $tType,C: $tType,A4: set(B),R3: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,C))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3)
       => bNF_Gr1419584066657907630d_pred(B,C,A4,R3,bNF_Greatest_toCard(B,C,A4,R3)) ) ) ).

% toCard_pred_toCard
tff(fact_3856_cardSuc__UNION__Cinfinite,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),As8: fun(set(B),set(C)),B2: set(C)] :
      ( ( bNF_Ca4139267488887388095finite(B,R3)
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => ( bNF_Ca3754400796208372196lChain(set(B),set(C),bNF_Ca8387033319878233205ardSuc(B,R3),As8)
       => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(set(B)),set(set(C)),image2(set(B),set(C),As8),field2(set(B),bNF_Ca8387033319878233205ardSuc(B,R3)))))
         => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(C,B2)),R3),bNF_Wellorder_ordLeq(C,B))
           => ? [X2: set(B)] :
                ( member(set(B),X2,field2(set(B),bNF_Ca8387033319878233205ardSuc(B,R3)))
                & aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),B2),aa(set(B),set(C),As8,X2)) ) ) ) ) ) ).

% cardSuc_UNION_Cinfinite
tff(fact_3857_toCard__inj,axiom,
    ! [C: $tType,B: $tType,A4: set(B),R3: set(product_prod(C,C)),X: B,Y: B] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,C))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3)
       => ( member(B,X,A4)
         => ( member(B,Y,A4)
           => ( ( aa(B,C,bNF_Greatest_toCard(B,C,A4,R3),X) = aa(B,C,bNF_Greatest_toCard(B,C,A4,R3),Y) )
            <=> ( X = Y ) ) ) ) ) ) ).

% toCard_inj
tff(fact_3858_comp__single__set__bd,axiom,
    ! [C: $tType,E: $tType,B: $tType,F7: $tType,D: $tType,Fbd: set(product_prod(B,B)),Fset: fun(C,set(D)),Gset: fun(E,set(C)),Gbd: set(product_prod(F7,F7)),X: E] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,Fbd),Fbd)
     => ( ! [X2: C] : member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),Fset,X2))),Fbd),bNF_Wellorder_ordLeq(D,B))
       => ( ! [X2: E] : member(product_prod(set(product_prod(C,C)),set(product_prod(F7,F7))),aa(set(product_prod(F7,F7)),product_prod(set(product_prod(C,C)),set(product_prod(F7,F7))),aa(set(product_prod(C,C)),fun(set(product_prod(F7,F7)),product_prod(set(product_prod(C,C)),set(product_prod(F7,F7)))),product_Pair(set(product_prod(C,C)),set(product_prod(F7,F7))),bNF_Ca6860139660246222851ard_of(C,aa(E,set(C),Gset,X2))),Gbd),bNF_Wellorder_ordLeq(C,F7))
         => member(product_prod(set(product_prod(D,D)),set(product_prod(product_prod(F7,B),product_prod(F7,B)))),aa(set(product_prod(product_prod(F7,B),product_prod(F7,B))),product_prod(set(product_prod(D,D)),set(product_prod(product_prod(F7,B),product_prod(F7,B)))),aa(set(product_prod(D,D)),fun(set(product_prod(product_prod(F7,B),product_prod(F7,B))),product_prod(set(product_prod(D,D)),set(product_prod(product_prod(F7,B),product_prod(F7,B))))),product_Pair(set(product_prod(D,D)),set(product_prod(product_prod(F7,B),product_prod(F7,B)))),bNF_Ca6860139660246222851ard_of(D,aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),Fset),aa(E,set(C),Gset,X))))),bNF_Cardinal_cprod(F7,B,Gbd,Fbd)),bNF_Wellorder_ordLeq(D,product_prod(F7,B))) ) ) ) ).

% comp_single_set_bd
tff(fact_3859_cinfinite__mono,axiom,
    ! [B: $tType,C: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R1),R22),bNF_Wellorder_ordLeq(B,C))
     => ( bNF_Ca4139267488887388095finite(B,R1)
       => bNF_Ca4139267488887388095finite(C,R22) ) ) ).

% cinfinite_mono
tff(fact_3860_cprod__infinite,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ( bNF_Ca4139267488887388095finite(B,R3)
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => member(product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,B),product_prod(B,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,B),product_prod(B,B))),set(product_prod(B,B))),bNF_Cardinal_cprod(B,B,R3,R3)),R3),bNF_Wellorder_ordIso(product_prod(B,B),B)) ) ).

% cprod_infinite
tff(fact_3861_cprod__com,axiom,
    ! [C: $tType,B: $tType,P1: set(product_prod(B,B)),P22: set(product_prod(C,C))] : member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Cardinal_cprod(B,C,P1,P22)),bNF_Cardinal_cprod(C,B,P22,P1)),bNF_Wellorder_ordIso(product_prod(B,C),product_prod(C,B))) ).

% cprod_com
tff(fact_3862_Cinfinite__limit,axiom,
    ! [B: $tType,X: B,R3: set(product_prod(B,B))] :
      ( member(B,X,field2(B,R3))
     => ( ( bNF_Ca4139267488887388095finite(B,R3)
          & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
       => ? [X2: B] :
            ( member(B,X2,field2(B,R3))
            & ( X != X2 )
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),X2),R3) ) ) ) ).

% Cinfinite_limit
tff(fact_3863_Cinfinite__limit2,axiom,
    ! [B: $tType,X1: B,R3: set(product_prod(B,B)),X22: B] :
      ( member(B,X1,field2(B,R3))
     => ( member(B,X22,field2(B,R3))
       => ( ( bNF_Ca4139267488887388095finite(B,R3)
            & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
         => ? [X2: B] :
              ( member(B,X2,field2(B,R3))
              & ( X1 != X2 )
              & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X1),X2),R3)
              & ( X22 != X2 )
              & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X22),X2),R3) ) ) ) ) ).

% Cinfinite_limit2
tff(fact_3864_cprod__cinfinite__bound,axiom,
    ! [C: $tType,D: $tType,B: $tType,P2: set(product_prod(B,B)),R3: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P2),R3),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(D,D)),fun(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C)))),product_Pair(set(product_prod(D,D)),set(product_prod(C,C))),Q2),R3),bNF_Wellorder_ordLeq(D,C))
       => ( bNF_Ca8970107618336181345der_on(B,field2(B,P2),P2)
         => ( bNF_Ca8970107618336181345der_on(D,field2(D,Q2),Q2)
           => ( ( bNF_Ca4139267488887388095finite(C,R3)
                & bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3) )
             => member(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(C,C))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),fun(set(product_prod(C,C)),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(C,C)))),product_Pair(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(C,C))),bNF_Cardinal_cprod(B,D,P2,Q2)),R3),bNF_Wellorder_ordLeq(product_prod(B,D),C)) ) ) ) ) ) ).

% cprod_cinfinite_bound
tff(fact_3865_cprod__dup,axiom,
    ! [B: $tType,D: $tType,C: $tType,R3: set(product_prod(B,B)),P2: set(product_prod(C,C)),P7: set(product_prod(D,D))] :
      ( bNF_Ca4139267488887388095finite(B,R3)
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => ( member(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(B,B),product_prod(B,B)))),aa(set(product_prod(product_prod(B,B),product_prod(B,B))),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(B,B),product_prod(B,B)))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),fun(set(product_prod(product_prod(B,B),product_prod(B,B))),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(B,B),product_prod(B,B))))),product_Pair(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(B,B),product_prod(B,B)))),bNF_Cardinal_cprod(C,D,P2,P7)),bNF_Cardinal_cprod(B,B,R3,R3)),bNF_Wellorder_ordIso(product_prod(C,D),product_prod(B,B)))
         => member(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(B,B))),bNF_Cardinal_cprod(C,D,P2,P7)),R3),bNF_Wellorder_ordIso(product_prod(C,D),B)) ) ) ) ).

% cprod_dup
tff(fact_3866_Cinfinite__cong,axiom,
    ! [B: $tType,C: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R1),R22),bNF_Wellorder_ordIso(B,C))
     => ( ( bNF_Ca4139267488887388095finite(B,R1)
          & bNF_Ca8970107618336181345der_on(B,field2(B,R1),R1) )
       => ( bNF_Ca4139267488887388095finite(C,R22)
          & bNF_Ca8970107618336181345der_on(C,field2(C,R22),R22) ) ) ) ).

% Cinfinite_cong
tff(fact_3867_Cinfinite__limit__finite,axiom,
    ! [B: $tType,X6: set(B),R3: set(product_prod(B,B))] :
      ( aa(set(B),$o,finite_finite(B),X6)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X6),field2(B,R3))
       => ( ( bNF_Ca4139267488887388095finite(B,R3)
            & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
         => ? [X2: B] :
              ( member(B,X2,field2(B,R3))
              & ! [Xa3: B] :
                  ( member(B,Xa3,X6)
                 => ( ( Xa3 != X2 )
                    & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa3),X2),R3) ) ) ) ) ) ) ).

% Cinfinite_limit_finite
tff(fact_3868_cprod__mono,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),P22: set(product_prod(D,D)),R22: set(product_prod(E,E))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),P22),R22),bNF_Wellorder_ordLeq(D,E))
       => member(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,E),product_prod(C,E)))),aa(set(product_prod(product_prod(C,E),product_prod(C,E))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,E),product_prod(C,E)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),fun(set(product_prod(product_prod(C,E),product_prod(C,E))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,E),product_prod(C,E))))),product_Pair(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,E),product_prod(C,E)))),bNF_Cardinal_cprod(B,D,P1,P22)),bNF_Cardinal_cprod(C,E,R1,R22)),bNF_Wellorder_ordLeq(product_prod(B,D),product_prod(C,E))) ) ) ).

% cprod_mono
tff(fact_3869_cprod__mono1,axiom,
    ! [C: $tType,D: $tType,B: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),fun(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D))))),product_Pair(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),bNF_Cardinal_cprod(B,D,P1,Q2)),bNF_Cardinal_cprod(C,D,R1,Q2)),bNF_Wellorder_ordLeq(product_prod(B,D),product_prod(C,D))) ) ).

% cprod_mono1
tff(fact_3870_cprod__mono2,axiom,
    ! [C: $tType,B: $tType,D: $tType,P22: set(product_prod(B,B)),R22: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P22),R22),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,B),product_prod(D,B))),fun(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C))))),product_Pair(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),bNF_Cardinal_cprod(D,B,Q2,P22)),bNF_Cardinal_cprod(D,C,Q2,R22)),bNF_Wellorder_ordLeq(product_prod(D,B),product_prod(D,C))) ) ).

% cprod_mono2
tff(fact_3871_cprod__cong,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),P22: set(product_prod(D,D)),R22: set(product_prod(E,E))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordIso(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),P22),R22),bNF_Wellorder_ordIso(D,E))
       => member(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,E),product_prod(C,E)))),aa(set(product_prod(product_prod(C,E),product_prod(C,E))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,E),product_prod(C,E)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),fun(set(product_prod(product_prod(C,E),product_prod(C,E))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,E),product_prod(C,E))))),product_Pair(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,E),product_prod(C,E)))),bNF_Cardinal_cprod(B,D,P1,P22)),bNF_Cardinal_cprod(C,E,R1,R22)),bNF_Wellorder_ordIso(product_prod(B,D),product_prod(C,E))) ) ) ).

% cprod_cong
tff(fact_3872_cprod__cong1,axiom,
    ! [C: $tType,D: $tType,B: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),P22: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),fun(set(product_prod(product_prod(C,D),product_prod(C,D))),product_prod(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D))))),product_Pair(set(product_prod(product_prod(B,D),product_prod(B,D))),set(product_prod(product_prod(C,D),product_prod(C,D)))),bNF_Cardinal_cprod(B,D,P1,P22)),bNF_Cardinal_cprod(C,D,R1,P22)),bNF_Wellorder_ordIso(product_prod(B,D),product_prod(C,D))) ) ).

% cprod_cong1
tff(fact_3873_cprod__cong2,axiom,
    ! [C: $tType,B: $tType,D: $tType,P22: set(product_prod(B,B)),R22: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P22),R22),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),aa(set(product_prod(product_prod(D,B),product_prod(D,B))),fun(set(product_prod(product_prod(D,C),product_prod(D,C))),product_prod(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C))))),product_Pair(set(product_prod(product_prod(D,B),product_prod(D,B))),set(product_prod(product_prod(D,C),product_prod(D,C)))),bNF_Cardinal_cprod(D,B,Q2,P22)),bNF_Cardinal_cprod(D,C,Q2,R22)),bNF_Wellorder_ordIso(product_prod(D,B),product_prod(D,C))) ) ).

% cprod_cong2
tff(fact_3874_Un__Cinfinite__bound,axiom,
    ! [C: $tType,B: $tType,A4: set(B),R3: set(product_prod(C,C)),B2: set(B)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,B2)),R3),bNF_Wellorder_ordLeq(B,C))
       => ( ( bNF_Ca4139267488887388095finite(C,R3)
            & bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3) )
         => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))),R3),bNF_Wellorder_ordLeq(B,C)) ) ) ) ).

% Un_Cinfinite_bound
tff(fact_3875_UNION__Cinfinite__bound,axiom,
    ! [B: $tType,C: $tType,D: $tType,I4: set(B),R3: set(product_prod(C,C)),A4: fun(B,set(D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,I4)),R3),bNF_Wellorder_ordLeq(B,C))
     => ( ! [X2: B] :
            ( member(B,X2,I4)
           => member(product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(D,D)),fun(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C)))),product_Pair(set(product_prod(D,D)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(D,aa(B,set(D),A4,X2))),R3),bNF_Wellorder_ordLeq(D,C)) )
       => ( ( bNF_Ca4139267488887388095finite(C,R3)
            & bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3) )
         => member(product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(D,D)),fun(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C)))),product_Pair(set(product_prod(D,D)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(D,aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(B),set(set(D)),image2(B,set(D),A4),I4)))),R3),bNF_Wellorder_ordLeq(D,C)) ) ) ) ).

% UNION_Cinfinite_bound
tff(fact_3876_fromCard__toCard,axiom,
    ! [C: $tType,B: $tType,A4: set(B),R3: set(product_prod(C,C)),Ba: B] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,C))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3)
       => ( member(B,Ba,A4)
         => ( bNF_Gr5436034075474128252omCard(B,C,A4,R3,aa(B,C,bNF_Greatest_toCard(B,C,A4,R3),Ba)) = Ba ) ) ) ) ).

% fromCard_toCard
tff(fact_3877_card__of__Csum__Times_H,axiom,
    ! [B: $tType,D: $tType,C: $tType,R3: set(product_prod(B,B)),I4: set(C),A4: fun(C,set(D))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( ! [X2: C] :
            ( member(C,X2,I4)
           => member(product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B))),aa(set(product_prod(D,D)),fun(set(product_prod(B,B)),product_prod(set(product_prod(D,D)),set(product_prod(B,B)))),product_Pair(set(product_prod(D,D)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),A4,X2))),R3),bNF_Wellorder_ordLeq(D,B)) )
       => member(product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(C,B),product_prod(C,B)))),aa(set(product_prod(product_prod(C,D),product_prod(C,D))),fun(set(product_prod(product_prod(C,B),product_prod(C,B))),product_prod(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(C,B),product_prod(C,B))))),product_Pair(set(product_prod(product_prod(C,D),product_prod(C,D))),set(product_prod(product_prod(C,B),product_prod(C,B)))),bNF_Cardinal_Csum(C,D,bNF_Ca6860139660246222851ard_of(C,I4),aTP_Lamp_ns(fun(C,set(D)),fun(C,set(product_prod(D,D))),A4))),bNF_Cardinal_cprod(C,B,bNF_Ca6860139660246222851ard_of(C,I4),R3)),bNF_Wellorder_ordLeq(product_prod(C,D),product_prod(C,B))) ) ) ).

% card_of_Csum_Times'
tff(fact_3878_card__of__Csum__Times,axiom,
    ! [D: $tType,C: $tType,B: $tType,I4: set(B),A4: fun(B,set(C)),B2: set(D)] :
      ( ! [X2: B] :
          ( member(B,X2,I4)
         => member(product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D))),aa(set(product_prod(C,C)),fun(set(product_prod(D,D)),product_prod(set(product_prod(C,C)),set(product_prod(D,D)))),product_Pair(set(product_prod(C,C)),set(product_prod(D,D))),bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),A4,X2))),bNF_Ca6860139660246222851ard_of(D,B2)),bNF_Wellorder_ordLeq(C,D)) )
     => member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(product_prod(B,D),product_prod(B,D))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(product_prod(B,D),product_prod(B,D)))),bNF_Cardinal_Csum(B,C,bNF_Ca6860139660246222851ard_of(B,I4),aTP_Lamp_nt(fun(B,set(C)),fun(B,set(product_prod(C,C))),A4))),bNF_Cardinal_cprod(B,D,bNF_Ca6860139660246222851ard_of(B,I4),bNF_Ca6860139660246222851ard_of(D,B2))),bNF_Wellorder_ordLeq(product_prod(B,C),product_prod(B,D))) ) ).

% card_of_Csum_Times
tff(fact_3879_Cfinite__cprod__Cinfinite,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),S: set(product_prod(C,C))] :
      ( ( bNF_Cardinal_cfinite(B,R3)
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => ( ( bNF_Ca4139267488887388095finite(C,S)
          & bNF_Ca8970107618336181345der_on(C,field2(C,S),S) )
       => member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(C,C))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(C,C)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(C,C)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(C,C))),bNF_Cardinal_cprod(B,C,R3,S)),S),bNF_Wellorder_ordLeq(product_prod(B,C),C)) ) ) ).

% Cfinite_cprod_Cinfinite
tff(fact_3880_Cfinite__ordLess__Cinfinite,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),S: set(product_prod(C,C))] :
      ( ( bNF_Cardinal_cfinite(B,R3)
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => ( ( bNF_Ca4139267488887388095finite(C,S)
          & bNF_Ca8970107618336181345der_on(C,field2(C,S),S) )
       => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),S),bNF_We4044943003108391690rdLess(B,C)) ) ) ).

% Cfinite_ordLess_Cinfinite
tff(fact_3881_cprod__infinite1_H,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),P2: set(product_prod(C,C))] :
      ( ( bNF_Ca4139267488887388095finite(B,R3)
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => ( ( ~ member(product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),fun(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),product_Pair(set(product_prod(C,C)),set(product_prod(C,C))),P2),bNF_Cardinal_czero(C)),bNF_Wellorder_ordIso(C,C))
          & bNF_Ca8970107618336181345der_on(C,field2(C,P2),P2) )
       => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),P2),R3),bNF_Wellorder_ordLeq(C,B))
         => member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(B,B))),bNF_Cardinal_cprod(B,C,R3,P2)),R3),bNF_Wellorder_ordIso(product_prod(B,C),B)) ) ) ) ).

% cprod_infinite1'
tff(fact_3882_ordLeq__cprod2,axiom,
    ! [B: $tType,C: $tType,P1: set(product_prod(B,B)),P22: set(product_prod(C,C))] :
      ( ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),P1),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
        & bNF_Ca8970107618336181345der_on(B,field2(B,P1),P1) )
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,P22),P22)
       => member(product_prod(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C)))),aa(set(product_prod(C,C)),fun(set(product_prod(product_prod(B,C),product_prod(B,C))),product_prod(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C))))),product_Pair(set(product_prod(C,C)),set(product_prod(product_prod(B,C),product_prod(B,C)))),P22),bNF_Cardinal_cprod(B,C,P1,P22)),bNF_Wellorder_ordLeq(C,product_prod(B,C))) ) ) ).

% ordLeq_cprod2
tff(fact_3883_cone__def,axiom,
    bNF_Cardinal_cone = bNF_Ca6860139660246222851ard_of(product_unit,aa(set(product_unit),set(product_unit),insert2(product_unit,product_Unity),bot_bot(set(product_unit)))) ).

% cone_def
tff(fact_3884_cinfinite__cprod2,axiom,
    ! [B: $tType,C: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C))] :
      ( ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R1),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
        & bNF_Ca8970107618336181345der_on(B,field2(B,R1),R1) )
     => ( ( bNF_Ca4139267488887388095finite(C,R22)
          & bNF_Ca8970107618336181345der_on(C,field2(C,R22),R22) )
       => bNF_Ca4139267488887388095finite(product_prod(B,C),bNF_Cardinal_cprod(B,C,R1,R22)) ) ) ).

% cinfinite_cprod2
tff(fact_3885_cone__not__czero,axiom,
    ! [B: $tType] : ~ member(product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(B,B))),aa(set(product_prod(product_unit,product_unit)),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(B,B)))),product_Pair(set(product_prod(product_unit,product_unit)),set(product_prod(B,B))),bNF_Cardinal_cone),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(product_unit,B)) ).

% cone_not_czero
tff(fact_3886_czero__def,axiom,
    ! [B: $tType] : ( bNF_Cardinal_czero(B) = bNF_Ca6860139660246222851ard_of(B,bot_bot(set(B))) ) ).

% czero_def
tff(fact_3887_czero__ordIso,axiom,
    ! [C: $tType,B: $tType] : member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Cardinal_czero(B)),bNF_Cardinal_czero(C)),bNF_Wellorder_ordIso(B,C)) ).

% czero_ordIso
tff(fact_3888_cone__ordLeq__Cnotzero,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => member(product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(B,B))),aa(set(product_prod(product_unit,product_unit)),fun(set(product_prod(B,B)),product_prod(set(product_prod(product_unit,product_unit)),set(product_prod(B,B)))),product_Pair(set(product_prod(product_unit,product_unit)),set(product_prod(B,B))),bNF_Cardinal_cone),R3),bNF_Wellorder_ordLeq(product_unit,B)) ) ).

% cone_ordLeq_Cnotzero
tff(fact_3889_cinfinite__not__czero,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca4139267488887388095finite(B,R3)
     => ~ member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),bNF_Cardinal_czero(C)),bNF_Wellorder_ordIso(B,C)) ) ).

% cinfinite_not_czero
tff(fact_3890_czeroE,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),bNF_Cardinal_czero(C)),bNF_Wellorder_ordIso(B,C))
     => ( field2(B,R3) = bot_bot(set(B)) ) ) ).

% czeroE
tff(fact_3891_card__of__ordIso__czero__iff__empty,axiom,
    ! [C: $tType,B: $tType,A4: set(B)] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Cardinal_czero(C)),bNF_Wellorder_ordIso(B,C))
    <=> ( A4 = bot_bot(set(B)) ) ) ).

% card_of_ordIso_czero_iff_empty
tff(fact_3892_czeroI,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( ( field2(B,R3) = bot_bot(set(B)) )
       => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),bNF_Cardinal_czero(C)),bNF_Wellorder_ordIso(B,C)) ) ) ).

% czeroI
tff(fact_3893_Cnotzero__imp__not__empty,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => ( field2(B,R3) != bot_bot(set(B)) ) ) ).

% Cnotzero_imp_not_empty
tff(fact_3894_Cnotzero__mono,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),Q2: set(product_prod(C,C))] :
      ( ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,Q2),Q2)
       => ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),Q2),bNF_Wellorder_ordLeq(B,C))
         => ( ~ member(product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),fun(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),product_Pair(set(product_prod(C,C)),set(product_prod(C,C))),Q2),bNF_Cardinal_czero(C)),bNF_Wellorder_ordIso(C,C))
            & bNF_Ca8970107618336181345der_on(C,field2(C,Q2),Q2) ) ) ) ) ).

% Cnotzero_mono
tff(fact_3895_Cinfinite__Cnotzero,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ( bNF_Ca4139267488887388095finite(B,R3)
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) ) ) ).

% Cinfinite_Cnotzero
tff(fact_3896_Cnotzero__UNIV,axiom,
    ! [B: $tType] :
      ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),bNF_Ca6860139660246222851ard_of(B,top_top(set(B)))),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
      & bNF_Ca8970107618336181345der_on(B,field2(B,bNF_Ca6860139660246222851ard_of(B,top_top(set(B)))),bNF_Ca6860139660246222851ard_of(B,top_top(set(B)))) ) ).

% Cnotzero_UNIV
tff(fact_3897_Cinfinite__cprod2,axiom,
    ! [B: $tType,C: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C))] :
      ( ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R1),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
        & bNF_Ca8970107618336181345der_on(B,field2(B,R1),R1) )
     => ( ( bNF_Ca4139267488887388095finite(C,R22)
          & bNF_Ca8970107618336181345der_on(C,field2(C,R22),R22) )
       => ( bNF_Ca4139267488887388095finite(product_prod(B,C),bNF_Cardinal_cprod(B,C,R1,R22))
          & bNF_Ca8970107618336181345der_on(product_prod(B,C),field2(product_prod(B,C),bNF_Cardinal_cprod(B,C,R1,R22)),bNF_Cardinal_cprod(B,C,R1,R22)) ) ) ) ).

% Cinfinite_cprod2
tff(fact_3898_cexp__mono,axiom,
    ! [F7: $tType,G: $tType,C: $tType,E: $tType,B: $tType,D: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),P22: set(product_prod(D,D)),R22: set(product_prod(E,E))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),P22),R22),bNF_Wellorder_ordLeq(D,E))
       => ( ( member(product_prod(set(product_prod(D,D)),set(product_prod(F7,F7))),aa(set(product_prod(F7,F7)),product_prod(set(product_prod(D,D)),set(product_prod(F7,F7))),aa(set(product_prod(D,D)),fun(set(product_prod(F7,F7)),product_prod(set(product_prod(D,D)),set(product_prod(F7,F7)))),product_Pair(set(product_prod(D,D)),set(product_prod(F7,F7))),P22),bNF_Cardinal_czero(F7)),bNF_Wellorder_ordIso(D,F7))
           => member(product_prod(set(product_prod(E,E)),set(product_prod(G,G))),aa(set(product_prod(G,G)),product_prod(set(product_prod(E,E)),set(product_prod(G,G))),aa(set(product_prod(E,E)),fun(set(product_prod(G,G)),product_prod(set(product_prod(E,E)),set(product_prod(G,G)))),product_Pair(set(product_prod(E,E)),set(product_prod(G,G))),R22),bNF_Cardinal_czero(G)),bNF_Wellorder_ordIso(E,G)) )
         => ( bNF_Ca8970107618336181345der_on(D,field2(D,P22),P22)
           => member(product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),aa(set(product_prod(fun(E,C),fun(E,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),aa(set(product_prod(fun(D,B),fun(D,B))),fun(set(product_prod(fun(E,C),fun(E,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C))))),product_Pair(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),bNF_Cardinal_cexp(B,D,P1,P22)),bNF_Cardinal_cexp(C,E,R1,R22)),bNF_Wellorder_ordLeq(fun(D,B),fun(E,C))) ) ) ) ) ).

% cexp_mono
tff(fact_3899_cexp__mono2,axiom,
    ! [E: $tType,F7: $tType,C: $tType,D: $tType,B: $tType,P22: set(product_prod(B,B)),R22: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P22),R22),bNF_Wellorder_ordLeq(B,C))
     => ( bNF_Ca8970107618336181345der_on(D,field2(D,Q2),Q2)
       => ( ( member(product_prod(set(product_prod(B,B)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(B,B)),set(product_prod(E,E))),aa(set(product_prod(B,B)),fun(set(product_prod(E,E)),product_prod(set(product_prod(B,B)),set(product_prod(E,E)))),product_Pair(set(product_prod(B,B)),set(product_prod(E,E))),P22),bNF_Cardinal_czero(E)),bNF_Wellorder_ordIso(B,E))
           => member(product_prod(set(product_prod(C,C)),set(product_prod(F7,F7))),aa(set(product_prod(F7,F7)),product_prod(set(product_prod(C,C)),set(product_prod(F7,F7))),aa(set(product_prod(C,C)),fun(set(product_prod(F7,F7)),product_prod(set(product_prod(C,C)),set(product_prod(F7,F7)))),product_Pair(set(product_prod(C,C)),set(product_prod(F7,F7))),R22),bNF_Cardinal_czero(F7)),bNF_Wellorder_ordIso(C,F7)) )
         => ( bNF_Ca8970107618336181345der_on(B,field2(B,P22),P22)
           => member(product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),aa(set(product_prod(fun(C,D),fun(C,D))),product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),aa(set(product_prod(fun(B,D),fun(B,D))),fun(set(product_prod(fun(C,D),fun(C,D))),product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D))))),product_Pair(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),bNF_Cardinal_cexp(D,B,Q2,P22)),bNF_Cardinal_cexp(D,C,Q2,R22)),bNF_Wellorder_ordLeq(fun(B,D),fun(C,D))) ) ) ) ) ).

% cexp_mono2
tff(fact_3900_cexp__mono2__Cnotzero,axiom,
    ! [C: $tType,D: $tType,B: $tType,P22: set(product_prod(B,B)),R22: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P22),R22),bNF_Wellorder_ordLeq(B,C))
     => ( bNF_Ca8970107618336181345der_on(D,field2(D,Q2),Q2)
       => ( ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),P22),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
            & bNF_Ca8970107618336181345der_on(B,field2(B,P22),P22) )
         => member(product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),aa(set(product_prod(fun(C,D),fun(C,D))),product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),aa(set(product_prod(fun(B,D),fun(B,D))),fun(set(product_prod(fun(C,D),fun(C,D))),product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D))))),product_Pair(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),bNF_Cardinal_cexp(D,B,Q2,P22)),bNF_Cardinal_cexp(D,C,Q2,R22)),bNF_Wellorder_ordLeq(fun(B,D),fun(C,D))) ) ) ) ).

% cexp_mono2_Cnotzero
tff(fact_3901_csum__dup,axiom,
    ! [B: $tType,D: $tType,C: $tType,R3: set(product_prod(B,B)),P2: set(product_prod(C,C)),P7: set(product_prod(D,D))] :
      ( bNF_Ca4139267488887388095finite(B,R3)
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => ( member(product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(sum_sum(B,B),sum_sum(B,B)))),aa(set(product_prod(sum_sum(B,B),sum_sum(B,B))),product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(sum_sum(B,B),sum_sum(B,B)))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),fun(set(product_prod(sum_sum(B,B),sum_sum(B,B))),product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(sum_sum(B,B),sum_sum(B,B))))),product_Pair(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(sum_sum(B,B),sum_sum(B,B)))),bNF_Cardinal_csum(C,D,P2,P7)),bNF_Cardinal_csum(B,B,R3,R3)),bNF_Wellorder_ordIso(sum_sum(C,D),sum_sum(B,B)))
         => member(product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(C,D),sum_sum(C,D))),set(product_prod(B,B))),bNF_Cardinal_csum(C,D,P2,P7)),R3),bNF_Wellorder_ordIso(sum_sum(C,D),B)) ) ) ) ).

% csum_dup
tff(fact_3902_cprod__csum__distrib1,axiom,
    ! [D: $tType,C: $tType,B: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C)),R33: set(product_prod(D,D))] : member(product_prod(set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))),set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D))))),aa(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),product_prod(set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))),set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D))))),aa(set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))),fun(set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))),product_prod(set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))),set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D)))))),product_Pair(set(product_prod(sum_sum(product_prod(B,C),product_prod(B,D)),sum_sum(product_prod(B,C),product_prod(B,D)))),set(product_prod(product_prod(B,sum_sum(C,D)),product_prod(B,sum_sum(C,D))))),bNF_Cardinal_csum(product_prod(B,C),product_prod(B,D),bNF_Cardinal_cprod(B,C,R1,R22),bNF_Cardinal_cprod(B,D,R1,R33))),bNF_Cardinal_cprod(B,sum_sum(C,D),R1,bNF_Cardinal_csum(C,D,R22,R33))),bNF_Wellorder_ordIso(sum_sum(product_prod(B,C),product_prod(B,D)),product_prod(B,sum_sum(C,D)))) ).

% cprod_csum_distrib1
tff(fact_3903_csum__assoc,axiom,
    ! [D: $tType,C: $tType,B: $tType,P1: set(product_prod(B,B)),P22: set(product_prod(C,C)),P32: set(product_prod(D,D))] : member(product_prod(set(product_prod(sum_sum(sum_sum(B,C),D),sum_sum(sum_sum(B,C),D))),set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D))))),aa(set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D)))),product_prod(set(product_prod(sum_sum(sum_sum(B,C),D),sum_sum(sum_sum(B,C),D))),set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D))))),aa(set(product_prod(sum_sum(sum_sum(B,C),D),sum_sum(sum_sum(B,C),D))),fun(set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D)))),product_prod(set(product_prod(sum_sum(sum_sum(B,C),D),sum_sum(sum_sum(B,C),D))),set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D)))))),product_Pair(set(product_prod(sum_sum(sum_sum(B,C),D),sum_sum(sum_sum(B,C),D))),set(product_prod(sum_sum(B,sum_sum(C,D)),sum_sum(B,sum_sum(C,D))))),bNF_Cardinal_csum(sum_sum(B,C),D,bNF_Cardinal_csum(B,C,P1,P22),P32)),bNF_Cardinal_csum(B,sum_sum(C,D),P1,bNF_Cardinal_csum(C,D,P22,P32))),bNF_Wellorder_ordIso(sum_sum(sum_sum(B,C),D),sum_sum(B,sum_sum(C,D)))) ).

% csum_assoc
tff(fact_3904_csum__csum,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C)),R33: set(product_prod(D,D)),R42: set(product_prod(E,E))] : member(product_prod(set(product_prod(sum_sum(sum_sum(B,C),sum_sum(D,E)),sum_sum(sum_sum(B,C),sum_sum(D,E)))),set(product_prod(sum_sum(sum_sum(B,D),sum_sum(C,E)),sum_sum(sum_sum(B,D),sum_sum(C,E))))),aa(set(product_prod(sum_sum(sum_sum(B,D),sum_sum(C,E)),sum_sum(sum_sum(B,D),sum_sum(C,E)))),product_prod(set(product_prod(sum_sum(sum_sum(B,C),sum_sum(D,E)),sum_sum(sum_sum(B,C),sum_sum(D,E)))),set(product_prod(sum_sum(sum_sum(B,D),sum_sum(C,E)),sum_sum(sum_sum(B,D),sum_sum(C,E))))),aa(set(product_prod(sum_sum(sum_sum(B,C),sum_sum(D,E)),sum_sum(sum_sum(B,C),sum_sum(D,E)))),fun(set(product_prod(sum_sum(sum_sum(B,D),sum_sum(C,E)),sum_sum(sum_sum(B,D),sum_sum(C,E)))),product_prod(set(product_prod(sum_sum(sum_sum(B,C),sum_sum(D,E)),sum_sum(sum_sum(B,C),sum_sum(D,E)))),set(product_prod(sum_sum(sum_sum(B,D),sum_sum(C,E)),sum_sum(sum_sum(B,D),sum_sum(C,E)))))),product_Pair(set(product_prod(sum_sum(sum_sum(B,C),sum_sum(D,E)),sum_sum(sum_sum(B,C),sum_sum(D,E)))),set(product_prod(sum_sum(sum_sum(B,D),sum_sum(C,E)),sum_sum(sum_sum(B,D),sum_sum(C,E))))),bNF_Cardinal_csum(sum_sum(B,C),sum_sum(D,E),bNF_Cardinal_csum(B,C,R1,R22),bNF_Cardinal_csum(D,E,R33,R42))),bNF_Cardinal_csum(sum_sum(B,D),sum_sum(C,E),bNF_Cardinal_csum(B,D,R1,R33),bNF_Cardinal_csum(C,E,R22,R42))),bNF_Wellorder_ordIso(sum_sum(sum_sum(B,C),sum_sum(D,E)),sum_sum(sum_sum(B,D),sum_sum(C,E)))) ).

% csum_csum
tff(fact_3905_cexp__cprod,axiom,
    ! [B: $tType,D: $tType,C: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(D,D)),R33: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R1),R1)
     => member(product_prod(set(product_prod(fun(C,fun(D,B)),fun(C,fun(D,B)))),set(product_prod(fun(product_prod(D,C),B),fun(product_prod(D,C),B)))),aa(set(product_prod(fun(product_prod(D,C),B),fun(product_prod(D,C),B))),product_prod(set(product_prod(fun(C,fun(D,B)),fun(C,fun(D,B)))),set(product_prod(fun(product_prod(D,C),B),fun(product_prod(D,C),B)))),aa(set(product_prod(fun(C,fun(D,B)),fun(C,fun(D,B)))),fun(set(product_prod(fun(product_prod(D,C),B),fun(product_prod(D,C),B))),product_prod(set(product_prod(fun(C,fun(D,B)),fun(C,fun(D,B)))),set(product_prod(fun(product_prod(D,C),B),fun(product_prod(D,C),B))))),product_Pair(set(product_prod(fun(C,fun(D,B)),fun(C,fun(D,B)))),set(product_prod(fun(product_prod(D,C),B),fun(product_prod(D,C),B)))),bNF_Cardinal_cexp(fun(D,B),C,bNF_Cardinal_cexp(B,D,R1,R22),R33)),bNF_Cardinal_cexp(B,product_prod(D,C),R1,bNF_Cardinal_cprod(D,C,R22,R33))),bNF_Wellorder_ordIso(fun(C,fun(D,B)),fun(product_prod(D,C),B))) ) ).

% cexp_cprod
tff(fact_3906_cprod__cexp__csum__cexp__Cinfinite,axiom,
    ! [D: $tType,C: $tType,B: $tType,T4: set(product_prod(B,B)),R3: set(product_prod(C,C)),S: set(product_prod(D,D))] :
      ( ( bNF_Ca4139267488887388095finite(B,T4)
        & bNF_Ca8970107618336181345der_on(B,field2(B,T4),T4) )
     => member(product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(fun(B,sum_sum(C,D)),fun(B,sum_sum(C,D))))),aa(set(product_prod(fun(B,sum_sum(C,D)),fun(B,sum_sum(C,D)))),product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(fun(B,sum_sum(C,D)),fun(B,sum_sum(C,D))))),aa(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),fun(set(product_prod(fun(B,sum_sum(C,D)),fun(B,sum_sum(C,D)))),product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(fun(B,sum_sum(C,D)),fun(B,sum_sum(C,D)))))),product_Pair(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(fun(B,sum_sum(C,D)),fun(B,sum_sum(C,D))))),bNF_Cardinal_cexp(product_prod(C,D),B,bNF_Cardinal_cprod(C,D,R3,S),T4)),bNF_Cardinal_cexp(sum_sum(C,D),B,bNF_Cardinal_csum(C,D,R3,S),T4)),bNF_Wellorder_ordLeq(fun(B,product_prod(C,D)),fun(B,sum_sum(C,D)))) ) ).

% cprod_cexp_csum_cexp_Cinfinite
tff(fact_3907_csum__com,axiom,
    ! [C: $tType,B: $tType,P1: set(product_prod(B,B)),P22: set(product_prod(C,C))] : member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),bNF_Cardinal_csum(B,C,P1,P22)),bNF_Cardinal_csum(C,B,P22,P1)),bNF_Wellorder_ordIso(sum_sum(B,C),sum_sum(C,B))) ).

% csum_com
tff(fact_3908_cprod__cexp,axiom,
    ! [D: $tType,C: $tType,B: $tType,R3: set(product_prod(C,C)),S: set(product_prod(D,D)),T4: set(product_prod(B,B))] : member(product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D))))),aa(set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D)))),product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D))))),aa(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),fun(set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D)))),product_prod(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D)))))),product_Pair(set(product_prod(fun(B,product_prod(C,D)),fun(B,product_prod(C,D)))),set(product_prod(product_prod(fun(B,C),fun(B,D)),product_prod(fun(B,C),fun(B,D))))),bNF_Cardinal_cexp(product_prod(C,D),B,bNF_Cardinal_cprod(C,D,R3,S),T4)),bNF_Cardinal_cprod(fun(B,C),fun(B,D),bNF_Cardinal_cexp(C,B,R3,T4),bNF_Cardinal_cexp(D,B,S,T4))),bNF_Wellorder_ordIso(fun(B,product_prod(C,D)),product_prod(fun(B,C),fun(B,D)))) ).

% cprod_cexp
tff(fact_3909_cexp__cone,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(fun(product_unit,B),fun(product_unit,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(fun(product_unit,B),fun(product_unit,B))),set(product_prod(B,B))),aa(set(product_prod(fun(product_unit,B),fun(product_unit,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(fun(product_unit,B),fun(product_unit,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(fun(product_unit,B),fun(product_unit,B))),set(product_prod(B,B))),bNF_Cardinal_cexp(B,product_unit,R3,bNF_Cardinal_cone)),R3),bNF_Wellorder_ordIso(fun(product_unit,B),B)) ) ).

% cexp_cone
tff(fact_3910_cexp__cprod__ordLeq,axiom,
    ! [B: $tType,C: $tType,D: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C)),R33: set(product_prod(D,D))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R1),R1)
     => ( ( bNF_Ca4139267488887388095finite(C,R22)
          & bNF_Ca8970107618336181345der_on(C,field2(C,R22),R22) )
       => ( ( ~ member(product_prod(set(product_prod(D,D)),set(product_prod(D,D))),aa(set(product_prod(D,D)),product_prod(set(product_prod(D,D)),set(product_prod(D,D))),aa(set(product_prod(D,D)),fun(set(product_prod(D,D)),product_prod(set(product_prod(D,D)),set(product_prod(D,D)))),product_Pair(set(product_prod(D,D)),set(product_prod(D,D))),R33),bNF_Cardinal_czero(D)),bNF_Wellorder_ordIso(D,D))
            & bNF_Ca8970107618336181345der_on(D,field2(D,R33),R33) )
         => ( member(product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(D,D)),fun(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C)))),product_Pair(set(product_prod(D,D)),set(product_prod(C,C))),R33),R22),bNF_Wellorder_ordLeq(D,C))
           => member(product_prod(set(product_prod(fun(D,fun(C,B)),fun(D,fun(C,B)))),set(product_prod(fun(C,B),fun(C,B)))),aa(set(product_prod(fun(C,B),fun(C,B))),product_prod(set(product_prod(fun(D,fun(C,B)),fun(D,fun(C,B)))),set(product_prod(fun(C,B),fun(C,B)))),aa(set(product_prod(fun(D,fun(C,B)),fun(D,fun(C,B)))),fun(set(product_prod(fun(C,B),fun(C,B))),product_prod(set(product_prod(fun(D,fun(C,B)),fun(D,fun(C,B)))),set(product_prod(fun(C,B),fun(C,B))))),product_Pair(set(product_prod(fun(D,fun(C,B)),fun(D,fun(C,B)))),set(product_prod(fun(C,B),fun(C,B)))),bNF_Cardinal_cexp(fun(C,B),D,bNF_Cardinal_cexp(B,C,R1,R22),R33)),bNF_Cardinal_cexp(B,C,R1,R22)),bNF_Wellorder_ordIso(fun(D,fun(C,B)),fun(C,B))) ) ) ) ) ).

% cexp_cprod_ordLeq
tff(fact_3911_Un__csum,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,B),sum_sum(B,B)))),aa(set(product_prod(sum_sum(B,B),sum_sum(B,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,B),sum_sum(B,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(B,B),sum_sum(B,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,B),sum_sum(B,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(B,B),sum_sum(B,B)))),bNF_Ca6860139660246222851ard_of(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))),bNF_Cardinal_csum(B,B,bNF_Ca6860139660246222851ard_of(B,A4),bNF_Ca6860139660246222851ard_of(B,B2))),bNF_Wellorder_ordLeq(B,sum_sum(B,B))) ).

% Un_csum
tff(fact_3912_ordLeq__csum2,axiom,
    ! [C: $tType,B: $tType,P22: set(product_prod(B,B)),P1: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,P22),P22)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(C,B),sum_sum(C,B))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(C,B),sum_sum(C,B)))),P22),bNF_Cardinal_csum(C,B,P1,P22)),bNF_Wellorder_ordLeq(B,sum_sum(C,B))) ) ).

% ordLeq_csum2
tff(fact_3913_ordLeq__csum1,axiom,
    ! [C: $tType,B: $tType,P1: set(product_prod(B,B)),P22: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,P1),P1)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(B,B)),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),P1),bNF_Cardinal_csum(B,C,P1,P22)),bNF_Wellorder_ordLeq(B,sum_sum(B,C))) ) ).

% ordLeq_csum1
tff(fact_3914_csum__cong2,axiom,
    ! [C: $tType,B: $tType,D: $tType,P22: set(product_prod(B,B)),R22: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P22),R22),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,B),sum_sum(D,B))),fun(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C))))),product_Pair(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),bNF_Cardinal_csum(D,B,Q2,P22)),bNF_Cardinal_csum(D,C,Q2,R22)),bNF_Wellorder_ordIso(sum_sum(D,B),sum_sum(D,C))) ) ).

% csum_cong2
tff(fact_3915_csum__cong1,axiom,
    ! [C: $tType,D: $tType,B: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordIso(B,C))
     => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),bNF_Cardinal_csum(B,D,P1,Q2)),bNF_Cardinal_csum(C,D,R1,Q2)),bNF_Wellorder_ordIso(sum_sum(B,D),sum_sum(C,D))) ) ).

% csum_cong1
tff(fact_3916_csum__cong,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),P22: set(product_prod(D,D)),R22: set(product_prod(E,E))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordIso(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),P22),R22),bNF_Wellorder_ordIso(D,E))
       => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),bNF_Cardinal_csum(B,D,P1,P22)),bNF_Cardinal_csum(C,E,R1,R22)),bNF_Wellorder_ordIso(sum_sum(B,D),sum_sum(C,E))) ) ) ).

% csum_cong
tff(fact_3917_csum__mono2,axiom,
    ! [C: $tType,B: $tType,D: $tType,P22: set(product_prod(B,B)),R22: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P22),R22),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),aa(set(product_prod(sum_sum(D,B),sum_sum(D,B))),fun(set(product_prod(sum_sum(D,C),sum_sum(D,C))),product_prod(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C))))),product_Pair(set(product_prod(sum_sum(D,B),sum_sum(D,B))),set(product_prod(sum_sum(D,C),sum_sum(D,C)))),bNF_Cardinal_csum(D,B,Q2,P22)),bNF_Cardinal_csum(D,C,Q2,R22)),bNF_Wellorder_ordLeq(sum_sum(D,B),sum_sum(D,C))) ) ).

% csum_mono2
tff(fact_3918_csum__mono1,axiom,
    ! [C: $tType,D: $tType,B: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordLeq(B,C))
     => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,D),sum_sum(C,D))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,D),sum_sum(C,D)))),bNF_Cardinal_csum(B,D,P1,Q2)),bNF_Cardinal_csum(C,D,R1,Q2)),bNF_Wellorder_ordLeq(sum_sum(B,D),sum_sum(C,D))) ) ).

% csum_mono1
tff(fact_3919_csum__mono,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),P22: set(product_prod(D,D)),R22: set(product_prod(E,E))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),P22),R22),bNF_Wellorder_ordLeq(D,E))
       => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(sum_sum(C,E),sum_sum(C,E))),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E))))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(sum_sum(C,E),sum_sum(C,E)))),bNF_Cardinal_csum(B,D,P1,P22)),bNF_Cardinal_csum(C,E,R1,R22)),bNF_Wellorder_ordLeq(sum_sum(B,D),sum_sum(C,E))) ) ) ).

% csum_mono
tff(fact_3920_Plus__csum,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] : member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Ca6860139660246222851ard_of(sum_sum(B,C),sum_Plus(B,C,A4,B2))),bNF_Cardinal_csum(B,C,bNF_Ca6860139660246222851ard_of(B,A4),bNF_Ca6860139660246222851ard_of(C,B2))),bNF_Wellorder_ordIso(sum_sum(B,C),sum_sum(B,C))) ).

% Plus_csum
tff(fact_3921_cexp__mono_H,axiom,
    ! [C: $tType,E: $tType,B: $tType,D: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),P22: set(product_prod(D,D)),R22: set(product_prod(E,E))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),P22),R22),bNF_Wellorder_ordLeq(D,E))
       => ( ( ( field2(D,P22) = bot_bot(set(D)) )
           => ( field2(E,R22) = bot_bot(set(E)) ) )
         => member(product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),aa(set(product_prod(fun(E,C),fun(E,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),aa(set(product_prod(fun(D,B),fun(D,B))),fun(set(product_prod(fun(E,C),fun(E,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C))))),product_Pair(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),bNF_Cardinal_cexp(B,D,P1,P22)),bNF_Cardinal_cexp(C,E,R1,R22)),bNF_Wellorder_ordLeq(fun(D,B),fun(E,C))) ) ) ) ).

% cexp_mono'
tff(fact_3922_cexp__mono1,axiom,
    ! [C: $tType,B: $tType,D: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordLeq(B,C))
     => ( bNF_Ca8970107618336181345der_on(D,field2(D,Q2),Q2)
       => member(product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(D,C),fun(D,C)))),aa(set(product_prod(fun(D,C),fun(D,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(D,C),fun(D,C)))),aa(set(product_prod(fun(D,B),fun(D,B))),fun(set(product_prod(fun(D,C),fun(D,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(D,C),fun(D,C))))),product_Pair(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(D,C),fun(D,C)))),bNF_Cardinal_cexp(B,D,P1,Q2)),bNF_Cardinal_cexp(C,D,R1,Q2)),bNF_Wellorder_ordLeq(fun(D,B),fun(D,C))) ) ) ).

% cexp_mono1
tff(fact_3923_cexp__mono2_H,axiom,
    ! [C: $tType,D: $tType,B: $tType,P22: set(product_prod(B,B)),R22: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P22),R22),bNF_Wellorder_ordLeq(B,C))
     => ( bNF_Ca8970107618336181345der_on(D,field2(D,Q2),Q2)
       => ( ( ( field2(B,P22) = bot_bot(set(B)) )
           => ( field2(C,R22) = bot_bot(set(C)) ) )
         => member(product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),aa(set(product_prod(fun(C,D),fun(C,D))),product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),aa(set(product_prod(fun(B,D),fun(B,D))),fun(set(product_prod(fun(C,D),fun(C,D))),product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D))))),product_Pair(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),bNF_Cardinal_cexp(D,B,Q2,P22)),bNF_Cardinal_cexp(D,C,Q2,R22)),bNF_Wellorder_ordLeq(fun(B,D),fun(C,D))) ) ) ) ).

% cexp_mono2'
tff(fact_3924_csum__absorb2_H,axiom,
    ! [B: $tType,C: $tType,R22: set(product_prod(B,B)),R1: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R22),R22)
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R1),R22),bNF_Wellorder_ordLeq(C,B))
       => ( ( bNF_Ca4139267488887388095finite(C,R1)
            | bNF_Ca4139267488887388095finite(B,R22) )
         => member(product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(C,B),sum_sum(C,B))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(C,B),sum_sum(C,B))),set(product_prod(B,B))),bNF_Cardinal_csum(C,B,R1,R22)),R22),bNF_Wellorder_ordIso(sum_sum(C,B),B)) ) ) ) ).

% csum_absorb2'
tff(fact_3925_csum__absorb1_H,axiom,
    ! [C: $tType,B: $tType,R22: set(product_prod(B,B)),R1: set(product_prod(C,C))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R22),R22)
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R1),R22),bNF_Wellorder_ordLeq(C,B))
       => ( ( bNF_Ca4139267488887388095finite(C,R1)
            | bNF_Ca4139267488887388095finite(B,R22) )
         => member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),bNF_Cardinal_csum(B,C,R22,R1)),R22),bNF_Wellorder_ordIso(sum_sum(B,C),B)) ) ) ) ).

% csum_absorb1'
tff(fact_3926_csum__absorb1,axiom,
    ! [C: $tType,B: $tType,R22: set(product_prod(B,B)),R1: set(product_prod(C,C))] :
      ( ( bNF_Ca4139267488887388095finite(B,R22)
        & bNF_Ca8970107618336181345der_on(B,field2(B,R22),R22) )
     => ( member(product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B))),aa(set(product_prod(C,C)),fun(set(product_prod(B,B)),product_prod(set(product_prod(C,C)),set(product_prod(B,B)))),product_Pair(set(product_prod(C,C)),set(product_prod(B,B))),R1),R22),bNF_Wellorder_ordLeq(C,B))
       => member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(B,B)),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B)))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(B,B))),bNF_Cardinal_csum(B,C,R22,R1)),R22),bNF_Wellorder_ordIso(sum_sum(B,C),B)) ) ) ).

% csum_absorb1
tff(fact_3927_ordLeq__cexp1,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),Q2: set(product_prod(C,C))] :
      ( ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,Q2),Q2)
       => member(product_prod(set(product_prod(C,C)),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(C,C)),set(product_prod(fun(B,C),fun(B,C)))),aa(set(product_prod(C,C)),fun(set(product_prod(fun(B,C),fun(B,C))),product_prod(set(product_prod(C,C)),set(product_prod(fun(B,C),fun(B,C))))),product_Pair(set(product_prod(C,C)),set(product_prod(fun(B,C),fun(B,C)))),Q2),bNF_Cardinal_cexp(C,B,Q2,R3)),bNF_Wellorder_ordLeq(C,fun(B,C))) ) ) ).

% ordLeq_cexp1
tff(fact_3928_csum__cinfinite__bound,axiom,
    ! [C: $tType,D: $tType,B: $tType,P2: set(product_prod(B,B)),R3: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P2),R3),bNF_Wellorder_ordLeq(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C))),aa(set(product_prod(D,D)),fun(set(product_prod(C,C)),product_prod(set(product_prod(D,D)),set(product_prod(C,C)))),product_Pair(set(product_prod(D,D)),set(product_prod(C,C))),Q2),R3),bNF_Wellorder_ordLeq(D,C))
       => ( bNF_Ca8970107618336181345der_on(B,field2(B,P2),P2)
         => ( bNF_Ca8970107618336181345der_on(D,field2(D,Q2),Q2)
           => ( ( bNF_Ca4139267488887388095finite(C,R3)
                & bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3) )
             => member(product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(C,C))),aa(set(product_prod(sum_sum(B,D),sum_sum(B,D))),fun(set(product_prod(C,C)),product_prod(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(C,C)))),product_Pair(set(product_prod(sum_sum(B,D),sum_sum(B,D))),set(product_prod(C,C))),bNF_Cardinal_csum(B,D,P2,Q2)),R3),bNF_Wellorder_ordLeq(sum_sum(B,D),C)) ) ) ) ) ) ).

% csum_cinfinite_bound
tff(fact_3929_csum__Cnotzero1,axiom,
    ! [B: $tType,C: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C))] :
      ( ( ~ member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R1),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso(B,B))
        & bNF_Ca8970107618336181345der_on(B,field2(B,R1),R1) )
     => ( ~ member(product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),aa(set(product_prod(sum_sum(B,C),sum_sum(B,C))),fun(set(product_prod(sum_sum(B,C),sum_sum(B,C))),product_prod(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C))))),product_Pair(set(product_prod(sum_sum(B,C),sum_sum(B,C))),set(product_prod(sum_sum(B,C),sum_sum(B,C)))),bNF_Cardinal_csum(B,C,R1,R22)),bNF_Cardinal_czero(sum_sum(B,C))),bNF_Wellorder_ordIso(sum_sum(B,C),sum_sum(B,C)))
        & bNF_Ca8970107618336181345der_on(sum_sum(B,C),field2(sum_sum(B,C),bNF_Cardinal_csum(B,C,R1,R22)),bNF_Cardinal_csum(B,C,R1,R22)) ) ) ).

% csum_Cnotzero1
tff(fact_3930_cexp__cong2,axiom,
    ! [C: $tType,D: $tType,B: $tType,P22: set(product_prod(B,B)),R22: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P22),R22),bNF_Wellorder_ordIso(B,C))
     => ( bNF_Ca8970107618336181345der_on(D,field2(D,Q2),Q2)
       => ( bNF_Ca8970107618336181345der_on(B,field2(B,P22),P22)
         => member(product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),aa(set(product_prod(fun(C,D),fun(C,D))),product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),aa(set(product_prod(fun(B,D),fun(B,D))),fun(set(product_prod(fun(C,D),fun(C,D))),product_prod(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D))))),product_Pair(set(product_prod(fun(B,D),fun(B,D))),set(product_prod(fun(C,D),fun(C,D)))),bNF_Cardinal_cexp(D,B,Q2,P22)),bNF_Cardinal_cexp(D,C,Q2,R22)),bNF_Wellorder_ordIso(fun(B,D),fun(C,D))) ) ) ) ).

% cexp_cong2
tff(fact_3931_cexp__cong1,axiom,
    ! [C: $tType,B: $tType,D: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),Q2: set(product_prod(D,D))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordIso(B,C))
     => ( bNF_Ca8970107618336181345der_on(D,field2(D,Q2),Q2)
       => member(product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(D,C),fun(D,C)))),aa(set(product_prod(fun(D,C),fun(D,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(D,C),fun(D,C)))),aa(set(product_prod(fun(D,B),fun(D,B))),fun(set(product_prod(fun(D,C),fun(D,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(D,C),fun(D,C))))),product_Pair(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(D,C),fun(D,C)))),bNF_Cardinal_cexp(B,D,P1,Q2)),bNF_Cardinal_cexp(C,D,R1,Q2)),bNF_Wellorder_ordIso(fun(D,B),fun(D,C))) ) ) ).

% cexp_cong1
tff(fact_3932_cexp__cong,axiom,
    ! [C: $tType,E: $tType,B: $tType,D: $tType,P1: set(product_prod(B,B)),R1: set(product_prod(C,C)),P22: set(product_prod(D,D)),R22: set(product_prod(E,E))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),P1),R1),bNF_Wellorder_ordIso(B,C))
     => ( member(product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E))),aa(set(product_prod(D,D)),fun(set(product_prod(E,E)),product_prod(set(product_prod(D,D)),set(product_prod(E,E)))),product_Pair(set(product_prod(D,D)),set(product_prod(E,E))),P22),R22),bNF_Wellorder_ordIso(D,E))
       => ( bNF_Ca8970107618336181345der_on(E,field2(E,R22),R22)
         => ( bNF_Ca8970107618336181345der_on(D,field2(D,P22),P22)
           => member(product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),aa(set(product_prod(fun(E,C),fun(E,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),aa(set(product_prod(fun(D,B),fun(D,B))),fun(set(product_prod(fun(E,C),fun(E,C))),product_prod(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C))))),product_Pair(set(product_prod(fun(D,B),fun(D,B))),set(product_prod(fun(E,C),fun(E,C)))),bNF_Cardinal_cexp(B,D,P1,P22)),bNF_Cardinal_cexp(C,E,R1,R22)),bNF_Wellorder_ordIso(fun(D,B),fun(E,C))) ) ) ) ) ).

% cexp_cong
tff(fact_3933_ordLeq__cexp2,axiom,
    ! [B: $tType,C: $tType,Q2: set(product_prod(B,B)),R3: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod($o,$o)),fun(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B)))),product_Pair(set(product_prod($o,$o)),set(product_prod(B,B))),bNF_Cardinal_ctwo),Q2),bNF_Wellorder_ordLeq($o,B))
     => ( bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3)
       => member(product_prod(set(product_prod(C,C)),set(product_prod(fun(C,B),fun(C,B)))),aa(set(product_prod(fun(C,B),fun(C,B))),product_prod(set(product_prod(C,C)),set(product_prod(fun(C,B),fun(C,B)))),aa(set(product_prod(C,C)),fun(set(product_prod(fun(C,B),fun(C,B))),product_prod(set(product_prod(C,C)),set(product_prod(fun(C,B),fun(C,B))))),product_Pair(set(product_prod(C,C)),set(product_prod(fun(C,B),fun(C,B)))),R3),bNF_Cardinal_cexp(B,C,Q2,R3)),bNF_Wellorder_ordLeq(C,fun(C,B))) ) ) ).

% ordLeq_cexp2
tff(fact_3934_Cfinite__cexp__Cinfinite,axiom,
    ! [B: $tType,C: $tType,S: set(product_prod(B,B)),T4: set(product_prod(C,C))] :
      ( ( bNF_Cardinal_cfinite(B,S)
        & bNF_Ca8970107618336181345der_on(B,field2(B,S),S) )
     => ( ( bNF_Ca4139267488887388095finite(C,T4)
          & bNF_Ca8970107618336181345der_on(C,field2(C,T4),T4) )
       => member(product_prod(set(product_prod(fun(C,B),fun(C,B))),set(product_prod(fun(C,$o),fun(C,$o)))),aa(set(product_prod(fun(C,$o),fun(C,$o))),product_prod(set(product_prod(fun(C,B),fun(C,B))),set(product_prod(fun(C,$o),fun(C,$o)))),aa(set(product_prod(fun(C,B),fun(C,B))),fun(set(product_prod(fun(C,$o),fun(C,$o))),product_prod(set(product_prod(fun(C,B),fun(C,B))),set(product_prod(fun(C,$o),fun(C,$o))))),product_Pair(set(product_prod(fun(C,B),fun(C,B))),set(product_prod(fun(C,$o),fun(C,$o)))),bNF_Cardinal_cexp(B,C,S,T4)),bNF_Cardinal_cexp($o,C,bNF_Cardinal_ctwo,T4)),bNF_Wellorder_ordLeq(fun(C,B),fun(C,$o))) ) ) ).

% Cfinite_cexp_Cinfinite
tff(fact_3935_cinfinite__cexp,axiom,
    ! [B: $tType,C: $tType,Q2: set(product_prod(B,B)),R3: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod($o,$o)),fun(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B)))),product_Pair(set(product_prod($o,$o)),set(product_prod(B,B))),bNF_Cardinal_ctwo),Q2),bNF_Wellorder_ordLeq($o,B))
     => ( ( bNF_Ca4139267488887388095finite(C,R3)
          & bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3) )
       => bNF_Ca4139267488887388095finite(fun(C,B),bNF_Cardinal_cexp(B,C,Q2,R3)) ) ) ).

% cinfinite_cexp
tff(fact_3936_Cinfinite__cexp,axiom,
    ! [B: $tType,C: $tType,Q2: set(product_prod(B,B)),R3: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod($o,$o)),fun(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B)))),product_Pair(set(product_prod($o,$o)),set(product_prod(B,B))),bNF_Cardinal_ctwo),Q2),bNF_Wellorder_ordLeq($o,B))
     => ( ( bNF_Ca4139267488887388095finite(C,R3)
          & bNF_Ca8970107618336181345der_on(C,field2(C,R3),R3) )
       => ( bNF_Ca4139267488887388095finite(fun(C,B),bNF_Cardinal_cexp(B,C,Q2,R3))
          & bNF_Ca8970107618336181345der_on(fun(C,B),field2(fun(C,B),bNF_Cardinal_cexp(B,C,Q2,R3)),bNF_Cardinal_cexp(B,C,Q2,R3)) ) ) ) ).

% Cinfinite_cexp
tff(fact_3937_ctwo__Cnotzero,axiom,
    ( ~ member(product_prod(set(product_prod($o,$o)),set(product_prod($o,$o))),aa(set(product_prod($o,$o)),product_prod(set(product_prod($o,$o)),set(product_prod($o,$o))),aa(set(product_prod($o,$o)),fun(set(product_prod($o,$o)),product_prod(set(product_prod($o,$o)),set(product_prod($o,$o)))),product_Pair(set(product_prod($o,$o)),set(product_prod($o,$o))),bNF_Cardinal_ctwo),bNF_Cardinal_czero($o)),bNF_Wellorder_ordIso($o,$o))
    & bNF_Ca8970107618336181345der_on($o,field2($o,bNF_Cardinal_ctwo),bNF_Cardinal_ctwo) ) ).

% ctwo_Cnotzero
tff(fact_3938_cprod__csum__cexp,axiom,
    ! [C: $tType,B: $tType,R1: set(product_prod(B,B)),R22: set(product_prod(C,C))] : member(product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(fun($o,sum_sum(B,C)),fun($o,sum_sum(B,C))))),aa(set(product_prod(fun($o,sum_sum(B,C)),fun($o,sum_sum(B,C)))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(fun($o,sum_sum(B,C)),fun($o,sum_sum(B,C))))),aa(set(product_prod(product_prod(B,C),product_prod(B,C))),fun(set(product_prod(fun($o,sum_sum(B,C)),fun($o,sum_sum(B,C)))),product_prod(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(fun($o,sum_sum(B,C)),fun($o,sum_sum(B,C)))))),product_Pair(set(product_prod(product_prod(B,C),product_prod(B,C))),set(product_prod(fun($o,sum_sum(B,C)),fun($o,sum_sum(B,C))))),bNF_Cardinal_cprod(B,C,R1,R22)),bNF_Cardinal_cexp(sum_sum(B,C),$o,bNF_Cardinal_csum(B,C,R1,R22),bNF_Cardinal_ctwo)),bNF_Wellorder_ordLeq(product_prod(B,C),fun($o,sum_sum(B,C)))) ).

% cprod_csum_cexp
tff(fact_3939_ordLess__ctwo__cexp,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(fun(B,$o),fun(B,$o)))),aa(set(product_prod(fun(B,$o),fun(B,$o))),product_prod(set(product_prod(B,B)),set(product_prod(fun(B,$o),fun(B,$o)))),aa(set(product_prod(B,B)),fun(set(product_prod(fun(B,$o),fun(B,$o))),product_prod(set(product_prod(B,B)),set(product_prod(fun(B,$o),fun(B,$o))))),product_Pair(set(product_prod(B,B)),set(product_prod(fun(B,$o),fun(B,$o)))),R3),bNF_Cardinal_cexp($o,B,bNF_Cardinal_ctwo,R3)),bNF_We4044943003108391690rdLess(B,fun(B,$o))) ) ).

% ordLess_ctwo_cexp
tff(fact_3940_ctwo__not__czero,axiom,
    ! [B: $tType] : ~ member(product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod($o,$o)),fun(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B)))),product_Pair(set(product_prod($o,$o)),set(product_prod(B,B))),bNF_Cardinal_ctwo),bNF_Cardinal_czero(B)),bNF_Wellorder_ordIso($o,B)) ).

% ctwo_not_czero
tff(fact_3941_ctwo__ordLess__Cinfinite,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ( bNF_Ca4139267488887388095finite(B,R3)
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => member(product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod($o,$o)),fun(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B)))),product_Pair(set(product_prod($o,$o)),set(product_prod(B,B))),bNF_Cardinal_ctwo),R3),bNF_We4044943003108391690rdLess($o,B)) ) ).

% ctwo_ordLess_Cinfinite
tff(fact_3942_ctwo__ordLeq__Cinfinite,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ( bNF_Ca4139267488887388095finite(B,R3)
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => member(product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B))),aa(set(product_prod($o,$o)),fun(set(product_prod(B,B)),product_prod(set(product_prod($o,$o)),set(product_prod(B,B)))),product_Pair(set(product_prod($o,$o)),set(product_prod(B,B))),bNF_Cardinal_ctwo),R3),bNF_Wellorder_ordLeq($o,B)) ) ).

% ctwo_ordLeq_Cinfinite
tff(fact_3943_csum__Cfinite__cexp__Cinfinite,axiom,
    ! [C: $tType,B: $tType,D: $tType,R3: set(product_prod(B,B)),S: set(product_prod(C,C)),T4: set(product_prod(D,D))] :
      ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
     => ( ( bNF_Cardinal_cfinite(C,S)
          & bNF_Ca8970107618336181345der_on(C,field2(C,S),S) )
       => ( ( bNF_Ca4139267488887388095finite(D,T4)
            & bNF_Ca8970107618336181345der_on(D,field2(D,T4),T4) )
         => member(product_prod(set(product_prod(fun(D,sum_sum(B,C)),fun(D,sum_sum(B,C)))),set(product_prod(fun(D,sum_sum(B,$o)),fun(D,sum_sum(B,$o))))),aa(set(product_prod(fun(D,sum_sum(B,$o)),fun(D,sum_sum(B,$o)))),product_prod(set(product_prod(fun(D,sum_sum(B,C)),fun(D,sum_sum(B,C)))),set(product_prod(fun(D,sum_sum(B,$o)),fun(D,sum_sum(B,$o))))),aa(set(product_prod(fun(D,sum_sum(B,C)),fun(D,sum_sum(B,C)))),fun(set(product_prod(fun(D,sum_sum(B,$o)),fun(D,sum_sum(B,$o)))),product_prod(set(product_prod(fun(D,sum_sum(B,C)),fun(D,sum_sum(B,C)))),set(product_prod(fun(D,sum_sum(B,$o)),fun(D,sum_sum(B,$o)))))),product_Pair(set(product_prod(fun(D,sum_sum(B,C)),fun(D,sum_sum(B,C)))),set(product_prod(fun(D,sum_sum(B,$o)),fun(D,sum_sum(B,$o))))),bNF_Cardinal_cexp(sum_sum(B,C),D,bNF_Cardinal_csum(B,C,R3,S),T4)),bNF_Cardinal_cexp(sum_sum(B,$o),D,bNF_Cardinal_csum(B,$o,R3,bNF_Cardinal_ctwo),T4)),bNF_Wellorder_ordLeq(fun(D,sum_sum(B,C)),fun(D,sum_sum(B,$o)))) ) ) ) ).

% csum_Cfinite_cexp_Cinfinite
tff(fact_3944_natLeq__ordLeq__cinfinite,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ( bNF_Ca4139267488887388095finite(B,R3)
        & bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3) )
     => member(product_prod(set(product_prod(nat,nat)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(nat,nat)),set(product_prod(B,B))),aa(set(product_prod(nat,nat)),fun(set(product_prod(B,B)),product_prod(set(product_prod(nat,nat)),set(product_prod(B,B)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(B,B))),bNF_Ca8665028551170535155natLeq),R3),bNF_Wellorder_ordLeq(nat,B)) ) ).

% natLeq_ordLeq_cinfinite
tff(fact_3945_infinite__iff__natLeq__ordLeq,axiom,
    ! [B: $tType,A4: set(B)] :
      ~ ( aa(set(B),$o,finite_finite(B),A4)
      <=> member(product_prod(set(product_prod(nat,nat)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(nat,nat)),set(product_prod(B,B))),aa(set(product_prod(nat,nat)),fun(set(product_prod(B,B)),product_prod(set(product_prod(nat,nat)),set(product_prod(B,B)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(B,B))),bNF_Ca8665028551170535155natLeq),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Wellorder_ordLeq(nat,B)) ) ).

% infinite_iff_natLeq_ordLeq
tff(fact_3946_dir__image__ordIso,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),Fa: fun(B,C)] :
      ( order_well_order_on(B,field2(B,R3),R3)
     => ( inj_on(B,C,Fa,field2(B,R3))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),bNF_We2720479622203943262_image(B,C,R3,Fa)),bNF_Wellorder_ordIso(B,C)) ) ) ).

% dir_image_ordIso
tff(fact_3947_card__of__nat,axiom,
    member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bNF_Ca6860139660246222851ard_of(nat,top_top(set(nat)))),bNF_Ca8665028551170535155natLeq),bNF_Wellorder_ordIso(nat,nat)) ).

% card_of_nat
tff(fact_3948_ctwo__ordLess__natLeq,axiom,
    member(product_prod(set(product_prod($o,$o)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod($o,$o)),set(product_prod(nat,nat))),aa(set(product_prod($o,$o)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod($o,$o)),set(product_prod(nat,nat)))),product_Pair(set(product_prod($o,$o)),set(product_prod(nat,nat))),bNF_Cardinal_ctwo),bNF_Ca8665028551170535155natLeq),bNF_We4044943003108391690rdLess($o,nat)) ).

% ctwo_ordLess_natLeq
tff(fact_3949_dir__image__def,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,C)),Fa: fun(C,B)] : ( bNF_We2720479622203943262_image(C,B,R3,Fa) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(C,B),fun(product_prod(B,B),$o),aTP_Lamp_nu(set(product_prod(C,C)),fun(fun(C,B),fun(product_prod(B,B),$o)),R3),Fa)) ) ).

% dir_image_def
tff(fact_3950_Restr__natLeq2,axiom,
    ! [N: nat] : ( aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),inf_inf(set(product_prod(nat,nat))),bNF_Ca8665028551170535155natLeq),product_Sigma(nat,nat,order_underS(nat,bNF_Ca8665028551170535155natLeq,N),aTP_Lamp_nv(nat,fun(nat,set(nat)),N))) = aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_nw(nat,fun(nat,fun(nat,$o)),N))) ) ).

% Restr_natLeq2
tff(fact_3951_Restr__natLeq,axiom,
    ! [N: nat] : ( aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),inf_inf(set(product_prod(nat,nat))),bNF_Ca8665028551170535155natLeq),product_Sigma(nat,nat,aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_ds(nat,fun(nat,$o),N)),aTP_Lamp_nx(nat,fun(nat,set(nat)),N))) = aa(fun(product_prod(nat,nat),$o),set(product_prod(nat,nat)),collect(product_prod(nat,nat)),aa(fun(nat,fun(nat,$o)),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,$o),aTP_Lamp_nw(nat,fun(nat,fun(nat,$o)),N))) ) ).

% Restr_natLeq
tff(fact_3952_card__of__Field__natLeq,axiom,
    member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),bNF_Ca6860139660246222851ard_of(nat,field2(nat,bNF_Ca8665028551170535155natLeq))),bNF_Ca8665028551170535155natLeq),bNF_Wellorder_ordIso(nat,nat)) ).

% card_of_Field_natLeq
tff(fact_3953_finite__iff__ordLess__natLeq,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A4)
    <=> member(product_prod(set(product_prod(B,B)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(B,B)),set(product_prod(nat,nat))),aa(set(product_prod(B,B)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(B,B)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(B,B)),set(product_prod(nat,nat))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca8665028551170535155natLeq),bNF_We4044943003108391690rdLess(B,nat)) ) ).

% finite_iff_ordLess_natLeq
tff(fact_3954_dir__image,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),R3: set(product_prod(B,B))] :
      ( ! [X2: B,Y2: B] :
          ( ( aa(B,C,Fa,X2) = aa(B,C,Fa,Y2) )
        <=> ( X2 = Y2 ) )
     => ( bNF_Ca8970107618336181345der_on(B,field2(B,R3),R3)
       => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),bNF_We2720479622203943262_image(B,C,R3,Fa)),bNF_Wellorder_ordIso(B,C)) ) ) ).

% dir_image
tff(fact_3955_subset__singleton__iff__Uniq,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ? [A6: B] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),aa(set(B),set(B),insert2(B,A6),bot_bot(set(B))))
    <=> uniq(B,aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),A4)) ) ).

% subset_singleton_iff_Uniq
tff(fact_3956_Gcd__fin__def,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ( semiring_gcd_Gcd_fin(B) = bounde2362111253966948842tice_F(B,gcd_gcd(B),zero_zero(B),one_one(B)) ) ) ).

% Gcd_fin_def
tff(fact_3957_dom__fun__upd,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,option(C)),X: B,Y: option(C)] :
      ( dom(B,C,fun_upd(B,option(C),Fa,X,Y))
      = $ite(Y = none(C),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),dom(B,C,Fa)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))),aa(set(B),set(B),insert2(B,X),dom(B,C,Fa))) ) ).

% dom_fun_upd
tff(fact_3958_ex__is__arg__min__if__finite,axiom,
    ! [C: $tType,B: $tType] :
      ( order(C)
     => ! [S2: set(B),Fa: fun(B,C)] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( ( S2 != bot_bot(set(B)) )
           => ? [X_1: B] : lattic501386751177426532rg_min(B,C,Fa,aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),S2),X_1) ) ) ) ).

% ex_is_arg_min_if_finite
tff(fact_3959_dom__eq__empty__conv,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,option(C))] :
      ( ( dom(B,C,Fa) = bot_bot(set(B)) )
    <=> ! [X4: B] : ( aa(B,option(C),Fa,X4) = none(C) ) ) ).

% dom_eq_empty_conv
tff(fact_3960_dom__restrict,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C)),A4: set(B)] : ( dom(B,C,restrict_map(B,C,M4,A4)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,M4)),A4) ) ).

% dom_restrict
tff(fact_3961_dom__empty,axiom,
    ! [C: $tType,B: $tType] : ( dom(B,C,aTP_Lamp_mh(B,option(C))) = bot_bot(set(B)) ) ).

% dom_empty
tff(fact_3962_dom__override__on,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,option(C)),Ga: fun(B,option(C)),A4: set(B)] : ( dom(B,C,override_on(B,option(C),Fa,Ga,A4)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),dom(B,C,Fa)),aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_ny(fun(B,option(C)),fun(set(B),fun(B,$o)),Ga),A4)))),aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_nz(fun(B,option(C)),fun(set(B),fun(B,$o)),Ga),A4))) ) ).

% dom_override_on
tff(fact_3963_dom__if,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,$o),Fa: fun(B,option(C)),Ga: fun(B,option(C))] : ( dom(B,C,aa(fun(B,option(C)),fun(B,option(C)),aa(fun(B,option(C)),fun(fun(B,option(C)),fun(B,option(C))),aTP_Lamp_oa(fun(B,$o),fun(fun(B,option(C)),fun(fun(B,option(C)),fun(B,option(C)))),Pa),Fa),Ga)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,Fa)),aa(fun(B,$o),set(B),collect(B),Pa))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,Ga)),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ob(fun(B,$o),fun(B,$o),Pa)))) ) ).

% dom_if
tff(fact_3964_restrict__map__eq_I1_J,axiom,
    ! [B: $tType,C: $tType,M4: fun(C,option(B)),A4: set(C),K: C] :
      ( ( aa(C,option(B),restrict_map(C,B,M4,A4),K) = none(B) )
    <=> ~ member(C,K,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),dom(C,B,M4)),A4)) ) ).

% restrict_map_eq(1)
tff(fact_3965_inj__on__map__the,axiom,
    ! [C: $tType,B: $tType,D4: set(B),M4: fun(B,option(C))] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),D4),dom(B,C,M4))
     => ( inj_on(B,option(C),M4,D4)
       => inj_on(B,C,aa(fun(B,option(C)),fun(B,C),aa(fun(option(C),C),fun(fun(B,option(C)),fun(B,C)),comp(option(C),C,B),the2(C)),M4),D4) ) ) ).

% inj_on_map_the
tff(fact_3966_graph__eq__to__snd__dom,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C))] : ( graph(B,C,M4) = aa(set(B),set(product_prod(B,C)),image2(B,product_prod(B,C),aTP_Lamp_oc(fun(B,option(C)),fun(B,product_prod(B,C)),M4)),dom(B,C,M4)) ) ).

% graph_eq_to_snd_dom
tff(fact_3967_dom__eq__singleton__conv,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,option(C)),X: B] :
      ( ( dom(B,C,Fa) = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) )
    <=> ? [V4: C] : ( Fa = fun_upd(B,option(C),aTP_Lamp_mh(B,option(C)),X,aa(C,option(C),some(C),V4)) ) ) ).

% dom_eq_singleton_conv
tff(fact_3968_ran__map__upd__Some,axiom,
    ! [C: $tType,B: $tType,M4: fun(C,option(B)),X: C,Y: B,Z2: B] :
      ( ( aa(C,option(B),M4,X) = aa(B,option(B),some(B),Y) )
     => ( inj_on(C,option(B),M4,dom(C,B,M4))
       => ( ~ member(B,Z2,ran(C,B,M4))
         => ( ran(C,B,fun_upd(C,option(B),M4,X,aa(B,option(B),some(B),Z2))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),ran(C,B,M4)),aa(set(B),set(B),insert2(B,Y),bot_bot(set(B))))),aa(set(B),set(B),insert2(B,Z2),bot_bot(set(B)))) ) ) ) ) ).

% ran_map_upd_Some
tff(fact_3969_bounded__quasi__semilattice__set_Oremove,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Top: B,Bot: B,Normalize: fun(B,B),A3: B,A4: set(B)] :
      ( bounde6485984586167503788ce_set(B,Fa,Top,Bot,Normalize)
     => ( member(B,A3,A4)
       => ( aa(set(B),B,bounde2362111253966948842tice_F(B,Fa,Top,Bot),A4) = aa(B,B,aa(B,fun(B,B),Fa,A3),aa(set(B),B,bounde2362111253966948842tice_F(B,Fa,Top,Bot),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) ) ) ).

% bounded_quasi_semilattice_set.remove
tff(fact_3970_bounded__quasi__semilattice__set_Oinsert__remove,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Top: B,Bot: B,Normalize: fun(B,B),A3: B,A4: set(B)] :
      ( bounde6485984586167503788ce_set(B,Fa,Top,Bot,Normalize)
     => ( aa(set(B),B,bounde2362111253966948842tice_F(B,Fa,Top,Bot),aa(set(B),set(B),insert2(B,A3),A4)) = aa(B,B,aa(B,fun(B,B),Fa,A3),aa(set(B),B,bounde2362111253966948842tice_F(B,Fa,Top,Bot),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) ) ).

% bounded_quasi_semilattice_set.insert_remove
tff(fact_3971_graph__map__add,axiom,
    ! [C: $tType,B: $tType,M12: fun(B,option(C)),M22: fun(B,option(C))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,M12)),dom(B,C,M22)) = bot_bot(set(B)) )
     => ( graph(B,C,map_add(B,C,M12,M22)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),sup_sup(set(product_prod(B,C))),graph(B,C,M12)),graph(B,C,M22)) ) ) ).

% graph_map_add
tff(fact_3972_ran__empty,axiom,
    ! [C: $tType,B: $tType] : ( ran(C,B,aTP_Lamp_od(C,option(B))) = bot_bot(set(B)) ) ).

% ran_empty
tff(fact_3973_ran__add,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,option(C)),Ga: fun(B,option(C))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,Fa)),dom(B,C,Ga)) = bot_bot(set(B)) )
     => ( ran(B,C,map_add(B,C,Fa,Ga)) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),ran(B,C,Fa)),ran(B,C,Ga)) ) ) ).

% ran_add
tff(fact_3974_ran__map__add,axiom,
    ! [C: $tType,B: $tType,M12: fun(B,option(C)),M22: fun(B,option(C))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,M12)),dom(B,C,M22)) = bot_bot(set(B)) )
     => ( ran(B,C,map_add(B,C,M12,M22)) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),ran(B,C,M12)),ran(B,C,M22)) ) ) ).

% ran_map_add
tff(fact_3975_map__add__left__comm,axiom,
    ! [C: $tType,B: $tType,A4: fun(B,option(C)),B2: fun(B,option(C)),C3: fun(B,option(C))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,A4)),dom(B,C,B2)) = bot_bot(set(B)) )
     => ( map_add(B,C,A4,map_add(B,C,B2,C3)) = map_add(B,C,B2,map_add(B,C,A4,C3)) ) ) ).

% map_add_left_comm
tff(fact_3976_map__add__distinct__le,axiom,
    ! [C: $tType,B: $tType] :
      ( preorder(C)
     => ! [M4: fun(B,option(C)),M6: fun(B,option(C)),N: fun(B,option(C)),N2: fun(B,option(C))] :
          ( aa(fun(B,option(C)),$o,aa(fun(B,option(C)),fun(fun(B,option(C)),$o),ord_less_eq(fun(B,option(C))),M4),M6)
         => ( aa(fun(B,option(C)),$o,aa(fun(B,option(C)),fun(fun(B,option(C)),$o),ord_less_eq(fun(B,option(C))),N),N2)
           => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,M6)),dom(B,C,N2)) = bot_bot(set(B)) )
             => aa(fun(B,option(C)),$o,aa(fun(B,option(C)),fun(fun(B,option(C)),$o),ord_less_eq(fun(B,option(C))),map_add(B,C,M4,N)),map_add(B,C,M6,N2)) ) ) ) ) ).

% map_add_distinct_le
tff(fact_3977_map__add__comm,axiom,
    ! [C: $tType,B: $tType,M12: fun(B,option(C)),M22: fun(B,option(C))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),dom(B,C,M12)),dom(B,C,M22)) = bot_bot(set(B)) )
     => ( map_add(B,C,M12,M22) = map_add(B,C,M22,M12) ) ) ).

% map_add_comm
tff(fact_3978_bounded__quasi__semilattice__set_Oempty,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Top: B,Bot: B,Normalize: fun(B,B)] :
      ( bounde6485984586167503788ce_set(B,Fa,Top,Bot,Normalize)
     => ( aa(set(B),B,bounde2362111253966948842tice_F(B,Fa,Top,Bot),bot_bot(set(B))) = Top ) ) ).

% bounded_quasi_semilattice_set.empty
tff(fact_3979_ran__is__image,axiom,
    ! [B: $tType,C: $tType,M: fun(C,option(B))] : ( ran(C,B,M) = aa(set(C),set(B),image2(C,B,aa(fun(C,option(B)),fun(C,B),aa(fun(option(B),B),fun(fun(C,option(B)),fun(C,B)),comp(option(B),B,C),the2(B)),M)),dom(C,B,M)) ) ).

% ran_is_image
tff(fact_3980_relImage__def,axiom,
    ! [B: $tType,C: $tType,R: set(product_prod(C,C)),Fa: fun(C,B)] : ( bNF_Gr4221423524335903396lImage(C,B,R,Fa) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(C,B),fun(product_prod(B,B),$o),aTP_Lamp_nu(set(product_prod(C,C)),fun(fun(C,B),fun(product_prod(B,B),$o)),R),Fa)) ) ).

% relImage_def
tff(fact_3981_Sup__fin_Osemilattice__order__set__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => lattic4895041142388067077er_set(B,sup_sup(B),aTP_Lamp_oe(B,fun(B,$o)),aTP_Lamp_of(B,fun(B,$o))) ) ).

% Sup_fin.semilattice_order_set_axioms
tff(fact_3982_type__copy__vimage2p__Grp__Abs,axiom,
    ! [B: $tType,C: $tType,E: $tType,D: $tType,Rep: fun(B,C),Abs: fun(C,B),Ga: fun(D,E),Pa: fun(E,$o),H2: fun(E,B)] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( aa(fun(E,fun(B,$o)),fun(D,fun(C,$o)),bNF_vimage2p(D,E,C,B,$o,Ga,Abs),bNF_Grp(E,B,aa(fun(E,$o),set(E),collect(E),Pa),H2)) = bNF_Grp(D,C,aa(fun(D,$o),set(D),collect(D),aa(fun(E,$o),fun(D,$o),aTP_Lamp_og(fun(D,E),fun(fun(E,$o),fun(D,$o)),Ga),Pa)),aa(fun(D,E),fun(D,C),aa(fun(E,C),fun(fun(D,E),fun(D,C)),comp(E,C,D),aa(fun(E,B),fun(E,C),aa(fun(B,C),fun(fun(E,B),fun(E,C)),comp(B,C,E),Rep),H2)),Ga)) ) ) ).

% type_copy_vimage2p_Grp_Abs
tff(fact_3983_type__copy__vimage2p__Grp__Rep,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,Rep: fun(B,C),Abs: fun(C,B),Fa: fun(D,E),Pa: fun(E,$o),H2: fun(E,C)] :
      ( type_definition(B,C,Rep,Abs,top_top(set(C)))
     => ( aa(fun(E,fun(C,$o)),fun(D,fun(B,$o)),bNF_vimage2p(D,E,B,C,$o,Fa,Rep),bNF_Grp(E,C,aa(fun(E,$o),set(E),collect(E),Pa),H2)) = bNF_Grp(D,B,aa(fun(D,$o),set(D),collect(D),aa(fun(E,$o),fun(D,$o),aTP_Lamp_og(fun(D,E),fun(fun(E,$o),fun(D,$o)),Fa),Pa)),aa(fun(D,E),fun(D,B),aa(fun(E,B),fun(fun(D,E),fun(D,B)),comp(E,B,D),aa(fun(E,C),fun(E,B),aa(fun(C,B),fun(fun(E,C),fun(E,B)),comp(C,B,E),Abs),H2)),Fa)) ) ) ).

% type_copy_vimage2p_Grp_Rep
tff(fact_3984_fun_Orel__Grp,axiom,
    ! [B: $tType,D: $tType,C: $tType,A4: set(C),Fa: fun(C,D)] : ( bNF_rel_fun(B,B,C,D,fequal(B),bNF_Grp(C,D,A4,Fa)) = bNF_Grp(fun(B,C),fun(B,D),aa(fun(fun(B,C),$o),set(fun(B,C)),collect(fun(B,C)),aTP_Lamp_nl(set(C),fun(fun(B,C),$o),A4)),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Fa)) ) ).

% fun.rel_Grp
tff(fact_3985_Collect__case__prod__Grp__eqD,axiom,
    ! [C: $tType,B: $tType,Z2: product_prod(B,C),A4: set(B),Fa: fun(B,C)] :
      ( member(product_prod(B,C),Z2,aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),bNF_Grp(B,C,A4,Fa))))
     => ( aa(product_prod(B,C),C,aa(fun(product_prod(B,C),B),fun(product_prod(B,C),C),aa(fun(B,C),fun(fun(product_prod(B,C),B),fun(product_prod(B,C),C)),comp(B,C,product_prod(B,C)),Fa),product_fst(B,C)),Z2) = aa(product_prod(B,C),C,product_snd(B,C),Z2) ) ) ).

% Collect_case_prod_Grp_eqD
tff(fact_3986_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => lattic4895041142388067077er_set(B,inf_inf(B),ord_less_eq(B),ord_less(B)) ) ).

% Inf_fin.semilattice_order_set_axioms
tff(fact_3987_mono__cINF,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( ( condit1219197933456340205attice(C)
        & condit1219197933456340205attice(B) )
     => ! [Fa: fun(B,C),A4: fun(D,B),I4: set(D)] :
          ( order_mono(B,C,Fa)
         => ( condit1013018076250108175_below(B,aa(set(D),set(B),image2(D,B,A4),I4))
           => ( ( I4 != bot_bot(set(D)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,A4),I4)))),aa(set(C),C,complete_Inf_Inf(C),aa(set(D),set(C),image2(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_oh(fun(B,C),fun(fun(D,B),fun(D,C)),Fa),A4)),I4))) ) ) ) ) ).

% mono_cINF
tff(fact_3988_mono__cInf,axiom,
    ! [C: $tType,B: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(C) )
     => ! [Fa: fun(B,C),A4: set(B)] :
          ( order_mono(B,C,Fa)
         => ( condit1013018076250108175_below(B,A4)
           => ( ( A4 != bot_bot(set(B)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,aa(set(B),B,complete_Inf_Inf(B),A4))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image2(B,C,Fa),A4))) ) ) ) ) ).

% mono_cInf
tff(fact_3989_mono__cSUP,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(C) )
     => ! [Fa: fun(B,C),A4: fun(D,B),I4: set(D)] :
          ( order_mono(B,C,Fa)
         => ( condit941137186595557371_above(B,aa(set(D),set(B),image2(D,B,A4),I4))
           => ( ( I4 != bot_bot(set(D)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(D),set(C),image2(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_oh(fun(B,C),fun(fun(D,B),fun(D,C)),Fa),A4)),I4))),aa(B,C,Fa,aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,A4),I4)))) ) ) ) ) ).

% mono_cSUP
tff(fact_3990_mono__cSup,axiom,
    ! [C: $tType,B: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(C) )
     => ! [Fa: fun(B,C),A4: set(B)] :
          ( order_mono(B,C,Fa)
         => ( condit941137186595557371_above(B,A4)
           => ( ( A4 != bot_bot(set(B)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image2(B,C,Fa),A4))),aa(B,C,Fa,aa(set(B),B,complete_Sup_Sup(B),A4))) ) ) ) ) ).

% mono_cSup
tff(fact_3991_monoD,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [Fa: fun(B,C),X: B,Y: B] :
          ( order_mono(B,C,Fa)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X)),aa(B,C,Fa,Y)) ) ) ) ).

% monoD
tff(fact_3992_monoE,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [Fa: fun(B,C),X: B,Y: B] :
          ( order_mono(B,C,Fa)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X)),aa(B,C,Fa,Y)) ) ) ) ).

% monoE
tff(fact_3993_monoI,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [Fa: fun(B,C)] :
          ( ! [X2: B,Y2: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y2)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X2)),aa(B,C,Fa,Y2)) )
         => order_mono(B,C,Fa) ) ) ).

% monoI
tff(fact_3994_mono__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [Fa: fun(B,C)] :
          ( order_mono(B,C,Fa)
        <=> ! [X4: B,Y3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),Y3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,X4)),aa(B,C,Fa,Y3)) ) ) ) ).

% mono_def
tff(fact_3995_mono__strict__invE,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & order(C) )
     => ! [Fa: fun(B,C),X: B,Y: B] :
          ( order_mono(B,C,Fa)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,X)),aa(B,C,Fa,Y))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y) ) ) ) ).

% mono_strict_invE
tff(fact_3996_mono__add,axiom,
    ! [B: $tType] :
      ( ordere6658533253407199908up_add(B)
     => ! [A3: B] : order_mono(B,B,aa(B,fun(B,B),plus_plus(B),A3)) ) ).

% mono_add
tff(fact_3997_min__of__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [Fa: fun(B,C),M4: B,N: B] :
          ( order_mono(B,C,Fa)
         => ( aa(C,C,aa(C,fun(C,C),ord_min(C),aa(B,C,Fa,M4)),aa(B,C,Fa,N)) = aa(B,C,Fa,aa(B,B,aa(B,fun(B,B),ord_min(B),M4),N)) ) ) ) ).

% min_of_mono
tff(fact_3998_mono__Int,axiom,
    ! [C: $tType,B: $tType,Fa: fun(set(B),set(C)),A4: set(B),B2: set(B)] :
      ( order_mono(set(B),set(C),Fa)
     => aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),Fa,A4)),aa(set(B),set(C),Fa,B2))) ) ).

% mono_Int
tff(fact_3999_mono__invE,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & order(C) )
     => ! [Fa: fun(B,C),X: B,Y: B] :
          ( order_mono(B,C,Fa)
         => ( aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,X)),aa(B,C,Fa,Y))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y) ) ) ) ).

% mono_invE
tff(fact_4000_mono__inf,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semilattice_inf(B)
        & semilattice_inf(C) )
     => ! [Fa: fun(B,C),A4: B,B2: B] :
          ( order_mono(B,C,Fa)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),B2))),aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,Fa,A4)),aa(B,C,Fa,B2))) ) ) ).

% mono_inf
tff(fact_4001_mono__sup,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semilattice_sup(B)
        & semilattice_sup(C) )
     => ! [Fa: fun(B,C),A4: B,B2: B] :
          ( order_mono(B,C,Fa)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(B,C,Fa,A4)),aa(B,C,Fa,B2))),aa(B,C,Fa,aa(B,B,aa(B,fun(B,B),sup_sup(B),A4),B2))) ) ) ).

% mono_sup
tff(fact_4002_Rings_Omono__mult,axiom,
    ! [B: $tType] :
      ( ordered_semiring(B)
     => ! [A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
         => order_mono(B,B,aa(B,fun(B,B),times_times(B),A3)) ) ) ).

% Rings.mono_mult
tff(fact_4003_mono__Max__commute,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [Fa: fun(B,C),A4: set(B)] :
          ( order_mono(B,C,Fa)
         => ( aa(set(B),$o,finite_finite(B),A4)
           => ( ( A4 != bot_bot(set(B)) )
             => ( aa(B,C,Fa,lattic643756798349783984er_Max(B,A4)) = lattic643756798349783984er_Max(C,aa(set(B),set(C),image2(B,C,Fa),A4)) ) ) ) ) ) ).

% mono_Max_commute
tff(fact_4004_mono__Min__commute,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [Fa: fun(B,C),A4: set(B)] :
          ( order_mono(B,C,Fa)
         => ( aa(set(B),$o,finite_finite(B),A4)
           => ( ( A4 != bot_bot(set(B)) )
             => ( aa(B,C,Fa,lattic643756798350308766er_Min(B,A4)) = lattic643756798350308766er_Min(C,aa(set(B),set(C),image2(B,C,Fa),A4)) ) ) ) ) ) ).

% mono_Min_commute
tff(fact_4005_finite_Omono,axiom,
    ! [B: $tType] : order_mono(fun(set(B),$o),fun(set(B),$o),aTP_Lamp_mz(fun(set(B),$o),fun(set(B),$o))) ).

% finite.mono
tff(fact_4006_lfp__induct,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(B,B),Pa: B] :
          ( order_mono(B,B,Fa)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,Fa,aa(B,B,aa(B,fun(B,B),inf_inf(B),complete_lattice_lfp(B,Fa)),Pa))),Pa)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),complete_lattice_lfp(B,Fa)),Pa) ) ) ) ).

% lfp_induct
tff(fact_4007_def__lfp__induct,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: B,Fa: fun(B,B),Pa: B] :
          ( ( A4 = complete_lattice_lfp(B,Fa) )
         => ( order_mono(B,B,Fa)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,Fa,aa(B,B,aa(B,fun(B,B),inf_inf(B),A4),Pa))),Pa)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A4),Pa) ) ) ) ) ).

% def_lfp_induct
tff(fact_4008_cInf__cSup,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [S2: set(B)] :
          ( ( S2 != bot_bot(set(B)) )
         => ( condit1013018076250108175_below(B,S2)
           => ( aa(set(B),B,complete_Inf_Inf(B),S2) = aa(set(B),B,complete_Sup_Sup(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_oi(set(B),fun(B,$o),S2))) ) ) ) ) ).

% cInf_cSup
tff(fact_4009_cSup__cInf,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [S2: set(B)] :
          ( ( S2 != bot_bot(set(B)) )
         => ( condit941137186595557371_above(B,S2)
           => ( aa(set(B),B,complete_Sup_Sup(B),S2) = aa(set(B),B,complete_Inf_Inf(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_oj(set(B),fun(B,$o),S2))) ) ) ) ) ).

% cSup_cInf
tff(fact_4010_ball__empty,axiom,
    ! [B: $tType,Pa: fun(B,$o),X3: B] :
      ( member(B,X3,bot_bot(set(B)))
     => aa(B,$o,Pa,X3) ) ).

% ball_empty
tff(fact_4011_def__lfp__induct__set,axiom,
    ! [B: $tType,A4: set(B),Fa: fun(set(B),set(B)),A3: B,Pa: fun(B,$o)] :
      ( ( A4 = complete_lattice_lfp(set(B),Fa) )
     => ( order_mono(set(B),set(B),Fa)
       => ( member(B,A3,A4)
         => ( ! [X2: B] :
                ( member(B,X2,aa(set(B),set(B),Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(fun(B,$o),set(B),collect(B),Pa))))
               => aa(B,$o,Pa,X2) )
           => aa(B,$o,Pa,A3) ) ) ) ) ).

% def_lfp_induct_set
tff(fact_4012_lfp__induct__set,axiom,
    ! [B: $tType,A3: B,Fa: fun(set(B),set(B)),Pa: fun(B,$o)] :
      ( member(B,A3,complete_lattice_lfp(set(B),Fa))
     => ( order_mono(set(B),set(B),Fa)
       => ( ! [X2: B] :
              ( member(B,X2,aa(set(B),set(B),Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),complete_lattice_lfp(set(B),Fa)),aa(fun(B,$o),set(B),collect(B),Pa))))
             => aa(B,$o,Pa,X2) )
         => aa(B,$o,Pa,A3) ) ) ) ).

% lfp_induct_set
tff(fact_4013_mono__compose,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType] :
      ( ( order(D)
        & order(B) )
     => ! [Qa: fun(B,fun(C,D)),Fa: fun(E,C)] :
          ( order_mono(B,fun(C,D),Qa)
         => order_mono(B,fun(E,D),aa(fun(E,C),fun(B,fun(E,D)),aTP_Lamp_ok(fun(B,fun(C,D)),fun(fun(E,C),fun(B,fun(E,D))),Qa),Fa)) ) ) ).

% mono_compose
tff(fact_4014_Ball__image__comp,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),A4: set(C),Ga: fun(B,$o)] :
      ( ! [X4: B] :
          ( member(B,X4,aa(set(C),set(B),image2(C,B,Fa),A4))
         => aa(B,$o,Ga,X4) )
    <=> ! [X4: C] :
          ( member(C,X4,A4)
         => aa(C,$o,aa(fun(C,B),fun(C,$o),aa(fun(B,$o),fun(fun(C,B),fun(C,$o)),comp(B,$o,C),Ga),Fa),X4) ) ) ).

% Ball_image_comp
tff(fact_4015_Ball__comp__iff,axiom,
    ! [B: $tType,C: $tType,D: $tType,A4: fun(C,set(D)),Fa: fun(D,$o),Ga: fun(B,C),X3: B] :
      ( aa(B,$o,aa(fun(B,C),fun(B,$o),aa(fun(C,$o),fun(fun(B,C),fun(B,$o)),comp(C,$o,B),aa(fun(D,$o),fun(C,$o),aTP_Lamp_ol(fun(C,set(D)),fun(fun(D,$o),fun(C,$o)),A4),Fa)),Ga),X3)
    <=> ! [Xa2: D] :
          ( member(D,Xa2,aa(B,set(D),aa(fun(B,C),fun(B,set(D)),aa(fun(C,set(D)),fun(fun(B,C),fun(B,set(D))),comp(C,set(D),B),A4),Ga),X3))
         => aa(D,$o,Fa,Xa2) ) ) ).

% Ball_comp_iff
tff(fact_4016_Chains__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( chains(B,R3) = aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_om(set(product_prod(B,B)),fun(set(B),$o),R3)) ) ).

% Chains_def
tff(fact_4017_refl__on__def_H,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] :
      ( refl_on(B,A4,R3)
    <=> ( ! [X4: product_prod(B,B)] :
            ( member(product_prod(B,B),X4,R3)
           => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aTP_Lamp_on(set(B),fun(B,fun(B,$o)),A4)),X4) )
        & ! [X4: B] :
            ( member(B,X4,A4)
           => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),X4),R3) ) ) ) ).

% refl_on_def'
tff(fact_4018_lfp__induct2,axiom,
    ! [B: $tType,C: $tType,A3: B,Ba: C,Fa: fun(set(product_prod(B,C)),set(product_prod(B,C))),Pa: fun(B,fun(C,$o))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),complete_lattice_lfp(set(product_prod(B,C)),Fa))
     => ( order_mono(set(product_prod(B,C)),set(product_prod(B,C)),Fa)
       => ( ! [A8: B,B4: C] :
              ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4),aa(set(product_prod(B,C)),set(product_prod(B,C)),Fa,aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),complete_lattice_lfp(set(product_prod(B,C)),Fa)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Pa)))))
             => aa(C,$o,aa(B,fun(C,$o),Pa,A8),B4) )
         => aa(C,$o,aa(B,fun(C,$o),Pa,A3),Ba) ) ) ) ).

% lfp_induct2
tff(fact_4019_UnderS__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] : ( order_UnderS(B,R3,A4) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_oo(set(product_prod(B,B)),fun(set(B),fun(B,$o)),R3),A4)) ) ).

% UnderS_def
tff(fact_4020_Under__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] : ( order_Under(B,R3,A4) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_op(set(product_prod(B,B)),fun(set(B),fun(B,$o)),R3),A4)) ) ).

% Under_def
tff(fact_4021_Above__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] : ( order_Above(B,R3,A4) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_oq(set(product_prod(B,B)),fun(set(B),fun(B,$o)),R3),A4)) ) ).

% Above_def
tff(fact_4022_min__ext__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( min_ext(B,R3) = aa(fun(product_prod(set(B),set(B)),$o),set(product_prod(set(B),set(B))),collect(product_prod(set(B),set(B))),aTP_Lamp_or(set(product_prod(B,B)),fun(product_prod(set(B),set(B)),$o),R3)) ) ).

% min_ext_def
tff(fact_4023_bex__empty,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ~ ? [X3: B] :
          ( member(B,X3,bot_bot(set(B)))
          & aa(B,$o,Pa,X3) ) ).

% bex_empty
tff(fact_4024_conj__comp__iff,axiom,
    ! [C: $tType,B: $tType,Pa: fun(C,$o),Qa: fun(C,$o),Ga: fun(B,C),X3: B] :
      ( aa(B,$o,aa(fun(B,C),fun(B,$o),aa(fun(C,$o),fun(fun(B,C),fun(B,$o)),comp(C,$o,B),aa(fun(C,$o),fun(C,$o),aTP_Lamp_os(fun(C,$o),fun(fun(C,$o),fun(C,$o)),Pa),Qa)),Ga),X3)
    <=> ( aa(B,$o,aa(fun(B,C),fun(B,$o),aa(fun(C,$o),fun(fun(B,C),fun(B,$o)),comp(C,$o,B),Pa),Ga),X3)
        & aa(B,$o,aa(fun(B,C),fun(B,$o),aa(fun(C,$o),fun(fun(B,C),fun(B,$o)),comp(C,$o,B),Qa),Ga),X3) ) ) ).

% conj_comp_iff
tff(fact_4025_Image__def,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,B)),S: set(C)] : ( image(C,B,R3,S) = aa(fun(B,$o),set(B),collect(B),aa(set(C),fun(B,$o),aTP_Lamp_ot(set(product_prod(C,B)),fun(set(C),fun(B,$o)),R3),S)) ) ).

% Image_def
tff(fact_4026_max__extp_Ocases,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),A1: set(B),A22: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),max_extp(B,R),A1),A22)
     => ~ ( aa(set(B),$o,finite_finite(B),A1)
         => ( aa(set(B),$o,finite_finite(B),A22)
           => ( ( A22 != aa(fun(B,$o),set(B),collect(B),bot_bot(fun(B,$o))) )
             => ~ ! [X3: B] :
                    ( member(B,X3,A1)
                   => ? [Xa4: B] :
                        ( member(B,Xa4,A22)
                        & aa(B,$o,aa(B,fun(B,$o),R,X3),Xa4) ) ) ) ) ) ) ).

% max_extp.cases
tff(fact_4027_max__extp_Osimps,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),A1: set(B),A22: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),max_extp(B,R),A1),A22)
    <=> ( aa(set(B),$o,finite_finite(B),A1)
        & aa(set(B),$o,finite_finite(B),A22)
        & ( A22 != aa(fun(B,$o),set(B),collect(B),bot_bot(fun(B,$o))) )
        & ! [X4: B] :
            ( member(B,X4,A1)
           => ? [Xa2: B] :
                ( member(B,Xa2,A22)
                & aa(B,$o,aa(B,fun(B,$o),R,X4),Xa2) ) ) ) ) ).

% max_extp.simps
tff(fact_4028_max__extp_Omax__extI,axiom,
    ! [B: $tType,X6: set(B),Y5: set(B),R: fun(B,fun(B,$o))] :
      ( aa(set(B),$o,finite_finite(B),X6)
     => ( aa(set(B),$o,finite_finite(B),Y5)
       => ( ( Y5 != aa(fun(B,$o),set(B),collect(B),bot_bot(fun(B,$o))) )
         => ( ! [X2: B] :
                ( member(B,X2,X6)
               => ? [Xa3: B] :
                    ( member(B,Xa3,Y5)
                    & aa(B,$o,aa(B,fun(B,$o),R,X2),Xa3) ) )
           => aa(set(B),$o,aa(set(B),fun(set(B),$o),max_extp(B,R),X6),Y5) ) ) ) ) ).

% max_extp.max_extI
tff(fact_4029_max__ext__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] : ( max_ext(B,R) = aa(fun(product_prod(set(B),set(B)),$o),set(product_prod(set(B),set(B))),collect(product_prod(set(B),set(B))),aa(fun(set(B),fun(set(B),$o)),fun(product_prod(set(B),set(B)),$o),product_case_prod(set(B),set(B),$o),aTP_Lamp_ou(set(product_prod(B,B)),fun(set(B),fun(set(B),$o)),R))) ) ).

% max_ext_eq
tff(fact_4030_AboveS__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] : ( order_AboveS(B,R3,A4) = aa(fun(B,$o),set(B),collect(B),aa(set(B),fun(B,$o),aTP_Lamp_ov(set(product_prod(B,B)),fun(set(B),fun(B,$o)),R3),A4)) ) ).

% AboveS_def
tff(fact_4031_flip__pred,axiom,
    ! [B: $tType,C: $tType,A4: set(product_prod(B,C)),R: fun(C,fun(B,$o))] :
      ( aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),A4),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),conversep(C,B,R))))
     => aa(set(product_prod(C,B)),$o,aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),$o),ord_less_eq(set(product_prod(C,B))),aa(set(product_prod(B,C)),set(product_prod(C,B)),image2(product_prod(B,C),product_prod(C,B),aa(fun(B,fun(C,product_prod(C,B))),fun(product_prod(B,C),product_prod(C,B)),product_case_prod(B,C,product_prod(C,B)),aTP_Lamp_es(B,fun(C,product_prod(C,B))))),A4)),aa(fun(product_prod(C,B),$o),set(product_prod(C,B)),collect(product_prod(C,B)),aa(fun(C,fun(B,$o)),fun(product_prod(C,B),$o),product_case_prod(C,B,$o),R))) ) ).

% flip_pred
tff(fact_4032_acyclic__insert,axiom,
    ! [B: $tType,Y: B,X: B,R3: set(product_prod(B,B))] :
      ( transitive_acyclic(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),X)),R3))
    <=> ( transitive_acyclic(B,R3)
        & ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,R3)) ) ) ).

% acyclic_insert
tff(fact_4033_acyclic__empty,axiom,
    ! [B: $tType] : transitive_acyclic(B,bot_bot(set(product_prod(B,B)))) ).

% acyclic_empty
tff(fact_4034_converse__meet,axiom,
    ! [B: $tType,C: $tType,R3: fun(C,fun(B,$o)),S: fun(C,fun(B,$o))] : ( conversep(C,B,aa(fun(C,fun(B,$o)),fun(C,fun(B,$o)),aa(fun(C,fun(B,$o)),fun(fun(C,fun(B,$o)),fun(C,fun(B,$o))),inf_inf(fun(C,fun(B,$o))),R3),S)) = aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),conversep(C,B,R3)),conversep(C,B,S)) ) ).

% converse_meet
tff(fact_4035_acyclicI__order,axiom,
    ! [C: $tType,B: $tType] :
      ( preorder(C)
     => ! [R3: set(product_prod(B,B)),Fa: fun(B,C)] :
          ( ! [A8: B,B4: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),B4),R3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Fa,B4)),aa(B,C,Fa,A8)) )
         => transitive_acyclic(B,R3) ) ) ).

% acyclicI_order
tff(fact_4036_acyclicI,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ! [X2: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2),transitive_trancl(B,R3))
     => transitive_acyclic(B,R3) ) ).

% acyclicI
tff(fact_4037_acyclic__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( transitive_acyclic(B,R3)
    <=> ! [X4: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),X4),transitive_trancl(B,R3)) ) ).

% acyclic_def
tff(fact_4038_cyclicE,axiom,
    ! [B: $tType,Ga: set(product_prod(B,B))] :
      ( ~ transitive_acyclic(B,Ga)
     => ~ ! [X2: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2),transitive_trancl(B,Ga)) ) ).

% cyclicE
tff(fact_4039_AboveS__disjoint,axiom,
    ! [B: $tType,A4: set(B),R3: set(product_prod(B,B))] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),order_AboveS(B,R3,A4)) = bot_bot(set(B)) ) ).

% AboveS_disjoint
tff(fact_4040_Least__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Pa: fun(B,$o)] : ( ord_Least(B,Pa) = the(B,aTP_Lamp_ow(fun(B,$o),fun(B,$o),Pa)) ) ) ).

% Least_def
tff(fact_4041_acyclic__insert__cyclic,axiom,
    ! [B: $tType,Ga: set(product_prod(B,B)),X: B,Y: B] :
      ( transitive_acyclic(B,Ga)
     => ( ~ transitive_acyclic(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y)),Ga))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),X),transitive_rtrancl(B,Ga)) ) ) ).

% acyclic_insert_cyclic
tff(fact_4042_Greatest__def,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o)] : ( order_Greatest(B,Pa) = the(B,aTP_Lamp_ox(fun(B,$o),fun(B,$o),Pa)) ) ) ).

% Greatest_def
tff(fact_4043_wo__rel_Osuc__greater,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),B2: set(B),Ba: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
       => ( ( order_AboveS(B,R3,B2) != bot_bot(set(B)) )
         => ( member(B,Ba,B2)
           => ( ( bNF_Wellorder_wo_suc(B,R3,B2) != Ba )
              & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),bNF_Wellorder_wo_suc(B,R3,B2)),R3) ) ) ) ) ) ).

% wo_rel.suc_greater
tff(fact_4044_wo__rel_Osuc__ofilter__in,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B),Ba: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( order_ofilter(B,R3,A4)
       => ( ( order_AboveS(B,R3,A4) != bot_bot(set(B)) )
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),bNF_Wellorder_wo_suc(B,R3,A4)),R3)
           => ( ( Ba != bNF_Wellorder_wo_suc(B,R3,A4) )
             => member(B,Ba,A4) ) ) ) ) ) ).

% wo_rel.suc_ofilter_in
tff(fact_4045_wo__rel_Osuc__AboveS,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
       => ( ( order_AboveS(B,R3,B2) != bot_bot(set(B)) )
         => member(B,bNF_Wellorder_wo_suc(B,R3,B2),order_AboveS(B,R3,B2)) ) ) ) ).

% wo_rel.suc_AboveS
tff(fact_4046_GreatestI2__order,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o),X: B,Qa: fun(B,$o)] :
          ( aa(B,$o,Pa,X)
         => ( ! [Y2: B] :
                ( aa(B,$o,Pa,Y2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),X) )
           => ( ! [X2: B] :
                  ( aa(B,$o,Pa,X2)
                 => ( ! [Y4: B] :
                        ( aa(B,$o,Pa,Y4)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y4),X2) )
                   => aa(B,$o,Qa,X2) ) )
             => aa(B,$o,Qa,order_Greatest(B,Pa)) ) ) ) ) ).

% GreatestI2_order
tff(fact_4047_Greatest__equality,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Pa: fun(B,$o),X: B] :
          ( aa(B,$o,Pa,X)
         => ( ! [Y2: B] :
                ( aa(B,$o,Pa,Y2)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y2),X) )
           => ( order_Greatest(B,Pa) = X ) ) ) ) ).

% Greatest_equality
tff(fact_4048_wo__rel_Osuc__least__AboveS,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( member(B,A3,order_AboveS(B,R3,B2))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),bNF_Wellorder_wo_suc(B,R3,B2)),A3),R3) ) ) ).

% wo_rel.suc_least_AboveS
tff(fact_4049_wo__rel_Oequals__suc__AboveS,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),B2: set(B),A3: B] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
       => ( member(B,A3,order_AboveS(B,R3,B2))
         => ( ! [A9: B] :
                ( member(B,A9,order_AboveS(B,R3,B2))
               => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),A9),R3) )
           => ( A3 = bNF_Wellorder_wo_suc(B,R3,B2) ) ) ) ) ) ).

% wo_rel.equals_suc_AboveS
tff(fact_4050_wo__rel_Osuc__inField,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),B2: set(B)] :
      ( bNF_Wellorder_wo_rel(B,R3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),field2(B,R3))
       => ( ( order_AboveS(B,R3,B2) != bot_bot(set(B)) )
         => member(B,bNF_Wellorder_wo_suc(B,R3,B2),field2(B,R3)) ) ) ) ).

% wo_rel.suc_inField
tff(fact_4051_ord_OLeast__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Pa: fun(B,$o)] : ( aa(fun(B,$o),B,least(B,Less_eq),Pa) = the(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_oy(fun(B,fun(B,$o)),fun(fun(B,$o),fun(B,$o)),Less_eq),Pa)) ) ).

% ord.Least_def
tff(fact_4052_fun_Orel__compp__Grp,axiom,
    ! [B: $tType,D: $tType,C: $tType,R: fun(C,fun(D,$o))] : ( bNF_rel_fun(B,B,C,D,fequal(B),R) = relcompp(fun(B,C),fun(B,product_prod(C,D)),fun(B,D),conversep(fun(B,product_prod(C,D)),fun(B,C),bNF_Grp(fun(B,product_prod(C,D)),fun(B,C),aa(fun(fun(B,product_prod(C,D)),$o),set(fun(B,product_prod(C,D))),collect(fun(B,product_prod(C,D))),aTP_Lamp_gr(fun(C,fun(D,$o)),fun(fun(B,product_prod(C,D)),$o),R)),aa(fun(product_prod(C,D),C),fun(fun(B,product_prod(C,D)),fun(B,C)),comp(product_prod(C,D),C,B),product_fst(C,D)))),bNF_Grp(fun(B,product_prod(C,D)),fun(B,D),aa(fun(fun(B,product_prod(C,D)),$o),set(fun(B,product_prod(C,D))),collect(fun(B,product_prod(C,D))),aTP_Lamp_gr(fun(C,fun(D,$o)),fun(fun(B,product_prod(C,D)),$o),R)),aa(fun(product_prod(C,D),D),fun(fun(B,product_prod(C,D)),fun(B,D)),comp(product_prod(C,D),D,B),product_snd(C,D)))) ) ).

% fun.rel_compp_Grp
tff(fact_4053_init__seg__of__def,axiom,
    ! [B: $tType] : ( init_seg_of(B) = aa(fun(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),$o),set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),collect(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),aa(fun(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o)),fun(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),$o),product_case_prod(set(product_prod(B,B)),set(product_prod(B,B)),$o),aTP_Lamp_oz(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o)))) ) ).

% init_seg_of_def
tff(fact_4054_inf__filter__def,axiom,
    ! [B: $tType,F: filter(B),F2: filter(B)] : ( aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F),F2) = abs_filter(B,aa(filter(B),fun(fun(B,$o),$o),aTP_Lamp_pa(filter(B),fun(filter(B),fun(fun(B,$o),$o)),F),F2)) ) ).

% inf_filter_def
tff(fact_4055_relcompp__bot1,axiom,
    ! [D: $tType,C: $tType,B: $tType,R: fun(D,fun(C,$o))] : ( relcompp(B,D,C,bot_bot(fun(B,fun(D,$o))),R) = bot_bot(fun(B,fun(C,$o))) ) ).

% relcompp_bot1
tff(fact_4056_relcompp__bot2,axiom,
    ! [D: $tType,C: $tType,B: $tType,R: fun(B,fun(D,$o))] : ( relcompp(B,D,C,R,bot_bot(fun(D,fun(C,$o)))) = bot_bot(fun(B,fun(C,$o))) ) ).

% relcompp_bot2
tff(fact_4057_ord_OLeast_Ocong,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o))] : ( least(B,Less_eq) = least(B,Less_eq) ) ).

% ord.Least.cong
tff(fact_4058_refl__on__init__seg__of,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),R3),init_seg_of(B)) ).

% refl_on_init_seg_of
tff(fact_4059_antisym__init__seg__of,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),S: set(product_prod(B,B))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),S),init_seg_of(B))
     => ( member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),S),R3),init_seg_of(B))
       => ( R3 = S ) ) ) ).

% antisym_init_seg_of
tff(fact_4060_trans__init__seg__of,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),S: set(product_prod(B,B)),T4: set(product_prod(B,B))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),S),init_seg_of(B))
     => ( member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),S),T4),init_seg_of(B))
       => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),T4),init_seg_of(B)) ) ) ).

% trans_init_seg_of
tff(fact_4061_bot__filter__def,axiom,
    ! [B: $tType] : ( bot_bot(filter(B)) = abs_filter(B,aTP_Lamp_pb(fun(B,$o),$o)) ) ).

% bot_filter_def
tff(fact_4062_relcompp__relcomp__eq,axiom,
    ! [B: $tType,C: $tType,D: $tType,R3: set(product_prod(B,D)),S: set(product_prod(D,C)),X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),relcompp(B,D,C,aTP_Lamp_pc(set(product_prod(B,D)),fun(B,fun(D,$o)),R3),aTP_Lamp_pd(set(product_prod(D,C)),fun(D,fun(C,$o)),S)),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),relcomp(B,D,C,R3,S)) ) ).

% relcompp_relcomp_eq
tff(fact_4063_relcomp__def,axiom,
    ! [B: $tType,D: $tType,C: $tType,X3: set(product_prod(B,C)),Xa3: set(product_prod(C,D))] : ( relcomp(B,C,D,X3,Xa3) = aa(fun(product_prod(B,D),$o),set(product_prod(B,D)),collect(product_prod(B,D)),aa(fun(B,fun(D,$o)),fun(product_prod(B,D),$o),product_case_prod(B,D,$o),relcompp(B,C,D,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),X3),aTP_Lamp_pe(set(product_prod(C,D)),fun(C,fun(D,$o)),Xa3)))) ) ).

% relcomp_def
tff(fact_4064_Chains__init__seg__of__Union,axiom,
    ! [B: $tType,R: set(set(product_prod(B,B))),R3: set(product_prod(B,B))] :
      ( member(set(set(product_prod(B,B))),R,chains(set(product_prod(B,B)),init_seg_of(B)))
     => ( member(set(product_prod(B,B)),R3,R)
       => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),R3),aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),R)),init_seg_of(B)) ) ) ).

% Chains_init_seg_of_Union
tff(fact_4065_initial__segment__of__Diff,axiom,
    ! [B: $tType,P2: set(product_prod(B,B)),Q2: set(product_prod(B,B)),S: set(product_prod(B,B))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),P2),Q2),init_seg_of(B))
     => member(product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),product_Pair(set(product_prod(B,B)),set(product_prod(B,B))),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),P2),S)),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),Q2),S)),init_seg_of(B)) ) ).

% initial_segment_of_Diff
tff(fact_4066_irrefl__tranclI,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X: B] :
      ( ( aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),converse(B,B,R3)),transitive_rtrancl(B,R3)) = bot_bot(set(product_prod(B,B))) )
     => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),X),transitive_trancl(B,R3)) ) ).

% irrefl_tranclI
tff(fact_4067_su__rel__fun_Of__def,axiom,
    ! [C: $tType,B: $tType,F: set(product_prod(B,C)),Fa: fun(B,C),A4: B] :
      ( su_rel_fun(B,C,F,Fa)
     => ( aa(B,C,Fa,A4) = the(C,aa(B,fun(C,$o),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),F),A4)) ) ) ).

% su_rel_fun.f_def
tff(fact_4068_su__rel__fun_Ointro,axiom,
    ! [C: $tType,B: $tType,F: set(product_prod(B,C)),Fa: fun(B,C)] :
      ( ! [A12: B,B8: C,B11: C] :
          ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A12),B8),F)
         => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A12),B11),F)
           => ( B8 = B11 ) ) )
     => ( ! [A12: B,P4: $o] :
            ( ! [B13: C] :
                ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A12),B13),F)
               => (P4) )
           => (P4) )
       => ( ! [A12: B] : ( aa(B,C,Fa,A12) = the(C,aa(B,fun(C,$o),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),F),A12)) )
         => su_rel_fun(B,C,F,Fa) ) ) ) ).

% su_rel_fun.intro
tff(fact_4069_su__rel__fun__def,axiom,
    ! [C: $tType,B: $tType,F: set(product_prod(B,C)),Fa: fun(B,C)] :
      ( su_rel_fun(B,C,F,Fa)
    <=> ( ! [A11: B,B7: C,B14: C] :
            ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A11),B7),F)
           => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A11),B14),F)
             => ( B7 = B14 ) ) )
        & ! [A11: B,P3: $o] :
            ( ! [B7: C] :
                ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A11),B7),F)
               => (P3) )
           => (P3) )
        & ! [A11: B] : ( aa(B,C,Fa,A11) = the(C,aa(B,fun(C,$o),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),F),A11)) ) ) ) ).

% su_rel_fun_def
tff(fact_4070_converse__iff,axiom,
    ! [B: $tType,C: $tType,A3: B,Ba: C,R3: set(product_prod(C,B))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),converse(C,B,R3))
    <=> member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Ba),A3),R3) ) ).

% converse_iff
tff(fact_4071_converse__empty,axiom,
    ! [C: $tType,B: $tType] : ( converse(C,B,bot_bot(set(product_prod(C,B)))) = bot_bot(set(product_prod(B,C))) ) ).

% converse_empty
tff(fact_4072_converse_Ocases,axiom,
    ! [B: $tType,C: $tType,A1: B,A22: C,R3: set(product_prod(C,B))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A1),A22),converse(C,B,R3))
     => member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),A22),A1),R3) ) ).

% converse.cases
tff(fact_4073_converse_Osimps,axiom,
    ! [B: $tType,C: $tType,A1: B,A22: C,R3: set(product_prod(C,B))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A1),A22),converse(C,B,R3))
    <=> ? [A6: C,B5: B] :
          ( ( A1 = B5 )
          & ( A22 = A6 )
          & member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),A6),B5),R3) ) ) ).

% converse.simps
tff(fact_4074_converseD,axiom,
    ! [B: $tType,C: $tType,A3: B,Ba: C,R3: set(product_prod(C,B))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),converse(C,B,R3))
     => member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Ba),A3),R3) ) ).

% converseD
tff(fact_4075_converseE,axiom,
    ! [B: $tType,C: $tType,Yx: product_prod(B,C),R3: set(product_prod(C,B))] :
      ( member(product_prod(B,C),Yx,converse(C,B,R3))
     => ~ ! [X2: C,Y2: B] :
            ( ( Yx = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Y2),X2) )
           => ~ member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X2),Y2),R3) ) ) ).

% converseE
tff(fact_4076_converseI,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,R3: set(product_prod(B,C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),R3)
     => member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Ba),A3),converse(B,C,R3)) ) ).

% converseI
tff(fact_4077_converse__Int,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,B)),S: set(product_prod(C,B))] : ( converse(C,B,aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),set(product_prod(C,B))),inf_inf(set(product_prod(C,B))),R3),S)) = aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),converse(C,B,R3)),converse(C,B,S)) ) ).

% converse_Int
tff(fact_4078_rtrancl__converseD,axiom,
    ! [B: $tType,X: B,Y: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,converse(B,B,R3)))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),X),transitive_rtrancl(B,R3)) ) ).

% rtrancl_converseD
tff(fact_4079_rtrancl__converseI,axiom,
    ! [B: $tType,Y: B,X: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),X),transitive_rtrancl(B,R3))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,converse(B,B,R3))) ) ).

% rtrancl_converseI
tff(fact_4080_trancl__converseI,axiom,
    ! [B: $tType,X: B,Y: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),converse(B,B,transitive_trancl(B,R3)))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_trancl(B,converse(B,B,R3))) ) ).

% trancl_converseI
tff(fact_4081_trancl__converseD,axiom,
    ! [B: $tType,X: B,Y: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_trancl(B,converse(B,B,R3)))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),converse(B,B,transitive_trancl(B,R3))) ) ).

% trancl_converseD
tff(fact_4082_su__rel__fun_Osurjective,axiom,
    ! [C: $tType,B: $tType,F: set(product_prod(B,C)),Fa: fun(B,C),A4: B] :
      ( su_rel_fun(B,C,F,Fa)
     => ~ ! [B8: C] : ~ member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B8),F) ) ).

% su_rel_fun.surjective
tff(fact_4083_su__rel__fun_Ounique,axiom,
    ! [B: $tType,C: $tType,F: set(product_prod(B,C)),Fa: fun(B,C),A4: B,B2: C,B15: C] :
      ( su_rel_fun(B,C,F,Fa)
     => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B2),F)
       => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B15),F)
         => ( B2 = B15 ) ) ) ) ).

% su_rel_fun.unique
tff(fact_4084_su__rel__fun_Orepr2,axiom,
    ! [C: $tType,B: $tType,F: set(product_prod(B,C)),Fa: fun(B,C),A4: B,B2: C] :
      ( su_rel_fun(B,C,F,Fa)
     => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B2),F)
       => ( B2 = aa(B,C,Fa,A4) ) ) ) ).

% su_rel_fun.repr2
tff(fact_4085_su__rel__fun_Orepr1,axiom,
    ! [C: $tType,B: $tType,F: set(product_prod(B,C)),Fa: fun(B,C),A4: B] :
      ( su_rel_fun(B,C,F,Fa)
     => member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),aa(B,C,Fa,A4)),F) ) ).

% su_rel_fun.repr1
tff(fact_4086_su__rel__fun_Orepr,axiom,
    ! [C: $tType,B: $tType,F: set(product_prod(B,C)),Fa: fun(B,C),A4: B,B2: C] :
      ( su_rel_fun(B,C,F,Fa)
     => ( ( aa(B,C,Fa,A4) = B2 )
      <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A4),B2),F) ) ) ).

% su_rel_fun.repr
tff(fact_4087_converse__unfold,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,B))] : ( converse(C,B,R3) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_pf(set(product_prod(C,B)),fun(B,fun(C,$o)),R3))) ) ).

% converse_unfold
tff(fact_4088_conversep__converse__eq,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,B)),X3: B,Xa3: C] :
      ( aa(C,$o,aa(B,fun(C,$o),conversep(C,B,aTP_Lamp_ll(set(product_prod(C,B)),fun(C,fun(B,$o)),R3)),X3),Xa3)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3),converse(C,B,R3)) ) ).

% conversep_converse_eq
tff(fact_4089_converse__def,axiom,
    ! [C: $tType,B: $tType,X3: set(product_prod(B,C))] : ( converse(B,C,X3) = aa(fun(product_prod(C,B),$o),set(product_prod(C,B)),collect(product_prod(C,B)),aa(fun(C,fun(B,$o)),fun(product_prod(C,B),$o),product_case_prod(C,B,$o),conversep(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),X3)))) ) ).

% converse_def
tff(fact_4090_trans__wf__iff,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( trans(B,R3)
     => ( wf(B,R3)
      <=> ! [A6: B] : wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,image(B,B,converse(B,B,R3),aa(set(B),set(B),insert2(B,A6),bot_bot(set(B)))),aa(B,fun(B,set(B)),aTP_Lamp_pg(set(product_prod(B,B)),fun(B,fun(B,set(B))),R3),A6)))) ) ) ).

% trans_wf_iff
tff(fact_4091_Image__INT__eq,axiom,
    ! [C: $tType,B: $tType,D: $tType,R3: set(product_prod(C,B)),A4: set(D),B2: fun(D,set(C))] :
      ( single_valued(B,C,converse(C,B,R3))
     => ( ( A4 != bot_bot(set(D)) )
       => ( image(C,B,R3,aa(set(set(C)),set(C),complete_Inf_Inf(set(C)),aa(set(D),set(set(C)),image2(D,set(C),B2),A4))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_ph(set(product_prod(C,B)),fun(fun(D,set(C)),fun(D,set(B))),R3),B2)),A4)) ) ) ) ).

% Image_INT_eq
tff(fact_4092_ord__to__filter__compat,axiom,
    ! [B: $tType,R0: set(product_prod(B,B))] : bNF_Wellorder_compat(set(product_prod(B,B)),set(B),aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),aa(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),fun(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B)))),set(product_prod(set(product_prod(B,B)),set(product_prod(B,B))))),inf_inf(set(product_prod(set(product_prod(B,B)),set(product_prod(B,B))))),bNF_We4044943003108391690rdLess(B,B)),product_Sigma(set(product_prod(B,B)),set(product_prod(B,B)),image(set(product_prod(B,B)),set(product_prod(B,B)),converse(set(product_prod(B,B)),set(product_prod(B,B)),bNF_We4044943003108391690rdLess(B,B)),aa(set(set(product_prod(B,B))),set(set(product_prod(B,B))),insert2(set(product_prod(B,B)),R0),bot_bot(set(set(product_prod(B,B)))))),aTP_Lamp_pi(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(set(product_prod(B,B)))),R0))),bNF_We413866401316099525erIncl(B,R0),bNF_We8469521843155493636filter(B,R0)) ).

% ord_to_filter_compat
tff(fact_4093_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(nat,nat)] :
      ( ( nat_prod_decode_aux(X,Xa) = Y )
     => ( aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa))
       => ~ ( ( Y
              = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xa),X),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Xa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),Xa)),nat_prod_decode_aux(aa(nat,nat,suc,X),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),aa(nat,nat,suc,X)))) )
           => ~ aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),Xa)) ) ) ) ).

% prod_decode_aux.pelims
tff(fact_4094_trans__empty,axiom,
    ! [B: $tType] : trans(B,bot_bot(set(product_prod(B,B)))) ).

% trans_empty
tff(fact_4095_trans__Int,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),S: set(product_prod(B,B))] :
      ( trans(B,R3)
     => ( trans(B,S)
       => trans(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),S)) ) ) ).

% trans_Int
tff(fact_4096_transD,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X: B,Y: B,Z2: B] :
      ( trans(B,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
       => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),Z2),R3)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),R3) ) ) ) ).

% transD
tff(fact_4097_transE,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X: B,Y: B,Z2: B] :
      ( trans(B,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
       => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),Z2),R3)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),R3) ) ) ) ).

% transE
tff(fact_4098_transI,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ! [X2: B,Y2: B,Z3: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),R3)
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),R3)
           => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Z3),R3) ) )
     => trans(B,R3) ) ).

% transI
tff(fact_4099_trans__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( trans(B,R3)
    <=> ! [X4: B,Y3: B,Z4: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Y3),R3)
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y3),Z4),R3)
           => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Z4),R3) ) ) ) ).

% trans_def
tff(fact_4100_single__valuedD,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,C)),X: B,Y: C,Z2: C] :
      ( single_valued(B,C,R3)
     => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y),R3)
       => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Z2),R3)
         => ( Y = Z2 ) ) ) ) ).

% single_valuedD
tff(fact_4101_single__valuedI,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,C))] :
      ( ! [X2: B,Y2: C,Z3: C] :
          ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2),R3)
         => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Z3),R3)
           => ( Y2 = Z3 ) ) )
     => single_valued(B,C,R3) ) ).

% single_valuedI
tff(fact_4102_single__valued__def,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,C))] :
      ( single_valued(B,C,R3)
    <=> ! [X4: B,Y3: C] :
          ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Y3),R3)
         => ! [Z4: C] :
              ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Z4),R3)
             => ( Y3 = Z4 ) ) ) ) ).

% single_valued_def
tff(fact_4103_single__valued__empty,axiom,
    ! [C: $tType,B: $tType] : single_valued(B,C,bot_bot(set(product_prod(B,C)))) ).

% single_valued_empty
tff(fact_4104_single__valued__inter2,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S2: set(product_prod(B,C))] :
      ( single_valued(B,C,R)
     => single_valued(B,C,aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),S2),R)) ) ).

% single_valued_inter2
tff(fact_4105_single__valued__inter1,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,C)),S2: set(product_prod(B,C))] :
      ( single_valued(B,C,R)
     => single_valued(B,C,aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),R),S2)) ) ).

% single_valued_inter1
tff(fact_4106_compat__def,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C)] :
      ( bNF_Wellorder_compat(B,C,R3,R4,Fa)
    <=> ! [A6: B,B5: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A6),B5),R3)
         => member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),aa(B,C,Fa,A6)),aa(B,C,Fa,B5)),R4) ) ) ).

% compat_def
tff(fact_4107_trans__Restr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A4: set(B)] :
      ( trans(B,R3)
     => trans(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),product_Sigma(B,B,A4,aTP_Lamp_if(set(B),fun(B,set(B)),A4)))) ) ).

% trans_Restr
tff(fact_4108_single__valued__confluent,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X: B,Y: B,Z2: B] :
      ( single_valued(B,B,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,R3))
       => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),transitive_rtrancl(B,R3))
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),Z2),transitive_rtrancl(B,R3))
            | member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z2),Y),transitive_rtrancl(B,R3)) ) ) ) ) ).

% single_valued_confluent
tff(fact_4109_under__incr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( trans(B,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),order_under(B,R3,A3)),order_under(B,R3,Ba)) ) ) ).

% under_incr
tff(fact_4110_trans__singleton,axiom,
    ! [B: $tType,A3: B] : trans(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),A3)),bot_bot(set(product_prod(B,B))))) ).

% trans_singleton
tff(fact_4111_trans__join,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( trans(B,R3)
    <=> ! [X4: product_prod(B,B)] :
          ( member(product_prod(B,B),X4,R3)
         => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aTP_Lamp_pk(set(product_prod(B,B)),fun(B,fun(B,$o)),R3)),X4) ) ) ).

% trans_join
tff(fact_4112_prod__decode__aux_Ocases,axiom,
    ! [X: product_prod(nat,nat)] :
      ~ ! [K2: nat,M5: nat] : ( X != aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),K2),M5) ) ).

% prod_decode_aux.cases
tff(fact_4113_underS__incr,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B,Ba: B] :
      ( trans(B,R3)
     => ( antisym(B,R3)
       => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
         => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),order_underS(B,R3,A3)),order_underS(B,R3,Ba)) ) ) ) ).

% underS_incr
tff(fact_4114_Image__Int__eq,axiom,
    ! [B: $tType,C: $tType,R: set(product_prod(C,B)),A4: set(C),B2: set(C)] :
      ( single_valued(B,C,converse(C,B,R))
     => ( image(C,B,R,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),image(C,B,R,A4)),image(C,B,R,B2)) ) ) ).

% Image_Int_eq
tff(fact_4115_prod__decode__aux_Osimps,axiom,
    ! [K: nat,M4: nat] :
      ( nat_prod_decode_aux(K,M4)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),K),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),M4),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),M4)),nat_prod_decode_aux(aa(nat,nat,suc,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M4),aa(nat,nat,suc,K)))) ) ).

% prod_decode_aux.simps
tff(fact_4116_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod(nat,nat)] :
      ( ( nat_prod_decode_aux(X,Xa) = Y )
     => ( Y
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xa),X),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Xa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X),Xa)),nat_prod_decode_aux(aa(nat,nat,suc,X),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),aa(nat,nat,suc,X)))) ) ) ).

% prod_decode_aux.elims
tff(fact_4117_wf__finite__segments,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( irrefl(B,R3)
     => ( trans(B,R3)
       => ( ! [X2: B] : aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_nk(set(product_prod(B,B)),fun(B,fun(B,$o)),R3),X2)))
         => wf(B,R3) ) ) ) ).

% wf_finite_segments
tff(fact_4118_single__valuedp__single__valued__eq,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,C))] :
      ( single_valuedp(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),R3))
    <=> single_valued(B,C,R3) ) ).

% single_valuedp_single_valued_eq
tff(fact_4119_set__encode__empty,axiom,
    nat_set_encode(bot_bot(set(nat))) = zero_zero(nat) ).

% set_encode_empty
tff(fact_4120_aboveS__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),A3: B] : ( order_aboveS(B,R3,A3) = aa(fun(B,$o),set(B),collect(B),aa(B,fun(B,$o),aTP_Lamp_pl(set(product_prod(B,B)),fun(B,fun(B,$o)),R3),A3)) ) ).

% aboveS_def
tff(fact_4121_irrefl__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( irrefl(B,R3)
    <=> ! [A6: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A6),A6),R3) ) ).

% irrefl_def
tff(fact_4122_irreflI,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ! [A8: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),A8),R)
     => irrefl(B,R) ) ).

% irreflI
tff(fact_4123_single__valuedp__bot,axiom,
    ! [C: $tType,B: $tType] : single_valuedp(B,C,bot_bot(fun(B,fun(C,$o)))) ).

% single_valuedp_bot
tff(fact_4124_relInvImage__def,axiom,
    ! [C: $tType,B: $tType,A4: set(B),R: set(product_prod(C,C)),Fa: fun(B,C)] : ( bNF_Gr7122648621184425601vImage(B,C,A4,R,Fa) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,C),fun(product_prod(B,B),$o),aa(set(product_prod(C,C)),fun(fun(B,C),fun(product_prod(B,B),$o)),aTP_Lamp_pm(set(B),fun(set(product_prod(C,C)),fun(fun(B,C),fun(product_prod(B,B),$o))),A4),R),Fa)) ) ).

% relInvImage_def
tff(fact_4125_Heap__lub__empty,axiom,
    ! [B: $tType] : ( aa(set(heap_Time_Heap(B)),heap_Time_Heap(B),heap_Time_Heap_lub(B),bot_bot(set(heap_Time_Heap(B)))) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),aTP_Lamp_mi(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))) ) ).

% Heap_lub_empty
tff(fact_4126_normalize__stable,axiom,
    ! [Q2: int,P2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q2)
     => ( algebr8660921524188924756oprime(int,P2,Q2)
       => ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2) ) ) ) ).

% normalize_stable
tff(fact_4127_semilattice__order__set_Osubset__imp,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: set(B),B2: set(B)] :
      ( lattic4895041142388067077er_set(B,Fa,Less_eq,Less)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
       => ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(B),$o,finite_finite(B),B2)
           => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),B2)),aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4)) ) ) ) ) ).

% semilattice_order_set.subset_imp
tff(fact_4128_coprime__mult__right__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,C2,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba))
        <=> ( algebr8660921524188924756oprime(B,C2,A3)
            & algebr8660921524188924756oprime(B,C2,Ba) ) ) ) ).

% coprime_mult_right_iff
tff(fact_4129_coprime__mult__left__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( algebr8660921524188924756oprime(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2)
        <=> ( algebr8660921524188924756oprime(B,A3,C2)
            & algebr8660921524188924756oprime(B,Ba,C2) ) ) ) ).

% coprime_mult_left_iff
tff(fact_4130_coprime__self,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B] :
          ( algebr8660921524188924756oprime(B,A3,A3)
        <=> dvd_dvd(B,A3,one_one(B)) ) ) ).

% coprime_self
tff(fact_4131_coprime__imp__gcd__eq__1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,A3,Ba)
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) = one_one(B) ) ) ) ).

% coprime_imp_gcd_eq_1
tff(fact_4132_coprime__0__left__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B] :
          ( algebr8660921524188924756oprime(B,zero_zero(B),A3)
        <=> dvd_dvd(B,A3,one_one(B)) ) ) ).

% coprime_0_left_iff
tff(fact_4133_coprime__0__right__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B] :
          ( algebr8660921524188924756oprime(B,A3,zero_zero(B))
        <=> dvd_dvd(B,A3,one_one(B)) ) ) ).

% coprime_0_right_iff
tff(fact_4134_coprime__mult__self__left__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
        <=> ( dvd_dvd(B,C2,one_one(B))
            & algebr8660921524188924756oprime(B,A3,Ba) ) ) ) ).

% coprime_mult_self_left_iff
tff(fact_4135_coprime__mult__self__right__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
        <=> ( dvd_dvd(B,C2,one_one(B))
            & algebr8660921524188924756oprime(B,A3,Ba) ) ) ) ).

% coprime_mult_self_right_iff
tff(fact_4136_is__unit__gcd,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba),one_one(B))
        <=> algebr8660921524188924756oprime(B,A3,Ba) ) ) ).

% is_unit_gcd
tff(fact_4137_coprime__1__right,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B] : algebr8660921524188924756oprime(B,A3,one_one(B)) ) ).

% coprime_1_right
tff(fact_4138_coprime__1__left,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B] : algebr8660921524188924756oprime(B,one_one(B),A3) ) ).

% coprime_1_left
tff(fact_4139_coprime__add__one__right,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B] : algebr8660921524188924756oprime(B,A3,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B))) ) ).

% coprime_add_one_right
tff(fact_4140_coprime__add__one__left,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B] : algebr8660921524188924756oprime(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A3),one_one(B)),A3) ) ).

% coprime_add_one_left
tff(fact_4141_coprime__doff__one__right,axiom,
    ! [B: $tType] :
      ( ring_gcd(B)
     => ! [A3: B] : algebr8660921524188924756oprime(B,A3,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))) ) ).

% coprime_doff_one_right
tff(fact_4142_coprime__diff__one__left,axiom,
    ! [B: $tType] :
      ( ring_gcd(B)
     => ! [A3: B] : algebr8660921524188924756oprime(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B)),A3) ) ).

% coprime_diff_one_left
tff(fact_4143_coprime__dvd__mult__right__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,A3,C2)
         => ( dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))
          <=> dvd_dvd(B,A3,Ba) ) ) ) ).

% coprime_dvd_mult_right_iff
tff(fact_4144_coprime__dvd__mult__left__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,A3,C2)
         => ( dvd_dvd(B,A3,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))
          <=> dvd_dvd(B,A3,Ba) ) ) ) ).

% coprime_dvd_mult_left_iff
tff(fact_4145_divides__mult,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( dvd_dvd(B,A3,C2)
         => ( dvd_dvd(B,Ba,C2)
           => ( algebr8660921524188924756oprime(B,A3,Ba)
             => dvd_dvd(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2) ) ) ) ) ).

% divides_mult
tff(fact_4146_is__unit__right__imp__coprime,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Ba: B,A3: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => algebr8660921524188924756oprime(B,A3,Ba) ) ) ).

% is_unit_right_imp_coprime
tff(fact_4147_is__unit__left__imp__coprime,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => algebr8660921524188924756oprime(B,A3,Ba) ) ) ).

% is_unit_left_imp_coprime
tff(fact_4148_coprime__common__divisor,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( algebr8660921524188924756oprime(B,A3,Ba)
         => ( dvd_dvd(B,C2,A3)
           => ( dvd_dvd(B,C2,Ba)
             => dvd_dvd(B,C2,one_one(B)) ) ) ) ) ).

% coprime_common_divisor
tff(fact_4149_coprime__absorb__right,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [Y: B,X: B] :
          ( dvd_dvd(B,Y,X)
         => ( algebr8660921524188924756oprime(B,X,Y)
          <=> dvd_dvd(B,Y,one_one(B)) ) ) ) ).

% coprime_absorb_right
tff(fact_4150_coprime__imp__coprime,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [C2: B,D2: B,A3: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,C2,D2)
         => ( ! [E3: B] :
                ( ~ dvd_dvd(B,E3,one_one(B))
               => ( dvd_dvd(B,E3,A3)
                 => ( dvd_dvd(B,E3,Ba)
                   => dvd_dvd(B,E3,C2) ) ) )
           => ( ! [E3: B] :
                  ( ~ dvd_dvd(B,E3,one_one(B))
                 => ( dvd_dvd(B,E3,A3)
                   => ( dvd_dvd(B,E3,Ba)
                     => dvd_dvd(B,E3,D2) ) ) )
             => algebr8660921524188924756oprime(B,A3,Ba) ) ) ) ) ).

% coprime_imp_coprime
tff(fact_4151_coprime__absorb__left,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [X: B,Y: B] :
          ( dvd_dvd(B,X,Y)
         => ( algebr8660921524188924756oprime(B,X,Y)
          <=> dvd_dvd(B,X,one_one(B)) ) ) ) ).

% coprime_absorb_left
tff(fact_4152_not__coprimeI,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( dvd_dvd(B,C2,A3)
         => ( dvd_dvd(B,C2,Ba)
           => ( ~ dvd_dvd(B,C2,one_one(B))
             => ~ algebr8660921524188924756oprime(B,A3,Ba) ) ) ) ) ).

% not_coprimeI
tff(fact_4153_not__coprimeE,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( ~ algebr8660921524188924756oprime(B,A3,Ba)
         => ~ ! [C4: B] :
                ( dvd_dvd(B,C4,A3)
               => ( dvd_dvd(B,C4,Ba)
                 => dvd_dvd(B,C4,one_one(B)) ) ) ) ) ).

% not_coprimeE
tff(fact_4154_coprime__def,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,A3,Ba)
        <=> ! [C5: B] :
              ( dvd_dvd(B,C5,A3)
             => ( dvd_dvd(B,C5,Ba)
               => dvd_dvd(B,C5,one_one(B)) ) ) ) ) ).

% coprime_def
tff(fact_4155_coprimeI,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A3: B,Ba: B] :
          ( ! [C4: B] :
              ( dvd_dvd(B,C4,A3)
             => ( dvd_dvd(B,C4,Ba)
               => dvd_dvd(B,C4,one_one(B)) ) )
         => algebr8660921524188924756oprime(B,A3,Ba) ) ) ).

% coprimeI
tff(fact_4156_mult__mod__cancel__right,axiom,
    ! [B: $tType] :
      ( ( euclid8851590272496341667cancel(B)
        & semiring_gcd(B) )
     => ! [A3: B,N: B,M4: B,Ba: B] :
          ( ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),N),M4) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),N),M4) )
         => ( algebr8660921524188924756oprime(B,M4,N)
           => ( modulo_modulo(B,A3,M4) = modulo_modulo(B,Ba,M4) ) ) ) ) ).

% mult_mod_cancel_right
tff(fact_4157_mult__mod__cancel__left,axiom,
    ! [B: $tType] :
      ( ( euclid8851590272496341667cancel(B)
        & semiring_gcd(B) )
     => ! [N: B,A3: B,M4: B,Ba: B] :
          ( ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),N),A3),M4) = modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),N),Ba),M4) )
         => ( algebr8660921524188924756oprime(B,M4,N)
           => ( modulo_modulo(B,A3,M4) = modulo_modulo(B,Ba,M4) ) ) ) ) ).

% mult_mod_cancel_left
tff(fact_4158_gcd__mult__right__right__cancel,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,A3,C2)
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) ) ) ) ).

% gcd_mult_right_right_cancel
tff(fact_4159_gcd__mult__right__left__cancel,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,C2: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,A3,C2)
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) ) ) ) ).

% gcd_mult_right_left_cancel
tff(fact_4160_gcd__mult__left__right__cancel,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( algebr8660921524188924756oprime(B,Ba,C2)
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),Ba) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) ) ) ) ).

% gcd_mult_left_right_cancel
tff(fact_4161_gcd__mult__left__left__cancel,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( algebr8660921524188924756oprime(B,Ba,C2)
         => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),Ba) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) ) ) ) ).

% gcd_mult_left_left_cancel
tff(fact_4162_coprime__iff__gcd__eq__1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,A3,Ba)
        <=> ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) = one_one(B) ) ) ) ).

% coprime_iff_gcd_eq_1
tff(fact_4163_gcd__eq__1__imp__coprime,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) = one_one(B) )
         => algebr8660921524188924756oprime(B,A3,Ba) ) ) ).

% gcd_eq_1_imp_coprime
tff(fact_4164_quotient__of__coprime,axiom,
    ! [R3: rat,P2: int,Q2: int] :
      ( ( quotient_of(R3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2) )
     => algebr8660921524188924756oprime(int,P2,Q2) ) ).

% quotient_of_coprime
tff(fact_4165_normalize__coprime,axiom,
    ! [R3: product_prod(int,int),P2: int,Q2: int] :
      ( ( normalize(R3) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2) )
     => algebr8660921524188924756oprime(int,P2,Q2) ) ).

% normalize_coprime
tff(fact_4166_Inf__fin__def,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ( lattic7752659483105999362nf_fin(B) = lattic1715443433743089157tice_F(B,inf_inf(B)) ) ) ).

% Inf_fin_def
tff(fact_4167_Sup__fin__def,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ( lattic5882676163264333800up_fin(B) = lattic1715443433743089157tice_F(B,sup_sup(B)) ) ) ).

% Sup_fin_def
tff(fact_4168_invertible__coprime,axiom,
    ! [B: $tType] :
      ( euclid8851590272496341667cancel(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( ( modulo_modulo(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),C2) = one_one(B) )
         => algebr8660921524188924756oprime(B,A3,C2) ) ) ).

% invertible_coprime
tff(fact_4169_gcd__coprime__exists,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) != zero_zero(B) )
         => ? [A9: B,B6: B] :
              ( ( A3 = aa(B,B,aa(B,fun(B,B),times_times(B),A9),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)) )
              & ( Ba = aa(B,B,aa(B,fun(B,B),times_times(B),B6),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)) )
              & algebr8660921524188924756oprime(B,A9,B6) ) ) ) ).

% gcd_coprime_exists
tff(fact_4170_gcd__coprime,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,A5: B,B3: B] :
          ( ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) != zero_zero(B) )
         => ( ( A3 = aa(B,B,aa(B,fun(B,B),times_times(B),A5),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)) )
           => ( ( Ba = aa(B,B,aa(B,fun(B,B),times_times(B),B3),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)) )
             => algebr8660921524188924756oprime(B,A5,B3) ) ) ) ) ).

% gcd_coprime
tff(fact_4171_semilattice__order__set_Obounded__iff,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: set(B),X: B] :
      ( lattic4895041142388067077er_set(B,Fa,Less_eq,Less)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( ( A4 != bot_bot(set(B)) )
         => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,X),aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4))
          <=> ! [X4: B] :
                ( member(B,X4,A4)
               => aa(B,$o,aa(B,fun(B,$o),Less_eq,X),X4) ) ) ) ) ) ).

% semilattice_order_set.bounded_iff
tff(fact_4172_semilattice__order__set_OboundedI,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: set(B),X: B] :
      ( lattic4895041142388067077er_set(B,Fa,Less_eq,Less)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( ( A4 != bot_bot(set(B)) )
         => ( ! [A8: B] :
                ( member(B,A8,A4)
               => aa(B,$o,aa(B,fun(B,$o),Less_eq,X),A8) )
           => aa(B,$o,aa(B,fun(B,$o),Less_eq,X),aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4)) ) ) ) ) ).

% semilattice_order_set.boundedI
tff(fact_4173_semilattice__order__set_OboundedE,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A4: set(B),X: B] :
      ( lattic4895041142388067077er_set(B,Fa,Less_eq,Less)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( ( A4 != bot_bot(set(B)) )
         => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,X),aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4))
           => ! [A13: B] :
                ( member(B,A13,A4)
               => aa(B,$o,aa(B,fun(B,$o),Less_eq,X),A13) ) ) ) ) ) ).

% semilattice_order_set.boundedE
tff(fact_4174_semilattice__set_Oinsert__remove,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A4: set(B),X: B] :
      ( lattic149705377957585745ce_set(B,Fa)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),aa(set(B),set(B),insert2(B,X),A4))
          = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),Fa,X),aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ) ) ).

% semilattice_set.insert_remove
tff(fact_4175_semilattice__set_Oremove,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A4: set(B),X: B] :
      ( lattic149705377957585745ce_set(B,Fa)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( member(B,X,A4)
         => ( aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4)
            = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),Fa,X),aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ) ) ) ).

% semilattice_set.remove
tff(fact_4176_semilattice__set_Ounion,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A4: set(B),B2: set(B)] :
      ( lattic149705377957585745ce_set(B,Fa)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(B),$o,finite_finite(B),B2)
           => ( ( B2 != bot_bot(set(B)) )
             => ( aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(B,B,aa(B,fun(B,B),Fa,aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4)),aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),B2)) ) ) ) ) ) ) ).

% semilattice_set.union
tff(fact_4177_semilattice__set_Oinsert__not__elem,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A4: set(B),X: B] :
      ( lattic149705377957585745ce_set(B,Fa)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( ~ member(B,X,A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),Fa,X),aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4)) ) ) ) ) ) ).

% semilattice_set.insert_not_elem
tff(fact_4178_Sup__fin_Osemilattice__set__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => lattic149705377957585745ce_set(B,sup_sup(B)) ) ).

% Sup_fin.semilattice_set_axioms
tff(fact_4179_Inf__fin_Osemilattice__set__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => lattic149705377957585745ce_set(B,inf_inf(B)) ) ).

% Inf_fin.semilattice_set_axioms
tff(fact_4180_semilattice__set_Osingleton,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),X: B] :
      ( lattic149705377957585745ce_set(B,Fa)
     => ( aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = X ) ) ).

% semilattice_set.singleton
tff(fact_4181_semilattice__set_Ohom__commute,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),H2: fun(B,B),N4: set(B)] :
      ( lattic149705377957585745ce_set(B,Fa)
     => ( ! [X2: B,Y2: B] : ( aa(B,B,H2,aa(B,B,aa(B,fun(B,B),Fa,X2),Y2)) = aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,H2,X2)),aa(B,B,H2,Y2)) )
       => ( aa(set(B),$o,finite_finite(B),N4)
         => ( ( N4 != bot_bot(set(B)) )
           => ( aa(B,B,H2,aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),N4)) = aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),aa(set(B),set(B),image2(B,B,H2),N4)) ) ) ) ) ) ).

% semilattice_set.hom_commute
tff(fact_4182_semilattice__set_Osubset,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A4: set(B),B2: set(B)] :
      ( lattic149705377957585745ce_set(B,Fa)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( ( B2 != bot_bot(set(B)) )
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A4)
           => ( aa(B,B,aa(B,fun(B,B),Fa,aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),B2)),aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4)) = aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4) ) ) ) ) ) ).

% semilattice_set.subset
tff(fact_4183_semilattice__set_Oclosed,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A4: set(B)] :
      ( lattic149705377957585745ce_set(B,Fa)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( ( A4 != bot_bot(set(B)) )
         => ( ! [X2: B,Y2: B] : member(B,aa(B,B,aa(B,fun(B,B),Fa,X2),Y2),aa(set(B),set(B),insert2(B,X2),aa(set(B),set(B),insert2(B,Y2),bot_bot(set(B)))))
           => member(B,aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4),A4) ) ) ) ) ).

% semilattice_set.closed
tff(fact_4184_semilattice__set_Oinsert,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A4: set(B),X: B] :
      ( lattic149705377957585745ce_set(B,Fa)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),Fa,X),aa(set(B),B,lattic1715443433743089157tice_F(B,Fa),A4)) ) ) ) ) ).

% semilattice_set.insert
tff(fact_4185_prod_OatLeastLessThan__reindex,axiom,
    ! [B: $tType,C: $tType] :
      ( ( comm_monoid_mult(C)
        & ord(B) )
     => ! [H2: fun(nat,B),M4: nat,N: nat,Ga: fun(B,C)] :
          ( bij_betw(nat,B,H2,set_or7035219750837199246ssThan(nat,M4,N),set_or7035219750837199246ssThan(B,aa(nat,B,H2,M4),aa(nat,B,H2,N)))
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),set_or7035219750837199246ssThan(B,aa(nat,B,H2,M4),aa(nat,B,H2,N))) = aa(set(nat),C,aa(fun(nat,C),fun(set(nat),C),groups7121269368397514597t_prod(nat,C),aa(fun(nat,B),fun(nat,C),aa(fun(B,C),fun(fun(nat,B),fun(nat,C)),comp(B,C,nat),Ga),H2)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ) ).

% prod.atLeastLessThan_reindex
tff(fact_4186_antisymp__antisym__eq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( antisymp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3))
    <=> antisym(B,R3) ) ).

% antisymp_antisym_eq
tff(fact_4187_prod_OatLeastAtMost__reindex,axiom,
    ! [B: $tType,C: $tType] :
      ( ( comm_monoid_mult(C)
        & ord(B) )
     => ! [H2: fun(nat,B),M4: nat,N: nat,Ga: fun(B,C)] :
          ( bij_betw(nat,B,H2,set_or1337092689740270186AtMost(nat,M4,N),set_or1337092689740270186AtMost(B,aa(nat,B,H2,M4),aa(nat,B,H2,N)))
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),Ga),set_or1337092689740270186AtMost(B,aa(nat,B,H2,M4),aa(nat,B,H2,N))) = aa(set(nat),C,aa(fun(nat,C),fun(set(nat),C),groups7121269368397514597t_prod(nat,C),aa(fun(nat,B),fun(nat,C),aa(fun(B,C),fun(fun(nat,B),fun(nat,C)),comp(B,C,nat),Ga),H2)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ) ).

% prod.atLeastAtMost_reindex
tff(fact_4188_Max_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( lattic643756798349783984er_Max(B,aa(set(B),set(B),insert2(B,X),A4))
            = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),ord_max(B),X),lattic643756798349783984er_Max(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ) ) ).

% Max.insert_remove
tff(fact_4189_max_Oright__idem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)),Ba) = aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) ) ) ).

% max.right_idem
tff(fact_4190_max_Oleft__idem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) ) ) ).

% max.left_idem
tff(fact_4191_max_Oidem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),A3) = A3 ) ) ).

% max.idem
tff(fact_4192_max_Obounded__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),C2)),A3)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
            & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3) ) ) ) ).

% max.bounded_iff
tff(fact_4193_max_Oabsorb2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) = Ba ) ) ) ).

% max.absorb2
tff(fact_4194_max_Oabsorb1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) = A3 ) ) ) ).

% max.absorb1
tff(fact_4195_max_Oabsorb3,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) = A3 ) ) ) ).

% max.absorb3
tff(fact_4196_max_Oabsorb4,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),Ba)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) = Ba ) ) ) ).

% max.absorb4
tff(fact_4197_max__less__iff__conj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B,Z2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y)),Z2)
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Z2)
            & aa(B,$o,aa(B,fun(B,$o),ord_less(B),Y),Z2) ) ) ) ).

% max_less_iff_conj
tff(fact_4198_max__bot2,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),X),bot_bot(B)) = X ) ) ).

% max_bot2
tff(fact_4199_max__bot,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),bot_bot(B)),X) = X ) ) ).

% max_bot
tff(fact_4200_max__top,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),top_top(B)),X) = top_top(B) ) ) ).

% max_top
tff(fact_4201_max__top2,axiom,
    ! [B: $tType] :
      ( order_top(B)
     => ! [X: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),X),top_top(B)) = top_top(B) ) ) ).

% max_top2
tff(fact_4202_max__min__same_I4_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Y: B,X: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),Y),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)) = Y ) ) ).

% max_min_same(4)
tff(fact_4203_max__min__same_I3_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)),Y) = Y ) ) ).

% max_min_same(3)
tff(fact_4204_max__min__same_I2_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)),X) = X ) ) ).

% max_min_same(2)
tff(fact_4205_max__min__same_I1_J,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: B,Y: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),X),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)) = X ) ) ).

% max_min_same(1)
tff(fact_4206_max__0__1_I1_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ( aa(B,B,aa(B,fun(B,B),ord_max(B),zero_zero(B)),one_one(B)) = one_one(B) ) ) ).

% max_0_1(1)
tff(fact_4207_max__0__1_I2_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ( aa(B,B,aa(B,fun(B,B),ord_max(B),one_one(B)),zero_zero(B)) = one_one(B) ) ) ).

% max_0_1(2)
tff(fact_4208_max__0__1_I6_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(num,B,numeral_numeral(B),X)),one_one(B)) = aa(num,B,numeral_numeral(B),X) ) ) ).

% max_0_1(6)
tff(fact_4209_max__0__1_I5_J,axiom,
    ! [B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [X: num] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),one_one(B)),aa(num,B,numeral_numeral(B),X)) = aa(num,B,numeral_numeral(B),X) ) ) ).

% max_0_1(5)
tff(fact_4210_Int__atLeastAtMost,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,A3,Ba)),set_or1337092689740270186AtMost(B,C2,D2)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A3),C2),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),D2)) ) ) ).

% Int_atLeastAtMost
tff(fact_4211_Int__atLeastLessThan,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or7035219750837199246ssThan(B,A3,Ba)),set_or7035219750837199246ssThan(B,C2,D2)) = set_or7035219750837199246ssThan(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A3),C2),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),D2)) ) ) ).

% Int_atLeastLessThan
tff(fact_4212_Int__atLeastAtMostR2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,C2: B,D2: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_ord_atLeast(B,A3)),set_or1337092689740270186AtMost(B,C2,D2)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A3),C2),D2) ) ) ).

% Int_atLeastAtMostR2
tff(fact_4213_Int__atLeastAtMostL2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or1337092689740270186AtMost(B,A3,Ba)),set_ord_atLeast(B,C2)) = set_or1337092689740270186AtMost(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A3),C2),Ba) ) ) ).

% Int_atLeastAtMostL2
tff(fact_4214_Int__greaterThanAtMost,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or3652927894154168847AtMost(B,A3,Ba)),set_or3652927894154168847AtMost(B,C2,D2)) = set_or3652927894154168847AtMost(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A3),C2),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),D2)) ) ) ).

% Int_greaterThanAtMost
tff(fact_4215_Int__greaterThanLessThan,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B,D2: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_or5935395276787703475ssThan(B,A3,Ba)),set_or5935395276787703475ssThan(B,C2,D2)) = set_or5935395276787703475ssThan(B,aa(B,B,aa(B,fun(B,B),ord_max(B),A3),C2),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),D2)) ) ) ).

% Int_greaterThanLessThan
tff(fact_4216_Max__insert,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( lattic643756798349783984er_Max(B,aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),ord_max(B),X),lattic643756798349783984er_Max(B,A4)) ) ) ) ) ).

% Max_insert
tff(fact_4217_max__of__mono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [Fa: fun(B,C),M4: B,N: B] :
          ( order_mono(B,C,Fa)
         => ( aa(C,C,aa(C,fun(C,C),ord_max(C),aa(B,C,Fa,M4)),aa(B,C,Fa,N)) = aa(B,C,Fa,aa(B,B,aa(B,fun(B,B),ord_max(B),M4),N)) ) ) ) ).

% max_of_mono
tff(fact_4218_bij__betw__trans,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(B,C),A4: set(B),B2: set(C),Ga: fun(C,D),C3: set(D)] :
      ( bij_betw(B,C,Fa,A4,B2)
     => ( bij_betw(C,D,Ga,B2,C3)
       => bij_betw(B,D,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),Fa),A4,C3) ) ) ).

% bij_betw_trans
tff(fact_4219_bij__betw__comp__iff,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(B,C),A4: set(B),A10: set(C),F9: fun(C,D),A17: set(D)] :
      ( bij_betw(B,C,Fa,A4,A10)
     => ( bij_betw(C,D,F9,A10,A17)
      <=> bij_betw(B,D,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),F9),Fa),A4,A17) ) ) ).

% bij_betw_comp_iff
tff(fact_4220_sup__max,axiom,
    ! [B: $tType] :
      ( ( semilattice_sup(B)
        & linorder(B) )
     => ( sup_sup(B) = ord_max(B) ) ) ).

% sup_max
tff(fact_4221_complete__linorder__sup__max,axiom,
    ! [B: $tType] :
      ( comple5582772986160207858norder(B)
     => ( sup_sup(B) = ord_max(B) ) ) ).

% complete_linorder_sup_max
tff(fact_4222_max__min__distrib1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,C2: B,A3: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),C2)),A3) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),A3)),aa(B,B,aa(B,fun(B,B),ord_max(B),C2),A3)) ) ) ).

% max_min_distrib1
tff(fact_4223_max__min__distrib2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),C2)) ) ) ).

% max_min_distrib2
tff(fact_4224_min__max__distrib1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,C2: B,A3: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),C2)),A3) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_min(B),Ba),A3)),aa(B,B,aa(B,fun(B,B),ord_min(B),C2),A3)) ) ) ).

% min_max_distrib1
tff(fact_4225_min__max__distrib2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),ord_min(B),A3),aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),C2)) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),ord_min(B),A3),C2)) ) ) ).

% min_max_distrib2
tff(fact_4226_max__add__distrib__left,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y)),Z2) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Z2)),aa(B,B,aa(B,fun(B,B),plus_plus(B),Y),Z2)) ) ) ).

% max_add_distrib_left
tff(fact_4227_max__add__distrib__right,axiom,
    ! [B: $tType] :
      ( ordere2412721322843649153imp_le(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),X),aa(B,B,aa(B,fun(B,B),ord_max(B),Y),Z2)) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y)),aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Z2)) ) ) ).

% max_add_distrib_right
tff(fact_4228_max_Oleft__commute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),C2)) = aa(B,B,aa(B,fun(B,B),ord_max(B),A3),aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),C2)) ) ) ).

% max.left_commute
tff(fact_4229_max_Ocommute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) = aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),A3) ) ) ).

% max.commute
tff(fact_4230_max_Oassoc,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),ord_max(B),A3),aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),C2)) ) ) ).

% max.assoc
tff(fact_4231_max_Ostrict__coboundedI2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)) ) ) ).

% max.strict_coboundedI2
tff(fact_4232_max_Ostrict__coboundedI1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)) ) ) ).

% max.strict_coboundedI1
tff(fact_4233_max_Ostrict__order__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
        <=> ( ( A3 = aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) )
            & ( A3 != Ba ) ) ) ) ).

% max.strict_order_iff
tff(fact_4234_max_Ostrict__boundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),C2)),A3)
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Ba),A3)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),A3) ) ) ) ).

% max.strict_boundedE
tff(fact_4235_less__max__iff__disj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Z2: B,X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),X)
            | aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z2),Y) ) ) ) ).

% less_max_iff_disj
tff(fact_4236_max__diff__distrib__left,axiom,
    ! [B: $tType] :
      ( ordered_ab_group_add(B)
     => ! [X: B,Y: B,Z2: B] : ( aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y)),Z2) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),X),Z2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Y),Z2)) ) ) ).

% max_diff_distrib_left
tff(fact_4237_max_Osemigroup__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semigroup(B,ord_max(B)) ) ).

% max.semigroup_axioms
tff(fact_4238_max_Omono,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [C2: B,A3: B,D2: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),D2),Ba)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_max(B),C2),D2)),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)) ) ) ) ).

% max.mono
tff(fact_4239_max_OorderE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( A3 = aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) ) ) ) ).

% max.orderE
tff(fact_4240_max_OorderI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 = aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3) ) ) ).

% max.orderI
tff(fact_4241_max_OboundedE,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,C2: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),C2)),A3)
         => ~ ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
             => ~ aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3) ) ) ) ).

% max.boundedE
tff(fact_4242_max_OboundedI,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B,C2: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),ord_max(B),Ba),C2)),A3) ) ) ) ).

% max.boundedI
tff(fact_4243_max_Oorder__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
        <=> ( A3 = aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) ) ) ) ).

% max.order_iff
tff(fact_4244_max_Ocobounded1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)) ) ).

% max.cobounded1
tff(fact_4245_max_Ocobounded2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)) ) ).

% max.cobounded2
tff(fact_4246_le__max__iff__disj,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Z2: B,X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y))
        <=> ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),X)
            | aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z2),Y) ) ) ) ).

% le_max_iff_disj
tff(fact_4247_max_Oabsorb__iff1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Ba),A3)
        <=> ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) = A3 ) ) ) ).

% max.absorb_iff1
tff(fact_4248_max_Oabsorb__iff2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba)
        <=> ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba) = Ba ) ) ) ).

% max.absorb_iff2
tff(fact_4249_max_OcoboundedI1,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [C2: B,A3: B,Ba: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)) ) ) ).

% max.coboundedI1
tff(fact_4250_max_OcoboundedI2,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [C2: B,Ba: B,A3: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),Ba)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)) ) ) ).

% max.coboundedI2
tff(fact_4251_max__def,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [A3: B,Ba: B] :
          ( aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),Ba),Ba,A3) ) ) ).

% max_def
tff(fact_4252_max__absorb1,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Y: B,X: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),X)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y) = X ) ) ) ).

% max_absorb1
tff(fact_4253_max__absorb2,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [X: B,Y: B] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
         => ( aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y) = Y ) ) ) ).

% max_absorb2
tff(fact_4254_bij__betw__empty2,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),A4: set(B)] :
      ( bij_betw(B,C,Fa,A4,bot_bot(set(C)))
     => ( A4 = bot_bot(set(B)) ) ) ).

% bij_betw_empty2
tff(fact_4255_bij__betw__empty1,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),A4: set(C)] :
      ( bij_betw(B,C,Fa,bot_bot(set(B)),A4)
     => ( A4 = bot_bot(set(C)) ) ) ).

% bij_betw_empty1
tff(fact_4256_bij__comp,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(B,C),Ga: fun(C,D)] :
      ( bij_betw(B,C,Fa,top_top(set(B)),top_top(set(C)))
     => ( bij_betw(C,D,Ga,top_top(set(C)),top_top(set(D)))
       => bij_betw(B,D,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),Fa),top_top(set(B)),top_top(set(D))) ) ) ).

% bij_comp
tff(fact_4257_minus__max__eq__min,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [X: B,Y: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y)) = aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,uminus_uminus(B),X)),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% minus_max_eq_min
tff(fact_4258_minus__min__eq__max,axiom,
    ! [B: $tType] :
      ( linord5086331880401160121up_add(B)
     => ! [X: B,Y: B] : ( aa(B,B,uminus_uminus(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,uminus_uminus(B),X)),aa(B,B,uminus_uminus(B),Y)) ) ) ).

% minus_min_eq_max
tff(fact_4259_lessThan__Int__lessThan,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A3: B,Ba: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(B,set(B),set_ord_greaterThan(B),A3)),aa(B,set(B),set_ord_greaterThan(B),Ba)) = aa(B,set(B),set_ord_greaterThan(B),aa(B,B,aa(B,fun(B,B),ord_max(B),A3),Ba)) ) ) ).

% lessThan_Int_lessThan
tff(fact_4260_bij__betw__comp__iff2,axiom,
    ! [D: $tType,B: $tType,C: $tType,F9: fun(B,C),A10: set(B),A17: set(C),Fa: fun(D,B),A4: set(D)] :
      ( bij_betw(B,C,F9,A10,A17)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(D),set(B),image2(D,B,Fa),A4)),A10)
       => ( bij_betw(D,B,Fa,A4,A10)
        <=> bij_betw(D,C,aa(fun(D,B),fun(D,C),aa(fun(B,C),fun(fun(D,B),fun(D,C)),comp(B,C,D),F9),Fa),A4,A17) ) ) ) ).

% bij_betw_comp_iff2
tff(fact_4261_notIn__Un__bij__betw,axiom,
    ! [B: $tType,C: $tType,Ba: B,A4: set(B),Fa: fun(B,C),A10: set(C)] :
      ( ~ member(B,Ba,A4)
     => ( ~ member(C,aa(B,C,Fa,Ba),A10)
       => ( bij_betw(B,C,Fa,A4,A10)
         => bij_betw(B,C,Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A10),aa(set(C),set(C),insert2(C,aa(B,C,Fa,Ba)),bot_bot(set(C))))) ) ) ) ).

% notIn_Un_bij_betw
tff(fact_4262_notIn__Un__bij__betw3,axiom,
    ! [B: $tType,C: $tType,Ba: B,A4: set(B),Fa: fun(B,C),A10: set(C)] :
      ( ~ member(B,Ba,A4)
     => ( ~ member(C,aa(B,C,Fa,Ba),A10)
       => ( bij_betw(B,C,Fa,A4,A10)
        <=> bij_betw(B,C,Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B)))),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A10),aa(set(C),set(C),insert2(C,aa(B,C,Fa,Ba)),bot_bot(set(C))))) ) ) ) ).

% notIn_Un_bij_betw3
tff(fact_4263_bij__betw__combine,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),A4: set(B),B2: set(C),C3: set(B),D4: set(C)] :
      ( bij_betw(B,C,Fa,A4,B2)
     => ( bij_betw(B,C,Fa,C3,D4)
       => ( ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),B2),D4) = bot_bot(set(C)) )
         => bij_betw(B,C,Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),C3),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),B2),D4)) ) ) ) ).

% bij_betw_combine
tff(fact_4264_bij__betw__partition,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),A4: set(B),C3: set(B),B2: set(C),D4: set(C)] :
      ( bij_betw(B,C,Fa,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),C3),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),B2),D4))
     => ( bij_betw(B,C,Fa,C3,D4)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),C3) = bot_bot(set(B)) )
         => ( ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),B2),D4) = bot_bot(set(C)) )
           => bij_betw(B,C,Fa,A4,B2) ) ) ) ) ).

% bij_betw_partition
tff(fact_4265_o__bij,axiom,
    ! [B: $tType,C: $tType,Ga: fun(C,B),Fa: fun(B,C)] :
      ( ( aa(fun(B,C),fun(B,B),aa(fun(C,B),fun(fun(B,C),fun(B,B)),comp(C,B,B),Ga),Fa) = id(B) )
     => ( ( aa(fun(C,B),fun(C,C),aa(fun(B,C),fun(fun(C,B),fun(C,C)),comp(B,C,C),Fa),Ga) = id(C) )
       => bij_betw(B,C,Fa,top_top(set(B)),top_top(set(C))) ) ) ).

% o_bij
tff(fact_4266_ex__bij__betw,axiom,
    ! [C: $tType,B: $tType,A4: set(B),R3: set(product_prod(C,C))] :
      ( member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),R3),bNF_Wellorder_ordLeq(B,C))
     => ? [F8: fun(C,B),B8: set(C)] : bij_betw(C,B,F8,B8,A4) ) ).

% ex_bij_betw
tff(fact_4267_card__of__ordIso,axiom,
    ! [C: $tType,B: $tType,A4: set(B),B2: set(C)] :
      ( ? [F10: fun(B,C)] : bij_betw(B,C,F10,A4,B2)
    <=> member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordIso(B,C)) ) ).

% card_of_ordIso
tff(fact_4268_card__of__ordIsoI,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),A4: set(B),B2: set(C)] :
      ( bij_betw(B,C,Fa,A4,B2)
     => member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),bNF_Ca6860139660246222851ard_of(B,A4)),bNF_Ca6860139660246222851ard_of(C,B2)),bNF_Wellorder_ordIso(B,C)) ) ).

% card_of_ordIsoI
tff(fact_4269_antisym__bot,axiom,
    ! [B: $tType] : antisymp(B,bot_bot(fun(B,fun(B,$o)))) ).

% antisym_bot
tff(fact_4270_Well__order__iso__copy,axiom,
    ! [C: $tType,B: $tType,A4: set(B),R3: set(product_prod(B,B)),Fa: fun(B,C),A10: set(C)] :
      ( order_well_order_on(B,A4,R3)
     => ( bij_betw(B,C,Fa,A4,A10)
       => ? [R11: set(product_prod(C,C))] :
            ( order_well_order_on(C,A10,R11)
            & member(product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(set(product_prod(C,C)),product_prod(set(product_prod(B,B)),set(product_prod(C,C)))),product_Pair(set(product_prod(B,B)),set(product_prod(C,C))),R3),R11),bNF_Wellorder_ordIso(B,C)) ) ) ) ).

% Well_order_iso_copy
tff(fact_4271_iso__iff2,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),R4: set(product_prod(C,C)),Fa: fun(B,C)] :
      ( bNF_Wellorder_iso(B,C,R3,R4,Fa)
    <=> ( bij_betw(B,C,Fa,field2(B,R3),field2(C,R4))
        & ! [X4: B] :
            ( member(B,X4,field2(B,R3))
           => ! [Xa2: B] :
                ( member(B,Xa2,field2(B,R3))
               => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa2),R3)
                <=> member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),aa(B,C,Fa,X4)),aa(B,C,Fa,Xa2)),R4) ) ) ) ) ) ).

% iso_iff2
tff(fact_4272_max__nat_Osemilattice__neutr__axioms,axiom,
    semilattice_neutr(nat,ord_max(nat),zero_zero(nat)) ).

% max_nat.semilattice_neutr_axioms
tff(fact_4273_max__nat_Omonoid__axioms,axiom,
    monoid(nat,ord_max(nat),zero_zero(nat)) ).

% max_nat.monoid_axioms
tff(fact_4274_bij__betw__disjoint__Un,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),A4: set(B),C3: set(C),Ga: fun(B,C),B2: set(B),D4: set(C)] :
      ( bij_betw(B,C,Fa,A4,C3)
     => ( bij_betw(B,C,Ga,B2,D4)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) )
         => ( ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),C3),D4) = bot_bot(set(C)) )
           => bij_betw(B,C,aa(fun(B,C),fun(B,C),aa(set(B),fun(fun(B,C),fun(B,C)),aTP_Lamp_cp(fun(B,C),fun(set(B),fun(fun(B,C),fun(B,C))),Fa),A4),Ga),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),C3),D4)) ) ) ) ) ).

% bij_betw_disjoint_Un
tff(fact_4275_infinite__imp__bij__betw2,axiom,
    ! [B: $tType,A4: set(B),A3: B] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ? [H: fun(B,B)] : bij_betw(B,B,H,A4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) ) ).

% infinite_imp_bij_betw2
tff(fact_4276_infinite__imp__bij__betw,axiom,
    ! [B: $tType,A4: set(B),A3: B] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ? [H: fun(B,B)] : bij_betw(B,B,H,A4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B))))) ) ).

% infinite_imp_bij_betw
tff(fact_4277_min__mult__distrib__right,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B,Y: B,P2: B] :
          ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)),P2)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),P2),aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),P2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),P2)),aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),P2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),P2))) ) ) ).

% min_mult_distrib_right
tff(fact_4278_max__mult__distrib__right,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [X: B,Y: B,P2: B] :
          ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y)),P2)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),P2),aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),P2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),P2)),aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),times_times(B),X),P2)),aa(B,B,aa(B,fun(B,B),times_times(B),Y),P2))) ) ) ).

% max_mult_distrib_right
tff(fact_4279_min__mult__distrib__left,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [P2: B,X: B,Y: B] :
          ( aa(B,B,aa(B,fun(B,B),times_times(B),P2),aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),P2),aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),times_times(B),P2),X)),aa(B,B,aa(B,fun(B,B),times_times(B),P2),Y)),aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),times_times(B),P2),X)),aa(B,B,aa(B,fun(B,B),times_times(B),P2),Y))) ) ) ).

% min_mult_distrib_left
tff(fact_4280_max__mult__distrib__left,axiom,
    ! [B: $tType] :
      ( linordered_idom(B)
     => ! [P2: B,X: B,Y: B] :
          ( aa(B,B,aa(B,fun(B,B),times_times(B),P2),aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),P2),aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,aa(B,fun(B,B),times_times(B),P2),X)),aa(B,B,aa(B,fun(B,B),times_times(B),P2),Y)),aa(B,B,aa(B,fun(B,B),ord_min(B),aa(B,B,aa(B,fun(B,B),times_times(B),P2),X)),aa(B,B,aa(B,fun(B,B),times_times(B),P2),Y))) ) ) ).

% max_mult_distrib_left
tff(fact_4281_Sup__insert__finite,axiom,
    ! [B: $tType] :
      ( condit6923001295902523014norder(B)
     => ! [S2: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),S2)
         => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(B),set(B),insert2(B,X),S2))
            = $ite(S2 = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),ord_max(B),X),aa(set(B),B,complete_Sup_Sup(B),S2))) ) ) ) ).

% Sup_insert_finite
tff(fact_4282_hom__Max__commute,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [H2: fun(B,B),N4: set(B)] :
          ( ! [X2: B,Y2: B] : ( aa(B,B,H2,aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y2)) = aa(B,B,aa(B,fun(B,B),ord_max(B),aa(B,B,H2,X2)),aa(B,B,H2,Y2)) )
         => ( aa(set(B),$o,finite_finite(B),N4)
           => ( ( N4 != bot_bot(set(B)) )
             => ( aa(B,B,H2,lattic643756798349783984er_Max(B,N4)) = lattic643756798349783984er_Max(B,aa(set(B),set(B),image2(B,B,H2),N4)) ) ) ) ) ) ).

% hom_Max_commute
tff(fact_4283_Max_Osubset,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( B2 != bot_bot(set(B)) )
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B2),A4)
             => ( aa(B,B,aa(B,fun(B,B),ord_max(B),lattic643756798349783984er_Max(B,B2)),lattic643756798349783984er_Max(B,A4)) = lattic643756798349783984er_Max(B,A4) ) ) ) ) ) ).

% Max.subset
tff(fact_4284_Max_Oinsert__not__elem,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ~ member(B,X,A4)
           => ( ( A4 != bot_bot(set(B)) )
             => ( lattic643756798349783984er_Max(B,aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),ord_max(B),X),lattic643756798349783984er_Max(B,A4)) ) ) ) ) ) ).

% Max.insert_not_elem
tff(fact_4285_Max_Oclosed,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [X2: B,Y2: B] : member(B,aa(B,B,aa(B,fun(B,B),ord_max(B),X2),Y2),aa(set(B),set(B),insert2(B,X2),aa(set(B),set(B),insert2(B,Y2),bot_bot(set(B)))))
             => member(B,lattic643756798349783984er_Max(B,A4),A4) ) ) ) ) ).

% Max.closed
tff(fact_4286_Max_Ounion,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),B2: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( aa(set(B),$o,finite_finite(B),B2)
             => ( ( B2 != bot_bot(set(B)) )
               => ( lattic643756798349783984er_Max(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(B,B,aa(B,fun(B,B),ord_max(B),lattic643756798349783984er_Max(B,A4)),lattic643756798349783984er_Max(B,B2)) ) ) ) ) ) ) ).

% Max.union
tff(fact_4287_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [S4: set(B),T6: set(C),H2: fun(B,C),S2: set(B),T3: set(C),Ga: fun(C,D)] :
          ( aa(set(B),$o,finite_finite(B),S4)
         => ( aa(set(C),$o,finite_finite(C),T6)
           => ( bij_betw(B,C,H2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),S4),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T3),T6))
             => ( ! [A8: B] :
                    ( member(B,A8,S4)
                   => ( aa(C,D,Ga,aa(B,C,H2,A8)) = one_one(D) ) )
               => ( ! [B4: C] :
                      ( member(C,B4,T6)
                     => ( aa(C,D,Ga,B4) = one_one(D) ) )
                 => ( aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(C,D),fun(B,D),aTP_Lamp_pn(fun(B,C),fun(fun(C,D),fun(B,D)),H2),Ga)),S2) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),Ga),T3) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
tff(fact_4288_sum_OatLeastAtMost__reindex,axiom,
    ! [B: $tType,C: $tType] :
      ( ( comm_monoid_add(C)
        & ord(B) )
     => ! [H2: fun(nat,B),M4: nat,N: nat,Ga: fun(B,C)] :
          ( bij_betw(nat,B,H2,set_or1337092689740270186AtMost(nat,M4,N),set_or1337092689740270186AtMost(B,aa(nat,B,H2,M4),aa(nat,B,H2,N)))
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),set_or1337092689740270186AtMost(B,aa(nat,B,H2,M4),aa(nat,B,H2,N))) = aa(set(nat),C,aa(fun(nat,C),fun(set(nat),C),groups7311177749621191930dd_sum(nat,C),aa(fun(nat,B),fun(nat,C),aa(fun(B,C),fun(fun(nat,B),fun(nat,C)),comp(B,C,nat),Ga),H2)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ) ).

% sum.atLeastAtMost_reindex
tff(fact_4289_sum_OatLeastLessThan__reindex,axiom,
    ! [B: $tType,C: $tType] :
      ( ( comm_monoid_add(C)
        & ord(B) )
     => ! [H2: fun(nat,B),M4: nat,N: nat,Ga: fun(B,C)] :
          ( bij_betw(nat,B,H2,set_or7035219750837199246ssThan(nat,M4,N),set_or7035219750837199246ssThan(B,aa(nat,B,H2,M4),aa(nat,B,H2,N)))
         => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),Ga),set_or7035219750837199246ssThan(B,aa(nat,B,H2,M4),aa(nat,B,H2,N))) = aa(set(nat),C,aa(fun(nat,C),fun(set(nat),C),groups7311177749621191930dd_sum(nat,C),aa(fun(nat,B),fun(nat,C),aa(fun(B,C),fun(fun(nat,B),fun(nat,C)),comp(B,C,nat),Ga),H2)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ) ).

% sum.atLeastLessThan_reindex
tff(fact_4290_Max_Oremove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( lattic643756798349783984er_Max(B,A4)
              = $ite(aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) = bot_bot(set(B)),X,aa(B,B,aa(B,fun(B,B),ord_max(B),X),lattic643756798349783984er_Max(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))))) ) ) ) ) ).

% Max.remove
tff(fact_4291_next__present,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),H4: heap_ext(product_unit),X: B,H2: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),product_prod(ref(B),heap_ext(product_unit)),aa(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),heap_ext(product_unit))),product_Pair(ref(B),heap_ext(product_unit)),R3),H4) = ref_alloc(B,X,H2) )
         => ref_present(B,H4,R3) ) ) ).

% next_present
tff(fact_4292_next__fresh,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: ref(B),H4: heap_ext(product_unit),X: B,H2: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),product_prod(ref(B),heap_ext(product_unit)),aa(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),heap_ext(product_unit))),product_Pair(ref(B),heap_ext(product_unit)),R3),H4) = ref_alloc(B,X,H2) )
         => ~ ref_present(B,H2,R3) ) ) ).

% next_fresh
tff(fact_4293_K__record__comp,axiom,
    ! [B: $tType,D: $tType,C: $tType,C2: C,Fa: fun(B,D),X3: B] : ( aa(B,C,aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),aTP_Lamp_po(C,fun(D,C),C2)),Fa),X3) = C2 ) ).

% K_record_comp
tff(fact_4294_bind__singleton__conv__image,axiom,
    ! [B: $tType,C: $tType,A4: set(C),Fa: fun(C,B)] : ( bind3(C,B,A4,aTP_Lamp_iw(fun(C,B),fun(C,set(B)),Fa)) = aa(set(C),set(B),image2(C,B,Fa),A4) ) ).

% bind_singleton_conv_image
tff(fact_4295_empty__bind,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,set(B))] : ( bind3(C,B,bot_bot(set(C)),Fa) = bot_bot(set(B)) ) ).

% empty_bind
tff(fact_4296_bind__const,axiom,
    ! [C: $tType,B: $tType,A4: set(C),B2: set(B)] :
      ( bind3(C,B,A4,aTP_Lamp_ho(set(B),fun(C,set(B)),B2))
      = $ite(A4 = bot_bot(set(C)),bot_bot(set(B)),B2) ) ).

% bind_const
tff(fact_4297_nonempty__bind__const,axiom,
    ! [B: $tType,C: $tType,A4: set(B),B2: set(C)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( bind3(B,C,A4,aTP_Lamp_hq(set(C),fun(B,set(C)),B2)) = B2 ) ) ).

% nonempty_bind_const
tff(fact_4298_bind__image,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(D,C),A4: set(D),Ga: fun(C,set(B))] : ( bind3(C,B,aa(set(D),set(C),image2(D,C,Fa),A4),Ga) = bind3(D,B,A4,aa(fun(D,C),fun(D,set(B)),aa(fun(C,set(B)),fun(fun(D,C),fun(D,set(B))),comp(C,set(B),D),Ga),Fa)) ) ).

% bind_image
tff(fact_4299_image__bind,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(C,B),A4: set(D),Ga: fun(D,set(C))] : ( aa(set(C),set(B),image2(C,B,Fa),bind3(D,C,A4,Ga)) = bind3(D,B,A4,aa(fun(D,set(C)),fun(D,set(B)),aa(fun(set(C),set(B)),fun(fun(D,set(C)),fun(D,set(B))),comp(set(C),set(B),D),image2(C,B,Fa)),Ga)) ) ).

% image_bind
tff(fact_4300_set__decode__zero,axiom,
    nat_set_decode(zero_zero(nat)) = bot_bot(set(nat)) ).

% set_decode_zero
tff(fact_4301_Func__empty,axiom,
    ! [C: $tType,B: $tType,B2: set(C)] : ( bNF_Wellorder_Func(B,C,bot_bot(set(B)),B2) = aa(set(fun(B,C)),set(fun(B,C)),insert2(fun(B,C),aTP_Lamp_pp(B,C)),bot_bot(set(fun(B,C)))) ) ).

% Func_empty
tff(fact_4302_power__int__add__1,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X: B,M4: int] :
          ( ( ( X != zero_zero(B) )
            | ( M4 != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(B,X,aa(int,int,aa(int,fun(int,int),plus_plus(int),M4),one_one(int))) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X,M4)),X) ) ) ) ).

% power_int_add_1
tff(fact_4303_power__int__add__1_H,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X: B,M4: int] :
          ( ( ( X != zero_zero(B) )
            | ( M4 != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(B,X,aa(int,int,aa(int,fun(int,int),plus_plus(int),M4),one_one(int))) = aa(B,B,aa(B,fun(B,B),times_times(B),X),power_int(B,X,M4)) ) ) ) ).

% power_int_add_1'
tff(fact_4304_power__int__1__left,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [N: int] : ( power_int(B,one_one(B),N) = one_one(B) ) ) ).

% power_int_1_left
tff(fact_4305_power__int__mult__distrib__numeral1,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [W2: num,Y: B,M4: int] : ( power_int(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),W2)),Y),M4) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,aa(num,B,numeral_numeral(B),W2),M4)),power_int(B,Y,M4)) ) ) ).

% power_int_mult_distrib_numeral1
tff(fact_4306_power__int__mult__distrib__numeral2,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X: B,W2: num,M4: int] : ( power_int(B,aa(B,B,aa(B,fun(B,B),times_times(B),X),aa(num,B,numeral_numeral(B),W2)),M4) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X,M4)),power_int(B,aa(num,B,numeral_numeral(B),W2),M4)) ) ) ).

% power_int_mult_distrib_numeral2
tff(fact_4307_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( inverse(B)
        & power(B) )
     => ! [X: B] : ( power_int(B,X,zero_zero(int)) = one_one(B) ) ) ).

% power_int_0_right
tff(fact_4308_power__int__minus__one__mult__self,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [M4: int] : ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),M4)),power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),M4)) = one_one(B) ) ) ).

% power_int_minus_one_mult_self
tff(fact_4309_power__int__minus__one__mult__self_H,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [M4: int,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),M4)),aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),M4)),Ba)) = Ba ) ) ).

% power_int_minus_one_mult_self'
tff(fact_4310_power__int__add__numeral,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X: B,M4: num,N: num] : ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X,aa(num,int,numeral_numeral(int),M4))),power_int(B,X,aa(num,int,numeral_numeral(int),N))) = power_int(B,X,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M4),N))) ) ) ).

% power_int_add_numeral
tff(fact_4311_power__int__add__numeral2,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X: B,M4: num,N: num,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X,aa(num,int,numeral_numeral(int),M4))),aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X,aa(num,int,numeral_numeral(int),N))),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M4),N)))),Ba) ) ) ).

% power_int_add_numeral2
tff(fact_4312_mod__h__bot__normalize,axiom,
    ! [B: $tType,H2: heap_ext(product_unit),Pa: assn] :
      ( syntax7388354845996824322omatch(B,heap_ext(product_unit),undefined(B),H2)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),bot_bot(set(nat))))
      <=> aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Pa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),undefined(heap_ext(product_unit))),bot_bot(set(nat)))) ) ) ).

% mod_h_bot_normalize
tff(fact_4313_power__int__commutes,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X: B,N: int] : ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X,N)),X) = aa(B,B,aa(B,fun(B,B),times_times(B),X),power_int(B,X,N)) ) ) ).

% power_int_commutes
tff(fact_4314_power__int__mult__distrib,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X: B,Y: B,M4: int] : ( power_int(B,aa(B,B,aa(B,fun(B,B),times_times(B),X),Y),M4) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X,M4)),power_int(B,Y,M4)) ) ) ).

% power_int_mult_distrib
tff(fact_4315_power__int__one__over,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X: B,N: int] : ( power_int(B,divide_divide(B,one_one(B),X),N) = divide_divide(B,one_one(B),power_int(B,X,N)) ) ) ).

% power_int_one_over
tff(fact_4316_power__int__0__left__If,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [M4: int] :
          ( power_int(B,zero_zero(B),M4)
          = $ite(M4 = zero_zero(int),one_one(B),zero_zero(B)) ) ) ).

% power_int_0_left_If
tff(fact_4317_power__int__increasing,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [N: int,N4: int,A3: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),N),N4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),power_int(B,A3,N)),power_int(B,A3,N4)) ) ) ) ).

% power_int_increasing
tff(fact_4318_power__int__strict__increasing,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [N: int,N4: int,A3: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),N),N4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),power_int(B,A3,N)),power_int(B,A3,N4)) ) ) ) ).

% power_int_strict_increasing
tff(fact_4319_power__int__minus__one__minus,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [N: int] : ( power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(int,int,uminus_uminus(int),N)) = power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),N) ) ) ).

% power_int_minus_one_minus
tff(fact_4320_power__int__minus__one__diff__commute,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [A3: int,Ba: int] : ( power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(int,int,aa(int,fun(int,int),minus_minus(int),A3),Ba)) = power_int(B,aa(B,B,uminus_uminus(B),one_one(B)),aa(int,int,aa(int,fun(int,int),minus_minus(int),Ba),A3)) ) ) ).

% power_int_minus_one_diff_commute
tff(fact_4321_power__int__strict__decreasing,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [N: int,N4: int,A3: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),N),N4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),A3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),A3),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),power_int(B,A3,N4)),power_int(B,A3,N)) ) ) ) ) ).

% power_int_strict_decreasing
tff(fact_4322_one__le__power__int,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X: B,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),X)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),power_int(B,X,N)) ) ) ) ).

% one_le_power_int
tff(fact_4323_one__less__power__int,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [A3: B,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),A3)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),power_int(B,A3,N)) ) ) ) ).

% one_less_power_int
tff(fact_4324_power__int__add,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [X: B,M4: int,N: int] :
          ( ( ( X != zero_zero(B) )
            | ( aa(int,int,aa(int,fun(int,int),plus_plus(int),M4),N) != zero_zero(int) ) )
         => ( power_int(B,X,aa(int,int,aa(int,fun(int,int),plus_plus(int),M4),N)) = aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X,M4)),power_int(B,X,N)) ) ) ) ).

% power_int_add
tff(fact_4325_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( division_ring(D)
        & one(B)
        & uminus(B) )
     => ! [X: C,A3: D,N: int] :
          ( nO_MATCH(B,C,aa(B,B,uminus_uminus(B),one_one(B)),X)
         => ( power_int(D,aa(D,D,uminus_uminus(D),A3),N) = aa(D,D,aa(D,fun(D,D),times_times(D),power_int(D,aa(D,D,uminus_uminus(D),one_one(D)),N)),power_int(D,A3,N)) ) ) ) ).

% power_int_minus_left_distrib
tff(fact_4326_power__int__le__one,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X: B,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),X)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),one_one(B))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),power_int(B,X,N)),one_one(B)) ) ) ) ) ).

% power_int_le_one
tff(fact_4327_power__int__decreasing,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [N: int,N4: int,A3: B] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),N),N4)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),A3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A3),one_one(B))
             => ( ( ( A3 != zero_zero(B) )
                  | ( N4 != zero_zero(int) )
                  | ( N = zero_zero(int) ) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),power_int(B,A3,N4)),power_int(B,A3,N)) ) ) ) ) ) ).

% power_int_decreasing
tff(fact_4328_power__int__le__imp__le__exp,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X: B,M4: int,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),power_int(B,X,M4)),power_int(B,X,N))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
             => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),M4),N) ) ) ) ) ).

% power_int_le_imp_le_exp
tff(fact_4329_power__int__le__imp__less__exp,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [X: B,M4: int,N: int] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),X)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),power_int(B,X,M4)),power_int(B,X,N))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
             => aa(int,$o,aa(int,fun(int,$o),ord_less(int),M4),N) ) ) ) ) ).

% power_int_le_imp_less_exp
tff(fact_4330_power__int__minus__mult,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [X: B,N: int] :
          ( ( ( X != zero_zero(B) )
            | ( N != zero_zero(int) ) )
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),power_int(B,X,aa(int,int,aa(int,fun(int,int),minus_minus(int),N),one_one(int)))),X) = power_int(B,X,N) ) ) ) ).

% power_int_minus_mult
tff(fact_4331_numeral__unfold__funpow,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [K: num] : ( aa(num,B,numeral_numeral(B),K) = aa(B,B,compow(fun(B,B),aa(num,nat,numeral_numeral(nat),K),aa(B,fun(B,B),plus_plus(B),one_one(B))),zero_zero(B)) ) ) ).

% numeral_unfold_funpow
tff(fact_4332_Fract__def,axiom,
    fract = aa(fun(int,fun(int,product_prod(int,int))),fun(int,fun(int,rat)),map_fun(int,int,fun(int,product_prod(int,int)),fun(int,rat),id(int),map_fun(int,int,product_prod(int,int),rat,id(int),abs_Rat)),aTP_Lamp_gu(int,fun(int,product_prod(int,int)))) ).

% Fract_def
tff(fact_4333_Fract_Otransfer,axiom,
    aa(fun(int,fun(int,rat)),$o,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,rat)),$o),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,rat),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),rat,fequal(int),pcr_rat)),aTP_Lamp_gu(int,fun(int,product_prod(int,int)))),fract) ).

% Fract.transfer
tff(fact_4334_mset__set__Union,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( aa(set(B),$o,finite_finite(B),B2)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2) = bot_bot(set(B)) )
         => ( mset_set(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),mset_set(B,A4)),mset_set(B,B2)) ) ) ) ) ).

% mset_set_Union
tff(fact_4335_mset__set_Oempty,axiom,
    ! [B: $tType] : ( mset_set(B,bot_bot(set(B))) = zero_zero(multiset(B)) ) ).

% mset_set.empty
tff(fact_4336_comp__funpow,axiom,
    ! [B: $tType,C: $tType,N: nat,Fa: fun(C,C)] : ( compow(fun(fun(B,C),fun(B,C)),N,aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),Fa)) = aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),compow(fun(C,C),N,Fa)) ) ).

% comp_funpow
tff(fact_4337_funpow__times__power,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Fa: fun(B,nat),X: B] : ( compow(fun(B,B),aa(B,nat,Fa,X),aa(B,fun(B,B),times_times(B),X)) = aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),X),aa(B,nat,Fa,X))) ) ) ).

% funpow_times_power
tff(fact_4338_funpow_Osimps_I2_J,axiom,
    ! [B: $tType,N: nat,Fa: fun(B,B)] : ( compow(fun(B,B),aa(nat,nat,suc,N),Fa) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),Fa),compow(fun(B,B),N,Fa)) ) ).

% funpow.simps(2)
tff(fact_4339_funpow__Suc__right,axiom,
    ! [B: $tType,N: nat,Fa: fun(B,B)] : ( compow(fun(B,B),aa(nat,nat,suc,N),Fa) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),compow(fun(B,B),N,Fa)),Fa) ) ).

% funpow_Suc_right
tff(fact_4340_funpow__add,axiom,
    ! [B: $tType,M4: nat,N: nat,Fa: fun(B,B)] : ( compow(fun(B,B),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),N),Fa) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),compow(fun(B,B),M4,Fa)),compow(fun(B,B),N,Fa)) ) ).

% funpow_add
tff(fact_4341_quotient__of__eq,axiom,
    ! [A3: int,Ba: int,P2: int,Q2: int] :
      ( ( quotient_of(aa(int,rat,aa(int,fun(int,rat),fract,A3),Ba)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2) )
     => ( aa(int,rat,aa(int,fun(int,rat),fract,P2),Q2) = aa(int,rat,aa(int,fun(int,rat),fract,A3),Ba) ) ) ).

% quotient_of_eq
tff(fact_4342_normalize__eq,axiom,
    ! [A3: int,Ba: int,P2: int,Q2: int] :
      ( ( normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),Ba)) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),P2),Q2) )
     => ( aa(int,rat,aa(int,fun(int,rat),fract,P2),Q2) = aa(int,rat,aa(int,fun(int,rat),fract,A3),Ba) ) ) ).

% normalize_eq
tff(fact_4343_mono__funpow,axiom,
    ! [B: $tType] :
      ( ( lattice(B)
        & order_bot(B) )
     => ! [Qa: fun(B,B)] :
          ( order_mono(B,B,Qa)
         => order_mono(nat,B,aTP_Lamp_pq(fun(B,B),fun(nat,B),Qa)) ) ) ).

% mono_funpow
tff(fact_4344_Kleene__iter__lpfp,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [Fa: fun(B,B),P2: B,K: nat] :
          ( order_mono(B,B,Fa)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,Fa,P2)),P2)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,compow(fun(B,B),K,Fa),bot_bot(B))),P2) ) ) ) ).

% Kleene_iter_lpfp
tff(fact_4345_relpowp__bot,axiom,
    ! [B: $tType,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( compow(fun(B,fun(B,$o)),N,bot_bot(fun(B,fun(B,$o)))) = bot_bot(fun(B,fun(B,$o))) ) ) ).

% relpowp_bot
tff(fact_4346_mset__set__empty__iff,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ( mset_set(B,A4) = zero_zero(multiset(B)) )
    <=> ( ( A4 = bot_bot(set(B)) )
        | ~ aa(set(B),$o,finite_finite(B),A4) ) ) ).

% mset_set_empty_iff
tff(fact_4347_quotient__of__Fract,axiom,
    ! [A3: int,Ba: int] : ( quotient_of(aa(int,rat,aa(int,fun(int,rat),fract,A3),Ba)) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),A3),Ba)) ) ).

% quotient_of_Fract
tff(fact_4348_of__nat__def,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat] : ( aa(nat,B,semiring_1_of_nat(B),N) = aa(B,B,compow(fun(B,B),N,aa(B,fun(B,B),plus_plus(B),one_one(B))),zero_zero(B)) ) ) ).

% of_nat_def
tff(fact_4349_numeral__add__unfold__funpow,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [K: num,A3: B] : ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(num,B,numeral_numeral(B),K)),A3) = aa(B,B,compow(fun(B,B),aa(num,nat,numeral_numeral(nat),K),aa(B,fun(B,B),plus_plus(B),one_one(B))),A3) ) ) ).

% numeral_add_unfold_funpow
tff(fact_4350_funpow__decreasing,axiom,
    ! [B: $tType] :
      ( ( lattice(B)
        & order_bot(B) )
     => ! [M4: nat,N: nat,Fa: fun(B,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
         => ( order_mono(B,B,Fa)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,compow(fun(B,B),M4,Fa),bot_bot(B))),aa(B,B,compow(fun(B,B),N,Fa),bot_bot(B))) ) ) ) ).

% funpow_decreasing
tff(fact_4351_lfp__Kleene__iter,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(B,B),K: nat] :
          ( order_mono(B,B,Fa)
         => ( ( aa(B,B,compow(fun(B,B),aa(nat,nat,suc,K),Fa),bot_bot(B)) = aa(B,B,compow(fun(B,B),K,Fa),bot_bot(B)) )
           => ( complete_lattice_lfp(B,Fa) = aa(B,B,compow(fun(B,B),K,Fa),bot_bot(B)) ) ) ) ) ).

% lfp_Kleene_iter
tff(fact_4352_Fract_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( aa(int,rat,aa(int,fun(int,rat),fract,Xa),X)
      = aa(product_prod(int,int),rat,abs_Rat,$ite(X = zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Xa),X))) ) ).

% Fract.abs_eq
tff(fact_4353_mset__set_Oinsert__remove,axiom,
    ! [B: $tType,A4: set(B),X: B] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( mset_set(B,aa(set(B),set(B),insert2(B,X),A4)) = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X),mset_set(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ).

% mset_set.insert_remove
tff(fact_4354_mset__set_Oremove,axiom,
    ! [B: $tType,A4: set(B),X: B] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( member(B,X,A4)
       => ( mset_set(B,A4) = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X),mset_set(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ).

% mset_set.remove
tff(fact_4355_mult__cancel,axiom,
    ! [B: $tType,S: set(product_prod(B,B)),X6: multiset(B),Z6: multiset(B),Y5: multiset(B)] :
      ( trans(B,S)
     => ( irrefl(B,S)
       => ( member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),X6),Z6)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),Y5),Z6)),mult(B,S))
        <=> member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),X6),Y5),mult(B,S)) ) ) ) ).

% mult_cancel
tff(fact_4356_o__prs_I2_J,axiom,
    ! [G: $tType,F7: $tType,D: $tType,E: $tType,B: $tType,C: $tType,I5: $tType,H7: $tType,R12: fun(B,fun(B,$o)),Abs1: fun(B,C),Rep1: fun(C,B),R23: fun(D,fun(D,$o)),Abs22: fun(D,E),Rep22: fun(E,D),R32: fun(F7,fun(F7,$o)),Abs32: fun(F7,G),Rep32: fun(G,F7)] :
      ( quotient3(B,C,R12,Abs1,Rep1)
     => ( quotient3(D,E,R23,Abs22,Rep22)
       => ( quotient3(F7,G,R32,Abs32,Rep32)
         => ( aa(fun(fun(H7,I5),fun(fun(B,H7),fun(B,I5))),fun(fun(H7,I5),fun(fun(C,H7),fun(C,I5))),map_fun(fun(H7,I5),fun(H7,I5),fun(fun(B,H7),fun(B,I5)),fun(fun(C,H7),fun(C,I5)),id(fun(H7,I5)),map_fun(fun(C,H7),fun(B,H7),fun(B,I5),fun(C,I5),map_fun(B,C,H7,H7,Abs1,id(H7)),map_fun(C,B,I5,I5,Rep1,id(I5)))),comp(H7,I5,B)) = comp(H7,I5,C) ) ) ) ) ).

% o_prs(2)
tff(fact_4357_mult__cancel__add__mset,axiom,
    ! [B: $tType,S: set(product_prod(B,B)),Uu: B,X6: multiset(B),Y5: multiset(B)] :
      ( trans(B,S)
     => ( irrefl(B,S)
       => ( member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),Uu),X6)),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),Uu),Y5)),mult(B,S))
        <=> member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),X6),Y5),mult(B,S)) ) ) ) ).

% mult_cancel_add_mset
tff(fact_4358_mset__set_Ocomp__fun__commute__on,axiom,
    ! [B: $tType,Y: B,X: B] : ( aa(fun(multiset(B),multiset(B)),fun(multiset(B),multiset(B)),aa(fun(multiset(B),multiset(B)),fun(fun(multiset(B),multiset(B)),fun(multiset(B),multiset(B))),comp(multiset(B),multiset(B),multiset(B)),aa(B,fun(multiset(B),multiset(B)),add_mset(B),Y)),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X)) = aa(fun(multiset(B),multiset(B)),fun(multiset(B),multiset(B)),aa(fun(multiset(B),multiset(B)),fun(fun(multiset(B),multiset(B)),fun(multiset(B),multiset(B))),comp(multiset(B),multiset(B),multiset(B)),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X)),aa(B,fun(multiset(B),multiset(B)),add_mset(B),Y)) ) ).

% mset_set.comp_fun_commute_on
tff(fact_4359_comp__fun__commute__mset__image,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] : finite6289374366891150609ommute(B,multiset(C),aa(fun(B,C),fun(B,fun(multiset(C),multiset(C))),aa(fun(C,fun(multiset(C),multiset(C))),fun(fun(B,C),fun(B,fun(multiset(C),multiset(C)))),comp(C,fun(multiset(C),multiset(C)),B),add_mset(C)),Fa)) ).

% comp_fun_commute_mset_image
tff(fact_4360_abs__o__rep,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(B,$o)),Abs: fun(B,C),Rep: fun(C,B)] :
      ( quotient3(B,C,R,Abs,Rep)
     => ( aa(fun(C,B),fun(C,C),aa(fun(B,C),fun(fun(C,B),fun(C,C)),comp(B,C,C),Abs),Rep) = id(C) ) ) ).

% abs_o_rep
tff(fact_4361_o__prs_I1_J,axiom,
    ! [D: $tType,F7: $tType,B: $tType,C: $tType,G: $tType,E: $tType,R12: fun(B,fun(B,$o)),Abs1: fun(B,C),Rep1: fun(C,B),R23: fun(D,fun(D,$o)),Abs22: fun(D,E),Rep22: fun(E,D),R32: fun(F7,fun(F7,$o)),Abs32: fun(F7,G),Rep32: fun(G,F7)] :
      ( quotient3(B,C,R12,Abs1,Rep1)
     => ( quotient3(D,E,R23,Abs22,Rep22)
       => ( quotient3(F7,G,R32,Abs32,Rep32)
         => ( aa(fun(fun(D,F7),fun(fun(B,D),fun(B,F7))),fun(fun(E,G),fun(fun(C,E),fun(C,G))),map_fun(fun(E,G),fun(D,F7),fun(fun(B,D),fun(B,F7)),fun(fun(C,E),fun(C,G)),map_fun(D,E,G,F7,Abs22,Rep32),map_fun(fun(C,E),fun(B,D),fun(B,F7),fun(C,G),map_fun(B,C,E,D,Abs1,Rep22),map_fun(C,B,F7,G,Rep1,Abs32))),comp(D,F7,B)) = comp(E,G,C) ) ) ) ) ).

% o_prs(1)
tff(fact_4362_OOO__eq__quotient3,axiom,
    ! [B: $tType,C: $tType,D: $tType,R12: fun(B,fun(B,$o)),Abs1: fun(B,C),Rep1: fun(C,B),Abs22: fun(C,D),Rep22: fun(D,C)] :
      ( quotient3(B,C,R12,Abs1,Rep1)
     => ( quotient3(C,D,fequal(C),Abs22,Rep22)
       => quotient3(B,D,relcompp(B,B,B,R12,relcompp(B,B,B,fequal(B),R12)),aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Abs22),Abs1),aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Rep1),Rep22)) ) ) ).

% OOO_eq_quotient3
tff(fact_4363_OOO__quotient3,axiom,
    ! [B: $tType,C: $tType,D: $tType,R12: fun(B,fun(B,$o)),Abs1: fun(B,C),Rep1: fun(C,B),R23: fun(C,fun(C,$o)),Abs22: fun(C,D),Rep22: fun(D,C),R24: fun(B,fun(B,$o))] :
      ( quotient3(B,C,R12,Abs1,Rep1)
     => ( quotient3(C,D,R23,Abs22,Rep22)
       => ( ! [X2: B,Y2: B] :
              ( aa(B,$o,aa(B,fun(B,$o),R24,X2),Y2)
             => ( aa(B,$o,aa(B,fun(B,$o),R12,X2),X2)
               => ( aa(B,$o,aa(B,fun(B,$o),R12,Y2),Y2)
                 => aa(C,$o,aa(C,fun(C,$o),R23,aa(B,C,Abs1,X2)),aa(B,C,Abs1,Y2)) ) ) )
         => ( ! [X2: C,Y2: C] :
                ( aa(C,$o,aa(C,fun(C,$o),R23,X2),Y2)
               => aa(B,$o,aa(B,fun(B,$o),R24,aa(C,B,Rep1,X2)),aa(C,B,Rep1,Y2)) )
           => quotient3(B,D,relcompp(B,B,B,R12,relcompp(B,B,B,R24,R12)),aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Abs22),Abs1),aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Rep1),Rep22)) ) ) ) ) ).

% OOO_quotient3
tff(fact_4364_mult__cancel__max,axiom,
    ! [B: $tType,S: set(product_prod(B,B)),X6: multiset(B),Y5: multiset(B)] :
      ( trans(B,S)
     => ( irrefl(B,S)
       => ( member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),X6),Y5),mult(B,S))
        <=> member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),X6),Y5)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),Y5),X6)),mult(B,S)) ) ) ) ).

% mult_cancel_max
tff(fact_4365_multeqp__code__iff__reflcl__mult,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),Pa: fun(B,fun(B,$o)),N4: multiset(B),M: multiset(B)] :
      ( irrefl(B,R)
     => ( trans(B,R)
       => ( ! [X2: B,Y2: B] :
              ( aa(B,$o,aa(B,fun(B,$o),Pa,X2),Y2)
            <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),R) )
         => ( multeqp_code(B,Pa,N4,M)
          <=> member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),N4),M),aa(set(product_prod(multiset(B),multiset(B))),set(product_prod(multiset(B),multiset(B))),aa(set(product_prod(multiset(B),multiset(B))),fun(set(product_prod(multiset(B),multiset(B))),set(product_prod(multiset(B),multiset(B)))),sup_sup(set(product_prod(multiset(B),multiset(B)))),mult(B,R)),id2(multiset(B)))) ) ) ) ) ).

% multeqp_code_iff_reflcl_mult
tff(fact_4366_multp__code__iff__mult,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),Pa: fun(B,fun(B,$o)),N4: multiset(B),M: multiset(B)] :
      ( irrefl(B,R)
     => ( trans(B,R)
       => ( ! [X2: B,Y2: B] :
              ( aa(B,$o,aa(B,fun(B,$o),Pa,X2),Y2)
            <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),R) )
         => ( multp_code(B,Pa,N4,M)
          <=> member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),N4),M),mult(B,R)) ) ) ) ) ).

% multp_code_iff_mult
tff(fact_4367_mult__implies__one__step,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),M: multiset(B),N4: multiset(B)] :
      ( trans(B,R3)
     => ( member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),M),N4),mult(B,R3))
       => ? [I6: multiset(B),J5: multiset(B)] :
            ( ( N4 = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),I6),J5) )
            & ? [K7: multiset(B)] :
                ( ( M = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),I6),K7) )
                & ( J5 != zero_zero(multiset(B)) )
                & ! [X3: B] :
                    ( member(B,X3,aa(multiset(B),set(B),set_mset(B),K7))
                   => ? [Xa4: B] :
                        ( member(B,Xa4,aa(multiset(B),set(B),set_mset(B),J5))
                        & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa4),R3) ) ) ) ) ) ) ).

% mult_implies_one_step
tff(fact_4368_multp__def,axiom,
    ! [B: $tType,R3: fun(B,fun(B,$o)),M: multiset(B),N4: multiset(B)] :
      ( multp(B,R3,M,N4)
    <=> member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),M),N4),mult(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R3)))) ) ).

% multp_def
tff(fact_4369_set__mset__eq__empty__iff,axiom,
    ! [B: $tType,M: multiset(B)] :
      ( ( aa(multiset(B),set(B),set_mset(B),M) = bot_bot(set(B)) )
    <=> ( M = zero_zero(multiset(B)) ) ) ).

% set_mset_eq_empty_iff
tff(fact_4370_set__mset__empty,axiom,
    ! [B: $tType] : ( aa(multiset(B),set(B),set_mset(B),zero_zero(multiset(B))) = bot_bot(set(B)) ) ).

% set_mset_empty
tff(fact_4371_in__Inf__multiset__iff,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: B] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( member(B,X,aa(multiset(B),set(B),set_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A4)))
      <=> ! [X4: multiset(B)] :
            ( member(multiset(B),X4,A4)
           => member(B,X,aa(multiset(B),set(B),set_mset(B),X4)) ) ) ) ).

% in_Inf_multiset_iff
tff(fact_4372_infinite__set__mset__mset__set,axiom,
    ! [B: $tType,A4: set(B)] :
      ( ~ aa(set(B),$o,finite_finite(B),A4)
     => ( aa(multiset(B),set(B),set_mset(B),mset_set(B,A4)) = bot_bot(set(B)) ) ) ).

% infinite_set_mset_mset_set
tff(fact_4373_set__mset__Inf,axiom,
    ! [B: $tType,A4: set(multiset(B))] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( aa(multiset(B),set(B),set_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A4)) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(multiset(B)),set(set(B)),image2(multiset(B),set(B),set_mset(B)),A4)) ) ) ).

% set_mset_Inf
tff(fact_4374_set__mset__single,axiom,
    ! [B: $tType,Ba: B] : ( aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),Ba),zero_zero(multiset(B)))) = aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))) ) ).

% set_mset_single
tff(fact_4375_at__most__one__mset__mset__diff,axiom,
    ! [B: $tType,A3: B,M: multiset(B)] :
      ( ~ member(B,A3,aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),M),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A3),zero_zero(multiset(B))))))
     => ( aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),M),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A3),zero_zero(multiset(B))))) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(multiset(B),set(B),set_mset(B),M)),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) ) ) ).

% at_most_one_mset_mset_diff
tff(fact_4376_one__step__implies__mult,axiom,
    ! [B: $tType,J4: multiset(B),K5: multiset(B),R3: set(product_prod(B,B)),I4: multiset(B)] :
      ( ( J4 != zero_zero(multiset(B)) )
     => ( ! [X2: B] :
            ( member(B,X2,aa(multiset(B),set(B),set_mset(B),K5))
           => ? [Xa3: B] :
                ( member(B,Xa3,aa(multiset(B),set(B),set_mset(B),J4))
                & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Xa3),R3) ) )
       => member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),I4),K5)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),I4),J4)),mult(B,R3)) ) ) ).

% one_step_implies_mult
tff(fact_4377_mult1__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( mult1(B,R3) = aa(fun(product_prod(multiset(B),multiset(B)),$o),set(product_prod(multiset(B),multiset(B))),collect(product_prod(multiset(B),multiset(B))),aa(fun(multiset(B),fun(multiset(B),$o)),fun(product_prod(multiset(B),multiset(B)),$o),product_case_prod(multiset(B),multiset(B),$o),aTP_Lamp_pr(set(product_prod(B,B)),fun(multiset(B),fun(multiset(B),$o)),R3))) ) ).

% mult1_def
tff(fact_4378_less__add,axiom,
    ! [B: $tType,N4: multiset(B),A3: B,M0: multiset(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),N4),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A3),M0)),mult1(B,R3))
     => ( ? [M7: multiset(B)] :
            ( member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),M7),M0),mult1(B,R3))
            & ( N4 = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A3),M7) ) )
        | ? [K7: multiset(B)] :
            ( ! [B9: B] :
                ( member(B,B9,aa(multiset(B),set(B),set_mset(B),K7))
               => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B9),A3),R3) )
            & ( N4 = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),M0),K7) ) ) ) ) ).

% less_add
tff(fact_4379_mult1I,axiom,
    ! [B: $tType,M: multiset(B),A3: B,M0: multiset(B),N4: multiset(B),K5: multiset(B),R3: set(product_prod(B,B))] :
      ( ( M = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A3),M0) )
     => ( ( N4 = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),M0),K5) )
       => ( ! [B4: B] :
              ( member(B,B4,aa(multiset(B),set(B),set_mset(B),K5))
             => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B4),A3),R3) )
         => member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),N4),M),mult1(B,R3)) ) ) ) ).

% mult1I
tff(fact_4380_mult1E,axiom,
    ! [B: $tType,N4: multiset(B),M: multiset(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),N4),M),mult1(B,R3))
     => ~ ! [A8: B,M02: multiset(B)] :
            ( ( M = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A8),M02) )
           => ! [K7: multiset(B)] :
                ( ( N4 = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),M02),K7) )
               => ~ ! [B9: B] :
                      ( member(B,B9,aa(multiset(B),set(B),set_mset(B),K7))
                     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B9),A8),R3) ) ) ) ) ).

% mult1E
tff(fact_4381_not__less__empty,axiom,
    ! [B: $tType,M: multiset(B),R3: set(product_prod(B,B))] : ~ member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),M),zero_zero(multiset(B))),mult1(B,R3)) ).

% not_less_empty
tff(fact_4382_mult1__union,axiom,
    ! [B: $tType,B2: multiset(B),D4: multiset(B),R3: set(product_prod(B,B)),C3: multiset(B)] :
      ( member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),B2),D4),mult1(B,R3))
     => member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),C3),B2)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),C3),D4)),mult1(B,R3)) ) ).

% mult1_union
tff(fact_4383_mult1__lessE,axiom,
    ! [B: $tType,N4: multiset(B),M: multiset(B),R3: fun(B,fun(B,$o))] :
      ( member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),N4),M),mult1(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R3))))
     => ( asymp(B,R3)
       => ~ ! [A8: B,M02: multiset(B)] :
              ( ( M = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A8),M02) )
             => ! [K7: multiset(B)] :
                  ( ( N4 = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),M02),K7) )
                 => ( ~ member(B,A8,aa(multiset(B),set(B),set_mset(B),K7))
                   => ~ ! [B9: B] :
                          ( member(B,B9,aa(multiset(B),set(B),set_mset(B),K7))
                         => aa(B,$o,aa(B,fun(B,$o),R3,B9),A8) ) ) ) ) ) ) ).

% mult1_lessE
tff(fact_4384_sum__wcount__Int,axiom,
    ! [B: $tType,A4: set(B),Fa: fun(B,nat),N4: multiset(B)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),wcount(B,Fa,N4)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(multiset(B),set(B),set_mset(B),N4))) = aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),wcount(B,Fa,N4)),A4) ) ) ).

% sum_wcount_Int
tff(fact_4385_wmsI,axiom,
    ! [A4: multiset(product_prod(nat,nat)),B2: multiset(product_prod(nat,nat)),Z6: multiset(product_prod(nat,nat))] :
      ( ( member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),A4)),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),B2)),fun_max_strict)
        | ( ( A4 = zero_zero(multiset(product_prod(nat,nat))) )
          & ( B2 = zero_zero(multiset(product_prod(nat,nat))) ) ) )
     => member(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_Pair(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),A4)),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),B2)),ms_weak) ) ).

% wmsI
tff(fact_4386_smsI,axiom,
    ! [A4: multiset(product_prod(nat,nat)),B2: multiset(product_prod(nat,nat)),Z6: multiset(product_prod(nat,nat))] :
      ( member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),A4)),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),B2)),fun_max_strict)
     => member(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_Pair(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),A4)),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),B2)),ms_strict) ) ).

% smsI
tff(fact_4387_ms__reduction__pair,axiom,
    fun_reduction_pair(multiset(product_prod(nat,nat)),aa(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_prod(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))))),aa(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),fun(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_prod(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))))),product_Pair(set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),set(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))))),ms_strict),ms_weak)) ).

% ms_reduction_pair
tff(fact_4388_ms__strictI,axiom,
    ! [Z6: multiset(product_prod(nat,nat)),Z7: multiset(product_prod(nat,nat)),A4: multiset(product_prod(nat,nat)),B2: multiset(product_prod(nat,nat))] :
      ( pw_leq(Z6,Z7)
     => ( member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),A4)),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),B2)),fun_max_strict)
       => member(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_Pair(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),A4)),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z7),B2)),ms_strict) ) ) ).

% ms_strictI
tff(fact_4389_ms__weakI1,axiom,
    ! [Z6: multiset(product_prod(nat,nat)),Z7: multiset(product_prod(nat,nat)),A4: multiset(product_prod(nat,nat)),B2: multiset(product_prod(nat,nat))] :
      ( pw_leq(Z6,Z7)
     => ( member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),A4)),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),B2)),fun_max_strict)
       => member(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_Pair(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),A4)),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z7),B2)),ms_weak) ) ) ).

% ms_weakI1
tff(fact_4390_pw__leq__split,axiom,
    ! [X6: multiset(product_prod(nat,nat)),Y5: multiset(product_prod(nat,nat))] :
      ( pw_leq(X6,Y5)
     => ? [A12: multiset(product_prod(nat,nat)),B8: multiset(product_prod(nat,nat)),Z8: multiset(product_prod(nat,nat))] :
          ( ( X6 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),A12),Z8) )
          & ( Y5 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),B8),Z8) )
          & ( member(product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),product_prod(set(product_prod(nat,nat)),set(product_prod(nat,nat)))),product_Pair(set(product_prod(nat,nat)),set(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),A12)),aa(multiset(product_prod(nat,nat)),set(product_prod(nat,nat)),set_mset(product_prod(nat,nat)),B8)),fun_max_strict)
            | ( ( B8 = zero_zero(multiset(product_prod(nat,nat))) )
              & ( A12 = zero_zero(multiset(product_prod(nat,nat))) ) ) ) ) ) ).

% pw_leq_split
tff(fact_4391_ms__weakI2,axiom,
    ! [Z6: multiset(product_prod(nat,nat)),Z7: multiset(product_prod(nat,nat))] :
      ( pw_leq(Z6,Z7)
     => member(product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),product_prod(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)))),product_Pair(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z6),zero_zero(multiset(product_prod(nat,nat))))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),Z7),zero_zero(multiset(product_prod(nat,nat))))),ms_weak) ) ).

% ms_weakI2
tff(fact_4392_pw__leq__lstep,axiom,
    ! [X: product_prod(nat,nat),Y: product_prod(nat,nat)] :
      ( member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_leq)
     => pw_leq(aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),X),zero_zero(multiset(product_prod(nat,nat)))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),Y),zero_zero(multiset(product_prod(nat,nat))))) ) ).

% pw_leq_lstep
tff(fact_4393_pw__leq__step,axiom,
    ! [X: product_prod(nat,nat),Y: product_prod(nat,nat),X6: multiset(product_prod(nat,nat)),Y5: multiset(product_prod(nat,nat))] :
      ( member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X),Y),fun_pair_leq)
     => ( pw_leq(X6,Y5)
       => pw_leq(aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),X),zero_zero(multiset(product_prod(nat,nat))))),X6),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),Y),zero_zero(multiset(product_prod(nat,nat))))),Y5)) ) ) ).

% pw_leq_step
tff(fact_4394_pw__leq_Osimps,axiom,
    ! [A1: multiset(product_prod(nat,nat)),A22: multiset(product_prod(nat,nat))] :
      ( pw_leq(A1,A22)
    <=> ( ( ( A1 = zero_zero(multiset(product_prod(nat,nat))) )
          & ( A22 = zero_zero(multiset(product_prod(nat,nat))) ) )
        | ? [X4: product_prod(nat,nat),Y3: product_prod(nat,nat),X8: multiset(product_prod(nat,nat)),Y8: multiset(product_prod(nat,nat))] :
            ( ( A1 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),X4),zero_zero(multiset(product_prod(nat,nat))))),X8) )
            & ( A22 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),Y3),zero_zero(multiset(product_prod(nat,nat))))),Y8) )
            & member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X4),Y3),fun_pair_leq)
            & pw_leq(X8,Y8) ) ) ) ).

% pw_leq.simps
tff(fact_4395_pw__leq_Ocases,axiom,
    ! [A1: multiset(product_prod(nat,nat)),A22: multiset(product_prod(nat,nat))] :
      ( pw_leq(A1,A22)
     => ( ( ( A1 = zero_zero(multiset(product_prod(nat,nat))) )
         => ( A22 != zero_zero(multiset(product_prod(nat,nat))) ) )
       => ~ ! [X2: product_prod(nat,nat),Y2: product_prod(nat,nat),X7: multiset(product_prod(nat,nat))] :
              ( ( A1 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),X2),zero_zero(multiset(product_prod(nat,nat))))),X7) )
             => ! [Y9: multiset(product_prod(nat,nat))] :
                  ( ( A22 = aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(multiset(product_prod(nat,nat)),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),plus_plus(multiset(product_prod(nat,nat))),aa(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat)),aa(product_prod(nat,nat),fun(multiset(product_prod(nat,nat)),multiset(product_prod(nat,nat))),add_mset(product_prod(nat,nat)),Y2),zero_zero(multiset(product_prod(nat,nat))))),Y9) )
                 => ( member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat))),product_Pair(product_prod(nat,nat),product_prod(nat,nat)),X2),Y2),fun_pair_leq)
                   => ~ pw_leq(X7,Y9) ) ) ) ) ) ).

% pw_leq.cases
tff(fact_4396_set__mset__replicate__mset__subset,axiom,
    ! [B: $tType,N: nat,X: B] :
      ( aa(multiset(B),set(B),set_mset(B),replicate_mset(B,N,X))
      = $ite(N = zero_zero(nat),bot_bot(set(B)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) ) ).

% set_mset_replicate_mset_subset
tff(fact_4397_mult__cancel__max0,axiom,
    ! [B: $tType,S: set(product_prod(B,B)),X6: multiset(B),Y5: multiset(B)] :
      ( trans(B,S)
     => ( irrefl(B,S)
       => ( member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),X6),Y5),mult(B,S))
        <=> member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),X6),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X6),Y5))),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),Y5),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X6),Y5))),mult(B,S)) ) ) ) ).

% mult_cancel_max0
tff(fact_4398_prod__mset_Oremove,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [X: B,A4: multiset(B)] :
          ( member(B,X,aa(multiset(B),set(B),set_mset(B),A4))
         => ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),A4) = aa(B,B,aa(B,fun(B,B),times_times(B),X),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),minus_minus(multiset(B)),A4),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X),zero_zero(multiset(B)))))) ) ) ) ).

% prod_mset.remove
tff(fact_4399_add_Ogroup__axioms,axiom,
    ! [B: $tType] :
      ( group_add(B)
     => group(B,plus_plus(B),zero_zero(B),uminus_uminus(B)) ) ).

% add.group_axioms
tff(fact_4400_set__mset__inter,axiom,
    ! [B: $tType,A4: multiset(B),B2: multiset(B)] : ( aa(multiset(B),set(B),set_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A4),B2)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(multiset(B),set(B),set_mset(B),A4)),aa(multiset(B),set(B),set_mset(B),B2)) ) ).

% set_mset_inter
tff(fact_4401_prod__mset__empty,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),zero_zero(multiset(B))) = one_one(B) ) ) ).

% prod_mset_empty
tff(fact_4402_prod__mset_Oadd__mset,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [X: B,N4: multiset(B)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),X),N4)) = aa(B,B,aa(B,fun(B,B),times_times(B),X),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),N4)) ) ) ).

% prod_mset.add_mset
tff(fact_4403_prod__mset__Un,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: multiset(B),B2: multiset(B)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),A4),B2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),A4)),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),B2)) ) ) ).

% prod_mset_Un
tff(fact_4404_prod__mset_Ounion,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M: multiset(B),N4: multiset(B)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),M),N4)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),M)),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),N4)) ) ) ).

% prod_mset.union
tff(fact_4405_group_Oleft__cancel,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A3: B,Ba: B,C2: B] :
      ( group(B,Fa,Z2,Inverse)
     => ( ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = aa(B,B,aa(B,fun(B,B),Fa,A3),C2) )
      <=> ( Ba = C2 ) ) ) ).

% group.left_cancel
tff(fact_4406_group_Oleft__inverse,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A3: B] :
      ( group(B,Fa,Z2,Inverse)
     => ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,Inverse,A3)),A3) = Z2 ) ) ).

% group.left_inverse
tff(fact_4407_group_Oright__cancel,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),Ba: B,A3: B,C2: B] :
      ( group(B,Fa,Z2,Inverse)
     => ( ( aa(B,B,aa(B,fun(B,B),Fa,Ba),A3) = aa(B,B,aa(B,fun(B,B),Fa,C2),A3) )
      <=> ( Ba = C2 ) ) ) ).

% group.right_cancel
tff(fact_4408_group_Oright__inverse,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A3: B] :
      ( group(B,Fa,Z2,Inverse)
     => ( aa(B,B,aa(B,fun(B,B),Fa,A3),aa(B,B,Inverse,A3)) = Z2 ) ) ).

% group.right_inverse
tff(fact_4409_group_Oinverse__unique,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A3: B,Ba: B] :
      ( group(B,Fa,Z2,Inverse)
     => ( ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = Z2 )
       => ( aa(B,B,Inverse,A3) = Ba ) ) ) ).

% group.inverse_unique
tff(fact_4410_group_Oinverse__inverse,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A3: B] :
      ( group(B,Fa,Z2,Inverse)
     => ( aa(B,B,Inverse,aa(B,B,Inverse,A3)) = A3 ) ) ).

% group.inverse_inverse
tff(fact_4411_group_Oinverse__neutral,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( group(B,Fa,Z2,Inverse)
     => ( aa(B,B,Inverse,Z2) = Z2 ) ) ).

% group.inverse_neutral
tff(fact_4412_group_Ogroup__left__neutral,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A3: B] :
      ( group(B,Fa,Z2,Inverse)
     => ( aa(B,B,aa(B,fun(B,B),Fa,Z2),A3) = A3 ) ) ).

% group.group_left_neutral
tff(fact_4413_group_Oinverse__distrib__swap,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B),A3: B,Ba: B] :
      ( group(B,Fa,Z2,Inverse)
     => ( aa(B,B,Inverse,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)) = aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,Inverse,Ba)),aa(B,B,Inverse,A3)) ) ) ).

% group.inverse_distrib_swap
tff(fact_4414_group_Oaxioms_I1_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( group(B,Fa,Z2,Inverse)
     => semigroup(B,Fa) ) ).

% group.axioms(1)
tff(fact_4415_prod__mset_Oneutral,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: multiset(B)] :
          ( ! [X2: B] :
              ( member(B,X2,aa(multiset(B),set(B),set_mset(B),A4))
             => ( X2 = one_one(B) ) )
         => ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),A4) = one_one(B) ) ) ) ).

% prod_mset.neutral
tff(fact_4416_is__unit__prod__mset__iff,axiom,
    ! [B: $tType] :
      ( algebraic_semidom(B)
     => ! [A4: multiset(B)] :
          ( dvd_dvd(B,aa(multiset(B),B,comm_m9189036328036947845d_mset(B),A4),one_one(B))
        <=> ! [X4: B] :
              ( member(B,X4,aa(multiset(B),set(B),set_mset(B),A4))
             => dvd_dvd(B,X4,one_one(B)) ) ) ) ).

% is_unit_prod_mset_iff
tff(fact_4417_group__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( group(B,Fa,Z2,Inverse)
    <=> ( semigroup(B,Fa)
        & group_axioms(B,Fa,Z2,Inverse) ) ) ).

% group_def
tff(fact_4418_group_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( semigroup(B,Fa)
     => ( group_axioms(B,Fa,Z2,Inverse)
       => group(B,Fa,Z2,Inverse) ) ) ).

% group.intro
tff(fact_4419_prod__mset_Oeq__fold,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [M: multiset(B)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),M) = aa(multiset(B),B,fold_mset(B,B,times_times(B),one_one(B)),M) ) ) ).

% prod_mset.eq_fold
tff(fact_4420_subset__mset_OInf__fin_Oinsert,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),A4)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4)) ) ) ) ).

% subset_mset.Inf_fin.insert
tff(fact_4421_subset__mset_OInf__fin_Osingleton,axiom,
    ! [B: $tType,X: multiset(B)] : ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B))))) = X ) ).

% subset_mset.Inf_fin.singleton
tff(fact_4422_group__axioms__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( group_axioms(B,Fa,Z2,Inverse)
    <=> ( ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),Fa,Z2),A6) = A6 )
        & ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,Inverse,A6)),A6) = Z2 ) ) ) ).

% group_axioms_def
tff(fact_4423_group__axioms_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( ! [A8: B] : ( aa(B,B,aa(B,fun(B,B),Fa,Z2),A8) = A8 )
     => ( ! [A8: B] : ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,Inverse,A8)),A8) = Z2 )
       => group_axioms(B,Fa,Z2,Inverse) ) ) ).

% group_axioms.intro
tff(fact_4424_subset__mset_OInf__fin_Ounion,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),B2)
         => ( ( B2 != bot_bot(set(multiset(B))) )
           => ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),sup_sup(set(multiset(B))),A4),B2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4)),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),B2)) ) ) ) ) ) ).

% subset_mset.Inf_fin.union
tff(fact_4425_subset__mset_OInf__fin_Osubset,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( B2 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),B2),A4)
         => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),B2)),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4)) = lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4) ) ) ) ) ).

% subset_mset.Inf_fin.subset
tff(fact_4426_subset__mset_OInf__fin_Ohom__commute,axiom,
    ! [B: $tType,H2: fun(multiset(B),multiset(B)),N4: set(multiset(B))] :
      ( ! [X2: multiset(B),Y2: multiset(B)] : ( aa(multiset(B),multiset(B),H2,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X2),Y2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),aa(multiset(B),multiset(B),H2,X2)),aa(multiset(B),multiset(B),H2,Y2)) )
     => ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),N4)
       => ( ( N4 != bot_bot(set(multiset(B))) )
         => ( aa(multiset(B),multiset(B),H2,lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),N4)) = lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),image2(multiset(B),multiset(B),H2),N4)) ) ) ) ) ).

% subset_mset.Inf_fin.hom_commute
tff(fact_4427_group_Oaxioms_I2_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Inverse: fun(B,B)] :
      ( group(B,Fa,Z2,Inverse)
     => group_axioms(B,Fa,Z2,Inverse) ) ).

% group.axioms(2)
tff(fact_4428_subset__mset_OcInf__eq__Inf__fin,axiom,
    ! [B: $tType,X6: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),X6)
     => ( ( X6 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X6) = lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),X6) ) ) ) ).

% subset_mset.cInf_eq_Inf_fin
tff(fact_4429_subset__mset_OInf__fin_Oremove,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( member(multiset(B),X,A4)
       => ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4)
          = $ite(aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A4),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B))))) = bot_bot(set(multiset(B))),X,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A4),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B)))))))) ) ) ) ).

% subset_mset.Inf_fin.remove
tff(fact_4430_subset__mset_OInf__fin_Oinsert__remove,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),A4))
        = $ite(aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A4),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B))))) = bot_bot(set(multiset(B))),X,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A4),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B)))))))) ) ) ).

% subset_mset.Inf_fin.insert_remove
tff(fact_4431_subset__mset_OInf__fin_Oinsert__not__elem,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ~ member(multiset(B),X,A4)
       => ( ( A4 != bot_bot(set(multiset(B))) )
         => ( lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),A4)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4)) ) ) ) ) ).

% subset_mset.Inf_fin.insert_not_elem
tff(fact_4432_subset__mset_OInf__fin_Oclosed,axiom,
    ! [B: $tType,A4: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( ! [X2: multiset(B),Y2: multiset(B)] : member(multiset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X2),Y2),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X2),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),Y2),bot_bot(set(multiset(B))))))
         => member(multiset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4),A4) ) ) ) ).

% subset_mset.Inf_fin.closed
tff(fact_4433_subset__mset_Osup__Inf1__distrib,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4)) = lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_ps(set(multiset(B)),fun(multiset(B),fun(multiset(B),$o)),A4),X))) ) ) ) ).

% subset_mset.sup_Inf1_distrib
tff(fact_4434_subset__mset_Osup__Inf2__distrib,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),B2)
         => ( ( B2 != bot_bot(set(multiset(B))) )
           => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4)),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),B2)) = lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(set(multiset(B)),fun(multiset(B),$o),aTP_Lamp_pt(set(multiset(B)),fun(set(multiset(B)),fun(multiset(B),$o)),A4),B2))) ) ) ) ) ) ).

% subset_mset.sup_Inf2_distrib
tff(fact_4435_subset__mset_OInf__fin_Obounded__iff,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4))
        <=> ! [X4: multiset(B)] :
              ( member(multiset(B),X4,A4)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X),X4) ) ) ) ) ).

% subset_mset.Inf_fin.bounded_iff
tff(fact_4436_subset__mset_OInf__fin_OboundedI,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( ! [A8: multiset(B)] :
              ( member(multiset(B),A8,A4)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X),A8) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4)) ) ) ) ).

% subset_mset.Inf_fin.boundedI
tff(fact_4437_subset__mset_Omonoid__axioms,axiom,
    ! [B: $tType] : monoid(multiset(B),union_mset(B),zero_zero(multiset(B))) ).

% subset_mset.monoid_axioms
tff(fact_4438_subset__mset_Osemilattice__neutr__axioms,axiom,
    ! [B: $tType] : semilattice_neutr(multiset(B),union_mset(B),zero_zero(multiset(B))) ).

% subset_mset.semilattice_neutr_axioms
tff(fact_4439_subset__mset_OcInf__eq__non__empty,axiom,
    ! [B: $tType,X6: set(multiset(B)),A3: multiset(B)] :
      ( ( X6 != bot_bot(set(multiset(B))) )
     => ( ! [X2: multiset(B)] :
            ( member(multiset(B),X2,X6)
           => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A3),X2) )
       => ( ! [Y2: multiset(B)] :
              ( ! [X3: multiset(B)] :
                  ( member(multiset(B),X3,X6)
                 => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Y2),X3) )
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Y2),A3) )
         => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X6) = A3 ) ) ) ) ).

% subset_mset.cInf_eq_non_empty
tff(fact_4440_subset__mset_OcInf__greatest,axiom,
    ! [B: $tType,X6: set(multiset(B)),Z2: multiset(B)] :
      ( ( X6 != bot_bot(set(multiset(B))) )
     => ( ! [X2: multiset(B)] :
            ( member(multiset(B),X2,X6)
           => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Z2),X2) )
       => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Z2),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X6)) ) ) ).

% subset_mset.cInf_greatest
tff(fact_4441_subset__mset_OcSup__least,axiom,
    ! [B: $tType,X6: set(multiset(B)),Z2: multiset(B)] :
      ( ( X6 != bot_bot(set(multiset(B))) )
     => ( ! [X2: multiset(B)] :
            ( member(multiset(B),X2,X6)
           => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X2),Z2) )
       => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),X6)),Z2) ) ) ).

% subset_mset.cSup_least
tff(fact_4442_subset__mset_OcSup__eq__non__empty,axiom,
    ! [B: $tType,X6: set(multiset(B)),A3: multiset(B)] :
      ( ( X6 != bot_bot(set(multiset(B))) )
     => ( ! [X2: multiset(B)] :
            ( member(multiset(B),X2,X6)
           => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X2),A3) )
       => ( ! [Y2: multiset(B)] :
              ( ! [X3: multiset(B)] :
                  ( member(multiset(B),X3,X6)
                 => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X3),Y2) )
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A3),Y2) )
         => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),X6) = A3 ) ) ) ) ).

% subset_mset.cSup_eq_non_empty
tff(fact_4443_subset__mset_Ofinite__has__minimal,axiom,
    ! [B: $tType,A4: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ? [X2: multiset(B)] :
            ( member(multiset(B),X2,A4)
            & ! [Xa3: multiset(B)] :
                ( member(multiset(B),Xa3,A4)
               => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Xa3),X2)
                 => ( X2 = Xa3 ) ) ) ) ) ) ).

% subset_mset.finite_has_minimal
tff(fact_4444_subset__mset_Ofinite__has__maximal,axiom,
    ! [B: $tType,A4: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ? [X2: multiset(B)] :
            ( member(multiset(B),X2,A4)
            & ! [Xa3: multiset(B)] :
                ( member(multiset(B),Xa3,A4)
               => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X2),Xa3)
                 => ( X2 = Xa3 ) ) ) ) ) ) ).

% subset_mset.finite_has_maximal
tff(fact_4445_subset__mset_OcINF__greatest,axiom,
    ! [C: $tType,B: $tType,A4: set(B),M4: multiset(C),Fa: fun(B,multiset(C))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( ! [X2: B] :
            ( member(B,X2,A4)
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),M4),aa(B,multiset(C),Fa,X2)) )
       => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),M4),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))) ) ) ).

% subset_mset.cINF_greatest
tff(fact_4446_subset__mset_OcSUP__least,axiom,
    ! [B: $tType,C: $tType,A4: set(B),Fa: fun(B,multiset(C)),M: multiset(C)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( ! [X2: B] :
            ( member(B,X2,A4)
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),Fa,X2)),M) )
       => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))),M) ) ) ).

% subset_mset.cSUP_least
tff(fact_4447_subset__mset_OInf__fin_Osubset__imp,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),A4),B2)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),B2)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),B2)),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4)) ) ) ) ).

% subset_mset.Inf_fin.subset_imp
tff(fact_4448_subset__mset_OInf__fin_OboundedE,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4))
         => ! [A13: multiset(B)] :
              ( member(multiset(B),A13,A4)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X),A13) ) ) ) ) ).

% subset_mset.Inf_fin.boundedE
tff(fact_4449_subset__mset_OInf__fin__le__Sup__fin,axiom,
    ! [B: $tType,A4: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic8678736583308907530nf_fin(multiset(B),inter_mset(B),A4)),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)) ) ) ).

% subset_mset.Inf_fin_le_Sup_fin
tff(fact_4450_subset__mset_OSup__fin_Oinsert__remove,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),A4))
        = $ite(aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A4),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B))))) = bot_bot(set(multiset(B))),X,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X),lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A4),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B)))))))) ) ) ).

% subset_mset.Sup_fin.insert_remove
tff(fact_4451_subset__mset_OSup__fin_Oremove,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( member(multiset(B),X,A4)
       => ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)
          = $ite(aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A4),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B))))) = bot_bot(set(multiset(B))),X,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X),lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),A4),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B)))))))) ) ) ) ).

% subset_mset.Sup_fin.remove
tff(fact_4452_subset__mset_Oinf__Sup2__distrib,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),B2)
         => ( ( B2 != bot_bot(set(multiset(B))) )
           => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)),lattic4630905495605216202up_fin(multiset(B),union_mset(B),B2)) = lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(set(multiset(B)),fun(multiset(B),$o),aTP_Lamp_pu(set(multiset(B)),fun(set(multiset(B)),fun(multiset(B),$o)),A4),B2))) ) ) ) ) ) ).

% subset_mset.inf_Sup2_distrib
tff(fact_4453_subset__mset_OSup__fin_Osingleton,axiom,
    ! [B: $tType,X: multiset(B)] : ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B))))) = X ) ).

% subset_mset.Sup_fin.singleton
tff(fact_4454_subset__mset_OSup__fin_Oinsert,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),A4)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)) ) ) ) ).

% subset_mset.Sup_fin.insert
tff(fact_4455_subset__mset_OSup__fin_Obounded__iff,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)),X)
        <=> ! [X4: multiset(B)] :
              ( member(multiset(B),X4,A4)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X4),X) ) ) ) ) ).

% subset_mset.Sup_fin.bounded_iff
tff(fact_4456_subset__mset_OSup__fin_OboundedI,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( ! [A8: multiset(B)] :
              ( member(multiset(B),A8,A4)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A8),X) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)),X) ) ) ) ).

% subset_mset.Sup_fin.boundedI
tff(fact_4457_subset__mset_OSup__fin_OboundedE,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)),X)
         => ! [A13: multiset(B)] :
              ( member(multiset(B),A13,A4)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A13),X) ) ) ) ) ).

% subset_mset.Sup_fin.boundedE
tff(fact_4458_subset__mset_OcSup__eq__Sup__fin,axiom,
    ! [B: $tType,X6: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),X6)
     => ( ( X6 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),X6) = lattic4630905495605216202up_fin(multiset(B),union_mset(B),X6) ) ) ) ).

% subset_mset.cSup_eq_Sup_fin
tff(fact_4459_subset__mset_OSup__fin_Oinsert__not__elem,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ~ member(multiset(B),X,A4)
       => ( ( A4 != bot_bot(set(multiset(B))) )
         => ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),A4)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)) ) ) ) ) ).

% subset_mset.Sup_fin.insert_not_elem
tff(fact_4460_subset__mset_OSup__fin_Oclosed,axiom,
    ! [B: $tType,A4: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( ! [X2: multiset(B),Y2: multiset(B)] : member(multiset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X2),Y2),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X2),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),Y2),bot_bot(set(multiset(B))))))
         => member(multiset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4),A4) ) ) ) ).

% subset_mset.Sup_fin.closed
tff(fact_4461_subset__mset_OSup__fin_Osubset,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( B2 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),B2),A4)
         => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),B2)),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)) = lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4) ) ) ) ) ).

% subset_mset.Sup_fin.subset
tff(fact_4462_subset__mset_OSup__fin_Ounion,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),B2)
         => ( ( B2 != bot_bot(set(multiset(B))) )
           => ( lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),sup_sup(set(multiset(B))),A4),B2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)),lattic4630905495605216202up_fin(multiset(B),union_mset(B),B2)) ) ) ) ) ) ).

% subset_mset.Sup_fin.union
tff(fact_4463_subset__mset_OSup__fin_Ohom__commute,axiom,
    ! [B: $tType,H2: fun(multiset(B),multiset(B)),N4: set(multiset(B))] :
      ( ! [X2: multiset(B),Y2: multiset(B)] : ( aa(multiset(B),multiset(B),H2,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),X2),Y2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),aa(multiset(B),multiset(B),H2,X2)),aa(multiset(B),multiset(B),H2,Y2)) )
     => ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),N4)
       => ( ( N4 != bot_bot(set(multiset(B))) )
         => ( aa(multiset(B),multiset(B),H2,lattic4630905495605216202up_fin(multiset(B),union_mset(B),N4)) = lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(set(multiset(B)),set(multiset(B)),image2(multiset(B),multiset(B),H2),N4)) ) ) ) ) ).

% subset_mset.Sup_fin.hom_commute
tff(fact_4464_subset__mset_OSup__fin_Osubset__imp,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),A4),B2)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),B2)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)),lattic4630905495605216202up_fin(multiset(B),union_mset(B),B2)) ) ) ) ).

% subset_mset.Sup_fin.subset_imp
tff(fact_4465_subset__mset_Oinf__Sup1__distrib,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: multiset(B)] :
      ( aa(set(multiset(B)),$o,finite_finite(multiset(B)),A4)
     => ( ( A4 != bot_bot(set(multiset(B))) )
       => ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),X),lattic4630905495605216202up_fin(multiset(B),union_mset(B),A4)) = lattic4630905495605216202up_fin(multiset(B),union_mset(B),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_pv(set(multiset(B)),fun(multiset(B),fun(multiset(B),$o)),A4),X))) ) ) ) ).

% subset_mset.inf_Sup1_distrib
tff(fact_4466_subset__mset_Omono__sup,axiom,
    ! [C: $tType,B: $tType] :
      ( semilattice_sup(C)
     => ! [Fa: fun(multiset(B),C),A4: multiset(B),B2: multiset(B)] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),Fa)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(multiset(B),C,Fa,A4)),aa(multiset(B),C,Fa,B2))),aa(multiset(B),C,Fa,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A4),B2))) ) ) ).

% subset_mset.mono_sup
tff(fact_4467_subset__mset_Omono__inf,axiom,
    ! [C: $tType,B: $tType] :
      ( semilattice_inf(C)
     => ! [Fa: fun(multiset(B),C),A4: multiset(B),B2: multiset(B)] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),Fa)
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(multiset(B),C,Fa,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A4),B2))),aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(multiset(B),C,Fa,A4)),aa(multiset(B),C,Fa,B2))) ) ) ).

% subset_mset.mono_inf
tff(fact_4468_subset__mset_OcINF__union,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,multiset(C)),B2: set(B)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))
       => ( ( B2 != bot_bot(set(B)) )
         => ( condit8119078960628432327_below(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),B2))
           => ( aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),inter_mset(C),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),B2))) ) ) ) ) ) ).

% subset_mset.cINF_union
tff(fact_4469_subset__mset_OcINF__insert,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,multiset(C)),A3: B] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))
       => ( aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),aa(set(B),set(B),insert2(B,A3),A4))) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),inter_mset(C),aa(B,multiset(C),Fa,A3)),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))) ) ) ) ).

% subset_mset.cINF_insert
tff(fact_4470_subset__mset_Obdd__below__empty,axiom,
    ! [B: $tType] : condit8119078960628432327_below(multiset(B),subseteq_mset(B),bot_bot(set(multiset(B)))) ).

% subset_mset.bdd_below_empty
tff(fact_4471_order_Omono_Ocong,axiom,
    ! [C: $tType,B: $tType] :
      ( order(C)
     => ! [Less_eq: fun(B,fun(B,$o))] : ( mono(B,C,Less_eq) = mono(B,C,Less_eq) ) ) ).

% order.mono.cong
tff(fact_4472_subset__mset_Obdd__below__Int2,axiom,
    ! [B: $tType,B2: set(multiset(B)),A4: set(multiset(B))] :
      ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),B2)
     => condit8119078960628432327_below(multiset(B),subseteq_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A4),B2)) ) ).

% subset_mset.bdd_below_Int2
tff(fact_4473_subset__mset_Obdd__below__Int1,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),A4)
     => condit8119078960628432327_below(multiset(B),subseteq_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A4),B2)) ) ).

% subset_mset.bdd_below_Int1
tff(fact_4474_subset__mset_OcInf__mono,axiom,
    ! [B: $tType,B2: set(multiset(B)),A4: set(multiset(B))] :
      ( ( B2 != bot_bot(set(multiset(B))) )
     => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),A4)
       => ( ! [B4: multiset(B)] :
              ( member(multiset(B),B4,B2)
             => ? [X3: multiset(B)] :
                  ( member(multiset(B),X3,A4)
                  & aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X3),B4) ) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A4)),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),B2)) ) ) ) ).

% subset_mset.cInf_mono
tff(fact_4475_subset__mset_Ole__cInf__iff,axiom,
    ! [B: $tType,S2: set(multiset(B)),A3: multiset(B)] :
      ( ( S2 != bot_bot(set(multiset(B))) )
     => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),S2)
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A3),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),S2))
        <=> ! [X4: multiset(B)] :
              ( member(multiset(B),X4,S2)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A3),X4) ) ) ) ) ).

% subset_mset.le_cInf_iff
tff(fact_4476_subset__mset_Omono__cInf,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Fa: fun(multiset(B),C),A4: set(multiset(B))] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),Fa)
         => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),A4)
           => ( ( A4 != bot_bot(set(multiset(B))) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(multiset(B),C,Fa,aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A4))),aa(set(C),C,complete_Inf_Inf(C),aa(set(multiset(B)),set(C),image2(multiset(B),C,Fa),A4))) ) ) ) ) ).

% subset_mset.mono_cInf
tff(fact_4477_subset__mset_Ole__cINF__iff,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,multiset(C)),U: multiset(C)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))
       => ( aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),U),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4)))
        <=> ! [X4: B] :
              ( member(B,X4,A4)
             => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),U),aa(B,multiset(C),Fa,X4)) ) ) ) ) ).

% subset_mset.le_cINF_iff
tff(fact_4478_subset__mset_OcINF__mono,axiom,
    ! [D: $tType,C: $tType,B: $tType,B2: set(B),Fa: fun(D,multiset(C)),A4: set(D),Ga: fun(B,multiset(C))] :
      ( ( B2 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(C),subseteq_mset(C),aa(set(D),set(multiset(C)),image2(D,multiset(C),Fa),A4))
       => ( ! [M5: B] :
              ( member(B,M5,B2)
             => ? [X3: D] :
                  ( member(D,X3,A4)
                  & aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(D,multiset(C),Fa,X3)),aa(B,multiset(C),Ga,M5)) ) )
         => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(D),set(multiset(C)),image2(D,multiset(C),Fa),A4))),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Ga),B2))) ) ) ) ).

% subset_mset.cINF_mono
tff(fact_4479_subset__mset_Oless__eq__cInf__inter,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),A4)
     => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),B2)
       => ( ( aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A4),B2) != bot_bot(set(multiset(B))) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A4)),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),B2))),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A4),B2))) ) ) ) ).

% subset_mset.less_eq_cInf_inter
tff(fact_4480_subset__mset_Omono__cINF,axiom,
    ! [B: $tType,C: $tType,D: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Fa: fun(multiset(B),C),A4: fun(D,multiset(B)),I4: set(D)] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),Fa)
         => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),aa(set(D),set(multiset(B)),image2(D,multiset(B),A4),I4))
           => ( ( I4 != bot_bot(set(D)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(multiset(B),C,Fa,aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(D),set(multiset(B)),image2(D,multiset(B),A4),I4)))),aa(set(C),C,complete_Inf_Inf(C),aa(set(D),set(C),image2(D,C,aa(fun(D,multiset(B)),fun(D,C),aTP_Lamp_pw(fun(multiset(B),C),fun(fun(D,multiset(B)),fun(D,C)),Fa),A4)),I4))) ) ) ) ) ).

% subset_mset.mono_cINF
tff(fact_4481_subset__mset_OcInf__superset__mono,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),B2)
       => ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),A4),B2)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),B2)),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A4)) ) ) ) ).

% subset_mset.cInf_superset_mono
tff(fact_4482_subset__mset_OcInf__cSup,axiom,
    ! [B: $tType,S2: set(multiset(B))] :
      ( ( S2 != bot_bot(set(multiset(B))) )
     => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),S2)
       => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),S2) = aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aTP_Lamp_px(set(multiset(B)),fun(multiset(B),$o),S2))) ) ) ) ).

% subset_mset.cInf_cSup
tff(fact_4483_subset__mset_OcINF__superset__mono,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Ga: fun(B,multiset(C)),B2: set(B),Fa: fun(B,multiset(C))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Ga),B2))
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
         => ( ! [X2: B] :
                ( member(B,X2,B2)
               => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),Ga,X2)),aa(B,multiset(C),Fa,X2)) )
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Ga),B2))),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))) ) ) ) ) ).

% subset_mset.cINF_superset_mono
tff(fact_4484_subset__mset_OcInf__insert__If,axiom,
    ! [B: $tType,X6: set(multiset(B)),A3: multiset(B)] :
      ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),X6)
     => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),A3),X6))
        = $ite(X6 = bot_bot(set(multiset(B))),A3,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A3),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X6))) ) ) ).

% subset_mset.cInf_insert_If
tff(fact_4485_subset__mset_OcInf__insert,axiom,
    ! [B: $tType,X6: set(multiset(B)),A3: multiset(B)] :
      ( ( X6 != bot_bot(set(multiset(B))) )
     => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),X6)
       => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),A3),X6)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A3),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X6)) ) ) ) ).

% subset_mset.cInf_insert
tff(fact_4486_subset__mset_OcINF__inf__distrib,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,multiset(C)),Ga: fun(B,multiset(C))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8119078960628432327_below(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))
       => ( condit8119078960628432327_below(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Ga),A4))
         => ( aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),inter_mset(C),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))),aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Ga),A4))) = aa(set(multiset(C)),multiset(C),complete_Inf_Inf(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),aa(fun(B,multiset(C)),fun(B,multiset(C)),aTP_Lamp_py(fun(B,multiset(C)),fun(fun(B,multiset(C)),fun(B,multiset(C))),Fa),Ga)),A4)) ) ) ) ) ).

% subset_mset.cINF_inf_distrib
tff(fact_4487_subset__mset_OcInf__union__distrib,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),A4)
       => ( ( B2 != bot_bot(set(multiset(B))) )
         => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),B2)
           => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),sup_sup(set(multiset(B))),A4),B2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A4)),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),B2)) ) ) ) ) ) ).

% subset_mset.cInf_union_distrib
tff(fact_4488_subset__mset_Omono__cSUP,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Fa: fun(multiset(B),C),A4: fun(D,multiset(B)),I4: set(D)] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),Fa)
         => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),aa(set(D),set(multiset(B)),image2(D,multiset(B),A4),I4))
           => ( ( I4 != bot_bot(set(D)) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(D),set(C),image2(D,C,aa(fun(D,multiset(B)),fun(D,C),aTP_Lamp_pw(fun(multiset(B),C),fun(fun(D,multiset(B)),fun(D,C)),Fa),A4)),I4))),aa(multiset(B),C,Fa,aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(D),set(multiset(B)),image2(D,multiset(B),A4),I4)))) ) ) ) ) ).

% subset_mset.mono_cSUP
tff(fact_4489_subset__mset_Omono__cSup,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Fa: fun(multiset(B),C),A4: set(multiset(B))] :
          ( aa(fun(multiset(B),C),$o,mono(multiset(B),C,subseteq_mset(B)),Fa)
         => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A4)
           => ( ( A4 != bot_bot(set(multiset(B))) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(multiset(B)),set(C),image2(multiset(B),C,Fa),A4))),aa(multiset(B),C,Fa,aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A4))) ) ) ) ) ).

% subset_mset.mono_cSup
tff(fact_4490_subset__mset_OcSUP__union,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,multiset(C)),B2: set(B)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))
       => ( ( B2 != bot_bot(set(B)) )
         => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),B2))
           => ( aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),A4),B2))) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),union_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),B2))) ) ) ) ) ) ).

% subset_mset.cSUP_union
tff(fact_4491_subset__mset_OcSUP__insert,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,multiset(C)),A3: B] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))
       => ( aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),aa(set(B),set(B),insert2(B,A3),A4))) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),union_mset(C),aa(B,multiset(C),Fa,A3)),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))) ) ) ) ).

% subset_mset.cSUP_insert
tff(fact_4492_subset__mset_Obdd__above__empty,axiom,
    ! [B: $tType] : condit8047198070973881523_above(multiset(B),subseteq_mset(B),bot_bot(set(multiset(B)))) ).

% subset_mset.bdd_above_empty
tff(fact_4493_subset__mset_Obdd__above__Int1,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A4)
     => condit8047198070973881523_above(multiset(B),subseteq_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A4),B2)) ) ).

% subset_mset.bdd_above_Int1
tff(fact_4494_subset__mset_Obdd__above__Int2,axiom,
    ! [B: $tType,B2: set(multiset(B)),A4: set(multiset(B))] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),B2)
     => condit8047198070973881523_above(multiset(B),subseteq_mset(B),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A4),B2)) ) ).

% subset_mset.bdd_above_Int2
tff(fact_4495_subset__mset_OcSup__le__iff,axiom,
    ! [B: $tType,S2: set(multiset(B)),A3: multiset(B)] :
      ( ( S2 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),S2)
       => ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),S2)),A3)
        <=> ! [X4: multiset(B)] :
              ( member(multiset(B),X4,S2)
             => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X4),A3) ) ) ) ) ).

% subset_mset.cSup_le_iff
tff(fact_4496_subset__mset_OcSup__mono,axiom,
    ! [B: $tType,B2: set(multiset(B)),A4: set(multiset(B))] :
      ( ( B2 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A4)
       => ( ! [B4: multiset(B)] :
              ( member(multiset(B),B4,B2)
             => ? [X3: multiset(B)] :
                  ( member(multiset(B),X3,A4)
                  & aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),B4),X3) ) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),B2)),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A4)) ) ) ) ).

% subset_mset.cSup_mono
tff(fact_4497_subset__mset_OcSUP__mono,axiom,
    ! [B: $tType,C: $tType,D: $tType,A4: set(B),Ga: fun(D,multiset(C)),B2: set(D),Fa: fun(B,multiset(C))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(D),set(multiset(C)),image2(D,multiset(C),Ga),B2))
       => ( ! [N3: B] :
              ( member(B,N3,A4)
             => ? [X3: D] :
                  ( member(D,X3,B2)
                  & aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),Fa,N3)),aa(D,multiset(C),Ga,X3)) ) )
         => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(D),set(multiset(C)),image2(D,multiset(C),Ga),B2))) ) ) ) ).

% subset_mset.cSUP_mono
tff(fact_4498_subset__mset_OcSUP__le__iff,axiom,
    ! [B: $tType,C: $tType,A4: set(B),Fa: fun(B,multiset(C)),U: multiset(C)] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))
       => ( aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))),U)
        <=> ! [X4: B] :
              ( member(B,X4,A4)
             => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),Fa,X4)),U) ) ) ) ) ).

% subset_mset.cSUP_le_iff
tff(fact_4499_subset__mset_OcSup__inter__less__eq,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A4)
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),B2)
       => ( ( aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A4),B2) != bot_bot(set(multiset(B))) )
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),A4),B2))),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A4)),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),B2))) ) ) ) ).

% subset_mset.cSup_inter_less_eq
tff(fact_4500_subset__mset_OcSup__subset__mono,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),B2)
       => ( aa(set(multiset(B)),$o,aa(set(multiset(B)),fun(set(multiset(B)),$o),ord_less_eq(set(multiset(B))),A4),B2)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A4)),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),B2)) ) ) ) ).

% subset_mset.cSup_subset_mono
tff(fact_4501_subset__mset_OcSup__cInf,axiom,
    ! [B: $tType,S2: set(multiset(B))] :
      ( ( S2 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),S2)
       => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),S2) = aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(fun(multiset(B),$o),set(multiset(B)),collect(multiset(B)),aTP_Lamp_pz(set(multiset(B)),fun(multiset(B),$o),S2))) ) ) ) ).

% subset_mset.cSup_cInf
tff(fact_4502_subset__mset_OcSUP__subset__mono,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Ga: fun(B,multiset(C)),B2: set(B),Fa: fun(B,multiset(C))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Ga),B2))
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),B2)
         => ( ! [X2: B] :
                ( member(B,X2,A4)
               => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(B,multiset(C),Fa,X2)),aa(B,multiset(C),Ga,X2)) )
           => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subseteq_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Ga),B2))) ) ) ) ) ).

% subset_mset.cSUP_subset_mono
tff(fact_4503_subset__mset_OcSup__insert,axiom,
    ! [B: $tType,X6: set(multiset(B)),A3: multiset(B)] :
      ( ( X6 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),X6)
       => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),A3),X6)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A3),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),X6)) ) ) ) ).

% subset_mset.cSup_insert
tff(fact_4504_subset__mset_OcSup__insert__If,axiom,
    ! [B: $tType,X6: set(multiset(B)),A3: multiset(B)] :
      ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),X6)
     => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),A3),X6))
        = $ite(X6 = bot_bot(set(multiset(B))),A3,aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A3),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),X6))) ) ) ).

% subset_mset.cSup_insert_If
tff(fact_4505_subset__mset_OcInf__le__cSup,axiom,
    ! [B: $tType,A4: set(multiset(B))] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A4)
       => ( condit8119078960628432327_below(multiset(B),subseteq_mset(B),A4)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A4)),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A4)) ) ) ) ).

% subset_mset.cInf_le_cSup
tff(fact_4506_subset__mset_OSUP__sup__distrib,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,multiset(C)),Ga: fun(B,multiset(C))] :
      ( ( A4 != bot_bot(set(B)) )
     => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))
       => ( condit8047198070973881523_above(multiset(C),subseteq_mset(C),aa(set(B),set(multiset(C)),image2(B,multiset(C),Ga),A4))
         => ( aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),union_mset(C),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Fa),A4))),aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),Ga),A4))) = aa(set(multiset(C)),multiset(C),complete_Sup_Sup(multiset(C)),aa(set(B),set(multiset(C)),image2(B,multiset(C),aa(fun(B,multiset(C)),fun(B,multiset(C)),aTP_Lamp_qa(fun(B,multiset(C)),fun(fun(B,multiset(C)),fun(B,multiset(C))),Fa),Ga)),A4)) ) ) ) ) ).

% subset_mset.SUP_sup_distrib
tff(fact_4507_subset__mset_OcSup__union__distrib,axiom,
    ! [B: $tType,A4: set(multiset(B)),B2: set(multiset(B))] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A4)
       => ( ( B2 != bot_bot(set(multiset(B))) )
         => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),B2)
           => ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),sup_sup(set(multiset(B))),A4),B2)) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A4)),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),B2)) ) ) ) ) ) ).

% subset_mset.cSup_union_distrib
tff(fact_4508_bdd__above__multiset__imp__finite__support,axiom,
    ! [B: $tType,A4: set(multiset(B))] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A4)
       => aa(set(B),$o,finite_finite(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(multiset(B)),set(set(B)),image2(multiset(B),set(B),aTP_Lamp_qc(multiset(B),set(B))),A4))) ) ) ).

% bdd_above_multiset_imp_finite_support
tff(fact_4509_Sup__multiset__in__multiset,axiom,
    ! [B: $tType,A4: set(multiset(B))] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A4)
       => aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_qe(set(multiset(B)),fun(B,$o),A4))) ) ) ).

% Sup_multiset_in_multiset
tff(fact_4510_count__Sup__multiset__nonempty,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: B] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( condit8047198070973881523_above(multiset(B),subseteq_mset(B),A4)
       => ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A4)),X) = aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(B)),set(nat),image2(multiset(B),nat,aTP_Lamp_qd(B,fun(multiset(B),nat),X)),A4)) ) ) ) ).

% count_Sup_multiset_nonempty
tff(fact_4511_subset__mset_OatLeastAtMost__singleton__iff,axiom,
    ! [B: $tType,A3: multiset(B),Ba: multiset(B),C2: multiset(B)] :
      ( ( set_atLeastAtMost(multiset(B),subseteq_mset(B),A3,Ba) = aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),C2),bot_bot(set(multiset(B)))) )
    <=> ( ( A3 = Ba )
        & ( Ba = C2 ) ) ) ).

% subset_mset.atLeastAtMost_singleton_iff
tff(fact_4512_subset__mset_OatLeastatMost__empty__iff,axiom,
    ! [B: $tType,A3: multiset(B),Ba: multiset(B)] :
      ( ( set_atLeastAtMost(multiset(B),subseteq_mset(B),A3,Ba) = bot_bot(set(multiset(B))) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A3),Ba) ) ).

% subset_mset.atLeastatMost_empty_iff
tff(fact_4513_subset__mset_OatLeastatMost__empty__iff2,axiom,
    ! [B: $tType,A3: multiset(B),Ba: multiset(B)] :
      ( ( bot_bot(set(multiset(B))) = set_atLeastAtMost(multiset(B),subseteq_mset(B),A3,Ba) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),A3),Ba) ) ).

% subset_mset.atLeastatMost_empty_iff2
tff(fact_4514_subset__mset_OatLeastAtMost__singleton,axiom,
    ! [B: $tType,A3: multiset(B)] : ( set_atLeastAtMost(multiset(B),subseteq_mset(B),A3,A3) = aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),A3),bot_bot(set(multiset(B)))) ) ).

% subset_mset.atLeastAtMost_singleton
tff(fact_4515_Inf__multiset_Orep__eq,axiom,
    ! [B: $tType,X: set(multiset(B)),X3: B] :
      ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),X)),X3)
      = $ite(aa(set(multiset(B)),set(fun(B,nat)),image2(multiset(B),fun(B,nat),count(B)),X) = bot_bot(set(fun(B,nat))),zero_zero(nat),aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(fun(B,nat)),set(nat),image2(fun(B,nat),nat,aTP_Lamp_qf(B,fun(fun(B,nat),nat),X3)),aa(set(multiset(B)),set(fun(B,nat)),image2(multiset(B),fun(B,nat),count(B)),X)))) ) ).

% Inf_multiset.rep_eq
tff(fact_4516_count__Inf__multiset__nonempty,axiom,
    ! [B: $tType,A4: set(multiset(B)),X: B] :
      ( ( A4 != bot_bot(set(multiset(B))) )
     => ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),A4)),X) = aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(multiset(B)),set(nat),image2(multiset(B),nat,aTP_Lamp_qd(B,fun(multiset(B),nat),X)),A4)) ) ) ).

% count_Inf_multiset_nonempty
tff(fact_4517_subset__mset_OatLeastAtMost__singleton_H,axiom,
    ! [B: $tType,A3: multiset(B),Ba: multiset(B)] :
      ( ( A3 = Ba )
     => ( set_atLeastAtMost(multiset(B),subseteq_mset(B),A3,Ba) = aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),A3),bot_bot(set(multiset(B)))) ) ) ).

% subset_mset.atLeastAtMost_singleton'
tff(fact_4518_Sup__multiset__def,axiom,
    ! [B: $tType,A4: set(multiset(B))] :
      ( aa(set(multiset(B)),multiset(B),complete_Sup_Sup(multiset(B)),A4)
      = $ite(
          ( ( A4 != bot_bot(set(multiset(B))) )
          & condit8047198070973881523_above(multiset(B),subseteq_mset(B),A4) ),
          aa(fun(B,nat),multiset(B),abs_multiset(B),aTP_Lamp_qg(set(multiset(B)),fun(B,nat),A4)),
          zero_zero(multiset(B)) ) ) ).

% Sup_multiset_def
tff(fact_4519_count__image__mset,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),A4: multiset(C),X: B] : ( aa(B,nat,aa(multiset(B),fun(B,nat),count(B),aa(multiset(C),multiset(B),image_mset(C,B,Fa),A4)),X) = aa(set(C),nat,aa(fun(C,nat),fun(set(C),nat),groups7311177749621191930dd_sum(C,nat),aa(multiset(C),fun(C,nat),count(C),A4)),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(set(B),set(C),aa(fun(C,B),fun(set(B),set(C)),vimage(C,B),Fa),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))),aa(multiset(C),set(C),set_mset(C),A4))) ) ).

% count_image_mset
tff(fact_4520_Inf__multiset__def,axiom,
    ! [B: $tType] : ( complete_Inf_Inf(multiset(B)) = aa(fun(set(fun(B,nat)),fun(B,nat)),fun(set(multiset(B)),multiset(B)),map_fun(set(multiset(B)),set(fun(B,nat)),fun(B,nat),multiset(B),image2(multiset(B),fun(B,nat),count(B)),abs_multiset(B)),aTP_Lamp_qh(set(fun(B,nat)),fun(B,nat))) ) ).

% Inf_multiset_def
tff(fact_4521_prod__mset_Ounion__disjoint,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [A4: multiset(B),B2: multiset(B),Ga: fun(B,C)] :
          ( ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A4),B2) = zero_zero(multiset(B)) )
         => ( aa(multiset(C),C,comm_m9189036328036947845d_mset(C),aa(multiset(B),multiset(C),image_mset(B,C,Ga),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A4),B2))) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(multiset(C),C,comm_m9189036328036947845d_mset(C),aa(multiset(B),multiset(C),image_mset(B,C,Ga),A4))),aa(multiset(C),C,comm_m9189036328036947845d_mset(C),aa(multiset(B),multiset(C),image_mset(B,C,Ga),B2))) ) ) ) ).

% prod_mset.union_disjoint
tff(fact_4522_prod__mset_Oneutral__const,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A4: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aTP_Lamp_ak(C,B)),A4)) = one_one(B) ) ) ).

% prod_mset.neutral_const
tff(fact_4523_prod__mset_Oinsert,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(C,B),X: C,A4: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,Ga),aa(multiset(C),multiset(C),aa(C,fun(multiset(C),multiset(C)),add_mset(C),X),A4))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Ga,X)),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,Ga),A4))) ) ) ).

% prod_mset.insert
tff(fact_4524_multiset_Omap__comp,axiom,
    ! [C: $tType,B: $tType,D: $tType,Ga: fun(C,B),Fa: fun(D,C),V: multiset(D)] : ( aa(multiset(C),multiset(B),image_mset(C,B,Ga),aa(multiset(D),multiset(C),image_mset(D,C,Fa),V)) = aa(multiset(D),multiset(B),image_mset(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Ga),Fa)),V) ) ).

% multiset.map_comp
tff(fact_4525_image__mset_Ocompositionality,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(C,B),Ga: fun(D,C),Multiset: multiset(D)] : ( aa(multiset(C),multiset(B),image_mset(C,B,Fa),aa(multiset(D),multiset(C),image_mset(D,C,Ga),Multiset)) = aa(multiset(D),multiset(B),image_mset(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Fa),Ga)),Multiset) ) ).

% image_mset.compositionality
tff(fact_4526_prod__mset_Odistrib,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Ga: fun(C,B),H2: fun(C,B),A4: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_bb(fun(C,B),fun(fun(C,B),fun(C,B)),Ga),H2)),A4)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,Ga),A4))),aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,H2),A4))) ) ) ).

% prod_mset.distrib
tff(fact_4527_image__mset_Ocomp,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(D,C),Ga: fun(B,D)] : ( aa(fun(multiset(B),multiset(D)),fun(multiset(B),multiset(C)),aa(fun(multiset(D),multiset(C)),fun(fun(multiset(B),multiset(D)),fun(multiset(B),multiset(C))),comp(multiset(D),multiset(C),multiset(B)),image_mset(D,C,Fa)),image_mset(B,D,Ga)) = image_mset(B,C,aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),Ga)) ) ).

% image_mset.comp
tff(fact_4528_image__mset__cong__pair,axiom,
    ! [D: $tType,C: $tType,B: $tType,M: multiset(product_prod(B,C)),Fa: fun(B,fun(C,D)),Ga: fun(B,fun(C,D))] :
      ( ! [X2: B,Y2: C] :
          ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2),aa(multiset(product_prod(B,C)),set(product_prod(B,C)),set_mset(product_prod(B,C)),M))
         => ( aa(C,D,aa(B,fun(C,D),Fa,X2),Y2) = aa(C,D,aa(B,fun(C,D),Ga,X2),Y2) ) )
     => ( aa(multiset(product_prod(B,C)),multiset(D),image_mset(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),Fa)),M) = aa(multiset(product_prod(B,C)),multiset(D),image_mset(product_prod(B,C),D,aa(fun(B,fun(C,D)),fun(product_prod(B,C),D),product_case_prod(B,C,D),Ga)),M) ) ) ).

% image_mset_cong_pair
tff(fact_4529_image__mset__def,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C)] : ( image_mset(B,C,Fa) = fold_mset(B,multiset(C),aa(fun(B,C),fun(B,fun(multiset(C),multiset(C))),aa(fun(C,fun(multiset(C),multiset(C))),fun(fun(B,C),fun(B,fun(multiset(C),multiset(C)))),comp(C,fun(multiset(C),multiset(C)),B),add_mset(C)),Fa),zero_zero(multiset(C))) ) ).

% image_mset_def
tff(fact_4530_prod__mset__delta_H,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Y: C,C2: B,A4: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_qi(C,fun(B,fun(C,B)),Y),C2)),A4)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),C2),aa(C,nat,aa(multiset(C),fun(C,nat),count(C),A4),Y)) ) ) ).

% prod_mset_delta'
tff(fact_4531_prod__mset__delta,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Y: C,C2: B,A4: multiset(C)] : ( aa(multiset(B),B,comm_m9189036328036947845d_mset(B),aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_qj(C,fun(B,fun(C,B)),Y),C2)),A4)) = aa(nat,B,aa(B,fun(nat,B),power_power(B),C2),aa(C,nat,aa(multiset(C),fun(C,nat),count(C),A4),Y)) ) ) ).

% prod_mset_delta
tff(fact_4532_sum__mset__delta,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_1(B)
     => ! [Y: C,C2: B,A4: multiset(C)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_qk(C,fun(B,fun(C,B)),Y),C2)),A4)) = aa(B,B,aa(B,fun(B,B),times_times(B),C2),aa(nat,B,semiring_1_of_nat(B),aa(C,nat,aa(multiset(C),fun(C,nat),count(C),A4),Y))) ) ) ).

% sum_mset_delta
tff(fact_4533_sum__mset__delta_H,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_1(B)
     => ! [Y: C,C2: B,A4: multiset(C)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_ql(C,fun(B,fun(C,B)),Y),C2)),A4)) = aa(B,B,aa(B,fun(B,B),times_times(B),C2),aa(nat,B,semiring_1_of_nat(B),aa(C,nat,aa(multiset(C),fun(C,nat),count(C),A4),Y))) ) ) ).

% sum_mset_delta'
tff(fact_4534_inv__o__cancel,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] :
      ( inj_on(B,C,Fa,top_top(set(B)))
     => ( aa(fun(B,C),fun(B,B),aa(fun(C,B),fun(fun(B,C),fun(B,B)),comp(C,B,B),hilbert_inv_into(B,C,top_top(set(B)),Fa)),Fa) = id(B) ) ) ).

% inv_o_cancel
tff(fact_4535_prod__filter__INF,axiom,
    ! [C: $tType,E: $tType,D: $tType,B: $tType,I4: set(B),J4: set(C),A4: fun(B,filter(D)),B2: fun(C,filter(E))] :
      ( ( I4 != bot_bot(set(B)) )
     => ( ( J4 != bot_bot(set(C)) )
       => ( prod_filter(D,E,aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(B),set(filter(D)),image2(B,filter(D),A4),I4)),aa(set(filter(E)),filter(E),complete_Inf_Inf(filter(E)),aa(set(C),set(filter(E)),image2(C,filter(E),B2),J4))) = aa(set(filter(product_prod(D,E))),filter(product_prod(D,E)),complete_Inf_Inf(filter(product_prod(D,E))),aa(set(B),set(filter(product_prod(D,E))),image2(B,filter(product_prod(D,E)),aa(fun(C,filter(E)),fun(B,filter(product_prod(D,E))),aa(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,filter(product_prod(D,E)))),aTP_Lamp_qn(set(C),fun(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,filter(product_prod(D,E))))),J4),A4),B2)),I4)) ) ) ) ).

% prod_filter_INF
tff(fact_4536_o__inv__o__cancel,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(B,C),Ga: fun(B,D)] :
      ( inj_on(B,C,Fa,top_top(set(B)))
     => ( aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),Ga),hilbert_inv_into(B,C,top_top(set(B)),Fa))),Fa) = Ga ) ) ).

% o_inv_o_cancel
tff(fact_4537_sum__mset__replicate__mset,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat,A3: B] : ( comm_m7189776963980413722m_mset(B,replicate_mset(B,N,A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),A3) ) ) ).

% sum_mset_replicate_mset
tff(fact_4538_prod__filter__eq__bot,axiom,
    ! [B: $tType,C: $tType,A4: filter(B),B2: filter(C)] :
      ( ( prod_filter(B,C,A4,B2) = bot_bot(filter(product_prod(B,C))) )
    <=> ( ( A4 = bot_bot(filter(B)) )
        | ( B2 = bot_bot(filter(C)) ) ) ) ).

% prod_filter_eq_bot
tff(fact_4539_eventually__prod__same,axiom,
    ! [B: $tType,Pa: fun(product_prod(B,B),$o),F: filter(B)] :
      ( eventually(product_prod(B,B),Pa,prod_filter(B,B,F,F))
    <=> ? [Q7: fun(B,$o)] :
          ( eventually(B,Q7,F)
          & ! [X4: B,Y3: B] :
              ( aa(B,$o,Q7,X4)
             => ( aa(B,$o,Q7,Y3)
               => aa(product_prod(B,B),$o,Pa,aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Y3)) ) ) ) ) ).

% eventually_prod_same
tff(fact_4540_eventually__prod__filter,axiom,
    ! [B: $tType,C: $tType,Pa: fun(product_prod(B,C),$o),F: filter(B),G5: filter(C)] :
      ( eventually(product_prod(B,C),Pa,prod_filter(B,C,F,G5))
    <=> ? [Pf: fun(B,$o),Pg: fun(C,$o)] :
          ( eventually(B,Pf,F)
          & eventually(C,Pg,G5)
          & ! [X4: B,Y3: C] :
              ( aa(B,$o,Pf,X4)
             => ( aa(C,$o,Pg,Y3)
               => aa(product_prod(B,C),$o,Pa,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Y3)) ) ) ) ) ).

% eventually_prod_filter
tff(fact_4541_sum__mset__product,axiom,
    ! [D: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add(C)
        & times(C)
        & semiring_0(B) )
     => ! [Fa: fun(C,B),A4: multiset(C),Ga: fun(D,B),B2: multiset(D)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,Fa),A4))),comm_m7189776963980413722m_mset(B,aa(multiset(D),multiset(B),image_mset(D,B,Ga),B2))) = comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(multiset(D),fun(C,B),aa(fun(D,B),fun(multiset(D),fun(C,B)),aTP_Lamp_qp(fun(C,B),fun(fun(D,B),fun(multiset(D),fun(C,B))),Fa),Ga),B2)),A4)) ) ) ).

% sum_mset_product
tff(fact_4542_sum__mset__distrib__right,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Fa: fun(C,B),M: multiset(C),C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,Fa),M))),C2) = comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(B,fun(C,B),aTP_Lamp_bc(fun(C,B),fun(B,fun(C,B)),Fa),C2)),M)) ) ) ).

% sum_mset_distrib_right
tff(fact_4543_sum__mset__distrib__left,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [C2: B,Fa: fun(C,B),M: multiset(C)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),C2),comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,Fa),M))) = comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_bd(B,fun(fun(C,B),fun(C,B)),C2),Fa)),M)) ) ) ).

% sum_mset_distrib_left
tff(fact_4544_inv__into__comp,axiom,
    ! [B: $tType,D: $tType,C: $tType,Fa: fun(B,C),Ga: fun(D,B),A4: set(D),X: C] :
      ( inj_on(B,C,Fa,aa(set(D),set(B),image2(D,B,Ga),A4))
     => ( inj_on(D,B,Ga,A4)
       => ( member(C,X,aa(set(B),set(C),image2(B,C,Fa),aa(set(D),set(B),image2(D,B,Ga),A4)))
         => ( aa(C,D,hilbert_inv_into(D,C,A4,aa(fun(D,B),fun(D,C),aa(fun(B,C),fun(fun(D,B),fun(D,C)),comp(B,C,D),Fa),Ga)),X) = aa(C,D,aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),hilbert_inv_into(D,B,A4,Ga)),hilbert_inv_into(B,C,aa(set(D),set(B),image2(D,B,Ga),A4),Fa)),X) ) ) ) ) ).

% inv_into_comp
tff(fact_4545_inv__unique__comp,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,B),Ga: fun(B,C)] :
      ( ( aa(fun(B,C),fun(B,B),aa(fun(C,B),fun(fun(B,C),fun(B,B)),comp(C,B,B),Fa),Ga) = id(B) )
     => ( ( aa(fun(C,B),fun(C,C),aa(fun(B,C),fun(fun(C,B),fun(C,C)),comp(B,C,C),Ga),Fa) = id(C) )
       => ( hilbert_inv_into(C,B,top_top(set(C)),Fa) = Ga ) ) ) ).

% inv_unique_comp
tff(fact_4546_o__inv__distrib,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,C),Ga: fun(D,B)] :
      ( bij_betw(B,C,Fa,top_top(set(B)),top_top(set(C)))
     => ( bij_betw(D,B,Ga,top_top(set(D)),top_top(set(B)))
       => ( hilbert_inv_into(D,C,top_top(set(D)),aa(fun(D,B),fun(D,C),aa(fun(B,C),fun(fun(D,B),fun(D,C)),comp(B,C,D),Fa),Ga)) = aa(fun(C,B),fun(C,D),aa(fun(B,D),fun(fun(C,B),fun(C,D)),comp(B,D,C),hilbert_inv_into(D,B,top_top(set(D)),Ga)),hilbert_inv_into(B,C,top_top(set(B)),Fa)) ) ) ) ).

% o_inv_distrib
tff(fact_4547_prod__filter__mono__iff,axiom,
    ! [B: $tType,C: $tType,A4: filter(B),B2: filter(C),C3: filter(B),D4: filter(C)] :
      ( ( A4 != bot_bot(filter(B)) )
     => ( ( B2 != bot_bot(filter(C)) )
       => ( aa(filter(product_prod(B,C)),$o,aa(filter(product_prod(B,C)),fun(filter(product_prod(B,C)),$o),ord_less_eq(filter(product_prod(B,C))),prod_filter(B,C,A4,B2)),prod_filter(B,C,C3,D4))
        <=> ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),A4),C3)
            & aa(filter(C),$o,aa(filter(C),fun(filter(C),$o),ord_less_eq(filter(C)),B2),D4) ) ) ) ) ).

% prod_filter_mono_iff
tff(fact_4548_iso__backward,axiom,
    ! [B: $tType,C: $tType,X: B,Y: B,R4: set(product_prod(B,B)),R3: set(product_prod(C,C)),Fa: fun(C,B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R4)
     => ( bNF_Wellorder_iso(C,B,R3,R4,Fa)
       => member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),aa(B,C,hilbert_inv_into(C,B,field2(C,R3),Fa),X)),aa(B,C,hilbert_inv_into(C,B,field2(C,R3),Fa),Y)),R3) ) ) ).

% iso_backward
tff(fact_4549_surj__iff,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,B)] :
      ( ( aa(set(C),set(B),image2(C,B,Fa),top_top(set(C))) = top_top(set(B)) )
    <=> ( aa(fun(B,C),fun(B,B),aa(fun(C,B),fun(fun(B,C),fun(B,B)),comp(C,B,B),Fa),hilbert_inv_into(C,B,top_top(set(C)),Fa)) = id(B) ) ) ).

% surj_iff
tff(fact_4550_inj__iff,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] :
      ( inj_on(B,C,Fa,top_top(set(B)))
    <=> ( aa(fun(B,C),fun(B,B),aa(fun(C,B),fun(fun(B,C),fun(B,B)),comp(C,B,B),hilbert_inv_into(B,C,top_top(set(B)),Fa)),Fa) = id(B) ) ) ).

% inj_iff
tff(fact_4551_fn__o__inv__fn__is__id,axiom,
    ! [B: $tType,Fa: fun(B,B),N: nat] :
      ( bij_betw(B,B,Fa,top_top(set(B)),top_top(set(B)))
     => ! [X3: B] : ( aa(B,B,aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),compow(fun(B,B),N,Fa)),compow(fun(B,B),N,hilbert_inv_into(B,B,top_top(set(B)),Fa))),X3) = X3 ) ) ).

% fn_o_inv_fn_is_id
tff(fact_4552_inv__fn__o__fn__is__id,axiom,
    ! [B: $tType,Fa: fun(B,B),N: nat] :
      ( bij_betw(B,B,Fa,top_top(set(B)),top_top(set(B)))
     => ! [X3: B] : ( aa(B,B,aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),compow(fun(B,B),N,hilbert_inv_into(B,B,top_top(set(B)),Fa))),compow(fun(B,B),N,Fa)),X3) = X3 ) ) ).

% inv_fn_o_fn_is_id
tff(fact_4553_eventually__prod1,axiom,
    ! [B: $tType,C: $tType,B2: filter(B),Pa: fun(C,$o),A4: filter(C)] :
      ( ( B2 != bot_bot(filter(B)) )
     => ( eventually(product_prod(C,B),aa(fun(C,fun(B,$o)),fun(product_prod(C,B),$o),product_case_prod(C,B,$o),aTP_Lamp_qq(fun(C,$o),fun(C,fun(B,$o)),Pa)),prod_filter(C,B,A4,B2))
      <=> eventually(C,Pa,A4) ) ) ).

% eventually_prod1
tff(fact_4554_eventually__prod2,axiom,
    ! [B: $tType,C: $tType,A4: filter(B),Pa: fun(C,$o),B2: filter(C)] :
      ( ( A4 != bot_bot(filter(B)) )
     => ( eventually(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_qr(fun(C,$o),fun(B,fun(C,$o)),Pa)),prod_filter(B,C,A4,B2))
      <=> eventually(C,Pa,B2) ) ) ).

% eventually_prod2
tff(fact_4555_prod__filter__INF2,axiom,
    ! [D: $tType,C: $tType,B: $tType,J4: set(B),A4: filter(C),B2: fun(B,filter(D))] :
      ( ( J4 != bot_bot(set(B)) )
     => ( prod_filter(C,D,A4,aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(B),set(filter(D)),image2(B,filter(D),B2),J4))) = aa(set(filter(product_prod(C,D))),filter(product_prod(C,D)),complete_Inf_Inf(filter(product_prod(C,D))),aa(set(B),set(filter(product_prod(C,D))),image2(B,filter(product_prod(C,D)),aa(fun(B,filter(D)),fun(B,filter(product_prod(C,D))),aTP_Lamp_qs(filter(C),fun(fun(B,filter(D)),fun(B,filter(product_prod(C,D)))),A4),B2)),J4)) ) ) ).

% prod_filter_INF2
tff(fact_4556_prod__filter__INF1,axiom,
    ! [D: $tType,C: $tType,B: $tType,I4: set(B),A4: fun(B,filter(C)),B2: filter(D)] :
      ( ( I4 != bot_bot(set(B)) )
     => ( prod_filter(C,D,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),A4),I4)),B2) = aa(set(filter(product_prod(C,D))),filter(product_prod(C,D)),complete_Inf_Inf(filter(product_prod(C,D))),aa(set(B),set(filter(product_prod(C,D))),image2(B,filter(product_prod(C,D)),aa(filter(D),fun(B,filter(product_prod(C,D))),aTP_Lamp_qt(fun(B,filter(C)),fun(filter(D),fun(B,filter(product_prod(C,D)))),A4),B2)),I4)) ) ) ).

% prod_filter_INF1
tff(fact_4557_bijection_Oinv__comp__left,axiom,
    ! [B: $tType,Fa: fun(B,B)] :
      ( hilbert_bijection(B,Fa)
     => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),hilbert_inv_into(B,B,top_top(set(B)),Fa)),Fa) = id(B) ) ) ).

% bijection.inv_comp_left
tff(fact_4558_bijection_Oinv__comp__right,axiom,
    ! [B: $tType,Fa: fun(B,B)] :
      ( hilbert_bijection(B,Fa)
     => ( aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),Fa),hilbert_inv_into(B,B,top_top(set(B)),Fa)) = id(B) ) ) ).

% bijection.inv_comp_right
tff(fact_4559_sum__mset__constant,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Y: B,A4: multiset(C)] : ( comm_m7189776963980413722m_mset(B,aa(multiset(C),multiset(B),image_mset(C,B,aTP_Lamp_at(B,fun(C,B),Y)),A4)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),size_size(multiset(C),A4))),Y) ) ) ).

% sum_mset_constant
tff(fact_4560_relpow__fun__conv,axiom,
    ! [B: $tType,A3: B,Ba: B,N: nat,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),compow(set(product_prod(B,B)),N,R))
    <=> ? [F10: fun(nat,B)] :
          ( ( aa(nat,B,F10,zero_zero(nat)) = A3 )
          & ( aa(nat,B,F10,N) = Ba )
          & ! [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),N)
             => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(nat,B,F10,I2)),aa(nat,B,F10,aa(nat,nat,suc,I2))),R) ) ) ) ).

% relpow_fun_conv
tff(fact_4561_relpow__Suc__D2_H,axiom,
    ! [B: $tType,N: nat,R: set(product_prod(B,B)),X3: B,Y4: B,Z5: B] :
      ( ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Y4),compow(set(product_prod(B,B)),N,R))
        & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),Z5),R) )
     => ? [W: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),W),R)
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),W),Z5),compow(set(product_prod(B,B)),N,R)) ) ) ).

% relpow_Suc_D2'
tff(fact_4562_relpow__0__I,axiom,
    ! [B: $tType,X: B,R: set(product_prod(B,B))] : member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),X),compow(set(product_prod(B,B)),zero_zero(nat),R)) ).

% relpow_0_I
tff(fact_4563_relpow__0__E,axiom,
    ! [B: $tType,X: B,Y: B,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),compow(set(product_prod(B,B)),zero_zero(nat),R))
     => ( X = Y ) ) ).

% relpow_0_E
tff(fact_4564_relpow__Suc__I2,axiom,
    ! [B: $tType,X: B,Y: B,R: set(product_prod(B,B)),Z2: B,N: nat] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),Z2),compow(set(product_prod(B,B)),N,R))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),compow(set(product_prod(B,B)),aa(nat,nat,suc,N),R)) ) ) ).

% relpow_Suc_I2
tff(fact_4565_relpow__Suc__E2,axiom,
    ! [B: $tType,X: B,Z2: B,N: nat,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),compow(set(product_prod(B,B)),aa(nat,nat,suc,N),R))
     => ~ ! [Y2: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y2),R)
           => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z2),compow(set(product_prod(B,B)),N,R)) ) ) ).

% relpow_Suc_E2
tff(fact_4566_relpow__Suc__D2,axiom,
    ! [B: $tType,X: B,Z2: B,N: nat,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),compow(set(product_prod(B,B)),aa(nat,nat,suc,N),R))
     => ? [Y2: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y2),R)
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z2),compow(set(product_prod(B,B)),N,R)) ) ) ).

% relpow_Suc_D2
tff(fact_4567_relpow__Suc__I,axiom,
    ! [B: $tType,X: B,Y: B,N: nat,R: set(product_prod(B,B)),Z2: B] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),compow(set(product_prod(B,B)),N,R))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),Z2),R)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),compow(set(product_prod(B,B)),aa(nat,nat,suc,N),R)) ) ) ).

% relpow_Suc_I
tff(fact_4568_relpow__Suc__E,axiom,
    ! [B: $tType,X: B,Z2: B,N: nat,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),compow(set(product_prod(B,B)),aa(nat,nat,suc,N),R))
     => ~ ! [Y2: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y2),compow(set(product_prod(B,B)),N,R))
           => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z2),R) ) ) ).

% relpow_Suc_E
tff(fact_4569_relpowp__relpow__eq,axiom,
    ! [B: $tType,N: nat,R: set(product_prod(B,B)),X3: B,Xa3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),compow(fun(B,fun(B,$o)),N,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R)),X3),Xa3)
    <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa3),compow(set(product_prod(B,B)),N,R)) ) ).

% relpowp_relpow_eq
tff(fact_4570_relpow__E,axiom,
    ! [B: $tType,X: B,Z2: B,N: nat,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),compow(set(product_prod(B,B)),N,R))
     => ( ( ( N = zero_zero(nat) )
         => ( X != Z2 ) )
       => ~ ! [Y2: B,M5: nat] :
              ( ( N = aa(nat,nat,suc,M5) )
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y2),compow(set(product_prod(B,B)),M5,R))
               => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z2),R) ) ) ) ) ).

% relpow_E
tff(fact_4571_relpow__E2,axiom,
    ! [B: $tType,X: B,Z2: B,N: nat,R: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Z2),compow(set(product_prod(B,B)),N,R))
     => ( ( ( N = zero_zero(nat) )
         => ( X != Z2 ) )
       => ~ ! [Y2: B,M5: nat] :
              ( ( N = aa(nat,nat,suc,M5) )
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y2),R)
               => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z2),compow(set(product_prod(B,B)),M5,R)) ) ) ) ) ).

% relpow_E2
tff(fact_4572_relpow__empty,axiom,
    ! [B: $tType,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( compow(set(product_prod(B,B)),N,bot_bot(set(product_prod(B,B)))) = bot_bot(set(product_prod(B,B))) ) ) ).

% relpow_empty
tff(fact_4573_exhaustive__integer_H_Ocases,axiom,
    ! [X: product_prod(fun(code_integer,option(product_prod($o,list(code_term)))),product_prod(code_integer,code_integer))] :
      ~ ! [F8: fun(code_integer,option(product_prod($o,list(code_term)))),D3: code_integer,I3: code_integer] : ( X != aa(product_prod(code_integer,code_integer),product_prod(fun(code_integer,option(product_prod($o,list(code_term)))),product_prod(code_integer,code_integer)),aa(fun(code_integer,option(product_prod($o,list(code_term)))),fun(product_prod(code_integer,code_integer),product_prod(fun(code_integer,option(product_prod($o,list(code_term)))),product_prod(code_integer,code_integer))),product_Pair(fun(code_integer,option(product_prod($o,list(code_term)))),product_prod(code_integer,code_integer)),F8),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),D3),I3)) ) ).

% exhaustive_integer'.cases
tff(fact_4574_full__exhaustive__integer_H_Ocases,axiom,
    ! [X: product_prod(fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_integer,code_integer))] :
      ~ ! [F8: fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),D3: code_integer,I3: code_integer] : ( X != aa(product_prod(code_integer,code_integer),product_prod(fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_integer,code_integer)),aa(fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),fun(product_prod(code_integer,code_integer),product_prod(fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_integer,code_integer))),product_Pair(fun(product_prod(code_integer,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_integer,code_integer)),F8),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),D3),I3)) ) ).

% full_exhaustive_integer'.cases
tff(fact_4575_Inf__multiset_Oabs__eq,axiom,
    ! [B: $tType,X: set(fun(B,nat))] :
      ( aa(set(fun(B,nat)),$o,aa(set(fun(B,nat)),fun(set(fun(B,nat)),$o),bNF_rel_set(fun(B,nat),fun(B,nat),bNF_eq_onp(fun(B,nat),aTP_Lamp_qv(fun(B,nat),$o))),X),X)
     => ( aa(set(multiset(B)),multiset(B),complete_Inf_Inf(multiset(B)),aa(set(fun(B,nat)),set(multiset(B)),image2(fun(B,nat),multiset(B),abs_multiset(B)),X)) = aa(fun(B,nat),multiset(B),abs_multiset(B),aa(set(fun(B,nat)),fun(B,nat),aTP_Lamp_qh(set(fun(B,nat)),fun(B,nat)),X)) ) ) ).

% Inf_multiset.abs_eq
tff(fact_4576_irreflp__irrefl__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( irreflp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R))
    <=> irrefl(B,R) ) ).

% irreflp_irrefl_eq
tff(fact_4577_Inf__multiset_Orsp,axiom,
    ! [B: $tType] : aa(fun(set(fun(B,nat)),fun(B,nat)),$o,aa(fun(set(fun(B,nat)),fun(B,nat)),fun(fun(set(fun(B,nat)),fun(B,nat)),$o),bNF_rel_fun(set(fun(B,nat)),set(fun(B,nat)),fun(B,nat),fun(B,nat),bNF_rel_set(fun(B,nat),fun(B,nat),bNF_eq_onp(fun(B,nat),aTP_Lamp_qv(fun(B,nat),$o))),bNF_eq_onp(fun(B,nat),aTP_Lamp_qv(fun(B,nat),$o))),aTP_Lamp_qh(set(fun(B,nat)),fun(B,nat))),aTP_Lamp_qh(set(fun(B,nat)),fun(B,nat))) ).

% Inf_multiset.rsp
tff(fact_4578_exhaustive__int_H_Ocases,axiom,
    ! [X: product_prod(fun(int,option(product_prod($o,list(code_term)))),product_prod(int,int))] :
      ~ ! [F8: fun(int,option(product_prod($o,list(code_term)))),D3: int,I3: int] : ( X != aa(product_prod(int,int),product_prod(fun(int,option(product_prod($o,list(code_term)))),product_prod(int,int)),aa(fun(int,option(product_prod($o,list(code_term)))),fun(product_prod(int,int),product_prod(fun(int,option(product_prod($o,list(code_term)))),product_prod(int,int))),product_Pair(fun(int,option(product_prod($o,list(code_term)))),product_prod(int,int)),F8),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),D3),I3)) ) ).

% exhaustive_int'.cases
tff(fact_4579_full__exhaustive__int_H_Ocases,axiom,
    ! [X: product_prod(fun(product_prod(int,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(int,int))] :
      ~ ! [F8: fun(product_prod(int,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),D3: int,I3: int] : ( X != aa(product_prod(int,int),product_prod(fun(product_prod(int,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(int,int)),aa(fun(product_prod(int,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),fun(product_prod(int,int),product_prod(fun(product_prod(int,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(int,int))),product_Pair(fun(product_prod(int,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(int,int)),F8),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),D3),I3)) ) ).

% full_exhaustive_int'.cases
tff(fact_4580_empty__transfer,axiom,
    ! [B: $tType,C: $tType,A4: fun(B,fun(C,$o))] : aa(set(C),$o,aa(set(B),fun(set(C),$o),bNF_rel_set(B,C,A4),bot_bot(set(B))),bot_bot(set(C))) ).

% empty_transfer
tff(fact_4581_equivp__equiv,axiom,
    ! [B: $tType,A4: set(product_prod(B,B))] :
      ( equiv_equiv(B,top_top(set(B)),A4)
    <=> equiv_equivp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),A4)) ) ).

% equivp_equiv
tff(fact_4582_asymp__asym__eq,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( asymp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R))
    <=> asym(B,R) ) ).

% asymp_asym_eq
tff(fact_4583_asym_Ocases,axiom,
    ! [B: $tType,A3: set(product_prod(B,B))] :
      ( asym(B,A3)
     => ! [A13: B,B9: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A13),B9),A3)
         => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B9),A13),A3) ) ) ).

% asym.cases
tff(fact_4584_asym_Osimps,axiom,
    ! [B: $tType,A3: set(product_prod(B,B))] :
      ( asym(B,A3)
    <=> ? [R6: set(product_prod(B,B))] :
          ( ( A3 = R6 )
          & ! [X4: B,Xa2: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa2),R6)
             => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa2),X4),R6) ) ) ) ).

% asym.simps
tff(fact_4585_asym_Ointros,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ! [A8: B,B4: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),B4),R)
         => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B4),A8),R) )
     => asym(B,R) ) ).

% asym.intros
tff(fact_4586_asymD,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),X: B,Y: B] :
      ( asym(B,R)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R)
       => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y),X),R) ) ) ).

% asymD
tff(fact_4587_asym__iff,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( asym(B,R)
    <=> ! [X4: B,Y3: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Y3),R)
         => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y3),X4),R) ) ) ).

% asym_iff
tff(fact_4588_Inf__multiset_Otransfer,axiom,
    ! [B: $tType] : aa(fun(set(multiset(B)),multiset(B)),$o,aa(fun(set(fun(B,nat)),fun(B,nat)),fun(fun(set(multiset(B)),multiset(B)),$o),bNF_rel_fun(set(fun(B,nat)),set(multiset(B)),fun(B,nat),multiset(B),bNF_rel_set(fun(B,nat),multiset(B),pcr_multiset(B,B,fequal(B))),pcr_multiset(B,B,fequal(B))),aTP_Lamp_qh(set(fun(B,nat)),fun(B,nat))),complete_Inf_Inf(multiset(B))) ).

% Inf_multiset.transfer
tff(fact_4589_min__of__antimono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [Fa: fun(B,C),X: B,Y: B] :
          ( order_antimono(B,C,Fa)
         => ( aa(C,C,aa(C,fun(C,C),ord_min(C),aa(B,C,Fa,X)),aa(B,C,Fa,Y)) = aa(B,C,Fa,aa(B,B,aa(B,fun(B,B),ord_max(B),X),Y)) ) ) ) ).

% min_of_antimono
tff(fact_4590_max__of__antimono,axiom,
    ! [C: $tType,B: $tType] :
      ( ( linorder(B)
        & linorder(C) )
     => ! [Fa: fun(B,C),X: B,Y: B] :
          ( order_antimono(B,C,Fa)
         => ( aa(C,C,aa(C,fun(C,C),ord_max(C),aa(B,C,Fa,X)),aa(B,C,Fa,Y)) = aa(B,C,Fa,aa(B,B,aa(B,fun(B,B),ord_min(B),X),Y)) ) ) ) ).

% max_of_antimono
tff(fact_4591_antimonoD,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [Fa: fun(B,C),X: B,Y: B] :
          ( order_antimono(B,C,Fa)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,Y)),aa(B,C,Fa,X)) ) ) ) ).

% antimonoD
tff(fact_4592_antimonoE,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [Fa: fun(B,C),X: B,Y: B] :
          ( order_antimono(B,C,Fa)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y)
           => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,Y)),aa(B,C,Fa,X)) ) ) ) ).

% antimonoE
tff(fact_4593_antimonoI,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [Fa: fun(B,C)] :
          ( ! [X2: B,Y2: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X2),Y2)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,Y2)),aa(B,C,Fa,X2)) )
         => order_antimono(B,C,Fa) ) ) ).

% antimonoI
tff(fact_4594_antimono__def,axiom,
    ! [C: $tType,B: $tType] :
      ( ( order(B)
        & order(C) )
     => ! [Fa: fun(B,C)] :
          ( order_antimono(B,C,Fa)
        <=> ! [X4: B,Y3: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),Y3)
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,Fa,Y3)),aa(B,C,Fa,X4)) ) ) ) ).

% antimono_def
tff(fact_4595_Range__insert,axiom,
    ! [B: $tType,C: $tType,A3: C,Ba: B,R3: set(product_prod(C,B))] : ( range2(C,B,aa(set(product_prod(C,B)),set(product_prod(C,B)),insert2(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),A3),Ba)),R3)) = aa(set(B),set(B),insert2(B,Ba),range2(C,B,R3)) ) ).

% Range_insert
tff(fact_4596_in__chain__finite,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [A4: set(B)] :
          ( comple1602240252501008431_chain(B,ord_less_eq(B),A4)
         => ( aa(set(B),$o,finite_finite(B),A4)
           => ( ( A4 != bot_bot(set(B)) )
             => member(B,aa(set(B),B,complete_Sup_Sup(B),A4),A4) ) ) ) ) ).

% in_chain_finite
tff(fact_4597_Range__empty,axiom,
    ! [C: $tType,B: $tType] : ( range2(C,B,bot_bot(set(product_prod(C,B)))) = bot_bot(set(B)) ) ).

% Range_empty
tff(fact_4598_chain__empty,axiom,
    ! [B: $tType,Ord: fun(B,fun(B,$o))] : comple1602240252501008431_chain(B,Ord,bot_bot(set(B))) ).

% chain_empty
tff(fact_4599_Range_Ocases,axiom,
    ! [B: $tType,C: $tType,A3: B,R3: set(product_prod(C,B))] :
      ( member(B,A3,range2(C,B,R3))
     => ~ ! [A8: C] : ~ member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),A8),A3),R3) ) ).

% Range.cases
tff(fact_4600_Range_Osimps,axiom,
    ! [B: $tType,C: $tType,A3: B,R3: set(product_prod(C,B))] :
      ( member(B,A3,range2(C,B,R3))
    <=> ? [A6: C,B5: B] :
          ( ( A3 = B5 )
          & member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),A6),B5),R3) ) ) ).

% Range.simps
tff(fact_4601_Range_Ointros,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,R3: set(product_prod(B,C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),R3)
     => member(C,Ba,range2(B,C,R3)) ) ).

% Range.intros
tff(fact_4602_RangeE,axiom,
    ! [B: $tType,C: $tType,Ba: B,R3: set(product_prod(C,B))] :
      ( member(B,Ba,range2(C,B,R3))
     => ~ ! [A8: C] : ~ member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),A8),Ba),R3) ) ).

% RangeE
tff(fact_4603_Range__iff,axiom,
    ! [B: $tType,C: $tType,A3: B,R3: set(product_prod(C,B))] :
      ( member(B,A3,range2(C,B,R3))
    <=> ? [Y3: C] : member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Y3),A3),R3) ) ).

% Range_iff
tff(fact_4604_Range__empty__iff,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,B))] :
      ( ( range2(C,B,R3) = bot_bot(set(B)) )
    <=> ( R3 = bot_bot(set(product_prod(C,B))) ) ) ).

% Range_empty_iff
tff(fact_4605_chain__singleton,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [X: B] : comple1602240252501008431_chain(B,ord_less_eq(B),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) ) ).

% chain_singleton
tff(fact_4606_Range__Int__subset,axiom,
    ! [B: $tType,C: $tType,A4: set(product_prod(C,B)),B2: set(product_prod(C,B))] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),range2(C,B,aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(set(product_prod(C,B)),fun(set(product_prod(C,B)),set(product_prod(C,B))),inf_inf(set(product_prod(C,B))),A4),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),range2(C,B,A4)),range2(C,B,B2))) ).

% Range_Int_subset
tff(fact_4607_wf__UN,axiom,
    ! [C: $tType,B: $tType,I4: set(B),R3: fun(B,set(product_prod(C,C)))] :
      ( ! [I3: B] :
          ( member(B,I3,I4)
         => wf(C,aa(B,set(product_prod(C,C)),R3,I3)) )
     => ( ! [I3: B,J3: B] :
            ( member(B,I3,I4)
           => ( member(B,J3,I4)
             => ( ( aa(B,set(product_prod(C,C)),R3,I3) != aa(B,set(product_prod(C,C)),R3,J3) )
               => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),domain(C,C,aa(B,set(product_prod(C,C)),R3,I3))),range2(C,C,aa(B,set(product_prod(C,C)),R3,J3))) = bot_bot(set(C)) ) ) ) )
       => wf(C,aa(set(set(product_prod(C,C))),set(product_prod(C,C)),complete_Sup_Sup(set(product_prod(C,C))),aa(set(B),set(set(product_prod(C,C))),image2(B,set(product_prod(C,C)),R3),I4))) ) ) ).

% wf_UN
tff(fact_4608_dom__ran__disj__comp,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),domain(B,B,R)),range2(B,B,R)) = bot_bot(set(B)) )
     => ( relcomp(B,B,B,R,R) = bot_bot(set(product_prod(B,B))) ) ) ).

% dom_ran_disj_comp
tff(fact_4609_wf__max,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( wf(B,converse(B,B,R))
     => ( ( R != bot_bot(set(product_prod(B,B))) )
       => ~ ! [M5: B] : ~ member(B,M5,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),range2(B,B,R)),domain(B,B,R))) ) ) ).

% wf_max
tff(fact_4610_Domain__empty,axiom,
    ! [C: $tType,B: $tType] : ( domain(B,C,bot_bot(set(product_prod(B,C)))) = bot_bot(set(B)) ) ).

% Domain_empty
tff(fact_4611_Domain__insert,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,R3: set(product_prod(B,C))] : ( domain(B,C,aa(set(product_prod(B,C)),set(product_prod(B,C)),insert2(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba)),R3)) = aa(set(B),set(B),insert2(B,A3),domain(B,C,R3)) ) ).

% Domain_insert
tff(fact_4612_Domain__iff,axiom,
    ! [C: $tType,B: $tType,A3: B,R3: set(product_prod(B,C))] :
      ( member(B,A3,domain(B,C,R3))
    <=> ? [Y3: C] : member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Y3),R3) ) ).

% Domain_iff
tff(fact_4613_DomainE,axiom,
    ! [C: $tType,B: $tType,A3: B,R3: set(product_prod(B,C))] :
      ( member(B,A3,domain(B,C,R3))
     => ~ ! [B4: C] : ~ member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),B4),R3) ) ).

% DomainE
tff(fact_4614_Domain_ODomainI,axiom,
    ! [C: $tType,B: $tType,A3: B,Ba: C,R3: set(product_prod(B,C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),R3)
     => member(B,A3,domain(B,C,R3)) ) ).

% Domain.DomainI
tff(fact_4615_Domain_Osimps,axiom,
    ! [C: $tType,B: $tType,A3: B,R3: set(product_prod(B,C))] :
      ( member(B,A3,domain(B,C,R3))
    <=> ? [A6: B,B5: C] :
          ( ( A3 = A6 )
          & member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A6),B5),R3) ) ) ).

% Domain.simps
tff(fact_4616_Domain_Ocases,axiom,
    ! [C: $tType,B: $tType,A3: B,R3: set(product_prod(B,C))] :
      ( member(B,A3,domain(B,C,R3))
     => ~ ! [B4: C] : ~ member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),B4),R3) ) ).

% Domain.cases
tff(fact_4617_Not__Domain__rtrancl,axiom,
    ! [B: $tType,X: B,R: set(product_prod(B,B)),Y: B] :
      ( ~ member(B,X,domain(B,B,R))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,R))
      <=> ( X = Y ) ) ) ).

% Not_Domain_rtrancl
tff(fact_4618_Domain__empty__iff,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,C))] :
      ( ( domain(B,C,R3) = bot_bot(set(B)) )
    <=> ( R3 = bot_bot(set(product_prod(B,C))) ) ) ).

% Domain_empty_iff
tff(fact_4619_Domain__unfold,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,C))] : ( domain(B,C,R3) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_qw(set(product_prod(B,C)),fun(B,$o),R3)) ) ).

% Domain_unfold
tff(fact_4620_Domain__Int__subset,axiom,
    ! [C: $tType,B: $tType,A4: set(product_prod(B,C)),B2: set(product_prod(B,C))] : aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),domain(B,C,aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),set(product_prod(B,C))),inf_inf(set(product_prod(B,C))),A4),B2))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),domain(B,C,A4)),domain(B,C,B2))) ).

% Domain_Int_subset
tff(fact_4621_wf__no__path,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),domain(B,B,R)),range2(B,B,R)) = bot_bot(set(B)) )
     => wf(B,R) ) ).

% wf_no_path
tff(fact_4622_wf__min,axiom,
    ! [B: $tType,R: set(product_prod(B,B))] :
      ( wf(B,R)
     => ( ( R != bot_bot(set(product_prod(B,B))) )
       => ~ ! [M5: B] : ~ member(B,M5,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),domain(B,B,R)),range2(B,B,R))) ) ) ).

% wf_min
tff(fact_4623_wf__Un,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),S: set(product_prod(B,B))] :
      ( wf(B,R3)
     => ( wf(B,S)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),domain(B,B,R3)),range2(B,B,S)) = bot_bot(set(B)) )
         => wf(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),sup_sup(set(product_prod(B,B))),R3),S)) ) ) ) ).

% wf_Un
tff(fact_4624_wf__Union,axiom,
    ! [B: $tType,R: set(set(product_prod(B,B)))] :
      ( ! [X2: set(product_prod(B,B))] :
          ( member(set(product_prod(B,B)),X2,R)
         => wf(B,X2) )
     => ( ! [X2: set(product_prod(B,B))] :
            ( member(set(product_prod(B,B)),X2,R)
           => ! [Xa4: set(product_prod(B,B))] :
                ( member(set(product_prod(B,B)),Xa4,R)
               => ( ( X2 != Xa4 )
                 => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),domain(B,B,X2)),range2(B,B,Xa4)) = bot_bot(set(B)) ) ) ) )
       => wf(B,aa(set(set(product_prod(B,B))),set(product_prod(B,B)),complete_Sup_Sup(set(product_prod(B,B))),R)) ) ) ).

% wf_Union
tff(fact_4625_for__in__RI,axiom,
    ! [C: $tType,B: $tType,X: B,R: set(product_prod(B,C))] :
      ( member(B,X,domain(B,C,R))
     => member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),fun_of_rel(B,C,R,X)),R) ) ).

% for_in_RI
tff(fact_4626_Rangep__Range__eq,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,B)),X3: B] :
      ( aa(B,$o,rangep(C,B,aTP_Lamp_ll(set(product_prod(C,B)),fun(C,fun(B,$o)),R3)),X3)
    <=> member(B,X3,range2(C,B,R3)) ) ).

% Rangep_Range_eq
tff(fact_4627_Range__def,axiom,
    ! [C: $tType,B: $tType,X3: set(product_prod(B,C))] : ( range2(B,C,X3) = aa(fun(C,$o),set(C),collect(C),rangep(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),X3))) ) ).

% Range_def
tff(fact_4628_cofinite__bot,axiom,
    ! [B: $tType] :
      ( ( cofinite(B) = bot_bot(filter(B)) )
    <=> aa(set(B),$o,finite_finite(B),top_top(set(B))) ) ).

% cofinite_bot
tff(fact_4629_drop__bit__of__1,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat] : ( bit_se4197421643247451524op_bit(B,N,one_one(B)) = aa($o,B,zero_neq_one_of_bool(B),( N = zero_zero(nat) )) ) ) ).

% drop_bit_of_1
tff(fact_4630_wfP__SUP,axiom,
    ! [C: $tType,B: $tType,R3: fun(B,fun(C,fun(C,$o)))] :
      ( ! [I3: B] : wfP(C,aa(B,fun(C,fun(C,$o)),R3,I3))
     => ( ! [I3: B,J3: B] :
            ( ( aa(B,fun(C,fun(C,$o)),R3,I3) != aa(B,fun(C,fun(C,$o)),R3,J3) )
           => ( aa(fun(C,$o),fun(C,$o),aa(fun(C,$o),fun(fun(C,$o),fun(C,$o)),inf_inf(fun(C,$o)),domainp(C,C,aa(B,fun(C,fun(C,$o)),R3,I3))),rangep(C,C,aa(B,fun(C,fun(C,$o)),R3,J3))) = bot_bot(fun(C,$o)) ) )
       => wfP(C,aa(set(fun(C,fun(C,$o))),fun(C,fun(C,$o)),complete_Sup_Sup(fun(C,fun(C,$o))),aa(set(B),set(fun(C,fun(C,$o))),image2(B,fun(C,fun(C,$o)),R3),top_top(set(B))))) ) ) ).

% wfP_SUP
tff(fact_4631_bit__drop__bit__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [N: nat,A3: B] : ( bit_se5641148757651400278ts_bit(B,bit_se4197421643247451524op_bit(B,N,A3)) = aa(fun(nat,nat),fun(nat,$o),aa(fun(nat,$o),fun(fun(nat,nat),fun(nat,$o)),comp(nat,$o,nat),bit_se5641148757651400278ts_bit(B,A3)),aa(nat,fun(nat,nat),plus_plus(nat),N)) ) ) ).

% bit_drop_bit_eq
tff(fact_4632_Domainp__Domain__eq,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,C)),X3: B] :
      ( aa(B,$o,domainp(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),R3)),X3)
    <=> member(B,X3,domain(B,C,R3)) ) ).

% Domainp_Domain_eq
tff(fact_4633_Domain__def,axiom,
    ! [C: $tType,B: $tType,X3: set(product_prod(B,C))] : ( domain(B,C,X3) = aa(fun(B,$o),set(B),collect(B),domainp(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),X3))) ) ).

% Domain_def
tff(fact_4634_wfP__wf__eq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( wfP(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3))
    <=> wf(B,R3) ) ).

% wfP_wf_eq
tff(fact_4635_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B,N: nat] : ( divide_divide(B,A3,bit_se4730199178511100633sh_bit(B,N,one_one(B))) = bit_se4197421643247451524op_bit(B,N,A3) ) ) ).

% div_push_bit_of_1_eq_drop_bit
tff(fact_4636_bit__iff__and__drop__bit__eq__1,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [A3: B,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,A3),N)
        <=> ( aa(B,B,aa(B,fun(B,B),bit_se5824344872417868541ns_and(B),bit_se4197421643247451524op_bit(B,N,A3)),one_one(B)) = one_one(B) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
tff(fact_4637_pcr__Domainp__par,axiom,
    ! [B: $tType,C: $tType,D: $tType,B2: fun(B,fun(C,$o)),P23: fun(B,$o),A4: fun(D,fun(B,$o)),P12: fun(D,$o),P24: fun(D,$o)] :
      ( ( domainp(B,C,B2) = P23 )
     => ( ( domainp(D,B,A4) = P12 )
       => ( aa(fun(B,$o),$o,aa(fun(D,$o),fun(fun(B,$o),$o),bNF_rel_fun(D,B,$o,$o,A4,fequal($o)),P24),P23)
         => ( domainp(D,C,relcompp(D,B,C,A4,B2)) = aa(fun(D,$o),fun(D,$o),aa(fun(D,$o),fun(fun(D,$o),fun(D,$o)),inf_inf(fun(D,$o)),P12),P24) ) ) ) ) ).

% pcr_Domainp_par
tff(fact_4638_drop__bit__exp__eq,axiom,
    ! [B: $tType] :
      ( bit_se359711467146920520ations(B)
     => ! [M4: nat,N: nat] :
          ( bit_se4197421643247451524op_bit(B,M4,aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),N))
          = aa(B,B,
              aa(B,fun(B,B),times_times(B),
                aa($o,B,zero_neq_one_of_bool(B),
                  aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
                & bit_se6407376104438227557le_bit(B,type2(B),N))),
              aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ).

% drop_bit_exp_eq
tff(fact_4639_composed__equiv__rel__eq__onp,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o)),Pa: fun(B,$o),P: fun(C,$o),P8: fun(B,$o)] :
      ( left_unique(B,C,R)
     => ( aa(fun(C,$o),$o,aa(fun(B,$o),fun(fun(C,$o),$o),bNF_rel_fun(B,C,$o,$o,R,fequal($o)),Pa),P)
       => ( ( domainp(B,C,R) = P8 )
         => ( relcompp(B,C,B,R,relcompp(C,C,B,bNF_eq_onp(C,P),conversep(B,C,R))) = bNF_eq_onp(B,aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),P8),Pa)) ) ) ) ) ).

% composed_equiv_rel_eq_onp
tff(fact_4640_bit__minus__1__iff,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,uminus_uminus(B),one_one(B))),N)
        <=> bit_se6407376104438227557le_bit(B,type2(B),N) ) ) ).

% bit_minus_1_iff
tff(fact_4641_bit__minus__iff,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => ! [A3: B,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,uminus_uminus(B),A3)),N)
        <=> ( bit_se6407376104438227557le_bit(B,type2(B),N)
            & ~ aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A3),one_one(B))),N) ) ) ) ).

% bit_minus_iff
tff(fact_4642_bit__mask__sub__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [M4: nat,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),M4)),one_one(B))),N)
        <=> ( bit_se6407376104438227557le_bit(B,type2(B),N)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M4) ) ) ) ).

% bit_mask_sub_iff
tff(fact_4643_bit__double__iff,axiom,
    ! [B: $tType] :
      ( bit_semiring_bits(B)
     => ! [A3: B,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),A3)),N)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(B,A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))
            & ( N != zero_zero(nat) )
            & bit_se6407376104438227557le_bit(B,type2(B),N) ) ) ) ).

% bit_double_iff
tff(fact_4644_multiset_Odomain__par,axiom,
    ! [C: $tType,B: $tType,T3: fun(B,fun(C,$o)),DT: fun(B,$o),DS: fun(nat,$o),P24: fun(fun(B,nat),$o)] :
      ( ( domainp(B,C,T3) = DT )
     => ( ( domainp(nat,nat,fequal(nat)) = DS )
       => ( left_unique(B,C,T3)
         => ( aa(fun(fun(C,nat),$o),$o,aa(fun(fun(B,nat),$o),fun(fun(fun(C,nat),$o),$o),bNF_rel_fun(fun(B,nat),fun(C,nat),$o,$o,bNF_rel_fun(B,C,nat,nat,T3,fequal(nat)),fequal($o)),P24),aTP_Lamp_qy(fun(C,nat),$o))
           => ( domainp(fun(B,nat),multiset(C),pcr_multiset(B,C,T3)) = aa(fun(fun(B,nat),$o),fun(fun(B,nat),$o),aa(fun(fun(B,nat),$o),fun(fun(fun(B,nat),$o),fun(fun(B,nat),$o)),inf_inf(fun(fun(B,nat),$o)),basic_pred_fun(B,nat,DT,DS)),P24) ) ) ) ) ) ).

% multiset.domain_par
tff(fact_4645_cut__def,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),R: set(product_prod(B,B)),X: B,X3: B] :
      ( aa(B,C,cut(B,C,Fa,R,X),X3)
      = $ite(member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),X),R),aa(B,C,Fa,X3),undefined(C)) ) ).

% cut_def
tff(fact_4646_pairwise__alt,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),S2: set(B)] :
      ( pairwise(B,R,S2)
    <=> ! [X4: B] :
          ( member(B,X4,S2)
         => ! [Xa2: B] :
              ( member(B,Xa2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),S2),aa(set(B),set(B),insert2(B,X4),bot_bot(set(B)))))
             => aa(B,$o,aa(B,fun(B,$o),R,X4),Xa2) ) ) ) ).

% pairwise_alt
tff(fact_4647_pairwise__empty,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o))] : pairwise(B,Pa,bot_bot(set(B))) ).

% pairwise_empty
tff(fact_4648_pred__fun__True__id,axiom,
    ! [B: $tType,C: $tType,D: $tType,P2: fun(C,$o),Fa: fun(D,C)] :
      ( nO_MATCH(fun(B,B),fun(C,$o),id(B),P2)
     => ( aa(fun(D,C),$o,basic_pred_fun(D,C,aTP_Lamp_qz(D,$o),P2),Fa)
      <=> aa(fun(D,$o),$o,basic_pred_fun(D,$o,aTP_Lamp_qz(D,$o),id($o)),aa(fun(D,C),fun(D,$o),aa(fun(C,$o),fun(fun(D,C),fun(D,$o)),comp(C,$o,D),P2),Fa)) ) ) ).

% pred_fun_True_id
tff(fact_4649_fun_Omap__cong__pred,axiom,
    ! [D: $tType,C: $tType,B: $tType,X: fun(B,C),Ya: fun(B,C),Fa: fun(C,D),Ga: fun(C,D)] :
      ( ( X = Ya )
     => ( aa(fun(B,C),$o,basic_pred_fun(B,C,aTP_Lamp_ra(B,$o),aa(fun(C,D),fun(C,$o),aTP_Lamp_rb(fun(C,D),fun(fun(C,D),fun(C,$o)),Fa),Ga)),Ya)
       => ( aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Fa),X) = aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),Ya) ) ) ) ).

% fun.map_cong_pred
tff(fact_4650_cuts__eq,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),R: set(product_prod(B,B)),X: B,Ga: fun(B,C)] :
      ( ( cut(B,C,Fa,R,X) = cut(B,C,Ga,R,X) )
    <=> ! [Y3: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y3),X),R)
         => ( aa(B,C,Fa,Y3) = aa(B,C,Ga,Y3) ) ) ) ).

% cuts_eq
tff(fact_4651_cut__apply,axiom,
    ! [C: $tType,B: $tType,X: B,A3: B,R: set(product_prod(B,B)),Fa: fun(B,C)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),A3),R)
     => ( aa(B,C,cut(B,C,Fa,R,A3),X) = aa(B,C,Fa,X) ) ) ).

% cut_apply
tff(fact_4652_pairwise__singleton,axiom,
    ! [B: $tType,Pa: fun(B,fun(B,$o)),A4: B] : pairwise(B,Pa,aa(set(B),set(B),insert2(B,A4),bot_bot(set(B)))) ).

% pairwise_singleton
tff(fact_4653_fun_Opred__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,Qa: fun(C,$o),Fa: fun(D,C),X: fun(B,D)] :
      ( aa(fun(B,C),$o,basic_pred_fun(B,C,aTP_Lamp_ra(B,$o),Qa),aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),X))
    <=> aa(fun(B,D),$o,basic_pred_fun(B,D,aTP_Lamp_ra(B,$o),aa(fun(D,C),fun(D,$o),aa(fun(C,$o),fun(fun(D,C),fun(D,$o)),comp(C,$o,D),Qa),Fa)),X) ) ).

% fun.pred_map
tff(fact_4654_ID_Oin__rel,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),A3: B,Ba: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),bNF_id_bnf(fun(B,fun(C,$o))),R),A3),Ba)
    <=> ? [Z4: product_prod(B,C)] :
          ( member(product_prod(B,C),Z4,aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aTP_Lamp_rc(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),R)))
          & ( aa(product_prod(B,C),B,aa(fun(product_prod(B,C),B),fun(product_prod(B,C),B),bNF_id_bnf(fun(product_prod(B,C),B)),product_fst(B,C)),Z4) = A3 )
          & ( aa(product_prod(B,C),C,aa(fun(product_prod(B,C),C),fun(product_prod(B,C),C),bNF_id_bnf(fun(product_prod(B,C),C)),product_snd(B,C)),Z4) = Ba ) ) ) ).

% ID.in_rel
tff(fact_4655_is__num_Ocases,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [A3: B] :
          ( neg_numeral_is_num(B,A3)
         => ( ( A3 != one_one(B) )
           => ( ! [X2: B] :
                  ( ( A3 = aa(B,B,uminus_uminus(B),X2) )
                 => ~ neg_numeral_is_num(B,X2) )
             => ~ ! [X2: B,Y2: B] :
                    ( ( A3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),X2),Y2) )
                   => ( neg_numeral_is_num(B,X2)
                     => ~ neg_numeral_is_num(B,Y2) ) ) ) ) ) ) ).

% is_num.cases
tff(fact_4656_is__num_Osimps,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => ! [A3: B] :
          ( neg_numeral_is_num(B,A3)
        <=> ( ( A3 = one_one(B) )
            | ? [X4: B] :
                ( ( A3 = aa(B,B,uminus_uminus(B),X4) )
                & neg_numeral_is_num(B,X4) )
            | ? [X4: B,Y3: B] :
                ( ( A3 = aa(B,B,aa(B,fun(B,B),plus_plus(B),X4),Y3) )
                & neg_numeral_is_num(B,X4)
                & neg_numeral_is_num(B,Y3) ) ) ) ) ).

% is_num.simps
tff(fact_4657_is__num__normalize_I4_J,axiom,
    ! [B: $tType] :
      ( neg_numeral(B)
     => neg_numeral_is_num(B,one_one(B)) ) ).

% is_num_normalize(4)
tff(fact_4658_ID_Opred__map,axiom,
    ! [B: $tType,C: $tType,Qa: fun(B,$o),Fa: fun(C,B),X: C] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),bNF_id_bnf(fun(B,$o)),Qa),aa(C,B,aa(fun(C,B),fun(C,B),bNF_id_bnf(fun(C,B)),Fa),X))
    <=> aa(C,$o,aa(fun(C,$o),fun(C,$o),bNF_id_bnf(fun(C,$o)),aa(fun(C,B),fun(C,$o),aa(fun(B,$o),fun(fun(C,B),fun(C,$o)),comp(B,$o,C),Qa),Fa)),X) ) ).

% ID.pred_map
tff(fact_4659_ID_Orel__refl__strong,axiom,
    ! [B: $tType,X: B,Ra2: fun(B,fun(B,$o))] :
      ( ! [Z3: B] :
          ( member(B,Z3,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))
         => aa(B,$o,aa(B,fun(B,$o),Ra2,Z3),Z3) )
     => aa(B,$o,aa(B,fun(B,$o),aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),bNF_id_bnf(fun(B,fun(B,$o))),Ra2),X),X) ) ).

% ID.rel_refl_strong
tff(fact_4660_ID_Orel__mono__strong,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),X: B,Y: C,Ra2: fun(B,fun(C,$o))] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),bNF_id_bnf(fun(B,fun(C,$o))),R),X),Y)
     => ( ! [Z3: B,Yb: C] :
            ( member(B,Z3,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))
           => ( member(C,Yb,aa(set(C),set(C),insert2(C,Y),bot_bot(set(C))))
             => ( aa(C,$o,aa(B,fun(C,$o),R,Z3),Yb)
               => aa(C,$o,aa(B,fun(C,$o),Ra2,Z3),Yb) ) ) )
       => aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),bNF_id_bnf(fun(B,fun(C,$o))),Ra2),X),Y) ) ) ).

% ID.rel_mono_strong
tff(fact_4661_ID_Orel__cong,axiom,
    ! [B: $tType,C: $tType,X: B,Ya: B,Y: C,Xa: C,R: fun(B,fun(C,$o)),Ra2: fun(B,fun(C,$o))] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z3: B,Yb: C] :
              ( member(B,Z3,aa(set(B),set(B),insert2(B,Ya),bot_bot(set(B))))
             => ( member(C,Yb,aa(set(C),set(C),insert2(C,Xa),bot_bot(set(C))))
               => ( aa(C,$o,aa(B,fun(C,$o),R,Z3),Yb)
                <=> aa(C,$o,aa(B,fun(C,$o),Ra2,Z3),Yb) ) ) )
         => ( aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),bNF_id_bnf(fun(B,fun(C,$o))),R),X),Y)
          <=> aa(C,$o,aa(B,fun(C,$o),aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),bNF_id_bnf(fun(B,fun(C,$o))),Ra2),Ya),Xa) ) ) ) ) ).

% ID.rel_cong
tff(fact_4662_Basic__BNF__LFPs_Octor__rec__o__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(D,C),Ga: fun(B,D)] : ( aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),basic_BNF_ctor_rec(fun(D,C),Fa)),Ga) = basic_BNF_ctor_rec(fun(B,C),aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),aa(fun(B,B),fun(B,D),aa(fun(B,D),fun(fun(B,B),fun(B,D)),comp(B,D,B),aa(fun(B,D),fun(B,D),aa(fun(D,D),fun(fun(B,D),fun(B,D)),comp(D,D,B),bNF_id_bnf(D)),Ga)),bNF_id_bnf(B)))) ) ).

% Basic_BNF_LFPs.ctor_rec_o_map
tff(fact_4663_Basic__BNF__LFPs_Octor__rec__def__alt,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] : ( Fa = basic_BNF_ctor_rec(fun(B,C),aa(fun(B,B),fun(B,C),aa(fun(B,C),fun(fun(B,B),fun(B,C)),comp(B,C,B),Fa),bNF_id_bnf(B))) ) ).

% Basic_BNF_LFPs.ctor_rec_def_alt
tff(fact_4664_snga__assn__raw_Oelims_I3_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X,Xa),Xb)
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ( ( array_get(B,H,X) = Xa )
                  & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(B,X)),bot_bot(set(nat))) )
                  & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X)),lim(product_unit,H)) ) ) ) ) ).

% snga_assn_raw.elims(3)
tff(fact_4665_relH__array,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: array(B)] :
          ( relH(As,H2,H4)
         => ( member(nat,addr_of_array(B,R3),As)
           => ( array_get(B,H2,R3) = array_get(B,H4,R3) ) ) ) ) ).

% relH_array
tff(fact_4666_ID_Opred__cong,axiom,
    ! [B: $tType,X: B,Ya: B,Pa: fun(B,$o),Paa: fun(B,$o)] :
      ( ( X = Ya )
     => ( ! [Z3: B] :
            ( member(B,Z3,aa(set(B),set(B),insert2(B,Ya),bot_bot(set(B))))
           => ( aa(B,$o,Pa,Z3)
            <=> aa(B,$o,Paa,Z3) ) )
       => ( aa(B,$o,aa(fun(B,$o),fun(B,$o),bNF_id_bnf(fun(B,$o)),Pa),X)
        <=> aa(B,$o,aa(fun(B,$o),fun(B,$o),bNF_id_bnf(fun(B,$o)),Paa),Ya) ) ) ) ).

% ID.pred_cong
tff(fact_4667_ID_Opred__mono__strong,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: B,Paa: fun(B,$o)] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),bNF_id_bnf(fun(B,$o)),Pa),X)
     => ( ! [Z3: B] :
            ( member(B,Z3,aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))
           => ( aa(B,$o,Pa,Z3)
             => aa(B,$o,Paa,Z3) ) )
       => aa(B,$o,aa(fun(B,$o),fun(B,$o),bNF_id_bnf(fun(B,$o)),Paa),X) ) ) ).

% ID.pred_mono_strong
tff(fact_4668_ID_Opred__set,axiom,
    ! [B: $tType,Pa: fun(B,$o),X3: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),bNF_id_bnf(fun(B,$o)),Pa),X3)
    <=> ! [Xa2: B] :
          ( member(B,Xa2,aa(set(B),set(B),insert2(B,X3),bot_bot(set(B))))
         => aa(B,$o,Pa,Xa2) ) ) ).

% ID.pred_set
tff(fact_4669_snga__assn__raw_Osimps,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: array(B),X: list(B),H2: heap_ext(product_unit),As: set(nat)] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,R3,X),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
        <=> ( ( array_get(B,H2,R3) = X )
            & ( As = aa(set(nat),set(nat),insert2(nat,addr_of_array(B,R3)),bot_bot(set(nat))) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,R3)),lim(product_unit,H2)) ) ) ) ).

% snga_assn_raw.simps
tff(fact_4670_snga__assn__raw_Oelims_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
          ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X,Xa),Xb)
          <=> (Y) )
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ( (Y)
                <=> ~ ( ( array_get(B,H,X) = Xa )
                      & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(B,X)),bot_bot(set(nat))) )
                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X)),lim(product_unit,H)) ) ) ) ) ) ).

% snga_assn_raw.elims(1)
tff(fact_4671_snga__assn__raw_Oelims_I2_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X,Xa),Xb)
         => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
               => ~ ( ( array_get(B,H,X) = Xa )
                    & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(B,X)),bot_bot(set(nat))) )
                    & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X)),lim(product_unit,H)) ) ) ) ) ).

% snga_assn_raw.elims(2)
tff(fact_4672_snga__assn__raw_Opelims_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
          ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X,Xa),Xb)
          <=> (Y) )
         => ( aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( ( (Y)
                    <=> ( ( array_get(B,H,X) = Xa )
                        & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(B,X)),bot_bot(set(nat))) )
                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X)),lim(product_unit,H)) ) )
                   => ~ aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)))) ) ) ) ) ) ).

% snga_assn_raw.pelims(1)
tff(fact_4673_snga__assn__raw_Opelims_I2_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X,Xa),Xb)
         => ( aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))
                   => ~ ( ( array_get(B,H,X) = Xa )
                        & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(B,X)),bot_bot(set(nat))) )
                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X)),lim(product_unit,H)) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(2)
tff(fact_4674_snga__assn__raw_Opelims_I3_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [X: array(B),Xa: list(B),Xb: product_prod(heap_ext(product_unit),set(nat))] :
          ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,snga_assn_raw(B,X,Xa),Xb)
         => ( aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),Xb)))
           => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
                  ( ( Xb = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
                 => ( aa(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),$o,accp(product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),snga_assn_raw_rel(B)),aa(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),aa(array(B),fun(product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),product_prod(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))))),product_Pair(array(B),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),X),aa(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat))),aa(list(B),fun(product_prod(heap_ext(product_unit),set(nat)),product_prod(list(B),product_prod(heap_ext(product_unit),set(nat)))),product_Pair(list(B),product_prod(heap_ext(product_unit),set(nat))),Xa),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))))
                   => ( ( array_get(B,H,X) = Xa )
                      & ( As2 = aa(set(nat),set(nat),insert2(nat,addr_of_array(B,X)),bot_bot(set(nat))) )
                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),addr_of_array(B,X)),lim(product_unit,H)) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(3)
tff(fact_4675_relH__set__array,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [R3: array(B),As: set(nat),H2: heap_ext(product_unit),X: list(B)] :
          ( ~ member(nat,addr_of_array(B,R3),As)
         => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
           => relH(As,H2,array_set(B,R3,X,H2)) ) ) ) ).

% relH_set_array
tff(fact_4676_ctor__rec__unique,axiom,
    ! [C: $tType,B: $tType,Ga: fun(B,B),Fa: fun(B,C),S: fun(B,C)] :
      ( ( Ga = id(B) )
     => ( ( aa(fun(B,B),fun(B,C),aa(fun(B,C),fun(fun(B,B),fun(B,C)),comp(B,C,B),Fa),basic_BNF_xtor(B)) = aa(fun(B,B),fun(B,C),aa(fun(B,C),fun(fun(B,B),fun(B,C)),comp(B,C,B),S),aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),bNF_id_bnf(B)),Ga)),bNF_id_bnf(B))) )
       => ( Fa = basic_BNF_ctor_rec(fun(B,C),S) ) ) ) ).

% ctor_rec_unique
tff(fact_4677_Basic__BNF__LFPs_Octor__rec,axiom,
    ! [C: $tType,B: $tType,Ga: fun(B,B),Fa: fun(B,C),X: B] :
      ( ( Ga = id(B) )
     => ( aa(B,C,basic_BNF_ctor_rec(fun(B,C),Fa),aa(B,B,basic_BNF_xtor(B),X)) = aa(B,C,Fa,aa(B,B,aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),bNF_id_bnf(B)),Ga)),bNF_id_bnf(B)),X)) ) ) ).

% Basic_BNF_LFPs.ctor_rec
tff(fact_4678_xtor__map__unique,axiom,
    ! [C: $tType,B: $tType,U: fun(B,C),Fa: fun(B,C)] :
      ( ( aa(fun(B,B),fun(B,C),aa(fun(B,C),fun(fun(B,B),fun(B,C)),comp(B,C,B),U),basic_BNF_xtor(B)) = aa(fun(B,C),fun(B,C),aa(fun(C,C),fun(fun(B,C),fun(B,C)),comp(C,C,B),basic_BNF_xtor(C)),Fa) )
     => ( U = Fa ) ) ).

% xtor_map_unique
tff(fact_4679_Basic__BNF__LFPs_OPair__def__alt,axiom,
    ! [B: $tType,C: $tType,X3: B,Xa3: C] : ( aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3) = aa(product_prod(B,C),product_prod(B,C),basic_BNF_xtor(product_prod(B,C)),aa(product_prod(B,C),product_prod(B,C),bNF_id_bnf(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X3),Xa3))) ) ).

% Basic_BNF_LFPs.Pair_def_alt
tff(fact_4680_freeze__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A3: array(B)] : ( array_freeze(B,A3) = heap_Time_heap(list(B),aTP_Lamp_rd(array(B),fun(heap_ext(product_unit),product_prod(list(B),product_prod(heap_ext(product_unit),nat))),A3)) ) ) ).

% freeze_def
tff(fact_4681_execute__freeze,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A3: array(B),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(list(B),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(list(B)),fun(heap_ext(product_unit),option(product_prod(list(B),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(list(B)),array_freeze(B,A3)),H2) = aa(product_prod(list(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(list(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(list(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(list(B),product_prod(heap_ext(product_unit),nat)),aa(list(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(list(B),product_prod(heap_ext(product_unit),nat))),product_Pair(list(B),product_prod(heap_ext(product_unit),nat)),array_get(B,H2,A3)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),array_length(B,H2,A3))))) ) ) ).

% execute_freeze
tff(fact_4682_subset__mset_OatLeastatMost__empty,axiom,
    ! [B: $tType,Ba: multiset(B),A3: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),Ba),A3)
     => ( set_atLeastAtMost(multiset(B),subseteq_mset(B),A3,Ba) = bot_bot(set(multiset(B))) ) ) ).

% subset_mset.atLeastatMost_empty
tff(fact_4683_subset__mset_OacyclicI__order,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,B)),Fa: fun(B,multiset(C))] :
      ( ! [A8: B,B4: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),B4),R3)
         => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subset_mset(C),aa(B,multiset(C),Fa,B4)),aa(B,multiset(C),Fa,A8)) )
     => transitive_acyclic(B,R3) ) ).

% subset_mset.acyclicI_order
tff(fact_4684_subset__implies__mult,axiom,
    ! [B: $tType,A4: multiset(B),B2: multiset(B),R3: set(product_prod(B,B))] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),A4),B2)
     => member(product_prod(multiset(B),multiset(B)),aa(multiset(B),product_prod(multiset(B),multiset(B)),aa(multiset(B),fun(multiset(B),product_prod(multiset(B),multiset(B))),product_Pair(multiset(B),multiset(B)),A4),B2),mult(B,R3)) ) ).

% subset_implies_mult
tff(fact_4685_subset__mset_OgreaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [B: $tType,A3: multiset(B),Ba: multiset(B)] : ( set_gr3752724095348155675AtMost(multiset(B),subseteq_mset(B),subset_mset(B),A3,Ba) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),set_atLeastAtMost(multiset(B),subseteq_mset(B),A3,Ba)),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),A3),bot_bot(set(multiset(B))))) ) ).

% subset_mset.greaterThanAtMost_eq_atLeastAtMost_diff
tff(fact_4686_subset__mset_OatLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [B: $tType,A3: multiset(B),Ba: multiset(B)] : ( set_atLeastLessThan(multiset(B),subseteq_mset(B),subset_mset(B),A3,Ba) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),minus_minus(set(multiset(B))),set_atLeastAtMost(multiset(B),subseteq_mset(B),A3,Ba)),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),Ba),bot_bot(set(multiset(B))))) ) ).

% subset_mset.atLeastLessThan_eq_atLeastAtMost_diff
tff(fact_4687_subset__mset_OgreaterThanLessThan__empty,axiom,
    ! [B: $tType,L: multiset(B),K: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),L),K)
     => ( set_gr287244882034783167ssThan(multiset(B),subset_mset(B),K,L) = bot_bot(set(multiset(B))) ) ) ).

% subset_mset.greaterThanLessThan_empty
tff(fact_4688_subset__mset_OatLeastLessThan__empty__iff2,axiom,
    ! [B: $tType,A3: multiset(B),Ba: multiset(B)] :
      ( ( bot_bot(set(multiset(B))) = set_atLeastLessThan(multiset(B),subseteq_mset(B),subset_mset(B),A3,Ba) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),A3),Ba) ) ).

% subset_mset.atLeastLessThan_empty_iff2
tff(fact_4689_subset__mset_OatLeastLessThan__empty__iff,axiom,
    ! [B: $tType,A3: multiset(B),Ba: multiset(B)] :
      ( ( set_atLeastLessThan(multiset(B),subseteq_mset(B),subset_mset(B),A3,Ba) = bot_bot(set(multiset(B))) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),A3),Ba) ) ).

% subset_mset.atLeastLessThan_empty_iff
tff(fact_4690_subset__mset_OatLeastLessThan__empty,axiom,
    ! [B: $tType,Ba: multiset(B),A3: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Ba),A3)
     => ( set_atLeastLessThan(multiset(B),subseteq_mset(B),subset_mset(B),A3,Ba) = bot_bot(set(multiset(B))) ) ) ).

% subset_mset.atLeastLessThan_empty
tff(fact_4691_subset__mset_OgreaterThanAtMost__empty__iff2,axiom,
    ! [B: $tType,K: multiset(B),L: multiset(B)] :
      ( ( bot_bot(set(multiset(B))) = set_gr3752724095348155675AtMost(multiset(B),subseteq_mset(B),subset_mset(B),K,L) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),K),L) ) ).

% subset_mset.greaterThanAtMost_empty_iff2
tff(fact_4692_subset__mset_OgreaterThanAtMost__empty__iff,axiom,
    ! [B: $tType,K: multiset(B),L: multiset(B)] :
      ( ( set_gr3752724095348155675AtMost(multiset(B),subseteq_mset(B),subset_mset(B),K,L) = bot_bot(set(multiset(B))) )
    <=> ~ aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),K),L) ) ).

% subset_mset.greaterThanAtMost_empty_iff
tff(fact_4693_subset__mset_OgreaterThanAtMost__empty,axiom,
    ! [B: $tType,L: multiset(B),K: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),L),K)
     => ( set_gr3752724095348155675AtMost(multiset(B),subseteq_mset(B),subset_mset(B),K,L) = bot_bot(set(multiset(B))) ) ) ).

% subset_mset.greaterThanAtMost_empty
tff(fact_4694_execute__len,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A3: array(B),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(nat,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(nat),fun(heap_ext(product_unit),option(product_prod(nat,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(nat),array_len(B,A3)),H2) = aa(product_prod(nat,product_prod(heap_ext(product_unit),nat)),option(product_prod(nat,product_prod(heap_ext(product_unit),nat))),some(product_prod(nat,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(nat,product_prod(heap_ext(product_unit),nat)),aa(nat,fun(product_prod(heap_ext(product_unit),nat),product_prod(nat,product_prod(heap_ext(product_unit),nat))),product_Pair(nat,product_prod(heap_ext(product_unit),nat)),array_length(B,H2,A3)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),one_one(nat)))) ) ) ).

% execute_len
tff(fact_4695_subset__mset_OIio__Int__singleton,axiom,
    ! [B: $tType,K: multiset(B),X: multiset(B)] :
      ( aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_lessThan(multiset(B),subset_mset(B),K)),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B)))))
      = $ite(aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subset_mset(B),X),K),aa(set(multiset(B)),set(multiset(B)),insert2(multiset(B),X),bot_bot(set(multiset(B)))),bot_bot(set(multiset(B)))) ) ).

% subset_mset.Iio_Int_singleton
tff(fact_4696_subset__mset_Osum__pos,axiom,
    ! [C: $tType,B: $tType,I4: set(B),Fa: fun(B,multiset(C))] :
      ( aa(set(B),$o,finite_finite(B),I4)
     => ( ( I4 != bot_bot(set(B)) )
       => ( ! [I3: B] :
              ( member(B,I3,I4)
             => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subset_mset(C),zero_zero(multiset(C))),aa(B,multiset(C),Fa,I3)) )
         => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subset_mset(C),zero_zero(multiset(C))),groups3894954378712506084id_sum(multiset(C),B,plus_plus(multiset(C)),zero_zero(multiset(C)),Fa,I4)) ) ) ) ).

% subset_mset.sum_pos
tff(fact_4697_subset__mset_Osum__strict__mono,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,multiset(C)),Ga: fun(B,multiset(C))] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( ( A4 != bot_bot(set(B)) )
       => ( ! [X2: B] :
              ( member(B,X2,A4)
             => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subset_mset(C),aa(B,multiset(C),Fa,X2)),aa(B,multiset(C),Ga,X2)) )
         => aa(multiset(C),$o,aa(multiset(C),fun(multiset(C),$o),subset_mset(C),groups3894954378712506084id_sum(multiset(C),B,plus_plus(multiset(C)),zero_zero(multiset(C)),Fa,A4)),groups3894954378712506084id_sum(multiset(C),B,plus_plus(multiset(C)),zero_zero(multiset(C)),Ga,A4)) ) ) ) ).

% subset_mset.sum_strict_mono
tff(fact_4698_subset__mset_OatLeastLessThan__def,axiom,
    ! [B: $tType,L: multiset(B),U: multiset(B)] : ( set_atLeastLessThan(multiset(B),subseteq_mset(B),subset_mset(B),L,U) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_atLeast(multiset(B),subseteq_mset(B),L)),set_lessThan(multiset(B),subset_mset(B),U)) ) ).

% subset_mset.atLeastLessThan_def
tff(fact_4699_subset__mset_OgreaterThanLessThan__eq,axiom,
    ! [B: $tType,A3: multiset(B),Ba: multiset(B)] : ( set_gr287244882034783167ssThan(multiset(B),subset_mset(B),A3,Ba) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_greaterThan(multiset(B),subset_mset(B),A3)),set_lessThan(multiset(B),subset_mset(B),Ba)) ) ).

% subset_mset.greaterThanLessThan_eq
tff(fact_4700_subset__mset_OgreaterThanLessThan__def,axiom,
    ! [B: $tType,L: multiset(B),U: multiset(B)] : ( set_gr287244882034783167ssThan(multiset(B),subset_mset(B),L,U) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_greaterThan(multiset(B),subset_mset(B),L)),set_lessThan(multiset(B),subset_mset(B),U)) ) ).

% subset_mset.greaterThanLessThan_def
tff(fact_4701_subset__mset_Onot__empty__eq__Ici__eq__empty,axiom,
    ! [B: $tType,L: multiset(B)] : ( bot_bot(set(multiset(B))) != set_atLeast(multiset(B),subseteq_mset(B),L) ) ).

% subset_mset.not_empty_eq_Ici_eq_empty
tff(fact_4702_ord_OgreaterThanLessThan__def,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o)),L: B,U: B] : ( set_gr287244882034783167ssThan(B,Less,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_greaterThan(B,Less,L)),set_lessThan(B,Less,U)) ) ).

% ord.greaterThanLessThan_def
tff(fact_4703_ord_OgreaterThanLessThan__eq,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o)),A3: B,Ba: B] : ( set_gr287244882034783167ssThan(B,Less,A3,Ba) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_greaterThan(B,Less,A3)),set_lessThan(B,Less,Ba)) ) ).

% ord.greaterThanLessThan_eq
tff(fact_4704_ord_OatLeastLessThan__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),L: B,U: B] : ( set_atLeastLessThan(B,Less_eq,Less,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_atLeast(B,Less_eq,L)),set_lessThan(B,Less,U)) ) ).

% ord.atLeastLessThan_def
tff(fact_4705_subset__mset_OgreaterThanAtMost__def,axiom,
    ! [B: $tType,L: multiset(B),U: multiset(B)] : ( set_gr3752724095348155675AtMost(multiset(B),subseteq_mset(B),subset_mset(B),L,U) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_greaterThan(multiset(B),subset_mset(B),L)),set_atMost(multiset(B),subseteq_mset(B),U)) ) ).

% subset_mset.greaterThanAtMost_def
tff(fact_4706_ord_OgreaterThanAtMost__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),L: B,U: B] : ( set_gr3752724095348155675AtMost(B,Less_eq,Less,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_greaterThan(B,Less,L)),set_atMost(B,Less_eq,U)) ) ).

% ord.greaterThanAtMost_def
tff(fact_4707_ord_OatLeastAtMost__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),L: B,U: B] : ( set_atLeastAtMost(B,Less_eq,L,U) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),set_atLeast(B,Less_eq,L)),set_atMost(B,Less_eq,U)) ) ).

% ord.atLeastAtMost_def
tff(fact_4708_subset__mset_Onot__empty__eq__Iic__eq__empty,axiom,
    ! [B: $tType,H2: multiset(B)] : ( bot_bot(set(multiset(B))) != set_atMost(multiset(B),subseteq_mset(B),H2) ) ).

% subset_mset.not_empty_eq_Iic_eq_empty
tff(fact_4709_subset__mset_OatLeastAtMost__def,axiom,
    ! [B: $tType,L: multiset(B),U: multiset(B)] : ( set_atLeastAtMost(multiset(B),subseteq_mset(B),L,U) = aa(set(multiset(B)),set(multiset(B)),aa(set(multiset(B)),fun(set(multiset(B)),set(multiset(B))),inf_inf(set(multiset(B))),set_atLeast(multiset(B),subseteq_mset(B),L)),set_atMost(multiset(B),subseteq_mset(B),U)) ) ).

% subset_mset.atLeastAtMost_def
tff(fact_4710_execute__nth_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I: nat,H2: heap_ext(product_unit),A3: array(B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),array_length(B,H2,A3))
         => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),aa(nat,heap_Time_Heap(B),array_nth(B,A3),I)),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),nth(B,array_get(B,H2,A3),I)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),H2),one_one(nat)))) ) ) ) ).

% execute_nth(1)
tff(fact_4711_length__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A3: array(B),Xs: list(B)] : hoare_hoare_triple(nat,snga_assn(B,A3,Xs),array_len(B,A3),aa(list(B),fun(nat,assn),aTP_Lamp_re(array(B),fun(list(B),fun(nat,assn)),A3),Xs)) ) ).

% length_rule
tff(fact_4712_Array__Time_Onth__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A3: array(B),I: nat] : ( aa(nat,heap_Time_Heap(B),array_nth(B,A3),I) = heap_Time_guard(B,aa(nat,fun(heap_ext(product_unit),$o),aTP_Lamp_rf(array(B),fun(nat,fun(heap_ext(product_unit),$o)),A3),I),aa(nat,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rg(array(B),fun(nat,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))),A3),I)) ) ) ).

% Array_Time.nth_def
tff(fact_4713_nth__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I: nat,Xs: list(B),A3: array(B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),size_size(list(B),Xs))
         => hoare_hoare_triple(B,snga_assn(B,A3,Xs),aa(nat,heap_Time_Heap(B),array_nth(B,A3),I),aa(array(B),fun(B,assn),aa(list(B),fun(array(B),fun(B,assn)),aTP_Lamp_rh(nat,fun(list(B),fun(array(B),fun(B,assn))),I),Xs),A3)) ) ) ).

% nth_rule
tff(fact_4714_nth__step__trancl,axiom,
    ! [B: $tType,Xs: list(B),R: set(product_prod(B,B)),N: nat,M4: nat] :
      ( ! [N3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),size_size(list(B),Xs)),one_one(nat)))
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),nth(B,Xs,aa(nat,nat,suc,N3))),nth(B,Xs,N3)),R) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),size_size(list(B),Xs))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),N)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),nth(B,Xs,N)),nth(B,Xs,M4)),transitive_trancl(B,R)) ) ) ) ).

% nth_step_trancl
tff(fact_4715_product__nth,axiom,
    ! [B: $tType,C: $tType,N: nat,Xs: list(B),Ys: list(C)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),size_size(list(B),Xs)),size_size(list(C),Ys)))
     => ( nth(product_prod(B,C),product(B,C,Xs,Ys),N) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),nth(B,Xs,divide_divide(nat,N,size_size(list(C),Ys)))),nth(C,Ys,modulo_modulo(nat,N,size_size(list(C),Ys)))) ) ) ).

% product_nth
tff(fact_4716_mergesort__by__rel__split__length,axiom,
    ! [B: $tType,Xs1: list(B),Xs2: list(B),Xs: list(B)] :
      ( ( size_size(list(B),aa(product_prod(list(B),list(B)),list(B),product_fst(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs1),Xs2),Xs))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_size(list(B),Xs1)),divide_divide(nat,size_size(list(B),Xs),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))),modulo_modulo(nat,size_size(list(B),Xs),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) )
      & ( size_size(list(B),aa(product_prod(list(B),list(B)),list(B),product_snd(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs1),Xs2),Xs))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_size(list(B),Xs2)),divide_divide(nat,size_size(list(B),Xs),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% mergesort_by_rel_split_length
tff(fact_4717_execute__swap_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I: nat,H2: heap_ext(product_unit),A3: array(B),X: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),array_length(B,H2,A3))
         => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),array_swap(B,I,X,A3)),H2) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),nth(B,array_get(B,H2,A3),I)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(B,A3,I,X,H2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ).

% execute_swap(1)
tff(fact_4718_swap__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I: nat,X: B,A3: array(B)] : ( array_swap(B,I,X,A3) = heap_Time_guard(B,aa(array(B),fun(heap_ext(product_unit),$o),aTP_Lamp_ri(nat,fun(array(B),fun(heap_ext(product_unit),$o)),I),A3),aa(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(B,fun(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_rj(nat,fun(B,fun(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))))),I),X),A3)) ) ) ).

% swap_def
tff(fact_4719_map__entry__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I: nat,Fa: fun(B,B),A3: array(B)] : ( array_map_entry(B,I,Fa,A3) = heap_Time_guard(array(B),aa(array(B),fun(heap_ext(product_unit),$o),aTP_Lamp_ri(nat,fun(array(B),fun(heap_ext(product_unit),$o)),I),A3),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(fun(B,B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_rk(nat,fun(fun(B,B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))))),I),Fa),A3)) ) ) ).

% map_entry_def
tff(fact_4720_execute__map__entry_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I: nat,H2: heap_ext(product_unit),A3: array(B),Fa: fun(B,B)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),array_length(B,H2,A3))
         => ( aa(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(array(B)),fun(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(array(B)),array_map_entry(B,I,Fa,A3)),H2) = aa(product_prod(array(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_Pair(array(B),product_prod(heap_ext(product_unit),nat)),A3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(B,A3,I,aa(B,B,Fa,nth(B,array_get(B,H2,A3),I)),H2)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))))) ) ) ) ).

% execute_map_entry(1)
tff(fact_4721_mergesort__by__rel__split_Osimps_I1_J,axiom,
    ! [B: $tType,Xs1: list(B),Xs2: list(B)] : ( merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs1),Xs2),nil(B)) = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs1),Xs2) ) ).

% mergesort_by_rel_split.simps(1)
tff(fact_4722_execute__upd_I1_J,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I: nat,H2: heap_ext(product_unit),A3: array(B),X: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),array_length(B,H2,A3))
         => ( aa(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(array(B)),fun(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(array(B)),array_upd(B,I,X,A3)),H2) = aa(product_prod(array(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_Pair(array(B),product_prod(heap_ext(product_unit),nat)),A3),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(B,A3,I,X,H2)),one_one(nat)))) ) ) ) ).

% execute_upd(1)
tff(fact_4723_upd__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I: nat,X: B,A3: array(B)] : ( array_upd(B,I,X,A3) = heap_Time_guard(array(B),aa(array(B),fun(heap_ext(product_unit),$o),aTP_Lamp_ri(nat,fun(array(B),fun(heap_ext(product_unit),$o)),I),A3),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(B,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_rl(nat,fun(B,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))))),I),X),A3)) ) ) ).

% upd_def
tff(fact_4724_execute__of__list,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Xs: list(B),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(array(B)),fun(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(array(B)),array_of_list(B,Xs)),H2) = aa(product_prod(array(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rm(list(B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Xs)),array_alloc(B,Xs,H2))) ) ) ).

% execute_of_list
tff(fact_4725_effect__of__listI,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A3: array(B),H4: heap_ext(product_unit),Xs: list(B),H2: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),product_prod(array(B),heap_ext(product_unit)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),heap_ext(product_unit))),product_Pair(array(B),heap_ext(product_unit)),A3),H4) = array_alloc(B,Xs,H2) )
         => heap_Time_effect(array(B),array_of_list(B,Xs),H2,H4,A3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),size_size(list(B),Xs))) ) ) ).

% effect_of_listI
tff(fact_4726_of__list__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Xs: list(B)] : ( array_of_list(B,Xs) = heap_Time_heap(array(B),aTP_Lamp_rn(list(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),Xs)) ) ) ).

% of_list_def
tff(fact_4727_Array__Time_Oalloc__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Xs: list(B),H2: heap_ext(product_unit)] :
          ( array_alloc(B,Xs,H2)
          = $let(
              l: nat,
              l := lim(product_unit,H2),
              $let(
                r: array(B),
                r := array2(B,l),
                aa(heap_ext(product_unit),product_prod(array(B),heap_ext(product_unit)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),heap_ext(product_unit))),product_Pair(array(B),heap_ext(product_unit)),r),array_set(B,r,Xs,lim_update(product_unit,aTP_Lamp_mw(nat,fun(nat,nat),l),H2))) ) ) ) ) ).

% Array_Time.alloc_def
tff(fact_4728_upd__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [I: nat,Xs: list(B),A3: array(B),X: B] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),size_size(list(B),Xs))
         => hoare_hoare_triple(array(B),snga_assn(B,A3,Xs),array_upd(B,I,X,A3),aa(B,fun(array(B),assn),aa(array(B),fun(B,fun(array(B),assn)),aa(list(B),fun(array(B),fun(B,fun(array(B),assn))),aTP_Lamp_ro(nat,fun(list(B),fun(array(B),fun(B,fun(array(B),assn)))),I),Xs),A3),X)) ) ) ).

% upd_rule
tff(fact_4729_horner__sum__eq__sum__funpow,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_0(B)
     => ! [Fa: fun(C,B),A3: B,Xs: list(C)] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),Fa),A3),Xs) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(list(C),fun(nat,B),aa(B,fun(list(C),fun(nat,B)),aTP_Lamp_rp(fun(C,B),fun(B,fun(list(C),fun(nat,B))),Fa),A3),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),size_size(list(C),Xs))) ) ) ).

% horner_sum_eq_sum_funpow
tff(fact_4730_horner__sum__eq__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_1(B)
     => ! [Fa: fun(C,B),A3: B,Xs: list(C)] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),Fa),A3),Xs) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups7311177749621191930dd_sum(nat,B),aa(list(C),fun(nat,B),aa(B,fun(list(C),fun(nat,B)),aTP_Lamp_rq(fun(C,B),fun(B,fun(list(C),fun(nat,B))),Fa),A3),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),size_size(list(C),Xs))) ) ) ).

% horner_sum_eq_sum
tff(fact_4731_nth__enumerate__eq,axiom,
    ! [B: $tType,M4: nat,Xs: list(B),N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M4),size_size(list(B),Xs))
     => ( nth(product_prod(nat,B),enumerate(B,N,Xs),M4) = aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M4)),nth(B,Xs,M4)) ) ) ).

% nth_enumerate_eq
tff(fact_4732_mergesort__by__rel_Opinduct,axiom,
    ! [B: $tType,A0: fun(B,fun(B,$o)),A1: list(B),Pa: fun(fun(B,fun(B,$o)),fun(list(B),$o))] :
      ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),mergesort_by_rel_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),A0),A1))
     => ( ! [R13: fun(B,fun(B,$o)),Xs3: list(B)] :
            ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),mergesort_by_rel_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),R13),Xs3))
           => ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),size_size(list(B),Xs3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))
               => aa(list(B),$o,aa(fun(B,fun(B,$o)),fun(list(B),$o),Pa,R13),aa(product_prod(list(B),list(B)),list(B),product_fst(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs3))) )
             => ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),size_size(list(B),Xs3)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))
                 => aa(list(B),$o,aa(fun(B,fun(B,$o)),fun(list(B),$o),Pa,R13),aa(product_prod(list(B),list(B)),list(B),product_snd(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs3))) )
               => aa(list(B),$o,aa(fun(B,fun(B,$o)),fun(list(B),$o),Pa,R13),Xs3) ) ) )
       => aa(list(B),$o,aa(fun(B,fun(B,$o)),fun(list(B),$o),Pa,A0),A1) ) ) ).

% mergesort_by_rel.pinduct
tff(fact_4733_mergesort__by__rel_Oelims,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B),Y: list(B)] :
      ( ( mergesort_by_rel(B,X,Xa) = Y )
     => ( Y
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),size_size(list(B),Xa)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Xa,merges9089515139780605204_merge(B,X,mergesort_by_rel(B,X,aa(product_prod(list(B),list(B)),list(B),product_fst(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xa))),mergesort_by_rel(B,X,aa(product_prod(list(B),list(B)),list(B),product_snd(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xa))))) ) ) ).

% mergesort_by_rel.elims
tff(fact_4734_mergesort__by__rel_Ocases,axiom,
    ! [B: $tType,X: product_prod(fun(B,fun(B,$o)),list(B))] :
      ~ ! [R13: fun(B,fun(B,$o)),Xs3: list(B)] : ( X != aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),R13),Xs3) ) ).

% mergesort_by_rel.cases
tff(fact_4735_mergesort__by__rel_Opsimps,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),Xs: list(B)] :
      ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),mergesort_by_rel_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),R),Xs))
     => ( mergesort_by_rel(B,R,Xs)
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),size_size(list(B),Xs)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Xs,merges9089515139780605204_merge(B,R,mergesort_by_rel(B,R,aa(product_prod(list(B),list(B)),list(B),product_fst(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs))),mergesort_by_rel(B,R,aa(product_prod(list(B),list(B)),list(B),product_snd(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs))))) ) ) ).

% mergesort_by_rel.psimps
tff(fact_4736_mergesort__by__rel_Opelims,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B),Y: list(B)] :
      ( ( mergesort_by_rel(B,X,Xa) = Y )
     => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),mergesort_by_rel_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),Xa))
       => ~ ( ( Y
              = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),size_size(list(B),Xa)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Xa,merges9089515139780605204_merge(B,X,mergesort_by_rel(B,X,aa(product_prod(list(B),list(B)),list(B),product_fst(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xa))),mergesort_by_rel(B,X,aa(product_prod(list(B),list(B)),list(B),product_snd(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xa))))) )
           => ~ aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),mergesort_by_rel_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),Xa)) ) ) ) ).

% mergesort_by_rel.pelims
tff(fact_4737_mergesort__by__rel_Osimps,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),Xs: list(B)] :
      ( mergesort_by_rel(B,R,Xs)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),size_size(list(B),Xs)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Xs,merges9089515139780605204_merge(B,R,mergesort_by_rel(B,R,aa(product_prod(list(B),list(B)),list(B),product_fst(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs))),mergesort_by_rel(B,R,aa(product_prod(list(B),list(B)),list(B),product_snd(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs))))) ) ).

% mergesort_by_rel.simps
tff(fact_4738_mergesort__by__rel__simps_I3_J,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),X1: B,X22: B,Xs: list(B)] : ( mergesort_by_rel(B,R,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X1),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X22),Xs))) = aa(product_prod(list(B),list(B)),list(B),aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aTP_Lamp_rr(fun(B,fun(B,$o)),fun(list(B),fun(list(B),list(B))),R)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X1),nil(B))),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X22),nil(B))),Xs)) ) ).

% mergesort_by_rel_simps(3)
tff(fact_4739_execute__new,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,X: B,H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(array(B)),fun(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(array(B)),aa(B,heap_Time_Heap(array(B)),aa(nat,fun(B,heap_Time_Heap(array(B))),array_new(B),N),X)),H2) = aa(product_prod(array(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rs(nat,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),N)),array_alloc(B,replicate(B,N,X),H2))) ) ) ).

% execute_new
tff(fact_4740_listrel1__iff__update,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel1(B,R3))
    <=> ? [Y3: B,N5: nat] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),nth(B,Xs,N5)),Y3),R3)
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N5),size_size(list(B),Xs))
          & ( Ys = list_update(B,Xs,N5,Y3) ) ) ) ).

% listrel1_iff_update
tff(fact_4741_Cons__listrel1__Cons,axiom,
    ! [B: $tType,X: B,Xs: list(B),Y: B,Ys: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)),listrel1(B,R3))
    <=> ( ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
          & ( Xs = Ys ) )
        | ( ( X = Y )
          & member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel1(B,R3)) ) ) ) ).

% Cons_listrel1_Cons
tff(fact_4742_horner__sum__simps_I2_J,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_0(B)
     => ! [Fa: fun(C,B),A3: B,X: C,Xs: list(C)] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),Fa),A3),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),X),Xs)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(C,B,Fa,X)),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),Fa),A3),Xs))) ) ) ).

% horner_sum_simps(2)
tff(fact_4743_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs: list(B)] : ( enumerate(B,N,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)) = aa(list(product_prod(nat,B)),list(product_prod(nat,B)),aa(product_prod(nat,B),fun(list(product_prod(nat,B)),list(product_prod(nat,B))),cons(product_prod(nat,B)),aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),N),X)),enumerate(B,aa(nat,nat,suc,N),Xs)) ) ).

% enumerate_simps(2)
tff(fact_4744_listrel1I1,axiom,
    ! [B: $tType,X: B,Y: B,R3: set(product_prod(B,B)),Xs: list(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
     => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Xs)),listrel1(B,R3)) ) ).

% listrel1I1
tff(fact_4745_listrel1I2,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B)),X: B] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel1(B,R3))
     => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Ys)),listrel1(B,R3)) ) ).

% listrel1I2
tff(fact_4746_Cons__listrel1E1,axiom,
    ! [B: $tType,X: B,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),Ys),listrel1(B,R3))
     => ( ! [Y2: B] :
            ( ( Ys = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs) )
           => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y2),R3) )
       => ~ ! [Zs: list(B)] :
              ( ( Ys = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Zs) )
             => ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Zs),listrel1(B,R3)) ) ) ) ).

% Cons_listrel1E1
tff(fact_4747_Cons__listrel1E2,axiom,
    ! [B: $tType,Xs: list(B),Y: B,Ys: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)),listrel1(B,R3))
     => ( ! [X2: B] :
            ( ( Xs = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Ys) )
           => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y),R3) )
       => ~ ! [Zs: list(B)] :
              ( ( Xs = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Zs) )
             => ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Zs),Ys),listrel1(B,R3)) ) ) ) ).

% Cons_listrel1E2
tff(fact_4748_rtrancl__listrel1__ConsI2,axiom,
    ! [B: $tType,X: B,Y: B,R3: set(product_prod(B,B)),Xs: list(B),Ys: list(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,R3))
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),transitive_rtrancl(list(B),listrel1(B,R3)))
       => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)),transitive_rtrancl(list(B),listrel1(B,R3))) ) ) ).

% rtrancl_listrel1_ConsI2
tff(fact_4749_rtrancl__listrel1__ConsI1,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B)),X: B] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),transitive_rtrancl(list(B),listrel1(B,R3)))
     => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Ys)),transitive_rtrancl(list(B),listrel1(B,R3))) ) ).

% rtrancl_listrel1_ConsI1
tff(fact_4750_zipf_Ocases,axiom,
    ! [D: $tType,B: $tType,C: $tType,X: product_prod(fun(B,fun(C,D)),product_prod(list(B),list(C)))] :
      ( ! [F8: fun(B,fun(C,D))] : ( X != aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,D)),product_prod(list(B),list(C))),aa(fun(B,fun(C,D)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,D)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,D)),product_prod(list(B),list(C))),F8),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),nil(C))) )
     => ( ! [F8: fun(B,fun(C,D)),A8: B,As2: list(B),B4: C,Bs2: list(C)] : ( X != aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,D)),product_prod(list(B),list(C))),aa(fun(B,fun(C,D)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,D)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,D)),product_prod(list(B),list(C))),F8),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),B4),Bs2))) )
       => ( ! [A8: fun(B,fun(C,D)),V3: B,Va: list(B)] : ( X != aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,D)),product_prod(list(B),list(C))),aa(fun(B,fun(C,D)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,D)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,D)),product_prod(list(B),list(C))),A8),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va)),nil(C))) )
         => ~ ! [A8: fun(B,fun(C,D)),V3: C,Va: list(C)] : ( X != aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,D)),product_prod(list(B),list(C))),aa(fun(B,fun(C,D)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,D)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,D)),product_prod(list(B),list(C))),A8),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),V3),Va))) ) ) ) ) ).

% zipf.cases
tff(fact_4751_merge_Ocases,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: product_prod(list(B),list(B))] :
          ( ! [L22: list(B)] : ( X != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),L22) )
         => ( ! [V3: B,Va: list(B)] : ( X != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va)),nil(B)) )
           => ~ ! [X12: B,L12: list(B),X23: B,L22: list(B)] : ( X != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),L12)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),L22)) ) ) ) ) ).

% merge.cases
tff(fact_4752_list__all__zip_Ocases,axiom,
    ! [B: $tType,C: $tType,X: product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))] :
      ( ! [P4: fun(B,fun(C,$o))] : ( X != aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),P4),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),nil(C))) )
     => ( ! [P4: fun(B,fun(C,$o)),A8: B,As2: list(B),B4: C,Bs2: list(C)] : ( X != aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),P4),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),B4),Bs2))) )
       => ( ! [P4: fun(B,fun(C,$o)),V3: B,Va: list(B)] : ( X != aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),P4),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va)),nil(C))) )
         => ~ ! [P4: fun(B,fun(C,$o)),V3: C,Va: list(C)] : ( X != aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),P4),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),V3),Va))) ) ) ) ) ).

% list_all_zip.cases
tff(fact_4753_partition__rev_Ocases,axiom,
    ! [B: $tType,X: product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B)))] :
      ( ! [P4: fun(B,$o),Yes: list(B),No: list(B)] : ( X != aa(product_prod(product_prod(list(B),list(B)),list(B)),product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),aa(fun(B,$o),fun(product_prod(product_prod(list(B),list(B)),list(B)),product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B)))),product_Pair(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),P4),aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),No)),nil(B))) )
     => ~ ! [P4: fun(B,$o),Yes: list(B),No: list(B),X2: B,Xs3: list(B)] : ( X != aa(product_prod(product_prod(list(B),list(B)),list(B)),product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),aa(fun(B,$o),fun(product_prod(product_prod(list(B),list(B)),list(B)),product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B)))),product_Pair(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),P4),aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),No)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3))) ) ) ).

% partition_rev.cases
tff(fact_4754_quicksort__by__rel_Ocases,axiom,
    ! [B: $tType,X: product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))] :
      ( ! [R13: fun(B,fun(B,$o)),Sl: list(B)] : ( X != aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R13),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Sl),nil(B))) )
     => ~ ! [R13: fun(B,fun(B,$o)),Sl: list(B),X2: B,Xs3: list(B)] : ( X != aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R13),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Sl),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3))) ) ) ).

% quicksort_by_rel.cases
tff(fact_4755_mergesort__by__rel__merge_Ocases,axiom,
    ! [B: $tType,X: product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))] :
      ( ! [R13: fun(B,fun(B,$o)),X2: B,Xs3: list(B),Y2: B,Ys2: list(B)] : ( X != aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R13),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2))) )
     => ( ! [R13: fun(B,fun(B,$o)),Xs3: list(B)] : ( X != aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R13),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs3),nil(B))) )
       => ~ ! [R13: fun(B,fun(B,$o)),V3: B,Va: list(B)] : ( X != aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R13),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va))) ) ) ) ).

% mergesort_by_rel_merge.cases
tff(fact_4756_mergesort__by__rel__split_Ocases,axiom,
    ! [B: $tType,X: product_prod(product_prod(list(B),list(B)),list(B))] :
      ( ! [Xs12: list(B),Xs22: list(B)] : ( X != aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22)),nil(B)) )
     => ( ! [Xs12: list(B),Xs22: list(B),X2: B] : ( X != aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B))) )
       => ~ ! [Xs12: list(B),Xs22: list(B),X12: B,X23: B,Xs3: list(B)] : ( X != aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),Xs3))) ) ) ) ).

% mergesort_by_rel_split.cases
tff(fact_4757_map__tailrec__rev_Ocases,axiom,
    ! [B: $tType,C: $tType,X: product_prod(fun(B,C),product_prod(list(B),list(C)))] :
      ( ! [F8: fun(B,C),Bs2: list(C)] : ( X != aa(product_prod(list(B),list(C)),product_prod(fun(B,C),product_prod(list(B),list(C))),aa(fun(B,C),fun(product_prod(list(B),list(C)),product_prod(fun(B,C),product_prod(list(B),list(C)))),product_Pair(fun(B,C),product_prod(list(B),list(C))),F8),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),Bs2)) )
     => ~ ! [F8: fun(B,C),A8: B,As2: list(B),Bs2: list(C)] : ( X != aa(product_prod(list(B),list(C)),product_prod(fun(B,C),product_prod(list(B),list(C))),aa(fun(B,C),fun(product_prod(list(B),list(C)),product_prod(fun(B,C),product_prod(list(B),list(C)))),product_Pair(fun(B,C),product_prod(list(B),list(C))),F8),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2)),Bs2)) ) ) ).

% map_tailrec_rev.cases
tff(fact_4758_shuffles_Ocases,axiom,
    ! [B: $tType,X: product_prod(list(B),list(B))] :
      ( ! [Ys2: list(B)] : ( X != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Ys2) )
     => ( ! [Xs3: list(B)] : ( X != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs3),nil(B)) )
       => ~ ! [X2: B,Xs3: list(B),Y2: B,Ys2: list(B)] : ( X != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2)) ) ) ) ).

% shuffles.cases
tff(fact_4759_subset__eq__mset__impl_Ocases,axiom,
    ! [B: $tType,X: product_prod(list(B),list(B))] :
      ( ! [Ys2: list(B)] : ( X != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Ys2) )
     => ~ ! [X2: B,Xs3: list(B),Ys2: list(B)] : ( X != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),Ys2) ) ) ).

% subset_eq_mset_impl.cases
tff(fact_4760_arg__min__list_Ocases,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [X: product_prod(fun(B,C),list(B))] :
          ( ! [F8: fun(B,C),X2: B] : ( X != aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),F8),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B))) )
         => ( ! [F8: fun(B,C),X2: B,Y2: B,Zs: list(B)] : ( X != aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),F8),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Zs))) )
           => ~ ! [A8: fun(B,C)] : ( X != aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),A8),nil(B)) ) ) ) ) ).

% arg_min_list.cases
tff(fact_4761_successively_Ocases,axiom,
    ! [B: $tType,X: product_prod(fun(B,fun(B,$o)),list(B))] :
      ( ! [P4: fun(B,fun(B,$o))] : ( X != aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),P4),nil(B)) )
     => ( ! [P4: fun(B,fun(B,$o)),X2: B] : ( X != aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),P4),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B))) )
       => ~ ! [P4: fun(B,fun(B,$o)),X2: B,Y2: B,Xs3: list(B)] : ( X != aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),P4),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs3))) ) ) ) ).

% successively.cases
tff(fact_4762_sorted__wrt_Ocases,axiom,
    ! [B: $tType,X: product_prod(fun(B,fun(B,$o)),list(B))] :
      ( ! [P4: fun(B,fun(B,$o))] : ( X != aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),P4),nil(B)) )
     => ~ ! [P4: fun(B,fun(B,$o)),X2: B,Ys2: list(B)] : ( X != aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),P4),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Ys2)) ) ) ).

% sorted_wrt.cases
tff(fact_4763_not__listrel1__Nil,axiom,
    ! [B: $tType,Xs: list(B),R3: set(product_prod(B,B))] : ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),nil(B)),listrel1(B,R3)) ).

% not_listrel1_Nil
tff(fact_4764_not__Nil__listrel1,axiom,
    ! [B: $tType,Xs: list(B),R3: set(product_prod(B,B))] : ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Xs),listrel1(B,R3)) ).

% not_Nil_listrel1
tff(fact_4765_rtrancl__listrel1__eq__len,axiom,
    ! [B: $tType,X: list(B),Y: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Y),transitive_rtrancl(list(B),listrel1(B,R3)))
     => ( size_size(list(B),X) = size_size(list(B),Y) ) ) ).

% rtrancl_listrel1_eq_len
tff(fact_4766_listrel1__eq__len,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel1(B,R3))
     => ( size_size(list(B),Xs) = size_size(list(B),Ys) ) ) ).

% listrel1_eq_len
tff(fact_4767_mergesort__by__rel__split_Osimps_I3_J,axiom,
    ! [B: $tType,Xs1: list(B),Xs2: list(B),X1: B,X22: B,Xs: list(B)] : ( merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs1),Xs2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X1),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X22),Xs))) = merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X1),Xs1)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X22),Xs2)),Xs) ) ).

% mergesort_by_rel_split.simps(3)
tff(fact_4768_in__listrel1__converse,axiom,
    ! [B: $tType,X: list(B),Y: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Y),listrel1(B,converse(B,B,R3)))
    <=> member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Y),converse(list(B),list(B),listrel1(B,R3))) ) ).

% in_listrel1_converse
tff(fact_4769_new__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,X: B] : hoare_hoare_triple(array(B),one_one(assn),aa(B,heap_Time_Heap(array(B)),aa(nat,fun(B,heap_Time_Heap(array(B))),array_new(B),N),X),aa(B,fun(array(B),assn),aTP_Lamp_rt(nat,fun(B,fun(array(B),assn)),N),X)) ) ).

% new_rule
tff(fact_4770_mergesort__by__rel__split_Osimps_I2_J,axiom,
    ! [B: $tType,Xs1: list(B),Xs2: list(B),X: B] : ( merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs1),Xs2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),nil(B))) = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs1)),Xs2) ) ).

% mergesort_by_rel_split.simps(2)
tff(fact_4771_mergesort__by__rel__split_Oelims,axiom,
    ! [B: $tType,X: product_prod(list(B),list(B)),Xa: list(B),Y: product_prod(list(B),list(B))] :
      ( ( merges295452479951948502_split(B,X,Xa) = Y )
     => ( ! [Xs12: list(B),Xs22: list(B)] :
            ( ( X = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22) )
           => ( ( Xa = nil(B) )
             => ( Y != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22) ) ) )
       => ( ! [Xs12: list(B),Xs22: list(B)] :
              ( ( X = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22) )
             => ! [X2: B] :
                  ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)) )
                 => ( Y != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs12)),Xs22) ) ) )
         => ~ ! [Xs12: list(B),Xs22: list(B)] :
                ( ( X = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22) )
               => ! [X12: B,X23: B,Xs3: list(B)] :
                    ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),Xs3)) )
                   => ( Y != merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),Xs12)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),Xs22)),Xs3) ) ) ) ) ) ) ).

% mergesort_by_rel_split.elims
tff(fact_4772_effect__newI,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A3: array(B),H4: heap_ext(product_unit),N: nat,X: B,H2: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),product_prod(array(B),heap_ext(product_unit)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),heap_ext(product_unit))),product_Pair(array(B),heap_ext(product_unit)),A3),H4) = array_alloc(B,replicate(B,N,X),H2) )
         => heap_Time_effect(array(B),aa(B,heap_Time_Heap(array(B)),aa(nat,fun(B,heap_Time_Heap(array(B))),array_new(B),N),X),H2,H4,A3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) ) ).

% effect_newI
tff(fact_4773_new__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,X: B] : ( aa(B,heap_Time_Heap(array(B)),aa(nat,fun(B,heap_Time_Heap(array(B))),array_new(B),N),X) = heap_Time_heap(array(B),aa(B,fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_ru(nat,fun(B,fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),N),X)) ) ) ).

% new_def
tff(fact_4774_listrel1p__def,axiom,
    ! [B: $tType,R3: fun(B,fun(B,$o)),Xs: list(B),Ys: list(B)] :
      ( listrel1p(B,R3,Xs,Ys)
    <=> member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel1(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R3)))) ) ).

% listrel1p_def
tff(fact_4775_mergesort__by__rel__merge_Opelims,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B),Xb: list(B),Y: list(B)] :
      ( ( merges9089515139780605204_merge(B,X,Xa,Xb) = Y )
     => ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),merges2244889521215249637ge_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xa),Xb)))
       => ( ! [X2: B,Xs3: list(B)] :
              ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
             => ! [Y2: B,Ys2: list(B)] :
                  ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2) )
                 => ( ( Y
                      = $ite(aa(B,$o,aa(B,fun(B,$o),X,X2),Y2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),merges9089515139780605204_merge(B,X,Xs3,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2))),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),merges9089515139780605204_merge(B,X,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3),Ys2))) )
                   => ~ aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),merges2244889521215249637ge_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2)))) ) ) )
         => ( ( ( Xb = nil(B) )
             => ( ( Y = Xa )
               => ~ aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),merges2244889521215249637ge_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xa),nil(B)))) ) )
           => ~ ( ( Xa = nil(B) )
               => ! [V3: B,Va: list(B)] :
                    ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va) )
                   => ( ( Y = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va) )
                     => ~ aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),merges2244889521215249637ge_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va)))) ) ) ) ) ) ) ) ).

% mergesort_by_rel_merge.pelims
tff(fact_4776_lexn_Osimps_I2_J,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),N: nat] : ( lexn(B,R3,aa(nat,nat,suc,N)) = aa(set(product_prod(list(B),list(B))),set(product_prod(list(B),list(B))),aa(set(product_prod(list(B),list(B))),fun(set(product_prod(list(B),list(B))),set(product_prod(list(B),list(B)))),inf_inf(set(product_prod(list(B),list(B)))),aa(set(product_prod(product_prod(B,list(B)),product_prod(B,list(B)))),set(product_prod(list(B),list(B))),image2(product_prod(product_prod(B,list(B)),product_prod(B,list(B))),product_prod(list(B),list(B)),product_map_prod(product_prod(B,list(B)),list(B),product_prod(B,list(B)),list(B),aa(fun(B,fun(list(B),list(B))),fun(product_prod(B,list(B)),list(B)),product_case_prod(B,list(B),list(B)),cons(B)),aa(fun(B,fun(list(B),list(B))),fun(product_prod(B,list(B)),list(B)),product_case_prod(B,list(B),list(B)),cons(B)))),lex_prod(B,list(B),R3,lexn(B,R3,N)))),aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_rv(nat,fun(list(B),fun(list(B),$o)),N)))) ) ).

% lexn.simps(2)
tff(fact_4777_lexn_Osimps_I1_J,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( lexn(B,R3,zero_zero(nat)) = bot_bot(set(product_prod(list(B),list(B)))) ) ).

% lexn.simps(1)
tff(fact_4778_lexn__length,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B)),N: nat] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),lexn(B,R3,N))
     => ( ( size_size(list(B),Xs) = N )
        & ( size_size(list(B),Ys) = N ) ) ) ).

% lexn_length
tff(fact_4779_set__Cons__sing__Nil,axiom,
    ! [B: $tType,A4: set(B)] : ( set_Cons(B,A4,aa(set(list(B)),set(list(B)),insert2(list(B),nil(B)),bot_bot(set(list(B))))) = aa(set(B),set(list(B)),image2(B,list(B),aTP_Lamp_rw(B,list(B))),A4) ) ).

% set_Cons_sing_Nil
tff(fact_4780_part__code_I2_J,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Fa: fun(B,C),Pivot: C,X: B,Xs: list(B)] : ( linorder_part(B,C,Fa,Pivot,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)) = aa(product_prod(list(B),product_prod(list(B),list(B))),product_prod(list(B),product_prod(list(B),list(B))),aa(fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),fun(product_prod(list(B),product_prod(list(B),list(B))),product_prod(list(B),product_prod(list(B),list(B)))),product_case_prod(list(B),product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),aa(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),aa(C,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))))),aTP_Lamp_ry(fun(B,C),fun(C,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))))),Fa),Pivot),X)),linorder_part(B,C,Fa,Pivot,Xs)) ) ) ).

% part_code(2)
tff(fact_4781_part__code_I1_J,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Fa: fun(B,C),Pivot: C] : ( linorder_part(B,C,Fa,Pivot,nil(B)) = aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),nil(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B))) ) ) ).

% part_code(1)
tff(fact_4782_listrel__Cons,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(C,B)),X: C,Xs: list(C)] : ( image(list(C),list(B),listrel(C,B,R3),aa(set(list(C)),set(list(C)),insert2(list(C),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),X),Xs)),bot_bot(set(list(C))))) = set_Cons(B,image(C,B,R3,aa(set(C),set(C),insert2(C,X),bot_bot(set(C)))),image(list(C),list(B),listrel(C,B,R3),aa(set(list(C)),set(list(C)),insert2(list(C),Xs),bot_bot(set(list(C)))))) ) ).

% listrel_Cons
tff(fact_4783_listset_Osimps_I1_J,axiom,
    ! [B: $tType] : ( listset(B,nil(set(B))) = aa(set(list(B)),set(list(B)),insert2(list(B),nil(B)),bot_bot(set(list(B)))) ) ).

% listset.simps(1)
tff(fact_4784_extract__Cons__code,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: B,Xs: list(B)] :
      ( extract(B,Pa,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs))
      = $ite(aa(B,$o,Pa,X),aa(product_prod(list(B),product_prod(B,list(B))),option(product_prod(list(B),product_prod(B,list(B)))),some(product_prod(list(B),product_prod(B,list(B)))),aa(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B))),aa(list(B),fun(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B)))),product_Pair(list(B),product_prod(B,list(B))),nil(B)),aa(list(B),product_prod(B,list(B)),aa(B,fun(list(B),product_prod(B,list(B))),product_Pair(B,list(B)),X),Xs))),case_option(option(product_prod(list(B),product_prod(B,list(B)))),product_prod(list(B),product_prod(B,list(B))),none(product_prod(list(B),product_prod(B,list(B)))),aa(fun(list(B),fun(product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B)))))),fun(product_prod(list(B),product_prod(B,list(B))),option(product_prod(list(B),product_prod(B,list(B))))),product_case_prod(list(B),product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B))))),aTP_Lamp_sa(B,fun(list(B),fun(product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B)))))),X)),extract(B,Pa,Xs))) ) ).

% extract_Cons_code
tff(fact_4785_listrel__rtrancl__refl,axiom,
    ! [B: $tType,Xs: list(B),R3: set(product_prod(B,B))] : member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Xs),listrel(B,B,transitive_rtrancl(B,R3))) ).

% listrel_rtrancl_refl
tff(fact_4786_listrel__Nil,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(C,B))] : ( image(list(C),list(B),listrel(C,B,R3),aa(set(list(C)),set(list(C)),insert2(list(C),nil(C)),bot_bot(set(list(C))))) = aa(set(list(B)),set(list(B)),insert2(list(B),nil(B)),bot_bot(set(list(B)))) ) ).

% listrel_Nil
tff(fact_4787_listrel_ONil,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,C))] : member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),nil(C)),listrel(B,C,R3)) ).

% listrel.Nil
tff(fact_4788_listrel__Nil1,axiom,
    ! [B: $tType,C: $tType,Xs: list(C),R3: set(product_prod(B,C))] :
      ( member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),Xs),listrel(B,C,R3))
     => ( Xs = nil(C) ) ) ).

% listrel_Nil1
tff(fact_4789_listrel__Nil2,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),R3: set(product_prod(B,C))] :
      ( member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xs),nil(C)),listrel(B,C,R3))
     => ( Xs = nil(B) ) ) ).

% listrel_Nil2
tff(fact_4790_listrel__eq__len,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),Ys: list(C),R3: set(product_prod(B,C))] :
      ( member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xs),Ys),listrel(B,C,R3))
     => ( size_size(list(B),Xs) = size_size(list(C),Ys) ) ) ).

% listrel_eq_len
tff(fact_4791_listrel__rtrancl__trans,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B)),Zs2: list(B)] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel(B,B,transitive_rtrancl(B,R3)))
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ys),Zs2),listrel(B,B,transitive_rtrancl(B,R3)))
       => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Zs2),listrel(B,B,transitive_rtrancl(B,R3))) ) ) ).

% listrel_rtrancl_trans
tff(fact_4792_listrel__Cons2,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Y: C,Ys: list(C),R3: set(product_prod(B,C))] :
      ( member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xs),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),Y),Ys)),listrel(B,C,R3))
     => ~ ! [X2: B,Xs3: list(B)] :
            ( ( Xs = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
           => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y),R3)
             => ~ member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xs3),Ys),listrel(B,C,R3)) ) ) ) ).

% listrel_Cons2
tff(fact_4793_listrel__Cons1,axiom,
    ! [C: $tType,B: $tType,Y: B,Ys: list(B),Xs: list(C),R3: set(product_prod(B,C))] :
      ( member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)),Xs),listrel(B,C,R3))
     => ~ ! [Y2: C,Ys2: list(C)] :
            ( ( Xs = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),Y2),Ys2) )
           => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Y),Y2),R3)
             => ~ member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Ys),Ys2),listrel(B,C,R3)) ) ) ) ).

% listrel_Cons1
tff(fact_4794_listrel_OCons,axiom,
    ! [C: $tType,B: $tType,X: B,Y: C,R3: set(product_prod(B,C)),Xs: list(B),Ys: list(C)] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y),R3)
     => ( member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xs),Ys),listrel(B,C,R3))
       => member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),Y),Ys)),listrel(B,C,R3)) ) ) ).

% listrel.Cons
tff(fact_4795_listrel__reflcl__if__listrel1,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel1(B,R3))
     => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel(B,B,transitive_rtrancl(B,R3))) ) ).

% listrel_reflcl_if_listrel1
tff(fact_4796_rtrancl__listrel1__if__listrel,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel(B,B,R3))
     => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),transitive_rtrancl(list(B),listrel1(B,R3))) ) ).

% rtrancl_listrel1_if_listrel
tff(fact_4797_listrel_Osimps,axiom,
    ! [C: $tType,B: $tType,A1: list(B),A22: list(C),R3: set(product_prod(B,C))] :
      ( member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),A1),A22),listrel(B,C,R3))
    <=> ( ( ( A1 = nil(B) )
          & ( A22 = nil(C) ) )
        | ? [X4: B,Y3: C,Xs4: list(B),Ys3: list(C)] :
            ( ( A1 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X4),Xs4) )
            & ( A22 = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),Y3),Ys3) )
            & member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Y3),R3)
            & member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xs4),Ys3),listrel(B,C,R3)) ) ) ) ).

% listrel.simps
tff(fact_4798_listrel_Ocases,axiom,
    ! [C: $tType,B: $tType,A1: list(B),A22: list(C),R3: set(product_prod(B,C))] :
      ( member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),A1),A22),listrel(B,C,R3))
     => ( ( ( A1 = nil(B) )
         => ( A22 != nil(C) ) )
       => ~ ! [X2: B,Y2: C,Xs3: list(B)] :
              ( ( A1 = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
             => ! [Ys2: list(C)] :
                  ( ( A22 = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),Y2),Ys2) )
                 => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2),R3)
                   => ~ member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xs3),Ys2),listrel(B,C,R3)) ) ) ) ) ) ).

% listrel.cases
tff(fact_4799_listrel__iff__nth,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Ys: list(C),R3: set(product_prod(B,C))] :
      ( member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xs),Ys),listrel(B,C,R3))
    <=> ( ( size_size(list(B),Xs) = size_size(list(C),Ys) )
        & ! [N5: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N5),size_size(list(B),Xs))
           => member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),nth(B,Xs,N5)),nth(C,Ys,N5)),R3) ) ) ) ).

% listrel_iff_nth
tff(fact_4800_sorted__list__of__set__nonempty,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( linord4507533701916653071of_set(B,A4) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),lattic643756798350308766er_Min(B,A4)),linord4507533701916653071of_set(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,lattic643756798350308766er_Min(B,A4)),bot_bot(set(B)))))) ) ) ) ) ).

% sorted_list_of_set_nonempty
tff(fact_4801_upto_Opelims,axiom,
    ! [X: int,Xa: int,Y: list(int)] :
      ( ( upto(X,Xa) = Y )
     => ( aa(product_prod(int,int),$o,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X),Xa))
       => ~ ( ( Y
              = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X),Xa),aa(list(int),list(int),aa(int,fun(list(int),list(int)),cons(int),X),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),X),one_one(int)),Xa)),nil(int)) )
           => ~ aa(product_prod(int,int),$o,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),X),Xa)) ) ) ) ).

% upto.pelims
tff(fact_4802_upto_Opsimps,axiom,
    ! [I: int,J2: int] :
      ( aa(product_prod(int,int),$o,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),I),J2))
     => ( upto(I,J2)
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),J2),aa(list(int),list(int),aa(int,fun(list(int),list(int)),cons(int),I),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J2)),nil(int)) ) ) ).

% upto.psimps
tff(fact_4803_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( linord4507533701916653071of_set(B,bot_bot(set(B))) = nil(B) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
tff(fact_4804_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( linord4507533701916653071of_set(B,A4) = nil(B) )
          <=> ( A4 = bot_bot(set(B)) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
tff(fact_4805_Cons__lenlex__iff,axiom,
    ! [B: $tType,M4: B,Ms: list(B),N: B,Ns: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),M4),Ms)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),N),Ns)),lenlex(B,R3))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),size_size(list(B),Ms)),size_size(list(B),Ns))
        | ( ( size_size(list(B),Ms) = size_size(list(B),Ns) )
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),M4),N),R3) )
        | ( ( M4 = N )
          & member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ms),Ns),lenlex(B,R3)) ) ) ) ).

% Cons_lenlex_iff
tff(fact_4806_lexn__conv,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),N: nat] : ( lexn(B,R3,N) = aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aa(nat,fun(list(B),fun(list(B),$o)),aTP_Lamp_sb(set(product_prod(B,B)),fun(nat,fun(list(B),fun(list(B),$o))),R3),N))) ) ).

% lexn_conv
tff(fact_4807_Nil__lenlex__iff1,axiom,
    ! [B: $tType,Ns: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Ns),lenlex(B,R3))
    <=> ( Ns != nil(B) ) ) ).

% Nil_lenlex_iff1
tff(fact_4808_lenlex__append2,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),Us: list(B),Xs: list(B),Ys: list(B)] :
      ( irrefl(B,R)
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us),Xs)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us),Ys)),lenlex(B,R))
      <=> member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),lenlex(B,R)) ) ) ).

% lenlex_append2
tff(fact_4809_append_Omonoid__axioms,axiom,
    ! [B: $tType] : monoid(list(B),append(B),nil(B)) ).

% append.monoid_axioms
tff(fact_4810_lenlex__append1,axiom,
    ! [B: $tType,Us: list(B),Xs: list(B),R: set(product_prod(B,B)),Vs: list(B),Ys: list(B)] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Us),Xs),lenlex(B,R))
     => ( ( size_size(list(B),Vs) = size_size(list(B),Ys) )
       => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us),Vs)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)),lenlex(B,R)) ) ) ).

% lenlex_append1
tff(fact_4811_append__listrel1I,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B)),Us: list(B),Vs: list(B)] :
      ( ( ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel1(B,R3))
          & ( Us = Vs ) )
        | ( ( Xs = Ys )
          & member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Us),Vs),listrel1(B,R3)) ) )
     => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Us)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Ys),Vs)),listrel1(B,R3)) ) ).

% append_listrel1I
tff(fact_4812_lenlex__irreflexive,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Xs: list(B)] :
      ( ! [X2: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2),R3)
     => ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Xs),lenlex(B,R3)) ) ).

% lenlex_irreflexive
tff(fact_4813_Nil__lenlex__iff2,axiom,
    ! [B: $tType,Ns: list(B),R3: set(product_prod(B,B))] : ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ns),nil(B)),lenlex(B,R3)) ).

% Nil_lenlex_iff2
tff(fact_4814_lenlex__trans,axiom,
    ! [B: $tType,X: list(B),Y: list(B),R3: set(product_prod(B,B)),Z2: list(B)] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Y),lenlex(B,R3))
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Y),Z2),lenlex(B,R3))
       => ( trans(B,R3)
         => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Z2),lenlex(B,R3)) ) ) ) ).

% lenlex_trans
tff(fact_4815_listrel1I,axiom,
    ! [B: $tType,X: B,Y: B,R3: set(product_prod(B,B)),Xs: list(B),Us: list(B),Vs: list(B),Ys: list(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
     => ( ( Xs = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Vs)) )
       => ( ( Ys = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Vs)) )
         => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel1(B,R3)) ) ) ) ).

% listrel1I
tff(fact_4816_listrel1E,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel1(B,R3))
     => ~ ! [X2: B,Y2: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),R3)
           => ! [Us2: list(B),Vs2: list(B)] :
                ( ( Xs = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Vs2)) )
               => ( Ys != aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Vs2)) ) ) ) ) ).

% listrel1E
tff(fact_4817_lenlex__length,axiom,
    ! [B: $tType,Ms: list(B),Ns: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ms),Ns),lenlex(B,R3))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),size_size(list(B),Ms)),size_size(list(B),Ns)) ) ).

% lenlex_length
tff(fact_4818_snoc__listrel1__snoc__iff,axiom,
    ! [B: $tType,Xs: list(B),X: B,Ys: list(B),Y: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),nil(B)))),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Ys),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),nil(B)))),listrel1(B,R3))
    <=> ( ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),listrel1(B,R3))
          & ( X = Y ) )
        | ( ( Xs = Ys )
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3) ) ) ) ).

% snoc_listrel1_snoc_iff
tff(fact_4819_horner__sum__append,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_1(B)
     => ! [Fa: fun(C,B),A3: B,Xs: list(C),Ys: list(C)] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),Fa),A3),aa(list(C),list(C),aa(list(C),fun(list(C),list(C)),append(C),Xs),Ys)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),Fa),A3),Xs)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),A3),size_size(list(C),Xs))),aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),Fa),A3),Ys))) ) ) ).

% horner_sum_append
tff(fact_4820_listrel1__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( listrel1(B,R3) = aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_sc(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),R3))) ) ).

% listrel1_def
tff(fact_4821_lex__conv,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( lex(B,R3) = aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_sd(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),R3))) ) ).

% lex_conv
tff(fact_4822_lenlex__conv,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( lenlex(B,R3) = aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_se(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),R3))) ) ).

% lenlex_conv
tff(fact_4823_lexord__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( lexord(B,R3) = aa(fun(product_prod(list(B),list(B)),$o),set(product_prod(list(B),list(B))),collect(product_prod(list(B),list(B))),aa(fun(list(B),fun(list(B),$o)),fun(product_prod(list(B),list(B)),$o),product_case_prod(list(B),list(B),$o),aTP_Lamp_sf(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),R3))) ) ).

% lexord_def
tff(fact_4824_lexord__cons__cons,axiom,
    ! [B: $tType,A3: B,X: list(B),Ba: B,Y: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A3),X)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Ba),Y)),lexord(B,R3))
    <=> ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
        | ( ( A3 = Ba )
          & member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Y),lexord(B,R3)) ) ) ) ).

% lexord_cons_cons
tff(fact_4825_lexord__Nil__left,axiom,
    ! [B: $tType,Y: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Y),lexord(B,R3))
    <=> ? [A6: B,X4: list(B)] : ( Y = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A6),X4) ) ) ).

% lexord_Nil_left
tff(fact_4826_lexord__same__pref__if__irrefl,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Xs: list(B),Ys: list(B),Zs2: list(B)] :
      ( irrefl(B,R3)
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Zs2)),lexord(B,R3))
      <=> member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ys),Zs2),lexord(B,R3)) ) ) ).

% lexord_same_pref_if_irrefl
tff(fact_4827_Cons__in__lex,axiom,
    ! [B: $tType,X: B,Xs: list(B),Y: B,Ys: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)),lex(B,R3))
    <=> ( ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),R3)
          & ( size_size(list(B),Xs) = size_size(list(B),Ys) ) )
        | ( ( X = Y )
          & member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),lex(B,R3)) ) ) ) ).

% Cons_in_lex
tff(fact_4828_lexord__lex,axiom,
    ! [B: $tType,X: list(B),Y: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Y),lex(B,R3))
    <=> ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Y),lexord(B,R3))
        & ( size_size(list(B),X) = size_size(list(B),Y) ) ) ) ).

% lexord_lex
tff(fact_4829_lexord__linear,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X: list(B),Y: list(B)] :
      ( ! [A8: B,B4: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),B4),R3)
          | ( A8 = B4 )
          | member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B4),A8),R3) )
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Y),lexord(B,R3))
        | ( X = Y )
        | member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Y),X),lexord(B,R3)) ) ) ).

% lexord_linear
tff(fact_4830_lexord__irreflexive,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Xs: list(B)] :
      ( ! [X2: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2),R3)
     => ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Xs),lexord(B,R3)) ) ).

% lexord_irreflexive
tff(fact_4831_lexord__Nil__right,axiom,
    ! [B: $tType,X: list(B),R3: set(product_prod(B,B))] : ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),nil(B)),lexord(B,R3)) ).

% lexord_Nil_right
tff(fact_4832_lexord__append__leftI,axiom,
    ! [B: $tType,U: list(B),V: list(B),R3: set(product_prod(B,B)),X: list(B)] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),U),V),lexord(B,R3))
     => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),X),U)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),X),V)),lexord(B,R3)) ) ).

% lexord_append_leftI
tff(fact_4833_lexord__trans,axiom,
    ! [B: $tType,X: list(B),Y: list(B),R3: set(product_prod(B,B)),Z2: list(B)] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Y),lexord(B,R3))
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Y),Z2),lexord(B,R3))
       => ( trans(B,R3)
         => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Z2),lexord(B,R3)) ) ) ) ).

% lexord_trans
tff(fact_4834_lexord__asymmetric,axiom,
    ! [B: $tType,R: set(product_prod(B,B)),A3: list(B),Ba: list(B)] :
      ( asym(B,R)
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),A3),Ba),lexord(B,R))
       => ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ba),A3),lexord(B,R)) ) ) ).

% lexord_asymmetric
tff(fact_4835_Nil2__notin__lex,axiom,
    ! [B: $tType,Xs: list(B),R3: set(product_prod(B,B))] : ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),nil(B)),lex(B,R3)) ).

% Nil2_notin_lex
tff(fact_4836_Nil__notin__lex,axiom,
    ! [B: $tType,Ys: list(B),R3: set(product_prod(B,B))] : ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Ys),lex(B,R3)) ).

% Nil_notin_lex
tff(fact_4837_lex__append__leftI,axiom,
    ! [B: $tType,Ys: list(B),Zs2: list(B),R3: set(product_prod(B,B)),Xs: list(B)] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ys),Zs2),lex(B,R3))
     => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Zs2)),lex(B,R3)) ) ).

% lex_append_leftI
tff(fact_4838_lexl__not__refl,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X: list(B)] :
      ( irrefl(B,R3)
     => ~ member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),X),lex(B,R3)) ) ).

% lexl_not_refl
tff(fact_4839_lexord__append__leftD,axiom,
    ! [B: $tType,X: list(B),U: list(B),V: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),X),U)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),X),V)),lexord(B,R3))
     => ( ! [A8: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),A8),R3)
       => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),U),V),lexord(B,R3)) ) ) ).

% lexord_append_leftD
tff(fact_4840_lexord__append__rightI,axiom,
    ! [B: $tType,Y: list(B),X: list(B),R3: set(product_prod(B,B))] :
      ( ? [B9: B,Z5: list(B)] : ( Y = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B9),Z5) )
     => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),X),Y)),lexord(B,R3)) ) ).

% lexord_append_rightI
tff(fact_4841_lexord__sufE,axiom,
    ! [B: $tType,Xs: list(B),Zs2: list(B),Ys: list(B),Qs: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Zs2)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Ys),Qs)),lexord(B,R3))
     => ( ( Xs != Ys )
       => ( ( size_size(list(B),Xs) = size_size(list(B),Ys) )
         => ( ( size_size(list(B),Zs2) = size_size(list(B),Qs) )
           => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),lexord(B,R3)) ) ) ) ) ).

% lexord_sufE
tff(fact_4842_lex__append__left__iff,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Xs: list(B),Ys: list(B),Zs2: list(B)] :
      ( ! [X2: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2),R3)
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Zs2)),lex(B,R3))
      <=> member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ys),Zs2),lex(B,R3)) ) ) ).

% lex_append_left_iff
tff(fact_4843_lex__append__leftD,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Xs: list(B),Ys: list(B),Zs2: list(B)] :
      ( ! [X2: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),X2),R3)
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Zs2)),lex(B,R3))
       => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ys),Zs2),lex(B,R3)) ) ) ).

% lex_append_leftD
tff(fact_4844_lex__append__rightI,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B)),Vs: list(B),Us: list(B)] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),lex(B,R3))
     => ( ( size_size(list(B),Vs) = size_size(list(B),Us) )
       => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Us)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Ys),Vs)),lex(B,R3)) ) ) ).

% lex_append_rightI
tff(fact_4845_lexord__append__left__rightI,axiom,
    ! [B: $tType,A3: B,Ba: B,R3: set(product_prod(B,B)),U: list(B),X: list(B),Y: list(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
     => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),U),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A3),X))),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),U),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Ba),Y))),lexord(B,R3)) ) ).

% lexord_append_left_rightI
tff(fact_4846_lexord__sufI,axiom,
    ! [B: $tType,U: list(B),W2: list(B),R3: set(product_prod(B,B)),V: list(B),Z2: list(B)] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),U),W2),lexord(B,R3))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),size_size(list(B),W2)),size_size(list(B),U))
       => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),U),V)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),W2),Z2)),lexord(B,R3)) ) ) ).

% lexord_sufI
tff(fact_4847_lenlex__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : ( lenlex(B,R3) = inv_image(product_prod(nat,list(B)),list(B),lex_prod(nat,list(B),less_than,lex(B,R3)),aTP_Lamp_sg(list(B),product_prod(nat,list(B)))) ) ).

% lenlex_def
tff(fact_4848_List_Olexordp__def,axiom,
    ! [B: $tType,R3: fun(B,fun(B,$o)),Xs: list(B),Ys: list(B)] :
      ( lexordp(B,R3,Xs,Ys)
    <=> member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),lexord(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R3)))) ) ).

% List.lexordp_def
tff(fact_4849_extract__Some__iff,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B),Ys: list(B),Y: B,Zs2: list(B)] :
      ( ( extract(B,Pa,Xs) = aa(product_prod(list(B),product_prod(B,list(B))),option(product_prod(list(B),product_prod(B,list(B)))),some(product_prod(list(B),product_prod(B,list(B)))),aa(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B))),aa(list(B),fun(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B)))),product_Pair(list(B),product_prod(B,list(B))),Ys),aa(list(B),product_prod(B,list(B)),aa(B,fun(list(B),product_prod(B,list(B))),product_Pair(B,list(B)),Y),Zs2))) )
    <=> ( ( Xs = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Ys),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Zs2)) )
        & aa(B,$o,Pa,Y)
        & ~ ? [X4: B] :
              ( member(B,X4,aa(list(B),set(B),set2(B),Ys))
              & aa(B,$o,Pa,X4) ) ) ) ).

% extract_Some_iff
tff(fact_4850_extract__SomeE,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B),Ys: list(B),Y: B,Zs2: list(B)] :
      ( ( extract(B,Pa,Xs) = aa(product_prod(list(B),product_prod(B,list(B))),option(product_prod(list(B),product_prod(B,list(B)))),some(product_prod(list(B),product_prod(B,list(B)))),aa(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B))),aa(list(B),fun(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B)))),product_Pair(list(B),product_prod(B,list(B))),Ys),aa(list(B),product_prod(B,list(B)),aa(B,fun(list(B),product_prod(B,list(B))),product_Pair(B,list(B)),Y),Zs2))) )
     => ( ( Xs = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Ys),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Zs2)) )
        & aa(B,$o,Pa,Y)
        & ~ ? [X3: B] :
              ( member(B,X3,aa(list(B),set(B),set2(B),Ys))
              & aa(B,$o,Pa,X3) ) ) ) ).

% extract_SomeE
tff(fact_4851_set__empty,axiom,
    ! [B: $tType,Xs: list(B)] :
      ( ( aa(list(B),set(B),set2(B),Xs) = bot_bot(set(B)) )
    <=> ( Xs = nil(B) ) ) ).

% set_empty
tff(fact_4852_set__empty2,axiom,
    ! [B: $tType,Xs: list(B)] :
      ( ( bot_bot(set(B)) = aa(list(B),set(B),set2(B),Xs) )
    <=> ( Xs = nil(B) ) ) ).

% set_empty2
tff(fact_4853_set__replicate,axiom,
    ! [B: $tType,N: nat,X: B] :
      ( ( N != zero_zero(nat) )
     => ( aa(list(B),set(B),set2(B),replicate(B,N,X)) = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) ) ).

% set_replicate
tff(fact_4854_empty__set,axiom,
    ! [B: $tType] : ( bot_bot(set(B)) = aa(list(B),set(B),set2(B),nil(B)) ) ).

% empty_set
tff(fact_4855_lexord__partial__trans,axiom,
    ! [B: $tType,Xs: list(B),R3: set(product_prod(B,B)),Ys: list(B),Zs2: list(B)] :
      ( ! [X2: B,Y2: B,Z3: B] :
          ( member(B,X2,aa(list(B),set(B),set2(B),Xs))
         => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Y2),R3)
           => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),Z3),R3)
             => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X2),Z3),R3) ) ) )
     => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),lexord(B,R3))
       => ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ys),Zs2),lexord(B,R3))
         => member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Zs2),lexord(B,R3)) ) ) ) ).

% lexord_partial_trans
tff(fact_4856_set__replicate__conv__if,axiom,
    ! [B: $tType,N: nat,X: B] :
      ( aa(list(B),set(B),set2(B),replicate(B,N,X))
      = $ite(N = zero_zero(nat),bot_bot(set(B)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) ) ).

% set_replicate_conv_if
tff(fact_4857_set__replicate__Suc,axiom,
    ! [B: $tType,N: nat,X: B] : ( aa(list(B),set(B),set2(B),replicate(B,aa(nat,nat,suc,N),X)) = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) ).

% set_replicate_Suc
tff(fact_4858_lexord__same__pref__iff,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs2: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Zs2)),lexord(B,R3))
    <=> ( ? [X4: B] :
            ( member(B,X4,aa(list(B),set(B),set2(B),Xs))
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),X4),R3) )
        | member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Ys),Zs2),lexord(B,R3)) ) ) ).

% lexord_same_pref_iff
tff(fact_4859_Pow__set_I1_J,axiom,
    ! [B: $tType] : ( pow(B,aa(list(B),set(B),set2(B),nil(B))) = aa(set(set(B)),set(set(B)),insert2(set(B),bot_bot(set(B))),bot_bot(set(set(B)))) ) ).

% Pow_set(1)
tff(fact_4860_set__update__distinct,axiom,
    ! [B: $tType,Xs: list(B),N: nat,X: B] :
      ( distinct(B,Xs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),size_size(list(B),Xs))
       => ( aa(list(B),set(B),set2(B),list_update(B,Xs,N,X)) = aa(set(B),set(B),insert2(B,X),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(set(B),set(B),insert2(B,nth(B,Xs,N)),bot_bot(set(B))))) ) ) ) ).

% set_update_distinct
tff(fact_4861_arg__min__list_Opelims,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [X: fun(B,C),Xa: list(B),Y: B] :
          ( ( arg_min_list(B,C,X,Xa) = Y )
         => ( aa(product_prod(fun(B,C),list(B)),$o,accp(product_prod(fun(B,C),list(B)),arg_min_list_rel(B,C)),aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),X),Xa))
           => ( ! [X2: B] :
                  ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)) )
                 => ( ( Y = X2 )
                   => ~ aa(product_prod(fun(B,C),list(B)),$o,accp(product_prod(fun(B,C),list(B)),arg_min_list_rel(B,C)),aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)))) ) )
             => ( ! [X2: B,Y2: B,Zs: list(B)] :
                    ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Zs)) )
                   => ( ( Y
                        = $let(
                            m: B,
                            m := arg_min_list(B,C,X,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Zs)),
                            $ite(aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,X,X2)),aa(B,C,X,m)),X2,m) ) )
                     => ~ aa(product_prod(fun(B,C),list(B)),$o,accp(product_prod(fun(B,C),list(B)),arg_min_list_rel(B,C)),aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Zs)))) ) )
               => ~ ( ( Xa = nil(B) )
                   => ( ( Y = undefined(B) )
                     => ~ aa(product_prod(fun(B,C),list(B)),$o,accp(product_prod(fun(B,C),list(B)),arg_min_list_rel(B,C)),aa(list(B),product_prod(fun(B,C),list(B)),aa(fun(B,C),fun(list(B),product_prod(fun(B,C),list(B))),product_Pair(fun(B,C),list(B)),X),nil(B))) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
tff(fact_4862_set__removeAll,axiom,
    ! [B: $tType,X: B,Xs: list(B)] : ( aa(list(B),set(B),set2(B),removeAll(B,X,Xs)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) ) ).

% set_removeAll
tff(fact_4863_distinct__append,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B)] :
      ( distinct(B,aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys))
    <=> ( distinct(B,Xs)
        & distinct(B,Ys)
        & ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) ) ) ) ).

% distinct_append
tff(fact_4864_distinct__list__update,axiom,
    ! [B: $tType,Xs: list(B),A3: B,I: nat] :
      ( distinct(B,Xs)
     => ( ~ member(B,A3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(set(B),set(B),insert2(B,nth(B,Xs,I)),bot_bot(set(B)))))
       => distinct(B,list_update(B,Xs,I,A3)) ) ) ).

% distinct_list_update
tff(fact_4865_set__remove1__eq,axiom,
    ! [B: $tType,Xs: list(B),X: B] :
      ( distinct(B,Xs)
     => ( aa(list(B),set(B),set2(B),remove1(B,X,Xs)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))) ) ) ).

% set_remove1_eq
tff(fact_4866_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( linord4507533701916653071of_set(B,aa(set(B),set(B),insert2(B,X),A4)) = aa(list(B),list(B),linorder_insort_key(B,B,aTP_Lamp_sh(B,B),X),linord4507533701916653071of_set(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
tff(fact_4867_distinct__foldl__invar,axiom,
    ! [C: $tType,B: $tType,S2: list(B),I4: fun(set(B),fun(C,$o)),Sigma_0: C,Fa: fun(C,fun(B,C))] :
      ( distinct(B,S2)
     => ( aa(C,$o,aa(set(B),fun(C,$o),I4,aa(list(B),set(B),set2(B),S2)),Sigma_0)
       => ( ! [X2: B,It: set(B),Sigma: C] :
              ( member(B,X2,It)
             => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),It),aa(list(B),set(B),set2(B),S2))
               => ( aa(C,$o,aa(set(B),fun(C,$o),I4,It),Sigma)
                 => aa(C,$o,aa(set(B),fun(C,$o),I4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),It),aa(set(B),set(B),insert2(B,X2),bot_bot(set(B))))),aa(B,C,aa(C,fun(B,C),Fa,Sigma),X2)) ) ) )
         => aa(C,$o,aa(set(B),fun(C,$o),I4,bot_bot(set(B))),foldl(C,B,Fa,Sigma_0,S2)) ) ) ) ).

% distinct_foldl_invar
tff(fact_4868_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Y: B,X: B] : ( aa(fun(list(B),list(B)),fun(list(B),list(B)),aa(fun(list(B),list(B)),fun(fun(list(B),list(B)),fun(list(B),list(B))),comp(list(B),list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_sh(B,B),Y)),linorder_insort_key(B,B,aTP_Lamp_sh(B,B),X)) = aa(fun(list(B),list(B)),fun(list(B),list(B)),aa(fun(list(B),list(B)),fun(fun(list(B),list(B)),fun(list(B),list(B))),comp(list(B),list(B),list(B)),linorder_insort_key(B,B,aTP_Lamp_sh(B,B),X)),linorder_insort_key(B,B,aTP_Lamp_sh(B,B),Y)) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
tff(fact_4869_fst__foldl,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(B,fun(D,B)),Ga: fun(B,fun(C,fun(D,C))),A3: B,Ba: C,Xs: list(D)] : ( aa(product_prod(B,C),B,product_fst(B,C),foldl(product_prod(B,C),D,aa(fun(B,fun(C,fun(D,product_prod(B,C)))),fun(product_prod(B,C),fun(D,product_prod(B,C))),product_case_prod(B,C,fun(D,product_prod(B,C))),aa(fun(B,fun(C,fun(D,C))),fun(B,fun(C,fun(D,product_prod(B,C)))),aTP_Lamp_si(fun(B,fun(D,B)),fun(fun(B,fun(C,fun(D,C))),fun(B,fun(C,fun(D,product_prod(B,C))))),Fa),Ga)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba),Xs)) = foldl(B,D,Fa,A3,Xs) ) ).

% fst_foldl
tff(fact_4870_foldl__absorb1,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [X: B,Zs2: list(B)] : ( aa(B,B,aa(B,fun(B,B),times_times(B),X),foldl(B,B,times_times(B),one_one(B),Zs2)) = foldl(B,B,times_times(B),X,Zs2) ) ) ).

% foldl_absorb1
tff(fact_4871_foldl__un__empty__eq,axiom,
    ! [B: $tType,I: set(B),Ww: list(set(B))] : ( foldl(set(B),set(B),sup_sup(set(B)),I,Ww) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),I),foldl(set(B),set(B),sup_sup(set(B)),bot_bot(set(B)),Ww)) ) ).

% foldl_un_empty_eq
tff(fact_4872_foldl__set,axiom,
    ! [B: $tType,L: list(set(B))] : ( foldl(set(B),set(B),sup_sup(set(B)),bot_bot(set(B)),L) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(fun(set(B),$o),set(set(B)),collect(set(B)),aTP_Lamp_sj(list(set(B)),fun(set(B),$o),L))) ) ).

% foldl_set
tff(fact_4873_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( linord4507533701916653071of_set(B,A4) = aa(list(B),list(B),linorder_insort_key(B,B,aTP_Lamp_sh(B,B),X),linord4507533701916653071of_set(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
tff(fact_4874_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [A4: set(B),X: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( linord4507533701916653071of_set(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B))))) = remove1(B,X,linord4507533701916653071of_set(B,A4)) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
tff(fact_4875_lexord__take__index__conv,axiom,
    ! [B: $tType,X: list(B),Y: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Y),lexord(B,R3))
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),size_size(list(B),X)),size_size(list(B),Y))
          & ( take(B,size_size(list(B),X),Y) = X ) )
        | ? [I2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),size_size(list(B),X)),size_size(list(B),Y)))
            & ( take(B,I2,X) = take(B,I2,Y) )
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),nth(B,X,I2)),nth(B,Y,I2)),R3) ) ) ) ).

% lexord_take_index_conv
tff(fact_4876_mset__mergesort__by__rel__split,axiom,
    ! [B: $tType,Xs1: list(B),Xs2: list(B),Xs: list(B)] : ( aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),aa(list(B),multiset(B),mset(B),aa(product_prod(list(B),list(B)),list(B),product_fst(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs1),Xs2),Xs)))),aa(list(B),multiset(B),mset(B),aa(product_prod(list(B),list(B)),list(B),product_snd(list(B),list(B)),merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs1),Xs2),Xs)))) = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),aa(list(B),multiset(B),mset(B),Xs)),aa(list(B),multiset(B),mset(B),Xs1))),aa(list(B),multiset(B),mset(B),Xs2)) ) ).

% mset_mergesort_by_rel_split
tff(fact_4877_listrel__def,axiom,
    ! [C: $tType,B: $tType,X3: set(product_prod(B,C))] : ( listrel(B,C,X3) = aa(fun(product_prod(list(B),list(C)),$o),set(product_prod(list(B),list(C))),collect(product_prod(list(B),list(C))),aa(fun(list(B),fun(list(C),$o)),fun(product_prod(list(B),list(C)),$o),product_case_prod(list(B),list(C),$o),listrelp(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),X3)))) ) ).

% listrel_def
tff(fact_4878_set__mset__comp__mset,axiom,
    ! [B: $tType] : ( aa(fun(list(B),multiset(B)),fun(list(B),set(B)),aa(fun(multiset(B),set(B)),fun(fun(list(B),multiset(B)),fun(list(B),set(B))),comp(multiset(B),set(B),list(B)),set_mset(B)),mset(B)) = set2(B) ) ).

% set_mset_comp_mset
tff(fact_4879_lex__take__index,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),R3: set(product_prod(B,B))] :
      ( member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),lex(B,R3))
     => ~ ! [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),size_size(list(B),Xs))
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),size_size(list(B),Ys))
             => ( ( take(B,I3,Xs) = take(B,I3,Ys) )
               => ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),nth(B,Xs,I3)),nth(B,Ys,I3)),R3) ) ) ) ) ).

% lex_take_index
tff(fact_4880_listrelp__listrel__eq,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(B,C)),X3: list(B),Xa3: list(C)] :
      ( aa(list(C),$o,aa(list(B),fun(list(C),$o),listrelp(B,C,aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),R3)),X3),Xa3)
    <=> member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),X3),Xa3),listrel(B,C,R3)) ) ).

% listrelp_listrel_eq
tff(fact_4881_card__disjoint__shuffles,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
     => ( finite_card(list(B),shuffles(B,Xs,Ys)) = binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_size(list(B),Xs)),size_size(list(B),Ys)),size_size(list(B),Xs)) ) ) ).

% card_disjoint_shuffles
tff(fact_4882_nth__zip,axiom,
    ! [B: $tType,C: $tType,I: nat,Xs: list(B),Ys: list(C)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),size_size(list(B),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),size_size(list(C),Ys))
       => ( nth(product_prod(B,C),zip(B,C,Xs,Ys),I) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),nth(B,Xs,I)),nth(C,Ys,I)) ) ) ) ).

% nth_zip
tff(fact_4883_listrel__iff__zip,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Ys: list(C),R3: set(product_prod(B,C))] :
      ( member(product_prod(list(B),list(C)),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xs),Ys),listrel(B,C,R3))
    <=> ( ( size_size(list(B),Xs) = size_size(list(C),Ys) )
        & ! [X4: product_prod(B,C)] :
            ( member(product_prod(B,C),X4,aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,Xs,Ys)))
           => aa(product_prod(B,C),$o,aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),R3)),X4) ) ) ) ).

% listrel_iff_zip
tff(fact_4884_zip__Cons__Cons,axiom,
    ! [B: $tType,C: $tType,X: B,Xs: list(B),Y: C,Ys: list(C)] : ( zip(B,C,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),Y),Ys)) = aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)),zip(B,C,Xs,Ys)) ) ).

% zip_Cons_Cons
tff(fact_4885_zip__replicate,axiom,
    ! [B: $tType,C: $tType,I: nat,X: B,J2: nat,Y: C] : ( zip(B,C,replicate(B,I,X),replicate(C,J2,Y)) = replicate(product_prod(B,C),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),I),J2),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)) ) ).

% zip_replicate
tff(fact_4886_zip__same,axiom,
    ! [B: $tType,A3: B,Ba: B,Xs: list(B)] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),aa(list(product_prod(B,B)),set(product_prod(B,B)),set2(product_prod(B,B)),zip(B,B,Xs,Xs)))
    <=> ( member(B,A3,aa(list(B),set(B),set2(B),Xs))
        & ( A3 = Ba ) ) ) ).

% zip_same
tff(fact_4887_in__set__zipE,axiom,
    ! [B: $tType,C: $tType,X: B,Y: C,Xs: list(B),Ys: list(C)] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,Xs,Ys)))
     => ~ ( member(B,X,aa(list(B),set(B),set2(B),Xs))
         => ~ member(C,Y,aa(list(C),set(C),set2(C),Ys)) ) ) ).

% in_set_zipE
tff(fact_4888_set__zip__leftD,axiom,
    ! [C: $tType,B: $tType,X: B,Y: C,Xs: list(B),Ys: list(C)] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,Xs,Ys)))
     => member(B,X,aa(list(B),set(B),set2(B),Xs)) ) ).

% set_zip_leftD
tff(fact_4889_set__zip__rightD,axiom,
    ! [B: $tType,C: $tType,X: B,Y: C,Xs: list(B),Ys: list(C)] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,Xs,Ys)))
     => member(C,Y,aa(list(C),set(C),set2(C),Ys)) ) ).

% set_zip_rightD
tff(fact_4890_zip__update,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),I: nat,X: B,Ys: list(C),Y: C] : ( zip(B,C,list_update(B,Xs,I,X),list_update(C,Ys,I,Y)) = list_update(product_prod(B,C),zip(B,C,Xs,Ys),I,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)) ) ).

% zip_update
tff(fact_4891_in__set__impl__in__set__zip2,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),Ys: list(C),Y: C] :
      ( ( size_size(list(B),Xs) = size_size(list(C),Ys) )
     => ( member(C,Y,aa(list(C),set(C),set2(C),Ys))
       => ~ ! [X2: B] : ~ member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,Xs,Ys))) ) ) ).

% in_set_impl_in_set_zip2
tff(fact_4892_in__set__impl__in__set__zip1,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),Ys: list(C),X: B] :
      ( ( size_size(list(B),Xs) = size_size(list(C),Ys) )
     => ( member(B,X,aa(list(B),set(B),set2(B),Xs))
       => ~ ! [Y2: C] : ~ member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y2),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,Xs,Ys))) ) ) ).

% in_set_impl_in_set_zip1
tff(fact_4893_zip__eq__ConsE,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),Ys: list(C),Xy: product_prod(B,C),Xys: list(product_prod(B,C))] :
      ( ( zip(B,C,Xs,Ys) = aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),Xy),Xys) )
     => ~ ! [X2: B,Xs5: list(B)] :
            ( ( Xs = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs5) )
           => ! [Y2: C,Ys4: list(C)] :
                ( ( Ys = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),Y2),Ys4) )
               => ( ( Xy = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X2),Y2) )
                 => ( Xys != zip(B,C,Xs5,Ys4) ) ) ) ) ) ).

% zip_eq_ConsE
tff(fact_4894_shuffles_Osimps_I2_J,axiom,
    ! [B: $tType,Xs: list(B)] : ( shuffles(B,Xs,nil(B)) = aa(set(list(B)),set(list(B)),insert2(list(B),Xs),bot_bot(set(list(B)))) ) ).

% shuffles.simps(2)
tff(fact_4895_shuffles_Osimps_I1_J,axiom,
    ! [B: $tType,Ys: list(B)] : ( shuffles(B,nil(B),Ys) = aa(set(list(B)),set(list(B)),insert2(list(B),Ys),bot_bot(set(list(B)))) ) ).

% shuffles.simps(1)
tff(fact_4896_distinct__disjoint__shuffles,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs2: list(B)] :
      ( distinct(B,Xs)
     => ( distinct(B,Ys)
       => ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
         => ( member(list(B),Zs2,shuffles(B,Xs,Ys))
           => distinct(B,Zs2) ) ) ) ) ).

% distinct_disjoint_shuffles
tff(fact_4897_shuffles_Oelims,axiom,
    ! [B: $tType,X: list(B),Xa: list(B),Y: set(list(B))] :
      ( ( shuffles(B,X,Xa) = Y )
     => ( ( ( X = nil(B) )
         => ( Y != aa(set(list(B)),set(list(B)),insert2(list(B),Xa),bot_bot(set(list(B)))) ) )
       => ( ( ( Xa = nil(B) )
           => ( Y != aa(set(list(B)),set(list(B)),insert2(list(B),X),bot_bot(set(list(B)))) ) )
         => ~ ! [X2: B,Xs3: list(B)] :
                ( ( X = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
               => ! [Y2: B,Ys2: list(B)] :
                    ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2) )
                   => ( Y != aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),sup_sup(set(list(B))),aa(set(list(B)),set(list(B)),image2(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2)),shuffles(B,Xs3,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2)))),aa(set(list(B)),set(list(B)),image2(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2)),shuffles(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3),Ys2))) ) ) ) ) ) ) ).

% shuffles.elims
tff(fact_4898_set__zip,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),Ys: list(C)] : ( aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),zip(B,C,Xs,Ys)) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(list(C),fun(product_prod(B,C),$o),aTP_Lamp_sk(list(B),fun(list(C),fun(product_prod(B,C),$o)),Xs),Ys)) ) ).

% set_zip
tff(fact_4899_inv__image__partition,axiom,
    ! [B: $tType,Xs: list(B),Pa: fun(B,$o),Ys: list(B)] :
      ( ! [X2: B] :
          ( member(B,X2,aa(list(B),set(B),set2(B),Xs))
         => aa(B,$o,Pa,X2) )
     => ( ! [Y2: B] :
            ( member(B,Y2,aa(list(B),set(B),set2(B),Ys))
           => ~ aa(B,$o,Pa,Y2) )
       => ( aa(set(product_prod(list(B),list(B))),set(list(B)),aa(fun(list(B),product_prod(list(B),list(B))),fun(set(product_prod(list(B),list(B))),set(list(B))),vimage(list(B),product_prod(list(B),list(B))),partition(B,Pa)),aa(set(product_prod(list(B),list(B))),set(product_prod(list(B),list(B))),insert2(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys)),bot_bot(set(product_prod(list(B),list(B)))))) = shuffles(B,Xs,Ys) ) ) ) ).

% inv_image_partition
tff(fact_4900_mset__zip__take__Cons__drop__twice,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),Ys: list(C),J2: nat,X: B,Y: C] :
      ( ( size_size(list(B),Xs) = size_size(list(C),Ys) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J2),size_size(list(B),Xs))
       => ( aa(list(product_prod(B,C)),multiset(product_prod(B,C)),mset(product_prod(B,C)),zip(B,C,aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),take(B,J2,Xs)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),drop(B,J2,Xs))),aa(list(C),list(C),aa(list(C),fun(list(C),list(C)),append(C),take(C,J2,Ys)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),Y),drop(C,J2,Ys))))) = aa(multiset(product_prod(B,C)),multiset(product_prod(B,C)),aa(product_prod(B,C),fun(multiset(product_prod(B,C)),multiset(product_prod(B,C))),add_mset(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)),aa(list(product_prod(B,C)),multiset(product_prod(B,C)),mset(product_prod(B,C)),zip(B,C,Xs,Ys))) ) ) ) ).

% mset_zip_take_Cons_drop_twice
tff(fact_4901_lists__empty,axiom,
    ! [B: $tType] : ( lists(B,bot_bot(set(B))) = aa(set(list(B)),set(list(B)),insert2(list(B),nil(B)),bot_bot(set(list(B)))) ) ).

% lists_empty
tff(fact_4902_lists__Int__eq,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( lists(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) = aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),inf_inf(set(list(B))),lists(B,A4)),lists(B,B2)) ) ).

% lists_Int_eq
tff(fact_4903_lists__IntI,axiom,
    ! [B: $tType,L: list(B),A4: set(B),B2: set(B)] :
      ( member(list(B),L,lists(B,A4))
     => ( member(list(B),L,lists(B,B2))
       => member(list(B),L,lists(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2))) ) ) ).

% lists_IntI
tff(fact_4904_lists__of__len__fin1,axiom,
    ! [B: $tType,Pa: set(B),N: nat] :
      ( aa(set(B),$o,finite_finite(B),Pa)
     => aa(set(list(B)),$o,finite_finite(list(B)),aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),inf_inf(set(list(B))),lists(B,Pa)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aTP_Lamp_sl(nat,fun(list(B),$o),N)))) ) ).

% lists_of_len_fin1
tff(fact_4905_lists__of__len__fin2,axiom,
    ! [B: $tType,Pa: set(B),N: nat] :
      ( aa(set(B),$o,finite_finite(B),Pa)
     => aa(set(list(B)),$o,finite_finite(list(B)),aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),inf_inf(set(list(B))),lists(B,Pa)),aa(fun(list(B),$o),set(list(B)),collect(list(B)),aTP_Lamp_sm(nat,fun(list(B),$o),N)))) ) ).

% lists_of_len_fin2
tff(fact_4906_partition_Osimps_I1_J,axiom,
    ! [B: $tType,Pa: fun(B,$o)] : ( aa(list(B),product_prod(list(B),list(B)),partition(B,Pa),nil(B)) = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)) ) ).

% partition.simps(1)
tff(fact_4907_partition__P,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B),Yes2: list(B),No2: list(B)] :
      ( ( aa(list(B),product_prod(list(B),list(B)),partition(B,Pa),Xs) = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes2),No2) )
     => ( ! [X3: B] :
            ( member(B,X3,aa(list(B),set(B),set2(B),Yes2))
           => aa(B,$o,Pa,X3) )
        & ! [X3: B] :
            ( member(B,X3,aa(list(B),set(B),set2(B),No2))
           => ~ aa(B,$o,Pa,X3) ) ) ) ).

% partition_P
tff(fact_4908_partition_Osimps_I2_J,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: B,Xs: list(B)] : ( aa(list(B),product_prod(list(B),list(B)),partition(B,Pa),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)) = aa(product_prod(list(B),list(B)),product_prod(list(B),list(B)),aa(fun(list(B),fun(list(B),product_prod(list(B),list(B)))),fun(product_prod(list(B),list(B)),product_prod(list(B),list(B))),product_case_prod(list(B),list(B),product_prod(list(B),list(B))),aa(B,fun(list(B),fun(list(B),product_prod(list(B),list(B)))),aTP_Lamp_sn(fun(B,$o),fun(B,fun(list(B),fun(list(B),product_prod(list(B),list(B))))),Pa),X)),aa(list(B),product_prod(list(B),list(B)),partition(B,Pa),Xs)) ) ).

% partition.simps(2)
tff(fact_4909_partition__set,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B),Yes2: list(B),No2: list(B)] :
      ( ( aa(list(B),product_prod(list(B),list(B)),partition(B,Pa),Xs) = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes2),No2) )
     => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(list(B),set(B),set2(B),Yes2)),aa(list(B),set(B),set2(B),No2)) = aa(list(B),set(B),set2(B),Xs) ) ) ).

% partition_set
tff(fact_4910_set__take__disj__set__drop__if__distinct,axiom,
    ! [B: $tType,Vs: list(B),I: nat,J2: nat] :
      ( distinct(B,Vs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J2)
       => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),take(B,I,Vs))),aa(list(B),set(B),set2(B),drop(B,J2,Vs))) = bot_bot(set(B)) ) ) ) ).

% set_take_disj_set_drop_if_distinct
tff(fact_4911_INF__set__fold,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(C,B),Xs: list(C)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image2(C,B,Fa),aa(list(C),set(C),set2(C),Xs))) = aa(B,B,fold(C,B,aa(fun(C,B),fun(C,fun(B,B)),aa(fun(B,fun(B,B)),fun(fun(C,B),fun(C,fun(B,B))),comp(B,fun(B,B),C),inf_inf(B)),Fa),Xs),top_top(B)) ) ) ).

% INF_set_fold
tff(fact_4912_SUP__set__fold,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(C,B),Xs: list(C)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image2(C,B,Fa),aa(list(C),set(C),set2(C),Xs))) = aa(B,B,fold(C,B,aa(fun(C,B),fun(C,fun(B,B)),aa(fun(B,fun(B,B)),fun(fun(C,B),fun(C,fun(B,B))),comp(B,fun(B,B),C),sup_sup(B)),Fa),Xs),bot_bot(B)) ) ) ).

% SUP_set_fold
tff(fact_4913_shuffles_Opelims,axiom,
    ! [B: $tType,X: list(B),Xa: list(B),Y: set(list(B))] :
      ( ( shuffles(B,X,Xa) = Y )
     => ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Xa))
       => ( ( ( X = nil(B) )
           => ( ( Y = aa(set(list(B)),set(list(B)),insert2(list(B),Xa),bot_bot(set(list(B)))) )
             => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Xa)) ) )
         => ( ( ( Xa = nil(B) )
             => ( ( Y = aa(set(list(B)),set(list(B)),insert2(list(B),X),bot_bot(set(list(B)))) )
               => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),nil(B))) ) )
           => ~ ! [X2: B,Xs3: list(B)] :
                  ( ( X = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
                 => ! [Y2: B,Ys2: list(B)] :
                      ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2) )
                     => ( ( Y = aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),sup_sup(set(list(B))),aa(set(list(B)),set(list(B)),image2(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2)),shuffles(B,Xs3,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2)))),aa(set(list(B)),set(list(B)),image2(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2)),shuffles(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3),Ys2))) )
                       => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2))) ) ) ) ) ) ) ) ).

% shuffles.pelims
tff(fact_4914_fold__append,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,fun(B,B)),Xs: list(C),Ys: list(C)] : ( fold(C,B,Fa,aa(list(C),list(C),aa(list(C),fun(list(C),list(C)),append(C),Xs),Ys)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),fold(C,B,Fa,Ys)),fold(C,B,Fa,Xs)) ) ).

% fold_append
tff(fact_4915_shuffles_Opinduct,axiom,
    ! [B: $tType,A0: list(B),A1: list(B),Pa: fun(list(B),fun(list(B),$o))] :
      ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),A0),A1))
     => ( ! [Ys2: list(B)] :
            ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Ys2))
           => aa(list(B),$o,aa(list(B),fun(list(B),$o),Pa,nil(B)),Ys2) )
       => ( ! [Xs3: list(B)] :
              ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs3),nil(B)))
             => aa(list(B),$o,aa(list(B),fun(list(B),$o),Pa,Xs3),nil(B)) )
         => ( ! [X2: B,Xs3: list(B),Y2: B,Ys2: list(B)] :
                ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2)))
               => ( aa(list(B),$o,aa(list(B),fun(list(B),$o),Pa,Xs3),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2))
                 => ( aa(list(B),$o,aa(list(B),fun(list(B),$o),Pa,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),Ys2)
                   => aa(list(B),$o,aa(list(B),fun(list(B),$o),Pa,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Ys2)) ) ) )
           => aa(list(B),$o,aa(list(B),fun(list(B),$o),Pa,A0),A1) ) ) ) ) ).

% shuffles.pinduct
tff(fact_4916_fold__Cons,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,fun(B,B)),X: C,Xs: list(C)] : ( fold(C,B,Fa,aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),X),Xs)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),fold(C,B,Fa,Xs)),aa(C,fun(B,B),Fa,X)) ) ).

% fold_Cons
tff(fact_4917_fold__commute,axiom,
    ! [B: $tType,D: $tType,C: $tType,Xs: list(B),H2: fun(C,D),Ga: fun(B,fun(C,C)),Fa: fun(B,fun(D,D))] :
      ( ! [X2: B] :
          ( member(B,X2,aa(list(B),set(B),set2(B),Xs))
         => ( aa(fun(C,C),fun(C,D),aa(fun(C,D),fun(fun(C,C),fun(C,D)),comp(C,D,C),H2),aa(B,fun(C,C),Ga,X2)) = aa(fun(C,D),fun(C,D),aa(fun(D,D),fun(fun(C,D),fun(C,D)),comp(D,D,C),aa(B,fun(D,D),Fa,X2)),H2) ) )
     => ( aa(fun(C,C),fun(C,D),aa(fun(C,D),fun(fun(C,C),fun(C,D)),comp(C,D,C),H2),fold(B,C,Ga,Xs)) = aa(fun(C,D),fun(C,D),aa(fun(D,D),fun(fun(C,D),fun(C,D)),comp(D,D,C),fold(B,D,Fa,Xs)),H2) ) ) ).

% fold_commute
tff(fact_4918_fold__commute__apply,axiom,
    ! [B: $tType,D: $tType,C: $tType,Xs: list(B),H2: fun(C,D),Ga: fun(B,fun(C,C)),Fa: fun(B,fun(D,D)),S: C] :
      ( ! [X2: B] :
          ( member(B,X2,aa(list(B),set(B),set2(B),Xs))
         => ( aa(fun(C,C),fun(C,D),aa(fun(C,D),fun(fun(C,C),fun(C,D)),comp(C,D,C),H2),aa(B,fun(C,C),Ga,X2)) = aa(fun(C,D),fun(C,D),aa(fun(D,D),fun(fun(C,D),fun(C,D)),comp(D,D,C),aa(B,fun(D,D),Fa,X2)),H2) ) )
     => ( aa(C,D,H2,aa(C,C,fold(B,C,Ga,Xs),S)) = aa(D,D,fold(B,D,Fa,Xs),aa(C,D,H2,S)) ) ) ).

% fold_commute_apply
tff(fact_4919_fold__multiset__equiv,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Fa: fun(B,fun(C,C)),Ys: list(B)] :
      ( ! [X2: B,Y2: B] :
          ( member(B,X2,aa(list(B),set(B),set2(B),Xs))
         => ( member(B,Y2,aa(list(B),set(B),set2(B),Xs))
           => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,Y2)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y2)),aa(B,fun(C,C),Fa,X2)) ) ) )
     => ( ( aa(list(B),multiset(B),mset(B),Xs) = aa(list(B),multiset(B),mset(B),Ys) )
       => ( fold(B,C,Fa,Xs) = fold(B,C,Fa,Ys) ) ) ) ).

% fold_multiset_equiv
tff(fact_4920_fold__remove1__split,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Fa: fun(B,fun(C,C)),X: B] :
      ( ! [X2: B,Y2: B] :
          ( member(B,X2,aa(list(B),set(B),set2(B),Xs))
         => ( member(B,Y2,aa(list(B),set(B),set2(B),Xs))
           => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,Y2)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y2)),aa(B,fun(C,C),Fa,X2)) ) ) )
     => ( member(B,X,aa(list(B),set(B),set2(B),Xs))
       => ( fold(B,C,Fa,Xs) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),fold(B,C,Fa,remove1(B,X,Xs))),aa(B,fun(C,C),Fa,X)) ) ) ) ).

% fold_remove1_split
tff(fact_4921_shuffles_Opsimps_I1_J,axiom,
    ! [B: $tType,Ys: list(B)] :
      ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Ys))
     => ( shuffles(B,nil(B),Ys) = aa(set(list(B)),set(list(B)),insert2(list(B),Ys),bot_bot(set(list(B)))) ) ) ).

% shuffles.psimps(1)
tff(fact_4922_shuffles_Opsimps_I2_J,axiom,
    ! [B: $tType,Xs: list(B)] :
      ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),nil(B)))
     => ( shuffles(B,Xs,nil(B)) = aa(set(list(B)),set(list(B)),insert2(list(B),Xs),bot_bot(set(list(B)))) ) ) ).

% shuffles.psimps(2)
tff(fact_4923_shuffles_Opsimps_I3_J,axiom,
    ! [B: $tType,X: B,Xs: list(B),Y: B,Ys: list(B)] :
      ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),shuffles_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)))
     => ( shuffles(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)) = aa(set(list(B)),set(list(B)),aa(set(list(B)),fun(set(list(B)),set(list(B))),sup_sup(set(list(B))),aa(set(list(B)),set(list(B)),image2(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X)),shuffles(B,Xs,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y),Ys)))),aa(set(list(B)),set(list(B)),image2(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y)),shuffles(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs),Ys))) ) ) ).

% shuffles.psimps(3)
tff(fact_4924_Sup__set__fold,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Xs: list(B)] : ( aa(set(B),B,complete_Sup_Sup(B),aa(list(B),set(B),set2(B),Xs)) = aa(B,B,fold(B,B,sup_sup(B),Xs),bot_bot(B)) ) ) ).

% Sup_set_fold
tff(fact_4925_Inf__set__fold,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Xs: list(B)] : ( aa(set(B),B,complete_Inf_Inf(B),aa(list(B),set(B),set2(B),Xs)) = aa(B,B,fold(B,B,inf_inf(B),Xs),top_top(B)) ) ) ).

% Inf_set_fold
tff(fact_4926_Inf__fin_Oset__eq__fold,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [X: B,Xs: list(B)] : ( aa(set(B),B,lattic7752659483105999362nf_fin(B),aa(list(B),set(B),set2(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs))) = aa(B,B,fold(B,B,inf_inf(B),Xs),X) ) ) ).

% Inf_fin.set_eq_fold
tff(fact_4927_Sup__fin_Oset__eq__fold,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [X: B,Xs: list(B)] : ( aa(set(B),B,lattic5882676163264333800up_fin(B),aa(list(B),set(B),set2(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs))) = aa(B,B,fold(B,B,sup_sup(B),Xs),X) ) ) ).

% Sup_fin.set_eq_fold
tff(fact_4928_splice_Opinduct,axiom,
    ! [B: $tType,A0: list(B),A1: list(B),Pa: fun(list(B),fun(list(B),$o))] :
      ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),splice_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),A0),A1))
     => ( ! [Ys2: list(B)] :
            ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),splice_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Ys2))
           => aa(list(B),$o,aa(list(B),fun(list(B),$o),Pa,nil(B)),Ys2) )
       => ( ! [X2: B,Xs3: list(B),Ys2: list(B)] :
              ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),splice_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),Ys2))
             => ( aa(list(B),$o,aa(list(B),fun(list(B),$o),Pa,Ys2),Xs3)
               => aa(list(B),$o,aa(list(B),fun(list(B),$o),Pa,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),Ys2) ) )
         => aa(list(B),$o,aa(list(B),fun(list(B),$o),Pa,A0),A1) ) ) ) ).

% splice.pinduct
tff(fact_4929_subset__eq__mset__impl_Opelims,axiom,
    ! [B: $tType,X: list(B),Xa: list(B),Y: option($o)] :
      ( ( subset_eq_mset_impl(B,X,Xa) = Y )
     => ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),subset751672762298770561pl_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Xa))
       => ( ( ( X = nil(B) )
           => ( ( Y = aa($o,option($o),some($o),( Xa != nil(B) )) )
             => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),subset751672762298770561pl_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Xa)) ) )
         => ~ ! [X2: B,Xs3: list(B)] :
                ( ( X = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
               => ( ( Y = case_option(option($o),product_prod(list(B),product_prod(B,list(B))),none($o),aa(fun(list(B),fun(product_prod(B,list(B)),option($o))),fun(product_prod(list(B),product_prod(B,list(B))),option($o)),product_case_prod(list(B),product_prod(B,list(B)),option($o)),aTP_Lamp_sp(list(B),fun(list(B),fun(product_prod(B,list(B)),option($o))),Xs3)),extract(B,aa(B,fun(B,$o),fequal(B),X2),Xa)) )
                 => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),subset751672762298770561pl_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),Xa)) ) ) ) ) ) ).

% subset_eq_mset_impl.pelims
tff(fact_4930_zipf__zip,axiom,
    ! [B: $tType,C: $tType,L1: list(B),L2: list(C)] :
      ( ( size_size(list(B),L1) = size_size(list(C),L2) )
     => ( zipf(B,C,product_prod(B,C),product_Pair(B,C),L1,L2) = zip(B,C,L1,L2) ) ) ).

% zipf_zip
tff(fact_4931_zipf_Opelims,axiom,
    ! [B: $tType,C: $tType,D: $tType,X: fun(C,fun(D,B)),Xa: list(C),Xb: list(D),Y: list(B)] :
      ( ( zipf(C,D,B,X,Xa,Xb) = Y )
     => ( aa(product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),$o,accp(product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),zipf_rel(C,D,B)),aa(product_prod(list(C),list(D)),product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),aa(fun(C,fun(D,B)),fun(product_prod(list(C),list(D)),product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D)))),product_Pair(fun(C,fun(D,B)),product_prod(list(C),list(D))),X),aa(list(D),product_prod(list(C),list(D)),aa(list(C),fun(list(D),product_prod(list(C),list(D))),product_Pair(list(C),list(D)),Xa),Xb)))
       => ( ( ( Xa = nil(C) )
           => ( ( Xb = nil(D) )
             => ( ( Y = nil(B) )
               => ~ aa(product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),$o,accp(product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),zipf_rel(C,D,B)),aa(product_prod(list(C),list(D)),product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),aa(fun(C,fun(D,B)),fun(product_prod(list(C),list(D)),product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D)))),product_Pair(fun(C,fun(D,B)),product_prod(list(C),list(D))),X),aa(list(D),product_prod(list(C),list(D)),aa(list(C),fun(list(D),product_prod(list(C),list(D))),product_Pair(list(C),list(D)),nil(C)),nil(D)))) ) ) )
         => ( ! [A8: C,As2: list(C)] :
                ( ( Xa = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),A8),As2) )
               => ! [B4: D,Bs2: list(D)] :
                    ( ( Xb = aa(list(D),list(D),aa(D,fun(list(D),list(D)),cons(D),B4),Bs2) )
                   => ( ( Y = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),aa(D,B,aa(C,fun(D,B),X,A8),B4)),zipf(C,D,B,X,As2,Bs2)) )
                     => ~ aa(product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),$o,accp(product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),zipf_rel(C,D,B)),aa(product_prod(list(C),list(D)),product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),aa(fun(C,fun(D,B)),fun(product_prod(list(C),list(D)),product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D)))),product_Pair(fun(C,fun(D,B)),product_prod(list(C),list(D))),X),aa(list(D),product_prod(list(C),list(D)),aa(list(C),fun(list(D),product_prod(list(C),list(D))),product_Pair(list(C),list(D)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),A8),As2)),aa(list(D),list(D),aa(D,fun(list(D),list(D)),cons(D),B4),Bs2)))) ) ) )
           => ( ! [V3: C,Va: list(C)] :
                  ( ( Xa = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),V3),Va) )
                 => ( ( Xb = nil(D) )
                   => ( ( Y = undefined(list(B)) )
                     => ~ aa(product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),$o,accp(product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),zipf_rel(C,D,B)),aa(product_prod(list(C),list(D)),product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),aa(fun(C,fun(D,B)),fun(product_prod(list(C),list(D)),product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D)))),product_Pair(fun(C,fun(D,B)),product_prod(list(C),list(D))),X),aa(list(D),product_prod(list(C),list(D)),aa(list(C),fun(list(D),product_prod(list(C),list(D))),product_Pair(list(C),list(D)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),V3),Va)),nil(D)))) ) ) )
             => ~ ( ( Xa = nil(C) )
                 => ! [V3: D,Va: list(D)] :
                      ( ( Xb = aa(list(D),list(D),aa(D,fun(list(D),list(D)),cons(D),V3),Va) )
                     => ( ( Y = undefined(list(B)) )
                       => ~ aa(product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),$o,accp(product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),zipf_rel(C,D,B)),aa(product_prod(list(C),list(D)),product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D))),aa(fun(C,fun(D,B)),fun(product_prod(list(C),list(D)),product_prod(fun(C,fun(D,B)),product_prod(list(C),list(D)))),product_Pair(fun(C,fun(D,B)),product_prod(list(C),list(D))),X),aa(list(D),product_prod(list(C),list(D)),aa(list(C),fun(list(D),product_prod(list(C),list(D))),product_Pair(list(C),list(D)),nil(C)),aa(list(D),list(D),aa(D,fun(list(D),list(D)),cons(D),V3),Va)))) ) ) ) ) ) ) ) ) ).

% zipf.pelims
tff(fact_4932_splice_Opelims,axiom,
    ! [B: $tType,X: list(B),Xa: list(B),Y: list(B)] :
      ( ( splice(B,X,Xa) = Y )
     => ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),splice_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Xa))
       => ( ( ( X = nil(B) )
           => ( ( Y = Xa )
             => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),splice_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Xa)) ) )
         => ~ ! [X2: B,Xs3: list(B)] :
                ( ( X = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
               => ( ( Y = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),splice(B,Xa,Xs3)) )
                 => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),splice_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)),Xa)) ) ) ) ) ) ).

% splice.pelims
tff(fact_4933_splice_Opsimps_I1_J,axiom,
    ! [B: $tType,Ys: list(B)] :
      ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),splice_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Ys))
     => ( splice(B,nil(B),Ys) = Ys ) ) ).

% splice.psimps(1)
tff(fact_4934_splice_Opsimps_I2_J,axiom,
    ! [B: $tType,X: B,Xs: list(B),Ys: list(B)] :
      ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),splice_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)),Ys))
     => ( splice(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs),Ys) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),splice(B,Ys,Xs)) ) ) ).

% splice.psimps(2)
tff(fact_4935_set__rec,axiom,
    ! [B: $tType,Xs: list(B)] : ( aa(list(B),set(B),set2(B),Xs) = aa(list(B),set(B),rec_list(set(B),B,bot_bot(set(B)),aTP_Lamp_sq(B,fun(list(B),fun(set(B),set(B))))),Xs) ) ).

% set_rec
tff(fact_4936_map__tailrec__rev_Opelims,axiom,
    ! [C: $tType,B: $tType,X: fun(C,B),Xa: list(C),Xb: list(B),Y: list(B)] :
      ( ( map_tailrec_rev(C,B,X,Xa,Xb) = Y )
     => ( aa(product_prod(fun(C,B),product_prod(list(C),list(B))),$o,accp(product_prod(fun(C,B),product_prod(list(C),list(B))),map_tailrec_rev_rel(C,B)),aa(product_prod(list(C),list(B)),product_prod(fun(C,B),product_prod(list(C),list(B))),aa(fun(C,B),fun(product_prod(list(C),list(B)),product_prod(fun(C,B),product_prod(list(C),list(B)))),product_Pair(fun(C,B),product_prod(list(C),list(B))),X),aa(list(B),product_prod(list(C),list(B)),aa(list(C),fun(list(B),product_prod(list(C),list(B))),product_Pair(list(C),list(B)),Xa),Xb)))
       => ( ( ( Xa = nil(C) )
           => ( ( Y = Xb )
             => ~ aa(product_prod(fun(C,B),product_prod(list(C),list(B))),$o,accp(product_prod(fun(C,B),product_prod(list(C),list(B))),map_tailrec_rev_rel(C,B)),aa(product_prod(list(C),list(B)),product_prod(fun(C,B),product_prod(list(C),list(B))),aa(fun(C,B),fun(product_prod(list(C),list(B)),product_prod(fun(C,B),product_prod(list(C),list(B)))),product_Pair(fun(C,B),product_prod(list(C),list(B))),X),aa(list(B),product_prod(list(C),list(B)),aa(list(C),fun(list(B),product_prod(list(C),list(B))),product_Pair(list(C),list(B)),nil(C)),Xb))) ) )
         => ~ ! [A8: C,As2: list(C)] :
                ( ( Xa = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),A8),As2) )
               => ( ( Y = map_tailrec_rev(C,B,X,As2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),aa(C,B,X,A8)),Xb)) )
                 => ~ aa(product_prod(fun(C,B),product_prod(list(C),list(B))),$o,accp(product_prod(fun(C,B),product_prod(list(C),list(B))),map_tailrec_rev_rel(C,B)),aa(product_prod(list(C),list(B)),product_prod(fun(C,B),product_prod(list(C),list(B))),aa(fun(C,B),fun(product_prod(list(C),list(B)),product_prod(fun(C,B),product_prod(list(C),list(B)))),product_Pair(fun(C,B),product_prod(list(C),list(B))),X),aa(list(B),product_prod(list(C),list(B)),aa(list(C),fun(list(B),product_prod(list(C),list(B))),product_Pair(list(C),list(B)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),A8),As2)),Xb))) ) ) ) ) ) ).

% map_tailrec_rev.pelims
tff(fact_4937_zip__left__commute,axiom,
    ! [C: $tType,B: $tType,D: $tType,Xs: list(B),Ys: list(C),Zs2: list(D)] : ( zip(B,product_prod(C,D),Xs,zip(C,D,Ys,Zs2)) = aa(list(product_prod(C,product_prod(B,D))),list(product_prod(B,product_prod(C,D))),map(product_prod(C,product_prod(B,D)),product_prod(B,product_prod(C,D)),aa(fun(C,fun(product_prod(B,D),product_prod(B,product_prod(C,D)))),fun(product_prod(C,product_prod(B,D)),product_prod(B,product_prod(C,D))),product_case_prod(C,product_prod(B,D),product_prod(B,product_prod(C,D))),aTP_Lamp_ss(C,fun(product_prod(B,D),product_prod(B,product_prod(C,D)))))),zip(C,product_prod(B,D),Ys,zip(B,D,Xs,Zs2))) ) ).

% zip_left_commute
tff(fact_4938_map__map,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(C,B),Ga: fun(D,C),Xs: list(D)] : ( aa(list(C),list(B),map(C,B,Fa),aa(list(D),list(C),map(D,C,Ga),Xs)) = aa(list(D),list(B),map(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Fa),Ga)),Xs) ) ).

% map_map
tff(fact_4939_List_Omap_Ocompositionality,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(C,B),Ga: fun(D,C),List: list(D)] : ( aa(list(C),list(B),map(C,B,Fa),aa(list(D),list(C),map(D,C,Ga),List)) = aa(list(D),list(B),map(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Fa),Ga)),List) ) ).

% List.map.compositionality
tff(fact_4940_list_Omap__comp,axiom,
    ! [C: $tType,B: $tType,D: $tType,Ga: fun(C,B),Fa: fun(D,C),V: list(D)] : ( aa(list(C),list(B),map(C,B,Ga),aa(list(D),list(C),map(D,C,Fa),V)) = aa(list(D),list(B),map(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Ga),Fa)),V) ) ).

% list.map_comp
tff(fact_4941_map__comp__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(D,C),Ga: fun(B,D)] : ( aa(fun(list(B),list(D)),fun(list(B),list(C)),aa(fun(list(D),list(C)),fun(fun(list(B),list(D)),fun(list(B),list(C))),comp(list(D),list(C),list(B)),map(D,C,Fa)),map(B,D,Ga)) = map(B,C,aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),Ga)) ) ).

% map_comp_map
tff(fact_4942_List_Omap_Ocomp,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(D,C),Ga: fun(B,D)] : ( aa(fun(list(B),list(D)),fun(list(B),list(C)),aa(fun(list(D),list(C)),fun(fun(list(B),list(D)),fun(list(B),list(C))),comp(list(D),list(C),list(B)),map(D,C,Fa)),map(B,D,Ga)) = map(B,C,aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),Ga)) ) ).

% List.map.comp
tff(fact_4943_map__fst__mk__snd,axiom,
    ! [C: $tType,B: $tType,K: C,L: list(B)] : ( aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),aa(list(B),list(product_prod(B,C)),map(B,product_prod(B,C),aa(C,fun(B,product_prod(B,C)),aTP_Lamp_ex(C,fun(B,product_prod(B,C))),K)),L)) = L ) ).

% map_fst_mk_snd
tff(fact_4944_map__snd__mk__fst,axiom,
    ! [C: $tType,B: $tType,K: C,L: list(B)] : ( aa(list(product_prod(C,B)),list(B),map(product_prod(C,B),B,product_snd(C,B)),aa(list(B),list(product_prod(C,B)),map(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),K)),L)) = L ) ).

% map_snd_mk_fst
tff(fact_4945_map__fst__mk__fst,axiom,
    ! [C: $tType,B: $tType,K: B,L: list(C)] : ( aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),aa(list(C),list(product_prod(B,C)),map(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K)),L)) = replicate(B,size_size(list(C),L),K) ) ).

% map_fst_mk_fst
tff(fact_4946_map__snd__mk__snd,axiom,
    ! [C: $tType,B: $tType,K: B,L: list(C)] : ( aa(list(product_prod(C,B)),list(B),map(product_prod(C,B),B,product_snd(C,B)),aa(list(C),list(product_prod(C,B)),map(C,product_prod(C,B),aa(B,fun(C,product_prod(C,B)),aTP_Lamp_es(B,fun(C,product_prod(C,B))),K)),L)) = replicate(B,size_size(list(C),L),K) ) ).

% map_snd_mk_snd
tff(fact_4947_list_Orec__o__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,Ga: C,Gaa: fun(D,fun(list(D),fun(C,C))),Fa: fun(B,D)] : ( aa(fun(list(B),list(D)),fun(list(B),C),aa(fun(list(D),C),fun(fun(list(B),list(D)),fun(list(B),C)),comp(list(D),C,list(B)),rec_list(C,D,Ga,Gaa)),map(B,D,Fa)) = rec_list(C,B,Ga,aa(fun(B,D),fun(B,fun(list(B),fun(C,C))),aTP_Lamp_st(fun(D,fun(list(D),fun(C,C))),fun(fun(B,D),fun(B,fun(list(B),fun(C,C)))),Gaa),Fa)) ) ).

% list.rec_o_map
tff(fact_4948_zip__map1,axiom,
    ! [B: $tType,D: $tType,C: $tType,Fa: fun(D,B),Xs: list(D),Ys: list(C)] : ( zip(B,C,aa(list(D),list(B),map(D,B,Fa),Xs),Ys) = aa(list(product_prod(D,C)),list(product_prod(B,C)),map(product_prod(D,C),product_prod(B,C),aa(fun(D,fun(C,product_prod(B,C))),fun(product_prod(D,C),product_prod(B,C)),product_case_prod(D,C,product_prod(B,C)),aTP_Lamp_su(fun(D,B),fun(D,fun(C,product_prod(B,C))),Fa))),zip(D,C,Xs,Ys)) ) ).

% zip_map1
tff(fact_4949_zip__map2,axiom,
    ! [C: $tType,B: $tType,D: $tType,Xs: list(B),Fa: fun(D,C),Ys: list(D)] : ( zip(B,C,Xs,aa(list(D),list(C),map(D,C,Fa),Ys)) = aa(list(product_prod(B,D)),list(product_prod(B,C)),map(product_prod(B,D),product_prod(B,C),aa(fun(B,fun(D,product_prod(B,C))),fun(product_prod(B,D),product_prod(B,C)),product_case_prod(B,D,product_prod(B,C)),aTP_Lamp_sv(fun(D,C),fun(B,fun(D,product_prod(B,C))),Fa))),zip(B,D,Xs,Ys)) ) ).

% zip_map2
tff(fact_4950_map__zip__map,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,Fa: fun(product_prod(C,D),B),Ga: fun(E,C),Xs: list(E),Ys: list(D)] : ( aa(list(product_prod(C,D)),list(B),map(product_prod(C,D),B,Fa),zip(C,D,aa(list(E),list(C),map(E,C,Ga),Xs),Ys)) = aa(list(product_prod(E,D)),list(B),map(product_prod(E,D),B,aa(fun(E,fun(D,B)),fun(product_prod(E,D),B),product_case_prod(E,D,B),aa(fun(E,C),fun(E,fun(D,B)),aTP_Lamp_sw(fun(product_prod(C,D),B),fun(fun(E,C),fun(E,fun(D,B))),Fa),Ga))),zip(E,D,Xs,Ys)) ) ).

% map_zip_map
tff(fact_4951_map__zip__map2,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,Fa: fun(product_prod(C,D),B),Xs: list(C),Ga: fun(E,D),Ys: list(E)] : ( aa(list(product_prod(C,D)),list(B),map(product_prod(C,D),B,Fa),zip(C,D,Xs,aa(list(E),list(D),map(E,D,Ga),Ys))) = aa(list(product_prod(C,E)),list(B),map(product_prod(C,E),B,aa(fun(C,fun(E,B)),fun(product_prod(C,E),B),product_case_prod(C,E,B),aa(fun(E,D),fun(C,fun(E,B)),aTP_Lamp_sx(fun(product_prod(C,D),B),fun(fun(E,D),fun(C,fun(E,B))),Fa),Ga))),zip(C,E,Xs,Ys)) ) ).

% map_zip_map2
tff(fact_4952_map__prod__fun__zip,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,Fa: fun(D,B),Ga: fun(E,C),Xs: list(D),Ys: list(E)] : ( aa(list(product_prod(D,E)),list(product_prod(B,C)),map(product_prod(D,E),product_prod(B,C),aa(fun(D,fun(E,product_prod(B,C))),fun(product_prod(D,E),product_prod(B,C)),product_case_prod(D,E,product_prod(B,C)),aa(fun(E,C),fun(D,fun(E,product_prod(B,C))),aTP_Lamp_it(fun(D,B),fun(fun(E,C),fun(D,fun(E,product_prod(B,C)))),Fa),Ga))),zip(D,E,Xs,Ys)) = zip(B,C,aa(list(D),list(B),map(D,B,Fa),Xs),aa(list(E),list(C),map(E,C,Ga),Ys)) ) ).

% map_prod_fun_zip
tff(fact_4953_set__oo__map__alt,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),X3: list(B)] : ( aa(list(B),set(C),aa(fun(list(B),list(C)),fun(list(B),set(C)),aa(fun(list(C),set(C)),fun(fun(list(B),list(C)),fun(list(B),set(C))),comp(list(C),set(C),list(B)),set2(C)),map(B,C,Fa)),X3) = aa(set(B),set(C),image2(B,C,Fa),aa(list(B),set(B),set2(B),X3)) ) ).

% set_oo_map_alt
tff(fact_4954_fold__map,axiom,
    ! [C: $tType,B: $tType,D: $tType,Ga: fun(C,fun(B,B)),Fa: fun(D,C),Xs: list(D)] : ( fold(C,B,Ga,aa(list(D),list(C),map(D,C,Fa),Xs)) = fold(D,B,aa(fun(D,C),fun(D,fun(B,B)),aa(fun(C,fun(B,B)),fun(fun(D,C),fun(D,fun(B,B))),comp(C,fun(B,B),D),Ga),Fa),Xs) ) ).

% fold_map
tff(fact_4955_zip__same__conv__map,axiom,
    ! [B: $tType,Xs: list(B)] : ( zip(B,B,Xs,Xs) = aa(list(B),list(product_prod(B,B)),map(B,product_prod(B,B),aTP_Lamp_cg(B,product_prod(B,B))),Xs) ) ).

% zip_same_conv_map
tff(fact_4956_product_Osimps_I2_J,axiom,
    ! [B: $tType,C: $tType,X: B,Xs: list(B),Ys: list(C)] : ( product(B,C,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs),Ys) = aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(list(product_prod(B,C)),fun(list(product_prod(B,C)),list(product_prod(B,C))),append(product_prod(B,C)),aa(list(C),list(product_prod(B,C)),map(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X)),Ys)),product(B,C,Xs,Ys)) ) ).

% product.simps(2)
tff(fact_4957_zip__commute,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Ys: list(C)] : ( zip(B,C,Xs,Ys) = aa(list(product_prod(C,B)),list(product_prod(B,C)),map(product_prod(C,B),product_prod(B,C),aa(fun(C,fun(B,product_prod(B,C))),fun(product_prod(C,B),product_prod(B,C)),product_case_prod(C,B,product_prod(B,C)),aTP_Lamp_ex(C,fun(B,product_prod(B,C))))),zip(C,B,Ys,Xs)) ) ).

% zip_commute
tff(fact_4958_distinct__map__fstD,axiom,
    ! [B: $tType,C: $tType,Xs: list(product_prod(B,C)),X: B,Y: C,Z2: C] :
      ( distinct(B,aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xs))
     => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),Xs))
       => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Z2),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),Xs))
         => ( Y = Z2 ) ) ) ) ).

% distinct_map_fstD
tff(fact_4959_eq__key__imp__eq__value,axiom,
    ! [B: $tType,C: $tType,Xs: list(product_prod(B,C)),K: B,V1: C,V22: C] :
      ( distinct(B,aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xs))
     => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K),V1),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),Xs))
       => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K),V22),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),Xs))
         => ( V1 = V22 ) ) ) ) ).

% eq_key_imp_eq_value
tff(fact_4960_zip__replicate1,axiom,
    ! [B: $tType,C: $tType,N: nat,X: B,Ys: list(C)] : ( zip(B,C,replicate(B,N,X),Ys) = aa(list(C),list(product_prod(B,C)),map(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X)),take(C,N,Ys)) ) ).

% zip_replicate1
tff(fact_4961_map__zip2,axiom,
    ! [B: $tType,C: $tType,K: B,L: list(C)] : ( aa(list(C),list(product_prod(B,C)),map(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K)),L) = zip(B,C,replicate(B,size_size(list(C),L),K),L) ) ).

% map_zip2
tff(fact_4962_map__zip1,axiom,
    ! [B: $tType,C: $tType,K: C,L: list(B)] : ( aa(list(B),list(product_prod(B,C)),map(B,product_prod(B,C),aa(C,fun(B,product_prod(B,C)),aTP_Lamp_ex(C,fun(B,product_prod(B,C))),K)),L) = zip(B,C,L,replicate(C,size_size(list(B),L),K)) ) ).

% map_zip1
tff(fact_4963_zip__replicate2,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),N: nat,Y: C] : ( zip(B,C,Xs,replicate(C,N,Y)) = aa(list(B),list(product_prod(B,C)),map(B,product_prod(B,C),aa(C,fun(B,product_prod(B,C)),aTP_Lamp_ex(C,fun(B,product_prod(B,C))),Y)),take(B,N,Xs)) ) ).

% zip_replicate2
tff(fact_4964_Id__on__set,axiom,
    ! [B: $tType,Xs: list(B)] : ( id_on(B,aa(list(B),set(B),set2(B),Xs)) = aa(list(product_prod(B,B)),set(product_prod(B,B)),set2(product_prod(B,B)),aa(list(B),list(product_prod(B,B)),map(B,product_prod(B,B),aTP_Lamp_cg(B,product_prod(B,B))),Xs)) ) ).

% Id_on_set
tff(fact_4965_map__of__eq__Some__iff,axiom,
    ! [C: $tType,B: $tType,Xys: list(product_prod(B,C)),X: B,Y: C] :
      ( distinct(B,aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xys))
     => ( ( aa(B,option(C),map_of(B,C,Xys),X) = aa(C,option(C),some(C),Y) )
      <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),Xys)) ) ) ).

% map_of_eq_Some_iff
tff(fact_4966_Some__eq__map__of__iff,axiom,
    ! [C: $tType,B: $tType,Xys: list(product_prod(B,C)),Y: C,X: B] :
      ( distinct(B,aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xys))
     => ( ( aa(C,option(C),some(C),Y) = aa(B,option(C),map_of(B,C,Xys),X) )
      <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),Xys)) ) ) ).

% Some_eq_map_of_iff
tff(fact_4967_map__of__is__SomeI,axiom,
    ! [B: $tType,C: $tType,Xys: list(product_prod(B,C)),X: B,Y: C] :
      ( distinct(B,aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xys))
     => ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),Xys))
       => ( aa(B,option(C),map_of(B,C,Xys),X) = aa(C,option(C),some(C),Y) ) ) ) ).

% map_of_is_SomeI
tff(fact_4968_weak__map__of__SomeI,axiom,
    ! [B: $tType,C: $tType,K: B,X: C,L: list(product_prod(B,C))] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),K),X),aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),L))
     => ? [X2: C] : ( aa(B,option(C),map_of(B,C,L),K) = aa(C,option(C),some(C),X2) ) ) ).

% weak_map_of_SomeI
tff(fact_4969_map__of__SomeD,axiom,
    ! [B: $tType,C: $tType,Xs: list(product_prod(C,B)),K: C,Y: B] :
      ( ( aa(C,option(B),map_of(C,B,Xs),K) = aa(B,option(B),some(B),Y) )
     => member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),K),Y),aa(list(product_prod(C,B)),set(product_prod(C,B)),set2(product_prod(C,B)),Xs)) ) ).

% map_of_SomeD
tff(fact_4970_map__of__Cons__code_I2_J,axiom,
    ! [B: $tType,C: $tType,L: C,V: B,Ps: list(product_prod(C,B)),K: C] :
      ( aa(C,option(B),map_of(C,B,aa(list(product_prod(C,B)),list(product_prod(C,B)),aa(product_prod(C,B),fun(list(product_prod(C,B)),list(product_prod(C,B))),cons(product_prod(C,B)),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),L),V)),Ps)),K)
      = $ite(L = K,aa(B,option(B),some(B),V),aa(C,option(B),map_of(C,B,Ps),K)) ) ).

% map_of_Cons_code(2)
tff(fact_4971_map__of__Some__split,axiom,
    ! [C: $tType,B: $tType,Xs: list(product_prod(C,B)),K: C,V: B] :
      ( ( aa(C,option(B),map_of(C,B,Xs),K) = aa(B,option(B),some(B),V) )
     => ? [Ys2: list(product_prod(C,B)),Zs: list(product_prod(C,B))] :
          ( ( Xs = aa(list(product_prod(C,B)),list(product_prod(C,B)),aa(list(product_prod(C,B)),fun(list(product_prod(C,B)),list(product_prod(C,B))),append(product_prod(C,B)),Ys2),aa(list(product_prod(C,B)),list(product_prod(C,B)),aa(product_prod(C,B),fun(list(product_prod(C,B)),list(product_prod(C,B))),cons(product_prod(C,B)),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),K),V)),Zs)) )
          & ( aa(C,option(B),map_of(C,B,Ys2),K) = none(B) ) ) ) ).

% map_of_Some_split
tff(fact_4972_zip__assoc,axiom,
    ! [C: $tType,B: $tType,D: $tType,Xs: list(B),Ys: list(C),Zs2: list(D)] : ( zip(B,product_prod(C,D),Xs,zip(C,D,Ys,Zs2)) = aa(list(product_prod(product_prod(B,C),D)),list(product_prod(B,product_prod(C,D))),map(product_prod(product_prod(B,C),D),product_prod(B,product_prod(C,D)),aa(fun(product_prod(B,C),fun(D,product_prod(B,product_prod(C,D)))),fun(product_prod(product_prod(B,C),D),product_prod(B,product_prod(C,D))),product_case_prod(product_prod(B,C),D,product_prod(B,product_prod(C,D))),aa(fun(B,fun(C,fun(D,product_prod(B,product_prod(C,D))))),fun(product_prod(B,C),fun(D,product_prod(B,product_prod(C,D)))),product_case_prod(B,C,fun(D,product_prod(B,product_prod(C,D)))),aTP_Lamp_sy(B,fun(C,fun(D,product_prod(B,product_prod(C,D)))))))),zip(product_prod(B,C),D,zip(B,C,Xs,Ys),Zs2)) ) ).

% zip_assoc
tff(fact_4973_map__of__map__keys,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),M4: fun(B,option(C))] :
      ( ( aa(list(B),set(B),set2(B),Xs) = dom(B,C,M4) )
     => ( map_of(B,C,aa(list(B),list(product_prod(B,C)),map(B,product_prod(B,C),aTP_Lamp_oc(fun(B,option(C)),fun(B,product_prod(B,C)),M4)),Xs)) = M4 ) ) ).

% map_of_map_keys
tff(fact_4974_map__of__distinct__lookup,axiom,
    ! [B: $tType,C: $tType,X: B,Xs: list(product_prod(B,C)),Ys: list(product_prod(B,C)),Y: C] :
      ( ~ member(B,X,aa(list(B),set(B),set2(B),aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xs)))
     => ( ~ member(B,X,aa(list(B),set(B),set2(B),aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Ys)))
       => ( aa(B,option(C),map_of(B,C,aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(list(product_prod(B,C)),fun(list(product_prod(B,C)),list(product_prod(B,C))),append(product_prod(B,C)),Xs),aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)),Ys))),X) = aa(C,option(C),some(C),Y) ) ) ) ).

% map_of_distinct_lookup
tff(fact_4975_map__of__mapk__SomeI,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(B,C),T4: list(product_prod(B,D)),K: B,X: D] :
      ( inj_on(B,C,Fa,top_top(set(B)))
     => ( ( aa(B,option(D),map_of(B,D,T4),K) = aa(D,option(D),some(D),X) )
       => ( aa(C,option(D),map_of(C,D,aa(list(product_prod(B,D)),list(product_prod(C,D)),map(product_prod(B,D),product_prod(C,D),aa(fun(B,fun(D,product_prod(C,D))),fun(product_prod(B,D),product_prod(C,D)),product_case_prod(B,D,product_prod(C,D)),aTP_Lamp_sz(fun(B,C),fun(B,fun(D,product_prod(C,D))),Fa))),T4)),aa(B,C,Fa,K)) = aa(D,option(D),some(D),X) ) ) ) ).

% map_of_mapk_SomeI
tff(fact_4976_map__of__map__restrict,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),Ks: list(B)] : ( map_of(B,C,aa(list(B),list(product_prod(B,C)),map(B,product_prod(B,C),aTP_Lamp_bp(fun(B,C),fun(B,product_prod(B,C)),Fa)),Ks)) = restrict_map(B,C,aa(fun(B,C),fun(B,option(C)),aa(fun(C,option(C)),fun(fun(B,C),fun(B,option(C))),comp(C,option(C),B),some(C)),Fa),aa(list(B),set(B),set2(B),Ks)) ) ).

% map_of_map_restrict
tff(fact_4977_map__of__distinct__upd3,axiom,
    ! [B: $tType,C: $tType,X: B,Xs: list(product_prod(B,C)),Ys: list(product_prod(B,C)),Y: C,Y6: C] :
      ( ~ member(B,X,aa(list(B),set(B),set2(B),aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xs)))
     => ( ~ member(B,X,aa(list(B),set(B),set2(B),aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Ys)))
       => ( map_of(B,C,aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(list(product_prod(B,C)),fun(list(product_prod(B,C)),list(product_prod(B,C))),append(product_prod(B,C)),Xs),aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)),Ys))) = fun_upd(B,option(C),map_of(B,C,aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(list(product_prod(B,C)),fun(list(product_prod(B,C)),list(product_prod(B,C))),append(product_prod(B,C)),Xs),aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y6)),Ys))),X,aa(C,option(C),some(C),Y)) ) ) ) ).

% map_of_distinct_upd3
tff(fact_4978_map__of__distinct__upd2,axiom,
    ! [B: $tType,C: $tType,X: B,Xs: list(product_prod(B,C)),Ys: list(product_prod(B,C)),Y: C] :
      ( ~ member(B,X,aa(list(B),set(B),set2(B),aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xs)))
     => ( ~ member(B,X,aa(list(B),set(B),set2(B),aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Ys)))
       => ( map_of(B,C,aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(list(product_prod(B,C)),fun(list(product_prod(B,C)),list(product_prod(B,C))),append(product_prod(B,C)),Xs),aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)),Ys))) = fun_upd(B,option(C),map_of(B,C,aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(list(product_prod(B,C)),fun(list(product_prod(B,C)),list(product_prod(B,C))),append(product_prod(B,C)),Xs),Ys)),X,aa(C,option(C),some(C),Y)) ) ) ) ).

% map_of_distinct_upd2
tff(fact_4979_map__of__distinct__upd4,axiom,
    ! [B: $tType,C: $tType,X: B,Xs: list(product_prod(B,C)),Ys: list(product_prod(B,C)),Y: C] :
      ( ~ member(B,X,aa(list(B),set(B),set2(B),aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Xs)))
     => ( ~ member(B,X,aa(list(B),set(B),set2(B),aa(list(product_prod(B,C)),list(B),map(product_prod(B,C),B,product_fst(B,C)),Ys)))
       => ( map_of(B,C,aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(list(product_prod(B,C)),fun(list(product_prod(B,C)),list(product_prod(B,C))),append(product_prod(B,C)),Xs),Ys)) = fun_upd(B,option(C),map_of(B,C,aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(list(product_prod(B,C)),fun(list(product_prod(B,C)),list(product_prod(B,C))),append(product_prod(B,C)),Xs),aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y)),Ys))),X,none(C)) ) ) ) ).

% map_of_distinct_upd4
tff(fact_4980_set__relcomp,axiom,
    ! [C: $tType,D: $tType,B: $tType,Xys: list(product_prod(B,D)),Yzs: list(product_prod(D,C))] : ( relcomp(B,D,C,aa(list(product_prod(B,D)),set(product_prod(B,D)),set2(product_prod(B,D)),Xys),aa(list(product_prod(D,C)),set(product_prod(D,C)),set2(product_prod(D,C)),Yzs)) = aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),concat(product_prod(B,C),aa(list(product_prod(B,D)),list(list(product_prod(B,C))),map(product_prod(B,D),list(product_prod(B,C)),aTP_Lamp_tb(list(product_prod(D,C)),fun(product_prod(B,D),list(product_prod(B,C))),Yzs)),Xys))) ) ).

% set_relcomp
tff(fact_4981_execute__make,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,Fa: fun(nat,B),H2: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(array(B)),fun(heap_ext(product_unit),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(array(B)),array_make(B,N,Fa)),H2) = aa(product_prod(array(B),product_prod(heap_ext(product_unit),nat)),option(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),some(product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rs(nat,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),N)),array_alloc(B,aa(list(nat),list(B),map(nat,B,Fa),upt(zero_zero(nat),N)),H2))) ) ) ).

% execute_make
tff(fact_4982_map__of__Some__filter__not__in,axiom,
    ! [C: $tType,B: $tType,Xs: list(product_prod(C,B)),K: C,V: B,Pa: fun(product_prod(C,B),$o)] :
      ( ( aa(C,option(B),map_of(C,B,Xs),K) = aa(B,option(B),some(B),V) )
     => ( ~ aa(product_prod(C,B),$o,Pa,aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),K),V))
       => ( distinct(C,aa(list(product_prod(C,B)),list(C),map(product_prod(C,B),C,product_fst(C,B)),Xs))
         => ( aa(C,option(B),map_of(C,B,filter2(product_prod(C,B),Pa,Xs)),K) = none(B) ) ) ) ) ).

% map_of_Some_filter_not_in
tff(fact_4983_partition__filter__conv,axiom,
    ! [B: $tType,Fa: fun(B,$o),Xs: list(B)] : ( aa(list(B),product_prod(list(B),list(B)),partition(B,Fa),Xs) = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),filter2(B,Fa,Xs)),filter2(B,aa(fun(B,$o),fun(B,$o),aa(fun($o,$o),fun(fun(B,$o),fun(B,$o)),comp($o,$o,B),fNot),Fa),Xs)) ) ).

% partition_filter_conv
tff(fact_4984_length__filter__map,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),Fa: fun(C,B),Xs: list(C)] : ( size_size(list(B),filter2(B,Pa,aa(list(C),list(B),map(C,B,Fa),Xs))) = size_size(list(C),filter2(C,aa(fun(C,B),fun(C,$o),aa(fun(B,$o),fun(fun(C,B),fun(C,$o)),comp(B,$o,C),Pa),Fa),Xs)) ) ).

% length_filter_map
tff(fact_4985_filter__map,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),Fa: fun(C,B),Xs: list(C)] : ( filter2(B,Pa,aa(list(C),list(B),map(C,B,Fa),Xs)) = aa(list(C),list(B),map(C,B,Fa),filter2(C,aa(fun(C,B),fun(C,$o),aa(fun(B,$o),fun(fun(C,B),fun(C,$o)),comp(B,$o,C),Pa),Fa),Xs)) ) ).

% filter_map
tff(fact_4986_inter__set__filter,axiom,
    ! [B: $tType,A4: set(B),Xs: list(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),aa(list(B),set(B),set2(B),Xs)) = aa(list(B),set(B),set2(B),filter2(B,aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),A4),Xs)) ) ).

% inter_set_filter
tff(fact_4987_partition__filter2,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B)] : ( aa(product_prod(list(B),list(B)),list(B),product_snd(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),partition(B,Pa),Xs)) = filter2(B,aa(fun(B,$o),fun(B,$o),aa(fun($o,$o),fun(fun(B,$o),fun(B,$o)),comp($o,$o,B),fNot),Pa),Xs) ) ).

% partition_filter2
tff(fact_4988_enumerate__map__upt,axiom,
    ! [B: $tType,N: nat,Fa: fun(nat,B),M4: nat] : ( enumerate(B,N,aa(list(nat),list(B),map(nat,B,Fa),upt(N,M4))) = aa(list(nat),list(product_prod(nat,B)),map(nat,product_prod(nat,B),aTP_Lamp_tc(fun(nat,B),fun(nat,product_prod(nat,B)),Fa)),upt(N,M4)) ) ).

% enumerate_map_upt
tff(fact_4989_make__rule,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,Fa: fun(nat,B)] : hoare_hoare_triple(array(B),one_one(assn),array_make(B,N,Fa),aa(fun(nat,B),fun(array(B),assn),aTP_Lamp_td(nat,fun(fun(nat,B),fun(array(B),assn)),N),Fa)) ) ).

% make_rule
tff(fact_4990_set__minus__filter__out,axiom,
    ! [B: $tType,Xs: list(B),Y: B] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(set(B),set(B),insert2(B,Y),bot_bot(set(B)))) = aa(list(B),set(B),set2(B),filter2(B,aTP_Lamp_te(B,fun(B,$o),Y),Xs)) ) ).

% set_minus_filter_out
tff(fact_4991_filter__shuffles__disjoint1_I2_J,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs2: list(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
     => ( member(list(B),Zs2,shuffles(B,Xs,Ys))
       => ( filter2(B,aTP_Lamp_tf(list(B),fun(B,$o),Xs),Zs2) = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
tff(fact_4992_filter__shuffles__disjoint1_I1_J,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs2: list(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
     => ( member(list(B),Zs2,shuffles(B,Xs,Ys))
       => ( filter2(B,aTP_Lamp_tg(list(B),fun(B,$o),Xs),Zs2) = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
tff(fact_4993_filter__shuffles__disjoint2_I2_J,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs2: list(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
     => ( member(list(B),Zs2,shuffles(B,Xs,Ys))
       => ( filter2(B,aTP_Lamp_tf(list(B),fun(B,$o),Ys),Zs2) = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
tff(fact_4994_filter__shuffles__disjoint2_I1_J,axiom,
    ! [B: $tType,Xs: list(B),Ys: list(B),Zs2: list(B)] :
      ( ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Xs)),aa(list(B),set(B),set2(B),Ys)) = bot_bot(set(B)) )
     => ( member(list(B),Zs2,shuffles(B,Xs,Ys))
       => ( filter2(B,aTP_Lamp_tg(list(B),fun(B,$o),Ys),Zs2) = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
tff(fact_4995_product__concat__map,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Ys: list(C)] : ( product(B,C,Xs,Ys) = concat(product_prod(B,C),aa(list(B),list(list(product_prod(B,C))),map(B,list(product_prod(B,C)),aTP_Lamp_th(list(C),fun(B,list(product_prod(B,C))),Ys)),Xs)) ) ).

% product_concat_map
tff(fact_4996_distinct__concat,axiom,
    ! [B: $tType,Xs: list(list(B))] :
      ( distinct(list(B),Xs)
     => ( ! [Ys2: list(B)] :
            ( member(list(B),Ys2,aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
           => distinct(B,Ys2) )
       => ( ! [Ys2: list(B),Zs: list(B)] :
              ( member(list(B),Ys2,aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
             => ( member(list(B),Zs,aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
               => ( ( Ys2 != Zs )
                 => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Ys2)),aa(list(B),set(B),set2(B),Zs)) = bot_bot(set(B)) ) ) ) )
         => distinct(B,concat(B,Xs)) ) ) ) ).

% distinct_concat
tff(fact_4997_effect__makeI,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A3: array(B),H4: heap_ext(product_unit),Fa: fun(nat,B),N: nat,H2: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),product_prod(array(B),heap_ext(product_unit)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),heap_ext(product_unit))),product_Pair(array(B),heap_ext(product_unit)),A3),H4) = array_alloc(B,aa(list(nat),list(B),map(nat,B,Fa),upt(zero_zero(nat),N)),H2) )
         => heap_Time_effect(array(B),array_make(B,N,Fa),H2,H4,A3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) ) ).

% effect_makeI
tff(fact_4998_enumerate__replicate__eq,axiom,
    ! [B: $tType,N: nat,M4: nat,A3: B] : ( enumerate(B,N,replicate(B,M4,A3)) = aa(list(nat),list(product_prod(nat,B)),map(nat,product_prod(nat,B),aTP_Lamp_ti(B,fun(nat,product_prod(nat,B)),A3)),upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M4))) ) ).

% enumerate_replicate_eq
tff(fact_4999_distinct__length__filter,axiom,
    ! [B: $tType,Xs: list(B),Pa: fun(B,$o)] :
      ( distinct(B,Xs)
     => ( size_size(list(B),filter2(B,Pa,Xs)) = finite_card(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(fun(B,$o),set(B),collect(B),Pa)),aa(list(B),set(B),set2(B),Xs))) ) ) ).

% distinct_length_filter
tff(fact_5000_part__def,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Fa: fun(B,C),Pivot: C,Xs: list(B)] : ( linorder_part(B,C,Fa,Pivot,Xs) = aa(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))),aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_Pair(list(B),product_prod(list(B),list(B))),filter2(B,aa(C,fun(B,$o),aTP_Lamp_tj(fun(B,C),fun(C,fun(B,$o)),Fa),Pivot),Xs)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),filter2(B,aa(C,fun(B,$o),aTP_Lamp_tk(fun(B,C),fun(C,fun(B,$o)),Fa),Pivot),Xs)),filter2(B,aa(C,fun(B,$o),aTP_Lamp_tl(fun(B,C),fun(C,fun(B,$o)),Fa),Pivot),Xs))) ) ) ).

% part_def
tff(fact_5001_distinct__concat__iff,axiom,
    ! [B: $tType,Xs: list(list(B))] :
      ( distinct(B,concat(B,Xs))
    <=> ( distinct(list(B),removeAll(list(B),nil(B),Xs))
        & ! [Ys3: list(B)] :
            ( member(list(B),Ys3,aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
           => distinct(B,Ys3) )
        & ! [Ys3: list(B),Zs3: list(B)] :
            ( ( member(list(B),Ys3,aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
              & member(list(B),Zs3,aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
              & ( Ys3 != Zs3 ) )
           => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Ys3)),aa(list(B),set(B),set2(B),Zs3)) = bot_bot(set(B)) ) ) ) ) ).

% distinct_concat_iff
tff(fact_5002_Array__Time_Omake__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [N: nat,Fa: fun(nat,B)] : ( array_make(B,N,Fa) = heap_Time_heap(array(B),aa(fun(nat,B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_tm(nat,fun(fun(nat,B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),N),Fa)) ) ) ).

% Array_Time.make_def
tff(fact_5003_product__code,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Ys: list(C)] : ( product_product(B,C,aa(list(B),set(B),set2(B),Xs),aa(list(C),set(C),set2(C),Ys)) = aa(list(product_prod(B,C)),set(product_prod(B,C)),set2(product_prod(B,C)),concat(product_prod(B,C),aa(list(B),list(list(product_prod(B,C))),map(B,list(product_prod(B,C)),aTP_Lamp_th(list(C),fun(B,list(product_prod(B,C))),Ys)),Xs))) ) ).

% product_code
tff(fact_5004_map__filter__def,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,option(B)),Xs: list(C)] : ( map_filter(C,B,Fa,Xs) = aa(list(C),list(B),map(C,B,aa(fun(C,option(B)),fun(C,B),aa(fun(option(B),B),fun(fun(C,option(B)),fun(C,B)),comp(option(B),B,C),the2(B)),Fa)),filter2(C,aTP_Lamp_tn(fun(C,option(B)),fun(C,$o),Fa),Xs)) ) ).

% map_filter_def
tff(fact_5005_zip__Cons1,axiom,
    ! [B: $tType,C: $tType,X: B,Xs: list(B),Ys: list(C)] : ( zip(B,C,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs),Ys) = case_list(list(product_prod(B,C)),C,nil(product_prod(B,C)),aa(list(B),fun(C,fun(list(C),list(product_prod(B,C)))),aTP_Lamp_to(B,fun(list(B),fun(C,fun(list(C),list(product_prod(B,C))))),X),Xs),Ys) ) ).

% zip_Cons1
tff(fact_5006_distinct__concat_H,axiom,
    ! [B: $tType,Xs: list(list(B))] :
      ( distinct(list(B),filter2(list(B),aTP_Lamp_tp(list(B),$o),Xs))
     => ( ! [Ys2: list(B)] :
            ( member(list(B),Ys2,aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
           => distinct(B,Ys2) )
       => ( ! [Ys2: list(B),Zs: list(B)] :
              ( member(list(B),Ys2,aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
             => ( member(list(B),Zs,aa(list(list(B)),set(list(B)),set2(list(B)),Xs))
               => ( ( Ys2 != Zs )
                 => ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(list(B),set(B),set2(B),Ys2)),aa(list(B),set(B),set2(B),Zs)) = bot_bot(set(B)) ) ) ) )
         => distinct(B,concat(B,Xs)) ) ) ) ).

% distinct_concat'
tff(fact_5007_zip__Cons,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Y: C,Ys: list(C)] : ( zip(B,C,Xs,aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),Y),Ys)) = case_list(list(product_prod(B,C)),B,nil(product_prod(B,C)),aa(list(C),fun(B,fun(list(B),list(product_prod(B,C)))),aTP_Lamp_tq(C,fun(list(C),fun(B,fun(list(B),list(product_prod(B,C))))),Y),Ys),Xs) ) ).

% zip_Cons
tff(fact_5008_in__measures_I2_J,axiom,
    ! [B: $tType,X: B,Y: B,Fa: fun(B,nat),Fs: list(fun(B,nat))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),measures(B,aa(list(fun(B,nat)),list(fun(B,nat)),aa(fun(B,nat),fun(list(fun(B,nat)),list(fun(B,nat))),cons(fun(B,nat)),Fa),Fs)))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,Fa,X)),aa(B,nat,Fa,Y))
        | ( ( aa(B,nat,Fa,X) = aa(B,nat,Fa,Y) )
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),measures(B,Fs)) ) ) ) ).

% in_measures(2)
tff(fact_5009_partition__rev_Opelims,axiom,
    ! [B: $tType,X: fun(B,$o),Xa: product_prod(list(B),list(B)),Xb: list(B),Y: product_prod(list(B),list(B))] :
      ( ( partition_rev(B,X,Xa,Xb) = Y )
     => ( aa(product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),$o,accp(product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),partition_rev_rel(B)),aa(product_prod(product_prod(list(B),list(B)),list(B)),product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),aa(fun(B,$o),fun(product_prod(product_prod(list(B),list(B)),list(B)),product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B)))),product_Pair(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),X),aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),Xa),Xb)))
       => ( ! [Yes: list(B),No: list(B)] :
              ( ( Xa = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),No) )
             => ( ( Xb = nil(B) )
               => ( ( Y = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),No) )
                 => ~ aa(product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),$o,accp(product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),partition_rev_rel(B)),aa(product_prod(product_prod(list(B),list(B)),list(B)),product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),aa(fun(B,$o),fun(product_prod(product_prod(list(B),list(B)),list(B)),product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B)))),product_Pair(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),X),aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),No)),nil(B)))) ) ) )
         => ~ ! [Yes: list(B),No: list(B)] :
                ( ( Xa = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),No) )
               => ! [X2: B,Xs3: list(B)] :
                    ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
                   => ( ( Y
                        = partition_rev(B,X,$ite(aa(B,$o,X,X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Yes)),No),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),No))),Xs3) )
                     => ~ aa(product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),$o,accp(product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),partition_rev_rel(B)),aa(product_prod(product_prod(list(B),list(B)),list(B)),product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),aa(fun(B,$o),fun(product_prod(product_prod(list(B),list(B)),list(B)),product_prod(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B)))),product_Pair(fun(B,$o),product_prod(product_prod(list(B),list(B)),list(B))),X),aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),No)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)))) ) ) ) ) ) ) ).

% partition_rev.pelims
tff(fact_5010_list__collect__set__map__simps_I1_J,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(C,set(B)),X: fun(D,C)] : ( list_collect_set(C,B,Fa,aa(list(D),list(C),map(D,C,X),nil(D))) = bot_bot(set(B)) ) ).

% list_collect_set_map_simps(1)
tff(fact_5011_in__measures_I1_J,axiom,
    ! [B: $tType,X: B,Y: B] : ~ member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),measures(B,nil(fun(B,nat)))) ).

% in_measures(1)
tff(fact_5012_list__collect__set__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,set(B))] : ( list_collect_set(C,B,Fa,nil(C)) = bot_bot(set(B)) ) ).

% list_collect_set_simps(1)
tff(fact_5013_partition__rev_Osimps_I2_J,axiom,
    ! [B: $tType,Pa: fun(B,$o),Yes2: list(B),No2: list(B),X: B,Xs: list(B)] :
      ( partition_rev(B,Pa,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes2),No2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs))
      = partition_rev(B,Pa,$ite(aa(B,$o,Pa,X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Yes2)),No2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),No2))),Xs) ) ).

% partition_rev.simps(2)
tff(fact_5014_partition__rev_Osimps_I1_J,axiom,
    ! [B: $tType,Pa: fun(B,$o),Yes2: list(B),No2: list(B)] : ( partition_rev(B,Pa,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes2),No2),nil(B)) = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes2),No2) ) ).

% partition_rev.simps(1)
tff(fact_5015_measures__less,axiom,
    ! [B: $tType,Fa: fun(B,nat),X: B,Y: B,Fs: list(fun(B,nat))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,Fa,X)),aa(B,nat,Fa,Y))
     => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),measures(B,aa(list(fun(B,nat)),list(fun(B,nat)),aa(fun(B,nat),fun(list(fun(B,nat)),list(fun(B,nat))),cons(fun(B,nat)),Fa),Fs))) ) ).

% measures_less
tff(fact_5016_measures__lesseq,axiom,
    ! [B: $tType,Fa: fun(B,nat),X: B,Y: B,Fs: list(fun(B,nat))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(B,nat,Fa,X)),aa(B,nat,Fa,Y))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),measures(B,Fs))
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),measures(B,aa(list(fun(B,nat)),list(fun(B,nat)),aa(fun(B,nat),fun(list(fun(B,nat)),list(fun(B,nat))),cons(fun(B,nat)),Fa),Fs))) ) ) ).

% measures_lesseq
tff(fact_5017_partition__rev_Oelims,axiom,
    ! [B: $tType,X: fun(B,$o),Xa: product_prod(list(B),list(B)),Xb: list(B),Y: product_prod(list(B),list(B))] :
      ( ( partition_rev(B,X,Xa,Xb) = Y )
     => ( ! [Yes: list(B),No: list(B)] :
            ( ( Xa = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),No) )
           => ( ( Xb = nil(B) )
             => ( Y != aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),No) ) ) )
       => ~ ! [Yes: list(B),No: list(B)] :
              ( ( Xa = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),No) )
             => ! [X2: B,Xs3: list(B)] :
                  ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
                 => ( Y
                   != partition_rev(B,X,$ite(aa(B,$o,X,X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Yes)),No),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),No))),Xs3) ) ) ) ) ) ).

% partition_rev.elims
tff(fact_5018_quicksort__by__rel_Osimps_I2_J,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),Sl2: list(B),X: B,Xs: list(B)] : ( quicksort_by_rel(B,R,Sl2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)) = aa(product_prod(list(B),list(B)),list(B),aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aa(B,fun(list(B),fun(list(B),list(B))),aa(list(B),fun(B,fun(list(B),fun(list(B),list(B)))),aTP_Lamp_tr(fun(B,fun(B,$o)),fun(list(B),fun(B,fun(list(B),fun(list(B),list(B))))),R),Sl2),X)),partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),R),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs)) ) ).

% quicksort_by_rel.simps(2)
tff(fact_5019_quicksort__by__rel_Oelims,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B),Xb: list(B),Y: list(B)] :
      ( ( quicksort_by_rel(B,X,Xa,Xb) = Y )
     => ( ( ( Xb = nil(B) )
         => ( Y != Xa ) )
       => ~ ! [X2: B,Xs3: list(B)] :
              ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
             => ( Y != aa(product_prod(list(B),list(B)),list(B),aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aa(B,fun(list(B),fun(list(B),list(B))),aa(list(B),fun(B,fun(list(B),fun(list(B),list(B)))),aTP_Lamp_tr(fun(B,fun(B,$o)),fun(list(B),fun(B,fun(list(B),fun(list(B),list(B))))),X),Xa),X2)),partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),X),X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs3)) ) ) ) ) ).

% quicksort_by_rel.elims
tff(fact_5020_quicksort__by__rel_Opelims,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B),Xb: list(B),Y: list(B)] :
      ( ( quicksort_by_rel(B,X,Xa,Xb) = Y )
     => ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xa),Xb)))
       => ( ( ( Xb = nil(B) )
           => ( ( Y = Xa )
             => ~ aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xa),nil(B)))) ) )
         => ~ ! [X2: B,Xs3: list(B)] :
                ( ( Xb = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3) )
               => ( ( Y = aa(product_prod(list(B),list(B)),list(B),aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aa(B,fun(list(B),fun(list(B),list(B))),aa(list(B),fun(B,fun(list(B),fun(list(B),list(B)))),aTP_Lamp_tr(fun(B,fun(B,$o)),fun(list(B),fun(B,fun(list(B),fun(list(B),list(B))))),X),Xa),X2)),partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),X),X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs3)) )
                 => ~ aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xa),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)))) ) ) ) ) ) ).

% quicksort_by_rel.pelims
tff(fact_5021_quicksort__by__rel_Opsimps_I1_J,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),Sl2: list(B)] :
      ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Sl2),nil(B))))
     => ( quicksort_by_rel(B,R,Sl2,nil(B)) = Sl2 ) ) ).

% quicksort_by_rel.psimps(1)
tff(fact_5022_quicksort__by__rel_Opinduct,axiom,
    ! [B: $tType,A0: fun(B,fun(B,$o)),A1: list(B),A22: list(B),Pa: fun(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)))] :
      ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),A0),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),A1),A22)))
     => ( ! [R13: fun(B,fun(B,$o)),Sl: list(B)] :
            ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R13),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Sl),nil(B))))
           => aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)),Pa,R13),Sl),nil(B)) )
       => ( ! [R13: fun(B,fun(B,$o)),Sl: list(B),X2: B,Xs3: list(B)] :
              ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R13),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Sl),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3))))
             => ( ! [Xa3: product_prod(list(B),list(B)),Xb2: list(B),Y4: list(B)] :
                    ( ( Xa3 = partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),R13),X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs3) )
                   => ( ( aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xb2),Y4) = Xa3 )
                     => aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)),Pa,R13),Sl),Y4) ) )
               => ( ! [Xa3: product_prod(list(B),list(B)),Xb2: list(B),Y4: list(B)] :
                      ( ( Xa3 = partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),R13),X2),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs3) )
                     => ( ( aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xb2),Y4) = Xa3 )
                       => aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)),Pa,R13),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),quicksort_by_rel(B,R13,Sl,Y4))),Xb2) ) )
                 => aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)),Pa,R13),Sl),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs3)) ) ) )
         => aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(fun(B,fun(B,$o)),fun(list(B),fun(list(B),$o)),Pa,A0),A1),A22) ) ) ) ).

% quicksort_by_rel.pinduct
tff(fact_5023_quicksort__by__rel_Opsimps_I2_J,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o)),Sl2: list(B),X: B,Xs: list(B)] :
      ( aa(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),$o,accp(product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),quicksort_by_rel_rel(B)),aa(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B))),aa(fun(B,fun(B,$o)),fun(product_prod(list(B),list(B)),product_prod(fun(B,fun(B,$o)),product_prod(list(B),list(B)))),product_Pair(fun(B,fun(B,$o)),product_prod(list(B),list(B))),R),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Sl2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs))))
     => ( quicksort_by_rel(B,R,Sl2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)) = aa(product_prod(list(B),list(B)),list(B),aa(fun(list(B),fun(list(B),list(B))),fun(product_prod(list(B),list(B)),list(B)),product_case_prod(list(B),list(B),list(B)),aa(B,fun(list(B),fun(list(B),list(B))),aa(list(B),fun(B,fun(list(B),fun(list(B),list(B)))),aTP_Lamp_tr(fun(B,fun(B,$o)),fun(list(B),fun(B,fun(list(B),fun(list(B),list(B))))),R),Sl2),X)),partition_rev(B,aa(B,fun(B,$o),aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),R),X),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),nil(B)),Xs)) ) ) ).

% quicksort_by_rel.psimps(2)
tff(fact_5024_horner__sum__foldr,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_semiring_0(B)
     => ! [Fa: fun(C,B),A3: B,Xs: list(C)] : ( aa(list(C),B,aa(B,fun(list(C),B),aa(fun(C,B),fun(B,fun(list(C),B)),groups4207007520872428315er_sum(C,B),Fa),A3),Xs) = aa(B,B,foldr(C,B,aa(B,fun(C,fun(B,B)),aTP_Lamp_tt(fun(C,B),fun(B,fun(C,fun(B,B))),Fa),A3),Xs),zero_zero(B)) ) ) ).

% horner_sum_foldr
tff(fact_5025_horner__sum__transfer,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType] :
      ( ( comm_semiring_0(C)
        & comm_semiring_0(B) )
     => ! [A4: fun(B,fun(C,$o)),B2: fun(D,fun(E,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),A4,zero_zero(B)),zero_zero(C))
         => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),A4,bNF_rel_fun(B,C,B,C,A4,A4)),plus_plus(B)),plus_plus(C))
           => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),A4,bNF_rel_fun(B,C,B,C,A4,A4)),times_times(B)),times_times(C))
             => aa(fun(fun(E,C),fun(C,fun(list(E),C))),$o,aa(fun(fun(D,B),fun(B,fun(list(D),B))),fun(fun(fun(E,C),fun(C,fun(list(E),C))),$o),bNF_rel_fun(fun(D,B),fun(E,C),fun(B,fun(list(D),B)),fun(C,fun(list(E),C)),bNF_rel_fun(D,E,B,C,B2,A4),bNF_rel_fun(B,C,fun(list(D),B),fun(list(E),C),A4,bNF_rel_fun(list(D),list(E),B,C,list_all2(D,E,B2),A4))),groups4207007520872428315er_sum(D,B)),groups4207007520872428315er_sum(E,C)) ) ) ) ) ).

% horner_sum_transfer
tff(fact_5026_partition__rev__filter__conv,axiom,
    ! [B: $tType,Pa: fun(B,$o),Yes2: list(B),No2: list(B),Xs: list(B)] : ( partition_rev(B,Pa,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Yes2),No2),Xs) = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),rev(B,filter2(B,Pa,Xs))),Yes2)),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),rev(B,filter2(B,aa(fun(B,$o),fun(B,$o),aa(fun($o,$o),fun(fun(B,$o),fun(B,$o)),comp($o,$o,B),fNot),Pa),Xs))),No2)) ) ).

% partition_rev_filter_conv
tff(fact_5027_foldr_Ofoldr__Cons,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,fun(B,B)),X: C,Xs: list(C)] : ( foldr(C,B,Fa,aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),X),Xs)) = aa(fun(B,B),fun(B,B),aa(fun(B,B),fun(fun(B,B),fun(B,B)),comp(B,B,B),aa(C,fun(B,B),Fa,X)),foldr(C,B,Fa,Xs)) ) ).

% foldr.foldr_Cons
tff(fact_5028_foldr__map,axiom,
    ! [D: $tType,C: $tType,B: $tType,Ga: fun(C,fun(B,B)),Fa: fun(D,C),Xs: list(D),A3: B] : ( aa(B,B,foldr(C,B,Ga,aa(list(D),list(C),map(D,C,Fa),Xs)),A3) = aa(B,B,foldr(D,B,aa(fun(D,C),fun(D,fun(B,B)),aa(fun(C,fun(B,B)),fun(fun(D,C),fun(D,fun(B,B))),comp(C,fun(B,B),D),Ga),Fa),Xs),A3) ) ).

% foldr_map
tff(fact_5029_fold__rev,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Fa: fun(B,fun(C,C))] :
      ( ! [X2: B,Y2: B] :
          ( member(B,X2,aa(list(B),set(B),set2(B),Xs))
         => ( member(B,Y2,aa(list(B),set(B),set2(B),Xs))
           => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y2)),aa(B,fun(C,C),Fa,X2)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,Y2)) ) ) )
     => ( fold(B,C,Fa,rev(B,Xs)) = fold(B,C,Fa,Xs) ) ) ).

% fold_rev
tff(fact_5030_foldr__fold,axiom,
    ! [C: $tType,B: $tType,Xs: list(B),Fa: fun(B,fun(C,C))] :
      ( ! [X2: B,Y2: B] :
          ( member(B,X2,aa(list(B),set(B),set2(B),Xs))
         => ( member(B,Y2,aa(list(B),set(B),set2(B),Xs))
           => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y2)),aa(B,fun(C,C),Fa,X2)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,Y2)) ) ) )
     => ( foldr(B,C,Fa,Xs) = fold(B,C,Fa,Xs) ) ) ).

% foldr_fold
tff(fact_5031_prod__list__transfer,axiom,
    ! [B: $tType,C: $tType] :
      ( ( monoid_mult(C)
        & monoid_mult(B) )
     => ! [A4: fun(B,fun(C,$o))] :
          ( aa(C,$o,aa(B,fun(C,$o),A4,one_one(B)),one_one(C))
         => ( aa(fun(C,fun(C,C)),$o,aa(fun(B,fun(B,B)),fun(fun(C,fun(C,C)),$o),bNF_rel_fun(B,C,fun(B,B),fun(C,C),A4,bNF_rel_fun(B,C,B,C,A4,A4)),times_times(B)),times_times(C))
           => aa(fun(list(C),C),$o,aa(fun(list(B),B),fun(fun(list(C),C),$o),bNF_rel_fun(list(B),list(C),B,C,list_all2(B,C,A4),A4),groups5270119922927024881d_list(B)),groups5270119922927024881d_list(C)) ) ) ) ).

% prod_list_transfer
tff(fact_5032_lexordp__conv__lexord,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Xs: list(B),Ys: list(B)] :
          ( ord_lexordp(B,Xs,Ys)
        <=> member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs),Ys),lexord(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),ord_less(B))))) ) ) ).

% lexordp_conv_lexord
tff(fact_5033_revg_Opelims,axiom,
    ! [B: $tType,X: list(B),Xa: list(B),Y: list(B)] :
      ( ( revg(B,X,Xa) = Y )
     => ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),revg_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Xa))
       => ( ( ( X = nil(B) )
           => ( ( Y = Xa )
             => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),revg_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Xa)) ) )
         => ~ ! [A8: B,As2: list(B)] :
                ( ( X = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2) )
               => ( ( Y = revg(B,As2,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),Xa)) )
                 => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),revg_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2)),Xa)) ) ) ) ) ) ).

% revg.pelims
tff(fact_5034_prod__list_OCons,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [X: B,Xs: list(B)] : ( aa(list(B),B,groups5270119922927024881d_list(B),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),X),aa(list(B),B,groups5270119922927024881d_list(B),Xs)) ) ) ).

% prod_list.Cons
tff(fact_5035_prod__list_ONil,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ( aa(list(B),B,groups5270119922927024881d_list(B),nil(B)) = one_one(B) ) ) ).

% prod_list.Nil
tff(fact_5036_prod__list_Oappend,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Xs: list(B),Ys: list(B)] : ( aa(list(B),B,groups5270119922927024881d_list(B),aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xs),Ys)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(list(B),B,groups5270119922927024881d_list(B),Xs)),aa(list(B),B,groups5270119922927024881d_list(B),Ys)) ) ) ).

% prod_list.append
tff(fact_5037_prod__list_Oeq__foldr,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Xs: list(B)] : ( aa(list(B),B,groups5270119922927024881d_list(B),Xs) = aa(B,B,foldr(B,B,times_times(B),Xs),one_one(B)) ) ) ).

% prod_list.eq_foldr
tff(fact_5038_map__of__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(D,C),Xs: list(product_prod(B,D))] : ( map_of(B,C,aa(list(product_prod(B,D)),list(product_prod(B,C)),map(product_prod(B,D),product_prod(B,C),aa(fun(B,fun(D,product_prod(B,C))),fun(product_prod(B,D),product_prod(B,C)),product_case_prod(B,D,product_prod(B,C)),aTP_Lamp_sv(fun(D,C),fun(B,fun(D,product_prod(B,C))),Fa))),Xs)) = aa(fun(B,option(D)),fun(B,option(C)),aa(fun(option(D),option(C)),fun(fun(B,option(D)),fun(B,option(C))),comp(option(D),option(C),B),map_option(D,C,Fa)),map_of(B,D,Xs)) ) ).

% map_of_map
tff(fact_5039_assert__def,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: B] :
      ( heap_Time_assert(B,Pa,X)
      = $ite(aa(B,$o,Pa,X),aa(B,heap_Time_Heap(B),heap_Time_return(B),X),heap_Time_raise(B,aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2($true,$false,$false,$false,$false,$true,$true,$false)),aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2($true,$true,$false,$false,$true,$true,$true,$false)),aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2($true,$true,$false,$false,$true,$true,$true,$false)),aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2($true,$false,$true,$false,$false,$true,$true,$false)),aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2($false,$true,$false,$false,$true,$true,$true,$false)),aa(list(char),list(char),aa(char,fun(list(char),list(char)),cons(char),char2($false,$false,$true,$false,$true,$true,$true,$false)),nil(char))))))))) ) ).

% assert_def
tff(fact_5040_prod__list__def,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ( groups5270119922927024881d_list(B) = groups_monoid_F(B,times_times(B),one_one(B)) ) ) ).

% prod_list_def
tff(fact_5041_case__map__option,axiom,
    ! [C: $tType,B: $tType,D: $tType,Ga: B,H2: fun(C,B),Fa: fun(D,C),X: option(D)] : ( case_option(B,C,Ga,H2,aa(option(D),option(C),map_option(D,C,Fa),X)) = case_option(B,D,Ga,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),H2),Fa),X) ) ).

% case_map_option
tff(fact_5042_dom__map__option__comp,axiom,
    ! [C: $tType,D: $tType,B: $tType,Ga: fun(D,C),M4: fun(B,option(D))] : ( dom(B,C,aa(fun(B,option(D)),fun(B,option(C)),aa(fun(option(D),option(C)),fun(fun(B,option(D)),fun(B,option(C))),comp(option(D),option(C),B),map_option(D,C,Ga)),M4)) = dom(B,D,M4) ) ).

% dom_map_option_comp
tff(fact_5043_map__option__o__empty,axiom,
    ! [B: $tType,D: $tType,C: $tType,Fa: fun(D,C),X3: B] : ( aa(B,option(C),aa(fun(B,option(D)),fun(B,option(C)),aa(fun(option(D),option(C)),fun(fun(B,option(D)),fun(B,option(C))),comp(option(D),option(C),B),map_option(D,C,Fa)),aTP_Lamp_tu(B,option(D))),X3) = none(C) ) ).

% map_option_o_empty
tff(fact_5044_map__option__o__map__upd,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(D,C),M4: fun(B,option(D)),A3: B,Ba: D] : ( aa(fun(B,option(D)),fun(B,option(C)),aa(fun(option(D),option(C)),fun(fun(B,option(D)),fun(B,option(C))),comp(option(D),option(C),B),map_option(D,C,Fa)),fun_upd(B,option(D),M4,A3,aa(D,option(D),some(D),Ba))) = fun_upd(B,option(C),aa(fun(B,option(D)),fun(B,option(C)),aa(fun(option(D),option(C)),fun(fun(B,option(D)),fun(B,option(C))),comp(option(D),option(C),B),map_option(D,C,Fa)),M4),A3,aa(C,option(C),some(C),aa(D,C,Fa,Ba))) ) ).

% map_option_o_map_upd
tff(fact_5045_map__option_Ocompositionality,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(C,B),Ga: fun(D,C),Option: option(D)] : ( aa(option(C),option(B),map_option(C,B,Fa),aa(option(D),option(C),map_option(D,C,Ga),Option)) = aa(option(D),option(B),map_option(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Fa),Ga)),Option) ) ).

% map_option.compositionality
tff(fact_5046_option_Omap__comp,axiom,
    ! [C: $tType,B: $tType,D: $tType,Ga: fun(C,B),Fa: fun(D,C),V: option(D)] : ( aa(option(C),option(B),map_option(C,B,Ga),aa(option(D),option(C),map_option(D,C,Fa),V)) = aa(option(D),option(B),map_option(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Ga),Fa)),V) ) ).

% option.map_comp
tff(fact_5047_map__option_Ocomp,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(D,C),Ga: fun(B,D)] : ( aa(fun(option(B),option(D)),fun(option(B),option(C)),aa(fun(option(D),option(C)),fun(fun(option(B),option(D)),fun(option(B),option(C))),comp(option(D),option(C),option(B)),map_option(D,C,Fa)),map_option(B,D,Ga)) = map_option(B,C,aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),Ga)) ) ).

% map_option.comp
tff(fact_5048_option_Osize__gen__o__map,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,nat),Ga: fun(B,C)] : ( aa(fun(option(B),option(C)),fun(option(B),nat),aa(fun(option(C),nat),fun(fun(option(B),option(C)),fun(option(B),nat)),comp(option(C),nat,option(B)),size_option(C,Fa)),map_option(B,C,Ga)) = size_option(B,aa(fun(B,C),fun(B,nat),aa(fun(C,nat),fun(fun(B,C),fun(B,nat)),comp(C,nat,B),Fa),Ga)) ) ).

% option.size_gen_o_map
tff(fact_5049_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [R3: B,Xs: list(C)] : ( groups8242544230860333062m_list(B,aa(list(C),list(B),map(C,B,aTP_Lamp_at(B,fun(C,B),R3)),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),size_size(list(C),Xs))),R3) ) ) ).

% sum_list_triv
tff(fact_5050_merge_Opelims,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [X: list(B),Xa: list(B),Y: list(B)] :
          ( ( merge(B,X,Xa) = Y )
         => ( aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),merge_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),X),Xa))
           => ( ( ( X = nil(B) )
               => ( ( Y = Xa )
                 => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),merge_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),nil(B)),Xa)) ) )
             => ( ! [V3: B,Va: list(B)] :
                    ( ( X = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va) )
                   => ( ( Xa = nil(B) )
                     => ( ( Y = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va) )
                       => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),merge_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va)),nil(B))) ) ) )
               => ~ ! [X12: B,L12: list(B)] :
                      ( ( X = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),L12) )
                     => ! [X23: B,L22: list(B)] :
                          ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),L22) )
                         => ( ( Y
                              = $ite(
                                  aa(B,$o,aa(B,fun(B,$o),ord_less(B),X12),X23),
                                  aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),merge(B,L12,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),L22))),
                                  $ite(X12 = X23,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),merge(B,L12,L22)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),merge(B,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),L12),L22))) ) )
                           => ~ aa(product_prod(list(B),list(B)),$o,accp(product_prod(list(B),list(B)),merge_rel(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),L12)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),L22))) ) ) ) ) ) ) ) ) ).

% merge.pelims
tff(fact_5051_sum__list__const__mult,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [C2: B,Fa: fun(C,B),Xs: list(C)] : ( groups8242544230860333062m_list(B,aa(list(C),list(B),map(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_bd(B,fun(fun(C,B),fun(C,B)),C2),Fa)),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),C2),groups8242544230860333062m_list(B,aa(list(C),list(B),map(C,B,Fa),Xs))) ) ) ).

% sum_list_const_mult
tff(fact_5052_sum__list__mult__const,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_0(B)
     => ! [Fa: fun(C,B),C2: B,Xs: list(C)] : ( groups8242544230860333062m_list(B,aa(list(C),list(B),map(C,B,aa(B,fun(C,B),aTP_Lamp_bc(fun(C,B),fun(B,fun(C,B)),Fa),C2)),Xs)) = aa(B,B,aa(B,fun(B,B),times_times(B),groups8242544230860333062m_list(B,aa(list(C),list(B),map(C,B,Fa),Xs))),C2) ) ) ).

% sum_list_mult_const
tff(fact_5053_uminus__sum__list__map,axiom,
    ! [B: $tType,C: $tType] :
      ( ab_group_add(B)
     => ! [Fa: fun(C,B),Xs: list(C)] : ( aa(B,B,uminus_uminus(B),groups8242544230860333062m_list(B,aa(list(C),list(B),map(C,B,Fa),Xs))) = groups8242544230860333062m_list(B,aa(list(C),list(B),map(C,B,aa(fun(C,B),fun(C,B),aa(fun(B,B),fun(fun(C,B),fun(C,B)),comp(B,B,C),uminus_uminus(B)),Fa)),Xs)) ) ) ).

% uminus_sum_list_map
tff(fact_5054_sum__list__replicate,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [N: nat,C2: B] : ( groups8242544230860333062m_list(B,replicate(B,N,C2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),N)),C2) ) ) ).

% sum_list_replicate
tff(fact_5055_option_Orec__o__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,Ga: C,Gaa: fun(D,C),Fa: fun(B,D)] : ( aa(fun(option(B),option(D)),fun(option(B),C),aa(fun(option(D),C),fun(fun(option(B),option(D)),fun(option(B),C)),comp(option(D),C,option(B)),rec_option(C,D,Ga,Gaa)),map_option(B,D,Fa)) = rec_option(C,B,Ga,aa(fun(B,D),fun(B,C),aTP_Lamp_tv(fun(D,C),fun(fun(B,D),fun(B,C)),Gaa),Fa)) ) ).

% option.rec_o_map
tff(fact_5056_mergesort__by__rel__split_Opelims,axiom,
    ! [B: $tType,X: product_prod(list(B),list(B)),Xa: list(B),Y: product_prod(list(B),list(B))] :
      ( ( merges295452479951948502_split(B,X,Xa) = Y )
     => ( aa(product_prod(product_prod(list(B),list(B)),list(B)),$o,accp(product_prod(product_prod(list(B),list(B)),list(B)),merges7066485432131860899it_rel(B)),aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),X),Xa))
       => ( ! [Xs12: list(B),Xs22: list(B)] :
              ( ( X = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22) )
             => ( ( Xa = nil(B) )
               => ( ( Y = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22) )
                 => ~ aa(product_prod(product_prod(list(B),list(B)),list(B)),$o,accp(product_prod(product_prod(list(B),list(B)),list(B)),merges7066485432131860899it_rel(B)),aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22)),nil(B))) ) ) )
         => ( ! [Xs12: list(B),Xs22: list(B)] :
                ( ( X = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22) )
               => ! [X2: B] :
                    ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)) )
                   => ( ( Y = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Xs12)),Xs22) )
                     => ~ aa(product_prod(product_prod(list(B),list(B)),list(B)),$o,accp(product_prod(product_prod(list(B),list(B)),list(B)),merges7066485432131860899it_rel(B)),aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)))) ) ) )
           => ~ ! [Xs12: list(B),Xs22: list(B)] :
                  ( ( X = aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22) )
                 => ! [X12: B,X23: B,Xs3: list(B)] :
                      ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),Xs3)) )
                     => ( ( Y = merges295452479951948502_split(B,aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),Xs12)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),Xs22)),Xs3) )
                       => ~ aa(product_prod(product_prod(list(B),list(B)),list(B)),$o,accp(product_prod(product_prod(list(B),list(B)),list(B)),merges7066485432131860899it_rel(B)),aa(list(B),product_prod(product_prod(list(B),list(B)),list(B)),aa(product_prod(list(B),list(B)),fun(list(B),product_prod(product_prod(list(B),list(B)),list(B))),product_Pair(product_prod(list(B),list(B)),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Xs12),Xs22)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X12),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X23),Xs3)))) ) ) ) ) ) ) ) ).

% mergesort_by_rel_split.pelims
tff(fact_5057_size__list__map,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,nat),Ga: fun(C,B),Xs: list(C)] : ( aa(list(B),nat,size_list(B,Fa),aa(list(C),list(B),map(C,B,Ga),Xs)) = aa(list(C),nat,size_list(C,aa(fun(C,B),fun(C,nat),aa(fun(B,nat),fun(fun(C,B),fun(C,nat)),comp(B,nat,C),Fa),Ga)),Xs) ) ).

% size_list_map
tff(fact_5058_list_Osize__gen__o__map,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,nat),Ga: fun(B,C)] : ( aa(fun(list(B),list(C)),fun(list(B),nat),aa(fun(list(C),nat),fun(fun(list(B),list(C)),fun(list(B),nat)),comp(list(C),nat,list(B)),size_list(C,Fa)),map(B,C,Ga)) = size_list(B,aa(fun(B,C),fun(B,nat),aa(fun(C,nat),fun(fun(B,C),fun(B,nat)),comp(C,nat,B),Fa),Ga)) ) ).

% list.size_gen_o_map
tff(fact_5059_make_H__def,axiom,
    ! [B: $tType,C: $tType] :
      ( ( semiring_1(C)
        & heap(B) )
     => ! [I: code_integer,Fa: fun(C,B)] : ( array_make2(C,B,I,Fa) = array_make(B,aa(code_integer,nat,code_nat_of_integer,I),aa(fun(nat,C),fun(nat,B),aa(fun(C,B),fun(fun(nat,C),fun(nat,B)),comp(C,B,nat),Fa),semiring_1_of_nat(C))) ) ) ).

% make'_def
tff(fact_5060_next_Osimps,axiom,
    ! [V: code_natural,W2: code_natural] :
      ( aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),V),W2))
      = $let(
          v: code_natural,
          v := minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,V,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),divide_divide(code_natural,V,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,one2)))))))))))))))),
          $let(
            w2: code_natural,
            w2 := minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),modulo_modulo(code_natural,W2,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,one2))))))))))))))))),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),divide_divide(code_natural,W2,aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,one2)))))))))))))))))),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,one2)))))))))))))),
            aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),minus_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),v,aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),w2),one_one(code_natural)))),one_one(code_natural))),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),v),w2)) ) ) ) ).

% next.simps
tff(fact_5061_inter__coset__fold,axiom,
    ! [B: $tType,A4: set(B),Xs: list(B)] : ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),coset(B,Xs)) = aa(set(B),set(B),fold(B,set(B),remove(B),Xs),A4) ) ).

% inter_coset_fold
tff(fact_5062_log_Ocases,axiom,
    ! [X: product_prod(code_natural,code_natural)] :
      ~ ! [B4: code_natural,I3: code_natural] : ( X != aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),B4),I3) ) ).

% log.cases
tff(fact_5063_iter_Ocases,axiom,
    ! [B: $tType,X: product_prod(fun(product_prod(code_natural,code_natural),product_prod(product_prod(B,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),product_prod(code_natural,product_prod(code_natural,code_natural)))] :
      ~ ! [Random: fun(product_prod(code_natural,code_natural),product_prod(product_prod(B,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),Nrandom: code_natural,Seed: product_prod(code_natural,code_natural)] : ( X != aa(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(fun(product_prod(code_natural,code_natural),product_prod(product_prod(B,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),product_prod(code_natural,product_prod(code_natural,code_natural))),aa(fun(product_prod(code_natural,code_natural),product_prod(product_prod(B,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),fun(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(fun(product_prod(code_natural,code_natural),product_prod(product_prod(B,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),product_prod(code_natural,product_prod(code_natural,code_natural)))),product_Pair(fun(product_prod(code_natural,code_natural),product_prod(product_prod(B,fun(product_unit,code_term)),product_prod(code_natural,code_natural))),product_prod(code_natural,product_prod(code_natural,code_natural))),Random),aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),Nrandom),Seed)) ) ).

% iter.cases
tff(fact_5064_exhaustive__fun_H_Ocases,axiom,
    ! [B: $tType,C: $tType] :
      ( ( quickc658316121487927005ustive(C)
        & cl_HOL_Oequal(B)
        & quickc658316121487927005ustive(B) )
     => ! [X: product_prod(fun(fun(B,C),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural))] :
          ~ ! [F8: fun(fun(B,C),option(product_prod($o,list(code_term)))),I3: code_natural,D3: code_natural] : ( X != aa(product_prod(code_natural,code_natural),product_prod(fun(fun(B,C),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural)),aa(fun(fun(B,C),option(product_prod($o,list(code_term)))),fun(product_prod(code_natural,code_natural),product_prod(fun(fun(B,C),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural))),product_Pair(fun(fun(B,C),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural)),F8),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),I3),D3)) ) ) ).

% exhaustive_fun'.cases
tff(fact_5065_exhaustive__natural_H_Ocases,axiom,
    ! [X: product_prod(fun(code_natural,option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural))] :
      ~ ! [F8: fun(code_natural,option(product_prod($o,list(code_term)))),D3: code_natural,I3: code_natural] : ( X != aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural)),aa(fun(code_natural,option(product_prod($o,list(code_term)))),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural)),F8),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),D3),I3)) ) ).

% exhaustive_natural'.cases
tff(fact_5066_full__exhaustive__fun_H_Ocases,axiom,
    ! [B: $tType,C: $tType] :
      ( ( quickc3360725361186068524ustive(C)
        & cl_HOL_Oequal(B)
        & quickc3360725361186068524ustive(B) )
     => ! [X: product_prod(fun(product_prod(fun(B,C),fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural))] :
          ~ ! [F8: fun(product_prod(fun(B,C),fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),I3: code_natural,D3: code_natural] : ( X != aa(product_prod(code_natural,code_natural),product_prod(fun(product_prod(fun(B,C),fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural)),aa(fun(product_prod(fun(B,C),fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),fun(product_prod(code_natural,code_natural),product_prod(fun(product_prod(fun(B,C),fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural))),product_Pair(fun(product_prod(fun(B,C),fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural)),F8),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),I3),D3)) ) ) ).

% full_exhaustive_fun'.cases
tff(fact_5067_full__exhaustive__natural_H_Ocases,axiom,
    ! [X: product_prod(fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural))] :
      ~ ! [F8: fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),D3: code_natural,I3: code_natural] : ( X != aa(product_prod(code_natural,code_natural),product_prod(fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural)),aa(fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),fun(product_prod(code_natural,code_natural),product_prod(fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural))),product_Pair(fun(product_prod(code_natural,fun(product_unit,code_term)),option(product_prod($o,list(code_term)))),product_prod(code_natural,code_natural)),F8),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),D3),I3)) ) ).

% full_exhaustive_natural'.cases
tff(fact_5068_nth_H__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [A3: array(B)] : ( array_nth2(B,A3) = aa(fun(code_integer,nat),fun(code_integer,heap_Time_Heap(B)),aa(fun(nat,heap_Time_Heap(B)),fun(fun(code_integer,nat),fun(code_integer,heap_Time_Heap(B))),comp(nat,heap_Time_Heap(B),code_integer),array_nth(B,A3)),code_nat_of_integer) ) ) ).

% nth'_def
tff(fact_5069_new_H__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ( array_new2(B) = aa(fun(code_integer,nat),fun(code_integer,fun(B,heap_Time_Heap(array(B)))),aa(fun(nat,fun(B,heap_Time_Heap(array(B)))),fun(fun(code_integer,nat),fun(code_integer,fun(B,heap_Time_Heap(array(B))))),comp(nat,fun(B,heap_Time_Heap(array(B))),code_integer),array_new(B)),code_nat_of_integer) ) ) ).

% new'_def
tff(fact_5070_split__seed__def,axiom,
    ! [S: product_prod(code_natural,code_natural)] : ( split_seed(S) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_case_prod(code_natural,code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aTP_Lamp_tx(product_prod(code_natural,code_natural),fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),S)),S) ) ).

% split_seed_def
tff(fact_5071_Lazy__Sequence_Oiterate__upto_Ocases,axiom,
    ! [B: $tType,X: product_prod(fun(code_natural,B),product_prod(code_natural,code_natural))] :
      ~ ! [F8: fun(code_natural,B),N3: code_natural,M5: code_natural] : ( X != aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),aa(fun(code_natural,B),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,B),product_prod(code_natural,code_natural)),F8),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),N3),M5)) ) ).

% Lazy_Sequence.iterate_upto.cases
tff(fact_5072_Predicate_Oiterate__upto_Opinduct,axiom,
    ! [B: $tType,A0: fun(code_natural,B),A1: code_natural,A22: code_natural,Pa: fun(fun(code_natural,B),fun(code_natural,fun(code_natural,$o)))] :
      ( aa(product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),$o,accp(product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),iterate_upto_rel(B)),aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),aa(fun(code_natural,B),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,B),product_prod(code_natural,code_natural)),A0),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),A1),A22)))
     => ( ! [F8: fun(code_natural,B),N3: code_natural,M5: code_natural] :
            ( aa(product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),$o,accp(product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),iterate_upto_rel(B)),aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),aa(fun(code_natural,B),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,B),product_prod(code_natural,code_natural)),F8),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),N3),M5)))
           => ( ! [X3: product_unit] :
                  ( ~ aa(code_natural,$o,aa(code_natural,fun(code_natural,$o),ord_less(code_natural),M5),N3)
                 => aa(code_natural,$o,aa(code_natural,fun(code_natural,$o),aa(fun(code_natural,B),fun(code_natural,fun(code_natural,$o)),Pa,F8),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),N3),one_one(code_natural))),M5) )
             => aa(code_natural,$o,aa(code_natural,fun(code_natural,$o),aa(fun(code_natural,B),fun(code_natural,fun(code_natural,$o)),Pa,F8),N3),M5) ) )
       => aa(code_natural,$o,aa(code_natural,fun(code_natural,$o),aa(fun(code_natural,B),fun(code_natural,fun(code_natural,$o)),Pa,A0),A1),A22) ) ) ).

% Predicate.iterate_upto.pinduct
tff(fact_5073_Random_Orange__def,axiom,
    ! [K: code_natural] : ( range(K) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),iterate(code_natural,product_prod(code_natural,code_natural),log(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),K),aTP_Lamp_tz(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))))),one_one(code_natural)),aTP_Lamp_ua(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),K)) ) ).

% Random.range_def
tff(fact_5074_scomp__Pair,axiom,
    ! [D: $tType,C: $tType,B: $tType,X: fun(B,product_prod(C,D))] : ( product_scomp(B,C,D,product_prod(C,D),X,product_Pair(C,D)) = X ) ).

% scomp_Pair
tff(fact_5075_Pair__scomp,axiom,
    ! [B: $tType,C: $tType,D: $tType,X: D,Fa: fun(D,fun(B,C))] : ( product_scomp(B,D,B,C,aa(D,fun(B,product_prod(D,B)),product_Pair(D,B),X),Fa) = aa(D,fun(B,C),Fa,X) ) ).

% Pair_scomp
tff(fact_5076_small__lazy_H_Ocases,axiom,
    ! [X: product_prod(int,int)] :
      ~ ! [D3: int,I3: int] : ( X != aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),D3),I3) ) ).

% small_lazy'.cases
tff(fact_5077_iterate_Osimps,axiom,
    ! [B: $tType,C: $tType,K: code_natural,Fa: fun(C,fun(B,product_prod(C,B))),X: C] :
      ( aa(C,fun(B,product_prod(C,B)),iterate(C,B,K,Fa),X)
      = $ite(K = zero_zero(code_natural),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X),product_scomp(B,C,B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),Fa,X),iterate(C,B,aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),minus_minus(code_natural),K),one_one(code_natural)),Fa))) ) ).

% iterate.simps
tff(fact_5078_iterate_Oelims,axiom,
    ! [B: $tType,C: $tType,X: code_natural,Xa: fun(C,fun(B,product_prod(C,B))),Xb: C,Y: fun(B,product_prod(C,B))] :
      ( ( aa(C,fun(B,product_prod(C,B)),iterate(C,B,X,Xa),Xb) = Y )
     => ( Y
        = $ite(X = zero_zero(code_natural),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Xb),product_scomp(B,C,B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),Xa,Xb),iterate(C,B,aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),minus_minus(code_natural),X),one_one(code_natural)),Xa))) ) ) ).

% iterate.elims
tff(fact_5079_log_Opelims,axiom,
    ! [X: code_natural,Xa: code_natural,Y: code_natural] :
      ( ( log(X,Xa) = Y )
     => ( aa(product_prod(code_natural,code_natural),$o,accp(product_prod(code_natural,code_natural),log_rel),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),X),Xa))
       => ~ ( ( Y
              = $ite(
                  ( aa(code_natural,$o,aa(code_natural,fun(code_natural,$o),ord_less_eq(code_natural),X),one_one(code_natural))
                  | aa(code_natural,$o,aa(code_natural,fun(code_natural,$o),ord_less(code_natural),Xa),X) ),
                  one_one(code_natural),
                  aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),one_one(code_natural)),log(X,divide_divide(code_natural,Xa,X))) ) )
           => ~ aa(product_prod(code_natural,code_natural),$o,accp(product_prod(code_natural,code_natural),log_rel),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),X),Xa)) ) ) ) ).

% log.pelims
tff(fact_5080_iterate_Opelims,axiom,
    ! [B: $tType,C: $tType,X: code_natural,Xa: fun(C,fun(B,product_prod(C,B))),Xb: C,Y: fun(B,product_prod(C,B))] :
      ( ( aa(C,fun(B,product_prod(C,B)),iterate(C,B,X,Xa),Xb) = Y )
     => ( aa(product_prod(code_natural,product_prod(fun(C,fun(B,product_prod(C,B))),C)),$o,accp(product_prod(code_natural,product_prod(fun(C,fun(B,product_prod(C,B))),C)),iterate_rel(C,B)),aa(product_prod(fun(C,fun(B,product_prod(C,B))),C),product_prod(code_natural,product_prod(fun(C,fun(B,product_prod(C,B))),C)),aa(code_natural,fun(product_prod(fun(C,fun(B,product_prod(C,B))),C),product_prod(code_natural,product_prod(fun(C,fun(B,product_prod(C,B))),C))),product_Pair(code_natural,product_prod(fun(C,fun(B,product_prod(C,B))),C)),X),aa(C,product_prod(fun(C,fun(B,product_prod(C,B))),C),aa(fun(C,fun(B,product_prod(C,B))),fun(C,product_prod(fun(C,fun(B,product_prod(C,B))),C)),product_Pair(fun(C,fun(B,product_prod(C,B))),C),Xa),Xb)))
       => ~ ( ( Y
              = $ite(X = zero_zero(code_natural),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Xb),product_scomp(B,C,B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),Xa,Xb),iterate(C,B,aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),minus_minus(code_natural),X),one_one(code_natural)),Xa))) )
           => ~ aa(product_prod(code_natural,product_prod(fun(C,fun(B,product_prod(C,B))),C)),$o,accp(product_prod(code_natural,product_prod(fun(C,fun(B,product_prod(C,B))),C)),iterate_rel(C,B)),aa(product_prod(fun(C,fun(B,product_prod(C,B))),C),product_prod(code_natural,product_prod(fun(C,fun(B,product_prod(C,B))),C)),aa(code_natural,fun(product_prod(fun(C,fun(B,product_prod(C,B))),C),product_prod(code_natural,product_prod(fun(C,fun(B,product_prod(C,B))),C))),product_Pair(code_natural,product_prod(fun(C,fun(B,product_prod(C,B))),C)),X),aa(C,product_prod(fun(C,fun(B,product_prod(C,B))),C),aa(fun(C,fun(B,product_prod(C,B))),fun(C,product_prod(fun(C,fun(B,product_prod(C,B))),C)),product_Pair(fun(C,fun(B,product_prod(C,B))),C),Xa),Xb))) ) ) ) ).

% iterate.pelims
tff(fact_5081_iter_H_Ocases,axiom,
    ! [B: $tType] :
      ( quickcheck_random(B)
     => ! [X: product_prod(itself(B),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))))] :
          ~ ! [T5: itself(B),Nrandom: code_natural,Sz: code_natural,Seed: product_prod(code_natural,code_natural)] : ( X != aa(product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))),product_prod(itself(B),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural)))),aa(itself(B),fun(product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))),product_prod(itself(B),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))))),product_Pair(itself(B),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural)))),T5),aa(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))),aa(code_natural,fun(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural)))),product_Pair(code_natural,product_prod(code_natural,product_prod(code_natural,code_natural))),Nrandom),aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),Sz),Seed))) ) ) ).

% iter'.cases
tff(fact_5082_iterate_Ocases,axiom,
    ! [C: $tType,B: $tType,X: product_prod(code_natural,product_prod(fun(B,fun(C,product_prod(B,C))),B))] :
      ~ ! [K2: code_natural,F8: fun(B,fun(C,product_prod(B,C))),X2: B] : ( X != aa(product_prod(fun(B,fun(C,product_prod(B,C))),B),product_prod(code_natural,product_prod(fun(B,fun(C,product_prod(B,C))),B)),aa(code_natural,fun(product_prod(fun(B,fun(C,product_prod(B,C))),B),product_prod(code_natural,product_prod(fun(B,fun(C,product_prod(B,C))),B))),product_Pair(code_natural,product_prod(fun(B,fun(C,product_prod(B,C))),B)),K2),aa(B,product_prod(fun(B,fun(C,product_prod(B,C))),B),aa(fun(B,fun(C,product_prod(B,C))),fun(B,product_prod(fun(B,fun(C,product_prod(B,C))),B)),product_Pair(fun(B,fun(C,product_prod(B,C))),B),F8),X2)) ) ).

% iterate.cases
tff(fact_5083_prod__filter__assoc,axiom,
    ! [B: $tType,C: $tType,D: $tType,F: filter(B),G5: filter(C),H10: filter(D)] : ( prod_filter(product_prod(B,C),D,prod_filter(B,C,F,G5),H10) = filtermap(product_prod(B,product_prod(C,D)),product_prod(product_prod(B,C),D),aa(fun(B,fun(product_prod(C,D),product_prod(product_prod(B,C),D))),fun(product_prod(B,product_prod(C,D)),product_prod(product_prod(B,C),D)),product_case_prod(B,product_prod(C,D),product_prod(product_prod(B,C),D)),aTP_Lamp_uc(B,fun(product_prod(C,D),product_prod(product_prod(B,C),D)))),prod_filter(B,product_prod(C,D),F,prod_filter(C,D,G5,H10))) ) ).

% prod_filter_assoc
tff(fact_5084_select__weight__cons__zero,axiom,
    ! [B: $tType,X: B,Xs: list(product_prod(code_natural,B))] : ( select_weight(B,aa(list(product_prod(code_natural,B)),list(product_prod(code_natural,B)),aa(product_prod(code_natural,B),fun(list(product_prod(code_natural,B)),list(product_prod(code_natural,B))),cons(product_prod(code_natural,B)),aa(B,product_prod(code_natural,B),aa(code_natural,fun(B,product_prod(code_natural,B)),product_Pair(code_natural,B),zero_zero(code_natural)),X)),Xs)) = select_weight(B,Xs) ) ).

% select_weight_cons_zero
tff(fact_5085_select__weight__def,axiom,
    ! [B: $tType,Xs: list(product_prod(code_natural,B))] : ( select_weight(B,Xs) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)),range(groups8242544230860333062m_list(code_natural,aa(list(product_prod(code_natural,B)),list(code_natural),map(product_prod(code_natural,B),code_natural,product_fst(code_natural,B)),Xs))),aTP_Lamp_ud(list(product_prod(code_natural,B)),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)))),Xs)) ) ).

% select_weight_def
tff(fact_5086_filtermap__bot,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,B)] : ( filtermap(C,B,Fa,bot_bot(filter(C))) = bot_bot(filter(B)) ) ).

% filtermap_bot
tff(fact_5087_filtermap__bot__iff,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),F: filter(C)] :
      ( ( filtermap(C,B,Fa,F) = bot_bot(filter(B)) )
    <=> ( F = bot_bot(filter(C)) ) ) ).

% filtermap_bot_iff
tff(fact_5088_filtermap__Pair,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(D,B),Ga: fun(D,C),F: filter(D)] : aa(filter(product_prod(B,C)),$o,aa(filter(product_prod(B,C)),fun(filter(product_prod(B,C)),$o),ord_less_eq(filter(product_prod(B,C))),filtermap(D,product_prod(B,C),aa(fun(D,C),fun(D,product_prod(B,C)),aTP_Lamp_jk(fun(D,B),fun(fun(D,C),fun(D,product_prod(B,C))),Fa),Ga),F)),prod_filter(B,C,filtermap(D,B,Fa,F),filtermap(D,C,Ga,F))) ).

% filtermap_Pair
tff(fact_5089_filtermap__inf,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),F12: filter(C),F24: filter(C)] : aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),filtermap(C,B,Fa,aa(filter(C),filter(C),aa(filter(C),fun(filter(C),filter(C)),inf_inf(filter(C)),F12),F24))),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),filtermap(C,B,Fa,F12)),filtermap(C,B,Fa,F24))) ).

% filtermap_inf
tff(fact_5090_select__weight__select,axiom,
    ! [B: $tType,Xs: list(B)] :
      ( ( Xs != nil(B) )
     => ( select_weight(B,aa(list(B),list(product_prod(code_natural,B)),map(B,product_prod(code_natural,B),aa(code_natural,fun(B,product_prod(code_natural,B)),product_Pair(code_natural,B),one_one(code_natural))),Xs)) = select(B,Xs) ) ) ).

% select_weight_select
tff(fact_5091_prod__filter__principal__singleton2,axiom,
    ! [C: $tType,B: $tType,F: filter(B),X: C] : ( prod_filter(B,C,F,principal(C,aa(set(C),set(C),insert2(C,X),bot_bot(set(C))))) = filtermap(B,product_prod(B,C),aa(C,fun(B,product_prod(B,C)),aTP_Lamp_ex(C,fun(B,product_prod(B,C))),X),F) ) ).

% prod_filter_principal_singleton2
tff(fact_5092_pick__same,axiom,
    ! [B: $tType,L: nat,Xs: list(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),L),size_size(list(B),Xs))
     => ( pick(B,aa(list(B),list(product_prod(code_natural,B)),map(B,product_prod(code_natural,B),aa(code_natural,fun(B,product_prod(code_natural,B)),product_Pair(code_natural,B),one_one(code_natural))),Xs),code_natural_of_nat(L)) = nth(B,Xs,L) ) ) ).

% pick_same
tff(fact_5093_inf__principal,axiom,
    ! [B: $tType,A4: set(B),B2: set(B)] : ( aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),principal(B,A4)),principal(B,B2)) = principal(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A4),B2)) ) ).

% inf_principal
tff(fact_5094_principal__eq__bot__iff,axiom,
    ! [B: $tType,X6: set(B)] :
      ( ( principal(B,X6) = bot_bot(filter(B)) )
    <=> ( X6 = bot_bot(set(B)) ) ) ).

% principal_eq_bot_iff
tff(fact_5095_bot__eq__principal__empty,axiom,
    ! [B: $tType] : ( bot_bot(filter(B)) = principal(B,bot_bot(set(B))) ) ).

% bot_eq_principal_empty
tff(fact_5096_eventually__inf__principal,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),S: set(B)] :
      ( eventually(B,Pa,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F),principal(B,S)))
    <=> eventually(B,aa(set(B),fun(B,$o),aTP_Lamp_ue(fun(B,$o),fun(set(B),fun(B,$o)),Pa),S),F) ) ).

% eventually_inf_principal
tff(fact_5097_prod__filter__principal__singleton,axiom,
    ! [B: $tType,C: $tType,X: B,F: filter(C)] : ( prod_filter(B,C,principal(B,aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))),F) = filtermap(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),F) ) ).

% prod_filter_principal_singleton
tff(fact_5098_select__def,axiom,
    ! [B: $tType,Xs: list(B)] : ( select(B,Xs) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)),range(code_natural_of_nat(size_size(list(B),Xs))),aTP_Lamp_uf(list(B),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)))),Xs)) ) ).

% select_def
tff(fact_5099_finite__subsets__at__top__finite,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( finite5375528669736107172at_top(B,A4) = principal(set(B),aa(set(set(B)),set(set(B)),insert2(set(B),A4),bot_bot(set(set(B))))) ) ) ).

% finite_subsets_at_top_finite
tff(fact_5100_filterlim__base__iff,axiom,
    ! [B: $tType,C: $tType,D: $tType,E: $tType,I4: set(B),F: fun(B,set(C)),Fa: fun(C,D),G5: fun(E,set(D)),J4: set(E)] :
      ( ( I4 != bot_bot(set(B)) )
     => ( ! [I3: B] :
            ( member(B,I3,I4)
           => ! [J3: B] :
                ( member(B,J3,I4)
               => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),F,I3)),aa(B,set(C),F,J3))
                  | aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(B,set(C),F,J3)),aa(B,set(C),F,I3)) ) ) )
       => ( filterlim(C,D,Fa,aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(E),set(filter(D)),image2(E,filter(D),aTP_Lamp_ug(fun(E,set(D)),fun(E,filter(D)),G5)),J4)),aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(B),set(filter(C)),image2(B,filter(C),aTP_Lamp_uh(fun(B,set(C)),fun(B,filter(C)),F)),I4)))
        <=> ! [X4: E] :
              ( member(E,X4,J4)
             => ? [Xa2: B] :
                  ( member(B,Xa2,I4)
                  & ! [Xb3: C] :
                      ( member(C,Xb3,aa(B,set(C),F,Xa2))
                     => member(D,aa(C,D,Fa,Xb3),aa(E,set(D),G5,X4)) ) ) ) ) ) ) ).

% filterlim_base_iff
tff(fact_5101_filterlim__inf,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),F24: filter(C),F32: filter(C),F12: filter(B)] :
      ( filterlim(B,C,Fa,aa(filter(C),filter(C),aa(filter(C),fun(filter(C),filter(C)),inf_inf(filter(C)),F24),F32),F12)
    <=> ( filterlim(B,C,Fa,F24,F12)
        & filterlim(B,C,Fa,F32,F12) ) ) ).

% filterlim_inf
tff(fact_5102_finite__subsets__at__top__neq__bot,axiom,
    ! [B: $tType,A4: set(B)] : ( finite5375528669736107172at_top(B,A4) != bot_bot(filter(set(B))) ) ).

% finite_subsets_at_top_neq_bot
tff(fact_5103_filterlim__Pair,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,C),G5: filter(C),F: filter(B),Ga: fun(B,D),H10: filter(D)] :
      ( filterlim(B,C,Fa,G5,F)
     => ( filterlim(B,D,Ga,H10,F)
       => filterlim(B,product_prod(C,D),aa(fun(B,D),fun(B,product_prod(C,D)),aTP_Lamp_ui(fun(B,C),fun(fun(B,D),fun(B,product_prod(C,D))),Fa),Ga),prod_filter(C,D,G5,H10),F) ) ) ).

% filterlim_Pair
tff(fact_5104_filterlim__If,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C),G5: filter(C),F: filter(B),Pa: fun(B,$o),Ga: fun(B,C)] :
      ( filterlim(B,C,Fa,G5,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F),principal(B,aa(fun(B,$o),set(B),collect(B),Pa))))
     => ( filterlim(B,C,Ga,G5,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F),principal(B,aa(fun(B,$o),set(B),collect(B),aTP_Lamp_ob(fun(B,$o),fun(B,$o),Pa)))))
       => filterlim(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,$o),fun(fun(B,C),fun(B,C)),aTP_Lamp_uj(fun(B,C),fun(fun(B,$o),fun(fun(B,C),fun(B,C))),Fa),Pa),Ga),G5,F) ) ) ).

% filterlim_If
tff(fact_5105_map__conv__bind__option,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),X: option(C)] : ( aa(option(C),option(B),map_option(C,B,Fa),X) = bind(C,B,X,aa(fun(C,B),fun(C,option(B)),aa(fun(B,option(B)),fun(fun(C,B),fun(C,option(B))),comp(B,option(B),C),some(B)),Fa)) ) ).

% map_conv_bind_option
tff(fact_5106_Random__Pred_Ounion__def,axiom,
    ! [B: $tType,R12: fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),R23: fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),X3: product_prod(code_natural,code_natural)] : ( random_union(B,R12,R23,X3) = aa(product_prod(pred(B),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(fun(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(product_prod(pred(B),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural))),product_case_prod(pred(B),product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aTP_Lamp_ul(fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),fun(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),R23)),aa(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)),R12,X3)) ) ).

% Random_Pred.union_def
tff(fact_5107_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [B: $tType,C: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),S2: set(C),Fa: fun(C,B),X: C,A4: set(C)] :
      ( folding_insort_key(B,C,Less_eq,Less,S2,Fa)
     => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(C),set(C),insert2(C,X),A4)),S2)
       => ( aa(set(C),$o,finite_finite(C),A4)
         => ( sorted8670434370408473282of_set(B,C,Less_eq,Fa,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A4),aa(set(C),set(C),insert2(C,X),bot_bot(set(C))))) = remove1(C,X,sorted8670434370408473282of_set(B,C,Less_eq,Fa,A4)) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
tff(fact_5108_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [B: $tType,C: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),S2: set(C),Fa: fun(C,B)] :
      ( folding_insort_key(B,C,Less_eq,Less,S2,Fa)
     => ( sorted8670434370408473282of_set(B,C,Less_eq,Fa,bot_bot(set(C))) = nil(C) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
tff(fact_5109_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [B: $tType,C: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),S2: set(C),Fa: fun(C,B),A4: set(C)] :
      ( folding_insort_key(B,C,Less_eq,Less,S2,Fa)
     => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),A4),S2)
       => ( aa(set(C),$o,finite_finite(C),A4)
         => ( ( sorted8670434370408473282of_set(B,C,Less_eq,Fa,A4) = nil(C) )
          <=> ( A4 = bot_bot(set(C)) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
tff(fact_5110_bind__map__option,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(D,C),X: option(D),Ga: fun(C,option(B))] : ( bind(C,B,aa(option(D),option(C),map_option(D,C,Fa),X),Ga) = bind(D,B,X,aa(fun(D,C),fun(D,option(B)),aa(fun(C,option(B)),fun(fun(D,C),fun(D,option(B))),comp(C,option(B),D),Ga),Fa)) ) ).

% bind_map_option
tff(fact_5111_map__option__bind,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(C,B),X: option(D),Ga: fun(D,option(C))] : ( aa(option(C),option(B),map_option(C,B,Fa),bind(D,C,X,Ga)) = bind(D,B,X,aa(fun(D,option(C)),fun(D,option(B)),aa(fun(option(C),option(B)),fun(fun(D,option(C)),fun(D,option(B))),comp(option(C),option(B),D),map_option(C,B,Fa)),Ga)) ) ).

% map_option_bind
tff(fact_5112_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [B: $tType,C: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),S2: set(C),Fa: fun(C,B),X: C,A4: set(C)] :
      ( folding_insort_key(B,C,Less_eq,Less,S2,Fa)
     => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(C),set(C),insert2(C,X),A4)),S2)
       => ( aa(set(C),$o,finite_finite(C),A4)
         => ( sorted8670434370408473282of_set(B,C,Less_eq,Fa,aa(set(C),set(C),insert2(C,X),A4)) = aa(list(C),list(C),insort_key(B,C,Less_eq,Fa,X),sorted8670434370408473282of_set(B,C,Less_eq,Fa,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A4),aa(set(C),set(C),insert2(C,X),bot_bot(set(C)))))) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
tff(fact_5113_Random__Pred_Oempty__def,axiom,
    ! [B: $tType] : ( random_empty(B) = aa(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),product_Pair(pred(B),product_prod(code_natural,code_natural)),bot_bot(pred(B))) ) ).

% Random_Pred.empty_def
tff(fact_5114_Random__Pred_Obind__def,axiom,
    ! [B: $tType,C: $tType,R: fun(product_prod(code_natural,code_natural),product_prod(pred(C),product_prod(code_natural,code_natural))),Fa: fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),X3: product_prod(code_natural,code_natural)] : ( aa(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)),random_bind(C,B,R,Fa),X3) = aa(product_prod(pred(C),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(fun(pred(C),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(product_prod(pred(C),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural))),product_case_prod(pred(C),product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aTP_Lamp_uo(fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(pred(C),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Fa)),aa(product_prod(code_natural,code_natural),product_prod(pred(C),product_prod(code_natural,code_natural)),R,X3)) ) ).

% Random_Pred.bind_def
tff(fact_5115_bottom__bind,axiom,
    ! [C: $tType,B: $tType,Pa: fun(C,pred(B))] : ( bind2(C,B,bot_bot(pred(C)),Pa) = bot_bot(pred(B)) ) ).

% bottom_bind
tff(fact_5116_folding__insort__key_Oinsort__key__commute,axiom,
    ! [B: $tType,C: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),S2: set(C),Fa: fun(C,B),X: C,Y: C] :
      ( folding_insort_key(B,C,Less_eq,Less,S2,Fa)
     => ( member(C,X,S2)
       => ( member(C,Y,S2)
         => ( aa(fun(list(C),list(C)),fun(list(C),list(C)),aa(fun(list(C),list(C)),fun(fun(list(C),list(C)),fun(list(C),list(C))),comp(list(C),list(C),list(C)),insort_key(B,C,Less_eq,Fa,Y)),insort_key(B,C,Less_eq,Fa,X)) = aa(fun(list(C),list(C)),fun(list(C),list(C)),aa(fun(list(C),list(C)),fun(fun(list(C),list(C)),fun(list(C),list(C))),comp(list(C),list(C),list(C)),insort_key(B,C,Less_eq,Fa,X)),insort_key(B,C,Less_eq,Fa,Y)) ) ) ) ) ).

% folding_insort_key.insort_key_commute
tff(fact_5117_Random__Pred_Omap__def,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),Pa: fun(product_prod(code_natural,code_natural),product_prod(pred(C),product_prod(code_natural,code_natural)))] : ( random_map(C,B,Fa,Pa) = random_bind(C,B,Pa,aa(fun(C,B),fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),aa(fun(B,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(fun(C,B),fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))))),comp(B,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),C),random_single(B)),Fa)) ) ).

% Random_Pred.map_def
tff(fact_5118_set__bind__option,axiom,
    ! [B: $tType,C: $tType,X: option(C),Fa: fun(C,option(B))] : ( aa(option(B),set(B),set_option(B),bind(C,B,X,Fa)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(C),set(set(B)),image2(C,set(B),aa(fun(C,option(B)),fun(C,set(B)),aa(fun(option(B),set(B)),fun(fun(C,option(B)),fun(C,set(B))),comp(option(B),set(B),C),set_option(B)),Fa)),aa(option(C),set(C),set_option(C),X))) ) ).

% set_bind_option
tff(fact_5119_singleton__sup,axiom,
    ! [B: $tType,Default: fun(product_unit,B),A4: pred(B),B2: pred(B)] :
      ( singleton(B,Default,aa(pred(B),pred(B),aa(pred(B),fun(pred(B),pred(B)),sup_sup(pred(B)),A4),B2))
      = $ite(
          A4 = bot_bot(pred(B)),
          singleton(B,Default,B2),
          $ite(
            B2 = bot_bot(pred(B)),
            singleton(B,Default,A4),
            $ite(singleton(B,Default,A4) = singleton(B,Default,B2),singleton(B,Default,A4),aa(product_unit,B,Default,product_Unity)) ) ) ) ).

% singleton_sup
tff(fact_5120_set__empty__eq,axiom,
    ! [B: $tType,Xo: option(B)] :
      ( ( aa(option(B),set(B),set_option(B),Xo) = bot_bot(set(B)) )
    <=> ( Xo = none(B) ) ) ).

% set_empty_eq
tff(fact_5121_option_Osimps_I14_J,axiom,
    ! [B: $tType] : ( aa(option(B),set(B),set_option(B),none(B)) = bot_bot(set(B)) ) ).

% option.simps(14)
tff(fact_5122_singleton__bot,axiom,
    ! [B: $tType,Default: fun(product_unit,B)] : ( singleton(B,Default,bot_bot(pred(B))) = aa(product_unit,B,Default,product_Unity) ) ).

% singleton_bot
tff(fact_5123_option_Osimps_I15_J,axiom,
    ! [B: $tType,X22: B] : ( aa(option(B),set(B),set_option(B),aa(B,option(B),some(B),X22)) = aa(set(B),set(B),insert2(B,X22),bot_bot(set(B))) ) ).

% option.simps(15)
tff(fact_5124_singleton__sup__aux,axiom,
    ! [B: $tType,Default: fun(product_unit,B),A4: pred(B),B2: pred(B)] :
      ( singleton(B,Default,aa(pred(B),pred(B),aa(pred(B),fun(pred(B),pred(B)),sup_sup(pred(B)),A4),B2))
      = $ite(
          A4 = bot_bot(pred(B)),
          singleton(B,Default,B2),
          $ite(B2 = bot_bot(pred(B)),singleton(B,Default,A4),singleton(B,Default,aa(pred(B),pred(B),aa(pred(B),fun(pred(B),pred(B)),sup_sup(pred(B)),aa(B,pred(B),single(B),singleton(B,Default,A4))),aa(B,pred(B),single(B),singleton(B,Default,B2))))) ) ) ).

% singleton_sup_aux
tff(fact_5125_Random__Pred_Osingle__def,axiom,
    ! [B: $tType,X: B] : ( aa(B,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),random_single(B),X) = aa(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),product_Pair(pred(B),product_prod(code_natural,code_natural)),aa(B,pred(B),single(B),X)) ) ).

% Random_Pred.single_def
tff(fact_5126_mult__one__div__unit__factor,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),divide_divide(B,one_one(B),unit_f5069060285200089521factor(B,Ba))) = divide_divide(B,A3,unit_f5069060285200089521factor(B,Ba)) ) ) ).

% mult_one_div_unit_factor
tff(fact_5127_unit__factor__1,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ( unit_f5069060285200089521factor(B,one_one(B)) = one_one(B) ) ) ).

% unit_factor_1
tff(fact_5128_inv__unit__factor__eq__0__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B] :
          ( ( divide_divide(B,one_one(B),unit_f5069060285200089521factor(B,A3)) = zero_zero(B) )
        <=> ( A3 = zero_zero(B) ) ) ) ).

% inv_unit_factor_eq_0_iff
tff(fact_5129_unit__factor__mult__unit__left,axiom,
    ! [B: $tType] :
      ( semido2269285787275462019factor(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),A3),unit_f5069060285200089521factor(B,Ba)) ) ) ) ).

% unit_factor_mult_unit_left
tff(fact_5130_unit__factor__mult__unit__right,axiom,
    ! [B: $tType] :
      ( semido2269285787275462019factor(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),unit_f5069060285200089521factor(B,Ba)),A3) ) ) ) ).

% unit_factor_mult_unit_right
tff(fact_5131_unit__factor__mult,axiom,
    ! [B: $tType] :
      ( normal6328177297339901930cative(B)
     => ! [A3: B,Ba: B] : ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),unit_f5069060285200089521factor(B,A3)),unit_f5069060285200089521factor(B,Ba)) ) ) ).

% unit_factor_mult
tff(fact_5132_unit__pred__cases,axiom,
    ! [Pa: fun(pred(product_unit),$o),Qa: pred(product_unit)] :
      ( aa(pred(product_unit),$o,Pa,bot_bot(pred(product_unit)))
     => ( aa(pred(product_unit),$o,Pa,aa(product_unit,pred(product_unit),single(product_unit),product_Unity))
       => aa(pred(product_unit),$o,Pa,Qa) ) ) ).

% unit_pred_cases
tff(fact_5133_single__not__bot,axiom,
    ! [B: $tType,X: B] : ( aa(B,pred(B),single(B),X) != bot_bot(pred(B)) ) ).

% single_not_bot
tff(fact_5134_is__unit__unit__factor,axiom,
    ! [B: $tType] :
      ( semido2269285787275462019factor(B)
     => ! [A3: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( unit_f5069060285200089521factor(B,A3) = A3 ) ) ) ).

% is_unit_unit_factor
tff(fact_5135_gcd__mult__distrib,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [K: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),K),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),K),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),K),Ba))),unit_f5069060285200089521factor(B,K)) ) ) ).

% gcd_mult_distrib
tff(fact_5136_mult__gcd__right,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))),unit_f5069060285200089521factor(B,C2)) ) ) ).

% mult_gcd_right
tff(fact_5137_mult__gcd__left,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [C2: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),C2),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),unit_f5069060285200089521factor(B,C2)),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))) ) ) ).

% mult_gcd_left
tff(fact_5138_unit__factor__is__unit,axiom,
    ! [B: $tType] :
      ( semido2269285787275462019factor(B)
     => ! [A3: B] :
          ( ( A3 != zero_zero(B) )
         => dvd_dvd(B,unit_f5069060285200089521factor(B,A3),one_one(B)) ) ) ).

% unit_factor_is_unit
tff(fact_5139_unit__factor__gcd,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba))
          = $ite(
              ( ( A3 = zero_zero(B) )
              & ( Ba = zero_zero(B) ) ),
              zero_zero(B),
              one_one(B) ) ) ) ).

% unit_factor_gcd
tff(fact_5140_coprime__crossproduct_H,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [Ba: B,D2: B,A3: B,C2: B] :
          ( ( Ba != zero_zero(B) )
         => ( ( unit_f5069060285200089521factor(B,Ba) = unit_f5069060285200089521factor(B,D2) )
           => ( algebr8660921524188924756oprime(B,A3,Ba)
             => ( algebr8660921524188924756oprime(B,C2,D2)
               => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),A3),D2) = aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2) )
                <=> ( ( A3 = C2 )
                    & ( Ba = D2 ) ) ) ) ) ) ) ) ).

% coprime_crossproduct'
tff(fact_5141_unit__factor__Gcd,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: set(B)] :
          ( unit_f5069060285200089521factor(B,gcd_Gcd(B,A4))
          = $ite(gcd_Gcd(B,A4) = zero_zero(B),zero_zero(B),one_one(B)) ) ) ).

% unit_factor_Gcd
tff(fact_5142_Random__Pred_ORandom__def,axiom,
    ! [B: $tType,Ga: fun(product_prod(code_natural,code_natural),product_prod(product_prod(B,fun(product_unit,code_term)),product_prod(code_natural,code_natural)))] : ( random_Random(B,Ga) = product_scomp(product_prod(code_natural,code_natural),product_prod(B,fun(product_unit,code_term)),product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)),Ga,aa(fun(product_prod(B,fun(product_unit,code_term)),pred(B)),fun(product_prod(B,fun(product_unit,code_term)),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),aa(fun(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(fun(product_prod(B,fun(product_unit,code_term)),pred(B)),fun(product_prod(B,fun(product_unit,code_term)),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))))),comp(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),product_prod(B,fun(product_unit,code_term))),product_Pair(pred(B),product_prod(code_natural,code_natural))),aa(fun(product_prod(B,fun(product_unit,code_term)),B),fun(product_prod(B,fun(product_unit,code_term)),pred(B)),aa(fun(B,pred(B)),fun(fun(product_prod(B,fun(product_unit,code_term)),B),fun(product_prod(B,fun(product_unit,code_term)),pred(B))),comp(B,pred(B),product_prod(B,fun(product_unit,code_term))),single(B)),product_fst(B,fun(product_unit,code_term))))) ) ).

% Random_Pred.Random_def
tff(fact_5143_pred__of__set__set__foldr__sup,axiom,
    ! [B: $tType,Xs: list(B)] : ( aa(set(B),pred(B),pred_of_set(B),aa(list(B),set(B),set2(B),Xs)) = aa(pred(B),pred(B),foldr(pred(B),pred(B),sup_sup(pred(B)),aa(list(B),list(pred(B)),map(B,pred(B),single(B)),Xs)),bot_bot(pred(B))) ) ).

% pred_of_set_set_foldr_sup
tff(fact_5144_pred__of__set__set__fold__sup,axiom,
    ! [B: $tType,Xs: list(B)] : ( aa(set(B),pred(B),pred_of_set(B),aa(list(B),set(B),set2(B),Xs)) = aa(pred(B),pred(B),fold(pred(B),pred(B),sup_sup(pred(B)),aa(list(B),list(pred(B)),map(B,pred(B),single(B)),Xs)),bot_bot(pred(B))) ) ).

% pred_of_set_set_fold_sup
tff(fact_5145_pred__of__set__fold__sup,axiom,
    ! [B: $tType,A4: set(B)] :
      ( aa(set(B),$o,finite_finite(B),A4)
     => ( aa(set(B),pred(B),pred_of_set(B),A4) = finite_fold(pred(B),pred(B),sup_sup(pred(B)),bot_bot(pred(B)),aa(set(B),set(pred(B)),image2(B,pred(B),single(B)),A4)) ) ) ).

% pred_of_set_fold_sup
tff(fact_5146_if__pred__eq,axiom,
    ! [Ba: $o] :
      ( if_pred(Ba)
      = $ite((Ba),aa(product_unit,pred(product_unit),single(product_unit),product_Unity),bot_bot(pred(product_unit))) ) ).

% if_pred_eq
tff(fact_5147_Predicate_Omap__def,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),Pa: pred(C)] : ( aa(pred(C),pred(B),map2(C,B,Fa),Pa) = bind2(C,B,Pa,aa(fun(C,B),fun(C,pred(B)),aa(fun(B,pred(B)),fun(fun(C,B),fun(C,pred(B))),comp(B,pred(B),C),single(B)),Fa)) ) ).

% Predicate.map_def
tff(fact_5148_contains__pred__def,axiom,
    ! [B: $tType,A4: set(B),X: B] :
      ( predic7144156976422707464s_pred(B,A4,X)
      = $ite(member(B,X,A4),aa(product_unit,pred(product_unit),single(product_unit),product_Unity),bot_bot(pred(product_unit))) ) ).

% contains_pred_def
tff(fact_5149_Predicate_Omap_Ocomp,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(D,C),Ga: fun(B,D)] : ( aa(fun(pred(B),pred(D)),fun(pred(B),pred(C)),aa(fun(pred(D),pred(C)),fun(fun(pred(B),pred(D)),fun(pred(B),pred(C))),comp(pred(D),pred(C),pred(B)),map2(D,C,Fa)),map2(B,D,Ga)) = map2(B,C,aa(fun(B,D),fun(B,C),aa(fun(D,C),fun(fun(B,D),fun(B,C)),comp(D,C,B),Fa),Ga)) ) ).

% Predicate.map.comp
tff(fact_5150_Predicate_Omap_Ocompositionality,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(C,B),Ga: fun(D,C),Pred: pred(D)] : ( aa(pred(C),pred(B),map2(C,B,Fa),aa(pred(D),pred(C),map2(D,C,Ga),Pred)) = aa(pred(D),pred(B),map2(D,B,aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Fa),Ga)),Pred) ) ).

% Predicate.map.compositionality
tff(fact_5151_Gcd__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => bounde6485984586167503788ce_set(B,gcd_gcd(B),zero_zero(B),one_one(B),normal6383669964737779283malize(B)) ) ).

% Gcd_fin.bounded_quasi_semilattice_set_axioms
tff(fact_5152_Lcm__no__units,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: set(B)] : ( gcd_Lcm(B,A4) = gcd_Lcm(B,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_up(B,$o)))) ) ) ).

% Lcm_no_units
tff(fact_5153_Heap__lub__def,axiom,
    ! [B: $tType] : ( heap_Time_Heap_lub(B) = partial_img_lub(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_execute(B),heap_Time_Heap2(B),partial_fun_lub(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit),partial_flat_lub(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),none(product_prod(B,product_prod(heap_ext(product_unit),nat)))))) ) ).

% Heap_lub_def
tff(fact_5154_normalize__mult__normalize__right,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),aa(B,B,normal6383669964737779283malize(B),Ba))) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ).

% normalize_mult_normalize_right
tff(fact_5155_normalize__mult__normalize__left,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A3)),Ba)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ).

% normalize_mult_normalize_left
tff(fact_5156_gcd_Onormalize__bottom,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ( aa(B,B,normal6383669964737779283malize(B),one_one(B)) = one_one(B) ) ) ).

% gcd.normalize_bottom
tff(fact_5157_normalize__1,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ( aa(B,B,normal6383669964737779283malize(B),one_one(B)) = one_one(B) ) ) ).

% normalize_1
tff(fact_5158_Lcm__empty,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ( gcd_Lcm(B,bot_bot(set(B))) = one_one(B) ) ) ).

% Lcm_empty
tff(fact_5159_Lcm__1__iff,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: set(B)] :
          ( ( gcd_Lcm(B,A4) = one_one(B) )
        <=> ! [X4: B] :
              ( member(B,X4,A4)
             => dvd_dvd(B,X4,one_one(B)) ) ) ) ).

% Lcm_1_iff
tff(fact_5160_normalize__mult__unit__factor,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A3)),unit_f5069060285200089521factor(B,A3)) = A3 ) ) ).

% normalize_mult_unit_factor
tff(fact_5161_unit__factor__mult__normalize,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),unit_f5069060285200089521factor(B,A3)),aa(B,B,normal6383669964737779283malize(B),A3)) = A3 ) ) ).

% unit_factor_mult_normalize
tff(fact_5162_normalize__mult__unit__right,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [Ba: B,A3: B] :
          ( dvd_dvd(B,Ba,one_one(B))
         => ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,normal6383669964737779283malize(B),A3) ) ) ) ).

% normalize_mult_unit_right
tff(fact_5163_normalize__mult__unit__left,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B,Ba: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,normal6383669964737779283malize(B),Ba) ) ) ) ).

% normalize_mult_unit_left
tff(fact_5164_normalize__unit__factor,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B] :
          ( ( A3 != zero_zero(B) )
         => ( aa(B,B,normal6383669964737779283malize(B),unit_f5069060285200089521factor(B,A3)) = one_one(B) ) ) ) ).

% normalize_unit_factor
tff(fact_5165_unit__factor__normalize,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B] :
          ( ( A3 != zero_zero(B) )
         => ( unit_f5069060285200089521factor(B,aa(B,B,normal6383669964737779283malize(B),A3)) = one_one(B) ) ) ) ).

% unit_factor_normalize
tff(fact_5166_Lcm__singleton,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: B] : ( gcd_Lcm(B,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) = aa(B,B,normal6383669964737779283malize(B),A3) ) ) ).

% Lcm_singleton
tff(fact_5167_normalize__div,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B] : ( divide_divide(B,aa(B,B,normal6383669964737779283malize(B),A3),A3) = divide_divide(B,one_one(B),unit_f5069060285200089521factor(B,A3)) ) ) ).

% normalize_div
tff(fact_5168_Gcd__singleton,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: B] : ( gcd_Gcd(B,aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))) = aa(B,B,normal6383669964737779283malize(B),A3) ) ) ).

% Gcd_singleton
tff(fact_5169_Lcm__mult,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: set(B),C2: B] :
          ( ( A4 != bot_bot(set(B)) )
         => ( gcd_Lcm(B,aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),C2)),A4)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),gcd_Lcm(B,A4))) ) ) ) ).

% Lcm_mult
tff(fact_5170_normalize__mult,axiom,
    ! [B: $tType] :
      ( normal6328177297339901930cative(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A3)),aa(B,B,normal6383669964737779283malize(B),Ba)) ) ) ).

% normalize_mult
tff(fact_5171_associated__unit,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A3) = aa(B,B,normal6383669964737779283malize(B),Ba) )
         => ( dvd_dvd(B,A3,one_one(B))
           => dvd_dvd(B,Ba,one_one(B)) ) ) ) ).

% associated_unit
tff(fact_5172_normalize__1__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A3) = one_one(B) )
        <=> dvd_dvd(B,A3,one_one(B)) ) ) ).

% normalize_1_iff
tff(fact_5173_is__unit__normalize,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,normal6383669964737779283malize(B),A3) = one_one(B) ) ) ) ).

% is_unit_normalize
tff(fact_5174_normalize__idem__imp__is__unit__iff,axiom,
    ! [B: $tType] :
      ( normal8620421768224518004emidom(B)
     => ! [A3: B] :
          ( ( aa(B,B,normal6383669964737779283malize(B),A3) = A3 )
         => ( dvd_dvd(B,A3,one_one(B))
          <=> ( A3 = one_one(B) ) ) ) ) ).

% normalize_idem_imp_is_unit_iff
tff(fact_5175_gcd__mult__left,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [C2: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba))) ) ) ).

% gcd_mult_left
tff(fact_5176_gcd__mult__right,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,C2: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),Ba),A3)),C2)) ) ) ).

% gcd_mult_right
tff(fact_5177_gcd__mult__distrib_H,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [C2: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),C2)),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),gcd_gcd(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ).

% gcd_mult_distrib'
tff(fact_5178_coprime__crossproduct,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,D2: B,Ba: B,C2: B] :
          ( algebr8660921524188924756oprime(B,A3,D2)
         => ( algebr8660921524188924756oprime(B,Ba,C2)
           => ( ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A3)),aa(B,B,normal6383669964737779283malize(B),C2)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),Ba)),aa(B,B,normal6383669964737779283malize(B),D2)) )
            <=> ( ( aa(B,B,normal6383669964737779283malize(B),A3) = aa(B,B,normal6383669964737779283malize(B),Ba) )
                & ( aa(B,B,normal6383669964737779283malize(B),C2) = aa(B,B,normal6383669964737779283malize(B),D2) ) ) ) ) ) ) ).

% coprime_crossproduct
tff(fact_5179_Lcm__coprime,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: set(B)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( ( A4 != bot_bot(set(B)) )
           => ( ! [A8: B,B4: B] :
                  ( member(B,A8,A4)
                 => ( member(B,B4,A4)
                   => ( ( A8 != B4 )
                     => algebr8660921524188924756oprime(B,A8,B4) ) ) )
             => ( gcd_Lcm(B,A4) = aa(B,B,normal6383669964737779283malize(B),aa(set(B),B,aa(fun(B,B),fun(set(B),B),groups7121269368397514597t_prod(B,B),aTP_Lamp_uq(B,B)),A4)) ) ) ) ) ) ).

% Lcm_coprime
tff(fact_5180_Lcm__nat__empty,axiom,
    gcd_Lcm(nat,bot_bot(set(nat))) = one_one(nat) ).

% Lcm_nat_empty
tff(fact_5181_Gcd__mult,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [C2: B,A4: set(B)] : ( gcd_Gcd(B,aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),C2)),A4)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),gcd_Gcd(B,A4))) ) ) ).

% Gcd_mult
tff(fact_5182_Lcm__int__def,axiom,
    ! [K5: set(int)] : ( gcd_Lcm(int,K5) = aa(nat,int,semiring_1_of_nat(int),gcd_Lcm(nat,aa(set(int),set(nat),image2(int,nat,aa(fun(int,int),fun(int,nat),aa(fun(int,nat),fun(fun(int,int),fun(int,nat)),comp(int,nat,int),nat2),abs_abs(int))),K5))) ) ).

% Lcm_int_def
tff(fact_5183_unit__factor__Lcm,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A4: set(B)] :
          ( unit_f5069060285200089521factor(B,gcd_Lcm(B,A4))
          = $ite(gcd_Lcm(B,A4) = zero_zero(B),zero_zero(B),one_one(B)) ) ) ).

% unit_factor_Lcm
tff(fact_5184_Gcd__fin__mult,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: set(B),Ba: B] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(B),B,semiring_gcd_Gcd_fin(B),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),Ba)),A4)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),aa(set(B),B,semiring_gcd_Gcd_fin(B),A4))) ) ) ) ).

% Gcd_fin_mult
tff(fact_5185_gcd_Obounded__quasi__semilattice__axioms,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => bounde8507323023520639062attice(B,gcd_gcd(B),zero_zero(B),one_one(B),normal6383669964737779283malize(B)) ) ).

% gcd.bounded_quasi_semilattice_axioms
tff(fact_5186_Lcm__fin__mult,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: set(B),Ba: B] :
          ( ( A4 != bot_bot(set(B)) )
         => ( aa(set(B),B,semiring_gcd_Lcm_fin(B),aa(set(B),set(B),image2(B,B,aa(B,fun(B,B),times_times(B),Ba)),A4)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),aa(set(B),B,semiring_gcd_Lcm_fin(B),A4))) ) ) ) ).

% Lcm_fin_mult
tff(fact_5187_gcd__lcm,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( ( A3 != zero_zero(B) )
         => ( ( Ba != zero_zero(B) )
           => ( aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba) = aa(B,B,normal6383669964737779283malize(B),divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba))) ) ) ) ) ).

% gcd_lcm
tff(fact_5188_lcm__eq__1__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba) = one_one(B) )
        <=> ( dvd_dvd(B,A3,one_one(B))
            & dvd_dvd(B,Ba,one_one(B)) ) ) ) ).

% lcm_eq_1_iff
tff(fact_5189_lcm_Otop__left__normalize,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),one_one(B)),A3) = aa(B,B,normal6383669964737779283malize(B),A3) ) ) ).

% lcm.top_left_normalize
tff(fact_5190_lcm_Otop__right__normalize,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B] : ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),one_one(B)) = aa(B,B,normal6383669964737779283malize(B),A3) ) ) ).

% lcm.top_right_normalize
tff(fact_5191_Lcm__fin_Oempty,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ( aa(set(B),B,semiring_gcd_Lcm_fin(B),bot_bot(set(B))) = one_one(B) ) ) ).

% Lcm_fin.empty
tff(fact_5192_is__unit__Lcm__fin__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: set(B)] :
          ( dvd_dvd(B,aa(set(B),B,semiring_gcd_Lcm_fin(B),A4),one_one(B))
        <=> ( aa(set(B),B,semiring_gcd_Lcm_fin(B),A4) = one_one(B) ) ) ) ).

% is_unit_Lcm_fin_iff
tff(fact_5193_unit__factor__lcm,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( unit_f5069060285200089521factor(B,aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba))
          = $ite(
              ( ( A3 = zero_zero(B) )
              | ( Ba = zero_zero(B) ) ),
              zero_zero(B),
              one_one(B) ) ) ) ).

% unit_factor_lcm
tff(fact_5194_lcm__mult__gcd,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A3)),aa(B,B,normal6383669964737779283malize(B),Ba)) ) ) ).

% lcm_mult_gcd
tff(fact_5195_gcd__mult__lcm,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),A3)),aa(B,B,normal6383669964737779283malize(B),Ba)) ) ) ).

% gcd_mult_lcm
tff(fact_5196_Lcm__2,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: B,Ba: B] : ( gcd_Lcm(B,aa(set(B),set(B),insert2(B,A3),aa(set(B),set(B),insert2(B,Ba),bot_bot(set(B))))) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba) ) ) ).

% Lcm_2
tff(fact_5197_lcm_Obounded__quasi__semilattice__axioms,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => bounde8507323023520639062attice(B,gcd_lcm(B),one_one(B),zero_zero(B),normal6383669964737779283malize(B)) ) ).

% lcm.bounded_quasi_semilattice_axioms
tff(fact_5198_Lcm__fin_Oremove,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,A4: set(B)] :
          ( member(B,A3,A4)
         => ( aa(set(B),B,semiring_gcd_Lcm_fin(B),A4) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),aa(set(B),B,semiring_gcd_Lcm_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) ) ) ).

% Lcm_fin.remove
tff(fact_5199_Lcm__fin_Oinsert__remove,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,A4: set(B)] : ( aa(set(B),B,semiring_gcd_Lcm_fin(B),aa(set(B),set(B),insert2(B,A3),A4)) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),aa(set(B),B,semiring_gcd_Lcm_fin(B),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,A3),bot_bot(set(B)))))) ) ) ).

% Lcm_fin.insert_remove
tff(fact_5200_Lcm__fin_Oset__eq__fold,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [Xs: list(B)] : ( aa(set(B),B,semiring_gcd_Lcm_fin(B),aa(list(B),set(B),set2(B),Xs)) = aa(B,B,fold(B,B,gcd_lcm(B),Xs),one_one(B)) ) ) ).

% Lcm_fin.set_eq_fold
tff(fact_5201_Lcm__fin__def,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ( semiring_gcd_Lcm_fin(B) = bounde2362111253966948842tice_F(B,gcd_lcm(B),one_one(B),zero_zero(B)) ) ) ).

% Lcm_fin_def
tff(fact_5202_lcm__mult__distrib_H,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [C2: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,normal6383669964737779283malize(B),C2)),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) ) ) ).

% lcm_mult_distrib'
tff(fact_5203_lcm__mult__right,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,C2: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),Ba),A3)),C2)) ) ) ).

% lcm_mult_right
tff(fact_5204_lcm__mult__left,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [C2: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba))) ) ) ).

% lcm_mult_left
tff(fact_5205_Lcm__fin_Oeq__fold,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: set(B)] :
          ( aa(set(B),B,semiring_gcd_Lcm_fin(B),A4)
          = $ite(aa(set(B),$o,finite_finite(B),A4),finite_fold(B,B,gcd_lcm(B),one_one(B),A4),zero_zero(B)) ) ) ).

% Lcm_fin.eq_fold
tff(fact_5206_lcm__mult__distrib,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [K: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),K),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),K),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),K),Ba))),unit_f5069060285200089521factor(B,K)) ) ) ).

% lcm_mult_distrib
tff(fact_5207_mult__lcm__right,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [A3: B,Ba: B,C2: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),C2))),unit_f5069060285200089521factor(B,C2)) ) ) ).

% mult_lcm_right
tff(fact_5208_mult__lcm__left,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [C2: B,A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),C2),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba)) = aa(B,B,aa(B,fun(B,B),times_times(B),unit_f5069060285200089521factor(B,C2)),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),C2),Ba))) ) ) ).

% mult_lcm_left
tff(fact_5209_Lcm__in__lcm__closed__set__nat,axiom,
    ! [M: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),M)
     => ( ( M != bot_bot(set(nat)) )
       => ( ! [M5: nat,N3: nat] :
              ( member(nat,M5,M)
             => ( member(nat,N3,M)
               => member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M5),N3),M) ) )
         => member(nat,gcd_Lcm(nat,M),M) ) ) ) ).

% Lcm_in_lcm_closed_set_nat
tff(fact_5210_lcm__mult__unit2,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),Ba),aa(B,B,aa(B,fun(B,B),times_times(B),C2),A3)) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),Ba),C2) ) ) ) ).

% lcm_mult_unit2
tff(fact_5211_lcm__mult__unit1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),aa(B,B,aa(B,fun(B,B),times_times(B),Ba),A3)),C2) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),Ba),C2) ) ) ) ).

% lcm_mult_unit1
tff(fact_5212_lcm__div__unit2,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),Ba),divide_divide(B,C2,A3)) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),Ba),C2) ) ) ) ).

% lcm_div_unit2
tff(fact_5213_lcm__div__unit1,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B,C2: B] :
          ( dvd_dvd(B,A3,one_one(B))
         => ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),divide_divide(B,Ba,A3)),C2) = aa(B,B,aa(B,fun(B,B),gcd_lcm(B),Ba),C2) ) ) ) ).

% lcm_div_unit1
tff(fact_5214_lcm__gcd__prod,axiom,
    ! [B: $tType] :
      ( semiri6843258321239162965malize(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba)),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba)) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ).

% lcm_gcd_prod
tff(fact_5215_lcm__coprime,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] :
          ( algebr8660921524188924756oprime(B,A3,Ba)
         => ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba) = aa(B,B,normal6383669964737779283malize(B),aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba)) ) ) ) ).

% lcm_coprime
tff(fact_5216_Lcm__fin__1__iff,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A4: set(B)] :
          ( ( aa(set(B),B,semiring_gcd_Lcm_fin(B),A4) = one_one(B) )
        <=> ( ! [X4: B] :
                ( member(B,X4,A4)
               => dvd_dvd(B,X4,one_one(B)) )
            & aa(set(B),$o,finite_finite(B),A4) ) ) ) ).

% Lcm_fin_1_iff
tff(fact_5217_lcm__gcd,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: B,Ba: B] : ( aa(B,B,aa(B,fun(B,B),gcd_lcm(B),A3),Ba) = aa(B,B,normal6383669964737779283malize(B),divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),aa(B,B,aa(B,fun(B,B),gcd_gcd(B),A3),Ba))) ) ) ).

% lcm_gcd
tff(fact_5218_Lcm__set__eq__fold,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [Xs: list(B)] : ( gcd_Lcm(B,aa(list(B),set(B),set2(B),Xs)) = aa(B,B,fold(B,B,gcd_lcm(B),Xs),one_one(B)) ) ) ).

% Lcm_set_eq_fold
tff(fact_5219_Lcm__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [B: $tType] :
      ( semiring_gcd(B)
     => bounde6485984586167503788ce_set(B,gcd_lcm(B),one_one(B),zero_zero(B),normal6383669964737779283malize(B)) ) ).

% Lcm_fin.bounded_quasi_semilattice_set_axioms
tff(fact_5220_Lcm__eq__Max__nat,axiom,
    ! [M: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),M)
     => ( ( M != bot_bot(set(nat)) )
       => ( ~ member(nat,zero_zero(nat),M)
         => ( ! [M5: nat,N3: nat] :
                ( member(nat,M5,M)
               => ( member(nat,N3,M)
                 => member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_lcm(nat),M5),N3),M) ) )
           => ( gcd_Lcm(nat,M) = lattic643756798349783984er_Max(nat,M) ) ) ) ) ) ).

% Lcm_eq_Max_nat
tff(fact_5221_prod_Ocomm__monoid__list__set__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => groups4802862169904069756st_set(B,times_times(B),one_one(B)) ) ).

% prod.comm_monoid_list_set_axioms
tff(fact_5222_prod_H__def,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ( groups1962203154675924110t_prod(B,C) = groups_comm_monoid_G(C,B,times_times(C),one_one(C)) ) ) ).

% prod'_def
tff(fact_5223_Gr__def,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,C)] : ( bNF_Gr(B,C,A4,Fa) = aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,C),fun(product_prod(B,C),$o),aTP_Lamp_ur(set(B),fun(fun(B,C),fun(product_prod(B,C),$o)),A4),Fa)) ) ).

% Gr_def
tff(fact_5224_GrD1,axiom,
    ! [C: $tType,B: $tType,X: B,Fx: C,A4: set(B),Fa: fun(B,C)] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Fx),bNF_Gr(B,C,A4,Fa))
     => member(B,X,A4) ) ).

% GrD1
tff(fact_5225_GrD2,axiom,
    ! [B: $tType,C: $tType,X: B,Fx: C,A4: set(B),Fa: fun(B,C)] :
      ( member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Fx),bNF_Gr(B,C,A4,Fa))
     => ( aa(B,C,Fa,X) = Fx ) ) ).

% GrD2
tff(fact_5226_and_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( bit_ri3973907225187159222ations(B)
     => comm_monoid(B,bit_se5824344872417868541ns_and(B),aa(B,B,uminus_uminus(B),one_one(B))) ) ).

% and.comm_monoid_axioms
tff(fact_5227_Heap_Osize__gen__o__map,axiom,
    ! [C: $tType,B: $tType,Fa: fun(C,nat),Ga: fun(B,C)] : ( aa(fun(heap_Time_Heap(B),heap_Time_Heap(C)),fun(heap_Time_Heap(B),nat),aa(fun(heap_Time_Heap(C),nat),fun(fun(heap_Time_Heap(B),heap_Time_Heap(C)),fun(heap_Time_Heap(B),nat)),comp(heap_Time_Heap(C),nat,heap_Time_Heap(B)),heap_Time_size_Heap(C,Fa)),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Ga)) = heap_Time_size_Heap(B,aa(fun(B,C),fun(B,nat),aa(fun(C,nat),fun(fun(B,C),fun(B,nat)),comp(C,nat,B),Fa),Ga)) ) ).

% Heap.size_gen_o_map
tff(fact_5228_max_Osemilattice__order__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semilattice_order(B,ord_max(B),aTP_Lamp_us(B,fun(B,$o)),aTP_Lamp_ut(B,fun(B,$o))) ) ).

% max.semilattice_order_axioms
tff(fact_5229_Heap_Omap__comp,axiom,
    ! [C: $tType,B: $tType,D: $tType,Ga: fun(C,B),Fa: fun(D,C),V: heap_Time_Heap(D)] : ( aa(heap_Time_Heap(C),heap_Time_Heap(B),aa(fun(C,B),fun(heap_Time_Heap(C),heap_Time_Heap(B)),heap_Time_map_Heap(C,B),Ga),aa(heap_Time_Heap(D),heap_Time_Heap(C),aa(fun(D,C),fun(heap_Time_Heap(D),heap_Time_Heap(C)),heap_Time_map_Heap(D,C),Fa),V)) = aa(heap_Time_Heap(D),heap_Time_Heap(B),aa(fun(D,B),fun(heap_Time_Heap(D),heap_Time_Heap(B)),heap_Time_map_Heap(D,B),aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Ga),Fa)),V) ) ).

% Heap.map_comp
tff(fact_5230_Heap_Omap,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),X: fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(C),heap_Time_Heap(B),aa(fun(C,B),fun(heap_Time_Heap(C),heap_Time_Heap(B)),heap_Time_map_Heap(C,B),Fa),aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(C),heap_Time_Heap2(C),X)) = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(fun(option(product_prod(C,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),comp(option(product_prod(C,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),map_option(product_prod(C,product_prod(heap_ext(product_unit),nat)),product_prod(B,product_prod(heap_ext(product_unit),nat)),product_map_prod(C,B,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),Fa,id(product_prod(heap_ext(product_unit),nat))))),X)) ) ).

% Heap.map
tff(fact_5231_Heap_Omap__ident,axiom,
    ! [B: $tType,T4: heap_Time_Heap(B)] : ( aa(heap_Time_Heap(B),heap_Time_Heap(B),aa(fun(B,B),fun(heap_Time_Heap(B),heap_Time_Heap(B)),heap_Time_map_Heap(B,B),aTP_Lamp_uu(B,B)),T4) = T4 ) ).

% Heap.map_ident
tff(fact_5232_semilattice__order_Ostrict__coboundedI2,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Ba: B,C2: B,A3: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,Ba),C2)
       => aa(B,$o,aa(B,fun(B,$o),Less,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),C2) ) ) ).

% semilattice_order.strict_coboundedI2
tff(fact_5233_semilattice__order_Ostrict__coboundedI1,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,C2: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),C2)
       => aa(B,$o,aa(B,fun(B,$o),Less,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),C2) ) ) ).

% semilattice_order.strict_coboundedI1
tff(fact_5234_semilattice__order_Ostrict__order__iff,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
      <=> ( ( A3 = aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) )
          & ( A3 != Ba ) ) ) ) ).

% semilattice_order.strict_order_iff
tff(fact_5235_semilattice__order_Ostrict__boundedE,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B,C2: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),aa(B,B,aa(B,fun(B,B),Fa,Ba),C2))
       => ~ ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
           => ~ aa(B,$o,aa(B,fun(B,$o),Less,A3),C2) ) ) ) ).

% semilattice_order.strict_boundedE
tff(fact_5236_semilattice__order_OcoboundedI2,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Ba: B,C2: B,A3: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Ba),C2)
       => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),C2) ) ) ).

% semilattice_order.coboundedI2
tff(fact_5237_semilattice__order_OcoboundedI1,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,C2: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),C2)
       => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),C2) ) ) ).

% semilattice_order.coboundedI1
tff(fact_5238_semilattice__order_Obounded__iff,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B,C2: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),aa(B,B,aa(B,fun(B,B),Fa,Ba),C2))
      <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
          & aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),C2) ) ) ) ).

% semilattice_order.bounded_iff
tff(fact_5239_semilattice__order_Oabsorb__iff2,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Ba: B,A3: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Ba),A3)
      <=> ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = Ba ) ) ) ).

% semilattice_order.absorb_iff2
tff(fact_5240_semilattice__order_Oabsorb__iff1,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
      <=> ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = A3 ) ) ) ).

% semilattice_order.absorb_iff1
tff(fact_5241_semilattice__order_Ocobounded2,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),Ba) ) ).

% semilattice_order.cobounded2
tff(fact_5242_semilattice__order_Ocobounded1,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),A3) ) ).

% semilattice_order.cobounded1
tff(fact_5243_semilattice__order_Oorder__iff,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
      <=> ( A3 = aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) ) ) ) ).

% semilattice_order.order_iff
tff(fact_5244_semilattice__order_OboundedI,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B,C2: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),C2)
         => aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),aa(B,B,aa(B,fun(B,B),Fa,Ba),C2)) ) ) ) ).

% semilattice_order.boundedI
tff(fact_5245_semilattice__order_OboundedE,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B,C2: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),aa(B,B,aa(B,fun(B,B),Fa,Ba),C2))
       => ~ ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
           => ~ aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),C2) ) ) ) ).

% semilattice_order.boundedE
tff(fact_5246_semilattice__order_Oabsorb4,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Ba: B,A3: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,Ba),A3)
       => ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = Ba ) ) ) ).

% semilattice_order.absorb4
tff(fact_5247_semilattice__order_Oabsorb3,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
       => ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = A3 ) ) ) ).

% semilattice_order.absorb3
tff(fact_5248_semilattice__order_Oabsorb2,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Ba: B,A3: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Ba),A3)
       => ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = Ba ) ) ) ).

% semilattice_order.absorb2
tff(fact_5249_semilattice__order_Oabsorb1,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
       => ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = A3 ) ) ) ).

% semilattice_order.absorb1
tff(fact_5250_semilattice__order_OorderI,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( ( A3 = aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) )
       => aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba) ) ) ).

% semilattice_order.orderI
tff(fact_5251_semilattice__order_OorderE,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
       => ( A3 = aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) ) ) ) ).

% semilattice_order.orderE
tff(fact_5252_semilattice__order_Omono,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,C2: B,Ba: B,D2: B] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),C2)
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Ba),D2)
         => aa(B,$o,aa(B,fun(B,$o),Less_eq,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),aa(B,B,aa(B,fun(B,B),Fa,C2),D2)) ) ) ) ).

% semilattice_order.mono
tff(fact_5253_comm__monoid_Ocomm__neutral,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,A3: B] :
      ( comm_monoid(B,Fa,Z2)
     => ( aa(B,B,aa(B,fun(B,B),Fa,A3),Z2) = A3 ) ) ).

% comm_monoid.comm_neutral
tff(fact_5254_semilattice__neutr__order_Oaxioms_I2_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semila1105856199041335345_order(B,Fa,Z2,Less_eq,Less)
     => semilattice_order(B,Fa,Less_eq,Less) ) ).

% semilattice_neutr_order.axioms(2)
tff(fact_5255_Heap_Omap__id,axiom,
    ! [B: $tType,T4: heap_Time_Heap(B)] : ( aa(heap_Time_Heap(B),heap_Time_Heap(B),aa(fun(B,B),fun(heap_Time_Heap(B),heap_Time_Heap(B)),heap_Time_map_Heap(B,B),id(B)),T4) = T4 ) ).

% Heap.map_id
tff(fact_5256_Heap_Omap__id0,axiom,
    ! [B: $tType] : ( aa(fun(B,B),fun(heap_Time_Heap(B),heap_Time_Heap(B)),heap_Time_map_Heap(B,B),id(B)) = id(heap_Time_Heap(B)) ) ).

% Heap.map_id0
tff(fact_5257_semilattice__neutr_Oaxioms_I2_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( semilattice_neutr(B,Fa,Z2)
     => comm_monoid(B,Fa,Z2) ) ).

% semilattice_neutr.axioms(2)
tff(fact_5258_add_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_add(B)
     => comm_monoid(B,plus_plus(B),zero_zero(B)) ) ).

% add.comm_monoid_axioms
tff(fact_5259_mult_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => comm_monoid(B,times_times(B),one_one(B)) ) ).

% mult.comm_monoid_axioms
tff(fact_5260_Heap_Oinj__map,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] :
      ( inj_on(B,C,Fa,top_top(set(B)))
     => inj_on(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Fa),top_top(set(heap_Time_Heap(B)))) ) ).

% Heap.inj_map
tff(fact_5261_sup__bot_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => comm_monoid(B,sup_sup(B),bot_bot(B)) ) ).

% sup_bot.comm_monoid_axioms
tff(fact_5262_inf__top_Ocomm__monoid__axioms,axiom,
    ! [B: $tType] :
      ( bounde4346867609351753570nf_top(B)
     => comm_monoid(B,inf_inf(B),top_top(B)) ) ).

% inf_top.comm_monoid_axioms
tff(fact_5263_semilattice__neutr__order__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semila1105856199041335345_order(B,Fa,Z2,Less_eq,Less)
    <=> ( semilattice_neutr(B,Fa,Z2)
        & semilattice_order(B,Fa,Less_eq,Less) ) ) ).

% semilattice_neutr_order_def
tff(fact_5264_semilattice__neutr__order_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semilattice_neutr(B,Fa,Z2)
     => ( semilattice_order(B,Fa,Less_eq,Less)
       => semila1105856199041335345_order(B,Fa,Z2,Less_eq,Less) ) ) ).

% semilattice_neutr_order.intro
tff(fact_5265_inf_Osemilattice__order__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => semilattice_order(B,inf_inf(B),ord_less_eq(B),ord_less(B)) ) ).

% inf.semilattice_order_axioms
tff(fact_5266_min_Osemilattice__order__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semilattice_order(B,ord_min(B),ord_less_eq(B),ord_less(B)) ) ).

% min.semilattice_order_axioms
tff(fact_5267_sup_Osemilattice__order__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => semilattice_order(B,sup_sup(B),aTP_Lamp_oe(B,fun(B,$o)),aTP_Lamp_of(B,fun(B,$o))) ) ).

% sup.semilattice_order_axioms
tff(fact_5268_Heap_Orec__o__map,axiom,
    ! [C: $tType,D: $tType,B: $tType,Ga: fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),Fa: fun(B,D)] : ( aa(fun(heap_Time_Heap(B),heap_Time_Heap(D)),fun(heap_Time_Heap(B),C),aa(fun(heap_Time_Heap(D),C),fun(fun(heap_Time_Heap(B),heap_Time_Heap(D)),fun(heap_Time_Heap(B),C)),comp(heap_Time_Heap(D),C,heap_Time_Heap(B)),aa(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(D),C),heap_Time_rec_Heap(D,C),Ga)),aa(fun(B,D),fun(heap_Time_Heap(B),heap_Time_Heap(D)),heap_Time_map_Heap(B,D),Fa)) = aa(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(B),C),heap_Time_rec_Heap(B,C),aa(fun(B,D),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),aTP_Lamp_uv(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(B,D),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C)),Ga),Fa)) ) ).

% Heap.rec_o_map
tff(fact_5269_prod__mset__def,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ( comm_m9189036328036947845d_mset(B) = comm_monoid_F(B,times_times(B),one_one(B)) ) ) ).

% prod_mset_def
tff(fact_5270_Heap_Oset,axiom,
    ! [B: $tType,X: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),X)) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),set(set(B)),image2(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(B),aTP_Lamp_uw(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(B))),aa(set(heap_ext(product_unit)),set(option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),image2(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),X),top_top(set(heap_ext(product_unit)))))) ) ).

% Heap.set
tff(fact_5271_Heap_Oset__intros,axiom,
    ! [B: $tType,Y: option(product_prod(B,product_prod(heap_ext(product_unit),nat))),X: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Ya: product_prod(B,product_prod(heap_ext(product_unit),nat)),Yb2: B] :
      ( member(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),Y,aa(set(heap_ext(product_unit)),set(option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),image2(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),X),top_top(set(heap_ext(product_unit)))))
     => ( member(product_prod(B,product_prod(heap_ext(product_unit),nat)),Ya,aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(product_prod(B,product_prod(heap_ext(product_unit),nat))),set_option(product_prod(B,product_prod(heap_ext(product_unit),nat))),Y))
       => ( member(B,Yb2,aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),set(B),basic_fsts(B,product_prod(heap_ext(product_unit),nat)),Ya))
         => member(B,Yb2,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),X))) ) ) ) ).

% Heap.set_intros
tff(fact_5272_Heap_Oset__cases,axiom,
    ! [B: $tType,E2: B,A3: heap_Time_Heap(B)] :
      ( member(B,E2,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),A3))
     => ~ ! [Z3: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] :
            ( ( A3 = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),Z3) )
           => ! [Xa4: option(product_prod(B,product_prod(heap_ext(product_unit),nat)))] :
                ( member(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),Xa4,aa(set(heap_ext(product_unit)),set(option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),image2(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),Z3),top_top(set(heap_ext(product_unit)))))
               => ! [Xb4: product_prod(B,product_prod(heap_ext(product_unit),nat))] :
                    ( member(product_prod(B,product_prod(heap_ext(product_unit),nat)),Xb4,aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(product_prod(B,product_prod(heap_ext(product_unit),nat))),set_option(product_prod(B,product_prod(heap_ext(product_unit),nat))),Xa4))
                   => ~ member(B,E2,aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),set(B),basic_fsts(B,product_prod(heap_ext(product_unit),nat)),Xb4)) ) ) ) ) ).

% Heap.set_cases
tff(fact_5273_Heap_Omap__cong,axiom,
    ! [C: $tType,B: $tType,X: heap_Time_Heap(B),Ya: heap_Time_Heap(B),Fa: fun(B,C),Ga: fun(B,C)] :
      ( ( X = Ya )
     => ( ! [Z3: B] :
            ( member(B,Z3,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),Ya))
           => ( aa(B,C,Fa,Z3) = aa(B,C,Ga,Z3) ) )
       => ( aa(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Fa),X) = aa(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Ga),Ya) ) ) ) ).

% Heap.map_cong
tff(fact_5274_Heap_Omap__cong0,axiom,
    ! [C: $tType,B: $tType,X: heap_Time_Heap(B),Fa: fun(B,C),Ga: fun(B,C)] :
      ( ! [Z3: B] :
          ( member(B,Z3,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),X))
         => ( aa(B,C,Fa,Z3) = aa(B,C,Ga,Z3) ) )
     => ( aa(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Fa),X) = aa(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Ga),X) ) ) ).

% Heap.map_cong0
tff(fact_5275_Heap_Oinj__map__strong,axiom,
    ! [C: $tType,B: $tType,X: heap_Time_Heap(B),Xa: heap_Time_Heap(B),Fa: fun(B,C),Faa: fun(B,C)] :
      ( ! [Z3: B,Za: B] :
          ( member(B,Z3,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),X))
         => ( member(B,Za,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),Xa))
           => ( ( aa(B,C,Fa,Z3) = aa(B,C,Faa,Za) )
             => ( Z3 = Za ) ) ) )
     => ( ( aa(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Fa),X) = aa(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Faa),Xa) )
       => ( X = Xa ) ) ) ).

% Heap.inj_map_strong
tff(fact_5276_Heap_Orec,axiom,
    ! [B: $tType,C: $tType,Fa: fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),B),X: fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(C),B,aa(fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),B),fun(heap_Time_Heap(C),B),heap_Time_rec_Heap(C,B),Fa),aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(C),heap_Time_Heap2(C),X)) = aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),B,Fa,X) ) ).

% Heap.rec
tff(fact_5277_Heap_Oset__map,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,B),V: heap_Time_Heap(C)] : ( aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),aa(heap_Time_Heap(C),heap_Time_Heap(B),aa(fun(C,B),fun(heap_Time_Heap(C),heap_Time_Heap(B)),heap_Time_map_Heap(C,B),Fa),V)) = aa(set(C),set(B),image2(C,B,Fa),aa(heap_Time_Heap(C),set(C),heap_Time_set_Heap(C),V)) ) ).

% Heap.set_map
tff(fact_5278_Heap_Orel__Grp,axiom,
    ! [C: $tType,B: $tType,A4: set(B),Fa: fun(B,C)] : ( aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),bNF_Grp(B,C,A4,Fa)) = bNF_Grp(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(heap_Time_Heap(B),$o),set(heap_Time_Heap(B)),collect(heap_Time_Heap(B)),aTP_Lamp_ux(set(B),fun(heap_Time_Heap(B),$o),A4)),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Fa)) ) ).

% Heap.rel_Grp
tff(fact_5279_Heap_Orel__compp__Grp,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] : ( aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R) = relcompp(heap_Time_Heap(B),heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(C),conversep(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(B),bNF_Grp(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(B),aa(fun(heap_Time_Heap(product_prod(B,C)),$o),set(heap_Time_Heap(product_prod(B,C))),collect(heap_Time_Heap(product_prod(B,C))),aTP_Lamp_uy(fun(B,fun(C,$o)),fun(heap_Time_Heap(product_prod(B,C)),$o),R)),aa(fun(product_prod(B,C),B),fun(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(B)),heap_Time_map_Heap(product_prod(B,C),B),product_fst(B,C)))),bNF_Grp(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(C),aa(fun(heap_Time_Heap(product_prod(B,C)),$o),set(heap_Time_Heap(product_prod(B,C))),collect(heap_Time_Heap(product_prod(B,C))),aTP_Lamp_uy(fun(B,fun(C,$o)),fun(heap_Time_Heap(product_prod(B,C)),$o),R)),aa(fun(product_prod(B,C),C),fun(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(C)),heap_Time_map_Heap(product_prod(B,C),C),product_snd(B,C)))) ) ).

% Heap.rel_compp_Grp
tff(fact_5280_Heap_Oin__rel,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),A3: heap_Time_Heap(B),Ba: heap_Time_Heap(C)] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R),A3),Ba)
    <=> ? [Z4: heap_Time_Heap(product_prod(B,C))] :
          ( member(heap_Time_Heap(product_prod(B,C)),Z4,aa(fun(heap_Time_Heap(product_prod(B,C)),$o),set(heap_Time_Heap(product_prod(B,C))),collect(heap_Time_Heap(product_prod(B,C))),aTP_Lamp_uy(fun(B,fun(C,$o)),fun(heap_Time_Heap(product_prod(B,C)),$o),R)))
          & ( aa(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(B),aa(fun(product_prod(B,C),B),fun(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(B)),heap_Time_map_Heap(product_prod(B,C),B),product_fst(B,C)),Z4) = A3 )
          & ( aa(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(C),aa(fun(product_prod(B,C),C),fun(heap_Time_Heap(product_prod(B,C)),heap_Time_Heap(C)),heap_Time_map_Heap(product_prod(B,C),C),product_snd(B,C)),Z4) = Ba ) ) ) ).

% Heap.in_rel
tff(fact_5281_Heap_Orel__cong,axiom,
    ! [B: $tType,C: $tType,X: heap_Time_Heap(B),Ya: heap_Time_Heap(B),Y: heap_Time_Heap(C),Xa: heap_Time_Heap(C),R: fun(B,fun(C,$o)),Ra2: fun(B,fun(C,$o))] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z3: B,Yb: C] :
              ( member(B,Z3,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),Ya))
             => ( member(C,Yb,aa(heap_Time_Heap(C),set(C),heap_Time_set_Heap(C),Xa))
               => ( aa(C,$o,aa(B,fun(C,$o),R,Z3),Yb)
                <=> aa(C,$o,aa(B,fun(C,$o),Ra2,Z3),Yb) ) ) )
         => ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R),X),Y)
          <=> aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),Ra2),Ya),Xa) ) ) ) ) ).

% Heap.rel_cong
tff(fact_5282_Heap_Orel__mono__strong,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),X: heap_Time_Heap(B),Y: heap_Time_Heap(C),Ra2: fun(B,fun(C,$o))] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R),X),Y)
     => ( ! [Z3: B,Yb: C] :
            ( member(B,Z3,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),X))
           => ( member(C,Yb,aa(heap_Time_Heap(C),set(C),heap_Time_set_Heap(C),Y))
             => ( aa(C,$o,aa(B,fun(C,$o),R,Z3),Yb)
               => aa(C,$o,aa(B,fun(C,$o),Ra2,Z3),Yb) ) ) )
       => aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),Ra2),X),Y) ) ) ).

% Heap.rel_mono_strong
tff(fact_5283_Heap_Orel__refl__strong,axiom,
    ! [B: $tType,X: heap_Time_Heap(B),Ra2: fun(B,fun(B,$o))] :
      ( ! [Z3: B] :
          ( member(B,Z3,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),X))
         => aa(B,$o,aa(B,fun(B,$o),Ra2,Z3),Z3) )
     => aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),aa(fun(B,fun(B,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(B,B),Ra2),X),X) ) ).

% Heap.rel_refl_strong
tff(fact_5284_Heap_Orel__mono,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o)),Ra2: fun(B,fun(C,$o))] :
      ( aa(fun(B,fun(C,$o)),$o,aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),$o),ord_less_eq(fun(B,fun(C,$o))),R),Ra2)
     => aa(fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),$o,aa(fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),fun(fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),$o),ord_less_eq(fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o))),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R)),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),Ra2)) ) ).

% Heap.rel_mono
tff(fact_5285_Heap_Orel__transfer,axiom,
    ! [B: $tType,C: $tType,E: $tType,D: $tType,Sa: fun(B,fun(D,$o)),Sc: fun(C,fun(E,$o))] : aa(fun(fun(D,fun(E,$o)),fun(heap_Time_Heap(D),fun(heap_Time_Heap(E),$o))),$o,aa(fun(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o))),fun(fun(fun(D,fun(E,$o)),fun(heap_Time_Heap(D),fun(heap_Time_Heap(E),$o))),$o),bNF_rel_fun(fun(B,fun(C,$o)),fun(D,fun(E,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),fun(heap_Time_Heap(D),fun(heap_Time_Heap(E),$o)),bNF_rel_fun(B,D,fun(C,$o),fun(E,$o),Sa,bNF_rel_fun(C,E,$o,$o,Sc,fequal($o))),bNF_rel_fun(heap_Time_Heap(B),heap_Time_Heap(D),fun(heap_Time_Heap(C),$o),fun(heap_Time_Heap(E),$o),aa(fun(B,fun(D,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(D),$o)),heap_Time_rel_Heap(B,D),Sa),bNF_rel_fun(heap_Time_Heap(C),heap_Time_Heap(E),$o,$o,aa(fun(C,fun(E,$o)),fun(heap_Time_Heap(C),fun(heap_Time_Heap(E),$o)),heap_Time_rel_Heap(C,E),Sc),fequal($o)))),heap_Time_rel_Heap(B,C)),heap_Time_rel_Heap(D,E)) ).

% Heap.rel_transfer
tff(fact_5286_Heap_Orel__compp,axiom,
    ! [B: $tType,C: $tType,D: $tType,R: fun(B,fun(D,$o)),S2: fun(D,fun(C,$o))] : ( aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),relcompp(B,D,C,R,S2)) = relcompp(heap_Time_Heap(B),heap_Time_Heap(D),heap_Time_Heap(C),aa(fun(B,fun(D,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(D),$o)),heap_Time_rel_Heap(B,D),R),aa(fun(D,fun(C,$o)),fun(heap_Time_Heap(D),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(D,C),S2)) ) ).

% Heap.rel_compp
tff(fact_5287_Heap_Orel__refl,axiom,
    ! [B: $tType,Ra2: fun(B,fun(B,$o)),X: heap_Time_Heap(B)] :
      ( ! [X2: B] : aa(B,$o,aa(B,fun(B,$o),Ra2,X2),X2)
     => aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),aa(fun(B,fun(B,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(B,B),Ra2),X),X) ) ).

% Heap.rel_refl
tff(fact_5288_Heap_Orel__eq,axiom,
    ! [B: $tType] : ( aa(fun(B,fun(B,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(B,B),fequal(B)) = fequal(heap_Time_Heap(B)) ) ).

% Heap.rel_eq
tff(fact_5289_Heap_Orel__conversep,axiom,
    ! [B: $tType,C: $tType,R: fun(C,fun(B,$o))] : ( aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),conversep(C,B,R)) = conversep(heap_Time_Heap(C),heap_Time_Heap(B),aa(fun(C,fun(B,$o)),fun(heap_Time_Heap(C),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(C,B),R)) ) ).

% Heap.rel_conversep
tff(fact_5290_Heap_Orel__flip,axiom,
    ! [C: $tType,B: $tType,R: fun(C,fun(B,$o)),A3: heap_Time_Heap(B),Ba: heap_Time_Heap(C)] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),conversep(C,B,R)),A3),Ba)
    <=> aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(C),fun(heap_Time_Heap(B),$o),aa(fun(C,fun(B,$o)),fun(heap_Time_Heap(C),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(C,B),R),Ba),A3) ) ).

% Heap.rel_flip
tff(fact_5291_Heap_Oleft__unique__rel,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] :
      ( left_unique(B,C,R)
     => left_unique(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R)) ) ).

% Heap.left_unique_rel
tff(fact_5292_Heap_Orel__map_I2_J,axiom,
    ! [B: $tType,C: $tType,D: $tType,Sa: fun(B,fun(C,$o)),X: heap_Time_Heap(B),Ga: fun(D,C),Y: heap_Time_Heap(D)] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),Sa),X),aa(heap_Time_Heap(D),heap_Time_Heap(C),aa(fun(D,C),fun(heap_Time_Heap(D),heap_Time_Heap(C)),heap_Time_map_Heap(D,C),Ga),Y))
    <=> aa(heap_Time_Heap(D),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(D),$o),aa(fun(B,fun(D,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(D),$o)),heap_Time_rel_Heap(B,D),aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_uz(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Sa),Ga)),X),Y) ) ).

% Heap.rel_map(2)
tff(fact_5293_Heap_Orel__map_I1_J,axiom,
    ! [D: $tType,B: $tType,C: $tType,Sb: fun(B,fun(C,$o)),I: fun(D,B),X: heap_Time_Heap(D),Y: heap_Time_Heap(C)] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),Sb),aa(heap_Time_Heap(D),heap_Time_Heap(B),aa(fun(D,B),fun(heap_Time_Heap(D),heap_Time_Heap(B)),heap_Time_map_Heap(D,B),I),X)),Y)
    <=> aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(D),fun(heap_Time_Heap(C),$o),aa(fun(D,fun(C,$o)),fun(heap_Time_Heap(D),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(D,C),aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_va(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Sb),I)),X),Y) ) ).

% Heap.rel_map(1)
tff(fact_5294_Heap_Omap__transfer,axiom,
    ! [B: $tType,C: $tType,E: $tType,D: $tType,Rb2: fun(B,fun(D,$o)),Sd: fun(C,fun(E,$o))] : aa(fun(fun(D,E),fun(heap_Time_Heap(D),heap_Time_Heap(E))),$o,aa(fun(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C))),fun(fun(fun(D,E),fun(heap_Time_Heap(D),heap_Time_Heap(E))),$o),bNF_rel_fun(fun(B,C),fun(D,E),fun(heap_Time_Heap(B),heap_Time_Heap(C)),fun(heap_Time_Heap(D),heap_Time_Heap(E)),bNF_rel_fun(B,D,C,E,Rb2,Sd),bNF_rel_fun(heap_Time_Heap(B),heap_Time_Heap(D),heap_Time_Heap(C),heap_Time_Heap(E),aa(fun(B,fun(D,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(D),$o)),heap_Time_rel_Heap(B,D),Rb2),aa(fun(C,fun(E,$o)),fun(heap_Time_Heap(C),fun(heap_Time_Heap(E),$o)),heap_Time_rel_Heap(C,E),Sd))),heap_Time_map_Heap(B,C)),heap_Time_map_Heap(D,E)) ).

% Heap.map_transfer
tff(fact_5295_Heap_Oset__transfer,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o))] : aa(fun(heap_Time_Heap(C),set(C)),$o,aa(fun(heap_Time_Heap(B),set(B)),fun(fun(heap_Time_Heap(C),set(C)),$o),bNF_rel_fun(heap_Time_Heap(B),heap_Time_Heap(C),set(B),set(C),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R),bNF_rel_set(B,C,R)),heap_Time_set_Heap(B)),heap_Time_set_Heap(C)) ).

% Heap.set_transfer
tff(fact_5296_sorted__wrt_Opelims_I1_J,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B),Y: $o] :
      ( ( sorted_wrt(B,X,Xa)
      <=> (Y) )
     => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),sorted_wrt_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),Xa))
       => ( ( ( Xa = nil(B) )
           => ( (Y)
             => ~ aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),sorted_wrt_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),nil(B))) ) )
         => ~ ! [X2: B,Ys2: list(B)] :
                ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Ys2) )
               => ( ( (Y)
                  <=> ( ! [Xa2: B] :
                          ( member(B,Xa2,aa(list(B),set(B),set2(B),Ys2))
                         => aa(B,$o,aa(B,fun(B,$o),X,X2),Xa2) )
                      & sorted_wrt(B,X,Ys2) ) )
                 => ~ aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),sorted_wrt_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Ys2))) ) ) ) ) ) ).

% sorted_wrt.pelims(1)
tff(fact_5297_sorted__wrt_Opelims_I2_J,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B)] :
      ( sorted_wrt(B,X,Xa)
     => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),sorted_wrt_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),Xa))
       => ( ( ( Xa = nil(B) )
           => ~ aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),sorted_wrt_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),nil(B))) )
         => ~ ! [X2: B,Ys2: list(B)] :
                ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Ys2) )
               => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),sorted_wrt_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Ys2)))
                 => ~ ( ! [Xa3: B] :
                          ( member(B,Xa3,aa(list(B),set(B),set2(B),Ys2))
                         => aa(B,$o,aa(B,fun(B,$o),X,X2),Xa3) )
                      & sorted_wrt(B,X,Ys2) ) ) ) ) ) ) ).

% sorted_wrt.pelims(2)
tff(fact_5298_size__multiset__o__map,axiom,
    ! [C: $tType,B: $tType,Ga: fun(C,nat),Fa: fun(B,C)] : ( aa(fun(multiset(B),multiset(C)),fun(multiset(B),nat),aa(fun(multiset(C),nat),fun(fun(multiset(B),multiset(C)),fun(multiset(B),nat)),comp(multiset(C),nat,multiset(B)),size_multiset(C,Ga)),image_mset(B,C,Fa)) = size_multiset(B,aa(fun(B,C),fun(B,nat),aa(fun(C,nat),fun(fun(B,C),fun(B,nat)),comp(C,nat,B),Ga),Fa)) ) ).

% size_multiset_o_map
tff(fact_5299_sorted__wrt_Opelims_I3_J,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B)] :
      ( ~ sorted_wrt(B,X,Xa)
     => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),sorted_wrt_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),Xa))
       => ~ ! [X2: B,Ys2: list(B)] :
              ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Ys2) )
             => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),sorted_wrt_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),Ys2)))
               => ( ! [Xa4: B] :
                      ( member(B,Xa4,aa(list(B),set(B),set2(B),Ys2))
                     => aa(B,$o,aa(B,fun(B,$o),X,X2),Xa4) )
                  & sorted_wrt(B,X,Ys2) ) ) ) ) ) ).

% sorted_wrt.pelims(3)
tff(fact_5300_Heap_Opred__transfer,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o))] : aa(fun(fun(C,$o),fun(heap_Time_Heap(C),$o)),$o,aa(fun(fun(B,$o),fun(heap_Time_Heap(B),$o)),fun(fun(fun(C,$o),fun(heap_Time_Heap(C),$o)),$o),bNF_rel_fun(fun(B,$o),fun(C,$o),fun(heap_Time_Heap(B),$o),fun(heap_Time_Heap(C),$o),bNF_rel_fun(B,C,$o,$o,R,fequal($o)),bNF_rel_fun(heap_Time_Heap(B),heap_Time_Heap(C),$o,$o,aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R),fequal($o))),heap_Time_pred_Heap(B)),heap_Time_pred_Heap(C)) ).

% Heap.pred_transfer
tff(fact_5301_numeral__sqr,axiom,
    ! [B: $tType] :
      ( semiring_numeral(B)
     => ! [K: num] : ( aa(num,B,numeral_numeral(B),sqr(K)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),K)),aa(num,B,numeral_numeral(B),K)) ) ) ).

% numeral_sqr
tff(fact_5302_folding__on_Oremove,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C)),A4: set(B),X: B,Z2: C] :
      ( finite_folding_on(B,C,S2,Fa)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A4),S2)
       => ( aa(set(B),$o,finite_finite(B),A4)
         => ( member(B,X,A4)
           => ( finite_folding_F(B,C,Fa,Z2,A4) = aa(C,C,aa(B,fun(C,C),Fa,X),finite_folding_F(B,C,Fa,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ) ).

% folding_on.remove
tff(fact_5303_Heap_Opred__mono,axiom,
    ! [B: $tType,Pa: fun(B,$o),Paa: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less_eq(fun(B,$o)),Pa),Paa)
     => aa(fun(heap_Time_Heap(B),$o),$o,aa(fun(heap_Time_Heap(B),$o),fun(fun(heap_Time_Heap(B),$o),$o),ord_less_eq(fun(heap_Time_Heap(B),$o)),aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Pa)),aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Paa)) ) ).

% Heap.pred_mono
tff(fact_5304_folding__on_Ointro,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C))] :
      ( ! [X2: B,Y2: B] :
          ( member(B,X2,S2)
         => ( member(B,Y2,S2)
           => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y2)),aa(B,fun(C,C),Fa,X2)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,Y2)) ) ) )
     => finite_folding_on(B,C,S2,Fa) ) ).

% folding_on.intro
tff(fact_5305_folding__on_Ocomp__fun__commute__on,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C)),X: B,Y: B] :
      ( finite_folding_on(B,C,S2,Fa)
     => ( member(B,X,S2)
       => ( member(B,Y,S2)
         => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y)),aa(B,fun(C,C),Fa,X)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X)),aa(B,fun(C,C),Fa,Y)) ) ) ) ) ).

% folding_on.comp_fun_commute_on
tff(fact_5306_folding__on__def,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C))] :
      ( finite_folding_on(B,C,S2,Fa)
    <=> ! [X4: B,Y3: B] :
          ( member(B,X4,S2)
         => ( member(B,Y3,S2)
           => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y3)),aa(B,fun(C,C),Fa,X4)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X4)),aa(B,fun(C,C),Fa,Y3)) ) ) ) ) ).

% folding_on_def
tff(fact_5307_folding__on_Oempty,axiom,
    ! [B: $tType,C: $tType,S2: set(B),Fa: fun(B,fun(C,C)),Z2: C] :
      ( finite_folding_on(B,C,S2,Fa)
     => ( finite_folding_F(B,C,Fa,Z2,bot_bot(set(B))) = Z2 ) ) ).

% folding_on.empty
tff(fact_5308_Heap_Opred__True,axiom,
    ! [B: $tType,X3: heap_Time_Heap(B)] : aa(heap_Time_Heap(B),$o,aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),aTP_Lamp_ra(B,$o)),X3) ).

% Heap.pred_True
tff(fact_5309_Heap_Opred__mono__strong,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: heap_Time_Heap(B),Paa: fun(B,$o)] :
      ( aa(heap_Time_Heap(B),$o,aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Pa),X)
     => ( ! [Z3: B] :
            ( member(B,Z3,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),X))
           => ( aa(B,$o,Pa,Z3)
             => aa(B,$o,Paa,Z3) ) )
       => aa(heap_Time_Heap(B),$o,aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Paa),X) ) ) ).

% Heap.pred_mono_strong
tff(fact_5310_Heap_Opred__cong,axiom,
    ! [B: $tType,X: heap_Time_Heap(B),Ya: heap_Time_Heap(B),Pa: fun(B,$o),Paa: fun(B,$o)] :
      ( ( X = Ya )
     => ( ! [Z3: B] :
            ( member(B,Z3,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),Ya))
           => ( aa(B,$o,Pa,Z3)
            <=> aa(B,$o,Paa,Z3) ) )
       => ( aa(heap_Time_Heap(B),$o,aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Pa),X)
        <=> aa(heap_Time_Heap(B),$o,aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Paa),Ya) ) ) ) ).

% Heap.pred_cong
tff(fact_5311_Heap_Omap__cong__pred,axiom,
    ! [C: $tType,B: $tType,X: heap_Time_Heap(B),Ya: heap_Time_Heap(B),Fa: fun(B,C),Ga: fun(B,C)] :
      ( ( X = Ya )
     => ( aa(heap_Time_Heap(B),$o,aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),aa(fun(B,C),fun(B,$o),aTP_Lamp_vb(fun(B,C),fun(fun(B,C),fun(B,$o)),Fa),Ga)),Ya)
       => ( aa(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Fa),X) = aa(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Ga),Ya) ) ) ) ).

% Heap.map_cong_pred
tff(fact_5312_Heap_Orel__eq__onp,axiom,
    ! [B: $tType,Pa: fun(B,$o)] : ( aa(fun(B,fun(B,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(B,B),bNF_eq_onp(B,Pa)) = bNF_eq_onp(heap_Time_Heap(B),aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Pa)) ) ).

% Heap.rel_eq_onp
tff(fact_5313_Heap_Opred__rel,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: heap_Time_Heap(B)] :
      ( aa(heap_Time_Heap(B),$o,aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Pa),X)
    <=> aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),aa(fun(B,fun(B,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(B,B),bNF_eq_onp(B,Pa)),X),X) ) ).

% Heap.pred_rel
tff(fact_5314_Heap_Opred__set,axiom,
    ! [B: $tType,Pa: fun(B,$o),X3: heap_Time_Heap(B)] :
      ( aa(heap_Time_Heap(B),$o,aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Pa),X3)
    <=> ! [Xa2: B] :
          ( member(B,Xa2,aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),X3))
         => aa(B,$o,Pa,Xa2) ) ) ).

% Heap.pred_set
tff(fact_5315_Heap_ODomainp__rel,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] : ( domainp(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R)) = aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),domainp(B,C,R)) ) ).

% Heap.Domainp_rel
tff(fact_5316_Heap_Opred__map,axiom,
    ! [B: $tType,C: $tType,Qa: fun(B,$o),Fa: fun(C,B),X: heap_Time_Heap(C)] :
      ( aa(heap_Time_Heap(B),$o,aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Qa),aa(heap_Time_Heap(C),heap_Time_Heap(B),aa(fun(C,B),fun(heap_Time_Heap(C),heap_Time_Heap(B)),heap_Time_map_Heap(C,B),Fa),X))
    <=> aa(heap_Time_Heap(C),$o,aa(fun(C,$o),fun(heap_Time_Heap(C),$o),heap_Time_pred_Heap(C),aa(fun(C,B),fun(C,$o),aa(fun(B,$o),fun(fun(C,B),fun(C,$o)),comp(B,$o,C),Qa),Fa)),X) ) ).

% Heap.pred_map
tff(fact_5317_folding__on_Oinsert__remove,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C)),X: B,A4: set(B),Z2: C] :
      ( finite_folding_on(B,C,S2,Fa)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,X),A4)),S2)
       => ( aa(set(B),$o,finite_finite(B),A4)
         => ( finite_folding_F(B,C,Fa,Z2,aa(set(B),set(B),insert2(B,X),A4)) = aa(C,C,aa(B,fun(C,C),Fa,X),finite_folding_F(B,C,Fa,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% folding_on.insert_remove
tff(fact_5318_coinduct,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Fa: fun(B,B),X6: B] :
          ( order_mono(B,B,Fa)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X6),aa(B,B,Fa,aa(B,B,aa(B,fun(B,B),sup_sup(B),X6),complete_lattice_gfp(B,Fa))))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X6),complete_lattice_gfp(B,Fa)) ) ) ) ).

% coinduct
tff(fact_5319_def__coinduct,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A4: B,Fa: fun(B,B),X6: B] :
          ( ( A4 = complete_lattice_gfp(B,Fa) )
         => ( order_mono(B,B,Fa)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X6),aa(B,B,Fa,aa(B,B,aa(B,fun(B,B),sup_sup(B),X6),A4)))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X6),A4) ) ) ) ) ).

% def_coinduct
tff(fact_5320_coinduct__lemma,axiom,
    ! [B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [X6: B,Fa: fun(B,B)] :
          ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X6),aa(B,B,Fa,aa(B,B,aa(B,fun(B,B),sup_sup(B),X6),complete_lattice_gfp(B,Fa))))
         => ( order_mono(B,B,Fa)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),X6),complete_lattice_gfp(B,Fa))),aa(B,B,Fa,aa(B,B,aa(B,fun(B,B),sup_sup(B),X6),complete_lattice_gfp(B,Fa)))) ) ) ) ).

% coinduct_lemma
tff(fact_5321_predicate1I,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o)] :
      ( ! [X2: B] :
          ( aa(B,$o,Pa,X2)
         => aa(B,$o,Qa,X2) )
     => aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less_eq(fun(B,$o)),Pa),Qa) ) ).

% predicate1I
tff(fact_5322_rev__predicate1D,axiom,
    ! [B: $tType,Pa: fun(B,$o),X: B,Qa: fun(B,$o)] :
      ( aa(B,$o,Pa,X)
     => ( aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less_eq(fun(B,$o)),Pa),Qa)
       => aa(B,$o,Qa,X) ) ) ).

% rev_predicate1D
tff(fact_5323_predicate1D,axiom,
    ! [B: $tType,Pa: fun(B,$o),Qa: fun(B,$o),X: B] :
      ( aa(fun(B,$o),$o,aa(fun(B,$o),fun(fun(B,$o),$o),ord_less_eq(fun(B,$o)),Pa),Qa)
     => ( aa(B,$o,Pa,X)
       => aa(B,$o,Qa,X) ) ) ).

% predicate1D
tff(fact_5324_Random__Pred_Onot__randompred__def,axiom,
    ! [Pa: fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),X3: product_prod(code_natural,code_natural)] : ( random6974930770145893639ompred(Pa,X3) = aa(product_prod(pred(product_unit),product_prod(code_natural,code_natural)),product_prod(pred(product_unit),product_prod(code_natural,code_natural)),aa(fun(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)))),fun(product_prod(pred(product_unit),product_prod(code_natural,code_natural)),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),product_case_prod(pred(product_unit),product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),aTP_Lamp_vc(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))))),aa(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)),Pa,X3)) ) ).

% Random_Pred.not_randompred_def
tff(fact_5325_filtercomap__neq__bot__surj,axiom,
    ! [B: $tType,C: $tType,F: filter(B),Fa: fun(C,B)] :
      ( ( F != bot_bot(filter(B)) )
     => ( ( aa(set(C),set(B),image2(C,B,Fa),top_top(set(C))) = top_top(set(B)) )
       => ( filtercomap(C,B,Fa,F) != bot_bot(filter(C)) ) ) ) ).

% filtercomap_neq_bot_surj
tff(fact_5326_trancl__def,axiom,
    ! [B: $tType,X3: set(product_prod(B,B))] : ( transitive_trancl(B,X3) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),transitive_tranclp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),X3)))) ) ).

% trancl_def
tff(fact_5327_filtercomap__bot,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,C)] : ( filtercomap(B,C,Fa,bot_bot(filter(C))) = bot_bot(filter(B)) ) ).

% filtercomap_bot
tff(fact_5328_eval__inf,axiom,
    ! [B: $tType,Pa: pred(B),Qa: pred(B)] : ( aa(pred(B),fun(B,$o),eval(B),aa(pred(B),pred(B),aa(pred(B),fun(pred(B),pred(B)),inf_inf(pred(B)),Pa),Qa)) = aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),aa(pred(B),fun(B,$o),eval(B),Pa)),aa(pred(B),fun(B,$o),eval(B),Qa)) ) ).

% eval_inf
tff(fact_5329_eval__bot,axiom,
    ! [B: $tType] : ( aa(pred(B),fun(B,$o),eval(B),bot_bot(pred(B))) = bot_bot(fun(B,$o)) ) ).

% eval_bot
tff(fact_5330_eval__INF,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,pred(B)),A4: set(C)] : ( aa(pred(B),fun(B,$o),eval(B),aa(set(pred(B)),pred(B),complete_Inf_Inf(pred(B)),aa(set(C),set(pred(B)),image2(C,pred(B),Fa),A4))) = aa(set(fun(B,$o)),fun(B,$o),complete_Inf_Inf(fun(B,$o)),aa(set(C),set(fun(B,$o)),image2(C,fun(B,$o),aa(fun(C,pred(B)),fun(C,fun(B,$o)),aa(fun(pred(B),fun(B,$o)),fun(fun(C,pred(B)),fun(C,fun(B,$o))),comp(pred(B),fun(B,$o),C),eval(B)),Fa)),A4)) ) ).

% eval_INF
tff(fact_5331_eval__SUP,axiom,
    ! [B: $tType,C: $tType,Fa: fun(C,pred(B)),A4: set(C)] : ( aa(pred(B),fun(B,$o),eval(B),aa(set(pred(B)),pred(B),complete_Sup_Sup(pred(B)),aa(set(C),set(pred(B)),image2(C,pred(B),Fa),A4))) = aa(set(fun(B,$o)),fun(B,$o),complete_Sup_Sup(fun(B,$o)),aa(set(C),set(fun(B,$o)),image2(C,fun(B,$o),aa(fun(C,pred(B)),fun(C,fun(B,$o)),aa(fun(pred(B),fun(B,$o)),fun(fun(C,pred(B)),fun(C,fun(B,$o))),comp(pred(B),fun(B,$o),C),eval(B)),Fa)),A4)) ) ).

% eval_SUP
tff(fact_5332_botE,axiom,
    ! [B: $tType,X: B] : ~ aa(B,$o,aa(pred(B),fun(B,$o),eval(B),bot_bot(pred(B))),X) ).

% botE
tff(fact_5333_not__bot,axiom,
    ! [B: $tType,A4: pred(B)] :
      ( ( A4 != bot_bot(pred(B)) )
     => ~ ! [X2: B] : ~ aa(B,$o,aa(pred(B),fun(B,$o),eval(B),A4),X2) ) ).

% not_bot
tff(fact_5334_tranclp__induct2,axiom,
    ! [B: $tType,C: $tType,R3: fun(product_prod(B,C),fun(product_prod(B,C),$o)),Ax: B,Ay: C,Bx: B,By: C,Pa: fun(B,fun(C,$o))] :
      ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),transitive_tranclp(product_prod(B,C),R3),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Bx),By))
     => ( ! [A8: B,B4: C] :
            ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),R3,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4))
           => aa(C,$o,aa(B,fun(C,$o),Pa,A8),B4) )
       => ( ! [A8: B,B4: C,Aa2: B,Ba2: C] :
              ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),transitive_tranclp(product_prod(B,C),R3),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4))
             => ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),R3,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Aa2),Ba2))
               => ( aa(C,$o,aa(B,fun(C,$o),Pa,A8),B4)
                 => aa(C,$o,aa(B,fun(C,$o),Pa,Aa2),Ba2) ) ) )
         => aa(C,$o,aa(B,fun(C,$o),Pa,Bx),By) ) ) ) ).

% tranclp_induct2
tff(fact_5335_filtercomap__inf,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,C),F12: filter(C),F24: filter(C)] : ( filtercomap(B,C,Fa,aa(filter(C),filter(C),aa(filter(C),fun(filter(C),filter(C)),inf_inf(filter(C)),F12),F24)) = aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),filtercomap(B,C,Fa,F12)),filtercomap(B,C,Fa,F24)) ) ).

% filtercomap_inf
tff(fact_5336_filterlim__filtercomap__iff,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,C),Ga: fun(C,D),G5: filter(D),F: filter(B)] :
      ( filterlim(B,C,Fa,filtercomap(C,D,Ga,G5),F)
    <=> filterlim(B,D,aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Ga),Fa),G5,F) ) ).

% filterlim_filtercomap_iff
tff(fact_5337_tranclp__trancl__eq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X3: B,Xa3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),transitive_tranclp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3)),X3),Xa3)
    <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa3),transitive_trancl(B,R3)) ) ).

% tranclp_trancl_eq
tff(fact_5338_filtercomap__neq__bot,axiom,
    ! [B: $tType,C: $tType,F: filter(B),Fa: fun(C,B)] :
      ( ! [P4: fun(B,$o)] :
          ( eventually(B,P4,F)
         => ? [X3: C] : aa(B,$o,P4,aa(C,B,Fa,X3)) )
     => ( filtercomap(C,B,Fa,F) != bot_bot(filter(C)) ) ) ).

% filtercomap_neq_bot
tff(fact_5339_Nitpick_Otranclp__unfold,axiom,
    ! [B: $tType,R3: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( aa(B,$o,aa(B,fun(B,$o),transitive_tranclp(B,R3),A3),Ba)
    <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),transitive_trancl(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R3)))) ) ).

% Nitpick.tranclp_unfold
tff(fact_5340_not__pred__eq,axiom,
    ! [Pa: pred(product_unit)] :
      ( not_pred(Pa)
      = $ite(aa(product_unit,$o,aa(pred(product_unit),fun(product_unit,$o),eval(product_unit),Pa),product_Unity),bot_bot(pred(product_unit)),aa(product_unit,pred(product_unit),single(product_unit),product_Unity)) ) ).

% not_pred_eq
tff(fact_5341_reflp__refl__eq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( reflp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3))
    <=> refl_on(B,top_top(set(B)),R3) ) ).

% reflp_refl_eq
tff(fact_5342_Heap_Orel__reflp,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o))] :
      ( reflp(B,R)
     => reflp(heap_Time_Heap(B),aa(fun(B,fun(B,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(B,B),R)) ) ).

% Heap.rel_reflp
tff(fact_5343_reflp__inf,axiom,
    ! [B: $tType,R3: fun(B,fun(B,$o)),S: fun(B,fun(B,$o))] :
      ( reflp(B,R3)
     => ( reflp(B,S)
       => reflp(B,aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),inf_inf(fun(B,fun(B,$o))),R3),S)) ) ) ).

% reflp_inf
tff(fact_5344_inf__pred__def,axiom,
    ! [B: $tType,Pa: pred(B),Qa: pred(B)] : ( aa(pred(B),pred(B),aa(pred(B),fun(pred(B),pred(B)),inf_inf(pred(B)),Pa),Qa) = aa(fun(B,$o),pred(B),pred2(B),aa(fun(B,$o),fun(B,$o),aa(fun(B,$o),fun(fun(B,$o),fun(B,$o)),inf_inf(fun(B,$o)),aa(pred(B),fun(B,$o),eval(B),Pa)),aa(pred(B),fun(B,$o),eval(B),Qa))) ) ).

% inf_pred_def
tff(fact_5345_fun__of__rel__def,axiom,
    ! [B: $tType,C: $tType,R: set(product_prod(C,B)),X: C] : ( fun_of_rel(C,B,R,X) = fChoice(B,aa(C,fun(B,$o),aTP_Lamp_ll(set(product_prod(C,B)),fun(C,fun(B,$o)),R),X)) ) ).

% fun_of_rel_def
tff(fact_5346_le__prod__encode__1,axiom,
    ! [A3: nat,Ba: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A3),nat_prod_encode(aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),Ba))) ).

% le_prod_encode_1
tff(fact_5347_Eps__case__prod__eq,axiom,
    ! [B: $tType,C: $tType,X: B,Y: C] : ( fChoice(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(C,fun(B,fun(C,$o)),aTP_Lamp_jt(B,fun(C,fun(B,fun(C,$o))),X),Y))) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X),Y) ) ).

% Eps_case_prod_eq
tff(fact_5348_some__insert__self,axiom,
    ! [B: $tType,S2: set(B)] :
      ( ( S2 != bot_bot(set(B)) )
     => ( aa(set(B),set(B),insert2(B,fChoice(B,aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),S2))),S2) = S2 ) ) ).

% some_insert_self
tff(fact_5349_some__elem,axiom,
    ! [B: $tType,S2: set(B)] :
      ( ( S2 != bot_bot(set(B)) )
     => member(B,fChoice(B,aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),S2)),S2) ) ).

% some_elem
tff(fact_5350_some__in__eq,axiom,
    ! [B: $tType,A4: set(B)] :
      ( member(B,fChoice(B,aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),A4)),A4)
    <=> ( A4 != bot_bot(set(B)) ) ) ).

% some_in_eq
tff(fact_5351_split__paired__Eps,axiom,
    ! [C: $tType,B: $tType,Pa: fun(product_prod(B,C),$o)] : ( fChoice(product_prod(B,C),Pa) = fChoice(product_prod(B,C),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aTP_Lamp_vd(fun(product_prod(B,C),$o),fun(B,fun(C,$o)),Pa))) ) ).

% split_paired_Eps
tff(fact_5352_pred__of__set__def,axiom,
    ! [B: $tType] : ( pred_of_set(B) = aa(fun(set(B),fun(B,$o)),fun(set(B),pred(B)),aa(fun(fun(B,$o),pred(B)),fun(fun(set(B),fun(B,$o)),fun(set(B),pred(B))),comp(fun(B,$o),pred(B),set(B)),pred2(B)),aTP_Lamp_a(set(B),fun(B,$o))) ) ).

% pred_of_set_def
tff(fact_5353_bot__pred__def,axiom,
    ! [B: $tType] : ( bot_bot(pred(B)) = aa(fun(B,$o),pred(B),pred2(B),bot_bot(fun(B,$o))) ) ).

% bot_pred_def
tff(fact_5354_le__prod__encode__2,axiom,
    ! [Ba: nat,A3: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Ba),nat_prod_encode(aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),A3),Ba))) ).

% le_prod_encode_2
tff(fact_5355_list__encode_Oelims,axiom,
    ! [X: list(nat),Y: nat] :
      ( ( nat_list_encode(X) = Y )
     => ( ( ( X = nil(nat) )
         => ( Y != zero_zero(nat) ) )
       => ~ ! [X2: nat,Xs3: list(nat)] :
              ( ( X = aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),X2),Xs3) )
             => ( Y != aa(nat,nat,suc,nat_prod_encode(aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),nat_list_encode(Xs3)))) ) ) ) ) ).

% list_encode.elims
tff(fact_5356_list__encode_Osimps_I2_J,axiom,
    ! [X: nat,Xs: list(nat)] : ( nat_list_encode(aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),X),Xs)) = aa(nat,nat,suc,nat_prod_encode(aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X),nat_list_encode(Xs)))) ) ).

% list_encode.simps(2)
tff(fact_5357_prod__list_Ocomm__monoid__list__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => groups1828464146339083142d_list(B,times_times(B),one_one(B)) ) ).

% prod_list.comm_monoid_list_axioms
tff(fact_5358_list__encode_Opelims,axiom,
    ! [X: list(nat),Y: nat] :
      ( ( nat_list_encode(X) = Y )
     => ( aa(list(nat),$o,accp(list(nat),nat_list_encode_rel),X)
       => ( ( ( X = nil(nat) )
           => ( ( Y = zero_zero(nat) )
             => ~ aa(list(nat),$o,accp(list(nat),nat_list_encode_rel),nil(nat)) ) )
         => ~ ! [X2: nat,Xs3: list(nat)] :
                ( ( X = aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),X2),Xs3) )
               => ( ( Y = aa(nat,nat,suc,nat_prod_encode(aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X2),nat_list_encode(Xs3)))) )
                 => ~ aa(list(nat),$o,accp(list(nat),nat_list_encode_rel),aa(list(nat),list(nat),aa(nat,fun(list(nat),list(nat)),cons(nat),X2),Xs3)) ) ) ) ) ) ).

% list_encode.pelims
tff(fact_5359_map__option__o__case__sum,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Fa: fun(E,D),Ga: fun(B,option(E)),H2: fun(C,option(E))] : ( aa(fun(sum_sum(B,C),option(E)),fun(sum_sum(B,C),option(D)),aa(fun(option(E),option(D)),fun(fun(sum_sum(B,C),option(E)),fun(sum_sum(B,C),option(D))),comp(option(E),option(D),sum_sum(B,C)),map_option(E,D,Fa)),sum_case_sum(B,option(E),C,Ga,H2)) = sum_case_sum(B,option(D),C,aa(fun(B,option(E)),fun(B,option(D)),aa(fun(option(E),option(D)),fun(fun(B,option(E)),fun(B,option(D))),comp(option(E),option(D),B),map_option(E,D,Fa)),Ga),aa(fun(C,option(E)),fun(C,option(D)),aa(fun(option(E),option(D)),fun(fun(C,option(E)),fun(C,option(D))),comp(option(E),option(D),C),map_option(E,D,Fa)),H2)) ) ).

% map_option_o_case_sum
tff(fact_5360_Pair__transfer,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,A4: fun(B,fun(C,$o)),B2: fun(D,fun(E,$o))] : aa(fun(C,fun(E,product_prod(C,E))),$o,aa(fun(B,fun(D,product_prod(B,D))),fun(fun(C,fun(E,product_prod(C,E))),$o),bNF_rel_fun(B,C,fun(D,product_prod(B,D)),fun(E,product_prod(C,E)),A4,bNF_rel_fun(D,E,product_prod(B,D),product_prod(C,E),B2,basic_rel_prod(B,C,D,E,A4,B2))),product_Pair(B,D)),product_Pair(C,E)) ).

% Pair_transfer
tff(fact_5361_rel__prod__inject,axiom,
    ! [C: $tType,B: $tType,D: $tType,E: $tType,R12: fun(B,fun(C,$o)),R23: fun(D,fun(E,$o)),A3: B,Ba: D,C2: C,D2: E] :
      ( aa(product_prod(C,E),$o,aa(product_prod(B,D),fun(product_prod(C,E),$o),basic_rel_prod(B,C,D,E,R12,R23),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),A3),Ba)),aa(E,product_prod(C,E),aa(C,fun(E,product_prod(C,E)),product_Pair(C,E),C2),D2))
    <=> ( aa(C,$o,aa(B,fun(C,$o),R12,A3),C2)
        & aa(E,$o,aa(D,fun(E,$o),R23,Ba),D2) ) ) ).

% rel_prod_inject
tff(fact_5362_o__case__sum,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,H2: fun(E,D),Fa: fun(B,E),Ga: fun(C,E)] : ( aa(fun(sum_sum(B,C),E),fun(sum_sum(B,C),D),aa(fun(E,D),fun(fun(sum_sum(B,C),E),fun(sum_sum(B,C),D)),comp(E,D,sum_sum(B,C)),H2),sum_case_sum(B,E,C,Fa,Ga)) = sum_case_sum(B,D,C,aa(fun(B,E),fun(B,D),aa(fun(E,D),fun(fun(B,E),fun(B,D)),comp(E,D,B),H2),Fa),aa(fun(C,E),fun(C,D),aa(fun(E,D),fun(fun(C,E),fun(C,D)),comp(E,D,C),H2),Ga)) ) ).

% o_case_sum
tff(fact_5363_rel__prod_Ocases,axiom,
    ! [C: $tType,B: $tType,D: $tType,E: $tType,R12: fun(B,fun(C,$o)),R23: fun(D,fun(E,$o)),A1: product_prod(B,D),A22: product_prod(C,E)] :
      ( aa(product_prod(C,E),$o,aa(product_prod(B,D),fun(product_prod(C,E),$o),basic_rel_prod(B,C,D,E,R12,R23),A1),A22)
     => ~ ! [A8: B,B4: C,C4: D] :
            ( ( A1 = aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),A8),C4) )
           => ! [D3: E] :
                ( ( A22 = aa(E,product_prod(C,E),aa(C,fun(E,product_prod(C,E)),product_Pair(C,E),B4),D3) )
               => ( aa(C,$o,aa(B,fun(C,$o),R12,A8),B4)
                 => ~ aa(E,$o,aa(D,fun(E,$o),R23,C4),D3) ) ) ) ) ).

% rel_prod.cases
tff(fact_5364_rel__prod_Osimps,axiom,
    ! [C: $tType,B: $tType,D: $tType,E: $tType,R12: fun(B,fun(C,$o)),R23: fun(D,fun(E,$o)),A1: product_prod(B,D),A22: product_prod(C,E)] :
      ( aa(product_prod(C,E),$o,aa(product_prod(B,D),fun(product_prod(C,E),$o),basic_rel_prod(B,C,D,E,R12,R23),A1),A22)
    <=> ? [A6: B,B5: C,C5: D,D5: E] :
          ( ( A1 = aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),A6),C5) )
          & ( A22 = aa(E,product_prod(C,E),aa(C,fun(E,product_prod(C,E)),product_Pair(C,E),B5),D5) )
          & aa(C,$o,aa(B,fun(C,$o),R12,A6),B5)
          & aa(E,$o,aa(D,fun(E,$o),R23,C5),D5) ) ) ).

% rel_prod.simps
tff(fact_5365_rel__prod_Ointros,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,R12: fun(B,fun(C,$o)),A3: B,Ba: C,R23: fun(D,fun(E,$o)),C2: D,D2: E] :
      ( aa(C,$o,aa(B,fun(C,$o),R12,A3),Ba)
     => ( aa(E,$o,aa(D,fun(E,$o),R23,C2),D2)
       => aa(product_prod(C,E),$o,aa(product_prod(B,D),fun(product_prod(C,E),$o),basic_rel_prod(B,C,D,E,R12,R23),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),A3),C2)),aa(E,product_prod(C,E),aa(C,fun(E,product_prod(C,E)),product_Pair(C,E),Ba),D2)) ) ) ).

% rel_prod.intros
tff(fact_5366_Heap_Orec__transfer,axiom,
    ! [B: $tType,C: $tType,E: $tType,D: $tType,R: fun(B,fun(D,$o)),S2: fun(C,fun(E,$o))] : aa(fun(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),E),fun(heap_Time_Heap(D),E)),$o,aa(fun(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(B),C)),fun(fun(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),E),fun(heap_Time_Heap(D),E)),$o),bNF_rel_fun(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),E),fun(heap_Time_Heap(B),C),fun(heap_Time_Heap(D),E),bNF_rel_fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C,E,bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(D,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(D,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(B,D,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),S2),bNF_rel_fun(heap_Time_Heap(B),heap_Time_Heap(D),C,E,aa(fun(B,fun(D,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(D),$o)),heap_Time_rel_Heap(B,D),R),S2)),heap_Time_rec_Heap(B,C)),heap_Time_rec_Heap(D,E)) ).

% Heap.rec_transfer
tff(fact_5367_ordering__top_Oaxioms_I2_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ordering_top_axioms(B,Less_eq,Top) ) ).

% ordering_top.axioms(2)
tff(fact_5368_heap__step__admissible,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType,F7: $tType,Pa: fun(F7,fun(B,fun(D,fun(C,fun(E,$o))))),X: F7] : comple1908693960933563346ssible(fun(B,option(product_prod(C,product_prod(D,E)))),partial_fun_lub(option(product_prod(C,product_prod(D,E))),option(product_prod(C,product_prod(D,E))),B,partial_flat_lub(option(product_prod(C,product_prod(D,E))),none(product_prod(C,product_prod(D,E))))),partial_fun_ord(option(product_prod(C,product_prod(D,E))),option(product_prod(C,product_prod(D,E))),B,partial_flat_ord(option(product_prod(C,product_prod(D,E))),none(product_prod(C,product_prod(D,E))))),aa(F7,fun(fun(B,option(product_prod(C,product_prod(D,E)))),$o),aTP_Lamp_ve(fun(F7,fun(B,fun(D,fun(C,fun(E,$o))))),fun(F7,fun(fun(B,option(product_prod(C,product_prod(D,E)))),$o)),Pa),X)) ).

% heap_step_admissible
tff(fact_5369_rel__option__iff,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),X: option(B),Y: option(C)] :
      ( aa(option(C),$o,aa(option(B),fun(option(C),$o),rel_option(B,C,R),X),Y)
    <=> aa(product_prod(option(B),option(C)),$o,aa(fun(option(B),fun(option(C),$o)),fun(product_prod(option(B),option(C)),$o),product_case_prod(option(B),option(C),$o),aTP_Lamp_vh(fun(B,fun(C,$o)),fun(option(B),fun(option(C),$o)),R)),aa(option(C),product_prod(option(B),option(C)),aa(option(B),fun(option(C),product_prod(option(B),option(C))),product_Pair(option(B),option(C)),X),Y)) ) ).

% rel_option_iff
tff(fact_5370_ordering__top__axioms_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Top: B] :
      ( ! [A8: B] : aa(B,$o,aa(B,fun(B,$o),Less_eq,A8),Top)
     => ordering_top_axioms(B,Less_eq,Top) ) ).

% ordering_top_axioms.intro
tff(fact_5371_ordering__top__axioms__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Top: B] :
      ( ordering_top_axioms(B,Less_eq,Top)
    <=> ! [A6: B] : aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),Top) ) ).

% ordering_top_axioms_def
tff(fact_5372_rel__option__inf,axiom,
    ! [C: $tType,B: $tType,A4: fun(B,fun(C,$o)),B2: fun(B,fun(C,$o))] : ( aa(fun(option(B),fun(option(C),$o)),fun(option(B),fun(option(C),$o)),aa(fun(option(B),fun(option(C),$o)),fun(fun(option(B),fun(option(C),$o)),fun(option(B),fun(option(C),$o))),inf_inf(fun(option(B),fun(option(C),$o))),rel_option(B,C,A4)),rel_option(B,C,B2)) = rel_option(B,C,aa(fun(B,fun(C,$o)),fun(B,fun(C,$o)),aa(fun(B,fun(C,$o)),fun(fun(B,fun(C,$o)),fun(B,fun(C,$o))),inf_inf(fun(B,fun(C,$o))),A4),B2)) ) ).

% rel_option_inf
tff(fact_5373_Heap_Orel__cases,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),A3: heap_Time_Heap(B),Ba: heap_Time_Heap(C)] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R),A3),Ba)
     => ~ ! [Xa4: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] :
            ( ( A3 = aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),Xa4) )
           => ! [Ya3: fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))))] :
                ( ( Ba = aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(C),heap_Time_Heap2(C),Ya3) )
               => ~ aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),$o,aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),$o),bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(C,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(B,C,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),Xa4),Ya3) ) ) ) ).

% Heap.rel_cases
tff(fact_5374_Heap_Orel__induct,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),X: heap_Time_Heap(B),Y: heap_Time_Heap(C),Qa: fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o))] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R),X),Y)
     => ( ! [A8: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),B4: fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))))] :
            ( aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),$o,aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),$o),bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(C,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(B,C,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),A8),B4)
           => aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),Qa,aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),A8)),aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(C),heap_Time_Heap2(C),B4)) )
       => aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),Qa,X),Y) ) ) ).

% Heap.rel_induct
tff(fact_5375_Heap_Orel__inject,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),X: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Y: fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))))] :
      ( aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),X)),aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(C),heap_Time_Heap2(C),Y))
    <=> aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),$o,aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),$o),bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(C,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(B,C,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),X),Y) ) ).

% Heap.rel_inject
tff(fact_5376_Heap_Orel__intros,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o)),X: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Y: fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))))] :
      ( aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),$o,aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),$o),bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(C,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(B,C,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),X),Y)
     => aa(heap_Time_Heap(C),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),X)),aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(C),heap_Time_Heap2(C),Y)) ) ).

% Heap.rel_intros
tff(fact_5377_Heap_Octr__transfer,axiom,
    ! [B: $tType,C: $tType,R: fun(B,fun(C,$o))] : aa(fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(C)),$o,aa(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B)),fun(fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(C)),$o),bNF_rel_fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap(C),bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(C,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(B,C,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R)),heap_Time_Heap2(B)),heap_Time_Heap2(C)) ).

% Heap.ctr_transfer
tff(fact_5378_ccpo_OadmissibleD,axiom,
    ! [B: $tType,Lub: fun(set(B),B),Ord: fun(B,fun(B,$o)),Pa: fun(B,$o),A4: set(B)] :
      ( comple1908693960933563346ssible(B,Lub,Ord,Pa)
     => ( comple1602240252501008431_chain(B,Ord,A4)
       => ( ( A4 != bot_bot(set(B)) )
         => ( ! [X2: B] :
                ( member(B,X2,A4)
               => aa(B,$o,Pa,X2) )
           => aa(B,$o,Pa,aa(set(B),B,Lub,A4)) ) ) ) ) ).

% ccpo.admissibleD
tff(fact_5379_ccpo_OadmissibleI,axiom,
    ! [B: $tType,Ord: fun(B,fun(B,$o)),Pa: fun(B,$o),Lub: fun(set(B),B)] :
      ( ! [A12: set(B)] :
          ( comple1602240252501008431_chain(B,Ord,A12)
         => ( ( A12 != bot_bot(set(B)) )
           => ( ! [X3: B] :
                  ( member(B,X3,A12)
                 => aa(B,$o,Pa,X3) )
             => aa(B,$o,Pa,aa(set(B),B,Lub,A12)) ) ) )
     => comple1908693960933563346ssible(B,Lub,Ord,Pa) ) ).

% ccpo.admissibleI
tff(fact_5380_ccpo_Oadmissible__def,axiom,
    ! [B: $tType,Lub: fun(set(B),B),Ord: fun(B,fun(B,$o)),Pa: fun(B,$o)] :
      ( comple1908693960933563346ssible(B,Lub,Ord,Pa)
    <=> ! [A11: set(B)] :
          ( comple1602240252501008431_chain(B,Ord,A11)
         => ( ( A11 != bot_bot(set(B)) )
           => ( ! [X4: B] :
                  ( member(B,X4,A11)
                 => aa(B,$o,Pa,X4) )
             => aa(B,$o,Pa,aa(set(B),B,Lub,A11)) ) ) ) ) ).

% ccpo.admissible_def
tff(fact_5381_Heap_Ocase__transfer,axiom,
    ! [B: $tType,C: $tType,E: $tType,D: $tType,R: fun(B,fun(D,$o)),S2: fun(C,fun(E,$o))] : aa(fun(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),E),fun(heap_Time_Heap(D),E)),$o,aa(fun(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(B),C)),fun(fun(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),E),fun(heap_Time_Heap(D),E)),$o),bNF_rel_fun(fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),E),fun(heap_Time_Heap(B),C),fun(heap_Time_Heap(D),E),bNF_rel_fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C,E,bNF_rel_fun(heap_ext(product_unit),heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(D,product_prod(heap_ext(product_unit),nat))),fequal(heap_ext(product_unit)),rel_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(D,product_prod(heap_ext(product_unit),nat)),basic_rel_prod(B,D,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),R,fequal(product_prod(heap_ext(product_unit),nat))))),S2),bNF_rel_fun(heap_Time_Heap(B),heap_Time_Heap(D),C,E,aa(fun(B,fun(D,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(D),$o)),heap_Time_rel_Heap(B,D),R),S2)),heap_Time_case_Heap(B,C)),heap_Time_case_Heap(D,E)) ).

% Heap.case_transfer
tff(fact_5382_ordering__top__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B] :
      ( ordering_top(B,Less_eq,Less,Top)
    <=> ( ordering(B,Less_eq,Less)
        & ordering_top_axioms(B,Less_eq,Top) ) ) ).

% ordering_top_def
tff(fact_5383_ordering__top_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B] :
      ( ordering(B,Less_eq,Less)
     => ( ordering_top_axioms(B,Less_eq,Top)
       => ordering_top(B,Less_eq,Less,Top) ) ) ).

% ordering_top.intro
tff(fact_5384_Heap_Ocase__distrib,axiom,
    ! [C: $tType,B: $tType,D: $tType,H2: fun(C,B),Fa: fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),Heap: heap_Time_Heap(D)] : ( aa(C,B,H2,aa(heap_Time_Heap(D),C,aa(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),fun(heap_Time_Heap(D),C),heap_Time_case_Heap(D,C),Fa),Heap)) = aa(heap_Time_Heap(D),B,aa(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),B),fun(heap_Time_Heap(D),B),heap_Time_case_Heap(D,B),aa(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),B),aTP_Lamp_vi(fun(C,B),fun(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),B)),H2),Fa)),Heap) ) ).

% Heap.case_distrib
tff(fact_5385_ordering__dualI,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ordering(B,aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Less_eq),aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Less))
     => ordering(B,Less_eq,Less) ) ).

% ordering_dualI
tff(fact_5386_ordering__strictI,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ! [A8: B,B4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A8),B4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),Less,A8),B4)
            | ( A8 = B4 ) ) )
     => ( ! [A8: B,B4: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less,A8),B4)
           => ~ aa(B,$o,aa(B,fun(B,$o),Less,B4),A8) )
       => ( ! [A8: B] : ~ aa(B,$o,aa(B,fun(B,$o),Less,A8),A8)
         => ( ! [A8: B,B4: B,C4: B] :
                ( aa(B,$o,aa(B,fun(B,$o),Less,A8),B4)
               => ( aa(B,$o,aa(B,fun(B,$o),Less,B4),C4)
                 => aa(B,$o,aa(B,fun(B,$o),Less,A8),C4) ) )
           => ordering(B,Less_eq,Less) ) ) ) ) ).

% ordering_strictI
tff(fact_5387_ordering_Onot__eq__order__implies__strict,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( ordering(B,Less_eq,Less)
     => ( ( A3 != Ba )
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
         => aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba) ) ) ) ).

% ordering.not_eq_order_implies_strict
tff(fact_5388_ordering_Ostrict__implies__not__eq,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( ordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
       => ( A3 != Ba ) ) ) ).

% ordering.strict_implies_not_eq
tff(fact_5389_ordering_Ostrict__iff__order,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( ordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
      <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
          & ( A3 != Ba ) ) ) ) ).

% ordering.strict_iff_order
tff(fact_5390_ordering_Oorder__iff__strict,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( ordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
      <=> ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
          | ( A3 = Ba ) ) ) ) ).

% ordering.order_iff_strict
tff(fact_5391_ordering_Oantisym,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( ordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Ba),A3)
         => ( A3 = Ba ) ) ) ) ).

% ordering.antisym
tff(fact_5392_ordering_Oeq__iff,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( ordering(B,Less_eq,Less)
     => ( ( A3 = Ba )
      <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
          & aa(B,$o,aa(B,fun(B,$o),Less_eq,Ba),A3) ) ) ) ).

% ordering.eq_iff
tff(fact_5393_ordering__top_Oaxioms_I1_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),Top: B] :
      ( ordering_top(B,Less_eq,Less,Top)
     => ordering(B,Less_eq,Less) ) ).

% ordering_top.axioms(1)
tff(fact_5394_order_Oordering__axioms,axiom,
    ! [B: $tType] :
      ( order(B)
     => ordering(B,ord_less_eq(B),ord_less(B)) ) ).

% order.ordering_axioms
tff(fact_5395_Heap_Ocase,axiom,
    ! [B: $tType,C: $tType,Fa: fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),B),X: fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))))] : ( aa(heap_Time_Heap(C),B,aa(fun(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),B),fun(heap_Time_Heap(C),B),heap_Time_case_Heap(C,B),Fa),aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(C),heap_Time_Heap2(C),X)) = aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),B,Fa,X) ) ).

% Heap.case
tff(fact_5396_dual__order_Oordering__axioms,axiom,
    ! [B: $tType] :
      ( order(B)
     => ordering(B,aTP_Lamp_vj(B,fun(B,$o)),aTP_Lamp_vk(B,fun(B,$o))) ) ).

% dual_order.ordering_axioms
tff(fact_5397_admissible__image,axiom,
    ! [B: $tType,C: $tType,Le: fun(B,fun(B,$o)),Lub: fun(set(B),B),Pa: fun(C,$o),Ga: fun(B,C),Fa: fun(C,B)] :
      ( partia7178651479351089652itions(B,Le,Lub)
     => ( comple1908693960933563346ssible(B,Lub,Le,aa(fun(B,C),fun(B,$o),aa(fun(C,$o),fun(fun(B,C),fun(B,$o)),comp(C,$o,B),Pa),Ga))
       => ( ! [X2: C,Y2: C] :
              ( ( aa(C,B,Fa,X2) = aa(C,B,Fa,Y2) )
             => ( X2 = Y2 ) )
         => ( ! [X2: B] : ( aa(C,B,Fa,aa(B,C,Ga,X2)) = X2 )
           => comple1908693960933563346ssible(C,partial_img_lub(C,B,B,C,Fa,Ga,Lub),partial_img_ord(C,B,$o,Fa,Le),Pa) ) ) ) ) ).

% admissible_image
tff(fact_5398_list__all__zip_Opelims_I1_J,axiom,
    ! [B: $tType,C: $tType,X: fun(B,fun(C,$o)),Xa: list(B),Xb: list(C),Y: $o] :
      ( ( list_all_zip(B,C,X,Xa,Xb)
      <=> (Y) )
     => ( aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xa),Xb)))
       => ( ( ( Xa = nil(B) )
           => ( ( Xb = nil(C) )
             => ( (Y)
               => ~ aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),nil(C)))) ) ) )
         => ( ! [A8: B,As2: list(B)] :
                ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2) )
               => ! [B4: C,Bs2: list(C)] :
                    ( ( Xb = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),B4),Bs2) )
                   => ( ( (Y)
                      <=> ( aa(C,$o,aa(B,fun(C,$o),X,A8),B4)
                          & list_all_zip(B,C,X,As2,Bs2) ) )
                     => ~ aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),B4),Bs2)))) ) ) )
           => ( ! [V3: B,Va: list(B)] :
                  ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va) )
                 => ( ( Xb = nil(C) )
                   => ( ~ (Y)
                     => ~ aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va)),nil(C)))) ) ) )
             => ~ ( ( Xa = nil(B) )
                 => ! [V3: C,Va: list(C)] :
                      ( ( Xb = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),V3),Va) )
                     => ( ~ (Y)
                       => ~ aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),V3),Va)))) ) ) ) ) ) ) ) ) ).

% list_all_zip.pelims(1)
tff(fact_5399_list__all__zip_Opelims_I2_J,axiom,
    ! [B: $tType,C: $tType,X: fun(B,fun(C,$o)),Xa: list(B),Xb: list(C)] :
      ( list_all_zip(B,C,X,Xa,Xb)
     => ( aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xa),Xb)))
       => ( ( ( Xa = nil(B) )
           => ( ( Xb = nil(C) )
             => ~ aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),nil(C)))) ) )
         => ~ ! [A8: B,As2: list(B)] :
                ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2) )
               => ! [B4: C,Bs2: list(C)] :
                    ( ( Xb = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),B4),Bs2) )
                   => ( aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),B4),Bs2))))
                     => ~ ( aa(C,$o,aa(B,fun(C,$o),X,A8),B4)
                          & list_all_zip(B,C,X,As2,Bs2) ) ) ) ) ) ) ) ).

% list_all_zip.pelims(2)
tff(fact_5400_list__all__zip_Opelims_I3_J,axiom,
    ! [B: $tType,C: $tType,X: fun(B,fun(C,$o)),Xa: list(B),Xb: list(C)] :
      ( ~ list_all_zip(B,C,X,Xa,Xb)
     => ( aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),Xa),Xb)))
       => ( ! [A8: B,As2: list(B)] :
              ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2) )
             => ! [B4: C,Bs2: list(C)] :
                  ( ( Xb = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),B4),Bs2) )
                 => ( aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A8),As2)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),B4),Bs2))))
                   => ( aa(C,$o,aa(B,fun(C,$o),X,A8),B4)
                      & list_all_zip(B,C,X,As2,Bs2) ) ) ) )
         => ( ! [V3: B,Va: list(B)] :
                ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va) )
               => ( ( Xb = nil(C) )
                 => ~ aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),V3),Va)),nil(C)))) ) )
           => ~ ( ( Xa = nil(B) )
               => ! [V3: C,Va: list(C)] :
                    ( ( Xb = aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),V3),Va) )
                   => ~ aa(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),$o,accp(product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),list_all_zip_rel(B,C)),aa(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C))),aa(fun(B,fun(C,$o)),fun(product_prod(list(B),list(C)),product_prod(fun(B,fun(C,$o)),product_prod(list(B),list(C)))),product_Pair(fun(B,fun(C,$o)),product_prod(list(B),list(C))),X),aa(list(C),product_prod(list(B),list(C)),aa(list(B),fun(list(C),product_prod(list(B),list(C))),product_Pair(list(B),list(C)),nil(B)),aa(list(C),list(C),aa(C,fun(list(C),list(C)),cons(C),V3),Va)))) ) ) ) ) ) ) ).

% list_all_zip.pelims(3)
tff(fact_5401_partial__function__definitions_Ofixp__induct__uc,axiom,
    ! [C: $tType,B: $tType,D: $tType,Leq: fun(B,fun(B,$o)),Lub: fun(set(B),B),U2: fun(D,fun(C,B)),F: fun(D,D),C3: fun(fun(C,B),D),Fa: D,Pa: fun(fun(C,B),$o)] :
      ( partia7178651479351089652itions(B,Leq,Lub)
     => ( ! [X2: C] : comple7038119648293358887notone(fun(C,B),B,partial_fun_ord(B,B,C,Leq),Leq,aa(C,fun(fun(C,B),B),aa(fun(fun(C,B),D),fun(C,fun(fun(C,B),B)),aa(fun(D,D),fun(fun(fun(C,B),D),fun(C,fun(fun(C,B),B))),aTP_Lamp_vl(fun(D,fun(C,B)),fun(fun(D,D),fun(fun(fun(C,B),D),fun(C,fun(fun(C,B),B)))),U2),F),C3),X2))
       => ( ( Fa = aa(fun(C,B),D,C3,comple187402453842119260l_fixp(fun(C,B),partial_fun_lub(B,B,C,Lub),partial_fun_ord(B,B,C,Leq),aa(fun(fun(C,B),D),fun(fun(C,B),fun(C,B)),aa(fun(D,D),fun(fun(fun(C,B),D),fun(fun(C,B),fun(C,B))),aTP_Lamp_vm(fun(D,fun(C,B)),fun(fun(D,D),fun(fun(fun(C,B),D),fun(fun(C,B),fun(C,B)))),U2),F),C3))) )
         => ( ! [F8: fun(C,B)] : ( aa(D,fun(C,B),U2,aa(fun(C,B),D,C3,F8)) = F8 )
           => ( comple1908693960933563346ssible(fun(C,B),partial_fun_lub(B,B,C,Lub),partial_fun_ord(B,B,C,Leq),Pa)
             => ( aa(fun(C,B),$o,Pa,aTP_Lamp_vn(fun(set(B),B),fun(C,B),Lub))
               => ( ! [F8: D] :
                      ( aa(fun(C,B),$o,Pa,aa(D,fun(C,B),U2,F8))
                     => aa(fun(C,B),$o,Pa,aa(D,fun(C,B),U2,aa(D,D,F,F8))) )
                 => aa(fun(C,B),$o,Pa,aa(D,fun(C,B),U2,Fa)) ) ) ) ) ) ) ) ).

% partial_function_definitions.fixp_induct_uc
tff(fact_5402_rat_Odomain__par,axiom,
    ! [DR1: fun(int,$o),DR2: fun(int,$o),P24: fun(product_prod(int,int),$o)] :
      ( ( domainp(int,int,fequal(int)) = DR1 )
     => ( ( domainp(int,int,fequal(int)) = DR2 )
       => ( aa(fun(product_prod(int,int),$o),$o,aa(fun(product_prod(int,int),$o),fun(fun(product_prod(int,int),$o),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),$o,$o,basic_rel_prod(int,int,int,int,fequal(int),fequal(int)),fequal($o)),P24),aTP_Lamp_vo(product_prod(int,int),$o))
         => ( domainp(product_prod(int,int),rat,pcr_rat) = aa(fun(product_prod(int,int),$o),fun(product_prod(int,int),$o),aa(fun(product_prod(int,int),$o),fun(fun(product_prod(int,int),$o),fun(product_prod(int,int),$o)),inf_inf(fun(product_prod(int,int),$o)),basic_pred_prod(int,int,DR1,DR2)),P24) ) ) ) ) ).

% rat.domain_par
tff(fact_5403_Predicate_Oiterate__upto_Opelims,axiom,
    ! [B: $tType,X: fun(code_natural,B),Xa: code_natural,Xb: code_natural,Y: pred(B)] :
      ( ( iterate_upto(B,X,Xa,Xb) = Y )
     => ( aa(product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),$o,accp(product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),iterate_upto_rel(B)),aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),aa(fun(code_natural,B),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,B),product_prod(code_natural,code_natural)),X),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),Xa),Xb)))
       => ~ ( ( Y = seq2(B,aa(code_natural,fun(product_unit,seq(B)),aa(code_natural,fun(code_natural,fun(product_unit,seq(B))),aTP_Lamp_vp(fun(code_natural,B),fun(code_natural,fun(code_natural,fun(product_unit,seq(B)))),X),Xa),Xb)) )
           => ~ aa(product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),$o,accp(product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),iterate_upto_rel(B)),aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),aa(fun(code_natural,B),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,B),product_prod(code_natural,code_natural)),X),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),Xa),Xb))) ) ) ) ).

% Predicate.iterate_upto.pelims
tff(fact_5404_pred__prod__inject,axiom,
    ! [B: $tType,C: $tType,P12: fun(B,$o),P23: fun(C,$o),A3: B,Ba: C] :
      ( aa(product_prod(B,C),$o,basic_pred_prod(B,C,P12,P23),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba))
    <=> ( aa(B,$o,P12,A3)
        & aa(C,$o,P23,Ba) ) ) ).

% pred_prod_inject
tff(fact_5405_Predicate_Osingle__code,axiom,
    ! [B: $tType,X: B] : ( aa(B,pred(B),single(B),X) = seq2(B,aTP_Lamp_vq(B,fun(product_unit,seq(B)),X)) ) ).

% Predicate.single_code
tff(fact_5406_bot__set__code,axiom,
    ! [B: $tType] : ( bot_bot(pred(B)) = seq2(B,aTP_Lamp_vr(product_unit,seq(B))) ) ).

% bot_set_code
tff(fact_5407_pred__prod_Ocases,axiom,
    ! [B: $tType,C: $tType,P12: fun(B,$o),P23: fun(C,$o),A3: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,basic_pred_prod(B,C,P12,P23),A3)
     => ~ ! [A8: B,B4: C] :
            ( ( A3 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4) )
           => ( aa(B,$o,P12,A8)
             => ~ aa(C,$o,P23,B4) ) ) ) ).

% pred_prod.cases
tff(fact_5408_pred__prod_Osimps,axiom,
    ! [B: $tType,C: $tType,P12: fun(B,$o),P23: fun(C,$o),A3: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,basic_pred_prod(B,C,P12,P23),A3)
    <=> ? [A6: B,B5: C] :
          ( ( A3 = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A6),B5) )
          & aa(B,$o,P12,A6)
          & aa(C,$o,P23,B5) ) ) ).

% pred_prod.simps
tff(fact_5409_pred__prod_Ointros,axiom,
    ! [B: $tType,C: $tType,P12: fun(B,$o),A3: B,P23: fun(C,$o),Ba: C] :
      ( aa(B,$o,P12,A3)
     => ( aa(C,$o,P23,Ba)
       => aa(product_prod(B,C),$o,basic_pred_prod(B,C,P12,P23),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba)) ) ) ).

% pred_prod.intros
tff(fact_5410_pred__prod__split,axiom,
    ! [B: $tType,C: $tType,Pa: fun($o,$o),Qa: fun(B,$o),R: fun(C,$o),Xy: product_prod(B,C)] :
      ( aa($o,$o,Pa,aa(product_prod(B,C),$o,basic_pred_prod(B,C,Qa,R),Xy))
    <=> ! [X4: B,Y3: C] :
          ( ( Xy = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Y3) )
         => aa($o,$o,Pa,
              aa(B,$o,Qa,X4)
            & aa(C,$o,R,Y3)) ) ) ).

% pred_prod_split
tff(fact_5411_prod_Opred__map,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,Q1a: fun(B,$o),Q2a: fun(C,$o),F1: fun(D,B),F22: fun(E,C),X: product_prod(D,E)] :
      ( aa(product_prod(B,C),$o,basic_pred_prod(B,C,Q1a,Q2a),aa(product_prod(D,E),product_prod(B,C),product_map_prod(D,B,E,C,F1,F22),X))
    <=> aa(product_prod(D,E),$o,basic_pred_prod(D,E,aa(fun(D,B),fun(D,$o),aa(fun(B,$o),fun(fun(D,B),fun(D,$o)),comp(B,$o,D),Q1a),F1),aa(fun(E,C),fun(E,$o),aa(fun(C,$o),fun(fun(E,C),fun(E,$o)),comp(C,$o,E),Q2a),F22)),X) ) ).

% prod.pred_map
tff(fact_5412_Predicate_Oiterate__upto_Opsimps,axiom,
    ! [B: $tType,Fa: fun(code_natural,B),N: code_natural,M4: code_natural] :
      ( aa(product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),$o,accp(product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),iterate_upto_rel(B)),aa(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural)),aa(fun(code_natural,B),fun(product_prod(code_natural,code_natural),product_prod(fun(code_natural,B),product_prod(code_natural,code_natural))),product_Pair(fun(code_natural,B),product_prod(code_natural,code_natural)),Fa),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),N),M4)))
     => ( iterate_upto(B,Fa,N,M4) = seq2(B,aa(code_natural,fun(product_unit,seq(B)),aa(code_natural,fun(code_natural,fun(product_unit,seq(B))),aTP_Lamp_vp(fun(code_natural,B),fun(code_natural,fun(code_natural,fun(product_unit,seq(B)))),Fa),N),M4)) ) ) ).

% Predicate.iterate_upto.psimps
tff(fact_5413_Random__Pred_Oiterate__upto__def,axiom,
    ! [B: $tType,Fa: fun(code_natural,B),N: code_natural,M4: code_natural] : ( random_iterate_upto(B,Fa,N,M4) = aa(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),product_Pair(pred(B),product_prod(code_natural,code_natural)),iterate_upto(B,Fa,N,M4)) ) ).

% Random_Pred.iterate_upto_def
tff(fact_5414_fixp__induct,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [Pa: fun(B,$o),Fa: fun(B,B)] :
          ( comple1908693960933563346ssible(B,complete_Sup_Sup(B),ord_less_eq(B),Pa)
         => ( comple7038119648293358887notone(B,B,ord_less_eq(B),ord_less_eq(B),Fa)
           => ( aa(B,$o,Pa,aa(set(B),B,complete_Sup_Sup(B),bot_bot(set(B))))
             => ( ! [X2: B] :
                    ( aa(B,$o,Pa,X2)
                   => aa(B,$o,Pa,aa(B,B,Fa,X2)) )
               => aa(B,$o,Pa,comple115746919287870866o_fixp(B,Fa)) ) ) ) ) ) ).

% fixp_induct
tff(fact_5415_heap_Ofixp__induct__uc,axiom,
    ! [B: $tType,C: $tType,D: $tType,U2: fun(D,fun(B,heap_Time_Heap(C))),F: fun(D,D),C3: fun(fun(B,heap_Time_Heap(C)),D),Fa: D,Pa: fun(fun(B,heap_Time_Heap(C)),$o)] :
      ( ! [X2: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)))),aTP_Lamp_vs(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))))),U2),F),C3),X2))
     => ( ( Fa = aa(fun(B,heap_Time_Heap(C)),D,C3,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)))),aTP_Lamp_vt(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))))),U2),F),C3))) )
       => ( ! [F8: fun(B,heap_Time_Heap(C))] : ( aa(D,fun(B,heap_Time_Heap(C)),U2,aa(fun(B,heap_Time_Heap(C)),D,C3,F8)) = F8 )
         => ( comple1908693960933563346ssible(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),Pa)
           => ( aa(fun(B,heap_Time_Heap(C)),$o,Pa,aTP_Lamp_vv(B,heap_Time_Heap(C)))
             => ( ! [F8: D] :
                    ( aa(fun(B,heap_Time_Heap(C)),$o,Pa,aa(D,fun(B,heap_Time_Heap(C)),U2,F8))
                   => aa(fun(B,heap_Time_Heap(C)),$o,Pa,aa(D,fun(B,heap_Time_Heap(C)),U2,aa(D,D,F,F8))) )
               => aa(fun(B,heap_Time_Heap(C)),$o,Pa,aa(D,fun(B,heap_Time_Heap(C)),U2,Fa)) ) ) ) ) ) ) ).

% heap.fixp_induct_uc
tff(fact_5416_heap_Oconst__mono,axiom,
    ! [B: $tType,C: $tType,Ord: fun(B,fun(B,$o)),C2: heap_Time_Heap(C)] : comple7038119648293358887notone(B,heap_Time_Heap(C),Ord,heap_Time_Heap_ord(C),aTP_Lamp_vw(heap_Time_Heap(C),fun(B,heap_Time_Heap(C)),C2)) ).

% heap.const_mono
tff(fact_5417_heap_Oleq__refl,axiom,
    ! [B: $tType,X: heap_Time_Heap(B)] : aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),X),X) ).

% heap.leq_refl
tff(fact_5418_heap_Oleq__trans,axiom,
    ! [B: $tType,X: heap_Time_Heap(B),Y: heap_Time_Heap(B),Z2: heap_Time_Heap(B)] :
      ( aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),X),Y)
     => ( aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),Y),Z2)
       => aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),X),Z2) ) ) ).

% heap.leq_trans
tff(fact_5419_heap_Oleq__antisym,axiom,
    ! [B: $tType,X: heap_Time_Heap(B),Y: heap_Time_Heap(B)] :
      ( aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),X),Y)
     => ( aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),Y),X)
       => ( X = Y ) ) ) ).

% heap.leq_antisym
tff(fact_5420_heap_Olub__least,axiom,
    ! [B: $tType,A4: set(heap_Time_Heap(B)),Z2: heap_Time_Heap(B)] :
      ( comple1602240252501008431_chain(heap_Time_Heap(B),heap_Time_Heap_ord(B),A4)
     => ( ! [X2: heap_Time_Heap(B)] :
            ( member(heap_Time_Heap(B),X2,A4)
           => aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),X2),Z2) )
       => aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),aa(set(heap_Time_Heap(B)),heap_Time_Heap(B),heap_Time_Heap_lub(B),A4)),Z2) ) ) ).

% heap.lub_least
tff(fact_5421_heap_Olub__upper,axiom,
    ! [B: $tType,A4: set(heap_Time_Heap(B)),X: heap_Time_Heap(B)] :
      ( comple1602240252501008431_chain(heap_Time_Heap(B),heap_Time_Heap_ord(B),A4)
     => ( member(heap_Time_Heap(B),X,A4)
       => aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),X),aa(set(heap_Time_Heap(B)),heap_Time_Heap(B),heap_Time_Heap_lub(B),A4)) ) ) ).

% heap.lub_upper
tff(fact_5422_heap__interpretation,axiom,
    ! [B: $tType] : partia7178651479351089652itions(heap_Time_Heap(B),heap_Time_Heap_ord(B),heap_Time_Heap_lub(B)) ).

% heap_interpretation
tff(fact_5423_heap_Omono__body__fixp,axiom,
    ! [C: $tType,B: $tType,F: fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)))] :
      ( ! [X2: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aTP_Lamp_vx(fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),F),X2))
     => ( comple187402453842119260l_fixp(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),F) = aa(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)),F,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),F)) ) ) ).

% heap.mono_body_fixp
tff(fact_5424_heap_Ofixp__rule__uc,axiom,
    ! [B: $tType,C: $tType,D: $tType,U2: fun(D,fun(B,heap_Time_Heap(C))),F: fun(D,D),C3: fun(fun(B,heap_Time_Heap(C)),D),Fa: D] :
      ( ! [X2: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)))),aTP_Lamp_vs(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))))),U2),F),C3),X2))
     => ( ( Fa = aa(fun(B,heap_Time_Heap(C)),D,C3,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)))),aTP_Lamp_vt(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))))),U2),F),C3))) )
       => ( ! [F8: D] : ( aa(fun(B,heap_Time_Heap(C)),D,C3,aa(D,fun(B,heap_Time_Heap(C)),U2,F8)) = F8 )
         => ( Fa = aa(D,D,F,Fa) ) ) ) ) ).

% heap.fixp_rule_uc
tff(fact_5425_Heap__Time__Monad_Obind__mono,axiom,
    ! [E: $tType,C: $tType,B: $tType,D: $tType,B2: fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D)),C3: fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E)))] :
      ( comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(D),B2)
     => ( ! [Y2: D] : comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(E),aa(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E)),C3,Y2))
       => comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(E),aa(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E)),aTP_Lamp_vz(fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D)),fun(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),B2),C3)) ) ) ).

% Heap_Time_Monad.bind_mono
tff(fact_5426_Heap__ord__def,axiom,
    ! [B: $tType] : ( heap_Time_Heap_ord(B) = partial_img_ord(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),$o,heap_Time_execute(B),partial_fun_ord(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit),partial_flat_ord(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),none(product_prod(B,product_prod(heap_ext(product_unit),nat)))))) ) ).

% Heap_ord_def
tff(fact_5427_Heap__ordE,axiom,
    ! [B: $tType,X: heap_Time_Heap(B),Y: heap_Time_Heap(B),H2: heap_ext(product_unit)] :
      ( aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),X),Y)
     => ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),X),H2) != none(product_prod(B,product_prod(heap_ext(product_unit),nat))) )
       => ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),X),H2) = aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Y),H2) ) ) ) ).

% Heap_ordE
tff(fact_5428_Heap__ordI,axiom,
    ! [B: $tType,X: heap_Time_Heap(B),Y: heap_Time_Heap(B)] :
      ( ! [H: heap_ext(product_unit)] :
          ( ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),X),H) = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) )
          | ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),X),H) = aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),Y),H) ) )
     => aa(heap_Time_Heap(B),$o,aa(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o),heap_Time_Heap_ord(B),X),Y) ) ).

% Heap_ordI
tff(fact_5429_fixp__induct__heap,axiom,
    ! [D: $tType,C: $tType,B: $tType,U2: fun(D,fun(B,heap_Time_Heap(C))),F: fun(D,D),C3: fun(fun(B,heap_Time_Heap(C)),D),Fa: D,Pa: fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))))),X: B,H2: heap_ext(product_unit),H4: heap_ext(product_unit),R3: C,N: nat] :
      ( ! [X2: B] : comple7038119648293358887notone(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),heap_Time_Heap_ord(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)))),aTP_Lamp_vs(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))))),U2),F),C3),X2))
     => ( ( Fa = aa(fun(B,heap_Time_Heap(C)),D,C3,comple187402453842119260l_fixp(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)))),aTP_Lamp_vt(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))))),U2),F),C3))) )
       => ( ! [F8: fun(B,heap_Time_Heap(C))] : ( aa(D,fun(B,heap_Time_Heap(C)),U2,aa(fun(B,heap_Time_Heap(C)),D,C3,F8)) = F8 )
         => ( ! [F8: D,X2: B,H: heap_ext(product_unit),H5: heap_ext(product_unit),R2: C,N3: nat] :
                ( ! [Xa3: B,Ha: heap_ext(product_unit),H_a: heap_ext(product_unit),Ra3: C,Na: nat] :
                    ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),aa(D,fun(B,heap_Time_Heap(C)),U2,F8),Xa3),Ha,H_a,Ra3,Na)
                   => aa(nat,$o,aa(C,fun(nat,$o),aa(heap_ext(product_unit),fun(C,fun(nat,$o)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o)))),Pa,Xa3),Ha),H_a),Ra3),Na) )
               => ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),aa(D,fun(B,heap_Time_Heap(C)),U2,aa(D,D,F,F8)),X2),H,H5,R2,N3)
                 => aa(nat,$o,aa(C,fun(nat,$o),aa(heap_ext(product_unit),fun(C,fun(nat,$o)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o)))),Pa,X2),H),H5),R2),N3) ) )
           => ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),aa(D,fun(B,heap_Time_Heap(C)),U2,Fa),X),H2,H4,R3,N)
             => aa(nat,$o,aa(C,fun(nat,$o),aa(heap_ext(product_unit),fun(C,fun(nat,$o)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o)))),Pa,X),H2),H4),R3),N) ) ) ) ) ) ).

% fixp_induct_heap
tff(fact_5430_admissible__heap,axiom,
    ! [C: $tType,B: $tType,Pa: fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o)))))] : comple1908693960933563346ssible(fun(B,heap_Time_Heap(C)),partial_fun_lub(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_lub(C)),partial_fun_ord(heap_Time_Heap(C),heap_Time_Heap(C),B,heap_Time_Heap_ord(C)),aTP_Lamp_wa(fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))))),fun(fun(B,heap_Time_Heap(C)),$o),Pa)) ).

% admissible_heap
tff(fact_5431_Heap_Opred__inject,axiom,
    ! [B: $tType,Pa: fun(B,$o),A3: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] :
      ( aa(heap_Time_Heap(B),$o,aa(fun(B,$o),fun(heap_Time_Heap(B),$o),heap_Time_pred_Heap(B),Pa),aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(B),heap_Time_Heap2(B),A3))
    <=> aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),$o,basic_pred_fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_wb(heap_ext(product_unit),$o),pred_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),basic_pred_prod(B,product_prod(heap_ext(product_unit),nat),Pa,top_top(fun(product_prod(heap_ext(product_unit),nat),$o))))),A3) ) ).

% Heap.pred_inject
tff(fact_5432_of__seq__code_I1_J,axiom,
    ! [B: $tType] : ( aa(seq(B),set(B),set_of_seq(B),empty(B)) = bot_bot(set(B)) ) ).

% of_seq_code(1)
tff(fact_5433_pred__of__seq_Osimps_I1_J,axiom,
    ! [B: $tType] : ( aa(seq(B),pred(B),pred_of_seq(B),empty(B)) = bot_bot(pred(B)) ) ).

% pred_of_seq.simps(1)
tff(fact_5434_top1I,axiom,
    ! [B: $tType,X: B] : aa(B,$o,top_top(fun(B,$o)),X) ).

% top1I
tff(fact_5435_option_Opred__map,axiom,
    ! [B: $tType,C: $tType,Qa: fun(B,$o),Fa: fun(C,B),X: option(C)] :
      ( aa(option(B),$o,pred_option(B,Qa),aa(option(C),option(B),map_option(C,B,Fa),X))
    <=> aa(option(C),$o,pred_option(C,aa(fun(C,B),fun(C,$o),aa(fun(B,$o),fun(fun(C,B),fun(C,$o)),comp(B,$o,C),Qa),Fa)),X) ) ).

% option.pred_map
tff(fact_5436_of__pred__code,axiom,
    ! [B: $tType,Fa: fun(product_unit,seq(B))] : ( aa(pred(B),set(B),set_of_pred(B),seq2(B,Fa)) = case_seq(set(B),B,bot_bot(set(B)),aTP_Lamp_wc(B,fun(pred(B),set(B))),aTP_Lamp_wd(pred(B),fun(seq(B),set(B))),aa(product_unit,seq(B),Fa,product_Unity)) ) ).

% of_pred_code
tff(fact_5437_set__of__seq__def,axiom,
    ! [B: $tType] : ( set_of_seq(B) = aa(fun(seq(B),pred(B)),fun(seq(B),set(B)),aa(fun(pred(B),set(B)),fun(fun(seq(B),pred(B)),fun(seq(B),set(B))),comp(pred(B),set(B),seq(B)),set_of_pred(B)),pred_of_seq(B)) ) ).

% set_of_seq_def
tff(fact_5438_nths__empty,axiom,
    ! [B: $tType,Xs: list(B)] : ( nths(B,Xs,bot_bot(set(nat))) = nil(B) ) ).

% nths_empty
tff(fact_5439_set__of__pred__def,axiom,
    ! [B: $tType] : ( set_of_pred(B) = aa(fun(pred(B),fun(B,$o)),fun(pred(B),set(B)),aa(fun(fun(B,$o),set(B)),fun(fun(pred(B),fun(B,$o)),fun(pred(B),set(B))),comp(fun(B,$o),set(B),pred(B)),collect(B)),eval(B)) ) ).

% set_of_pred_def
tff(fact_5440_ordering_Oaxioms_I2_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ordering(B,Less_eq,Less)
     => ordering_axioms(B,Less_eq,Less) ) ).

% ordering.axioms(2)
tff(fact_5441_abstract__boolean__algebra_Ointro,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( abel_semigroup(B,Conj)
     => ( abel_semigroup(B,Disj)
       => ( boolea6902313364301356556axioms(B,Conj,Disj,Compl,Zero,One)
         => boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One) ) ) ) ).

% abstract_boolean_algebra.intro
tff(fact_5442_abstract__boolean__algebra__def,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
    <=> ( abel_semigroup(B,Conj)
        & abel_semigroup(B,Disj)
        & boolea6902313364301356556axioms(B,Conj,Disj,Compl,Zero,One) ) ) ).

% abstract_boolean_algebra_def
tff(fact_5443_sup_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => abel_semigroup(B,sup_sup(B)) ) ).

% sup.abel_semigroup_axioms
tff(fact_5444_max_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => abel_semigroup(B,ord_max(B)) ) ).

% max.abel_semigroup_axioms
tff(fact_5445_ordering__axioms__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ordering_axioms(B,Less_eq,Less)
    <=> ( ! [A6: B,B5: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less,A6),B5)
          <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),B5)
              & ( A6 != B5 ) ) )
        & ! [A6: B,B5: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),B5)
           => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B5),A6)
             => ( A6 = B5 ) ) ) ) ) ).

% ordering_axioms_def
tff(fact_5446_ordering__axioms_Ointro,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o)),Less_eq: fun(B,fun(B,$o))] :
      ( ! [A8: B,B4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less,A8),B4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A8),B4)
            & ( A8 != B4 ) ) )
     => ( ! [A8: B,B4: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A8),B4)
           => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B4),A8)
             => ( A8 = B4 ) ) )
       => ordering_axioms(B,Less_eq,Less) ) ) ).

% ordering_axioms.intro
tff(fact_5447_abel__semigroup_Oleft__commute,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Ba: B,A3: B,C2: B] :
      ( abel_semigroup(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,Ba),aa(B,B,aa(B,fun(B,B),Fa,A3),C2)) = aa(B,B,aa(B,fun(B,B),Fa,A3),aa(B,B,aa(B,fun(B,B),Fa,Ba),C2)) ) ) ).

% abel_semigroup.left_commute
tff(fact_5448_abel__semigroup_Ocommute,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A3: B,Ba: B] :
      ( abel_semigroup(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = aa(B,B,aa(B,fun(B,B),Fa,Ba),A3) ) ) ).

% abel_semigroup.commute
tff(fact_5449_min_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => abel_semigroup(B,ord_min(B)) ) ).

% min.abel_semigroup_axioms
tff(fact_5450_abstract__boolean__algebra_Oaxioms_I2_J,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => abel_semigroup(B,Disj) ) ).

% abstract_boolean_algebra.axioms(2)
tff(fact_5451_abstract__boolean__algebra_Oaxioms_I1_J,axiom,
    ! [B: $tType,Conj: fun(B,fun(B,B)),Disj: fun(B,fun(B,B)),Compl: fun(B,B),Zero: B,One: B] :
      ( boolea2506097494486148201lgebra(B,Conj,Disj,Compl,Zero,One)
     => abel_semigroup(B,Conj) ) ).

% abstract_boolean_algebra.axioms(1)
tff(fact_5452_abel__semigroup_Oaxioms_I1_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( abel_semigroup(B,Fa)
     => semigroup(B,Fa) ) ).

% abel_semigroup.axioms(1)
tff(fact_5453_mult_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => abel_semigroup(B,times_times(B)) ) ).

% mult.abel_semigroup_axioms
tff(fact_5454_add_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => abel_semigroup(B,plus_plus(B)) ) ).

% add.abel_semigroup_axioms
tff(fact_5455_comm__monoid_Oaxioms_I1_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid(B,Fa,Z2)
     => abel_semigroup(B,Fa) ) ).

% comm_monoid.axioms(1)
tff(fact_5456_inf_Oabel__semigroup__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => abel_semigroup(B,inf_inf(B)) ) ).

% inf.abel_semigroup_axioms
tff(fact_5457_abel__semigroup_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( semigroup(B,Fa)
     => ( abel_s757365448890700780axioms(B,Fa)
       => abel_semigroup(B,Fa) ) ) ).

% abel_semigroup.intro
tff(fact_5458_abel__semigroup__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( abel_semigroup(B,Fa)
    <=> ( semigroup(B,Fa)
        & abel_s757365448890700780axioms(B,Fa) ) ) ).

% abel_semigroup_def
tff(fact_5459_comm__monoid_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( abel_semigroup(B,Fa)
     => ( comm_monoid_axioms(B,Fa,Z2)
       => comm_monoid(B,Fa,Z2) ) ) ).

% comm_monoid.intro
tff(fact_5460_comm__monoid__axioms_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( ! [A8: B] : ( aa(B,B,aa(B,fun(B,B),Fa,A8),Z2) = A8 )
     => comm_monoid_axioms(B,Fa,Z2) ) ).

% comm_monoid_axioms.intro
tff(fact_5461_abel__semigroup__axioms_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( ! [A8: B,B4: B] : ( aa(B,B,aa(B,fun(B,B),Fa,A8),B4) = aa(B,B,aa(B,fun(B,B),Fa,B4),A8) )
     => abel_s757365448890700780axioms(B,Fa) ) ).

% abel_semigroup_axioms.intro
tff(fact_5462_comm__monoid__axioms__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid_axioms(B,Fa,Z2)
    <=> ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),Fa,A6),Z2) = A6 ) ) ).

% comm_monoid_axioms_def
tff(fact_5463_abel__semigroup__axioms__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( abel_s757365448890700780axioms(B,Fa)
    <=> ! [A6: B,B5: B] : ( aa(B,B,aa(B,fun(B,B),Fa,A6),B5) = aa(B,B,aa(B,fun(B,B),Fa,B5),A6) ) ) ).

% abel_semigroup_axioms_def
tff(fact_5464_abel__semigroup_Oaxioms_I2_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( abel_semigroup(B,Fa)
     => abel_s757365448890700780axioms(B,Fa) ) ).

% abel_semigroup.axioms(2)
tff(fact_5465_comm__monoid_Oaxioms_I2_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid(B,Fa,Z2)
     => comm_monoid_axioms(B,Fa,Z2) ) ).

% comm_monoid.axioms(2)
tff(fact_5466_comm__monoid__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( comm_monoid(B,Fa,Z2)
    <=> ( abel_semigroup(B,Fa)
        & comm_monoid_axioms(B,Fa,Z2) ) ) ).

% comm_monoid_def
tff(fact_5467_ordering__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ordering(B,Less_eq,Less)
    <=> ( partial_preordering(B,Less_eq)
        & ordering_axioms(B,Less_eq,Less) ) ) ).

% ordering_def
tff(fact_5468_ordering_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( partial_preordering(B,Less_eq)
     => ( ordering_axioms(B,Less_eq,Less)
       => ordering(B,Less_eq,Less) ) ) ).

% ordering.intro
tff(fact_5469_prod__list_Omonoid__list__axioms,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => groups_monoid_list(B,times_times(B),one_one(B)) ) ).

% prod_list.monoid_list_axioms
tff(fact_5470_order_Opartial__preordering__axioms,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => partial_preordering(B,ord_less_eq(B)) ) ).

% order.partial_preordering_axioms
tff(fact_5471_partial__preordering__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o))] :
      ( partial_preordering(B,Less_eq)
    <=> ( ! [A6: B] : aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),A6)
        & ! [A6: B,B5: B,C5: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),B5)
           => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B5),C5)
             => aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),C5) ) ) ) ) ).

% partial_preordering_def
tff(fact_5472_partial__preordering_Otrans,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),A3: B,Ba: B,C2: B] :
      ( partial_preordering(B,Less_eq)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Ba),C2)
         => aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),C2) ) ) ) ).

% partial_preordering.trans
tff(fact_5473_partial__preordering_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o))] :
      ( ! [A8: B] : aa(B,$o,aa(B,fun(B,$o),Less_eq,A8),A8)
     => ( ! [A8: B,B4: B,C4: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A8),B4)
           => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,B4),C4)
             => aa(B,$o,aa(B,fun(B,$o),Less_eq,A8),C4) ) )
       => partial_preordering(B,Less_eq) ) ) ).

% partial_preordering.intro
tff(fact_5474_partial__preordering_Orefl,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),A3: B] :
      ( partial_preordering(B,Less_eq)
     => aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),A3) ) ).

% partial_preordering.refl
tff(fact_5475_monoid__list_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( monoid(B,Fa,Z2)
     => groups_monoid_list(B,Fa,Z2) ) ).

% monoid_list.intro
tff(fact_5476_monoid__list_Oaxioms,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( groups_monoid_list(B,Fa,Z2)
     => monoid(B,Fa,Z2) ) ).

% monoid_list.axioms
tff(fact_5477_monoid__list__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( groups_monoid_list(B,Fa,Z2)
    <=> monoid(B,Fa,Z2) ) ).

% monoid_list_def
tff(fact_5478_ordering_Oaxioms_I1_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ordering(B,Less_eq,Less)
     => partial_preordering(B,Less_eq) ) ).

% ordering.axioms(1)
tff(fact_5479_dual__order_Opartial__preordering__axioms,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => partial_preordering(B,aTP_Lamp_we(B,fun(B,$o))) ) ).

% dual_order.partial_preordering_axioms
tff(fact_5480_semilattice__neutr_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( semilattice(B,Fa)
     => ( comm_monoid(B,Fa,Z2)
       => semilattice_neutr(B,Fa,Z2) ) ) ).

% semilattice_neutr.intro
tff(fact_5481_semilattice__neutr__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( semilattice_neutr(B,Fa,Z2)
    <=> ( semilattice(B,Fa)
        & comm_monoid(B,Fa,Z2) ) ) ).

% semilattice_neutr_def
tff(fact_5482_case__sum__o__map__sum__id,axiom,
    ! [B: $tType,C: $tType,D: $tType,Ga: fun(C,B),Fa: fun(D,B),X: sum_sum(D,C)] : ( aa(sum_sum(D,C),B,aa(fun(sum_sum(D,C),sum_sum(B,C)),fun(sum_sum(D,C),B),aa(fun(sum_sum(B,C),B),fun(fun(sum_sum(D,C),sum_sum(B,C)),fun(sum_sum(D,C),B)),comp(sum_sum(B,C),B,sum_sum(D,C)),sum_case_sum(B,B,C,id(B),Ga)),sum_map_sum(D,B,C,C,Fa,id(C))),X) = aa(sum_sum(D,C),B,sum_case_sum(D,B,C,aa(fun(D,D),fun(D,B),aa(fun(D,B),fun(fun(D,D),fun(D,B)),comp(D,B,D),Fa),id(D)),Ga),X) ) ).

% case_sum_o_map_sum_id
tff(fact_5483_map__sum_Ocomp,axiom,
    ! [B: $tType,F7: $tType,D: $tType,E: $tType,G: $tType,C: $tType,Fa: fun(F7,D),Ga: fun(G,E),H2: fun(B,F7),I: fun(C,G)] : ( aa(fun(sum_sum(B,C),sum_sum(F7,G)),fun(sum_sum(B,C),sum_sum(D,E)),aa(fun(sum_sum(F7,G),sum_sum(D,E)),fun(fun(sum_sum(B,C),sum_sum(F7,G)),fun(sum_sum(B,C),sum_sum(D,E))),comp(sum_sum(F7,G),sum_sum(D,E),sum_sum(B,C)),sum_map_sum(F7,D,G,E,Fa,Ga)),sum_map_sum(B,F7,C,G,H2,I)) = sum_map_sum(B,D,C,E,aa(fun(B,F7),fun(B,D),aa(fun(F7,D),fun(fun(B,F7),fun(B,D)),comp(F7,D,B),Fa),H2),aa(fun(C,G),fun(C,E),aa(fun(G,E),fun(fun(C,G),fun(C,E)),comp(G,E,C),Ga),I)) ) ).

% map_sum.comp
tff(fact_5484_map__sum_Ocompositionality,axiom,
    ! [E: $tType,C: $tType,B: $tType,D: $tType,G: $tType,F7: $tType,Fa: fun(D,B),Ga: fun(E,C),H2: fun(F7,D),I: fun(G,E),Sum: sum_sum(F7,G)] : ( aa(sum_sum(D,E),sum_sum(B,C),sum_map_sum(D,B,E,C,Fa,Ga),aa(sum_sum(F7,G),sum_sum(D,E),sum_map_sum(F7,D,G,E,H2,I),Sum)) = aa(sum_sum(F7,G),sum_sum(B,C),sum_map_sum(F7,B,G,C,aa(fun(F7,D),fun(F7,B),aa(fun(D,B),fun(fun(F7,D),fun(F7,B)),comp(D,B,F7),Fa),H2),aa(fun(G,E),fun(G,C),aa(fun(E,C),fun(fun(G,E),fun(G,C)),comp(E,C,G),Ga),I)),Sum) ) ).

% map_sum.compositionality
tff(fact_5485_sum_Omap__comp,axiom,
    ! [E: $tType,C: $tType,B: $tType,D: $tType,G: $tType,F7: $tType,G1: fun(D,B),G22: fun(E,C),F1: fun(F7,D),F22: fun(G,E),V: sum_sum(F7,G)] : ( aa(sum_sum(D,E),sum_sum(B,C),sum_map_sum(D,B,E,C,G1,G22),aa(sum_sum(F7,G),sum_sum(D,E),sum_map_sum(F7,D,G,E,F1,F22),V)) = aa(sum_sum(F7,G),sum_sum(B,C),sum_map_sum(F7,B,G,C,aa(fun(F7,D),fun(F7,B),aa(fun(D,B),fun(fun(F7,D),fun(F7,B)),comp(D,B,F7),G1),F1),aa(fun(G,E),fun(G,C),aa(fun(E,C),fun(fun(G,E),fun(G,C)),comp(E,C,G),G22),F22)),V) ) ).

% sum.map_comp
tff(fact_5486_semilattice_Oaxioms_I1_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( semilattice(B,Fa)
     => abel_semigroup(B,Fa) ) ).

% semilattice.axioms(1)
tff(fact_5487_inf_Osemilattice__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => semilattice(B,inf_inf(B)) ) ).

% inf.semilattice_axioms
tff(fact_5488_semilattice__order_Oaxioms_I1_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => semilattice(B,Fa) ) ).

% semilattice_order.axioms(1)
tff(fact_5489_max_Osemilattice__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semilattice(B,ord_max(B)) ) ).

% max.semilattice_axioms
tff(fact_5490_semilattice_Oidem,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A3: B] :
      ( semilattice(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,A3),A3) = A3 ) ) ).

% semilattice.idem
tff(fact_5491_semilattice_Oleft__idem,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A3: B,Ba: B] :
      ( semilattice(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,A3),aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)) = aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) ) ) ).

% semilattice.left_idem
tff(fact_5492_semilattice_Oright__idem,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A3: B,Ba: B] :
      ( semilattice(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),Ba) = aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) ) ) ).

% semilattice.right_idem
tff(fact_5493_min_Osemilattice__axioms,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => semilattice(B,ord_min(B)) ) ).

% min.semilattice_axioms
tff(fact_5494_semilattice__neutr_Oaxioms_I1_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( semilattice_neutr(B,Fa,Z2)
     => semilattice(B,Fa) ) ).

% semilattice_neutr.axioms(1)
tff(fact_5495_sup_Osemilattice__axioms,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => semilattice(B,sup_sup(B)) ) ).

% sup.semilattice_axioms
tff(fact_5496_case__sum__o__map__sum,axiom,
    ! [B: $tType,E: $tType,D: $tType,F7: $tType,C: $tType,Fa: fun(E,D),Ga: fun(F7,D),H12: fun(B,E),H23: fun(C,F7)] : ( aa(fun(sum_sum(B,C),sum_sum(E,F7)),fun(sum_sum(B,C),D),aa(fun(sum_sum(E,F7),D),fun(fun(sum_sum(B,C),sum_sum(E,F7)),fun(sum_sum(B,C),D)),comp(sum_sum(E,F7),D,sum_sum(B,C)),sum_case_sum(E,D,F7,Fa,Ga)),sum_map_sum(B,E,C,F7,H12,H23)) = sum_case_sum(B,D,C,aa(fun(B,E),fun(B,D),aa(fun(E,D),fun(fun(B,E),fun(B,D)),comp(E,D,B),Fa),H12),aa(fun(C,F7),fun(C,D),aa(fun(F7,D),fun(fun(C,F7),fun(C,D)),comp(F7,D,C),Ga),H23)) ) ).

% case_sum_o_map_sum
tff(fact_5497_case__sum__map__sum,axiom,
    ! [D: $tType,B: $tType,C: $tType,F7: $tType,E: $tType,L: fun(C,B),R3: fun(D,B),Fa: fun(E,C),Ga: fun(F7,D),X: sum_sum(E,F7)] : ( aa(sum_sum(C,D),B,sum_case_sum(C,B,D,L,R3),aa(sum_sum(E,F7),sum_sum(C,D),sum_map_sum(E,C,F7,D,Fa,Ga),X)) = aa(sum_sum(E,F7),B,sum_case_sum(E,B,F7,aa(fun(E,C),fun(E,B),aa(fun(C,B),fun(fun(E,C),fun(E,B)),comp(C,B,E),L),Fa),aa(fun(F7,D),fun(F7,B),aa(fun(D,B),fun(fun(F7,D),fun(F7,B)),comp(D,B,F7),R3),Ga)),X) ) ).

% case_sum_map_sum
tff(fact_5498_sum_Osize__gen__o__map,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Fa: fun(D,nat),Faa: fun(E,nat),Ga: fun(B,D),Gaa: fun(C,E)] : ( aa(fun(sum_sum(B,C),sum_sum(D,E)),fun(sum_sum(B,C),nat),aa(fun(sum_sum(D,E),nat),fun(fun(sum_sum(B,C),sum_sum(D,E)),fun(sum_sum(B,C),nat)),comp(sum_sum(D,E),nat,sum_sum(B,C)),basic_BNF_size_sum(D,E,Fa,Faa)),sum_map_sum(B,D,C,E,Ga,Gaa)) = basic_BNF_size_sum(B,C,aa(fun(B,D),fun(B,nat),aa(fun(D,nat),fun(fun(B,D),fun(B,nat)),comp(D,nat,B),Fa),Ga),aa(fun(C,E),fun(C,nat),aa(fun(E,nat),fun(fun(C,E),fun(C,nat)),comp(E,nat,C),Faa),Gaa)) ) ).

% sum.size_gen_o_map
tff(fact_5499_semilattice__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( semilattice(B,Fa)
    <=> ( abel_semigroup(B,Fa)
        & semilattice_axioms(B,Fa) ) ) ).

% semilattice_def
tff(fact_5500_semilattice_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( abel_semigroup(B,Fa)
     => ( semilattice_axioms(B,Fa)
       => semilattice(B,Fa) ) ) ).

% semilattice.intro
tff(fact_5501_semilattice__axioms__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( semilattice_axioms(B,Fa)
    <=> ! [A6: B] : ( aa(B,B,aa(B,fun(B,B),Fa,A6),A6) = A6 ) ) ).

% semilattice_axioms_def
tff(fact_5502_semilattice__axioms_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( ! [A8: B] : ( aa(B,B,aa(B,fun(B,B),Fa,A8),A8) = A8 )
     => semilattice_axioms(B,Fa) ) ).

% semilattice_axioms.intro
tff(fact_5503_semilattice_Oaxioms_I2_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( semilattice(B,Fa)
     => semilattice_axioms(B,Fa) ) ).

% semilattice.axioms(2)
tff(fact_5504_semilattice__order_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semilattice(B,Fa)
     => ( semila6385135966242565138axioms(B,Fa,Less_eq,Less)
       => semilattice_order(B,Fa,Less_eq,Less) ) ) ).

% semilattice_order.intro
tff(fact_5505_semilattice__order__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semilattice_order(B,Fa,Less_eq,Less)
    <=> ( semilattice(B,Fa)
        & semila6385135966242565138axioms(B,Fa,Less_eq,Less) ) ) ).

% semilattice_order_def
tff(fact_5506_map__sum__o__inj_I1_J,axiom,
    ! [E: $tType,D: $tType,C: $tType,B: $tType,Fa: fun(B,C),Ga: fun(E,D)] : ( aa(fun(B,sum_sum(B,E)),fun(B,sum_sum(C,D)),aa(fun(sum_sum(B,E),sum_sum(C,D)),fun(fun(B,sum_sum(B,E)),fun(B,sum_sum(C,D))),comp(sum_sum(B,E),sum_sum(C,D),B),sum_map_sum(B,C,E,D,Fa,Ga)),sum_Inl(B,E)) = aa(fun(B,C),fun(B,sum_sum(C,D)),aa(fun(C,sum_sum(C,D)),fun(fun(B,C),fun(B,sum_sum(C,D))),comp(C,sum_sum(C,D),B),sum_Inl(C,D)),Fa) ) ).

% map_sum_o_inj(1)
tff(fact_5507_semilattice__order__axioms_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Fa: fun(B,fun(B,B)),Less: fun(B,fun(B,$o))] :
      ( ! [A8: B,B4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A8),B4)
        <=> ( A8 = aa(B,B,aa(B,fun(B,B),Fa,A8),B4) ) )
     => ( ! [A8: B,B4: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less,A8),B4)
          <=> ( ( A8 = aa(B,B,aa(B,fun(B,B),Fa,A8),B4) )
              & ( A8 != B4 ) ) )
       => semila6385135966242565138axioms(B,Fa,Less_eq,Less) ) ) ).

% semilattice_order_axioms.intro
tff(fact_5508_semilattice__order__axioms__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semila6385135966242565138axioms(B,Fa,Less_eq,Less)
    <=> ( ! [A6: B,B5: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),B5)
          <=> ( A6 = aa(B,B,aa(B,fun(B,B),Fa,A6),B5) ) )
        & ! [A6: B,B5: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less,A6),B5)
          <=> ( ( A6 = aa(B,B,aa(B,fun(B,B),Fa,A6),B5) )
              & ( A6 != B5 ) ) ) ) ) ).

% semilattice_order_axioms_def
tff(fact_5509_case__sum__o__inj_I1_J,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(B,C),Ga: fun(D,C)] : ( aa(fun(B,sum_sum(B,D)),fun(B,C),aa(fun(sum_sum(B,D),C),fun(fun(B,sum_sum(B,D)),fun(B,C)),comp(sum_sum(B,D),C,B),sum_case_sum(B,C,D,Fa,Ga)),sum_Inl(B,D)) = Fa ) ).

% case_sum_o_inj(1)
tff(fact_5510_semilattice__order_Oaxioms_I2_J,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( semilattice_order(B,Fa,Less_eq,Less)
     => semila6385135966242565138axioms(B,Fa,Less_eq,Less) ) ).

% semilattice_order.axioms(2)
tff(fact_5511_prod_OPlus,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_mult(D)
     => ! [A4: set(B),B2: set(C),Ga: fun(sum_sum(B,C),D)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(C),$o,finite_finite(C),B2)
           => ( aa(set(sum_sum(B,C)),D,aa(fun(sum_sum(B,C),D),fun(set(sum_sum(B,C)),D),groups7121269368397514597t_prod(sum_sum(B,C),D),Ga),sum_Plus(B,C,A4,B2)) = aa(D,D,aa(D,fun(D,D),times_times(D),aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7121269368397514597t_prod(B,D),aa(fun(B,sum_sum(B,C)),fun(B,D),aa(fun(sum_sum(B,C),D),fun(fun(B,sum_sum(B,C)),fun(B,D)),comp(sum_sum(B,C),D,B),Ga),sum_Inl(B,C))),A4)),aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),aa(fun(C,sum_sum(B,C)),fun(C,D),aa(fun(sum_sum(B,C),D),fun(fun(C,sum_sum(B,C)),fun(C,D)),comp(sum_sum(B,C),D,C),Ga),sum_Inr(C,B))),B2)) ) ) ) ) ).

% prod.Plus
tff(fact_5512_sum_OPlus,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( comm_monoid_add(D)
     => ! [A4: set(B),B2: set(C),Ga: fun(sum_sum(B,C),D)] :
          ( aa(set(B),$o,finite_finite(B),A4)
         => ( aa(set(C),$o,finite_finite(C),B2)
           => ( aa(set(sum_sum(B,C)),D,aa(fun(sum_sum(B,C),D),fun(set(sum_sum(B,C)),D),groups7311177749621191930dd_sum(sum_sum(B,C),D),Ga),sum_Plus(B,C,A4,B2)) = aa(D,D,aa(D,fun(D,D),plus_plus(D),aa(set(B),D,aa(fun(B,D),fun(set(B),D),groups7311177749621191930dd_sum(B,D),aa(fun(B,sum_sum(B,C)),fun(B,D),aa(fun(sum_sum(B,C),D),fun(fun(B,sum_sum(B,C)),fun(B,D)),comp(sum_sum(B,C),D,B),Ga),sum_Inl(B,C))),A4)),aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),aa(fun(C,sum_sum(B,C)),fun(C,D),aa(fun(sum_sum(B,C),D),fun(fun(C,sum_sum(B,C)),fun(C,D)),comp(sum_sum(B,C),D,C),Ga),sum_Inr(C,B))),B2)) ) ) ) ) ).

% sum.Plus
tff(fact_5513_card__order__csum__cone__cexp__def,axiom,
    ! [B: $tType,C: $tType,R3: set(product_prod(B,B)),A14: set(C)] :
      ( bNF_Ca8970107618336181345der_on(B,top_top(set(B)),R3)
     => ( bNF_Cardinal_cexp(sum_sum(C,product_unit),B,bNF_Cardinal_csum(C,product_unit,bNF_Ca6860139660246222851ard_of(C,A14),bNF_Cardinal_cone),R3) = bNF_Ca6860139660246222851ard_of(fun(B,sum_sum(C,product_unit)),bNF_Wellorder_Func(B,sum_sum(C,product_unit),top_top(set(B)),aa(set(sum_sum(C,product_unit)),set(sum_sum(C,product_unit)),aa(set(sum_sum(C,product_unit)),fun(set(sum_sum(C,product_unit)),set(sum_sum(C,product_unit))),sup_sup(set(sum_sum(C,product_unit))),aa(set(C),set(sum_sum(C,product_unit)),image2(C,sum_sum(C,product_unit),sum_Inl(C,product_unit)),A14)),aa(set(sum_sum(C,product_unit)),set(sum_sum(C,product_unit)),insert2(sum_sum(C,product_unit),aa(product_unit,sum_sum(C,product_unit),sum_Inr(product_unit,C),product_Unity)),bot_bot(set(sum_sum(C,product_unit))))))) ) ) ).

% card_order_csum_cone_cexp_def
tff(fact_5514_case__sum__o__inj_I2_J,axiom,
    ! [D: $tType,C: $tType,B: $tType,Fa: fun(D,C),Ga: fun(B,C)] : ( aa(fun(B,sum_sum(D,B)),fun(B,C),aa(fun(sum_sum(D,B),C),fun(fun(B,sum_sum(D,B)),fun(B,C)),comp(sum_sum(D,B),C,B),sum_case_sum(D,C,B,Fa,Ga)),sum_Inr(B,D)) = Ga ) ).

% case_sum_o_inj(2)
tff(fact_5515_case__sum__expand__Inr__pointfree,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(sum_sum(B,D),C),Ga: fun(B,C)] :
      ( ( aa(fun(B,sum_sum(B,D)),fun(B,C),aa(fun(sum_sum(B,D),C),fun(fun(B,sum_sum(B,D)),fun(B,C)),comp(sum_sum(B,D),C,B),Fa),sum_Inl(B,D)) = Ga )
     => ( sum_case_sum(B,C,D,Ga,aa(fun(D,sum_sum(B,D)),fun(D,C),aa(fun(sum_sum(B,D),C),fun(fun(D,sum_sum(B,D)),fun(D,C)),comp(sum_sum(B,D),C,D),Fa),sum_Inr(D,B))) = Fa ) ) ).

% case_sum_expand_Inr_pointfree
tff(fact_5516_case__sum__expand__Inr_H,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(sum_sum(B,D),C),Ga: fun(B,C),H2: fun(D,C)] :
      ( ( aa(fun(B,sum_sum(B,D)),fun(B,C),aa(fun(sum_sum(B,D),C),fun(fun(B,sum_sum(B,D)),fun(B,C)),comp(sum_sum(B,D),C,B),Fa),sum_Inl(B,D)) = Ga )
     => ( ( H2 = aa(fun(D,sum_sum(B,D)),fun(D,C),aa(fun(sum_sum(B,D),C),fun(fun(D,sum_sum(B,D)),fun(D,C)),comp(sum_sum(B,D),C,D),Fa),sum_Inr(D,B)) )
      <=> ( sum_case_sum(B,C,D,Ga,H2) = Fa ) ) ) ).

% case_sum_expand_Inr'
tff(fact_5517_case__sum__expand__Inr,axiom,
    ! [C: $tType,D: $tType,B: $tType,Fa: fun(sum_sum(B,D),C),Ga: fun(B,C),X: sum_sum(B,D)] :
      ( ( aa(fun(B,sum_sum(B,D)),fun(B,C),aa(fun(sum_sum(B,D),C),fun(fun(B,sum_sum(B,D)),fun(B,C)),comp(sum_sum(B,D),C,B),Fa),sum_Inl(B,D)) = Ga )
     => ( aa(sum_sum(B,D),C,Fa,X) = aa(sum_sum(B,D),C,sum_case_sum(B,C,D,Ga,aa(fun(D,sum_sum(B,D)),fun(D,C),aa(fun(sum_sum(B,D),C),fun(fun(D,sum_sum(B,D)),fun(D,C)),comp(sum_sum(B,D),C,D),Fa),sum_Inr(D,B))),X) ) ) ).

% case_sum_expand_Inr
tff(fact_5518_map__sum__o__inj_I2_J,axiom,
    ! [E: $tType,C: $tType,D: $tType,B: $tType,Fa: fun(E,C),Ga: fun(B,D)] : ( aa(fun(B,sum_sum(E,B)),fun(B,sum_sum(C,D)),aa(fun(sum_sum(E,B),sum_sum(C,D)),fun(fun(B,sum_sum(E,B)),fun(B,sum_sum(C,D))),comp(sum_sum(E,B),sum_sum(C,D),B),sum_map_sum(E,C,B,D,Fa,Ga)),sum_Inr(B,E)) = aa(fun(B,D),fun(B,sum_sum(C,D)),aa(fun(D,sum_sum(C,D)),fun(fun(B,D),fun(B,sum_sum(C,D))),comp(D,sum_sum(C,D),B),sum_Inr(D,C)),Ga) ) ).

% map_sum_o_inj(2)
tff(fact_5519_sum__set__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,X: B] : ( aa(sum_sum(B,C),set(B),basic_setl(B,C),aa(B,sum_sum(B,C),sum_Inl(B,C),X)) = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) ).

% sum_set_simps(1)
tff(fact_5520_sum__set__simps_I4_J,axiom,
    ! [C: $tType,B: $tType,X: B] : ( aa(sum_sum(C,B),set(B),basic_setr(C,B),aa(B,sum_sum(C,B),sum_Inr(B,C),X)) = aa(set(B),set(B),insert2(B,X),bot_bot(set(B))) ) ).

% sum_set_simps(4)
tff(fact_5521_Node__def,axiom,
    ! [C: $tType,B: $tType] : ( old_Node(B,C) = aa(fun(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),$o),set(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))),collect(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))),aTP_Lamp_wf(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),$o)) ) ).

% Node_def
tff(fact_5522_sum__set__simps_I2_J,axiom,
    ! [C: $tType,B: $tType,X: C] : ( aa(sum_sum(B,C),set(B),basic_setl(B,C),aa(C,sum_sum(B,C),sum_Inr(C,B),X)) = bot_bot(set(B)) ) ).

% sum_set_simps(2)
tff(fact_5523_sum__set__simps_I3_J,axiom,
    ! [C: $tType,B: $tType,X: C] : ( aa(sum_sum(C,B),set(B),basic_setr(C,B),aa(C,sum_sum(C,B),sum_Inl(C,B),X)) = bot_bot(set(B)) ) ).

% sum_set_simps(3)
tff(fact_5524_Node__K0__I,axiom,
    ! [C: $tType,B: $tType,A3: sum_sum(C,nat)] : member(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),aa(sum_sum(C,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(C,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))),product_Pair(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),aTP_Lamp_wg(nat,sum_sum(B,nat))),A3),old_Node(B,C)) ).

% Node_K0_I
tff(fact_5525_sum__set__defs_I2_J,axiom,
    ! [B: $tType,C: $tType] : ( basic_setr(B,C) = sum_case_sum(B,set(C),C,aTP_Lamp_hp(B,set(C)),aTP_Lamp_wh(C,set(C))) ) ).

% sum_set_defs(2)
tff(fact_5526_sum__set__defs_I1_J,axiom,
    ! [B: $tType,C: $tType] : ( basic_setl(B,C) = sum_case_sum(B,set(B),C,aTP_Lamp_bf(B,set(B)),aTP_Lamp_ij(C,set(B))) ) ).

% sum_set_defs(1)
tff(fact_5527_ndepth__K0,axiom,
    ! [B: $tType,C: $tType,X: sum_sum(B,nat)] : ( old_ndepth(B,C,old_Abs_Node(C,B,aa(sum_sum(B,nat),product_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat)),aa(fun(nat,sum_sum(C,nat)),fun(sum_sum(B,nat),product_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat))),product_Pair(fun(nat,sum_sum(C,nat)),sum_sum(B,nat)),aTP_Lamp_wi(nat,sum_sum(C,nat))),X))) = zero_zero(nat) ) ).

% ndepth_K0
tff(fact_5528_Atom__def,axiom,
    ! [C: $tType,B: $tType,X3: sum_sum(B,nat)] : ( aa(sum_sum(B,nat),set(old_node(B,C)),old_Atom(B,C),X3) = aa(set(old_node(B,C)),set(old_node(B,C)),insert2(old_node(B,C),old_Abs_Node(C,B,aa(sum_sum(B,nat),product_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat)),aa(fun(nat,sum_sum(C,nat)),fun(sum_sum(B,nat),product_prod(fun(nat,sum_sum(C,nat)),sum_sum(B,nat))),product_Pair(fun(nat,sum_sum(C,nat)),sum_sum(B,nat)),aTP_Lamp_wi(nat,sum_sum(C,nat))),X3))),bot_bot(set(old_node(B,C)))) ) ).

% Atom_def
tff(fact_5529_Leaf__def,axiom,
    ! [C: $tType,B: $tType] : ( old_Leaf(B,C) = aa(fun(B,sum_sum(B,nat)),fun(B,set(old_node(B,C))),aa(fun(sum_sum(B,nat),set(old_node(B,C))),fun(fun(B,sum_sum(B,nat)),fun(B,set(old_node(B,C)))),comp(sum_sum(B,nat),set(old_node(B,C)),B),old_Atom(B,C)),sum_Inl(B,nat)) ) ).

% Leaf_def
tff(fact_5530_nth__item_Opinduct,axiom,
    ! [A0: nat,Pa: fun(nat,$o)] :
      ( aa(nat,$o,accp(nat,nth_item_rel),A0)
     => ( ( aa(nat,$o,accp(nat,nth_item_rel),zero_zero(nat))
         => aa(nat,$o,Pa,zero_zero(nat)) )
       => ( ! [N3: nat] :
              ( aa(nat,$o,accp(nat,nth_item_rel),aa(nat,nat,suc,N3))
             => ( ! [A13: nat,Aa3: nat] :
                    ( ( nat_sum_decode(N3) = aa(nat,sum_sum(nat,nat),sum_Inl(nat,nat),A13) )
                   => ( ( nat_sum_decode(A13) = aa(nat,sum_sum(nat,nat),sum_Inl(nat,nat),Aa3) )
                     => aa(nat,$o,Pa,Aa3) ) )
               => ( ! [A13: nat,B9: nat] :
                      ( ( nat_sum_decode(N3) = aa(nat,sum_sum(nat,nat),sum_Inl(nat,nat),A13) )
                     => ( ( nat_sum_decode(A13) = aa(nat,sum_sum(nat,nat),sum_Inr(nat,nat),B9) )
                       => aa(nat,$o,Pa,B9) ) )
                 => ( ! [B9: nat,Ba3: nat,X3: nat,Y4: nat] :
                        ( ( nat_sum_decode(N3) = aa(nat,sum_sum(nat,nat),sum_Inr(nat,nat),B9) )
                       => ( ( nat_sum_decode(B9) = aa(nat,sum_sum(nat,nat),sum_Inr(nat,nat),Ba3) )
                         => ( ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X3),Y4) = nat_prod_decode(Ba3) )
                           => aa(nat,$o,Pa,X3) ) ) )
                   => ( ! [B9: nat,Ba3: nat,X3: nat,Y4: nat] :
                          ( ( nat_sum_decode(N3) = aa(nat,sum_sum(nat,nat),sum_Inr(nat,nat),B9) )
                         => ( ( nat_sum_decode(B9) = aa(nat,sum_sum(nat,nat),sum_Inr(nat,nat),Ba3) )
                           => ( ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X3),Y4) = nat_prod_decode(Ba3) )
                             => aa(nat,$o,Pa,Y4) ) ) )
                     => aa(nat,$o,Pa,aa(nat,nat,suc,N3)) ) ) ) ) )
         => aa(nat,$o,Pa,A0) ) ) ) ).

% nth_item.pinduct
tff(fact_5531_ntrunc__0,axiom,
    ! [C: $tType,B: $tType,M: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(old_node(B,C)),old_ntrunc(B,C,zero_zero(nat)),M) = bot_bot(set(old_node(B,C))) ) ).

% ntrunc_0
tff(fact_5532_ntrunc__o__equality,axiom,
    ! [D: $tType,C: $tType,B: $tType,H12: fun(B,set(old_node(C,D))),H23: fun(B,set(old_node(C,D)))] :
      ( ! [K2: nat] : ( aa(fun(B,set(old_node(C,D))),fun(B,set(old_node(C,D))),aa(fun(set(old_node(C,D)),set(old_node(C,D))),fun(fun(B,set(old_node(C,D))),fun(B,set(old_node(C,D)))),comp(set(old_node(C,D)),set(old_node(C,D)),B),old_ntrunc(C,D,K2)),H12) = aa(fun(B,set(old_node(C,D))),fun(B,set(old_node(C,D))),aa(fun(set(old_node(C,D)),set(old_node(C,D))),fun(fun(B,set(old_node(C,D))),fun(B,set(old_node(C,D)))),comp(set(old_node(C,D)),set(old_node(C,D)),B),old_ntrunc(C,D,K2)),H23) )
     => ( H12 = H23 ) ) ).

% ntrunc_o_equality
tff(fact_5533_list__decode_Opinduct,axiom,
    ! [A0: nat,Pa: fun(nat,$o)] :
      ( aa(nat,$o,accp(nat,nat_list_decode_rel),A0)
     => ( ( aa(nat,$o,accp(nat,nat_list_decode_rel),zero_zero(nat))
         => aa(nat,$o,Pa,zero_zero(nat)) )
       => ( ! [N3: nat] :
              ( aa(nat,$o,accp(nat,nat_list_decode_rel),aa(nat,nat,suc,N3))
             => ( ! [X3: nat,Y4: nat] :
                    ( ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),X3),Y4) = nat_prod_decode(N3) )
                   => aa(nat,$o,Pa,Y4) )
               => aa(nat,$o,Pa,aa(nat,nat,suc,N3)) ) )
         => aa(nat,$o,Pa,A0) ) ) ) ).

% list_decode.pinduct
tff(fact_5534_ntrunc__one__In0,axiom,
    ! [C: $tType,B: $tType,M: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(old_node(B,C)),old_ntrunc(B,C,aa(nat,nat,suc,zero_zero(nat))),old_In0(B,C,M)) = bot_bot(set(old_node(B,C))) ) ).

% ntrunc_one_In0
tff(fact_5535_ntrunc__one__In1,axiom,
    ! [C: $tType,B: $tType,M: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(old_node(B,C)),old_ntrunc(B,C,aa(nat,nat,suc,zero_zero(nat))),old_In1(B,C,M)) = bot_bot(set(old_node(B,C))) ) ).

% ntrunc_one_In1
tff(fact_5536_dsum__def,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),S: set(product_prod(set(old_node(B,C)),set(old_node(B,C))))] : ( old_dsum(B,C,R3,S) = aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),sup_sup(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),complete_Sup_Sup(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),image2(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),fun(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),product_case_prod(set(old_node(B,C)),set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_wj(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))))),R3))),aa(set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),complete_Sup_Sup(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),image2(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),fun(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),product_case_prod(set(old_node(B,C)),set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_wk(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))))),S))) ) ).

% dsum_def
tff(fact_5537_Numb__def,axiom,
    ! [C: $tType,B: $tType] : ( old_Numb(B,C) = aa(fun(nat,sum_sum(B,nat)),fun(nat,set(old_node(B,C))),aa(fun(sum_sum(B,nat),set(old_node(B,C))),fun(fun(nat,sum_sum(B,nat)),fun(nat,set(old_node(B,C)))),comp(sum_sum(B,nat),set(old_node(B,C)),nat),old_Atom(B,C)),sum_Inr(nat,B)) ) ).

% Numb_def
tff(fact_5538_dsumE,axiom,
    ! [C: $tType,B: $tType,W2: product_prod(set(old_node(B,C)),set(old_node(B,C))),R3: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),S: set(product_prod(set(old_node(B,C)),set(old_node(B,C))))] :
      ( member(product_prod(set(old_node(B,C)),set(old_node(B,C))),W2,old_dsum(B,C,R3,S))
     => ( ! [X2: set(old_node(B,C)),X9: set(old_node(B,C))] :
            ( member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),X2),X9),R3)
           => ( W2 != aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_In0(B,C,X2)),old_In0(B,C,X9)) ) )
       => ~ ! [Y2: set(old_node(B,C)),Y7: set(old_node(B,C))] :
              ( member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),Y2),Y7),S)
             => ( W2 != aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_In1(B,C,Y2)),old_In1(B,C,Y7)) ) ) ) ) ).

% dsumE
tff(fact_5539_dsum__In1I,axiom,
    ! [C: $tType,B: $tType,N4: set(old_node(B,C)),N7: set(old_node(B,C)),S: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),R3: set(product_prod(set(old_node(B,C)),set(old_node(B,C))))] :
      ( member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),N4),N7),S)
     => member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_In1(B,C,N4)),old_In1(B,C,N7)),old_dsum(B,C,R3,S)) ) ).

% dsum_In1I
tff(fact_5540_dsum__In0I,axiom,
    ! [C: $tType,B: $tType,M: set(old_node(B,C)),M8: set(old_node(B,C)),R3: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),S: set(product_prod(set(old_node(B,C)),set(old_node(B,C))))] :
      ( member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),M),M8),R3)
     => member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_In0(B,C,M)),old_In0(B,C,M8)),old_dsum(B,C,R3,S)) ) ).

% dsum_In0I
tff(fact_5541_dprod__def,axiom,
    ! [C: $tType,B: $tType,R3: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),S: set(product_prod(set(old_node(B,C)),set(old_node(B,C))))] : ( old_dprod(B,C,R3,S) = aa(set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),complete_Sup_Sup(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),image2(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),fun(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),product_case_prod(set(old_node(B,C)),set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_wm(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),S))),R3)) ) ).

% dprod_def
tff(fact_5542_dual__order_Opreordering__axioms,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => preordering(B,aTP_Lamp_we(B,fun(B,$o)),aTP_Lamp_wn(B,fun(B,$o))) ) ).

% dual_order.preordering_axioms
tff(fact_5543_curr__def,axiom,
    ! [B: $tType,D: $tType,C: $tType,A4: set(B),Fa: fun(product_prod(B,C),D),X3: B] :
      ( bNF_Wellorder_curr(B,C,D,A4,Fa,X3)
      = $ite(member(B,X3,A4),aa(B,fun(C,D),aTP_Lamp_et(fun(product_prod(B,C),D),fun(B,fun(C,D)),Fa),X3),undefined(fun(C,D))) ) ).

% curr_def
tff(fact_5544_dprodI,axiom,
    ! [C: $tType,B: $tType,M: set(old_node(B,C)),M8: set(old_node(B,C)),R3: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),N4: set(old_node(B,C)),N7: set(old_node(B,C)),S: set(product_prod(set(old_node(B,C)),set(old_node(B,C))))] :
      ( member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),M),M8),R3)
     => ( member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),N4),N7),S)
       => member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_Scons(B,C,M,N4)),old_Scons(B,C,M8,N7)),old_dprod(B,C,R3,S)) ) ) ).

% dprodI
tff(fact_5545_dprodE,axiom,
    ! [C: $tType,B: $tType,C2: product_prod(set(old_node(B,C)),set(old_node(B,C))),R3: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),S: set(product_prod(set(old_node(B,C)),set(old_node(B,C))))] :
      ( member(product_prod(set(old_node(B,C)),set(old_node(B,C))),C2,old_dprod(B,C,R3,S))
     => ~ ! [X2: set(old_node(B,C)),Y2: set(old_node(B,C)),X9: set(old_node(B,C))] :
            ( member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),X2),X9),R3)
           => ! [Y7: set(old_node(B,C))] :
                ( member(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),Y2),Y7),S)
               => ( C2 != aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_Scons(B,C,X2,Y2)),old_Scons(B,C,X9,Y7)) ) ) ) ) ).

% dprodE
tff(fact_5546_preordering__dualI,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( preordering(B,aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Less_eq),aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Less))
     => preordering(B,Less_eq,Less) ) ).

% preordering_dualI
tff(fact_5547_preordering__strictI,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( ! [A8: B,B4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A8),B4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),Less,A8),B4)
            | ( A8 = B4 ) ) )
     => ( ! [A8: B,B4: B] :
            ( aa(B,$o,aa(B,fun(B,$o),Less,A8),B4)
           => ~ aa(B,$o,aa(B,fun(B,$o),Less,B4),A8) )
       => ( ! [A8: B] : ~ aa(B,$o,aa(B,fun(B,$o),Less,A8),A8)
         => ( ! [A8: B,B4: B,C4: B] :
                ( aa(B,$o,aa(B,fun(B,$o),Less,A8),B4)
               => ( aa(B,$o,aa(B,fun(B,$o),Less,B4),C4)
                 => aa(B,$o,aa(B,fun(B,$o),Less,A8),C4) ) )
           => preordering(B,Less_eq,Less) ) ) ) ) ).

% preordering_strictI
tff(fact_5548_preordering_Ostrict__implies__order,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
       => aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba) ) ) ).

% preordering.strict_implies_order
tff(fact_5549_preordering_Ostrict__iff__not,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
      <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
          & ~ aa(B,$o,aa(B,fun(B,$o),Less_eq,Ba),A3) ) ) ) ).

% preordering.strict_iff_not
tff(fact_5550_preordering_Ostrict__trans2,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B,C2: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
       => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,Ba),C2)
         => aa(B,$o,aa(B,fun(B,$o),Less,A3),C2) ) ) ) ).

% preordering.strict_trans2
tff(fact_5551_preordering_Ostrict__trans1,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B,C2: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A3),Ba)
       => ( aa(B,$o,aa(B,fun(B,$o),Less,Ba),C2)
         => aa(B,$o,aa(B,fun(B,$o),Less,A3),C2) ) ) ) ).

% preordering.strict_trans1
tff(fact_5552_preordering_Ostrict__trans,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B,C2: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
       => ( aa(B,$o,aa(B,fun(B,$o),Less,Ba),C2)
         => aa(B,$o,aa(B,fun(B,$o),Less,A3),C2) ) ) ) ).

% preordering.strict_trans
tff(fact_5553_preordering_Oirrefl,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B] :
      ( preordering(B,Less_eq,Less)
     => ~ aa(B,$o,aa(B,fun(B,$o),Less,A3),A3) ) ).

% preordering.irrefl
tff(fact_5554_preordering_Oasym,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o)),A3: B,Ba: B] :
      ( preordering(B,Less_eq,Less)
     => ( aa(B,$o,aa(B,fun(B,$o),Less,A3),Ba)
       => ~ aa(B,$o,aa(B,fun(B,$o),Less,Ba),A3) ) ) ).

% preordering.asym
tff(fact_5555_preordering_Oaxioms_I1_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( preordering(B,Less_eq,Less)
     => partial_preordering(B,Less_eq) ) ).

% preordering.axioms(1)
tff(fact_5556_order_Opreordering__axioms,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => preordering(B,ord_less_eq(B),ord_less(B)) ) ).

% order.preordering_axioms
tff(fact_5557_preordering_Ointro,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( partial_preordering(B,Less_eq)
     => ( preordering_axioms(B,Less_eq,Less)
       => preordering(B,Less_eq,Less) ) ) ).

% preordering.intro
tff(fact_5558_preordering__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( preordering(B,Less_eq,Less)
    <=> ( partial_preordering(B,Less_eq)
        & preordering_axioms(B,Less_eq,Less) ) ) ).

% preordering_def
tff(fact_5559_preordering_Oaxioms_I2_J,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( preordering(B,Less_eq,Less)
     => preordering_axioms(B,Less_eq,Less) ) ).

% preordering.axioms(2)
tff(fact_5560_preordering__axioms_Ointro,axiom,
    ! [B: $tType,Less: fun(B,fun(B,$o)),Less_eq: fun(B,fun(B,$o))] :
      ( ! [A8: B,B4: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less,A8),B4)
        <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A8),B4)
            & ~ aa(B,$o,aa(B,fun(B,$o),Less_eq,B4),A8) ) )
     => preordering_axioms(B,Less_eq,Less) ) ).

% preordering_axioms.intro
tff(fact_5561_preordering__axioms__def,axiom,
    ! [B: $tType,Less_eq: fun(B,fun(B,$o)),Less: fun(B,fun(B,$o))] :
      ( preordering_axioms(B,Less_eq,Less)
    <=> ! [A6: B,B5: B] :
          ( aa(B,$o,aa(B,fun(B,$o),Less,A6),B5)
        <=> ( aa(B,$o,aa(B,fun(B,$o),Less_eq,A6),B5)
            & ~ aa(B,$o,aa(B,fun(B,$o),Less_eq,B5),A6) ) ) ) ).

% preordering_axioms_def
tff(fact_5562_rotate__add,axiom,
    ! [B: $tType,M4: nat,N: nat] : ( rotate(B,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),N)) = aa(fun(list(B),list(B)),fun(list(B),list(B)),aa(fun(list(B),list(B)),fun(fun(list(B),list(B)),fun(list(B),list(B))),comp(list(B),list(B),list(B)),rotate(B,M4)),rotate(B,N)) ) ).

% rotate_add
tff(fact_5563_extract__def,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B)] : ( extract(B,Pa,Xs) = case_list(option(product_prod(list(B),product_prod(B,list(B)))),B,none(product_prod(list(B),product_prod(B,list(B)))),aa(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B)))))),aTP_Lamp_wo(fun(B,$o),fun(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))))),Pa),Xs),dropWhile(B,aa(fun(B,$o),fun(B,$o),aa(fun($o,$o),fun(fun(B,$o),fun(B,$o)),comp($o,$o,B),fNot),Pa),Xs)) ) ).

% extract_def
tff(fact_5564_relH__def,axiom,
    ! [As: set(nat),H2: heap_ext(product_unit),H4: heap_ext(product_unit)] :
      ( relH(As,H2,H4)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H2),As))
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H4),As))
        & ! [T7: typerep,X4: nat] :
            ( member(nat,X4,As)
           => ( ( aa(nat,nat,refs(product_unit,H2,T7),X4) = aa(nat,nat,refs(product_unit,H4,T7),X4) )
              & ( arrays(product_unit,H2,T7,X4) = arrays(product_unit,H4,T7,X4) ) ) ) ) ) ).

% relH_def
tff(fact_5565_zip__takeWhile__snd,axiom,
    ! [B: $tType,C: $tType,Xs: list(B),Pa: fun(C,$o),Ys: list(C)] : ( zip(B,C,Xs,takeWhile(C,Pa,Ys)) = takeWhile(product_prod(B,C),aa(fun(product_prod(B,C),C),fun(product_prod(B,C),$o),aa(fun(C,$o),fun(fun(product_prod(B,C),C),fun(product_prod(B,C),$o)),comp(C,$o,product_prod(B,C)),Pa),product_snd(B,C)),zip(B,C,Xs,Ys)) ) ).

% zip_takeWhile_snd
tff(fact_5566_zip__takeWhile__fst,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),Xs: list(B),Ys: list(C)] : ( zip(B,C,takeWhile(B,Pa,Xs),Ys) = takeWhile(product_prod(B,C),aa(fun(product_prod(B,C),B),fun(product_prod(B,C),$o),aa(fun(B,$o),fun(fun(product_prod(B,C),B),fun(product_prod(B,C),$o)),comp(B,$o,product_prod(B,C)),Pa),product_fst(B,C)),zip(B,C,Xs,Ys)) ) ).

% zip_takeWhile_fst
tff(fact_5567_takeWhile__map,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),Fa: fun(C,B),Xs: list(C)] : ( takeWhile(B,Pa,aa(list(C),list(B),map(C,B,Fa),Xs)) = aa(list(C),list(B),map(C,B,Fa),takeWhile(C,aa(fun(C,B),fun(C,$o),aa(fun(B,$o),fun(fun(C,B),fun(C,$o)),comp(B,$o,C),Pa),Fa),Xs)) ) ).

% takeWhile_map
tff(fact_5568_dropWhile__map,axiom,
    ! [B: $tType,C: $tType,Pa: fun(B,$o),Fa: fun(C,B),Xs: list(C)] : ( dropWhile(B,Pa,aa(list(C),list(B),map(C,B,Fa),Xs)) = aa(list(C),list(B),map(C,B,Fa),dropWhile(C,aa(fun(C,B),fun(C,$o),aa(fun(B,$o),fun(fun(C,B),fun(C,$o)),comp(B,$o,C),Pa),Fa),Xs)) ) ).

% dropWhile_map
tff(fact_5569_find__dropWhile,axiom,
    ! [B: $tType,Pa: fun(B,$o),Xs: list(B)] : ( find(B,Pa,Xs) = case_list(option(B),B,none(B),aTP_Lamp_wp(B,fun(list(B),option(B))),dropWhile(B,aa(fun(B,$o),fun(B,$o),aa(fun($o,$o),fun(fun(B,$o),fun(B,$o)),comp($o,$o,B),fNot),Pa),Xs)) ) ).

% find_dropWhile
tff(fact_5570_Ref__Time_Oget__def,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [H2: heap_ext(product_unit)] : ( ref_get(B,H2) = aa(fun(ref(B),nat),fun(ref(B),B),aa(fun(nat,B),fun(fun(ref(B),nat),fun(ref(B),B)),comp(nat,B,ref(B)),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),from_nat(B)),refs(product_unit,H2,typerep_typerep(B,type2(B))))),addr_of_ref(B)) ) ) ).

% Ref_Time.get_def
tff(fact_5571_sum_Opred__map,axiom,
    ! [C: $tType,B: $tType,E: $tType,D: $tType,Q1a: fun(B,$o),Q2a: fun(C,$o),F1: fun(D,B),F22: fun(E,C),X: sum_sum(D,E)] :
      ( basic_pred_sum(B,C,Q1a,Q2a,aa(sum_sum(D,E),sum_sum(B,C),sum_map_sum(D,B,E,C,F1,F22),X))
    <=> basic_pred_sum(D,E,aa(fun(D,B),fun(D,$o),aa(fun(B,$o),fun(fun(D,B),fun(D,$o)),comp(B,$o,D),Q1a),F1),aa(fun(E,C),fun(E,$o),aa(fun(C,$o),fun(fun(E,C),fun(E,$o)),comp(C,$o,E),Q2a),F22),X) ) ).

% sum.pred_map
tff(fact_5572_in__range_Opelims_I3_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X)
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
               => ! [X2: nat] :
                    ( member(nat,X2,As2)
                   => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X2),lim(product_unit,H)) ) ) ) ) ) ).

% in_range.pelims(3)
tff(fact_5573_in__range_Opelims_I2_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X)
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
               => ~ ! [X3: nat] :
                      ( member(nat,X3,As2)
                     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),lim(product_unit,H)) ) ) ) ) ) ).

% in_range.pelims(2)
tff(fact_5574_in__range_Opelims_I1_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,X)
      <=> (Y) )
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),X)
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( ( (Y)
                <=> ! [X4: nat] :
                      ( member(nat,X4,As2)
                     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),lim(product_unit,H)) ) )
               => ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),in_range_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)) ) ) ) ) ).

% in_range.pelims(1)
tff(fact_5575_one__assn__raw_Opelims_I3_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X)
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
               => ( As2 = bot_bot(set(nat)) ) ) ) ) ) ).

% one_assn_raw.pelims(3)
tff(fact_5576_one__assn__raw_Opelims_I2_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X)
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X)
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2))
               => ( As2 != bot_bot(set(nat)) ) ) ) ) ) ).

% one_assn_raw.pelims(2)
tff(fact_5577_one__assn__raw_Opelims_I1_J,axiom,
    ! [X: product_prod(heap_ext(product_unit),set(nat)),Y: $o] :
      ( ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,one_assn_raw,X)
      <=> (Y) )
     => ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),X)
       => ~ ! [H: heap_ext(product_unit),As2: set(nat)] :
              ( ( X = aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2) )
             => ( ( (Y)
                <=> ( As2 = bot_bot(set(nat)) ) )
               => ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,accp(product_prod(heap_ext(product_unit),set(nat)),one_assn_raw_rel),aa(set(nat),product_prod(heap_ext(product_unit),set(nat)),aa(heap_ext(product_unit),fun(set(nat),product_prod(heap_ext(product_unit),set(nat))),product_Pair(heap_ext(product_unit),set(nat)),H),As2)) ) ) ) ) ).

% one_assn_raw.pelims(1)
tff(fact_5578_Enum_Ortranclp__rtrancl__eq,axiom,
    ! [B: $tType,R3: fun(B,fun(B,$o)),X: B,Y: B] :
      ( aa(B,$o,aa(B,fun(B,$o),transitive_rtranclp(B,R3),X),Y)
    <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X),Y),transitive_rtrancl(B,aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),R3)))) ) ).

% Enum.rtranclp_rtrancl_eq
tff(fact_5579_rtrancl__def,axiom,
    ! [B: $tType,X3: set(product_prod(B,B))] : ( transitive_rtrancl(B,X3) = aa(fun(product_prod(B,B),$o),set(product_prod(B,B)),collect(product_prod(B,B)),aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),transitive_rtranclp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),X3)))) ) ).

% rtrancl_def
tff(fact_5580_Quotient__compose,axiom,
    ! [B: $tType,D: $tType,C: $tType,R12: fun(B,fun(B,$o)),Abs1: fun(B,C),Rep1: fun(C,B),T1: fun(B,fun(C,$o)),R23: fun(C,fun(C,$o)),Abs22: fun(C,D),Rep22: fun(D,C),T22: fun(C,fun(D,$o))] :
      ( quotient(B,C,R12,Abs1,Rep1,T1)
     => ( quotient(C,D,R23,Abs22,Rep22,T22)
       => quotient(B,D,relcompp(B,C,B,T1,relcompp(C,C,B,R23,conversep(B,C,T1))),aa(fun(B,C),fun(B,D),aa(fun(C,D),fun(fun(B,C),fun(B,D)),comp(C,D,B),Abs22),Abs1),aa(fun(D,C),fun(D,B),aa(fun(C,B),fun(fun(D,C),fun(D,B)),comp(C,B,D),Rep1),Rep22),relcompp(B,C,D,T1,T22)) ) ) ).

% Quotient_compose
tff(fact_5581_rtranclp__induct2,axiom,
    ! [B: $tType,C: $tType,R3: fun(product_prod(B,C),fun(product_prod(B,C),$o)),Ax: B,Ay: C,Bx: B,By: C,Pa: fun(B,fun(C,$o))] :
      ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),transitive_rtranclp(product_prod(B,C),R3),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Bx),By))
     => ( aa(C,$o,aa(B,fun(C,$o),Pa,Ax),Ay)
       => ( ! [A8: B,B4: C,Aa2: B,Ba2: C] :
              ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),transitive_rtranclp(product_prod(B,C),R3),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4))
             => ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),R3,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Aa2),Ba2))
               => ( aa(C,$o,aa(B,fun(C,$o),Pa,A8),B4)
                 => aa(C,$o,aa(B,fun(C,$o),Pa,Aa2),Ba2) ) ) )
         => aa(C,$o,aa(B,fun(C,$o),Pa,Bx),By) ) ) ) ).

% rtranclp_induct2
tff(fact_5582_converse__rtranclpE2,axiom,
    ! [B: $tType,C: $tType,R3: fun(product_prod(B,C),fun(product_prod(B,C),$o)),Xa: B,Xb: C,Za2: B,Zb: C] :
      ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),transitive_rtranclp(product_prod(B,C),R3),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Xa),Xb)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Za2),Zb))
     => ( ( aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Xa),Xb) != aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Za2),Zb) )
       => ~ ! [A8: B,B4: C] :
              ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),R3,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Xa),Xb)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4))
             => ~ aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),transitive_rtranclp(product_prod(B,C),R3),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Za2),Zb)) ) ) ) ).

% converse_rtranclpE2
tff(fact_5583_converse__rtranclp__induct2,axiom,
    ! [B: $tType,C: $tType,R3: fun(product_prod(B,C),fun(product_prod(B,C),$o)),Ax: B,Ay: C,Bx: B,By: C,Pa: fun(B,fun(C,$o))] :
      ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),transitive_rtranclp(product_prod(B,C),R3),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Ax),Ay)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Bx),By))
     => ( aa(C,$o,aa(B,fun(C,$o),Pa,Bx),By)
       => ( ! [A8: B,B4: C,Aa2: B,Ba2: C] :
              ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),R3,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A8),B4)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Aa2),Ba2))
             => ( aa(product_prod(B,C),$o,aa(product_prod(B,C),fun(product_prod(B,C),$o),transitive_rtranclp(product_prod(B,C),R3),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Aa2),Ba2)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Bx),By))
               => ( aa(C,$o,aa(B,fun(C,$o),Pa,Aa2),Ba2)
                 => aa(C,$o,aa(B,fun(C,$o),Pa,A8),B4) ) ) )
         => aa(C,$o,aa(B,fun(C,$o),Pa,Ax),Ay) ) ) ) ).

% converse_rtranclp_induct2
tff(fact_5584_Heap_OQuotient,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(B,$o)),Abs: fun(B,C),Rep: fun(C,B),T3: fun(B,fun(C,$o))] :
      ( quotient(B,C,R,Abs,Rep,T3)
     => quotient(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,fun(B,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(B,B),R),aa(fun(B,C),fun(heap_Time_Heap(B),heap_Time_Heap(C)),heap_Time_map_Heap(B,C),Abs),aa(fun(C,B),fun(heap_Time_Heap(C),heap_Time_Heap(B)),heap_Time_map_Heap(C,B),Rep),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),T3)) ) ).

% Heap.Quotient
tff(fact_5585_rtranclp__r__diff__Id,axiom,
    ! [B: $tType,R3: fun(B,fun(B,$o))] : ( transitive_rtranclp(B,aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),inf_inf(fun(B,fun(B,$o))),R3),aTP_Lamp_wq(B,fun(B,$o)))) = transitive_rtranclp(B,R3) ) ).

% rtranclp_r_diff_Id
tff(fact_5586_Transitive__Closure_Ortranclp__rtrancl__eq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X3: B,Xa3: B] :
      ( aa(B,$o,aa(B,fun(B,$o),transitive_rtranclp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3)),X3),Xa3)
    <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X3),Xa3),transitive_rtrancl(B,R3)) ) ).

% Transitive_Closure.rtranclp_rtrancl_eq
tff(fact_5587_accp__acc__eq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),X3: B] :
      ( aa(B,$o,accp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3)),X3)
    <=> member(B,X3,acc(B,R3)) ) ).

% accp_acc_eq
tff(fact_5588_acc__def,axiom,
    ! [B: $tType,X3: set(product_prod(B,B))] : ( acc(B,X3) = aa(fun(B,$o),set(B),collect(B),accp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),X3))) ) ).

% acc_def
tff(fact_5589_map__mmupd__empty,axiom,
    ! [C: $tType,B: $tType,M4: fun(B,option(C)),V: C] : ( map_mmupd(B,C,M4,bot_bot(set(B)),V) = M4 ) ).

% map_mmupd_empty
tff(fact_5590_acc_Ocases,axiom,
    ! [B: $tType,A3: B,R3: set(product_prod(B,B))] :
      ( member(B,A3,acc(B,R3))
     => ! [Y4: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),A3),R3)
         => member(B,Y4,acc(B,R3)) ) ) ).

% acc.cases
tff(fact_5591_acc_Osimps,axiom,
    ! [B: $tType,A3: B,R3: set(product_prod(B,B))] :
      ( member(B,A3,acc(B,R3))
    <=> ? [X4: B] :
          ( ( A3 = X4 )
          & ! [Xa2: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa2),X4),R3)
             => member(B,Xa2,acc(B,R3)) ) ) ) ).

% acc.simps
tff(fact_5592_acc_Ointros,axiom,
    ! [B: $tType,X: B,R3: set(product_prod(B,B))] :
      ( ! [Y2: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y2),X),R3)
         => member(B,Y2,acc(B,R3)) )
     => member(B,X,acc(B,R3)) ) ).

% acc.intros
tff(fact_5593_acc__induct,axiom,
    ! [B: $tType,A3: B,R3: set(product_prod(B,B)),Pa: fun(B,$o)] :
      ( member(B,A3,acc(B,R3))
     => ( ! [X2: B] :
            ( member(B,X2,acc(B,R3))
           => ( ! [Y4: B] :
                  ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),X2),R3)
                 => aa(B,$o,Pa,Y4) )
             => aa(B,$o,Pa,X2) ) )
       => aa(B,$o,Pa,A3) ) ) ).

% acc_induct
tff(fact_5594_acc__downward,axiom,
    ! [B: $tType,Ba: B,R3: set(product_prod(B,B)),A3: B] :
      ( member(B,Ba,acc(B,R3))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3)
       => member(B,A3,acc(B,R3)) ) ) ).

% acc_downward
tff(fact_5595_not__acc__down,axiom,
    ! [B: $tType,X: B,R: set(product_prod(B,B))] :
      ( ~ member(B,X,acc(B,R))
     => ~ ! [Z3: B] :
            ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z3),X),R)
           => member(B,Z3,acc(B,R)) ) ) ).

% not_acc_down
tff(fact_5596_acc__induct__rule,axiom,
    ! [B: $tType,A3: B,R3: set(product_prod(B,B)),Pa: fun(B,$o)] :
      ( member(B,A3,acc(B,R3))
     => ( ! [X2: B] :
            ( member(B,X2,acc(B,R3))
           => ( ! [Y4: B] :
                  ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y4),X2),R3)
                 => aa(B,$o,Pa,Y4) )
             => aa(B,$o,Pa,X2) ) )
       => aa(B,$o,Pa,A3) ) ) ).

% acc_induct_rule
tff(fact_5597_acc__subset__induct,axiom,
    ! [B: $tType,D4: set(B),R: set(product_prod(B,B)),X: B,Pa: fun(B,$o)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),D4),acc(B,R))
     => ( ! [X2: B,Z3: B] :
            ( member(B,X2,D4)
           => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z3),X2),R)
             => member(B,Z3,D4) ) )
       => ( member(B,X,D4)
         => ( ! [X2: B] :
                ( member(B,X2,D4)
               => ( ! [Z5: B] :
                      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z5),X2),R)
                     => aa(B,$o,Pa,Z5) )
                 => aa(B,$o,Pa,X2) ) )
           => aa(B,$o,Pa,X) ) ) ) ) ).

% acc_subset_induct
tff(fact_5598_acc__downwards__aux,axiom,
    ! [B: $tType,Ba: B,A3: B,R3: set(product_prod(B,B))] :
      ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),A3),transitive_rtrancl(B,R3))
     => ( member(B,A3,acc(B,R3))
       => member(B,Ba,acc(B,R3)) ) ) ).

% acc_downwards_aux
tff(fact_5599_acc__downwards,axiom,
    ! [B: $tType,A3: B,R3: set(product_prod(B,B)),Ba: B] :
      ( member(B,A3,acc(B,R3))
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),A3),transitive_rtrancl(B,R3))
       => member(B,Ba,acc(B,R3)) ) ) ).

% acc_downwards
tff(fact_5600_or__not__num__neg_Opelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( bit_or_not_num_neg(X,Xa) = Y )
     => ( aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X),Xa))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = one2 )
               => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2)) ) ) )
         => ( ( ( X = one2 )
             => ! [M5: num] :
                  ( ( Xa = aa(num,num,bit0,M5) )
                 => ( ( Y = aa(num,num,bit1,M5) )
                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,M5))) ) ) )
           => ( ( ( X = one2 )
               => ! [M5: num] :
                    ( ( Xa = aa(num,num,bit1,M5) )
                   => ( ( Y = aa(num,num,bit1,M5) )
                     => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,M5))) ) ) )
             => ( ! [N3: num] :
                    ( ( X = aa(num,num,bit0,N3) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,num,bit0,one2) )
                       => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,N3)),one2)) ) ) )
               => ( ! [N3: num] :
                      ( ( X = aa(num,num,bit0,N3) )
                     => ! [M5: num] :
                          ( ( Xa = aa(num,num,bit0,M5) )
                         => ( ( Y = bitM(bit_or_not_num_neg(N3,M5)) )
                           => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,N3)),aa(num,num,bit0,M5))) ) ) )
                 => ( ! [N3: num] :
                        ( ( X = aa(num,num,bit0,N3) )
                       => ! [M5: num] :
                            ( ( Xa = aa(num,num,bit1,M5) )
                           => ( ( Y = aa(num,num,bit0,bit_or_not_num_neg(N3,M5)) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,N3)),aa(num,num,bit1,M5))) ) ) )
                   => ( ! [N3: num] :
                          ( ( X = aa(num,num,bit1,N3) )
                         => ( ( Xa = one2 )
                           => ( ( Y = one2 )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,N3)),one2)) ) ) )
                     => ( ! [N3: num] :
                            ( ( X = aa(num,num,bit1,N3) )
                           => ! [M5: num] :
                                ( ( Xa = aa(num,num,bit0,M5) )
                               => ( ( Y = bitM(bit_or_not_num_neg(N3,M5)) )
                                 => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,N3)),aa(num,num,bit0,M5))) ) ) )
                       => ~ ! [N3: num] :
                              ( ( X = aa(num,num,bit1,N3) )
                             => ! [M5: num] :
                                  ( ( Xa = aa(num,num,bit1,M5) )
                                 => ( ( Y = bitM(bit_or_not_num_neg(N3,M5)) )
                                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_or3848514188828904588eg_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,N3)),aa(num,num,bit1,M5))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
tff(fact_5601_and__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( bit_un7362597486090784418nd_num(X,Xa) = Y )
     => ( aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X),Xa))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = aa(num,option(num),some(num),one2) )
               => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2)) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa = aa(num,num,bit0,N3) )
                 => ( ( Y = none(num) )
                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N3))) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa = aa(num,num,bit1,N3) )
                   => ( ( Y = aa(num,option(num),some(num),one2) )
                     => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N3))) ) ) )
             => ( ! [M5: num] :
                    ( ( X = aa(num,num,bit0,M5) )
                   => ( ( Xa = one2 )
                     => ( ( Y = none(num) )
                       => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),one2)) ) ) )
               => ( ! [M5: num] :
                      ( ( X = aa(num,num,bit0,M5) )
                     => ! [N3: num] :
                          ( ( Xa = aa(num,num,bit0,N3) )
                         => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M5,N3)) )
                           => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit0,N3))) ) ) )
                 => ( ! [M5: num] :
                        ( ( X = aa(num,num,bit0,M5) )
                       => ! [N3: num] :
                            ( ( Xa = aa(num,num,bit1,N3) )
                           => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M5,N3)) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit1,N3))) ) ) )
                   => ( ! [M5: num] :
                          ( ( X = aa(num,num,bit1,M5) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,option(num),some(num),one2) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),one2)) ) ) )
                     => ( ! [M5: num] :
                            ( ( X = aa(num,num,bit1,M5) )
                           => ! [N3: num] :
                                ( ( Xa = aa(num,num,bit0,N3) )
                               => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un7362597486090784418nd_num(M5,N3)) )
                                 => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit0,N3))) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X = aa(num,num,bit1,M5) )
                             => ! [N3: num] :
                                  ( ( Xa = aa(num,num,bit1,N3) )
                                 => ( ( Y = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_wr(num,option(num)),bit_un7362597486090784418nd_num(M5,N3)) )
                                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4731106466462545111um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit1,N3))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
tff(fact_5602_and__not__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( bit_and_not_num(X,Xa) = Y )
     => ( aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X),Xa))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = none(num) )
               => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2)) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa = aa(num,num,bit0,N3) )
                 => ( ( Y = aa(num,option(num),some(num),one2) )
                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N3))) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa = aa(num,num,bit1,N3) )
                   => ( ( Y = none(num) )
                     => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N3))) ) ) )
             => ( ! [M5: num] :
                    ( ( X = aa(num,num,bit0,M5) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,M5)) )
                       => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),one2)) ) ) )
               => ( ! [M5: num] :
                      ( ( X = aa(num,num,bit0,M5) )
                     => ! [N3: num] :
                          ( ( Xa = aa(num,num,bit0,N3) )
                         => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M5,N3)) )
                           => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit0,N3))) ) ) )
                 => ( ! [M5: num] :
                        ( ( X = aa(num,num,bit0,M5) )
                       => ! [N3: num] :
                            ( ( Xa = aa(num,num,bit1,N3) )
                           => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M5,N3)) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit1,N3))) ) ) )
                   => ( ! [M5: num] :
                          ( ( X = aa(num,num,bit1,M5) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,M5)) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),one2)) ) ) )
                     => ( ! [M5: num] :
                            ( ( X = aa(num,num,bit1,M5) )
                           => ! [N3: num] :
                                ( ( Xa = aa(num,num,bit0,N3) )
                               => ( ( Y = case_option(option(num),num,aa(num,option(num),some(num),one2),aTP_Lamp_wr(num,option(num)),bit_and_not_num(M5,N3)) )
                                 => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit0,N3))) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X = aa(num,num,bit1,M5) )
                             => ! [N3: num] :
                                  ( ( Xa = aa(num,num,bit1,N3) )
                                 => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_and_not_num(M5,N3)) )
                                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_and_not_num_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit1,N3))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
tff(fact_5603_xor__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option(num)] :
      ( ( bit_un2480387367778600638or_num(X,Xa) = Y )
     => ( aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X),Xa))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = none(num) )
               => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2)) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa = aa(num,num,bit0,N3) )
                 => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit1,N3)) )
                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N3))) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa = aa(num,num,bit1,N3) )
                   => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,N3)) )
                     => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N3))) ) ) )
             => ( ! [M5: num] :
                    ( ( X = aa(num,num,bit0,M5) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit1,M5)) )
                       => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),one2)) ) ) )
               => ( ! [M5: num] :
                      ( ( X = aa(num,num,bit0,M5) )
                     => ! [N3: num] :
                          ( ( Xa = aa(num,num,bit0,N3) )
                         => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un2480387367778600638or_num(M5,N3)) )
                           => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit0,N3))) ) ) )
                 => ( ! [M5: num] :
                        ( ( X = aa(num,num,bit0,M5) )
                       => ! [N3: num] :
                            ( ( Xa = aa(num,num,bit1,N3) )
                           => ( ( Y = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_un2480387367778600638or_num(M5,N3))) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit1,N3))) ) ) )
                   => ( ! [M5: num] :
                          ( ( X = aa(num,num,bit1,M5) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,option(num),some(num),aa(num,num,bit0,M5)) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),one2)) ) ) )
                     => ( ! [M5: num] :
                            ( ( X = aa(num,num,bit1,M5) )
                           => ! [N3: num] :
                                ( ( Xa = aa(num,num,bit0,N3) )
                               => ( ( Y = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_un2480387367778600638or_num(M5,N3))) )
                                 => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit0,N3))) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X = aa(num,num,bit1,M5) )
                             => ! [N3: num] :
                                  ( ( Xa = aa(num,num,bit1,N3) )
                                 => ( ( Y = aa(option(num),option(num),map_option(num,num,bit0),bit_un2480387367778600638or_num(M5,N3)) )
                                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un2901131394128224187um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit1,N3))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.pelims
tff(fact_5604_or__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( bit_un6697907153464112080or_num(X,Xa) = Y )
     => ( aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),X),Xa))
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = one2 )
               => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),one2)) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa = aa(num,num,bit0,N3) )
                 => ( ( Y = aa(num,num,bit1,N3) )
                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit0,N3))) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa = aa(num,num,bit1,N3) )
                   => ( ( Y = aa(num,num,bit1,N3) )
                     => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),one2),aa(num,num,bit1,N3))) ) ) )
             => ( ! [M5: num] :
                    ( ( X = aa(num,num,bit0,M5) )
                   => ( ( Xa = one2 )
                     => ( ( Y = aa(num,num,bit1,M5) )
                       => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),one2)) ) ) )
               => ( ! [M5: num] :
                      ( ( X = aa(num,num,bit0,M5) )
                     => ! [N3: num] :
                          ( ( Xa = aa(num,num,bit0,N3) )
                         => ( ( Y = aa(num,num,bit0,bit_un6697907153464112080or_num(M5,N3)) )
                           => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit0,N3))) ) ) )
                 => ( ! [M5: num] :
                        ( ( X = aa(num,num,bit0,M5) )
                       => ! [N3: num] :
                            ( ( Xa = aa(num,num,bit1,N3) )
                           => ( ( Y = aa(num,num,bit1,bit_un6697907153464112080or_num(M5,N3)) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit0,M5)),aa(num,num,bit1,N3))) ) ) )
                   => ( ! [M5: num] :
                          ( ( X = aa(num,num,bit1,M5) )
                         => ( ( Xa = one2 )
                           => ( ( Y = aa(num,num,bit1,M5) )
                             => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),one2)) ) ) )
                     => ( ! [M5: num] :
                            ( ( X = aa(num,num,bit1,M5) )
                           => ! [N3: num] :
                                ( ( Xa = aa(num,num,bit0,N3) )
                               => ( ( Y = aa(num,num,bit1,bit_un6697907153464112080or_num(M5,N3)) )
                                 => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit0,N3))) ) ) )
                       => ~ ! [M5: num] :
                              ( ( X = aa(num,num,bit1,M5) )
                             => ! [N3: num] :
                                  ( ( Xa = aa(num,num,bit1,N3) )
                                 => ( ( Y = aa(num,num,bit1,bit_un6697907153464112080or_num(M5,N3)) )
                                   => ~ aa(product_prod(num,num),$o,accp(product_prod(num,num),bit_un4773296044027857193um_rel),aa(num,product_prod(num,num),aa(num,fun(num,product_prod(num,num)),product_Pair(num,num),aa(num,num,bit1,M5)),aa(num,num,bit1,N3))) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_num.pelims
tff(fact_5605_take__bit__num__code,axiom,
    ! [N: nat,M4: num] : ( bit_take_bit_num(N,M4) = aa(product_prod(nat,num),option(num),aa(fun(nat,fun(num,option(num))),fun(product_prod(nat,num),option(num)),product_case_prod(nat,num,option(num)),aTP_Lamp_ww(nat,fun(num,option(num)))),aa(num,product_prod(nat,num),aa(nat,fun(num,product_prod(nat,num)),product_Pair(nat,num),N),M4)) ) ).

% take_bit_num_code
tff(fact_5606_multiset_Opred__map,axiom,
    ! [B: $tType,C: $tType,Qa: fun(B,$o),Fa: fun(C,B),X: multiset(C)] :
      ( pred_mset(B,Qa,aa(multiset(C),multiset(B),image_mset(C,B,Fa),X))
    <=> pred_mset(C,aa(fun(C,B),fun(C,$o),aa(fun(B,$o),fun(fun(C,B),fun(C,$o)),comp(B,$o,C),Qa),Fa),X) ) ).

% multiset.pred_map
tff(fact_5607_prod__mset_Ocomm__monoid__mset__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => comm_monoid_mset(B,times_times(B),one_one(B)) ) ).

% prod_mset.comm_monoid_mset_axioms
tff(fact_5608_ac__operator_Osafe__commute,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),X: B,Y: B,A3: B,Ba: B] :
      ( syntax_ac_operator(B,Fa)
     => ( syntax7388354845996824322omatch(B,B,aa(B,B,aa(B,fun(B,B),Fa,X),Y),A3)
       => ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = aa(B,B,aa(B,fun(B,B),Fa,Ba),A3) ) ) ) ).

% ac_operator.safe_commute
tff(fact_5609_mult_Oac__operator__axioms,axiom,
    ! [B: $tType] :
      ( ab_semigroup_mult(B)
     => syntax_ac_operator(B,times_times(B)) ) ).

% mult.ac_operator_axioms
tff(fact_5610_ac__operator__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( syntax_ac_operator(B,Fa)
    <=> ( ! [A6: B,B5: B,C5: B] : ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,A6),B5)),C5) = aa(B,B,aa(B,fun(B,B),Fa,A6),aa(B,B,aa(B,fun(B,B),Fa,B5),C5)) )
        & ! [A6: B,B5: B] : ( aa(B,B,aa(B,fun(B,B),Fa,A6),B5) = aa(B,B,aa(B,fun(B,B),Fa,B5),A6) ) ) ) ).

% ac_operator_def
tff(fact_5611_ac__operator_Oright__commute,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A3: B,Ba: B,C2: B] :
      ( syntax_ac_operator(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,A3),C2)),Ba) ) ) ).

% ac_operator.right_commute
tff(fact_5612_ac__operator_Oleft__commute,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A3: B,Ba: B,C2: B] :
      ( syntax_ac_operator(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,A3),aa(B,B,aa(B,fun(B,B),Fa,Ba),C2)) = aa(B,B,aa(B,fun(B,B),Fa,Ba),aa(B,B,aa(B,fun(B,B),Fa,A3),C2)) ) ) ).

% ac_operator.left_commute
tff(fact_5613_ac__operator_Oright__assoc,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A3: B,Ba: B,C2: B] :
      ( syntax_ac_operator(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),C2) = aa(B,B,aa(B,fun(B,B),Fa,A3),aa(B,B,aa(B,fun(B,B),Fa,Ba),C2)) ) ) ).

% ac_operator.right_assoc
tff(fact_5614_ac__operator_Oleft__assoc,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A3: B,Ba: B,C2: B] :
      ( syntax_ac_operator(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,A3),aa(B,B,aa(B,fun(B,B),Fa,Ba),C2)) = aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,A3),Ba)),C2) ) ) ).

% ac_operator.left_assoc
tff(fact_5615_ac__operator_Ocommute,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),A3: B,Ba: B] :
      ( syntax_ac_operator(B,Fa)
     => ( aa(B,B,aa(B,fun(B,B),Fa,A3),Ba) = aa(B,B,aa(B,fun(B,B),Fa,Ba),A3) ) ) ).

% ac_operator.commute
tff(fact_5616_ac__operator_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B))] :
      ( ! [A8: B,B4: B,C4: B] : ( aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,A8),B4)),C4) = aa(B,B,aa(B,fun(B,B),Fa,A8),aa(B,B,aa(B,fun(B,B),Fa,B4),C4)) )
     => ( ! [A8: B,B4: B] : ( aa(B,B,aa(B,fun(B,B),Fa,A8),B4) = aa(B,B,aa(B,fun(B,B),Fa,B4),A8) )
       => syntax_ac_operator(B,Fa) ) ) ).

% ac_operator.intro
tff(fact_5617_add_Oac__operator__axioms,axiom,
    ! [B: $tType] :
      ( ab_semigroup_add(B)
     => syntax_ac_operator(B,plus_plus(B)) ) ).

% add.ac_operator_axioms
tff(fact_5618_successively_Opelims_I2_J,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B)] :
      ( successively(B,X,Xa)
     => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),successively_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),Xa))
       => ( ( ( Xa = nil(B) )
           => ~ aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),successively_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),nil(B))) )
         => ( ! [X2: B] :
                ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)) )
               => ~ aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),successively_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)))) )
           => ~ ! [X2: B,Y2: B,Xs3: list(B)] :
                  ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs3)) )
                 => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),successively_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs3))))
                   => ~ ( aa(B,$o,aa(B,fun(B,$o),X,X2),Y2)
                        & successively(B,X,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs3)) ) ) ) ) ) ) ) ).

% successively.pelims(2)
tff(fact_5619_successively_Opelims_I1_J,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B),Y: $o] :
      ( ( successively(B,X,Xa)
      <=> (Y) )
     => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),successively_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),Xa))
       => ( ( ( Xa = nil(B) )
           => ( (Y)
             => ~ aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),successively_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),nil(B))) ) )
         => ( ! [X2: B] :
                ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)) )
               => ( (Y)
                 => ~ aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),successively_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),nil(B)))) ) )
           => ~ ! [X2: B,Y2: B,Xs3: list(B)] :
                  ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs3)) )
                 => ( ( (Y)
                    <=> ( aa(B,$o,aa(B,fun(B,$o),X,X2),Y2)
                        & successively(B,X,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs3)) ) )
                   => ~ aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),successively_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs3)))) ) ) ) ) ) ) ).

% successively.pelims(1)
tff(fact_5620_bot__in__iterates,axiom,
    ! [B: $tType] :
      ( comple9053668089753744459l_ccpo(B)
     => ! [Fa: fun(B,B)] : member(B,aa(set(B),B,complete_Sup_Sup(B),bot_bot(set(B))),comple6359979572994053840erates(B,Fa)) ) ).

% bot_in_iterates
tff(fact_5621_successively_Opelims_I3_J,axiom,
    ! [B: $tType,X: fun(B,fun(B,$o)),Xa: list(B)] :
      ( ~ successively(B,X,Xa)
     => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),successively_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),Xa))
       => ~ ! [X2: B,Y2: B,Xs3: list(B)] :
              ( ( Xa = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs3)) )
             => ( aa(product_prod(fun(B,fun(B,$o)),list(B)),$o,accp(product_prod(fun(B,fun(B,$o)),list(B)),successively_rel(B)),aa(list(B),product_prod(fun(B,fun(B,$o)),list(B)),aa(fun(B,fun(B,$o)),fun(list(B),product_prod(fun(B,fun(B,$o)),list(B))),product_Pair(fun(B,fun(B,$o)),list(B)),X),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs3))))
               => ( aa(B,$o,aa(B,fun(B,$o),X,X2),Y2)
                  & successively(B,X,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y2),Xs3)) ) ) ) ) ) ).

% successively.pelims(3)
tff(fact_5622_sym__Int__converse,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] : sym(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),converse(B,B,R3))) ).

% sym_Int_converse
tff(fact_5623_comp__fun__idem__on__axioms__def,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C))] :
      ( finite4980608107308702382axioms(B,C,S2,Fa)
    <=> ! [X4: B] :
          ( member(B,X4,S2)
         => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X4)),aa(B,fun(C,C),Fa,X4)) = aa(B,fun(C,C),Fa,X4) ) ) ) ).

% comp_fun_idem_on_axioms_def
tff(fact_5624_folding__idem__on__axioms__def,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C))] :
      ( finite6916993218817215295axioms(B,C,S2,Fa)
    <=> ! [X4: B,Y3: B] :
          ( member(B,X4,S2)
         => ( member(B,Y3,S2)
           => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X4)),aa(B,fun(C,C),Fa,X4)) = aa(B,fun(C,C),Fa,X4) ) ) ) ) ).

% folding_idem_on_axioms_def
tff(fact_5625_symD,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Ba: B,A3: B] :
      ( sym(B,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),A3),R3)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3) ) ) ).

% symD
tff(fact_5626_symE,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),Ba: B,A3: B] :
      ( sym(B,R3)
     => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Ba),A3),R3)
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A3),Ba),R3) ) ) ).

% symE
tff(fact_5627_symI,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( ! [A8: B,B4: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A8),B4),R3)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B4),A8),R3) )
     => sym(B,R3) ) ).

% symI
tff(fact_5628_sym__def,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( sym(B,R3)
    <=> ! [X4: B,Y3: B] :
          ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Y3),R3)
         => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Y3),X4),R3) ) ) ).

% sym_def
tff(fact_5629_sym__Int,axiom,
    ! [B: $tType,R3: set(product_prod(B,B)),S: set(product_prod(B,B))] :
      ( sym(B,R3)
     => ( sym(B,S)
       => sym(B,aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),inf_inf(set(product_prod(B,B))),R3),S)) ) ) ).

% sym_Int
tff(fact_5630_folding__idem__on__axioms_Ointro,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C))] :
      ( ! [X2: B,Y2: B] :
          ( member(B,X2,S2)
         => ( member(B,Y2,S2)
           => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,X2)) = aa(B,fun(C,C),Fa,X2) ) ) )
     => finite6916993218817215295axioms(B,C,S2,Fa) ) ).

% folding_idem_on_axioms.intro
tff(fact_5631_comp__fun__idem__on__axioms_Ointro,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C))] :
      ( ! [X2: B] :
          ( member(B,X2,S2)
         => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,X2)) = aa(B,fun(C,C),Fa,X2) ) )
     => finite4980608107308702382axioms(B,C,S2,Fa) ) ).

% comp_fun_idem_on_axioms.intro
tff(fact_5632_folding__idem__axioms_Ointro,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C))] :
      ( ! [X2: B] : ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,X2)) = aa(B,fun(C,C),Fa,X2) )
     => finite7837460588564673216axioms(B,C,Fa) ) ).

% folding_idem_axioms.intro
tff(fact_5633_comp__fun__idem__axioms_Ointro,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C))] :
      ( ! [X2: B] : ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,X2)) = aa(B,fun(C,C),Fa,X2) )
     => finite1981172056906289455axioms(B,C,Fa) ) ).

% comp_fun_idem_axioms.intro
tff(fact_5634_folding__idem__axioms__def,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C))] :
      ( finite7837460588564673216axioms(B,C,Fa)
    <=> ! [X4: B] : ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X4)),aa(B,fun(C,C),Fa,X4)) = aa(B,fun(C,C),Fa,X4) ) ) ).

% folding_idem_axioms_def
tff(fact_5635_comp__fun__idem__axioms__def,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C))] :
      ( finite1981172056906289455axioms(B,C,Fa)
    <=> ! [X4: B] : ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X4)),aa(B,fun(C,C),Fa,X4)) = aa(B,fun(C,C),Fa,X4) ) ) ).

% comp_fun_idem_axioms_def
tff(fact_5636_curry__conv,axiom,
    ! [B: $tType,C: $tType,D: $tType,Fa: fun(product_prod(C,D),B),A3: C,Ba: D] : ( product_curry(C,D,B,Fa,A3,Ba) = aa(product_prod(C,D),B,Fa,aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),A3),Ba)) ) ).

% curry_conv
tff(fact_5637_vimage__right__total__transfer,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,B2: fun(B,fun(C,$o)),A4: fun(D,fun(E,$o))] :
      ( bi_unique(B,C,B2)
     => ( right_total(D,E,A4)
       => aa(fun(fun(E,C),fun(set(C),set(E))),$o,aa(fun(fun(D,B),fun(set(B),set(D))),fun(fun(fun(E,C),fun(set(C),set(E))),$o),bNF_rel_fun(fun(D,B),fun(E,C),fun(set(B),set(D)),fun(set(C),set(E)),bNF_rel_fun(D,E,B,C,A4,B2),bNF_rel_fun(set(B),set(C),set(D),set(E),bNF_rel_set(B,C,B2),bNF_rel_set(D,E,A4))),aTP_Lamp_wx(fun(D,fun(E,$o)),fun(fun(D,B),fun(set(B),set(D))),A4)),vimage(E,C)) ) ) ).

% vimage_right_total_transfer
tff(fact_5638_uprod__def,axiom,
    ! [C: $tType,B: $tType,A4: set(set(old_node(B,C))),B2: set(set(old_node(B,C)))] : ( old_uprod(B,C,A4,B2) = aa(set(set(set(old_node(B,C)))),set(set(old_node(B,C))),complete_Sup_Sup(set(set(old_node(B,C)))),aa(set(set(old_node(B,C))),set(set(set(old_node(B,C)))),image2(set(old_node(B,C)),set(set(old_node(B,C))),aTP_Lamp_wz(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),B2)),A4)) ) ).

% uprod_def
tff(fact_5639_curryI,axiom,
    ! [B: $tType,C: $tType,Fa: fun(product_prod(B,C),$o),A3: B,Ba: C] :
      ( aa(product_prod(B,C),$o,Fa,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba))
     => product_curry(B,C,$o,Fa,A3,Ba) ) ).

% curryI
tff(fact_5640_curryD,axiom,
    ! [B: $tType,C: $tType,Fa: fun(product_prod(B,C),$o),A3: B,Ba: C] :
      ( product_curry(B,C,$o,Fa,A3,Ba)
     => aa(product_prod(B,C),$o,Fa,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba)) ) ).

% curryD
tff(fact_5641_curryE,axiom,
    ! [B: $tType,C: $tType,Fa: fun(product_prod(B,C),$o),A3: B,Ba: C] :
      ( product_curry(B,C,$o,Fa,A3,Ba)
     => aa(product_prod(B,C),$o,Fa,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A3),Ba)) ) ).

% curryE
tff(fact_5642_Heap_Obi__unique__rel,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] :
      ( bi_unique(B,C,R)
     => bi_unique(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R)) ) ).

% Heap.bi_unique_rel
tff(fact_5643_Heap_Oright__total__rel,axiom,
    ! [C: $tType,B: $tType,R: fun(B,fun(C,$o))] :
      ( right_total(B,C,R)
     => right_total(heap_Time_Heap(B),heap_Time_Heap(C),aa(fun(B,fun(C,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(C),$o)),heap_Time_rel_Heap(B,C),R)) ) ).

% Heap.right_total_rel
tff(fact_5644_inter__transfer,axiom,
    ! [B: $tType,C: $tType,A4: fun(B,fun(C,$o))] :
      ( bi_unique(B,C,A4)
     => aa(fun(set(C),fun(set(C),set(C))),$o,aa(fun(set(B),fun(set(B),set(B))),fun(fun(set(C),fun(set(C),set(C))),$o),bNF_rel_fun(set(B),set(C),fun(set(B),set(B)),fun(set(C),set(C)),bNF_rel_set(B,C,A4),bNF_rel_fun(set(B),set(C),set(B),set(C),bNF_rel_set(B,C,A4),bNF_rel_set(B,C,A4))),inf_inf(set(B))),inf_inf(set(C))) ) ).

% inter_transfer
tff(fact_5645_right__total__Inter__transfer,axiom,
    ! [B: $tType,C: $tType,A4: fun(B,fun(C,$o))] :
      ( bi_unique(B,C,A4)
     => ( right_total(B,C,A4)
       => aa(fun(set(set(C)),set(C)),$o,aa(fun(set(set(B)),set(B)),fun(fun(set(set(C)),set(C)),$o),bNF_rel_fun(set(set(B)),set(set(C)),set(B),set(C),bNF_rel_set(set(B),set(C),bNF_rel_set(B,C,A4)),bNF_rel_set(B,C,A4)),aTP_Lamp_xa(fun(B,fun(C,$o)),fun(set(set(B)),set(B)),A4)),complete_Inf_Inf(set(C))) ) ) ).

% right_total_Inter_transfer
tff(fact_5646_right__total__Compl__transfer,axiom,
    ! [B: $tType,C: $tType,A4: fun(B,fun(C,$o))] :
      ( bi_unique(B,C,A4)
     => ( right_total(B,C,A4)
       => aa(fun(set(C),set(C)),$o,aa(fun(set(B),set(B)),fun(fun(set(C),set(C)),$o),bNF_rel_fun(set(B),set(C),set(B),set(C),bNF_rel_set(B,C,A4),bNF_rel_set(B,C,A4)),aTP_Lamp_xb(fun(B,fun(C,$o)),fun(set(B),set(B)),A4)),uminus_uminus(set(C))) ) ) ).

% right_total_Compl_transfer
tff(fact_5647_curry__def,axiom,
    ! [D: $tType,B: $tType,C: $tType,X3: fun(product_prod(B,C),D),Xa3: B,Xb2: C] : ( product_curry(B,C,D,X3,Xa3,Xb2) = aa(product_prod(B,C),D,X3,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Xa3),Xb2)) ) ).

% curry_def
tff(fact_5648_Rats__eq__range__of__rat__o__nat__to__rat__surj,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ( field_char_0_Rats(B) = aa(set(nat),set(B),image2(nat,B,aa(fun(nat,rat),fun(nat,B),aa(fun(rat,B),fun(fun(nat,rat),fun(nat,B)),comp(rat,B,nat),field_char_0_of_rat(B)),nat_to_rat_surj)),top_top(set(nat))) ) ) ).

% Rats_eq_range_of_rat_o_nat_to_rat_surj
tff(fact_5649_symp__sym__eq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( symp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3))
    <=> sym(B,R3) ) ).

% symp_sym_eq
tff(fact_5650_remove__rev__def,axiom,
    ! [B: $tType,X: B] : ( remove_rev(B,X) = filter_rev(B,aa(fun(B,$o),fun(B,$o),aa(fun($o,$o),fun(fun(B,$o),fun(B,$o)),comp($o,$o,B),fNot),aa(B,fun(B,$o),fequal(B),X))) ) ).

% remove_rev_def
tff(fact_5651_symp__inf,axiom,
    ! [B: $tType,R3: fun(B,fun(B,$o)),S: fun(B,fun(B,$o))] :
      ( symp(B,R3)
     => ( symp(B,S)
       => symp(B,aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),inf_inf(fun(B,fun(B,$o))),R3),S)) ) ) ).

% symp_inf
tff(fact_5652_Heap_Orel__symp,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o))] :
      ( symp(B,R)
     => symp(heap_Time_Heap(B),aa(fun(B,fun(B,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(B,B),R)) ) ).

% Heap.rel_symp
tff(fact_5653_Rats__mult,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [A3: B,Ba: B] :
          ( member(B,A3,field_char_0_Rats(B))
         => ( member(B,Ba,field_char_0_Rats(B))
           => member(B,aa(B,B,aa(B,fun(B,B),times_times(B),A3),Ba),field_char_0_Rats(B)) ) ) ) ).

% Rats_mult
tff(fact_5654_Rats__1,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => member(B,one_one(B),field_char_0_Rats(B)) ) ).

% Rats_1
tff(fact_5655_comm__monoid__set_OatLeastAtMost__shift__0,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,M4: nat,N: nat,Ga: fun(nat,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M4),N)
       => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),Ga),set_or1337092689740270186AtMost(nat,M4,N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ) ).

% comm_monoid_set.atLeastAtMost_shift_0
tff(fact_5656_comm__monoid__mult__class_Oprod__def,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ( groups7121269368397514597t_prod(B,C) = groups_comm_monoid_F(C,B,times_times(C),one_one(C)) ) ) ).

% comm_monoid_mult_class.prod_def
tff(fact_5657_eventually__prod__sequentially,axiom,
    ! [Pa: fun(product_prod(nat,nat),$o)] :
      ( eventually(product_prod(nat,nat),Pa,prod_filter(nat,nat,at_top(nat),at_top(nat)))
    <=> ? [N8: nat] :
        ! [M3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),M3)
         => ! [N5: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N5)
             => aa(product_prod(nat,nat),$o,Pa,aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),N5),M3)) ) ) ) ).

% eventually_prod_sequentially
tff(fact_5658_trivial__limit__sequentially,axiom,
    at_top(nat) != bot_bot(filter(nat)) ).

% trivial_limit_sequentially
tff(fact_5659_comm__monoid__set_Oreindex__nontrivial,axiom,
    ! [D: $tType,B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),H2: fun(C,D),Ga: fun(D,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( ! [X2: C,Y2: C] :
              ( member(C,X2,A4)
             => ( member(C,Y2,A4)
               => ( ( X2 != Y2 )
                 => ( ( aa(C,D,H2,X2) = aa(C,D,H2,Y2) )
                   => ( aa(D,B,Ga,aa(C,D,H2,X2)) = Z2 ) ) ) ) )
         => ( aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,Fa,Z2),Ga),aa(set(C),set(D),image2(C,D,H2),A4)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),aa(fun(C,D),fun(C,B),aa(fun(D,B),fun(fun(C,D),fun(C,B)),comp(D,B,C),Ga),H2)),A4) ) ) ) ) ).

% comm_monoid_set.reindex_nontrivial
tff(fact_5660_comm__monoid__set_OUnion__comp,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,B2: set(set(C)),Ga: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( ! [X2: set(C)] :
            ( member(set(C),X2,B2)
           => aa(set(C),$o,finite_finite(C),X2) )
       => ( ! [A15: set(C)] :
              ( member(set(C),A15,B2)
             => ! [A24: set(C)] :
                  ( member(set(C),A24,B2)
                 => ( ( A15 != A24 )
                   => ! [X2: C] :
                        ( member(C,X2,A15)
                       => ( member(C,X2,A24)
                         => ( aa(C,B,Ga,X2) = Z2 ) ) ) ) ) )
         => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),B2)) = aa(set(set(C)),B,aa(fun(C,B),fun(set(set(C)),B),aa(fun(fun(C,B),fun(set(C),B)),fun(fun(C,B),fun(set(set(C)),B)),aa(fun(fun(set(C),B),fun(set(set(C)),B)),fun(fun(fun(C,B),fun(set(C),B)),fun(fun(C,B),fun(set(set(C)),B))),comp(fun(set(C),B),fun(set(set(C)),B),fun(C,B)),groups_comm_monoid_F(B,set(C),Fa,Z2)),groups_comm_monoid_F(B,C,Fa,Z2)),Ga),B2) ) ) ) ) ).

% comm_monoid_set.Union_comp
tff(fact_5661_comm__monoid__set_Oreindex,axiom,
    ! [D: $tType,B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,H2: fun(C,D),A4: set(C),Ga: fun(D,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( inj_on(C,D,H2,A4)
       => ( aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,Fa,Z2),Ga),aa(set(C),set(D),image2(C,D,H2),A4)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),aa(fun(C,D),fun(C,B),aa(fun(D,B),fun(fun(C,D),fun(C,B)),comp(D,B,C),Ga),H2)),A4) ) ) ) ).

% comm_monoid_set.reindex
tff(fact_5662_comm__monoid__set_OUnion__disjoint,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,C3: set(set(C)),Ga: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( ! [X2: set(C)] :
            ( member(set(C),X2,C3)
           => aa(set(C),$o,finite_finite(C),X2) )
       => ( ! [X2: set(C)] :
              ( member(set(C),X2,C3)
             => ! [Xa4: set(C)] :
                  ( member(set(C),Xa4,C3)
                 => ( ( X2 != Xa4 )
                   => ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),X2),Xa4) = bot_bot(set(C)) ) ) ) )
         => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),C3)) = aa(set(set(C)),B,aa(fun(C,B),fun(set(set(C)),B),aa(fun(fun(C,B),fun(set(C),B)),fun(fun(C,B),fun(set(set(C)),B)),aa(fun(fun(set(C),B),fun(set(set(C)),B)),fun(fun(fun(C,B),fun(set(C),B)),fun(fun(C,B),fun(set(set(C)),B))),comp(fun(set(C),B),fun(set(set(C)),B),fun(C,B)),groups_comm_monoid_F(B,set(C),Fa,Z2)),groups_comm_monoid_F(B,C,Fa,Z2)),Ga),C3) ) ) ) ) ).

% comm_monoid_set.Union_disjoint
tff(fact_5663_comm__monoid__set_OPlus,axiom,
    ! [C: $tType,B: $tType,D: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),B2: set(D),Ga: fun(sum_sum(C,D),B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( aa(set(D),$o,finite_finite(D),B2)
         => ( aa(set(sum_sum(C,D)),B,aa(fun(sum_sum(C,D),B),fun(set(sum_sum(C,D)),B),groups_comm_monoid_F(B,sum_sum(C,D),Fa,Z2),Ga),sum_Plus(C,D,A4,B2)) = aa(B,B,aa(B,fun(B,B),Fa,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),aa(fun(C,sum_sum(C,D)),fun(C,B),aa(fun(sum_sum(C,D),B),fun(fun(C,sum_sum(C,D)),fun(C,B)),comp(sum_sum(C,D),B,C),Ga),sum_Inl(C,D))),A4)),aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,Fa,Z2),aa(fun(D,sum_sum(C,D)),fun(D,B),aa(fun(sum_sum(C,D),B),fun(fun(D,sum_sum(C,D)),fun(D,B)),comp(sum_sum(C,D),B,D),Ga),sum_Inr(D,C))),B2)) ) ) ) ) ).

% comm_monoid_set.Plus
tff(fact_5664_comm__monoid__set_OatLeastLessThan__reindex,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [Fa: fun(B,fun(B,B)),Z2: B,H2: fun(nat,C),M4: nat,N: nat,Ga: fun(C,B)] :
          ( groups778175481326437816id_set(B,Fa,Z2)
         => ( bij_betw(nat,C,H2,set_or7035219750837199246ssThan(nat,M4,N),set_or7035219750837199246ssThan(C,aa(nat,C,H2,M4),aa(nat,C,H2,N)))
           => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),set_or7035219750837199246ssThan(C,aa(nat,C,H2,M4),aa(nat,C,H2,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,C),fun(nat,B),aa(fun(C,B),fun(fun(nat,C),fun(nat,B)),comp(C,B,nat),Ga),H2)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ) ) ).

% comm_monoid_set.atLeastLessThan_reindex
tff(fact_5665_comm__monoid__set_OatLeastAtMost__reindex,axiom,
    ! [C: $tType,B: $tType] :
      ( ord(C)
     => ! [Fa: fun(B,fun(B,B)),Z2: B,H2: fun(nat,C),M4: nat,N: nat,Ga: fun(C,B)] :
          ( groups778175481326437816id_set(B,Fa,Z2)
         => ( bij_betw(nat,C,H2,set_or1337092689740270186AtMost(nat,M4,N),set_or1337092689740270186AtMost(C,aa(nat,C,H2,M4),aa(nat,C,H2,N)))
           => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),set_or1337092689740270186AtMost(C,aa(nat,C,H2,M4),aa(nat,C,H2,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,C),fun(nat,B),aa(fun(C,B),fun(fun(nat,C),fun(nat,B)),comp(C,B,nat),Ga),H2)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ) ) ).

% comm_monoid_set.atLeastAtMost_reindex
tff(fact_5666_comm__monoid__set_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(nat,B),M4: nat,N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),Ga),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_Suc_atMost_Suc_shift
tff(fact_5667_comm__monoid__set_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(nat,B),M4: nat,N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),Ga),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_Suc_lessThan_Suc_shift
tff(fact_5668_comm__monoid__set_OatLeast__int__lessThan__int__shift,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(int,B),M4: nat,N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(int),B,aa(fun(int,B),fun(set(int),B),groups_comm_monoid_F(B,int,Fa,Z2),Ga),set_or7035219750837199246ssThan(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,int),fun(nat,B),aa(fun(int,B),fun(fun(nat,int),fun(nat,B)),comp(int,B,nat),Ga),semiring_1_of_nat(int))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_int_lessThan_int_shift
tff(fact_5669_comm__monoid__set_OatLeast__int__atMost__int__shift,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(int,B),M4: nat,N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(int),B,aa(fun(int,B),fun(set(int),B),groups_comm_monoid_F(B,int,Fa,Z2),Ga),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),M4),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,int),fun(nat,B),aa(fun(int,B),fun(fun(nat,int),fun(nat,B)),comp(int,B,nat),Ga),semiring_1_of_nat(int))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_int_atMost_int_shift
tff(fact_5670_comm__monoid__set_Oeq__fold,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(C,B),A4: set(C)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),A4) = finite_fold(C,B,aa(fun(C,B),fun(C,fun(B,B)),aa(fun(B,fun(B,B)),fun(fun(C,B),fun(C,fun(B,B))),comp(B,fun(B,B),C),Fa),Ga),Z2,A4) ) ) ).

% comm_monoid_set.eq_fold
tff(fact_5671_comm__monoid__set_OatLeastAtMost__shift__bounds,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(nat,B),M4: nat,K: nat,N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),Ga),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeastAtMost_shift_bounds
tff(fact_5672_comm__monoid__set_OatLeastLessThan__shift__bounds,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(nat,B),M4: nat,K: nat,N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),Ga),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M4),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeastLessThan_shift_bounds
tff(fact_5673_comm__monoid__set_OatLeast0__atMost__Suc__shift,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(nat,B),N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),Ga),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),Fa,aa(nat,B,Ga,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% comm_monoid_set.atLeast0_atMost_Suc_shift
tff(fact_5674_comm__monoid__set_OatLeast0__lessThan__Suc__shift,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(nat,B),N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),Ga),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(B,B,aa(B,fun(B,B),Fa,aa(nat,B,Ga,zero_zero(nat))),aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% comm_monoid_set.atLeast0_lessThan_Suc_shift
tff(fact_5675_comm__monoid__set_Ounion__inter,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),B2: set(C),Ga: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( aa(set(C),$o,finite_finite(C),B2)
         => ( aa(B,B,aa(B,fun(B,B),Fa,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A4),B2))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),B2))) = aa(B,B,aa(B,fun(B,B),Fa,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),A4)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),B2)) ) ) ) ) ).

% comm_monoid_set.union_inter
tff(fact_5676_comm__monoid__set_Ounion__inter__neutral,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),B2: set(C),Ga: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( aa(set(C),$o,finite_finite(C),B2)
         => ( ! [X2: C] :
                ( member(C,X2,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),B2))
               => ( aa(C,B,Ga,X2) = Z2 ) )
           => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A4),B2)) = aa(B,B,aa(B,fun(B,B),Fa,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),A4)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),B2)) ) ) ) ) ) ).

% comm_monoid_set.union_inter_neutral
tff(fact_5677_comm__monoid__set_Ounion__diff2,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),B2: set(C),Ga: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( aa(set(C),$o,finite_finite(C),B2)
         => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A4),B2)) = aa(B,B,aa(B,fun(B,B),Fa,aa(B,B,aa(B,fun(B,B),Fa,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A4),B2))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),B2),A4)))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),B2))) ) ) ) ) ).

% comm_monoid_set.union_diff2
tff(fact_5678_prod_Ocomm__monoid__set__axioms,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => groups778175481326437816id_set(B,times_times(B),one_one(B)) ) ).

% prod.comm_monoid_set_axioms
tff(fact_5679_comm__monoid__set_OIf__cases,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),Pa: fun(C,$o),H2: fun(C,B),Ga: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_ao(fun(C,$o),fun(fun(C,B),fun(fun(C,B),fun(C,B))),Pa),H2),Ga)),A4) = aa(B,B,aa(B,fun(B,B),Fa,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),H2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),aa(fun(C,$o),set(C),collect(C),Pa)))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),aa(set(C),set(C),uminus_uminus(set(C)),aa(fun(C,$o),set(C),collect(C),Pa))))) ) ) ) ).

% comm_monoid_set.If_cases
tff(fact_5680_comm__monoid__set_Ointer__restrict,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),Ga: fun(C,B),B2: set(C)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),B2)) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),aa(set(C),fun(C,B),aa(fun(C,B),fun(set(C),fun(C,B)),aTP_Lamp_xc(B,fun(fun(C,B),fun(set(C),fun(C,B))),Z2),Ga),B2)),A4) ) ) ) ).

% comm_monoid_set.inter_restrict
tff(fact_5681_comm__monoid__set_OInt__Diff,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),Ga: fun(C,B),B2: set(C)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),A4) = aa(B,B,aa(B,fun(B,B),Fa,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),B2))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A4),B2))) ) ) ) ).

% comm_monoid_set.Int_Diff
tff(fact_5682_comm__monoid__set_Omono__neutral__cong,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,T3: set(C),S2: set(C),H2: fun(C,B),Ga: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),T3)
       => ( aa(set(C),$o,finite_finite(C),S2)
         => ( ! [I3: C] :
                ( member(C,I3,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),T3),S2))
               => ( aa(C,B,H2,I3) = Z2 ) )
           => ( ! [I3: C] :
                  ( member(C,I3,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),S2),T3))
                 => ( aa(C,B,Ga,I3) = Z2 ) )
             => ( ! [X2: C] :
                    ( member(C,X2,aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),S2),T3))
                   => ( aa(C,B,Ga,X2) = aa(C,B,H2,X2) ) )
               => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),S2) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),H2),T3) ) ) ) ) ) ) ) ).

% comm_monoid_set.mono_neutral_cong
tff(fact_5683_comm__monoid__set_Oremove,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),X: C,Ga: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( member(C,X,A4)
         => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),A4) = aa(B,B,aa(B,fun(B,B),Fa,aa(C,B,Ga,X)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A4),aa(set(C),set(C),insert2(C,X),bot_bot(set(C)))))) ) ) ) ) ).

% comm_monoid_set.remove
tff(fact_5684_comm__monoid__set_Oinsert__remove,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),Ga: fun(C,B),X: C] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),insert2(C,X),A4)) = aa(B,B,aa(B,fun(B,B),Fa,aa(C,B,Ga,X)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),A4),aa(set(C),set(C),insert2(C,X),bot_bot(set(C)))))) ) ) ) ).

% comm_monoid_set.insert_remove
tff(fact_5685_comm__monoid__set_Oempty,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),bot_bot(set(C))) = Z2 ) ) ).

% comm_monoid_set.empty
tff(fact_5686_comm__monoid__set_Odelta__remove,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,S2: set(C),A3: C,Ba: fun(C,B),C2: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),S2)
       => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_xd(C,fun(fun(C,B),fun(fun(C,B),fun(C,B))),A3),Ba),C2)),S2)
          = $ite(member(C,A3,S2),aa(B,B,aa(B,fun(B,B),Fa,aa(C,B,Ba,A3)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),C2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),S2),aa(set(C),set(C),insert2(C,A3),bot_bot(set(C)))))),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),C2),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),minus_minus(set(C)),S2),aa(set(C),set(C),insert2(C,A3),bot_bot(set(C)))))) ) ) ) ).

% comm_monoid_set.delta_remove
tff(fact_5687_filtermap__sequentually__ne__bot,axiom,
    ! [B: $tType,Fa: fun(nat,B)] : ( filtermap(nat,B,Fa,at_top(nat)) != bot_bot(filter(B)) ) ).

% filtermap_sequentually_ne_bot
tff(fact_5688_trivial__limit__at__top__linorder,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( at_top(B) != bot_bot(filter(B)) ) ) ).

% trivial_limit_at_top_linorder
tff(fact_5689_comm__monoid__set_Ounion__disjoint,axiom,
    ! [B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(C),B2: set(C),Ga: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),A4)
       => ( aa(set(C),$o,finite_finite(C),B2)
         => ( ( aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),A4),B2) = bot_bot(set(C)) )
           => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),sup_sup(set(C)),A4),B2)) = aa(B,B,aa(B,fun(B,B),Fa,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),A4)),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),Ga),B2)) ) ) ) ) ) ).

% comm_monoid_set.union_disjoint
tff(fact_5690_comm__monoid__set_Oempty_H,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(B,B)),Z2: B,P2: fun(C,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_G(B,C,Fa,Z2),P2),bot_bot(set(C))) = Z2 ) ) ).

% comm_monoid_set.empty'
tff(fact_5691_comm__monoid__set_OatLeastLessThan__shift__0,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(nat,B),M4: nat,N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),Ga),set_or7035219750837199246ssThan(nat,M4,N)) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aa(nat,fun(nat,nat),plus_plus(nat),M4))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M4))) ) ) ).

% comm_monoid_set.atLeastLessThan_shift_0
tff(fact_5692_comm__monoid__set_OUNION__disjoint,axiom,
    ! [D: $tType,B: $tType,C: $tType,Fa: fun(B,fun(B,B)),Z2: B,I4: set(C),A4: fun(C,set(D)),Ga: fun(D,B)] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(C),$o,finite_finite(C),I4)
       => ( ! [X2: C] :
              ( member(C,X2,I4)
             => aa(set(D),$o,finite_finite(D),aa(C,set(D),A4,X2)) )
         => ( ! [X2: C] :
                ( member(C,X2,I4)
               => ! [Xa4: C] :
                    ( member(C,Xa4,I4)
                   => ( ( X2 != Xa4 )
                     => ( aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),inf_inf(set(D)),aa(C,set(D),A4,X2)),aa(C,set(D),A4,Xa4)) = bot_bot(set(D)) ) ) ) )
           => ( aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,Fa,Z2),Ga),aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),A4),I4))) = aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups_comm_monoid_F(B,C,Fa,Z2),aa(fun(D,B),fun(C,B),aa(fun(C,set(D)),fun(fun(D,B),fun(C,B)),aa(B,fun(fun(C,set(D)),fun(fun(D,B),fun(C,B))),aTP_Lamp_xe(fun(B,fun(B,B)),fun(B,fun(fun(C,set(D)),fun(fun(D,B),fun(C,B)))),Fa),Z2),A4),Ga)),I4) ) ) ) ) ) ).

% comm_monoid_set.UNION_disjoint
tff(fact_5693_comm__monoid__set_OatLeast__atMost__pred__shift,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(nat,B),M4: nat,N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aTP_Lamp_de(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),Ga),set_or1337092689740270186AtMost(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_atMost_pred_shift
tff(fact_5694_comm__monoid__set_OatLeast__lessThan__pred__shift,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,Ga: fun(nat,B),M4: nat,N: nat] :
      ( groups778175481326437816id_set(B,Fa,Z2)
     => ( aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),aa(fun(nat,nat),fun(nat,B),aa(fun(nat,B),fun(fun(nat,nat),fun(nat,B)),comp(nat,B,nat),Ga),aTP_Lamp_de(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M4),aa(nat,nat,suc,N))) = aa(set(nat),B,aa(fun(nat,B),fun(set(nat),B),groups_comm_monoid_F(B,nat,Fa,Z2),Ga),set_or7035219750837199246ssThan(nat,M4,N)) ) ) ).

% comm_monoid_set.atLeast_lessThan_pred_shift
tff(fact_5695_Nitpick_OEx1__unfold,axiom,
    ! [B: $tType,Pa: fun(B,$o)] :
      ( ? [X4: B] :
          ( aa(B,$o,Pa,X4)
          & ! [Y3: B] :
              ( aa(B,$o,Pa,Y3)
             => ( Y3 = X4 ) ) )
    <=> ? [X4: B] : ( aa(fun(B,$o),set(B),collect(B),Pa) = aa(set(B),set(B),insert2(B,X4),bot_bot(set(B))) ) ) ).

% Nitpick.Ex1_unfold
tff(fact_5696_num__of__integer_Otransfer,axiom,
    aa(fun(code_integer,num),$o,aa(fun(int,num),fun(fun(code_integer,num),$o),bNF_rel_fun(int,code_integer,num,num,code_pcr_integer,fequal(num)),aa(fun(int,nat),fun(int,num),aa(fun(nat,num),fun(fun(int,nat),fun(int,num)),comp(nat,num,int),num_of_nat),nat2)),code_num_of_integer) ).

% num_of_integer.transfer
tff(fact_5697_num__of__integer__def,axiom,
    code_num_of_integer = aa(fun(int,num),fun(code_integer,num),map_fun(code_integer,int,num,num,code_int_of_integer,id(num)),aa(fun(int,nat),fun(int,num),aa(fun(nat,num),fun(fun(int,nat),fun(int,num)),comp(nat,num,int),num_of_nat),nat2)) ).

% num_of_integer_def
tff(fact_5698_adm__wf__def,axiom,
    ! [C: $tType,B: $tType,R: set(product_prod(B,B)),F: fun(fun(B,C),fun(B,C))] :
      ( adm_wf(B,C,R,F)
    <=> ! [F10: fun(B,C),G4: fun(B,C),X4: B] :
          ( ! [Z4: B] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z4),X4),R)
             => ( aa(B,C,F10,Z4) = aa(B,C,G4,Z4) ) )
         => ( aa(B,C,aa(fun(B,C),fun(B,C),F,F10),X4) = aa(B,C,aa(fun(B,C),fun(B,C),F,G4),X4) ) ) ) ).

% adm_wf_def
tff(fact_5699_list_Opred__map,axiom,
    ! [B: $tType,C: $tType,Qa: fun(B,$o),Fa: fun(C,B),X: list(C)] :
      ( list_all(B,Qa,aa(list(C),list(B),map(C,B,Fa),X))
    <=> list_all(C,aa(fun(C,B),fun(C,$o),aa(fun(B,$o),fun(fun(C,B),fun(C,$o)),comp(B,$o,C),Qa),Fa),X) ) ).

% list.pred_map
tff(fact_5700_eventually__frequentlyE,axiom,
    ! [B: $tType,Pa: fun(B,$o),F: filter(B),Qa: fun(B,$o)] :
      ( eventually(B,Pa,F)
     => ( eventually(B,aa(fun(B,$o),fun(B,$o),aTP_Lamp_xf(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Pa),Qa),F)
       => ( ( F != bot_bot(filter(B)) )
         => frequently(B,Qa,F) ) ) ) ).

% eventually_frequentlyE
tff(fact_5701_frequently__const,axiom,
    ! [B: $tType,F: filter(B),Pa: $o] :
      ( ( F != bot_bot(filter(B)) )
     => ( frequently(B,aTP_Lamp_aj($o,fun(B,$o),Pa),F)
      <=> (Pa) ) ) ).

% frequently_const
tff(fact_5702_frequently__const__iff,axiom,
    ! [B: $tType,Pa: $o,F: filter(B)] :
      ( frequently(B,aTP_Lamp_aj($o,fun(B,$o),Pa),F)
    <=> ( (Pa)
        & ( F != bot_bot(filter(B)) ) ) ) ).

% frequently_const_iff
tff(fact_5703_eventually__frequently,axiom,
    ! [B: $tType,F: filter(B),Pa: fun(B,$o)] :
      ( ( F != bot_bot(filter(B)) )
     => ( eventually(B,Pa,F)
       => frequently(B,Pa,F) ) ) ).

% eventually_frequently
tff(fact_5704_folding__idem_Ocomp__fun__idem,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C)),X: B] :
      ( finite_folding_idem(B,C,Fa)
     => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X)),aa(B,fun(C,C),Fa,X)) = aa(B,fun(C,C),Fa,X) ) ) ).

% folding_idem.comp_fun_idem
tff(fact_5705_semilattice__neutr__set_Oremove,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(B),X: B] :
      ( lattic5652469242046573047tr_set(B,Fa,Z2)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( member(B,X,A4)
         => ( lattic5214292709420241887eutr_F(B,Fa,Z2,A4) = aa(B,B,aa(B,fun(B,B),Fa,X),lattic5214292709420241887eutr_F(B,Fa,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ) ).

% semilattice_neutr_set.remove
tff(fact_5706_semilattice__neutr__set_Oinsert__remove,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(B),X: B] :
      ( lattic5652469242046573047tr_set(B,Fa,Z2)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( lattic5214292709420241887eutr_F(B,Fa,Z2,aa(set(B),set(B),insert2(B,X),A4)) = aa(B,B,aa(B,fun(B,B),Fa,X),lattic5214292709420241887eutr_F(B,Fa,Z2,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A4),aa(set(B),set(B),insert2(B,X),bot_bot(set(B)))))) ) ) ) ).

% semilattice_neutr_set.insert_remove
tff(fact_5707_semilattice__neutr__set_Ointro,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( semilattice_neutr(B,Fa,Z2)
     => lattic5652469242046573047tr_set(B,Fa,Z2) ) ).

% semilattice_neutr_set.intro
tff(fact_5708_semilattice__neutr__set_Oaxioms,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( lattic5652469242046573047tr_set(B,Fa,Z2)
     => semilattice_neutr(B,Fa,Z2) ) ).

% semilattice_neutr_set.axioms
tff(fact_5709_semilattice__neutr__set__def,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( lattic5652469242046573047tr_set(B,Fa,Z2)
    <=> semilattice_neutr(B,Fa,Z2) ) ).

% semilattice_neutr_set_def
tff(fact_5710_semilattice__neutr__set_Oclosed,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B,A4: set(B)] :
      ( lattic5652469242046573047tr_set(B,Fa,Z2)
     => ( aa(set(B),$o,finite_finite(B),A4)
       => ( ( A4 != bot_bot(set(B)) )
         => ( ! [X2: B,Y2: B] : member(B,aa(B,B,aa(B,fun(B,B),Fa,X2),Y2),aa(set(B),set(B),insert2(B,X2),aa(set(B),set(B),insert2(B,Y2),bot_bot(set(B)))))
           => member(B,lattic5214292709420241887eutr_F(B,Fa,Z2,A4),A4) ) ) ) ) ).

% semilattice_neutr_set.closed
tff(fact_5711_semilattice__neutr__set_Oempty,axiom,
    ! [B: $tType,Fa: fun(B,fun(B,B)),Z2: B] :
      ( lattic5652469242046573047tr_set(B,Fa,Z2)
     => ( lattic5214292709420241887eutr_F(B,Fa,Z2,bot_bot(set(B))) = Z2 ) ) ).

% semilattice_neutr_set.empty
tff(fact_5712_transp__trans__eq,axiom,
    ! [B: $tType,R3: set(product_prod(B,B))] :
      ( transp(B,aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),R3))
    <=> trans(B,R3) ) ).

% transp_trans_eq
tff(fact_5713_folding__def,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C))] :
      ( finite_folding(B,C,Fa)
    <=> ! [Y3: B,X4: B] : ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y3)),aa(B,fun(C,C),Fa,X4)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X4)),aa(B,fun(C,C),Fa,Y3)) ) ) ).

% folding_def
tff(fact_5714_folding__idem__on_Ocomp__fun__idem__on,axiom,
    ! [C: $tType,B: $tType,S2: set(B),Fa: fun(B,fun(C,C)),X: B,Y: B] :
      ( finite1890593828518410140dem_on(B,C,S2,Fa)
     => ( member(B,X,S2)
       => ( member(B,Y,S2)
         => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X)),aa(B,fun(C,C),Fa,X)) = aa(B,fun(C,C),Fa,X) ) ) ) ) ).

% folding_idem_on.comp_fun_idem_on
tff(fact_5715_Heap_Orel__transp,axiom,
    ! [B: $tType,R: fun(B,fun(B,$o))] :
      ( transp(B,R)
     => transp(heap_Time_Heap(B),aa(fun(B,fun(B,$o)),fun(heap_Time_Heap(B),fun(heap_Time_Heap(B),$o)),heap_Time_rel_Heap(B,B),R)) ) ).

% Heap.rel_transp
tff(fact_5716_transp__inf,axiom,
    ! [B: $tType,R3: fun(B,fun(B,$o)),S: fun(B,fun(B,$o))] :
      ( transp(B,R3)
     => ( transp(B,S)
       => transp(B,aa(fun(B,fun(B,$o)),fun(B,fun(B,$o)),aa(fun(B,fun(B,$o)),fun(fun(B,fun(B,$o)),fun(B,fun(B,$o))),inf_inf(fun(B,fun(B,$o))),R3),S)) ) ) ).

% transp_inf
tff(fact_5717_folding_Ointro,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C))] :
      ( ! [Y2: B,X2: B] : ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y2)),aa(B,fun(C,C),Fa,X2)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X2)),aa(B,fun(C,C),Fa,Y2)) )
     => finite_folding(B,C,Fa) ) ).

% folding.intro
tff(fact_5718_folding_Ocomp__fun__commute,axiom,
    ! [C: $tType,B: $tType,Fa: fun(B,fun(C,C)),Y: B,X: B] :
      ( finite_folding(B,C,Fa)
     => ( aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,Y)),aa(B,fun(C,C),Fa,X)) = aa(fun(C,C),fun(C,C),aa(fun(C,C),fun(fun(C,C),fun(C,C)),comp(C,C,C),aa(B,fun(C,C),Fa,X)),aa(B,fun(C,C),Fa,Y)) ) ) ).

% folding.comp_fun_commute
tff(fact_5719_random__aux__set_Ocases,axiom,
    ! [X: product_prod(code_natural,code_natural)] :
      ( ! [J3: code_natural] : ( X != aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),zero_zero(code_natural)),J3) )
     => ~ ! [I3: code_natural,J3: code_natural] : ( X != aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),code_Suc(I3)),J3) ) ) ).

% random_aux_set.cases
tff(fact_5720_is__empty__bot,axiom,
    ! [B: $tType] : is_empty(B,bot_bot(pred(B))) ).

% is_empty_bot
tff(fact_5721_Predicate_Ois__empty__def,axiom,
    ! [B: $tType,A4: pred(B)] :
      ( is_empty(B,A4)
    <=> ( A4 = bot_bot(pred(B)) ) ) ).

% Predicate.is_empty_def
tff(fact_5722_trivial__limit__at__bot__linorder,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ( at_bot(B) != bot_bot(filter(B)) ) ) ).

% trivial_limit_at_bot_linorder
tff(fact_5723_ATP_Olambda__1,axiom,
    ! [Uu: product_prod(int,int)] :
      ( aa(product_prod(int,int),product_prod(int,int),aTP_Lamp_gl(product_prod(int,int),product_prod(int,int)),Uu)
      = $ite(aa(product_prod(int,int),int,product_fst(int,int),Uu) = zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uu))) ) ).

% ATP.lambda_1
tff(fact_5724_ATP_Olambda__2,axiom,
    ! [B: $tType,Uu: set(set(B))] : ( aa(set(set(B)),int,aTP_Lamp_jy(set(set(B)),int),Uu) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),finite_card(set(B),Uu)),one_one(nat)))),aa(nat,int,semiring_1_of_nat(int),finite_card(B,aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),Uu)))) ) ).

% ATP.lambda_2
tff(fact_5725_ATP_Olambda__3,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,set(product_prod(B,B)),aTP_Lamp_ix(B,set(product_prod(B,B))),Uu) = aa(set(product_prod(B,B)),set(product_prod(B,B)),insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),Uu)),bot_bot(set(product_prod(B,B)))) ) ).

% ATP.lambda_3
tff(fact_5726_ATP_Olambda__4,axiom,
    ! [Uu: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aTP_Lamp_gq(product_prod(int,int),product_prod(int,int)),Uu) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),aa(product_prod(int,int),int,product_fst(int,int),Uu))),aa(product_prod(int,int),int,product_snd(int,int),Uu)) ) ).

% ATP.lambda_4
tff(fact_5727_ATP_Olambda__5,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),product_prod(nat,list(B)),aTP_Lamp_sg(list(B),product_prod(nat,list(B))),Uu) = aa(list(B),product_prod(nat,list(B)),aa(nat,fun(list(B),product_prod(nat,list(B))),product_Pair(nat,list(B)),size_size(list(B),Uu)),Uu) ) ).

% ATP.lambda_5
tff(fact_5728_ATP_Olambda__6,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_de(nat,nat),Uu) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),aa(nat,nat,suc,zero_zero(nat))) ) ).

% ATP.lambda_6
tff(fact_5729_ATP_Olambda__7,axiom,
    ! [C: $tType,Uu: C] : ( aa(C,product_prod(C,C),aTP_Lamp_co(C,product_prod(C,C)),Uu) = aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Uu),Uu) ) ).

% ATP.lambda_7
tff(fact_5730_ATP_Olambda__8,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,product_prod(B,B),aTP_Lamp_cg(B,product_prod(B,B)),Uu) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),Uu) ) ).

% ATP.lambda_8
tff(fact_5731_ATP_Olambda__9,axiom,
    ! [Uu: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aTP_Lamp_vo(product_prod(int,int),$o),Uu)
    <=> aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Uu),Uu) ) ).

% ATP.lambda_9
tff(fact_5732_ATP_Olambda__10,axiom,
    ! [B: $tType] :
      ( semiring_1(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_en(B,B),Uu) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),one_one(B)) ) ) ).

% ATP.lambda_10
tff(fact_5733_ATP_Olambda__11,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [Uu: B] :
          ( aa(B,$o,aTP_Lamp_up(B,$o),Uu)
        <=> dvd_dvd(B,Uu,one_one(B)) ) ) ).

% ATP.lambda_11
tff(fact_5734_ATP_Olambda__12,axiom,
    ! [Uu: nat] : ( aa(nat,product_prod(nat,nat),aTP_Lamp_hb(nat,product_prod(nat,nat)),Uu) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Uu),zero_zero(nat)) ) ).

% ATP.lambda_12
tff(fact_5735_ATP_Olambda__13,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,list(B),aTP_Lamp_rw(B,list(B)),Uu) = aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uu),nil(B)) ) ).

% ATP.lambda_13
tff(fact_5736_ATP_Olambda__14,axiom,
    ! [C: $tType,Uu: C] : ( aa(C,set(C),aTP_Lamp_wh(C,set(C)),Uu) = aa(set(C),set(C),insert2(C,Uu),bot_bot(set(C))) ) ).

% ATP.lambda_14
tff(fact_5737_ATP_Olambda__15,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,set(B),aTP_Lamp_bf(B,set(B)),Uu) = aa(set(B),set(B),insert2(B,Uu),bot_bot(set(B))) ) ).

% ATP.lambda_15
tff(fact_5738_ATP_Olambda__16,axiom,
    ! [Uu: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_tz(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu) = product_scomp(product_prod(code_natural,code_natural),code_natural,product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,aTP_Lamp_ty(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu)) ) ).

% ATP.lambda_16
tff(fact_5739_ATP_Olambda__17,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,fun(set(product_prod(B,B)),set(product_prod(B,B))),aTP_Lamp_gb(B,fun(set(product_prod(B,B)),set(product_prod(B,B)))),Uu) = insert2(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),Uu)) ) ).

% ATP.lambda_17
tff(fact_5740_ATP_Olambda__18,axiom,
    ! [B: $tType,Uu: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_tp(list(B),$o),Uu)
    <=> ( Uu != nil(B) ) ) ).

% ATP.lambda_18
tff(fact_5741_ATP_Olambda__19,axiom,
    ! [B: $tType,Uu: option(product_prod(B,product_prod(heap_ext(product_unit),nat)))] : ( aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(B),aTP_Lamp_uw(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(B)),Uu) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(set(B)),image2(product_prod(B,product_prod(heap_ext(product_unit),nat)),set(B),basic_fsts(B,product_prod(heap_ext(product_unit),nat))),aa(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),set(product_prod(B,product_prod(heap_ext(product_unit),nat))),set_option(product_prod(B,product_prod(heap_ext(product_unit),nat))),Uu))) ) ).

% ATP.lambda_19
tff(fact_5742_ATP_Olambda__20,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: B] : ( aa(B,fun(product_prod(C,D),product_prod(product_prod(B,C),D)),aTP_Lamp_uc(B,fun(product_prod(C,D),product_prod(product_prod(B,C),D))),Uu) = aa(fun(C,fun(D,product_prod(product_prod(B,C),D))),fun(product_prod(C,D),product_prod(product_prod(B,C),D)),product_case_prod(C,D,product_prod(product_prod(B,C),D)),aTP_Lamp_ub(B,fun(C,fun(D,product_prod(product_prod(B,C),D))),Uu)) ) ).

% ATP.lambda_20
tff(fact_5743_ATP_Olambda__21,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: C] : ( aa(C,fun(product_prod(B,D),product_prod(B,product_prod(C,D))),aTP_Lamp_ss(C,fun(product_prod(B,D),product_prod(B,product_prod(C,D)))),Uu) = aa(fun(B,fun(D,product_prod(B,product_prod(C,D)))),fun(product_prod(B,D),product_prod(B,product_prod(C,D))),product_case_prod(B,D,product_prod(B,product_prod(C,D))),aTP_Lamp_sr(C,fun(B,fun(D,product_prod(B,product_prod(C,D)))),Uu)) ) ).

% ATP.lambda_21
tff(fact_5744_ATP_Olambda__22,axiom,
    ! [B: $tType,Uu: multiset(B)] : ( aa(multiset(B),set(B),aTP_Lamp_qc(multiset(B),set(B)),Uu) = aa(fun(B,$o),set(B),collect(B),aTP_Lamp_qb(multiset(B),fun(B,$o),Uu)) ) ).

% ATP.lambda_22
tff(fact_5745_ATP_Olambda__23,axiom,
    ! [Uu: nat] : ( aa(nat,set(nat),aTP_Lamp_lh(nat,set(nat)),Uu) = aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_lg(nat,fun(nat,$o),Uu)) ) ).

% ATP.lambda_23
tff(fact_5746_ATP_Olambda__24,axiom,
    ! [C: $tType,Uu: fun(C,nat)] :
      ( aa(fun(C,nat),$o,aTP_Lamp_qy(fun(C,nat),$o),Uu)
    <=> aa(set(C),$o,finite_finite(C),aa(fun(C,$o),set(C),collect(C),aTP_Lamp_qx(fun(C,nat),fun(C,$o),Uu))) ) ).

% ATP.lambda_24
tff(fact_5747_ATP_Olambda__25,axiom,
    ! [B: $tType,Uu: fun(B,nat)] :
      ( aa(fun(B,nat),$o,aTP_Lamp_qv(fun(B,nat),$o),Uu)
    <=> aa(set(B),$o,finite_finite(B),aa(fun(B,$o),set(B),collect(B),aTP_Lamp_qu(fun(B,nat),fun(B,$o),Uu))) ) ).

% ATP.lambda_25
tff(fact_5748_ATP_Olambda__26,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_wr(num,option(num)),Uu) = aa(num,option(num),some(num),aa(num,num,bit1,Uu)) ) ).

% ATP.lambda_26
tff(fact_5749_ATP_Olambda__27,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_ws(num,option(num)),Uu) = aa(num,option(num),some(num),aa(num,num,bit0,Uu)) ) ).

% ATP.lambda_27
tff(fact_5750_ATP_Olambda__28,axiom,
    ! [Uu: int] : ( aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ey(int,fun(int,product_prod(int,int))),Uu) = aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,uminus_uminus(int),Uu)) ) ).

% ATP.lambda_28
tff(fact_5751_ATP_Olambda__29,axiom,
    ! [Uu: int] : ( aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ew(int,fun(int,product_prod(int,int))),Uu) = aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,abs_abs(int),Uu)) ) ).

% ATP.lambda_29
tff(fact_5752_ATP_Olambda__30,axiom,
    ! [Uu: nat] : ( aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_ff(nat,fun(nat,product_prod(nat,nat))),Uu) = aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_30
tff(fact_5753_ATP_Olambda__31,axiom,
    ! [B: $tType,Uu: product_prod(B,B)] :
      ( aa(product_prod(B,B),$o,aTP_Lamp_kk(product_prod(B,B),$o),Uu)
    <=> ? [X4: B] : ( Uu = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),X4) ) ) ).

% ATP.lambda_31
tff(fact_5754_ATP_Olambda__32,axiom,
    ! [B: $tType,C: $tType,Uu: product_prod(product_prod($o,B),product_prod($o,C))] :
      ( aa(product_prod(product_prod($o,B),product_prod($o,C)),$o,aTP_Lamp_kv(product_prod(product_prod($o,B),product_prod($o,C)),$o),Uu)
    <=> ? [X4: B,Y3: C] : ( Uu = aa(product_prod($o,C),product_prod(product_prod($o,B),product_prod($o,C)),aa(product_prod($o,B),fun(product_prod($o,C),product_prod(product_prod($o,B),product_prod($o,C))),product_Pair(product_prod($o,B),product_prod($o,C)),aa(B,product_prod($o,B),aa($o,fun(B,product_prod($o,B)),product_Pair($o,B),$true),X4)),aa(C,product_prod($o,C),aa($o,fun(C,product_prod($o,C)),product_Pair($o,C),$false),Y3)) ) ) ).

% ATP.lambda_32
tff(fact_5755_ATP_Olambda__33,axiom,
    ! [C: $tType,B: $tType,Uu: product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))] :
      ( aa(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),$o,aTP_Lamp_wf(product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),$o),Uu)
    <=> ? [F10: fun(nat,sum_sum(B,nat)),X4: sum_sum(C,nat),K4: nat] :
          ( ( Uu = aa(sum_sum(C,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),aa(fun(nat,sum_sum(B,nat)),fun(sum_sum(C,nat),product_prod(fun(nat,sum_sum(B,nat)),sum_sum(C,nat))),product_Pair(fun(nat,sum_sum(B,nat)),sum_sum(C,nat)),F10),X4) )
          & ( aa(nat,sum_sum(B,nat),F10,K4) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) ) ) ) ).

% ATP.lambda_33
tff(fact_5756_ATP_Olambda__34,axiom,
    ! [B: $tType,C: $tType,Uu: B] : ( aa(B,heap_Time_Heap(C),aTP_Lamp_vv(B,heap_Time_Heap(C)),Uu) = aa(fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_Heap(C),heap_Time_Heap2(C),aTP_Lamp_vu(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))))) ) ).

% ATP.lambda_34
tff(fact_5757_ATP_Olambda__35,axiom,
    ! [C: $tType,Uu: nat] : ( aa(nat,sum_sum(C,nat),aTP_Lamp_wi(nat,sum_sum(C,nat)),Uu) = aa(nat,sum_sum(C,nat),sum_Inr(nat,C),zero_zero(nat)) ) ).

% ATP.lambda_35
tff(fact_5758_ATP_Olambda__36,axiom,
    ! [B: $tType,Uu: nat] : ( aa(nat,sum_sum(B,nat),aTP_Lamp_wg(nat,sum_sum(B,nat)),Uu) = aa(nat,sum_sum(B,nat),sum_Inr(nat,B),zero_zero(nat)) ) ).

% ATP.lambda_36
tff(fact_5759_ATP_Olambda__37,axiom,
    ! [Uu: num,Uua: nat] : ( aa(nat,option(num),aTP_Lamp_wv(num,fun(nat,option(num)),Uu),Uua) = case_num(option(num),aa(num,option(num),some(num),one2),aTP_Lamp_wt(nat,fun(num,option(num)),Uua),aTP_Lamp_wu(nat,fun(num,option(num)),Uua),Uu) ) ).

% ATP.lambda_37
tff(fact_5760_ATP_Olambda__38,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: nat,Uua: nat] :
          ( aa(nat,B,aTP_Lamp_ac(nat,fun(nat,B),Uu),Uua)
          = $ite(dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),Uua),aa(nat,B,semiring_1_of_nat(B),binomial(Uu,Uua)),zero_zero(B)) ) ) ).

% ATP.lambda_38
tff(fact_5761_ATP_Olambda__39,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: product_prod(B,D),Uua: product_prod(D,C)] :
      ( aa(product_prod(D,C),list(product_prod(B,C)),aTP_Lamp_ta(product_prod(B,D),fun(product_prod(D,C),list(product_prod(B,C))),Uu),Uua)
      = $ite(aa(product_prod(B,D),D,product_snd(B,D),Uu) = aa(product_prod(D,C),D,product_fst(D,C),Uua),aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(product_prod(B,D),B,product_fst(B,D),Uu)),aa(product_prod(D,C),C,product_snd(D,C),Uua))),nil(product_prod(B,C))),nil(product_prod(B,C))) ) ).

% ATP.lambda_39
tff(fact_5762_ATP_Olambda__40,axiom,
    ! [Uu: pred(product_unit),Uua: product_prod(code_natural,code_natural)] :
      ( aa(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)),aa(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),aTP_Lamp_vc(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)))),Uu),Uua)
      = $ite(aa(product_unit,$o,aa(pred(product_unit),fun(product_unit,$o),eval(product_unit),Uu),product_Unity),aa(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)),aa(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),product_Pair(pred(product_unit),product_prod(code_natural,code_natural)),bot_bot(pred(product_unit))),Uua),aa(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural)),aa(pred(product_unit),fun(product_prod(code_natural,code_natural),product_prod(pred(product_unit),product_prod(code_natural,code_natural))),product_Pair(pred(product_unit),product_prod(code_natural,code_natural)),aa(product_unit,pred(product_unit),single(product_unit),product_Unity)),Uua)) ) ).

% ATP.lambda_40
tff(fact_5763_ATP_Olambda__41,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fj(int,fun(int,product_prod(int,int))),Uu),Uua)
      = $ite(Uu = zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),Uu)),Uua)),aa(int,int,abs_abs(int),Uu))) ) ).

% ATP.lambda_41
tff(fact_5764_ATP_Olambda__42,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_gu(int,fun(int,product_prod(int,int))),Uu),Uua)
      = $ite(Uua = zero_zero(int),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),Uu),Uua)) ) ).

% ATP.lambda_42
tff(fact_5765_ATP_Olambda__43,axiom,
    ! [B: $tType,Uu: set(fun(B,nat)),Uua: B] :
      ( aa(B,nat,aa(set(fun(B,nat)),fun(B,nat),aTP_Lamp_qh(set(fun(B,nat)),fun(B,nat)),Uu),Uua)
      = $ite(Uu = bot_bot(set(fun(B,nat))),zero_zero(nat),aa(set(nat),nat,complete_Inf_Inf(nat),aa(set(fun(B,nat)),set(nat),image2(fun(B,nat),nat,aTP_Lamp_qf(B,fun(fun(B,nat),nat),Uua)),Uu))) ) ).

% ATP.lambda_43
tff(fact_5766_ATP_Olambda__44,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: nat,Uua: nat] :
          ( aa(nat,B,aTP_Lamp_ab(nat,fun(nat,B),Uu),Uua)
          = $ite(~ dvd_dvd(nat,aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)),Uua),aa(nat,B,semiring_1_of_nat(B),binomial(Uu,Uua)),zero_zero(B)) ) ) ).

% ATP.lambda_44
tff(fact_5767_ATP_Olambda__45,axiom,
    ! [B: $tType] :
      ( ( lattice(B)
        & order_bot(B) )
     => ! [Uu: fun(B,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_pq(fun(B,B),fun(nat,B),Uu),Uua) = aa(B,B,compow(fun(B,B),Uua,Uu),bot_bot(B)) ) ) ).

% ATP.lambda_45
tff(fact_5768_ATP_Olambda__46,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [Uu: option(B),Uua: B] : ( aa(B,option(B),aTP_Lamp_ms(option(B),fun(B,option(B)),Uu),Uua) = case_option(option(B),B,none(B),aTP_Lamp_mr(B,fun(B,option(B)),Uua),Uu) ) ) ).

% ATP.lambda_46
tff(fact_5769_ATP_Olambda__47,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aa(nat,fun(num,option(num)),aTP_Lamp_ww(nat,fun(num,option(num))),Uu),Uua) = case_nat(option(num),none(num),aTP_Lamp_wv(num,fun(nat,option(num)),Uua),Uu) ) ).

% ATP.lambda_47
tff(fact_5770_ATP_Olambda__48,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_wt(nat,fun(num,option(num)),Uu),Uua) = case_option(option(num),num,none(num),aTP_Lamp_ws(num,option(num)),bit_take_bit_num(Uu,Uua)) ) ).

% ATP.lambda_48
tff(fact_5771_ATP_Olambda__49,axiom,
    ! [Uu: product_prod(int,int),Uua: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aa(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),aTP_Lamp_gs(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),Uu),Uua) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uua)),aa(product_prod(int,int),int,product_snd(int,int),Uu)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))) ) ).

% ATP.lambda_49
tff(fact_5772_ATP_Olambda__50,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,B,aTP_Lamp_eh(nat,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),Uua)),aa(nat,B,semiring_1_of_nat(B),Uua))),aa(nat,B,semiring_1_of_nat(B),binomial(Uu,Uua))) ) ) ).

% ATP.lambda_50
tff(fact_5773_ATP_Olambda__51,axiom,
    ! [Uu: product_prod(int,int),Uua: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aa(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),aTP_Lamp_gt(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),Uu),Uua) = aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))) ) ).

% ATP.lambda_51
tff(fact_5774_ATP_Olambda__52,axiom,
    ! [C: $tType,B: $tType,Uu: set(old_node(B,C)),Uua: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_wk(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),Uu),Uua) = aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),insert2(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_In1(B,C,Uu)),old_In1(B,C,Uua))),bot_bot(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))) ) ).

% ATP.lambda_52
tff(fact_5775_ATP_Olambda__53,axiom,
    ! [C: $tType,B: $tType,Uu: set(old_node(B,C)),Uua: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_wj(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),Uu),Uua) = aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),insert2(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_In0(B,C,Uu)),old_In0(B,C,Uua))),bot_bot(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))) ) ).

% ATP.lambda_53
tff(fact_5776_ATP_Olambda__54,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,B,aTP_Lamp_ej(nat,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),Uua)),aa(nat,B,semiring_1_of_nat(B),binomial(Uu,Uua))) ) ) ).

% ATP.lambda_54
tff(fact_5777_ATP_Olambda__55,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B] : ( aa(B,set(set(B)),aTP_Lamp_ln(set(product_prod(B,B)),fun(B,set(set(B))),Uu),Uua) = aa(set(set(B)),set(set(B)),insert2(set(B),image(B,B,Uu,aa(set(B),set(B),insert2(B,Uua),bot_bot(set(B))))),bot_bot(set(set(B)))) ) ).

% ATP.lambda_55
tff(fact_5778_ATP_Olambda__56,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_dd(B,fun(nat,B),Uu),Uua) = aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uua))),Uua) ) ) ).

% ATP.lambda_56
tff(fact_5779_ATP_Olambda__57,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_ad(B,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,Uu),Uua)),aa(B,B,aa(B,fun(B,B),minus_minus(B),divide_divide(B,Uu,aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))),aa(nat,B,semiring_1_of_nat(B),Uua))) ) ) ).

% ATP.lambda_57
tff(fact_5780_ATP_Olambda__58,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_dv(B,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,Uu),Uua)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),one_one(B))),Uua)) ) ) ).

% ATP.lambda_58
tff(fact_5781_ATP_Olambda__59,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(list(B),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_rd(array(B),fun(heap_ext(product_unit),product_prod(list(B),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(list(B),product_prod(heap_ext(product_unit),nat)),aa(list(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(list(B),product_prod(heap_ext(product_unit),nat))),product_Pair(list(B),product_prod(heap_ext(product_unit),nat)),array_get(B,Uua,Uu)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),array_length(B,Uua,Uu)))) ) ) ).

% ATP.lambda_59
tff(fact_5782_ATP_Olambda__60,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: set(set(B))] :
      ( aa(set(set(B)),$o,aTP_Lamp_jz(set(set(B)),fun(set(set(B)),$o),Uu),Uua)
    <=> ( aa(set(set(B)),$o,aa(set(set(B)),fun(set(set(B)),$o),ord_less_eq(set(set(B))),Uua),Uu)
        & ( Uua != bot_bot(set(set(B))) ) ) ) ).

% ATP.lambda_60
tff(fact_5783_ATP_Olambda__61,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(B,B))] :
      ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),aTP_Lamp_oz(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o)),Uu),Uua)
    <=> ( aa(set(product_prod(B,B)),$o,aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),$o),ord_less_eq(set(product_prod(B,B))),Uu),Uua)
        & ! [A6: B,B5: B,C5: B] :
            ( ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A6),B5),Uua)
              & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B5),C5),Uu) )
           => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A6),B5),Uu) ) ) ) ).

% ATP.lambda_61
tff(fact_5784_ATP_Olambda__62,axiom,
    ! [C: $tType,B: $tType,Uu: set(old_node(B,C)),Uua: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(set(old_node(B,C))),aTP_Lamp_wy(set(old_node(B,C)),fun(set(old_node(B,C)),set(set(old_node(B,C)))),Uu),Uua) = aa(set(set(old_node(B,C))),set(set(old_node(B,C))),insert2(set(old_node(B,C)),old_Scons(B,C,Uu,Uua)),bot_bot(set(set(old_node(B,C))))) ) ).

% ATP.lambda_62
tff(fact_5785_ATP_Olambda__63,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: B] : ( aa(B,set(product_prod(C,B)),aTP_Lamp_hj(C,fun(B,set(product_prod(C,B))),Uu),Uua) = aa(set(product_prod(C,B)),set(product_prod(C,B)),insert2(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uu),Uua)),bot_bot(set(product_prod(C,B)))) ) ).

% ATP.lambda_63
tff(fact_5786_ATP_Olambda__64,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C] : ( aa(C,set(product_prod(B,C)),aTP_Lamp_hw(B,fun(C,set(product_prod(B,C))),Uu),Uua) = aa(set(product_prod(B,C)),set(product_prod(B,C)),insert2(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),Uua)),bot_bot(set(product_prod(B,C)))) ) ).

% ATP.lambda_64
tff(fact_5787_ATP_Olambda__65,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aTP_Lamp_rc(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),Uu),Uua)
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),aa(set(product_prod(B,C)),set(product_prod(B,C)),insert2(product_prod(B,C),Uua),bot_bot(set(product_prod(B,C))))),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Uu))) ) ).

% ATP.lambda_65
tff(fact_5788_ATP_Olambda__66,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(C,fun(D,$o)),Uua: fun(B,product_prod(C,D))] :
      ( aa(fun(B,product_prod(C,D)),$o,aTP_Lamp_gr(fun(C,fun(D,$o)),fun(fun(B,product_prod(C,D)),$o),Uu),Uua)
    <=> aa(set(product_prod(C,D)),$o,aa(set(product_prod(C,D)),fun(set(product_prod(C,D)),$o),ord_less_eq(set(product_prod(C,D))),aa(set(B),set(product_prod(C,D)),image2(B,product_prod(C,D),Uua),top_top(set(B)))),aa(fun(product_prod(C,D),$o),set(product_prod(C,D)),collect(product_prod(C,D)),aa(fun(C,fun(D,$o)),fun(product_prod(C,D),$o),product_case_prod(C,D,$o),Uu))) ) ).

% ATP.lambda_66
tff(fact_5789_ATP_Olambda__67,axiom,
    ! [B: $tType,Uu: fun(set(B),$o),Uua: set(B)] :
      ( aa(set(B),$o,aa(fun(set(B),$o),fun(set(B),$o),aTP_Lamp_mz(fun(set(B),$o),fun(set(B),$o)),Uu),Uua)
    <=> ( ( Uua = bot_bot(set(B)) )
        | ? [A11: set(B),A6: B] :
            ( ( Uua = aa(set(B),set(B),insert2(B,A6),A11) )
            & aa(set(B),$o,Uu,A11) ) ) ) ).

% ATP.lambda_67
tff(fact_5790_ATP_Olambda__68,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: fun(B,C)] :
      ( aa(fun(B,C),$o,aTP_Lamp_nl(set(C),fun(fun(B,C),$o),Uu),Uua)
    <=> aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image2(B,C,Uua),top_top(set(B)))),Uu) ) ).

% ATP.lambda_68
tff(fact_5791_ATP_Olambda__69,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B] : ( aa(B,set(set(B)),aTP_Lamp_kx(set(product_prod(B,B)),fun(B,set(set(B))),Uu),Uua) = equiv_quotient(B,aa(set(B),set(B),insert2(B,Uua),bot_bot(set(B))),Uu) ) ).

% ATP.lambda_69
tff(fact_5792_ATP_Olambda__70,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,product_prod(B,C)),Uua: B] : ( aa(B,set(C),aTP_Lamp_hi(fun(D,product_prod(B,C)),fun(B,set(C)),Uu),Uua) = aa(set(D),set(C),image2(D,C,aa(fun(D,product_prod(B,C)),fun(D,C),aa(fun(product_prod(B,C),C),fun(fun(D,product_prod(B,C)),fun(D,C)),comp(product_prod(B,C),C,D),product_snd(B,C)),Uu)),top_top(set(D))) ) ).

% ATP.lambda_70
tff(fact_5793_ATP_Olambda__71,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_dt(fun(nat,B),fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua))),aa(nat,B,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)))) ) ) ).

% ATP.lambda_71
tff(fact_5794_ATP_Olambda__72,axiom,
    ! [B: $tType] :
      ( division_ring(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_aw(fun(nat,B),fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,Uua)),aa(nat,B,aa(B,fun(nat,B),power_power(B),zero_zero(B)),Uua)) ) ) ).

% ATP.lambda_72
tff(fact_5795_ATP_Olambda__73,axiom,
    ! [B: $tType] :
      ( ord(B)
     => ! [Uu: fun(B,$o),Uua: B] :
          ( aa(B,$o,aTP_Lamp_ow(fun(B,$o),fun(B,$o),Uu),Uua)
        <=> ( aa(B,$o,Uu,Uua)
            & ! [Y3: B] :
                ( aa(B,$o,Uu,Y3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Y3) ) ) ) ) ).

% ATP.lambda_73
tff(fact_5796_ATP_Olambda__74,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Uu: fun(B,$o),Uua: B] :
          ( aa(B,$o,aTP_Lamp_ox(fun(B,$o),fun(B,$o),Uu),Uua)
        <=> ( aa(B,$o,Uu,Uua)
            & ! [Y3: B] :
                ( aa(B,$o,Uu,Y3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y3),Uua) ) ) ) ) ).

% ATP.lambda_74
tff(fact_5797_ATP_Olambda__75,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B] : ( aa(B,product_prod(nat,B),aTP_Lamp_hk(fun(B,nat),fun(B,product_prod(nat,B)),Uu),Uua) = aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),aa(B,nat,Uu,Uua)),Uua) ) ).

% ATP.lambda_75
tff(fact_5798_ATP_Olambda__76,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: B] : ( aa(B,product_prod(C,B),aTP_Lamp_bq(fun(B,C),fun(B,product_prod(C,B)),Uu),Uua) = aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),aa(B,C,Uu,Uua)),Uua) ) ).

% ATP.lambda_76
tff(fact_5799_ATP_Olambda__77,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: B] : ( aa(B,assn,aTP_Lamp_cm(fun(B,assn),fun(B,assn),Uu),Uua) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,Uu,Uua)),top_top(assn)) ) ).

% ATP.lambda_77
tff(fact_5800_ATP_Olambda__78,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,B),Uua: C] : ( aa(C,set(B),aTP_Lamp_iw(fun(C,B),fun(C,set(B)),Uu),Uua) = aa(set(B),set(B),insert2(B,aa(C,B,Uu,Uua)),bot_bot(set(B))) ) ).

% ATP.lambda_78
tff(fact_5801_ATP_Olambda__79,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(B,C),Uua: B] :
          ( aa(B,$o,aTP_Lamp_ce(fun(B,C),fun(B,$o),Uu),Uua)
        <=> ( aa(B,C,Uu,Uua) = one_one(C) ) ) ) ).

% ATP.lambda_79
tff(fact_5802_ATP_Olambda__80,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: list(B),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_rn(list(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rm(list(B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(B,Uu,Uua)) ) ) ).

% ATP.lambda_80
tff(fact_5803_ATP_Olambda__81,axiom,
    ! [Uu: assn,Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aTP_Lamp_cw(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uu),Uua)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,Uua)
        & ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Uu),Uua) ) ) ).

% ATP.lambda_81
tff(fact_5804_ATP_Olambda__82,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aTP_Lamp_al(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uu),Uua)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,in_range,Uua)
        & ~ aa(product_prod(heap_ext(product_unit),set(nat)),$o,Uu,Uua) ) ) ).

% ATP.lambda_82
tff(fact_5805_ATP_Olambda__83,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: heap_Time_Heap(product_prod(B,C))] :
      ( aa(heap_Time_Heap(product_prod(B,C)),$o,aTP_Lamp_uy(fun(B,fun(C,$o)),fun(heap_Time_Heap(product_prod(B,C)),$o),Uu),Uua)
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),aa(heap_Time_Heap(product_prod(B,C)),set(product_prod(B,C)),heap_Time_set_Heap(product_prod(B,C)),Uua)),aa(fun(product_prod(B,C),$o),set(product_prod(B,C)),collect(product_prod(B,C)),aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),Uu))) ) ).

% ATP.lambda_83
tff(fact_5806_ATP_Olambda__84,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: set(set(B))] : ( aa(set(set(B)),set(B),aTP_Lamp_xa(fun(B,fun(C,$o)),fun(set(set(B)),set(B)),Uu),Uua) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),Uua)),aa(fun(B,$o),set(B),collect(B),domainp(B,C,Uu))) ) ).

% ATP.lambda_84
tff(fact_5807_ATP_Olambda__85,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: set(B)] : ( aa(set(B),set(B),aTP_Lamp_xb(fun(B,fun(C,$o)),fun(set(B),set(B)),Uu),Uua) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(B),set(B),uminus_uminus(set(B)),Uua)),aa(fun(B,$o),set(B),collect(B),domainp(B,C,Uu))) ) ).

% ATP.lambda_85
tff(fact_5808_ATP_Olambda__86,axiom,
    ! [B: $tType,Uu: pred(B),Uua: seq(B)] : ( aa(seq(B),set(B),aa(pred(B),fun(seq(B),set(B)),aTP_Lamp_wd(pred(B),fun(seq(B),set(B))),Uu),Uua) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(pred(B),set(B),set_of_pred(B),Uu)),aa(seq(B),set(B),set_of_seq(B),Uua)) ) ).

% ATP.lambda_86
tff(fact_5809_ATP_Olambda__87,axiom,
    ! [B: $tType,Uu: set(B),Uua: heap_Time_Heap(B)] :
      ( aa(heap_Time_Heap(B),$o,aTP_Lamp_ux(set(B),fun(heap_Time_Heap(B),$o),Uu),Uua)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(heap_Time_Heap(B),set(B),heap_Time_set_Heap(B),Uua)),Uu) ) ).

% ATP.lambda_87
tff(fact_5810_ATP_Olambda__88,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,B,aTP_Lamp_eb(nat,fun(nat,B),Uu),Uua) = aa(nat,B,gbinomial(B,aa(nat,B,semiring_1_of_nat(B),Uua)),Uu) ) ) ).

% ATP.lambda_88
tff(fact_5811_ATP_Olambda__89,axiom,
    ! [B: $tType,C: $tType,Uu: list(C),Uua: B] : ( aa(B,list(product_prod(B,C)),aTP_Lamp_th(list(C),fun(B,list(product_prod(B,C))),Uu),Uua) = aa(list(C),list(product_prod(B,C)),map(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua)),Uu) ) ).

% ATP.lambda_89
tff(fact_5812_ATP_Olambda__90,axiom,
    ! [B: $tType,Uu: nat,Uua: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_sl(nat,fun(list(B),$o),Uu),Uua)
    <=> ( size_size(list(B),Uua) = Uu ) ) ).

% ATP.lambda_90
tff(fact_5813_ATP_Olambda__91,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(B,B))] : ( aa(set(product_prod(B,B)),set(set(product_prod(B,B))),aTP_Lamp_pi(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(set(product_prod(B,B)))),Uu),Uua) = image(set(product_prod(B,B)),set(product_prod(B,B)),converse(set(product_prod(B,B)),set(product_prod(B,B)),bNF_We4044943003108391690rdLess(B,B)),aa(set(set(product_prod(B,B))),set(set(product_prod(B,B))),insert2(set(product_prod(B,B)),Uu),bot_bot(set(set(product_prod(B,B)))))) ) ).

% ATP.lambda_91
tff(fact_5814_ATP_Olambda__92,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Uu: B,Uua: B] : ( aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),aTP_Lamp_eo(B,fun(B,product_prod(B,B))),Uu),Uua) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Uua)),one_one(B))) ) ) ).

% ATP.lambda_92
tff(fact_5815_ATP_Olambda__93,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Uu: B,Uua: B] : ( aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),aTP_Lamp_er(B,fun(B,product_prod(B,B))),Uu),Uua) = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uu),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Uua)) ) ) ).

% ATP.lambda_93
tff(fact_5816_ATP_Olambda__94,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_aa(B,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),divide_divide(B,aa(nat,B,semiring_1_of_nat(B),Uua),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_94
tff(fact_5817_ATP_Olambda__95,axiom,
    ! [B: $tType,Uu: B,Uua: set(set(B))] : ( aa(set(set(B)),set(set(B)),aa(B,fun(set(set(B)),set(set(B))),aTP_Lamp_jj(B,fun(set(set(B)),set(set(B)))),Uu),Uua) = aa(set(set(B)),set(set(B)),aa(set(set(B)),fun(set(set(B)),set(set(B))),sup_sup(set(set(B))),Uua),aa(set(set(B)),set(set(B)),image2(set(B),set(B),insert2(B,Uu)),Uua)) ) ).

% ATP.lambda_95
tff(fact_5818_ATP_Olambda__96,axiom,
    ! [B: $tType,Uu: B,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),aTP_Lamp_ly(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),zero_zero(nat))) ) ).

% ATP.lambda_96
tff(fact_5819_ATP_Olambda__97,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: ref(B),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),aa(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mt(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),aa(ref(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),product_Pair(ref(B),product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat))) ) ) ).

% ATP.lambda_97
tff(fact_5820_ATP_Olambda__98,axiom,
    ! [B: $tType,Uu: B,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),aTP_Lamp_lt(B,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),Uu),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat))) ) ).

% ATP.lambda_98
tff(fact_5821_ATP_Olambda__99,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,B)),Uua: C] : ( aa(C,set(B),aTP_Lamp_lm(set(product_prod(C,B)),fun(C,set(B)),Uu),Uua) = image(C,B,Uu,aa(set(C),set(C),insert2(C,Uua),bot_bot(set(C)))) ) ).

% ATP.lambda_99
tff(fact_5822_ATP_Olambda__100,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,C),Uua: C] : ( aa(C,set(B),aTP_Lamp_jp(fun(B,C),fun(C,set(B)),Uu),Uua) = aa(set(C),set(B),aa(fun(B,C),fun(set(C),set(B)),vimage(B,C),Uu),aa(set(C),set(C),insert2(C,Uua),bot_bot(set(C)))) ) ).

% ATP.lambda_100
tff(fact_5823_ATP_Olambda__101,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_ju(set(B),fun(B,$o),Uu),Uua)
    <=> ( Uu = aa(set(B),set(B),insert2(B,Uua),bot_bot(set(B))) ) ) ).

% ATP.lambda_101
tff(fact_5824_ATP_Olambda__102,axiom,
    ! [B: $tType,Uu: fun(nat,B),Uua: nat] : ( aa(nat,product_prod(nat,B),aTP_Lamp_tc(fun(nat,B),fun(nat,product_prod(nat,B)),Uu),Uua) = aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),Uua),aa(nat,B,Uu,Uua)) ) ).

% ATP.lambda_102
tff(fact_5825_ATP_Olambda__103,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: B] : ( aa(B,product_prod(B,C),aTP_Lamp_bp(fun(B,C),fun(B,product_prod(B,C)),Uu),Uua) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),aa(B,C,Uu,Uua)) ) ).

% ATP.lambda_103
tff(fact_5826_ATP_Olambda__104,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,option(C)),Uua: B] : ( aa(B,product_prod(B,C),aTP_Lamp_oc(fun(B,option(C)),fun(B,product_prod(B,C)),Uu),Uua) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),aa(option(C),C,the2(C),aa(B,option(C),Uu,Uua))) ) ).

% ATP.lambda_104
tff(fact_5827_ATP_Olambda__105,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,B,aTP_Lamp_dx(B,fun(nat,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uua)) ) ) ).

% ATP.lambda_105
tff(fact_5828_ATP_Olambda__106,axiom,
    ! [B: $tType,Uu: list(set(B)),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_sj(list(set(B)),fun(set(B),$o),Uu),Uua)
    <=> member(set(B),Uua,aa(list(set(B)),set(set(B)),set2(set(B)),Uu)) ) ).

% ATP.lambda_106
tff(fact_5829_ATP_Olambda__107,axiom,
    ! [B: $tType,Uu: list(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_tg(list(B),fun(B,$o),Uu),Uua)
    <=> member(B,Uua,aa(list(B),set(B),set2(B),Uu)) ) ).

% ATP.lambda_107
tff(fact_5830_ATP_Olambda__108,axiom,
    ! [B: $tType,Uu: B,Uua: pred(B)] : ( aa(pred(B),set(B),aa(B,fun(pred(B),set(B)),aTP_Lamp_wc(B,fun(pred(B),set(B))),Uu),Uua) = aa(set(B),set(B),insert2(B,Uu),aa(pred(B),set(B),set_of_pred(B),Uua)) ) ).

% ATP.lambda_108
tff(fact_5831_ATP_Olambda__109,axiom,
    ! [B: $tType,Uu: nat,Uua: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_sm(nat,fun(list(B),$o),Uu),Uua)
    <=> ( Uu = size_size(list(B),Uua) ) ) ).

% ATP.lambda_109
tff(fact_5832_ATP_Olambda__110,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ct(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_110
tff(fact_5833_ATP_Olambda__111,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_oe(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_111
tff(fact_5834_ATP_Olambda__112,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ch(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_112
tff(fact_5835_ATP_Olambda__113,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_we(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_113
tff(fact_5836_ATP_Olambda__114,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_us(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_114
tff(fact_5837_ATP_Olambda__115,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_vj(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),Uu) ) ) ).

% ATP.lambda_115
tff(fact_5838_ATP_Olambda__116,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_ds(nat,fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),Uu) ) ).

% ATP.lambda_116
tff(fact_5839_ATP_Olambda__117,axiom,
    ! [B: $tType] :
      ( bounde4967611905675639751up_bot(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_cu(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_117
tff(fact_5840_ATP_Olambda__118,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_of(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_118
tff(fact_5841_ATP_Olambda__119,axiom,
    ! [B: $tType] :
      ( order_bot(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ci(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_119
tff(fact_5842_ATP_Olambda__120,axiom,
    ! [B: $tType] :
      ( preorder(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_wn(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_120
tff(fact_5843_ATP_Olambda__121,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ut(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_121
tff(fact_5844_ATP_Olambda__122,axiom,
    ! [B: $tType] :
      ( order(B)
     => ! [Uu: B,Uua: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_vk(B,fun(B,$o)),Uu),Uua)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),Uu) ) ) ).

% ATP.lambda_122
tff(fact_5845_ATP_Olambda__123,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_dg(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),Uu) ) ) ).

% ATP.lambda_123
tff(fact_5846_ATP_Olambda__124,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_df(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uu) ) ).

% ATP.lambda_124
tff(fact_5847_ATP_Olambda__125,axiom,
    ! [B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_bw(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),minus_minus(B),Uua),Uu) ) ) ).

% ATP.lambda_125
tff(fact_5848_ATP_Olambda__126,axiom,
    ! [B: $tType,Uu: B,Uua: multiset(B)] : ( aa(multiset(B),nat,aTP_Lamp_qd(B,fun(multiset(B),nat),Uu),Uua) = aa(B,nat,aa(multiset(B),fun(B,nat),count(B),Uua),Uu) ) ).

% ATP.lambda_126
tff(fact_5849_ATP_Olambda__127,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_kg(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Uua),Uu) ) ) ).

% ATP.lambda_127
tff(fact_5850_ATP_Olambda__128,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B)] : ( aa(set(B),set(B),aTP_Lamp_io(set(B),fun(set(B),set(B)),Uu),Uua) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),Uua),Uu) ) ).

% ATP.lambda_128
tff(fact_5851_ATP_Olambda__129,axiom,
    ! [B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: B,Uua: B] : ( aa(B,B,aTP_Lamp_ia(B,fun(B,B),Uu),Uua) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Uua),Uu) ) ) ).

% ATP.lambda_129
tff(fact_5852_ATP_Olambda__130,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: B,Uua: ref(B)] : ( aa(ref(B),assn,aa(B,fun(ref(B),assn),aTP_Lamp_bj(B,fun(ref(B),assn)),Uu),Uua) = sngr_assn(B,Uua,Uu) ) ) ).

% ATP.lambda_130
tff(fact_5853_ATP_Olambda__131,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: list(B),Uua: array(B)] : ( aa(array(B),assn,aa(list(B),fun(array(B),assn),aTP_Lamp_bk(list(B),fun(array(B),assn)),Uu),Uua) = snga_assn(B,Uua,Uu) ) ) ).

% ATP.lambda_131
tff(fact_5854_ATP_Olambda__132,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_lg(nat,fun(nat,$o),Uu),Uua)
    <=> dvd_dvd(nat,Uua,Uu) ) ).

% ATP.lambda_132
tff(fact_5855_ATP_Olambda__133,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_hc(nat,fun(nat,product_prod(nat,nat))),Uu),Uua) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),Uua),Uu) ) ).

% ATP.lambda_133
tff(fact_5856_ATP_Olambda__134,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: B] : ( aa(B,product_prod(B,C),aa(C,fun(B,product_prod(B,C)),aTP_Lamp_ex(C,fun(B,product_prod(B,C))),Uu),Uua) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uu) ) ).

% ATP.lambda_134
tff(fact_5857_ATP_Olambda__135,axiom,
    ! [B: $tType,Uu: B,Uua: nat] : ( aa(nat,product_prod(nat,B),aTP_Lamp_ti(B,fun(nat,product_prod(nat,B)),Uu),Uua) = aa(B,product_prod(nat,B),aa(nat,fun(B,product_prod(nat,B)),product_Pair(nat,B),Uua),Uu) ) ).

% ATP.lambda_135
tff(fact_5858_ATP_Olambda__136,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C] : ( aa(C,product_prod(C,B),aa(B,fun(C,product_prod(C,B)),aTP_Lamp_es(B,fun(C,product_prod(C,B))),Uu),Uua) = aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uua),Uu) ) ).

% ATP.lambda_136
tff(fact_5859_ATP_Olambda__137,axiom,
    ! [C: $tType,Uu: set(C),Uua: C] :
      ( aa(C,$o,aTP_Lamp_lz(set(C),fun(C,$o),Uu),Uua)
    <=> member(C,Uua,Uu) ) ).

% ATP.lambda_137
tff(fact_5860_ATP_Olambda__138,axiom,
    ! [B: $tType] :
      ( wellorder(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_hf(set(B),fun(B,$o),Uu),Uua)
        <=> member(B,Uua,Uu) ) ) ).

% ATP.lambda_138
tff(fact_5861_ATP_Olambda__139,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_a(set(B),fun(B,$o)),Uu),Uua)
    <=> member(B,Uua,Uu) ) ).

% ATP.lambda_139
tff(fact_5862_ATP_Olambda__140,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(B,D),Uua: fun(D,set(C))] : ( aa(fun(D,set(C)),fun(B,set(C)),aTP_Lamp_kp(fun(B,D),fun(fun(D,set(C)),fun(B,set(C))),Uu),Uua) = aa(fun(B,D),fun(B,set(C)),aa(fun(D,set(C)),fun(fun(B,D),fun(B,set(C))),comp(D,set(C),B),Uua),Uu) ) ).

% ATP.lambda_140
tff(fact_5863_ATP_Olambda__141,axiom,
    ! [B: $tType,Uu: B,Uua: B] :
      ( aa(B,$o,aTP_Lamp_ai(B,fun(B,$o),Uu),Uua)
    <=> ( Uua = Uu ) ) ).

% ATP.lambda_141
tff(fact_5864_ATP_Olambda__142,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_mw(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),one_one(nat)) ) ).

% ATP.lambda_142
tff(fact_5865_ATP_Olambda__143,axiom,
    ! [B: $tType,Uu: B,Uua: product_unit] : ( aa(product_unit,seq(B),aTP_Lamp_vq(B,fun(product_unit,seq(B)),Uu),Uua) = insert(B,Uu,bot_bot(pred(B))) ) ).

% ATP.lambda_143
tff(fact_5866_ATP_Olambda__144,axiom,
    ! [B: $tType,Uu: B,Uua: B] : ( aa(B,set(B),aTP_Lamp_lo(B,fun(B,set(B)),Uu),Uua) = aa(set(B),set(B),insert2(B,Uu),bot_bot(set(B))) ) ).

% ATP.lambda_144
tff(fact_5867_ATP_Olambda__145,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: B,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),aTP_Lamp_mu(B,fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),Uu),Uua) = aa(product_prod(ref(B),heap_ext(product_unit)),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)),aa(fun(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(ref(B),heap_ext(product_unit)),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(ref(B),heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mt(ref(B),fun(heap_ext(product_unit),product_prod(ref(B),product_prod(heap_ext(product_unit),nat))))),ref_alloc(B,Uu,Uua)) ) ) ).

% ATP.lambda_145
tff(fact_5868_ATP_Olambda__146,axiom,
    ! [B: $tType,Uu: multiset(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_qb(multiset(B),fun(B,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(B,nat,aa(multiset(B),fun(B,nat),count(B),Uu),Uua)) ) ).

% ATP.lambda_146
tff(fact_5869_ATP_Olambda__147,axiom,
    ! [C: $tType,Uu: fun(C,nat),Uua: C] :
      ( aa(C,$o,aTP_Lamp_qx(fun(C,nat),fun(C,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(C,nat,Uu,Uua)) ) ).

% ATP.lambda_147
tff(fact_5870_ATP_Olambda__148,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: B] :
      ( aa(B,$o,aTP_Lamp_qu(fun(B,nat),fun(B,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(B,nat,Uu,Uua)) ) ).

% ATP.lambda_148
tff(fact_5871_ATP_Olambda__149,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_qe(set(multiset(B)),fun(B,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(B)),set(nat),image2(multiset(B),nat,aTP_Lamp_qd(B,fun(multiset(B),nat),Uua)),Uu))) ) ).

% ATP.lambda_149
tff(fact_5872_ATP_Olambda__150,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_nv(nat,fun(nat,set(nat)),Uu),Uua) = order_underS(nat,bNF_Ca8665028551170535155natLeq,Uu) ) ).

% ATP.lambda_150
tff(fact_5873_ATP_Olambda__151,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,B,aTP_Lamp_cr(fun(nat,B),fun(nat,B),Uu),Uua) = aa(nat,B,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_151
tff(fact_5874_ATP_Olambda__152,axiom,
    ! [B: $tType,D: $tType,Uu: D,Uua: fun(D,set(set(B)))] : ( aa(fun(D,set(set(B))),set(set(B)),aTP_Lamp_nf(D,fun(fun(D,set(set(B))),set(set(B))),Uu),Uua) = aa(D,set(set(B)),Uua,Uu) ) ).

% ATP.lambda_152
tff(fact_5875_ATP_Olambda__153,axiom,
    ! [B: $tType,Uu: B,Uua: fun(B,nat)] : ( aa(fun(B,nat),nat,aTP_Lamp_qf(B,fun(fun(B,nat),nat),Uu),Uua) = aa(B,nat,Uua,Uu) ) ).

% ATP.lambda_153
tff(fact_5876_ATP_Olambda__154,axiom,
    ! [C: $tType,B: $tType,Uu: fun(set(B),B),Uua: C] : ( aa(C,B,aTP_Lamp_vn(fun(set(B),B),fun(C,B),Uu),Uua) = aa(set(B),B,Uu,bot_bot(set(B))) ) ).

% ATP.lambda_154
tff(fact_5877_ATP_Olambda__155,axiom,
    ! [B: $tType] :
      ( semilattice_sup(B)
     => ! [Uu: B,Uua: option(B)] : ( aa(option(B),option(B),aa(B,fun(option(B),option(B)),aTP_Lamp_mk(B,fun(option(B),option(B))),Uu),Uua) = aa(B,option(B),some(B),case_option(B,B,Uu,aa(B,fun(B,B),sup_sup(B),Uu),Uua)) ) ) ).

% ATP.lambda_155
tff(fact_5878_ATP_Olambda__156,axiom,
    ! [B: $tType] :
      ( semilattice_inf(B)
     => ! [Uu: B,Uua: option(B)] : ( aa(option(B),option(B),aa(B,fun(option(B),option(B)),aTP_Lamp_ml(B,fun(option(B),option(B))),Uu),Uua) = aa(B,option(B),some(B),case_option(B,B,Uu,aa(B,fun(B,B),inf_inf(B),Uu),Uua)) ) ) ).

% ATP.lambda_156
tff(fact_5879_ATP_Olambda__157,axiom,
    ! [Uu: nat,Uua: num] : ( aa(num,option(num),aTP_Lamp_wu(nat,fun(num,option(num)),Uu),Uua) = aa(num,option(num),some(num),case_option(num,num,one2,bit1,bit_take_bit_num(Uu,Uua))) ) ).

% ATP.lambda_157
tff(fact_5880_ATP_Olambda__158,axiom,
    ! [B: $tType,Uu: list(B),Uua: list(B)] : ( aa(list(B),fun(product_prod(B,list(B)),option($o)),aTP_Lamp_sp(list(B),fun(list(B),fun(product_prod(B,list(B)),option($o))),Uu),Uua) = aa(fun(B,fun(list(B),option($o))),fun(product_prod(B,list(B)),option($o)),product_case_prod(B,list(B),option($o)),aa(list(B),fun(B,fun(list(B),option($o))),aTP_Lamp_so(list(B),fun(list(B),fun(B,fun(list(B),option($o)))),Uu),Uua)) ) ).

% ATP.lambda_158
tff(fact_5881_ATP_Olambda__159,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] : ( aa(list(B),fun(product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B))))),aTP_Lamp_sa(B,fun(list(B),fun(product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B)))))),Uu),Uua) = aa(fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B)))))),fun(product_prod(B,list(B)),option(product_prod(list(B),product_prod(B,list(B))))),product_case_prod(B,list(B),option(product_prod(list(B),product_prod(B,list(B))))),aa(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B)))))),aTP_Lamp_rz(B,fun(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))))),Uu),Uua)) ) ).

% ATP.lambda_159
tff(fact_5882_ATP_Olambda__160,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,heap_Time_Heap(B)),Uua: C] : ( aa(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mn(fun(C,heap_Time_Heap(B)),fun(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua) = aa(fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),product_case_prod(heap_ext(product_unit),nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(C,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_mm(fun(C,heap_Time_Heap(B)),fun(C,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua)) ) ).

% ATP.lambda_160
tff(fact_5883_ATP_Olambda__161,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_ha(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gz(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_161
tff(fact_5884_ATP_Olambda__162,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gy(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gx(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_162
tff(fact_5885_ATP_Olambda__163,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_gw(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = aa(fun(nat,fun(nat,product_prod(nat,nat))),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gv(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_163
tff(fact_5886_ATP_Olambda__164,axiom,
    ! [B: $tType,Uu: fun(heap_ext(product_unit),B),Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mg(fun(heap_ext(product_unit),B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),aa(heap_ext(product_unit),B,Uu,Uua)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),one_one(nat)))) ) ).

% ATP.lambda_164
tff(fact_5887_ATP_Olambda__165,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,option(B)),Uua: C] :
      ( aa(C,$o,aTP_Lamp_tn(fun(C,option(B)),fun(C,$o),Uu),Uua)
    <=> ( aa(C,option(B),Uu,Uua) != none(B) ) ) ).

% ATP.lambda_165
tff(fact_5888_ATP_Olambda__166,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B] : ( aa(B,set(product_prod(B,C)),aTP_Lamp_hx(fun(B,set(C)),fun(B,set(product_prod(B,C))),Uu),Uua) = aa(set(set(product_prod(B,C))),set(product_prod(B,C)),complete_Sup_Sup(set(product_prod(B,C))),aa(set(C),set(set(product_prod(B,C))),image2(C,set(product_prod(B,C)),aTP_Lamp_hw(B,fun(C,set(product_prod(B,C))),Uua)),aa(B,set(C),Uu,Uua))) ) ).

% ATP.lambda_166
tff(fact_5889_ATP_Olambda__167,axiom,
    ! [C: $tType,B: $tType,Uu: set(set(old_node(B,C))),Uua: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(set(old_node(B,C))),aTP_Lamp_wz(set(set(old_node(B,C))),fun(set(old_node(B,C)),set(set(old_node(B,C)))),Uu),Uua) = aa(set(set(set(old_node(B,C)))),set(set(old_node(B,C))),complete_Sup_Sup(set(set(old_node(B,C)))),aa(set(set(old_node(B,C))),set(set(set(old_node(B,C)))),image2(set(old_node(B,C)),set(set(old_node(B,C))),aTP_Lamp_wy(set(old_node(B,C)),fun(set(old_node(B,C)),set(set(old_node(B,C)))),Uua)),Uu)) ) ).

% ATP.lambda_167
tff(fact_5890_ATP_Olambda__168,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: B] : ( aa(B,nat,aTP_Lamp_qg(set(multiset(B)),fun(B,nat),Uu),Uua) = aa(set(nat),nat,complete_Sup_Sup(nat),aa(set(multiset(B)),set(nat),image2(multiset(B),nat,aTP_Lamp_qd(B,fun(multiset(B),nat),Uua)),Uu)) ) ).

% ATP.lambda_168
tff(fact_5891_ATP_Olambda__169,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: list(product_prod(D,C)),Uua: product_prod(B,D)] : ( aa(product_prod(B,D),list(product_prod(B,C)),aTP_Lamp_tb(list(product_prod(D,C)),fun(product_prod(B,D),list(product_prod(B,C))),Uu),Uua) = concat(product_prod(B,C),aa(list(product_prod(D,C)),list(list(product_prod(B,C))),map(product_prod(D,C),list(product_prod(B,C)),aTP_Lamp_ta(product_prod(B,D),fun(product_prod(D,C),list(product_prod(B,C))),Uua)),Uu)) ) ).

% ATP.lambda_169
tff(fact_5892_ATP_Olambda__170,axiom,
    ! [Uu: code_natural,Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_ty(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),Uua),aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),times_times(code_natural),Uu),aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2)))))))))))))))))))))))))))))))))) ) ).

% ATP.lambda_170
tff(fact_5893_ATP_Olambda__171,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,fun(B,B),aTP_Lamp_ek(B,fun(nat,fun(B,B)),Uu),Uua) = aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uua))) ) ) ).

% ATP.lambda_171
tff(fact_5894_ATP_Olambda__172,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: B,Uua: nat] : ( aa(nat,fun(B,B),aTP_Lamp_ee(B,fun(nat,fun(B,B)),Uu),Uua) = aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(nat,B,semiring_1_of_nat(B),Uua))) ) ) ).

% ATP.lambda_172
tff(fact_5895_ATP_Olambda__173,axiom,
    ! [B: $tType,Uu: list(B),Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural))),aTP_Lamp_uf(list(B),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(B,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural))),product_Pair(B,product_prod(code_natural,code_natural)),nth(B,Uu,code_nat_of_natural(Uua))) ) ).

% ATP.lambda_173
tff(fact_5896_ATP_Olambda__174,axiom,
    ! [B: $tType,Uu: list(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_tf(list(B),fun(B,$o),Uu),Uua)
    <=> ~ member(B,Uua,aa(list(B),set(B),set2(B),Uu)) ) ).

% ATP.lambda_174
tff(fact_5897_ATP_Olambda__175,axiom,
    ! [B: $tType] :
      ( sup(B)
     => ! [Uu: B,Uua: B] : ( aa(B,option(B),aTP_Lamp_mp(B,fun(B,option(B)),Uu),Uua) = aa(B,option(B),some(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),Uu),Uua)) ) ) ).

% ATP.lambda_175
tff(fact_5898_ATP_Olambda__176,axiom,
    ! [B: $tType] :
      ( inf(B)
     => ! [Uu: B,Uua: B] : ( aa(B,option(B),aTP_Lamp_mr(B,fun(B,option(B)),Uu),Uua) = aa(B,option(B),some(B),aa(B,B,aa(B,fun(B,B),inf_inf(B),Uu),Uua)) ) ) ).

% ATP.lambda_176
tff(fact_5899_ATP_Olambda__177,axiom,
    ! [Uu: code_natural,Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),aTP_Lamp_ua(code_natural,fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural))),product_Pair(code_natural,product_prod(code_natural,code_natural)),modulo_modulo(code_natural,Uua,Uu)) ) ).

% ATP.lambda_177
tff(fact_5900_ATP_Olambda__178,axiom,
    ! [B: $tType,Uu: pred(B),Uua: pred(B)] : ( aa(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aTP_Lamp_uk(pred(B),fun(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uu),Uua) = aa(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),product_Pair(pred(B),product_prod(code_natural,code_natural)),aa(pred(B),pred(B),aa(pred(B),fun(pred(B),pred(B)),sup_sup(pred(B)),Uu),Uua)) ) ).

% ATP.lambda_178
tff(fact_5901_ATP_Olambda__179,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: B,Uua: C] : ( aa(C,fun(D,product_prod(product_prod(B,C),D)),aTP_Lamp_ub(B,fun(C,fun(D,product_prod(product_prod(B,C),D))),Uu),Uua) = aa(product_prod(B,C),fun(D,product_prod(product_prod(B,C),D)),product_Pair(product_prod(B,C),D),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),Uua)) ) ).

% ATP.lambda_179
tff(fact_5902_ATP_Olambda__180,axiom,
    ! [B: $tType,Uu: list(product_prod(code_natural,B)),Uua: code_natural] : ( aa(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural))),aTP_Lamp_ud(list(product_prod(code_natural,B)),fun(code_natural,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural)))),Uu),Uua) = aa(B,fun(product_prod(code_natural,code_natural),product_prod(B,product_prod(code_natural,code_natural))),product_Pair(B,product_prod(code_natural,code_natural)),pick(B,Uu,Uua)) ) ).

% ATP.lambda_180
tff(fact_5903_ATP_Olambda__181,axiom,
    ! [C: $tType,B: $tType,Uu: C,Uua: B] : ( aa(B,fun(set(product_prod(C,B)),set(product_prod(C,B))),aTP_Lamp_gf(C,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),Uu),Uua) = insert2(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uu),Uua)) ) ).

% ATP.lambda_181
tff(fact_5904_ATP_Olambda__182,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: C] : ( aa(C,fun(set(product_prod(B,C)),set(product_prod(B,C))),aTP_Lamp_ja(B,fun(C,fun(set(product_prod(B,C)),set(product_prod(B,C)))),Uu),Uua) = insert2(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),Uua)) ) ).

% ATP.lambda_182
tff(fact_5905_ATP_Olambda__183,axiom,
    ! [B: $tType,Uu: B,Uua: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_wq(B,fun(B,$o)),Uu),Uua)
    <=> ( Uu != Uua ) ) ).

% ATP.lambda_183
tff(fact_5906_ATP_Olambda__184,axiom,
    ! [B: $tType,Uu: B,Uua: B] :
      ( aa(B,$o,aTP_Lamp_te(B,fun(B,$o),Uu),Uua)
    <=> ( Uua != Uu ) ) ).

% ATP.lambda_184
tff(fact_5907_ATP_Olambda__185,axiom,
    ! [B: $tType,Uu: B,Uua: B] : ( aa(B,set(B),aTP_Lamp_jf(B,fun(B,set(B)),Uu),Uua) = aa(set(B),set(B),uminus_uminus(set(B)),aa(set(B),set(B),insert2(B,Uu),bot_bot(set(B)))) ) ).

% ATP.lambda_185
tff(fact_5908_ATP_Olambda__186,axiom,
    ! [Uu: nat,Uua: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mf(nat,fun(heap_ext(product_unit),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),Uu),Uua) = aa(product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),option(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),some(product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aa(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(product_unit,fun(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),product_Pair(product_unit,product_prod(heap_ext(product_unit),nat)),product_Unity),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uua),Uu))) ) ).

% ATP.lambda_186
tff(fact_5909_ATP_Olambda__187,axiom,
    ! [D: $tType,C: $tType,Uu: fun(C,set(D)),Uua: C] : ( aa(C,set(product_prod(D,D)),aTP_Lamp_ns(fun(C,set(D)),fun(C,set(product_prod(D,D))),Uu),Uua) = bNF_Ca6860139660246222851ard_of(D,aa(C,set(D),Uu,Uua)) ) ).

% ATP.lambda_187
tff(fact_5910_ATP_Olambda__188,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B] : ( aa(B,set(product_prod(C,C)),aTP_Lamp_nt(fun(B,set(C)),fun(B,set(product_prod(C,C))),Uu),Uua) = bNF_Ca6860139660246222851ard_of(C,aa(B,set(C),Uu,Uua)) ) ).

% ATP.lambda_188
tff(fact_5911_ATP_Olambda__189,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(B,$o),Uua: B] : ( aa(B,C,aTP_Lamp_ax(fun(B,$o),fun(B,C),Uu),Uua) = aa($o,C,zero_neq_one_of_bool(C),aa(B,$o,Uu,Uua)) ) ) ).

% ATP.lambda_189
tff(fact_5912_ATP_Olambda__190,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(nat,B),Uua: nat] : ( aa(nat,fun(B,B),aTP_Lamp_cx(fun(nat,B),fun(nat,fun(B,B)),Uu),Uua) = aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,Uua)) ) ) ).

% ATP.lambda_190
tff(fact_5913_ATP_Olambda__191,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: C] : ( aa(C,heap_Time_Heap(B),aTP_Lamp_cj(fun(C,B),fun(C,heap_Time_Heap(B)),Uu),Uua) = aa(B,heap_Time_Heap(B),heap_Time_return(B),aa(C,B,Uu,Uua)) ) ).

% ATP.lambda_191
tff(fact_5914_ATP_Olambda__192,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [Uu: fun(B,C),Uua: B] : ( aa(B,option(C),aTP_Lamp_mc(fun(B,C),fun(B,option(C)),Uu),Uua) = aa(C,option(C),some(C),aa(B,C,Uu,Uua)) ) ) ).

% ATP.lambda_192
tff(fact_5915_ATP_Olambda__193,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,assn)),Uua: B] : ( aa(B,assn,aTP_Lamp_la(fun(B,fun(C,assn)),fun(B,assn),Uu),Uua) = ex_assn(C,aa(B,fun(C,assn),Uu,Uua)) ) ).

% ATP.lambda_193
tff(fact_5916_ATP_Olambda__194,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(D,B),Uua: D] : ( aa(D,fun(C,product_prod(B,C)),aTP_Lamp_su(fun(D,B),fun(D,fun(C,product_prod(B,C))),Uu),Uua) = aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Uu,Uua)) ) ).

% ATP.lambda_194
tff(fact_5917_ATP_Olambda__195,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(B,C),Uua: B] : ( aa(B,fun(D,product_prod(C,D)),aTP_Lamp_sz(fun(B,C),fun(B,fun(D,product_prod(C,D))),Uu),Uua) = aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(B,C,Uu,Uua)) ) ).

% ATP.lambda_195
tff(fact_5918_ATP_Olambda__196,axiom,
    ! [D: $tType,E: $tType,Uu: fun(E,set(D)),Uua: E] : ( aa(E,filter(D),aTP_Lamp_ug(fun(E,set(D)),fun(E,filter(D)),Uu),Uua) = principal(D,aa(E,set(D),Uu,Uua)) ) ).

% ATP.lambda_196
tff(fact_5919_ATP_Olambda__197,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B] : ( aa(B,filter(C),aTP_Lamp_uh(fun(B,set(C)),fun(B,filter(C)),Uu),Uua) = principal(C,aa(B,set(C),Uu,Uua)) ) ).

% ATP.lambda_197
tff(fact_5920_ATP_Olambda__198,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: B] : ( aa(B,nat,aTP_Lamp_jc(fun(B,set(C)),fun(B,nat),Uu),Uua) = finite_card(C,aa(B,set(C),Uu,Uua)) ) ).

% ATP.lambda_198
tff(fact_5921_ATP_Olambda__199,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: B] : ( aa(B,fun(set(C),set(C)),aTP_Lamp_fy(fun(B,C),fun(B,fun(set(C),set(C))),Uu),Uua) = insert2(C,aa(B,C,Uu,Uua)) ) ).

% ATP.lambda_199
tff(fact_5922_ATP_Olambda__200,axiom,
    ! [C: $tType,Uu: fun(C,$o),Uua: C] :
      ( aa(C,$o,aTP_Lamp_ap(fun(C,$o),fun(C,$o),Uu),Uua)
    <=> ~ aa(C,$o,Uu,Uua) ) ).

% ATP.lambda_200
tff(fact_5923_ATP_Olambda__201,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B] :
      ( aa(B,$o,aTP_Lamp_ob(fun(B,$o),fun(B,$o),Uu),Uua)
    <=> ~ aa(B,$o,Uu,Uua) ) ).

% ATP.lambda_201
tff(fact_5924_ATP_Olambda__202,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_nx(nat,fun(nat,set(nat)),Uu),Uua) = aa(fun(nat,$o),set(nat),collect(nat),aTP_Lamp_ds(nat,fun(nat,$o),Uu)) ) ).

% ATP.lambda_202
tff(fact_5925_ATP_Olambda__203,axiom,
    ! [B: $tType,Uu: fun(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aTP_Lamp_ka(fun(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uu),Uua)
    <=> ? [X4: B] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(B,fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uu,X4),Uua) ) ).

% ATP.lambda_203
tff(fact_5926_ATP_Olambda__204,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_oi(set(B),fun(B,$o),Uu),Uua)
        <=> ! [X4: B] :
              ( member(B,X4,Uu)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),X4) ) ) ) ).

% ATP.lambda_204
tff(fact_5927_ATP_Olambda__205,axiom,
    ! [B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Uu: set(B),Uua: B] :
          ( aa(B,$o,aTP_Lamp_oj(set(B),fun(B,$o),Uu),Uua)
        <=> ! [X4: B] :
              ( member(B,X4,Uu)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X4),Uua) ) ) ) ).

% ATP.lambda_205
tff(fact_5928_ATP_Olambda__206,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: multiset(B)] :
      ( aa(multiset(B),$o,aTP_Lamp_px(set(multiset(B)),fun(multiset(B),$o),Uu),Uua)
    <=> ! [X4: multiset(B)] :
          ( member(multiset(B),X4,Uu)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),Uua),X4) ) ) ).

% ATP.lambda_206
tff(fact_5929_ATP_Olambda__207,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: multiset(B)] :
      ( aa(multiset(B),$o,aTP_Lamp_pz(set(multiset(B)),fun(multiset(B),$o),Uu),Uua)
    <=> ! [X4: multiset(B)] :
          ( member(multiset(B),X4,Uu)
         => aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),subseteq_mset(B),X4),Uua) ) ) ).

% ATP.lambda_207
tff(fact_5930_ATP_Olambda__208,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_om(set(product_prod(B,B)),fun(set(B),$o),Uu),Uua)
    <=> ! [X4: B] :
          ( member(B,X4,Uua)
         => ! [Xa2: B] :
              ( member(B,Xa2,Uua)
             => ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa2),Uu)
                | member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa2),X4),Uu) ) ) ) ) ).

% ATP.lambda_208
tff(fact_5931_ATP_Olambda__209,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: B] :
      ( aa(B,$o,aTP_Lamp_qw(set(product_prod(B,C)),fun(B,$o),Uu),Uua)
    <=> ? [Y3: C] : member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Y3),Uu) ) ).

% ATP.lambda_209
tff(fact_5932_ATP_Olambda__210,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aTP_Lamp_lf(fun(B,assn),fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uu),Uua)
    <=> ? [X4: B] : aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,aa(B,assn,Uu,X4)),Uua) ) ).

% ATP.lambda_210
tff(fact_5933_ATP_Olambda__211,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aTP_Lamp_me(B,fun(product_prod(B,C),$o),Uu),Uua)
    <=> ? [V5: C] : ( Uua = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),V5) ) ) ).

% ATP.lambda_211
tff(fact_5934_ATP_Olambda__212,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: product_prod(product_prod($o,B),product_prod($o,C))] :
      ( aa(product_prod(product_prod($o,B),product_prod($o,C)),$o,aTP_Lamp_ku(set(product_prod(B,C)),fun(product_prod(product_prod($o,B),product_prod($o,C)),$o),Uu),Uua)
    <=> ? [X4: B,Y3: C] :
          ( ( Uua = aa(product_prod($o,C),product_prod(product_prod($o,B),product_prod($o,C)),aa(product_prod($o,B),fun(product_prod($o,C),product_prod(product_prod($o,B),product_prod($o,C))),product_Pair(product_prod($o,B),product_prod($o,C)),aa(B,product_prod($o,B),aa($o,fun(B,product_prod($o,B)),product_Pair($o,B),$false),X4)),aa(C,product_prod($o,C),aa($o,fun(C,product_prod($o,C)),product_Pair($o,C),$false),Y3)) )
          & member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),X4),Y3),Uu) ) ) ).

% ATP.lambda_212
tff(fact_5935_ATP_Olambda__213,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,option(C)),Uua: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aTP_Lamp_mx(fun(B,option(C)),fun(product_prod(B,C),$o),Uu),Uua)
    <=> ? [A6: B,B5: C] :
          ( ( Uua = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A6),B5) )
          & ( aa(B,option(C),Uu,A6) = aa(C,option(C),some(C),B5) ) ) ) ).

% ATP.lambda_213
tff(fact_5936_ATP_Olambda__214,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: product_prod(set(B),set(B))] :
      ( aa(product_prod(set(B),set(B)),$o,aTP_Lamp_or(set(product_prod(B,B)),fun(product_prod(set(B),set(B)),$o),Uu),Uua)
    <=> ? [X8: set(B),Y8: set(B)] :
          ( ( Uua = aa(set(B),product_prod(set(B),set(B)),aa(set(B),fun(set(B),product_prod(set(B),set(B))),product_Pair(set(B),set(B)),X8),Y8) )
          & ( X8 != bot_bot(set(B)) )
          & ! [X4: B] :
              ( member(B,X4,Y8)
             => ? [Xa2: B] :
                  ( member(B,Xa2,X8)
                  & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Xa2),X4),Uu) ) ) ) ) ).

% ATP.lambda_214
tff(fact_5937_ATP_Olambda__215,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))))),Uua: fun(B,heap_Time_Heap(C))] :
      ( aa(fun(B,heap_Time_Heap(C)),$o,aTP_Lamp_wa(fun(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))))),fun(fun(B,heap_Time_Heap(C)),$o),Uu),Uua)
    <=> ! [X4: B,H3: heap_ext(product_unit),H9: heap_ext(product_unit),R5: C,N5: nat] :
          ( heap_Time_effect(C,aa(B,heap_Time_Heap(C),Uua,X4),H3,H9,R5,N5)
         => aa(nat,$o,aa(C,fun(nat,$o),aa(heap_ext(product_unit),fun(C,fun(nat,$o)),aa(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o))),aa(B,fun(heap_ext(product_unit),fun(heap_ext(product_unit),fun(C,fun(nat,$o)))),Uu,X4),H3),H9),R5),N5) ) ) ).

% ATP.lambda_215
tff(fact_5938_ATP_Olambda__216,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] : ( aa(B,set(B),aTP_Lamp_jq(set(B),fun(B,set(B)),Uu),Uua) = aa(set(B),set(B),uminus_uminus(set(B)),Uu) ) ).

% ATP.lambda_216
tff(fact_5939_ATP_Olambda__217,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: B,Uua: product_unit] : ( aa(product_unit,heap_Time_Heap(B),aTP_Lamp_hg(B,fun(product_unit,heap_Time_Heap(B)),Uu),Uua) = aa(B,heap_Time_Heap(B),heap_Time_return(B),Uu) ) ) ).

% ATP.lambda_217
tff(fact_5940_ATP_Olambda__218,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] : ( aa(list(B),option(B),aa(B,fun(list(B),option(B)),aTP_Lamp_wp(B,fun(list(B),option(B))),Uu),Uua) = aa(B,option(B),some(B),Uu) ) ).

% ATP.lambda_218
tff(fact_5941_ATP_Olambda__219,axiom,
    ! [D: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: D] : ( aa(D,set(C),aTP_Lamp_nn(set(product_prod(C,C)),fun(D,set(C)),Uu),Uua) = field2(C,Uu) ) ).

% ATP.lambda_219
tff(fact_5942_ATP_Olambda__220,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: B] : ( aa(B,set(C),aTP_Lamp_nr(set(product_prod(C,C)),fun(B,set(C)),Uu),Uua) = field2(C,Uu) ) ).

% ATP.lambda_220
tff(fact_5943_ATP_Olambda__221,axiom,
    ! [D: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: D] : ( aa(D,set(B),aTP_Lamp_nm(set(product_prod(B,B)),fun(D,set(B)),Uu),Uua) = field2(B,Uu) ) ).

% ATP.lambda_221
tff(fact_5944_ATP_Olambda__222,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,B)),Uua: C] : ( aa(C,set(B),aTP_Lamp_nq(set(product_prod(B,B)),fun(C,set(B)),Uu),Uua) = field2(B,Uu) ) ).

% ATP.lambda_222
tff(fact_5945_ATP_Olambda__223,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B] : ( aa(B,set(B),aTP_Lamp_ig(set(product_prod(B,B)),fun(B,set(B)),Uu),Uua) = field2(B,Uu) ) ).

% ATP.lambda_223
tff(fact_5946_ATP_Olambda__224,axiom,
    ! [B: $tType,Uu: B,Uua: list(B)] : ( aa(list(B),fun(set(B),set(B)),aa(B,fun(list(B),fun(set(B),set(B))),aTP_Lamp_sq(B,fun(list(B),fun(set(B),set(B)))),Uu),Uua) = insert2(B,Uu) ) ).

% ATP.lambda_224
tff(fact_5947_ATP_Olambda__225,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: option(B),Uub: option(C)] :
      ( aa(option(C),$o,aa(option(B),fun(option(C),$o),aTP_Lamp_vh(fun(B,fun(C,$o)),fun(option(B),fun(option(C),$o)),Uu),Uua),Uub)
    <=> case_option($o,B,case_option($o,C,$true,aTP_Lamp_vf(C,$o),Uub),aa(option(C),fun(B,$o),aTP_Lamp_vg(fun(B,fun(C,$o)),fun(option(C),fun(B,$o)),Uu),Uub),Uua) ) ).

% ATP.lambda_225
tff(fact_5948_ATP_Olambda__226,axiom,
    ! [Uu: num,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_fp(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),aa(num,code_integer,numeral_numeral(code_integer),Uu)),Uub),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uub),aa(num,code_integer,numeral_numeral(code_integer),Uu))),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_226
tff(fact_5949_ATP_Olambda__227,axiom,
    ! [Uu: num,Uua: nat,Uub: nat] :
      ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_fi(num,fun(nat,fun(nat,product_prod(nat,nat))),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Uu)),Uub),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),Uu))),aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_227
tff(fact_5950_ATP_Olambda__228,axiom,
    ! [Uu: num,Uua: int,Uub: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fk(num,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),Uu)),Uub),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uub),aa(num,int,numeral_numeral(int),Uu))),aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),aa(num,num,bit0,one2))),Uua)),Uub)) ) ).

% ATP.lambda_228
tff(fact_5951_ATP_Olambda__229,axiom,
    ! [B: $tType] :
      ( unique1627219031080169319umeral(B)
     => ! [Uu: num,Uua: B,Uub: B] :
          ( aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),aTP_Lamp_eq(num,fun(B,fun(B,product_prod(B,B))),Uu),Uua),Uub)
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(num,B,numeral_numeral(B),Uu)),Uub),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Uua)),one_one(B))),aa(B,B,aa(B,fun(B,B),minus_minus(B),Uub),aa(num,B,numeral_numeral(B),Uu))),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(num,B,numeral_numeral(B),aa(num,num,bit0,one2))),Uua)),Uub)) ) ) ).

% ATP.lambda_229
tff(fact_5952_ATP_Olambda__230,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(B,C),Uua: set(B),Uub: B] :
          ( aa(B,C,aa(set(B),fun(B,C),aTP_Lamp_cc(fun(B,C),fun(set(B),fun(B,C)),Uu),Uua),Uub)
          = $ite(member(B,Uub,Uua),aa(B,C,Uu,Uub),zero_zero(C)) ) ) ).

% ATP.lambda_230
tff(fact_5953_ATP_Olambda__231,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(B,C),Uua: set(B),Uub: B] :
          ( aa(B,C,aa(set(B),fun(B,C),aTP_Lamp_cd(fun(B,C),fun(set(B),fun(B,C)),Uu),Uua),Uub)
          = $ite(member(B,Uub,Uua),aa(B,C,Uu,Uub),one_one(C)) ) ) ).

% ATP.lambda_231
tff(fact_5954_ATP_Olambda__232,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_an(B,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub)
          = $ite(Uu = Uub,aa(B,C,Uua,Uub),one_one(C)) ) ) ).

% ATP.lambda_232
tff(fact_5955_ATP_Olambda__233,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_am(B,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(B,C,Uua,Uub),one_one(C)) ) ) ).

% ATP.lambda_233
tff(fact_5956_ATP_Olambda__234,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: C,Uua: B,Uub: C] :
          ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_ql(C,fun(B,fun(C,B)),Uu),Uua),Uub)
          = $ite(Uu = Uub,Uua,zero_zero(B)) ) ) ).

% ATP.lambda_234
tff(fact_5957_ATP_Olambda__235,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: C,Uua: B,Uub: C] :
          ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_qi(C,fun(B,fun(C,B)),Uu),Uua),Uub)
          = $ite(Uu = Uub,Uua,one_one(B)) ) ) ).

% ATP.lambda_235
tff(fact_5958_ATP_Olambda__236,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: C,Uua: B,Uub: C] :
          ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_qk(C,fun(B,fun(C,B)),Uu),Uua),Uub)
          = $ite(Uub = Uu,Uua,zero_zero(B)) ) ) ).

% ATP.lambda_236
tff(fact_5959_ATP_Olambda__237,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: C,Uua: B,Uub: C] :
          ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_qj(C,fun(B,fun(C,B)),Uu),Uua),Uub)
          = $ite(Uub = Uu,Uua,one_one(B)) ) ) ).

% ATP.lambda_237
tff(fact_5960_ATP_Olambda__238,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gk(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_238
tff(fact_5961_ATP_Olambda__239,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gi(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_239
tff(fact_5962_ATP_Olambda__240,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_gj(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),product_Pair(code_integer,code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uu),Uub))) ) ).

% ATP.lambda_240
tff(fact_5963_ATP_Olambda__241,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B,Uub: set(B)] :
      ( aa(set(B),set(B),aa(B,fun(set(B),set(B)),aTP_Lamp_gc(fun(B,$o),fun(B,fun(set(B),set(B))),Uu),Uua),Uub)
      = $ite(aa(B,$o,Uu,Uua),aa(set(B),set(B),insert2(B,Uua),Uub),Uub) ) ).

% ATP.lambda_241
tff(fact_5964_ATP_Olambda__242,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(B,C),Uua: fun(B,$o),Uub: B] :
          ( aa(B,C,aa(fun(B,$o),fun(B,C),aTP_Lamp_by(fun(B,C),fun(fun(B,$o),fun(B,C)),Uu),Uua),Uub)
          = $ite(aa(B,$o,Uua,Uub),aa(B,C,Uu,Uub),one_one(C)) ) ) ).

% ATP.lambda_242
tff(fact_5965_ATP_Olambda__243,axiom,
    ! [B: $tType,Uu: fun(heap_ext(product_unit),$o),Uua: fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),Uub: heap_ext(product_unit)] :
      ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mj(fun(heap_ext(product_unit),$o),fun(fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub)
      = $ite(aa(heap_ext(product_unit),$o,Uu,Uub),aa(product_prod(B,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),some(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),Uua,Uub)),none(product_prod(B,product_prod(heap_ext(product_unit),nat)))) ) ).

% ATP.lambda_243
tff(fact_5966_ATP_Olambda__244,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: B,Uub: set(product_prod(B,C))] : ( aa(set(product_prod(B,C)),set(product_prod(B,C)),aa(B,fun(set(product_prod(B,C)),set(product_prod(B,C))),aTP_Lamp_jb(set(C),fun(B,fun(set(product_prod(B,C)),set(product_prod(B,C)))),Uu),Uua),Uub) = finite_fold(C,set(product_prod(B,C)),aTP_Lamp_ja(B,fun(C,fun(set(product_prod(B,C)),set(product_prod(B,C)))),Uua),Uub,Uu) ) ).

% ATP.lambda_244
tff(fact_5967_ATP_Olambda__245,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: C,Uub: set(product_prod(C,B))] : ( aa(set(product_prod(C,B)),set(product_prod(C,B)),aa(C,fun(set(product_prod(C,B)),set(product_prod(C,B))),aTP_Lamp_gg(set(B),fun(C,fun(set(product_prod(C,B)),set(product_prod(C,B)))),Uu),Uua),Uub) = finite_fold(B,set(product_prod(C,B)),aTP_Lamp_gf(C,fun(B,fun(set(product_prod(C,B)),set(product_prod(C,B)))),Uua),Uub,Uu) ) ).

% ATP.lambda_245
tff(fact_5968_ATP_Olambda__246,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: list(B),Uub: list(B)] : ( aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),aTP_Lamp_rr(fun(B,fun(B,$o)),fun(list(B),fun(list(B),list(B))),Uu),Uua),Uub) = merges9089515139780605204_merge(B,Uu,mergesort_by_rel(B,Uu,Uua),mergesort_by_rel(B,Uu,Uub)) ) ).

% ATP.lambda_246
tff(fact_5969_ATP_Olambda__247,axiom,
    ! [B: $tType] :
      ( sup(B)
     => ! [Uu: option(B),Uua: option(B),Uub: B] : ( aa(B,option(B),aa(option(B),fun(B,option(B)),aTP_Lamp_mq(option(B),fun(option(B),fun(B,option(B))),Uu),Uua),Uub) = case_option(option(B),B,Uu,aTP_Lamp_mp(B,fun(B,option(B)),Uub),Uua) ) ) ).

% ATP.lambda_247
tff(fact_5970_ATP_Olambda__248,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,$o)),Uua: option(C),Uub: B] :
      ( aa(B,$o,aa(option(C),fun(B,$o),aTP_Lamp_vg(fun(B,fun(C,$o)),fun(option(C),fun(B,$o)),Uu),Uua),Uub)
    <=> case_option($o,C,$false,aa(B,fun(C,$o),Uu,Uub),Uua) ) ).

% ATP.lambda_248
tff(fact_5971_ATP_Olambda__249,axiom,
    ! [B: $tType,C: $tType,Uu: heap_Time_Heap(C),Uua: fun(C,heap_Time_Heap(B)),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(C,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mo(heap_Time_Heap(C),fun(fun(C,heap_Time_Heap(B)),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub) = case_option(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),product_prod(C,product_prod(heap_ext(product_unit),nat)),none(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(fun(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),fun(product_prod(C,product_prod(heap_ext(product_unit),nat)),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),product_case_prod(C,product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_mn(fun(C,heap_Time_Heap(B)),fun(C,fun(product_prod(heap_ext(product_unit),nat),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uua)),aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(C),fun(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(C),Uu),Uub)) ) ).

% ATP.lambda_249
tff(fact_5972_ATP_Olambda__250,axiom,
    ! [C: $tType,B: $tType,Uu: fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),Uua: B,Uub: fun(B,heap_Time_Heap(C))] : ( aa(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aTP_Lamp_vx(fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),Uu),Uua),Uub) = aa(B,heap_Time_Heap(C),aa(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)),Uu,Uub),Uua) ) ).

% ATP.lambda_250
tff(fact_5973_ATP_Olambda__251,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,Uu: fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),Uua: fun(B,heap_Time_Heap(C)),Uub: D] : ( aa(D,heap_Time_Heap(E),aa(fun(B,heap_Time_Heap(C)),fun(D,heap_Time_Heap(E)),aTP_Lamp_vy(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),fun(D,heap_Time_Heap(E))),Uu),Uua),Uub) = aa(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E),aa(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E)),Uu,Uub),Uua) ) ).

% ATP.lambda_251
tff(fact_5974_ATP_Olambda__252,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,fun(C,assn)),Uua: C,Uub: B] : ( aa(B,assn,aa(C,fun(B,assn),aTP_Lamp_kz(fun(B,fun(C,assn)),fun(C,fun(B,assn)),Uu),Uua),Uub) = aa(C,assn,aa(B,fun(C,assn),Uu,Uub),Uua) ) ).

% ATP.lambda_252
tff(fact_5975_ATP_Olambda__253,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ts(fun(B,fun(B,$o)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(B,$o,aa(B,fun(B,$o),Uu,Uub),Uua) ) ).

% ATP.lambda_253
tff(fact_5976_ATP_Olambda__254,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,$o),aa(code_integer,fun(code_integer,product_prod(code_integer,$o)),aTP_Lamp_gh(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),Uu),Uua),Uub)
      = aa($o,product_prod(code_integer,$o),
          aa(code_integer,fun($o,product_prod(code_integer,$o)),product_Pair(code_integer,$o),$ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),Uu),Uua,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),Uub))),
          ( Uub = one_one(code_integer) )) ) ).

% ATP.lambda_254
tff(fact_5977_ATP_Olambda__255,axiom,
    ! [Uu: product_prod(code_natural,code_natural),Uua: code_natural,Uub: code_natural] : ( aa(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aTP_Lamp_tx(product_prod(code_natural,code_natural),fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),Uu),Uua),Uub) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_case_prod(code_natural,code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aa(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),aTP_Lamp_tw(code_natural,fun(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))))),Uua),Uub)),aa(product_prod(code_natural,product_prod(code_natural,code_natural)),product_prod(code_natural,code_natural),product_snd(code_natural,product_prod(code_natural,code_natural)),aa(product_prod(code_natural,code_natural),product_prod(code_natural,product_prod(code_natural,code_natural)),next,Uu))) ) ).

% ATP.lambda_255
tff(fact_5978_ATP_Olambda__256,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uua: pred(C),Uub: product_prod(code_natural,code_natural)] : ( aa(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(pred(C),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aTP_Lamp_uo(fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(pred(C),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uu),Uua),Uub) = aa(product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural))),product_case_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aa(pred(C),fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),aTP_Lamp_un(fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(pred(C),fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))))),Uu),Uua)),split_seed(Uub)) ) ).

% ATP.lambda_256
tff(fact_5979_ATP_Olambda__257,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fh(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fg(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_257
tff(fact_5980_ATP_Olambda__258,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fe(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fd(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_258
tff(fact_5981_ATP_Olambda__259,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fc(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fb(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_259
tff(fact_5982_ATP_Olambda__260,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_fa(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),aa(fun(int,fun(int,product_prod(int,int))),fun(product_prod(int,int),product_prod(int,int)),product_case_prod(int,int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_ez(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_260
tff(fact_5983_ATP_Olambda__261,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: nat,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(nat,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rg(array(B),fun(nat,fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),nth(B,array_get(B,Uub,Uu),Uua)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),one_one(nat))) ) ) ).

% ATP.lambda_261
tff(fact_5984_ATP_Olambda__262,axiom,
    ! [B: $tType] :
      ( field(B)
     => ! [Uu: fun(nat,B),Uua: fun(nat,B),Uub: nat] : ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aTP_Lamp_ay(fun(nat,B),fun(fun(nat,B),fun(nat,B)),Uu),Uua),Uub) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,Uub)),aa(nat,B,aa(B,fun(nat,B),power_power(B),zero_zero(B)),Uub)),aa(nat,B,Uua,Uub)) ) ) ).

% ATP.lambda_262
tff(fact_5985_ATP_Olambda__263,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_se(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),size_size(list(B),Uua)),size_size(list(B),Uub))
        | ( ( size_size(list(B),Uua) = size_size(list(B),Uub) )
          & member(product_prod(list(B),list(B)),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Uua),Uub),lex(B,Uu)) ) ) ) ).

% ATP.lambda_263
tff(fact_5986_ATP_Olambda__264,axiom,
    ! [B: $tType,Uu: nat,Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_rv(nat,fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( ( size_size(list(B),Uua) = aa(nat,nat,suc,Uu) )
        & ( size_size(list(B),Uub) = aa(nat,nat,suc,Uu) ) ) ) ).

% ATP.lambda_264
tff(fact_5987_ATP_Olambda__265,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_sd(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ( ( size_size(list(B),Uua) = size_size(list(B),Uub) )
        & ? [Xys2: list(B),X4: B,Y3: B,Xs6: list(B),Ys5: list(B)] :
            ( ( Uua = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xys2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X4),Xs6)) )
            & ( Uub = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xys2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y3),Ys5)) )
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Y3),Uu) ) ) ) ).

% ATP.lambda_265
tff(fact_5988_ATP_Olambda__266,axiom,
    ! [Uu: heap_ext(product_unit),Uua: heap_ext(product_unit),Uub: nat] :
      ( aa(nat,$o,aa(heap_ext(product_unit),fun(nat,$o),aTP_Lamp_lr(heap_ext(product_unit),fun(heap_ext(product_unit),fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),lim(product_unit,Uu)),Uub)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),lim(product_unit,Uua)) ) ) ).

% ATP.lambda_266
tff(fact_5989_ATP_Olambda__267,axiom,
    ! [Uu: heap_ext(product_unit),Uua: set(nat),Uub: nat] :
      ( aa(nat,$o,aa(set(nat),fun(nat,$o),aTP_Lamp_mb(heap_ext(product_unit),fun(set(nat),fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),lim(product_unit,Uu))
        & ~ member(nat,Uub,Uua) ) ) ).

% ATP.lambda_267
tff(fact_5990_ATP_Olambda__268,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_op(set(product_prod(B,B)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( member(B,Uub,field2(B,Uu))
        & ! [X4: B] :
            ( member(B,X4,Uua)
           => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),X4),Uu) ) ) ) ).

% ATP.lambda_268
tff(fact_5991_ATP_Olambda__269,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_oq(set(product_prod(B,B)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( member(B,Uub,field2(B,Uu))
        & ! [X4: B] :
            ( member(B,X4,Uua)
           => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Uub),Uu) ) ) ) ).

% ATP.lambda_269
tff(fact_5992_ATP_Olambda__270,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_oo(set(product_prod(B,B)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( member(B,Uub,field2(B,Uu))
        & ! [X4: B] :
            ( member(B,X4,Uua)
           => ( ( Uub != X4 )
              & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),X4),Uu) ) ) ) ) ).

% ATP.lambda_270
tff(fact_5993_ATP_Olambda__271,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_ov(set(product_prod(B,B)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( member(B,Uub,field2(B,Uu))
        & ! [X4: B] :
            ( member(B,X4,Uua)
           => ( ( Uub != X4 )
              & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Uub),Uu) ) ) ) ) ).

% ATP.lambda_271
tff(fact_5994_ATP_Olambda__272,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_nw(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),Uub) ) ) ).

% ATP.lambda_272
tff(fact_5995_ATP_Olambda__273,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(B,B)),Uub: fun(C,B)] : ( aa(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C))))),aTP_Lamp_je(set(product_prod(B,B)),fun(set(product_prod(B,B)),fun(fun(C,B),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))))),Uu),Uua),Uub) = aa(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C))),aa(set(product_prod(C,C)),fun(set(product_prod(C,C)),product_prod(set(product_prod(C,C)),set(product_prod(C,C)))),product_Pair(set(product_prod(C,C)),set(product_prod(C,C))),inv_image(B,C,Uu,Uub)),inv_image(B,C,Uua,Uub)) ) ).

% ATP.lambda_273
tff(fact_5996_ATP_Olambda__274,axiom,
    ! [Uu: assn,Uua: assn,Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_ca(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Uu),Uua),Uub)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Uu),Uub)
        | aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Uua),Uub) ) ) ).

% ATP.lambda_274
tff(fact_5997_ATP_Olambda__275,axiom,
    ! [Uu: assn,Uua: assn,Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_cb(assn,fun(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Uu),Uua),Uub)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Uu),Uub)
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(assn,fun(product_prod(heap_ext(product_unit),set(nat)),$o),rep_assn,Uua),Uub) ) ) ).

% ATP.lambda_275
tff(fact_5998_ATP_Olambda__276,axiom,
    ! [B: $tType,Uu: set(B),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_on(set(B),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( member(B,Uua,Uu)
        & member(B,Uub,Uu) ) ) ).

% ATP.lambda_276
tff(fact_5999_ATP_Olambda__277,axiom,
    ! [B: $tType,Uu: set(B),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_bl(set(B),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( member(B,Uub,Uu)
        & member(B,Uub,Uua) ) ) ).

% ATP.lambda_277
tff(fact_6000_ATP_Olambda__278,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_ue(fun(B,$o),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> ( member(B,Uub,Uua)
       => aa(B,$o,Uu,Uub) ) ) ).

% ATP.lambda_278
tff(fact_6001_ATP_Olambda__279,axiom,
    ! [B: $tType,Uu: set(B),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_bx(set(B),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( member(B,Uub,Uu)
        & aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_279
tff(fact_6002_ATP_Olambda__280,axiom,
    ! [B: $tType,Uu: B,Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_bg(B,fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uu = Uub )
        & aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_280
tff(fact_6003_ATP_Olambda__281,axiom,
    ! [B: $tType,Uu: B,Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_bh(B,fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uub = Uu )
        & aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_281
tff(fact_6004_ATP_Olambda__282,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(B,set(C)),Uub: B] :
      ( aa(B,$o,aa(fun(B,set(C)),fun(B,$o),aTP_Lamp_ir(set(B),fun(fun(B,set(C)),fun(B,$o)),Uu),Uua),Uub)
    <=> ( member(B,Uub,Uu)
        & ( aa(B,set(C),Uua,Uub) != bot_bot(set(C)) ) ) ) ).

% ATP.lambda_282
tff(fact_6005_ATP_Olambda__283,axiom,
    ! [B: $tType,C: $tType] :
      ( ab_group_add(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_fo(set(B),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
        <=> ( member(B,Uub,Uu)
            & ( aa(B,C,Uua,Uub) != zero_zero(C) ) ) ) ) ).

% ATP.lambda_283
tff(fact_6006_ATP_Olambda__284,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_bt(set(B),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
        <=> ( member(B,Uub,Uu)
            & ( aa(B,C,Uua,Uub) != one_one(C) ) ) ) ) ).

% ATP.lambda_284
tff(fact_6007_ATP_Olambda__285,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(C,B),Uua: set(C),Uub: C] :
          ( aa(C,$o,aa(set(C),fun(C,$o),aTP_Lamp_hy(fun(C,B),fun(set(C),fun(C,$o)),Uu),Uua),Uub)
        <=> ( member(C,Uub,Uua)
            & ( aa(C,B,Uu,Uub) != one_one(B) ) ) ) ) ).

% ATP.lambda_285
tff(fact_6008_ATP_Olambda__286,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: list(B),Uub: nat] : ( aa(nat,assn,aa(list(B),fun(nat,assn),aTP_Lamp_re(array(B),fun(list(B),fun(nat,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(B,Uu,Uua)),pure_assn(( Uub = size_size(list(B),Uua) ))) ) ) ).

% ATP.lambda_286
tff(fact_6009_ATP_Olambda__287,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: ref(B),Uua: B,Uub: B] : ( aa(B,assn,aa(B,fun(B,assn),aTP_Lamp_ep(ref(B),fun(B,fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),sngr_assn(B,Uu,Uua)),pure_assn(( Uub = Uua ))) ) ) ).

% ATP.lambda_287
tff(fact_6010_ATP_Olambda__288,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: list(B),Uub: list(B)] : ( aa(list(B),assn,aa(list(B),fun(list(B),assn),aTP_Lamp_fl(array(B),fun(list(B),fun(list(B),assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(B,Uu,Uua)),pure_assn(( Uub = Uua ))) ) ) ).

% ATP.lambda_288
tff(fact_6011_ATP_Olambda__289,axiom,
    ! [B: $tType,E: $tType,D: $tType,Uu: fun(D,fun(E,$o)),Uua: fun(D,B),Uub: set(B)] : ( aa(set(B),set(D),aa(fun(D,B),fun(set(B),set(D)),aTP_Lamp_wx(fun(D,fun(E,$o)),fun(fun(D,B),fun(set(B),set(D))),Uu),Uua),Uub) = aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),inf_inf(set(D)),aa(set(B),set(D),aa(fun(D,B),fun(set(B),set(D)),vimage(D,B),Uua),Uub)),aa(fun(D,$o),set(D),collect(D),domainp(D,E,Uu))) ) ).

% ATP.lambda_289
tff(fact_6012_ATP_Olambda__290,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B,Uub: B] : ( aa(B,B,aa(B,fun(B,B),aTP_Lamp_dk(B,fun(B,fun(B,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),divide_divide(B,Uub,Uu)),Uua) ) ) ).

% ATP.lambda_290
tff(fact_6013_ATP_Olambda__291,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B,Uub: B] : ( aa(B,B,aa(B,fun(B,B),aTP_Lamp_di(B,fun(B,fun(B,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_291
tff(fact_6014_ATP_Olambda__292,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B,Uub: B] : ( aa(B,B,aa(B,fun(B,B),aTP_Lamp_dj(B,fun(B,fun(B,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,Uub,Uu)),Uua) ) ) ).

% ATP.lambda_292
tff(fact_6015_ATP_Olambda__293,axiom,
    ! [B: $tType] :
      ( linordered_field(B)
     => ! [Uu: B,Uua: B,Uub: B] : ( aa(B,B,aa(B,fun(B,B),aTP_Lamp_dh(B,fun(B,fun(B,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_293
tff(fact_6016_ATP_Olambda__294,axiom,
    ! [C: $tType,D: $tType,Uu: set(product_prod(D,C)),Uua: D,Uub: C] :
      ( aa(C,$o,aa(D,fun(C,$o),aTP_Lamp_pd(set(product_prod(D,C)),fun(D,fun(C,$o)),Uu),Uua),Uub)
    <=> member(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),Uua),Uub),Uu) ) ).

% ATP.lambda_294
tff(fact_6017_ATP_Olambda__295,axiom,
    ! [D: $tType,C: $tType,Uu: set(product_prod(C,D)),Uua: C,Uub: D] :
      ( aa(D,$o,aa(C,fun(D,$o),aTP_Lamp_pe(set(product_prod(C,D)),fun(C,fun(D,$o)),Uu),Uua),Uub)
    <=> member(product_prod(C,D),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),Uua),Uub),Uu) ) ).

% ATP.lambda_295
tff(fact_6018_ATP_Olambda__296,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,B)),Uua: C,Uub: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_ll(set(product_prod(C,B)),fun(C,fun(B,$o)),Uu),Uua),Uub)
    <=> member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uua),Uub),Uu) ) ).

% ATP.lambda_296
tff(fact_6019_ATP_Olambda__297,axiom,
    ! [D: $tType,B: $tType,Uu: set(product_prod(B,D)),Uua: B,Uub: D] :
      ( aa(D,$o,aa(B,fun(D,$o),aTP_Lamp_pc(set(product_prod(B,D)),fun(B,fun(D,$o)),Uu),Uua),Uub)
    <=> member(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),Uua),Uub),Uu) ) ).

% ATP.lambda_297
tff(fact_6020_ATP_Olambda__298,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(product_prod(B,C)),fun(B,fun(C,$o)),aTP_Lamp_be(set(product_prod(B,C)),fun(B,fun(C,$o))),Uu),Uua),Uub)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uub),Uu) ) ).

% ATP.lambda_298
tff(fact_6021_ATP_Olambda__299,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_el(set(product_prod(B,B)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uub),Uu) ) ).

% ATP.lambda_299
tff(fact_6022_ATP_Olambda__300,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,B)),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_pf(set(product_prod(C,B)),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),Uub),Uua),Uu) ) ).

% ATP.lambda_300
tff(fact_6023_ATP_Olambda__301,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_nk(set(product_prod(B,B)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uua),Uu) ) ).

% ATP.lambda_301
tff(fact_6024_ATP_Olambda__302,axiom,
    ! [D: $tType,E: $tType,C: $tType,B: $tType,Uu: fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D)),Uua: fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),Uub: fun(B,heap_Time_Heap(C))] : ( aa(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E),aa(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E)),aTP_Lamp_vz(fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D)),fun(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),Uu),Uua),Uub) = heap_Time_bind(D,E,aa(fun(B,heap_Time_Heap(C)),heap_Time_Heap(D),Uu,Uub),aa(fun(B,heap_Time_Heap(C)),fun(D,heap_Time_Heap(E)),aTP_Lamp_vy(fun(D,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(E))),fun(fun(B,heap_Time_Heap(C)),fun(D,heap_Time_Heap(E))),Uua),Uub)) ) ).

% ATP.lambda_302
tff(fact_6025_ATP_Olambda__303,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_bb(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_303
tff(fact_6026_ATP_Olambda__304,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(B,C),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_ip(fun(B,C),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Uu,Uub)),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_304
tff(fact_6027_ATP_Olambda__305,axiom,
    ! [C: $tType,B: $tType] :
      ( linordered_idom(C)
     => ! [Uu: fun(B,C),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_dl(fun(B,C),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Uua,Uub)),aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_305
tff(fact_6028_ATP_Olambda__306,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ie(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_306
tff(fact_6029_ATP_Olambda__307,axiom,
    ! [B: $tType,C: $tType] :
      ( lattice(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_lw(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_307
tff(fact_6030_ATP_Olambda__308,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: fun(B,assn),Uub: B] : ( aa(B,assn,aa(fun(B,assn),fun(B,assn),aTP_Lamp_lc(fun(B,assn),fun(fun(B,assn),fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(B,assn,Uu,Uub)),aa(B,assn,Uua,Uub)) ) ).

% ATP.lambda_308
tff(fact_6031_ATP_Olambda__309,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: fun(B,C),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_lx(fun(B,C),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),sup_sup(C),aa(B,C,Uu,Uub)),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_309
tff(fact_6032_ATP_Olambda__310,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,set(B)),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_kl(fun(C,set(B)),fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(C,set(B),Uu,Uub)),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_310
tff(fact_6033_ATP_Olambda__311,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ke(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_311
tff(fact_6034_ATP_Olambda__312,axiom,
    ! [B: $tType,C: $tType] :
      ( lattice(B)
     => ! [Uu: fun(C,B),Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_na(fun(C,B),fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,Uu,Uub)),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_312
tff(fact_6035_ATP_Olambda__313,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,set(C)),Uua: fun(B,set(C)),Uub: B] : ( aa(B,set(C),aa(fun(B,set(C)),fun(B,set(C)),aTP_Lamp_ih(fun(B,set(C)),fun(fun(B,set(C)),fun(B,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),aa(B,set(C),Uu,Uub)),aa(B,set(C),Uua,Uub)) ) ).

% ATP.lambda_313
tff(fact_6036_ATP_Olambda__314,axiom,
    ! [C: $tType,B: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: fun(B,C),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_nb(fun(B,C),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,Uu,Uub)),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_314
tff(fact_6037_ATP_Olambda__315,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,multiset(C)),Uua: fun(B,multiset(C)),Uub: B] : ( aa(B,multiset(C),aa(fun(B,multiset(C)),fun(B,multiset(C)),aTP_Lamp_qa(fun(B,multiset(C)),fun(fun(B,multiset(C)),fun(B,multiset(C))),Uu),Uua),Uub) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),union_mset(C),aa(B,multiset(C),Uu,Uub)),aa(B,multiset(C),Uua,Uub)) ) ).

% ATP.lambda_315
tff(fact_6038_ATP_Olambda__316,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,multiset(C)),Uua: fun(B,multiset(C)),Uub: B] : ( aa(B,multiset(C),aa(fun(B,multiset(C)),fun(B,multiset(C)),aTP_Lamp_py(fun(B,multiset(C)),fun(fun(B,multiset(C)),fun(B,multiset(C))),Uu),Uua),Uub) = aa(multiset(C),multiset(C),aa(multiset(C),fun(multiset(C),multiset(C)),inter_mset(C),aa(B,multiset(C),Uu,Uub)),aa(B,multiset(C),Uua,Uub)) ) ).

% ATP.lambda_316
tff(fact_6039_ATP_Olambda__317,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,B),Uua: fun(D,C),Uub: D] : ( aa(D,product_prod(B,C),aa(fun(D,C),fun(D,product_prod(B,C)),aTP_Lamp_jk(fun(D,B),fun(fun(D,C),fun(D,product_prod(B,C))),Uu),Uua),Uub) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Uu,Uub)),aa(D,C,Uua,Uub)) ) ).

% ATP.lambda_317
tff(fact_6040_ATP_Olambda__318,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(B,C),Uua: fun(B,D),Uub: B] : ( aa(B,product_prod(C,D),aa(fun(B,D),fun(B,product_prod(C,D)),aTP_Lamp_ui(fun(B,C),fun(fun(B,D),fun(B,product_prod(C,D))),Uu),Uua),Uub) = aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(B,C,Uu,Uub)),aa(B,D,Uua,Uub)) ) ).

% ATP.lambda_318
tff(fact_6041_ATP_Olambda__319,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uua: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_ag(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Uu),Uua),Uub)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Uu,Uub)
        | aa(product_prod(heap_ext(product_unit),set(nat)),$o,Uua,Uub) ) ) ).

% ATP.lambda_319
tff(fact_6042_ATP_Olambda__320,axiom,
    ! [Uu: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uua: fun(product_prod(heap_ext(product_unit),set(nat)),$o),Uub: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aa(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o),aTP_Lamp_ah(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(fun(product_prod(heap_ext(product_unit),set(nat)),$o),fun(product_prod(heap_ext(product_unit),set(nat)),$o)),Uu),Uua),Uub)
    <=> ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,Uu,Uub)
        & aa(product_prod(heap_ext(product_unit),set(nat)),$o,Uua,Uub) ) ) ).

% ATP.lambda_320
tff(fact_6043_ATP_Olambda__321,axiom,
    ! [C: $tType,Uu: fun(C,$o),Uua: fun(C,$o),Uub: C] :
      ( aa(C,$o,aa(fun(C,$o),fun(C,$o),aTP_Lamp_os(fun(C,$o),fun(fun(C,$o),fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(C,$o,Uu,Uub)
        & aa(C,$o,Uua,Uub) ) ) ).

% ATP.lambda_321
tff(fact_6044_ATP_Olambda__322,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_bm(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uu,Uub)
        & aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_322
tff(fact_6045_ATP_Olambda__323,axiom,
    ! [D: $tType,C: $tType,Uu: fun(C,D),Uua: fun(C,D),Uub: C] :
      ( aa(C,$o,aa(fun(C,D),fun(C,$o),aTP_Lamp_rb(fun(C,D),fun(fun(C,D),fun(C,$o)),Uu),Uua),Uub)
    <=> ( aa(C,D,Uu,Uub) = aa(C,D,Uua,Uub) ) ) ).

% ATP.lambda_323
tff(fact_6046_ATP_Olambda__324,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: fun(B,C),Uub: B] :
      ( aa(B,$o,aa(fun(B,C),fun(B,$o),aTP_Lamp_vb(fun(B,C),fun(fun(B,C),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,C,Uu,Uub) = aa(B,C,Uua,Uub) ) ) ).

% ATP.lambda_324
tff(fact_6047_ATP_Olambda__325,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(B,C),Uua: fun(B,$o),Uub: B] : ( aa(B,C,aa(fun(B,$o),fun(B,C),aTP_Lamp_av(fun(B,C),fun(fun(B,$o),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Uu,Uub)),aa($o,C,zero_neq_one_of_bool(C),aa(B,$o,Uua,Uub))) ) ) ).

% ATP.lambda_325
tff(fact_6048_ATP_Olambda__326,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_oy(fun(B,fun(B,$o)),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,$o,Uua,Uub)
        & ! [Y3: B] :
            ( aa(B,$o,Uua,Y3)
           => aa(B,$o,aa(B,fun(B,$o),Uu,Uub),Y3) ) ) ) ).

% ATP.lambda_326
tff(fact_6049_ATP_Olambda__327,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: fun(B,assn),Uub: B] : ( aa(B,assn,aa(fun(B,assn),fun(B,assn),aTP_Lamp_lb(fun(B,assn),fun(fun(B,assn),fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(B,assn,Uu,Uub)),ex_assn(B,Uua)) ) ).

% ATP.lambda_327
tff(fact_6050_ATP_Olambda__328,axiom,
    ! [Uu: fun(b,b),Uua: ref(b),Uub: b] :
      ( aa(b,heap_Time_Heap(b),aa(ref(b),fun(b,heap_Time_Heap(b)),aTP_Lamp_hh(fun(b,b),fun(ref(b),fun(b,heap_Time_Heap(b))),Uu),Uua),Uub)
      = $let(
          y: b,
          y := aa(b,b,Uu,Uub),
          heap_Time_bind(product_unit,b,ref_update(b,Uua,y),aTP_Lamp_hg(b,fun(product_unit,heap_Time_Heap(b)),y)) ) ) ).

% ATP.lambda_328
tff(fact_6051_ATP_Olambda__329,axiom,
    ! [B: $tType,C: $tType] :
      ( euclid4440199948858584721cancel(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] : ( aa(B,C,aa(C,fun(B,C),aTP_Lamp_cz(fun(B,C),fun(C,fun(B,C)),Uu),Uua),Uub) = divide_divide(C,aa(B,C,Uu,Uub),Uua) ) ) ).

% ATP.lambda_329
tff(fact_6052_ATP_Olambda__330,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_tj(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less(C),aa(B,C,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_330
tff(fact_6053_ATP_Olambda__331,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C] : ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_bc(fun(C,B),fun(B,fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_331
tff(fact_6054_ATP_Olambda__332,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: assn,Uub: B] : ( aa(B,assn,aa(assn,fun(B,assn),aTP_Lamp_bs(fun(B,assn),fun(assn,fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(B,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_332
tff(fact_6055_ATP_Olambda__333,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,set(B)),Uua: set(B),Uub: C] : ( aa(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_kb(fun(C,set(B)),fun(set(B),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(C,set(B),Uu,Uub)),Uua) ) ).

% ATP.lambda_333
tff(fact_6056_ATP_Olambda__334,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,set(B)),Uua: set(B),Uub: C] : ( aa(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_ht(fun(C,set(B)),fun(set(B),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(C,set(B),Uu,Uub)),Uua) ) ).

% ATP.lambda_334
tff(fact_6057_ATP_Olambda__335,axiom,
    ! [C: $tType,B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C] : ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_kf(fun(C,B),fun(B,fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_335
tff(fact_6058_ATP_Olambda__336,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: assn,Uub: B] : ( aa(B,assn,aa(assn,fun(B,assn),aTP_Lamp_ld(fun(B,assn),fun(assn,fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),sup_sup(assn),aa(B,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_336
tff(fact_6059_ATP_Olambda__337,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,set(B)),Uua: set(B),Uub: C] : ( aa(C,set(B),aa(set(B),fun(C,set(B)),aTP_Lamp_in(fun(C,set(B)),fun(set(B),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(C,set(B),Uu,Uub)),Uua) ) ).

% ATP.lambda_337
tff(fact_6060_ATP_Olambda__338,axiom,
    ! [C: $tType,B: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C] : ( aa(C,B,aa(B,fun(C,B),aTP_Lamp_hz(fun(C,B),fun(B,fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_338
tff(fact_6061_ATP_Olambda__339,axiom,
    ! [B: $tType,Uu: fun(B,assn),Uua: assn,Uub: B] : ( aa(B,assn,aa(assn,fun(B,assn),aTP_Lamp_le(fun(B,assn),fun(assn,fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),inf_inf(assn),aa(B,assn,Uu,Uub)),Uua) ) ).

% ATP.lambda_339
tff(fact_6062_ATP_Olambda__340,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] : ( aa(B,C,aa(C,fun(B,C),aTP_Lamp_km(fun(B,C),fun(C,fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),inf_inf(C),aa(B,C,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_340
tff(fact_6063_ATP_Olambda__341,axiom,
    ! [B: $tType,C: $tType] :
      ( linord4140545234300271783up_add(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] : ( aa(B,C,aa(C,fun(B,C),aTP_Lamp_lj(fun(B,C),fun(C,fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_341
tff(fact_6064_ATP_Olambda__342,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(D,heap_Time_Heap(C)),Uua: fun(C,heap_Time_Heap(B)),Uub: D] : ( aa(D,heap_Time_Heap(B),aa(fun(C,heap_Time_Heap(B)),fun(D,heap_Time_Heap(B)),aTP_Lamp_ae(fun(D,heap_Time_Heap(C)),fun(fun(C,heap_Time_Heap(B)),fun(D,heap_Time_Heap(B))),Uu),Uua),Uub) = heap_Time_bind(C,B,aa(D,heap_Time_Heap(C),Uu,Uub),Uua) ) ).

% ATP.lambda_342
tff(fact_6065_ATP_Olambda__343,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,filter(C)),Uua: filter(D),Uub: B] : ( aa(B,filter(product_prod(C,D)),aa(filter(D),fun(B,filter(product_prod(C,D))),aTP_Lamp_qt(fun(B,filter(C)),fun(filter(D),fun(B,filter(product_prod(C,D)))),Uu),Uua),Uub) = prod_filter(C,D,aa(B,filter(C),Uu,Uub),Uua) ) ).

% ATP.lambda_343
tff(fact_6066_ATP_Olambda__344,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_tk(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(B,C,Uu,Uub) = Uua ) ) ) ).

% ATP.lambda_344
tff(fact_6067_ATP_Olambda__345,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,C),Uua: C,Uub: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_js(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
    <=> ( aa(B,C,Uu,Uub) = Uua ) ) ).

% ATP.lambda_345
tff(fact_6068_ATP_Olambda__346,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: fun(nat,B),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(nat,B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_tm(nat,fun(fun(nat,B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rs(nat,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(B,aa(list(nat),list(B),map(nat,B,Uua),upt(zero_zero(nat),Uu)),Uub)) ) ) ).

% ATP.lambda_346
tff(fact_6069_ATP_Olambda__347,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: B,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(B,fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_ru(nat,fun(B,fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),fun(product_prod(array(B),heap_ext(product_unit)),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_case_prod(array(B),heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rs(nat,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu)),array_alloc(B,replicate(B,Uu,Uua),Uub)) ) ) ).

% ATP.lambda_347
tff(fact_6070_ATP_Olambda__348,axiom,
    ! [B: $tType,Uu: fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),Uua: pred(B),Uub: product_prod(code_natural,code_natural)] : ( aa(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aTP_Lamp_ul(fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),fun(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uu),Uua),Uub) = aa(product_prod(pred(B),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(fun(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(product_prod(pred(B),product_prod(code_natural,code_natural)),product_prod(pred(B),product_prod(code_natural,code_natural))),product_case_prod(pred(B),product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aTP_Lamp_uk(pred(B),fun(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uua)),aa(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)),Uu,Uub)) ) ).

% ATP.lambda_348
tff(fact_6071_ATP_Olambda__349,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_pl(set(product_prod(B,B)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uub != Uua )
        & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uub),Uu) ) ) ).

% ATP.lambda_349
tff(fact_6072_ATP_Olambda__350,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_nd(set(product_prod(B,B)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ( ( Uub != Uua )
        & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uua),Uu) ) ) ).

% ATP.lambda_350
tff(fact_6073_ATP_Olambda__351,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(B,$o),Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_au(fun(B,$o),fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),times_times(C),aa($o,C,zero_neq_one_of_bool(C),aa(B,$o,Uu,Uub))),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_351
tff(fact_6074_ATP_Olambda__352,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: fun(B,$o),Uub: B] :
      ( aa(B,$o,aa(fun(B,$o),fun(B,$o),aTP_Lamp_xf(fun(B,$o),fun(fun(B,$o),fun(B,$o)),Uu),Uua),Uub)
    <=> ( ~ aa(B,$o,Uu,Uub)
        | aa(B,$o,Uua,Uub) ) ) ).

% ATP.lambda_352
tff(fact_6075_ATP_Olambda__353,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: set(B)] :
      ( aa(set(B),$o,aa(set(B),fun(set(B),$o),aTP_Lamp_ou(set(product_prod(B,B)),fun(set(B),fun(set(B),$o)),Uu),Uua),Uub)
    <=> ( aa(set(B),$o,finite_finite(B),Uua)
        & aa(set(B),$o,finite_finite(B),Uub)
        & ( Uub != bot_bot(set(B)) )
        & ! [X4: B] :
            ( member(B,X4,Uua)
           => ? [Xa2: B] :
                ( member(B,Xa2,Uub)
                & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Xa2),Uu) ) ) ) ) ).

% ATP.lambda_353
tff(fact_6076_ATP_Olambda__354,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] : ( aa(B,set(B),aa(B,fun(B,set(B)),aTP_Lamp_pg(set(product_prod(B,B)),fun(B,fun(B,set(B))),Uu),Uua),Uub) = image(B,B,converse(B,B,Uu),aa(set(B),set(B),insert2(B,Uua),bot_bot(set(B)))) ) ).

% ATP.lambda_354
tff(fact_6077_ATP_Olambda__355,axiom,
    ! [B: $tType] :
      ( euclid5411537665997757685th_nat(B)
     => ! [Uu: B,Uua: B,Uub: nat] : ( aa(nat,B,aa(B,fun(nat,B),aTP_Lamp_ei(B,fun(B,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),Uub)),Uua)) ) ) ).

% ATP.lambda_355
tff(fact_6078_ATP_Olambda__356,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: B,Uua: B,Uub: nat] : ( aa(nat,B,aa(B,fun(nat,B),aTP_Lamp_ef(B,fun(B,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),Uub)),Uua)) ) ) ).

% ATP.lambda_356
tff(fact_6079_ATP_Olambda__357,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: array(B),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rs(nat,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_Pair(array(B),product_prod(heap_ext(product_unit),nat)),Uua),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),one_one(nat)))) ) ) ).

% ATP.lambda_357
tff(fact_6080_ATP_Olambda__358,axiom,
    ! [B: $tType,Uu: B,Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_ls(B,fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> member(B,Uub,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uua),aa(set(B),set(B),insert2(B,Uu),bot_bot(set(B))))) ) ).

% ATP.lambda_358
tff(fact_6081_ATP_Olambda__359,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: list(B),Uua: array(B),Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aTP_Lamp_rm(list(B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_Pair(array(B),product_prod(heap_ext(product_unit),nat)),Uua),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),Uub),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),size_size(list(B),Uu)))) ) ) ).

% ATP.lambda_359
tff(fact_6082_ATP_Olambda__360,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: fun(nat,B),Uub: array(B)] : ( aa(array(B),assn,aa(fun(nat,B),fun(array(B),assn),aTP_Lamp_td(nat,fun(fun(nat,B),fun(array(B),assn)),Uu),Uua),Uub) = snga_assn(B,Uub,aa(list(nat),list(B),map(nat,B,Uua),upt(zero_zero(nat),Uu))) ) ) ).

% ATP.lambda_360
tff(fact_6083_ATP_Olambda__361,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [Uu: B,Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_du(B,fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_361
tff(fact_6084_ATP_Olambda__362,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,option(C)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_ny(fun(B,option(C)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> member(B,Uub,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uua),dom(B,C,Uu))) ) ).

% ATP.lambda_362
tff(fact_6085_ATP_Olambda__363,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,option(C)),Uua: set(B),Uub: B] :
      ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_nz(fun(B,option(C)),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
    <=> member(B,Uub,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),Uua),dom(B,C,Uu))) ) ).

% ATP.lambda_363
tff(fact_6086_ATP_Olambda__364,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: array(B),Uub: heap_ext(product_unit)] :
          ( aa(heap_ext(product_unit),$o,aa(array(B),fun(heap_ext(product_unit),$o),aTP_Lamp_ri(nat,fun(array(B),fun(heap_ext(product_unit),$o)),Uu),Uua),Uub)
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uu),array_length(B,Uub,Uua)) ) ) ).

% ATP.lambda_364
tff(fact_6087_ATP_Olambda__365,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: array(B),Uua: nat,Uub: heap_ext(product_unit)] :
          ( aa(heap_ext(product_unit),$o,aa(nat,fun(heap_ext(product_unit),$o),aTP_Lamp_rf(array(B),fun(nat,fun(heap_ext(product_unit),$o)),Uu),Uua),Uub)
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),array_length(B,Uub,Uu)) ) ) ).

% ATP.lambda_365
tff(fact_6088_ATP_Olambda__366,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [Uu: B,Uua: nat,Uub: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aTP_Lamp_cf(B,fun(nat,fun(nat,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_366
tff(fact_6089_ATP_Olambda__367,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: B,Uub: array(B)] : ( aa(array(B),assn,aa(B,fun(array(B),assn),aTP_Lamp_rt(nat,fun(B,fun(array(B),assn)),Uu),Uua),Uub) = snga_assn(B,Uub,replicate(B,Uu,Uua)) ) ) ).

% ATP.lambda_367
tff(fact_6090_ATP_Olambda__368,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: B,Uua: C,Uub: D] : ( aa(D,product_prod(B,product_prod(C,D)),aa(C,fun(D,product_prod(B,product_prod(C,D))),aa(B,fun(C,fun(D,product_prod(B,product_prod(C,D)))),aTP_Lamp_sy(B,fun(C,fun(D,product_prod(B,product_prod(C,D))))),Uu),Uua),Uub) = aa(product_prod(C,D),product_prod(B,product_prod(C,D)),aa(B,fun(product_prod(C,D),product_prod(B,product_prod(C,D))),product_Pair(B,product_prod(C,D)),Uu),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),Uua),Uub)) ) ).

% ATP.lambda_368
tff(fact_6091_ATP_Olambda__369,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: C,Uua: B,Uub: D] : ( aa(D,product_prod(B,product_prod(C,D)),aa(B,fun(D,product_prod(B,product_prod(C,D))),aTP_Lamp_sr(C,fun(B,fun(D,product_prod(B,product_prod(C,D)))),Uu),Uua),Uub) = aa(product_prod(C,D),product_prod(B,product_prod(C,D)),aa(B,fun(product_prod(C,D),product_prod(B,product_prod(C,D))),product_Pair(B,product_prod(C,D)),Uua),aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),Uu),Uub)) ) ).

% ATP.lambda_369
tff(fact_6092_ATP_Olambda__370,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_iz(fun(B,set(C)),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7121269368397514597t_prod(C,D),Uua),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_370
tff(fact_6093_ATP_Olambda__371,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_iy(fun(B,set(C)),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(set(C),D,aa(fun(C,D),fun(set(C),D),groups7311177749621191930dd_sum(C,D),Uua),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_371
tff(fact_6094_ATP_Olambda__372,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_tl(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(C,$o,aa(C,fun(C,$o),ord_less(C),Uua),aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_372
tff(fact_6095_ATP_Olambda__373,axiom,
    ! [C: $tType,Uu: assn,Uua: fun(C,assn),Uub: C] : ( aa(C,assn,aa(fun(C,assn),fun(C,assn),aTP_Lamp_bz(assn,fun(fun(C,assn),fun(C,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Uu),aa(C,assn,Uua,Uub)) ) ).

% ATP.lambda_373
tff(fact_6096_ATP_Olambda__374,axiom,
    ! [B: $tType,C: $tType] :
      ( semiring_0(B)
     => ! [Uu: B,Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_bd(B,fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uu),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_374
tff(fact_6097_ATP_Olambda__375,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_jv(set(B),fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_375
tff(fact_6098_ATP_Olambda__376,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_hs(set(B),fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_376
tff(fact_6099_ATP_Olambda__377,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: B,Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_kh(B,fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),sup_sup(B),Uu),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_377
tff(fact_6100_ATP_Olambda__378,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_im(set(B),fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_378
tff(fact_6101_ATP_Olambda__379,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [Uu: C,Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_kn(C,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(C,C,aa(C,fun(C,C),inf_inf(C),Uu),aa(B,C,Uua,Uub)) ) ) ).

% ATP.lambda_379
tff(fact_6102_ATP_Olambda__380,axiom,
    ! [B: $tType,C: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: B,Uua: fun(C,B),Uub: C] : ( aa(C,B,aa(fun(C,B),fun(C,B),aTP_Lamp_ib(B,fun(fun(C,B),fun(C,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),inf_inf(B),Uu),aa(C,B,Uua,Uub)) ) ) ).

% ATP.lambda_380
tff(fact_6103_ATP_Olambda__381,axiom,
    ! [C: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_da(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> dvd_dvd(C,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_381
tff(fact_6104_ATP_Olambda__382,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: filter(C),Uua: fun(B,filter(D)),Uub: B] : ( aa(B,filter(product_prod(C,D)),aa(fun(B,filter(D)),fun(B,filter(product_prod(C,D))),aTP_Lamp_qs(filter(C),fun(fun(B,filter(D)),fun(B,filter(product_prod(C,D)))),Uu),Uua),Uub) = prod_filter(C,D,Uu,aa(B,filter(D),Uua,Uub)) ) ).

% ATP.lambda_382
tff(fact_6105_ATP_Olambda__383,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,C),Uua: B,Uub: D] : ( aa(D,product_prod(B,C),aa(B,fun(D,product_prod(B,C)),aTP_Lamp_sv(fun(D,C),fun(B,fun(D,product_prod(B,C))),Uu),Uua),Uub) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),aa(D,C,Uu,Uub)) ) ).

% ATP.lambda_383
tff(fact_6106_ATP_Olambda__384,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: set(product_prod(C,B)),Uua: fun(D,set(C)),Uub: D] : ( aa(D,set(B),aa(fun(D,set(C)),fun(D,set(B)),aTP_Lamp_ph(set(product_prod(C,B)),fun(fun(D,set(C)),fun(D,set(B))),Uu),Uua),Uub) = image(C,B,Uu,aa(D,set(C),Uua,Uub)) ) ).

% ATP.lambda_384
tff(fact_6107_ATP_Olambda__385,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: fun(C,set(B)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(B)),fun(C,set(B)),aTP_Lamp_hr(B,fun(fun(C,set(B)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),insert2(B,Uu),aa(C,set(B),Uua,Uub)) ) ).

% ATP.lambda_385
tff(fact_6108_ATP_Olambda__386,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( condit1219197933456340205attice(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,D),Uub: B] : ( aa(B,set(D),aa(fun(C,D),fun(B,set(D)),aTP_Lamp_lu(fun(B,set(C)),fun(fun(C,D),fun(B,set(D))),Uu),Uua),Uub) = aa(set(C),set(D),image2(C,D,Uua),aa(B,set(C),Uu,Uub)) ) ) ).

% ATP.lambda_386
tff(fact_6109_ATP_Olambda__387,axiom,
    ! [B: $tType,Uu: assn,Uua: B,Uub: B] : ( aa(B,assn,aa(B,fun(B,assn),aTP_Lamp_cn(assn,fun(B,fun(B,assn)),Uu),Uua),Uub) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),Uu),pure_assn(( Uub = Uua ))) ) ).

% ATP.lambda_387
tff(fact_6110_ATP_Olambda__388,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: fun(C,B),Uub: B] : ( aa(B,set(B),aa(fun(C,B),fun(B,set(B)),aTP_Lamp_ne(set(product_prod(C,C)),fun(fun(C,B),fun(B,set(B))),Uu),Uua),Uub) = aa(set(C),set(B),image2(C,B,Uua),field2(C,Uu)) ) ).

% ATP.lambda_388
tff(fact_6111_ATP_Olambda__389,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: set(B),Uua: set(D),Uub: fun(B,C)] : ( aa(fun(B,C),set(fun(B,D)),aa(set(D),fun(fun(B,C),set(fun(B,D))),aTP_Lamp_ng(set(B),fun(set(D),fun(fun(B,C),set(fun(B,D)))),Uu),Uua),Uub) = bNF_Wellorder_Func(B,D,Uu,Uua) ) ).

% ATP.lambda_389
tff(fact_6112_ATP_Olambda__390,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: set(C),Uub: B] : ( aa(B,set(C),aa(set(C),fun(B,set(C)),aTP_Lamp_ii(set(C),fun(set(C),fun(B,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),aa(set(C),fun(set(C),set(C)),inf_inf(set(C)),Uu),Uua) ) ).

% ATP.lambda_390
tff(fact_6113_ATP_Olambda__391,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] : ( aa(B,set(B),aa(B,fun(B,set(B)),aTP_Lamp_nc(set(product_prod(B,B)),fun(B,fun(B,set(B))),Uu),Uua),Uub) = order_underS(B,Uu,Uua) ) ).

% ATP.lambda_391
tff(fact_6114_ATP_Olambda__392,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] : ( aa(B,set(B),aa(B,fun(B,set(B)),aTP_Lamp_jd(set(product_prod(B,B)),fun(B,fun(B,set(B))),Uu),Uua),Uub) = order_above(B,Uu,Uua) ) ).

% ATP.lambda_392
tff(fact_6115_ATP_Olambda__393,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: ref(B),Uua: B,Uub: product_unit] : ( aa(product_unit,assn,aa(B,fun(product_unit,assn),aTP_Lamp_he(ref(B),fun(B,fun(product_unit,assn)),Uu),Uua),Uub) = sngr_assn(B,Uu,Uua) ) ) ).

% ATP.lambda_393
tff(fact_6116_ATP_Olambda__394,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: set(C),Uua: set(D),Uub: B] : ( aa(B,set(sum_sum(C,D)),aa(set(D),fun(B,set(sum_sum(C,D))),aTP_Lamp_no(set(C),fun(set(D),fun(B,set(sum_sum(C,D)))),Uu),Uua),Uub) = sum_Plus(C,D,Uu,Uua) ) ).

% ATP.lambda_394
tff(fact_6117_ATP_Olambda__395,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: set(C),Uub: B] : ( aa(B,set(C),aa(set(C),fun(B,set(C)),aTP_Lamp_hv(C,fun(set(C),fun(B,set(C))),Uu),Uua),Uub) = aa(set(C),set(C),insert2(C,Uu),Uua) ) ).

% ATP.lambda_395
tff(fact_6118_ATP_Olambda__396,axiom,
    ! [B: $tType,C: $tType,E: $tType,Uu: fun(E,C),Uua: set(E),Uub: B] : ( aa(B,set(C),aa(set(E),fun(B,set(C)),aTP_Lamp_iv(fun(E,C),fun(set(E),fun(B,set(C))),Uu),Uua),Uub) = aa(set(E),set(C),image2(E,C,Uu),Uua) ) ).

% ATP.lambda_396
tff(fact_6119_ATP_Olambda__397,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: ref(B),Uua: B,Uub: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(B,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_ma(ref(B),fun(B,fun(heap_ext(product_unit),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)))),Uu),Uua),Uub) = aa(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat)),aa(product_unit,fun(product_prod(heap_ext(product_unit),nat),product_prod(product_unit,product_prod(heap_ext(product_unit),nat))),product_Pair(product_unit,product_prod(heap_ext(product_unit),nat)),product_Unity),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),ref_set(B,Uu,Uua,Uub)),one_one(nat))) ) ) ).

% ATP.lambda_397
tff(fact_6120_ATP_Olambda__398,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),Uua: fun(B,D),Uub: fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))))] : ( aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C,aa(fun(B,D),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C),aTP_Lamp_uv(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(B,D),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),C)),Uu),Uua),Uub) = aa(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C,Uu,aa(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),aa(fun(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),fun(fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat))))),comp(option(product_prod(B,product_prod(heap_ext(product_unit),nat))),option(product_prod(D,product_prod(heap_ext(product_unit),nat))),heap_ext(product_unit)),map_option(product_prod(B,product_prod(heap_ext(product_unit),nat)),product_prod(D,product_prod(heap_ext(product_unit),nat)),product_map_prod(B,D,product_prod(heap_ext(product_unit),nat),product_prod(heap_ext(product_unit),nat),Uua,id(product_prod(heap_ext(product_unit),nat))))),Uub)) ) ).

% ATP.lambda_398
tff(fact_6121_ATP_Olambda__399,axiom,
    ! [B: $tType,C: $tType,Uu: fun(product_prod(B,C),$o),Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_vd(fun(product_prod(B,C),$o),fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(B,C),$o,Uu,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uub)) ) ).

% ATP.lambda_399
tff(fact_6122_ATP_Olambda__400,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(product_prod(B,C),D),Uua: B,Uub: C] : ( aa(C,D,aa(B,fun(C,D),aTP_Lamp_et(fun(product_prod(B,C),D),fun(B,fun(C,D)),Uu),Uua),Uub) = aa(product_prod(B,C),D,Uu,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uua),Uub)) ) ).

% ATP.lambda_400
tff(fact_6123_ATP_Olambda__401,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: fun(multiset(B),C),Uua: fun(D,multiset(B)),Uub: D] : ( aa(D,C,aa(fun(D,multiset(B)),fun(D,C),aTP_Lamp_pw(fun(multiset(B),C),fun(fun(D,multiset(B)),fun(D,C)),Uu),Uua),Uub) = aa(multiset(B),C,Uu,aa(D,multiset(B),Uua,Uub)) ) ) ).

% ATP.lambda_401
tff(fact_6124_ATP_Olambda__402,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(D,C),Uua: fun(B,D),Uub: B] : ( aa(B,C,aa(fun(B,D),fun(B,C),aTP_Lamp_tv(fun(D,C),fun(fun(B,D),fun(B,C)),Uu),Uua),Uub) = aa(D,C,Uu,aa(B,D,Uua,Uub)) ) ).

% ATP.lambda_402
tff(fact_6125_ATP_Olambda__403,axiom,
    ! [D: $tType,C: $tType,E: $tType,Uu: fun(C,fun(D,$o)),Uua: fun(E,C),Uub: E] : ( aa(E,fun(D,$o),aa(fun(E,C),fun(E,fun(D,$o)),aTP_Lamp_gp(fun(C,fun(D,$o)),fun(fun(E,C),fun(E,fun(D,$o))),Uu),Uua),Uub) = aa(C,fun(D,$o),Uu,aa(E,C,Uua,Uub)) ) ).

% ATP.lambda_403
tff(fact_6126_ATP_Olambda__404,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(C,B),Uua: fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),Uub: fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat))))] : ( aa(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),B,aa(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),B),aTP_Lamp_vi(fun(C,B),fun(fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C),fun(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),B)),Uu),Uua),Uub) = aa(C,B,Uu,aa(fun(heap_ext(product_unit),option(product_prod(D,product_prod(heap_ext(product_unit),nat)))),C,Uua,Uub)) ) ).

% ATP.lambda_404
tff(fact_6127_ATP_Olambda__405,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(C) )
     => ! [Uu: fun(B,C),Uua: fun(D,B),Uub: D] : ( aa(D,C,aa(fun(D,B),fun(D,C),aTP_Lamp_oh(fun(B,C),fun(fun(D,B),fun(D,C)),Uu),Uua),Uub) = aa(B,C,Uu,aa(D,B,Uua,Uub)) ) ) ).

% ATP.lambda_405
tff(fact_6128_ATP_Olambda__406,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(D,B),Uub: D] : ( aa(D,fun(C,$o),aa(fun(D,B),fun(D,fun(C,$o)),aTP_Lamp_va(fun(B,fun(C,$o)),fun(fun(D,B),fun(D,fun(C,$o))),Uu),Uua),Uub) = aa(B,fun(C,$o),Uu,aa(D,B,Uua,Uub)) ) ).

% ATP.lambda_406
tff(fact_6129_ATP_Olambda__407,axiom,
    ! [E: $tType,D: $tType,Uu: fun(D,E),Uua: fun(E,$o),Uub: D] :
      ( aa(D,$o,aa(fun(E,$o),fun(D,$o),aTP_Lamp_og(fun(D,E),fun(fun(E,$o),fun(D,$o)),Uu),Uua),Uub)
    <=> aa(E,$o,Uua,aa(D,E,Uu,Uub)) ) ).

% ATP.lambda_407
tff(fact_6130_ATP_Olambda__408,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(D)
     => ! [Uu: fun(B,C),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_pn(fun(B,C),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(C,D,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_408
tff(fact_6131_ATP_Olambda__409,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( semiring_1(D)
     => ! [Uu: fun(B,C),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_dm(fun(B,C),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(C,D,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_409
tff(fact_6132_ATP_Olambda__410,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,$o),Uua: C,Uub: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_qq(fun(C,$o),fun(C,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(C,$o,Uu,Uua) ) ).

% ATP.lambda_410
tff(fact_6133_ATP_Olambda__411,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: fun(C,heap_Time_Heap(B)),Uub: product_unit] : ( aa(product_unit,heap_Time_Heap(B),aa(fun(C,heap_Time_Heap(B)),fun(product_unit,heap_Time_Heap(B)),aTP_Lamp_fn(C,fun(fun(C,heap_Time_Heap(B)),fun(product_unit,heap_Time_Heap(B))),Uu),Uua),Uub) = aa(C,heap_Time_Heap(B),Uua,Uu) ) ).

% ATP.lambda_411
tff(fact_6134_ATP_Olambda__412,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] : ( aa(B,fun(product_prod(B,B),$o),aa(B,fun(B,fun(product_prod(B,B),$o)),aTP_Lamp_fw(set(product_prod(B,B)),fun(B,fun(B,fun(product_prod(B,B),$o))),Uu),Uua),Uub) = aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(B,fun(B,fun(B,$o)),aa(B,fun(B,fun(B,fun(B,$o))),aTP_Lamp_fv(set(product_prod(B,B)),fun(B,fun(B,fun(B,fun(B,$o)))),Uu),Uua),Uub)) ) ).

% ATP.lambda_412
tff(fact_6135_ATP_Olambda__413,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uua: product_prod(code_natural,code_natural),Uub: C] : ( aa(C,pred(B),aa(product_prod(code_natural,code_natural),fun(C,pred(B)),aTP_Lamp_um(fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),fun(C,pred(B))),Uu),Uua),Uub) = aa(product_prod(pred(B),product_prod(code_natural,code_natural)),pred(B),product_fst(pred(B),product_prod(code_natural,code_natural)),aa(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)),aa(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),Uu,Uub),Uua)) ) ).

% ATP.lambda_413
tff(fact_6136_ATP_Olambda__414,axiom,
    ! [C: $tType,B: $tType,Uu: set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),Uua: set(old_node(B,C)),Uub: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aTP_Lamp_wm(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),Uu),Uua),Uub) = aa(set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),complete_Sup_Sup(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),image2(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),fun(product_prod(set(old_node(B,C)),set(old_node(B,C))),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),product_case_prod(set(old_node(B,C)),set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),aTP_Lamp_wl(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))))),Uua),Uub))),Uu)) ) ).

% ATP.lambda_414
tff(fact_6137_ATP_Olambda__415,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),Uua: pred(C),Uub: product_prod(code_natural,code_natural)] : ( aa(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),aa(pred(C),fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),aTP_Lamp_un(fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(pred(C),fun(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))))),Uu),Uua),Uub) = aa(pred(B),fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural))),product_Pair(pred(B),product_prod(code_natural,code_natural)),bind2(C,B,Uua,aa(product_prod(code_natural,code_natural),fun(C,pred(B)),aTP_Lamp_um(fun(C,fun(product_prod(code_natural,code_natural),product_prod(pred(B),product_prod(code_natural,code_natural)))),fun(product_prod(code_natural,code_natural),fun(C,pred(B))),Uu),Uub))) ) ).

% ATP.lambda_415
tff(fact_6138_ATP_Olambda__416,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( condit1219197933456340205attice(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_lv(fun(B,set(C)),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(set(D),D,complete_Sup_Sup(D),aa(set(C),set(D),image2(C,D,Uua),aa(B,set(C),Uu,Uub))) ) ) ).

% ATP.lambda_416
tff(fact_6139_ATP_Olambda__417,axiom,
    ! [D: $tType,C: $tType,B: $tType] :
      ( condit1219197933456340205attice(D)
     => ! [Uu: fun(B,set(C)),Uua: fun(C,D),Uub: B] : ( aa(B,D,aa(fun(C,D),fun(B,D),aTP_Lamp_my(fun(B,set(C)),fun(fun(C,D),fun(B,D)),Uu),Uua),Uub) = aa(set(D),D,complete_Inf_Inf(D),aa(set(C),set(D),image2(C,D,Uua),aa(B,set(C),Uu,Uub))) ) ) ).

% ATP.lambda_417
tff(fact_6140_ATP_Olambda__418,axiom,
    ! [C: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B] :
          ( aa(B,$o,aa(C,fun(B,$o),aTP_Lamp_db(fun(B,C),fun(C,fun(B,$o)),Uu),Uua),Uub)
        <=> ~ dvd_dvd(C,Uua,aa(B,C,Uu,Uub)) ) ) ).

% ATP.lambda_418
tff(fact_6141_ATP_Olambda__419,axiom,
    ! [B: $tType,C: $tType,Uu: list(B),Uua: list(C),Uub: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(list(C),fun(product_prod(B,C),$o),aTP_Lamp_sk(list(B),fun(list(C),fun(product_prod(B,C),$o)),Uu),Uua),Uub)
    <=> ? [I2: nat] :
          ( ( Uub = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),nth(B,Uu,I2)),nth(C,Uua,I2)) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),size_size(list(B),Uu)),size_size(list(C),Uua))) ) ) ).

% ATP.lambda_419
tff(fact_6142_ATP_Olambda__420,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: fun(B,C),Uub: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(fun(B,C),fun(product_prod(B,C),$o),aTP_Lamp_ur(set(B),fun(fun(B,C),fun(product_prod(B,C),$o)),Uu),Uua),Uub)
    <=> ? [A6: B] :
          ( ( Uub = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),A6),aa(B,C,Uua,A6)) )
          & member(B,A6,Uu) ) ) ).

% ATP.lambda_420
tff(fact_6143_ATP_Olambda__421,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Uu: set(B),Uua: B,Uub: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_ks(set(B),fun(B,fun(B,$o)),Uu),Uua),Uub)
        <=> ? [A6: B] :
              ( ( Uub = aa(B,B,aa(B,fun(B,B),sup_sup(B),Uua),A6) )
              & member(B,A6,Uu) ) ) ) ).

% ATP.lambda_421
tff(fact_6144_ATP_Olambda__422,axiom,
    ! [B: $tType] :
      ( finite8700451911770168679attice(B)
     => ! [Uu: B,Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_kd(B,fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ? [B5: B] :
              ( ( Uub = aa(B,B,aa(B,fun(B,B),inf_inf(B),Uu),B5) )
              & member(B,B5,Uua) ) ) ) ).

% ATP.lambda_422
tff(fact_6145_ATP_Olambda__423,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Uu: set(B),Uua: B,Uub: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_kr(set(B),fun(B,fun(B,$o)),Uu),Uua),Uub)
        <=> ? [A6: B] :
              ( ( Uub = aa(B,B,aa(B,fun(B,B),inf_inf(B),Uua),A6) )
              & member(B,A6,Uu) ) ) ) ).

% ATP.lambda_423
tff(fact_6146_ATP_Olambda__424,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: multiset(B),Uub: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_ps(set(multiset(B)),fun(multiset(B),fun(multiset(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: multiset(B)] :
          ( ( Uub = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),Uua),A6) )
          & member(multiset(B),A6,Uu) ) ) ).

% ATP.lambda_424
tff(fact_6147_ATP_Olambda__425,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: multiset(B),Uub: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_pv(set(multiset(B)),fun(multiset(B),fun(multiset(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: multiset(B)] :
          ( ( Uub = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),Uua),A6) )
          & member(multiset(B),A6,Uu) ) ) ).

% ATP.lambda_425
tff(fact_6148_ATP_Olambda__426,axiom,
    ! [C: $tType,D: $tType,Uu: fun(C,set(D)),Uua: fun(D,$o),Uub: C] :
      ( aa(C,$o,aa(fun(D,$o),fun(C,$o),aTP_Lamp_ol(fun(C,set(D)),fun(fun(D,$o),fun(C,$o)),Uu),Uua),Uub)
    <=> ! [X4: D] :
          ( member(D,X4,aa(C,set(D),Uu,Uub))
         => aa(D,$o,Uua,X4) ) ) ).

% ATP.lambda_426
tff(fact_6149_ATP_Olambda__427,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_pk(set(product_prod(B,B)),fun(B,fun(B,$o)),Uu),Uua),Uub)
    <=> ! [X4: product_prod(B,B)] :
          ( member(product_prod(B,B),X4,Uu)
         => aa(product_prod(B,B),$o,aa(fun(B,fun(B,$o)),fun(product_prod(B,B),$o),product_case_prod(B,B,$o),aa(B,fun(B,fun(B,$o)),aa(B,fun(B,fun(B,fun(B,$o))),aTP_Lamp_pj(set(product_prod(B,B)),fun(B,fun(B,fun(B,fun(B,$o)))),Uu),Uua),Uub)),X4) ) ) ).

% ATP.lambda_427
tff(fact_6150_ATP_Olambda__428,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,B)),Uua: set(C),Uub: B] :
      ( aa(B,$o,aa(set(C),fun(B,$o),aTP_Lamp_ot(set(product_prod(C,B)),fun(set(C),fun(B,$o)),Uu),Uua),Uub)
    <=> ? [X4: C] :
          ( member(C,X4,Uua)
          & member(product_prod(C,B),aa(B,product_prod(C,B),aa(C,fun(B,product_prod(C,B)),product_Pair(C,B),X4),Uub),Uu) ) ) ).

% ATP.lambda_428
tff(fact_6151_ATP_Olambda__429,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,B),Uua: fun(C,fun(C,$o)),Uub: product_prod(B,B)] :
      ( aa(product_prod(B,B),$o,aa(fun(C,fun(C,$o)),fun(product_prod(B,B),$o),aTP_Lamp_kc(fun(C,B),fun(fun(C,fun(C,$o)),fun(product_prod(B,B),$o)),Uu),Uua),Uub)
    <=> ? [A6: C,B5: C] :
          ( ( Uub = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(C,B,Uu,A6)),aa(C,B,Uu,B5)) )
          & aa(C,$o,aa(C,fun(C,$o),Uua,A6),B5) ) ) ).

% ATP.lambda_429
tff(fact_6152_ATP_Olambda__430,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: fun(C,B),Uub: product_prod(B,B)] :
      ( aa(product_prod(B,B),$o,aa(fun(C,B),fun(product_prod(B,B),$o),aTP_Lamp_nu(set(product_prod(C,C)),fun(fun(C,B),fun(product_prod(B,B),$o)),Uu),Uua),Uub)
    <=> ? [A6: C,B5: C] :
          ( ( Uub = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),aa(C,B,Uua,A6)),aa(C,B,Uua,B5)) )
          & member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),A6),B5),Uu) ) ) ).

% ATP.lambda_430
tff(fact_6153_ATP_Olambda__431,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_sf(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: B,V4: list(B)] :
          ( ( Uub = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Uua),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),A6),V4)) )
          | ? [U3: list(B),Aa4: B,B5: B,Va2: list(B),W3: list(B)] :
              ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Aa4),B5),Uu)
              & ( Uua = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),U3),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Aa4),Va2)) )
              & ( Uub = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),U3),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),B5),W3)) ) ) ) ) ).

% ATP.lambda_431
tff(fact_6154_ATP_Olambda__432,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Uu: set(B),Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_kt(set(B),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ? [A6: B,B5: B] :
              ( ( Uub = aa(B,B,aa(B,fun(B,B),sup_sup(B),A6),B5) )
              & member(B,A6,Uu)
              & member(B,B5,Uua) ) ) ) ).

% ATP.lambda_432
tff(fact_6155_ATP_Olambda__433,axiom,
    ! [B: $tType] :
      ( distrib_lattice(B)
     => ! [Uu: set(B),Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_kq(set(B),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ? [A6: B,B5: B] :
              ( ( Uub = aa(B,B,aa(B,fun(B,B),inf_inf(B),A6),B5) )
              & member(B,A6,Uu)
              & member(B,B5,Uua) ) ) ) ).

% ATP.lambda_433
tff(fact_6156_ATP_Olambda__434,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: set(multiset(B)),Uub: multiset(B)] :
      ( aa(multiset(B),$o,aa(set(multiset(B)),fun(multiset(B),$o),aTP_Lamp_pt(set(multiset(B)),fun(set(multiset(B)),fun(multiset(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: multiset(B),B5: multiset(B)] :
          ( ( Uub = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),union_mset(B),A6),B5) )
          & member(multiset(B),A6,Uu)
          & member(multiset(B),B5,Uua) ) ) ).

% ATP.lambda_434
tff(fact_6157_ATP_Olambda__435,axiom,
    ! [B: $tType,Uu: set(multiset(B)),Uua: set(multiset(B)),Uub: multiset(B)] :
      ( aa(multiset(B),$o,aa(set(multiset(B)),fun(multiset(B),$o),aTP_Lamp_pu(set(multiset(B)),fun(set(multiset(B)),fun(multiset(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: multiset(B),B5: multiset(B)] :
          ( ( Uub = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),inter_mset(B),A6),B5) )
          & member(multiset(B),A6,Uu)
          & member(multiset(B),B5,Uua) ) ) ).

% ATP.lambda_435
tff(fact_6158_ATP_Olambda__436,axiom,
    ! [B: $tType,Uu: filter(B),Uua: filter(B),Uub: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aa(filter(B),fun(fun(B,$o),$o),aTP_Lamp_pa(filter(B),fun(filter(B),fun(fun(B,$o),$o)),Uu),Uua),Uub)
    <=> ? [Q7: fun(B,$o),R6: fun(B,$o)] :
          ( eventually(B,Q7,Uu)
          & eventually(B,R6,Uua)
          & ! [X4: B] :
              ( ( aa(B,$o,Q7,X4)
                & aa(B,$o,R6,X4) )
             => aa(B,$o,Uub,X4) ) ) ) ).

% ATP.lambda_436
tff(fact_6159_ATP_Olambda__437,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: multiset(B),Uub: multiset(B)] :
      ( aa(multiset(B),$o,aa(multiset(B),fun(multiset(B),$o),aTP_Lamp_pr(set(product_prod(B,B)),fun(multiset(B),fun(multiset(B),$o)),Uu),Uua),Uub)
    <=> ? [A6: B,M03: multiset(B),K6: multiset(B)] :
          ( ( Uub = aa(multiset(B),multiset(B),aa(B,fun(multiset(B),multiset(B)),add_mset(B),A6),M03) )
          & ( Uua = aa(multiset(B),multiset(B),aa(multiset(B),fun(multiset(B),multiset(B)),plus_plus(multiset(B)),M03),K6) )
          & ! [B5: B] :
              ( member(B,B5,aa(multiset(B),set(B),set_mset(B),K6))
             => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),B5),A6),Uu) ) ) ) ).

% ATP.lambda_437
tff(fact_6160_ATP_Olambda__438,axiom,
    ! [C: $tType,B: $tType,F7: $tType,D: $tType,E: $tType,Uu: fun(F7,fun(B,fun(D,fun(C,fun(E,$o))))),Uua: F7,Uub: fun(B,option(product_prod(C,product_prod(D,E))))] :
      ( aa(fun(B,option(product_prod(C,product_prod(D,E)))),$o,aa(F7,fun(fun(B,option(product_prod(C,product_prod(D,E)))),$o),aTP_Lamp_ve(fun(F7,fun(B,fun(D,fun(C,fun(E,$o))))),fun(F7,fun(fun(B,option(product_prod(C,product_prod(D,E)))),$o)),Uu),Uua),Uub)
    <=> ! [H3: B,H9: D,R5: C,N5: E] :
          ( ( aa(B,option(product_prod(C,product_prod(D,E))),Uub,H3) = aa(product_prod(C,product_prod(D,E)),option(product_prod(C,product_prod(D,E))),some(product_prod(C,product_prod(D,E))),aa(product_prod(D,E),product_prod(C,product_prod(D,E)),aa(C,fun(product_prod(D,E),product_prod(C,product_prod(D,E))),product_Pair(C,product_prod(D,E)),R5),aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),H9),N5))) )
         => aa(E,$o,aa(C,fun(E,$o),aa(D,fun(C,fun(E,$o)),aa(B,fun(D,fun(C,fun(E,$o))),aa(F7,fun(B,fun(D,fun(C,fun(E,$o)))),Uu,Uua),H3),H9),R5),N5) ) ) ).

% ATP.lambda_438
tff(fact_6161_ATP_Olambda__439,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: list(B),Uub: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aTP_Lamp_sc(set(product_prod(B,B)),fun(list(B),fun(list(B),$o)),Uu),Uua),Uub)
    <=> ? [Us3: list(B),Z4: B,Z9: B,Vs3: list(B)] :
          ( ( Uua = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us3),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Z4),Vs3)) )
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Z4),Z9),Uu)
          & ( Uub = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Us3),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Z9),Vs3)) ) ) ) ).

% ATP.lambda_439
tff(fact_6162_ATP_Olambda__440,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: product_prod(D,B),Uua: B,Uub: C,Uuc: set(product_prod(D,C))] :
      ( aa(set(product_prod(D,C)),set(product_prod(D,C)),aa(C,fun(set(product_prod(D,C)),set(product_prod(D,C))),aa(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aTP_Lamp_fx(product_prod(D,B),fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),Uu),Uua),Uub),Uuc)
      = $ite(aa(product_prod(D,B),B,product_snd(D,B),Uu) = Uua,aa(set(product_prod(D,C)),set(product_prod(D,C)),insert2(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),aa(product_prod(D,B),D,product_fst(D,B),Uu)),Uub)),Uuc),Uuc) ) ).

% ATP.lambda_440
tff(fact_6163_ATP_Olambda__441,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: set(B),Uub: B,Uuc: C] :
      ( aa(C,B,aa(B,fun(C,B),aa(set(B),fun(B,fun(C,B)),aTP_Lamp_em(fun(B,C),fun(set(B),fun(B,fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(member(C,Uuc,aa(set(B),set(C),image2(B,C,Uu),Uua)),aa(C,B,the_inv_into(B,C,Uua,Uu),Uuc),Uub) ) ).

% ATP.lambda_441
tff(fact_6164_ATP_Olambda__442,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: fun(B,C),Uub: B,Uuc: C] :
      ( aa(C,B,aa(B,fun(C,B),aa(fun(B,C),fun(B,fun(C,B)),aTP_Lamp_cv(set(B),fun(fun(B,C),fun(B,fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(member(C,Uuc,aa(set(B),set(C),image2(B,C,Uua),Uu)),aa(C,B,the_inv_into(B,C,Uu,Uua),Uuc),Uub) ) ).

% ATP.lambda_442
tff(fact_6165_ATP_Olambda__443,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: B,Uub: C,Uuc: set(C)] :
      ( aa(set(C),set(C),aa(C,fun(set(C),set(C)),aa(B,fun(C,fun(set(C),set(C))),aTP_Lamp_lk(set(B),fun(B,fun(C,fun(set(C),set(C)))),Uu),Uua),Uub),Uuc)
      = $ite(member(B,Uua,Uu),aa(set(C),set(C),insert2(C,Uub),Uuc),Uuc) ) ).

% ATP.lambda_443
tff(fact_6166_ATP_Olambda__444,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: nat,Uua: fun(nat,B),Uub: fun(nat,B),Uuc: nat] :
          ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_dz(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),Uu),Uua),Uub),Uuc)
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),
              aa(nat,B,Uua,Uuc),
              $ite(Uuc = Uu,one_one(B),aa(nat,B,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ).

% ATP.lambda_444
tff(fact_6167_ATP_Olambda__445,axiom,
    ! [B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: nat,Uua: fun(nat,B),Uub: fun(nat,B),Uuc: nat] :
          ( aa(nat,B,aa(fun(nat,B),fun(nat,B),aa(fun(nat,B),fun(fun(nat,B),fun(nat,B)),aTP_Lamp_ea(nat,fun(fun(nat,B),fun(fun(nat,B),fun(nat,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),aa(nat,B,Uua,Uuc),aa(nat,B,Uub,Uuc)) ) ) ).

% ATP.lambda_445
tff(fact_6168_ATP_Olambda__446,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: set(B),Uub: fun(B,C),Uuc: B] :
      ( aa(B,C,aa(fun(B,C),fun(B,C),aa(set(B),fun(fun(B,C),fun(B,C)),aTP_Lamp_cp(fun(B,C),fun(set(B),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
      = $ite(member(B,Uuc,Uua),aa(B,C,Uu,Uuc),aa(B,C,Uub,Uuc)) ) ).

% ATP.lambda_446
tff(fact_6169_ATP_Olambda__447,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: fun(C,B),Uub: fun(C,B),Uuc: C] :
      ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_xd(C,fun(fun(C,B),fun(fun(C,B),fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(Uuc = Uu,aa(C,B,Uua,Uuc),aa(C,B,Uub,Uuc)) ) ).

% ATP.lambda_447
tff(fact_6170_ATP_Olambda__448,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_dc(B,fun(fun(B,C),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(B,C,Uua,Uuc),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_448
tff(fact_6171_ATP_Olambda__449,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_cy(B,fun(fun(B,C),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(B,C,Uua,Uuc),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_449
tff(fact_6172_ATP_Olambda__450,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: fun(C,B),Uub: set(C),Uuc: C] :
      ( aa(C,B,aa(set(C),fun(C,B),aa(fun(C,B),fun(set(C),fun(C,B)),aTP_Lamp_xc(B,fun(fun(C,B),fun(set(C),fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(member(C,Uuc,Uub),aa(C,B,Uua,Uuc),Uu) ) ).

% ATP.lambda_450
tff(fact_6173_ATP_Olambda__451,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: B,Uua: fun(B,C),Uub: C,Uuc: B] :
          ( aa(B,C,aa(C,fun(B,C),aa(fun(B,C),fun(C,fun(B,C)),aTP_Lamp_dp(B,fun(fun(B,C),fun(C,fun(B,C))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(B,C,Uua,Uuc),Uub) ) ) ).

% ATP.lambda_451
tff(fact_6174_ATP_Olambda__452,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: C,Uub: C,Uuc: B] :
      ( aa(B,C,aa(C,fun(B,C),aa(C,fun(C,fun(B,C)),aTP_Lamp_jm(set(B),fun(C,fun(C,fun(B,C))),Uu),Uua),Uub),Uuc)
      = $ite(member(B,Uuc,Uu),Uua,Uub) ) ).

% ATP.lambda_452
tff(fact_6175_ATP_Olambda__453,axiom,
    ! [B: $tType,Uu: fun(code_natural,B),Uua: code_natural,Uub: code_natural,Uuc: product_unit] :
      ( aa(product_unit,seq(B),aa(code_natural,fun(product_unit,seq(B)),aa(code_natural,fun(code_natural,fun(product_unit,seq(B))),aTP_Lamp_vp(fun(code_natural,B),fun(code_natural,fun(code_natural,fun(product_unit,seq(B)))),Uu),Uua),Uub),Uuc)
      = $ite(aa(code_natural,$o,aa(code_natural,fun(code_natural,$o),ord_less(code_natural),Uub),Uua),empty(B),insert(B,aa(code_natural,B,Uu,Uua),iterate_upto(B,Uu,aa(code_natural,code_natural,aa(code_natural,fun(code_natural,code_natural),plus_plus(code_natural),Uua),one_one(code_natural)),Uub))) ) ).

% ATP.lambda_453
tff(fact_6176_ATP_Olambda__454,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: B,Uub: list(B),Uuc: list(B)] :
      ( aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),aa(B,fun(list(B),fun(list(B),product_prod(list(B),list(B)))),aTP_Lamp_sn(fun(B,$o),fun(B,fun(list(B),fun(list(B),product_prod(list(B),list(B))))),Uu),Uua),Uub),Uuc)
      = $ite(aa(B,$o,Uu,Uua),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua),Uub)),Uuc),aa(list(B),product_prod(list(B),list(B)),aa(list(B),fun(list(B),product_prod(list(B),list(B))),product_Pair(list(B),list(B)),Uub),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uua),Uuc))) ) ).

% ATP.lambda_454
tff(fact_6177_ATP_Olambda__455,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,$o),Uua: fun(C,B),Uub: fun(C,B),Uuc: C] :
      ( aa(C,B,aa(fun(C,B),fun(C,B),aa(fun(C,B),fun(fun(C,B),fun(C,B)),aTP_Lamp_ao(fun(C,$o),fun(fun(C,B),fun(fun(C,B),fun(C,B))),Uu),Uua),Uub),Uuc)
      = $ite(aa(C,$o,Uu,Uuc),aa(C,B,Uua,Uuc),aa(C,B,Uub,Uuc)) ) ).

% ATP.lambda_455
tff(fact_6178_ATP_Olambda__456,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,$o),Uua: fun(B,option(C)),Uub: fun(B,option(C)),Uuc: B] :
      ( aa(B,option(C),aa(fun(B,option(C)),fun(B,option(C)),aa(fun(B,option(C)),fun(fun(B,option(C)),fun(B,option(C))),aTP_Lamp_oa(fun(B,$o),fun(fun(B,option(C)),fun(fun(B,option(C)),fun(B,option(C)))),Uu),Uua),Uub),Uuc)
      = $ite(aa(B,$o,Uu,Uuc),aa(B,option(C),Uua,Uuc),aa(B,option(C),Uub,Uuc)) ) ).

% ATP.lambda_456
tff(fact_6179_ATP_Olambda__457,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(B,$o),Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_cs(fun(B,$o),fun(fun(B,C),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
          = $ite(aa(B,$o,Uu,Uuc),aa(B,C,Uua,Uuc),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_457
tff(fact_6180_ATP_Olambda__458,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(B,$o),Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,C),fun(fun(B,C),fun(B,C)),aTP_Lamp_cq(fun(B,$o),fun(fun(B,C),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
          = $ite(aa(B,$o,Uu,Uuc),aa(B,C,Uua,Uuc),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_458
tff(fact_6181_ATP_Olambda__459,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,C),Uua: fun(B,$o),Uub: fun(B,C),Uuc: B] :
      ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(B,$o),fun(fun(B,C),fun(B,C)),aTP_Lamp_uj(fun(B,C),fun(fun(B,$o),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc)
      = $ite(aa(B,$o,Uua,Uuc),aa(B,C,Uu,Uuc),aa(B,C,Uub,Uuc)) ) ).

% ATP.lambda_459
tff(fact_6182_ATP_Olambda__460,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: set(product_prod(B,C)),Uua: D,Uub: B,Uuc: set(product_prod(D,C))] : ( aa(set(product_prod(D,C)),set(product_prod(D,C)),aa(B,fun(set(product_prod(D,C)),set(product_prod(D,C))),aa(D,fun(B,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aTP_Lamp_ge(set(product_prod(B,C)),fun(D,fun(B,fun(set(product_prod(D,C)),set(product_prod(D,C))))),Uu),Uua),Uub),Uuc) = finite_fold(product_prod(B,C),set(product_prod(D,C)),aa(fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),fun(product_prod(B,C),fun(set(product_prod(D,C)),set(product_prod(D,C)))),product_case_prod(B,C,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aa(B,fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),aTP_Lamp_gd(D,fun(B,fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C)))))),Uua),Uub)),Uuc,Uu) ) ).

% ATP.lambda_460
tff(fact_6183_ATP_Olambda__461,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: set(product_prod(C,D)),Uua: B,Uub: C,Uuc: set(product_prod(B,D))] : ( aa(set(product_prod(B,D)),set(product_prod(B,D)),aa(C,fun(set(product_prod(B,D)),set(product_prod(B,D))),aa(B,fun(C,fun(set(product_prod(B,D)),set(product_prod(B,D)))),aTP_Lamp_ga(set(product_prod(C,D)),fun(B,fun(C,fun(set(product_prod(B,D)),set(product_prod(B,D))))),Uu),Uua),Uub),Uuc) = finite_fold(product_prod(C,D),set(product_prod(B,D)),aa(fun(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D))))),fun(product_prod(C,D),fun(set(product_prod(B,D)),set(product_prod(B,D)))),product_case_prod(C,D,fun(set(product_prod(B,D)),set(product_prod(B,D)))),aa(C,fun(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D))))),aTP_Lamp_fz(B,fun(C,fun(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D)))))),Uua),Uub)),Uuc,Uu) ) ).

% ATP.lambda_461
tff(fact_6184_ATP_Olambda__462,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_semiring_0(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: list(C),Uuc: nat] : ( aa(nat,B,aa(list(C),fun(nat,B),aa(B,fun(list(C),fun(nat,B)),aTP_Lamp_rp(fun(C,B),fun(B,fun(list(C),fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,compow(fun(B,B),Uuc,aa(B,fun(B,B),times_times(B),Uua)),aa(C,B,Uu,nth(C,Uub,Uuc))) ) ) ).

% ATP.lambda_462
tff(fact_6185_ATP_Olambda__463,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(D,fun(list(D),fun(C,C))),Uua: fun(B,D),Uub: B,Uuc: list(B)] : ( aa(list(B),fun(C,C),aa(B,fun(list(B),fun(C,C)),aa(fun(B,D),fun(B,fun(list(B),fun(C,C))),aTP_Lamp_st(fun(D,fun(list(D),fun(C,C))),fun(fun(B,D),fun(B,fun(list(B),fun(C,C)))),Uu),Uua),Uub),Uuc) = aa(list(D),fun(C,C),aa(D,fun(list(D),fun(C,C)),Uu,aa(B,D,Uua,Uub)),aa(list(B),list(D),map(B,D,Uua),Uuc)) ) ).

% ATP.lambda_463
tff(fact_6186_ATP_Olambda__464,axiom,
    ! [C: $tType,D: $tType,E: $tType,Uu: fun(C,fun(D,$o)),Uua: fun(E,D),Uub: C,Uuc: E] :
      ( aa(E,$o,aa(C,fun(E,$o),aa(fun(E,D),fun(C,fun(E,$o)),aTP_Lamp_go(fun(C,fun(D,$o)),fun(fun(E,D),fun(C,fun(E,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(D,$o,aa(C,fun(D,$o),Uu,Uub),aa(E,D,Uua,Uuc)) ) ).

% ATP.lambda_464
tff(fact_6187_ATP_Olambda__465,axiom,
    ! [B: $tType,D: $tType,C: $tType,E: $tType] :
      ( ( order(D)
        & order(B) )
     => ! [Uu: fun(B,fun(C,D)),Uua: fun(E,C),Uub: B,Uuc: E] : ( aa(E,D,aa(B,fun(E,D),aa(fun(E,C),fun(B,fun(E,D)),aTP_Lamp_ok(fun(B,fun(C,D)),fun(fun(E,C),fun(B,fun(E,D))),Uu),Uua),Uub),Uuc) = aa(C,D,aa(B,fun(C,D),Uu,Uub),aa(E,C,Uua,Uuc)) ) ) ).

% ATP.lambda_465
tff(fact_6188_ATP_Olambda__466,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(D,C),Uub: B,Uuc: D] :
      ( aa(D,$o,aa(B,fun(D,$o),aa(fun(D,C),fun(B,fun(D,$o)),aTP_Lamp_uz(fun(B,fun(C,$o)),fun(fun(D,C),fun(B,fun(D,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(C,$o,aa(B,fun(C,$o),Uu,Uub),aa(D,C,Uua,Uuc)) ) ).

% ATP.lambda_466
tff(fact_6189_ATP_Olambda__467,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: set(D),Uuc: C] : ( aa(C,B,aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_ba(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),Uu),Uua),Uub),Uuc) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups7311177749621191930dd_sum(D,B),aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_az(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uuc)),Uub) ) ) ).

% ATP.lambda_467
tff(fact_6190_ATP_Olambda__468,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,fun(C,assn)),Uua: $o,Uub: B,Uuc: C] : ( aa(C,assn,aa(B,fun(C,assn),aa($o,fun(B,fun(C,assn)),aTP_Lamp_ar(fun(B,fun(C,assn)),fun($o,fun(B,fun(C,assn))),Uu),Uua),Uub),Uuc) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),aa(C,assn,aa(B,fun(C,assn),Uu,Uub),Uuc)),pure_assn(Uua)) ) ).

% ATP.lambda_468
tff(fact_6191_ATP_Olambda__469,axiom,
    ! [Uu: code_natural,Uua: code_natural,Uub: code_natural,Uuc: code_natural] : ( aa(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),aa(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)))),aTP_Lamp_tw(code_natural,fun(code_natural,fun(code_natural,fun(code_natural,product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))))),Uu),Uua),Uub),Uuc) = aa(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(product_prod(code_natural,code_natural),fun(product_prod(code_natural,code_natural),product_prod(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural))),product_Pair(product_prod(code_natural,code_natural),product_prod(code_natural,code_natural)),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),inc_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),Uu)),Uuc)),aa(code_natural,product_prod(code_natural,code_natural),aa(code_natural,fun(code_natural,product_prod(code_natural,code_natural)),product_Pair(code_natural,code_natural),Uub),inc_shift(aa(num,code_natural,numeral_numeral(code_natural),aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit0,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,one2))))))))))))))))))))))))))))))),Uua))) ) ).

% ATP.lambda_469
tff(fact_6192_ATP_Olambda__470,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: set(B),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(B),fun(B,fun(B,$o)),aTP_Lamp_lp(fun(B,fun(B,$o)),fun(set(B),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uuc),product_Sigma(B,B,Uua,aTP_Lamp_if(set(B),fun(B,set(B)),Uua)))
        & aa(B,$o,aa(B,fun(B,$o),Uu,Uub),Uuc) ) ) ).

% ATP.lambda_470
tff(fact_6193_ATP_Olambda__471,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gz(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uub))) ) ).

% ATP.lambda_471
tff(fact_6194_ATP_Olambda__472,axiom,
    ! [C: $tType,B: $tType,Uu: set(old_node(B,C)),Uua: set(old_node(B,C)),Uub: set(old_node(B,C)),Uuc: set(old_node(B,C))] : ( aa(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))),aTP_Lamp_wl(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),fun(set(old_node(B,C)),set(product_prod(set(old_node(B,C)),set(old_node(B,C))))))),Uu),Uua),Uub),Uuc) = aa(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),set(product_prod(set(old_node(B,C)),set(old_node(B,C)))),insert2(product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C))),aa(set(old_node(B,C)),fun(set(old_node(B,C)),product_prod(set(old_node(B,C)),set(old_node(B,C)))),product_Pair(set(old_node(B,C)),set(old_node(B,C))),old_Scons(B,C,Uu,Uub)),old_Scons(B,C,Uua,Uuc))),bot_bot(set(product_prod(set(old_node(B,C)),set(old_node(B,C)))))) ) ).

% ATP.lambda_472
tff(fact_6195_ATP_Olambda__473,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: B,Uub: array(B),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(B,fun(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_rj(nat,fun(B,fun(array(B),fun(heap_ext(product_unit),product_prod(B,product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat)),aa(B,fun(product_prod(heap_ext(product_unit),nat),product_prod(B,product_prod(heap_ext(product_unit),nat))),product_Pair(B,product_prod(heap_ext(product_unit),nat)),nth(B,array_get(B,Uuc,Uub),Uu)),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(B,Uub,Uu,Uua,Uuc)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_473
tff(fact_6196_ATP_Olambda__474,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: set(B),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(B),fun(B,fun(B,$o)),aTP_Lamp_jo(set(product_prod(B,B)),fun(set(B),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uuc),Uu)
        & ~ member(B,Uub,Uua)
        & ~ member(B,Uuc,Uua) ) ) ).

% ATP.lambda_474
tff(fact_6197_ATP_Olambda__475,axiom,
    ! [B: $tType,Uu: fun(B,nat),Uua: set(product_prod(B,B)),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aTP_Lamp_hd(fun(B,nat),fun(set(product_prod(B,B)),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(B,nat,Uu,Uub)),aa(B,nat,Uu,Uuc))
        | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(B,nat,Uu,Uub)),aa(B,nat,Uu,Uuc))
          & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uuc),Uua) ) ) ) ).

% ATP.lambda_475
tff(fact_6198_ATP_Olambda__476,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: fun(B,C),Uub: B,Uuc: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(fun(B,C),fun(B,fun(B,$o)),aTP_Lamp_is(set(product_prod(C,C)),fun(fun(B,C),fun(B,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),aa(B,C,Uua,Uub)),aa(B,C,Uua,Uuc)),Uu) ) ).

% ATP.lambda_476
tff(fact_6199_ATP_Olambda__477,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,option(C)),Uua: fun(product_prod(B,C),$o),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(fun(product_prod(B,C),$o),fun(B,fun(C,$o)),aTP_Lamp_md(fun(B,option(C)),fun(fun(product_prod(B,C),$o),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( aa(B,option(C),Uu,Uub) = aa(C,option(C),some(C),Uuc) )
        & aa(product_prod(B,C),$o,Uua,aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uub),Uuc)) ) ) ).

% ATP.lambda_477
tff(fact_6200_ATP_Olambda__478,axiom,
    ! [B: $tType] :
      ( comm_ring_1(B)
     => ! [Uu: B,Uua: B,Uub: nat,Uuc: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(B,fun(nat,fun(nat,B)),aTP_Lamp_dy(B,fun(B,fun(nat,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),binomial(Uub,Uuc))),comm_s3205402744901411588hammer(B,Uu,Uuc))),comm_s3205402744901411588hammer(B,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_478
tff(fact_6201_ATP_Olambda__479,axiom,
    ! [B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: B,Uua: B,Uub: nat,Uuc: nat] : ( aa(nat,B,aa(nat,fun(nat,B),aa(B,fun(nat,fun(nat,B)),aTP_Lamp_dw(B,fun(B,fun(nat,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),binomial(Uub,Uuc))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),Uuc))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_479
tff(fact_6202_ATP_Olambda__480,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: nat,Uub: list(B),Uuc: list(B)] :
      ( aa(list(B),$o,aa(list(B),fun(list(B),$o),aa(nat,fun(list(B),fun(list(B),$o)),aTP_Lamp_sb(set(product_prod(B,B)),fun(nat,fun(list(B),fun(list(B),$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( size_size(list(B),Uub) = Uua )
        & ( size_size(list(B),Uuc) = Uua )
        & ? [Xys2: list(B),X4: B,Y3: B,Xs6: list(B),Ys5: list(B)] :
            ( ( Uub = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xys2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),X4),Xs6)) )
            & ( Uuc = aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Xys2),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Y3),Ys5)) )
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),X4),Y3),Uu) ) ) ) ).

% ATP.lambda_480
tff(fact_6203_ATP_Olambda__481,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [Uu: B,Uua: nat,Uub: B,Uuc: nat] : ( aa(nat,B,aa(B,fun(nat,B),aa(nat,fun(B,fun(nat,B)),aTP_Lamp_dq(B,fun(nat,fun(B,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uuc)))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),Uuc)) ) ) ).

% ATP.lambda_481
tff(fact_6204_ATP_Olambda__482,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: fun(B,C),Uub: C,Uuc: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aa(fun(B,C),fun(C,fun(B,$o)),aTP_Lamp_dn(set(B),fun(fun(B,C),fun(C,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( member(B,Uuc,Uu)
        & ( aa(B,C,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_482
tff(fact_6205_ATP_Olambda__483,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,C),Uua: set(B),Uub: C,Uuc: B] :
      ( aa(B,$o,aa(C,fun(B,$o),aa(set(B),fun(C,fun(B,$o)),aTP_Lamp_jr(fun(B,C),fun(set(B),fun(C,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( member(B,Uuc,Uua)
        & ( aa(B,C,Uu,Uuc) = Uub ) ) ) ).

% ATP.lambda_483
tff(fact_6206_ATP_Olambda__484,axiom,
    ! [B: $tType] :
      ( ( monoid_mult(B)
        & comm_ring(B) )
     => ! [Uu: B,Uua: nat,Uub: B,Uuc: nat] : ( aa(nat,B,aa(B,fun(nat,B),aa(nat,fun(B,fun(nat,B)),aTP_Lamp_dr(B,fun(nat,fun(B,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uu),Uuc)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uuc))) ) ) ).

% ATP.lambda_484
tff(fact_6207_ATP_Olambda__485,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gv(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)) ) ).

% ATP.lambda_485
tff(fact_6208_ATP_Olambda__486,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_gx(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),product_Pair(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ).

% ATP.lambda_486
tff(fact_6209_ATP_Olambda__487,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: list(B),Uub: C,Uuc: list(C)] : ( aa(list(C),list(product_prod(B,C)),aa(C,fun(list(C),list(product_prod(B,C))),aa(list(B),fun(C,fun(list(C),list(product_prod(B,C)))),aTP_Lamp_to(B,fun(list(B),fun(C,fun(list(C),list(product_prod(B,C))))),Uu),Uua),Uub),Uuc) = aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uu),Uub)),zip(B,C,Uua,Uuc)) ) ).

% ATP.lambda_487
tff(fact_6210_ATP_Olambda__488,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: list(C),Uub: B,Uuc: list(B)] : ( aa(list(B),list(product_prod(B,C)),aa(B,fun(list(B),list(product_prod(B,C))),aa(list(C),fun(B,fun(list(B),list(product_prod(B,C)))),aTP_Lamp_tq(C,fun(list(C),fun(B,fun(list(B),list(product_prod(B,C))))),Uu),Uua),Uub),Uuc) = aa(list(product_prod(B,C)),list(product_prod(B,C)),aa(product_prod(B,C),fun(list(product_prod(B,C)),list(product_prod(B,C))),cons(product_prod(B,C)),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uub),Uu)),zip(B,C,Uuc,Uua)) ) ).

% ATP.lambda_488
tff(fact_6211_ATP_Olambda__489,axiom,
    ! [B: $tType,C: $tType,Uu: B,Uua: C,Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(C,fun(B,fun(C,$o)),aTP_Lamp_jt(B,fun(C,fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( Uu = Uub )
        & ( Uua = Uuc ) ) ) ).

% ATP.lambda_489
tff(fact_6212_ATP_Olambda__490,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: fun(D,set(product_prod(B,C))),Uua: D,Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(D,fun(B,fun(C,$o)),aTP_Lamp_jg(fun(D,set(product_prod(B,C))),fun(D,fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> member(product_prod(B,C),aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),Uub),Uuc),aa(D,set(product_prod(B,C)),Uu,Uua)) ) ).

% ATP.lambda_490
tff(fact_6213_ATP_Olambda__491,axiom,
    ! [B: $tType,C: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(B,C),Uuc: B] :
          ( aa(B,$o,aa(fun(B,C),fun(B,$o),aa(fun(B,C),fun(fun(B,C),fun(B,$o)),aTP_Lamp_bu(set(B),fun(fun(B,C),fun(fun(B,C),fun(B,$o))),Uu),Uua),Uub),Uuc)
        <=> ( member(B,Uuc,Uu)
            & ( aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,Uua,Uuc)),aa(B,C,Uub,Uuc)) != one_one(C) ) ) ) ) ).

% ATP.lambda_491
tff(fact_6214_ATP_Olambda__492,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: list(B),Uub: array(B),Uuc: B] : ( aa(B,assn,aa(array(B),fun(B,assn),aa(list(B),fun(array(B),fun(B,assn)),aTP_Lamp_rh(nat,fun(list(B),fun(array(B),fun(B,assn))),Uu),Uua),Uub),Uuc) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(B,Uub,Uua)),pure_assn(( Uuc = nth(B,Uua,Uu) ))) ) ) ).

% ATP.lambda_492
tff(fact_6215_ATP_Olambda__493,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_semiring_1(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: list(C),Uuc: nat] : ( aa(nat,B,aa(list(C),fun(nat,B),aa(B,fun(list(C),fun(nat,B)),aTP_Lamp_rq(fun(C,B),fun(B,fun(list(C),fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Uu,nth(C,Uub,Uuc))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uua),Uuc)) ) ) ).

% ATP.lambda_493
tff(fact_6216_ATP_Olambda__494,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_semiring_0(B)
     => ! [Uu: fun(C,B),Uua: B,Uub: C,Uuc: B] : ( aa(B,B,aa(C,fun(B,B),aa(B,fun(C,fun(B,B)),aTP_Lamp_tt(fun(C,B),fun(B,fun(C,fun(B,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(C,B,Uu,Uub)),aa(B,B,aa(B,fun(B,B),times_times(B),Uua),Uuc)) ) ) ).

% ATP.lambda_494
tff(fact_6217_ATP_Olambda__495,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( semiring_0(B)
        & comm_monoid_add(C)
        & times(C) )
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_qo(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_495
tff(fact_6218_ATP_Olambda__496,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( semiring_0(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_az(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(C,B,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_496
tff(fact_6219_ATP_Olambda__497,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( semiring_0(D)
     => ! [Uu: fun(B,D),Uua: fun(C,D),Uub: B,Uuc: C] : ( aa(C,D,aa(B,fun(C,D),aa(fun(C,D),fun(B,fun(C,D)),aTP_Lamp_jw(fun(B,D),fun(fun(C,D),fun(B,fun(C,D))),Uu),Uua),Uub),Uuc) = aa(D,D,aa(D,fun(D,D),times_times(D),aa(B,D,Uu,Uub)),aa(C,D,Uua,Uuc)) ) ) ).

% ATP.lambda_497
tff(fact_6220_ATP_Olambda__498,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_ki(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(C,B,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_498
tff(fact_6221_ATP_Olambda__499,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(C,set(B)),Uua: fun(D,set(B)),Uub: C,Uuc: D] : ( aa(D,set(B),aa(C,fun(D,set(B)),aa(fun(D,set(B)),fun(C,fun(D,set(B))),aTP_Lamp_ik(fun(C,set(B)),fun(fun(D,set(B)),fun(C,fun(D,set(B)))),Uu),Uua),Uub),Uuc) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(C,set(B),Uu,Uub)),aa(D,set(B),Uua,Uuc)) ) ).

% ATP.lambda_499
tff(fact_6222_ATP_Olambda__500,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: C,Uuc: D] : ( aa(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_ic(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(C,B,Uu,Uub)),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_500
tff(fact_6223_ATP_Olambda__501,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Uu: fun(B,filter(D)),Uua: fun(C,filter(E)),Uub: B,Uuc: C] : ( aa(C,filter(product_prod(D,E)),aa(B,fun(C,filter(product_prod(D,E))),aa(fun(C,filter(E)),fun(B,fun(C,filter(product_prod(D,E)))),aTP_Lamp_qm(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,fun(C,filter(product_prod(D,E))))),Uu),Uua),Uub),Uuc) = prod_filter(D,E,aa(B,filter(D),Uu,Uub),aa(C,filter(E),Uua,Uuc)) ) ).

% ATP.lambda_501
tff(fact_6224_ATP_Olambda__502,axiom,
    ! [D: $tType,B: $tType,C: $tType,E: $tType,Uu: fun(D,B),Uua: fun(E,C),Uub: D,Uuc: E] : ( aa(E,product_prod(B,C),aa(D,fun(E,product_prod(B,C)),aa(fun(E,C),fun(D,fun(E,product_prod(B,C))),aTP_Lamp_it(fun(D,B),fun(fun(E,C),fun(D,fun(E,product_prod(B,C)))),Uu),Uua),Uub),Uuc) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Uu,Uub)),aa(E,C,Uua,Uuc)) ) ).

% ATP.lambda_502
tff(fact_6225_ATP_Olambda__503,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Uu: fun(B,D),Uua: fun(C,E),Uub: B,Uuc: C] : ( aa(C,product_prod(D,E),aa(B,fun(C,product_prod(D,E)),aa(fun(C,E),fun(B,fun(C,product_prod(D,E))),aTP_Lamp_eu(fun(B,D),fun(fun(C,E),fun(B,fun(C,product_prod(D,E)))),Uu),Uua),Uub),Uuc) = aa(E,product_prod(D,E),aa(D,fun(E,product_prod(D,E)),product_Pair(D,E),aa(B,D,Uu,Uub)),aa(C,E,Uua,Uuc)) ) ).

% ATP.lambda_503
tff(fact_6226_ATP_Olambda__504,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( semiring_1(D)
     => ! [Uu: set(B),Uua: fun(B,C),Uub: fun(C,D),Uuc: C] : ( aa(C,D,aa(fun(C,D),fun(C,D),aa(fun(B,C),fun(fun(C,D),fun(C,D)),aTP_Lamp_do(set(B),fun(fun(B,C),fun(fun(C,D),fun(C,D))),Uu),Uua),Uub),Uuc) = aa(D,D,aa(D,fun(D,D),times_times(D),aa(nat,D,semiring_1_of_nat(D),finite_card(B,aa(fun(B,$o),set(B),collect(B),aa(C,fun(B,$o),aa(fun(B,C),fun(C,fun(B,$o)),aTP_Lamp_dn(set(B),fun(fun(B,C),fun(C,fun(B,$o))),Uu),Uua),Uuc))))),aa(C,D,Uub,Uuc)) ) ) ).

% ATP.lambda_504
tff(fact_6227_ATP_Olambda__505,axiom,
    ! [B: $tType,C: $tType,Uu: $o,Uua: fun(B,fun(C,assn)),Uub: B,Uuc: C] : ( aa(C,assn,aa(B,fun(C,assn),aa(fun(B,fun(C,assn)),fun(B,fun(C,assn)),aTP_Lamp_aq($o,fun(fun(B,fun(C,assn)),fun(B,fun(C,assn))),Uu),Uua),Uub),Uuc) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),pure_assn(Uu)),aa(C,assn,aa(B,fun(C,assn),Uua,Uub),Uuc)) ) ).

% ATP.lambda_505
tff(fact_6228_ATP_Olambda__506,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: fun(B,B),Uub: array(B),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(fun(B,B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_rk(nat,fun(fun(B,B),fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_Pair(array(B),product_prod(heap_ext(product_unit),nat)),Uub),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(B,Uub,Uu,aa(B,B,Uua,nth(B,array_get(B,Uuc,Uub),Uu)),Uuc)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit0,one2)))) ) ) ).

% ATP.lambda_506
tff(fact_6229_ATP_Olambda__507,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: B,Uub: array(B),Uuc: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),aa(B,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat)))),aTP_Lamp_rl(nat,fun(B,fun(array(B),fun(heap_ext(product_unit),product_prod(array(B),product_prod(heap_ext(product_unit),nat))))),Uu),Uua),Uub),Uuc) = aa(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat)),aa(array(B),fun(product_prod(heap_ext(product_unit),nat),product_prod(array(B),product_prod(heap_ext(product_unit),nat))),product_Pair(array(B),product_prod(heap_ext(product_unit),nat)),Uub),aa(nat,product_prod(heap_ext(product_unit),nat),aa(heap_ext(product_unit),fun(nat,product_prod(heap_ext(product_unit),nat)),product_Pair(heap_ext(product_unit),nat),array_update(B,Uub,Uu,Uua,Uuc)),one_one(nat))) ) ) ).

% ATP.lambda_507
tff(fact_6230_ATP_Olambda__508,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(D,B),Uua: fun(D,C),Uub: set(D),Uuc: B] : ( aa(B,set(C),aa(set(D),fun(B,set(C)),aa(fun(D,C),fun(set(D),fun(B,set(C))),aTP_Lamp_jl(fun(D,B),fun(fun(D,C),fun(set(D),fun(B,set(C)))),Uu),Uua),Uub),Uuc) = aa(set(D),set(C),image2(D,C,Uua),aa(set(D),set(D),aa(set(D),fun(set(D),set(D)),inf_inf(set(D)),aa(set(B),set(D),aa(fun(D,B),fun(set(B),set(D)),vimage(D,B),Uu),aa(set(B),set(B),insert2(B,Uuc),bot_bot(set(B))))),Uub)) ) ).

% ATP.lambda_508
tff(fact_6231_ATP_Olambda__509,axiom,
    ! [C: $tType,B: $tType,Uu: fun(C,heap_Time_Heap(B)),Uua: C,Uub: heap_ext(product_unit),Uuc: nat] : ( aa(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),aa(C,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat))))),aTP_Lamp_mm(fun(C,heap_Time_Heap(B)),fun(C,fun(heap_ext(product_unit),fun(nat,option(product_prod(B,product_prod(heap_ext(product_unit),nat)))))),Uu),Uua),Uub),Uuc) = heap_Time_timeFrame(B,Uuc,aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aa(heap_Time_Heap(B),fun(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),heap_Time_execute(B),aa(C,heap_Time_Heap(B),Uu,Uua)),Uub)) ) ).

% ATP.lambda_509
tff(fact_6232_ATP_Olambda__510,axiom,
    ! [B: $tType,Uu: list(B),Uua: list(B),Uub: B,Uuc: list(B)] : ( aa(list(B),option($o),aa(B,fun(list(B),option($o)),aa(list(B),fun(B,fun(list(B),option($o))),aTP_Lamp_so(list(B),fun(list(B),fun(B,fun(list(B),option($o)))),Uu),Uua),Uub),Uuc) = subset_eq_mset_impl(B,Uu,aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),append(B),Uua),Uuc)) ) ).

% ATP.lambda_510
tff(fact_6233_ATP_Olambda__511,axiom,
    ! [B: $tType,E: $tType,C: $tType,D: $tType,Uu: fun(product_prod(C,D),B),Uua: fun(E,C),Uub: E,Uuc: D] : ( aa(D,B,aa(E,fun(D,B),aa(fun(E,C),fun(E,fun(D,B)),aTP_Lamp_sw(fun(product_prod(C,D),B),fun(fun(E,C),fun(E,fun(D,B))),Uu),Uua),Uub),Uuc) = aa(product_prod(C,D),B,Uu,aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),aa(E,C,Uua,Uub)),Uuc)) ) ).

% ATP.lambda_511
tff(fact_6234_ATP_Olambda__512,axiom,
    ! [B: $tType,C: $tType,D: $tType,E: $tType,Uu: fun(product_prod(C,D),B),Uua: fun(E,D),Uub: C,Uuc: E] : ( aa(E,B,aa(C,fun(E,B),aa(fun(E,D),fun(C,fun(E,B)),aTP_Lamp_sx(fun(product_prod(C,D),B),fun(fun(E,D),fun(C,fun(E,B))),Uu),Uua),Uub),Uuc) = aa(product_prod(C,D),B,Uu,aa(D,product_prod(C,D),aa(C,fun(D,product_prod(C,D)),product_Pair(C,D),Uub),aa(E,D,Uua,Uuc))) ) ).

% ATP.lambda_512
tff(fact_6235_ATP_Olambda__513,axiom,
    ! [D: $tType,B: $tType,C: $tType,Uu: fun(D,fun(C,B)),Uua: fun(D,D),Uub: fun(fun(C,B),D),Uuc: fun(C,B)] : ( aa(fun(C,B),fun(C,B),aa(fun(fun(C,B),D),fun(fun(C,B),fun(C,B)),aa(fun(D,D),fun(fun(fun(C,B),D),fun(fun(C,B),fun(C,B))),aTP_Lamp_vm(fun(D,fun(C,B)),fun(fun(D,D),fun(fun(fun(C,B),D),fun(fun(C,B),fun(C,B)))),Uu),Uua),Uub),Uuc) = aa(D,fun(C,B),Uu,aa(D,D,Uua,aa(fun(C,B),D,Uub,Uuc))) ) ).

% ATP.lambda_513
tff(fact_6236_ATP_Olambda__514,axiom,
    ! [D: $tType,C: $tType,B: $tType,Uu: fun(D,fun(B,heap_Time_Heap(C))),Uua: fun(D,D),Uub: fun(fun(B,heap_Time_Heap(C)),D),Uuc: fun(B,heap_Time_Heap(C))] : ( aa(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C)))),aTP_Lamp_vt(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(fun(B,heap_Time_Heap(C)),fun(B,heap_Time_Heap(C))))),Uu),Uua),Uub),Uuc) = aa(D,fun(B,heap_Time_Heap(C)),Uu,aa(D,D,Uua,aa(fun(B,heap_Time_Heap(C)),D,Uub,Uuc))) ) ).

% ATP.lambda_514
tff(fact_6237_ATP_Olambda__515,axiom,
    ! [C: $tType,B: $tType] :
      ( linorder(C)
     => ! [Uu: fun(B,C),Uua: C,Uub: B,Uuc: list(B)] : ( aa(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),aa(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))),aa(C,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))))),aTP_Lamp_ry(fun(B,C),fun(C,fun(B,fun(list(B),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B))))))),Uu),Uua),Uub),Uuc) = aa(fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))),fun(product_prod(list(B),list(B)),product_prod(list(B),product_prod(list(B),list(B)))),product_case_prod(list(B),list(B),product_prod(list(B),product_prod(list(B),list(B)))),aa(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))),aa(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))),aa(C,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B))))))),aTP_Lamp_rx(fun(B,C),fun(C,fun(B,fun(list(B),fun(list(B),fun(list(B),product_prod(list(B),product_prod(list(B),list(B)))))))),Uu),Uua),Uub),Uuc)) ) ) ).

% ATP.lambda_515
tff(fact_6238_ATP_Olambda__516,axiom,
    ! [B: $tType,C: $tType,Uu: fun(B,$o),Uua: fun(B,set(product_prod(C,C))),Uub: B,Uuc: C] : ( aa(C,fun(product_prod(B,C),$o),aa(B,fun(C,fun(product_prod(B,C),$o)),aa(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(product_prod(B,C),$o))),aTP_Lamp_gn(fun(B,$o),fun(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(product_prod(B,C),$o)))),Uu),Uua),Uub),Uuc) = aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(C,fun(B,fun(C,$o)),aa(B,fun(C,fun(B,fun(C,$o))),aa(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(B,fun(C,$o)))),aTP_Lamp_gm(fun(B,$o),fun(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(B,fun(C,$o))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_516
tff(fact_6239_ATP_Olambda__517,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(C,C)),Uub: B,Uuc: C] : ( aa(C,fun(product_prod(B,C),$o),aa(B,fun(C,fun(product_prod(B,C),$o)),aa(set(product_prod(C,C)),fun(B,fun(C,fun(product_prod(B,C),$o))),aTP_Lamp_fs(set(product_prod(B,B)),fun(set(product_prod(C,C)),fun(B,fun(C,fun(product_prod(B,C),$o)))),Uu),Uua),Uub),Uuc) = aa(fun(B,fun(C,$o)),fun(product_prod(B,C),$o),product_case_prod(B,C,$o),aa(C,fun(B,fun(C,$o)),aa(B,fun(C,fun(B,fun(C,$o))),aa(set(product_prod(C,C)),fun(B,fun(C,fun(B,fun(C,$o)))),aTP_Lamp_fr(set(product_prod(B,B)),fun(set(product_prod(C,C)),fun(B,fun(C,fun(B,fun(C,$o))))),Uu),Uua),Uub),Uuc)) ) ).

% ATP.lambda_517
tff(fact_6240_ATP_Olambda__518,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( ( semiring_0(B)
        & comm_monoid_add(C)
        & times(C) )
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: multiset(D),Uuc: C] : ( aa(C,B,aa(multiset(D),fun(C,B),aa(fun(D,B),fun(multiset(D),fun(C,B)),aTP_Lamp_qp(fun(C,B),fun(fun(D,B),fun(multiset(D),fun(C,B))),Uu),Uua),Uub),Uuc) = comm_m7189776963980413722m_mset(B,aa(multiset(D),multiset(B),image_mset(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_qo(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_518
tff(fact_6241_ATP_Olambda__519,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(C,set(B)),Uua: fun(D,set(B)),Uub: set(D),Uuc: C] : ( aa(C,set(B),aa(set(D),fun(C,set(B)),aa(fun(D,set(B)),fun(set(D),fun(C,set(B))),aTP_Lamp_il(fun(C,set(B)),fun(fun(D,set(B)),fun(set(D),fun(C,set(B)))),Uu),Uua),Uub),Uuc) = aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(D),set(set(B)),image2(D,set(B),aa(C,fun(D,set(B)),aa(fun(D,set(B)),fun(C,fun(D,set(B))),aTP_Lamp_ik(fun(C,set(B)),fun(fun(D,set(B)),fun(C,fun(D,set(B)))),Uu),Uua),Uuc)),Uub)) ) ).

% ATP.lambda_519
tff(fact_6242_ATP_Olambda__520,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: set(D),Uuc: C] : ( aa(C,B,aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_id(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),Uu),Uua),Uub),Uuc) = aa(set(B),B,complete_Sup_Sup(B),aa(set(D),set(B),image2(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_ic(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_520
tff(fact_6243_ATP_Olambda__521,axiom,
    ! [B: $tType,D: $tType,E: $tType,C: $tType,Uu: set(C),Uua: fun(B,filter(D)),Uub: fun(C,filter(E)),Uuc: B] : ( aa(B,filter(product_prod(D,E)),aa(fun(C,filter(E)),fun(B,filter(product_prod(D,E))),aa(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,filter(product_prod(D,E)))),aTP_Lamp_qn(set(C),fun(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,filter(product_prod(D,E))))),Uu),Uua),Uub),Uuc) = aa(set(filter(product_prod(D,E))),filter(product_prod(D,E)),complete_Inf_Inf(filter(product_prod(D,E))),aa(set(C),set(filter(product_prod(D,E))),image2(C,filter(product_prod(D,E)),aa(B,fun(C,filter(product_prod(D,E))),aa(fun(C,filter(E)),fun(B,fun(C,filter(product_prod(D,E)))),aTP_Lamp_qm(fun(B,filter(D)),fun(fun(C,filter(E)),fun(B,fun(C,filter(product_prod(D,E))))),Uua),Uub),Uuc)),Uu)) ) ).

% ATP.lambda_521
tff(fact_6244_ATP_Olambda__522,axiom,
    ! [C: $tType,B: $tType,D: $tType] :
      ( comple592849572758109894attice(B)
     => ! [Uu: fun(C,B),Uua: fun(D,B),Uub: set(D),Uuc: C] : ( aa(C,B,aa(set(D),fun(C,B),aa(fun(D,B),fun(set(D),fun(C,B)),aTP_Lamp_kj(fun(C,B),fun(fun(D,B),fun(set(D),fun(C,B))),Uu),Uua),Uub),Uuc) = aa(set(B),B,complete_Inf_Inf(B),aa(set(D),set(B),image2(D,B,aa(C,fun(D,B),aa(fun(D,B),fun(C,fun(D,B)),aTP_Lamp_ki(fun(C,B),fun(fun(D,B),fun(C,fun(D,B))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_522
tff(fact_6245_ATP_Olambda__523,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_ez(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_523
tff(fact_6246_ATP_Olambda__524,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fg(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_524
tff(fact_6247_ATP_Olambda__525,axiom,
    ! [B: $tType,Uu: fun(B,$o),Uua: list(B),Uub: B,Uuc: list(B)] : ( aa(list(B),option(product_prod(list(B),product_prod(B,list(B)))),aa(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))),aa(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B)))))),aTP_Lamp_wo(fun(B,$o),fun(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(B),product_prod(B,list(B))),option(product_prod(list(B),product_prod(B,list(B)))),some(product_prod(list(B),product_prod(B,list(B)))),aa(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B))),aa(list(B),fun(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B)))),product_Pair(list(B),product_prod(B,list(B))),takeWhile(B,aa(fun(B,$o),fun(B,$o),aa(fun($o,$o),fun(fun(B,$o),fun(B,$o)),comp($o,$o,B),fNot),Uu),Uua)),aa(list(B),product_prod(B,list(B)),aa(B,fun(list(B),product_prod(B,list(B))),product_Pair(B,list(B)),Uub),Uuc))) ) ).

% ATP.lambda_525
tff(fact_6248_ATP_Olambda__526,axiom,
    ! [B: $tType,Uu: B,Uua: list(B),Uub: B,Uuc: list(B)] : ( aa(list(B),option(product_prod(list(B),product_prod(B,list(B)))),aa(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))),aa(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B)))))),aTP_Lamp_rz(B,fun(list(B),fun(B,fun(list(B),option(product_prod(list(B),product_prod(B,list(B))))))),Uu),Uua),Uub),Uuc) = aa(product_prod(list(B),product_prod(B,list(B))),option(product_prod(list(B),product_prod(B,list(B)))),some(product_prod(list(B),product_prod(B,list(B)))),aa(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B))),aa(list(B),fun(product_prod(B,list(B)),product_prod(list(B),product_prod(B,list(B)))),product_Pair(list(B),product_prod(B,list(B))),aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uu),Uua)),aa(list(B),product_prod(B,list(B)),aa(B,fun(list(B),product_prod(B,list(B))),product_Pair(B,list(B)),Uub),Uuc))) ) ).

% ATP.lambda_526
tff(fact_6249_ATP_Olambda__527,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fd(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uub)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_527
tff(fact_6250_ATP_Olambda__528,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_fb(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),product_Pair(int,int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_528
tff(fact_6251_ATP_Olambda__529,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: set(product_prod(C,C)),Uua: fun(B,fun(C,set(D))),Uub: C,Uuc: B] : ( aa(B,set(D),aa(C,fun(B,set(D)),aa(fun(B,fun(C,set(D))),fun(C,fun(B,set(D))),aTP_Lamp_mv(set(product_prod(C,C)),fun(fun(B,fun(C,set(D))),fun(C,fun(B,set(D)))),Uu),Uua),Uub),Uuc) = aa(set(set(D)),set(D),complete_Sup_Sup(set(D)),aa(set(C),set(set(D)),image2(C,set(D),aa(B,fun(C,set(D)),Uua,Uuc)),image(C,C,Uu,aa(set(C),set(C),insert2(C,Uub),bot_bot(set(C)))))) ) ).

% ATP.lambda_529
tff(fact_6252_ATP_Olambda__530,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: set(product_prod(B,D)),Uua: set(product_prod(D,C)),Uub: B,Uuc: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(set(product_prod(D,C)),fun(B,fun(C,$o)),aTP_Lamp_ko(set(product_prod(B,D)),fun(set(product_prod(D,C)),fun(B,fun(C,$o))),Uu),Uua),Uub),Uuc)
    <=> ? [Y3: D] :
          ( member(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),Uub),Y3),Uu)
          & member(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),Y3),Uuc),Uua) ) ) ).

% ATP.lambda_530
tff(fact_6253_ATP_Olambda__531,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: set(D),Uua: fun(D,B),Uub: fun(D,C),Uuc: product_prod(B,C)] :
      ( aa(product_prod(B,C),$o,aa(fun(D,C),fun(product_prod(B,C),$o),aa(fun(D,B),fun(fun(D,C),fun(product_prod(B,C),$o)),aTP_Lamp_kw(set(D),fun(fun(D,B),fun(fun(D,C),fun(product_prod(B,C),$o))),Uu),Uua),Uub),Uuc)
    <=> ? [A6: D] :
          ( ( Uuc = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,Uua,A6)),aa(D,C,Uub,A6)) )
          & member(D,A6,Uu) ) ) ).

% ATP.lambda_531
tff(fact_6254_ATP_Olambda__532,axiom,
    ! [B: $tType,C: $tType,Uu: set(B),Uua: set(product_prod(C,C)),Uub: fun(B,C),Uuc: product_prod(B,B)] :
      ( aa(product_prod(B,B),$o,aa(fun(B,C),fun(product_prod(B,B),$o),aa(set(product_prod(C,C)),fun(fun(B,C),fun(product_prod(B,B),$o)),aTP_Lamp_pm(set(B),fun(set(product_prod(C,C)),fun(fun(B,C),fun(product_prod(B,B),$o))),Uu),Uua),Uub),Uuc)
    <=> ? [A18: B,A25: B] :
          ( ( Uuc = aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),A18),A25) )
          & member(B,A18,Uu)
          & member(B,A25,Uu)
          & member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),aa(B,C,Uub,A18)),aa(B,C,Uub,A25)),Uua) ) ) ).

% ATP.lambda_532
tff(fact_6255_ATP_Olambda__533,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(B,fun(B,B)),Uua: B,Uub: fun(C,set(D)),Uuc: fun(D,B),Uud: C] : ( aa(C,B,aa(fun(D,B),fun(C,B),aa(fun(C,set(D)),fun(fun(D,B),fun(C,B)),aa(B,fun(fun(C,set(D)),fun(fun(D,B),fun(C,B))),aTP_Lamp_xe(fun(B,fun(B,B)),fun(B,fun(fun(C,set(D)),fun(fun(D,B),fun(C,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(D),B,aa(fun(D,B),fun(set(D),B),groups_comm_monoid_F(B,D,Uu,Uua),Uuc),aa(C,set(D),Uub,Uud)) ) ).

% ATP.lambda_533
tff(fact_6256_ATP_Olambda__534,axiom,
    ! [B: $tType,C: $tType,D: $tType,Uu: D,Uua: B,Uub: B,Uuc: C,Uud: set(product_prod(D,C))] :
      ( aa(set(product_prod(D,C)),set(product_prod(D,C)),aa(C,fun(set(product_prod(D,C)),set(product_prod(D,C))),aa(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C)))),aa(B,fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C))))),aTP_Lamp_gd(D,fun(B,fun(B,fun(C,fun(set(product_prod(D,C)),set(product_prod(D,C)))))),Uu),Uua),Uub),Uuc),Uud)
      = $ite(Uua = Uub,aa(set(product_prod(D,C)),set(product_prod(D,C)),insert2(product_prod(D,C),aa(C,product_prod(D,C),aa(D,fun(C,product_prod(D,C)),product_Pair(D,C),Uu),Uuc)),Uud),Uud) ) ).

% ATP.lambda_534
tff(fact_6257_ATP_Olambda__535,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: B,Uua: C,Uub: C,Uuc: D,Uud: set(product_prod(B,D))] :
      ( aa(set(product_prod(B,D)),set(product_prod(B,D)),aa(D,fun(set(product_prod(B,D)),set(product_prod(B,D))),aa(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D)))),aa(C,fun(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D))))),aTP_Lamp_fz(B,fun(C,fun(C,fun(D,fun(set(product_prod(B,D)),set(product_prod(B,D)))))),Uu),Uua),Uub),Uuc),Uud)
      = $ite(Uua = Uub,aa(set(product_prod(B,D)),set(product_prod(B,D)),insert2(product_prod(B,D),aa(D,product_prod(B,D),aa(B,fun(D,product_prod(B,D)),product_Pair(B,D),Uu),Uuc)),Uud),Uud) ) ).

% ATP.lambda_535
tff(fact_6258_ATP_Olambda__536,axiom,
    ! [B: $tType,Uu: fun(B,fun(B,$o)),Uua: list(B),Uub: B,Uuc: list(B),Uud: list(B)] : ( aa(list(B),list(B),aa(list(B),fun(list(B),list(B)),aa(B,fun(list(B),fun(list(B),list(B))),aa(list(B),fun(B,fun(list(B),fun(list(B),list(B)))),aTP_Lamp_tr(fun(B,fun(B,$o)),fun(list(B),fun(B,fun(list(B),fun(list(B),list(B))))),Uu),Uua),Uub),Uuc),Uud) = quicksort_by_rel(B,Uu,aa(list(B),list(B),aa(B,fun(list(B),list(B)),cons(B),Uub),quicksort_by_rel(B,Uu,Uua,Uud)),Uuc) ) ).

% ATP.lambda_536
tff(fact_6259_ATP_Olambda__537,axiom,
    ! [B: $tType,D: $tType,C: $tType,Uu: fun(D,fun(C,B)),Uua: fun(D,D),Uub: fun(fun(C,B),D),Uuc: C,Uud: fun(C,B)] : ( aa(fun(C,B),B,aa(C,fun(fun(C,B),B),aa(fun(fun(C,B),D),fun(C,fun(fun(C,B),B)),aa(fun(D,D),fun(fun(fun(C,B),D),fun(C,fun(fun(C,B),B))),aTP_Lamp_vl(fun(D,fun(C,B)),fun(fun(D,D),fun(fun(fun(C,B),D),fun(C,fun(fun(C,B),B)))),Uu),Uua),Uub),Uuc),Uud) = aa(C,B,aa(D,fun(C,B),Uu,aa(D,D,Uua,aa(fun(C,B),D,Uub,Uud))),Uuc) ) ).

% ATP.lambda_537
tff(fact_6260_ATP_Olambda__538,axiom,
    ! [C: $tType,D: $tType,B: $tType,Uu: fun(D,fun(B,heap_Time_Heap(C))),Uua: fun(D,D),Uub: fun(fun(B,heap_Time_Heap(C)),D),Uuc: B,Uud: fun(B,heap_Time_Heap(C))] : ( aa(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C),aa(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)),aa(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))),aa(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C)))),aTP_Lamp_vs(fun(D,fun(B,heap_Time_Heap(C))),fun(fun(D,D),fun(fun(fun(B,heap_Time_Heap(C)),D),fun(B,fun(fun(B,heap_Time_Heap(C)),heap_Time_Heap(C))))),Uu),Uua),Uub),Uuc),Uud) = aa(B,heap_Time_Heap(C),aa(D,fun(B,heap_Time_Heap(C)),Uu,aa(D,D,Uua,aa(fun(B,heap_Time_Heap(C)),D,Uub,Uud))),Uuc) ) ).

% ATP.lambda_538
tff(fact_6261_ATP_Olambda__539,axiom,
    ! [B: $tType,E: $tType,D: $tType,F7: $tType,C: $tType,Uu: fun(E,fun(F7,D)),Uua: fun(B,E),Uub: fun(C,F7),Uuc: B,Uud: C] : ( aa(C,D,aa(B,fun(C,D),aa(fun(C,F7),fun(B,fun(C,D)),aa(fun(B,E),fun(fun(C,F7),fun(B,fun(C,D))),aTP_Lamp_ev(fun(E,fun(F7,D)),fun(fun(B,E),fun(fun(C,F7),fun(B,fun(C,D)))),Uu),Uua),Uub),Uuc),Uud) = aa(F7,D,aa(E,fun(F7,D),Uu,aa(B,E,Uua,Uuc)),aa(C,F7,Uub,Uud)) ) ).

% ATP.lambda_539
tff(fact_6262_ATP_Olambda__540,axiom,
    ! [C: $tType,B: $tType,D: $tType,Uu: fun(B,fun(D,B)),Uua: fun(B,fun(C,fun(D,C))),Uub: B,Uuc: C,Uud: D] : ( aa(D,product_prod(B,C),aa(C,fun(D,product_prod(B,C)),aa(B,fun(C,fun(D,product_prod(B,C))),aa(fun(B,fun(C,fun(D,C))),fun(B,fun(C,fun(D,product_prod(B,C)))),aTP_Lamp_si(fun(B,fun(D,B)),fun(fun(B,fun(C,fun(D,C))),fun(B,fun(C,fun(D,product_prod(B,C))))),Uu),Uua),Uub),Uuc),Uud) = aa(C,product_prod(B,C),aa(B,fun(C,product_prod(B,C)),product_Pair(B,C),aa(D,B,aa(B,fun(D,B),Uu,Uub),Uud)),aa(D,C,aa(C,fun(D,C),aa(B,fun(C,fun(D,C)),Uua,Uub),Uuc),Uud)) ) ).

% ATP.lambda_540
tff(fact_6263_ATP_Olambda__541,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: nat,Uua: B,Uub: B,Uuc: B,Uud: nat] : ( aa(nat,B,aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_eg(nat,fun(B,fun(B,fun(B,fun(nat,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),Uud)),Uua)),one_one(B))),Uud)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uub),Uud))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_541
tff(fact_6264_ATP_Olambda__542,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: nat,Uua: B,Uub: B,Uuc: B,Uud: nat] : ( aa(nat,B,aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_ec(nat,fun(B,fun(B,fun(B,fun(nat,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(nat,B,semiring_1_of_nat(B),Uu)),Uua)),Uud)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uub),Uud))),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uuc),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_542
tff(fact_6265_ATP_Olambda__543,axiom,
    ! [B: $tType,Uu: B,Uua: B,Uub: set(product_prod(B,B)),Uuc: B,Uud: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aa(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o))),aTP_Lamp_lq(B,fun(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uuc),Uu),transitive_trancl(B,Uub))
          | ( Uuc = Uu ) )
        & ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uud),transitive_trancl(B,Uub))
          | ( Uud = Uua ) ) ) ) ).

% ATP.lambda_543
tff(fact_6266_ATP_Olambda__544,axiom,
    ! [B: $tType] :
      ( field_char_0(B)
     => ! [Uu: nat,Uua: B,Uub: B,Uuc: B,Uud: nat] : ( aa(nat,B,aa(B,fun(nat,B),aa(B,fun(B,fun(nat,B)),aa(B,fun(B,fun(B,fun(nat,B))),aTP_Lamp_ed(nat,fun(B,fun(B,fun(B,fun(nat,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,gbinomial(B,aa(B,B,uminus_uminus(B),Uua)),Uud)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,uminus_uminus(B),Uub)),Uud))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_544
tff(fact_6267_ATP_Olambda__545,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B,Uuc: B,Uud: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(B,fun(B,fun(B,$o)),aa(B,fun(B,fun(B,fun(B,$o))),aTP_Lamp_fv(set(product_prod(B,B)),fun(B,fun(B,fun(B,fun(B,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert2(B,Uua),aa(set(B),set(B),insert2(B,Uub),aa(set(B),set(B),insert2(B,Uuc),aa(set(B),set(B),insert2(B,Uud),bot_bot(set(B))))))),field2(B,Uu))
        & ( ( ( Uua = Uuc )
            & ( Uub = Uud ) )
          | member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),bNF_We1388413361240627857o_max2(B,Uu,Uua,Uub)),bNF_We1388413361240627857o_max2(B,Uu,Uuc,Uud)),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),Uu),id2(B)))
          | ( ( bNF_We1388413361240627857o_max2(B,Uu,Uua,Uub) = bNF_We1388413361240627857o_max2(B,Uu,Uuc,Uud) )
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uuc),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),Uu),id2(B))) )
          | ( ( bNF_We1388413361240627857o_max2(B,Uu,Uua,Uub) = bNF_We1388413361240627857o_max2(B,Uu,Uuc,Uud) )
            & ( Uua = Uuc )
            & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uud),aa(set(product_prod(B,B)),set(product_prod(B,B)),aa(set(product_prod(B,B)),fun(set(product_prod(B,B)),set(product_prod(B,B))),minus_minus(set(product_prod(B,B))),Uu),id2(B))) ) ) ) ) ).

% ATP.lambda_545
tff(fact_6268_ATP_Olambda__546,axiom,
    ! [B: $tType,Uu: B,Uua: B,Uub: set(product_prod(B,B)),Uuc: B,Uud: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(set(product_prod(B,B)),fun(B,fun(B,$o)),aa(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o))),aTP_Lamp_jh(B,fun(B,fun(set(product_prod(B,B)),fun(B,fun(B,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uuc),Uu),transitive_rtrancl(B,Uub))
        & member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uud),transitive_rtrancl(B,Uub)) ) ) ).

% ATP.lambda_546
tff(fact_6269_ATP_Olambda__547,axiom,
    ! [B: $tType] :
      ( heap(B)
     => ! [Uu: nat,Uua: list(B),Uub: array(B),Uuc: B,Uud: array(B)] : ( aa(array(B),assn,aa(B,fun(array(B),assn),aa(array(B),fun(B,fun(array(B),assn)),aa(list(B),fun(array(B),fun(B,fun(array(B),assn))),aTP_Lamp_ro(nat,fun(list(B),fun(array(B),fun(B,fun(array(B),assn)))),Uu),Uua),Uub),Uuc),Uud) = aa(assn,assn,aa(assn,fun(assn,assn),times_times(assn),snga_assn(B,Uub,list_update(B,Uua,Uu,Uuc))),pure_assn(( Uud = Uub ))) ) ) ).

% ATP.lambda_547
tff(fact_6270_ATP_Olambda__548,axiom,
    ! [B: $tType,Uu: set(product_prod(B,B)),Uua: B,Uub: B,Uuc: B,Uud: B] :
      ( aa(B,$o,aa(B,fun(B,$o),aa(B,fun(B,fun(B,$o)),aa(B,fun(B,fun(B,fun(B,$o))),aTP_Lamp_pj(set(product_prod(B,B)),fun(B,fun(B,fun(B,fun(B,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( ( Uub = Uuc )
       => member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uua),Uud),Uu) ) ) ).

% ATP.lambda_548
tff(fact_6271_ATP_Olambda__549,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( semiring_0(D)
     => ! [Uu: fun(B,D),Uua: fun(C,D),Uub: set(B),Uuc: set(C),Uud: D] :
          ( aa(D,$o,aa(set(C),fun(D,$o),aa(set(B),fun(set(C),fun(D,$o)),aa(fun(C,D),fun(set(B),fun(set(C),fun(D,$o))),aTP_Lamp_jx(fun(B,D),fun(fun(C,D),fun(set(B),fun(set(C),fun(D,$o)))),Uu),Uua),Uub),Uuc),Uud)
        <=> ? [A6: B,B5: C] :
              ( ( Uud = aa(D,D,aa(D,fun(D,D),times_times(D),aa(B,D,Uu,A6)),aa(C,D,Uua,B5)) )
              & member(B,A6,Uub)
              & member(C,B5,Uuc) ) ) ) ).

% ATP.lambda_549
tff(fact_6272_ATP_Olambda__550,axiom,
    ! [B: $tType,C: $tType,Uu: set(product_prod(B,B)),Uua: set(product_prod(C,C)),Uub: B,Uuc: C,Uud: B,Uue: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(C,fun(B,fun(C,$o)),aa(B,fun(C,fun(B,fun(C,$o))),aa(set(product_prod(C,C)),fun(B,fun(C,fun(B,fun(C,$o)))),aTP_Lamp_fr(set(product_prod(B,B)),fun(set(product_prod(C,C)),fun(B,fun(C,fun(B,fun(C,$o))))),Uu),Uua),Uub),Uuc),Uud),Uue)
    <=> ( member(product_prod(B,B),aa(B,product_prod(B,B),aa(B,fun(B,product_prod(B,B)),product_Pair(B,B),Uub),Uud),Uu)
        | ( ( Uub = Uud )
          & member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Uuc),Uue),Uua) ) ) ) ).

% ATP.lambda_550
tff(fact_6273_ATP_Olambda__551,axiom,
    ! [C: $tType,B: $tType,Uu: fun(B,$o),Uua: fun(B,set(product_prod(C,C))),Uub: B,Uuc: C,Uud: B,Uue: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aa(C,fun(B,fun(C,$o)),aa(B,fun(C,fun(B,fun(C,$o))),aa(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(B,fun(C,$o)))),aTP_Lamp_gm(fun(B,$o),fun(fun(B,set(product_prod(C,C))),fun(B,fun(C,fun(B,fun(C,$o))))),Uu),Uua),Uub),Uuc),Uud),Uue)
    <=> ( ( Uub = Uud )
        & aa(B,$o,Uu,Uud)
        & member(product_prod(C,C),aa(C,product_prod(C,C),aa(C,fun(C,product_prod(C,C)),product_Pair(C,C),Uuc),Uue),aa(B,set(product_prod(C,C)),Uua,Uud)) ) ) ).

% ATP.lambda_551
tff(fact_6274_ATP_Olambda__552,axiom,
    ! [Uu: fun(b,c),Uua: c,Uub: b,Uuc: list(b),Uud: list(b),Uue: list(b)] :
      ( aa(list(b),product_prod(list(b),product_prod(list(b),list(b))),aa(list(b),fun(list(b),product_prod(list(b),product_prod(list(b),list(b)))),aa(list(b),fun(list(b),fun(list(b),product_prod(list(b),product_prod(list(b),list(b))))),aa(b,fun(list(b),fun(list(b),fun(list(b),product_prod(list(b),product_prod(list(b),list(b)))))),aa(c,fun(b,fun(list(b),fun(list(b),fun(list(b),product_prod(list(b),product_prod(list(b),list(b))))))),aTP_Lamp_rx(fun(b,c),fun(c,fun(b,fun(list(b),fun(list(b),fun(list(b),product_prod(list(b),product_prod(list(b),list(b)))))))),Uu),Uua),Uub),Uuc),Uud),Uue)
      = $let(
          x: c,
          x := aa(b,c,Uu,Uub),
          $ite(
            aa(c,$o,aa(c,fun(c,$o),ord_less(c),x),Uua),
            aa(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b))),aa(list(b),fun(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b)))),product_Pair(list(b),product_prod(list(b),list(b))),aa(list(b),list(b),aa(b,fun(list(b),list(b)),cons(b),Uub),Uuc)),aa(list(b),product_prod(list(b),list(b)),aa(list(b),fun(list(b),product_prod(list(b),list(b))),product_Pair(list(b),list(b)),Uud),Uue)),
            $ite(aa(c,$o,aa(c,fun(c,$o),ord_less(c),Uua),x),aa(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b))),aa(list(b),fun(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b)))),product_Pair(list(b),product_prod(list(b),list(b))),Uuc),aa(list(b),product_prod(list(b),list(b)),aa(list(b),fun(list(b),product_prod(list(b),list(b))),product_Pair(list(b),list(b)),Uud),aa(list(b),list(b),aa(b,fun(list(b),list(b)),cons(b),Uub),Uue))),aa(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b))),aa(list(b),fun(product_prod(list(b),list(b)),product_prod(list(b),product_prod(list(b),list(b)))),product_Pair(list(b),product_prod(list(b),list(b))),Uuc),aa(list(b),product_prod(list(b),list(b)),aa(list(b),fun(list(b),product_prod(list(b),list(b))),product_Pair(list(b),list(b)),aa(list(b),list(b),aa(b,fun(list(b),list(b)),cons(b),Uub),Uud)),Uue))) ) ) ) ).

% ATP.lambda_552
tff(fact_6275_ATP_Olambda__553,axiom,
    ! [C: $tType,B: $tType,Uu: $o,Uua: B,Uub: C] :
      ( aa(C,$o,aa(B,fun(C,$o),aTP_Lamp_fq($o,fun(B,fun(C,$o)),Uu),Uua),Uub)
    <=> (Uu) ) ).

% ATP.lambda_553
tff(fact_6276_ATP_Olambda__554,axiom,
    ! [B: $tType,C: $tType,Uu: heap_Time_Heap(C),Uua: B] : ( aa(B,heap_Time_Heap(C),aTP_Lamp_vw(heap_Time_Heap(C),fun(B,heap_Time_Heap(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_554
tff(fact_6277_ATP_Olambda__555,axiom,
    ! [B: $tType,Uu: heap_Time_Heap(B),Uua: product_unit] : ( aa(product_unit,heap_Time_Heap(B),aTP_Lamp_fm(heap_Time_Heap(B),fun(product_unit,heap_Time_Heap(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_555
tff(fact_6278_ATP_Olambda__556,axiom,
    ! [C: $tType,B: $tType] :
      ( heap(C)
     => ! [Uu: heap_Time_Heap(B),Uua: C] : ( aa(C,heap_Time_Heap(B),aTP_Lamp_fu(heap_Time_Heap(B),fun(C,heap_Time_Heap(B)),Uu),Uua) = Uu ) ) ).

% ATP.lambda_556
tff(fact_6279_ATP_Olambda__557,axiom,
    ! [B: $tType,C: $tType,Uu: multiset(C),Uua: B] : ( aa(B,multiset(C),aTP_Lamp_ji(multiset(C),fun(B,multiset(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_557
tff(fact_6280_ATP_Olambda__558,axiom,
    ! [B: $tType,Uu: assn,Uua: B] : ( aa(B,assn,aTP_Lamp_ky(assn,fun(B,assn),Uu),Uua) = Uu ) ).

% ATP.lambda_558
tff(fact_6281_ATP_Olambda__559,axiom,
    ! [B: $tType,Uu: $o,Uua: B] :
      ( aa(B,$o,aTP_Lamp_aj($o,fun(B,$o),Uu),Uua)
    <=> (Uu) ) ).

% ATP.lambda_559
tff(fact_6282_ATP_Olambda__560,axiom,
    ! [D: $tType,E: $tType,Uu: set(E),Uua: D] : ( aa(D,set(E),aTP_Lamp_iu(set(E),fun(D,set(E)),Uu),Uua) = Uu ) ).

% ATP.lambda_560
tff(fact_6283_ATP_Olambda__561,axiom,
    ! [C: $tType,D: $tType,Uu: set(D),Uua: C] : ( aa(C,set(D),aTP_Lamp_jn(set(D),fun(C,set(D)),Uu),Uua) = Uu ) ).

% ATP.lambda_561
tff(fact_6284_ATP_Olambda__562,axiom,
    ! [B: $tType,D: $tType,Uu: set(D),Uua: B] : ( aa(B,set(D),aTP_Lamp_nj(set(D),fun(B,set(D)),Uu),Uua) = Uu ) ).

% ATP.lambda_562
tff(fact_6285_ATP_Olambda__563,axiom,
    ! [D: $tType,C: $tType,Uu: set(C),Uua: D] : ( aa(D,set(C),aTP_Lamp_ni(set(C),fun(D,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_563
tff(fact_6286_ATP_Olambda__564,axiom,
    ! [B: $tType,C: $tType,Uu: set(C),Uua: B] : ( aa(B,set(C),aTP_Lamp_hq(set(C),fun(B,set(C)),Uu),Uua) = Uu ) ).

% ATP.lambda_564
tff(fact_6287_ATP_Olambda__565,axiom,
    ! [D: $tType,B: $tType,Uu: set(B),Uua: D] : ( aa(D,set(B),aTP_Lamp_nh(set(B),fun(D,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_565
tff(fact_6288_ATP_Olambda__566,axiom,
    ! [C: $tType,B: $tType,Uu: set(B),Uua: C] : ( aa(C,set(B),aTP_Lamp_ho(set(B),fun(C,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_566
tff(fact_6289_ATP_Olambda__567,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] : ( aa(B,set(B),aTP_Lamp_if(set(B),fun(B,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_567
tff(fact_6290_ATP_Olambda__568,axiom,
    ! [B: $tType,C: $tType,Uu: fun(C,$o),Uua: B] : ( aa(B,fun(C,$o),aTP_Lamp_qr(fun(C,$o),fun(B,fun(C,$o)),Uu),Uua) = Uu ) ).

% ATP.lambda_568
tff(fact_6291_ATP_Olambda__569,axiom,
    ! [B: $tType,C: $tType] :
      ( condit1219197933456340205attice(C)
     => ! [Uu: C,Uua: B] : ( aa(B,C,aTP_Lamp_hm(C,fun(B,C),Uu),Uua) = Uu ) ) ).

% ATP.lambda_569
tff(fact_6292_ATP_Olambda__570,axiom,
    ! [B: $tType,C: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [Uu: C,Uua: B] : ( aa(B,C,aTP_Lamp_hn(C,fun(B,C),Uu),Uua) = Uu ) ) ).

% ATP.lambda_570
tff(fact_6293_ATP_Olambda__571,axiom,
    ! [B: $tType,C: $tType] :
      ( linorder(C)
     => ! [Uu: C,Uua: B] : ( aa(B,C,aTP_Lamp_li(C,fun(B,C),Uu),Uua) = Uu ) ) ).

% ATP.lambda_571
tff(fact_6294_ATP_Olambda__572,axiom,
    ! [D: $tType,C: $tType,Uu: C,Uua: D] : ( aa(D,C,aTP_Lamp_po(C,fun(D,C),Uu),Uua) = Uu ) ).

% ATP.lambda_572
tff(fact_6295_ATP_Olambda__573,axiom,
    ! [B: $tType,C: $tType,Uu: C,Uua: B] : ( aa(B,C,aTP_Lamp_bv(C,fun(B,C),Uu),Uua) = Uu ) ).

% ATP.lambda_573
tff(fact_6296_ATP_Olambda__574,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_iq(B,fun(C,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_574
tff(fact_6297_ATP_Olambda__575,axiom,
    ! [C: $tType,B: $tType] :
      ( semiring_1(B)
     => ! [Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_at(B,fun(C,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_575
tff(fact_6298_ATP_Olambda__576,axiom,
    ! [C: $tType,B: $tType,Uu: B,Uua: C] : ( aa(C,B,aTP_Lamp_as(B,fun(C,B),Uu),Uua) = Uu ) ).

% ATP.lambda_576
tff(fact_6299_ATP_Olambda__577,axiom,
    ! [C: $tType,Uu: C] : ( aa(C,C,aTP_Lamp_br(C,C),Uu) = Uu ) ).

% ATP.lambda_577
tff(fact_6300_ATP_Olambda__578,axiom,
    ! [B: $tType] :
      ( linorder(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_sh(B,B),Uu) = Uu ) ) ).

% ATP.lambda_578
tff(fact_6301_ATP_Olambda__579,axiom,
    ! [B: $tType] :
      ( monoid_mult(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_bn(B,B),Uu) = Uu ) ) ).

% ATP.lambda_579
tff(fact_6302_ATP_Olambda__580,axiom,
    ! [B: $tType] :
      ( semiring_Gcd(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_uq(B,B),Uu) = Uu ) ) ).

% ATP.lambda_580
tff(fact_6303_ATP_Olambda__581,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,B,aTP_Lamp_uu(B,B),Uu) = Uu ) ).

% ATP.lambda_581
tff(fact_6304_ATP_Olambda__582,axiom,
    ! [B: $tType,Uu: B] : ( aa(B,set($o),aTP_Lamp_np(B,set($o)),Uu) = top_top(set($o)) ) ).

% ATP.lambda_582
tff(fact_6305_ATP_Olambda__583,axiom,
    ! [B: $tType,C: $tType,Uu: B] : ( aa(B,set(C),aTP_Lamp_hu(B,set(C)),Uu) = top_top(set(C)) ) ).

% ATP.lambda_583
tff(fact_6306_ATP_Olambda__584,axiom,
    ! [D: $tType,C: $tType,Uu: D] : ( aa(D,set(C),aTP_Lamp_ck(D,set(C)),Uu) = bot_bot(set(C)) ) ).

% ATP.lambda_584
tff(fact_6307_ATP_Olambda__585,axiom,
    ! [C: $tType,B: $tType,Uu: C] : ( aa(C,set(B),aTP_Lamp_ij(C,set(B)),Uu) = bot_bot(set(B)) ) ).

% ATP.lambda_585
tff(fact_6308_ATP_Olambda__586,axiom,
    ! [C: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [Uu: C] : ( aa(C,B,aTP_Lamp_hl(C,B),Uu) = bot_bot(B) ) ) ).

% ATP.lambda_586
tff(fact_6309_ATP_Olambda__587,axiom,
    ! [B: $tType,E: $tType,Uu: B] : ( aa(B,set(E),aTP_Lamp_cl(B,set(E)),Uu) = bot_bot(set(E)) ) ).

% ATP.lambda_587
tff(fact_6310_ATP_Olambda__588,axiom,
    ! [B: $tType,C: $tType,Uu: B] : ( aa(B,set(C),aTP_Lamp_hp(B,set(C)),Uu) = bot_bot(set(C)) ) ).

% ATP.lambda_588
tff(fact_6311_ATP_Olambda__589,axiom,
    ! [B: $tType] :
      ( mult_zero(B)
     => ! [Uu: B] : ( aa(B,B,aTP_Lamp_bo(B,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_589
tff(fact_6312_ATP_Olambda__590,axiom,
    ! [Uu: product_unit] : ( aa(product_unit,assn,aTP_Lamp_ft(product_unit,assn),Uu) = one_one(assn) ) ).

% ATP.lambda_590
tff(fact_6313_ATP_Olambda__591,axiom,
    ! [C: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: C] : ( aa(C,B,aTP_Lamp_ak(C,B),Uu) = one_one(B) ) ) ).

% ATP.lambda_591
tff(fact_6314_ATP_Olambda__592,axiom,
    ! [B: $tType,Uu: product_unit] : ( aa(product_unit,seq(B),aTP_Lamp_vr(product_unit,seq(B)),Uu) = empty(B) ) ).

% ATP.lambda_592
tff(fact_6315_ATP_Olambda__593,axiom,
    ! [C: $tType,Uu: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_vu(heap_ext(product_unit),option(product_prod(C,product_prod(heap_ext(product_unit),nat)))),Uu) = none(product_prod(C,product_prod(heap_ext(product_unit),nat))) ) ).

% ATP.lambda_593
tff(fact_6316_ATP_Olambda__594,axiom,
    ! [B: $tType,Uu: heap_ext(product_unit)] : ( aa(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat))),aTP_Lamp_mi(heap_ext(product_unit),option(product_prod(B,product_prod(heap_ext(product_unit),nat)))),Uu) = none(product_prod(B,product_prod(heap_ext(product_unit),nat))) ) ).

% ATP.lambda_594
tff(fact_6317_ATP_Olambda__595,axiom,
    ! [C: $tType,B: $tType,Uu: C] : ( aa(C,option(B),aTP_Lamp_od(C,option(B)),Uu) = none(B) ) ).

% ATP.lambda_595
tff(fact_6318_ATP_Olambda__596,axiom,
    ! [B: $tType,D: $tType,Uu: B] : ( aa(B,option(D),aTP_Lamp_tu(B,option(D)),Uu) = none(D) ) ).

% ATP.lambda_596
tff(fact_6319_ATP_Olambda__597,axiom,
    ! [B: $tType,C: $tType,Uu: B] : ( aa(B,option(C),aTP_Lamp_mh(B,option(C)),Uu) = none(C) ) ).

% ATP.lambda_597
tff(fact_6320_ATP_Olambda__598,axiom,
    ! [B: $tType,C: $tType,Uu: B] : ( aa(B,C,aTP_Lamp_pp(B,C),Uu) = undefined(C) ) ).

% ATP.lambda_598
tff(fact_6321_ATP_Olambda__599,axiom,
    ! [Uu: product_prod(heap_ext(product_unit),set(nat))] :
      ( aa(product_prod(heap_ext(product_unit),set(nat)),$o,aTP_Lamp_af(product_prod(heap_ext(product_unit),set(nat)),$o),Uu)
    <=> $false ) ).

% ATP.lambda_599
tff(fact_6322_ATP_Olambda__600,axiom,
    ! [C: $tType,Uu: C] :
      ( aa(C,$o,aTP_Lamp_vf(C,$o),Uu)
    <=> $false ) ).

% ATP.lambda_600
tff(fact_6323_ATP_Olambda__601,axiom,
    ! [B: $tType,Uu: B] :
      ( aa(B,$o,aTP_Lamp_bi(B,$o),Uu)
    <=> $false ) ).

% ATP.lambda_601
tff(fact_6324_ATP_Olambda__602,axiom,
    ! [Uu: heap_ext(product_unit)] :
      ( aa(heap_ext(product_unit),$o,aTP_Lamp_wb(heap_ext(product_unit),$o),Uu)
    <=> $true ) ).

% ATP.lambda_602
tff(fact_6325_ATP_Olambda__603,axiom,
    ! [B: $tType,Uu: fun(B,$o)] :
      ( aa(fun(B,$o),$o,aTP_Lamp_pb(fun(B,$o),$o),Uu)
    <=> $true ) ).

% ATP.lambda_603
tff(fact_6326_ATP_Olambda__604,axiom,
    ! [D: $tType,Uu: D] :
      ( aa(D,$o,aTP_Lamp_qz(D,$o),Uu)
    <=> $true ) ).

% ATP.lambda_604
tff(fact_6327_ATP_Olambda__605,axiom,
    ! [B: $tType,Uu: B] :
      ( aa(B,$o,aTP_Lamp_ra(B,$o),Uu)
    <=> $true ) ).

% ATP.lambda_605

% Type constructors (840)
tff(tcon_Heap__Time__Monad_OHeap___Code__Evaluation_Oterm__of,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(heap_Time_Heap(A19)) ) ).

tff(tcon_Heap__Time__Monad_OHeap___Typerep_Otyperep,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(heap_Time_Heap(A19)) ) ).

tff(tcon_Code__Numeral_Onatural___Code__Evaluation_Oterm__of_1,axiom,
    code_term_of(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Typerep_Otyperep_2,axiom,
    typerep2(code_natural) ).

tff(tcon_Code__Numeral_Ointeger___Code__Evaluation_Oterm__of_3,axiom,
    code_term_of(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Typerep_Otyperep_4,axiom,
    typerep2(code_integer) ).

tff(tcon_Code__Evaluation_Oterm___Code__Evaluation_Oterm__of_5,axiom,
    code_term_of(code_term) ).

tff(tcon_Code__Evaluation_Oterm___Typerep_Otyperep_6,axiom,
    typerep2(code_term) ).

tff(tcon_Heap_Oheap_Oheap__ext___Code__Evaluation_Oterm__of_7,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(heap_ext(A19)) ) ).

tff(tcon_Heap_Oheap_Oheap__ext___Typerep_Otyperep_8,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(heap_ext(A19)) ) ).

tff(tcon_Product__Type_Ounit___Code__Evaluation_Oterm__of_9,axiom,
    code_term_of(product_unit) ).

tff(tcon_Product__Type_Ounit___Enum_Oenum,axiom,
    enum(product_unit) ).

tff(tcon_Product__Type_Ounit___Typerep_Otyperep_10,axiom,
    typerep2(product_unit) ).

tff(tcon_Product__Type_Oprod___Code__Evaluation_Oterm__of_11,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => code_term_of(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___Enum_Oenum_12,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( enum(A19)
        & enum(A20) )
     => enum(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___Typerep_Otyperep_13,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => typerep2(product_prod(A19,A20)) ) ).

tff(tcon_Old__Datatype_Onode___Typerep_Otyperep_14,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => typerep2(old_node(A19,A20)) ) ).

tff(tcon_Multiset_Omultiset___Code__Evaluation_Oterm__of_15,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Typerep_Otyperep_16,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(multiset(A19)) ) ).

tff(tcon_Typerep_Otyperep___Code__Evaluation_Oterm__of_17,axiom,
    code_term_of(typerep) ).

tff(tcon_Typerep_Otyperep___Typerep_Otyperep_18,axiom,
    typerep2(typerep) ).

tff(tcon_Assertions_Oassn___Typerep_Otyperep_19,axiom,
    typerep2(assn) ).

tff(tcon_Predicate_Opred___Code__Evaluation_Oterm__of_20,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(pred(A19)) ) ).

tff(tcon_Predicate_Opred___Typerep_Otyperep_21,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(pred(A19)) ) ).

tff(tcon_Predicate_Oseq___Code__Evaluation_Oterm__of_22,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(seq(A19)) ) ).

tff(tcon_Predicate_Oseq___Typerep_Otyperep_23,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(seq(A19)) ) ).

tff(tcon_Option_Ooption___Code__Evaluation_Oterm__of_24,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(option(A19)) ) ).

tff(tcon_Option_Ooption___Enum_Oenum_25,axiom,
    ! [A19: $tType] :
      ( enum(A19)
     => enum(option(A19)) ) ).

tff(tcon_Option_Ooption___Typerep_Otyperep_26,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(option(A19)) ) ).

tff(tcon_Filter_Ofilter___Code__Evaluation_Oterm__of_27,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(filter(A19)) ) ).

tff(tcon_Filter_Ofilter___Typerep_Otyperep_28,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(filter(A19)) ) ).

tff(tcon_Sum__Type_Osum___Code__Evaluation_Oterm__of_29,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => code_term_of(sum_sum(A19,A20)) ) ).

tff(tcon_Sum__Type_Osum___Enum_Oenum_30,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( enum(A19)
        & enum(A20) )
     => enum(sum_sum(A19,A20)) ) ).

tff(tcon_Sum__Type_Osum___Typerep_Otyperep_31,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => typerep2(sum_sum(A19,A20)) ) ).

tff(tcon_String_Ochar___Code__Evaluation_Oterm__of_32,axiom,
    code_term_of(char) ).

tff(tcon_String_Ochar___Enum_Oenum_33,axiom,
    enum(char) ).

tff(tcon_String_Ochar___Typerep_Otyperep_34,axiom,
    typerep2(char) ).

tff(tcon_Heap_Oarray___Code__Evaluation_Oterm__of_35,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(array(A19)) ) ).

tff(tcon_Heap_Oarray___Typerep_Otyperep_36,axiom,
    ! [A19: $tType] : typerep2(array(A19)) ).

tff(tcon_List_Olist___Code__Evaluation_Oterm__of_37,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(list(A19)) ) ).

tff(tcon_List_Olist___Typerep_Otyperep_38,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(list(A19)) ) ).

tff(tcon_Heap_Oref___Code__Evaluation_Oterm__of_39,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(ref(A19)) ) ).

tff(tcon_Heap_Oref___Typerep_Otyperep_40,axiom,
    ! [A19: $tType] : typerep2(ref(A19)) ).

tff(tcon_HOL_Obool___Code__Evaluation_Oterm__of_41,axiom,
    code_term_of($o) ).

tff(tcon_HOL_Obool___Enum_Oenum_42,axiom,
    enum($o) ).

tff(tcon_HOL_Obool___Typerep_Otyperep_43,axiom,
    typerep2($o) ).

tff(tcon_Set_Oset___Code__Evaluation_Oterm__of_44,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(set(A19)) ) ).

tff(tcon_Set_Oset___Enum_Oenum_45,axiom,
    ! [A19: $tType] :
      ( enum(A19)
     => enum(set(A19)) ) ).

tff(tcon_Set_Oset___Typerep_Otyperep_46,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(set(A19)) ) ).

tff(tcon_Rat_Orat___Code__Evaluation_Oterm__of_47,axiom,
    code_term_of(rat) ).

tff(tcon_Rat_Orat___Typerep_Otyperep_48,axiom,
    typerep2(rat) ).

tff(tcon_Num_Onum___Code__Evaluation_Oterm__of_49,axiom,
    code_term_of(num) ).

tff(tcon_Num_Onum___Typerep_Otyperep_50,axiom,
    typerep2(num) ).

tff(tcon_Nat_Onat___Code__Evaluation_Oterm__of_51,axiom,
    code_term_of(nat) ).

tff(tcon_Nat_Onat___Typerep_Otyperep_52,axiom,
    typerep2(nat) ).

tff(tcon_Int_Oint___Code__Evaluation_Oterm__of_53,axiom,
    code_term_of(int) ).

tff(tcon_Int_Oint___Typerep_Otyperep_54,axiom,
    typerep2(int) ).

tff(tcon_itself___Code__Evaluation_Oterm__of_55,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => code_term_of(itself(A19)) ) ).

tff(tcon_itself___Typerep_Otyperep_56,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => typerep2(itself(A19)) ) ).

tff(tcon_fun___Code__Evaluation_Oterm__of_57,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => code_term_of(fun(A19,A20)) ) ).

tff(tcon_fun___Enum_Oenum_58,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( enum(A19)
        & enum(A20) )
     => enum(fun(A19,A20)) ) ).

tff(tcon_fun___Typerep_Otyperep_59,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( typerep2(A19)
        & typerep2(A20) )
     => typerep2(fun(A19,A20)) ) ).

tff(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( comple6319245703460814977attice(A20)
     => condit1219197933456340205attice(fun(A19,A20)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( comple592849572758109894attice(A20)
     => comple592849572758109894attice(fun(A19,A20)) ) ).

tff(tcon_fun___Quickcheck__Exhaustive_Ofull__exhaustive,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( cl_HOL_Oequal(A19)
        & quickc3360725361186068524ustive(A19)
        & quickc3360725361186068524ustive(A20) )
     => quickc3360725361186068524ustive(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bounded_lattice(A20)
     => bounde4967611905675639751up_bot(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bounded_lattice(A20)
     => bounde4346867609351753570nf_top(fun(A19,A20)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( comple6319245703460814977attice(A20)
     => comple6319245703460814977attice(fun(A19,A20)) ) ).

tff(tcon_fun___Quickcheck__Exhaustive_Oexhaustive,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( cl_HOL_Oequal(A19)
        & quickc658316121487927005ustive(A19)
        & quickc658316121487927005ustive(A20) )
     => quickc658316121487927005ustive(fun(A19,A20)) ) ).

tff(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A19: $tType,A20: $tType] :
      ( boolea8198339166811842893lgebra(A20)
     => boolea8198339166811842893lgebra(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice__top,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bounded_lattice(A20)
     => bounded_lattice_top(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice__bot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bounded_lattice(A20)
     => bounded_lattice_bot(fun(A19,A20)) ) ).

tff(tcon_fun___Complete__Partial__Order_Occpo,axiom,
    ! [A19: $tType,A20: $tType] :
      ( comple6319245703460814977attice(A20)
     => comple9053668089753744459l_ccpo(fun(A19,A20)) ) ).

tff(tcon_fun___Quickcheck__Random_Orandom,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( code_term_of(A19)
        & cl_HOL_Oequal(A19)
        & quickcheck_random(A20) )
     => quickcheck_random(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A19: $tType,A20: $tType] :
      ( semilattice_sup(A20)
     => semilattice_sup(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A19: $tType,A20: $tType] :
      ( semilattice_inf(A20)
     => semilattice_inf(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( distrib_lattice(A20)
     => distrib_lattice(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Obounded__lattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bounded_lattice(A20)
     => bounded_lattice(fun(A19,A20)) ) ).

tff(tcon_fun___Complete__Lattices_OSup,axiom,
    ! [A19: $tType,A20: $tType] :
      ( complete_Sup(A20)
     => complete_Sup(fun(A19,A20)) ) ).

tff(tcon_fun___Complete__Lattices_OInf,axiom,
    ! [A19: $tType,A20: $tType] :
      ( complete_Inf(A20)
     => complete_Inf(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A19: $tType,A20: $tType] :
      ( order_top(A20)
     => order_top(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( order_bot(A20)
     => order_bot(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Opreorder,axiom,
    ! [A19: $tType,A20: $tType] :
      ( preorder(A20)
     => preorder(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Olattice,axiom,
    ! [A19: $tType,A20: $tType] :
      ( lattice(A20)
     => lattice(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Oorder,axiom,
    ! [A19: $tType,A20: $tType] :
      ( order(A20)
     => order(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Otop,axiom,
    ! [A19: $tType,A20: $tType] :
      ( top(A20)
     => top(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Oord,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ord(A20)
     => ord(fun(A19,A20)) ) ).

tff(tcon_fun___Orderings_Obot,axiom,
    ! [A19: $tType,A20: $tType] :
      ( bot(A20)
     => bot(fun(A19,A20)) ) ).

tff(tcon_fun___Groups_Ouminus,axiom,
    ! [A19: $tType,A20: $tType] :
      ( uminus(A20)
     => uminus(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Osup,axiom,
    ! [A19: $tType,A20: $tType] :
      ( semilattice_sup(A20)
     => sup(fun(A19,A20)) ) ).

tff(tcon_fun___Lattices_Oinf,axiom,
    ! [A19: $tType,A20: $tType] :
      ( semilattice_inf(A20)
     => inf(fun(A19,A20)) ) ).

tff(tcon_fun___Groups_Ominus,axiom,
    ! [A19: $tType,A20: $tType] :
      ( minus(A20)
     => minus(fun(A19,A20)) ) ).

tff(tcon_fun___HOL_Oequal,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( enum(A19)
        & cl_HOL_Oequal(A20) )
     => cl_HOL_Oequal(fun(A19,A20)) ) ).

tff(tcon_itself___Quickcheck__Random_Orandom_60,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => quickcheck_random(itself(A19)) ) ).

tff(tcon_itself___HOL_Oequal_61,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(itself(A19)) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder(int) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_62,axiom,
    condit1219197933456340205attice(int) ).

tff(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations(int) ).

tff(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel(int) ).

tff(tcon_Int_Oint___Rings_Onormalization__semidom__multiplicative,axiom,
    normal6328177297339901930cative(int) ).

tff(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict(int) ).

tff(tcon_Int_Oint___Quickcheck__Exhaustive_Ofull__exhaustive_63,axiom,
    quickc3360725361186068524ustive(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add(int) ).

tff(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide__unit__factor,axiom,
    semido2269285787275462019factor(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict(int) ).

tff(tcon_Int_Oint___Quickcheck__Exhaustive_Oexhaustive_64,axiom,
    quickc658316121487927005ustive(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize(int) ).

tff(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add(int) ).

tff(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits(int) ).

tff(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring(int) ).

tff(tcon_Int_Oint___Rings_Onormalization__semidom,axiom,
    normal8620421768224518004emidom(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom(int) ).

tff(tcon_Int_Oint___Quickcheck__Random_Orandom_65,axiom,
    quickcheck_random(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__sup_66,axiom,
    semilattice_sup(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__inf_67,axiom,
    semilattice_inf(int) ).

tff(tcon_Int_Oint___Lattices_Odistrib__lattice_68,axiom,
    distrib_lattice(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs(int) ).

tff(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult(int) ).

tff(tcon_Int_Oint___Complete__Lattices_OSup_69,axiom,
    complete_Sup(int) ).

tff(tcon_Int_Oint___Complete__Lattices_OInf_70,axiom,
    complete_Inf(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide(int) ).

tff(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring(int) ).

tff(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0(int) ).

tff(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn(int) ).

tff(tcon_Int_Oint___Orderings_Opreorder_71,axiom,
    preorder(int) ).

tff(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0(int) ).

tff(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top(int) ).

tff(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot(int) ).

tff(tcon_Int_Oint___Lattices_Olattice_72,axiom,
    lattice(int) ).

tff(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd(int) ).

tff(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring(int) ).

tff(tcon_Int_Oint___Orderings_Oorder_73,axiom,
    order(int) ).

tff(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral(int) ).

tff(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0(int) ).

tff(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring(int) ).

tff(tcon_Int_Oint___Orderings_Oord_74,axiom,
    ord(int) ).

tff(tcon_Int_Oint___Groups_Ouminus_75,axiom,
    uminus(int) ).

tff(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1(int) ).

tff(tcon_Int_Oint___Lattices_Osup_76,axiom,
    sup(int) ).

tff(tcon_Int_Oint___Lattices_Oinf_77,axiom,
    inf(int) ).

tff(tcon_Int_Oint___Groups_Otimes,axiom,
    times(int) ).

tff(tcon_Int_Oint___Groups_Ominus_78,axiom,
    minus(int) ).

tff(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd(int) ).

tff(tcon_Int_Oint___Power_Opower,axiom,
    power(int) ).

tff(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral(int) ).

tff(tcon_Int_Oint___Groups_Ozero,axiom,
    zero(int) ).

tff(tcon_Int_Oint___Rings_Oring,axiom,
    ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom,axiom,
    idom(int) ).

tff(tcon_Int_Oint___Groups_Oone,axiom,
    one(int) ).

tff(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd(int) ).

tff(tcon_Int_Oint___Heap_Oheap,axiom,
    heap(int) ).

tff(tcon_Int_Oint___HOL_Oequal_79,axiom,
    cl_HOL_Oequal(int) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_80,axiom,
    condit6923001295902523014norder(nat) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_81,axiom,
    condit1219197933456340205attice(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_82,axiom,
    bit_un5681908812861735899ations(nat) ).

tff(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_83,axiom,
    semiri1453513574482234551roduct(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_84,axiom,
    euclid5411537665997757685th_nat(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_85,axiom,
    ordere1937475149494474687imp_le(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_86,axiom,
    euclid3128863361964157862miring(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_87,axiom,
    euclid4440199948858584721cancel(nat) ).

tff(tcon_Nat_Onat___Rings_Onormalization__semidom__multiplicative_88,axiom,
    normal6328177297339901930cative(nat) ).

tff(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_89,axiom,
    unique1627219031080169319umeral(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_90,axiom,
    semiri6575147826004484403cancel(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_91,axiom,
    strict9044650504122735259up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_92,axiom,
    ordere580206878836729694up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_93,axiom,
    ordere2412721322843649153imp_le(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_94,axiom,
    bit_se359711467146920520ations(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_95,axiom,
    linord2810124833399127020strict(nat) ).

tff(tcon_Nat_Onat___Quickcheck__Exhaustive_Ofull__exhaustive_96,axiom,
    quickc3360725361186068524ustive(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_97,axiom,
    strict7427464778891057005id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_98,axiom,
    ordere8940638589300402666id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_99,axiom,
    euclid3725896446679973847miring(nat) ).

tff(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_100,axiom,
    linord4140545234300271783up_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_101,axiom,
    linord181362715937106298miring(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide__unit__factor_102,axiom,
    semido2269285787275462019factor(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_103,axiom,
    linord8928482502909563296strict(nat) ).

tff(tcon_Nat_Onat___Quickcheck__Exhaustive_Oexhaustive_104,axiom,
    quickc658316121487927005ustive(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_105,axiom,
    semiri3467727345109120633visors(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_106,axiom,
    ordere6658533253407199908up_add(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_107,axiom,
    semiri6843258321239162965malize(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_108,axiom,
    ordere6911136660526730532id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_109,axiom,
    cancel2418104881723323429up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_110,axiom,
    cancel1802427076303600483id_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_111,axiom,
    comm_s4317794764714335236cancel(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_112,axiom,
    bit_semiring_bits(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__comm__semiring_113,axiom,
    ordere2520102378445227354miring(nat) ).

tff(tcon_Nat_Onat___Rings_Onormalization__semidom_114,axiom,
    normal8620421768224518004emidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_115,axiom,
    cancel_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring_116,axiom,
    linordered_semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring__0_117,axiom,
    ordered_semiring_0(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semidom_118,axiom,
    linordered_semidom(nat) ).

tff(tcon_Nat_Onat___Quickcheck__Random_Orandom_119,axiom,
    quickcheck_random(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__sup_120,axiom,
    semilattice_sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__inf_121,axiom,
    semilattice_inf(nat) ).

tff(tcon_Nat_Onat___Lattices_Odistrib__lattice_122,axiom,
    distrib_lattice(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__mult_123,axiom,
    ab_semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Oalgebraic__semidom_124,axiom,
    algebraic_semidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_125,axiom,
    comm_monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__add_126,axiom,
    ab_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring_127,axiom,
    ordered_semiring(nat) ).

tff(tcon_Nat_Onat___Parity_Osemiring__parity_128,axiom,
    semiring_parity(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__add_129,axiom,
    comm_monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__modulo_130,axiom,
    semiring_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1_131,axiom,
    comm_semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__0_132,axiom,
    comm_semiring_0(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__mult_133,axiom,
    semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Complete__Lattices_OSup_134,axiom,
    complete_Sup(nat) ).

tff(tcon_Nat_Onat___Complete__Lattices_OInf_135,axiom,
    complete_Inf(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__modulo_136,axiom,
    semidom_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide_137,axiom,
    semidom_divide(nat) ).

tff(tcon_Nat_Onat___Num_Osemiring__numeral_138,axiom,
    semiring_numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__add_139,axiom,
    semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__less__one_140,axiom,
    zero_less_one(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring_141,axiom,
    comm_semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder__bot_142,axiom,
    order_bot(nat) ).

tff(tcon_Nat_Onat___Nat_Osemiring__char__0_143,axiom,
    semiring_char_0(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__neq__one_144,axiom,
    zero_neq_one(nat) ).

tff(tcon_Nat_Onat___Orderings_Opreorder_145,axiom,
    preorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Olinorder_146,axiom,
    linorder(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__mult_147,axiom,
    monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__add_148,axiom,
    monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1_149,axiom,
    semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__0_150,axiom,
    semiring_0(nat) ).

tff(tcon_Nat_Onat___Orderings_Ono__top_151,axiom,
    no_top(nat) ).

tff(tcon_Nat_Onat___Lattices_Olattice_152,axiom,
    lattice(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd_153,axiom,
    semiring_gcd(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__Gcd_154,axiom,
    semiring_Gcd(nat) ).

tff(tcon_Nat_Onat___Rings_Omult__zero_155,axiom,
    mult_zero(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder_156,axiom,
    order(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring_157,axiom,
    semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Oord_158,axiom,
    ord(nat) ).

tff(tcon_Nat_Onat___Orderings_Obot_159,axiom,
    bot(nat) ).

tff(tcon_Nat_Onat___Lattices_Osup_160,axiom,
    sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Oinf_161,axiom,
    inf(nat) ).

tff(tcon_Nat_Onat___Groups_Otimes_162,axiom,
    times(nat) ).

tff(tcon_Nat_Onat___Groups_Ominus_163,axiom,
    minus(nat) ).

tff(tcon_Nat_Onat___Power_Opower_164,axiom,
    power(nat) ).

tff(tcon_Nat_Onat___Num_Onumeral_165,axiom,
    numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Ozero_166,axiom,
    zero(nat) ).

tff(tcon_Nat_Onat___Groups_Oone_167,axiom,
    one(nat) ).

tff(tcon_Nat_Onat___Rings_Odvd_168,axiom,
    dvd(nat) ).

tff(tcon_Nat_Onat___Heap_Oheap_169,axiom,
    heap(nat) ).

tff(tcon_Nat_Onat___HOL_Oequal_170,axiom,
    cl_HOL_Oequal(nat) ).

tff(tcon_Num_Onum___Quickcheck__Exhaustive_Ofull__exhaustive_171,axiom,
    quickc3360725361186068524ustive(num) ).

tff(tcon_Num_Onum___Quickcheck__Random_Orandom_172,axiom,
    quickcheck_random(num) ).

tff(tcon_Num_Onum___Orderings_Opreorder_173,axiom,
    preorder(num) ).

tff(tcon_Num_Onum___Orderings_Olinorder_174,axiom,
    linorder(num) ).

tff(tcon_Num_Onum___Orderings_Oorder_175,axiom,
    order(num) ).

tff(tcon_Num_Onum___Orderings_Oord_176,axiom,
    ord(num) ).

tff(tcon_Num_Onum___Groups_Otimes_177,axiom,
    times(num) ).

tff(tcon_Num_Onum___HOL_Oequal_178,axiom,
    cl_HOL_Oequal(num) ).

tff(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_179,axiom,
    semiri1453513574482234551roduct(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_180,axiom,
    ordere1937475149494474687imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_181,axiom,
    semiri6575147826004484403cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_182,axiom,
    strict9044650504122735259up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_183,axiom,
    ordere580206878836729694up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_184,axiom,
    ordere2412721322843649153imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_185,axiom,
    linord2810124833399127020strict(rat) ).

tff(tcon_Rat_Orat___Quickcheck__Exhaustive_Ofull__exhaustive_186,axiom,
    quickc3360725361186068524ustive(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_187,axiom,
    strict7427464778891057005id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_188,axiom,
    ordere8940638589300402666id_add(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_189,axiom,
    linord715952674999750819strict(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_190,axiom,
    linord4140545234300271783up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_191,axiom,
    linord181362715937106298miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_192,axiom,
    linord8928482502909563296strict(rat) ).

tff(tcon_Rat_Orat___Quickcheck__Exhaustive_Oexhaustive_193,axiom,
    quickc658316121487927005ustive(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_194,axiom,
    semiri3467727345109120633visors(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_195,axiom,
    ordere6658533253407199908up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_196,axiom,
    ordere166539214618696060dd_abs(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_197,axiom,
    ordere6911136660526730532id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_198,axiom,
    linord5086331880401160121up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_199,axiom,
    cancel2418104881723323429up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_200,axiom,
    ring_15535105094025558882visors(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_201,axiom,
    cancel1802427076303600483id_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring__strict_202,axiom,
    linord4710134922213307826strict(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_203,axiom,
    comm_s4317794764714335236cancel(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__comm__semiring_204,axiom,
    ordere2520102378445227354miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1_205,axiom,
    linord6961819062388156250ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add_206,axiom,
    ordered_ab_group_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_207,axiom,
    cancel_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring_208,axiom,
    linordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring__0_209,axiom,
    ordered_semiring_0(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semidom_210,axiom,
    linordered_semidom(rat) ).

tff(tcon_Rat_Orat___Quickcheck__Random_Orandom_211,axiom,
    quickcheck_random(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__sup_212,axiom,
    semilattice_sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__inf_213,axiom,
    semilattice_inf(rat) ).

tff(tcon_Rat_Orat___Lattices_Odistrib__lattice_214,axiom,
    distrib_lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__mult_215,axiom,
    ab_semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_216,axiom,
    comm_monoid_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__add_217,axiom,
    ab_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring_218,axiom,
    ordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring__abs_219,axiom,
    ordered_ring_abs(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__add_220,axiom,
    comm_monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring_221,axiom,
    linordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__idom_222,axiom,
    linordered_idom(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1_223,axiom,
    comm_semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__0_224,axiom,
    comm_semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__mult_225,axiom,
    semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom__divide_226,axiom,
    semidom_divide(rat) ).

tff(tcon_Rat_Orat___Num_Osemiring__numeral_227,axiom,
    semiring_numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__add_228,axiom,
    semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__less__one_229,axiom,
    zero_less_one(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring_230,axiom,
    comm_semiring(rat) ).

tff(tcon_Rat_Orat___Nat_Osemiring__char__0_231,axiom,
    semiring_char_0(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__group__add_232,axiom,
    ab_group_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__neq__one_233,axiom,
    zero_neq_one(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring_234,axiom,
    ordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__abs__sgn_235,axiom,
    idom_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Orderings_Opreorder_236,axiom,
    preorder(rat) ).

tff(tcon_Rat_Orat___Orderings_Olinorder_237,axiom,
    linorder(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__mult_238,axiom,
    monoid_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring__1_239,axiom,
    comm_ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__add_240,axiom,
    monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1_241,axiom,
    semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__0_242,axiom,
    semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__top_243,axiom,
    no_top(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__bot_244,axiom,
    no_bot(rat) ).

tff(tcon_Rat_Orat___Lattices_Olattice_245,axiom,
    lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Ogroup__add_246,axiom,
    group_add(rat) ).

tff(tcon_Rat_Orat___Rings_Omult__zero_247,axiom,
    mult_zero(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring_248,axiom,
    comm_ring(rat) ).

tff(tcon_Rat_Orat___Orderings_Oorder_249,axiom,
    order(rat) ).

tff(tcon_Rat_Orat___Num_Oneg__numeral_250,axiom,
    neg_numeral(rat) ).

tff(tcon_Rat_Orat___Nat_Oring__char__0_251,axiom,
    ring_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring_252,axiom,
    semiring(rat) ).

tff(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse(rat) ).

tff(tcon_Rat_Orat___Orderings_Oord_253,axiom,
    ord(rat) ).

tff(tcon_Rat_Orat___Groups_Ouminus_254,axiom,
    uminus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1_255,axiom,
    ring_1(rat) ).

tff(tcon_Rat_Orat___Lattices_Osup_256,axiom,
    sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Oinf_257,axiom,
    inf(rat) ).

tff(tcon_Rat_Orat___Groups_Otimes_258,axiom,
    times(rat) ).

tff(tcon_Rat_Orat___Groups_Ominus_259,axiom,
    minus(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield,axiom,
    field(rat) ).

tff(tcon_Rat_Orat___Power_Opower_260,axiom,
    power(rat) ).

tff(tcon_Rat_Orat___Num_Onumeral_261,axiom,
    numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Ozero_262,axiom,
    zero(rat) ).

tff(tcon_Rat_Orat___Rings_Oring_263,axiom,
    ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom_264,axiom,
    idom(rat) ).

tff(tcon_Rat_Orat___Groups_Oone_265,axiom,
    one(rat) ).

tff(tcon_Rat_Orat___Rings_Odvd_266,axiom,
    dvd(rat) ).

tff(tcon_Rat_Orat___HOL_Oequal_267,axiom,
    cl_HOL_Oequal(rat) ).

tff(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_268,axiom,
    ! [A19: $tType] : condit1219197933456340205attice(set(A19)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_269,axiom,
    ! [A19: $tType] : comple592849572758109894attice(set(A19)) ).

tff(tcon_Set_Oset___Quickcheck__Exhaustive_Ofull__exhaustive_270,axiom,
    ! [A19: $tType] :
      ( quickc3360725361186068524ustive(A19)
     => quickc3360725361186068524ustive(set(A19)) ) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_271,axiom,
    ! [A19: $tType] : bounde4967611905675639751up_bot(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_272,axiom,
    ! [A19: $tType] : bounde4346867609351753570nf_top(set(A19)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_273,axiom,
    ! [A19: $tType] : comple6319245703460814977attice(set(A19)) ).

tff(tcon_Set_Oset___Quickcheck__Exhaustive_Oexhaustive_274,axiom,
    ! [A19: $tType] :
      ( quickc658316121487927005ustive(A19)
     => quickc658316121487927005ustive(set(A19)) ) ).

tff(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_275,axiom,
    ! [A19: $tType] : boolea8198339166811842893lgebra(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice__top_276,axiom,
    ! [A19: $tType] : bounded_lattice_top(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice__bot_277,axiom,
    ! [A19: $tType] : bounded_lattice_bot(set(A19)) ).

tff(tcon_Set_Oset___Complete__Partial__Order_Occpo_278,axiom,
    ! [A19: $tType] : comple9053668089753744459l_ccpo(set(A19)) ).

tff(tcon_Set_Oset___Quickcheck__Random_Orandom_279,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(set(A19)) ) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__sup_280,axiom,
    ! [A19: $tType] : semilattice_sup(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__inf_281,axiom,
    ! [A19: $tType] : semilattice_inf(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Odistrib__lattice_282,axiom,
    ! [A19: $tType] : distrib_lattice(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice_283,axiom,
    ! [A19: $tType] : bounded_lattice(set(A19)) ).

tff(tcon_Set_Oset___Complete__Lattices_OSup_284,axiom,
    ! [A19: $tType] : complete_Sup(set(A19)) ).

tff(tcon_Set_Oset___Complete__Lattices_OInf_285,axiom,
    ! [A19: $tType] : complete_Inf(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Oorder__top_286,axiom,
    ! [A19: $tType] : order_top(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Oorder__bot_287,axiom,
    ! [A19: $tType] : order_bot(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Opreorder_288,axiom,
    ! [A19: $tType] : preorder(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Olattice_289,axiom,
    ! [A19: $tType] : lattice(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Oorder_290,axiom,
    ! [A19: $tType] : order(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Otop_291,axiom,
    ! [A19: $tType] : top(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Oord_292,axiom,
    ! [A19: $tType] : ord(set(A19)) ).

tff(tcon_Set_Oset___Orderings_Obot_293,axiom,
    ! [A19: $tType] : bot(set(A19)) ).

tff(tcon_Set_Oset___Groups_Ouminus_294,axiom,
    ! [A19: $tType] : uminus(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Osup_295,axiom,
    ! [A19: $tType] : sup(set(A19)) ).

tff(tcon_Set_Oset___Lattices_Oinf_296,axiom,
    ! [A19: $tType] : inf(set(A19)) ).

tff(tcon_Set_Oset___Groups_Ominus_297,axiom,
    ! [A19: $tType] : minus(set(A19)) ).

tff(tcon_Set_Oset___HOL_Oequal_298,axiom,
    ! [A19: $tType] :
      ( cl_HOL_Oequal(A19)
     => cl_HOL_Oequal(set(A19)) ) ).

tff(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_299,axiom,
    condit1219197933456340205attice($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_300,axiom,
    comple592849572758109894attice($o) ).

tff(tcon_HOL_Obool___Quickcheck__Exhaustive_Ofull__exhaustive_301,axiom,
    quickc3360725361186068524ustive($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_302,axiom,
    bounde4967611905675639751up_bot($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_303,axiom,
    bounde4346867609351753570nf_top($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_304,axiom,
    comple6319245703460814977attice($o) ).

tff(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_305,axiom,
    boolea8198339166811842893lgebra($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice__top_306,axiom,
    bounded_lattice_top($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_307,axiom,
    bounded_lattice_bot($o) ).

tff(tcon_HOL_Obool___Complete__Partial__Order_Occpo_308,axiom,
    comple9053668089753744459l_ccpo($o) ).

tff(tcon_HOL_Obool___Quickcheck__Random_Orandom_309,axiom,
    quickcheck_random($o) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__sup_310,axiom,
    semilattice_sup($o) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__inf_311,axiom,
    semilattice_inf($o) ).

tff(tcon_HOL_Obool___Lattices_Odistrib__lattice_312,axiom,
    distrib_lattice($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice_313,axiom,
    bounded_lattice($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_OSup_314,axiom,
    complete_Sup($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_OInf_315,axiom,
    complete_Inf($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder__top_316,axiom,
    order_top($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder__bot_317,axiom,
    order_bot($o) ).

tff(tcon_HOL_Obool___Orderings_Opreorder_318,axiom,
    preorder($o) ).

tff(tcon_HOL_Obool___Orderings_Olinorder_319,axiom,
    linorder($o) ).

tff(tcon_HOL_Obool___Lattices_Olattice_320,axiom,
    lattice($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder_321,axiom,
    order($o) ).

tff(tcon_HOL_Obool___Orderings_Otop_322,axiom,
    top($o) ).

tff(tcon_HOL_Obool___Orderings_Oord_323,axiom,
    ord($o) ).

tff(tcon_HOL_Obool___Orderings_Obot_324,axiom,
    bot($o) ).

tff(tcon_HOL_Obool___Groups_Ouminus_325,axiom,
    uminus($o) ).

tff(tcon_HOL_Obool___Lattices_Osup_326,axiom,
    sup($o) ).

tff(tcon_HOL_Obool___Lattices_Oinf_327,axiom,
    inf($o) ).

tff(tcon_HOL_Obool___Groups_Ominus_328,axiom,
    minus($o) ).

tff(tcon_HOL_Obool___Heap_Oheap_329,axiom,
    heap($o) ).

tff(tcon_HOL_Obool___HOL_Oequal_330,axiom,
    cl_HOL_Oequal($o) ).

tff(tcon_Heap_Oref___Quickcheck__Exhaustive_Ofull__exhaustive_331,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => quickc3360725361186068524ustive(ref(A19)) ) ).

tff(tcon_Heap_Oref___Quickcheck__Random_Orandom_332,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => quickcheck_random(ref(A19)) ) ).

tff(tcon_Heap_Oref___Heap_Oheap_333,axiom,
    ! [A19: $tType] : heap(ref(A19)) ).

tff(tcon_Heap_Oref___HOL_Oequal_334,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(ref(A19)) ).

tff(tcon_List_Olist___Quickcheck__Exhaustive_Ofull__exhaustive_335,axiom,
    ! [A19: $tType] :
      ( quickc3360725361186068524ustive(A19)
     => quickc3360725361186068524ustive(list(A19)) ) ).

tff(tcon_List_Olist___Quickcheck__Random_Orandom_336,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(list(A19)) ) ).

tff(tcon_List_Olist___Heap_Oheap_337,axiom,
    ! [A19: $tType] :
      ( heap(A19)
     => heap(list(A19)) ) ).

tff(tcon_List_Olist___HOL_Oequal_338,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(list(A19)) ).

tff(tcon_Heap_Oarray___Quickcheck__Exhaustive_Ofull__exhaustive_339,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => quickc3360725361186068524ustive(array(A19)) ) ).

tff(tcon_Heap_Oarray___Quickcheck__Random_Orandom_340,axiom,
    ! [A19: $tType] :
      ( typerep2(A19)
     => quickcheck_random(array(A19)) ) ).

tff(tcon_Heap_Oarray___Heap_Oheap_341,axiom,
    ! [A19: $tType] : heap(array(A19)) ).

tff(tcon_Heap_Oarray___HOL_Oequal_342,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(array(A19)) ).

tff(tcon_String_Ochar___Quickcheck__Exhaustive_Ofull__exhaustive_343,axiom,
    quickc3360725361186068524ustive(char) ).

tff(tcon_String_Ochar___Quickcheck__Random_Orandom_344,axiom,
    quickcheck_random(char) ).

tff(tcon_String_Ochar___Heap_Oheap_345,axiom,
    heap(char) ).

tff(tcon_String_Ochar___HOL_Oequal_346,axiom,
    cl_HOL_Oequal(char) ).

tff(tcon_Sum__Type_Osum___Quickcheck__Exhaustive_Ofull__exhaustive_347,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( quickc3360725361186068524ustive(A19)
        & quickc3360725361186068524ustive(A20) )
     => quickc3360725361186068524ustive(sum_sum(A19,A20)) ) ).

tff(tcon_Sum__Type_Osum___Quickcheck__Random_Orandom_348,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( quickcheck_random(A19)
        & quickcheck_random(A20) )
     => quickcheck_random(sum_sum(A19,A20)) ) ).

tff(tcon_Sum__Type_Osum___Heap_Oheap_349,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( heap(A19)
        & heap(A20) )
     => heap(sum_sum(A19,A20)) ) ).

tff(tcon_Sum__Type_Osum___HOL_Oequal_350,axiom,
    ! [A19: $tType,A20: $tType] : cl_HOL_Oequal(sum_sum(A19,A20)) ).

tff(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_351,axiom,
    ! [A19: $tType] : condit1219197933456340205attice(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_352,axiom,
    ! [A19: $tType] : bounde4967611905675639751up_bot(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_353,axiom,
    ! [A19: $tType] : bounde4346867609351753570nf_top(filter(A19)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_354,axiom,
    ! [A19: $tType] : comple6319245703460814977attice(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice__top_355,axiom,
    ! [A19: $tType] : bounded_lattice_top(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice__bot_356,axiom,
    ! [A19: $tType] : bounded_lattice_bot(filter(A19)) ).

tff(tcon_Filter_Ofilter___Complete__Partial__Order_Occpo_357,axiom,
    ! [A19: $tType] : comple9053668089753744459l_ccpo(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_358,axiom,
    ! [A19: $tType] : semilattice_sup(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_359,axiom,
    ! [A19: $tType] : semilattice_inf(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_360,axiom,
    ! [A19: $tType] : distrib_lattice(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice_361,axiom,
    ! [A19: $tType] : bounded_lattice(filter(A19)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_OSup_362,axiom,
    ! [A19: $tType] : complete_Sup(filter(A19)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_OInf_363,axiom,
    ! [A19: $tType] : complete_Inf(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__top_364,axiom,
    ! [A19: $tType] : order_top(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__bot_365,axiom,
    ! [A19: $tType] : order_bot(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Opreorder_366,axiom,
    ! [A19: $tType] : preorder(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Olattice_367,axiom,
    ! [A19: $tType] : lattice(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder_368,axiom,
    ! [A19: $tType] : order(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Otop_369,axiom,
    ! [A19: $tType] : top(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Oord_370,axiom,
    ! [A19: $tType] : ord(filter(A19)) ).

tff(tcon_Filter_Ofilter___Orderings_Obot_371,axiom,
    ! [A19: $tType] : bot(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Osup_372,axiom,
    ! [A19: $tType] : sup(filter(A19)) ).

tff(tcon_Filter_Ofilter___Lattices_Oinf_373,axiom,
    ! [A19: $tType] : inf(filter(A19)) ).

tff(tcon_Filter_Ofilter___HOL_Oequal_374,axiom,
    ! [A19: $tType] :
      ( cl_HOL_Oequal(A19)
     => cl_HOL_Oequal(filter(A19)) ) ).

tff(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_375,axiom,
    ! [A19: $tType] :
      ( comple5582772986160207858norder(A19)
     => condit6923001295902523014norder(option(A19)) ) ).

tff(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_376,axiom,
    ! [A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => condit1219197933456340205attice(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__distrib__lattice_377,axiom,
    ! [A19: $tType] :
      ( comple592849572758109894attice(A19)
     => comple592849572758109894attice(option(A19)) ) ).

tff(tcon_Option_Ooption___Quickcheck__Exhaustive_Ofull__exhaustive_378,axiom,
    ! [A19: $tType] :
      ( quickc3360725361186068524ustive(A19)
     => quickc3360725361186068524ustive(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__semilattice__sup__bot_379,axiom,
    ! [A19: $tType] :
      ( lattice(A19)
     => bounde4967611905675639751up_bot(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__semilattice__inf__top_380,axiom,
    ! [A19: $tType] :
      ( bounded_lattice_top(A19)
     => bounde4346867609351753570nf_top(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__linorder,axiom,
    ! [A19: $tType] :
      ( comple5582772986160207858norder(A19)
     => comple5582772986160207858norder(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_Ocomplete__lattice_381,axiom,
    ! [A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => comple6319245703460814977attice(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice__top_382,axiom,
    ! [A19: $tType] :
      ( bounded_lattice_top(A19)
     => bounded_lattice_top(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice__bot_383,axiom,
    ! [A19: $tType] :
      ( lattice(A19)
     => bounded_lattice_bot(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Partial__Order_Occpo_384,axiom,
    ! [A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => comple9053668089753744459l_ccpo(option(A19)) ) ).

tff(tcon_Option_Ooption___Quickcheck__Random_Orandom_385,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Osemilattice__sup_386,axiom,
    ! [A19: $tType] :
      ( semilattice_sup(A19)
     => semilattice_sup(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Osemilattice__inf_387,axiom,
    ! [A19: $tType] :
      ( semilattice_inf(A19)
     => semilattice_inf(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Odistrib__lattice_388,axiom,
    ! [A19: $tType] :
      ( distrib_lattice(A19)
     => distrib_lattice(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Obounded__lattice_389,axiom,
    ! [A19: $tType] :
      ( bounded_lattice_top(A19)
     => bounded_lattice(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_OSup_390,axiom,
    ! [A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => complete_Sup(option(A19)) ) ).

tff(tcon_Option_Ooption___Complete__Lattices_OInf_391,axiom,
    ! [A19: $tType] :
      ( comple6319245703460814977attice(A19)
     => complete_Inf(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Owellorder_392,axiom,
    ! [A19: $tType] :
      ( wellorder(A19)
     => wellorder(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder__top_393,axiom,
    ! [A19: $tType] :
      ( order_top(A19)
     => order_top(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder__bot_394,axiom,
    ! [A19: $tType] :
      ( order(A19)
     => order_bot(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Opreorder_395,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => preorder(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Olinorder_396,axiom,
    ! [A19: $tType] :
      ( linorder(A19)
     => linorder(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Olattice_397,axiom,
    ! [A19: $tType] :
      ( lattice(A19)
     => lattice(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Oorder_398,axiom,
    ! [A19: $tType] :
      ( order(A19)
     => order(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Otop_399,axiom,
    ! [A19: $tType] :
      ( order_top(A19)
     => top(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Oord_400,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => ord(option(A19)) ) ).

tff(tcon_Option_Ooption___Orderings_Obot_401,axiom,
    ! [A19: $tType] :
      ( order(A19)
     => bot(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Osup_402,axiom,
    ! [A19: $tType] :
      ( sup(A19)
     => sup(option(A19)) ) ).

tff(tcon_Option_Ooption___Lattices_Oinf_403,axiom,
    ! [A19: $tType] :
      ( inf(A19)
     => inf(option(A19)) ) ).

tff(tcon_Option_Ooption___Heap_Oheap_404,axiom,
    ! [A19: $tType] :
      ( heap(A19)
     => heap(option(A19)) ) ).

tff(tcon_Option_Ooption___HOL_Oequal_405,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(option(A19)) ).

tff(tcon_Predicate_Oseq___HOL_Oequal_406,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(seq(A19)) ).

tff(tcon_Predicate_Opred___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_407,axiom,
    ! [A19: $tType] : condit1219197933456340205attice(pred(A19)) ).

tff(tcon_Predicate_Opred___Complete__Lattices_Ocomplete__distrib__lattice_408,axiom,
    ! [A19: $tType] : comple592849572758109894attice(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Obounded__semilattice__sup__bot_409,axiom,
    ! [A19: $tType] : bounde4967611905675639751up_bot(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Obounded__semilattice__inf__top_410,axiom,
    ! [A19: $tType] : bounde4346867609351753570nf_top(pred(A19)) ).

tff(tcon_Predicate_Opred___Complete__Lattices_Ocomplete__lattice_411,axiom,
    ! [A19: $tType] : comple6319245703460814977attice(pred(A19)) ).

tff(tcon_Predicate_Opred___Boolean__Algebras_Oboolean__algebra_412,axiom,
    ! [A19: $tType] : boolea8198339166811842893lgebra(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Obounded__lattice__top_413,axiom,
    ! [A19: $tType] : bounded_lattice_top(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Obounded__lattice__bot_414,axiom,
    ! [A19: $tType] : bounded_lattice_bot(pred(A19)) ).

tff(tcon_Predicate_Opred___Complete__Partial__Order_Occpo_415,axiom,
    ! [A19: $tType] : comple9053668089753744459l_ccpo(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Osemilattice__sup_416,axiom,
    ! [A19: $tType] : semilattice_sup(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Osemilattice__inf_417,axiom,
    ! [A19: $tType] : semilattice_inf(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Odistrib__lattice_418,axiom,
    ! [A19: $tType] : distrib_lattice(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Obounded__lattice_419,axiom,
    ! [A19: $tType] : bounded_lattice(pred(A19)) ).

tff(tcon_Predicate_Opred___Complete__Lattices_OSup_420,axiom,
    ! [A19: $tType] : complete_Sup(pred(A19)) ).

tff(tcon_Predicate_Opred___Complete__Lattices_OInf_421,axiom,
    ! [A19: $tType] : complete_Inf(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Oorder__top_422,axiom,
    ! [A19: $tType] : order_top(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Oorder__bot_423,axiom,
    ! [A19: $tType] : order_bot(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Opreorder_424,axiom,
    ! [A19: $tType] : preorder(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Olattice_425,axiom,
    ! [A19: $tType] : lattice(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Oorder_426,axiom,
    ! [A19: $tType] : order(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Otop_427,axiom,
    ! [A19: $tType] : top(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Oord_428,axiom,
    ! [A19: $tType] : ord(pred(A19)) ).

tff(tcon_Predicate_Opred___Orderings_Obot_429,axiom,
    ! [A19: $tType] : bot(pred(A19)) ).

tff(tcon_Predicate_Opred___Groups_Ouminus_430,axiom,
    ! [A19: $tType] : uminus(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Osup_431,axiom,
    ! [A19: $tType] : sup(pred(A19)) ).

tff(tcon_Predicate_Opred___Lattices_Oinf_432,axiom,
    ! [A19: $tType] : inf(pred(A19)) ).

tff(tcon_Predicate_Opred___Groups_Ominus_433,axiom,
    ! [A19: $tType] : minus(pred(A19)) ).

tff(tcon_Predicate_Opred___HOL_Oequal_434,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(pred(A19)) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__sup__bot_435,axiom,
    bounde4967611905675639751up_bot(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__inf__top_436,axiom,
    bounde4346867609351753570nf_top(assn) ).

tff(tcon_Assertions_Oassn___Boolean__Algebras_Oboolean__algebra_437,axiom,
    boolea8198339166811842893lgebra(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice__top_438,axiom,
    bounded_lattice_top(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice__bot_439,axiom,
    bounded_lattice_bot(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osemilattice__sup_440,axiom,
    semilattice_sup(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osemilattice__inf_441,axiom,
    semilattice_inf(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Odistrib__lattice_442,axiom,
    distrib_lattice(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Obounded__lattice_443,axiom,
    bounded_lattice(assn) ).

tff(tcon_Assertions_Oassn___Groups_Oab__semigroup__mult_444,axiom,
    ab_semigroup_mult(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ocomm__monoid__mult_445,axiom,
    comm_monoid_mult(assn) ).

tff(tcon_Assertions_Oassn___Groups_Osemigroup__mult_446,axiom,
    semigroup_mult(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder__top_447,axiom,
    order_top(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder__bot_448,axiom,
    order_bot(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Opreorder_449,axiom,
    preorder(assn) ).

tff(tcon_Assertions_Oassn___Groups_Omonoid__mult_450,axiom,
    monoid_mult(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Olattice_451,axiom,
    lattice(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oorder_452,axiom,
    order(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Otop_453,axiom,
    top(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Oord_454,axiom,
    ord(assn) ).

tff(tcon_Assertions_Oassn___Orderings_Obot_455,axiom,
    bot(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ouminus_456,axiom,
    uminus(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Osup_457,axiom,
    sup(assn) ).

tff(tcon_Assertions_Oassn___Lattices_Oinf_458,axiom,
    inf(assn) ).

tff(tcon_Assertions_Oassn___Groups_Otimes_459,axiom,
    times(assn) ).

tff(tcon_Assertions_Oassn___Groups_Ominus_460,axiom,
    minus(assn) ).

tff(tcon_Assertions_Oassn___Power_Opower_461,axiom,
    power(assn) ).

tff(tcon_Assertions_Oassn___Groups_Oone_462,axiom,
    one(assn) ).

tff(tcon_Assertions_Oassn___Rings_Odvd_463,axiom,
    dvd(assn) ).

tff(tcon_Typerep_Otyperep___Heap_Oheap_464,axiom,
    heap(typerep) ).

tff(tcon_Typerep_Otyperep___HOL_Oequal_465,axiom,
    cl_HOL_Oequal(typerep) ).

tff(tcon_Multiset_Omultiset___Quickcheck__Exhaustive_Ofull__exhaustive_466,axiom,
    ! [A19: $tType] :
      ( quickc3360725361186068524ustive(A19)
     => quickc3360725361186068524ustive(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Oordered__ab__semigroup__add_467,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => ordere6658533253407199908up_add(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__ab__semigroup__add_468,axiom,
    ! [A19: $tType] : cancel2418104881723323429up_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__comm__monoid__add_469,axiom,
    ! [A19: $tType] : cancel1802427076303600483id_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocancel__semigroup__add_470,axiom,
    ! [A19: $tType] : cancel_semigroup_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Quickcheck__Random_Orandom_471,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__diff_472,axiom,
    ! [A19: $tType] : comm_monoid_diff(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Oab__semigroup__add_473,axiom,
    ! [A19: $tType] : ab_semigroup_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__add_474,axiom,
    ! [A19: $tType] : comm_monoid_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Complete__Lattices_OSup_475,axiom,
    ! [A19: $tType] : complete_Sup(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Complete__Lattices_OInf_476,axiom,
    ! [A19: $tType] : complete_Inf(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Osemigroup__add_477,axiom,
    ! [A19: $tType] : semigroup_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Orderings_Opreorder_478,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => preorder(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Omonoid__add_479,axiom,
    ! [A19: $tType] : monoid_add(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Orderings_Oorder_480,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => order(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Orderings_Oord_481,axiom,
    ! [A19: $tType] :
      ( preorder(A19)
     => ord(multiset(A19)) ) ).

tff(tcon_Multiset_Omultiset___Groups_Ominus_482,axiom,
    ! [A19: $tType] : minus(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___Groups_Ozero_483,axiom,
    ! [A19: $tType] : zero(multiset(A19)) ).

tff(tcon_Multiset_Omultiset___HOL_Oequal_484,axiom,
    ! [A19: $tType] :
      ( cl_HOL_Oequal(A19)
     => cl_HOL_Oequal(multiset(A19)) ) ).

tff(tcon_Product__Type_Oprod___Quickcheck__Exhaustive_Ofull__exhaustive_485,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( quickc3360725361186068524ustive(A19)
        & quickc3360725361186068524ustive(A20) )
     => quickc3360725361186068524ustive(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___Quickcheck__Exhaustive_Oexhaustive_486,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( quickc658316121487927005ustive(A19)
        & quickc658316121487927005ustive(A20) )
     => quickc658316121487927005ustive(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___Quickcheck__Random_Orandom_487,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( quickcheck_random(A19)
        & quickcheck_random(A20) )
     => quickcheck_random(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___Heap_Oheap_488,axiom,
    ! [A19: $tType,A20: $tType] :
      ( ( heap(A19)
        & heap(A20) )
     => heap(product_prod(A19,A20)) ) ).

tff(tcon_Product__Type_Oprod___HOL_Oequal_489,axiom,
    ! [A19: $tType,A20: $tType] : cl_HOL_Oequal(product_prod(A19,A20)) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_490,axiom,
    condit6923001295902523014norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_491,axiom,
    condit1219197933456340205attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_492,axiom,
    comple592849572758109894attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Quickcheck__Exhaustive_Ofull__exhaustive_493,axiom,
    quickc3360725361186068524ustive(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_494,axiom,
    bounde4967611905675639751up_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_495,axiom,
    bounde4346867609351753570nf_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_496,axiom,
    comple5582772986160207858norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_497,axiom,
    comple6319245703460814977attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_498,axiom,
    boolea8198339166811842893lgebra(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__top_499,axiom,
    bounded_lattice_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__bot_500,axiom,
    bounded_lattice_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Partial__Order_Occpo_501,axiom,
    comple9053668089753744459l_ccpo(product_unit) ).

tff(tcon_Product__Type_Ounit___Quickcheck__Random_Orandom_502,axiom,
    quickcheck_random(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_503,axiom,
    semilattice_sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_504,axiom,
    semilattice_inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Odistrib__lattice_505,axiom,
    distrib_lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice_506,axiom,
    bounded_lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_OSup_507,axiom,
    complete_Sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_OInf_508,axiom,
    complete_Inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Owellorder_509,axiom,
    wellorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__top_510,axiom,
    order_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__bot_511,axiom,
    order_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Opreorder_512,axiom,
    preorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Olinorder_513,axiom,
    linorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Olattice_514,axiom,
    lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder_515,axiom,
    order(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Otop_516,axiom,
    top(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oord_517,axiom,
    ord(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Obot_518,axiom,
    bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ouminus_519,axiom,
    uminus(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osup_520,axiom,
    sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Oinf_521,axiom,
    inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ominus_522,axiom,
    minus(product_unit) ).

tff(tcon_Product__Type_Ounit___Heap_Oheap_523,axiom,
    heap(product_unit) ).

tff(tcon_Product__Type_Ounit___HOL_Oequal_524,axiom,
    cl_HOL_Oequal(product_unit) ).

tff(tcon_Heap_Oheap_Oheap__ext___Quickcheck__Random_Orandom_525,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(heap_ext(A19)) ) ).

tff(tcon_Heap_Oheap_Oheap__ext___HOL_Oequal_526,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(heap_ext(A19)) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_527,axiom,
    bit_un5681908812861735899ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_528,axiom,
    semiri1453513574482234551roduct(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_529,axiom,
    euclid5411537665997757685th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_530,axiom,
    euclid8789492081693882211th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_531,axiom,
    ordere1937475149494474687imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_532,axiom,
    euclid3128863361964157862miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_533,axiom,
    euclid4440199948858584721cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_534,axiom,
    unique1627219031080169319umeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_535,axiom,
    euclid8851590272496341667cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_536,axiom,
    semiri6575147826004484403cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_537,axiom,
    strict9044650504122735259up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_538,axiom,
    ordere580206878836729694up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_539,axiom,
    ordere2412721322843649153imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_540,axiom,
    bit_se359711467146920520ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_541,axiom,
    linord2810124833399127020strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Quickcheck__Exhaustive_Ofull__exhaustive_542,axiom,
    quickc3360725361186068524ustive(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_543,axiom,
    strict7427464778891057005id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_544,axiom,
    ordere8940638589300402666id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_545,axiom,
    euclid3725896446679973847miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_546,axiom,
    linord715952674999750819strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_547,axiom,
    linord4140545234300271783up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_548,axiom,
    bit_ri3973907225187159222ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_549,axiom,
    linord181362715937106298miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_550,axiom,
    linord8928482502909563296strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Quickcheck__Exhaustive_Oexhaustive_551,axiom,
    quickc658316121487927005ustive(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_552,axiom,
    semiri3467727345109120633visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_553,axiom,
    ordere6658533253407199908up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_554,axiom,
    ordere166539214618696060dd_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_555,axiom,
    ordere6911136660526730532id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_556,axiom,
    linord5086331880401160121up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_557,axiom,
    cancel2418104881723323429up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_558,axiom,
    ring_15535105094025558882visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_559,axiom,
    cancel1802427076303600483id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_560,axiom,
    linord4710134922213307826strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_561,axiom,
    comm_s4317794764714335236cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_562,axiom,
    bit_semiring_bits(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_563,axiom,
    ordere2520102378445227354miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_564,axiom,
    linord6961819062388156250ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_565,axiom,
    ordered_ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_566,axiom,
    cancel_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_567,axiom,
    linordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_568,axiom,
    ordered_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_569,axiom,
    linordered_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Quickcheck__Random_Orandom_570,axiom,
    quickcheck_random(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_571,axiom,
    ab_semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_572,axiom,
    algebraic_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_573,axiom,
    comm_monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_574,axiom,
    ab_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_575,axiom,
    ordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_576,axiom,
    ordered_ring_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_577,axiom,
    semiring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_578,axiom,
    comm_monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_579,axiom,
    semiring_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_580,axiom,
    linordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_581,axiom,
    linordered_idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_582,axiom,
    comm_semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_583,axiom,
    comm_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_584,axiom,
    semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_585,axiom,
    semidom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_586,axiom,
    semidom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_587,axiom,
    semiring_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_588,axiom,
    semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_589,axiom,
    zero_less_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_590,axiom,
    comm_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_591,axiom,
    semiring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_592,axiom,
    ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_593,axiom,
    zero_neq_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_594,axiom,
    ordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_595,axiom,
    idom_abs_sgn(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_596,axiom,
    preorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_597,axiom,
    linorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_598,axiom,
    monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_599,axiom,
    comm_ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_600,axiom,
    monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_601,axiom,
    semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_602,axiom,
    semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_603,axiom,
    group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_604,axiom,
    mult_zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_605,axiom,
    comm_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oorder_606,axiom,
    order(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_607,axiom,
    neg_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_608,axiom,
    ring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring_609,axiom,
    semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oord_610,axiom,
    ord(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ouminus_611,axiom,
    uminus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1_612,axiom,
    ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Otimes_613,axiom,
    times(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ominus_614,axiom,
    minus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Power_Opower_615,axiom,
    power(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Onumeral_616,axiom,
    numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ozero_617,axiom,
    zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring_618,axiom,
    ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom_619,axiom,
    idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oone_620,axiom,
    one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Odvd_621,axiom,
    dvd(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___HOL_Oequal_622,axiom,
    cl_HOL_Oequal(code_integer) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_623,axiom,
    bit_un5681908812861735899ations(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring__with__nat_624,axiom,
    euclid5411537665997757685th_nat(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__monoid__add__imp__le_625,axiom,
    ordere1937475149494474687imp_le(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring_626,axiom,
    euclid3128863361964157862miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring__cancel_627,axiom,
    euclid4440199948858584721cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors__cancel_628,axiom,
    semiri6575147826004484403cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__ab__semigroup__add_629,axiom,
    strict9044650504122735259up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__ab__semigroup__add_630,axiom,
    ordere580206878836729694up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add__imp__le_631,axiom,
    ordere2412721322843649153imp_le(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bit__operations_632,axiom,
    bit_se359711467146920520ations(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__comm__semiring__strict_633,axiom,
    linord2810124833399127020strict(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Quickcheck__Exhaustive_Ofull__exhaustive_634,axiom,
    quickc3360725361186068524ustive(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__comm__monoid__add_635,axiom,
    strict7427464778891057005id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__comm__monoid__add_636,axiom,
    ordere8940638589300402666id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring_637,axiom,
    euclid3725896446679973847miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Olinordered__ab__semigroup__add_638,axiom,
    linord4140545234300271783up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__nonzero__semiring_639,axiom,
    linord181362715937106298miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring__strict_640,axiom,
    linord8928482502909563296strict(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Quickcheck__Exhaustive_Oexhaustive_641,axiom,
    quickc658316121487927005ustive(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors_642,axiom,
    semiri3467727345109120633visors(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_643,axiom,
    ordere6658533253407199908up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oordered__comm__monoid__add_644,axiom,
    ordere6911136660526730532id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__ab__semigroup__add_645,axiom,
    cancel2418104881723323429up_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_646,axiom,
    cancel1802427076303600483id_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1__cancel_647,axiom,
    comm_s4317794764714335236cancel(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bits_648,axiom,
    bit_semiring_bits(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__comm__semiring_649,axiom,
    ordere2520102378445227354miring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_650,axiom,
    cancel_semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring_651,axiom,
    linordered_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring__0_652,axiom,
    ordered_semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Olinordered__semidom_653,axiom,
    linordered_semidom(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Quickcheck__Random_Orandom_654,axiom,
    quickcheck_random(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__mult_655,axiom,
    ab_semigroup_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oalgebraic__semidom_656,axiom,
    algebraic_semidom(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__mult_657,axiom,
    comm_monoid_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__diff_658,axiom,
    comm_monoid_diff(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_659,axiom,
    ab_semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring_660,axiom,
    ordered_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Parity_Osemiring__parity_661,axiom,
    semiring_parity(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_662,axiom,
    comm_monoid_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__modulo_663,axiom,
    semiring_modulo(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_664,axiom,
    comm_semiring_1(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__0_665,axiom,
    comm_semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Osemigroup__mult_666,axiom,
    semigroup_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemidom__modulo_667,axiom,
    semidom_modulo(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemidom__divide_668,axiom,
    semidom_divide(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Num_Osemiring__numeral_669,axiom,
    semiring_numeral(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_670,axiom,
    semigroup_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ozero__less__one_671,axiom,
    zero_less_one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring_672,axiom,
    comm_semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Nat_Osemiring__char__0_673,axiom,
    semiring_char_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Ozero__neq__one_674,axiom,
    zero_neq_one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Opreorder_675,axiom,
    preorder(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Olinorder_676,axiom,
    linorder(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Omonoid__mult_677,axiom,
    monoid_mult(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_678,axiom,
    monoid_add(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_679,axiom,
    semiring_1(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring__0_680,axiom,
    semiring_0(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Omult__zero_681,axiom,
    mult_zero(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Oorder_682,axiom,
    order(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Osemiring_683,axiom,
    semiring(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Orderings_Oord_684,axiom,
    ord(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Otimes_685,axiom,
    times(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ominus_686,axiom,
    minus(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Power_Opower_687,axiom,
    power(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Num_Onumeral_688,axiom,
    numeral(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Ozero_689,axiom,
    zero(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Groups_Oone_690,axiom,
    one(code_natural) ).

tff(tcon_Code__Numeral_Onatural___Rings_Odvd_691,axiom,
    dvd(code_natural) ).

tff(tcon_Code__Numeral_Onatural___HOL_Oequal_692,axiom,
    cl_HOL_Oequal(code_natural) ).

tff(tcon_Heap__Time__Monad_OHeap___Quickcheck__Random_Orandom_693,axiom,
    ! [A19: $tType] :
      ( quickcheck_random(A19)
     => quickcheck_random(heap_Time_Heap(A19)) ) ).

tff(tcon_Heap__Time__Monad_OHeap___HOL_Oequal_694,axiom,
    ! [A19: $tType] : cl_HOL_Oequal(heap_Time_Heap(A19)) ).

% Helper facts (5)
tff(help_fNot_2_1_U,axiom,
    ! [P9: $o] :
      ( (P9)
      | aa($o,$o,fNot,P9) ) ).

tff(help_fNot_1_1_U,axiom,
    ! [P9: $o] :
      ( ~ aa($o,$o,fNot,P9)
      | ~ (P9) ) ).

tff(help_fequal_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( X != Y )
      | aa(A,$o,aa(A,fun(A,$o),fequal(A),X),Y) ) ).

tff(help_fequal_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ~ aa(A,$o,aa(A,fun(A,$o),fequal(A),X),Y)
      | ( X = Y ) ) ).

tff(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P9: fun(A,$o)] :
      ( aa(A,$o,P9,fChoice(A,P9))
      = ( ? [X8: A] : aa(A,$o,P9,X8) ) ) ).

% Free types (2)
tff(tfree_0,hypothesis,
    heap(b) ).

tff(tfree_1,hypothesis,
    linorder(c) ).

% Conjectures (1)
tff(conj_0,conjecture,
    hoare_hoare_triple(a,p,$ite(b2,f,g),q) ).

%------------------------------------------------------------------------------
